#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 4904
#define LARGE_STATE_COUNT 1397
#define SYMBOL_COUNT 404
#define ALIAS_COUNT 6
#define TOKEN_COUNT 170
#define EXTERNAL_TOKEN_COUNT 5
#define FIELD_COUNT 49
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 303

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_as = 5,
  anon_sym_LBRACE = 6,
  anon_sym_COMMA = 7,
  anon_sym_RBRACE = 8,
  anon_sym_type = 9,
  anon_sym_typeof = 10,
  anon_sym_import = 11,
  anon_sym_from = 12,
  anon_sym_var = 13,
  anon_sym_let = 14,
  anon_sym_const = 15,
  anon_sym_BANG = 16,
  anon_sym_else = 17,
  anon_sym_if = 18,
  anon_sym_switch = 19,
  anon_sym_for = 20,
  anon_sym_LPAREN = 21,
  anon_sym_RPAREN = 22,
  anon_sym_await = 23,
  anon_sym_in = 24,
  anon_sym_of = 25,
  anon_sym_while = 26,
  anon_sym_do = 27,
  anon_sym_try = 28,
  anon_sym_with = 29,
  anon_sym_break = 30,
  anon_sym_continue = 31,
  anon_sym_debugger = 32,
  anon_sym_return = 33,
  anon_sym_throw = 34,
  anon_sym_SEMI = 35,
  anon_sym_COLON = 36,
  anon_sym_case = 37,
  anon_sym_default = 38,
  anon_sym_catch = 39,
  anon_sym_finally = 40,
  anon_sym_yield = 41,
  anon_sym_EQ = 42,
  anon_sym_LBRACK = 43,
  anon_sym_RBRACK = 44,
  sym__glimmer_template_content = 45,
  anon_sym_LTtemplate_GT = 46,
  anon_sym_LT_SLASHtemplate_GT = 47,
  anon_sym_LT = 48,
  anon_sym_GT = 49,
  anon_sym_SLASH = 50,
  anon_sym_DOT = 51,
  anon_sym_class = 52,
  anon_sym_async = 53,
  anon_sym_function = 54,
  anon_sym_EQ_GT = 55,
  anon_sym_QMARK_DOT = 56,
  anon_sym_new = 57,
  anon_sym_PLUS_EQ = 58,
  anon_sym_DASH_EQ = 59,
  anon_sym_STAR_EQ = 60,
  anon_sym_SLASH_EQ = 61,
  anon_sym_PERCENT_EQ = 62,
  anon_sym_CARET_EQ = 63,
  anon_sym_AMP_EQ = 64,
  anon_sym_PIPE_EQ = 65,
  anon_sym_GT_GT_EQ = 66,
  anon_sym_GT_GT_GT_EQ = 67,
  anon_sym_LT_LT_EQ = 68,
  anon_sym_STAR_STAR_EQ = 69,
  anon_sym_AMP_AMP_EQ = 70,
  anon_sym_PIPE_PIPE_EQ = 71,
  anon_sym_QMARK_QMARK_EQ = 72,
  anon_sym_DOT_DOT_DOT = 73,
  anon_sym_AMP_AMP = 74,
  anon_sym_PIPE_PIPE = 75,
  anon_sym_GT_GT = 76,
  anon_sym_GT_GT_GT = 77,
  anon_sym_LT_LT = 78,
  anon_sym_AMP = 79,
  anon_sym_CARET = 80,
  anon_sym_PIPE = 81,
  anon_sym_PLUS = 82,
  anon_sym_DASH = 83,
  anon_sym_PERCENT = 84,
  anon_sym_STAR_STAR = 85,
  anon_sym_LT_EQ = 86,
  anon_sym_EQ_EQ = 87,
  anon_sym_EQ_EQ_EQ = 88,
  anon_sym_BANG_EQ = 89,
  anon_sym_BANG_EQ_EQ = 90,
  anon_sym_GT_EQ = 91,
  anon_sym_QMARK_QMARK = 92,
  anon_sym_instanceof = 93,
  anon_sym_TILDE = 94,
  anon_sym_void = 95,
  anon_sym_delete = 96,
  anon_sym_PLUS_PLUS = 97,
  anon_sym_DASH_DASH = 98,
  anon_sym_DQUOTE = 99,
  anon_sym_SQUOTE = 100,
  sym_unescaped_double_string_fragment = 101,
  sym_unescaped_single_string_fragment = 102,
  sym_escape_sequence = 103,
  sym_comment = 104,
  anon_sym_BQUOTE = 105,
  anon_sym_DOLLAR_LBRACE = 106,
  anon_sym_SLASH2 = 107,
  sym_regex_pattern = 108,
  sym_regex_flags = 109,
  sym_number = 110,
  sym_private_property_identifier = 111,
  anon_sym_target = 112,
  sym_this = 113,
  sym_super = 114,
  sym_true = 115,
  sym_false = 116,
  sym_null = 117,
  sym_undefined = 118,
  anon_sym_AT = 119,
  anon_sym_static = 120,
  anon_sym_readonly = 121,
  anon_sym_get = 122,
  anon_sym_set = 123,
  anon_sym_QMARK = 124,
  anon_sym_declare = 125,
  anon_sym_namespace = 126,
  anon_sym_public = 127,
  anon_sym_private = 128,
  anon_sym_protected = 129,
  anon_sym_override = 130,
  anon_sym_module = 131,
  anon_sym_any = 132,
  anon_sym_number = 133,
  anon_sym_boolean = 134,
  anon_sym_string = 135,
  anon_sym_symbol = 136,
  anon_sym_abstract = 137,
  anon_sym_satisfies = 138,
  anon_sym_require = 139,
  anon_sym_extends = 140,
  anon_sym_implements = 141,
  anon_sym_global = 142,
  anon_sym_interface = 143,
  anon_sym_enum = 144,
  anon_sym_DASH_QMARK_COLON = 145,
  anon_sym_QMARK_COLON = 146,
  anon_sym_asserts = 147,
  anon_sym_infer = 148,
  anon_sym_is = 149,
  anon_sym_keyof = 150,
  anon_sym_unknown = 151,
  anon_sym_never = 152,
  anon_sym_object = 153,
  anon_sym_LBRACE_PIPE = 154,
  anon_sym_PIPE_RBRACE = 155,
  anon_sym_component = 156,
  anon_sym_POUND = 157,
  anon_sym_instance = 158,
  anon_sym_constructor = 159,
  anon_sym_BQUOTE_BQUOTE_BQUOTE = 160,
  anon_sym_prop = 161,
  anon_sym_id = 162,
  anon_sym_event = 163,
  anon_sym_fn = 164,
  anon_sym_on = 165,
  sym__automatic_semicolon = 166,
  sym__template_chars = 167,
  sym__ternary_qmark = 168,
  sym__function_signature_automatic_semicolon = 169,
  sym_program = 170,
  sym_export_statement = 171,
  sym_declaration = 172,
  sym_import = 173,
  sym_import_statement = 174,
  sym_expression_statement = 175,
  sym_variable_declaration = 176,
  sym_lexical_declaration = 177,
  sym_variable_declarator = 178,
  sym_statement_block = 179,
  sym_else_clause = 180,
  sym_if_statement = 181,
  sym_switch_statement = 182,
  sym_for_statement = 183,
  sym_for_in_statement = 184,
  sym__for_header = 185,
  sym_while_statement = 186,
  sym_do_statement = 187,
  sym_try_statement = 188,
  sym_with_statement = 189,
  sym_break_statement = 190,
  sym_continue_statement = 191,
  sym_debugger_statement = 192,
  sym_return_statement = 193,
  sym_throw_statement = 194,
  sym_empty_statement = 195,
  sym_labeled_statement = 196,
  sym_switch_body = 197,
  sym_switch_case = 198,
  sym_switch_default = 199,
  sym_catch_clause = 200,
  sym_finally_clause = 201,
  sym_parenthesized_expression = 202,
  sym_expression = 203,
  sym_primary_expression = 204,
  sym_yield_expression = 205,
  sym_object = 206,
  sym_object_pattern = 207,
  sym_assignment_pattern = 208,
  sym_object_assignment_pattern = 209,
  sym_array = 210,
  sym_array_pattern = 211,
  sym_glimmer_template = 212,
  sym_glimmer_opening_tag = 213,
  sym_glimmer_closing_tag = 214,
  sym_nested_identifier = 215,
  sym_class = 216,
  sym_class_declaration = 217,
  sym_class_heritage = 218,
  sym_function = 219,
  sym_function_declaration = 220,
  sym_generator_function = 221,
  sym_generator_function_declaration = 222,
  sym_arrow_function = 223,
  sym__call_signature = 224,
  sym__formal_parameter = 225,
  sym_optional_chain = 226,
  sym_call_expression = 227,
  sym_new_expression = 228,
  sym_await_expression = 229,
  sym_member_expression = 230,
  sym_subscript_expression = 231,
  sym_assignment_expression = 232,
  sym__augmented_assignment_lhs = 233,
  sym_augmented_assignment_expression = 234,
  sym__initializer = 235,
  sym__destructuring_pattern = 236,
  sym_spread_element = 237,
  sym_ternary_expression = 238,
  sym_binary_expression = 239,
  sym_unary_expression = 240,
  sym_update_expression = 241,
  sym_sequence_expression = 242,
  sym_string = 243,
  sym_template_string = 244,
  sym_template_substitution = 245,
  sym_regex = 246,
  sym_meta_property = 247,
  sym_arguments = 248,
  sym_decorator = 249,
  sym_decorator_member_expression = 250,
  sym_decorator_call_expression = 251,
  sym_class_body = 252,
  sym_formal_parameters = 253,
  sym_class_static_block = 254,
  sym_pattern = 255,
  sym_rest_pattern = 256,
  sym_method_definition = 257,
  sym_pair = 258,
  sym_pair_pattern = 259,
  sym__property_name = 260,
  sym_computed_property_name = 261,
  sym_public_field_definition = 262,
  sym_non_null_expression = 263,
  sym_method_signature = 264,
  sym_abstract_method_signature = 265,
  sym_function_signature = 266,
  sym_type_assertion = 267,
  sym_as_expression = 268,
  sym_satisfies_expression = 269,
  sym_extends_clause = 270,
  sym_implements_clause = 271,
  sym_ambient_declaration = 272,
  sym_abstract_class_declaration = 273,
  sym_module = 274,
  sym_internal_module = 275,
  sym__module = 276,
  sym_import_alias = 277,
  sym_nested_type_identifier = 278,
  sym_interface_declaration = 279,
  sym_extends_type_clause = 280,
  sym_enum_declaration = 281,
  sym_enum_body = 282,
  sym_enum_assignment = 283,
  sym_type_alias_declaration = 284,
  sym_accessibility_modifier = 285,
  sym_override_modifier = 286,
  sym_required_parameter = 287,
  sym_optional_parameter = 288,
  sym__parameter_name = 289,
  sym_omitting_type_annotation = 290,
  sym_opting_type_annotation = 291,
  sym_type_annotation = 292,
  sym_asserts = 293,
  sym__type = 294,
  sym_tuple_parameter = 295,
  sym_optional_tuple_parameter = 296,
  sym_optional_type = 297,
  sym_rest_type = 298,
  sym__tuple_type_member = 299,
  sym_constructor_type = 300,
  sym__primary_type = 301,
  sym_template_type = 302,
  sym_template_literal_type = 303,
  sym_infer_type = 304,
  sym_conditional_type = 305,
  sym_generic_type = 306,
  sym_type_predicate = 307,
  sym_type_predicate_annotation = 308,
  sym__type_query_member_expression = 309,
  sym__type_query_subscript_expression = 310,
  sym__type_query_call_expression = 311,
  sym_type_query = 312,
  sym_index_type_query = 313,
  sym_lookup_type = 314,
  sym_mapped_type_clause = 315,
  sym_literal_type = 316,
  sym__number = 317,
  sym_existential_type = 318,
  sym_flow_maybe_type = 319,
  sym_parenthesized_type = 320,
  sym_predefined_type = 321,
  sym_type_arguments = 322,
  sym_object_type = 323,
  sym_call_signature = 324,
  sym_property_signature = 325,
  sym_type_parameters = 326,
  sym_type_parameter = 327,
  sym_default_type = 328,
  sym_constraint = 329,
  sym_construct_signature = 330,
  sym_index_signature = 331,
  sym_array_type = 332,
  sym_tuple_type = 333,
  sym_readonly_type = 334,
  sym_union_type = 335,
  sym_intersection_type = 336,
  sym_function_type = 337,
  sym_property_assignment_expression = 338,
  sym_import_path = 339,
  sym_import_path_segment = 340,
  sym_import_as = 341,
  sym_js_import_statement = 342,
  sym_component = 343,
  sym_component_declaration = 344,
  sym_component_short_heritage = 345,
  sym_component_heritage = 346,
  sym_component_identifier = 347,
  sym_component_instance = 348,
  sym_component_instance_statement = 349,
  sym_new_component_expression = 350,
  sym_new_tagged_component_expression = 351,
  sym_new_tripple_tagged_component_expression = 352,
  sym_component_body = 353,
  sym_new_component_body = 354,
  sym_constructor_definition = 355,
  sym_tagged_type_string = 356,
  sym_tripple_tagged_type_string = 357,
  sym_formal_type_parameters = 358,
  sym_required_type_parameter = 359,
  sym_optional_type_parameter = 360,
  sym_formal_type_parameter = 361,
  sym_property_declaration_name = 362,
  sym_type_narrow = 363,
  sym_property_declaration = 364,
  sym_property_expression_initializer = 365,
  sym_static_property_declaration = 366,
  sym_identifier_property_assignment = 367,
  sym_property_assignment = 368,
  sym_event_declaration = 369,
  sym_typed_function_return_type = 370,
  sym_property_accessor_declaration = 371,
  sym_typed_method_declaration = 372,
  sym_listener_declaration = 373,
  aux_sym_program_repeat1 = 374,
  aux_sym_variable_declaration_repeat1 = 375,
  aux_sym_statement_block_repeat1 = 376,
  aux_sym_switch_body_repeat1 = 377,
  aux_sym_object_repeat1 = 378,
  aux_sym_object_pattern_repeat1 = 379,
  aux_sym_array_repeat1 = 380,
  aux_sym_array_pattern_repeat1 = 381,
  aux_sym_glimmer_template_repeat1 = 382,
  aux_sym_class_repeat1 = 383,
  aux_sym_string_repeat1 = 384,
  aux_sym_string_repeat2 = 385,
  aux_sym_template_string_repeat1 = 386,
  aux_sym_class_body_repeat1 = 387,
  aux_sym_formal_parameters_repeat1 = 388,
  aux_sym_extends_clause_repeat1 = 389,
  aux_sym_implements_clause_repeat1 = 390,
  aux_sym_extends_type_clause_repeat1 = 391,
  aux_sym_enum_body_repeat1 = 392,
  aux_sym_template_literal_type_repeat1 = 393,
  aux_sym_object_type_repeat1 = 394,
  aux_sym_type_parameters_repeat1 = 395,
  aux_sym_tuple_type_repeat1 = 396,
  aux_sym_import_path_repeat1 = 397,
  aux_sym_import_path_segment_repeat1 = 398,
  aux_sym_js_import_statement_repeat1 = 399,
  aux_sym_component_short_heritage_repeat1 = 400,
  aux_sym_component_body_repeat1 = 401,
  aux_sym_new_component_body_repeat1 = 402,
  aux_sym_formal_type_parameters_repeat1 = 403,
  alias_sym_property_identifier = 404,
  alias_sym_shorthand_property_identifier = 405,
  alias_sym_shorthand_property_identifier_pattern = 406,
  alias_sym_statement_identifier = 407,
  alias_sym_this_type = 408,
  alias_sym_type_identifier = 409,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_as] = "as",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_type] = "type",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_BANG] = "!",
  [anon_sym_else] = "else",
  [anon_sym_if] = "if",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_EQ] = "=",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [sym__glimmer_template_content] = "_glimmer_template_content",
  [anon_sym_LTtemplate_GT] = "<template>",
  [anon_sym_LT_SLASHtemplate_GT] = "</template>",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_QMARK_DOT] = "\?.",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_SQUOTE] = "'",
  [sym_unescaped_double_string_fragment] = "string_fragment",
  [sym_unescaped_single_string_fragment] = "string_fragment",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [sym_private_property_identifier] = "private_property_identifier",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_readonly] = "readonly",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_QMARK] = "\?",
  [anon_sym_declare] = "declare",
  [anon_sym_namespace] = "namespace",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_override] = "override",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_abstract] = "abstract",
  [anon_sym_satisfies] = "satisfies",
  [anon_sym_require] = "require",
  [anon_sym_extends] = "extends",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_enum] = "enum",
  [anon_sym_DASH_QMARK_COLON] = "-\?:",
  [anon_sym_QMARK_COLON] = "\?:",
  [anon_sym_asserts] = "asserts",
  [anon_sym_infer] = "infer",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_unknown] = "unknown",
  [anon_sym_never] = "never",
  [anon_sym_object] = "object",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [anon_sym_component] = "component",
  [anon_sym_POUND] = "#",
  [anon_sym_instance] = "instance",
  [anon_sym_constructor] = "constructor",
  [anon_sym_BQUOTE_BQUOTE_BQUOTE] = "```",
  [anon_sym_prop] = "prop",
  [anon_sym_id] = "id",
  [anon_sym_event] = "event",
  [anon_sym_fn] = "fn",
  [anon_sym_on] = "on",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym__ternary_qmark] = "\?",
  [sym__function_signature_automatic_semicolon] = "_function_signature_automatic_semicolon",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_declaration] = "declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_else_clause] = "else_clause",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_expression] = "expression",
  [sym_primary_expression] = "primary_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_object_pattern] = "object_pattern",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_object_assignment_pattern] = "object_assignment_pattern",
  [sym_array] = "array",
  [sym_array_pattern] = "array_pattern",
  [sym_glimmer_template] = "glimmer_template",
  [sym_glimmer_opening_tag] = "glimmer_opening_tag",
  [sym_glimmer_closing_tag] = "glimmer_closing_tag",
  [sym_nested_identifier] = "nested_identifier",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym__formal_parameter] = "_formal_parameter",
  [sym_optional_chain] = "optional_chain",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym__augmented_assignment_lhs] = "_augmented_assignment_lhs",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym__destructuring_pattern] = "_destructuring_pattern",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_formal_parameters] = "formal_parameters",
  [sym_class_static_block] = "class_static_block",
  [sym_pattern] = "pattern",
  [sym_rest_pattern] = "rest_pattern",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym_pair_pattern] = "pair_pattern",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_public_field_definition] = "public_field_definition",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_type_assertion] = "type_assertion",
  [sym_as_expression] = "as_expression",
  [sym_satisfies_expression] = "satisfies_expression",
  [sym_extends_clause] = "extends_clause",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_type_clause] = "extends_type_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_override_modifier] = "override_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_omitting_type_annotation] = "omitting_type_annotation",
  [sym_opting_type_annotation] = "opting_type_annotation",
  [sym_type_annotation] = "type_annotation",
  [sym_asserts] = "asserts",
  [sym__type] = "_type",
  [sym_tuple_parameter] = "required_parameter",
  [sym_optional_tuple_parameter] = "optional_parameter",
  [sym_optional_type] = "optional_type",
  [sym_rest_type] = "rest_type",
  [sym__tuple_type_member] = "_tuple_type_member",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_template_type] = "template_type",
  [sym_template_literal_type] = "template_literal_type",
  [sym_infer_type] = "infer_type",
  [sym_conditional_type] = "conditional_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_predicate_annotation] = "type_predicate_annotation",
  [sym__type_query_member_expression] = "member_expression",
  [sym__type_query_subscript_expression] = "subscript_expression",
  [sym__type_query_call_expression] = "call_expression",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_readonly_type] = "readonly_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [sym_property_assignment_expression] = "property_assignment_expression",
  [sym_import_path] = "import_path",
  [sym_import_path_segment] = "import_path_segment",
  [sym_import_as] = "import_as",
  [sym_js_import_statement] = "js_import_statement",
  [sym_component] = "component",
  [sym_component_declaration] = "component_declaration",
  [sym_component_short_heritage] = "component_short_heritage",
  [sym_component_heritage] = "component_heritage",
  [sym_component_identifier] = "component_identifier",
  [sym_component_instance] = "component_instance",
  [sym_component_instance_statement] = "component_instance_statement",
  [sym_new_component_expression] = "new_component_expression",
  [sym_new_tagged_component_expression] = "new_tagged_component_expression",
  [sym_new_tripple_tagged_component_expression] = "new_tripple_tagged_component_expression",
  [sym_component_body] = "component_body",
  [sym_new_component_body] = "new_component_body",
  [sym_constructor_definition] = "constructor_definition",
  [sym_tagged_type_string] = "tagged_type_string",
  [sym_tripple_tagged_type_string] = "tripple_tagged_type_string",
  [sym_formal_type_parameters] = "formal_type_parameters",
  [sym_required_type_parameter] = "required_type_parameter",
  [sym_optional_type_parameter] = "optional_type_parameter",
  [sym_formal_type_parameter] = "formal_type_parameter",
  [sym_property_declaration_name] = "property_declaration_name",
  [sym_type_narrow] = "type_narrow",
  [sym_property_declaration] = "property_declaration",
  [sym_property_expression_initializer] = "property_expression_initializer",
  [sym_static_property_declaration] = "static_property_declaration",
  [sym_identifier_property_assignment] = "identifier_property_assignment",
  [sym_property_assignment] = "property_assignment",
  [sym_event_declaration] = "event_declaration",
  [sym_typed_function_return_type] = "typed_function_return_type",
  [sym_property_accessor_declaration] = "property_accessor_declaration",
  [sym_typed_method_declaration] = "typed_method_declaration",
  [sym_listener_declaration] = "listener_declaration",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_statement_block_repeat1] = "statement_block_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_object_pattern_repeat1] = "object_pattern_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_array_pattern_repeat1] = "array_pattern_repeat1",
  [aux_sym_glimmer_template_repeat1] = "glimmer_template_repeat1",
  [aux_sym_class_repeat1] = "class_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_type_clause_repeat1] = "extends_type_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_template_literal_type_repeat1] = "template_literal_type_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [aux_sym_import_path_repeat1] = "import_path_repeat1",
  [aux_sym_import_path_segment_repeat1] = "import_path_segment_repeat1",
  [aux_sym_js_import_statement_repeat1] = "js_import_statement_repeat1",
  [aux_sym_component_short_heritage_repeat1] = "component_short_heritage_repeat1",
  [aux_sym_component_body_repeat1] = "component_body_repeat1",
  [aux_sym_new_component_body_repeat1] = "new_component_body_repeat1",
  [aux_sym_formal_type_parameters_repeat1] = "formal_type_parameters_repeat1",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_shorthand_property_identifier_pattern] = "shorthand_property_identifier_pattern",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_this_type] = "this_type",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [sym__glimmer_template_content] = sym__glimmer_template_content,
  [anon_sym_LTtemplate_GT] = anon_sym_LTtemplate_GT,
  [anon_sym_LT_SLASHtemplate_GT] = anon_sym_LT_SLASHtemplate_GT,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_QMARK_DOT] = anon_sym_QMARK_DOT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [sym_unescaped_double_string_fragment] = sym_unescaped_double_string_fragment,
  [sym_unescaped_single_string_fragment] = sym_unescaped_double_string_fragment,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_comment] = sym_comment,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_number] = sym_number,
  [sym_private_property_identifier] = sym_private_property_identifier,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_undefined] = sym_undefined,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_readonly] = anon_sym_readonly,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_symbol] = anon_sym_symbol,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_satisfies] = anon_sym_satisfies,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_DASH_QMARK_COLON] = anon_sym_DASH_QMARK_COLON,
  [anon_sym_QMARK_COLON] = anon_sym_QMARK_COLON,
  [anon_sym_asserts] = anon_sym_asserts,
  [anon_sym_infer] = anon_sym_infer,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_keyof] = anon_sym_keyof,
  [anon_sym_unknown] = anon_sym_unknown,
  [anon_sym_never] = anon_sym_never,
  [anon_sym_object] = anon_sym_object,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [anon_sym_component] = anon_sym_component,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_instance] = anon_sym_instance,
  [anon_sym_constructor] = anon_sym_constructor,
  [anon_sym_BQUOTE_BQUOTE_BQUOTE] = anon_sym_BQUOTE_BQUOTE_BQUOTE,
  [anon_sym_prop] = anon_sym_prop,
  [anon_sym_id] = anon_sym_id,
  [anon_sym_event] = anon_sym_event,
  [anon_sym_fn] = anon_sym_fn,
  [anon_sym_on] = anon_sym_on,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym__ternary_qmark] = anon_sym_QMARK,
  [sym__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_declaration] = sym_declaration,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_else_clause] = sym_else_clause,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_expression] = sym_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_object_pattern] = sym_object_pattern,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_object_assignment_pattern] = sym_object_assignment_pattern,
  [sym_array] = sym_array,
  [sym_array_pattern] = sym_array_pattern,
  [sym_glimmer_template] = sym_glimmer_template,
  [sym_glimmer_opening_tag] = sym_glimmer_opening_tag,
  [sym_glimmer_closing_tag] = sym_glimmer_closing_tag,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function] = sym_function,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym__call_signature] = sym__call_signature,
  [sym__formal_parameter] = sym__formal_parameter,
  [sym_optional_chain] = sym_optional_chain,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym__augmented_assignment_lhs] = sym__augmented_assignment_lhs,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym__destructuring_pattern] = sym__destructuring_pattern,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_class_static_block] = sym_class_static_block,
  [sym_pattern] = sym_pattern,
  [sym_rest_pattern] = sym_rest_pattern,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym_pair_pattern] = sym_pair_pattern,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym_non_null_expression] = sym_non_null_expression,
  [sym_method_signature] = sym_method_signature,
  [sym_abstract_method_signature] = sym_abstract_method_signature,
  [sym_function_signature] = sym_function_signature,
  [sym_type_assertion] = sym_type_assertion,
  [sym_as_expression] = sym_as_expression,
  [sym_satisfies_expression] = sym_satisfies_expression,
  [sym_extends_clause] = sym_extends_clause,
  [sym_implements_clause] = sym_implements_clause,
  [sym_ambient_declaration] = sym_ambient_declaration,
  [sym_abstract_class_declaration] = sym_abstract_class_declaration,
  [sym_module] = sym_module,
  [sym_internal_module] = sym_internal_module,
  [sym__module] = sym__module,
  [sym_import_alias] = sym_import_alias,
  [sym_nested_type_identifier] = sym_nested_type_identifier,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_extends_type_clause] = sym_extends_type_clause,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_assignment] = sym_enum_assignment,
  [sym_type_alias_declaration] = sym_type_alias_declaration,
  [sym_accessibility_modifier] = sym_accessibility_modifier,
  [sym_override_modifier] = sym_override_modifier,
  [sym_required_parameter] = sym_required_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym__parameter_name] = sym__parameter_name,
  [sym_omitting_type_annotation] = sym_omitting_type_annotation,
  [sym_opting_type_annotation] = sym_opting_type_annotation,
  [sym_type_annotation] = sym_type_annotation,
  [sym_asserts] = sym_asserts,
  [sym__type] = sym__type,
  [sym_tuple_parameter] = sym_required_parameter,
  [sym_optional_tuple_parameter] = sym_optional_parameter,
  [sym_optional_type] = sym_optional_type,
  [sym_rest_type] = sym_rest_type,
  [sym__tuple_type_member] = sym__tuple_type_member,
  [sym_constructor_type] = sym_constructor_type,
  [sym__primary_type] = sym__primary_type,
  [sym_template_type] = sym_template_type,
  [sym_template_literal_type] = sym_template_literal_type,
  [sym_infer_type] = sym_infer_type,
  [sym_conditional_type] = sym_conditional_type,
  [sym_generic_type] = sym_generic_type,
  [sym_type_predicate] = sym_type_predicate,
  [sym_type_predicate_annotation] = sym_type_predicate_annotation,
  [sym__type_query_member_expression] = sym_member_expression,
  [sym__type_query_subscript_expression] = sym_subscript_expression,
  [sym__type_query_call_expression] = sym_call_expression,
  [sym_type_query] = sym_type_query,
  [sym_index_type_query] = sym_index_type_query,
  [sym_lookup_type] = sym_lookup_type,
  [sym_mapped_type_clause] = sym_mapped_type_clause,
  [sym_literal_type] = sym_literal_type,
  [sym__number] = sym_unary_expression,
  [sym_existential_type] = sym_existential_type,
  [sym_flow_maybe_type] = sym_flow_maybe_type,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym_predefined_type] = sym_predefined_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_object_type] = sym_object_type,
  [sym_call_signature] = sym_call_signature,
  [sym_property_signature] = sym_property_signature,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_default_type] = sym_default_type,
  [sym_constraint] = sym_constraint,
  [sym_construct_signature] = sym_construct_signature,
  [sym_index_signature] = sym_index_signature,
  [sym_array_type] = sym_array_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_readonly_type] = sym_readonly_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_function_type] = sym_function_type,
  [sym_property_assignment_expression] = sym_property_assignment_expression,
  [sym_import_path] = sym_import_path,
  [sym_import_path_segment] = sym_import_path_segment,
  [sym_import_as] = sym_import_as,
  [sym_js_import_statement] = sym_js_import_statement,
  [sym_component] = sym_component,
  [sym_component_declaration] = sym_component_declaration,
  [sym_component_short_heritage] = sym_component_short_heritage,
  [sym_component_heritage] = sym_component_heritage,
  [sym_component_identifier] = sym_component_identifier,
  [sym_component_instance] = sym_component_instance,
  [sym_component_instance_statement] = sym_component_instance_statement,
  [sym_new_component_expression] = sym_new_component_expression,
  [sym_new_tagged_component_expression] = sym_new_tagged_component_expression,
  [sym_new_tripple_tagged_component_expression] = sym_new_tripple_tagged_component_expression,
  [sym_component_body] = sym_component_body,
  [sym_new_component_body] = sym_new_component_body,
  [sym_constructor_definition] = sym_constructor_definition,
  [sym_tagged_type_string] = sym_tagged_type_string,
  [sym_tripple_tagged_type_string] = sym_tripple_tagged_type_string,
  [sym_formal_type_parameters] = sym_formal_type_parameters,
  [sym_required_type_parameter] = sym_required_type_parameter,
  [sym_optional_type_parameter] = sym_optional_type_parameter,
  [sym_formal_type_parameter] = sym_formal_type_parameter,
  [sym_property_declaration_name] = sym_property_declaration_name,
  [sym_type_narrow] = sym_type_narrow,
  [sym_property_declaration] = sym_property_declaration,
  [sym_property_expression_initializer] = sym_property_expression_initializer,
  [sym_static_property_declaration] = sym_static_property_declaration,
  [sym_identifier_property_assignment] = sym_identifier_property_assignment,
  [sym_property_assignment] = sym_property_assignment,
  [sym_event_declaration] = sym_event_declaration,
  [sym_typed_function_return_type] = sym_typed_function_return_type,
  [sym_property_accessor_declaration] = sym_property_accessor_declaration,
  [sym_typed_method_declaration] = sym_typed_method_declaration,
  [sym_listener_declaration] = sym_listener_declaration,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_statement_block_repeat1] = aux_sym_statement_block_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_object_pattern_repeat1] = aux_sym_object_pattern_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_array_pattern_repeat1] = aux_sym_array_pattern_repeat1,
  [aux_sym_glimmer_template_repeat1] = aux_sym_glimmer_template_repeat1,
  [aux_sym_class_repeat1] = aux_sym_class_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym_extends_clause_repeat1] = aux_sym_extends_clause_repeat1,
  [aux_sym_implements_clause_repeat1] = aux_sym_implements_clause_repeat1,
  [aux_sym_extends_type_clause_repeat1] = aux_sym_extends_type_clause_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_template_literal_type_repeat1] = aux_sym_template_literal_type_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [aux_sym_import_path_repeat1] = aux_sym_import_path_repeat1,
  [aux_sym_import_path_segment_repeat1] = aux_sym_import_path_segment_repeat1,
  [aux_sym_js_import_statement_repeat1] = aux_sym_js_import_statement_repeat1,
  [aux_sym_component_short_heritage_repeat1] = aux_sym_component_short_heritage_repeat1,
  [aux_sym_component_body_repeat1] = aux_sym_component_body_repeat1,
  [aux_sym_new_component_body_repeat1] = aux_sym_new_component_body_repeat1,
  [aux_sym_formal_type_parameters_repeat1] = aux_sym_formal_type_parameters_repeat1,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_shorthand_property_identifier_pattern] = alias_sym_shorthand_property_identifier_pattern,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_this_type] = alias_sym_this_type,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym__glimmer_template_content] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LTtemplate_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_SLASHtemplate_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_unescaped_double_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_unescaped_single_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_private_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_satisfies] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asserts] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unknown] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_never] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_object] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_component] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instance] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constructor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE_BQUOTE_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_prop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_id] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_event] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_on] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym__ternary_qmark] = {
    .visible = true,
    .named = false,
  },
  [sym__function_signature_automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_object_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_template] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_opening_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_closing_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym__formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_optional_chain] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__augmented_assignment_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym__destructuring_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_class_static_block] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_rest_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_pair_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_satisfies_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_override_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_omitting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_opting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_asserts] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_type] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_type_member] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_template_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym_infer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_readonly_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_property_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_path] = {
    .visible = true,
    .named = true,
  },
  [sym_import_path_segment] = {
    .visible = true,
    .named = true,
  },
  [sym_import_as] = {
    .visible = true,
    .named = true,
  },
  [sym_js_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_component] = {
    .visible = true,
    .named = true,
  },
  [sym_component_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_component_short_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_component_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_component_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_component_instance] = {
    .visible = true,
    .named = true,
  },
  [sym_component_instance_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_new_component_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_tagged_component_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_tripple_tagged_component_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_component_body] = {
    .visible = true,
    .named = true,
  },
  [sym_new_component_body] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_tagged_type_string] = {
    .visible = true,
    .named = true,
  },
  [sym_tripple_tagged_type_string] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_required_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_property_declaration_name] = {
    .visible = true,
    .named = true,
  },
  [sym_type_narrow] = {
    .visible = true,
    .named = true,
  },
  [sym_property_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_property_expression_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_static_property_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier_property_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_property_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_event_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_function_return_type] = {
    .visible = true,
    .named = true,
  },
  [sym_property_accessor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_listener_declaration] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_statement_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_glimmer_template_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_type_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_literal_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_path_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_path_segment_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_js_import_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_component_short_heritage_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_component_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_new_component_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_this_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_assignment = 5,
  field_binding_assignemnt = 6,
  field_body = 7,
  field_close_tag = 8,
  field_condition = 9,
  field_consequence = 10,
  field_constraint = 11,
  field_constructor = 12,
  field_content = 13,
  field_decorator = 14,
  field_finalizer = 15,
  field_flags = 16,
  field_function = 17,
  field_handler = 18,
  field_heritage = 19,
  field_id = 20,
  field_increment = 21,
  field_index = 22,
  field_index_type = 23,
  field_initializer = 24,
  field_key = 25,
  field_kind = 26,
  field_label = 27,
  field_left = 28,
  field_member = 29,
  field_module = 30,
  field_name = 31,
  field_object = 32,
  field_open_tag = 33,
  field_operator = 34,
  field_optional_chain = 35,
  field_parameter = 36,
  field_parameters = 37,
  field_pattern = 38,
  field_property = 39,
  field_relative = 40,
  field_return = 41,
  field_return_type = 42,
  field_right = 43,
  field_sign = 44,
  field_source = 45,
  field_type = 46,
  field_type_arguments = 47,
  field_type_parameters = 48,
  field_value = 49,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_assignment] = "assignment",
  [field_binding_assignemnt] = "binding_assignemnt",
  [field_body] = "body",
  [field_close_tag] = "close_tag",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_constructor] = "constructor",
  [field_content] = "content",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_heritage] = "heritage",
  [field_id] = "id",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_index_type] = "index_type",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_kind] = "kind",
  [field_label] = "label",
  [field_left] = "left",
  [field_member] = "member",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_open_tag] = "open_tag",
  [field_operator] = "operator",
  [field_optional_chain] = "optional_chain",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_relative] = "relative",
  [field_return] = "return",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_sign] = "sign",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 1},
  [4] = {.index = 3, .length = 2},
  [5] = {.index = 5, .length = 2},
  [6] = {.index = 7, .length = 1},
  [7] = {.index = 8, .length = 2},
  [10] = {.index = 10, .length = 2},
  [11] = {.index = 12, .length = 1},
  [12] = {.index = 13, .length = 2},
  [13] = {.index = 15, .length = 2},
  [14] = {.index = 17, .length = 2},
  [15] = {.index = 19, .length = 3},
  [16] = {.index = 22, .length = 1},
  [17] = {.index = 23, .length = 2},
  [18] = {.index = 25, .length = 3},
  [19] = {.index = 28, .length = 1},
  [21] = {.index = 29, .length = 1},
  [22] = {.index = 30, .length = 2},
  [24] = {.index = 32, .length = 3},
  [25] = {.index = 35, .length = 2},
  [26] = {.index = 37, .length = 2},
  [27] = {.index = 39, .length = 2},
  [28] = {.index = 41, .length = 1},
  [29] = {.index = 42, .length = 2},
  [30] = {.index = 22, .length = 1},
  [31] = {.index = 44, .length = 2},
  [32] = {.index = 46, .length = 2},
  [34] = {.index = 48, .length = 1},
  [35] = {.index = 46, .length = 2},
  [36] = {.index = 49, .length = 2},
  [37] = {.index = 51, .length = 1},
  [38] = {.index = 52, .length = 2},
  [39] = {.index = 54, .length = 3},
  [40] = {.index = 57, .length = 3},
  [41] = {.index = 60, .length = 3},
  [42] = {.index = 63, .length = 2},
  [43] = {.index = 65, .length = 3},
  [44] = {.index = 68, .length = 3},
  [45] = {.index = 71, .length = 3},
  [46] = {.index = 74, .length = 4},
  [47] = {.index = 78, .length = 1},
  [48] = {.index = 79, .length = 1},
  [49] = {.index = 80, .length = 2},
  [50] = {.index = 82, .length = 2},
  [51] = {.index = 84, .length = 2},
  [52] = {.index = 86, .length = 2},
  [53] = {.index = 88, .length = 1},
  [54] = {.index = 89, .length = 4},
  [55] = {.index = 93, .length = 2},
  [56] = {.index = 95, .length = 4},
  [57] = {.index = 99, .length = 4},
  [59] = {.index = 103, .length = 1},
  [60] = {.index = 104, .length = 3},
  [61] = {.index = 107, .length = 3},
  [62] = {.index = 110, .length = 2},
  [63] = {.index = 112, .length = 2},
  [64] = {.index = 114, .length = 2},
  [65] = {.index = 116, .length = 2},
  [66] = {.index = 118, .length = 2},
  [67] = {.index = 120, .length = 2},
  [68] = {.index = 122, .length = 1},
  [69] = {.index = 123, .length = 2},
  [70] = {.index = 125, .length = 2},
  [71] = {.index = 127, .length = 2},
  [72] = {.index = 129, .length = 2},
  [73] = {.index = 131, .length = 4},
  [74] = {.index = 135, .length = 2},
  [75] = {.index = 137, .length = 4},
  [76] = {.index = 141, .length = 4},
  [77] = {.index = 145, .length = 4},
  [78] = {.index = 149, .length = 1},
  [79] = {.index = 150, .length = 2},
  [80] = {.index = 152, .length = 2},
  [83] = {.index = 13, .length = 2},
  [84] = {.index = 154, .length = 1},
  [85] = {.index = 155, .length = 1},
  [86] = {.index = 156, .length = 2},
  [87] = {.index = 158, .length = 4},
  [88] = {.index = 162, .length = 2},
  [89] = {.index = 164, .length = 2},
  [90] = {.index = 150, .length = 2},
  [91] = {.index = 152, .length = 2},
  [92] = {.index = 166, .length = 3},
  [93] = {.index = 30, .length = 2},
  [94] = {.index = 169, .length = 3},
  [95] = {.index = 169, .length = 3},
  [96] = {.index = 172, .length = 3},
  [97] = {.index = 175, .length = 3},
  [98] = {.index = 178, .length = 4},
  [99] = {.index = 182, .length = 3},
  [100] = {.index = 185, .length = 4},
  [101] = {.index = 189, .length = 2},
  [102] = {.index = 191, .length = 2},
  [103] = {.index = 193, .length = 2},
  [104] = {.index = 195, .length = 1},
  [105] = {.index = 196, .length = 4},
  [106] = {.index = 200, .length = 2},
  [107] = {.index = 202, .length = 4},
  [108] = {.index = 202, .length = 4},
  [109] = {.index = 206, .length = 4},
  [110] = {.index = 206, .length = 4},
  [111] = {.index = 210, .length = 4},
  [112] = {.index = 210, .length = 4},
  [113] = {.index = 214, .length = 1},
  [114] = {.index = 215, .length = 3},
  [115] = {.index = 218, .length = 3},
  [116] = {.index = 221, .length = 4},
  [117] = {.index = 225, .length = 2},
  [118] = {.index = 227, .length = 3},
  [119] = {.index = 230, .length = 2},
  [120] = {.index = 232, .length = 3},
  [121] = {.index = 235, .length = 3},
  [122] = {.index = 238, .length = 3},
  [123] = {.index = 241, .length = 3},
  [124] = {.index = 244, .length = 5},
  [125] = {.index = 249, .length = 1},
  [126] = {.index = 150, .length = 2},
  [127] = {.index = 250, .length = 2},
  [128] = {.index = 252, .length = 5},
  [129] = {.index = 257, .length = 1},
  [130] = {.index = 258, .length = 2},
  [131] = {.index = 260, .length = 2},
  [132] = {.index = 262, .length = 2},
  [133] = {.index = 264, .length = 3},
  [134] = {.index = 267, .length = 2},
  [135] = {.index = 269, .length = 3},
  [136] = {.index = 272, .length = 2},
  [137] = {.index = 274, .length = 2},
  [138] = {.index = 276, .length = 4},
  [139] = {.index = 274, .length = 2},
  [140] = {.index = 280, .length = 4},
  [141] = {.index = 284, .length = 5},
  [142] = {.index = 289, .length = 3},
  [143] = {.index = 292, .length = 2},
  [144] = {.index = 65, .length = 3},
  [145] = {.index = 294, .length = 2},
  [146] = {.index = 296, .length = 3},
  [147] = {.index = 299, .length = 4},
  [148] = {.index = 200, .length = 2},
  [149] = {.index = 303, .length = 1},
  [150] = {.index = 304, .length = 4},
  [151] = {.index = 308, .length = 3},
  [152] = {.index = 311, .length = 2},
  [153] = {.index = 313, .length = 2},
  [154] = {.index = 315, .length = 1},
  [155] = {.index = 316, .length = 2},
  [156] = {.index = 318, .length = 2},
  [157] = {.index = 320, .length = 4},
  [158] = {.index = 324, .length = 4},
  [159] = {.index = 328, .length = 4},
  [160] = {.index = 332, .length = 1},
  [161] = {.index = 333, .length = 4},
  [162] = {.index = 337, .length = 2},
  [163] = {.index = 339, .length = 3},
  [164] = {.index = 342, .length = 3},
  [165] = {.index = 345, .length = 2},
  [166] = {.index = 347, .length = 2},
  [167] = {.index = 349, .length = 2},
  [168] = {.index = 351, .length = 3},
  [169] = {.index = 354, .length = 2},
  [170] = {.index = 356, .length = 2},
  [171] = {.index = 358, .length = 4},
  [172] = {.index = 200, .length = 2},
  [173] = {.index = 362, .length = 5},
  [174] = {.index = 367, .length = 2},
  [175] = {.index = 369, .length = 2},
  [176] = {.index = 371, .length = 3},
  [177] = {.index = 374, .length = 4},
  [178] = {.index = 378, .length = 4},
  [179] = {.index = 382, .length = 4},
  [180] = {.index = 386, .length = 5},
  [181] = {.index = 391, .length = 3},
  [182] = {.index = 394, .length = 3},
  [183] = {.index = 397, .length = 3},
  [184] = {.index = 400, .length = 4},
  [185] = {.index = 404, .length = 3},
  [186] = {.index = 407, .length = 4},
  [187] = {.index = 411, .length = 4},
  [188] = {.index = 415, .length = 2},
  [189] = {.index = 417, .length = 2},
  [190] = {.index = 419, .length = 1},
  [191] = {.index = 420, .length = 3},
  [192] = {.index = 423, .length = 1},
  [193] = {.index = 424, .length = 2},
  [194] = {.index = 426, .length = 4},
  [195] = {.index = 430, .length = 4},
  [196] = {.index = 434, .length = 4},
  [197] = {.index = 438, .length = 2},
  [198] = {.index = 440, .length = 4},
  [199] = {.index = 444, .length = 2},
  [200] = {.index = 446, .length = 1},
  [201] = {.index = 447, .length = 2},
  [202] = {.index = 449, .length = 2},
  [203] = {.index = 451, .length = 6},
  [204] = {.index = 457, .length = 2},
  [205] = {.index = 459, .length = 2},
  [206] = {.index = 461, .length = 2},
  [207] = {.index = 463, .length = 2},
  [208] = {.index = 465, .length = 1},
  [209] = {.index = 466, .length = 2},
  [210] = {.index = 468, .length = 3},
  [211] = {.index = 471, .length = 3},
  [212] = {.index = 474, .length = 3},
  [213] = {.index = 477, .length = 3},
  [214] = {.index = 480, .length = 3},
  [215] = {.index = 483, .length = 3},
  [216] = {.index = 486, .length = 3},
  [217] = {.index = 489, .length = 5},
  [218] = {.index = 494, .length = 2},
  [219] = {.index = 496, .length = 2},
  [220] = {.index = 498, .length = 3},
  [221] = {.index = 501, .length = 5},
  [222] = {.index = 506, .length = 4},
  [223] = {.index = 510, .length = 3},
  [224] = {.index = 513, .length = 3},
  [225] = {.index = 510, .length = 3},
  [226] = {.index = 516, .length = 2},
  [227] = {.index = 518, .length = 4},
  [228] = {.index = 522, .length = 4},
  [229] = {.index = 526, .length = 2},
  [230] = {.index = 528, .length = 2},
  [231] = {.index = 530, .length = 2},
  [232] = {.index = 532, .length = 3},
  [233] = {.index = 535, .length = 6},
  [234] = {.index = 541, .length = 3},
  [235] = {.index = 530, .length = 2},
  [236] = {.index = 544, .length = 1},
  [237] = {.index = 544, .length = 1},
  [238] = {.index = 545, .length = 4},
  [239] = {.index = 549, .length = 4},
  [240] = {.index = 553, .length = 5},
  [241] = {.index = 558, .length = 2},
  [242] = {.index = 560, .length = 3},
  [243] = {.index = 563, .length = 3},
  [244] = {.index = 566, .length = 2},
  [245] = {.index = 568, .length = 4},
  [246] = {.index = 572, .length = 4},
  [247] = {.index = 576, .length = 3},
  [248] = {.index = 576, .length = 3},
  [249] = {.index = 579, .length = 2},
  [250] = {.index = 581, .length = 2},
  [251] = {.index = 583, .length = 2},
  [252] = {.index = 585, .length = 2},
  [253] = {.index = 587, .length = 3},
  [254] = {.index = 590, .length = 2},
  [255] = {.index = 590, .length = 2},
  [256] = {.index = 592, .length = 3},
  [257] = {.index = 595, .length = 5},
  [258] = {.index = 600, .length = 5},
  [259] = {.index = 605, .length = 3},
  [260] = {.index = 608, .length = 2},
  [261] = {.index = 610, .length = 3},
  [262] = {.index = 613, .length = 2},
  [263] = {.index = 615, .length = 1},
  [264] = {.index = 616, .length = 4},
  [265] = {.index = 616, .length = 4},
  [266] = {.index = 620, .length = 4},
  [267] = {.index = 624, .length = 4},
  [268] = {.index = 628, .length = 3},
  [269] = {.index = 631, .length = 3},
  [270] = {.index = 631, .length = 3},
  [271] = {.index = 634, .length = 3},
  [272] = {.index = 637, .length = 3},
  [273] = {.index = 640, .length = 2},
  [274] = {.index = 642, .length = 2},
  [275] = {.index = 644, .length = 2},
  [276] = {.index = 646, .length = 1},
  [277] = {.index = 647, .length = 3},
  [278] = {.index = 650, .length = 4},
  [279] = {.index = 654, .length = 5},
  [280] = {.index = 659, .length = 5},
  [281] = {.index = 664, .length = 3},
  [282] = {.index = 667, .length = 2},
  [283] = {.index = 669, .length = 3},
  [284] = {.index = 672, .length = 2},
  [285] = {.index = 674, .length = 2},
  [286] = {.index = 676, .length = 4},
  [287] = {.index = 680, .length = 2},
  [288] = {.index = 682, .length = 4},
  [289] = {.index = 686, .length = 4},
  [290] = {.index = 690, .length = 2},
  [292] = {.index = 692, .length = 4},
  [293] = {.index = 696, .length = 5},
  [294] = {.index = 701, .length = 5},
  [295] = {.index = 706, .length = 3},
  [296] = {.index = 709, .length = 2},
  [297] = {.index = 711, .length = 2},
  [298] = {.index = 713, .length = 3},
  [299] = {.index = 716, .length = 5},
  [300] = {.index = 721, .length = 3},
  [301] = {.index = 724, .length = 5},
  [302] = {.index = 729, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_relative, 0},
  [2] =
    {field_body, 1},
  [3] =
    {field_body, 1},
    {field_heritage, 0},
  [5] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [7] =
    {field_source, 2},
  [8] =
    {field_arguments, 1},
    {field_function, 0},
  [10] =
    {field_argument, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
  [12] =
    {field_member, 0},
  [13] =
    {field_body, 2},
    {field_name, 1},
  [15] =
    {field_body, 2},
    {field_heritage, 1},
  [17] =
    {field_body, 2},
    {field_id, 1},
  [19] =
    {field_body, 2},
    {field_heritage, 0},
    {field_id, 1},
  [22] =
    {field_name, 0},
  [23] =
    {field_body, 2},
    {field_decorator, 0, .inherited = true},
  [25] =
    {field_body, 2},
    {field_decorator, 0, .inherited = true},
    {field_heritage, 1},
  [28] =
    {field_source, 3},
  [29] =
    {field_parameters, 0},
  [30] =
    {field_object, 0},
    {field_property, 2},
  [32] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [35] =
    {field_object, 1, .inherited = true},
    {field_property, 1, .inherited = true},
  [37] =
    {field_index, 1, .inherited = true},
    {field_object, 1, .inherited = true},
  [39] =
    {field_arguments, 1, .inherited = true},
    {field_function, 1, .inherited = true},
  [41] =
    {field_pattern, 0},
  [42] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
  [44] =
    {field_argument, 1},
    {field_operator, 0},
  [46] =
    {field_name, 0},
    {field_type_arguments, 1},
  [48] =
    {field_name, 1},
  [49] =
    {field_name, 1},
    {field_type, 0},
  [51] =
    {field_member, 1, .inherited = true},
  [52] =
    {field_member, 0, .inherited = true},
    {field_member, 1, .inherited = true},
  [54] =
    {field_body, 3},
    {field_heritage, 2},
    {field_name, 1},
  [57] =
    {field_body, 3},
    {field_id, 2},
    {field_name, 1},
  [60] =
    {field_body, 3},
    {field_heritage, 1},
    {field_id, 2},
  [63] =
    {field_arguments, 2},
    {field_name, 0},
  [65] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [68] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_heritage, 2},
  [71] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_id, 2},
  [74] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_heritage, 1},
    {field_id, 2},
  [78] =
    {field_source, 4},
  [79] =
    {field_constructor, 1},
  [80] =
    {field_argument, 0},
    {field_operator, 1},
  [82] =
    {field_close_tag, 1},
    {field_open_tag, 0},
  [84] =
    {field_parameters, 0},
    {field_return_type, 1},
  [86] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [88] =
    {field_parameters, 1},
  [89] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [93] =
    {field_name, 0},
    {field_type, 1},
  [95] =
    {field_arguments, 1},
    {field_function, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [99] =
    {field_arguments, 1},
    {field_function, 0},
    {field_index, 0, .inherited = true},
    {field_object, 0, .inherited = true},
  [103] =
    {field_pattern, 1},
  [104] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [107] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 1},
  [110] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 1},
  [112] =
    {field_name, 0},
    {field_value, 1},
  [114] =
    {field_constraint, 1},
    {field_name, 0},
  [116] =
    {field_binding_assignemnt, 1},
    {field_name, 0},
  [118] =
    {field_assignment, 1},
    {field_name, 0},
  [120] =
    {field_module, 0},
    {field_name, 2},
  [122] =
    {field_name, 2},
  [123] =
    {field_name, 2},
    {field_type, 1},
  [125] =
    {field_body, 2},
    {field_parameters, 1},
  [127] =
    {field_name, 1},
    {field_parameters, 2},
  [129] =
    {field_parameters, 0},
    {field_return_type, 2},
  [131] =
    {field_body, 4},
    {field_heritage, 2},
    {field_id, 3},
    {field_name, 1},
  [135] =
    {field_arguments, 3},
    {field_name, 0},
  [137] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_heritage, 3},
    {field_name, 2},
  [141] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_id, 3},
    {field_name, 2},
  [145] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_heritage, 2},
    {field_id, 3},
  [149] =
    {field_source, 5},
  [150] =
    {field_left, 0},
    {field_right, 2},
  [152] =
    {field_body, 2},
    {field_parameter, 0},
  [154] =
    {field_value, 1},
  [155] =
    {field_body, 2},
  [156] =
    {field_body, 2},
    {field_type_parameters, 1},
  [158] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [162] =
    {field_arguments, 2},
    {field_constructor, 1},
  [164] =
    {field_constructor, 1},
    {field_type_arguments, 2},
  [166] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [169] =
    {field_object, 0},
    {field_optional_chain, 1},
    {field_property, 2},
  [172] =
    {field_arguments, 2},
    {field_function, 0},
    {field_optional_chain, 1},
  [175] =
    {field_close_tag, 2},
    {field_content, 1},
    {field_open_tag, 0},
  [178] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [182] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [185] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [189] =
    {field_parameters, 1},
    {field_type, 2},
  [191] =
    {field_parameters, 2},
    {field_type_parameters, 1},
  [193] =
    {field_name, 1},
    {field_type, 2},
  [195] =
    {field_parameters, 2},
  [196] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [200] =
    {field_name, 0},
    {field_type, 2},
  [202] =
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
    {field_property, 2},
  [206] =
    {field_index, 0, .inherited = true},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 2},
  [210] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_object, 0},
    {field_property, 2},
  [214] =
    {field_pattern, 2},
  [215] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_value, 2, .inherited = true},
  [218] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 2},
  [221] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [225] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 2},
  [227] =
    {field_constraint, 1},
    {field_name, 0},
    {field_value, 2},
  [230] =
    {field_parameters, 1},
    {field_type, 3},
  [232] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2},
  [235] =
    {field_parameters, 1},
    {field_return_type, 3},
    {field_type_parameters, 0},
  [238] =
    {field_binding_assignemnt, 2},
    {field_name, 1},
    {field_type, 0},
  [241] =
    {field_assignment, 2},
    {field_name, 1},
    {field_type, 0},
  [244] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_heritage, 3},
    {field_id, 4},
    {field_name, 2},
  [249] =
    {field_source, 6},
  [250] =
    {field_key, 0},
    {field_value, 2},
  [252] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [257] =
    {field_type, 2},
  [258] =
    {field_flags, 3},
    {field_pattern, 1},
  [260] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [262] =
    {field_body, 3},
    {field_name, 1},
  [264] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [267] =
    {field_type_arguments, 2},
    {field_value, 1},
  [269] =
    {field_type_arguments, 2, .inherited = true},
    {field_value, 1},
    {field_value, 2, .inherited = true},
  [272] =
    {field_body, 3},
    {field_type_parameters, 1},
  [274] =
    {field_body, 3},
    {field_parameter, 1},
  [276] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [280] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [284] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [289] =
    {field_arguments, 3},
    {field_constructor, 1},
    {field_type_arguments, 2},
  [292] =
    {field_index, 2},
    {field_object, 0},
  [294] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [296] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [299] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [303] =
    {field_type, 3},
  [304] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [308] =
    {field_parameters, 2},
    {field_type, 3},
    {field_type_parameters, 1},
  [311] =
    {field_name, 2},
    {field_type, 3},
  [313] =
    {field_name, 1},
    {field_type, 3},
  [315] =
    {field_name, 3},
  [316] =
    {field_parameters, 2},
    {field_type, 3},
  [318] =
    {field_parameters, 3},
    {field_type_parameters, 2},
  [320] =
    {field_index, 2},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [324] =
    {field_index, 0, .inherited = true},
    {field_index, 2},
    {field_object, 0},
    {field_object, 0, .inherited = true},
  [328] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_index, 2},
    {field_object, 0},
  [332] =
    {field_pattern, 3},
  [333] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [337] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 3},
  [339] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
  [342] =
    {field_parameters, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [345] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [347] =
    {field_body, 4},
    {field_name, 1},
  [349] =
    {field_parameters, 2},
    {field_type, 4},
  [351] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [354] =
    {field_binding_assignemnt, 3},
    {field_name, 1},
  [356] =
    {field_assignment, 3},
    {field_name, 1},
  [358] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
    {field_return, 3},
  [362] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [367] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [369] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [371] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [374] =
    {field_type_arguments, 2},
    {field_type_arguments, 3, .inherited = true},
    {field_value, 1},
    {field_value, 3, .inherited = true},
  [378] =
    {field_type_arguments, 0, .inherited = true},
    {field_type_arguments, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [382] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [386] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [391] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [394] =
    {field_index, 3},
    {field_object, 0},
    {field_optional_chain, 1},
  [397] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [400] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [404] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [407] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [411] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [415] =
    {field_name, 2},
    {field_type, 4},
  [417] =
    {field_name, 3},
    {field_type, 4},
  [419] =
    {field_type, 4},
  [420] =
    {field_parameters, 3},
    {field_type, 4},
    {field_type_parameters, 2},
  [423] =
    {field_name, 4},
  [424] =
    {field_index, 3},
    {field_object, 0},
  [426] =
    {field_index, 3},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [430] =
    {field_index, 0, .inherited = true},
    {field_index, 3},
    {field_object, 0},
    {field_object, 0, .inherited = true},
  [434] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_index, 3},
    {field_object, 0},
  [438] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 4},
  [440] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
    {field_return, 4},
  [444] =
    {field_body, 2},
    {field_label, 0},
  [446] =
    {field_kind, 0},
  [447] =
    {field_condition, 1},
    {field_consequence, 2},
  [449] =
    {field_body, 2},
    {field_value, 1},
  [451] =
    {field_body, 2},
    {field_kind, 1, .inherited = true},
    {field_left, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [457] =
    {field_body, 2},
    {field_condition, 1},
  [459] =
    {field_body, 1},
    {field_handler, 2},
  [461] =
    {field_body, 1},
    {field_finalizer, 2},
  [463] =
    {field_body, 2},
    {field_object, 1},
  [465] =
    {field_label, 1},
  [466] =
    {field_body, 1},
    {field_name, 0},
  [468] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4},
  [471] =
    {field_body, 5},
    {field_name, 1},
    {field_return, 4},
  [474] =
    {field_parameters, 3},
    {field_type, 5},
    {field_type_parameters, 2},
  [477] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [480] =
    {field_binding_assignemnt, 4},
    {field_name, 1},
    {field_type, 3},
  [483] =
    {field_assignment, 4},
    {field_name, 1},
    {field_type, 3},
  [486] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 3},
  [489] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [494] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [496] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [498] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [501] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [506] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [510] =
    {field_index_type, 3},
    {field_name, 1},
    {field_type, 5},
  [513] =
    {field_alias, 4},
    {field_name, 0},
    {field_type, 2},
  [516] =
    {field_sign, 0},
    {field_type, 5},
  [518] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [522] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [526] =
    {field_name, 3},
    {field_type, 5},
  [528] =
    {field_name, 4},
    {field_type, 5},
  [530] =
    {field_body, 3},
    {field_name, 2},
  [532] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [535] =
    {field_body, 3},
    {field_kind, 2, .inherited = true},
    {field_left, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [541] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [544] =
    {field_type, 1},
  [545] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 4},
    {field_return, 5},
  [549] =
    {field_alternative, 6},
    {field_consequence, 4},
    {field_left, 0},
    {field_right, 2},
  [553] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [558] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [560] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [563] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [566] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [568] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [572] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [576] =
    {field_index_type, 4},
    {field_name, 2},
    {field_type, 6},
  [579] =
    {field_name, 4},
    {field_type, 6},
  [581] =
    {field_name, 1},
    {field_value, 3},
  [583] =
    {field_body, 1},
    {field_condition, 3},
  [585] =
    {field_body, 4},
    {field_name, 2},
  [587] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [590] =
    {field_type, 1},
    {field_type, 2, .inherited = true},
  [592] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [595] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [600] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [605] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [608] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [610] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [613] =
    {field_name, 4},
    {field_value, 5, .inherited = true},
  [615] =
    {field_name, 5},
  [616] =
    {field_index_type, 5},
    {field_name, 3},
    {field_sign, 0},
    {field_type, 7},
  [620] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [624] =
    {field_name, 6},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [628] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [631] =
    {field_left, 1},
    {field_operator, 2},
    {field_right, 3},
  [634] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [637] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [640] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [642] =
    {field_name, 1},
    {field_name, 2, .inherited = true},
  [644] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [646] =
    {field_name, 2, .inherited = true},
  [647] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [650] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [654] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [659] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [664] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [667] =
    {field_name, 4},
    {field_value, 6, .inherited = true},
  [669] =
    {field_name, 4},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [672] =
    {field_name, 5},
    {field_value, 6, .inherited = true},
  [674] =
    {field_name, 5},
    {field_type, 6},
  [676] =
    {field_name, 6},
    {field_parameters, 8, .inherited = true},
    {field_return_type, 8, .inherited = true},
    {field_type_parameters, 8, .inherited = true},
  [680] =
    {field_body, 3},
    {field_value, 1},
  [682] =
    {field_kind, 1},
    {field_left, 2},
    {field_operator, 3},
    {field_right, 4},
  [686] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [690] =
    {field_body, 4},
    {field_parameter, 2},
  [692] =
    {field_body, 6},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [696] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [701] =
    {field_body, 8},
    {field_name, 6},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [706] =
    {field_name, 4},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [709] =
    {field_name, 5},
    {field_value, 7, .inherited = true},
  [711] =
    {field_name, 5},
    {field_type, 7},
  [713] =
    {field_name, 5},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [716] =
    {field_kind, 1},
    {field_left, 2},
    {field_operator, 4},
    {field_right, 5},
    {field_value, 3, .inherited = true},
  [721] =
    {field_body, 5},
    {field_parameter, 2},
    {field_type, 3},
  [724] =
    {field_body, 9},
    {field_name, 6},
    {field_parameters, 8, .inherited = true},
    {field_return_type, 8, .inherited = true},
    {field_type_parameters, 8, .inherited = true},
  [729] =
    {field_name, 5},
    {field_type, 7},
    {field_value, 8, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [8] = {
    [0] = alias_sym_type_identifier,
  },
  [9] = {
    [0] = alias_sym_this_type,
  },
  [20] = {
    [0] = sym_identifier,
  },
  [22] = {
    [2] = alias_sym_property_identifier,
  },
  [23] = {
    [0] = alias_sym_property_identifier,
  },
  [30] = {
    [0] = alias_sym_type_identifier,
  },
  [32] = {
    [0] = alias_sym_type_identifier,
  },
  [33] = {
    [1] = alias_sym_type_identifier,
  },
  [58] = {
    [1] = sym_identifier,
  },
  [63] = {
    [0] = alias_sym_type_identifier,
  },
  [64] = {
    [0] = alias_sym_type_identifier,
  },
  [67] = {
    [2] = alias_sym_type_identifier,
  },
  [79] = {
    [0] = sym_identifier,
  },
  [80] = {
    [0] = sym_identifier,
  },
  [81] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [82] = {
    [1] = alias_sym_shorthand_property_identifier_pattern,
  },
  [83] = {
    [1] = alias_sym_type_identifier,
  },
  [94] = {
    [2] = alias_sym_property_identifier,
  },
  [107] = {
    [2] = alias_sym_property_identifier,
  },
  [109] = {
    [2] = alias_sym_property_identifier,
  },
  [111] = {
    [2] = alias_sym_property_identifier,
  },
  [118] = {
    [0] = alias_sym_type_identifier,
  },
  [126] = {
    [0] = alias_sym_shorthand_property_identifier_pattern,
  },
  [132] = {
    [1] = alias_sym_type_identifier,
  },
  [133] = {
    [1] = alias_sym_type_identifier,
  },
  [137] = {
    [1] = sym_identifier,
  },
  [144] = {
    [2] = alias_sym_type_identifier,
  },
  [148] = {
    [0] = alias_sym_type_identifier,
  },
  [172] = {
    [0] = sym_identifier,
  },
  [176] = {
    [1] = alias_sym_type_identifier,
  },
  [183] = {
    [2] = alias_sym_type_identifier,
  },
  [184] = {
    [2] = alias_sym_type_identifier,
  },
  [199] = {
    [0] = alias_sym_statement_identifier,
  },
  [208] = {
    [1] = alias_sym_statement_identifier,
  },
  [222] = {
    [2] = alias_sym_type_identifier,
  },
  [223] = {
    [1] = sym_identifier,
  },
  [224] = {
    [0] = alias_sym_type_identifier,
  },
  [235] = {
    [2] = alias_sym_type_identifier,
  },
  [236] = {
    [1] = alias_sym_type_identifier,
  },
  [247] = {
    [2] = sym_identifier,
  },
  [250] = {
    [1] = alias_sym_type_identifier,
  },
  [252] = {
    [2] = alias_sym_type_identifier,
  },
  [253] = {
    [2] = alias_sym_type_identifier,
  },
  [254] = {
    [1] = alias_sym_type_identifier,
  },
  [256] = {
    [3] = alias_sym_type_identifier,
  },
  [264] = {
    [3] = sym_identifier,
  },
  [268] = {
    [1] = alias_sym_type_identifier,
  },
  [269] = {
    [1] = sym_identifier,
  },
  [272] = {
    [2] = alias_sym_type_identifier,
  },
  [277] = {
    [3] = alias_sym_type_identifier,
  },
  [278] = {
    [3] = alias_sym_type_identifier,
  },
  [291] = {
    [3] = alias_sym_property_identifier,
  },
  [292] = {
    [3] = alias_sym_type_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_predefined_type, 2,
    sym_predefined_type,
    sym_identifier,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 4,
  [5] = 4,
  [6] = 4,
  [7] = 4,
  [8] = 4,
  [9] = 4,
  [10] = 4,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 16,
  [18] = 18,
  [19] = 18,
  [20] = 16,
  [21] = 16,
  [22] = 18,
  [23] = 16,
  [24] = 18,
  [25] = 18,
  [26] = 16,
  [27] = 16,
  [28] = 18,
  [29] = 18,
  [30] = 18,
  [31] = 16,
  [32] = 18,
  [33] = 16,
  [34] = 16,
  [35] = 18,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 37,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 41,
  [45] = 36,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 43,
  [50] = 38,
  [51] = 48,
  [52] = 47,
  [53] = 42,
  [54] = 46,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 56,
  [63] = 63,
  [64] = 63,
  [65] = 63,
  [66] = 63,
  [67] = 63,
  [68] = 63,
  [69] = 63,
  [70] = 70,
  [71] = 70,
  [72] = 72,
  [73] = 72,
  [74] = 72,
  [75] = 72,
  [76] = 72,
  [77] = 72,
  [78] = 78,
  [79] = 78,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 78,
  [86] = 78,
  [87] = 78,
  [88] = 78,
  [89] = 78,
  [90] = 78,
  [91] = 91,
  [92] = 91,
  [93] = 91,
  [94] = 94,
  [95] = 95,
  [96] = 94,
  [97] = 97,
  [98] = 94,
  [99] = 95,
  [100] = 95,
  [101] = 97,
  [102] = 97,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 106,
  [108] = 106,
  [109] = 106,
  [110] = 106,
  [111] = 103,
  [112] = 106,
  [113] = 106,
  [114] = 114,
  [115] = 115,
  [116] = 106,
  [117] = 105,
  [118] = 118,
  [119] = 105,
  [120] = 120,
  [121] = 120,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 125,
  [127] = 127,
  [128] = 122,
  [129] = 127,
  [130] = 130,
  [131] = 131,
  [132] = 131,
  [133] = 131,
  [134] = 131,
  [135] = 131,
  [136] = 131,
  [137] = 131,
  [138] = 138,
  [139] = 131,
  [140] = 131,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 142,
  [146] = 146,
  [147] = 147,
  [148] = 125,
  [149] = 149,
  [150] = 125,
  [151] = 151,
  [152] = 152,
  [153] = 152,
  [154] = 154,
  [155] = 149,
  [156] = 156,
  [157] = 152,
  [158] = 152,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 152,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 149,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 185,
  [187] = 187,
  [188] = 188,
  [189] = 188,
  [190] = 190,
  [191] = 164,
  [192] = 190,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 149,
  [207] = 207,
  [208] = 167,
  [209] = 209,
  [210] = 199,
  [211] = 165,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 213,
  [221] = 166,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 230,
  [233] = 233,
  [234] = 225,
  [235] = 235,
  [236] = 233,
  [237] = 229,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 241,
  [244] = 225,
  [245] = 242,
  [246] = 246,
  [247] = 241,
  [248] = 224,
  [249] = 231,
  [250] = 250,
  [251] = 241,
  [252] = 252,
  [253] = 242,
  [254] = 241,
  [255] = 242,
  [256] = 225,
  [257] = 257,
  [258] = 225,
  [259] = 257,
  [260] = 260,
  [261] = 233,
  [262] = 229,
  [263] = 225,
  [264] = 242,
  [265] = 241,
  [266] = 230,
  [267] = 229,
  [268] = 229,
  [269] = 240,
  [270] = 240,
  [271] = 230,
  [272] = 272,
  [273] = 224,
  [274] = 224,
  [275] = 242,
  [276] = 224,
  [277] = 225,
  [278] = 246,
  [279] = 229,
  [280] = 224,
  [281] = 231,
  [282] = 241,
  [283] = 246,
  [284] = 284,
  [285] = 284,
  [286] = 286,
  [287] = 230,
  [288] = 288,
  [289] = 288,
  [290] = 224,
  [291] = 252,
  [292] = 292,
  [293] = 241,
  [294] = 241,
  [295] = 241,
  [296] = 284,
  [297] = 246,
  [298] = 246,
  [299] = 233,
  [300] = 246,
  [301] = 224,
  [302] = 229,
  [303] = 230,
  [304] = 230,
  [305] = 242,
  [306] = 246,
  [307] = 225,
  [308] = 229,
  [309] = 242,
  [310] = 246,
  [311] = 230,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 312,
  [326] = 322,
  [327] = 327,
  [328] = 316,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 322,
  [334] = 321,
  [335] = 329,
  [336] = 331,
  [337] = 318,
  [338] = 331,
  [339] = 339,
  [340] = 340,
  [341] = 341,
  [342] = 341,
  [343] = 316,
  [344] = 317,
  [345] = 312,
  [346] = 330,
  [347] = 347,
  [348] = 340,
  [349] = 331,
  [350] = 318,
  [351] = 313,
  [352] = 339,
  [353] = 315,
  [354] = 321,
  [355] = 339,
  [356] = 314,
  [357] = 357,
  [358] = 341,
  [359] = 320,
  [360] = 323,
  [361] = 340,
  [362] = 321,
  [363] = 339,
  [364] = 341,
  [365] = 365,
  [366] = 331,
  [367] = 324,
  [368] = 330,
  [369] = 339,
  [370] = 370,
  [371] = 341,
  [372] = 317,
  [373] = 373,
  [374] = 321,
  [375] = 375,
  [376] = 331,
  [377] = 377,
  [378] = 329,
  [379] = 315,
  [380] = 357,
  [381] = 323,
  [382] = 315,
  [383] = 373,
  [384] = 384,
  [385] = 313,
  [386] = 332,
  [387] = 357,
  [388] = 324,
  [389] = 312,
  [390] = 331,
  [391] = 313,
  [392] = 370,
  [393] = 339,
  [394] = 339,
  [395] = 323,
  [396] = 330,
  [397] = 324,
  [398] = 321,
  [399] = 323,
  [400] = 357,
  [401] = 322,
  [402] = 373,
  [403] = 377,
  [404] = 315,
  [405] = 318,
  [406] = 314,
  [407] = 317,
  [408] = 329,
  [409] = 375,
  [410] = 410,
  [411] = 321,
  [412] = 331,
  [413] = 357,
  [414] = 313,
  [415] = 332,
  [416] = 330,
  [417] = 319,
  [418] = 373,
  [419] = 314,
  [420] = 312,
  [421] = 317,
  [422] = 316,
  [423] = 340,
  [424] = 313,
  [425] = 373,
  [426] = 377,
  [427] = 314,
  [428] = 319,
  [429] = 320,
  [430] = 377,
  [431] = 324,
  [432] = 319,
  [433] = 320,
  [434] = 341,
  [435] = 315,
  [436] = 316,
  [437] = 340,
  [438] = 438,
  [439] = 318,
  [440] = 332,
  [441] = 377,
  [442] = 373,
  [443] = 320,
  [444] = 330,
  [445] = 341,
  [446] = 319,
  [447] = 447,
  [448] = 377,
  [449] = 375,
  [450] = 314,
  [451] = 330,
  [452] = 329,
  [453] = 332,
  [454] = 320,
  [455] = 321,
  [456] = 340,
  [457] = 341,
  [458] = 322,
  [459] = 319,
  [460] = 460,
  [461] = 320,
  [462] = 438,
  [463] = 312,
  [464] = 318,
  [465] = 332,
  [466] = 312,
  [467] = 317,
  [468] = 316,
  [469] = 329,
  [470] = 332,
  [471] = 315,
  [472] = 317,
  [473] = 320,
  [474] = 332,
  [475] = 329,
  [476] = 317,
  [477] = 477,
  [478] = 478,
  [479] = 357,
  [480] = 480,
  [481] = 319,
  [482] = 482,
  [483] = 324,
  [484] = 357,
  [485] = 316,
  [486] = 323,
  [487] = 340,
  [488] = 319,
  [489] = 324,
  [490] = 313,
  [491] = 318,
  [492] = 324,
  [493] = 314,
  [494] = 315,
  [495] = 323,
  [496] = 318,
  [497] = 312,
  [498] = 316,
  [499] = 329,
  [500] = 373,
  [501] = 377,
  [502] = 375,
  [503] = 314,
  [504] = 330,
  [505] = 339,
  [506] = 377,
  [507] = 373,
  [508] = 323,
  [509] = 313,
  [510] = 340,
  [511] = 511,
  [512] = 357,
  [513] = 513,
  [514] = 513,
  [515] = 515,
  [516] = 515,
  [517] = 517,
  [518] = 517,
  [519] = 519,
  [520] = 519,
  [521] = 519,
  [522] = 519,
  [523] = 517,
  [524] = 517,
  [525] = 525,
  [526] = 525,
  [527] = 527,
  [528] = 527,
  [529] = 529,
  [530] = 530,
  [531] = 529,
  [532] = 532,
  [533] = 529,
  [534] = 534,
  [535] = 529,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 537,
  [544] = 544,
  [545] = 544,
  [546] = 544,
  [547] = 547,
  [548] = 547,
  [549] = 547,
  [550] = 550,
  [551] = 544,
  [552] = 547,
  [553] = 527,
  [554] = 547,
  [555] = 544,
  [556] = 527,
  [557] = 557,
  [558] = 557,
  [559] = 557,
  [560] = 557,
  [561] = 537,
  [562] = 562,
  [563] = 562,
  [564] = 564,
  [565] = 562,
  [566] = 564,
  [567] = 564,
  [568] = 564,
  [569] = 562,
  [570] = 570,
  [571] = 571,
  [572] = 570,
  [573] = 571,
  [574] = 574,
  [575] = 570,
  [576] = 571,
  [577] = 570,
  [578] = 571,
  [579] = 579,
  [580] = 579,
  [581] = 581,
  [582] = 579,
  [583] = 583,
  [584] = 583,
  [585] = 583,
  [586] = 579,
  [587] = 583,
  [588] = 588,
  [589] = 589,
  [590] = 590,
  [591] = 591,
  [592] = 592,
  [593] = 593,
  [594] = 594,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 149,
  [599] = 149,
  [600] = 600,
  [601] = 601,
  [602] = 602,
  [603] = 603,
  [604] = 604,
  [605] = 605,
  [606] = 588,
  [607] = 607,
  [608] = 608,
  [609] = 609,
  [610] = 610,
  [611] = 184,
  [612] = 612,
  [613] = 613,
  [614] = 614,
  [615] = 615,
  [616] = 616,
  [617] = 617,
  [618] = 618,
  [619] = 619,
  [620] = 217,
  [621] = 621,
  [622] = 622,
  [623] = 623,
  [624] = 589,
  [625] = 625,
  [626] = 149,
  [627] = 627,
  [628] = 149,
  [629] = 149,
  [630] = 182,
  [631] = 205,
  [632] = 618,
  [633] = 633,
  [634] = 634,
  [635] = 635,
  [636] = 636,
  [637] = 588,
  [638] = 149,
  [639] = 639,
  [640] = 149,
  [641] = 641,
  [642] = 642,
  [643] = 643,
  [644] = 644,
  [645] = 645,
  [646] = 646,
  [647] = 647,
  [648] = 648,
  [649] = 649,
  [650] = 650,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 203,
  [656] = 656,
  [657] = 657,
  [658] = 658,
  [659] = 216,
  [660] = 660,
  [661] = 661,
  [662] = 662,
  [663] = 663,
  [664] = 664,
  [665] = 149,
  [666] = 666,
  [667] = 667,
  [668] = 668,
  [669] = 669,
  [670] = 670,
  [671] = 671,
  [672] = 149,
  [673] = 673,
  [674] = 674,
  [675] = 202,
  [676] = 676,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 680,
  [681] = 681,
  [682] = 682,
  [683] = 683,
  [684] = 588,
  [685] = 685,
  [686] = 686,
  [687] = 687,
  [688] = 212,
  [689] = 689,
  [690] = 203,
  [691] = 691,
  [692] = 692,
  [693] = 182,
  [694] = 694,
  [695] = 695,
  [696] = 696,
  [697] = 205,
  [698] = 698,
  [699] = 699,
  [700] = 700,
  [701] = 701,
  [702] = 702,
  [703] = 216,
  [704] = 704,
  [705] = 705,
  [706] = 706,
  [707] = 707,
  [708] = 708,
  [709] = 709,
  [710] = 710,
  [711] = 711,
  [712] = 149,
  [713] = 713,
  [714] = 714,
  [715] = 715,
  [716] = 716,
  [717] = 149,
  [718] = 718,
  [719] = 719,
  [720] = 720,
  [721] = 721,
  [722] = 722,
  [723] = 723,
  [724] = 724,
  [725] = 725,
  [726] = 726,
  [727] = 727,
  [728] = 728,
  [729] = 729,
  [730] = 730,
  [731] = 731,
  [732] = 732,
  [733] = 733,
  [734] = 734,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 739,
  [740] = 740,
  [741] = 741,
  [742] = 742,
  [743] = 743,
  [744] = 744,
  [745] = 745,
  [746] = 746,
  [747] = 747,
  [748] = 748,
  [749] = 749,
  [750] = 750,
  [751] = 751,
  [752] = 752,
  [753] = 753,
  [754] = 754,
  [755] = 162,
  [756] = 756,
  [757] = 757,
  [758] = 758,
  [759] = 759,
  [760] = 760,
  [761] = 761,
  [762] = 762,
  [763] = 763,
  [764] = 764,
  [765] = 765,
  [766] = 766,
  [767] = 767,
  [768] = 768,
  [769] = 769,
  [770] = 770,
  [771] = 771,
  [772] = 772,
  [773] = 773,
  [774] = 774,
  [775] = 775,
  [776] = 776,
  [777] = 777,
  [778] = 212,
  [779] = 779,
  [780] = 780,
  [781] = 781,
  [782] = 782,
  [783] = 783,
  [784] = 784,
  [785] = 785,
  [786] = 786,
  [787] = 787,
  [788] = 788,
  [789] = 789,
  [790] = 790,
  [791] = 791,
  [792] = 792,
  [793] = 793,
  [794] = 794,
  [795] = 795,
  [796] = 796,
  [797] = 797,
  [798] = 798,
  [799] = 799,
  [800] = 800,
  [801] = 801,
  [802] = 802,
  [803] = 803,
  [804] = 804,
  [805] = 162,
  [806] = 806,
  [807] = 202,
  [808] = 808,
  [809] = 809,
  [810] = 810,
  [811] = 811,
  [812] = 812,
  [813] = 813,
  [814] = 814,
  [815] = 815,
  [816] = 816,
  [817] = 817,
  [818] = 818,
  [819] = 819,
  [820] = 820,
  [821] = 821,
  [822] = 822,
  [823] = 823,
  [824] = 824,
  [825] = 825,
  [826] = 826,
  [827] = 827,
  [828] = 828,
  [829] = 829,
  [830] = 830,
  [831] = 831,
  [832] = 832,
  [833] = 833,
  [834] = 834,
  [835] = 835,
  [836] = 836,
  [837] = 837,
  [838] = 838,
  [839] = 839,
  [840] = 840,
  [841] = 841,
  [842] = 842,
  [843] = 843,
  [844] = 844,
  [845] = 845,
  [846] = 846,
  [847] = 847,
  [848] = 848,
  [849] = 849,
  [850] = 617,
  [851] = 851,
  [852] = 852,
  [853] = 853,
  [854] = 854,
  [855] = 855,
  [856] = 856,
  [857] = 857,
  [858] = 858,
  [859] = 859,
  [860] = 860,
  [861] = 861,
  [862] = 862,
  [863] = 863,
  [864] = 864,
  [865] = 865,
  [866] = 866,
  [867] = 867,
  [868] = 868,
  [869] = 869,
  [870] = 870,
  [871] = 871,
  [872] = 872,
  [873] = 873,
  [874] = 874,
  [875] = 875,
  [876] = 876,
  [877] = 877,
  [878] = 878,
  [879] = 879,
  [880] = 880,
  [881] = 881,
  [882] = 882,
  [883] = 883,
  [884] = 884,
  [885] = 885,
  [886] = 886,
  [887] = 887,
  [888] = 808,
  [889] = 889,
  [890] = 890,
  [891] = 791,
  [892] = 892,
  [893] = 893,
  [894] = 894,
  [895] = 895,
  [896] = 896,
  [897] = 897,
  [898] = 898,
  [899] = 899,
  [900] = 900,
  [901] = 901,
  [902] = 902,
  [903] = 903,
  [904] = 904,
  [905] = 905,
  [906] = 906,
  [907] = 907,
  [908] = 205,
  [909] = 909,
  [910] = 910,
  [911] = 911,
  [912] = 912,
  [913] = 913,
  [914] = 914,
  [915] = 735,
  [916] = 916,
  [917] = 917,
  [918] = 918,
  [919] = 919,
  [920] = 779,
  [921] = 921,
  [922] = 770,
  [923] = 923,
  [924] = 924,
  [925] = 925,
  [926] = 926,
  [927] = 927,
  [928] = 928,
  [929] = 929,
  [930] = 930,
  [931] = 931,
  [932] = 932,
  [933] = 933,
  [934] = 934,
  [935] = 935,
  [936] = 936,
  [937] = 937,
  [938] = 938,
  [939] = 939,
  [940] = 940,
  [941] = 941,
  [942] = 942,
  [943] = 943,
  [944] = 944,
  [945] = 945,
  [946] = 946,
  [947] = 947,
  [948] = 875,
  [949] = 949,
  [950] = 950,
  [951] = 951,
  [952] = 952,
  [953] = 953,
  [954] = 954,
  [955] = 874,
  [956] = 956,
  [957] = 957,
  [958] = 958,
  [959] = 959,
  [960] = 960,
  [961] = 961,
  [962] = 962,
  [963] = 963,
  [964] = 964,
  [965] = 965,
  [966] = 966,
  [967] = 946,
  [968] = 968,
  [969] = 969,
  [970] = 970,
  [971] = 182,
  [972] = 972,
  [973] = 973,
  [974] = 974,
  [975] = 975,
  [976] = 976,
  [977] = 977,
  [978] = 978,
  [979] = 979,
  [980] = 980,
  [981] = 981,
  [982] = 982,
  [983] = 983,
  [984] = 984,
  [985] = 985,
  [986] = 986,
  [987] = 987,
  [988] = 988,
  [989] = 989,
  [990] = 990,
  [991] = 991,
  [992] = 992,
  [993] = 993,
  [994] = 994,
  [995] = 995,
  [996] = 996,
  [997] = 997,
  [998] = 998,
  [999] = 999,
  [1000] = 1000,
  [1001] = 1001,
  [1002] = 1002,
  [1003] = 1003,
  [1004] = 1004,
  [1005] = 184,
  [1006] = 1006,
  [1007] = 1007,
  [1008] = 1008,
  [1009] = 1009,
  [1010] = 1010,
  [1011] = 1011,
  [1012] = 1012,
  [1013] = 1013,
  [1014] = 1014,
  [1015] = 1015,
  [1016] = 1016,
  [1017] = 1017,
  [1018] = 216,
  [1019] = 1019,
  [1020] = 1020,
  [1021] = 1021,
  [1022] = 1022,
  [1023] = 1023,
  [1024] = 202,
  [1025] = 1025,
  [1026] = 1026,
  [1027] = 1027,
  [1028] = 1028,
  [1029] = 1029,
  [1030] = 1030,
  [1031] = 1031,
  [1032] = 1032,
  [1033] = 1033,
  [1034] = 1034,
  [1035] = 1035,
  [1036] = 1036,
  [1037] = 1037,
  [1038] = 1038,
  [1039] = 1039,
  [1040] = 1040,
  [1041] = 1041,
  [1042] = 1042,
  [1043] = 1043,
  [1044] = 1044,
  [1045] = 1045,
  [1046] = 1046,
  [1047] = 1047,
  [1048] = 203,
  [1049] = 1049,
  [1050] = 1050,
  [1051] = 1051,
  [1052] = 1052,
  [1053] = 1053,
  [1054] = 1054,
  [1055] = 1055,
  [1056] = 1056,
  [1057] = 1057,
  [1058] = 1058,
  [1059] = 217,
  [1060] = 1060,
  [1061] = 1061,
  [1062] = 1062,
  [1063] = 1063,
  [1064] = 1064,
  [1065] = 212,
  [1066] = 1066,
  [1067] = 1067,
  [1068] = 1068,
  [1069] = 763,
  [1070] = 859,
  [1071] = 738,
  [1072] = 840,
  [1073] = 726,
  [1074] = 724,
  [1075] = 761,
  [1076] = 852,
  [1077] = 710,
  [1078] = 765,
  [1079] = 800,
  [1080] = 781,
  [1081] = 739,
  [1082] = 870,
  [1083] = 742,
  [1084] = 746,
  [1085] = 848,
  [1086] = 801,
  [1087] = 748,
  [1088] = 768,
  [1089] = 757,
  [1090] = 762,
  [1091] = 764,
  [1092] = 769,
  [1093] = 760,
  [1094] = 802,
  [1095] = 1095,
  [1096] = 1096,
  [1097] = 1096,
  [1098] = 1098,
  [1099] = 946,
  [1100] = 1096,
  [1101] = 1101,
  [1102] = 542,
  [1103] = 1096,
  [1104] = 1104,
  [1105] = 1105,
  [1106] = 1096,
  [1107] = 1107,
  [1108] = 1108,
  [1109] = 1109,
  [1110] = 1110,
  [1111] = 541,
  [1112] = 1112,
  [1113] = 1113,
  [1114] = 1096,
  [1115] = 968,
  [1116] = 1116,
  [1117] = 1116,
  [1118] = 1118,
  [1119] = 1118,
  [1120] = 1116,
  [1121] = 1118,
  [1122] = 1118,
  [1123] = 1118,
  [1124] = 1116,
  [1125] = 1116,
  [1126] = 1118,
  [1127] = 1116,
  [1128] = 1128,
  [1129] = 1129,
  [1130] = 1129,
  [1131] = 1129,
  [1132] = 1132,
  [1133] = 1129,
  [1134] = 1134,
  [1135] = 1135,
  [1136] = 1136,
  [1137] = 1137,
  [1138] = 1138,
  [1139] = 1138,
  [1140] = 1140,
  [1141] = 1141,
  [1142] = 1141,
  [1143] = 1141,
  [1144] = 1144,
  [1145] = 921,
  [1146] = 1141,
  [1147] = 949,
  [1148] = 1140,
  [1149] = 906,
  [1150] = 1144,
  [1151] = 1151,
  [1152] = 1140,
  [1153] = 1135,
  [1154] = 1135,
  [1155] = 1140,
  [1156] = 1140,
  [1157] = 1144,
  [1158] = 1158,
  [1159] = 1144,
  [1160] = 1160,
  [1161] = 1161,
  [1162] = 1134,
  [1163] = 1160,
  [1164] = 1160,
  [1165] = 1165,
  [1166] = 1166,
  [1167] = 1165,
  [1168] = 1168,
  [1169] = 1160,
  [1170] = 1168,
  [1171] = 1166,
  [1172] = 1172,
  [1173] = 1160,
  [1174] = 1166,
  [1175] = 1172,
  [1176] = 1172,
  [1177] = 1172,
  [1178] = 1161,
  [1179] = 1161,
  [1180] = 1180,
  [1181] = 1166,
  [1182] = 1172,
  [1183] = 1161,
  [1184] = 1161,
  [1185] = 1160,
  [1186] = 1134,
  [1187] = 1161,
  [1188] = 1168,
  [1189] = 1168,
  [1190] = 1166,
  [1191] = 1166,
  [1192] = 1168,
  [1193] = 1166,
  [1194] = 1168,
  [1195] = 1134,
  [1196] = 1160,
  [1197] = 1161,
  [1198] = 1168,
  [1199] = 1160,
  [1200] = 1166,
  [1201] = 1172,
  [1202] = 1166,
  [1203] = 1160,
  [1204] = 1204,
  [1205] = 1205,
  [1206] = 1206,
  [1207] = 1207,
  [1208] = 1205,
  [1209] = 1209,
  [1210] = 1210,
  [1211] = 1211,
  [1212] = 1212,
  [1213] = 1209,
  [1214] = 1214,
  [1215] = 1215,
  [1216] = 1206,
  [1217] = 1209,
  [1218] = 1151,
  [1219] = 1219,
  [1220] = 1220,
  [1221] = 1221,
  [1222] = 1222,
  [1223] = 1209,
  [1224] = 1214,
  [1225] = 1205,
  [1226] = 1210,
  [1227] = 1219,
  [1228] = 1207,
  [1229] = 1219,
  [1230] = 1204,
  [1231] = 1215,
  [1232] = 1209,
  [1233] = 1233,
  [1234] = 1234,
  [1235] = 1235,
  [1236] = 1209,
  [1237] = 1233,
  [1238] = 1238,
  [1239] = 1239,
  [1240] = 1240,
  [1241] = 1220,
  [1242] = 1242,
  [1243] = 1243,
  [1244] = 1244,
  [1245] = 1245,
  [1246] = 1206,
  [1247] = 1220,
  [1248] = 1219,
  [1249] = 1249,
  [1250] = 1250,
  [1251] = 1251,
  [1252] = 1220,
  [1253] = 1250,
  [1254] = 1242,
  [1255] = 1255,
  [1256] = 1255,
  [1257] = 1206,
  [1258] = 1239,
  [1259] = 1242,
  [1260] = 1260,
  [1261] = 1260,
  [1262] = 1209,
  [1263] = 1235,
  [1264] = 1250,
  [1265] = 1239,
  [1266] = 1214,
  [1267] = 1235,
  [1268] = 517,
  [1269] = 1239,
  [1270] = 1235,
  [1271] = 1260,
  [1272] = 1250,
  [1273] = 1205,
  [1274] = 1206,
  [1275] = 1214,
  [1276] = 1276,
  [1277] = 1205,
  [1278] = 1207,
  [1279] = 1211,
  [1280] = 1207,
  [1281] = 1204,
  [1282] = 1215,
  [1283] = 1233,
  [1284] = 1250,
  [1285] = 1285,
  [1286] = 1219,
  [1287] = 1255,
  [1288] = 1220,
  [1289] = 1209,
  [1290] = 1206,
  [1291] = 1291,
  [1292] = 1214,
  [1293] = 1293,
  [1294] = 1205,
  [1295] = 1207,
  [1296] = 1204,
  [1297] = 1210,
  [1298] = 1249,
  [1299] = 1250,
  [1300] = 1219,
  [1301] = 1214,
  [1302] = 1207,
  [1303] = 1215,
  [1304] = 1233,
  [1305] = 1211,
  [1306] = 1211,
  [1307] = 1210,
  [1308] = 1255,
  [1309] = 1219,
  [1310] = 1242,
  [1311] = 1211,
  [1312] = 1219,
  [1313] = 1239,
  [1314] = 1210,
  [1315] = 1285,
  [1316] = 1210,
  [1317] = 1204,
  [1318] = 1215,
  [1319] = 1204,
  [1320] = 517,
  [1321] = 1235,
  [1322] = 1134,
  [1323] = 1250,
  [1324] = 1250,
  [1325] = 1245,
  [1326] = 1211,
  [1327] = 1211,
  [1328] = 1210,
  [1329] = 1233,
  [1330] = 1204,
  [1331] = 1233,
  [1332] = 1211,
  [1333] = 1220,
  [1334] = 1235,
  [1335] = 1251,
  [1336] = 1206,
  [1337] = 1214,
  [1338] = 1235,
  [1339] = 1239,
  [1340] = 1239,
  [1341] = 1205,
  [1342] = 1204,
  [1343] = 1207,
  [1344] = 1344,
  [1345] = 1233,
  [1346] = 1206,
  [1347] = 1215,
  [1348] = 1233,
  [1349] = 1242,
  [1350] = 1220,
  [1351] = 1239,
  [1352] = 1215,
  [1353] = 517,
  [1354] = 1204,
  [1355] = 1215,
  [1356] = 1255,
  [1357] = 1207,
  [1358] = 1249,
  [1359] = 1242,
  [1360] = 1255,
  [1361] = 1251,
  [1362] = 1211,
  [1363] = 517,
  [1364] = 1220,
  [1365] = 1235,
  [1366] = 1205,
  [1367] = 1242,
  [1368] = 1276,
  [1369] = 1369,
  [1370] = 1370,
  [1371] = 1371,
  [1372] = 1214,
  [1373] = 1250,
  [1374] = 1255,
  [1375] = 517,
  [1376] = 1376,
  [1377] = 1377,
  [1378] = 1209,
  [1379] = 1242,
  [1380] = 1220,
  [1381] = 1206,
  [1382] = 1382,
  [1383] = 1383,
  [1384] = 1384,
  [1385] = 1369,
  [1386] = 1255,
  [1387] = 1255,
  [1388] = 1214,
  [1389] = 1219,
  [1390] = 1242,
  [1391] = 1205,
  [1392] = 1207,
  [1393] = 1233,
  [1394] = 1215,
  [1395] = 1235,
  [1396] = 1239,
  [1397] = 1151,
  [1398] = 1398,
  [1399] = 517,
  [1400] = 517,
  [1401] = 1158,
  [1402] = 1402,
  [1403] = 1403,
  [1404] = 1404,
  [1405] = 1403,
  [1406] = 1406,
  [1407] = 1404,
  [1408] = 1403,
  [1409] = 1151,
  [1410] = 1403,
  [1411] = 1403,
  [1412] = 1412,
  [1413] = 517,
  [1414] = 1403,
  [1415] = 1403,
  [1416] = 1406,
  [1417] = 1403,
  [1418] = 517,
  [1419] = 517,
  [1420] = 1420,
  [1421] = 517,
  [1422] = 1422,
  [1423] = 1420,
  [1424] = 1422,
  [1425] = 1422,
  [1426] = 1420,
  [1427] = 1344,
  [1428] = 1422,
  [1429] = 1420,
  [1430] = 536,
  [1431] = 1431,
  [1432] = 532,
  [1433] = 1431,
  [1434] = 1431,
  [1435] = 538,
  [1436] = 530,
  [1437] = 540,
  [1438] = 534,
  [1439] = 1431,
  [1440] = 539,
  [1441] = 541,
  [1442] = 537,
  [1443] = 542,
  [1444] = 1444,
  [1445] = 1445,
  [1446] = 1444,
  [1447] = 1447,
  [1448] = 1448,
  [1449] = 1449,
  [1450] = 1450,
  [1451] = 1451,
  [1452] = 1452,
  [1453] = 1453,
  [1454] = 1454,
  [1455] = 1445,
  [1456] = 1456,
  [1457] = 1445,
  [1458] = 1453,
  [1459] = 1450,
  [1460] = 537,
  [1461] = 1461,
  [1462] = 536,
  [1463] = 532,
  [1464] = 534,
  [1465] = 1445,
  [1466] = 538,
  [1467] = 530,
  [1468] = 1468,
  [1469] = 1469,
  [1470] = 1470,
  [1471] = 527,
  [1472] = 542,
  [1473] = 1473,
  [1474] = 527,
  [1475] = 1447,
  [1476] = 1448,
  [1477] = 539,
  [1478] = 1478,
  [1479] = 541,
  [1480] = 540,
  [1481] = 1481,
  [1482] = 527,
  [1483] = 527,
  [1484] = 1484,
  [1485] = 527,
  [1486] = 1473,
  [1487] = 1484,
  [1488] = 527,
  [1489] = 885,
  [1490] = 1451,
  [1491] = 1447,
  [1492] = 527,
  [1493] = 940,
  [1494] = 918,
  [1495] = 537,
  [1496] = 1452,
  [1497] = 527,
  [1498] = 1498,
  [1499] = 1499,
  [1500] = 537,
  [1501] = 1470,
  [1502] = 527,
  [1503] = 1452,
  [1504] = 1504,
  [1505] = 182,
  [1506] = 205,
  [1507] = 537,
  [1508] = 537,
  [1509] = 1447,
  [1510] = 1510,
  [1511] = 1478,
  [1512] = 1002,
  [1513] = 1066,
  [1514] = 1452,
  [1515] = 527,
  [1516] = 988,
  [1517] = 1062,
  [1518] = 203,
  [1519] = 216,
  [1520] = 527,
  [1521] = 537,
  [1522] = 1499,
  [1523] = 1523,
  [1524] = 1524,
  [1525] = 1525,
  [1526] = 1526,
  [1527] = 1527,
  [1528] = 1528,
  [1529] = 1528,
  [1530] = 1528,
  [1531] = 1528,
  [1532] = 950,
  [1533] = 1528,
  [1534] = 889,
  [1535] = 1528,
  [1536] = 1528,
  [1537] = 1537,
  [1538] = 1538,
  [1539] = 1539,
  [1540] = 986,
  [1541] = 1541,
  [1542] = 1542,
  [1543] = 1012,
  [1544] = 1544,
  [1545] = 885,
  [1546] = 1546,
  [1547] = 1547,
  [1548] = 1548,
  [1549] = 1008,
  [1550] = 1550,
  [1551] = 1551,
  [1552] = 1552,
  [1553] = 1553,
  [1554] = 1554,
  [1555] = 1555,
  [1556] = 1556,
  [1557] = 1557,
  [1558] = 1558,
  [1559] = 1559,
  [1560] = 1004,
  [1561] = 1561,
  [1562] = 1562,
  [1563] = 1563,
  [1564] = 1564,
  [1565] = 1055,
  [1566] = 985,
  [1567] = 940,
  [1568] = 984,
  [1569] = 987,
  [1570] = 1570,
  [1571] = 1571,
  [1572] = 918,
  [1573] = 1573,
  [1574] = 1574,
  [1575] = 1575,
  [1576] = 1576,
  [1577] = 1577,
  [1578] = 1523,
  [1579] = 1579,
  [1580] = 1579,
  [1581] = 1579,
  [1582] = 1582,
  [1583] = 1579,
  [1584] = 1577,
  [1585] = 1579,
  [1586] = 1582,
  [1587] = 1577,
  [1588] = 1577,
  [1589] = 1582,
  [1590] = 1577,
  [1591] = 1577,
  [1592] = 1579,
  [1593] = 1579,
  [1594] = 1582,
  [1595] = 1577,
  [1596] = 1596,
  [1597] = 1582,
  [1598] = 1582,
  [1599] = 1582,
  [1600] = 700,
  [1601] = 1601,
  [1602] = 1601,
  [1603] = 1601,
  [1604] = 1601,
  [1605] = 1601,
  [1606] = 1601,
  [1607] = 687,
  [1608] = 1601,
  [1609] = 1601,
  [1610] = 1601,
  [1611] = 1526,
  [1612] = 789,
  [1613] = 162,
  [1614] = 776,
  [1615] = 1615,
  [1616] = 750,
  [1617] = 728,
  [1618] = 1615,
  [1619] = 747,
  [1620] = 875,
  [1621] = 1621,
  [1622] = 794,
  [1623] = 788,
  [1624] = 785,
  [1625] = 1615,
  [1626] = 808,
  [1627] = 1615,
  [1628] = 786,
  [1629] = 774,
  [1630] = 815,
  [1631] = 1615,
  [1632] = 1615,
  [1633] = 1615,
  [1634] = 1634,
  [1635] = 843,
  [1636] = 944,
  [1637] = 892,
  [1638] = 882,
  [1639] = 904,
  [1640] = 907,
  [1641] = 912,
  [1642] = 914,
  [1643] = 916,
  [1644] = 917,
  [1645] = 919,
  [1646] = 779,
  [1647] = 925,
  [1648] = 926,
  [1649] = 182,
  [1650] = 936,
  [1651] = 943,
  [1652] = 927,
  [1653] = 974,
  [1654] = 931,
  [1655] = 946,
  [1656] = 953,
  [1657] = 878,
  [1658] = 965,
  [1659] = 973,
  [1660] = 954,
  [1661] = 934,
  [1662] = 932,
  [1663] = 929,
  [1664] = 928,
  [1665] = 770,
  [1666] = 980,
  [1667] = 937,
  [1668] = 898,
  [1669] = 906,
  [1670] = 887,
  [1671] = 894,
  [1672] = 880,
  [1673] = 205,
  [1674] = 935,
  [1675] = 942,
  [1676] = 947,
  [1677] = 958,
  [1678] = 959,
  [1679] = 961,
  [1680] = 962,
  [1681] = 966,
  [1682] = 975,
  [1683] = 910,
  [1684] = 875,
  [1685] = 909,
  [1686] = 905,
  [1687] = 902,
  [1688] = 883,
  [1689] = 893,
  [1690] = 735,
  [1691] = 884,
  [1692] = 945,
  [1693] = 938,
  [1694] = 930,
  [1695] = 900,
  [1696] = 951,
  [1697] = 911,
  [1698] = 977,
  [1699] = 899,
  [1700] = 941,
  [1701] = 890,
  [1702] = 940,
  [1703] = 918,
  [1704] = 949,
  [1705] = 939,
  [1706] = 976,
  [1707] = 972,
  [1708] = 933,
  [1709] = 924,
  [1710] = 923,
  [1711] = 913,
  [1712] = 903,
  [1713] = 901,
  [1714] = 874,
  [1715] = 897,
  [1716] = 896,
  [1717] = 895,
  [1718] = 1718,
  [1719] = 886,
  [1720] = 791,
  [1721] = 889,
  [1722] = 808,
  [1723] = 957,
  [1724] = 885,
  [1725] = 921,
  [1726] = 950,
  [1727] = 960,
  [1728] = 978,
  [1729] = 963,
  [1730] = 881,
  [1731] = 979,
  [1732] = 879,
  [1733] = 970,
  [1734] = 969,
  [1735] = 964,
  [1736] = 956,
  [1737] = 952,
  [1738] = 1738,
  [1739] = 1023,
  [1740] = 700,
  [1741] = 1741,
  [1742] = 1052,
  [1743] = 998,
  [1744] = 1058,
  [1745] = 1745,
  [1746] = 687,
  [1747] = 1745,
  [1748] = 1741,
  [1749] = 1067,
  [1750] = 983,
  [1751] = 1010,
  [1752] = 1016,
  [1753] = 1034,
  [1754] = 1035,
  [1755] = 1049,
  [1756] = 1756,
  [1757] = 1060,
  [1758] = 1044,
  [1759] = 203,
  [1760] = 1741,
  [1761] = 1033,
  [1762] = 1029,
  [1763] = 202,
  [1764] = 1745,
  [1765] = 1022,
  [1766] = 216,
  [1767] = 1021,
  [1768] = 1745,
  [1769] = 1745,
  [1770] = 1015,
  [1771] = 1014,
  [1772] = 1011,
  [1773] = 1009,
  [1774] = 1006,
  [1775] = 996,
  [1776] = 995,
  [1777] = 994,
  [1778] = 1056,
  [1779] = 1051,
  [1780] = 1050,
  [1781] = 1037,
  [1782] = 1036,
  [1783] = 1027,
  [1784] = 1007,
  [1785] = 1004,
  [1786] = 1055,
  [1787] = 1787,
  [1788] = 1787,
  [1789] = 1741,
  [1790] = 1741,
  [1791] = 1745,
  [1792] = 1047,
  [1793] = 1053,
  [1794] = 1057,
  [1795] = 1064,
  [1796] = 1066,
  [1797] = 1062,
  [1798] = 984,
  [1799] = 985,
  [1800] = 986,
  [1801] = 987,
  [1802] = 212,
  [1803] = 1803,
  [1804] = 1068,
  [1805] = 1046,
  [1806] = 1063,
  [1807] = 1061,
  [1808] = 982,
  [1809] = 1054,
  [1810] = 1045,
  [1811] = 1043,
  [1812] = 1042,
  [1813] = 1041,
  [1814] = 1040,
  [1815] = 1039,
  [1816] = 1038,
  [1817] = 1031,
  [1818] = 1030,
  [1819] = 1028,
  [1820] = 1026,
  [1821] = 1025,
  [1822] = 1020,
  [1823] = 1017,
  [1824] = 1741,
  [1825] = 1032,
  [1826] = 1019,
  [1827] = 1013,
  [1828] = 988,
  [1829] = 1002,
  [1830] = 184,
  [1831] = 1008,
  [1832] = 1012,
  [1833] = 989,
  [1834] = 217,
  [1835] = 990,
  [1836] = 991,
  [1837] = 992,
  [1838] = 993,
  [1839] = 997,
  [1840] = 999,
  [1841] = 1000,
  [1842] = 1001,
  [1843] = 981,
  [1844] = 1003,
  [1845] = 1845,
  [1846] = 1846,
  [1847] = 1845,
  [1848] = 747,
  [1849] = 945,
  [1850] = 776,
  [1851] = 789,
  [1852] = 978,
  [1853] = 750,
  [1854] = 1854,
  [1855] = 728,
  [1856] = 794,
  [1857] = 1845,
  [1858] = 788,
  [1859] = 785,
  [1860] = 1845,
  [1861] = 1861,
  [1862] = 786,
  [1863] = 774,
  [1864] = 217,
  [1865] = 941,
  [1866] = 202,
  [1867] = 941,
  [1868] = 978,
  [1869] = 205,
  [1870] = 1870,
  [1871] = 184,
  [1872] = 945,
  [1873] = 182,
  [1874] = 203,
  [1875] = 212,
  [1876] = 216,
  [1877] = 1877,
  [1878] = 815,
  [1879] = 843,
  [1880] = 1880,
  [1881] = 724,
  [1882] = 769,
  [1883] = 934,
  [1884] = 954,
  [1885] = 973,
  [1886] = 965,
  [1887] = 969,
  [1888] = 878,
  [1889] = 802,
  [1890] = 953,
  [1891] = 1891,
  [1892] = 1892,
  [1893] = 970,
  [1894] = 931,
  [1895] = 1895,
  [1896] = 927,
  [1897] = 879,
  [1898] = 979,
  [1899] = 936,
  [1900] = 926,
  [1901] = 881,
  [1902] = 1902,
  [1903] = 943,
  [1904] = 951,
  [1905] = 779,
  [1906] = 1880,
  [1907] = 919,
  [1908] = 917,
  [1909] = 916,
  [1910] = 1910,
  [1911] = 880,
  [1912] = 912,
  [1913] = 1913,
  [1914] = 1914,
  [1915] = 907,
  [1916] = 1916,
  [1917] = 1902,
  [1918] = 1846,
  [1919] = 960,
  [1920] = 904,
  [1921] = 894,
  [1922] = 1922,
  [1923] = 887,
  [1924] = 802,
  [1925] = 956,
  [1926] = 902,
  [1927] = 765,
  [1928] = 761,
  [1929] = 900,
  [1930] = 898,
  [1931] = 859,
  [1932] = 952,
  [1933] = 890,
  [1934] = 886,
  [1935] = 859,
  [1936] = 840,
  [1937] = 963,
  [1938] = 840,
  [1939] = 768,
  [1940] = 1880,
  [1941] = 1846,
  [1942] = 870,
  [1943] = 1943,
  [1944] = 781,
  [1945] = 957,
  [1946] = 848,
  [1947] = 1910,
  [1948] = 768,
  [1949] = 1916,
  [1950] = 945,
  [1951] = 968,
  [1952] = 1952,
  [1953] = 1916,
  [1954] = 918,
  [1955] = 765,
  [1956] = 761,
  [1957] = 1910,
  [1958] = 874,
  [1959] = 946,
  [1960] = 889,
  [1961] = 899,
  [1962] = 882,
  [1963] = 942,
  [1964] = 911,
  [1965] = 925,
  [1966] = 726,
  [1967] = 738,
  [1968] = 739,
  [1969] = 930,
  [1970] = 870,
  [1971] = 848,
  [1972] = 938,
  [1973] = 781,
  [1974] = 162,
  [1975] = 914,
  [1976] = 742,
  [1977] = 724,
  [1978] = 726,
  [1979] = 802,
  [1980] = 738,
  [1981] = 739,
  [1982] = 742,
  [1983] = 1983,
  [1984] = 935,
  [1985] = 746,
  [1986] = 748,
  [1987] = 757,
  [1988] = 760,
  [1989] = 763,
  [1990] = 941,
  [1991] = 949,
  [1992] = 885,
  [1993] = 800,
  [1994] = 801,
  [1995] = 896,
  [1996] = 1902,
  [1997] = 895,
  [1998] = 897,
  [1999] = 940,
  [2000] = 906,
  [2001] = 1877,
  [2002] = 2002,
  [2003] = 746,
  [2004] = 859,
  [2005] = 762,
  [2006] = 1916,
  [2007] = 764,
  [2008] = 840,
  [2009] = 977,
  [2010] = 972,
  [2011] = 921,
  [2012] = 791,
  [2013] = 748,
  [2014] = 769,
  [2015] = 768,
  [2016] = 1910,
  [2017] = 974,
  [2018] = 870,
  [2019] = 848,
  [2020] = 901,
  [2021] = 1902,
  [2022] = 903,
  [2023] = 1902,
  [2024] = 913,
  [2025] = 964,
  [2026] = 765,
  [2027] = 932,
  [2028] = 929,
  [2029] = 980,
  [2030] = 761,
  [2031] = 757,
  [2032] = 724,
  [2033] = 726,
  [2034] = 738,
  [2035] = 739,
  [2036] = 2002,
  [2037] = 1877,
  [2038] = 742,
  [2039] = 746,
  [2040] = 748,
  [2041] = 2041,
  [2042] = 757,
  [2043] = 760,
  [2044] = 763,
  [2045] = 923,
  [2046] = 924,
  [2047] = 937,
  [2048] = 800,
  [2049] = 884,
  [2050] = 735,
  [2051] = 944,
  [2052] = 801,
  [2053] = 933,
  [2054] = 760,
  [2055] = 976,
  [2056] = 909,
  [2057] = 763,
  [2058] = 769,
  [2059] = 905,
  [2060] = 939,
  [2061] = 947,
  [2062] = 2062,
  [2063] = 950,
  [2064] = 958,
  [2065] = 801,
  [2066] = 800,
  [2067] = 762,
  [2068] = 892,
  [2069] = 928,
  [2070] = 764,
  [2071] = 959,
  [2072] = 1880,
  [2073] = 961,
  [2074] = 883,
  [2075] = 770,
  [2076] = 962,
  [2077] = 978,
  [2078] = 781,
  [2079] = 1846,
  [2080] = 966,
  [2081] = 2081,
  [2082] = 2082,
  [2083] = 975,
  [2084] = 762,
  [2085] = 910,
  [2086] = 764,
  [2087] = 893,
  [2088] = 162,
  [2089] = 2089,
  [2090] = 757,
  [2091] = 1877,
  [2092] = 763,
  [2093] = 2093,
  [2094] = 2094,
  [2095] = 2095,
  [2096] = 2094,
  [2097] = 768,
  [2098] = 1058,
  [2099] = 1055,
  [2100] = 760,
  [2101] = 2101,
  [2102] = 946,
  [2103] = 800,
  [2104] = 2104,
  [2105] = 2094,
  [2106] = 763,
  [2107] = 760,
  [2108] = 1012,
  [2109] = 1008,
  [2110] = 998,
  [2111] = 2111,
  [2112] = 1880,
  [2113] = 2113,
  [2114] = 802,
  [2115] = 1846,
  [2116] = 1003,
  [2117] = 2094,
  [2118] = 769,
  [2119] = 2094,
  [2120] = 1002,
  [2121] = 840,
  [2122] = 859,
  [2123] = 2123,
  [2124] = 987,
  [2125] = 988,
  [2126] = 859,
  [2127] = 986,
  [2128] = 840,
  [2129] = 985,
  [2130] = 768,
  [2131] = 1007,
  [2132] = 2132,
  [2133] = 1027,
  [2134] = 1036,
  [2135] = 1943,
  [2136] = 2113,
  [2137] = 984,
  [2138] = 1037,
  [2139] = 2139,
  [2140] = 761,
  [2141] = 1870,
  [2142] = 2104,
  [2143] = 2082,
  [2144] = 1943,
  [2145] = 764,
  [2146] = 2146,
  [2147] = 178,
  [2148] = 170,
  [2149] = 223,
  [2150] = 2150,
  [2151] = 1062,
  [2152] = 1050,
  [2153] = 1051,
  [2154] = 1056,
  [2155] = 1066,
  [2156] = 1060,
  [2157] = 171,
  [2158] = 2158,
  [2159] = 172,
  [2160] = 2160,
  [2161] = 173,
  [2162] = 177,
  [2163] = 870,
  [2164] = 757,
  [2165] = 180,
  [2166] = 181,
  [2167] = 946,
  [2168] = 1047,
  [2169] = 848,
  [2170] = 200,
  [2171] = 1053,
  [2172] = 765,
  [2173] = 761,
  [2174] = 724,
  [2175] = 726,
  [2176] = 201,
  [2177] = 209,
  [2178] = 1057,
  [2179] = 2179,
  [2180] = 1064,
  [2181] = 2181,
  [2182] = 1032,
  [2183] = 1891,
  [2184] = 1067,
  [2185] = 2139,
  [2186] = 2186,
  [2187] = 983,
  [2188] = 2188,
  [2189] = 738,
  [2190] = 196,
  [2191] = 739,
  [2192] = 195,
  [2193] = 194,
  [2194] = 1004,
  [2195] = 187,
  [2196] = 801,
  [2197] = 176,
  [2198] = 994,
  [2199] = 742,
  [2200] = 746,
  [2201] = 748,
  [2202] = 1031,
  [2203] = 168,
  [2204] = 762,
  [2205] = 198,
  [2206] = 800,
  [2207] = 801,
  [2208] = 995,
  [2209] = 996,
  [2210] = 175,
  [2211] = 2211,
  [2212] = 941,
  [2213] = 769,
  [2214] = 2214,
  [2215] = 2113,
  [2216] = 764,
  [2217] = 762,
  [2218] = 781,
  [2219] = 1068,
  [2220] = 1846,
  [2221] = 1880,
  [2222] = 222,
  [2223] = 1046,
  [2224] = 1006,
  [2225] = 1063,
  [2226] = 218,
  [2227] = 1010,
  [2228] = 1009,
  [2229] = 968,
  [2230] = 1016,
  [2231] = 1034,
  [2232] = 2232,
  [2233] = 1035,
  [2234] = 2234,
  [2235] = 981,
  [2236] = 2236,
  [2237] = 1001,
  [2238] = 2081,
  [2239] = 2239,
  [2240] = 169,
  [2241] = 174,
  [2242] = 1000,
  [2243] = 2094,
  [2244] = 204,
  [2245] = 214,
  [2246] = 215,
  [2247] = 219,
  [2248] = 1011,
  [2249] = 1014,
  [2250] = 2250,
  [2251] = 183,
  [2252] = 724,
  [2253] = 2081,
  [2254] = 2254,
  [2255] = 1049,
  [2256] = 1015,
  [2257] = 2132,
  [2258] = 1021,
  [2259] = 1022,
  [2260] = 997,
  [2261] = 1023,
  [2262] = 2094,
  [2263] = 2094,
  [2264] = 993,
  [2265] = 1029,
  [2266] = 1061,
  [2267] = 992,
  [2268] = 1019,
  [2269] = 982,
  [2270] = 1033,
  [2271] = 999,
  [2272] = 991,
  [2273] = 990,
  [2274] = 1013,
  [2275] = 1054,
  [2276] = 989,
  [2277] = 726,
  [2278] = 1044,
  [2279] = 1045,
  [2280] = 765,
  [2281] = 1043,
  [2282] = 2132,
  [2283] = 1052,
  [2284] = 2284,
  [2285] = 738,
  [2286] = 2132,
  [2287] = 197,
  [2288] = 1891,
  [2289] = 2041,
  [2290] = 1042,
  [2291] = 1041,
  [2292] = 207,
  [2293] = 1040,
  [2294] = 739,
  [2295] = 945,
  [2296] = 978,
  [2297] = 746,
  [2298] = 848,
  [2299] = 742,
  [2300] = 1030,
  [2301] = 1039,
  [2302] = 1038,
  [2303] = 1028,
  [2304] = 1020,
  [2305] = 781,
  [2306] = 2094,
  [2307] = 748,
  [2308] = 1026,
  [2309] = 870,
  [2310] = 802,
  [2311] = 1025,
  [2312] = 968,
  [2313] = 193,
  [2314] = 1017,
  [2315] = 2315,
  [2316] = 2316,
  [2317] = 946,
  [2318] = 2318,
  [2319] = 1943,
  [2320] = 2320,
  [2321] = 2321,
  [2322] = 2320,
  [2323] = 2323,
  [2324] = 2321,
  [2325] = 2041,
  [2326] = 2320,
  [2327] = 1854,
  [2328] = 1913,
  [2329] = 2321,
  [2330] = 941,
  [2331] = 2331,
  [2332] = 2332,
  [2333] = 2333,
  [2334] = 1913,
  [2335] = 1870,
  [2336] = 2336,
  [2337] = 1891,
  [2338] = 2338,
  [2339] = 941,
  [2340] = 2340,
  [2341] = 2341,
  [2342] = 2342,
  [2343] = 2343,
  [2344] = 2344,
  [2345] = 946,
  [2346] = 2321,
  [2347] = 2321,
  [2348] = 2348,
  [2349] = 2344,
  [2350] = 2341,
  [2351] = 2321,
  [2352] = 2342,
  [2353] = 968,
  [2354] = 2354,
  [2355] = 2355,
  [2356] = 2082,
  [2357] = 2357,
  [2358] = 2315,
  [2359] = 1880,
  [2360] = 2250,
  [2361] = 1846,
  [2362] = 2321,
  [2363] = 2341,
  [2364] = 2364,
  [2365] = 2321,
  [2366] = 2366,
  [2367] = 2367,
  [2368] = 2368,
  [2369] = 2369,
  [2370] = 2082,
  [2371] = 2321,
  [2372] = 2372,
  [2373] = 2373,
  [2374] = 802,
  [2375] = 2372,
  [2376] = 742,
  [2377] = 739,
  [2378] = 764,
  [2379] = 762,
  [2380] = 2380,
  [2381] = 2381,
  [2382] = 761,
  [2383] = 2383,
  [2384] = 2384,
  [2385] = 2383,
  [2386] = 765,
  [2387] = 2387,
  [2388] = 1756,
  [2389] = 2389,
  [2390] = 781,
  [2391] = 2391,
  [2392] = 848,
  [2393] = 2393,
  [2394] = 870,
  [2395] = 2391,
  [2396] = 2396,
  [2397] = 2383,
  [2398] = 768,
  [2399] = 840,
  [2400] = 2400,
  [2401] = 1913,
  [2402] = 859,
  [2403] = 2403,
  [2404] = 2404,
  [2405] = 746,
  [2406] = 1943,
  [2407] = 2372,
  [2408] = 2408,
  [2409] = 2409,
  [2410] = 2391,
  [2411] = 748,
  [2412] = 2383,
  [2413] = 2413,
  [2414] = 2408,
  [2415] = 941,
  [2416] = 2416,
  [2417] = 978,
  [2418] = 2384,
  [2419] = 1891,
  [2420] = 2420,
  [2421] = 2421,
  [2422] = 2422,
  [2423] = 2423,
  [2424] = 738,
  [2425] = 2425,
  [2426] = 2391,
  [2427] = 2427,
  [2428] = 2428,
  [2429] = 724,
  [2430] = 2383,
  [2431] = 2372,
  [2432] = 2432,
  [2433] = 2433,
  [2434] = 2434,
  [2435] = 2372,
  [2436] = 2434,
  [2437] = 2383,
  [2438] = 726,
  [2439] = 2391,
  [2440] = 2372,
  [2441] = 2372,
  [2442] = 2434,
  [2443] = 2383,
  [2444] = 2383,
  [2445] = 2445,
  [2446] = 2391,
  [2447] = 2433,
  [2448] = 945,
  [2449] = 2433,
  [2450] = 2391,
  [2451] = 2383,
  [2452] = 2452,
  [2453] = 2453,
  [2454] = 2454,
  [2455] = 2455,
  [2456] = 2372,
  [2457] = 2457,
  [2458] = 2458,
  [2459] = 801,
  [2460] = 2393,
  [2461] = 2461,
  [2462] = 2462,
  [2463] = 2463,
  [2464] = 2464,
  [2465] = 1913,
  [2466] = 2466,
  [2467] = 2467,
  [2468] = 2081,
  [2469] = 757,
  [2470] = 2470,
  [2471] = 1870,
  [2472] = 2472,
  [2473] = 2427,
  [2474] = 2474,
  [2475] = 2475,
  [2476] = 2433,
  [2477] = 2434,
  [2478] = 2391,
  [2479] = 2372,
  [2480] = 2457,
  [2481] = 769,
  [2482] = 2482,
  [2483] = 800,
  [2484] = 763,
  [2485] = 2485,
  [2486] = 760,
  [2487] = 2487,
  [2488] = 2488,
  [2489] = 2489,
  [2490] = 2490,
  [2491] = 2491,
  [2492] = 2492,
  [2493] = 2493,
  [2494] = 2494,
  [2495] = 2495,
  [2496] = 2494,
  [2497] = 2497,
  [2498] = 2498,
  [2499] = 2499,
  [2500] = 2500,
  [2501] = 2501,
  [2502] = 2502,
  [2503] = 941,
  [2504] = 2487,
  [2505] = 2487,
  [2506] = 946,
  [2507] = 2487,
  [2508] = 2495,
  [2509] = 2501,
  [2510] = 968,
  [2511] = 2487,
  [2512] = 2500,
  [2513] = 2513,
  [2514] = 978,
  [2515] = 2499,
  [2516] = 2487,
  [2517] = 2101,
  [2518] = 2487,
  [2519] = 2519,
  [2520] = 2498,
  [2521] = 945,
  [2522] = 2522,
  [2523] = 2487,
  [2524] = 2524,
  [2525] = 2525,
  [2526] = 2487,
  [2527] = 2495,
  [2528] = 2528,
  [2529] = 2529,
  [2530] = 2530,
  [2531] = 2531,
  [2532] = 2532,
  [2533] = 2533,
  [2534] = 2534,
  [2535] = 2535,
  [2536] = 2536,
  [2537] = 2433,
  [2538] = 2538,
  [2539] = 2434,
  [2540] = 2434,
  [2541] = 2434,
  [2542] = 2542,
  [2543] = 2434,
  [2544] = 2433,
  [2545] = 2433,
  [2546] = 2546,
  [2547] = 2547,
  [2548] = 2434,
  [2549] = 2433,
  [2550] = 2433,
  [2551] = 2434,
  [2552] = 2433,
  [2553] = 2553,
  [2554] = 2433,
  [2555] = 2434,
  [2556] = 2433,
  [2557] = 2434,
  [2558] = 2434,
  [2559] = 2433,
  [2560] = 2560,
  [2561] = 203,
  [2562] = 216,
  [2563] = 2563,
  [2564] = 1454,
  [2565] = 2530,
  [2566] = 2534,
  [2567] = 2567,
  [2568] = 2568,
  [2569] = 2569,
  [2570] = 1461,
  [2571] = 2571,
  [2572] = 2572,
  [2573] = 2573,
  [2574] = 2574,
  [2575] = 2575,
  [2576] = 2576,
  [2577] = 2577,
  [2578] = 2578,
  [2579] = 2579,
  [2580] = 2580,
  [2581] = 2581,
  [2582] = 2582,
  [2583] = 2583,
  [2584] = 2584,
  [2585] = 2585,
  [2586] = 2586,
  [2587] = 2587,
  [2588] = 2588,
  [2589] = 2589,
  [2590] = 2590,
  [2591] = 2591,
  [2592] = 2592,
  [2593] = 2593,
  [2594] = 2594,
  [2595] = 2595,
  [2596] = 205,
  [2597] = 2597,
  [2598] = 2598,
  [2599] = 2599,
  [2600] = 2600,
  [2601] = 182,
  [2602] = 2602,
  [2603] = 2603,
  [2604] = 2604,
  [2605] = 2524,
  [2606] = 2606,
  [2607] = 182,
  [2608] = 2499,
  [2609] = 2501,
  [2610] = 2499,
  [2611] = 2493,
  [2612] = 2612,
  [2613] = 2613,
  [2614] = 2498,
  [2615] = 2615,
  [2616] = 2500,
  [2617] = 2604,
  [2618] = 2498,
  [2619] = 2619,
  [2620] = 2500,
  [2621] = 2621,
  [2622] = 2513,
  [2623] = 2501,
  [2624] = 2488,
  [2625] = 205,
  [2626] = 2626,
  [2627] = 2627,
  [2628] = 1481,
  [2629] = 940,
  [2630] = 203,
  [2631] = 885,
  [2632] = 2632,
  [2633] = 918,
  [2634] = 2634,
  [2635] = 2635,
  [2636] = 2636,
  [2637] = 2637,
  [2638] = 2638,
  [2639] = 2639,
  [2640] = 2640,
  [2641] = 1468,
  [2642] = 2642,
  [2643] = 216,
  [2644] = 2497,
  [2645] = 2645,
  [2646] = 2646,
  [2647] = 2647,
  [2648] = 2648,
  [2649] = 2649,
  [2650] = 2650,
  [2651] = 2651,
  [2652] = 2652,
  [2653] = 2653,
  [2654] = 2654,
  [2655] = 2655,
  [2656] = 2656,
  [2657] = 2657,
  [2658] = 2658,
  [2659] = 2659,
  [2660] = 2660,
  [2661] = 2661,
  [2662] = 2662,
  [2663] = 2663,
  [2664] = 2664,
  [2665] = 2665,
  [2666] = 2666,
  [2667] = 2667,
  [2668] = 2668,
  [2669] = 2669,
  [2670] = 2670,
  [2671] = 2671,
  [2672] = 2672,
  [2673] = 2673,
  [2674] = 2674,
  [2675] = 2675,
  [2676] = 2669,
  [2677] = 2675,
  [2678] = 2678,
  [2679] = 2679,
  [2680] = 2680,
  [2681] = 2681,
  [2682] = 2664,
  [2683] = 2683,
  [2684] = 2684,
  [2685] = 2683,
  [2686] = 2686,
  [2687] = 2687,
  [2688] = 2666,
  [2689] = 2689,
  [2690] = 2687,
  [2691] = 2691,
  [2692] = 2692,
  [2693] = 2662,
  [2694] = 885,
  [2695] = 940,
  [2696] = 875,
  [2697] = 808,
  [2698] = 918,
  [2699] = 2699,
  [2700] = 882,
  [2701] = 788,
  [2702] = 794,
  [2703] = 785,
  [2704] = 910,
  [2705] = 898,
  [2706] = 907,
  [2707] = 878,
  [2708] = 953,
  [2709] = 931,
  [2710] = 883,
  [2711] = 959,
  [2712] = 902,
  [2713] = 962,
  [2714] = 912,
  [2715] = 914,
  [2716] = 916,
  [2717] = 966,
  [2718] = 932,
  [2719] = 917,
  [2720] = 904,
  [2721] = 928,
  [2722] = 919,
  [2723] = 975,
  [2724] = 892,
  [2725] = 2725,
  [2726] = 973,
  [2727] = 958,
  [2728] = 947,
  [2729] = 944,
  [2730] = 900,
  [2731] = 905,
  [2732] = 893,
  [2733] = 965,
  [2734] = 954,
  [2735] = 961,
  [2736] = 934,
  [2737] = 909,
  [2738] = 929,
  [2739] = 2725,
  [2740] = 957,
  [2741] = 895,
  [2742] = 779,
  [2743] = 735,
  [2744] = 897,
  [2745] = 774,
  [2746] = 791,
  [2747] = 896,
  [2748] = 874,
  [2749] = 770,
  [2750] = 2750,
  [2751] = 951,
  [2752] = 970,
  [2753] = 901,
  [2754] = 786,
  [2755] = 882,
  [2756] = 939,
  [2757] = 808,
  [2758] = 875,
  [2759] = 2750,
  [2760] = 2760,
  [2761] = 935,
  [2762] = 2762,
  [2763] = 926,
  [2764] = 2764,
  [2765] = 930,
  [2766] = 794,
  [2767] = 938,
  [2768] = 788,
  [2769] = 884,
  [2770] = 899,
  [2771] = 911,
  [2772] = 925,
  [2773] = 963,
  [2774] = 927,
  [2775] = 2764,
  [2776] = 785,
  [2777] = 2764,
  [2778] = 936,
  [2779] = 952,
  [2780] = 2764,
  [2781] = 2764,
  [2782] = 2760,
  [2783] = 903,
  [2784] = 942,
  [2785] = 2764,
  [2786] = 913,
  [2787] = 2764,
  [2788] = 2788,
  [2789] = 2764,
  [2790] = 887,
  [2791] = 880,
  [2792] = 700,
  [2793] = 960,
  [2794] = 979,
  [2795] = 879,
  [2796] = 2796,
  [2797] = 2797,
  [2798] = 890,
  [2799] = 933,
  [2800] = 924,
  [2801] = 964,
  [2802] = 2802,
  [2803] = 956,
  [2804] = 900,
  [2805] = 2805,
  [2806] = 747,
  [2807] = 607,
  [2808] = 919,
  [2809] = 917,
  [2810] = 916,
  [2811] = 914,
  [2812] = 912,
  [2813] = 907,
  [2814] = 904,
  [2815] = 902,
  [2816] = 898,
  [2817] = 2817,
  [2818] = 2818,
  [2819] = 934,
  [2820] = 2820,
  [2821] = 2821,
  [2822] = 2822,
  [2823] = 931,
  [2824] = 953,
  [2825] = 878,
  [2826] = 965,
  [2827] = 973,
  [2828] = 954,
  [2829] = 909,
  [2830] = 932,
  [2831] = 929,
  [2832] = 928,
  [2833] = 2817,
  [2834] = 2818,
  [2835] = 700,
  [2836] = 2820,
  [2837] = 2821,
  [2838] = 2838,
  [2839] = 2817,
  [2840] = 2840,
  [2841] = 2818,
  [2842] = 2842,
  [2843] = 944,
  [2844] = 947,
  [2845] = 958,
  [2846] = 959,
  [2847] = 961,
  [2848] = 962,
  [2849] = 966,
  [2850] = 975,
  [2851] = 910,
  [2852] = 2820,
  [2853] = 905,
  [2854] = 892,
  [2855] = 883,
  [2856] = 893,
  [2857] = 700,
  [2858] = 2821,
  [2859] = 614,
  [2860] = 2860,
  [2861] = 2817,
  [2862] = 2818,
  [2863] = 2863,
  [2864] = 2864,
  [2865] = 2821,
  [2866] = 2820,
  [2867] = 2818,
  [2868] = 2817,
  [2869] = 2820,
  [2870] = 2821,
  [2871] = 700,
  [2872] = 2821,
  [2873] = 2820,
  [2874] = 2817,
  [2875] = 619,
  [2876] = 2818,
  [2877] = 895,
  [2878] = 896,
  [2879] = 2879,
  [2880] = 897,
  [2881] = 2881,
  [2882] = 2882,
  [2883] = 2883,
  [2884] = 2884,
  [2885] = 2885,
  [2886] = 2805,
  [2887] = 747,
  [2888] = 747,
  [2889] = 747,
  [2890] = 918,
  [2891] = 957,
  [2892] = 2882,
  [2893] = 2881,
  [2894] = 885,
  [2895] = 2895,
  [2896] = 794,
  [2897] = 786,
  [2898] = 700,
  [2899] = 788,
  [2900] = 785,
  [2901] = 940,
  [2902] = 2902,
  [2903] = 2882,
  [2904] = 2881,
  [2905] = 2905,
  [2906] = 2906,
  [2907] = 2907,
  [2908] = 2882,
  [2909] = 2909,
  [2910] = 2881,
  [2911] = 2881,
  [2912] = 2912,
  [2913] = 917,
  [2914] = 2914,
  [2915] = 2915,
  [2916] = 2916,
  [2917] = 2917,
  [2918] = 2918,
  [2919] = 2914,
  [2920] = 2920,
  [2921] = 2921,
  [2922] = 747,
  [2923] = 2923,
  [2924] = 893,
  [2925] = 883,
  [2926] = 892,
  [2927] = 574,
  [2928] = 905,
  [2929] = 909,
  [2930] = 910,
  [2931] = 975,
  [2932] = 2914,
  [2933] = 966,
  [2934] = 962,
  [2935] = 2935,
  [2936] = 961,
  [2937] = 959,
  [2938] = 958,
  [2939] = 947,
  [2940] = 774,
  [2941] = 944,
  [2942] = 2942,
  [2943] = 2943,
  [2944] = 843,
  [2945] = 928,
  [2946] = 815,
  [2947] = 929,
  [2948] = 932,
  [2949] = 934,
  [2950] = 954,
  [2951] = 973,
  [2952] = 965,
  [2953] = 878,
  [2954] = 882,
  [2955] = 953,
  [2956] = 931,
  [2957] = 2914,
  [2958] = 2958,
  [2959] = 919,
  [2960] = 916,
  [2961] = 914,
  [2962] = 912,
  [2963] = 907,
  [2964] = 2964,
  [2965] = 904,
  [2966] = 902,
  [2967] = 900,
  [2968] = 898,
  [2969] = 882,
  [2970] = 2970,
  [2971] = 2971,
  [2972] = 2972,
  [2973] = 2973,
  [2974] = 2974,
  [2975] = 2975,
  [2976] = 899,
  [2977] = 895,
  [2978] = 964,
  [2979] = 956,
  [2980] = 952,
  [2981] = 951,
  [2982] = 591,
  [2983] = 791,
  [2984] = 2984,
  [2985] = 615,
  [2986] = 786,
  [2987] = 779,
  [2988] = 901,
  [2989] = 903,
  [2990] = 913,
  [2991] = 890,
  [2992] = 894,
  [2993] = 924,
  [2994] = 933,
  [2995] = 936,
  [2996] = 927,
  [2997] = 939,
  [2998] = 949,
  [2999] = 616,
  [3000] = 642,
  [3001] = 770,
  [3002] = 3002,
  [3003] = 3003,
  [3004] = 592,
  [3005] = 906,
  [3006] = 969,
  [3007] = 882,
  [3008] = 887,
  [3009] = 977,
  [3010] = 735,
  [3011] = 972,
  [3012] = 957,
  [3013] = 970,
  [3014] = 879,
  [3015] = 921,
  [3016] = 885,
  [3017] = 963,
  [3018] = 960,
  [3019] = 3002,
  [3020] = 874,
  [3021] = 918,
  [3022] = 3022,
  [3023] = 843,
  [3024] = 815,
  [3025] = 896,
  [3026] = 911,
  [3027] = 925,
  [3028] = 897,
  [3029] = 930,
  [3030] = 843,
  [3031] = 815,
  [3032] = 938,
  [3033] = 880,
  [3034] = 942,
  [3035] = 926,
  [3036] = 940,
  [3037] = 976,
  [3038] = 923,
  [3039] = 935,
  [3040] = 881,
  [3041] = 979,
  [3042] = 601,
  [3043] = 884,
  [3044] = 843,
  [3045] = 886,
  [3046] = 815,
  [3047] = 894,
  [3048] = 3048,
  [3049] = 3049,
  [3050] = 3050,
  [3051] = 969,
  [3052] = 977,
  [3053] = 972,
  [3054] = 977,
  [3055] = 881,
  [3056] = 972,
  [3057] = 815,
  [3058] = 977,
  [3059] = 881,
  [3060] = 3048,
  [3061] = 3061,
  [3062] = 843,
  [3063] = 652,
  [3064] = 3064,
  [3065] = 3065,
  [3066] = 881,
  [3067] = 3067,
  [3068] = 969,
  [3069] = 894,
  [3070] = 969,
  [3071] = 3064,
  [3072] = 886,
  [3073] = 3073,
  [3074] = 923,
  [3075] = 976,
  [3076] = 3076,
  [3077] = 923,
  [3078] = 3078,
  [3079] = 641,
  [3080] = 976,
  [3081] = 894,
  [3082] = 3082,
  [3083] = 3076,
  [3084] = 886,
  [3085] = 976,
  [3086] = 3076,
  [3087] = 886,
  [3088] = 3088,
  [3089] = 700,
  [3090] = 923,
  [3091] = 972,
  [3092] = 774,
  [3093] = 3088,
  [3094] = 3064,
  [3095] = 3095,
  [3096] = 887,
  [3097] = 949,
  [3098] = 2914,
  [3099] = 3099,
  [3100] = 906,
  [3101] = 3101,
  [3102] = 735,
  [3103] = 2914,
  [3104] = 3104,
  [3105] = 2914,
  [3106] = 3106,
  [3107] = 939,
  [3108] = 3108,
  [3109] = 3109,
  [3110] = 3110,
  [3111] = 2914,
  [3112] = 3112,
  [3113] = 3113,
  [3114] = 972,
  [3115] = 3050,
  [3116] = 3116,
  [3117] = 977,
  [3118] = 3073,
  [3119] = 3119,
  [3120] = 976,
  [3121] = 933,
  [3122] = 3122,
  [3123] = 3123,
  [3124] = 3124,
  [3125] = 924,
  [3126] = 921,
  [3127] = 906,
  [3128] = 3101,
  [3129] = 923,
  [3130] = 921,
  [3131] = 3116,
  [3132] = 3132,
  [3133] = 949,
  [3134] = 2914,
  [3135] = 747,
  [3136] = 913,
  [3137] = 3137,
  [3138] = 3137,
  [3139] = 3139,
  [3140] = 2914,
  [3141] = 886,
  [3142] = 890,
  [3143] = 3143,
  [3144] = 779,
  [3145] = 2914,
  [3146] = 884,
  [3147] = 3147,
  [3148] = 926,
  [3149] = 3073,
  [3150] = 938,
  [3151] = 930,
  [3152] = 903,
  [3153] = 2914,
  [3154] = 3143,
  [3155] = 3113,
  [3156] = 925,
  [3157] = 911,
  [3158] = 899,
  [3159] = 808,
  [3160] = 936,
  [3161] = 927,
  [3162] = 3143,
  [3163] = 3163,
  [3164] = 874,
  [3165] = 3050,
  [3166] = 3116,
  [3167] = 2914,
  [3168] = 770,
  [3169] = 960,
  [3170] = 3170,
  [3171] = 963,
  [3172] = 881,
  [3173] = 979,
  [3174] = 879,
  [3175] = 970,
  [3176] = 969,
  [3177] = 964,
  [3178] = 956,
  [3179] = 952,
  [3180] = 3101,
  [3181] = 951,
  [3182] = 3123,
  [3183] = 894,
  [3184] = 875,
  [3185] = 880,
  [3186] = 935,
  [3187] = 3124,
  [3188] = 791,
  [3189] = 3189,
  [3190] = 3190,
  [3191] = 942,
  [3192] = 901,
  [3193] = 786,
  [3194] = 3194,
  [3195] = 950,
  [3196] = 3196,
  [3197] = 3194,
  [3198] = 3198,
  [3199] = 3194,
  [3200] = 3200,
  [3201] = 3201,
  [3202] = 3202,
  [3203] = 3203,
  [3204] = 889,
  [3205] = 3201,
  [3206] = 3194,
  [3207] = 3123,
  [3208] = 1454,
  [3209] = 3194,
  [3210] = 3210,
  [3211] = 3211,
  [3212] = 3212,
  [3213] = 3112,
  [3214] = 3214,
  [3215] = 3022,
  [3216] = 3216,
  [3217] = 3217,
  [3218] = 3218,
  [3219] = 3219,
  [3220] = 3220,
  [3221] = 3221,
  [3222] = 3109,
  [3223] = 3223,
  [3224] = 3224,
  [3225] = 3225,
  [3226] = 3226,
  [3227] = 3227,
  [3228] = 3228,
  [3229] = 3224,
  [3230] = 3147,
  [3231] = 3163,
  [3232] = 3232,
  [3233] = 3233,
  [3234] = 3234,
  [3235] = 3235,
  [3236] = 3236,
  [3237] = 3237,
  [3238] = 3238,
  [3239] = 3239,
  [3240] = 3236,
  [3241] = 3241,
  [3242] = 3242,
  [3243] = 3243,
  [3244] = 3244,
  [3245] = 3245,
  [3246] = 3246,
  [3247] = 3247,
  [3248] = 3003,
  [3249] = 3249,
  [3250] = 3250,
  [3251] = 3246,
  [3252] = 3252,
  [3253] = 699,
  [3254] = 3254,
  [3255] = 3255,
  [3256] = 3256,
  [3257] = 3256,
  [3258] = 3258,
  [3259] = 3256,
  [3260] = 3260,
  [3261] = 3261,
  [3262] = 3061,
  [3263] = 3263,
  [3264] = 3123,
  [3265] = 3265,
  [3266] = 3266,
  [3267] = 3223,
  [3268] = 3268,
  [3269] = 3269,
  [3270] = 3270,
  [3271] = 3110,
  [3272] = 3272,
  [3273] = 3273,
  [3274] = 3274,
  [3275] = 3275,
  [3276] = 3276,
  [3277] = 3277,
  [3278] = 3227,
  [3279] = 3279,
  [3280] = 3280,
  [3281] = 3235,
  [3282] = 3282,
  [3283] = 3283,
  [3284] = 3284,
  [3285] = 3246,
  [3286] = 3216,
  [3287] = 3234,
  [3288] = 1461,
  [3289] = 3289,
  [3290] = 3233,
  [3291] = 3291,
  [3292] = 3292,
  [3293] = 3293,
  [3294] = 3294,
  [3295] = 3295,
  [3296] = 3250,
  [3297] = 3297,
  [3298] = 3228,
  [3299] = 3299,
  [3300] = 3289,
  [3301] = 3299,
  [3302] = 3302,
  [3303] = 3303,
  [3304] = 3304,
  [3305] = 3225,
  [3306] = 3306,
  [3307] = 3299,
  [3308] = 3221,
  [3309] = 3309,
  [3310] = 3227,
  [3311] = 3311,
  [3312] = 3216,
  [3313] = 3289,
  [3314] = 3314,
  [3315] = 3123,
  [3316] = 3297,
  [3317] = 3317,
  [3318] = 3318,
  [3319] = 3319,
  [3320] = 3320,
  [3321] = 843,
  [3322] = 815,
  [3323] = 3323,
  [3324] = 3324,
  [3325] = 1456,
  [3326] = 3224,
  [3327] = 3236,
  [3328] = 3328,
  [3329] = 3329,
  [3330] = 3297,
  [3331] = 3331,
  [3332] = 3332,
  [3333] = 3333,
  [3334] = 3334,
  [3335] = 3335,
  [3336] = 3336,
  [3337] = 3337,
  [3338] = 3338,
  [3339] = 3339,
  [3340] = 3340,
  [3341] = 3341,
  [3342] = 3238,
  [3343] = 3214,
  [3344] = 3344,
  [3345] = 3345,
  [3346] = 3346,
  [3347] = 3347,
  [3348] = 3347,
  [3349] = 3349,
  [3350] = 3350,
  [3351] = 3351,
  [3352] = 3352,
  [3353] = 3344,
  [3354] = 3347,
  [3355] = 3237,
  [3356] = 3356,
  [3357] = 969,
  [3358] = 3336,
  [3359] = 881,
  [3360] = 3360,
  [3361] = 3261,
  [3362] = 3362,
  [3363] = 3245,
  [3364] = 3364,
  [3365] = 3365,
  [3366] = 3362,
  [3367] = 3362,
  [3368] = 3334,
  [3369] = 3369,
  [3370] = 3362,
  [3371] = 3254,
  [3372] = 3372,
  [3373] = 3341,
  [3374] = 3340,
  [3375] = 3339,
  [3376] = 3376,
  [3377] = 3377,
  [3378] = 3378,
  [3379] = 3379,
  [3380] = 3351,
  [3381] = 3376,
  [3382] = 3382,
  [3383] = 3260,
  [3384] = 3269,
  [3385] = 3276,
  [3386] = 3303,
  [3387] = 3309,
  [3388] = 3388,
  [3389] = 3344,
  [3390] = 3390,
  [3391] = 3266,
  [3392] = 3392,
  [3393] = 3265,
  [3394] = 3347,
  [3395] = 3263,
  [3396] = 3396,
  [3397] = 3238,
  [3398] = 3376,
  [3399] = 3399,
  [3400] = 3351,
  [3401] = 3351,
  [3402] = 3241,
  [3403] = 3403,
  [3404] = 3396,
  [3405] = 3242,
  [3406] = 3406,
  [3407] = 3407,
  [3408] = 3408,
  [3409] = 3409,
  [3410] = 3247,
  [3411] = 3328,
  [3412] = 3364,
  [3413] = 3365,
  [3414] = 3414,
  [3415] = 3341,
  [3416] = 3416,
  [3417] = 3340,
  [3418] = 3356,
  [3419] = 3339,
  [3420] = 3420,
  [3421] = 3421,
  [3422] = 3275,
  [3423] = 3408,
  [3424] = 3272,
  [3425] = 3347,
  [3426] = 3376,
  [3427] = 3427,
  [3428] = 3258,
  [3429] = 3396,
  [3430] = 3396,
  [3431] = 3255,
  [3432] = 3352,
  [3433] = 3433,
  [3434] = 3434,
  [3435] = 3435,
  [3436] = 3378,
  [3437] = 3437,
  [3438] = 3378,
  [3439] = 3378,
  [3440] = 3351,
  [3441] = 3427,
  [3442] = 3442,
  [3443] = 3443,
  [3444] = 3409,
  [3445] = 3317,
  [3446] = 3318,
  [3447] = 3447,
  [3448] = 3244,
  [3449] = 3362,
  [3450] = 3335,
  [3451] = 886,
  [3452] = 3364,
  [3453] = 3365,
  [3454] = 3420,
  [3455] = 3421,
  [3456] = 3456,
  [3457] = 3457,
  [3458] = 3458,
  [3459] = 3414,
  [3460] = 3388,
  [3461] = 3378,
  [3462] = 972,
  [3463] = 3463,
  [3464] = 3434,
  [3465] = 3406,
  [3466] = 3466,
  [3467] = 3467,
  [3468] = 977,
  [3469] = 3378,
  [3470] = 3470,
  [3471] = 3333,
  [3472] = 3396,
  [3473] = 3376,
  [3474] = 3421,
  [3475] = 3420,
  [3476] = 3336,
  [3477] = 3351,
  [3478] = 3478,
  [3479] = 3479,
  [3480] = 3347,
  [3481] = 3481,
  [3482] = 3396,
  [3483] = 3434,
  [3484] = 3376,
  [3485] = 3378,
  [3486] = 3351,
  [3487] = 3487,
  [3488] = 3488,
  [3489] = 3489,
  [3490] = 3435,
  [3491] = 3324,
  [3492] = 3492,
  [3493] = 3339,
  [3494] = 3335,
  [3495] = 3495,
  [3496] = 3340,
  [3497] = 3341,
  [3498] = 3421,
  [3499] = 3420,
  [3500] = 3500,
  [3501] = 3501,
  [3502] = 3502,
  [3503] = 3347,
  [3504] = 3504,
  [3505] = 3277,
  [3506] = 923,
  [3507] = 976,
  [3508] = 3456,
  [3509] = 3396,
  [3510] = 590,
  [3511] = 3362,
  [3512] = 3512,
  [3513] = 3376,
  [3514] = 3514,
  [3515] = 3515,
  [3516] = 894,
  [3517] = 3517,
  [3518] = 3403,
  [3519] = 3519,
  [3520] = 3520,
  [3521] = 3521,
  [3522] = 3522,
  [3523] = 3523,
  [3524] = 3524,
  [3525] = 3525,
  [3526] = 3526,
  [3527] = 3527,
  [3528] = 3528,
  [3529] = 3073,
  [3530] = 3283,
  [3531] = 3531,
  [3532] = 3532,
  [3533] = 3533,
  [3534] = 3534,
  [3535] = 3535,
  [3536] = 3536,
  [3537] = 3232,
  [3538] = 3538,
  [3539] = 3539,
  [3540] = 3540,
  [3541] = 3268,
  [3542] = 3542,
  [3543] = 3543,
  [3544] = 3544,
  [3545] = 3545,
  [3546] = 3546,
  [3547] = 3547,
  [3548] = 3548,
  [3549] = 3520,
  [3550] = 3550,
  [3551] = 3551,
  [3552] = 3552,
  [3553] = 3553,
  [3554] = 3554,
  [3555] = 3555,
  [3556] = 3556,
  [3557] = 3557,
  [3558] = 3050,
  [3559] = 3559,
  [3560] = 3560,
  [3561] = 3561,
  [3562] = 3562,
  [3563] = 3563,
  [3564] = 3564,
  [3565] = 3565,
  [3566] = 745,
  [3567] = 3567,
  [3568] = 3568,
  [3569] = 3569,
  [3570] = 3050,
  [3571] = 3571,
  [3572] = 3572,
  [3573] = 3573,
  [3574] = 3574,
  [3575] = 3575,
  [3576] = 3576,
  [3577] = 3577,
  [3578] = 3578,
  [3579] = 3579,
  [3580] = 3542,
  [3581] = 3581,
  [3582] = 3582,
  [3583] = 3583,
  [3584] = 3584,
  [3585] = 3585,
  [3586] = 3586,
  [3587] = 3587,
  [3588] = 3588,
  [3589] = 3589,
  [3590] = 3590,
  [3591] = 3591,
  [3592] = 3581,
  [3593] = 3593,
  [3594] = 3594,
  [3595] = 3595,
  [3596] = 3596,
  [3597] = 3597,
  [3598] = 3598,
  [3599] = 3540,
  [3600] = 3600,
  [3601] = 3601,
  [3602] = 3559,
  [3603] = 3545,
  [3604] = 3604,
  [3605] = 3605,
  [3606] = 3606,
  [3607] = 3607,
  [3608] = 3608,
  [3609] = 3609,
  [3610] = 3610,
  [3611] = 633,
  [3612] = 3612,
  [3613] = 3613,
  [3614] = 3614,
  [3615] = 3615,
  [3616] = 3616,
  [3617] = 3617,
  [3618] = 3559,
  [3619] = 3619,
  [3620] = 3620,
  [3621] = 3562,
  [3622] = 3622,
  [3623] = 3591,
  [3624] = 3551,
  [3625] = 3625,
  [3626] = 3544,
  [3627] = 3627,
  [3628] = 3628,
  [3629] = 3629,
  [3630] = 3600,
  [3631] = 3547,
  [3632] = 3575,
  [3633] = 3591,
  [3634] = 3539,
  [3635] = 3589,
  [3636] = 3636,
  [3637] = 3577,
  [3638] = 3577,
  [3639] = 3639,
  [3640] = 3640,
  [3641] = 3641,
  [3642] = 3612,
  [3643] = 3643,
  [3644] = 3644,
  [3645] = 3645,
  [3646] = 3646,
  [3647] = 3647,
  [3648] = 3639,
  [3649] = 3560,
  [3650] = 3650,
  [3651] = 882,
  [3652] = 3652,
  [3653] = 3653,
  [3654] = 3654,
  [3655] = 3655,
  [3656] = 3656,
  [3657] = 3657,
  [3658] = 3658,
  [3659] = 3659,
  [3660] = 3654,
  [3661] = 3661,
  [3662] = 3643,
  [3663] = 3663,
  [3664] = 3664,
  [3665] = 3073,
  [3666] = 3666,
  [3667] = 3667,
  [3668] = 3668,
  [3669] = 3669,
  [3670] = 3670,
  [3671] = 3538,
  [3672] = 3672,
  [3673] = 3673,
  [3674] = 3674,
  [3675] = 3573,
  [3676] = 3212,
  [3677] = 3627,
  [3678] = 3578,
  [3679] = 3679,
  [3680] = 3608,
  [3681] = 3575,
  [3682] = 3593,
  [3683] = 3656,
  [3684] = 3684,
  [3685] = 3559,
  [3686] = 3559,
  [3687] = 3577,
  [3688] = 3688,
  [3689] = 3689,
  [3690] = 3565,
  [3691] = 3653,
  [3692] = 3692,
  [3693] = 3693,
  [3694] = 3576,
  [3695] = 3548,
  [3696] = 3610,
  [3697] = 3654,
  [3698] = 3698,
  [3699] = 3699,
  [3700] = 3700,
  [3701] = 3559,
  [3702] = 3620,
  [3703] = 3703,
  [3704] = 3704,
  [3705] = 3705,
  [3706] = 3500,
  [3707] = 3707,
  [3708] = 3708,
  [3709] = 3709,
  [3710] = 3502,
  [3711] = 3711,
  [3712] = 3495,
  [3713] = 3713,
  [3714] = 3565,
  [3715] = 3715,
  [3716] = 3647,
  [3717] = 3717,
  [3718] = 3517,
  [3719] = 3577,
  [3720] = 3720,
  [3721] = 3721,
  [3722] = 3577,
  [3723] = 3723,
  [3724] = 3548,
  [3725] = 3725,
  [3726] = 3726,
  [3727] = 3727,
  [3728] = 3728,
  [3729] = 3729,
  [3730] = 3730,
  [3731] = 3731,
  [3732] = 3730,
  [3733] = 3733,
  [3734] = 3734,
  [3735] = 3735,
  [3736] = 3736,
  [3737] = 3737,
  [3738] = 3738,
  [3739] = 3739,
  [3740] = 3736,
  [3741] = 3741,
  [3742] = 3729,
  [3743] = 3741,
  [3744] = 3744,
  [3745] = 3744,
  [3746] = 3746,
  [3747] = 3747,
  [3748] = 3748,
  [3749] = 3749,
  [3750] = 3750,
  [3751] = 3744,
  [3752] = 3739,
  [3753] = 3749,
  [3754] = 3736,
  [3755] = 3741,
  [3756] = 3734,
  [3757] = 3749,
  [3758] = 3748,
  [3759] = 3759,
  [3760] = 3733,
  [3761] = 3737,
  [3762] = 3762,
  [3763] = 3738,
  [3764] = 3749,
  [3765] = 3744,
  [3766] = 3730,
  [3767] = 3738,
  [3768] = 3730,
  [3769] = 3741,
  [3770] = 3770,
  [3771] = 3736,
  [3772] = 3733,
  [3773] = 3730,
  [3774] = 3730,
  [3775] = 3741,
  [3776] = 3736,
  [3777] = 3739,
  [3778] = 3778,
  [3779] = 3779,
  [3780] = 3730,
  [3781] = 3781,
  [3782] = 3782,
  [3783] = 3738,
  [3784] = 3784,
  [3785] = 3731,
  [3786] = 3786,
  [3787] = 3744,
  [3788] = 3788,
  [3789] = 3749,
  [3790] = 3790,
  [3791] = 3791,
  [3792] = 3792,
  [3793] = 3793,
  [3794] = 3748,
  [3795] = 3795,
  [3796] = 3796,
  [3797] = 3731,
  [3798] = 3734,
  [3799] = 3799,
  [3800] = 3737,
  [3801] = 3759,
  [3802] = 3796,
  [3803] = 3803,
  [3804] = 3804,
  [3805] = 3805,
  [3806] = 3733,
  [3807] = 3770,
  [3808] = 3808,
  [3809] = 3733,
  [3810] = 3810,
  [3811] = 3811,
  [3812] = 3749,
  [3813] = 3734,
  [3814] = 3814,
  [3815] = 3815,
  [3816] = 3744,
  [3817] = 3817,
  [3818] = 3818,
  [3819] = 3819,
  [3820] = 3820,
  [3821] = 3741,
  [3822] = 3822,
  [3823] = 3736,
  [3824] = 3739,
  [3825] = 3825,
  [3826] = 3826,
  [3827] = 3820,
  [3828] = 3826,
  [3829] = 3799,
  [3830] = 3830,
  [3831] = 3831,
  [3832] = 3759,
  [3833] = 3833,
  [3834] = 3739,
  [3835] = 3835,
  [3836] = 3836,
  [3837] = 3837,
  [3838] = 3729,
  [3839] = 648,
  [3840] = 3840,
  [3841] = 3841,
  [3842] = 3842,
  [3843] = 3731,
  [3844] = 3770,
  [3845] = 3845,
  [3846] = 3739,
  [3847] = 3847,
  [3848] = 3739,
  [3849] = 3811,
  [3850] = 3730,
  [3851] = 3851,
  [3852] = 702,
  [3853] = 3853,
  [3854] = 3847,
  [3855] = 3851,
  [3856] = 3856,
  [3857] = 3857,
  [3858] = 3739,
  [3859] = 3859,
  [3860] = 3860,
  [3861] = 3822,
  [3862] = 3862,
  [3863] = 3863,
  [3864] = 3738,
  [3865] = 3727,
  [3866] = 3866,
  [3867] = 3867,
  [3868] = 3734,
  [3869] = 3869,
  [3870] = 3870,
  [3871] = 3871,
  [3872] = 3728,
  [3873] = 3734,
  [3874] = 3730,
  [3875] = 3731,
  [3876] = 3738,
  [3877] = 3877,
  [3878] = 3878,
  [3879] = 3739,
  [3880] = 3880,
  [3881] = 3734,
  [3882] = 3882,
  [3883] = 3731,
  [3884] = 3738,
  [3885] = 3885,
  [3886] = 3886,
  [3887] = 3738,
  [3888] = 3734,
  [3889] = 3733,
  [3890] = 3736,
  [3891] = 3741,
  [3892] = 3886,
  [3893] = 3734,
  [3894] = 3738,
  [3895] = 3727,
  [3896] = 3822,
  [3897] = 3897,
  [3898] = 3898,
  [3899] = 3899,
  [3900] = 3749,
  [3901] = 3811,
  [3902] = 3744,
  [3903] = 3903,
  [3904] = 3904,
  [3905] = 3214,
  [3906] = 3906,
  [3907] = 3907,
  [3908] = 3908,
  [3909] = 3909,
  [3910] = 3910,
  [3911] = 3911,
  [3912] = 3912,
  [3913] = 3913,
  [3914] = 3914,
  [3915] = 205,
  [3916] = 3916,
  [3917] = 3917,
  [3918] = 3918,
  [3919] = 3919,
  [3920] = 3920,
  [3921] = 3921,
  [3922] = 3922,
  [3923] = 3923,
  [3924] = 3924,
  [3925] = 3925,
  [3926] = 3926,
  [3927] = 3919,
  [3928] = 3928,
  [3929] = 3910,
  [3930] = 3916,
  [3931] = 3931,
  [3932] = 3932,
  [3933] = 3933,
  [3934] = 3934,
  [3935] = 3935,
  [3936] = 3936,
  [3937] = 3937,
  [3938] = 3938,
  [3939] = 3939,
  [3940] = 3658,
  [3941] = 3941,
  [3942] = 3942,
  [3943] = 3904,
  [3944] = 3244,
  [3945] = 3945,
  [3946] = 3946,
  [3947] = 3947,
  [3948] = 3948,
  [3949] = 3949,
  [3950] = 3950,
  [3951] = 3951,
  [3952] = 3904,
  [3953] = 3237,
  [3954] = 3954,
  [3955] = 3955,
  [3956] = 3956,
  [3957] = 3957,
  [3958] = 3958,
  [3959] = 3959,
  [3960] = 3960,
  [3961] = 3950,
  [3962] = 182,
  [3963] = 3963,
  [3964] = 3964,
  [3965] = 3965,
  [3966] = 3966,
  [3967] = 3967,
  [3968] = 3934,
  [3969] = 3969,
  [3970] = 3970,
  [3971] = 3908,
  [3972] = 3908,
  [3973] = 3914,
  [3974] = 3918,
  [3975] = 696,
  [3976] = 3976,
  [3977] = 3977,
  [3978] = 3947,
  [3979] = 3979,
  [3980] = 3980,
  [3981] = 3981,
  [3982] = 3982,
  [3983] = 3983,
  [3984] = 3976,
  [3985] = 3985,
  [3986] = 3928,
  [3987] = 3931,
  [3988] = 3977,
  [3989] = 3933,
  [3990] = 3936,
  [3991] = 3991,
  [3992] = 3992,
  [3993] = 3993,
  [3994] = 3994,
  [3995] = 3995,
  [3996] = 3996,
  [3997] = 3997,
  [3998] = 3998,
  [3999] = 3999,
  [4000] = 4000,
  [4001] = 4001,
  [4002] = 3937,
  [4003] = 4003,
  [4004] = 3941,
  [4005] = 4005,
  [4006] = 4006,
  [4007] = 4007,
  [4008] = 4008,
  [4009] = 3948,
  [4010] = 3949,
  [4011] = 4011,
  [4012] = 3950,
  [4013] = 4013,
  [4014] = 4014,
  [4015] = 3904,
  [4016] = 3951,
  [4017] = 4017,
  [4018] = 4018,
  [4019] = 3922,
  [4020] = 4020,
  [4021] = 4021,
  [4022] = 3911,
  [4023] = 3912,
  [4024] = 4024,
  [4025] = 4025,
  [4026] = 3245,
  [4027] = 4027,
  [4028] = 3947,
  [4029] = 4029,
  [4030] = 4030,
  [4031] = 3922,
  [4032] = 3908,
  [4033] = 3980,
  [4034] = 4029,
  [4035] = 4035,
  [4036] = 3912,
  [4037] = 4037,
  [4038] = 3918,
  [4039] = 4039,
  [4040] = 4040,
  [4041] = 4041,
  [4042] = 4042,
  [4043] = 4043,
  [4044] = 4044,
  [4045] = 4045,
  [4046] = 4046,
  [4047] = 4047,
  [4048] = 3982,
  [4049] = 3947,
  [4050] = 3985,
  [4051] = 3928,
  [4052] = 3991,
  [4053] = 3936,
  [4054] = 3911,
  [4055] = 3956,
  [4056] = 4056,
  [4057] = 3992,
  [4058] = 3950,
  [4059] = 3950,
  [4060] = 3951,
  [4061] = 3945,
  [4062] = 4001,
  [4063] = 4063,
  [4064] = 4064,
  [4065] = 4005,
  [4066] = 3908,
  [4067] = 4006,
  [4068] = 4014,
  [4069] = 4017,
  [4070] = 4070,
  [4071] = 4071,
  [4072] = 4072,
  [4073] = 4073,
  [4074] = 4074,
  [4075] = 3947,
  [4076] = 4076,
  [4077] = 4077,
  [4078] = 4078,
  [4079] = 4079,
  [4080] = 4080,
  [4081] = 4081,
  [4082] = 3912,
  [4083] = 3911,
  [4084] = 4018,
  [4085] = 3947,
  [4086] = 4086,
  [4087] = 3955,
  [4088] = 3957,
  [4089] = 3912,
  [4090] = 3911,
  [4091] = 4091,
  [4092] = 4092,
  [4093] = 4093,
  [4094] = 4094,
  [4095] = 3958,
  [4096] = 3904,
  [4097] = 3959,
  [4098] = 3922,
  [4099] = 3908,
  [4100] = 4100,
  [4101] = 4020,
  [4102] = 4102,
  [4103] = 3947,
  [4104] = 4104,
  [4105] = 4105,
  [4106] = 3904,
  [4107] = 3947,
  [4108] = 3980,
  [4109] = 3912,
  [4110] = 3904,
  [4111] = 4111,
  [4112] = 3911,
  [4113] = 3912,
  [4114] = 3911,
  [4115] = 4115,
  [4116] = 3912,
  [4117] = 3911,
  [4118] = 4072,
  [4119] = 4119,
  [4120] = 3922,
  [4121] = 3528,
  [4122] = 3904,
  [4123] = 4123,
  [4124] = 3939,
  [4125] = 3985,
  [4126] = 3991,
  [4127] = 4063,
  [4128] = 4073,
  [4129] = 3904,
  [4130] = 4130,
  [4131] = 3645,
  [4132] = 3911,
  [4133] = 4005,
  [4134] = 4006,
  [4135] = 4123,
  [4136] = 3947,
  [4137] = 970,
  [4138] = 3912,
  [4139] = 4100,
  [4140] = 3959,
  [4141] = 3958,
  [4142] = 3957,
  [4143] = 3955,
  [4144] = 951,
  [4145] = 3950,
  [4146] = 4020,
  [4147] = 4100,
  [4148] = 3908,
  [4149] = 699,
  [4150] = 3922,
  [4151] = 3983,
  [4152] = 4152,
  [4153] = 4153,
  [4154] = 4154,
  [4155] = 4155,
  [4156] = 4152,
  [4157] = 4157,
  [4158] = 4158,
  [4159] = 542,
  [4160] = 4160,
  [4161] = 4161,
  [4162] = 4162,
  [4163] = 4163,
  [4164] = 4164,
  [4165] = 4165,
  [4166] = 4166,
  [4167] = 4167,
  [4168] = 4158,
  [4169] = 4169,
  [4170] = 4170,
  [4171] = 4161,
  [4172] = 4172,
  [4173] = 4173,
  [4174] = 3880,
  [4175] = 4175,
  [4176] = 4176,
  [4177] = 4177,
  [4178] = 4178,
  [4179] = 4179,
  [4180] = 4155,
  [4181] = 4181,
  [4182] = 4176,
  [4183] = 4157,
  [4184] = 4152,
  [4185] = 4160,
  [4186] = 4172,
  [4187] = 4187,
  [4188] = 4154,
  [4189] = 4189,
  [4190] = 4190,
  [4191] = 4191,
  [4192] = 4192,
  [4193] = 4193,
  [4194] = 4194,
  [4195] = 4195,
  [4196] = 4196,
  [4197] = 4177,
  [4198] = 4198,
  [4199] = 2595,
  [4200] = 4200,
  [4201] = 4201,
  [4202] = 4162,
  [4203] = 4203,
  [4204] = 2592,
  [4205] = 4205,
  [4206] = 2591,
  [4207] = 4189,
  [4208] = 4162,
  [4209] = 4209,
  [4210] = 4210,
  [4211] = 4211,
  [4212] = 4162,
  [4213] = 4213,
  [4214] = 2588,
  [4215] = 4195,
  [4216] = 4160,
  [4217] = 4217,
  [4218] = 4218,
  [4219] = 4219,
  [4220] = 4220,
  [4221] = 4221,
  [4222] = 2587,
  [4223] = 4223,
  [4224] = 2583,
  [4225] = 4225,
  [4226] = 4226,
  [4227] = 4227,
  [4228] = 4228,
  [4229] = 4229,
  [4230] = 4230,
  [4231] = 4231,
  [4232] = 4161,
  [4233] = 4160,
  [4234] = 4234,
  [4235] = 4190,
  [4236] = 4236,
  [4237] = 4237,
  [4238] = 4192,
  [4239] = 4239,
  [4240] = 4240,
  [4241] = 2577,
  [4242] = 4242,
  [4243] = 4243,
  [4244] = 4244,
  [4245] = 2576,
  [4246] = 4246,
  [4247] = 4247,
  [4248] = 4248,
  [4249] = 4249,
  [4250] = 4250,
  [4251] = 4251,
  [4252] = 4252,
  [4253] = 4253,
  [4254] = 4254,
  [4255] = 4255,
  [4256] = 4256,
  [4257] = 4257,
  [4258] = 2567,
  [4259] = 4179,
  [4260] = 4260,
  [4261] = 4261,
  [4262] = 2568,
  [4263] = 4172,
  [4264] = 4264,
  [4265] = 4265,
  [4266] = 4266,
  [4267] = 4200,
  [4268] = 4164,
  [4269] = 4167,
  [4270] = 4170,
  [4271] = 4271,
  [4272] = 4175,
  [4273] = 4273,
  [4274] = 4274,
  [4275] = 4275,
  [4276] = 4276,
  [4277] = 4277,
  [4278] = 4201,
  [4279] = 4247,
  [4280] = 4203,
  [4281] = 4154,
  [4282] = 4282,
  [4283] = 4152,
  [4284] = 4227,
  [4285] = 4285,
  [4286] = 4161,
  [4287] = 3495,
  [4288] = 4178,
  [4289] = 4157,
  [4290] = 4290,
  [4291] = 4291,
  [4292] = 2569,
  [4293] = 2571,
  [4294] = 4294,
  [4295] = 4155,
  [4296] = 4296,
  [4297] = 4155,
  [4298] = 4298,
  [4299] = 4157,
  [4300] = 4164,
  [4301] = 4301,
  [4302] = 4152,
  [4303] = 4303,
  [4304] = 4167,
  [4305] = 4154,
  [4306] = 4306,
  [4307] = 2573,
  [4308] = 4308,
  [4309] = 2574,
  [4310] = 4209,
  [4311] = 4210,
  [4312] = 4170,
  [4313] = 4213,
  [4314] = 4217,
  [4315] = 4315,
  [4316] = 4175,
  [4317] = 4317,
  [4318] = 4318,
  [4319] = 4319,
  [4320] = 4320,
  [4321] = 4321,
  [4322] = 4242,
  [4323] = 2590,
  [4324] = 4324,
  [4325] = 4325,
  [4326] = 4319,
  [4327] = 4327,
  [4328] = 4158,
  [4329] = 4329,
  [4330] = 4178,
  [4331] = 4160,
  [4332] = 4155,
  [4333] = 2584,
  [4334] = 2585,
  [4335] = 4157,
  [4336] = 4336,
  [4337] = 4154,
  [4338] = 4338,
  [4339] = 4339,
  [4340] = 541,
  [4341] = 4341,
  [4342] = 4342,
  [4343] = 4162,
  [4344] = 4344,
  [4345] = 4345,
  [4346] = 4346,
  [4347] = 4347,
  [4348] = 4348,
  [4349] = 4349,
  [4350] = 4350,
  [4351] = 2589,
  [4352] = 4352,
  [4353] = 2594,
  [4354] = 4187,
  [4355] = 1539,
  [4356] = 4356,
  [4357] = 4357,
  [4358] = 4252,
  [4359] = 4253,
  [4360] = 4172,
  [4361] = 4361,
  [4362] = 4256,
  [4363] = 4264,
  [4364] = 1556,
  [4365] = 4365,
  [4366] = 4163,
  [4367] = 4315,
  [4368] = 4158,
  [4369] = 4161,
  [4370] = 4273,
  [4371] = 4172,
  [4372] = 4274,
  [4373] = 4373,
  [4374] = 4275,
  [4375] = 4294,
  [4376] = 4376,
  [4377] = 4377,
  [4378] = 4291,
  [4379] = 4158,
  [4380] = 4380,
  [4381] = 4290,
  [4382] = 4158,
  [4383] = 4161,
  [4384] = 4384,
  [4385] = 4385,
  [4386] = 4386,
  [4387] = 4172,
  [4388] = 4388,
  [4389] = 4389,
  [4390] = 4390,
  [4391] = 3238,
  [4392] = 4392,
  [4393] = 4158,
  [4394] = 4394,
  [4395] = 4290,
  [4396] = 4291,
  [4397] = 4294,
  [4398] = 4161,
  [4399] = 4348,
  [4400] = 4346,
  [4401] = 4218,
  [4402] = 4172,
  [4403] = 4320,
  [4404] = 4345,
  [4405] = 4219,
  [4406] = 4220,
  [4407] = 2586,
  [4408] = 4408,
  [4409] = 2598,
  [4410] = 4410,
  [4411] = 4226,
  [4412] = 4342,
  [4413] = 4413,
  [4414] = 1570,
  [4415] = 4415,
  [4416] = 4218,
  [4417] = 4417,
  [4418] = 4418,
  [4419] = 4229,
  [4420] = 4320,
  [4421] = 4169,
  [4422] = 4231,
  [4423] = 4298,
  [4424] = 4219,
  [4425] = 4220,
  [4426] = 4426,
  [4427] = 4226,
  [4428] = 4301,
  [4429] = 4285,
  [4430] = 4229,
  [4431] = 4231,
  [4432] = 4327,
  [4433] = 3500,
  [4434] = 4255,
  [4435] = 4154,
  [4436] = 4436,
  [4437] = 4437,
  [4438] = 4438,
  [4439] = 4439,
  [4440] = 3502,
  [4441] = 4336,
  [4442] = 4442,
  [4443] = 4255,
  [4444] = 4444,
  [4445] = 4152,
  [4446] = 4257,
  [4447] = 4260,
  [4448] = 4448,
  [4449] = 4158,
  [4450] = 4173,
  [4451] = 4157,
  [4452] = 4155,
  [4453] = 4257,
  [4454] = 4172,
  [4455] = 4260,
  [4456] = 4325,
  [4457] = 4457,
  [4458] = 4458,
  [4459] = 4459,
  [4460] = 4460,
  [4461] = 4461,
  [4462] = 4462,
  [4463] = 4463,
  [4464] = 4464,
  [4465] = 4361,
  [4466] = 4161,
  [4467] = 4467,
  [4468] = 4468,
  [4469] = 4469,
  [4470] = 4317,
  [4471] = 4471,
  [4472] = 4472,
  [4473] = 4473,
  [4474] = 4474,
  [4475] = 4475,
  [4476] = 4476,
  [4477] = 4477,
  [4478] = 4303,
  [4479] = 4160,
  [4480] = 4480,
  [4481] = 4481,
  [4482] = 4161,
  [4483] = 4394,
  [4484] = 4348,
  [4485] = 4346,
  [4486] = 4486,
  [4487] = 4345,
  [4488] = 4342,
  [4489] = 4489,
  [4490] = 3517,
  [4491] = 3238,
  [4492] = 4492,
  [4493] = 4158,
  [4494] = 4327,
  [4495] = 4172,
  [4496] = 4325,
  [4497] = 4361,
  [4498] = 4317,
  [4499] = 4481,
  [4500] = 4492,
  [4501] = 4501,
  [4502] = 4303,
  [4503] = 4503,
  [4504] = 4489,
  [4505] = 4505,
  [4506] = 2582,
  [4507] = 4507,
  [4508] = 4508,
  [4509] = 1571,
  [4510] = 4377,
  [4511] = 4511,
  [4512] = 4512,
  [4513] = 4513,
  [4514] = 4514,
  [4515] = 4515,
  [4516] = 4516,
  [4517] = 4517,
  [4518] = 4518,
  [4519] = 4519,
  [4520] = 4520,
  [4521] = 4521,
  [4522] = 4522,
  [4523] = 4523,
  [4524] = 4524,
  [4525] = 4525,
  [4526] = 4526,
  [4527] = 4527,
  [4528] = 4528,
  [4529] = 4529,
  [4530] = 4530,
  [4531] = 4531,
  [4532] = 4532,
  [4533] = 4533,
  [4534] = 4534,
  [4535] = 4535,
  [4536] = 4536,
  [4537] = 4537,
  [4538] = 4538,
  [4539] = 4539,
  [4540] = 4540,
  [4541] = 4541,
  [4542] = 4542,
  [4543] = 4519,
  [4544] = 4544,
  [4545] = 4545,
  [4546] = 4546,
  [4547] = 4547,
  [4548] = 4548,
  [4549] = 4549,
  [4550] = 4550,
  [4551] = 4513,
  [4552] = 4552,
  [4553] = 4553,
  [4554] = 4554,
  [4555] = 4555,
  [4556] = 4556,
  [4557] = 4557,
  [4558] = 4558,
  [4559] = 4540,
  [4560] = 4560,
  [4561] = 4516,
  [4562] = 4534,
  [4563] = 4517,
  [4564] = 4519,
  [4565] = 4521,
  [4566] = 4522,
  [4567] = 4523,
  [4568] = 4528,
  [4569] = 4530,
  [4570] = 4531,
  [4571] = 4533,
  [4572] = 4539,
  [4573] = 4542,
  [4574] = 4574,
  [4575] = 4575,
  [4576] = 4576,
  [4577] = 4518,
  [4578] = 4532,
  [4579] = 4579,
  [4580] = 4580,
  [4581] = 4581,
  [4582] = 4582,
  [4583] = 4583,
  [4584] = 4584,
  [4585] = 4585,
  [4586] = 4536,
  [4587] = 4515,
  [4588] = 4588,
  [4589] = 4589,
  [4590] = 4583,
  [4591] = 4591,
  [4592] = 4592,
  [4593] = 4520,
  [4594] = 4519,
  [4595] = 4579,
  [4596] = 4596,
  [4597] = 4576,
  [4598] = 4512,
  [4599] = 4574,
  [4600] = 4534,
  [4601] = 4601,
  [4602] = 4601,
  [4603] = 4540,
  [4604] = 4542,
  [4605] = 4546,
  [4606] = 4520,
  [4607] = 4539,
  [4608] = 4608,
  [4609] = 4601,
  [4610] = 4547,
  [4611] = 4549,
  [4612] = 4538,
  [4613] = 4550,
  [4614] = 4513,
  [4615] = 4531,
  [4616] = 4534,
  [4617] = 4552,
  [4618] = 4618,
  [4619] = 4540,
  [4620] = 4530,
  [4621] = 4528,
  [4622] = 4523,
  [4623] = 4522,
  [4624] = 4624,
  [4625] = 4521,
  [4626] = 4626,
  [4627] = 4555,
  [4628] = 4533,
  [4629] = 4554,
  [4630] = 4526,
  [4631] = 4534,
  [4632] = 4553,
  [4633] = 4540,
  [4634] = 4634,
  [4635] = 4552,
  [4636] = 4513,
  [4637] = 4637,
  [4638] = 4638,
  [4639] = 4540,
  [4640] = 4540,
  [4641] = 4641,
  [4642] = 4642,
  [4643] = 4550,
  [4644] = 4549,
  [4645] = 4645,
  [4646] = 4547,
  [4647] = 4546,
  [4648] = 4648,
  [4649] = 4520,
  [4650] = 4579,
  [4651] = 4574,
  [4652] = 4546,
  [4653] = 4653,
  [4654] = 4547,
  [4655] = 4554,
  [4656] = 4549,
  [4657] = 4657,
  [4658] = 4658,
  [4659] = 4550,
  [4660] = 4576,
  [4661] = 4513,
  [4662] = 4552,
  [4663] = 4553,
  [4664] = 4556,
  [4665] = 4555,
  [4666] = 4548,
  [4667] = 4554,
  [4668] = 4555,
  [4669] = 4576,
  [4670] = 4532,
  [4671] = 4574,
  [4672] = 4672,
  [4673] = 4596,
  [4674] = 4536,
  [4675] = 4579,
  [4676] = 4537,
  [4677] = 4537,
  [4678] = 4518,
  [4679] = 4532,
  [4680] = 4680,
  [4681] = 4681,
  [4682] = 4557,
  [4683] = 4558,
  [4684] = 4560,
  [4685] = 4685,
  [4686] = 4576,
  [4687] = 4574,
  [4688] = 4529,
  [4689] = 4518,
  [4690] = 4690,
  [4691] = 4560,
  [4692] = 4558,
  [4693] = 4519,
  [4694] = 4557,
  [4695] = 4535,
  [4696] = 4541,
  [4697] = 4553,
  [4698] = 4698,
  [4699] = 4519,
  [4700] = 4541,
  [4701] = 4701,
  [4702] = 4702,
  [4703] = 4518,
  [4704] = 4704,
  [4705] = 4705,
  [4706] = 4706,
  [4707] = 4626,
  [4708] = 4540,
  [4709] = 4576,
  [4710] = 4517,
  [4711] = 4521,
  [4712] = 4522,
  [4713] = 4535,
  [4714] = 4637,
  [4715] = 4574,
  [4716] = 4601,
  [4717] = 4681,
  [4718] = 4523,
  [4719] = 4690,
  [4720] = 4534,
  [4721] = 4560,
  [4722] = 4558,
  [4723] = 4557,
  [4724] = 4724,
  [4725] = 4538,
  [4726] = 4529,
  [4727] = 4542,
  [4728] = 4541,
  [4729] = 4528,
  [4730] = 4530,
  [4731] = 4531,
  [4732] = 4533,
  [4733] = 4539,
  [4734] = 4535,
  [4735] = 4542,
  [4736] = 4517,
  [4737] = 4737,
  [4738] = 4533,
  [4739] = 4739,
  [4740] = 4531,
  [4741] = 4741,
  [4742] = 4530,
  [4743] = 4702,
  [4744] = 4528,
  [4745] = 4523,
  [4746] = 4522,
  [4747] = 4583,
  [4748] = 4521,
  [4749] = 4517,
  [4750] = 4518,
  [4751] = 4518,
  [4752] = 4752,
  [4753] = 4529,
  [4754] = 4519,
  [4755] = 4755,
  [4756] = 4529,
  [4757] = 4532,
  [4758] = 4546,
  [4759] = 4759,
  [4760] = 4760,
  [4761] = 4520,
  [4762] = 4762,
  [4763] = 4591,
  [4764] = 4547,
  [4765] = 4532,
  [4766] = 4766,
  [4767] = 4549,
  [4768] = 4550,
  [4769] = 4529,
  [4770] = 4540,
  [4771] = 4537,
  [4772] = 4576,
  [4773] = 4552,
  [4774] = 4553,
  [4775] = 4554,
  [4776] = 4532,
  [4777] = 4777,
  [4778] = 4778,
  [4779] = 4555,
  [4780] = 4537,
  [4781] = 4512,
  [4782] = 4782,
  [4783] = 4601,
  [4784] = 4548,
  [4785] = 4556,
  [4786] = 4574,
  [4787] = 4534,
  [4788] = 4788,
  [4789] = 4789,
  [4790] = 4596,
  [4791] = 4645,
  [4792] = 4541,
  [4793] = 4793,
  [4794] = 4576,
  [4795] = 4556,
  [4796] = 4796,
  [4797] = 4548,
  [4798] = 4557,
  [4799] = 4558,
  [4800] = 4560,
  [4801] = 4579,
  [4802] = 4539,
  [4803] = 4648,
  [4804] = 4737,
  [4805] = 4529,
  [4806] = 4548,
  [4807] = 4556,
  [4808] = 4537,
  [4809] = 4672,
  [4810] = 1052,
  [4811] = 4532,
  [4812] = 4556,
  [4813] = 4529,
  [4814] = 4548,
  [4815] = 4518,
  [4816] = 4557,
  [4817] = 4558,
  [4818] = 4560,
  [4819] = 4579,
  [4820] = 4596,
  [4821] = 4648,
  [4822] = 4512,
  [4823] = 4823,
  [4824] = 4541,
  [4825] = 4579,
  [4826] = 4826,
  [4827] = 4556,
  [4828] = 4828,
  [4829] = 4548,
  [4830] = 4830,
  [4831] = 4557,
  [4832] = 4558,
  [4833] = 4560,
  [4834] = 4555,
  [4835] = 4554,
  [4836] = 4648,
  [4837] = 4553,
  [4838] = 4596,
  [4839] = 4648,
  [4840] = 4552,
  [4841] = 4648,
  [4842] = 4842,
  [4843] = 4843,
  [4844] = 4512,
  [4845] = 4538,
  [4846] = 4648,
  [4847] = 4823,
  [4848] = 4848,
  [4849] = 4513,
  [4850] = 4550,
  [4851] = 4851,
  [4852] = 4512,
  [4853] = 4823,
  [4854] = 4596,
  [4855] = 4855,
  [4856] = 4549,
  [4857] = 4857,
  [4858] = 4547,
  [4859] = 4579,
  [4860] = 4520,
  [4861] = 4546,
  [4862] = 4532,
  [4863] = 4519,
  [4864] = 4579,
  [4865] = 4538,
  [4866] = 4574,
  [4867] = 4752,
  [4868] = 4868,
  [4869] = 4690,
  [4870] = 4576,
  [4871] = 4574,
  [4872] = 4517,
  [4873] = 4521,
  [4874] = 4560,
  [4875] = 4519,
  [4876] = 4741,
  [4877] = 4588,
  [4878] = 4558,
  [4879] = 4642,
  [4880] = 4557,
  [4881] = 4522,
  [4882] = 4882,
  [4883] = 4523,
  [4884] = 4528,
  [4885] = 4885,
  [4886] = 4886,
  [4887] = 4541,
  [4888] = 4556,
  [4889] = 4530,
  [4890] = 4851,
  [4891] = 4548,
  [4892] = 4535,
  [4893] = 4648,
  [4894] = 4531,
  [4895] = 4533,
  [4896] = 4539,
  [4897] = 4542,
  [4898] = 4672,
  [4899] = 4899,
  [4900] = 4648,
  [4901] = 4901,
  [4902] = 4529,
  [4903] = 4518,
};

static inline bool anon_sym_BANG_character_set_1(int32_t c) {
  return (c < 8192
    ? (c < ' '
      ? (c < '\r'
        ? (c >= '\t' && c <= '\n')
        : c <= '\r')
      : (c <= ' ' || (c < 5760
        ? c == 160
        : c <= 5760)))
    : (c <= 8203 || (c < 12288
      ? (c < 8287
        ? c == 8239
        : c <= 8288)
      : (c <= 12288 || c == 65279))));
}

static inline bool sym__glimmer_template_content_character_set_1(int32_t c) {
  return (c < 8192
    ? (c < ' '
      ? (c < '\r'
        ? c == '\t'
        : c <= '\r')
      : (c <= ' ' || (c < 5760
        ? c == 160
        : c <= 5760)))
    : (c <= 8203 || (c < 12288
      ? (c < 8287
        ? c == 8239
        : c <= 8288)
      : (c <= 12288 || c == 65279))));
}

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : (c <= '`' || (c >= '{' && c <= '~')))))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : c <= '~')))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : (c <= '`' || (c >= '|' && c <= '~')))))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_private_property_identifier_character_set_1(int32_t c) {
  return (c < 160
    ? (c < '['
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '@')))
      : (c <= '^' || (c < '{'
        ? c == '`'
        : c <= '~')))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(104);
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(256);
      if (lookahead == '$') ADVANCE(243);
      if (lookahead == '%') ADVANCE(192);
      if (lookahead == '&') ADVANCE(174);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(107);
      if (lookahead == '+') ADVANCE(186);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(190);
      if (lookahead == '.') ADVANCE(143);
      if (lookahead == '/') ADVANCE(229);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(133);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(138);
      if (lookahead == '?') ADVANCE(249);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '^') ADVANCE(177);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(180);
      if (lookahead == '}') ADVANCE(112);
      if (lookahead == '~') ADVANCE(203);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(97)
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(244);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(1)
      if (lookahead == '/') ADVANCE(126);
      if (lookahead == '<') ADVANCE(128);
      if (sym__glimmer_template_content_character_set_1(lookahead)) ADVANCE(127);
      if (lookahead != 0) ADVANCE(125);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(32)
      if (lookahead == '/') ADVANCE(26);
      if (lookahead == '[') ADVANCE(39);
      if (lookahead == '\\') ADVANCE(96);
      if (sym__glimmer_template_content_character_set_1(lookahead)) ADVANCE(230);
      if (lookahead != 0) ADVANCE(231);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(255);
      if (lookahead == '%') ADVANCE(192);
      if (lookahead == '&') ADVANCE(174);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(107);
      if (lookahead == '+') ADVANCE(186);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(189);
      if (lookahead == '.') ADVANCE(143);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == '<') ADVANCE(133);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(138);
      if (lookahead == '?') ADVANCE(249);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '^') ADVANCE(177);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '|') ADVANCE(179);
      if (lookahead == '~') ADVANCE(203);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(3)
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != ';' &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(244);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(255);
      if (lookahead == '%') ADVANCE(192);
      if (lookahead == '&') ADVANCE(174);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(107);
      if (lookahead == '+') ADVANCE(186);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(189);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(132);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(138);
      if (lookahead == '?') ADVANCE(249);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '^') ADVANCE(177);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '|') ADVANCE(180);
      if (lookahead == '}') ADVANCE(112);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(4)
      if (lookahead != 0 &&
          lookahead > 31 &&
          (lookahead < '0' || '9' < lookahead) &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(255);
      if (lookahead == '%') ADVANCE(192);
      if (lookahead == '&') ADVANCE(174);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == '*') ADVANCE(107);
      if (lookahead == '+') ADVANCE(186);
      if (lookahead == '-') ADVANCE(189);
      if (lookahead == '.') ADVANCE(144);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(132);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(138);
      if (lookahead == '?') ADVANCE(249);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '^') ADVANCE(177);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(179);
      if (lookahead == '}') ADVANCE(112);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(5)
      if (lookahead != 0 &&
          lookahead > 31 &&
          (lookahead < ')' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(40);
      if (lookahead == '%') ADVANCE(192);
      if (lookahead == '&') ADVANCE(174);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(107);
      if (lookahead == '+') ADVANCE(186);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(189);
      if (lookahead == '.') ADVANCE(144);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(132);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(138);
      if (lookahead == '?') ADVANCE(249);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '^') ADVANCE(177);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(179);
      if (lookahead == '}') ADVANCE(112);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(6)
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != '@' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '%') ADVANCE(192);
      if (lookahead == '&') ADVANCE(174);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(107);
      if (lookahead == '+') ADVANCE(186);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(189);
      if (lookahead == '.') ADVANCE(143);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == '<') ADVANCE(133);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(138);
      if (lookahead == '?') ADVANCE(249);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '^') ADVANCE(177);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(179);
      if (lookahead == '~') ADVANCE(203);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(7)
      if (lookahead != 0 &&
          lookahead > '#' &&
          lookahead != ';' &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(244);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '%') ADVANCE(191);
      if (lookahead == '&') ADVANCE(175);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(108);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(144);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(135);
      if (lookahead == '=') ADVANCE(120);
      if (lookahead == '>') ADVANCE(139);
      if (lookahead == '?') ADVANCE(30);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '|') ADVANCE(181);
      if (lookahead == '}') ADVANCE(112);
      if (lookahead == '~') ADVANCE(203);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(8)
      if (lookahead != 0 &&
          lookahead > '#') ADVANCE(244);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '%') ADVANCE(191);
      if (lookahead == '&') ADVANCE(175);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == '*') ADVANCE(108);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(144);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(135);
      if (lookahead == '=') ADVANCE(35);
      if (lookahead == '>') ADVANCE(139);
      if (lookahead == '?') ADVANCE(250);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(181);
      if (lookahead == '}') ADVANCE(112);
      if (lookahead == '~') ADVANCE(203);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(9)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < ')' || ':' < lookahead) &&
          lookahead != ']') ADVANCE(244);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '%') ADVANCE(191);
      if (lookahead == '&') ADVANCE(175);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == '*') ADVANCE(108);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(144);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(134);
      if (lookahead == '=') ADVANCE(35);
      if (lookahead == '>') ADVANCE(139);
      if (lookahead == '?') ADVANCE(250);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(181);
      if (lookahead == '}') ADVANCE(112);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(11)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(232);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < ')' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '%') ADVANCE(191);
      if (lookahead == '&') ADVANCE(175);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == '*') ADVANCE(108);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(144);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(134);
      if (lookahead == '=') ADVANCE(35);
      if (lookahead == '>') ADVANCE(139);
      if (lookahead == '?') ADVANCE(250);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(181);
      if (lookahead == '}') ADVANCE(112);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(11)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < ')' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '%') ADVANCE(191);
      if (lookahead == '&') ADVANCE(175);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == '*') ADVANCE(108);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(144);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(134);
      if (lookahead == '=') ADVANCE(120);
      if (lookahead == '>') ADVANCE(139);
      if (lookahead == '?') ADVANCE(250);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(181);
      if (lookahead == '}') ADVANCE(112);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(12)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < ')' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '%') ADVANCE(191);
      if (lookahead == '&') ADVANCE(175);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(108);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(134);
      if (lookahead == '=') ADVANCE(35);
      if (lookahead == '>') ADVANCE(139);
      if (lookahead == '?') ADVANCE(30);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '|') ADVANCE(181);
      if (lookahead == '}') ADVANCE(112);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(14)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(232);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          (lookahead < '`' || '~' < lookahead)) ADVANCE(244);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '%') ADVANCE(191);
      if (lookahead == '&') ADVANCE(175);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(108);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(134);
      if (lookahead == '=') ADVANCE(35);
      if (lookahead == '>') ADVANCE(139);
      if (lookahead == '?') ADVANCE(30);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '|') ADVANCE(181);
      if (lookahead == '}') ADVANCE(112);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(14)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 15:
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '%') ADVANCE(191);
      if (lookahead == '&') ADVANCE(175);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(108);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(134);
      if (lookahead == '=') ADVANCE(120);
      if (lookahead == '>') ADVANCE(139);
      if (lookahead == '?') ADVANCE(250);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '|') ADVANCE(182);
      if (lookahead == '}') ADVANCE(112);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(15)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 16:
      if (lookahead == '!') ADVANCE(105);
      if (lookahead == '\\') ADVANCE(60);
      if (!sym_private_property_identifier_character_set_1(lookahead)) ADVANCE(245);
      END_STATE();
    case 17:
      if (lookahead == '!') ADVANCE(113);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '&') ADVANCE(173);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(106);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == '<') ADVANCE(136);
      if (lookahead == '?') ADVANCE(247);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(178);
      if (lookahead == '~') ADVANCE(203);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(17)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}') ADVANCE(244);
      END_STATE();
    case 18:
      if (lookahead == '!') ADVANCE(113);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '&') ADVANCE(173);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(144);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(136);
      if (lookahead == '=') ADVANCE(119);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '}') ADVANCE(112);
      if (lookahead == '~') ADVANCE(203);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(18)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '?' < lookahead) &&
          lookahead != ']' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(244);
      END_STATE();
    case 19:
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '/') ADVANCE(209);
      if (lookahead == '\\') ADVANCE(61);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(212);
      if (lookahead != 0) ADVANCE(213);
      END_STATE();
    case 20:
      if (lookahead == '#') ADVANCE(255);
      if (lookahead == '&') ADVANCE(173);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == '/') ADVANCE(26);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == '<') ADVANCE(131);
      if (lookahead == '=') ADVANCE(122);
      if (lookahead == '>') ADVANCE(137);
      if (lookahead == '?') ADVANCE(247);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '|') ADVANCE(178);
      if (lookahead == '}') ADVANCE(112);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(20)
      if (lookahead != 0 &&
          lookahead > '"' &&
          (lookahead < '%' || '@' < lookahead) &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 21:
      if (lookahead == '$') ADVANCE(62);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(38);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == '/') ADVANCE(26);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == '<') ADVANCE(131);
      if (lookahead == '?') ADVANCE(34);
      if (lookahead == '\\') ADVANCE(61);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(110);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(22)
      END_STATE();
    case 22:
      if (lookahead == '$') ADVANCE(62);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(38);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == '/') ADVANCE(26);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == '<') ADVANCE(131);
      if (lookahead == '?') ADVANCE(34);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(110);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(22)
      END_STATE();
    case 23:
      if (lookahead == '$') ADVANCE(62);
      if (lookahead == '/') ADVANCE(26);
      if (lookahead == '\\') ADVANCE(61);
      if (lookahead == '`') ADVANCE(41);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(24)
      END_STATE();
    case 24:
      if (lookahead == '$') ADVANCE(62);
      if (lookahead == '/') ADVANCE(26);
      if (lookahead == '`') ADVANCE(41);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(24)
      END_STATE();
    case 25:
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '\\') ADVANCE(61);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(218);
      if (lookahead != 0) ADVANCE(219);
      END_STATE();
    case 26:
      if (lookahead == '*') ADVANCE(28);
      if (lookahead == '/') ADVANCE(225);
      END_STATE();
    case 27:
      if (lookahead == '*') ADVANCE(27);
      if (lookahead == '/') ADVANCE(224);
      if (lookahead != 0) ADVANCE(28);
      END_STATE();
    case 28:
      if (lookahead == '*') ADVANCE(27);
      if (lookahead != 0) ADVANCE(28);
      END_STATE();
    case 29:
      if (lookahead == '.') ADVANCE(31);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(241);
      END_STATE();
    case 30:
      if (lookahead == '.') ADVANCE(146);
      if (lookahead == '?') ADVANCE(201);
      END_STATE();
    case 31:
      if (lookahead == '.') ADVANCE(162);
      END_STATE();
    case 32:
      if (lookahead == '/') ADVANCE(26);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(32)
      END_STATE();
    case 33:
      if (lookahead == ':') ADVANCE(251);
      END_STATE();
    case 34:
      if (lookahead == ':') ADVANCE(252);
      END_STATE();
    case 35:
      if (lookahead == '=') ADVANCE(196);
      END_STATE();
    case 36:
      if (lookahead == '>') ADVANCE(129);
      END_STATE();
    case 37:
      if (lookahead == '>') ADVANCE(130);
      END_STATE();
    case 38:
      if (lookahead == '?') ADVANCE(33);
      END_STATE();
    case 39:
      if (lookahead == '\\') ADVANCE(95);
      if (lookahead == ']') ADVANCE(231);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(39);
      END_STATE();
    case 40:
      if (lookahead == '\\') ADVANCE(60);
      if (!sym_private_property_identifier_character_set_1(lookahead)) ADVANCE(245);
      END_STATE();
    case 41:
      if (lookahead == '`') ADVANCE(42);
      END_STATE();
    case 42:
      if (lookahead == '`') ADVANCE(257);
      END_STATE();
    case 43:
      if (lookahead == 'a') ADVANCE(55);
      END_STATE();
    case 44:
      if (lookahead == 'a') ADVANCE(56);
      END_STATE();
    case 45:
      if (lookahead == 'e') ADVANCE(51);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(36);
      END_STATE();
    case 47:
      if (lookahead == 'e') ADVANCE(37);
      END_STATE();
    case 48:
      if (lookahead == 'e') ADVANCE(52);
      END_STATE();
    case 49:
      if (lookahead == 'l') ADVANCE(43);
      END_STATE();
    case 50:
      if (lookahead == 'l') ADVANCE(44);
      END_STATE();
    case 51:
      if (lookahead == 'm') ADVANCE(53);
      END_STATE();
    case 52:
      if (lookahead == 'm') ADVANCE(54);
      END_STATE();
    case 53:
      if (lookahead == 'p') ADVANCE(49);
      END_STATE();
    case 54:
      if (lookahead == 'p') ADVANCE(50);
      END_STATE();
    case 55:
      if (lookahead == 't') ADVANCE(46);
      END_STATE();
    case 56:
      if (lookahead == 't') ADVANCE(47);
      END_STATE();
    case 57:
      if (lookahead == 't') ADVANCE(48);
      END_STATE();
    case 58:
      if (lookahead == 'u') ADVANCE(63);
      if (lookahead == 'x') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(223);
      if (lookahead != 0) ADVANCE(220);
      END_STATE();
    case 59:
      if (lookahead == 'u') ADVANCE(64);
      END_STATE();
    case 60:
      if (lookahead == 'u') ADVANCE(65);
      END_STATE();
    case 61:
      if (lookahead == 'u') ADVANCE(66);
      if (lookahead == 'x') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(223);
      if (lookahead != 0) ADVANCE(220);
      END_STATE();
    case 62:
      if (lookahead == '{') ADVANCE(228);
      END_STATE();
    case 63:
      if (lookahead == '{') ADVANCE(81);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(92);
      END_STATE();
    case 64:
      if (lookahead == '{') ADVANCE(85);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(93);
      END_STATE();
    case 65:
      if (lookahead == '{') ADVANCE(86);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(94);
      END_STATE();
    case 66:
      if (lookahead == '{') ADVANCE(88);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(84);
      END_STATE();
    case 67:
      if (lookahead == '}') ADVANCE(244);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 68:
      if (lookahead == '}') ADVANCE(220);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(68);
      END_STATE();
    case 69:
      if (lookahead == '}') ADVANCE(221);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(69);
      END_STATE();
    case 70:
      if (lookahead == '}') ADVANCE(245);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(70);
      END_STATE();
    case 71:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(240);
      END_STATE();
    case 72:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(236);
      END_STATE();
    case 73:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(237);
      END_STATE();
    case 74:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(235);
      END_STATE();
    case 75:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(241);
      END_STATE();
    case 76:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(239);
      END_STATE();
    case 77:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(240);
      END_STATE();
    case 78:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(244);
      END_STATE();
    case 79:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(220);
      END_STATE();
    case 80:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(238);
      END_STATE();
    case 81:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(69);
      END_STATE();
    case 82:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(221);
      END_STATE();
    case 83:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(245);
      END_STATE();
    case 84:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(87);
      END_STATE();
    case 85:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 86:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(70);
      END_STATE();
    case 87:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(79);
      END_STATE();
    case 88:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(68);
      END_STATE();
    case 89:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(82);
      END_STATE();
    case 90:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(78);
      END_STATE();
    case 91:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(83);
      END_STATE();
    case 92:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(89);
      END_STATE();
    case 93:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(90);
      END_STATE();
    case 94:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(91);
      END_STATE();
    case 95:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(39);
      END_STATE();
    case 96:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(231);
      END_STATE();
    case 97:
      if (eof) ADVANCE(104);
      if (lookahead == '!') ADVANCE(114);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(256);
      if (lookahead == '$') ADVANCE(243);
      if (lookahead == '%') ADVANCE(192);
      if (lookahead == '&') ADVANCE(174);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(107);
      if (lookahead == '+') ADVANCE(186);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(190);
      if (lookahead == '.') ADVANCE(143);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(133);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(138);
      if (lookahead == '?') ADVANCE(249);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '^') ADVANCE(177);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(180);
      if (lookahead == '}') ADVANCE(112);
      if (lookahead == '~') ADVANCE(203);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(97)
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(244);
      END_STATE();
    case 98:
      if (eof) ADVANCE(104);
      if (lookahead == '!') ADVANCE(113);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(16);
      if (lookahead == '&') ADVANCE(173);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(106);
      if (lookahead == '+') ADVANCE(185);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(188);
      if (lookahead == '.') ADVANCE(143);
      if (lookahead == '/') ADVANCE(140);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(136);
      if (lookahead == '=') ADVANCE(122);
      if (lookahead == '>') ADVANCE(137);
      if (lookahead == '?') ADVANCE(247);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '|') ADVANCE(183);
      if (lookahead == '}') ADVANCE(112);
      if (lookahead == '~') ADVANCE(203);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(98)
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != '%' &&
          lookahead != '^') ADVANCE(244);
      END_STATE();
    case 99:
      if (eof) ADVANCE(104);
      if (lookahead == '!') ADVANCE(113);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(40);
      if (lookahead == '&') ADVANCE(173);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(106);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(187);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(26);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(131);
      if (lookahead == '=') ADVANCE(122);
      if (lookahead == '>') ADVANCE(137);
      if (lookahead == '?') ADVANCE(247);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '|') ADVANCE(183);
      if (lookahead == '}') ADVANCE(112);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(99)
      if (lookahead != 0 &&
          lookahead > 31 &&
          (lookahead < '%' || '+' < lookahead) &&
          lookahead != '^' &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 100:
      if (eof) ADVANCE(104);
      if (lookahead == '!') ADVANCE(113);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(40);
      if (lookahead == '&') ADVANCE(173);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == '*') ADVANCE(106);
      if (lookahead == '+') ADVANCE(184);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(187);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(229);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(131);
      if (lookahead == '=') ADVANCE(122);
      if (lookahead == '>') ADVANCE(137);
      if (lookahead == '?') ADVANCE(247);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(183);
      if (lookahead == '}') ADVANCE(112);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(101)
      if (lookahead != 0 &&
          lookahead > 31 &&
          (lookahead < '%' || ')' < lookahead) &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 101:
      if (eof) ADVANCE(104);
      if (lookahead == '!') ADVANCE(113);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(40);
      if (lookahead == '&') ADVANCE(173);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == '*') ADVANCE(106);
      if (lookahead == '+') ADVANCE(184);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(187);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(26);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(131);
      if (lookahead == '=') ADVANCE(122);
      if (lookahead == '>') ADVANCE(137);
      if (lookahead == '?') ADVANCE(247);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '`') ADVANCE(226);
      if (lookahead == '{') ADVANCE(110);
      if (lookahead == '|') ADVANCE(183);
      if (lookahead == '}') ADVANCE(112);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(101)
      if (lookahead != 0 &&
          lookahead > 31 &&
          (lookahead < '%' || ')' < lookahead) &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 102:
      if (eof) ADVANCE(104);
      if (lookahead == '"') ADVANCE(206);
      if (lookahead == '#') ADVANCE(40);
      if (lookahead == '&') ADVANCE(173);
      if (lookahead == '\'') ADVANCE(207);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == '*') ADVANCE(106);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '-') ADVANCE(187);
      if (lookahead == '.') ADVANCE(144);
      if (lookahead == '/') ADVANCE(26);
      if (lookahead == '0') ADVANCE(234);
      if (lookahead == '=') ADVANCE(119);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '}') ADVANCE(112);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(102)
      if (lookahead != 0 &&
          lookahead > '!' &&
          (lookahead < '%' || '?' < lookahead) &&
          lookahead != ']' &&
          lookahead != '^' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(244);
      END_STATE();
    case 103:
      if (eof) ADVANCE(104);
      if (lookahead == '#') ADVANCE(255);
      if (lookahead == '&') ADVANCE(173);
      if (lookahead == '(') ADVANCE(115);
      if (lookahead == ')') ADVANCE(116);
      if (lookahead == '*') ADVANCE(106);
      if (lookahead == ',') ADVANCE(111);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == '/') ADVANCE(26);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(131);
      if (lookahead == '=') ADVANCE(122);
      if (lookahead == '>') ADVANCE(137);
      if (lookahead == '?') ADVANCE(248);
      if (lookahead == '@') ADVANCE(246);
      if (lookahead == '[') ADVANCE(123);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == ']') ADVANCE(124);
      if (lookahead == '`') ADVANCE(227);
      if (lookahead == '{') ADVANCE(109);
      if (lookahead == '|') ADVANCE(183);
      if (lookahead == '}') ADVANCE(112);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(103)
      if (lookahead != 0 &&
          lookahead > '"' &&
          (lookahead < '%' || '9' < lookahead) &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(244);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(105);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(194);
      if (lookahead == '=') ADVANCE(149);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(193);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(253);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(198);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(196);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(196);
      if (lookahead == '>') ADVANCE(145);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(145);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '*') ADVANCE(28);
      if (lookahead == '/') ADVANCE(225);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '/') ADVANCE(126);
      if (lookahead == '<') ADVANCE(128);
      if (sym__glimmer_template_content_character_set_1(lookahead)) ADVANCE(127);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(125);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '/') ADVANCE(57);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_LTtemplate_GT);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_LT_SLASHtemplate_GT);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(172);
      if (lookahead == '=') ADVANCE(195);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(172);
      if (lookahead == '=') ADVANCE(195);
      if (lookahead == 't') ADVANCE(45);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(171);
      if (lookahead == '=') ADVANCE(195);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(171);
      if (lookahead == '=') ADVANCE(195);
      if (lookahead == 't') ADVANCE(45);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == 't') ADVANCE(45);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(200);
      if (lookahead == '>') ADVANCE(167);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(200);
      if (lookahead == '>') ADVANCE(168);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(28);
      if (lookahead == '/') ADVANCE(225);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(28);
      if (lookahead == '/') ADVANCE(225);
      if (lookahead == '=') ADVANCE(150);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(31);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(241);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(241);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_QMARK_DOT);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(159);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(160);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(155);
      if (lookahead == '>') ADVANCE(170);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(169);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(156);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(157);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(164);
      if (lookahead == '=') ADVANCE(153);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(163);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(152);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(154);
      if (lookahead == '|') ADVANCE(166);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(154);
      if (lookahead == '|') ADVANCE(166);
      if (lookahead == '}') ADVANCE(254);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(165);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(165);
      if (lookahead == '}') ADVANCE(254);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(254);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(204);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(204);
      if (lookahead == '=') ADVANCE(147);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(205);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(205);
      if (lookahead == '=') ADVANCE(148);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(205);
      if (lookahead == '=') ADVANCE(148);
      if (lookahead == '?') ADVANCE(33);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(151);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(158);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(197);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(199);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(161);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '\n') ADVANCE(213);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(208);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(211);
      if (lookahead == '/') ADVANCE(208);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(213);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(210);
      if (lookahead == '/') ADVANCE(213);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(211);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(210);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(211);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '/') ADVANCE(209);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(212);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(213);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(213);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(214);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(217);
      if (lookahead == '/') ADVANCE(214);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(219);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(216);
      if (lookahead == '/') ADVANCE(219);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(217);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(216);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(217);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '/') ADVANCE(215);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(218);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(219);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(219);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(59);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(244);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(220);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(222);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(225);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      if (lookahead == '`') ADVANCE(42);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(28);
      if (lookahead == '/') ADVANCE(225);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '\n') SKIP(32)
      if (lookahead == '/') ADVANCE(26);
      if (lookahead == '[') ADVANCE(39);
      if (lookahead == '\\') ADVANCE(96);
      if (sym__glimmer_template_content_character_set_1(lookahead)) ADVANCE(230);
      if (lookahead != 0) ADVANCE(231);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(39);
      if (lookahead == '\\') ADVANCE(96);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(231);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(59);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(232);
      if (!sym_identifier_character_set_2(lookahead)) ADVANCE(244);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(242);
      if (lookahead == '0') ADVANCE(239);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(72);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(73);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(80);
      if (lookahead == '_') ADVANCE(76);
      if (lookahead == 'n') ADVANCE(233);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(235);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(242);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (lookahead == '_') ADVANCE(74);
      if (lookahead == 'n') ADVANCE(233);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(235);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(72);
      if (lookahead == 'n') ADVANCE(233);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(236);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(73);
      if (lookahead == 'n') ADVANCE(233);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(237);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(80);
      if (lookahead == 'n') ADVANCE(233);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(238);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(76);
      if (lookahead == 'n') ADVANCE(233);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(239);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(240);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (lookahead == '_') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(241);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(241);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '{') ADVANCE(228);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(244);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(59);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(244);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_private_property_identifier);
      if (lookahead == '\\') ADVANCE(60);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(245);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(146);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(146);
      if (lookahead == '?') ADVANCE(202);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(146);
      if (lookahead == '?') ADVANCE(201);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_DASH_QMARK_COLON);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_QMARK_COLON);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == '!') ADVANCE(105);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_BQUOTE_BQUOTE_BQUOTE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'k') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8203) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 8288 ||
          lookahead == 12288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'v') ADVANCE(35);
      if (lookahead == 'x') ADVANCE(36);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(37);
      if (lookahead == 'i') ADVANCE(38);
      if (lookahead == 'n') ADVANCE(39);
      if (lookahead == 'o') ADVANCE(40);
      if (lookahead == 'r') ADVANCE(41);
      if (lookahead == 'u') ADVANCE(42);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(43);
      if (lookahead == 'l') ADVANCE(44);
      END_STATE();
    case 8:
      if (lookahead == 'd') ADVANCE(45);
      if (lookahead == 'f') ADVANCE(46);
      if (lookahead == 'm') ADVANCE(47);
      if (lookahead == 'n') ADVANCE(48);
      if (lookahead == 's') ADVANCE(49);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(50);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(51);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(52);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(53);
      if (lookahead == 'e') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(55);
      END_STATE();
    case 13:
      if (lookahead == 'b') ADVANCE(56);
      if (lookahead == 'f') ADVANCE(57);
      if (lookahead == 'n') ADVANCE(58);
      if (lookahead == 'v') ADVANCE(59);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(60);
      if (lookahead == 'u') ADVANCE(61);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(62);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(63);
      if (lookahead == 'e') ADVANCE(64);
      if (lookahead == 't') ADVANCE(65);
      if (lookahead == 'u') ADVANCE(66);
      if (lookahead == 'w') ADVANCE(67);
      if (lookahead == 'y') ADVANCE(68);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(69);
      if (lookahead == 'h') ADVANCE(70);
      if (lookahead == 'r') ADVANCE(71);
      if (lookahead == 'y') ADVANCE(72);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(73);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(74);
      if (lookahead == 'o') ADVANCE(75);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(76);
      if (lookahead == 'i') ADVANCE(77);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(78);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(79);
      END_STATE();
    case 23:
      if (lookahead == 'y') ADVANCE(80);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(81);
      if (lookahead == 'y') ADVANCE(82);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(83);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(84);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(85);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(86);
      if (lookahead == 't') ADVANCE(87);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(88);
      END_STATE();
    case 30:
      if (lookahead == 'm') ADVANCE(89);
      if (lookahead == 'n') ADVANCE(90);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(91);
      if (lookahead == 'c') ADVANCE(92);
      if (lookahead == 'f') ADVANCE(93);
      if (lookahead == 'l') ADVANCE(94);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(95);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(96);
      END_STATE();
    case 35:
      if (lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 36:
      if (lookahead == 'p') ADVANCE(98);
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 37:
      if (lookahead == 'l') ADVANCE(100);
      END_STATE();
    case 38:
      if (lookahead == 'n') ADVANCE(101);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_fn);
      END_STATE();
    case 40:
      if (lookahead == 'r') ADVANCE(102);
      END_STATE();
    case 41:
      if (lookahead == 'o') ADVANCE(103);
      END_STATE();
    case 42:
      if (lookahead == 'n') ADVANCE(104);
      END_STATE();
    case 43:
      if (lookahead == 't') ADVANCE(105);
      END_STATE();
    case 44:
      if (lookahead == 'o') ADVANCE(106);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_id);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 47:
      if (lookahead == 'p') ADVANCE(107);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'f') ADVANCE(108);
      if (lookahead == 's') ADVANCE(109);
      if (lookahead == 't') ADVANCE(110);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 50:
      if (lookahead == 'y') ADVANCE(111);
      END_STATE();
    case 51:
      if (lookahead == 't') ADVANCE(112);
      END_STATE();
    case 52:
      if (lookahead == 'd') ADVANCE(113);
      END_STATE();
    case 53:
      if (lookahead == 'm') ADVANCE(114);
      END_STATE();
    case 54:
      if (lookahead == 'v') ADVANCE(115);
      if (lookahead == 'w') ADVANCE(116);
      END_STATE();
    case 55:
      if (lookahead == 'l') ADVANCE(117);
      if (lookahead == 'm') ADVANCE(118);
      END_STATE();
    case 56:
      if (lookahead == 'j') ADVANCE(119);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_on);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(120);
      END_STATE();
    case 60:
      if (lookahead == 'i') ADVANCE(121);
      if (lookahead == 'o') ADVANCE(122);
      END_STATE();
    case 61:
      if (lookahead == 'b') ADVANCE(123);
      END_STATE();
    case 62:
      if (lookahead == 'a') ADVANCE(124);
      if (lookahead == 'q') ADVANCE(125);
      if (lookahead == 't') ADVANCE(126);
      END_STATE();
    case 63:
      if (lookahead == 't') ADVANCE(127);
      END_STATE();
    case 64:
      if (lookahead == 't') ADVANCE(128);
      END_STATE();
    case 65:
      if (lookahead == 'a') ADVANCE(129);
      if (lookahead == 'r') ADVANCE(130);
      END_STATE();
    case 66:
      if (lookahead == 'p') ADVANCE(131);
      END_STATE();
    case 67:
      if (lookahead == 'i') ADVANCE(132);
      END_STATE();
    case 68:
      if (lookahead == 'm') ADVANCE(133);
      END_STATE();
    case 69:
      if (lookahead == 'r') ADVANCE(134);
      END_STATE();
    case 70:
      if (lookahead == 'i') ADVANCE(135);
      if (lookahead == 'r') ADVANCE(136);
      END_STATE();
    case 71:
      if (lookahead == 'u') ADVANCE(137);
      if (lookahead == 'y') ADVANCE(138);
      END_STATE();
    case 72:
      if (lookahead == 'p') ADVANCE(139);
      END_STATE();
    case 73:
      if (lookahead == 'd') ADVANCE(140);
      if (lookahead == 'k') ADVANCE(141);
      END_STATE();
    case 74:
      if (lookahead == 'r') ADVANCE(142);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(143);
      END_STATE();
    case 76:
      if (lookahead == 'i') ADVANCE(144);
      END_STATE();
    case 77:
      if (lookahead == 't') ADVANCE(145);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(146);
      END_STATE();
    case 79:
      if (lookahead == 't') ADVANCE(147);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 81:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 82:
      if (lookahead == 'n') ADVANCE(149);
      END_STATE();
    case 83:
      if (lookahead == 'i') ADVANCE(150);
      END_STATE();
    case 84:
      if (lookahead == 'l') ADVANCE(151);
      END_STATE();
    case 85:
      if (lookahead == 'a') ADVANCE(152);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(153);
      END_STATE();
    case 87:
      if (lookahead == 'c') ADVANCE(154);
      END_STATE();
    case 88:
      if (lookahead == 's') ADVANCE(155);
      END_STATE();
    case 89:
      if (lookahead == 'p') ADVANCE(156);
      END_STATE();
    case 90:
      if (lookahead == 's') ADVANCE(157);
      if (lookahead == 't') ADVANCE(158);
      END_STATE();
    case 91:
      if (lookahead == 'u') ADVANCE(159);
      END_STATE();
    case 92:
      if (lookahead == 'l') ADVANCE(160);
      END_STATE();
    case 93:
      if (lookahead == 'a') ADVANCE(161);
      END_STATE();
    case 94:
      if (lookahead == 'e') ADVANCE(162);
      END_STATE();
    case 95:
      if (lookahead == 'e') ADVANCE(163);
      END_STATE();
    case 96:
      if (lookahead == 'm') ADVANCE(164);
      END_STATE();
    case 97:
      if (lookahead == 'n') ADVANCE(165);
      END_STATE();
    case 98:
      if (lookahead == 'o') ADVANCE(166);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(167);
      END_STATE();
    case 100:
      if (lookahead == 's') ADVANCE(168);
      END_STATE();
    case 101:
      if (lookahead == 'a') ADVANCE(169);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 103:
      if (lookahead == 'm') ADVANCE(170);
      END_STATE();
    case 104:
      if (lookahead == 'c') ADVANCE(171);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 106:
      if (lookahead == 'b') ADVANCE(172);
      END_STATE();
    case 107:
      if (lookahead == 'l') ADVANCE(173);
      if (lookahead == 'o') ADVANCE(174);
      END_STATE();
    case 108:
      if (lookahead == 'e') ADVANCE(175);
      END_STATE();
    case 109:
      if (lookahead == 't') ADVANCE(176);
      END_STATE();
    case 110:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 111:
      if (lookahead == 'o') ADVANCE(178);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 113:
      if (lookahead == 'u') ADVANCE(179);
      END_STATE();
    case 114:
      if (lookahead == 'e') ADVANCE(180);
      END_STATE();
    case 115:
      if (lookahead == 'e') ADVANCE(181);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 117:
      if (lookahead == 'l') ADVANCE(182);
      END_STATE();
    case 118:
      if (lookahead == 'b') ADVANCE(183);
      END_STATE();
    case 119:
      if (lookahead == 'e') ADVANCE(184);
      END_STATE();
    case 120:
      if (lookahead == 'r') ADVANCE(185);
      END_STATE();
    case 121:
      if (lookahead == 'v') ADVANCE(186);
      END_STATE();
    case 122:
      if (lookahead == 'p') ADVANCE(187);
      if (lookahead == 't') ADVANCE(188);
      END_STATE();
    case 123:
      if (lookahead == 'l') ADVANCE(189);
      END_STATE();
    case 124:
      if (lookahead == 'd') ADVANCE(190);
      END_STATE();
    case 125:
      if (lookahead == 'u') ADVANCE(191);
      END_STATE();
    case 126:
      if (lookahead == 'u') ADVANCE(192);
      END_STATE();
    case 127:
      if (lookahead == 'i') ADVANCE(193);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 129:
      if (lookahead == 't') ADVANCE(194);
      END_STATE();
    case 130:
      if (lookahead == 'i') ADVANCE(195);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(196);
      END_STATE();
    case 132:
      if (lookahead == 't') ADVANCE(197);
      END_STATE();
    case 133:
      if (lookahead == 'b') ADVANCE(198);
      END_STATE();
    case 134:
      if (lookahead == 'g') ADVANCE(199);
      END_STATE();
    case 135:
      if (lookahead == 's') ADVANCE(200);
      END_STATE();
    case 136:
      if (lookahead == 'o') ADVANCE(201);
      END_STATE();
    case 137:
      if (lookahead == 'e') ADVANCE(202);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 139:
      if (lookahead == 'e') ADVANCE(203);
      END_STATE();
    case 140:
      if (lookahead == 'e') ADVANCE(204);
      END_STATE();
    case 141:
      if (lookahead == 'n') ADVANCE(205);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 143:
      if (lookahead == 'd') ADVANCE(206);
      END_STATE();
    case 144:
      if (lookahead == 'l') ADVANCE(207);
      END_STATE();
    case 145:
      if (lookahead == 'h') ADVANCE(208);
      END_STATE();
    case 146:
      if (lookahead == 'l') ADVANCE(209);
      END_STATE();
    case 147:
      if (lookahead == 'r') ADVANCE(210);
      END_STATE();
    case 148:
      if (lookahead == 'r') ADVANCE(211);
      END_STATE();
    case 149:
      if (lookahead == 'c') ADVANCE(212);
      END_STATE();
    case 150:
      if (lookahead == 't') ADVANCE(213);
      END_STATE();
    case 151:
      if (lookahead == 'e') ADVANCE(214);
      END_STATE();
    case 152:
      if (lookahead == 'k') ADVANCE(215);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 154:
      if (lookahead == 'h') ADVANCE(216);
      END_STATE();
    case 155:
      if (lookahead == 's') ADVANCE(217);
      END_STATE();
    case 156:
      if (lookahead == 'o') ADVANCE(218);
      END_STATE();
    case 157:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 158:
      if (lookahead == 'i') ADVANCE(220);
      END_STATE();
    case 159:
      if (lookahead == 'g') ADVANCE(221);
      END_STATE();
    case 160:
      if (lookahead == 'a') ADVANCE(222);
      END_STATE();
    case 161:
      if (lookahead == 'u') ADVANCE(223);
      END_STATE();
    case 162:
      if (lookahead == 't') ADVANCE(224);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 165:
      if (lookahead == 't') ADVANCE(225);
      END_STATE();
    case 166:
      if (lookahead == 'r') ADVANCE(226);
      END_STATE();
    case 167:
      if (lookahead == 'n') ADVANCE(227);
      END_STATE();
    case 168:
      if (lookahead == 'e') ADVANCE(228);
      END_STATE();
    case 169:
      if (lookahead == 'l') ADVANCE(229);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 171:
      if (lookahead == 't') ADVANCE(230);
      END_STATE();
    case 172:
      if (lookahead == 'a') ADVANCE(231);
      END_STATE();
    case 173:
      if (lookahead == 'e') ADVANCE(232);
      END_STATE();
    case 174:
      if (lookahead == 'r') ADVANCE(233);
      END_STATE();
    case 175:
      if (lookahead == 'r') ADVANCE(234);
      END_STATE();
    case 176:
      if (lookahead == 'a') ADVANCE(235);
      END_STATE();
    case 177:
      if (lookahead == 'r') ADVANCE(236);
      END_STATE();
    case 178:
      if (lookahead == 'f') ADVANCE(237);
      END_STATE();
    case 179:
      if (lookahead == 'l') ADVANCE(238);
      END_STATE();
    case 180:
      if (lookahead == 's') ADVANCE(239);
      END_STATE();
    case 181:
      if (lookahead == 'r') ADVANCE(240);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 183:
      if (lookahead == 'e') ADVANCE(241);
      END_STATE();
    case 184:
      if (lookahead == 'c') ADVANCE(242);
      END_STATE();
    case 185:
      if (lookahead == 'r') ADVANCE(243);
      END_STATE();
    case 186:
      if (lookahead == 'a') ADVANCE(244);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_prop);
      END_STATE();
    case 188:
      if (lookahead == 'e') ADVANCE(245);
      END_STATE();
    case 189:
      if (lookahead == 'i') ADVANCE(246);
      END_STATE();
    case 190:
      if (lookahead == 'o') ADVANCE(247);
      END_STATE();
    case 191:
      if (lookahead == 'i') ADVANCE(248);
      END_STATE();
    case 192:
      if (lookahead == 'r') ADVANCE(249);
      END_STATE();
    case 193:
      if (lookahead == 's') ADVANCE(250);
      END_STATE();
    case 194:
      if (lookahead == 'i') ADVANCE(251);
      END_STATE();
    case 195:
      if (lookahead == 'n') ADVANCE(252);
      END_STATE();
    case 196:
      if (lookahead == 'r') ADVANCE(253);
      END_STATE();
    case 197:
      if (lookahead == 'c') ADVANCE(254);
      END_STATE();
    case 198:
      if (lookahead == 'o') ADVANCE(255);
      END_STATE();
    case 199:
      if (lookahead == 'e') ADVANCE(256);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 201:
      if (lookahead == 'w') ADVANCE(257);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(258);
      END_STATE();
    case 204:
      if (lookahead == 'f') ADVANCE(259);
      END_STATE();
    case 205:
      if (lookahead == 'o') ADVANCE(260);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 207:
      if (lookahead == 'e') ADVANCE(261);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 209:
      if (lookahead == 'd') ADVANCE(262);
      END_STATE();
    case 210:
      if (lookahead == 'a') ADVANCE(263);
      END_STATE();
    case 211:
      if (lookahead == 't') ADVANCE(264);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 214:
      if (lookahead == 'a') ADVANCE(265);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 218:
      if (lookahead == 'n') ADVANCE(266);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_const);
      if (lookahead == 'r') ADVANCE(267);
      END_STATE();
    case 220:
      if (lookahead == 'n') ADVANCE(268);
      END_STATE();
    case 221:
      if (lookahead == 'g') ADVANCE(269);
      END_STATE();
    case 222:
      if (lookahead == 'r') ADVANCE(270);
      END_STATE();
    case 223:
      if (lookahead == 'l') ADVANCE(271);
      END_STATE();
    case 224:
      if (lookahead == 'e') ADVANCE(272);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_event);
      END_STATE();
    case 226:
      if (lookahead == 't') ADVANCE(273);
      END_STATE();
    case 227:
      if (lookahead == 'd') ADVANCE(274);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 229:
      if (lookahead == 'l') ADVANCE(275);
      END_STATE();
    case 230:
      if (lookahead == 'i') ADVANCE(276);
      END_STATE();
    case 231:
      if (lookahead == 'l') ADVANCE(277);
      END_STATE();
    case 232:
      if (lookahead == 'm') ADVANCE(278);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(279);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_infer);
      END_STATE();
    case 235:
      if (lookahead == 'n') ADVANCE(280);
      END_STATE();
    case 236:
      if (lookahead == 'f') ADVANCE(281);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 238:
      if (lookahead == 'e') ADVANCE(282);
      END_STATE();
    case 239:
      if (lookahead == 'p') ADVANCE(283);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_never);
      END_STATE();
    case 241:
      if (lookahead == 'r') ADVANCE(284);
      END_STATE();
    case 242:
      if (lookahead == 't') ADVANCE(285);
      END_STATE();
    case 243:
      if (lookahead == 'i') ADVANCE(286);
      END_STATE();
    case 244:
      if (lookahead == 't') ADVANCE(287);
      END_STATE();
    case 245:
      if (lookahead == 'c') ADVANCE(288);
      END_STATE();
    case 246:
      if (lookahead == 'c') ADVANCE(289);
      END_STATE();
    case 247:
      if (lookahead == 'n') ADVANCE(290);
      END_STATE();
    case 248:
      if (lookahead == 'r') ADVANCE(291);
      END_STATE();
    case 249:
      if (lookahead == 'n') ADVANCE(292);
      END_STATE();
    case 250:
      if (lookahead == 'f') ADVANCE(293);
      END_STATE();
    case 251:
      if (lookahead == 'c') ADVANCE(294);
      END_STATE();
    case 252:
      if (lookahead == 'g') ADVANCE(295);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 254:
      if (lookahead == 'h') ADVANCE(296);
      END_STATE();
    case 255:
      if (lookahead == 'l') ADVANCE(297);
      END_STATE();
    case 256:
      if (lookahead == 't') ADVANCE(298);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 258:
      if (lookahead == 'f') ADVANCE(299);
      END_STATE();
    case 259:
      if (lookahead == 'i') ADVANCE(300);
      END_STATE();
    case 260:
      if (lookahead == 'w') ADVANCE(301);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 263:
      if (lookahead == 'c') ADVANCE(302);
      END_STATE();
    case 264:
      if (lookahead == 's') ADVANCE(303);
      END_STATE();
    case 265:
      if (lookahead == 'n') ADVANCE(304);
      END_STATE();
    case 266:
      if (lookahead == 'e') ADVANCE(305);
      END_STATE();
    case 267:
      if (lookahead == 'u') ADVANCE(306);
      END_STATE();
    case 268:
      if (lookahead == 'u') ADVANCE(307);
      END_STATE();
    case 269:
      if (lookahead == 'e') ADVANCE(308);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(309);
      END_STATE();
    case 271:
      if (lookahead == 't') ADVANCE(310);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 274:
      if (lookahead == 's') ADVANCE(311);
      END_STATE();
    case 275:
      if (lookahead == 'y') ADVANCE(312);
      END_STATE();
    case 276:
      if (lookahead == 'o') ADVANCE(313);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 278:
      if (lookahead == 'e') ADVANCE(314);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 280:
      if (lookahead == 'c') ADVANCE(315);
      END_STATE();
    case 281:
      if (lookahead == 'a') ADVANCE(316);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 283:
      if (lookahead == 'a') ADVANCE(317);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_object);
      END_STATE();
    case 286:
      if (lookahead == 'd') ADVANCE(318);
      END_STATE();
    case 287:
      if (lookahead == 'e') ADVANCE(319);
      END_STATE();
    case 288:
      if (lookahead == 't') ADVANCE(320);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 290:
      if (lookahead == 'l') ADVANCE(321);
      END_STATE();
    case 291:
      if (lookahead == 'e') ADVANCE(322);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 293:
      if (lookahead == 'i') ADVANCE(323);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 300:
      if (lookahead == 'n') ADVANCE(324);
      END_STATE();
    case 301:
      if (lookahead == 'n') ADVANCE(325);
      END_STATE();
    case 302:
      if (lookahead == 't') ADVANCE(326);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_asserts);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 305:
      if (lookahead == 'n') ADVANCE(327);
      END_STATE();
    case 306:
      if (lookahead == 'c') ADVANCE(328);
      END_STATE();
    case 307:
      if (lookahead == 'e') ADVANCE(329);
      END_STATE();
    case 308:
      if (lookahead == 'r') ADVANCE(330);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 313:
      if (lookahead == 'n') ADVANCE(331);
      END_STATE();
    case 314:
      if (lookahead == 'n') ADVANCE(332);
      END_STATE();
    case 315:
      if (lookahead == 'e') ADVANCE(333);
      END_STATE();
    case 316:
      if (lookahead == 'c') ADVANCE(334);
      END_STATE();
    case 317:
      if (lookahead == 'c') ADVANCE(335);
      END_STATE();
    case 318:
      if (lookahead == 'e') ADVANCE(336);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 320:
      if (lookahead == 'e') ADVANCE(337);
      END_STATE();
    case 321:
      if (lookahead == 'y') ADVANCE(338);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 323:
      if (lookahead == 'e') ADVANCE(339);
      END_STATE();
    case 324:
      if (lookahead == 'e') ADVANCE(340);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(anon_sym_unknown);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 327:
      if (lookahead == 't') ADVANCE(341);
      END_STATE();
    case 328:
      if (lookahead == 't') ADVANCE(342);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 332:
      if (lookahead == 't') ADVANCE(343);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(anon_sym_instance);
      if (lookahead == 'o') ADVANCE(344);
      END_STATE();
    case 334:
      if (lookahead == 'e') ADVANCE(345);
      END_STATE();
    case 335:
      if (lookahead == 'e') ADVANCE(346);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 337:
      if (lookahead == 'd') ADVANCE(347);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 339:
      if (lookahead == 's') ADVANCE(348);
      END_STATE();
    case 340:
      if (lookahead == 'd') ADVANCE(349);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(anon_sym_component);
      END_STATE();
    case 342:
      if (lookahead == 'o') ADVANCE(350);
      END_STATE();
    case 343:
      if (lookahead == 's') ADVANCE(351);
      END_STATE();
    case 344:
      if (lookahead == 'f') ADVANCE(352);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(anon_sym_satisfies);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 350:
      if (lookahead == 'r') ADVANCE(353);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(anon_sym_constructor);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 98},
  [2] = {.lex_state = 7, .external_lex_state = 2},
  [3] = {.lex_state = 7, .external_lex_state = 2},
  [4] = {.lex_state = 98},
  [5] = {.lex_state = 98},
  [6] = {.lex_state = 98},
  [7] = {.lex_state = 98},
  [8] = {.lex_state = 98},
  [9] = {.lex_state = 98},
  [10] = {.lex_state = 98},
  [11] = {.lex_state = 98},
  [12] = {.lex_state = 98},
  [13] = {.lex_state = 98},
  [14] = {.lex_state = 98},
  [15] = {.lex_state = 98},
  [16] = {.lex_state = 98},
  [17] = {.lex_state = 98},
  [18] = {.lex_state = 98},
  [19] = {.lex_state = 98},
  [20] = {.lex_state = 98},
  [21] = {.lex_state = 98},
  [22] = {.lex_state = 98},
  [23] = {.lex_state = 98},
  [24] = {.lex_state = 98},
  [25] = {.lex_state = 98},
  [26] = {.lex_state = 98},
  [27] = {.lex_state = 98},
  [28] = {.lex_state = 98},
  [29] = {.lex_state = 98},
  [30] = {.lex_state = 98},
  [31] = {.lex_state = 98},
  [32] = {.lex_state = 98},
  [33] = {.lex_state = 98},
  [34] = {.lex_state = 98},
  [35] = {.lex_state = 98},
  [36] = {.lex_state = 98},
  [37] = {.lex_state = 98},
  [38] = {.lex_state = 98},
  [39] = {.lex_state = 98},
  [40] = {.lex_state = 98},
  [41] = {.lex_state = 98},
  [42] = {.lex_state = 98},
  [43] = {.lex_state = 98},
  [44] = {.lex_state = 98},
  [45] = {.lex_state = 98},
  [46] = {.lex_state = 98},
  [47] = {.lex_state = 98},
  [48] = {.lex_state = 98},
  [49] = {.lex_state = 98},
  [50] = {.lex_state = 98},
  [51] = {.lex_state = 98},
  [52] = {.lex_state = 98},
  [53] = {.lex_state = 98},
  [54] = {.lex_state = 98},
  [55] = {.lex_state = 3, .external_lex_state = 2},
  [56] = {.lex_state = 3, .external_lex_state = 2},
  [57] = {.lex_state = 3, .external_lex_state = 2},
  [58] = {.lex_state = 3, .external_lex_state = 2},
  [59] = {.lex_state = 3, .external_lex_state = 2},
  [60] = {.lex_state = 3, .external_lex_state = 2},
  [61] = {.lex_state = 3, .external_lex_state = 2},
  [62] = {.lex_state = 3, .external_lex_state = 2},
  [63] = {.lex_state = 17},
  [64] = {.lex_state = 17},
  [65] = {.lex_state = 17},
  [66] = {.lex_state = 17},
  [67] = {.lex_state = 17},
  [68] = {.lex_state = 17},
  [69] = {.lex_state = 17},
  [70] = {.lex_state = 17},
  [71] = {.lex_state = 17},
  [72] = {.lex_state = 17},
  [73] = {.lex_state = 17},
  [74] = {.lex_state = 17},
  [75] = {.lex_state = 17},
  [76] = {.lex_state = 17},
  [77] = {.lex_state = 17},
  [78] = {.lex_state = 9, .external_lex_state = 2},
  [79] = {.lex_state = 9, .external_lex_state = 2},
  [80] = {.lex_state = 17},
  [81] = {.lex_state = 17},
  [82] = {.lex_state = 17},
  [83] = {.lex_state = 17},
  [84] = {.lex_state = 17},
  [85] = {.lex_state = 8, .external_lex_state = 3},
  [86] = {.lex_state = 8, .external_lex_state = 2},
  [87] = {.lex_state = 8, .external_lex_state = 3},
  [88] = {.lex_state = 8, .external_lex_state = 2},
  [89] = {.lex_state = 8, .external_lex_state = 2},
  [90] = {.lex_state = 8, .external_lex_state = 2},
  [91] = {.lex_state = 98},
  [92] = {.lex_state = 98},
  [93] = {.lex_state = 98},
  [94] = {.lex_state = 98},
  [95] = {.lex_state = 98},
  [96] = {.lex_state = 98},
  [97] = {.lex_state = 98},
  [98] = {.lex_state = 98},
  [99] = {.lex_state = 98},
  [100] = {.lex_state = 98},
  [101] = {.lex_state = 98},
  [102] = {.lex_state = 98},
  [103] = {.lex_state = 98},
  [104] = {.lex_state = 98},
  [105] = {.lex_state = 6, .external_lex_state = 2},
  [106] = {.lex_state = 98},
  [107] = {.lex_state = 98},
  [108] = {.lex_state = 98},
  [109] = {.lex_state = 98},
  [110] = {.lex_state = 98},
  [111] = {.lex_state = 98},
  [112] = {.lex_state = 98},
  [113] = {.lex_state = 98},
  [114] = {.lex_state = 98},
  [115] = {.lex_state = 6, .external_lex_state = 2},
  [116] = {.lex_state = 98},
  [117] = {.lex_state = 6, .external_lex_state = 2},
  [118] = {.lex_state = 98},
  [119] = {.lex_state = 6, .external_lex_state = 2},
  [120] = {.lex_state = 6, .external_lex_state = 2},
  [121] = {.lex_state = 6, .external_lex_state = 2},
  [122] = {.lex_state = 98},
  [123] = {.lex_state = 98},
  [124] = {.lex_state = 98},
  [125] = {.lex_state = 98},
  [126] = {.lex_state = 98, .external_lex_state = 4},
  [127] = {.lex_state = 98},
  [128] = {.lex_state = 98},
  [129] = {.lex_state = 98},
  [130] = {.lex_state = 98},
  [131] = {.lex_state = 98},
  [132] = {.lex_state = 98},
  [133] = {.lex_state = 98},
  [134] = {.lex_state = 98},
  [135] = {.lex_state = 98},
  [136] = {.lex_state = 98},
  [137] = {.lex_state = 98},
  [138] = {.lex_state = 98},
  [139] = {.lex_state = 98},
  [140] = {.lex_state = 98},
  [141] = {.lex_state = 98},
  [142] = {.lex_state = 98},
  [143] = {.lex_state = 98},
  [144] = {.lex_state = 98},
  [145] = {.lex_state = 98},
  [146] = {.lex_state = 98},
  [147] = {.lex_state = 98},
  [148] = {.lex_state = 98},
  [149] = {.lex_state = 6, .external_lex_state = 2},
  [150] = {.lex_state = 98},
  [151] = {.lex_state = 98},
  [152] = {.lex_state = 98},
  [153] = {.lex_state = 98},
  [154] = {.lex_state = 98, .external_lex_state = 4},
  [155] = {.lex_state = 6, .external_lex_state = 2},
  [156] = {.lex_state = 98},
  [157] = {.lex_state = 98},
  [158] = {.lex_state = 98},
  [159] = {.lex_state = 98},
  [160] = {.lex_state = 98},
  [161] = {.lex_state = 98},
  [162] = {.lex_state = 8, .external_lex_state = 3},
  [163] = {.lex_state = 98},
  [164] = {.lex_state = 98},
  [165] = {.lex_state = 98},
  [166] = {.lex_state = 98},
  [167] = {.lex_state = 98},
  [168] = {.lex_state = 8, .external_lex_state = 3},
  [169] = {.lex_state = 8, .external_lex_state = 3},
  [170] = {.lex_state = 8, .external_lex_state = 3},
  [171] = {.lex_state = 8, .external_lex_state = 3},
  [172] = {.lex_state = 8, .external_lex_state = 3},
  [173] = {.lex_state = 8, .external_lex_state = 3},
  [174] = {.lex_state = 8, .external_lex_state = 3},
  [175] = {.lex_state = 8, .external_lex_state = 3},
  [176] = {.lex_state = 8, .external_lex_state = 3},
  [177] = {.lex_state = 8, .external_lex_state = 3},
  [178] = {.lex_state = 8, .external_lex_state = 3},
  [179] = {.lex_state = 6, .external_lex_state = 2},
  [180] = {.lex_state = 8, .external_lex_state = 3},
  [181] = {.lex_state = 8, .external_lex_state = 3},
  [182] = {.lex_state = 8, .external_lex_state = 3},
  [183] = {.lex_state = 8, .external_lex_state = 3},
  [184] = {.lex_state = 8, .external_lex_state = 3},
  [185] = {.lex_state = 98},
  [186] = {.lex_state = 98},
  [187] = {.lex_state = 8, .external_lex_state = 3},
  [188] = {.lex_state = 98},
  [189] = {.lex_state = 98},
  [190] = {.lex_state = 98},
  [191] = {.lex_state = 98},
  [192] = {.lex_state = 98},
  [193] = {.lex_state = 8, .external_lex_state = 3},
  [194] = {.lex_state = 8, .external_lex_state = 3},
  [195] = {.lex_state = 8, .external_lex_state = 3},
  [196] = {.lex_state = 8, .external_lex_state = 3},
  [197] = {.lex_state = 8, .external_lex_state = 3},
  [198] = {.lex_state = 8, .external_lex_state = 3},
  [199] = {.lex_state = 98},
  [200] = {.lex_state = 8, .external_lex_state = 3},
  [201] = {.lex_state = 8, .external_lex_state = 3},
  [202] = {.lex_state = 8, .external_lex_state = 3},
  [203] = {.lex_state = 8, .external_lex_state = 3},
  [204] = {.lex_state = 8, .external_lex_state = 3},
  [205] = {.lex_state = 8, .external_lex_state = 3},
  [206] = {.lex_state = 6, .external_lex_state = 2},
  [207] = {.lex_state = 8, .external_lex_state = 3},
  [208] = {.lex_state = 98},
  [209] = {.lex_state = 8, .external_lex_state = 3},
  [210] = {.lex_state = 98},
  [211] = {.lex_state = 98},
  [212] = {.lex_state = 8, .external_lex_state = 3},
  [213] = {.lex_state = 98},
  [214] = {.lex_state = 8, .external_lex_state = 3},
  [215] = {.lex_state = 8, .external_lex_state = 3},
  [216] = {.lex_state = 8, .external_lex_state = 3},
  [217] = {.lex_state = 8, .external_lex_state = 3},
  [218] = {.lex_state = 8, .external_lex_state = 3},
  [219] = {.lex_state = 8, .external_lex_state = 3},
  [220] = {.lex_state = 98},
  [221] = {.lex_state = 98},
  [222] = {.lex_state = 8, .external_lex_state = 3},
  [223] = {.lex_state = 8, .external_lex_state = 3},
  [224] = {.lex_state = 98},
  [225] = {.lex_state = 98},
  [226] = {.lex_state = 98},
  [227] = {.lex_state = 98},
  [228] = {.lex_state = 98},
  [229] = {.lex_state = 98},
  [230] = {.lex_state = 98},
  [231] = {.lex_state = 98},
  [232] = {.lex_state = 98},
  [233] = {.lex_state = 18},
  [234] = {.lex_state = 98},
  [235] = {.lex_state = 98},
  [236] = {.lex_state = 18},
  [237] = {.lex_state = 98},
  [238] = {.lex_state = 98},
  [239] = {.lex_state = 98},
  [240] = {.lex_state = 98},
  [241] = {.lex_state = 18},
  [242] = {.lex_state = 98},
  [243] = {.lex_state = 18},
  [244] = {.lex_state = 98},
  [245] = {.lex_state = 98},
  [246] = {.lex_state = 98},
  [247] = {.lex_state = 18},
  [248] = {.lex_state = 98},
  [249] = {.lex_state = 98},
  [250] = {.lex_state = 98},
  [251] = {.lex_state = 18},
  [252] = {.lex_state = 98},
  [253] = {.lex_state = 98},
  [254] = {.lex_state = 18},
  [255] = {.lex_state = 98},
  [256] = {.lex_state = 98},
  [257] = {.lex_state = 98},
  [258] = {.lex_state = 98},
  [259] = {.lex_state = 98},
  [260] = {.lex_state = 98},
  [261] = {.lex_state = 18},
  [262] = {.lex_state = 98},
  [263] = {.lex_state = 98},
  [264] = {.lex_state = 98},
  [265] = {.lex_state = 18},
  [266] = {.lex_state = 98},
  [267] = {.lex_state = 98},
  [268] = {.lex_state = 98},
  [269] = {.lex_state = 98},
  [270] = {.lex_state = 98},
  [271] = {.lex_state = 98},
  [272] = {.lex_state = 98},
  [273] = {.lex_state = 98},
  [274] = {.lex_state = 98},
  [275] = {.lex_state = 98},
  [276] = {.lex_state = 98},
  [277] = {.lex_state = 98},
  [278] = {.lex_state = 98},
  [279] = {.lex_state = 98},
  [280] = {.lex_state = 98},
  [281] = {.lex_state = 98},
  [282] = {.lex_state = 18},
  [283] = {.lex_state = 98},
  [284] = {.lex_state = 98},
  [285] = {.lex_state = 98},
  [286] = {.lex_state = 98},
  [287] = {.lex_state = 98},
  [288] = {.lex_state = 98},
  [289] = {.lex_state = 98},
  [290] = {.lex_state = 98},
  [291] = {.lex_state = 98},
  [292] = {.lex_state = 98},
  [293] = {.lex_state = 18},
  [294] = {.lex_state = 18},
  [295] = {.lex_state = 18},
  [296] = {.lex_state = 98},
  [297] = {.lex_state = 98},
  [298] = {.lex_state = 98},
  [299] = {.lex_state = 18},
  [300] = {.lex_state = 98},
  [301] = {.lex_state = 98},
  [302] = {.lex_state = 98},
  [303] = {.lex_state = 98},
  [304] = {.lex_state = 98},
  [305] = {.lex_state = 98},
  [306] = {.lex_state = 98},
  [307] = {.lex_state = 98},
  [308] = {.lex_state = 98},
  [309] = {.lex_state = 98},
  [310] = {.lex_state = 98},
  [311] = {.lex_state = 98},
  [312] = {.lex_state = 98},
  [313] = {.lex_state = 98},
  [314] = {.lex_state = 98},
  [315] = {.lex_state = 98},
  [316] = {.lex_state = 98},
  [317] = {.lex_state = 98},
  [318] = {.lex_state = 98},
  [319] = {.lex_state = 98},
  [320] = {.lex_state = 98},
  [321] = {.lex_state = 98},
  [322] = {.lex_state = 98},
  [323] = {.lex_state = 98},
  [324] = {.lex_state = 98},
  [325] = {.lex_state = 98},
  [326] = {.lex_state = 98},
  [327] = {.lex_state = 98},
  [328] = {.lex_state = 98},
  [329] = {.lex_state = 98},
  [330] = {.lex_state = 98},
  [331] = {.lex_state = 98},
  [332] = {.lex_state = 98},
  [333] = {.lex_state = 98},
  [334] = {.lex_state = 98},
  [335] = {.lex_state = 98},
  [336] = {.lex_state = 98},
  [337] = {.lex_state = 98},
  [338] = {.lex_state = 98},
  [339] = {.lex_state = 98},
  [340] = {.lex_state = 98},
  [341] = {.lex_state = 98},
  [342] = {.lex_state = 98},
  [343] = {.lex_state = 98},
  [344] = {.lex_state = 98},
  [345] = {.lex_state = 98},
  [346] = {.lex_state = 98},
  [347] = {.lex_state = 98},
  [348] = {.lex_state = 98},
  [349] = {.lex_state = 98},
  [350] = {.lex_state = 98},
  [351] = {.lex_state = 98},
  [352] = {.lex_state = 98},
  [353] = {.lex_state = 98},
  [354] = {.lex_state = 98},
  [355] = {.lex_state = 98},
  [356] = {.lex_state = 98},
  [357] = {.lex_state = 98},
  [358] = {.lex_state = 98},
  [359] = {.lex_state = 98},
  [360] = {.lex_state = 98},
  [361] = {.lex_state = 98},
  [362] = {.lex_state = 98},
  [363] = {.lex_state = 98},
  [364] = {.lex_state = 98},
  [365] = {.lex_state = 98},
  [366] = {.lex_state = 98},
  [367] = {.lex_state = 98},
  [368] = {.lex_state = 98},
  [369] = {.lex_state = 98},
  [370] = {.lex_state = 98},
  [371] = {.lex_state = 98},
  [372] = {.lex_state = 98},
  [373] = {.lex_state = 98},
  [374] = {.lex_state = 98},
  [375] = {.lex_state = 98},
  [376] = {.lex_state = 98},
  [377] = {.lex_state = 98},
  [378] = {.lex_state = 98},
  [379] = {.lex_state = 98},
  [380] = {.lex_state = 98},
  [381] = {.lex_state = 98},
  [382] = {.lex_state = 98},
  [383] = {.lex_state = 98},
  [384] = {.lex_state = 98},
  [385] = {.lex_state = 98},
  [386] = {.lex_state = 98},
  [387] = {.lex_state = 98},
  [388] = {.lex_state = 98},
  [389] = {.lex_state = 98},
  [390] = {.lex_state = 98},
  [391] = {.lex_state = 98},
  [392] = {.lex_state = 98},
  [393] = {.lex_state = 98},
  [394] = {.lex_state = 98},
  [395] = {.lex_state = 98},
  [396] = {.lex_state = 98},
  [397] = {.lex_state = 98},
  [398] = {.lex_state = 98},
  [399] = {.lex_state = 98},
  [400] = {.lex_state = 98},
  [401] = {.lex_state = 98},
  [402] = {.lex_state = 98},
  [403] = {.lex_state = 98},
  [404] = {.lex_state = 98},
  [405] = {.lex_state = 98},
  [406] = {.lex_state = 98},
  [407] = {.lex_state = 98},
  [408] = {.lex_state = 98},
  [409] = {.lex_state = 98},
  [410] = {.lex_state = 98},
  [411] = {.lex_state = 98},
  [412] = {.lex_state = 98},
  [413] = {.lex_state = 98},
  [414] = {.lex_state = 98},
  [415] = {.lex_state = 98},
  [416] = {.lex_state = 98},
  [417] = {.lex_state = 98},
  [418] = {.lex_state = 98},
  [419] = {.lex_state = 98},
  [420] = {.lex_state = 98},
  [421] = {.lex_state = 98},
  [422] = {.lex_state = 98},
  [423] = {.lex_state = 98},
  [424] = {.lex_state = 98},
  [425] = {.lex_state = 98},
  [426] = {.lex_state = 98},
  [427] = {.lex_state = 98},
  [428] = {.lex_state = 98},
  [429] = {.lex_state = 98},
  [430] = {.lex_state = 98},
  [431] = {.lex_state = 98},
  [432] = {.lex_state = 98},
  [433] = {.lex_state = 98},
  [434] = {.lex_state = 98},
  [435] = {.lex_state = 98},
  [436] = {.lex_state = 98},
  [437] = {.lex_state = 98},
  [438] = {.lex_state = 98},
  [439] = {.lex_state = 98},
  [440] = {.lex_state = 98},
  [441] = {.lex_state = 98},
  [442] = {.lex_state = 98},
  [443] = {.lex_state = 98},
  [444] = {.lex_state = 98},
  [445] = {.lex_state = 98},
  [446] = {.lex_state = 98},
  [447] = {.lex_state = 98},
  [448] = {.lex_state = 98},
  [449] = {.lex_state = 98},
  [450] = {.lex_state = 98},
  [451] = {.lex_state = 98},
  [452] = {.lex_state = 98},
  [453] = {.lex_state = 98},
  [454] = {.lex_state = 98},
  [455] = {.lex_state = 98},
  [456] = {.lex_state = 98},
  [457] = {.lex_state = 98},
  [458] = {.lex_state = 98},
  [459] = {.lex_state = 98},
  [460] = {.lex_state = 98},
  [461] = {.lex_state = 98},
  [462] = {.lex_state = 98},
  [463] = {.lex_state = 98},
  [464] = {.lex_state = 98},
  [465] = {.lex_state = 98},
  [466] = {.lex_state = 98},
  [467] = {.lex_state = 98},
  [468] = {.lex_state = 98},
  [469] = {.lex_state = 98},
  [470] = {.lex_state = 98},
  [471] = {.lex_state = 98},
  [472] = {.lex_state = 98},
  [473] = {.lex_state = 98},
  [474] = {.lex_state = 98},
  [475] = {.lex_state = 98},
  [476] = {.lex_state = 98},
  [477] = {.lex_state = 98},
  [478] = {.lex_state = 98},
  [479] = {.lex_state = 98},
  [480] = {.lex_state = 98},
  [481] = {.lex_state = 98},
  [482] = {.lex_state = 98},
  [483] = {.lex_state = 98},
  [484] = {.lex_state = 98},
  [485] = {.lex_state = 98},
  [486] = {.lex_state = 98},
  [487] = {.lex_state = 98},
  [488] = {.lex_state = 98},
  [489] = {.lex_state = 98},
  [490] = {.lex_state = 98},
  [491] = {.lex_state = 98},
  [492] = {.lex_state = 98},
  [493] = {.lex_state = 98},
  [494] = {.lex_state = 98},
  [495] = {.lex_state = 98},
  [496] = {.lex_state = 98},
  [497] = {.lex_state = 98},
  [498] = {.lex_state = 98},
  [499] = {.lex_state = 98},
  [500] = {.lex_state = 98},
  [501] = {.lex_state = 98},
  [502] = {.lex_state = 98},
  [503] = {.lex_state = 98},
  [504] = {.lex_state = 98},
  [505] = {.lex_state = 98},
  [506] = {.lex_state = 98},
  [507] = {.lex_state = 98},
  [508] = {.lex_state = 98},
  [509] = {.lex_state = 98},
  [510] = {.lex_state = 98},
  [511] = {.lex_state = 98},
  [512] = {.lex_state = 98},
  [513] = {.lex_state = 3, .external_lex_state = 2},
  [514] = {.lex_state = 3, .external_lex_state = 2},
  [515] = {.lex_state = 3, .external_lex_state = 2},
  [516] = {.lex_state = 3, .external_lex_state = 2},
  [517] = {.lex_state = 5, .external_lex_state = 2},
  [518] = {.lex_state = 5, .external_lex_state = 2},
  [519] = {.lex_state = 4, .external_lex_state = 3},
  [520] = {.lex_state = 4, .external_lex_state = 3},
  [521] = {.lex_state = 4, .external_lex_state = 3},
  [522] = {.lex_state = 4, .external_lex_state = 3},
  [523] = {.lex_state = 5, .external_lex_state = 2},
  [524] = {.lex_state = 5, .external_lex_state = 2},
  [525] = {.lex_state = 4, .external_lex_state = 3},
  [526] = {.lex_state = 4, .external_lex_state = 3},
  [527] = {.lex_state = 6, .external_lex_state = 2},
  [528] = {.lex_state = 6, .external_lex_state = 2},
  [529] = {.lex_state = 6, .external_lex_state = 3},
  [530] = {.lex_state = 6, .external_lex_state = 2},
  [531] = {.lex_state = 6, .external_lex_state = 3},
  [532] = {.lex_state = 6, .external_lex_state = 2},
  [533] = {.lex_state = 6, .external_lex_state = 3},
  [534] = {.lex_state = 6, .external_lex_state = 2},
  [535] = {.lex_state = 6, .external_lex_state = 3},
  [536] = {.lex_state = 6, .external_lex_state = 2},
  [537] = {.lex_state = 6, .external_lex_state = 2},
  [538] = {.lex_state = 6, .external_lex_state = 2},
  [539] = {.lex_state = 6, .external_lex_state = 2},
  [540] = {.lex_state = 6, .external_lex_state = 2},
  [541] = {.lex_state = 6, .external_lex_state = 2},
  [542] = {.lex_state = 6, .external_lex_state = 2},
  [543] = {.lex_state = 6, .external_lex_state = 2},
  [544] = {.lex_state = 100},
  [545] = {.lex_state = 100},
  [546] = {.lex_state = 100},
  [547] = {.lex_state = 100},
  [548] = {.lex_state = 100},
  [549] = {.lex_state = 100},
  [550] = {.lex_state = 100},
  [551] = {.lex_state = 100},
  [552] = {.lex_state = 100},
  [553] = {.lex_state = 6, .external_lex_state = 2},
  [554] = {.lex_state = 100},
  [555] = {.lex_state = 100},
  [556] = {.lex_state = 6, .external_lex_state = 2},
  [557] = {.lex_state = 6, .external_lex_state = 3},
  [558] = {.lex_state = 6, .external_lex_state = 3},
  [559] = {.lex_state = 6, .external_lex_state = 3},
  [560] = {.lex_state = 6, .external_lex_state = 3},
  [561] = {.lex_state = 6, .external_lex_state = 2},
  [562] = {.lex_state = 6, .external_lex_state = 3},
  [563] = {.lex_state = 6, .external_lex_state = 3},
  [564] = {.lex_state = 6, .external_lex_state = 3},
  [565] = {.lex_state = 6, .external_lex_state = 3},
  [566] = {.lex_state = 6, .external_lex_state = 3},
  [567] = {.lex_state = 6, .external_lex_state = 3},
  [568] = {.lex_state = 6, .external_lex_state = 3},
  [569] = {.lex_state = 6, .external_lex_state = 3},
  [570] = {.lex_state = 6, .external_lex_state = 3},
  [571] = {.lex_state = 6, .external_lex_state = 3},
  [572] = {.lex_state = 6, .external_lex_state = 3},
  [573] = {.lex_state = 6, .external_lex_state = 3},
  [574] = {.lex_state = 18},
  [575] = {.lex_state = 6, .external_lex_state = 3},
  [576] = {.lex_state = 6, .external_lex_state = 3},
  [577] = {.lex_state = 6, .external_lex_state = 3},
  [578] = {.lex_state = 6, .external_lex_state = 3},
  [579] = {.lex_state = 100},
  [580] = {.lex_state = 100},
  [581] = {.lex_state = 100},
  [582] = {.lex_state = 100},
  [583] = {.lex_state = 100},
  [584] = {.lex_state = 100},
  [585] = {.lex_state = 100},
  [586] = {.lex_state = 100},
  [587] = {.lex_state = 100},
  [588] = {.lex_state = 4, .external_lex_state = 2},
  [589] = {.lex_state = 4, .external_lex_state = 2},
  [590] = {.lex_state = 98},
  [591] = {.lex_state = 18},
  [592] = {.lex_state = 18},
  [593] = {.lex_state = 98, .external_lex_state = 4},
  [594] = {.lex_state = 98, .external_lex_state = 4},
  [595] = {.lex_state = 98, .external_lex_state = 4},
  [596] = {.lex_state = 98, .external_lex_state = 4},
  [597] = {.lex_state = 98, .external_lex_state = 4},
  [598] = {.lex_state = 4, .external_lex_state = 3},
  [599] = {.lex_state = 4, .external_lex_state = 3},
  [600] = {.lex_state = 98, .external_lex_state = 4},
  [601] = {.lex_state = 18},
  [602] = {.lex_state = 98, .external_lex_state = 4},
  [603] = {.lex_state = 98, .external_lex_state = 4},
  [604] = {.lex_state = 98, .external_lex_state = 4},
  [605] = {.lex_state = 98, .external_lex_state = 4},
  [606] = {.lex_state = 4, .external_lex_state = 2},
  [607] = {.lex_state = 18},
  [608] = {.lex_state = 98, .external_lex_state = 4},
  [609] = {.lex_state = 98, .external_lex_state = 4},
  [610] = {.lex_state = 98, .external_lex_state = 4},
  [611] = {.lex_state = 98, .external_lex_state = 4},
  [612] = {.lex_state = 98, .external_lex_state = 4},
  [613] = {.lex_state = 98, .external_lex_state = 4},
  [614] = {.lex_state = 18},
  [615] = {.lex_state = 18},
  [616] = {.lex_state = 18},
  [617] = {.lex_state = 4, .external_lex_state = 3},
  [618] = {.lex_state = 4, .external_lex_state = 3},
  [619] = {.lex_state = 18},
  [620] = {.lex_state = 98, .external_lex_state = 4},
  [621] = {.lex_state = 98, .external_lex_state = 4},
  [622] = {.lex_state = 98, .external_lex_state = 4},
  [623] = {.lex_state = 98, .external_lex_state = 4},
  [624] = {.lex_state = 4, .external_lex_state = 2},
  [625] = {.lex_state = 98, .external_lex_state = 4},
  [626] = {.lex_state = 4, .external_lex_state = 2},
  [627] = {.lex_state = 98, .external_lex_state = 4},
  [628] = {.lex_state = 4, .external_lex_state = 3},
  [629] = {.lex_state = 4, .external_lex_state = 3},
  [630] = {.lex_state = 98, .external_lex_state = 4},
  [631] = {.lex_state = 98, .external_lex_state = 4},
  [632] = {.lex_state = 4, .external_lex_state = 3},
  [633] = {.lex_state = 18},
  [634] = {.lex_state = 98},
  [635] = {.lex_state = 98},
  [636] = {.lex_state = 98},
  [637] = {.lex_state = 4, .external_lex_state = 2},
  [638] = {.lex_state = 4, .external_lex_state = 2},
  [639] = {.lex_state = 98},
  [640] = {.lex_state = 4, .external_lex_state = 2},
  [641] = {.lex_state = 98},
  [642] = {.lex_state = 98},
  [643] = {.lex_state = 98},
  [644] = {.lex_state = 98},
  [645] = {.lex_state = 98},
  [646] = {.lex_state = 98},
  [647] = {.lex_state = 98},
  [648] = {.lex_state = 98},
  [649] = {.lex_state = 98},
  [650] = {.lex_state = 98},
  [651] = {.lex_state = 98},
  [652] = {.lex_state = 18},
  [653] = {.lex_state = 98},
  [654] = {.lex_state = 98},
  [655] = {.lex_state = 98},
  [656] = {.lex_state = 4, .external_lex_state = 2},
  [657] = {.lex_state = 98},
  [658] = {.lex_state = 98},
  [659] = {.lex_state = 98},
  [660] = {.lex_state = 98},
  [661] = {.lex_state = 98},
  [662] = {.lex_state = 98},
  [663] = {.lex_state = 98},
  [664] = {.lex_state = 98},
  [665] = {.lex_state = 4, .external_lex_state = 2},
  [666] = {.lex_state = 98},
  [667] = {.lex_state = 98},
  [668] = {.lex_state = 98},
  [669] = {.lex_state = 98},
  [670] = {.lex_state = 98},
  [671] = {.lex_state = 98},
  [672] = {.lex_state = 4, .external_lex_state = 2},
  [673] = {.lex_state = 98, .external_lex_state = 4},
  [674] = {.lex_state = 98, .external_lex_state = 4},
  [675] = {.lex_state = 98, .external_lex_state = 4},
  [676] = {.lex_state = 98, .external_lex_state = 4},
  [677] = {.lex_state = 4, .external_lex_state = 2},
  [678] = {.lex_state = 98, .external_lex_state = 4},
  [679] = {.lex_state = 98, .external_lex_state = 4},
  [680] = {.lex_state = 98, .external_lex_state = 4},
  [681] = {.lex_state = 98},
  [682] = {.lex_state = 98, .external_lex_state = 4},
  [683] = {.lex_state = 4, .external_lex_state = 2},
  [684] = {.lex_state = 4, .external_lex_state = 2},
  [685] = {.lex_state = 98},
  [686] = {.lex_state = 98, .external_lex_state = 4},
  [687] = {.lex_state = 12, .external_lex_state = 2},
  [688] = {.lex_state = 98, .external_lex_state = 4},
  [689] = {.lex_state = 98},
  [690] = {.lex_state = 98, .external_lex_state = 4},
  [691] = {.lex_state = 98, .external_lex_state = 4},
  [692] = {.lex_state = 98, .external_lex_state = 4},
  [693] = {.lex_state = 98, .external_lex_state = 4},
  [694] = {.lex_state = 98, .external_lex_state = 4},
  [695] = {.lex_state = 98, .external_lex_state = 4},
  [696] = {.lex_state = 98},
  [697] = {.lex_state = 98, .external_lex_state = 4},
  [698] = {.lex_state = 98},
  [699] = {.lex_state = 18},
  [700] = {.lex_state = 12, .external_lex_state = 2},
  [701] = {.lex_state = 98},
  [702] = {.lex_state = 98},
  [703] = {.lex_state = 98, .external_lex_state = 4},
  [704] = {.lex_state = 98},
  [705] = {.lex_state = 98},
  [706] = {.lex_state = 98},
  [707] = {.lex_state = 98},
  [708] = {.lex_state = 98},
  [709] = {.lex_state = 98},
  [710] = {.lex_state = 12, .external_lex_state = 2},
  [711] = {.lex_state = 98},
  [712] = {.lex_state = 4, .external_lex_state = 2},
  [713] = {.lex_state = 98},
  [714] = {.lex_state = 98},
  [715] = {.lex_state = 98},
  [716] = {.lex_state = 98},
  [717] = {.lex_state = 4, .external_lex_state = 2},
  [718] = {.lex_state = 98},
  [719] = {.lex_state = 98},
  [720] = {.lex_state = 98},
  [721] = {.lex_state = 98},
  [722] = {.lex_state = 98},
  [723] = {.lex_state = 98},
  [724] = {.lex_state = 12, .external_lex_state = 2},
  [725] = {.lex_state = 98},
  [726] = {.lex_state = 12, .external_lex_state = 2},
  [727] = {.lex_state = 98},
  [728] = {.lex_state = 12, .external_lex_state = 2},
  [729] = {.lex_state = 98},
  [730] = {.lex_state = 98},
  [731] = {.lex_state = 98},
  [732] = {.lex_state = 98},
  [733] = {.lex_state = 98},
  [734] = {.lex_state = 98},
  [735] = {.lex_state = 98},
  [736] = {.lex_state = 98},
  [737] = {.lex_state = 98},
  [738] = {.lex_state = 12, .external_lex_state = 2},
  [739] = {.lex_state = 12, .external_lex_state = 2},
  [740] = {.lex_state = 98},
  [741] = {.lex_state = 98},
  [742] = {.lex_state = 12, .external_lex_state = 2},
  [743] = {.lex_state = 98},
  [744] = {.lex_state = 98},
  [745] = {.lex_state = 98},
  [746] = {.lex_state = 12, .external_lex_state = 2},
  [747] = {.lex_state = 12, .external_lex_state = 2},
  [748] = {.lex_state = 12, .external_lex_state = 2},
  [749] = {.lex_state = 98},
  [750] = {.lex_state = 12, .external_lex_state = 2},
  [751] = {.lex_state = 98},
  [752] = {.lex_state = 98},
  [753] = {.lex_state = 98},
  [754] = {.lex_state = 98},
  [755] = {.lex_state = 12, .external_lex_state = 3},
  [756] = {.lex_state = 98},
  [757] = {.lex_state = 12, .external_lex_state = 2},
  [758] = {.lex_state = 98},
  [759] = {.lex_state = 98},
  [760] = {.lex_state = 12, .external_lex_state = 2},
  [761] = {.lex_state = 12, .external_lex_state = 2},
  [762] = {.lex_state = 12, .external_lex_state = 2},
  [763] = {.lex_state = 12, .external_lex_state = 2},
  [764] = {.lex_state = 12, .external_lex_state = 2},
  [765] = {.lex_state = 12, .external_lex_state = 2},
  [766] = {.lex_state = 98},
  [767] = {.lex_state = 98},
  [768] = {.lex_state = 12, .external_lex_state = 2},
  [769] = {.lex_state = 12, .external_lex_state = 2},
  [770] = {.lex_state = 98},
  [771] = {.lex_state = 98},
  [772] = {.lex_state = 98},
  [773] = {.lex_state = 98},
  [774] = {.lex_state = 12, .external_lex_state = 2},
  [775] = {.lex_state = 98},
  [776] = {.lex_state = 12, .external_lex_state = 2},
  [777] = {.lex_state = 98},
  [778] = {.lex_state = 98},
  [779] = {.lex_state = 98},
  [780] = {.lex_state = 98},
  [781] = {.lex_state = 12, .external_lex_state = 2},
  [782] = {.lex_state = 98},
  [783] = {.lex_state = 98},
  [784] = {.lex_state = 98},
  [785] = {.lex_state = 12, .external_lex_state = 2},
  [786] = {.lex_state = 12, .external_lex_state = 2},
  [787] = {.lex_state = 98},
  [788] = {.lex_state = 12, .external_lex_state = 2},
  [789] = {.lex_state = 12, .external_lex_state = 2},
  [790] = {.lex_state = 98},
  [791] = {.lex_state = 98},
  [792] = {.lex_state = 98},
  [793] = {.lex_state = 98},
  [794] = {.lex_state = 12, .external_lex_state = 2},
  [795] = {.lex_state = 98},
  [796] = {.lex_state = 98},
  [797] = {.lex_state = 98},
  [798] = {.lex_state = 98},
  [799] = {.lex_state = 98},
  [800] = {.lex_state = 12, .external_lex_state = 2},
  [801] = {.lex_state = 12, .external_lex_state = 2},
  [802] = {.lex_state = 12, .external_lex_state = 2},
  [803] = {.lex_state = 98},
  [804] = {.lex_state = 98},
  [805] = {.lex_state = 12, .external_lex_state = 3},
  [806] = {.lex_state = 98},
  [807] = {.lex_state = 98},
  [808] = {.lex_state = 98},
  [809] = {.lex_state = 98},
  [810] = {.lex_state = 98},
  [811] = {.lex_state = 98},
  [812] = {.lex_state = 98},
  [813] = {.lex_state = 98},
  [814] = {.lex_state = 98},
  [815] = {.lex_state = 12, .external_lex_state = 2},
  [816] = {.lex_state = 98},
  [817] = {.lex_state = 98},
  [818] = {.lex_state = 98},
  [819] = {.lex_state = 98},
  [820] = {.lex_state = 98},
  [821] = {.lex_state = 98},
  [822] = {.lex_state = 98},
  [823] = {.lex_state = 98},
  [824] = {.lex_state = 98},
  [825] = {.lex_state = 98},
  [826] = {.lex_state = 98},
  [827] = {.lex_state = 98},
  [828] = {.lex_state = 98},
  [829] = {.lex_state = 98},
  [830] = {.lex_state = 98},
  [831] = {.lex_state = 98},
  [832] = {.lex_state = 98},
  [833] = {.lex_state = 98},
  [834] = {.lex_state = 98},
  [835] = {.lex_state = 98},
  [836] = {.lex_state = 98},
  [837] = {.lex_state = 98},
  [838] = {.lex_state = 98},
  [839] = {.lex_state = 98},
  [840] = {.lex_state = 12, .external_lex_state = 2},
  [841] = {.lex_state = 98},
  [842] = {.lex_state = 98},
  [843] = {.lex_state = 12, .external_lex_state = 2},
  [844] = {.lex_state = 98},
  [845] = {.lex_state = 98},
  [846] = {.lex_state = 98},
  [847] = {.lex_state = 98},
  [848] = {.lex_state = 12, .external_lex_state = 2},
  [849] = {.lex_state = 98},
  [850] = {.lex_state = 4, .external_lex_state = 2},
  [851] = {.lex_state = 98},
  [852] = {.lex_state = 12, .external_lex_state = 2},
  [853] = {.lex_state = 98},
  [854] = {.lex_state = 98},
  [855] = {.lex_state = 98},
  [856] = {.lex_state = 98},
  [857] = {.lex_state = 98},
  [858] = {.lex_state = 98},
  [859] = {.lex_state = 12, .external_lex_state = 2},
  [860] = {.lex_state = 98},
  [861] = {.lex_state = 98},
  [862] = {.lex_state = 98},
  [863] = {.lex_state = 98},
  [864] = {.lex_state = 98},
  [865] = {.lex_state = 98},
  [866] = {.lex_state = 98},
  [867] = {.lex_state = 98},
  [868] = {.lex_state = 98},
  [869] = {.lex_state = 98},
  [870] = {.lex_state = 12, .external_lex_state = 2},
  [871] = {.lex_state = 12, .external_lex_state = 2},
  [872] = {.lex_state = 98},
  [873] = {.lex_state = 98},
  [874] = {.lex_state = 98},
  [875] = {.lex_state = 98},
  [876] = {.lex_state = 98},
  [877] = {.lex_state = 98},
  [878] = {.lex_state = 12, .external_lex_state = 2},
  [879] = {.lex_state = 12, .external_lex_state = 2},
  [880] = {.lex_state = 12, .external_lex_state = 2},
  [881] = {.lex_state = 12, .external_lex_state = 2},
  [882] = {.lex_state = 12, .external_lex_state = 2},
  [883] = {.lex_state = 12, .external_lex_state = 2},
  [884] = {.lex_state = 12, .external_lex_state = 2},
  [885] = {.lex_state = 12, .external_lex_state = 2},
  [886] = {.lex_state = 12, .external_lex_state = 2},
  [887] = {.lex_state = 12, .external_lex_state = 2},
  [888] = {.lex_state = 12, .external_lex_state = 2},
  [889] = {.lex_state = 12, .external_lex_state = 2},
  [890] = {.lex_state = 12, .external_lex_state = 2},
  [891] = {.lex_state = 12, .external_lex_state = 2},
  [892] = {.lex_state = 12, .external_lex_state = 2},
  [893] = {.lex_state = 12, .external_lex_state = 2},
  [894] = {.lex_state = 12, .external_lex_state = 2},
  [895] = {.lex_state = 12, .external_lex_state = 2},
  [896] = {.lex_state = 12, .external_lex_state = 2},
  [897] = {.lex_state = 12, .external_lex_state = 2},
  [898] = {.lex_state = 12, .external_lex_state = 2},
  [899] = {.lex_state = 12, .external_lex_state = 2},
  [900] = {.lex_state = 12, .external_lex_state = 2},
  [901] = {.lex_state = 12, .external_lex_state = 2},
  [902] = {.lex_state = 12, .external_lex_state = 2},
  [903] = {.lex_state = 12, .external_lex_state = 2},
  [904] = {.lex_state = 12, .external_lex_state = 2},
  [905] = {.lex_state = 12, .external_lex_state = 2},
  [906] = {.lex_state = 12, .external_lex_state = 2},
  [907] = {.lex_state = 12, .external_lex_state = 2},
  [908] = {.lex_state = 12, .external_lex_state = 3},
  [909] = {.lex_state = 12, .external_lex_state = 2},
  [910] = {.lex_state = 12, .external_lex_state = 2},
  [911] = {.lex_state = 12, .external_lex_state = 2},
  [912] = {.lex_state = 12, .external_lex_state = 2},
  [913] = {.lex_state = 12, .external_lex_state = 2},
  [914] = {.lex_state = 12, .external_lex_state = 2},
  [915] = {.lex_state = 12, .external_lex_state = 2},
  [916] = {.lex_state = 12, .external_lex_state = 2},
  [917] = {.lex_state = 12, .external_lex_state = 2},
  [918] = {.lex_state = 12, .external_lex_state = 2},
  [919] = {.lex_state = 12, .external_lex_state = 2},
  [920] = {.lex_state = 12, .external_lex_state = 2},
  [921] = {.lex_state = 12, .external_lex_state = 2},
  [922] = {.lex_state = 12, .external_lex_state = 2},
  [923] = {.lex_state = 12, .external_lex_state = 2},
  [924] = {.lex_state = 12, .external_lex_state = 2},
  [925] = {.lex_state = 12, .external_lex_state = 2},
  [926] = {.lex_state = 12, .external_lex_state = 2},
  [927] = {.lex_state = 12, .external_lex_state = 2},
  [928] = {.lex_state = 12, .external_lex_state = 2},
  [929] = {.lex_state = 12, .external_lex_state = 2},
  [930] = {.lex_state = 12, .external_lex_state = 2},
  [931] = {.lex_state = 12, .external_lex_state = 2},
  [932] = {.lex_state = 12, .external_lex_state = 2},
  [933] = {.lex_state = 12, .external_lex_state = 2},
  [934] = {.lex_state = 12, .external_lex_state = 2},
  [935] = {.lex_state = 12, .external_lex_state = 2},
  [936] = {.lex_state = 12, .external_lex_state = 2},
  [937] = {.lex_state = 12, .external_lex_state = 2},
  [938] = {.lex_state = 12, .external_lex_state = 2},
  [939] = {.lex_state = 12, .external_lex_state = 2},
  [940] = {.lex_state = 12, .external_lex_state = 2},
  [941] = {.lex_state = 12, .external_lex_state = 2},
  [942] = {.lex_state = 12, .external_lex_state = 2},
  [943] = {.lex_state = 12, .external_lex_state = 2},
  [944] = {.lex_state = 12, .external_lex_state = 2},
  [945] = {.lex_state = 12, .external_lex_state = 2},
  [946] = {.lex_state = 12, .external_lex_state = 2},
  [947] = {.lex_state = 12, .external_lex_state = 2},
  [948] = {.lex_state = 12, .external_lex_state = 2},
  [949] = {.lex_state = 12, .external_lex_state = 2},
  [950] = {.lex_state = 12, .external_lex_state = 2},
  [951] = {.lex_state = 12, .external_lex_state = 2},
  [952] = {.lex_state = 12, .external_lex_state = 2},
  [953] = {.lex_state = 12, .external_lex_state = 2},
  [954] = {.lex_state = 12, .external_lex_state = 2},
  [955] = {.lex_state = 12, .external_lex_state = 2},
  [956] = {.lex_state = 12, .external_lex_state = 2},
  [957] = {.lex_state = 12, .external_lex_state = 2},
  [958] = {.lex_state = 12, .external_lex_state = 2},
  [959] = {.lex_state = 12, .external_lex_state = 2},
  [960] = {.lex_state = 12, .external_lex_state = 2},
  [961] = {.lex_state = 12, .external_lex_state = 2},
  [962] = {.lex_state = 12, .external_lex_state = 2},
  [963] = {.lex_state = 12, .external_lex_state = 2},
  [964] = {.lex_state = 12, .external_lex_state = 2},
  [965] = {.lex_state = 12, .external_lex_state = 2},
  [966] = {.lex_state = 12, .external_lex_state = 2},
  [967] = {.lex_state = 12, .external_lex_state = 2},
  [968] = {.lex_state = 10, .external_lex_state = 2},
  [969] = {.lex_state = 12, .external_lex_state = 2},
  [970] = {.lex_state = 12, .external_lex_state = 2},
  [971] = {.lex_state = 12, .external_lex_state = 3},
  [972] = {.lex_state = 12, .external_lex_state = 2},
  [973] = {.lex_state = 12, .external_lex_state = 2},
  [974] = {.lex_state = 12, .external_lex_state = 2},
  [975] = {.lex_state = 12, .external_lex_state = 2},
  [976] = {.lex_state = 12, .external_lex_state = 2},
  [977] = {.lex_state = 12, .external_lex_state = 2},
  [978] = {.lex_state = 12, .external_lex_state = 2},
  [979] = {.lex_state = 12, .external_lex_state = 2},
  [980] = {.lex_state = 12, .external_lex_state = 2},
  [981] = {.lex_state = 12, .external_lex_state = 2},
  [982] = {.lex_state = 12, .external_lex_state = 2},
  [983] = {.lex_state = 12, .external_lex_state = 2},
  [984] = {.lex_state = 12, .external_lex_state = 2},
  [985] = {.lex_state = 12, .external_lex_state = 2},
  [986] = {.lex_state = 12, .external_lex_state = 2},
  [987] = {.lex_state = 12, .external_lex_state = 2},
  [988] = {.lex_state = 12, .external_lex_state = 2},
  [989] = {.lex_state = 12, .external_lex_state = 2},
  [990] = {.lex_state = 12, .external_lex_state = 2},
  [991] = {.lex_state = 12, .external_lex_state = 2},
  [992] = {.lex_state = 12, .external_lex_state = 2},
  [993] = {.lex_state = 12, .external_lex_state = 2},
  [994] = {.lex_state = 12, .external_lex_state = 2},
  [995] = {.lex_state = 12, .external_lex_state = 2},
  [996] = {.lex_state = 12, .external_lex_state = 2},
  [997] = {.lex_state = 12, .external_lex_state = 2},
  [998] = {.lex_state = 12, .external_lex_state = 2},
  [999] = {.lex_state = 12, .external_lex_state = 2},
  [1000] = {.lex_state = 12, .external_lex_state = 2},
  [1001] = {.lex_state = 12, .external_lex_state = 2},
  [1002] = {.lex_state = 12, .external_lex_state = 2},
  [1003] = {.lex_state = 12, .external_lex_state = 2},
  [1004] = {.lex_state = 12, .external_lex_state = 2},
  [1005] = {.lex_state = 12, .external_lex_state = 2},
  [1006] = {.lex_state = 12, .external_lex_state = 2},
  [1007] = {.lex_state = 12, .external_lex_state = 2},
  [1008] = {.lex_state = 12, .external_lex_state = 2},
  [1009] = {.lex_state = 12, .external_lex_state = 2},
  [1010] = {.lex_state = 12, .external_lex_state = 2},
  [1011] = {.lex_state = 12, .external_lex_state = 2},
  [1012] = {.lex_state = 12, .external_lex_state = 2},
  [1013] = {.lex_state = 12, .external_lex_state = 2},
  [1014] = {.lex_state = 12, .external_lex_state = 2},
  [1015] = {.lex_state = 12, .external_lex_state = 2},
  [1016] = {.lex_state = 12, .external_lex_state = 2},
  [1017] = {.lex_state = 12, .external_lex_state = 2},
  [1018] = {.lex_state = 12, .external_lex_state = 2},
  [1019] = {.lex_state = 12, .external_lex_state = 2},
  [1020] = {.lex_state = 12, .external_lex_state = 2},
  [1021] = {.lex_state = 12, .external_lex_state = 2},
  [1022] = {.lex_state = 12, .external_lex_state = 2},
  [1023] = {.lex_state = 12, .external_lex_state = 2},
  [1024] = {.lex_state = 12, .external_lex_state = 2},
  [1025] = {.lex_state = 12, .external_lex_state = 2},
  [1026] = {.lex_state = 12, .external_lex_state = 2},
  [1027] = {.lex_state = 12, .external_lex_state = 2},
  [1028] = {.lex_state = 12, .external_lex_state = 2},
  [1029] = {.lex_state = 12, .external_lex_state = 2},
  [1030] = {.lex_state = 12, .external_lex_state = 2},
  [1031] = {.lex_state = 12, .external_lex_state = 2},
  [1032] = {.lex_state = 12, .external_lex_state = 2},
  [1033] = {.lex_state = 12, .external_lex_state = 2},
  [1034] = {.lex_state = 12, .external_lex_state = 2},
  [1035] = {.lex_state = 12, .external_lex_state = 2},
  [1036] = {.lex_state = 12, .external_lex_state = 2},
  [1037] = {.lex_state = 12, .external_lex_state = 2},
  [1038] = {.lex_state = 12, .external_lex_state = 2},
  [1039] = {.lex_state = 12, .external_lex_state = 2},
  [1040] = {.lex_state = 12, .external_lex_state = 2},
  [1041] = {.lex_state = 12, .external_lex_state = 2},
  [1042] = {.lex_state = 12, .external_lex_state = 2},
  [1043] = {.lex_state = 12, .external_lex_state = 2},
  [1044] = {.lex_state = 12, .external_lex_state = 2},
  [1045] = {.lex_state = 12, .external_lex_state = 2},
  [1046] = {.lex_state = 12, .external_lex_state = 2},
  [1047] = {.lex_state = 12, .external_lex_state = 2},
  [1048] = {.lex_state = 12, .external_lex_state = 2},
  [1049] = {.lex_state = 12, .external_lex_state = 2},
  [1050] = {.lex_state = 12, .external_lex_state = 2},
  [1051] = {.lex_state = 12, .external_lex_state = 2},
  [1052] = {.lex_state = 12, .external_lex_state = 2},
  [1053] = {.lex_state = 12, .external_lex_state = 2},
  [1054] = {.lex_state = 12, .external_lex_state = 2},
  [1055] = {.lex_state = 12, .external_lex_state = 2},
  [1056] = {.lex_state = 12, .external_lex_state = 2},
  [1057] = {.lex_state = 12, .external_lex_state = 2},
  [1058] = {.lex_state = 12, .external_lex_state = 2},
  [1059] = {.lex_state = 12, .external_lex_state = 2},
  [1060] = {.lex_state = 12, .external_lex_state = 2},
  [1061] = {.lex_state = 12, .external_lex_state = 2},
  [1062] = {.lex_state = 12, .external_lex_state = 2},
  [1063] = {.lex_state = 12, .external_lex_state = 2},
  [1064] = {.lex_state = 12, .external_lex_state = 2},
  [1065] = {.lex_state = 12, .external_lex_state = 2},
  [1066] = {.lex_state = 12, .external_lex_state = 2},
  [1067] = {.lex_state = 12, .external_lex_state = 2},
  [1068] = {.lex_state = 12, .external_lex_state = 2},
  [1069] = {.lex_state = 12, .external_lex_state = 2},
  [1070] = {.lex_state = 12, .external_lex_state = 2},
  [1071] = {.lex_state = 12, .external_lex_state = 2},
  [1072] = {.lex_state = 12, .external_lex_state = 2},
  [1073] = {.lex_state = 12, .external_lex_state = 2},
  [1074] = {.lex_state = 12, .external_lex_state = 2},
  [1075] = {.lex_state = 12, .external_lex_state = 2},
  [1076] = {.lex_state = 12, .external_lex_state = 2},
  [1077] = {.lex_state = 12, .external_lex_state = 2},
  [1078] = {.lex_state = 12, .external_lex_state = 2},
  [1079] = {.lex_state = 12, .external_lex_state = 2},
  [1080] = {.lex_state = 12, .external_lex_state = 2},
  [1081] = {.lex_state = 12, .external_lex_state = 2},
  [1082] = {.lex_state = 12, .external_lex_state = 2},
  [1083] = {.lex_state = 12, .external_lex_state = 2},
  [1084] = {.lex_state = 12, .external_lex_state = 2},
  [1085] = {.lex_state = 12, .external_lex_state = 2},
  [1086] = {.lex_state = 12, .external_lex_state = 2},
  [1087] = {.lex_state = 12, .external_lex_state = 2},
  [1088] = {.lex_state = 12, .external_lex_state = 2},
  [1089] = {.lex_state = 12, .external_lex_state = 2},
  [1090] = {.lex_state = 12, .external_lex_state = 2},
  [1091] = {.lex_state = 12, .external_lex_state = 2},
  [1092] = {.lex_state = 12, .external_lex_state = 2},
  [1093] = {.lex_state = 12, .external_lex_state = 2},
  [1094] = {.lex_state = 12, .external_lex_state = 2},
  [1095] = {.lex_state = 98},
  [1096] = {.lex_state = 100},
  [1097] = {.lex_state = 100},
  [1098] = {.lex_state = 98},
  [1099] = {.lex_state = 12, .external_lex_state = 2},
  [1100] = {.lex_state = 100},
  [1101] = {.lex_state = 98},
  [1102] = {.lex_state = 98},
  [1103] = {.lex_state = 100},
  [1104] = {.lex_state = 98},
  [1105] = {.lex_state = 98},
  [1106] = {.lex_state = 100},
  [1107] = {.lex_state = 98},
  [1108] = {.lex_state = 98},
  [1109] = {.lex_state = 98},
  [1110] = {.lex_state = 98},
  [1111] = {.lex_state = 98},
  [1112] = {.lex_state = 98},
  [1113] = {.lex_state = 98},
  [1114] = {.lex_state = 100},
  [1115] = {.lex_state = 10, .external_lex_state = 2},
  [1116] = {.lex_state = 100},
  [1117] = {.lex_state = 100},
  [1118] = {.lex_state = 100},
  [1119] = {.lex_state = 100},
  [1120] = {.lex_state = 100},
  [1121] = {.lex_state = 100},
  [1122] = {.lex_state = 100},
  [1123] = {.lex_state = 100},
  [1124] = {.lex_state = 100},
  [1125] = {.lex_state = 100},
  [1126] = {.lex_state = 100},
  [1127] = {.lex_state = 100},
  [1128] = {.lex_state = 100},
  [1129] = {.lex_state = 4, .external_lex_state = 3},
  [1130] = {.lex_state = 4, .external_lex_state = 3},
  [1131] = {.lex_state = 4, .external_lex_state = 3},
  [1132] = {.lex_state = 100},
  [1133] = {.lex_state = 4, .external_lex_state = 3},
  [1134] = {.lex_state = 4, .external_lex_state = 3},
  [1135] = {.lex_state = 4, .external_lex_state = 3},
  [1136] = {.lex_state = 4, .external_lex_state = 2},
  [1137] = {.lex_state = 100},
  [1138] = {.lex_state = 100},
  [1139] = {.lex_state = 100},
  [1140] = {.lex_state = 100},
  [1141] = {.lex_state = 4, .external_lex_state = 3},
  [1142] = {.lex_state = 4, .external_lex_state = 3},
  [1143] = {.lex_state = 4, .external_lex_state = 3},
  [1144] = {.lex_state = 4, .external_lex_state = 3},
  [1145] = {.lex_state = 98},
  [1146] = {.lex_state = 4, .external_lex_state = 3},
  [1147] = {.lex_state = 98},
  [1148] = {.lex_state = 100},
  [1149] = {.lex_state = 98},
  [1150] = {.lex_state = 4, .external_lex_state = 3},
  [1151] = {.lex_state = 4, .external_lex_state = 2},
  [1152] = {.lex_state = 100},
  [1153] = {.lex_state = 4, .external_lex_state = 2},
  [1154] = {.lex_state = 4, .external_lex_state = 2},
  [1155] = {.lex_state = 100},
  [1156] = {.lex_state = 100},
  [1157] = {.lex_state = 4, .external_lex_state = 3},
  [1158] = {.lex_state = 4, .external_lex_state = 2},
  [1159] = {.lex_state = 4, .external_lex_state = 3},
  [1160] = {.lex_state = 100},
  [1161] = {.lex_state = 100},
  [1162] = {.lex_state = 4, .external_lex_state = 2},
  [1163] = {.lex_state = 100},
  [1164] = {.lex_state = 100},
  [1165] = {.lex_state = 4, .external_lex_state = 2},
  [1166] = {.lex_state = 100},
  [1167] = {.lex_state = 4, .external_lex_state = 2},
  [1168] = {.lex_state = 100},
  [1169] = {.lex_state = 100},
  [1170] = {.lex_state = 100},
  [1171] = {.lex_state = 100},
  [1172] = {.lex_state = 100},
  [1173] = {.lex_state = 100},
  [1174] = {.lex_state = 100},
  [1175] = {.lex_state = 100},
  [1176] = {.lex_state = 100},
  [1177] = {.lex_state = 100},
  [1178] = {.lex_state = 100},
  [1179] = {.lex_state = 100},
  [1180] = {.lex_state = 100},
  [1181] = {.lex_state = 100},
  [1182] = {.lex_state = 100},
  [1183] = {.lex_state = 100},
  [1184] = {.lex_state = 100},
  [1185] = {.lex_state = 100},
  [1186] = {.lex_state = 4, .external_lex_state = 2},
  [1187] = {.lex_state = 100},
  [1188] = {.lex_state = 100},
  [1189] = {.lex_state = 100},
  [1190] = {.lex_state = 100},
  [1191] = {.lex_state = 100},
  [1192] = {.lex_state = 100},
  [1193] = {.lex_state = 100},
  [1194] = {.lex_state = 100},
  [1195] = {.lex_state = 4, .external_lex_state = 2},
  [1196] = {.lex_state = 100},
  [1197] = {.lex_state = 100},
  [1198] = {.lex_state = 100},
  [1199] = {.lex_state = 100},
  [1200] = {.lex_state = 100},
  [1201] = {.lex_state = 100},
  [1202] = {.lex_state = 100},
  [1203] = {.lex_state = 100},
  [1204] = {.lex_state = 100},
  [1205] = {.lex_state = 100},
  [1206] = {.lex_state = 100},
  [1207] = {.lex_state = 100},
  [1208] = {.lex_state = 100},
  [1209] = {.lex_state = 100},
  [1210] = {.lex_state = 100},
  [1211] = {.lex_state = 100},
  [1212] = {.lex_state = 100},
  [1213] = {.lex_state = 100},
  [1214] = {.lex_state = 100},
  [1215] = {.lex_state = 100},
  [1216] = {.lex_state = 100},
  [1217] = {.lex_state = 100},
  [1218] = {.lex_state = 4, .external_lex_state = 2},
  [1219] = {.lex_state = 100},
  [1220] = {.lex_state = 100},
  [1221] = {.lex_state = 100},
  [1222] = {.lex_state = 100},
  [1223] = {.lex_state = 100},
  [1224] = {.lex_state = 100},
  [1225] = {.lex_state = 100},
  [1226] = {.lex_state = 100},
  [1227] = {.lex_state = 100},
  [1228] = {.lex_state = 100},
  [1229] = {.lex_state = 100},
  [1230] = {.lex_state = 100},
  [1231] = {.lex_state = 100},
  [1232] = {.lex_state = 100},
  [1233] = {.lex_state = 100},
  [1234] = {.lex_state = 100},
  [1235] = {.lex_state = 100},
  [1236] = {.lex_state = 100},
  [1237] = {.lex_state = 100},
  [1238] = {.lex_state = 100},
  [1239] = {.lex_state = 100},
  [1240] = {.lex_state = 100},
  [1241] = {.lex_state = 100},
  [1242] = {.lex_state = 100},
  [1243] = {.lex_state = 100},
  [1244] = {.lex_state = 100},
  [1245] = {.lex_state = 100},
  [1246] = {.lex_state = 100},
  [1247] = {.lex_state = 100},
  [1248] = {.lex_state = 100},
  [1249] = {.lex_state = 100},
  [1250] = {.lex_state = 100},
  [1251] = {.lex_state = 100},
  [1252] = {.lex_state = 100},
  [1253] = {.lex_state = 100},
  [1254] = {.lex_state = 100},
  [1255] = {.lex_state = 100},
  [1256] = {.lex_state = 100},
  [1257] = {.lex_state = 100},
  [1258] = {.lex_state = 100},
  [1259] = {.lex_state = 100},
  [1260] = {.lex_state = 100},
  [1261] = {.lex_state = 100},
  [1262] = {.lex_state = 100},
  [1263] = {.lex_state = 100},
  [1264] = {.lex_state = 100},
  [1265] = {.lex_state = 100},
  [1266] = {.lex_state = 100},
  [1267] = {.lex_state = 100},
  [1268] = {.lex_state = 4, .external_lex_state = 3},
  [1269] = {.lex_state = 100},
  [1270] = {.lex_state = 100},
  [1271] = {.lex_state = 100},
  [1272] = {.lex_state = 100},
  [1273] = {.lex_state = 100},
  [1274] = {.lex_state = 100},
  [1275] = {.lex_state = 100},
  [1276] = {.lex_state = 100},
  [1277] = {.lex_state = 100},
  [1278] = {.lex_state = 100},
  [1279] = {.lex_state = 100},
  [1280] = {.lex_state = 100},
  [1281] = {.lex_state = 100},
  [1282] = {.lex_state = 100},
  [1283] = {.lex_state = 100},
  [1284] = {.lex_state = 100},
  [1285] = {.lex_state = 4, .external_lex_state = 3},
  [1286] = {.lex_state = 100},
  [1287] = {.lex_state = 100},
  [1288] = {.lex_state = 100},
  [1289] = {.lex_state = 100},
  [1290] = {.lex_state = 100},
  [1291] = {.lex_state = 100},
  [1292] = {.lex_state = 100},
  [1293] = {.lex_state = 100},
  [1294] = {.lex_state = 100},
  [1295] = {.lex_state = 100},
  [1296] = {.lex_state = 100},
  [1297] = {.lex_state = 100},
  [1298] = {.lex_state = 100},
  [1299] = {.lex_state = 100},
  [1300] = {.lex_state = 100},
  [1301] = {.lex_state = 100},
  [1302] = {.lex_state = 100},
  [1303] = {.lex_state = 100},
  [1304] = {.lex_state = 100},
  [1305] = {.lex_state = 100},
  [1306] = {.lex_state = 100},
  [1307] = {.lex_state = 100},
  [1308] = {.lex_state = 100},
  [1309] = {.lex_state = 100},
  [1310] = {.lex_state = 100},
  [1311] = {.lex_state = 100},
  [1312] = {.lex_state = 100},
  [1313] = {.lex_state = 100},
  [1314] = {.lex_state = 100},
  [1315] = {.lex_state = 4, .external_lex_state = 3},
  [1316] = {.lex_state = 100},
  [1317] = {.lex_state = 100},
  [1318] = {.lex_state = 100},
  [1319] = {.lex_state = 100},
  [1320] = {.lex_state = 4, .external_lex_state = 3},
  [1321] = {.lex_state = 100},
  [1322] = {.lex_state = 4, .external_lex_state = 2},
  [1323] = {.lex_state = 100},
  [1324] = {.lex_state = 100},
  [1325] = {.lex_state = 100},
  [1326] = {.lex_state = 100},
  [1327] = {.lex_state = 100},
  [1328] = {.lex_state = 100},
  [1329] = {.lex_state = 100},
  [1330] = {.lex_state = 100},
  [1331] = {.lex_state = 100},
  [1332] = {.lex_state = 100},
  [1333] = {.lex_state = 100},
  [1334] = {.lex_state = 100},
  [1335] = {.lex_state = 100},
  [1336] = {.lex_state = 100},
  [1337] = {.lex_state = 100},
  [1338] = {.lex_state = 100},
  [1339] = {.lex_state = 100},
  [1340] = {.lex_state = 100},
  [1341] = {.lex_state = 100},
  [1342] = {.lex_state = 100},
  [1343] = {.lex_state = 100},
  [1344] = {.lex_state = 4, .external_lex_state = 3},
  [1345] = {.lex_state = 100},
  [1346] = {.lex_state = 100},
  [1347] = {.lex_state = 100},
  [1348] = {.lex_state = 100},
  [1349] = {.lex_state = 100},
  [1350] = {.lex_state = 100},
  [1351] = {.lex_state = 100},
  [1352] = {.lex_state = 100},
  [1353] = {.lex_state = 4, .external_lex_state = 2},
  [1354] = {.lex_state = 100},
  [1355] = {.lex_state = 100},
  [1356] = {.lex_state = 100},
  [1357] = {.lex_state = 100},
  [1358] = {.lex_state = 100},
  [1359] = {.lex_state = 100},
  [1360] = {.lex_state = 100},
  [1361] = {.lex_state = 100},
  [1362] = {.lex_state = 100},
  [1363] = {.lex_state = 4, .external_lex_state = 3},
  [1364] = {.lex_state = 100},
  [1365] = {.lex_state = 100},
  [1366] = {.lex_state = 100},
  [1367] = {.lex_state = 100},
  [1368] = {.lex_state = 100},
  [1369] = {.lex_state = 4, .external_lex_state = 2},
  [1370] = {.lex_state = 100},
  [1371] = {.lex_state = 100},
  [1372] = {.lex_state = 100},
  [1373] = {.lex_state = 100},
  [1374] = {.lex_state = 100},
  [1375] = {.lex_state = 4, .external_lex_state = 3},
  [1376] = {.lex_state = 100},
  [1377] = {.lex_state = 100},
  [1378] = {.lex_state = 100},
  [1379] = {.lex_state = 100},
  [1380] = {.lex_state = 100},
  [1381] = {.lex_state = 100},
  [1382] = {.lex_state = 100},
  [1383] = {.lex_state = 100},
  [1384] = {.lex_state = 100},
  [1385] = {.lex_state = 4, .external_lex_state = 2},
  [1386] = {.lex_state = 100},
  [1387] = {.lex_state = 100},
  [1388] = {.lex_state = 100},
  [1389] = {.lex_state = 100},
  [1390] = {.lex_state = 100},
  [1391] = {.lex_state = 100},
  [1392] = {.lex_state = 100},
  [1393] = {.lex_state = 100},
  [1394] = {.lex_state = 100},
  [1395] = {.lex_state = 100},
  [1396] = {.lex_state = 100},
  [1397] = {.lex_state = 4, .external_lex_state = 2},
  [1398] = {.lex_state = 4, .external_lex_state = 2},
  [1399] = {.lex_state = 4, .external_lex_state = 2},
  [1400] = {.lex_state = 4, .external_lex_state = 2},
  [1401] = {.lex_state = 4, .external_lex_state = 2},
  [1402] = {.lex_state = 4, .external_lex_state = 2},
  [1403] = {.lex_state = 99},
  [1404] = {.lex_state = 4, .external_lex_state = 3},
  [1405] = {.lex_state = 99},
  [1406] = {.lex_state = 4, .external_lex_state = 3},
  [1407] = {.lex_state = 4, .external_lex_state = 3},
  [1408] = {.lex_state = 99},
  [1409] = {.lex_state = 4, .external_lex_state = 2},
  [1410] = {.lex_state = 99},
  [1411] = {.lex_state = 99},
  [1412] = {.lex_state = 4, .external_lex_state = 2},
  [1413] = {.lex_state = 4, .external_lex_state = 2},
  [1414] = {.lex_state = 99},
  [1415] = {.lex_state = 99},
  [1416] = {.lex_state = 4, .external_lex_state = 3},
  [1417] = {.lex_state = 99},
  [1418] = {.lex_state = 4, .external_lex_state = 2},
  [1419] = {.lex_state = 4, .external_lex_state = 2},
  [1420] = {.lex_state = 4, .external_lex_state = 3},
  [1421] = {.lex_state = 4, .external_lex_state = 2},
  [1422] = {.lex_state = 4, .external_lex_state = 3},
  [1423] = {.lex_state = 4, .external_lex_state = 3},
  [1424] = {.lex_state = 4, .external_lex_state = 3},
  [1425] = {.lex_state = 4, .external_lex_state = 3},
  [1426] = {.lex_state = 4, .external_lex_state = 3},
  [1427] = {.lex_state = 4, .external_lex_state = 2},
  [1428] = {.lex_state = 4, .external_lex_state = 3},
  [1429] = {.lex_state = 4, .external_lex_state = 3},
  [1430] = {.lex_state = 4, .external_lex_state = 2},
  [1431] = {.lex_state = 4, .external_lex_state = 3},
  [1432] = {.lex_state = 4, .external_lex_state = 2},
  [1433] = {.lex_state = 4, .external_lex_state = 3},
  [1434] = {.lex_state = 4, .external_lex_state = 3},
  [1435] = {.lex_state = 4, .external_lex_state = 2},
  [1436] = {.lex_state = 4, .external_lex_state = 2},
  [1437] = {.lex_state = 4, .external_lex_state = 2},
  [1438] = {.lex_state = 4, .external_lex_state = 2},
  [1439] = {.lex_state = 4, .external_lex_state = 3},
  [1440] = {.lex_state = 4, .external_lex_state = 2},
  [1441] = {.lex_state = 4, .external_lex_state = 2},
  [1442] = {.lex_state = 4, .external_lex_state = 2},
  [1443] = {.lex_state = 4, .external_lex_state = 2},
  [1444] = {.lex_state = 99},
  [1445] = {.lex_state = 4, .external_lex_state = 3},
  [1446] = {.lex_state = 99},
  [1447] = {.lex_state = 4, .external_lex_state = 2},
  [1448] = {.lex_state = 4, .external_lex_state = 2},
  [1449] = {.lex_state = 98},
  [1450] = {.lex_state = 4, .external_lex_state = 3},
  [1451] = {.lex_state = 4, .external_lex_state = 2},
  [1452] = {.lex_state = 4, .external_lex_state = 2},
  [1453] = {.lex_state = 4, .external_lex_state = 3},
  [1454] = {.lex_state = 98},
  [1455] = {.lex_state = 4, .external_lex_state = 2},
  [1456] = {.lex_state = 98},
  [1457] = {.lex_state = 4, .external_lex_state = 2},
  [1458] = {.lex_state = 4, .external_lex_state = 3},
  [1459] = {.lex_state = 4, .external_lex_state = 3},
  [1460] = {.lex_state = 4, .external_lex_state = 3},
  [1461] = {.lex_state = 98},
  [1462] = {.lex_state = 4, .external_lex_state = 3},
  [1463] = {.lex_state = 4, .external_lex_state = 3},
  [1464] = {.lex_state = 4, .external_lex_state = 3},
  [1465] = {.lex_state = 4, .external_lex_state = 2},
  [1466] = {.lex_state = 4, .external_lex_state = 3},
  [1467] = {.lex_state = 4, .external_lex_state = 3},
  [1468] = {.lex_state = 98},
  [1469] = {.lex_state = 98},
  [1470] = {.lex_state = 4, .external_lex_state = 2},
  [1471] = {.lex_state = 4, .external_lex_state = 3},
  [1472] = {.lex_state = 4, .external_lex_state = 3},
  [1473] = {.lex_state = 4, .external_lex_state = 2},
  [1474] = {.lex_state = 4, .external_lex_state = 3},
  [1475] = {.lex_state = 4, .external_lex_state = 2},
  [1476] = {.lex_state = 4, .external_lex_state = 2},
  [1477] = {.lex_state = 4, .external_lex_state = 3},
  [1478] = {.lex_state = 4, .external_lex_state = 3},
  [1479] = {.lex_state = 4, .external_lex_state = 3},
  [1480] = {.lex_state = 4, .external_lex_state = 3},
  [1481] = {.lex_state = 98},
  [1482] = {.lex_state = 4, .external_lex_state = 3},
  [1483] = {.lex_state = 4, .external_lex_state = 2},
  [1484] = {.lex_state = 4, .external_lex_state = 3},
  [1485] = {.lex_state = 4, .external_lex_state = 3},
  [1486] = {.lex_state = 4, .external_lex_state = 2},
  [1487] = {.lex_state = 4, .external_lex_state = 3},
  [1488] = {.lex_state = 4, .external_lex_state = 2},
  [1489] = {.lex_state = 98},
  [1490] = {.lex_state = 4, .external_lex_state = 2},
  [1491] = {.lex_state = 4, .external_lex_state = 2},
  [1492] = {.lex_state = 4, .external_lex_state = 2},
  [1493] = {.lex_state = 98},
  [1494] = {.lex_state = 98},
  [1495] = {.lex_state = 4, .external_lex_state = 3},
  [1496] = {.lex_state = 4, .external_lex_state = 2},
  [1497] = {.lex_state = 4, .external_lex_state = 2},
  [1498] = {.lex_state = 4, .external_lex_state = 2},
  [1499] = {.lex_state = 4, .external_lex_state = 3},
  [1500] = {.lex_state = 4, .external_lex_state = 3},
  [1501] = {.lex_state = 4, .external_lex_state = 2},
  [1502] = {.lex_state = 4, .external_lex_state = 2},
  [1503] = {.lex_state = 4, .external_lex_state = 2},
  [1504] = {.lex_state = 4, .external_lex_state = 2},
  [1505] = {.lex_state = 100, .external_lex_state = 4},
  [1506] = {.lex_state = 100, .external_lex_state = 4},
  [1507] = {.lex_state = 4, .external_lex_state = 2},
  [1508] = {.lex_state = 4, .external_lex_state = 2},
  [1509] = {.lex_state = 4, .external_lex_state = 2},
  [1510] = {.lex_state = 4, .external_lex_state = 2},
  [1511] = {.lex_state = 4, .external_lex_state = 2},
  [1512] = {.lex_state = 100},
  [1513] = {.lex_state = 100},
  [1514] = {.lex_state = 4, .external_lex_state = 2},
  [1515] = {.lex_state = 4, .external_lex_state = 2},
  [1516] = {.lex_state = 100},
  [1517] = {.lex_state = 100},
  [1518] = {.lex_state = 100},
  [1519] = {.lex_state = 100},
  [1520] = {.lex_state = 4, .external_lex_state = 2},
  [1521] = {.lex_state = 4, .external_lex_state = 2},
  [1522] = {.lex_state = 4, .external_lex_state = 2},
  [1523] = {.lex_state = 100},
  [1524] = {.lex_state = 100},
  [1525] = {.lex_state = 100},
  [1526] = {.lex_state = 100},
  [1527] = {.lex_state = 100},
  [1528] = {.lex_state = 100},
  [1529] = {.lex_state = 100},
  [1530] = {.lex_state = 100},
  [1531] = {.lex_state = 100},
  [1532] = {.lex_state = 100},
  [1533] = {.lex_state = 100},
  [1534] = {.lex_state = 100},
  [1535] = {.lex_state = 100},
  [1536] = {.lex_state = 100},
  [1537] = {.lex_state = 100},
  [1538] = {.lex_state = 100},
  [1539] = {.lex_state = 100},
  [1540] = {.lex_state = 100},
  [1541] = {.lex_state = 100},
  [1542] = {.lex_state = 100},
  [1543] = {.lex_state = 100},
  [1544] = {.lex_state = 100},
  [1545] = {.lex_state = 100},
  [1546] = {.lex_state = 100},
  [1547] = {.lex_state = 100},
  [1548] = {.lex_state = 100},
  [1549] = {.lex_state = 100},
  [1550] = {.lex_state = 100},
  [1551] = {.lex_state = 100},
  [1552] = {.lex_state = 100},
  [1553] = {.lex_state = 100},
  [1554] = {.lex_state = 100},
  [1555] = {.lex_state = 100},
  [1556] = {.lex_state = 100},
  [1557] = {.lex_state = 100},
  [1558] = {.lex_state = 100},
  [1559] = {.lex_state = 100},
  [1560] = {.lex_state = 100},
  [1561] = {.lex_state = 100},
  [1562] = {.lex_state = 100},
  [1563] = {.lex_state = 100},
  [1564] = {.lex_state = 100},
  [1565] = {.lex_state = 100},
  [1566] = {.lex_state = 100},
  [1567] = {.lex_state = 100},
  [1568] = {.lex_state = 100},
  [1569] = {.lex_state = 100},
  [1570] = {.lex_state = 100},
  [1571] = {.lex_state = 100},
  [1572] = {.lex_state = 100},
  [1573] = {.lex_state = 100},
  [1574] = {.lex_state = 100},
  [1575] = {.lex_state = 100},
  [1576] = {.lex_state = 100},
  [1577] = {.lex_state = 100},
  [1578] = {.lex_state = 100},
  [1579] = {.lex_state = 100},
  [1580] = {.lex_state = 100},
  [1581] = {.lex_state = 100},
  [1582] = {.lex_state = 100},
  [1583] = {.lex_state = 100},
  [1584] = {.lex_state = 100},
  [1585] = {.lex_state = 100},
  [1586] = {.lex_state = 100},
  [1587] = {.lex_state = 100},
  [1588] = {.lex_state = 100},
  [1589] = {.lex_state = 100},
  [1590] = {.lex_state = 100},
  [1591] = {.lex_state = 100},
  [1592] = {.lex_state = 100},
  [1593] = {.lex_state = 100},
  [1594] = {.lex_state = 100},
  [1595] = {.lex_state = 100},
  [1596] = {.lex_state = 100},
  [1597] = {.lex_state = 100},
  [1598] = {.lex_state = 100},
  [1599] = {.lex_state = 100},
  [1600] = {.lex_state = 15, .external_lex_state = 2},
  [1601] = {.lex_state = 98},
  [1602] = {.lex_state = 98},
  [1603] = {.lex_state = 98},
  [1604] = {.lex_state = 98},
  [1605] = {.lex_state = 98},
  [1606] = {.lex_state = 98},
  [1607] = {.lex_state = 15, .external_lex_state = 2},
  [1608] = {.lex_state = 98},
  [1609] = {.lex_state = 98},
  [1610] = {.lex_state = 98},
  [1611] = {.lex_state = 100},
  [1612] = {.lex_state = 15, .external_lex_state = 2},
  [1613] = {.lex_state = 15, .external_lex_state = 3},
  [1614] = {.lex_state = 15, .external_lex_state = 2},
  [1615] = {.lex_state = 100},
  [1616] = {.lex_state = 15, .external_lex_state = 2},
  [1617] = {.lex_state = 15, .external_lex_state = 2},
  [1618] = {.lex_state = 100},
  [1619] = {.lex_state = 15, .external_lex_state = 2},
  [1620] = {.lex_state = 15, .external_lex_state = 2},
  [1621] = {.lex_state = 100},
  [1622] = {.lex_state = 15, .external_lex_state = 2},
  [1623] = {.lex_state = 15, .external_lex_state = 2},
  [1624] = {.lex_state = 15, .external_lex_state = 2},
  [1625] = {.lex_state = 100},
  [1626] = {.lex_state = 15, .external_lex_state = 2},
  [1627] = {.lex_state = 100},
  [1628] = {.lex_state = 15, .external_lex_state = 2},
  [1629] = {.lex_state = 15, .external_lex_state = 2},
  [1630] = {.lex_state = 15, .external_lex_state = 2},
  [1631] = {.lex_state = 100},
  [1632] = {.lex_state = 100},
  [1633] = {.lex_state = 100},
  [1634] = {.lex_state = 100},
  [1635] = {.lex_state = 15, .external_lex_state = 2},
  [1636] = {.lex_state = 15, .external_lex_state = 2},
  [1637] = {.lex_state = 15, .external_lex_state = 2},
  [1638] = {.lex_state = 15, .external_lex_state = 2},
  [1639] = {.lex_state = 15, .external_lex_state = 2},
  [1640] = {.lex_state = 15, .external_lex_state = 2},
  [1641] = {.lex_state = 15, .external_lex_state = 2},
  [1642] = {.lex_state = 15, .external_lex_state = 2},
  [1643] = {.lex_state = 15, .external_lex_state = 2},
  [1644] = {.lex_state = 15, .external_lex_state = 2},
  [1645] = {.lex_state = 15, .external_lex_state = 2},
  [1646] = {.lex_state = 15, .external_lex_state = 2},
  [1647] = {.lex_state = 15, .external_lex_state = 2},
  [1648] = {.lex_state = 15, .external_lex_state = 2},
  [1649] = {.lex_state = 15, .external_lex_state = 3},
  [1650] = {.lex_state = 15, .external_lex_state = 2},
  [1651] = {.lex_state = 15, .external_lex_state = 2},
  [1652] = {.lex_state = 15, .external_lex_state = 2},
  [1653] = {.lex_state = 15, .external_lex_state = 2},
  [1654] = {.lex_state = 15, .external_lex_state = 2},
  [1655] = {.lex_state = 15, .external_lex_state = 2},
  [1656] = {.lex_state = 15, .external_lex_state = 2},
  [1657] = {.lex_state = 15, .external_lex_state = 2},
  [1658] = {.lex_state = 15, .external_lex_state = 2},
  [1659] = {.lex_state = 15, .external_lex_state = 2},
  [1660] = {.lex_state = 15, .external_lex_state = 2},
  [1661] = {.lex_state = 15, .external_lex_state = 2},
  [1662] = {.lex_state = 15, .external_lex_state = 2},
  [1663] = {.lex_state = 15, .external_lex_state = 2},
  [1664] = {.lex_state = 15, .external_lex_state = 2},
  [1665] = {.lex_state = 15, .external_lex_state = 2},
  [1666] = {.lex_state = 15, .external_lex_state = 2},
  [1667] = {.lex_state = 15, .external_lex_state = 2},
  [1668] = {.lex_state = 15, .external_lex_state = 2},
  [1669] = {.lex_state = 15, .external_lex_state = 2},
  [1670] = {.lex_state = 15, .external_lex_state = 2},
  [1671] = {.lex_state = 15, .external_lex_state = 2},
  [1672] = {.lex_state = 15, .external_lex_state = 2},
  [1673] = {.lex_state = 15, .external_lex_state = 3},
  [1674] = {.lex_state = 15, .external_lex_state = 2},
  [1675] = {.lex_state = 15, .external_lex_state = 2},
  [1676] = {.lex_state = 15, .external_lex_state = 2},
  [1677] = {.lex_state = 15, .external_lex_state = 2},
  [1678] = {.lex_state = 15, .external_lex_state = 2},
  [1679] = {.lex_state = 15, .external_lex_state = 2},
  [1680] = {.lex_state = 15, .external_lex_state = 2},
  [1681] = {.lex_state = 15, .external_lex_state = 2},
  [1682] = {.lex_state = 15, .external_lex_state = 2},
  [1683] = {.lex_state = 15, .external_lex_state = 2},
  [1684] = {.lex_state = 15, .external_lex_state = 3},
  [1685] = {.lex_state = 15, .external_lex_state = 2},
  [1686] = {.lex_state = 15, .external_lex_state = 2},
  [1687] = {.lex_state = 15, .external_lex_state = 2},
  [1688] = {.lex_state = 15, .external_lex_state = 2},
  [1689] = {.lex_state = 15, .external_lex_state = 2},
  [1690] = {.lex_state = 15, .external_lex_state = 2},
  [1691] = {.lex_state = 15, .external_lex_state = 2},
  [1692] = {.lex_state = 15, .external_lex_state = 2},
  [1693] = {.lex_state = 15, .external_lex_state = 2},
  [1694] = {.lex_state = 15, .external_lex_state = 2},
  [1695] = {.lex_state = 15, .external_lex_state = 2},
  [1696] = {.lex_state = 15, .external_lex_state = 2},
  [1697] = {.lex_state = 15, .external_lex_state = 2},
  [1698] = {.lex_state = 15, .external_lex_state = 2},
  [1699] = {.lex_state = 15, .external_lex_state = 2},
  [1700] = {.lex_state = 15, .external_lex_state = 2},
  [1701] = {.lex_state = 15, .external_lex_state = 2},
  [1702] = {.lex_state = 15, .external_lex_state = 2},
  [1703] = {.lex_state = 15, .external_lex_state = 2},
  [1704] = {.lex_state = 15, .external_lex_state = 2},
  [1705] = {.lex_state = 15, .external_lex_state = 2},
  [1706] = {.lex_state = 15, .external_lex_state = 2},
  [1707] = {.lex_state = 15, .external_lex_state = 2},
  [1708] = {.lex_state = 15, .external_lex_state = 2},
  [1709] = {.lex_state = 15, .external_lex_state = 2},
  [1710] = {.lex_state = 15, .external_lex_state = 2},
  [1711] = {.lex_state = 15, .external_lex_state = 2},
  [1712] = {.lex_state = 15, .external_lex_state = 2},
  [1713] = {.lex_state = 15, .external_lex_state = 2},
  [1714] = {.lex_state = 15, .external_lex_state = 2},
  [1715] = {.lex_state = 15, .external_lex_state = 2},
  [1716] = {.lex_state = 15, .external_lex_state = 2},
  [1717] = {.lex_state = 15, .external_lex_state = 2},
  [1718] = {.lex_state = 100},
  [1719] = {.lex_state = 15, .external_lex_state = 2},
  [1720] = {.lex_state = 15, .external_lex_state = 2},
  [1721] = {.lex_state = 15, .external_lex_state = 2},
  [1722] = {.lex_state = 15, .external_lex_state = 3},
  [1723] = {.lex_state = 15, .external_lex_state = 2},
  [1724] = {.lex_state = 15, .external_lex_state = 2},
  [1725] = {.lex_state = 15, .external_lex_state = 2},
  [1726] = {.lex_state = 15, .external_lex_state = 2},
  [1727] = {.lex_state = 15, .external_lex_state = 2},
  [1728] = {.lex_state = 15, .external_lex_state = 2},
  [1729] = {.lex_state = 15, .external_lex_state = 2},
  [1730] = {.lex_state = 15, .external_lex_state = 2},
  [1731] = {.lex_state = 15, .external_lex_state = 2},
  [1732] = {.lex_state = 15, .external_lex_state = 2},
  [1733] = {.lex_state = 15, .external_lex_state = 2},
  [1734] = {.lex_state = 15, .external_lex_state = 2},
  [1735] = {.lex_state = 15, .external_lex_state = 2},
  [1736] = {.lex_state = 15, .external_lex_state = 2},
  [1737] = {.lex_state = 15, .external_lex_state = 2},
  [1738] = {.lex_state = 98},
  [1739] = {.lex_state = 15, .external_lex_state = 2},
  [1740] = {.lex_state = 15, .external_lex_state = 3},
  [1741] = {.lex_state = 100},
  [1742] = {.lex_state = 15, .external_lex_state = 2},
  [1743] = {.lex_state = 15, .external_lex_state = 2},
  [1744] = {.lex_state = 15, .external_lex_state = 2},
  [1745] = {.lex_state = 100},
  [1746] = {.lex_state = 15, .external_lex_state = 3},
  [1747] = {.lex_state = 100},
  [1748] = {.lex_state = 100},
  [1749] = {.lex_state = 15, .external_lex_state = 2},
  [1750] = {.lex_state = 15, .external_lex_state = 2},
  [1751] = {.lex_state = 15, .external_lex_state = 2},
  [1752] = {.lex_state = 15, .external_lex_state = 2},
  [1753] = {.lex_state = 15, .external_lex_state = 2},
  [1754] = {.lex_state = 15, .external_lex_state = 2},
  [1755] = {.lex_state = 15, .external_lex_state = 2},
  [1756] = {.lex_state = 15, .external_lex_state = 2},
  [1757] = {.lex_state = 15, .external_lex_state = 2},
  [1758] = {.lex_state = 15, .external_lex_state = 2},
  [1759] = {.lex_state = 15, .external_lex_state = 2},
  [1760] = {.lex_state = 100},
  [1761] = {.lex_state = 15, .external_lex_state = 2},
  [1762] = {.lex_state = 15, .external_lex_state = 2},
  [1763] = {.lex_state = 15, .external_lex_state = 2},
  [1764] = {.lex_state = 100},
  [1765] = {.lex_state = 15, .external_lex_state = 2},
  [1766] = {.lex_state = 15, .external_lex_state = 2},
  [1767] = {.lex_state = 15, .external_lex_state = 2},
  [1768] = {.lex_state = 100},
  [1769] = {.lex_state = 100},
  [1770] = {.lex_state = 15, .external_lex_state = 2},
  [1771] = {.lex_state = 15, .external_lex_state = 2},
  [1772] = {.lex_state = 15, .external_lex_state = 2},
  [1773] = {.lex_state = 15, .external_lex_state = 2},
  [1774] = {.lex_state = 15, .external_lex_state = 2},
  [1775] = {.lex_state = 15, .external_lex_state = 2},
  [1776] = {.lex_state = 15, .external_lex_state = 2},
  [1777] = {.lex_state = 15, .external_lex_state = 2},
  [1778] = {.lex_state = 15, .external_lex_state = 2},
  [1779] = {.lex_state = 15, .external_lex_state = 2},
  [1780] = {.lex_state = 15, .external_lex_state = 2},
  [1781] = {.lex_state = 15, .external_lex_state = 2},
  [1782] = {.lex_state = 15, .external_lex_state = 2},
  [1783] = {.lex_state = 15, .external_lex_state = 2},
  [1784] = {.lex_state = 15, .external_lex_state = 2},
  [1785] = {.lex_state = 15, .external_lex_state = 2},
  [1786] = {.lex_state = 15, .external_lex_state = 2},
  [1787] = {.lex_state = 15, .external_lex_state = 3},
  [1788] = {.lex_state = 15, .external_lex_state = 3},
  [1789] = {.lex_state = 100},
  [1790] = {.lex_state = 100},
  [1791] = {.lex_state = 100},
  [1792] = {.lex_state = 15, .external_lex_state = 2},
  [1793] = {.lex_state = 15, .external_lex_state = 2},
  [1794] = {.lex_state = 15, .external_lex_state = 2},
  [1795] = {.lex_state = 15, .external_lex_state = 2},
  [1796] = {.lex_state = 15, .external_lex_state = 2},
  [1797] = {.lex_state = 15, .external_lex_state = 2},
  [1798] = {.lex_state = 15, .external_lex_state = 2},
  [1799] = {.lex_state = 15, .external_lex_state = 2},
  [1800] = {.lex_state = 15, .external_lex_state = 2},
  [1801] = {.lex_state = 15, .external_lex_state = 2},
  [1802] = {.lex_state = 15, .external_lex_state = 2},
  [1803] = {.lex_state = 100},
  [1804] = {.lex_state = 15, .external_lex_state = 2},
  [1805] = {.lex_state = 15, .external_lex_state = 2},
  [1806] = {.lex_state = 15, .external_lex_state = 2},
  [1807] = {.lex_state = 15, .external_lex_state = 2},
  [1808] = {.lex_state = 15, .external_lex_state = 2},
  [1809] = {.lex_state = 15, .external_lex_state = 2},
  [1810] = {.lex_state = 15, .external_lex_state = 2},
  [1811] = {.lex_state = 15, .external_lex_state = 2},
  [1812] = {.lex_state = 15, .external_lex_state = 2},
  [1813] = {.lex_state = 15, .external_lex_state = 2},
  [1814] = {.lex_state = 15, .external_lex_state = 2},
  [1815] = {.lex_state = 15, .external_lex_state = 2},
  [1816] = {.lex_state = 15, .external_lex_state = 2},
  [1817] = {.lex_state = 15, .external_lex_state = 2},
  [1818] = {.lex_state = 15, .external_lex_state = 2},
  [1819] = {.lex_state = 15, .external_lex_state = 2},
  [1820] = {.lex_state = 15, .external_lex_state = 2},
  [1821] = {.lex_state = 15, .external_lex_state = 2},
  [1822] = {.lex_state = 15, .external_lex_state = 2},
  [1823] = {.lex_state = 15, .external_lex_state = 2},
  [1824] = {.lex_state = 100},
  [1825] = {.lex_state = 15, .external_lex_state = 2},
  [1826] = {.lex_state = 15, .external_lex_state = 2},
  [1827] = {.lex_state = 15, .external_lex_state = 2},
  [1828] = {.lex_state = 15, .external_lex_state = 2},
  [1829] = {.lex_state = 15, .external_lex_state = 2},
  [1830] = {.lex_state = 15, .external_lex_state = 2},
  [1831] = {.lex_state = 15, .external_lex_state = 2},
  [1832] = {.lex_state = 15, .external_lex_state = 2},
  [1833] = {.lex_state = 15, .external_lex_state = 2},
  [1834] = {.lex_state = 15, .external_lex_state = 2},
  [1835] = {.lex_state = 15, .external_lex_state = 2},
  [1836] = {.lex_state = 15, .external_lex_state = 2},
  [1837] = {.lex_state = 15, .external_lex_state = 2},
  [1838] = {.lex_state = 15, .external_lex_state = 2},
  [1839] = {.lex_state = 15, .external_lex_state = 2},
  [1840] = {.lex_state = 15, .external_lex_state = 2},
  [1841] = {.lex_state = 15, .external_lex_state = 2},
  [1842] = {.lex_state = 15, .external_lex_state = 2},
  [1843] = {.lex_state = 15, .external_lex_state = 2},
  [1844] = {.lex_state = 15, .external_lex_state = 2},
  [1845] = {.lex_state = 100, .external_lex_state = 4},
  [1846] = {.lex_state = 15, .external_lex_state = 3},
  [1847] = {.lex_state = 100, .external_lex_state = 4},
  [1848] = {.lex_state = 15, .external_lex_state = 3},
  [1849] = {.lex_state = 15, .external_lex_state = 2},
  [1850] = {.lex_state = 15, .external_lex_state = 3},
  [1851] = {.lex_state = 15, .external_lex_state = 3},
  [1852] = {.lex_state = 15, .external_lex_state = 2},
  [1853] = {.lex_state = 15, .external_lex_state = 3},
  [1854] = {.lex_state = 15, .external_lex_state = 2},
  [1855] = {.lex_state = 15, .external_lex_state = 3},
  [1856] = {.lex_state = 15, .external_lex_state = 3},
  [1857] = {.lex_state = 100, .external_lex_state = 4},
  [1858] = {.lex_state = 15, .external_lex_state = 3},
  [1859] = {.lex_state = 15, .external_lex_state = 3},
  [1860] = {.lex_state = 100, .external_lex_state = 4},
  [1861] = {.lex_state = 15, .external_lex_state = 2},
  [1862] = {.lex_state = 15, .external_lex_state = 3},
  [1863] = {.lex_state = 15, .external_lex_state = 3},
  [1864] = {.lex_state = 15, .external_lex_state = 3},
  [1865] = {.lex_state = 15, .external_lex_state = 2},
  [1866] = {.lex_state = 15, .external_lex_state = 3},
  [1867] = {.lex_state = 15, .external_lex_state = 2},
  [1868] = {.lex_state = 15, .external_lex_state = 2},
  [1869] = {.lex_state = 15, .external_lex_state = 3},
  [1870] = {.lex_state = 15, .external_lex_state = 2},
  [1871] = {.lex_state = 15, .external_lex_state = 3},
  [1872] = {.lex_state = 15, .external_lex_state = 2},
  [1873] = {.lex_state = 15, .external_lex_state = 3},
  [1874] = {.lex_state = 15, .external_lex_state = 3},
  [1875] = {.lex_state = 15, .external_lex_state = 3},
  [1876] = {.lex_state = 15, .external_lex_state = 3},
  [1877] = {.lex_state = 15, .external_lex_state = 3},
  [1878] = {.lex_state = 15, .external_lex_state = 3},
  [1879] = {.lex_state = 15, .external_lex_state = 3},
  [1880] = {.lex_state = 15, .external_lex_state = 3},
  [1881] = {.lex_state = 15, .external_lex_state = 3},
  [1882] = {.lex_state = 15, .external_lex_state = 3},
  [1883] = {.lex_state = 15, .external_lex_state = 3},
  [1884] = {.lex_state = 15, .external_lex_state = 3},
  [1885] = {.lex_state = 15, .external_lex_state = 3},
  [1886] = {.lex_state = 15, .external_lex_state = 3},
  [1887] = {.lex_state = 15, .external_lex_state = 3},
  [1888] = {.lex_state = 15, .external_lex_state = 3},
  [1889] = {.lex_state = 15, .external_lex_state = 2},
  [1890] = {.lex_state = 15, .external_lex_state = 3},
  [1891] = {.lex_state = 15, .external_lex_state = 3},
  [1892] = {.lex_state = 15, .external_lex_state = 2},
  [1893] = {.lex_state = 15, .external_lex_state = 3},
  [1894] = {.lex_state = 15, .external_lex_state = 3},
  [1895] = {.lex_state = 15, .external_lex_state = 3},
  [1896] = {.lex_state = 15, .external_lex_state = 3},
  [1897] = {.lex_state = 15, .external_lex_state = 3},
  [1898] = {.lex_state = 15, .external_lex_state = 3},
  [1899] = {.lex_state = 15, .external_lex_state = 3},
  [1900] = {.lex_state = 15, .external_lex_state = 3},
  [1901] = {.lex_state = 15, .external_lex_state = 3},
  [1902] = {.lex_state = 15, .external_lex_state = 2},
  [1903] = {.lex_state = 15, .external_lex_state = 3},
  [1904] = {.lex_state = 15, .external_lex_state = 3},
  [1905] = {.lex_state = 15, .external_lex_state = 3},
  [1906] = {.lex_state = 15, .external_lex_state = 2},
  [1907] = {.lex_state = 15, .external_lex_state = 3},
  [1908] = {.lex_state = 15, .external_lex_state = 3},
  [1909] = {.lex_state = 15, .external_lex_state = 3},
  [1910] = {.lex_state = 100, .external_lex_state = 4},
  [1911] = {.lex_state = 15, .external_lex_state = 3},
  [1912] = {.lex_state = 15, .external_lex_state = 3},
  [1913] = {.lex_state = 15, .external_lex_state = 3},
  [1914] = {.lex_state = 15, .external_lex_state = 3},
  [1915] = {.lex_state = 15, .external_lex_state = 3},
  [1916] = {.lex_state = 100, .external_lex_state = 4},
  [1917] = {.lex_state = 15, .external_lex_state = 2},
  [1918] = {.lex_state = 15, .external_lex_state = 2},
  [1919] = {.lex_state = 15, .external_lex_state = 3},
  [1920] = {.lex_state = 15, .external_lex_state = 3},
  [1921] = {.lex_state = 15, .external_lex_state = 3},
  [1922] = {.lex_state = 15, .external_lex_state = 2},
  [1923] = {.lex_state = 15, .external_lex_state = 3},
  [1924] = {.lex_state = 15, .external_lex_state = 3},
  [1925] = {.lex_state = 15, .external_lex_state = 3},
  [1926] = {.lex_state = 15, .external_lex_state = 3},
  [1927] = {.lex_state = 15, .external_lex_state = 2},
  [1928] = {.lex_state = 15, .external_lex_state = 2},
  [1929] = {.lex_state = 15, .external_lex_state = 3},
  [1930] = {.lex_state = 15, .external_lex_state = 3},
  [1931] = {.lex_state = 15, .external_lex_state = 2},
  [1932] = {.lex_state = 15, .external_lex_state = 3},
  [1933] = {.lex_state = 15, .external_lex_state = 3},
  [1934] = {.lex_state = 15, .external_lex_state = 3},
  [1935] = {.lex_state = 15, .external_lex_state = 3},
  [1936] = {.lex_state = 15, .external_lex_state = 2},
  [1937] = {.lex_state = 15, .external_lex_state = 3},
  [1938] = {.lex_state = 15, .external_lex_state = 3},
  [1939] = {.lex_state = 15, .external_lex_state = 3},
  [1940] = {.lex_state = 15, .external_lex_state = 2},
  [1941] = {.lex_state = 15, .external_lex_state = 2},
  [1942] = {.lex_state = 15, .external_lex_state = 3},
  [1943] = {.lex_state = 15, .external_lex_state = 3},
  [1944] = {.lex_state = 15, .external_lex_state = 3},
  [1945] = {.lex_state = 15, .external_lex_state = 3},
  [1946] = {.lex_state = 15, .external_lex_state = 3},
  [1947] = {.lex_state = 100, .external_lex_state = 4},
  [1948] = {.lex_state = 15, .external_lex_state = 2},
  [1949] = {.lex_state = 100, .external_lex_state = 4},
  [1950] = {.lex_state = 15, .external_lex_state = 3},
  [1951] = {.lex_state = 13, .external_lex_state = 2},
  [1952] = {.lex_state = 99, .external_lex_state = 4},
  [1953] = {.lex_state = 100, .external_lex_state = 4},
  [1954] = {.lex_state = 15, .external_lex_state = 3},
  [1955] = {.lex_state = 15, .external_lex_state = 3},
  [1956] = {.lex_state = 15, .external_lex_state = 3},
  [1957] = {.lex_state = 100, .external_lex_state = 4},
  [1958] = {.lex_state = 15, .external_lex_state = 3},
  [1959] = {.lex_state = 15, .external_lex_state = 3},
  [1960] = {.lex_state = 15, .external_lex_state = 3},
  [1961] = {.lex_state = 15, .external_lex_state = 3},
  [1962] = {.lex_state = 15, .external_lex_state = 3},
  [1963] = {.lex_state = 15, .external_lex_state = 3},
  [1964] = {.lex_state = 15, .external_lex_state = 3},
  [1965] = {.lex_state = 15, .external_lex_state = 3},
  [1966] = {.lex_state = 15, .external_lex_state = 3},
  [1967] = {.lex_state = 15, .external_lex_state = 3},
  [1968] = {.lex_state = 15, .external_lex_state = 3},
  [1969] = {.lex_state = 15, .external_lex_state = 3},
  [1970] = {.lex_state = 15, .external_lex_state = 2},
  [1971] = {.lex_state = 15, .external_lex_state = 2},
  [1972] = {.lex_state = 15, .external_lex_state = 3},
  [1973] = {.lex_state = 15, .external_lex_state = 2},
  [1974] = {.lex_state = 15, .external_lex_state = 3},
  [1975] = {.lex_state = 15, .external_lex_state = 3},
  [1976] = {.lex_state = 15, .external_lex_state = 3},
  [1977] = {.lex_state = 15, .external_lex_state = 2},
  [1978] = {.lex_state = 15, .external_lex_state = 2},
  [1979] = {.lex_state = 15, .external_lex_state = 3},
  [1980] = {.lex_state = 15, .external_lex_state = 2},
  [1981] = {.lex_state = 15, .external_lex_state = 2},
  [1982] = {.lex_state = 15, .external_lex_state = 2},
  [1983] = {.lex_state = 15, .external_lex_state = 2},
  [1984] = {.lex_state = 15, .external_lex_state = 3},
  [1985] = {.lex_state = 15, .external_lex_state = 2},
  [1986] = {.lex_state = 15, .external_lex_state = 2},
  [1987] = {.lex_state = 15, .external_lex_state = 2},
  [1988] = {.lex_state = 15, .external_lex_state = 2},
  [1989] = {.lex_state = 15, .external_lex_state = 2},
  [1990] = {.lex_state = 15, .external_lex_state = 3},
  [1991] = {.lex_state = 15, .external_lex_state = 3},
  [1992] = {.lex_state = 15, .external_lex_state = 3},
  [1993] = {.lex_state = 15, .external_lex_state = 2},
  [1994] = {.lex_state = 15, .external_lex_state = 2},
  [1995] = {.lex_state = 15, .external_lex_state = 3},
  [1996] = {.lex_state = 15, .external_lex_state = 2},
  [1997] = {.lex_state = 15, .external_lex_state = 3},
  [1998] = {.lex_state = 15, .external_lex_state = 3},
  [1999] = {.lex_state = 15, .external_lex_state = 3},
  [2000] = {.lex_state = 15, .external_lex_state = 3},
  [2001] = {.lex_state = 15, .external_lex_state = 2},
  [2002] = {.lex_state = 15, .external_lex_state = 2},
  [2003] = {.lex_state = 15, .external_lex_state = 3},
  [2004] = {.lex_state = 15, .external_lex_state = 3},
  [2005] = {.lex_state = 15, .external_lex_state = 3},
  [2006] = {.lex_state = 100, .external_lex_state = 4},
  [2007] = {.lex_state = 15, .external_lex_state = 3},
  [2008] = {.lex_state = 15, .external_lex_state = 3},
  [2009] = {.lex_state = 15, .external_lex_state = 3},
  [2010] = {.lex_state = 15, .external_lex_state = 3},
  [2011] = {.lex_state = 15, .external_lex_state = 3},
  [2012] = {.lex_state = 15, .external_lex_state = 3},
  [2013] = {.lex_state = 15, .external_lex_state = 3},
  [2014] = {.lex_state = 15, .external_lex_state = 3},
  [2015] = {.lex_state = 15, .external_lex_state = 3},
  [2016] = {.lex_state = 100, .external_lex_state = 4},
  [2017] = {.lex_state = 15, .external_lex_state = 3},
  [2018] = {.lex_state = 15, .external_lex_state = 3},
  [2019] = {.lex_state = 15, .external_lex_state = 3},
  [2020] = {.lex_state = 15, .external_lex_state = 3},
  [2021] = {.lex_state = 15, .external_lex_state = 2},
  [2022] = {.lex_state = 15, .external_lex_state = 3},
  [2023] = {.lex_state = 15, .external_lex_state = 2},
  [2024] = {.lex_state = 15, .external_lex_state = 3},
  [2025] = {.lex_state = 15, .external_lex_state = 3},
  [2026] = {.lex_state = 15, .external_lex_state = 3},
  [2027] = {.lex_state = 15, .external_lex_state = 3},
  [2028] = {.lex_state = 15, .external_lex_state = 3},
  [2029] = {.lex_state = 15, .external_lex_state = 3},
  [2030] = {.lex_state = 15, .external_lex_state = 3},
  [2031] = {.lex_state = 15, .external_lex_state = 3},
  [2032] = {.lex_state = 15, .external_lex_state = 3},
  [2033] = {.lex_state = 15, .external_lex_state = 3},
  [2034] = {.lex_state = 15, .external_lex_state = 3},
  [2035] = {.lex_state = 15, .external_lex_state = 3},
  [2036] = {.lex_state = 15, .external_lex_state = 2},
  [2037] = {.lex_state = 15, .external_lex_state = 2},
  [2038] = {.lex_state = 15, .external_lex_state = 3},
  [2039] = {.lex_state = 15, .external_lex_state = 3},
  [2040] = {.lex_state = 15, .external_lex_state = 3},
  [2041] = {.lex_state = 15, .external_lex_state = 2},
  [2042] = {.lex_state = 15, .external_lex_state = 3},
  [2043] = {.lex_state = 15, .external_lex_state = 3},
  [2044] = {.lex_state = 15, .external_lex_state = 3},
  [2045] = {.lex_state = 15, .external_lex_state = 3},
  [2046] = {.lex_state = 15, .external_lex_state = 3},
  [2047] = {.lex_state = 15, .external_lex_state = 3},
  [2048] = {.lex_state = 15, .external_lex_state = 3},
  [2049] = {.lex_state = 15, .external_lex_state = 3},
  [2050] = {.lex_state = 15, .external_lex_state = 3},
  [2051] = {.lex_state = 15, .external_lex_state = 3},
  [2052] = {.lex_state = 15, .external_lex_state = 3},
  [2053] = {.lex_state = 15, .external_lex_state = 3},
  [2054] = {.lex_state = 15, .external_lex_state = 3},
  [2055] = {.lex_state = 15, .external_lex_state = 3},
  [2056] = {.lex_state = 15, .external_lex_state = 3},
  [2057] = {.lex_state = 15, .external_lex_state = 3},
  [2058] = {.lex_state = 15, .external_lex_state = 2},
  [2059] = {.lex_state = 15, .external_lex_state = 3},
  [2060] = {.lex_state = 15, .external_lex_state = 3},
  [2061] = {.lex_state = 15, .external_lex_state = 3},
  [2062] = {.lex_state = 15, .external_lex_state = 3},
  [2063] = {.lex_state = 15, .external_lex_state = 3},
  [2064] = {.lex_state = 15, .external_lex_state = 3},
  [2065] = {.lex_state = 15, .external_lex_state = 3},
  [2066] = {.lex_state = 15, .external_lex_state = 3},
  [2067] = {.lex_state = 15, .external_lex_state = 2},
  [2068] = {.lex_state = 15, .external_lex_state = 3},
  [2069] = {.lex_state = 15, .external_lex_state = 3},
  [2070] = {.lex_state = 15, .external_lex_state = 2},
  [2071] = {.lex_state = 15, .external_lex_state = 3},
  [2072] = {.lex_state = 15, .external_lex_state = 2},
  [2073] = {.lex_state = 15, .external_lex_state = 3},
  [2074] = {.lex_state = 15, .external_lex_state = 3},
  [2075] = {.lex_state = 15, .external_lex_state = 3},
  [2076] = {.lex_state = 15, .external_lex_state = 3},
  [2077] = {.lex_state = 15, .external_lex_state = 3},
  [2078] = {.lex_state = 15, .external_lex_state = 3},
  [2079] = {.lex_state = 15, .external_lex_state = 2},
  [2080] = {.lex_state = 15, .external_lex_state = 3},
  [2081] = {.lex_state = 15, .external_lex_state = 3},
  [2082] = {.lex_state = 15, .external_lex_state = 3},
  [2083] = {.lex_state = 15, .external_lex_state = 3},
  [2084] = {.lex_state = 15, .external_lex_state = 3},
  [2085] = {.lex_state = 15, .external_lex_state = 3},
  [2086] = {.lex_state = 15, .external_lex_state = 3},
  [2087] = {.lex_state = 15, .external_lex_state = 3},
  [2088] = {.lex_state = 15, .external_lex_state = 3},
  [2089] = {.lex_state = 15, .external_lex_state = 2},
  [2090] = {.lex_state = 15, .external_lex_state = 2},
  [2091] = {.lex_state = 15, .external_lex_state = 2},
  [2092] = {.lex_state = 15, .external_lex_state = 2},
  [2093] = {.lex_state = 15, .external_lex_state = 2},
  [2094] = {.lex_state = 15, .external_lex_state = 2},
  [2095] = {.lex_state = 15, .external_lex_state = 3},
  [2096] = {.lex_state = 15, .external_lex_state = 2},
  [2097] = {.lex_state = 15, .external_lex_state = 2},
  [2098] = {.lex_state = 15, .external_lex_state = 3},
  [2099] = {.lex_state = 15, .external_lex_state = 3},
  [2100] = {.lex_state = 15, .external_lex_state = 2},
  [2101] = {.lex_state = 15, .external_lex_state = 3},
  [2102] = {.lex_state = 15, .external_lex_state = 3},
  [2103] = {.lex_state = 15, .external_lex_state = 2},
  [2104] = {.lex_state = 15, .external_lex_state = 2},
  [2105] = {.lex_state = 15, .external_lex_state = 2},
  [2106] = {.lex_state = 15, .external_lex_state = 2},
  [2107] = {.lex_state = 15, .external_lex_state = 2},
  [2108] = {.lex_state = 15, .external_lex_state = 3},
  [2109] = {.lex_state = 15, .external_lex_state = 3},
  [2110] = {.lex_state = 15, .external_lex_state = 3},
  [2111] = {.lex_state = 15, .external_lex_state = 2},
  [2112] = {.lex_state = 15, .external_lex_state = 2},
  [2113] = {.lex_state = 15, .external_lex_state = 2},
  [2114] = {.lex_state = 15, .external_lex_state = 2},
  [2115] = {.lex_state = 15, .external_lex_state = 2},
  [2116] = {.lex_state = 15, .external_lex_state = 3},
  [2117] = {.lex_state = 15, .external_lex_state = 2},
  [2118] = {.lex_state = 15, .external_lex_state = 2},
  [2119] = {.lex_state = 15, .external_lex_state = 2},
  [2120] = {.lex_state = 15, .external_lex_state = 3},
  [2121] = {.lex_state = 15, .external_lex_state = 2},
  [2122] = {.lex_state = 15, .external_lex_state = 2},
  [2123] = {.lex_state = 15, .external_lex_state = 2},
  [2124] = {.lex_state = 15, .external_lex_state = 3},
  [2125] = {.lex_state = 15, .external_lex_state = 3},
  [2126] = {.lex_state = 15, .external_lex_state = 2},
  [2127] = {.lex_state = 15, .external_lex_state = 3},
  [2128] = {.lex_state = 15, .external_lex_state = 2},
  [2129] = {.lex_state = 15, .external_lex_state = 3},
  [2130] = {.lex_state = 15, .external_lex_state = 2},
  [2131] = {.lex_state = 15, .external_lex_state = 3},
  [2132] = {.lex_state = 100, .external_lex_state = 4},
  [2133] = {.lex_state = 15, .external_lex_state = 3},
  [2134] = {.lex_state = 15, .external_lex_state = 3},
  [2135] = {.lex_state = 15, .external_lex_state = 2},
  [2136] = {.lex_state = 15, .external_lex_state = 2},
  [2137] = {.lex_state = 15, .external_lex_state = 3},
  [2138] = {.lex_state = 15, .external_lex_state = 3},
  [2139] = {.lex_state = 15, .external_lex_state = 2},
  [2140] = {.lex_state = 15, .external_lex_state = 2},
  [2141] = {.lex_state = 15, .external_lex_state = 2},
  [2142] = {.lex_state = 15, .external_lex_state = 2},
  [2143] = {.lex_state = 15, .external_lex_state = 2},
  [2144] = {.lex_state = 15, .external_lex_state = 2},
  [2145] = {.lex_state = 15, .external_lex_state = 2},
  [2146] = {.lex_state = 15, .external_lex_state = 2},
  [2147] = {.lex_state = 15, .external_lex_state = 3},
  [2148] = {.lex_state = 15, .external_lex_state = 3},
  [2149] = {.lex_state = 15, .external_lex_state = 3},
  [2150] = {.lex_state = 15, .external_lex_state = 2},
  [2151] = {.lex_state = 15, .external_lex_state = 3},
  [2152] = {.lex_state = 15, .external_lex_state = 3},
  [2153] = {.lex_state = 15, .external_lex_state = 3},
  [2154] = {.lex_state = 15, .external_lex_state = 3},
  [2155] = {.lex_state = 15, .external_lex_state = 3},
  [2156] = {.lex_state = 15, .external_lex_state = 3},
  [2157] = {.lex_state = 15, .external_lex_state = 3},
  [2158] = {.lex_state = 15, .external_lex_state = 2},
  [2159] = {.lex_state = 15, .external_lex_state = 3},
  [2160] = {.lex_state = 15, .external_lex_state = 2},
  [2161] = {.lex_state = 15, .external_lex_state = 3},
  [2162] = {.lex_state = 15, .external_lex_state = 3},
  [2163] = {.lex_state = 15, .external_lex_state = 2},
  [2164] = {.lex_state = 15, .external_lex_state = 2},
  [2165] = {.lex_state = 15, .external_lex_state = 3},
  [2166] = {.lex_state = 15, .external_lex_state = 3},
  [2167] = {.lex_state = 15, .external_lex_state = 3},
  [2168] = {.lex_state = 15, .external_lex_state = 3},
  [2169] = {.lex_state = 15, .external_lex_state = 2},
  [2170] = {.lex_state = 15, .external_lex_state = 3},
  [2171] = {.lex_state = 15, .external_lex_state = 3},
  [2172] = {.lex_state = 15, .external_lex_state = 2},
  [2173] = {.lex_state = 15, .external_lex_state = 2},
  [2174] = {.lex_state = 15, .external_lex_state = 2},
  [2175] = {.lex_state = 15, .external_lex_state = 2},
  [2176] = {.lex_state = 15, .external_lex_state = 3},
  [2177] = {.lex_state = 15, .external_lex_state = 3},
  [2178] = {.lex_state = 15, .external_lex_state = 3},
  [2179] = {.lex_state = 15, .external_lex_state = 2},
  [2180] = {.lex_state = 15, .external_lex_state = 3},
  [2181] = {.lex_state = 15, .external_lex_state = 3},
  [2182] = {.lex_state = 15, .external_lex_state = 3},
  [2183] = {.lex_state = 15, .external_lex_state = 2},
  [2184] = {.lex_state = 15, .external_lex_state = 3},
  [2185] = {.lex_state = 15, .external_lex_state = 2},
  [2186] = {.lex_state = 15, .external_lex_state = 3},
  [2187] = {.lex_state = 15, .external_lex_state = 3},
  [2188] = {.lex_state = 15, .external_lex_state = 2},
  [2189] = {.lex_state = 15, .external_lex_state = 2},
  [2190] = {.lex_state = 15, .external_lex_state = 3},
  [2191] = {.lex_state = 15, .external_lex_state = 2},
  [2192] = {.lex_state = 15, .external_lex_state = 3},
  [2193] = {.lex_state = 15, .external_lex_state = 3},
  [2194] = {.lex_state = 15, .external_lex_state = 3},
  [2195] = {.lex_state = 15, .external_lex_state = 3},
  [2196] = {.lex_state = 15, .external_lex_state = 2},
  [2197] = {.lex_state = 15, .external_lex_state = 3},
  [2198] = {.lex_state = 15, .external_lex_state = 3},
  [2199] = {.lex_state = 15, .external_lex_state = 2},
  [2200] = {.lex_state = 15, .external_lex_state = 2},
  [2201] = {.lex_state = 15, .external_lex_state = 2},
  [2202] = {.lex_state = 15, .external_lex_state = 3},
  [2203] = {.lex_state = 15, .external_lex_state = 3},
  [2204] = {.lex_state = 15, .external_lex_state = 2},
  [2205] = {.lex_state = 15, .external_lex_state = 3},
  [2206] = {.lex_state = 15, .external_lex_state = 2},
  [2207] = {.lex_state = 15, .external_lex_state = 2},
  [2208] = {.lex_state = 15, .external_lex_state = 3},
  [2209] = {.lex_state = 15, .external_lex_state = 3},
  [2210] = {.lex_state = 15, .external_lex_state = 3},
  [2211] = {.lex_state = 15, .external_lex_state = 3},
  [2212] = {.lex_state = 15, .external_lex_state = 3},
  [2213] = {.lex_state = 15, .external_lex_state = 2},
  [2214] = {.lex_state = 15, .external_lex_state = 3},
  [2215] = {.lex_state = 15, .external_lex_state = 2},
  [2216] = {.lex_state = 15, .external_lex_state = 2},
  [2217] = {.lex_state = 15, .external_lex_state = 2},
  [2218] = {.lex_state = 15, .external_lex_state = 2},
  [2219] = {.lex_state = 15, .external_lex_state = 3},
  [2220] = {.lex_state = 15, .external_lex_state = 2},
  [2221] = {.lex_state = 15, .external_lex_state = 2},
  [2222] = {.lex_state = 15, .external_lex_state = 3},
  [2223] = {.lex_state = 15, .external_lex_state = 3},
  [2224] = {.lex_state = 15, .external_lex_state = 3},
  [2225] = {.lex_state = 15, .external_lex_state = 3},
  [2226] = {.lex_state = 15, .external_lex_state = 3},
  [2227] = {.lex_state = 15, .external_lex_state = 3},
  [2228] = {.lex_state = 15, .external_lex_state = 3},
  [2229] = {.lex_state = 13, .external_lex_state = 3},
  [2230] = {.lex_state = 15, .external_lex_state = 3},
  [2231] = {.lex_state = 15, .external_lex_state = 3},
  [2232] = {.lex_state = 15, .external_lex_state = 2},
  [2233] = {.lex_state = 15, .external_lex_state = 3},
  [2234] = {.lex_state = 15, .external_lex_state = 2},
  [2235] = {.lex_state = 15, .external_lex_state = 3},
  [2236] = {.lex_state = 15, .external_lex_state = 2},
  [2237] = {.lex_state = 15, .external_lex_state = 3},
  [2238] = {.lex_state = 15, .external_lex_state = 2},
  [2239] = {.lex_state = 15, .external_lex_state = 2},
  [2240] = {.lex_state = 15, .external_lex_state = 3},
  [2241] = {.lex_state = 15, .external_lex_state = 3},
  [2242] = {.lex_state = 15, .external_lex_state = 3},
  [2243] = {.lex_state = 15, .external_lex_state = 2},
  [2244] = {.lex_state = 15, .external_lex_state = 3},
  [2245] = {.lex_state = 15, .external_lex_state = 3},
  [2246] = {.lex_state = 15, .external_lex_state = 3},
  [2247] = {.lex_state = 15, .external_lex_state = 3},
  [2248] = {.lex_state = 15, .external_lex_state = 3},
  [2249] = {.lex_state = 15, .external_lex_state = 3},
  [2250] = {.lex_state = 15, .external_lex_state = 2},
  [2251] = {.lex_state = 15, .external_lex_state = 3},
  [2252] = {.lex_state = 15, .external_lex_state = 2},
  [2253] = {.lex_state = 15, .external_lex_state = 3},
  [2254] = {.lex_state = 100, .external_lex_state = 4},
  [2255] = {.lex_state = 15, .external_lex_state = 3},
  [2256] = {.lex_state = 15, .external_lex_state = 3},
  [2257] = {.lex_state = 100, .external_lex_state = 4},
  [2258] = {.lex_state = 15, .external_lex_state = 3},
  [2259] = {.lex_state = 15, .external_lex_state = 3},
  [2260] = {.lex_state = 15, .external_lex_state = 3},
  [2261] = {.lex_state = 15, .external_lex_state = 3},
  [2262] = {.lex_state = 15, .external_lex_state = 2},
  [2263] = {.lex_state = 15, .external_lex_state = 2},
  [2264] = {.lex_state = 15, .external_lex_state = 3},
  [2265] = {.lex_state = 15, .external_lex_state = 3},
  [2266] = {.lex_state = 15, .external_lex_state = 3},
  [2267] = {.lex_state = 15, .external_lex_state = 3},
  [2268] = {.lex_state = 15, .external_lex_state = 3},
  [2269] = {.lex_state = 15, .external_lex_state = 3},
  [2270] = {.lex_state = 15, .external_lex_state = 3},
  [2271] = {.lex_state = 15, .external_lex_state = 3},
  [2272] = {.lex_state = 15, .external_lex_state = 3},
  [2273] = {.lex_state = 15, .external_lex_state = 3},
  [2274] = {.lex_state = 15, .external_lex_state = 3},
  [2275] = {.lex_state = 15, .external_lex_state = 3},
  [2276] = {.lex_state = 15, .external_lex_state = 3},
  [2277] = {.lex_state = 15, .external_lex_state = 2},
  [2278] = {.lex_state = 15, .external_lex_state = 3},
  [2279] = {.lex_state = 15, .external_lex_state = 3},
  [2280] = {.lex_state = 15, .external_lex_state = 2},
  [2281] = {.lex_state = 15, .external_lex_state = 3},
  [2282] = {.lex_state = 100, .external_lex_state = 4},
  [2283] = {.lex_state = 15, .external_lex_state = 3},
  [2284] = {.lex_state = 100, .external_lex_state = 4},
  [2285] = {.lex_state = 15, .external_lex_state = 2},
  [2286] = {.lex_state = 100, .external_lex_state = 4},
  [2287] = {.lex_state = 15, .external_lex_state = 3},
  [2288] = {.lex_state = 15, .external_lex_state = 2},
  [2289] = {.lex_state = 15, .external_lex_state = 3},
  [2290] = {.lex_state = 15, .external_lex_state = 3},
  [2291] = {.lex_state = 15, .external_lex_state = 3},
  [2292] = {.lex_state = 15, .external_lex_state = 3},
  [2293] = {.lex_state = 15, .external_lex_state = 3},
  [2294] = {.lex_state = 15, .external_lex_state = 2},
  [2295] = {.lex_state = 15, .external_lex_state = 3},
  [2296] = {.lex_state = 15, .external_lex_state = 3},
  [2297] = {.lex_state = 15, .external_lex_state = 2},
  [2298] = {.lex_state = 15, .external_lex_state = 2},
  [2299] = {.lex_state = 15, .external_lex_state = 2},
  [2300] = {.lex_state = 15, .external_lex_state = 3},
  [2301] = {.lex_state = 15, .external_lex_state = 3},
  [2302] = {.lex_state = 15, .external_lex_state = 3},
  [2303] = {.lex_state = 15, .external_lex_state = 3},
  [2304] = {.lex_state = 15, .external_lex_state = 3},
  [2305] = {.lex_state = 15, .external_lex_state = 2},
  [2306] = {.lex_state = 15, .external_lex_state = 2},
  [2307] = {.lex_state = 15, .external_lex_state = 2},
  [2308] = {.lex_state = 15, .external_lex_state = 3},
  [2309] = {.lex_state = 15, .external_lex_state = 2},
  [2310] = {.lex_state = 15, .external_lex_state = 2},
  [2311] = {.lex_state = 15, .external_lex_state = 3},
  [2312] = {.lex_state = 13, .external_lex_state = 3},
  [2313] = {.lex_state = 15, .external_lex_state = 3},
  [2314] = {.lex_state = 15, .external_lex_state = 3},
  [2315] = {.lex_state = 15, .external_lex_state = 2},
  [2316] = {.lex_state = 15, .external_lex_state = 2},
  [2317] = {.lex_state = 15, .external_lex_state = 2},
  [2318] = {.lex_state = 15, .external_lex_state = 2},
  [2319] = {.lex_state = 15, .external_lex_state = 2},
  [2320] = {.lex_state = 15, .external_lex_state = 2},
  [2321] = {.lex_state = 100},
  [2322] = {.lex_state = 15, .external_lex_state = 2},
  [2323] = {.lex_state = 100, .external_lex_state = 4},
  [2324] = {.lex_state = 100},
  [2325] = {.lex_state = 15, .external_lex_state = 2},
  [2326] = {.lex_state = 15, .external_lex_state = 2},
  [2327] = {.lex_state = 15, .external_lex_state = 2},
  [2328] = {.lex_state = 15, .external_lex_state = 2},
  [2329] = {.lex_state = 100},
  [2330] = {.lex_state = 15, .external_lex_state = 2},
  [2331] = {.lex_state = 100, .external_lex_state = 4},
  [2332] = {.lex_state = 100, .external_lex_state = 4},
  [2333] = {.lex_state = 15, .external_lex_state = 2},
  [2334] = {.lex_state = 15, .external_lex_state = 2},
  [2335] = {.lex_state = 15, .external_lex_state = 2},
  [2336] = {.lex_state = 100, .external_lex_state = 4},
  [2337] = {.lex_state = 15, .external_lex_state = 2},
  [2338] = {.lex_state = 15, .external_lex_state = 2},
  [2339] = {.lex_state = 15, .external_lex_state = 2},
  [2340] = {.lex_state = 15, .external_lex_state = 2},
  [2341] = {.lex_state = 15, .external_lex_state = 2},
  [2342] = {.lex_state = 15, .external_lex_state = 2},
  [2343] = {.lex_state = 15, .external_lex_state = 2},
  [2344] = {.lex_state = 98},
  [2345] = {.lex_state = 15, .external_lex_state = 2},
  [2346] = {.lex_state = 100},
  [2347] = {.lex_state = 100},
  [2348] = {.lex_state = 15, .external_lex_state = 2},
  [2349] = {.lex_state = 98},
  [2350] = {.lex_state = 15, .external_lex_state = 2},
  [2351] = {.lex_state = 100},
  [2352] = {.lex_state = 15, .external_lex_state = 2},
  [2353] = {.lex_state = 13, .external_lex_state = 2},
  [2354] = {.lex_state = 15, .external_lex_state = 2},
  [2355] = {.lex_state = 15, .external_lex_state = 2},
  [2356] = {.lex_state = 15, .external_lex_state = 2},
  [2357] = {.lex_state = 15, .external_lex_state = 2},
  [2358] = {.lex_state = 15, .external_lex_state = 2},
  [2359] = {.lex_state = 15, .external_lex_state = 2},
  [2360] = {.lex_state = 15, .external_lex_state = 2},
  [2361] = {.lex_state = 15, .external_lex_state = 2},
  [2362] = {.lex_state = 100},
  [2363] = {.lex_state = 15, .external_lex_state = 2},
  [2364] = {.lex_state = 100, .external_lex_state = 4},
  [2365] = {.lex_state = 100},
  [2366] = {.lex_state = 100, .external_lex_state = 4},
  [2367] = {.lex_state = 100, .external_lex_state = 4},
  [2368] = {.lex_state = 100, .external_lex_state = 4},
  [2369] = {.lex_state = 15, .external_lex_state = 2},
  [2370] = {.lex_state = 15, .external_lex_state = 2},
  [2371] = {.lex_state = 100},
  [2372] = {.lex_state = 100},
  [2373] = {.lex_state = 15, .external_lex_state = 2},
  [2374] = {.lex_state = 15, .external_lex_state = 2},
  [2375] = {.lex_state = 100},
  [2376] = {.lex_state = 15, .external_lex_state = 2},
  [2377] = {.lex_state = 15, .external_lex_state = 2},
  [2378] = {.lex_state = 15, .external_lex_state = 2},
  [2379] = {.lex_state = 15, .external_lex_state = 2},
  [2380] = {.lex_state = 100, .external_lex_state = 4},
  [2381] = {.lex_state = 100, .external_lex_state = 4},
  [2382] = {.lex_state = 15, .external_lex_state = 2},
  [2383] = {.lex_state = 100},
  [2384] = {.lex_state = 15, .external_lex_state = 2},
  [2385] = {.lex_state = 100},
  [2386] = {.lex_state = 15, .external_lex_state = 2},
  [2387] = {.lex_state = 100, .external_lex_state = 4},
  [2388] = {.lex_state = 15, .external_lex_state = 2},
  [2389] = {.lex_state = 100, .external_lex_state = 4},
  [2390] = {.lex_state = 15, .external_lex_state = 2},
  [2391] = {.lex_state = 15, .external_lex_state = 2},
  [2392] = {.lex_state = 15, .external_lex_state = 2},
  [2393] = {.lex_state = 100, .external_lex_state = 4},
  [2394] = {.lex_state = 15, .external_lex_state = 2},
  [2395] = {.lex_state = 15, .external_lex_state = 2},
  [2396] = {.lex_state = 15, .external_lex_state = 2},
  [2397] = {.lex_state = 100},
  [2398] = {.lex_state = 15, .external_lex_state = 2},
  [2399] = {.lex_state = 15, .external_lex_state = 2},
  [2400] = {.lex_state = 100, .external_lex_state = 4},
  [2401] = {.lex_state = 15, .external_lex_state = 2},
  [2402] = {.lex_state = 15, .external_lex_state = 2},
  [2403] = {.lex_state = 100, .external_lex_state = 4},
  [2404] = {.lex_state = 100, .external_lex_state = 4},
  [2405] = {.lex_state = 15, .external_lex_state = 2},
  [2406] = {.lex_state = 15, .external_lex_state = 2},
  [2407] = {.lex_state = 100},
  [2408] = {.lex_state = 100, .external_lex_state = 4},
  [2409] = {.lex_state = 98},
  [2410] = {.lex_state = 15, .external_lex_state = 2},
  [2411] = {.lex_state = 15, .external_lex_state = 2},
  [2412] = {.lex_state = 100},
  [2413] = {.lex_state = 100, .external_lex_state = 4},
  [2414] = {.lex_state = 100, .external_lex_state = 4},
  [2415] = {.lex_state = 15, .external_lex_state = 2},
  [2416] = {.lex_state = 100, .external_lex_state = 4},
  [2417] = {.lex_state = 15, .external_lex_state = 2},
  [2418] = {.lex_state = 15, .external_lex_state = 2},
  [2419] = {.lex_state = 15, .external_lex_state = 2},
  [2420] = {.lex_state = 15, .external_lex_state = 2},
  [2421] = {.lex_state = 100, .external_lex_state = 4},
  [2422] = {.lex_state = 15, .external_lex_state = 2},
  [2423] = {.lex_state = 100, .external_lex_state = 4},
  [2424] = {.lex_state = 15, .external_lex_state = 2},
  [2425] = {.lex_state = 15, .external_lex_state = 2},
  [2426] = {.lex_state = 15, .external_lex_state = 2},
  [2427] = {.lex_state = 100, .external_lex_state = 4},
  [2428] = {.lex_state = 100, .external_lex_state = 4},
  [2429] = {.lex_state = 15, .external_lex_state = 2},
  [2430] = {.lex_state = 100},
  [2431] = {.lex_state = 100},
  [2432] = {.lex_state = 15, .external_lex_state = 2},
  [2433] = {.lex_state = 100, .external_lex_state = 4},
  [2434] = {.lex_state = 100, .external_lex_state = 4},
  [2435] = {.lex_state = 100},
  [2436] = {.lex_state = 100, .external_lex_state = 4},
  [2437] = {.lex_state = 100},
  [2438] = {.lex_state = 15, .external_lex_state = 2},
  [2439] = {.lex_state = 15, .external_lex_state = 2},
  [2440] = {.lex_state = 100},
  [2441] = {.lex_state = 100},
  [2442] = {.lex_state = 100, .external_lex_state = 4},
  [2443] = {.lex_state = 100},
  [2444] = {.lex_state = 100},
  [2445] = {.lex_state = 100, .external_lex_state = 4},
  [2446] = {.lex_state = 15, .external_lex_state = 2},
  [2447] = {.lex_state = 100, .external_lex_state = 4},
  [2448] = {.lex_state = 15, .external_lex_state = 2},
  [2449] = {.lex_state = 100, .external_lex_state = 4},
  [2450] = {.lex_state = 15, .external_lex_state = 2},
  [2451] = {.lex_state = 100},
  [2452] = {.lex_state = 15, .external_lex_state = 2},
  [2453] = {.lex_state = 100, .external_lex_state = 4},
  [2454] = {.lex_state = 15, .external_lex_state = 2},
  [2455] = {.lex_state = 15, .external_lex_state = 2},
  [2456] = {.lex_state = 100},
  [2457] = {.lex_state = 100, .external_lex_state = 4},
  [2458] = {.lex_state = 100, .external_lex_state = 4},
  [2459] = {.lex_state = 15, .external_lex_state = 2},
  [2460] = {.lex_state = 100, .external_lex_state = 4},
  [2461] = {.lex_state = 100, .external_lex_state = 4},
  [2462] = {.lex_state = 15, .external_lex_state = 2},
  [2463] = {.lex_state = 100, .external_lex_state = 4},
  [2464] = {.lex_state = 100, .external_lex_state = 4},
  [2465] = {.lex_state = 15, .external_lex_state = 2},
  [2466] = {.lex_state = 15, .external_lex_state = 2},
  [2467] = {.lex_state = 15, .external_lex_state = 2},
  [2468] = {.lex_state = 15, .external_lex_state = 2},
  [2469] = {.lex_state = 15, .external_lex_state = 2},
  [2470] = {.lex_state = 15, .external_lex_state = 2},
  [2471] = {.lex_state = 15, .external_lex_state = 2},
  [2472] = {.lex_state = 15, .external_lex_state = 2},
  [2473] = {.lex_state = 100, .external_lex_state = 4},
  [2474] = {.lex_state = 15, .external_lex_state = 2},
  [2475] = {.lex_state = 15, .external_lex_state = 2},
  [2476] = {.lex_state = 100, .external_lex_state = 4},
  [2477] = {.lex_state = 100, .external_lex_state = 4},
  [2478] = {.lex_state = 15, .external_lex_state = 2},
  [2479] = {.lex_state = 100},
  [2480] = {.lex_state = 100, .external_lex_state = 4},
  [2481] = {.lex_state = 15, .external_lex_state = 2},
  [2482] = {.lex_state = 15, .external_lex_state = 2},
  [2483] = {.lex_state = 15, .external_lex_state = 2},
  [2484] = {.lex_state = 15, .external_lex_state = 2},
  [2485] = {.lex_state = 15, .external_lex_state = 2},
  [2486] = {.lex_state = 15, .external_lex_state = 2},
  [2487] = {.lex_state = 100},
  [2488] = {.lex_state = 100, .external_lex_state = 4},
  [2489] = {.lex_state = 100, .external_lex_state = 4},
  [2490] = {.lex_state = 100, .external_lex_state = 4},
  [2491] = {.lex_state = 100, .external_lex_state = 4},
  [2492] = {.lex_state = 100, .external_lex_state = 4},
  [2493] = {.lex_state = 100, .external_lex_state = 4},
  [2494] = {.lex_state = 98},
  [2495] = {.lex_state = 15, .external_lex_state = 2},
  [2496] = {.lex_state = 98},
  [2497] = {.lex_state = 100, .external_lex_state = 4},
  [2498] = {.lex_state = 100, .external_lex_state = 4},
  [2499] = {.lex_state = 100, .external_lex_state = 4},
  [2500] = {.lex_state = 100, .external_lex_state = 4},
  [2501] = {.lex_state = 100, .external_lex_state = 4},
  [2502] = {.lex_state = 100, .external_lex_state = 4},
  [2503] = {.lex_state = 15, .external_lex_state = 2},
  [2504] = {.lex_state = 100},
  [2505] = {.lex_state = 100},
  [2506] = {.lex_state = 15, .external_lex_state = 2},
  [2507] = {.lex_state = 100},
  [2508] = {.lex_state = 15, .external_lex_state = 2},
  [2509] = {.lex_state = 100, .external_lex_state = 4},
  [2510] = {.lex_state = 13, .external_lex_state = 2},
  [2511] = {.lex_state = 100},
  [2512] = {.lex_state = 100, .external_lex_state = 4},
  [2513] = {.lex_state = 100, .external_lex_state = 4},
  [2514] = {.lex_state = 15, .external_lex_state = 2},
  [2515] = {.lex_state = 100, .external_lex_state = 4},
  [2516] = {.lex_state = 100},
  [2517] = {.lex_state = 15, .external_lex_state = 2},
  [2518] = {.lex_state = 100},
  [2519] = {.lex_state = 100},
  [2520] = {.lex_state = 100, .external_lex_state = 4},
  [2521] = {.lex_state = 15, .external_lex_state = 2},
  [2522] = {.lex_state = 98},
  [2523] = {.lex_state = 100},
  [2524] = {.lex_state = 100, .external_lex_state = 4},
  [2525] = {.lex_state = 100, .external_lex_state = 4},
  [2526] = {.lex_state = 100},
  [2527] = {.lex_state = 15, .external_lex_state = 2},
  [2528] = {.lex_state = 100},
  [2529] = {.lex_state = 98, .external_lex_state = 4},
  [2530] = {.lex_state = 100, .external_lex_state = 4},
  [2531] = {.lex_state = 98, .external_lex_state = 4},
  [2532] = {.lex_state = 98, .external_lex_state = 4},
  [2533] = {.lex_state = 100},
  [2534] = {.lex_state = 100, .external_lex_state = 4},
  [2535] = {.lex_state = 98, .external_lex_state = 4},
  [2536] = {.lex_state = 100},
  [2537] = {.lex_state = 100},
  [2538] = {.lex_state = 100},
  [2539] = {.lex_state = 100},
  [2540] = {.lex_state = 100},
  [2541] = {.lex_state = 100},
  [2542] = {.lex_state = 98, .external_lex_state = 4},
  [2543] = {.lex_state = 100},
  [2544] = {.lex_state = 100},
  [2545] = {.lex_state = 100},
  [2546] = {.lex_state = 100},
  [2547] = {.lex_state = 98, .external_lex_state = 4},
  [2548] = {.lex_state = 100},
  [2549] = {.lex_state = 100},
  [2550] = {.lex_state = 100},
  [2551] = {.lex_state = 100},
  [2552] = {.lex_state = 100},
  [2553] = {.lex_state = 100},
  [2554] = {.lex_state = 100},
  [2555] = {.lex_state = 100},
  [2556] = {.lex_state = 100},
  [2557] = {.lex_state = 100},
  [2558] = {.lex_state = 100},
  [2559] = {.lex_state = 100},
  [2560] = {.lex_state = 100},
  [2561] = {.lex_state = 100, .external_lex_state = 4},
  [2562] = {.lex_state = 100, .external_lex_state = 4},
  [2563] = {.lex_state = 100},
  [2564] = {.lex_state = 102},
  [2565] = {.lex_state = 100},
  [2566] = {.lex_state = 100},
  [2567] = {.lex_state = 100, .external_lex_state = 4},
  [2568] = {.lex_state = 100, .external_lex_state = 4},
  [2569] = {.lex_state = 100, .external_lex_state = 4},
  [2570] = {.lex_state = 102},
  [2571] = {.lex_state = 100, .external_lex_state = 4},
  [2572] = {.lex_state = 100},
  [2573] = {.lex_state = 100, .external_lex_state = 4},
  [2574] = {.lex_state = 100, .external_lex_state = 4},
  [2575] = {.lex_state = 100},
  [2576] = {.lex_state = 100, .external_lex_state = 4},
  [2577] = {.lex_state = 100, .external_lex_state = 4},
  [2578] = {.lex_state = 100},
  [2579] = {.lex_state = 100},
  [2580] = {.lex_state = 100},
  [2581] = {.lex_state = 100},
  [2582] = {.lex_state = 100, .external_lex_state = 4},
  [2583] = {.lex_state = 100, .external_lex_state = 4},
  [2584] = {.lex_state = 100, .external_lex_state = 4},
  [2585] = {.lex_state = 100, .external_lex_state = 4},
  [2586] = {.lex_state = 100, .external_lex_state = 4},
  [2587] = {.lex_state = 100, .external_lex_state = 4},
  [2588] = {.lex_state = 100, .external_lex_state = 4},
  [2589] = {.lex_state = 100, .external_lex_state = 4},
  [2590] = {.lex_state = 100, .external_lex_state = 4},
  [2591] = {.lex_state = 100, .external_lex_state = 4},
  [2592] = {.lex_state = 100, .external_lex_state = 4},
  [2593] = {.lex_state = 100, .external_lex_state = 4},
  [2594] = {.lex_state = 100, .external_lex_state = 4},
  [2595] = {.lex_state = 100, .external_lex_state = 4},
  [2596] = {.lex_state = 100, .external_lex_state = 4},
  [2597] = {.lex_state = 100},
  [2598] = {.lex_state = 100, .external_lex_state = 4},
  [2599] = {.lex_state = 100},
  [2600] = {.lex_state = 100},
  [2601] = {.lex_state = 100, .external_lex_state = 4},
  [2602] = {.lex_state = 100},
  [2603] = {.lex_state = 100},
  [2604] = {.lex_state = 100},
  [2605] = {.lex_state = 100},
  [2606] = {.lex_state = 100},
  [2607] = {.lex_state = 100, .external_lex_state = 4},
  [2608] = {.lex_state = 100},
  [2609] = {.lex_state = 100},
  [2610] = {.lex_state = 100},
  [2611] = {.lex_state = 100},
  [2612] = {.lex_state = 100},
  [2613] = {.lex_state = 100},
  [2614] = {.lex_state = 100},
  [2615] = {.lex_state = 100},
  [2616] = {.lex_state = 100},
  [2617] = {.lex_state = 100},
  [2618] = {.lex_state = 100},
  [2619] = {.lex_state = 98},
  [2620] = {.lex_state = 100},
  [2621] = {.lex_state = 100},
  [2622] = {.lex_state = 100},
  [2623] = {.lex_state = 100},
  [2624] = {.lex_state = 100},
  [2625] = {.lex_state = 100, .external_lex_state = 4},
  [2626] = {.lex_state = 98},
  [2627] = {.lex_state = 98},
  [2628] = {.lex_state = 100},
  [2629] = {.lex_state = 100},
  [2630] = {.lex_state = 100},
  [2631] = {.lex_state = 100},
  [2632] = {.lex_state = 100},
  [2633] = {.lex_state = 100},
  [2634] = {.lex_state = 98},
  [2635] = {.lex_state = 98},
  [2636] = {.lex_state = 98},
  [2637] = {.lex_state = 98},
  [2638] = {.lex_state = 98},
  [2639] = {.lex_state = 98},
  [2640] = {.lex_state = 98},
  [2641] = {.lex_state = 100},
  [2642] = {.lex_state = 100},
  [2643] = {.lex_state = 100},
  [2644] = {.lex_state = 100},
  [2645] = {.lex_state = 98},
  [2646] = {.lex_state = 98},
  [2647] = {.lex_state = 98},
  [2648] = {.lex_state = 98},
  [2649] = {.lex_state = 98},
  [2650] = {.lex_state = 98},
  [2651] = {.lex_state = 98},
  [2652] = {.lex_state = 98},
  [2653] = {.lex_state = 98},
  [2654] = {.lex_state = 98},
  [2655] = {.lex_state = 98},
  [2656] = {.lex_state = 98},
  [2657] = {.lex_state = 98},
  [2658] = {.lex_state = 98},
  [2659] = {.lex_state = 98},
  [2660] = {.lex_state = 98},
  [2661] = {.lex_state = 98},
  [2662] = {.lex_state = 98},
  [2663] = {.lex_state = 98},
  [2664] = {.lex_state = 98},
  [2665] = {.lex_state = 98},
  [2666] = {.lex_state = 98},
  [2667] = {.lex_state = 98},
  [2668] = {.lex_state = 98},
  [2669] = {.lex_state = 98},
  [2670] = {.lex_state = 98},
  [2671] = {.lex_state = 98},
  [2672] = {.lex_state = 98},
  [2673] = {.lex_state = 98},
  [2674] = {.lex_state = 98},
  [2675] = {.lex_state = 98},
  [2676] = {.lex_state = 98},
  [2677] = {.lex_state = 98},
  [2678] = {.lex_state = 98},
  [2679] = {.lex_state = 98},
  [2680] = {.lex_state = 98},
  [2681] = {.lex_state = 98},
  [2682] = {.lex_state = 98},
  [2683] = {.lex_state = 98},
  [2684] = {.lex_state = 98},
  [2685] = {.lex_state = 98},
  [2686] = {.lex_state = 98},
  [2687] = {.lex_state = 98},
  [2688] = {.lex_state = 98},
  [2689] = {.lex_state = 98},
  [2690] = {.lex_state = 98},
  [2691] = {.lex_state = 98},
  [2692] = {.lex_state = 98},
  [2693] = {.lex_state = 98},
  [2694] = {.lex_state = 103},
  [2695] = {.lex_state = 103},
  [2696] = {.lex_state = 99},
  [2697] = {.lex_state = 99},
  [2698] = {.lex_state = 103},
  [2699] = {.lex_state = 98},
  [2700] = {.lex_state = 20},
  [2701] = {.lex_state = 103},
  [2702] = {.lex_state = 103},
  [2703] = {.lex_state = 103},
  [2704] = {.lex_state = 103},
  [2705] = {.lex_state = 103},
  [2706] = {.lex_state = 103},
  [2707] = {.lex_state = 103},
  [2708] = {.lex_state = 103},
  [2709] = {.lex_state = 103},
  [2710] = {.lex_state = 103},
  [2711] = {.lex_state = 103},
  [2712] = {.lex_state = 103},
  [2713] = {.lex_state = 103},
  [2714] = {.lex_state = 103},
  [2715] = {.lex_state = 103},
  [2716] = {.lex_state = 103},
  [2717] = {.lex_state = 103},
  [2718] = {.lex_state = 103},
  [2719] = {.lex_state = 103},
  [2720] = {.lex_state = 103},
  [2721] = {.lex_state = 103},
  [2722] = {.lex_state = 103},
  [2723] = {.lex_state = 103},
  [2724] = {.lex_state = 103},
  [2725] = {.lex_state = 103},
  [2726] = {.lex_state = 103},
  [2727] = {.lex_state = 103},
  [2728] = {.lex_state = 103},
  [2729] = {.lex_state = 103},
  [2730] = {.lex_state = 103},
  [2731] = {.lex_state = 103},
  [2732] = {.lex_state = 103},
  [2733] = {.lex_state = 103},
  [2734] = {.lex_state = 103},
  [2735] = {.lex_state = 103},
  [2736] = {.lex_state = 103},
  [2737] = {.lex_state = 103},
  [2738] = {.lex_state = 103},
  [2739] = {.lex_state = 103},
  [2740] = {.lex_state = 103},
  [2741] = {.lex_state = 103},
  [2742] = {.lex_state = 98},
  [2743] = {.lex_state = 98},
  [2744] = {.lex_state = 103},
  [2745] = {.lex_state = 98},
  [2746] = {.lex_state = 98},
  [2747] = {.lex_state = 103},
  [2748] = {.lex_state = 98},
  [2749] = {.lex_state = 98},
  [2750] = {.lex_state = 103},
  [2751] = {.lex_state = 98},
  [2752] = {.lex_state = 98},
  [2753] = {.lex_state = 98},
  [2754] = {.lex_state = 99},
  [2755] = {.lex_state = 103, .external_lex_state = 4},
  [2756] = {.lex_state = 98},
  [2757] = {.lex_state = 99, .external_lex_state = 4},
  [2758] = {.lex_state = 99, .external_lex_state = 4},
  [2759] = {.lex_state = 103, .external_lex_state = 4},
  [2760] = {.lex_state = 20},
  [2761] = {.lex_state = 98},
  [2762] = {.lex_state = 98},
  [2763] = {.lex_state = 98},
  [2764] = {.lex_state = 7},
  [2765] = {.lex_state = 98},
  [2766] = {.lex_state = 103, .external_lex_state = 4},
  [2767] = {.lex_state = 98},
  [2768] = {.lex_state = 103, .external_lex_state = 4},
  [2769] = {.lex_state = 98},
  [2770] = {.lex_state = 98},
  [2771] = {.lex_state = 98},
  [2772] = {.lex_state = 98},
  [2773] = {.lex_state = 98},
  [2774] = {.lex_state = 98},
  [2775] = {.lex_state = 7},
  [2776] = {.lex_state = 103, .external_lex_state = 4},
  [2777] = {.lex_state = 7},
  [2778] = {.lex_state = 98},
  [2779] = {.lex_state = 98},
  [2780] = {.lex_state = 7},
  [2781] = {.lex_state = 7},
  [2782] = {.lex_state = 103, .external_lex_state = 4},
  [2783] = {.lex_state = 98},
  [2784] = {.lex_state = 98},
  [2785] = {.lex_state = 7},
  [2786] = {.lex_state = 98},
  [2787] = {.lex_state = 7},
  [2788] = {.lex_state = 98},
  [2789] = {.lex_state = 7},
  [2790] = {.lex_state = 98},
  [2791] = {.lex_state = 98},
  [2792] = {.lex_state = 20},
  [2793] = {.lex_state = 98},
  [2794] = {.lex_state = 98},
  [2795] = {.lex_state = 98},
  [2796] = {.lex_state = 102},
  [2797] = {.lex_state = 98},
  [2798] = {.lex_state = 98},
  [2799] = {.lex_state = 98},
  [2800] = {.lex_state = 98},
  [2801] = {.lex_state = 98},
  [2802] = {.lex_state = 98},
  [2803] = {.lex_state = 98},
  [2804] = {.lex_state = 103, .external_lex_state = 4},
  [2805] = {.lex_state = 20},
  [2806] = {.lex_state = 20},
  [2807] = {.lex_state = 102},
  [2808] = {.lex_state = 103, .external_lex_state = 4},
  [2809] = {.lex_state = 103, .external_lex_state = 4},
  [2810] = {.lex_state = 103, .external_lex_state = 4},
  [2811] = {.lex_state = 103, .external_lex_state = 4},
  [2812] = {.lex_state = 103, .external_lex_state = 4},
  [2813] = {.lex_state = 103, .external_lex_state = 4},
  [2814] = {.lex_state = 103, .external_lex_state = 4},
  [2815] = {.lex_state = 103, .external_lex_state = 4},
  [2816] = {.lex_state = 103, .external_lex_state = 4},
  [2817] = {.lex_state = 98},
  [2818] = {.lex_state = 98},
  [2819] = {.lex_state = 103, .external_lex_state = 4},
  [2820] = {.lex_state = 98},
  [2821] = {.lex_state = 98},
  [2822] = {.lex_state = 100, .external_lex_state = 4},
  [2823] = {.lex_state = 103, .external_lex_state = 4},
  [2824] = {.lex_state = 103, .external_lex_state = 4},
  [2825] = {.lex_state = 103, .external_lex_state = 4},
  [2826] = {.lex_state = 103, .external_lex_state = 4},
  [2827] = {.lex_state = 103, .external_lex_state = 4},
  [2828] = {.lex_state = 103, .external_lex_state = 4},
  [2829] = {.lex_state = 103, .external_lex_state = 4},
  [2830] = {.lex_state = 103, .external_lex_state = 4},
  [2831] = {.lex_state = 103, .external_lex_state = 4},
  [2832] = {.lex_state = 103, .external_lex_state = 4},
  [2833] = {.lex_state = 98},
  [2834] = {.lex_state = 98},
  [2835] = {.lex_state = 103, .external_lex_state = 4},
  [2836] = {.lex_state = 98},
  [2837] = {.lex_state = 98},
  [2838] = {.lex_state = 100, .external_lex_state = 4},
  [2839] = {.lex_state = 98},
  [2840] = {.lex_state = 100, .external_lex_state = 4},
  [2841] = {.lex_state = 98},
  [2842] = {.lex_state = 100, .external_lex_state = 4},
  [2843] = {.lex_state = 103, .external_lex_state = 4},
  [2844] = {.lex_state = 103, .external_lex_state = 4},
  [2845] = {.lex_state = 103, .external_lex_state = 4},
  [2846] = {.lex_state = 103, .external_lex_state = 4},
  [2847] = {.lex_state = 103, .external_lex_state = 4},
  [2848] = {.lex_state = 103, .external_lex_state = 4},
  [2849] = {.lex_state = 103, .external_lex_state = 4},
  [2850] = {.lex_state = 103, .external_lex_state = 4},
  [2851] = {.lex_state = 103, .external_lex_state = 4},
  [2852] = {.lex_state = 98},
  [2853] = {.lex_state = 103, .external_lex_state = 4},
  [2854] = {.lex_state = 103, .external_lex_state = 4},
  [2855] = {.lex_state = 103, .external_lex_state = 4},
  [2856] = {.lex_state = 103, .external_lex_state = 4},
  [2857] = {.lex_state = 103, .external_lex_state = 4},
  [2858] = {.lex_state = 98},
  [2859] = {.lex_state = 102},
  [2860] = {.lex_state = 100, .external_lex_state = 4},
  [2861] = {.lex_state = 98},
  [2862] = {.lex_state = 98},
  [2863] = {.lex_state = 100, .external_lex_state = 4},
  [2864] = {.lex_state = 100, .external_lex_state = 4},
  [2865] = {.lex_state = 98},
  [2866] = {.lex_state = 98},
  [2867] = {.lex_state = 98},
  [2868] = {.lex_state = 98},
  [2869] = {.lex_state = 98},
  [2870] = {.lex_state = 98},
  [2871] = {.lex_state = 103},
  [2872] = {.lex_state = 98},
  [2873] = {.lex_state = 98},
  [2874] = {.lex_state = 98},
  [2875] = {.lex_state = 102},
  [2876] = {.lex_state = 98},
  [2877] = {.lex_state = 103, .external_lex_state = 4},
  [2878] = {.lex_state = 103, .external_lex_state = 4},
  [2879] = {.lex_state = 100, .external_lex_state = 4},
  [2880] = {.lex_state = 103, .external_lex_state = 4},
  [2881] = {.lex_state = 98},
  [2882] = {.lex_state = 100, .external_lex_state = 4},
  [2883] = {.lex_state = 100, .external_lex_state = 4},
  [2884] = {.lex_state = 100, .external_lex_state = 4},
  [2885] = {.lex_state = 100, .external_lex_state = 4},
  [2886] = {.lex_state = 103, .external_lex_state = 4},
  [2887] = {.lex_state = 103, .external_lex_state = 4},
  [2888] = {.lex_state = 103, .external_lex_state = 4},
  [2889] = {.lex_state = 103},
  [2890] = {.lex_state = 103, .external_lex_state = 4},
  [2891] = {.lex_state = 103, .external_lex_state = 4},
  [2892] = {.lex_state = 100, .external_lex_state = 4},
  [2893] = {.lex_state = 98},
  [2894] = {.lex_state = 103, .external_lex_state = 4},
  [2895] = {.lex_state = 100, .external_lex_state = 4},
  [2896] = {.lex_state = 103, .external_lex_state = 5},
  [2897] = {.lex_state = 99, .external_lex_state = 4},
  [2898] = {.lex_state = 103, .external_lex_state = 5},
  [2899] = {.lex_state = 103, .external_lex_state = 5},
  [2900] = {.lex_state = 103, .external_lex_state = 5},
  [2901] = {.lex_state = 103, .external_lex_state = 4},
  [2902] = {.lex_state = 100, .external_lex_state = 4},
  [2903] = {.lex_state = 100, .external_lex_state = 4},
  [2904] = {.lex_state = 98},
  [2905] = {.lex_state = 100, .external_lex_state = 4},
  [2906] = {.lex_state = 100, .external_lex_state = 4},
  [2907] = {.lex_state = 103},
  [2908] = {.lex_state = 100, .external_lex_state = 4},
  [2909] = {.lex_state = 100, .external_lex_state = 4},
  [2910] = {.lex_state = 98},
  [2911] = {.lex_state = 98},
  [2912] = {.lex_state = 100, .external_lex_state = 4},
  [2913] = {.lex_state = 103, .external_lex_state = 5},
  [2914] = {.lex_state = 100, .external_lex_state = 4},
  [2915] = {.lex_state = 100, .external_lex_state = 4},
  [2916] = {.lex_state = 100, .external_lex_state = 4},
  [2917] = {.lex_state = 100, .external_lex_state = 4},
  [2918] = {.lex_state = 100, .external_lex_state = 4},
  [2919] = {.lex_state = 100, .external_lex_state = 4},
  [2920] = {.lex_state = 20},
  [2921] = {.lex_state = 100, .external_lex_state = 4},
  [2922] = {.lex_state = 103, .external_lex_state = 5},
  [2923] = {.lex_state = 100, .external_lex_state = 4},
  [2924] = {.lex_state = 103, .external_lex_state = 5},
  [2925] = {.lex_state = 103, .external_lex_state = 5},
  [2926] = {.lex_state = 103, .external_lex_state = 5},
  [2927] = {.lex_state = 102},
  [2928] = {.lex_state = 103, .external_lex_state = 5},
  [2929] = {.lex_state = 103, .external_lex_state = 5},
  [2930] = {.lex_state = 103, .external_lex_state = 5},
  [2931] = {.lex_state = 103, .external_lex_state = 5},
  [2932] = {.lex_state = 100, .external_lex_state = 4},
  [2933] = {.lex_state = 103, .external_lex_state = 5},
  [2934] = {.lex_state = 103, .external_lex_state = 5},
  [2935] = {.lex_state = 100, .external_lex_state = 4},
  [2936] = {.lex_state = 103, .external_lex_state = 5},
  [2937] = {.lex_state = 103, .external_lex_state = 5},
  [2938] = {.lex_state = 103, .external_lex_state = 5},
  [2939] = {.lex_state = 103, .external_lex_state = 5},
  [2940] = {.lex_state = 98, .external_lex_state = 4},
  [2941] = {.lex_state = 103, .external_lex_state = 5},
  [2942] = {.lex_state = 100, .external_lex_state = 4},
  [2943] = {.lex_state = 100, .external_lex_state = 4},
  [2944] = {.lex_state = 98},
  [2945] = {.lex_state = 103, .external_lex_state = 5},
  [2946] = {.lex_state = 98},
  [2947] = {.lex_state = 103, .external_lex_state = 5},
  [2948] = {.lex_state = 103, .external_lex_state = 5},
  [2949] = {.lex_state = 103, .external_lex_state = 5},
  [2950] = {.lex_state = 103, .external_lex_state = 5},
  [2951] = {.lex_state = 103, .external_lex_state = 5},
  [2952] = {.lex_state = 103, .external_lex_state = 5},
  [2953] = {.lex_state = 103, .external_lex_state = 5},
  [2954] = {.lex_state = 103},
  [2955] = {.lex_state = 103, .external_lex_state = 5},
  [2956] = {.lex_state = 103, .external_lex_state = 5},
  [2957] = {.lex_state = 100, .external_lex_state = 4},
  [2958] = {.lex_state = 100, .external_lex_state = 4},
  [2959] = {.lex_state = 103, .external_lex_state = 5},
  [2960] = {.lex_state = 103, .external_lex_state = 5},
  [2961] = {.lex_state = 103, .external_lex_state = 5},
  [2962] = {.lex_state = 103, .external_lex_state = 5},
  [2963] = {.lex_state = 103, .external_lex_state = 5},
  [2964] = {.lex_state = 100, .external_lex_state = 4},
  [2965] = {.lex_state = 103, .external_lex_state = 5},
  [2966] = {.lex_state = 103, .external_lex_state = 5},
  [2967] = {.lex_state = 103, .external_lex_state = 5},
  [2968] = {.lex_state = 103, .external_lex_state = 5},
  [2969] = {.lex_state = 103, .external_lex_state = 4},
  [2970] = {.lex_state = 100, .external_lex_state = 4},
  [2971] = {.lex_state = 100, .external_lex_state = 4},
  [2972] = {.lex_state = 100, .external_lex_state = 4},
  [2973] = {.lex_state = 100, .external_lex_state = 4},
  [2974] = {.lex_state = 100, .external_lex_state = 4},
  [2975] = {.lex_state = 100, .external_lex_state = 4},
  [2976] = {.lex_state = 98, .external_lex_state = 4},
  [2977] = {.lex_state = 103, .external_lex_state = 5},
  [2978] = {.lex_state = 98, .external_lex_state = 4},
  [2979] = {.lex_state = 98, .external_lex_state = 4},
  [2980] = {.lex_state = 98, .external_lex_state = 4},
  [2981] = {.lex_state = 98, .external_lex_state = 4},
  [2982] = {.lex_state = 103},
  [2983] = {.lex_state = 98, .external_lex_state = 4},
  [2984] = {.lex_state = 100, .external_lex_state = 4},
  [2985] = {.lex_state = 103},
  [2986] = {.lex_state = 99, .external_lex_state = 5},
  [2987] = {.lex_state = 98, .external_lex_state = 4},
  [2988] = {.lex_state = 98, .external_lex_state = 4},
  [2989] = {.lex_state = 98, .external_lex_state = 4},
  [2990] = {.lex_state = 98, .external_lex_state = 4},
  [2991] = {.lex_state = 98, .external_lex_state = 4},
  [2992] = {.lex_state = 98},
  [2993] = {.lex_state = 98, .external_lex_state = 4},
  [2994] = {.lex_state = 98, .external_lex_state = 4},
  [2995] = {.lex_state = 98, .external_lex_state = 4},
  [2996] = {.lex_state = 98, .external_lex_state = 4},
  [2997] = {.lex_state = 98, .external_lex_state = 4},
  [2998] = {.lex_state = 98, .external_lex_state = 4},
  [2999] = {.lex_state = 103},
  [3000] = {.lex_state = 98},
  [3001] = {.lex_state = 98, .external_lex_state = 4},
  [3002] = {.lex_state = 4},
  [3003] = {.lex_state = 100, .external_lex_state = 4},
  [3004] = {.lex_state = 103},
  [3005] = {.lex_state = 98, .external_lex_state = 4},
  [3006] = {.lex_state = 98},
  [3007] = {.lex_state = 103, .external_lex_state = 5},
  [3008] = {.lex_state = 98, .external_lex_state = 4},
  [3009] = {.lex_state = 98},
  [3010] = {.lex_state = 98, .external_lex_state = 4},
  [3011] = {.lex_state = 98},
  [3012] = {.lex_state = 103, .external_lex_state = 5},
  [3013] = {.lex_state = 98, .external_lex_state = 4},
  [3014] = {.lex_state = 98, .external_lex_state = 4},
  [3015] = {.lex_state = 98, .external_lex_state = 4},
  [3016] = {.lex_state = 103, .external_lex_state = 5},
  [3017] = {.lex_state = 98, .external_lex_state = 4},
  [3018] = {.lex_state = 98, .external_lex_state = 4},
  [3019] = {.lex_state = 4},
  [3020] = {.lex_state = 98, .external_lex_state = 4},
  [3021] = {.lex_state = 103, .external_lex_state = 5},
  [3022] = {.lex_state = 100, .external_lex_state = 4},
  [3023] = {.lex_state = 98, .external_lex_state = 4},
  [3024] = {.lex_state = 98, .external_lex_state = 4},
  [3025] = {.lex_state = 103, .external_lex_state = 5},
  [3026] = {.lex_state = 98, .external_lex_state = 4},
  [3027] = {.lex_state = 98, .external_lex_state = 4},
  [3028] = {.lex_state = 103, .external_lex_state = 5},
  [3029] = {.lex_state = 98, .external_lex_state = 4},
  [3030] = {.lex_state = 98, .external_lex_state = 4},
  [3031] = {.lex_state = 98, .external_lex_state = 4},
  [3032] = {.lex_state = 98, .external_lex_state = 4},
  [3033] = {.lex_state = 98, .external_lex_state = 4},
  [3034] = {.lex_state = 98, .external_lex_state = 4},
  [3035] = {.lex_state = 98, .external_lex_state = 4},
  [3036] = {.lex_state = 103, .external_lex_state = 5},
  [3037] = {.lex_state = 98},
  [3038] = {.lex_state = 98},
  [3039] = {.lex_state = 98, .external_lex_state = 4},
  [3040] = {.lex_state = 98},
  [3041] = {.lex_state = 98, .external_lex_state = 4},
  [3042] = {.lex_state = 103},
  [3043] = {.lex_state = 98, .external_lex_state = 4},
  [3044] = {.lex_state = 98},
  [3045] = {.lex_state = 98},
  [3046] = {.lex_state = 98},
  [3047] = {.lex_state = 98, .external_lex_state = 4},
  [3048] = {.lex_state = 99},
  [3049] = {.lex_state = 99},
  [3050] = {.lex_state = 98, .external_lex_state = 4},
  [3051] = {.lex_state = 98, .external_lex_state = 4},
  [3052] = {.lex_state = 98, .external_lex_state = 4},
  [3053] = {.lex_state = 98, .external_lex_state = 4},
  [3054] = {.lex_state = 98, .external_lex_state = 4},
  [3055] = {.lex_state = 98},
  [3056] = {.lex_state = 98, .external_lex_state = 4},
  [3057] = {.lex_state = 98, .external_lex_state = 5},
  [3058] = {.lex_state = 98},
  [3059] = {.lex_state = 98, .external_lex_state = 4},
  [3060] = {.lex_state = 99},
  [3061] = {.lex_state = 100, .external_lex_state = 4},
  [3062] = {.lex_state = 98, .external_lex_state = 5},
  [3063] = {.lex_state = 103},
  [3064] = {.lex_state = 99},
  [3065] = {.lex_state = 98, .external_lex_state = 4},
  [3066] = {.lex_state = 98, .external_lex_state = 4},
  [3067] = {.lex_state = 98, .external_lex_state = 4},
  [3068] = {.lex_state = 98, .external_lex_state = 4},
  [3069] = {.lex_state = 98},
  [3070] = {.lex_state = 98},
  [3071] = {.lex_state = 99},
  [3072] = {.lex_state = 98},
  [3073] = {.lex_state = 98, .external_lex_state = 4},
  [3074] = {.lex_state = 98},
  [3075] = {.lex_state = 98},
  [3076] = {.lex_state = 99},
  [3077] = {.lex_state = 98, .external_lex_state = 4},
  [3078] = {.lex_state = 103},
  [3079] = {.lex_state = 98},
  [3080] = {.lex_state = 98, .external_lex_state = 4},
  [3081] = {.lex_state = 98, .external_lex_state = 4},
  [3082] = {.lex_state = 100, .external_lex_state = 4},
  [3083] = {.lex_state = 99},
  [3084] = {.lex_state = 98, .external_lex_state = 4},
  [3085] = {.lex_state = 98, .external_lex_state = 4},
  [3086] = {.lex_state = 99},
  [3087] = {.lex_state = 98, .external_lex_state = 4},
  [3088] = {.lex_state = 99},
  [3089] = {.lex_state = 103},
  [3090] = {.lex_state = 98, .external_lex_state = 4},
  [3091] = {.lex_state = 98},
  [3092] = {.lex_state = 98, .external_lex_state = 5},
  [3093] = {.lex_state = 99},
  [3094] = {.lex_state = 99},
  [3095] = {.lex_state = 98, .external_lex_state = 4},
  [3096] = {.lex_state = 98, .external_lex_state = 5},
  [3097] = {.lex_state = 17},
  [3098] = {.lex_state = 100},
  [3099] = {.lex_state = 98, .external_lex_state = 4},
  [3100] = {.lex_state = 17},
  [3101] = {.lex_state = 4},
  [3102] = {.lex_state = 98, .external_lex_state = 5},
  [3103] = {.lex_state = 100},
  [3104] = {.lex_state = 99},
  [3105] = {.lex_state = 100},
  [3106] = {.lex_state = 98, .external_lex_state = 4},
  [3107] = {.lex_state = 98, .external_lex_state = 5},
  [3108] = {.lex_state = 98, .external_lex_state = 4},
  [3109] = {.lex_state = 98},
  [3110] = {.lex_state = 98},
  [3111] = {.lex_state = 100},
  [3112] = {.lex_state = 98},
  [3113] = {.lex_state = 99},
  [3114] = {.lex_state = 98, .external_lex_state = 5},
  [3115] = {.lex_state = 98, .external_lex_state = 5},
  [3116] = {.lex_state = 99},
  [3117] = {.lex_state = 98, .external_lex_state = 5},
  [3118] = {.lex_state = 98, .external_lex_state = 5},
  [3119] = {.lex_state = 99},
  [3120] = {.lex_state = 98, .external_lex_state = 5},
  [3121] = {.lex_state = 98, .external_lex_state = 5},
  [3122] = {.lex_state = 99},
  [3123] = {.lex_state = 98, .external_lex_state = 4},
  [3124] = {.lex_state = 99},
  [3125] = {.lex_state = 98, .external_lex_state = 5},
  [3126] = {.lex_state = 98, .external_lex_state = 5},
  [3127] = {.lex_state = 98, .external_lex_state = 5},
  [3128] = {.lex_state = 4},
  [3129] = {.lex_state = 98, .external_lex_state = 5},
  [3130] = {.lex_state = 17},
  [3131] = {.lex_state = 99},
  [3132] = {.lex_state = 99},
  [3133] = {.lex_state = 98, .external_lex_state = 5},
  [3134] = {.lex_state = 100},
  [3135] = {.lex_state = 103},
  [3136] = {.lex_state = 98, .external_lex_state = 5},
  [3137] = {.lex_state = 4},
  [3138] = {.lex_state = 4},
  [3139] = {.lex_state = 99},
  [3140] = {.lex_state = 100},
  [3141] = {.lex_state = 98, .external_lex_state = 5},
  [3142] = {.lex_state = 98, .external_lex_state = 5},
  [3143] = {.lex_state = 99},
  [3144] = {.lex_state = 98, .external_lex_state = 5},
  [3145] = {.lex_state = 100},
  [3146] = {.lex_state = 98, .external_lex_state = 5},
  [3147] = {.lex_state = 98},
  [3148] = {.lex_state = 98, .external_lex_state = 5},
  [3149] = {.lex_state = 0, .external_lex_state = 4},
  [3150] = {.lex_state = 98, .external_lex_state = 5},
  [3151] = {.lex_state = 98, .external_lex_state = 5},
  [3152] = {.lex_state = 98, .external_lex_state = 5},
  [3153] = {.lex_state = 100},
  [3154] = {.lex_state = 99},
  [3155] = {.lex_state = 99},
  [3156] = {.lex_state = 98, .external_lex_state = 5},
  [3157] = {.lex_state = 98, .external_lex_state = 5},
  [3158] = {.lex_state = 98, .external_lex_state = 5},
  [3159] = {.lex_state = 98, .external_lex_state = 5},
  [3160] = {.lex_state = 98, .external_lex_state = 5},
  [3161] = {.lex_state = 98, .external_lex_state = 5},
  [3162] = {.lex_state = 99},
  [3163] = {.lex_state = 98},
  [3164] = {.lex_state = 98, .external_lex_state = 5},
  [3165] = {.lex_state = 0, .external_lex_state = 4},
  [3166] = {.lex_state = 99},
  [3167] = {.lex_state = 100},
  [3168] = {.lex_state = 98, .external_lex_state = 5},
  [3169] = {.lex_state = 98, .external_lex_state = 5},
  [3170] = {.lex_state = 98, .external_lex_state = 4},
  [3171] = {.lex_state = 98, .external_lex_state = 5},
  [3172] = {.lex_state = 98, .external_lex_state = 5},
  [3173] = {.lex_state = 98, .external_lex_state = 5},
  [3174] = {.lex_state = 98, .external_lex_state = 5},
  [3175] = {.lex_state = 98, .external_lex_state = 5},
  [3176] = {.lex_state = 98, .external_lex_state = 5},
  [3177] = {.lex_state = 98, .external_lex_state = 5},
  [3178] = {.lex_state = 98, .external_lex_state = 5},
  [3179] = {.lex_state = 98, .external_lex_state = 5},
  [3180] = {.lex_state = 4},
  [3181] = {.lex_state = 98, .external_lex_state = 5},
  [3182] = {.lex_state = 98, .external_lex_state = 4},
  [3183] = {.lex_state = 98, .external_lex_state = 5},
  [3184] = {.lex_state = 98, .external_lex_state = 5},
  [3185] = {.lex_state = 98, .external_lex_state = 5},
  [3186] = {.lex_state = 98, .external_lex_state = 5},
  [3187] = {.lex_state = 99},
  [3188] = {.lex_state = 98, .external_lex_state = 5},
  [3189] = {.lex_state = 98, .external_lex_state = 4},
  [3190] = {.lex_state = 98, .external_lex_state = 4},
  [3191] = {.lex_state = 98, .external_lex_state = 5},
  [3192] = {.lex_state = 98, .external_lex_state = 5},
  [3193] = {.lex_state = 100},
  [3194] = {.lex_state = 21, .external_lex_state = 6},
  [3195] = {.lex_state = 98},
  [3196] = {.lex_state = 98, .external_lex_state = 4},
  [3197] = {.lex_state = 21, .external_lex_state = 6},
  [3198] = {.lex_state = 98, .external_lex_state = 4},
  [3199] = {.lex_state = 21, .external_lex_state = 6},
  [3200] = {.lex_state = 98},
  [3201] = {.lex_state = 98},
  [3202] = {.lex_state = 98},
  [3203] = {.lex_state = 98, .external_lex_state = 4},
  [3204] = {.lex_state = 98},
  [3205] = {.lex_state = 98},
  [3206] = {.lex_state = 21, .external_lex_state = 6},
  [3207] = {.lex_state = 98, .external_lex_state = 5},
  [3208] = {.lex_state = 103},
  [3209] = {.lex_state = 21, .external_lex_state = 6},
  [3210] = {.lex_state = 98},
  [3211] = {.lex_state = 0, .external_lex_state = 4},
  [3212] = {.lex_state = 98, .external_lex_state = 4},
  [3213] = {.lex_state = 98, .external_lex_state = 4},
  [3214] = {.lex_state = 98, .external_lex_state = 4},
  [3215] = {.lex_state = 100},
  [3216] = {.lex_state = 98},
  [3217] = {.lex_state = 103},
  [3218] = {.lex_state = 103},
  [3219] = {.lex_state = 98},
  [3220] = {.lex_state = 21},
  [3221] = {.lex_state = 103},
  [3222] = {.lex_state = 98, .external_lex_state = 4},
  [3223] = {.lex_state = 98},
  [3224] = {.lex_state = 98},
  [3225] = {.lex_state = 100},
  [3226] = {.lex_state = 0, .external_lex_state = 4},
  [3227] = {.lex_state = 103},
  [3228] = {.lex_state = 100},
  [3229] = {.lex_state = 98},
  [3230] = {.lex_state = 98, .external_lex_state = 4},
  [3231] = {.lex_state = 98, .external_lex_state = 4},
  [3232] = {.lex_state = 98, .external_lex_state = 4},
  [3233] = {.lex_state = 4},
  [3234] = {.lex_state = 100},
  [3235] = {.lex_state = 103},
  [3236] = {.lex_state = 100},
  [3237] = {.lex_state = 98, .external_lex_state = 4},
  [3238] = {.lex_state = 98, .external_lex_state = 4},
  [3239] = {.lex_state = 0, .external_lex_state = 4},
  [3240] = {.lex_state = 100},
  [3241] = {.lex_state = 98, .external_lex_state = 4},
  [3242] = {.lex_state = 98, .external_lex_state = 4},
  [3243] = {.lex_state = 98},
  [3244] = {.lex_state = 98, .external_lex_state = 4},
  [3245] = {.lex_state = 98, .external_lex_state = 4},
  [3246] = {.lex_state = 98},
  [3247] = {.lex_state = 98, .external_lex_state = 4},
  [3248] = {.lex_state = 100},
  [3249] = {.lex_state = 100},
  [3250] = {.lex_state = 98},
  [3251] = {.lex_state = 98},
  [3252] = {.lex_state = 0, .external_lex_state = 4},
  [3253] = {.lex_state = 4},
  [3254] = {.lex_state = 98, .external_lex_state = 4},
  [3255] = {.lex_state = 98, .external_lex_state = 4},
  [3256] = {.lex_state = 98},
  [3257] = {.lex_state = 98},
  [3258] = {.lex_state = 98, .external_lex_state = 4},
  [3259] = {.lex_state = 98},
  [3260] = {.lex_state = 98, .external_lex_state = 4},
  [3261] = {.lex_state = 98, .external_lex_state = 4},
  [3262] = {.lex_state = 100},
  [3263] = {.lex_state = 98, .external_lex_state = 4},
  [3264] = {.lex_state = 98},
  [3265] = {.lex_state = 98, .external_lex_state = 4},
  [3266] = {.lex_state = 98, .external_lex_state = 4},
  [3267] = {.lex_state = 98},
  [3268] = {.lex_state = 98, .external_lex_state = 4},
  [3269] = {.lex_state = 98, .external_lex_state = 4},
  [3270] = {.lex_state = 98},
  [3271] = {.lex_state = 98, .external_lex_state = 4},
  [3272] = {.lex_state = 98, .external_lex_state = 4},
  [3273] = {.lex_state = 0, .external_lex_state = 4},
  [3274] = {.lex_state = 0, .external_lex_state = 4},
  [3275] = {.lex_state = 98, .external_lex_state = 4},
  [3276] = {.lex_state = 98, .external_lex_state = 4},
  [3277] = {.lex_state = 98, .external_lex_state = 4},
  [3278] = {.lex_state = 103},
  [3279] = {.lex_state = 98},
  [3280] = {.lex_state = 98},
  [3281] = {.lex_state = 103},
  [3282] = {.lex_state = 98},
  [3283] = {.lex_state = 98},
  [3284] = {.lex_state = 98},
  [3285] = {.lex_state = 98},
  [3286] = {.lex_state = 98},
  [3287] = {.lex_state = 100},
  [3288] = {.lex_state = 103},
  [3289] = {.lex_state = 98},
  [3290] = {.lex_state = 4},
  [3291] = {.lex_state = 98},
  [3292] = {.lex_state = 98},
  [3293] = {.lex_state = 98},
  [3294] = {.lex_state = 98},
  [3295] = {.lex_state = 98},
  [3296] = {.lex_state = 98},
  [3297] = {.lex_state = 103},
  [3298] = {.lex_state = 100},
  [3299] = {.lex_state = 100},
  [3300] = {.lex_state = 98},
  [3301] = {.lex_state = 100},
  [3302] = {.lex_state = 98},
  [3303] = {.lex_state = 98, .external_lex_state = 4},
  [3304] = {.lex_state = 0, .external_lex_state = 4},
  [3305] = {.lex_state = 100},
  [3306] = {.lex_state = 103},
  [3307] = {.lex_state = 100},
  [3308] = {.lex_state = 103},
  [3309] = {.lex_state = 98, .external_lex_state = 4},
  [3310] = {.lex_state = 103},
  [3311] = {.lex_state = 98},
  [3312] = {.lex_state = 98},
  [3313] = {.lex_state = 98},
  [3314] = {.lex_state = 98},
  [3315] = {.lex_state = 98},
  [3316] = {.lex_state = 103},
  [3317] = {.lex_state = 98, .external_lex_state = 4},
  [3318] = {.lex_state = 98, .external_lex_state = 4},
  [3319] = {.lex_state = 0, .external_lex_state = 4},
  [3320] = {.lex_state = 0, .external_lex_state = 4},
  [3321] = {.lex_state = 98},
  [3322] = {.lex_state = 98},
  [3323] = {.lex_state = 0, .external_lex_state = 4},
  [3324] = {.lex_state = 98, .external_lex_state = 4},
  [3325] = {.lex_state = 98},
  [3326] = {.lex_state = 98},
  [3327] = {.lex_state = 100},
  [3328] = {.lex_state = 98, .external_lex_state = 4},
  [3329] = {.lex_state = 103},
  [3330] = {.lex_state = 103},
  [3331] = {.lex_state = 0, .external_lex_state = 4},
  [3332] = {.lex_state = 100},
  [3333] = {.lex_state = 23, .external_lex_state = 6},
  [3334] = {.lex_state = 100},
  [3335] = {.lex_state = 100},
  [3336] = {.lex_state = 100},
  [3337] = {.lex_state = 98},
  [3338] = {.lex_state = 21},
  [3339] = {.lex_state = 4},
  [3340] = {.lex_state = 23, .external_lex_state = 6},
  [3341] = {.lex_state = 21, .external_lex_state = 6},
  [3342] = {.lex_state = 98, .external_lex_state = 5},
  [3343] = {.lex_state = 98, .external_lex_state = 5},
  [3344] = {.lex_state = 21, .external_lex_state = 6},
  [3345] = {.lex_state = 103},
  [3346] = {.lex_state = 100},
  [3347] = {.lex_state = 0, .external_lex_state = 4},
  [3348] = {.lex_state = 0, .external_lex_state = 4},
  [3349] = {.lex_state = 98},
  [3350] = {.lex_state = 100},
  [3351] = {.lex_state = 98},
  [3352] = {.lex_state = 103},
  [3353] = {.lex_state = 21, .external_lex_state = 6},
  [3354] = {.lex_state = 0, .external_lex_state = 4},
  [3355] = {.lex_state = 98, .external_lex_state = 5},
  [3356] = {.lex_state = 100},
  [3357] = {.lex_state = 98},
  [3358] = {.lex_state = 100},
  [3359] = {.lex_state = 98},
  [3360] = {.lex_state = 21},
  [3361] = {.lex_state = 98, .external_lex_state = 5},
  [3362] = {.lex_state = 98},
  [3363] = {.lex_state = 98, .external_lex_state = 5},
  [3364] = {.lex_state = 21, .external_lex_state = 6},
  [3365] = {.lex_state = 103},
  [3366] = {.lex_state = 98},
  [3367] = {.lex_state = 98},
  [3368] = {.lex_state = 100},
  [3369] = {.lex_state = 21},
  [3370] = {.lex_state = 98},
  [3371] = {.lex_state = 98, .external_lex_state = 5},
  [3372] = {.lex_state = 103},
  [3373] = {.lex_state = 21, .external_lex_state = 6},
  [3374] = {.lex_state = 23, .external_lex_state = 6},
  [3375] = {.lex_state = 4},
  [3376] = {.lex_state = 0, .external_lex_state = 4},
  [3377] = {.lex_state = 98},
  [3378] = {.lex_state = 0, .external_lex_state = 4},
  [3379] = {.lex_state = 100},
  [3380] = {.lex_state = 98},
  [3381] = {.lex_state = 0, .external_lex_state = 4},
  [3382] = {.lex_state = 100},
  [3383] = {.lex_state = 98, .external_lex_state = 5},
  [3384] = {.lex_state = 98, .external_lex_state = 5},
  [3385] = {.lex_state = 98, .external_lex_state = 5},
  [3386] = {.lex_state = 98, .external_lex_state = 5},
  [3387] = {.lex_state = 98, .external_lex_state = 5},
  [3388] = {.lex_state = 100},
  [3389] = {.lex_state = 21, .external_lex_state = 6},
  [3390] = {.lex_state = 98},
  [3391] = {.lex_state = 98, .external_lex_state = 5},
  [3392] = {.lex_state = 100},
  [3393] = {.lex_state = 98, .external_lex_state = 5},
  [3394] = {.lex_state = 0, .external_lex_state = 4},
  [3395] = {.lex_state = 98, .external_lex_state = 5},
  [3396] = {.lex_state = 0, .external_lex_state = 4},
  [3397] = {.lex_state = 98, .external_lex_state = 4},
  [3398] = {.lex_state = 0, .external_lex_state = 4},
  [3399] = {.lex_state = 100},
  [3400] = {.lex_state = 98},
  [3401] = {.lex_state = 98},
  [3402] = {.lex_state = 98, .external_lex_state = 5},
  [3403] = {.lex_state = 100},
  [3404] = {.lex_state = 0, .external_lex_state = 4},
  [3405] = {.lex_state = 98, .external_lex_state = 5},
  [3406] = {.lex_state = 98},
  [3407] = {.lex_state = 98},
  [3408] = {.lex_state = 100},
  [3409] = {.lex_state = 100},
  [3410] = {.lex_state = 98, .external_lex_state = 5},
  [3411] = {.lex_state = 98, .external_lex_state = 5},
  [3412] = {.lex_state = 21, .external_lex_state = 6},
  [3413] = {.lex_state = 103},
  [3414] = {.lex_state = 103},
  [3415] = {.lex_state = 21, .external_lex_state = 6},
  [3416] = {.lex_state = 103},
  [3417] = {.lex_state = 23, .external_lex_state = 6},
  [3418] = {.lex_state = 100},
  [3419] = {.lex_state = 4},
  [3420] = {.lex_state = 21, .external_lex_state = 6},
  [3421] = {.lex_state = 23, .external_lex_state = 6},
  [3422] = {.lex_state = 98, .external_lex_state = 5},
  [3423] = {.lex_state = 100},
  [3424] = {.lex_state = 98, .external_lex_state = 5},
  [3425] = {.lex_state = 0, .external_lex_state = 4},
  [3426] = {.lex_state = 0, .external_lex_state = 4},
  [3427] = {.lex_state = 100},
  [3428] = {.lex_state = 98, .external_lex_state = 5},
  [3429] = {.lex_state = 0, .external_lex_state = 4},
  [3430] = {.lex_state = 0, .external_lex_state = 4},
  [3431] = {.lex_state = 98, .external_lex_state = 5},
  [3432] = {.lex_state = 103},
  [3433] = {.lex_state = 21},
  [3434] = {.lex_state = 103},
  [3435] = {.lex_state = 100},
  [3436] = {.lex_state = 0, .external_lex_state = 4},
  [3437] = {.lex_state = 98},
  [3438] = {.lex_state = 0, .external_lex_state = 4},
  [3439] = {.lex_state = 0, .external_lex_state = 4},
  [3440] = {.lex_state = 98},
  [3441] = {.lex_state = 100},
  [3442] = {.lex_state = 100},
  [3443] = {.lex_state = 0, .external_lex_state = 4},
  [3444] = {.lex_state = 100},
  [3445] = {.lex_state = 98, .external_lex_state = 5},
  [3446] = {.lex_state = 98, .external_lex_state = 5},
  [3447] = {.lex_state = 100},
  [3448] = {.lex_state = 98, .external_lex_state = 5},
  [3449] = {.lex_state = 98},
  [3450] = {.lex_state = 100},
  [3451] = {.lex_state = 98},
  [3452] = {.lex_state = 21, .external_lex_state = 6},
  [3453] = {.lex_state = 103},
  [3454] = {.lex_state = 21, .external_lex_state = 6},
  [3455] = {.lex_state = 23, .external_lex_state = 6},
  [3456] = {.lex_state = 98},
  [3457] = {.lex_state = 100},
  [3458] = {.lex_state = 21},
  [3459] = {.lex_state = 103},
  [3460] = {.lex_state = 100},
  [3461] = {.lex_state = 0, .external_lex_state = 4},
  [3462] = {.lex_state = 98},
  [3463] = {.lex_state = 98},
  [3464] = {.lex_state = 103},
  [3465] = {.lex_state = 98},
  [3466] = {.lex_state = 98},
  [3467] = {.lex_state = 98},
  [3468] = {.lex_state = 98},
  [3469] = {.lex_state = 0, .external_lex_state = 4},
  [3470] = {.lex_state = 100},
  [3471] = {.lex_state = 21, .external_lex_state = 6},
  [3472] = {.lex_state = 0, .external_lex_state = 4},
  [3473] = {.lex_state = 0, .external_lex_state = 4},
  [3474] = {.lex_state = 23, .external_lex_state = 6},
  [3475] = {.lex_state = 21, .external_lex_state = 6},
  [3476] = {.lex_state = 100},
  [3477] = {.lex_state = 98},
  [3478] = {.lex_state = 98},
  [3479] = {.lex_state = 100},
  [3480] = {.lex_state = 0, .external_lex_state = 4},
  [3481] = {.lex_state = 100},
  [3482] = {.lex_state = 0, .external_lex_state = 4},
  [3483] = {.lex_state = 103},
  [3484] = {.lex_state = 0, .external_lex_state = 4},
  [3485] = {.lex_state = 0, .external_lex_state = 4},
  [3486] = {.lex_state = 98},
  [3487] = {.lex_state = 21},
  [3488] = {.lex_state = 100},
  [3489] = {.lex_state = 21},
  [3490] = {.lex_state = 100},
  [3491] = {.lex_state = 98, .external_lex_state = 5},
  [3492] = {.lex_state = 100},
  [3493] = {.lex_state = 4},
  [3494] = {.lex_state = 100},
  [3495] = {.lex_state = 98, .external_lex_state = 4},
  [3496] = {.lex_state = 23, .external_lex_state = 6},
  [3497] = {.lex_state = 21, .external_lex_state = 6},
  [3498] = {.lex_state = 23, .external_lex_state = 6},
  [3499] = {.lex_state = 21, .external_lex_state = 6},
  [3500] = {.lex_state = 98, .external_lex_state = 4},
  [3501] = {.lex_state = 100},
  [3502] = {.lex_state = 98, .external_lex_state = 4},
  [3503] = {.lex_state = 0, .external_lex_state = 4},
  [3504] = {.lex_state = 0},
  [3505] = {.lex_state = 98, .external_lex_state = 5},
  [3506] = {.lex_state = 98},
  [3507] = {.lex_state = 98},
  [3508] = {.lex_state = 98},
  [3509] = {.lex_state = 0, .external_lex_state = 4},
  [3510] = {.lex_state = 98},
  [3511] = {.lex_state = 98},
  [3512] = {.lex_state = 21},
  [3513] = {.lex_state = 0, .external_lex_state = 4},
  [3514] = {.lex_state = 100},
  [3515] = {.lex_state = 21},
  [3516] = {.lex_state = 98},
  [3517] = {.lex_state = 98, .external_lex_state = 4},
  [3518] = {.lex_state = 100},
  [3519] = {.lex_state = 21},
  [3520] = {.lex_state = 100},
  [3521] = {.lex_state = 0, .external_lex_state = 4},
  [3522] = {.lex_state = 98},
  [3523] = {.lex_state = 0, .external_lex_state = 4},
  [3524] = {.lex_state = 0, .external_lex_state = 4},
  [3525] = {.lex_state = 100},
  [3526] = {.lex_state = 21, .external_lex_state = 6},
  [3527] = {.lex_state = 98},
  [3528] = {.lex_state = 98},
  [3529] = {.lex_state = 98},
  [3530] = {.lex_state = 98},
  [3531] = {.lex_state = 98, .external_lex_state = 4},
  [3532] = {.lex_state = 100},
  [3533] = {.lex_state = 98},
  [3534] = {.lex_state = 0},
  [3535] = {.lex_state = 0, .external_lex_state = 4},
  [3536] = {.lex_state = 98},
  [3537] = {.lex_state = 98},
  [3538] = {.lex_state = 98},
  [3539] = {.lex_state = 100},
  [3540] = {.lex_state = 0},
  [3541] = {.lex_state = 98},
  [3542] = {.lex_state = 0},
  [3543] = {.lex_state = 98},
  [3544] = {.lex_state = 98, .external_lex_state = 5},
  [3545] = {.lex_state = 0},
  [3546] = {.lex_state = 0},
  [3547] = {.lex_state = 100},
  [3548] = {.lex_state = 100},
  [3549] = {.lex_state = 100},
  [3550] = {.lex_state = 0, .external_lex_state = 4},
  [3551] = {.lex_state = 98, .external_lex_state = 5},
  [3552] = {.lex_state = 0, .external_lex_state = 4},
  [3553] = {.lex_state = 100},
  [3554] = {.lex_state = 0, .external_lex_state = 4},
  [3555] = {.lex_state = 0, .external_lex_state = 4},
  [3556] = {.lex_state = 0, .external_lex_state = 4},
  [3557] = {.lex_state = 0, .external_lex_state = 4},
  [3558] = {.lex_state = 98},
  [3559] = {.lex_state = 21, .external_lex_state = 6},
  [3560] = {.lex_state = 100},
  [3561] = {.lex_state = 0, .external_lex_state = 4},
  [3562] = {.lex_state = 0},
  [3563] = {.lex_state = 0, .external_lex_state = 4},
  [3564] = {.lex_state = 0, .external_lex_state = 4},
  [3565] = {.lex_state = 100},
  [3566] = {.lex_state = 0, .external_lex_state = 4},
  [3567] = {.lex_state = 0, .external_lex_state = 4},
  [3568] = {.lex_state = 0, .external_lex_state = 4},
  [3569] = {.lex_state = 0, .external_lex_state = 4},
  [3570] = {.lex_state = 0},
  [3571] = {.lex_state = 100},
  [3572] = {.lex_state = 0, .external_lex_state = 4},
  [3573] = {.lex_state = 100},
  [3574] = {.lex_state = 100},
  [3575] = {.lex_state = 98},
  [3576] = {.lex_state = 100},
  [3577] = {.lex_state = 21, .external_lex_state = 6},
  [3578] = {.lex_state = 100},
  [3579] = {.lex_state = 98, .external_lex_state = 4},
  [3580] = {.lex_state = 0},
  [3581] = {.lex_state = 98},
  [3582] = {.lex_state = 100},
  [3583] = {.lex_state = 0, .external_lex_state = 4},
  [3584] = {.lex_state = 100},
  [3585] = {.lex_state = 98, .external_lex_state = 4},
  [3586] = {.lex_state = 0, .external_lex_state = 4},
  [3587] = {.lex_state = 0, .external_lex_state = 4},
  [3588] = {.lex_state = 98, .external_lex_state = 4},
  [3589] = {.lex_state = 100},
  [3590] = {.lex_state = 0, .external_lex_state = 4},
  [3591] = {.lex_state = 100},
  [3592] = {.lex_state = 98},
  [3593] = {.lex_state = 100},
  [3594] = {.lex_state = 0, .external_lex_state = 4},
  [3595] = {.lex_state = 0, .external_lex_state = 4},
  [3596] = {.lex_state = 0, .external_lex_state = 4},
  [3597] = {.lex_state = 0, .external_lex_state = 4},
  [3598] = {.lex_state = 0, .external_lex_state = 4},
  [3599] = {.lex_state = 0},
  [3600] = {.lex_state = 100},
  [3601] = {.lex_state = 0, .external_lex_state = 4},
  [3602] = {.lex_state = 21, .external_lex_state = 6},
  [3603] = {.lex_state = 0},
  [3604] = {.lex_state = 0, .external_lex_state = 4},
  [3605] = {.lex_state = 0, .external_lex_state = 4},
  [3606] = {.lex_state = 0, .external_lex_state = 4},
  [3607] = {.lex_state = 0, .external_lex_state = 4},
  [3608] = {.lex_state = 98, .external_lex_state = 5},
  [3609] = {.lex_state = 100},
  [3610] = {.lex_state = 7},
  [3611] = {.lex_state = 4},
  [3612] = {.lex_state = 100},
  [3613] = {.lex_state = 0, .external_lex_state = 4},
  [3614] = {.lex_state = 0, .external_lex_state = 4},
  [3615] = {.lex_state = 100},
  [3616] = {.lex_state = 0, .external_lex_state = 4},
  [3617] = {.lex_state = 98, .external_lex_state = 4},
  [3618] = {.lex_state = 21, .external_lex_state = 6},
  [3619] = {.lex_state = 0, .external_lex_state = 4},
  [3620] = {.lex_state = 100},
  [3621] = {.lex_state = 0},
  [3622] = {.lex_state = 0, .external_lex_state = 4},
  [3623] = {.lex_state = 100},
  [3624] = {.lex_state = 98, .external_lex_state = 5},
  [3625] = {.lex_state = 100},
  [3626] = {.lex_state = 98, .external_lex_state = 5},
  [3627] = {.lex_state = 98},
  [3628] = {.lex_state = 98},
  [3629] = {.lex_state = 98},
  [3630] = {.lex_state = 100},
  [3631] = {.lex_state = 100},
  [3632] = {.lex_state = 98},
  [3633] = {.lex_state = 100},
  [3634] = {.lex_state = 100},
  [3635] = {.lex_state = 100},
  [3636] = {.lex_state = 98},
  [3637] = {.lex_state = 21, .external_lex_state = 6},
  [3638] = {.lex_state = 21, .external_lex_state = 6},
  [3639] = {.lex_state = 98, .external_lex_state = 5},
  [3640] = {.lex_state = 98},
  [3641] = {.lex_state = 98},
  [3642] = {.lex_state = 100},
  [3643] = {.lex_state = 100},
  [3644] = {.lex_state = 98},
  [3645] = {.lex_state = 98},
  [3646] = {.lex_state = 98},
  [3647] = {.lex_state = 100},
  [3648] = {.lex_state = 98, .external_lex_state = 5},
  [3649] = {.lex_state = 100},
  [3650] = {.lex_state = 0, .external_lex_state = 4},
  [3651] = {.lex_state = 21},
  [3652] = {.lex_state = 98},
  [3653] = {.lex_state = 0},
  [3654] = {.lex_state = 100},
  [3655] = {.lex_state = 98},
  [3656] = {.lex_state = 98},
  [3657] = {.lex_state = 100},
  [3658] = {.lex_state = 98},
  [3659] = {.lex_state = 0, .external_lex_state = 4},
  [3660] = {.lex_state = 100},
  [3661] = {.lex_state = 98},
  [3662] = {.lex_state = 100},
  [3663] = {.lex_state = 0, .external_lex_state = 4},
  [3664] = {.lex_state = 0, .external_lex_state = 4},
  [3665] = {.lex_state = 0},
  [3666] = {.lex_state = 0, .external_lex_state = 4},
  [3667] = {.lex_state = 0, .external_lex_state = 4},
  [3668] = {.lex_state = 98},
  [3669] = {.lex_state = 98},
  [3670] = {.lex_state = 98},
  [3671] = {.lex_state = 98},
  [3672] = {.lex_state = 98},
  [3673] = {.lex_state = 0, .external_lex_state = 4},
  [3674] = {.lex_state = 100},
  [3675] = {.lex_state = 100},
  [3676] = {.lex_state = 98},
  [3677] = {.lex_state = 98},
  [3678] = {.lex_state = 100},
  [3679] = {.lex_state = 0, .external_lex_state = 4},
  [3680] = {.lex_state = 98, .external_lex_state = 5},
  [3681] = {.lex_state = 98},
  [3682] = {.lex_state = 100},
  [3683] = {.lex_state = 98},
  [3684] = {.lex_state = 100},
  [3685] = {.lex_state = 21, .external_lex_state = 6},
  [3686] = {.lex_state = 21, .external_lex_state = 6},
  [3687] = {.lex_state = 21, .external_lex_state = 6},
  [3688] = {.lex_state = 0, .external_lex_state = 4},
  [3689] = {.lex_state = 0, .external_lex_state = 4},
  [3690] = {.lex_state = 100},
  [3691] = {.lex_state = 0},
  [3692] = {.lex_state = 0, .external_lex_state = 4},
  [3693] = {.lex_state = 100},
  [3694] = {.lex_state = 100},
  [3695] = {.lex_state = 100},
  [3696] = {.lex_state = 7},
  [3697] = {.lex_state = 100},
  [3698] = {.lex_state = 0, .external_lex_state = 4},
  [3699] = {.lex_state = 0, .external_lex_state = 4},
  [3700] = {.lex_state = 98},
  [3701] = {.lex_state = 21, .external_lex_state = 6},
  [3702] = {.lex_state = 100},
  [3703] = {.lex_state = 0, .external_lex_state = 4},
  [3704] = {.lex_state = 0, .external_lex_state = 4},
  [3705] = {.lex_state = 0, .external_lex_state = 4},
  [3706] = {.lex_state = 98, .external_lex_state = 5},
  [3707] = {.lex_state = 0, .external_lex_state = 4},
  [3708] = {.lex_state = 100},
  [3709] = {.lex_state = 4},
  [3710] = {.lex_state = 98, .external_lex_state = 5},
  [3711] = {.lex_state = 0, .external_lex_state = 4},
  [3712] = {.lex_state = 98, .external_lex_state = 5},
  [3713] = {.lex_state = 0, .external_lex_state = 4},
  [3714] = {.lex_state = 100},
  [3715] = {.lex_state = 0, .external_lex_state = 4},
  [3716] = {.lex_state = 100},
  [3717] = {.lex_state = 100},
  [3718] = {.lex_state = 98, .external_lex_state = 5},
  [3719] = {.lex_state = 21, .external_lex_state = 6},
  [3720] = {.lex_state = 0, .external_lex_state = 4},
  [3721] = {.lex_state = 0, .external_lex_state = 4},
  [3722] = {.lex_state = 21, .external_lex_state = 6},
  [3723] = {.lex_state = 0, .external_lex_state = 4},
  [3724] = {.lex_state = 100},
  [3725] = {.lex_state = 0, .external_lex_state = 4},
  [3726] = {.lex_state = 0, .external_lex_state = 4},
  [3727] = {.lex_state = 3},
  [3728] = {.lex_state = 23, .external_lex_state = 6},
  [3729] = {.lex_state = 1},
  [3730] = {.lex_state = 98},
  [3731] = {.lex_state = 98},
  [3732] = {.lex_state = 98},
  [3733] = {.lex_state = 98},
  [3734] = {.lex_state = 100},
  [3735] = {.lex_state = 3},
  [3736] = {.lex_state = 19},
  [3737] = {.lex_state = 3},
  [3738] = {.lex_state = 100},
  [3739] = {.lex_state = 98},
  [3740] = {.lex_state = 19},
  [3741] = {.lex_state = 25},
  [3742] = {.lex_state = 1},
  [3743] = {.lex_state = 25},
  [3744] = {.lex_state = 19},
  [3745] = {.lex_state = 19},
  [3746] = {.lex_state = 4},
  [3747] = {.lex_state = 3},
  [3748] = {.lex_state = 1},
  [3749] = {.lex_state = 25},
  [3750] = {.lex_state = 3},
  [3751] = {.lex_state = 19},
  [3752] = {.lex_state = 98},
  [3753] = {.lex_state = 25},
  [3754] = {.lex_state = 19},
  [3755] = {.lex_state = 25},
  [3756] = {.lex_state = 100},
  [3757] = {.lex_state = 25},
  [3758] = {.lex_state = 1},
  [3759] = {.lex_state = 3},
  [3760] = {.lex_state = 98},
  [3761] = {.lex_state = 3},
  [3762] = {.lex_state = 4},
  [3763] = {.lex_state = 100},
  [3764] = {.lex_state = 25},
  [3765] = {.lex_state = 19},
  [3766] = {.lex_state = 98},
  [3767] = {.lex_state = 100},
  [3768] = {.lex_state = 98},
  [3769] = {.lex_state = 25},
  [3770] = {.lex_state = 3},
  [3771] = {.lex_state = 19},
  [3772] = {.lex_state = 98},
  [3773] = {.lex_state = 98},
  [3774] = {.lex_state = 98},
  [3775] = {.lex_state = 25},
  [3776] = {.lex_state = 19},
  [3777] = {.lex_state = 98},
  [3778] = {.lex_state = 4},
  [3779] = {.lex_state = 0},
  [3780] = {.lex_state = 98},
  [3781] = {.lex_state = 0},
  [3782] = {.lex_state = 3},
  [3783] = {.lex_state = 100},
  [3784] = {.lex_state = 3},
  [3785] = {.lex_state = 98},
  [3786] = {.lex_state = 0},
  [3787] = {.lex_state = 19},
  [3788] = {.lex_state = 0},
  [3789] = {.lex_state = 25},
  [3790] = {.lex_state = 0},
  [3791] = {.lex_state = 98},
  [3792] = {.lex_state = 98},
  [3793] = {.lex_state = 4},
  [3794] = {.lex_state = 1},
  [3795] = {.lex_state = 98},
  [3796] = {.lex_state = 3},
  [3797] = {.lex_state = 98},
  [3798] = {.lex_state = 100},
  [3799] = {.lex_state = 0},
  [3800] = {.lex_state = 3},
  [3801] = {.lex_state = 3},
  [3802] = {.lex_state = 3},
  [3803] = {.lex_state = 0},
  [3804] = {.lex_state = 100},
  [3805] = {.lex_state = 0, .external_lex_state = 4},
  [3806] = {.lex_state = 98},
  [3807] = {.lex_state = 3},
  [3808] = {.lex_state = 98},
  [3809] = {.lex_state = 98},
  [3810] = {.lex_state = 98},
  [3811] = {.lex_state = 3},
  [3812] = {.lex_state = 25},
  [3813] = {.lex_state = 100},
  [3814] = {.lex_state = 4},
  [3815] = {.lex_state = 3},
  [3816] = {.lex_state = 19},
  [3817] = {.lex_state = 19},
  [3818] = {.lex_state = 25},
  [3819] = {.lex_state = 98},
  [3820] = {.lex_state = 3},
  [3821] = {.lex_state = 25},
  [3822] = {.lex_state = 3},
  [3823] = {.lex_state = 19},
  [3824] = {.lex_state = 98},
  [3825] = {.lex_state = 98},
  [3826] = {.lex_state = 3},
  [3827] = {.lex_state = 3},
  [3828] = {.lex_state = 3},
  [3829] = {.lex_state = 0},
  [3830] = {.lex_state = 98},
  [3831] = {.lex_state = 0, .external_lex_state = 4},
  [3832] = {.lex_state = 3},
  [3833] = {.lex_state = 98},
  [3834] = {.lex_state = 98},
  [3835] = {.lex_state = 0, .external_lex_state = 4},
  [3836] = {.lex_state = 98},
  [3837] = {.lex_state = 98},
  [3838] = {.lex_state = 1},
  [3839] = {.lex_state = 98},
  [3840] = {.lex_state = 0},
  [3841] = {.lex_state = 98},
  [3842] = {.lex_state = 98},
  [3843] = {.lex_state = 98},
  [3844] = {.lex_state = 3},
  [3845] = {.lex_state = 100},
  [3846] = {.lex_state = 98},
  [3847] = {.lex_state = 3},
  [3848] = {.lex_state = 98},
  [3849] = {.lex_state = 3},
  [3850] = {.lex_state = 98},
  [3851] = {.lex_state = 3},
  [3852] = {.lex_state = 98},
  [3853] = {.lex_state = 0},
  [3854] = {.lex_state = 3},
  [3855] = {.lex_state = 3},
  [3856] = {.lex_state = 100},
  [3857] = {.lex_state = 100},
  [3858] = {.lex_state = 98},
  [3859] = {.lex_state = 0},
  [3860] = {.lex_state = 3},
  [3861] = {.lex_state = 3},
  [3862] = {.lex_state = 98},
  [3863] = {.lex_state = 0, .external_lex_state = 4},
  [3864] = {.lex_state = 100},
  [3865] = {.lex_state = 3},
  [3866] = {.lex_state = 98},
  [3867] = {.lex_state = 3},
  [3868] = {.lex_state = 100},
  [3869] = {.lex_state = 21, .external_lex_state = 6},
  [3870] = {.lex_state = 98},
  [3871] = {.lex_state = 98},
  [3872] = {.lex_state = 21, .external_lex_state = 6},
  [3873] = {.lex_state = 100},
  [3874] = {.lex_state = 98},
  [3875] = {.lex_state = 98},
  [3876] = {.lex_state = 100},
  [3877] = {.lex_state = 98},
  [3878] = {.lex_state = 98},
  [3879] = {.lex_state = 98},
  [3880] = {.lex_state = 0},
  [3881] = {.lex_state = 100},
  [3882] = {.lex_state = 0},
  [3883] = {.lex_state = 98},
  [3884] = {.lex_state = 100},
  [3885] = {.lex_state = 0},
  [3886] = {.lex_state = 3},
  [3887] = {.lex_state = 100},
  [3888] = {.lex_state = 100},
  [3889] = {.lex_state = 98},
  [3890] = {.lex_state = 19},
  [3891] = {.lex_state = 25},
  [3892] = {.lex_state = 3},
  [3893] = {.lex_state = 100},
  [3894] = {.lex_state = 100},
  [3895] = {.lex_state = 3},
  [3896] = {.lex_state = 3},
  [3897] = {.lex_state = 3},
  [3898] = {.lex_state = 0},
  [3899] = {.lex_state = 0, .external_lex_state = 5},
  [3900] = {.lex_state = 25},
  [3901] = {.lex_state = 3},
  [3902] = {.lex_state = 19},
  [3903] = {.lex_state = 1},
  [3904] = {.lex_state = 98},
  [3905] = {.lex_state = 98},
  [3906] = {.lex_state = 0},
  [3907] = {.lex_state = 0, .external_lex_state = 4},
  [3908] = {.lex_state = 98},
  [3909] = {.lex_state = 0},
  [3910] = {.lex_state = 98},
  [3911] = {.lex_state = 0},
  [3912] = {.lex_state = 0},
  [3913] = {.lex_state = 98},
  [3914] = {.lex_state = 0},
  [3915] = {.lex_state = 98, .external_lex_state = 4},
  [3916] = {.lex_state = 0},
  [3917] = {.lex_state = 21, .external_lex_state = 6},
  [3918] = {.lex_state = 0},
  [3919] = {.lex_state = 98},
  [3920] = {.lex_state = 0},
  [3921] = {.lex_state = 0},
  [3922] = {.lex_state = 0},
  [3923] = {.lex_state = 98, .external_lex_state = 4},
  [3924] = {.lex_state = 98, .external_lex_state = 4},
  [3925] = {.lex_state = 0},
  [3926] = {.lex_state = 0},
  [3927] = {.lex_state = 98},
  [3928] = {.lex_state = 0},
  [3929] = {.lex_state = 98},
  [3930] = {.lex_state = 0},
  [3931] = {.lex_state = 0},
  [3932] = {.lex_state = 0},
  [3933] = {.lex_state = 0},
  [3934] = {.lex_state = 98},
  [3935] = {.lex_state = 0, .external_lex_state = 4},
  [3936] = {.lex_state = 0},
  [3937] = {.lex_state = 0},
  [3938] = {.lex_state = 98},
  [3939] = {.lex_state = 0},
  [3940] = {.lex_state = 7},
  [3941] = {.lex_state = 0},
  [3942] = {.lex_state = 98},
  [3943] = {.lex_state = 98},
  [3944] = {.lex_state = 98},
  [3945] = {.lex_state = 0},
  [3946] = {.lex_state = 100},
  [3947] = {.lex_state = 0},
  [3948] = {.lex_state = 98},
  [3949] = {.lex_state = 98},
  [3950] = {.lex_state = 0},
  [3951] = {.lex_state = 0},
  [3952] = {.lex_state = 98},
  [3953] = {.lex_state = 98},
  [3954] = {.lex_state = 98},
  [3955] = {.lex_state = 98},
  [3956] = {.lex_state = 0},
  [3957] = {.lex_state = 98},
  [3958] = {.lex_state = 98},
  [3959] = {.lex_state = 98},
  [3960] = {.lex_state = 0},
  [3961] = {.lex_state = 0},
  [3962] = {.lex_state = 98, .external_lex_state = 4},
  [3963] = {.lex_state = 0, .external_lex_state = 4},
  [3964] = {.lex_state = 0, .external_lex_state = 4},
  [3965] = {.lex_state = 0, .external_lex_state = 4},
  [3966] = {.lex_state = 0, .external_lex_state = 4},
  [3967] = {.lex_state = 0, .external_lex_state = 4},
  [3968] = {.lex_state = 98},
  [3969] = {.lex_state = 0, .external_lex_state = 4},
  [3970] = {.lex_state = 0, .external_lex_state = 4},
  [3971] = {.lex_state = 98},
  [3972] = {.lex_state = 98},
  [3973] = {.lex_state = 0},
  [3974] = {.lex_state = 0},
  [3975] = {.lex_state = 98},
  [3976] = {.lex_state = 98},
  [3977] = {.lex_state = 0},
  [3978] = {.lex_state = 0},
  [3979] = {.lex_state = 0, .external_lex_state = 4},
  [3980] = {.lex_state = 98},
  [3981] = {.lex_state = 0, .external_lex_state = 4},
  [3982] = {.lex_state = 0},
  [3983] = {.lex_state = 98},
  [3984] = {.lex_state = 98},
  [3985] = {.lex_state = 0},
  [3986] = {.lex_state = 0},
  [3987] = {.lex_state = 0},
  [3988] = {.lex_state = 0},
  [3989] = {.lex_state = 0},
  [3990] = {.lex_state = 0},
  [3991] = {.lex_state = 0},
  [3992] = {.lex_state = 0},
  [3993] = {.lex_state = 0},
  [3994] = {.lex_state = 0, .external_lex_state = 4},
  [3995] = {.lex_state = 0, .external_lex_state = 4},
  [3996] = {.lex_state = 0, .external_lex_state = 4},
  [3997] = {.lex_state = 0, .external_lex_state = 4},
  [3998] = {.lex_state = 0, .external_lex_state = 4},
  [3999] = {.lex_state = 0, .external_lex_state = 4},
  [4000] = {.lex_state = 0, .external_lex_state = 4},
  [4001] = {.lex_state = 0},
  [4002] = {.lex_state = 0},
  [4003] = {.lex_state = 0, .external_lex_state = 4},
  [4004] = {.lex_state = 0},
  [4005] = {.lex_state = 0},
  [4006] = {.lex_state = 0},
  [4007] = {.lex_state = 0, .external_lex_state = 4},
  [4008] = {.lex_state = 0, .external_lex_state = 4},
  [4009] = {.lex_state = 98},
  [4010] = {.lex_state = 98},
  [4011] = {.lex_state = 0, .external_lex_state = 4},
  [4012] = {.lex_state = 0},
  [4013] = {.lex_state = 98},
  [4014] = {.lex_state = 0},
  [4015] = {.lex_state = 98},
  [4016] = {.lex_state = 0},
  [4017] = {.lex_state = 0},
  [4018] = {.lex_state = 98},
  [4019] = {.lex_state = 0},
  [4020] = {.lex_state = 0},
  [4021] = {.lex_state = 4, .external_lex_state = 4},
  [4022] = {.lex_state = 0},
  [4023] = {.lex_state = 0},
  [4024] = {.lex_state = 0, .external_lex_state = 4},
  [4025] = {.lex_state = 0, .external_lex_state = 4},
  [4026] = {.lex_state = 98},
  [4027] = {.lex_state = 0, .external_lex_state = 4},
  [4028] = {.lex_state = 0},
  [4029] = {.lex_state = 0},
  [4030] = {.lex_state = 98},
  [4031] = {.lex_state = 0},
  [4032] = {.lex_state = 98},
  [4033] = {.lex_state = 98},
  [4034] = {.lex_state = 0},
  [4035] = {.lex_state = 0},
  [4036] = {.lex_state = 0},
  [4037] = {.lex_state = 0, .external_lex_state = 4},
  [4038] = {.lex_state = 0},
  [4039] = {.lex_state = 0, .external_lex_state = 4},
  [4040] = {.lex_state = 0, .external_lex_state = 4},
  [4041] = {.lex_state = 0, .external_lex_state = 4},
  [4042] = {.lex_state = 0, .external_lex_state = 4},
  [4043] = {.lex_state = 0, .external_lex_state = 4},
  [4044] = {.lex_state = 0, .external_lex_state = 4},
  [4045] = {.lex_state = 0, .external_lex_state = 4},
  [4046] = {.lex_state = 0, .external_lex_state = 4},
  [4047] = {.lex_state = 0, .external_lex_state = 4},
  [4048] = {.lex_state = 0},
  [4049] = {.lex_state = 0},
  [4050] = {.lex_state = 0},
  [4051] = {.lex_state = 0},
  [4052] = {.lex_state = 0},
  [4053] = {.lex_state = 0},
  [4054] = {.lex_state = 0},
  [4055] = {.lex_state = 0},
  [4056] = {.lex_state = 4},
  [4057] = {.lex_state = 0},
  [4058] = {.lex_state = 0},
  [4059] = {.lex_state = 0},
  [4060] = {.lex_state = 0},
  [4061] = {.lex_state = 0},
  [4062] = {.lex_state = 0},
  [4063] = {.lex_state = 0},
  [4064] = {.lex_state = 0},
  [4065] = {.lex_state = 0},
  [4066] = {.lex_state = 98},
  [4067] = {.lex_state = 0},
  [4068] = {.lex_state = 0},
  [4069] = {.lex_state = 0},
  [4070] = {.lex_state = 0},
  [4071] = {.lex_state = 4},
  [4072] = {.lex_state = 98},
  [4073] = {.lex_state = 0},
  [4074] = {.lex_state = 0, .external_lex_state = 4},
  [4075] = {.lex_state = 0},
  [4076] = {.lex_state = 0, .external_lex_state = 4},
  [4077] = {.lex_state = 0, .external_lex_state = 4},
  [4078] = {.lex_state = 0, .external_lex_state = 4},
  [4079] = {.lex_state = 0, .external_lex_state = 4},
  [4080] = {.lex_state = 0, .external_lex_state = 4},
  [4081] = {.lex_state = 0, .external_lex_state = 4},
  [4082] = {.lex_state = 0},
  [4083] = {.lex_state = 0},
  [4084] = {.lex_state = 98},
  [4085] = {.lex_state = 0},
  [4086] = {.lex_state = 0},
  [4087] = {.lex_state = 98},
  [4088] = {.lex_state = 98},
  [4089] = {.lex_state = 0},
  [4090] = {.lex_state = 0},
  [4091] = {.lex_state = 0},
  [4092] = {.lex_state = 0, .external_lex_state = 4},
  [4093] = {.lex_state = 0, .external_lex_state = 4},
  [4094] = {.lex_state = 0, .external_lex_state = 4},
  [4095] = {.lex_state = 98},
  [4096] = {.lex_state = 98},
  [4097] = {.lex_state = 98},
  [4098] = {.lex_state = 0},
  [4099] = {.lex_state = 98},
  [4100] = {.lex_state = 98},
  [4101] = {.lex_state = 0},
  [4102] = {.lex_state = 0, .external_lex_state = 4},
  [4103] = {.lex_state = 0},
  [4104] = {.lex_state = 0, .external_lex_state = 4},
  [4105] = {.lex_state = 0, .external_lex_state = 4},
  [4106] = {.lex_state = 98},
  [4107] = {.lex_state = 0},
  [4108] = {.lex_state = 98},
  [4109] = {.lex_state = 0},
  [4110] = {.lex_state = 98},
  [4111] = {.lex_state = 0, .external_lex_state = 4},
  [4112] = {.lex_state = 0},
  [4113] = {.lex_state = 0},
  [4114] = {.lex_state = 0},
  [4115] = {.lex_state = 0, .external_lex_state = 4},
  [4116] = {.lex_state = 0},
  [4117] = {.lex_state = 0},
  [4118] = {.lex_state = 98},
  [4119] = {.lex_state = 0, .external_lex_state = 4},
  [4120] = {.lex_state = 0},
  [4121] = {.lex_state = 7},
  [4122] = {.lex_state = 98},
  [4123] = {.lex_state = 0},
  [4124] = {.lex_state = 0},
  [4125] = {.lex_state = 0},
  [4126] = {.lex_state = 0},
  [4127] = {.lex_state = 0},
  [4128] = {.lex_state = 0},
  [4129] = {.lex_state = 98},
  [4130] = {.lex_state = 98},
  [4131] = {.lex_state = 7},
  [4132] = {.lex_state = 0},
  [4133] = {.lex_state = 0},
  [4134] = {.lex_state = 0},
  [4135] = {.lex_state = 0},
  [4136] = {.lex_state = 0},
  [4137] = {.lex_state = 0},
  [4138] = {.lex_state = 0},
  [4139] = {.lex_state = 98},
  [4140] = {.lex_state = 98},
  [4141] = {.lex_state = 98},
  [4142] = {.lex_state = 98},
  [4143] = {.lex_state = 98},
  [4144] = {.lex_state = 0},
  [4145] = {.lex_state = 0},
  [4146] = {.lex_state = 0},
  [4147] = {.lex_state = 98},
  [4148] = {.lex_state = 98},
  [4149] = {.lex_state = 4, .external_lex_state = 4},
  [4150] = {.lex_state = 0},
  [4151] = {.lex_state = 98},
  [4152] = {.lex_state = 98},
  [4153] = {.lex_state = 98},
  [4154] = {.lex_state = 98},
  [4155] = {.lex_state = 98},
  [4156] = {.lex_state = 98},
  [4157] = {.lex_state = 98},
  [4158] = {.lex_state = 0},
  [4159] = {.lex_state = 0, .external_lex_state = 4},
  [4160] = {.lex_state = 0},
  [4161] = {.lex_state = 0},
  [4162] = {.lex_state = 0},
  [4163] = {.lex_state = 98},
  [4164] = {.lex_state = 98},
  [4165] = {.lex_state = 98},
  [4166] = {.lex_state = 98},
  [4167] = {.lex_state = 98},
  [4168] = {.lex_state = 0},
  [4169] = {.lex_state = 98},
  [4170] = {.lex_state = 98},
  [4171] = {.lex_state = 0},
  [4172] = {.lex_state = 0},
  [4173] = {.lex_state = 98},
  [4174] = {.lex_state = 0, .external_lex_state = 4},
  [4175] = {.lex_state = 98},
  [4176] = {.lex_state = 98},
  [4177] = {.lex_state = 98},
  [4178] = {.lex_state = 98},
  [4179] = {.lex_state = 98},
  [4180] = {.lex_state = 98},
  [4181] = {.lex_state = 0},
  [4182] = {.lex_state = 98},
  [4183] = {.lex_state = 98},
  [4184] = {.lex_state = 98},
  [4185] = {.lex_state = 0},
  [4186] = {.lex_state = 0},
  [4187] = {.lex_state = 98},
  [4188] = {.lex_state = 98},
  [4189] = {.lex_state = 98},
  [4190] = {.lex_state = 98},
  [4191] = {.lex_state = 98},
  [4192] = {.lex_state = 98},
  [4193] = {.lex_state = 98},
  [4194] = {.lex_state = 98},
  [4195] = {.lex_state = 98},
  [4196] = {.lex_state = 98},
  [4197] = {.lex_state = 98},
  [4198] = {.lex_state = 98},
  [4199] = {.lex_state = 0},
  [4200] = {.lex_state = 98},
  [4201] = {.lex_state = 98},
  [4202] = {.lex_state = 0},
  [4203] = {.lex_state = 98},
  [4204] = {.lex_state = 0},
  [4205] = {.lex_state = 98},
  [4206] = {.lex_state = 0},
  [4207] = {.lex_state = 98},
  [4208] = {.lex_state = 0},
  [4209] = {.lex_state = 98},
  [4210] = {.lex_state = 98},
  [4211] = {.lex_state = 1},
  [4212] = {.lex_state = 0},
  [4213] = {.lex_state = 98},
  [4214] = {.lex_state = 0},
  [4215] = {.lex_state = 98},
  [4216] = {.lex_state = 0},
  [4217] = {.lex_state = 98},
  [4218] = {.lex_state = 98},
  [4219] = {.lex_state = 98},
  [4220] = {.lex_state = 98},
  [4221] = {.lex_state = 98},
  [4222] = {.lex_state = 0},
  [4223] = {.lex_state = 98},
  [4224] = {.lex_state = 0},
  [4225] = {.lex_state = 98},
  [4226] = {.lex_state = 98},
  [4227] = {.lex_state = 0},
  [4228] = {.lex_state = 0},
  [4229] = {.lex_state = 98},
  [4230] = {.lex_state = 0},
  [4231] = {.lex_state = 98},
  [4232] = {.lex_state = 0},
  [4233] = {.lex_state = 0},
  [4234] = {.lex_state = 98},
  [4235] = {.lex_state = 98},
  [4236] = {.lex_state = 98},
  [4237] = {.lex_state = 98},
  [4238] = {.lex_state = 98},
  [4239] = {.lex_state = 98},
  [4240] = {.lex_state = 0},
  [4241] = {.lex_state = 0},
  [4242] = {.lex_state = 98},
  [4243] = {.lex_state = 98},
  [4244] = {.lex_state = 0},
  [4245] = {.lex_state = 0},
  [4246] = {.lex_state = 0},
  [4247] = {.lex_state = 98},
  [4248] = {.lex_state = 98},
  [4249] = {.lex_state = 98},
  [4250] = {.lex_state = 98},
  [4251] = {.lex_state = 98},
  [4252] = {.lex_state = 98},
  [4253] = {.lex_state = 98},
  [4254] = {.lex_state = 98},
  [4255] = {.lex_state = 98},
  [4256] = {.lex_state = 98},
  [4257] = {.lex_state = 98},
  [4258] = {.lex_state = 0},
  [4259] = {.lex_state = 98},
  [4260] = {.lex_state = 98},
  [4261] = {.lex_state = 98},
  [4262] = {.lex_state = 0},
  [4263] = {.lex_state = 0},
  [4264] = {.lex_state = 98},
  [4265] = {.lex_state = 98},
  [4266] = {.lex_state = 98},
  [4267] = {.lex_state = 98},
  [4268] = {.lex_state = 98},
  [4269] = {.lex_state = 98},
  [4270] = {.lex_state = 98},
  [4271] = {.lex_state = 0},
  [4272] = {.lex_state = 98},
  [4273] = {.lex_state = 98},
  [4274] = {.lex_state = 98},
  [4275] = {.lex_state = 98},
  [4276] = {.lex_state = 98},
  [4277] = {.lex_state = 98},
  [4278] = {.lex_state = 98},
  [4279] = {.lex_state = 98},
  [4280] = {.lex_state = 98},
  [4281] = {.lex_state = 98},
  [4282] = {.lex_state = 98},
  [4283] = {.lex_state = 98},
  [4284] = {.lex_state = 0},
  [4285] = {.lex_state = 98},
  [4286] = {.lex_state = 0},
  [4287] = {.lex_state = 98},
  [4288] = {.lex_state = 98},
  [4289] = {.lex_state = 98},
  [4290] = {.lex_state = 98},
  [4291] = {.lex_state = 98},
  [4292] = {.lex_state = 0},
  [4293] = {.lex_state = 0},
  [4294] = {.lex_state = 98},
  [4295] = {.lex_state = 98},
  [4296] = {.lex_state = 0},
  [4297] = {.lex_state = 98},
  [4298] = {.lex_state = 98},
  [4299] = {.lex_state = 98},
  [4300] = {.lex_state = 98},
  [4301] = {.lex_state = 98},
  [4302] = {.lex_state = 98},
  [4303] = {.lex_state = 98},
  [4304] = {.lex_state = 98},
  [4305] = {.lex_state = 98},
  [4306] = {.lex_state = 98},
  [4307] = {.lex_state = 0},
  [4308] = {.lex_state = 98},
  [4309] = {.lex_state = 0},
  [4310] = {.lex_state = 98},
  [4311] = {.lex_state = 98},
  [4312] = {.lex_state = 98},
  [4313] = {.lex_state = 98},
  [4314] = {.lex_state = 98},
  [4315] = {.lex_state = 0},
  [4316] = {.lex_state = 98},
  [4317] = {.lex_state = 98},
  [4318] = {.lex_state = 98},
  [4319] = {.lex_state = 0},
  [4320] = {.lex_state = 98},
  [4321] = {.lex_state = 98},
  [4322] = {.lex_state = 98},
  [4323] = {.lex_state = 0},
  [4324] = {.lex_state = 0, .external_lex_state = 4},
  [4325] = {.lex_state = 98},
  [4326] = {.lex_state = 0},
  [4327] = {.lex_state = 98},
  [4328] = {.lex_state = 0},
  [4329] = {.lex_state = 0},
  [4330] = {.lex_state = 98},
  [4331] = {.lex_state = 0},
  [4332] = {.lex_state = 98},
  [4333] = {.lex_state = 0},
  [4334] = {.lex_state = 0},
  [4335] = {.lex_state = 98},
  [4336] = {.lex_state = 0},
  [4337] = {.lex_state = 98},
  [4338] = {.lex_state = 0},
  [4339] = {.lex_state = 0},
  [4340] = {.lex_state = 0, .external_lex_state = 4},
  [4341] = {.lex_state = 0},
  [4342] = {.lex_state = 98},
  [4343] = {.lex_state = 0},
  [4344] = {.lex_state = 98},
  [4345] = {.lex_state = 98},
  [4346] = {.lex_state = 98},
  [4347] = {.lex_state = 0},
  [4348] = {.lex_state = 98},
  [4349] = {.lex_state = 98},
  [4350] = {.lex_state = 98},
  [4351] = {.lex_state = 0},
  [4352] = {.lex_state = 98},
  [4353] = {.lex_state = 0},
  [4354] = {.lex_state = 98},
  [4355] = {.lex_state = 98},
  [4356] = {.lex_state = 0},
  [4357] = {.lex_state = 98},
  [4358] = {.lex_state = 98},
  [4359] = {.lex_state = 98},
  [4360] = {.lex_state = 0},
  [4361] = {.lex_state = 98},
  [4362] = {.lex_state = 98},
  [4363] = {.lex_state = 98},
  [4364] = {.lex_state = 98},
  [4365] = {.lex_state = 0},
  [4366] = {.lex_state = 98},
  [4367] = {.lex_state = 0},
  [4368] = {.lex_state = 0},
  [4369] = {.lex_state = 0},
  [4370] = {.lex_state = 98},
  [4371] = {.lex_state = 0},
  [4372] = {.lex_state = 98},
  [4373] = {.lex_state = 98},
  [4374] = {.lex_state = 98},
  [4375] = {.lex_state = 98},
  [4376] = {.lex_state = 0},
  [4377] = {.lex_state = 0},
  [4378] = {.lex_state = 98},
  [4379] = {.lex_state = 0},
  [4380] = {.lex_state = 98},
  [4381] = {.lex_state = 98},
  [4382] = {.lex_state = 0},
  [4383] = {.lex_state = 0},
  [4384] = {.lex_state = 0},
  [4385] = {.lex_state = 0},
  [4386] = {.lex_state = 98},
  [4387] = {.lex_state = 0},
  [4388] = {.lex_state = 98},
  [4389] = {.lex_state = 98},
  [4390] = {.lex_state = 98},
  [4391] = {.lex_state = 98},
  [4392] = {.lex_state = 0},
  [4393] = {.lex_state = 0},
  [4394] = {.lex_state = 0},
  [4395] = {.lex_state = 98},
  [4396] = {.lex_state = 98},
  [4397] = {.lex_state = 98},
  [4398] = {.lex_state = 0},
  [4399] = {.lex_state = 98},
  [4400] = {.lex_state = 98},
  [4401] = {.lex_state = 98},
  [4402] = {.lex_state = 0},
  [4403] = {.lex_state = 98},
  [4404] = {.lex_state = 98},
  [4405] = {.lex_state = 98},
  [4406] = {.lex_state = 98},
  [4407] = {.lex_state = 0},
  [4408] = {.lex_state = 98},
  [4409] = {.lex_state = 0},
  [4410] = {.lex_state = 98},
  [4411] = {.lex_state = 98},
  [4412] = {.lex_state = 98},
  [4413] = {.lex_state = 0},
  [4414] = {.lex_state = 98},
  [4415] = {.lex_state = 0},
  [4416] = {.lex_state = 98},
  [4417] = {.lex_state = 98},
  [4418] = {.lex_state = 0},
  [4419] = {.lex_state = 98},
  [4420] = {.lex_state = 98},
  [4421] = {.lex_state = 98},
  [4422] = {.lex_state = 98},
  [4423] = {.lex_state = 98},
  [4424] = {.lex_state = 98},
  [4425] = {.lex_state = 98},
  [4426] = {.lex_state = 98},
  [4427] = {.lex_state = 98},
  [4428] = {.lex_state = 98},
  [4429] = {.lex_state = 98},
  [4430] = {.lex_state = 98},
  [4431] = {.lex_state = 98},
  [4432] = {.lex_state = 98},
  [4433] = {.lex_state = 98},
  [4434] = {.lex_state = 98},
  [4435] = {.lex_state = 98},
  [4436] = {.lex_state = 0, .external_lex_state = 4},
  [4437] = {.lex_state = 0, .external_lex_state = 4},
  [4438] = {.lex_state = 0, .external_lex_state = 4},
  [4439] = {.lex_state = 0, .external_lex_state = 4},
  [4440] = {.lex_state = 98},
  [4441] = {.lex_state = 0},
  [4442] = {.lex_state = 98},
  [4443] = {.lex_state = 98},
  [4444] = {.lex_state = 0},
  [4445] = {.lex_state = 98},
  [4446] = {.lex_state = 98},
  [4447] = {.lex_state = 98},
  [4448] = {.lex_state = 0},
  [4449] = {.lex_state = 0},
  [4450] = {.lex_state = 98},
  [4451] = {.lex_state = 98},
  [4452] = {.lex_state = 98},
  [4453] = {.lex_state = 98},
  [4454] = {.lex_state = 0},
  [4455] = {.lex_state = 98},
  [4456] = {.lex_state = 98},
  [4457] = {.lex_state = 98},
  [4458] = {.lex_state = 98},
  [4459] = {.lex_state = 98},
  [4460] = {.lex_state = 98},
  [4461] = {.lex_state = 0},
  [4462] = {.lex_state = 98},
  [4463] = {.lex_state = 98},
  [4464] = {.lex_state = 0},
  [4465] = {.lex_state = 98},
  [4466] = {.lex_state = 0},
  [4467] = {.lex_state = 0},
  [4468] = {.lex_state = 0},
  [4469] = {.lex_state = 98},
  [4470] = {.lex_state = 98},
  [4471] = {.lex_state = 98},
  [4472] = {.lex_state = 98},
  [4473] = {.lex_state = 0},
  [4474] = {.lex_state = 0},
  [4475] = {.lex_state = 98},
  [4476] = {.lex_state = 98},
  [4477] = {.lex_state = 0},
  [4478] = {.lex_state = 98},
  [4479] = {.lex_state = 0},
  [4480] = {.lex_state = 98},
  [4481] = {.lex_state = 0},
  [4482] = {.lex_state = 0},
  [4483] = {.lex_state = 0},
  [4484] = {.lex_state = 98},
  [4485] = {.lex_state = 98},
  [4486] = {.lex_state = 0},
  [4487] = {.lex_state = 98},
  [4488] = {.lex_state = 98},
  [4489] = {.lex_state = 0},
  [4490] = {.lex_state = 98},
  [4491] = {.lex_state = 98},
  [4492] = {.lex_state = 98},
  [4493] = {.lex_state = 0},
  [4494] = {.lex_state = 98},
  [4495] = {.lex_state = 0},
  [4496] = {.lex_state = 98},
  [4497] = {.lex_state = 98},
  [4498] = {.lex_state = 98},
  [4499] = {.lex_state = 0},
  [4500] = {.lex_state = 98},
  [4501] = {.lex_state = 0, .external_lex_state = 4},
  [4502] = {.lex_state = 98},
  [4503] = {.lex_state = 0, .external_lex_state = 4},
  [4504] = {.lex_state = 0},
  [4505] = {.lex_state = 0},
  [4506] = {.lex_state = 0},
  [4507] = {.lex_state = 98},
  [4508] = {.lex_state = 0},
  [4509] = {.lex_state = 98},
  [4510] = {.lex_state = 0},
  [4511] = {.lex_state = 98},
  [4512] = {.lex_state = 0},
  [4513] = {.lex_state = 0},
  [4514] = {.lex_state = 98},
  [4515] = {.lex_state = 0},
  [4516] = {.lex_state = 98},
  [4517] = {.lex_state = 0},
  [4518] = {.lex_state = 0},
  [4519] = {.lex_state = 0},
  [4520] = {.lex_state = 0},
  [4521] = {.lex_state = 0},
  [4522] = {.lex_state = 0},
  [4523] = {.lex_state = 0},
  [4524] = {.lex_state = 0},
  [4525] = {.lex_state = 98},
  [4526] = {.lex_state = 98},
  [4527] = {.lex_state = 98},
  [4528] = {.lex_state = 0},
  [4529] = {.lex_state = 98},
  [4530] = {.lex_state = 0},
  [4531] = {.lex_state = 0},
  [4532] = {.lex_state = 0},
  [4533] = {.lex_state = 0},
  [4534] = {.lex_state = 2},
  [4535] = {.lex_state = 0},
  [4536] = {.lex_state = 0},
  [4537] = {.lex_state = 0},
  [4538] = {.lex_state = 98},
  [4539] = {.lex_state = 0},
  [4540] = {.lex_state = 4},
  [4541] = {.lex_state = 100},
  [4542] = {.lex_state = 0},
  [4543] = {.lex_state = 0},
  [4544] = {.lex_state = 0},
  [4545] = {.lex_state = 0},
  [4546] = {.lex_state = 0},
  [4547] = {.lex_state = 0},
  [4548] = {.lex_state = 0},
  [4549] = {.lex_state = 0},
  [4550] = {.lex_state = 0},
  [4551] = {.lex_state = 0},
  [4552] = {.lex_state = 0},
  [4553] = {.lex_state = 0},
  [4554] = {.lex_state = 0},
  [4555] = {.lex_state = 0},
  [4556] = {.lex_state = 0},
  [4557] = {.lex_state = 0},
  [4558] = {.lex_state = 0},
  [4559] = {.lex_state = 4},
  [4560] = {.lex_state = 0},
  [4561] = {.lex_state = 98},
  [4562] = {.lex_state = 2},
  [4563] = {.lex_state = 0},
  [4564] = {.lex_state = 0},
  [4565] = {.lex_state = 0},
  [4566] = {.lex_state = 0},
  [4567] = {.lex_state = 0},
  [4568] = {.lex_state = 0},
  [4569] = {.lex_state = 0},
  [4570] = {.lex_state = 0},
  [4571] = {.lex_state = 0},
  [4572] = {.lex_state = 0},
  [4573] = {.lex_state = 0},
  [4574] = {.lex_state = 0},
  [4575] = {.lex_state = 0},
  [4576] = {.lex_state = 0},
  [4577] = {.lex_state = 0},
  [4578] = {.lex_state = 0},
  [4579] = {.lex_state = 0},
  [4580] = {.lex_state = 98},
  [4581] = {.lex_state = 98},
  [4582] = {.lex_state = 98},
  [4583] = {.lex_state = 0},
  [4584] = {.lex_state = 98},
  [4585] = {.lex_state = 98},
  [4586] = {.lex_state = 0},
  [4587] = {.lex_state = 0},
  [4588] = {.lex_state = 98},
  [4589] = {.lex_state = 98},
  [4590] = {.lex_state = 0},
  [4591] = {.lex_state = 0},
  [4592] = {.lex_state = 98},
  [4593] = {.lex_state = 0},
  [4594] = {.lex_state = 0},
  [4595] = {.lex_state = 0},
  [4596] = {.lex_state = 98},
  [4597] = {.lex_state = 0},
  [4598] = {.lex_state = 0},
  [4599] = {.lex_state = 0},
  [4600] = {.lex_state = 2},
  [4601] = {.lex_state = 0},
  [4602] = {.lex_state = 0},
  [4603] = {.lex_state = 4},
  [4604] = {.lex_state = 0},
  [4605] = {.lex_state = 0},
  [4606] = {.lex_state = 0},
  [4607] = {.lex_state = 0},
  [4608] = {.lex_state = 98},
  [4609] = {.lex_state = 0},
  [4610] = {.lex_state = 0},
  [4611] = {.lex_state = 0},
  [4612] = {.lex_state = 98},
  [4613] = {.lex_state = 0},
  [4614] = {.lex_state = 0},
  [4615] = {.lex_state = 0},
  [4616] = {.lex_state = 2},
  [4617] = {.lex_state = 0},
  [4618] = {.lex_state = 0},
  [4619] = {.lex_state = 4},
  [4620] = {.lex_state = 0},
  [4621] = {.lex_state = 0},
  [4622] = {.lex_state = 0},
  [4623] = {.lex_state = 0},
  [4624] = {.lex_state = 0},
  [4625] = {.lex_state = 0},
  [4626] = {.lex_state = 0},
  [4627] = {.lex_state = 0},
  [4628] = {.lex_state = 0},
  [4629] = {.lex_state = 0},
  [4630] = {.lex_state = 98},
  [4631] = {.lex_state = 2},
  [4632] = {.lex_state = 0},
  [4633] = {.lex_state = 4},
  [4634] = {.lex_state = 0},
  [4635] = {.lex_state = 0},
  [4636] = {.lex_state = 0},
  [4637] = {.lex_state = 98},
  [4638] = {.lex_state = 98},
  [4639] = {.lex_state = 4},
  [4640] = {.lex_state = 4},
  [4641] = {.lex_state = 98},
  [4642] = {.lex_state = 98},
  [4643] = {.lex_state = 0},
  [4644] = {.lex_state = 0},
  [4645] = {.lex_state = 0},
  [4646] = {.lex_state = 0},
  [4647] = {.lex_state = 0},
  [4648] = {.lex_state = 98},
  [4649] = {.lex_state = 0},
  [4650] = {.lex_state = 0},
  [4651] = {.lex_state = 0},
  [4652] = {.lex_state = 0},
  [4653] = {.lex_state = 98},
  [4654] = {.lex_state = 0},
  [4655] = {.lex_state = 0},
  [4656] = {.lex_state = 0},
  [4657] = {.lex_state = 0},
  [4658] = {.lex_state = 98},
  [4659] = {.lex_state = 0},
  [4660] = {.lex_state = 0},
  [4661] = {.lex_state = 0},
  [4662] = {.lex_state = 0},
  [4663] = {.lex_state = 0},
  [4664] = {.lex_state = 0},
  [4665] = {.lex_state = 0},
  [4666] = {.lex_state = 0},
  [4667] = {.lex_state = 0},
  [4668] = {.lex_state = 0},
  [4669] = {.lex_state = 0},
  [4670] = {.lex_state = 0},
  [4671] = {.lex_state = 0},
  [4672] = {.lex_state = 98},
  [4673] = {.lex_state = 98},
  [4674] = {.lex_state = 0},
  [4675] = {.lex_state = 0},
  [4676] = {.lex_state = 0},
  [4677] = {.lex_state = 0},
  [4678] = {.lex_state = 0},
  [4679] = {.lex_state = 0},
  [4680] = {.lex_state = 0},
  [4681] = {.lex_state = 98},
  [4682] = {.lex_state = 0},
  [4683] = {.lex_state = 0},
  [4684] = {.lex_state = 0},
  [4685] = {.lex_state = 0},
  [4686] = {.lex_state = 0},
  [4687] = {.lex_state = 0},
  [4688] = {.lex_state = 98},
  [4689] = {.lex_state = 0},
  [4690] = {.lex_state = 98},
  [4691] = {.lex_state = 0},
  [4692] = {.lex_state = 0},
  [4693] = {.lex_state = 0},
  [4694] = {.lex_state = 0},
  [4695] = {.lex_state = 0},
  [4696] = {.lex_state = 100},
  [4697] = {.lex_state = 0},
  [4698] = {.lex_state = 0},
  [4699] = {.lex_state = 0},
  [4700] = {.lex_state = 100},
  [4701] = {.lex_state = 0},
  [4702] = {.lex_state = 98},
  [4703] = {.lex_state = 0},
  [4704] = {.lex_state = 0},
  [4705] = {.lex_state = 0},
  [4706] = {.lex_state = 0},
  [4707] = {.lex_state = 0},
  [4708] = {.lex_state = 4},
  [4709] = {.lex_state = 0},
  [4710] = {.lex_state = 0},
  [4711] = {.lex_state = 0},
  [4712] = {.lex_state = 0},
  [4713] = {.lex_state = 0},
  [4714] = {.lex_state = 98},
  [4715] = {.lex_state = 0},
  [4716] = {.lex_state = 0},
  [4717] = {.lex_state = 98},
  [4718] = {.lex_state = 0},
  [4719] = {.lex_state = 98},
  [4720] = {.lex_state = 2},
  [4721] = {.lex_state = 0},
  [4722] = {.lex_state = 0},
  [4723] = {.lex_state = 0},
  [4724] = {.lex_state = 98},
  [4725] = {.lex_state = 98},
  [4726] = {.lex_state = 98},
  [4727] = {.lex_state = 0},
  [4728] = {.lex_state = 100},
  [4729] = {.lex_state = 0},
  [4730] = {.lex_state = 0},
  [4731] = {.lex_state = 0},
  [4732] = {.lex_state = 0},
  [4733] = {.lex_state = 0},
  [4734] = {.lex_state = 0},
  [4735] = {.lex_state = 0},
  [4736] = {.lex_state = 0},
  [4737] = {.lex_state = 98},
  [4738] = {.lex_state = 0},
  [4739] = {.lex_state = 0},
  [4740] = {.lex_state = 0},
  [4741] = {.lex_state = 98},
  [4742] = {.lex_state = 0},
  [4743] = {.lex_state = 98},
  [4744] = {.lex_state = 0},
  [4745] = {.lex_state = 0},
  [4746] = {.lex_state = 0},
  [4747] = {.lex_state = 0},
  [4748] = {.lex_state = 0},
  [4749] = {.lex_state = 0},
  [4750] = {.lex_state = 0},
  [4751] = {.lex_state = 0},
  [4752] = {.lex_state = 0},
  [4753] = {.lex_state = 98},
  [4754] = {.lex_state = 0},
  [4755] = {.lex_state = 98},
  [4756] = {.lex_state = 98},
  [4757] = {.lex_state = 0},
  [4758] = {.lex_state = 0},
  [4759] = {.lex_state = 0},
  [4760] = {.lex_state = 0},
  [4761] = {.lex_state = 0},
  [4762] = {.lex_state = 98},
  [4763] = {.lex_state = 0},
  [4764] = {.lex_state = 0},
  [4765] = {.lex_state = 0},
  [4766] = {.lex_state = 98},
  [4767] = {.lex_state = 0},
  [4768] = {.lex_state = 0},
  [4769] = {.lex_state = 98},
  [4770] = {.lex_state = 4},
  [4771] = {.lex_state = 0},
  [4772] = {.lex_state = 0},
  [4773] = {.lex_state = 0},
  [4774] = {.lex_state = 0},
  [4775] = {.lex_state = 0},
  [4776] = {.lex_state = 0},
  [4777] = {.lex_state = 98},
  [4778] = {.lex_state = 98},
  [4779] = {.lex_state = 0},
  [4780] = {.lex_state = 0},
  [4781] = {.lex_state = 0},
  [4782] = {.lex_state = 0},
  [4783] = {.lex_state = 0},
  [4784] = {.lex_state = 0},
  [4785] = {.lex_state = 0},
  [4786] = {.lex_state = 0},
  [4787] = {.lex_state = 2},
  [4788] = {.lex_state = 0},
  [4789] = {.lex_state = 0},
  [4790] = {.lex_state = 98},
  [4791] = {.lex_state = 0},
  [4792] = {.lex_state = 100},
  [4793] = {.lex_state = 98},
  [4794] = {.lex_state = 0},
  [4795] = {.lex_state = 0},
  [4796] = {.lex_state = 0},
  [4797] = {.lex_state = 0},
  [4798] = {.lex_state = 0},
  [4799] = {.lex_state = 0},
  [4800] = {.lex_state = 0},
  [4801] = {.lex_state = 0},
  [4802] = {.lex_state = 0},
  [4803] = {.lex_state = 98},
  [4804] = {.lex_state = 98},
  [4805] = {.lex_state = 98},
  [4806] = {.lex_state = 0},
  [4807] = {.lex_state = 0},
  [4808] = {.lex_state = 0},
  [4809] = {.lex_state = 98},
  [4810] = {.lex_state = 0},
  [4811] = {.lex_state = 0},
  [4812] = {.lex_state = 0},
  [4813] = {.lex_state = 98},
  [4814] = {.lex_state = 0},
  [4815] = {.lex_state = 0},
  [4816] = {.lex_state = 0},
  [4817] = {.lex_state = 0},
  [4818] = {.lex_state = 0},
  [4819] = {.lex_state = 0},
  [4820] = {.lex_state = 98},
  [4821] = {.lex_state = 98},
  [4822] = {.lex_state = 0},
  [4823] = {.lex_state = 98},
  [4824] = {.lex_state = 100},
  [4825] = {.lex_state = 0},
  [4826] = {.lex_state = 98},
  [4827] = {.lex_state = 0},
  [4828] = {.lex_state = 98},
  [4829] = {.lex_state = 0},
  [4830] = {.lex_state = 0},
  [4831] = {.lex_state = 0},
  [4832] = {.lex_state = 0},
  [4833] = {.lex_state = 0},
  [4834] = {.lex_state = 0},
  [4835] = {.lex_state = 0},
  [4836] = {.lex_state = 98},
  [4837] = {.lex_state = 0},
  [4838] = {.lex_state = 98},
  [4839] = {.lex_state = 98},
  [4840] = {.lex_state = 0},
  [4841] = {.lex_state = 98},
  [4842] = {.lex_state = 98},
  [4843] = {.lex_state = 98},
  [4844] = {.lex_state = 0},
  [4845] = {.lex_state = 98},
  [4846] = {.lex_state = 98},
  [4847] = {.lex_state = 98},
  [4848] = {.lex_state = 98},
  [4849] = {.lex_state = 0},
  [4850] = {.lex_state = 0},
  [4851] = {.lex_state = 98},
  [4852] = {.lex_state = 0},
  [4853] = {.lex_state = 98},
  [4854] = {.lex_state = 98},
  [4855] = {.lex_state = 98},
  [4856] = {.lex_state = 0},
  [4857] = {.lex_state = 98},
  [4858] = {.lex_state = 0},
  [4859] = {.lex_state = 0},
  [4860] = {.lex_state = 0},
  [4861] = {.lex_state = 0},
  [4862] = {.lex_state = 0},
  [4863] = {.lex_state = 0},
  [4864] = {.lex_state = 0},
  [4865] = {.lex_state = 98},
  [4866] = {.lex_state = 0},
  [4867] = {.lex_state = 0},
  [4868] = {.lex_state = 98},
  [4869] = {.lex_state = 98},
  [4870] = {.lex_state = 0},
  [4871] = {.lex_state = 0},
  [4872] = {.lex_state = 0},
  [4873] = {.lex_state = 0},
  [4874] = {.lex_state = 0},
  [4875] = {.lex_state = 0},
  [4876] = {.lex_state = 98},
  [4877] = {.lex_state = 98},
  [4878] = {.lex_state = 0},
  [4879] = {.lex_state = 98},
  [4880] = {.lex_state = 0},
  [4881] = {.lex_state = 0},
  [4882] = {.lex_state = 98},
  [4883] = {.lex_state = 0},
  [4884] = {.lex_state = 0},
  [4885] = {.lex_state = 98},
  [4886] = {.lex_state = 98},
  [4887] = {.lex_state = 100},
  [4888] = {.lex_state = 0},
  [4889] = {.lex_state = 0},
  [4890] = {.lex_state = 98},
  [4891] = {.lex_state = 0},
  [4892] = {.lex_state = 0},
  [4893] = {.lex_state = 98},
  [4894] = {.lex_state = 0},
  [4895] = {.lex_state = 0},
  [4896] = {.lex_state = 0},
  [4897] = {.lex_state = 0},
  [4898] = {.lex_state = 98},
  [4899] = {.lex_state = 0},
  [4900] = {.lex_state = 98},
  [4901] = {.lex_state = 98},
  [4902] = {.lex_state = 98},
  [4903] = {.lex_state = 0},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
  ts_external_token__ternary_qmark = 2,
  ts_external_token_PIPE_PIPE = 3,
  ts_external_token__function_signature_automatic_semicolon = 4,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
  [ts_external_token__ternary_qmark] = sym__ternary_qmark,
  [ts_external_token_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [ts_external_token__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
};

static const bool ts_external_scanner_states[7][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [2] = {
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [3] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [5] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [6] = {
    [ts_external_token__template_chars] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LTtemplate_GT] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_QMARK_DOT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_satisfies] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_DASH_QMARK_COLON] = ACTIONS(1),
    [anon_sym_asserts] = ACTIONS(1),
    [anon_sym_infer] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_unknown] = ACTIONS(1),
    [anon_sym_never] = ACTIONS(1),
    [anon_sym_object] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [anon_sym_component] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_instance] = ACTIONS(1),
    [anon_sym_constructor] = ACTIONS(1),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1),
    [anon_sym_prop] = ACTIONS(1),
    [anon_sym_id] = ACTIONS(1),
    [anon_sym_event] = ACTIONS(1),
    [anon_sym_fn] = ACTIONS(1),
    [anon_sym_on] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
    [sym__ternary_qmark] = ACTIONS(1),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(4899),
    [sym_import_statement] = STATE(2802),
    [sym_decorator] = STATE(1469),
    [sym_js_import_statement] = STATE(2802),
    [sym_component_declaration] = STATE(2802),
    [sym_component_short_heritage] = STATE(3735),
    [sym_component_instance] = STATE(4130),
    [sym_component_instance_statement] = STATE(2802),
    [aux_sym_program_repeat1] = STATE(2802),
    [aux_sym_class_repeat1] = STATE(3337),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_hash_bang_line] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_AMP] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_component] = ACTIONS(15),
    [anon_sym_instance] = ACTIONS(17),
  },
  [2] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3137),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(2288),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3653),
    [sym_pattern] = STATE(3543),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3006),
    [sym_constructor_type] = STATE(3006),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3006),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_type_arguments] = STATE(435),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4227),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3006),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3006),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(32),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(36),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_EQ] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(48),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(54),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(67),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(81),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(92),
    [sym_number] = ACTIONS(94),
    [sym_this] = ACTIONS(96),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(100),
    [sym_false] = ACTIONS(100),
    [sym_null] = ACTIONS(100),
    [sym_undefined] = ACTIONS(102),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(104),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(106),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_override] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(108),
    [anon_sym_number] = ACTIONS(108),
    [anon_sym_boolean] = ACTIONS(108),
    [anon_sym_string] = ACTIONS(108),
    [anon_sym_symbol] = ACTIONS(108),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_component] = ACTIONS(120),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [3] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3137),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(2288),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3653),
    [sym_pattern] = STATE(3543),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3006),
    [sym_constructor_type] = STATE(3006),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3006),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_type_arguments] = STATE(435),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4227),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3006),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3006),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(32),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(36),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_EQ] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(48),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(54),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(67),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(81),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(92),
    [sym_number] = ACTIONS(94),
    [sym_this] = ACTIONS(96),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(100),
    [sym_false] = ACTIONS(100),
    [sym_null] = ACTIONS(100),
    [sym_undefined] = ACTIONS(102),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(104),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(106),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_override] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(108),
    [anon_sym_number] = ACTIONS(108),
    [anon_sym_boolean] = ACTIONS(108),
    [anon_sym_string] = ACTIONS(108),
    [anon_sym_symbol] = ACTIONS(108),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_component] = ACTIONS(120),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [4] = {
    [sym_export_statement] = STATE(32),
    [sym_declaration] = STATE(32),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(32),
    [sym_expression_statement] = STATE(32),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(32),
    [sym_if_statement] = STATE(32),
    [sym_switch_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_for_in_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_do_statement] = STATE(32),
    [sym_try_statement] = STATE(32),
    [sym_with_statement] = STATE(32),
    [sym_break_statement] = STATE(32),
    [sym_continue_statement] = STATE(32),
    [sym_debugger_statement] = STATE(32),
    [sym_return_statement] = STATE(32),
    [sym_throw_statement] = STATE(32),
    [sym_empty_statement] = STATE(32),
    [sym_labeled_statement] = STATE(32),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4524),
    [sym_object_assignment_pattern] = STATE(4014),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4524),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4524),
    [sym_spread_element] = STATE(4134),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2214),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_rest_pattern] = STATE(4014),
    [sym_method_definition] = STATE(4134),
    [sym_pair] = STATE(4134),
    [sym_pair_pattern] = STATE(4014),
    [sym__property_name] = STATE(3249),
    [sym_computed_property_name] = STATE(3249),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_accessibility_modifier] = STATE(2635),
    [sym_override_modifier] = STATE(2656),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(32),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(32),
    [aux_sym_object_repeat1] = STATE(4133),
    [aux_sym_object_pattern_repeat1] = STATE(4001),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(129),
    [anon_sym_export] = ACTIONS(131),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(139),
    [anon_sym_type] = ACTIONS(141),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(193),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(209),
    [sym_private_property_identifier] = ACTIONS(211),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(217),
    [anon_sym_readonly] = ACTIONS(219),
    [anon_sym_get] = ACTIONS(221),
    [anon_sym_set] = ACTIONS(221),
    [anon_sym_declare] = ACTIONS(223),
    [anon_sym_namespace] = ACTIONS(225),
    [anon_sym_public] = ACTIONS(227),
    [anon_sym_private] = ACTIONS(227),
    [anon_sym_protected] = ACTIONS(227),
    [anon_sym_override] = ACTIONS(229),
    [anon_sym_module] = ACTIONS(231),
    [anon_sym_any] = ACTIONS(233),
    [anon_sym_number] = ACTIONS(233),
    [anon_sym_boolean] = ACTIONS(233),
    [anon_sym_string] = ACTIONS(233),
    [anon_sym_symbol] = ACTIONS(233),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [5] = {
    [sym_export_statement] = STATE(35),
    [sym_declaration] = STATE(35),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(35),
    [sym_expression_statement] = STATE(35),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(35),
    [sym_if_statement] = STATE(35),
    [sym_switch_statement] = STATE(35),
    [sym_for_statement] = STATE(35),
    [sym_for_in_statement] = STATE(35),
    [sym_while_statement] = STATE(35),
    [sym_do_statement] = STATE(35),
    [sym_try_statement] = STATE(35),
    [sym_with_statement] = STATE(35),
    [sym_break_statement] = STATE(35),
    [sym_continue_statement] = STATE(35),
    [sym_debugger_statement] = STATE(35),
    [sym_return_statement] = STATE(35),
    [sym_throw_statement] = STATE(35),
    [sym_empty_statement] = STATE(35),
    [sym_labeled_statement] = STATE(35),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4524),
    [sym_object_assignment_pattern] = STATE(4014),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4524),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4524),
    [sym_spread_element] = STATE(4134),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2214),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_rest_pattern] = STATE(4014),
    [sym_method_definition] = STATE(4134),
    [sym_pair] = STATE(4134),
    [sym_pair_pattern] = STATE(4014),
    [sym__property_name] = STATE(3249),
    [sym_computed_property_name] = STATE(3249),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_accessibility_modifier] = STATE(2635),
    [sym_override_modifier] = STATE(2656),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(35),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(35),
    [aux_sym_object_repeat1] = STATE(4133),
    [aux_sym_object_pattern_repeat1] = STATE(4001),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(129),
    [anon_sym_export] = ACTIONS(131),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(243),
    [anon_sym_type] = ACTIONS(141),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(193),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(209),
    [sym_private_property_identifier] = ACTIONS(211),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(217),
    [anon_sym_readonly] = ACTIONS(219),
    [anon_sym_get] = ACTIONS(221),
    [anon_sym_set] = ACTIONS(221),
    [anon_sym_declare] = ACTIONS(223),
    [anon_sym_namespace] = ACTIONS(225),
    [anon_sym_public] = ACTIONS(227),
    [anon_sym_private] = ACTIONS(227),
    [anon_sym_protected] = ACTIONS(227),
    [anon_sym_override] = ACTIONS(229),
    [anon_sym_module] = ACTIONS(231),
    [anon_sym_any] = ACTIONS(233),
    [anon_sym_number] = ACTIONS(233),
    [anon_sym_boolean] = ACTIONS(233),
    [anon_sym_string] = ACTIONS(233),
    [anon_sym_symbol] = ACTIONS(233),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [6] = {
    [sym_export_statement] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(30),
    [sym_expression_statement] = STATE(30),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(30),
    [sym_if_statement] = STATE(30),
    [sym_switch_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_for_in_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_do_statement] = STATE(30),
    [sym_try_statement] = STATE(30),
    [sym_with_statement] = STATE(30),
    [sym_break_statement] = STATE(30),
    [sym_continue_statement] = STATE(30),
    [sym_debugger_statement] = STATE(30),
    [sym_return_statement] = STATE(30),
    [sym_throw_statement] = STATE(30),
    [sym_empty_statement] = STATE(30),
    [sym_labeled_statement] = STATE(30),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4524),
    [sym_object_assignment_pattern] = STATE(4014),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4524),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4524),
    [sym_spread_element] = STATE(4067),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2214),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_rest_pattern] = STATE(4014),
    [sym_method_definition] = STATE(4067),
    [sym_pair] = STATE(4067),
    [sym_pair_pattern] = STATE(4014),
    [sym__property_name] = STATE(3249),
    [sym_computed_property_name] = STATE(3249),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_accessibility_modifier] = STATE(2635),
    [sym_override_modifier] = STATE(2656),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(30),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(30),
    [aux_sym_object_repeat1] = STATE(4065),
    [aux_sym_object_pattern_repeat1] = STATE(4001),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(245),
    [anon_sym_export] = ACTIONS(247),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(249),
    [anon_sym_type] = ACTIONS(251),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(253),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(209),
    [sym_private_property_identifier] = ACTIONS(211),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(255),
    [anon_sym_readonly] = ACTIONS(257),
    [anon_sym_get] = ACTIONS(259),
    [anon_sym_set] = ACTIONS(259),
    [anon_sym_declare] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_public] = ACTIONS(265),
    [anon_sym_private] = ACTIONS(265),
    [anon_sym_protected] = ACTIONS(265),
    [anon_sym_override] = ACTIONS(267),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_any] = ACTIONS(271),
    [anon_sym_number] = ACTIONS(271),
    [anon_sym_boolean] = ACTIONS(271),
    [anon_sym_string] = ACTIONS(271),
    [anon_sym_symbol] = ACTIONS(271),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [7] = {
    [sym_export_statement] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_for_in_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_try_statement] = STATE(29),
    [sym_with_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_debugger_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_throw_statement] = STATE(29),
    [sym_empty_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4524),
    [sym_object_assignment_pattern] = STATE(4014),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4524),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4524),
    [sym_spread_element] = STATE(4006),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2214),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_rest_pattern] = STATE(4014),
    [sym_method_definition] = STATE(4006),
    [sym_pair] = STATE(4006),
    [sym_pair_pattern] = STATE(4014),
    [sym__property_name] = STATE(3249),
    [sym_computed_property_name] = STATE(3249),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_accessibility_modifier] = STATE(2635),
    [sym_override_modifier] = STATE(2656),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(29),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(29),
    [aux_sym_object_repeat1] = STATE(4005),
    [aux_sym_object_pattern_repeat1] = STATE(4001),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(275),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(277),
    [anon_sym_type] = ACTIONS(279),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(281),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(209),
    [sym_private_property_identifier] = ACTIONS(211),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(283),
    [anon_sym_readonly] = ACTIONS(285),
    [anon_sym_get] = ACTIONS(287),
    [anon_sym_set] = ACTIONS(287),
    [anon_sym_declare] = ACTIONS(289),
    [anon_sym_namespace] = ACTIONS(291),
    [anon_sym_public] = ACTIONS(293),
    [anon_sym_private] = ACTIONS(293),
    [anon_sym_protected] = ACTIONS(293),
    [anon_sym_override] = ACTIONS(295),
    [anon_sym_module] = ACTIONS(297),
    [anon_sym_any] = ACTIONS(299),
    [anon_sym_number] = ACTIONS(299),
    [anon_sym_boolean] = ACTIONS(299),
    [anon_sym_string] = ACTIONS(299),
    [anon_sym_symbol] = ACTIONS(299),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [8] = {
    [sym_export_statement] = STATE(32),
    [sym_declaration] = STATE(32),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(32),
    [sym_expression_statement] = STATE(32),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(32),
    [sym_if_statement] = STATE(32),
    [sym_switch_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_for_in_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_do_statement] = STATE(32),
    [sym_try_statement] = STATE(32),
    [sym_with_statement] = STATE(32),
    [sym_break_statement] = STATE(32),
    [sym_continue_statement] = STATE(32),
    [sym_debugger_statement] = STATE(32),
    [sym_return_statement] = STATE(32),
    [sym_throw_statement] = STATE(32),
    [sym_empty_statement] = STATE(32),
    [sym_labeled_statement] = STATE(32),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4524),
    [sym_object_assignment_pattern] = STATE(4014),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4524),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4524),
    [sym_spread_element] = STATE(4067),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2214),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_rest_pattern] = STATE(4014),
    [sym_method_definition] = STATE(4067),
    [sym_pair] = STATE(4067),
    [sym_pair_pattern] = STATE(4014),
    [sym__property_name] = STATE(3249),
    [sym_computed_property_name] = STATE(3249),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_accessibility_modifier] = STATE(2635),
    [sym_override_modifier] = STATE(2656),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(32),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(32),
    [aux_sym_object_repeat1] = STATE(4065),
    [aux_sym_object_pattern_repeat1] = STATE(4001),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(245),
    [anon_sym_export] = ACTIONS(247),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(301),
    [anon_sym_type] = ACTIONS(251),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(253),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(209),
    [sym_private_property_identifier] = ACTIONS(211),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(255),
    [anon_sym_readonly] = ACTIONS(257),
    [anon_sym_get] = ACTIONS(259),
    [anon_sym_set] = ACTIONS(259),
    [anon_sym_declare] = ACTIONS(261),
    [anon_sym_namespace] = ACTIONS(263),
    [anon_sym_public] = ACTIONS(265),
    [anon_sym_private] = ACTIONS(265),
    [anon_sym_protected] = ACTIONS(265),
    [anon_sym_override] = ACTIONS(267),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_any] = ACTIONS(271),
    [anon_sym_number] = ACTIONS(271),
    [anon_sym_boolean] = ACTIONS(271),
    [anon_sym_string] = ACTIONS(271),
    [anon_sym_symbol] = ACTIONS(271),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [9] = {
    [sym_export_statement] = STATE(28),
    [sym_declaration] = STATE(28),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(28),
    [sym_expression_statement] = STATE(28),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_for_in_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_debugger_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_throw_statement] = STATE(28),
    [sym_empty_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4524),
    [sym_object_assignment_pattern] = STATE(4014),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4524),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4524),
    [sym_spread_element] = STATE(4134),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2214),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_rest_pattern] = STATE(4014),
    [sym_method_definition] = STATE(4134),
    [sym_pair] = STATE(4134),
    [sym_pair_pattern] = STATE(4014),
    [sym__property_name] = STATE(3249),
    [sym_computed_property_name] = STATE(3249),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_accessibility_modifier] = STATE(2635),
    [sym_override_modifier] = STATE(2656),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(28),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(28),
    [aux_sym_object_repeat1] = STATE(4133),
    [aux_sym_object_pattern_repeat1] = STATE(4001),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(129),
    [anon_sym_export] = ACTIONS(131),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(303),
    [anon_sym_type] = ACTIONS(141),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(193),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(209),
    [sym_private_property_identifier] = ACTIONS(211),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(217),
    [anon_sym_readonly] = ACTIONS(219),
    [anon_sym_get] = ACTIONS(221),
    [anon_sym_set] = ACTIONS(221),
    [anon_sym_declare] = ACTIONS(223),
    [anon_sym_namespace] = ACTIONS(225),
    [anon_sym_public] = ACTIONS(227),
    [anon_sym_private] = ACTIONS(227),
    [anon_sym_protected] = ACTIONS(227),
    [anon_sym_override] = ACTIONS(229),
    [anon_sym_module] = ACTIONS(231),
    [anon_sym_any] = ACTIONS(233),
    [anon_sym_number] = ACTIONS(233),
    [anon_sym_boolean] = ACTIONS(233),
    [anon_sym_string] = ACTIONS(233),
    [anon_sym_symbol] = ACTIONS(233),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [10] = {
    [sym_export_statement] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_for_in_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_try_statement] = STATE(29),
    [sym_with_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_debugger_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_throw_statement] = STATE(29),
    [sym_empty_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4524),
    [sym_object_assignment_pattern] = STATE(4014),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4524),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4524),
    [sym_spread_element] = STATE(4006),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2214),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_rest_pattern] = STATE(4014),
    [sym_method_definition] = STATE(4006),
    [sym_pair] = STATE(4006),
    [sym_pair_pattern] = STATE(4014),
    [sym__property_name] = STATE(3249),
    [sym_computed_property_name] = STATE(3249),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_accessibility_modifier] = STATE(2635),
    [sym_override_modifier] = STATE(2656),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(29),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(29),
    [aux_sym_object_repeat1] = STATE(4005),
    [aux_sym_object_pattern_repeat1] = STATE(4001),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(305),
    [anon_sym_export] = ACTIONS(307),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(277),
    [anon_sym_type] = ACTIONS(309),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(311),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(209),
    [sym_private_property_identifier] = ACTIONS(211),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(313),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_get] = ACTIONS(317),
    [anon_sym_set] = ACTIONS(317),
    [anon_sym_declare] = ACTIONS(319),
    [anon_sym_namespace] = ACTIONS(321),
    [anon_sym_public] = ACTIONS(323),
    [anon_sym_private] = ACTIONS(323),
    [anon_sym_protected] = ACTIONS(323),
    [anon_sym_override] = ACTIONS(325),
    [anon_sym_module] = ACTIONS(327),
    [anon_sym_any] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(329),
    [anon_sym_boolean] = ACTIONS(329),
    [anon_sym_string] = ACTIONS(329),
    [anon_sym_symbol] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [11] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(11),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(11),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(331),
    [anon_sym_export] = ACTIONS(334),
    [anon_sym_LBRACE] = ACTIONS(337),
    [anon_sym_RBRACE] = ACTIONS(340),
    [anon_sym_type] = ACTIONS(342),
    [anon_sym_typeof] = ACTIONS(345),
    [anon_sym_import] = ACTIONS(348),
    [anon_sym_var] = ACTIONS(351),
    [anon_sym_let] = ACTIONS(354),
    [anon_sym_const] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(360),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_switch] = ACTIONS(366),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_LPAREN] = ACTIONS(372),
    [anon_sym_await] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(378),
    [anon_sym_do] = ACTIONS(381),
    [anon_sym_try] = ACTIONS(384),
    [anon_sym_with] = ACTIONS(387),
    [anon_sym_break] = ACTIONS(390),
    [anon_sym_continue] = ACTIONS(393),
    [anon_sym_debugger] = ACTIONS(396),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_throw] = ACTIONS(402),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_case] = ACTIONS(408),
    [anon_sym_default] = ACTIONS(408),
    [anon_sym_yield] = ACTIONS(410),
    [anon_sym_LBRACK] = ACTIONS(413),
    [anon_sym_LTtemplate_GT] = ACTIONS(416),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(422),
    [anon_sym_class] = ACTIONS(425),
    [anon_sym_async] = ACTIONS(428),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_AMP] = ACTIONS(437),
    [anon_sym_PLUS] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(360),
    [anon_sym_void] = ACTIONS(345),
    [anon_sym_delete] = ACTIONS(345),
    [anon_sym_PLUS_PLUS] = ACTIONS(440),
    [anon_sym_DASH_DASH] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(449),
    [sym_number] = ACTIONS(452),
    [sym_this] = ACTIONS(455),
    [sym_super] = ACTIONS(455),
    [sym_true] = ACTIONS(455),
    [sym_false] = ACTIONS(455),
    [sym_null] = ACTIONS(455),
    [sym_undefined] = ACTIONS(458),
    [anon_sym_AT] = ACTIONS(461),
    [anon_sym_static] = ACTIONS(464),
    [anon_sym_readonly] = ACTIONS(464),
    [anon_sym_get] = ACTIONS(464),
    [anon_sym_set] = ACTIONS(464),
    [anon_sym_declare] = ACTIONS(467),
    [anon_sym_namespace] = ACTIONS(470),
    [anon_sym_public] = ACTIONS(464),
    [anon_sym_private] = ACTIONS(464),
    [anon_sym_protected] = ACTIONS(464),
    [anon_sym_override] = ACTIONS(464),
    [anon_sym_module] = ACTIONS(473),
    [anon_sym_any] = ACTIONS(464),
    [anon_sym_number] = ACTIONS(464),
    [anon_sym_boolean] = ACTIONS(464),
    [anon_sym_string] = ACTIONS(464),
    [anon_sym_symbol] = ACTIONS(464),
    [anon_sym_abstract] = ACTIONS(476),
    [anon_sym_interface] = ACTIONS(479),
    [anon_sym_enum] = ACTIONS(482),
    [anon_sym_component] = ACTIONS(485),
  },
  [12] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(11),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(11),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(492),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_case] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(496),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [13] = {
    [sym_export_statement] = STATE(14),
    [sym_declaration] = STATE(14),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(14),
    [sym_expression_statement] = STATE(14),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_switch_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_for_in_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_do_statement] = STATE(14),
    [sym_try_statement] = STATE(14),
    [sym_with_statement] = STATE(14),
    [sym_break_statement] = STATE(14),
    [sym_continue_statement] = STATE(14),
    [sym_debugger_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_throw_statement] = STATE(14),
    [sym_empty_statement] = STATE(14),
    [sym_labeled_statement] = STATE(14),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(14),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(14),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(512),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_case] = ACTIONS(514),
    [anon_sym_default] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [14] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(11),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(11),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(516),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_case] = ACTIONS(518),
    [anon_sym_default] = ACTIONS(518),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [15] = {
    [sym_export_statement] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(12),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(12),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(520),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_case] = ACTIONS(522),
    [anon_sym_default] = ACTIONS(522),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [16] = {
    [sym_export_statement] = STATE(19),
    [sym_declaration] = STATE(19),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(19),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(19),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(524),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [17] = {
    [sym_export_statement] = STATE(32),
    [sym_declaration] = STATE(32),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(32),
    [sym_expression_statement] = STATE(32),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(32),
    [sym_if_statement] = STATE(32),
    [sym_switch_statement] = STATE(32),
    [sym_for_statement] = STATE(32),
    [sym_for_in_statement] = STATE(32),
    [sym_while_statement] = STATE(32),
    [sym_do_statement] = STATE(32),
    [sym_try_statement] = STATE(32),
    [sym_with_statement] = STATE(32),
    [sym_break_statement] = STATE(32),
    [sym_continue_statement] = STATE(32),
    [sym_debugger_statement] = STATE(32),
    [sym_return_statement] = STATE(32),
    [sym_throw_statement] = STATE(32),
    [sym_empty_statement] = STATE(32),
    [sym_labeled_statement] = STATE(32),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(32),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(32),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(526),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [18] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(11),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(11),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(528),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [19] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(11),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(11),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(530),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [20] = {
    [sym_export_statement] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(30),
    [sym_expression_statement] = STATE(30),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(30),
    [sym_if_statement] = STATE(30),
    [sym_switch_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_for_in_statement] = STATE(30),
    [sym_while_statement] = STATE(30),
    [sym_do_statement] = STATE(30),
    [sym_try_statement] = STATE(30),
    [sym_with_statement] = STATE(30),
    [sym_break_statement] = STATE(30),
    [sym_continue_statement] = STATE(30),
    [sym_debugger_statement] = STATE(30),
    [sym_return_statement] = STATE(30),
    [sym_throw_statement] = STATE(30),
    [sym_empty_statement] = STATE(30),
    [sym_labeled_statement] = STATE(30),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(30),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(30),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(532),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [21] = {
    [sym_export_statement] = STATE(28),
    [sym_declaration] = STATE(28),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(28),
    [sym_expression_statement] = STATE(28),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_for_in_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_debugger_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_throw_statement] = STATE(28),
    [sym_empty_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(28),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(28),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(534),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [22] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(11),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(11),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(536),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [23] = {
    [sym_export_statement] = STATE(18),
    [sym_declaration] = STATE(18),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_for_in_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_try_statement] = STATE(18),
    [sym_with_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_debugger_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_throw_statement] = STATE(18),
    [sym_empty_statement] = STATE(18),
    [sym_labeled_statement] = STATE(18),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(18),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(18),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(538),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [24] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(11),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(11),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(540),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [25] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(11),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(11),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(542),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [26] = {
    [sym_export_statement] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(22),
    [sym_expression_statement] = STATE(22),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_switch_statement] = STATE(22),
    [sym_for_statement] = STATE(22),
    [sym_for_in_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_do_statement] = STATE(22),
    [sym_try_statement] = STATE(22),
    [sym_with_statement] = STATE(22),
    [sym_break_statement] = STATE(22),
    [sym_continue_statement] = STATE(22),
    [sym_debugger_statement] = STATE(22),
    [sym_return_statement] = STATE(22),
    [sym_throw_statement] = STATE(22),
    [sym_empty_statement] = STATE(22),
    [sym_labeled_statement] = STATE(22),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(22),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(22),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(544),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [27] = {
    [sym_export_statement] = STATE(24),
    [sym_declaration] = STATE(24),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(24),
    [sym_expression_statement] = STATE(24),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_switch_statement] = STATE(24),
    [sym_for_statement] = STATE(24),
    [sym_for_in_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_do_statement] = STATE(24),
    [sym_try_statement] = STATE(24),
    [sym_with_statement] = STATE(24),
    [sym_break_statement] = STATE(24),
    [sym_continue_statement] = STATE(24),
    [sym_debugger_statement] = STATE(24),
    [sym_return_statement] = STATE(24),
    [sym_throw_statement] = STATE(24),
    [sym_empty_statement] = STATE(24),
    [sym_labeled_statement] = STATE(24),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(24),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(24),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(546),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [28] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(11),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(11),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(548),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [29] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(11),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(11),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(550),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [30] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(11),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(11),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(552),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [31] = {
    [sym_export_statement] = STATE(25),
    [sym_declaration] = STATE(25),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_for_in_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_with_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_debugger_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_throw_statement] = STATE(25),
    [sym_empty_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(25),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(25),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [32] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(11),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(11),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(556),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [33] = {
    [sym_export_statement] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_switch_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_for_in_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_try_statement] = STATE(29),
    [sym_with_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_debugger_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_throw_statement] = STATE(29),
    [sym_empty_statement] = STATE(29),
    [sym_labeled_statement] = STATE(29),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(29),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(29),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(558),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [34] = {
    [sym_export_statement] = STATE(35),
    [sym_declaration] = STATE(35),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(35),
    [sym_expression_statement] = STATE(35),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(35),
    [sym_if_statement] = STATE(35),
    [sym_switch_statement] = STATE(35),
    [sym_for_statement] = STATE(35),
    [sym_for_in_statement] = STATE(35),
    [sym_while_statement] = STATE(35),
    [sym_do_statement] = STATE(35),
    [sym_try_statement] = STATE(35),
    [sym_with_statement] = STATE(35),
    [sym_break_statement] = STATE(35),
    [sym_continue_statement] = STATE(35),
    [sym_debugger_statement] = STATE(35),
    [sym_return_statement] = STATE(35),
    [sym_throw_statement] = STATE(35),
    [sym_empty_statement] = STATE(35),
    [sym_labeled_statement] = STATE(35),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(35),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(35),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(560),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [35] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(11),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_statement_block_repeat1] = STATE(11),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(562),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [36] = {
    [sym_export_statement] = STATE(854),
    [sym_declaration] = STATE(854),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(854),
    [sym_expression_statement] = STATE(854),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(854),
    [sym_if_statement] = STATE(854),
    [sym_switch_statement] = STATE(854),
    [sym_for_statement] = STATE(854),
    [sym_for_in_statement] = STATE(854),
    [sym_while_statement] = STATE(854),
    [sym_do_statement] = STATE(854),
    [sym_try_statement] = STATE(854),
    [sym_with_statement] = STATE(854),
    [sym_break_statement] = STATE(854),
    [sym_continue_statement] = STATE(854),
    [sym_debugger_statement] = STATE(854),
    [sym_return_statement] = STATE(854),
    [sym_throw_statement] = STATE(854),
    [sym_empty_statement] = STATE(854),
    [sym_labeled_statement] = STATE(854),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(854),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [37] = {
    [sym_export_statement] = STATE(704),
    [sym_declaration] = STATE(704),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(704),
    [sym_expression_statement] = STATE(704),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(704),
    [sym_if_statement] = STATE(704),
    [sym_switch_statement] = STATE(704),
    [sym_for_statement] = STATE(704),
    [sym_for_in_statement] = STATE(704),
    [sym_while_statement] = STATE(704),
    [sym_do_statement] = STATE(704),
    [sym_try_statement] = STATE(704),
    [sym_with_statement] = STATE(704),
    [sym_break_statement] = STATE(704),
    [sym_continue_statement] = STATE(704),
    [sym_debugger_statement] = STATE(704),
    [sym_return_statement] = STATE(704),
    [sym_throw_statement] = STATE(704),
    [sym_empty_statement] = STATE(704),
    [sym_labeled_statement] = STATE(704),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(704),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [38] = {
    [sym_export_statement] = STATE(817),
    [sym_declaration] = STATE(817),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(817),
    [sym_expression_statement] = STATE(817),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(817),
    [sym_if_statement] = STATE(817),
    [sym_switch_statement] = STATE(817),
    [sym_for_statement] = STATE(817),
    [sym_for_in_statement] = STATE(817),
    [sym_while_statement] = STATE(817),
    [sym_do_statement] = STATE(817),
    [sym_try_statement] = STATE(817),
    [sym_with_statement] = STATE(817),
    [sym_break_statement] = STATE(817),
    [sym_continue_statement] = STATE(817),
    [sym_debugger_statement] = STATE(817),
    [sym_return_statement] = STATE(817),
    [sym_throw_statement] = STATE(817),
    [sym_empty_statement] = STATE(817),
    [sym_labeled_statement] = STATE(817),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(817),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [39] = {
    [sym_export_statement] = STATE(4581),
    [sym_declaration] = STATE(4581),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(4581),
    [sym_expression_statement] = STATE(4581),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(4581),
    [sym_if_statement] = STATE(4581),
    [sym_switch_statement] = STATE(4581),
    [sym_for_statement] = STATE(4581),
    [sym_for_in_statement] = STATE(4581),
    [sym_while_statement] = STATE(4581),
    [sym_do_statement] = STATE(4581),
    [sym_try_statement] = STATE(4581),
    [sym_with_statement] = STATE(4581),
    [sym_break_statement] = STATE(4581),
    [sym_continue_statement] = STATE(4581),
    [sym_debugger_statement] = STATE(4581),
    [sym_return_statement] = STATE(4581),
    [sym_throw_statement] = STATE(4581),
    [sym_empty_statement] = STATE(4581),
    [sym_labeled_statement] = STATE(4581),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(4581),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3892),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3201),
    [sym_identifier] = ACTIONS(564),
    [anon_sym_export] = ACTIONS(566),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(570),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(572),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(574),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(580),
    [anon_sym_with] = ACTIONS(582),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(584),
    [anon_sym_async] = ACTIONS(586),
    [anon_sym_function] = ACTIONS(588),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_readonly] = ACTIONS(590),
    [anon_sym_get] = ACTIONS(590),
    [anon_sym_set] = ACTIONS(590),
    [anon_sym_declare] = ACTIONS(592),
    [anon_sym_namespace] = ACTIONS(594),
    [anon_sym_public] = ACTIONS(590),
    [anon_sym_private] = ACTIONS(590),
    [anon_sym_protected] = ACTIONS(590),
    [anon_sym_override] = ACTIONS(590),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(590),
    [anon_sym_number] = ACTIONS(590),
    [anon_sym_boolean] = ACTIONS(590),
    [anon_sym_string] = ACTIONS(590),
    [anon_sym_symbol] = ACTIONS(590),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(598),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(600),
  },
  [40] = {
    [sym_export_statement] = STATE(704),
    [sym_declaration] = STATE(704),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(704),
    [sym_expression_statement] = STATE(704),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(704),
    [sym_if_statement] = STATE(704),
    [sym_switch_statement] = STATE(704),
    [sym_for_statement] = STATE(704),
    [sym_for_in_statement] = STATE(704),
    [sym_while_statement] = STATE(704),
    [sym_do_statement] = STATE(704),
    [sym_try_statement] = STATE(704),
    [sym_with_statement] = STATE(704),
    [sym_break_statement] = STATE(704),
    [sym_continue_statement] = STATE(704),
    [sym_debugger_statement] = STATE(704),
    [sym_return_statement] = STATE(704),
    [sym_throw_statement] = STATE(704),
    [sym_empty_statement] = STATE(704),
    [sym_labeled_statement] = STATE(704),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(704),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3892),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3201),
    [sym_identifier] = ACTIONS(564),
    [anon_sym_export] = ACTIONS(566),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(570),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(572),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(574),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(580),
    [anon_sym_with] = ACTIONS(582),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(584),
    [anon_sym_async] = ACTIONS(586),
    [anon_sym_function] = ACTIONS(588),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_readonly] = ACTIONS(590),
    [anon_sym_get] = ACTIONS(590),
    [anon_sym_set] = ACTIONS(590),
    [anon_sym_declare] = ACTIONS(592),
    [anon_sym_namespace] = ACTIONS(594),
    [anon_sym_public] = ACTIONS(590),
    [anon_sym_private] = ACTIONS(590),
    [anon_sym_protected] = ACTIONS(590),
    [anon_sym_override] = ACTIONS(590),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(590),
    [anon_sym_number] = ACTIONS(590),
    [anon_sym_boolean] = ACTIONS(590),
    [anon_sym_string] = ACTIONS(590),
    [anon_sym_symbol] = ACTIONS(590),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(598),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(600),
  },
  [41] = {
    [sym_export_statement] = STATE(851),
    [sym_declaration] = STATE(851),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(851),
    [sym_expression_statement] = STATE(851),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(851),
    [sym_if_statement] = STATE(851),
    [sym_switch_statement] = STATE(851),
    [sym_for_statement] = STATE(851),
    [sym_for_in_statement] = STATE(851),
    [sym_while_statement] = STATE(851),
    [sym_do_statement] = STATE(851),
    [sym_try_statement] = STATE(851),
    [sym_with_statement] = STATE(851),
    [sym_break_statement] = STATE(851),
    [sym_continue_statement] = STATE(851),
    [sym_debugger_statement] = STATE(851),
    [sym_return_statement] = STATE(851),
    [sym_throw_statement] = STATE(851),
    [sym_empty_statement] = STATE(851),
    [sym_labeled_statement] = STATE(851),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(851),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [42] = {
    [sym_export_statement] = STATE(743),
    [sym_declaration] = STATE(743),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(743),
    [sym_expression_statement] = STATE(743),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(743),
    [sym_if_statement] = STATE(743),
    [sym_switch_statement] = STATE(743),
    [sym_for_statement] = STATE(743),
    [sym_for_in_statement] = STATE(743),
    [sym_while_statement] = STATE(743),
    [sym_do_statement] = STATE(743),
    [sym_try_statement] = STATE(743),
    [sym_with_statement] = STATE(743),
    [sym_break_statement] = STATE(743),
    [sym_continue_statement] = STATE(743),
    [sym_debugger_statement] = STATE(743),
    [sym_return_statement] = STATE(743),
    [sym_throw_statement] = STATE(743),
    [sym_empty_statement] = STATE(743),
    [sym_labeled_statement] = STATE(743),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(743),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [43] = {
    [sym_export_statement] = STATE(823),
    [sym_declaration] = STATE(818),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(816),
    [sym_expression_statement] = STATE(814),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(793),
    [sym_if_statement] = STATE(784),
    [sym_switch_statement] = STATE(782),
    [sym_for_statement] = STATE(773),
    [sym_for_in_statement] = STATE(771),
    [sym_while_statement] = STATE(766),
    [sym_do_statement] = STATE(753),
    [sym_try_statement] = STATE(749),
    [sym_with_statement] = STATE(744),
    [sym_break_statement] = STATE(741),
    [sym_continue_statement] = STATE(720),
    [sym_debugger_statement] = STATE(714),
    [sym_return_statement] = STATE(711),
    [sym_throw_statement] = STATE(758),
    [sym_empty_statement] = STATE(775),
    [sym_labeled_statement] = STATE(790),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(705),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3892),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3201),
    [sym_identifier] = ACTIONS(564),
    [anon_sym_export] = ACTIONS(566),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(570),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(572),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(574),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(580),
    [anon_sym_with] = ACTIONS(582),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(584),
    [anon_sym_async] = ACTIONS(586),
    [anon_sym_function] = ACTIONS(588),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_readonly] = ACTIONS(590),
    [anon_sym_get] = ACTIONS(590),
    [anon_sym_set] = ACTIONS(590),
    [anon_sym_declare] = ACTIONS(592),
    [anon_sym_namespace] = ACTIONS(594),
    [anon_sym_public] = ACTIONS(590),
    [anon_sym_private] = ACTIONS(590),
    [anon_sym_protected] = ACTIONS(590),
    [anon_sym_override] = ACTIONS(590),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(590),
    [anon_sym_number] = ACTIONS(590),
    [anon_sym_boolean] = ACTIONS(590),
    [anon_sym_string] = ACTIONS(590),
    [anon_sym_symbol] = ACTIONS(590),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(598),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(600),
  },
  [44] = {
    [sym_export_statement] = STATE(851),
    [sym_declaration] = STATE(851),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(851),
    [sym_expression_statement] = STATE(851),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(851),
    [sym_if_statement] = STATE(851),
    [sym_switch_statement] = STATE(851),
    [sym_for_statement] = STATE(851),
    [sym_for_in_statement] = STATE(851),
    [sym_while_statement] = STATE(851),
    [sym_do_statement] = STATE(851),
    [sym_try_statement] = STATE(851),
    [sym_with_statement] = STATE(851),
    [sym_break_statement] = STATE(851),
    [sym_continue_statement] = STATE(851),
    [sym_debugger_statement] = STATE(851),
    [sym_return_statement] = STATE(851),
    [sym_throw_statement] = STATE(851),
    [sym_empty_statement] = STATE(851),
    [sym_labeled_statement] = STATE(851),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(851),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3892),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3201),
    [sym_identifier] = ACTIONS(564),
    [anon_sym_export] = ACTIONS(566),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(570),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(572),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(574),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(580),
    [anon_sym_with] = ACTIONS(582),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(584),
    [anon_sym_async] = ACTIONS(586),
    [anon_sym_function] = ACTIONS(588),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_readonly] = ACTIONS(590),
    [anon_sym_get] = ACTIONS(590),
    [anon_sym_set] = ACTIONS(590),
    [anon_sym_declare] = ACTIONS(592),
    [anon_sym_namespace] = ACTIONS(594),
    [anon_sym_public] = ACTIONS(590),
    [anon_sym_private] = ACTIONS(590),
    [anon_sym_protected] = ACTIONS(590),
    [anon_sym_override] = ACTIONS(590),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(590),
    [anon_sym_number] = ACTIONS(590),
    [anon_sym_boolean] = ACTIONS(590),
    [anon_sym_string] = ACTIONS(590),
    [anon_sym_symbol] = ACTIONS(590),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(598),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(600),
  },
  [45] = {
    [sym_export_statement] = STATE(854),
    [sym_declaration] = STATE(854),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(854),
    [sym_expression_statement] = STATE(854),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(854),
    [sym_if_statement] = STATE(854),
    [sym_switch_statement] = STATE(854),
    [sym_for_statement] = STATE(854),
    [sym_for_in_statement] = STATE(854),
    [sym_while_statement] = STATE(854),
    [sym_do_statement] = STATE(854),
    [sym_try_statement] = STATE(854),
    [sym_with_statement] = STATE(854),
    [sym_break_statement] = STATE(854),
    [sym_continue_statement] = STATE(854),
    [sym_debugger_statement] = STATE(854),
    [sym_return_statement] = STATE(854),
    [sym_throw_statement] = STATE(854),
    [sym_empty_statement] = STATE(854),
    [sym_labeled_statement] = STATE(854),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(854),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3892),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3201),
    [sym_identifier] = ACTIONS(564),
    [anon_sym_export] = ACTIONS(566),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(570),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(572),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(574),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(580),
    [anon_sym_with] = ACTIONS(582),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(584),
    [anon_sym_async] = ACTIONS(586),
    [anon_sym_function] = ACTIONS(588),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_readonly] = ACTIONS(590),
    [anon_sym_get] = ACTIONS(590),
    [anon_sym_set] = ACTIONS(590),
    [anon_sym_declare] = ACTIONS(592),
    [anon_sym_namespace] = ACTIONS(594),
    [anon_sym_public] = ACTIONS(590),
    [anon_sym_private] = ACTIONS(590),
    [anon_sym_protected] = ACTIONS(590),
    [anon_sym_override] = ACTIONS(590),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(590),
    [anon_sym_number] = ACTIONS(590),
    [anon_sym_boolean] = ACTIONS(590),
    [anon_sym_string] = ACTIONS(590),
    [anon_sym_symbol] = ACTIONS(590),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(598),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(600),
  },
  [46] = {
    [sym_export_statement] = STATE(847),
    [sym_declaration] = STATE(847),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(847),
    [sym_expression_statement] = STATE(847),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(847),
    [sym_if_statement] = STATE(847),
    [sym_switch_statement] = STATE(847),
    [sym_for_statement] = STATE(847),
    [sym_for_in_statement] = STATE(847),
    [sym_while_statement] = STATE(847),
    [sym_do_statement] = STATE(847),
    [sym_try_statement] = STATE(847),
    [sym_with_statement] = STATE(847),
    [sym_break_statement] = STATE(847),
    [sym_continue_statement] = STATE(847),
    [sym_debugger_statement] = STATE(847),
    [sym_return_statement] = STATE(847),
    [sym_throw_statement] = STATE(847),
    [sym_empty_statement] = STATE(847),
    [sym_labeled_statement] = STATE(847),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(847),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3892),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3201),
    [sym_identifier] = ACTIONS(564),
    [anon_sym_export] = ACTIONS(566),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(570),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(572),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(574),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(580),
    [anon_sym_with] = ACTIONS(582),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(584),
    [anon_sym_async] = ACTIONS(586),
    [anon_sym_function] = ACTIONS(588),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_readonly] = ACTIONS(590),
    [anon_sym_get] = ACTIONS(590),
    [anon_sym_set] = ACTIONS(590),
    [anon_sym_declare] = ACTIONS(592),
    [anon_sym_namespace] = ACTIONS(594),
    [anon_sym_public] = ACTIONS(590),
    [anon_sym_private] = ACTIONS(590),
    [anon_sym_protected] = ACTIONS(590),
    [anon_sym_override] = ACTIONS(590),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(590),
    [anon_sym_number] = ACTIONS(590),
    [anon_sym_boolean] = ACTIONS(590),
    [anon_sym_string] = ACTIONS(590),
    [anon_sym_symbol] = ACTIONS(590),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(598),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(600),
  },
  [47] = {
    [sym_export_statement] = STATE(709),
    [sym_declaration] = STATE(708),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(707),
    [sym_expression_statement] = STATE(706),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(756),
    [sym_if_statement] = STATE(799),
    [sym_switch_statement] = STATE(803),
    [sym_for_statement] = STATE(809),
    [sym_for_in_statement] = STATE(811),
    [sym_while_statement] = STATE(819),
    [sym_do_statement] = STATE(820),
    [sym_try_statement] = STATE(821),
    [sym_with_statement] = STATE(824),
    [sym_break_statement] = STATE(825),
    [sym_continue_statement] = STATE(826),
    [sym_debugger_statement] = STATE(828),
    [sym_return_statement] = STATE(830),
    [sym_throw_statement] = STATE(834),
    [sym_empty_statement] = STATE(844),
    [sym_labeled_statement] = STATE(845),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(846),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3892),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3201),
    [sym_identifier] = ACTIONS(564),
    [anon_sym_export] = ACTIONS(566),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(570),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(572),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(574),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(580),
    [anon_sym_with] = ACTIONS(582),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(584),
    [anon_sym_async] = ACTIONS(586),
    [anon_sym_function] = ACTIONS(588),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_readonly] = ACTIONS(590),
    [anon_sym_get] = ACTIONS(590),
    [anon_sym_set] = ACTIONS(590),
    [anon_sym_declare] = ACTIONS(592),
    [anon_sym_namespace] = ACTIONS(594),
    [anon_sym_public] = ACTIONS(590),
    [anon_sym_private] = ACTIONS(590),
    [anon_sym_protected] = ACTIONS(590),
    [anon_sym_override] = ACTIONS(590),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(590),
    [anon_sym_number] = ACTIONS(590),
    [anon_sym_boolean] = ACTIONS(590),
    [anon_sym_string] = ACTIONS(590),
    [anon_sym_symbol] = ACTIONS(590),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(598),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(600),
  },
  [48] = {
    [sym_export_statement] = STATE(3975),
    [sym_declaration] = STATE(3975),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(3975),
    [sym_expression_statement] = STATE(3975),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(3975),
    [sym_if_statement] = STATE(3975),
    [sym_switch_statement] = STATE(3975),
    [sym_for_statement] = STATE(3975),
    [sym_for_in_statement] = STATE(3975),
    [sym_while_statement] = STATE(3975),
    [sym_do_statement] = STATE(3975),
    [sym_try_statement] = STATE(3975),
    [sym_with_statement] = STATE(3975),
    [sym_break_statement] = STATE(3975),
    [sym_continue_statement] = STATE(3975),
    [sym_debugger_statement] = STATE(3975),
    [sym_return_statement] = STATE(3975),
    [sym_throw_statement] = STATE(3975),
    [sym_empty_statement] = STATE(3975),
    [sym_labeled_statement] = STATE(3975),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(3975),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3892),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3201),
    [sym_identifier] = ACTIONS(564),
    [anon_sym_export] = ACTIONS(566),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(570),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(572),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(574),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(580),
    [anon_sym_with] = ACTIONS(582),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(584),
    [anon_sym_async] = ACTIONS(586),
    [anon_sym_function] = ACTIONS(588),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_readonly] = ACTIONS(590),
    [anon_sym_get] = ACTIONS(590),
    [anon_sym_set] = ACTIONS(590),
    [anon_sym_declare] = ACTIONS(592),
    [anon_sym_namespace] = ACTIONS(594),
    [anon_sym_public] = ACTIONS(590),
    [anon_sym_private] = ACTIONS(590),
    [anon_sym_protected] = ACTIONS(590),
    [anon_sym_override] = ACTIONS(590),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(590),
    [anon_sym_number] = ACTIONS(590),
    [anon_sym_boolean] = ACTIONS(590),
    [anon_sym_string] = ACTIONS(590),
    [anon_sym_symbol] = ACTIONS(590),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(598),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(600),
  },
  [49] = {
    [sym_export_statement] = STATE(823),
    [sym_declaration] = STATE(818),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(816),
    [sym_expression_statement] = STATE(814),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(793),
    [sym_if_statement] = STATE(784),
    [sym_switch_statement] = STATE(782),
    [sym_for_statement] = STATE(773),
    [sym_for_in_statement] = STATE(771),
    [sym_while_statement] = STATE(766),
    [sym_do_statement] = STATE(753),
    [sym_try_statement] = STATE(749),
    [sym_with_statement] = STATE(744),
    [sym_break_statement] = STATE(741),
    [sym_continue_statement] = STATE(720),
    [sym_debugger_statement] = STATE(714),
    [sym_return_statement] = STATE(711),
    [sym_throw_statement] = STATE(758),
    [sym_empty_statement] = STATE(775),
    [sym_labeled_statement] = STATE(790),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(705),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [50] = {
    [sym_export_statement] = STATE(817),
    [sym_declaration] = STATE(817),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(817),
    [sym_expression_statement] = STATE(817),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(817),
    [sym_if_statement] = STATE(817),
    [sym_switch_statement] = STATE(817),
    [sym_for_statement] = STATE(817),
    [sym_for_in_statement] = STATE(817),
    [sym_while_statement] = STATE(817),
    [sym_do_statement] = STATE(817),
    [sym_try_statement] = STATE(817),
    [sym_with_statement] = STATE(817),
    [sym_break_statement] = STATE(817),
    [sym_continue_statement] = STATE(817),
    [sym_debugger_statement] = STATE(817),
    [sym_return_statement] = STATE(817),
    [sym_throw_statement] = STATE(817),
    [sym_empty_statement] = STATE(817),
    [sym_labeled_statement] = STATE(817),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(817),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3892),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3201),
    [sym_identifier] = ACTIONS(564),
    [anon_sym_export] = ACTIONS(566),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(570),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(572),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(574),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(580),
    [anon_sym_with] = ACTIONS(582),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(584),
    [anon_sym_async] = ACTIONS(586),
    [anon_sym_function] = ACTIONS(588),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_readonly] = ACTIONS(590),
    [anon_sym_get] = ACTIONS(590),
    [anon_sym_set] = ACTIONS(590),
    [anon_sym_declare] = ACTIONS(592),
    [anon_sym_namespace] = ACTIONS(594),
    [anon_sym_public] = ACTIONS(590),
    [anon_sym_private] = ACTIONS(590),
    [anon_sym_protected] = ACTIONS(590),
    [anon_sym_override] = ACTIONS(590),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(590),
    [anon_sym_number] = ACTIONS(590),
    [anon_sym_boolean] = ACTIONS(590),
    [anon_sym_string] = ACTIONS(590),
    [anon_sym_symbol] = ACTIONS(590),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(598),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(600),
  },
  [51] = {
    [sym_export_statement] = STATE(696),
    [sym_declaration] = STATE(696),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(696),
    [sym_expression_statement] = STATE(696),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(696),
    [sym_if_statement] = STATE(696),
    [sym_switch_statement] = STATE(696),
    [sym_for_statement] = STATE(696),
    [sym_for_in_statement] = STATE(696),
    [sym_while_statement] = STATE(696),
    [sym_do_statement] = STATE(696),
    [sym_try_statement] = STATE(696),
    [sym_with_statement] = STATE(696),
    [sym_break_statement] = STATE(696),
    [sym_continue_statement] = STATE(696),
    [sym_debugger_statement] = STATE(696),
    [sym_return_statement] = STATE(696),
    [sym_throw_statement] = STATE(696),
    [sym_empty_statement] = STATE(696),
    [sym_labeled_statement] = STATE(696),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(696),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [52] = {
    [sym_export_statement] = STATE(709),
    [sym_declaration] = STATE(708),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(707),
    [sym_expression_statement] = STATE(706),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(756),
    [sym_if_statement] = STATE(799),
    [sym_switch_statement] = STATE(803),
    [sym_for_statement] = STATE(809),
    [sym_for_in_statement] = STATE(811),
    [sym_while_statement] = STATE(819),
    [sym_do_statement] = STATE(820),
    [sym_try_statement] = STATE(821),
    [sym_with_statement] = STATE(824),
    [sym_break_statement] = STATE(825),
    [sym_continue_statement] = STATE(826),
    [sym_debugger_statement] = STATE(828),
    [sym_return_statement] = STATE(830),
    [sym_throw_statement] = STATE(834),
    [sym_empty_statement] = STATE(844),
    [sym_labeled_statement] = STATE(845),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(846),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [53] = {
    [sym_export_statement] = STATE(743),
    [sym_declaration] = STATE(743),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(743),
    [sym_expression_statement] = STATE(743),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(743),
    [sym_if_statement] = STATE(743),
    [sym_switch_statement] = STATE(743),
    [sym_for_statement] = STATE(743),
    [sym_for_in_statement] = STATE(743),
    [sym_while_statement] = STATE(743),
    [sym_do_statement] = STATE(743),
    [sym_try_statement] = STATE(743),
    [sym_with_statement] = STATE(743),
    [sym_break_statement] = STATE(743),
    [sym_continue_statement] = STATE(743),
    [sym_debugger_statement] = STATE(743),
    [sym_return_statement] = STATE(743),
    [sym_throw_statement] = STATE(743),
    [sym_empty_statement] = STATE(743),
    [sym_labeled_statement] = STATE(743),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(743),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3892),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3201),
    [sym_identifier] = ACTIONS(564),
    [anon_sym_export] = ACTIONS(566),
    [anon_sym_LBRACE] = ACTIONS(568),
    [anon_sym_type] = ACTIONS(570),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(572),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(574),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(580),
    [anon_sym_with] = ACTIONS(582),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(584),
    [anon_sym_async] = ACTIONS(586),
    [anon_sym_function] = ACTIONS(588),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(590),
    [anon_sym_readonly] = ACTIONS(590),
    [anon_sym_get] = ACTIONS(590),
    [anon_sym_set] = ACTIONS(590),
    [anon_sym_declare] = ACTIONS(592),
    [anon_sym_namespace] = ACTIONS(594),
    [anon_sym_public] = ACTIONS(590),
    [anon_sym_private] = ACTIONS(590),
    [anon_sym_protected] = ACTIONS(590),
    [anon_sym_override] = ACTIONS(590),
    [anon_sym_module] = ACTIONS(596),
    [anon_sym_any] = ACTIONS(590),
    [anon_sym_number] = ACTIONS(590),
    [anon_sym_boolean] = ACTIONS(590),
    [anon_sym_string] = ACTIONS(590),
    [anon_sym_symbol] = ACTIONS(590),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(598),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(600),
  },
  [54] = {
    [sym_export_statement] = STATE(847),
    [sym_declaration] = STATE(847),
    [sym_import] = STATE(2110),
    [sym_import_statement] = STATE(847),
    [sym_expression_statement] = STATE(847),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_statement_block] = STATE(847),
    [sym_if_statement] = STATE(847),
    [sym_switch_statement] = STATE(847),
    [sym_for_statement] = STATE(847),
    [sym_for_in_statement] = STATE(847),
    [sym_while_statement] = STATE(847),
    [sym_do_statement] = STATE(847),
    [sym_try_statement] = STATE(847),
    [sym_with_statement] = STATE(847),
    [sym_break_statement] = STATE(847),
    [sym_continue_statement] = STATE(847),
    [sym_debugger_statement] = STATE(847),
    [sym_return_statement] = STATE(847),
    [sym_throw_statement] = STATE(847),
    [sym_empty_statement] = STATE(847),
    [sym_labeled_statement] = STATE(847),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_class_declaration] = STATE(759),
    [sym_function] = STATE(2110),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function] = STATE(2110),
    [sym_generator_function_declaration] = STATE(759),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_function_signature] = STATE(759),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_js_import_statement] = STATE(847),
    [sym_component] = STATE(2110),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3886),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3205),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_export] = ACTIONS(490),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(147),
    [anon_sym_let] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_try] = ACTIONS(169),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(175),
    [anon_sym_debugger] = ACTIONS(177),
    [anon_sym_return] = ACTIONS(179),
    [anon_sym_throw] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(191),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(504),
    [anon_sym_readonly] = ACTIONS(504),
    [anon_sym_get] = ACTIONS(504),
    [anon_sym_set] = ACTIONS(504),
    [anon_sym_declare] = ACTIONS(506),
    [anon_sym_namespace] = ACTIONS(508),
    [anon_sym_public] = ACTIONS(504),
    [anon_sym_private] = ACTIONS(504),
    [anon_sym_protected] = ACTIONS(504),
    [anon_sym_override] = ACTIONS(504),
    [anon_sym_module] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(504),
    [anon_sym_number] = ACTIONS(504),
    [anon_sym_boolean] = ACTIONS(504),
    [anon_sym_string] = ACTIONS(504),
    [anon_sym_symbol] = ACTIONS(504),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
    [anon_sym_component] = ACTIONS(241),
  },
  [55] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3672),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(36),
    [anon_sym_LPAREN] = ACTIONS(606),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_EQ] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(609),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(54),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(617),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(36),
    [anon_sym_DASH] = ACTIONS(36),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(624),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(21),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_override] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_component] = ACTIONS(120),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [56] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3543),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(36),
    [anon_sym_LPAREN] = ACTIONS(606),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_EQ] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(609),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(54),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(617),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(36),
    [anon_sym_DASH] = ACTIONS(36),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(630),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(21),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_override] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_component] = ACTIONS(120),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [57] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3661),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(36),
    [anon_sym_LPAREN] = ACTIONS(606),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_EQ] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(609),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(54),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(617),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(36),
    [anon_sym_DASH] = ACTIONS(36),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(632),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(21),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_override] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_component] = ACTIONS(120),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [58] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3669),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(36),
    [anon_sym_LPAREN] = ACTIONS(606),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_EQ] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(609),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(54),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(617),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(36),
    [anon_sym_DASH] = ACTIONS(36),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(634),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(21),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_override] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_component] = ACTIONS(120),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [59] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3655),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(36),
    [anon_sym_LPAREN] = ACTIONS(606),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_EQ] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(609),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(54),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(617),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(36),
    [anon_sym_DASH] = ACTIONS(36),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(636),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(21),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_override] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_component] = ACTIONS(120),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [60] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3636),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(36),
    [anon_sym_LPAREN] = ACTIONS(606),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_EQ] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(609),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(54),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(617),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(36),
    [anon_sym_DASH] = ACTIONS(36),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(638),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(21),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_override] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_component] = ACTIONS(120),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [61] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3628),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(36),
    [anon_sym_LPAREN] = ACTIONS(606),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_EQ] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(609),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(54),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(617),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(36),
    [anon_sym_DASH] = ACTIONS(36),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(640),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(21),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_override] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_component] = ACTIONS(120),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [62] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3543),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_COMMA] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(36),
    [anon_sym_LPAREN] = ACTIONS(606),
    [anon_sym_RPAREN] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_EQ] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(609),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(54),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(617),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(36),
    [anon_sym_DASH] = ACTIONS(36),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(630),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(21),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_override] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_component] = ACTIONS(120),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [63] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2136),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(3992),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3137),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1503),
    [sym_subscript_expression] = STATE(1503),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_spread_element] = STATE(3991),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(2288),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3653),
    [sym_pattern] = STATE(3829),
    [sym_rest_pattern] = STATE(3546),
    [sym_non_null_expression] = STATE(1503),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4019),
    [sym_optional_tuple_parameter] = STATE(4019),
    [sym_optional_type] = STATE(4019),
    [sym_rest_type] = STATE(4019),
    [sym__tuple_type_member] = STATE(4019),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_type_arguments] = STATE(435),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4227),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(3985),
    [aux_sym_array_pattern_repeat1] = STATE(3982),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(648),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(652),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(654),
    [anon_sym_RBRACK] = ACTIONS(656),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(67),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(81),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(92),
    [sym_number] = ACTIONS(94),
    [sym_this] = ACTIONS(672),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(100),
    [sym_false] = ACTIONS(100),
    [sym_null] = ACTIONS(100),
    [sym_undefined] = ACTIONS(674),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_readonly] = ACTIONS(676),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_override] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(680),
    [anon_sym_number] = ACTIONS(680),
    [anon_sym_boolean] = ACTIONS(680),
    [anon_sym_string] = ACTIONS(680),
    [anon_sym_symbol] = ACTIONS(680),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_component] = ACTIONS(120),
  },
  [64] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2136),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(3992),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3137),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1503),
    [sym_subscript_expression] = STATE(1503),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_spread_element] = STATE(3991),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(2288),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3653),
    [sym_pattern] = STATE(3829),
    [sym_rest_pattern] = STATE(3546),
    [sym_non_null_expression] = STATE(1503),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4019),
    [sym_optional_tuple_parameter] = STATE(4019),
    [sym_optional_type] = STATE(4019),
    [sym_rest_type] = STATE(4019),
    [sym__tuple_type_member] = STATE(4019),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_type_arguments] = STATE(435),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4227),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(3985),
    [aux_sym_array_pattern_repeat1] = STATE(3982),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(648),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(652),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(654),
    [anon_sym_RBRACK] = ACTIONS(682),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(67),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(81),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(92),
    [sym_number] = ACTIONS(94),
    [sym_this] = ACTIONS(672),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(100),
    [sym_false] = ACTIONS(100),
    [sym_null] = ACTIONS(100),
    [sym_undefined] = ACTIONS(674),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_readonly] = ACTIONS(676),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_override] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(680),
    [anon_sym_number] = ACTIONS(680),
    [anon_sym_boolean] = ACTIONS(680),
    [anon_sym_string] = ACTIONS(680),
    [anon_sym_symbol] = ACTIONS(680),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_component] = ACTIONS(120),
  },
  [65] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2136),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(3992),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3137),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1503),
    [sym_subscript_expression] = STATE(1503),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_spread_element] = STATE(3991),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(2288),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3653),
    [sym_pattern] = STATE(3829),
    [sym_rest_pattern] = STATE(3546),
    [sym_non_null_expression] = STATE(1503),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4019),
    [sym_optional_tuple_parameter] = STATE(4019),
    [sym_optional_type] = STATE(4019),
    [sym_rest_type] = STATE(4019),
    [sym__tuple_type_member] = STATE(4019),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_type_arguments] = STATE(435),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4227),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(3985),
    [aux_sym_array_pattern_repeat1] = STATE(3982),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(648),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(652),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(654),
    [anon_sym_RBRACK] = ACTIONS(684),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(67),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(81),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(92),
    [sym_number] = ACTIONS(94),
    [sym_this] = ACTIONS(672),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(100),
    [sym_false] = ACTIONS(100),
    [sym_null] = ACTIONS(100),
    [sym_undefined] = ACTIONS(674),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_readonly] = ACTIONS(676),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_override] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(680),
    [anon_sym_number] = ACTIONS(680),
    [anon_sym_boolean] = ACTIONS(680),
    [anon_sym_string] = ACTIONS(680),
    [anon_sym_symbol] = ACTIONS(680),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_component] = ACTIONS(120),
  },
  [66] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2136),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(3992),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3137),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1503),
    [sym_subscript_expression] = STATE(1503),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_spread_element] = STATE(3991),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(2288),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3653),
    [sym_pattern] = STATE(3829),
    [sym_rest_pattern] = STATE(3546),
    [sym_non_null_expression] = STATE(1503),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4019),
    [sym_optional_tuple_parameter] = STATE(4019),
    [sym_optional_type] = STATE(4019),
    [sym_rest_type] = STATE(4019),
    [sym__tuple_type_member] = STATE(4019),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_type_arguments] = STATE(435),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4227),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(3985),
    [aux_sym_array_pattern_repeat1] = STATE(3982),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(648),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(652),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(654),
    [anon_sym_RBRACK] = ACTIONS(686),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(67),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(81),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(92),
    [sym_number] = ACTIONS(94),
    [sym_this] = ACTIONS(672),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(100),
    [sym_false] = ACTIONS(100),
    [sym_null] = ACTIONS(100),
    [sym_undefined] = ACTIONS(674),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_readonly] = ACTIONS(676),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_override] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(680),
    [anon_sym_number] = ACTIONS(680),
    [anon_sym_boolean] = ACTIONS(680),
    [anon_sym_string] = ACTIONS(680),
    [anon_sym_symbol] = ACTIONS(680),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_component] = ACTIONS(120),
  },
  [67] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2136),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(3992),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3137),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1503),
    [sym_subscript_expression] = STATE(1503),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_spread_element] = STATE(3991),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(2288),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3653),
    [sym_pattern] = STATE(3829),
    [sym_rest_pattern] = STATE(3546),
    [sym_non_null_expression] = STATE(1503),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4019),
    [sym_optional_tuple_parameter] = STATE(4019),
    [sym_optional_type] = STATE(4019),
    [sym_rest_type] = STATE(4019),
    [sym__tuple_type_member] = STATE(4019),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_type_arguments] = STATE(435),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4227),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(3985),
    [aux_sym_array_pattern_repeat1] = STATE(3982),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(648),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(652),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(654),
    [anon_sym_RBRACK] = ACTIONS(688),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(67),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(81),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(92),
    [sym_number] = ACTIONS(94),
    [sym_this] = ACTIONS(672),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(100),
    [sym_false] = ACTIONS(100),
    [sym_null] = ACTIONS(100),
    [sym_undefined] = ACTIONS(674),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_readonly] = ACTIONS(676),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_override] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(680),
    [anon_sym_number] = ACTIONS(680),
    [anon_sym_boolean] = ACTIONS(680),
    [anon_sym_string] = ACTIONS(680),
    [anon_sym_symbol] = ACTIONS(680),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_component] = ACTIONS(120),
  },
  [68] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2136),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(3992),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3137),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1503),
    [sym_subscript_expression] = STATE(1503),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_spread_element] = STATE(3991),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(2288),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3653),
    [sym_pattern] = STATE(3829),
    [sym_rest_pattern] = STATE(3546),
    [sym_non_null_expression] = STATE(1503),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4150),
    [sym_optional_tuple_parameter] = STATE(4150),
    [sym_optional_type] = STATE(4150),
    [sym_rest_type] = STATE(4150),
    [sym__tuple_type_member] = STATE(4150),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_type_arguments] = STATE(435),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4227),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(3985),
    [aux_sym_array_pattern_repeat1] = STATE(3982),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(648),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(652),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(654),
    [anon_sym_RBRACK] = ACTIONS(692),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(67),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(81),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(92),
    [sym_number] = ACTIONS(94),
    [sym_this] = ACTIONS(672),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(100),
    [sym_false] = ACTIONS(100),
    [sym_null] = ACTIONS(100),
    [sym_undefined] = ACTIONS(674),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_readonly] = ACTIONS(676),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_override] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(680),
    [anon_sym_number] = ACTIONS(680),
    [anon_sym_boolean] = ACTIONS(680),
    [anon_sym_string] = ACTIONS(680),
    [anon_sym_symbol] = ACTIONS(680),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_component] = ACTIONS(120),
  },
  [69] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2136),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(3992),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3137),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1503),
    [sym_subscript_expression] = STATE(1503),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_spread_element] = STATE(3991),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(2288),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3653),
    [sym_pattern] = STATE(3829),
    [sym_rest_pattern] = STATE(3546),
    [sym_non_null_expression] = STATE(1503),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4019),
    [sym_optional_tuple_parameter] = STATE(4019),
    [sym_optional_type] = STATE(4019),
    [sym_rest_type] = STATE(4019),
    [sym__tuple_type_member] = STATE(4019),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_type_arguments] = STATE(435),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4227),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(3985),
    [aux_sym_array_pattern_repeat1] = STATE(3982),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(642),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(648),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(652),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(654),
    [anon_sym_RBRACK] = ACTIONS(694),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(67),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(81),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(92),
    [sym_number] = ACTIONS(94),
    [sym_this] = ACTIONS(672),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(100),
    [sym_false] = ACTIONS(100),
    [sym_null] = ACTIONS(100),
    [sym_undefined] = ACTIONS(674),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_readonly] = ACTIONS(676),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_override] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(680),
    [anon_sym_number] = ACTIONS(680),
    [anon_sym_boolean] = ACTIONS(680),
    [anon_sym_string] = ACTIONS(680),
    [anon_sym_symbol] = ACTIONS(680),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_component] = ACTIONS(120),
  },
  [70] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(1917),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3530),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3530),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3137),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym__formal_parameter] = STATE(4020),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1496),
    [sym_subscript_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3530),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4734),
    [sym_string] = STATE(2183),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3653),
    [sym_pattern] = STATE(3652),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1496),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_nested_type_identifier] = STATE(2754),
    [sym_accessibility_modifier] = STATE(147),
    [sym_override_modifier] = STATE(161),
    [sym_required_parameter] = STATE(4020),
    [sym_optional_parameter] = STATE(4020),
    [sym__parameter_name] = STATE(3279),
    [sym__type] = STATE(3733),
    [sym_constructor_type] = STATE(3733),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3733),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_type_arguments] = STATE(379),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4227),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3733),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3733),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(700),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(702),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(706),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(712),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(714),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(720),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(726),
    [sym_number] = ACTIONS(728),
    [sym_this] = ACTIONS(730),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(732),
    [sym_false] = ACTIONS(732),
    [sym_null] = ACTIONS(732),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_readonly] = ACTIONS(738),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(740),
    [anon_sym_private] = ACTIONS(740),
    [anon_sym_protected] = ACTIONS(740),
    [anon_sym_override] = ACTIONS(742),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(744),
    [anon_sym_number] = ACTIONS(744),
    [anon_sym_boolean] = ACTIONS(744),
    [anon_sym_string] = ACTIONS(744),
    [anon_sym_symbol] = ACTIONS(744),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_component] = ACTIONS(120),
  },
  [71] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(1917),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3530),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3530),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3137),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym__formal_parameter] = STATE(4020),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1496),
    [sym_subscript_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3530),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4734),
    [sym_string] = STATE(2183),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3653),
    [sym_pattern] = STATE(3652),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1496),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_nested_type_identifier] = STATE(2754),
    [sym_accessibility_modifier] = STATE(147),
    [sym_override_modifier] = STATE(161),
    [sym_required_parameter] = STATE(4020),
    [sym_optional_parameter] = STATE(4020),
    [sym__parameter_name] = STATE(3279),
    [sym__type] = STATE(3809),
    [sym_constructor_type] = STATE(3809),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3809),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_type_arguments] = STATE(379),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4227),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3809),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3809),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(700),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(702),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(706),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(712),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(714),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(718),
    [anon_sym_DASH] = ACTIONS(718),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(720),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(726),
    [sym_number] = ACTIONS(728),
    [sym_this] = ACTIONS(730),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(732),
    [sym_false] = ACTIONS(732),
    [sym_null] = ACTIONS(732),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_readonly] = ACTIONS(738),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(740),
    [anon_sym_private] = ACTIONS(740),
    [anon_sym_protected] = ACTIONS(740),
    [anon_sym_override] = ACTIONS(742),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(744),
    [anon_sym_number] = ACTIONS(744),
    [anon_sym_boolean] = ACTIONS(744),
    [anon_sym_string] = ACTIONS(744),
    [anon_sym_symbol] = ACTIONS(744),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_component] = ACTIONS(120),
  },
  [72] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3137),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym__formal_parameter] = STATE(4020),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(2288),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3653),
    [sym_pattern] = STATE(3652),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_nested_type_identifier] = STATE(2754),
    [sym_accessibility_modifier] = STATE(147),
    [sym_override_modifier] = STATE(161),
    [sym_required_parameter] = STATE(4020),
    [sym_optional_parameter] = STATE(4020),
    [sym__parameter_name] = STATE(3279),
    [sym__type] = STATE(3809),
    [sym_constructor_type] = STATE(3809),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3809),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_type_arguments] = STATE(435),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4227),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3809),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3809),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(32),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(706),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(48),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(67),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(81),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(92),
    [sym_number] = ACTIONS(94),
    [sym_this] = ACTIONS(746),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(100),
    [sym_false] = ACTIONS(100),
    [sym_null] = ACTIONS(100),
    [sym_undefined] = ACTIONS(102),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(748),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(750),
    [anon_sym_private] = ACTIONS(750),
    [anon_sym_protected] = ACTIONS(750),
    [anon_sym_override] = ACTIONS(752),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(108),
    [anon_sym_number] = ACTIONS(108),
    [anon_sym_boolean] = ACTIONS(108),
    [anon_sym_string] = ACTIONS(108),
    [anon_sym_symbol] = ACTIONS(108),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_component] = ACTIONS(120),
  },
  [73] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3137),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym__formal_parameter] = STATE(4020),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(2288),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3653),
    [sym_pattern] = STATE(3652),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_nested_type_identifier] = STATE(2754),
    [sym_accessibility_modifier] = STATE(147),
    [sym_override_modifier] = STATE(161),
    [sym_required_parameter] = STATE(4020),
    [sym_optional_parameter] = STATE(4020),
    [sym__parameter_name] = STATE(3279),
    [sym__type] = STATE(3889),
    [sym_constructor_type] = STATE(3889),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3889),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_type_arguments] = STATE(435),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4227),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3889),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3889),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(32),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(706),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(48),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(67),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(81),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(92),
    [sym_number] = ACTIONS(94),
    [sym_this] = ACTIONS(746),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(100),
    [sym_false] = ACTIONS(100),
    [sym_null] = ACTIONS(100),
    [sym_undefined] = ACTIONS(102),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(748),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(750),
    [anon_sym_private] = ACTIONS(750),
    [anon_sym_protected] = ACTIONS(750),
    [anon_sym_override] = ACTIONS(752),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(108),
    [anon_sym_number] = ACTIONS(108),
    [anon_sym_boolean] = ACTIONS(108),
    [anon_sym_string] = ACTIONS(108),
    [anon_sym_symbol] = ACTIONS(108),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_component] = ACTIONS(120),
  },
  [74] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3137),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym__formal_parameter] = STATE(4020),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(2288),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3653),
    [sym_pattern] = STATE(3652),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_nested_type_identifier] = STATE(2754),
    [sym_accessibility_modifier] = STATE(147),
    [sym_override_modifier] = STATE(161),
    [sym_required_parameter] = STATE(4020),
    [sym_optional_parameter] = STATE(4020),
    [sym__parameter_name] = STATE(3279),
    [sym__type] = STATE(3733),
    [sym_constructor_type] = STATE(3733),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3733),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_type_arguments] = STATE(435),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4227),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3733),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3733),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(32),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(706),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(48),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(67),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(81),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(92),
    [sym_number] = ACTIONS(94),
    [sym_this] = ACTIONS(746),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(100),
    [sym_false] = ACTIONS(100),
    [sym_null] = ACTIONS(100),
    [sym_undefined] = ACTIONS(102),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(748),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(750),
    [anon_sym_private] = ACTIONS(750),
    [anon_sym_protected] = ACTIONS(750),
    [anon_sym_override] = ACTIONS(752),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(108),
    [anon_sym_number] = ACTIONS(108),
    [anon_sym_boolean] = ACTIONS(108),
    [anon_sym_string] = ACTIONS(108),
    [anon_sym_symbol] = ACTIONS(108),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_component] = ACTIONS(120),
  },
  [75] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3137),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym__formal_parameter] = STATE(4020),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(2288),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3653),
    [sym_pattern] = STATE(3652),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_nested_type_identifier] = STATE(2754),
    [sym_accessibility_modifier] = STATE(147),
    [sym_override_modifier] = STATE(161),
    [sym_required_parameter] = STATE(4020),
    [sym_optional_parameter] = STATE(4020),
    [sym__parameter_name] = STATE(3279),
    [sym__type] = STATE(3760),
    [sym_constructor_type] = STATE(3760),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3760),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_type_arguments] = STATE(435),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4227),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3760),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3760),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(32),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(706),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(48),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(67),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(81),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(92),
    [sym_number] = ACTIONS(94),
    [sym_this] = ACTIONS(746),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(100),
    [sym_false] = ACTIONS(100),
    [sym_null] = ACTIONS(100),
    [sym_undefined] = ACTIONS(102),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(748),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(750),
    [anon_sym_private] = ACTIONS(750),
    [anon_sym_protected] = ACTIONS(750),
    [anon_sym_override] = ACTIONS(752),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(108),
    [anon_sym_number] = ACTIONS(108),
    [anon_sym_boolean] = ACTIONS(108),
    [anon_sym_string] = ACTIONS(108),
    [anon_sym_symbol] = ACTIONS(108),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_component] = ACTIONS(120),
  },
  [76] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3137),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym__formal_parameter] = STATE(4020),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(2288),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3653),
    [sym_pattern] = STATE(3652),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_nested_type_identifier] = STATE(2754),
    [sym_accessibility_modifier] = STATE(147),
    [sym_override_modifier] = STATE(161),
    [sym_required_parameter] = STATE(4020),
    [sym_optional_parameter] = STATE(4020),
    [sym__parameter_name] = STATE(3279),
    [sym__type] = STATE(3806),
    [sym_constructor_type] = STATE(3806),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3806),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_type_arguments] = STATE(435),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4227),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3806),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3806),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(32),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(706),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(48),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(67),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(81),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(92),
    [sym_number] = ACTIONS(94),
    [sym_this] = ACTIONS(746),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(100),
    [sym_false] = ACTIONS(100),
    [sym_null] = ACTIONS(100),
    [sym_undefined] = ACTIONS(102),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(748),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(750),
    [anon_sym_private] = ACTIONS(750),
    [anon_sym_protected] = ACTIONS(750),
    [anon_sym_override] = ACTIONS(752),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(108),
    [anon_sym_number] = ACTIONS(108),
    [anon_sym_boolean] = ACTIONS(108),
    [anon_sym_string] = ACTIONS(108),
    [anon_sym_symbol] = ACTIONS(108),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_component] = ACTIONS(120),
  },
  [77] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3137),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym__formal_parameter] = STATE(4020),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(2288),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3653),
    [sym_pattern] = STATE(3652),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_nested_type_identifier] = STATE(2754),
    [sym_accessibility_modifier] = STATE(147),
    [sym_override_modifier] = STATE(161),
    [sym_required_parameter] = STATE(4020),
    [sym_optional_parameter] = STATE(4020),
    [sym__parameter_name] = STATE(3279),
    [sym__type] = STATE(3772),
    [sym_constructor_type] = STATE(3772),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3772),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_type_arguments] = STATE(435),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4227),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3772),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3772),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(19),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(32),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(706),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(48),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(67),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(81),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(92),
    [sym_number] = ACTIONS(94),
    [sym_this] = ACTIONS(746),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(100),
    [sym_false] = ACTIONS(100),
    [sym_null] = ACTIONS(100),
    [sym_undefined] = ACTIONS(102),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(748),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(750),
    [anon_sym_private] = ACTIONS(750),
    [anon_sym_protected] = ACTIONS(750),
    [anon_sym_override] = ACTIONS(752),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(108),
    [anon_sym_number] = ACTIONS(108),
    [anon_sym_boolean] = ACTIONS(108),
    [anon_sym_string] = ACTIONS(108),
    [anon_sym_symbol] = ACTIONS(108),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_component] = ACTIONS(120),
  },
  [78] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(802),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_STAR] = ACTIONS(758),
    [anon_sym_as] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(762),
    [anon_sym_RBRACE] = ACTIONS(764),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(766),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_in] = ACTIONS(760),
    [anon_sym_SEMI] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_GT] = ACTIONS(760),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_DOT] = ACTIONS(760),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_QMARK_DOT] = ACTIONS(764),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP_AMP] = ACTIONS(764),
    [anon_sym_PIPE_PIPE] = ACTIONS(764),
    [anon_sym_GT_GT] = ACTIONS(760),
    [anon_sym_GT_GT_GT] = ACTIONS(764),
    [anon_sym_LT_LT] = ACTIONS(764),
    [anon_sym_AMP] = ACTIONS(788),
    [anon_sym_CARET] = ACTIONS(764),
    [anon_sym_PIPE] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_PERCENT] = ACTIONS(764),
    [anon_sym_STAR_STAR] = ACTIONS(764),
    [anon_sym_LT_EQ] = ACTIONS(764),
    [anon_sym_EQ_EQ] = ACTIONS(760),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(764),
    [anon_sym_BANG_EQ] = ACTIONS(760),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(764),
    [anon_sym_GT_EQ] = ACTIONS(764),
    [anon_sym_QMARK_QMARK] = ACTIONS(764),
    [anon_sym_instanceof] = ACTIONS(760),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_abstract] = ACTIONS(760),
    [anon_sym_satisfies] = ACTIONS(760),
    [anon_sym_infer] = ACTIONS(760),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(760),
    [anon_sym_never] = ACTIONS(760),
    [anon_sym_object] = ACTIONS(760),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
    [anon_sym_component] = ACTIONS(806),
    [anon_sym_constructor] = ACTIONS(760),
    [anon_sym_prop] = ACTIONS(760),
    [anon_sym_id] = ACTIONS(760),
    [anon_sym_event] = ACTIONS(760),
    [anon_sym_fn] = ACTIONS(760),
    [anon_sym_on] = ACTIONS(760),
    [sym__ternary_qmark] = ACTIONS(764),
  },
  [79] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1094),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_STAR] = ACTIONS(812),
    [anon_sym_as] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(762),
    [anon_sym_RBRACE] = ACTIONS(764),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(814),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_in] = ACTIONS(760),
    [anon_sym_SEMI] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_GT] = ACTIONS(760),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_DOT] = ACTIONS(760),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_QMARK_DOT] = ACTIONS(764),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP_AMP] = ACTIONS(764),
    [anon_sym_PIPE_PIPE] = ACTIONS(764),
    [anon_sym_GT_GT] = ACTIONS(760),
    [anon_sym_GT_GT_GT] = ACTIONS(764),
    [anon_sym_LT_LT] = ACTIONS(764),
    [anon_sym_AMP] = ACTIONS(788),
    [anon_sym_CARET] = ACTIONS(764),
    [anon_sym_PIPE] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_PERCENT] = ACTIONS(764),
    [anon_sym_STAR_STAR] = ACTIONS(764),
    [anon_sym_LT_EQ] = ACTIONS(764),
    [anon_sym_EQ_EQ] = ACTIONS(760),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(764),
    [anon_sym_BANG_EQ] = ACTIONS(760),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(764),
    [anon_sym_GT_EQ] = ACTIONS(764),
    [anon_sym_QMARK_QMARK] = ACTIONS(764),
    [anon_sym_instanceof] = ACTIONS(760),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_QMARK] = ACTIONS(760),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_abstract] = ACTIONS(760),
    [anon_sym_satisfies] = ACTIONS(760),
    [anon_sym_infer] = ACTIONS(760),
    [anon_sym_keyof] = ACTIONS(760),
    [anon_sym_unknown] = ACTIONS(760),
    [anon_sym_never] = ACTIONS(760),
    [anon_sym_object] = ACTIONS(760),
    [anon_sym_LBRACE_PIPE] = ACTIONS(764),
    [anon_sym_component] = ACTIONS(806),
    [anon_sym_prop] = ACTIONS(760),
    [anon_sym_id] = ACTIONS(760),
    [anon_sym_event] = ACTIONS(760),
    [anon_sym_fn] = ACTIONS(760),
    [anon_sym_on] = ACTIONS(760),
    [sym__ternary_qmark] = ACTIONS(764),
  },
  [80] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2340),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(4477),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3138),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1503),
    [sym_subscript_expression] = STATE(1503),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1891),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3691),
    [sym_pattern] = STATE(3932),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1503),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3123),
    [sym_constructor_type] = STATE(3123),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3123),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_type_arguments] = STATE(435),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4284),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3123),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3123),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(832),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(836),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(838),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(842),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(844),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(846),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(850),
    [anon_sym_DASH] = ACTIONS(850),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(852),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(854),
    [sym_number] = ACTIONS(856),
    [sym_this] = ACTIONS(858),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(860),
    [sym_false] = ACTIONS(860),
    [sym_null] = ACTIONS(860),
    [sym_undefined] = ACTIONS(862),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_readonly] = ACTIONS(864),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_override] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(868),
    [anon_sym_number] = ACTIONS(868),
    [anon_sym_boolean] = ACTIONS(868),
    [anon_sym_string] = ACTIONS(868),
    [anon_sym_symbol] = ACTIONS(868),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
    [anon_sym_component] = ACTIONS(120),
  },
  [81] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2342),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3137),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4587),
    [sym_string] = STATE(2183),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3653),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(3527),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3866),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_type_arguments] = STATE(435),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4227),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(880),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(884),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(32),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(886),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(81),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(726),
    [sym_number] = ACTIONS(728),
    [sym_this] = ACTIONS(890),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(732),
    [sym_false] = ACTIONS(732),
    [sym_null] = ACTIONS(732),
    [sym_undefined] = ACTIONS(892),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(894),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(896),
    [anon_sym_number] = ACTIONS(896),
    [anon_sym_boolean] = ACTIONS(896),
    [anon_sym_string] = ACTIONS(896),
    [anon_sym_symbol] = ACTIONS(896),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_component] = ACTIONS(120),
  },
  [82] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2173),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3137),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(2337),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3653),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3440),
    [sym_constructor_type] = STATE(3440),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3440),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_type_arguments] = STATE(404),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4227),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3440),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3440),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(898),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(902),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(904),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(912),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(918),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(920),
    [anon_sym_DASH] = ACTIONS(920),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(922),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(928),
    [sym_number] = ACTIONS(930),
    [sym_this] = ACTIONS(932),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(934),
    [sym_false] = ACTIONS(934),
    [sym_null] = ACTIONS(934),
    [sym_undefined] = ACTIONS(936),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(938),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(940),
    [anon_sym_number] = ACTIONS(940),
    [anon_sym_boolean] = ACTIONS(940),
    [anon_sym_string] = ACTIONS(940),
    [anon_sym_symbol] = ACTIONS(940),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_component] = ACTIONS(120),
  },
  [83] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3243),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3243),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3137),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3243),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(2419),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3653),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3533),
    [sym_constructor_type] = STATE(3533),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3533),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_type_arguments] = STATE(435),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4227),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3533),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3533),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(942),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(946),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_typeof] = ACTIONS(652),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(948),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(81),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(952),
    [sym_number] = ACTIONS(954),
    [sym_this] = ACTIONS(956),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(958),
    [sym_false] = ACTIONS(958),
    [sym_null] = ACTIONS(958),
    [sym_undefined] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(962),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(964),
    [anon_sym_number] = ACTIONS(964),
    [anon_sym_boolean] = ACTIONS(964),
    [anon_sym_string] = ACTIONS(964),
    [anon_sym_symbol] = ACTIONS(964),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_component] = ACTIONS(120),
  },
  [84] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1892),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3243),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3243),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3137),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1490),
    [sym_subscript_expression] = STATE(1490),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3243),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(2288),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3653),
    [sym_non_null_expression] = STATE(1490),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3533),
    [sym_constructor_type] = STATE(3533),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3533),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_type_arguments] = STATE(435),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4227),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3533),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3533),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(966),
    [anon_sym_export] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(970),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_typeof] = ACTIONS(652),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(654),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(972),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(67),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(81),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(92),
    [sym_number] = ACTIONS(94),
    [sym_this] = ACTIONS(672),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(100),
    [sym_false] = ACTIONS(100),
    [sym_null] = ACTIONS(100),
    [sym_undefined] = ACTIONS(974),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_readonly] = ACTIONS(962),
    [anon_sym_get] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(968),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_override] = ACTIONS(968),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(976),
    [anon_sym_number] = ACTIONS(976),
    [anon_sym_boolean] = ACTIONS(976),
    [anon_sym_string] = ACTIONS(976),
    [anon_sym_symbol] = ACTIONS(976),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_component] = ACTIONS(120),
  },
  [85] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(1979),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_STAR] = ACTIONS(982),
    [anon_sym_as] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_COMMA] = ACTIONS(764),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_in] = ACTIONS(760),
    [anon_sym_of] = ACTIONS(760),
    [anon_sym_SEMI] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_GT] = ACTIONS(760),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_DOT] = ACTIONS(760),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_QMARK_DOT] = ACTIONS(764),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP_AMP] = ACTIONS(764),
    [anon_sym_PIPE_PIPE] = ACTIONS(764),
    [anon_sym_GT_GT] = ACTIONS(760),
    [anon_sym_GT_GT_GT] = ACTIONS(764),
    [anon_sym_LT_LT] = ACTIONS(764),
    [anon_sym_AMP] = ACTIONS(788),
    [anon_sym_CARET] = ACTIONS(764),
    [anon_sym_PIPE] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_PERCENT] = ACTIONS(764),
    [anon_sym_STAR_STAR] = ACTIONS(764),
    [anon_sym_LT_EQ] = ACTIONS(764),
    [anon_sym_EQ_EQ] = ACTIONS(760),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(764),
    [anon_sym_BANG_EQ] = ACTIONS(760),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(764),
    [anon_sym_GT_EQ] = ACTIONS(764),
    [anon_sym_QMARK_QMARK] = ACTIONS(764),
    [anon_sym_instanceof] = ACTIONS(760),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_satisfies] = ACTIONS(760),
    [anon_sym_component] = ACTIONS(1010),
    [sym__automatic_semicolon] = ACTIONS(764),
    [sym__ternary_qmark] = ACTIONS(764),
  },
  [86] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1889),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_as] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_COMMA] = ACTIONS(764),
    [anon_sym_RBRACE] = ACTIONS(764),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(83),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(764),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_in] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_RBRACK] = ACTIONS(764),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_GT] = ACTIONS(760),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_DOT] = ACTIONS(760),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_QMARK_DOT] = ACTIONS(764),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP_AMP] = ACTIONS(764),
    [anon_sym_PIPE_PIPE] = ACTIONS(764),
    [anon_sym_GT_GT] = ACTIONS(760),
    [anon_sym_GT_GT_GT] = ACTIONS(764),
    [anon_sym_LT_LT] = ACTIONS(764),
    [anon_sym_AMP] = ACTIONS(788),
    [anon_sym_CARET] = ACTIONS(764),
    [anon_sym_PIPE] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_PERCENT] = ACTIONS(764),
    [anon_sym_STAR_STAR] = ACTIONS(764),
    [anon_sym_LT_EQ] = ACTIONS(764),
    [anon_sym_EQ_EQ] = ACTIONS(760),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(764),
    [anon_sym_BANG_EQ] = ACTIONS(760),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(764),
    [anon_sym_GT_EQ] = ACTIONS(764),
    [anon_sym_QMARK_QMARK] = ACTIONS(764),
    [anon_sym_instanceof] = ACTIONS(760),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_satisfies] = ACTIONS(760),
    [anon_sym_component] = ACTIONS(120),
    [sym__ternary_qmark] = ACTIONS(764),
  },
  [87] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(1924),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_STAR] = ACTIONS(1028),
    [anon_sym_as] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_COMMA] = ACTIONS(764),
    [anon_sym_RBRACE] = ACTIONS(764),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_in] = ACTIONS(760),
    [anon_sym_SEMI] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_GT] = ACTIONS(760),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_DOT] = ACTIONS(760),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_QMARK_DOT] = ACTIONS(764),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP_AMP] = ACTIONS(764),
    [anon_sym_PIPE_PIPE] = ACTIONS(764),
    [anon_sym_GT_GT] = ACTIONS(760),
    [anon_sym_GT_GT_GT] = ACTIONS(764),
    [anon_sym_LT_LT] = ACTIONS(764),
    [anon_sym_AMP] = ACTIONS(788),
    [anon_sym_CARET] = ACTIONS(764),
    [anon_sym_PIPE] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_PERCENT] = ACTIONS(764),
    [anon_sym_STAR_STAR] = ACTIONS(764),
    [anon_sym_LT_EQ] = ACTIONS(764),
    [anon_sym_EQ_EQ] = ACTIONS(760),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(764),
    [anon_sym_BANG_EQ] = ACTIONS(760),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(764),
    [anon_sym_GT_EQ] = ACTIONS(764),
    [anon_sym_QMARK_QMARK] = ACTIONS(764),
    [anon_sym_instanceof] = ACTIONS(760),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_satisfies] = ACTIONS(760),
    [anon_sym_component] = ACTIONS(1010),
    [sym__automatic_semicolon] = ACTIONS(764),
    [sym__ternary_qmark] = ACTIONS(764),
  },
  [88] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2114),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_STAR] = ACTIONS(1036),
    [anon_sym_as] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_COMMA] = ACTIONS(764),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(722),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(764),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_in] = ACTIONS(760),
    [anon_sym_COLON] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_GT] = ACTIONS(760),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_DOT] = ACTIONS(760),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_QMARK_DOT] = ACTIONS(764),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP_AMP] = ACTIONS(764),
    [anon_sym_PIPE_PIPE] = ACTIONS(764),
    [anon_sym_GT_GT] = ACTIONS(760),
    [anon_sym_GT_GT_GT] = ACTIONS(764),
    [anon_sym_LT_LT] = ACTIONS(764),
    [anon_sym_AMP] = ACTIONS(788),
    [anon_sym_CARET] = ACTIONS(764),
    [anon_sym_PIPE] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_PERCENT] = ACTIONS(764),
    [anon_sym_STAR_STAR] = ACTIONS(764),
    [anon_sym_LT_EQ] = ACTIONS(764),
    [anon_sym_EQ_EQ] = ACTIONS(760),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(764),
    [anon_sym_BANG_EQ] = ACTIONS(760),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(764),
    [anon_sym_GT_EQ] = ACTIONS(764),
    [anon_sym_QMARK_QMARK] = ACTIONS(764),
    [anon_sym_instanceof] = ACTIONS(760),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_satisfies] = ACTIONS(760),
    [anon_sym_component] = ACTIONS(120),
    [sym__ternary_qmark] = ACTIONS(764),
  },
  [89] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2310),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_STAR] = ACTIONS(1048),
    [anon_sym_as] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_COMMA] = ACTIONS(764),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(924),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_GT] = ACTIONS(760),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_DOT] = ACTIONS(760),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_QMARK_DOT] = ACTIONS(764),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP_AMP] = ACTIONS(764),
    [anon_sym_PIPE_PIPE] = ACTIONS(764),
    [anon_sym_GT_GT] = ACTIONS(760),
    [anon_sym_GT_GT_GT] = ACTIONS(764),
    [anon_sym_LT_LT] = ACTIONS(764),
    [anon_sym_AMP] = ACTIONS(788),
    [anon_sym_CARET] = ACTIONS(764),
    [anon_sym_PIPE] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_PERCENT] = ACTIONS(764),
    [anon_sym_STAR_STAR] = ACTIONS(764),
    [anon_sym_LT_EQ] = ACTIONS(764),
    [anon_sym_EQ_EQ] = ACTIONS(760),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(764),
    [anon_sym_BANG_EQ] = ACTIONS(760),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(764),
    [anon_sym_GT_EQ] = ACTIONS(764),
    [anon_sym_QMARK_QMARK] = ACTIONS(764),
    [anon_sym_instanceof] = ACTIONS(760),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_satisfies] = ACTIONS(760),
    [anon_sym_implements] = ACTIONS(760),
    [anon_sym_component] = ACTIONS(120),
    [sym__ternary_qmark] = ACTIONS(764),
  },
  [90] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2374),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_STAR] = ACTIONS(1058),
    [anon_sym_as] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1060),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_in] = ACTIONS(760),
    [anon_sym_of] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_GT] = ACTIONS(760),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_DOT] = ACTIONS(760),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_QMARK_DOT] = ACTIONS(764),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP_AMP] = ACTIONS(764),
    [anon_sym_PIPE_PIPE] = ACTIONS(764),
    [anon_sym_GT_GT] = ACTIONS(760),
    [anon_sym_GT_GT_GT] = ACTIONS(764),
    [anon_sym_LT_LT] = ACTIONS(764),
    [anon_sym_AMP] = ACTIONS(788),
    [anon_sym_CARET] = ACTIONS(764),
    [anon_sym_PIPE] = ACTIONS(760),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_PERCENT] = ACTIONS(764),
    [anon_sym_STAR_STAR] = ACTIONS(764),
    [anon_sym_LT_EQ] = ACTIONS(764),
    [anon_sym_EQ_EQ] = ACTIONS(760),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(764),
    [anon_sym_BANG_EQ] = ACTIONS(760),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(764),
    [anon_sym_GT_EQ] = ACTIONS(764),
    [anon_sym_QMARK_QMARK] = ACTIONS(764),
    [anon_sym_instanceof] = ACTIONS(760),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_satisfies] = ACTIONS(760),
    [anon_sym_component] = ACTIONS(120),
    [sym__ternary_qmark] = ACTIONS(764),
  },
  [91] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2023),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3530),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3530),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym__formal_parameter] = STATE(4020),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1496),
    [sym_subscript_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3530),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4713),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3652),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1496),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_accessibility_modifier] = STATE(147),
    [sym_override_modifier] = STATE(161),
    [sym_required_parameter] = STATE(4020),
    [sym_optional_parameter] = STATE(4020),
    [sym__parameter_name] = STATE(3279),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(1078),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(706),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1082),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(714),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(1084),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1086),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_readonly] = ACTIONS(1088),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(740),
    [anon_sym_private] = ACTIONS(740),
    [anon_sym_protected] = ACTIONS(740),
    [anon_sym_override] = ACTIONS(742),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [anon_sym_component] = ACTIONS(120),
  },
  [92] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(1902),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3530),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3530),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym__formal_parameter] = STATE(4020),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1496),
    [sym_subscript_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3530),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4892),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3652),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1496),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_accessibility_modifier] = STATE(147),
    [sym_override_modifier] = STATE(161),
    [sym_required_parameter] = STATE(4020),
    [sym_optional_parameter] = STATE(4020),
    [sym__parameter_name] = STATE(3279),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(1078),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(706),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1082),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(714),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(1084),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1086),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_readonly] = ACTIONS(1088),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(740),
    [anon_sym_private] = ACTIONS(740),
    [anon_sym_protected] = ACTIONS(740),
    [anon_sym_override] = ACTIONS(742),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [anon_sym_component] = ACTIONS(120),
  },
  [93] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(1917),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3530),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3530),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym__formal_parameter] = STATE(4020),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1496),
    [sym_subscript_expression] = STATE(1496),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3530),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4734),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3652),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1496),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_accessibility_modifier] = STATE(147),
    [sym_override_modifier] = STATE(161),
    [sym_required_parameter] = STATE(4020),
    [sym_optional_parameter] = STATE(4020),
    [sym__parameter_name] = STATE(3279),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(1078),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(706),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1082),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(714),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(1084),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1086),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_readonly] = ACTIONS(1088),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(740),
    [anon_sym_private] = ACTIONS(740),
    [anon_sym_protected] = ACTIONS(740),
    [anon_sym_override] = ACTIONS(742),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [anon_sym_component] = ACTIONS(120),
  },
  [94] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym__formal_parameter] = STATE(4461),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3652),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_accessibility_modifier] = STATE(147),
    [sym_override_modifier] = STATE(161),
    [sym_required_parameter] = STATE(4461),
    [sym_optional_parameter] = STATE(4461),
    [sym__parameter_name] = STATE(3279),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1090),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(1094),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(1096),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(750),
    [anon_sym_private] = ACTIONS(750),
    [anon_sym_protected] = ACTIONS(750),
    [anon_sym_override] = ACTIONS(752),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_component] = ACTIONS(120),
  },
  [95] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym__formal_parameter] = STATE(4461),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3652),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_accessibility_modifier] = STATE(147),
    [sym_override_modifier] = STATE(161),
    [sym_required_parameter] = STATE(4461),
    [sym_optional_parameter] = STATE(4461),
    [sym__parameter_name] = STATE(3279),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1098),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(1094),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(1096),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(750),
    [anon_sym_private] = ACTIONS(750),
    [anon_sym_protected] = ACTIONS(750),
    [anon_sym_override] = ACTIONS(752),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_component] = ACTIONS(120),
  },
  [96] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym__formal_parameter] = STATE(4461),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3652),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_accessibility_modifier] = STATE(147),
    [sym_override_modifier] = STATE(161),
    [sym_required_parameter] = STATE(4461),
    [sym_optional_parameter] = STATE(4461),
    [sym__parameter_name] = STATE(3279),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1100),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(1094),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(1096),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(750),
    [anon_sym_private] = ACTIONS(750),
    [anon_sym_protected] = ACTIONS(750),
    [anon_sym_override] = ACTIONS(752),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_component] = ACTIONS(120),
  },
  [97] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym__formal_parameter] = STATE(4020),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3652),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_accessibility_modifier] = STATE(147),
    [sym_override_modifier] = STATE(161),
    [sym_required_parameter] = STATE(4020),
    [sym_optional_parameter] = STATE(4020),
    [sym__parameter_name] = STATE(3279),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(706),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(1094),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(1096),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(750),
    [anon_sym_private] = ACTIONS(750),
    [anon_sym_protected] = ACTIONS(750),
    [anon_sym_override] = ACTIONS(752),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_component] = ACTIONS(120),
  },
  [98] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym__formal_parameter] = STATE(4461),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3652),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_accessibility_modifier] = STATE(147),
    [sym_override_modifier] = STATE(161),
    [sym_required_parameter] = STATE(4461),
    [sym_optional_parameter] = STATE(4461),
    [sym__parameter_name] = STATE(3279),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1102),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(1094),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(1096),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(750),
    [anon_sym_private] = ACTIONS(750),
    [anon_sym_protected] = ACTIONS(750),
    [anon_sym_override] = ACTIONS(752),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_component] = ACTIONS(120),
  },
  [99] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym__formal_parameter] = STATE(4461),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3652),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_accessibility_modifier] = STATE(147),
    [sym_override_modifier] = STATE(161),
    [sym_required_parameter] = STATE(4461),
    [sym_optional_parameter] = STATE(4461),
    [sym__parameter_name] = STATE(3279),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1104),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(1094),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(1096),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(750),
    [anon_sym_private] = ACTIONS(750),
    [anon_sym_protected] = ACTIONS(750),
    [anon_sym_override] = ACTIONS(752),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_component] = ACTIONS(120),
  },
  [100] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym__formal_parameter] = STATE(4461),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3652),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_accessibility_modifier] = STATE(147),
    [sym_override_modifier] = STATE(161),
    [sym_required_parameter] = STATE(4461),
    [sym_optional_parameter] = STATE(4461),
    [sym__parameter_name] = STATE(3279),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1106),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(1094),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(1096),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(750),
    [anon_sym_private] = ACTIONS(750),
    [anon_sym_protected] = ACTIONS(750),
    [anon_sym_override] = ACTIONS(752),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_component] = ACTIONS(120),
  },
  [101] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym__formal_parameter] = STATE(4146),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3652),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_accessibility_modifier] = STATE(147),
    [sym_override_modifier] = STATE(161),
    [sym_required_parameter] = STATE(4146),
    [sym_optional_parameter] = STATE(4146),
    [sym__parameter_name] = STATE(3279),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1108),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(1094),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(1096),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(750),
    [anon_sym_private] = ACTIONS(750),
    [anon_sym_protected] = ACTIONS(750),
    [anon_sym_override] = ACTIONS(752),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_component] = ACTIONS(120),
  },
  [102] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym__formal_parameter] = STATE(4101),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3652),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_accessibility_modifier] = STATE(147),
    [sym_override_modifier] = STATE(161),
    [sym_required_parameter] = STATE(4101),
    [sym_optional_parameter] = STATE(4101),
    [sym__parameter_name] = STATE(3279),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1110),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(1094),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(1096),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(750),
    [anon_sym_private] = ACTIONS(750),
    [anon_sym_protected] = ACTIONS(750),
    [anon_sym_override] = ACTIONS(752),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_component] = ACTIONS(120),
  },
  [103] = {
    [sym_import] = STATE(2110),
    [sym_expression_statement] = STATE(142),
    [sym_variable_declaration] = STATE(142),
    [sym_lexical_declaration] = STATE(142),
    [sym_empty_statement] = STATE(142),
    [sym_parenthesized_expression] = STATE(1499),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(3983),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(3983),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1499),
    [sym_subscript_expression] = STATE(1499),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(3983),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1499),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1112),
    [anon_sym_export] = ACTIONS(1114),
    [anon_sym_LBRACE] = ACTIONS(1116),
    [anon_sym_type] = ACTIONS(1114),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_var] = ACTIONS(1118),
    [anon_sym_let] = ACTIONS(1120),
    [anon_sym_const] = ACTIONS(1120),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(1122),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1126),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1114),
    [anon_sym_readonly] = ACTIONS(1114),
    [anon_sym_get] = ACTIONS(1114),
    [anon_sym_set] = ACTIONS(1114),
    [anon_sym_declare] = ACTIONS(1114),
    [anon_sym_namespace] = ACTIONS(1114),
    [anon_sym_public] = ACTIONS(1114),
    [anon_sym_private] = ACTIONS(1114),
    [anon_sym_protected] = ACTIONS(1114),
    [anon_sym_override] = ACTIONS(1114),
    [anon_sym_module] = ACTIONS(1114),
    [anon_sym_any] = ACTIONS(1114),
    [anon_sym_number] = ACTIONS(1114),
    [anon_sym_boolean] = ACTIONS(1114),
    [anon_sym_string] = ACTIONS(1114),
    [anon_sym_symbol] = ACTIONS(1114),
    [anon_sym_component] = ACTIONS(1010),
  },
  [104] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2188),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(3992),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1503),
    [sym_subscript_expression] = STATE(1503),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_spread_element] = STATE(4126),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3829),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1503),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(4125),
    [aux_sym_array_pattern_repeat1] = STATE(3982),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_COMMA] = ACTIONS(1130),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1082),
    [anon_sym_RBRACK] = ACTIONS(1132),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_readonly] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_override] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [anon_sym_component] = ACTIONS(120),
  },
  [105] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3006),
    [sym_constructor_type] = STATE(3006),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3006),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3006),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3006),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_EQ] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(1146),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(1150),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1152),
    [anon_sym_DASH] = ACTIONS(1152),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(106),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [106] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2113),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(3992),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1503),
    [sym_subscript_expression] = STATE(1503),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_spread_element] = STATE(4126),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3829),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1503),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(4125),
    [aux_sym_array_pattern_repeat1] = STATE(3982),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_COMMA] = ACTIONS(1130),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1082),
    [anon_sym_RBRACK] = ACTIONS(1168),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_readonly] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_override] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [anon_sym_component] = ACTIONS(120),
  },
  [107] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2136),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(3992),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1503),
    [sym_subscript_expression] = STATE(1503),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_spread_element] = STATE(3991),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3829),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1503),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(3985),
    [aux_sym_array_pattern_repeat1] = STATE(3982),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_COMMA] = ACTIONS(1130),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1082),
    [anon_sym_RBRACK] = ACTIONS(1170),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_readonly] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_override] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [anon_sym_component] = ACTIONS(120),
  },
  [108] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2113),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(3992),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1503),
    [sym_subscript_expression] = STATE(1503),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_spread_element] = STATE(4126),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3829),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1503),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(4125),
    [aux_sym_array_pattern_repeat1] = STATE(3982),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_COMMA] = ACTIONS(1130),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1082),
    [anon_sym_RBRACK] = ACTIONS(1132),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_readonly] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_override] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [anon_sym_component] = ACTIONS(120),
  },
  [109] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2215),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(3992),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1503),
    [sym_subscript_expression] = STATE(1503),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_spread_element] = STATE(4052),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3829),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1503),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(4050),
    [aux_sym_array_pattern_repeat1] = STATE(3982),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_COMMA] = ACTIONS(1130),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1082),
    [anon_sym_RBRACK] = ACTIONS(1172),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_readonly] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_override] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [anon_sym_component] = ACTIONS(120),
  },
  [110] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2136),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(3992),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1503),
    [sym_subscript_expression] = STATE(1503),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_spread_element] = STATE(3991),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3829),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1503),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(3985),
    [aux_sym_array_pattern_repeat1] = STATE(3982),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_COMMA] = ACTIONS(1130),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1082),
    [anon_sym_RBRACK] = ACTIONS(1174),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_readonly] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_override] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [anon_sym_component] = ACTIONS(120),
  },
  [111] = {
    [sym_import] = STATE(2110),
    [sym_expression_statement] = STATE(145),
    [sym_variable_declaration] = STATE(145),
    [sym_lexical_declaration] = STATE(145),
    [sym_empty_statement] = STATE(145),
    [sym_parenthesized_expression] = STATE(1499),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(3983),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(3983),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1499),
    [sym_subscript_expression] = STATE(1499),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(3983),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1499),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1112),
    [anon_sym_export] = ACTIONS(1114),
    [anon_sym_LBRACE] = ACTIONS(1116),
    [anon_sym_type] = ACTIONS(1114),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_var] = ACTIONS(1118),
    [anon_sym_let] = ACTIONS(1120),
    [anon_sym_const] = ACTIONS(1120),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(1122),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1126),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1114),
    [anon_sym_readonly] = ACTIONS(1114),
    [anon_sym_get] = ACTIONS(1114),
    [anon_sym_set] = ACTIONS(1114),
    [anon_sym_declare] = ACTIONS(1114),
    [anon_sym_namespace] = ACTIONS(1114),
    [anon_sym_public] = ACTIONS(1114),
    [anon_sym_private] = ACTIONS(1114),
    [anon_sym_protected] = ACTIONS(1114),
    [anon_sym_override] = ACTIONS(1114),
    [anon_sym_module] = ACTIONS(1114),
    [anon_sym_any] = ACTIONS(1114),
    [anon_sym_number] = ACTIONS(1114),
    [anon_sym_boolean] = ACTIONS(1114),
    [anon_sym_string] = ACTIONS(1114),
    [anon_sym_symbol] = ACTIONS(1114),
    [anon_sym_component] = ACTIONS(1010),
  },
  [112] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2136),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(3992),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1503),
    [sym_subscript_expression] = STATE(1503),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_spread_element] = STATE(3991),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3829),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1503),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(3985),
    [aux_sym_array_pattern_repeat1] = STATE(3982),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_COMMA] = ACTIONS(1130),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1082),
    [anon_sym_RBRACK] = ACTIONS(1176),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_readonly] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_override] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [anon_sym_component] = ACTIONS(120),
  },
  [113] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2136),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(3992),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1503),
    [sym_subscript_expression] = STATE(1503),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_spread_element] = STATE(3991),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3829),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1503),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(3985),
    [aux_sym_array_pattern_repeat1] = STATE(3982),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_COMMA] = ACTIONS(1130),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1082),
    [anon_sym_RBRACK] = ACTIONS(1178),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_readonly] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_override] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [anon_sym_component] = ACTIONS(120),
  },
  [114] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym__formal_parameter] = STATE(4461),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3652),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_accessibility_modifier] = STATE(147),
    [sym_override_modifier] = STATE(161),
    [sym_required_parameter] = STATE(4461),
    [sym_optional_parameter] = STATE(4461),
    [sym__parameter_name] = STATE(3279),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(1094),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(1096),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(750),
    [anon_sym_private] = ACTIONS(750),
    [anon_sym_protected] = ACTIONS(750),
    [anon_sym_override] = ACTIONS(752),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_component] = ACTIONS(120),
  },
  [115] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3006),
    [sym_constructor_type] = STATE(3006),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3006),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3006),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3006),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_COMMA] = ACTIONS(1180),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(1180),
    [anon_sym_LT] = ACTIONS(1146),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(1150),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1152),
    [anon_sym_DASH] = ACTIONS(1152),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(106),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [116] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2136),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(3992),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1503),
    [sym_subscript_expression] = STATE(1503),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_spread_element] = STATE(3991),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3829),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1503),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(3985),
    [aux_sym_array_pattern_repeat1] = STATE(3982),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_COMMA] = ACTIONS(1130),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1082),
    [anon_sym_RBRACK] = ACTIONS(1187),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_readonly] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_override] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [anon_sym_component] = ACTIONS(120),
  },
  [117] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3006),
    [sym_constructor_type] = STATE(3006),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3006),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3006),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3006),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_COMMA] = ACTIONS(29),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(1146),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(1150),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1152),
    [anon_sym_DASH] = ACTIONS(1152),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(106),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [118] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2384),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(3992),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3829),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_mapped_type_clause] = STATE(4701),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_pattern_repeat1] = STATE(3982),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1189),
    [anon_sym_export] = ACTIONS(1191),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_COMMA] = ACTIONS(1193),
    [anon_sym_type] = ACTIONS(1191),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_RBRACK] = ACTIONS(1195),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1191),
    [anon_sym_readonly] = ACTIONS(1191),
    [anon_sym_get] = ACTIONS(1191),
    [anon_sym_set] = ACTIONS(1191),
    [anon_sym_declare] = ACTIONS(1191),
    [anon_sym_namespace] = ACTIONS(1191),
    [anon_sym_public] = ACTIONS(1191),
    [anon_sym_private] = ACTIONS(1191),
    [anon_sym_protected] = ACTIONS(1191),
    [anon_sym_override] = ACTIONS(1191),
    [anon_sym_module] = ACTIONS(1191),
    [anon_sym_any] = ACTIONS(1191),
    [anon_sym_number] = ACTIONS(1191),
    [anon_sym_boolean] = ACTIONS(1191),
    [anon_sym_string] = ACTIONS(1191),
    [anon_sym_symbol] = ACTIONS(1191),
    [anon_sym_component] = ACTIONS(120),
  },
  [119] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3051),
    [sym_constructor_type] = STATE(3051),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3051),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3051),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3051),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_COMMA] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(29),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(1146),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(1217),
    [anon_sym_PLUS] = ACTIONS(1219),
    [anon_sym_DASH] = ACTIONS(1219),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(1235),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [120] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3006),
    [sym_constructor_type] = STATE(3006),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3006),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3006),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3006),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(65),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(1146),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(1150),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1152),
    [anon_sym_DASH] = ACTIONS(1152),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(106),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [121] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3006),
    [sym_constructor_type] = STATE(3006),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3006),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3006),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3006),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(1146),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_EQ_GT] = ACTIONS(1239),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(1150),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1152),
    [anon_sym_DASH] = ACTIONS(1152),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(106),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_implements] = ACTIONS(25),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [122] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2146),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(4392),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1503),
    [sym_subscript_expression] = STATE(1503),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_spread_element] = STATE(3993),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3920),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1503),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_COMMA] = ACTIONS(1241),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1082),
    [anon_sym_RBRACK] = ACTIONS(1244),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_readonly] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_override] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [anon_sym_component] = ACTIONS(120),
  },
  [123] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2418),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(3992),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3829),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_pattern_repeat1] = STATE(3982),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_COMMA] = ACTIONS(1193),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_RBRACK] = ACTIONS(1195),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(21),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_override] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_component] = ACTIONS(120),
  },
  [124] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2146),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(4392),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1503),
    [sym_subscript_expression] = STATE(1503),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_spread_element] = STATE(3993),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3920),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1503),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_COMMA] = ACTIONS(1241),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1082),
    [anon_sym_RBRACK] = ACTIONS(1241),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_readonly] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_override] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [anon_sym_component] = ACTIONS(120),
  },
  [125] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1614),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_COMMA] = ACTIONS(1248),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1248),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_RBRACK] = ACTIONS(1248),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(1248),
    [anon_sym_PIPE] = ACTIONS(1248),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_QMARK] = ACTIONS(1248),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_extends] = ACTIONS(1250),
    [anon_sym_component] = ACTIONS(120),
  },
  [126] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1614),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_COMMA] = ACTIONS(1248),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(1248),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(1248),
    [anon_sym_PIPE] = ACTIONS(1250),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_extends] = ACTIONS(1250),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1248),
    [anon_sym_component] = ACTIONS(120),
    [sym__automatic_semicolon] = ACTIONS(1248),
  },
  [127] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(3992),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1514),
    [sym_subscript_expression] = STATE(1514),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3829),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1514),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_pattern_repeat1] = STATE(3982),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1252),
    [anon_sym_export] = ACTIONS(1254),
    [anon_sym_LBRACE] = ACTIONS(1256),
    [anon_sym_COMMA] = ACTIONS(1193),
    [anon_sym_type] = ACTIONS(1254),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_RBRACK] = ACTIONS(1195),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1260),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1254),
    [anon_sym_get] = ACTIONS(1254),
    [anon_sym_set] = ACTIONS(1254),
    [anon_sym_declare] = ACTIONS(1254),
    [anon_sym_namespace] = ACTIONS(1254),
    [anon_sym_public] = ACTIONS(1254),
    [anon_sym_private] = ACTIONS(1254),
    [anon_sym_protected] = ACTIONS(1254),
    [anon_sym_override] = ACTIONS(1254),
    [anon_sym_module] = ACTIONS(1254),
    [anon_sym_any] = ACTIONS(1254),
    [anon_sym_number] = ACTIONS(1254),
    [anon_sym_boolean] = ACTIONS(1254),
    [anon_sym_string] = ACTIONS(1254),
    [anon_sym_symbol] = ACTIONS(1254),
    [anon_sym_component] = ACTIONS(120),
  },
  [128] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2146),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(4392),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1503),
    [sym_subscript_expression] = STATE(1503),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_spread_element] = STATE(3993),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3920),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1503),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_COMMA] = ACTIONS(1241),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1082),
    [anon_sym_RBRACK] = ACTIONS(1264),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_readonly] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_override] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [anon_sym_component] = ACTIONS(120),
  },
  [129] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(4057),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1514),
    [sym_subscript_expression] = STATE(1514),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3799),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1514),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_pattern_repeat1] = STATE(4048),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1252),
    [anon_sym_export] = ACTIONS(1254),
    [anon_sym_LBRACE] = ACTIONS(1256),
    [anon_sym_COMMA] = ACTIONS(1193),
    [anon_sym_type] = ACTIONS(1254),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_RBRACK] = ACTIONS(1268),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1260),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1254),
    [anon_sym_get] = ACTIONS(1254),
    [anon_sym_set] = ACTIONS(1254),
    [anon_sym_declare] = ACTIONS(1254),
    [anon_sym_namespace] = ACTIONS(1254),
    [anon_sym_public] = ACTIONS(1254),
    [anon_sym_private] = ACTIONS(1254),
    [anon_sym_protected] = ACTIONS(1254),
    [anon_sym_override] = ACTIONS(1254),
    [anon_sym_module] = ACTIONS(1254),
    [anon_sym_any] = ACTIONS(1254),
    [anon_sym_number] = ACTIONS(1254),
    [anon_sym_boolean] = ACTIONS(1254),
    [anon_sym_string] = ACTIONS(1254),
    [anon_sym_symbol] = ACTIONS(1254),
    [anon_sym_component] = ACTIONS(120),
  },
  [130] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(4392),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1514),
    [sym_subscript_expression] = STATE(1514),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3920),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1514),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1252),
    [anon_sym_export] = ACTIONS(1254),
    [anon_sym_LBRACE] = ACTIONS(1256),
    [anon_sym_COMMA] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(1254),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_RBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1260),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1254),
    [anon_sym_readonly] = ACTIONS(1254),
    [anon_sym_get] = ACTIONS(1254),
    [anon_sym_set] = ACTIONS(1254),
    [anon_sym_declare] = ACTIONS(1254),
    [anon_sym_namespace] = ACTIONS(1254),
    [anon_sym_public] = ACTIONS(1254),
    [anon_sym_private] = ACTIONS(1254),
    [anon_sym_protected] = ACTIONS(1254),
    [anon_sym_override] = ACTIONS(1254),
    [anon_sym_module] = ACTIONS(1254),
    [anon_sym_any] = ACTIONS(1254),
    [anon_sym_number] = ACTIONS(1254),
    [anon_sym_boolean] = ACTIONS(1254),
    [anon_sym_string] = ACTIONS(1254),
    [anon_sym_symbol] = ACTIONS(1254),
    [anon_sym_component] = ACTIONS(120),
  },
  [131] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2117),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_spread_element] = STATE(4114),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(4109),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_COMMA] = ACTIONS(1272),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1274),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [132] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2243),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_spread_element] = STATE(4022),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(4023),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_COMMA] = ACTIONS(1272),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1278),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [133] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2096),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_spread_element] = STATE(3911),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(3912),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_COMMA] = ACTIONS(1272),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1280),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [134] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2306),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_spread_element] = STATE(4117),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(4116),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_COMMA] = ACTIONS(1272),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1282),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [135] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2263),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_spread_element] = STATE(4132),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(4138),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_COMMA] = ACTIONS(1272),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1284),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [136] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2094),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_spread_element] = STATE(4090),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(4089),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_COMMA] = ACTIONS(1272),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1286),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [137] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2119),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_spread_element] = STATE(4112),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(4113),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_COMMA] = ACTIONS(1272),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1288),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [138] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2146),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_spread_element] = STATE(3993),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1290),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_RBRACK] = ACTIONS(1290),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [139] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2262),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_spread_element] = STATE(4083),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(4082),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_COMMA] = ACTIONS(1272),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1292),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [140] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2105),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_spread_element] = STATE(4054),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_array_repeat1] = STATE(4036),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_COMMA] = ACTIONS(1272),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1294),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1276),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [141] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3536),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_accessibility_modifier] = STATE(143),
    [sym_override_modifier] = STATE(159),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3860),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(1449),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(1296),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(1298),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(736),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(1300),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(750),
    [anon_sym_private] = ACTIONS(750),
    [anon_sym_protected] = ACTIONS(750),
    [anon_sym_override] = ACTIONS(752),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_component] = ACTIONS(1302),
  },
  [142] = {
    [sym_import] = STATE(2110),
    [sym_expression_statement] = STATE(210),
    [sym_empty_statement] = STATE(210),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [143] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3640),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_override_modifier] = STATE(151),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(1304),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(1306),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_override] = ACTIONS(752),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_component] = ACTIONS(120),
  },
  [144] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2340),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(4477),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1503),
    [sym_subscript_expression] = STATE(1503),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3932),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1503),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_export] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1082),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1134),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(644),
    [anon_sym_readonly] = ACTIONS(644),
    [anon_sym_get] = ACTIONS(644),
    [anon_sym_set] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(644),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_public] = ACTIONS(644),
    [anon_sym_private] = ACTIONS(644),
    [anon_sym_protected] = ACTIONS(644),
    [anon_sym_override] = ACTIONS(644),
    [anon_sym_module] = ACTIONS(644),
    [anon_sym_any] = ACTIONS(644),
    [anon_sym_number] = ACTIONS(644),
    [anon_sym_boolean] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_symbol] = ACTIONS(644),
    [anon_sym_component] = ACTIONS(120),
  },
  [145] = {
    [sym_import] = STATE(2110),
    [sym_expression_statement] = STATE(199),
    [sym_empty_statement] = STATE(199),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2211),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4503),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [146] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_assignment_pattern] = STATE(4477),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3932),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(21),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_override] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_component] = ACTIONS(120),
  },
  [147] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3543),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_override_modifier] = STATE(160),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(630),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_override] = ACTIONS(752),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_component] = ACTIONS(120),
  },
  [148] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(1614),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_COMMA] = ACTIONS(1248),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_GT] = ACTIONS(1248),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(1248),
    [anon_sym_PIPE] = ACTIONS(1248),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_extends] = ACTIONS(1250),
    [anon_sym_component] = ACTIONS(120),
  },
  [149] = {
    [sym__call_signature] = STATE(4691),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(1310),
    [anon_sym_export] = ACTIONS(1313),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_RBRACE] = ACTIONS(65),
    [anon_sym_type] = ACTIONS(1313),
    [anon_sym_typeof] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(1324),
    [anon_sym_EQ_GT] = ACTIONS(1326),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(25),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_void] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(65),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(65),
    [sym_number] = ACTIONS(65),
    [sym_this] = ACTIONS(25),
    [sym_true] = ACTIONS(25),
    [sym_false] = ACTIONS(25),
    [sym_null] = ACTIONS(25),
    [sym_undefined] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(1321),
    [anon_sym_readonly] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_QMARK] = ACTIONS(25),
    [anon_sym_declare] = ACTIONS(1313),
    [anon_sym_namespace] = ACTIONS(1313),
    [anon_sym_public] = ACTIONS(1313),
    [anon_sym_private] = ACTIONS(1313),
    [anon_sym_protected] = ACTIONS(1313),
    [anon_sym_override] = ACTIONS(1313),
    [anon_sym_module] = ACTIONS(1313),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_abstract] = ACTIONS(25),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_infer] = ACTIONS(25),
    [anon_sym_keyof] = ACTIONS(25),
    [anon_sym_unknown] = ACTIONS(25),
    [anon_sym_never] = ACTIONS(25),
    [anon_sym_object] = ACTIONS(25),
    [anon_sym_LBRACE_PIPE] = ACTIONS(65),
    [anon_sym_constructor] = ACTIONS(25),
    [anon_sym_prop] = ACTIONS(25),
    [anon_sym_id] = ACTIONS(25),
    [anon_sym_event] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_on] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [150] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(1614),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1248),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1248),
    [anon_sym_PIPE] = ACTIONS(1248),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_extends] = ACTIONS(1250),
    [anon_sym_component] = ACTIONS(120),
  },
  [151] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3668),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(1328),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(1330),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_override] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_component] = ACTIONS(120),
  },
  [152] = {
    [sym_import] = STATE(1756),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1614),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym__type_query_member_expression] = STATE(2701),
    [sym__type_query_subscript_expression] = STATE(2702),
    [sym__type_query_call_expression] = STATE(2740),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [153] = {
    [sym_import] = STATE(2388),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1614),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym__type_query_member_expression] = STATE(2768),
    [sym__type_query_subscript_expression] = STATE(2766),
    [sym__type_query_call_expression] = STATE(2891),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1334),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [154] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2181),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4437),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
    [sym__automatic_semicolon] = ACTIONS(1336),
  },
  [155] = {
    [sym__call_signature] = STATE(4691),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(1310),
    [anon_sym_export] = ACTIONS(1313),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_RBRACE] = ACTIONS(65),
    [anon_sym_type] = ACTIONS(1313),
    [anon_sym_typeof] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(1324),
    [anon_sym_EQ_GT] = ACTIONS(1326),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(25),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_void] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(65),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(65),
    [sym_number] = ACTIONS(65),
    [sym_this] = ACTIONS(25),
    [sym_true] = ACTIONS(25),
    [sym_false] = ACTIONS(25),
    [sym_null] = ACTIONS(25),
    [sym_undefined] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(1321),
    [anon_sym_readonly] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_QMARK] = ACTIONS(25),
    [anon_sym_declare] = ACTIONS(1313),
    [anon_sym_namespace] = ACTIONS(1313),
    [anon_sym_public] = ACTIONS(1313),
    [anon_sym_private] = ACTIONS(1313),
    [anon_sym_protected] = ACTIONS(1313),
    [anon_sym_override] = ACTIONS(1313),
    [anon_sym_module] = ACTIONS(1313),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_abstract] = ACTIONS(25),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_infer] = ACTIONS(25),
    [anon_sym_keyof] = ACTIONS(25),
    [anon_sym_unknown] = ACTIONS(25),
    [anon_sym_never] = ACTIONS(25),
    [anon_sym_object] = ACTIONS(25),
    [anon_sym_LBRACE_PIPE] = ACTIONS(65),
    [anon_sym_constructor] = ACTIONS(25),
    [anon_sym_prop] = ACTIONS(25),
    [anon_sym_id] = ACTIONS(25),
    [anon_sym_event] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_on] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [156] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1522),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4151),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4151),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1522),
    [sym_subscript_expression] = STATE(1522),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4151),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1522),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1340),
    [anon_sym_export] = ACTIONS(1342),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_type] = ACTIONS(1342),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_var] = ACTIONS(1346),
    [anon_sym_let] = ACTIONS(1348),
    [anon_sym_const] = ACTIONS(1348),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1350),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1352),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1342),
    [anon_sym_readonly] = ACTIONS(1342),
    [anon_sym_get] = ACTIONS(1342),
    [anon_sym_set] = ACTIONS(1342),
    [anon_sym_declare] = ACTIONS(1342),
    [anon_sym_namespace] = ACTIONS(1342),
    [anon_sym_public] = ACTIONS(1342),
    [anon_sym_private] = ACTIONS(1342),
    [anon_sym_protected] = ACTIONS(1342),
    [anon_sym_override] = ACTIONS(1342),
    [anon_sym_module] = ACTIONS(1342),
    [anon_sym_any] = ACTIONS(1342),
    [anon_sym_number] = ACTIONS(1342),
    [anon_sym_boolean] = ACTIONS(1342),
    [anon_sym_string] = ACTIONS(1342),
    [anon_sym_symbol] = ACTIONS(1342),
    [anon_sym_component] = ACTIONS(120),
  },
  [157] = {
    [sym_import] = STATE(1756),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1614),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym__type_query_member_expression] = STATE(2701),
    [sym__type_query_subscript_expression] = STATE(2702),
    [sym__type_query_call_expression] = STATE(2740),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [158] = {
    [sym_import] = STATE(1756),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(1614),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym__type_query_member_expression] = STATE(2701),
    [sym__type_query_subscript_expression] = STATE(2702),
    [sym__type_query_call_expression] = STATE(2740),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1358),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [159] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3641),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(1360),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(1362),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_override] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_component] = ACTIONS(120),
  },
  [160] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3628),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(640),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(1364),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_override] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_component] = ACTIONS(120),
  },
  [161] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3283),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3283),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1452),
    [sym_subscript_expression] = STATE(1452),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3283),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_pattern] = STATE(3543),
    [sym_rest_pattern] = STATE(3282),
    [sym_non_null_expression] = STATE(1452),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_export] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_type] = ACTIONS(21),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(59),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(630),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_readonly] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(21),
    [anon_sym_set] = ACTIONS(21),
    [anon_sym_declare] = ACTIONS(21),
    [anon_sym_namespace] = ACTIONS(21),
    [anon_sym_public] = ACTIONS(21),
    [anon_sym_private] = ACTIONS(21),
    [anon_sym_protected] = ACTIONS(21),
    [anon_sym_override] = ACTIONS(21),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_any] = ACTIONS(21),
    [anon_sym_number] = ACTIONS(21),
    [anon_sym_boolean] = ACTIONS(21),
    [anon_sym_string] = ACTIONS(21),
    [anon_sym_symbol] = ACTIONS(21),
    [anon_sym_component] = ACTIONS(120),
  },
  [162] = {
    [sym_identifier] = ACTIONS(1366),
    [anon_sym_export] = ACTIONS(1366),
    [anon_sym_STAR] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(1368),
    [anon_sym_LBRACE] = ACTIONS(1370),
    [anon_sym_COMMA] = ACTIONS(1372),
    [anon_sym_RBRACE] = ACTIONS(1370),
    [anon_sym_type] = ACTIONS(1366),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_import] = ACTIONS(1366),
    [anon_sym_var] = ACTIONS(1366),
    [anon_sym_let] = ACTIONS(1366),
    [anon_sym_const] = ACTIONS(1366),
    [anon_sym_BANG] = ACTIONS(1366),
    [anon_sym_else] = ACTIONS(1366),
    [anon_sym_if] = ACTIONS(1366),
    [anon_sym_switch] = ACTIONS(1366),
    [anon_sym_for] = ACTIONS(1366),
    [anon_sym_LPAREN] = ACTIONS(1370),
    [anon_sym_await] = ACTIONS(1366),
    [anon_sym_in] = ACTIONS(1368),
    [anon_sym_while] = ACTIONS(1366),
    [anon_sym_do] = ACTIONS(1366),
    [anon_sym_try] = ACTIONS(1366),
    [anon_sym_with] = ACTIONS(1366),
    [anon_sym_break] = ACTIONS(1366),
    [anon_sym_continue] = ACTIONS(1366),
    [anon_sym_debugger] = ACTIONS(1366),
    [anon_sym_return] = ACTIONS(1366),
    [anon_sym_throw] = ACTIONS(1366),
    [anon_sym_SEMI] = ACTIONS(1370),
    [anon_sym_case] = ACTIONS(1366),
    [anon_sym_default] = ACTIONS(1366),
    [anon_sym_yield] = ACTIONS(1366),
    [anon_sym_EQ] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_LTtemplate_GT] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(1368),
    [anon_sym_SLASH] = ACTIONS(1366),
    [anon_sym_DOT] = ACTIONS(1368),
    [anon_sym_class] = ACTIONS(1366),
    [anon_sym_async] = ACTIONS(1366),
    [anon_sym_function] = ACTIONS(1366),
    [anon_sym_QMARK_DOT] = ACTIONS(1372),
    [anon_sym_new] = ACTIONS(1366),
    [anon_sym_AMP_AMP] = ACTIONS(1372),
    [anon_sym_PIPE_PIPE] = ACTIONS(1372),
    [anon_sym_GT_GT] = ACTIONS(1368),
    [anon_sym_GT_GT_GT] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1366),
    [anon_sym_CARET] = ACTIONS(1372),
    [anon_sym_PIPE] = ACTIONS(1368),
    [anon_sym_PLUS] = ACTIONS(1366),
    [anon_sym_DASH] = ACTIONS(1366),
    [anon_sym_PERCENT] = ACTIONS(1372),
    [anon_sym_STAR_STAR] = ACTIONS(1372),
    [anon_sym_LT_EQ] = ACTIONS(1372),
    [anon_sym_EQ_EQ] = ACTIONS(1368),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1372),
    [anon_sym_BANG_EQ] = ACTIONS(1368),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1372),
    [anon_sym_GT_EQ] = ACTIONS(1372),
    [anon_sym_QMARK_QMARK] = ACTIONS(1372),
    [anon_sym_instanceof] = ACTIONS(1368),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1366),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_DQUOTE] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1370),
    [sym_number] = ACTIONS(1370),
    [sym_this] = ACTIONS(1366),
    [sym_super] = ACTIONS(1366),
    [sym_true] = ACTIONS(1366),
    [sym_false] = ACTIONS(1366),
    [sym_null] = ACTIONS(1366),
    [sym_undefined] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(1370),
    [anon_sym_static] = ACTIONS(1366),
    [anon_sym_readonly] = ACTIONS(1366),
    [anon_sym_get] = ACTIONS(1366),
    [anon_sym_set] = ACTIONS(1366),
    [anon_sym_declare] = ACTIONS(1366),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_public] = ACTIONS(1366),
    [anon_sym_private] = ACTIONS(1366),
    [anon_sym_protected] = ACTIONS(1366),
    [anon_sym_override] = ACTIONS(1366),
    [anon_sym_module] = ACTIONS(1366),
    [anon_sym_any] = ACTIONS(1366),
    [anon_sym_number] = ACTIONS(1366),
    [anon_sym_boolean] = ACTIONS(1366),
    [anon_sym_string] = ACTIONS(1366),
    [anon_sym_symbol] = ACTIONS(1366),
    [anon_sym_abstract] = ACTIONS(1366),
    [anon_sym_satisfies] = ACTIONS(1368),
    [anon_sym_interface] = ACTIONS(1366),
    [anon_sym_enum] = ACTIONS(1366),
    [anon_sym_component] = ACTIONS(1366),
    [sym__automatic_semicolon] = ACTIONS(1376),
    [sym__ternary_qmark] = ACTIONS(1372),
  },
  [163] = {
    [sym_import] = STATE(1756),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(1614),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym__type_query_member_expression] = STATE(2701),
    [sym__type_query_subscript_expression] = STATE(2702),
    [sym__type_query_call_expression] = STATE(2740),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1378),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [164] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1541),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1076),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_property_assignment_expression] = STATE(1541),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [165] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1574),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1076),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_property_assignment_expression] = STATE(1574),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [166] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1575),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1076),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_property_assignment_expression] = STATE(1575),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [167] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1562),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1076),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_property_assignment_expression] = STATE(1562),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [168] = {
    [sym_identifier] = ACTIONS(1382),
    [anon_sym_export] = ACTIONS(1382),
    [anon_sym_STAR] = ACTIONS(1384),
    [anon_sym_as] = ACTIONS(1384),
    [anon_sym_LBRACE] = ACTIONS(1386),
    [anon_sym_COMMA] = ACTIONS(1388),
    [anon_sym_RBRACE] = ACTIONS(1386),
    [anon_sym_type] = ACTIONS(1382),
    [anon_sym_typeof] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(1382),
    [anon_sym_var] = ACTIONS(1382),
    [anon_sym_let] = ACTIONS(1382),
    [anon_sym_const] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1382),
    [anon_sym_else] = ACTIONS(1382),
    [anon_sym_if] = ACTIONS(1382),
    [anon_sym_switch] = ACTIONS(1382),
    [anon_sym_for] = ACTIONS(1382),
    [anon_sym_LPAREN] = ACTIONS(1386),
    [anon_sym_await] = ACTIONS(1382),
    [anon_sym_in] = ACTIONS(1384),
    [anon_sym_while] = ACTIONS(1382),
    [anon_sym_do] = ACTIONS(1382),
    [anon_sym_try] = ACTIONS(1382),
    [anon_sym_with] = ACTIONS(1382),
    [anon_sym_break] = ACTIONS(1382),
    [anon_sym_continue] = ACTIONS(1382),
    [anon_sym_debugger] = ACTIONS(1382),
    [anon_sym_return] = ACTIONS(1382),
    [anon_sym_throw] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1386),
    [anon_sym_case] = ACTIONS(1382),
    [anon_sym_default] = ACTIONS(1382),
    [anon_sym_yield] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(1386),
    [anon_sym_LTtemplate_GT] = ACTIONS(1386),
    [anon_sym_LT] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1384),
    [anon_sym_SLASH] = ACTIONS(1382),
    [anon_sym_DOT] = ACTIONS(1384),
    [anon_sym_class] = ACTIONS(1382),
    [anon_sym_async] = ACTIONS(1382),
    [anon_sym_function] = ACTIONS(1382),
    [anon_sym_QMARK_DOT] = ACTIONS(1388),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_AMP_AMP] = ACTIONS(1388),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_GT_GT] = ACTIONS(1384),
    [anon_sym_GT_GT_GT] = ACTIONS(1388),
    [anon_sym_LT_LT] = ACTIONS(1388),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_PIPE] = ACTIONS(1384),
    [anon_sym_PLUS] = ACTIONS(1382),
    [anon_sym_DASH] = ACTIONS(1382),
    [anon_sym_PERCENT] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1388),
    [anon_sym_LT_EQ] = ACTIONS(1388),
    [anon_sym_EQ_EQ] = ACTIONS(1384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1388),
    [anon_sym_BANG_EQ] = ACTIONS(1384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1388),
    [anon_sym_GT_EQ] = ACTIONS(1388),
    [anon_sym_QMARK_QMARK] = ACTIONS(1388),
    [anon_sym_instanceof] = ACTIONS(1384),
    [anon_sym_TILDE] = ACTIONS(1386),
    [anon_sym_void] = ACTIONS(1382),
    [anon_sym_delete] = ACTIONS(1382),
    [anon_sym_PLUS_PLUS] = ACTIONS(1386),
    [anon_sym_DASH_DASH] = ACTIONS(1386),
    [anon_sym_DQUOTE] = ACTIONS(1386),
    [anon_sym_SQUOTE] = ACTIONS(1386),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1386),
    [sym_number] = ACTIONS(1386),
    [sym_this] = ACTIONS(1382),
    [sym_super] = ACTIONS(1382),
    [sym_true] = ACTIONS(1382),
    [sym_false] = ACTIONS(1382),
    [sym_null] = ACTIONS(1382),
    [sym_undefined] = ACTIONS(1382),
    [anon_sym_AT] = ACTIONS(1386),
    [anon_sym_static] = ACTIONS(1382),
    [anon_sym_readonly] = ACTIONS(1382),
    [anon_sym_get] = ACTIONS(1382),
    [anon_sym_set] = ACTIONS(1382),
    [anon_sym_declare] = ACTIONS(1382),
    [anon_sym_namespace] = ACTIONS(1382),
    [anon_sym_public] = ACTIONS(1382),
    [anon_sym_private] = ACTIONS(1382),
    [anon_sym_protected] = ACTIONS(1382),
    [anon_sym_override] = ACTIONS(1382),
    [anon_sym_module] = ACTIONS(1382),
    [anon_sym_any] = ACTIONS(1382),
    [anon_sym_number] = ACTIONS(1382),
    [anon_sym_boolean] = ACTIONS(1382),
    [anon_sym_string] = ACTIONS(1382),
    [anon_sym_symbol] = ACTIONS(1382),
    [anon_sym_abstract] = ACTIONS(1382),
    [anon_sym_satisfies] = ACTIONS(1384),
    [anon_sym_interface] = ACTIONS(1382),
    [anon_sym_enum] = ACTIONS(1382),
    [anon_sym_component] = ACTIONS(1382),
    [sym__automatic_semicolon] = ACTIONS(1390),
    [sym__ternary_qmark] = ACTIONS(1388),
  },
  [169] = {
    [sym_identifier] = ACTIONS(1392),
    [anon_sym_export] = ACTIONS(1392),
    [anon_sym_STAR] = ACTIONS(1394),
    [anon_sym_as] = ACTIONS(1394),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_COMMA] = ACTIONS(1398),
    [anon_sym_RBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(1392),
    [anon_sym_typeof] = ACTIONS(1392),
    [anon_sym_import] = ACTIONS(1392),
    [anon_sym_var] = ACTIONS(1392),
    [anon_sym_let] = ACTIONS(1392),
    [anon_sym_const] = ACTIONS(1392),
    [anon_sym_BANG] = ACTIONS(1392),
    [anon_sym_else] = ACTIONS(1392),
    [anon_sym_if] = ACTIONS(1392),
    [anon_sym_switch] = ACTIONS(1392),
    [anon_sym_for] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_await] = ACTIONS(1392),
    [anon_sym_in] = ACTIONS(1394),
    [anon_sym_while] = ACTIONS(1392),
    [anon_sym_do] = ACTIONS(1392),
    [anon_sym_try] = ACTIONS(1392),
    [anon_sym_with] = ACTIONS(1392),
    [anon_sym_break] = ACTIONS(1392),
    [anon_sym_continue] = ACTIONS(1392),
    [anon_sym_debugger] = ACTIONS(1392),
    [anon_sym_return] = ACTIONS(1392),
    [anon_sym_throw] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1396),
    [anon_sym_case] = ACTIONS(1392),
    [anon_sym_default] = ACTIONS(1392),
    [anon_sym_yield] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(1396),
    [anon_sym_LTtemplate_GT] = ACTIONS(1396),
    [anon_sym_LT] = ACTIONS(1392),
    [anon_sym_GT] = ACTIONS(1394),
    [anon_sym_SLASH] = ACTIONS(1392),
    [anon_sym_DOT] = ACTIONS(1394),
    [anon_sym_class] = ACTIONS(1392),
    [anon_sym_async] = ACTIONS(1392),
    [anon_sym_function] = ACTIONS(1392),
    [anon_sym_QMARK_DOT] = ACTIONS(1398),
    [anon_sym_new] = ACTIONS(1392),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_GT_GT] = ACTIONS(1394),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1392),
    [anon_sym_CARET] = ACTIONS(1398),
    [anon_sym_PIPE] = ACTIONS(1394),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_STAR_STAR] = ACTIONS(1398),
    [anon_sym_LT_EQ] = ACTIONS(1398),
    [anon_sym_EQ_EQ] = ACTIONS(1394),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1398),
    [anon_sym_BANG_EQ] = ACTIONS(1394),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1398),
    [anon_sym_GT_EQ] = ACTIONS(1398),
    [anon_sym_QMARK_QMARK] = ACTIONS(1398),
    [anon_sym_instanceof] = ACTIONS(1394),
    [anon_sym_TILDE] = ACTIONS(1396),
    [anon_sym_void] = ACTIONS(1392),
    [anon_sym_delete] = ACTIONS(1392),
    [anon_sym_PLUS_PLUS] = ACTIONS(1396),
    [anon_sym_DASH_DASH] = ACTIONS(1396),
    [anon_sym_DQUOTE] = ACTIONS(1396),
    [anon_sym_SQUOTE] = ACTIONS(1396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1396),
    [sym_number] = ACTIONS(1396),
    [sym_this] = ACTIONS(1392),
    [sym_super] = ACTIONS(1392),
    [sym_true] = ACTIONS(1392),
    [sym_false] = ACTIONS(1392),
    [sym_null] = ACTIONS(1392),
    [sym_undefined] = ACTIONS(1392),
    [anon_sym_AT] = ACTIONS(1396),
    [anon_sym_static] = ACTIONS(1392),
    [anon_sym_readonly] = ACTIONS(1392),
    [anon_sym_get] = ACTIONS(1392),
    [anon_sym_set] = ACTIONS(1392),
    [anon_sym_declare] = ACTIONS(1392),
    [anon_sym_namespace] = ACTIONS(1392),
    [anon_sym_public] = ACTIONS(1392),
    [anon_sym_private] = ACTIONS(1392),
    [anon_sym_protected] = ACTIONS(1392),
    [anon_sym_override] = ACTIONS(1392),
    [anon_sym_module] = ACTIONS(1392),
    [anon_sym_any] = ACTIONS(1392),
    [anon_sym_number] = ACTIONS(1392),
    [anon_sym_boolean] = ACTIONS(1392),
    [anon_sym_string] = ACTIONS(1392),
    [anon_sym_symbol] = ACTIONS(1392),
    [anon_sym_abstract] = ACTIONS(1392),
    [anon_sym_satisfies] = ACTIONS(1394),
    [anon_sym_interface] = ACTIONS(1392),
    [anon_sym_enum] = ACTIONS(1392),
    [anon_sym_component] = ACTIONS(1392),
    [sym__automatic_semicolon] = ACTIONS(1400),
    [sym__ternary_qmark] = ACTIONS(1398),
  },
  [170] = {
    [sym_identifier] = ACTIONS(1402),
    [anon_sym_export] = ACTIONS(1402),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_as] = ACTIONS(1404),
    [anon_sym_LBRACE] = ACTIONS(1406),
    [anon_sym_COMMA] = ACTIONS(1408),
    [anon_sym_RBRACE] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1402),
    [anon_sym_typeof] = ACTIONS(1402),
    [anon_sym_import] = ACTIONS(1402),
    [anon_sym_var] = ACTIONS(1402),
    [anon_sym_let] = ACTIONS(1402),
    [anon_sym_const] = ACTIONS(1402),
    [anon_sym_BANG] = ACTIONS(1402),
    [anon_sym_else] = ACTIONS(1402),
    [anon_sym_if] = ACTIONS(1402),
    [anon_sym_switch] = ACTIONS(1402),
    [anon_sym_for] = ACTIONS(1402),
    [anon_sym_LPAREN] = ACTIONS(1406),
    [anon_sym_await] = ACTIONS(1402),
    [anon_sym_in] = ACTIONS(1404),
    [anon_sym_while] = ACTIONS(1402),
    [anon_sym_do] = ACTIONS(1402),
    [anon_sym_try] = ACTIONS(1402),
    [anon_sym_with] = ACTIONS(1402),
    [anon_sym_break] = ACTIONS(1402),
    [anon_sym_continue] = ACTIONS(1402),
    [anon_sym_debugger] = ACTIONS(1402),
    [anon_sym_return] = ACTIONS(1402),
    [anon_sym_throw] = ACTIONS(1402),
    [anon_sym_SEMI] = ACTIONS(1406),
    [anon_sym_case] = ACTIONS(1402),
    [anon_sym_default] = ACTIONS(1402),
    [anon_sym_yield] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1406),
    [anon_sym_LTtemplate_GT] = ACTIONS(1406),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_GT] = ACTIONS(1404),
    [anon_sym_SLASH] = ACTIONS(1402),
    [anon_sym_DOT] = ACTIONS(1404),
    [anon_sym_class] = ACTIONS(1402),
    [anon_sym_async] = ACTIONS(1402),
    [anon_sym_function] = ACTIONS(1402),
    [anon_sym_QMARK_DOT] = ACTIONS(1408),
    [anon_sym_new] = ACTIONS(1402),
    [anon_sym_AMP_AMP] = ACTIONS(1408),
    [anon_sym_PIPE_PIPE] = ACTIONS(1408),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_GT_GT_GT] = ACTIONS(1408),
    [anon_sym_LT_LT] = ACTIONS(1408),
    [anon_sym_AMP] = ACTIONS(1402),
    [anon_sym_CARET] = ACTIONS(1408),
    [anon_sym_PIPE] = ACTIONS(1404),
    [anon_sym_PLUS] = ACTIONS(1402),
    [anon_sym_DASH] = ACTIONS(1402),
    [anon_sym_PERCENT] = ACTIONS(1408),
    [anon_sym_STAR_STAR] = ACTIONS(1408),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_EQ_EQ] = ACTIONS(1404),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1408),
    [anon_sym_BANG_EQ] = ACTIONS(1404),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1408),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_QMARK_QMARK] = ACTIONS(1408),
    [anon_sym_instanceof] = ACTIONS(1404),
    [anon_sym_TILDE] = ACTIONS(1406),
    [anon_sym_void] = ACTIONS(1402),
    [anon_sym_delete] = ACTIONS(1402),
    [anon_sym_PLUS_PLUS] = ACTIONS(1406),
    [anon_sym_DASH_DASH] = ACTIONS(1406),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_SQUOTE] = ACTIONS(1406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1406),
    [sym_number] = ACTIONS(1406),
    [sym_this] = ACTIONS(1402),
    [sym_super] = ACTIONS(1402),
    [sym_true] = ACTIONS(1402),
    [sym_false] = ACTIONS(1402),
    [sym_null] = ACTIONS(1402),
    [sym_undefined] = ACTIONS(1402),
    [anon_sym_AT] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1402),
    [anon_sym_readonly] = ACTIONS(1402),
    [anon_sym_get] = ACTIONS(1402),
    [anon_sym_set] = ACTIONS(1402),
    [anon_sym_declare] = ACTIONS(1402),
    [anon_sym_namespace] = ACTIONS(1402),
    [anon_sym_public] = ACTIONS(1402),
    [anon_sym_private] = ACTIONS(1402),
    [anon_sym_protected] = ACTIONS(1402),
    [anon_sym_override] = ACTIONS(1402),
    [anon_sym_module] = ACTIONS(1402),
    [anon_sym_any] = ACTIONS(1402),
    [anon_sym_number] = ACTIONS(1402),
    [anon_sym_boolean] = ACTIONS(1402),
    [anon_sym_string] = ACTIONS(1402),
    [anon_sym_symbol] = ACTIONS(1402),
    [anon_sym_abstract] = ACTIONS(1402),
    [anon_sym_satisfies] = ACTIONS(1404),
    [anon_sym_interface] = ACTIONS(1402),
    [anon_sym_enum] = ACTIONS(1402),
    [anon_sym_component] = ACTIONS(1402),
    [sym__automatic_semicolon] = ACTIONS(1410),
    [sym__ternary_qmark] = ACTIONS(1408),
  },
  [171] = {
    [sym_identifier] = ACTIONS(1412),
    [anon_sym_export] = ACTIONS(1412),
    [anon_sym_STAR] = ACTIONS(1414),
    [anon_sym_as] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(1416),
    [anon_sym_COMMA] = ACTIONS(1418),
    [anon_sym_RBRACE] = ACTIONS(1416),
    [anon_sym_type] = ACTIONS(1412),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_import] = ACTIONS(1412),
    [anon_sym_var] = ACTIONS(1412),
    [anon_sym_let] = ACTIONS(1412),
    [anon_sym_const] = ACTIONS(1412),
    [anon_sym_BANG] = ACTIONS(1412),
    [anon_sym_else] = ACTIONS(1412),
    [anon_sym_if] = ACTIONS(1412),
    [anon_sym_switch] = ACTIONS(1412),
    [anon_sym_for] = ACTIONS(1412),
    [anon_sym_LPAREN] = ACTIONS(1416),
    [anon_sym_await] = ACTIONS(1412),
    [anon_sym_in] = ACTIONS(1414),
    [anon_sym_while] = ACTIONS(1412),
    [anon_sym_do] = ACTIONS(1412),
    [anon_sym_try] = ACTIONS(1412),
    [anon_sym_with] = ACTIONS(1412),
    [anon_sym_break] = ACTIONS(1412),
    [anon_sym_continue] = ACTIONS(1412),
    [anon_sym_debugger] = ACTIONS(1412),
    [anon_sym_return] = ACTIONS(1412),
    [anon_sym_throw] = ACTIONS(1412),
    [anon_sym_SEMI] = ACTIONS(1416),
    [anon_sym_case] = ACTIONS(1412),
    [anon_sym_default] = ACTIONS(1412),
    [anon_sym_yield] = ACTIONS(1412),
    [anon_sym_LBRACK] = ACTIONS(1416),
    [anon_sym_LTtemplate_GT] = ACTIONS(1416),
    [anon_sym_LT] = ACTIONS(1412),
    [anon_sym_GT] = ACTIONS(1414),
    [anon_sym_SLASH] = ACTIONS(1412),
    [anon_sym_DOT] = ACTIONS(1414),
    [anon_sym_class] = ACTIONS(1412),
    [anon_sym_async] = ACTIONS(1412),
    [anon_sym_function] = ACTIONS(1412),
    [anon_sym_QMARK_DOT] = ACTIONS(1418),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_PIPE_PIPE] = ACTIONS(1418),
    [anon_sym_GT_GT] = ACTIONS(1414),
    [anon_sym_GT_GT_GT] = ACTIONS(1418),
    [anon_sym_LT_LT] = ACTIONS(1418),
    [anon_sym_AMP] = ACTIONS(1412),
    [anon_sym_CARET] = ACTIONS(1418),
    [anon_sym_PIPE] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1412),
    [anon_sym_DASH] = ACTIONS(1412),
    [anon_sym_PERCENT] = ACTIONS(1418),
    [anon_sym_STAR_STAR] = ACTIONS(1418),
    [anon_sym_LT_EQ] = ACTIONS(1418),
    [anon_sym_EQ_EQ] = ACTIONS(1414),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1418),
    [anon_sym_BANG_EQ] = ACTIONS(1414),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1418),
    [anon_sym_GT_EQ] = ACTIONS(1418),
    [anon_sym_QMARK_QMARK] = ACTIONS(1418),
    [anon_sym_instanceof] = ACTIONS(1414),
    [anon_sym_TILDE] = ACTIONS(1416),
    [anon_sym_void] = ACTIONS(1412),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_PLUS_PLUS] = ACTIONS(1416),
    [anon_sym_DASH_DASH] = ACTIONS(1416),
    [anon_sym_DQUOTE] = ACTIONS(1416),
    [anon_sym_SQUOTE] = ACTIONS(1416),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [sym_number] = ACTIONS(1416),
    [sym_this] = ACTIONS(1412),
    [sym_super] = ACTIONS(1412),
    [sym_true] = ACTIONS(1412),
    [sym_false] = ACTIONS(1412),
    [sym_null] = ACTIONS(1412),
    [sym_undefined] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(1416),
    [anon_sym_static] = ACTIONS(1412),
    [anon_sym_readonly] = ACTIONS(1412),
    [anon_sym_get] = ACTIONS(1412),
    [anon_sym_set] = ACTIONS(1412),
    [anon_sym_declare] = ACTIONS(1412),
    [anon_sym_namespace] = ACTIONS(1412),
    [anon_sym_public] = ACTIONS(1412),
    [anon_sym_private] = ACTIONS(1412),
    [anon_sym_protected] = ACTIONS(1412),
    [anon_sym_override] = ACTIONS(1412),
    [anon_sym_module] = ACTIONS(1412),
    [anon_sym_any] = ACTIONS(1412),
    [anon_sym_number] = ACTIONS(1412),
    [anon_sym_boolean] = ACTIONS(1412),
    [anon_sym_string] = ACTIONS(1412),
    [anon_sym_symbol] = ACTIONS(1412),
    [anon_sym_abstract] = ACTIONS(1412),
    [anon_sym_satisfies] = ACTIONS(1414),
    [anon_sym_interface] = ACTIONS(1412),
    [anon_sym_enum] = ACTIONS(1412),
    [anon_sym_component] = ACTIONS(1412),
    [sym__automatic_semicolon] = ACTIONS(1420),
    [sym__ternary_qmark] = ACTIONS(1418),
  },
  [172] = {
    [sym_identifier] = ACTIONS(1422),
    [anon_sym_export] = ACTIONS(1422),
    [anon_sym_STAR] = ACTIONS(1424),
    [anon_sym_as] = ACTIONS(1424),
    [anon_sym_LBRACE] = ACTIONS(1426),
    [anon_sym_COMMA] = ACTIONS(1428),
    [anon_sym_RBRACE] = ACTIONS(1426),
    [anon_sym_type] = ACTIONS(1422),
    [anon_sym_typeof] = ACTIONS(1422),
    [anon_sym_import] = ACTIONS(1422),
    [anon_sym_var] = ACTIONS(1422),
    [anon_sym_let] = ACTIONS(1422),
    [anon_sym_const] = ACTIONS(1422),
    [anon_sym_BANG] = ACTIONS(1422),
    [anon_sym_else] = ACTIONS(1422),
    [anon_sym_if] = ACTIONS(1422),
    [anon_sym_switch] = ACTIONS(1422),
    [anon_sym_for] = ACTIONS(1422),
    [anon_sym_LPAREN] = ACTIONS(1426),
    [anon_sym_await] = ACTIONS(1422),
    [anon_sym_in] = ACTIONS(1424),
    [anon_sym_while] = ACTIONS(1422),
    [anon_sym_do] = ACTIONS(1422),
    [anon_sym_try] = ACTIONS(1422),
    [anon_sym_with] = ACTIONS(1422),
    [anon_sym_break] = ACTIONS(1422),
    [anon_sym_continue] = ACTIONS(1422),
    [anon_sym_debugger] = ACTIONS(1422),
    [anon_sym_return] = ACTIONS(1422),
    [anon_sym_throw] = ACTIONS(1422),
    [anon_sym_SEMI] = ACTIONS(1426),
    [anon_sym_case] = ACTIONS(1422),
    [anon_sym_default] = ACTIONS(1422),
    [anon_sym_yield] = ACTIONS(1422),
    [anon_sym_LBRACK] = ACTIONS(1426),
    [anon_sym_LTtemplate_GT] = ACTIONS(1426),
    [anon_sym_LT] = ACTIONS(1422),
    [anon_sym_GT] = ACTIONS(1424),
    [anon_sym_SLASH] = ACTIONS(1422),
    [anon_sym_DOT] = ACTIONS(1424),
    [anon_sym_class] = ACTIONS(1422),
    [anon_sym_async] = ACTIONS(1422),
    [anon_sym_function] = ACTIONS(1422),
    [anon_sym_QMARK_DOT] = ACTIONS(1428),
    [anon_sym_new] = ACTIONS(1422),
    [anon_sym_AMP_AMP] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1428),
    [anon_sym_GT_GT] = ACTIONS(1424),
    [anon_sym_GT_GT_GT] = ACTIONS(1428),
    [anon_sym_LT_LT] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1422),
    [anon_sym_CARET] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1424),
    [anon_sym_PLUS] = ACTIONS(1422),
    [anon_sym_DASH] = ACTIONS(1422),
    [anon_sym_PERCENT] = ACTIONS(1428),
    [anon_sym_STAR_STAR] = ACTIONS(1428),
    [anon_sym_LT_EQ] = ACTIONS(1428),
    [anon_sym_EQ_EQ] = ACTIONS(1424),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1428),
    [anon_sym_BANG_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1428),
    [anon_sym_GT_EQ] = ACTIONS(1428),
    [anon_sym_QMARK_QMARK] = ACTIONS(1428),
    [anon_sym_instanceof] = ACTIONS(1424),
    [anon_sym_TILDE] = ACTIONS(1426),
    [anon_sym_void] = ACTIONS(1422),
    [anon_sym_delete] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1426),
    [anon_sym_DASH_DASH] = ACTIONS(1426),
    [anon_sym_DQUOTE] = ACTIONS(1426),
    [anon_sym_SQUOTE] = ACTIONS(1426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1426),
    [sym_number] = ACTIONS(1426),
    [sym_this] = ACTIONS(1422),
    [sym_super] = ACTIONS(1422),
    [sym_true] = ACTIONS(1422),
    [sym_false] = ACTIONS(1422),
    [sym_null] = ACTIONS(1422),
    [sym_undefined] = ACTIONS(1422),
    [anon_sym_AT] = ACTIONS(1426),
    [anon_sym_static] = ACTIONS(1422),
    [anon_sym_readonly] = ACTIONS(1422),
    [anon_sym_get] = ACTIONS(1422),
    [anon_sym_set] = ACTIONS(1422),
    [anon_sym_declare] = ACTIONS(1422),
    [anon_sym_namespace] = ACTIONS(1422),
    [anon_sym_public] = ACTIONS(1422),
    [anon_sym_private] = ACTIONS(1422),
    [anon_sym_protected] = ACTIONS(1422),
    [anon_sym_override] = ACTIONS(1422),
    [anon_sym_module] = ACTIONS(1422),
    [anon_sym_any] = ACTIONS(1422),
    [anon_sym_number] = ACTIONS(1422),
    [anon_sym_boolean] = ACTIONS(1422),
    [anon_sym_string] = ACTIONS(1422),
    [anon_sym_symbol] = ACTIONS(1422),
    [anon_sym_abstract] = ACTIONS(1422),
    [anon_sym_satisfies] = ACTIONS(1424),
    [anon_sym_interface] = ACTIONS(1422),
    [anon_sym_enum] = ACTIONS(1422),
    [anon_sym_component] = ACTIONS(1422),
    [sym__automatic_semicolon] = ACTIONS(1430),
    [sym__ternary_qmark] = ACTIONS(1428),
  },
  [173] = {
    [sym_identifier] = ACTIONS(1432),
    [anon_sym_export] = ACTIONS(1432),
    [anon_sym_STAR] = ACTIONS(1434),
    [anon_sym_as] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1436),
    [anon_sym_COMMA] = ACTIONS(1438),
    [anon_sym_RBRACE] = ACTIONS(1436),
    [anon_sym_type] = ACTIONS(1432),
    [anon_sym_typeof] = ACTIONS(1432),
    [anon_sym_import] = ACTIONS(1432),
    [anon_sym_var] = ACTIONS(1432),
    [anon_sym_let] = ACTIONS(1432),
    [anon_sym_const] = ACTIONS(1432),
    [anon_sym_BANG] = ACTIONS(1432),
    [anon_sym_else] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1432),
    [anon_sym_switch] = ACTIONS(1432),
    [anon_sym_for] = ACTIONS(1432),
    [anon_sym_LPAREN] = ACTIONS(1436),
    [anon_sym_await] = ACTIONS(1432),
    [anon_sym_in] = ACTIONS(1434),
    [anon_sym_while] = ACTIONS(1432),
    [anon_sym_do] = ACTIONS(1432),
    [anon_sym_try] = ACTIONS(1432),
    [anon_sym_with] = ACTIONS(1432),
    [anon_sym_break] = ACTIONS(1432),
    [anon_sym_continue] = ACTIONS(1432),
    [anon_sym_debugger] = ACTIONS(1432),
    [anon_sym_return] = ACTIONS(1432),
    [anon_sym_throw] = ACTIONS(1432),
    [anon_sym_SEMI] = ACTIONS(1436),
    [anon_sym_case] = ACTIONS(1432),
    [anon_sym_default] = ACTIONS(1432),
    [anon_sym_yield] = ACTIONS(1432),
    [anon_sym_LBRACK] = ACTIONS(1436),
    [anon_sym_LTtemplate_GT] = ACTIONS(1436),
    [anon_sym_LT] = ACTIONS(1432),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_SLASH] = ACTIONS(1432),
    [anon_sym_DOT] = ACTIONS(1434),
    [anon_sym_class] = ACTIONS(1432),
    [anon_sym_async] = ACTIONS(1432),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_QMARK_DOT] = ACTIONS(1438),
    [anon_sym_new] = ACTIONS(1432),
    [anon_sym_AMP_AMP] = ACTIONS(1438),
    [anon_sym_PIPE_PIPE] = ACTIONS(1438),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [anon_sym_GT_GT_GT] = ACTIONS(1438),
    [anon_sym_LT_LT] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1432),
    [anon_sym_CARET] = ACTIONS(1438),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1432),
    [anon_sym_DASH] = ACTIONS(1432),
    [anon_sym_PERCENT] = ACTIONS(1438),
    [anon_sym_STAR_STAR] = ACTIONS(1438),
    [anon_sym_LT_EQ] = ACTIONS(1438),
    [anon_sym_EQ_EQ] = ACTIONS(1434),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1438),
    [anon_sym_BANG_EQ] = ACTIONS(1434),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1438),
    [anon_sym_GT_EQ] = ACTIONS(1438),
    [anon_sym_QMARK_QMARK] = ACTIONS(1438),
    [anon_sym_instanceof] = ACTIONS(1434),
    [anon_sym_TILDE] = ACTIONS(1436),
    [anon_sym_void] = ACTIONS(1432),
    [anon_sym_delete] = ACTIONS(1432),
    [anon_sym_PLUS_PLUS] = ACTIONS(1436),
    [anon_sym_DASH_DASH] = ACTIONS(1436),
    [anon_sym_DQUOTE] = ACTIONS(1436),
    [anon_sym_SQUOTE] = ACTIONS(1436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1436),
    [sym_number] = ACTIONS(1436),
    [sym_this] = ACTIONS(1432),
    [sym_super] = ACTIONS(1432),
    [sym_true] = ACTIONS(1432),
    [sym_false] = ACTIONS(1432),
    [sym_null] = ACTIONS(1432),
    [sym_undefined] = ACTIONS(1432),
    [anon_sym_AT] = ACTIONS(1436),
    [anon_sym_static] = ACTIONS(1432),
    [anon_sym_readonly] = ACTIONS(1432),
    [anon_sym_get] = ACTIONS(1432),
    [anon_sym_set] = ACTIONS(1432),
    [anon_sym_declare] = ACTIONS(1432),
    [anon_sym_namespace] = ACTIONS(1432),
    [anon_sym_public] = ACTIONS(1432),
    [anon_sym_private] = ACTIONS(1432),
    [anon_sym_protected] = ACTIONS(1432),
    [anon_sym_override] = ACTIONS(1432),
    [anon_sym_module] = ACTIONS(1432),
    [anon_sym_any] = ACTIONS(1432),
    [anon_sym_number] = ACTIONS(1432),
    [anon_sym_boolean] = ACTIONS(1432),
    [anon_sym_string] = ACTIONS(1432),
    [anon_sym_symbol] = ACTIONS(1432),
    [anon_sym_abstract] = ACTIONS(1432),
    [anon_sym_satisfies] = ACTIONS(1434),
    [anon_sym_interface] = ACTIONS(1432),
    [anon_sym_enum] = ACTIONS(1432),
    [anon_sym_component] = ACTIONS(1432),
    [sym__automatic_semicolon] = ACTIONS(1440),
    [sym__ternary_qmark] = ACTIONS(1438),
  },
  [174] = {
    [sym_identifier] = ACTIONS(1442),
    [anon_sym_export] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_as] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_COMMA] = ACTIONS(1448),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [anon_sym_type] = ACTIONS(1442),
    [anon_sym_typeof] = ACTIONS(1442),
    [anon_sym_import] = ACTIONS(1442),
    [anon_sym_var] = ACTIONS(1442),
    [anon_sym_let] = ACTIONS(1442),
    [anon_sym_const] = ACTIONS(1442),
    [anon_sym_BANG] = ACTIONS(1442),
    [anon_sym_else] = ACTIONS(1442),
    [anon_sym_if] = ACTIONS(1442),
    [anon_sym_switch] = ACTIONS(1442),
    [anon_sym_for] = ACTIONS(1442),
    [anon_sym_LPAREN] = ACTIONS(1446),
    [anon_sym_await] = ACTIONS(1442),
    [anon_sym_in] = ACTIONS(1444),
    [anon_sym_while] = ACTIONS(1442),
    [anon_sym_do] = ACTIONS(1442),
    [anon_sym_try] = ACTIONS(1442),
    [anon_sym_with] = ACTIONS(1442),
    [anon_sym_break] = ACTIONS(1442),
    [anon_sym_continue] = ACTIONS(1442),
    [anon_sym_debugger] = ACTIONS(1442),
    [anon_sym_return] = ACTIONS(1442),
    [anon_sym_throw] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_case] = ACTIONS(1442),
    [anon_sym_default] = ACTIONS(1442),
    [anon_sym_yield] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_LTtemplate_GT] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1444),
    [anon_sym_SLASH] = ACTIONS(1442),
    [anon_sym_DOT] = ACTIONS(1444),
    [anon_sym_class] = ACTIONS(1442),
    [anon_sym_async] = ACTIONS(1442),
    [anon_sym_function] = ACTIONS(1442),
    [anon_sym_QMARK_DOT] = ACTIONS(1448),
    [anon_sym_new] = ACTIONS(1442),
    [anon_sym_AMP_AMP] = ACTIONS(1448),
    [anon_sym_PIPE_PIPE] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_GT_GT_GT] = ACTIONS(1448),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1442),
    [anon_sym_CARET] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1444),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_PERCENT] = ACTIONS(1448),
    [anon_sym_STAR_STAR] = ACTIONS(1448),
    [anon_sym_LT_EQ] = ACTIONS(1448),
    [anon_sym_EQ_EQ] = ACTIONS(1444),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1448),
    [anon_sym_BANG_EQ] = ACTIONS(1444),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1448),
    [anon_sym_GT_EQ] = ACTIONS(1448),
    [anon_sym_QMARK_QMARK] = ACTIONS(1448),
    [anon_sym_instanceof] = ACTIONS(1444),
    [anon_sym_TILDE] = ACTIONS(1446),
    [anon_sym_void] = ACTIONS(1442),
    [anon_sym_delete] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1446),
    [anon_sym_DASH_DASH] = ACTIONS(1446),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [anon_sym_SQUOTE] = ACTIONS(1446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [sym_number] = ACTIONS(1446),
    [sym_this] = ACTIONS(1442),
    [sym_super] = ACTIONS(1442),
    [sym_true] = ACTIONS(1442),
    [sym_false] = ACTIONS(1442),
    [sym_null] = ACTIONS(1442),
    [sym_undefined] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(1446),
    [anon_sym_static] = ACTIONS(1442),
    [anon_sym_readonly] = ACTIONS(1442),
    [anon_sym_get] = ACTIONS(1442),
    [anon_sym_set] = ACTIONS(1442),
    [anon_sym_declare] = ACTIONS(1442),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_public] = ACTIONS(1442),
    [anon_sym_private] = ACTIONS(1442),
    [anon_sym_protected] = ACTIONS(1442),
    [anon_sym_override] = ACTIONS(1442),
    [anon_sym_module] = ACTIONS(1442),
    [anon_sym_any] = ACTIONS(1442),
    [anon_sym_number] = ACTIONS(1442),
    [anon_sym_boolean] = ACTIONS(1442),
    [anon_sym_string] = ACTIONS(1442),
    [anon_sym_symbol] = ACTIONS(1442),
    [anon_sym_abstract] = ACTIONS(1442),
    [anon_sym_satisfies] = ACTIONS(1444),
    [anon_sym_interface] = ACTIONS(1442),
    [anon_sym_enum] = ACTIONS(1442),
    [anon_sym_component] = ACTIONS(1442),
    [sym__automatic_semicolon] = ACTIONS(1450),
    [sym__ternary_qmark] = ACTIONS(1448),
  },
  [175] = {
    [sym_identifier] = ACTIONS(1452),
    [anon_sym_export] = ACTIONS(1452),
    [anon_sym_STAR] = ACTIONS(1454),
    [anon_sym_as] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [anon_sym_COMMA] = ACTIONS(1458),
    [anon_sym_RBRACE] = ACTIONS(1456),
    [anon_sym_type] = ACTIONS(1452),
    [anon_sym_typeof] = ACTIONS(1452),
    [anon_sym_import] = ACTIONS(1452),
    [anon_sym_var] = ACTIONS(1452),
    [anon_sym_let] = ACTIONS(1452),
    [anon_sym_const] = ACTIONS(1452),
    [anon_sym_BANG] = ACTIONS(1452),
    [anon_sym_else] = ACTIONS(1452),
    [anon_sym_if] = ACTIONS(1452),
    [anon_sym_switch] = ACTIONS(1452),
    [anon_sym_for] = ACTIONS(1452),
    [anon_sym_LPAREN] = ACTIONS(1456),
    [anon_sym_await] = ACTIONS(1452),
    [anon_sym_in] = ACTIONS(1454),
    [anon_sym_while] = ACTIONS(1452),
    [anon_sym_do] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(1452),
    [anon_sym_with] = ACTIONS(1452),
    [anon_sym_break] = ACTIONS(1452),
    [anon_sym_continue] = ACTIONS(1452),
    [anon_sym_debugger] = ACTIONS(1452),
    [anon_sym_return] = ACTIONS(1452),
    [anon_sym_throw] = ACTIONS(1452),
    [anon_sym_SEMI] = ACTIONS(1456),
    [anon_sym_case] = ACTIONS(1452),
    [anon_sym_default] = ACTIONS(1452),
    [anon_sym_yield] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1456),
    [anon_sym_LTtemplate_GT] = ACTIONS(1456),
    [anon_sym_LT] = ACTIONS(1452),
    [anon_sym_GT] = ACTIONS(1454),
    [anon_sym_SLASH] = ACTIONS(1452),
    [anon_sym_DOT] = ACTIONS(1454),
    [anon_sym_class] = ACTIONS(1452),
    [anon_sym_async] = ACTIONS(1452),
    [anon_sym_function] = ACTIONS(1452),
    [anon_sym_QMARK_DOT] = ACTIONS(1458),
    [anon_sym_new] = ACTIONS(1452),
    [anon_sym_AMP_AMP] = ACTIONS(1458),
    [anon_sym_PIPE_PIPE] = ACTIONS(1458),
    [anon_sym_GT_GT] = ACTIONS(1454),
    [anon_sym_GT_GT_GT] = ACTIONS(1458),
    [anon_sym_LT_LT] = ACTIONS(1458),
    [anon_sym_AMP] = ACTIONS(1452),
    [anon_sym_CARET] = ACTIONS(1458),
    [anon_sym_PIPE] = ACTIONS(1454),
    [anon_sym_PLUS] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1452),
    [anon_sym_PERCENT] = ACTIONS(1458),
    [anon_sym_STAR_STAR] = ACTIONS(1458),
    [anon_sym_LT_EQ] = ACTIONS(1458),
    [anon_sym_EQ_EQ] = ACTIONS(1454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1458),
    [anon_sym_BANG_EQ] = ACTIONS(1454),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1458),
    [anon_sym_GT_EQ] = ACTIONS(1458),
    [anon_sym_QMARK_QMARK] = ACTIONS(1458),
    [anon_sym_instanceof] = ACTIONS(1454),
    [anon_sym_TILDE] = ACTIONS(1456),
    [anon_sym_void] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1452),
    [anon_sym_PLUS_PLUS] = ACTIONS(1456),
    [anon_sym_DASH_DASH] = ACTIONS(1456),
    [anon_sym_DQUOTE] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(1456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1456),
    [sym_number] = ACTIONS(1456),
    [sym_this] = ACTIONS(1452),
    [sym_super] = ACTIONS(1452),
    [sym_true] = ACTIONS(1452),
    [sym_false] = ACTIONS(1452),
    [sym_null] = ACTIONS(1452),
    [sym_undefined] = ACTIONS(1452),
    [anon_sym_AT] = ACTIONS(1456),
    [anon_sym_static] = ACTIONS(1452),
    [anon_sym_readonly] = ACTIONS(1452),
    [anon_sym_get] = ACTIONS(1452),
    [anon_sym_set] = ACTIONS(1452),
    [anon_sym_declare] = ACTIONS(1452),
    [anon_sym_namespace] = ACTIONS(1452),
    [anon_sym_public] = ACTIONS(1452),
    [anon_sym_private] = ACTIONS(1452),
    [anon_sym_protected] = ACTIONS(1452),
    [anon_sym_override] = ACTIONS(1452),
    [anon_sym_module] = ACTIONS(1452),
    [anon_sym_any] = ACTIONS(1452),
    [anon_sym_number] = ACTIONS(1452),
    [anon_sym_boolean] = ACTIONS(1452),
    [anon_sym_string] = ACTIONS(1452),
    [anon_sym_symbol] = ACTIONS(1452),
    [anon_sym_abstract] = ACTIONS(1452),
    [anon_sym_satisfies] = ACTIONS(1454),
    [anon_sym_interface] = ACTIONS(1452),
    [anon_sym_enum] = ACTIONS(1452),
    [anon_sym_component] = ACTIONS(1452),
    [sym__automatic_semicolon] = ACTIONS(1460),
    [sym__ternary_qmark] = ACTIONS(1458),
  },
  [176] = {
    [sym_identifier] = ACTIONS(1462),
    [anon_sym_export] = ACTIONS(1462),
    [anon_sym_STAR] = ACTIONS(1464),
    [anon_sym_as] = ACTIONS(1464),
    [anon_sym_LBRACE] = ACTIONS(1466),
    [anon_sym_COMMA] = ACTIONS(1468),
    [anon_sym_RBRACE] = ACTIONS(1466),
    [anon_sym_type] = ACTIONS(1462),
    [anon_sym_typeof] = ACTIONS(1462),
    [anon_sym_import] = ACTIONS(1462),
    [anon_sym_var] = ACTIONS(1462),
    [anon_sym_let] = ACTIONS(1462),
    [anon_sym_const] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_else] = ACTIONS(1462),
    [anon_sym_if] = ACTIONS(1462),
    [anon_sym_switch] = ACTIONS(1462),
    [anon_sym_for] = ACTIONS(1462),
    [anon_sym_LPAREN] = ACTIONS(1466),
    [anon_sym_await] = ACTIONS(1462),
    [anon_sym_in] = ACTIONS(1464),
    [anon_sym_while] = ACTIONS(1462),
    [anon_sym_do] = ACTIONS(1462),
    [anon_sym_try] = ACTIONS(1462),
    [anon_sym_with] = ACTIONS(1462),
    [anon_sym_break] = ACTIONS(1462),
    [anon_sym_continue] = ACTIONS(1462),
    [anon_sym_debugger] = ACTIONS(1462),
    [anon_sym_return] = ACTIONS(1462),
    [anon_sym_throw] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1466),
    [anon_sym_case] = ACTIONS(1462),
    [anon_sym_default] = ACTIONS(1462),
    [anon_sym_yield] = ACTIONS(1462),
    [anon_sym_LBRACK] = ACTIONS(1466),
    [anon_sym_LTtemplate_GT] = ACTIONS(1466),
    [anon_sym_LT] = ACTIONS(1462),
    [anon_sym_GT] = ACTIONS(1464),
    [anon_sym_SLASH] = ACTIONS(1462),
    [anon_sym_DOT] = ACTIONS(1464),
    [anon_sym_class] = ACTIONS(1462),
    [anon_sym_async] = ACTIONS(1462),
    [anon_sym_function] = ACTIONS(1462),
    [anon_sym_QMARK_DOT] = ACTIONS(1468),
    [anon_sym_new] = ACTIONS(1462),
    [anon_sym_AMP_AMP] = ACTIONS(1468),
    [anon_sym_PIPE_PIPE] = ACTIONS(1468),
    [anon_sym_GT_GT] = ACTIONS(1464),
    [anon_sym_GT_GT_GT] = ACTIONS(1468),
    [anon_sym_LT_LT] = ACTIONS(1468),
    [anon_sym_AMP] = ACTIONS(1462),
    [anon_sym_CARET] = ACTIONS(1468),
    [anon_sym_PIPE] = ACTIONS(1464),
    [anon_sym_PLUS] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1462),
    [anon_sym_PERCENT] = ACTIONS(1468),
    [anon_sym_STAR_STAR] = ACTIONS(1468),
    [anon_sym_LT_EQ] = ACTIONS(1468),
    [anon_sym_EQ_EQ] = ACTIONS(1464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1468),
    [anon_sym_BANG_EQ] = ACTIONS(1464),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1468),
    [anon_sym_GT_EQ] = ACTIONS(1468),
    [anon_sym_QMARK_QMARK] = ACTIONS(1468),
    [anon_sym_instanceof] = ACTIONS(1464),
    [anon_sym_TILDE] = ACTIONS(1466),
    [anon_sym_void] = ACTIONS(1462),
    [anon_sym_delete] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1466),
    [anon_sym_DASH_DASH] = ACTIONS(1466),
    [anon_sym_DQUOTE] = ACTIONS(1466),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1466),
    [sym_number] = ACTIONS(1466),
    [sym_this] = ACTIONS(1462),
    [sym_super] = ACTIONS(1462),
    [sym_true] = ACTIONS(1462),
    [sym_false] = ACTIONS(1462),
    [sym_null] = ACTIONS(1462),
    [sym_undefined] = ACTIONS(1462),
    [anon_sym_AT] = ACTIONS(1466),
    [anon_sym_static] = ACTIONS(1462),
    [anon_sym_readonly] = ACTIONS(1462),
    [anon_sym_get] = ACTIONS(1462),
    [anon_sym_set] = ACTIONS(1462),
    [anon_sym_declare] = ACTIONS(1462),
    [anon_sym_namespace] = ACTIONS(1462),
    [anon_sym_public] = ACTIONS(1462),
    [anon_sym_private] = ACTIONS(1462),
    [anon_sym_protected] = ACTIONS(1462),
    [anon_sym_override] = ACTIONS(1462),
    [anon_sym_module] = ACTIONS(1462),
    [anon_sym_any] = ACTIONS(1462),
    [anon_sym_number] = ACTIONS(1462),
    [anon_sym_boolean] = ACTIONS(1462),
    [anon_sym_string] = ACTIONS(1462),
    [anon_sym_symbol] = ACTIONS(1462),
    [anon_sym_abstract] = ACTIONS(1462),
    [anon_sym_satisfies] = ACTIONS(1464),
    [anon_sym_interface] = ACTIONS(1462),
    [anon_sym_enum] = ACTIONS(1462),
    [anon_sym_component] = ACTIONS(1462),
    [sym__automatic_semicolon] = ACTIONS(1470),
    [sym__ternary_qmark] = ACTIONS(1468),
  },
  [177] = {
    [sym_identifier] = ACTIONS(1472),
    [anon_sym_export] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_as] = ACTIONS(1474),
    [anon_sym_LBRACE] = ACTIONS(1476),
    [anon_sym_COMMA] = ACTIONS(1478),
    [anon_sym_RBRACE] = ACTIONS(1476),
    [anon_sym_type] = ACTIONS(1472),
    [anon_sym_typeof] = ACTIONS(1472),
    [anon_sym_import] = ACTIONS(1472),
    [anon_sym_var] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1472),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_else] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_switch] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_in] = ACTIONS(1474),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_do] = ACTIONS(1472),
    [anon_sym_try] = ACTIONS(1472),
    [anon_sym_with] = ACTIONS(1472),
    [anon_sym_break] = ACTIONS(1472),
    [anon_sym_continue] = ACTIONS(1472),
    [anon_sym_debugger] = ACTIONS(1472),
    [anon_sym_return] = ACTIONS(1472),
    [anon_sym_throw] = ACTIONS(1472),
    [anon_sym_SEMI] = ACTIONS(1476),
    [anon_sym_case] = ACTIONS(1472),
    [anon_sym_default] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1472),
    [anon_sym_LBRACK] = ACTIONS(1476),
    [anon_sym_LTtemplate_GT] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1472),
    [anon_sym_GT] = ACTIONS(1474),
    [anon_sym_SLASH] = ACTIONS(1472),
    [anon_sym_DOT] = ACTIONS(1474),
    [anon_sym_class] = ACTIONS(1472),
    [anon_sym_async] = ACTIONS(1472),
    [anon_sym_function] = ACTIONS(1472),
    [anon_sym_QMARK_DOT] = ACTIONS(1478),
    [anon_sym_new] = ACTIONS(1472),
    [anon_sym_AMP_AMP] = ACTIONS(1478),
    [anon_sym_PIPE_PIPE] = ACTIONS(1478),
    [anon_sym_GT_GT] = ACTIONS(1474),
    [anon_sym_GT_GT_GT] = ACTIONS(1478),
    [anon_sym_LT_LT] = ACTIONS(1478),
    [anon_sym_AMP] = ACTIONS(1472),
    [anon_sym_CARET] = ACTIONS(1478),
    [anon_sym_PIPE] = ACTIONS(1474),
    [anon_sym_PLUS] = ACTIONS(1472),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_PERCENT] = ACTIONS(1478),
    [anon_sym_STAR_STAR] = ACTIONS(1478),
    [anon_sym_LT_EQ] = ACTIONS(1478),
    [anon_sym_EQ_EQ] = ACTIONS(1474),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1478),
    [anon_sym_BANG_EQ] = ACTIONS(1474),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1478),
    [anon_sym_GT_EQ] = ACTIONS(1478),
    [anon_sym_QMARK_QMARK] = ACTIONS(1478),
    [anon_sym_instanceof] = ACTIONS(1474),
    [anon_sym_TILDE] = ACTIONS(1476),
    [anon_sym_void] = ACTIONS(1472),
    [anon_sym_delete] = ACTIONS(1472),
    [anon_sym_PLUS_PLUS] = ACTIONS(1476),
    [anon_sym_DASH_DASH] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [sym_number] = ACTIONS(1476),
    [sym_this] = ACTIONS(1472),
    [sym_super] = ACTIONS(1472),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [sym_null] = ACTIONS(1472),
    [sym_undefined] = ACTIONS(1472),
    [anon_sym_AT] = ACTIONS(1476),
    [anon_sym_static] = ACTIONS(1472),
    [anon_sym_readonly] = ACTIONS(1472),
    [anon_sym_get] = ACTIONS(1472),
    [anon_sym_set] = ACTIONS(1472),
    [anon_sym_declare] = ACTIONS(1472),
    [anon_sym_namespace] = ACTIONS(1472),
    [anon_sym_public] = ACTIONS(1472),
    [anon_sym_private] = ACTIONS(1472),
    [anon_sym_protected] = ACTIONS(1472),
    [anon_sym_override] = ACTIONS(1472),
    [anon_sym_module] = ACTIONS(1472),
    [anon_sym_any] = ACTIONS(1472),
    [anon_sym_number] = ACTIONS(1472),
    [anon_sym_boolean] = ACTIONS(1472),
    [anon_sym_string] = ACTIONS(1472),
    [anon_sym_symbol] = ACTIONS(1472),
    [anon_sym_abstract] = ACTIONS(1472),
    [anon_sym_satisfies] = ACTIONS(1474),
    [anon_sym_interface] = ACTIONS(1472),
    [anon_sym_enum] = ACTIONS(1472),
    [anon_sym_component] = ACTIONS(1472),
    [sym__automatic_semicolon] = ACTIONS(1480),
    [sym__ternary_qmark] = ACTIONS(1478),
  },
  [178] = {
    [sym_identifier] = ACTIONS(1482),
    [anon_sym_export] = ACTIONS(1482),
    [anon_sym_STAR] = ACTIONS(1484),
    [anon_sym_as] = ACTIONS(1484),
    [anon_sym_LBRACE] = ACTIONS(1486),
    [anon_sym_COMMA] = ACTIONS(1488),
    [anon_sym_RBRACE] = ACTIONS(1486),
    [anon_sym_type] = ACTIONS(1482),
    [anon_sym_typeof] = ACTIONS(1482),
    [anon_sym_import] = ACTIONS(1482),
    [anon_sym_var] = ACTIONS(1482),
    [anon_sym_let] = ACTIONS(1482),
    [anon_sym_const] = ACTIONS(1482),
    [anon_sym_BANG] = ACTIONS(1482),
    [anon_sym_else] = ACTIONS(1482),
    [anon_sym_if] = ACTIONS(1482),
    [anon_sym_switch] = ACTIONS(1482),
    [anon_sym_for] = ACTIONS(1482),
    [anon_sym_LPAREN] = ACTIONS(1486),
    [anon_sym_await] = ACTIONS(1482),
    [anon_sym_in] = ACTIONS(1484),
    [anon_sym_while] = ACTIONS(1482),
    [anon_sym_do] = ACTIONS(1482),
    [anon_sym_try] = ACTIONS(1482),
    [anon_sym_with] = ACTIONS(1482),
    [anon_sym_break] = ACTIONS(1482),
    [anon_sym_continue] = ACTIONS(1482),
    [anon_sym_debugger] = ACTIONS(1482),
    [anon_sym_return] = ACTIONS(1482),
    [anon_sym_throw] = ACTIONS(1482),
    [anon_sym_SEMI] = ACTIONS(1486),
    [anon_sym_case] = ACTIONS(1482),
    [anon_sym_default] = ACTIONS(1482),
    [anon_sym_yield] = ACTIONS(1482),
    [anon_sym_LBRACK] = ACTIONS(1486),
    [anon_sym_LTtemplate_GT] = ACTIONS(1486),
    [anon_sym_LT] = ACTIONS(1482),
    [anon_sym_GT] = ACTIONS(1484),
    [anon_sym_SLASH] = ACTIONS(1482),
    [anon_sym_DOT] = ACTIONS(1484),
    [anon_sym_class] = ACTIONS(1482),
    [anon_sym_async] = ACTIONS(1482),
    [anon_sym_function] = ACTIONS(1482),
    [anon_sym_QMARK_DOT] = ACTIONS(1488),
    [anon_sym_new] = ACTIONS(1482),
    [anon_sym_AMP_AMP] = ACTIONS(1488),
    [anon_sym_PIPE_PIPE] = ACTIONS(1488),
    [anon_sym_GT_GT] = ACTIONS(1484),
    [anon_sym_GT_GT_GT] = ACTIONS(1488),
    [anon_sym_LT_LT] = ACTIONS(1488),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_CARET] = ACTIONS(1488),
    [anon_sym_PIPE] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1482),
    [anon_sym_PERCENT] = ACTIONS(1488),
    [anon_sym_STAR_STAR] = ACTIONS(1488),
    [anon_sym_LT_EQ] = ACTIONS(1488),
    [anon_sym_EQ_EQ] = ACTIONS(1484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1488),
    [anon_sym_BANG_EQ] = ACTIONS(1484),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1488),
    [anon_sym_GT_EQ] = ACTIONS(1488),
    [anon_sym_QMARK_QMARK] = ACTIONS(1488),
    [anon_sym_instanceof] = ACTIONS(1484),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_void] = ACTIONS(1482),
    [anon_sym_delete] = ACTIONS(1482),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1486),
    [sym_number] = ACTIONS(1486),
    [sym_this] = ACTIONS(1482),
    [sym_super] = ACTIONS(1482),
    [sym_true] = ACTIONS(1482),
    [sym_false] = ACTIONS(1482),
    [sym_null] = ACTIONS(1482),
    [sym_undefined] = ACTIONS(1482),
    [anon_sym_AT] = ACTIONS(1486),
    [anon_sym_static] = ACTIONS(1482),
    [anon_sym_readonly] = ACTIONS(1482),
    [anon_sym_get] = ACTIONS(1482),
    [anon_sym_set] = ACTIONS(1482),
    [anon_sym_declare] = ACTIONS(1482),
    [anon_sym_namespace] = ACTIONS(1482),
    [anon_sym_public] = ACTIONS(1482),
    [anon_sym_private] = ACTIONS(1482),
    [anon_sym_protected] = ACTIONS(1482),
    [anon_sym_override] = ACTIONS(1482),
    [anon_sym_module] = ACTIONS(1482),
    [anon_sym_any] = ACTIONS(1482),
    [anon_sym_number] = ACTIONS(1482),
    [anon_sym_boolean] = ACTIONS(1482),
    [anon_sym_string] = ACTIONS(1482),
    [anon_sym_symbol] = ACTIONS(1482),
    [anon_sym_abstract] = ACTIONS(1482),
    [anon_sym_satisfies] = ACTIONS(1484),
    [anon_sym_interface] = ACTIONS(1482),
    [anon_sym_enum] = ACTIONS(1482),
    [anon_sym_component] = ACTIONS(1482),
    [sym__automatic_semicolon] = ACTIONS(1490),
    [sym__ternary_qmark] = ACTIONS(1488),
  },
  [179] = {
    [sym__call_signature] = STATE(4560),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_export] = ACTIONS(1495),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_RBRACE] = ACTIONS(65),
    [anon_sym_type] = ACTIONS(1495),
    [anon_sym_typeof] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1497),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(1499),
    [anon_sym_function] = ACTIONS(1324),
    [anon_sym_EQ_GT] = ACTIONS(1502),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(25),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_void] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(65),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(65),
    [sym_number] = ACTIONS(65),
    [sym_this] = ACTIONS(25),
    [sym_true] = ACTIONS(25),
    [sym_false] = ACTIONS(25),
    [sym_null] = ACTIONS(25),
    [sym_undefined] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(1499),
    [anon_sym_readonly] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(1495),
    [anon_sym_set] = ACTIONS(1495),
    [anon_sym_QMARK] = ACTIONS(25),
    [anon_sym_declare] = ACTIONS(1495),
    [anon_sym_namespace] = ACTIONS(1495),
    [anon_sym_public] = ACTIONS(1495),
    [anon_sym_private] = ACTIONS(1495),
    [anon_sym_protected] = ACTIONS(1495),
    [anon_sym_override] = ACTIONS(1495),
    [anon_sym_module] = ACTIONS(1495),
    [anon_sym_any] = ACTIONS(1499),
    [anon_sym_number] = ACTIONS(1499),
    [anon_sym_boolean] = ACTIONS(1499),
    [anon_sym_string] = ACTIONS(1499),
    [anon_sym_symbol] = ACTIONS(1499),
    [anon_sym_abstract] = ACTIONS(25),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_infer] = ACTIONS(25),
    [anon_sym_keyof] = ACTIONS(25),
    [anon_sym_unknown] = ACTIONS(25),
    [anon_sym_never] = ACTIONS(25),
    [anon_sym_object] = ACTIONS(25),
    [anon_sym_LBRACE_PIPE] = ACTIONS(65),
    [anon_sym_prop] = ACTIONS(25),
    [anon_sym_id] = ACTIONS(25),
    [anon_sym_event] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_on] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [180] = {
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_export] = ACTIONS(1504),
    [anon_sym_STAR] = ACTIONS(1506),
    [anon_sym_as] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1508),
    [anon_sym_COMMA] = ACTIONS(1510),
    [anon_sym_RBRACE] = ACTIONS(1508),
    [anon_sym_type] = ACTIONS(1504),
    [anon_sym_typeof] = ACTIONS(1504),
    [anon_sym_import] = ACTIONS(1504),
    [anon_sym_var] = ACTIONS(1504),
    [anon_sym_let] = ACTIONS(1504),
    [anon_sym_const] = ACTIONS(1504),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_else] = ACTIONS(1504),
    [anon_sym_if] = ACTIONS(1504),
    [anon_sym_switch] = ACTIONS(1504),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_LPAREN] = ACTIONS(1508),
    [anon_sym_await] = ACTIONS(1504),
    [anon_sym_in] = ACTIONS(1506),
    [anon_sym_while] = ACTIONS(1504),
    [anon_sym_do] = ACTIONS(1504),
    [anon_sym_try] = ACTIONS(1504),
    [anon_sym_with] = ACTIONS(1504),
    [anon_sym_break] = ACTIONS(1504),
    [anon_sym_continue] = ACTIONS(1504),
    [anon_sym_debugger] = ACTIONS(1504),
    [anon_sym_return] = ACTIONS(1504),
    [anon_sym_throw] = ACTIONS(1504),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_case] = ACTIONS(1504),
    [anon_sym_default] = ACTIONS(1504),
    [anon_sym_yield] = ACTIONS(1504),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_LTtemplate_GT] = ACTIONS(1508),
    [anon_sym_LT] = ACTIONS(1504),
    [anon_sym_GT] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1504),
    [anon_sym_DOT] = ACTIONS(1506),
    [anon_sym_class] = ACTIONS(1504),
    [anon_sym_async] = ACTIONS(1504),
    [anon_sym_function] = ACTIONS(1504),
    [anon_sym_QMARK_DOT] = ACTIONS(1510),
    [anon_sym_new] = ACTIONS(1504),
    [anon_sym_AMP_AMP] = ACTIONS(1510),
    [anon_sym_PIPE_PIPE] = ACTIONS(1510),
    [anon_sym_GT_GT] = ACTIONS(1506),
    [anon_sym_GT_GT_GT] = ACTIONS(1510),
    [anon_sym_LT_LT] = ACTIONS(1510),
    [anon_sym_AMP] = ACTIONS(1504),
    [anon_sym_CARET] = ACTIONS(1510),
    [anon_sym_PIPE] = ACTIONS(1506),
    [anon_sym_PLUS] = ACTIONS(1504),
    [anon_sym_DASH] = ACTIONS(1504),
    [anon_sym_PERCENT] = ACTIONS(1510),
    [anon_sym_STAR_STAR] = ACTIONS(1510),
    [anon_sym_LT_EQ] = ACTIONS(1510),
    [anon_sym_EQ_EQ] = ACTIONS(1506),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1510),
    [anon_sym_BANG_EQ] = ACTIONS(1506),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1510),
    [anon_sym_GT_EQ] = ACTIONS(1510),
    [anon_sym_QMARK_QMARK] = ACTIONS(1510),
    [anon_sym_instanceof] = ACTIONS(1506),
    [anon_sym_TILDE] = ACTIONS(1508),
    [anon_sym_void] = ACTIONS(1504),
    [anon_sym_delete] = ACTIONS(1504),
    [anon_sym_PLUS_PLUS] = ACTIONS(1508),
    [anon_sym_DASH_DASH] = ACTIONS(1508),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1508),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_number] = ACTIONS(1508),
    [sym_this] = ACTIONS(1504),
    [sym_super] = ACTIONS(1504),
    [sym_true] = ACTIONS(1504),
    [sym_false] = ACTIONS(1504),
    [sym_null] = ACTIONS(1504),
    [sym_undefined] = ACTIONS(1504),
    [anon_sym_AT] = ACTIONS(1508),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_readonly] = ACTIONS(1504),
    [anon_sym_get] = ACTIONS(1504),
    [anon_sym_set] = ACTIONS(1504),
    [anon_sym_declare] = ACTIONS(1504),
    [anon_sym_namespace] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1504),
    [anon_sym_private] = ACTIONS(1504),
    [anon_sym_protected] = ACTIONS(1504),
    [anon_sym_override] = ACTIONS(1504),
    [anon_sym_module] = ACTIONS(1504),
    [anon_sym_any] = ACTIONS(1504),
    [anon_sym_number] = ACTIONS(1504),
    [anon_sym_boolean] = ACTIONS(1504),
    [anon_sym_string] = ACTIONS(1504),
    [anon_sym_symbol] = ACTIONS(1504),
    [anon_sym_abstract] = ACTIONS(1504),
    [anon_sym_satisfies] = ACTIONS(1506),
    [anon_sym_interface] = ACTIONS(1504),
    [anon_sym_enum] = ACTIONS(1504),
    [anon_sym_component] = ACTIONS(1504),
    [sym__automatic_semicolon] = ACTIONS(1512),
    [sym__ternary_qmark] = ACTIONS(1510),
  },
  [181] = {
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_export] = ACTIONS(1514),
    [anon_sym_STAR] = ACTIONS(1516),
    [anon_sym_as] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(1518),
    [anon_sym_COMMA] = ACTIONS(1520),
    [anon_sym_RBRACE] = ACTIONS(1518),
    [anon_sym_type] = ACTIONS(1514),
    [anon_sym_typeof] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1514),
    [anon_sym_var] = ACTIONS(1514),
    [anon_sym_let] = ACTIONS(1514),
    [anon_sym_const] = ACTIONS(1514),
    [anon_sym_BANG] = ACTIONS(1514),
    [anon_sym_else] = ACTIONS(1514),
    [anon_sym_if] = ACTIONS(1514),
    [anon_sym_switch] = ACTIONS(1514),
    [anon_sym_for] = ACTIONS(1514),
    [anon_sym_LPAREN] = ACTIONS(1518),
    [anon_sym_await] = ACTIONS(1514),
    [anon_sym_in] = ACTIONS(1516),
    [anon_sym_while] = ACTIONS(1514),
    [anon_sym_do] = ACTIONS(1514),
    [anon_sym_try] = ACTIONS(1514),
    [anon_sym_with] = ACTIONS(1514),
    [anon_sym_break] = ACTIONS(1514),
    [anon_sym_continue] = ACTIONS(1514),
    [anon_sym_debugger] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1514),
    [anon_sym_throw] = ACTIONS(1514),
    [anon_sym_SEMI] = ACTIONS(1518),
    [anon_sym_case] = ACTIONS(1514),
    [anon_sym_default] = ACTIONS(1514),
    [anon_sym_yield] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1518),
    [anon_sym_LTtemplate_GT] = ACTIONS(1518),
    [anon_sym_LT] = ACTIONS(1514),
    [anon_sym_GT] = ACTIONS(1516),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_DOT] = ACTIONS(1516),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_async] = ACTIONS(1514),
    [anon_sym_function] = ACTIONS(1514),
    [anon_sym_QMARK_DOT] = ACTIONS(1520),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_AMP_AMP] = ACTIONS(1520),
    [anon_sym_PIPE_PIPE] = ACTIONS(1520),
    [anon_sym_GT_GT] = ACTIONS(1516),
    [anon_sym_GT_GT_GT] = ACTIONS(1520),
    [anon_sym_LT_LT] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1514),
    [anon_sym_CARET] = ACTIONS(1520),
    [anon_sym_PIPE] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1514),
    [anon_sym_DASH] = ACTIONS(1514),
    [anon_sym_PERCENT] = ACTIONS(1520),
    [anon_sym_STAR_STAR] = ACTIONS(1520),
    [anon_sym_LT_EQ] = ACTIONS(1520),
    [anon_sym_EQ_EQ] = ACTIONS(1516),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1520),
    [anon_sym_BANG_EQ] = ACTIONS(1516),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1520),
    [anon_sym_GT_EQ] = ACTIONS(1520),
    [anon_sym_QMARK_QMARK] = ACTIONS(1520),
    [anon_sym_instanceof] = ACTIONS(1516),
    [anon_sym_TILDE] = ACTIONS(1518),
    [anon_sym_void] = ACTIONS(1514),
    [anon_sym_delete] = ACTIONS(1514),
    [anon_sym_PLUS_PLUS] = ACTIONS(1518),
    [anon_sym_DASH_DASH] = ACTIONS(1518),
    [anon_sym_DQUOTE] = ACTIONS(1518),
    [anon_sym_SQUOTE] = ACTIONS(1518),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1518),
    [sym_number] = ACTIONS(1518),
    [sym_this] = ACTIONS(1514),
    [sym_super] = ACTIONS(1514),
    [sym_true] = ACTIONS(1514),
    [sym_false] = ACTIONS(1514),
    [sym_null] = ACTIONS(1514),
    [sym_undefined] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(1518),
    [anon_sym_static] = ACTIONS(1514),
    [anon_sym_readonly] = ACTIONS(1514),
    [anon_sym_get] = ACTIONS(1514),
    [anon_sym_set] = ACTIONS(1514),
    [anon_sym_declare] = ACTIONS(1514),
    [anon_sym_namespace] = ACTIONS(1514),
    [anon_sym_public] = ACTIONS(1514),
    [anon_sym_private] = ACTIONS(1514),
    [anon_sym_protected] = ACTIONS(1514),
    [anon_sym_override] = ACTIONS(1514),
    [anon_sym_module] = ACTIONS(1514),
    [anon_sym_any] = ACTIONS(1514),
    [anon_sym_number] = ACTIONS(1514),
    [anon_sym_boolean] = ACTIONS(1514),
    [anon_sym_string] = ACTIONS(1514),
    [anon_sym_symbol] = ACTIONS(1514),
    [anon_sym_abstract] = ACTIONS(1514),
    [anon_sym_satisfies] = ACTIONS(1516),
    [anon_sym_interface] = ACTIONS(1514),
    [anon_sym_enum] = ACTIONS(1514),
    [anon_sym_component] = ACTIONS(1514),
    [sym__automatic_semicolon] = ACTIONS(1522),
    [sym__ternary_qmark] = ACTIONS(1520),
  },
  [182] = {
    [sym_identifier] = ACTIONS(1524),
    [anon_sym_export] = ACTIONS(1524),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_as] = ACTIONS(1524),
    [anon_sym_LBRACE] = ACTIONS(1526),
    [anon_sym_COMMA] = ACTIONS(1526),
    [anon_sym_RBRACE] = ACTIONS(1526),
    [anon_sym_type] = ACTIONS(1524),
    [anon_sym_typeof] = ACTIONS(1524),
    [anon_sym_import] = ACTIONS(1524),
    [anon_sym_var] = ACTIONS(1524),
    [anon_sym_let] = ACTIONS(1524),
    [anon_sym_const] = ACTIONS(1524),
    [anon_sym_BANG] = ACTIONS(1524),
    [anon_sym_else] = ACTIONS(1524),
    [anon_sym_if] = ACTIONS(1524),
    [anon_sym_switch] = ACTIONS(1524),
    [anon_sym_for] = ACTIONS(1524),
    [anon_sym_LPAREN] = ACTIONS(1526),
    [anon_sym_await] = ACTIONS(1524),
    [anon_sym_in] = ACTIONS(1524),
    [anon_sym_while] = ACTIONS(1524),
    [anon_sym_do] = ACTIONS(1524),
    [anon_sym_try] = ACTIONS(1524),
    [anon_sym_with] = ACTIONS(1524),
    [anon_sym_break] = ACTIONS(1524),
    [anon_sym_continue] = ACTIONS(1524),
    [anon_sym_debugger] = ACTIONS(1524),
    [anon_sym_return] = ACTIONS(1524),
    [anon_sym_throw] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1526),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1524),
    [anon_sym_yield] = ACTIONS(1524),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LTtemplate_GT] = ACTIONS(1526),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_GT] = ACTIONS(1524),
    [anon_sym_SLASH] = ACTIONS(1524),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_class] = ACTIONS(1524),
    [anon_sym_async] = ACTIONS(1524),
    [anon_sym_function] = ACTIONS(1524),
    [anon_sym_QMARK_DOT] = ACTIONS(1526),
    [anon_sym_new] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE_PIPE] = ACTIONS(1526),
    [anon_sym_GT_GT] = ACTIONS(1524),
    [anon_sym_GT_GT_GT] = ACTIONS(1526),
    [anon_sym_LT_LT] = ACTIONS(1526),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_CARET] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_PLUS] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1524),
    [anon_sym_PERCENT] = ACTIONS(1526),
    [anon_sym_STAR_STAR] = ACTIONS(1526),
    [anon_sym_LT_EQ] = ACTIONS(1526),
    [anon_sym_EQ_EQ] = ACTIONS(1524),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1526),
    [anon_sym_BANG_EQ] = ACTIONS(1524),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1526),
    [anon_sym_GT_EQ] = ACTIONS(1526),
    [anon_sym_QMARK_QMARK] = ACTIONS(1526),
    [anon_sym_instanceof] = ACTIONS(1524),
    [anon_sym_TILDE] = ACTIONS(1526),
    [anon_sym_void] = ACTIONS(1524),
    [anon_sym_delete] = ACTIONS(1524),
    [anon_sym_PLUS_PLUS] = ACTIONS(1526),
    [anon_sym_DASH_DASH] = ACTIONS(1526),
    [anon_sym_DQUOTE] = ACTIONS(1526),
    [anon_sym_SQUOTE] = ACTIONS(1526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1526),
    [sym_number] = ACTIONS(1526),
    [sym_this] = ACTIONS(1524),
    [sym_super] = ACTIONS(1524),
    [sym_true] = ACTIONS(1524),
    [sym_false] = ACTIONS(1524),
    [sym_null] = ACTIONS(1524),
    [sym_undefined] = ACTIONS(1524),
    [anon_sym_AT] = ACTIONS(1526),
    [anon_sym_static] = ACTIONS(1524),
    [anon_sym_readonly] = ACTIONS(1524),
    [anon_sym_get] = ACTIONS(1524),
    [anon_sym_set] = ACTIONS(1524),
    [anon_sym_declare] = ACTIONS(1524),
    [anon_sym_namespace] = ACTIONS(1524),
    [anon_sym_public] = ACTIONS(1524),
    [anon_sym_private] = ACTIONS(1524),
    [anon_sym_protected] = ACTIONS(1524),
    [anon_sym_override] = ACTIONS(1524),
    [anon_sym_module] = ACTIONS(1524),
    [anon_sym_any] = ACTIONS(1524),
    [anon_sym_number] = ACTIONS(1524),
    [anon_sym_boolean] = ACTIONS(1524),
    [anon_sym_string] = ACTIONS(1524),
    [anon_sym_symbol] = ACTIONS(1524),
    [anon_sym_abstract] = ACTIONS(1524),
    [anon_sym_satisfies] = ACTIONS(1524),
    [anon_sym_interface] = ACTIONS(1524),
    [anon_sym_enum] = ACTIONS(1524),
    [anon_sym_component] = ACTIONS(1524),
    [sym__automatic_semicolon] = ACTIONS(1528),
    [sym__ternary_qmark] = ACTIONS(1526),
  },
  [183] = {
    [sym_identifier] = ACTIONS(1530),
    [anon_sym_export] = ACTIONS(1530),
    [anon_sym_STAR] = ACTIONS(1532),
    [anon_sym_as] = ACTIONS(1532),
    [anon_sym_LBRACE] = ACTIONS(1534),
    [anon_sym_COMMA] = ACTIONS(1536),
    [anon_sym_RBRACE] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1530),
    [anon_sym_typeof] = ACTIONS(1530),
    [anon_sym_import] = ACTIONS(1530),
    [anon_sym_var] = ACTIONS(1530),
    [anon_sym_let] = ACTIONS(1530),
    [anon_sym_const] = ACTIONS(1530),
    [anon_sym_BANG] = ACTIONS(1530),
    [anon_sym_else] = ACTIONS(1530),
    [anon_sym_if] = ACTIONS(1530),
    [anon_sym_switch] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1530),
    [anon_sym_LPAREN] = ACTIONS(1534),
    [anon_sym_await] = ACTIONS(1530),
    [anon_sym_in] = ACTIONS(1532),
    [anon_sym_while] = ACTIONS(1530),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_try] = ACTIONS(1530),
    [anon_sym_with] = ACTIONS(1530),
    [anon_sym_break] = ACTIONS(1530),
    [anon_sym_continue] = ACTIONS(1530),
    [anon_sym_debugger] = ACTIONS(1530),
    [anon_sym_return] = ACTIONS(1530),
    [anon_sym_throw] = ACTIONS(1530),
    [anon_sym_SEMI] = ACTIONS(1534),
    [anon_sym_case] = ACTIONS(1530),
    [anon_sym_default] = ACTIONS(1530),
    [anon_sym_yield] = ACTIONS(1530),
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_LTtemplate_GT] = ACTIONS(1534),
    [anon_sym_LT] = ACTIONS(1530),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_SLASH] = ACTIONS(1530),
    [anon_sym_DOT] = ACTIONS(1532),
    [anon_sym_class] = ACTIONS(1530),
    [anon_sym_async] = ACTIONS(1530),
    [anon_sym_function] = ACTIONS(1530),
    [anon_sym_QMARK_DOT] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1530),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE_PIPE] = ACTIONS(1536),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [anon_sym_GT_GT_GT] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1536),
    [anon_sym_AMP] = ACTIONS(1530),
    [anon_sym_CARET] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_PLUS] = ACTIONS(1530),
    [anon_sym_DASH] = ACTIONS(1530),
    [anon_sym_PERCENT] = ACTIONS(1536),
    [anon_sym_STAR_STAR] = ACTIONS(1536),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1536),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_QMARK_QMARK] = ACTIONS(1536),
    [anon_sym_instanceof] = ACTIONS(1532),
    [anon_sym_TILDE] = ACTIONS(1534),
    [anon_sym_void] = ACTIONS(1530),
    [anon_sym_delete] = ACTIONS(1530),
    [anon_sym_PLUS_PLUS] = ACTIONS(1534),
    [anon_sym_DASH_DASH] = ACTIONS(1534),
    [anon_sym_DQUOTE] = ACTIONS(1534),
    [anon_sym_SQUOTE] = ACTIONS(1534),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1534),
    [sym_number] = ACTIONS(1534),
    [sym_this] = ACTIONS(1530),
    [sym_super] = ACTIONS(1530),
    [sym_true] = ACTIONS(1530),
    [sym_false] = ACTIONS(1530),
    [sym_null] = ACTIONS(1530),
    [sym_undefined] = ACTIONS(1530),
    [anon_sym_AT] = ACTIONS(1534),
    [anon_sym_static] = ACTIONS(1530),
    [anon_sym_readonly] = ACTIONS(1530),
    [anon_sym_get] = ACTIONS(1530),
    [anon_sym_set] = ACTIONS(1530),
    [anon_sym_declare] = ACTIONS(1530),
    [anon_sym_namespace] = ACTIONS(1530),
    [anon_sym_public] = ACTIONS(1530),
    [anon_sym_private] = ACTIONS(1530),
    [anon_sym_protected] = ACTIONS(1530),
    [anon_sym_override] = ACTIONS(1530),
    [anon_sym_module] = ACTIONS(1530),
    [anon_sym_any] = ACTIONS(1530),
    [anon_sym_number] = ACTIONS(1530),
    [anon_sym_boolean] = ACTIONS(1530),
    [anon_sym_string] = ACTIONS(1530),
    [anon_sym_symbol] = ACTIONS(1530),
    [anon_sym_abstract] = ACTIONS(1530),
    [anon_sym_satisfies] = ACTIONS(1532),
    [anon_sym_interface] = ACTIONS(1530),
    [anon_sym_enum] = ACTIONS(1530),
    [anon_sym_component] = ACTIONS(1530),
    [sym__automatic_semicolon] = ACTIONS(1538),
    [sym__ternary_qmark] = ACTIONS(1536),
  },
  [184] = {
    [sym_identifier] = ACTIONS(1540),
    [anon_sym_export] = ACTIONS(1540),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_as] = ACTIONS(1540),
    [anon_sym_LBRACE] = ACTIONS(1542),
    [anon_sym_COMMA] = ACTIONS(1542),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [anon_sym_type] = ACTIONS(1540),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(1540),
    [anon_sym_var] = ACTIONS(1540),
    [anon_sym_let] = ACTIONS(1540),
    [anon_sym_const] = ACTIONS(1540),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_else] = ACTIONS(1540),
    [anon_sym_if] = ACTIONS(1540),
    [anon_sym_switch] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1542),
    [anon_sym_await] = ACTIONS(1540),
    [anon_sym_in] = ACTIONS(1540),
    [anon_sym_while] = ACTIONS(1540),
    [anon_sym_do] = ACTIONS(1540),
    [anon_sym_try] = ACTIONS(1540),
    [anon_sym_with] = ACTIONS(1540),
    [anon_sym_break] = ACTIONS(1540),
    [anon_sym_continue] = ACTIONS(1540),
    [anon_sym_debugger] = ACTIONS(1540),
    [anon_sym_return] = ACTIONS(1540),
    [anon_sym_throw] = ACTIONS(1540),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_case] = ACTIONS(1540),
    [anon_sym_default] = ACTIONS(1540),
    [anon_sym_yield] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1542),
    [anon_sym_LTtemplate_GT] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1540),
    [anon_sym_DOT] = ACTIONS(1540),
    [anon_sym_class] = ACTIONS(1540),
    [anon_sym_async] = ACTIONS(1540),
    [anon_sym_function] = ACTIONS(1540),
    [anon_sym_QMARK_DOT] = ACTIONS(1542),
    [anon_sym_new] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1540),
    [anon_sym_GT_GT_GT] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_CARET] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_PERCENT] = ACTIONS(1542),
    [anon_sym_STAR_STAR] = ACTIONS(1542),
    [anon_sym_LT_EQ] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1540),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1540),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1542),
    [anon_sym_GT_EQ] = ACTIONS(1542),
    [anon_sym_QMARK_QMARK] = ACTIONS(1542),
    [anon_sym_instanceof] = ACTIONS(1540),
    [anon_sym_TILDE] = ACTIONS(1542),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1542),
    [anon_sym_DASH_DASH] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [sym_number] = ACTIONS(1542),
    [sym_this] = ACTIONS(1540),
    [sym_super] = ACTIONS(1540),
    [sym_true] = ACTIONS(1540),
    [sym_false] = ACTIONS(1540),
    [sym_null] = ACTIONS(1540),
    [sym_undefined] = ACTIONS(1540),
    [anon_sym_AT] = ACTIONS(1542),
    [anon_sym_static] = ACTIONS(1540),
    [anon_sym_readonly] = ACTIONS(1540),
    [anon_sym_get] = ACTIONS(1540),
    [anon_sym_set] = ACTIONS(1540),
    [anon_sym_declare] = ACTIONS(1540),
    [anon_sym_namespace] = ACTIONS(1540),
    [anon_sym_public] = ACTIONS(1540),
    [anon_sym_private] = ACTIONS(1540),
    [anon_sym_protected] = ACTIONS(1540),
    [anon_sym_override] = ACTIONS(1540),
    [anon_sym_module] = ACTIONS(1540),
    [anon_sym_any] = ACTIONS(1540),
    [anon_sym_number] = ACTIONS(1540),
    [anon_sym_boolean] = ACTIONS(1540),
    [anon_sym_string] = ACTIONS(1540),
    [anon_sym_symbol] = ACTIONS(1540),
    [anon_sym_abstract] = ACTIONS(1540),
    [anon_sym_satisfies] = ACTIONS(1540),
    [anon_sym_interface] = ACTIONS(1540),
    [anon_sym_enum] = ACTIONS(1540),
    [anon_sym_component] = ACTIONS(1540),
    [sym__automatic_semicolon] = ACTIONS(1542),
    [sym__ternary_qmark] = ACTIONS(1542),
  },
  [185] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1537),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1076),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_property_assignment_expression] = STATE(1537),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [186] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1537),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(852),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_property_assignment_expression] = STATE(1537),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [187] = {
    [sym_identifier] = ACTIONS(1544),
    [anon_sym_export] = ACTIONS(1544),
    [anon_sym_STAR] = ACTIONS(1546),
    [anon_sym_as] = ACTIONS(1546),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_COMMA] = ACTIONS(1550),
    [anon_sym_RBRACE] = ACTIONS(1548),
    [anon_sym_type] = ACTIONS(1544),
    [anon_sym_typeof] = ACTIONS(1544),
    [anon_sym_import] = ACTIONS(1544),
    [anon_sym_var] = ACTIONS(1544),
    [anon_sym_let] = ACTIONS(1544),
    [anon_sym_const] = ACTIONS(1544),
    [anon_sym_BANG] = ACTIONS(1544),
    [anon_sym_else] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_switch] = ACTIONS(1544),
    [anon_sym_for] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1548),
    [anon_sym_await] = ACTIONS(1544),
    [anon_sym_in] = ACTIONS(1546),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_do] = ACTIONS(1544),
    [anon_sym_try] = ACTIONS(1544),
    [anon_sym_with] = ACTIONS(1544),
    [anon_sym_break] = ACTIONS(1544),
    [anon_sym_continue] = ACTIONS(1544),
    [anon_sym_debugger] = ACTIONS(1544),
    [anon_sym_return] = ACTIONS(1544),
    [anon_sym_throw] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1548),
    [anon_sym_case] = ACTIONS(1544),
    [anon_sym_default] = ACTIONS(1544),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_LTtemplate_GT] = ACTIONS(1548),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_GT] = ACTIONS(1546),
    [anon_sym_SLASH] = ACTIONS(1544),
    [anon_sym_DOT] = ACTIONS(1546),
    [anon_sym_class] = ACTIONS(1544),
    [anon_sym_async] = ACTIONS(1544),
    [anon_sym_function] = ACTIONS(1544),
    [anon_sym_QMARK_DOT] = ACTIONS(1550),
    [anon_sym_new] = ACTIONS(1544),
    [anon_sym_AMP_AMP] = ACTIONS(1550),
    [anon_sym_PIPE_PIPE] = ACTIONS(1550),
    [anon_sym_GT_GT] = ACTIONS(1546),
    [anon_sym_GT_GT_GT] = ACTIONS(1550),
    [anon_sym_LT_LT] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(1544),
    [anon_sym_CARET] = ACTIONS(1550),
    [anon_sym_PIPE] = ACTIONS(1546),
    [anon_sym_PLUS] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1544),
    [anon_sym_PERCENT] = ACTIONS(1550),
    [anon_sym_STAR_STAR] = ACTIONS(1550),
    [anon_sym_LT_EQ] = ACTIONS(1550),
    [anon_sym_EQ_EQ] = ACTIONS(1546),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1550),
    [anon_sym_BANG_EQ] = ACTIONS(1546),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1550),
    [anon_sym_GT_EQ] = ACTIONS(1550),
    [anon_sym_QMARK_QMARK] = ACTIONS(1550),
    [anon_sym_instanceof] = ACTIONS(1546),
    [anon_sym_TILDE] = ACTIONS(1548),
    [anon_sym_void] = ACTIONS(1544),
    [anon_sym_delete] = ACTIONS(1544),
    [anon_sym_PLUS_PLUS] = ACTIONS(1548),
    [anon_sym_DASH_DASH] = ACTIONS(1548),
    [anon_sym_DQUOTE] = ACTIONS(1548),
    [anon_sym_SQUOTE] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1548),
    [sym_number] = ACTIONS(1548),
    [sym_this] = ACTIONS(1544),
    [sym_super] = ACTIONS(1544),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_undefined] = ACTIONS(1544),
    [anon_sym_AT] = ACTIONS(1548),
    [anon_sym_static] = ACTIONS(1544),
    [anon_sym_readonly] = ACTIONS(1544),
    [anon_sym_get] = ACTIONS(1544),
    [anon_sym_set] = ACTIONS(1544),
    [anon_sym_declare] = ACTIONS(1544),
    [anon_sym_namespace] = ACTIONS(1544),
    [anon_sym_public] = ACTIONS(1544),
    [anon_sym_private] = ACTIONS(1544),
    [anon_sym_protected] = ACTIONS(1544),
    [anon_sym_override] = ACTIONS(1544),
    [anon_sym_module] = ACTIONS(1544),
    [anon_sym_any] = ACTIONS(1544),
    [anon_sym_number] = ACTIONS(1544),
    [anon_sym_boolean] = ACTIONS(1544),
    [anon_sym_string] = ACTIONS(1544),
    [anon_sym_symbol] = ACTIONS(1544),
    [anon_sym_abstract] = ACTIONS(1544),
    [anon_sym_satisfies] = ACTIONS(1546),
    [anon_sym_interface] = ACTIONS(1544),
    [anon_sym_enum] = ACTIONS(1544),
    [anon_sym_component] = ACTIONS(1544),
    [sym__automatic_semicolon] = ACTIONS(1552),
    [sym__ternary_qmark] = ACTIONS(1550),
  },
  [188] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1573),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1076),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_property_assignment_expression] = STATE(1573),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [189] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1573),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(852),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_property_assignment_expression] = STATE(1573),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [190] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1576),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(852),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_property_assignment_expression] = STATE(1576),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [191] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1541),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(852),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_property_assignment_expression] = STATE(1541),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [192] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1576),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1076),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_property_assignment_expression] = STATE(1576),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [193] = {
    [sym_identifier] = ACTIONS(1554),
    [anon_sym_export] = ACTIONS(1554),
    [anon_sym_STAR] = ACTIONS(1556),
    [anon_sym_as] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(1558),
    [anon_sym_COMMA] = ACTIONS(1560),
    [anon_sym_RBRACE] = ACTIONS(1558),
    [anon_sym_type] = ACTIONS(1554),
    [anon_sym_typeof] = ACTIONS(1554),
    [anon_sym_import] = ACTIONS(1554),
    [anon_sym_var] = ACTIONS(1554),
    [anon_sym_let] = ACTIONS(1554),
    [anon_sym_const] = ACTIONS(1554),
    [anon_sym_BANG] = ACTIONS(1554),
    [anon_sym_else] = ACTIONS(1554),
    [anon_sym_if] = ACTIONS(1554),
    [anon_sym_switch] = ACTIONS(1554),
    [anon_sym_for] = ACTIONS(1554),
    [anon_sym_LPAREN] = ACTIONS(1558),
    [anon_sym_await] = ACTIONS(1554),
    [anon_sym_in] = ACTIONS(1556),
    [anon_sym_while] = ACTIONS(1554),
    [anon_sym_do] = ACTIONS(1554),
    [anon_sym_try] = ACTIONS(1554),
    [anon_sym_with] = ACTIONS(1554),
    [anon_sym_break] = ACTIONS(1554),
    [anon_sym_continue] = ACTIONS(1554),
    [anon_sym_debugger] = ACTIONS(1554),
    [anon_sym_return] = ACTIONS(1554),
    [anon_sym_throw] = ACTIONS(1554),
    [anon_sym_SEMI] = ACTIONS(1558),
    [anon_sym_case] = ACTIONS(1554),
    [anon_sym_default] = ACTIONS(1554),
    [anon_sym_yield] = ACTIONS(1554),
    [anon_sym_LBRACK] = ACTIONS(1558),
    [anon_sym_LTtemplate_GT] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1554),
    [anon_sym_GT] = ACTIONS(1556),
    [anon_sym_SLASH] = ACTIONS(1554),
    [anon_sym_DOT] = ACTIONS(1556),
    [anon_sym_class] = ACTIONS(1554),
    [anon_sym_async] = ACTIONS(1554),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_QMARK_DOT] = ACTIONS(1560),
    [anon_sym_new] = ACTIONS(1554),
    [anon_sym_AMP_AMP] = ACTIONS(1560),
    [anon_sym_PIPE_PIPE] = ACTIONS(1560),
    [anon_sym_GT_GT] = ACTIONS(1556),
    [anon_sym_GT_GT_GT] = ACTIONS(1560),
    [anon_sym_LT_LT] = ACTIONS(1560),
    [anon_sym_AMP] = ACTIONS(1554),
    [anon_sym_CARET] = ACTIONS(1560),
    [anon_sym_PIPE] = ACTIONS(1556),
    [anon_sym_PLUS] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1554),
    [anon_sym_PERCENT] = ACTIONS(1560),
    [anon_sym_STAR_STAR] = ACTIONS(1560),
    [anon_sym_LT_EQ] = ACTIONS(1560),
    [anon_sym_EQ_EQ] = ACTIONS(1556),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1560),
    [anon_sym_BANG_EQ] = ACTIONS(1556),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1560),
    [anon_sym_GT_EQ] = ACTIONS(1560),
    [anon_sym_QMARK_QMARK] = ACTIONS(1560),
    [anon_sym_instanceof] = ACTIONS(1556),
    [anon_sym_TILDE] = ACTIONS(1558),
    [anon_sym_void] = ACTIONS(1554),
    [anon_sym_delete] = ACTIONS(1554),
    [anon_sym_PLUS_PLUS] = ACTIONS(1558),
    [anon_sym_DASH_DASH] = ACTIONS(1558),
    [anon_sym_DQUOTE] = ACTIONS(1558),
    [anon_sym_SQUOTE] = ACTIONS(1558),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1558),
    [sym_number] = ACTIONS(1558),
    [sym_this] = ACTIONS(1554),
    [sym_super] = ACTIONS(1554),
    [sym_true] = ACTIONS(1554),
    [sym_false] = ACTIONS(1554),
    [sym_null] = ACTIONS(1554),
    [sym_undefined] = ACTIONS(1554),
    [anon_sym_AT] = ACTIONS(1558),
    [anon_sym_static] = ACTIONS(1554),
    [anon_sym_readonly] = ACTIONS(1554),
    [anon_sym_get] = ACTIONS(1554),
    [anon_sym_set] = ACTIONS(1554),
    [anon_sym_declare] = ACTIONS(1554),
    [anon_sym_namespace] = ACTIONS(1554),
    [anon_sym_public] = ACTIONS(1554),
    [anon_sym_private] = ACTIONS(1554),
    [anon_sym_protected] = ACTIONS(1554),
    [anon_sym_override] = ACTIONS(1554),
    [anon_sym_module] = ACTIONS(1554),
    [anon_sym_any] = ACTIONS(1554),
    [anon_sym_number] = ACTIONS(1554),
    [anon_sym_boolean] = ACTIONS(1554),
    [anon_sym_string] = ACTIONS(1554),
    [anon_sym_symbol] = ACTIONS(1554),
    [anon_sym_abstract] = ACTIONS(1554),
    [anon_sym_satisfies] = ACTIONS(1556),
    [anon_sym_interface] = ACTIONS(1554),
    [anon_sym_enum] = ACTIONS(1554),
    [anon_sym_component] = ACTIONS(1554),
    [sym__automatic_semicolon] = ACTIONS(1562),
    [sym__ternary_qmark] = ACTIONS(1560),
  },
  [194] = {
    [sym_identifier] = ACTIONS(1564),
    [anon_sym_export] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_as] = ACTIONS(1566),
    [anon_sym_LBRACE] = ACTIONS(1568),
    [anon_sym_COMMA] = ACTIONS(1570),
    [anon_sym_RBRACE] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1564),
    [anon_sym_typeof] = ACTIONS(1564),
    [anon_sym_import] = ACTIONS(1564),
    [anon_sym_var] = ACTIONS(1564),
    [anon_sym_let] = ACTIONS(1564),
    [anon_sym_const] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(1564),
    [anon_sym_else] = ACTIONS(1564),
    [anon_sym_if] = ACTIONS(1564),
    [anon_sym_switch] = ACTIONS(1564),
    [anon_sym_for] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(1568),
    [anon_sym_await] = ACTIONS(1564),
    [anon_sym_in] = ACTIONS(1566),
    [anon_sym_while] = ACTIONS(1564),
    [anon_sym_do] = ACTIONS(1564),
    [anon_sym_try] = ACTIONS(1564),
    [anon_sym_with] = ACTIONS(1564),
    [anon_sym_break] = ACTIONS(1564),
    [anon_sym_continue] = ACTIONS(1564),
    [anon_sym_debugger] = ACTIONS(1564),
    [anon_sym_return] = ACTIONS(1564),
    [anon_sym_throw] = ACTIONS(1564),
    [anon_sym_SEMI] = ACTIONS(1568),
    [anon_sym_case] = ACTIONS(1564),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_yield] = ACTIONS(1564),
    [anon_sym_LBRACK] = ACTIONS(1568),
    [anon_sym_LTtemplate_GT] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1566),
    [anon_sym_SLASH] = ACTIONS(1564),
    [anon_sym_DOT] = ACTIONS(1566),
    [anon_sym_class] = ACTIONS(1564),
    [anon_sym_async] = ACTIONS(1564),
    [anon_sym_function] = ACTIONS(1564),
    [anon_sym_QMARK_DOT] = ACTIONS(1570),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_AMP_AMP] = ACTIONS(1570),
    [anon_sym_PIPE_PIPE] = ACTIONS(1570),
    [anon_sym_GT_GT] = ACTIONS(1566),
    [anon_sym_GT_GT_GT] = ACTIONS(1570),
    [anon_sym_LT_LT] = ACTIONS(1570),
    [anon_sym_AMP] = ACTIONS(1564),
    [anon_sym_CARET] = ACTIONS(1570),
    [anon_sym_PIPE] = ACTIONS(1566),
    [anon_sym_PLUS] = ACTIONS(1564),
    [anon_sym_DASH] = ACTIONS(1564),
    [anon_sym_PERCENT] = ACTIONS(1570),
    [anon_sym_STAR_STAR] = ACTIONS(1570),
    [anon_sym_LT_EQ] = ACTIONS(1570),
    [anon_sym_EQ_EQ] = ACTIONS(1566),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1570),
    [anon_sym_BANG_EQ] = ACTIONS(1566),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1570),
    [anon_sym_GT_EQ] = ACTIONS(1570),
    [anon_sym_QMARK_QMARK] = ACTIONS(1570),
    [anon_sym_instanceof] = ACTIONS(1566),
    [anon_sym_TILDE] = ACTIONS(1568),
    [anon_sym_void] = ACTIONS(1564),
    [anon_sym_delete] = ACTIONS(1564),
    [anon_sym_PLUS_PLUS] = ACTIONS(1568),
    [anon_sym_DASH_DASH] = ACTIONS(1568),
    [anon_sym_DQUOTE] = ACTIONS(1568),
    [anon_sym_SQUOTE] = ACTIONS(1568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1568),
    [sym_number] = ACTIONS(1568),
    [sym_this] = ACTIONS(1564),
    [sym_super] = ACTIONS(1564),
    [sym_true] = ACTIONS(1564),
    [sym_false] = ACTIONS(1564),
    [sym_null] = ACTIONS(1564),
    [sym_undefined] = ACTIONS(1564),
    [anon_sym_AT] = ACTIONS(1568),
    [anon_sym_static] = ACTIONS(1564),
    [anon_sym_readonly] = ACTIONS(1564),
    [anon_sym_get] = ACTIONS(1564),
    [anon_sym_set] = ACTIONS(1564),
    [anon_sym_declare] = ACTIONS(1564),
    [anon_sym_namespace] = ACTIONS(1564),
    [anon_sym_public] = ACTIONS(1564),
    [anon_sym_private] = ACTIONS(1564),
    [anon_sym_protected] = ACTIONS(1564),
    [anon_sym_override] = ACTIONS(1564),
    [anon_sym_module] = ACTIONS(1564),
    [anon_sym_any] = ACTIONS(1564),
    [anon_sym_number] = ACTIONS(1564),
    [anon_sym_boolean] = ACTIONS(1564),
    [anon_sym_string] = ACTIONS(1564),
    [anon_sym_symbol] = ACTIONS(1564),
    [anon_sym_abstract] = ACTIONS(1564),
    [anon_sym_satisfies] = ACTIONS(1566),
    [anon_sym_interface] = ACTIONS(1564),
    [anon_sym_enum] = ACTIONS(1564),
    [anon_sym_component] = ACTIONS(1564),
    [sym__automatic_semicolon] = ACTIONS(1572),
    [sym__ternary_qmark] = ACTIONS(1570),
  },
  [195] = {
    [sym_identifier] = ACTIONS(1574),
    [anon_sym_export] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_as] = ACTIONS(1576),
    [anon_sym_LBRACE] = ACTIONS(1578),
    [anon_sym_COMMA] = ACTIONS(1580),
    [anon_sym_RBRACE] = ACTIONS(1578),
    [anon_sym_type] = ACTIONS(1574),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(1574),
    [anon_sym_var] = ACTIONS(1574),
    [anon_sym_let] = ACTIONS(1574),
    [anon_sym_const] = ACTIONS(1574),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_else] = ACTIONS(1574),
    [anon_sym_if] = ACTIONS(1574),
    [anon_sym_switch] = ACTIONS(1574),
    [anon_sym_for] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1578),
    [anon_sym_await] = ACTIONS(1574),
    [anon_sym_in] = ACTIONS(1576),
    [anon_sym_while] = ACTIONS(1574),
    [anon_sym_do] = ACTIONS(1574),
    [anon_sym_try] = ACTIONS(1574),
    [anon_sym_with] = ACTIONS(1574),
    [anon_sym_break] = ACTIONS(1574),
    [anon_sym_continue] = ACTIONS(1574),
    [anon_sym_debugger] = ACTIONS(1574),
    [anon_sym_return] = ACTIONS(1574),
    [anon_sym_throw] = ACTIONS(1574),
    [anon_sym_SEMI] = ACTIONS(1578),
    [anon_sym_case] = ACTIONS(1574),
    [anon_sym_default] = ACTIONS(1574),
    [anon_sym_yield] = ACTIONS(1574),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_LTtemplate_GT] = ACTIONS(1578),
    [anon_sym_LT] = ACTIONS(1574),
    [anon_sym_GT] = ACTIONS(1576),
    [anon_sym_SLASH] = ACTIONS(1574),
    [anon_sym_DOT] = ACTIONS(1576),
    [anon_sym_class] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1574),
    [anon_sym_function] = ACTIONS(1574),
    [anon_sym_QMARK_DOT] = ACTIONS(1580),
    [anon_sym_new] = ACTIONS(1574),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1576),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1576),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ] = ACTIONS(1576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ] = ACTIONS(1576),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1580),
    [anon_sym_GT_EQ] = ACTIONS(1580),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1576),
    [anon_sym_TILDE] = ACTIONS(1578),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1578),
    [anon_sym_DASH_DASH] = ACTIONS(1578),
    [anon_sym_DQUOTE] = ACTIONS(1578),
    [anon_sym_SQUOTE] = ACTIONS(1578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1578),
    [sym_number] = ACTIONS(1578),
    [sym_this] = ACTIONS(1574),
    [sym_super] = ACTIONS(1574),
    [sym_true] = ACTIONS(1574),
    [sym_false] = ACTIONS(1574),
    [sym_null] = ACTIONS(1574),
    [sym_undefined] = ACTIONS(1574),
    [anon_sym_AT] = ACTIONS(1578),
    [anon_sym_static] = ACTIONS(1574),
    [anon_sym_readonly] = ACTIONS(1574),
    [anon_sym_get] = ACTIONS(1574),
    [anon_sym_set] = ACTIONS(1574),
    [anon_sym_declare] = ACTIONS(1574),
    [anon_sym_namespace] = ACTIONS(1574),
    [anon_sym_public] = ACTIONS(1574),
    [anon_sym_private] = ACTIONS(1574),
    [anon_sym_protected] = ACTIONS(1574),
    [anon_sym_override] = ACTIONS(1574),
    [anon_sym_module] = ACTIONS(1574),
    [anon_sym_any] = ACTIONS(1574),
    [anon_sym_number] = ACTIONS(1574),
    [anon_sym_boolean] = ACTIONS(1574),
    [anon_sym_string] = ACTIONS(1574),
    [anon_sym_symbol] = ACTIONS(1574),
    [anon_sym_abstract] = ACTIONS(1574),
    [anon_sym_satisfies] = ACTIONS(1576),
    [anon_sym_interface] = ACTIONS(1574),
    [anon_sym_enum] = ACTIONS(1574),
    [anon_sym_component] = ACTIONS(1574),
    [sym__automatic_semicolon] = ACTIONS(1582),
    [sym__ternary_qmark] = ACTIONS(1580),
  },
  [196] = {
    [sym_identifier] = ACTIONS(1584),
    [anon_sym_export] = ACTIONS(1584),
    [anon_sym_STAR] = ACTIONS(1586),
    [anon_sym_as] = ACTIONS(1586),
    [anon_sym_LBRACE] = ACTIONS(1588),
    [anon_sym_COMMA] = ACTIONS(1590),
    [anon_sym_RBRACE] = ACTIONS(1588),
    [anon_sym_type] = ACTIONS(1584),
    [anon_sym_typeof] = ACTIONS(1584),
    [anon_sym_import] = ACTIONS(1584),
    [anon_sym_var] = ACTIONS(1584),
    [anon_sym_let] = ACTIONS(1584),
    [anon_sym_const] = ACTIONS(1584),
    [anon_sym_BANG] = ACTIONS(1584),
    [anon_sym_else] = ACTIONS(1584),
    [anon_sym_if] = ACTIONS(1584),
    [anon_sym_switch] = ACTIONS(1584),
    [anon_sym_for] = ACTIONS(1584),
    [anon_sym_LPAREN] = ACTIONS(1588),
    [anon_sym_await] = ACTIONS(1584),
    [anon_sym_in] = ACTIONS(1586),
    [anon_sym_while] = ACTIONS(1584),
    [anon_sym_do] = ACTIONS(1584),
    [anon_sym_try] = ACTIONS(1584),
    [anon_sym_with] = ACTIONS(1584),
    [anon_sym_break] = ACTIONS(1584),
    [anon_sym_continue] = ACTIONS(1584),
    [anon_sym_debugger] = ACTIONS(1584),
    [anon_sym_return] = ACTIONS(1584),
    [anon_sym_throw] = ACTIONS(1584),
    [anon_sym_SEMI] = ACTIONS(1588),
    [anon_sym_case] = ACTIONS(1584),
    [anon_sym_default] = ACTIONS(1584),
    [anon_sym_yield] = ACTIONS(1584),
    [anon_sym_LBRACK] = ACTIONS(1588),
    [anon_sym_LTtemplate_GT] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1584),
    [anon_sym_GT] = ACTIONS(1586),
    [anon_sym_SLASH] = ACTIONS(1584),
    [anon_sym_DOT] = ACTIONS(1586),
    [anon_sym_class] = ACTIONS(1584),
    [anon_sym_async] = ACTIONS(1584),
    [anon_sym_function] = ACTIONS(1584),
    [anon_sym_QMARK_DOT] = ACTIONS(1590),
    [anon_sym_new] = ACTIONS(1584),
    [anon_sym_AMP_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1590),
    [anon_sym_GT_GT] = ACTIONS(1586),
    [anon_sym_GT_GT_GT] = ACTIONS(1590),
    [anon_sym_LT_LT] = ACTIONS(1590),
    [anon_sym_AMP] = ACTIONS(1584),
    [anon_sym_CARET] = ACTIONS(1590),
    [anon_sym_PIPE] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1584),
    [anon_sym_DASH] = ACTIONS(1584),
    [anon_sym_PERCENT] = ACTIONS(1590),
    [anon_sym_STAR_STAR] = ACTIONS(1590),
    [anon_sym_LT_EQ] = ACTIONS(1590),
    [anon_sym_EQ_EQ] = ACTIONS(1586),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1590),
    [anon_sym_BANG_EQ] = ACTIONS(1586),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1590),
    [anon_sym_QMARK_QMARK] = ACTIONS(1590),
    [anon_sym_instanceof] = ACTIONS(1586),
    [anon_sym_TILDE] = ACTIONS(1588),
    [anon_sym_void] = ACTIONS(1584),
    [anon_sym_delete] = ACTIONS(1584),
    [anon_sym_PLUS_PLUS] = ACTIONS(1588),
    [anon_sym_DASH_DASH] = ACTIONS(1588),
    [anon_sym_DQUOTE] = ACTIONS(1588),
    [anon_sym_SQUOTE] = ACTIONS(1588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1588),
    [sym_number] = ACTIONS(1588),
    [sym_this] = ACTIONS(1584),
    [sym_super] = ACTIONS(1584),
    [sym_true] = ACTIONS(1584),
    [sym_false] = ACTIONS(1584),
    [sym_null] = ACTIONS(1584),
    [sym_undefined] = ACTIONS(1584),
    [anon_sym_AT] = ACTIONS(1588),
    [anon_sym_static] = ACTIONS(1584),
    [anon_sym_readonly] = ACTIONS(1584),
    [anon_sym_get] = ACTIONS(1584),
    [anon_sym_set] = ACTIONS(1584),
    [anon_sym_declare] = ACTIONS(1584),
    [anon_sym_namespace] = ACTIONS(1584),
    [anon_sym_public] = ACTIONS(1584),
    [anon_sym_private] = ACTIONS(1584),
    [anon_sym_protected] = ACTIONS(1584),
    [anon_sym_override] = ACTIONS(1584),
    [anon_sym_module] = ACTIONS(1584),
    [anon_sym_any] = ACTIONS(1584),
    [anon_sym_number] = ACTIONS(1584),
    [anon_sym_boolean] = ACTIONS(1584),
    [anon_sym_string] = ACTIONS(1584),
    [anon_sym_symbol] = ACTIONS(1584),
    [anon_sym_abstract] = ACTIONS(1584),
    [anon_sym_satisfies] = ACTIONS(1586),
    [anon_sym_interface] = ACTIONS(1584),
    [anon_sym_enum] = ACTIONS(1584),
    [anon_sym_component] = ACTIONS(1584),
    [sym__automatic_semicolon] = ACTIONS(1592),
    [sym__ternary_qmark] = ACTIONS(1590),
  },
  [197] = {
    [sym_identifier] = ACTIONS(1594),
    [anon_sym_export] = ACTIONS(1594),
    [anon_sym_STAR] = ACTIONS(1596),
    [anon_sym_as] = ACTIONS(1596),
    [anon_sym_LBRACE] = ACTIONS(1598),
    [anon_sym_COMMA] = ACTIONS(1600),
    [anon_sym_RBRACE] = ACTIONS(1598),
    [anon_sym_type] = ACTIONS(1594),
    [anon_sym_typeof] = ACTIONS(1594),
    [anon_sym_import] = ACTIONS(1594),
    [anon_sym_var] = ACTIONS(1594),
    [anon_sym_let] = ACTIONS(1594),
    [anon_sym_const] = ACTIONS(1594),
    [anon_sym_BANG] = ACTIONS(1594),
    [anon_sym_else] = ACTIONS(1594),
    [anon_sym_if] = ACTIONS(1594),
    [anon_sym_switch] = ACTIONS(1594),
    [anon_sym_for] = ACTIONS(1594),
    [anon_sym_LPAREN] = ACTIONS(1598),
    [anon_sym_await] = ACTIONS(1594),
    [anon_sym_in] = ACTIONS(1596),
    [anon_sym_while] = ACTIONS(1594),
    [anon_sym_do] = ACTIONS(1594),
    [anon_sym_try] = ACTIONS(1594),
    [anon_sym_with] = ACTIONS(1594),
    [anon_sym_break] = ACTIONS(1594),
    [anon_sym_continue] = ACTIONS(1594),
    [anon_sym_debugger] = ACTIONS(1594),
    [anon_sym_return] = ACTIONS(1594),
    [anon_sym_throw] = ACTIONS(1594),
    [anon_sym_SEMI] = ACTIONS(1598),
    [anon_sym_case] = ACTIONS(1594),
    [anon_sym_default] = ACTIONS(1594),
    [anon_sym_yield] = ACTIONS(1594),
    [anon_sym_LBRACK] = ACTIONS(1598),
    [anon_sym_LTtemplate_GT] = ACTIONS(1598),
    [anon_sym_LT] = ACTIONS(1594),
    [anon_sym_GT] = ACTIONS(1596),
    [anon_sym_SLASH] = ACTIONS(1594),
    [anon_sym_DOT] = ACTIONS(1596),
    [anon_sym_class] = ACTIONS(1594),
    [anon_sym_async] = ACTIONS(1594),
    [anon_sym_function] = ACTIONS(1594),
    [anon_sym_QMARK_DOT] = ACTIONS(1600),
    [anon_sym_new] = ACTIONS(1594),
    [anon_sym_AMP_AMP] = ACTIONS(1600),
    [anon_sym_PIPE_PIPE] = ACTIONS(1600),
    [anon_sym_GT_GT] = ACTIONS(1596),
    [anon_sym_GT_GT_GT] = ACTIONS(1600),
    [anon_sym_LT_LT] = ACTIONS(1600),
    [anon_sym_AMP] = ACTIONS(1594),
    [anon_sym_CARET] = ACTIONS(1600),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_PLUS] = ACTIONS(1594),
    [anon_sym_DASH] = ACTIONS(1594),
    [anon_sym_PERCENT] = ACTIONS(1600),
    [anon_sym_STAR_STAR] = ACTIONS(1600),
    [anon_sym_LT_EQ] = ACTIONS(1600),
    [anon_sym_EQ_EQ] = ACTIONS(1596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1596),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1600),
    [anon_sym_GT_EQ] = ACTIONS(1600),
    [anon_sym_QMARK_QMARK] = ACTIONS(1600),
    [anon_sym_instanceof] = ACTIONS(1596),
    [anon_sym_TILDE] = ACTIONS(1598),
    [anon_sym_void] = ACTIONS(1594),
    [anon_sym_delete] = ACTIONS(1594),
    [anon_sym_PLUS_PLUS] = ACTIONS(1598),
    [anon_sym_DASH_DASH] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1598),
    [sym_number] = ACTIONS(1598),
    [sym_this] = ACTIONS(1594),
    [sym_super] = ACTIONS(1594),
    [sym_true] = ACTIONS(1594),
    [sym_false] = ACTIONS(1594),
    [sym_null] = ACTIONS(1594),
    [sym_undefined] = ACTIONS(1594),
    [anon_sym_AT] = ACTIONS(1598),
    [anon_sym_static] = ACTIONS(1594),
    [anon_sym_readonly] = ACTIONS(1594),
    [anon_sym_get] = ACTIONS(1594),
    [anon_sym_set] = ACTIONS(1594),
    [anon_sym_declare] = ACTIONS(1594),
    [anon_sym_namespace] = ACTIONS(1594),
    [anon_sym_public] = ACTIONS(1594),
    [anon_sym_private] = ACTIONS(1594),
    [anon_sym_protected] = ACTIONS(1594),
    [anon_sym_override] = ACTIONS(1594),
    [anon_sym_module] = ACTIONS(1594),
    [anon_sym_any] = ACTIONS(1594),
    [anon_sym_number] = ACTIONS(1594),
    [anon_sym_boolean] = ACTIONS(1594),
    [anon_sym_string] = ACTIONS(1594),
    [anon_sym_symbol] = ACTIONS(1594),
    [anon_sym_abstract] = ACTIONS(1594),
    [anon_sym_satisfies] = ACTIONS(1596),
    [anon_sym_interface] = ACTIONS(1594),
    [anon_sym_enum] = ACTIONS(1594),
    [anon_sym_component] = ACTIONS(1594),
    [sym__automatic_semicolon] = ACTIONS(1602),
    [sym__ternary_qmark] = ACTIONS(1600),
  },
  [198] = {
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_export] = ACTIONS(1604),
    [anon_sym_STAR] = ACTIONS(1606),
    [anon_sym_as] = ACTIONS(1606),
    [anon_sym_LBRACE] = ACTIONS(1608),
    [anon_sym_COMMA] = ACTIONS(1610),
    [anon_sym_RBRACE] = ACTIONS(1608),
    [anon_sym_type] = ACTIONS(1604),
    [anon_sym_typeof] = ACTIONS(1604),
    [anon_sym_import] = ACTIONS(1604),
    [anon_sym_var] = ACTIONS(1604),
    [anon_sym_let] = ACTIONS(1604),
    [anon_sym_const] = ACTIONS(1604),
    [anon_sym_BANG] = ACTIONS(1604),
    [anon_sym_else] = ACTIONS(1604),
    [anon_sym_if] = ACTIONS(1604),
    [anon_sym_switch] = ACTIONS(1604),
    [anon_sym_for] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1608),
    [anon_sym_await] = ACTIONS(1604),
    [anon_sym_in] = ACTIONS(1606),
    [anon_sym_while] = ACTIONS(1604),
    [anon_sym_do] = ACTIONS(1604),
    [anon_sym_try] = ACTIONS(1604),
    [anon_sym_with] = ACTIONS(1604),
    [anon_sym_break] = ACTIONS(1604),
    [anon_sym_continue] = ACTIONS(1604),
    [anon_sym_debugger] = ACTIONS(1604),
    [anon_sym_return] = ACTIONS(1604),
    [anon_sym_throw] = ACTIONS(1604),
    [anon_sym_SEMI] = ACTIONS(1608),
    [anon_sym_case] = ACTIONS(1604),
    [anon_sym_default] = ACTIONS(1604),
    [anon_sym_yield] = ACTIONS(1604),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_LTtemplate_GT] = ACTIONS(1608),
    [anon_sym_LT] = ACTIONS(1604),
    [anon_sym_GT] = ACTIONS(1606),
    [anon_sym_SLASH] = ACTIONS(1604),
    [anon_sym_DOT] = ACTIONS(1606),
    [anon_sym_class] = ACTIONS(1604),
    [anon_sym_async] = ACTIONS(1604),
    [anon_sym_function] = ACTIONS(1604),
    [anon_sym_QMARK_DOT] = ACTIONS(1610),
    [anon_sym_new] = ACTIONS(1604),
    [anon_sym_AMP_AMP] = ACTIONS(1610),
    [anon_sym_PIPE_PIPE] = ACTIONS(1610),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_GT_GT_GT] = ACTIONS(1610),
    [anon_sym_LT_LT] = ACTIONS(1610),
    [anon_sym_AMP] = ACTIONS(1604),
    [anon_sym_CARET] = ACTIONS(1610),
    [anon_sym_PIPE] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1604),
    [anon_sym_DASH] = ACTIONS(1604),
    [anon_sym_PERCENT] = ACTIONS(1610),
    [anon_sym_STAR_STAR] = ACTIONS(1610),
    [anon_sym_LT_EQ] = ACTIONS(1610),
    [anon_sym_EQ_EQ] = ACTIONS(1606),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1610),
    [anon_sym_BANG_EQ] = ACTIONS(1606),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1610),
    [anon_sym_GT_EQ] = ACTIONS(1610),
    [anon_sym_QMARK_QMARK] = ACTIONS(1610),
    [anon_sym_instanceof] = ACTIONS(1606),
    [anon_sym_TILDE] = ACTIONS(1608),
    [anon_sym_void] = ACTIONS(1604),
    [anon_sym_delete] = ACTIONS(1604),
    [anon_sym_PLUS_PLUS] = ACTIONS(1608),
    [anon_sym_DASH_DASH] = ACTIONS(1608),
    [anon_sym_DQUOTE] = ACTIONS(1608),
    [anon_sym_SQUOTE] = ACTIONS(1608),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1608),
    [sym_number] = ACTIONS(1608),
    [sym_this] = ACTIONS(1604),
    [sym_super] = ACTIONS(1604),
    [sym_true] = ACTIONS(1604),
    [sym_false] = ACTIONS(1604),
    [sym_null] = ACTIONS(1604),
    [sym_undefined] = ACTIONS(1604),
    [anon_sym_AT] = ACTIONS(1608),
    [anon_sym_static] = ACTIONS(1604),
    [anon_sym_readonly] = ACTIONS(1604),
    [anon_sym_get] = ACTIONS(1604),
    [anon_sym_set] = ACTIONS(1604),
    [anon_sym_declare] = ACTIONS(1604),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_public] = ACTIONS(1604),
    [anon_sym_private] = ACTIONS(1604),
    [anon_sym_protected] = ACTIONS(1604),
    [anon_sym_override] = ACTIONS(1604),
    [anon_sym_module] = ACTIONS(1604),
    [anon_sym_any] = ACTIONS(1604),
    [anon_sym_number] = ACTIONS(1604),
    [anon_sym_boolean] = ACTIONS(1604),
    [anon_sym_string] = ACTIONS(1604),
    [anon_sym_symbol] = ACTIONS(1604),
    [anon_sym_abstract] = ACTIONS(1604),
    [anon_sym_satisfies] = ACTIONS(1606),
    [anon_sym_interface] = ACTIONS(1604),
    [anon_sym_enum] = ACTIONS(1604),
    [anon_sym_component] = ACTIONS(1604),
    [sym__automatic_semicolon] = ACTIONS(1612),
    [sym__ternary_qmark] = ACTIONS(1610),
  },
  [199] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2358),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4791),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1614),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [200] = {
    [sym_identifier] = ACTIONS(1616),
    [anon_sym_export] = ACTIONS(1616),
    [anon_sym_STAR] = ACTIONS(1618),
    [anon_sym_as] = ACTIONS(1618),
    [anon_sym_LBRACE] = ACTIONS(1620),
    [anon_sym_COMMA] = ACTIONS(1622),
    [anon_sym_RBRACE] = ACTIONS(1620),
    [anon_sym_type] = ACTIONS(1616),
    [anon_sym_typeof] = ACTIONS(1616),
    [anon_sym_import] = ACTIONS(1616),
    [anon_sym_var] = ACTIONS(1616),
    [anon_sym_let] = ACTIONS(1616),
    [anon_sym_const] = ACTIONS(1616),
    [anon_sym_BANG] = ACTIONS(1616),
    [anon_sym_else] = ACTIONS(1616),
    [anon_sym_if] = ACTIONS(1616),
    [anon_sym_switch] = ACTIONS(1616),
    [anon_sym_for] = ACTIONS(1616),
    [anon_sym_LPAREN] = ACTIONS(1620),
    [anon_sym_await] = ACTIONS(1616),
    [anon_sym_in] = ACTIONS(1618),
    [anon_sym_while] = ACTIONS(1616),
    [anon_sym_do] = ACTIONS(1616),
    [anon_sym_try] = ACTIONS(1616),
    [anon_sym_with] = ACTIONS(1616),
    [anon_sym_break] = ACTIONS(1616),
    [anon_sym_continue] = ACTIONS(1616),
    [anon_sym_debugger] = ACTIONS(1616),
    [anon_sym_return] = ACTIONS(1616),
    [anon_sym_throw] = ACTIONS(1616),
    [anon_sym_SEMI] = ACTIONS(1620),
    [anon_sym_case] = ACTIONS(1616),
    [anon_sym_default] = ACTIONS(1616),
    [anon_sym_yield] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_LTtemplate_GT] = ACTIONS(1620),
    [anon_sym_LT] = ACTIONS(1616),
    [anon_sym_GT] = ACTIONS(1618),
    [anon_sym_SLASH] = ACTIONS(1616),
    [anon_sym_DOT] = ACTIONS(1618),
    [anon_sym_class] = ACTIONS(1616),
    [anon_sym_async] = ACTIONS(1616),
    [anon_sym_function] = ACTIONS(1616),
    [anon_sym_QMARK_DOT] = ACTIONS(1622),
    [anon_sym_new] = ACTIONS(1616),
    [anon_sym_AMP_AMP] = ACTIONS(1622),
    [anon_sym_PIPE_PIPE] = ACTIONS(1622),
    [anon_sym_GT_GT] = ACTIONS(1618),
    [anon_sym_GT_GT_GT] = ACTIONS(1622),
    [anon_sym_LT_LT] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1616),
    [anon_sym_CARET] = ACTIONS(1622),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_PLUS] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1616),
    [anon_sym_PERCENT] = ACTIONS(1622),
    [anon_sym_STAR_STAR] = ACTIONS(1622),
    [anon_sym_LT_EQ] = ACTIONS(1622),
    [anon_sym_EQ_EQ] = ACTIONS(1618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1622),
    [anon_sym_BANG_EQ] = ACTIONS(1618),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1622),
    [anon_sym_GT_EQ] = ACTIONS(1622),
    [anon_sym_QMARK_QMARK] = ACTIONS(1622),
    [anon_sym_instanceof] = ACTIONS(1618),
    [anon_sym_TILDE] = ACTIONS(1620),
    [anon_sym_void] = ACTIONS(1616),
    [anon_sym_delete] = ACTIONS(1616),
    [anon_sym_PLUS_PLUS] = ACTIONS(1620),
    [anon_sym_DASH_DASH] = ACTIONS(1620),
    [anon_sym_DQUOTE] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(1620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1620),
    [sym_number] = ACTIONS(1620),
    [sym_this] = ACTIONS(1616),
    [sym_super] = ACTIONS(1616),
    [sym_true] = ACTIONS(1616),
    [sym_false] = ACTIONS(1616),
    [sym_null] = ACTIONS(1616),
    [sym_undefined] = ACTIONS(1616),
    [anon_sym_AT] = ACTIONS(1620),
    [anon_sym_static] = ACTIONS(1616),
    [anon_sym_readonly] = ACTIONS(1616),
    [anon_sym_get] = ACTIONS(1616),
    [anon_sym_set] = ACTIONS(1616),
    [anon_sym_declare] = ACTIONS(1616),
    [anon_sym_namespace] = ACTIONS(1616),
    [anon_sym_public] = ACTIONS(1616),
    [anon_sym_private] = ACTIONS(1616),
    [anon_sym_protected] = ACTIONS(1616),
    [anon_sym_override] = ACTIONS(1616),
    [anon_sym_module] = ACTIONS(1616),
    [anon_sym_any] = ACTIONS(1616),
    [anon_sym_number] = ACTIONS(1616),
    [anon_sym_boolean] = ACTIONS(1616),
    [anon_sym_string] = ACTIONS(1616),
    [anon_sym_symbol] = ACTIONS(1616),
    [anon_sym_abstract] = ACTIONS(1616),
    [anon_sym_satisfies] = ACTIONS(1618),
    [anon_sym_interface] = ACTIONS(1616),
    [anon_sym_enum] = ACTIONS(1616),
    [anon_sym_component] = ACTIONS(1616),
    [sym__automatic_semicolon] = ACTIONS(1624),
    [sym__ternary_qmark] = ACTIONS(1622),
  },
  [201] = {
    [sym_identifier] = ACTIONS(1626),
    [anon_sym_export] = ACTIONS(1626),
    [anon_sym_STAR] = ACTIONS(1628),
    [anon_sym_as] = ACTIONS(1628),
    [anon_sym_LBRACE] = ACTIONS(1630),
    [anon_sym_COMMA] = ACTIONS(1632),
    [anon_sym_RBRACE] = ACTIONS(1630),
    [anon_sym_type] = ACTIONS(1626),
    [anon_sym_typeof] = ACTIONS(1626),
    [anon_sym_import] = ACTIONS(1626),
    [anon_sym_var] = ACTIONS(1626),
    [anon_sym_let] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1626),
    [anon_sym_BANG] = ACTIONS(1626),
    [anon_sym_else] = ACTIONS(1626),
    [anon_sym_if] = ACTIONS(1626),
    [anon_sym_switch] = ACTIONS(1626),
    [anon_sym_for] = ACTIONS(1626),
    [anon_sym_LPAREN] = ACTIONS(1630),
    [anon_sym_await] = ACTIONS(1626),
    [anon_sym_in] = ACTIONS(1628),
    [anon_sym_while] = ACTIONS(1626),
    [anon_sym_do] = ACTIONS(1626),
    [anon_sym_try] = ACTIONS(1626),
    [anon_sym_with] = ACTIONS(1626),
    [anon_sym_break] = ACTIONS(1626),
    [anon_sym_continue] = ACTIONS(1626),
    [anon_sym_debugger] = ACTIONS(1626),
    [anon_sym_return] = ACTIONS(1626),
    [anon_sym_throw] = ACTIONS(1626),
    [anon_sym_SEMI] = ACTIONS(1630),
    [anon_sym_case] = ACTIONS(1626),
    [anon_sym_default] = ACTIONS(1626),
    [anon_sym_yield] = ACTIONS(1626),
    [anon_sym_LBRACK] = ACTIONS(1630),
    [anon_sym_LTtemplate_GT] = ACTIONS(1630),
    [anon_sym_LT] = ACTIONS(1626),
    [anon_sym_GT] = ACTIONS(1628),
    [anon_sym_SLASH] = ACTIONS(1626),
    [anon_sym_DOT] = ACTIONS(1628),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1626),
    [anon_sym_function] = ACTIONS(1626),
    [anon_sym_QMARK_DOT] = ACTIONS(1632),
    [anon_sym_new] = ACTIONS(1626),
    [anon_sym_AMP_AMP] = ACTIONS(1632),
    [anon_sym_PIPE_PIPE] = ACTIONS(1632),
    [anon_sym_GT_GT] = ACTIONS(1628),
    [anon_sym_GT_GT_GT] = ACTIONS(1632),
    [anon_sym_LT_LT] = ACTIONS(1632),
    [anon_sym_AMP] = ACTIONS(1626),
    [anon_sym_CARET] = ACTIONS(1632),
    [anon_sym_PIPE] = ACTIONS(1628),
    [anon_sym_PLUS] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1626),
    [anon_sym_PERCENT] = ACTIONS(1632),
    [anon_sym_STAR_STAR] = ACTIONS(1632),
    [anon_sym_LT_EQ] = ACTIONS(1632),
    [anon_sym_EQ_EQ] = ACTIONS(1628),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1632),
    [anon_sym_BANG_EQ] = ACTIONS(1628),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1632),
    [anon_sym_GT_EQ] = ACTIONS(1632),
    [anon_sym_QMARK_QMARK] = ACTIONS(1632),
    [anon_sym_instanceof] = ACTIONS(1628),
    [anon_sym_TILDE] = ACTIONS(1630),
    [anon_sym_void] = ACTIONS(1626),
    [anon_sym_delete] = ACTIONS(1626),
    [anon_sym_PLUS_PLUS] = ACTIONS(1630),
    [anon_sym_DASH_DASH] = ACTIONS(1630),
    [anon_sym_DQUOTE] = ACTIONS(1630),
    [anon_sym_SQUOTE] = ACTIONS(1630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1630),
    [sym_number] = ACTIONS(1630),
    [sym_this] = ACTIONS(1626),
    [sym_super] = ACTIONS(1626),
    [sym_true] = ACTIONS(1626),
    [sym_false] = ACTIONS(1626),
    [sym_null] = ACTIONS(1626),
    [sym_undefined] = ACTIONS(1626),
    [anon_sym_AT] = ACTIONS(1630),
    [anon_sym_static] = ACTIONS(1626),
    [anon_sym_readonly] = ACTIONS(1626),
    [anon_sym_get] = ACTIONS(1626),
    [anon_sym_set] = ACTIONS(1626),
    [anon_sym_declare] = ACTIONS(1626),
    [anon_sym_namespace] = ACTIONS(1626),
    [anon_sym_public] = ACTIONS(1626),
    [anon_sym_private] = ACTIONS(1626),
    [anon_sym_protected] = ACTIONS(1626),
    [anon_sym_override] = ACTIONS(1626),
    [anon_sym_module] = ACTIONS(1626),
    [anon_sym_any] = ACTIONS(1626),
    [anon_sym_number] = ACTIONS(1626),
    [anon_sym_boolean] = ACTIONS(1626),
    [anon_sym_string] = ACTIONS(1626),
    [anon_sym_symbol] = ACTIONS(1626),
    [anon_sym_abstract] = ACTIONS(1626),
    [anon_sym_satisfies] = ACTIONS(1628),
    [anon_sym_interface] = ACTIONS(1626),
    [anon_sym_enum] = ACTIONS(1626),
    [anon_sym_component] = ACTIONS(1626),
    [sym__automatic_semicolon] = ACTIONS(1634),
    [sym__ternary_qmark] = ACTIONS(1632),
  },
  [202] = {
    [sym_identifier] = ACTIONS(1636),
    [anon_sym_export] = ACTIONS(1636),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_as] = ACTIONS(1636),
    [anon_sym_LBRACE] = ACTIONS(1638),
    [anon_sym_COMMA] = ACTIONS(1638),
    [anon_sym_RBRACE] = ACTIONS(1638),
    [anon_sym_type] = ACTIONS(1636),
    [anon_sym_typeof] = ACTIONS(1636),
    [anon_sym_import] = ACTIONS(1636),
    [anon_sym_var] = ACTIONS(1636),
    [anon_sym_let] = ACTIONS(1636),
    [anon_sym_const] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1636),
    [anon_sym_else] = ACTIONS(1636),
    [anon_sym_if] = ACTIONS(1636),
    [anon_sym_switch] = ACTIONS(1636),
    [anon_sym_for] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_await] = ACTIONS(1636),
    [anon_sym_in] = ACTIONS(1636),
    [anon_sym_while] = ACTIONS(1636),
    [anon_sym_do] = ACTIONS(1636),
    [anon_sym_try] = ACTIONS(1636),
    [anon_sym_with] = ACTIONS(1636),
    [anon_sym_break] = ACTIONS(1636),
    [anon_sym_continue] = ACTIONS(1636),
    [anon_sym_debugger] = ACTIONS(1636),
    [anon_sym_return] = ACTIONS(1636),
    [anon_sym_throw] = ACTIONS(1636),
    [anon_sym_SEMI] = ACTIONS(1638),
    [anon_sym_case] = ACTIONS(1636),
    [anon_sym_default] = ACTIONS(1636),
    [anon_sym_yield] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(1638),
    [anon_sym_LTtemplate_GT] = ACTIONS(1638),
    [anon_sym_LT] = ACTIONS(1636),
    [anon_sym_GT] = ACTIONS(1636),
    [anon_sym_SLASH] = ACTIONS(1636),
    [anon_sym_DOT] = ACTIONS(1636),
    [anon_sym_class] = ACTIONS(1636),
    [anon_sym_async] = ACTIONS(1636),
    [anon_sym_function] = ACTIONS(1636),
    [anon_sym_QMARK_DOT] = ACTIONS(1638),
    [anon_sym_new] = ACTIONS(1636),
    [anon_sym_AMP_AMP] = ACTIONS(1638),
    [anon_sym_PIPE_PIPE] = ACTIONS(1638),
    [anon_sym_GT_GT] = ACTIONS(1636),
    [anon_sym_GT_GT_GT] = ACTIONS(1638),
    [anon_sym_LT_LT] = ACTIONS(1638),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_CARET] = ACTIONS(1638),
    [anon_sym_PIPE] = ACTIONS(1636),
    [anon_sym_PLUS] = ACTIONS(1636),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_PERCENT] = ACTIONS(1638),
    [anon_sym_STAR_STAR] = ACTIONS(1638),
    [anon_sym_LT_EQ] = ACTIONS(1638),
    [anon_sym_EQ_EQ] = ACTIONS(1636),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1638),
    [anon_sym_BANG_EQ] = ACTIONS(1636),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1638),
    [anon_sym_GT_EQ] = ACTIONS(1638),
    [anon_sym_QMARK_QMARK] = ACTIONS(1638),
    [anon_sym_instanceof] = ACTIONS(1636),
    [anon_sym_TILDE] = ACTIONS(1638),
    [anon_sym_void] = ACTIONS(1636),
    [anon_sym_delete] = ACTIONS(1636),
    [anon_sym_PLUS_PLUS] = ACTIONS(1638),
    [anon_sym_DASH_DASH] = ACTIONS(1638),
    [anon_sym_DQUOTE] = ACTIONS(1638),
    [anon_sym_SQUOTE] = ACTIONS(1638),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1638),
    [sym_number] = ACTIONS(1638),
    [sym_this] = ACTIONS(1636),
    [sym_super] = ACTIONS(1636),
    [sym_true] = ACTIONS(1636),
    [sym_false] = ACTIONS(1636),
    [sym_null] = ACTIONS(1636),
    [sym_undefined] = ACTIONS(1636),
    [anon_sym_AT] = ACTIONS(1638),
    [anon_sym_static] = ACTIONS(1636),
    [anon_sym_readonly] = ACTIONS(1636),
    [anon_sym_get] = ACTIONS(1636),
    [anon_sym_set] = ACTIONS(1636),
    [anon_sym_declare] = ACTIONS(1636),
    [anon_sym_namespace] = ACTIONS(1636),
    [anon_sym_public] = ACTIONS(1636),
    [anon_sym_private] = ACTIONS(1636),
    [anon_sym_protected] = ACTIONS(1636),
    [anon_sym_override] = ACTIONS(1636),
    [anon_sym_module] = ACTIONS(1636),
    [anon_sym_any] = ACTIONS(1636),
    [anon_sym_number] = ACTIONS(1636),
    [anon_sym_boolean] = ACTIONS(1636),
    [anon_sym_string] = ACTIONS(1636),
    [anon_sym_symbol] = ACTIONS(1636),
    [anon_sym_abstract] = ACTIONS(1636),
    [anon_sym_satisfies] = ACTIONS(1636),
    [anon_sym_interface] = ACTIONS(1636),
    [anon_sym_enum] = ACTIONS(1636),
    [anon_sym_component] = ACTIONS(1636),
    [sym__automatic_semicolon] = ACTIONS(1638),
    [sym__ternary_qmark] = ACTIONS(1638),
  },
  [203] = {
    [sym_identifier] = ACTIONS(1640),
    [anon_sym_export] = ACTIONS(1640),
    [anon_sym_STAR] = ACTIONS(1640),
    [anon_sym_as] = ACTIONS(1640),
    [anon_sym_LBRACE] = ACTIONS(1642),
    [anon_sym_COMMA] = ACTIONS(1642),
    [anon_sym_RBRACE] = ACTIONS(1642),
    [anon_sym_type] = ACTIONS(1640),
    [anon_sym_typeof] = ACTIONS(1640),
    [anon_sym_import] = ACTIONS(1640),
    [anon_sym_var] = ACTIONS(1640),
    [anon_sym_let] = ACTIONS(1640),
    [anon_sym_const] = ACTIONS(1640),
    [anon_sym_BANG] = ACTIONS(1640),
    [anon_sym_else] = ACTIONS(1640),
    [anon_sym_if] = ACTIONS(1640),
    [anon_sym_switch] = ACTIONS(1640),
    [anon_sym_for] = ACTIONS(1640),
    [anon_sym_LPAREN] = ACTIONS(1642),
    [anon_sym_await] = ACTIONS(1640),
    [anon_sym_in] = ACTIONS(1640),
    [anon_sym_while] = ACTIONS(1640),
    [anon_sym_do] = ACTIONS(1640),
    [anon_sym_try] = ACTIONS(1640),
    [anon_sym_with] = ACTIONS(1640),
    [anon_sym_break] = ACTIONS(1640),
    [anon_sym_continue] = ACTIONS(1640),
    [anon_sym_debugger] = ACTIONS(1640),
    [anon_sym_return] = ACTIONS(1640),
    [anon_sym_throw] = ACTIONS(1640),
    [anon_sym_SEMI] = ACTIONS(1642),
    [anon_sym_case] = ACTIONS(1640),
    [anon_sym_default] = ACTIONS(1640),
    [anon_sym_yield] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1642),
    [anon_sym_LTtemplate_GT] = ACTIONS(1642),
    [anon_sym_LT] = ACTIONS(1640),
    [anon_sym_GT] = ACTIONS(1640),
    [anon_sym_SLASH] = ACTIONS(1640),
    [anon_sym_DOT] = ACTIONS(1640),
    [anon_sym_class] = ACTIONS(1640),
    [anon_sym_async] = ACTIONS(1640),
    [anon_sym_function] = ACTIONS(1640),
    [anon_sym_QMARK_DOT] = ACTIONS(1642),
    [anon_sym_new] = ACTIONS(1640),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_GT_GT] = ACTIONS(1640),
    [anon_sym_GT_GT_GT] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1640),
    [anon_sym_CARET] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_DASH] = ACTIONS(1640),
    [anon_sym_PERCENT] = ACTIONS(1642),
    [anon_sym_STAR_STAR] = ACTIONS(1642),
    [anon_sym_LT_EQ] = ACTIONS(1642),
    [anon_sym_EQ_EQ] = ACTIONS(1640),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1642),
    [anon_sym_BANG_EQ] = ACTIONS(1640),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1642),
    [anon_sym_GT_EQ] = ACTIONS(1642),
    [anon_sym_QMARK_QMARK] = ACTIONS(1642),
    [anon_sym_instanceof] = ACTIONS(1640),
    [anon_sym_TILDE] = ACTIONS(1642),
    [anon_sym_void] = ACTIONS(1640),
    [anon_sym_delete] = ACTIONS(1640),
    [anon_sym_PLUS_PLUS] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [anon_sym_SQUOTE] = ACTIONS(1642),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [sym_number] = ACTIONS(1642),
    [sym_this] = ACTIONS(1640),
    [sym_super] = ACTIONS(1640),
    [sym_true] = ACTIONS(1640),
    [sym_false] = ACTIONS(1640),
    [sym_null] = ACTIONS(1640),
    [sym_undefined] = ACTIONS(1640),
    [anon_sym_AT] = ACTIONS(1642),
    [anon_sym_static] = ACTIONS(1640),
    [anon_sym_readonly] = ACTIONS(1640),
    [anon_sym_get] = ACTIONS(1640),
    [anon_sym_set] = ACTIONS(1640),
    [anon_sym_declare] = ACTIONS(1640),
    [anon_sym_namespace] = ACTIONS(1640),
    [anon_sym_public] = ACTIONS(1640),
    [anon_sym_private] = ACTIONS(1640),
    [anon_sym_protected] = ACTIONS(1640),
    [anon_sym_override] = ACTIONS(1640),
    [anon_sym_module] = ACTIONS(1640),
    [anon_sym_any] = ACTIONS(1640),
    [anon_sym_number] = ACTIONS(1640),
    [anon_sym_boolean] = ACTIONS(1640),
    [anon_sym_string] = ACTIONS(1640),
    [anon_sym_symbol] = ACTIONS(1640),
    [anon_sym_abstract] = ACTIONS(1640),
    [anon_sym_satisfies] = ACTIONS(1640),
    [anon_sym_interface] = ACTIONS(1640),
    [anon_sym_enum] = ACTIONS(1640),
    [anon_sym_component] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(1642),
    [sym__ternary_qmark] = ACTIONS(1642),
  },
  [204] = {
    [sym_identifier] = ACTIONS(1644),
    [anon_sym_export] = ACTIONS(1644),
    [anon_sym_STAR] = ACTIONS(1646),
    [anon_sym_as] = ACTIONS(1646),
    [anon_sym_LBRACE] = ACTIONS(1648),
    [anon_sym_COMMA] = ACTIONS(1650),
    [anon_sym_RBRACE] = ACTIONS(1648),
    [anon_sym_type] = ACTIONS(1644),
    [anon_sym_typeof] = ACTIONS(1644),
    [anon_sym_import] = ACTIONS(1644),
    [anon_sym_var] = ACTIONS(1644),
    [anon_sym_let] = ACTIONS(1644),
    [anon_sym_const] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1644),
    [anon_sym_else] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(1644),
    [anon_sym_switch] = ACTIONS(1644),
    [anon_sym_for] = ACTIONS(1644),
    [anon_sym_LPAREN] = ACTIONS(1648),
    [anon_sym_await] = ACTIONS(1644),
    [anon_sym_in] = ACTIONS(1646),
    [anon_sym_while] = ACTIONS(1644),
    [anon_sym_do] = ACTIONS(1644),
    [anon_sym_try] = ACTIONS(1644),
    [anon_sym_with] = ACTIONS(1644),
    [anon_sym_break] = ACTIONS(1644),
    [anon_sym_continue] = ACTIONS(1644),
    [anon_sym_debugger] = ACTIONS(1644),
    [anon_sym_return] = ACTIONS(1644),
    [anon_sym_throw] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1648),
    [anon_sym_case] = ACTIONS(1644),
    [anon_sym_default] = ACTIONS(1644),
    [anon_sym_yield] = ACTIONS(1644),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [anon_sym_LTtemplate_GT] = ACTIONS(1648),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_GT] = ACTIONS(1646),
    [anon_sym_SLASH] = ACTIONS(1644),
    [anon_sym_DOT] = ACTIONS(1646),
    [anon_sym_class] = ACTIONS(1644),
    [anon_sym_async] = ACTIONS(1644),
    [anon_sym_function] = ACTIONS(1644),
    [anon_sym_QMARK_DOT] = ACTIONS(1650),
    [anon_sym_new] = ACTIONS(1644),
    [anon_sym_AMP_AMP] = ACTIONS(1650),
    [anon_sym_PIPE_PIPE] = ACTIONS(1650),
    [anon_sym_GT_GT] = ACTIONS(1646),
    [anon_sym_GT_GT_GT] = ACTIONS(1650),
    [anon_sym_LT_LT] = ACTIONS(1650),
    [anon_sym_AMP] = ACTIONS(1644),
    [anon_sym_CARET] = ACTIONS(1650),
    [anon_sym_PIPE] = ACTIONS(1646),
    [anon_sym_PLUS] = ACTIONS(1644),
    [anon_sym_DASH] = ACTIONS(1644),
    [anon_sym_PERCENT] = ACTIONS(1650),
    [anon_sym_STAR_STAR] = ACTIONS(1650),
    [anon_sym_LT_EQ] = ACTIONS(1650),
    [anon_sym_EQ_EQ] = ACTIONS(1646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1650),
    [anon_sym_BANG_EQ] = ACTIONS(1646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1650),
    [anon_sym_GT_EQ] = ACTIONS(1650),
    [anon_sym_QMARK_QMARK] = ACTIONS(1650),
    [anon_sym_instanceof] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_void] = ACTIONS(1644),
    [anon_sym_delete] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1648),
    [anon_sym_DASH_DASH] = ACTIONS(1648),
    [anon_sym_DQUOTE] = ACTIONS(1648),
    [anon_sym_SQUOTE] = ACTIONS(1648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [sym_number] = ACTIONS(1648),
    [sym_this] = ACTIONS(1644),
    [sym_super] = ACTIONS(1644),
    [sym_true] = ACTIONS(1644),
    [sym_false] = ACTIONS(1644),
    [sym_null] = ACTIONS(1644),
    [sym_undefined] = ACTIONS(1644),
    [anon_sym_AT] = ACTIONS(1648),
    [anon_sym_static] = ACTIONS(1644),
    [anon_sym_readonly] = ACTIONS(1644),
    [anon_sym_get] = ACTIONS(1644),
    [anon_sym_set] = ACTIONS(1644),
    [anon_sym_declare] = ACTIONS(1644),
    [anon_sym_namespace] = ACTIONS(1644),
    [anon_sym_public] = ACTIONS(1644),
    [anon_sym_private] = ACTIONS(1644),
    [anon_sym_protected] = ACTIONS(1644),
    [anon_sym_override] = ACTIONS(1644),
    [anon_sym_module] = ACTIONS(1644),
    [anon_sym_any] = ACTIONS(1644),
    [anon_sym_number] = ACTIONS(1644),
    [anon_sym_boolean] = ACTIONS(1644),
    [anon_sym_string] = ACTIONS(1644),
    [anon_sym_symbol] = ACTIONS(1644),
    [anon_sym_abstract] = ACTIONS(1644),
    [anon_sym_satisfies] = ACTIONS(1646),
    [anon_sym_interface] = ACTIONS(1644),
    [anon_sym_enum] = ACTIONS(1644),
    [anon_sym_component] = ACTIONS(1644),
    [sym__automatic_semicolon] = ACTIONS(1652),
    [sym__ternary_qmark] = ACTIONS(1650),
  },
  [205] = {
    [sym_identifier] = ACTIONS(1366),
    [anon_sym_export] = ACTIONS(1366),
    [anon_sym_STAR] = ACTIONS(1366),
    [anon_sym_as] = ACTIONS(1366),
    [anon_sym_LBRACE] = ACTIONS(1370),
    [anon_sym_COMMA] = ACTIONS(1370),
    [anon_sym_RBRACE] = ACTIONS(1370),
    [anon_sym_type] = ACTIONS(1366),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_import] = ACTIONS(1366),
    [anon_sym_var] = ACTIONS(1366),
    [anon_sym_let] = ACTIONS(1366),
    [anon_sym_const] = ACTIONS(1366),
    [anon_sym_BANG] = ACTIONS(1366),
    [anon_sym_else] = ACTIONS(1366),
    [anon_sym_if] = ACTIONS(1366),
    [anon_sym_switch] = ACTIONS(1366),
    [anon_sym_for] = ACTIONS(1366),
    [anon_sym_LPAREN] = ACTIONS(1370),
    [anon_sym_await] = ACTIONS(1366),
    [anon_sym_in] = ACTIONS(1366),
    [anon_sym_while] = ACTIONS(1366),
    [anon_sym_do] = ACTIONS(1366),
    [anon_sym_try] = ACTIONS(1366),
    [anon_sym_with] = ACTIONS(1366),
    [anon_sym_break] = ACTIONS(1366),
    [anon_sym_continue] = ACTIONS(1366),
    [anon_sym_debugger] = ACTIONS(1366),
    [anon_sym_return] = ACTIONS(1366),
    [anon_sym_throw] = ACTIONS(1366),
    [anon_sym_SEMI] = ACTIONS(1370),
    [anon_sym_case] = ACTIONS(1366),
    [anon_sym_default] = ACTIONS(1366),
    [anon_sym_yield] = ACTIONS(1366),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_LTtemplate_GT] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(1366),
    [anon_sym_SLASH] = ACTIONS(1366),
    [anon_sym_DOT] = ACTIONS(1366),
    [anon_sym_class] = ACTIONS(1366),
    [anon_sym_async] = ACTIONS(1366),
    [anon_sym_function] = ACTIONS(1366),
    [anon_sym_QMARK_DOT] = ACTIONS(1370),
    [anon_sym_new] = ACTIONS(1366),
    [anon_sym_AMP_AMP] = ACTIONS(1370),
    [anon_sym_PIPE_PIPE] = ACTIONS(1370),
    [anon_sym_GT_GT] = ACTIONS(1366),
    [anon_sym_GT_GT_GT] = ACTIONS(1370),
    [anon_sym_LT_LT] = ACTIONS(1370),
    [anon_sym_AMP] = ACTIONS(1366),
    [anon_sym_CARET] = ACTIONS(1370),
    [anon_sym_PIPE] = ACTIONS(1366),
    [anon_sym_PLUS] = ACTIONS(1366),
    [anon_sym_DASH] = ACTIONS(1366),
    [anon_sym_PERCENT] = ACTIONS(1370),
    [anon_sym_STAR_STAR] = ACTIONS(1370),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_EQ_EQ] = ACTIONS(1366),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG_EQ] = ACTIONS(1366),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_QMARK_QMARK] = ACTIONS(1370),
    [anon_sym_instanceof] = ACTIONS(1366),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1366),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_DQUOTE] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1370),
    [sym_number] = ACTIONS(1370),
    [sym_this] = ACTIONS(1366),
    [sym_super] = ACTIONS(1366),
    [sym_true] = ACTIONS(1366),
    [sym_false] = ACTIONS(1366),
    [sym_null] = ACTIONS(1366),
    [sym_undefined] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(1370),
    [anon_sym_static] = ACTIONS(1366),
    [anon_sym_readonly] = ACTIONS(1366),
    [anon_sym_get] = ACTIONS(1366),
    [anon_sym_set] = ACTIONS(1366),
    [anon_sym_declare] = ACTIONS(1366),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_public] = ACTIONS(1366),
    [anon_sym_private] = ACTIONS(1366),
    [anon_sym_protected] = ACTIONS(1366),
    [anon_sym_override] = ACTIONS(1366),
    [anon_sym_module] = ACTIONS(1366),
    [anon_sym_any] = ACTIONS(1366),
    [anon_sym_number] = ACTIONS(1366),
    [anon_sym_boolean] = ACTIONS(1366),
    [anon_sym_string] = ACTIONS(1366),
    [anon_sym_symbol] = ACTIONS(1366),
    [anon_sym_abstract] = ACTIONS(1366),
    [anon_sym_satisfies] = ACTIONS(1366),
    [anon_sym_interface] = ACTIONS(1366),
    [anon_sym_enum] = ACTIONS(1366),
    [anon_sym_component] = ACTIONS(1366),
    [sym__automatic_semicolon] = ACTIONS(1654),
    [sym__ternary_qmark] = ACTIONS(1370),
  },
  [206] = {
    [sym__call_signature] = STATE(4560),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_export] = ACTIONS(1495),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_RBRACE] = ACTIONS(65),
    [anon_sym_type] = ACTIONS(1495),
    [anon_sym_typeof] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(1499),
    [anon_sym_function] = ACTIONS(1324),
    [anon_sym_EQ_GT] = ACTIONS(1502),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(25),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_void] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(65),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(65),
    [sym_number] = ACTIONS(65),
    [sym_this] = ACTIONS(25),
    [sym_true] = ACTIONS(25),
    [sym_false] = ACTIONS(25),
    [sym_null] = ACTIONS(25),
    [sym_undefined] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(1499),
    [anon_sym_readonly] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(1495),
    [anon_sym_set] = ACTIONS(1495),
    [anon_sym_QMARK] = ACTIONS(25),
    [anon_sym_declare] = ACTIONS(1495),
    [anon_sym_namespace] = ACTIONS(1495),
    [anon_sym_public] = ACTIONS(1495),
    [anon_sym_private] = ACTIONS(1495),
    [anon_sym_protected] = ACTIONS(1495),
    [anon_sym_override] = ACTIONS(1495),
    [anon_sym_module] = ACTIONS(1495),
    [anon_sym_any] = ACTIONS(1499),
    [anon_sym_number] = ACTIONS(1499),
    [anon_sym_boolean] = ACTIONS(1499),
    [anon_sym_string] = ACTIONS(1499),
    [anon_sym_symbol] = ACTIONS(1499),
    [anon_sym_abstract] = ACTIONS(25),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_infer] = ACTIONS(25),
    [anon_sym_keyof] = ACTIONS(25),
    [anon_sym_unknown] = ACTIONS(25),
    [anon_sym_never] = ACTIONS(25),
    [anon_sym_object] = ACTIONS(25),
    [anon_sym_LBRACE_PIPE] = ACTIONS(65),
    [anon_sym_prop] = ACTIONS(25),
    [anon_sym_id] = ACTIONS(25),
    [anon_sym_event] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_on] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [207] = {
    [sym_identifier] = ACTIONS(1656),
    [anon_sym_export] = ACTIONS(1656),
    [anon_sym_STAR] = ACTIONS(1658),
    [anon_sym_as] = ACTIONS(1658),
    [anon_sym_LBRACE] = ACTIONS(1660),
    [anon_sym_COMMA] = ACTIONS(1662),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [anon_sym_type] = ACTIONS(1656),
    [anon_sym_typeof] = ACTIONS(1656),
    [anon_sym_import] = ACTIONS(1656),
    [anon_sym_var] = ACTIONS(1656),
    [anon_sym_let] = ACTIONS(1656),
    [anon_sym_const] = ACTIONS(1656),
    [anon_sym_BANG] = ACTIONS(1656),
    [anon_sym_else] = ACTIONS(1656),
    [anon_sym_if] = ACTIONS(1656),
    [anon_sym_switch] = ACTIONS(1656),
    [anon_sym_for] = ACTIONS(1656),
    [anon_sym_LPAREN] = ACTIONS(1660),
    [anon_sym_await] = ACTIONS(1656),
    [anon_sym_in] = ACTIONS(1658),
    [anon_sym_while] = ACTIONS(1656),
    [anon_sym_do] = ACTIONS(1656),
    [anon_sym_try] = ACTIONS(1656),
    [anon_sym_with] = ACTIONS(1656),
    [anon_sym_break] = ACTIONS(1656),
    [anon_sym_continue] = ACTIONS(1656),
    [anon_sym_debugger] = ACTIONS(1656),
    [anon_sym_return] = ACTIONS(1656),
    [anon_sym_throw] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1660),
    [anon_sym_case] = ACTIONS(1656),
    [anon_sym_default] = ACTIONS(1656),
    [anon_sym_yield] = ACTIONS(1656),
    [anon_sym_LBRACK] = ACTIONS(1660),
    [anon_sym_LTtemplate_GT] = ACTIONS(1660),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_GT] = ACTIONS(1658),
    [anon_sym_SLASH] = ACTIONS(1656),
    [anon_sym_DOT] = ACTIONS(1658),
    [anon_sym_class] = ACTIONS(1656),
    [anon_sym_async] = ACTIONS(1656),
    [anon_sym_function] = ACTIONS(1656),
    [anon_sym_QMARK_DOT] = ACTIONS(1662),
    [anon_sym_new] = ACTIONS(1656),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1658),
    [anon_sym_GT_GT_GT] = ACTIONS(1662),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_AMP] = ACTIONS(1656),
    [anon_sym_CARET] = ACTIONS(1662),
    [anon_sym_PIPE] = ACTIONS(1658),
    [anon_sym_PLUS] = ACTIONS(1656),
    [anon_sym_DASH] = ACTIONS(1656),
    [anon_sym_PERCENT] = ACTIONS(1662),
    [anon_sym_STAR_STAR] = ACTIONS(1662),
    [anon_sym_LT_EQ] = ACTIONS(1662),
    [anon_sym_EQ_EQ] = ACTIONS(1658),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1662),
    [anon_sym_BANG_EQ] = ACTIONS(1658),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1662),
    [anon_sym_GT_EQ] = ACTIONS(1662),
    [anon_sym_QMARK_QMARK] = ACTIONS(1662),
    [anon_sym_instanceof] = ACTIONS(1658),
    [anon_sym_TILDE] = ACTIONS(1660),
    [anon_sym_void] = ACTIONS(1656),
    [anon_sym_delete] = ACTIONS(1656),
    [anon_sym_PLUS_PLUS] = ACTIONS(1660),
    [anon_sym_DASH_DASH] = ACTIONS(1660),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_SQUOTE] = ACTIONS(1660),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [sym_number] = ACTIONS(1660),
    [sym_this] = ACTIONS(1656),
    [sym_super] = ACTIONS(1656),
    [sym_true] = ACTIONS(1656),
    [sym_false] = ACTIONS(1656),
    [sym_null] = ACTIONS(1656),
    [sym_undefined] = ACTIONS(1656),
    [anon_sym_AT] = ACTIONS(1660),
    [anon_sym_static] = ACTIONS(1656),
    [anon_sym_readonly] = ACTIONS(1656),
    [anon_sym_get] = ACTIONS(1656),
    [anon_sym_set] = ACTIONS(1656),
    [anon_sym_declare] = ACTIONS(1656),
    [anon_sym_namespace] = ACTIONS(1656),
    [anon_sym_public] = ACTIONS(1656),
    [anon_sym_private] = ACTIONS(1656),
    [anon_sym_protected] = ACTIONS(1656),
    [anon_sym_override] = ACTIONS(1656),
    [anon_sym_module] = ACTIONS(1656),
    [anon_sym_any] = ACTIONS(1656),
    [anon_sym_number] = ACTIONS(1656),
    [anon_sym_boolean] = ACTIONS(1656),
    [anon_sym_string] = ACTIONS(1656),
    [anon_sym_symbol] = ACTIONS(1656),
    [anon_sym_abstract] = ACTIONS(1656),
    [anon_sym_satisfies] = ACTIONS(1658),
    [anon_sym_interface] = ACTIONS(1656),
    [anon_sym_enum] = ACTIONS(1656),
    [anon_sym_component] = ACTIONS(1656),
    [sym__automatic_semicolon] = ACTIONS(1664),
    [sym__ternary_qmark] = ACTIONS(1662),
  },
  [208] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1562),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(852),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_property_assignment_expression] = STATE(1562),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [209] = {
    [sym_identifier] = ACTIONS(1666),
    [anon_sym_export] = ACTIONS(1666),
    [anon_sym_STAR] = ACTIONS(1668),
    [anon_sym_as] = ACTIONS(1668),
    [anon_sym_LBRACE] = ACTIONS(1670),
    [anon_sym_COMMA] = ACTIONS(1672),
    [anon_sym_RBRACE] = ACTIONS(1670),
    [anon_sym_type] = ACTIONS(1666),
    [anon_sym_typeof] = ACTIONS(1666),
    [anon_sym_import] = ACTIONS(1666),
    [anon_sym_var] = ACTIONS(1666),
    [anon_sym_let] = ACTIONS(1666),
    [anon_sym_const] = ACTIONS(1666),
    [anon_sym_BANG] = ACTIONS(1666),
    [anon_sym_else] = ACTIONS(1666),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_switch] = ACTIONS(1666),
    [anon_sym_for] = ACTIONS(1666),
    [anon_sym_LPAREN] = ACTIONS(1670),
    [anon_sym_await] = ACTIONS(1666),
    [anon_sym_in] = ACTIONS(1668),
    [anon_sym_while] = ACTIONS(1666),
    [anon_sym_do] = ACTIONS(1666),
    [anon_sym_try] = ACTIONS(1666),
    [anon_sym_with] = ACTIONS(1666),
    [anon_sym_break] = ACTIONS(1666),
    [anon_sym_continue] = ACTIONS(1666),
    [anon_sym_debugger] = ACTIONS(1666),
    [anon_sym_return] = ACTIONS(1666),
    [anon_sym_throw] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1670),
    [anon_sym_case] = ACTIONS(1666),
    [anon_sym_default] = ACTIONS(1666),
    [anon_sym_yield] = ACTIONS(1666),
    [anon_sym_LBRACK] = ACTIONS(1670),
    [anon_sym_LTtemplate_GT] = ACTIONS(1670),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_GT] = ACTIONS(1668),
    [anon_sym_SLASH] = ACTIONS(1666),
    [anon_sym_DOT] = ACTIONS(1668),
    [anon_sym_class] = ACTIONS(1666),
    [anon_sym_async] = ACTIONS(1666),
    [anon_sym_function] = ACTIONS(1666),
    [anon_sym_QMARK_DOT] = ACTIONS(1672),
    [anon_sym_new] = ACTIONS(1666),
    [anon_sym_AMP_AMP] = ACTIONS(1672),
    [anon_sym_PIPE_PIPE] = ACTIONS(1672),
    [anon_sym_GT_GT] = ACTIONS(1668),
    [anon_sym_GT_GT_GT] = ACTIONS(1672),
    [anon_sym_LT_LT] = ACTIONS(1672),
    [anon_sym_AMP] = ACTIONS(1666),
    [anon_sym_CARET] = ACTIONS(1672),
    [anon_sym_PIPE] = ACTIONS(1668),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_PERCENT] = ACTIONS(1672),
    [anon_sym_STAR_STAR] = ACTIONS(1672),
    [anon_sym_LT_EQ] = ACTIONS(1672),
    [anon_sym_EQ_EQ] = ACTIONS(1668),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1672),
    [anon_sym_BANG_EQ] = ACTIONS(1668),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1672),
    [anon_sym_GT_EQ] = ACTIONS(1672),
    [anon_sym_QMARK_QMARK] = ACTIONS(1672),
    [anon_sym_instanceof] = ACTIONS(1668),
    [anon_sym_TILDE] = ACTIONS(1670),
    [anon_sym_void] = ACTIONS(1666),
    [anon_sym_delete] = ACTIONS(1666),
    [anon_sym_PLUS_PLUS] = ACTIONS(1670),
    [anon_sym_DASH_DASH] = ACTIONS(1670),
    [anon_sym_DQUOTE] = ACTIONS(1670),
    [anon_sym_SQUOTE] = ACTIONS(1670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1670),
    [sym_number] = ACTIONS(1670),
    [sym_this] = ACTIONS(1666),
    [sym_super] = ACTIONS(1666),
    [sym_true] = ACTIONS(1666),
    [sym_false] = ACTIONS(1666),
    [sym_null] = ACTIONS(1666),
    [sym_undefined] = ACTIONS(1666),
    [anon_sym_AT] = ACTIONS(1670),
    [anon_sym_static] = ACTIONS(1666),
    [anon_sym_readonly] = ACTIONS(1666),
    [anon_sym_get] = ACTIONS(1666),
    [anon_sym_set] = ACTIONS(1666),
    [anon_sym_declare] = ACTIONS(1666),
    [anon_sym_namespace] = ACTIONS(1666),
    [anon_sym_public] = ACTIONS(1666),
    [anon_sym_private] = ACTIONS(1666),
    [anon_sym_protected] = ACTIONS(1666),
    [anon_sym_override] = ACTIONS(1666),
    [anon_sym_module] = ACTIONS(1666),
    [anon_sym_any] = ACTIONS(1666),
    [anon_sym_number] = ACTIONS(1666),
    [anon_sym_boolean] = ACTIONS(1666),
    [anon_sym_string] = ACTIONS(1666),
    [anon_sym_symbol] = ACTIONS(1666),
    [anon_sym_abstract] = ACTIONS(1666),
    [anon_sym_satisfies] = ACTIONS(1668),
    [anon_sym_interface] = ACTIONS(1666),
    [anon_sym_enum] = ACTIONS(1666),
    [anon_sym_component] = ACTIONS(1666),
    [sym__automatic_semicolon] = ACTIONS(1674),
    [sym__ternary_qmark] = ACTIONS(1672),
  },
  [210] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2315),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4645),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_RPAREN] = ACTIONS(1676),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [211] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1574),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(852),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_property_assignment_expression] = STATE(1574),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [212] = {
    [sym_identifier] = ACTIONS(1678),
    [anon_sym_export] = ACTIONS(1678),
    [anon_sym_STAR] = ACTIONS(1678),
    [anon_sym_as] = ACTIONS(1678),
    [anon_sym_LBRACE] = ACTIONS(1680),
    [anon_sym_COMMA] = ACTIONS(1680),
    [anon_sym_RBRACE] = ACTIONS(1680),
    [anon_sym_type] = ACTIONS(1678),
    [anon_sym_typeof] = ACTIONS(1678),
    [anon_sym_import] = ACTIONS(1678),
    [anon_sym_var] = ACTIONS(1678),
    [anon_sym_let] = ACTIONS(1678),
    [anon_sym_const] = ACTIONS(1678),
    [anon_sym_BANG] = ACTIONS(1678),
    [anon_sym_else] = ACTIONS(1678),
    [anon_sym_if] = ACTIONS(1678),
    [anon_sym_switch] = ACTIONS(1678),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [anon_sym_await] = ACTIONS(1678),
    [anon_sym_in] = ACTIONS(1678),
    [anon_sym_while] = ACTIONS(1678),
    [anon_sym_do] = ACTIONS(1678),
    [anon_sym_try] = ACTIONS(1678),
    [anon_sym_with] = ACTIONS(1678),
    [anon_sym_break] = ACTIONS(1678),
    [anon_sym_continue] = ACTIONS(1678),
    [anon_sym_debugger] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1678),
    [anon_sym_throw] = ACTIONS(1678),
    [anon_sym_SEMI] = ACTIONS(1680),
    [anon_sym_case] = ACTIONS(1678),
    [anon_sym_default] = ACTIONS(1678),
    [anon_sym_yield] = ACTIONS(1678),
    [anon_sym_LBRACK] = ACTIONS(1680),
    [anon_sym_LTtemplate_GT] = ACTIONS(1680),
    [anon_sym_LT] = ACTIONS(1678),
    [anon_sym_GT] = ACTIONS(1678),
    [anon_sym_SLASH] = ACTIONS(1678),
    [anon_sym_DOT] = ACTIONS(1678),
    [anon_sym_class] = ACTIONS(1678),
    [anon_sym_async] = ACTIONS(1678),
    [anon_sym_function] = ACTIONS(1678),
    [anon_sym_QMARK_DOT] = ACTIONS(1680),
    [anon_sym_new] = ACTIONS(1678),
    [anon_sym_AMP_AMP] = ACTIONS(1680),
    [anon_sym_PIPE_PIPE] = ACTIONS(1680),
    [anon_sym_GT_GT] = ACTIONS(1678),
    [anon_sym_GT_GT_GT] = ACTIONS(1680),
    [anon_sym_LT_LT] = ACTIONS(1680),
    [anon_sym_AMP] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_PIPE] = ACTIONS(1678),
    [anon_sym_PLUS] = ACTIONS(1678),
    [anon_sym_DASH] = ACTIONS(1678),
    [anon_sym_PERCENT] = ACTIONS(1680),
    [anon_sym_STAR_STAR] = ACTIONS(1680),
    [anon_sym_LT_EQ] = ACTIONS(1680),
    [anon_sym_EQ_EQ] = ACTIONS(1678),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1680),
    [anon_sym_BANG_EQ] = ACTIONS(1678),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1680),
    [anon_sym_GT_EQ] = ACTIONS(1680),
    [anon_sym_QMARK_QMARK] = ACTIONS(1680),
    [anon_sym_instanceof] = ACTIONS(1678),
    [anon_sym_TILDE] = ACTIONS(1680),
    [anon_sym_void] = ACTIONS(1678),
    [anon_sym_delete] = ACTIONS(1678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1680),
    [anon_sym_DASH_DASH] = ACTIONS(1680),
    [anon_sym_DQUOTE] = ACTIONS(1680),
    [anon_sym_SQUOTE] = ACTIONS(1680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1680),
    [sym_number] = ACTIONS(1680),
    [sym_this] = ACTIONS(1678),
    [sym_super] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_null] = ACTIONS(1678),
    [sym_undefined] = ACTIONS(1678),
    [anon_sym_AT] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1678),
    [anon_sym_readonly] = ACTIONS(1678),
    [anon_sym_get] = ACTIONS(1678),
    [anon_sym_set] = ACTIONS(1678),
    [anon_sym_declare] = ACTIONS(1678),
    [anon_sym_namespace] = ACTIONS(1678),
    [anon_sym_public] = ACTIONS(1678),
    [anon_sym_private] = ACTIONS(1678),
    [anon_sym_protected] = ACTIONS(1678),
    [anon_sym_override] = ACTIONS(1678),
    [anon_sym_module] = ACTIONS(1678),
    [anon_sym_any] = ACTIONS(1678),
    [anon_sym_number] = ACTIONS(1678),
    [anon_sym_boolean] = ACTIONS(1678),
    [anon_sym_string] = ACTIONS(1678),
    [anon_sym_symbol] = ACTIONS(1678),
    [anon_sym_abstract] = ACTIONS(1678),
    [anon_sym_satisfies] = ACTIONS(1678),
    [anon_sym_interface] = ACTIONS(1678),
    [anon_sym_enum] = ACTIONS(1678),
    [anon_sym_component] = ACTIONS(1678),
    [sym__automatic_semicolon] = ACTIONS(1680),
    [sym__ternary_qmark] = ACTIONS(1680),
  },
  [213] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1564),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(852),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_property_assignment_expression] = STATE(1564),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [214] = {
    [sym_identifier] = ACTIONS(1682),
    [anon_sym_export] = ACTIONS(1682),
    [anon_sym_STAR] = ACTIONS(1684),
    [anon_sym_as] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [anon_sym_COMMA] = ACTIONS(1688),
    [anon_sym_RBRACE] = ACTIONS(1686),
    [anon_sym_type] = ACTIONS(1682),
    [anon_sym_typeof] = ACTIONS(1682),
    [anon_sym_import] = ACTIONS(1682),
    [anon_sym_var] = ACTIONS(1682),
    [anon_sym_let] = ACTIONS(1682),
    [anon_sym_const] = ACTIONS(1682),
    [anon_sym_BANG] = ACTIONS(1682),
    [anon_sym_else] = ACTIONS(1682),
    [anon_sym_if] = ACTIONS(1682),
    [anon_sym_switch] = ACTIONS(1682),
    [anon_sym_for] = ACTIONS(1682),
    [anon_sym_LPAREN] = ACTIONS(1686),
    [anon_sym_await] = ACTIONS(1682),
    [anon_sym_in] = ACTIONS(1684),
    [anon_sym_while] = ACTIONS(1682),
    [anon_sym_do] = ACTIONS(1682),
    [anon_sym_try] = ACTIONS(1682),
    [anon_sym_with] = ACTIONS(1682),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1682),
    [anon_sym_debugger] = ACTIONS(1682),
    [anon_sym_return] = ACTIONS(1682),
    [anon_sym_throw] = ACTIONS(1682),
    [anon_sym_SEMI] = ACTIONS(1686),
    [anon_sym_case] = ACTIONS(1682),
    [anon_sym_default] = ACTIONS(1682),
    [anon_sym_yield] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1686),
    [anon_sym_LTtemplate_GT] = ACTIONS(1686),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_GT] = ACTIONS(1684),
    [anon_sym_SLASH] = ACTIONS(1682),
    [anon_sym_DOT] = ACTIONS(1684),
    [anon_sym_class] = ACTIONS(1682),
    [anon_sym_async] = ACTIONS(1682),
    [anon_sym_function] = ACTIONS(1682),
    [anon_sym_QMARK_DOT] = ACTIONS(1688),
    [anon_sym_new] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1688),
    [anon_sym_PIPE_PIPE] = ACTIONS(1688),
    [anon_sym_GT_GT] = ACTIONS(1684),
    [anon_sym_GT_GT_GT] = ACTIONS(1688),
    [anon_sym_LT_LT] = ACTIONS(1688),
    [anon_sym_AMP] = ACTIONS(1682),
    [anon_sym_CARET] = ACTIONS(1688),
    [anon_sym_PIPE] = ACTIONS(1684),
    [anon_sym_PLUS] = ACTIONS(1682),
    [anon_sym_DASH] = ACTIONS(1682),
    [anon_sym_PERCENT] = ACTIONS(1688),
    [anon_sym_STAR_STAR] = ACTIONS(1688),
    [anon_sym_LT_EQ] = ACTIONS(1688),
    [anon_sym_EQ_EQ] = ACTIONS(1684),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1688),
    [anon_sym_BANG_EQ] = ACTIONS(1684),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1688),
    [anon_sym_GT_EQ] = ACTIONS(1688),
    [anon_sym_QMARK_QMARK] = ACTIONS(1688),
    [anon_sym_instanceof] = ACTIONS(1684),
    [anon_sym_TILDE] = ACTIONS(1686),
    [anon_sym_void] = ACTIONS(1682),
    [anon_sym_delete] = ACTIONS(1682),
    [anon_sym_PLUS_PLUS] = ACTIONS(1686),
    [anon_sym_DASH_DASH] = ACTIONS(1686),
    [anon_sym_DQUOTE] = ACTIONS(1686),
    [anon_sym_SQUOTE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1686),
    [sym_number] = ACTIONS(1686),
    [sym_this] = ACTIONS(1682),
    [sym_super] = ACTIONS(1682),
    [sym_true] = ACTIONS(1682),
    [sym_false] = ACTIONS(1682),
    [sym_null] = ACTIONS(1682),
    [sym_undefined] = ACTIONS(1682),
    [anon_sym_AT] = ACTIONS(1686),
    [anon_sym_static] = ACTIONS(1682),
    [anon_sym_readonly] = ACTIONS(1682),
    [anon_sym_get] = ACTIONS(1682),
    [anon_sym_set] = ACTIONS(1682),
    [anon_sym_declare] = ACTIONS(1682),
    [anon_sym_namespace] = ACTIONS(1682),
    [anon_sym_public] = ACTIONS(1682),
    [anon_sym_private] = ACTIONS(1682),
    [anon_sym_protected] = ACTIONS(1682),
    [anon_sym_override] = ACTIONS(1682),
    [anon_sym_module] = ACTIONS(1682),
    [anon_sym_any] = ACTIONS(1682),
    [anon_sym_number] = ACTIONS(1682),
    [anon_sym_boolean] = ACTIONS(1682),
    [anon_sym_string] = ACTIONS(1682),
    [anon_sym_symbol] = ACTIONS(1682),
    [anon_sym_abstract] = ACTIONS(1682),
    [anon_sym_satisfies] = ACTIONS(1684),
    [anon_sym_interface] = ACTIONS(1682),
    [anon_sym_enum] = ACTIONS(1682),
    [anon_sym_component] = ACTIONS(1682),
    [sym__automatic_semicolon] = ACTIONS(1690),
    [sym__ternary_qmark] = ACTIONS(1688),
  },
  [215] = {
    [sym_identifier] = ACTIONS(1692),
    [anon_sym_export] = ACTIONS(1692),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_as] = ACTIONS(1694),
    [anon_sym_LBRACE] = ACTIONS(1696),
    [anon_sym_COMMA] = ACTIONS(1698),
    [anon_sym_RBRACE] = ACTIONS(1696),
    [anon_sym_type] = ACTIONS(1692),
    [anon_sym_typeof] = ACTIONS(1692),
    [anon_sym_import] = ACTIONS(1692),
    [anon_sym_var] = ACTIONS(1692),
    [anon_sym_let] = ACTIONS(1692),
    [anon_sym_const] = ACTIONS(1692),
    [anon_sym_BANG] = ACTIONS(1692),
    [anon_sym_else] = ACTIONS(1692),
    [anon_sym_if] = ACTIONS(1692),
    [anon_sym_switch] = ACTIONS(1692),
    [anon_sym_for] = ACTIONS(1692),
    [anon_sym_LPAREN] = ACTIONS(1696),
    [anon_sym_await] = ACTIONS(1692),
    [anon_sym_in] = ACTIONS(1694),
    [anon_sym_while] = ACTIONS(1692),
    [anon_sym_do] = ACTIONS(1692),
    [anon_sym_try] = ACTIONS(1692),
    [anon_sym_with] = ACTIONS(1692),
    [anon_sym_break] = ACTIONS(1692),
    [anon_sym_continue] = ACTIONS(1692),
    [anon_sym_debugger] = ACTIONS(1692),
    [anon_sym_return] = ACTIONS(1692),
    [anon_sym_throw] = ACTIONS(1692),
    [anon_sym_SEMI] = ACTIONS(1696),
    [anon_sym_case] = ACTIONS(1692),
    [anon_sym_default] = ACTIONS(1692),
    [anon_sym_yield] = ACTIONS(1692),
    [anon_sym_LBRACK] = ACTIONS(1696),
    [anon_sym_LTtemplate_GT] = ACTIONS(1696),
    [anon_sym_LT] = ACTIONS(1692),
    [anon_sym_GT] = ACTIONS(1694),
    [anon_sym_SLASH] = ACTIONS(1692),
    [anon_sym_DOT] = ACTIONS(1694),
    [anon_sym_class] = ACTIONS(1692),
    [anon_sym_async] = ACTIONS(1692),
    [anon_sym_function] = ACTIONS(1692),
    [anon_sym_QMARK_DOT] = ACTIONS(1698),
    [anon_sym_new] = ACTIONS(1692),
    [anon_sym_AMP_AMP] = ACTIONS(1698),
    [anon_sym_PIPE_PIPE] = ACTIONS(1698),
    [anon_sym_GT_GT] = ACTIONS(1694),
    [anon_sym_GT_GT_GT] = ACTIONS(1698),
    [anon_sym_LT_LT] = ACTIONS(1698),
    [anon_sym_AMP] = ACTIONS(1692),
    [anon_sym_CARET] = ACTIONS(1698),
    [anon_sym_PIPE] = ACTIONS(1694),
    [anon_sym_PLUS] = ACTIONS(1692),
    [anon_sym_DASH] = ACTIONS(1692),
    [anon_sym_PERCENT] = ACTIONS(1698),
    [anon_sym_STAR_STAR] = ACTIONS(1698),
    [anon_sym_LT_EQ] = ACTIONS(1698),
    [anon_sym_EQ_EQ] = ACTIONS(1694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1698),
    [anon_sym_BANG_EQ] = ACTIONS(1694),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1698),
    [anon_sym_GT_EQ] = ACTIONS(1698),
    [anon_sym_QMARK_QMARK] = ACTIONS(1698),
    [anon_sym_instanceof] = ACTIONS(1694),
    [anon_sym_TILDE] = ACTIONS(1696),
    [anon_sym_void] = ACTIONS(1692),
    [anon_sym_delete] = ACTIONS(1692),
    [anon_sym_PLUS_PLUS] = ACTIONS(1696),
    [anon_sym_DASH_DASH] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1696),
    [anon_sym_SQUOTE] = ACTIONS(1696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1696),
    [sym_number] = ACTIONS(1696),
    [sym_this] = ACTIONS(1692),
    [sym_super] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_null] = ACTIONS(1692),
    [sym_undefined] = ACTIONS(1692),
    [anon_sym_AT] = ACTIONS(1696),
    [anon_sym_static] = ACTIONS(1692),
    [anon_sym_readonly] = ACTIONS(1692),
    [anon_sym_get] = ACTIONS(1692),
    [anon_sym_set] = ACTIONS(1692),
    [anon_sym_declare] = ACTIONS(1692),
    [anon_sym_namespace] = ACTIONS(1692),
    [anon_sym_public] = ACTIONS(1692),
    [anon_sym_private] = ACTIONS(1692),
    [anon_sym_protected] = ACTIONS(1692),
    [anon_sym_override] = ACTIONS(1692),
    [anon_sym_module] = ACTIONS(1692),
    [anon_sym_any] = ACTIONS(1692),
    [anon_sym_number] = ACTIONS(1692),
    [anon_sym_boolean] = ACTIONS(1692),
    [anon_sym_string] = ACTIONS(1692),
    [anon_sym_symbol] = ACTIONS(1692),
    [anon_sym_abstract] = ACTIONS(1692),
    [anon_sym_satisfies] = ACTIONS(1694),
    [anon_sym_interface] = ACTIONS(1692),
    [anon_sym_enum] = ACTIONS(1692),
    [anon_sym_component] = ACTIONS(1692),
    [sym__automatic_semicolon] = ACTIONS(1700),
    [sym__ternary_qmark] = ACTIONS(1698),
  },
  [216] = {
    [sym_identifier] = ACTIONS(1524),
    [anon_sym_export] = ACTIONS(1524),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_as] = ACTIONS(1524),
    [anon_sym_LBRACE] = ACTIONS(1526),
    [anon_sym_COMMA] = ACTIONS(1526),
    [anon_sym_RBRACE] = ACTIONS(1526),
    [anon_sym_type] = ACTIONS(1524),
    [anon_sym_typeof] = ACTIONS(1524),
    [anon_sym_import] = ACTIONS(1524),
    [anon_sym_var] = ACTIONS(1524),
    [anon_sym_let] = ACTIONS(1524),
    [anon_sym_const] = ACTIONS(1524),
    [anon_sym_BANG] = ACTIONS(1524),
    [anon_sym_else] = ACTIONS(1524),
    [anon_sym_if] = ACTIONS(1524),
    [anon_sym_switch] = ACTIONS(1524),
    [anon_sym_for] = ACTIONS(1524),
    [anon_sym_LPAREN] = ACTIONS(1526),
    [anon_sym_await] = ACTIONS(1524),
    [anon_sym_in] = ACTIONS(1524),
    [anon_sym_while] = ACTIONS(1524),
    [anon_sym_do] = ACTIONS(1524),
    [anon_sym_try] = ACTIONS(1524),
    [anon_sym_with] = ACTIONS(1524),
    [anon_sym_break] = ACTIONS(1524),
    [anon_sym_continue] = ACTIONS(1524),
    [anon_sym_debugger] = ACTIONS(1524),
    [anon_sym_return] = ACTIONS(1524),
    [anon_sym_throw] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1526),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1524),
    [anon_sym_yield] = ACTIONS(1524),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LTtemplate_GT] = ACTIONS(1526),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_GT] = ACTIONS(1524),
    [anon_sym_SLASH] = ACTIONS(1524),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_class] = ACTIONS(1524),
    [anon_sym_async] = ACTIONS(1524),
    [anon_sym_function] = ACTIONS(1524),
    [anon_sym_QMARK_DOT] = ACTIONS(1526),
    [anon_sym_new] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE_PIPE] = ACTIONS(1526),
    [anon_sym_GT_GT] = ACTIONS(1524),
    [anon_sym_GT_GT_GT] = ACTIONS(1526),
    [anon_sym_LT_LT] = ACTIONS(1526),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_CARET] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_PLUS] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1524),
    [anon_sym_PERCENT] = ACTIONS(1526),
    [anon_sym_STAR_STAR] = ACTIONS(1526),
    [anon_sym_LT_EQ] = ACTIONS(1526),
    [anon_sym_EQ_EQ] = ACTIONS(1524),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1526),
    [anon_sym_BANG_EQ] = ACTIONS(1524),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1526),
    [anon_sym_GT_EQ] = ACTIONS(1526),
    [anon_sym_QMARK_QMARK] = ACTIONS(1526),
    [anon_sym_instanceof] = ACTIONS(1524),
    [anon_sym_TILDE] = ACTIONS(1526),
    [anon_sym_void] = ACTIONS(1524),
    [anon_sym_delete] = ACTIONS(1524),
    [anon_sym_PLUS_PLUS] = ACTIONS(1526),
    [anon_sym_DASH_DASH] = ACTIONS(1526),
    [anon_sym_DQUOTE] = ACTIONS(1526),
    [anon_sym_SQUOTE] = ACTIONS(1526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1526),
    [sym_number] = ACTIONS(1526),
    [sym_this] = ACTIONS(1524),
    [sym_super] = ACTIONS(1524),
    [sym_true] = ACTIONS(1524),
    [sym_false] = ACTIONS(1524),
    [sym_null] = ACTIONS(1524),
    [sym_undefined] = ACTIONS(1524),
    [anon_sym_AT] = ACTIONS(1526),
    [anon_sym_static] = ACTIONS(1524),
    [anon_sym_readonly] = ACTIONS(1524),
    [anon_sym_get] = ACTIONS(1524),
    [anon_sym_set] = ACTIONS(1524),
    [anon_sym_declare] = ACTIONS(1524),
    [anon_sym_namespace] = ACTIONS(1524),
    [anon_sym_public] = ACTIONS(1524),
    [anon_sym_private] = ACTIONS(1524),
    [anon_sym_protected] = ACTIONS(1524),
    [anon_sym_override] = ACTIONS(1524),
    [anon_sym_module] = ACTIONS(1524),
    [anon_sym_any] = ACTIONS(1524),
    [anon_sym_number] = ACTIONS(1524),
    [anon_sym_boolean] = ACTIONS(1524),
    [anon_sym_string] = ACTIONS(1524),
    [anon_sym_symbol] = ACTIONS(1524),
    [anon_sym_abstract] = ACTIONS(1524),
    [anon_sym_satisfies] = ACTIONS(1524),
    [anon_sym_interface] = ACTIONS(1524),
    [anon_sym_enum] = ACTIONS(1524),
    [anon_sym_component] = ACTIONS(1524),
    [sym__automatic_semicolon] = ACTIONS(1526),
    [sym__ternary_qmark] = ACTIONS(1526),
  },
  [217] = {
    [sym_identifier] = ACTIONS(1702),
    [anon_sym_export] = ACTIONS(1702),
    [anon_sym_STAR] = ACTIONS(1702),
    [anon_sym_as] = ACTIONS(1702),
    [anon_sym_LBRACE] = ACTIONS(1704),
    [anon_sym_COMMA] = ACTIONS(1704),
    [anon_sym_RBRACE] = ACTIONS(1704),
    [anon_sym_type] = ACTIONS(1702),
    [anon_sym_typeof] = ACTIONS(1702),
    [anon_sym_import] = ACTIONS(1702),
    [anon_sym_var] = ACTIONS(1702),
    [anon_sym_let] = ACTIONS(1702),
    [anon_sym_const] = ACTIONS(1702),
    [anon_sym_BANG] = ACTIONS(1702),
    [anon_sym_else] = ACTIONS(1702),
    [anon_sym_if] = ACTIONS(1702),
    [anon_sym_switch] = ACTIONS(1702),
    [anon_sym_for] = ACTIONS(1702),
    [anon_sym_LPAREN] = ACTIONS(1704),
    [anon_sym_await] = ACTIONS(1702),
    [anon_sym_in] = ACTIONS(1702),
    [anon_sym_while] = ACTIONS(1702),
    [anon_sym_do] = ACTIONS(1702),
    [anon_sym_try] = ACTIONS(1702),
    [anon_sym_with] = ACTIONS(1702),
    [anon_sym_break] = ACTIONS(1702),
    [anon_sym_continue] = ACTIONS(1702),
    [anon_sym_debugger] = ACTIONS(1702),
    [anon_sym_return] = ACTIONS(1702),
    [anon_sym_throw] = ACTIONS(1702),
    [anon_sym_SEMI] = ACTIONS(1704),
    [anon_sym_case] = ACTIONS(1702),
    [anon_sym_default] = ACTIONS(1702),
    [anon_sym_yield] = ACTIONS(1702),
    [anon_sym_LBRACK] = ACTIONS(1704),
    [anon_sym_LTtemplate_GT] = ACTIONS(1704),
    [anon_sym_LT] = ACTIONS(1702),
    [anon_sym_GT] = ACTIONS(1702),
    [anon_sym_SLASH] = ACTIONS(1702),
    [anon_sym_DOT] = ACTIONS(1702),
    [anon_sym_class] = ACTIONS(1702),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(1702),
    [anon_sym_QMARK_DOT] = ACTIONS(1704),
    [anon_sym_new] = ACTIONS(1702),
    [anon_sym_AMP_AMP] = ACTIONS(1704),
    [anon_sym_PIPE_PIPE] = ACTIONS(1704),
    [anon_sym_GT_GT] = ACTIONS(1702),
    [anon_sym_GT_GT_GT] = ACTIONS(1704),
    [anon_sym_LT_LT] = ACTIONS(1704),
    [anon_sym_AMP] = ACTIONS(1702),
    [anon_sym_CARET] = ACTIONS(1704),
    [anon_sym_PIPE] = ACTIONS(1702),
    [anon_sym_PLUS] = ACTIONS(1702),
    [anon_sym_DASH] = ACTIONS(1702),
    [anon_sym_PERCENT] = ACTIONS(1704),
    [anon_sym_STAR_STAR] = ACTIONS(1704),
    [anon_sym_LT_EQ] = ACTIONS(1704),
    [anon_sym_EQ_EQ] = ACTIONS(1702),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1704),
    [anon_sym_BANG_EQ] = ACTIONS(1702),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1704),
    [anon_sym_GT_EQ] = ACTIONS(1704),
    [anon_sym_QMARK_QMARK] = ACTIONS(1704),
    [anon_sym_instanceof] = ACTIONS(1702),
    [anon_sym_TILDE] = ACTIONS(1704),
    [anon_sym_void] = ACTIONS(1702),
    [anon_sym_delete] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1704),
    [anon_sym_DASH_DASH] = ACTIONS(1704),
    [anon_sym_DQUOTE] = ACTIONS(1704),
    [anon_sym_SQUOTE] = ACTIONS(1704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1704),
    [sym_number] = ACTIONS(1704),
    [sym_this] = ACTIONS(1702),
    [sym_super] = ACTIONS(1702),
    [sym_true] = ACTIONS(1702),
    [sym_false] = ACTIONS(1702),
    [sym_null] = ACTIONS(1702),
    [sym_undefined] = ACTIONS(1702),
    [anon_sym_AT] = ACTIONS(1704),
    [anon_sym_static] = ACTIONS(1702),
    [anon_sym_readonly] = ACTIONS(1702),
    [anon_sym_get] = ACTIONS(1702),
    [anon_sym_set] = ACTIONS(1702),
    [anon_sym_declare] = ACTIONS(1702),
    [anon_sym_namespace] = ACTIONS(1702),
    [anon_sym_public] = ACTIONS(1702),
    [anon_sym_private] = ACTIONS(1702),
    [anon_sym_protected] = ACTIONS(1702),
    [anon_sym_override] = ACTIONS(1702),
    [anon_sym_module] = ACTIONS(1702),
    [anon_sym_any] = ACTIONS(1702),
    [anon_sym_number] = ACTIONS(1702),
    [anon_sym_boolean] = ACTIONS(1702),
    [anon_sym_string] = ACTIONS(1702),
    [anon_sym_symbol] = ACTIONS(1702),
    [anon_sym_abstract] = ACTIONS(1702),
    [anon_sym_satisfies] = ACTIONS(1702),
    [anon_sym_interface] = ACTIONS(1702),
    [anon_sym_enum] = ACTIONS(1702),
    [anon_sym_component] = ACTIONS(1702),
    [sym__automatic_semicolon] = ACTIONS(1704),
    [sym__ternary_qmark] = ACTIONS(1704),
  },
  [218] = {
    [sym_identifier] = ACTIONS(1706),
    [anon_sym_export] = ACTIONS(1706),
    [anon_sym_STAR] = ACTIONS(1708),
    [anon_sym_as] = ACTIONS(1708),
    [anon_sym_LBRACE] = ACTIONS(1710),
    [anon_sym_COMMA] = ACTIONS(1712),
    [anon_sym_RBRACE] = ACTIONS(1710),
    [anon_sym_type] = ACTIONS(1706),
    [anon_sym_typeof] = ACTIONS(1706),
    [anon_sym_import] = ACTIONS(1706),
    [anon_sym_var] = ACTIONS(1706),
    [anon_sym_let] = ACTIONS(1706),
    [anon_sym_const] = ACTIONS(1706),
    [anon_sym_BANG] = ACTIONS(1706),
    [anon_sym_else] = ACTIONS(1706),
    [anon_sym_if] = ACTIONS(1706),
    [anon_sym_switch] = ACTIONS(1706),
    [anon_sym_for] = ACTIONS(1706),
    [anon_sym_LPAREN] = ACTIONS(1710),
    [anon_sym_await] = ACTIONS(1706),
    [anon_sym_in] = ACTIONS(1708),
    [anon_sym_while] = ACTIONS(1706),
    [anon_sym_do] = ACTIONS(1706),
    [anon_sym_try] = ACTIONS(1706),
    [anon_sym_with] = ACTIONS(1706),
    [anon_sym_break] = ACTIONS(1706),
    [anon_sym_continue] = ACTIONS(1706),
    [anon_sym_debugger] = ACTIONS(1706),
    [anon_sym_return] = ACTIONS(1706),
    [anon_sym_throw] = ACTIONS(1706),
    [anon_sym_SEMI] = ACTIONS(1710),
    [anon_sym_case] = ACTIONS(1706),
    [anon_sym_default] = ACTIONS(1706),
    [anon_sym_yield] = ACTIONS(1706),
    [anon_sym_LBRACK] = ACTIONS(1710),
    [anon_sym_LTtemplate_GT] = ACTIONS(1710),
    [anon_sym_LT] = ACTIONS(1706),
    [anon_sym_GT] = ACTIONS(1708),
    [anon_sym_SLASH] = ACTIONS(1706),
    [anon_sym_DOT] = ACTIONS(1708),
    [anon_sym_class] = ACTIONS(1706),
    [anon_sym_async] = ACTIONS(1706),
    [anon_sym_function] = ACTIONS(1706),
    [anon_sym_QMARK_DOT] = ACTIONS(1712),
    [anon_sym_new] = ACTIONS(1706),
    [anon_sym_AMP_AMP] = ACTIONS(1712),
    [anon_sym_PIPE_PIPE] = ACTIONS(1712),
    [anon_sym_GT_GT] = ACTIONS(1708),
    [anon_sym_GT_GT_GT] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(1712),
    [anon_sym_AMP] = ACTIONS(1706),
    [anon_sym_CARET] = ACTIONS(1712),
    [anon_sym_PIPE] = ACTIONS(1708),
    [anon_sym_PLUS] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(1706),
    [anon_sym_PERCENT] = ACTIONS(1712),
    [anon_sym_STAR_STAR] = ACTIONS(1712),
    [anon_sym_LT_EQ] = ACTIONS(1712),
    [anon_sym_EQ_EQ] = ACTIONS(1708),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1712),
    [anon_sym_BANG_EQ] = ACTIONS(1708),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1712),
    [anon_sym_GT_EQ] = ACTIONS(1712),
    [anon_sym_QMARK_QMARK] = ACTIONS(1712),
    [anon_sym_instanceof] = ACTIONS(1708),
    [anon_sym_TILDE] = ACTIONS(1710),
    [anon_sym_void] = ACTIONS(1706),
    [anon_sym_delete] = ACTIONS(1706),
    [anon_sym_PLUS_PLUS] = ACTIONS(1710),
    [anon_sym_DASH_DASH] = ACTIONS(1710),
    [anon_sym_DQUOTE] = ACTIONS(1710),
    [anon_sym_SQUOTE] = ACTIONS(1710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1710),
    [sym_number] = ACTIONS(1710),
    [sym_this] = ACTIONS(1706),
    [sym_super] = ACTIONS(1706),
    [sym_true] = ACTIONS(1706),
    [sym_false] = ACTIONS(1706),
    [sym_null] = ACTIONS(1706),
    [sym_undefined] = ACTIONS(1706),
    [anon_sym_AT] = ACTIONS(1710),
    [anon_sym_static] = ACTIONS(1706),
    [anon_sym_readonly] = ACTIONS(1706),
    [anon_sym_get] = ACTIONS(1706),
    [anon_sym_set] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1706),
    [anon_sym_namespace] = ACTIONS(1706),
    [anon_sym_public] = ACTIONS(1706),
    [anon_sym_private] = ACTIONS(1706),
    [anon_sym_protected] = ACTIONS(1706),
    [anon_sym_override] = ACTIONS(1706),
    [anon_sym_module] = ACTIONS(1706),
    [anon_sym_any] = ACTIONS(1706),
    [anon_sym_number] = ACTIONS(1706),
    [anon_sym_boolean] = ACTIONS(1706),
    [anon_sym_string] = ACTIONS(1706),
    [anon_sym_symbol] = ACTIONS(1706),
    [anon_sym_abstract] = ACTIONS(1706),
    [anon_sym_satisfies] = ACTIONS(1708),
    [anon_sym_interface] = ACTIONS(1706),
    [anon_sym_enum] = ACTIONS(1706),
    [anon_sym_component] = ACTIONS(1706),
    [sym__automatic_semicolon] = ACTIONS(1714),
    [sym__ternary_qmark] = ACTIONS(1712),
  },
  [219] = {
    [sym_identifier] = ACTIONS(1716),
    [anon_sym_export] = ACTIONS(1716),
    [anon_sym_STAR] = ACTIONS(1718),
    [anon_sym_as] = ACTIONS(1718),
    [anon_sym_LBRACE] = ACTIONS(1720),
    [anon_sym_COMMA] = ACTIONS(1722),
    [anon_sym_RBRACE] = ACTIONS(1720),
    [anon_sym_type] = ACTIONS(1716),
    [anon_sym_typeof] = ACTIONS(1716),
    [anon_sym_import] = ACTIONS(1716),
    [anon_sym_var] = ACTIONS(1716),
    [anon_sym_let] = ACTIONS(1716),
    [anon_sym_const] = ACTIONS(1716),
    [anon_sym_BANG] = ACTIONS(1716),
    [anon_sym_else] = ACTIONS(1716),
    [anon_sym_if] = ACTIONS(1716),
    [anon_sym_switch] = ACTIONS(1716),
    [anon_sym_for] = ACTIONS(1716),
    [anon_sym_LPAREN] = ACTIONS(1720),
    [anon_sym_await] = ACTIONS(1716),
    [anon_sym_in] = ACTIONS(1718),
    [anon_sym_while] = ACTIONS(1716),
    [anon_sym_do] = ACTIONS(1716),
    [anon_sym_try] = ACTIONS(1716),
    [anon_sym_with] = ACTIONS(1716),
    [anon_sym_break] = ACTIONS(1716),
    [anon_sym_continue] = ACTIONS(1716),
    [anon_sym_debugger] = ACTIONS(1716),
    [anon_sym_return] = ACTIONS(1716),
    [anon_sym_throw] = ACTIONS(1716),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_case] = ACTIONS(1716),
    [anon_sym_default] = ACTIONS(1716),
    [anon_sym_yield] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1720),
    [anon_sym_LTtemplate_GT] = ACTIONS(1720),
    [anon_sym_LT] = ACTIONS(1716),
    [anon_sym_GT] = ACTIONS(1718),
    [anon_sym_SLASH] = ACTIONS(1716),
    [anon_sym_DOT] = ACTIONS(1718),
    [anon_sym_class] = ACTIONS(1716),
    [anon_sym_async] = ACTIONS(1716),
    [anon_sym_function] = ACTIONS(1716),
    [anon_sym_QMARK_DOT] = ACTIONS(1722),
    [anon_sym_new] = ACTIONS(1716),
    [anon_sym_AMP_AMP] = ACTIONS(1722),
    [anon_sym_PIPE_PIPE] = ACTIONS(1722),
    [anon_sym_GT_GT] = ACTIONS(1718),
    [anon_sym_GT_GT_GT] = ACTIONS(1722),
    [anon_sym_LT_LT] = ACTIONS(1722),
    [anon_sym_AMP] = ACTIONS(1716),
    [anon_sym_CARET] = ACTIONS(1722),
    [anon_sym_PIPE] = ACTIONS(1718),
    [anon_sym_PLUS] = ACTIONS(1716),
    [anon_sym_DASH] = ACTIONS(1716),
    [anon_sym_PERCENT] = ACTIONS(1722),
    [anon_sym_STAR_STAR] = ACTIONS(1722),
    [anon_sym_LT_EQ] = ACTIONS(1722),
    [anon_sym_EQ_EQ] = ACTIONS(1718),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1722),
    [anon_sym_BANG_EQ] = ACTIONS(1718),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1722),
    [anon_sym_GT_EQ] = ACTIONS(1722),
    [anon_sym_QMARK_QMARK] = ACTIONS(1722),
    [anon_sym_instanceof] = ACTIONS(1718),
    [anon_sym_TILDE] = ACTIONS(1720),
    [anon_sym_void] = ACTIONS(1716),
    [anon_sym_delete] = ACTIONS(1716),
    [anon_sym_PLUS_PLUS] = ACTIONS(1720),
    [anon_sym_DASH_DASH] = ACTIONS(1720),
    [anon_sym_DQUOTE] = ACTIONS(1720),
    [anon_sym_SQUOTE] = ACTIONS(1720),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1720),
    [sym_number] = ACTIONS(1720),
    [sym_this] = ACTIONS(1716),
    [sym_super] = ACTIONS(1716),
    [sym_true] = ACTIONS(1716),
    [sym_false] = ACTIONS(1716),
    [sym_null] = ACTIONS(1716),
    [sym_undefined] = ACTIONS(1716),
    [anon_sym_AT] = ACTIONS(1720),
    [anon_sym_static] = ACTIONS(1716),
    [anon_sym_readonly] = ACTIONS(1716),
    [anon_sym_get] = ACTIONS(1716),
    [anon_sym_set] = ACTIONS(1716),
    [anon_sym_declare] = ACTIONS(1716),
    [anon_sym_namespace] = ACTIONS(1716),
    [anon_sym_public] = ACTIONS(1716),
    [anon_sym_private] = ACTIONS(1716),
    [anon_sym_protected] = ACTIONS(1716),
    [anon_sym_override] = ACTIONS(1716),
    [anon_sym_module] = ACTIONS(1716),
    [anon_sym_any] = ACTIONS(1716),
    [anon_sym_number] = ACTIONS(1716),
    [anon_sym_boolean] = ACTIONS(1716),
    [anon_sym_string] = ACTIONS(1716),
    [anon_sym_symbol] = ACTIONS(1716),
    [anon_sym_abstract] = ACTIONS(1716),
    [anon_sym_satisfies] = ACTIONS(1718),
    [anon_sym_interface] = ACTIONS(1716),
    [anon_sym_enum] = ACTIONS(1716),
    [anon_sym_component] = ACTIONS(1716),
    [sym__automatic_semicolon] = ACTIONS(1724),
    [sym__ternary_qmark] = ACTIONS(1722),
  },
  [220] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1564),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1076),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_property_assignment_expression] = STATE(1564),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [221] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1575),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(852),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_property_assignment_expression] = STATE(1575),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [222] = {
    [sym_identifier] = ACTIONS(1726),
    [anon_sym_export] = ACTIONS(1726),
    [anon_sym_STAR] = ACTIONS(1728),
    [anon_sym_as] = ACTIONS(1728),
    [anon_sym_LBRACE] = ACTIONS(1730),
    [anon_sym_COMMA] = ACTIONS(1732),
    [anon_sym_RBRACE] = ACTIONS(1730),
    [anon_sym_type] = ACTIONS(1726),
    [anon_sym_typeof] = ACTIONS(1726),
    [anon_sym_import] = ACTIONS(1726),
    [anon_sym_var] = ACTIONS(1726),
    [anon_sym_let] = ACTIONS(1726),
    [anon_sym_const] = ACTIONS(1726),
    [anon_sym_BANG] = ACTIONS(1726),
    [anon_sym_else] = ACTIONS(1726),
    [anon_sym_if] = ACTIONS(1726),
    [anon_sym_switch] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1726),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_await] = ACTIONS(1726),
    [anon_sym_in] = ACTIONS(1728),
    [anon_sym_while] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1726),
    [anon_sym_try] = ACTIONS(1726),
    [anon_sym_with] = ACTIONS(1726),
    [anon_sym_break] = ACTIONS(1726),
    [anon_sym_continue] = ACTIONS(1726),
    [anon_sym_debugger] = ACTIONS(1726),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_throw] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1730),
    [anon_sym_case] = ACTIONS(1726),
    [anon_sym_default] = ACTIONS(1726),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_LBRACK] = ACTIONS(1730),
    [anon_sym_LTtemplate_GT] = ACTIONS(1730),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_SLASH] = ACTIONS(1726),
    [anon_sym_DOT] = ACTIONS(1728),
    [anon_sym_class] = ACTIONS(1726),
    [anon_sym_async] = ACTIONS(1726),
    [anon_sym_function] = ACTIONS(1726),
    [anon_sym_QMARK_DOT] = ACTIONS(1732),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_AMP_AMP] = ACTIONS(1732),
    [anon_sym_PIPE_PIPE] = ACTIONS(1732),
    [anon_sym_GT_GT] = ACTIONS(1728),
    [anon_sym_GT_GT_GT] = ACTIONS(1732),
    [anon_sym_LT_LT] = ACTIONS(1732),
    [anon_sym_AMP] = ACTIONS(1726),
    [anon_sym_CARET] = ACTIONS(1732),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_PLUS] = ACTIONS(1726),
    [anon_sym_DASH] = ACTIONS(1726),
    [anon_sym_PERCENT] = ACTIONS(1732),
    [anon_sym_STAR_STAR] = ACTIONS(1732),
    [anon_sym_LT_EQ] = ACTIONS(1732),
    [anon_sym_EQ_EQ] = ACTIONS(1728),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1732),
    [anon_sym_BANG_EQ] = ACTIONS(1728),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1732),
    [anon_sym_GT_EQ] = ACTIONS(1732),
    [anon_sym_QMARK_QMARK] = ACTIONS(1732),
    [anon_sym_instanceof] = ACTIONS(1728),
    [anon_sym_TILDE] = ACTIONS(1730),
    [anon_sym_void] = ACTIONS(1726),
    [anon_sym_delete] = ACTIONS(1726),
    [anon_sym_PLUS_PLUS] = ACTIONS(1730),
    [anon_sym_DASH_DASH] = ACTIONS(1730),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1730),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1730),
    [sym_number] = ACTIONS(1730),
    [sym_this] = ACTIONS(1726),
    [sym_super] = ACTIONS(1726),
    [sym_true] = ACTIONS(1726),
    [sym_false] = ACTIONS(1726),
    [sym_null] = ACTIONS(1726),
    [sym_undefined] = ACTIONS(1726),
    [anon_sym_AT] = ACTIONS(1730),
    [anon_sym_static] = ACTIONS(1726),
    [anon_sym_readonly] = ACTIONS(1726),
    [anon_sym_get] = ACTIONS(1726),
    [anon_sym_set] = ACTIONS(1726),
    [anon_sym_declare] = ACTIONS(1726),
    [anon_sym_namespace] = ACTIONS(1726),
    [anon_sym_public] = ACTIONS(1726),
    [anon_sym_private] = ACTIONS(1726),
    [anon_sym_protected] = ACTIONS(1726),
    [anon_sym_override] = ACTIONS(1726),
    [anon_sym_module] = ACTIONS(1726),
    [anon_sym_any] = ACTIONS(1726),
    [anon_sym_number] = ACTIONS(1726),
    [anon_sym_boolean] = ACTIONS(1726),
    [anon_sym_string] = ACTIONS(1726),
    [anon_sym_symbol] = ACTIONS(1726),
    [anon_sym_abstract] = ACTIONS(1726),
    [anon_sym_satisfies] = ACTIONS(1728),
    [anon_sym_interface] = ACTIONS(1726),
    [anon_sym_enum] = ACTIONS(1726),
    [anon_sym_component] = ACTIONS(1726),
    [sym__automatic_semicolon] = ACTIONS(1734),
    [sym__ternary_qmark] = ACTIONS(1732),
  },
  [223] = {
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1736),
    [anon_sym_STAR] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_COMMA] = ACTIONS(1742),
    [anon_sym_RBRACE] = ACTIONS(1740),
    [anon_sym_type] = ACTIONS(1736),
    [anon_sym_typeof] = ACTIONS(1736),
    [anon_sym_import] = ACTIONS(1736),
    [anon_sym_var] = ACTIONS(1736),
    [anon_sym_let] = ACTIONS(1736),
    [anon_sym_const] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1736),
    [anon_sym_else] = ACTIONS(1736),
    [anon_sym_if] = ACTIONS(1736),
    [anon_sym_switch] = ACTIONS(1736),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_LPAREN] = ACTIONS(1740),
    [anon_sym_await] = ACTIONS(1736),
    [anon_sym_in] = ACTIONS(1738),
    [anon_sym_while] = ACTIONS(1736),
    [anon_sym_do] = ACTIONS(1736),
    [anon_sym_try] = ACTIONS(1736),
    [anon_sym_with] = ACTIONS(1736),
    [anon_sym_break] = ACTIONS(1736),
    [anon_sym_continue] = ACTIONS(1736),
    [anon_sym_debugger] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1736),
    [anon_sym_throw] = ACTIONS(1736),
    [anon_sym_SEMI] = ACTIONS(1740),
    [anon_sym_case] = ACTIONS(1736),
    [anon_sym_default] = ACTIONS(1736),
    [anon_sym_yield] = ACTIONS(1736),
    [anon_sym_LBRACK] = ACTIONS(1740),
    [anon_sym_LTtemplate_GT] = ACTIONS(1740),
    [anon_sym_LT] = ACTIONS(1736),
    [anon_sym_GT] = ACTIONS(1738),
    [anon_sym_SLASH] = ACTIONS(1736),
    [anon_sym_DOT] = ACTIONS(1738),
    [anon_sym_class] = ACTIONS(1736),
    [anon_sym_async] = ACTIONS(1736),
    [anon_sym_function] = ACTIONS(1736),
    [anon_sym_QMARK_DOT] = ACTIONS(1742),
    [anon_sym_new] = ACTIONS(1736),
    [anon_sym_AMP_AMP] = ACTIONS(1742),
    [anon_sym_PIPE_PIPE] = ACTIONS(1742),
    [anon_sym_GT_GT] = ACTIONS(1738),
    [anon_sym_GT_GT_GT] = ACTIONS(1742),
    [anon_sym_LT_LT] = ACTIONS(1742),
    [anon_sym_AMP] = ACTIONS(1736),
    [anon_sym_CARET] = ACTIONS(1742),
    [anon_sym_PIPE] = ACTIONS(1738),
    [anon_sym_PLUS] = ACTIONS(1736),
    [anon_sym_DASH] = ACTIONS(1736),
    [anon_sym_PERCENT] = ACTIONS(1742),
    [anon_sym_STAR_STAR] = ACTIONS(1742),
    [anon_sym_LT_EQ] = ACTIONS(1742),
    [anon_sym_EQ_EQ] = ACTIONS(1738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1742),
    [anon_sym_BANG_EQ] = ACTIONS(1738),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1742),
    [anon_sym_GT_EQ] = ACTIONS(1742),
    [anon_sym_QMARK_QMARK] = ACTIONS(1742),
    [anon_sym_instanceof] = ACTIONS(1738),
    [anon_sym_TILDE] = ACTIONS(1740),
    [anon_sym_void] = ACTIONS(1736),
    [anon_sym_delete] = ACTIONS(1736),
    [anon_sym_PLUS_PLUS] = ACTIONS(1740),
    [anon_sym_DASH_DASH] = ACTIONS(1740),
    [anon_sym_DQUOTE] = ACTIONS(1740),
    [anon_sym_SQUOTE] = ACTIONS(1740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_number] = ACTIONS(1740),
    [sym_this] = ACTIONS(1736),
    [sym_super] = ACTIONS(1736),
    [sym_true] = ACTIONS(1736),
    [sym_false] = ACTIONS(1736),
    [sym_null] = ACTIONS(1736),
    [sym_undefined] = ACTIONS(1736),
    [anon_sym_AT] = ACTIONS(1740),
    [anon_sym_static] = ACTIONS(1736),
    [anon_sym_readonly] = ACTIONS(1736),
    [anon_sym_get] = ACTIONS(1736),
    [anon_sym_set] = ACTIONS(1736),
    [anon_sym_declare] = ACTIONS(1736),
    [anon_sym_namespace] = ACTIONS(1736),
    [anon_sym_public] = ACTIONS(1736),
    [anon_sym_private] = ACTIONS(1736),
    [anon_sym_protected] = ACTIONS(1736),
    [anon_sym_override] = ACTIONS(1736),
    [anon_sym_module] = ACTIONS(1736),
    [anon_sym_any] = ACTIONS(1736),
    [anon_sym_number] = ACTIONS(1736),
    [anon_sym_boolean] = ACTIONS(1736),
    [anon_sym_string] = ACTIONS(1736),
    [anon_sym_symbol] = ACTIONS(1736),
    [anon_sym_abstract] = ACTIONS(1736),
    [anon_sym_satisfies] = ACTIONS(1738),
    [anon_sym_interface] = ACTIONS(1736),
    [anon_sym_enum] = ACTIONS(1736),
    [anon_sym_component] = ACTIONS(1736),
    [sym__automatic_semicolon] = ACTIONS(1744),
    [sym__ternary_qmark] = ACTIONS(1742),
  },
  [224] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1780),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1993),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [225] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1809),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2378),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [226] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2355),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4796),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [227] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4706),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [228] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2357),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4789),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [229] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1061),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1092),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [230] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1006),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1085),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [231] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2289),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4174),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [232] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1774),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2392),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [233] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1607),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3545),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4319),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_DOT] = ACTIONS(1750),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [234] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1054),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(764),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [235] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2316),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4788),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [236] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1607),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3545),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4319),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1752),
    [anon_sym_export] = ACTIONS(1754),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1754),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_DOT] = ACTIONS(1750),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1756),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1754),
    [anon_sym_readonly] = ACTIONS(1754),
    [anon_sym_get] = ACTIONS(1754),
    [anon_sym_set] = ACTIONS(1754),
    [anon_sym_declare] = ACTIONS(1754),
    [anon_sym_namespace] = ACTIONS(1754),
    [anon_sym_public] = ACTIONS(1754),
    [anon_sym_private] = ACTIONS(1754),
    [anon_sym_protected] = ACTIONS(1754),
    [anon_sym_override] = ACTIONS(1754),
    [anon_sym_module] = ACTIONS(1754),
    [anon_sym_any] = ACTIONS(1754),
    [anon_sym_number] = ACTIONS(1754),
    [anon_sym_boolean] = ACTIONS(1754),
    [anon_sym_string] = ACTIONS(1754),
    [anon_sym_symbol] = ACTIONS(1754),
    [anon_sym_component] = ACTIONS(120),
  },
  [237] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1061),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(769),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [238] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2369),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4782),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [239] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2333),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4705),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [240] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2320),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4586),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [241] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1460),
    [sym_expression] = STATE(2495),
    [sym_primary_expression] = STATE(1746),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1460),
    [sym_subscript_expression] = STATE(1460),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1460),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1758),
    [anon_sym_export] = ACTIONS(1760),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1760),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_DOT] = ACTIONS(1762),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1764),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1766),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1768),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1760),
    [anon_sym_readonly] = ACTIONS(1760),
    [anon_sym_get] = ACTIONS(1760),
    [anon_sym_set] = ACTIONS(1760),
    [anon_sym_declare] = ACTIONS(1760),
    [anon_sym_namespace] = ACTIONS(1760),
    [anon_sym_public] = ACTIONS(1760),
    [anon_sym_private] = ACTIONS(1760),
    [anon_sym_protected] = ACTIONS(1760),
    [anon_sym_override] = ACTIONS(1760),
    [anon_sym_module] = ACTIONS(1760),
    [anon_sym_any] = ACTIONS(1760),
    [anon_sym_number] = ACTIONS(1760),
    [anon_sym_boolean] = ACTIONS(1760),
    [anon_sym_string] = ACTIONS(1760),
    [anon_sym_symbol] = ACTIONS(1760),
    [anon_sym_component] = ACTIONS(1010),
  },
  [242] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1045),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(762),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [243] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1460),
    [sym_expression] = STATE(2495),
    [sym_primary_expression] = STATE(1746),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1460),
    [sym_subscript_expression] = STATE(1460),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1460),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1770),
    [anon_sym_export] = ACTIONS(1772),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1772),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_DOT] = ACTIONS(1762),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1774),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1766),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1768),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1772),
    [anon_sym_readonly] = ACTIONS(1772),
    [anon_sym_get] = ACTIONS(1772),
    [anon_sym_set] = ACTIONS(1772),
    [anon_sym_declare] = ACTIONS(1772),
    [anon_sym_namespace] = ACTIONS(1772),
    [anon_sym_public] = ACTIONS(1772),
    [anon_sym_private] = ACTIONS(1772),
    [anon_sym_protected] = ACTIONS(1772),
    [anon_sym_override] = ACTIONS(1772),
    [anon_sym_module] = ACTIONS(1772),
    [anon_sym_any] = ACTIONS(1772),
    [anon_sym_number] = ACTIONS(1772),
    [anon_sym_boolean] = ACTIONS(1772),
    [anon_sym_string] = ACTIONS(1772),
    [anon_sym_symbol] = ACTIONS(1772),
    [anon_sym_component] = ACTIONS(1010),
  },
  [244] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1054),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1091),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [245] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1045),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1090),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [246] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1758),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2121),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [247] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1607),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1778),
    [anon_sym_export] = ACTIONS(1780),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1780),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_DOT] = ACTIONS(1750),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1782),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1780),
    [anon_sym_readonly] = ACTIONS(1780),
    [anon_sym_get] = ACTIONS(1780),
    [anon_sym_set] = ACTIONS(1780),
    [anon_sym_declare] = ACTIONS(1780),
    [anon_sym_namespace] = ACTIONS(1780),
    [anon_sym_public] = ACTIONS(1780),
    [anon_sym_private] = ACTIONS(1780),
    [anon_sym_protected] = ACTIONS(1780),
    [anon_sym_override] = ACTIONS(1780),
    [anon_sym_module] = ACTIONS(1780),
    [anon_sym_any] = ACTIONS(1780),
    [anon_sym_number] = ACTIONS(1780),
    [anon_sym_boolean] = ACTIONS(1780),
    [anon_sym_string] = ACTIONS(1780),
    [anon_sym_symbol] = ACTIONS(1780),
    [anon_sym_component] = ACTIONS(120),
  },
  [248] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1780),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2103),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [249] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2041),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(3880),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [250] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4704),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [251] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1607),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_DOT] = ACTIONS(1762),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [252] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1542),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(710),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [253] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1810),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2217),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [254] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(537),
    [sym_expression] = STATE(2508),
    [sym_primary_expression] = STATE(687),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(537),
    [sym_subscript_expression] = STATE(537),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(537),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(1784),
    [anon_sym_export] = ACTIONS(1786),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(1786),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_DOT] = ACTIONS(1790),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(1792),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(1794),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(1796),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1786),
    [anon_sym_readonly] = ACTIONS(1786),
    [anon_sym_get] = ACTIONS(1786),
    [anon_sym_set] = ACTIONS(1786),
    [anon_sym_declare] = ACTIONS(1786),
    [anon_sym_namespace] = ACTIONS(1786),
    [anon_sym_public] = ACTIONS(1786),
    [anon_sym_private] = ACTIONS(1786),
    [anon_sym_protected] = ACTIONS(1786),
    [anon_sym_override] = ACTIONS(1786),
    [anon_sym_module] = ACTIONS(1786),
    [anon_sym_any] = ACTIONS(1786),
    [anon_sym_number] = ACTIONS(1786),
    [anon_sym_boolean] = ACTIONS(1786),
    [anon_sym_string] = ACTIONS(1786),
    [anon_sym_symbol] = ACTIONS(1786),
    [anon_sym_component] = ACTIONS(806),
  },
  [255] = {
    [sym_import] = STATE(2110),
    [sym_statement_block] = STATE(2279),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(2084),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(1798),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [256] = {
    [sym_import] = STATE(2110),
    [sym_statement_block] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(2086),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(1798),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [257] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(1996),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4535),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [258] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1809),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2216),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [259] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2021),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4695),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [260] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2318),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4760),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [261] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1607),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3603),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4326),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_DOT] = ACTIONS(1750),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [262] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1807),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2058),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [263] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1809),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2070),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [264] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1810),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2067),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [265] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1607),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_DOT] = ACTIONS(1750),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [266] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1006),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(848),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [267] = {
    [sym_import] = STATE(2110),
    [sym_statement_block] = STATE(2266),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(1882),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(1798),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [268] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1807),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2213),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [269] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2322),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4674),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [270] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2326),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4536),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [271] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1774),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2169),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [272] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2384),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_mapped_type_clause] = STATE(4575),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1800),
    [anon_sym_export] = ACTIONS(1802),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1802),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1804),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1802),
    [anon_sym_readonly] = ACTIONS(1802),
    [anon_sym_get] = ACTIONS(1802),
    [anon_sym_set] = ACTIONS(1802),
    [anon_sym_declare] = ACTIONS(1802),
    [anon_sym_namespace] = ACTIONS(1802),
    [anon_sym_public] = ACTIONS(1802),
    [anon_sym_private] = ACTIONS(1802),
    [anon_sym_protected] = ACTIONS(1802),
    [anon_sym_override] = ACTIONS(1802),
    [anon_sym_module] = ACTIONS(1802),
    [anon_sym_any] = ACTIONS(1802),
    [anon_sym_number] = ACTIONS(1802),
    [anon_sym_boolean] = ACTIONS(1802),
    [anon_sym_string] = ACTIONS(1802),
    [anon_sym_symbol] = ACTIONS(1802),
    [anon_sym_component] = ACTIONS(120),
  },
  [273] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1050),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(800),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [274] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1780),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2206),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [275] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1810),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2204),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [276] = {
    [sym_import] = STATE(2110),
    [sym_statement_block] = STATE(2152),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2048),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1798),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [277] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1809),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2145),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [278] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1044),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(840),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [279] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1807),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2118),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [280] = {
    [sym_import] = STATE(2110),
    [sym_statement_block] = STATE(2152),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(2066),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(1798),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [281] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2325),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(3880),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [282] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(537),
    [sym_expression] = STATE(2508),
    [sym_primary_expression] = STATE(687),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(537),
    [sym_subscript_expression] = STATE(537),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(537),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(1806),
    [anon_sym_export] = ACTIONS(1808),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(1808),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_DOT] = ACTIONS(1790),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(1810),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(1794),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(1796),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1808),
    [anon_sym_readonly] = ACTIONS(1808),
    [anon_sym_get] = ACTIONS(1808),
    [anon_sym_set] = ACTIONS(1808),
    [anon_sym_declare] = ACTIONS(1808),
    [anon_sym_namespace] = ACTIONS(1808),
    [anon_sym_public] = ACTIONS(1808),
    [anon_sym_private] = ACTIONS(1808),
    [anon_sym_protected] = ACTIONS(1808),
    [anon_sym_override] = ACTIONS(1808),
    [anon_sym_module] = ACTIONS(1808),
    [anon_sym_any] = ACTIONS(1808),
    [anon_sym_number] = ACTIONS(1808),
    [anon_sym_boolean] = ACTIONS(1808),
    [anon_sym_string] = ACTIONS(1808),
    [anon_sym_symbol] = ACTIONS(1808),
    [anon_sym_component] = ACTIONS(806),
  },
  [283] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1758),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2128),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [284] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2363),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4590),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [285] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2341),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4583),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [286] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2186),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_sequence_expression] = STATE(4436),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [287] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1774),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1971),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [288] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2352),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4515),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [289] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2342),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4587),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [290] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1050),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1079),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [291] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1542),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1077),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [292] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2384),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_mapped_type_clause] = STATE(4701),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1812),
    [anon_sym_export] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1814),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1816),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1814),
    [anon_sym_readonly] = ACTIONS(1814),
    [anon_sym_get] = ACTIONS(1814),
    [anon_sym_set] = ACTIONS(1814),
    [anon_sym_declare] = ACTIONS(1814),
    [anon_sym_namespace] = ACTIONS(1814),
    [anon_sym_public] = ACTIONS(1814),
    [anon_sym_private] = ACTIONS(1814),
    [anon_sym_protected] = ACTIONS(1814),
    [anon_sym_override] = ACTIONS(1814),
    [anon_sym_module] = ACTIONS(1814),
    [anon_sym_any] = ACTIONS(1814),
    [anon_sym_number] = ACTIONS(1814),
    [anon_sym_boolean] = ACTIONS(1814),
    [anon_sym_string] = ACTIONS(1814),
    [anon_sym_symbol] = ACTIONS(1814),
    [anon_sym_component] = ACTIONS(120),
  },
  [293] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1607),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_DOT] = ACTIONS(1790),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [294] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1607),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1752),
    [anon_sym_export] = ACTIONS(1754),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1754),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_DOT] = ACTIONS(1750),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1756),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1754),
    [anon_sym_readonly] = ACTIONS(1754),
    [anon_sym_get] = ACTIONS(1754),
    [anon_sym_set] = ACTIONS(1754),
    [anon_sym_declare] = ACTIONS(1754),
    [anon_sym_namespace] = ACTIONS(1754),
    [anon_sym_public] = ACTIONS(1754),
    [anon_sym_private] = ACTIONS(1754),
    [anon_sym_protected] = ACTIONS(1754),
    [anon_sym_override] = ACTIONS(1754),
    [anon_sym_module] = ACTIONS(1754),
    [anon_sym_any] = ACTIONS(1754),
    [anon_sym_number] = ACTIONS(1754),
    [anon_sym_boolean] = ACTIONS(1754),
    [anon_sym_string] = ACTIONS(1754),
    [anon_sym_symbol] = ACTIONS(1754),
    [anon_sym_component] = ACTIONS(120),
  },
  [295] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1607),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1818),
    [anon_sym_export] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1820),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_DOT] = ACTIONS(1750),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1822),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1820),
    [anon_sym_readonly] = ACTIONS(1820),
    [anon_sym_get] = ACTIONS(1820),
    [anon_sym_set] = ACTIONS(1820),
    [anon_sym_declare] = ACTIONS(1820),
    [anon_sym_namespace] = ACTIONS(1820),
    [anon_sym_public] = ACTIONS(1820),
    [anon_sym_private] = ACTIONS(1820),
    [anon_sym_protected] = ACTIONS(1820),
    [anon_sym_override] = ACTIONS(1820),
    [anon_sym_module] = ACTIONS(1820),
    [anon_sym_any] = ACTIONS(1820),
    [anon_sym_number] = ACTIONS(1820),
    [anon_sym_boolean] = ACTIONS(1820),
    [anon_sym_string] = ACTIONS(1820),
    [anon_sym_symbol] = ACTIONS(1820),
    [anon_sym_component] = ACTIONS(120),
  },
  [296] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2350),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_sequence_expression] = STATE(4747),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [297] = {
    [sym_import] = STATE(998),
    [sym_statement_block] = STATE(1044),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1072),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1748),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [298] = {
    [sym_import] = STATE(2110),
    [sym_statement_block] = STATE(2278),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2008),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1798),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [299] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1607),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3545),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4319),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1818),
    [anon_sym_export] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1820),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_DOT] = ACTIONS(1750),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1822),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1820),
    [anon_sym_readonly] = ACTIONS(1820),
    [anon_sym_get] = ACTIONS(1820),
    [anon_sym_set] = ACTIONS(1820),
    [anon_sym_declare] = ACTIONS(1820),
    [anon_sym_namespace] = ACTIONS(1820),
    [anon_sym_public] = ACTIONS(1820),
    [anon_sym_private] = ACTIONS(1820),
    [anon_sym_protected] = ACTIONS(1820),
    [anon_sym_override] = ACTIONS(1820),
    [anon_sym_module] = ACTIONS(1820),
    [anon_sym_any] = ACTIONS(1820),
    [anon_sym_number] = ACTIONS(1820),
    [anon_sym_boolean] = ACTIONS(1820),
    [anon_sym_string] = ACTIONS(1820),
    [anon_sym_symbol] = ACTIONS(1820),
    [anon_sym_component] = ACTIONS(120),
  },
  [300] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1758),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2399),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [301] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1780),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2483),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [302] = {
    [sym_import] = STATE(2110),
    [sym_statement_block] = STATE(2266),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2014),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1798),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [303] = {
    [sym_import] = STATE(2110),
    [sym_statement_block] = STATE(2224),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(1946),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(1798),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [304] = {
    [sym_import] = STATE(2110),
    [sym_statement_block] = STATE(2224),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2019),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1798),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [305] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1810),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2379),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [306] = {
    [sym_import] = STATE(2110),
    [sym_statement_block] = STATE(2278),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(1938),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(1798),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [307] = {
    [sym_import] = STATE(2110),
    [sym_statement_block] = STATE(2275),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2007),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1798),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [308] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1807),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2481),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [309] = {
    [sym_import] = STATE(2110),
    [sym_statement_block] = STATE(2279),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2005),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1798),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [310] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1758),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1936),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1746),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [311] = {
    [sym_import] = STATE(1743),
    [sym_statement_block] = STATE(1774),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2298),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [312] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2174),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [313] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2199),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [314] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2469),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [315] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(728),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [316] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(1967),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [317] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(1966),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [318] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2309),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [319] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2486),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [320] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2484),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [321] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2391),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [322] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1614),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(1824),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [323] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(1612),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [324] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(1614),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [325] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(1881),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [326] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(1614),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(1826),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [327] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(1914),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [328] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(738),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [329] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2305),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [330] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(1956),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [331] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(1955),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [332] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2459),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [333] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1614),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(1826),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [334] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2426),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [335] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(1944),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [336] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(765),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [337] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(1942),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [338] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1078),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [339] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(1939),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [340] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2035),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [341] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(1935),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [342] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1931),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [343] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2034),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [344] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2033),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [345] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2032),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [346] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2030),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [347] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1892),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3243),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3243),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1490),
    [sym_subscript_expression] = STATE(1490),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3243),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1490),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1828),
    [anon_sym_export] = ACTIONS(968),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_type] = ACTIONS(968),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1082),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(972),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(968),
    [anon_sym_readonly] = ACTIONS(968),
    [anon_sym_get] = ACTIONS(968),
    [anon_sym_set] = ACTIONS(968),
    [anon_sym_declare] = ACTIONS(968),
    [anon_sym_namespace] = ACTIONS(968),
    [anon_sym_public] = ACTIONS(968),
    [anon_sym_private] = ACTIONS(968),
    [anon_sym_protected] = ACTIONS(968),
    [anon_sym_override] = ACTIONS(968),
    [anon_sym_module] = ACTIONS(968),
    [anon_sym_any] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_boolean] = ACTIONS(968),
    [anon_sym_string] = ACTIONS(968),
    [anon_sym_symbol] = ACTIONS(968),
    [anon_sym_component] = ACTIONS(120),
  },
  [348] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(739),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [349] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2026),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [350] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2018),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [351] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(742),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [352] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2398),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [353] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(1855),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [354] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2450),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [355] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [356] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [357] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(1853),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [358] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2402),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [359] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1069),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [360] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(1851),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [361] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(1968),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [362] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2395),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [363] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1088),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [364] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2004),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [365] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1892),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [366] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2172),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [367] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(1850),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [368] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2173),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [369] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1948),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [370] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2384),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [371] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1070),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [372] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(726),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [373] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(746),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [374] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2446),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [375] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2468),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [376] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2280),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [377] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(748),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [378] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1080),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [379] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(1617),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [380] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(1616),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [381] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(1612),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [382] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(1617),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [383] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2405),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [384] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(1861),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [385] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2038),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [386] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2196),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [387] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(1616),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [388] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(1614),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [389] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(724),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [390] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2386),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [391] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(1976),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [392] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2418),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [393] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2130),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [394] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(768),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [395] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(789),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [396] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2140),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [397] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(776),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [398] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2410),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [399] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(1612),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [400] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(1616),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [401] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(1614),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(1832),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [402] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(2003),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [403] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(2013),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [404] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(1617),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [405] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1970),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [406] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(2031),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [407] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2175),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [408] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2218),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [409] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(2081),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [410] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2348),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [411] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2478),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [412] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1927),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [413] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(750),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [414] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2376),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [415] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1086),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [416] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1928),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [417] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(2054),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [418] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2039),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [419] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(757),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [420] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1977),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [421] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1978),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [422] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1980),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [423] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1981),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [424] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1982),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [425] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1985),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [426] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1986),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [427] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1987),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [428] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1988),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [429] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1989),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [430] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2040),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [431] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(1614),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [432] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(760),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [433] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(763),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [434] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2122),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [435] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1617),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [436] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2189),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [437] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2191),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [438] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3243),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3243),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3243),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1834),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_LBRACE] = ACTIONS(604),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1836),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
    [anon_sym_component] = ACTIONS(120),
  },
  [439] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2394),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [440] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1994),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [441] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2411),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [442] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2200),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [443] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(2057),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [444] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(761),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [445] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2126),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [446] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2043),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [447] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [448] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2201),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [449] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2238),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [450] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2090),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [451] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1075),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [452] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(2078),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [453] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1500),
    [sym_expression] = STATE(2065),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4797),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4797),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4795),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1500),
    [sym_subscript_expression] = STATE(1500),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2775),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4797),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1500),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(353),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(978),
    [anon_sym_export] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_typeof] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(1004),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(992),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_void] = ACTIONS(986),
    [anon_sym_delete] = ACTIONS(986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1006),
    [anon_sym_DASH_DASH] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(980),
    [anon_sym_readonly] = ACTIONS(980),
    [anon_sym_get] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(980),
    [anon_sym_declare] = ACTIONS(980),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_public] = ACTIONS(980),
    [anon_sym_private] = ACTIONS(980),
    [anon_sym_protected] = ACTIONS(980),
    [anon_sym_override] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [anon_sym_any] = ACTIONS(980),
    [anon_sym_number] = ACTIONS(980),
    [anon_sym_boolean] = ACTIONS(980),
    [anon_sym_string] = ACTIONS(980),
    [anon_sym_symbol] = ACTIONS(980),
    [anon_sym_component] = ACTIONS(1010),
  },
  [454] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2044),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [455] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2439),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [456] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2377),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [457] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(859),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [458] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1614),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(1838),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [459] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2100),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [460] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2343),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [461] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2092),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [462] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(3243),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(3243),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1451),
    [sym_subscript_expression] = STATE(1451),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(3243),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1451),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1834),
    [anon_sym_export] = ACTIONS(944),
    [anon_sym_LBRACE] = ACTIONS(1256),
    [anon_sym_type] = ACTIONS(944),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1836),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(944),
    [anon_sym_readonly] = ACTIONS(944),
    [anon_sym_get] = ACTIONS(944),
    [anon_sym_set] = ACTIONS(944),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_namespace] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(944),
    [anon_sym_private] = ACTIONS(944),
    [anon_sym_protected] = ACTIONS(944),
    [anon_sym_override] = ACTIONS(944),
    [anon_sym_module] = ACTIONS(944),
    [anon_sym_any] = ACTIONS(944),
    [anon_sym_number] = ACTIONS(944),
    [anon_sym_boolean] = ACTIONS(944),
    [anon_sym_string] = ACTIONS(944),
    [anon_sym_symbol] = ACTIONS(944),
    [anon_sym_component] = ACTIONS(120),
  },
  [463] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1074),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [464] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2163),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [465] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2052),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [466] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2252),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [467] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2277),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [468] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2424),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [469] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1973),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [470] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(801),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [471] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(1855),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [472] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2438),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [473] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2106),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [474] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(2207),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [475] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(781),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [476] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1073),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [477] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(1895),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [478] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2111),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [479] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(1853),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [480] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(871),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [481] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2107),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [482] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(2340),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [483] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(776),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [484] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1616),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [485] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2285),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [486] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(1851),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [487] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2294),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [488] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1093),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [489] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1614),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [490] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2299),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [491] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(870),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [492] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(1850),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [493] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1089),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [494] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(728),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [495] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(789),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [496] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1082),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [497] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2429),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [498] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1071),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [499] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2390),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [500] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2297),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [501] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2307),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [502] = {
    [sym_import] = STATE(2110),
    [sym_parenthesized_expression] = STATE(1495),
    [sym_expression] = STATE(2253),
    [sym_primary_expression] = STATE(1903),
    [sym_yield_expression] = STATE(2098),
    [sym_object] = STATE(2110),
    [sym_object_pattern] = STATE(4891),
    [sym_array] = STATE(2110),
    [sym_array_pattern] = STATE(4891),
    [sym_glimmer_template] = STATE(2098),
    [sym_glimmer_opening_tag] = STATE(3748),
    [sym_nested_identifier] = STATE(3101),
    [sym_class] = STATE(2110),
    [sym_function] = STATE(2110),
    [sym_generator_function] = STATE(2110),
    [sym_arrow_function] = STATE(2110),
    [sym__call_signature] = STATE(4888),
    [sym_call_expression] = STATE(2110),
    [sym_new_expression] = STATE(2098),
    [sym_await_expression] = STATE(2098),
    [sym_member_expression] = STATE(1495),
    [sym_subscript_expression] = STATE(1495),
    [sym_assignment_expression] = STATE(2098),
    [sym__augmented_assignment_lhs] = STATE(2785),
    [sym_augmented_assignment_expression] = STATE(2098),
    [sym__destructuring_pattern] = STATE(4891),
    [sym_ternary_expression] = STATE(2098),
    [sym_binary_expression] = STATE(2098),
    [sym_unary_expression] = STATE(2098),
    [sym_update_expression] = STATE(2098),
    [sym_string] = STATE(2110),
    [sym_template_string] = STATE(2110),
    [sym_regex] = STATE(2110),
    [sym_meta_property] = STATE(2110),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1495),
    [sym_type_assertion] = STATE(2098),
    [sym_as_expression] = STATE(2098),
    [sym_satisfies_expression] = STATE(2098),
    [sym_type_arguments] = STATE(471),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(2110),
    [sym_component_short_heritage] = STATE(3737),
    [sym_new_component_expression] = STATE(2098),
    [sym_new_tagged_component_expression] = STATE(2098),
    [sym_new_tripple_tagged_component_expression] = STATE(2098),
    [aux_sym_class_repeat1] = STATE(3313),
    [sym_identifier] = ACTIONS(1024),
    [anon_sym_export] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_typeof] = ACTIONS(143),
    [anon_sym_import] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [anon_sym_yield] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(498),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(189),
    [anon_sym_class] = ACTIONS(996),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_function] = ACTIONS(1000),
    [anon_sym_new] = ACTIONS(197),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(143),
    [anon_sym_DASH] = ACTIONS(143),
    [anon_sym_TILDE] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(143),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(207),
    [sym_number] = ACTIONS(502),
    [sym_this] = ACTIONS(213),
    [sym_super] = ACTIONS(213),
    [sym_true] = ACTIONS(213),
    [sym_false] = ACTIONS(213),
    [sym_null] = ACTIONS(213),
    [sym_undefined] = ACTIONS(215),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1026),
    [anon_sym_readonly] = ACTIONS(1026),
    [anon_sym_get] = ACTIONS(1026),
    [anon_sym_set] = ACTIONS(1026),
    [anon_sym_declare] = ACTIONS(1026),
    [anon_sym_namespace] = ACTIONS(1026),
    [anon_sym_public] = ACTIONS(1026),
    [anon_sym_private] = ACTIONS(1026),
    [anon_sym_protected] = ACTIONS(1026),
    [anon_sym_override] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_any] = ACTIONS(1026),
    [anon_sym_number] = ACTIONS(1026),
    [anon_sym_boolean] = ACTIONS(1026),
    [anon_sym_string] = ACTIONS(1026),
    [anon_sym_symbol] = ACTIONS(1026),
    [anon_sym_component] = ACTIONS(1010),
  },
  [503] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2164),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [504] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1521),
    [sym_expression] = STATE(2382),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4829),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4829),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4827),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1521),
    [sym_subscript_expression] = STATE(1521),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2777),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4829),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1521),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_export] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_typeof] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1062),
    [anon_sym_yield] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(1066),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1070),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_void] = ACTIONS(1060),
    [anon_sym_delete] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1056),
    [anon_sym_readonly] = ACTIONS(1056),
    [anon_sym_get] = ACTIONS(1056),
    [anon_sym_set] = ACTIONS(1056),
    [anon_sym_declare] = ACTIONS(1056),
    [anon_sym_namespace] = ACTIONS(1056),
    [anon_sym_public] = ACTIONS(1056),
    [anon_sym_private] = ACTIONS(1056),
    [anon_sym_protected] = ACTIONS(1056),
    [anon_sym_override] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [anon_sym_any] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_boolean] = ACTIONS(1056),
    [anon_sym_string] = ACTIONS(1056),
    [anon_sym_symbol] = ACTIONS(1056),
    [anon_sym_component] = ACTIONS(120),
  },
  [505] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1507),
    [sym_expression] = STATE(2097),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4666),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4666),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4664),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1507),
    [sym_subscript_expression] = STATE(1507),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2789),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4666),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(379),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_export] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_typeof] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(708),
    [anon_sym_yield] = ACTIONS(710),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(722),
    [anon_sym_DASH] = ACTIONS(722),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(722),
    [anon_sym_delete] = ACTIONS(722),
    [anon_sym_PLUS_PLUS] = ACTIONS(724),
    [anon_sym_DASH_DASH] = ACTIONS(724),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(1034),
    [anon_sym_readonly] = ACTIONS(1034),
    [anon_sym_get] = ACTIONS(1034),
    [anon_sym_set] = ACTIONS(1034),
    [anon_sym_declare] = ACTIONS(1034),
    [anon_sym_namespace] = ACTIONS(1034),
    [anon_sym_public] = ACTIONS(1034),
    [anon_sym_private] = ACTIONS(1034),
    [anon_sym_protected] = ACTIONS(1034),
    [anon_sym_override] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_any] = ACTIONS(1034),
    [anon_sym_number] = ACTIONS(1034),
    [anon_sym_boolean] = ACTIONS(1034),
    [anon_sym_string] = ACTIONS(1034),
    [anon_sym_symbol] = ACTIONS(1034),
    [anon_sym_component] = ACTIONS(120),
  },
  [506] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1087),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [507] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1084),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [508] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1442),
    [sym_expression] = STATE(1612),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4784),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4784),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4785),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1442),
    [sym_subscript_expression] = STATE(1442),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2780),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4784),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1442),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(435),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_typeof] = ACTIONS(83),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(79),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(658),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(888),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(79),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_delete] = ACTIONS(83),
    [anon_sym_PLUS_PLUS] = ACTIONS(670),
    [anon_sym_DASH_DASH] = ACTIONS(670),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(882),
    [anon_sym_readonly] = ACTIONS(882),
    [anon_sym_get] = ACTIONS(882),
    [anon_sym_set] = ACTIONS(882),
    [anon_sym_declare] = ACTIONS(882),
    [anon_sym_namespace] = ACTIONS(882),
    [anon_sym_public] = ACTIONS(882),
    [anon_sym_private] = ACTIONS(882),
    [anon_sym_protected] = ACTIONS(882),
    [anon_sym_override] = ACTIONS(882),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(882),
    [anon_sym_number] = ACTIONS(882),
    [anon_sym_boolean] = ACTIONS(882),
    [anon_sym_string] = ACTIONS(882),
    [anon_sym_symbol] = ACTIONS(882),
    [anon_sym_component] = ACTIONS(120),
  },
  [509] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1083),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [510] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(561),
    [sym_expression] = STATE(1081),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4548),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4548),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4556),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(561),
    [sym_subscript_expression] = STATE(561),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2787),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4548),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(561),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(315),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(808),
    [anon_sym_export] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(810),
    [anon_sym_typeof] = ACTIONS(814),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(826),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(824),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_TILDE] = ACTIONS(826),
    [anon_sym_void] = ACTIONS(814),
    [anon_sym_delete] = ACTIONS(814),
    [anon_sym_PLUS_PLUS] = ACTIONS(828),
    [anon_sym_DASH_DASH] = ACTIONS(828),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(810),
    [anon_sym_readonly] = ACTIONS(810),
    [anon_sym_get] = ACTIONS(810),
    [anon_sym_set] = ACTIONS(810),
    [anon_sym_declare] = ACTIONS(810),
    [anon_sym_namespace] = ACTIONS(810),
    [anon_sym_public] = ACTIONS(810),
    [anon_sym_private] = ACTIONS(810),
    [anon_sym_protected] = ACTIONS(810),
    [anon_sym_override] = ACTIONS(810),
    [anon_sym_module] = ACTIONS(810),
    [anon_sym_any] = ACTIONS(810),
    [anon_sym_number] = ACTIONS(810),
    [anon_sym_boolean] = ACTIONS(810),
    [anon_sym_string] = ACTIONS(810),
    [anon_sym_symbol] = ACTIONS(810),
    [anon_sym_component] = ACTIONS(806),
  },
  [511] = {
    [sym_import] = STATE(1743),
    [sym_parenthesized_expression] = STATE(1508),
    [sym_expression] = STATE(1983),
    [sym_primary_expression] = STATE(1651),
    [sym_yield_expression] = STATE(1744),
    [sym_object] = STATE(1743),
    [sym_object_pattern] = STATE(4814),
    [sym_array] = STATE(1743),
    [sym_array_pattern] = STATE(4814),
    [sym_glimmer_template] = STATE(1744),
    [sym_glimmer_opening_tag] = STATE(3794),
    [sym_nested_identifier] = STATE(3128),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_arrow_function] = STATE(1743),
    [sym__call_signature] = STATE(4812),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1744),
    [sym_await_expression] = STATE(1744),
    [sym_member_expression] = STATE(1508),
    [sym_subscript_expression] = STATE(1508),
    [sym_assignment_expression] = STATE(1744),
    [sym__augmented_assignment_lhs] = STATE(2764),
    [sym_augmented_assignment_expression] = STATE(1744),
    [sym__destructuring_pattern] = STATE(4814),
    [sym_ternary_expression] = STATE(1744),
    [sym_binary_expression] = STATE(1744),
    [sym_unary_expression] = STATE(1744),
    [sym_update_expression] = STATE(1744),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(1508),
    [sym_type_assertion] = STATE(1744),
    [sym_as_expression] = STATE(1744),
    [sym_satisfies_expression] = STATE(1744),
    [sym_type_arguments] = STATE(404),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(1743),
    [sym_component_short_heritage] = STATE(3800),
    [sym_new_component_expression] = STATE(1744),
    [sym_new_tagged_component_expression] = STATE(1744),
    [sym_new_tripple_tagged_component_expression] = STATE(1744),
    [aux_sym_class_repeat1] = STATE(3289),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_export] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(900),
    [anon_sym_typeof] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(34),
    [anon_sym_BANG] = ACTIONS(906),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(908),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(1020),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(57),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_function] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(1050),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(924),
    [anon_sym_DASH] = ACTIONS(924),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_void] = ACTIONS(924),
    [anon_sym_delete] = ACTIONS(924),
    [anon_sym_PLUS_PLUS] = ACTIONS(926),
    [anon_sym_DASH_DASH] = ACTIONS(926),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(620),
    [sym_number] = ACTIONS(622),
    [sym_this] = ACTIONS(98),
    [sym_super] = ACTIONS(98),
    [sym_true] = ACTIONS(98),
    [sym_false] = ACTIONS(98),
    [sym_null] = ACTIONS(98),
    [sym_undefined] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(900),
    [anon_sym_readonly] = ACTIONS(900),
    [anon_sym_get] = ACTIONS(900),
    [anon_sym_set] = ACTIONS(900),
    [anon_sym_declare] = ACTIONS(900),
    [anon_sym_namespace] = ACTIONS(900),
    [anon_sym_public] = ACTIONS(900),
    [anon_sym_private] = ACTIONS(900),
    [anon_sym_protected] = ACTIONS(900),
    [anon_sym_override] = ACTIONS(900),
    [anon_sym_module] = ACTIONS(900),
    [anon_sym_any] = ACTIONS(900),
    [anon_sym_number] = ACTIONS(900),
    [anon_sym_boolean] = ACTIONS(900),
    [anon_sym_string] = ACTIONS(900),
    [anon_sym_symbol] = ACTIONS(900),
    [anon_sym_component] = ACTIONS(120),
  },
  [512] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(543),
    [sym_expression] = STATE(750),
    [sym_primary_expression] = STATE(943),
    [sym_yield_expression] = STATE(1058),
    [sym_object] = STATE(998),
    [sym_object_pattern] = STATE(4806),
    [sym_array] = STATE(998),
    [sym_array_pattern] = STATE(4806),
    [sym_glimmer_template] = STATE(1058),
    [sym_glimmer_opening_tag] = STATE(3758),
    [sym_nested_identifier] = STATE(3180),
    [sym_class] = STATE(998),
    [sym_function] = STATE(998),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(4807),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(1058),
    [sym_await_expression] = STATE(1058),
    [sym_member_expression] = STATE(543),
    [sym_subscript_expression] = STATE(543),
    [sym_assignment_expression] = STATE(1058),
    [sym__augmented_assignment_lhs] = STATE(2781),
    [sym_augmented_assignment_expression] = STATE(1058),
    [sym__destructuring_pattern] = STATE(4806),
    [sym_ternary_expression] = STATE(1058),
    [sym_binary_expression] = STATE(1058),
    [sym_unary_expression] = STATE(1058),
    [sym_update_expression] = STATE(1058),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1469),
    [sym_formal_parameters] = STATE(3665),
    [sym_non_null_expression] = STATE(543),
    [sym_type_assertion] = STATE(1058),
    [sym_as_expression] = STATE(1058),
    [sym_satisfies_expression] = STATE(1058),
    [sym_type_arguments] = STATE(494),
    [sym_type_parameters] = STATE(4212),
    [sym_component] = STATE(998),
    [sym_component_short_heritage] = STATE(3761),
    [sym_new_component_expression] = STATE(1058),
    [sym_new_tagged_component_expression] = STATE(1058),
    [sym_new_tripple_tagged_component_expression] = STATE(1058),
    [aux_sym_class_repeat1] = STATE(3300),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_LBRACE] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(766),
    [anon_sym_import] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(790),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(772),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [anon_sym_LTtemplate_GT] = ACTIONS(50),
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_SLASH] = ACTIONS(778),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(782),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_new] = ACTIONS(786),
    [anon_sym_AMP] = ACTIONS(11),
    [anon_sym_PLUS] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(766),
    [anon_sym_TILDE] = ACTIONS(790),
    [anon_sym_void] = ACTIONS(766),
    [anon_sym_delete] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(792),
    [anon_sym_DASH_DASH] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(798),
    [sym_number] = ACTIONS(800),
    [sym_this] = ACTIONS(802),
    [sym_super] = ACTIONS(802),
    [sym_true] = ACTIONS(802),
    [sym_false] = ACTIONS(802),
    [sym_null] = ACTIONS(802),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_readonly] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_override] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_component] = ACTIONS(806),
  },
  [513] = {
    [sym_identifier] = ACTIONS(1840),
    [anon_sym_export] = ACTIONS(1840),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1842),
    [anon_sym_COMMA] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(1840),
    [anon_sym_typeof] = ACTIONS(1840),
    [anon_sym_import] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1840),
    [anon_sym_LPAREN] = ACTIONS(1842),
    [anon_sym_RPAREN] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1840),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(1840),
    [anon_sym_EQ] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1842),
    [anon_sym_LTtemplate_GT] = ACTIONS(1842),
    [anon_sym_LT] = ACTIONS(1840),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(1840),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(1840),
    [anon_sym_async] = ACTIONS(1840),
    [anon_sym_function] = ACTIONS(1840),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(1840),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1842),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_DASH] = ACTIONS(1840),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(1842),
    [anon_sym_void] = ACTIONS(1840),
    [anon_sym_delete] = ACTIONS(1840),
    [anon_sym_PLUS_PLUS] = ACTIONS(1842),
    [anon_sym_DASH_DASH] = ACTIONS(1842),
    [anon_sym_DQUOTE] = ACTIONS(1842),
    [anon_sym_SQUOTE] = ACTIONS(1842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1842),
    [sym_number] = ACTIONS(1842),
    [sym_this] = ACTIONS(1840),
    [sym_super] = ACTIONS(1840),
    [sym_true] = ACTIONS(1840),
    [sym_false] = ACTIONS(1840),
    [sym_null] = ACTIONS(1840),
    [sym_undefined] = ACTIONS(1840),
    [anon_sym_AT] = ACTIONS(1842),
    [anon_sym_static] = ACTIONS(1840),
    [anon_sym_readonly] = ACTIONS(1840),
    [anon_sym_get] = ACTIONS(1840),
    [anon_sym_set] = ACTIONS(1840),
    [anon_sym_QMARK] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(1840),
    [anon_sym_namespace] = ACTIONS(1840),
    [anon_sym_public] = ACTIONS(1840),
    [anon_sym_private] = ACTIONS(1840),
    [anon_sym_protected] = ACTIONS(1840),
    [anon_sym_override] = ACTIONS(1840),
    [anon_sym_module] = ACTIONS(1840),
    [anon_sym_any] = ACTIONS(1840),
    [anon_sym_number] = ACTIONS(1840),
    [anon_sym_boolean] = ACTIONS(1840),
    [anon_sym_string] = ACTIONS(1840),
    [anon_sym_symbol] = ACTIONS(1840),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_component] = ACTIONS(1840),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [514] = {
    [sym_identifier] = ACTIONS(1840),
    [anon_sym_export] = ACTIONS(1840),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1842),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_type] = ACTIONS(1840),
    [anon_sym_typeof] = ACTIONS(1840),
    [anon_sym_import] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(1840),
    [anon_sym_LPAREN] = ACTIONS(1842),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_await] = ACTIONS(1840),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_yield] = ACTIONS(1840),
    [anon_sym_EQ] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(1842),
    [anon_sym_LTtemplate_GT] = ACTIONS(1842),
    [anon_sym_LT] = ACTIONS(1840),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(1840),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(1840),
    [anon_sym_async] = ACTIONS(1840),
    [anon_sym_function] = ACTIONS(1840),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(1840),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1842),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(1840),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(1840),
    [anon_sym_DASH] = ACTIONS(1840),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(1842),
    [anon_sym_void] = ACTIONS(1840),
    [anon_sym_delete] = ACTIONS(1840),
    [anon_sym_PLUS_PLUS] = ACTIONS(1842),
    [anon_sym_DASH_DASH] = ACTIONS(1842),
    [anon_sym_DQUOTE] = ACTIONS(1842),
    [anon_sym_SQUOTE] = ACTIONS(1842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1842),
    [sym_number] = ACTIONS(1842),
    [sym_this] = ACTIONS(1840),
    [sym_super] = ACTIONS(1840),
    [sym_true] = ACTIONS(1840),
    [sym_false] = ACTIONS(1840),
    [sym_null] = ACTIONS(1840),
    [sym_undefined] = ACTIONS(1840),
    [anon_sym_AT] = ACTIONS(1842),
    [anon_sym_static] = ACTIONS(1840),
    [anon_sym_readonly] = ACTIONS(1840),
    [anon_sym_get] = ACTIONS(1840),
    [anon_sym_set] = ACTIONS(1840),
    [anon_sym_QMARK] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(1840),
    [anon_sym_namespace] = ACTIONS(1840),
    [anon_sym_public] = ACTIONS(1840),
    [anon_sym_private] = ACTIONS(1840),
    [anon_sym_protected] = ACTIONS(1840),
    [anon_sym_override] = ACTIONS(1840),
    [anon_sym_module] = ACTIONS(1840),
    [anon_sym_any] = ACTIONS(1840),
    [anon_sym_number] = ACTIONS(1840),
    [anon_sym_boolean] = ACTIONS(1840),
    [anon_sym_string] = ACTIONS(1840),
    [anon_sym_symbol] = ACTIONS(1840),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_component] = ACTIONS(1840),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [515] = {
    [sym_identifier] = ACTIONS(1844),
    [anon_sym_export] = ACTIONS(1844),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1846),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_type] = ACTIONS(1844),
    [anon_sym_typeof] = ACTIONS(1844),
    [anon_sym_import] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_LPAREN] = ACTIONS(1846),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_await] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_yield] = ACTIONS(1844),
    [anon_sym_EQ] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(1846),
    [anon_sym_LTtemplate_GT] = ACTIONS(1846),
    [anon_sym_LT] = ACTIONS(1844),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(1844),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(1844),
    [anon_sym_async] = ACTIONS(1844),
    [anon_sym_function] = ACTIONS(1844),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(1844),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(1844),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(1844),
    [anon_sym_DASH] = ACTIONS(1844),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(1846),
    [anon_sym_void] = ACTIONS(1844),
    [anon_sym_delete] = ACTIONS(1844),
    [anon_sym_PLUS_PLUS] = ACTIONS(1846),
    [anon_sym_DASH_DASH] = ACTIONS(1846),
    [anon_sym_DQUOTE] = ACTIONS(1846),
    [anon_sym_SQUOTE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1846),
    [sym_number] = ACTIONS(1846),
    [sym_this] = ACTIONS(1844),
    [sym_super] = ACTIONS(1844),
    [sym_true] = ACTIONS(1844),
    [sym_false] = ACTIONS(1844),
    [sym_null] = ACTIONS(1844),
    [sym_undefined] = ACTIONS(1844),
    [anon_sym_AT] = ACTIONS(1846),
    [anon_sym_static] = ACTIONS(1844),
    [anon_sym_readonly] = ACTIONS(1844),
    [anon_sym_get] = ACTIONS(1844),
    [anon_sym_set] = ACTIONS(1844),
    [anon_sym_QMARK] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(1844),
    [anon_sym_namespace] = ACTIONS(1844),
    [anon_sym_public] = ACTIONS(1844),
    [anon_sym_private] = ACTIONS(1844),
    [anon_sym_protected] = ACTIONS(1844),
    [anon_sym_override] = ACTIONS(1844),
    [anon_sym_module] = ACTIONS(1844),
    [anon_sym_any] = ACTIONS(1844),
    [anon_sym_number] = ACTIONS(1844),
    [anon_sym_boolean] = ACTIONS(1844),
    [anon_sym_string] = ACTIONS(1844),
    [anon_sym_symbol] = ACTIONS(1844),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_component] = ACTIONS(1844),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [516] = {
    [sym_identifier] = ACTIONS(1844),
    [anon_sym_export] = ACTIONS(1844),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1846),
    [anon_sym_COMMA] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(1844),
    [anon_sym_typeof] = ACTIONS(1844),
    [anon_sym_import] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(1844),
    [anon_sym_LPAREN] = ACTIONS(1846),
    [anon_sym_RPAREN] = ACTIONS(29),
    [anon_sym_await] = ACTIONS(1844),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(1844),
    [anon_sym_EQ] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1846),
    [anon_sym_LTtemplate_GT] = ACTIONS(1846),
    [anon_sym_LT] = ACTIONS(1844),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(1844),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_class] = ACTIONS(1844),
    [anon_sym_async] = ACTIONS(1844),
    [anon_sym_function] = ACTIONS(1844),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(1844),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(1844),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(1844),
    [anon_sym_DASH] = ACTIONS(1844),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(1846),
    [anon_sym_void] = ACTIONS(1844),
    [anon_sym_delete] = ACTIONS(1844),
    [anon_sym_PLUS_PLUS] = ACTIONS(1846),
    [anon_sym_DASH_DASH] = ACTIONS(1846),
    [anon_sym_DQUOTE] = ACTIONS(1846),
    [anon_sym_SQUOTE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1846),
    [sym_number] = ACTIONS(1846),
    [sym_this] = ACTIONS(1844),
    [sym_super] = ACTIONS(1844),
    [sym_true] = ACTIONS(1844),
    [sym_false] = ACTIONS(1844),
    [sym_null] = ACTIONS(1844),
    [sym_undefined] = ACTIONS(1844),
    [anon_sym_AT] = ACTIONS(1846),
    [anon_sym_static] = ACTIONS(1844),
    [anon_sym_readonly] = ACTIONS(1844),
    [anon_sym_get] = ACTIONS(1844),
    [anon_sym_set] = ACTIONS(1844),
    [anon_sym_QMARK] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(1844),
    [anon_sym_namespace] = ACTIONS(1844),
    [anon_sym_public] = ACTIONS(1844),
    [anon_sym_private] = ACTIONS(1844),
    [anon_sym_protected] = ACTIONS(1844),
    [anon_sym_override] = ACTIONS(1844),
    [anon_sym_module] = ACTIONS(1844),
    [anon_sym_any] = ACTIONS(1844),
    [anon_sym_number] = ACTIONS(1844),
    [anon_sym_boolean] = ACTIONS(1844),
    [anon_sym_string] = ACTIONS(1844),
    [anon_sym_symbol] = ACTIONS(1844),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_component] = ACTIONS(1844),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [517] = {
    [sym_component_identifier] = STATE(3375),
    [sym_new_component_body] = STATE(1721),
    [sym_tagged_type_string] = STATE(1832),
    [sym_tripple_tagged_type_string] = STATE(1831),
    [sym_identifier] = ACTIONS(1848),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1848),
    [anon_sym_LBRACE] = ACTIONS(1850),
    [anon_sym_RBRACE] = ACTIONS(1852),
    [anon_sym_typeof] = ACTIONS(1848),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(1854),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(1856),
    [anon_sym_async] = ACTIONS(1848),
    [anon_sym_EQ_GT] = ACTIONS(1859),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1848),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1848),
    [anon_sym_void] = ACTIONS(1848),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [anon_sym_DQUOTE] = ACTIONS(1852),
    [anon_sym_SQUOTE] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1863),
    [sym_number] = ACTIONS(1852),
    [sym_this] = ACTIONS(1848),
    [sym_true] = ACTIONS(1848),
    [sym_false] = ACTIONS(1848),
    [sym_null] = ACTIONS(1848),
    [sym_undefined] = ACTIONS(1848),
    [anon_sym_static] = ACTIONS(1848),
    [anon_sym_readonly] = ACTIONS(1848),
    [anon_sym_get] = ACTIONS(1848),
    [anon_sym_set] = ACTIONS(1848),
    [anon_sym_QMARK] = ACTIONS(1848),
    [anon_sym_any] = ACTIONS(1848),
    [anon_sym_number] = ACTIONS(1848),
    [anon_sym_boolean] = ACTIONS(1848),
    [anon_sym_string] = ACTIONS(1848),
    [anon_sym_symbol] = ACTIONS(1848),
    [anon_sym_abstract] = ACTIONS(1848),
    [anon_sym_satisfies] = ACTIONS(1848),
    [anon_sym_infer] = ACTIONS(1848),
    [anon_sym_keyof] = ACTIONS(1848),
    [anon_sym_unknown] = ACTIONS(1848),
    [anon_sym_never] = ACTIONS(1848),
    [anon_sym_object] = ACTIONS(1848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_constructor] = ACTIONS(1848),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1868),
    [anon_sym_prop] = ACTIONS(1848),
    [anon_sym_id] = ACTIONS(1848),
    [anon_sym_event] = ACTIONS(1848),
    [anon_sym_fn] = ACTIONS(1848),
    [anon_sym_on] = ACTIONS(1848),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [518] = {
    [sym_component_identifier] = STATE(3339),
    [sym_new_component_body] = STATE(889),
    [sym_tagged_type_string] = STATE(1012),
    [sym_tripple_tagged_type_string] = STATE(1008),
    [sym_identifier] = ACTIONS(1848),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1848),
    [anon_sym_LBRACE] = ACTIONS(1870),
    [anon_sym_RBRACE] = ACTIONS(1852),
    [anon_sym_typeof] = ACTIONS(1848),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(1856),
    [anon_sym_async] = ACTIONS(1848),
    [anon_sym_EQ_GT] = ACTIONS(1859),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1848),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1848),
    [anon_sym_void] = ACTIONS(1848),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [anon_sym_DQUOTE] = ACTIONS(1852),
    [anon_sym_SQUOTE] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1874),
    [sym_number] = ACTIONS(1852),
    [sym_this] = ACTIONS(1848),
    [sym_true] = ACTIONS(1848),
    [sym_false] = ACTIONS(1848),
    [sym_null] = ACTIONS(1848),
    [sym_undefined] = ACTIONS(1848),
    [anon_sym_static] = ACTIONS(1848),
    [anon_sym_readonly] = ACTIONS(1848),
    [anon_sym_get] = ACTIONS(1848),
    [anon_sym_set] = ACTIONS(1848),
    [anon_sym_QMARK] = ACTIONS(1848),
    [anon_sym_any] = ACTIONS(1848),
    [anon_sym_number] = ACTIONS(1848),
    [anon_sym_boolean] = ACTIONS(1848),
    [anon_sym_string] = ACTIONS(1848),
    [anon_sym_symbol] = ACTIONS(1848),
    [anon_sym_abstract] = ACTIONS(1848),
    [anon_sym_satisfies] = ACTIONS(1848),
    [anon_sym_infer] = ACTIONS(1848),
    [anon_sym_keyof] = ACTIONS(1848),
    [anon_sym_unknown] = ACTIONS(1848),
    [anon_sym_never] = ACTIONS(1848),
    [anon_sym_object] = ACTIONS(1848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_constructor] = ACTIONS(1848),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1877),
    [anon_sym_prop] = ACTIONS(1848),
    [anon_sym_id] = ACTIONS(1848),
    [anon_sym_event] = ACTIONS(1848),
    [anon_sym_fn] = ACTIONS(1848),
    [anon_sym_on] = ACTIONS(1848),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [519] = {
    [sym_declaration] = STATE(864),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_class_declaration] = STATE(759),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function_declaration] = STATE(759),
    [sym_decorator] = STATE(1469),
    [sym_function_signature] = STATE(759),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3735),
    [aux_sym_object_repeat1] = STATE(4053),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [aux_sym_class_repeat1] = STATE(3200),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1879),
    [anon_sym_type] = ACTIONS(1881),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_var] = ACTIONS(1885),
    [anon_sym_let] = ACTIONS(1887),
    [anon_sym_const] = ACTIONS(1889),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(1902),
    [anon_sym_async] = ACTIONS(1904),
    [anon_sym_function] = ACTIONS(1906),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(65),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(1912),
    [anon_sym_namespace] = ACTIONS(1914),
    [anon_sym_module] = ACTIONS(1916),
    [anon_sym_abstract] = ACTIONS(1918),
    [anon_sym_satisfies] = ACTIONS(65),
    [anon_sym_global] = ACTIONS(1920),
    [anon_sym_interface] = ACTIONS(1922),
    [anon_sym_enum] = ACTIONS(1924),
    [anon_sym_component] = ACTIONS(15),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [520] = {
    [sym_declaration] = STATE(864),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_class_declaration] = STATE(759),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function_declaration] = STATE(759),
    [sym_decorator] = STATE(1469),
    [sym_function_signature] = STATE(759),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3735),
    [aux_sym_object_repeat1] = STATE(3936),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [aux_sym_class_repeat1] = STATE(3200),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1926),
    [anon_sym_type] = ACTIONS(1881),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_var] = ACTIONS(1885),
    [anon_sym_let] = ACTIONS(1887),
    [anon_sym_const] = ACTIONS(1889),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(1902),
    [anon_sym_async] = ACTIONS(1904),
    [anon_sym_function] = ACTIONS(1906),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(65),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(1912),
    [anon_sym_namespace] = ACTIONS(1914),
    [anon_sym_module] = ACTIONS(1916),
    [anon_sym_abstract] = ACTIONS(1918),
    [anon_sym_satisfies] = ACTIONS(65),
    [anon_sym_global] = ACTIONS(1920),
    [anon_sym_interface] = ACTIONS(1922),
    [anon_sym_enum] = ACTIONS(1924),
    [anon_sym_component] = ACTIONS(15),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [521] = {
    [sym_declaration] = STATE(864),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_class_declaration] = STATE(759),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function_declaration] = STATE(759),
    [sym_decorator] = STATE(1469),
    [sym_function_signature] = STATE(759),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3735),
    [aux_sym_object_repeat1] = STATE(3936),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [aux_sym_class_repeat1] = STATE(3200),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1928),
    [anon_sym_type] = ACTIONS(1881),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_var] = ACTIONS(1885),
    [anon_sym_let] = ACTIONS(1887),
    [anon_sym_const] = ACTIONS(1889),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(1902),
    [anon_sym_async] = ACTIONS(1904),
    [anon_sym_function] = ACTIONS(1906),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(65),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(1912),
    [anon_sym_namespace] = ACTIONS(1914),
    [anon_sym_module] = ACTIONS(1916),
    [anon_sym_abstract] = ACTIONS(1918),
    [anon_sym_satisfies] = ACTIONS(65),
    [anon_sym_global] = ACTIONS(1920),
    [anon_sym_interface] = ACTIONS(1922),
    [anon_sym_enum] = ACTIONS(1924),
    [anon_sym_component] = ACTIONS(15),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [522] = {
    [sym_declaration] = STATE(864),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_class_declaration] = STATE(759),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function_declaration] = STATE(759),
    [sym_decorator] = STATE(1469),
    [sym_function_signature] = STATE(759),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3735),
    [aux_sym_object_repeat1] = STATE(3990),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [aux_sym_class_repeat1] = STATE(3200),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1930),
    [anon_sym_type] = ACTIONS(1881),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_var] = ACTIONS(1885),
    [anon_sym_let] = ACTIONS(1887),
    [anon_sym_const] = ACTIONS(1889),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(1902),
    [anon_sym_async] = ACTIONS(1904),
    [anon_sym_function] = ACTIONS(1906),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(65),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(1912),
    [anon_sym_namespace] = ACTIONS(1914),
    [anon_sym_module] = ACTIONS(1916),
    [anon_sym_abstract] = ACTIONS(1918),
    [anon_sym_satisfies] = ACTIONS(65),
    [anon_sym_global] = ACTIONS(1920),
    [anon_sym_interface] = ACTIONS(1922),
    [anon_sym_enum] = ACTIONS(1924),
    [anon_sym_component] = ACTIONS(15),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [523] = {
    [sym_component_identifier] = STATE(3339),
    [sym_new_component_body] = STATE(889),
    [sym_tagged_type_string] = STATE(1012),
    [sym_tripple_tagged_type_string] = STATE(1008),
    [sym_identifier] = ACTIONS(1848),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1848),
    [anon_sym_LBRACE] = ACTIONS(1870),
    [anon_sym_RBRACE] = ACTIONS(1852),
    [anon_sym_typeof] = ACTIONS(1848),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(1932),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(1856),
    [anon_sym_async] = ACTIONS(1848),
    [anon_sym_EQ_GT] = ACTIONS(1934),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1848),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1848),
    [anon_sym_void] = ACTIONS(1848),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [anon_sym_DQUOTE] = ACTIONS(1852),
    [anon_sym_SQUOTE] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1874),
    [sym_number] = ACTIONS(1852),
    [sym_this] = ACTIONS(1848),
    [sym_true] = ACTIONS(1848),
    [sym_false] = ACTIONS(1848),
    [sym_null] = ACTIONS(1848),
    [sym_undefined] = ACTIONS(1848),
    [anon_sym_static] = ACTIONS(1848),
    [anon_sym_readonly] = ACTIONS(1848),
    [anon_sym_QMARK] = ACTIONS(1848),
    [anon_sym_any] = ACTIONS(1848),
    [anon_sym_number] = ACTIONS(1848),
    [anon_sym_boolean] = ACTIONS(1848),
    [anon_sym_string] = ACTIONS(1848),
    [anon_sym_symbol] = ACTIONS(1848),
    [anon_sym_abstract] = ACTIONS(1848),
    [anon_sym_satisfies] = ACTIONS(1848),
    [anon_sym_infer] = ACTIONS(1848),
    [anon_sym_keyof] = ACTIONS(1848),
    [anon_sym_unknown] = ACTIONS(1848),
    [anon_sym_never] = ACTIONS(1848),
    [anon_sym_object] = ACTIONS(1848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1877),
    [anon_sym_prop] = ACTIONS(1848),
    [anon_sym_id] = ACTIONS(1848),
    [anon_sym_event] = ACTIONS(1848),
    [anon_sym_fn] = ACTIONS(1848),
    [anon_sym_on] = ACTIONS(1848),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [524] = {
    [sym_component_identifier] = STATE(3375),
    [sym_new_component_body] = STATE(1721),
    [sym_tagged_type_string] = STATE(1832),
    [sym_tripple_tagged_type_string] = STATE(1831),
    [sym_identifier] = ACTIONS(1848),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1848),
    [anon_sym_LBRACE] = ACTIONS(1850),
    [anon_sym_RBRACE] = ACTIONS(1852),
    [anon_sym_typeof] = ACTIONS(1848),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(1854),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(1856),
    [anon_sym_async] = ACTIONS(1848),
    [anon_sym_EQ_GT] = ACTIONS(1934),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1848),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1848),
    [anon_sym_void] = ACTIONS(1848),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [anon_sym_DQUOTE] = ACTIONS(1852),
    [anon_sym_SQUOTE] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1863),
    [sym_number] = ACTIONS(1852),
    [sym_this] = ACTIONS(1848),
    [sym_true] = ACTIONS(1848),
    [sym_false] = ACTIONS(1848),
    [sym_null] = ACTIONS(1848),
    [sym_undefined] = ACTIONS(1848),
    [anon_sym_static] = ACTIONS(1848),
    [anon_sym_readonly] = ACTIONS(1848),
    [anon_sym_QMARK] = ACTIONS(1848),
    [anon_sym_any] = ACTIONS(1848),
    [anon_sym_number] = ACTIONS(1848),
    [anon_sym_boolean] = ACTIONS(1848),
    [anon_sym_string] = ACTIONS(1848),
    [anon_sym_symbol] = ACTIONS(1848),
    [anon_sym_abstract] = ACTIONS(1848),
    [anon_sym_satisfies] = ACTIONS(1848),
    [anon_sym_infer] = ACTIONS(1848),
    [anon_sym_keyof] = ACTIONS(1848),
    [anon_sym_unknown] = ACTIONS(1848),
    [anon_sym_never] = ACTIONS(1848),
    [anon_sym_object] = ACTIONS(1848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1868),
    [anon_sym_prop] = ACTIONS(1848),
    [anon_sym_id] = ACTIONS(1848),
    [anon_sym_event] = ACTIONS(1848),
    [anon_sym_fn] = ACTIONS(1848),
    [anon_sym_on] = ACTIONS(1848),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [525] = {
    [sym_declaration] = STATE(864),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_class_declaration] = STATE(759),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function_declaration] = STATE(759),
    [sym_decorator] = STATE(1469),
    [sym_function_signature] = STATE(759),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3735),
    [aux_sym_class_repeat1] = STATE(3200),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_type] = ACTIONS(1881),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_var] = ACTIONS(1885),
    [anon_sym_let] = ACTIONS(1887),
    [anon_sym_const] = ACTIONS(1889),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(65),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1936),
    [anon_sym_EQ] = ACTIONS(1938),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(25),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(1902),
    [anon_sym_async] = ACTIONS(1904),
    [anon_sym_function] = ACTIONS(1906),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(65),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1912),
    [anon_sym_namespace] = ACTIONS(1914),
    [anon_sym_module] = ACTIONS(1916),
    [anon_sym_abstract] = ACTIONS(1918),
    [anon_sym_satisfies] = ACTIONS(65),
    [anon_sym_global] = ACTIONS(1920),
    [anon_sym_interface] = ACTIONS(1922),
    [anon_sym_enum] = ACTIONS(1924),
    [anon_sym_component] = ACTIONS(15),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [526] = {
    [sym_declaration] = STATE(864),
    [sym_variable_declaration] = STATE(759),
    [sym_lexical_declaration] = STATE(759),
    [sym_class_declaration] = STATE(759),
    [sym_function_declaration] = STATE(759),
    [sym_generator_function_declaration] = STATE(759),
    [sym_decorator] = STATE(1469),
    [sym_function_signature] = STATE(759),
    [sym_ambient_declaration] = STATE(759),
    [sym_abstract_class_declaration] = STATE(759),
    [sym_module] = STATE(759),
    [sym_internal_module] = STATE(752),
    [sym_import_alias] = STATE(759),
    [sym_interface_declaration] = STATE(759),
    [sym_enum_declaration] = STATE(759),
    [sym_type_alias_declaration] = STATE(759),
    [sym_component_declaration] = STATE(759),
    [sym_component_short_heritage] = STATE(3735),
    [aux_sym_class_repeat1] = STATE(3200),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_type] = ACTIONS(1881),
    [anon_sym_import] = ACTIONS(1883),
    [anon_sym_var] = ACTIONS(1885),
    [anon_sym_let] = ACTIONS(1887),
    [anon_sym_const] = ACTIONS(1889),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(65),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1940),
    [anon_sym_EQ] = ACTIONS(1938),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(25),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(1902),
    [anon_sym_async] = ACTIONS(1942),
    [anon_sym_function] = ACTIONS(1944),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(65),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(1946),
    [anon_sym_namespace] = ACTIONS(1948),
    [anon_sym_module] = ACTIONS(1950),
    [anon_sym_abstract] = ACTIONS(1918),
    [anon_sym_satisfies] = ACTIONS(65),
    [anon_sym_global] = ACTIONS(1952),
    [anon_sym_interface] = ACTIONS(1954),
    [anon_sym_enum] = ACTIONS(1924),
    [anon_sym_component] = ACTIONS(15),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [527] = {
    [sym_identifier] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_RBRACE] = ACTIONS(65),
    [anon_sym_typeof] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(65),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(25),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(25),
    [anon_sym_EQ_GT] = ACTIONS(1326),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(25),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_void] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(65),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(65),
    [sym_number] = ACTIONS(65),
    [sym_this] = ACTIONS(25),
    [sym_true] = ACTIONS(25),
    [sym_false] = ACTIONS(25),
    [sym_null] = ACTIONS(25),
    [sym_undefined] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_readonly] = ACTIONS(25),
    [anon_sym_get] = ACTIONS(25),
    [anon_sym_set] = ACTIONS(25),
    [anon_sym_QMARK] = ACTIONS(25),
    [anon_sym_any] = ACTIONS(25),
    [anon_sym_number] = ACTIONS(25),
    [anon_sym_boolean] = ACTIONS(25),
    [anon_sym_string] = ACTIONS(25),
    [anon_sym_symbol] = ACTIONS(25),
    [anon_sym_abstract] = ACTIONS(25),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_infer] = ACTIONS(25),
    [anon_sym_keyof] = ACTIONS(25),
    [anon_sym_unknown] = ACTIONS(25),
    [anon_sym_never] = ACTIONS(25),
    [anon_sym_object] = ACTIONS(25),
    [anon_sym_LBRACE_PIPE] = ACTIONS(65),
    [anon_sym_constructor] = ACTIONS(25),
    [anon_sym_prop] = ACTIONS(25),
    [anon_sym_id] = ACTIONS(25),
    [anon_sym_event] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_on] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [528] = {
    [sym_identifier] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_RBRACE] = ACTIONS(65),
    [anon_sym_typeof] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(65),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(25),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(25),
    [anon_sym_EQ_GT] = ACTIONS(1326),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(25),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_void] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(65),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(65),
    [sym_number] = ACTIONS(65),
    [sym_this] = ACTIONS(25),
    [sym_true] = ACTIONS(25),
    [sym_false] = ACTIONS(25),
    [sym_null] = ACTIONS(25),
    [sym_undefined] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_readonly] = ACTIONS(25),
    [anon_sym_get] = ACTIONS(25),
    [anon_sym_set] = ACTIONS(25),
    [anon_sym_QMARK] = ACTIONS(25),
    [anon_sym_any] = ACTIONS(25),
    [anon_sym_number] = ACTIONS(25),
    [anon_sym_boolean] = ACTIONS(25),
    [anon_sym_string] = ACTIONS(25),
    [anon_sym_symbol] = ACTIONS(25),
    [anon_sym_abstract] = ACTIONS(25),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_infer] = ACTIONS(25),
    [anon_sym_keyof] = ACTIONS(25),
    [anon_sym_unknown] = ACTIONS(25),
    [anon_sym_never] = ACTIONS(25),
    [anon_sym_object] = ACTIONS(25),
    [anon_sym_LBRACE_PIPE] = ACTIONS(65),
    [anon_sym_constructor] = ACTIONS(25),
    [anon_sym_prop] = ACTIONS(25),
    [anon_sym_id] = ACTIONS(25),
    [anon_sym_event] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_on] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [529] = {
    [sym__call_signature] = STATE(4874),
    [sym_string] = STATE(3488),
    [sym_formal_parameters] = STATE(3665),
    [sym__property_name] = STATE(3488),
    [sym_computed_property_name] = STATE(3488),
    [sym_type_parameters] = STATE(4212),
    [aux_sym_object_repeat1] = STATE(3936),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(1956),
    [anon_sym_export] = ACTIONS(1958),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1928),
    [anon_sym_type] = ACTIONS(1958),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1963),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1970),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(1958),
    [anon_sym_function] = ACTIONS(1974),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1976),
    [sym_private_property_identifier] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(1958),
    [anon_sym_readonly] = ACTIONS(1958),
    [anon_sym_get] = ACTIONS(1978),
    [anon_sym_set] = ACTIONS(1978),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(1958),
    [anon_sym_namespace] = ACTIONS(1958),
    [anon_sym_public] = ACTIONS(1958),
    [anon_sym_private] = ACTIONS(1958),
    [anon_sym_protected] = ACTIONS(1958),
    [anon_sym_override] = ACTIONS(1958),
    [anon_sym_module] = ACTIONS(1958),
    [anon_sym_any] = ACTIONS(1958),
    [anon_sym_number] = ACTIONS(1958),
    [anon_sym_boolean] = ACTIONS(1958),
    [anon_sym_string] = ACTIONS(1958),
    [anon_sym_symbol] = ACTIONS(1958),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [530] = {
    [sym_identifier] = ACTIONS(1980),
    [anon_sym_STAR] = ACTIONS(1980),
    [anon_sym_as] = ACTIONS(1980),
    [anon_sym_LBRACE] = ACTIONS(1980),
    [anon_sym_RBRACE] = ACTIONS(1982),
    [anon_sym_typeof] = ACTIONS(1980),
    [anon_sym_BANG] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_in] = ACTIONS(1980),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym_EQ] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1982),
    [anon_sym_LT] = ACTIONS(1980),
    [anon_sym_GT] = ACTIONS(1980),
    [anon_sym_SLASH] = ACTIONS(1980),
    [anon_sym_DOT] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_QMARK_DOT] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(1980),
    [anon_sym_PLUS_EQ] = ACTIONS(1982),
    [anon_sym_DASH_EQ] = ACTIONS(1982),
    [anon_sym_STAR_EQ] = ACTIONS(1982),
    [anon_sym_SLASH_EQ] = ACTIONS(1982),
    [anon_sym_PERCENT_EQ] = ACTIONS(1982),
    [anon_sym_CARET_EQ] = ACTIONS(1982),
    [anon_sym_AMP_EQ] = ACTIONS(1982),
    [anon_sym_PIPE_EQ] = ACTIONS(1982),
    [anon_sym_GT_GT_EQ] = ACTIONS(1982),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1982),
    [anon_sym_LT_LT_EQ] = ACTIONS(1982),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1982),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1982),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1982),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1982),
    [anon_sym_AMP_AMP] = ACTIONS(1980),
    [anon_sym_PIPE_PIPE] = ACTIONS(1980),
    [anon_sym_GT_GT] = ACTIONS(1980),
    [anon_sym_GT_GT_GT] = ACTIONS(1980),
    [anon_sym_LT_LT] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1980),
    [anon_sym_CARET] = ACTIONS(1980),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_PERCENT] = ACTIONS(1980),
    [anon_sym_STAR_STAR] = ACTIONS(1980),
    [anon_sym_LT_EQ] = ACTIONS(1982),
    [anon_sym_EQ_EQ] = ACTIONS(1980),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1982),
    [anon_sym_BANG_EQ] = ACTIONS(1980),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1982),
    [anon_sym_GT_EQ] = ACTIONS(1982),
    [anon_sym_QMARK_QMARK] = ACTIONS(1980),
    [anon_sym_instanceof] = ACTIONS(1980),
    [anon_sym_void] = ACTIONS(1980),
    [anon_sym_PLUS_PLUS] = ACTIONS(1982),
    [anon_sym_DASH_DASH] = ACTIONS(1982),
    [anon_sym_DQUOTE] = ACTIONS(1982),
    [anon_sym_SQUOTE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1982),
    [sym_number] = ACTIONS(1982),
    [sym_this] = ACTIONS(1980),
    [sym_true] = ACTIONS(1980),
    [sym_false] = ACTIONS(1980),
    [sym_null] = ACTIONS(1980),
    [sym_undefined] = ACTIONS(1980),
    [anon_sym_static] = ACTIONS(1980),
    [anon_sym_readonly] = ACTIONS(1980),
    [anon_sym_get] = ACTIONS(1980),
    [anon_sym_set] = ACTIONS(1980),
    [anon_sym_QMARK] = ACTIONS(1980),
    [anon_sym_any] = ACTIONS(1980),
    [anon_sym_number] = ACTIONS(1980),
    [anon_sym_boolean] = ACTIONS(1980),
    [anon_sym_string] = ACTIONS(1980),
    [anon_sym_symbol] = ACTIONS(1980),
    [anon_sym_abstract] = ACTIONS(1980),
    [anon_sym_satisfies] = ACTIONS(1980),
    [anon_sym_infer] = ACTIONS(1980),
    [anon_sym_keyof] = ACTIONS(1980),
    [anon_sym_unknown] = ACTIONS(1980),
    [anon_sym_never] = ACTIONS(1980),
    [anon_sym_object] = ACTIONS(1980),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1982),
    [anon_sym_constructor] = ACTIONS(1980),
    [anon_sym_prop] = ACTIONS(1980),
    [anon_sym_id] = ACTIONS(1980),
    [anon_sym_event] = ACTIONS(1980),
    [anon_sym_fn] = ACTIONS(1980),
    [anon_sym_on] = ACTIONS(1980),
    [sym__ternary_qmark] = ACTIONS(1982),
  },
  [531] = {
    [sym__call_signature] = STATE(4874),
    [sym_string] = STATE(3488),
    [sym_formal_parameters] = STATE(3665),
    [sym__property_name] = STATE(3488),
    [sym_computed_property_name] = STATE(3488),
    [sym_type_parameters] = STATE(4212),
    [aux_sym_object_repeat1] = STATE(3936),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(1956),
    [anon_sym_export] = ACTIONS(1958),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1926),
    [anon_sym_type] = ACTIONS(1958),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1963),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1970),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(1958),
    [anon_sym_function] = ACTIONS(1974),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1976),
    [sym_private_property_identifier] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(1958),
    [anon_sym_readonly] = ACTIONS(1958),
    [anon_sym_get] = ACTIONS(1978),
    [anon_sym_set] = ACTIONS(1978),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(1958),
    [anon_sym_namespace] = ACTIONS(1958),
    [anon_sym_public] = ACTIONS(1958),
    [anon_sym_private] = ACTIONS(1958),
    [anon_sym_protected] = ACTIONS(1958),
    [anon_sym_override] = ACTIONS(1958),
    [anon_sym_module] = ACTIONS(1958),
    [anon_sym_any] = ACTIONS(1958),
    [anon_sym_number] = ACTIONS(1958),
    [anon_sym_boolean] = ACTIONS(1958),
    [anon_sym_string] = ACTIONS(1958),
    [anon_sym_symbol] = ACTIONS(1958),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [532] = {
    [sym_identifier] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1984),
    [anon_sym_as] = ACTIONS(1984),
    [anon_sym_LBRACE] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1986),
    [anon_sym_typeof] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_SEMI] = ACTIONS(1986),
    [anon_sym_EQ] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_QMARK_DOT] = ACTIONS(1986),
    [anon_sym_new] = ACTIONS(1984),
    [anon_sym_PLUS_EQ] = ACTIONS(1986),
    [anon_sym_DASH_EQ] = ACTIONS(1986),
    [anon_sym_STAR_EQ] = ACTIONS(1986),
    [anon_sym_SLASH_EQ] = ACTIONS(1986),
    [anon_sym_PERCENT_EQ] = ACTIONS(1986),
    [anon_sym_CARET_EQ] = ACTIONS(1986),
    [anon_sym_AMP_EQ] = ACTIONS(1986),
    [anon_sym_PIPE_EQ] = ACTIONS(1986),
    [anon_sym_GT_GT_EQ] = ACTIONS(1986),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1986),
    [anon_sym_LT_LT_EQ] = ACTIONS(1986),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1986),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1986),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1986),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1986),
    [anon_sym_AMP_AMP] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_GT_GT_GT] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(1984),
    [anon_sym_LT_EQ] = ACTIONS(1986),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1986),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1986),
    [anon_sym_GT_EQ] = ACTIONS(1986),
    [anon_sym_QMARK_QMARK] = ACTIONS(1984),
    [anon_sym_instanceof] = ACTIONS(1984),
    [anon_sym_void] = ACTIONS(1984),
    [anon_sym_PLUS_PLUS] = ACTIONS(1986),
    [anon_sym_DASH_DASH] = ACTIONS(1986),
    [anon_sym_DQUOTE] = ACTIONS(1986),
    [anon_sym_SQUOTE] = ACTIONS(1986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1986),
    [sym_number] = ACTIONS(1986),
    [sym_this] = ACTIONS(1984),
    [sym_true] = ACTIONS(1984),
    [sym_false] = ACTIONS(1984),
    [sym_null] = ACTIONS(1984),
    [sym_undefined] = ACTIONS(1984),
    [anon_sym_static] = ACTIONS(1984),
    [anon_sym_readonly] = ACTIONS(1984),
    [anon_sym_get] = ACTIONS(1984),
    [anon_sym_set] = ACTIONS(1984),
    [anon_sym_QMARK] = ACTIONS(1984),
    [anon_sym_any] = ACTIONS(1984),
    [anon_sym_number] = ACTIONS(1984),
    [anon_sym_boolean] = ACTIONS(1984),
    [anon_sym_string] = ACTIONS(1984),
    [anon_sym_symbol] = ACTIONS(1984),
    [anon_sym_abstract] = ACTIONS(1984),
    [anon_sym_satisfies] = ACTIONS(1984),
    [anon_sym_infer] = ACTIONS(1984),
    [anon_sym_keyof] = ACTIONS(1984),
    [anon_sym_unknown] = ACTIONS(1984),
    [anon_sym_never] = ACTIONS(1984),
    [anon_sym_object] = ACTIONS(1984),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1986),
    [anon_sym_constructor] = ACTIONS(1984),
    [anon_sym_prop] = ACTIONS(1984),
    [anon_sym_id] = ACTIONS(1984),
    [anon_sym_event] = ACTIONS(1984),
    [anon_sym_fn] = ACTIONS(1984),
    [anon_sym_on] = ACTIONS(1984),
    [sym__ternary_qmark] = ACTIONS(1986),
  },
  [533] = {
    [sym__call_signature] = STATE(4874),
    [sym_string] = STATE(3488),
    [sym_formal_parameters] = STATE(3665),
    [sym__property_name] = STATE(3488),
    [sym_computed_property_name] = STATE(3488),
    [sym_type_parameters] = STATE(4212),
    [aux_sym_object_repeat1] = STATE(3990),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(1956),
    [anon_sym_export] = ACTIONS(1958),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1930),
    [anon_sym_type] = ACTIONS(1958),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1963),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1970),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(1958),
    [anon_sym_function] = ACTIONS(1974),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1976),
    [sym_private_property_identifier] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(1958),
    [anon_sym_readonly] = ACTIONS(1958),
    [anon_sym_get] = ACTIONS(1978),
    [anon_sym_set] = ACTIONS(1978),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(1958),
    [anon_sym_namespace] = ACTIONS(1958),
    [anon_sym_public] = ACTIONS(1958),
    [anon_sym_private] = ACTIONS(1958),
    [anon_sym_protected] = ACTIONS(1958),
    [anon_sym_override] = ACTIONS(1958),
    [anon_sym_module] = ACTIONS(1958),
    [anon_sym_any] = ACTIONS(1958),
    [anon_sym_number] = ACTIONS(1958),
    [anon_sym_boolean] = ACTIONS(1958),
    [anon_sym_string] = ACTIONS(1958),
    [anon_sym_symbol] = ACTIONS(1958),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [534] = {
    [sym_identifier] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(1988),
    [anon_sym_as] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1988),
    [anon_sym_RBRACE] = ACTIONS(1990),
    [anon_sym_typeof] = ACTIONS(1988),
    [anon_sym_BANG] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1990),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1990),
    [anon_sym_EQ] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1990),
    [anon_sym_LT] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1988),
    [anon_sym_SLASH] = ACTIONS(1988),
    [anon_sym_DOT] = ACTIONS(1988),
    [anon_sym_async] = ACTIONS(1988),
    [anon_sym_QMARK_DOT] = ACTIONS(1990),
    [anon_sym_new] = ACTIONS(1988),
    [anon_sym_PLUS_EQ] = ACTIONS(1990),
    [anon_sym_DASH_EQ] = ACTIONS(1990),
    [anon_sym_STAR_EQ] = ACTIONS(1990),
    [anon_sym_SLASH_EQ] = ACTIONS(1990),
    [anon_sym_PERCENT_EQ] = ACTIONS(1990),
    [anon_sym_CARET_EQ] = ACTIONS(1990),
    [anon_sym_AMP_EQ] = ACTIONS(1990),
    [anon_sym_PIPE_EQ] = ACTIONS(1990),
    [anon_sym_GT_GT_EQ] = ACTIONS(1990),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1990),
    [anon_sym_LT_LT_EQ] = ACTIONS(1990),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1990),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1990),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1990),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1990),
    [anon_sym_AMP_AMP] = ACTIONS(1988),
    [anon_sym_PIPE_PIPE] = ACTIONS(1988),
    [anon_sym_GT_GT] = ACTIONS(1988),
    [anon_sym_GT_GT_GT] = ACTIONS(1988),
    [anon_sym_LT_LT] = ACTIONS(1988),
    [anon_sym_AMP] = ACTIONS(1988),
    [anon_sym_CARET] = ACTIONS(1988),
    [anon_sym_PIPE] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_DASH] = ACTIONS(1988),
    [anon_sym_PERCENT] = ACTIONS(1988),
    [anon_sym_STAR_STAR] = ACTIONS(1988),
    [anon_sym_LT_EQ] = ACTIONS(1990),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1990),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1990),
    [anon_sym_GT_EQ] = ACTIONS(1990),
    [anon_sym_QMARK_QMARK] = ACTIONS(1988),
    [anon_sym_instanceof] = ACTIONS(1988),
    [anon_sym_void] = ACTIONS(1988),
    [anon_sym_PLUS_PLUS] = ACTIONS(1990),
    [anon_sym_DASH_DASH] = ACTIONS(1990),
    [anon_sym_DQUOTE] = ACTIONS(1990),
    [anon_sym_SQUOTE] = ACTIONS(1990),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1990),
    [sym_number] = ACTIONS(1990),
    [sym_this] = ACTIONS(1988),
    [sym_true] = ACTIONS(1988),
    [sym_false] = ACTIONS(1988),
    [sym_null] = ACTIONS(1988),
    [sym_undefined] = ACTIONS(1988),
    [anon_sym_static] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_get] = ACTIONS(1988),
    [anon_sym_set] = ACTIONS(1988),
    [anon_sym_QMARK] = ACTIONS(1988),
    [anon_sym_any] = ACTIONS(1988),
    [anon_sym_number] = ACTIONS(1988),
    [anon_sym_boolean] = ACTIONS(1988),
    [anon_sym_string] = ACTIONS(1988),
    [anon_sym_symbol] = ACTIONS(1988),
    [anon_sym_abstract] = ACTIONS(1988),
    [anon_sym_satisfies] = ACTIONS(1988),
    [anon_sym_infer] = ACTIONS(1988),
    [anon_sym_keyof] = ACTIONS(1988),
    [anon_sym_unknown] = ACTIONS(1988),
    [anon_sym_never] = ACTIONS(1988),
    [anon_sym_object] = ACTIONS(1988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1990),
    [anon_sym_constructor] = ACTIONS(1988),
    [anon_sym_prop] = ACTIONS(1988),
    [anon_sym_id] = ACTIONS(1988),
    [anon_sym_event] = ACTIONS(1988),
    [anon_sym_fn] = ACTIONS(1988),
    [anon_sym_on] = ACTIONS(1988),
    [sym__ternary_qmark] = ACTIONS(1990),
  },
  [535] = {
    [sym__call_signature] = STATE(4874),
    [sym_string] = STATE(3488),
    [sym_formal_parameters] = STATE(3665),
    [sym__property_name] = STATE(3488),
    [sym_computed_property_name] = STATE(3488),
    [sym_type_parameters] = STATE(4212),
    [aux_sym_object_repeat1] = STATE(4053),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(1956),
    [anon_sym_export] = ACTIONS(1958),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1879),
    [anon_sym_type] = ACTIONS(1958),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1963),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1970),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(1958),
    [anon_sym_function] = ACTIONS(1974),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1976),
    [sym_private_property_identifier] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(1958),
    [anon_sym_readonly] = ACTIONS(1958),
    [anon_sym_get] = ACTIONS(1978),
    [anon_sym_set] = ACTIONS(1978),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(1958),
    [anon_sym_namespace] = ACTIONS(1958),
    [anon_sym_public] = ACTIONS(1958),
    [anon_sym_private] = ACTIONS(1958),
    [anon_sym_protected] = ACTIONS(1958),
    [anon_sym_override] = ACTIONS(1958),
    [anon_sym_module] = ACTIONS(1958),
    [anon_sym_any] = ACTIONS(1958),
    [anon_sym_number] = ACTIONS(1958),
    [anon_sym_boolean] = ACTIONS(1958),
    [anon_sym_string] = ACTIONS(1958),
    [anon_sym_symbol] = ACTIONS(1958),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [536] = {
    [sym_identifier] = ACTIONS(1992),
    [anon_sym_STAR] = ACTIONS(1992),
    [anon_sym_as] = ACTIONS(1992),
    [anon_sym_LBRACE] = ACTIONS(1992),
    [anon_sym_RBRACE] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1992),
    [anon_sym_BANG] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1994),
    [anon_sym_in] = ACTIONS(1992),
    [anon_sym_SEMI] = ACTIONS(1994),
    [anon_sym_EQ] = ACTIONS(1992),
    [anon_sym_LBRACK] = ACTIONS(1994),
    [anon_sym_LT] = ACTIONS(1992),
    [anon_sym_GT] = ACTIONS(1992),
    [anon_sym_SLASH] = ACTIONS(1992),
    [anon_sym_DOT] = ACTIONS(1992),
    [anon_sym_async] = ACTIONS(1992),
    [anon_sym_QMARK_DOT] = ACTIONS(1994),
    [anon_sym_new] = ACTIONS(1992),
    [anon_sym_PLUS_EQ] = ACTIONS(1994),
    [anon_sym_DASH_EQ] = ACTIONS(1994),
    [anon_sym_STAR_EQ] = ACTIONS(1994),
    [anon_sym_SLASH_EQ] = ACTIONS(1994),
    [anon_sym_PERCENT_EQ] = ACTIONS(1994),
    [anon_sym_CARET_EQ] = ACTIONS(1994),
    [anon_sym_AMP_EQ] = ACTIONS(1994),
    [anon_sym_PIPE_EQ] = ACTIONS(1994),
    [anon_sym_GT_GT_EQ] = ACTIONS(1994),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1994),
    [anon_sym_LT_LT_EQ] = ACTIONS(1994),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1994),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1994),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1994),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1994),
    [anon_sym_AMP_AMP] = ACTIONS(1992),
    [anon_sym_PIPE_PIPE] = ACTIONS(1992),
    [anon_sym_GT_GT] = ACTIONS(1992),
    [anon_sym_GT_GT_GT] = ACTIONS(1992),
    [anon_sym_LT_LT] = ACTIONS(1992),
    [anon_sym_AMP] = ACTIONS(1992),
    [anon_sym_CARET] = ACTIONS(1992),
    [anon_sym_PIPE] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_PERCENT] = ACTIONS(1992),
    [anon_sym_STAR_STAR] = ACTIONS(1992),
    [anon_sym_LT_EQ] = ACTIONS(1994),
    [anon_sym_EQ_EQ] = ACTIONS(1992),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1994),
    [anon_sym_BANG_EQ] = ACTIONS(1992),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1994),
    [anon_sym_GT_EQ] = ACTIONS(1994),
    [anon_sym_QMARK_QMARK] = ACTIONS(1992),
    [anon_sym_instanceof] = ACTIONS(1992),
    [anon_sym_void] = ACTIONS(1992),
    [anon_sym_PLUS_PLUS] = ACTIONS(1994),
    [anon_sym_DASH_DASH] = ACTIONS(1994),
    [anon_sym_DQUOTE] = ACTIONS(1994),
    [anon_sym_SQUOTE] = ACTIONS(1994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1994),
    [sym_number] = ACTIONS(1994),
    [sym_this] = ACTIONS(1992),
    [sym_true] = ACTIONS(1992),
    [sym_false] = ACTIONS(1992),
    [sym_null] = ACTIONS(1992),
    [sym_undefined] = ACTIONS(1992),
    [anon_sym_static] = ACTIONS(1992),
    [anon_sym_readonly] = ACTIONS(1992),
    [anon_sym_get] = ACTIONS(1992),
    [anon_sym_set] = ACTIONS(1992),
    [anon_sym_QMARK] = ACTIONS(1992),
    [anon_sym_any] = ACTIONS(1992),
    [anon_sym_number] = ACTIONS(1992),
    [anon_sym_boolean] = ACTIONS(1992),
    [anon_sym_string] = ACTIONS(1992),
    [anon_sym_symbol] = ACTIONS(1992),
    [anon_sym_abstract] = ACTIONS(1992),
    [anon_sym_satisfies] = ACTIONS(1992),
    [anon_sym_infer] = ACTIONS(1992),
    [anon_sym_keyof] = ACTIONS(1992),
    [anon_sym_unknown] = ACTIONS(1992),
    [anon_sym_never] = ACTIONS(1992),
    [anon_sym_object] = ACTIONS(1992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1994),
    [anon_sym_constructor] = ACTIONS(1992),
    [anon_sym_prop] = ACTIONS(1992),
    [anon_sym_id] = ACTIONS(1992),
    [anon_sym_event] = ACTIONS(1992),
    [anon_sym_fn] = ACTIONS(1992),
    [anon_sym_on] = ACTIONS(1992),
    [sym__ternary_qmark] = ACTIONS(1994),
  },
  [537] = {
    [sym_identifier] = ACTIONS(1848),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1848),
    [anon_sym_LBRACE] = ACTIONS(1848),
    [anon_sym_RBRACE] = ACTIONS(1852),
    [anon_sym_typeof] = ACTIONS(1848),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(1854),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(1848),
    [anon_sym_async] = ACTIONS(1848),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1848),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1848),
    [anon_sym_void] = ACTIONS(1848),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [anon_sym_DQUOTE] = ACTIONS(1852),
    [anon_sym_SQUOTE] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1852),
    [sym_number] = ACTIONS(1852),
    [sym_this] = ACTIONS(1848),
    [sym_true] = ACTIONS(1848),
    [sym_false] = ACTIONS(1848),
    [sym_null] = ACTIONS(1848),
    [sym_undefined] = ACTIONS(1848),
    [anon_sym_static] = ACTIONS(1848),
    [anon_sym_readonly] = ACTIONS(1848),
    [anon_sym_get] = ACTIONS(1848),
    [anon_sym_set] = ACTIONS(1848),
    [anon_sym_QMARK] = ACTIONS(1848),
    [anon_sym_any] = ACTIONS(1848),
    [anon_sym_number] = ACTIONS(1848),
    [anon_sym_boolean] = ACTIONS(1848),
    [anon_sym_string] = ACTIONS(1848),
    [anon_sym_symbol] = ACTIONS(1848),
    [anon_sym_abstract] = ACTIONS(1848),
    [anon_sym_satisfies] = ACTIONS(1848),
    [anon_sym_infer] = ACTIONS(1848),
    [anon_sym_keyof] = ACTIONS(1848),
    [anon_sym_unknown] = ACTIONS(1848),
    [anon_sym_never] = ACTIONS(1848),
    [anon_sym_object] = ACTIONS(1848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_constructor] = ACTIONS(1848),
    [anon_sym_prop] = ACTIONS(1848),
    [anon_sym_id] = ACTIONS(1848),
    [anon_sym_event] = ACTIONS(1848),
    [anon_sym_fn] = ACTIONS(1848),
    [anon_sym_on] = ACTIONS(1848),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [538] = {
    [sym_identifier] = ACTIONS(1996),
    [anon_sym_STAR] = ACTIONS(1996),
    [anon_sym_as] = ACTIONS(1996),
    [anon_sym_LBRACE] = ACTIONS(1996),
    [anon_sym_RBRACE] = ACTIONS(1998),
    [anon_sym_typeof] = ACTIONS(1996),
    [anon_sym_BANG] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(1998),
    [anon_sym_in] = ACTIONS(1996),
    [anon_sym_SEMI] = ACTIONS(1998),
    [anon_sym_EQ] = ACTIONS(1996),
    [anon_sym_LBRACK] = ACTIONS(1998),
    [anon_sym_LT] = ACTIONS(1996),
    [anon_sym_GT] = ACTIONS(1996),
    [anon_sym_SLASH] = ACTIONS(1996),
    [anon_sym_DOT] = ACTIONS(1996),
    [anon_sym_async] = ACTIONS(1996),
    [anon_sym_QMARK_DOT] = ACTIONS(1998),
    [anon_sym_new] = ACTIONS(1996),
    [anon_sym_PLUS_EQ] = ACTIONS(1998),
    [anon_sym_DASH_EQ] = ACTIONS(1998),
    [anon_sym_STAR_EQ] = ACTIONS(1998),
    [anon_sym_SLASH_EQ] = ACTIONS(1998),
    [anon_sym_PERCENT_EQ] = ACTIONS(1998),
    [anon_sym_CARET_EQ] = ACTIONS(1998),
    [anon_sym_AMP_EQ] = ACTIONS(1998),
    [anon_sym_PIPE_EQ] = ACTIONS(1998),
    [anon_sym_GT_GT_EQ] = ACTIONS(1998),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1998),
    [anon_sym_LT_LT_EQ] = ACTIONS(1998),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1998),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1998),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1998),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1998),
    [anon_sym_AMP_AMP] = ACTIONS(1996),
    [anon_sym_PIPE_PIPE] = ACTIONS(1996),
    [anon_sym_GT_GT] = ACTIONS(1996),
    [anon_sym_GT_GT_GT] = ACTIONS(1996),
    [anon_sym_LT_LT] = ACTIONS(1996),
    [anon_sym_AMP] = ACTIONS(1996),
    [anon_sym_CARET] = ACTIONS(1996),
    [anon_sym_PIPE] = ACTIONS(1996),
    [anon_sym_PLUS] = ACTIONS(1996),
    [anon_sym_DASH] = ACTIONS(1996),
    [anon_sym_PERCENT] = ACTIONS(1996),
    [anon_sym_STAR_STAR] = ACTIONS(1996),
    [anon_sym_LT_EQ] = ACTIONS(1998),
    [anon_sym_EQ_EQ] = ACTIONS(1996),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1998),
    [anon_sym_BANG_EQ] = ACTIONS(1996),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1998),
    [anon_sym_GT_EQ] = ACTIONS(1998),
    [anon_sym_QMARK_QMARK] = ACTIONS(1996),
    [anon_sym_instanceof] = ACTIONS(1996),
    [anon_sym_void] = ACTIONS(1996),
    [anon_sym_PLUS_PLUS] = ACTIONS(1998),
    [anon_sym_DASH_DASH] = ACTIONS(1998),
    [anon_sym_DQUOTE] = ACTIONS(1998),
    [anon_sym_SQUOTE] = ACTIONS(1998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1998),
    [sym_number] = ACTIONS(1998),
    [sym_this] = ACTIONS(1996),
    [sym_true] = ACTIONS(1996),
    [sym_false] = ACTIONS(1996),
    [sym_null] = ACTIONS(1996),
    [sym_undefined] = ACTIONS(1996),
    [anon_sym_static] = ACTIONS(1996),
    [anon_sym_readonly] = ACTIONS(1996),
    [anon_sym_get] = ACTIONS(1996),
    [anon_sym_set] = ACTIONS(1996),
    [anon_sym_QMARK] = ACTIONS(1996),
    [anon_sym_any] = ACTIONS(1996),
    [anon_sym_number] = ACTIONS(1996),
    [anon_sym_boolean] = ACTIONS(1996),
    [anon_sym_string] = ACTIONS(1996),
    [anon_sym_symbol] = ACTIONS(1996),
    [anon_sym_abstract] = ACTIONS(1996),
    [anon_sym_satisfies] = ACTIONS(1996),
    [anon_sym_infer] = ACTIONS(1996),
    [anon_sym_keyof] = ACTIONS(1996),
    [anon_sym_unknown] = ACTIONS(1996),
    [anon_sym_never] = ACTIONS(1996),
    [anon_sym_object] = ACTIONS(1996),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1998),
    [anon_sym_constructor] = ACTIONS(1996),
    [anon_sym_prop] = ACTIONS(1996),
    [anon_sym_id] = ACTIONS(1996),
    [anon_sym_event] = ACTIONS(1996),
    [anon_sym_fn] = ACTIONS(1996),
    [anon_sym_on] = ACTIONS(1996),
    [sym__ternary_qmark] = ACTIONS(1998),
  },
  [539] = {
    [sym_identifier] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(2000),
    [anon_sym_as] = ACTIONS(2000),
    [anon_sym_LBRACE] = ACTIONS(2000),
    [anon_sym_RBRACE] = ACTIONS(2002),
    [anon_sym_typeof] = ACTIONS(2000),
    [anon_sym_BANG] = ACTIONS(2000),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(2000),
    [anon_sym_SEMI] = ACTIONS(2002),
    [anon_sym_EQ] = ACTIONS(2000),
    [anon_sym_LBRACK] = ACTIONS(2002),
    [anon_sym_LT] = ACTIONS(2000),
    [anon_sym_GT] = ACTIONS(2000),
    [anon_sym_SLASH] = ACTIONS(2000),
    [anon_sym_DOT] = ACTIONS(2000),
    [anon_sym_async] = ACTIONS(2000),
    [anon_sym_QMARK_DOT] = ACTIONS(2002),
    [anon_sym_new] = ACTIONS(2000),
    [anon_sym_PLUS_EQ] = ACTIONS(2002),
    [anon_sym_DASH_EQ] = ACTIONS(2002),
    [anon_sym_STAR_EQ] = ACTIONS(2002),
    [anon_sym_SLASH_EQ] = ACTIONS(2002),
    [anon_sym_PERCENT_EQ] = ACTIONS(2002),
    [anon_sym_CARET_EQ] = ACTIONS(2002),
    [anon_sym_AMP_EQ] = ACTIONS(2002),
    [anon_sym_PIPE_EQ] = ACTIONS(2002),
    [anon_sym_GT_GT_EQ] = ACTIONS(2002),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2002),
    [anon_sym_LT_LT_EQ] = ACTIONS(2002),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2002),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2002),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2002),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2002),
    [anon_sym_AMP_AMP] = ACTIONS(2000),
    [anon_sym_PIPE_PIPE] = ACTIONS(2000),
    [anon_sym_GT_GT] = ACTIONS(2000),
    [anon_sym_GT_GT_GT] = ACTIONS(2000),
    [anon_sym_LT_LT] = ACTIONS(2000),
    [anon_sym_AMP] = ACTIONS(2000),
    [anon_sym_CARET] = ACTIONS(2000),
    [anon_sym_PIPE] = ACTIONS(2000),
    [anon_sym_PLUS] = ACTIONS(2000),
    [anon_sym_DASH] = ACTIONS(2000),
    [anon_sym_PERCENT] = ACTIONS(2000),
    [anon_sym_STAR_STAR] = ACTIONS(2000),
    [anon_sym_LT_EQ] = ACTIONS(2002),
    [anon_sym_EQ_EQ] = ACTIONS(2000),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2002),
    [anon_sym_BANG_EQ] = ACTIONS(2000),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2002),
    [anon_sym_GT_EQ] = ACTIONS(2002),
    [anon_sym_QMARK_QMARK] = ACTIONS(2000),
    [anon_sym_instanceof] = ACTIONS(2000),
    [anon_sym_void] = ACTIONS(2000),
    [anon_sym_PLUS_PLUS] = ACTIONS(2002),
    [anon_sym_DASH_DASH] = ACTIONS(2002),
    [anon_sym_DQUOTE] = ACTIONS(2002),
    [anon_sym_SQUOTE] = ACTIONS(2002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2002),
    [sym_number] = ACTIONS(2002),
    [sym_this] = ACTIONS(2000),
    [sym_true] = ACTIONS(2000),
    [sym_false] = ACTIONS(2000),
    [sym_null] = ACTIONS(2000),
    [sym_undefined] = ACTIONS(2000),
    [anon_sym_static] = ACTIONS(2000),
    [anon_sym_readonly] = ACTIONS(2000),
    [anon_sym_get] = ACTIONS(2000),
    [anon_sym_set] = ACTIONS(2000),
    [anon_sym_QMARK] = ACTIONS(2000),
    [anon_sym_any] = ACTIONS(2000),
    [anon_sym_number] = ACTIONS(2000),
    [anon_sym_boolean] = ACTIONS(2000),
    [anon_sym_string] = ACTIONS(2000),
    [anon_sym_symbol] = ACTIONS(2000),
    [anon_sym_abstract] = ACTIONS(2000),
    [anon_sym_satisfies] = ACTIONS(2000),
    [anon_sym_infer] = ACTIONS(2000),
    [anon_sym_keyof] = ACTIONS(2000),
    [anon_sym_unknown] = ACTIONS(2000),
    [anon_sym_never] = ACTIONS(2000),
    [anon_sym_object] = ACTIONS(2000),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2002),
    [anon_sym_constructor] = ACTIONS(2000),
    [anon_sym_prop] = ACTIONS(2000),
    [anon_sym_id] = ACTIONS(2000),
    [anon_sym_event] = ACTIONS(2000),
    [anon_sym_fn] = ACTIONS(2000),
    [anon_sym_on] = ACTIONS(2000),
    [sym__ternary_qmark] = ACTIONS(2002),
  },
  [540] = {
    [sym_identifier] = ACTIONS(2004),
    [anon_sym_STAR] = ACTIONS(2004),
    [anon_sym_as] = ACTIONS(2004),
    [anon_sym_LBRACE] = ACTIONS(2004),
    [anon_sym_RBRACE] = ACTIONS(2006),
    [anon_sym_typeof] = ACTIONS(2004),
    [anon_sym_BANG] = ACTIONS(2004),
    [anon_sym_LPAREN] = ACTIONS(2006),
    [anon_sym_in] = ACTIONS(2004),
    [anon_sym_SEMI] = ACTIONS(2006),
    [anon_sym_EQ] = ACTIONS(2004),
    [anon_sym_LBRACK] = ACTIONS(2006),
    [anon_sym_LT] = ACTIONS(2004),
    [anon_sym_GT] = ACTIONS(2004),
    [anon_sym_SLASH] = ACTIONS(2004),
    [anon_sym_DOT] = ACTIONS(2004),
    [anon_sym_async] = ACTIONS(2004),
    [anon_sym_QMARK_DOT] = ACTIONS(2006),
    [anon_sym_new] = ACTIONS(2004),
    [anon_sym_PLUS_EQ] = ACTIONS(2006),
    [anon_sym_DASH_EQ] = ACTIONS(2006),
    [anon_sym_STAR_EQ] = ACTIONS(2006),
    [anon_sym_SLASH_EQ] = ACTIONS(2006),
    [anon_sym_PERCENT_EQ] = ACTIONS(2006),
    [anon_sym_CARET_EQ] = ACTIONS(2006),
    [anon_sym_AMP_EQ] = ACTIONS(2006),
    [anon_sym_PIPE_EQ] = ACTIONS(2006),
    [anon_sym_GT_GT_EQ] = ACTIONS(2006),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2006),
    [anon_sym_LT_LT_EQ] = ACTIONS(2006),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2006),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2006),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2006),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2006),
    [anon_sym_AMP_AMP] = ACTIONS(2004),
    [anon_sym_PIPE_PIPE] = ACTIONS(2004),
    [anon_sym_GT_GT] = ACTIONS(2004),
    [anon_sym_GT_GT_GT] = ACTIONS(2004),
    [anon_sym_LT_LT] = ACTIONS(2004),
    [anon_sym_AMP] = ACTIONS(2004),
    [anon_sym_CARET] = ACTIONS(2004),
    [anon_sym_PIPE] = ACTIONS(2004),
    [anon_sym_PLUS] = ACTIONS(2004),
    [anon_sym_DASH] = ACTIONS(2004),
    [anon_sym_PERCENT] = ACTIONS(2004),
    [anon_sym_STAR_STAR] = ACTIONS(2004),
    [anon_sym_LT_EQ] = ACTIONS(2006),
    [anon_sym_EQ_EQ] = ACTIONS(2004),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2006),
    [anon_sym_BANG_EQ] = ACTIONS(2004),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2006),
    [anon_sym_GT_EQ] = ACTIONS(2006),
    [anon_sym_QMARK_QMARK] = ACTIONS(2004),
    [anon_sym_instanceof] = ACTIONS(2004),
    [anon_sym_void] = ACTIONS(2004),
    [anon_sym_PLUS_PLUS] = ACTIONS(2006),
    [anon_sym_DASH_DASH] = ACTIONS(2006),
    [anon_sym_DQUOTE] = ACTIONS(2006),
    [anon_sym_SQUOTE] = ACTIONS(2006),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2006),
    [sym_number] = ACTIONS(2006),
    [sym_this] = ACTIONS(2004),
    [sym_true] = ACTIONS(2004),
    [sym_false] = ACTIONS(2004),
    [sym_null] = ACTIONS(2004),
    [sym_undefined] = ACTIONS(2004),
    [anon_sym_static] = ACTIONS(2004),
    [anon_sym_readonly] = ACTIONS(2004),
    [anon_sym_get] = ACTIONS(2004),
    [anon_sym_set] = ACTIONS(2004),
    [anon_sym_QMARK] = ACTIONS(2004),
    [anon_sym_any] = ACTIONS(2004),
    [anon_sym_number] = ACTIONS(2004),
    [anon_sym_boolean] = ACTIONS(2004),
    [anon_sym_string] = ACTIONS(2004),
    [anon_sym_symbol] = ACTIONS(2004),
    [anon_sym_abstract] = ACTIONS(2004),
    [anon_sym_satisfies] = ACTIONS(2004),
    [anon_sym_infer] = ACTIONS(2004),
    [anon_sym_keyof] = ACTIONS(2004),
    [anon_sym_unknown] = ACTIONS(2004),
    [anon_sym_never] = ACTIONS(2004),
    [anon_sym_object] = ACTIONS(2004),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2006),
    [anon_sym_constructor] = ACTIONS(2004),
    [anon_sym_prop] = ACTIONS(2004),
    [anon_sym_id] = ACTIONS(2004),
    [anon_sym_event] = ACTIONS(2004),
    [anon_sym_fn] = ACTIONS(2004),
    [anon_sym_on] = ACTIONS(2004),
    [sym__ternary_qmark] = ACTIONS(2006),
  },
  [541] = {
    [sym_identifier] = ACTIONS(2008),
    [anon_sym_STAR] = ACTIONS(2008),
    [anon_sym_as] = ACTIONS(2008),
    [anon_sym_LBRACE] = ACTIONS(2008),
    [anon_sym_RBRACE] = ACTIONS(2010),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_BANG] = ACTIONS(2008),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_in] = ACTIONS(2008),
    [anon_sym_SEMI] = ACTIONS(2010),
    [anon_sym_EQ] = ACTIONS(2008),
    [anon_sym_LBRACK] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2008),
    [anon_sym_GT] = ACTIONS(2008),
    [anon_sym_SLASH] = ACTIONS(2008),
    [anon_sym_DOT] = ACTIONS(2008),
    [anon_sym_async] = ACTIONS(2008),
    [anon_sym_QMARK_DOT] = ACTIONS(2010),
    [anon_sym_new] = ACTIONS(2008),
    [anon_sym_PLUS_EQ] = ACTIONS(2010),
    [anon_sym_DASH_EQ] = ACTIONS(2010),
    [anon_sym_STAR_EQ] = ACTIONS(2010),
    [anon_sym_SLASH_EQ] = ACTIONS(2010),
    [anon_sym_PERCENT_EQ] = ACTIONS(2010),
    [anon_sym_CARET_EQ] = ACTIONS(2010),
    [anon_sym_AMP_EQ] = ACTIONS(2010),
    [anon_sym_PIPE_EQ] = ACTIONS(2010),
    [anon_sym_GT_GT_EQ] = ACTIONS(2010),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2010),
    [anon_sym_LT_LT_EQ] = ACTIONS(2010),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2010),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2010),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2010),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2010),
    [anon_sym_AMP_AMP] = ACTIONS(2008),
    [anon_sym_PIPE_PIPE] = ACTIONS(2008),
    [anon_sym_GT_GT] = ACTIONS(2008),
    [anon_sym_GT_GT_GT] = ACTIONS(2008),
    [anon_sym_LT_LT] = ACTIONS(2008),
    [anon_sym_AMP] = ACTIONS(2008),
    [anon_sym_CARET] = ACTIONS(2008),
    [anon_sym_PIPE] = ACTIONS(2008),
    [anon_sym_PLUS] = ACTIONS(2008),
    [anon_sym_DASH] = ACTIONS(2008),
    [anon_sym_PERCENT] = ACTIONS(2008),
    [anon_sym_STAR_STAR] = ACTIONS(2008),
    [anon_sym_LT_EQ] = ACTIONS(2010),
    [anon_sym_EQ_EQ] = ACTIONS(2008),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2010),
    [anon_sym_BANG_EQ] = ACTIONS(2008),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2010),
    [anon_sym_GT_EQ] = ACTIONS(2010),
    [anon_sym_QMARK_QMARK] = ACTIONS(2008),
    [anon_sym_instanceof] = ACTIONS(2008),
    [anon_sym_void] = ACTIONS(2008),
    [anon_sym_PLUS_PLUS] = ACTIONS(2010),
    [anon_sym_DASH_DASH] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_SQUOTE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [sym_number] = ACTIONS(2010),
    [sym_this] = ACTIONS(2008),
    [sym_true] = ACTIONS(2008),
    [sym_false] = ACTIONS(2008),
    [sym_null] = ACTIONS(2008),
    [sym_undefined] = ACTIONS(2008),
    [anon_sym_static] = ACTIONS(2008),
    [anon_sym_readonly] = ACTIONS(2008),
    [anon_sym_get] = ACTIONS(2008),
    [anon_sym_set] = ACTIONS(2008),
    [anon_sym_QMARK] = ACTIONS(2008),
    [anon_sym_any] = ACTIONS(2008),
    [anon_sym_number] = ACTIONS(2008),
    [anon_sym_boolean] = ACTIONS(2008),
    [anon_sym_string] = ACTIONS(2008),
    [anon_sym_symbol] = ACTIONS(2008),
    [anon_sym_abstract] = ACTIONS(2008),
    [anon_sym_satisfies] = ACTIONS(2008),
    [anon_sym_infer] = ACTIONS(2008),
    [anon_sym_keyof] = ACTIONS(2008),
    [anon_sym_unknown] = ACTIONS(2008),
    [anon_sym_never] = ACTIONS(2008),
    [anon_sym_object] = ACTIONS(2008),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2010),
    [anon_sym_constructor] = ACTIONS(2008),
    [anon_sym_prop] = ACTIONS(2008),
    [anon_sym_id] = ACTIONS(2008),
    [anon_sym_event] = ACTIONS(2008),
    [anon_sym_fn] = ACTIONS(2008),
    [anon_sym_on] = ACTIONS(2008),
    [sym__ternary_qmark] = ACTIONS(2010),
  },
  [542] = {
    [sym_identifier] = ACTIONS(2012),
    [anon_sym_STAR] = ACTIONS(2012),
    [anon_sym_as] = ACTIONS(2012),
    [anon_sym_LBRACE] = ACTIONS(2012),
    [anon_sym_RBRACE] = ACTIONS(2014),
    [anon_sym_typeof] = ACTIONS(2012),
    [anon_sym_BANG] = ACTIONS(2012),
    [anon_sym_LPAREN] = ACTIONS(2014),
    [anon_sym_in] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym_EQ] = ACTIONS(2012),
    [anon_sym_LBRACK] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(2012),
    [anon_sym_GT] = ACTIONS(2012),
    [anon_sym_SLASH] = ACTIONS(2012),
    [anon_sym_DOT] = ACTIONS(2012),
    [anon_sym_async] = ACTIONS(2012),
    [anon_sym_QMARK_DOT] = ACTIONS(2014),
    [anon_sym_new] = ACTIONS(2012),
    [anon_sym_PLUS_EQ] = ACTIONS(2014),
    [anon_sym_DASH_EQ] = ACTIONS(2014),
    [anon_sym_STAR_EQ] = ACTIONS(2014),
    [anon_sym_SLASH_EQ] = ACTIONS(2014),
    [anon_sym_PERCENT_EQ] = ACTIONS(2014),
    [anon_sym_CARET_EQ] = ACTIONS(2014),
    [anon_sym_AMP_EQ] = ACTIONS(2014),
    [anon_sym_PIPE_EQ] = ACTIONS(2014),
    [anon_sym_GT_GT_EQ] = ACTIONS(2014),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2014),
    [anon_sym_LT_LT_EQ] = ACTIONS(2014),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2014),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2014),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2014),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2014),
    [anon_sym_AMP_AMP] = ACTIONS(2012),
    [anon_sym_PIPE_PIPE] = ACTIONS(2012),
    [anon_sym_GT_GT] = ACTIONS(2012),
    [anon_sym_GT_GT_GT] = ACTIONS(2012),
    [anon_sym_LT_LT] = ACTIONS(2012),
    [anon_sym_AMP] = ACTIONS(2012),
    [anon_sym_CARET] = ACTIONS(2012),
    [anon_sym_PIPE] = ACTIONS(2012),
    [anon_sym_PLUS] = ACTIONS(2012),
    [anon_sym_DASH] = ACTIONS(2012),
    [anon_sym_PERCENT] = ACTIONS(2012),
    [anon_sym_STAR_STAR] = ACTIONS(2012),
    [anon_sym_LT_EQ] = ACTIONS(2014),
    [anon_sym_EQ_EQ] = ACTIONS(2012),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2014),
    [anon_sym_BANG_EQ] = ACTIONS(2012),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2014),
    [anon_sym_GT_EQ] = ACTIONS(2014),
    [anon_sym_QMARK_QMARK] = ACTIONS(2012),
    [anon_sym_instanceof] = ACTIONS(2012),
    [anon_sym_void] = ACTIONS(2012),
    [anon_sym_PLUS_PLUS] = ACTIONS(2014),
    [anon_sym_DASH_DASH] = ACTIONS(2014),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2014),
    [sym_number] = ACTIONS(2014),
    [sym_this] = ACTIONS(2012),
    [sym_true] = ACTIONS(2012),
    [sym_false] = ACTIONS(2012),
    [sym_null] = ACTIONS(2012),
    [sym_undefined] = ACTIONS(2012),
    [anon_sym_static] = ACTIONS(2012),
    [anon_sym_readonly] = ACTIONS(2012),
    [anon_sym_get] = ACTIONS(2012),
    [anon_sym_set] = ACTIONS(2012),
    [anon_sym_QMARK] = ACTIONS(2012),
    [anon_sym_any] = ACTIONS(2012),
    [anon_sym_number] = ACTIONS(2012),
    [anon_sym_boolean] = ACTIONS(2012),
    [anon_sym_string] = ACTIONS(2012),
    [anon_sym_symbol] = ACTIONS(2012),
    [anon_sym_abstract] = ACTIONS(2012),
    [anon_sym_satisfies] = ACTIONS(2012),
    [anon_sym_infer] = ACTIONS(2012),
    [anon_sym_keyof] = ACTIONS(2012),
    [anon_sym_unknown] = ACTIONS(2012),
    [anon_sym_never] = ACTIONS(2012),
    [anon_sym_object] = ACTIONS(2012),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2014),
    [anon_sym_constructor] = ACTIONS(2012),
    [anon_sym_prop] = ACTIONS(2012),
    [anon_sym_id] = ACTIONS(2012),
    [anon_sym_event] = ACTIONS(2012),
    [anon_sym_fn] = ACTIONS(2012),
    [anon_sym_on] = ACTIONS(2012),
    [sym__ternary_qmark] = ACTIONS(2014),
  },
  [543] = {
    [sym_identifier] = ACTIONS(1848),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1848),
    [anon_sym_LBRACE] = ACTIONS(1848),
    [anon_sym_RBRACE] = ACTIONS(1852),
    [anon_sym_typeof] = ACTIONS(1848),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(1848),
    [anon_sym_async] = ACTIONS(1848),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1848),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1848),
    [anon_sym_void] = ACTIONS(1848),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [anon_sym_DQUOTE] = ACTIONS(1852),
    [anon_sym_SQUOTE] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1852),
    [sym_number] = ACTIONS(1852),
    [sym_this] = ACTIONS(1848),
    [sym_true] = ACTIONS(1848),
    [sym_false] = ACTIONS(1848),
    [sym_null] = ACTIONS(1848),
    [sym_undefined] = ACTIONS(1848),
    [anon_sym_static] = ACTIONS(1848),
    [anon_sym_readonly] = ACTIONS(1848),
    [anon_sym_get] = ACTIONS(1848),
    [anon_sym_set] = ACTIONS(1848),
    [anon_sym_QMARK] = ACTIONS(1848),
    [anon_sym_any] = ACTIONS(1848),
    [anon_sym_number] = ACTIONS(1848),
    [anon_sym_boolean] = ACTIONS(1848),
    [anon_sym_string] = ACTIONS(1848),
    [anon_sym_symbol] = ACTIONS(1848),
    [anon_sym_abstract] = ACTIONS(1848),
    [anon_sym_satisfies] = ACTIONS(1848),
    [anon_sym_infer] = ACTIONS(1848),
    [anon_sym_keyof] = ACTIONS(1848),
    [anon_sym_unknown] = ACTIONS(1848),
    [anon_sym_never] = ACTIONS(1848),
    [anon_sym_object] = ACTIONS(1848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_constructor] = ACTIONS(1848),
    [anon_sym_prop] = ACTIONS(1848),
    [anon_sym_id] = ACTIONS(1848),
    [anon_sym_event] = ACTIONS(1848),
    [anon_sym_fn] = ACTIONS(1848),
    [anon_sym_on] = ACTIONS(1848),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [544] = {
    [sym_nested_identifier] = STATE(3019),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_new_component_expression] = STATE(1557),
    [sym_new_tagged_component_expression] = STATE(1557),
    [sym_new_tripple_tagged_component_expression] = STATE(1557),
    [sym_constructor_definition] = STATE(1557),
    [sym_type_narrow] = STATE(4187),
    [sym_property_declaration] = STATE(1557),
    [sym_static_property_declaration] = STATE(1557),
    [sym_identifier_property_assignment] = STATE(1557),
    [sym_property_assignment] = STATE(1557),
    [sym_event_declaration] = STATE(1557),
    [sym_property_accessor_declaration] = STATE(1557),
    [sym_typed_method_declaration] = STATE(1557),
    [sym_listener_declaration] = STATE(1557),
    [aux_sym_component_body_repeat1] = STATE(550),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(2018),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_async] = ACTIONS(2022),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_static] = ACTIONS(2028),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_get] = ACTIONS(2030),
    [anon_sym_set] = ACTIONS(2032),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_constructor] = ACTIONS(2034),
    [anon_sym_prop] = ACTIONS(2036),
    [anon_sym_id] = ACTIONS(2038),
    [anon_sym_event] = ACTIONS(2040),
    [anon_sym_fn] = ACTIONS(2042),
    [anon_sym_on] = ACTIONS(2044),
  },
  [545] = {
    [sym_nested_identifier] = STATE(3019),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_new_component_expression] = STATE(1557),
    [sym_new_tagged_component_expression] = STATE(1557),
    [sym_new_tripple_tagged_component_expression] = STATE(1557),
    [sym_constructor_definition] = STATE(1557),
    [sym_type_narrow] = STATE(4187),
    [sym_property_declaration] = STATE(1557),
    [sym_static_property_declaration] = STATE(1557),
    [sym_identifier_property_assignment] = STATE(1557),
    [sym_property_assignment] = STATE(1557),
    [sym_event_declaration] = STATE(1557),
    [sym_property_accessor_declaration] = STATE(1557),
    [sym_typed_method_declaration] = STATE(1557),
    [sym_listener_declaration] = STATE(1557),
    [aux_sym_component_body_repeat1] = STATE(550),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(2046),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_async] = ACTIONS(2022),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_static] = ACTIONS(2028),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_get] = ACTIONS(2030),
    [anon_sym_set] = ACTIONS(2032),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_constructor] = ACTIONS(2034),
    [anon_sym_prop] = ACTIONS(2036),
    [anon_sym_id] = ACTIONS(2038),
    [anon_sym_event] = ACTIONS(2040),
    [anon_sym_fn] = ACTIONS(2042),
    [anon_sym_on] = ACTIONS(2044),
  },
  [546] = {
    [sym_nested_identifier] = STATE(3019),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_new_component_expression] = STATE(1557),
    [sym_new_tagged_component_expression] = STATE(1557),
    [sym_new_tripple_tagged_component_expression] = STATE(1557),
    [sym_constructor_definition] = STATE(1557),
    [sym_type_narrow] = STATE(4187),
    [sym_property_declaration] = STATE(1557),
    [sym_static_property_declaration] = STATE(1557),
    [sym_identifier_property_assignment] = STATE(1557),
    [sym_property_assignment] = STATE(1557),
    [sym_event_declaration] = STATE(1557),
    [sym_property_accessor_declaration] = STATE(1557),
    [sym_typed_method_declaration] = STATE(1557),
    [sym_listener_declaration] = STATE(1557),
    [aux_sym_component_body_repeat1] = STATE(550),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(2048),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_async] = ACTIONS(2022),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_static] = ACTIONS(2028),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_get] = ACTIONS(2030),
    [anon_sym_set] = ACTIONS(2032),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_constructor] = ACTIONS(2034),
    [anon_sym_prop] = ACTIONS(2036),
    [anon_sym_id] = ACTIONS(2038),
    [anon_sym_event] = ACTIONS(2040),
    [anon_sym_fn] = ACTIONS(2042),
    [anon_sym_on] = ACTIONS(2044),
  },
  [547] = {
    [sym_nested_identifier] = STATE(3019),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_new_component_expression] = STATE(1557),
    [sym_new_tagged_component_expression] = STATE(1557),
    [sym_new_tripple_tagged_component_expression] = STATE(1557),
    [sym_constructor_definition] = STATE(1557),
    [sym_type_narrow] = STATE(4187),
    [sym_property_declaration] = STATE(1557),
    [sym_static_property_declaration] = STATE(1557),
    [sym_identifier_property_assignment] = STATE(1557),
    [sym_property_assignment] = STATE(1557),
    [sym_event_declaration] = STATE(1557),
    [sym_property_accessor_declaration] = STATE(1557),
    [sym_typed_method_declaration] = STATE(1557),
    [sym_listener_declaration] = STATE(1557),
    [aux_sym_component_body_repeat1] = STATE(545),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(2050),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_async] = ACTIONS(2022),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_static] = ACTIONS(2028),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_get] = ACTIONS(2030),
    [anon_sym_set] = ACTIONS(2032),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_constructor] = ACTIONS(2034),
    [anon_sym_prop] = ACTIONS(2036),
    [anon_sym_id] = ACTIONS(2038),
    [anon_sym_event] = ACTIONS(2040),
    [anon_sym_fn] = ACTIONS(2042),
    [anon_sym_on] = ACTIONS(2044),
  },
  [548] = {
    [sym_nested_identifier] = STATE(3019),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_new_component_expression] = STATE(1557),
    [sym_new_tagged_component_expression] = STATE(1557),
    [sym_new_tripple_tagged_component_expression] = STATE(1557),
    [sym_constructor_definition] = STATE(1557),
    [sym_type_narrow] = STATE(4187),
    [sym_property_declaration] = STATE(1557),
    [sym_static_property_declaration] = STATE(1557),
    [sym_identifier_property_assignment] = STATE(1557),
    [sym_property_assignment] = STATE(1557),
    [sym_event_declaration] = STATE(1557),
    [sym_property_accessor_declaration] = STATE(1557),
    [sym_typed_method_declaration] = STATE(1557),
    [sym_listener_declaration] = STATE(1557),
    [aux_sym_component_body_repeat1] = STATE(546),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(2052),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_async] = ACTIONS(2022),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_static] = ACTIONS(2028),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_get] = ACTIONS(2030),
    [anon_sym_set] = ACTIONS(2032),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_constructor] = ACTIONS(2034),
    [anon_sym_prop] = ACTIONS(2036),
    [anon_sym_id] = ACTIONS(2038),
    [anon_sym_event] = ACTIONS(2040),
    [anon_sym_fn] = ACTIONS(2042),
    [anon_sym_on] = ACTIONS(2044),
  },
  [549] = {
    [sym_nested_identifier] = STATE(3019),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_new_component_expression] = STATE(1557),
    [sym_new_tagged_component_expression] = STATE(1557),
    [sym_new_tripple_tagged_component_expression] = STATE(1557),
    [sym_constructor_definition] = STATE(1557),
    [sym_type_narrow] = STATE(4187),
    [sym_property_declaration] = STATE(1557),
    [sym_static_property_declaration] = STATE(1557),
    [sym_identifier_property_assignment] = STATE(1557),
    [sym_property_assignment] = STATE(1557),
    [sym_event_declaration] = STATE(1557),
    [sym_property_accessor_declaration] = STATE(1557),
    [sym_typed_method_declaration] = STATE(1557),
    [sym_listener_declaration] = STATE(1557),
    [aux_sym_component_body_repeat1] = STATE(555),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(2054),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_async] = ACTIONS(2022),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_static] = ACTIONS(2028),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_get] = ACTIONS(2030),
    [anon_sym_set] = ACTIONS(2032),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_constructor] = ACTIONS(2034),
    [anon_sym_prop] = ACTIONS(2036),
    [anon_sym_id] = ACTIONS(2038),
    [anon_sym_event] = ACTIONS(2040),
    [anon_sym_fn] = ACTIONS(2042),
    [anon_sym_on] = ACTIONS(2044),
  },
  [550] = {
    [sym_nested_identifier] = STATE(3019),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_new_component_expression] = STATE(1557),
    [sym_new_tagged_component_expression] = STATE(1557),
    [sym_new_tripple_tagged_component_expression] = STATE(1557),
    [sym_constructor_definition] = STATE(1557),
    [sym_type_narrow] = STATE(4187),
    [sym_property_declaration] = STATE(1557),
    [sym_static_property_declaration] = STATE(1557),
    [sym_identifier_property_assignment] = STATE(1557),
    [sym_property_assignment] = STATE(1557),
    [sym_event_declaration] = STATE(1557),
    [sym_property_accessor_declaration] = STATE(1557),
    [sym_typed_method_declaration] = STATE(1557),
    [sym_listener_declaration] = STATE(1557),
    [aux_sym_component_body_repeat1] = STATE(550),
    [sym_identifier] = ACTIONS(2056),
    [anon_sym_STAR] = ACTIONS(2059),
    [anon_sym_LBRACE] = ACTIONS(2062),
    [anon_sym_RBRACE] = ACTIONS(2065),
    [anon_sym_typeof] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(2070),
    [anon_sym_LBRACK] = ACTIONS(2073),
    [anon_sym_LT] = ACTIONS(2076),
    [anon_sym_async] = ACTIONS(2079),
    [anon_sym_new] = ACTIONS(2082),
    [anon_sym_AMP] = ACTIONS(2085),
    [anon_sym_PIPE] = ACTIONS(2088),
    [anon_sym_PLUS] = ACTIONS(2091),
    [anon_sym_DASH] = ACTIONS(2091),
    [anon_sym_void] = ACTIONS(2094),
    [anon_sym_DQUOTE] = ACTIONS(2097),
    [anon_sym_SQUOTE] = ACTIONS(2100),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2103),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2109),
    [sym_true] = ACTIONS(2112),
    [sym_false] = ACTIONS(2112),
    [sym_null] = ACTIONS(2112),
    [sym_undefined] = ACTIONS(2112),
    [anon_sym_static] = ACTIONS(2115),
    [anon_sym_readonly] = ACTIONS(2118),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2124),
    [anon_sym_QMARK] = ACTIONS(2127),
    [anon_sym_any] = ACTIONS(2094),
    [anon_sym_number] = ACTIONS(2094),
    [anon_sym_boolean] = ACTIONS(2094),
    [anon_sym_string] = ACTIONS(2094),
    [anon_sym_symbol] = ACTIONS(2094),
    [anon_sym_abstract] = ACTIONS(2130),
    [anon_sym_infer] = ACTIONS(2133),
    [anon_sym_keyof] = ACTIONS(2136),
    [anon_sym_unknown] = ACTIONS(2094),
    [anon_sym_never] = ACTIONS(2094),
    [anon_sym_object] = ACTIONS(2094),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2139),
    [anon_sym_constructor] = ACTIONS(2142),
    [anon_sym_prop] = ACTIONS(2145),
    [anon_sym_id] = ACTIONS(2148),
    [anon_sym_event] = ACTIONS(2151),
    [anon_sym_fn] = ACTIONS(2154),
    [anon_sym_on] = ACTIONS(2157),
  },
  [551] = {
    [sym_nested_identifier] = STATE(3019),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_new_component_expression] = STATE(1557),
    [sym_new_tagged_component_expression] = STATE(1557),
    [sym_new_tripple_tagged_component_expression] = STATE(1557),
    [sym_constructor_definition] = STATE(1557),
    [sym_type_narrow] = STATE(4187),
    [sym_property_declaration] = STATE(1557),
    [sym_static_property_declaration] = STATE(1557),
    [sym_identifier_property_assignment] = STATE(1557),
    [sym_property_assignment] = STATE(1557),
    [sym_event_declaration] = STATE(1557),
    [sym_property_accessor_declaration] = STATE(1557),
    [sym_typed_method_declaration] = STATE(1557),
    [sym_listener_declaration] = STATE(1557),
    [aux_sym_component_body_repeat1] = STATE(550),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_async] = ACTIONS(2022),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_static] = ACTIONS(2028),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_get] = ACTIONS(2030),
    [anon_sym_set] = ACTIONS(2032),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_constructor] = ACTIONS(2034),
    [anon_sym_prop] = ACTIONS(2036),
    [anon_sym_id] = ACTIONS(2038),
    [anon_sym_event] = ACTIONS(2040),
    [anon_sym_fn] = ACTIONS(2042),
    [anon_sym_on] = ACTIONS(2044),
  },
  [552] = {
    [sym_nested_identifier] = STATE(3019),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_new_component_expression] = STATE(1557),
    [sym_new_tagged_component_expression] = STATE(1557),
    [sym_new_tripple_tagged_component_expression] = STATE(1557),
    [sym_constructor_definition] = STATE(1557),
    [sym_type_narrow] = STATE(4187),
    [sym_property_declaration] = STATE(1557),
    [sym_static_property_declaration] = STATE(1557),
    [sym_identifier_property_assignment] = STATE(1557),
    [sym_property_assignment] = STATE(1557),
    [sym_event_declaration] = STATE(1557),
    [sym_property_accessor_declaration] = STATE(1557),
    [sym_typed_method_declaration] = STATE(1557),
    [sym_listener_declaration] = STATE(1557),
    [aux_sym_component_body_repeat1] = STATE(544),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(2162),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_async] = ACTIONS(2022),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_static] = ACTIONS(2028),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_get] = ACTIONS(2030),
    [anon_sym_set] = ACTIONS(2032),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_constructor] = ACTIONS(2034),
    [anon_sym_prop] = ACTIONS(2036),
    [anon_sym_id] = ACTIONS(2038),
    [anon_sym_event] = ACTIONS(2040),
    [anon_sym_fn] = ACTIONS(2042),
    [anon_sym_on] = ACTIONS(2044),
  },
  [553] = {
    [sym_identifier] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_RBRACE] = ACTIONS(65),
    [anon_sym_typeof] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(65),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1497),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(25),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(25),
    [anon_sym_EQ_GT] = ACTIONS(1502),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(25),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_void] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(65),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(65),
    [sym_number] = ACTIONS(65),
    [sym_this] = ACTIONS(25),
    [sym_true] = ACTIONS(25),
    [sym_false] = ACTIONS(25),
    [sym_null] = ACTIONS(25),
    [sym_undefined] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_readonly] = ACTIONS(25),
    [anon_sym_QMARK] = ACTIONS(25),
    [anon_sym_any] = ACTIONS(25),
    [anon_sym_number] = ACTIONS(25),
    [anon_sym_boolean] = ACTIONS(25),
    [anon_sym_string] = ACTIONS(25),
    [anon_sym_symbol] = ACTIONS(25),
    [anon_sym_abstract] = ACTIONS(25),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_infer] = ACTIONS(25),
    [anon_sym_keyof] = ACTIONS(25),
    [anon_sym_unknown] = ACTIONS(25),
    [anon_sym_never] = ACTIONS(25),
    [anon_sym_object] = ACTIONS(25),
    [anon_sym_LBRACE_PIPE] = ACTIONS(65),
    [anon_sym_prop] = ACTIONS(25),
    [anon_sym_id] = ACTIONS(25),
    [anon_sym_event] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_on] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [554] = {
    [sym_nested_identifier] = STATE(3019),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_new_component_expression] = STATE(1557),
    [sym_new_tagged_component_expression] = STATE(1557),
    [sym_new_tripple_tagged_component_expression] = STATE(1557),
    [sym_constructor_definition] = STATE(1557),
    [sym_type_narrow] = STATE(4187),
    [sym_property_declaration] = STATE(1557),
    [sym_static_property_declaration] = STATE(1557),
    [sym_identifier_property_assignment] = STATE(1557),
    [sym_property_assignment] = STATE(1557),
    [sym_event_declaration] = STATE(1557),
    [sym_property_accessor_declaration] = STATE(1557),
    [sym_typed_method_declaration] = STATE(1557),
    [sym_listener_declaration] = STATE(1557),
    [aux_sym_component_body_repeat1] = STATE(551),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(2164),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_async] = ACTIONS(2022),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_static] = ACTIONS(2028),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_get] = ACTIONS(2030),
    [anon_sym_set] = ACTIONS(2032),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_constructor] = ACTIONS(2034),
    [anon_sym_prop] = ACTIONS(2036),
    [anon_sym_id] = ACTIONS(2038),
    [anon_sym_event] = ACTIONS(2040),
    [anon_sym_fn] = ACTIONS(2042),
    [anon_sym_on] = ACTIONS(2044),
  },
  [555] = {
    [sym_nested_identifier] = STATE(3019),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_new_component_expression] = STATE(1557),
    [sym_new_tagged_component_expression] = STATE(1557),
    [sym_new_tripple_tagged_component_expression] = STATE(1557),
    [sym_constructor_definition] = STATE(1557),
    [sym_type_narrow] = STATE(4187),
    [sym_property_declaration] = STATE(1557),
    [sym_static_property_declaration] = STATE(1557),
    [sym_identifier_property_assignment] = STATE(1557),
    [sym_property_assignment] = STATE(1557),
    [sym_event_declaration] = STATE(1557),
    [sym_property_accessor_declaration] = STATE(1557),
    [sym_typed_method_declaration] = STATE(1557),
    [sym_listener_declaration] = STATE(1557),
    [aux_sym_component_body_repeat1] = STATE(550),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_async] = ACTIONS(2022),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_static] = ACTIONS(2028),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_get] = ACTIONS(2030),
    [anon_sym_set] = ACTIONS(2032),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_constructor] = ACTIONS(2034),
    [anon_sym_prop] = ACTIONS(2036),
    [anon_sym_id] = ACTIONS(2038),
    [anon_sym_event] = ACTIONS(2040),
    [anon_sym_fn] = ACTIONS(2042),
    [anon_sym_on] = ACTIONS(2044),
  },
  [556] = {
    [sym_identifier] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_RBRACE] = ACTIONS(65),
    [anon_sym_typeof] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(65),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(25),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(25),
    [anon_sym_EQ_GT] = ACTIONS(1502),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_new] = ACTIONS(25),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_void] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(65),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(65),
    [sym_number] = ACTIONS(65),
    [sym_this] = ACTIONS(25),
    [sym_true] = ACTIONS(25),
    [sym_false] = ACTIONS(25),
    [sym_null] = ACTIONS(25),
    [sym_undefined] = ACTIONS(25),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_readonly] = ACTIONS(25),
    [anon_sym_QMARK] = ACTIONS(25),
    [anon_sym_any] = ACTIONS(25),
    [anon_sym_number] = ACTIONS(25),
    [anon_sym_boolean] = ACTIONS(25),
    [anon_sym_string] = ACTIONS(25),
    [anon_sym_symbol] = ACTIONS(25),
    [anon_sym_abstract] = ACTIONS(25),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_infer] = ACTIONS(25),
    [anon_sym_keyof] = ACTIONS(25),
    [anon_sym_unknown] = ACTIONS(25),
    [anon_sym_never] = ACTIONS(25),
    [anon_sym_object] = ACTIONS(25),
    [anon_sym_LBRACE_PIPE] = ACTIONS(65),
    [anon_sym_prop] = ACTIONS(25),
    [anon_sym_id] = ACTIONS(25),
    [anon_sym_event] = ACTIONS(25),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_on] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [557] = {
    [sym_string] = STATE(3488),
    [sym__property_name] = STATE(3488),
    [sym_computed_property_name] = STATE(3488),
    [sym_override_modifier] = STATE(2649),
    [aux_sym_object_repeat1] = STATE(3990),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_export] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1930),
    [anon_sym_type] = ACTIONS(2168),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(2170),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1976),
    [sym_private_property_identifier] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_readonly] = ACTIONS(2172),
    [anon_sym_get] = ACTIONS(2174),
    [anon_sym_set] = ACTIONS(2174),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(2168),
    [anon_sym_namespace] = ACTIONS(2168),
    [anon_sym_public] = ACTIONS(2168),
    [anon_sym_private] = ACTIONS(2168),
    [anon_sym_protected] = ACTIONS(2168),
    [anon_sym_override] = ACTIONS(2176),
    [anon_sym_module] = ACTIONS(2168),
    [anon_sym_any] = ACTIONS(2168),
    [anon_sym_number] = ACTIONS(2168),
    [anon_sym_boolean] = ACTIONS(2168),
    [anon_sym_string] = ACTIONS(2168),
    [anon_sym_symbol] = ACTIONS(2168),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [558] = {
    [sym_string] = STATE(3488),
    [sym__property_name] = STATE(3488),
    [sym_computed_property_name] = STATE(3488),
    [sym_override_modifier] = STATE(2649),
    [aux_sym_object_repeat1] = STATE(3936),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_export] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1928),
    [anon_sym_type] = ACTIONS(2168),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(2170),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1976),
    [sym_private_property_identifier] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_readonly] = ACTIONS(2172),
    [anon_sym_get] = ACTIONS(2174),
    [anon_sym_set] = ACTIONS(2174),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(2168),
    [anon_sym_namespace] = ACTIONS(2168),
    [anon_sym_public] = ACTIONS(2168),
    [anon_sym_private] = ACTIONS(2168),
    [anon_sym_protected] = ACTIONS(2168),
    [anon_sym_override] = ACTIONS(2176),
    [anon_sym_module] = ACTIONS(2168),
    [anon_sym_any] = ACTIONS(2168),
    [anon_sym_number] = ACTIONS(2168),
    [anon_sym_boolean] = ACTIONS(2168),
    [anon_sym_string] = ACTIONS(2168),
    [anon_sym_symbol] = ACTIONS(2168),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [559] = {
    [sym_string] = STATE(3488),
    [sym__property_name] = STATE(3488),
    [sym_computed_property_name] = STATE(3488),
    [sym_override_modifier] = STATE(2649),
    [aux_sym_object_repeat1] = STATE(4053),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_export] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1879),
    [anon_sym_type] = ACTIONS(2168),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(2170),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1976),
    [sym_private_property_identifier] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_readonly] = ACTIONS(2172),
    [anon_sym_get] = ACTIONS(2174),
    [anon_sym_set] = ACTIONS(2174),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(2168),
    [anon_sym_namespace] = ACTIONS(2168),
    [anon_sym_public] = ACTIONS(2168),
    [anon_sym_private] = ACTIONS(2168),
    [anon_sym_protected] = ACTIONS(2168),
    [anon_sym_override] = ACTIONS(2176),
    [anon_sym_module] = ACTIONS(2168),
    [anon_sym_any] = ACTIONS(2168),
    [anon_sym_number] = ACTIONS(2168),
    [anon_sym_boolean] = ACTIONS(2168),
    [anon_sym_string] = ACTIONS(2168),
    [anon_sym_symbol] = ACTIONS(2168),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [560] = {
    [sym_string] = STATE(3488),
    [sym__property_name] = STATE(3488),
    [sym_computed_property_name] = STATE(3488),
    [sym_override_modifier] = STATE(2649),
    [aux_sym_object_repeat1] = STATE(3936),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_export] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1926),
    [anon_sym_type] = ACTIONS(2168),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(2170),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1976),
    [sym_private_property_identifier] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_readonly] = ACTIONS(2172),
    [anon_sym_get] = ACTIONS(2174),
    [anon_sym_set] = ACTIONS(2174),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(2168),
    [anon_sym_namespace] = ACTIONS(2168),
    [anon_sym_public] = ACTIONS(2168),
    [anon_sym_private] = ACTIONS(2168),
    [anon_sym_protected] = ACTIONS(2168),
    [anon_sym_override] = ACTIONS(2176),
    [anon_sym_module] = ACTIONS(2168),
    [anon_sym_any] = ACTIONS(2168),
    [anon_sym_number] = ACTIONS(2168),
    [anon_sym_boolean] = ACTIONS(2168),
    [anon_sym_string] = ACTIONS(2168),
    [anon_sym_symbol] = ACTIONS(2168),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [561] = {
    [sym_identifier] = ACTIONS(1848),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1848),
    [anon_sym_LBRACE] = ACTIONS(1848),
    [anon_sym_RBRACE] = ACTIONS(1852),
    [anon_sym_typeof] = ACTIONS(1848),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(1932),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(1848),
    [anon_sym_async] = ACTIONS(1848),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1848),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1848),
    [anon_sym_void] = ACTIONS(1848),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [anon_sym_DQUOTE] = ACTIONS(1852),
    [anon_sym_SQUOTE] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1852),
    [sym_number] = ACTIONS(1852),
    [sym_this] = ACTIONS(1848),
    [sym_true] = ACTIONS(1848),
    [sym_false] = ACTIONS(1848),
    [sym_null] = ACTIONS(1848),
    [sym_undefined] = ACTIONS(1848),
    [anon_sym_static] = ACTIONS(1848),
    [anon_sym_readonly] = ACTIONS(1848),
    [anon_sym_QMARK] = ACTIONS(1848),
    [anon_sym_any] = ACTIONS(1848),
    [anon_sym_number] = ACTIONS(1848),
    [anon_sym_boolean] = ACTIONS(1848),
    [anon_sym_string] = ACTIONS(1848),
    [anon_sym_symbol] = ACTIONS(1848),
    [anon_sym_abstract] = ACTIONS(1848),
    [anon_sym_satisfies] = ACTIONS(1848),
    [anon_sym_infer] = ACTIONS(1848),
    [anon_sym_keyof] = ACTIONS(1848),
    [anon_sym_unknown] = ACTIONS(1848),
    [anon_sym_never] = ACTIONS(1848),
    [anon_sym_object] = ACTIONS(1848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_prop] = ACTIONS(1848),
    [anon_sym_id] = ACTIONS(1848),
    [anon_sym_event] = ACTIONS(1848),
    [anon_sym_fn] = ACTIONS(1848),
    [anon_sym_on] = ACTIONS(1848),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [562] = {
    [sym_string] = STATE(3488),
    [sym__property_name] = STATE(3488),
    [sym_computed_property_name] = STATE(3488),
    [aux_sym_object_repeat1] = STATE(3990),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_export] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1930),
    [anon_sym_type] = ACTIONS(2168),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(2168),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1976),
    [sym_private_property_identifier] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_readonly] = ACTIONS(2168),
    [anon_sym_get] = ACTIONS(2168),
    [anon_sym_set] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(2168),
    [anon_sym_namespace] = ACTIONS(2168),
    [anon_sym_public] = ACTIONS(2168),
    [anon_sym_private] = ACTIONS(2168),
    [anon_sym_protected] = ACTIONS(2168),
    [anon_sym_override] = ACTIONS(2168),
    [anon_sym_module] = ACTIONS(2168),
    [anon_sym_any] = ACTIONS(2168),
    [anon_sym_number] = ACTIONS(2168),
    [anon_sym_boolean] = ACTIONS(2168),
    [anon_sym_string] = ACTIONS(2168),
    [anon_sym_symbol] = ACTIONS(2168),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [563] = {
    [sym_string] = STATE(3488),
    [sym__property_name] = STATE(3488),
    [sym_computed_property_name] = STATE(3488),
    [aux_sym_object_repeat1] = STATE(3936),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_export] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1926),
    [anon_sym_type] = ACTIONS(2168),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(2168),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1976),
    [sym_private_property_identifier] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_readonly] = ACTIONS(2168),
    [anon_sym_get] = ACTIONS(2168),
    [anon_sym_set] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(2168),
    [anon_sym_namespace] = ACTIONS(2168),
    [anon_sym_public] = ACTIONS(2168),
    [anon_sym_private] = ACTIONS(2168),
    [anon_sym_protected] = ACTIONS(2168),
    [anon_sym_override] = ACTIONS(2168),
    [anon_sym_module] = ACTIONS(2168),
    [anon_sym_any] = ACTIONS(2168),
    [anon_sym_number] = ACTIONS(2168),
    [anon_sym_boolean] = ACTIONS(2168),
    [anon_sym_string] = ACTIONS(2168),
    [anon_sym_symbol] = ACTIONS(2168),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [564] = {
    [sym_string] = STATE(3488),
    [sym__property_name] = STATE(3488),
    [sym_computed_property_name] = STATE(3488),
    [aux_sym_object_repeat1] = STATE(3936),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_export] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1926),
    [anon_sym_type] = ACTIONS(2168),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(2170),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1976),
    [sym_private_property_identifier] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_readonly] = ACTIONS(2168),
    [anon_sym_get] = ACTIONS(2174),
    [anon_sym_set] = ACTIONS(2174),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(2168),
    [anon_sym_namespace] = ACTIONS(2168),
    [anon_sym_public] = ACTIONS(2168),
    [anon_sym_private] = ACTIONS(2168),
    [anon_sym_protected] = ACTIONS(2168),
    [anon_sym_override] = ACTIONS(2168),
    [anon_sym_module] = ACTIONS(2168),
    [anon_sym_any] = ACTIONS(2168),
    [anon_sym_number] = ACTIONS(2168),
    [anon_sym_boolean] = ACTIONS(2168),
    [anon_sym_string] = ACTIONS(2168),
    [anon_sym_symbol] = ACTIONS(2168),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [565] = {
    [sym_string] = STATE(3488),
    [sym__property_name] = STATE(3488),
    [sym_computed_property_name] = STATE(3488),
    [aux_sym_object_repeat1] = STATE(4053),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_export] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1879),
    [anon_sym_type] = ACTIONS(2168),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(2168),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1976),
    [sym_private_property_identifier] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_readonly] = ACTIONS(2168),
    [anon_sym_get] = ACTIONS(2168),
    [anon_sym_set] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(2168),
    [anon_sym_namespace] = ACTIONS(2168),
    [anon_sym_public] = ACTIONS(2168),
    [anon_sym_private] = ACTIONS(2168),
    [anon_sym_protected] = ACTIONS(2168),
    [anon_sym_override] = ACTIONS(2168),
    [anon_sym_module] = ACTIONS(2168),
    [anon_sym_any] = ACTIONS(2168),
    [anon_sym_number] = ACTIONS(2168),
    [anon_sym_boolean] = ACTIONS(2168),
    [anon_sym_string] = ACTIONS(2168),
    [anon_sym_symbol] = ACTIONS(2168),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [566] = {
    [sym_string] = STATE(3488),
    [sym__property_name] = STATE(3488),
    [sym_computed_property_name] = STATE(3488),
    [aux_sym_object_repeat1] = STATE(3990),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_export] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1930),
    [anon_sym_type] = ACTIONS(2168),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(2170),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1976),
    [sym_private_property_identifier] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_readonly] = ACTIONS(2168),
    [anon_sym_get] = ACTIONS(2174),
    [anon_sym_set] = ACTIONS(2174),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(2168),
    [anon_sym_namespace] = ACTIONS(2168),
    [anon_sym_public] = ACTIONS(2168),
    [anon_sym_private] = ACTIONS(2168),
    [anon_sym_protected] = ACTIONS(2168),
    [anon_sym_override] = ACTIONS(2168),
    [anon_sym_module] = ACTIONS(2168),
    [anon_sym_any] = ACTIONS(2168),
    [anon_sym_number] = ACTIONS(2168),
    [anon_sym_boolean] = ACTIONS(2168),
    [anon_sym_string] = ACTIONS(2168),
    [anon_sym_symbol] = ACTIONS(2168),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [567] = {
    [sym_string] = STATE(3488),
    [sym__property_name] = STATE(3488),
    [sym_computed_property_name] = STATE(3488),
    [aux_sym_object_repeat1] = STATE(4053),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_export] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1879),
    [anon_sym_type] = ACTIONS(2168),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(2170),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1976),
    [sym_private_property_identifier] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_readonly] = ACTIONS(2168),
    [anon_sym_get] = ACTIONS(2174),
    [anon_sym_set] = ACTIONS(2174),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(2168),
    [anon_sym_namespace] = ACTIONS(2168),
    [anon_sym_public] = ACTIONS(2168),
    [anon_sym_private] = ACTIONS(2168),
    [anon_sym_protected] = ACTIONS(2168),
    [anon_sym_override] = ACTIONS(2168),
    [anon_sym_module] = ACTIONS(2168),
    [anon_sym_any] = ACTIONS(2168),
    [anon_sym_number] = ACTIONS(2168),
    [anon_sym_boolean] = ACTIONS(2168),
    [anon_sym_string] = ACTIONS(2168),
    [anon_sym_symbol] = ACTIONS(2168),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [568] = {
    [sym_string] = STATE(3488),
    [sym__property_name] = STATE(3488),
    [sym_computed_property_name] = STATE(3488),
    [aux_sym_object_repeat1] = STATE(3936),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_export] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1928),
    [anon_sym_type] = ACTIONS(2168),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(2170),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1976),
    [sym_private_property_identifier] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_readonly] = ACTIONS(2168),
    [anon_sym_get] = ACTIONS(2174),
    [anon_sym_set] = ACTIONS(2174),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(2168),
    [anon_sym_namespace] = ACTIONS(2168),
    [anon_sym_public] = ACTIONS(2168),
    [anon_sym_private] = ACTIONS(2168),
    [anon_sym_protected] = ACTIONS(2168),
    [anon_sym_override] = ACTIONS(2168),
    [anon_sym_module] = ACTIONS(2168),
    [anon_sym_any] = ACTIONS(2168),
    [anon_sym_number] = ACTIONS(2168),
    [anon_sym_boolean] = ACTIONS(2168),
    [anon_sym_string] = ACTIONS(2168),
    [anon_sym_symbol] = ACTIONS(2168),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [569] = {
    [sym_string] = STATE(3488),
    [sym__property_name] = STATE(3488),
    [sym_computed_property_name] = STATE(3488),
    [aux_sym_object_repeat1] = STATE(3936),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_export] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1928),
    [anon_sym_type] = ACTIONS(2168),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(2168),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1976),
    [sym_private_property_identifier] = ACTIONS(1976),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_readonly] = ACTIONS(2168),
    [anon_sym_get] = ACTIONS(2168),
    [anon_sym_set] = ACTIONS(2168),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(2168),
    [anon_sym_namespace] = ACTIONS(2168),
    [anon_sym_public] = ACTIONS(2168),
    [anon_sym_private] = ACTIONS(2168),
    [anon_sym_protected] = ACTIONS(2168),
    [anon_sym_override] = ACTIONS(2168),
    [anon_sym_module] = ACTIONS(2168),
    [anon_sym_any] = ACTIONS(2168),
    [anon_sym_number] = ACTIONS(2168),
    [anon_sym_boolean] = ACTIONS(2168),
    [anon_sym_string] = ACTIONS(2168),
    [anon_sym_symbol] = ACTIONS(2168),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [570] = {
    [aux_sym_object_repeat1] = STATE(4053),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(1844),
    [anon_sym_export] = ACTIONS(1844),
    [anon_sym_STAR] = ACTIONS(1844),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1879),
    [anon_sym_type] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1846),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(1844),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1846),
    [anon_sym_SQUOTE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1846),
    [sym_private_property_identifier] = ACTIONS(1846),
    [anon_sym_static] = ACTIONS(1844),
    [anon_sym_readonly] = ACTIONS(1844),
    [anon_sym_get] = ACTIONS(1844),
    [anon_sym_set] = ACTIONS(1844),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(1844),
    [anon_sym_namespace] = ACTIONS(1844),
    [anon_sym_public] = ACTIONS(1844),
    [anon_sym_private] = ACTIONS(1844),
    [anon_sym_protected] = ACTIONS(1844),
    [anon_sym_override] = ACTIONS(1844),
    [anon_sym_module] = ACTIONS(1844),
    [anon_sym_any] = ACTIONS(1844),
    [anon_sym_number] = ACTIONS(1844),
    [anon_sym_boolean] = ACTIONS(1844),
    [anon_sym_string] = ACTIONS(1844),
    [anon_sym_symbol] = ACTIONS(1844),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [571] = {
    [aux_sym_object_repeat1] = STATE(4053),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(1840),
    [anon_sym_export] = ACTIONS(1840),
    [anon_sym_STAR] = ACTIONS(1840),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1879),
    [anon_sym_type] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1842),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(1840),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1842),
    [anon_sym_SQUOTE] = ACTIONS(1842),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1842),
    [sym_private_property_identifier] = ACTIONS(1842),
    [anon_sym_static] = ACTIONS(1840),
    [anon_sym_readonly] = ACTIONS(1840),
    [anon_sym_get] = ACTIONS(1840),
    [anon_sym_set] = ACTIONS(1840),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(1840),
    [anon_sym_namespace] = ACTIONS(1840),
    [anon_sym_public] = ACTIONS(1840),
    [anon_sym_private] = ACTIONS(1840),
    [anon_sym_protected] = ACTIONS(1840),
    [anon_sym_override] = ACTIONS(1840),
    [anon_sym_module] = ACTIONS(1840),
    [anon_sym_any] = ACTIONS(1840),
    [anon_sym_number] = ACTIONS(1840),
    [anon_sym_boolean] = ACTIONS(1840),
    [anon_sym_string] = ACTIONS(1840),
    [anon_sym_symbol] = ACTIONS(1840),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [572] = {
    [aux_sym_object_repeat1] = STATE(3990),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(1844),
    [anon_sym_export] = ACTIONS(1844),
    [anon_sym_STAR] = ACTIONS(1844),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1930),
    [anon_sym_type] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1846),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(1844),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1846),
    [anon_sym_SQUOTE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1846),
    [sym_private_property_identifier] = ACTIONS(1846),
    [anon_sym_static] = ACTIONS(1844),
    [anon_sym_readonly] = ACTIONS(1844),
    [anon_sym_get] = ACTIONS(1844),
    [anon_sym_set] = ACTIONS(1844),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(1844),
    [anon_sym_namespace] = ACTIONS(1844),
    [anon_sym_public] = ACTIONS(1844),
    [anon_sym_private] = ACTIONS(1844),
    [anon_sym_protected] = ACTIONS(1844),
    [anon_sym_override] = ACTIONS(1844),
    [anon_sym_module] = ACTIONS(1844),
    [anon_sym_any] = ACTIONS(1844),
    [anon_sym_number] = ACTIONS(1844),
    [anon_sym_boolean] = ACTIONS(1844),
    [anon_sym_string] = ACTIONS(1844),
    [anon_sym_symbol] = ACTIONS(1844),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [573] = {
    [aux_sym_object_repeat1] = STATE(3990),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(1840),
    [anon_sym_export] = ACTIONS(1840),
    [anon_sym_STAR] = ACTIONS(1840),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1930),
    [anon_sym_type] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1842),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(1840),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1842),
    [anon_sym_SQUOTE] = ACTIONS(1842),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1842),
    [sym_private_property_identifier] = ACTIONS(1842),
    [anon_sym_static] = ACTIONS(1840),
    [anon_sym_readonly] = ACTIONS(1840),
    [anon_sym_get] = ACTIONS(1840),
    [anon_sym_set] = ACTIONS(1840),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(1840),
    [anon_sym_namespace] = ACTIONS(1840),
    [anon_sym_public] = ACTIONS(1840),
    [anon_sym_private] = ACTIONS(1840),
    [anon_sym_protected] = ACTIONS(1840),
    [anon_sym_override] = ACTIONS(1840),
    [anon_sym_module] = ACTIONS(1840),
    [anon_sym_any] = ACTIONS(1840),
    [anon_sym_number] = ACTIONS(1840),
    [anon_sym_boolean] = ACTIONS(1840),
    [anon_sym_string] = ACTIONS(1840),
    [anon_sym_symbol] = ACTIONS(1840),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [574] = {
    [aux_sym_import_path_segment_repeat1] = STATE(619),
    [aux_sym_js_import_statement_repeat1] = STATE(4072),
    [sym_identifier] = ACTIONS(2178),
    [anon_sym_export] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(2183),
    [anon_sym_COMMA] = ACTIONS(2185),
    [anon_sym_RBRACE] = ACTIONS(2183),
    [anon_sym_type] = ACTIONS(2181),
    [anon_sym_typeof] = ACTIONS(2181),
    [anon_sym_import] = ACTIONS(2181),
    [anon_sym_from] = ACTIONS(2187),
    [anon_sym_var] = ACTIONS(2181),
    [anon_sym_let] = ACTIONS(2181),
    [anon_sym_const] = ACTIONS(2181),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_else] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(2181),
    [anon_sym_switch] = ACTIONS(2181),
    [anon_sym_for] = ACTIONS(2181),
    [anon_sym_LPAREN] = ACTIONS(2183),
    [anon_sym_await] = ACTIONS(2181),
    [anon_sym_while] = ACTIONS(2181),
    [anon_sym_do] = ACTIONS(2181),
    [anon_sym_try] = ACTIONS(2181),
    [anon_sym_with] = ACTIONS(2181),
    [anon_sym_break] = ACTIONS(2181),
    [anon_sym_continue] = ACTIONS(2181),
    [anon_sym_debugger] = ACTIONS(2181),
    [anon_sym_return] = ACTIONS(2181),
    [anon_sym_throw] = ACTIONS(2181),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym_case] = ACTIONS(2181),
    [anon_sym_default] = ACTIONS(2181),
    [anon_sym_yield] = ACTIONS(2181),
    [anon_sym_EQ] = ACTIONS(2189),
    [anon_sym_LBRACK] = ACTIONS(2183),
    [anon_sym_LTtemplate_GT] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_class] = ACTIONS(2181),
    [anon_sym_async] = ACTIONS(2181),
    [anon_sym_function] = ACTIONS(2181),
    [anon_sym_new] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2178),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_void] = ACTIONS(2181),
    [anon_sym_delete] = ACTIONS(2181),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_DQUOTE] = ACTIONS(2183),
    [anon_sym_SQUOTE] = ACTIONS(2183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2183),
    [sym_number] = ACTIONS(2191),
    [sym_this] = ACTIONS(2181),
    [sym_super] = ACTIONS(2181),
    [sym_true] = ACTIONS(2181),
    [sym_false] = ACTIONS(2181),
    [sym_null] = ACTIONS(2181),
    [sym_undefined] = ACTIONS(2181),
    [anon_sym_AT] = ACTIONS(2183),
    [anon_sym_static] = ACTIONS(2181),
    [anon_sym_readonly] = ACTIONS(2181),
    [anon_sym_get] = ACTIONS(2181),
    [anon_sym_set] = ACTIONS(2181),
    [anon_sym_declare] = ACTIONS(2181),
    [anon_sym_namespace] = ACTIONS(2181),
    [anon_sym_public] = ACTIONS(2181),
    [anon_sym_private] = ACTIONS(2181),
    [anon_sym_protected] = ACTIONS(2181),
    [anon_sym_override] = ACTIONS(2181),
    [anon_sym_module] = ACTIONS(2181),
    [anon_sym_any] = ACTIONS(2181),
    [anon_sym_number] = ACTIONS(2181),
    [anon_sym_boolean] = ACTIONS(2181),
    [anon_sym_string] = ACTIONS(2181),
    [anon_sym_symbol] = ACTIONS(2181),
    [anon_sym_abstract] = ACTIONS(2181),
    [anon_sym_interface] = ACTIONS(2181),
    [anon_sym_enum] = ACTIONS(2181),
    [anon_sym_component] = ACTIONS(2181),
  },
  [575] = {
    [aux_sym_object_repeat1] = STATE(3936),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(1844),
    [anon_sym_export] = ACTIONS(1844),
    [anon_sym_STAR] = ACTIONS(1844),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1928),
    [anon_sym_type] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1846),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(1844),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1846),
    [anon_sym_SQUOTE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1846),
    [sym_private_property_identifier] = ACTIONS(1846),
    [anon_sym_static] = ACTIONS(1844),
    [anon_sym_readonly] = ACTIONS(1844),
    [anon_sym_get] = ACTIONS(1844),
    [anon_sym_set] = ACTIONS(1844),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(1844),
    [anon_sym_namespace] = ACTIONS(1844),
    [anon_sym_public] = ACTIONS(1844),
    [anon_sym_private] = ACTIONS(1844),
    [anon_sym_protected] = ACTIONS(1844),
    [anon_sym_override] = ACTIONS(1844),
    [anon_sym_module] = ACTIONS(1844),
    [anon_sym_any] = ACTIONS(1844),
    [anon_sym_number] = ACTIONS(1844),
    [anon_sym_boolean] = ACTIONS(1844),
    [anon_sym_string] = ACTIONS(1844),
    [anon_sym_symbol] = ACTIONS(1844),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [576] = {
    [aux_sym_object_repeat1] = STATE(3936),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(1840),
    [anon_sym_export] = ACTIONS(1840),
    [anon_sym_STAR] = ACTIONS(1840),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1928),
    [anon_sym_type] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1842),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(1840),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1842),
    [anon_sym_SQUOTE] = ACTIONS(1842),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1842),
    [sym_private_property_identifier] = ACTIONS(1842),
    [anon_sym_static] = ACTIONS(1840),
    [anon_sym_readonly] = ACTIONS(1840),
    [anon_sym_get] = ACTIONS(1840),
    [anon_sym_set] = ACTIONS(1840),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(1840),
    [anon_sym_namespace] = ACTIONS(1840),
    [anon_sym_public] = ACTIONS(1840),
    [anon_sym_private] = ACTIONS(1840),
    [anon_sym_protected] = ACTIONS(1840),
    [anon_sym_override] = ACTIONS(1840),
    [anon_sym_module] = ACTIONS(1840),
    [anon_sym_any] = ACTIONS(1840),
    [anon_sym_number] = ACTIONS(1840),
    [anon_sym_boolean] = ACTIONS(1840),
    [anon_sym_string] = ACTIONS(1840),
    [anon_sym_symbol] = ACTIONS(1840),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [577] = {
    [aux_sym_object_repeat1] = STATE(3936),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(1844),
    [anon_sym_export] = ACTIONS(1844),
    [anon_sym_STAR] = ACTIONS(1844),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1926),
    [anon_sym_type] = ACTIONS(1844),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1846),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(1844),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1846),
    [anon_sym_SQUOTE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1846),
    [sym_private_property_identifier] = ACTIONS(1846),
    [anon_sym_static] = ACTIONS(1844),
    [anon_sym_readonly] = ACTIONS(1844),
    [anon_sym_get] = ACTIONS(1844),
    [anon_sym_set] = ACTIONS(1844),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(1844),
    [anon_sym_namespace] = ACTIONS(1844),
    [anon_sym_public] = ACTIONS(1844),
    [anon_sym_private] = ACTIONS(1844),
    [anon_sym_protected] = ACTIONS(1844),
    [anon_sym_override] = ACTIONS(1844),
    [anon_sym_module] = ACTIONS(1844),
    [anon_sym_any] = ACTIONS(1844),
    [anon_sym_number] = ACTIONS(1844),
    [anon_sym_boolean] = ACTIONS(1844),
    [anon_sym_string] = ACTIONS(1844),
    [anon_sym_symbol] = ACTIONS(1844),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [578] = {
    [aux_sym_object_repeat1] = STATE(3936),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(1840),
    [anon_sym_export] = ACTIONS(1840),
    [anon_sym_STAR] = ACTIONS(1840),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1926),
    [anon_sym_type] = ACTIONS(1840),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(1842),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(1840),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(1842),
    [anon_sym_SQUOTE] = ACTIONS(1842),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1842),
    [sym_private_property_identifier] = ACTIONS(1842),
    [anon_sym_static] = ACTIONS(1840),
    [anon_sym_readonly] = ACTIONS(1840),
    [anon_sym_get] = ACTIONS(1840),
    [anon_sym_set] = ACTIONS(1840),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_declare] = ACTIONS(1840),
    [anon_sym_namespace] = ACTIONS(1840),
    [anon_sym_public] = ACTIONS(1840),
    [anon_sym_private] = ACTIONS(1840),
    [anon_sym_protected] = ACTIONS(1840),
    [anon_sym_override] = ACTIONS(1840),
    [anon_sym_module] = ACTIONS(1840),
    [anon_sym_any] = ACTIONS(1840),
    [anon_sym_number] = ACTIONS(1840),
    [anon_sym_boolean] = ACTIONS(1840),
    [anon_sym_string] = ACTIONS(1840),
    [anon_sym_symbol] = ACTIONS(1840),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [579] = {
    [sym_nested_identifier] = STATE(3002),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_new_component_expression] = STATE(1634),
    [sym_new_tagged_component_expression] = STATE(1634),
    [sym_new_tripple_tagged_component_expression] = STATE(1634),
    [sym_type_narrow] = STATE(4354),
    [sym_property_declaration] = STATE(1634),
    [sym_identifier_property_assignment] = STATE(1634),
    [sym_property_assignment] = STATE(1634),
    [sym_event_declaration] = STATE(1634),
    [sym_typed_method_declaration] = STATE(1634),
    [sym_listener_declaration] = STATE(1634),
    [aux_sym_new_component_body_repeat1] = STATE(581),
    [sym_identifier] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(2196),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_async] = ACTIONS(2022),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_prop] = ACTIONS(2200),
    [anon_sym_id] = ACTIONS(2038),
    [anon_sym_event] = ACTIONS(2040),
    [anon_sym_fn] = ACTIONS(2042),
    [anon_sym_on] = ACTIONS(2202),
  },
  [580] = {
    [sym_nested_identifier] = STATE(3002),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_new_component_expression] = STATE(1634),
    [sym_new_tagged_component_expression] = STATE(1634),
    [sym_new_tripple_tagged_component_expression] = STATE(1634),
    [sym_type_narrow] = STATE(4354),
    [sym_property_declaration] = STATE(1634),
    [sym_identifier_property_assignment] = STATE(1634),
    [sym_property_assignment] = STATE(1634),
    [sym_event_declaration] = STATE(1634),
    [sym_typed_method_declaration] = STATE(1634),
    [sym_listener_declaration] = STATE(1634),
    [aux_sym_new_component_body_repeat1] = STATE(581),
    [sym_identifier] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_async] = ACTIONS(2022),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_prop] = ACTIONS(2200),
    [anon_sym_id] = ACTIONS(2038),
    [anon_sym_event] = ACTIONS(2040),
    [anon_sym_fn] = ACTIONS(2042),
    [anon_sym_on] = ACTIONS(2202),
  },
  [581] = {
    [sym_nested_identifier] = STATE(3002),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_new_component_expression] = STATE(1634),
    [sym_new_tagged_component_expression] = STATE(1634),
    [sym_new_tripple_tagged_component_expression] = STATE(1634),
    [sym_type_narrow] = STATE(4354),
    [sym_property_declaration] = STATE(1634),
    [sym_identifier_property_assignment] = STATE(1634),
    [sym_property_assignment] = STATE(1634),
    [sym_event_declaration] = STATE(1634),
    [sym_typed_method_declaration] = STATE(1634),
    [sym_listener_declaration] = STATE(1634),
    [aux_sym_new_component_body_repeat1] = STATE(581),
    [sym_identifier] = ACTIONS(2206),
    [anon_sym_STAR] = ACTIONS(2209),
    [anon_sym_LBRACE] = ACTIONS(2212),
    [anon_sym_RBRACE] = ACTIONS(2215),
    [anon_sym_typeof] = ACTIONS(2217),
    [anon_sym_LPAREN] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2223),
    [anon_sym_LT] = ACTIONS(2226),
    [anon_sym_async] = ACTIONS(2229),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_AMP] = ACTIONS(2235),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_PLUS] = ACTIONS(2241),
    [anon_sym_DASH] = ACTIONS(2241),
    [anon_sym_void] = ACTIONS(2244),
    [anon_sym_DQUOTE] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2253),
    [sym_number] = ACTIONS(2256),
    [sym_this] = ACTIONS(2259),
    [sym_true] = ACTIONS(2262),
    [sym_false] = ACTIONS(2262),
    [sym_null] = ACTIONS(2262),
    [sym_undefined] = ACTIONS(2262),
    [anon_sym_static] = ACTIONS(2265),
    [anon_sym_readonly] = ACTIONS(2268),
    [anon_sym_QMARK] = ACTIONS(2271),
    [anon_sym_any] = ACTIONS(2244),
    [anon_sym_number] = ACTIONS(2244),
    [anon_sym_boolean] = ACTIONS(2244),
    [anon_sym_string] = ACTIONS(2244),
    [anon_sym_symbol] = ACTIONS(2244),
    [anon_sym_abstract] = ACTIONS(2274),
    [anon_sym_infer] = ACTIONS(2277),
    [anon_sym_keyof] = ACTIONS(2280),
    [anon_sym_unknown] = ACTIONS(2244),
    [anon_sym_never] = ACTIONS(2244),
    [anon_sym_object] = ACTIONS(2244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2283),
    [anon_sym_prop] = ACTIONS(2286),
    [anon_sym_id] = ACTIONS(2289),
    [anon_sym_event] = ACTIONS(2292),
    [anon_sym_fn] = ACTIONS(2295),
    [anon_sym_on] = ACTIONS(2298),
  },
  [582] = {
    [sym_nested_identifier] = STATE(3002),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_new_component_expression] = STATE(1634),
    [sym_new_tagged_component_expression] = STATE(1634),
    [sym_new_tripple_tagged_component_expression] = STATE(1634),
    [sym_type_narrow] = STATE(4354),
    [sym_property_declaration] = STATE(1634),
    [sym_identifier_property_assignment] = STATE(1634),
    [sym_property_assignment] = STATE(1634),
    [sym_event_declaration] = STATE(1634),
    [sym_typed_method_declaration] = STATE(1634),
    [sym_listener_declaration] = STATE(1634),
    [aux_sym_new_component_body_repeat1] = STATE(581),
    [sym_identifier] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(2301),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_async] = ACTIONS(2022),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_prop] = ACTIONS(2200),
    [anon_sym_id] = ACTIONS(2038),
    [anon_sym_event] = ACTIONS(2040),
    [anon_sym_fn] = ACTIONS(2042),
    [anon_sym_on] = ACTIONS(2202),
  },
  [583] = {
    [sym_nested_identifier] = STATE(3002),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_new_component_expression] = STATE(1634),
    [sym_new_tagged_component_expression] = STATE(1634),
    [sym_new_tripple_tagged_component_expression] = STATE(1634),
    [sym_type_narrow] = STATE(4354),
    [sym_property_declaration] = STATE(1634),
    [sym_identifier_property_assignment] = STATE(1634),
    [sym_property_assignment] = STATE(1634),
    [sym_event_declaration] = STATE(1634),
    [sym_typed_method_declaration] = STATE(1634),
    [sym_listener_declaration] = STATE(1634),
    [aux_sym_new_component_body_repeat1] = STATE(582),
    [sym_identifier] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(2303),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_async] = ACTIONS(2022),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_prop] = ACTIONS(2200),
    [anon_sym_id] = ACTIONS(2038),
    [anon_sym_event] = ACTIONS(2040),
    [anon_sym_fn] = ACTIONS(2042),
    [anon_sym_on] = ACTIONS(2202),
  },
  [584] = {
    [sym_nested_identifier] = STATE(3002),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_new_component_expression] = STATE(1634),
    [sym_new_tagged_component_expression] = STATE(1634),
    [sym_new_tripple_tagged_component_expression] = STATE(1634),
    [sym_type_narrow] = STATE(4354),
    [sym_property_declaration] = STATE(1634),
    [sym_identifier_property_assignment] = STATE(1634),
    [sym_property_assignment] = STATE(1634),
    [sym_event_declaration] = STATE(1634),
    [sym_typed_method_declaration] = STATE(1634),
    [sym_listener_declaration] = STATE(1634),
    [aux_sym_new_component_body_repeat1] = STATE(580),
    [sym_identifier] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(2305),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_async] = ACTIONS(2022),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_prop] = ACTIONS(2200),
    [anon_sym_id] = ACTIONS(2038),
    [anon_sym_event] = ACTIONS(2040),
    [anon_sym_fn] = ACTIONS(2042),
    [anon_sym_on] = ACTIONS(2202),
  },
  [585] = {
    [sym_nested_identifier] = STATE(3002),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_new_component_expression] = STATE(1634),
    [sym_new_tagged_component_expression] = STATE(1634),
    [sym_new_tripple_tagged_component_expression] = STATE(1634),
    [sym_type_narrow] = STATE(4354),
    [sym_property_declaration] = STATE(1634),
    [sym_identifier_property_assignment] = STATE(1634),
    [sym_property_assignment] = STATE(1634),
    [sym_event_declaration] = STATE(1634),
    [sym_typed_method_declaration] = STATE(1634),
    [sym_listener_declaration] = STATE(1634),
    [aux_sym_new_component_body_repeat1] = STATE(579),
    [sym_identifier] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(2307),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_async] = ACTIONS(2022),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_prop] = ACTIONS(2200),
    [anon_sym_id] = ACTIONS(2038),
    [anon_sym_event] = ACTIONS(2040),
    [anon_sym_fn] = ACTIONS(2042),
    [anon_sym_on] = ACTIONS(2202),
  },
  [586] = {
    [sym_nested_identifier] = STATE(3002),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_new_component_expression] = STATE(1634),
    [sym_new_tagged_component_expression] = STATE(1634),
    [sym_new_tripple_tagged_component_expression] = STATE(1634),
    [sym_type_narrow] = STATE(4354),
    [sym_property_declaration] = STATE(1634),
    [sym_identifier_property_assignment] = STATE(1634),
    [sym_property_assignment] = STATE(1634),
    [sym_event_declaration] = STATE(1634),
    [sym_typed_method_declaration] = STATE(1634),
    [sym_listener_declaration] = STATE(1634),
    [aux_sym_new_component_body_repeat1] = STATE(581),
    [sym_identifier] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(2309),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_async] = ACTIONS(2022),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_prop] = ACTIONS(2200),
    [anon_sym_id] = ACTIONS(2038),
    [anon_sym_event] = ACTIONS(2040),
    [anon_sym_fn] = ACTIONS(2042),
    [anon_sym_on] = ACTIONS(2202),
  },
  [587] = {
    [sym_nested_identifier] = STATE(3002),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_new_component_expression] = STATE(1634),
    [sym_new_tagged_component_expression] = STATE(1634),
    [sym_new_tripple_tagged_component_expression] = STATE(1634),
    [sym_type_narrow] = STATE(4354),
    [sym_property_declaration] = STATE(1634),
    [sym_identifier_property_assignment] = STATE(1634),
    [sym_property_assignment] = STATE(1634),
    [sym_event_declaration] = STATE(1634),
    [sym_typed_method_declaration] = STATE(1634),
    [sym_listener_declaration] = STATE(1634),
    [aux_sym_new_component_body_repeat1] = STATE(586),
    [sym_identifier] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(2311),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_async] = ACTIONS(2022),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_static] = ACTIONS(2198),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_prop] = ACTIONS(2200),
    [anon_sym_id] = ACTIONS(2038),
    [anon_sym_event] = ACTIONS(2040),
    [anon_sym_fn] = ACTIONS(2042),
    [anon_sym_on] = ACTIONS(2202),
  },
  [588] = {
    [sym__call_signature] = STATE(4721),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2313),
    [anon_sym_export] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_RBRACE] = ACTIONS(122),
    [anon_sym_type] = ACTIONS(2315),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_RPAREN] = ACTIONS(122),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(122),
    [anon_sym_EQ] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_RBRACK] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2315),
    [anon_sym_function] = ACTIONS(2317),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2315),
    [anon_sym_readonly] = ACTIONS(2315),
    [anon_sym_get] = ACTIONS(2315),
    [anon_sym_set] = ACTIONS(2315),
    [anon_sym_QMARK] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(2315),
    [anon_sym_namespace] = ACTIONS(2315),
    [anon_sym_public] = ACTIONS(2315),
    [anon_sym_private] = ACTIONS(2315),
    [anon_sym_protected] = ACTIONS(2315),
    [anon_sym_override] = ACTIONS(2315),
    [anon_sym_module] = ACTIONS(2315),
    [anon_sym_any] = ACTIONS(2315),
    [anon_sym_number] = ACTIONS(2315),
    [anon_sym_boolean] = ACTIONS(2315),
    [anon_sym_string] = ACTIONS(2315),
    [anon_sym_symbol] = ACTIONS(2315),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [589] = {
    [sym__call_signature] = STATE(4721),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2313),
    [anon_sym_export] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(1183),
    [anon_sym_RBRACE] = ACTIONS(1183),
    [anon_sym_type] = ACTIONS(2315),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_RPAREN] = ACTIONS(1183),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_RBRACK] = ACTIONS(1183),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2315),
    [anon_sym_function] = ACTIONS(2317),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2315),
    [anon_sym_readonly] = ACTIONS(2315),
    [anon_sym_get] = ACTIONS(2315),
    [anon_sym_set] = ACTIONS(2315),
    [anon_sym_QMARK] = ACTIONS(2319),
    [anon_sym_declare] = ACTIONS(2315),
    [anon_sym_namespace] = ACTIONS(2315),
    [anon_sym_public] = ACTIONS(2315),
    [anon_sym_private] = ACTIONS(2315),
    [anon_sym_protected] = ACTIONS(2315),
    [anon_sym_override] = ACTIONS(2315),
    [anon_sym_module] = ACTIONS(2315),
    [anon_sym_any] = ACTIONS(2315),
    [anon_sym_number] = ACTIONS(2315),
    [anon_sym_boolean] = ACTIONS(2315),
    [anon_sym_string] = ACTIONS(2315),
    [anon_sym_symbol] = ACTIONS(2315),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [590] = {
    [sym_catch_clause] = STATE(648),
    [sym_finally_clause] = STATE(853),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_export] = ACTIONS(2321),
    [anon_sym_LBRACE] = ACTIONS(2323),
    [anon_sym_RBRACE] = ACTIONS(2323),
    [anon_sym_type] = ACTIONS(2321),
    [anon_sym_typeof] = ACTIONS(2321),
    [anon_sym_import] = ACTIONS(2321),
    [anon_sym_var] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_const] = ACTIONS(2321),
    [anon_sym_BANG] = ACTIONS(2323),
    [anon_sym_else] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_switch] = ACTIONS(2321),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2323),
    [anon_sym_await] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [anon_sym_break] = ACTIONS(2321),
    [anon_sym_continue] = ACTIONS(2321),
    [anon_sym_debugger] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_throw] = ACTIONS(2321),
    [anon_sym_SEMI] = ACTIONS(2323),
    [anon_sym_case] = ACTIONS(2321),
    [anon_sym_default] = ACTIONS(2321),
    [anon_sym_catch] = ACTIONS(2325),
    [anon_sym_finally] = ACTIONS(2327),
    [anon_sym_yield] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LTtemplate_GT] = ACTIONS(2323),
    [anon_sym_LT] = ACTIONS(2321),
    [anon_sym_SLASH] = ACTIONS(2321),
    [anon_sym_class] = ACTIONS(2321),
    [anon_sym_async] = ACTIONS(2321),
    [anon_sym_function] = ACTIONS(2321),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_AMP] = ACTIONS(2323),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2323),
    [anon_sym_void] = ACTIONS(2321),
    [anon_sym_delete] = ACTIONS(2321),
    [anon_sym_PLUS_PLUS] = ACTIONS(2323),
    [anon_sym_DASH_DASH] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2323),
    [anon_sym_SQUOTE] = ACTIONS(2323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2323),
    [sym_number] = ACTIONS(2323),
    [sym_this] = ACTIONS(2321),
    [sym_super] = ACTIONS(2321),
    [sym_true] = ACTIONS(2321),
    [sym_false] = ACTIONS(2321),
    [sym_null] = ACTIONS(2321),
    [sym_undefined] = ACTIONS(2321),
    [anon_sym_AT] = ACTIONS(2323),
    [anon_sym_static] = ACTIONS(2321),
    [anon_sym_readonly] = ACTIONS(2321),
    [anon_sym_get] = ACTIONS(2321),
    [anon_sym_set] = ACTIONS(2321),
    [anon_sym_declare] = ACTIONS(2321),
    [anon_sym_namespace] = ACTIONS(2321),
    [anon_sym_public] = ACTIONS(2321),
    [anon_sym_private] = ACTIONS(2321),
    [anon_sym_protected] = ACTIONS(2321),
    [anon_sym_override] = ACTIONS(2321),
    [anon_sym_module] = ACTIONS(2321),
    [anon_sym_any] = ACTIONS(2321),
    [anon_sym_number] = ACTIONS(2321),
    [anon_sym_boolean] = ACTIONS(2321),
    [anon_sym_string] = ACTIONS(2321),
    [anon_sym_symbol] = ACTIONS(2321),
    [anon_sym_abstract] = ACTIONS(2321),
    [anon_sym_interface] = ACTIONS(2321),
    [anon_sym_enum] = ACTIONS(2321),
    [anon_sym_component] = ACTIONS(2321),
  },
  [591] = {
    [aux_sym_import_path_repeat1] = STATE(616),
    [sym_identifier] = ACTIONS(2329),
    [anon_sym_export] = ACTIONS(2329),
    [anon_sym_as] = ACTIONS(2329),
    [anon_sym_LBRACE] = ACTIONS(2331),
    [anon_sym_RBRACE] = ACTIONS(2331),
    [anon_sym_type] = ACTIONS(2329),
    [anon_sym_typeof] = ACTIONS(2329),
    [anon_sym_import] = ACTIONS(2329),
    [anon_sym_var] = ACTIONS(2329),
    [anon_sym_let] = ACTIONS(2329),
    [anon_sym_const] = ACTIONS(2329),
    [anon_sym_BANG] = ACTIONS(2331),
    [anon_sym_else] = ACTIONS(2329),
    [anon_sym_if] = ACTIONS(2329),
    [anon_sym_switch] = ACTIONS(2329),
    [anon_sym_for] = ACTIONS(2329),
    [anon_sym_LPAREN] = ACTIONS(2331),
    [anon_sym_await] = ACTIONS(2329),
    [anon_sym_while] = ACTIONS(2329),
    [anon_sym_do] = ACTIONS(2329),
    [anon_sym_try] = ACTIONS(2329),
    [anon_sym_with] = ACTIONS(2329),
    [anon_sym_break] = ACTIONS(2329),
    [anon_sym_continue] = ACTIONS(2329),
    [anon_sym_debugger] = ACTIONS(2329),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_throw] = ACTIONS(2329),
    [anon_sym_SEMI] = ACTIONS(2331),
    [anon_sym_case] = ACTIONS(2329),
    [anon_sym_default] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2329),
    [anon_sym_LBRACK] = ACTIONS(2331),
    [anon_sym_LTtemplate_GT] = ACTIONS(2331),
    [anon_sym_LT] = ACTIONS(2329),
    [anon_sym_SLASH] = ACTIONS(2329),
    [anon_sym_DOT] = ACTIONS(2333),
    [anon_sym_class] = ACTIONS(2329),
    [anon_sym_async] = ACTIONS(2329),
    [anon_sym_function] = ACTIONS(2329),
    [anon_sym_new] = ACTIONS(2329),
    [anon_sym_AMP] = ACTIONS(2331),
    [anon_sym_PLUS] = ACTIONS(2329),
    [anon_sym_DASH] = ACTIONS(2329),
    [anon_sym_TILDE] = ACTIONS(2331),
    [anon_sym_void] = ACTIONS(2329),
    [anon_sym_delete] = ACTIONS(2329),
    [anon_sym_PLUS_PLUS] = ACTIONS(2331),
    [anon_sym_DASH_DASH] = ACTIONS(2331),
    [anon_sym_DQUOTE] = ACTIONS(2331),
    [anon_sym_SQUOTE] = ACTIONS(2331),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2331),
    [sym_number] = ACTIONS(2331),
    [sym_this] = ACTIONS(2329),
    [sym_super] = ACTIONS(2329),
    [sym_true] = ACTIONS(2329),
    [sym_false] = ACTIONS(2329),
    [sym_null] = ACTIONS(2329),
    [sym_undefined] = ACTIONS(2329),
    [anon_sym_AT] = ACTIONS(2331),
    [anon_sym_static] = ACTIONS(2329),
    [anon_sym_readonly] = ACTIONS(2329),
    [anon_sym_get] = ACTIONS(2329),
    [anon_sym_set] = ACTIONS(2329),
    [anon_sym_declare] = ACTIONS(2329),
    [anon_sym_namespace] = ACTIONS(2329),
    [anon_sym_public] = ACTIONS(2329),
    [anon_sym_private] = ACTIONS(2329),
    [anon_sym_protected] = ACTIONS(2329),
    [anon_sym_override] = ACTIONS(2329),
    [anon_sym_module] = ACTIONS(2329),
    [anon_sym_any] = ACTIONS(2329),
    [anon_sym_number] = ACTIONS(2329),
    [anon_sym_boolean] = ACTIONS(2329),
    [anon_sym_string] = ACTIONS(2329),
    [anon_sym_symbol] = ACTIONS(2329),
    [anon_sym_abstract] = ACTIONS(2329),
    [anon_sym_interface] = ACTIONS(2329),
    [anon_sym_enum] = ACTIONS(2329),
    [anon_sym_component] = ACTIONS(2329),
  },
  [592] = {
    [aux_sym_import_path_repeat1] = STATE(591),
    [sym_identifier] = ACTIONS(2335),
    [anon_sym_export] = ACTIONS(2335),
    [anon_sym_as] = ACTIONS(2335),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_RBRACE] = ACTIONS(2337),
    [anon_sym_type] = ACTIONS(2335),
    [anon_sym_typeof] = ACTIONS(2335),
    [anon_sym_import] = ACTIONS(2335),
    [anon_sym_var] = ACTIONS(2335),
    [anon_sym_let] = ACTIONS(2335),
    [anon_sym_const] = ACTIONS(2335),
    [anon_sym_BANG] = ACTIONS(2337),
    [anon_sym_else] = ACTIONS(2335),
    [anon_sym_if] = ACTIONS(2335),
    [anon_sym_switch] = ACTIONS(2335),
    [anon_sym_for] = ACTIONS(2335),
    [anon_sym_LPAREN] = ACTIONS(2337),
    [anon_sym_await] = ACTIONS(2335),
    [anon_sym_while] = ACTIONS(2335),
    [anon_sym_do] = ACTIONS(2335),
    [anon_sym_try] = ACTIONS(2335),
    [anon_sym_with] = ACTIONS(2335),
    [anon_sym_break] = ACTIONS(2335),
    [anon_sym_continue] = ACTIONS(2335),
    [anon_sym_debugger] = ACTIONS(2335),
    [anon_sym_return] = ACTIONS(2335),
    [anon_sym_throw] = ACTIONS(2335),
    [anon_sym_SEMI] = ACTIONS(2337),
    [anon_sym_case] = ACTIONS(2335),
    [anon_sym_default] = ACTIONS(2335),
    [anon_sym_yield] = ACTIONS(2335),
    [anon_sym_LBRACK] = ACTIONS(2337),
    [anon_sym_LTtemplate_GT] = ACTIONS(2337),
    [anon_sym_LT] = ACTIONS(2335),
    [anon_sym_SLASH] = ACTIONS(2335),
    [anon_sym_DOT] = ACTIONS(2333),
    [anon_sym_class] = ACTIONS(2335),
    [anon_sym_async] = ACTIONS(2335),
    [anon_sym_function] = ACTIONS(2335),
    [anon_sym_new] = ACTIONS(2335),
    [anon_sym_AMP] = ACTIONS(2337),
    [anon_sym_PLUS] = ACTIONS(2335),
    [anon_sym_DASH] = ACTIONS(2335),
    [anon_sym_TILDE] = ACTIONS(2337),
    [anon_sym_void] = ACTIONS(2335),
    [anon_sym_delete] = ACTIONS(2335),
    [anon_sym_PLUS_PLUS] = ACTIONS(2337),
    [anon_sym_DASH_DASH] = ACTIONS(2337),
    [anon_sym_DQUOTE] = ACTIONS(2337),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2337),
    [sym_number] = ACTIONS(2337),
    [sym_this] = ACTIONS(2335),
    [sym_super] = ACTIONS(2335),
    [sym_true] = ACTIONS(2335),
    [sym_false] = ACTIONS(2335),
    [sym_null] = ACTIONS(2335),
    [sym_undefined] = ACTIONS(2335),
    [anon_sym_AT] = ACTIONS(2337),
    [anon_sym_static] = ACTIONS(2335),
    [anon_sym_readonly] = ACTIONS(2335),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
    [anon_sym_declare] = ACTIONS(2335),
    [anon_sym_namespace] = ACTIONS(2335),
    [anon_sym_public] = ACTIONS(2335),
    [anon_sym_private] = ACTIONS(2335),
    [anon_sym_protected] = ACTIONS(2335),
    [anon_sym_override] = ACTIONS(2335),
    [anon_sym_module] = ACTIONS(2335),
    [anon_sym_any] = ACTIONS(2335),
    [anon_sym_number] = ACTIONS(2335),
    [anon_sym_boolean] = ACTIONS(2335),
    [anon_sym_string] = ACTIONS(2335),
    [anon_sym_symbol] = ACTIONS(2335),
    [anon_sym_abstract] = ACTIONS(2335),
    [anon_sym_interface] = ACTIONS(2335),
    [anon_sym_enum] = ACTIONS(2335),
    [anon_sym_component] = ACTIONS(2335),
  },
  [593] = {
    [ts_builtin_sym_end] = ACTIONS(1548),
    [sym_identifier] = ACTIONS(1544),
    [anon_sym_export] = ACTIONS(1544),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_RBRACE] = ACTIONS(1548),
    [anon_sym_type] = ACTIONS(1544),
    [anon_sym_typeof] = ACTIONS(1544),
    [anon_sym_import] = ACTIONS(1544),
    [anon_sym_var] = ACTIONS(1544),
    [anon_sym_let] = ACTIONS(1544),
    [anon_sym_const] = ACTIONS(1544),
    [anon_sym_BANG] = ACTIONS(1548),
    [anon_sym_else] = ACTIONS(1544),
    [anon_sym_if] = ACTIONS(1544),
    [anon_sym_switch] = ACTIONS(1544),
    [anon_sym_for] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1548),
    [anon_sym_await] = ACTIONS(1544),
    [anon_sym_while] = ACTIONS(1544),
    [anon_sym_do] = ACTIONS(1544),
    [anon_sym_try] = ACTIONS(1544),
    [anon_sym_with] = ACTIONS(1544),
    [anon_sym_break] = ACTIONS(1544),
    [anon_sym_continue] = ACTIONS(1544),
    [anon_sym_debugger] = ACTIONS(1544),
    [anon_sym_return] = ACTIONS(1544),
    [anon_sym_throw] = ACTIONS(1544),
    [anon_sym_SEMI] = ACTIONS(1548),
    [anon_sym_case] = ACTIONS(1544),
    [anon_sym_default] = ACTIONS(1544),
    [anon_sym_yield] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_LTtemplate_GT] = ACTIONS(1548),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_SLASH] = ACTIONS(1544),
    [anon_sym_class] = ACTIONS(1544),
    [anon_sym_async] = ACTIONS(1544),
    [anon_sym_function] = ACTIONS(1544),
    [anon_sym_new] = ACTIONS(1544),
    [anon_sym_AMP] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1544),
    [anon_sym_TILDE] = ACTIONS(1548),
    [anon_sym_void] = ACTIONS(1544),
    [anon_sym_delete] = ACTIONS(1544),
    [anon_sym_PLUS_PLUS] = ACTIONS(1548),
    [anon_sym_DASH_DASH] = ACTIONS(1548),
    [anon_sym_DQUOTE] = ACTIONS(1548),
    [anon_sym_SQUOTE] = ACTIONS(1548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1548),
    [sym_number] = ACTIONS(1548),
    [sym_this] = ACTIONS(1544),
    [sym_super] = ACTIONS(1544),
    [sym_true] = ACTIONS(1544),
    [sym_false] = ACTIONS(1544),
    [sym_null] = ACTIONS(1544),
    [sym_undefined] = ACTIONS(1544),
    [anon_sym_AT] = ACTIONS(1548),
    [anon_sym_static] = ACTIONS(1544),
    [anon_sym_readonly] = ACTIONS(1544),
    [anon_sym_get] = ACTIONS(1544),
    [anon_sym_set] = ACTIONS(1544),
    [anon_sym_declare] = ACTIONS(1544),
    [anon_sym_namespace] = ACTIONS(1544),
    [anon_sym_public] = ACTIONS(1544),
    [anon_sym_private] = ACTIONS(1544),
    [anon_sym_protected] = ACTIONS(1544),
    [anon_sym_override] = ACTIONS(1544),
    [anon_sym_module] = ACTIONS(1544),
    [anon_sym_any] = ACTIONS(1544),
    [anon_sym_number] = ACTIONS(1544),
    [anon_sym_boolean] = ACTIONS(1544),
    [anon_sym_string] = ACTIONS(1544),
    [anon_sym_symbol] = ACTIONS(1544),
    [anon_sym_abstract] = ACTIONS(1544),
    [anon_sym_interface] = ACTIONS(1544),
    [anon_sym_enum] = ACTIONS(1544),
    [anon_sym_component] = ACTIONS(1544),
    [anon_sym_instance] = ACTIONS(1544),
    [sym__automatic_semicolon] = ACTIONS(1552),
  },
  [594] = {
    [ts_builtin_sym_end] = ACTIONS(1568),
    [sym_identifier] = ACTIONS(1564),
    [anon_sym_export] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(1568),
    [anon_sym_RBRACE] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1564),
    [anon_sym_typeof] = ACTIONS(1564),
    [anon_sym_import] = ACTIONS(1564),
    [anon_sym_var] = ACTIONS(1564),
    [anon_sym_let] = ACTIONS(1564),
    [anon_sym_const] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(1568),
    [anon_sym_else] = ACTIONS(1564),
    [anon_sym_if] = ACTIONS(1564),
    [anon_sym_switch] = ACTIONS(1564),
    [anon_sym_for] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(1568),
    [anon_sym_await] = ACTIONS(1564),
    [anon_sym_while] = ACTIONS(1564),
    [anon_sym_do] = ACTIONS(1564),
    [anon_sym_try] = ACTIONS(1564),
    [anon_sym_with] = ACTIONS(1564),
    [anon_sym_break] = ACTIONS(1564),
    [anon_sym_continue] = ACTIONS(1564),
    [anon_sym_debugger] = ACTIONS(1564),
    [anon_sym_return] = ACTIONS(1564),
    [anon_sym_throw] = ACTIONS(1564),
    [anon_sym_SEMI] = ACTIONS(1568),
    [anon_sym_case] = ACTIONS(1564),
    [anon_sym_default] = ACTIONS(1564),
    [anon_sym_yield] = ACTIONS(1564),
    [anon_sym_LBRACK] = ACTIONS(1568),
    [anon_sym_LTtemplate_GT] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(1564),
    [anon_sym_SLASH] = ACTIONS(1564),
    [anon_sym_class] = ACTIONS(1564),
    [anon_sym_async] = ACTIONS(1564),
    [anon_sym_function] = ACTIONS(1564),
    [anon_sym_new] = ACTIONS(1564),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_PLUS] = ACTIONS(1564),
    [anon_sym_DASH] = ACTIONS(1564),
    [anon_sym_TILDE] = ACTIONS(1568),
    [anon_sym_void] = ACTIONS(1564),
    [anon_sym_delete] = ACTIONS(1564),
    [anon_sym_PLUS_PLUS] = ACTIONS(1568),
    [anon_sym_DASH_DASH] = ACTIONS(1568),
    [anon_sym_DQUOTE] = ACTIONS(1568),
    [anon_sym_SQUOTE] = ACTIONS(1568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1568),
    [sym_number] = ACTIONS(1568),
    [sym_this] = ACTIONS(1564),
    [sym_super] = ACTIONS(1564),
    [sym_true] = ACTIONS(1564),
    [sym_false] = ACTIONS(1564),
    [sym_null] = ACTIONS(1564),
    [sym_undefined] = ACTIONS(1564),
    [anon_sym_AT] = ACTIONS(1568),
    [anon_sym_static] = ACTIONS(1564),
    [anon_sym_readonly] = ACTIONS(1564),
    [anon_sym_get] = ACTIONS(1564),
    [anon_sym_set] = ACTIONS(1564),
    [anon_sym_declare] = ACTIONS(1564),
    [anon_sym_namespace] = ACTIONS(1564),
    [anon_sym_public] = ACTIONS(1564),
    [anon_sym_private] = ACTIONS(1564),
    [anon_sym_protected] = ACTIONS(1564),
    [anon_sym_override] = ACTIONS(1564),
    [anon_sym_module] = ACTIONS(1564),
    [anon_sym_any] = ACTIONS(1564),
    [anon_sym_number] = ACTIONS(1564),
    [anon_sym_boolean] = ACTIONS(1564),
    [anon_sym_string] = ACTIONS(1564),
    [anon_sym_symbol] = ACTIONS(1564),
    [anon_sym_abstract] = ACTIONS(1564),
    [anon_sym_interface] = ACTIONS(1564),
    [anon_sym_enum] = ACTIONS(1564),
    [anon_sym_component] = ACTIONS(1564),
    [anon_sym_instance] = ACTIONS(1564),
    [sym__automatic_semicolon] = ACTIONS(1572),
  },
  [595] = {
    [ts_builtin_sym_end] = ACTIONS(1578),
    [sym_identifier] = ACTIONS(1574),
    [anon_sym_export] = ACTIONS(1574),
    [anon_sym_LBRACE] = ACTIONS(1578),
    [anon_sym_RBRACE] = ACTIONS(1578),
    [anon_sym_type] = ACTIONS(1574),
    [anon_sym_typeof] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(1574),
    [anon_sym_var] = ACTIONS(1574),
    [anon_sym_let] = ACTIONS(1574),
    [anon_sym_const] = ACTIONS(1574),
    [anon_sym_BANG] = ACTIONS(1578),
    [anon_sym_else] = ACTIONS(1574),
    [anon_sym_if] = ACTIONS(1574),
    [anon_sym_switch] = ACTIONS(1574),
    [anon_sym_for] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1578),
    [anon_sym_await] = ACTIONS(1574),
    [anon_sym_while] = ACTIONS(1574),
    [anon_sym_do] = ACTIONS(1574),
    [anon_sym_try] = ACTIONS(1574),
    [anon_sym_with] = ACTIONS(1574),
    [anon_sym_break] = ACTIONS(1574),
    [anon_sym_continue] = ACTIONS(1574),
    [anon_sym_debugger] = ACTIONS(1574),
    [anon_sym_return] = ACTIONS(1574),
    [anon_sym_throw] = ACTIONS(1574),
    [anon_sym_SEMI] = ACTIONS(1578),
    [anon_sym_case] = ACTIONS(1574),
    [anon_sym_default] = ACTIONS(1574),
    [anon_sym_yield] = ACTIONS(1574),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_LTtemplate_GT] = ACTIONS(1578),
    [anon_sym_LT] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1574),
    [anon_sym_class] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1574),
    [anon_sym_function] = ACTIONS(1574),
    [anon_sym_new] = ACTIONS(1574),
    [anon_sym_AMP] = ACTIONS(1578),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_TILDE] = ACTIONS(1578),
    [anon_sym_void] = ACTIONS(1574),
    [anon_sym_delete] = ACTIONS(1574),
    [anon_sym_PLUS_PLUS] = ACTIONS(1578),
    [anon_sym_DASH_DASH] = ACTIONS(1578),
    [anon_sym_DQUOTE] = ACTIONS(1578),
    [anon_sym_SQUOTE] = ACTIONS(1578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1578),
    [sym_number] = ACTIONS(1578),
    [sym_this] = ACTIONS(1574),
    [sym_super] = ACTIONS(1574),
    [sym_true] = ACTIONS(1574),
    [sym_false] = ACTIONS(1574),
    [sym_null] = ACTIONS(1574),
    [sym_undefined] = ACTIONS(1574),
    [anon_sym_AT] = ACTIONS(1578),
    [anon_sym_static] = ACTIONS(1574),
    [anon_sym_readonly] = ACTIONS(1574),
    [anon_sym_get] = ACTIONS(1574),
    [anon_sym_set] = ACTIONS(1574),
    [anon_sym_declare] = ACTIONS(1574),
    [anon_sym_namespace] = ACTIONS(1574),
    [anon_sym_public] = ACTIONS(1574),
    [anon_sym_private] = ACTIONS(1574),
    [anon_sym_protected] = ACTIONS(1574),
    [anon_sym_override] = ACTIONS(1574),
    [anon_sym_module] = ACTIONS(1574),
    [anon_sym_any] = ACTIONS(1574),
    [anon_sym_number] = ACTIONS(1574),
    [anon_sym_boolean] = ACTIONS(1574),
    [anon_sym_string] = ACTIONS(1574),
    [anon_sym_symbol] = ACTIONS(1574),
    [anon_sym_abstract] = ACTIONS(1574),
    [anon_sym_interface] = ACTIONS(1574),
    [anon_sym_enum] = ACTIONS(1574),
    [anon_sym_component] = ACTIONS(1574),
    [anon_sym_instance] = ACTIONS(1574),
    [sym__automatic_semicolon] = ACTIONS(1582),
  },
  [596] = {
    [ts_builtin_sym_end] = ACTIONS(1588),
    [sym_identifier] = ACTIONS(1584),
    [anon_sym_export] = ACTIONS(1584),
    [anon_sym_LBRACE] = ACTIONS(1588),
    [anon_sym_RBRACE] = ACTIONS(1588),
    [anon_sym_type] = ACTIONS(1584),
    [anon_sym_typeof] = ACTIONS(1584),
    [anon_sym_import] = ACTIONS(1584),
    [anon_sym_var] = ACTIONS(1584),
    [anon_sym_let] = ACTIONS(1584),
    [anon_sym_const] = ACTIONS(1584),
    [anon_sym_BANG] = ACTIONS(1588),
    [anon_sym_else] = ACTIONS(1584),
    [anon_sym_if] = ACTIONS(1584),
    [anon_sym_switch] = ACTIONS(1584),
    [anon_sym_for] = ACTIONS(1584),
    [anon_sym_LPAREN] = ACTIONS(1588),
    [anon_sym_await] = ACTIONS(1584),
    [anon_sym_while] = ACTIONS(1584),
    [anon_sym_do] = ACTIONS(1584),
    [anon_sym_try] = ACTIONS(1584),
    [anon_sym_with] = ACTIONS(1584),
    [anon_sym_break] = ACTIONS(1584),
    [anon_sym_continue] = ACTIONS(1584),
    [anon_sym_debugger] = ACTIONS(1584),
    [anon_sym_return] = ACTIONS(1584),
    [anon_sym_throw] = ACTIONS(1584),
    [anon_sym_SEMI] = ACTIONS(1588),
    [anon_sym_case] = ACTIONS(1584),
    [anon_sym_default] = ACTIONS(1584),
    [anon_sym_yield] = ACTIONS(1584),
    [anon_sym_LBRACK] = ACTIONS(1588),
    [anon_sym_LTtemplate_GT] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1584),
    [anon_sym_SLASH] = ACTIONS(1584),
    [anon_sym_class] = ACTIONS(1584),
    [anon_sym_async] = ACTIONS(1584),
    [anon_sym_function] = ACTIONS(1584),
    [anon_sym_new] = ACTIONS(1584),
    [anon_sym_AMP] = ACTIONS(1588),
    [anon_sym_PLUS] = ACTIONS(1584),
    [anon_sym_DASH] = ACTIONS(1584),
    [anon_sym_TILDE] = ACTIONS(1588),
    [anon_sym_void] = ACTIONS(1584),
    [anon_sym_delete] = ACTIONS(1584),
    [anon_sym_PLUS_PLUS] = ACTIONS(1588),
    [anon_sym_DASH_DASH] = ACTIONS(1588),
    [anon_sym_DQUOTE] = ACTIONS(1588),
    [anon_sym_SQUOTE] = ACTIONS(1588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1588),
    [sym_number] = ACTIONS(1588),
    [sym_this] = ACTIONS(1584),
    [sym_super] = ACTIONS(1584),
    [sym_true] = ACTIONS(1584),
    [sym_false] = ACTIONS(1584),
    [sym_null] = ACTIONS(1584),
    [sym_undefined] = ACTIONS(1584),
    [anon_sym_AT] = ACTIONS(1588),
    [anon_sym_static] = ACTIONS(1584),
    [anon_sym_readonly] = ACTIONS(1584),
    [anon_sym_get] = ACTIONS(1584),
    [anon_sym_set] = ACTIONS(1584),
    [anon_sym_declare] = ACTIONS(1584),
    [anon_sym_namespace] = ACTIONS(1584),
    [anon_sym_public] = ACTIONS(1584),
    [anon_sym_private] = ACTIONS(1584),
    [anon_sym_protected] = ACTIONS(1584),
    [anon_sym_override] = ACTIONS(1584),
    [anon_sym_module] = ACTIONS(1584),
    [anon_sym_any] = ACTIONS(1584),
    [anon_sym_number] = ACTIONS(1584),
    [anon_sym_boolean] = ACTIONS(1584),
    [anon_sym_string] = ACTIONS(1584),
    [anon_sym_symbol] = ACTIONS(1584),
    [anon_sym_abstract] = ACTIONS(1584),
    [anon_sym_interface] = ACTIONS(1584),
    [anon_sym_enum] = ACTIONS(1584),
    [anon_sym_component] = ACTIONS(1584),
    [anon_sym_instance] = ACTIONS(1584),
    [sym__automatic_semicolon] = ACTIONS(1592),
  },
  [597] = {
    [ts_builtin_sym_end] = ACTIONS(1396),
    [sym_identifier] = ACTIONS(1392),
    [anon_sym_export] = ACTIONS(1392),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_RBRACE] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(1392),
    [anon_sym_typeof] = ACTIONS(1392),
    [anon_sym_import] = ACTIONS(1392),
    [anon_sym_var] = ACTIONS(1392),
    [anon_sym_let] = ACTIONS(1392),
    [anon_sym_const] = ACTIONS(1392),
    [anon_sym_BANG] = ACTIONS(1396),
    [anon_sym_else] = ACTIONS(1392),
    [anon_sym_if] = ACTIONS(1392),
    [anon_sym_switch] = ACTIONS(1392),
    [anon_sym_for] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_await] = ACTIONS(1392),
    [anon_sym_while] = ACTIONS(1392),
    [anon_sym_do] = ACTIONS(1392),
    [anon_sym_try] = ACTIONS(1392),
    [anon_sym_with] = ACTIONS(1392),
    [anon_sym_break] = ACTIONS(1392),
    [anon_sym_continue] = ACTIONS(1392),
    [anon_sym_debugger] = ACTIONS(1392),
    [anon_sym_return] = ACTIONS(1392),
    [anon_sym_throw] = ACTIONS(1392),
    [anon_sym_SEMI] = ACTIONS(1396),
    [anon_sym_case] = ACTIONS(1392),
    [anon_sym_default] = ACTIONS(1392),
    [anon_sym_yield] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(1396),
    [anon_sym_LTtemplate_GT] = ACTIONS(1396),
    [anon_sym_LT] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1392),
    [anon_sym_class] = ACTIONS(1392),
    [anon_sym_async] = ACTIONS(1392),
    [anon_sym_function] = ACTIONS(1392),
    [anon_sym_new] = ACTIONS(1392),
    [anon_sym_AMP] = ACTIONS(1396),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_TILDE] = ACTIONS(1396),
    [anon_sym_void] = ACTIONS(1392),
    [anon_sym_delete] = ACTIONS(1392),
    [anon_sym_PLUS_PLUS] = ACTIONS(1396),
    [anon_sym_DASH_DASH] = ACTIONS(1396),
    [anon_sym_DQUOTE] = ACTIONS(1396),
    [anon_sym_SQUOTE] = ACTIONS(1396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1396),
    [sym_number] = ACTIONS(1396),
    [sym_this] = ACTIONS(1392),
    [sym_super] = ACTIONS(1392),
    [sym_true] = ACTIONS(1392),
    [sym_false] = ACTIONS(1392),
    [sym_null] = ACTIONS(1392),
    [sym_undefined] = ACTIONS(1392),
    [anon_sym_AT] = ACTIONS(1396),
    [anon_sym_static] = ACTIONS(1392),
    [anon_sym_readonly] = ACTIONS(1392),
    [anon_sym_get] = ACTIONS(1392),
    [anon_sym_set] = ACTIONS(1392),
    [anon_sym_declare] = ACTIONS(1392),
    [anon_sym_namespace] = ACTIONS(1392),
    [anon_sym_public] = ACTIONS(1392),
    [anon_sym_private] = ACTIONS(1392),
    [anon_sym_protected] = ACTIONS(1392),
    [anon_sym_override] = ACTIONS(1392),
    [anon_sym_module] = ACTIONS(1392),
    [anon_sym_any] = ACTIONS(1392),
    [anon_sym_number] = ACTIONS(1392),
    [anon_sym_boolean] = ACTIONS(1392),
    [anon_sym_string] = ACTIONS(1392),
    [anon_sym_symbol] = ACTIONS(1392),
    [anon_sym_abstract] = ACTIONS(1392),
    [anon_sym_interface] = ACTIONS(1392),
    [anon_sym_enum] = ACTIONS(1392),
    [anon_sym_component] = ACTIONS(1392),
    [anon_sym_instance] = ACTIONS(1392),
    [sym__automatic_semicolon] = ACTIONS(1400),
  },
  [598] = {
    [sym__call_signature] = STATE(4874),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2339),
    [anon_sym_export] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(65),
    [anon_sym_type] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2341),
    [anon_sym_function] = ACTIONS(2343),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2341),
    [anon_sym_readonly] = ACTIONS(2341),
    [anon_sym_get] = ACTIONS(2341),
    [anon_sym_set] = ACTIONS(2341),
    [anon_sym_declare] = ACTIONS(2341),
    [anon_sym_namespace] = ACTIONS(2341),
    [anon_sym_public] = ACTIONS(2341),
    [anon_sym_private] = ACTIONS(2341),
    [anon_sym_protected] = ACTIONS(2341),
    [anon_sym_override] = ACTIONS(2341),
    [anon_sym_module] = ACTIONS(2341),
    [anon_sym_any] = ACTIONS(2341),
    [anon_sym_number] = ACTIONS(2341),
    [anon_sym_boolean] = ACTIONS(2341),
    [anon_sym_string] = ACTIONS(2341),
    [anon_sym_symbol] = ACTIONS(2341),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [599] = {
    [sym__call_signature] = STATE(4874),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2339),
    [anon_sym_export] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(65),
    [anon_sym_type] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1938),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2341),
    [anon_sym_function] = ACTIONS(2343),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2341),
    [anon_sym_readonly] = ACTIONS(2341),
    [anon_sym_get] = ACTIONS(2341),
    [anon_sym_set] = ACTIONS(2341),
    [anon_sym_declare] = ACTIONS(2341),
    [anon_sym_namespace] = ACTIONS(2341),
    [anon_sym_public] = ACTIONS(2341),
    [anon_sym_private] = ACTIONS(2341),
    [anon_sym_protected] = ACTIONS(2341),
    [anon_sym_override] = ACTIONS(2341),
    [anon_sym_module] = ACTIONS(2341),
    [anon_sym_any] = ACTIONS(2341),
    [anon_sym_number] = ACTIONS(2341),
    [anon_sym_boolean] = ACTIONS(2341),
    [anon_sym_string] = ACTIONS(2341),
    [anon_sym_symbol] = ACTIONS(2341),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [600] = {
    [ts_builtin_sym_end] = ACTIONS(1386),
    [sym_identifier] = ACTIONS(1382),
    [anon_sym_export] = ACTIONS(1382),
    [anon_sym_LBRACE] = ACTIONS(1386),
    [anon_sym_RBRACE] = ACTIONS(1386),
    [anon_sym_type] = ACTIONS(1382),
    [anon_sym_typeof] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(1382),
    [anon_sym_var] = ACTIONS(1382),
    [anon_sym_let] = ACTIONS(1382),
    [anon_sym_const] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1386),
    [anon_sym_else] = ACTIONS(1382),
    [anon_sym_if] = ACTIONS(1382),
    [anon_sym_switch] = ACTIONS(1382),
    [anon_sym_for] = ACTIONS(1382),
    [anon_sym_LPAREN] = ACTIONS(1386),
    [anon_sym_await] = ACTIONS(1382),
    [anon_sym_while] = ACTIONS(1382),
    [anon_sym_do] = ACTIONS(1382),
    [anon_sym_try] = ACTIONS(1382),
    [anon_sym_with] = ACTIONS(1382),
    [anon_sym_break] = ACTIONS(1382),
    [anon_sym_continue] = ACTIONS(1382),
    [anon_sym_debugger] = ACTIONS(1382),
    [anon_sym_return] = ACTIONS(1382),
    [anon_sym_throw] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1386),
    [anon_sym_case] = ACTIONS(1382),
    [anon_sym_default] = ACTIONS(1382),
    [anon_sym_yield] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(1386),
    [anon_sym_LTtemplate_GT] = ACTIONS(1386),
    [anon_sym_LT] = ACTIONS(1382),
    [anon_sym_SLASH] = ACTIONS(1382),
    [anon_sym_class] = ACTIONS(1382),
    [anon_sym_async] = ACTIONS(1382),
    [anon_sym_function] = ACTIONS(1382),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(1382),
    [anon_sym_DASH] = ACTIONS(1382),
    [anon_sym_TILDE] = ACTIONS(1386),
    [anon_sym_void] = ACTIONS(1382),
    [anon_sym_delete] = ACTIONS(1382),
    [anon_sym_PLUS_PLUS] = ACTIONS(1386),
    [anon_sym_DASH_DASH] = ACTIONS(1386),
    [anon_sym_DQUOTE] = ACTIONS(1386),
    [anon_sym_SQUOTE] = ACTIONS(1386),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1386),
    [sym_number] = ACTIONS(1386),
    [sym_this] = ACTIONS(1382),
    [sym_super] = ACTIONS(1382),
    [sym_true] = ACTIONS(1382),
    [sym_false] = ACTIONS(1382),
    [sym_null] = ACTIONS(1382),
    [sym_undefined] = ACTIONS(1382),
    [anon_sym_AT] = ACTIONS(1386),
    [anon_sym_static] = ACTIONS(1382),
    [anon_sym_readonly] = ACTIONS(1382),
    [anon_sym_get] = ACTIONS(1382),
    [anon_sym_set] = ACTIONS(1382),
    [anon_sym_declare] = ACTIONS(1382),
    [anon_sym_namespace] = ACTIONS(1382),
    [anon_sym_public] = ACTIONS(1382),
    [anon_sym_private] = ACTIONS(1382),
    [anon_sym_protected] = ACTIONS(1382),
    [anon_sym_override] = ACTIONS(1382),
    [anon_sym_module] = ACTIONS(1382),
    [anon_sym_any] = ACTIONS(1382),
    [anon_sym_number] = ACTIONS(1382),
    [anon_sym_boolean] = ACTIONS(1382),
    [anon_sym_string] = ACTIONS(1382),
    [anon_sym_symbol] = ACTIONS(1382),
    [anon_sym_abstract] = ACTIONS(1382),
    [anon_sym_interface] = ACTIONS(1382),
    [anon_sym_enum] = ACTIONS(1382),
    [anon_sym_component] = ACTIONS(1382),
    [anon_sym_instance] = ACTIONS(1382),
    [sym__automatic_semicolon] = ACTIONS(1390),
  },
  [601] = {
    [aux_sym_import_path_repeat1] = STATE(616),
    [sym_identifier] = ACTIONS(2345),
    [anon_sym_export] = ACTIONS(2345),
    [anon_sym_as] = ACTIONS(2345),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_RBRACE] = ACTIONS(2347),
    [anon_sym_type] = ACTIONS(2345),
    [anon_sym_typeof] = ACTIONS(2345),
    [anon_sym_import] = ACTIONS(2345),
    [anon_sym_var] = ACTIONS(2345),
    [anon_sym_let] = ACTIONS(2345),
    [anon_sym_const] = ACTIONS(2345),
    [anon_sym_BANG] = ACTIONS(2347),
    [anon_sym_else] = ACTIONS(2345),
    [anon_sym_if] = ACTIONS(2345),
    [anon_sym_switch] = ACTIONS(2345),
    [anon_sym_for] = ACTIONS(2345),
    [anon_sym_LPAREN] = ACTIONS(2347),
    [anon_sym_await] = ACTIONS(2345),
    [anon_sym_while] = ACTIONS(2345),
    [anon_sym_do] = ACTIONS(2345),
    [anon_sym_try] = ACTIONS(2345),
    [anon_sym_with] = ACTIONS(2345),
    [anon_sym_break] = ACTIONS(2345),
    [anon_sym_continue] = ACTIONS(2345),
    [anon_sym_debugger] = ACTIONS(2345),
    [anon_sym_return] = ACTIONS(2345),
    [anon_sym_throw] = ACTIONS(2345),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_case] = ACTIONS(2345),
    [anon_sym_default] = ACTIONS(2345),
    [anon_sym_yield] = ACTIONS(2345),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_LTtemplate_GT] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2345),
    [anon_sym_SLASH] = ACTIONS(2345),
    [anon_sym_DOT] = ACTIONS(2333),
    [anon_sym_class] = ACTIONS(2345),
    [anon_sym_async] = ACTIONS(2345),
    [anon_sym_function] = ACTIONS(2345),
    [anon_sym_new] = ACTIONS(2345),
    [anon_sym_AMP] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2345),
    [anon_sym_DASH] = ACTIONS(2345),
    [anon_sym_TILDE] = ACTIONS(2347),
    [anon_sym_void] = ACTIONS(2345),
    [anon_sym_delete] = ACTIONS(2345),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [anon_sym_DQUOTE] = ACTIONS(2347),
    [anon_sym_SQUOTE] = ACTIONS(2347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2347),
    [sym_number] = ACTIONS(2347),
    [sym_this] = ACTIONS(2345),
    [sym_super] = ACTIONS(2345),
    [sym_true] = ACTIONS(2345),
    [sym_false] = ACTIONS(2345),
    [sym_null] = ACTIONS(2345),
    [sym_undefined] = ACTIONS(2345),
    [anon_sym_AT] = ACTIONS(2347),
    [anon_sym_static] = ACTIONS(2345),
    [anon_sym_readonly] = ACTIONS(2345),
    [anon_sym_get] = ACTIONS(2345),
    [anon_sym_set] = ACTIONS(2345),
    [anon_sym_declare] = ACTIONS(2345),
    [anon_sym_namespace] = ACTIONS(2345),
    [anon_sym_public] = ACTIONS(2345),
    [anon_sym_private] = ACTIONS(2345),
    [anon_sym_protected] = ACTIONS(2345),
    [anon_sym_override] = ACTIONS(2345),
    [anon_sym_module] = ACTIONS(2345),
    [anon_sym_any] = ACTIONS(2345),
    [anon_sym_number] = ACTIONS(2345),
    [anon_sym_boolean] = ACTIONS(2345),
    [anon_sym_string] = ACTIONS(2345),
    [anon_sym_symbol] = ACTIONS(2345),
    [anon_sym_abstract] = ACTIONS(2345),
    [anon_sym_interface] = ACTIONS(2345),
    [anon_sym_enum] = ACTIONS(2345),
    [anon_sym_component] = ACTIONS(2345),
  },
  [602] = {
    [ts_builtin_sym_end] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(1554),
    [anon_sym_export] = ACTIONS(1554),
    [anon_sym_LBRACE] = ACTIONS(1558),
    [anon_sym_RBRACE] = ACTIONS(1558),
    [anon_sym_type] = ACTIONS(1554),
    [anon_sym_typeof] = ACTIONS(1554),
    [anon_sym_import] = ACTIONS(1554),
    [anon_sym_var] = ACTIONS(1554),
    [anon_sym_let] = ACTIONS(1554),
    [anon_sym_const] = ACTIONS(1554),
    [anon_sym_BANG] = ACTIONS(1558),
    [anon_sym_else] = ACTIONS(1554),
    [anon_sym_if] = ACTIONS(1554),
    [anon_sym_switch] = ACTIONS(1554),
    [anon_sym_for] = ACTIONS(1554),
    [anon_sym_LPAREN] = ACTIONS(1558),
    [anon_sym_await] = ACTIONS(1554),
    [anon_sym_while] = ACTIONS(1554),
    [anon_sym_do] = ACTIONS(1554),
    [anon_sym_try] = ACTIONS(1554),
    [anon_sym_with] = ACTIONS(1554),
    [anon_sym_break] = ACTIONS(1554),
    [anon_sym_continue] = ACTIONS(1554),
    [anon_sym_debugger] = ACTIONS(1554),
    [anon_sym_return] = ACTIONS(1554),
    [anon_sym_throw] = ACTIONS(1554),
    [anon_sym_SEMI] = ACTIONS(1558),
    [anon_sym_case] = ACTIONS(1554),
    [anon_sym_default] = ACTIONS(1554),
    [anon_sym_yield] = ACTIONS(1554),
    [anon_sym_LBRACK] = ACTIONS(1558),
    [anon_sym_LTtemplate_GT] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1554),
    [anon_sym_SLASH] = ACTIONS(1554),
    [anon_sym_class] = ACTIONS(1554),
    [anon_sym_async] = ACTIONS(1554),
    [anon_sym_function] = ACTIONS(1554),
    [anon_sym_new] = ACTIONS(1554),
    [anon_sym_AMP] = ACTIONS(1558),
    [anon_sym_PLUS] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1554),
    [anon_sym_TILDE] = ACTIONS(1558),
    [anon_sym_void] = ACTIONS(1554),
    [anon_sym_delete] = ACTIONS(1554),
    [anon_sym_PLUS_PLUS] = ACTIONS(1558),
    [anon_sym_DASH_DASH] = ACTIONS(1558),
    [anon_sym_DQUOTE] = ACTIONS(1558),
    [anon_sym_SQUOTE] = ACTIONS(1558),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1558),
    [sym_number] = ACTIONS(1558),
    [sym_this] = ACTIONS(1554),
    [sym_super] = ACTIONS(1554),
    [sym_true] = ACTIONS(1554),
    [sym_false] = ACTIONS(1554),
    [sym_null] = ACTIONS(1554),
    [sym_undefined] = ACTIONS(1554),
    [anon_sym_AT] = ACTIONS(1558),
    [anon_sym_static] = ACTIONS(1554),
    [anon_sym_readonly] = ACTIONS(1554),
    [anon_sym_get] = ACTIONS(1554),
    [anon_sym_set] = ACTIONS(1554),
    [anon_sym_declare] = ACTIONS(1554),
    [anon_sym_namespace] = ACTIONS(1554),
    [anon_sym_public] = ACTIONS(1554),
    [anon_sym_private] = ACTIONS(1554),
    [anon_sym_protected] = ACTIONS(1554),
    [anon_sym_override] = ACTIONS(1554),
    [anon_sym_module] = ACTIONS(1554),
    [anon_sym_any] = ACTIONS(1554),
    [anon_sym_number] = ACTIONS(1554),
    [anon_sym_boolean] = ACTIONS(1554),
    [anon_sym_string] = ACTIONS(1554),
    [anon_sym_symbol] = ACTIONS(1554),
    [anon_sym_abstract] = ACTIONS(1554),
    [anon_sym_interface] = ACTIONS(1554),
    [anon_sym_enum] = ACTIONS(1554),
    [anon_sym_component] = ACTIONS(1554),
    [anon_sym_instance] = ACTIONS(1554),
    [sym__automatic_semicolon] = ACTIONS(1562),
  },
  [603] = {
    [ts_builtin_sym_end] = ACTIONS(1660),
    [sym_identifier] = ACTIONS(1656),
    [anon_sym_export] = ACTIONS(1656),
    [anon_sym_LBRACE] = ACTIONS(1660),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [anon_sym_type] = ACTIONS(1656),
    [anon_sym_typeof] = ACTIONS(1656),
    [anon_sym_import] = ACTIONS(1656),
    [anon_sym_var] = ACTIONS(1656),
    [anon_sym_let] = ACTIONS(1656),
    [anon_sym_const] = ACTIONS(1656),
    [anon_sym_BANG] = ACTIONS(1660),
    [anon_sym_else] = ACTIONS(1656),
    [anon_sym_if] = ACTIONS(1656),
    [anon_sym_switch] = ACTIONS(1656),
    [anon_sym_for] = ACTIONS(1656),
    [anon_sym_LPAREN] = ACTIONS(1660),
    [anon_sym_await] = ACTIONS(1656),
    [anon_sym_while] = ACTIONS(1656),
    [anon_sym_do] = ACTIONS(1656),
    [anon_sym_try] = ACTIONS(1656),
    [anon_sym_with] = ACTIONS(1656),
    [anon_sym_break] = ACTIONS(1656),
    [anon_sym_continue] = ACTIONS(1656),
    [anon_sym_debugger] = ACTIONS(1656),
    [anon_sym_return] = ACTIONS(1656),
    [anon_sym_throw] = ACTIONS(1656),
    [anon_sym_SEMI] = ACTIONS(1660),
    [anon_sym_case] = ACTIONS(1656),
    [anon_sym_default] = ACTIONS(1656),
    [anon_sym_yield] = ACTIONS(1656),
    [anon_sym_LBRACK] = ACTIONS(1660),
    [anon_sym_LTtemplate_GT] = ACTIONS(1660),
    [anon_sym_LT] = ACTIONS(1656),
    [anon_sym_SLASH] = ACTIONS(1656),
    [anon_sym_class] = ACTIONS(1656),
    [anon_sym_async] = ACTIONS(1656),
    [anon_sym_function] = ACTIONS(1656),
    [anon_sym_new] = ACTIONS(1656),
    [anon_sym_AMP] = ACTIONS(1660),
    [anon_sym_PLUS] = ACTIONS(1656),
    [anon_sym_DASH] = ACTIONS(1656),
    [anon_sym_TILDE] = ACTIONS(1660),
    [anon_sym_void] = ACTIONS(1656),
    [anon_sym_delete] = ACTIONS(1656),
    [anon_sym_PLUS_PLUS] = ACTIONS(1660),
    [anon_sym_DASH_DASH] = ACTIONS(1660),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_SQUOTE] = ACTIONS(1660),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [sym_number] = ACTIONS(1660),
    [sym_this] = ACTIONS(1656),
    [sym_super] = ACTIONS(1656),
    [sym_true] = ACTIONS(1656),
    [sym_false] = ACTIONS(1656),
    [sym_null] = ACTIONS(1656),
    [sym_undefined] = ACTIONS(1656),
    [anon_sym_AT] = ACTIONS(1660),
    [anon_sym_static] = ACTIONS(1656),
    [anon_sym_readonly] = ACTIONS(1656),
    [anon_sym_get] = ACTIONS(1656),
    [anon_sym_set] = ACTIONS(1656),
    [anon_sym_declare] = ACTIONS(1656),
    [anon_sym_namespace] = ACTIONS(1656),
    [anon_sym_public] = ACTIONS(1656),
    [anon_sym_private] = ACTIONS(1656),
    [anon_sym_protected] = ACTIONS(1656),
    [anon_sym_override] = ACTIONS(1656),
    [anon_sym_module] = ACTIONS(1656),
    [anon_sym_any] = ACTIONS(1656),
    [anon_sym_number] = ACTIONS(1656),
    [anon_sym_boolean] = ACTIONS(1656),
    [anon_sym_string] = ACTIONS(1656),
    [anon_sym_symbol] = ACTIONS(1656),
    [anon_sym_abstract] = ACTIONS(1656),
    [anon_sym_interface] = ACTIONS(1656),
    [anon_sym_enum] = ACTIONS(1656),
    [anon_sym_component] = ACTIONS(1656),
    [anon_sym_instance] = ACTIONS(1656),
    [sym__automatic_semicolon] = ACTIONS(1664),
  },
  [604] = {
    [ts_builtin_sym_end] = ACTIONS(1696),
    [sym_identifier] = ACTIONS(1692),
    [anon_sym_export] = ACTIONS(1692),
    [anon_sym_LBRACE] = ACTIONS(1696),
    [anon_sym_RBRACE] = ACTIONS(1696),
    [anon_sym_type] = ACTIONS(1692),
    [anon_sym_typeof] = ACTIONS(1692),
    [anon_sym_import] = ACTIONS(1692),
    [anon_sym_var] = ACTIONS(1692),
    [anon_sym_let] = ACTIONS(1692),
    [anon_sym_const] = ACTIONS(1692),
    [anon_sym_BANG] = ACTIONS(1696),
    [anon_sym_else] = ACTIONS(1692),
    [anon_sym_if] = ACTIONS(1692),
    [anon_sym_switch] = ACTIONS(1692),
    [anon_sym_for] = ACTIONS(1692),
    [anon_sym_LPAREN] = ACTIONS(1696),
    [anon_sym_await] = ACTIONS(1692),
    [anon_sym_while] = ACTIONS(1692),
    [anon_sym_do] = ACTIONS(1692),
    [anon_sym_try] = ACTIONS(1692),
    [anon_sym_with] = ACTIONS(1692),
    [anon_sym_break] = ACTIONS(1692),
    [anon_sym_continue] = ACTIONS(1692),
    [anon_sym_debugger] = ACTIONS(1692),
    [anon_sym_return] = ACTIONS(1692),
    [anon_sym_throw] = ACTIONS(1692),
    [anon_sym_SEMI] = ACTIONS(1696),
    [anon_sym_case] = ACTIONS(1692),
    [anon_sym_default] = ACTIONS(1692),
    [anon_sym_yield] = ACTIONS(1692),
    [anon_sym_LBRACK] = ACTIONS(1696),
    [anon_sym_LTtemplate_GT] = ACTIONS(1696),
    [anon_sym_LT] = ACTIONS(1692),
    [anon_sym_SLASH] = ACTIONS(1692),
    [anon_sym_class] = ACTIONS(1692),
    [anon_sym_async] = ACTIONS(1692),
    [anon_sym_function] = ACTIONS(1692),
    [anon_sym_new] = ACTIONS(1692),
    [anon_sym_AMP] = ACTIONS(1696),
    [anon_sym_PLUS] = ACTIONS(1692),
    [anon_sym_DASH] = ACTIONS(1692),
    [anon_sym_TILDE] = ACTIONS(1696),
    [anon_sym_void] = ACTIONS(1692),
    [anon_sym_delete] = ACTIONS(1692),
    [anon_sym_PLUS_PLUS] = ACTIONS(1696),
    [anon_sym_DASH_DASH] = ACTIONS(1696),
    [anon_sym_DQUOTE] = ACTIONS(1696),
    [anon_sym_SQUOTE] = ACTIONS(1696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1696),
    [sym_number] = ACTIONS(1696),
    [sym_this] = ACTIONS(1692),
    [sym_super] = ACTIONS(1692),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_null] = ACTIONS(1692),
    [sym_undefined] = ACTIONS(1692),
    [anon_sym_AT] = ACTIONS(1696),
    [anon_sym_static] = ACTIONS(1692),
    [anon_sym_readonly] = ACTIONS(1692),
    [anon_sym_get] = ACTIONS(1692),
    [anon_sym_set] = ACTIONS(1692),
    [anon_sym_declare] = ACTIONS(1692),
    [anon_sym_namespace] = ACTIONS(1692),
    [anon_sym_public] = ACTIONS(1692),
    [anon_sym_private] = ACTIONS(1692),
    [anon_sym_protected] = ACTIONS(1692),
    [anon_sym_override] = ACTIONS(1692),
    [anon_sym_module] = ACTIONS(1692),
    [anon_sym_any] = ACTIONS(1692),
    [anon_sym_number] = ACTIONS(1692),
    [anon_sym_boolean] = ACTIONS(1692),
    [anon_sym_string] = ACTIONS(1692),
    [anon_sym_symbol] = ACTIONS(1692),
    [anon_sym_abstract] = ACTIONS(1692),
    [anon_sym_interface] = ACTIONS(1692),
    [anon_sym_enum] = ACTIONS(1692),
    [anon_sym_component] = ACTIONS(1692),
    [anon_sym_instance] = ACTIONS(1692),
    [sym__automatic_semicolon] = ACTIONS(1700),
  },
  [605] = {
    [ts_builtin_sym_end] = ACTIONS(1598),
    [sym_identifier] = ACTIONS(1594),
    [anon_sym_export] = ACTIONS(1594),
    [anon_sym_LBRACE] = ACTIONS(1598),
    [anon_sym_RBRACE] = ACTIONS(1598),
    [anon_sym_type] = ACTIONS(1594),
    [anon_sym_typeof] = ACTIONS(1594),
    [anon_sym_import] = ACTIONS(1594),
    [anon_sym_var] = ACTIONS(1594),
    [anon_sym_let] = ACTIONS(1594),
    [anon_sym_const] = ACTIONS(1594),
    [anon_sym_BANG] = ACTIONS(1598),
    [anon_sym_else] = ACTIONS(1594),
    [anon_sym_if] = ACTIONS(1594),
    [anon_sym_switch] = ACTIONS(1594),
    [anon_sym_for] = ACTIONS(1594),
    [anon_sym_LPAREN] = ACTIONS(1598),
    [anon_sym_await] = ACTIONS(1594),
    [anon_sym_while] = ACTIONS(1594),
    [anon_sym_do] = ACTIONS(1594),
    [anon_sym_try] = ACTIONS(1594),
    [anon_sym_with] = ACTIONS(1594),
    [anon_sym_break] = ACTIONS(1594),
    [anon_sym_continue] = ACTIONS(1594),
    [anon_sym_debugger] = ACTIONS(1594),
    [anon_sym_return] = ACTIONS(1594),
    [anon_sym_throw] = ACTIONS(1594),
    [anon_sym_SEMI] = ACTIONS(1598),
    [anon_sym_case] = ACTIONS(1594),
    [anon_sym_default] = ACTIONS(1594),
    [anon_sym_yield] = ACTIONS(1594),
    [anon_sym_LBRACK] = ACTIONS(1598),
    [anon_sym_LTtemplate_GT] = ACTIONS(1598),
    [anon_sym_LT] = ACTIONS(1594),
    [anon_sym_SLASH] = ACTIONS(1594),
    [anon_sym_class] = ACTIONS(1594),
    [anon_sym_async] = ACTIONS(1594),
    [anon_sym_function] = ACTIONS(1594),
    [anon_sym_new] = ACTIONS(1594),
    [anon_sym_AMP] = ACTIONS(1598),
    [anon_sym_PLUS] = ACTIONS(1594),
    [anon_sym_DASH] = ACTIONS(1594),
    [anon_sym_TILDE] = ACTIONS(1598),
    [anon_sym_void] = ACTIONS(1594),
    [anon_sym_delete] = ACTIONS(1594),
    [anon_sym_PLUS_PLUS] = ACTIONS(1598),
    [anon_sym_DASH_DASH] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1598),
    [anon_sym_SQUOTE] = ACTIONS(1598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1598),
    [sym_number] = ACTIONS(1598),
    [sym_this] = ACTIONS(1594),
    [sym_super] = ACTIONS(1594),
    [sym_true] = ACTIONS(1594),
    [sym_false] = ACTIONS(1594),
    [sym_null] = ACTIONS(1594),
    [sym_undefined] = ACTIONS(1594),
    [anon_sym_AT] = ACTIONS(1598),
    [anon_sym_static] = ACTIONS(1594),
    [anon_sym_readonly] = ACTIONS(1594),
    [anon_sym_get] = ACTIONS(1594),
    [anon_sym_set] = ACTIONS(1594),
    [anon_sym_declare] = ACTIONS(1594),
    [anon_sym_namespace] = ACTIONS(1594),
    [anon_sym_public] = ACTIONS(1594),
    [anon_sym_private] = ACTIONS(1594),
    [anon_sym_protected] = ACTIONS(1594),
    [anon_sym_override] = ACTIONS(1594),
    [anon_sym_module] = ACTIONS(1594),
    [anon_sym_any] = ACTIONS(1594),
    [anon_sym_number] = ACTIONS(1594),
    [anon_sym_boolean] = ACTIONS(1594),
    [anon_sym_string] = ACTIONS(1594),
    [anon_sym_symbol] = ACTIONS(1594),
    [anon_sym_abstract] = ACTIONS(1594),
    [anon_sym_interface] = ACTIONS(1594),
    [anon_sym_enum] = ACTIONS(1594),
    [anon_sym_component] = ACTIONS(1594),
    [anon_sym_instance] = ACTIONS(1594),
    [sym__automatic_semicolon] = ACTIONS(1602),
  },
  [606] = {
    [sym__call_signature] = STATE(4684),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2349),
    [anon_sym_export] = ACTIONS(2351),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(2351),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_RPAREN] = ACTIONS(29),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(29),
    [anon_sym_EQ] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2351),
    [anon_sym_function] = ACTIONS(2317),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2351),
    [anon_sym_readonly] = ACTIONS(2351),
    [anon_sym_get] = ACTIONS(2351),
    [anon_sym_set] = ACTIONS(2351),
    [anon_sym_QMARK] = ACTIONS(628),
    [anon_sym_declare] = ACTIONS(2351),
    [anon_sym_namespace] = ACTIONS(2351),
    [anon_sym_public] = ACTIONS(2351),
    [anon_sym_private] = ACTIONS(2351),
    [anon_sym_protected] = ACTIONS(2351),
    [anon_sym_override] = ACTIONS(2351),
    [anon_sym_module] = ACTIONS(2351),
    [anon_sym_any] = ACTIONS(2351),
    [anon_sym_number] = ACTIONS(2351),
    [anon_sym_boolean] = ACTIONS(2351),
    [anon_sym_string] = ACTIONS(2351),
    [anon_sym_symbol] = ACTIONS(2351),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [607] = {
    [aux_sym_import_path_segment_repeat1] = STATE(607),
    [sym_identifier] = ACTIONS(2353),
    [anon_sym_export] = ACTIONS(2356),
    [anon_sym_as] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_RBRACE] = ACTIONS(2358),
    [anon_sym_type] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2356),
    [anon_sym_import] = ACTIONS(2356),
    [anon_sym_var] = ACTIONS(2356),
    [anon_sym_let] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(2356),
    [anon_sym_BANG] = ACTIONS(2358),
    [anon_sym_else] = ACTIONS(2356),
    [anon_sym_if] = ACTIONS(2356),
    [anon_sym_switch] = ACTIONS(2356),
    [anon_sym_for] = ACTIONS(2356),
    [anon_sym_LPAREN] = ACTIONS(2358),
    [anon_sym_await] = ACTIONS(2356),
    [anon_sym_while] = ACTIONS(2356),
    [anon_sym_do] = ACTIONS(2356),
    [anon_sym_try] = ACTIONS(2356),
    [anon_sym_with] = ACTIONS(2356),
    [anon_sym_break] = ACTIONS(2356),
    [anon_sym_continue] = ACTIONS(2356),
    [anon_sym_debugger] = ACTIONS(2356),
    [anon_sym_return] = ACTIONS(2356),
    [anon_sym_throw] = ACTIONS(2356),
    [anon_sym_SEMI] = ACTIONS(2358),
    [anon_sym_case] = ACTIONS(2356),
    [anon_sym_default] = ACTIONS(2356),
    [anon_sym_yield] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2358),
    [anon_sym_LTtemplate_GT] = ACTIONS(2358),
    [anon_sym_LT] = ACTIONS(2356),
    [anon_sym_SLASH] = ACTIONS(2356),
    [anon_sym_DOT] = ACTIONS(2356),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_async] = ACTIONS(2356),
    [anon_sym_function] = ACTIONS(2356),
    [anon_sym_new] = ACTIONS(2356),
    [anon_sym_AMP] = ACTIONS(2358),
    [anon_sym_PLUS] = ACTIONS(2356),
    [anon_sym_DASH] = ACTIONS(2353),
    [anon_sym_TILDE] = ACTIONS(2358),
    [anon_sym_void] = ACTIONS(2356),
    [anon_sym_delete] = ACTIONS(2356),
    [anon_sym_PLUS_PLUS] = ACTIONS(2358),
    [anon_sym_DASH_DASH] = ACTIONS(2358),
    [anon_sym_DQUOTE] = ACTIONS(2358),
    [anon_sym_SQUOTE] = ACTIONS(2358),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2358),
    [sym_number] = ACTIONS(2360),
    [sym_this] = ACTIONS(2356),
    [sym_super] = ACTIONS(2356),
    [sym_true] = ACTIONS(2356),
    [sym_false] = ACTIONS(2356),
    [sym_null] = ACTIONS(2356),
    [sym_undefined] = ACTIONS(2356),
    [anon_sym_AT] = ACTIONS(2358),
    [anon_sym_static] = ACTIONS(2356),
    [anon_sym_readonly] = ACTIONS(2356),
    [anon_sym_get] = ACTIONS(2356),
    [anon_sym_set] = ACTIONS(2356),
    [anon_sym_declare] = ACTIONS(2356),
    [anon_sym_namespace] = ACTIONS(2356),
    [anon_sym_public] = ACTIONS(2356),
    [anon_sym_private] = ACTIONS(2356),
    [anon_sym_protected] = ACTIONS(2356),
    [anon_sym_override] = ACTIONS(2356),
    [anon_sym_module] = ACTIONS(2356),
    [anon_sym_any] = ACTIONS(2356),
    [anon_sym_number] = ACTIONS(2356),
    [anon_sym_boolean] = ACTIONS(2356),
    [anon_sym_string] = ACTIONS(2356),
    [anon_sym_symbol] = ACTIONS(2356),
    [anon_sym_abstract] = ACTIONS(2356),
    [anon_sym_interface] = ACTIONS(2356),
    [anon_sym_enum] = ACTIONS(2356),
    [anon_sym_component] = ACTIONS(2356),
  },
  [608] = {
    [ts_builtin_sym_end] = ACTIONS(1686),
    [sym_identifier] = ACTIONS(1682),
    [anon_sym_export] = ACTIONS(1682),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [anon_sym_RBRACE] = ACTIONS(1686),
    [anon_sym_type] = ACTIONS(1682),
    [anon_sym_typeof] = ACTIONS(1682),
    [anon_sym_import] = ACTIONS(1682),
    [anon_sym_var] = ACTIONS(1682),
    [anon_sym_let] = ACTIONS(1682),
    [anon_sym_const] = ACTIONS(1682),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_else] = ACTIONS(1682),
    [anon_sym_if] = ACTIONS(1682),
    [anon_sym_switch] = ACTIONS(1682),
    [anon_sym_for] = ACTIONS(1682),
    [anon_sym_LPAREN] = ACTIONS(1686),
    [anon_sym_await] = ACTIONS(1682),
    [anon_sym_while] = ACTIONS(1682),
    [anon_sym_do] = ACTIONS(1682),
    [anon_sym_try] = ACTIONS(1682),
    [anon_sym_with] = ACTIONS(1682),
    [anon_sym_break] = ACTIONS(1682),
    [anon_sym_continue] = ACTIONS(1682),
    [anon_sym_debugger] = ACTIONS(1682),
    [anon_sym_return] = ACTIONS(1682),
    [anon_sym_throw] = ACTIONS(1682),
    [anon_sym_SEMI] = ACTIONS(1686),
    [anon_sym_case] = ACTIONS(1682),
    [anon_sym_default] = ACTIONS(1682),
    [anon_sym_yield] = ACTIONS(1682),
    [anon_sym_LBRACK] = ACTIONS(1686),
    [anon_sym_LTtemplate_GT] = ACTIONS(1686),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_SLASH] = ACTIONS(1682),
    [anon_sym_class] = ACTIONS(1682),
    [anon_sym_async] = ACTIONS(1682),
    [anon_sym_function] = ACTIONS(1682),
    [anon_sym_new] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1686),
    [anon_sym_PLUS] = ACTIONS(1682),
    [anon_sym_DASH] = ACTIONS(1682),
    [anon_sym_TILDE] = ACTIONS(1686),
    [anon_sym_void] = ACTIONS(1682),
    [anon_sym_delete] = ACTIONS(1682),
    [anon_sym_PLUS_PLUS] = ACTIONS(1686),
    [anon_sym_DASH_DASH] = ACTIONS(1686),
    [anon_sym_DQUOTE] = ACTIONS(1686),
    [anon_sym_SQUOTE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1686),
    [sym_number] = ACTIONS(1686),
    [sym_this] = ACTIONS(1682),
    [sym_super] = ACTIONS(1682),
    [sym_true] = ACTIONS(1682),
    [sym_false] = ACTIONS(1682),
    [sym_null] = ACTIONS(1682),
    [sym_undefined] = ACTIONS(1682),
    [anon_sym_AT] = ACTIONS(1686),
    [anon_sym_static] = ACTIONS(1682),
    [anon_sym_readonly] = ACTIONS(1682),
    [anon_sym_get] = ACTIONS(1682),
    [anon_sym_set] = ACTIONS(1682),
    [anon_sym_declare] = ACTIONS(1682),
    [anon_sym_namespace] = ACTIONS(1682),
    [anon_sym_public] = ACTIONS(1682),
    [anon_sym_private] = ACTIONS(1682),
    [anon_sym_protected] = ACTIONS(1682),
    [anon_sym_override] = ACTIONS(1682),
    [anon_sym_module] = ACTIONS(1682),
    [anon_sym_any] = ACTIONS(1682),
    [anon_sym_number] = ACTIONS(1682),
    [anon_sym_boolean] = ACTIONS(1682),
    [anon_sym_string] = ACTIONS(1682),
    [anon_sym_symbol] = ACTIONS(1682),
    [anon_sym_abstract] = ACTIONS(1682),
    [anon_sym_interface] = ACTIONS(1682),
    [anon_sym_enum] = ACTIONS(1682),
    [anon_sym_component] = ACTIONS(1682),
    [anon_sym_instance] = ACTIONS(1682),
    [sym__automatic_semicolon] = ACTIONS(1690),
  },
  [609] = {
    [ts_builtin_sym_end] = ACTIONS(1608),
    [sym_identifier] = ACTIONS(1604),
    [anon_sym_export] = ACTIONS(1604),
    [anon_sym_LBRACE] = ACTIONS(1608),
    [anon_sym_RBRACE] = ACTIONS(1608),
    [anon_sym_type] = ACTIONS(1604),
    [anon_sym_typeof] = ACTIONS(1604),
    [anon_sym_import] = ACTIONS(1604),
    [anon_sym_var] = ACTIONS(1604),
    [anon_sym_let] = ACTIONS(1604),
    [anon_sym_const] = ACTIONS(1604),
    [anon_sym_BANG] = ACTIONS(1608),
    [anon_sym_else] = ACTIONS(1604),
    [anon_sym_if] = ACTIONS(1604),
    [anon_sym_switch] = ACTIONS(1604),
    [anon_sym_for] = ACTIONS(1604),
    [anon_sym_LPAREN] = ACTIONS(1608),
    [anon_sym_await] = ACTIONS(1604),
    [anon_sym_while] = ACTIONS(1604),
    [anon_sym_do] = ACTIONS(1604),
    [anon_sym_try] = ACTIONS(1604),
    [anon_sym_with] = ACTIONS(1604),
    [anon_sym_break] = ACTIONS(1604),
    [anon_sym_continue] = ACTIONS(1604),
    [anon_sym_debugger] = ACTIONS(1604),
    [anon_sym_return] = ACTIONS(1604),
    [anon_sym_throw] = ACTIONS(1604),
    [anon_sym_SEMI] = ACTIONS(1608),
    [anon_sym_case] = ACTIONS(1604),
    [anon_sym_default] = ACTIONS(1604),
    [anon_sym_yield] = ACTIONS(1604),
    [anon_sym_LBRACK] = ACTIONS(1608),
    [anon_sym_LTtemplate_GT] = ACTIONS(1608),
    [anon_sym_LT] = ACTIONS(1604),
    [anon_sym_SLASH] = ACTIONS(1604),
    [anon_sym_class] = ACTIONS(1604),
    [anon_sym_async] = ACTIONS(1604),
    [anon_sym_function] = ACTIONS(1604),
    [anon_sym_new] = ACTIONS(1604),
    [anon_sym_AMP] = ACTIONS(1608),
    [anon_sym_PLUS] = ACTIONS(1604),
    [anon_sym_DASH] = ACTIONS(1604),
    [anon_sym_TILDE] = ACTIONS(1608),
    [anon_sym_void] = ACTIONS(1604),
    [anon_sym_delete] = ACTIONS(1604),
    [anon_sym_PLUS_PLUS] = ACTIONS(1608),
    [anon_sym_DASH_DASH] = ACTIONS(1608),
    [anon_sym_DQUOTE] = ACTIONS(1608),
    [anon_sym_SQUOTE] = ACTIONS(1608),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1608),
    [sym_number] = ACTIONS(1608),
    [sym_this] = ACTIONS(1604),
    [sym_super] = ACTIONS(1604),
    [sym_true] = ACTIONS(1604),
    [sym_false] = ACTIONS(1604),
    [sym_null] = ACTIONS(1604),
    [sym_undefined] = ACTIONS(1604),
    [anon_sym_AT] = ACTIONS(1608),
    [anon_sym_static] = ACTIONS(1604),
    [anon_sym_readonly] = ACTIONS(1604),
    [anon_sym_get] = ACTIONS(1604),
    [anon_sym_set] = ACTIONS(1604),
    [anon_sym_declare] = ACTIONS(1604),
    [anon_sym_namespace] = ACTIONS(1604),
    [anon_sym_public] = ACTIONS(1604),
    [anon_sym_private] = ACTIONS(1604),
    [anon_sym_protected] = ACTIONS(1604),
    [anon_sym_override] = ACTIONS(1604),
    [anon_sym_module] = ACTIONS(1604),
    [anon_sym_any] = ACTIONS(1604),
    [anon_sym_number] = ACTIONS(1604),
    [anon_sym_boolean] = ACTIONS(1604),
    [anon_sym_string] = ACTIONS(1604),
    [anon_sym_symbol] = ACTIONS(1604),
    [anon_sym_abstract] = ACTIONS(1604),
    [anon_sym_interface] = ACTIONS(1604),
    [anon_sym_enum] = ACTIONS(1604),
    [anon_sym_component] = ACTIONS(1604),
    [anon_sym_instance] = ACTIONS(1604),
    [sym__automatic_semicolon] = ACTIONS(1612),
  },
  [610] = {
    [ts_builtin_sym_end] = ACTIONS(1648),
    [sym_identifier] = ACTIONS(1644),
    [anon_sym_export] = ACTIONS(1644),
    [anon_sym_LBRACE] = ACTIONS(1648),
    [anon_sym_RBRACE] = ACTIONS(1648),
    [anon_sym_type] = ACTIONS(1644),
    [anon_sym_typeof] = ACTIONS(1644),
    [anon_sym_import] = ACTIONS(1644),
    [anon_sym_var] = ACTIONS(1644),
    [anon_sym_let] = ACTIONS(1644),
    [anon_sym_const] = ACTIONS(1644),
    [anon_sym_BANG] = ACTIONS(1648),
    [anon_sym_else] = ACTIONS(1644),
    [anon_sym_if] = ACTIONS(1644),
    [anon_sym_switch] = ACTIONS(1644),
    [anon_sym_for] = ACTIONS(1644),
    [anon_sym_LPAREN] = ACTIONS(1648),
    [anon_sym_await] = ACTIONS(1644),
    [anon_sym_while] = ACTIONS(1644),
    [anon_sym_do] = ACTIONS(1644),
    [anon_sym_try] = ACTIONS(1644),
    [anon_sym_with] = ACTIONS(1644),
    [anon_sym_break] = ACTIONS(1644),
    [anon_sym_continue] = ACTIONS(1644),
    [anon_sym_debugger] = ACTIONS(1644),
    [anon_sym_return] = ACTIONS(1644),
    [anon_sym_throw] = ACTIONS(1644),
    [anon_sym_SEMI] = ACTIONS(1648),
    [anon_sym_case] = ACTIONS(1644),
    [anon_sym_default] = ACTIONS(1644),
    [anon_sym_yield] = ACTIONS(1644),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [anon_sym_LTtemplate_GT] = ACTIONS(1648),
    [anon_sym_LT] = ACTIONS(1644),
    [anon_sym_SLASH] = ACTIONS(1644),
    [anon_sym_class] = ACTIONS(1644),
    [anon_sym_async] = ACTIONS(1644),
    [anon_sym_function] = ACTIONS(1644),
    [anon_sym_new] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1648),
    [anon_sym_PLUS] = ACTIONS(1644),
    [anon_sym_DASH] = ACTIONS(1644),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_void] = ACTIONS(1644),
    [anon_sym_delete] = ACTIONS(1644),
    [anon_sym_PLUS_PLUS] = ACTIONS(1648),
    [anon_sym_DASH_DASH] = ACTIONS(1648),
    [anon_sym_DQUOTE] = ACTIONS(1648),
    [anon_sym_SQUOTE] = ACTIONS(1648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [sym_number] = ACTIONS(1648),
    [sym_this] = ACTIONS(1644),
    [sym_super] = ACTIONS(1644),
    [sym_true] = ACTIONS(1644),
    [sym_false] = ACTIONS(1644),
    [sym_null] = ACTIONS(1644),
    [sym_undefined] = ACTIONS(1644),
    [anon_sym_AT] = ACTIONS(1648),
    [anon_sym_static] = ACTIONS(1644),
    [anon_sym_readonly] = ACTIONS(1644),
    [anon_sym_get] = ACTIONS(1644),
    [anon_sym_set] = ACTIONS(1644),
    [anon_sym_declare] = ACTIONS(1644),
    [anon_sym_namespace] = ACTIONS(1644),
    [anon_sym_public] = ACTIONS(1644),
    [anon_sym_private] = ACTIONS(1644),
    [anon_sym_protected] = ACTIONS(1644),
    [anon_sym_override] = ACTIONS(1644),
    [anon_sym_module] = ACTIONS(1644),
    [anon_sym_any] = ACTIONS(1644),
    [anon_sym_number] = ACTIONS(1644),
    [anon_sym_boolean] = ACTIONS(1644),
    [anon_sym_string] = ACTIONS(1644),
    [anon_sym_symbol] = ACTIONS(1644),
    [anon_sym_abstract] = ACTIONS(1644),
    [anon_sym_interface] = ACTIONS(1644),
    [anon_sym_enum] = ACTIONS(1644),
    [anon_sym_component] = ACTIONS(1644),
    [anon_sym_instance] = ACTIONS(1644),
    [sym__automatic_semicolon] = ACTIONS(1652),
  },
  [611] = {
    [ts_builtin_sym_end] = ACTIONS(1542),
    [sym_identifier] = ACTIONS(1540),
    [anon_sym_export] = ACTIONS(1540),
    [anon_sym_LBRACE] = ACTIONS(1542),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [anon_sym_type] = ACTIONS(1540),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(1540),
    [anon_sym_var] = ACTIONS(1540),
    [anon_sym_let] = ACTIONS(1540),
    [anon_sym_const] = ACTIONS(1540),
    [anon_sym_BANG] = ACTIONS(1542),
    [anon_sym_else] = ACTIONS(1540),
    [anon_sym_if] = ACTIONS(1540),
    [anon_sym_switch] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1542),
    [anon_sym_await] = ACTIONS(1540),
    [anon_sym_while] = ACTIONS(1540),
    [anon_sym_do] = ACTIONS(1540),
    [anon_sym_try] = ACTIONS(1540),
    [anon_sym_with] = ACTIONS(1540),
    [anon_sym_break] = ACTIONS(1540),
    [anon_sym_continue] = ACTIONS(1540),
    [anon_sym_debugger] = ACTIONS(1540),
    [anon_sym_return] = ACTIONS(1540),
    [anon_sym_throw] = ACTIONS(1540),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_case] = ACTIONS(1540),
    [anon_sym_default] = ACTIONS(1540),
    [anon_sym_yield] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1542),
    [anon_sym_LTtemplate_GT] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1540),
    [anon_sym_class] = ACTIONS(1540),
    [anon_sym_async] = ACTIONS(1540),
    [anon_sym_function] = ACTIONS(1540),
    [anon_sym_new] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1542),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_TILDE] = ACTIONS(1542),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1542),
    [anon_sym_DASH_DASH] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [sym_number] = ACTIONS(1542),
    [sym_this] = ACTIONS(1540),
    [sym_super] = ACTIONS(1540),
    [sym_true] = ACTIONS(1540),
    [sym_false] = ACTIONS(1540),
    [sym_null] = ACTIONS(1540),
    [sym_undefined] = ACTIONS(1540),
    [anon_sym_AT] = ACTIONS(1542),
    [anon_sym_static] = ACTIONS(1540),
    [anon_sym_readonly] = ACTIONS(1540),
    [anon_sym_get] = ACTIONS(1540),
    [anon_sym_set] = ACTIONS(1540),
    [anon_sym_declare] = ACTIONS(1540),
    [anon_sym_namespace] = ACTIONS(1540),
    [anon_sym_public] = ACTIONS(1540),
    [anon_sym_private] = ACTIONS(1540),
    [anon_sym_protected] = ACTIONS(1540),
    [anon_sym_override] = ACTIONS(1540),
    [anon_sym_module] = ACTIONS(1540),
    [anon_sym_any] = ACTIONS(1540),
    [anon_sym_number] = ACTIONS(1540),
    [anon_sym_boolean] = ACTIONS(1540),
    [anon_sym_string] = ACTIONS(1540),
    [anon_sym_symbol] = ACTIONS(1540),
    [anon_sym_abstract] = ACTIONS(1540),
    [anon_sym_interface] = ACTIONS(1540),
    [anon_sym_enum] = ACTIONS(1540),
    [anon_sym_component] = ACTIONS(1540),
    [anon_sym_instance] = ACTIONS(1540),
    [sym__automatic_semicolon] = ACTIONS(1542),
  },
  [612] = {
    [ts_builtin_sym_end] = ACTIONS(1720),
    [sym_identifier] = ACTIONS(1716),
    [anon_sym_export] = ACTIONS(1716),
    [anon_sym_LBRACE] = ACTIONS(1720),
    [anon_sym_RBRACE] = ACTIONS(1720),
    [anon_sym_type] = ACTIONS(1716),
    [anon_sym_typeof] = ACTIONS(1716),
    [anon_sym_import] = ACTIONS(1716),
    [anon_sym_var] = ACTIONS(1716),
    [anon_sym_let] = ACTIONS(1716),
    [anon_sym_const] = ACTIONS(1716),
    [anon_sym_BANG] = ACTIONS(1720),
    [anon_sym_else] = ACTIONS(1716),
    [anon_sym_if] = ACTIONS(1716),
    [anon_sym_switch] = ACTIONS(1716),
    [anon_sym_for] = ACTIONS(1716),
    [anon_sym_LPAREN] = ACTIONS(1720),
    [anon_sym_await] = ACTIONS(1716),
    [anon_sym_while] = ACTIONS(1716),
    [anon_sym_do] = ACTIONS(1716),
    [anon_sym_try] = ACTIONS(1716),
    [anon_sym_with] = ACTIONS(1716),
    [anon_sym_break] = ACTIONS(1716),
    [anon_sym_continue] = ACTIONS(1716),
    [anon_sym_debugger] = ACTIONS(1716),
    [anon_sym_return] = ACTIONS(1716),
    [anon_sym_throw] = ACTIONS(1716),
    [anon_sym_SEMI] = ACTIONS(1720),
    [anon_sym_case] = ACTIONS(1716),
    [anon_sym_default] = ACTIONS(1716),
    [anon_sym_yield] = ACTIONS(1716),
    [anon_sym_LBRACK] = ACTIONS(1720),
    [anon_sym_LTtemplate_GT] = ACTIONS(1720),
    [anon_sym_LT] = ACTIONS(1716),
    [anon_sym_SLASH] = ACTIONS(1716),
    [anon_sym_class] = ACTIONS(1716),
    [anon_sym_async] = ACTIONS(1716),
    [anon_sym_function] = ACTIONS(1716),
    [anon_sym_new] = ACTIONS(1716),
    [anon_sym_AMP] = ACTIONS(1720),
    [anon_sym_PLUS] = ACTIONS(1716),
    [anon_sym_DASH] = ACTIONS(1716),
    [anon_sym_TILDE] = ACTIONS(1720),
    [anon_sym_void] = ACTIONS(1716),
    [anon_sym_delete] = ACTIONS(1716),
    [anon_sym_PLUS_PLUS] = ACTIONS(1720),
    [anon_sym_DASH_DASH] = ACTIONS(1720),
    [anon_sym_DQUOTE] = ACTIONS(1720),
    [anon_sym_SQUOTE] = ACTIONS(1720),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1720),
    [sym_number] = ACTIONS(1720),
    [sym_this] = ACTIONS(1716),
    [sym_super] = ACTIONS(1716),
    [sym_true] = ACTIONS(1716),
    [sym_false] = ACTIONS(1716),
    [sym_null] = ACTIONS(1716),
    [sym_undefined] = ACTIONS(1716),
    [anon_sym_AT] = ACTIONS(1720),
    [anon_sym_static] = ACTIONS(1716),
    [anon_sym_readonly] = ACTIONS(1716),
    [anon_sym_get] = ACTIONS(1716),
    [anon_sym_set] = ACTIONS(1716),
    [anon_sym_declare] = ACTIONS(1716),
    [anon_sym_namespace] = ACTIONS(1716),
    [anon_sym_public] = ACTIONS(1716),
    [anon_sym_private] = ACTIONS(1716),
    [anon_sym_protected] = ACTIONS(1716),
    [anon_sym_override] = ACTIONS(1716),
    [anon_sym_module] = ACTIONS(1716),
    [anon_sym_any] = ACTIONS(1716),
    [anon_sym_number] = ACTIONS(1716),
    [anon_sym_boolean] = ACTIONS(1716),
    [anon_sym_string] = ACTIONS(1716),
    [anon_sym_symbol] = ACTIONS(1716),
    [anon_sym_abstract] = ACTIONS(1716),
    [anon_sym_interface] = ACTIONS(1716),
    [anon_sym_enum] = ACTIONS(1716),
    [anon_sym_component] = ACTIONS(1716),
    [anon_sym_instance] = ACTIONS(1716),
    [sym__automatic_semicolon] = ACTIONS(1724),
  },
  [613] = {
    [ts_builtin_sym_end] = ACTIONS(1518),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_export] = ACTIONS(1514),
    [anon_sym_LBRACE] = ACTIONS(1518),
    [anon_sym_RBRACE] = ACTIONS(1518),
    [anon_sym_type] = ACTIONS(1514),
    [anon_sym_typeof] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1514),
    [anon_sym_var] = ACTIONS(1514),
    [anon_sym_let] = ACTIONS(1514),
    [anon_sym_const] = ACTIONS(1514),
    [anon_sym_BANG] = ACTIONS(1518),
    [anon_sym_else] = ACTIONS(1514),
    [anon_sym_if] = ACTIONS(1514),
    [anon_sym_switch] = ACTIONS(1514),
    [anon_sym_for] = ACTIONS(1514),
    [anon_sym_LPAREN] = ACTIONS(1518),
    [anon_sym_await] = ACTIONS(1514),
    [anon_sym_while] = ACTIONS(1514),
    [anon_sym_do] = ACTIONS(1514),
    [anon_sym_try] = ACTIONS(1514),
    [anon_sym_with] = ACTIONS(1514),
    [anon_sym_break] = ACTIONS(1514),
    [anon_sym_continue] = ACTIONS(1514),
    [anon_sym_debugger] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1514),
    [anon_sym_throw] = ACTIONS(1514),
    [anon_sym_SEMI] = ACTIONS(1518),
    [anon_sym_case] = ACTIONS(1514),
    [anon_sym_default] = ACTIONS(1514),
    [anon_sym_yield] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1518),
    [anon_sym_LTtemplate_GT] = ACTIONS(1518),
    [anon_sym_LT] = ACTIONS(1514),
    [anon_sym_SLASH] = ACTIONS(1514),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_async] = ACTIONS(1514),
    [anon_sym_function] = ACTIONS(1514),
    [anon_sym_new] = ACTIONS(1514),
    [anon_sym_AMP] = ACTIONS(1518),
    [anon_sym_PLUS] = ACTIONS(1514),
    [anon_sym_DASH] = ACTIONS(1514),
    [anon_sym_TILDE] = ACTIONS(1518),
    [anon_sym_void] = ACTIONS(1514),
    [anon_sym_delete] = ACTIONS(1514),
    [anon_sym_PLUS_PLUS] = ACTIONS(1518),
    [anon_sym_DASH_DASH] = ACTIONS(1518),
    [anon_sym_DQUOTE] = ACTIONS(1518),
    [anon_sym_SQUOTE] = ACTIONS(1518),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1518),
    [sym_number] = ACTIONS(1518),
    [sym_this] = ACTIONS(1514),
    [sym_super] = ACTIONS(1514),
    [sym_true] = ACTIONS(1514),
    [sym_false] = ACTIONS(1514),
    [sym_null] = ACTIONS(1514),
    [sym_undefined] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(1518),
    [anon_sym_static] = ACTIONS(1514),
    [anon_sym_readonly] = ACTIONS(1514),
    [anon_sym_get] = ACTIONS(1514),
    [anon_sym_set] = ACTIONS(1514),
    [anon_sym_declare] = ACTIONS(1514),
    [anon_sym_namespace] = ACTIONS(1514),
    [anon_sym_public] = ACTIONS(1514),
    [anon_sym_private] = ACTIONS(1514),
    [anon_sym_protected] = ACTIONS(1514),
    [anon_sym_override] = ACTIONS(1514),
    [anon_sym_module] = ACTIONS(1514),
    [anon_sym_any] = ACTIONS(1514),
    [anon_sym_number] = ACTIONS(1514),
    [anon_sym_boolean] = ACTIONS(1514),
    [anon_sym_string] = ACTIONS(1514),
    [anon_sym_symbol] = ACTIONS(1514),
    [anon_sym_abstract] = ACTIONS(1514),
    [anon_sym_interface] = ACTIONS(1514),
    [anon_sym_enum] = ACTIONS(1514),
    [anon_sym_component] = ACTIONS(1514),
    [anon_sym_instance] = ACTIONS(1514),
    [sym__automatic_semicolon] = ACTIONS(1522),
  },
  [614] = {
    [aux_sym_import_path_segment_repeat1] = STATE(619),
    [sym_identifier] = ACTIONS(2178),
    [anon_sym_export] = ACTIONS(2181),
    [anon_sym_as] = ACTIONS(2181),
    [anon_sym_LBRACE] = ACTIONS(2183),
    [anon_sym_RBRACE] = ACTIONS(2183),
    [anon_sym_type] = ACTIONS(2181),
    [anon_sym_typeof] = ACTIONS(2181),
    [anon_sym_import] = ACTIONS(2181),
    [anon_sym_var] = ACTIONS(2181),
    [anon_sym_let] = ACTIONS(2181),
    [anon_sym_const] = ACTIONS(2181),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_else] = ACTIONS(2181),
    [anon_sym_if] = ACTIONS(2181),
    [anon_sym_switch] = ACTIONS(2181),
    [anon_sym_for] = ACTIONS(2181),
    [anon_sym_LPAREN] = ACTIONS(2183),
    [anon_sym_await] = ACTIONS(2181),
    [anon_sym_while] = ACTIONS(2181),
    [anon_sym_do] = ACTIONS(2181),
    [anon_sym_try] = ACTIONS(2181),
    [anon_sym_with] = ACTIONS(2181),
    [anon_sym_break] = ACTIONS(2181),
    [anon_sym_continue] = ACTIONS(2181),
    [anon_sym_debugger] = ACTIONS(2181),
    [anon_sym_return] = ACTIONS(2181),
    [anon_sym_throw] = ACTIONS(2181),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym_case] = ACTIONS(2181),
    [anon_sym_default] = ACTIONS(2181),
    [anon_sym_yield] = ACTIONS(2181),
    [anon_sym_LBRACK] = ACTIONS(2183),
    [anon_sym_LTtemplate_GT] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(2181),
    [anon_sym_SLASH] = ACTIONS(2181),
    [anon_sym_DOT] = ACTIONS(2181),
    [anon_sym_class] = ACTIONS(2181),
    [anon_sym_async] = ACTIONS(2181),
    [anon_sym_function] = ACTIONS(2181),
    [anon_sym_new] = ACTIONS(2181),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_PLUS] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(2178),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_void] = ACTIONS(2181),
    [anon_sym_delete] = ACTIONS(2181),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_DQUOTE] = ACTIONS(2183),
    [anon_sym_SQUOTE] = ACTIONS(2183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2183),
    [sym_number] = ACTIONS(2191),
    [sym_this] = ACTIONS(2181),
    [sym_super] = ACTIONS(2181),
    [sym_true] = ACTIONS(2181),
    [sym_false] = ACTIONS(2181),
    [sym_null] = ACTIONS(2181),
    [sym_undefined] = ACTIONS(2181),
    [anon_sym_AT] = ACTIONS(2183),
    [anon_sym_static] = ACTIONS(2181),
    [anon_sym_readonly] = ACTIONS(2181),
    [anon_sym_get] = ACTIONS(2181),
    [anon_sym_set] = ACTIONS(2181),
    [anon_sym_declare] = ACTIONS(2181),
    [anon_sym_namespace] = ACTIONS(2181),
    [anon_sym_public] = ACTIONS(2181),
    [anon_sym_private] = ACTIONS(2181),
    [anon_sym_protected] = ACTIONS(2181),
    [anon_sym_override] = ACTIONS(2181),
    [anon_sym_module] = ACTIONS(2181),
    [anon_sym_any] = ACTIONS(2181),
    [anon_sym_number] = ACTIONS(2181),
    [anon_sym_boolean] = ACTIONS(2181),
    [anon_sym_string] = ACTIONS(2181),
    [anon_sym_symbol] = ACTIONS(2181),
    [anon_sym_abstract] = ACTIONS(2181),
    [anon_sym_interface] = ACTIONS(2181),
    [anon_sym_enum] = ACTIONS(2181),
    [anon_sym_component] = ACTIONS(2181),
  },
  [615] = {
    [aux_sym_import_path_repeat1] = STATE(601),
    [sym_identifier] = ACTIONS(2363),
    [anon_sym_export] = ACTIONS(2363),
    [anon_sym_as] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2365),
    [anon_sym_RBRACE] = ACTIONS(2365),
    [anon_sym_type] = ACTIONS(2363),
    [anon_sym_typeof] = ACTIONS(2363),
    [anon_sym_import] = ACTIONS(2363),
    [anon_sym_var] = ACTIONS(2363),
    [anon_sym_let] = ACTIONS(2363),
    [anon_sym_const] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(2365),
    [anon_sym_else] = ACTIONS(2363),
    [anon_sym_if] = ACTIONS(2363),
    [anon_sym_switch] = ACTIONS(2363),
    [anon_sym_for] = ACTIONS(2363),
    [anon_sym_LPAREN] = ACTIONS(2365),
    [anon_sym_await] = ACTIONS(2363),
    [anon_sym_while] = ACTIONS(2363),
    [anon_sym_do] = ACTIONS(2363),
    [anon_sym_try] = ACTIONS(2363),
    [anon_sym_with] = ACTIONS(2363),
    [anon_sym_break] = ACTIONS(2363),
    [anon_sym_continue] = ACTIONS(2363),
    [anon_sym_debugger] = ACTIONS(2363),
    [anon_sym_return] = ACTIONS(2363),
    [anon_sym_throw] = ACTIONS(2363),
    [anon_sym_SEMI] = ACTIONS(2365),
    [anon_sym_case] = ACTIONS(2363),
    [anon_sym_default] = ACTIONS(2363),
    [anon_sym_yield] = ACTIONS(2363),
    [anon_sym_LBRACK] = ACTIONS(2365),
    [anon_sym_LTtemplate_GT] = ACTIONS(2365),
    [anon_sym_LT] = ACTIONS(2363),
    [anon_sym_SLASH] = ACTIONS(2363),
    [anon_sym_DOT] = ACTIONS(2333),
    [anon_sym_class] = ACTIONS(2363),
    [anon_sym_async] = ACTIONS(2363),
    [anon_sym_function] = ACTIONS(2363),
    [anon_sym_new] = ACTIONS(2363),
    [anon_sym_AMP] = ACTIONS(2365),
    [anon_sym_PLUS] = ACTIONS(2363),
    [anon_sym_DASH] = ACTIONS(2363),
    [anon_sym_TILDE] = ACTIONS(2365),
    [anon_sym_void] = ACTIONS(2363),
    [anon_sym_delete] = ACTIONS(2363),
    [anon_sym_PLUS_PLUS] = ACTIONS(2365),
    [anon_sym_DASH_DASH] = ACTIONS(2365),
    [anon_sym_DQUOTE] = ACTIONS(2365),
    [anon_sym_SQUOTE] = ACTIONS(2365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2365),
    [sym_number] = ACTIONS(2365),
    [sym_this] = ACTIONS(2363),
    [sym_super] = ACTIONS(2363),
    [sym_true] = ACTIONS(2363),
    [sym_false] = ACTIONS(2363),
    [sym_null] = ACTIONS(2363),
    [sym_undefined] = ACTIONS(2363),
    [anon_sym_AT] = ACTIONS(2365),
    [anon_sym_static] = ACTIONS(2363),
    [anon_sym_readonly] = ACTIONS(2363),
    [anon_sym_get] = ACTIONS(2363),
    [anon_sym_set] = ACTIONS(2363),
    [anon_sym_declare] = ACTIONS(2363),
    [anon_sym_namespace] = ACTIONS(2363),
    [anon_sym_public] = ACTIONS(2363),
    [anon_sym_private] = ACTIONS(2363),
    [anon_sym_protected] = ACTIONS(2363),
    [anon_sym_override] = ACTIONS(2363),
    [anon_sym_module] = ACTIONS(2363),
    [anon_sym_any] = ACTIONS(2363),
    [anon_sym_number] = ACTIONS(2363),
    [anon_sym_boolean] = ACTIONS(2363),
    [anon_sym_string] = ACTIONS(2363),
    [anon_sym_symbol] = ACTIONS(2363),
    [anon_sym_abstract] = ACTIONS(2363),
    [anon_sym_interface] = ACTIONS(2363),
    [anon_sym_enum] = ACTIONS(2363),
    [anon_sym_component] = ACTIONS(2363),
  },
  [616] = {
    [aux_sym_import_path_repeat1] = STATE(616),
    [sym_identifier] = ACTIONS(2367),
    [anon_sym_export] = ACTIONS(2367),
    [anon_sym_as] = ACTIONS(2367),
    [anon_sym_LBRACE] = ACTIONS(2369),
    [anon_sym_RBRACE] = ACTIONS(2369),
    [anon_sym_type] = ACTIONS(2367),
    [anon_sym_typeof] = ACTIONS(2367),
    [anon_sym_import] = ACTIONS(2367),
    [anon_sym_var] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(2367),
    [anon_sym_const] = ACTIONS(2367),
    [anon_sym_BANG] = ACTIONS(2369),
    [anon_sym_else] = ACTIONS(2367),
    [anon_sym_if] = ACTIONS(2367),
    [anon_sym_switch] = ACTIONS(2367),
    [anon_sym_for] = ACTIONS(2367),
    [anon_sym_LPAREN] = ACTIONS(2369),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_while] = ACTIONS(2367),
    [anon_sym_do] = ACTIONS(2367),
    [anon_sym_try] = ACTIONS(2367),
    [anon_sym_with] = ACTIONS(2367),
    [anon_sym_break] = ACTIONS(2367),
    [anon_sym_continue] = ACTIONS(2367),
    [anon_sym_debugger] = ACTIONS(2367),
    [anon_sym_return] = ACTIONS(2367),
    [anon_sym_throw] = ACTIONS(2367),
    [anon_sym_SEMI] = ACTIONS(2369),
    [anon_sym_case] = ACTIONS(2367),
    [anon_sym_default] = ACTIONS(2367),
    [anon_sym_yield] = ACTIONS(2367),
    [anon_sym_LBRACK] = ACTIONS(2369),
    [anon_sym_LTtemplate_GT] = ACTIONS(2369),
    [anon_sym_LT] = ACTIONS(2367),
    [anon_sym_SLASH] = ACTIONS(2367),
    [anon_sym_DOT] = ACTIONS(2371),
    [anon_sym_class] = ACTIONS(2367),
    [anon_sym_async] = ACTIONS(2367),
    [anon_sym_function] = ACTIONS(2367),
    [anon_sym_new] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(2369),
    [anon_sym_PLUS] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2367),
    [anon_sym_TILDE] = ACTIONS(2369),
    [anon_sym_void] = ACTIONS(2367),
    [anon_sym_delete] = ACTIONS(2367),
    [anon_sym_PLUS_PLUS] = ACTIONS(2369),
    [anon_sym_DASH_DASH] = ACTIONS(2369),
    [anon_sym_DQUOTE] = ACTIONS(2369),
    [anon_sym_SQUOTE] = ACTIONS(2369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2369),
    [sym_number] = ACTIONS(2369),
    [sym_this] = ACTIONS(2367),
    [sym_super] = ACTIONS(2367),
    [sym_true] = ACTIONS(2367),
    [sym_false] = ACTIONS(2367),
    [sym_null] = ACTIONS(2367),
    [sym_undefined] = ACTIONS(2367),
    [anon_sym_AT] = ACTIONS(2369),
    [anon_sym_static] = ACTIONS(2367),
    [anon_sym_readonly] = ACTIONS(2367),
    [anon_sym_get] = ACTIONS(2367),
    [anon_sym_set] = ACTIONS(2367),
    [anon_sym_declare] = ACTIONS(2367),
    [anon_sym_namespace] = ACTIONS(2367),
    [anon_sym_public] = ACTIONS(2367),
    [anon_sym_private] = ACTIONS(2367),
    [anon_sym_protected] = ACTIONS(2367),
    [anon_sym_override] = ACTIONS(2367),
    [anon_sym_module] = ACTIONS(2367),
    [anon_sym_any] = ACTIONS(2367),
    [anon_sym_number] = ACTIONS(2367),
    [anon_sym_boolean] = ACTIONS(2367),
    [anon_sym_string] = ACTIONS(2367),
    [anon_sym_symbol] = ACTIONS(2367),
    [anon_sym_abstract] = ACTIONS(2367),
    [anon_sym_interface] = ACTIONS(2367),
    [anon_sym_enum] = ACTIONS(2367),
    [anon_sym_component] = ACTIONS(2367),
  },
  [617] = {
    [sym__call_signature] = STATE(4874),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2339),
    [anon_sym_export] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_type] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(2374),
    [anon_sym_of] = ACTIONS(2377),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1938),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2341),
    [anon_sym_function] = ACTIONS(2343),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2341),
    [anon_sym_readonly] = ACTIONS(2341),
    [anon_sym_get] = ACTIONS(2341),
    [anon_sym_set] = ACTIONS(2341),
    [anon_sym_declare] = ACTIONS(2341),
    [anon_sym_namespace] = ACTIONS(2341),
    [anon_sym_public] = ACTIONS(2341),
    [anon_sym_private] = ACTIONS(2341),
    [anon_sym_protected] = ACTIONS(2341),
    [anon_sym_override] = ACTIONS(2341),
    [anon_sym_module] = ACTIONS(2341),
    [anon_sym_any] = ACTIONS(2341),
    [anon_sym_number] = ACTIONS(2341),
    [anon_sym_boolean] = ACTIONS(2341),
    [anon_sym_string] = ACTIONS(2341),
    [anon_sym_symbol] = ACTIONS(2341),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [618] = {
    [sym__call_signature] = STATE(4874),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2339),
    [anon_sym_export] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_type] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1936),
    [anon_sym_EQ] = ACTIONS(1938),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2341),
    [anon_sym_function] = ACTIONS(1974),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2341),
    [anon_sym_readonly] = ACTIONS(2341),
    [anon_sym_get] = ACTIONS(2341),
    [anon_sym_set] = ACTIONS(2341),
    [anon_sym_declare] = ACTIONS(2341),
    [anon_sym_namespace] = ACTIONS(2341),
    [anon_sym_public] = ACTIONS(2341),
    [anon_sym_private] = ACTIONS(2341),
    [anon_sym_protected] = ACTIONS(2341),
    [anon_sym_override] = ACTIONS(2341),
    [anon_sym_module] = ACTIONS(2341),
    [anon_sym_any] = ACTIONS(2341),
    [anon_sym_number] = ACTIONS(2341),
    [anon_sym_boolean] = ACTIONS(2341),
    [anon_sym_string] = ACTIONS(2341),
    [anon_sym_symbol] = ACTIONS(2341),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [619] = {
    [aux_sym_import_path_segment_repeat1] = STATE(607),
    [sym_identifier] = ACTIONS(2379),
    [anon_sym_export] = ACTIONS(2382),
    [anon_sym_as] = ACTIONS(2382),
    [anon_sym_LBRACE] = ACTIONS(2384),
    [anon_sym_RBRACE] = ACTIONS(2384),
    [anon_sym_type] = ACTIONS(2382),
    [anon_sym_typeof] = ACTIONS(2382),
    [anon_sym_import] = ACTIONS(2382),
    [anon_sym_var] = ACTIONS(2382),
    [anon_sym_let] = ACTIONS(2382),
    [anon_sym_const] = ACTIONS(2382),
    [anon_sym_BANG] = ACTIONS(2384),
    [anon_sym_else] = ACTIONS(2382),
    [anon_sym_if] = ACTIONS(2382),
    [anon_sym_switch] = ACTIONS(2382),
    [anon_sym_for] = ACTIONS(2382),
    [anon_sym_LPAREN] = ACTIONS(2384),
    [anon_sym_await] = ACTIONS(2382),
    [anon_sym_while] = ACTIONS(2382),
    [anon_sym_do] = ACTIONS(2382),
    [anon_sym_try] = ACTIONS(2382),
    [anon_sym_with] = ACTIONS(2382),
    [anon_sym_break] = ACTIONS(2382),
    [anon_sym_continue] = ACTIONS(2382),
    [anon_sym_debugger] = ACTIONS(2382),
    [anon_sym_return] = ACTIONS(2382),
    [anon_sym_throw] = ACTIONS(2382),
    [anon_sym_SEMI] = ACTIONS(2384),
    [anon_sym_case] = ACTIONS(2382),
    [anon_sym_default] = ACTIONS(2382),
    [anon_sym_yield] = ACTIONS(2382),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_LTtemplate_GT] = ACTIONS(2384),
    [anon_sym_LT] = ACTIONS(2382),
    [anon_sym_SLASH] = ACTIONS(2382),
    [anon_sym_DOT] = ACTIONS(2382),
    [anon_sym_class] = ACTIONS(2382),
    [anon_sym_async] = ACTIONS(2382),
    [anon_sym_function] = ACTIONS(2382),
    [anon_sym_new] = ACTIONS(2382),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_DASH] = ACTIONS(2379),
    [anon_sym_TILDE] = ACTIONS(2384),
    [anon_sym_void] = ACTIONS(2382),
    [anon_sym_delete] = ACTIONS(2382),
    [anon_sym_PLUS_PLUS] = ACTIONS(2384),
    [anon_sym_DASH_DASH] = ACTIONS(2384),
    [anon_sym_DQUOTE] = ACTIONS(2384),
    [anon_sym_SQUOTE] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2384),
    [sym_number] = ACTIONS(2386),
    [sym_this] = ACTIONS(2382),
    [sym_super] = ACTIONS(2382),
    [sym_true] = ACTIONS(2382),
    [sym_false] = ACTIONS(2382),
    [sym_null] = ACTIONS(2382),
    [sym_undefined] = ACTIONS(2382),
    [anon_sym_AT] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2382),
    [anon_sym_readonly] = ACTIONS(2382),
    [anon_sym_get] = ACTIONS(2382),
    [anon_sym_set] = ACTIONS(2382),
    [anon_sym_declare] = ACTIONS(2382),
    [anon_sym_namespace] = ACTIONS(2382),
    [anon_sym_public] = ACTIONS(2382),
    [anon_sym_private] = ACTIONS(2382),
    [anon_sym_protected] = ACTIONS(2382),
    [anon_sym_override] = ACTIONS(2382),
    [anon_sym_module] = ACTIONS(2382),
    [anon_sym_any] = ACTIONS(2382),
    [anon_sym_number] = ACTIONS(2382),
    [anon_sym_boolean] = ACTIONS(2382),
    [anon_sym_string] = ACTIONS(2382),
    [anon_sym_symbol] = ACTIONS(2382),
    [anon_sym_abstract] = ACTIONS(2382),
    [anon_sym_interface] = ACTIONS(2382),
    [anon_sym_enum] = ACTIONS(2382),
    [anon_sym_component] = ACTIONS(2382),
  },
  [620] = {
    [ts_builtin_sym_end] = ACTIONS(1704),
    [sym_identifier] = ACTIONS(1702),
    [anon_sym_export] = ACTIONS(1702),
    [anon_sym_LBRACE] = ACTIONS(1704),
    [anon_sym_RBRACE] = ACTIONS(1704),
    [anon_sym_type] = ACTIONS(1702),
    [anon_sym_typeof] = ACTIONS(1702),
    [anon_sym_import] = ACTIONS(1702),
    [anon_sym_var] = ACTIONS(1702),
    [anon_sym_let] = ACTIONS(1702),
    [anon_sym_const] = ACTIONS(1702),
    [anon_sym_BANG] = ACTIONS(1704),
    [anon_sym_else] = ACTIONS(1702),
    [anon_sym_if] = ACTIONS(1702),
    [anon_sym_switch] = ACTIONS(1702),
    [anon_sym_for] = ACTIONS(1702),
    [anon_sym_LPAREN] = ACTIONS(1704),
    [anon_sym_await] = ACTIONS(1702),
    [anon_sym_while] = ACTIONS(1702),
    [anon_sym_do] = ACTIONS(1702),
    [anon_sym_try] = ACTIONS(1702),
    [anon_sym_with] = ACTIONS(1702),
    [anon_sym_break] = ACTIONS(1702),
    [anon_sym_continue] = ACTIONS(1702),
    [anon_sym_debugger] = ACTIONS(1702),
    [anon_sym_return] = ACTIONS(1702),
    [anon_sym_throw] = ACTIONS(1702),
    [anon_sym_SEMI] = ACTIONS(1704),
    [anon_sym_case] = ACTIONS(1702),
    [anon_sym_default] = ACTIONS(1702),
    [anon_sym_yield] = ACTIONS(1702),
    [anon_sym_LBRACK] = ACTIONS(1704),
    [anon_sym_LTtemplate_GT] = ACTIONS(1704),
    [anon_sym_LT] = ACTIONS(1702),
    [anon_sym_SLASH] = ACTIONS(1702),
    [anon_sym_class] = ACTIONS(1702),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(1702),
    [anon_sym_new] = ACTIONS(1702),
    [anon_sym_AMP] = ACTIONS(1704),
    [anon_sym_PLUS] = ACTIONS(1702),
    [anon_sym_DASH] = ACTIONS(1702),
    [anon_sym_TILDE] = ACTIONS(1704),
    [anon_sym_void] = ACTIONS(1702),
    [anon_sym_delete] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1704),
    [anon_sym_DASH_DASH] = ACTIONS(1704),
    [anon_sym_DQUOTE] = ACTIONS(1704),
    [anon_sym_SQUOTE] = ACTIONS(1704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1704),
    [sym_number] = ACTIONS(1704),
    [sym_this] = ACTIONS(1702),
    [sym_super] = ACTIONS(1702),
    [sym_true] = ACTIONS(1702),
    [sym_false] = ACTIONS(1702),
    [sym_null] = ACTIONS(1702),
    [sym_undefined] = ACTIONS(1702),
    [anon_sym_AT] = ACTIONS(1704),
    [anon_sym_static] = ACTIONS(1702),
    [anon_sym_readonly] = ACTIONS(1702),
    [anon_sym_get] = ACTIONS(1702),
    [anon_sym_set] = ACTIONS(1702),
    [anon_sym_declare] = ACTIONS(1702),
    [anon_sym_namespace] = ACTIONS(1702),
    [anon_sym_public] = ACTIONS(1702),
    [anon_sym_private] = ACTIONS(1702),
    [anon_sym_protected] = ACTIONS(1702),
    [anon_sym_override] = ACTIONS(1702),
    [anon_sym_module] = ACTIONS(1702),
    [anon_sym_any] = ACTIONS(1702),
    [anon_sym_number] = ACTIONS(1702),
    [anon_sym_boolean] = ACTIONS(1702),
    [anon_sym_string] = ACTIONS(1702),
    [anon_sym_symbol] = ACTIONS(1702),
    [anon_sym_abstract] = ACTIONS(1702),
    [anon_sym_interface] = ACTIONS(1702),
    [anon_sym_enum] = ACTIONS(1702),
    [anon_sym_component] = ACTIONS(1702),
    [anon_sym_instance] = ACTIONS(1702),
    [sym__automatic_semicolon] = ACTIONS(1704),
  },
  [621] = {
    [ts_builtin_sym_end] = ACTIONS(1446),
    [sym_identifier] = ACTIONS(1442),
    [anon_sym_export] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [anon_sym_type] = ACTIONS(1442),
    [anon_sym_typeof] = ACTIONS(1442),
    [anon_sym_import] = ACTIONS(1442),
    [anon_sym_var] = ACTIONS(1442),
    [anon_sym_let] = ACTIONS(1442),
    [anon_sym_const] = ACTIONS(1442),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_else] = ACTIONS(1442),
    [anon_sym_if] = ACTIONS(1442),
    [anon_sym_switch] = ACTIONS(1442),
    [anon_sym_for] = ACTIONS(1442),
    [anon_sym_LPAREN] = ACTIONS(1446),
    [anon_sym_await] = ACTIONS(1442),
    [anon_sym_while] = ACTIONS(1442),
    [anon_sym_do] = ACTIONS(1442),
    [anon_sym_try] = ACTIONS(1442),
    [anon_sym_with] = ACTIONS(1442),
    [anon_sym_break] = ACTIONS(1442),
    [anon_sym_continue] = ACTIONS(1442),
    [anon_sym_debugger] = ACTIONS(1442),
    [anon_sym_return] = ACTIONS(1442),
    [anon_sym_throw] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_case] = ACTIONS(1442),
    [anon_sym_default] = ACTIONS(1442),
    [anon_sym_yield] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_LTtemplate_GT] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1442),
    [anon_sym_SLASH] = ACTIONS(1442),
    [anon_sym_class] = ACTIONS(1442),
    [anon_sym_async] = ACTIONS(1442),
    [anon_sym_function] = ACTIONS(1442),
    [anon_sym_new] = ACTIONS(1442),
    [anon_sym_AMP] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1446),
    [anon_sym_void] = ACTIONS(1442),
    [anon_sym_delete] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1446),
    [anon_sym_DASH_DASH] = ACTIONS(1446),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [anon_sym_SQUOTE] = ACTIONS(1446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [sym_number] = ACTIONS(1446),
    [sym_this] = ACTIONS(1442),
    [sym_super] = ACTIONS(1442),
    [sym_true] = ACTIONS(1442),
    [sym_false] = ACTIONS(1442),
    [sym_null] = ACTIONS(1442),
    [sym_undefined] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(1446),
    [anon_sym_static] = ACTIONS(1442),
    [anon_sym_readonly] = ACTIONS(1442),
    [anon_sym_get] = ACTIONS(1442),
    [anon_sym_set] = ACTIONS(1442),
    [anon_sym_declare] = ACTIONS(1442),
    [anon_sym_namespace] = ACTIONS(1442),
    [anon_sym_public] = ACTIONS(1442),
    [anon_sym_private] = ACTIONS(1442),
    [anon_sym_protected] = ACTIONS(1442),
    [anon_sym_override] = ACTIONS(1442),
    [anon_sym_module] = ACTIONS(1442),
    [anon_sym_any] = ACTIONS(1442),
    [anon_sym_number] = ACTIONS(1442),
    [anon_sym_boolean] = ACTIONS(1442),
    [anon_sym_string] = ACTIONS(1442),
    [anon_sym_symbol] = ACTIONS(1442),
    [anon_sym_abstract] = ACTIONS(1442),
    [anon_sym_interface] = ACTIONS(1442),
    [anon_sym_enum] = ACTIONS(1442),
    [anon_sym_component] = ACTIONS(1442),
    [anon_sym_instance] = ACTIONS(1442),
    [sym__automatic_semicolon] = ACTIONS(1450),
  },
  [622] = {
    [ts_builtin_sym_end] = ACTIONS(1436),
    [sym_identifier] = ACTIONS(1432),
    [anon_sym_export] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(1436),
    [anon_sym_RBRACE] = ACTIONS(1436),
    [anon_sym_type] = ACTIONS(1432),
    [anon_sym_typeof] = ACTIONS(1432),
    [anon_sym_import] = ACTIONS(1432),
    [anon_sym_var] = ACTIONS(1432),
    [anon_sym_let] = ACTIONS(1432),
    [anon_sym_const] = ACTIONS(1432),
    [anon_sym_BANG] = ACTIONS(1436),
    [anon_sym_else] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1432),
    [anon_sym_switch] = ACTIONS(1432),
    [anon_sym_for] = ACTIONS(1432),
    [anon_sym_LPAREN] = ACTIONS(1436),
    [anon_sym_await] = ACTIONS(1432),
    [anon_sym_while] = ACTIONS(1432),
    [anon_sym_do] = ACTIONS(1432),
    [anon_sym_try] = ACTIONS(1432),
    [anon_sym_with] = ACTIONS(1432),
    [anon_sym_break] = ACTIONS(1432),
    [anon_sym_continue] = ACTIONS(1432),
    [anon_sym_debugger] = ACTIONS(1432),
    [anon_sym_return] = ACTIONS(1432),
    [anon_sym_throw] = ACTIONS(1432),
    [anon_sym_SEMI] = ACTIONS(1436),
    [anon_sym_case] = ACTIONS(1432),
    [anon_sym_default] = ACTIONS(1432),
    [anon_sym_yield] = ACTIONS(1432),
    [anon_sym_LBRACK] = ACTIONS(1436),
    [anon_sym_LTtemplate_GT] = ACTIONS(1436),
    [anon_sym_LT] = ACTIONS(1432),
    [anon_sym_SLASH] = ACTIONS(1432),
    [anon_sym_class] = ACTIONS(1432),
    [anon_sym_async] = ACTIONS(1432),
    [anon_sym_function] = ACTIONS(1432),
    [anon_sym_new] = ACTIONS(1432),
    [anon_sym_AMP] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1432),
    [anon_sym_DASH] = ACTIONS(1432),
    [anon_sym_TILDE] = ACTIONS(1436),
    [anon_sym_void] = ACTIONS(1432),
    [anon_sym_delete] = ACTIONS(1432),
    [anon_sym_PLUS_PLUS] = ACTIONS(1436),
    [anon_sym_DASH_DASH] = ACTIONS(1436),
    [anon_sym_DQUOTE] = ACTIONS(1436),
    [anon_sym_SQUOTE] = ACTIONS(1436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1436),
    [sym_number] = ACTIONS(1436),
    [sym_this] = ACTIONS(1432),
    [sym_super] = ACTIONS(1432),
    [sym_true] = ACTIONS(1432),
    [sym_false] = ACTIONS(1432),
    [sym_null] = ACTIONS(1432),
    [sym_undefined] = ACTIONS(1432),
    [anon_sym_AT] = ACTIONS(1436),
    [anon_sym_static] = ACTIONS(1432),
    [anon_sym_readonly] = ACTIONS(1432),
    [anon_sym_get] = ACTIONS(1432),
    [anon_sym_set] = ACTIONS(1432),
    [anon_sym_declare] = ACTIONS(1432),
    [anon_sym_namespace] = ACTIONS(1432),
    [anon_sym_public] = ACTIONS(1432),
    [anon_sym_private] = ACTIONS(1432),
    [anon_sym_protected] = ACTIONS(1432),
    [anon_sym_override] = ACTIONS(1432),
    [anon_sym_module] = ACTIONS(1432),
    [anon_sym_any] = ACTIONS(1432),
    [anon_sym_number] = ACTIONS(1432),
    [anon_sym_boolean] = ACTIONS(1432),
    [anon_sym_string] = ACTIONS(1432),
    [anon_sym_symbol] = ACTIONS(1432),
    [anon_sym_abstract] = ACTIONS(1432),
    [anon_sym_interface] = ACTIONS(1432),
    [anon_sym_enum] = ACTIONS(1432),
    [anon_sym_component] = ACTIONS(1432),
    [anon_sym_instance] = ACTIONS(1432),
    [sym__automatic_semicolon] = ACTIONS(1440),
  },
  [623] = {
    [ts_builtin_sym_end] = ACTIONS(1426),
    [sym_identifier] = ACTIONS(1422),
    [anon_sym_export] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(1426),
    [anon_sym_RBRACE] = ACTIONS(1426),
    [anon_sym_type] = ACTIONS(1422),
    [anon_sym_typeof] = ACTIONS(1422),
    [anon_sym_import] = ACTIONS(1422),
    [anon_sym_var] = ACTIONS(1422),
    [anon_sym_let] = ACTIONS(1422),
    [anon_sym_const] = ACTIONS(1422),
    [anon_sym_BANG] = ACTIONS(1426),
    [anon_sym_else] = ACTIONS(1422),
    [anon_sym_if] = ACTIONS(1422),
    [anon_sym_switch] = ACTIONS(1422),
    [anon_sym_for] = ACTIONS(1422),
    [anon_sym_LPAREN] = ACTIONS(1426),
    [anon_sym_await] = ACTIONS(1422),
    [anon_sym_while] = ACTIONS(1422),
    [anon_sym_do] = ACTIONS(1422),
    [anon_sym_try] = ACTIONS(1422),
    [anon_sym_with] = ACTIONS(1422),
    [anon_sym_break] = ACTIONS(1422),
    [anon_sym_continue] = ACTIONS(1422),
    [anon_sym_debugger] = ACTIONS(1422),
    [anon_sym_return] = ACTIONS(1422),
    [anon_sym_throw] = ACTIONS(1422),
    [anon_sym_SEMI] = ACTIONS(1426),
    [anon_sym_case] = ACTIONS(1422),
    [anon_sym_default] = ACTIONS(1422),
    [anon_sym_yield] = ACTIONS(1422),
    [anon_sym_LBRACK] = ACTIONS(1426),
    [anon_sym_LTtemplate_GT] = ACTIONS(1426),
    [anon_sym_LT] = ACTIONS(1422),
    [anon_sym_SLASH] = ACTIONS(1422),
    [anon_sym_class] = ACTIONS(1422),
    [anon_sym_async] = ACTIONS(1422),
    [anon_sym_function] = ACTIONS(1422),
    [anon_sym_new] = ACTIONS(1422),
    [anon_sym_AMP] = ACTIONS(1426),
    [anon_sym_PLUS] = ACTIONS(1422),
    [anon_sym_DASH] = ACTIONS(1422),
    [anon_sym_TILDE] = ACTIONS(1426),
    [anon_sym_void] = ACTIONS(1422),
    [anon_sym_delete] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1426),
    [anon_sym_DASH_DASH] = ACTIONS(1426),
    [anon_sym_DQUOTE] = ACTIONS(1426),
    [anon_sym_SQUOTE] = ACTIONS(1426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1426),
    [sym_number] = ACTIONS(1426),
    [sym_this] = ACTIONS(1422),
    [sym_super] = ACTIONS(1422),
    [sym_true] = ACTIONS(1422),
    [sym_false] = ACTIONS(1422),
    [sym_null] = ACTIONS(1422),
    [sym_undefined] = ACTIONS(1422),
    [anon_sym_AT] = ACTIONS(1426),
    [anon_sym_static] = ACTIONS(1422),
    [anon_sym_readonly] = ACTIONS(1422),
    [anon_sym_get] = ACTIONS(1422),
    [anon_sym_set] = ACTIONS(1422),
    [anon_sym_declare] = ACTIONS(1422),
    [anon_sym_namespace] = ACTIONS(1422),
    [anon_sym_public] = ACTIONS(1422),
    [anon_sym_private] = ACTIONS(1422),
    [anon_sym_protected] = ACTIONS(1422),
    [anon_sym_override] = ACTIONS(1422),
    [anon_sym_module] = ACTIONS(1422),
    [anon_sym_any] = ACTIONS(1422),
    [anon_sym_number] = ACTIONS(1422),
    [anon_sym_boolean] = ACTIONS(1422),
    [anon_sym_string] = ACTIONS(1422),
    [anon_sym_symbol] = ACTIONS(1422),
    [anon_sym_abstract] = ACTIONS(1422),
    [anon_sym_interface] = ACTIONS(1422),
    [anon_sym_enum] = ACTIONS(1422),
    [anon_sym_component] = ACTIONS(1422),
    [anon_sym_instance] = ACTIONS(1422),
    [sym__automatic_semicolon] = ACTIONS(1430),
  },
  [624] = {
    [sym__call_signature] = STATE(4721),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2313),
    [anon_sym_export] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(1180),
    [anon_sym_RBRACE] = ACTIONS(1180),
    [anon_sym_type] = ACTIONS(2315),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_RBRACK] = ACTIONS(1180),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2315),
    [anon_sym_function] = ACTIONS(2317),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2315),
    [anon_sym_readonly] = ACTIONS(2315),
    [anon_sym_get] = ACTIONS(2315),
    [anon_sym_set] = ACTIONS(2315),
    [anon_sym_declare] = ACTIONS(2315),
    [anon_sym_namespace] = ACTIONS(2315),
    [anon_sym_public] = ACTIONS(2315),
    [anon_sym_private] = ACTIONS(2315),
    [anon_sym_protected] = ACTIONS(2315),
    [anon_sym_override] = ACTIONS(2315),
    [anon_sym_module] = ACTIONS(2315),
    [anon_sym_any] = ACTIONS(2315),
    [anon_sym_number] = ACTIONS(2315),
    [anon_sym_boolean] = ACTIONS(2315),
    [anon_sym_string] = ACTIONS(2315),
    [anon_sym_symbol] = ACTIONS(2315),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [625] = {
    [ts_builtin_sym_end] = ACTIONS(1416),
    [sym_identifier] = ACTIONS(1412),
    [anon_sym_export] = ACTIONS(1412),
    [anon_sym_LBRACE] = ACTIONS(1416),
    [anon_sym_RBRACE] = ACTIONS(1416),
    [anon_sym_type] = ACTIONS(1412),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_import] = ACTIONS(1412),
    [anon_sym_var] = ACTIONS(1412),
    [anon_sym_let] = ACTIONS(1412),
    [anon_sym_const] = ACTIONS(1412),
    [anon_sym_BANG] = ACTIONS(1416),
    [anon_sym_else] = ACTIONS(1412),
    [anon_sym_if] = ACTIONS(1412),
    [anon_sym_switch] = ACTIONS(1412),
    [anon_sym_for] = ACTIONS(1412),
    [anon_sym_LPAREN] = ACTIONS(1416),
    [anon_sym_await] = ACTIONS(1412),
    [anon_sym_while] = ACTIONS(1412),
    [anon_sym_do] = ACTIONS(1412),
    [anon_sym_try] = ACTIONS(1412),
    [anon_sym_with] = ACTIONS(1412),
    [anon_sym_break] = ACTIONS(1412),
    [anon_sym_continue] = ACTIONS(1412),
    [anon_sym_debugger] = ACTIONS(1412),
    [anon_sym_return] = ACTIONS(1412),
    [anon_sym_throw] = ACTIONS(1412),
    [anon_sym_SEMI] = ACTIONS(1416),
    [anon_sym_case] = ACTIONS(1412),
    [anon_sym_default] = ACTIONS(1412),
    [anon_sym_yield] = ACTIONS(1412),
    [anon_sym_LBRACK] = ACTIONS(1416),
    [anon_sym_LTtemplate_GT] = ACTIONS(1416),
    [anon_sym_LT] = ACTIONS(1412),
    [anon_sym_SLASH] = ACTIONS(1412),
    [anon_sym_class] = ACTIONS(1412),
    [anon_sym_async] = ACTIONS(1412),
    [anon_sym_function] = ACTIONS(1412),
    [anon_sym_new] = ACTIONS(1412),
    [anon_sym_AMP] = ACTIONS(1416),
    [anon_sym_PLUS] = ACTIONS(1412),
    [anon_sym_DASH] = ACTIONS(1412),
    [anon_sym_TILDE] = ACTIONS(1416),
    [anon_sym_void] = ACTIONS(1412),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_PLUS_PLUS] = ACTIONS(1416),
    [anon_sym_DASH_DASH] = ACTIONS(1416),
    [anon_sym_DQUOTE] = ACTIONS(1416),
    [anon_sym_SQUOTE] = ACTIONS(1416),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [sym_number] = ACTIONS(1416),
    [sym_this] = ACTIONS(1412),
    [sym_super] = ACTIONS(1412),
    [sym_true] = ACTIONS(1412),
    [sym_false] = ACTIONS(1412),
    [sym_null] = ACTIONS(1412),
    [sym_undefined] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(1416),
    [anon_sym_static] = ACTIONS(1412),
    [anon_sym_readonly] = ACTIONS(1412),
    [anon_sym_get] = ACTIONS(1412),
    [anon_sym_set] = ACTIONS(1412),
    [anon_sym_declare] = ACTIONS(1412),
    [anon_sym_namespace] = ACTIONS(1412),
    [anon_sym_public] = ACTIONS(1412),
    [anon_sym_private] = ACTIONS(1412),
    [anon_sym_protected] = ACTIONS(1412),
    [anon_sym_override] = ACTIONS(1412),
    [anon_sym_module] = ACTIONS(1412),
    [anon_sym_any] = ACTIONS(1412),
    [anon_sym_number] = ACTIONS(1412),
    [anon_sym_boolean] = ACTIONS(1412),
    [anon_sym_string] = ACTIONS(1412),
    [anon_sym_symbol] = ACTIONS(1412),
    [anon_sym_abstract] = ACTIONS(1412),
    [anon_sym_interface] = ACTIONS(1412),
    [anon_sym_enum] = ACTIONS(1412),
    [anon_sym_component] = ACTIONS(1412),
    [anon_sym_instance] = ACTIONS(1412),
    [sym__automatic_semicolon] = ACTIONS(1420),
  },
  [626] = {
    [sym__call_signature] = STATE(4721),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2313),
    [anon_sym_export] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(65),
    [anon_sym_type] = ACTIONS(2315),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_RPAREN] = ACTIONS(65),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_RBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2315),
    [anon_sym_function] = ACTIONS(2317),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2315),
    [anon_sym_readonly] = ACTIONS(2315),
    [anon_sym_get] = ACTIONS(2315),
    [anon_sym_set] = ACTIONS(2315),
    [anon_sym_declare] = ACTIONS(2315),
    [anon_sym_namespace] = ACTIONS(2315),
    [anon_sym_public] = ACTIONS(2315),
    [anon_sym_private] = ACTIONS(2315),
    [anon_sym_protected] = ACTIONS(2315),
    [anon_sym_override] = ACTIONS(2315),
    [anon_sym_module] = ACTIONS(2315),
    [anon_sym_any] = ACTIONS(2315),
    [anon_sym_number] = ACTIONS(2315),
    [anon_sym_boolean] = ACTIONS(2315),
    [anon_sym_string] = ACTIONS(2315),
    [anon_sym_symbol] = ACTIONS(2315),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [627] = {
    [ts_builtin_sym_end] = ACTIONS(1486),
    [sym_identifier] = ACTIONS(1482),
    [anon_sym_export] = ACTIONS(1482),
    [anon_sym_LBRACE] = ACTIONS(1486),
    [anon_sym_RBRACE] = ACTIONS(1486),
    [anon_sym_type] = ACTIONS(1482),
    [anon_sym_typeof] = ACTIONS(1482),
    [anon_sym_import] = ACTIONS(1482),
    [anon_sym_var] = ACTIONS(1482),
    [anon_sym_let] = ACTIONS(1482),
    [anon_sym_const] = ACTIONS(1482),
    [anon_sym_BANG] = ACTIONS(1486),
    [anon_sym_else] = ACTIONS(1482),
    [anon_sym_if] = ACTIONS(1482),
    [anon_sym_switch] = ACTIONS(1482),
    [anon_sym_for] = ACTIONS(1482),
    [anon_sym_LPAREN] = ACTIONS(1486),
    [anon_sym_await] = ACTIONS(1482),
    [anon_sym_while] = ACTIONS(1482),
    [anon_sym_do] = ACTIONS(1482),
    [anon_sym_try] = ACTIONS(1482),
    [anon_sym_with] = ACTIONS(1482),
    [anon_sym_break] = ACTIONS(1482),
    [anon_sym_continue] = ACTIONS(1482),
    [anon_sym_debugger] = ACTIONS(1482),
    [anon_sym_return] = ACTIONS(1482),
    [anon_sym_throw] = ACTIONS(1482),
    [anon_sym_SEMI] = ACTIONS(1486),
    [anon_sym_case] = ACTIONS(1482),
    [anon_sym_default] = ACTIONS(1482),
    [anon_sym_yield] = ACTIONS(1482),
    [anon_sym_LBRACK] = ACTIONS(1486),
    [anon_sym_LTtemplate_GT] = ACTIONS(1486),
    [anon_sym_LT] = ACTIONS(1482),
    [anon_sym_SLASH] = ACTIONS(1482),
    [anon_sym_class] = ACTIONS(1482),
    [anon_sym_async] = ACTIONS(1482),
    [anon_sym_function] = ACTIONS(1482),
    [anon_sym_new] = ACTIONS(1482),
    [anon_sym_AMP] = ACTIONS(1486),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1482),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_void] = ACTIONS(1482),
    [anon_sym_delete] = ACTIONS(1482),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1486),
    [sym_number] = ACTIONS(1486),
    [sym_this] = ACTIONS(1482),
    [sym_super] = ACTIONS(1482),
    [sym_true] = ACTIONS(1482),
    [sym_false] = ACTIONS(1482),
    [sym_null] = ACTIONS(1482),
    [sym_undefined] = ACTIONS(1482),
    [anon_sym_AT] = ACTIONS(1486),
    [anon_sym_static] = ACTIONS(1482),
    [anon_sym_readonly] = ACTIONS(1482),
    [anon_sym_get] = ACTIONS(1482),
    [anon_sym_set] = ACTIONS(1482),
    [anon_sym_declare] = ACTIONS(1482),
    [anon_sym_namespace] = ACTIONS(1482),
    [anon_sym_public] = ACTIONS(1482),
    [anon_sym_private] = ACTIONS(1482),
    [anon_sym_protected] = ACTIONS(1482),
    [anon_sym_override] = ACTIONS(1482),
    [anon_sym_module] = ACTIONS(1482),
    [anon_sym_any] = ACTIONS(1482),
    [anon_sym_number] = ACTIONS(1482),
    [anon_sym_boolean] = ACTIONS(1482),
    [anon_sym_string] = ACTIONS(1482),
    [anon_sym_symbol] = ACTIONS(1482),
    [anon_sym_abstract] = ACTIONS(1482),
    [anon_sym_interface] = ACTIONS(1482),
    [anon_sym_enum] = ACTIONS(1482),
    [anon_sym_component] = ACTIONS(1482),
    [anon_sym_instance] = ACTIONS(1482),
    [sym__automatic_semicolon] = ACTIONS(1490),
  },
  [628] = {
    [sym__call_signature] = STATE(4800),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2389),
    [anon_sym_export] = ACTIONS(2391),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_type] = ACTIONS(2391),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_of] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(2393),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2391),
    [anon_sym_function] = ACTIONS(2343),
    [anon_sym_EQ_GT] = ACTIONS(2395),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2391),
    [anon_sym_readonly] = ACTIONS(2391),
    [anon_sym_get] = ACTIONS(2391),
    [anon_sym_set] = ACTIONS(2391),
    [anon_sym_declare] = ACTIONS(2391),
    [anon_sym_namespace] = ACTIONS(2391),
    [anon_sym_public] = ACTIONS(2391),
    [anon_sym_private] = ACTIONS(2391),
    [anon_sym_protected] = ACTIONS(2391),
    [anon_sym_override] = ACTIONS(2391),
    [anon_sym_module] = ACTIONS(2391),
    [anon_sym_any] = ACTIONS(2391),
    [anon_sym_number] = ACTIONS(2391),
    [anon_sym_boolean] = ACTIONS(2391),
    [anon_sym_string] = ACTIONS(2391),
    [anon_sym_symbol] = ACTIONS(2391),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [629] = {
    [sym__call_signature] = STATE(4800),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2389),
    [anon_sym_export] = ACTIONS(2391),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_type] = ACTIONS(2391),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_of] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2391),
    [anon_sym_function] = ACTIONS(2343),
    [anon_sym_EQ_GT] = ACTIONS(2395),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2391),
    [anon_sym_readonly] = ACTIONS(2391),
    [anon_sym_get] = ACTIONS(2391),
    [anon_sym_set] = ACTIONS(2391),
    [anon_sym_declare] = ACTIONS(2391),
    [anon_sym_namespace] = ACTIONS(2391),
    [anon_sym_public] = ACTIONS(2391),
    [anon_sym_private] = ACTIONS(2391),
    [anon_sym_protected] = ACTIONS(2391),
    [anon_sym_override] = ACTIONS(2391),
    [anon_sym_module] = ACTIONS(2391),
    [anon_sym_any] = ACTIONS(2391),
    [anon_sym_number] = ACTIONS(2391),
    [anon_sym_boolean] = ACTIONS(2391),
    [anon_sym_string] = ACTIONS(2391),
    [anon_sym_symbol] = ACTIONS(2391),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [630] = {
    [sym_identifier] = ACTIONS(1524),
    [anon_sym_export] = ACTIONS(1524),
    [anon_sym_LBRACE] = ACTIONS(1526),
    [anon_sym_RBRACE] = ACTIONS(1526),
    [anon_sym_type] = ACTIONS(1524),
    [anon_sym_typeof] = ACTIONS(1524),
    [anon_sym_import] = ACTIONS(1524),
    [anon_sym_var] = ACTIONS(1524),
    [anon_sym_let] = ACTIONS(1524),
    [anon_sym_const] = ACTIONS(1524),
    [anon_sym_BANG] = ACTIONS(1526),
    [anon_sym_else] = ACTIONS(1524),
    [anon_sym_if] = ACTIONS(1524),
    [anon_sym_switch] = ACTIONS(1524),
    [anon_sym_for] = ACTIONS(1524),
    [anon_sym_LPAREN] = ACTIONS(1526),
    [anon_sym_await] = ACTIONS(1524),
    [anon_sym_while] = ACTIONS(1524),
    [anon_sym_do] = ACTIONS(1524),
    [anon_sym_try] = ACTIONS(1524),
    [anon_sym_with] = ACTIONS(1524),
    [anon_sym_break] = ACTIONS(1524),
    [anon_sym_continue] = ACTIONS(1524),
    [anon_sym_debugger] = ACTIONS(1524),
    [anon_sym_return] = ACTIONS(1524),
    [anon_sym_throw] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1526),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1524),
    [anon_sym_catch] = ACTIONS(1524),
    [anon_sym_finally] = ACTIONS(1524),
    [anon_sym_yield] = ACTIONS(1524),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LTtemplate_GT] = ACTIONS(1526),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_SLASH] = ACTIONS(1524),
    [anon_sym_class] = ACTIONS(1524),
    [anon_sym_async] = ACTIONS(1524),
    [anon_sym_function] = ACTIONS(1524),
    [anon_sym_new] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1526),
    [anon_sym_PLUS] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1524),
    [anon_sym_TILDE] = ACTIONS(1526),
    [anon_sym_void] = ACTIONS(1524),
    [anon_sym_delete] = ACTIONS(1524),
    [anon_sym_PLUS_PLUS] = ACTIONS(1526),
    [anon_sym_DASH_DASH] = ACTIONS(1526),
    [anon_sym_DQUOTE] = ACTIONS(1526),
    [anon_sym_SQUOTE] = ACTIONS(1526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1526),
    [sym_number] = ACTIONS(1526),
    [sym_this] = ACTIONS(1524),
    [sym_super] = ACTIONS(1524),
    [sym_true] = ACTIONS(1524),
    [sym_false] = ACTIONS(1524),
    [sym_null] = ACTIONS(1524),
    [sym_undefined] = ACTIONS(1524),
    [anon_sym_AT] = ACTIONS(1526),
    [anon_sym_static] = ACTIONS(1524),
    [anon_sym_readonly] = ACTIONS(1524),
    [anon_sym_get] = ACTIONS(1524),
    [anon_sym_set] = ACTIONS(1524),
    [anon_sym_declare] = ACTIONS(1524),
    [anon_sym_namespace] = ACTIONS(1524),
    [anon_sym_public] = ACTIONS(1524),
    [anon_sym_private] = ACTIONS(1524),
    [anon_sym_protected] = ACTIONS(1524),
    [anon_sym_override] = ACTIONS(1524),
    [anon_sym_module] = ACTIONS(1524),
    [anon_sym_any] = ACTIONS(1524),
    [anon_sym_number] = ACTIONS(1524),
    [anon_sym_boolean] = ACTIONS(1524),
    [anon_sym_string] = ACTIONS(1524),
    [anon_sym_symbol] = ACTIONS(1524),
    [anon_sym_abstract] = ACTIONS(1524),
    [anon_sym_interface] = ACTIONS(1524),
    [anon_sym_enum] = ACTIONS(1524),
    [anon_sym_component] = ACTIONS(1524),
    [sym__automatic_semicolon] = ACTIONS(2397),
  },
  [631] = {
    [sym_identifier] = ACTIONS(1366),
    [anon_sym_export] = ACTIONS(1366),
    [anon_sym_LBRACE] = ACTIONS(1370),
    [anon_sym_RBRACE] = ACTIONS(1370),
    [anon_sym_type] = ACTIONS(1366),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_import] = ACTIONS(1366),
    [anon_sym_var] = ACTIONS(1366),
    [anon_sym_let] = ACTIONS(1366),
    [anon_sym_const] = ACTIONS(1366),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_else] = ACTIONS(1366),
    [anon_sym_if] = ACTIONS(1366),
    [anon_sym_switch] = ACTIONS(1366),
    [anon_sym_for] = ACTIONS(1366),
    [anon_sym_LPAREN] = ACTIONS(1370),
    [anon_sym_await] = ACTIONS(1366),
    [anon_sym_while] = ACTIONS(1366),
    [anon_sym_do] = ACTIONS(1366),
    [anon_sym_try] = ACTIONS(1366),
    [anon_sym_with] = ACTIONS(1366),
    [anon_sym_break] = ACTIONS(1366),
    [anon_sym_continue] = ACTIONS(1366),
    [anon_sym_debugger] = ACTIONS(1366),
    [anon_sym_return] = ACTIONS(1366),
    [anon_sym_throw] = ACTIONS(1366),
    [anon_sym_SEMI] = ACTIONS(1370),
    [anon_sym_case] = ACTIONS(1366),
    [anon_sym_default] = ACTIONS(1366),
    [anon_sym_catch] = ACTIONS(1366),
    [anon_sym_finally] = ACTIONS(1366),
    [anon_sym_yield] = ACTIONS(1366),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_LTtemplate_GT] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_SLASH] = ACTIONS(1366),
    [anon_sym_class] = ACTIONS(1366),
    [anon_sym_async] = ACTIONS(1366),
    [anon_sym_function] = ACTIONS(1366),
    [anon_sym_new] = ACTIONS(1366),
    [anon_sym_AMP] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1366),
    [anon_sym_DASH] = ACTIONS(1366),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1366),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_DQUOTE] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1370),
    [sym_number] = ACTIONS(1370),
    [sym_this] = ACTIONS(1366),
    [sym_super] = ACTIONS(1366),
    [sym_true] = ACTIONS(1366),
    [sym_false] = ACTIONS(1366),
    [sym_null] = ACTIONS(1366),
    [sym_undefined] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(1370),
    [anon_sym_static] = ACTIONS(1366),
    [anon_sym_readonly] = ACTIONS(1366),
    [anon_sym_get] = ACTIONS(1366),
    [anon_sym_set] = ACTIONS(1366),
    [anon_sym_declare] = ACTIONS(1366),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_public] = ACTIONS(1366),
    [anon_sym_private] = ACTIONS(1366),
    [anon_sym_protected] = ACTIONS(1366),
    [anon_sym_override] = ACTIONS(1366),
    [anon_sym_module] = ACTIONS(1366),
    [anon_sym_any] = ACTIONS(1366),
    [anon_sym_number] = ACTIONS(1366),
    [anon_sym_boolean] = ACTIONS(1366),
    [anon_sym_string] = ACTIONS(1366),
    [anon_sym_symbol] = ACTIONS(1366),
    [anon_sym_abstract] = ACTIONS(1366),
    [anon_sym_interface] = ACTIONS(1366),
    [anon_sym_enum] = ACTIONS(1366),
    [anon_sym_component] = ACTIONS(1366),
    [sym__automatic_semicolon] = ACTIONS(1376),
  },
  [632] = {
    [sym__call_signature] = STATE(4874),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2339),
    [anon_sym_export] = ACTIONS(2341),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_type] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1940),
    [anon_sym_EQ] = ACTIONS(1938),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2341),
    [anon_sym_function] = ACTIONS(2399),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2341),
    [anon_sym_readonly] = ACTIONS(2341),
    [anon_sym_get] = ACTIONS(2341),
    [anon_sym_set] = ACTIONS(2341),
    [anon_sym_declare] = ACTIONS(2341),
    [anon_sym_namespace] = ACTIONS(2341),
    [anon_sym_public] = ACTIONS(2341),
    [anon_sym_private] = ACTIONS(2341),
    [anon_sym_protected] = ACTIONS(2341),
    [anon_sym_override] = ACTIONS(2341),
    [anon_sym_module] = ACTIONS(2341),
    [anon_sym_any] = ACTIONS(2341),
    [anon_sym_number] = ACTIONS(2341),
    [anon_sym_boolean] = ACTIONS(2341),
    [anon_sym_string] = ACTIONS(2341),
    [anon_sym_symbol] = ACTIONS(2341),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [633] = {
    [sym_statement_block] = STATE(822),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_export] = ACTIONS(2401),
    [anon_sym_LBRACE] = ACTIONS(2403),
    [anon_sym_RBRACE] = ACTIONS(2405),
    [anon_sym_type] = ACTIONS(2401),
    [anon_sym_typeof] = ACTIONS(2401),
    [anon_sym_import] = ACTIONS(2401),
    [anon_sym_var] = ACTIONS(2401),
    [anon_sym_let] = ACTIONS(2401),
    [anon_sym_const] = ACTIONS(2401),
    [anon_sym_BANG] = ACTIONS(2405),
    [anon_sym_else] = ACTIONS(2401),
    [anon_sym_if] = ACTIONS(2401),
    [anon_sym_switch] = ACTIONS(2401),
    [anon_sym_for] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(2405),
    [anon_sym_await] = ACTIONS(2401),
    [anon_sym_while] = ACTIONS(2401),
    [anon_sym_do] = ACTIONS(2401),
    [anon_sym_try] = ACTIONS(2401),
    [anon_sym_with] = ACTIONS(2401),
    [anon_sym_break] = ACTIONS(2401),
    [anon_sym_continue] = ACTIONS(2401),
    [anon_sym_debugger] = ACTIONS(2401),
    [anon_sym_return] = ACTIONS(2401),
    [anon_sym_throw] = ACTIONS(2401),
    [anon_sym_SEMI] = ACTIONS(2405),
    [anon_sym_case] = ACTIONS(2401),
    [anon_sym_default] = ACTIONS(2401),
    [anon_sym_yield] = ACTIONS(2401),
    [anon_sym_LBRACK] = ACTIONS(2405),
    [anon_sym_LTtemplate_GT] = ACTIONS(2405),
    [anon_sym_LT] = ACTIONS(2401),
    [anon_sym_SLASH] = ACTIONS(2401),
    [anon_sym_DOT] = ACTIONS(2407),
    [anon_sym_class] = ACTIONS(2401),
    [anon_sym_async] = ACTIONS(2401),
    [anon_sym_function] = ACTIONS(2401),
    [anon_sym_new] = ACTIONS(2401),
    [anon_sym_AMP] = ACTIONS(2405),
    [anon_sym_PLUS] = ACTIONS(2401),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_TILDE] = ACTIONS(2405),
    [anon_sym_void] = ACTIONS(2401),
    [anon_sym_delete] = ACTIONS(2401),
    [anon_sym_PLUS_PLUS] = ACTIONS(2405),
    [anon_sym_DASH_DASH] = ACTIONS(2405),
    [anon_sym_DQUOTE] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(2405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2405),
    [sym_number] = ACTIONS(2405),
    [sym_this] = ACTIONS(2401),
    [sym_super] = ACTIONS(2401),
    [sym_true] = ACTIONS(2401),
    [sym_false] = ACTIONS(2401),
    [sym_null] = ACTIONS(2401),
    [sym_undefined] = ACTIONS(2401),
    [anon_sym_AT] = ACTIONS(2405),
    [anon_sym_static] = ACTIONS(2401),
    [anon_sym_readonly] = ACTIONS(2401),
    [anon_sym_get] = ACTIONS(2401),
    [anon_sym_set] = ACTIONS(2401),
    [anon_sym_declare] = ACTIONS(2401),
    [anon_sym_namespace] = ACTIONS(2401),
    [anon_sym_public] = ACTIONS(2401),
    [anon_sym_private] = ACTIONS(2401),
    [anon_sym_protected] = ACTIONS(2401),
    [anon_sym_override] = ACTIONS(2401),
    [anon_sym_module] = ACTIONS(2401),
    [anon_sym_any] = ACTIONS(2401),
    [anon_sym_number] = ACTIONS(2401),
    [anon_sym_boolean] = ACTIONS(2401),
    [anon_sym_string] = ACTIONS(2401),
    [anon_sym_symbol] = ACTIONS(2401),
    [anon_sym_abstract] = ACTIONS(2401),
    [anon_sym_interface] = ACTIONS(2401),
    [anon_sym_enum] = ACTIONS(2401),
    [anon_sym_component] = ACTIONS(2401),
  },
  [634] = {
    [ts_builtin_sym_end] = ACTIONS(2409),
    [sym_identifier] = ACTIONS(2411),
    [anon_sym_export] = ACTIONS(2411),
    [anon_sym_LBRACE] = ACTIONS(2409),
    [anon_sym_RBRACE] = ACTIONS(2409),
    [anon_sym_type] = ACTIONS(2411),
    [anon_sym_typeof] = ACTIONS(2411),
    [anon_sym_import] = ACTIONS(2411),
    [anon_sym_var] = ACTIONS(2411),
    [anon_sym_let] = ACTIONS(2411),
    [anon_sym_const] = ACTIONS(2411),
    [anon_sym_BANG] = ACTIONS(2409),
    [anon_sym_else] = ACTIONS(2411),
    [anon_sym_if] = ACTIONS(2411),
    [anon_sym_switch] = ACTIONS(2411),
    [anon_sym_for] = ACTIONS(2411),
    [anon_sym_LPAREN] = ACTIONS(2409),
    [anon_sym_await] = ACTIONS(2411),
    [anon_sym_while] = ACTIONS(2411),
    [anon_sym_do] = ACTIONS(2411),
    [anon_sym_try] = ACTIONS(2411),
    [anon_sym_with] = ACTIONS(2411),
    [anon_sym_break] = ACTIONS(2411),
    [anon_sym_continue] = ACTIONS(2411),
    [anon_sym_debugger] = ACTIONS(2411),
    [anon_sym_return] = ACTIONS(2411),
    [anon_sym_throw] = ACTIONS(2411),
    [anon_sym_SEMI] = ACTIONS(2409),
    [anon_sym_case] = ACTIONS(2411),
    [anon_sym_default] = ACTIONS(2411),
    [anon_sym_yield] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2409),
    [anon_sym_LTtemplate_GT] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(2411),
    [anon_sym_SLASH] = ACTIONS(2411),
    [anon_sym_class] = ACTIONS(2411),
    [anon_sym_async] = ACTIONS(2411),
    [anon_sym_function] = ACTIONS(2411),
    [anon_sym_new] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2411),
    [anon_sym_DASH] = ACTIONS(2411),
    [anon_sym_TILDE] = ACTIONS(2409),
    [anon_sym_void] = ACTIONS(2411),
    [anon_sym_delete] = ACTIONS(2411),
    [anon_sym_PLUS_PLUS] = ACTIONS(2409),
    [anon_sym_DASH_DASH] = ACTIONS(2409),
    [anon_sym_DQUOTE] = ACTIONS(2409),
    [anon_sym_SQUOTE] = ACTIONS(2409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2409),
    [sym_number] = ACTIONS(2409),
    [sym_this] = ACTIONS(2411),
    [sym_super] = ACTIONS(2411),
    [sym_true] = ACTIONS(2411),
    [sym_false] = ACTIONS(2411),
    [sym_null] = ACTIONS(2411),
    [sym_undefined] = ACTIONS(2411),
    [anon_sym_AT] = ACTIONS(2409),
    [anon_sym_static] = ACTIONS(2411),
    [anon_sym_readonly] = ACTIONS(2411),
    [anon_sym_get] = ACTIONS(2411),
    [anon_sym_set] = ACTIONS(2411),
    [anon_sym_declare] = ACTIONS(2411),
    [anon_sym_namespace] = ACTIONS(2411),
    [anon_sym_public] = ACTIONS(2411),
    [anon_sym_private] = ACTIONS(2411),
    [anon_sym_protected] = ACTIONS(2411),
    [anon_sym_override] = ACTIONS(2411),
    [anon_sym_module] = ACTIONS(2411),
    [anon_sym_any] = ACTIONS(2411),
    [anon_sym_number] = ACTIONS(2411),
    [anon_sym_boolean] = ACTIONS(2411),
    [anon_sym_string] = ACTIONS(2411),
    [anon_sym_symbol] = ACTIONS(2411),
    [anon_sym_abstract] = ACTIONS(2411),
    [anon_sym_interface] = ACTIONS(2411),
    [anon_sym_enum] = ACTIONS(2411),
    [anon_sym_component] = ACTIONS(2411),
    [anon_sym_instance] = ACTIONS(2411),
  },
  [635] = {
    [ts_builtin_sym_end] = ACTIONS(2413),
    [sym_identifier] = ACTIONS(2415),
    [anon_sym_export] = ACTIONS(2415),
    [anon_sym_LBRACE] = ACTIONS(2413),
    [anon_sym_RBRACE] = ACTIONS(2413),
    [anon_sym_type] = ACTIONS(2415),
    [anon_sym_typeof] = ACTIONS(2415),
    [anon_sym_import] = ACTIONS(2415),
    [anon_sym_var] = ACTIONS(2415),
    [anon_sym_let] = ACTIONS(2415),
    [anon_sym_const] = ACTIONS(2415),
    [anon_sym_BANG] = ACTIONS(2413),
    [anon_sym_else] = ACTIONS(2415),
    [anon_sym_if] = ACTIONS(2415),
    [anon_sym_switch] = ACTIONS(2415),
    [anon_sym_for] = ACTIONS(2415),
    [anon_sym_LPAREN] = ACTIONS(2413),
    [anon_sym_await] = ACTIONS(2415),
    [anon_sym_while] = ACTIONS(2415),
    [anon_sym_do] = ACTIONS(2415),
    [anon_sym_try] = ACTIONS(2415),
    [anon_sym_with] = ACTIONS(2415),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_continue] = ACTIONS(2415),
    [anon_sym_debugger] = ACTIONS(2415),
    [anon_sym_return] = ACTIONS(2415),
    [anon_sym_throw] = ACTIONS(2415),
    [anon_sym_SEMI] = ACTIONS(2413),
    [anon_sym_case] = ACTIONS(2415),
    [anon_sym_default] = ACTIONS(2415),
    [anon_sym_yield] = ACTIONS(2415),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LTtemplate_GT] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2415),
    [anon_sym_SLASH] = ACTIONS(2415),
    [anon_sym_class] = ACTIONS(2415),
    [anon_sym_async] = ACTIONS(2415),
    [anon_sym_function] = ACTIONS(2415),
    [anon_sym_new] = ACTIONS(2415),
    [anon_sym_AMP] = ACTIONS(2413),
    [anon_sym_PLUS] = ACTIONS(2415),
    [anon_sym_DASH] = ACTIONS(2415),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_void] = ACTIONS(2415),
    [anon_sym_delete] = ACTIONS(2415),
    [anon_sym_PLUS_PLUS] = ACTIONS(2413),
    [anon_sym_DASH_DASH] = ACTIONS(2413),
    [anon_sym_DQUOTE] = ACTIONS(2413),
    [anon_sym_SQUOTE] = ACTIONS(2413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2413),
    [sym_number] = ACTIONS(2413),
    [sym_this] = ACTIONS(2415),
    [sym_super] = ACTIONS(2415),
    [sym_true] = ACTIONS(2415),
    [sym_false] = ACTIONS(2415),
    [sym_null] = ACTIONS(2415),
    [sym_undefined] = ACTIONS(2415),
    [anon_sym_AT] = ACTIONS(2413),
    [anon_sym_static] = ACTIONS(2415),
    [anon_sym_readonly] = ACTIONS(2415),
    [anon_sym_get] = ACTIONS(2415),
    [anon_sym_set] = ACTIONS(2415),
    [anon_sym_declare] = ACTIONS(2415),
    [anon_sym_namespace] = ACTIONS(2415),
    [anon_sym_public] = ACTIONS(2415),
    [anon_sym_private] = ACTIONS(2415),
    [anon_sym_protected] = ACTIONS(2415),
    [anon_sym_override] = ACTIONS(2415),
    [anon_sym_module] = ACTIONS(2415),
    [anon_sym_any] = ACTIONS(2415),
    [anon_sym_number] = ACTIONS(2415),
    [anon_sym_boolean] = ACTIONS(2415),
    [anon_sym_string] = ACTIONS(2415),
    [anon_sym_symbol] = ACTIONS(2415),
    [anon_sym_abstract] = ACTIONS(2415),
    [anon_sym_interface] = ACTIONS(2415),
    [anon_sym_enum] = ACTIONS(2415),
    [anon_sym_component] = ACTIONS(2415),
    [anon_sym_instance] = ACTIONS(2415),
  },
  [636] = {
    [ts_builtin_sym_end] = ACTIONS(2417),
    [sym_identifier] = ACTIONS(2419),
    [anon_sym_export] = ACTIONS(2419),
    [anon_sym_LBRACE] = ACTIONS(2417),
    [anon_sym_RBRACE] = ACTIONS(2417),
    [anon_sym_type] = ACTIONS(2419),
    [anon_sym_typeof] = ACTIONS(2419),
    [anon_sym_import] = ACTIONS(2419),
    [anon_sym_var] = ACTIONS(2419),
    [anon_sym_let] = ACTIONS(2419),
    [anon_sym_const] = ACTIONS(2419),
    [anon_sym_BANG] = ACTIONS(2417),
    [anon_sym_else] = ACTIONS(2419),
    [anon_sym_if] = ACTIONS(2419),
    [anon_sym_switch] = ACTIONS(2419),
    [anon_sym_for] = ACTIONS(2419),
    [anon_sym_LPAREN] = ACTIONS(2417),
    [anon_sym_await] = ACTIONS(2419),
    [anon_sym_while] = ACTIONS(2419),
    [anon_sym_do] = ACTIONS(2419),
    [anon_sym_try] = ACTIONS(2419),
    [anon_sym_with] = ACTIONS(2419),
    [anon_sym_break] = ACTIONS(2419),
    [anon_sym_continue] = ACTIONS(2419),
    [anon_sym_debugger] = ACTIONS(2419),
    [anon_sym_return] = ACTIONS(2419),
    [anon_sym_throw] = ACTIONS(2419),
    [anon_sym_SEMI] = ACTIONS(2417),
    [anon_sym_case] = ACTIONS(2419),
    [anon_sym_default] = ACTIONS(2419),
    [anon_sym_yield] = ACTIONS(2419),
    [anon_sym_LBRACK] = ACTIONS(2417),
    [anon_sym_LTtemplate_GT] = ACTIONS(2417),
    [anon_sym_LT] = ACTIONS(2419),
    [anon_sym_SLASH] = ACTIONS(2419),
    [anon_sym_class] = ACTIONS(2419),
    [anon_sym_async] = ACTIONS(2419),
    [anon_sym_function] = ACTIONS(2419),
    [anon_sym_new] = ACTIONS(2419),
    [anon_sym_AMP] = ACTIONS(2417),
    [anon_sym_PLUS] = ACTIONS(2419),
    [anon_sym_DASH] = ACTIONS(2419),
    [anon_sym_TILDE] = ACTIONS(2417),
    [anon_sym_void] = ACTIONS(2419),
    [anon_sym_delete] = ACTIONS(2419),
    [anon_sym_PLUS_PLUS] = ACTIONS(2417),
    [anon_sym_DASH_DASH] = ACTIONS(2417),
    [anon_sym_DQUOTE] = ACTIONS(2417),
    [anon_sym_SQUOTE] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2417),
    [sym_number] = ACTIONS(2417),
    [sym_this] = ACTIONS(2419),
    [sym_super] = ACTIONS(2419),
    [sym_true] = ACTIONS(2419),
    [sym_false] = ACTIONS(2419),
    [sym_null] = ACTIONS(2419),
    [sym_undefined] = ACTIONS(2419),
    [anon_sym_AT] = ACTIONS(2417),
    [anon_sym_static] = ACTIONS(2419),
    [anon_sym_readonly] = ACTIONS(2419),
    [anon_sym_get] = ACTIONS(2419),
    [anon_sym_set] = ACTIONS(2419),
    [anon_sym_declare] = ACTIONS(2419),
    [anon_sym_namespace] = ACTIONS(2419),
    [anon_sym_public] = ACTIONS(2419),
    [anon_sym_private] = ACTIONS(2419),
    [anon_sym_protected] = ACTIONS(2419),
    [anon_sym_override] = ACTIONS(2419),
    [anon_sym_module] = ACTIONS(2419),
    [anon_sym_any] = ACTIONS(2419),
    [anon_sym_number] = ACTIONS(2419),
    [anon_sym_boolean] = ACTIONS(2419),
    [anon_sym_string] = ACTIONS(2419),
    [anon_sym_symbol] = ACTIONS(2419),
    [anon_sym_abstract] = ACTIONS(2419),
    [anon_sym_interface] = ACTIONS(2419),
    [anon_sym_enum] = ACTIONS(2419),
    [anon_sym_component] = ACTIONS(2419),
    [anon_sym_instance] = ACTIONS(2419),
  },
  [637] = {
    [sym__call_signature] = STATE(4721),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2313),
    [anon_sym_export] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(29),
    [anon_sym_type] = ACTIONS(2315),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_RBRACK] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2315),
    [anon_sym_function] = ACTIONS(2317),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2315),
    [anon_sym_readonly] = ACTIONS(2315),
    [anon_sym_get] = ACTIONS(2315),
    [anon_sym_set] = ACTIONS(2315),
    [anon_sym_declare] = ACTIONS(2315),
    [anon_sym_namespace] = ACTIONS(2315),
    [anon_sym_public] = ACTIONS(2315),
    [anon_sym_private] = ACTIONS(2315),
    [anon_sym_protected] = ACTIONS(2315),
    [anon_sym_override] = ACTIONS(2315),
    [anon_sym_module] = ACTIONS(2315),
    [anon_sym_any] = ACTIONS(2315),
    [anon_sym_number] = ACTIONS(2315),
    [anon_sym_boolean] = ACTIONS(2315),
    [anon_sym_string] = ACTIONS(2315),
    [anon_sym_symbol] = ACTIONS(2315),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [638] = {
    [sym__call_signature] = STATE(4684),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2349),
    [anon_sym_export] = ACTIONS(2351),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_type] = ACTIONS(2351),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_RPAREN] = ACTIONS(65),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2351),
    [anon_sym_function] = ACTIONS(2317),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2351),
    [anon_sym_readonly] = ACTIONS(2351),
    [anon_sym_get] = ACTIONS(2351),
    [anon_sym_set] = ACTIONS(2351),
    [anon_sym_declare] = ACTIONS(2351),
    [anon_sym_namespace] = ACTIONS(2351),
    [anon_sym_public] = ACTIONS(2351),
    [anon_sym_private] = ACTIONS(2351),
    [anon_sym_protected] = ACTIONS(2351),
    [anon_sym_override] = ACTIONS(2351),
    [anon_sym_module] = ACTIONS(2351),
    [anon_sym_any] = ACTIONS(2351),
    [anon_sym_number] = ACTIONS(2351),
    [anon_sym_boolean] = ACTIONS(2351),
    [anon_sym_string] = ACTIONS(2351),
    [anon_sym_symbol] = ACTIONS(2351),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [639] = {
    [ts_builtin_sym_end] = ACTIONS(2421),
    [sym_identifier] = ACTIONS(2423),
    [anon_sym_export] = ACTIONS(2423),
    [anon_sym_LBRACE] = ACTIONS(2421),
    [anon_sym_RBRACE] = ACTIONS(2421),
    [anon_sym_type] = ACTIONS(2423),
    [anon_sym_typeof] = ACTIONS(2423),
    [anon_sym_import] = ACTIONS(2423),
    [anon_sym_var] = ACTIONS(2423),
    [anon_sym_let] = ACTIONS(2423),
    [anon_sym_const] = ACTIONS(2423),
    [anon_sym_BANG] = ACTIONS(2421),
    [anon_sym_else] = ACTIONS(2423),
    [anon_sym_if] = ACTIONS(2423),
    [anon_sym_switch] = ACTIONS(2423),
    [anon_sym_for] = ACTIONS(2423),
    [anon_sym_LPAREN] = ACTIONS(2421),
    [anon_sym_await] = ACTIONS(2423),
    [anon_sym_while] = ACTIONS(2423),
    [anon_sym_do] = ACTIONS(2423),
    [anon_sym_try] = ACTIONS(2423),
    [anon_sym_with] = ACTIONS(2423),
    [anon_sym_break] = ACTIONS(2423),
    [anon_sym_continue] = ACTIONS(2423),
    [anon_sym_debugger] = ACTIONS(2423),
    [anon_sym_return] = ACTIONS(2423),
    [anon_sym_throw] = ACTIONS(2423),
    [anon_sym_SEMI] = ACTIONS(2421),
    [anon_sym_case] = ACTIONS(2423),
    [anon_sym_default] = ACTIONS(2423),
    [anon_sym_yield] = ACTIONS(2423),
    [anon_sym_LBRACK] = ACTIONS(2421),
    [anon_sym_LTtemplate_GT] = ACTIONS(2421),
    [anon_sym_LT] = ACTIONS(2423),
    [anon_sym_SLASH] = ACTIONS(2423),
    [anon_sym_class] = ACTIONS(2423),
    [anon_sym_async] = ACTIONS(2423),
    [anon_sym_function] = ACTIONS(2423),
    [anon_sym_new] = ACTIONS(2423),
    [anon_sym_AMP] = ACTIONS(2421),
    [anon_sym_PLUS] = ACTIONS(2423),
    [anon_sym_DASH] = ACTIONS(2423),
    [anon_sym_TILDE] = ACTIONS(2421),
    [anon_sym_void] = ACTIONS(2423),
    [anon_sym_delete] = ACTIONS(2423),
    [anon_sym_PLUS_PLUS] = ACTIONS(2421),
    [anon_sym_DASH_DASH] = ACTIONS(2421),
    [anon_sym_DQUOTE] = ACTIONS(2421),
    [anon_sym_SQUOTE] = ACTIONS(2421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2421),
    [sym_number] = ACTIONS(2421),
    [sym_this] = ACTIONS(2423),
    [sym_super] = ACTIONS(2423),
    [sym_true] = ACTIONS(2423),
    [sym_false] = ACTIONS(2423),
    [sym_null] = ACTIONS(2423),
    [sym_undefined] = ACTIONS(2423),
    [anon_sym_AT] = ACTIONS(2421),
    [anon_sym_static] = ACTIONS(2423),
    [anon_sym_readonly] = ACTIONS(2423),
    [anon_sym_get] = ACTIONS(2423),
    [anon_sym_set] = ACTIONS(2423),
    [anon_sym_declare] = ACTIONS(2423),
    [anon_sym_namespace] = ACTIONS(2423),
    [anon_sym_public] = ACTIONS(2423),
    [anon_sym_private] = ACTIONS(2423),
    [anon_sym_protected] = ACTIONS(2423),
    [anon_sym_override] = ACTIONS(2423),
    [anon_sym_module] = ACTIONS(2423),
    [anon_sym_any] = ACTIONS(2423),
    [anon_sym_number] = ACTIONS(2423),
    [anon_sym_boolean] = ACTIONS(2423),
    [anon_sym_string] = ACTIONS(2423),
    [anon_sym_symbol] = ACTIONS(2423),
    [anon_sym_abstract] = ACTIONS(2423),
    [anon_sym_interface] = ACTIONS(2423),
    [anon_sym_enum] = ACTIONS(2423),
    [anon_sym_component] = ACTIONS(2423),
    [anon_sym_instance] = ACTIONS(2423),
  },
  [640] = {
    [sym__call_signature] = STATE(4684),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2349),
    [anon_sym_export] = ACTIONS(2351),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_type] = ACTIONS(2351),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_RPAREN] = ACTIONS(65),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(2425),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2351),
    [anon_sym_function] = ACTIONS(2317),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2351),
    [anon_sym_readonly] = ACTIONS(2351),
    [anon_sym_get] = ACTIONS(2351),
    [anon_sym_set] = ACTIONS(2351),
    [anon_sym_declare] = ACTIONS(2351),
    [anon_sym_namespace] = ACTIONS(2351),
    [anon_sym_public] = ACTIONS(2351),
    [anon_sym_private] = ACTIONS(2351),
    [anon_sym_protected] = ACTIONS(2351),
    [anon_sym_override] = ACTIONS(2351),
    [anon_sym_module] = ACTIONS(2351),
    [anon_sym_any] = ACTIONS(2351),
    [anon_sym_number] = ACTIONS(2351),
    [anon_sym_boolean] = ACTIONS(2351),
    [anon_sym_string] = ACTIONS(2351),
    [anon_sym_symbol] = ACTIONS(2351),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [641] = {
    [sym_import_as] = STATE(657),
    [sym_identifier] = ACTIONS(2427),
    [anon_sym_export] = ACTIONS(2427),
    [anon_sym_as] = ACTIONS(2429),
    [anon_sym_LBRACE] = ACTIONS(2431),
    [anon_sym_RBRACE] = ACTIONS(2431),
    [anon_sym_type] = ACTIONS(2427),
    [anon_sym_typeof] = ACTIONS(2427),
    [anon_sym_import] = ACTIONS(2427),
    [anon_sym_var] = ACTIONS(2427),
    [anon_sym_let] = ACTIONS(2427),
    [anon_sym_const] = ACTIONS(2427),
    [anon_sym_BANG] = ACTIONS(2431),
    [anon_sym_else] = ACTIONS(2427),
    [anon_sym_if] = ACTIONS(2427),
    [anon_sym_switch] = ACTIONS(2427),
    [anon_sym_for] = ACTIONS(2427),
    [anon_sym_LPAREN] = ACTIONS(2431),
    [anon_sym_await] = ACTIONS(2427),
    [anon_sym_while] = ACTIONS(2427),
    [anon_sym_do] = ACTIONS(2427),
    [anon_sym_try] = ACTIONS(2427),
    [anon_sym_with] = ACTIONS(2427),
    [anon_sym_break] = ACTIONS(2427),
    [anon_sym_continue] = ACTIONS(2427),
    [anon_sym_debugger] = ACTIONS(2427),
    [anon_sym_return] = ACTIONS(2427),
    [anon_sym_throw] = ACTIONS(2427),
    [anon_sym_SEMI] = ACTIONS(2431),
    [anon_sym_case] = ACTIONS(2427),
    [anon_sym_default] = ACTIONS(2427),
    [anon_sym_yield] = ACTIONS(2427),
    [anon_sym_LBRACK] = ACTIONS(2431),
    [anon_sym_LTtemplate_GT] = ACTIONS(2431),
    [anon_sym_LT] = ACTIONS(2427),
    [anon_sym_SLASH] = ACTIONS(2427),
    [anon_sym_class] = ACTIONS(2427),
    [anon_sym_async] = ACTIONS(2427),
    [anon_sym_function] = ACTIONS(2427),
    [anon_sym_new] = ACTIONS(2427),
    [anon_sym_AMP] = ACTIONS(2431),
    [anon_sym_PLUS] = ACTIONS(2427),
    [anon_sym_DASH] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2431),
    [anon_sym_void] = ACTIONS(2427),
    [anon_sym_delete] = ACTIONS(2427),
    [anon_sym_PLUS_PLUS] = ACTIONS(2431),
    [anon_sym_DASH_DASH] = ACTIONS(2431),
    [anon_sym_DQUOTE] = ACTIONS(2431),
    [anon_sym_SQUOTE] = ACTIONS(2431),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2431),
    [sym_number] = ACTIONS(2431),
    [sym_this] = ACTIONS(2427),
    [sym_super] = ACTIONS(2427),
    [sym_true] = ACTIONS(2427),
    [sym_false] = ACTIONS(2427),
    [sym_null] = ACTIONS(2427),
    [sym_undefined] = ACTIONS(2427),
    [anon_sym_AT] = ACTIONS(2431),
    [anon_sym_static] = ACTIONS(2427),
    [anon_sym_readonly] = ACTIONS(2427),
    [anon_sym_get] = ACTIONS(2427),
    [anon_sym_set] = ACTIONS(2427),
    [anon_sym_declare] = ACTIONS(2427),
    [anon_sym_namespace] = ACTIONS(2427),
    [anon_sym_public] = ACTIONS(2427),
    [anon_sym_private] = ACTIONS(2427),
    [anon_sym_protected] = ACTIONS(2427),
    [anon_sym_override] = ACTIONS(2427),
    [anon_sym_module] = ACTIONS(2427),
    [anon_sym_any] = ACTIONS(2427),
    [anon_sym_number] = ACTIONS(2427),
    [anon_sym_boolean] = ACTIONS(2427),
    [anon_sym_string] = ACTIONS(2427),
    [anon_sym_symbol] = ACTIONS(2427),
    [anon_sym_abstract] = ACTIONS(2427),
    [anon_sym_interface] = ACTIONS(2427),
    [anon_sym_enum] = ACTIONS(2427),
    [anon_sym_component] = ACTIONS(2427),
  },
  [642] = {
    [sym_import_path_segment] = STATE(615),
    [sym_identifier] = ACTIONS(2433),
    [anon_sym_export] = ACTIONS(2436),
    [anon_sym_as] = ACTIONS(2436),
    [anon_sym_LBRACE] = ACTIONS(2438),
    [anon_sym_RBRACE] = ACTIONS(2438),
    [anon_sym_type] = ACTIONS(2436),
    [anon_sym_typeof] = ACTIONS(2436),
    [anon_sym_import] = ACTIONS(2436),
    [anon_sym_var] = ACTIONS(2436),
    [anon_sym_let] = ACTIONS(2436),
    [anon_sym_const] = ACTIONS(2436),
    [anon_sym_BANG] = ACTIONS(2438),
    [anon_sym_else] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(2436),
    [anon_sym_switch] = ACTIONS(2436),
    [anon_sym_for] = ACTIONS(2436),
    [anon_sym_LPAREN] = ACTIONS(2438),
    [anon_sym_await] = ACTIONS(2436),
    [anon_sym_while] = ACTIONS(2436),
    [anon_sym_do] = ACTIONS(2436),
    [anon_sym_try] = ACTIONS(2436),
    [anon_sym_with] = ACTIONS(2436),
    [anon_sym_break] = ACTIONS(2436),
    [anon_sym_continue] = ACTIONS(2436),
    [anon_sym_debugger] = ACTIONS(2436),
    [anon_sym_return] = ACTIONS(2436),
    [anon_sym_throw] = ACTIONS(2436),
    [anon_sym_SEMI] = ACTIONS(2438),
    [anon_sym_case] = ACTIONS(2436),
    [anon_sym_default] = ACTIONS(2436),
    [anon_sym_yield] = ACTIONS(2436),
    [anon_sym_LBRACK] = ACTIONS(2438),
    [anon_sym_LTtemplate_GT] = ACTIONS(2438),
    [anon_sym_LT] = ACTIONS(2436),
    [anon_sym_SLASH] = ACTIONS(2436),
    [anon_sym_class] = ACTIONS(2436),
    [anon_sym_async] = ACTIONS(2436),
    [anon_sym_function] = ACTIONS(2436),
    [anon_sym_new] = ACTIONS(2436),
    [anon_sym_AMP] = ACTIONS(2438),
    [anon_sym_PLUS] = ACTIONS(2436),
    [anon_sym_DASH] = ACTIONS(2436),
    [anon_sym_TILDE] = ACTIONS(2438),
    [anon_sym_void] = ACTIONS(2436),
    [anon_sym_delete] = ACTIONS(2436),
    [anon_sym_PLUS_PLUS] = ACTIONS(2438),
    [anon_sym_DASH_DASH] = ACTIONS(2438),
    [anon_sym_DQUOTE] = ACTIONS(2438),
    [anon_sym_SQUOTE] = ACTIONS(2438),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2438),
    [sym_number] = ACTIONS(2438),
    [sym_this] = ACTIONS(2436),
    [sym_super] = ACTIONS(2436),
    [sym_true] = ACTIONS(2436),
    [sym_false] = ACTIONS(2436),
    [sym_null] = ACTIONS(2436),
    [sym_undefined] = ACTIONS(2436),
    [anon_sym_AT] = ACTIONS(2438),
    [anon_sym_static] = ACTIONS(2436),
    [anon_sym_readonly] = ACTIONS(2436),
    [anon_sym_get] = ACTIONS(2436),
    [anon_sym_set] = ACTIONS(2436),
    [anon_sym_declare] = ACTIONS(2436),
    [anon_sym_namespace] = ACTIONS(2436),
    [anon_sym_public] = ACTIONS(2436),
    [anon_sym_private] = ACTIONS(2436),
    [anon_sym_protected] = ACTIONS(2436),
    [anon_sym_override] = ACTIONS(2436),
    [anon_sym_module] = ACTIONS(2436),
    [anon_sym_any] = ACTIONS(2436),
    [anon_sym_number] = ACTIONS(2436),
    [anon_sym_boolean] = ACTIONS(2436),
    [anon_sym_string] = ACTIONS(2436),
    [anon_sym_symbol] = ACTIONS(2436),
    [anon_sym_abstract] = ACTIONS(2436),
    [anon_sym_interface] = ACTIONS(2436),
    [anon_sym_enum] = ACTIONS(2436),
    [anon_sym_component] = ACTIONS(2436),
  },
  [643] = {
    [ts_builtin_sym_end] = ACTIONS(2440),
    [sym_identifier] = ACTIONS(2442),
    [anon_sym_export] = ACTIONS(2442),
    [anon_sym_LBRACE] = ACTIONS(2440),
    [anon_sym_RBRACE] = ACTIONS(2440),
    [anon_sym_type] = ACTIONS(2442),
    [anon_sym_typeof] = ACTIONS(2442),
    [anon_sym_import] = ACTIONS(2442),
    [anon_sym_var] = ACTIONS(2442),
    [anon_sym_let] = ACTIONS(2442),
    [anon_sym_const] = ACTIONS(2442),
    [anon_sym_BANG] = ACTIONS(2440),
    [anon_sym_else] = ACTIONS(2442),
    [anon_sym_if] = ACTIONS(2442),
    [anon_sym_switch] = ACTIONS(2442),
    [anon_sym_for] = ACTIONS(2442),
    [anon_sym_LPAREN] = ACTIONS(2440),
    [anon_sym_await] = ACTIONS(2442),
    [anon_sym_while] = ACTIONS(2442),
    [anon_sym_do] = ACTIONS(2442),
    [anon_sym_try] = ACTIONS(2442),
    [anon_sym_with] = ACTIONS(2442),
    [anon_sym_break] = ACTIONS(2442),
    [anon_sym_continue] = ACTIONS(2442),
    [anon_sym_debugger] = ACTIONS(2442),
    [anon_sym_return] = ACTIONS(2442),
    [anon_sym_throw] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2440),
    [anon_sym_case] = ACTIONS(2442),
    [anon_sym_default] = ACTIONS(2442),
    [anon_sym_yield] = ACTIONS(2442),
    [anon_sym_LBRACK] = ACTIONS(2440),
    [anon_sym_LTtemplate_GT] = ACTIONS(2440),
    [anon_sym_LT] = ACTIONS(2442),
    [anon_sym_SLASH] = ACTIONS(2442),
    [anon_sym_class] = ACTIONS(2442),
    [anon_sym_async] = ACTIONS(2442),
    [anon_sym_function] = ACTIONS(2442),
    [anon_sym_new] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2440),
    [anon_sym_PLUS] = ACTIONS(2442),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_TILDE] = ACTIONS(2440),
    [anon_sym_void] = ACTIONS(2442),
    [anon_sym_delete] = ACTIONS(2442),
    [anon_sym_PLUS_PLUS] = ACTIONS(2440),
    [anon_sym_DASH_DASH] = ACTIONS(2440),
    [anon_sym_DQUOTE] = ACTIONS(2440),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2440),
    [sym_number] = ACTIONS(2440),
    [sym_this] = ACTIONS(2442),
    [sym_super] = ACTIONS(2442),
    [sym_true] = ACTIONS(2442),
    [sym_false] = ACTIONS(2442),
    [sym_null] = ACTIONS(2442),
    [sym_undefined] = ACTIONS(2442),
    [anon_sym_AT] = ACTIONS(2440),
    [anon_sym_static] = ACTIONS(2442),
    [anon_sym_readonly] = ACTIONS(2442),
    [anon_sym_get] = ACTIONS(2442),
    [anon_sym_set] = ACTIONS(2442),
    [anon_sym_declare] = ACTIONS(2442),
    [anon_sym_namespace] = ACTIONS(2442),
    [anon_sym_public] = ACTIONS(2442),
    [anon_sym_private] = ACTIONS(2442),
    [anon_sym_protected] = ACTIONS(2442),
    [anon_sym_override] = ACTIONS(2442),
    [anon_sym_module] = ACTIONS(2442),
    [anon_sym_any] = ACTIONS(2442),
    [anon_sym_number] = ACTIONS(2442),
    [anon_sym_boolean] = ACTIONS(2442),
    [anon_sym_string] = ACTIONS(2442),
    [anon_sym_symbol] = ACTIONS(2442),
    [anon_sym_abstract] = ACTIONS(2442),
    [anon_sym_interface] = ACTIONS(2442),
    [anon_sym_enum] = ACTIONS(2442),
    [anon_sym_component] = ACTIONS(2442),
    [anon_sym_instance] = ACTIONS(2442),
  },
  [644] = {
    [ts_builtin_sym_end] = ACTIONS(2444),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_export] = ACTIONS(2446),
    [anon_sym_LBRACE] = ACTIONS(2444),
    [anon_sym_RBRACE] = ACTIONS(2444),
    [anon_sym_type] = ACTIONS(2446),
    [anon_sym_typeof] = ACTIONS(2446),
    [anon_sym_import] = ACTIONS(2446),
    [anon_sym_var] = ACTIONS(2446),
    [anon_sym_let] = ACTIONS(2446),
    [anon_sym_const] = ACTIONS(2446),
    [anon_sym_BANG] = ACTIONS(2444),
    [anon_sym_else] = ACTIONS(2446),
    [anon_sym_if] = ACTIONS(2446),
    [anon_sym_switch] = ACTIONS(2446),
    [anon_sym_for] = ACTIONS(2446),
    [anon_sym_LPAREN] = ACTIONS(2444),
    [anon_sym_await] = ACTIONS(2446),
    [anon_sym_while] = ACTIONS(2446),
    [anon_sym_do] = ACTIONS(2446),
    [anon_sym_try] = ACTIONS(2446),
    [anon_sym_with] = ACTIONS(2446),
    [anon_sym_break] = ACTIONS(2446),
    [anon_sym_continue] = ACTIONS(2446),
    [anon_sym_debugger] = ACTIONS(2446),
    [anon_sym_return] = ACTIONS(2446),
    [anon_sym_throw] = ACTIONS(2446),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_case] = ACTIONS(2446),
    [anon_sym_default] = ACTIONS(2446),
    [anon_sym_yield] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [anon_sym_LTtemplate_GT] = ACTIONS(2444),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(2446),
    [anon_sym_class] = ACTIONS(2446),
    [anon_sym_async] = ACTIONS(2446),
    [anon_sym_function] = ACTIONS(2446),
    [anon_sym_new] = ACTIONS(2446),
    [anon_sym_AMP] = ACTIONS(2444),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_TILDE] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(2446),
    [anon_sym_delete] = ACTIONS(2446),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_DQUOTE] = ACTIONS(2444),
    [anon_sym_SQUOTE] = ACTIONS(2444),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2444),
    [sym_number] = ACTIONS(2444),
    [sym_this] = ACTIONS(2446),
    [sym_super] = ACTIONS(2446),
    [sym_true] = ACTIONS(2446),
    [sym_false] = ACTIONS(2446),
    [sym_null] = ACTIONS(2446),
    [sym_undefined] = ACTIONS(2446),
    [anon_sym_AT] = ACTIONS(2444),
    [anon_sym_static] = ACTIONS(2446),
    [anon_sym_readonly] = ACTIONS(2446),
    [anon_sym_get] = ACTIONS(2446),
    [anon_sym_set] = ACTIONS(2446),
    [anon_sym_declare] = ACTIONS(2446),
    [anon_sym_namespace] = ACTIONS(2446),
    [anon_sym_public] = ACTIONS(2446),
    [anon_sym_private] = ACTIONS(2446),
    [anon_sym_protected] = ACTIONS(2446),
    [anon_sym_override] = ACTIONS(2446),
    [anon_sym_module] = ACTIONS(2446),
    [anon_sym_any] = ACTIONS(2446),
    [anon_sym_number] = ACTIONS(2446),
    [anon_sym_boolean] = ACTIONS(2446),
    [anon_sym_string] = ACTIONS(2446),
    [anon_sym_symbol] = ACTIONS(2446),
    [anon_sym_abstract] = ACTIONS(2446),
    [anon_sym_interface] = ACTIONS(2446),
    [anon_sym_enum] = ACTIONS(2446),
    [anon_sym_component] = ACTIONS(2446),
    [anon_sym_instance] = ACTIONS(2446),
  },
  [645] = {
    [ts_builtin_sym_end] = ACTIONS(2448),
    [sym_identifier] = ACTIONS(2450),
    [anon_sym_export] = ACTIONS(2450),
    [anon_sym_LBRACE] = ACTIONS(2448),
    [anon_sym_RBRACE] = ACTIONS(2448),
    [anon_sym_type] = ACTIONS(2450),
    [anon_sym_typeof] = ACTIONS(2450),
    [anon_sym_import] = ACTIONS(2450),
    [anon_sym_var] = ACTIONS(2450),
    [anon_sym_let] = ACTIONS(2450),
    [anon_sym_const] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2448),
    [anon_sym_else] = ACTIONS(2450),
    [anon_sym_if] = ACTIONS(2450),
    [anon_sym_switch] = ACTIONS(2450),
    [anon_sym_for] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(2448),
    [anon_sym_await] = ACTIONS(2450),
    [anon_sym_while] = ACTIONS(2450),
    [anon_sym_do] = ACTIONS(2450),
    [anon_sym_try] = ACTIONS(2450),
    [anon_sym_with] = ACTIONS(2450),
    [anon_sym_break] = ACTIONS(2450),
    [anon_sym_continue] = ACTIONS(2450),
    [anon_sym_debugger] = ACTIONS(2450),
    [anon_sym_return] = ACTIONS(2450),
    [anon_sym_throw] = ACTIONS(2450),
    [anon_sym_SEMI] = ACTIONS(2448),
    [anon_sym_case] = ACTIONS(2450),
    [anon_sym_default] = ACTIONS(2450),
    [anon_sym_yield] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_LTtemplate_GT] = ACTIONS(2448),
    [anon_sym_LT] = ACTIONS(2450),
    [anon_sym_SLASH] = ACTIONS(2450),
    [anon_sym_class] = ACTIONS(2450),
    [anon_sym_async] = ACTIONS(2450),
    [anon_sym_function] = ACTIONS(2450),
    [anon_sym_new] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2448),
    [anon_sym_void] = ACTIONS(2450),
    [anon_sym_delete] = ACTIONS(2450),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_DQUOTE] = ACTIONS(2448),
    [anon_sym_SQUOTE] = ACTIONS(2448),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2448),
    [sym_number] = ACTIONS(2448),
    [sym_this] = ACTIONS(2450),
    [sym_super] = ACTIONS(2450),
    [sym_true] = ACTIONS(2450),
    [sym_false] = ACTIONS(2450),
    [sym_null] = ACTIONS(2450),
    [sym_undefined] = ACTIONS(2450),
    [anon_sym_AT] = ACTIONS(2448),
    [anon_sym_static] = ACTIONS(2450),
    [anon_sym_readonly] = ACTIONS(2450),
    [anon_sym_get] = ACTIONS(2450),
    [anon_sym_set] = ACTIONS(2450),
    [anon_sym_declare] = ACTIONS(2450),
    [anon_sym_namespace] = ACTIONS(2450),
    [anon_sym_public] = ACTIONS(2450),
    [anon_sym_private] = ACTIONS(2450),
    [anon_sym_protected] = ACTIONS(2450),
    [anon_sym_override] = ACTIONS(2450),
    [anon_sym_module] = ACTIONS(2450),
    [anon_sym_any] = ACTIONS(2450),
    [anon_sym_number] = ACTIONS(2450),
    [anon_sym_boolean] = ACTIONS(2450),
    [anon_sym_string] = ACTIONS(2450),
    [anon_sym_symbol] = ACTIONS(2450),
    [anon_sym_abstract] = ACTIONS(2450),
    [anon_sym_interface] = ACTIONS(2450),
    [anon_sym_enum] = ACTIONS(2450),
    [anon_sym_component] = ACTIONS(2450),
    [anon_sym_instance] = ACTIONS(2450),
  },
  [646] = {
    [ts_builtin_sym_end] = ACTIONS(2452),
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_export] = ACTIONS(2454),
    [anon_sym_LBRACE] = ACTIONS(2452),
    [anon_sym_RBRACE] = ACTIONS(2452),
    [anon_sym_type] = ACTIONS(2454),
    [anon_sym_typeof] = ACTIONS(2454),
    [anon_sym_import] = ACTIONS(2454),
    [anon_sym_var] = ACTIONS(2454),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_const] = ACTIONS(2454),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_else] = ACTIONS(2454),
    [anon_sym_if] = ACTIONS(2454),
    [anon_sym_switch] = ACTIONS(2454),
    [anon_sym_for] = ACTIONS(2454),
    [anon_sym_LPAREN] = ACTIONS(2452),
    [anon_sym_await] = ACTIONS(2454),
    [anon_sym_while] = ACTIONS(2454),
    [anon_sym_do] = ACTIONS(2454),
    [anon_sym_try] = ACTIONS(2454),
    [anon_sym_with] = ACTIONS(2454),
    [anon_sym_break] = ACTIONS(2454),
    [anon_sym_continue] = ACTIONS(2454),
    [anon_sym_debugger] = ACTIONS(2454),
    [anon_sym_return] = ACTIONS(2454),
    [anon_sym_throw] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2452),
    [anon_sym_case] = ACTIONS(2454),
    [anon_sym_default] = ACTIONS(2454),
    [anon_sym_yield] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2452),
    [anon_sym_LTtemplate_GT] = ACTIONS(2452),
    [anon_sym_LT] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_class] = ACTIONS(2454),
    [anon_sym_async] = ACTIONS(2454),
    [anon_sym_function] = ACTIONS(2454),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_TILDE] = ACTIONS(2452),
    [anon_sym_void] = ACTIONS(2454),
    [anon_sym_delete] = ACTIONS(2454),
    [anon_sym_PLUS_PLUS] = ACTIONS(2452),
    [anon_sym_DASH_DASH] = ACTIONS(2452),
    [anon_sym_DQUOTE] = ACTIONS(2452),
    [anon_sym_SQUOTE] = ACTIONS(2452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2452),
    [sym_number] = ACTIONS(2452),
    [sym_this] = ACTIONS(2454),
    [sym_super] = ACTIONS(2454),
    [sym_true] = ACTIONS(2454),
    [sym_false] = ACTIONS(2454),
    [sym_null] = ACTIONS(2454),
    [sym_undefined] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2452),
    [anon_sym_static] = ACTIONS(2454),
    [anon_sym_readonly] = ACTIONS(2454),
    [anon_sym_get] = ACTIONS(2454),
    [anon_sym_set] = ACTIONS(2454),
    [anon_sym_declare] = ACTIONS(2454),
    [anon_sym_namespace] = ACTIONS(2454),
    [anon_sym_public] = ACTIONS(2454),
    [anon_sym_private] = ACTIONS(2454),
    [anon_sym_protected] = ACTIONS(2454),
    [anon_sym_override] = ACTIONS(2454),
    [anon_sym_module] = ACTIONS(2454),
    [anon_sym_any] = ACTIONS(2454),
    [anon_sym_number] = ACTIONS(2454),
    [anon_sym_boolean] = ACTIONS(2454),
    [anon_sym_string] = ACTIONS(2454),
    [anon_sym_symbol] = ACTIONS(2454),
    [anon_sym_abstract] = ACTIONS(2454),
    [anon_sym_interface] = ACTIONS(2454),
    [anon_sym_enum] = ACTIONS(2454),
    [anon_sym_component] = ACTIONS(2454),
    [anon_sym_instance] = ACTIONS(2454),
  },
  [647] = {
    [ts_builtin_sym_end] = ACTIONS(2456),
    [sym_identifier] = ACTIONS(2458),
    [anon_sym_export] = ACTIONS(2458),
    [anon_sym_LBRACE] = ACTIONS(2456),
    [anon_sym_RBRACE] = ACTIONS(2456),
    [anon_sym_type] = ACTIONS(2458),
    [anon_sym_typeof] = ACTIONS(2458),
    [anon_sym_import] = ACTIONS(2458),
    [anon_sym_var] = ACTIONS(2458),
    [anon_sym_let] = ACTIONS(2458),
    [anon_sym_const] = ACTIONS(2458),
    [anon_sym_BANG] = ACTIONS(2456),
    [anon_sym_else] = ACTIONS(2458),
    [anon_sym_if] = ACTIONS(2458),
    [anon_sym_switch] = ACTIONS(2458),
    [anon_sym_for] = ACTIONS(2458),
    [anon_sym_LPAREN] = ACTIONS(2456),
    [anon_sym_await] = ACTIONS(2458),
    [anon_sym_while] = ACTIONS(2458),
    [anon_sym_do] = ACTIONS(2458),
    [anon_sym_try] = ACTIONS(2458),
    [anon_sym_with] = ACTIONS(2458),
    [anon_sym_break] = ACTIONS(2458),
    [anon_sym_continue] = ACTIONS(2458),
    [anon_sym_debugger] = ACTIONS(2458),
    [anon_sym_return] = ACTIONS(2458),
    [anon_sym_throw] = ACTIONS(2458),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_case] = ACTIONS(2458),
    [anon_sym_default] = ACTIONS(2458),
    [anon_sym_yield] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2456),
    [anon_sym_LTtemplate_GT] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2458),
    [anon_sym_SLASH] = ACTIONS(2458),
    [anon_sym_class] = ACTIONS(2458),
    [anon_sym_async] = ACTIONS(2458),
    [anon_sym_function] = ACTIONS(2458),
    [anon_sym_new] = ACTIONS(2458),
    [anon_sym_AMP] = ACTIONS(2456),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_TILDE] = ACTIONS(2456),
    [anon_sym_void] = ACTIONS(2458),
    [anon_sym_delete] = ACTIONS(2458),
    [anon_sym_PLUS_PLUS] = ACTIONS(2456),
    [anon_sym_DASH_DASH] = ACTIONS(2456),
    [anon_sym_DQUOTE] = ACTIONS(2456),
    [anon_sym_SQUOTE] = ACTIONS(2456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2456),
    [sym_number] = ACTIONS(2456),
    [sym_this] = ACTIONS(2458),
    [sym_super] = ACTIONS(2458),
    [sym_true] = ACTIONS(2458),
    [sym_false] = ACTIONS(2458),
    [sym_null] = ACTIONS(2458),
    [sym_undefined] = ACTIONS(2458),
    [anon_sym_AT] = ACTIONS(2456),
    [anon_sym_static] = ACTIONS(2458),
    [anon_sym_readonly] = ACTIONS(2458),
    [anon_sym_get] = ACTIONS(2458),
    [anon_sym_set] = ACTIONS(2458),
    [anon_sym_declare] = ACTIONS(2458),
    [anon_sym_namespace] = ACTIONS(2458),
    [anon_sym_public] = ACTIONS(2458),
    [anon_sym_private] = ACTIONS(2458),
    [anon_sym_protected] = ACTIONS(2458),
    [anon_sym_override] = ACTIONS(2458),
    [anon_sym_module] = ACTIONS(2458),
    [anon_sym_any] = ACTIONS(2458),
    [anon_sym_number] = ACTIONS(2458),
    [anon_sym_boolean] = ACTIONS(2458),
    [anon_sym_string] = ACTIONS(2458),
    [anon_sym_symbol] = ACTIONS(2458),
    [anon_sym_abstract] = ACTIONS(2458),
    [anon_sym_interface] = ACTIONS(2458),
    [anon_sym_enum] = ACTIONS(2458),
    [anon_sym_component] = ACTIONS(2458),
    [anon_sym_instance] = ACTIONS(2458),
  },
  [648] = {
    [sym_finally_clause] = STATE(751),
    [sym_identifier] = ACTIONS(2460),
    [anon_sym_export] = ACTIONS(2460),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(2462),
    [anon_sym_type] = ACTIONS(2460),
    [anon_sym_typeof] = ACTIONS(2460),
    [anon_sym_import] = ACTIONS(2460),
    [anon_sym_var] = ACTIONS(2460),
    [anon_sym_let] = ACTIONS(2460),
    [anon_sym_const] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_else] = ACTIONS(2460),
    [anon_sym_if] = ACTIONS(2460),
    [anon_sym_switch] = ACTIONS(2460),
    [anon_sym_for] = ACTIONS(2460),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_await] = ACTIONS(2460),
    [anon_sym_while] = ACTIONS(2460),
    [anon_sym_do] = ACTIONS(2460),
    [anon_sym_try] = ACTIONS(2460),
    [anon_sym_with] = ACTIONS(2460),
    [anon_sym_break] = ACTIONS(2460),
    [anon_sym_continue] = ACTIONS(2460),
    [anon_sym_debugger] = ACTIONS(2460),
    [anon_sym_return] = ACTIONS(2460),
    [anon_sym_throw] = ACTIONS(2460),
    [anon_sym_SEMI] = ACTIONS(2462),
    [anon_sym_case] = ACTIONS(2460),
    [anon_sym_default] = ACTIONS(2460),
    [anon_sym_finally] = ACTIONS(2327),
    [anon_sym_yield] = ACTIONS(2460),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LTtemplate_GT] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2460),
    [anon_sym_SLASH] = ACTIONS(2460),
    [anon_sym_class] = ACTIONS(2460),
    [anon_sym_async] = ACTIONS(2460),
    [anon_sym_function] = ACTIONS(2460),
    [anon_sym_new] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2460),
    [anon_sym_DASH] = ACTIONS(2460),
    [anon_sym_TILDE] = ACTIONS(2462),
    [anon_sym_void] = ACTIONS(2460),
    [anon_sym_delete] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(2462),
    [anon_sym_DASH_DASH] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [anon_sym_SQUOTE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [sym_number] = ACTIONS(2462),
    [sym_this] = ACTIONS(2460),
    [sym_super] = ACTIONS(2460),
    [sym_true] = ACTIONS(2460),
    [sym_false] = ACTIONS(2460),
    [sym_null] = ACTIONS(2460),
    [sym_undefined] = ACTIONS(2460),
    [anon_sym_AT] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2460),
    [anon_sym_readonly] = ACTIONS(2460),
    [anon_sym_get] = ACTIONS(2460),
    [anon_sym_set] = ACTIONS(2460),
    [anon_sym_declare] = ACTIONS(2460),
    [anon_sym_namespace] = ACTIONS(2460),
    [anon_sym_public] = ACTIONS(2460),
    [anon_sym_private] = ACTIONS(2460),
    [anon_sym_protected] = ACTIONS(2460),
    [anon_sym_override] = ACTIONS(2460),
    [anon_sym_module] = ACTIONS(2460),
    [anon_sym_any] = ACTIONS(2460),
    [anon_sym_number] = ACTIONS(2460),
    [anon_sym_boolean] = ACTIONS(2460),
    [anon_sym_string] = ACTIONS(2460),
    [anon_sym_symbol] = ACTIONS(2460),
    [anon_sym_abstract] = ACTIONS(2460),
    [anon_sym_interface] = ACTIONS(2460),
    [anon_sym_enum] = ACTIONS(2460),
    [anon_sym_component] = ACTIONS(2460),
  },
  [649] = {
    [ts_builtin_sym_end] = ACTIONS(2464),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_export] = ACTIONS(2466),
    [anon_sym_LBRACE] = ACTIONS(2464),
    [anon_sym_RBRACE] = ACTIONS(2464),
    [anon_sym_type] = ACTIONS(2466),
    [anon_sym_typeof] = ACTIONS(2466),
    [anon_sym_import] = ACTIONS(2466),
    [anon_sym_var] = ACTIONS(2466),
    [anon_sym_let] = ACTIONS(2466),
    [anon_sym_const] = ACTIONS(2466),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_else] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_switch] = ACTIONS(2466),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_LPAREN] = ACTIONS(2464),
    [anon_sym_await] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_with] = ACTIONS(2466),
    [anon_sym_break] = ACTIONS(2466),
    [anon_sym_continue] = ACTIONS(2466),
    [anon_sym_debugger] = ACTIONS(2466),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_throw] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_case] = ACTIONS(2466),
    [anon_sym_default] = ACTIONS(2466),
    [anon_sym_yield] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2464),
    [anon_sym_LTtemplate_GT] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_SLASH] = ACTIONS(2466),
    [anon_sym_class] = ACTIONS(2466),
    [anon_sym_async] = ACTIONS(2466),
    [anon_sym_function] = ACTIONS(2466),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_AMP] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_TILDE] = ACTIONS(2464),
    [anon_sym_void] = ACTIONS(2466),
    [anon_sym_delete] = ACTIONS(2466),
    [anon_sym_PLUS_PLUS] = ACTIONS(2464),
    [anon_sym_DASH_DASH] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [sym_number] = ACTIONS(2464),
    [sym_this] = ACTIONS(2466),
    [sym_super] = ACTIONS(2466),
    [sym_true] = ACTIONS(2466),
    [sym_false] = ACTIONS(2466),
    [sym_null] = ACTIONS(2466),
    [sym_undefined] = ACTIONS(2466),
    [anon_sym_AT] = ACTIONS(2464),
    [anon_sym_static] = ACTIONS(2466),
    [anon_sym_readonly] = ACTIONS(2466),
    [anon_sym_get] = ACTIONS(2466),
    [anon_sym_set] = ACTIONS(2466),
    [anon_sym_declare] = ACTIONS(2466),
    [anon_sym_namespace] = ACTIONS(2466),
    [anon_sym_public] = ACTIONS(2466),
    [anon_sym_private] = ACTIONS(2466),
    [anon_sym_protected] = ACTIONS(2466),
    [anon_sym_override] = ACTIONS(2466),
    [anon_sym_module] = ACTIONS(2466),
    [anon_sym_any] = ACTIONS(2466),
    [anon_sym_number] = ACTIONS(2466),
    [anon_sym_boolean] = ACTIONS(2466),
    [anon_sym_string] = ACTIONS(2466),
    [anon_sym_symbol] = ACTIONS(2466),
    [anon_sym_abstract] = ACTIONS(2466),
    [anon_sym_interface] = ACTIONS(2466),
    [anon_sym_enum] = ACTIONS(2466),
    [anon_sym_component] = ACTIONS(2466),
    [anon_sym_instance] = ACTIONS(2466),
  },
  [650] = {
    [ts_builtin_sym_end] = ACTIONS(2468),
    [sym_identifier] = ACTIONS(2470),
    [anon_sym_export] = ACTIONS(2470),
    [anon_sym_LBRACE] = ACTIONS(2468),
    [anon_sym_RBRACE] = ACTIONS(2468),
    [anon_sym_type] = ACTIONS(2470),
    [anon_sym_typeof] = ACTIONS(2470),
    [anon_sym_import] = ACTIONS(2470),
    [anon_sym_var] = ACTIONS(2470),
    [anon_sym_let] = ACTIONS(2470),
    [anon_sym_const] = ACTIONS(2470),
    [anon_sym_BANG] = ACTIONS(2468),
    [anon_sym_else] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_switch] = ACTIONS(2470),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_LPAREN] = ACTIONS(2468),
    [anon_sym_await] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_with] = ACTIONS(2470),
    [anon_sym_break] = ACTIONS(2470),
    [anon_sym_continue] = ACTIONS(2470),
    [anon_sym_debugger] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_throw] = ACTIONS(2470),
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym_case] = ACTIONS(2470),
    [anon_sym_default] = ACTIONS(2470),
    [anon_sym_yield] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2468),
    [anon_sym_LTtemplate_GT] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2470),
    [anon_sym_SLASH] = ACTIONS(2470),
    [anon_sym_class] = ACTIONS(2470),
    [anon_sym_async] = ACTIONS(2470),
    [anon_sym_function] = ACTIONS(2470),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_AMP] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_TILDE] = ACTIONS(2468),
    [anon_sym_void] = ACTIONS(2470),
    [anon_sym_delete] = ACTIONS(2470),
    [anon_sym_PLUS_PLUS] = ACTIONS(2468),
    [anon_sym_DASH_DASH] = ACTIONS(2468),
    [anon_sym_DQUOTE] = ACTIONS(2468),
    [anon_sym_SQUOTE] = ACTIONS(2468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2468),
    [sym_number] = ACTIONS(2468),
    [sym_this] = ACTIONS(2470),
    [sym_super] = ACTIONS(2470),
    [sym_true] = ACTIONS(2470),
    [sym_false] = ACTIONS(2470),
    [sym_null] = ACTIONS(2470),
    [sym_undefined] = ACTIONS(2470),
    [anon_sym_AT] = ACTIONS(2468),
    [anon_sym_static] = ACTIONS(2470),
    [anon_sym_readonly] = ACTIONS(2470),
    [anon_sym_get] = ACTIONS(2470),
    [anon_sym_set] = ACTIONS(2470),
    [anon_sym_declare] = ACTIONS(2470),
    [anon_sym_namespace] = ACTIONS(2470),
    [anon_sym_public] = ACTIONS(2470),
    [anon_sym_private] = ACTIONS(2470),
    [anon_sym_protected] = ACTIONS(2470),
    [anon_sym_override] = ACTIONS(2470),
    [anon_sym_module] = ACTIONS(2470),
    [anon_sym_any] = ACTIONS(2470),
    [anon_sym_number] = ACTIONS(2470),
    [anon_sym_boolean] = ACTIONS(2470),
    [anon_sym_string] = ACTIONS(2470),
    [anon_sym_symbol] = ACTIONS(2470),
    [anon_sym_abstract] = ACTIONS(2470),
    [anon_sym_interface] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2470),
    [anon_sym_component] = ACTIONS(2470),
    [anon_sym_instance] = ACTIONS(2470),
  },
  [651] = {
    [ts_builtin_sym_end] = ACTIONS(2472),
    [sym_identifier] = ACTIONS(2474),
    [anon_sym_export] = ACTIONS(2474),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_type] = ACTIONS(2474),
    [anon_sym_typeof] = ACTIONS(2474),
    [anon_sym_import] = ACTIONS(2474),
    [anon_sym_var] = ACTIONS(2474),
    [anon_sym_let] = ACTIONS(2474),
    [anon_sym_const] = ACTIONS(2474),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_else] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_switch] = ACTIONS(2474),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_LPAREN] = ACTIONS(2472),
    [anon_sym_await] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_with] = ACTIONS(2474),
    [anon_sym_break] = ACTIONS(2474),
    [anon_sym_continue] = ACTIONS(2474),
    [anon_sym_debugger] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_throw] = ACTIONS(2474),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_case] = ACTIONS(2474),
    [anon_sym_default] = ACTIONS(2474),
    [anon_sym_yield] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2472),
    [anon_sym_LTtemplate_GT] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2474),
    [anon_sym_SLASH] = ACTIONS(2474),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_async] = ACTIONS(2474),
    [anon_sym_function] = ACTIONS(2474),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(2472),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2472),
    [anon_sym_void] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(2474),
    [anon_sym_PLUS_PLUS] = ACTIONS(2472),
    [anon_sym_DASH_DASH] = ACTIONS(2472),
    [anon_sym_DQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2472),
    [sym_number] = ACTIONS(2472),
    [sym_this] = ACTIONS(2474),
    [sym_super] = ACTIONS(2474),
    [sym_true] = ACTIONS(2474),
    [sym_false] = ACTIONS(2474),
    [sym_null] = ACTIONS(2474),
    [sym_undefined] = ACTIONS(2474),
    [anon_sym_AT] = ACTIONS(2472),
    [anon_sym_static] = ACTIONS(2474),
    [anon_sym_readonly] = ACTIONS(2474),
    [anon_sym_get] = ACTIONS(2474),
    [anon_sym_set] = ACTIONS(2474),
    [anon_sym_declare] = ACTIONS(2474),
    [anon_sym_namespace] = ACTIONS(2474),
    [anon_sym_public] = ACTIONS(2474),
    [anon_sym_private] = ACTIONS(2474),
    [anon_sym_protected] = ACTIONS(2474),
    [anon_sym_override] = ACTIONS(2474),
    [anon_sym_module] = ACTIONS(2474),
    [anon_sym_any] = ACTIONS(2474),
    [anon_sym_number] = ACTIONS(2474),
    [anon_sym_boolean] = ACTIONS(2474),
    [anon_sym_string] = ACTIONS(2474),
    [anon_sym_symbol] = ACTIONS(2474),
    [anon_sym_abstract] = ACTIONS(2474),
    [anon_sym_interface] = ACTIONS(2474),
    [anon_sym_enum] = ACTIONS(2474),
    [anon_sym_component] = ACTIONS(2474),
    [anon_sym_instance] = ACTIONS(2474),
  },
  [652] = {
    [sym_identifier] = ACTIONS(2367),
    [anon_sym_export] = ACTIONS(2367),
    [anon_sym_as] = ACTIONS(2367),
    [anon_sym_LBRACE] = ACTIONS(2369),
    [anon_sym_RBRACE] = ACTIONS(2369),
    [anon_sym_type] = ACTIONS(2367),
    [anon_sym_typeof] = ACTIONS(2367),
    [anon_sym_import] = ACTIONS(2367),
    [anon_sym_var] = ACTIONS(2367),
    [anon_sym_let] = ACTIONS(2367),
    [anon_sym_const] = ACTIONS(2367),
    [anon_sym_BANG] = ACTIONS(2369),
    [anon_sym_else] = ACTIONS(2367),
    [anon_sym_if] = ACTIONS(2367),
    [anon_sym_switch] = ACTIONS(2367),
    [anon_sym_for] = ACTIONS(2367),
    [anon_sym_LPAREN] = ACTIONS(2369),
    [anon_sym_await] = ACTIONS(2367),
    [anon_sym_while] = ACTIONS(2367),
    [anon_sym_do] = ACTIONS(2367),
    [anon_sym_try] = ACTIONS(2367),
    [anon_sym_with] = ACTIONS(2367),
    [anon_sym_break] = ACTIONS(2367),
    [anon_sym_continue] = ACTIONS(2367),
    [anon_sym_debugger] = ACTIONS(2367),
    [anon_sym_return] = ACTIONS(2367),
    [anon_sym_throw] = ACTIONS(2367),
    [anon_sym_SEMI] = ACTIONS(2369),
    [anon_sym_case] = ACTIONS(2367),
    [anon_sym_default] = ACTIONS(2367),
    [anon_sym_yield] = ACTIONS(2367),
    [anon_sym_LBRACK] = ACTIONS(2369),
    [anon_sym_LTtemplate_GT] = ACTIONS(2369),
    [anon_sym_LT] = ACTIONS(2367),
    [anon_sym_SLASH] = ACTIONS(2367),
    [anon_sym_DOT] = ACTIONS(2367),
    [anon_sym_class] = ACTIONS(2367),
    [anon_sym_async] = ACTIONS(2367),
    [anon_sym_function] = ACTIONS(2367),
    [anon_sym_new] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(2369),
    [anon_sym_PLUS] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2367),
    [anon_sym_TILDE] = ACTIONS(2369),
    [anon_sym_void] = ACTIONS(2367),
    [anon_sym_delete] = ACTIONS(2367),
    [anon_sym_PLUS_PLUS] = ACTIONS(2369),
    [anon_sym_DASH_DASH] = ACTIONS(2369),
    [anon_sym_DQUOTE] = ACTIONS(2369),
    [anon_sym_SQUOTE] = ACTIONS(2369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2369),
    [sym_number] = ACTIONS(2369),
    [sym_this] = ACTIONS(2367),
    [sym_super] = ACTIONS(2367),
    [sym_true] = ACTIONS(2367),
    [sym_false] = ACTIONS(2367),
    [sym_null] = ACTIONS(2367),
    [sym_undefined] = ACTIONS(2367),
    [anon_sym_AT] = ACTIONS(2369),
    [anon_sym_static] = ACTIONS(2367),
    [anon_sym_readonly] = ACTIONS(2367),
    [anon_sym_get] = ACTIONS(2367),
    [anon_sym_set] = ACTIONS(2367),
    [anon_sym_declare] = ACTIONS(2367),
    [anon_sym_namespace] = ACTIONS(2367),
    [anon_sym_public] = ACTIONS(2367),
    [anon_sym_private] = ACTIONS(2367),
    [anon_sym_protected] = ACTIONS(2367),
    [anon_sym_override] = ACTIONS(2367),
    [anon_sym_module] = ACTIONS(2367),
    [anon_sym_any] = ACTIONS(2367),
    [anon_sym_number] = ACTIONS(2367),
    [anon_sym_boolean] = ACTIONS(2367),
    [anon_sym_string] = ACTIONS(2367),
    [anon_sym_symbol] = ACTIONS(2367),
    [anon_sym_abstract] = ACTIONS(2367),
    [anon_sym_interface] = ACTIONS(2367),
    [anon_sym_enum] = ACTIONS(2367),
    [anon_sym_component] = ACTIONS(2367),
  },
  [653] = {
    [ts_builtin_sym_end] = ACTIONS(2476),
    [sym_identifier] = ACTIONS(2478),
    [anon_sym_export] = ACTIONS(2478),
    [anon_sym_LBRACE] = ACTIONS(2476),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_type] = ACTIONS(2478),
    [anon_sym_typeof] = ACTIONS(2478),
    [anon_sym_import] = ACTIONS(2478),
    [anon_sym_var] = ACTIONS(2478),
    [anon_sym_let] = ACTIONS(2478),
    [anon_sym_const] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2476),
    [anon_sym_else] = ACTIONS(2478),
    [anon_sym_if] = ACTIONS(2478),
    [anon_sym_switch] = ACTIONS(2478),
    [anon_sym_for] = ACTIONS(2478),
    [anon_sym_LPAREN] = ACTIONS(2476),
    [anon_sym_await] = ACTIONS(2478),
    [anon_sym_while] = ACTIONS(2478),
    [anon_sym_do] = ACTIONS(2478),
    [anon_sym_try] = ACTIONS(2478),
    [anon_sym_with] = ACTIONS(2478),
    [anon_sym_break] = ACTIONS(2478),
    [anon_sym_continue] = ACTIONS(2478),
    [anon_sym_debugger] = ACTIONS(2478),
    [anon_sym_return] = ACTIONS(2478),
    [anon_sym_throw] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2476),
    [anon_sym_case] = ACTIONS(2478),
    [anon_sym_default] = ACTIONS(2478),
    [anon_sym_yield] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_LTtemplate_GT] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2478),
    [anon_sym_SLASH] = ACTIONS(2478),
    [anon_sym_class] = ACTIONS(2478),
    [anon_sym_async] = ACTIONS(2478),
    [anon_sym_function] = ACTIONS(2478),
    [anon_sym_new] = ACTIONS(2478),
    [anon_sym_AMP] = ACTIONS(2476),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(2478),
    [anon_sym_delete] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2476),
    [anon_sym_DASH_DASH] = ACTIONS(2476),
    [anon_sym_DQUOTE] = ACTIONS(2476),
    [anon_sym_SQUOTE] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2476),
    [sym_number] = ACTIONS(2476),
    [sym_this] = ACTIONS(2478),
    [sym_super] = ACTIONS(2478),
    [sym_true] = ACTIONS(2478),
    [sym_false] = ACTIONS(2478),
    [sym_null] = ACTIONS(2478),
    [sym_undefined] = ACTIONS(2478),
    [anon_sym_AT] = ACTIONS(2476),
    [anon_sym_static] = ACTIONS(2478),
    [anon_sym_readonly] = ACTIONS(2478),
    [anon_sym_get] = ACTIONS(2478),
    [anon_sym_set] = ACTIONS(2478),
    [anon_sym_declare] = ACTIONS(2478),
    [anon_sym_namespace] = ACTIONS(2478),
    [anon_sym_public] = ACTIONS(2478),
    [anon_sym_private] = ACTIONS(2478),
    [anon_sym_protected] = ACTIONS(2478),
    [anon_sym_override] = ACTIONS(2478),
    [anon_sym_module] = ACTIONS(2478),
    [anon_sym_any] = ACTIONS(2478),
    [anon_sym_number] = ACTIONS(2478),
    [anon_sym_boolean] = ACTIONS(2478),
    [anon_sym_string] = ACTIONS(2478),
    [anon_sym_symbol] = ACTIONS(2478),
    [anon_sym_abstract] = ACTIONS(2478),
    [anon_sym_interface] = ACTIONS(2478),
    [anon_sym_enum] = ACTIONS(2478),
    [anon_sym_component] = ACTIONS(2478),
    [anon_sym_instance] = ACTIONS(2478),
  },
  [654] = {
    [ts_builtin_sym_end] = ACTIONS(2480),
    [sym_identifier] = ACTIONS(2482),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2480),
    [anon_sym_RBRACE] = ACTIONS(2480),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_typeof] = ACTIONS(2482),
    [anon_sym_import] = ACTIONS(2482),
    [anon_sym_var] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2480),
    [anon_sym_else] = ACTIONS(2482),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2480),
    [anon_sym_await] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_with] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_debugger] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(2482),
    [anon_sym_default] = ACTIONS(2482),
    [anon_sym_yield] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2480),
    [anon_sym_LTtemplate_GT] = ACTIONS(2480),
    [anon_sym_LT] = ACTIONS(2482),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2482),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_AMP] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_TILDE] = ACTIONS(2480),
    [anon_sym_void] = ACTIONS(2482),
    [anon_sym_delete] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2480),
    [anon_sym_DQUOTE] = ACTIONS(2480),
    [anon_sym_SQUOTE] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2480),
    [sym_number] = ACTIONS(2480),
    [sym_this] = ACTIONS(2482),
    [sym_super] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_null] = ACTIONS(2482),
    [sym_undefined] = ACTIONS(2482),
    [anon_sym_AT] = ACTIONS(2480),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_abstract] = ACTIONS(2482),
    [anon_sym_interface] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
    [anon_sym_component] = ACTIONS(2482),
    [anon_sym_instance] = ACTIONS(2482),
  },
  [655] = {
    [sym_identifier] = ACTIONS(1640),
    [anon_sym_export] = ACTIONS(1640),
    [anon_sym_LBRACE] = ACTIONS(1642),
    [anon_sym_RBRACE] = ACTIONS(1642),
    [anon_sym_type] = ACTIONS(1640),
    [anon_sym_typeof] = ACTIONS(1640),
    [anon_sym_import] = ACTIONS(1640),
    [anon_sym_var] = ACTIONS(1640),
    [anon_sym_let] = ACTIONS(1640),
    [anon_sym_const] = ACTIONS(1640),
    [anon_sym_BANG] = ACTIONS(1642),
    [anon_sym_else] = ACTIONS(1640),
    [anon_sym_if] = ACTIONS(1640),
    [anon_sym_switch] = ACTIONS(1640),
    [anon_sym_for] = ACTIONS(1640),
    [anon_sym_LPAREN] = ACTIONS(1642),
    [anon_sym_await] = ACTIONS(1640),
    [anon_sym_while] = ACTIONS(1640),
    [anon_sym_do] = ACTIONS(1640),
    [anon_sym_try] = ACTIONS(1640),
    [anon_sym_with] = ACTIONS(1640),
    [anon_sym_break] = ACTIONS(1640),
    [anon_sym_continue] = ACTIONS(1640),
    [anon_sym_debugger] = ACTIONS(1640),
    [anon_sym_return] = ACTIONS(1640),
    [anon_sym_throw] = ACTIONS(1640),
    [anon_sym_SEMI] = ACTIONS(1642),
    [anon_sym_case] = ACTIONS(1640),
    [anon_sym_default] = ACTIONS(1640),
    [anon_sym_catch] = ACTIONS(1640),
    [anon_sym_finally] = ACTIONS(1640),
    [anon_sym_yield] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1642),
    [anon_sym_LTtemplate_GT] = ACTIONS(1642),
    [anon_sym_LT] = ACTIONS(1640),
    [anon_sym_SLASH] = ACTIONS(1640),
    [anon_sym_class] = ACTIONS(1640),
    [anon_sym_async] = ACTIONS(1640),
    [anon_sym_function] = ACTIONS(1640),
    [anon_sym_new] = ACTIONS(1640),
    [anon_sym_AMP] = ACTIONS(1642),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_DASH] = ACTIONS(1640),
    [anon_sym_TILDE] = ACTIONS(1642),
    [anon_sym_void] = ACTIONS(1640),
    [anon_sym_delete] = ACTIONS(1640),
    [anon_sym_PLUS_PLUS] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [anon_sym_SQUOTE] = ACTIONS(1642),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [sym_number] = ACTIONS(1642),
    [sym_this] = ACTIONS(1640),
    [sym_super] = ACTIONS(1640),
    [sym_true] = ACTIONS(1640),
    [sym_false] = ACTIONS(1640),
    [sym_null] = ACTIONS(1640),
    [sym_undefined] = ACTIONS(1640),
    [anon_sym_AT] = ACTIONS(1642),
    [anon_sym_static] = ACTIONS(1640),
    [anon_sym_readonly] = ACTIONS(1640),
    [anon_sym_get] = ACTIONS(1640),
    [anon_sym_set] = ACTIONS(1640),
    [anon_sym_declare] = ACTIONS(1640),
    [anon_sym_namespace] = ACTIONS(1640),
    [anon_sym_public] = ACTIONS(1640),
    [anon_sym_private] = ACTIONS(1640),
    [anon_sym_protected] = ACTIONS(1640),
    [anon_sym_override] = ACTIONS(1640),
    [anon_sym_module] = ACTIONS(1640),
    [anon_sym_any] = ACTIONS(1640),
    [anon_sym_number] = ACTIONS(1640),
    [anon_sym_boolean] = ACTIONS(1640),
    [anon_sym_string] = ACTIONS(1640),
    [anon_sym_symbol] = ACTIONS(1640),
    [anon_sym_abstract] = ACTIONS(1640),
    [anon_sym_interface] = ACTIONS(1640),
    [anon_sym_enum] = ACTIONS(1640),
    [anon_sym_component] = ACTIONS(1640),
  },
  [656] = {
    [sym__call_signature] = STATE(4721),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2313),
    [anon_sym_export] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_type] = ACTIONS(2315),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(2484),
    [anon_sym_EQ] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_RBRACK] = ACTIONS(29),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2315),
    [anon_sym_function] = ACTIONS(2317),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2315),
    [anon_sym_readonly] = ACTIONS(2315),
    [anon_sym_get] = ACTIONS(2315),
    [anon_sym_set] = ACTIONS(2315),
    [anon_sym_declare] = ACTIONS(2315),
    [anon_sym_namespace] = ACTIONS(2315),
    [anon_sym_public] = ACTIONS(2315),
    [anon_sym_private] = ACTIONS(2315),
    [anon_sym_protected] = ACTIONS(2315),
    [anon_sym_override] = ACTIONS(2315),
    [anon_sym_module] = ACTIONS(2315),
    [anon_sym_any] = ACTIONS(2315),
    [anon_sym_number] = ACTIONS(2315),
    [anon_sym_boolean] = ACTIONS(2315),
    [anon_sym_string] = ACTIONS(2315),
    [anon_sym_symbol] = ACTIONS(2315),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [657] = {
    [ts_builtin_sym_end] = ACTIONS(2486),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_LBRACE] = ACTIONS(2486),
    [anon_sym_RBRACE] = ACTIONS(2486),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_typeof] = ACTIONS(2488),
    [anon_sym_import] = ACTIONS(2488),
    [anon_sym_var] = ACTIONS(2488),
    [anon_sym_let] = ACTIONS(2488),
    [anon_sym_const] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(2486),
    [anon_sym_else] = ACTIONS(2488),
    [anon_sym_if] = ACTIONS(2488),
    [anon_sym_switch] = ACTIONS(2488),
    [anon_sym_for] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(2486),
    [anon_sym_await] = ACTIONS(2488),
    [anon_sym_while] = ACTIONS(2488),
    [anon_sym_do] = ACTIONS(2488),
    [anon_sym_try] = ACTIONS(2488),
    [anon_sym_with] = ACTIONS(2488),
    [anon_sym_break] = ACTIONS(2488),
    [anon_sym_continue] = ACTIONS(2488),
    [anon_sym_debugger] = ACTIONS(2488),
    [anon_sym_return] = ACTIONS(2488),
    [anon_sym_throw] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2486),
    [anon_sym_case] = ACTIONS(2488),
    [anon_sym_default] = ACTIONS(2488),
    [anon_sym_yield] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2486),
    [anon_sym_LTtemplate_GT] = ACTIONS(2486),
    [anon_sym_LT] = ACTIONS(2488),
    [anon_sym_SLASH] = ACTIONS(2488),
    [anon_sym_class] = ACTIONS(2488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_function] = ACTIONS(2488),
    [anon_sym_new] = ACTIONS(2488),
    [anon_sym_AMP] = ACTIONS(2486),
    [anon_sym_PLUS] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_TILDE] = ACTIONS(2486),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_delete] = ACTIONS(2488),
    [anon_sym_PLUS_PLUS] = ACTIONS(2486),
    [anon_sym_DASH_DASH] = ACTIONS(2486),
    [anon_sym_DQUOTE] = ACTIONS(2486),
    [anon_sym_SQUOTE] = ACTIONS(2486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2486),
    [sym_number] = ACTIONS(2486),
    [sym_this] = ACTIONS(2488),
    [sym_super] = ACTIONS(2488),
    [sym_true] = ACTIONS(2488),
    [sym_false] = ACTIONS(2488),
    [sym_null] = ACTIONS(2488),
    [sym_undefined] = ACTIONS(2488),
    [anon_sym_AT] = ACTIONS(2486),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_readonly] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_override] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_abstract] = ACTIONS(2488),
    [anon_sym_interface] = ACTIONS(2488),
    [anon_sym_enum] = ACTIONS(2488),
    [anon_sym_component] = ACTIONS(2488),
    [anon_sym_instance] = ACTIONS(2488),
  },
  [658] = {
    [ts_builtin_sym_end] = ACTIONS(2490),
    [sym_identifier] = ACTIONS(2492),
    [anon_sym_export] = ACTIONS(2492),
    [anon_sym_LBRACE] = ACTIONS(2490),
    [anon_sym_RBRACE] = ACTIONS(2490),
    [anon_sym_type] = ACTIONS(2492),
    [anon_sym_typeof] = ACTIONS(2492),
    [anon_sym_import] = ACTIONS(2492),
    [anon_sym_var] = ACTIONS(2492),
    [anon_sym_let] = ACTIONS(2492),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_BANG] = ACTIONS(2490),
    [anon_sym_else] = ACTIONS(2492),
    [anon_sym_if] = ACTIONS(2492),
    [anon_sym_switch] = ACTIONS(2492),
    [anon_sym_for] = ACTIONS(2492),
    [anon_sym_LPAREN] = ACTIONS(2490),
    [anon_sym_await] = ACTIONS(2492),
    [anon_sym_while] = ACTIONS(2492),
    [anon_sym_do] = ACTIONS(2492),
    [anon_sym_try] = ACTIONS(2492),
    [anon_sym_with] = ACTIONS(2492),
    [anon_sym_break] = ACTIONS(2492),
    [anon_sym_continue] = ACTIONS(2492),
    [anon_sym_debugger] = ACTIONS(2492),
    [anon_sym_return] = ACTIONS(2492),
    [anon_sym_throw] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym_case] = ACTIONS(2492),
    [anon_sym_default] = ACTIONS(2492),
    [anon_sym_yield] = ACTIONS(2492),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_LTtemplate_GT] = ACTIONS(2490),
    [anon_sym_LT] = ACTIONS(2492),
    [anon_sym_SLASH] = ACTIONS(2492),
    [anon_sym_class] = ACTIONS(2492),
    [anon_sym_async] = ACTIONS(2492),
    [anon_sym_function] = ACTIONS(2492),
    [anon_sym_new] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(2492),
    [anon_sym_DASH] = ACTIONS(2492),
    [anon_sym_TILDE] = ACTIONS(2490),
    [anon_sym_void] = ACTIONS(2492),
    [anon_sym_delete] = ACTIONS(2492),
    [anon_sym_PLUS_PLUS] = ACTIONS(2490),
    [anon_sym_DASH_DASH] = ACTIONS(2490),
    [anon_sym_DQUOTE] = ACTIONS(2490),
    [anon_sym_SQUOTE] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2490),
    [sym_number] = ACTIONS(2490),
    [sym_this] = ACTIONS(2492),
    [sym_super] = ACTIONS(2492),
    [sym_true] = ACTIONS(2492),
    [sym_false] = ACTIONS(2492),
    [sym_null] = ACTIONS(2492),
    [sym_undefined] = ACTIONS(2492),
    [anon_sym_AT] = ACTIONS(2490),
    [anon_sym_static] = ACTIONS(2492),
    [anon_sym_readonly] = ACTIONS(2492),
    [anon_sym_get] = ACTIONS(2492),
    [anon_sym_set] = ACTIONS(2492),
    [anon_sym_declare] = ACTIONS(2492),
    [anon_sym_namespace] = ACTIONS(2492),
    [anon_sym_public] = ACTIONS(2492),
    [anon_sym_private] = ACTIONS(2492),
    [anon_sym_protected] = ACTIONS(2492),
    [anon_sym_override] = ACTIONS(2492),
    [anon_sym_module] = ACTIONS(2492),
    [anon_sym_any] = ACTIONS(2492),
    [anon_sym_number] = ACTIONS(2492),
    [anon_sym_boolean] = ACTIONS(2492),
    [anon_sym_string] = ACTIONS(2492),
    [anon_sym_symbol] = ACTIONS(2492),
    [anon_sym_abstract] = ACTIONS(2492),
    [anon_sym_interface] = ACTIONS(2492),
    [anon_sym_enum] = ACTIONS(2492),
    [anon_sym_component] = ACTIONS(2492),
    [anon_sym_instance] = ACTIONS(2492),
  },
  [659] = {
    [sym_identifier] = ACTIONS(1524),
    [anon_sym_export] = ACTIONS(1524),
    [anon_sym_LBRACE] = ACTIONS(1526),
    [anon_sym_RBRACE] = ACTIONS(1526),
    [anon_sym_type] = ACTIONS(1524),
    [anon_sym_typeof] = ACTIONS(1524),
    [anon_sym_import] = ACTIONS(1524),
    [anon_sym_var] = ACTIONS(1524),
    [anon_sym_let] = ACTIONS(1524),
    [anon_sym_const] = ACTIONS(1524),
    [anon_sym_BANG] = ACTIONS(1526),
    [anon_sym_else] = ACTIONS(1524),
    [anon_sym_if] = ACTIONS(1524),
    [anon_sym_switch] = ACTIONS(1524),
    [anon_sym_for] = ACTIONS(1524),
    [anon_sym_LPAREN] = ACTIONS(1526),
    [anon_sym_await] = ACTIONS(1524),
    [anon_sym_while] = ACTIONS(1524),
    [anon_sym_do] = ACTIONS(1524),
    [anon_sym_try] = ACTIONS(1524),
    [anon_sym_with] = ACTIONS(1524),
    [anon_sym_break] = ACTIONS(1524),
    [anon_sym_continue] = ACTIONS(1524),
    [anon_sym_debugger] = ACTIONS(1524),
    [anon_sym_return] = ACTIONS(1524),
    [anon_sym_throw] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1526),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1524),
    [anon_sym_catch] = ACTIONS(1524),
    [anon_sym_finally] = ACTIONS(1524),
    [anon_sym_yield] = ACTIONS(1524),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LTtemplate_GT] = ACTIONS(1526),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_SLASH] = ACTIONS(1524),
    [anon_sym_class] = ACTIONS(1524),
    [anon_sym_async] = ACTIONS(1524),
    [anon_sym_function] = ACTIONS(1524),
    [anon_sym_new] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1526),
    [anon_sym_PLUS] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1524),
    [anon_sym_TILDE] = ACTIONS(1526),
    [anon_sym_void] = ACTIONS(1524),
    [anon_sym_delete] = ACTIONS(1524),
    [anon_sym_PLUS_PLUS] = ACTIONS(1526),
    [anon_sym_DASH_DASH] = ACTIONS(1526),
    [anon_sym_DQUOTE] = ACTIONS(1526),
    [anon_sym_SQUOTE] = ACTIONS(1526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1526),
    [sym_number] = ACTIONS(1526),
    [sym_this] = ACTIONS(1524),
    [sym_super] = ACTIONS(1524),
    [sym_true] = ACTIONS(1524),
    [sym_false] = ACTIONS(1524),
    [sym_null] = ACTIONS(1524),
    [sym_undefined] = ACTIONS(1524),
    [anon_sym_AT] = ACTIONS(1526),
    [anon_sym_static] = ACTIONS(1524),
    [anon_sym_readonly] = ACTIONS(1524),
    [anon_sym_get] = ACTIONS(1524),
    [anon_sym_set] = ACTIONS(1524),
    [anon_sym_declare] = ACTIONS(1524),
    [anon_sym_namespace] = ACTIONS(1524),
    [anon_sym_public] = ACTIONS(1524),
    [anon_sym_private] = ACTIONS(1524),
    [anon_sym_protected] = ACTIONS(1524),
    [anon_sym_override] = ACTIONS(1524),
    [anon_sym_module] = ACTIONS(1524),
    [anon_sym_any] = ACTIONS(1524),
    [anon_sym_number] = ACTIONS(1524),
    [anon_sym_boolean] = ACTIONS(1524),
    [anon_sym_string] = ACTIONS(1524),
    [anon_sym_symbol] = ACTIONS(1524),
    [anon_sym_abstract] = ACTIONS(1524),
    [anon_sym_interface] = ACTIONS(1524),
    [anon_sym_enum] = ACTIONS(1524),
    [anon_sym_component] = ACTIONS(1524),
  },
  [660] = {
    [ts_builtin_sym_end] = ACTIONS(2494),
    [sym_identifier] = ACTIONS(2496),
    [anon_sym_export] = ACTIONS(2496),
    [anon_sym_LBRACE] = ACTIONS(2494),
    [anon_sym_RBRACE] = ACTIONS(2494),
    [anon_sym_type] = ACTIONS(2496),
    [anon_sym_typeof] = ACTIONS(2496),
    [anon_sym_import] = ACTIONS(2496),
    [anon_sym_var] = ACTIONS(2496),
    [anon_sym_let] = ACTIONS(2496),
    [anon_sym_const] = ACTIONS(2496),
    [anon_sym_BANG] = ACTIONS(2494),
    [anon_sym_else] = ACTIONS(2496),
    [anon_sym_if] = ACTIONS(2496),
    [anon_sym_switch] = ACTIONS(2496),
    [anon_sym_for] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(2494),
    [anon_sym_await] = ACTIONS(2496),
    [anon_sym_while] = ACTIONS(2496),
    [anon_sym_do] = ACTIONS(2496),
    [anon_sym_try] = ACTIONS(2496),
    [anon_sym_with] = ACTIONS(2496),
    [anon_sym_break] = ACTIONS(2496),
    [anon_sym_continue] = ACTIONS(2496),
    [anon_sym_debugger] = ACTIONS(2496),
    [anon_sym_return] = ACTIONS(2496),
    [anon_sym_throw] = ACTIONS(2496),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_case] = ACTIONS(2496),
    [anon_sym_default] = ACTIONS(2496),
    [anon_sym_yield] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(2494),
    [anon_sym_LTtemplate_GT] = ACTIONS(2494),
    [anon_sym_LT] = ACTIONS(2496),
    [anon_sym_SLASH] = ACTIONS(2496),
    [anon_sym_class] = ACTIONS(2496),
    [anon_sym_async] = ACTIONS(2496),
    [anon_sym_function] = ACTIONS(2496),
    [anon_sym_new] = ACTIONS(2496),
    [anon_sym_AMP] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2494),
    [anon_sym_void] = ACTIONS(2496),
    [anon_sym_delete] = ACTIONS(2496),
    [anon_sym_PLUS_PLUS] = ACTIONS(2494),
    [anon_sym_DASH_DASH] = ACTIONS(2494),
    [anon_sym_DQUOTE] = ACTIONS(2494),
    [anon_sym_SQUOTE] = ACTIONS(2494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2494),
    [sym_number] = ACTIONS(2494),
    [sym_this] = ACTIONS(2496),
    [sym_super] = ACTIONS(2496),
    [sym_true] = ACTIONS(2496),
    [sym_false] = ACTIONS(2496),
    [sym_null] = ACTIONS(2496),
    [sym_undefined] = ACTIONS(2496),
    [anon_sym_AT] = ACTIONS(2494),
    [anon_sym_static] = ACTIONS(2496),
    [anon_sym_readonly] = ACTIONS(2496),
    [anon_sym_get] = ACTIONS(2496),
    [anon_sym_set] = ACTIONS(2496),
    [anon_sym_declare] = ACTIONS(2496),
    [anon_sym_namespace] = ACTIONS(2496),
    [anon_sym_public] = ACTIONS(2496),
    [anon_sym_private] = ACTIONS(2496),
    [anon_sym_protected] = ACTIONS(2496),
    [anon_sym_override] = ACTIONS(2496),
    [anon_sym_module] = ACTIONS(2496),
    [anon_sym_any] = ACTIONS(2496),
    [anon_sym_number] = ACTIONS(2496),
    [anon_sym_boolean] = ACTIONS(2496),
    [anon_sym_string] = ACTIONS(2496),
    [anon_sym_symbol] = ACTIONS(2496),
    [anon_sym_abstract] = ACTIONS(2496),
    [anon_sym_interface] = ACTIONS(2496),
    [anon_sym_enum] = ACTIONS(2496),
    [anon_sym_component] = ACTIONS(2496),
    [anon_sym_instance] = ACTIONS(2496),
  },
  [661] = {
    [ts_builtin_sym_end] = ACTIONS(2498),
    [sym_identifier] = ACTIONS(2500),
    [anon_sym_export] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(2498),
    [anon_sym_RBRACE] = ACTIONS(2498),
    [anon_sym_type] = ACTIONS(2500),
    [anon_sym_typeof] = ACTIONS(2500),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_var] = ACTIONS(2500),
    [anon_sym_let] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_else] = ACTIONS(2500),
    [anon_sym_if] = ACTIONS(2500),
    [anon_sym_switch] = ACTIONS(2500),
    [anon_sym_for] = ACTIONS(2500),
    [anon_sym_LPAREN] = ACTIONS(2498),
    [anon_sym_await] = ACTIONS(2500),
    [anon_sym_while] = ACTIONS(2500),
    [anon_sym_do] = ACTIONS(2500),
    [anon_sym_try] = ACTIONS(2500),
    [anon_sym_with] = ACTIONS(2500),
    [anon_sym_break] = ACTIONS(2500),
    [anon_sym_continue] = ACTIONS(2500),
    [anon_sym_debugger] = ACTIONS(2500),
    [anon_sym_return] = ACTIONS(2500),
    [anon_sym_throw] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym_case] = ACTIONS(2500),
    [anon_sym_default] = ACTIONS(2500),
    [anon_sym_yield] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2498),
    [anon_sym_LTtemplate_GT] = ACTIONS(2498),
    [anon_sym_LT] = ACTIONS(2500),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_async] = ACTIONS(2500),
    [anon_sym_function] = ACTIONS(2500),
    [anon_sym_new] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2498),
    [anon_sym_PLUS] = ACTIONS(2500),
    [anon_sym_DASH] = ACTIONS(2500),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_void] = ACTIONS(2500),
    [anon_sym_delete] = ACTIONS(2500),
    [anon_sym_PLUS_PLUS] = ACTIONS(2498),
    [anon_sym_DASH_DASH] = ACTIONS(2498),
    [anon_sym_DQUOTE] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2498),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2498),
    [sym_number] = ACTIONS(2498),
    [sym_this] = ACTIONS(2500),
    [sym_super] = ACTIONS(2500),
    [sym_true] = ACTIONS(2500),
    [sym_false] = ACTIONS(2500),
    [sym_null] = ACTIONS(2500),
    [sym_undefined] = ACTIONS(2500),
    [anon_sym_AT] = ACTIONS(2498),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_readonly] = ACTIONS(2500),
    [anon_sym_get] = ACTIONS(2500),
    [anon_sym_set] = ACTIONS(2500),
    [anon_sym_declare] = ACTIONS(2500),
    [anon_sym_namespace] = ACTIONS(2500),
    [anon_sym_public] = ACTIONS(2500),
    [anon_sym_private] = ACTIONS(2500),
    [anon_sym_protected] = ACTIONS(2500),
    [anon_sym_override] = ACTIONS(2500),
    [anon_sym_module] = ACTIONS(2500),
    [anon_sym_any] = ACTIONS(2500),
    [anon_sym_number] = ACTIONS(2500),
    [anon_sym_boolean] = ACTIONS(2500),
    [anon_sym_string] = ACTIONS(2500),
    [anon_sym_symbol] = ACTIONS(2500),
    [anon_sym_abstract] = ACTIONS(2500),
    [anon_sym_interface] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_component] = ACTIONS(2500),
    [anon_sym_instance] = ACTIONS(2500),
  },
  [662] = {
    [ts_builtin_sym_end] = ACTIONS(2502),
    [sym_identifier] = ACTIONS(2504),
    [anon_sym_export] = ACTIONS(2504),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_type] = ACTIONS(2504),
    [anon_sym_typeof] = ACTIONS(2504),
    [anon_sym_import] = ACTIONS(2504),
    [anon_sym_var] = ACTIONS(2504),
    [anon_sym_let] = ACTIONS(2504),
    [anon_sym_const] = ACTIONS(2504),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_else] = ACTIONS(2504),
    [anon_sym_if] = ACTIONS(2504),
    [anon_sym_switch] = ACTIONS(2504),
    [anon_sym_for] = ACTIONS(2504),
    [anon_sym_LPAREN] = ACTIONS(2502),
    [anon_sym_await] = ACTIONS(2504),
    [anon_sym_while] = ACTIONS(2504),
    [anon_sym_do] = ACTIONS(2504),
    [anon_sym_try] = ACTIONS(2504),
    [anon_sym_with] = ACTIONS(2504),
    [anon_sym_break] = ACTIONS(2504),
    [anon_sym_continue] = ACTIONS(2504),
    [anon_sym_debugger] = ACTIONS(2504),
    [anon_sym_return] = ACTIONS(2504),
    [anon_sym_throw] = ACTIONS(2504),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_case] = ACTIONS(2504),
    [anon_sym_default] = ACTIONS(2504),
    [anon_sym_yield] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2502),
    [anon_sym_LTtemplate_GT] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_SLASH] = ACTIONS(2504),
    [anon_sym_class] = ACTIONS(2504),
    [anon_sym_async] = ACTIONS(2504),
    [anon_sym_function] = ACTIONS(2504),
    [anon_sym_new] = ACTIONS(2504),
    [anon_sym_AMP] = ACTIONS(2502),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_void] = ACTIONS(2504),
    [anon_sym_delete] = ACTIONS(2504),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [sym_number] = ACTIONS(2502),
    [sym_this] = ACTIONS(2504),
    [sym_super] = ACTIONS(2504),
    [sym_true] = ACTIONS(2504),
    [sym_false] = ACTIONS(2504),
    [sym_null] = ACTIONS(2504),
    [sym_undefined] = ACTIONS(2504),
    [anon_sym_AT] = ACTIONS(2502),
    [anon_sym_static] = ACTIONS(2504),
    [anon_sym_readonly] = ACTIONS(2504),
    [anon_sym_get] = ACTIONS(2504),
    [anon_sym_set] = ACTIONS(2504),
    [anon_sym_declare] = ACTIONS(2504),
    [anon_sym_namespace] = ACTIONS(2504),
    [anon_sym_public] = ACTIONS(2504),
    [anon_sym_private] = ACTIONS(2504),
    [anon_sym_protected] = ACTIONS(2504),
    [anon_sym_override] = ACTIONS(2504),
    [anon_sym_module] = ACTIONS(2504),
    [anon_sym_any] = ACTIONS(2504),
    [anon_sym_number] = ACTIONS(2504),
    [anon_sym_boolean] = ACTIONS(2504),
    [anon_sym_string] = ACTIONS(2504),
    [anon_sym_symbol] = ACTIONS(2504),
    [anon_sym_abstract] = ACTIONS(2504),
    [anon_sym_interface] = ACTIONS(2504),
    [anon_sym_enum] = ACTIONS(2504),
    [anon_sym_component] = ACTIONS(2504),
    [anon_sym_instance] = ACTIONS(2504),
  },
  [663] = {
    [ts_builtin_sym_end] = ACTIONS(2506),
    [sym_identifier] = ACTIONS(2508),
    [anon_sym_export] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_type] = ACTIONS(2508),
    [anon_sym_typeof] = ACTIONS(2508),
    [anon_sym_import] = ACTIONS(2508),
    [anon_sym_var] = ACTIONS(2508),
    [anon_sym_let] = ACTIONS(2508),
    [anon_sym_const] = ACTIONS(2508),
    [anon_sym_BANG] = ACTIONS(2506),
    [anon_sym_else] = ACTIONS(2508),
    [anon_sym_if] = ACTIONS(2508),
    [anon_sym_switch] = ACTIONS(2508),
    [anon_sym_for] = ACTIONS(2508),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_await] = ACTIONS(2508),
    [anon_sym_while] = ACTIONS(2508),
    [anon_sym_do] = ACTIONS(2508),
    [anon_sym_try] = ACTIONS(2508),
    [anon_sym_with] = ACTIONS(2508),
    [anon_sym_break] = ACTIONS(2508),
    [anon_sym_continue] = ACTIONS(2508),
    [anon_sym_debugger] = ACTIONS(2508),
    [anon_sym_return] = ACTIONS(2508),
    [anon_sym_throw] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_case] = ACTIONS(2508),
    [anon_sym_default] = ACTIONS(2508),
    [anon_sym_yield] = ACTIONS(2508),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_LTtemplate_GT] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_SLASH] = ACTIONS(2508),
    [anon_sym_class] = ACTIONS(2508),
    [anon_sym_async] = ACTIONS(2508),
    [anon_sym_function] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_TILDE] = ACTIONS(2506),
    [anon_sym_void] = ACTIONS(2508),
    [anon_sym_delete] = ACTIONS(2508),
    [anon_sym_PLUS_PLUS] = ACTIONS(2506),
    [anon_sym_DASH_DASH] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [sym_number] = ACTIONS(2506),
    [sym_this] = ACTIONS(2508),
    [sym_super] = ACTIONS(2508),
    [sym_true] = ACTIONS(2508),
    [sym_false] = ACTIONS(2508),
    [sym_null] = ACTIONS(2508),
    [sym_undefined] = ACTIONS(2508),
    [anon_sym_AT] = ACTIONS(2506),
    [anon_sym_static] = ACTIONS(2508),
    [anon_sym_readonly] = ACTIONS(2508),
    [anon_sym_get] = ACTIONS(2508),
    [anon_sym_set] = ACTIONS(2508),
    [anon_sym_declare] = ACTIONS(2508),
    [anon_sym_namespace] = ACTIONS(2508),
    [anon_sym_public] = ACTIONS(2508),
    [anon_sym_private] = ACTIONS(2508),
    [anon_sym_protected] = ACTIONS(2508),
    [anon_sym_override] = ACTIONS(2508),
    [anon_sym_module] = ACTIONS(2508),
    [anon_sym_any] = ACTIONS(2508),
    [anon_sym_number] = ACTIONS(2508),
    [anon_sym_boolean] = ACTIONS(2508),
    [anon_sym_string] = ACTIONS(2508),
    [anon_sym_symbol] = ACTIONS(2508),
    [anon_sym_abstract] = ACTIONS(2508),
    [anon_sym_interface] = ACTIONS(2508),
    [anon_sym_enum] = ACTIONS(2508),
    [anon_sym_component] = ACTIONS(2508),
    [anon_sym_instance] = ACTIONS(2508),
  },
  [664] = {
    [ts_builtin_sym_end] = ACTIONS(2510),
    [sym_identifier] = ACTIONS(2512),
    [anon_sym_export] = ACTIONS(2512),
    [anon_sym_LBRACE] = ACTIONS(2510),
    [anon_sym_RBRACE] = ACTIONS(2510),
    [anon_sym_type] = ACTIONS(2512),
    [anon_sym_typeof] = ACTIONS(2512),
    [anon_sym_import] = ACTIONS(2512),
    [anon_sym_var] = ACTIONS(2512),
    [anon_sym_let] = ACTIONS(2512),
    [anon_sym_const] = ACTIONS(2512),
    [anon_sym_BANG] = ACTIONS(2510),
    [anon_sym_else] = ACTIONS(2512),
    [anon_sym_if] = ACTIONS(2512),
    [anon_sym_switch] = ACTIONS(2512),
    [anon_sym_for] = ACTIONS(2512),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_await] = ACTIONS(2512),
    [anon_sym_while] = ACTIONS(2512),
    [anon_sym_do] = ACTIONS(2512),
    [anon_sym_try] = ACTIONS(2512),
    [anon_sym_with] = ACTIONS(2512),
    [anon_sym_break] = ACTIONS(2512),
    [anon_sym_continue] = ACTIONS(2512),
    [anon_sym_debugger] = ACTIONS(2512),
    [anon_sym_return] = ACTIONS(2512),
    [anon_sym_throw] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2510),
    [anon_sym_case] = ACTIONS(2512),
    [anon_sym_default] = ACTIONS(2512),
    [anon_sym_yield] = ACTIONS(2512),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_LTtemplate_GT] = ACTIONS(2510),
    [anon_sym_LT] = ACTIONS(2512),
    [anon_sym_SLASH] = ACTIONS(2512),
    [anon_sym_class] = ACTIONS(2512),
    [anon_sym_async] = ACTIONS(2512),
    [anon_sym_function] = ACTIONS(2512),
    [anon_sym_new] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_TILDE] = ACTIONS(2510),
    [anon_sym_void] = ACTIONS(2512),
    [anon_sym_delete] = ACTIONS(2512),
    [anon_sym_PLUS_PLUS] = ACTIONS(2510),
    [anon_sym_DASH_DASH] = ACTIONS(2510),
    [anon_sym_DQUOTE] = ACTIONS(2510),
    [anon_sym_SQUOTE] = ACTIONS(2510),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2510),
    [sym_number] = ACTIONS(2510),
    [sym_this] = ACTIONS(2512),
    [sym_super] = ACTIONS(2512),
    [sym_true] = ACTIONS(2512),
    [sym_false] = ACTIONS(2512),
    [sym_null] = ACTIONS(2512),
    [sym_undefined] = ACTIONS(2512),
    [anon_sym_AT] = ACTIONS(2510),
    [anon_sym_static] = ACTIONS(2512),
    [anon_sym_readonly] = ACTIONS(2512),
    [anon_sym_get] = ACTIONS(2512),
    [anon_sym_set] = ACTIONS(2512),
    [anon_sym_declare] = ACTIONS(2512),
    [anon_sym_namespace] = ACTIONS(2512),
    [anon_sym_public] = ACTIONS(2512),
    [anon_sym_private] = ACTIONS(2512),
    [anon_sym_protected] = ACTIONS(2512),
    [anon_sym_override] = ACTIONS(2512),
    [anon_sym_module] = ACTIONS(2512),
    [anon_sym_any] = ACTIONS(2512),
    [anon_sym_number] = ACTIONS(2512),
    [anon_sym_boolean] = ACTIONS(2512),
    [anon_sym_string] = ACTIONS(2512),
    [anon_sym_symbol] = ACTIONS(2512),
    [anon_sym_abstract] = ACTIONS(2512),
    [anon_sym_interface] = ACTIONS(2512),
    [anon_sym_enum] = ACTIONS(2512),
    [anon_sym_component] = ACTIONS(2512),
    [anon_sym_instance] = ACTIONS(2512),
  },
  [665] = {
    [sym__call_signature] = STATE(4818),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_export] = ACTIONS(2516),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_type] = ACTIONS(2516),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2516),
    [anon_sym_function] = ACTIONS(2317),
    [anon_sym_EQ_GT] = ACTIONS(1239),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2516),
    [anon_sym_readonly] = ACTIONS(2516),
    [anon_sym_get] = ACTIONS(2516),
    [anon_sym_set] = ACTIONS(2516),
    [anon_sym_declare] = ACTIONS(2516),
    [anon_sym_namespace] = ACTIONS(2516),
    [anon_sym_public] = ACTIONS(2516),
    [anon_sym_private] = ACTIONS(2516),
    [anon_sym_protected] = ACTIONS(2516),
    [anon_sym_override] = ACTIONS(2516),
    [anon_sym_module] = ACTIONS(2516),
    [anon_sym_any] = ACTIONS(2516),
    [anon_sym_number] = ACTIONS(2516),
    [anon_sym_boolean] = ACTIONS(2516),
    [anon_sym_string] = ACTIONS(2516),
    [anon_sym_symbol] = ACTIONS(2516),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_implements] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [666] = {
    [ts_builtin_sym_end] = ACTIONS(2518),
    [sym_identifier] = ACTIONS(2520),
    [anon_sym_export] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_RBRACE] = ACTIONS(2518),
    [anon_sym_type] = ACTIONS(2520),
    [anon_sym_typeof] = ACTIONS(2520),
    [anon_sym_import] = ACTIONS(2520),
    [anon_sym_var] = ACTIONS(2520),
    [anon_sym_let] = ACTIONS(2520),
    [anon_sym_const] = ACTIONS(2520),
    [anon_sym_BANG] = ACTIONS(2518),
    [anon_sym_else] = ACTIONS(2520),
    [anon_sym_if] = ACTIONS(2520),
    [anon_sym_switch] = ACTIONS(2520),
    [anon_sym_for] = ACTIONS(2520),
    [anon_sym_LPAREN] = ACTIONS(2518),
    [anon_sym_await] = ACTIONS(2520),
    [anon_sym_while] = ACTIONS(2520),
    [anon_sym_do] = ACTIONS(2520),
    [anon_sym_try] = ACTIONS(2520),
    [anon_sym_with] = ACTIONS(2520),
    [anon_sym_break] = ACTIONS(2520),
    [anon_sym_continue] = ACTIONS(2520),
    [anon_sym_debugger] = ACTIONS(2520),
    [anon_sym_return] = ACTIONS(2520),
    [anon_sym_throw] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2518),
    [anon_sym_case] = ACTIONS(2520),
    [anon_sym_default] = ACTIONS(2520),
    [anon_sym_yield] = ACTIONS(2520),
    [anon_sym_LBRACK] = ACTIONS(2518),
    [anon_sym_LTtemplate_GT] = ACTIONS(2518),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_SLASH] = ACTIONS(2520),
    [anon_sym_class] = ACTIONS(2520),
    [anon_sym_async] = ACTIONS(2520),
    [anon_sym_function] = ACTIONS(2520),
    [anon_sym_new] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_DASH] = ACTIONS(2520),
    [anon_sym_TILDE] = ACTIONS(2518),
    [anon_sym_void] = ACTIONS(2520),
    [anon_sym_delete] = ACTIONS(2520),
    [anon_sym_PLUS_PLUS] = ACTIONS(2518),
    [anon_sym_DASH_DASH] = ACTIONS(2518),
    [anon_sym_DQUOTE] = ACTIONS(2518),
    [anon_sym_SQUOTE] = ACTIONS(2518),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2518),
    [sym_number] = ACTIONS(2518),
    [sym_this] = ACTIONS(2520),
    [sym_super] = ACTIONS(2520),
    [sym_true] = ACTIONS(2520),
    [sym_false] = ACTIONS(2520),
    [sym_null] = ACTIONS(2520),
    [sym_undefined] = ACTIONS(2520),
    [anon_sym_AT] = ACTIONS(2518),
    [anon_sym_static] = ACTIONS(2520),
    [anon_sym_readonly] = ACTIONS(2520),
    [anon_sym_get] = ACTIONS(2520),
    [anon_sym_set] = ACTIONS(2520),
    [anon_sym_declare] = ACTIONS(2520),
    [anon_sym_namespace] = ACTIONS(2520),
    [anon_sym_public] = ACTIONS(2520),
    [anon_sym_private] = ACTIONS(2520),
    [anon_sym_protected] = ACTIONS(2520),
    [anon_sym_override] = ACTIONS(2520),
    [anon_sym_module] = ACTIONS(2520),
    [anon_sym_any] = ACTIONS(2520),
    [anon_sym_number] = ACTIONS(2520),
    [anon_sym_boolean] = ACTIONS(2520),
    [anon_sym_string] = ACTIONS(2520),
    [anon_sym_symbol] = ACTIONS(2520),
    [anon_sym_abstract] = ACTIONS(2520),
    [anon_sym_interface] = ACTIONS(2520),
    [anon_sym_enum] = ACTIONS(2520),
    [anon_sym_component] = ACTIONS(2520),
    [anon_sym_instance] = ACTIONS(2520),
  },
  [667] = {
    [ts_builtin_sym_end] = ACTIONS(2522),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_LBRACE] = ACTIONS(2522),
    [anon_sym_RBRACE] = ACTIONS(2522),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_typeof] = ACTIONS(2524),
    [anon_sym_import] = ACTIONS(2524),
    [anon_sym_var] = ACTIONS(2524),
    [anon_sym_let] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_BANG] = ACTIONS(2522),
    [anon_sym_else] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2524),
    [anon_sym_switch] = ACTIONS(2524),
    [anon_sym_for] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(2522),
    [anon_sym_await] = ACTIONS(2524),
    [anon_sym_while] = ACTIONS(2524),
    [anon_sym_do] = ACTIONS(2524),
    [anon_sym_try] = ACTIONS(2524),
    [anon_sym_with] = ACTIONS(2524),
    [anon_sym_break] = ACTIONS(2524),
    [anon_sym_continue] = ACTIONS(2524),
    [anon_sym_debugger] = ACTIONS(2524),
    [anon_sym_return] = ACTIONS(2524),
    [anon_sym_throw] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_case] = ACTIONS(2524),
    [anon_sym_default] = ACTIONS(2524),
    [anon_sym_yield] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2522),
    [anon_sym_LTtemplate_GT] = ACTIONS(2522),
    [anon_sym_LT] = ACTIONS(2524),
    [anon_sym_SLASH] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_function] = ACTIONS(2524),
    [anon_sym_new] = ACTIONS(2524),
    [anon_sym_AMP] = ACTIONS(2522),
    [anon_sym_PLUS] = ACTIONS(2524),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_TILDE] = ACTIONS(2522),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_delete] = ACTIONS(2524),
    [anon_sym_PLUS_PLUS] = ACTIONS(2522),
    [anon_sym_DASH_DASH] = ACTIONS(2522),
    [anon_sym_DQUOTE] = ACTIONS(2522),
    [anon_sym_SQUOTE] = ACTIONS(2522),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2522),
    [sym_number] = ACTIONS(2522),
    [sym_this] = ACTIONS(2524),
    [sym_super] = ACTIONS(2524),
    [sym_true] = ACTIONS(2524),
    [sym_false] = ACTIONS(2524),
    [sym_null] = ACTIONS(2524),
    [sym_undefined] = ACTIONS(2524),
    [anon_sym_AT] = ACTIONS(2522),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_readonly] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_override] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [anon_sym_abstract] = ACTIONS(2524),
    [anon_sym_interface] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_component] = ACTIONS(2524),
    [anon_sym_instance] = ACTIONS(2524),
  },
  [668] = {
    [ts_builtin_sym_end] = ACTIONS(2526),
    [sym_identifier] = ACTIONS(2528),
    [anon_sym_export] = ACTIONS(2528),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_RBRACE] = ACTIONS(2526),
    [anon_sym_type] = ACTIONS(2528),
    [anon_sym_typeof] = ACTIONS(2528),
    [anon_sym_import] = ACTIONS(2528),
    [anon_sym_var] = ACTIONS(2528),
    [anon_sym_let] = ACTIONS(2528),
    [anon_sym_const] = ACTIONS(2528),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_else] = ACTIONS(2528),
    [anon_sym_if] = ACTIONS(2528),
    [anon_sym_switch] = ACTIONS(2528),
    [anon_sym_for] = ACTIONS(2528),
    [anon_sym_LPAREN] = ACTIONS(2526),
    [anon_sym_await] = ACTIONS(2528),
    [anon_sym_while] = ACTIONS(2528),
    [anon_sym_do] = ACTIONS(2528),
    [anon_sym_try] = ACTIONS(2528),
    [anon_sym_with] = ACTIONS(2528),
    [anon_sym_break] = ACTIONS(2528),
    [anon_sym_continue] = ACTIONS(2528),
    [anon_sym_debugger] = ACTIONS(2528),
    [anon_sym_return] = ACTIONS(2528),
    [anon_sym_throw] = ACTIONS(2528),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym_case] = ACTIONS(2528),
    [anon_sym_default] = ACTIONS(2528),
    [anon_sym_yield] = ACTIONS(2528),
    [anon_sym_LBRACK] = ACTIONS(2526),
    [anon_sym_LTtemplate_GT] = ACTIONS(2526),
    [anon_sym_LT] = ACTIONS(2528),
    [anon_sym_SLASH] = ACTIONS(2528),
    [anon_sym_class] = ACTIONS(2528),
    [anon_sym_async] = ACTIONS(2528),
    [anon_sym_function] = ACTIONS(2528),
    [anon_sym_new] = ACTIONS(2528),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_PLUS] = ACTIONS(2528),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_void] = ACTIONS(2528),
    [anon_sym_delete] = ACTIONS(2528),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_DQUOTE] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2526),
    [sym_number] = ACTIONS(2526),
    [sym_this] = ACTIONS(2528),
    [sym_super] = ACTIONS(2528),
    [sym_true] = ACTIONS(2528),
    [sym_false] = ACTIONS(2528),
    [sym_null] = ACTIONS(2528),
    [sym_undefined] = ACTIONS(2528),
    [anon_sym_AT] = ACTIONS(2526),
    [anon_sym_static] = ACTIONS(2528),
    [anon_sym_readonly] = ACTIONS(2528),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2528),
    [anon_sym_namespace] = ACTIONS(2528),
    [anon_sym_public] = ACTIONS(2528),
    [anon_sym_private] = ACTIONS(2528),
    [anon_sym_protected] = ACTIONS(2528),
    [anon_sym_override] = ACTIONS(2528),
    [anon_sym_module] = ACTIONS(2528),
    [anon_sym_any] = ACTIONS(2528),
    [anon_sym_number] = ACTIONS(2528),
    [anon_sym_boolean] = ACTIONS(2528),
    [anon_sym_string] = ACTIONS(2528),
    [anon_sym_symbol] = ACTIONS(2528),
    [anon_sym_abstract] = ACTIONS(2528),
    [anon_sym_interface] = ACTIONS(2528),
    [anon_sym_enum] = ACTIONS(2528),
    [anon_sym_component] = ACTIONS(2528),
    [anon_sym_instance] = ACTIONS(2528),
  },
  [669] = {
    [ts_builtin_sym_end] = ACTIONS(2530),
    [sym_identifier] = ACTIONS(2532),
    [anon_sym_export] = ACTIONS(2532),
    [anon_sym_LBRACE] = ACTIONS(2530),
    [anon_sym_RBRACE] = ACTIONS(2530),
    [anon_sym_type] = ACTIONS(2532),
    [anon_sym_typeof] = ACTIONS(2532),
    [anon_sym_import] = ACTIONS(2532),
    [anon_sym_var] = ACTIONS(2532),
    [anon_sym_let] = ACTIONS(2532),
    [anon_sym_const] = ACTIONS(2532),
    [anon_sym_BANG] = ACTIONS(2530),
    [anon_sym_else] = ACTIONS(2532),
    [anon_sym_if] = ACTIONS(2532),
    [anon_sym_switch] = ACTIONS(2532),
    [anon_sym_for] = ACTIONS(2532),
    [anon_sym_LPAREN] = ACTIONS(2530),
    [anon_sym_await] = ACTIONS(2532),
    [anon_sym_while] = ACTIONS(2532),
    [anon_sym_do] = ACTIONS(2532),
    [anon_sym_try] = ACTIONS(2532),
    [anon_sym_with] = ACTIONS(2532),
    [anon_sym_break] = ACTIONS(2532),
    [anon_sym_continue] = ACTIONS(2532),
    [anon_sym_debugger] = ACTIONS(2532),
    [anon_sym_return] = ACTIONS(2532),
    [anon_sym_throw] = ACTIONS(2532),
    [anon_sym_SEMI] = ACTIONS(2530),
    [anon_sym_case] = ACTIONS(2532),
    [anon_sym_default] = ACTIONS(2532),
    [anon_sym_yield] = ACTIONS(2532),
    [anon_sym_LBRACK] = ACTIONS(2530),
    [anon_sym_LTtemplate_GT] = ACTIONS(2530),
    [anon_sym_LT] = ACTIONS(2532),
    [anon_sym_SLASH] = ACTIONS(2532),
    [anon_sym_class] = ACTIONS(2532),
    [anon_sym_async] = ACTIONS(2532),
    [anon_sym_function] = ACTIONS(2532),
    [anon_sym_new] = ACTIONS(2532),
    [anon_sym_AMP] = ACTIONS(2530),
    [anon_sym_PLUS] = ACTIONS(2532),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_TILDE] = ACTIONS(2530),
    [anon_sym_void] = ACTIONS(2532),
    [anon_sym_delete] = ACTIONS(2532),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_DQUOTE] = ACTIONS(2530),
    [anon_sym_SQUOTE] = ACTIONS(2530),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2530),
    [sym_number] = ACTIONS(2530),
    [sym_this] = ACTIONS(2532),
    [sym_super] = ACTIONS(2532),
    [sym_true] = ACTIONS(2532),
    [sym_false] = ACTIONS(2532),
    [sym_null] = ACTIONS(2532),
    [sym_undefined] = ACTIONS(2532),
    [anon_sym_AT] = ACTIONS(2530),
    [anon_sym_static] = ACTIONS(2532),
    [anon_sym_readonly] = ACTIONS(2532),
    [anon_sym_get] = ACTIONS(2532),
    [anon_sym_set] = ACTIONS(2532),
    [anon_sym_declare] = ACTIONS(2532),
    [anon_sym_namespace] = ACTIONS(2532),
    [anon_sym_public] = ACTIONS(2532),
    [anon_sym_private] = ACTIONS(2532),
    [anon_sym_protected] = ACTIONS(2532),
    [anon_sym_override] = ACTIONS(2532),
    [anon_sym_module] = ACTIONS(2532),
    [anon_sym_any] = ACTIONS(2532),
    [anon_sym_number] = ACTIONS(2532),
    [anon_sym_boolean] = ACTIONS(2532),
    [anon_sym_string] = ACTIONS(2532),
    [anon_sym_symbol] = ACTIONS(2532),
    [anon_sym_abstract] = ACTIONS(2532),
    [anon_sym_interface] = ACTIONS(2532),
    [anon_sym_enum] = ACTIONS(2532),
    [anon_sym_component] = ACTIONS(2532),
    [anon_sym_instance] = ACTIONS(2532),
  },
  [670] = {
    [ts_builtin_sym_end] = ACTIONS(2534),
    [sym_identifier] = ACTIONS(2536),
    [anon_sym_export] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(2534),
    [anon_sym_RBRACE] = ACTIONS(2534),
    [anon_sym_type] = ACTIONS(2536),
    [anon_sym_typeof] = ACTIONS(2536),
    [anon_sym_import] = ACTIONS(2536),
    [anon_sym_var] = ACTIONS(2536),
    [anon_sym_let] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_BANG] = ACTIONS(2534),
    [anon_sym_else] = ACTIONS(2536),
    [anon_sym_if] = ACTIONS(2536),
    [anon_sym_switch] = ACTIONS(2536),
    [anon_sym_for] = ACTIONS(2536),
    [anon_sym_LPAREN] = ACTIONS(2534),
    [anon_sym_await] = ACTIONS(2536),
    [anon_sym_while] = ACTIONS(2536),
    [anon_sym_do] = ACTIONS(2536),
    [anon_sym_try] = ACTIONS(2536),
    [anon_sym_with] = ACTIONS(2536),
    [anon_sym_break] = ACTIONS(2536),
    [anon_sym_continue] = ACTIONS(2536),
    [anon_sym_debugger] = ACTIONS(2536),
    [anon_sym_return] = ACTIONS(2536),
    [anon_sym_throw] = ACTIONS(2536),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym_case] = ACTIONS(2536),
    [anon_sym_default] = ACTIONS(2536),
    [anon_sym_yield] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2534),
    [anon_sym_LTtemplate_GT] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_SLASH] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_async] = ACTIONS(2536),
    [anon_sym_function] = ACTIONS(2536),
    [anon_sym_new] = ACTIONS(2536),
    [anon_sym_AMP] = ACTIONS(2534),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_TILDE] = ACTIONS(2534),
    [anon_sym_void] = ACTIONS(2536),
    [anon_sym_delete] = ACTIONS(2536),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [sym_number] = ACTIONS(2534),
    [sym_this] = ACTIONS(2536),
    [sym_super] = ACTIONS(2536),
    [sym_true] = ACTIONS(2536),
    [sym_false] = ACTIONS(2536),
    [sym_null] = ACTIONS(2536),
    [sym_undefined] = ACTIONS(2536),
    [anon_sym_AT] = ACTIONS(2534),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_readonly] = ACTIONS(2536),
    [anon_sym_get] = ACTIONS(2536),
    [anon_sym_set] = ACTIONS(2536),
    [anon_sym_declare] = ACTIONS(2536),
    [anon_sym_namespace] = ACTIONS(2536),
    [anon_sym_public] = ACTIONS(2536),
    [anon_sym_private] = ACTIONS(2536),
    [anon_sym_protected] = ACTIONS(2536),
    [anon_sym_override] = ACTIONS(2536),
    [anon_sym_module] = ACTIONS(2536),
    [anon_sym_any] = ACTIONS(2536),
    [anon_sym_number] = ACTIONS(2536),
    [anon_sym_boolean] = ACTIONS(2536),
    [anon_sym_string] = ACTIONS(2536),
    [anon_sym_symbol] = ACTIONS(2536),
    [anon_sym_abstract] = ACTIONS(2536),
    [anon_sym_interface] = ACTIONS(2536),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_component] = ACTIONS(2536),
    [anon_sym_instance] = ACTIONS(2536),
  },
  [671] = {
    [ts_builtin_sym_end] = ACTIONS(2538),
    [sym_identifier] = ACTIONS(2540),
    [anon_sym_export] = ACTIONS(2540),
    [anon_sym_LBRACE] = ACTIONS(2538),
    [anon_sym_RBRACE] = ACTIONS(2538),
    [anon_sym_type] = ACTIONS(2540),
    [anon_sym_typeof] = ACTIONS(2540),
    [anon_sym_import] = ACTIONS(2540),
    [anon_sym_var] = ACTIONS(2540),
    [anon_sym_let] = ACTIONS(2540),
    [anon_sym_const] = ACTIONS(2540),
    [anon_sym_BANG] = ACTIONS(2538),
    [anon_sym_else] = ACTIONS(2540),
    [anon_sym_if] = ACTIONS(2540),
    [anon_sym_switch] = ACTIONS(2540),
    [anon_sym_for] = ACTIONS(2540),
    [anon_sym_LPAREN] = ACTIONS(2538),
    [anon_sym_await] = ACTIONS(2540),
    [anon_sym_while] = ACTIONS(2540),
    [anon_sym_do] = ACTIONS(2540),
    [anon_sym_try] = ACTIONS(2540),
    [anon_sym_with] = ACTIONS(2540),
    [anon_sym_break] = ACTIONS(2540),
    [anon_sym_continue] = ACTIONS(2540),
    [anon_sym_debugger] = ACTIONS(2540),
    [anon_sym_return] = ACTIONS(2540),
    [anon_sym_throw] = ACTIONS(2540),
    [anon_sym_SEMI] = ACTIONS(2538),
    [anon_sym_case] = ACTIONS(2540),
    [anon_sym_default] = ACTIONS(2540),
    [anon_sym_yield] = ACTIONS(2540),
    [anon_sym_LBRACK] = ACTIONS(2538),
    [anon_sym_LTtemplate_GT] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(2540),
    [anon_sym_SLASH] = ACTIONS(2540),
    [anon_sym_class] = ACTIONS(2540),
    [anon_sym_async] = ACTIONS(2540),
    [anon_sym_function] = ACTIONS(2540),
    [anon_sym_new] = ACTIONS(2540),
    [anon_sym_AMP] = ACTIONS(2538),
    [anon_sym_PLUS] = ACTIONS(2540),
    [anon_sym_DASH] = ACTIONS(2540),
    [anon_sym_TILDE] = ACTIONS(2538),
    [anon_sym_void] = ACTIONS(2540),
    [anon_sym_delete] = ACTIONS(2540),
    [anon_sym_PLUS_PLUS] = ACTIONS(2538),
    [anon_sym_DASH_DASH] = ACTIONS(2538),
    [anon_sym_DQUOTE] = ACTIONS(2538),
    [anon_sym_SQUOTE] = ACTIONS(2538),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2538),
    [sym_number] = ACTIONS(2538),
    [sym_this] = ACTIONS(2540),
    [sym_super] = ACTIONS(2540),
    [sym_true] = ACTIONS(2540),
    [sym_false] = ACTIONS(2540),
    [sym_null] = ACTIONS(2540),
    [sym_undefined] = ACTIONS(2540),
    [anon_sym_AT] = ACTIONS(2538),
    [anon_sym_static] = ACTIONS(2540),
    [anon_sym_readonly] = ACTIONS(2540),
    [anon_sym_get] = ACTIONS(2540),
    [anon_sym_set] = ACTIONS(2540),
    [anon_sym_declare] = ACTIONS(2540),
    [anon_sym_namespace] = ACTIONS(2540),
    [anon_sym_public] = ACTIONS(2540),
    [anon_sym_private] = ACTIONS(2540),
    [anon_sym_protected] = ACTIONS(2540),
    [anon_sym_override] = ACTIONS(2540),
    [anon_sym_module] = ACTIONS(2540),
    [anon_sym_any] = ACTIONS(2540),
    [anon_sym_number] = ACTIONS(2540),
    [anon_sym_boolean] = ACTIONS(2540),
    [anon_sym_string] = ACTIONS(2540),
    [anon_sym_symbol] = ACTIONS(2540),
    [anon_sym_abstract] = ACTIONS(2540),
    [anon_sym_interface] = ACTIONS(2540),
    [anon_sym_enum] = ACTIONS(2540),
    [anon_sym_component] = ACTIONS(2540),
    [anon_sym_instance] = ACTIONS(2540),
  },
  [672] = {
    [sym__call_signature] = STATE(4818),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_export] = ACTIONS(2516),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_type] = ACTIONS(2516),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2516),
    [anon_sym_function] = ACTIONS(2317),
    [anon_sym_EQ_GT] = ACTIONS(1239),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2516),
    [anon_sym_readonly] = ACTIONS(2516),
    [anon_sym_get] = ACTIONS(2516),
    [anon_sym_set] = ACTIONS(2516),
    [anon_sym_declare] = ACTIONS(2516),
    [anon_sym_namespace] = ACTIONS(2516),
    [anon_sym_public] = ACTIONS(2516),
    [anon_sym_private] = ACTIONS(2516),
    [anon_sym_protected] = ACTIONS(2516),
    [anon_sym_override] = ACTIONS(2516),
    [anon_sym_module] = ACTIONS(2516),
    [anon_sym_any] = ACTIONS(2516),
    [anon_sym_number] = ACTIONS(2516),
    [anon_sym_boolean] = ACTIONS(2516),
    [anon_sym_string] = ACTIONS(2516),
    [anon_sym_symbol] = ACTIONS(2516),
    [anon_sym_satisfies] = ACTIONS(25),
    [anon_sym_implements] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [673] = {
    [sym_identifier] = ACTIONS(1726),
    [anon_sym_export] = ACTIONS(1726),
    [anon_sym_LBRACE] = ACTIONS(1730),
    [anon_sym_RBRACE] = ACTIONS(1730),
    [anon_sym_type] = ACTIONS(1726),
    [anon_sym_typeof] = ACTIONS(1726),
    [anon_sym_import] = ACTIONS(1726),
    [anon_sym_var] = ACTIONS(1726),
    [anon_sym_let] = ACTIONS(1726),
    [anon_sym_const] = ACTIONS(1726),
    [anon_sym_BANG] = ACTIONS(1730),
    [anon_sym_else] = ACTIONS(1726),
    [anon_sym_if] = ACTIONS(1726),
    [anon_sym_switch] = ACTIONS(1726),
    [anon_sym_for] = ACTIONS(1726),
    [anon_sym_LPAREN] = ACTIONS(1730),
    [anon_sym_await] = ACTIONS(1726),
    [anon_sym_while] = ACTIONS(1726),
    [anon_sym_do] = ACTIONS(1726),
    [anon_sym_try] = ACTIONS(1726),
    [anon_sym_with] = ACTIONS(1726),
    [anon_sym_break] = ACTIONS(1726),
    [anon_sym_continue] = ACTIONS(1726),
    [anon_sym_debugger] = ACTIONS(1726),
    [anon_sym_return] = ACTIONS(1726),
    [anon_sym_throw] = ACTIONS(1726),
    [anon_sym_SEMI] = ACTIONS(1730),
    [anon_sym_case] = ACTIONS(1726),
    [anon_sym_default] = ACTIONS(1726),
    [anon_sym_yield] = ACTIONS(1726),
    [anon_sym_LBRACK] = ACTIONS(1730),
    [anon_sym_LTtemplate_GT] = ACTIONS(1730),
    [anon_sym_LT] = ACTIONS(1726),
    [anon_sym_SLASH] = ACTIONS(1726),
    [anon_sym_class] = ACTIONS(1726),
    [anon_sym_async] = ACTIONS(1726),
    [anon_sym_function] = ACTIONS(1726),
    [anon_sym_new] = ACTIONS(1726),
    [anon_sym_AMP] = ACTIONS(1730),
    [anon_sym_PLUS] = ACTIONS(1726),
    [anon_sym_DASH] = ACTIONS(1726),
    [anon_sym_TILDE] = ACTIONS(1730),
    [anon_sym_void] = ACTIONS(1726),
    [anon_sym_delete] = ACTIONS(1726),
    [anon_sym_PLUS_PLUS] = ACTIONS(1730),
    [anon_sym_DASH_DASH] = ACTIONS(1730),
    [anon_sym_DQUOTE] = ACTIONS(1730),
    [anon_sym_SQUOTE] = ACTIONS(1730),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1730),
    [sym_number] = ACTIONS(1730),
    [sym_this] = ACTIONS(1726),
    [sym_super] = ACTIONS(1726),
    [sym_true] = ACTIONS(1726),
    [sym_false] = ACTIONS(1726),
    [sym_null] = ACTIONS(1726),
    [sym_undefined] = ACTIONS(1726),
    [anon_sym_AT] = ACTIONS(1730),
    [anon_sym_static] = ACTIONS(1726),
    [anon_sym_readonly] = ACTIONS(1726),
    [anon_sym_get] = ACTIONS(1726),
    [anon_sym_set] = ACTIONS(1726),
    [anon_sym_declare] = ACTIONS(1726),
    [anon_sym_namespace] = ACTIONS(1726),
    [anon_sym_public] = ACTIONS(1726),
    [anon_sym_private] = ACTIONS(1726),
    [anon_sym_protected] = ACTIONS(1726),
    [anon_sym_override] = ACTIONS(1726),
    [anon_sym_module] = ACTIONS(1726),
    [anon_sym_any] = ACTIONS(1726),
    [anon_sym_number] = ACTIONS(1726),
    [anon_sym_boolean] = ACTIONS(1726),
    [anon_sym_string] = ACTIONS(1726),
    [anon_sym_symbol] = ACTIONS(1726),
    [anon_sym_abstract] = ACTIONS(1726),
    [anon_sym_interface] = ACTIONS(1726),
    [anon_sym_enum] = ACTIONS(1726),
    [anon_sym_component] = ACTIONS(1726),
    [sym__automatic_semicolon] = ACTIONS(1734),
  },
  [674] = {
    [sym_identifier] = ACTIONS(1452),
    [anon_sym_export] = ACTIONS(1452),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [anon_sym_RBRACE] = ACTIONS(1456),
    [anon_sym_type] = ACTIONS(1452),
    [anon_sym_typeof] = ACTIONS(1452),
    [anon_sym_import] = ACTIONS(1452),
    [anon_sym_var] = ACTIONS(1452),
    [anon_sym_let] = ACTIONS(1452),
    [anon_sym_const] = ACTIONS(1452),
    [anon_sym_BANG] = ACTIONS(1456),
    [anon_sym_else] = ACTIONS(1452),
    [anon_sym_if] = ACTIONS(1452),
    [anon_sym_switch] = ACTIONS(1452),
    [anon_sym_for] = ACTIONS(1452),
    [anon_sym_LPAREN] = ACTIONS(1456),
    [anon_sym_await] = ACTIONS(1452),
    [anon_sym_while] = ACTIONS(1452),
    [anon_sym_do] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(1452),
    [anon_sym_with] = ACTIONS(1452),
    [anon_sym_break] = ACTIONS(1452),
    [anon_sym_continue] = ACTIONS(1452),
    [anon_sym_debugger] = ACTIONS(1452),
    [anon_sym_return] = ACTIONS(1452),
    [anon_sym_throw] = ACTIONS(1452),
    [anon_sym_SEMI] = ACTIONS(1456),
    [anon_sym_case] = ACTIONS(1452),
    [anon_sym_default] = ACTIONS(1452),
    [anon_sym_yield] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1456),
    [anon_sym_LTtemplate_GT] = ACTIONS(1456),
    [anon_sym_LT] = ACTIONS(1452),
    [anon_sym_SLASH] = ACTIONS(1452),
    [anon_sym_class] = ACTIONS(1452),
    [anon_sym_async] = ACTIONS(1452),
    [anon_sym_function] = ACTIONS(1452),
    [anon_sym_new] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1456),
    [anon_sym_PLUS] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1452),
    [anon_sym_TILDE] = ACTIONS(1456),
    [anon_sym_void] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1452),
    [anon_sym_PLUS_PLUS] = ACTIONS(1456),
    [anon_sym_DASH_DASH] = ACTIONS(1456),
    [anon_sym_DQUOTE] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(1456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1456),
    [sym_number] = ACTIONS(1456),
    [sym_this] = ACTIONS(1452),
    [sym_super] = ACTIONS(1452),
    [sym_true] = ACTIONS(1452),
    [sym_false] = ACTIONS(1452),
    [sym_null] = ACTIONS(1452),
    [sym_undefined] = ACTIONS(1452),
    [anon_sym_AT] = ACTIONS(1456),
    [anon_sym_static] = ACTIONS(1452),
    [anon_sym_readonly] = ACTIONS(1452),
    [anon_sym_get] = ACTIONS(1452),
    [anon_sym_set] = ACTIONS(1452),
    [anon_sym_declare] = ACTIONS(1452),
    [anon_sym_namespace] = ACTIONS(1452),
    [anon_sym_public] = ACTIONS(1452),
    [anon_sym_private] = ACTIONS(1452),
    [anon_sym_protected] = ACTIONS(1452),
    [anon_sym_override] = ACTIONS(1452),
    [anon_sym_module] = ACTIONS(1452),
    [anon_sym_any] = ACTIONS(1452),
    [anon_sym_number] = ACTIONS(1452),
    [anon_sym_boolean] = ACTIONS(1452),
    [anon_sym_string] = ACTIONS(1452),
    [anon_sym_symbol] = ACTIONS(1452),
    [anon_sym_abstract] = ACTIONS(1452),
    [anon_sym_interface] = ACTIONS(1452),
    [anon_sym_enum] = ACTIONS(1452),
    [anon_sym_component] = ACTIONS(1452),
    [sym__automatic_semicolon] = ACTIONS(1460),
  },
  [675] = {
    [sym_identifier] = ACTIONS(1636),
    [anon_sym_export] = ACTIONS(1636),
    [anon_sym_LBRACE] = ACTIONS(1638),
    [anon_sym_RBRACE] = ACTIONS(1638),
    [anon_sym_type] = ACTIONS(1636),
    [anon_sym_typeof] = ACTIONS(1636),
    [anon_sym_import] = ACTIONS(1636),
    [anon_sym_var] = ACTIONS(1636),
    [anon_sym_let] = ACTIONS(1636),
    [anon_sym_const] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_else] = ACTIONS(1636),
    [anon_sym_if] = ACTIONS(1636),
    [anon_sym_switch] = ACTIONS(1636),
    [anon_sym_for] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_await] = ACTIONS(1636),
    [anon_sym_while] = ACTIONS(1636),
    [anon_sym_do] = ACTIONS(1636),
    [anon_sym_try] = ACTIONS(1636),
    [anon_sym_with] = ACTIONS(1636),
    [anon_sym_break] = ACTIONS(1636),
    [anon_sym_continue] = ACTIONS(1636),
    [anon_sym_debugger] = ACTIONS(1636),
    [anon_sym_return] = ACTIONS(1636),
    [anon_sym_throw] = ACTIONS(1636),
    [anon_sym_SEMI] = ACTIONS(1638),
    [anon_sym_case] = ACTIONS(1636),
    [anon_sym_default] = ACTIONS(1636),
    [anon_sym_yield] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(1638),
    [anon_sym_LTtemplate_GT] = ACTIONS(1638),
    [anon_sym_LT] = ACTIONS(1636),
    [anon_sym_SLASH] = ACTIONS(1636),
    [anon_sym_class] = ACTIONS(1636),
    [anon_sym_async] = ACTIONS(1636),
    [anon_sym_function] = ACTIONS(1636),
    [anon_sym_new] = ACTIONS(1636),
    [anon_sym_AMP] = ACTIONS(1638),
    [anon_sym_PLUS] = ACTIONS(1636),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_TILDE] = ACTIONS(1638),
    [anon_sym_void] = ACTIONS(1636),
    [anon_sym_delete] = ACTIONS(1636),
    [anon_sym_PLUS_PLUS] = ACTIONS(1638),
    [anon_sym_DASH_DASH] = ACTIONS(1638),
    [anon_sym_DQUOTE] = ACTIONS(1638),
    [anon_sym_SQUOTE] = ACTIONS(1638),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1638),
    [sym_number] = ACTIONS(1638),
    [sym_this] = ACTIONS(1636),
    [sym_super] = ACTIONS(1636),
    [sym_true] = ACTIONS(1636),
    [sym_false] = ACTIONS(1636),
    [sym_null] = ACTIONS(1636),
    [sym_undefined] = ACTIONS(1636),
    [anon_sym_AT] = ACTIONS(1638),
    [anon_sym_static] = ACTIONS(1636),
    [anon_sym_readonly] = ACTIONS(1636),
    [anon_sym_get] = ACTIONS(1636),
    [anon_sym_set] = ACTIONS(1636),
    [anon_sym_declare] = ACTIONS(1636),
    [anon_sym_namespace] = ACTIONS(1636),
    [anon_sym_public] = ACTIONS(1636),
    [anon_sym_private] = ACTIONS(1636),
    [anon_sym_protected] = ACTIONS(1636),
    [anon_sym_override] = ACTIONS(1636),
    [anon_sym_module] = ACTIONS(1636),
    [anon_sym_any] = ACTIONS(1636),
    [anon_sym_number] = ACTIONS(1636),
    [anon_sym_boolean] = ACTIONS(1636),
    [anon_sym_string] = ACTIONS(1636),
    [anon_sym_symbol] = ACTIONS(1636),
    [anon_sym_abstract] = ACTIONS(1636),
    [anon_sym_interface] = ACTIONS(1636),
    [anon_sym_enum] = ACTIONS(1636),
    [anon_sym_component] = ACTIONS(1636),
    [sym__automatic_semicolon] = ACTIONS(1638),
  },
  [676] = {
    [sym_identifier] = ACTIONS(1462),
    [anon_sym_export] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(1466),
    [anon_sym_RBRACE] = ACTIONS(1466),
    [anon_sym_type] = ACTIONS(1462),
    [anon_sym_typeof] = ACTIONS(1462),
    [anon_sym_import] = ACTIONS(1462),
    [anon_sym_var] = ACTIONS(1462),
    [anon_sym_let] = ACTIONS(1462),
    [anon_sym_const] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1466),
    [anon_sym_else] = ACTIONS(1462),
    [anon_sym_if] = ACTIONS(1462),
    [anon_sym_switch] = ACTIONS(1462),
    [anon_sym_for] = ACTIONS(1462),
    [anon_sym_LPAREN] = ACTIONS(1466),
    [anon_sym_await] = ACTIONS(1462),
    [anon_sym_while] = ACTIONS(1462),
    [anon_sym_do] = ACTIONS(1462),
    [anon_sym_try] = ACTIONS(1462),
    [anon_sym_with] = ACTIONS(1462),
    [anon_sym_break] = ACTIONS(1462),
    [anon_sym_continue] = ACTIONS(1462),
    [anon_sym_debugger] = ACTIONS(1462),
    [anon_sym_return] = ACTIONS(1462),
    [anon_sym_throw] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1466),
    [anon_sym_case] = ACTIONS(1462),
    [anon_sym_default] = ACTIONS(1462),
    [anon_sym_yield] = ACTIONS(1462),
    [anon_sym_LBRACK] = ACTIONS(1466),
    [anon_sym_LTtemplate_GT] = ACTIONS(1466),
    [anon_sym_LT] = ACTIONS(1462),
    [anon_sym_SLASH] = ACTIONS(1462),
    [anon_sym_class] = ACTIONS(1462),
    [anon_sym_async] = ACTIONS(1462),
    [anon_sym_function] = ACTIONS(1462),
    [anon_sym_new] = ACTIONS(1462),
    [anon_sym_AMP] = ACTIONS(1466),
    [anon_sym_PLUS] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1466),
    [anon_sym_void] = ACTIONS(1462),
    [anon_sym_delete] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1466),
    [anon_sym_DASH_DASH] = ACTIONS(1466),
    [anon_sym_DQUOTE] = ACTIONS(1466),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1466),
    [sym_number] = ACTIONS(1466),
    [sym_this] = ACTIONS(1462),
    [sym_super] = ACTIONS(1462),
    [sym_true] = ACTIONS(1462),
    [sym_false] = ACTIONS(1462),
    [sym_null] = ACTIONS(1462),
    [sym_undefined] = ACTIONS(1462),
    [anon_sym_AT] = ACTIONS(1466),
    [anon_sym_static] = ACTIONS(1462),
    [anon_sym_readonly] = ACTIONS(1462),
    [anon_sym_get] = ACTIONS(1462),
    [anon_sym_set] = ACTIONS(1462),
    [anon_sym_declare] = ACTIONS(1462),
    [anon_sym_namespace] = ACTIONS(1462),
    [anon_sym_public] = ACTIONS(1462),
    [anon_sym_private] = ACTIONS(1462),
    [anon_sym_protected] = ACTIONS(1462),
    [anon_sym_override] = ACTIONS(1462),
    [anon_sym_module] = ACTIONS(1462),
    [anon_sym_any] = ACTIONS(1462),
    [anon_sym_number] = ACTIONS(1462),
    [anon_sym_boolean] = ACTIONS(1462),
    [anon_sym_string] = ACTIONS(1462),
    [anon_sym_symbol] = ACTIONS(1462),
    [anon_sym_abstract] = ACTIONS(1462),
    [anon_sym_interface] = ACTIONS(1462),
    [anon_sym_enum] = ACTIONS(1462),
    [anon_sym_component] = ACTIONS(1462),
    [sym__automatic_semicolon] = ACTIONS(1470),
  },
  [677] = {
    [sym__call_signature] = STATE(4721),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2313),
    [anon_sym_export] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(2315),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(2542),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_RBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2315),
    [anon_sym_function] = ACTIONS(2317),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2315),
    [anon_sym_readonly] = ACTIONS(2315),
    [anon_sym_get] = ACTIONS(2315),
    [anon_sym_set] = ACTIONS(2315),
    [anon_sym_declare] = ACTIONS(2315),
    [anon_sym_namespace] = ACTIONS(2315),
    [anon_sym_public] = ACTIONS(2315),
    [anon_sym_private] = ACTIONS(2315),
    [anon_sym_protected] = ACTIONS(2315),
    [anon_sym_override] = ACTIONS(2315),
    [anon_sym_module] = ACTIONS(2315),
    [anon_sym_any] = ACTIONS(2315),
    [anon_sym_number] = ACTIONS(2315),
    [anon_sym_boolean] = ACTIONS(2315),
    [anon_sym_string] = ACTIONS(2315),
    [anon_sym_symbol] = ACTIONS(2315),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [678] = {
    [sym_identifier] = ACTIONS(1616),
    [anon_sym_export] = ACTIONS(1616),
    [anon_sym_LBRACE] = ACTIONS(1620),
    [anon_sym_RBRACE] = ACTIONS(1620),
    [anon_sym_type] = ACTIONS(1616),
    [anon_sym_typeof] = ACTIONS(1616),
    [anon_sym_import] = ACTIONS(1616),
    [anon_sym_var] = ACTIONS(1616),
    [anon_sym_let] = ACTIONS(1616),
    [anon_sym_const] = ACTIONS(1616),
    [anon_sym_BANG] = ACTIONS(1620),
    [anon_sym_else] = ACTIONS(1616),
    [anon_sym_if] = ACTIONS(1616),
    [anon_sym_switch] = ACTIONS(1616),
    [anon_sym_for] = ACTIONS(1616),
    [anon_sym_LPAREN] = ACTIONS(1620),
    [anon_sym_await] = ACTIONS(1616),
    [anon_sym_while] = ACTIONS(1616),
    [anon_sym_do] = ACTIONS(1616),
    [anon_sym_try] = ACTIONS(1616),
    [anon_sym_with] = ACTIONS(1616),
    [anon_sym_break] = ACTIONS(1616),
    [anon_sym_continue] = ACTIONS(1616),
    [anon_sym_debugger] = ACTIONS(1616),
    [anon_sym_return] = ACTIONS(1616),
    [anon_sym_throw] = ACTIONS(1616),
    [anon_sym_SEMI] = ACTIONS(1620),
    [anon_sym_case] = ACTIONS(1616),
    [anon_sym_default] = ACTIONS(1616),
    [anon_sym_yield] = ACTIONS(1616),
    [anon_sym_LBRACK] = ACTIONS(1620),
    [anon_sym_LTtemplate_GT] = ACTIONS(1620),
    [anon_sym_LT] = ACTIONS(1616),
    [anon_sym_SLASH] = ACTIONS(1616),
    [anon_sym_class] = ACTIONS(1616),
    [anon_sym_async] = ACTIONS(1616),
    [anon_sym_function] = ACTIONS(1616),
    [anon_sym_new] = ACTIONS(1616),
    [anon_sym_AMP] = ACTIONS(1620),
    [anon_sym_PLUS] = ACTIONS(1616),
    [anon_sym_DASH] = ACTIONS(1616),
    [anon_sym_TILDE] = ACTIONS(1620),
    [anon_sym_void] = ACTIONS(1616),
    [anon_sym_delete] = ACTIONS(1616),
    [anon_sym_PLUS_PLUS] = ACTIONS(1620),
    [anon_sym_DASH_DASH] = ACTIONS(1620),
    [anon_sym_DQUOTE] = ACTIONS(1620),
    [anon_sym_SQUOTE] = ACTIONS(1620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1620),
    [sym_number] = ACTIONS(1620),
    [sym_this] = ACTIONS(1616),
    [sym_super] = ACTIONS(1616),
    [sym_true] = ACTIONS(1616),
    [sym_false] = ACTIONS(1616),
    [sym_null] = ACTIONS(1616),
    [sym_undefined] = ACTIONS(1616),
    [anon_sym_AT] = ACTIONS(1620),
    [anon_sym_static] = ACTIONS(1616),
    [anon_sym_readonly] = ACTIONS(1616),
    [anon_sym_get] = ACTIONS(1616),
    [anon_sym_set] = ACTIONS(1616),
    [anon_sym_declare] = ACTIONS(1616),
    [anon_sym_namespace] = ACTIONS(1616),
    [anon_sym_public] = ACTIONS(1616),
    [anon_sym_private] = ACTIONS(1616),
    [anon_sym_protected] = ACTIONS(1616),
    [anon_sym_override] = ACTIONS(1616),
    [anon_sym_module] = ACTIONS(1616),
    [anon_sym_any] = ACTIONS(1616),
    [anon_sym_number] = ACTIONS(1616),
    [anon_sym_boolean] = ACTIONS(1616),
    [anon_sym_string] = ACTIONS(1616),
    [anon_sym_symbol] = ACTIONS(1616),
    [anon_sym_abstract] = ACTIONS(1616),
    [anon_sym_interface] = ACTIONS(1616),
    [anon_sym_enum] = ACTIONS(1616),
    [anon_sym_component] = ACTIONS(1616),
    [sym__automatic_semicolon] = ACTIONS(1624),
  },
  [679] = {
    [sym_identifier] = ACTIONS(1504),
    [anon_sym_export] = ACTIONS(1504),
    [anon_sym_LBRACE] = ACTIONS(1508),
    [anon_sym_RBRACE] = ACTIONS(1508),
    [anon_sym_type] = ACTIONS(1504),
    [anon_sym_typeof] = ACTIONS(1504),
    [anon_sym_import] = ACTIONS(1504),
    [anon_sym_var] = ACTIONS(1504),
    [anon_sym_let] = ACTIONS(1504),
    [anon_sym_const] = ACTIONS(1504),
    [anon_sym_BANG] = ACTIONS(1508),
    [anon_sym_else] = ACTIONS(1504),
    [anon_sym_if] = ACTIONS(1504),
    [anon_sym_switch] = ACTIONS(1504),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_LPAREN] = ACTIONS(1508),
    [anon_sym_await] = ACTIONS(1504),
    [anon_sym_while] = ACTIONS(1504),
    [anon_sym_do] = ACTIONS(1504),
    [anon_sym_try] = ACTIONS(1504),
    [anon_sym_with] = ACTIONS(1504),
    [anon_sym_break] = ACTIONS(1504),
    [anon_sym_continue] = ACTIONS(1504),
    [anon_sym_debugger] = ACTIONS(1504),
    [anon_sym_return] = ACTIONS(1504),
    [anon_sym_throw] = ACTIONS(1504),
    [anon_sym_SEMI] = ACTIONS(1508),
    [anon_sym_case] = ACTIONS(1504),
    [anon_sym_default] = ACTIONS(1504),
    [anon_sym_yield] = ACTIONS(1504),
    [anon_sym_LBRACK] = ACTIONS(1508),
    [anon_sym_LTtemplate_GT] = ACTIONS(1508),
    [anon_sym_LT] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(1504),
    [anon_sym_class] = ACTIONS(1504),
    [anon_sym_async] = ACTIONS(1504),
    [anon_sym_function] = ACTIONS(1504),
    [anon_sym_new] = ACTIONS(1504),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1504),
    [anon_sym_DASH] = ACTIONS(1504),
    [anon_sym_TILDE] = ACTIONS(1508),
    [anon_sym_void] = ACTIONS(1504),
    [anon_sym_delete] = ACTIONS(1504),
    [anon_sym_PLUS_PLUS] = ACTIONS(1508),
    [anon_sym_DASH_DASH] = ACTIONS(1508),
    [anon_sym_DQUOTE] = ACTIONS(1508),
    [anon_sym_SQUOTE] = ACTIONS(1508),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [sym_number] = ACTIONS(1508),
    [sym_this] = ACTIONS(1504),
    [sym_super] = ACTIONS(1504),
    [sym_true] = ACTIONS(1504),
    [sym_false] = ACTIONS(1504),
    [sym_null] = ACTIONS(1504),
    [sym_undefined] = ACTIONS(1504),
    [anon_sym_AT] = ACTIONS(1508),
    [anon_sym_static] = ACTIONS(1504),
    [anon_sym_readonly] = ACTIONS(1504),
    [anon_sym_get] = ACTIONS(1504),
    [anon_sym_set] = ACTIONS(1504),
    [anon_sym_declare] = ACTIONS(1504),
    [anon_sym_namespace] = ACTIONS(1504),
    [anon_sym_public] = ACTIONS(1504),
    [anon_sym_private] = ACTIONS(1504),
    [anon_sym_protected] = ACTIONS(1504),
    [anon_sym_override] = ACTIONS(1504),
    [anon_sym_module] = ACTIONS(1504),
    [anon_sym_any] = ACTIONS(1504),
    [anon_sym_number] = ACTIONS(1504),
    [anon_sym_boolean] = ACTIONS(1504),
    [anon_sym_string] = ACTIONS(1504),
    [anon_sym_symbol] = ACTIONS(1504),
    [anon_sym_abstract] = ACTIONS(1504),
    [anon_sym_interface] = ACTIONS(1504),
    [anon_sym_enum] = ACTIONS(1504),
    [anon_sym_component] = ACTIONS(1504),
    [sym__automatic_semicolon] = ACTIONS(1512),
  },
  [680] = {
    [sym_identifier] = ACTIONS(1472),
    [anon_sym_export] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(1476),
    [anon_sym_RBRACE] = ACTIONS(1476),
    [anon_sym_type] = ACTIONS(1472),
    [anon_sym_typeof] = ACTIONS(1472),
    [anon_sym_import] = ACTIONS(1472),
    [anon_sym_var] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1472),
    [anon_sym_BANG] = ACTIONS(1476),
    [anon_sym_else] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_switch] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_do] = ACTIONS(1472),
    [anon_sym_try] = ACTIONS(1472),
    [anon_sym_with] = ACTIONS(1472),
    [anon_sym_break] = ACTIONS(1472),
    [anon_sym_continue] = ACTIONS(1472),
    [anon_sym_debugger] = ACTIONS(1472),
    [anon_sym_return] = ACTIONS(1472),
    [anon_sym_throw] = ACTIONS(1472),
    [anon_sym_SEMI] = ACTIONS(1476),
    [anon_sym_case] = ACTIONS(1472),
    [anon_sym_default] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1472),
    [anon_sym_LBRACK] = ACTIONS(1476),
    [anon_sym_LTtemplate_GT] = ACTIONS(1476),
    [anon_sym_LT] = ACTIONS(1472),
    [anon_sym_SLASH] = ACTIONS(1472),
    [anon_sym_class] = ACTIONS(1472),
    [anon_sym_async] = ACTIONS(1472),
    [anon_sym_function] = ACTIONS(1472),
    [anon_sym_new] = ACTIONS(1472),
    [anon_sym_AMP] = ACTIONS(1476),
    [anon_sym_PLUS] = ACTIONS(1472),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_TILDE] = ACTIONS(1476),
    [anon_sym_void] = ACTIONS(1472),
    [anon_sym_delete] = ACTIONS(1472),
    [anon_sym_PLUS_PLUS] = ACTIONS(1476),
    [anon_sym_DASH_DASH] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [sym_number] = ACTIONS(1476),
    [sym_this] = ACTIONS(1472),
    [sym_super] = ACTIONS(1472),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [sym_null] = ACTIONS(1472),
    [sym_undefined] = ACTIONS(1472),
    [anon_sym_AT] = ACTIONS(1476),
    [anon_sym_static] = ACTIONS(1472),
    [anon_sym_readonly] = ACTIONS(1472),
    [anon_sym_get] = ACTIONS(1472),
    [anon_sym_set] = ACTIONS(1472),
    [anon_sym_declare] = ACTIONS(1472),
    [anon_sym_namespace] = ACTIONS(1472),
    [anon_sym_public] = ACTIONS(1472),
    [anon_sym_private] = ACTIONS(1472),
    [anon_sym_protected] = ACTIONS(1472),
    [anon_sym_override] = ACTIONS(1472),
    [anon_sym_module] = ACTIONS(1472),
    [anon_sym_any] = ACTIONS(1472),
    [anon_sym_number] = ACTIONS(1472),
    [anon_sym_boolean] = ACTIONS(1472),
    [anon_sym_string] = ACTIONS(1472),
    [anon_sym_symbol] = ACTIONS(1472),
    [anon_sym_abstract] = ACTIONS(1472),
    [anon_sym_interface] = ACTIONS(1472),
    [anon_sym_enum] = ACTIONS(1472),
    [anon_sym_component] = ACTIONS(1472),
    [sym__automatic_semicolon] = ACTIONS(1480),
  },
  [681] = {
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_var] = ACTIONS(2544),
    [anon_sym_let] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_RPAREN] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_with] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_debugger] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2546),
    [anon_sym_LTtemplate_GT] = ACTIONS(2546),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_async] = ACTIONS(2544),
    [anon_sym_function] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_AMP] = ACTIONS(2546),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_void] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2546),
    [sym_number] = ACTIONS(2546),
    [sym_this] = ACTIONS(2544),
    [sym_super] = ACTIONS(2544),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [sym_null] = ACTIONS(2544),
    [sym_undefined] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_readonly] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2544),
    [anon_sym_set] = ACTIONS(2544),
    [anon_sym_declare] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_public] = ACTIONS(2544),
    [anon_sym_private] = ACTIONS(2544),
    [anon_sym_protected] = ACTIONS(2544),
    [anon_sym_override] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_any] = ACTIONS(2544),
    [anon_sym_number] = ACTIONS(2544),
    [anon_sym_boolean] = ACTIONS(2544),
    [anon_sym_string] = ACTIONS(2544),
    [anon_sym_symbol] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2544),
    [anon_sym_interface] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_component] = ACTIONS(2544),
  },
  [682] = {
    [sym_identifier] = ACTIONS(1626),
    [anon_sym_export] = ACTIONS(1626),
    [anon_sym_LBRACE] = ACTIONS(1630),
    [anon_sym_RBRACE] = ACTIONS(1630),
    [anon_sym_type] = ACTIONS(1626),
    [anon_sym_typeof] = ACTIONS(1626),
    [anon_sym_import] = ACTIONS(1626),
    [anon_sym_var] = ACTIONS(1626),
    [anon_sym_let] = ACTIONS(1626),
    [anon_sym_const] = ACTIONS(1626),
    [anon_sym_BANG] = ACTIONS(1630),
    [anon_sym_else] = ACTIONS(1626),
    [anon_sym_if] = ACTIONS(1626),
    [anon_sym_switch] = ACTIONS(1626),
    [anon_sym_for] = ACTIONS(1626),
    [anon_sym_LPAREN] = ACTIONS(1630),
    [anon_sym_await] = ACTIONS(1626),
    [anon_sym_while] = ACTIONS(1626),
    [anon_sym_do] = ACTIONS(1626),
    [anon_sym_try] = ACTIONS(1626),
    [anon_sym_with] = ACTIONS(1626),
    [anon_sym_break] = ACTIONS(1626),
    [anon_sym_continue] = ACTIONS(1626),
    [anon_sym_debugger] = ACTIONS(1626),
    [anon_sym_return] = ACTIONS(1626),
    [anon_sym_throw] = ACTIONS(1626),
    [anon_sym_SEMI] = ACTIONS(1630),
    [anon_sym_case] = ACTIONS(1626),
    [anon_sym_default] = ACTIONS(1626),
    [anon_sym_yield] = ACTIONS(1626),
    [anon_sym_LBRACK] = ACTIONS(1630),
    [anon_sym_LTtemplate_GT] = ACTIONS(1630),
    [anon_sym_LT] = ACTIONS(1626),
    [anon_sym_SLASH] = ACTIONS(1626),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1626),
    [anon_sym_function] = ACTIONS(1626),
    [anon_sym_new] = ACTIONS(1626),
    [anon_sym_AMP] = ACTIONS(1630),
    [anon_sym_PLUS] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1626),
    [anon_sym_TILDE] = ACTIONS(1630),
    [anon_sym_void] = ACTIONS(1626),
    [anon_sym_delete] = ACTIONS(1626),
    [anon_sym_PLUS_PLUS] = ACTIONS(1630),
    [anon_sym_DASH_DASH] = ACTIONS(1630),
    [anon_sym_DQUOTE] = ACTIONS(1630),
    [anon_sym_SQUOTE] = ACTIONS(1630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1630),
    [sym_number] = ACTIONS(1630),
    [sym_this] = ACTIONS(1626),
    [sym_super] = ACTIONS(1626),
    [sym_true] = ACTIONS(1626),
    [sym_false] = ACTIONS(1626),
    [sym_null] = ACTIONS(1626),
    [sym_undefined] = ACTIONS(1626),
    [anon_sym_AT] = ACTIONS(1630),
    [anon_sym_static] = ACTIONS(1626),
    [anon_sym_readonly] = ACTIONS(1626),
    [anon_sym_get] = ACTIONS(1626),
    [anon_sym_set] = ACTIONS(1626),
    [anon_sym_declare] = ACTIONS(1626),
    [anon_sym_namespace] = ACTIONS(1626),
    [anon_sym_public] = ACTIONS(1626),
    [anon_sym_private] = ACTIONS(1626),
    [anon_sym_protected] = ACTIONS(1626),
    [anon_sym_override] = ACTIONS(1626),
    [anon_sym_module] = ACTIONS(1626),
    [anon_sym_any] = ACTIONS(1626),
    [anon_sym_number] = ACTIONS(1626),
    [anon_sym_boolean] = ACTIONS(1626),
    [anon_sym_string] = ACTIONS(1626),
    [anon_sym_symbol] = ACTIONS(1626),
    [anon_sym_abstract] = ACTIONS(1626),
    [anon_sym_interface] = ACTIONS(1626),
    [anon_sym_enum] = ACTIONS(1626),
    [anon_sym_component] = ACTIONS(1626),
    [sym__automatic_semicolon] = ACTIONS(1634),
  },
  [683] = {
    [sym__call_signature] = STATE(4721),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2313),
    [anon_sym_export] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(2315),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_COLON] = ACTIONS(2484),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_RBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2315),
    [anon_sym_function] = ACTIONS(2317),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2315),
    [anon_sym_readonly] = ACTIONS(2315),
    [anon_sym_get] = ACTIONS(2315),
    [anon_sym_set] = ACTIONS(2315),
    [anon_sym_declare] = ACTIONS(2315),
    [anon_sym_namespace] = ACTIONS(2315),
    [anon_sym_public] = ACTIONS(2315),
    [anon_sym_private] = ACTIONS(2315),
    [anon_sym_protected] = ACTIONS(2315),
    [anon_sym_override] = ACTIONS(2315),
    [anon_sym_module] = ACTIONS(2315),
    [anon_sym_any] = ACTIONS(2315),
    [anon_sym_number] = ACTIONS(2315),
    [anon_sym_boolean] = ACTIONS(2315),
    [anon_sym_string] = ACTIONS(2315),
    [anon_sym_symbol] = ACTIONS(2315),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [684] = {
    [sym__call_signature] = STATE(4721),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2313),
    [anon_sym_export] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(122),
    [anon_sym_type] = ACTIONS(2315),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_RBRACK] = ACTIONS(122),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2315),
    [anon_sym_function] = ACTIONS(2317),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2315),
    [anon_sym_readonly] = ACTIONS(2315),
    [anon_sym_get] = ACTIONS(2315),
    [anon_sym_set] = ACTIONS(2315),
    [anon_sym_declare] = ACTIONS(2315),
    [anon_sym_namespace] = ACTIONS(2315),
    [anon_sym_public] = ACTIONS(2315),
    [anon_sym_private] = ACTIONS(2315),
    [anon_sym_protected] = ACTIONS(2315),
    [anon_sym_override] = ACTIONS(2315),
    [anon_sym_module] = ACTIONS(2315),
    [anon_sym_any] = ACTIONS(2315),
    [anon_sym_number] = ACTIONS(2315),
    [anon_sym_boolean] = ACTIONS(2315),
    [anon_sym_string] = ACTIONS(2315),
    [anon_sym_symbol] = ACTIONS(2315),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [685] = {
    [sym_identifier] = ACTIONS(2548),
    [anon_sym_export] = ACTIONS(2548),
    [anon_sym_LBRACE] = ACTIONS(2550),
    [anon_sym_RBRACE] = ACTIONS(2550),
    [anon_sym_type] = ACTIONS(2548),
    [anon_sym_typeof] = ACTIONS(2548),
    [anon_sym_import] = ACTIONS(2548),
    [anon_sym_var] = ACTIONS(2548),
    [anon_sym_let] = ACTIONS(2548),
    [anon_sym_const] = ACTIONS(2548),
    [anon_sym_BANG] = ACTIONS(2550),
    [anon_sym_else] = ACTIONS(2548),
    [anon_sym_if] = ACTIONS(2548),
    [anon_sym_switch] = ACTIONS(2548),
    [anon_sym_for] = ACTIONS(2548),
    [anon_sym_LPAREN] = ACTIONS(2550),
    [anon_sym_RPAREN] = ACTIONS(2550),
    [anon_sym_await] = ACTIONS(2548),
    [anon_sym_while] = ACTIONS(2548),
    [anon_sym_do] = ACTIONS(2548),
    [anon_sym_try] = ACTIONS(2548),
    [anon_sym_with] = ACTIONS(2548),
    [anon_sym_break] = ACTIONS(2548),
    [anon_sym_continue] = ACTIONS(2548),
    [anon_sym_debugger] = ACTIONS(2548),
    [anon_sym_return] = ACTIONS(2548),
    [anon_sym_throw] = ACTIONS(2548),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym_case] = ACTIONS(2548),
    [anon_sym_default] = ACTIONS(2548),
    [anon_sym_yield] = ACTIONS(2548),
    [anon_sym_LBRACK] = ACTIONS(2550),
    [anon_sym_LTtemplate_GT] = ACTIONS(2550),
    [anon_sym_LT] = ACTIONS(2548),
    [anon_sym_SLASH] = ACTIONS(2548),
    [anon_sym_class] = ACTIONS(2548),
    [anon_sym_async] = ACTIONS(2548),
    [anon_sym_function] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2548),
    [anon_sym_AMP] = ACTIONS(2550),
    [anon_sym_PLUS] = ACTIONS(2548),
    [anon_sym_DASH] = ACTIONS(2548),
    [anon_sym_TILDE] = ACTIONS(2550),
    [anon_sym_void] = ACTIONS(2548),
    [anon_sym_delete] = ACTIONS(2548),
    [anon_sym_PLUS_PLUS] = ACTIONS(2550),
    [anon_sym_DASH_DASH] = ACTIONS(2550),
    [anon_sym_DQUOTE] = ACTIONS(2550),
    [anon_sym_SQUOTE] = ACTIONS(2550),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2550),
    [sym_number] = ACTIONS(2550),
    [sym_this] = ACTIONS(2548),
    [sym_super] = ACTIONS(2548),
    [sym_true] = ACTIONS(2548),
    [sym_false] = ACTIONS(2548),
    [sym_null] = ACTIONS(2548),
    [sym_undefined] = ACTIONS(2548),
    [anon_sym_AT] = ACTIONS(2550),
    [anon_sym_static] = ACTIONS(2548),
    [anon_sym_readonly] = ACTIONS(2548),
    [anon_sym_get] = ACTIONS(2548),
    [anon_sym_set] = ACTIONS(2548),
    [anon_sym_declare] = ACTIONS(2548),
    [anon_sym_namespace] = ACTIONS(2548),
    [anon_sym_public] = ACTIONS(2548),
    [anon_sym_private] = ACTIONS(2548),
    [anon_sym_protected] = ACTIONS(2548),
    [anon_sym_override] = ACTIONS(2548),
    [anon_sym_module] = ACTIONS(2548),
    [anon_sym_any] = ACTIONS(2548),
    [anon_sym_number] = ACTIONS(2548),
    [anon_sym_boolean] = ACTIONS(2548),
    [anon_sym_string] = ACTIONS(2548),
    [anon_sym_symbol] = ACTIONS(2548),
    [anon_sym_abstract] = ACTIONS(2548),
    [anon_sym_interface] = ACTIONS(2548),
    [anon_sym_enum] = ACTIONS(2548),
    [anon_sym_component] = ACTIONS(2548),
  },
  [686] = {
    [sym_identifier] = ACTIONS(1530),
    [anon_sym_export] = ACTIONS(1530),
    [anon_sym_LBRACE] = ACTIONS(1534),
    [anon_sym_RBRACE] = ACTIONS(1534),
    [anon_sym_type] = ACTIONS(1530),
    [anon_sym_typeof] = ACTIONS(1530),
    [anon_sym_import] = ACTIONS(1530),
    [anon_sym_var] = ACTIONS(1530),
    [anon_sym_let] = ACTIONS(1530),
    [anon_sym_const] = ACTIONS(1530),
    [anon_sym_BANG] = ACTIONS(1534),
    [anon_sym_else] = ACTIONS(1530),
    [anon_sym_if] = ACTIONS(1530),
    [anon_sym_switch] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1530),
    [anon_sym_LPAREN] = ACTIONS(1534),
    [anon_sym_await] = ACTIONS(1530),
    [anon_sym_while] = ACTIONS(1530),
    [anon_sym_do] = ACTIONS(1530),
    [anon_sym_try] = ACTIONS(1530),
    [anon_sym_with] = ACTIONS(1530),
    [anon_sym_break] = ACTIONS(1530),
    [anon_sym_continue] = ACTIONS(1530),
    [anon_sym_debugger] = ACTIONS(1530),
    [anon_sym_return] = ACTIONS(1530),
    [anon_sym_throw] = ACTIONS(1530),
    [anon_sym_SEMI] = ACTIONS(1534),
    [anon_sym_case] = ACTIONS(1530),
    [anon_sym_default] = ACTIONS(1530),
    [anon_sym_yield] = ACTIONS(1530),
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_LTtemplate_GT] = ACTIONS(1534),
    [anon_sym_LT] = ACTIONS(1530),
    [anon_sym_SLASH] = ACTIONS(1530),
    [anon_sym_class] = ACTIONS(1530),
    [anon_sym_async] = ACTIONS(1530),
    [anon_sym_function] = ACTIONS(1530),
    [anon_sym_new] = ACTIONS(1530),
    [anon_sym_AMP] = ACTIONS(1534),
    [anon_sym_PLUS] = ACTIONS(1530),
    [anon_sym_DASH] = ACTIONS(1530),
    [anon_sym_TILDE] = ACTIONS(1534),
    [anon_sym_void] = ACTIONS(1530),
    [anon_sym_delete] = ACTIONS(1530),
    [anon_sym_PLUS_PLUS] = ACTIONS(1534),
    [anon_sym_DASH_DASH] = ACTIONS(1534),
    [anon_sym_DQUOTE] = ACTIONS(1534),
    [anon_sym_SQUOTE] = ACTIONS(1534),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1534),
    [sym_number] = ACTIONS(1534),
    [sym_this] = ACTIONS(1530),
    [sym_super] = ACTIONS(1530),
    [sym_true] = ACTIONS(1530),
    [sym_false] = ACTIONS(1530),
    [sym_null] = ACTIONS(1530),
    [sym_undefined] = ACTIONS(1530),
    [anon_sym_AT] = ACTIONS(1534),
    [anon_sym_static] = ACTIONS(1530),
    [anon_sym_readonly] = ACTIONS(1530),
    [anon_sym_get] = ACTIONS(1530),
    [anon_sym_set] = ACTIONS(1530),
    [anon_sym_declare] = ACTIONS(1530),
    [anon_sym_namespace] = ACTIONS(1530),
    [anon_sym_public] = ACTIONS(1530),
    [anon_sym_private] = ACTIONS(1530),
    [anon_sym_protected] = ACTIONS(1530),
    [anon_sym_override] = ACTIONS(1530),
    [anon_sym_module] = ACTIONS(1530),
    [anon_sym_any] = ACTIONS(1530),
    [anon_sym_number] = ACTIONS(1530),
    [anon_sym_boolean] = ACTIONS(1530),
    [anon_sym_string] = ACTIONS(1530),
    [anon_sym_symbol] = ACTIONS(1530),
    [anon_sym_abstract] = ACTIONS(1530),
    [anon_sym_interface] = ACTIONS(1530),
    [anon_sym_enum] = ACTIONS(1530),
    [anon_sym_component] = ACTIONS(1530),
    [sym__automatic_semicolon] = ACTIONS(1538),
  },
  [687] = {
    [sym_optional_chain] = STATE(3632),
    [sym_arguments] = STATE(1011),
    [sym_type_arguments] = STATE(974),
    [sym_identifier] = ACTIONS(2552),
    [anon_sym_STAR] = ACTIONS(2552),
    [anon_sym_as] = ACTIONS(2552),
    [anon_sym_LBRACE] = ACTIONS(2552),
    [anon_sym_RBRACE] = ACTIONS(2554),
    [anon_sym_typeof] = ACTIONS(2552),
    [anon_sym_BANG] = ACTIONS(2552),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2552),
    [anon_sym_SEMI] = ACTIONS(2554),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2560),
    [anon_sym_GT] = ACTIONS(2552),
    [anon_sym_SLASH] = ACTIONS(2552),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2552),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2552),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_GT_GT] = ACTIONS(2552),
    [anon_sym_GT_GT_GT] = ACTIONS(2554),
    [anon_sym_LT_LT] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2552),
    [anon_sym_CARET] = ACTIONS(2554),
    [anon_sym_PIPE] = ACTIONS(2552),
    [anon_sym_PLUS] = ACTIONS(2552),
    [anon_sym_DASH] = ACTIONS(2552),
    [anon_sym_PERCENT] = ACTIONS(2554),
    [anon_sym_STAR_STAR] = ACTIONS(2554),
    [anon_sym_LT_EQ] = ACTIONS(2554),
    [anon_sym_EQ_EQ] = ACTIONS(2552),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2554),
    [anon_sym_BANG_EQ] = ACTIONS(2552),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2554),
    [anon_sym_GT_EQ] = ACTIONS(2554),
    [anon_sym_QMARK_QMARK] = ACTIONS(2554),
    [anon_sym_instanceof] = ACTIONS(2552),
    [anon_sym_void] = ACTIONS(2552),
    [anon_sym_PLUS_PLUS] = ACTIONS(2554),
    [anon_sym_DASH_DASH] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [anon_sym_SQUOTE] = ACTIONS(2554),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2554),
    [sym_number] = ACTIONS(2554),
    [sym_this] = ACTIONS(2552),
    [sym_true] = ACTIONS(2552),
    [sym_false] = ACTIONS(2552),
    [sym_null] = ACTIONS(2552),
    [sym_undefined] = ACTIONS(2552),
    [anon_sym_static] = ACTIONS(2552),
    [anon_sym_readonly] = ACTIONS(2552),
    [anon_sym_get] = ACTIONS(2552),
    [anon_sym_set] = ACTIONS(2552),
    [anon_sym_QMARK] = ACTIONS(2552),
    [anon_sym_any] = ACTIONS(2552),
    [anon_sym_number] = ACTIONS(2552),
    [anon_sym_boolean] = ACTIONS(2552),
    [anon_sym_string] = ACTIONS(2552),
    [anon_sym_symbol] = ACTIONS(2552),
    [anon_sym_abstract] = ACTIONS(2552),
    [anon_sym_satisfies] = ACTIONS(2552),
    [anon_sym_infer] = ACTIONS(2552),
    [anon_sym_keyof] = ACTIONS(2552),
    [anon_sym_unknown] = ACTIONS(2552),
    [anon_sym_never] = ACTIONS(2552),
    [anon_sym_object] = ACTIONS(2552),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2554),
    [anon_sym_constructor] = ACTIONS(2552),
    [anon_sym_prop] = ACTIONS(2552),
    [anon_sym_id] = ACTIONS(2552),
    [anon_sym_event] = ACTIONS(2552),
    [anon_sym_fn] = ACTIONS(2552),
    [anon_sym_on] = ACTIONS(2552),
    [sym__ternary_qmark] = ACTIONS(2554),
  },
  [688] = {
    [sym_identifier] = ACTIONS(1678),
    [anon_sym_export] = ACTIONS(1678),
    [anon_sym_LBRACE] = ACTIONS(1680),
    [anon_sym_RBRACE] = ACTIONS(1680),
    [anon_sym_type] = ACTIONS(1678),
    [anon_sym_typeof] = ACTIONS(1678),
    [anon_sym_import] = ACTIONS(1678),
    [anon_sym_var] = ACTIONS(1678),
    [anon_sym_let] = ACTIONS(1678),
    [anon_sym_const] = ACTIONS(1678),
    [anon_sym_BANG] = ACTIONS(1680),
    [anon_sym_else] = ACTIONS(1678),
    [anon_sym_if] = ACTIONS(1678),
    [anon_sym_switch] = ACTIONS(1678),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [anon_sym_await] = ACTIONS(1678),
    [anon_sym_while] = ACTIONS(1678),
    [anon_sym_do] = ACTIONS(1678),
    [anon_sym_try] = ACTIONS(1678),
    [anon_sym_with] = ACTIONS(1678),
    [anon_sym_break] = ACTIONS(1678),
    [anon_sym_continue] = ACTIONS(1678),
    [anon_sym_debugger] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1678),
    [anon_sym_throw] = ACTIONS(1678),
    [anon_sym_SEMI] = ACTIONS(1680),
    [anon_sym_case] = ACTIONS(1678),
    [anon_sym_default] = ACTIONS(1678),
    [anon_sym_yield] = ACTIONS(1678),
    [anon_sym_LBRACK] = ACTIONS(1680),
    [anon_sym_LTtemplate_GT] = ACTIONS(1680),
    [anon_sym_LT] = ACTIONS(1678),
    [anon_sym_SLASH] = ACTIONS(1678),
    [anon_sym_class] = ACTIONS(1678),
    [anon_sym_async] = ACTIONS(1678),
    [anon_sym_function] = ACTIONS(1678),
    [anon_sym_new] = ACTIONS(1678),
    [anon_sym_AMP] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(1678),
    [anon_sym_DASH] = ACTIONS(1678),
    [anon_sym_TILDE] = ACTIONS(1680),
    [anon_sym_void] = ACTIONS(1678),
    [anon_sym_delete] = ACTIONS(1678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1680),
    [anon_sym_DASH_DASH] = ACTIONS(1680),
    [anon_sym_DQUOTE] = ACTIONS(1680),
    [anon_sym_SQUOTE] = ACTIONS(1680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1680),
    [sym_number] = ACTIONS(1680),
    [sym_this] = ACTIONS(1678),
    [sym_super] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_null] = ACTIONS(1678),
    [sym_undefined] = ACTIONS(1678),
    [anon_sym_AT] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1678),
    [anon_sym_readonly] = ACTIONS(1678),
    [anon_sym_get] = ACTIONS(1678),
    [anon_sym_set] = ACTIONS(1678),
    [anon_sym_declare] = ACTIONS(1678),
    [anon_sym_namespace] = ACTIONS(1678),
    [anon_sym_public] = ACTIONS(1678),
    [anon_sym_private] = ACTIONS(1678),
    [anon_sym_protected] = ACTIONS(1678),
    [anon_sym_override] = ACTIONS(1678),
    [anon_sym_module] = ACTIONS(1678),
    [anon_sym_any] = ACTIONS(1678),
    [anon_sym_number] = ACTIONS(1678),
    [anon_sym_boolean] = ACTIONS(1678),
    [anon_sym_string] = ACTIONS(1678),
    [anon_sym_symbol] = ACTIONS(1678),
    [anon_sym_abstract] = ACTIONS(1678),
    [anon_sym_interface] = ACTIONS(1678),
    [anon_sym_enum] = ACTIONS(1678),
    [anon_sym_component] = ACTIONS(1678),
    [sym__automatic_semicolon] = ACTIONS(1680),
  },
  [689] = {
    [sym_identifier] = ACTIONS(2566),
    [anon_sym_export] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2568),
    [anon_sym_RBRACE] = ACTIONS(2568),
    [anon_sym_type] = ACTIONS(2566),
    [anon_sym_typeof] = ACTIONS(2566),
    [anon_sym_import] = ACTIONS(2566),
    [anon_sym_var] = ACTIONS(2566),
    [anon_sym_let] = ACTIONS(2566),
    [anon_sym_const] = ACTIONS(2566),
    [anon_sym_BANG] = ACTIONS(2568),
    [anon_sym_else] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2566),
    [anon_sym_switch] = ACTIONS(2566),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2568),
    [anon_sym_await] = ACTIONS(2566),
    [anon_sym_while] = ACTIONS(2566),
    [anon_sym_do] = ACTIONS(2566),
    [anon_sym_try] = ACTIONS(2566),
    [anon_sym_with] = ACTIONS(2566),
    [anon_sym_break] = ACTIONS(2566),
    [anon_sym_continue] = ACTIONS(2566),
    [anon_sym_debugger] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_throw] = ACTIONS(2566),
    [anon_sym_SEMI] = ACTIONS(2568),
    [anon_sym_case] = ACTIONS(2566),
    [anon_sym_default] = ACTIONS(2566),
    [anon_sym_finally] = ACTIONS(2566),
    [anon_sym_yield] = ACTIONS(2566),
    [anon_sym_LBRACK] = ACTIONS(2568),
    [anon_sym_LTtemplate_GT] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_SLASH] = ACTIONS(2566),
    [anon_sym_class] = ACTIONS(2566),
    [anon_sym_async] = ACTIONS(2566),
    [anon_sym_function] = ACTIONS(2566),
    [anon_sym_new] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2566),
    [anon_sym_DASH] = ACTIONS(2566),
    [anon_sym_TILDE] = ACTIONS(2568),
    [anon_sym_void] = ACTIONS(2566),
    [anon_sym_delete] = ACTIONS(2566),
    [anon_sym_PLUS_PLUS] = ACTIONS(2568),
    [anon_sym_DASH_DASH] = ACTIONS(2568),
    [anon_sym_DQUOTE] = ACTIONS(2568),
    [anon_sym_SQUOTE] = ACTIONS(2568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2568),
    [sym_number] = ACTIONS(2568),
    [sym_this] = ACTIONS(2566),
    [sym_super] = ACTIONS(2566),
    [sym_true] = ACTIONS(2566),
    [sym_false] = ACTIONS(2566),
    [sym_null] = ACTIONS(2566),
    [sym_undefined] = ACTIONS(2566),
    [anon_sym_AT] = ACTIONS(2568),
    [anon_sym_static] = ACTIONS(2566),
    [anon_sym_readonly] = ACTIONS(2566),
    [anon_sym_get] = ACTIONS(2566),
    [anon_sym_set] = ACTIONS(2566),
    [anon_sym_declare] = ACTIONS(2566),
    [anon_sym_namespace] = ACTIONS(2566),
    [anon_sym_public] = ACTIONS(2566),
    [anon_sym_private] = ACTIONS(2566),
    [anon_sym_protected] = ACTIONS(2566),
    [anon_sym_override] = ACTIONS(2566),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_any] = ACTIONS(2566),
    [anon_sym_number] = ACTIONS(2566),
    [anon_sym_boolean] = ACTIONS(2566),
    [anon_sym_string] = ACTIONS(2566),
    [anon_sym_symbol] = ACTIONS(2566),
    [anon_sym_abstract] = ACTIONS(2566),
    [anon_sym_interface] = ACTIONS(2566),
    [anon_sym_enum] = ACTIONS(2566),
    [anon_sym_component] = ACTIONS(2566),
  },
  [690] = {
    [sym_identifier] = ACTIONS(1640),
    [anon_sym_export] = ACTIONS(1640),
    [anon_sym_LBRACE] = ACTIONS(1642),
    [anon_sym_RBRACE] = ACTIONS(1642),
    [anon_sym_type] = ACTIONS(1640),
    [anon_sym_typeof] = ACTIONS(1640),
    [anon_sym_import] = ACTIONS(1640),
    [anon_sym_var] = ACTIONS(1640),
    [anon_sym_let] = ACTIONS(1640),
    [anon_sym_const] = ACTIONS(1640),
    [anon_sym_BANG] = ACTIONS(1642),
    [anon_sym_else] = ACTIONS(1640),
    [anon_sym_if] = ACTIONS(1640),
    [anon_sym_switch] = ACTIONS(1640),
    [anon_sym_for] = ACTIONS(1640),
    [anon_sym_LPAREN] = ACTIONS(1642),
    [anon_sym_await] = ACTIONS(1640),
    [anon_sym_while] = ACTIONS(1640),
    [anon_sym_do] = ACTIONS(1640),
    [anon_sym_try] = ACTIONS(1640),
    [anon_sym_with] = ACTIONS(1640),
    [anon_sym_break] = ACTIONS(1640),
    [anon_sym_continue] = ACTIONS(1640),
    [anon_sym_debugger] = ACTIONS(1640),
    [anon_sym_return] = ACTIONS(1640),
    [anon_sym_throw] = ACTIONS(1640),
    [anon_sym_SEMI] = ACTIONS(1642),
    [anon_sym_case] = ACTIONS(1640),
    [anon_sym_default] = ACTIONS(1640),
    [anon_sym_yield] = ACTIONS(1640),
    [anon_sym_LBRACK] = ACTIONS(1642),
    [anon_sym_LTtemplate_GT] = ACTIONS(1642),
    [anon_sym_LT] = ACTIONS(1640),
    [anon_sym_SLASH] = ACTIONS(1640),
    [anon_sym_class] = ACTIONS(1640),
    [anon_sym_async] = ACTIONS(1640),
    [anon_sym_function] = ACTIONS(1640),
    [anon_sym_new] = ACTIONS(1640),
    [anon_sym_AMP] = ACTIONS(1642),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_DASH] = ACTIONS(1640),
    [anon_sym_TILDE] = ACTIONS(1642),
    [anon_sym_void] = ACTIONS(1640),
    [anon_sym_delete] = ACTIONS(1640),
    [anon_sym_PLUS_PLUS] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [anon_sym_SQUOTE] = ACTIONS(1642),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [sym_number] = ACTIONS(1642),
    [sym_this] = ACTIONS(1640),
    [sym_super] = ACTIONS(1640),
    [sym_true] = ACTIONS(1640),
    [sym_false] = ACTIONS(1640),
    [sym_null] = ACTIONS(1640),
    [sym_undefined] = ACTIONS(1640),
    [anon_sym_AT] = ACTIONS(1642),
    [anon_sym_static] = ACTIONS(1640),
    [anon_sym_readonly] = ACTIONS(1640),
    [anon_sym_get] = ACTIONS(1640),
    [anon_sym_set] = ACTIONS(1640),
    [anon_sym_declare] = ACTIONS(1640),
    [anon_sym_namespace] = ACTIONS(1640),
    [anon_sym_public] = ACTIONS(1640),
    [anon_sym_private] = ACTIONS(1640),
    [anon_sym_protected] = ACTIONS(1640),
    [anon_sym_override] = ACTIONS(1640),
    [anon_sym_module] = ACTIONS(1640),
    [anon_sym_any] = ACTIONS(1640),
    [anon_sym_number] = ACTIONS(1640),
    [anon_sym_boolean] = ACTIONS(1640),
    [anon_sym_string] = ACTIONS(1640),
    [anon_sym_symbol] = ACTIONS(1640),
    [anon_sym_abstract] = ACTIONS(1640),
    [anon_sym_interface] = ACTIONS(1640),
    [anon_sym_enum] = ACTIONS(1640),
    [anon_sym_component] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(1642),
  },
  [691] = {
    [sym_identifier] = ACTIONS(1666),
    [anon_sym_export] = ACTIONS(1666),
    [anon_sym_LBRACE] = ACTIONS(1670),
    [anon_sym_RBRACE] = ACTIONS(1670),
    [anon_sym_type] = ACTIONS(1666),
    [anon_sym_typeof] = ACTIONS(1666),
    [anon_sym_import] = ACTIONS(1666),
    [anon_sym_var] = ACTIONS(1666),
    [anon_sym_let] = ACTIONS(1666),
    [anon_sym_const] = ACTIONS(1666),
    [anon_sym_BANG] = ACTIONS(1670),
    [anon_sym_else] = ACTIONS(1666),
    [anon_sym_if] = ACTIONS(1666),
    [anon_sym_switch] = ACTIONS(1666),
    [anon_sym_for] = ACTIONS(1666),
    [anon_sym_LPAREN] = ACTIONS(1670),
    [anon_sym_await] = ACTIONS(1666),
    [anon_sym_while] = ACTIONS(1666),
    [anon_sym_do] = ACTIONS(1666),
    [anon_sym_try] = ACTIONS(1666),
    [anon_sym_with] = ACTIONS(1666),
    [anon_sym_break] = ACTIONS(1666),
    [anon_sym_continue] = ACTIONS(1666),
    [anon_sym_debugger] = ACTIONS(1666),
    [anon_sym_return] = ACTIONS(1666),
    [anon_sym_throw] = ACTIONS(1666),
    [anon_sym_SEMI] = ACTIONS(1670),
    [anon_sym_case] = ACTIONS(1666),
    [anon_sym_default] = ACTIONS(1666),
    [anon_sym_yield] = ACTIONS(1666),
    [anon_sym_LBRACK] = ACTIONS(1670),
    [anon_sym_LTtemplate_GT] = ACTIONS(1670),
    [anon_sym_LT] = ACTIONS(1666),
    [anon_sym_SLASH] = ACTIONS(1666),
    [anon_sym_class] = ACTIONS(1666),
    [anon_sym_async] = ACTIONS(1666),
    [anon_sym_function] = ACTIONS(1666),
    [anon_sym_new] = ACTIONS(1666),
    [anon_sym_AMP] = ACTIONS(1670),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1670),
    [anon_sym_void] = ACTIONS(1666),
    [anon_sym_delete] = ACTIONS(1666),
    [anon_sym_PLUS_PLUS] = ACTIONS(1670),
    [anon_sym_DASH_DASH] = ACTIONS(1670),
    [anon_sym_DQUOTE] = ACTIONS(1670),
    [anon_sym_SQUOTE] = ACTIONS(1670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1670),
    [sym_number] = ACTIONS(1670),
    [sym_this] = ACTIONS(1666),
    [sym_super] = ACTIONS(1666),
    [sym_true] = ACTIONS(1666),
    [sym_false] = ACTIONS(1666),
    [sym_null] = ACTIONS(1666),
    [sym_undefined] = ACTIONS(1666),
    [anon_sym_AT] = ACTIONS(1670),
    [anon_sym_static] = ACTIONS(1666),
    [anon_sym_readonly] = ACTIONS(1666),
    [anon_sym_get] = ACTIONS(1666),
    [anon_sym_set] = ACTIONS(1666),
    [anon_sym_declare] = ACTIONS(1666),
    [anon_sym_namespace] = ACTIONS(1666),
    [anon_sym_public] = ACTIONS(1666),
    [anon_sym_private] = ACTIONS(1666),
    [anon_sym_protected] = ACTIONS(1666),
    [anon_sym_override] = ACTIONS(1666),
    [anon_sym_module] = ACTIONS(1666),
    [anon_sym_any] = ACTIONS(1666),
    [anon_sym_number] = ACTIONS(1666),
    [anon_sym_boolean] = ACTIONS(1666),
    [anon_sym_string] = ACTIONS(1666),
    [anon_sym_symbol] = ACTIONS(1666),
    [anon_sym_abstract] = ACTIONS(1666),
    [anon_sym_interface] = ACTIONS(1666),
    [anon_sym_enum] = ACTIONS(1666),
    [anon_sym_component] = ACTIONS(1666),
    [sym__automatic_semicolon] = ACTIONS(1674),
  },
  [692] = {
    [sym_identifier] = ACTIONS(1706),
    [anon_sym_export] = ACTIONS(1706),
    [anon_sym_LBRACE] = ACTIONS(1710),
    [anon_sym_RBRACE] = ACTIONS(1710),
    [anon_sym_type] = ACTIONS(1706),
    [anon_sym_typeof] = ACTIONS(1706),
    [anon_sym_import] = ACTIONS(1706),
    [anon_sym_var] = ACTIONS(1706),
    [anon_sym_let] = ACTIONS(1706),
    [anon_sym_const] = ACTIONS(1706),
    [anon_sym_BANG] = ACTIONS(1710),
    [anon_sym_else] = ACTIONS(1706),
    [anon_sym_if] = ACTIONS(1706),
    [anon_sym_switch] = ACTIONS(1706),
    [anon_sym_for] = ACTIONS(1706),
    [anon_sym_LPAREN] = ACTIONS(1710),
    [anon_sym_await] = ACTIONS(1706),
    [anon_sym_while] = ACTIONS(1706),
    [anon_sym_do] = ACTIONS(1706),
    [anon_sym_try] = ACTIONS(1706),
    [anon_sym_with] = ACTIONS(1706),
    [anon_sym_break] = ACTIONS(1706),
    [anon_sym_continue] = ACTIONS(1706),
    [anon_sym_debugger] = ACTIONS(1706),
    [anon_sym_return] = ACTIONS(1706),
    [anon_sym_throw] = ACTIONS(1706),
    [anon_sym_SEMI] = ACTIONS(1710),
    [anon_sym_case] = ACTIONS(1706),
    [anon_sym_default] = ACTIONS(1706),
    [anon_sym_yield] = ACTIONS(1706),
    [anon_sym_LBRACK] = ACTIONS(1710),
    [anon_sym_LTtemplate_GT] = ACTIONS(1710),
    [anon_sym_LT] = ACTIONS(1706),
    [anon_sym_SLASH] = ACTIONS(1706),
    [anon_sym_class] = ACTIONS(1706),
    [anon_sym_async] = ACTIONS(1706),
    [anon_sym_function] = ACTIONS(1706),
    [anon_sym_new] = ACTIONS(1706),
    [anon_sym_AMP] = ACTIONS(1710),
    [anon_sym_PLUS] = ACTIONS(1706),
    [anon_sym_DASH] = ACTIONS(1706),
    [anon_sym_TILDE] = ACTIONS(1710),
    [anon_sym_void] = ACTIONS(1706),
    [anon_sym_delete] = ACTIONS(1706),
    [anon_sym_PLUS_PLUS] = ACTIONS(1710),
    [anon_sym_DASH_DASH] = ACTIONS(1710),
    [anon_sym_DQUOTE] = ACTIONS(1710),
    [anon_sym_SQUOTE] = ACTIONS(1710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1710),
    [sym_number] = ACTIONS(1710),
    [sym_this] = ACTIONS(1706),
    [sym_super] = ACTIONS(1706),
    [sym_true] = ACTIONS(1706),
    [sym_false] = ACTIONS(1706),
    [sym_null] = ACTIONS(1706),
    [sym_undefined] = ACTIONS(1706),
    [anon_sym_AT] = ACTIONS(1710),
    [anon_sym_static] = ACTIONS(1706),
    [anon_sym_readonly] = ACTIONS(1706),
    [anon_sym_get] = ACTIONS(1706),
    [anon_sym_set] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1706),
    [anon_sym_namespace] = ACTIONS(1706),
    [anon_sym_public] = ACTIONS(1706),
    [anon_sym_private] = ACTIONS(1706),
    [anon_sym_protected] = ACTIONS(1706),
    [anon_sym_override] = ACTIONS(1706),
    [anon_sym_module] = ACTIONS(1706),
    [anon_sym_any] = ACTIONS(1706),
    [anon_sym_number] = ACTIONS(1706),
    [anon_sym_boolean] = ACTIONS(1706),
    [anon_sym_string] = ACTIONS(1706),
    [anon_sym_symbol] = ACTIONS(1706),
    [anon_sym_abstract] = ACTIONS(1706),
    [anon_sym_interface] = ACTIONS(1706),
    [anon_sym_enum] = ACTIONS(1706),
    [anon_sym_component] = ACTIONS(1706),
    [sym__automatic_semicolon] = ACTIONS(1714),
  },
  [693] = {
    [sym_identifier] = ACTIONS(1524),
    [anon_sym_export] = ACTIONS(1524),
    [anon_sym_LBRACE] = ACTIONS(1526),
    [anon_sym_RBRACE] = ACTIONS(1526),
    [anon_sym_type] = ACTIONS(1524),
    [anon_sym_typeof] = ACTIONS(1524),
    [anon_sym_import] = ACTIONS(1524),
    [anon_sym_var] = ACTIONS(1524),
    [anon_sym_let] = ACTIONS(1524),
    [anon_sym_const] = ACTIONS(1524),
    [anon_sym_BANG] = ACTIONS(1526),
    [anon_sym_else] = ACTIONS(1524),
    [anon_sym_if] = ACTIONS(1524),
    [anon_sym_switch] = ACTIONS(1524),
    [anon_sym_for] = ACTIONS(1524),
    [anon_sym_LPAREN] = ACTIONS(1526),
    [anon_sym_await] = ACTIONS(1524),
    [anon_sym_while] = ACTIONS(1524),
    [anon_sym_do] = ACTIONS(1524),
    [anon_sym_try] = ACTIONS(1524),
    [anon_sym_with] = ACTIONS(1524),
    [anon_sym_break] = ACTIONS(1524),
    [anon_sym_continue] = ACTIONS(1524),
    [anon_sym_debugger] = ACTIONS(1524),
    [anon_sym_return] = ACTIONS(1524),
    [anon_sym_throw] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1526),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1524),
    [anon_sym_yield] = ACTIONS(1524),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LTtemplate_GT] = ACTIONS(1526),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_SLASH] = ACTIONS(1524),
    [anon_sym_class] = ACTIONS(1524),
    [anon_sym_async] = ACTIONS(1524),
    [anon_sym_function] = ACTIONS(1524),
    [anon_sym_new] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1526),
    [anon_sym_PLUS] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1524),
    [anon_sym_TILDE] = ACTIONS(1526),
    [anon_sym_void] = ACTIONS(1524),
    [anon_sym_delete] = ACTIONS(1524),
    [anon_sym_PLUS_PLUS] = ACTIONS(1526),
    [anon_sym_DASH_DASH] = ACTIONS(1526),
    [anon_sym_DQUOTE] = ACTIONS(1526),
    [anon_sym_SQUOTE] = ACTIONS(1526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1526),
    [sym_number] = ACTIONS(1526),
    [sym_this] = ACTIONS(1524),
    [sym_super] = ACTIONS(1524),
    [sym_true] = ACTIONS(1524),
    [sym_false] = ACTIONS(1524),
    [sym_null] = ACTIONS(1524),
    [sym_undefined] = ACTIONS(1524),
    [anon_sym_AT] = ACTIONS(1526),
    [anon_sym_static] = ACTIONS(1524),
    [anon_sym_readonly] = ACTIONS(1524),
    [anon_sym_get] = ACTIONS(1524),
    [anon_sym_set] = ACTIONS(1524),
    [anon_sym_declare] = ACTIONS(1524),
    [anon_sym_namespace] = ACTIONS(1524),
    [anon_sym_public] = ACTIONS(1524),
    [anon_sym_private] = ACTIONS(1524),
    [anon_sym_protected] = ACTIONS(1524),
    [anon_sym_override] = ACTIONS(1524),
    [anon_sym_module] = ACTIONS(1524),
    [anon_sym_any] = ACTIONS(1524),
    [anon_sym_number] = ACTIONS(1524),
    [anon_sym_boolean] = ACTIONS(1524),
    [anon_sym_string] = ACTIONS(1524),
    [anon_sym_symbol] = ACTIONS(1524),
    [anon_sym_abstract] = ACTIONS(1524),
    [anon_sym_interface] = ACTIONS(1524),
    [anon_sym_enum] = ACTIONS(1524),
    [anon_sym_component] = ACTIONS(1524),
    [sym__automatic_semicolon] = ACTIONS(2570),
  },
  [694] = {
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(1736),
    [anon_sym_LBRACE] = ACTIONS(1740),
    [anon_sym_RBRACE] = ACTIONS(1740),
    [anon_sym_type] = ACTIONS(1736),
    [anon_sym_typeof] = ACTIONS(1736),
    [anon_sym_import] = ACTIONS(1736),
    [anon_sym_var] = ACTIONS(1736),
    [anon_sym_let] = ACTIONS(1736),
    [anon_sym_const] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1740),
    [anon_sym_else] = ACTIONS(1736),
    [anon_sym_if] = ACTIONS(1736),
    [anon_sym_switch] = ACTIONS(1736),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_LPAREN] = ACTIONS(1740),
    [anon_sym_await] = ACTIONS(1736),
    [anon_sym_while] = ACTIONS(1736),
    [anon_sym_do] = ACTIONS(1736),
    [anon_sym_try] = ACTIONS(1736),
    [anon_sym_with] = ACTIONS(1736),
    [anon_sym_break] = ACTIONS(1736),
    [anon_sym_continue] = ACTIONS(1736),
    [anon_sym_debugger] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1736),
    [anon_sym_throw] = ACTIONS(1736),
    [anon_sym_SEMI] = ACTIONS(1740),
    [anon_sym_case] = ACTIONS(1736),
    [anon_sym_default] = ACTIONS(1736),
    [anon_sym_yield] = ACTIONS(1736),
    [anon_sym_LBRACK] = ACTIONS(1740),
    [anon_sym_LTtemplate_GT] = ACTIONS(1740),
    [anon_sym_LT] = ACTIONS(1736),
    [anon_sym_SLASH] = ACTIONS(1736),
    [anon_sym_class] = ACTIONS(1736),
    [anon_sym_async] = ACTIONS(1736),
    [anon_sym_function] = ACTIONS(1736),
    [anon_sym_new] = ACTIONS(1736),
    [anon_sym_AMP] = ACTIONS(1740),
    [anon_sym_PLUS] = ACTIONS(1736),
    [anon_sym_DASH] = ACTIONS(1736),
    [anon_sym_TILDE] = ACTIONS(1740),
    [anon_sym_void] = ACTIONS(1736),
    [anon_sym_delete] = ACTIONS(1736),
    [anon_sym_PLUS_PLUS] = ACTIONS(1740),
    [anon_sym_DASH_DASH] = ACTIONS(1740),
    [anon_sym_DQUOTE] = ACTIONS(1740),
    [anon_sym_SQUOTE] = ACTIONS(1740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_number] = ACTIONS(1740),
    [sym_this] = ACTIONS(1736),
    [sym_super] = ACTIONS(1736),
    [sym_true] = ACTIONS(1736),
    [sym_false] = ACTIONS(1736),
    [sym_null] = ACTIONS(1736),
    [sym_undefined] = ACTIONS(1736),
    [anon_sym_AT] = ACTIONS(1740),
    [anon_sym_static] = ACTIONS(1736),
    [anon_sym_readonly] = ACTIONS(1736),
    [anon_sym_get] = ACTIONS(1736),
    [anon_sym_set] = ACTIONS(1736),
    [anon_sym_declare] = ACTIONS(1736),
    [anon_sym_namespace] = ACTIONS(1736),
    [anon_sym_public] = ACTIONS(1736),
    [anon_sym_private] = ACTIONS(1736),
    [anon_sym_protected] = ACTIONS(1736),
    [anon_sym_override] = ACTIONS(1736),
    [anon_sym_module] = ACTIONS(1736),
    [anon_sym_any] = ACTIONS(1736),
    [anon_sym_number] = ACTIONS(1736),
    [anon_sym_boolean] = ACTIONS(1736),
    [anon_sym_string] = ACTIONS(1736),
    [anon_sym_symbol] = ACTIONS(1736),
    [anon_sym_abstract] = ACTIONS(1736),
    [anon_sym_interface] = ACTIONS(1736),
    [anon_sym_enum] = ACTIONS(1736),
    [anon_sym_component] = ACTIONS(1736),
    [sym__automatic_semicolon] = ACTIONS(1744),
  },
  [695] = {
    [sym_identifier] = ACTIONS(1402),
    [anon_sym_export] = ACTIONS(1402),
    [anon_sym_LBRACE] = ACTIONS(1406),
    [anon_sym_RBRACE] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1402),
    [anon_sym_typeof] = ACTIONS(1402),
    [anon_sym_import] = ACTIONS(1402),
    [anon_sym_var] = ACTIONS(1402),
    [anon_sym_let] = ACTIONS(1402),
    [anon_sym_const] = ACTIONS(1402),
    [anon_sym_BANG] = ACTIONS(1406),
    [anon_sym_else] = ACTIONS(1402),
    [anon_sym_if] = ACTIONS(1402),
    [anon_sym_switch] = ACTIONS(1402),
    [anon_sym_for] = ACTIONS(1402),
    [anon_sym_LPAREN] = ACTIONS(1406),
    [anon_sym_await] = ACTIONS(1402),
    [anon_sym_while] = ACTIONS(1402),
    [anon_sym_do] = ACTIONS(1402),
    [anon_sym_try] = ACTIONS(1402),
    [anon_sym_with] = ACTIONS(1402),
    [anon_sym_break] = ACTIONS(1402),
    [anon_sym_continue] = ACTIONS(1402),
    [anon_sym_debugger] = ACTIONS(1402),
    [anon_sym_return] = ACTIONS(1402),
    [anon_sym_throw] = ACTIONS(1402),
    [anon_sym_SEMI] = ACTIONS(1406),
    [anon_sym_case] = ACTIONS(1402),
    [anon_sym_default] = ACTIONS(1402),
    [anon_sym_yield] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1406),
    [anon_sym_LTtemplate_GT] = ACTIONS(1406),
    [anon_sym_LT] = ACTIONS(1402),
    [anon_sym_SLASH] = ACTIONS(1402),
    [anon_sym_class] = ACTIONS(1402),
    [anon_sym_async] = ACTIONS(1402),
    [anon_sym_function] = ACTIONS(1402),
    [anon_sym_new] = ACTIONS(1402),
    [anon_sym_AMP] = ACTIONS(1406),
    [anon_sym_PLUS] = ACTIONS(1402),
    [anon_sym_DASH] = ACTIONS(1402),
    [anon_sym_TILDE] = ACTIONS(1406),
    [anon_sym_void] = ACTIONS(1402),
    [anon_sym_delete] = ACTIONS(1402),
    [anon_sym_PLUS_PLUS] = ACTIONS(1406),
    [anon_sym_DASH_DASH] = ACTIONS(1406),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_SQUOTE] = ACTIONS(1406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1406),
    [sym_number] = ACTIONS(1406),
    [sym_this] = ACTIONS(1402),
    [sym_super] = ACTIONS(1402),
    [sym_true] = ACTIONS(1402),
    [sym_false] = ACTIONS(1402),
    [sym_null] = ACTIONS(1402),
    [sym_undefined] = ACTIONS(1402),
    [anon_sym_AT] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1402),
    [anon_sym_readonly] = ACTIONS(1402),
    [anon_sym_get] = ACTIONS(1402),
    [anon_sym_set] = ACTIONS(1402),
    [anon_sym_declare] = ACTIONS(1402),
    [anon_sym_namespace] = ACTIONS(1402),
    [anon_sym_public] = ACTIONS(1402),
    [anon_sym_private] = ACTIONS(1402),
    [anon_sym_protected] = ACTIONS(1402),
    [anon_sym_override] = ACTIONS(1402),
    [anon_sym_module] = ACTIONS(1402),
    [anon_sym_any] = ACTIONS(1402),
    [anon_sym_number] = ACTIONS(1402),
    [anon_sym_boolean] = ACTIONS(1402),
    [anon_sym_string] = ACTIONS(1402),
    [anon_sym_symbol] = ACTIONS(1402),
    [anon_sym_abstract] = ACTIONS(1402),
    [anon_sym_interface] = ACTIONS(1402),
    [anon_sym_enum] = ACTIONS(1402),
    [anon_sym_component] = ACTIONS(1402),
    [sym__automatic_semicolon] = ACTIONS(1410),
  },
  [696] = {
    [sym_else_clause] = STATE(869),
    [sym_identifier] = ACTIONS(2572),
    [anon_sym_export] = ACTIONS(2572),
    [anon_sym_LBRACE] = ACTIONS(2574),
    [anon_sym_RBRACE] = ACTIONS(2574),
    [anon_sym_type] = ACTIONS(2572),
    [anon_sym_typeof] = ACTIONS(2572),
    [anon_sym_import] = ACTIONS(2572),
    [anon_sym_var] = ACTIONS(2572),
    [anon_sym_let] = ACTIONS(2572),
    [anon_sym_const] = ACTIONS(2572),
    [anon_sym_BANG] = ACTIONS(2574),
    [anon_sym_else] = ACTIONS(2576),
    [anon_sym_if] = ACTIONS(2572),
    [anon_sym_switch] = ACTIONS(2572),
    [anon_sym_for] = ACTIONS(2572),
    [anon_sym_LPAREN] = ACTIONS(2574),
    [anon_sym_await] = ACTIONS(2572),
    [anon_sym_while] = ACTIONS(2572),
    [anon_sym_do] = ACTIONS(2572),
    [anon_sym_try] = ACTIONS(2572),
    [anon_sym_with] = ACTIONS(2572),
    [anon_sym_break] = ACTIONS(2572),
    [anon_sym_continue] = ACTIONS(2572),
    [anon_sym_debugger] = ACTIONS(2572),
    [anon_sym_return] = ACTIONS(2572),
    [anon_sym_throw] = ACTIONS(2572),
    [anon_sym_SEMI] = ACTIONS(2574),
    [anon_sym_case] = ACTIONS(2572),
    [anon_sym_default] = ACTIONS(2572),
    [anon_sym_yield] = ACTIONS(2572),
    [anon_sym_LBRACK] = ACTIONS(2574),
    [anon_sym_LTtemplate_GT] = ACTIONS(2574),
    [anon_sym_LT] = ACTIONS(2572),
    [anon_sym_SLASH] = ACTIONS(2572),
    [anon_sym_class] = ACTIONS(2572),
    [anon_sym_async] = ACTIONS(2572),
    [anon_sym_function] = ACTIONS(2572),
    [anon_sym_new] = ACTIONS(2572),
    [anon_sym_AMP] = ACTIONS(2574),
    [anon_sym_PLUS] = ACTIONS(2572),
    [anon_sym_DASH] = ACTIONS(2572),
    [anon_sym_TILDE] = ACTIONS(2574),
    [anon_sym_void] = ACTIONS(2572),
    [anon_sym_delete] = ACTIONS(2572),
    [anon_sym_PLUS_PLUS] = ACTIONS(2574),
    [anon_sym_DASH_DASH] = ACTIONS(2574),
    [anon_sym_DQUOTE] = ACTIONS(2574),
    [anon_sym_SQUOTE] = ACTIONS(2574),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2574),
    [sym_number] = ACTIONS(2574),
    [sym_this] = ACTIONS(2572),
    [sym_super] = ACTIONS(2572),
    [sym_true] = ACTIONS(2572),
    [sym_false] = ACTIONS(2572),
    [sym_null] = ACTIONS(2572),
    [sym_undefined] = ACTIONS(2572),
    [anon_sym_AT] = ACTIONS(2574),
    [anon_sym_static] = ACTIONS(2572),
    [anon_sym_readonly] = ACTIONS(2572),
    [anon_sym_get] = ACTIONS(2572),
    [anon_sym_set] = ACTIONS(2572),
    [anon_sym_declare] = ACTIONS(2572),
    [anon_sym_namespace] = ACTIONS(2572),
    [anon_sym_public] = ACTIONS(2572),
    [anon_sym_private] = ACTIONS(2572),
    [anon_sym_protected] = ACTIONS(2572),
    [anon_sym_override] = ACTIONS(2572),
    [anon_sym_module] = ACTIONS(2572),
    [anon_sym_any] = ACTIONS(2572),
    [anon_sym_number] = ACTIONS(2572),
    [anon_sym_boolean] = ACTIONS(2572),
    [anon_sym_string] = ACTIONS(2572),
    [anon_sym_symbol] = ACTIONS(2572),
    [anon_sym_abstract] = ACTIONS(2572),
    [anon_sym_interface] = ACTIONS(2572),
    [anon_sym_enum] = ACTIONS(2572),
    [anon_sym_component] = ACTIONS(2572),
  },
  [697] = {
    [sym_identifier] = ACTIONS(1366),
    [anon_sym_export] = ACTIONS(1366),
    [anon_sym_LBRACE] = ACTIONS(1370),
    [anon_sym_RBRACE] = ACTIONS(1370),
    [anon_sym_type] = ACTIONS(1366),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_import] = ACTIONS(1366),
    [anon_sym_var] = ACTIONS(1366),
    [anon_sym_let] = ACTIONS(1366),
    [anon_sym_const] = ACTIONS(1366),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_else] = ACTIONS(1366),
    [anon_sym_if] = ACTIONS(1366),
    [anon_sym_switch] = ACTIONS(1366),
    [anon_sym_for] = ACTIONS(1366),
    [anon_sym_LPAREN] = ACTIONS(1370),
    [anon_sym_await] = ACTIONS(1366),
    [anon_sym_while] = ACTIONS(1366),
    [anon_sym_do] = ACTIONS(1366),
    [anon_sym_try] = ACTIONS(1366),
    [anon_sym_with] = ACTIONS(1366),
    [anon_sym_break] = ACTIONS(1366),
    [anon_sym_continue] = ACTIONS(1366),
    [anon_sym_debugger] = ACTIONS(1366),
    [anon_sym_return] = ACTIONS(1366),
    [anon_sym_throw] = ACTIONS(1366),
    [anon_sym_SEMI] = ACTIONS(1370),
    [anon_sym_case] = ACTIONS(1366),
    [anon_sym_default] = ACTIONS(1366),
    [anon_sym_yield] = ACTIONS(1366),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_LTtemplate_GT] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_SLASH] = ACTIONS(1366),
    [anon_sym_class] = ACTIONS(1366),
    [anon_sym_async] = ACTIONS(1366),
    [anon_sym_function] = ACTIONS(1366),
    [anon_sym_new] = ACTIONS(1366),
    [anon_sym_AMP] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1366),
    [anon_sym_DASH] = ACTIONS(1366),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_void] = ACTIONS(1366),
    [anon_sym_delete] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_DQUOTE] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1370),
    [sym_number] = ACTIONS(1370),
    [sym_this] = ACTIONS(1366),
    [sym_super] = ACTIONS(1366),
    [sym_true] = ACTIONS(1366),
    [sym_false] = ACTIONS(1366),
    [sym_null] = ACTIONS(1366),
    [sym_undefined] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(1370),
    [anon_sym_static] = ACTIONS(1366),
    [anon_sym_readonly] = ACTIONS(1366),
    [anon_sym_get] = ACTIONS(1366),
    [anon_sym_set] = ACTIONS(1366),
    [anon_sym_declare] = ACTIONS(1366),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_public] = ACTIONS(1366),
    [anon_sym_private] = ACTIONS(1366),
    [anon_sym_protected] = ACTIONS(1366),
    [anon_sym_override] = ACTIONS(1366),
    [anon_sym_module] = ACTIONS(1366),
    [anon_sym_any] = ACTIONS(1366),
    [anon_sym_number] = ACTIONS(1366),
    [anon_sym_boolean] = ACTIONS(1366),
    [anon_sym_string] = ACTIONS(1366),
    [anon_sym_symbol] = ACTIONS(1366),
    [anon_sym_abstract] = ACTIONS(1366),
    [anon_sym_interface] = ACTIONS(1366),
    [anon_sym_enum] = ACTIONS(1366),
    [anon_sym_component] = ACTIONS(1366),
    [sym__automatic_semicolon] = ACTIONS(2578),
  },
  [698] = {
    [sym_identifier] = ACTIONS(2580),
    [anon_sym_export] = ACTIONS(2580),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_RBRACE] = ACTIONS(2582),
    [anon_sym_type] = ACTIONS(2580),
    [anon_sym_typeof] = ACTIONS(2580),
    [anon_sym_import] = ACTIONS(2580),
    [anon_sym_var] = ACTIONS(2580),
    [anon_sym_let] = ACTIONS(2580),
    [anon_sym_const] = ACTIONS(2580),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_else] = ACTIONS(2580),
    [anon_sym_if] = ACTIONS(2580),
    [anon_sym_switch] = ACTIONS(2580),
    [anon_sym_for] = ACTIONS(2580),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_await] = ACTIONS(2580),
    [anon_sym_while] = ACTIONS(2580),
    [anon_sym_do] = ACTIONS(2580),
    [anon_sym_try] = ACTIONS(2580),
    [anon_sym_with] = ACTIONS(2580),
    [anon_sym_break] = ACTIONS(2580),
    [anon_sym_continue] = ACTIONS(2580),
    [anon_sym_debugger] = ACTIONS(2580),
    [anon_sym_return] = ACTIONS(2580),
    [anon_sym_throw] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym_case] = ACTIONS(2580),
    [anon_sym_default] = ACTIONS(2580),
    [anon_sym_finally] = ACTIONS(2580),
    [anon_sym_yield] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2582),
    [anon_sym_LTtemplate_GT] = ACTIONS(2582),
    [anon_sym_LT] = ACTIONS(2580),
    [anon_sym_SLASH] = ACTIONS(2580),
    [anon_sym_class] = ACTIONS(2580),
    [anon_sym_async] = ACTIONS(2580),
    [anon_sym_function] = ACTIONS(2580),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_AMP] = ACTIONS(2582),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_DASH] = ACTIONS(2580),
    [anon_sym_TILDE] = ACTIONS(2582),
    [anon_sym_void] = ACTIONS(2580),
    [anon_sym_delete] = ACTIONS(2580),
    [anon_sym_PLUS_PLUS] = ACTIONS(2582),
    [anon_sym_DASH_DASH] = ACTIONS(2582),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [anon_sym_SQUOTE] = ACTIONS(2582),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2582),
    [sym_number] = ACTIONS(2582),
    [sym_this] = ACTIONS(2580),
    [sym_super] = ACTIONS(2580),
    [sym_true] = ACTIONS(2580),
    [sym_false] = ACTIONS(2580),
    [sym_null] = ACTIONS(2580),
    [sym_undefined] = ACTIONS(2580),
    [anon_sym_AT] = ACTIONS(2582),
    [anon_sym_static] = ACTIONS(2580),
    [anon_sym_readonly] = ACTIONS(2580),
    [anon_sym_get] = ACTIONS(2580),
    [anon_sym_set] = ACTIONS(2580),
    [anon_sym_declare] = ACTIONS(2580),
    [anon_sym_namespace] = ACTIONS(2580),
    [anon_sym_public] = ACTIONS(2580),
    [anon_sym_private] = ACTIONS(2580),
    [anon_sym_protected] = ACTIONS(2580),
    [anon_sym_override] = ACTIONS(2580),
    [anon_sym_module] = ACTIONS(2580),
    [anon_sym_any] = ACTIONS(2580),
    [anon_sym_number] = ACTIONS(2580),
    [anon_sym_boolean] = ACTIONS(2580),
    [anon_sym_string] = ACTIONS(2580),
    [anon_sym_symbol] = ACTIONS(2580),
    [anon_sym_abstract] = ACTIONS(2580),
    [anon_sym_interface] = ACTIONS(2580),
    [anon_sym_enum] = ACTIONS(2580),
    [anon_sym_component] = ACTIONS(2580),
  },
  [699] = {
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_export] = ACTIONS(2584),
    [anon_sym_LBRACE] = ACTIONS(2586),
    [anon_sym_RBRACE] = ACTIONS(2586),
    [anon_sym_type] = ACTIONS(2584),
    [anon_sym_typeof] = ACTIONS(2584),
    [anon_sym_import] = ACTIONS(2584),
    [anon_sym_var] = ACTIONS(2584),
    [anon_sym_let] = ACTIONS(2584),
    [anon_sym_const] = ACTIONS(2584),
    [anon_sym_BANG] = ACTIONS(2586),
    [anon_sym_else] = ACTIONS(2584),
    [anon_sym_if] = ACTIONS(2584),
    [anon_sym_switch] = ACTIONS(2584),
    [anon_sym_for] = ACTIONS(2584),
    [anon_sym_LPAREN] = ACTIONS(2586),
    [anon_sym_await] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2584),
    [anon_sym_do] = ACTIONS(2584),
    [anon_sym_try] = ACTIONS(2584),
    [anon_sym_with] = ACTIONS(2584),
    [anon_sym_break] = ACTIONS(2584),
    [anon_sym_continue] = ACTIONS(2584),
    [anon_sym_debugger] = ACTIONS(2584),
    [anon_sym_return] = ACTIONS(2584),
    [anon_sym_throw] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_case] = ACTIONS(2584),
    [anon_sym_default] = ACTIONS(2584),
    [anon_sym_yield] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2586),
    [anon_sym_LTtemplate_GT] = ACTIONS(2586),
    [anon_sym_LT] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2584),
    [anon_sym_DOT] = ACTIONS(2584),
    [anon_sym_class] = ACTIONS(2584),
    [anon_sym_async] = ACTIONS(2584),
    [anon_sym_function] = ACTIONS(2584),
    [anon_sym_new] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_DASH] = ACTIONS(2584),
    [anon_sym_TILDE] = ACTIONS(2586),
    [anon_sym_void] = ACTIONS(2584),
    [anon_sym_delete] = ACTIONS(2584),
    [anon_sym_PLUS_PLUS] = ACTIONS(2586),
    [anon_sym_DASH_DASH] = ACTIONS(2586),
    [anon_sym_DQUOTE] = ACTIONS(2586),
    [anon_sym_SQUOTE] = ACTIONS(2586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2586),
    [sym_number] = ACTIONS(2586),
    [sym_this] = ACTIONS(2584),
    [sym_super] = ACTIONS(2584),
    [sym_true] = ACTIONS(2584),
    [sym_false] = ACTIONS(2584),
    [sym_null] = ACTIONS(2584),
    [sym_undefined] = ACTIONS(2584),
    [anon_sym_AT] = ACTIONS(2586),
    [anon_sym_static] = ACTIONS(2584),
    [anon_sym_readonly] = ACTIONS(2584),
    [anon_sym_get] = ACTIONS(2584),
    [anon_sym_set] = ACTIONS(2584),
    [anon_sym_declare] = ACTIONS(2584),
    [anon_sym_namespace] = ACTIONS(2584),
    [anon_sym_public] = ACTIONS(2584),
    [anon_sym_private] = ACTIONS(2584),
    [anon_sym_protected] = ACTIONS(2584),
    [anon_sym_override] = ACTIONS(2584),
    [anon_sym_module] = ACTIONS(2584),
    [anon_sym_any] = ACTIONS(2584),
    [anon_sym_number] = ACTIONS(2584),
    [anon_sym_boolean] = ACTIONS(2584),
    [anon_sym_string] = ACTIONS(2584),
    [anon_sym_symbol] = ACTIONS(2584),
    [anon_sym_abstract] = ACTIONS(2584),
    [anon_sym_interface] = ACTIONS(2584),
    [anon_sym_enum] = ACTIONS(2584),
    [anon_sym_component] = ACTIONS(2584),
  },
  [700] = {
    [sym_type_arguments] = STATE(970),
    [sym_identifier] = ACTIONS(2588),
    [anon_sym_STAR] = ACTIONS(2588),
    [anon_sym_as] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2588),
    [anon_sym_RBRACE] = ACTIONS(2590),
    [anon_sym_typeof] = ACTIONS(2588),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2590),
    [anon_sym_in] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2560),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_SLASH] = ACTIONS(2588),
    [anon_sym_DOT] = ACTIONS(2592),
    [anon_sym_async] = ACTIONS(2588),
    [anon_sym_QMARK_DOT] = ACTIONS(2590),
    [anon_sym_new] = ACTIONS(2588),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2588),
    [anon_sym_GT_GT_GT] = ACTIONS(2590),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2588),
    [anon_sym_CARET] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(2588),
    [anon_sym_PLUS] = ACTIONS(2588),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_PERCENT] = ACTIONS(2590),
    [anon_sym_STAR_STAR] = ACTIONS(2590),
    [anon_sym_LT_EQ] = ACTIONS(2590),
    [anon_sym_EQ_EQ] = ACTIONS(2588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2590),
    [anon_sym_BANG_EQ] = ACTIONS(2588),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2590),
    [anon_sym_GT_EQ] = ACTIONS(2590),
    [anon_sym_QMARK_QMARK] = ACTIONS(2590),
    [anon_sym_instanceof] = ACTIONS(2588),
    [anon_sym_void] = ACTIONS(2588),
    [anon_sym_PLUS_PLUS] = ACTIONS(2590),
    [anon_sym_DASH_DASH] = ACTIONS(2590),
    [anon_sym_DQUOTE] = ACTIONS(2590),
    [anon_sym_SQUOTE] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2590),
    [sym_number] = ACTIONS(2590),
    [sym_this] = ACTIONS(2588),
    [sym_true] = ACTIONS(2588),
    [sym_false] = ACTIONS(2588),
    [sym_null] = ACTIONS(2588),
    [sym_undefined] = ACTIONS(2588),
    [anon_sym_static] = ACTIONS(2588),
    [anon_sym_readonly] = ACTIONS(2588),
    [anon_sym_get] = ACTIONS(2588),
    [anon_sym_set] = ACTIONS(2588),
    [anon_sym_QMARK] = ACTIONS(2588),
    [anon_sym_any] = ACTIONS(2588),
    [anon_sym_number] = ACTIONS(2588),
    [anon_sym_boolean] = ACTIONS(2588),
    [anon_sym_string] = ACTIONS(2588),
    [anon_sym_symbol] = ACTIONS(2588),
    [anon_sym_abstract] = ACTIONS(2588),
    [anon_sym_satisfies] = ACTIONS(2588),
    [anon_sym_extends] = ACTIONS(2588),
    [anon_sym_infer] = ACTIONS(2588),
    [anon_sym_is] = ACTIONS(2594),
    [anon_sym_keyof] = ACTIONS(2588),
    [anon_sym_unknown] = ACTIONS(2588),
    [anon_sym_never] = ACTIONS(2588),
    [anon_sym_object] = ACTIONS(2588),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2590),
    [anon_sym_constructor] = ACTIONS(2588),
    [anon_sym_prop] = ACTIONS(2588),
    [anon_sym_id] = ACTIONS(2588),
    [anon_sym_event] = ACTIONS(2588),
    [anon_sym_fn] = ACTIONS(2588),
    [anon_sym_on] = ACTIONS(2588),
    [sym__ternary_qmark] = ACTIONS(2590),
  },
  [701] = {
    [sym_identifier] = ACTIONS(2596),
    [anon_sym_export] = ACTIONS(2596),
    [anon_sym_LBRACE] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2598),
    [anon_sym_type] = ACTIONS(2596),
    [anon_sym_typeof] = ACTIONS(2596),
    [anon_sym_import] = ACTIONS(2596),
    [anon_sym_var] = ACTIONS(2596),
    [anon_sym_let] = ACTIONS(2596),
    [anon_sym_const] = ACTIONS(2596),
    [anon_sym_BANG] = ACTIONS(2598),
    [anon_sym_else] = ACTIONS(2596),
    [anon_sym_if] = ACTIONS(2596),
    [anon_sym_switch] = ACTIONS(2596),
    [anon_sym_for] = ACTIONS(2596),
    [anon_sym_LPAREN] = ACTIONS(2598),
    [anon_sym_await] = ACTIONS(2596),
    [anon_sym_while] = ACTIONS(2596),
    [anon_sym_do] = ACTIONS(2596),
    [anon_sym_try] = ACTIONS(2596),
    [anon_sym_with] = ACTIONS(2596),
    [anon_sym_break] = ACTIONS(2596),
    [anon_sym_continue] = ACTIONS(2596),
    [anon_sym_debugger] = ACTIONS(2596),
    [anon_sym_return] = ACTIONS(2596),
    [anon_sym_throw] = ACTIONS(2596),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_case] = ACTIONS(2596),
    [anon_sym_default] = ACTIONS(2596),
    [anon_sym_finally] = ACTIONS(2596),
    [anon_sym_yield] = ACTIONS(2596),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_LTtemplate_GT] = ACTIONS(2598),
    [anon_sym_LT] = ACTIONS(2596),
    [anon_sym_SLASH] = ACTIONS(2596),
    [anon_sym_class] = ACTIONS(2596),
    [anon_sym_async] = ACTIONS(2596),
    [anon_sym_function] = ACTIONS(2596),
    [anon_sym_new] = ACTIONS(2596),
    [anon_sym_AMP] = ACTIONS(2598),
    [anon_sym_PLUS] = ACTIONS(2596),
    [anon_sym_DASH] = ACTIONS(2596),
    [anon_sym_TILDE] = ACTIONS(2598),
    [anon_sym_void] = ACTIONS(2596),
    [anon_sym_delete] = ACTIONS(2596),
    [anon_sym_PLUS_PLUS] = ACTIONS(2598),
    [anon_sym_DASH_DASH] = ACTIONS(2598),
    [anon_sym_DQUOTE] = ACTIONS(2598),
    [anon_sym_SQUOTE] = ACTIONS(2598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2598),
    [sym_number] = ACTIONS(2598),
    [sym_this] = ACTIONS(2596),
    [sym_super] = ACTIONS(2596),
    [sym_true] = ACTIONS(2596),
    [sym_false] = ACTIONS(2596),
    [sym_null] = ACTIONS(2596),
    [sym_undefined] = ACTIONS(2596),
    [anon_sym_AT] = ACTIONS(2598),
    [anon_sym_static] = ACTIONS(2596),
    [anon_sym_readonly] = ACTIONS(2596),
    [anon_sym_get] = ACTIONS(2596),
    [anon_sym_set] = ACTIONS(2596),
    [anon_sym_declare] = ACTIONS(2596),
    [anon_sym_namespace] = ACTIONS(2596),
    [anon_sym_public] = ACTIONS(2596),
    [anon_sym_private] = ACTIONS(2596),
    [anon_sym_protected] = ACTIONS(2596),
    [anon_sym_override] = ACTIONS(2596),
    [anon_sym_module] = ACTIONS(2596),
    [anon_sym_any] = ACTIONS(2596),
    [anon_sym_number] = ACTIONS(2596),
    [anon_sym_boolean] = ACTIONS(2596),
    [anon_sym_string] = ACTIONS(2596),
    [anon_sym_symbol] = ACTIONS(2596),
    [anon_sym_abstract] = ACTIONS(2596),
    [anon_sym_interface] = ACTIONS(2596),
    [anon_sym_enum] = ACTIONS(2596),
    [anon_sym_component] = ACTIONS(2596),
  },
  [702] = {
    [sym_statement_block] = STATE(822),
    [sym_identifier] = ACTIONS(2401),
    [anon_sym_export] = ACTIONS(2401),
    [anon_sym_LBRACE] = ACTIONS(2403),
    [anon_sym_RBRACE] = ACTIONS(2405),
    [anon_sym_type] = ACTIONS(2401),
    [anon_sym_typeof] = ACTIONS(2401),
    [anon_sym_import] = ACTIONS(2401),
    [anon_sym_var] = ACTIONS(2401),
    [anon_sym_let] = ACTIONS(2401),
    [anon_sym_const] = ACTIONS(2401),
    [anon_sym_BANG] = ACTIONS(2405),
    [anon_sym_else] = ACTIONS(2401),
    [anon_sym_if] = ACTIONS(2401),
    [anon_sym_switch] = ACTIONS(2401),
    [anon_sym_for] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(2405),
    [anon_sym_await] = ACTIONS(2401),
    [anon_sym_while] = ACTIONS(2401),
    [anon_sym_do] = ACTIONS(2401),
    [anon_sym_try] = ACTIONS(2401),
    [anon_sym_with] = ACTIONS(2401),
    [anon_sym_break] = ACTIONS(2401),
    [anon_sym_continue] = ACTIONS(2401),
    [anon_sym_debugger] = ACTIONS(2401),
    [anon_sym_return] = ACTIONS(2401),
    [anon_sym_throw] = ACTIONS(2401),
    [anon_sym_SEMI] = ACTIONS(2405),
    [anon_sym_case] = ACTIONS(2401),
    [anon_sym_default] = ACTIONS(2401),
    [anon_sym_yield] = ACTIONS(2401),
    [anon_sym_LBRACK] = ACTIONS(2405),
    [anon_sym_LTtemplate_GT] = ACTIONS(2405),
    [anon_sym_LT] = ACTIONS(2401),
    [anon_sym_SLASH] = ACTIONS(2401),
    [anon_sym_class] = ACTIONS(2401),
    [anon_sym_async] = ACTIONS(2401),
    [anon_sym_function] = ACTIONS(2401),
    [anon_sym_new] = ACTIONS(2401),
    [anon_sym_AMP] = ACTIONS(2405),
    [anon_sym_PLUS] = ACTIONS(2401),
    [anon_sym_DASH] = ACTIONS(2401),
    [anon_sym_TILDE] = ACTIONS(2405),
    [anon_sym_void] = ACTIONS(2401),
    [anon_sym_delete] = ACTIONS(2401),
    [anon_sym_PLUS_PLUS] = ACTIONS(2405),
    [anon_sym_DASH_DASH] = ACTIONS(2405),
    [anon_sym_DQUOTE] = ACTIONS(2405),
    [anon_sym_SQUOTE] = ACTIONS(2405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2405),
    [sym_number] = ACTIONS(2405),
    [sym_this] = ACTIONS(2401),
    [sym_super] = ACTIONS(2401),
    [sym_true] = ACTIONS(2401),
    [sym_false] = ACTIONS(2401),
    [sym_null] = ACTIONS(2401),
    [sym_undefined] = ACTIONS(2401),
    [anon_sym_AT] = ACTIONS(2405),
    [anon_sym_static] = ACTIONS(2401),
    [anon_sym_readonly] = ACTIONS(2401),
    [anon_sym_get] = ACTIONS(2401),
    [anon_sym_set] = ACTIONS(2401),
    [anon_sym_declare] = ACTIONS(2401),
    [anon_sym_namespace] = ACTIONS(2401),
    [anon_sym_public] = ACTIONS(2401),
    [anon_sym_private] = ACTIONS(2401),
    [anon_sym_protected] = ACTIONS(2401),
    [anon_sym_override] = ACTIONS(2401),
    [anon_sym_module] = ACTIONS(2401),
    [anon_sym_any] = ACTIONS(2401),
    [anon_sym_number] = ACTIONS(2401),
    [anon_sym_boolean] = ACTIONS(2401),
    [anon_sym_string] = ACTIONS(2401),
    [anon_sym_symbol] = ACTIONS(2401),
    [anon_sym_abstract] = ACTIONS(2401),
    [anon_sym_interface] = ACTIONS(2401),
    [anon_sym_enum] = ACTIONS(2401),
    [anon_sym_component] = ACTIONS(2401),
  },
  [703] = {
    [sym_identifier] = ACTIONS(1524),
    [anon_sym_export] = ACTIONS(1524),
    [anon_sym_LBRACE] = ACTIONS(1526),
    [anon_sym_RBRACE] = ACTIONS(1526),
    [anon_sym_type] = ACTIONS(1524),
    [anon_sym_typeof] = ACTIONS(1524),
    [anon_sym_import] = ACTIONS(1524),
    [anon_sym_var] = ACTIONS(1524),
    [anon_sym_let] = ACTIONS(1524),
    [anon_sym_const] = ACTIONS(1524),
    [anon_sym_BANG] = ACTIONS(1526),
    [anon_sym_else] = ACTIONS(1524),
    [anon_sym_if] = ACTIONS(1524),
    [anon_sym_switch] = ACTIONS(1524),
    [anon_sym_for] = ACTIONS(1524),
    [anon_sym_LPAREN] = ACTIONS(1526),
    [anon_sym_await] = ACTIONS(1524),
    [anon_sym_while] = ACTIONS(1524),
    [anon_sym_do] = ACTIONS(1524),
    [anon_sym_try] = ACTIONS(1524),
    [anon_sym_with] = ACTIONS(1524),
    [anon_sym_break] = ACTIONS(1524),
    [anon_sym_continue] = ACTIONS(1524),
    [anon_sym_debugger] = ACTIONS(1524),
    [anon_sym_return] = ACTIONS(1524),
    [anon_sym_throw] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1526),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1524),
    [anon_sym_yield] = ACTIONS(1524),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LTtemplate_GT] = ACTIONS(1526),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_SLASH] = ACTIONS(1524),
    [anon_sym_class] = ACTIONS(1524),
    [anon_sym_async] = ACTIONS(1524),
    [anon_sym_function] = ACTIONS(1524),
    [anon_sym_new] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1526),
    [anon_sym_PLUS] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1524),
    [anon_sym_TILDE] = ACTIONS(1526),
    [anon_sym_void] = ACTIONS(1524),
    [anon_sym_delete] = ACTIONS(1524),
    [anon_sym_PLUS_PLUS] = ACTIONS(1526),
    [anon_sym_DASH_DASH] = ACTIONS(1526),
    [anon_sym_DQUOTE] = ACTIONS(1526),
    [anon_sym_SQUOTE] = ACTIONS(1526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1526),
    [sym_number] = ACTIONS(1526),
    [sym_this] = ACTIONS(1524),
    [sym_super] = ACTIONS(1524),
    [sym_true] = ACTIONS(1524),
    [sym_false] = ACTIONS(1524),
    [sym_null] = ACTIONS(1524),
    [sym_undefined] = ACTIONS(1524),
    [anon_sym_AT] = ACTIONS(1526),
    [anon_sym_static] = ACTIONS(1524),
    [anon_sym_readonly] = ACTIONS(1524),
    [anon_sym_get] = ACTIONS(1524),
    [anon_sym_set] = ACTIONS(1524),
    [anon_sym_declare] = ACTIONS(1524),
    [anon_sym_namespace] = ACTIONS(1524),
    [anon_sym_public] = ACTIONS(1524),
    [anon_sym_private] = ACTIONS(1524),
    [anon_sym_protected] = ACTIONS(1524),
    [anon_sym_override] = ACTIONS(1524),
    [anon_sym_module] = ACTIONS(1524),
    [anon_sym_any] = ACTIONS(1524),
    [anon_sym_number] = ACTIONS(1524),
    [anon_sym_boolean] = ACTIONS(1524),
    [anon_sym_string] = ACTIONS(1524),
    [anon_sym_symbol] = ACTIONS(1524),
    [anon_sym_abstract] = ACTIONS(1524),
    [anon_sym_interface] = ACTIONS(1524),
    [anon_sym_enum] = ACTIONS(1524),
    [anon_sym_component] = ACTIONS(1524),
    [sym__automatic_semicolon] = ACTIONS(1526),
  },
  [704] = {
    [sym_identifier] = ACTIONS(2600),
    [anon_sym_export] = ACTIONS(2600),
    [anon_sym_LBRACE] = ACTIONS(2602),
    [anon_sym_RBRACE] = ACTIONS(2602),
    [anon_sym_type] = ACTIONS(2600),
    [anon_sym_typeof] = ACTIONS(2600),
    [anon_sym_import] = ACTIONS(2600),
    [anon_sym_var] = ACTIONS(2600),
    [anon_sym_let] = ACTIONS(2600),
    [anon_sym_const] = ACTIONS(2600),
    [anon_sym_BANG] = ACTIONS(2602),
    [anon_sym_else] = ACTIONS(2600),
    [anon_sym_if] = ACTIONS(2600),
    [anon_sym_switch] = ACTIONS(2600),
    [anon_sym_for] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_await] = ACTIONS(2600),
    [anon_sym_while] = ACTIONS(2600),
    [anon_sym_do] = ACTIONS(2600),
    [anon_sym_try] = ACTIONS(2600),
    [anon_sym_with] = ACTIONS(2600),
    [anon_sym_break] = ACTIONS(2600),
    [anon_sym_continue] = ACTIONS(2600),
    [anon_sym_debugger] = ACTIONS(2600),
    [anon_sym_return] = ACTIONS(2600),
    [anon_sym_throw] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_case] = ACTIONS(2600),
    [anon_sym_default] = ACTIONS(2600),
    [anon_sym_yield] = ACTIONS(2600),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_LTtemplate_GT] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2600),
    [anon_sym_SLASH] = ACTIONS(2600),
    [anon_sym_class] = ACTIONS(2600),
    [anon_sym_async] = ACTIONS(2600),
    [anon_sym_function] = ACTIONS(2600),
    [anon_sym_new] = ACTIONS(2600),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_PLUS] = ACTIONS(2600),
    [anon_sym_DASH] = ACTIONS(2600),
    [anon_sym_TILDE] = ACTIONS(2602),
    [anon_sym_void] = ACTIONS(2600),
    [anon_sym_delete] = ACTIONS(2600),
    [anon_sym_PLUS_PLUS] = ACTIONS(2602),
    [anon_sym_DASH_DASH] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_SQUOTE] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [sym_number] = ACTIONS(2602),
    [sym_this] = ACTIONS(2600),
    [sym_super] = ACTIONS(2600),
    [sym_true] = ACTIONS(2600),
    [sym_false] = ACTIONS(2600),
    [sym_null] = ACTIONS(2600),
    [sym_undefined] = ACTIONS(2600),
    [anon_sym_AT] = ACTIONS(2602),
    [anon_sym_static] = ACTIONS(2600),
    [anon_sym_readonly] = ACTIONS(2600),
    [anon_sym_get] = ACTIONS(2600),
    [anon_sym_set] = ACTIONS(2600),
    [anon_sym_declare] = ACTIONS(2600),
    [anon_sym_namespace] = ACTIONS(2600),
    [anon_sym_public] = ACTIONS(2600),
    [anon_sym_private] = ACTIONS(2600),
    [anon_sym_protected] = ACTIONS(2600),
    [anon_sym_override] = ACTIONS(2600),
    [anon_sym_module] = ACTIONS(2600),
    [anon_sym_any] = ACTIONS(2600),
    [anon_sym_number] = ACTIONS(2600),
    [anon_sym_boolean] = ACTIONS(2600),
    [anon_sym_string] = ACTIONS(2600),
    [anon_sym_symbol] = ACTIONS(2600),
    [anon_sym_abstract] = ACTIONS(2600),
    [anon_sym_interface] = ACTIONS(2600),
    [anon_sym_enum] = ACTIONS(2600),
    [anon_sym_component] = ACTIONS(2600),
  },
  [705] = {
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LTtemplate_GT] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_readonly] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_override] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_component] = ACTIONS(2604),
  },
  [706] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LTtemplate_GT] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2610),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_override] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_component] = ACTIONS(2608),
  },
  [707] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LTtemplate_GT] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2610),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_override] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_component] = ACTIONS(2608),
  },
  [708] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LTtemplate_GT] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2610),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_override] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_component] = ACTIONS(2608),
  },
  [709] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LTtemplate_GT] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2610),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_override] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_component] = ACTIONS(2608),
  },
  [710] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2612),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2612),
    [anon_sym_RBRACE] = ACTIONS(2618),
    [anon_sym_typeof] = ACTIONS(2612),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2612),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_QMARK_QMARK] = ACTIONS(2650),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(2612),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2618),
    [anon_sym_SQUOTE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2618),
    [sym_number] = ACTIONS(2618),
    [sym_this] = ACTIONS(2612),
    [sym_true] = ACTIONS(2612),
    [sym_false] = ACTIONS(2612),
    [sym_null] = ACTIONS(2612),
    [sym_undefined] = ACTIONS(2612),
    [anon_sym_static] = ACTIONS(2612),
    [anon_sym_readonly] = ACTIONS(2612),
    [anon_sym_get] = ACTIONS(2612),
    [anon_sym_set] = ACTIONS(2612),
    [anon_sym_QMARK] = ACTIONS(2612),
    [anon_sym_any] = ACTIONS(2612),
    [anon_sym_number] = ACTIONS(2612),
    [anon_sym_boolean] = ACTIONS(2612),
    [anon_sym_string] = ACTIONS(2612),
    [anon_sym_symbol] = ACTIONS(2612),
    [anon_sym_abstract] = ACTIONS(2612),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2612),
    [anon_sym_keyof] = ACTIONS(2612),
    [anon_sym_unknown] = ACTIONS(2612),
    [anon_sym_never] = ACTIONS(2612),
    [anon_sym_object] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2618),
    [anon_sym_constructor] = ACTIONS(2612),
    [anon_sym_prop] = ACTIONS(2612),
    [anon_sym_id] = ACTIONS(2612),
    [anon_sym_event] = ACTIONS(2612),
    [anon_sym_fn] = ACTIONS(2612),
    [anon_sym_on] = ACTIONS(2612),
    [sym__ternary_qmark] = ACTIONS(2656),
  },
  [711] = {
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LTtemplate_GT] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_readonly] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_override] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_component] = ACTIONS(2604),
  },
  [712] = {
    [sym__call_signature] = STATE(4833),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2658),
    [anon_sym_export] = ACTIONS(2660),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(2660),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_of] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(2662),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2660),
    [anon_sym_function] = ACTIONS(2317),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2660),
    [anon_sym_readonly] = ACTIONS(2660),
    [anon_sym_get] = ACTIONS(2660),
    [anon_sym_set] = ACTIONS(2660),
    [anon_sym_declare] = ACTIONS(2660),
    [anon_sym_namespace] = ACTIONS(2660),
    [anon_sym_public] = ACTIONS(2660),
    [anon_sym_private] = ACTIONS(2660),
    [anon_sym_protected] = ACTIONS(2660),
    [anon_sym_override] = ACTIONS(2660),
    [anon_sym_module] = ACTIONS(2660),
    [anon_sym_any] = ACTIONS(2660),
    [anon_sym_number] = ACTIONS(2660),
    [anon_sym_boolean] = ACTIONS(2660),
    [anon_sym_string] = ACTIONS(2660),
    [anon_sym_symbol] = ACTIONS(2660),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [713] = {
    [sym_identifier] = ACTIONS(2666),
    [anon_sym_export] = ACTIONS(2666),
    [anon_sym_LBRACE] = ACTIONS(2668),
    [anon_sym_RBRACE] = ACTIONS(2668),
    [anon_sym_type] = ACTIONS(2666),
    [anon_sym_typeof] = ACTIONS(2666),
    [anon_sym_import] = ACTIONS(2666),
    [anon_sym_var] = ACTIONS(2666),
    [anon_sym_let] = ACTIONS(2666),
    [anon_sym_const] = ACTIONS(2666),
    [anon_sym_BANG] = ACTIONS(2668),
    [anon_sym_else] = ACTIONS(2666),
    [anon_sym_if] = ACTIONS(2666),
    [anon_sym_switch] = ACTIONS(2666),
    [anon_sym_for] = ACTIONS(2666),
    [anon_sym_LPAREN] = ACTIONS(2668),
    [anon_sym_await] = ACTIONS(2666),
    [anon_sym_while] = ACTIONS(2666),
    [anon_sym_do] = ACTIONS(2666),
    [anon_sym_try] = ACTIONS(2666),
    [anon_sym_with] = ACTIONS(2666),
    [anon_sym_break] = ACTIONS(2666),
    [anon_sym_continue] = ACTIONS(2666),
    [anon_sym_debugger] = ACTIONS(2666),
    [anon_sym_return] = ACTIONS(2666),
    [anon_sym_throw] = ACTIONS(2666),
    [anon_sym_SEMI] = ACTIONS(2668),
    [anon_sym_case] = ACTIONS(2666),
    [anon_sym_default] = ACTIONS(2666),
    [anon_sym_yield] = ACTIONS(2666),
    [anon_sym_LBRACK] = ACTIONS(2668),
    [anon_sym_LTtemplate_GT] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(2666),
    [anon_sym_SLASH] = ACTIONS(2666),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_async] = ACTIONS(2666),
    [anon_sym_function] = ACTIONS(2666),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_AMP] = ACTIONS(2668),
    [anon_sym_PLUS] = ACTIONS(2666),
    [anon_sym_DASH] = ACTIONS(2666),
    [anon_sym_TILDE] = ACTIONS(2668),
    [anon_sym_void] = ACTIONS(2666),
    [anon_sym_delete] = ACTIONS(2666),
    [anon_sym_PLUS_PLUS] = ACTIONS(2668),
    [anon_sym_DASH_DASH] = ACTIONS(2668),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_SQUOTE] = ACTIONS(2668),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2668),
    [sym_number] = ACTIONS(2668),
    [sym_this] = ACTIONS(2666),
    [sym_super] = ACTIONS(2666),
    [sym_true] = ACTIONS(2666),
    [sym_false] = ACTIONS(2666),
    [sym_null] = ACTIONS(2666),
    [sym_undefined] = ACTIONS(2666),
    [anon_sym_AT] = ACTIONS(2668),
    [anon_sym_static] = ACTIONS(2666),
    [anon_sym_readonly] = ACTIONS(2666),
    [anon_sym_get] = ACTIONS(2666),
    [anon_sym_set] = ACTIONS(2666),
    [anon_sym_declare] = ACTIONS(2666),
    [anon_sym_namespace] = ACTIONS(2666),
    [anon_sym_public] = ACTIONS(2666),
    [anon_sym_private] = ACTIONS(2666),
    [anon_sym_protected] = ACTIONS(2666),
    [anon_sym_override] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2666),
    [anon_sym_any] = ACTIONS(2666),
    [anon_sym_number] = ACTIONS(2666),
    [anon_sym_boolean] = ACTIONS(2666),
    [anon_sym_string] = ACTIONS(2666),
    [anon_sym_symbol] = ACTIONS(2666),
    [anon_sym_abstract] = ACTIONS(2666),
    [anon_sym_interface] = ACTIONS(2666),
    [anon_sym_enum] = ACTIONS(2666),
    [anon_sym_component] = ACTIONS(2666),
  },
  [714] = {
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LTtemplate_GT] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_readonly] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_override] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_component] = ACTIONS(2604),
  },
  [715] = {
    [sym_identifier] = ACTIONS(2670),
    [anon_sym_export] = ACTIONS(2670),
    [anon_sym_LBRACE] = ACTIONS(2672),
    [anon_sym_RBRACE] = ACTIONS(2672),
    [anon_sym_type] = ACTIONS(2670),
    [anon_sym_typeof] = ACTIONS(2670),
    [anon_sym_import] = ACTIONS(2670),
    [anon_sym_var] = ACTIONS(2670),
    [anon_sym_let] = ACTIONS(2670),
    [anon_sym_const] = ACTIONS(2670),
    [anon_sym_BANG] = ACTIONS(2672),
    [anon_sym_else] = ACTIONS(2670),
    [anon_sym_if] = ACTIONS(2670),
    [anon_sym_switch] = ACTIONS(2670),
    [anon_sym_for] = ACTIONS(2670),
    [anon_sym_LPAREN] = ACTIONS(2672),
    [anon_sym_await] = ACTIONS(2670),
    [anon_sym_while] = ACTIONS(2670),
    [anon_sym_do] = ACTIONS(2670),
    [anon_sym_try] = ACTIONS(2670),
    [anon_sym_with] = ACTIONS(2670),
    [anon_sym_break] = ACTIONS(2670),
    [anon_sym_continue] = ACTIONS(2670),
    [anon_sym_debugger] = ACTIONS(2670),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_throw] = ACTIONS(2670),
    [anon_sym_SEMI] = ACTIONS(2672),
    [anon_sym_case] = ACTIONS(2670),
    [anon_sym_default] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2670),
    [anon_sym_LBRACK] = ACTIONS(2672),
    [anon_sym_LTtemplate_GT] = ACTIONS(2672),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_SLASH] = ACTIONS(2670),
    [anon_sym_class] = ACTIONS(2670),
    [anon_sym_async] = ACTIONS(2670),
    [anon_sym_function] = ACTIONS(2670),
    [anon_sym_new] = ACTIONS(2670),
    [anon_sym_AMP] = ACTIONS(2672),
    [anon_sym_PLUS] = ACTIONS(2670),
    [anon_sym_DASH] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2672),
    [anon_sym_void] = ACTIONS(2670),
    [anon_sym_delete] = ACTIONS(2670),
    [anon_sym_PLUS_PLUS] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(2672),
    [anon_sym_SQUOTE] = ACTIONS(2672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2672),
    [sym_number] = ACTIONS(2672),
    [sym_this] = ACTIONS(2670),
    [sym_super] = ACTIONS(2670),
    [sym_true] = ACTIONS(2670),
    [sym_false] = ACTIONS(2670),
    [sym_null] = ACTIONS(2670),
    [sym_undefined] = ACTIONS(2670),
    [anon_sym_AT] = ACTIONS(2672),
    [anon_sym_static] = ACTIONS(2670),
    [anon_sym_readonly] = ACTIONS(2670),
    [anon_sym_get] = ACTIONS(2670),
    [anon_sym_set] = ACTIONS(2670),
    [anon_sym_declare] = ACTIONS(2670),
    [anon_sym_namespace] = ACTIONS(2670),
    [anon_sym_public] = ACTIONS(2670),
    [anon_sym_private] = ACTIONS(2670),
    [anon_sym_protected] = ACTIONS(2670),
    [anon_sym_override] = ACTIONS(2670),
    [anon_sym_module] = ACTIONS(2670),
    [anon_sym_any] = ACTIONS(2670),
    [anon_sym_number] = ACTIONS(2670),
    [anon_sym_boolean] = ACTIONS(2670),
    [anon_sym_string] = ACTIONS(2670),
    [anon_sym_symbol] = ACTIONS(2670),
    [anon_sym_abstract] = ACTIONS(2670),
    [anon_sym_interface] = ACTIONS(2670),
    [anon_sym_enum] = ACTIONS(2670),
    [anon_sym_component] = ACTIONS(2670),
  },
  [716] = {
    [sym_identifier] = ACTIONS(2674),
    [anon_sym_export] = ACTIONS(2674),
    [anon_sym_LBRACE] = ACTIONS(2676),
    [anon_sym_RBRACE] = ACTIONS(2676),
    [anon_sym_type] = ACTIONS(2674),
    [anon_sym_typeof] = ACTIONS(2674),
    [anon_sym_import] = ACTIONS(2674),
    [anon_sym_var] = ACTIONS(2674),
    [anon_sym_let] = ACTIONS(2674),
    [anon_sym_const] = ACTIONS(2674),
    [anon_sym_BANG] = ACTIONS(2676),
    [anon_sym_else] = ACTIONS(2674),
    [anon_sym_if] = ACTIONS(2674),
    [anon_sym_switch] = ACTIONS(2674),
    [anon_sym_for] = ACTIONS(2674),
    [anon_sym_LPAREN] = ACTIONS(2676),
    [anon_sym_await] = ACTIONS(2674),
    [anon_sym_while] = ACTIONS(2674),
    [anon_sym_do] = ACTIONS(2674),
    [anon_sym_try] = ACTIONS(2674),
    [anon_sym_with] = ACTIONS(2674),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_continue] = ACTIONS(2674),
    [anon_sym_debugger] = ACTIONS(2674),
    [anon_sym_return] = ACTIONS(2674),
    [anon_sym_throw] = ACTIONS(2674),
    [anon_sym_SEMI] = ACTIONS(2676),
    [anon_sym_case] = ACTIONS(2674),
    [anon_sym_default] = ACTIONS(2674),
    [anon_sym_yield] = ACTIONS(2674),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_LTtemplate_GT] = ACTIONS(2676),
    [anon_sym_LT] = ACTIONS(2674),
    [anon_sym_SLASH] = ACTIONS(2674),
    [anon_sym_class] = ACTIONS(2674),
    [anon_sym_async] = ACTIONS(2674),
    [anon_sym_function] = ACTIONS(2674),
    [anon_sym_new] = ACTIONS(2674),
    [anon_sym_AMP] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(2674),
    [anon_sym_DASH] = ACTIONS(2674),
    [anon_sym_TILDE] = ACTIONS(2676),
    [anon_sym_void] = ACTIONS(2674),
    [anon_sym_delete] = ACTIONS(2674),
    [anon_sym_PLUS_PLUS] = ACTIONS(2676),
    [anon_sym_DASH_DASH] = ACTIONS(2676),
    [anon_sym_DQUOTE] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2676),
    [sym_number] = ACTIONS(2676),
    [sym_this] = ACTIONS(2674),
    [sym_super] = ACTIONS(2674),
    [sym_true] = ACTIONS(2674),
    [sym_false] = ACTIONS(2674),
    [sym_null] = ACTIONS(2674),
    [sym_undefined] = ACTIONS(2674),
    [anon_sym_AT] = ACTIONS(2676),
    [anon_sym_static] = ACTIONS(2674),
    [anon_sym_readonly] = ACTIONS(2674),
    [anon_sym_get] = ACTIONS(2674),
    [anon_sym_set] = ACTIONS(2674),
    [anon_sym_declare] = ACTIONS(2674),
    [anon_sym_namespace] = ACTIONS(2674),
    [anon_sym_public] = ACTIONS(2674),
    [anon_sym_private] = ACTIONS(2674),
    [anon_sym_protected] = ACTIONS(2674),
    [anon_sym_override] = ACTIONS(2674),
    [anon_sym_module] = ACTIONS(2674),
    [anon_sym_any] = ACTIONS(2674),
    [anon_sym_number] = ACTIONS(2674),
    [anon_sym_boolean] = ACTIONS(2674),
    [anon_sym_string] = ACTIONS(2674),
    [anon_sym_symbol] = ACTIONS(2674),
    [anon_sym_abstract] = ACTIONS(2674),
    [anon_sym_interface] = ACTIONS(2674),
    [anon_sym_enum] = ACTIONS(2674),
    [anon_sym_component] = ACTIONS(2674),
  },
  [717] = {
    [sym__call_signature] = STATE(4833),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2658),
    [anon_sym_export] = ACTIONS(2660),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(2660),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_of] = ACTIONS(25),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2660),
    [anon_sym_function] = ACTIONS(2317),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2660),
    [anon_sym_readonly] = ACTIONS(2660),
    [anon_sym_get] = ACTIONS(2660),
    [anon_sym_set] = ACTIONS(2660),
    [anon_sym_declare] = ACTIONS(2660),
    [anon_sym_namespace] = ACTIONS(2660),
    [anon_sym_public] = ACTIONS(2660),
    [anon_sym_private] = ACTIONS(2660),
    [anon_sym_protected] = ACTIONS(2660),
    [anon_sym_override] = ACTIONS(2660),
    [anon_sym_module] = ACTIONS(2660),
    [anon_sym_any] = ACTIONS(2660),
    [anon_sym_number] = ACTIONS(2660),
    [anon_sym_boolean] = ACTIONS(2660),
    [anon_sym_string] = ACTIONS(2660),
    [anon_sym_symbol] = ACTIONS(2660),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [718] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LTtemplate_GT] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_AMP] = ACTIONS(2680),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_override] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
    [anon_sym_component] = ACTIONS(2678),
  },
  [719] = {
    [sym_identifier] = ACTIONS(2682),
    [anon_sym_export] = ACTIONS(2682),
    [anon_sym_LBRACE] = ACTIONS(2684),
    [anon_sym_RBRACE] = ACTIONS(2684),
    [anon_sym_type] = ACTIONS(2682),
    [anon_sym_typeof] = ACTIONS(2682),
    [anon_sym_import] = ACTIONS(2682),
    [anon_sym_var] = ACTIONS(2682),
    [anon_sym_let] = ACTIONS(2682),
    [anon_sym_const] = ACTIONS(2682),
    [anon_sym_BANG] = ACTIONS(2684),
    [anon_sym_else] = ACTIONS(2682),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_switch] = ACTIONS(2682),
    [anon_sym_for] = ACTIONS(2682),
    [anon_sym_LPAREN] = ACTIONS(2684),
    [anon_sym_await] = ACTIONS(2682),
    [anon_sym_while] = ACTIONS(2682),
    [anon_sym_do] = ACTIONS(2682),
    [anon_sym_try] = ACTIONS(2682),
    [anon_sym_with] = ACTIONS(2682),
    [anon_sym_break] = ACTIONS(2682),
    [anon_sym_continue] = ACTIONS(2682),
    [anon_sym_debugger] = ACTIONS(2682),
    [anon_sym_return] = ACTIONS(2682),
    [anon_sym_throw] = ACTIONS(2682),
    [anon_sym_SEMI] = ACTIONS(2684),
    [anon_sym_case] = ACTIONS(2682),
    [anon_sym_default] = ACTIONS(2682),
    [anon_sym_yield] = ACTIONS(2682),
    [anon_sym_LBRACK] = ACTIONS(2684),
    [anon_sym_LTtemplate_GT] = ACTIONS(2684),
    [anon_sym_LT] = ACTIONS(2682),
    [anon_sym_SLASH] = ACTIONS(2682),
    [anon_sym_class] = ACTIONS(2682),
    [anon_sym_async] = ACTIONS(2682),
    [anon_sym_function] = ACTIONS(2682),
    [anon_sym_new] = ACTIONS(2682),
    [anon_sym_AMP] = ACTIONS(2684),
    [anon_sym_PLUS] = ACTIONS(2682),
    [anon_sym_DASH] = ACTIONS(2682),
    [anon_sym_TILDE] = ACTIONS(2684),
    [anon_sym_void] = ACTIONS(2682),
    [anon_sym_delete] = ACTIONS(2682),
    [anon_sym_PLUS_PLUS] = ACTIONS(2684),
    [anon_sym_DASH_DASH] = ACTIONS(2684),
    [anon_sym_DQUOTE] = ACTIONS(2684),
    [anon_sym_SQUOTE] = ACTIONS(2684),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2684),
    [sym_number] = ACTIONS(2684),
    [sym_this] = ACTIONS(2682),
    [sym_super] = ACTIONS(2682),
    [sym_true] = ACTIONS(2682),
    [sym_false] = ACTIONS(2682),
    [sym_null] = ACTIONS(2682),
    [sym_undefined] = ACTIONS(2682),
    [anon_sym_AT] = ACTIONS(2684),
    [anon_sym_static] = ACTIONS(2682),
    [anon_sym_readonly] = ACTIONS(2682),
    [anon_sym_get] = ACTIONS(2682),
    [anon_sym_set] = ACTIONS(2682),
    [anon_sym_declare] = ACTIONS(2682),
    [anon_sym_namespace] = ACTIONS(2682),
    [anon_sym_public] = ACTIONS(2682),
    [anon_sym_private] = ACTIONS(2682),
    [anon_sym_protected] = ACTIONS(2682),
    [anon_sym_override] = ACTIONS(2682),
    [anon_sym_module] = ACTIONS(2682),
    [anon_sym_any] = ACTIONS(2682),
    [anon_sym_number] = ACTIONS(2682),
    [anon_sym_boolean] = ACTIONS(2682),
    [anon_sym_string] = ACTIONS(2682),
    [anon_sym_symbol] = ACTIONS(2682),
    [anon_sym_abstract] = ACTIONS(2682),
    [anon_sym_interface] = ACTIONS(2682),
    [anon_sym_enum] = ACTIONS(2682),
    [anon_sym_component] = ACTIONS(2682),
  },
  [720] = {
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LTtemplate_GT] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_readonly] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_override] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_component] = ACTIONS(2604),
  },
  [721] = {
    [sym_identifier] = ACTIONS(2686),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_LBRACE] = ACTIONS(2688),
    [anon_sym_RBRACE] = ACTIONS(2688),
    [anon_sym_type] = ACTIONS(2686),
    [anon_sym_typeof] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2686),
    [anon_sym_var] = ACTIONS(2686),
    [anon_sym_let] = ACTIONS(2686),
    [anon_sym_const] = ACTIONS(2686),
    [anon_sym_BANG] = ACTIONS(2688),
    [anon_sym_else] = ACTIONS(2686),
    [anon_sym_if] = ACTIONS(2686),
    [anon_sym_switch] = ACTIONS(2686),
    [anon_sym_for] = ACTIONS(2686),
    [anon_sym_LPAREN] = ACTIONS(2688),
    [anon_sym_await] = ACTIONS(2686),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_do] = ACTIONS(2686),
    [anon_sym_try] = ACTIONS(2686),
    [anon_sym_with] = ACTIONS(2686),
    [anon_sym_break] = ACTIONS(2686),
    [anon_sym_continue] = ACTIONS(2686),
    [anon_sym_debugger] = ACTIONS(2686),
    [anon_sym_return] = ACTIONS(2686),
    [anon_sym_throw] = ACTIONS(2686),
    [anon_sym_SEMI] = ACTIONS(2688),
    [anon_sym_case] = ACTIONS(2686),
    [anon_sym_default] = ACTIONS(2686),
    [anon_sym_yield] = ACTIONS(2686),
    [anon_sym_LBRACK] = ACTIONS(2688),
    [anon_sym_LTtemplate_GT] = ACTIONS(2688),
    [anon_sym_LT] = ACTIONS(2686),
    [anon_sym_SLASH] = ACTIONS(2686),
    [anon_sym_class] = ACTIONS(2686),
    [anon_sym_async] = ACTIONS(2686),
    [anon_sym_function] = ACTIONS(2686),
    [anon_sym_new] = ACTIONS(2686),
    [anon_sym_AMP] = ACTIONS(2688),
    [anon_sym_PLUS] = ACTIONS(2686),
    [anon_sym_DASH] = ACTIONS(2686),
    [anon_sym_TILDE] = ACTIONS(2688),
    [anon_sym_void] = ACTIONS(2686),
    [anon_sym_delete] = ACTIONS(2686),
    [anon_sym_PLUS_PLUS] = ACTIONS(2688),
    [anon_sym_DASH_DASH] = ACTIONS(2688),
    [anon_sym_DQUOTE] = ACTIONS(2688),
    [anon_sym_SQUOTE] = ACTIONS(2688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2688),
    [sym_number] = ACTIONS(2688),
    [sym_this] = ACTIONS(2686),
    [sym_super] = ACTIONS(2686),
    [sym_true] = ACTIONS(2686),
    [sym_false] = ACTIONS(2686),
    [sym_null] = ACTIONS(2686),
    [sym_undefined] = ACTIONS(2686),
    [anon_sym_AT] = ACTIONS(2688),
    [anon_sym_static] = ACTIONS(2686),
    [anon_sym_readonly] = ACTIONS(2686),
    [anon_sym_get] = ACTIONS(2686),
    [anon_sym_set] = ACTIONS(2686),
    [anon_sym_declare] = ACTIONS(2686),
    [anon_sym_namespace] = ACTIONS(2686),
    [anon_sym_public] = ACTIONS(2686),
    [anon_sym_private] = ACTIONS(2686),
    [anon_sym_protected] = ACTIONS(2686),
    [anon_sym_override] = ACTIONS(2686),
    [anon_sym_module] = ACTIONS(2686),
    [anon_sym_any] = ACTIONS(2686),
    [anon_sym_number] = ACTIONS(2686),
    [anon_sym_boolean] = ACTIONS(2686),
    [anon_sym_string] = ACTIONS(2686),
    [anon_sym_symbol] = ACTIONS(2686),
    [anon_sym_abstract] = ACTIONS(2686),
    [anon_sym_interface] = ACTIONS(2686),
    [anon_sym_enum] = ACTIONS(2686),
    [anon_sym_component] = ACTIONS(2686),
  },
  [722] = {
    [sym_identifier] = ACTIONS(2690),
    [anon_sym_export] = ACTIONS(2690),
    [anon_sym_LBRACE] = ACTIONS(2692),
    [anon_sym_RBRACE] = ACTIONS(2692),
    [anon_sym_type] = ACTIONS(2690),
    [anon_sym_typeof] = ACTIONS(2690),
    [anon_sym_import] = ACTIONS(2690),
    [anon_sym_var] = ACTIONS(2690),
    [anon_sym_let] = ACTIONS(2690),
    [anon_sym_const] = ACTIONS(2690),
    [anon_sym_BANG] = ACTIONS(2692),
    [anon_sym_else] = ACTIONS(2690),
    [anon_sym_if] = ACTIONS(2690),
    [anon_sym_switch] = ACTIONS(2690),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_LPAREN] = ACTIONS(2692),
    [anon_sym_await] = ACTIONS(2690),
    [anon_sym_while] = ACTIONS(2690),
    [anon_sym_do] = ACTIONS(2690),
    [anon_sym_try] = ACTIONS(2690),
    [anon_sym_with] = ACTIONS(2690),
    [anon_sym_break] = ACTIONS(2690),
    [anon_sym_continue] = ACTIONS(2690),
    [anon_sym_debugger] = ACTIONS(2690),
    [anon_sym_return] = ACTIONS(2690),
    [anon_sym_throw] = ACTIONS(2690),
    [anon_sym_SEMI] = ACTIONS(2692),
    [anon_sym_case] = ACTIONS(2690),
    [anon_sym_default] = ACTIONS(2690),
    [anon_sym_yield] = ACTIONS(2690),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_LTtemplate_GT] = ACTIONS(2692),
    [anon_sym_LT] = ACTIONS(2690),
    [anon_sym_SLASH] = ACTIONS(2690),
    [anon_sym_class] = ACTIONS(2690),
    [anon_sym_async] = ACTIONS(2690),
    [anon_sym_function] = ACTIONS(2690),
    [anon_sym_new] = ACTIONS(2690),
    [anon_sym_AMP] = ACTIONS(2692),
    [anon_sym_PLUS] = ACTIONS(2690),
    [anon_sym_DASH] = ACTIONS(2690),
    [anon_sym_TILDE] = ACTIONS(2692),
    [anon_sym_void] = ACTIONS(2690),
    [anon_sym_delete] = ACTIONS(2690),
    [anon_sym_PLUS_PLUS] = ACTIONS(2692),
    [anon_sym_DASH_DASH] = ACTIONS(2692),
    [anon_sym_DQUOTE] = ACTIONS(2692),
    [anon_sym_SQUOTE] = ACTIONS(2692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2692),
    [sym_number] = ACTIONS(2692),
    [sym_this] = ACTIONS(2690),
    [sym_super] = ACTIONS(2690),
    [sym_true] = ACTIONS(2690),
    [sym_false] = ACTIONS(2690),
    [sym_null] = ACTIONS(2690),
    [sym_undefined] = ACTIONS(2690),
    [anon_sym_AT] = ACTIONS(2692),
    [anon_sym_static] = ACTIONS(2690),
    [anon_sym_readonly] = ACTIONS(2690),
    [anon_sym_get] = ACTIONS(2690),
    [anon_sym_set] = ACTIONS(2690),
    [anon_sym_declare] = ACTIONS(2690),
    [anon_sym_namespace] = ACTIONS(2690),
    [anon_sym_public] = ACTIONS(2690),
    [anon_sym_private] = ACTIONS(2690),
    [anon_sym_protected] = ACTIONS(2690),
    [anon_sym_override] = ACTIONS(2690),
    [anon_sym_module] = ACTIONS(2690),
    [anon_sym_any] = ACTIONS(2690),
    [anon_sym_number] = ACTIONS(2690),
    [anon_sym_boolean] = ACTIONS(2690),
    [anon_sym_string] = ACTIONS(2690),
    [anon_sym_symbol] = ACTIONS(2690),
    [anon_sym_abstract] = ACTIONS(2690),
    [anon_sym_interface] = ACTIONS(2690),
    [anon_sym_enum] = ACTIONS(2690),
    [anon_sym_component] = ACTIONS(2690),
  },
  [723] = {
    [sym_identifier] = ACTIONS(2694),
    [anon_sym_export] = ACTIONS(2694),
    [anon_sym_LBRACE] = ACTIONS(2696),
    [anon_sym_RBRACE] = ACTIONS(2696),
    [anon_sym_type] = ACTIONS(2694),
    [anon_sym_typeof] = ACTIONS(2694),
    [anon_sym_import] = ACTIONS(2694),
    [anon_sym_var] = ACTIONS(2694),
    [anon_sym_let] = ACTIONS(2694),
    [anon_sym_const] = ACTIONS(2694),
    [anon_sym_BANG] = ACTIONS(2696),
    [anon_sym_else] = ACTIONS(2694),
    [anon_sym_if] = ACTIONS(2694),
    [anon_sym_switch] = ACTIONS(2694),
    [anon_sym_for] = ACTIONS(2694),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_await] = ACTIONS(2694),
    [anon_sym_while] = ACTIONS(2694),
    [anon_sym_do] = ACTIONS(2694),
    [anon_sym_try] = ACTIONS(2694),
    [anon_sym_with] = ACTIONS(2694),
    [anon_sym_break] = ACTIONS(2694),
    [anon_sym_continue] = ACTIONS(2694),
    [anon_sym_debugger] = ACTIONS(2694),
    [anon_sym_return] = ACTIONS(2694),
    [anon_sym_throw] = ACTIONS(2694),
    [anon_sym_SEMI] = ACTIONS(2696),
    [anon_sym_case] = ACTIONS(2694),
    [anon_sym_default] = ACTIONS(2694),
    [anon_sym_yield] = ACTIONS(2694),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_LTtemplate_GT] = ACTIONS(2696),
    [anon_sym_LT] = ACTIONS(2694),
    [anon_sym_SLASH] = ACTIONS(2694),
    [anon_sym_class] = ACTIONS(2694),
    [anon_sym_async] = ACTIONS(2694),
    [anon_sym_function] = ACTIONS(2694),
    [anon_sym_new] = ACTIONS(2694),
    [anon_sym_AMP] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2694),
    [anon_sym_DASH] = ACTIONS(2694),
    [anon_sym_TILDE] = ACTIONS(2696),
    [anon_sym_void] = ACTIONS(2694),
    [anon_sym_delete] = ACTIONS(2694),
    [anon_sym_PLUS_PLUS] = ACTIONS(2696),
    [anon_sym_DASH_DASH] = ACTIONS(2696),
    [anon_sym_DQUOTE] = ACTIONS(2696),
    [anon_sym_SQUOTE] = ACTIONS(2696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2696),
    [sym_number] = ACTIONS(2696),
    [sym_this] = ACTIONS(2694),
    [sym_super] = ACTIONS(2694),
    [sym_true] = ACTIONS(2694),
    [sym_false] = ACTIONS(2694),
    [sym_null] = ACTIONS(2694),
    [sym_undefined] = ACTIONS(2694),
    [anon_sym_AT] = ACTIONS(2696),
    [anon_sym_static] = ACTIONS(2694),
    [anon_sym_readonly] = ACTIONS(2694),
    [anon_sym_get] = ACTIONS(2694),
    [anon_sym_set] = ACTIONS(2694),
    [anon_sym_declare] = ACTIONS(2694),
    [anon_sym_namespace] = ACTIONS(2694),
    [anon_sym_public] = ACTIONS(2694),
    [anon_sym_private] = ACTIONS(2694),
    [anon_sym_protected] = ACTIONS(2694),
    [anon_sym_override] = ACTIONS(2694),
    [anon_sym_module] = ACTIONS(2694),
    [anon_sym_any] = ACTIONS(2694),
    [anon_sym_number] = ACTIONS(2694),
    [anon_sym_boolean] = ACTIONS(2694),
    [anon_sym_string] = ACTIONS(2694),
    [anon_sym_symbol] = ACTIONS(2694),
    [anon_sym_abstract] = ACTIONS(2694),
    [anon_sym_interface] = ACTIONS(2694),
    [anon_sym_enum] = ACTIONS(2694),
    [anon_sym_component] = ACTIONS(2694),
  },
  [724] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_get] = ACTIONS(2698),
    [anon_sym_set] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_constructor] = ACTIONS(2698),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [725] = {
    [sym_identifier] = ACTIONS(2702),
    [anon_sym_export] = ACTIONS(2702),
    [anon_sym_LBRACE] = ACTIONS(2704),
    [anon_sym_RBRACE] = ACTIONS(2704),
    [anon_sym_type] = ACTIONS(2702),
    [anon_sym_typeof] = ACTIONS(2702),
    [anon_sym_import] = ACTIONS(2702),
    [anon_sym_var] = ACTIONS(2702),
    [anon_sym_let] = ACTIONS(2702),
    [anon_sym_const] = ACTIONS(2702),
    [anon_sym_BANG] = ACTIONS(2704),
    [anon_sym_else] = ACTIONS(2702),
    [anon_sym_if] = ACTIONS(2702),
    [anon_sym_switch] = ACTIONS(2702),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2704),
    [anon_sym_await] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(2702),
    [anon_sym_do] = ACTIONS(2702),
    [anon_sym_try] = ACTIONS(2702),
    [anon_sym_with] = ACTIONS(2702),
    [anon_sym_break] = ACTIONS(2702),
    [anon_sym_continue] = ACTIONS(2702),
    [anon_sym_debugger] = ACTIONS(2702),
    [anon_sym_return] = ACTIONS(2702),
    [anon_sym_throw] = ACTIONS(2702),
    [anon_sym_SEMI] = ACTIONS(2704),
    [anon_sym_case] = ACTIONS(2702),
    [anon_sym_default] = ACTIONS(2702),
    [anon_sym_yield] = ACTIONS(2702),
    [anon_sym_LBRACK] = ACTIONS(2704),
    [anon_sym_LTtemplate_GT] = ACTIONS(2704),
    [anon_sym_LT] = ACTIONS(2702),
    [anon_sym_SLASH] = ACTIONS(2702),
    [anon_sym_class] = ACTIONS(2702),
    [anon_sym_async] = ACTIONS(2702),
    [anon_sym_function] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2702),
    [anon_sym_AMP] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_DASH] = ACTIONS(2702),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_void] = ACTIONS(2702),
    [anon_sym_delete] = ACTIONS(2702),
    [anon_sym_PLUS_PLUS] = ACTIONS(2704),
    [anon_sym_DASH_DASH] = ACTIONS(2704),
    [anon_sym_DQUOTE] = ACTIONS(2704),
    [anon_sym_SQUOTE] = ACTIONS(2704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2704),
    [sym_number] = ACTIONS(2704),
    [sym_this] = ACTIONS(2702),
    [sym_super] = ACTIONS(2702),
    [sym_true] = ACTIONS(2702),
    [sym_false] = ACTIONS(2702),
    [sym_null] = ACTIONS(2702),
    [sym_undefined] = ACTIONS(2702),
    [anon_sym_AT] = ACTIONS(2704),
    [anon_sym_static] = ACTIONS(2702),
    [anon_sym_readonly] = ACTIONS(2702),
    [anon_sym_get] = ACTIONS(2702),
    [anon_sym_set] = ACTIONS(2702),
    [anon_sym_declare] = ACTIONS(2702),
    [anon_sym_namespace] = ACTIONS(2702),
    [anon_sym_public] = ACTIONS(2702),
    [anon_sym_private] = ACTIONS(2702),
    [anon_sym_protected] = ACTIONS(2702),
    [anon_sym_override] = ACTIONS(2702),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_any] = ACTIONS(2702),
    [anon_sym_number] = ACTIONS(2702),
    [anon_sym_boolean] = ACTIONS(2702),
    [anon_sym_string] = ACTIONS(2702),
    [anon_sym_symbol] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2702),
    [anon_sym_interface] = ACTIONS(2702),
    [anon_sym_enum] = ACTIONS(2702),
    [anon_sym_component] = ACTIONS(2702),
  },
  [726] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_get] = ACTIONS(2698),
    [anon_sym_set] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_constructor] = ACTIONS(2698),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [727] = {
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_export] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2708),
    [anon_sym_RBRACE] = ACTIONS(2708),
    [anon_sym_type] = ACTIONS(2706),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_import] = ACTIONS(2706),
    [anon_sym_var] = ACTIONS(2706),
    [anon_sym_let] = ACTIONS(2706),
    [anon_sym_const] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_else] = ACTIONS(2706),
    [anon_sym_if] = ACTIONS(2706),
    [anon_sym_switch] = ACTIONS(2706),
    [anon_sym_for] = ACTIONS(2706),
    [anon_sym_LPAREN] = ACTIONS(2708),
    [anon_sym_await] = ACTIONS(2706),
    [anon_sym_while] = ACTIONS(2706),
    [anon_sym_do] = ACTIONS(2706),
    [anon_sym_try] = ACTIONS(2706),
    [anon_sym_with] = ACTIONS(2706),
    [anon_sym_break] = ACTIONS(2706),
    [anon_sym_continue] = ACTIONS(2706),
    [anon_sym_debugger] = ACTIONS(2706),
    [anon_sym_return] = ACTIONS(2706),
    [anon_sym_throw] = ACTIONS(2706),
    [anon_sym_SEMI] = ACTIONS(2708),
    [anon_sym_case] = ACTIONS(2706),
    [anon_sym_default] = ACTIONS(2706),
    [anon_sym_yield] = ACTIONS(2706),
    [anon_sym_LBRACK] = ACTIONS(2708),
    [anon_sym_LTtemplate_GT] = ACTIONS(2708),
    [anon_sym_LT] = ACTIONS(2706),
    [anon_sym_SLASH] = ACTIONS(2706),
    [anon_sym_class] = ACTIONS(2706),
    [anon_sym_async] = ACTIONS(2706),
    [anon_sym_function] = ACTIONS(2706),
    [anon_sym_new] = ACTIONS(2706),
    [anon_sym_AMP] = ACTIONS(2708),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2708),
    [anon_sym_DASH_DASH] = ACTIONS(2708),
    [anon_sym_DQUOTE] = ACTIONS(2708),
    [anon_sym_SQUOTE] = ACTIONS(2708),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2708),
    [sym_number] = ACTIONS(2708),
    [sym_this] = ACTIONS(2706),
    [sym_super] = ACTIONS(2706),
    [sym_true] = ACTIONS(2706),
    [sym_false] = ACTIONS(2706),
    [sym_null] = ACTIONS(2706),
    [sym_undefined] = ACTIONS(2706),
    [anon_sym_AT] = ACTIONS(2708),
    [anon_sym_static] = ACTIONS(2706),
    [anon_sym_readonly] = ACTIONS(2706),
    [anon_sym_get] = ACTIONS(2706),
    [anon_sym_set] = ACTIONS(2706),
    [anon_sym_declare] = ACTIONS(2706),
    [anon_sym_namespace] = ACTIONS(2706),
    [anon_sym_public] = ACTIONS(2706),
    [anon_sym_private] = ACTIONS(2706),
    [anon_sym_protected] = ACTIONS(2706),
    [anon_sym_override] = ACTIONS(2706),
    [anon_sym_module] = ACTIONS(2706),
    [anon_sym_any] = ACTIONS(2706),
    [anon_sym_number] = ACTIONS(2706),
    [anon_sym_boolean] = ACTIONS(2706),
    [anon_sym_string] = ACTIONS(2706),
    [anon_sym_symbol] = ACTIONS(2706),
    [anon_sym_abstract] = ACTIONS(2706),
    [anon_sym_interface] = ACTIONS(2706),
    [anon_sym_enum] = ACTIONS(2706),
    [anon_sym_component] = ACTIONS(2706),
  },
  [728] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2710),
    [anon_sym_STAR] = ACTIONS(2710),
    [anon_sym_as] = ACTIONS(2710),
    [anon_sym_LBRACE] = ACTIONS(2710),
    [anon_sym_RBRACE] = ACTIONS(2712),
    [anon_sym_typeof] = ACTIONS(2710),
    [anon_sym_BANG] = ACTIONS(2710),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2710),
    [anon_sym_SEMI] = ACTIONS(2712),
    [anon_sym_LBRACK] = ACTIONS(2712),
    [anon_sym_LT] = ACTIONS(2710),
    [anon_sym_GT] = ACTIONS(2710),
    [anon_sym_SLASH] = ACTIONS(2710),
    [anon_sym_DOT] = ACTIONS(2710),
    [anon_sym_async] = ACTIONS(2710),
    [anon_sym_QMARK_DOT] = ACTIONS(2712),
    [anon_sym_new] = ACTIONS(2710),
    [anon_sym_AMP_AMP] = ACTIONS(2712),
    [anon_sym_PIPE_PIPE] = ACTIONS(2712),
    [anon_sym_GT_GT] = ACTIONS(2710),
    [anon_sym_GT_GT_GT] = ACTIONS(2712),
    [anon_sym_LT_LT] = ACTIONS(2712),
    [anon_sym_AMP] = ACTIONS(2710),
    [anon_sym_CARET] = ACTIONS(2712),
    [anon_sym_PIPE] = ACTIONS(2710),
    [anon_sym_PLUS] = ACTIONS(2710),
    [anon_sym_DASH] = ACTIONS(2710),
    [anon_sym_PERCENT] = ACTIONS(2712),
    [anon_sym_STAR_STAR] = ACTIONS(2712),
    [anon_sym_LT_EQ] = ACTIONS(2712),
    [anon_sym_EQ_EQ] = ACTIONS(2710),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2712),
    [anon_sym_BANG_EQ] = ACTIONS(2710),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2712),
    [anon_sym_GT_EQ] = ACTIONS(2712),
    [anon_sym_QMARK_QMARK] = ACTIONS(2712),
    [anon_sym_instanceof] = ACTIONS(2710),
    [anon_sym_void] = ACTIONS(2710),
    [anon_sym_PLUS_PLUS] = ACTIONS(2712),
    [anon_sym_DASH_DASH] = ACTIONS(2712),
    [anon_sym_DQUOTE] = ACTIONS(2712),
    [anon_sym_SQUOTE] = ACTIONS(2712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2712),
    [sym_number] = ACTIONS(2712),
    [sym_this] = ACTIONS(2710),
    [sym_true] = ACTIONS(2710),
    [sym_false] = ACTIONS(2710),
    [sym_null] = ACTIONS(2710),
    [sym_undefined] = ACTIONS(2710),
    [anon_sym_static] = ACTIONS(2710),
    [anon_sym_readonly] = ACTIONS(2710),
    [anon_sym_get] = ACTIONS(2710),
    [anon_sym_set] = ACTIONS(2710),
    [anon_sym_QMARK] = ACTIONS(2710),
    [anon_sym_any] = ACTIONS(2710),
    [anon_sym_number] = ACTIONS(2710),
    [anon_sym_boolean] = ACTIONS(2710),
    [anon_sym_string] = ACTIONS(2710),
    [anon_sym_symbol] = ACTIONS(2710),
    [anon_sym_abstract] = ACTIONS(2710),
    [anon_sym_satisfies] = ACTIONS(2710),
    [anon_sym_infer] = ACTIONS(2710),
    [anon_sym_keyof] = ACTIONS(2710),
    [anon_sym_unknown] = ACTIONS(2710),
    [anon_sym_never] = ACTIONS(2710),
    [anon_sym_object] = ACTIONS(2710),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2712),
    [anon_sym_constructor] = ACTIONS(2710),
    [anon_sym_prop] = ACTIONS(2710),
    [anon_sym_id] = ACTIONS(2710),
    [anon_sym_event] = ACTIONS(2710),
    [anon_sym_fn] = ACTIONS(2710),
    [anon_sym_on] = ACTIONS(2710),
    [sym__ternary_qmark] = ACTIONS(2712),
  },
  [729] = {
    [sym_identifier] = ACTIONS(2714),
    [anon_sym_export] = ACTIONS(2714),
    [anon_sym_LBRACE] = ACTIONS(2716),
    [anon_sym_RBRACE] = ACTIONS(2716),
    [anon_sym_type] = ACTIONS(2714),
    [anon_sym_typeof] = ACTIONS(2714),
    [anon_sym_import] = ACTIONS(2714),
    [anon_sym_var] = ACTIONS(2714),
    [anon_sym_let] = ACTIONS(2714),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_BANG] = ACTIONS(2716),
    [anon_sym_else] = ACTIONS(2714),
    [anon_sym_if] = ACTIONS(2714),
    [anon_sym_switch] = ACTIONS(2714),
    [anon_sym_for] = ACTIONS(2714),
    [anon_sym_LPAREN] = ACTIONS(2716),
    [anon_sym_await] = ACTIONS(2714),
    [anon_sym_while] = ACTIONS(2714),
    [anon_sym_do] = ACTIONS(2714),
    [anon_sym_try] = ACTIONS(2714),
    [anon_sym_with] = ACTIONS(2714),
    [anon_sym_break] = ACTIONS(2714),
    [anon_sym_continue] = ACTIONS(2714),
    [anon_sym_debugger] = ACTIONS(2714),
    [anon_sym_return] = ACTIONS(2714),
    [anon_sym_throw] = ACTIONS(2714),
    [anon_sym_SEMI] = ACTIONS(2716),
    [anon_sym_case] = ACTIONS(2714),
    [anon_sym_default] = ACTIONS(2714),
    [anon_sym_yield] = ACTIONS(2714),
    [anon_sym_LBRACK] = ACTIONS(2716),
    [anon_sym_LTtemplate_GT] = ACTIONS(2716),
    [anon_sym_LT] = ACTIONS(2714),
    [anon_sym_SLASH] = ACTIONS(2714),
    [anon_sym_class] = ACTIONS(2714),
    [anon_sym_async] = ACTIONS(2714),
    [anon_sym_function] = ACTIONS(2714),
    [anon_sym_new] = ACTIONS(2714),
    [anon_sym_AMP] = ACTIONS(2716),
    [anon_sym_PLUS] = ACTIONS(2714),
    [anon_sym_DASH] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_void] = ACTIONS(2714),
    [anon_sym_delete] = ACTIONS(2714),
    [anon_sym_PLUS_PLUS] = ACTIONS(2716),
    [anon_sym_DASH_DASH] = ACTIONS(2716),
    [anon_sym_DQUOTE] = ACTIONS(2716),
    [anon_sym_SQUOTE] = ACTIONS(2716),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2716),
    [sym_number] = ACTIONS(2716),
    [sym_this] = ACTIONS(2714),
    [sym_super] = ACTIONS(2714),
    [sym_true] = ACTIONS(2714),
    [sym_false] = ACTIONS(2714),
    [sym_null] = ACTIONS(2714),
    [sym_undefined] = ACTIONS(2714),
    [anon_sym_AT] = ACTIONS(2716),
    [anon_sym_static] = ACTIONS(2714),
    [anon_sym_readonly] = ACTIONS(2714),
    [anon_sym_get] = ACTIONS(2714),
    [anon_sym_set] = ACTIONS(2714),
    [anon_sym_declare] = ACTIONS(2714),
    [anon_sym_namespace] = ACTIONS(2714),
    [anon_sym_public] = ACTIONS(2714),
    [anon_sym_private] = ACTIONS(2714),
    [anon_sym_protected] = ACTIONS(2714),
    [anon_sym_override] = ACTIONS(2714),
    [anon_sym_module] = ACTIONS(2714),
    [anon_sym_any] = ACTIONS(2714),
    [anon_sym_number] = ACTIONS(2714),
    [anon_sym_boolean] = ACTIONS(2714),
    [anon_sym_string] = ACTIONS(2714),
    [anon_sym_symbol] = ACTIONS(2714),
    [anon_sym_abstract] = ACTIONS(2714),
    [anon_sym_interface] = ACTIONS(2714),
    [anon_sym_enum] = ACTIONS(2714),
    [anon_sym_component] = ACTIONS(2714),
  },
  [730] = {
    [sym_identifier] = ACTIONS(2718),
    [anon_sym_export] = ACTIONS(2718),
    [anon_sym_LBRACE] = ACTIONS(2720),
    [anon_sym_RBRACE] = ACTIONS(2720),
    [anon_sym_type] = ACTIONS(2718),
    [anon_sym_typeof] = ACTIONS(2718),
    [anon_sym_import] = ACTIONS(2718),
    [anon_sym_var] = ACTIONS(2718),
    [anon_sym_let] = ACTIONS(2718),
    [anon_sym_const] = ACTIONS(2718),
    [anon_sym_BANG] = ACTIONS(2720),
    [anon_sym_else] = ACTIONS(2718),
    [anon_sym_if] = ACTIONS(2718),
    [anon_sym_switch] = ACTIONS(2718),
    [anon_sym_for] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(2720),
    [anon_sym_await] = ACTIONS(2718),
    [anon_sym_while] = ACTIONS(2718),
    [anon_sym_do] = ACTIONS(2718),
    [anon_sym_try] = ACTIONS(2718),
    [anon_sym_with] = ACTIONS(2718),
    [anon_sym_break] = ACTIONS(2718),
    [anon_sym_continue] = ACTIONS(2718),
    [anon_sym_debugger] = ACTIONS(2718),
    [anon_sym_return] = ACTIONS(2718),
    [anon_sym_throw] = ACTIONS(2718),
    [anon_sym_SEMI] = ACTIONS(2720),
    [anon_sym_case] = ACTIONS(2718),
    [anon_sym_default] = ACTIONS(2718),
    [anon_sym_yield] = ACTIONS(2718),
    [anon_sym_LBRACK] = ACTIONS(2720),
    [anon_sym_LTtemplate_GT] = ACTIONS(2720),
    [anon_sym_LT] = ACTIONS(2718),
    [anon_sym_SLASH] = ACTIONS(2718),
    [anon_sym_class] = ACTIONS(2718),
    [anon_sym_async] = ACTIONS(2718),
    [anon_sym_function] = ACTIONS(2718),
    [anon_sym_new] = ACTIONS(2718),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_PLUS] = ACTIONS(2718),
    [anon_sym_DASH] = ACTIONS(2718),
    [anon_sym_TILDE] = ACTIONS(2720),
    [anon_sym_void] = ACTIONS(2718),
    [anon_sym_delete] = ACTIONS(2718),
    [anon_sym_PLUS_PLUS] = ACTIONS(2720),
    [anon_sym_DASH_DASH] = ACTIONS(2720),
    [anon_sym_DQUOTE] = ACTIONS(2720),
    [anon_sym_SQUOTE] = ACTIONS(2720),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2720),
    [sym_number] = ACTIONS(2720),
    [sym_this] = ACTIONS(2718),
    [sym_super] = ACTIONS(2718),
    [sym_true] = ACTIONS(2718),
    [sym_false] = ACTIONS(2718),
    [sym_null] = ACTIONS(2718),
    [sym_undefined] = ACTIONS(2718),
    [anon_sym_AT] = ACTIONS(2720),
    [anon_sym_static] = ACTIONS(2718),
    [anon_sym_readonly] = ACTIONS(2718),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
    [anon_sym_declare] = ACTIONS(2718),
    [anon_sym_namespace] = ACTIONS(2718),
    [anon_sym_public] = ACTIONS(2718),
    [anon_sym_private] = ACTIONS(2718),
    [anon_sym_protected] = ACTIONS(2718),
    [anon_sym_override] = ACTIONS(2718),
    [anon_sym_module] = ACTIONS(2718),
    [anon_sym_any] = ACTIONS(2718),
    [anon_sym_number] = ACTIONS(2718),
    [anon_sym_boolean] = ACTIONS(2718),
    [anon_sym_string] = ACTIONS(2718),
    [anon_sym_symbol] = ACTIONS(2718),
    [anon_sym_abstract] = ACTIONS(2718),
    [anon_sym_interface] = ACTIONS(2718),
    [anon_sym_enum] = ACTIONS(2718),
    [anon_sym_component] = ACTIONS(2718),
  },
  [731] = {
    [sym_identifier] = ACTIONS(2722),
    [anon_sym_export] = ACTIONS(2722),
    [anon_sym_LBRACE] = ACTIONS(2724),
    [anon_sym_RBRACE] = ACTIONS(2724),
    [anon_sym_type] = ACTIONS(2722),
    [anon_sym_typeof] = ACTIONS(2722),
    [anon_sym_import] = ACTIONS(2722),
    [anon_sym_var] = ACTIONS(2722),
    [anon_sym_let] = ACTIONS(2722),
    [anon_sym_const] = ACTIONS(2722),
    [anon_sym_BANG] = ACTIONS(2724),
    [anon_sym_else] = ACTIONS(2722),
    [anon_sym_if] = ACTIONS(2722),
    [anon_sym_switch] = ACTIONS(2722),
    [anon_sym_for] = ACTIONS(2722),
    [anon_sym_LPAREN] = ACTIONS(2724),
    [anon_sym_await] = ACTIONS(2722),
    [anon_sym_while] = ACTIONS(2722),
    [anon_sym_do] = ACTIONS(2722),
    [anon_sym_try] = ACTIONS(2722),
    [anon_sym_with] = ACTIONS(2722),
    [anon_sym_break] = ACTIONS(2722),
    [anon_sym_continue] = ACTIONS(2722),
    [anon_sym_debugger] = ACTIONS(2722),
    [anon_sym_return] = ACTIONS(2722),
    [anon_sym_throw] = ACTIONS(2722),
    [anon_sym_SEMI] = ACTIONS(2724),
    [anon_sym_case] = ACTIONS(2722),
    [anon_sym_default] = ACTIONS(2722),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(2724),
    [anon_sym_LTtemplate_GT] = ACTIONS(2724),
    [anon_sym_LT] = ACTIONS(2722),
    [anon_sym_SLASH] = ACTIONS(2722),
    [anon_sym_class] = ACTIONS(2722),
    [anon_sym_async] = ACTIONS(2722),
    [anon_sym_function] = ACTIONS(2722),
    [anon_sym_new] = ACTIONS(2722),
    [anon_sym_AMP] = ACTIONS(2724),
    [anon_sym_PLUS] = ACTIONS(2722),
    [anon_sym_DASH] = ACTIONS(2722),
    [anon_sym_TILDE] = ACTIONS(2724),
    [anon_sym_void] = ACTIONS(2722),
    [anon_sym_delete] = ACTIONS(2722),
    [anon_sym_PLUS_PLUS] = ACTIONS(2724),
    [anon_sym_DASH_DASH] = ACTIONS(2724),
    [anon_sym_DQUOTE] = ACTIONS(2724),
    [anon_sym_SQUOTE] = ACTIONS(2724),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2724),
    [sym_number] = ACTIONS(2724),
    [sym_this] = ACTIONS(2722),
    [sym_super] = ACTIONS(2722),
    [sym_true] = ACTIONS(2722),
    [sym_false] = ACTIONS(2722),
    [sym_null] = ACTIONS(2722),
    [sym_undefined] = ACTIONS(2722),
    [anon_sym_AT] = ACTIONS(2724),
    [anon_sym_static] = ACTIONS(2722),
    [anon_sym_readonly] = ACTIONS(2722),
    [anon_sym_get] = ACTIONS(2722),
    [anon_sym_set] = ACTIONS(2722),
    [anon_sym_declare] = ACTIONS(2722),
    [anon_sym_namespace] = ACTIONS(2722),
    [anon_sym_public] = ACTIONS(2722),
    [anon_sym_private] = ACTIONS(2722),
    [anon_sym_protected] = ACTIONS(2722),
    [anon_sym_override] = ACTIONS(2722),
    [anon_sym_module] = ACTIONS(2722),
    [anon_sym_any] = ACTIONS(2722),
    [anon_sym_number] = ACTIONS(2722),
    [anon_sym_boolean] = ACTIONS(2722),
    [anon_sym_string] = ACTIONS(2722),
    [anon_sym_symbol] = ACTIONS(2722),
    [anon_sym_abstract] = ACTIONS(2722),
    [anon_sym_interface] = ACTIONS(2722),
    [anon_sym_enum] = ACTIONS(2722),
    [anon_sym_component] = ACTIONS(2722),
  },
  [732] = {
    [sym_identifier] = ACTIONS(2726),
    [anon_sym_export] = ACTIONS(2726),
    [anon_sym_LBRACE] = ACTIONS(2728),
    [anon_sym_RBRACE] = ACTIONS(2728),
    [anon_sym_type] = ACTIONS(2726),
    [anon_sym_typeof] = ACTIONS(2726),
    [anon_sym_import] = ACTIONS(2726),
    [anon_sym_var] = ACTIONS(2726),
    [anon_sym_let] = ACTIONS(2726),
    [anon_sym_const] = ACTIONS(2726),
    [anon_sym_BANG] = ACTIONS(2728),
    [anon_sym_else] = ACTIONS(2726),
    [anon_sym_if] = ACTIONS(2726),
    [anon_sym_switch] = ACTIONS(2726),
    [anon_sym_for] = ACTIONS(2726),
    [anon_sym_LPAREN] = ACTIONS(2728),
    [anon_sym_await] = ACTIONS(2726),
    [anon_sym_while] = ACTIONS(2726),
    [anon_sym_do] = ACTIONS(2726),
    [anon_sym_try] = ACTIONS(2726),
    [anon_sym_with] = ACTIONS(2726),
    [anon_sym_break] = ACTIONS(2726),
    [anon_sym_continue] = ACTIONS(2726),
    [anon_sym_debugger] = ACTIONS(2726),
    [anon_sym_return] = ACTIONS(2726),
    [anon_sym_throw] = ACTIONS(2726),
    [anon_sym_SEMI] = ACTIONS(2728),
    [anon_sym_case] = ACTIONS(2726),
    [anon_sym_default] = ACTIONS(2726),
    [anon_sym_yield] = ACTIONS(2726),
    [anon_sym_LBRACK] = ACTIONS(2728),
    [anon_sym_LTtemplate_GT] = ACTIONS(2728),
    [anon_sym_LT] = ACTIONS(2726),
    [anon_sym_SLASH] = ACTIONS(2726),
    [anon_sym_class] = ACTIONS(2726),
    [anon_sym_async] = ACTIONS(2726),
    [anon_sym_function] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2726),
    [anon_sym_AMP] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2726),
    [anon_sym_DASH] = ACTIONS(2726),
    [anon_sym_TILDE] = ACTIONS(2728),
    [anon_sym_void] = ACTIONS(2726),
    [anon_sym_delete] = ACTIONS(2726),
    [anon_sym_PLUS_PLUS] = ACTIONS(2728),
    [anon_sym_DASH_DASH] = ACTIONS(2728),
    [anon_sym_DQUOTE] = ACTIONS(2728),
    [anon_sym_SQUOTE] = ACTIONS(2728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2728),
    [sym_number] = ACTIONS(2728),
    [sym_this] = ACTIONS(2726),
    [sym_super] = ACTIONS(2726),
    [sym_true] = ACTIONS(2726),
    [sym_false] = ACTIONS(2726),
    [sym_null] = ACTIONS(2726),
    [sym_undefined] = ACTIONS(2726),
    [anon_sym_AT] = ACTIONS(2728),
    [anon_sym_static] = ACTIONS(2726),
    [anon_sym_readonly] = ACTIONS(2726),
    [anon_sym_get] = ACTIONS(2726),
    [anon_sym_set] = ACTIONS(2726),
    [anon_sym_declare] = ACTIONS(2726),
    [anon_sym_namespace] = ACTIONS(2726),
    [anon_sym_public] = ACTIONS(2726),
    [anon_sym_private] = ACTIONS(2726),
    [anon_sym_protected] = ACTIONS(2726),
    [anon_sym_override] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2726),
    [anon_sym_any] = ACTIONS(2726),
    [anon_sym_number] = ACTIONS(2726),
    [anon_sym_boolean] = ACTIONS(2726),
    [anon_sym_string] = ACTIONS(2726),
    [anon_sym_symbol] = ACTIONS(2726),
    [anon_sym_abstract] = ACTIONS(2726),
    [anon_sym_interface] = ACTIONS(2726),
    [anon_sym_enum] = ACTIONS(2726),
    [anon_sym_component] = ACTIONS(2726),
  },
  [733] = {
    [sym_identifier] = ACTIONS(2730),
    [anon_sym_export] = ACTIONS(2730),
    [anon_sym_LBRACE] = ACTIONS(2732),
    [anon_sym_RBRACE] = ACTIONS(2732),
    [anon_sym_type] = ACTIONS(2730),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_import] = ACTIONS(2730),
    [anon_sym_var] = ACTIONS(2730),
    [anon_sym_let] = ACTIONS(2730),
    [anon_sym_const] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_else] = ACTIONS(2730),
    [anon_sym_if] = ACTIONS(2730),
    [anon_sym_switch] = ACTIONS(2730),
    [anon_sym_for] = ACTIONS(2730),
    [anon_sym_LPAREN] = ACTIONS(2732),
    [anon_sym_await] = ACTIONS(2730),
    [anon_sym_while] = ACTIONS(2730),
    [anon_sym_do] = ACTIONS(2730),
    [anon_sym_try] = ACTIONS(2730),
    [anon_sym_with] = ACTIONS(2730),
    [anon_sym_break] = ACTIONS(2730),
    [anon_sym_continue] = ACTIONS(2730),
    [anon_sym_debugger] = ACTIONS(2730),
    [anon_sym_return] = ACTIONS(2730),
    [anon_sym_throw] = ACTIONS(2730),
    [anon_sym_SEMI] = ACTIONS(2732),
    [anon_sym_case] = ACTIONS(2730),
    [anon_sym_default] = ACTIONS(2730),
    [anon_sym_yield] = ACTIONS(2730),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_LTtemplate_GT] = ACTIONS(2732),
    [anon_sym_LT] = ACTIONS(2730),
    [anon_sym_SLASH] = ACTIONS(2730),
    [anon_sym_class] = ACTIONS(2730),
    [anon_sym_async] = ACTIONS(2730),
    [anon_sym_function] = ACTIONS(2730),
    [anon_sym_new] = ACTIONS(2730),
    [anon_sym_AMP] = ACTIONS(2732),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2732),
    [anon_sym_DASH_DASH] = ACTIONS(2732),
    [anon_sym_DQUOTE] = ACTIONS(2732),
    [anon_sym_SQUOTE] = ACTIONS(2732),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2732),
    [sym_number] = ACTIONS(2732),
    [sym_this] = ACTIONS(2730),
    [sym_super] = ACTIONS(2730),
    [sym_true] = ACTIONS(2730),
    [sym_false] = ACTIONS(2730),
    [sym_null] = ACTIONS(2730),
    [sym_undefined] = ACTIONS(2730),
    [anon_sym_AT] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(2730),
    [anon_sym_readonly] = ACTIONS(2730),
    [anon_sym_get] = ACTIONS(2730),
    [anon_sym_set] = ACTIONS(2730),
    [anon_sym_declare] = ACTIONS(2730),
    [anon_sym_namespace] = ACTIONS(2730),
    [anon_sym_public] = ACTIONS(2730),
    [anon_sym_private] = ACTIONS(2730),
    [anon_sym_protected] = ACTIONS(2730),
    [anon_sym_override] = ACTIONS(2730),
    [anon_sym_module] = ACTIONS(2730),
    [anon_sym_any] = ACTIONS(2730),
    [anon_sym_number] = ACTIONS(2730),
    [anon_sym_boolean] = ACTIONS(2730),
    [anon_sym_string] = ACTIONS(2730),
    [anon_sym_symbol] = ACTIONS(2730),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_interface] = ACTIONS(2730),
    [anon_sym_enum] = ACTIONS(2730),
    [anon_sym_component] = ACTIONS(2730),
  },
  [734] = {
    [sym_identifier] = ACTIONS(2734),
    [anon_sym_export] = ACTIONS(2734),
    [anon_sym_LBRACE] = ACTIONS(2736),
    [anon_sym_RBRACE] = ACTIONS(2736),
    [anon_sym_type] = ACTIONS(2734),
    [anon_sym_typeof] = ACTIONS(2734),
    [anon_sym_import] = ACTIONS(2734),
    [anon_sym_var] = ACTIONS(2734),
    [anon_sym_let] = ACTIONS(2734),
    [anon_sym_const] = ACTIONS(2734),
    [anon_sym_BANG] = ACTIONS(2736),
    [anon_sym_else] = ACTIONS(2734),
    [anon_sym_if] = ACTIONS(2734),
    [anon_sym_switch] = ACTIONS(2734),
    [anon_sym_for] = ACTIONS(2734),
    [anon_sym_LPAREN] = ACTIONS(2736),
    [anon_sym_await] = ACTIONS(2734),
    [anon_sym_while] = ACTIONS(2734),
    [anon_sym_do] = ACTIONS(2734),
    [anon_sym_try] = ACTIONS(2734),
    [anon_sym_with] = ACTIONS(2734),
    [anon_sym_break] = ACTIONS(2734),
    [anon_sym_continue] = ACTIONS(2734),
    [anon_sym_debugger] = ACTIONS(2734),
    [anon_sym_return] = ACTIONS(2734),
    [anon_sym_throw] = ACTIONS(2734),
    [anon_sym_SEMI] = ACTIONS(2736),
    [anon_sym_case] = ACTIONS(2734),
    [anon_sym_default] = ACTIONS(2734),
    [anon_sym_yield] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2736),
    [anon_sym_LTtemplate_GT] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2734),
    [anon_sym_class] = ACTIONS(2734),
    [anon_sym_async] = ACTIONS(2734),
    [anon_sym_function] = ACTIONS(2734),
    [anon_sym_new] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2736),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_TILDE] = ACTIONS(2736),
    [anon_sym_void] = ACTIONS(2734),
    [anon_sym_delete] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(2736),
    [anon_sym_DASH_DASH] = ACTIONS(2736),
    [anon_sym_DQUOTE] = ACTIONS(2736),
    [anon_sym_SQUOTE] = ACTIONS(2736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2736),
    [sym_number] = ACTIONS(2736),
    [sym_this] = ACTIONS(2734),
    [sym_super] = ACTIONS(2734),
    [sym_true] = ACTIONS(2734),
    [sym_false] = ACTIONS(2734),
    [sym_null] = ACTIONS(2734),
    [sym_undefined] = ACTIONS(2734),
    [anon_sym_AT] = ACTIONS(2736),
    [anon_sym_static] = ACTIONS(2734),
    [anon_sym_readonly] = ACTIONS(2734),
    [anon_sym_get] = ACTIONS(2734),
    [anon_sym_set] = ACTIONS(2734),
    [anon_sym_declare] = ACTIONS(2734),
    [anon_sym_namespace] = ACTIONS(2734),
    [anon_sym_public] = ACTIONS(2734),
    [anon_sym_private] = ACTIONS(2734),
    [anon_sym_protected] = ACTIONS(2734),
    [anon_sym_override] = ACTIONS(2734),
    [anon_sym_module] = ACTIONS(2734),
    [anon_sym_any] = ACTIONS(2734),
    [anon_sym_number] = ACTIONS(2734),
    [anon_sym_boolean] = ACTIONS(2734),
    [anon_sym_string] = ACTIONS(2734),
    [anon_sym_symbol] = ACTIONS(2734),
    [anon_sym_abstract] = ACTIONS(2734),
    [anon_sym_interface] = ACTIONS(2734),
    [anon_sym_enum] = ACTIONS(2734),
    [anon_sym_component] = ACTIONS(2734),
  },
  [735] = {
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_export] = ACTIONS(2738),
    [anon_sym_LBRACE] = ACTIONS(2740),
    [anon_sym_RBRACE] = ACTIONS(2740),
    [anon_sym_type] = ACTIONS(2738),
    [anon_sym_typeof] = ACTIONS(2738),
    [anon_sym_import] = ACTIONS(2738),
    [anon_sym_var] = ACTIONS(2738),
    [anon_sym_let] = ACTIONS(2738),
    [anon_sym_const] = ACTIONS(2738),
    [anon_sym_BANG] = ACTIONS(2740),
    [anon_sym_else] = ACTIONS(2738),
    [anon_sym_if] = ACTIONS(2738),
    [anon_sym_switch] = ACTIONS(2738),
    [anon_sym_for] = ACTIONS(2738),
    [anon_sym_LPAREN] = ACTIONS(2740),
    [anon_sym_await] = ACTIONS(2738),
    [anon_sym_while] = ACTIONS(2738),
    [anon_sym_do] = ACTIONS(2738),
    [anon_sym_try] = ACTIONS(2738),
    [anon_sym_with] = ACTIONS(2738),
    [anon_sym_break] = ACTIONS(2738),
    [anon_sym_continue] = ACTIONS(2738),
    [anon_sym_debugger] = ACTIONS(2738),
    [anon_sym_return] = ACTIONS(2738),
    [anon_sym_throw] = ACTIONS(2738),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym_case] = ACTIONS(2738),
    [anon_sym_default] = ACTIONS(2738),
    [anon_sym_yield] = ACTIONS(2738),
    [anon_sym_LBRACK] = ACTIONS(2740),
    [anon_sym_LTtemplate_GT] = ACTIONS(2740),
    [anon_sym_LT] = ACTIONS(2738),
    [anon_sym_SLASH] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2738),
    [anon_sym_async] = ACTIONS(2738),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_new] = ACTIONS(2738),
    [anon_sym_AMP] = ACTIONS(2740),
    [anon_sym_PLUS] = ACTIONS(2738),
    [anon_sym_DASH] = ACTIONS(2738),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_void] = ACTIONS(2738),
    [anon_sym_delete] = ACTIONS(2738),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_DQUOTE] = ACTIONS(2740),
    [anon_sym_SQUOTE] = ACTIONS(2740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2740),
    [sym_number] = ACTIONS(2740),
    [sym_this] = ACTIONS(2738),
    [sym_super] = ACTIONS(2738),
    [sym_true] = ACTIONS(2738),
    [sym_false] = ACTIONS(2738),
    [sym_null] = ACTIONS(2738),
    [sym_undefined] = ACTIONS(2738),
    [anon_sym_AT] = ACTIONS(2740),
    [anon_sym_static] = ACTIONS(2738),
    [anon_sym_readonly] = ACTIONS(2738),
    [anon_sym_get] = ACTIONS(2738),
    [anon_sym_set] = ACTIONS(2738),
    [anon_sym_declare] = ACTIONS(2738),
    [anon_sym_namespace] = ACTIONS(2738),
    [anon_sym_public] = ACTIONS(2738),
    [anon_sym_private] = ACTIONS(2738),
    [anon_sym_protected] = ACTIONS(2738),
    [anon_sym_override] = ACTIONS(2738),
    [anon_sym_module] = ACTIONS(2738),
    [anon_sym_any] = ACTIONS(2738),
    [anon_sym_number] = ACTIONS(2738),
    [anon_sym_boolean] = ACTIONS(2738),
    [anon_sym_string] = ACTIONS(2738),
    [anon_sym_symbol] = ACTIONS(2738),
    [anon_sym_abstract] = ACTIONS(2738),
    [anon_sym_interface] = ACTIONS(2738),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_component] = ACTIONS(2738),
  },
  [736] = {
    [sym_identifier] = ACTIONS(2742),
    [anon_sym_export] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(2744),
    [anon_sym_RBRACE] = ACTIONS(2744),
    [anon_sym_type] = ACTIONS(2742),
    [anon_sym_typeof] = ACTIONS(2742),
    [anon_sym_import] = ACTIONS(2742),
    [anon_sym_var] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2742),
    [anon_sym_const] = ACTIONS(2742),
    [anon_sym_BANG] = ACTIONS(2744),
    [anon_sym_else] = ACTIONS(2742),
    [anon_sym_if] = ACTIONS(2742),
    [anon_sym_switch] = ACTIONS(2742),
    [anon_sym_for] = ACTIONS(2742),
    [anon_sym_LPAREN] = ACTIONS(2744),
    [anon_sym_await] = ACTIONS(2742),
    [anon_sym_while] = ACTIONS(2742),
    [anon_sym_do] = ACTIONS(2742),
    [anon_sym_try] = ACTIONS(2742),
    [anon_sym_with] = ACTIONS(2742),
    [anon_sym_break] = ACTIONS(2742),
    [anon_sym_continue] = ACTIONS(2742),
    [anon_sym_debugger] = ACTIONS(2742),
    [anon_sym_return] = ACTIONS(2742),
    [anon_sym_throw] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2744),
    [anon_sym_case] = ACTIONS(2742),
    [anon_sym_default] = ACTIONS(2742),
    [anon_sym_yield] = ACTIONS(2742),
    [anon_sym_LBRACK] = ACTIONS(2744),
    [anon_sym_LTtemplate_GT] = ACTIONS(2744),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_SLASH] = ACTIONS(2742),
    [anon_sym_class] = ACTIONS(2742),
    [anon_sym_async] = ACTIONS(2742),
    [anon_sym_function] = ACTIONS(2742),
    [anon_sym_new] = ACTIONS(2742),
    [anon_sym_AMP] = ACTIONS(2744),
    [anon_sym_PLUS] = ACTIONS(2742),
    [anon_sym_DASH] = ACTIONS(2742),
    [anon_sym_TILDE] = ACTIONS(2744),
    [anon_sym_void] = ACTIONS(2742),
    [anon_sym_delete] = ACTIONS(2742),
    [anon_sym_PLUS_PLUS] = ACTIONS(2744),
    [anon_sym_DASH_DASH] = ACTIONS(2744),
    [anon_sym_DQUOTE] = ACTIONS(2744),
    [anon_sym_SQUOTE] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2744),
    [sym_number] = ACTIONS(2744),
    [sym_this] = ACTIONS(2742),
    [sym_super] = ACTIONS(2742),
    [sym_true] = ACTIONS(2742),
    [sym_false] = ACTIONS(2742),
    [sym_null] = ACTIONS(2742),
    [sym_undefined] = ACTIONS(2742),
    [anon_sym_AT] = ACTIONS(2744),
    [anon_sym_static] = ACTIONS(2742),
    [anon_sym_readonly] = ACTIONS(2742),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
    [anon_sym_declare] = ACTIONS(2742),
    [anon_sym_namespace] = ACTIONS(2742),
    [anon_sym_public] = ACTIONS(2742),
    [anon_sym_private] = ACTIONS(2742),
    [anon_sym_protected] = ACTIONS(2742),
    [anon_sym_override] = ACTIONS(2742),
    [anon_sym_module] = ACTIONS(2742),
    [anon_sym_any] = ACTIONS(2742),
    [anon_sym_number] = ACTIONS(2742),
    [anon_sym_boolean] = ACTIONS(2742),
    [anon_sym_string] = ACTIONS(2742),
    [anon_sym_symbol] = ACTIONS(2742),
    [anon_sym_abstract] = ACTIONS(2742),
    [anon_sym_interface] = ACTIONS(2742),
    [anon_sym_enum] = ACTIONS(2742),
    [anon_sym_component] = ACTIONS(2742),
  },
  [737] = {
    [sym_identifier] = ACTIONS(2746),
    [anon_sym_export] = ACTIONS(2746),
    [anon_sym_LBRACE] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(2748),
    [anon_sym_type] = ACTIONS(2746),
    [anon_sym_typeof] = ACTIONS(2746),
    [anon_sym_import] = ACTIONS(2746),
    [anon_sym_var] = ACTIONS(2746),
    [anon_sym_let] = ACTIONS(2746),
    [anon_sym_const] = ACTIONS(2746),
    [anon_sym_BANG] = ACTIONS(2748),
    [anon_sym_else] = ACTIONS(2746),
    [anon_sym_if] = ACTIONS(2746),
    [anon_sym_switch] = ACTIONS(2746),
    [anon_sym_for] = ACTIONS(2746),
    [anon_sym_LPAREN] = ACTIONS(2748),
    [anon_sym_await] = ACTIONS(2746),
    [anon_sym_while] = ACTIONS(2746),
    [anon_sym_do] = ACTIONS(2746),
    [anon_sym_try] = ACTIONS(2746),
    [anon_sym_with] = ACTIONS(2746),
    [anon_sym_break] = ACTIONS(2746),
    [anon_sym_continue] = ACTIONS(2746),
    [anon_sym_debugger] = ACTIONS(2746),
    [anon_sym_return] = ACTIONS(2746),
    [anon_sym_throw] = ACTIONS(2746),
    [anon_sym_SEMI] = ACTIONS(2748),
    [anon_sym_case] = ACTIONS(2746),
    [anon_sym_default] = ACTIONS(2746),
    [anon_sym_yield] = ACTIONS(2746),
    [anon_sym_LBRACK] = ACTIONS(2748),
    [anon_sym_LTtemplate_GT] = ACTIONS(2748),
    [anon_sym_LT] = ACTIONS(2746),
    [anon_sym_SLASH] = ACTIONS(2746),
    [anon_sym_class] = ACTIONS(2746),
    [anon_sym_async] = ACTIONS(2746),
    [anon_sym_function] = ACTIONS(2746),
    [anon_sym_new] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(2748),
    [anon_sym_PLUS] = ACTIONS(2746),
    [anon_sym_DASH] = ACTIONS(2746),
    [anon_sym_TILDE] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(2746),
    [anon_sym_delete] = ACTIONS(2746),
    [anon_sym_PLUS_PLUS] = ACTIONS(2748),
    [anon_sym_DASH_DASH] = ACTIONS(2748),
    [anon_sym_DQUOTE] = ACTIONS(2748),
    [anon_sym_SQUOTE] = ACTIONS(2748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2748),
    [sym_number] = ACTIONS(2748),
    [sym_this] = ACTIONS(2746),
    [sym_super] = ACTIONS(2746),
    [sym_true] = ACTIONS(2746),
    [sym_false] = ACTIONS(2746),
    [sym_null] = ACTIONS(2746),
    [sym_undefined] = ACTIONS(2746),
    [anon_sym_AT] = ACTIONS(2748),
    [anon_sym_static] = ACTIONS(2746),
    [anon_sym_readonly] = ACTIONS(2746),
    [anon_sym_get] = ACTIONS(2746),
    [anon_sym_set] = ACTIONS(2746),
    [anon_sym_declare] = ACTIONS(2746),
    [anon_sym_namespace] = ACTIONS(2746),
    [anon_sym_public] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2746),
    [anon_sym_protected] = ACTIONS(2746),
    [anon_sym_override] = ACTIONS(2746),
    [anon_sym_module] = ACTIONS(2746),
    [anon_sym_any] = ACTIONS(2746),
    [anon_sym_number] = ACTIONS(2746),
    [anon_sym_boolean] = ACTIONS(2746),
    [anon_sym_string] = ACTIONS(2746),
    [anon_sym_symbol] = ACTIONS(2746),
    [anon_sym_abstract] = ACTIONS(2746),
    [anon_sym_interface] = ACTIONS(2746),
    [anon_sym_enum] = ACTIONS(2746),
    [anon_sym_component] = ACTIONS(2746),
  },
  [738] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2698),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2698),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2698),
    [anon_sym_GT_GT_GT] = ACTIONS(2700),
    [anon_sym_LT_LT] = ACTIONS(2700),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2700),
    [anon_sym_EQ_EQ] = ACTIONS(2698),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2700),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2700),
    [anon_sym_GT_EQ] = ACTIONS(2700),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(2698),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_get] = ACTIONS(2698),
    [anon_sym_set] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_constructor] = ACTIONS(2698),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [739] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_get] = ACTIONS(2698),
    [anon_sym_set] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_constructor] = ACTIONS(2698),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [740] = {
    [sym_identifier] = ACTIONS(2750),
    [anon_sym_export] = ACTIONS(2750),
    [anon_sym_LBRACE] = ACTIONS(2752),
    [anon_sym_RBRACE] = ACTIONS(2752),
    [anon_sym_type] = ACTIONS(2750),
    [anon_sym_typeof] = ACTIONS(2750),
    [anon_sym_import] = ACTIONS(2750),
    [anon_sym_var] = ACTIONS(2750),
    [anon_sym_let] = ACTIONS(2750),
    [anon_sym_const] = ACTIONS(2750),
    [anon_sym_BANG] = ACTIONS(2752),
    [anon_sym_else] = ACTIONS(2750),
    [anon_sym_if] = ACTIONS(2750),
    [anon_sym_switch] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2752),
    [anon_sym_await] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2750),
    [anon_sym_do] = ACTIONS(2750),
    [anon_sym_try] = ACTIONS(2750),
    [anon_sym_with] = ACTIONS(2750),
    [anon_sym_break] = ACTIONS(2750),
    [anon_sym_continue] = ACTIONS(2750),
    [anon_sym_debugger] = ACTIONS(2750),
    [anon_sym_return] = ACTIONS(2750),
    [anon_sym_throw] = ACTIONS(2750),
    [anon_sym_SEMI] = ACTIONS(2752),
    [anon_sym_case] = ACTIONS(2750),
    [anon_sym_default] = ACTIONS(2750),
    [anon_sym_yield] = ACTIONS(2750),
    [anon_sym_LBRACK] = ACTIONS(2752),
    [anon_sym_LTtemplate_GT] = ACTIONS(2752),
    [anon_sym_LT] = ACTIONS(2750),
    [anon_sym_SLASH] = ACTIONS(2750),
    [anon_sym_class] = ACTIONS(2750),
    [anon_sym_async] = ACTIONS(2750),
    [anon_sym_function] = ACTIONS(2750),
    [anon_sym_new] = ACTIONS(2750),
    [anon_sym_AMP] = ACTIONS(2752),
    [anon_sym_PLUS] = ACTIONS(2750),
    [anon_sym_DASH] = ACTIONS(2750),
    [anon_sym_TILDE] = ACTIONS(2752),
    [anon_sym_void] = ACTIONS(2750),
    [anon_sym_delete] = ACTIONS(2750),
    [anon_sym_PLUS_PLUS] = ACTIONS(2752),
    [anon_sym_DASH_DASH] = ACTIONS(2752),
    [anon_sym_DQUOTE] = ACTIONS(2752),
    [anon_sym_SQUOTE] = ACTIONS(2752),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2752),
    [sym_number] = ACTIONS(2752),
    [sym_this] = ACTIONS(2750),
    [sym_super] = ACTIONS(2750),
    [sym_true] = ACTIONS(2750),
    [sym_false] = ACTIONS(2750),
    [sym_null] = ACTIONS(2750),
    [sym_undefined] = ACTIONS(2750),
    [anon_sym_AT] = ACTIONS(2752),
    [anon_sym_static] = ACTIONS(2750),
    [anon_sym_readonly] = ACTIONS(2750),
    [anon_sym_get] = ACTIONS(2750),
    [anon_sym_set] = ACTIONS(2750),
    [anon_sym_declare] = ACTIONS(2750),
    [anon_sym_namespace] = ACTIONS(2750),
    [anon_sym_public] = ACTIONS(2750),
    [anon_sym_private] = ACTIONS(2750),
    [anon_sym_protected] = ACTIONS(2750),
    [anon_sym_override] = ACTIONS(2750),
    [anon_sym_module] = ACTIONS(2750),
    [anon_sym_any] = ACTIONS(2750),
    [anon_sym_number] = ACTIONS(2750),
    [anon_sym_boolean] = ACTIONS(2750),
    [anon_sym_string] = ACTIONS(2750),
    [anon_sym_symbol] = ACTIONS(2750),
    [anon_sym_abstract] = ACTIONS(2750),
    [anon_sym_interface] = ACTIONS(2750),
    [anon_sym_enum] = ACTIONS(2750),
    [anon_sym_component] = ACTIONS(2750),
  },
  [741] = {
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LTtemplate_GT] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_readonly] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_override] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_component] = ACTIONS(2604),
  },
  [742] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_get] = ACTIONS(2698),
    [anon_sym_set] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_constructor] = ACTIONS(2698),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [743] = {
    [sym_identifier] = ACTIONS(2754),
    [anon_sym_export] = ACTIONS(2754),
    [anon_sym_LBRACE] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(2756),
    [anon_sym_type] = ACTIONS(2754),
    [anon_sym_typeof] = ACTIONS(2754),
    [anon_sym_import] = ACTIONS(2754),
    [anon_sym_var] = ACTIONS(2754),
    [anon_sym_let] = ACTIONS(2754),
    [anon_sym_const] = ACTIONS(2754),
    [anon_sym_BANG] = ACTIONS(2756),
    [anon_sym_else] = ACTIONS(2754),
    [anon_sym_if] = ACTIONS(2754),
    [anon_sym_switch] = ACTIONS(2754),
    [anon_sym_for] = ACTIONS(2754),
    [anon_sym_LPAREN] = ACTIONS(2756),
    [anon_sym_await] = ACTIONS(2754),
    [anon_sym_while] = ACTIONS(2754),
    [anon_sym_do] = ACTIONS(2754),
    [anon_sym_try] = ACTIONS(2754),
    [anon_sym_with] = ACTIONS(2754),
    [anon_sym_break] = ACTIONS(2754),
    [anon_sym_continue] = ACTIONS(2754),
    [anon_sym_debugger] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2754),
    [anon_sym_throw] = ACTIONS(2754),
    [anon_sym_SEMI] = ACTIONS(2756),
    [anon_sym_case] = ACTIONS(2754),
    [anon_sym_default] = ACTIONS(2754),
    [anon_sym_yield] = ACTIONS(2754),
    [anon_sym_LBRACK] = ACTIONS(2756),
    [anon_sym_LTtemplate_GT] = ACTIONS(2756),
    [anon_sym_LT] = ACTIONS(2754),
    [anon_sym_SLASH] = ACTIONS(2754),
    [anon_sym_class] = ACTIONS(2754),
    [anon_sym_async] = ACTIONS(2754),
    [anon_sym_function] = ACTIONS(2754),
    [anon_sym_new] = ACTIONS(2754),
    [anon_sym_AMP] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2754),
    [anon_sym_DASH] = ACTIONS(2754),
    [anon_sym_TILDE] = ACTIONS(2756),
    [anon_sym_void] = ACTIONS(2754),
    [anon_sym_delete] = ACTIONS(2754),
    [anon_sym_PLUS_PLUS] = ACTIONS(2756),
    [anon_sym_DASH_DASH] = ACTIONS(2756),
    [anon_sym_DQUOTE] = ACTIONS(2756),
    [anon_sym_SQUOTE] = ACTIONS(2756),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2756),
    [sym_number] = ACTIONS(2756),
    [sym_this] = ACTIONS(2754),
    [sym_super] = ACTIONS(2754),
    [sym_true] = ACTIONS(2754),
    [sym_false] = ACTIONS(2754),
    [sym_null] = ACTIONS(2754),
    [sym_undefined] = ACTIONS(2754),
    [anon_sym_AT] = ACTIONS(2756),
    [anon_sym_static] = ACTIONS(2754),
    [anon_sym_readonly] = ACTIONS(2754),
    [anon_sym_get] = ACTIONS(2754),
    [anon_sym_set] = ACTIONS(2754),
    [anon_sym_declare] = ACTIONS(2754),
    [anon_sym_namespace] = ACTIONS(2754),
    [anon_sym_public] = ACTIONS(2754),
    [anon_sym_private] = ACTIONS(2754),
    [anon_sym_protected] = ACTIONS(2754),
    [anon_sym_override] = ACTIONS(2754),
    [anon_sym_module] = ACTIONS(2754),
    [anon_sym_any] = ACTIONS(2754),
    [anon_sym_number] = ACTIONS(2754),
    [anon_sym_boolean] = ACTIONS(2754),
    [anon_sym_string] = ACTIONS(2754),
    [anon_sym_symbol] = ACTIONS(2754),
    [anon_sym_abstract] = ACTIONS(2754),
    [anon_sym_interface] = ACTIONS(2754),
    [anon_sym_enum] = ACTIONS(2754),
    [anon_sym_component] = ACTIONS(2754),
  },
  [744] = {
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LTtemplate_GT] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_readonly] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_override] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_component] = ACTIONS(2604),
  },
  [745] = {
    [sym_identifier] = ACTIONS(2758),
    [anon_sym_export] = ACTIONS(2758),
    [anon_sym_LBRACE] = ACTIONS(2760),
    [anon_sym_RBRACE] = ACTIONS(2760),
    [anon_sym_type] = ACTIONS(2758),
    [anon_sym_typeof] = ACTIONS(2758),
    [anon_sym_import] = ACTIONS(2758),
    [anon_sym_var] = ACTIONS(2758),
    [anon_sym_let] = ACTIONS(2758),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_BANG] = ACTIONS(2760),
    [anon_sym_else] = ACTIONS(2758),
    [anon_sym_if] = ACTIONS(2758),
    [anon_sym_switch] = ACTIONS(2758),
    [anon_sym_for] = ACTIONS(2758),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_await] = ACTIONS(2758),
    [anon_sym_while] = ACTIONS(2758),
    [anon_sym_do] = ACTIONS(2758),
    [anon_sym_try] = ACTIONS(2758),
    [anon_sym_with] = ACTIONS(2758),
    [anon_sym_break] = ACTIONS(2758),
    [anon_sym_continue] = ACTIONS(2758),
    [anon_sym_debugger] = ACTIONS(2758),
    [anon_sym_return] = ACTIONS(2758),
    [anon_sym_throw] = ACTIONS(2758),
    [anon_sym_SEMI] = ACTIONS(2760),
    [anon_sym_case] = ACTIONS(2758),
    [anon_sym_default] = ACTIONS(2758),
    [anon_sym_yield] = ACTIONS(2758),
    [anon_sym_LBRACK] = ACTIONS(2760),
    [anon_sym_LTtemplate_GT] = ACTIONS(2760),
    [anon_sym_LT] = ACTIONS(2758),
    [anon_sym_SLASH] = ACTIONS(2758),
    [anon_sym_class] = ACTIONS(2758),
    [anon_sym_async] = ACTIONS(2758),
    [anon_sym_function] = ACTIONS(2758),
    [anon_sym_new] = ACTIONS(2758),
    [anon_sym_AMP] = ACTIONS(2760),
    [anon_sym_PLUS] = ACTIONS(2758),
    [anon_sym_DASH] = ACTIONS(2758),
    [anon_sym_TILDE] = ACTIONS(2760),
    [anon_sym_void] = ACTIONS(2758),
    [anon_sym_delete] = ACTIONS(2758),
    [anon_sym_PLUS_PLUS] = ACTIONS(2760),
    [anon_sym_DASH_DASH] = ACTIONS(2760),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_SQUOTE] = ACTIONS(2760),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2760),
    [sym_number] = ACTIONS(2760),
    [sym_this] = ACTIONS(2758),
    [sym_super] = ACTIONS(2758),
    [sym_true] = ACTIONS(2758),
    [sym_false] = ACTIONS(2758),
    [sym_null] = ACTIONS(2758),
    [sym_undefined] = ACTIONS(2758),
    [anon_sym_AT] = ACTIONS(2760),
    [anon_sym_static] = ACTIONS(2758),
    [anon_sym_readonly] = ACTIONS(2758),
    [anon_sym_get] = ACTIONS(2758),
    [anon_sym_set] = ACTIONS(2758),
    [anon_sym_declare] = ACTIONS(2758),
    [anon_sym_namespace] = ACTIONS(2758),
    [anon_sym_public] = ACTIONS(2758),
    [anon_sym_private] = ACTIONS(2758),
    [anon_sym_protected] = ACTIONS(2758),
    [anon_sym_override] = ACTIONS(2758),
    [anon_sym_module] = ACTIONS(2758),
    [anon_sym_any] = ACTIONS(2758),
    [anon_sym_number] = ACTIONS(2758),
    [anon_sym_boolean] = ACTIONS(2758),
    [anon_sym_string] = ACTIONS(2758),
    [anon_sym_symbol] = ACTIONS(2758),
    [anon_sym_abstract] = ACTIONS(2758),
    [anon_sym_interface] = ACTIONS(2758),
    [anon_sym_enum] = ACTIONS(2758),
    [anon_sym_component] = ACTIONS(2758),
  },
  [746] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_get] = ACTIONS(2698),
    [anon_sym_set] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_constructor] = ACTIONS(2698),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [747] = {
    [sym_type_arguments] = STATE(970),
    [sym_identifier] = ACTIONS(2588),
    [anon_sym_STAR] = ACTIONS(2588),
    [anon_sym_as] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2588),
    [anon_sym_RBRACE] = ACTIONS(2590),
    [anon_sym_typeof] = ACTIONS(2588),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2590),
    [anon_sym_in] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2560),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_SLASH] = ACTIONS(2588),
    [anon_sym_DOT] = ACTIONS(2592),
    [anon_sym_async] = ACTIONS(2588),
    [anon_sym_QMARK_DOT] = ACTIONS(2590),
    [anon_sym_new] = ACTIONS(2588),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2588),
    [anon_sym_GT_GT_GT] = ACTIONS(2590),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2588),
    [anon_sym_CARET] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(2588),
    [anon_sym_PLUS] = ACTIONS(2588),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_PERCENT] = ACTIONS(2590),
    [anon_sym_STAR_STAR] = ACTIONS(2590),
    [anon_sym_LT_EQ] = ACTIONS(2590),
    [anon_sym_EQ_EQ] = ACTIONS(2588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2590),
    [anon_sym_BANG_EQ] = ACTIONS(2588),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2590),
    [anon_sym_GT_EQ] = ACTIONS(2590),
    [anon_sym_QMARK_QMARK] = ACTIONS(2590),
    [anon_sym_instanceof] = ACTIONS(2588),
    [anon_sym_void] = ACTIONS(2588),
    [anon_sym_PLUS_PLUS] = ACTIONS(2590),
    [anon_sym_DASH_DASH] = ACTIONS(2590),
    [anon_sym_DQUOTE] = ACTIONS(2590),
    [anon_sym_SQUOTE] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2590),
    [sym_number] = ACTIONS(2590),
    [sym_this] = ACTIONS(2588),
    [sym_true] = ACTIONS(2588),
    [sym_false] = ACTIONS(2588),
    [sym_null] = ACTIONS(2588),
    [sym_undefined] = ACTIONS(2588),
    [anon_sym_static] = ACTIONS(2588),
    [anon_sym_readonly] = ACTIONS(2588),
    [anon_sym_get] = ACTIONS(2588),
    [anon_sym_set] = ACTIONS(2588),
    [anon_sym_QMARK] = ACTIONS(2588),
    [anon_sym_any] = ACTIONS(2588),
    [anon_sym_number] = ACTIONS(2588),
    [anon_sym_boolean] = ACTIONS(2588),
    [anon_sym_string] = ACTIONS(2588),
    [anon_sym_symbol] = ACTIONS(2588),
    [anon_sym_abstract] = ACTIONS(2588),
    [anon_sym_satisfies] = ACTIONS(2588),
    [anon_sym_extends] = ACTIONS(2588),
    [anon_sym_infer] = ACTIONS(2588),
    [anon_sym_keyof] = ACTIONS(2588),
    [anon_sym_unknown] = ACTIONS(2588),
    [anon_sym_never] = ACTIONS(2588),
    [anon_sym_object] = ACTIONS(2588),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2590),
    [anon_sym_constructor] = ACTIONS(2588),
    [anon_sym_prop] = ACTIONS(2588),
    [anon_sym_id] = ACTIONS(2588),
    [anon_sym_event] = ACTIONS(2588),
    [anon_sym_fn] = ACTIONS(2588),
    [anon_sym_on] = ACTIONS(2588),
    [sym__ternary_qmark] = ACTIONS(2590),
  },
  [748] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2698),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2698),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2698),
    [anon_sym_GT_GT_GT] = ACTIONS(2700),
    [anon_sym_LT_LT] = ACTIONS(2700),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2700),
    [anon_sym_EQ_EQ] = ACTIONS(2698),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2700),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2700),
    [anon_sym_GT_EQ] = ACTIONS(2700),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(2698),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_get] = ACTIONS(2698),
    [anon_sym_set] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_constructor] = ACTIONS(2698),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [749] = {
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LTtemplate_GT] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_readonly] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_override] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_component] = ACTIONS(2604),
  },
  [750] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2762),
    [anon_sym_STAR] = ACTIONS(2762),
    [anon_sym_as] = ACTIONS(2762),
    [anon_sym_LBRACE] = ACTIONS(2762),
    [anon_sym_RBRACE] = ACTIONS(2764),
    [anon_sym_typeof] = ACTIONS(2762),
    [anon_sym_BANG] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2762),
    [anon_sym_SEMI] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_GT] = ACTIONS(2762),
    [anon_sym_SLASH] = ACTIONS(2762),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2762),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2762),
    [anon_sym_AMP_AMP] = ACTIONS(2764),
    [anon_sym_PIPE_PIPE] = ACTIONS(2764),
    [anon_sym_GT_GT] = ACTIONS(2762),
    [anon_sym_GT_GT_GT] = ACTIONS(2764),
    [anon_sym_LT_LT] = ACTIONS(2764),
    [anon_sym_AMP] = ACTIONS(2762),
    [anon_sym_CARET] = ACTIONS(2764),
    [anon_sym_PIPE] = ACTIONS(2762),
    [anon_sym_PLUS] = ACTIONS(2762),
    [anon_sym_DASH] = ACTIONS(2762),
    [anon_sym_PERCENT] = ACTIONS(2764),
    [anon_sym_STAR_STAR] = ACTIONS(2764),
    [anon_sym_LT_EQ] = ACTIONS(2764),
    [anon_sym_EQ_EQ] = ACTIONS(2762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2764),
    [anon_sym_BANG_EQ] = ACTIONS(2762),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2764),
    [anon_sym_GT_EQ] = ACTIONS(2764),
    [anon_sym_QMARK_QMARK] = ACTIONS(2764),
    [anon_sym_instanceof] = ACTIONS(2762),
    [anon_sym_void] = ACTIONS(2762),
    [anon_sym_PLUS_PLUS] = ACTIONS(2764),
    [anon_sym_DASH_DASH] = ACTIONS(2764),
    [anon_sym_DQUOTE] = ACTIONS(2764),
    [anon_sym_SQUOTE] = ACTIONS(2764),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2764),
    [sym_number] = ACTIONS(2764),
    [sym_this] = ACTIONS(2762),
    [sym_true] = ACTIONS(2762),
    [sym_false] = ACTIONS(2762),
    [sym_null] = ACTIONS(2762),
    [sym_undefined] = ACTIONS(2762),
    [anon_sym_static] = ACTIONS(2762),
    [anon_sym_readonly] = ACTIONS(2762),
    [anon_sym_get] = ACTIONS(2762),
    [anon_sym_set] = ACTIONS(2762),
    [anon_sym_QMARK] = ACTIONS(2762),
    [anon_sym_any] = ACTIONS(2762),
    [anon_sym_number] = ACTIONS(2762),
    [anon_sym_boolean] = ACTIONS(2762),
    [anon_sym_string] = ACTIONS(2762),
    [anon_sym_symbol] = ACTIONS(2762),
    [anon_sym_abstract] = ACTIONS(2762),
    [anon_sym_satisfies] = ACTIONS(2762),
    [anon_sym_infer] = ACTIONS(2762),
    [anon_sym_keyof] = ACTIONS(2762),
    [anon_sym_unknown] = ACTIONS(2762),
    [anon_sym_never] = ACTIONS(2762),
    [anon_sym_object] = ACTIONS(2762),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2764),
    [anon_sym_constructor] = ACTIONS(2762),
    [anon_sym_prop] = ACTIONS(2762),
    [anon_sym_id] = ACTIONS(2762),
    [anon_sym_event] = ACTIONS(2762),
    [anon_sym_fn] = ACTIONS(2762),
    [anon_sym_on] = ACTIONS(2762),
    [sym__ternary_qmark] = ACTIONS(2764),
  },
  [751] = {
    [sym_identifier] = ACTIONS(2766),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_LBRACE] = ACTIONS(2768),
    [anon_sym_RBRACE] = ACTIONS(2768),
    [anon_sym_type] = ACTIONS(2766),
    [anon_sym_typeof] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2766),
    [anon_sym_var] = ACTIONS(2766),
    [anon_sym_let] = ACTIONS(2766),
    [anon_sym_const] = ACTIONS(2766),
    [anon_sym_BANG] = ACTIONS(2768),
    [anon_sym_else] = ACTIONS(2766),
    [anon_sym_if] = ACTIONS(2766),
    [anon_sym_switch] = ACTIONS(2766),
    [anon_sym_for] = ACTIONS(2766),
    [anon_sym_LPAREN] = ACTIONS(2768),
    [anon_sym_await] = ACTIONS(2766),
    [anon_sym_while] = ACTIONS(2766),
    [anon_sym_do] = ACTIONS(2766),
    [anon_sym_try] = ACTIONS(2766),
    [anon_sym_with] = ACTIONS(2766),
    [anon_sym_break] = ACTIONS(2766),
    [anon_sym_continue] = ACTIONS(2766),
    [anon_sym_debugger] = ACTIONS(2766),
    [anon_sym_return] = ACTIONS(2766),
    [anon_sym_throw] = ACTIONS(2766),
    [anon_sym_SEMI] = ACTIONS(2768),
    [anon_sym_case] = ACTIONS(2766),
    [anon_sym_default] = ACTIONS(2766),
    [anon_sym_yield] = ACTIONS(2766),
    [anon_sym_LBRACK] = ACTIONS(2768),
    [anon_sym_LTtemplate_GT] = ACTIONS(2768),
    [anon_sym_LT] = ACTIONS(2766),
    [anon_sym_SLASH] = ACTIONS(2766),
    [anon_sym_class] = ACTIONS(2766),
    [anon_sym_async] = ACTIONS(2766),
    [anon_sym_function] = ACTIONS(2766),
    [anon_sym_new] = ACTIONS(2766),
    [anon_sym_AMP] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2766),
    [anon_sym_DASH] = ACTIONS(2766),
    [anon_sym_TILDE] = ACTIONS(2768),
    [anon_sym_void] = ACTIONS(2766),
    [anon_sym_delete] = ACTIONS(2766),
    [anon_sym_PLUS_PLUS] = ACTIONS(2768),
    [anon_sym_DASH_DASH] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2768),
    [anon_sym_SQUOTE] = ACTIONS(2768),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2768),
    [sym_number] = ACTIONS(2768),
    [sym_this] = ACTIONS(2766),
    [sym_super] = ACTIONS(2766),
    [sym_true] = ACTIONS(2766),
    [sym_false] = ACTIONS(2766),
    [sym_null] = ACTIONS(2766),
    [sym_undefined] = ACTIONS(2766),
    [anon_sym_AT] = ACTIONS(2768),
    [anon_sym_static] = ACTIONS(2766),
    [anon_sym_readonly] = ACTIONS(2766),
    [anon_sym_get] = ACTIONS(2766),
    [anon_sym_set] = ACTIONS(2766),
    [anon_sym_declare] = ACTIONS(2766),
    [anon_sym_namespace] = ACTIONS(2766),
    [anon_sym_public] = ACTIONS(2766),
    [anon_sym_private] = ACTIONS(2766),
    [anon_sym_protected] = ACTIONS(2766),
    [anon_sym_override] = ACTIONS(2766),
    [anon_sym_module] = ACTIONS(2766),
    [anon_sym_any] = ACTIONS(2766),
    [anon_sym_number] = ACTIONS(2766),
    [anon_sym_boolean] = ACTIONS(2766),
    [anon_sym_string] = ACTIONS(2766),
    [anon_sym_symbol] = ACTIONS(2766),
    [anon_sym_abstract] = ACTIONS(2766),
    [anon_sym_interface] = ACTIONS(2766),
    [anon_sym_enum] = ACTIONS(2766),
    [anon_sym_component] = ACTIONS(2766),
  },
  [752] = {
    [sym_identifier] = ACTIONS(2770),
    [anon_sym_export] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2772),
    [anon_sym_RBRACE] = ACTIONS(2772),
    [anon_sym_type] = ACTIONS(2770),
    [anon_sym_typeof] = ACTIONS(2770),
    [anon_sym_import] = ACTIONS(2770),
    [anon_sym_var] = ACTIONS(2770),
    [anon_sym_let] = ACTIONS(2770),
    [anon_sym_const] = ACTIONS(2770),
    [anon_sym_BANG] = ACTIONS(2772),
    [anon_sym_else] = ACTIONS(2770),
    [anon_sym_if] = ACTIONS(2770),
    [anon_sym_switch] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2772),
    [anon_sym_await] = ACTIONS(2770),
    [anon_sym_while] = ACTIONS(2770),
    [anon_sym_do] = ACTIONS(2770),
    [anon_sym_try] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2770),
    [anon_sym_break] = ACTIONS(2770),
    [anon_sym_continue] = ACTIONS(2770),
    [anon_sym_debugger] = ACTIONS(2770),
    [anon_sym_return] = ACTIONS(2770),
    [anon_sym_throw] = ACTIONS(2770),
    [anon_sym_SEMI] = ACTIONS(2772),
    [anon_sym_case] = ACTIONS(2770),
    [anon_sym_default] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2770),
    [anon_sym_LBRACK] = ACTIONS(2772),
    [anon_sym_LTtemplate_GT] = ACTIONS(2772),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_SLASH] = ACTIONS(2770),
    [anon_sym_class] = ACTIONS(2770),
    [anon_sym_async] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2772),
    [anon_sym_PLUS] = ACTIONS(2770),
    [anon_sym_DASH] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2772),
    [anon_sym_void] = ACTIONS(2770),
    [anon_sym_delete] = ACTIONS(2770),
    [anon_sym_PLUS_PLUS] = ACTIONS(2772),
    [anon_sym_DASH_DASH] = ACTIONS(2772),
    [anon_sym_DQUOTE] = ACTIONS(2772),
    [anon_sym_SQUOTE] = ACTIONS(2772),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2772),
    [sym_number] = ACTIONS(2772),
    [sym_this] = ACTIONS(2770),
    [sym_super] = ACTIONS(2770),
    [sym_true] = ACTIONS(2770),
    [sym_false] = ACTIONS(2770),
    [sym_null] = ACTIONS(2770),
    [sym_undefined] = ACTIONS(2770),
    [anon_sym_AT] = ACTIONS(2772),
    [anon_sym_static] = ACTIONS(2770),
    [anon_sym_readonly] = ACTIONS(2770),
    [anon_sym_get] = ACTIONS(2770),
    [anon_sym_set] = ACTIONS(2770),
    [anon_sym_declare] = ACTIONS(2770),
    [anon_sym_namespace] = ACTIONS(2770),
    [anon_sym_public] = ACTIONS(2770),
    [anon_sym_private] = ACTIONS(2770),
    [anon_sym_protected] = ACTIONS(2770),
    [anon_sym_override] = ACTIONS(2770),
    [anon_sym_module] = ACTIONS(2770),
    [anon_sym_any] = ACTIONS(2770),
    [anon_sym_number] = ACTIONS(2770),
    [anon_sym_boolean] = ACTIONS(2770),
    [anon_sym_string] = ACTIONS(2770),
    [anon_sym_symbol] = ACTIONS(2770),
    [anon_sym_abstract] = ACTIONS(2770),
    [anon_sym_interface] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2770),
    [anon_sym_component] = ACTIONS(2770),
  },
  [753] = {
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LTtemplate_GT] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_readonly] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_override] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_component] = ACTIONS(2604),
  },
  [754] = {
    [sym_identifier] = ACTIONS(2774),
    [anon_sym_export] = ACTIONS(2774),
    [anon_sym_LBRACE] = ACTIONS(2776),
    [anon_sym_RBRACE] = ACTIONS(2776),
    [anon_sym_type] = ACTIONS(2774),
    [anon_sym_typeof] = ACTIONS(2774),
    [anon_sym_import] = ACTIONS(2774),
    [anon_sym_var] = ACTIONS(2774),
    [anon_sym_let] = ACTIONS(2774),
    [anon_sym_const] = ACTIONS(2774),
    [anon_sym_BANG] = ACTIONS(2776),
    [anon_sym_else] = ACTIONS(2774),
    [anon_sym_if] = ACTIONS(2774),
    [anon_sym_switch] = ACTIONS(2774),
    [anon_sym_for] = ACTIONS(2774),
    [anon_sym_LPAREN] = ACTIONS(2776),
    [anon_sym_await] = ACTIONS(2774),
    [anon_sym_while] = ACTIONS(2774),
    [anon_sym_do] = ACTIONS(2774),
    [anon_sym_try] = ACTIONS(2774),
    [anon_sym_with] = ACTIONS(2774),
    [anon_sym_break] = ACTIONS(2774),
    [anon_sym_continue] = ACTIONS(2774),
    [anon_sym_debugger] = ACTIONS(2774),
    [anon_sym_return] = ACTIONS(2774),
    [anon_sym_throw] = ACTIONS(2774),
    [anon_sym_SEMI] = ACTIONS(2776),
    [anon_sym_case] = ACTIONS(2774),
    [anon_sym_default] = ACTIONS(2774),
    [anon_sym_yield] = ACTIONS(2774),
    [anon_sym_LBRACK] = ACTIONS(2776),
    [anon_sym_LTtemplate_GT] = ACTIONS(2776),
    [anon_sym_LT] = ACTIONS(2774),
    [anon_sym_SLASH] = ACTIONS(2774),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_async] = ACTIONS(2774),
    [anon_sym_function] = ACTIONS(2774),
    [anon_sym_new] = ACTIONS(2774),
    [anon_sym_AMP] = ACTIONS(2776),
    [anon_sym_PLUS] = ACTIONS(2774),
    [anon_sym_DASH] = ACTIONS(2774),
    [anon_sym_TILDE] = ACTIONS(2776),
    [anon_sym_void] = ACTIONS(2774),
    [anon_sym_delete] = ACTIONS(2774),
    [anon_sym_PLUS_PLUS] = ACTIONS(2776),
    [anon_sym_DASH_DASH] = ACTIONS(2776),
    [anon_sym_DQUOTE] = ACTIONS(2776),
    [anon_sym_SQUOTE] = ACTIONS(2776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2776),
    [sym_number] = ACTIONS(2776),
    [sym_this] = ACTIONS(2774),
    [sym_super] = ACTIONS(2774),
    [sym_true] = ACTIONS(2774),
    [sym_false] = ACTIONS(2774),
    [sym_null] = ACTIONS(2774),
    [sym_undefined] = ACTIONS(2774),
    [anon_sym_AT] = ACTIONS(2776),
    [anon_sym_static] = ACTIONS(2774),
    [anon_sym_readonly] = ACTIONS(2774),
    [anon_sym_get] = ACTIONS(2774),
    [anon_sym_set] = ACTIONS(2774),
    [anon_sym_declare] = ACTIONS(2774),
    [anon_sym_namespace] = ACTIONS(2774),
    [anon_sym_public] = ACTIONS(2774),
    [anon_sym_private] = ACTIONS(2774),
    [anon_sym_protected] = ACTIONS(2774),
    [anon_sym_override] = ACTIONS(2774),
    [anon_sym_module] = ACTIONS(2774),
    [anon_sym_any] = ACTIONS(2774),
    [anon_sym_number] = ACTIONS(2774),
    [anon_sym_boolean] = ACTIONS(2774),
    [anon_sym_string] = ACTIONS(2774),
    [anon_sym_symbol] = ACTIONS(2774),
    [anon_sym_abstract] = ACTIONS(2774),
    [anon_sym_interface] = ACTIONS(2774),
    [anon_sym_enum] = ACTIONS(2774),
    [anon_sym_component] = ACTIONS(2774),
  },
  [755] = {
    [sym_identifier] = ACTIONS(1366),
    [anon_sym_STAR] = ACTIONS(1366),
    [anon_sym_as] = ACTIONS(1366),
    [anon_sym_LBRACE] = ACTIONS(1366),
    [anon_sym_RBRACE] = ACTIONS(1370),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_BANG] = ACTIONS(1366),
    [anon_sym_LPAREN] = ACTIONS(1370),
    [anon_sym_in] = ACTIONS(1366),
    [anon_sym_SEMI] = ACTIONS(1370),
    [anon_sym_EQ] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(1366),
    [anon_sym_SLASH] = ACTIONS(1366),
    [anon_sym_DOT] = ACTIONS(1366),
    [anon_sym_async] = ACTIONS(1366),
    [anon_sym_QMARK_DOT] = ACTIONS(1370),
    [anon_sym_new] = ACTIONS(1366),
    [anon_sym_AMP_AMP] = ACTIONS(1370),
    [anon_sym_PIPE_PIPE] = ACTIONS(1370),
    [anon_sym_GT_GT] = ACTIONS(1366),
    [anon_sym_GT_GT_GT] = ACTIONS(1370),
    [anon_sym_LT_LT] = ACTIONS(1370),
    [anon_sym_AMP] = ACTIONS(1366),
    [anon_sym_CARET] = ACTIONS(1370),
    [anon_sym_PIPE] = ACTIONS(1366),
    [anon_sym_PLUS] = ACTIONS(1366),
    [anon_sym_DASH] = ACTIONS(1366),
    [anon_sym_PERCENT] = ACTIONS(1370),
    [anon_sym_STAR_STAR] = ACTIONS(1370),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_EQ_EQ] = ACTIONS(1366),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG_EQ] = ACTIONS(1366),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_QMARK_QMARK] = ACTIONS(1370),
    [anon_sym_instanceof] = ACTIONS(1366),
    [anon_sym_void] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_DQUOTE] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1370),
    [sym_number] = ACTIONS(1370),
    [sym_this] = ACTIONS(1366),
    [sym_true] = ACTIONS(1366),
    [sym_false] = ACTIONS(1366),
    [sym_null] = ACTIONS(1366),
    [sym_undefined] = ACTIONS(1366),
    [anon_sym_static] = ACTIONS(1366),
    [anon_sym_readonly] = ACTIONS(1366),
    [anon_sym_get] = ACTIONS(1366),
    [anon_sym_set] = ACTIONS(1366),
    [anon_sym_QMARK] = ACTIONS(1366),
    [anon_sym_any] = ACTIONS(1366),
    [anon_sym_number] = ACTIONS(1366),
    [anon_sym_boolean] = ACTIONS(1366),
    [anon_sym_string] = ACTIONS(1366),
    [anon_sym_symbol] = ACTIONS(1366),
    [anon_sym_abstract] = ACTIONS(1366),
    [anon_sym_satisfies] = ACTIONS(1366),
    [anon_sym_infer] = ACTIONS(1366),
    [anon_sym_keyof] = ACTIONS(1366),
    [anon_sym_unknown] = ACTIONS(1366),
    [anon_sym_never] = ACTIONS(1366),
    [anon_sym_object] = ACTIONS(1366),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1370),
    [anon_sym_constructor] = ACTIONS(1366),
    [anon_sym_prop] = ACTIONS(1366),
    [anon_sym_id] = ACTIONS(1366),
    [anon_sym_event] = ACTIONS(1366),
    [anon_sym_fn] = ACTIONS(1366),
    [anon_sym_on] = ACTIONS(1366),
    [sym__automatic_semicolon] = ACTIONS(2778),
    [sym__ternary_qmark] = ACTIONS(1370),
  },
  [756] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LTtemplate_GT] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2610),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_override] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_component] = ACTIONS(2608),
  },
  [757] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(2698),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2698),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2698),
    [anon_sym_SLASH] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2698),
    [anon_sym_GT_GT_GT] = ACTIONS(2700),
    [anon_sym_LT_LT] = ACTIONS(2700),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2700),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2700),
    [anon_sym_EQ_EQ] = ACTIONS(2698),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2700),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2700),
    [anon_sym_GT_EQ] = ACTIONS(2700),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(2698),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_get] = ACTIONS(2698),
    [anon_sym_set] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_constructor] = ACTIONS(2698),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [758] = {
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LTtemplate_GT] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_readonly] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_override] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_component] = ACTIONS(2604),
  },
  [759] = {
    [sym_identifier] = ACTIONS(2770),
    [anon_sym_export] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(2772),
    [anon_sym_RBRACE] = ACTIONS(2772),
    [anon_sym_type] = ACTIONS(2770),
    [anon_sym_typeof] = ACTIONS(2770),
    [anon_sym_import] = ACTIONS(2770),
    [anon_sym_var] = ACTIONS(2770),
    [anon_sym_let] = ACTIONS(2770),
    [anon_sym_const] = ACTIONS(2770),
    [anon_sym_BANG] = ACTIONS(2772),
    [anon_sym_else] = ACTIONS(2770),
    [anon_sym_if] = ACTIONS(2770),
    [anon_sym_switch] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2770),
    [anon_sym_LPAREN] = ACTIONS(2772),
    [anon_sym_await] = ACTIONS(2770),
    [anon_sym_while] = ACTIONS(2770),
    [anon_sym_do] = ACTIONS(2770),
    [anon_sym_try] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2770),
    [anon_sym_break] = ACTIONS(2770),
    [anon_sym_continue] = ACTIONS(2770),
    [anon_sym_debugger] = ACTIONS(2770),
    [anon_sym_return] = ACTIONS(2770),
    [anon_sym_throw] = ACTIONS(2770),
    [anon_sym_SEMI] = ACTIONS(2772),
    [anon_sym_case] = ACTIONS(2770),
    [anon_sym_default] = ACTIONS(2770),
    [anon_sym_yield] = ACTIONS(2770),
    [anon_sym_LBRACK] = ACTIONS(2772),
    [anon_sym_LTtemplate_GT] = ACTIONS(2772),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_SLASH] = ACTIONS(2770),
    [anon_sym_class] = ACTIONS(2770),
    [anon_sym_async] = ACTIONS(2770),
    [anon_sym_function] = ACTIONS(2770),
    [anon_sym_new] = ACTIONS(2770),
    [anon_sym_AMP] = ACTIONS(2772),
    [anon_sym_PLUS] = ACTIONS(2770),
    [anon_sym_DASH] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2772),
    [anon_sym_void] = ACTIONS(2770),
    [anon_sym_delete] = ACTIONS(2770),
    [anon_sym_PLUS_PLUS] = ACTIONS(2772),
    [anon_sym_DASH_DASH] = ACTIONS(2772),
    [anon_sym_DQUOTE] = ACTIONS(2772),
    [anon_sym_SQUOTE] = ACTIONS(2772),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2772),
    [sym_number] = ACTIONS(2772),
    [sym_this] = ACTIONS(2770),
    [sym_super] = ACTIONS(2770),
    [sym_true] = ACTIONS(2770),
    [sym_false] = ACTIONS(2770),
    [sym_null] = ACTIONS(2770),
    [sym_undefined] = ACTIONS(2770),
    [anon_sym_AT] = ACTIONS(2772),
    [anon_sym_static] = ACTIONS(2770),
    [anon_sym_readonly] = ACTIONS(2770),
    [anon_sym_get] = ACTIONS(2770),
    [anon_sym_set] = ACTIONS(2770),
    [anon_sym_declare] = ACTIONS(2770),
    [anon_sym_namespace] = ACTIONS(2770),
    [anon_sym_public] = ACTIONS(2770),
    [anon_sym_private] = ACTIONS(2770),
    [anon_sym_protected] = ACTIONS(2770),
    [anon_sym_override] = ACTIONS(2770),
    [anon_sym_module] = ACTIONS(2770),
    [anon_sym_any] = ACTIONS(2770),
    [anon_sym_number] = ACTIONS(2770),
    [anon_sym_boolean] = ACTIONS(2770),
    [anon_sym_string] = ACTIONS(2770),
    [anon_sym_symbol] = ACTIONS(2770),
    [anon_sym_abstract] = ACTIONS(2770),
    [anon_sym_interface] = ACTIONS(2770),
    [anon_sym_enum] = ACTIONS(2770),
    [anon_sym_component] = ACTIONS(2770),
  },
  [760] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2698),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2700),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2700),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_get] = ACTIONS(2698),
    [anon_sym_set] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_constructor] = ACTIONS(2698),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [761] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2698),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2698),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2700),
    [anon_sym_EQ_EQ] = ACTIONS(2698),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2700),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2700),
    [anon_sym_GT_EQ] = ACTIONS(2700),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(2698),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_get] = ACTIONS(2698),
    [anon_sym_set] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_constructor] = ACTIONS(2698),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [762] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2780),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2780),
    [anon_sym_RBRACE] = ACTIONS(2782),
    [anon_sym_typeof] = ACTIONS(2780),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2780),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_QMARK_QMARK] = ACTIONS(2650),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2782),
    [anon_sym_SQUOTE] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2782),
    [sym_number] = ACTIONS(2782),
    [sym_this] = ACTIONS(2780),
    [sym_true] = ACTIONS(2780),
    [sym_false] = ACTIONS(2780),
    [sym_null] = ACTIONS(2780),
    [sym_undefined] = ACTIONS(2780),
    [anon_sym_static] = ACTIONS(2780),
    [anon_sym_readonly] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2780),
    [anon_sym_set] = ACTIONS(2780),
    [anon_sym_QMARK] = ACTIONS(2780),
    [anon_sym_any] = ACTIONS(2780),
    [anon_sym_number] = ACTIONS(2780),
    [anon_sym_boolean] = ACTIONS(2780),
    [anon_sym_string] = ACTIONS(2780),
    [anon_sym_symbol] = ACTIONS(2780),
    [anon_sym_abstract] = ACTIONS(2780),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2780),
    [anon_sym_keyof] = ACTIONS(2780),
    [anon_sym_unknown] = ACTIONS(2780),
    [anon_sym_never] = ACTIONS(2780),
    [anon_sym_object] = ACTIONS(2780),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2782),
    [anon_sym_constructor] = ACTIONS(2780),
    [anon_sym_prop] = ACTIONS(2780),
    [anon_sym_id] = ACTIONS(2780),
    [anon_sym_event] = ACTIONS(2780),
    [anon_sym_fn] = ACTIONS(2780),
    [anon_sym_on] = ACTIONS(2780),
    [sym__ternary_qmark] = ACTIONS(2656),
  },
  [763] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_get] = ACTIONS(2698),
    [anon_sym_set] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_constructor] = ACTIONS(2698),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [764] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2784),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2784),
    [anon_sym_RBRACE] = ACTIONS(2786),
    [anon_sym_typeof] = ACTIONS(2784),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2786),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2784),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2784),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_QMARK_QMARK] = ACTIONS(2650),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2786),
    [anon_sym_SQUOTE] = ACTIONS(2786),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2786),
    [sym_number] = ACTIONS(2786),
    [sym_this] = ACTIONS(2784),
    [sym_true] = ACTIONS(2784),
    [sym_false] = ACTIONS(2784),
    [sym_null] = ACTIONS(2784),
    [sym_undefined] = ACTIONS(2784),
    [anon_sym_static] = ACTIONS(2784),
    [anon_sym_readonly] = ACTIONS(2784),
    [anon_sym_get] = ACTIONS(2784),
    [anon_sym_set] = ACTIONS(2784),
    [anon_sym_QMARK] = ACTIONS(2784),
    [anon_sym_any] = ACTIONS(2784),
    [anon_sym_number] = ACTIONS(2784),
    [anon_sym_boolean] = ACTIONS(2784),
    [anon_sym_string] = ACTIONS(2784),
    [anon_sym_symbol] = ACTIONS(2784),
    [anon_sym_abstract] = ACTIONS(2784),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2784),
    [anon_sym_keyof] = ACTIONS(2784),
    [anon_sym_unknown] = ACTIONS(2784),
    [anon_sym_never] = ACTIONS(2784),
    [anon_sym_object] = ACTIONS(2784),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2786),
    [anon_sym_constructor] = ACTIONS(2784),
    [anon_sym_prop] = ACTIONS(2784),
    [anon_sym_id] = ACTIONS(2784),
    [anon_sym_event] = ACTIONS(2784),
    [anon_sym_fn] = ACTIONS(2784),
    [anon_sym_on] = ACTIONS(2784),
    [sym__ternary_qmark] = ACTIONS(2656),
  },
  [765] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(2698),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2698),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2698),
    [anon_sym_SLASH] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2698),
    [anon_sym_GT_GT_GT] = ACTIONS(2700),
    [anon_sym_LT_LT] = ACTIONS(2700),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2700),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2700),
    [anon_sym_EQ_EQ] = ACTIONS(2698),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2700),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2700),
    [anon_sym_GT_EQ] = ACTIONS(2700),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(2698),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_get] = ACTIONS(2698),
    [anon_sym_set] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_constructor] = ACTIONS(2698),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [766] = {
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LTtemplate_GT] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_readonly] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_override] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_component] = ACTIONS(2604),
  },
  [767] = {
    [sym_identifier] = ACTIONS(2774),
    [anon_sym_export] = ACTIONS(2774),
    [anon_sym_LBRACE] = ACTIONS(2776),
    [anon_sym_RBRACE] = ACTIONS(2776),
    [anon_sym_type] = ACTIONS(2774),
    [anon_sym_typeof] = ACTIONS(2774),
    [anon_sym_import] = ACTIONS(2774),
    [anon_sym_var] = ACTIONS(2774),
    [anon_sym_let] = ACTIONS(2774),
    [anon_sym_const] = ACTIONS(2774),
    [anon_sym_BANG] = ACTIONS(2776),
    [anon_sym_else] = ACTIONS(2774),
    [anon_sym_if] = ACTIONS(2774),
    [anon_sym_switch] = ACTIONS(2774),
    [anon_sym_for] = ACTIONS(2774),
    [anon_sym_LPAREN] = ACTIONS(2776),
    [anon_sym_await] = ACTIONS(2774),
    [anon_sym_while] = ACTIONS(2774),
    [anon_sym_do] = ACTIONS(2774),
    [anon_sym_try] = ACTIONS(2774),
    [anon_sym_with] = ACTIONS(2774),
    [anon_sym_break] = ACTIONS(2774),
    [anon_sym_continue] = ACTIONS(2774),
    [anon_sym_debugger] = ACTIONS(2774),
    [anon_sym_return] = ACTIONS(2774),
    [anon_sym_throw] = ACTIONS(2774),
    [anon_sym_SEMI] = ACTIONS(2776),
    [anon_sym_case] = ACTIONS(2774),
    [anon_sym_default] = ACTIONS(2774),
    [anon_sym_yield] = ACTIONS(2774),
    [anon_sym_LBRACK] = ACTIONS(2776),
    [anon_sym_LTtemplate_GT] = ACTIONS(2776),
    [anon_sym_LT] = ACTIONS(2774),
    [anon_sym_SLASH] = ACTIONS(2774),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_async] = ACTIONS(2774),
    [anon_sym_function] = ACTIONS(2774),
    [anon_sym_new] = ACTIONS(2774),
    [anon_sym_AMP] = ACTIONS(2776),
    [anon_sym_PLUS] = ACTIONS(2774),
    [anon_sym_DASH] = ACTIONS(2774),
    [anon_sym_TILDE] = ACTIONS(2776),
    [anon_sym_void] = ACTIONS(2774),
    [anon_sym_delete] = ACTIONS(2774),
    [anon_sym_PLUS_PLUS] = ACTIONS(2776),
    [anon_sym_DASH_DASH] = ACTIONS(2776),
    [anon_sym_DQUOTE] = ACTIONS(2776),
    [anon_sym_SQUOTE] = ACTIONS(2776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2776),
    [sym_number] = ACTIONS(2776),
    [sym_this] = ACTIONS(2774),
    [sym_super] = ACTIONS(2774),
    [sym_true] = ACTIONS(2774),
    [sym_false] = ACTIONS(2774),
    [sym_null] = ACTIONS(2774),
    [sym_undefined] = ACTIONS(2774),
    [anon_sym_AT] = ACTIONS(2776),
    [anon_sym_static] = ACTIONS(2774),
    [anon_sym_readonly] = ACTIONS(2774),
    [anon_sym_get] = ACTIONS(2774),
    [anon_sym_set] = ACTIONS(2774),
    [anon_sym_declare] = ACTIONS(2774),
    [anon_sym_namespace] = ACTIONS(2774),
    [anon_sym_public] = ACTIONS(2774),
    [anon_sym_private] = ACTIONS(2774),
    [anon_sym_protected] = ACTIONS(2774),
    [anon_sym_override] = ACTIONS(2774),
    [anon_sym_module] = ACTIONS(2774),
    [anon_sym_any] = ACTIONS(2774),
    [anon_sym_number] = ACTIONS(2774),
    [anon_sym_boolean] = ACTIONS(2774),
    [anon_sym_string] = ACTIONS(2774),
    [anon_sym_symbol] = ACTIONS(2774),
    [anon_sym_abstract] = ACTIONS(2774),
    [anon_sym_interface] = ACTIONS(2774),
    [anon_sym_enum] = ACTIONS(2774),
    [anon_sym_component] = ACTIONS(2774),
  },
  [768] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2788),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2788),
    [anon_sym_RBRACE] = ACTIONS(2790),
    [anon_sym_typeof] = ACTIONS(2788),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2790),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2788),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2788),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_QMARK_QMARK] = ACTIONS(2650),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(2788),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2790),
    [anon_sym_SQUOTE] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2790),
    [sym_number] = ACTIONS(2790),
    [sym_this] = ACTIONS(2788),
    [sym_true] = ACTIONS(2788),
    [sym_false] = ACTIONS(2788),
    [sym_null] = ACTIONS(2788),
    [sym_undefined] = ACTIONS(2788),
    [anon_sym_static] = ACTIONS(2788),
    [anon_sym_readonly] = ACTIONS(2788),
    [anon_sym_get] = ACTIONS(2788),
    [anon_sym_set] = ACTIONS(2788),
    [anon_sym_QMARK] = ACTIONS(2788),
    [anon_sym_any] = ACTIONS(2788),
    [anon_sym_number] = ACTIONS(2788),
    [anon_sym_boolean] = ACTIONS(2788),
    [anon_sym_string] = ACTIONS(2788),
    [anon_sym_symbol] = ACTIONS(2788),
    [anon_sym_abstract] = ACTIONS(2788),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2788),
    [anon_sym_keyof] = ACTIONS(2788),
    [anon_sym_unknown] = ACTIONS(2788),
    [anon_sym_never] = ACTIONS(2788),
    [anon_sym_object] = ACTIONS(2788),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2790),
    [anon_sym_constructor] = ACTIONS(2788),
    [anon_sym_prop] = ACTIONS(2788),
    [anon_sym_id] = ACTIONS(2788),
    [anon_sym_event] = ACTIONS(2788),
    [anon_sym_fn] = ACTIONS(2788),
    [anon_sym_on] = ACTIONS(2788),
    [sym__ternary_qmark] = ACTIONS(2656),
  },
  [769] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2792),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2792),
    [anon_sym_RBRACE] = ACTIONS(2794),
    [anon_sym_typeof] = ACTIONS(2792),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2792),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2792),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_QMARK_QMARK] = ACTIONS(2650),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(2792),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2794),
    [sym_number] = ACTIONS(2794),
    [sym_this] = ACTIONS(2792),
    [sym_true] = ACTIONS(2792),
    [sym_false] = ACTIONS(2792),
    [sym_null] = ACTIONS(2792),
    [sym_undefined] = ACTIONS(2792),
    [anon_sym_static] = ACTIONS(2792),
    [anon_sym_readonly] = ACTIONS(2792),
    [anon_sym_get] = ACTIONS(2792),
    [anon_sym_set] = ACTIONS(2792),
    [anon_sym_QMARK] = ACTIONS(2792),
    [anon_sym_any] = ACTIONS(2792),
    [anon_sym_number] = ACTIONS(2792),
    [anon_sym_boolean] = ACTIONS(2792),
    [anon_sym_string] = ACTIONS(2792),
    [anon_sym_symbol] = ACTIONS(2792),
    [anon_sym_abstract] = ACTIONS(2792),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2792),
    [anon_sym_keyof] = ACTIONS(2792),
    [anon_sym_unknown] = ACTIONS(2792),
    [anon_sym_never] = ACTIONS(2792),
    [anon_sym_object] = ACTIONS(2792),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2794),
    [anon_sym_constructor] = ACTIONS(2792),
    [anon_sym_prop] = ACTIONS(2792),
    [anon_sym_id] = ACTIONS(2792),
    [anon_sym_event] = ACTIONS(2792),
    [anon_sym_fn] = ACTIONS(2792),
    [anon_sym_on] = ACTIONS(2792),
    [sym__ternary_qmark] = ACTIONS(2656),
  },
  [770] = {
    [sym_identifier] = ACTIONS(2796),
    [anon_sym_export] = ACTIONS(2796),
    [anon_sym_LBRACE] = ACTIONS(2798),
    [anon_sym_RBRACE] = ACTIONS(2798),
    [anon_sym_type] = ACTIONS(2796),
    [anon_sym_typeof] = ACTIONS(2796),
    [anon_sym_import] = ACTIONS(2796),
    [anon_sym_var] = ACTIONS(2796),
    [anon_sym_let] = ACTIONS(2796),
    [anon_sym_const] = ACTIONS(2796),
    [anon_sym_BANG] = ACTIONS(2798),
    [anon_sym_else] = ACTIONS(2796),
    [anon_sym_if] = ACTIONS(2796),
    [anon_sym_switch] = ACTIONS(2796),
    [anon_sym_for] = ACTIONS(2796),
    [anon_sym_LPAREN] = ACTIONS(2798),
    [anon_sym_await] = ACTIONS(2796),
    [anon_sym_while] = ACTIONS(2796),
    [anon_sym_do] = ACTIONS(2796),
    [anon_sym_try] = ACTIONS(2796),
    [anon_sym_with] = ACTIONS(2796),
    [anon_sym_break] = ACTIONS(2796),
    [anon_sym_continue] = ACTIONS(2796),
    [anon_sym_debugger] = ACTIONS(2796),
    [anon_sym_return] = ACTIONS(2796),
    [anon_sym_throw] = ACTIONS(2796),
    [anon_sym_SEMI] = ACTIONS(2798),
    [anon_sym_case] = ACTIONS(2796),
    [anon_sym_default] = ACTIONS(2796),
    [anon_sym_yield] = ACTIONS(2796),
    [anon_sym_LBRACK] = ACTIONS(2798),
    [anon_sym_LTtemplate_GT] = ACTIONS(2798),
    [anon_sym_LT] = ACTIONS(2796),
    [anon_sym_SLASH] = ACTIONS(2796),
    [anon_sym_class] = ACTIONS(2796),
    [anon_sym_async] = ACTIONS(2796),
    [anon_sym_function] = ACTIONS(2796),
    [anon_sym_new] = ACTIONS(2796),
    [anon_sym_AMP] = ACTIONS(2798),
    [anon_sym_PLUS] = ACTIONS(2796),
    [anon_sym_DASH] = ACTIONS(2796),
    [anon_sym_TILDE] = ACTIONS(2798),
    [anon_sym_void] = ACTIONS(2796),
    [anon_sym_delete] = ACTIONS(2796),
    [anon_sym_PLUS_PLUS] = ACTIONS(2798),
    [anon_sym_DASH_DASH] = ACTIONS(2798),
    [anon_sym_DQUOTE] = ACTIONS(2798),
    [anon_sym_SQUOTE] = ACTIONS(2798),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2798),
    [sym_number] = ACTIONS(2798),
    [sym_this] = ACTIONS(2796),
    [sym_super] = ACTIONS(2796),
    [sym_true] = ACTIONS(2796),
    [sym_false] = ACTIONS(2796),
    [sym_null] = ACTIONS(2796),
    [sym_undefined] = ACTIONS(2796),
    [anon_sym_AT] = ACTIONS(2798),
    [anon_sym_static] = ACTIONS(2796),
    [anon_sym_readonly] = ACTIONS(2796),
    [anon_sym_get] = ACTIONS(2796),
    [anon_sym_set] = ACTIONS(2796),
    [anon_sym_declare] = ACTIONS(2796),
    [anon_sym_namespace] = ACTIONS(2796),
    [anon_sym_public] = ACTIONS(2796),
    [anon_sym_private] = ACTIONS(2796),
    [anon_sym_protected] = ACTIONS(2796),
    [anon_sym_override] = ACTIONS(2796),
    [anon_sym_module] = ACTIONS(2796),
    [anon_sym_any] = ACTIONS(2796),
    [anon_sym_number] = ACTIONS(2796),
    [anon_sym_boolean] = ACTIONS(2796),
    [anon_sym_string] = ACTIONS(2796),
    [anon_sym_symbol] = ACTIONS(2796),
    [anon_sym_abstract] = ACTIONS(2796),
    [anon_sym_interface] = ACTIONS(2796),
    [anon_sym_enum] = ACTIONS(2796),
    [anon_sym_component] = ACTIONS(2796),
  },
  [771] = {
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LTtemplate_GT] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_readonly] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_override] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_component] = ACTIONS(2604),
  },
  [772] = {
    [sym_identifier] = ACTIONS(2800),
    [anon_sym_export] = ACTIONS(2800),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_RBRACE] = ACTIONS(2802),
    [anon_sym_type] = ACTIONS(2800),
    [anon_sym_typeof] = ACTIONS(2800),
    [anon_sym_import] = ACTIONS(2800),
    [anon_sym_var] = ACTIONS(2800),
    [anon_sym_let] = ACTIONS(2800),
    [anon_sym_const] = ACTIONS(2800),
    [anon_sym_BANG] = ACTIONS(2802),
    [anon_sym_else] = ACTIONS(2800),
    [anon_sym_if] = ACTIONS(2800),
    [anon_sym_switch] = ACTIONS(2800),
    [anon_sym_for] = ACTIONS(2800),
    [anon_sym_LPAREN] = ACTIONS(2802),
    [anon_sym_await] = ACTIONS(2800),
    [anon_sym_while] = ACTIONS(2800),
    [anon_sym_do] = ACTIONS(2800),
    [anon_sym_try] = ACTIONS(2800),
    [anon_sym_with] = ACTIONS(2800),
    [anon_sym_break] = ACTIONS(2800),
    [anon_sym_continue] = ACTIONS(2800),
    [anon_sym_debugger] = ACTIONS(2800),
    [anon_sym_return] = ACTIONS(2800),
    [anon_sym_throw] = ACTIONS(2800),
    [anon_sym_SEMI] = ACTIONS(2802),
    [anon_sym_case] = ACTIONS(2800),
    [anon_sym_default] = ACTIONS(2800),
    [anon_sym_yield] = ACTIONS(2800),
    [anon_sym_LBRACK] = ACTIONS(2802),
    [anon_sym_LTtemplate_GT] = ACTIONS(2802),
    [anon_sym_LT] = ACTIONS(2800),
    [anon_sym_SLASH] = ACTIONS(2800),
    [anon_sym_class] = ACTIONS(2800),
    [anon_sym_async] = ACTIONS(2800),
    [anon_sym_function] = ACTIONS(2800),
    [anon_sym_new] = ACTIONS(2800),
    [anon_sym_AMP] = ACTIONS(2802),
    [anon_sym_PLUS] = ACTIONS(2800),
    [anon_sym_DASH] = ACTIONS(2800),
    [anon_sym_TILDE] = ACTIONS(2802),
    [anon_sym_void] = ACTIONS(2800),
    [anon_sym_delete] = ACTIONS(2800),
    [anon_sym_PLUS_PLUS] = ACTIONS(2802),
    [anon_sym_DASH_DASH] = ACTIONS(2802),
    [anon_sym_DQUOTE] = ACTIONS(2802),
    [anon_sym_SQUOTE] = ACTIONS(2802),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2802),
    [sym_number] = ACTIONS(2802),
    [sym_this] = ACTIONS(2800),
    [sym_super] = ACTIONS(2800),
    [sym_true] = ACTIONS(2800),
    [sym_false] = ACTIONS(2800),
    [sym_null] = ACTIONS(2800),
    [sym_undefined] = ACTIONS(2800),
    [anon_sym_AT] = ACTIONS(2802),
    [anon_sym_static] = ACTIONS(2800),
    [anon_sym_readonly] = ACTIONS(2800),
    [anon_sym_get] = ACTIONS(2800),
    [anon_sym_set] = ACTIONS(2800),
    [anon_sym_declare] = ACTIONS(2800),
    [anon_sym_namespace] = ACTIONS(2800),
    [anon_sym_public] = ACTIONS(2800),
    [anon_sym_private] = ACTIONS(2800),
    [anon_sym_protected] = ACTIONS(2800),
    [anon_sym_override] = ACTIONS(2800),
    [anon_sym_module] = ACTIONS(2800),
    [anon_sym_any] = ACTIONS(2800),
    [anon_sym_number] = ACTIONS(2800),
    [anon_sym_boolean] = ACTIONS(2800),
    [anon_sym_string] = ACTIONS(2800),
    [anon_sym_symbol] = ACTIONS(2800),
    [anon_sym_abstract] = ACTIONS(2800),
    [anon_sym_interface] = ACTIONS(2800),
    [anon_sym_enum] = ACTIONS(2800),
    [anon_sym_component] = ACTIONS(2800),
  },
  [773] = {
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LTtemplate_GT] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_readonly] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_override] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_component] = ACTIONS(2604),
  },
  [774] = {
    [sym_identifier] = ACTIONS(1250),
    [anon_sym_STAR] = ACTIONS(1250),
    [anon_sym_as] = ACTIONS(1250),
    [anon_sym_LBRACE] = ACTIONS(1250),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_typeof] = ACTIONS(1250),
    [anon_sym_BANG] = ACTIONS(1250),
    [anon_sym_LPAREN] = ACTIONS(1248),
    [anon_sym_in] = ACTIONS(1250),
    [anon_sym_SEMI] = ACTIONS(1248),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_LT] = ACTIONS(1250),
    [anon_sym_GT] = ACTIONS(1250),
    [anon_sym_SLASH] = ACTIONS(1250),
    [anon_sym_DOT] = ACTIONS(1250),
    [anon_sym_async] = ACTIONS(1250),
    [anon_sym_QMARK_DOT] = ACTIONS(1248),
    [anon_sym_new] = ACTIONS(1250),
    [anon_sym_AMP_AMP] = ACTIONS(1248),
    [anon_sym_PIPE_PIPE] = ACTIONS(1248),
    [anon_sym_GT_GT] = ACTIONS(1250),
    [anon_sym_GT_GT_GT] = ACTIONS(1248),
    [anon_sym_LT_LT] = ACTIONS(1248),
    [anon_sym_AMP] = ACTIONS(1250),
    [anon_sym_CARET] = ACTIONS(1248),
    [anon_sym_PIPE] = ACTIONS(1250),
    [anon_sym_PLUS] = ACTIONS(1250),
    [anon_sym_DASH] = ACTIONS(1250),
    [anon_sym_PERCENT] = ACTIONS(1248),
    [anon_sym_STAR_STAR] = ACTIONS(1248),
    [anon_sym_LT_EQ] = ACTIONS(1248),
    [anon_sym_EQ_EQ] = ACTIONS(1250),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1248),
    [anon_sym_BANG_EQ] = ACTIONS(1250),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1248),
    [anon_sym_GT_EQ] = ACTIONS(1248),
    [anon_sym_QMARK_QMARK] = ACTIONS(1248),
    [anon_sym_instanceof] = ACTIONS(1250),
    [anon_sym_void] = ACTIONS(1250),
    [anon_sym_PLUS_PLUS] = ACTIONS(1248),
    [anon_sym_DASH_DASH] = ACTIONS(1248),
    [anon_sym_DQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [sym_number] = ACTIONS(1248),
    [sym_this] = ACTIONS(1250),
    [sym_true] = ACTIONS(1250),
    [sym_false] = ACTIONS(1250),
    [sym_null] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_static] = ACTIONS(1250),
    [anon_sym_readonly] = ACTIONS(1250),
    [anon_sym_get] = ACTIONS(1250),
    [anon_sym_set] = ACTIONS(1250),
    [anon_sym_QMARK] = ACTIONS(1250),
    [anon_sym_any] = ACTIONS(1250),
    [anon_sym_number] = ACTIONS(1250),
    [anon_sym_boolean] = ACTIONS(1250),
    [anon_sym_string] = ACTIONS(1250),
    [anon_sym_symbol] = ACTIONS(1250),
    [anon_sym_abstract] = ACTIONS(1250),
    [anon_sym_satisfies] = ACTIONS(1250),
    [anon_sym_extends] = ACTIONS(1250),
    [anon_sym_infer] = ACTIONS(1250),
    [anon_sym_is] = ACTIONS(1250),
    [anon_sym_keyof] = ACTIONS(1250),
    [anon_sym_unknown] = ACTIONS(1250),
    [anon_sym_never] = ACTIONS(1250),
    [anon_sym_object] = ACTIONS(1250),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1248),
    [anon_sym_constructor] = ACTIONS(1250),
    [anon_sym_prop] = ACTIONS(1250),
    [anon_sym_id] = ACTIONS(1250),
    [anon_sym_event] = ACTIONS(1250),
    [anon_sym_fn] = ACTIONS(1250),
    [anon_sym_on] = ACTIONS(1250),
    [sym__ternary_qmark] = ACTIONS(1248),
  },
  [775] = {
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LTtemplate_GT] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_readonly] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_override] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_component] = ACTIONS(2604),
  },
  [776] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2804),
    [anon_sym_STAR] = ACTIONS(2804),
    [anon_sym_as] = ACTIONS(2804),
    [anon_sym_LBRACE] = ACTIONS(2804),
    [anon_sym_RBRACE] = ACTIONS(2806),
    [anon_sym_typeof] = ACTIONS(2804),
    [anon_sym_BANG] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2804),
    [anon_sym_SEMI] = ACTIONS(2806),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2804),
    [anon_sym_GT] = ACTIONS(2804),
    [anon_sym_SLASH] = ACTIONS(2804),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2804),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_AMP_AMP] = ACTIONS(2806),
    [anon_sym_PIPE_PIPE] = ACTIONS(2806),
    [anon_sym_GT_GT] = ACTIONS(2804),
    [anon_sym_GT_GT_GT] = ACTIONS(2806),
    [anon_sym_LT_LT] = ACTIONS(2806),
    [anon_sym_AMP] = ACTIONS(2804),
    [anon_sym_CARET] = ACTIONS(2806),
    [anon_sym_PIPE] = ACTIONS(2804),
    [anon_sym_PLUS] = ACTIONS(2804),
    [anon_sym_DASH] = ACTIONS(2804),
    [anon_sym_PERCENT] = ACTIONS(2806),
    [anon_sym_STAR_STAR] = ACTIONS(2806),
    [anon_sym_LT_EQ] = ACTIONS(2806),
    [anon_sym_EQ_EQ] = ACTIONS(2804),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2806),
    [anon_sym_BANG_EQ] = ACTIONS(2804),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2806),
    [anon_sym_GT_EQ] = ACTIONS(2806),
    [anon_sym_QMARK_QMARK] = ACTIONS(2806),
    [anon_sym_instanceof] = ACTIONS(2804),
    [anon_sym_void] = ACTIONS(2804),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2806),
    [anon_sym_SQUOTE] = ACTIONS(2806),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2806),
    [sym_number] = ACTIONS(2806),
    [sym_this] = ACTIONS(2804),
    [sym_true] = ACTIONS(2804),
    [sym_false] = ACTIONS(2804),
    [sym_null] = ACTIONS(2804),
    [sym_undefined] = ACTIONS(2804),
    [anon_sym_static] = ACTIONS(2804),
    [anon_sym_readonly] = ACTIONS(2804),
    [anon_sym_get] = ACTIONS(2804),
    [anon_sym_set] = ACTIONS(2804),
    [anon_sym_QMARK] = ACTIONS(2804),
    [anon_sym_any] = ACTIONS(2804),
    [anon_sym_number] = ACTIONS(2804),
    [anon_sym_boolean] = ACTIONS(2804),
    [anon_sym_string] = ACTIONS(2804),
    [anon_sym_symbol] = ACTIONS(2804),
    [anon_sym_abstract] = ACTIONS(2804),
    [anon_sym_satisfies] = ACTIONS(2804),
    [anon_sym_infer] = ACTIONS(2804),
    [anon_sym_keyof] = ACTIONS(2804),
    [anon_sym_unknown] = ACTIONS(2804),
    [anon_sym_never] = ACTIONS(2804),
    [anon_sym_object] = ACTIONS(2804),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2806),
    [anon_sym_constructor] = ACTIONS(2804),
    [anon_sym_prop] = ACTIONS(2804),
    [anon_sym_id] = ACTIONS(2804),
    [anon_sym_event] = ACTIONS(2804),
    [anon_sym_fn] = ACTIONS(2804),
    [anon_sym_on] = ACTIONS(2804),
    [sym__ternary_qmark] = ACTIONS(2806),
  },
  [777] = {
    [sym_identifier] = ACTIONS(2808),
    [anon_sym_export] = ACTIONS(2808),
    [anon_sym_LBRACE] = ACTIONS(2810),
    [anon_sym_RBRACE] = ACTIONS(2810),
    [anon_sym_type] = ACTIONS(2808),
    [anon_sym_typeof] = ACTIONS(2808),
    [anon_sym_import] = ACTIONS(2808),
    [anon_sym_var] = ACTIONS(2808),
    [anon_sym_let] = ACTIONS(2808),
    [anon_sym_const] = ACTIONS(2808),
    [anon_sym_BANG] = ACTIONS(2810),
    [anon_sym_else] = ACTIONS(2808),
    [anon_sym_if] = ACTIONS(2808),
    [anon_sym_switch] = ACTIONS(2808),
    [anon_sym_for] = ACTIONS(2808),
    [anon_sym_LPAREN] = ACTIONS(2810),
    [anon_sym_await] = ACTIONS(2808),
    [anon_sym_while] = ACTIONS(2808),
    [anon_sym_do] = ACTIONS(2808),
    [anon_sym_try] = ACTIONS(2808),
    [anon_sym_with] = ACTIONS(2808),
    [anon_sym_break] = ACTIONS(2808),
    [anon_sym_continue] = ACTIONS(2808),
    [anon_sym_debugger] = ACTIONS(2808),
    [anon_sym_return] = ACTIONS(2808),
    [anon_sym_throw] = ACTIONS(2808),
    [anon_sym_SEMI] = ACTIONS(2810),
    [anon_sym_case] = ACTIONS(2808),
    [anon_sym_default] = ACTIONS(2808),
    [anon_sym_yield] = ACTIONS(2808),
    [anon_sym_LBRACK] = ACTIONS(2810),
    [anon_sym_LTtemplate_GT] = ACTIONS(2810),
    [anon_sym_LT] = ACTIONS(2808),
    [anon_sym_SLASH] = ACTIONS(2808),
    [anon_sym_class] = ACTIONS(2808),
    [anon_sym_async] = ACTIONS(2808),
    [anon_sym_function] = ACTIONS(2808),
    [anon_sym_new] = ACTIONS(2808),
    [anon_sym_AMP] = ACTIONS(2810),
    [anon_sym_PLUS] = ACTIONS(2808),
    [anon_sym_DASH] = ACTIONS(2808),
    [anon_sym_TILDE] = ACTIONS(2810),
    [anon_sym_void] = ACTIONS(2808),
    [anon_sym_delete] = ACTIONS(2808),
    [anon_sym_PLUS_PLUS] = ACTIONS(2810),
    [anon_sym_DASH_DASH] = ACTIONS(2810),
    [anon_sym_DQUOTE] = ACTIONS(2810),
    [anon_sym_SQUOTE] = ACTIONS(2810),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2810),
    [sym_number] = ACTIONS(2810),
    [sym_this] = ACTIONS(2808),
    [sym_super] = ACTIONS(2808),
    [sym_true] = ACTIONS(2808),
    [sym_false] = ACTIONS(2808),
    [sym_null] = ACTIONS(2808),
    [sym_undefined] = ACTIONS(2808),
    [anon_sym_AT] = ACTIONS(2810),
    [anon_sym_static] = ACTIONS(2808),
    [anon_sym_readonly] = ACTIONS(2808),
    [anon_sym_get] = ACTIONS(2808),
    [anon_sym_set] = ACTIONS(2808),
    [anon_sym_declare] = ACTIONS(2808),
    [anon_sym_namespace] = ACTIONS(2808),
    [anon_sym_public] = ACTIONS(2808),
    [anon_sym_private] = ACTIONS(2808),
    [anon_sym_protected] = ACTIONS(2808),
    [anon_sym_override] = ACTIONS(2808),
    [anon_sym_module] = ACTIONS(2808),
    [anon_sym_any] = ACTIONS(2808),
    [anon_sym_number] = ACTIONS(2808),
    [anon_sym_boolean] = ACTIONS(2808),
    [anon_sym_string] = ACTIONS(2808),
    [anon_sym_symbol] = ACTIONS(2808),
    [anon_sym_abstract] = ACTIONS(2808),
    [anon_sym_interface] = ACTIONS(2808),
    [anon_sym_enum] = ACTIONS(2808),
    [anon_sym_component] = ACTIONS(2808),
  },
  [778] = {
    [sym_identifier] = ACTIONS(1678),
    [anon_sym_export] = ACTIONS(1678),
    [anon_sym_LBRACE] = ACTIONS(1680),
    [anon_sym_RBRACE] = ACTIONS(1680),
    [anon_sym_type] = ACTIONS(1678),
    [anon_sym_typeof] = ACTIONS(1678),
    [anon_sym_import] = ACTIONS(1678),
    [anon_sym_var] = ACTIONS(1678),
    [anon_sym_let] = ACTIONS(1678),
    [anon_sym_const] = ACTIONS(1678),
    [anon_sym_BANG] = ACTIONS(1680),
    [anon_sym_else] = ACTIONS(1678),
    [anon_sym_if] = ACTIONS(1678),
    [anon_sym_switch] = ACTIONS(1678),
    [anon_sym_for] = ACTIONS(1678),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [anon_sym_await] = ACTIONS(1678),
    [anon_sym_while] = ACTIONS(1678),
    [anon_sym_do] = ACTIONS(1678),
    [anon_sym_try] = ACTIONS(1678),
    [anon_sym_with] = ACTIONS(1678),
    [anon_sym_break] = ACTIONS(1678),
    [anon_sym_continue] = ACTIONS(1678),
    [anon_sym_debugger] = ACTIONS(1678),
    [anon_sym_return] = ACTIONS(1678),
    [anon_sym_throw] = ACTIONS(1678),
    [anon_sym_SEMI] = ACTIONS(1680),
    [anon_sym_case] = ACTIONS(1678),
    [anon_sym_default] = ACTIONS(1678),
    [anon_sym_yield] = ACTIONS(1678),
    [anon_sym_LBRACK] = ACTIONS(1680),
    [anon_sym_LTtemplate_GT] = ACTIONS(1680),
    [anon_sym_LT] = ACTIONS(1678),
    [anon_sym_SLASH] = ACTIONS(1678),
    [anon_sym_class] = ACTIONS(1678),
    [anon_sym_async] = ACTIONS(1678),
    [anon_sym_function] = ACTIONS(1678),
    [anon_sym_new] = ACTIONS(1678),
    [anon_sym_AMP] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(1678),
    [anon_sym_DASH] = ACTIONS(1678),
    [anon_sym_TILDE] = ACTIONS(1680),
    [anon_sym_void] = ACTIONS(1678),
    [anon_sym_delete] = ACTIONS(1678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1680),
    [anon_sym_DASH_DASH] = ACTIONS(1680),
    [anon_sym_DQUOTE] = ACTIONS(1680),
    [anon_sym_SQUOTE] = ACTIONS(1680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1680),
    [sym_number] = ACTIONS(1680),
    [sym_this] = ACTIONS(1678),
    [sym_super] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_null] = ACTIONS(1678),
    [sym_undefined] = ACTIONS(1678),
    [anon_sym_AT] = ACTIONS(1680),
    [anon_sym_static] = ACTIONS(1678),
    [anon_sym_readonly] = ACTIONS(1678),
    [anon_sym_get] = ACTIONS(1678),
    [anon_sym_set] = ACTIONS(1678),
    [anon_sym_declare] = ACTIONS(1678),
    [anon_sym_namespace] = ACTIONS(1678),
    [anon_sym_public] = ACTIONS(1678),
    [anon_sym_private] = ACTIONS(1678),
    [anon_sym_protected] = ACTIONS(1678),
    [anon_sym_override] = ACTIONS(1678),
    [anon_sym_module] = ACTIONS(1678),
    [anon_sym_any] = ACTIONS(1678),
    [anon_sym_number] = ACTIONS(1678),
    [anon_sym_boolean] = ACTIONS(1678),
    [anon_sym_string] = ACTIONS(1678),
    [anon_sym_symbol] = ACTIONS(1678),
    [anon_sym_abstract] = ACTIONS(1678),
    [anon_sym_interface] = ACTIONS(1678),
    [anon_sym_enum] = ACTIONS(1678),
    [anon_sym_component] = ACTIONS(1678),
  },
  [779] = {
    [sym_identifier] = ACTIONS(2812),
    [anon_sym_export] = ACTIONS(2812),
    [anon_sym_LBRACE] = ACTIONS(2814),
    [anon_sym_RBRACE] = ACTIONS(2814),
    [anon_sym_type] = ACTIONS(2812),
    [anon_sym_typeof] = ACTIONS(2812),
    [anon_sym_import] = ACTIONS(2812),
    [anon_sym_var] = ACTIONS(2812),
    [anon_sym_let] = ACTIONS(2812),
    [anon_sym_const] = ACTIONS(2812),
    [anon_sym_BANG] = ACTIONS(2814),
    [anon_sym_else] = ACTIONS(2812),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_switch] = ACTIONS(2812),
    [anon_sym_for] = ACTIONS(2812),
    [anon_sym_LPAREN] = ACTIONS(2814),
    [anon_sym_await] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_try] = ACTIONS(2812),
    [anon_sym_with] = ACTIONS(2812),
    [anon_sym_break] = ACTIONS(2812),
    [anon_sym_continue] = ACTIONS(2812),
    [anon_sym_debugger] = ACTIONS(2812),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_throw] = ACTIONS(2812),
    [anon_sym_SEMI] = ACTIONS(2814),
    [anon_sym_case] = ACTIONS(2812),
    [anon_sym_default] = ACTIONS(2812),
    [anon_sym_yield] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_LTtemplate_GT] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2812),
    [anon_sym_SLASH] = ACTIONS(2812),
    [anon_sym_class] = ACTIONS(2812),
    [anon_sym_async] = ACTIONS(2812),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_new] = ACTIONS(2812),
    [anon_sym_AMP] = ACTIONS(2814),
    [anon_sym_PLUS] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2812),
    [anon_sym_TILDE] = ACTIONS(2814),
    [anon_sym_void] = ACTIONS(2812),
    [anon_sym_delete] = ACTIONS(2812),
    [anon_sym_PLUS_PLUS] = ACTIONS(2814),
    [anon_sym_DASH_DASH] = ACTIONS(2814),
    [anon_sym_DQUOTE] = ACTIONS(2814),
    [anon_sym_SQUOTE] = ACTIONS(2814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2814),
    [sym_number] = ACTIONS(2814),
    [sym_this] = ACTIONS(2812),
    [sym_super] = ACTIONS(2812),
    [sym_true] = ACTIONS(2812),
    [sym_false] = ACTIONS(2812),
    [sym_null] = ACTIONS(2812),
    [sym_undefined] = ACTIONS(2812),
    [anon_sym_AT] = ACTIONS(2814),
    [anon_sym_static] = ACTIONS(2812),
    [anon_sym_readonly] = ACTIONS(2812),
    [anon_sym_get] = ACTIONS(2812),
    [anon_sym_set] = ACTIONS(2812),
    [anon_sym_declare] = ACTIONS(2812),
    [anon_sym_namespace] = ACTIONS(2812),
    [anon_sym_public] = ACTIONS(2812),
    [anon_sym_private] = ACTIONS(2812),
    [anon_sym_protected] = ACTIONS(2812),
    [anon_sym_override] = ACTIONS(2812),
    [anon_sym_module] = ACTIONS(2812),
    [anon_sym_any] = ACTIONS(2812),
    [anon_sym_number] = ACTIONS(2812),
    [anon_sym_boolean] = ACTIONS(2812),
    [anon_sym_string] = ACTIONS(2812),
    [anon_sym_symbol] = ACTIONS(2812),
    [anon_sym_abstract] = ACTIONS(2812),
    [anon_sym_interface] = ACTIONS(2812),
    [anon_sym_enum] = ACTIONS(2812),
    [anon_sym_component] = ACTIONS(2812),
  },
  [780] = {
    [sym_identifier] = ACTIONS(2816),
    [anon_sym_export] = ACTIONS(2816),
    [anon_sym_LBRACE] = ACTIONS(2818),
    [anon_sym_RBRACE] = ACTIONS(2818),
    [anon_sym_type] = ACTIONS(2816),
    [anon_sym_typeof] = ACTIONS(2816),
    [anon_sym_import] = ACTIONS(2816),
    [anon_sym_var] = ACTIONS(2816),
    [anon_sym_let] = ACTIONS(2816),
    [anon_sym_const] = ACTIONS(2816),
    [anon_sym_BANG] = ACTIONS(2818),
    [anon_sym_else] = ACTIONS(2816),
    [anon_sym_if] = ACTIONS(2816),
    [anon_sym_switch] = ACTIONS(2816),
    [anon_sym_for] = ACTIONS(2816),
    [anon_sym_LPAREN] = ACTIONS(2818),
    [anon_sym_await] = ACTIONS(2816),
    [anon_sym_while] = ACTIONS(2816),
    [anon_sym_do] = ACTIONS(2816),
    [anon_sym_try] = ACTIONS(2816),
    [anon_sym_with] = ACTIONS(2816),
    [anon_sym_break] = ACTIONS(2816),
    [anon_sym_continue] = ACTIONS(2816),
    [anon_sym_debugger] = ACTIONS(2816),
    [anon_sym_return] = ACTIONS(2816),
    [anon_sym_throw] = ACTIONS(2816),
    [anon_sym_SEMI] = ACTIONS(2818),
    [anon_sym_case] = ACTIONS(2816),
    [anon_sym_default] = ACTIONS(2816),
    [anon_sym_yield] = ACTIONS(2816),
    [anon_sym_LBRACK] = ACTIONS(2818),
    [anon_sym_LTtemplate_GT] = ACTIONS(2818),
    [anon_sym_LT] = ACTIONS(2816),
    [anon_sym_SLASH] = ACTIONS(2816),
    [anon_sym_class] = ACTIONS(2816),
    [anon_sym_async] = ACTIONS(2816),
    [anon_sym_function] = ACTIONS(2816),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_AMP] = ACTIONS(2818),
    [anon_sym_PLUS] = ACTIONS(2816),
    [anon_sym_DASH] = ACTIONS(2816),
    [anon_sym_TILDE] = ACTIONS(2818),
    [anon_sym_void] = ACTIONS(2816),
    [anon_sym_delete] = ACTIONS(2816),
    [anon_sym_PLUS_PLUS] = ACTIONS(2818),
    [anon_sym_DASH_DASH] = ACTIONS(2818),
    [anon_sym_DQUOTE] = ACTIONS(2818),
    [anon_sym_SQUOTE] = ACTIONS(2818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [sym_number] = ACTIONS(2818),
    [sym_this] = ACTIONS(2816),
    [sym_super] = ACTIONS(2816),
    [sym_true] = ACTIONS(2816),
    [sym_false] = ACTIONS(2816),
    [sym_null] = ACTIONS(2816),
    [sym_undefined] = ACTIONS(2816),
    [anon_sym_AT] = ACTIONS(2818),
    [anon_sym_static] = ACTIONS(2816),
    [anon_sym_readonly] = ACTIONS(2816),
    [anon_sym_get] = ACTIONS(2816),
    [anon_sym_set] = ACTIONS(2816),
    [anon_sym_declare] = ACTIONS(2816),
    [anon_sym_namespace] = ACTIONS(2816),
    [anon_sym_public] = ACTIONS(2816),
    [anon_sym_private] = ACTIONS(2816),
    [anon_sym_protected] = ACTIONS(2816),
    [anon_sym_override] = ACTIONS(2816),
    [anon_sym_module] = ACTIONS(2816),
    [anon_sym_any] = ACTIONS(2816),
    [anon_sym_number] = ACTIONS(2816),
    [anon_sym_boolean] = ACTIONS(2816),
    [anon_sym_string] = ACTIONS(2816),
    [anon_sym_symbol] = ACTIONS(2816),
    [anon_sym_abstract] = ACTIONS(2816),
    [anon_sym_interface] = ACTIONS(2816),
    [anon_sym_enum] = ACTIONS(2816),
    [anon_sym_component] = ACTIONS(2816),
  },
  [781] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2820),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2820),
    [anon_sym_RBRACE] = ACTIONS(2822),
    [anon_sym_typeof] = ACTIONS(2820),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2822),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2820),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2820),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_QMARK_QMARK] = ACTIONS(2650),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(2820),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2822),
    [anon_sym_SQUOTE] = ACTIONS(2822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2822),
    [sym_number] = ACTIONS(2822),
    [sym_this] = ACTIONS(2820),
    [sym_true] = ACTIONS(2820),
    [sym_false] = ACTIONS(2820),
    [sym_null] = ACTIONS(2820),
    [sym_undefined] = ACTIONS(2820),
    [anon_sym_static] = ACTIONS(2820),
    [anon_sym_readonly] = ACTIONS(2820),
    [anon_sym_get] = ACTIONS(2820),
    [anon_sym_set] = ACTIONS(2820),
    [anon_sym_QMARK] = ACTIONS(2820),
    [anon_sym_any] = ACTIONS(2820),
    [anon_sym_number] = ACTIONS(2820),
    [anon_sym_boolean] = ACTIONS(2820),
    [anon_sym_string] = ACTIONS(2820),
    [anon_sym_symbol] = ACTIONS(2820),
    [anon_sym_abstract] = ACTIONS(2820),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2820),
    [anon_sym_keyof] = ACTIONS(2820),
    [anon_sym_unknown] = ACTIONS(2820),
    [anon_sym_never] = ACTIONS(2820),
    [anon_sym_object] = ACTIONS(2820),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2822),
    [anon_sym_constructor] = ACTIONS(2820),
    [anon_sym_prop] = ACTIONS(2820),
    [anon_sym_id] = ACTIONS(2820),
    [anon_sym_event] = ACTIONS(2820),
    [anon_sym_fn] = ACTIONS(2820),
    [anon_sym_on] = ACTIONS(2820),
    [sym__ternary_qmark] = ACTIONS(2656),
  },
  [782] = {
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LTtemplate_GT] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_readonly] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_override] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_component] = ACTIONS(2604),
  },
  [783] = {
    [sym_identifier] = ACTIONS(2824),
    [anon_sym_export] = ACTIONS(2824),
    [anon_sym_LBRACE] = ACTIONS(2826),
    [anon_sym_RBRACE] = ACTIONS(2826),
    [anon_sym_type] = ACTIONS(2824),
    [anon_sym_typeof] = ACTIONS(2824),
    [anon_sym_import] = ACTIONS(2824),
    [anon_sym_var] = ACTIONS(2824),
    [anon_sym_let] = ACTIONS(2824),
    [anon_sym_const] = ACTIONS(2824),
    [anon_sym_BANG] = ACTIONS(2826),
    [anon_sym_else] = ACTIONS(2824),
    [anon_sym_if] = ACTIONS(2824),
    [anon_sym_switch] = ACTIONS(2824),
    [anon_sym_for] = ACTIONS(2824),
    [anon_sym_LPAREN] = ACTIONS(2826),
    [anon_sym_await] = ACTIONS(2824),
    [anon_sym_while] = ACTIONS(2824),
    [anon_sym_do] = ACTIONS(2824),
    [anon_sym_try] = ACTIONS(2824),
    [anon_sym_with] = ACTIONS(2824),
    [anon_sym_break] = ACTIONS(2824),
    [anon_sym_continue] = ACTIONS(2824),
    [anon_sym_debugger] = ACTIONS(2824),
    [anon_sym_return] = ACTIONS(2824),
    [anon_sym_throw] = ACTIONS(2824),
    [anon_sym_SEMI] = ACTIONS(2826),
    [anon_sym_case] = ACTIONS(2824),
    [anon_sym_default] = ACTIONS(2824),
    [anon_sym_yield] = ACTIONS(2824),
    [anon_sym_LBRACK] = ACTIONS(2826),
    [anon_sym_LTtemplate_GT] = ACTIONS(2826),
    [anon_sym_LT] = ACTIONS(2824),
    [anon_sym_SLASH] = ACTIONS(2824),
    [anon_sym_class] = ACTIONS(2824),
    [anon_sym_async] = ACTIONS(2824),
    [anon_sym_function] = ACTIONS(2824),
    [anon_sym_new] = ACTIONS(2824),
    [anon_sym_AMP] = ACTIONS(2826),
    [anon_sym_PLUS] = ACTIONS(2824),
    [anon_sym_DASH] = ACTIONS(2824),
    [anon_sym_TILDE] = ACTIONS(2826),
    [anon_sym_void] = ACTIONS(2824),
    [anon_sym_delete] = ACTIONS(2824),
    [anon_sym_PLUS_PLUS] = ACTIONS(2826),
    [anon_sym_DASH_DASH] = ACTIONS(2826),
    [anon_sym_DQUOTE] = ACTIONS(2826),
    [anon_sym_SQUOTE] = ACTIONS(2826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2826),
    [sym_number] = ACTIONS(2826),
    [sym_this] = ACTIONS(2824),
    [sym_super] = ACTIONS(2824),
    [sym_true] = ACTIONS(2824),
    [sym_false] = ACTIONS(2824),
    [sym_null] = ACTIONS(2824),
    [sym_undefined] = ACTIONS(2824),
    [anon_sym_AT] = ACTIONS(2826),
    [anon_sym_static] = ACTIONS(2824),
    [anon_sym_readonly] = ACTIONS(2824),
    [anon_sym_get] = ACTIONS(2824),
    [anon_sym_set] = ACTIONS(2824),
    [anon_sym_declare] = ACTIONS(2824),
    [anon_sym_namespace] = ACTIONS(2824),
    [anon_sym_public] = ACTIONS(2824),
    [anon_sym_private] = ACTIONS(2824),
    [anon_sym_protected] = ACTIONS(2824),
    [anon_sym_override] = ACTIONS(2824),
    [anon_sym_module] = ACTIONS(2824),
    [anon_sym_any] = ACTIONS(2824),
    [anon_sym_number] = ACTIONS(2824),
    [anon_sym_boolean] = ACTIONS(2824),
    [anon_sym_string] = ACTIONS(2824),
    [anon_sym_symbol] = ACTIONS(2824),
    [anon_sym_abstract] = ACTIONS(2824),
    [anon_sym_interface] = ACTIONS(2824),
    [anon_sym_enum] = ACTIONS(2824),
    [anon_sym_component] = ACTIONS(2824),
  },
  [784] = {
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LTtemplate_GT] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_readonly] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_override] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_component] = ACTIONS(2604),
  },
  [785] = {
    [sym_arguments] = STATE(895),
    [sym_identifier] = ACTIONS(2828),
    [anon_sym_STAR] = ACTIONS(2828),
    [anon_sym_as] = ACTIONS(2828),
    [anon_sym_LBRACE] = ACTIONS(2828),
    [anon_sym_RBRACE] = ACTIONS(2830),
    [anon_sym_typeof] = ACTIONS(2828),
    [anon_sym_BANG] = ACTIONS(2828),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2828),
    [anon_sym_SEMI] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_LT] = ACTIONS(2828),
    [anon_sym_GT] = ACTIONS(2828),
    [anon_sym_SLASH] = ACTIONS(2828),
    [anon_sym_DOT] = ACTIONS(2832),
    [anon_sym_async] = ACTIONS(2828),
    [anon_sym_QMARK_DOT] = ACTIONS(2830),
    [anon_sym_new] = ACTIONS(2828),
    [anon_sym_AMP_AMP] = ACTIONS(2830),
    [anon_sym_PIPE_PIPE] = ACTIONS(2830),
    [anon_sym_GT_GT] = ACTIONS(2828),
    [anon_sym_GT_GT_GT] = ACTIONS(2830),
    [anon_sym_LT_LT] = ACTIONS(2830),
    [anon_sym_AMP] = ACTIONS(2828),
    [anon_sym_CARET] = ACTIONS(2830),
    [anon_sym_PIPE] = ACTIONS(2828),
    [anon_sym_PLUS] = ACTIONS(2828),
    [anon_sym_DASH] = ACTIONS(2828),
    [anon_sym_PERCENT] = ACTIONS(2830),
    [anon_sym_STAR_STAR] = ACTIONS(2830),
    [anon_sym_LT_EQ] = ACTIONS(2830),
    [anon_sym_EQ_EQ] = ACTIONS(2828),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2830),
    [anon_sym_BANG_EQ] = ACTIONS(2828),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2830),
    [anon_sym_GT_EQ] = ACTIONS(2830),
    [anon_sym_QMARK_QMARK] = ACTIONS(2830),
    [anon_sym_instanceof] = ACTIONS(2828),
    [anon_sym_void] = ACTIONS(2828),
    [anon_sym_PLUS_PLUS] = ACTIONS(2830),
    [anon_sym_DASH_DASH] = ACTIONS(2830),
    [anon_sym_DQUOTE] = ACTIONS(2830),
    [anon_sym_SQUOTE] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2830),
    [sym_number] = ACTIONS(2830),
    [sym_this] = ACTIONS(2828),
    [sym_true] = ACTIONS(2828),
    [sym_false] = ACTIONS(2828),
    [sym_null] = ACTIONS(2828),
    [sym_undefined] = ACTIONS(2828),
    [anon_sym_static] = ACTIONS(2828),
    [anon_sym_readonly] = ACTIONS(2828),
    [anon_sym_get] = ACTIONS(2828),
    [anon_sym_set] = ACTIONS(2828),
    [anon_sym_QMARK] = ACTIONS(2828),
    [anon_sym_any] = ACTIONS(2828),
    [anon_sym_number] = ACTIONS(2828),
    [anon_sym_boolean] = ACTIONS(2828),
    [anon_sym_string] = ACTIONS(2828),
    [anon_sym_symbol] = ACTIONS(2828),
    [anon_sym_abstract] = ACTIONS(2828),
    [anon_sym_satisfies] = ACTIONS(2828),
    [anon_sym_extends] = ACTIONS(2828),
    [anon_sym_infer] = ACTIONS(2828),
    [anon_sym_keyof] = ACTIONS(2828),
    [anon_sym_unknown] = ACTIONS(2828),
    [anon_sym_never] = ACTIONS(2828),
    [anon_sym_object] = ACTIONS(2828),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2830),
    [anon_sym_constructor] = ACTIONS(2828),
    [anon_sym_prop] = ACTIONS(2828),
    [anon_sym_id] = ACTIONS(2828),
    [anon_sym_event] = ACTIONS(2828),
    [anon_sym_fn] = ACTIONS(2828),
    [anon_sym_on] = ACTIONS(2828),
    [sym__ternary_qmark] = ACTIONS(2830),
  },
  [786] = {
    [sym_type_arguments] = STATE(951),
    [sym_identifier] = ACTIONS(2834),
    [anon_sym_STAR] = ACTIONS(2834),
    [anon_sym_as] = ACTIONS(2834),
    [anon_sym_LBRACE] = ACTIONS(2834),
    [anon_sym_RBRACE] = ACTIONS(2836),
    [anon_sym_typeof] = ACTIONS(2834),
    [anon_sym_BANG] = ACTIONS(2834),
    [anon_sym_LPAREN] = ACTIONS(2836),
    [anon_sym_in] = ACTIONS(2834),
    [anon_sym_SEMI] = ACTIONS(2836),
    [anon_sym_LBRACK] = ACTIONS(2836),
    [anon_sym_LT] = ACTIONS(2560),
    [anon_sym_GT] = ACTIONS(2834),
    [anon_sym_SLASH] = ACTIONS(2834),
    [anon_sym_DOT] = ACTIONS(2834),
    [anon_sym_async] = ACTIONS(2834),
    [anon_sym_QMARK_DOT] = ACTIONS(2836),
    [anon_sym_new] = ACTIONS(2834),
    [anon_sym_AMP_AMP] = ACTIONS(2836),
    [anon_sym_PIPE_PIPE] = ACTIONS(2836),
    [anon_sym_GT_GT] = ACTIONS(2834),
    [anon_sym_GT_GT_GT] = ACTIONS(2836),
    [anon_sym_LT_LT] = ACTIONS(2836),
    [anon_sym_AMP] = ACTIONS(2834),
    [anon_sym_CARET] = ACTIONS(2836),
    [anon_sym_PIPE] = ACTIONS(2834),
    [anon_sym_PLUS] = ACTIONS(2834),
    [anon_sym_DASH] = ACTIONS(2834),
    [anon_sym_PERCENT] = ACTIONS(2836),
    [anon_sym_STAR_STAR] = ACTIONS(2836),
    [anon_sym_LT_EQ] = ACTIONS(2836),
    [anon_sym_EQ_EQ] = ACTIONS(2834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2836),
    [anon_sym_BANG_EQ] = ACTIONS(2834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2836),
    [anon_sym_GT_EQ] = ACTIONS(2836),
    [anon_sym_QMARK_QMARK] = ACTIONS(2836),
    [anon_sym_instanceof] = ACTIONS(2834),
    [anon_sym_void] = ACTIONS(2834),
    [anon_sym_PLUS_PLUS] = ACTIONS(2836),
    [anon_sym_DASH_DASH] = ACTIONS(2836),
    [anon_sym_DQUOTE] = ACTIONS(2836),
    [anon_sym_SQUOTE] = ACTIONS(2836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2836),
    [sym_number] = ACTIONS(2836),
    [sym_this] = ACTIONS(2834),
    [sym_true] = ACTIONS(2834),
    [sym_false] = ACTIONS(2834),
    [sym_null] = ACTIONS(2834),
    [sym_undefined] = ACTIONS(2834),
    [anon_sym_static] = ACTIONS(2834),
    [anon_sym_readonly] = ACTIONS(2834),
    [anon_sym_get] = ACTIONS(2834),
    [anon_sym_set] = ACTIONS(2834),
    [anon_sym_QMARK] = ACTIONS(2834),
    [anon_sym_any] = ACTIONS(2834),
    [anon_sym_number] = ACTIONS(2834),
    [anon_sym_boolean] = ACTIONS(2834),
    [anon_sym_string] = ACTIONS(2834),
    [anon_sym_symbol] = ACTIONS(2834),
    [anon_sym_abstract] = ACTIONS(2834),
    [anon_sym_satisfies] = ACTIONS(2834),
    [anon_sym_extends] = ACTIONS(2834),
    [anon_sym_infer] = ACTIONS(2834),
    [anon_sym_keyof] = ACTIONS(2834),
    [anon_sym_unknown] = ACTIONS(2834),
    [anon_sym_never] = ACTIONS(2834),
    [anon_sym_object] = ACTIONS(2834),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2836),
    [anon_sym_constructor] = ACTIONS(2834),
    [anon_sym_prop] = ACTIONS(2834),
    [anon_sym_id] = ACTIONS(2834),
    [anon_sym_event] = ACTIONS(2834),
    [anon_sym_fn] = ACTIONS(2834),
    [anon_sym_on] = ACTIONS(2834),
    [sym__ternary_qmark] = ACTIONS(2836),
  },
  [787] = {
    [sym_identifier] = ACTIONS(2838),
    [anon_sym_export] = ACTIONS(2838),
    [anon_sym_LBRACE] = ACTIONS(2840),
    [anon_sym_RBRACE] = ACTIONS(2840),
    [anon_sym_type] = ACTIONS(2838),
    [anon_sym_typeof] = ACTIONS(2838),
    [anon_sym_import] = ACTIONS(2838),
    [anon_sym_var] = ACTIONS(2838),
    [anon_sym_let] = ACTIONS(2838),
    [anon_sym_const] = ACTIONS(2838),
    [anon_sym_BANG] = ACTIONS(2840),
    [anon_sym_else] = ACTIONS(2838),
    [anon_sym_if] = ACTIONS(2838),
    [anon_sym_switch] = ACTIONS(2838),
    [anon_sym_for] = ACTIONS(2838),
    [anon_sym_LPAREN] = ACTIONS(2840),
    [anon_sym_await] = ACTIONS(2838),
    [anon_sym_while] = ACTIONS(2838),
    [anon_sym_do] = ACTIONS(2838),
    [anon_sym_try] = ACTIONS(2838),
    [anon_sym_with] = ACTIONS(2838),
    [anon_sym_break] = ACTIONS(2838),
    [anon_sym_continue] = ACTIONS(2838),
    [anon_sym_debugger] = ACTIONS(2838),
    [anon_sym_return] = ACTIONS(2838),
    [anon_sym_throw] = ACTIONS(2838),
    [anon_sym_SEMI] = ACTIONS(2840),
    [anon_sym_case] = ACTIONS(2838),
    [anon_sym_default] = ACTIONS(2838),
    [anon_sym_yield] = ACTIONS(2838),
    [anon_sym_LBRACK] = ACTIONS(2840),
    [anon_sym_LTtemplate_GT] = ACTIONS(2840),
    [anon_sym_LT] = ACTIONS(2838),
    [anon_sym_SLASH] = ACTIONS(2838),
    [anon_sym_class] = ACTIONS(2838),
    [anon_sym_async] = ACTIONS(2838),
    [anon_sym_function] = ACTIONS(2838),
    [anon_sym_new] = ACTIONS(2838),
    [anon_sym_AMP] = ACTIONS(2840),
    [anon_sym_PLUS] = ACTIONS(2838),
    [anon_sym_DASH] = ACTIONS(2838),
    [anon_sym_TILDE] = ACTIONS(2840),
    [anon_sym_void] = ACTIONS(2838),
    [anon_sym_delete] = ACTIONS(2838),
    [anon_sym_PLUS_PLUS] = ACTIONS(2840),
    [anon_sym_DASH_DASH] = ACTIONS(2840),
    [anon_sym_DQUOTE] = ACTIONS(2840),
    [anon_sym_SQUOTE] = ACTIONS(2840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2840),
    [sym_number] = ACTIONS(2840),
    [sym_this] = ACTIONS(2838),
    [sym_super] = ACTIONS(2838),
    [sym_true] = ACTIONS(2838),
    [sym_false] = ACTIONS(2838),
    [sym_null] = ACTIONS(2838),
    [sym_undefined] = ACTIONS(2838),
    [anon_sym_AT] = ACTIONS(2840),
    [anon_sym_static] = ACTIONS(2838),
    [anon_sym_readonly] = ACTIONS(2838),
    [anon_sym_get] = ACTIONS(2838),
    [anon_sym_set] = ACTIONS(2838),
    [anon_sym_declare] = ACTIONS(2838),
    [anon_sym_namespace] = ACTIONS(2838),
    [anon_sym_public] = ACTIONS(2838),
    [anon_sym_private] = ACTIONS(2838),
    [anon_sym_protected] = ACTIONS(2838),
    [anon_sym_override] = ACTIONS(2838),
    [anon_sym_module] = ACTIONS(2838),
    [anon_sym_any] = ACTIONS(2838),
    [anon_sym_number] = ACTIONS(2838),
    [anon_sym_boolean] = ACTIONS(2838),
    [anon_sym_string] = ACTIONS(2838),
    [anon_sym_symbol] = ACTIONS(2838),
    [anon_sym_abstract] = ACTIONS(2838),
    [anon_sym_interface] = ACTIONS(2838),
    [anon_sym_enum] = ACTIONS(2838),
    [anon_sym_component] = ACTIONS(2838),
  },
  [788] = {
    [sym_arguments] = STATE(896),
    [sym_identifier] = ACTIONS(2842),
    [anon_sym_STAR] = ACTIONS(2842),
    [anon_sym_as] = ACTIONS(2842),
    [anon_sym_LBRACE] = ACTIONS(2842),
    [anon_sym_RBRACE] = ACTIONS(2844),
    [anon_sym_typeof] = ACTIONS(2842),
    [anon_sym_BANG] = ACTIONS(2842),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2842),
    [anon_sym_SEMI] = ACTIONS(2844),
    [anon_sym_LBRACK] = ACTIONS(2844),
    [anon_sym_LT] = ACTIONS(2842),
    [anon_sym_GT] = ACTIONS(2842),
    [anon_sym_SLASH] = ACTIONS(2842),
    [anon_sym_DOT] = ACTIONS(2846),
    [anon_sym_async] = ACTIONS(2842),
    [anon_sym_QMARK_DOT] = ACTIONS(2844),
    [anon_sym_new] = ACTIONS(2842),
    [anon_sym_AMP_AMP] = ACTIONS(2844),
    [anon_sym_PIPE_PIPE] = ACTIONS(2844),
    [anon_sym_GT_GT] = ACTIONS(2842),
    [anon_sym_GT_GT_GT] = ACTIONS(2844),
    [anon_sym_LT_LT] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2842),
    [anon_sym_CARET] = ACTIONS(2844),
    [anon_sym_PIPE] = ACTIONS(2842),
    [anon_sym_PLUS] = ACTIONS(2842),
    [anon_sym_DASH] = ACTIONS(2842),
    [anon_sym_PERCENT] = ACTIONS(2844),
    [anon_sym_STAR_STAR] = ACTIONS(2844),
    [anon_sym_LT_EQ] = ACTIONS(2844),
    [anon_sym_EQ_EQ] = ACTIONS(2842),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2844),
    [anon_sym_BANG_EQ] = ACTIONS(2842),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2844),
    [anon_sym_GT_EQ] = ACTIONS(2844),
    [anon_sym_QMARK_QMARK] = ACTIONS(2844),
    [anon_sym_instanceof] = ACTIONS(2842),
    [anon_sym_void] = ACTIONS(2842),
    [anon_sym_PLUS_PLUS] = ACTIONS(2844),
    [anon_sym_DASH_DASH] = ACTIONS(2844),
    [anon_sym_DQUOTE] = ACTIONS(2844),
    [anon_sym_SQUOTE] = ACTIONS(2844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2844),
    [sym_number] = ACTIONS(2844),
    [sym_this] = ACTIONS(2842),
    [sym_true] = ACTIONS(2842),
    [sym_false] = ACTIONS(2842),
    [sym_null] = ACTIONS(2842),
    [sym_undefined] = ACTIONS(2842),
    [anon_sym_static] = ACTIONS(2842),
    [anon_sym_readonly] = ACTIONS(2842),
    [anon_sym_get] = ACTIONS(2842),
    [anon_sym_set] = ACTIONS(2842),
    [anon_sym_QMARK] = ACTIONS(2842),
    [anon_sym_any] = ACTIONS(2842),
    [anon_sym_number] = ACTIONS(2842),
    [anon_sym_boolean] = ACTIONS(2842),
    [anon_sym_string] = ACTIONS(2842),
    [anon_sym_symbol] = ACTIONS(2842),
    [anon_sym_abstract] = ACTIONS(2842),
    [anon_sym_satisfies] = ACTIONS(2842),
    [anon_sym_extends] = ACTIONS(2842),
    [anon_sym_infer] = ACTIONS(2842),
    [anon_sym_keyof] = ACTIONS(2842),
    [anon_sym_unknown] = ACTIONS(2842),
    [anon_sym_never] = ACTIONS(2842),
    [anon_sym_object] = ACTIONS(2842),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2844),
    [anon_sym_constructor] = ACTIONS(2842),
    [anon_sym_prop] = ACTIONS(2842),
    [anon_sym_id] = ACTIONS(2842),
    [anon_sym_event] = ACTIONS(2842),
    [anon_sym_fn] = ACTIONS(2842),
    [anon_sym_on] = ACTIONS(2842),
    [sym__ternary_qmark] = ACTIONS(2844),
  },
  [789] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2848),
    [anon_sym_STAR] = ACTIONS(2848),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2848),
    [anon_sym_RBRACE] = ACTIONS(2850),
    [anon_sym_typeof] = ACTIONS(2848),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2848),
    [anon_sym_SEMI] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2848),
    [anon_sym_GT] = ACTIONS(2848),
    [anon_sym_SLASH] = ACTIONS(2848),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2848),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2848),
    [anon_sym_AMP_AMP] = ACTIONS(2850),
    [anon_sym_PIPE_PIPE] = ACTIONS(2850),
    [anon_sym_GT_GT] = ACTIONS(2848),
    [anon_sym_GT_GT_GT] = ACTIONS(2850),
    [anon_sym_LT_LT] = ACTIONS(2850),
    [anon_sym_AMP] = ACTIONS(2848),
    [anon_sym_CARET] = ACTIONS(2850),
    [anon_sym_PIPE] = ACTIONS(2848),
    [anon_sym_PLUS] = ACTIONS(2848),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_PERCENT] = ACTIONS(2850),
    [anon_sym_STAR_STAR] = ACTIONS(2850),
    [anon_sym_LT_EQ] = ACTIONS(2850),
    [anon_sym_EQ_EQ] = ACTIONS(2848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2850),
    [anon_sym_BANG_EQ] = ACTIONS(2848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2850),
    [anon_sym_GT_EQ] = ACTIONS(2850),
    [anon_sym_QMARK_QMARK] = ACTIONS(2850),
    [anon_sym_instanceof] = ACTIONS(2848),
    [anon_sym_void] = ACTIONS(2848),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2850),
    [anon_sym_SQUOTE] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2850),
    [sym_number] = ACTIONS(2850),
    [sym_this] = ACTIONS(2848),
    [sym_true] = ACTIONS(2848),
    [sym_false] = ACTIONS(2848),
    [sym_null] = ACTIONS(2848),
    [sym_undefined] = ACTIONS(2848),
    [anon_sym_static] = ACTIONS(2848),
    [anon_sym_readonly] = ACTIONS(2848),
    [anon_sym_get] = ACTIONS(2848),
    [anon_sym_set] = ACTIONS(2848),
    [anon_sym_QMARK] = ACTIONS(2848),
    [anon_sym_any] = ACTIONS(2848),
    [anon_sym_number] = ACTIONS(2848),
    [anon_sym_boolean] = ACTIONS(2848),
    [anon_sym_string] = ACTIONS(2848),
    [anon_sym_symbol] = ACTIONS(2848),
    [anon_sym_abstract] = ACTIONS(2848),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2848),
    [anon_sym_keyof] = ACTIONS(2848),
    [anon_sym_unknown] = ACTIONS(2848),
    [anon_sym_never] = ACTIONS(2848),
    [anon_sym_object] = ACTIONS(2848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2850),
    [anon_sym_constructor] = ACTIONS(2848),
    [anon_sym_prop] = ACTIONS(2848),
    [anon_sym_id] = ACTIONS(2848),
    [anon_sym_event] = ACTIONS(2848),
    [anon_sym_fn] = ACTIONS(2848),
    [anon_sym_on] = ACTIONS(2848),
    [sym__ternary_qmark] = ACTIONS(2850),
  },
  [790] = {
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LTtemplate_GT] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_readonly] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_override] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_component] = ACTIONS(2604),
  },
  [791] = {
    [sym_identifier] = ACTIONS(2852),
    [anon_sym_export] = ACTIONS(2852),
    [anon_sym_LBRACE] = ACTIONS(2854),
    [anon_sym_RBRACE] = ACTIONS(2854),
    [anon_sym_type] = ACTIONS(2852),
    [anon_sym_typeof] = ACTIONS(2852),
    [anon_sym_import] = ACTIONS(2852),
    [anon_sym_var] = ACTIONS(2852),
    [anon_sym_let] = ACTIONS(2852),
    [anon_sym_const] = ACTIONS(2852),
    [anon_sym_BANG] = ACTIONS(2854),
    [anon_sym_else] = ACTIONS(2852),
    [anon_sym_if] = ACTIONS(2852),
    [anon_sym_switch] = ACTIONS(2852),
    [anon_sym_for] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2854),
    [anon_sym_await] = ACTIONS(2852),
    [anon_sym_while] = ACTIONS(2852),
    [anon_sym_do] = ACTIONS(2852),
    [anon_sym_try] = ACTIONS(2852),
    [anon_sym_with] = ACTIONS(2852),
    [anon_sym_break] = ACTIONS(2852),
    [anon_sym_continue] = ACTIONS(2852),
    [anon_sym_debugger] = ACTIONS(2852),
    [anon_sym_return] = ACTIONS(2852),
    [anon_sym_throw] = ACTIONS(2852),
    [anon_sym_SEMI] = ACTIONS(2854),
    [anon_sym_case] = ACTIONS(2852),
    [anon_sym_default] = ACTIONS(2852),
    [anon_sym_yield] = ACTIONS(2852),
    [anon_sym_LBRACK] = ACTIONS(2854),
    [anon_sym_LTtemplate_GT] = ACTIONS(2854),
    [anon_sym_LT] = ACTIONS(2852),
    [anon_sym_SLASH] = ACTIONS(2852),
    [anon_sym_class] = ACTIONS(2852),
    [anon_sym_async] = ACTIONS(2852),
    [anon_sym_function] = ACTIONS(2852),
    [anon_sym_new] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2854),
    [anon_sym_PLUS] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2854),
    [anon_sym_void] = ACTIONS(2852),
    [anon_sym_delete] = ACTIONS(2852),
    [anon_sym_PLUS_PLUS] = ACTIONS(2854),
    [anon_sym_DASH_DASH] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2854),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2854),
    [sym_number] = ACTIONS(2854),
    [sym_this] = ACTIONS(2852),
    [sym_super] = ACTIONS(2852),
    [sym_true] = ACTIONS(2852),
    [sym_false] = ACTIONS(2852),
    [sym_null] = ACTIONS(2852),
    [sym_undefined] = ACTIONS(2852),
    [anon_sym_AT] = ACTIONS(2854),
    [anon_sym_static] = ACTIONS(2852),
    [anon_sym_readonly] = ACTIONS(2852),
    [anon_sym_get] = ACTIONS(2852),
    [anon_sym_set] = ACTIONS(2852),
    [anon_sym_declare] = ACTIONS(2852),
    [anon_sym_namespace] = ACTIONS(2852),
    [anon_sym_public] = ACTIONS(2852),
    [anon_sym_private] = ACTIONS(2852),
    [anon_sym_protected] = ACTIONS(2852),
    [anon_sym_override] = ACTIONS(2852),
    [anon_sym_module] = ACTIONS(2852),
    [anon_sym_any] = ACTIONS(2852),
    [anon_sym_number] = ACTIONS(2852),
    [anon_sym_boolean] = ACTIONS(2852),
    [anon_sym_string] = ACTIONS(2852),
    [anon_sym_symbol] = ACTIONS(2852),
    [anon_sym_abstract] = ACTIONS(2852),
    [anon_sym_interface] = ACTIONS(2852),
    [anon_sym_enum] = ACTIONS(2852),
    [anon_sym_component] = ACTIONS(2852),
  },
  [792] = {
    [sym_identifier] = ACTIONS(2856),
    [anon_sym_export] = ACTIONS(2856),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_RBRACE] = ACTIONS(2858),
    [anon_sym_type] = ACTIONS(2856),
    [anon_sym_typeof] = ACTIONS(2856),
    [anon_sym_import] = ACTIONS(2856),
    [anon_sym_var] = ACTIONS(2856),
    [anon_sym_let] = ACTIONS(2856),
    [anon_sym_const] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_else] = ACTIONS(2856),
    [anon_sym_if] = ACTIONS(2856),
    [anon_sym_switch] = ACTIONS(2856),
    [anon_sym_for] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_await] = ACTIONS(2856),
    [anon_sym_while] = ACTIONS(2856),
    [anon_sym_do] = ACTIONS(2856),
    [anon_sym_try] = ACTIONS(2856),
    [anon_sym_with] = ACTIONS(2856),
    [anon_sym_break] = ACTIONS(2856),
    [anon_sym_continue] = ACTIONS(2856),
    [anon_sym_debugger] = ACTIONS(2856),
    [anon_sym_return] = ACTIONS(2856),
    [anon_sym_throw] = ACTIONS(2856),
    [anon_sym_SEMI] = ACTIONS(2858),
    [anon_sym_case] = ACTIONS(2856),
    [anon_sym_default] = ACTIONS(2856),
    [anon_sym_yield] = ACTIONS(2856),
    [anon_sym_LBRACK] = ACTIONS(2858),
    [anon_sym_LTtemplate_GT] = ACTIONS(2858),
    [anon_sym_LT] = ACTIONS(2856),
    [anon_sym_SLASH] = ACTIONS(2856),
    [anon_sym_class] = ACTIONS(2856),
    [anon_sym_async] = ACTIONS(2856),
    [anon_sym_function] = ACTIONS(2856),
    [anon_sym_new] = ACTIONS(2856),
    [anon_sym_AMP] = ACTIONS(2858),
    [anon_sym_PLUS] = ACTIONS(2856),
    [anon_sym_DASH] = ACTIONS(2856),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_void] = ACTIONS(2856),
    [anon_sym_delete] = ACTIONS(2856),
    [anon_sym_PLUS_PLUS] = ACTIONS(2858),
    [anon_sym_DASH_DASH] = ACTIONS(2858),
    [anon_sym_DQUOTE] = ACTIONS(2858),
    [anon_sym_SQUOTE] = ACTIONS(2858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2858),
    [sym_number] = ACTIONS(2858),
    [sym_this] = ACTIONS(2856),
    [sym_super] = ACTIONS(2856),
    [sym_true] = ACTIONS(2856),
    [sym_false] = ACTIONS(2856),
    [sym_null] = ACTIONS(2856),
    [sym_undefined] = ACTIONS(2856),
    [anon_sym_AT] = ACTIONS(2858),
    [anon_sym_static] = ACTIONS(2856),
    [anon_sym_readonly] = ACTIONS(2856),
    [anon_sym_get] = ACTIONS(2856),
    [anon_sym_set] = ACTIONS(2856),
    [anon_sym_declare] = ACTIONS(2856),
    [anon_sym_namespace] = ACTIONS(2856),
    [anon_sym_public] = ACTIONS(2856),
    [anon_sym_private] = ACTIONS(2856),
    [anon_sym_protected] = ACTIONS(2856),
    [anon_sym_override] = ACTIONS(2856),
    [anon_sym_module] = ACTIONS(2856),
    [anon_sym_any] = ACTIONS(2856),
    [anon_sym_number] = ACTIONS(2856),
    [anon_sym_boolean] = ACTIONS(2856),
    [anon_sym_string] = ACTIONS(2856),
    [anon_sym_symbol] = ACTIONS(2856),
    [anon_sym_abstract] = ACTIONS(2856),
    [anon_sym_interface] = ACTIONS(2856),
    [anon_sym_enum] = ACTIONS(2856),
    [anon_sym_component] = ACTIONS(2856),
  },
  [793] = {
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LTtemplate_GT] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_readonly] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_override] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_component] = ACTIONS(2604),
  },
  [794] = {
    [sym_arguments] = STATE(897),
    [sym_identifier] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2860),
    [anon_sym_as] = ACTIONS(2860),
    [anon_sym_LBRACE] = ACTIONS(2860),
    [anon_sym_RBRACE] = ACTIONS(2862),
    [anon_sym_typeof] = ACTIONS(2860),
    [anon_sym_BANG] = ACTIONS(2860),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2860),
    [anon_sym_SEMI] = ACTIONS(2862),
    [anon_sym_LBRACK] = ACTIONS(2862),
    [anon_sym_LT] = ACTIONS(2860),
    [anon_sym_GT] = ACTIONS(2860),
    [anon_sym_SLASH] = ACTIONS(2860),
    [anon_sym_DOT] = ACTIONS(2864),
    [anon_sym_async] = ACTIONS(2860),
    [anon_sym_QMARK_DOT] = ACTIONS(2862),
    [anon_sym_new] = ACTIONS(2860),
    [anon_sym_AMP_AMP] = ACTIONS(2862),
    [anon_sym_PIPE_PIPE] = ACTIONS(2862),
    [anon_sym_GT_GT] = ACTIONS(2860),
    [anon_sym_GT_GT_GT] = ACTIONS(2862),
    [anon_sym_LT_LT] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2860),
    [anon_sym_CARET] = ACTIONS(2862),
    [anon_sym_PIPE] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PERCENT] = ACTIONS(2862),
    [anon_sym_STAR_STAR] = ACTIONS(2862),
    [anon_sym_LT_EQ] = ACTIONS(2862),
    [anon_sym_EQ_EQ] = ACTIONS(2860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2862),
    [anon_sym_BANG_EQ] = ACTIONS(2860),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2862),
    [anon_sym_GT_EQ] = ACTIONS(2862),
    [anon_sym_QMARK_QMARK] = ACTIONS(2862),
    [anon_sym_instanceof] = ACTIONS(2860),
    [anon_sym_void] = ACTIONS(2860),
    [anon_sym_PLUS_PLUS] = ACTIONS(2862),
    [anon_sym_DASH_DASH] = ACTIONS(2862),
    [anon_sym_DQUOTE] = ACTIONS(2862),
    [anon_sym_SQUOTE] = ACTIONS(2862),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_number] = ACTIONS(2862),
    [sym_this] = ACTIONS(2860),
    [sym_true] = ACTIONS(2860),
    [sym_false] = ACTIONS(2860),
    [sym_null] = ACTIONS(2860),
    [sym_undefined] = ACTIONS(2860),
    [anon_sym_static] = ACTIONS(2860),
    [anon_sym_readonly] = ACTIONS(2860),
    [anon_sym_get] = ACTIONS(2860),
    [anon_sym_set] = ACTIONS(2860),
    [anon_sym_QMARK] = ACTIONS(2860),
    [anon_sym_any] = ACTIONS(2860),
    [anon_sym_number] = ACTIONS(2860),
    [anon_sym_boolean] = ACTIONS(2860),
    [anon_sym_string] = ACTIONS(2860),
    [anon_sym_symbol] = ACTIONS(2860),
    [anon_sym_abstract] = ACTIONS(2860),
    [anon_sym_satisfies] = ACTIONS(2860),
    [anon_sym_extends] = ACTIONS(2860),
    [anon_sym_infer] = ACTIONS(2860),
    [anon_sym_keyof] = ACTIONS(2860),
    [anon_sym_unknown] = ACTIONS(2860),
    [anon_sym_never] = ACTIONS(2860),
    [anon_sym_object] = ACTIONS(2860),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2862),
    [anon_sym_constructor] = ACTIONS(2860),
    [anon_sym_prop] = ACTIONS(2860),
    [anon_sym_id] = ACTIONS(2860),
    [anon_sym_event] = ACTIONS(2860),
    [anon_sym_fn] = ACTIONS(2860),
    [anon_sym_on] = ACTIONS(2860),
    [sym__ternary_qmark] = ACTIONS(2862),
  },
  [795] = {
    [sym_identifier] = ACTIONS(2866),
    [anon_sym_export] = ACTIONS(2866),
    [anon_sym_LBRACE] = ACTIONS(2868),
    [anon_sym_RBRACE] = ACTIONS(2868),
    [anon_sym_type] = ACTIONS(2866),
    [anon_sym_typeof] = ACTIONS(2866),
    [anon_sym_import] = ACTIONS(2866),
    [anon_sym_var] = ACTIONS(2866),
    [anon_sym_let] = ACTIONS(2866),
    [anon_sym_const] = ACTIONS(2866),
    [anon_sym_BANG] = ACTIONS(2868),
    [anon_sym_else] = ACTIONS(2866),
    [anon_sym_if] = ACTIONS(2866),
    [anon_sym_switch] = ACTIONS(2866),
    [anon_sym_for] = ACTIONS(2866),
    [anon_sym_LPAREN] = ACTIONS(2868),
    [anon_sym_await] = ACTIONS(2866),
    [anon_sym_while] = ACTIONS(2866),
    [anon_sym_do] = ACTIONS(2866),
    [anon_sym_try] = ACTIONS(2866),
    [anon_sym_with] = ACTIONS(2866),
    [anon_sym_break] = ACTIONS(2866),
    [anon_sym_continue] = ACTIONS(2866),
    [anon_sym_debugger] = ACTIONS(2866),
    [anon_sym_return] = ACTIONS(2866),
    [anon_sym_throw] = ACTIONS(2866),
    [anon_sym_SEMI] = ACTIONS(2868),
    [anon_sym_case] = ACTIONS(2866),
    [anon_sym_default] = ACTIONS(2866),
    [anon_sym_yield] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_LTtemplate_GT] = ACTIONS(2868),
    [anon_sym_LT] = ACTIONS(2866),
    [anon_sym_SLASH] = ACTIONS(2866),
    [anon_sym_class] = ACTIONS(2866),
    [anon_sym_async] = ACTIONS(2866),
    [anon_sym_function] = ACTIONS(2866),
    [anon_sym_new] = ACTIONS(2866),
    [anon_sym_AMP] = ACTIONS(2868),
    [anon_sym_PLUS] = ACTIONS(2866),
    [anon_sym_DASH] = ACTIONS(2866),
    [anon_sym_TILDE] = ACTIONS(2868),
    [anon_sym_void] = ACTIONS(2866),
    [anon_sym_delete] = ACTIONS(2866),
    [anon_sym_PLUS_PLUS] = ACTIONS(2868),
    [anon_sym_DASH_DASH] = ACTIONS(2868),
    [anon_sym_DQUOTE] = ACTIONS(2868),
    [anon_sym_SQUOTE] = ACTIONS(2868),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2868),
    [sym_number] = ACTIONS(2868),
    [sym_this] = ACTIONS(2866),
    [sym_super] = ACTIONS(2866),
    [sym_true] = ACTIONS(2866),
    [sym_false] = ACTIONS(2866),
    [sym_null] = ACTIONS(2866),
    [sym_undefined] = ACTIONS(2866),
    [anon_sym_AT] = ACTIONS(2868),
    [anon_sym_static] = ACTIONS(2866),
    [anon_sym_readonly] = ACTIONS(2866),
    [anon_sym_get] = ACTIONS(2866),
    [anon_sym_set] = ACTIONS(2866),
    [anon_sym_declare] = ACTIONS(2866),
    [anon_sym_namespace] = ACTIONS(2866),
    [anon_sym_public] = ACTIONS(2866),
    [anon_sym_private] = ACTIONS(2866),
    [anon_sym_protected] = ACTIONS(2866),
    [anon_sym_override] = ACTIONS(2866),
    [anon_sym_module] = ACTIONS(2866),
    [anon_sym_any] = ACTIONS(2866),
    [anon_sym_number] = ACTIONS(2866),
    [anon_sym_boolean] = ACTIONS(2866),
    [anon_sym_string] = ACTIONS(2866),
    [anon_sym_symbol] = ACTIONS(2866),
    [anon_sym_abstract] = ACTIONS(2866),
    [anon_sym_interface] = ACTIONS(2866),
    [anon_sym_enum] = ACTIONS(2866),
    [anon_sym_component] = ACTIONS(2866),
  },
  [796] = {
    [sym_identifier] = ACTIONS(2870),
    [anon_sym_export] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2872),
    [anon_sym_RBRACE] = ACTIONS(2872),
    [anon_sym_type] = ACTIONS(2870),
    [anon_sym_typeof] = ACTIONS(2870),
    [anon_sym_import] = ACTIONS(2870),
    [anon_sym_var] = ACTIONS(2870),
    [anon_sym_let] = ACTIONS(2870),
    [anon_sym_const] = ACTIONS(2870),
    [anon_sym_BANG] = ACTIONS(2872),
    [anon_sym_else] = ACTIONS(2870),
    [anon_sym_if] = ACTIONS(2870),
    [anon_sym_switch] = ACTIONS(2870),
    [anon_sym_for] = ACTIONS(2870),
    [anon_sym_LPAREN] = ACTIONS(2872),
    [anon_sym_await] = ACTIONS(2870),
    [anon_sym_while] = ACTIONS(2870),
    [anon_sym_do] = ACTIONS(2870),
    [anon_sym_try] = ACTIONS(2870),
    [anon_sym_with] = ACTIONS(2870),
    [anon_sym_break] = ACTIONS(2870),
    [anon_sym_continue] = ACTIONS(2870),
    [anon_sym_debugger] = ACTIONS(2870),
    [anon_sym_return] = ACTIONS(2870),
    [anon_sym_throw] = ACTIONS(2870),
    [anon_sym_SEMI] = ACTIONS(2872),
    [anon_sym_case] = ACTIONS(2870),
    [anon_sym_default] = ACTIONS(2870),
    [anon_sym_yield] = ACTIONS(2870),
    [anon_sym_LBRACK] = ACTIONS(2872),
    [anon_sym_LTtemplate_GT] = ACTIONS(2872),
    [anon_sym_LT] = ACTIONS(2870),
    [anon_sym_SLASH] = ACTIONS(2870),
    [anon_sym_class] = ACTIONS(2870),
    [anon_sym_async] = ACTIONS(2870),
    [anon_sym_function] = ACTIONS(2870),
    [anon_sym_new] = ACTIONS(2870),
    [anon_sym_AMP] = ACTIONS(2872),
    [anon_sym_PLUS] = ACTIONS(2870),
    [anon_sym_DASH] = ACTIONS(2870),
    [anon_sym_TILDE] = ACTIONS(2872),
    [anon_sym_void] = ACTIONS(2870),
    [anon_sym_delete] = ACTIONS(2870),
    [anon_sym_PLUS_PLUS] = ACTIONS(2872),
    [anon_sym_DASH_DASH] = ACTIONS(2872),
    [anon_sym_DQUOTE] = ACTIONS(2872),
    [anon_sym_SQUOTE] = ACTIONS(2872),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2872),
    [sym_number] = ACTIONS(2872),
    [sym_this] = ACTIONS(2870),
    [sym_super] = ACTIONS(2870),
    [sym_true] = ACTIONS(2870),
    [sym_false] = ACTIONS(2870),
    [sym_null] = ACTIONS(2870),
    [sym_undefined] = ACTIONS(2870),
    [anon_sym_AT] = ACTIONS(2872),
    [anon_sym_static] = ACTIONS(2870),
    [anon_sym_readonly] = ACTIONS(2870),
    [anon_sym_get] = ACTIONS(2870),
    [anon_sym_set] = ACTIONS(2870),
    [anon_sym_declare] = ACTIONS(2870),
    [anon_sym_namespace] = ACTIONS(2870),
    [anon_sym_public] = ACTIONS(2870),
    [anon_sym_private] = ACTIONS(2870),
    [anon_sym_protected] = ACTIONS(2870),
    [anon_sym_override] = ACTIONS(2870),
    [anon_sym_module] = ACTIONS(2870),
    [anon_sym_any] = ACTIONS(2870),
    [anon_sym_number] = ACTIONS(2870),
    [anon_sym_boolean] = ACTIONS(2870),
    [anon_sym_string] = ACTIONS(2870),
    [anon_sym_symbol] = ACTIONS(2870),
    [anon_sym_abstract] = ACTIONS(2870),
    [anon_sym_interface] = ACTIONS(2870),
    [anon_sym_enum] = ACTIONS(2870),
    [anon_sym_component] = ACTIONS(2870),
  },
  [797] = {
    [sym_identifier] = ACTIONS(2874),
    [anon_sym_export] = ACTIONS(2874),
    [anon_sym_LBRACE] = ACTIONS(2876),
    [anon_sym_RBRACE] = ACTIONS(2876),
    [anon_sym_type] = ACTIONS(2874),
    [anon_sym_typeof] = ACTIONS(2874),
    [anon_sym_import] = ACTIONS(2874),
    [anon_sym_var] = ACTIONS(2874),
    [anon_sym_let] = ACTIONS(2874),
    [anon_sym_const] = ACTIONS(2874),
    [anon_sym_BANG] = ACTIONS(2876),
    [anon_sym_else] = ACTIONS(2874),
    [anon_sym_if] = ACTIONS(2874),
    [anon_sym_switch] = ACTIONS(2874),
    [anon_sym_for] = ACTIONS(2874),
    [anon_sym_LPAREN] = ACTIONS(2876),
    [anon_sym_await] = ACTIONS(2874),
    [anon_sym_while] = ACTIONS(2874),
    [anon_sym_do] = ACTIONS(2874),
    [anon_sym_try] = ACTIONS(2874),
    [anon_sym_with] = ACTIONS(2874),
    [anon_sym_break] = ACTIONS(2874),
    [anon_sym_continue] = ACTIONS(2874),
    [anon_sym_debugger] = ACTIONS(2874),
    [anon_sym_return] = ACTIONS(2874),
    [anon_sym_throw] = ACTIONS(2874),
    [anon_sym_SEMI] = ACTIONS(2876),
    [anon_sym_case] = ACTIONS(2874),
    [anon_sym_default] = ACTIONS(2874),
    [anon_sym_yield] = ACTIONS(2874),
    [anon_sym_LBRACK] = ACTIONS(2876),
    [anon_sym_LTtemplate_GT] = ACTIONS(2876),
    [anon_sym_LT] = ACTIONS(2874),
    [anon_sym_SLASH] = ACTIONS(2874),
    [anon_sym_class] = ACTIONS(2874),
    [anon_sym_async] = ACTIONS(2874),
    [anon_sym_function] = ACTIONS(2874),
    [anon_sym_new] = ACTIONS(2874),
    [anon_sym_AMP] = ACTIONS(2876),
    [anon_sym_PLUS] = ACTIONS(2874),
    [anon_sym_DASH] = ACTIONS(2874),
    [anon_sym_TILDE] = ACTIONS(2876),
    [anon_sym_void] = ACTIONS(2874),
    [anon_sym_delete] = ACTIONS(2874),
    [anon_sym_PLUS_PLUS] = ACTIONS(2876),
    [anon_sym_DASH_DASH] = ACTIONS(2876),
    [anon_sym_DQUOTE] = ACTIONS(2876),
    [anon_sym_SQUOTE] = ACTIONS(2876),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2876),
    [sym_number] = ACTIONS(2876),
    [sym_this] = ACTIONS(2874),
    [sym_super] = ACTIONS(2874),
    [sym_true] = ACTIONS(2874),
    [sym_false] = ACTIONS(2874),
    [sym_null] = ACTIONS(2874),
    [sym_undefined] = ACTIONS(2874),
    [anon_sym_AT] = ACTIONS(2876),
    [anon_sym_static] = ACTIONS(2874),
    [anon_sym_readonly] = ACTIONS(2874),
    [anon_sym_get] = ACTIONS(2874),
    [anon_sym_set] = ACTIONS(2874),
    [anon_sym_declare] = ACTIONS(2874),
    [anon_sym_namespace] = ACTIONS(2874),
    [anon_sym_public] = ACTIONS(2874),
    [anon_sym_private] = ACTIONS(2874),
    [anon_sym_protected] = ACTIONS(2874),
    [anon_sym_override] = ACTIONS(2874),
    [anon_sym_module] = ACTIONS(2874),
    [anon_sym_any] = ACTIONS(2874),
    [anon_sym_number] = ACTIONS(2874),
    [anon_sym_boolean] = ACTIONS(2874),
    [anon_sym_string] = ACTIONS(2874),
    [anon_sym_symbol] = ACTIONS(2874),
    [anon_sym_abstract] = ACTIONS(2874),
    [anon_sym_interface] = ACTIONS(2874),
    [anon_sym_enum] = ACTIONS(2874),
    [anon_sym_component] = ACTIONS(2874),
  },
  [798] = {
    [sym_identifier] = ACTIONS(2878),
    [anon_sym_export] = ACTIONS(2878),
    [anon_sym_LBRACE] = ACTIONS(2880),
    [anon_sym_RBRACE] = ACTIONS(2880),
    [anon_sym_type] = ACTIONS(2878),
    [anon_sym_typeof] = ACTIONS(2878),
    [anon_sym_import] = ACTIONS(2878),
    [anon_sym_var] = ACTIONS(2878),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_const] = ACTIONS(2878),
    [anon_sym_BANG] = ACTIONS(2880),
    [anon_sym_else] = ACTIONS(2878),
    [anon_sym_if] = ACTIONS(2878),
    [anon_sym_switch] = ACTIONS(2878),
    [anon_sym_for] = ACTIONS(2878),
    [anon_sym_LPAREN] = ACTIONS(2880),
    [anon_sym_await] = ACTIONS(2878),
    [anon_sym_while] = ACTIONS(2878),
    [anon_sym_do] = ACTIONS(2878),
    [anon_sym_try] = ACTIONS(2878),
    [anon_sym_with] = ACTIONS(2878),
    [anon_sym_break] = ACTIONS(2878),
    [anon_sym_continue] = ACTIONS(2878),
    [anon_sym_debugger] = ACTIONS(2878),
    [anon_sym_return] = ACTIONS(2878),
    [anon_sym_throw] = ACTIONS(2878),
    [anon_sym_SEMI] = ACTIONS(2880),
    [anon_sym_case] = ACTIONS(2878),
    [anon_sym_default] = ACTIONS(2878),
    [anon_sym_yield] = ACTIONS(2878),
    [anon_sym_LBRACK] = ACTIONS(2880),
    [anon_sym_LTtemplate_GT] = ACTIONS(2880),
    [anon_sym_LT] = ACTIONS(2878),
    [anon_sym_SLASH] = ACTIONS(2878),
    [anon_sym_class] = ACTIONS(2878),
    [anon_sym_async] = ACTIONS(2878),
    [anon_sym_function] = ACTIONS(2878),
    [anon_sym_new] = ACTIONS(2878),
    [anon_sym_AMP] = ACTIONS(2880),
    [anon_sym_PLUS] = ACTIONS(2878),
    [anon_sym_DASH] = ACTIONS(2878),
    [anon_sym_TILDE] = ACTIONS(2880),
    [anon_sym_void] = ACTIONS(2878),
    [anon_sym_delete] = ACTIONS(2878),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_DQUOTE] = ACTIONS(2880),
    [anon_sym_SQUOTE] = ACTIONS(2880),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2880),
    [sym_number] = ACTIONS(2880),
    [sym_this] = ACTIONS(2878),
    [sym_super] = ACTIONS(2878),
    [sym_true] = ACTIONS(2878),
    [sym_false] = ACTIONS(2878),
    [sym_null] = ACTIONS(2878),
    [sym_undefined] = ACTIONS(2878),
    [anon_sym_AT] = ACTIONS(2880),
    [anon_sym_static] = ACTIONS(2878),
    [anon_sym_readonly] = ACTIONS(2878),
    [anon_sym_get] = ACTIONS(2878),
    [anon_sym_set] = ACTIONS(2878),
    [anon_sym_declare] = ACTIONS(2878),
    [anon_sym_namespace] = ACTIONS(2878),
    [anon_sym_public] = ACTIONS(2878),
    [anon_sym_private] = ACTIONS(2878),
    [anon_sym_protected] = ACTIONS(2878),
    [anon_sym_override] = ACTIONS(2878),
    [anon_sym_module] = ACTIONS(2878),
    [anon_sym_any] = ACTIONS(2878),
    [anon_sym_number] = ACTIONS(2878),
    [anon_sym_boolean] = ACTIONS(2878),
    [anon_sym_string] = ACTIONS(2878),
    [anon_sym_symbol] = ACTIONS(2878),
    [anon_sym_abstract] = ACTIONS(2878),
    [anon_sym_interface] = ACTIONS(2878),
    [anon_sym_enum] = ACTIONS(2878),
    [anon_sym_component] = ACTIONS(2878),
  },
  [799] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LTtemplate_GT] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2610),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_override] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_component] = ACTIONS(2608),
  },
  [800] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_RBRACE] = ACTIONS(2884),
    [anon_sym_typeof] = ACTIONS(2882),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2882),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2882),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_QMARK_QMARK] = ACTIONS(2650),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(2882),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2884),
    [anon_sym_SQUOTE] = ACTIONS(2884),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2884),
    [sym_number] = ACTIONS(2884),
    [sym_this] = ACTIONS(2882),
    [sym_true] = ACTIONS(2882),
    [sym_false] = ACTIONS(2882),
    [sym_null] = ACTIONS(2882),
    [sym_undefined] = ACTIONS(2882),
    [anon_sym_static] = ACTIONS(2882),
    [anon_sym_readonly] = ACTIONS(2882),
    [anon_sym_get] = ACTIONS(2882),
    [anon_sym_set] = ACTIONS(2882),
    [anon_sym_QMARK] = ACTIONS(2882),
    [anon_sym_any] = ACTIONS(2882),
    [anon_sym_number] = ACTIONS(2882),
    [anon_sym_boolean] = ACTIONS(2882),
    [anon_sym_string] = ACTIONS(2882),
    [anon_sym_symbol] = ACTIONS(2882),
    [anon_sym_abstract] = ACTIONS(2882),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2882),
    [anon_sym_keyof] = ACTIONS(2882),
    [anon_sym_unknown] = ACTIONS(2882),
    [anon_sym_never] = ACTIONS(2882),
    [anon_sym_object] = ACTIONS(2882),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2884),
    [anon_sym_constructor] = ACTIONS(2882),
    [anon_sym_prop] = ACTIONS(2882),
    [anon_sym_id] = ACTIONS(2882),
    [anon_sym_event] = ACTIONS(2882),
    [anon_sym_fn] = ACTIONS(2882),
    [anon_sym_on] = ACTIONS(2882),
    [sym__ternary_qmark] = ACTIONS(2656),
  },
  [801] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2886),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2886),
    [anon_sym_RBRACE] = ACTIONS(2888),
    [anon_sym_typeof] = ACTIONS(2886),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2888),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2886),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2886),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_QMARK_QMARK] = ACTIONS(2650),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(2886),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2888),
    [anon_sym_SQUOTE] = ACTIONS(2888),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2888),
    [sym_number] = ACTIONS(2888),
    [sym_this] = ACTIONS(2886),
    [sym_true] = ACTIONS(2886),
    [sym_false] = ACTIONS(2886),
    [sym_null] = ACTIONS(2886),
    [sym_undefined] = ACTIONS(2886),
    [anon_sym_static] = ACTIONS(2886),
    [anon_sym_readonly] = ACTIONS(2886),
    [anon_sym_get] = ACTIONS(2886),
    [anon_sym_set] = ACTIONS(2886),
    [anon_sym_QMARK] = ACTIONS(2886),
    [anon_sym_any] = ACTIONS(2886),
    [anon_sym_number] = ACTIONS(2886),
    [anon_sym_boolean] = ACTIONS(2886),
    [anon_sym_string] = ACTIONS(2886),
    [anon_sym_symbol] = ACTIONS(2886),
    [anon_sym_abstract] = ACTIONS(2886),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2886),
    [anon_sym_keyof] = ACTIONS(2886),
    [anon_sym_unknown] = ACTIONS(2886),
    [anon_sym_never] = ACTIONS(2886),
    [anon_sym_object] = ACTIONS(2886),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2888),
    [anon_sym_constructor] = ACTIONS(2886),
    [anon_sym_prop] = ACTIONS(2886),
    [anon_sym_id] = ACTIONS(2886),
    [anon_sym_event] = ACTIONS(2886),
    [anon_sym_fn] = ACTIONS(2886),
    [anon_sym_on] = ACTIONS(2886),
    [sym__ternary_qmark] = ACTIONS(2656),
  },
  [802] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2890),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_RBRACE] = ACTIONS(2892),
    [anon_sym_typeof] = ACTIONS(2890),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2892),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2890),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2890),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_QMARK_QMARK] = ACTIONS(2650),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(2890),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2892),
    [anon_sym_SQUOTE] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2892),
    [sym_number] = ACTIONS(2892),
    [sym_this] = ACTIONS(2890),
    [sym_true] = ACTIONS(2890),
    [sym_false] = ACTIONS(2890),
    [sym_null] = ACTIONS(2890),
    [sym_undefined] = ACTIONS(2890),
    [anon_sym_static] = ACTIONS(2890),
    [anon_sym_readonly] = ACTIONS(2890),
    [anon_sym_get] = ACTIONS(2890),
    [anon_sym_set] = ACTIONS(2890),
    [anon_sym_QMARK] = ACTIONS(2890),
    [anon_sym_any] = ACTIONS(2890),
    [anon_sym_number] = ACTIONS(2890),
    [anon_sym_boolean] = ACTIONS(2890),
    [anon_sym_string] = ACTIONS(2890),
    [anon_sym_symbol] = ACTIONS(2890),
    [anon_sym_abstract] = ACTIONS(2890),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2890),
    [anon_sym_keyof] = ACTIONS(2890),
    [anon_sym_unknown] = ACTIONS(2890),
    [anon_sym_never] = ACTIONS(2890),
    [anon_sym_object] = ACTIONS(2890),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2892),
    [anon_sym_constructor] = ACTIONS(2890),
    [anon_sym_prop] = ACTIONS(2890),
    [anon_sym_id] = ACTIONS(2890),
    [anon_sym_event] = ACTIONS(2890),
    [anon_sym_fn] = ACTIONS(2890),
    [anon_sym_on] = ACTIONS(2890),
    [sym__ternary_qmark] = ACTIONS(2656),
  },
  [803] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LTtemplate_GT] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2610),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_override] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_component] = ACTIONS(2608),
  },
  [804] = {
    [sym_identifier] = ACTIONS(2894),
    [anon_sym_export] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2896),
    [anon_sym_RBRACE] = ACTIONS(2896),
    [anon_sym_type] = ACTIONS(2894),
    [anon_sym_typeof] = ACTIONS(2894),
    [anon_sym_import] = ACTIONS(2894),
    [anon_sym_var] = ACTIONS(2894),
    [anon_sym_let] = ACTIONS(2894),
    [anon_sym_const] = ACTIONS(2894),
    [anon_sym_BANG] = ACTIONS(2896),
    [anon_sym_else] = ACTIONS(2894),
    [anon_sym_if] = ACTIONS(2894),
    [anon_sym_switch] = ACTIONS(2894),
    [anon_sym_for] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2896),
    [anon_sym_await] = ACTIONS(2894),
    [anon_sym_while] = ACTIONS(2894),
    [anon_sym_do] = ACTIONS(2894),
    [anon_sym_try] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2894),
    [anon_sym_break] = ACTIONS(2894),
    [anon_sym_continue] = ACTIONS(2894),
    [anon_sym_debugger] = ACTIONS(2894),
    [anon_sym_return] = ACTIONS(2894),
    [anon_sym_throw] = ACTIONS(2894),
    [anon_sym_SEMI] = ACTIONS(2896),
    [anon_sym_case] = ACTIONS(2894),
    [anon_sym_default] = ACTIONS(2894),
    [anon_sym_yield] = ACTIONS(2894),
    [anon_sym_LBRACK] = ACTIONS(2896),
    [anon_sym_LTtemplate_GT] = ACTIONS(2896),
    [anon_sym_LT] = ACTIONS(2894),
    [anon_sym_SLASH] = ACTIONS(2894),
    [anon_sym_class] = ACTIONS(2894),
    [anon_sym_async] = ACTIONS(2894),
    [anon_sym_function] = ACTIONS(2894),
    [anon_sym_new] = ACTIONS(2894),
    [anon_sym_AMP] = ACTIONS(2896),
    [anon_sym_PLUS] = ACTIONS(2894),
    [anon_sym_DASH] = ACTIONS(2894),
    [anon_sym_TILDE] = ACTIONS(2896),
    [anon_sym_void] = ACTIONS(2894),
    [anon_sym_delete] = ACTIONS(2894),
    [anon_sym_PLUS_PLUS] = ACTIONS(2896),
    [anon_sym_DASH_DASH] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [anon_sym_SQUOTE] = ACTIONS(2896),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2896),
    [sym_number] = ACTIONS(2896),
    [sym_this] = ACTIONS(2894),
    [sym_super] = ACTIONS(2894),
    [sym_true] = ACTIONS(2894),
    [sym_false] = ACTIONS(2894),
    [sym_null] = ACTIONS(2894),
    [sym_undefined] = ACTIONS(2894),
    [anon_sym_AT] = ACTIONS(2896),
    [anon_sym_static] = ACTIONS(2894),
    [anon_sym_readonly] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2894),
    [anon_sym_set] = ACTIONS(2894),
    [anon_sym_declare] = ACTIONS(2894),
    [anon_sym_namespace] = ACTIONS(2894),
    [anon_sym_public] = ACTIONS(2894),
    [anon_sym_private] = ACTIONS(2894),
    [anon_sym_protected] = ACTIONS(2894),
    [anon_sym_override] = ACTIONS(2894),
    [anon_sym_module] = ACTIONS(2894),
    [anon_sym_any] = ACTIONS(2894),
    [anon_sym_number] = ACTIONS(2894),
    [anon_sym_boolean] = ACTIONS(2894),
    [anon_sym_string] = ACTIONS(2894),
    [anon_sym_symbol] = ACTIONS(2894),
    [anon_sym_abstract] = ACTIONS(2894),
    [anon_sym_interface] = ACTIONS(2894),
    [anon_sym_enum] = ACTIONS(2894),
    [anon_sym_component] = ACTIONS(2894),
  },
  [805] = {
    [sym_identifier] = ACTIONS(1366),
    [anon_sym_STAR] = ACTIONS(1366),
    [anon_sym_as] = ACTIONS(1368),
    [anon_sym_LBRACE] = ACTIONS(1366),
    [anon_sym_RBRACE] = ACTIONS(1370),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_BANG] = ACTIONS(1368),
    [anon_sym_LPAREN] = ACTIONS(1370),
    [anon_sym_in] = ACTIONS(1368),
    [anon_sym_SEMI] = ACTIONS(1370),
    [anon_sym_EQ] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(1368),
    [anon_sym_SLASH] = ACTIONS(1368),
    [anon_sym_DOT] = ACTIONS(1368),
    [anon_sym_async] = ACTIONS(1366),
    [anon_sym_QMARK_DOT] = ACTIONS(1372),
    [anon_sym_new] = ACTIONS(1366),
    [anon_sym_AMP_AMP] = ACTIONS(1372),
    [anon_sym_PIPE_PIPE] = ACTIONS(1372),
    [anon_sym_GT_GT] = ACTIONS(1368),
    [anon_sym_GT_GT_GT] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1366),
    [anon_sym_CARET] = ACTIONS(1372),
    [anon_sym_PIPE] = ACTIONS(1366),
    [anon_sym_PLUS] = ACTIONS(1366),
    [anon_sym_DASH] = ACTIONS(1366),
    [anon_sym_PERCENT] = ACTIONS(1372),
    [anon_sym_STAR_STAR] = ACTIONS(1372),
    [anon_sym_LT_EQ] = ACTIONS(1372),
    [anon_sym_EQ_EQ] = ACTIONS(1368),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1372),
    [anon_sym_BANG_EQ] = ACTIONS(1368),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1372),
    [anon_sym_GT_EQ] = ACTIONS(1372),
    [anon_sym_QMARK_QMARK] = ACTIONS(1372),
    [anon_sym_instanceof] = ACTIONS(1368),
    [anon_sym_void] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(1372),
    [anon_sym_DASH_DASH] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1370),
    [sym_number] = ACTIONS(1370),
    [sym_this] = ACTIONS(1366),
    [sym_true] = ACTIONS(1366),
    [sym_false] = ACTIONS(1366),
    [sym_null] = ACTIONS(1366),
    [sym_undefined] = ACTIONS(1366),
    [anon_sym_static] = ACTIONS(1366),
    [anon_sym_readonly] = ACTIONS(1366),
    [anon_sym_get] = ACTIONS(1366),
    [anon_sym_set] = ACTIONS(1366),
    [anon_sym_QMARK] = ACTIONS(1366),
    [anon_sym_any] = ACTIONS(1366),
    [anon_sym_number] = ACTIONS(1366),
    [anon_sym_boolean] = ACTIONS(1366),
    [anon_sym_string] = ACTIONS(1366),
    [anon_sym_symbol] = ACTIONS(1366),
    [anon_sym_abstract] = ACTIONS(1366),
    [anon_sym_satisfies] = ACTIONS(1368),
    [anon_sym_infer] = ACTIONS(1366),
    [anon_sym_keyof] = ACTIONS(1366),
    [anon_sym_unknown] = ACTIONS(1366),
    [anon_sym_never] = ACTIONS(1366),
    [anon_sym_object] = ACTIONS(1366),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1370),
    [anon_sym_constructor] = ACTIONS(1366),
    [anon_sym_prop] = ACTIONS(1366),
    [anon_sym_id] = ACTIONS(1366),
    [anon_sym_event] = ACTIONS(1366),
    [anon_sym_fn] = ACTIONS(1366),
    [anon_sym_on] = ACTIONS(1366),
    [sym__automatic_semicolon] = ACTIONS(2898),
    [sym__ternary_qmark] = ACTIONS(1372),
  },
  [806] = {
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_LBRACE] = ACTIONS(2902),
    [anon_sym_RBRACE] = ACTIONS(2902),
    [anon_sym_type] = ACTIONS(2900),
    [anon_sym_typeof] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2900),
    [anon_sym_var] = ACTIONS(2900),
    [anon_sym_let] = ACTIONS(2900),
    [anon_sym_const] = ACTIONS(2900),
    [anon_sym_BANG] = ACTIONS(2902),
    [anon_sym_else] = ACTIONS(2900),
    [anon_sym_if] = ACTIONS(2900),
    [anon_sym_switch] = ACTIONS(2900),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_LPAREN] = ACTIONS(2902),
    [anon_sym_await] = ACTIONS(2900),
    [anon_sym_while] = ACTIONS(2900),
    [anon_sym_do] = ACTIONS(2900),
    [anon_sym_try] = ACTIONS(2900),
    [anon_sym_with] = ACTIONS(2900),
    [anon_sym_break] = ACTIONS(2900),
    [anon_sym_continue] = ACTIONS(2900),
    [anon_sym_debugger] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2900),
    [anon_sym_throw] = ACTIONS(2900),
    [anon_sym_SEMI] = ACTIONS(2902),
    [anon_sym_case] = ACTIONS(2900),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_yield] = ACTIONS(2900),
    [anon_sym_LBRACK] = ACTIONS(2902),
    [anon_sym_LTtemplate_GT] = ACTIONS(2902),
    [anon_sym_LT] = ACTIONS(2900),
    [anon_sym_SLASH] = ACTIONS(2900),
    [anon_sym_class] = ACTIONS(2900),
    [anon_sym_async] = ACTIONS(2900),
    [anon_sym_function] = ACTIONS(2900),
    [anon_sym_new] = ACTIONS(2900),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2900),
    [anon_sym_DASH] = ACTIONS(2900),
    [anon_sym_TILDE] = ACTIONS(2902),
    [anon_sym_void] = ACTIONS(2900),
    [anon_sym_delete] = ACTIONS(2900),
    [anon_sym_PLUS_PLUS] = ACTIONS(2902),
    [anon_sym_DASH_DASH] = ACTIONS(2902),
    [anon_sym_DQUOTE] = ACTIONS(2902),
    [anon_sym_SQUOTE] = ACTIONS(2902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2902),
    [sym_number] = ACTIONS(2902),
    [sym_this] = ACTIONS(2900),
    [sym_super] = ACTIONS(2900),
    [sym_true] = ACTIONS(2900),
    [sym_false] = ACTIONS(2900),
    [sym_null] = ACTIONS(2900),
    [sym_undefined] = ACTIONS(2900),
    [anon_sym_AT] = ACTIONS(2902),
    [anon_sym_static] = ACTIONS(2900),
    [anon_sym_readonly] = ACTIONS(2900),
    [anon_sym_get] = ACTIONS(2900),
    [anon_sym_set] = ACTIONS(2900),
    [anon_sym_declare] = ACTIONS(2900),
    [anon_sym_namespace] = ACTIONS(2900),
    [anon_sym_public] = ACTIONS(2900),
    [anon_sym_private] = ACTIONS(2900),
    [anon_sym_protected] = ACTIONS(2900),
    [anon_sym_override] = ACTIONS(2900),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_any] = ACTIONS(2900),
    [anon_sym_number] = ACTIONS(2900),
    [anon_sym_boolean] = ACTIONS(2900),
    [anon_sym_string] = ACTIONS(2900),
    [anon_sym_symbol] = ACTIONS(2900),
    [anon_sym_abstract] = ACTIONS(2900),
    [anon_sym_interface] = ACTIONS(2900),
    [anon_sym_enum] = ACTIONS(2900),
    [anon_sym_component] = ACTIONS(2900),
  },
  [807] = {
    [sym_identifier] = ACTIONS(1636),
    [anon_sym_export] = ACTIONS(1636),
    [anon_sym_LBRACE] = ACTIONS(1638),
    [anon_sym_RBRACE] = ACTIONS(1638),
    [anon_sym_type] = ACTIONS(1636),
    [anon_sym_typeof] = ACTIONS(1636),
    [anon_sym_import] = ACTIONS(1636),
    [anon_sym_var] = ACTIONS(1636),
    [anon_sym_let] = ACTIONS(1636),
    [anon_sym_const] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1638),
    [anon_sym_else] = ACTIONS(1636),
    [anon_sym_if] = ACTIONS(1636),
    [anon_sym_switch] = ACTIONS(1636),
    [anon_sym_for] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_await] = ACTIONS(1636),
    [anon_sym_while] = ACTIONS(1636),
    [anon_sym_do] = ACTIONS(1636),
    [anon_sym_try] = ACTIONS(1636),
    [anon_sym_with] = ACTIONS(1636),
    [anon_sym_break] = ACTIONS(1636),
    [anon_sym_continue] = ACTIONS(1636),
    [anon_sym_debugger] = ACTIONS(1636),
    [anon_sym_return] = ACTIONS(1636),
    [anon_sym_throw] = ACTIONS(1636),
    [anon_sym_SEMI] = ACTIONS(1638),
    [anon_sym_case] = ACTIONS(1636),
    [anon_sym_default] = ACTIONS(1636),
    [anon_sym_yield] = ACTIONS(1636),
    [anon_sym_LBRACK] = ACTIONS(1638),
    [anon_sym_LTtemplate_GT] = ACTIONS(1638),
    [anon_sym_LT] = ACTIONS(1636),
    [anon_sym_SLASH] = ACTIONS(1636),
    [anon_sym_class] = ACTIONS(1636),
    [anon_sym_async] = ACTIONS(1636),
    [anon_sym_function] = ACTIONS(1636),
    [anon_sym_new] = ACTIONS(1636),
    [anon_sym_AMP] = ACTIONS(1638),
    [anon_sym_PLUS] = ACTIONS(1636),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_TILDE] = ACTIONS(1638),
    [anon_sym_void] = ACTIONS(1636),
    [anon_sym_delete] = ACTIONS(1636),
    [anon_sym_PLUS_PLUS] = ACTIONS(1638),
    [anon_sym_DASH_DASH] = ACTIONS(1638),
    [anon_sym_DQUOTE] = ACTIONS(1638),
    [anon_sym_SQUOTE] = ACTIONS(1638),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1638),
    [sym_number] = ACTIONS(1638),
    [sym_this] = ACTIONS(1636),
    [sym_super] = ACTIONS(1636),
    [sym_true] = ACTIONS(1636),
    [sym_false] = ACTIONS(1636),
    [sym_null] = ACTIONS(1636),
    [sym_undefined] = ACTIONS(1636),
    [anon_sym_AT] = ACTIONS(1638),
    [anon_sym_static] = ACTIONS(1636),
    [anon_sym_readonly] = ACTIONS(1636),
    [anon_sym_get] = ACTIONS(1636),
    [anon_sym_set] = ACTIONS(1636),
    [anon_sym_declare] = ACTIONS(1636),
    [anon_sym_namespace] = ACTIONS(1636),
    [anon_sym_public] = ACTIONS(1636),
    [anon_sym_private] = ACTIONS(1636),
    [anon_sym_protected] = ACTIONS(1636),
    [anon_sym_override] = ACTIONS(1636),
    [anon_sym_module] = ACTIONS(1636),
    [anon_sym_any] = ACTIONS(1636),
    [anon_sym_number] = ACTIONS(1636),
    [anon_sym_boolean] = ACTIONS(1636),
    [anon_sym_string] = ACTIONS(1636),
    [anon_sym_symbol] = ACTIONS(1636),
    [anon_sym_abstract] = ACTIONS(1636),
    [anon_sym_interface] = ACTIONS(1636),
    [anon_sym_enum] = ACTIONS(1636),
    [anon_sym_component] = ACTIONS(1636),
  },
  [808] = {
    [sym_identifier] = ACTIONS(2904),
    [anon_sym_export] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(2906),
    [anon_sym_type] = ACTIONS(2904),
    [anon_sym_typeof] = ACTIONS(2904),
    [anon_sym_import] = ACTIONS(2904),
    [anon_sym_var] = ACTIONS(2904),
    [anon_sym_let] = ACTIONS(2904),
    [anon_sym_const] = ACTIONS(2904),
    [anon_sym_BANG] = ACTIONS(2906),
    [anon_sym_else] = ACTIONS(2904),
    [anon_sym_if] = ACTIONS(2904),
    [anon_sym_switch] = ACTIONS(2904),
    [anon_sym_for] = ACTIONS(2904),
    [anon_sym_LPAREN] = ACTIONS(2906),
    [anon_sym_await] = ACTIONS(2904),
    [anon_sym_while] = ACTIONS(2904),
    [anon_sym_do] = ACTIONS(2904),
    [anon_sym_try] = ACTIONS(2904),
    [anon_sym_with] = ACTIONS(2904),
    [anon_sym_break] = ACTIONS(2904),
    [anon_sym_continue] = ACTIONS(2904),
    [anon_sym_debugger] = ACTIONS(2904),
    [anon_sym_return] = ACTIONS(2904),
    [anon_sym_throw] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(2906),
    [anon_sym_case] = ACTIONS(2904),
    [anon_sym_default] = ACTIONS(2904),
    [anon_sym_yield] = ACTIONS(2904),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_LTtemplate_GT] = ACTIONS(2906),
    [anon_sym_LT] = ACTIONS(2904),
    [anon_sym_SLASH] = ACTIONS(2904),
    [anon_sym_class] = ACTIONS(2904),
    [anon_sym_async] = ACTIONS(2904),
    [anon_sym_function] = ACTIONS(2904),
    [anon_sym_new] = ACTIONS(2904),
    [anon_sym_AMP] = ACTIONS(2906),
    [anon_sym_PLUS] = ACTIONS(2904),
    [anon_sym_DASH] = ACTIONS(2904),
    [anon_sym_TILDE] = ACTIONS(2906),
    [anon_sym_void] = ACTIONS(2904),
    [anon_sym_delete] = ACTIONS(2904),
    [anon_sym_PLUS_PLUS] = ACTIONS(2906),
    [anon_sym_DASH_DASH] = ACTIONS(2906),
    [anon_sym_DQUOTE] = ACTIONS(2906),
    [anon_sym_SQUOTE] = ACTIONS(2906),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2906),
    [sym_number] = ACTIONS(2906),
    [sym_this] = ACTIONS(2904),
    [sym_super] = ACTIONS(2904),
    [sym_true] = ACTIONS(2904),
    [sym_false] = ACTIONS(2904),
    [sym_null] = ACTIONS(2904),
    [sym_undefined] = ACTIONS(2904),
    [anon_sym_AT] = ACTIONS(2906),
    [anon_sym_static] = ACTIONS(2904),
    [anon_sym_readonly] = ACTIONS(2904),
    [anon_sym_get] = ACTIONS(2904),
    [anon_sym_set] = ACTIONS(2904),
    [anon_sym_declare] = ACTIONS(2904),
    [anon_sym_namespace] = ACTIONS(2904),
    [anon_sym_public] = ACTIONS(2904),
    [anon_sym_private] = ACTIONS(2904),
    [anon_sym_protected] = ACTIONS(2904),
    [anon_sym_override] = ACTIONS(2904),
    [anon_sym_module] = ACTIONS(2904),
    [anon_sym_any] = ACTIONS(2904),
    [anon_sym_number] = ACTIONS(2904),
    [anon_sym_boolean] = ACTIONS(2904),
    [anon_sym_string] = ACTIONS(2904),
    [anon_sym_symbol] = ACTIONS(2904),
    [anon_sym_abstract] = ACTIONS(2904),
    [anon_sym_interface] = ACTIONS(2904),
    [anon_sym_enum] = ACTIONS(2904),
    [anon_sym_component] = ACTIONS(2904),
  },
  [809] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LTtemplate_GT] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2610),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_override] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_component] = ACTIONS(2608),
  },
  [810] = {
    [sym_identifier] = ACTIONS(2908),
    [anon_sym_export] = ACTIONS(2908),
    [anon_sym_LBRACE] = ACTIONS(2910),
    [anon_sym_RBRACE] = ACTIONS(2910),
    [anon_sym_type] = ACTIONS(2908),
    [anon_sym_typeof] = ACTIONS(2908),
    [anon_sym_import] = ACTIONS(2908),
    [anon_sym_var] = ACTIONS(2908),
    [anon_sym_let] = ACTIONS(2908),
    [anon_sym_const] = ACTIONS(2908),
    [anon_sym_BANG] = ACTIONS(2910),
    [anon_sym_else] = ACTIONS(2908),
    [anon_sym_if] = ACTIONS(2908),
    [anon_sym_switch] = ACTIONS(2908),
    [anon_sym_for] = ACTIONS(2908),
    [anon_sym_LPAREN] = ACTIONS(2910),
    [anon_sym_await] = ACTIONS(2908),
    [anon_sym_while] = ACTIONS(2908),
    [anon_sym_do] = ACTIONS(2908),
    [anon_sym_try] = ACTIONS(2908),
    [anon_sym_with] = ACTIONS(2908),
    [anon_sym_break] = ACTIONS(2908),
    [anon_sym_continue] = ACTIONS(2908),
    [anon_sym_debugger] = ACTIONS(2908),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_throw] = ACTIONS(2908),
    [anon_sym_SEMI] = ACTIONS(2910),
    [anon_sym_case] = ACTIONS(2908),
    [anon_sym_default] = ACTIONS(2908),
    [anon_sym_yield] = ACTIONS(2908),
    [anon_sym_LBRACK] = ACTIONS(2910),
    [anon_sym_LTtemplate_GT] = ACTIONS(2910),
    [anon_sym_LT] = ACTIONS(2908),
    [anon_sym_SLASH] = ACTIONS(2908),
    [anon_sym_class] = ACTIONS(2908),
    [anon_sym_async] = ACTIONS(2908),
    [anon_sym_function] = ACTIONS(2908),
    [anon_sym_new] = ACTIONS(2908),
    [anon_sym_AMP] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2908),
    [anon_sym_DASH] = ACTIONS(2908),
    [anon_sym_TILDE] = ACTIONS(2910),
    [anon_sym_void] = ACTIONS(2908),
    [anon_sym_delete] = ACTIONS(2908),
    [anon_sym_PLUS_PLUS] = ACTIONS(2910),
    [anon_sym_DASH_DASH] = ACTIONS(2910),
    [anon_sym_DQUOTE] = ACTIONS(2910),
    [anon_sym_SQUOTE] = ACTIONS(2910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2910),
    [sym_number] = ACTIONS(2910),
    [sym_this] = ACTIONS(2908),
    [sym_super] = ACTIONS(2908),
    [sym_true] = ACTIONS(2908),
    [sym_false] = ACTIONS(2908),
    [sym_null] = ACTIONS(2908),
    [sym_undefined] = ACTIONS(2908),
    [anon_sym_AT] = ACTIONS(2910),
    [anon_sym_static] = ACTIONS(2908),
    [anon_sym_readonly] = ACTIONS(2908),
    [anon_sym_get] = ACTIONS(2908),
    [anon_sym_set] = ACTIONS(2908),
    [anon_sym_declare] = ACTIONS(2908),
    [anon_sym_namespace] = ACTIONS(2908),
    [anon_sym_public] = ACTIONS(2908),
    [anon_sym_private] = ACTIONS(2908),
    [anon_sym_protected] = ACTIONS(2908),
    [anon_sym_override] = ACTIONS(2908),
    [anon_sym_module] = ACTIONS(2908),
    [anon_sym_any] = ACTIONS(2908),
    [anon_sym_number] = ACTIONS(2908),
    [anon_sym_boolean] = ACTIONS(2908),
    [anon_sym_string] = ACTIONS(2908),
    [anon_sym_symbol] = ACTIONS(2908),
    [anon_sym_abstract] = ACTIONS(2908),
    [anon_sym_interface] = ACTIONS(2908),
    [anon_sym_enum] = ACTIONS(2908),
    [anon_sym_component] = ACTIONS(2908),
  },
  [811] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LTtemplate_GT] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2610),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_override] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_component] = ACTIONS(2608),
  },
  [812] = {
    [sym_identifier] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_LBRACE] = ACTIONS(2914),
    [anon_sym_RBRACE] = ACTIONS(2914),
    [anon_sym_type] = ACTIONS(2912),
    [anon_sym_typeof] = ACTIONS(2912),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_var] = ACTIONS(2912),
    [anon_sym_let] = ACTIONS(2912),
    [anon_sym_const] = ACTIONS(2912),
    [anon_sym_BANG] = ACTIONS(2914),
    [anon_sym_else] = ACTIONS(2912),
    [anon_sym_if] = ACTIONS(2912),
    [anon_sym_switch] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2912),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_await] = ACTIONS(2912),
    [anon_sym_while] = ACTIONS(2912),
    [anon_sym_do] = ACTIONS(2912),
    [anon_sym_try] = ACTIONS(2912),
    [anon_sym_with] = ACTIONS(2912),
    [anon_sym_break] = ACTIONS(2912),
    [anon_sym_continue] = ACTIONS(2912),
    [anon_sym_debugger] = ACTIONS(2912),
    [anon_sym_return] = ACTIONS(2912),
    [anon_sym_throw] = ACTIONS(2912),
    [anon_sym_SEMI] = ACTIONS(2914),
    [anon_sym_case] = ACTIONS(2912),
    [anon_sym_default] = ACTIONS(2912),
    [anon_sym_yield] = ACTIONS(2912),
    [anon_sym_LBRACK] = ACTIONS(2914),
    [anon_sym_LTtemplate_GT] = ACTIONS(2914),
    [anon_sym_LT] = ACTIONS(2912),
    [anon_sym_SLASH] = ACTIONS(2912),
    [anon_sym_class] = ACTIONS(2912),
    [anon_sym_async] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2912),
    [anon_sym_new] = ACTIONS(2912),
    [anon_sym_AMP] = ACTIONS(2914),
    [anon_sym_PLUS] = ACTIONS(2912),
    [anon_sym_DASH] = ACTIONS(2912),
    [anon_sym_TILDE] = ACTIONS(2914),
    [anon_sym_void] = ACTIONS(2912),
    [anon_sym_delete] = ACTIONS(2912),
    [anon_sym_PLUS_PLUS] = ACTIONS(2914),
    [anon_sym_DASH_DASH] = ACTIONS(2914),
    [anon_sym_DQUOTE] = ACTIONS(2914),
    [anon_sym_SQUOTE] = ACTIONS(2914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2914),
    [sym_number] = ACTIONS(2914),
    [sym_this] = ACTIONS(2912),
    [sym_super] = ACTIONS(2912),
    [sym_true] = ACTIONS(2912),
    [sym_false] = ACTIONS(2912),
    [sym_null] = ACTIONS(2912),
    [sym_undefined] = ACTIONS(2912),
    [anon_sym_AT] = ACTIONS(2914),
    [anon_sym_static] = ACTIONS(2912),
    [anon_sym_readonly] = ACTIONS(2912),
    [anon_sym_get] = ACTIONS(2912),
    [anon_sym_set] = ACTIONS(2912),
    [anon_sym_declare] = ACTIONS(2912),
    [anon_sym_namespace] = ACTIONS(2912),
    [anon_sym_public] = ACTIONS(2912),
    [anon_sym_private] = ACTIONS(2912),
    [anon_sym_protected] = ACTIONS(2912),
    [anon_sym_override] = ACTIONS(2912),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_any] = ACTIONS(2912),
    [anon_sym_number] = ACTIONS(2912),
    [anon_sym_boolean] = ACTIONS(2912),
    [anon_sym_string] = ACTIONS(2912),
    [anon_sym_symbol] = ACTIONS(2912),
    [anon_sym_abstract] = ACTIONS(2912),
    [anon_sym_interface] = ACTIONS(2912),
    [anon_sym_enum] = ACTIONS(2912),
    [anon_sym_component] = ACTIONS(2912),
  },
  [813] = {
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_export] = ACTIONS(2916),
    [anon_sym_LBRACE] = ACTIONS(2918),
    [anon_sym_RBRACE] = ACTIONS(2918),
    [anon_sym_type] = ACTIONS(2916),
    [anon_sym_typeof] = ACTIONS(2916),
    [anon_sym_import] = ACTIONS(2916),
    [anon_sym_var] = ACTIONS(2916),
    [anon_sym_let] = ACTIONS(2916),
    [anon_sym_const] = ACTIONS(2916),
    [anon_sym_BANG] = ACTIONS(2918),
    [anon_sym_else] = ACTIONS(2916),
    [anon_sym_if] = ACTIONS(2916),
    [anon_sym_switch] = ACTIONS(2916),
    [anon_sym_for] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(2918),
    [anon_sym_await] = ACTIONS(2916),
    [anon_sym_while] = ACTIONS(2916),
    [anon_sym_do] = ACTIONS(2916),
    [anon_sym_try] = ACTIONS(2916),
    [anon_sym_with] = ACTIONS(2916),
    [anon_sym_break] = ACTIONS(2916),
    [anon_sym_continue] = ACTIONS(2916),
    [anon_sym_debugger] = ACTIONS(2916),
    [anon_sym_return] = ACTIONS(2916),
    [anon_sym_throw] = ACTIONS(2916),
    [anon_sym_SEMI] = ACTIONS(2918),
    [anon_sym_case] = ACTIONS(2916),
    [anon_sym_default] = ACTIONS(2916),
    [anon_sym_yield] = ACTIONS(2916),
    [anon_sym_LBRACK] = ACTIONS(2918),
    [anon_sym_LTtemplate_GT] = ACTIONS(2918),
    [anon_sym_LT] = ACTIONS(2916),
    [anon_sym_SLASH] = ACTIONS(2916),
    [anon_sym_class] = ACTIONS(2916),
    [anon_sym_async] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2916),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_AMP] = ACTIONS(2918),
    [anon_sym_PLUS] = ACTIONS(2916),
    [anon_sym_DASH] = ACTIONS(2916),
    [anon_sym_TILDE] = ACTIONS(2918),
    [anon_sym_void] = ACTIONS(2916),
    [anon_sym_delete] = ACTIONS(2916),
    [anon_sym_PLUS_PLUS] = ACTIONS(2918),
    [anon_sym_DASH_DASH] = ACTIONS(2918),
    [anon_sym_DQUOTE] = ACTIONS(2918),
    [anon_sym_SQUOTE] = ACTIONS(2918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2918),
    [sym_number] = ACTIONS(2918),
    [sym_this] = ACTIONS(2916),
    [sym_super] = ACTIONS(2916),
    [sym_true] = ACTIONS(2916),
    [sym_false] = ACTIONS(2916),
    [sym_null] = ACTIONS(2916),
    [sym_undefined] = ACTIONS(2916),
    [anon_sym_AT] = ACTIONS(2918),
    [anon_sym_static] = ACTIONS(2916),
    [anon_sym_readonly] = ACTIONS(2916),
    [anon_sym_get] = ACTIONS(2916),
    [anon_sym_set] = ACTIONS(2916),
    [anon_sym_declare] = ACTIONS(2916),
    [anon_sym_namespace] = ACTIONS(2916),
    [anon_sym_public] = ACTIONS(2916),
    [anon_sym_private] = ACTIONS(2916),
    [anon_sym_protected] = ACTIONS(2916),
    [anon_sym_override] = ACTIONS(2916),
    [anon_sym_module] = ACTIONS(2916),
    [anon_sym_any] = ACTIONS(2916),
    [anon_sym_number] = ACTIONS(2916),
    [anon_sym_boolean] = ACTIONS(2916),
    [anon_sym_string] = ACTIONS(2916),
    [anon_sym_symbol] = ACTIONS(2916),
    [anon_sym_abstract] = ACTIONS(2916),
    [anon_sym_interface] = ACTIONS(2916),
    [anon_sym_enum] = ACTIONS(2916),
    [anon_sym_component] = ACTIONS(2916),
  },
  [814] = {
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LTtemplate_GT] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_readonly] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_override] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_component] = ACTIONS(2604),
  },
  [815] = {
    [sym_identifier] = ACTIONS(2834),
    [anon_sym_STAR] = ACTIONS(2834),
    [anon_sym_as] = ACTIONS(2834),
    [anon_sym_LBRACE] = ACTIONS(2834),
    [anon_sym_RBRACE] = ACTIONS(2836),
    [anon_sym_typeof] = ACTIONS(2834),
    [anon_sym_BANG] = ACTIONS(2834),
    [anon_sym_LPAREN] = ACTIONS(2836),
    [anon_sym_in] = ACTIONS(2834),
    [anon_sym_SEMI] = ACTIONS(2836),
    [anon_sym_LBRACK] = ACTIONS(2836),
    [anon_sym_LT] = ACTIONS(2834),
    [anon_sym_GT] = ACTIONS(2834),
    [anon_sym_SLASH] = ACTIONS(2834),
    [anon_sym_DOT] = ACTIONS(2834),
    [anon_sym_async] = ACTIONS(2834),
    [anon_sym_QMARK_DOT] = ACTIONS(2836),
    [anon_sym_new] = ACTIONS(2834),
    [anon_sym_AMP_AMP] = ACTIONS(2836),
    [anon_sym_PIPE_PIPE] = ACTIONS(2836),
    [anon_sym_GT_GT] = ACTIONS(2834),
    [anon_sym_GT_GT_GT] = ACTIONS(2836),
    [anon_sym_LT_LT] = ACTIONS(2836),
    [anon_sym_AMP] = ACTIONS(2834),
    [anon_sym_CARET] = ACTIONS(2836),
    [anon_sym_PIPE] = ACTIONS(2834),
    [anon_sym_PLUS] = ACTIONS(2834),
    [anon_sym_DASH] = ACTIONS(2834),
    [anon_sym_PERCENT] = ACTIONS(2836),
    [anon_sym_STAR_STAR] = ACTIONS(2836),
    [anon_sym_LT_EQ] = ACTIONS(2836),
    [anon_sym_EQ_EQ] = ACTIONS(2834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2836),
    [anon_sym_BANG_EQ] = ACTIONS(2834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2836),
    [anon_sym_GT_EQ] = ACTIONS(2836),
    [anon_sym_QMARK_QMARK] = ACTIONS(2836),
    [anon_sym_instanceof] = ACTIONS(2834),
    [anon_sym_void] = ACTIONS(2834),
    [anon_sym_PLUS_PLUS] = ACTIONS(2836),
    [anon_sym_DASH_DASH] = ACTIONS(2836),
    [anon_sym_DQUOTE] = ACTIONS(2836),
    [anon_sym_SQUOTE] = ACTIONS(2836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2836),
    [sym_number] = ACTIONS(2836),
    [sym_this] = ACTIONS(2834),
    [sym_true] = ACTIONS(2834),
    [sym_false] = ACTIONS(2834),
    [sym_null] = ACTIONS(2834),
    [sym_undefined] = ACTIONS(2834),
    [anon_sym_static] = ACTIONS(2834),
    [anon_sym_readonly] = ACTIONS(2834),
    [anon_sym_get] = ACTIONS(2834),
    [anon_sym_set] = ACTIONS(2834),
    [anon_sym_QMARK] = ACTIONS(2834),
    [anon_sym_any] = ACTIONS(2834),
    [anon_sym_number] = ACTIONS(2834),
    [anon_sym_boolean] = ACTIONS(2834),
    [anon_sym_string] = ACTIONS(2834),
    [anon_sym_symbol] = ACTIONS(2834),
    [anon_sym_abstract] = ACTIONS(2834),
    [anon_sym_satisfies] = ACTIONS(2834),
    [anon_sym_extends] = ACTIONS(2834),
    [anon_sym_infer] = ACTIONS(2834),
    [anon_sym_is] = ACTIONS(2920),
    [anon_sym_keyof] = ACTIONS(2834),
    [anon_sym_unknown] = ACTIONS(2834),
    [anon_sym_never] = ACTIONS(2834),
    [anon_sym_object] = ACTIONS(2834),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2836),
    [anon_sym_constructor] = ACTIONS(2834),
    [anon_sym_prop] = ACTIONS(2834),
    [anon_sym_id] = ACTIONS(2834),
    [anon_sym_event] = ACTIONS(2834),
    [anon_sym_fn] = ACTIONS(2834),
    [anon_sym_on] = ACTIONS(2834),
    [sym__ternary_qmark] = ACTIONS(2836),
  },
  [816] = {
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LTtemplate_GT] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_readonly] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_override] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_component] = ACTIONS(2604),
  },
  [817] = {
    [sym_identifier] = ACTIONS(2922),
    [anon_sym_export] = ACTIONS(2922),
    [anon_sym_LBRACE] = ACTIONS(2924),
    [anon_sym_RBRACE] = ACTIONS(2924),
    [anon_sym_type] = ACTIONS(2922),
    [anon_sym_typeof] = ACTIONS(2922),
    [anon_sym_import] = ACTIONS(2922),
    [anon_sym_var] = ACTIONS(2922),
    [anon_sym_let] = ACTIONS(2922),
    [anon_sym_const] = ACTIONS(2922),
    [anon_sym_BANG] = ACTIONS(2924),
    [anon_sym_else] = ACTIONS(2922),
    [anon_sym_if] = ACTIONS(2922),
    [anon_sym_switch] = ACTIONS(2922),
    [anon_sym_for] = ACTIONS(2922),
    [anon_sym_LPAREN] = ACTIONS(2924),
    [anon_sym_await] = ACTIONS(2922),
    [anon_sym_while] = ACTIONS(2922),
    [anon_sym_do] = ACTIONS(2922),
    [anon_sym_try] = ACTIONS(2922),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_break] = ACTIONS(2922),
    [anon_sym_continue] = ACTIONS(2922),
    [anon_sym_debugger] = ACTIONS(2922),
    [anon_sym_return] = ACTIONS(2922),
    [anon_sym_throw] = ACTIONS(2922),
    [anon_sym_SEMI] = ACTIONS(2924),
    [anon_sym_case] = ACTIONS(2922),
    [anon_sym_default] = ACTIONS(2922),
    [anon_sym_yield] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2924),
    [anon_sym_LTtemplate_GT] = ACTIONS(2924),
    [anon_sym_LT] = ACTIONS(2922),
    [anon_sym_SLASH] = ACTIONS(2922),
    [anon_sym_class] = ACTIONS(2922),
    [anon_sym_async] = ACTIONS(2922),
    [anon_sym_function] = ACTIONS(2922),
    [anon_sym_new] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2924),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2924),
    [anon_sym_void] = ACTIONS(2922),
    [anon_sym_delete] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2924),
    [anon_sym_DASH_DASH] = ACTIONS(2924),
    [anon_sym_DQUOTE] = ACTIONS(2924),
    [anon_sym_SQUOTE] = ACTIONS(2924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2924),
    [sym_number] = ACTIONS(2924),
    [sym_this] = ACTIONS(2922),
    [sym_super] = ACTIONS(2922),
    [sym_true] = ACTIONS(2922),
    [sym_false] = ACTIONS(2922),
    [sym_null] = ACTIONS(2922),
    [sym_undefined] = ACTIONS(2922),
    [anon_sym_AT] = ACTIONS(2924),
    [anon_sym_static] = ACTIONS(2922),
    [anon_sym_readonly] = ACTIONS(2922),
    [anon_sym_get] = ACTIONS(2922),
    [anon_sym_set] = ACTIONS(2922),
    [anon_sym_declare] = ACTIONS(2922),
    [anon_sym_namespace] = ACTIONS(2922),
    [anon_sym_public] = ACTIONS(2922),
    [anon_sym_private] = ACTIONS(2922),
    [anon_sym_protected] = ACTIONS(2922),
    [anon_sym_override] = ACTIONS(2922),
    [anon_sym_module] = ACTIONS(2922),
    [anon_sym_any] = ACTIONS(2922),
    [anon_sym_number] = ACTIONS(2922),
    [anon_sym_boolean] = ACTIONS(2922),
    [anon_sym_string] = ACTIONS(2922),
    [anon_sym_symbol] = ACTIONS(2922),
    [anon_sym_abstract] = ACTIONS(2922),
    [anon_sym_interface] = ACTIONS(2922),
    [anon_sym_enum] = ACTIONS(2922),
    [anon_sym_component] = ACTIONS(2922),
  },
  [818] = {
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LTtemplate_GT] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_readonly] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_override] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_component] = ACTIONS(2604),
  },
  [819] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LTtemplate_GT] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2610),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_override] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_component] = ACTIONS(2608),
  },
  [820] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LTtemplate_GT] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2610),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_override] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_component] = ACTIONS(2608),
  },
  [821] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LTtemplate_GT] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2610),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_override] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_component] = ACTIONS(2608),
  },
  [822] = {
    [sym_identifier] = ACTIONS(2926),
    [anon_sym_export] = ACTIONS(2926),
    [anon_sym_LBRACE] = ACTIONS(2928),
    [anon_sym_RBRACE] = ACTIONS(2928),
    [anon_sym_type] = ACTIONS(2926),
    [anon_sym_typeof] = ACTIONS(2926),
    [anon_sym_import] = ACTIONS(2926),
    [anon_sym_var] = ACTIONS(2926),
    [anon_sym_let] = ACTIONS(2926),
    [anon_sym_const] = ACTIONS(2926),
    [anon_sym_BANG] = ACTIONS(2928),
    [anon_sym_else] = ACTIONS(2926),
    [anon_sym_if] = ACTIONS(2926),
    [anon_sym_switch] = ACTIONS(2926),
    [anon_sym_for] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(2928),
    [anon_sym_await] = ACTIONS(2926),
    [anon_sym_while] = ACTIONS(2926),
    [anon_sym_do] = ACTIONS(2926),
    [anon_sym_try] = ACTIONS(2926),
    [anon_sym_with] = ACTIONS(2926),
    [anon_sym_break] = ACTIONS(2926),
    [anon_sym_continue] = ACTIONS(2926),
    [anon_sym_debugger] = ACTIONS(2926),
    [anon_sym_return] = ACTIONS(2926),
    [anon_sym_throw] = ACTIONS(2926),
    [anon_sym_SEMI] = ACTIONS(2928),
    [anon_sym_case] = ACTIONS(2926),
    [anon_sym_default] = ACTIONS(2926),
    [anon_sym_yield] = ACTIONS(2926),
    [anon_sym_LBRACK] = ACTIONS(2928),
    [anon_sym_LTtemplate_GT] = ACTIONS(2928),
    [anon_sym_LT] = ACTIONS(2926),
    [anon_sym_SLASH] = ACTIONS(2926),
    [anon_sym_class] = ACTIONS(2926),
    [anon_sym_async] = ACTIONS(2926),
    [anon_sym_function] = ACTIONS(2926),
    [anon_sym_new] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2928),
    [anon_sym_PLUS] = ACTIONS(2926),
    [anon_sym_DASH] = ACTIONS(2926),
    [anon_sym_TILDE] = ACTIONS(2928),
    [anon_sym_void] = ACTIONS(2926),
    [anon_sym_delete] = ACTIONS(2926),
    [anon_sym_PLUS_PLUS] = ACTIONS(2928),
    [anon_sym_DASH_DASH] = ACTIONS(2928),
    [anon_sym_DQUOTE] = ACTIONS(2928),
    [anon_sym_SQUOTE] = ACTIONS(2928),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2928),
    [sym_number] = ACTIONS(2928),
    [sym_this] = ACTIONS(2926),
    [sym_super] = ACTIONS(2926),
    [sym_true] = ACTIONS(2926),
    [sym_false] = ACTIONS(2926),
    [sym_null] = ACTIONS(2926),
    [sym_undefined] = ACTIONS(2926),
    [anon_sym_AT] = ACTIONS(2928),
    [anon_sym_static] = ACTIONS(2926),
    [anon_sym_readonly] = ACTIONS(2926),
    [anon_sym_get] = ACTIONS(2926),
    [anon_sym_set] = ACTIONS(2926),
    [anon_sym_declare] = ACTIONS(2926),
    [anon_sym_namespace] = ACTIONS(2926),
    [anon_sym_public] = ACTIONS(2926),
    [anon_sym_private] = ACTIONS(2926),
    [anon_sym_protected] = ACTIONS(2926),
    [anon_sym_override] = ACTIONS(2926),
    [anon_sym_module] = ACTIONS(2926),
    [anon_sym_any] = ACTIONS(2926),
    [anon_sym_number] = ACTIONS(2926),
    [anon_sym_boolean] = ACTIONS(2926),
    [anon_sym_string] = ACTIONS(2926),
    [anon_sym_symbol] = ACTIONS(2926),
    [anon_sym_abstract] = ACTIONS(2926),
    [anon_sym_interface] = ACTIONS(2926),
    [anon_sym_enum] = ACTIONS(2926),
    [anon_sym_component] = ACTIONS(2926),
  },
  [823] = {
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LTtemplate_GT] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_readonly] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_override] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_component] = ACTIONS(2604),
  },
  [824] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LTtemplate_GT] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2610),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_override] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_component] = ACTIONS(2608),
  },
  [825] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LTtemplate_GT] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2610),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_override] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_component] = ACTIONS(2608),
  },
  [826] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LTtemplate_GT] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2610),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_override] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_component] = ACTIONS(2608),
  },
  [827] = {
    [sym_identifier] = ACTIONS(2930),
    [anon_sym_export] = ACTIONS(2930),
    [anon_sym_LBRACE] = ACTIONS(2932),
    [anon_sym_RBRACE] = ACTIONS(2932),
    [anon_sym_type] = ACTIONS(2930),
    [anon_sym_typeof] = ACTIONS(2930),
    [anon_sym_import] = ACTIONS(2930),
    [anon_sym_var] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_const] = ACTIONS(2930),
    [anon_sym_BANG] = ACTIONS(2932),
    [anon_sym_else] = ACTIONS(2930),
    [anon_sym_if] = ACTIONS(2930),
    [anon_sym_switch] = ACTIONS(2930),
    [anon_sym_for] = ACTIONS(2930),
    [anon_sym_LPAREN] = ACTIONS(2932),
    [anon_sym_await] = ACTIONS(2930),
    [anon_sym_while] = ACTIONS(2930),
    [anon_sym_do] = ACTIONS(2930),
    [anon_sym_try] = ACTIONS(2930),
    [anon_sym_with] = ACTIONS(2930),
    [anon_sym_break] = ACTIONS(2930),
    [anon_sym_continue] = ACTIONS(2930),
    [anon_sym_debugger] = ACTIONS(2930),
    [anon_sym_return] = ACTIONS(2930),
    [anon_sym_throw] = ACTIONS(2930),
    [anon_sym_SEMI] = ACTIONS(2932),
    [anon_sym_case] = ACTIONS(2930),
    [anon_sym_default] = ACTIONS(2930),
    [anon_sym_yield] = ACTIONS(2930),
    [anon_sym_LBRACK] = ACTIONS(2932),
    [anon_sym_LTtemplate_GT] = ACTIONS(2932),
    [anon_sym_LT] = ACTIONS(2930),
    [anon_sym_SLASH] = ACTIONS(2930),
    [anon_sym_class] = ACTIONS(2930),
    [anon_sym_async] = ACTIONS(2930),
    [anon_sym_function] = ACTIONS(2930),
    [anon_sym_new] = ACTIONS(2930),
    [anon_sym_AMP] = ACTIONS(2932),
    [anon_sym_PLUS] = ACTIONS(2930),
    [anon_sym_DASH] = ACTIONS(2930),
    [anon_sym_TILDE] = ACTIONS(2932),
    [anon_sym_void] = ACTIONS(2930),
    [anon_sym_delete] = ACTIONS(2930),
    [anon_sym_PLUS_PLUS] = ACTIONS(2932),
    [anon_sym_DASH_DASH] = ACTIONS(2932),
    [anon_sym_DQUOTE] = ACTIONS(2932),
    [anon_sym_SQUOTE] = ACTIONS(2932),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2932),
    [sym_number] = ACTIONS(2932),
    [sym_this] = ACTIONS(2930),
    [sym_super] = ACTIONS(2930),
    [sym_true] = ACTIONS(2930),
    [sym_false] = ACTIONS(2930),
    [sym_null] = ACTIONS(2930),
    [sym_undefined] = ACTIONS(2930),
    [anon_sym_AT] = ACTIONS(2932),
    [anon_sym_static] = ACTIONS(2930),
    [anon_sym_readonly] = ACTIONS(2930),
    [anon_sym_get] = ACTIONS(2930),
    [anon_sym_set] = ACTIONS(2930),
    [anon_sym_declare] = ACTIONS(2930),
    [anon_sym_namespace] = ACTIONS(2930),
    [anon_sym_public] = ACTIONS(2930),
    [anon_sym_private] = ACTIONS(2930),
    [anon_sym_protected] = ACTIONS(2930),
    [anon_sym_override] = ACTIONS(2930),
    [anon_sym_module] = ACTIONS(2930),
    [anon_sym_any] = ACTIONS(2930),
    [anon_sym_number] = ACTIONS(2930),
    [anon_sym_boolean] = ACTIONS(2930),
    [anon_sym_string] = ACTIONS(2930),
    [anon_sym_symbol] = ACTIONS(2930),
    [anon_sym_abstract] = ACTIONS(2930),
    [anon_sym_interface] = ACTIONS(2930),
    [anon_sym_enum] = ACTIONS(2930),
    [anon_sym_component] = ACTIONS(2930),
  },
  [828] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LTtemplate_GT] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2610),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_override] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_component] = ACTIONS(2608),
  },
  [829] = {
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_export] = ACTIONS(2934),
    [anon_sym_LBRACE] = ACTIONS(2936),
    [anon_sym_RBRACE] = ACTIONS(2936),
    [anon_sym_type] = ACTIONS(2934),
    [anon_sym_typeof] = ACTIONS(2934),
    [anon_sym_import] = ACTIONS(2934),
    [anon_sym_var] = ACTIONS(2934),
    [anon_sym_let] = ACTIONS(2934),
    [anon_sym_const] = ACTIONS(2934),
    [anon_sym_BANG] = ACTIONS(2936),
    [anon_sym_else] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_switch] = ACTIONS(2934),
    [anon_sym_for] = ACTIONS(2934),
    [anon_sym_LPAREN] = ACTIONS(2936),
    [anon_sym_await] = ACTIONS(2934),
    [anon_sym_while] = ACTIONS(2934),
    [anon_sym_do] = ACTIONS(2934),
    [anon_sym_try] = ACTIONS(2934),
    [anon_sym_with] = ACTIONS(2934),
    [anon_sym_break] = ACTIONS(2934),
    [anon_sym_continue] = ACTIONS(2934),
    [anon_sym_debugger] = ACTIONS(2934),
    [anon_sym_return] = ACTIONS(2934),
    [anon_sym_throw] = ACTIONS(2934),
    [anon_sym_SEMI] = ACTIONS(2936),
    [anon_sym_case] = ACTIONS(2934),
    [anon_sym_default] = ACTIONS(2934),
    [anon_sym_yield] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2936),
    [anon_sym_LTtemplate_GT] = ACTIONS(2936),
    [anon_sym_LT] = ACTIONS(2934),
    [anon_sym_SLASH] = ACTIONS(2934),
    [anon_sym_class] = ACTIONS(2934),
    [anon_sym_async] = ACTIONS(2934),
    [anon_sym_function] = ACTIONS(2934),
    [anon_sym_new] = ACTIONS(2934),
    [anon_sym_AMP] = ACTIONS(2936),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_TILDE] = ACTIONS(2936),
    [anon_sym_void] = ACTIONS(2934),
    [anon_sym_delete] = ACTIONS(2934),
    [anon_sym_PLUS_PLUS] = ACTIONS(2936),
    [anon_sym_DASH_DASH] = ACTIONS(2936),
    [anon_sym_DQUOTE] = ACTIONS(2936),
    [anon_sym_SQUOTE] = ACTIONS(2936),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2936),
    [sym_number] = ACTIONS(2936),
    [sym_this] = ACTIONS(2934),
    [sym_super] = ACTIONS(2934),
    [sym_true] = ACTIONS(2934),
    [sym_false] = ACTIONS(2934),
    [sym_null] = ACTIONS(2934),
    [sym_undefined] = ACTIONS(2934),
    [anon_sym_AT] = ACTIONS(2936),
    [anon_sym_static] = ACTIONS(2934),
    [anon_sym_readonly] = ACTIONS(2934),
    [anon_sym_get] = ACTIONS(2934),
    [anon_sym_set] = ACTIONS(2934),
    [anon_sym_declare] = ACTIONS(2934),
    [anon_sym_namespace] = ACTIONS(2934),
    [anon_sym_public] = ACTIONS(2934),
    [anon_sym_private] = ACTIONS(2934),
    [anon_sym_protected] = ACTIONS(2934),
    [anon_sym_override] = ACTIONS(2934),
    [anon_sym_module] = ACTIONS(2934),
    [anon_sym_any] = ACTIONS(2934),
    [anon_sym_number] = ACTIONS(2934),
    [anon_sym_boolean] = ACTIONS(2934),
    [anon_sym_string] = ACTIONS(2934),
    [anon_sym_symbol] = ACTIONS(2934),
    [anon_sym_abstract] = ACTIONS(2934),
    [anon_sym_interface] = ACTIONS(2934),
    [anon_sym_enum] = ACTIONS(2934),
    [anon_sym_component] = ACTIONS(2934),
  },
  [830] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LTtemplate_GT] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2610),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_override] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_component] = ACTIONS(2608),
  },
  [831] = {
    [sym_identifier] = ACTIONS(2938),
    [anon_sym_export] = ACTIONS(2938),
    [anon_sym_LBRACE] = ACTIONS(2940),
    [anon_sym_RBRACE] = ACTIONS(2940),
    [anon_sym_type] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(2938),
    [anon_sym_import] = ACTIONS(2938),
    [anon_sym_var] = ACTIONS(2938),
    [anon_sym_let] = ACTIONS(2938),
    [anon_sym_const] = ACTIONS(2938),
    [anon_sym_BANG] = ACTIONS(2940),
    [anon_sym_else] = ACTIONS(2938),
    [anon_sym_if] = ACTIONS(2938),
    [anon_sym_switch] = ACTIONS(2938),
    [anon_sym_for] = ACTIONS(2938),
    [anon_sym_LPAREN] = ACTIONS(2940),
    [anon_sym_await] = ACTIONS(2938),
    [anon_sym_while] = ACTIONS(2938),
    [anon_sym_do] = ACTIONS(2938),
    [anon_sym_try] = ACTIONS(2938),
    [anon_sym_with] = ACTIONS(2938),
    [anon_sym_break] = ACTIONS(2938),
    [anon_sym_continue] = ACTIONS(2938),
    [anon_sym_debugger] = ACTIONS(2938),
    [anon_sym_return] = ACTIONS(2938),
    [anon_sym_throw] = ACTIONS(2938),
    [anon_sym_SEMI] = ACTIONS(2940),
    [anon_sym_case] = ACTIONS(2938),
    [anon_sym_default] = ACTIONS(2938),
    [anon_sym_yield] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2940),
    [anon_sym_LTtemplate_GT] = ACTIONS(2940),
    [anon_sym_LT] = ACTIONS(2938),
    [anon_sym_SLASH] = ACTIONS(2938),
    [anon_sym_class] = ACTIONS(2938),
    [anon_sym_async] = ACTIONS(2938),
    [anon_sym_function] = ACTIONS(2938),
    [anon_sym_new] = ACTIONS(2938),
    [anon_sym_AMP] = ACTIONS(2940),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2940),
    [anon_sym_void] = ACTIONS(2938),
    [anon_sym_delete] = ACTIONS(2938),
    [anon_sym_PLUS_PLUS] = ACTIONS(2940),
    [anon_sym_DASH_DASH] = ACTIONS(2940),
    [anon_sym_DQUOTE] = ACTIONS(2940),
    [anon_sym_SQUOTE] = ACTIONS(2940),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2940),
    [sym_number] = ACTIONS(2940),
    [sym_this] = ACTIONS(2938),
    [sym_super] = ACTIONS(2938),
    [sym_true] = ACTIONS(2938),
    [sym_false] = ACTIONS(2938),
    [sym_null] = ACTIONS(2938),
    [sym_undefined] = ACTIONS(2938),
    [anon_sym_AT] = ACTIONS(2940),
    [anon_sym_static] = ACTIONS(2938),
    [anon_sym_readonly] = ACTIONS(2938),
    [anon_sym_get] = ACTIONS(2938),
    [anon_sym_set] = ACTIONS(2938),
    [anon_sym_declare] = ACTIONS(2938),
    [anon_sym_namespace] = ACTIONS(2938),
    [anon_sym_public] = ACTIONS(2938),
    [anon_sym_private] = ACTIONS(2938),
    [anon_sym_protected] = ACTIONS(2938),
    [anon_sym_override] = ACTIONS(2938),
    [anon_sym_module] = ACTIONS(2938),
    [anon_sym_any] = ACTIONS(2938),
    [anon_sym_number] = ACTIONS(2938),
    [anon_sym_boolean] = ACTIONS(2938),
    [anon_sym_string] = ACTIONS(2938),
    [anon_sym_symbol] = ACTIONS(2938),
    [anon_sym_abstract] = ACTIONS(2938),
    [anon_sym_interface] = ACTIONS(2938),
    [anon_sym_enum] = ACTIONS(2938),
    [anon_sym_component] = ACTIONS(2938),
  },
  [832] = {
    [sym_identifier] = ACTIONS(2942),
    [anon_sym_export] = ACTIONS(2942),
    [anon_sym_LBRACE] = ACTIONS(2944),
    [anon_sym_RBRACE] = ACTIONS(2944),
    [anon_sym_type] = ACTIONS(2942),
    [anon_sym_typeof] = ACTIONS(2942),
    [anon_sym_import] = ACTIONS(2942),
    [anon_sym_var] = ACTIONS(2942),
    [anon_sym_let] = ACTIONS(2942),
    [anon_sym_const] = ACTIONS(2942),
    [anon_sym_BANG] = ACTIONS(2944),
    [anon_sym_else] = ACTIONS(2942),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_switch] = ACTIONS(2942),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_LPAREN] = ACTIONS(2944),
    [anon_sym_await] = ACTIONS(2942),
    [anon_sym_while] = ACTIONS(2942),
    [anon_sym_do] = ACTIONS(2942),
    [anon_sym_try] = ACTIONS(2942),
    [anon_sym_with] = ACTIONS(2942),
    [anon_sym_break] = ACTIONS(2942),
    [anon_sym_continue] = ACTIONS(2942),
    [anon_sym_debugger] = ACTIONS(2942),
    [anon_sym_return] = ACTIONS(2942),
    [anon_sym_throw] = ACTIONS(2942),
    [anon_sym_SEMI] = ACTIONS(2944),
    [anon_sym_case] = ACTIONS(2942),
    [anon_sym_default] = ACTIONS(2942),
    [anon_sym_yield] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2944),
    [anon_sym_LTtemplate_GT] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2942),
    [anon_sym_SLASH] = ACTIONS(2942),
    [anon_sym_class] = ACTIONS(2942),
    [anon_sym_async] = ACTIONS(2942),
    [anon_sym_function] = ACTIONS(2942),
    [anon_sym_new] = ACTIONS(2942),
    [anon_sym_AMP] = ACTIONS(2944),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_DASH] = ACTIONS(2942),
    [anon_sym_TILDE] = ACTIONS(2944),
    [anon_sym_void] = ACTIONS(2942),
    [anon_sym_delete] = ACTIONS(2942),
    [anon_sym_PLUS_PLUS] = ACTIONS(2944),
    [anon_sym_DASH_DASH] = ACTIONS(2944),
    [anon_sym_DQUOTE] = ACTIONS(2944),
    [anon_sym_SQUOTE] = ACTIONS(2944),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2944),
    [sym_number] = ACTIONS(2944),
    [sym_this] = ACTIONS(2942),
    [sym_super] = ACTIONS(2942),
    [sym_true] = ACTIONS(2942),
    [sym_false] = ACTIONS(2942),
    [sym_null] = ACTIONS(2942),
    [sym_undefined] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(2944),
    [anon_sym_static] = ACTIONS(2942),
    [anon_sym_readonly] = ACTIONS(2942),
    [anon_sym_get] = ACTIONS(2942),
    [anon_sym_set] = ACTIONS(2942),
    [anon_sym_declare] = ACTIONS(2942),
    [anon_sym_namespace] = ACTIONS(2942),
    [anon_sym_public] = ACTIONS(2942),
    [anon_sym_private] = ACTIONS(2942),
    [anon_sym_protected] = ACTIONS(2942),
    [anon_sym_override] = ACTIONS(2942),
    [anon_sym_module] = ACTIONS(2942),
    [anon_sym_any] = ACTIONS(2942),
    [anon_sym_number] = ACTIONS(2942),
    [anon_sym_boolean] = ACTIONS(2942),
    [anon_sym_string] = ACTIONS(2942),
    [anon_sym_symbol] = ACTIONS(2942),
    [anon_sym_abstract] = ACTIONS(2942),
    [anon_sym_interface] = ACTIONS(2942),
    [anon_sym_enum] = ACTIONS(2942),
    [anon_sym_component] = ACTIONS(2942),
  },
  [833] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_export] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2948),
    [anon_sym_type] = ACTIONS(2946),
    [anon_sym_typeof] = ACTIONS(2946),
    [anon_sym_import] = ACTIONS(2946),
    [anon_sym_var] = ACTIONS(2946),
    [anon_sym_let] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_LPAREN] = ACTIONS(2948),
    [anon_sym_await] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_with] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_debugger] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2948),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_yield] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2948),
    [anon_sym_LTtemplate_GT] = ACTIONS(2948),
    [anon_sym_LT] = ACTIONS(2946),
    [anon_sym_SLASH] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_async] = ACTIONS(2946),
    [anon_sym_function] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2948),
    [anon_sym_void] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_PLUS_PLUS] = ACTIONS(2948),
    [anon_sym_DASH_DASH] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2948),
    [sym_number] = ACTIONS(2948),
    [sym_this] = ACTIONS(2946),
    [sym_super] = ACTIONS(2946),
    [sym_true] = ACTIONS(2946),
    [sym_false] = ACTIONS(2946),
    [sym_null] = ACTIONS(2946),
    [sym_undefined] = ACTIONS(2946),
    [anon_sym_AT] = ACTIONS(2948),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_readonly] = ACTIONS(2946),
    [anon_sym_get] = ACTIONS(2946),
    [anon_sym_set] = ACTIONS(2946),
    [anon_sym_declare] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_public] = ACTIONS(2946),
    [anon_sym_private] = ACTIONS(2946),
    [anon_sym_protected] = ACTIONS(2946),
    [anon_sym_override] = ACTIONS(2946),
    [anon_sym_module] = ACTIONS(2946),
    [anon_sym_any] = ACTIONS(2946),
    [anon_sym_number] = ACTIONS(2946),
    [anon_sym_boolean] = ACTIONS(2946),
    [anon_sym_string] = ACTIONS(2946),
    [anon_sym_symbol] = ACTIONS(2946),
    [anon_sym_abstract] = ACTIONS(2946),
    [anon_sym_interface] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_component] = ACTIONS(2946),
  },
  [834] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LTtemplate_GT] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2610),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_override] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_component] = ACTIONS(2608),
  },
  [835] = {
    [sym_identifier] = ACTIONS(2950),
    [anon_sym_export] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_RBRACE] = ACTIONS(2952),
    [anon_sym_type] = ACTIONS(2950),
    [anon_sym_typeof] = ACTIONS(2950),
    [anon_sym_import] = ACTIONS(2950),
    [anon_sym_var] = ACTIONS(2950),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_const] = ACTIONS(2950),
    [anon_sym_BANG] = ACTIONS(2952),
    [anon_sym_else] = ACTIONS(2950),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_switch] = ACTIONS(2950),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_LPAREN] = ACTIONS(2952),
    [anon_sym_await] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_with] = ACTIONS(2950),
    [anon_sym_break] = ACTIONS(2950),
    [anon_sym_continue] = ACTIONS(2950),
    [anon_sym_debugger] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_throw] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2952),
    [anon_sym_case] = ACTIONS(2950),
    [anon_sym_default] = ACTIONS(2950),
    [anon_sym_yield] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2952),
    [anon_sym_LTtemplate_GT] = ACTIONS(2952),
    [anon_sym_LT] = ACTIONS(2950),
    [anon_sym_SLASH] = ACTIONS(2950),
    [anon_sym_class] = ACTIONS(2950),
    [anon_sym_async] = ACTIONS(2950),
    [anon_sym_function] = ACTIONS(2950),
    [anon_sym_new] = ACTIONS(2950),
    [anon_sym_AMP] = ACTIONS(2952),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2952),
    [anon_sym_void] = ACTIONS(2950),
    [anon_sym_delete] = ACTIONS(2950),
    [anon_sym_PLUS_PLUS] = ACTIONS(2952),
    [anon_sym_DASH_DASH] = ACTIONS(2952),
    [anon_sym_DQUOTE] = ACTIONS(2952),
    [anon_sym_SQUOTE] = ACTIONS(2952),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2952),
    [sym_number] = ACTIONS(2952),
    [sym_this] = ACTIONS(2950),
    [sym_super] = ACTIONS(2950),
    [sym_true] = ACTIONS(2950),
    [sym_false] = ACTIONS(2950),
    [sym_null] = ACTIONS(2950),
    [sym_undefined] = ACTIONS(2950),
    [anon_sym_AT] = ACTIONS(2952),
    [anon_sym_static] = ACTIONS(2950),
    [anon_sym_readonly] = ACTIONS(2950),
    [anon_sym_get] = ACTIONS(2950),
    [anon_sym_set] = ACTIONS(2950),
    [anon_sym_declare] = ACTIONS(2950),
    [anon_sym_namespace] = ACTIONS(2950),
    [anon_sym_public] = ACTIONS(2950),
    [anon_sym_private] = ACTIONS(2950),
    [anon_sym_protected] = ACTIONS(2950),
    [anon_sym_override] = ACTIONS(2950),
    [anon_sym_module] = ACTIONS(2950),
    [anon_sym_any] = ACTIONS(2950),
    [anon_sym_number] = ACTIONS(2950),
    [anon_sym_boolean] = ACTIONS(2950),
    [anon_sym_string] = ACTIONS(2950),
    [anon_sym_symbol] = ACTIONS(2950),
    [anon_sym_abstract] = ACTIONS(2950),
    [anon_sym_interface] = ACTIONS(2950),
    [anon_sym_enum] = ACTIONS(2950),
    [anon_sym_component] = ACTIONS(2950),
  },
  [836] = {
    [sym_identifier] = ACTIONS(2954),
    [anon_sym_export] = ACTIONS(2954),
    [anon_sym_LBRACE] = ACTIONS(2956),
    [anon_sym_RBRACE] = ACTIONS(2956),
    [anon_sym_type] = ACTIONS(2954),
    [anon_sym_typeof] = ACTIONS(2954),
    [anon_sym_import] = ACTIONS(2954),
    [anon_sym_var] = ACTIONS(2954),
    [anon_sym_let] = ACTIONS(2954),
    [anon_sym_const] = ACTIONS(2954),
    [anon_sym_BANG] = ACTIONS(2956),
    [anon_sym_else] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_switch] = ACTIONS(2954),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_LPAREN] = ACTIONS(2956),
    [anon_sym_await] = ACTIONS(2954),
    [anon_sym_while] = ACTIONS(2954),
    [anon_sym_do] = ACTIONS(2954),
    [anon_sym_try] = ACTIONS(2954),
    [anon_sym_with] = ACTIONS(2954),
    [anon_sym_break] = ACTIONS(2954),
    [anon_sym_continue] = ACTIONS(2954),
    [anon_sym_debugger] = ACTIONS(2954),
    [anon_sym_return] = ACTIONS(2954),
    [anon_sym_throw] = ACTIONS(2954),
    [anon_sym_SEMI] = ACTIONS(2956),
    [anon_sym_case] = ACTIONS(2954),
    [anon_sym_default] = ACTIONS(2954),
    [anon_sym_yield] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2956),
    [anon_sym_LTtemplate_GT] = ACTIONS(2956),
    [anon_sym_LT] = ACTIONS(2954),
    [anon_sym_SLASH] = ACTIONS(2954),
    [anon_sym_class] = ACTIONS(2954),
    [anon_sym_async] = ACTIONS(2954),
    [anon_sym_function] = ACTIONS(2954),
    [anon_sym_new] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(2956),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_TILDE] = ACTIONS(2956),
    [anon_sym_void] = ACTIONS(2954),
    [anon_sym_delete] = ACTIONS(2954),
    [anon_sym_PLUS_PLUS] = ACTIONS(2956),
    [anon_sym_DASH_DASH] = ACTIONS(2956),
    [anon_sym_DQUOTE] = ACTIONS(2956),
    [anon_sym_SQUOTE] = ACTIONS(2956),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2956),
    [sym_number] = ACTIONS(2956),
    [sym_this] = ACTIONS(2954),
    [sym_super] = ACTIONS(2954),
    [sym_true] = ACTIONS(2954),
    [sym_false] = ACTIONS(2954),
    [sym_null] = ACTIONS(2954),
    [sym_undefined] = ACTIONS(2954),
    [anon_sym_AT] = ACTIONS(2956),
    [anon_sym_static] = ACTIONS(2954),
    [anon_sym_readonly] = ACTIONS(2954),
    [anon_sym_get] = ACTIONS(2954),
    [anon_sym_set] = ACTIONS(2954),
    [anon_sym_declare] = ACTIONS(2954),
    [anon_sym_namespace] = ACTIONS(2954),
    [anon_sym_public] = ACTIONS(2954),
    [anon_sym_private] = ACTIONS(2954),
    [anon_sym_protected] = ACTIONS(2954),
    [anon_sym_override] = ACTIONS(2954),
    [anon_sym_module] = ACTIONS(2954),
    [anon_sym_any] = ACTIONS(2954),
    [anon_sym_number] = ACTIONS(2954),
    [anon_sym_boolean] = ACTIONS(2954),
    [anon_sym_string] = ACTIONS(2954),
    [anon_sym_symbol] = ACTIONS(2954),
    [anon_sym_abstract] = ACTIONS(2954),
    [anon_sym_interface] = ACTIONS(2954),
    [anon_sym_enum] = ACTIONS(2954),
    [anon_sym_component] = ACTIONS(2954),
  },
  [837] = {
    [sym_identifier] = ACTIONS(2958),
    [anon_sym_export] = ACTIONS(2958),
    [anon_sym_LBRACE] = ACTIONS(2960),
    [anon_sym_RBRACE] = ACTIONS(2960),
    [anon_sym_type] = ACTIONS(2958),
    [anon_sym_typeof] = ACTIONS(2958),
    [anon_sym_import] = ACTIONS(2958),
    [anon_sym_var] = ACTIONS(2958),
    [anon_sym_let] = ACTIONS(2958),
    [anon_sym_const] = ACTIONS(2958),
    [anon_sym_BANG] = ACTIONS(2960),
    [anon_sym_else] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2958),
    [anon_sym_switch] = ACTIONS(2958),
    [anon_sym_for] = ACTIONS(2958),
    [anon_sym_LPAREN] = ACTIONS(2960),
    [anon_sym_await] = ACTIONS(2958),
    [anon_sym_while] = ACTIONS(2958),
    [anon_sym_do] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2958),
    [anon_sym_with] = ACTIONS(2958),
    [anon_sym_break] = ACTIONS(2958),
    [anon_sym_continue] = ACTIONS(2958),
    [anon_sym_debugger] = ACTIONS(2958),
    [anon_sym_return] = ACTIONS(2958),
    [anon_sym_throw] = ACTIONS(2958),
    [anon_sym_SEMI] = ACTIONS(2960),
    [anon_sym_case] = ACTIONS(2958),
    [anon_sym_default] = ACTIONS(2958),
    [anon_sym_yield] = ACTIONS(2958),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_LTtemplate_GT] = ACTIONS(2960),
    [anon_sym_LT] = ACTIONS(2958),
    [anon_sym_SLASH] = ACTIONS(2958),
    [anon_sym_class] = ACTIONS(2958),
    [anon_sym_async] = ACTIONS(2958),
    [anon_sym_function] = ACTIONS(2958),
    [anon_sym_new] = ACTIONS(2958),
    [anon_sym_AMP] = ACTIONS(2960),
    [anon_sym_PLUS] = ACTIONS(2958),
    [anon_sym_DASH] = ACTIONS(2958),
    [anon_sym_TILDE] = ACTIONS(2960),
    [anon_sym_void] = ACTIONS(2958),
    [anon_sym_delete] = ACTIONS(2958),
    [anon_sym_PLUS_PLUS] = ACTIONS(2960),
    [anon_sym_DASH_DASH] = ACTIONS(2960),
    [anon_sym_DQUOTE] = ACTIONS(2960),
    [anon_sym_SQUOTE] = ACTIONS(2960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2960),
    [sym_number] = ACTIONS(2960),
    [sym_this] = ACTIONS(2958),
    [sym_super] = ACTIONS(2958),
    [sym_true] = ACTIONS(2958),
    [sym_false] = ACTIONS(2958),
    [sym_null] = ACTIONS(2958),
    [sym_undefined] = ACTIONS(2958),
    [anon_sym_AT] = ACTIONS(2960),
    [anon_sym_static] = ACTIONS(2958),
    [anon_sym_readonly] = ACTIONS(2958),
    [anon_sym_get] = ACTIONS(2958),
    [anon_sym_set] = ACTIONS(2958),
    [anon_sym_declare] = ACTIONS(2958),
    [anon_sym_namespace] = ACTIONS(2958),
    [anon_sym_public] = ACTIONS(2958),
    [anon_sym_private] = ACTIONS(2958),
    [anon_sym_protected] = ACTIONS(2958),
    [anon_sym_override] = ACTIONS(2958),
    [anon_sym_module] = ACTIONS(2958),
    [anon_sym_any] = ACTIONS(2958),
    [anon_sym_number] = ACTIONS(2958),
    [anon_sym_boolean] = ACTIONS(2958),
    [anon_sym_string] = ACTIONS(2958),
    [anon_sym_symbol] = ACTIONS(2958),
    [anon_sym_abstract] = ACTIONS(2958),
    [anon_sym_interface] = ACTIONS(2958),
    [anon_sym_enum] = ACTIONS(2958),
    [anon_sym_component] = ACTIONS(2958),
  },
  [838] = {
    [sym_identifier] = ACTIONS(2962),
    [anon_sym_export] = ACTIONS(2962),
    [anon_sym_LBRACE] = ACTIONS(2964),
    [anon_sym_RBRACE] = ACTIONS(2964),
    [anon_sym_type] = ACTIONS(2962),
    [anon_sym_typeof] = ACTIONS(2962),
    [anon_sym_import] = ACTIONS(2962),
    [anon_sym_var] = ACTIONS(2962),
    [anon_sym_let] = ACTIONS(2962),
    [anon_sym_const] = ACTIONS(2962),
    [anon_sym_BANG] = ACTIONS(2964),
    [anon_sym_else] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2962),
    [anon_sym_switch] = ACTIONS(2962),
    [anon_sym_for] = ACTIONS(2962),
    [anon_sym_LPAREN] = ACTIONS(2964),
    [anon_sym_await] = ACTIONS(2962),
    [anon_sym_while] = ACTIONS(2962),
    [anon_sym_do] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2962),
    [anon_sym_with] = ACTIONS(2962),
    [anon_sym_break] = ACTIONS(2962),
    [anon_sym_continue] = ACTIONS(2962),
    [anon_sym_debugger] = ACTIONS(2962),
    [anon_sym_return] = ACTIONS(2962),
    [anon_sym_throw] = ACTIONS(2962),
    [anon_sym_SEMI] = ACTIONS(2964),
    [anon_sym_case] = ACTIONS(2962),
    [anon_sym_default] = ACTIONS(2962),
    [anon_sym_yield] = ACTIONS(2962),
    [anon_sym_LBRACK] = ACTIONS(2964),
    [anon_sym_LTtemplate_GT] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2962),
    [anon_sym_SLASH] = ACTIONS(2962),
    [anon_sym_class] = ACTIONS(2962),
    [anon_sym_async] = ACTIONS(2962),
    [anon_sym_function] = ACTIONS(2962),
    [anon_sym_new] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_PLUS] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2964),
    [anon_sym_void] = ACTIONS(2962),
    [anon_sym_delete] = ACTIONS(2962),
    [anon_sym_PLUS_PLUS] = ACTIONS(2964),
    [anon_sym_DASH_DASH] = ACTIONS(2964),
    [anon_sym_DQUOTE] = ACTIONS(2964),
    [anon_sym_SQUOTE] = ACTIONS(2964),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2964),
    [sym_number] = ACTIONS(2964),
    [sym_this] = ACTIONS(2962),
    [sym_super] = ACTIONS(2962),
    [sym_true] = ACTIONS(2962),
    [sym_false] = ACTIONS(2962),
    [sym_null] = ACTIONS(2962),
    [sym_undefined] = ACTIONS(2962),
    [anon_sym_AT] = ACTIONS(2964),
    [anon_sym_static] = ACTIONS(2962),
    [anon_sym_readonly] = ACTIONS(2962),
    [anon_sym_get] = ACTIONS(2962),
    [anon_sym_set] = ACTIONS(2962),
    [anon_sym_declare] = ACTIONS(2962),
    [anon_sym_namespace] = ACTIONS(2962),
    [anon_sym_public] = ACTIONS(2962),
    [anon_sym_private] = ACTIONS(2962),
    [anon_sym_protected] = ACTIONS(2962),
    [anon_sym_override] = ACTIONS(2962),
    [anon_sym_module] = ACTIONS(2962),
    [anon_sym_any] = ACTIONS(2962),
    [anon_sym_number] = ACTIONS(2962),
    [anon_sym_boolean] = ACTIONS(2962),
    [anon_sym_string] = ACTIONS(2962),
    [anon_sym_symbol] = ACTIONS(2962),
    [anon_sym_abstract] = ACTIONS(2962),
    [anon_sym_interface] = ACTIONS(2962),
    [anon_sym_enum] = ACTIONS(2962),
    [anon_sym_component] = ACTIONS(2962),
  },
  [839] = {
    [sym_identifier] = ACTIONS(2966),
    [anon_sym_export] = ACTIONS(2966),
    [anon_sym_LBRACE] = ACTIONS(2968),
    [anon_sym_RBRACE] = ACTIONS(2968),
    [anon_sym_type] = ACTIONS(2966),
    [anon_sym_typeof] = ACTIONS(2966),
    [anon_sym_import] = ACTIONS(2966),
    [anon_sym_var] = ACTIONS(2966),
    [anon_sym_let] = ACTIONS(2966),
    [anon_sym_const] = ACTIONS(2966),
    [anon_sym_BANG] = ACTIONS(2968),
    [anon_sym_else] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2966),
    [anon_sym_switch] = ACTIONS(2966),
    [anon_sym_for] = ACTIONS(2966),
    [anon_sym_LPAREN] = ACTIONS(2968),
    [anon_sym_await] = ACTIONS(2966),
    [anon_sym_while] = ACTIONS(2966),
    [anon_sym_do] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2966),
    [anon_sym_with] = ACTIONS(2966),
    [anon_sym_break] = ACTIONS(2966),
    [anon_sym_continue] = ACTIONS(2966),
    [anon_sym_debugger] = ACTIONS(2966),
    [anon_sym_return] = ACTIONS(2966),
    [anon_sym_throw] = ACTIONS(2966),
    [anon_sym_SEMI] = ACTIONS(2968),
    [anon_sym_case] = ACTIONS(2966),
    [anon_sym_default] = ACTIONS(2966),
    [anon_sym_yield] = ACTIONS(2966),
    [anon_sym_LBRACK] = ACTIONS(2968),
    [anon_sym_LTtemplate_GT] = ACTIONS(2968),
    [anon_sym_LT] = ACTIONS(2966),
    [anon_sym_SLASH] = ACTIONS(2966),
    [anon_sym_class] = ACTIONS(2966),
    [anon_sym_async] = ACTIONS(2966),
    [anon_sym_function] = ACTIONS(2966),
    [anon_sym_new] = ACTIONS(2966),
    [anon_sym_AMP] = ACTIONS(2968),
    [anon_sym_PLUS] = ACTIONS(2966),
    [anon_sym_DASH] = ACTIONS(2966),
    [anon_sym_TILDE] = ACTIONS(2968),
    [anon_sym_void] = ACTIONS(2966),
    [anon_sym_delete] = ACTIONS(2966),
    [anon_sym_PLUS_PLUS] = ACTIONS(2968),
    [anon_sym_DASH_DASH] = ACTIONS(2968),
    [anon_sym_DQUOTE] = ACTIONS(2968),
    [anon_sym_SQUOTE] = ACTIONS(2968),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2968),
    [sym_number] = ACTIONS(2968),
    [sym_this] = ACTIONS(2966),
    [sym_super] = ACTIONS(2966),
    [sym_true] = ACTIONS(2966),
    [sym_false] = ACTIONS(2966),
    [sym_null] = ACTIONS(2966),
    [sym_undefined] = ACTIONS(2966),
    [anon_sym_AT] = ACTIONS(2968),
    [anon_sym_static] = ACTIONS(2966),
    [anon_sym_readonly] = ACTIONS(2966),
    [anon_sym_get] = ACTIONS(2966),
    [anon_sym_set] = ACTIONS(2966),
    [anon_sym_declare] = ACTIONS(2966),
    [anon_sym_namespace] = ACTIONS(2966),
    [anon_sym_public] = ACTIONS(2966),
    [anon_sym_private] = ACTIONS(2966),
    [anon_sym_protected] = ACTIONS(2966),
    [anon_sym_override] = ACTIONS(2966),
    [anon_sym_module] = ACTIONS(2966),
    [anon_sym_any] = ACTIONS(2966),
    [anon_sym_number] = ACTIONS(2966),
    [anon_sym_boolean] = ACTIONS(2966),
    [anon_sym_string] = ACTIONS(2966),
    [anon_sym_symbol] = ACTIONS(2966),
    [anon_sym_abstract] = ACTIONS(2966),
    [anon_sym_interface] = ACTIONS(2966),
    [anon_sym_enum] = ACTIONS(2966),
    [anon_sym_component] = ACTIONS(2966),
  },
  [840] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2970),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2970),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_QMARK_QMARK] = ACTIONS(2650),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2972),
    [sym_number] = ACTIONS(2972),
    [sym_this] = ACTIONS(2970),
    [sym_true] = ACTIONS(2970),
    [sym_false] = ACTIONS(2970),
    [sym_null] = ACTIONS(2970),
    [sym_undefined] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_readonly] = ACTIONS(2970),
    [anon_sym_get] = ACTIONS(2970),
    [anon_sym_set] = ACTIONS(2970),
    [anon_sym_QMARK] = ACTIONS(2970),
    [anon_sym_any] = ACTIONS(2970),
    [anon_sym_number] = ACTIONS(2970),
    [anon_sym_boolean] = ACTIONS(2970),
    [anon_sym_string] = ACTIONS(2970),
    [anon_sym_symbol] = ACTIONS(2970),
    [anon_sym_abstract] = ACTIONS(2970),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2970),
    [anon_sym_keyof] = ACTIONS(2970),
    [anon_sym_unknown] = ACTIONS(2970),
    [anon_sym_never] = ACTIONS(2970),
    [anon_sym_object] = ACTIONS(2970),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2972),
    [anon_sym_constructor] = ACTIONS(2970),
    [anon_sym_prop] = ACTIONS(2970),
    [anon_sym_id] = ACTIONS(2970),
    [anon_sym_event] = ACTIONS(2970),
    [anon_sym_fn] = ACTIONS(2970),
    [anon_sym_on] = ACTIONS(2970),
    [sym__ternary_qmark] = ACTIONS(2656),
  },
  [841] = {
    [sym_identifier] = ACTIONS(2974),
    [anon_sym_export] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(2976),
    [anon_sym_RBRACE] = ACTIONS(2976),
    [anon_sym_type] = ACTIONS(2974),
    [anon_sym_typeof] = ACTIONS(2974),
    [anon_sym_import] = ACTIONS(2974),
    [anon_sym_var] = ACTIONS(2974),
    [anon_sym_let] = ACTIONS(2974),
    [anon_sym_const] = ACTIONS(2974),
    [anon_sym_BANG] = ACTIONS(2976),
    [anon_sym_else] = ACTIONS(2974),
    [anon_sym_if] = ACTIONS(2974),
    [anon_sym_switch] = ACTIONS(2974),
    [anon_sym_for] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(2976),
    [anon_sym_await] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_do] = ACTIONS(2974),
    [anon_sym_try] = ACTIONS(2974),
    [anon_sym_with] = ACTIONS(2974),
    [anon_sym_break] = ACTIONS(2974),
    [anon_sym_continue] = ACTIONS(2974),
    [anon_sym_debugger] = ACTIONS(2974),
    [anon_sym_return] = ACTIONS(2974),
    [anon_sym_throw] = ACTIONS(2974),
    [anon_sym_SEMI] = ACTIONS(2976),
    [anon_sym_case] = ACTIONS(2974),
    [anon_sym_default] = ACTIONS(2974),
    [anon_sym_yield] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2976),
    [anon_sym_LTtemplate_GT] = ACTIONS(2976),
    [anon_sym_LT] = ACTIONS(2974),
    [anon_sym_SLASH] = ACTIONS(2974),
    [anon_sym_class] = ACTIONS(2974),
    [anon_sym_async] = ACTIONS(2974),
    [anon_sym_function] = ACTIONS(2974),
    [anon_sym_new] = ACTIONS(2974),
    [anon_sym_AMP] = ACTIONS(2976),
    [anon_sym_PLUS] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2976),
    [anon_sym_void] = ACTIONS(2974),
    [anon_sym_delete] = ACTIONS(2974),
    [anon_sym_PLUS_PLUS] = ACTIONS(2976),
    [anon_sym_DASH_DASH] = ACTIONS(2976),
    [anon_sym_DQUOTE] = ACTIONS(2976),
    [anon_sym_SQUOTE] = ACTIONS(2976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2976),
    [sym_number] = ACTIONS(2976),
    [sym_this] = ACTIONS(2974),
    [sym_super] = ACTIONS(2974),
    [sym_true] = ACTIONS(2974),
    [sym_false] = ACTIONS(2974),
    [sym_null] = ACTIONS(2974),
    [sym_undefined] = ACTIONS(2974),
    [anon_sym_AT] = ACTIONS(2976),
    [anon_sym_static] = ACTIONS(2974),
    [anon_sym_readonly] = ACTIONS(2974),
    [anon_sym_get] = ACTIONS(2974),
    [anon_sym_set] = ACTIONS(2974),
    [anon_sym_declare] = ACTIONS(2974),
    [anon_sym_namespace] = ACTIONS(2974),
    [anon_sym_public] = ACTIONS(2974),
    [anon_sym_private] = ACTIONS(2974),
    [anon_sym_protected] = ACTIONS(2974),
    [anon_sym_override] = ACTIONS(2974),
    [anon_sym_module] = ACTIONS(2974),
    [anon_sym_any] = ACTIONS(2974),
    [anon_sym_number] = ACTIONS(2974),
    [anon_sym_boolean] = ACTIONS(2974),
    [anon_sym_string] = ACTIONS(2974),
    [anon_sym_symbol] = ACTIONS(2974),
    [anon_sym_abstract] = ACTIONS(2974),
    [anon_sym_interface] = ACTIONS(2974),
    [anon_sym_enum] = ACTIONS(2974),
    [anon_sym_component] = ACTIONS(2974),
  },
  [842] = {
    [sym_identifier] = ACTIONS(2978),
    [anon_sym_export] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(2980),
    [anon_sym_RBRACE] = ACTIONS(2980),
    [anon_sym_type] = ACTIONS(2978),
    [anon_sym_typeof] = ACTIONS(2978),
    [anon_sym_import] = ACTIONS(2978),
    [anon_sym_var] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2978),
    [anon_sym_const] = ACTIONS(2978),
    [anon_sym_BANG] = ACTIONS(2980),
    [anon_sym_else] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2978),
    [anon_sym_switch] = ACTIONS(2978),
    [anon_sym_for] = ACTIONS(2978),
    [anon_sym_LPAREN] = ACTIONS(2980),
    [anon_sym_await] = ACTIONS(2978),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_do] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2978),
    [anon_sym_with] = ACTIONS(2978),
    [anon_sym_break] = ACTIONS(2978),
    [anon_sym_continue] = ACTIONS(2978),
    [anon_sym_debugger] = ACTIONS(2978),
    [anon_sym_return] = ACTIONS(2978),
    [anon_sym_throw] = ACTIONS(2978),
    [anon_sym_SEMI] = ACTIONS(2980),
    [anon_sym_case] = ACTIONS(2978),
    [anon_sym_default] = ACTIONS(2978),
    [anon_sym_yield] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2980),
    [anon_sym_LTtemplate_GT] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2978),
    [anon_sym_SLASH] = ACTIONS(2978),
    [anon_sym_class] = ACTIONS(2978),
    [anon_sym_async] = ACTIONS(2978),
    [anon_sym_function] = ACTIONS(2978),
    [anon_sym_new] = ACTIONS(2978),
    [anon_sym_AMP] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2980),
    [anon_sym_void] = ACTIONS(2978),
    [anon_sym_delete] = ACTIONS(2978),
    [anon_sym_PLUS_PLUS] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2980),
    [anon_sym_SQUOTE] = ACTIONS(2980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2980),
    [sym_number] = ACTIONS(2980),
    [sym_this] = ACTIONS(2978),
    [sym_super] = ACTIONS(2978),
    [sym_true] = ACTIONS(2978),
    [sym_false] = ACTIONS(2978),
    [sym_null] = ACTIONS(2978),
    [sym_undefined] = ACTIONS(2978),
    [anon_sym_AT] = ACTIONS(2980),
    [anon_sym_static] = ACTIONS(2978),
    [anon_sym_readonly] = ACTIONS(2978),
    [anon_sym_get] = ACTIONS(2978),
    [anon_sym_set] = ACTIONS(2978),
    [anon_sym_declare] = ACTIONS(2978),
    [anon_sym_namespace] = ACTIONS(2978),
    [anon_sym_public] = ACTIONS(2978),
    [anon_sym_private] = ACTIONS(2978),
    [anon_sym_protected] = ACTIONS(2978),
    [anon_sym_override] = ACTIONS(2978),
    [anon_sym_module] = ACTIONS(2978),
    [anon_sym_any] = ACTIONS(2978),
    [anon_sym_number] = ACTIONS(2978),
    [anon_sym_boolean] = ACTIONS(2978),
    [anon_sym_string] = ACTIONS(2978),
    [anon_sym_symbol] = ACTIONS(2978),
    [anon_sym_abstract] = ACTIONS(2978),
    [anon_sym_interface] = ACTIONS(2978),
    [anon_sym_enum] = ACTIONS(2978),
    [anon_sym_component] = ACTIONS(2978),
  },
  [843] = {
    [sym_identifier] = ACTIONS(2982),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_as] = ACTIONS(2982),
    [anon_sym_LBRACE] = ACTIONS(2982),
    [anon_sym_RBRACE] = ACTIONS(2984),
    [anon_sym_typeof] = ACTIONS(2982),
    [anon_sym_BANG] = ACTIONS(2982),
    [anon_sym_LPAREN] = ACTIONS(2984),
    [anon_sym_in] = ACTIONS(2982),
    [anon_sym_SEMI] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2984),
    [anon_sym_LT] = ACTIONS(2982),
    [anon_sym_GT] = ACTIONS(2982),
    [anon_sym_SLASH] = ACTIONS(2982),
    [anon_sym_DOT] = ACTIONS(2982),
    [anon_sym_async] = ACTIONS(2982),
    [anon_sym_QMARK_DOT] = ACTIONS(2984),
    [anon_sym_new] = ACTIONS(2982),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_PIPE_PIPE] = ACTIONS(2984),
    [anon_sym_GT_GT] = ACTIONS(2982),
    [anon_sym_GT_GT_GT] = ACTIONS(2984),
    [anon_sym_LT_LT] = ACTIONS(2984),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_CARET] = ACTIONS(2984),
    [anon_sym_PIPE] = ACTIONS(2982),
    [anon_sym_PLUS] = ACTIONS(2982),
    [anon_sym_DASH] = ACTIONS(2982),
    [anon_sym_PERCENT] = ACTIONS(2984),
    [anon_sym_STAR_STAR] = ACTIONS(2984),
    [anon_sym_LT_EQ] = ACTIONS(2984),
    [anon_sym_EQ_EQ] = ACTIONS(2982),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2984),
    [anon_sym_BANG_EQ] = ACTIONS(2982),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2984),
    [anon_sym_GT_EQ] = ACTIONS(2984),
    [anon_sym_QMARK_QMARK] = ACTIONS(2984),
    [anon_sym_instanceof] = ACTIONS(2982),
    [anon_sym_void] = ACTIONS(2982),
    [anon_sym_PLUS_PLUS] = ACTIONS(2984),
    [anon_sym_DASH_DASH] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [anon_sym_SQUOTE] = ACTIONS(2984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2984),
    [sym_number] = ACTIONS(2984),
    [sym_this] = ACTIONS(2982),
    [sym_true] = ACTIONS(2982),
    [sym_false] = ACTIONS(2982),
    [sym_null] = ACTIONS(2982),
    [sym_undefined] = ACTIONS(2982),
    [anon_sym_static] = ACTIONS(2982),
    [anon_sym_readonly] = ACTIONS(2982),
    [anon_sym_get] = ACTIONS(2982),
    [anon_sym_set] = ACTIONS(2982),
    [anon_sym_QMARK] = ACTIONS(2982),
    [anon_sym_any] = ACTIONS(2982),
    [anon_sym_number] = ACTIONS(2982),
    [anon_sym_boolean] = ACTIONS(2982),
    [anon_sym_string] = ACTIONS(2982),
    [anon_sym_symbol] = ACTIONS(2982),
    [anon_sym_abstract] = ACTIONS(2982),
    [anon_sym_satisfies] = ACTIONS(2982),
    [anon_sym_extends] = ACTIONS(2982),
    [anon_sym_infer] = ACTIONS(2982),
    [anon_sym_is] = ACTIONS(2594),
    [anon_sym_keyof] = ACTIONS(2982),
    [anon_sym_unknown] = ACTIONS(2982),
    [anon_sym_never] = ACTIONS(2982),
    [anon_sym_object] = ACTIONS(2982),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2984),
    [anon_sym_constructor] = ACTIONS(2982),
    [anon_sym_prop] = ACTIONS(2982),
    [anon_sym_id] = ACTIONS(2982),
    [anon_sym_event] = ACTIONS(2982),
    [anon_sym_fn] = ACTIONS(2982),
    [anon_sym_on] = ACTIONS(2982),
    [sym__ternary_qmark] = ACTIONS(2984),
  },
  [844] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LTtemplate_GT] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2610),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_override] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_component] = ACTIONS(2608),
  },
  [845] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LTtemplate_GT] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2610),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_override] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_component] = ACTIONS(2608),
  },
  [846] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [anon_sym_LTtemplate_GT] = ACTIONS(2610),
    [anon_sym_LT] = ACTIONS(2608),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_AMP] = ACTIONS(2610),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2610),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_readonly] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_override] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_component] = ACTIONS(2608),
  },
  [847] = {
    [sym_identifier] = ACTIONS(2986),
    [anon_sym_export] = ACTIONS(2986),
    [anon_sym_LBRACE] = ACTIONS(2988),
    [anon_sym_RBRACE] = ACTIONS(2988),
    [anon_sym_type] = ACTIONS(2986),
    [anon_sym_typeof] = ACTIONS(2986),
    [anon_sym_import] = ACTIONS(2986),
    [anon_sym_var] = ACTIONS(2986),
    [anon_sym_let] = ACTIONS(2986),
    [anon_sym_const] = ACTIONS(2986),
    [anon_sym_BANG] = ACTIONS(2988),
    [anon_sym_else] = ACTIONS(2986),
    [anon_sym_if] = ACTIONS(2986),
    [anon_sym_switch] = ACTIONS(2986),
    [anon_sym_for] = ACTIONS(2986),
    [anon_sym_LPAREN] = ACTIONS(2988),
    [anon_sym_await] = ACTIONS(2986),
    [anon_sym_while] = ACTIONS(2986),
    [anon_sym_do] = ACTIONS(2986),
    [anon_sym_try] = ACTIONS(2986),
    [anon_sym_with] = ACTIONS(2986),
    [anon_sym_break] = ACTIONS(2986),
    [anon_sym_continue] = ACTIONS(2986),
    [anon_sym_debugger] = ACTIONS(2986),
    [anon_sym_return] = ACTIONS(2986),
    [anon_sym_throw] = ACTIONS(2986),
    [anon_sym_SEMI] = ACTIONS(2988),
    [anon_sym_case] = ACTIONS(2986),
    [anon_sym_default] = ACTIONS(2986),
    [anon_sym_yield] = ACTIONS(2986),
    [anon_sym_LBRACK] = ACTIONS(2988),
    [anon_sym_LTtemplate_GT] = ACTIONS(2988),
    [anon_sym_LT] = ACTIONS(2986),
    [anon_sym_SLASH] = ACTIONS(2986),
    [anon_sym_class] = ACTIONS(2986),
    [anon_sym_async] = ACTIONS(2986),
    [anon_sym_function] = ACTIONS(2986),
    [anon_sym_new] = ACTIONS(2986),
    [anon_sym_AMP] = ACTIONS(2988),
    [anon_sym_PLUS] = ACTIONS(2986),
    [anon_sym_DASH] = ACTIONS(2986),
    [anon_sym_TILDE] = ACTIONS(2988),
    [anon_sym_void] = ACTIONS(2986),
    [anon_sym_delete] = ACTIONS(2986),
    [anon_sym_PLUS_PLUS] = ACTIONS(2988),
    [anon_sym_DASH_DASH] = ACTIONS(2988),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [anon_sym_SQUOTE] = ACTIONS(2988),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2988),
    [sym_number] = ACTIONS(2988),
    [sym_this] = ACTIONS(2986),
    [sym_super] = ACTIONS(2986),
    [sym_true] = ACTIONS(2986),
    [sym_false] = ACTIONS(2986),
    [sym_null] = ACTIONS(2986),
    [sym_undefined] = ACTIONS(2986),
    [anon_sym_AT] = ACTIONS(2988),
    [anon_sym_static] = ACTIONS(2986),
    [anon_sym_readonly] = ACTIONS(2986),
    [anon_sym_get] = ACTIONS(2986),
    [anon_sym_set] = ACTIONS(2986),
    [anon_sym_declare] = ACTIONS(2986),
    [anon_sym_namespace] = ACTIONS(2986),
    [anon_sym_public] = ACTIONS(2986),
    [anon_sym_private] = ACTIONS(2986),
    [anon_sym_protected] = ACTIONS(2986),
    [anon_sym_override] = ACTIONS(2986),
    [anon_sym_module] = ACTIONS(2986),
    [anon_sym_any] = ACTIONS(2986),
    [anon_sym_number] = ACTIONS(2986),
    [anon_sym_boolean] = ACTIONS(2986),
    [anon_sym_string] = ACTIONS(2986),
    [anon_sym_symbol] = ACTIONS(2986),
    [anon_sym_abstract] = ACTIONS(2986),
    [anon_sym_interface] = ACTIONS(2986),
    [anon_sym_enum] = ACTIONS(2986),
    [anon_sym_component] = ACTIONS(2986),
  },
  [848] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2990),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2990),
    [anon_sym_RBRACE] = ACTIONS(2992),
    [anon_sym_typeof] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2990),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2990),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_QMARK_QMARK] = ACTIONS(2650),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(2990),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2992),
    [anon_sym_SQUOTE] = ACTIONS(2992),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2992),
    [sym_number] = ACTIONS(2992),
    [sym_this] = ACTIONS(2990),
    [sym_true] = ACTIONS(2990),
    [sym_false] = ACTIONS(2990),
    [sym_null] = ACTIONS(2990),
    [sym_undefined] = ACTIONS(2990),
    [anon_sym_static] = ACTIONS(2990),
    [anon_sym_readonly] = ACTIONS(2990),
    [anon_sym_get] = ACTIONS(2990),
    [anon_sym_set] = ACTIONS(2990),
    [anon_sym_QMARK] = ACTIONS(2990),
    [anon_sym_any] = ACTIONS(2990),
    [anon_sym_number] = ACTIONS(2990),
    [anon_sym_boolean] = ACTIONS(2990),
    [anon_sym_string] = ACTIONS(2990),
    [anon_sym_symbol] = ACTIONS(2990),
    [anon_sym_abstract] = ACTIONS(2990),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2990),
    [anon_sym_keyof] = ACTIONS(2990),
    [anon_sym_unknown] = ACTIONS(2990),
    [anon_sym_never] = ACTIONS(2990),
    [anon_sym_object] = ACTIONS(2990),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2992),
    [anon_sym_constructor] = ACTIONS(2990),
    [anon_sym_prop] = ACTIONS(2990),
    [anon_sym_id] = ACTIONS(2990),
    [anon_sym_event] = ACTIONS(2990),
    [anon_sym_fn] = ACTIONS(2990),
    [anon_sym_on] = ACTIONS(2990),
    [sym__ternary_qmark] = ACTIONS(2656),
  },
  [849] = {
    [sym_identifier] = ACTIONS(2994),
    [anon_sym_export] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [anon_sym_RBRACE] = ACTIONS(2996),
    [anon_sym_type] = ACTIONS(2994),
    [anon_sym_typeof] = ACTIONS(2994),
    [anon_sym_import] = ACTIONS(2994),
    [anon_sym_var] = ACTIONS(2994),
    [anon_sym_let] = ACTIONS(2994),
    [anon_sym_const] = ACTIONS(2994),
    [anon_sym_BANG] = ACTIONS(2996),
    [anon_sym_else] = ACTIONS(2994),
    [anon_sym_if] = ACTIONS(2994),
    [anon_sym_switch] = ACTIONS(2994),
    [anon_sym_for] = ACTIONS(2994),
    [anon_sym_LPAREN] = ACTIONS(2996),
    [anon_sym_await] = ACTIONS(2994),
    [anon_sym_while] = ACTIONS(2994),
    [anon_sym_do] = ACTIONS(2994),
    [anon_sym_try] = ACTIONS(2994),
    [anon_sym_with] = ACTIONS(2994),
    [anon_sym_break] = ACTIONS(2994),
    [anon_sym_continue] = ACTIONS(2994),
    [anon_sym_debugger] = ACTIONS(2994),
    [anon_sym_return] = ACTIONS(2994),
    [anon_sym_throw] = ACTIONS(2994),
    [anon_sym_SEMI] = ACTIONS(2996),
    [anon_sym_case] = ACTIONS(2994),
    [anon_sym_default] = ACTIONS(2994),
    [anon_sym_yield] = ACTIONS(2994),
    [anon_sym_LBRACK] = ACTIONS(2996),
    [anon_sym_LTtemplate_GT] = ACTIONS(2996),
    [anon_sym_LT] = ACTIONS(2994),
    [anon_sym_SLASH] = ACTIONS(2994),
    [anon_sym_class] = ACTIONS(2994),
    [anon_sym_async] = ACTIONS(2994),
    [anon_sym_function] = ACTIONS(2994),
    [anon_sym_new] = ACTIONS(2994),
    [anon_sym_AMP] = ACTIONS(2996),
    [anon_sym_PLUS] = ACTIONS(2994),
    [anon_sym_DASH] = ACTIONS(2994),
    [anon_sym_TILDE] = ACTIONS(2996),
    [anon_sym_void] = ACTIONS(2994),
    [anon_sym_delete] = ACTIONS(2994),
    [anon_sym_PLUS_PLUS] = ACTIONS(2996),
    [anon_sym_DASH_DASH] = ACTIONS(2996),
    [anon_sym_DQUOTE] = ACTIONS(2996),
    [anon_sym_SQUOTE] = ACTIONS(2996),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2996),
    [sym_number] = ACTIONS(2996),
    [sym_this] = ACTIONS(2994),
    [sym_super] = ACTIONS(2994),
    [sym_true] = ACTIONS(2994),
    [sym_false] = ACTIONS(2994),
    [sym_null] = ACTIONS(2994),
    [sym_undefined] = ACTIONS(2994),
    [anon_sym_AT] = ACTIONS(2996),
    [anon_sym_static] = ACTIONS(2994),
    [anon_sym_readonly] = ACTIONS(2994),
    [anon_sym_get] = ACTIONS(2994),
    [anon_sym_set] = ACTIONS(2994),
    [anon_sym_declare] = ACTIONS(2994),
    [anon_sym_namespace] = ACTIONS(2994),
    [anon_sym_public] = ACTIONS(2994),
    [anon_sym_private] = ACTIONS(2994),
    [anon_sym_protected] = ACTIONS(2994),
    [anon_sym_override] = ACTIONS(2994),
    [anon_sym_module] = ACTIONS(2994),
    [anon_sym_any] = ACTIONS(2994),
    [anon_sym_number] = ACTIONS(2994),
    [anon_sym_boolean] = ACTIONS(2994),
    [anon_sym_string] = ACTIONS(2994),
    [anon_sym_symbol] = ACTIONS(2994),
    [anon_sym_abstract] = ACTIONS(2994),
    [anon_sym_interface] = ACTIONS(2994),
    [anon_sym_enum] = ACTIONS(2994),
    [anon_sym_component] = ACTIONS(2994),
  },
  [850] = {
    [sym__call_signature] = STATE(4721),
    [sym_formal_parameters] = STATE(3665),
    [sym_type_parameters] = STATE(4212),
    [sym_identifier] = ACTIONS(2313),
    [anon_sym_export] = ACTIONS(2315),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_type] = ACTIONS(2315),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(2374),
    [anon_sym_of] = ACTIONS(2377),
    [anon_sym_EQ] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1318),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(2315),
    [anon_sym_function] = ACTIONS(2317),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(2315),
    [anon_sym_readonly] = ACTIONS(2315),
    [anon_sym_get] = ACTIONS(2315),
    [anon_sym_set] = ACTIONS(2315),
    [anon_sym_declare] = ACTIONS(2315),
    [anon_sym_namespace] = ACTIONS(2315),
    [anon_sym_public] = ACTIONS(2315),
    [anon_sym_private] = ACTIONS(2315),
    [anon_sym_protected] = ACTIONS(2315),
    [anon_sym_override] = ACTIONS(2315),
    [anon_sym_module] = ACTIONS(2315),
    [anon_sym_any] = ACTIONS(2315),
    [anon_sym_number] = ACTIONS(2315),
    [anon_sym_boolean] = ACTIONS(2315),
    [anon_sym_string] = ACTIONS(2315),
    [anon_sym_symbol] = ACTIONS(2315),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [851] = {
    [sym_identifier] = ACTIONS(2998),
    [anon_sym_export] = ACTIONS(2998),
    [anon_sym_LBRACE] = ACTIONS(3000),
    [anon_sym_RBRACE] = ACTIONS(3000),
    [anon_sym_type] = ACTIONS(2998),
    [anon_sym_typeof] = ACTIONS(2998),
    [anon_sym_import] = ACTIONS(2998),
    [anon_sym_var] = ACTIONS(2998),
    [anon_sym_let] = ACTIONS(2998),
    [anon_sym_const] = ACTIONS(2998),
    [anon_sym_BANG] = ACTIONS(3000),
    [anon_sym_else] = ACTIONS(2998),
    [anon_sym_if] = ACTIONS(2998),
    [anon_sym_switch] = ACTIONS(2998),
    [anon_sym_for] = ACTIONS(2998),
    [anon_sym_LPAREN] = ACTIONS(3000),
    [anon_sym_await] = ACTIONS(2998),
    [anon_sym_while] = ACTIONS(2998),
    [anon_sym_do] = ACTIONS(2998),
    [anon_sym_try] = ACTIONS(2998),
    [anon_sym_with] = ACTIONS(2998),
    [anon_sym_break] = ACTIONS(2998),
    [anon_sym_continue] = ACTIONS(2998),
    [anon_sym_debugger] = ACTIONS(2998),
    [anon_sym_return] = ACTIONS(2998),
    [anon_sym_throw] = ACTIONS(2998),
    [anon_sym_SEMI] = ACTIONS(3000),
    [anon_sym_case] = ACTIONS(2998),
    [anon_sym_default] = ACTIONS(2998),
    [anon_sym_yield] = ACTIONS(2998),
    [anon_sym_LBRACK] = ACTIONS(3000),
    [anon_sym_LTtemplate_GT] = ACTIONS(3000),
    [anon_sym_LT] = ACTIONS(2998),
    [anon_sym_SLASH] = ACTIONS(2998),
    [anon_sym_class] = ACTIONS(2998),
    [anon_sym_async] = ACTIONS(2998),
    [anon_sym_function] = ACTIONS(2998),
    [anon_sym_new] = ACTIONS(2998),
    [anon_sym_AMP] = ACTIONS(3000),
    [anon_sym_PLUS] = ACTIONS(2998),
    [anon_sym_DASH] = ACTIONS(2998),
    [anon_sym_TILDE] = ACTIONS(3000),
    [anon_sym_void] = ACTIONS(2998),
    [anon_sym_delete] = ACTIONS(2998),
    [anon_sym_PLUS_PLUS] = ACTIONS(3000),
    [anon_sym_DASH_DASH] = ACTIONS(3000),
    [anon_sym_DQUOTE] = ACTIONS(3000),
    [anon_sym_SQUOTE] = ACTIONS(3000),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3000),
    [sym_number] = ACTIONS(3000),
    [sym_this] = ACTIONS(2998),
    [sym_super] = ACTIONS(2998),
    [sym_true] = ACTIONS(2998),
    [sym_false] = ACTIONS(2998),
    [sym_null] = ACTIONS(2998),
    [sym_undefined] = ACTIONS(2998),
    [anon_sym_AT] = ACTIONS(3000),
    [anon_sym_static] = ACTIONS(2998),
    [anon_sym_readonly] = ACTIONS(2998),
    [anon_sym_get] = ACTIONS(2998),
    [anon_sym_set] = ACTIONS(2998),
    [anon_sym_declare] = ACTIONS(2998),
    [anon_sym_namespace] = ACTIONS(2998),
    [anon_sym_public] = ACTIONS(2998),
    [anon_sym_private] = ACTIONS(2998),
    [anon_sym_protected] = ACTIONS(2998),
    [anon_sym_override] = ACTIONS(2998),
    [anon_sym_module] = ACTIONS(2998),
    [anon_sym_any] = ACTIONS(2998),
    [anon_sym_number] = ACTIONS(2998),
    [anon_sym_boolean] = ACTIONS(2998),
    [anon_sym_string] = ACTIONS(2998),
    [anon_sym_symbol] = ACTIONS(2998),
    [anon_sym_abstract] = ACTIONS(2998),
    [anon_sym_interface] = ACTIONS(2998),
    [anon_sym_enum] = ACTIONS(2998),
    [anon_sym_component] = ACTIONS(2998),
  },
  [852] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(3002),
    [anon_sym_RBRACE] = ACTIONS(3004),
    [anon_sym_typeof] = ACTIONS(3002),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(3004),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(3002),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(3002),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_QMARK_QMARK] = ACTIONS(2650),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(3002),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(3004),
    [anon_sym_SQUOTE] = ACTIONS(3004),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3004),
    [sym_number] = ACTIONS(3004),
    [sym_this] = ACTIONS(3002),
    [sym_true] = ACTIONS(3002),
    [sym_false] = ACTIONS(3002),
    [sym_null] = ACTIONS(3002),
    [sym_undefined] = ACTIONS(3002),
    [anon_sym_static] = ACTIONS(3002),
    [anon_sym_readonly] = ACTIONS(3002),
    [anon_sym_get] = ACTIONS(3002),
    [anon_sym_set] = ACTIONS(3002),
    [anon_sym_QMARK] = ACTIONS(3002),
    [anon_sym_any] = ACTIONS(3002),
    [anon_sym_number] = ACTIONS(3002),
    [anon_sym_boolean] = ACTIONS(3002),
    [anon_sym_string] = ACTIONS(3002),
    [anon_sym_symbol] = ACTIONS(3002),
    [anon_sym_abstract] = ACTIONS(3002),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(3002),
    [anon_sym_keyof] = ACTIONS(3002),
    [anon_sym_unknown] = ACTIONS(3002),
    [anon_sym_never] = ACTIONS(3002),
    [anon_sym_object] = ACTIONS(3002),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3004),
    [anon_sym_constructor] = ACTIONS(3002),
    [anon_sym_prop] = ACTIONS(3002),
    [anon_sym_id] = ACTIONS(3002),
    [anon_sym_event] = ACTIONS(3002),
    [anon_sym_fn] = ACTIONS(3002),
    [anon_sym_on] = ACTIONS(3002),
    [sym__ternary_qmark] = ACTIONS(2656),
  },
  [853] = {
    [sym_identifier] = ACTIONS(3006),
    [anon_sym_export] = ACTIONS(3006),
    [anon_sym_LBRACE] = ACTIONS(3008),
    [anon_sym_RBRACE] = ACTIONS(3008),
    [anon_sym_type] = ACTIONS(3006),
    [anon_sym_typeof] = ACTIONS(3006),
    [anon_sym_import] = ACTIONS(3006),
    [anon_sym_var] = ACTIONS(3006),
    [anon_sym_let] = ACTIONS(3006),
    [anon_sym_const] = ACTIONS(3006),
    [anon_sym_BANG] = ACTIONS(3008),
    [anon_sym_else] = ACTIONS(3006),
    [anon_sym_if] = ACTIONS(3006),
    [anon_sym_switch] = ACTIONS(3006),
    [anon_sym_for] = ACTIONS(3006),
    [anon_sym_LPAREN] = ACTIONS(3008),
    [anon_sym_await] = ACTIONS(3006),
    [anon_sym_while] = ACTIONS(3006),
    [anon_sym_do] = ACTIONS(3006),
    [anon_sym_try] = ACTIONS(3006),
    [anon_sym_with] = ACTIONS(3006),
    [anon_sym_break] = ACTIONS(3006),
    [anon_sym_continue] = ACTIONS(3006),
    [anon_sym_debugger] = ACTIONS(3006),
    [anon_sym_return] = ACTIONS(3006),
    [anon_sym_throw] = ACTIONS(3006),
    [anon_sym_SEMI] = ACTIONS(3008),
    [anon_sym_case] = ACTIONS(3006),
    [anon_sym_default] = ACTIONS(3006),
    [anon_sym_yield] = ACTIONS(3006),
    [anon_sym_LBRACK] = ACTIONS(3008),
    [anon_sym_LTtemplate_GT] = ACTIONS(3008),
    [anon_sym_LT] = ACTIONS(3006),
    [anon_sym_SLASH] = ACTIONS(3006),
    [anon_sym_class] = ACTIONS(3006),
    [anon_sym_async] = ACTIONS(3006),
    [anon_sym_function] = ACTIONS(3006),
    [anon_sym_new] = ACTIONS(3006),
    [anon_sym_AMP] = ACTIONS(3008),
    [anon_sym_PLUS] = ACTIONS(3006),
    [anon_sym_DASH] = ACTIONS(3006),
    [anon_sym_TILDE] = ACTIONS(3008),
    [anon_sym_void] = ACTIONS(3006),
    [anon_sym_delete] = ACTIONS(3006),
    [anon_sym_PLUS_PLUS] = ACTIONS(3008),
    [anon_sym_DASH_DASH] = ACTIONS(3008),
    [anon_sym_DQUOTE] = ACTIONS(3008),
    [anon_sym_SQUOTE] = ACTIONS(3008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3008),
    [sym_number] = ACTIONS(3008),
    [sym_this] = ACTIONS(3006),
    [sym_super] = ACTIONS(3006),
    [sym_true] = ACTIONS(3006),
    [sym_false] = ACTIONS(3006),
    [sym_null] = ACTIONS(3006),
    [sym_undefined] = ACTIONS(3006),
    [anon_sym_AT] = ACTIONS(3008),
    [anon_sym_static] = ACTIONS(3006),
    [anon_sym_readonly] = ACTIONS(3006),
    [anon_sym_get] = ACTIONS(3006),
    [anon_sym_set] = ACTIONS(3006),
    [anon_sym_declare] = ACTIONS(3006),
    [anon_sym_namespace] = ACTIONS(3006),
    [anon_sym_public] = ACTIONS(3006),
    [anon_sym_private] = ACTIONS(3006),
    [anon_sym_protected] = ACTIONS(3006),
    [anon_sym_override] = ACTIONS(3006),
    [anon_sym_module] = ACTIONS(3006),
    [anon_sym_any] = ACTIONS(3006),
    [anon_sym_number] = ACTIONS(3006),
    [anon_sym_boolean] = ACTIONS(3006),
    [anon_sym_string] = ACTIONS(3006),
    [anon_sym_symbol] = ACTIONS(3006),
    [anon_sym_abstract] = ACTIONS(3006),
    [anon_sym_interface] = ACTIONS(3006),
    [anon_sym_enum] = ACTIONS(3006),
    [anon_sym_component] = ACTIONS(3006),
  },
  [854] = {
    [sym_identifier] = ACTIONS(3010),
    [anon_sym_export] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_RBRACE] = ACTIONS(3012),
    [anon_sym_type] = ACTIONS(3010),
    [anon_sym_typeof] = ACTIONS(3010),
    [anon_sym_import] = ACTIONS(3010),
    [anon_sym_var] = ACTIONS(3010),
    [anon_sym_let] = ACTIONS(3010),
    [anon_sym_const] = ACTIONS(3010),
    [anon_sym_BANG] = ACTIONS(3012),
    [anon_sym_else] = ACTIONS(3010),
    [anon_sym_if] = ACTIONS(3010),
    [anon_sym_switch] = ACTIONS(3010),
    [anon_sym_for] = ACTIONS(3010),
    [anon_sym_LPAREN] = ACTIONS(3012),
    [anon_sym_await] = ACTIONS(3010),
    [anon_sym_while] = ACTIONS(3010),
    [anon_sym_do] = ACTIONS(3010),
    [anon_sym_try] = ACTIONS(3010),
    [anon_sym_with] = ACTIONS(3010),
    [anon_sym_break] = ACTIONS(3010),
    [anon_sym_continue] = ACTIONS(3010),
    [anon_sym_debugger] = ACTIONS(3010),
    [anon_sym_return] = ACTIONS(3010),
    [anon_sym_throw] = ACTIONS(3010),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_case] = ACTIONS(3010),
    [anon_sym_default] = ACTIONS(3010),
    [anon_sym_yield] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_LTtemplate_GT] = ACTIONS(3012),
    [anon_sym_LT] = ACTIONS(3010),
    [anon_sym_SLASH] = ACTIONS(3010),
    [anon_sym_class] = ACTIONS(3010),
    [anon_sym_async] = ACTIONS(3010),
    [anon_sym_function] = ACTIONS(3010),
    [anon_sym_new] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3010),
    [anon_sym_DASH] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3012),
    [anon_sym_void] = ACTIONS(3010),
    [anon_sym_delete] = ACTIONS(3010),
    [anon_sym_PLUS_PLUS] = ACTIONS(3012),
    [anon_sym_DASH_DASH] = ACTIONS(3012),
    [anon_sym_DQUOTE] = ACTIONS(3012),
    [anon_sym_SQUOTE] = ACTIONS(3012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3012),
    [sym_number] = ACTIONS(3012),
    [sym_this] = ACTIONS(3010),
    [sym_super] = ACTIONS(3010),
    [sym_true] = ACTIONS(3010),
    [sym_false] = ACTIONS(3010),
    [sym_null] = ACTIONS(3010),
    [sym_undefined] = ACTIONS(3010),
    [anon_sym_AT] = ACTIONS(3012),
    [anon_sym_static] = ACTIONS(3010),
    [anon_sym_readonly] = ACTIONS(3010),
    [anon_sym_get] = ACTIONS(3010),
    [anon_sym_set] = ACTIONS(3010),
    [anon_sym_declare] = ACTIONS(3010),
    [anon_sym_namespace] = ACTIONS(3010),
    [anon_sym_public] = ACTIONS(3010),
    [anon_sym_private] = ACTIONS(3010),
    [anon_sym_protected] = ACTIONS(3010),
    [anon_sym_override] = ACTIONS(3010),
    [anon_sym_module] = ACTIONS(3010),
    [anon_sym_any] = ACTIONS(3010),
    [anon_sym_number] = ACTIONS(3010),
    [anon_sym_boolean] = ACTIONS(3010),
    [anon_sym_string] = ACTIONS(3010),
    [anon_sym_symbol] = ACTIONS(3010),
    [anon_sym_abstract] = ACTIONS(3010),
    [anon_sym_interface] = ACTIONS(3010),
    [anon_sym_enum] = ACTIONS(3010),
    [anon_sym_component] = ACTIONS(3010),
  },
  [855] = {
    [sym_identifier] = ACTIONS(3014),
    [anon_sym_export] = ACTIONS(3014),
    [anon_sym_LBRACE] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(3016),
    [anon_sym_type] = ACTIONS(3014),
    [anon_sym_typeof] = ACTIONS(3014),
    [anon_sym_import] = ACTIONS(3014),
    [anon_sym_var] = ACTIONS(3014),
    [anon_sym_let] = ACTIONS(3014),
    [anon_sym_const] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_else] = ACTIONS(3014),
    [anon_sym_if] = ACTIONS(3014),
    [anon_sym_switch] = ACTIONS(3014),
    [anon_sym_for] = ACTIONS(3014),
    [anon_sym_LPAREN] = ACTIONS(3016),
    [anon_sym_await] = ACTIONS(3014),
    [anon_sym_while] = ACTIONS(3014),
    [anon_sym_do] = ACTIONS(3014),
    [anon_sym_try] = ACTIONS(3014),
    [anon_sym_with] = ACTIONS(3014),
    [anon_sym_break] = ACTIONS(3014),
    [anon_sym_continue] = ACTIONS(3014),
    [anon_sym_debugger] = ACTIONS(3014),
    [anon_sym_return] = ACTIONS(3014),
    [anon_sym_throw] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3016),
    [anon_sym_case] = ACTIONS(3014),
    [anon_sym_default] = ACTIONS(3014),
    [anon_sym_yield] = ACTIONS(3014),
    [anon_sym_LBRACK] = ACTIONS(3016),
    [anon_sym_LTtemplate_GT] = ACTIONS(3016),
    [anon_sym_LT] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3014),
    [anon_sym_class] = ACTIONS(3014),
    [anon_sym_async] = ACTIONS(3014),
    [anon_sym_function] = ACTIONS(3014),
    [anon_sym_new] = ACTIONS(3014),
    [anon_sym_AMP] = ACTIONS(3016),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_DASH] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3016),
    [anon_sym_void] = ACTIONS(3014),
    [anon_sym_delete] = ACTIONS(3014),
    [anon_sym_PLUS_PLUS] = ACTIONS(3016),
    [anon_sym_DASH_DASH] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3016),
    [anon_sym_SQUOTE] = ACTIONS(3016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3016),
    [sym_number] = ACTIONS(3016),
    [sym_this] = ACTIONS(3014),
    [sym_super] = ACTIONS(3014),
    [sym_true] = ACTIONS(3014),
    [sym_false] = ACTIONS(3014),
    [sym_null] = ACTIONS(3014),
    [sym_undefined] = ACTIONS(3014),
    [anon_sym_AT] = ACTIONS(3016),
    [anon_sym_static] = ACTIONS(3014),
    [anon_sym_readonly] = ACTIONS(3014),
    [anon_sym_get] = ACTIONS(3014),
    [anon_sym_set] = ACTIONS(3014),
    [anon_sym_declare] = ACTIONS(3014),
    [anon_sym_namespace] = ACTIONS(3014),
    [anon_sym_public] = ACTIONS(3014),
    [anon_sym_private] = ACTIONS(3014),
    [anon_sym_protected] = ACTIONS(3014),
    [anon_sym_override] = ACTIONS(3014),
    [anon_sym_module] = ACTIONS(3014),
    [anon_sym_any] = ACTIONS(3014),
    [anon_sym_number] = ACTIONS(3014),
    [anon_sym_boolean] = ACTIONS(3014),
    [anon_sym_string] = ACTIONS(3014),
    [anon_sym_symbol] = ACTIONS(3014),
    [anon_sym_abstract] = ACTIONS(3014),
    [anon_sym_interface] = ACTIONS(3014),
    [anon_sym_enum] = ACTIONS(3014),
    [anon_sym_component] = ACTIONS(3014),
  },
  [856] = {
    [sym_identifier] = ACTIONS(3018),
    [anon_sym_export] = ACTIONS(3018),
    [anon_sym_LBRACE] = ACTIONS(3020),
    [anon_sym_RBRACE] = ACTIONS(3020),
    [anon_sym_type] = ACTIONS(3018),
    [anon_sym_typeof] = ACTIONS(3018),
    [anon_sym_import] = ACTIONS(3018),
    [anon_sym_var] = ACTIONS(3018),
    [anon_sym_let] = ACTIONS(3018),
    [anon_sym_const] = ACTIONS(3018),
    [anon_sym_BANG] = ACTIONS(3020),
    [anon_sym_else] = ACTIONS(3018),
    [anon_sym_if] = ACTIONS(3018),
    [anon_sym_switch] = ACTIONS(3018),
    [anon_sym_for] = ACTIONS(3018),
    [anon_sym_LPAREN] = ACTIONS(3020),
    [anon_sym_await] = ACTIONS(3018),
    [anon_sym_while] = ACTIONS(3018),
    [anon_sym_do] = ACTIONS(3018),
    [anon_sym_try] = ACTIONS(3018),
    [anon_sym_with] = ACTIONS(3018),
    [anon_sym_break] = ACTIONS(3018),
    [anon_sym_continue] = ACTIONS(3018),
    [anon_sym_debugger] = ACTIONS(3018),
    [anon_sym_return] = ACTIONS(3018),
    [anon_sym_throw] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(3020),
    [anon_sym_case] = ACTIONS(3018),
    [anon_sym_default] = ACTIONS(3018),
    [anon_sym_yield] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(3020),
    [anon_sym_LTtemplate_GT] = ACTIONS(3020),
    [anon_sym_LT] = ACTIONS(3018),
    [anon_sym_SLASH] = ACTIONS(3018),
    [anon_sym_class] = ACTIONS(3018),
    [anon_sym_async] = ACTIONS(3018),
    [anon_sym_function] = ACTIONS(3018),
    [anon_sym_new] = ACTIONS(3018),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_PLUS] = ACTIONS(3018),
    [anon_sym_DASH] = ACTIONS(3018),
    [anon_sym_TILDE] = ACTIONS(3020),
    [anon_sym_void] = ACTIONS(3018),
    [anon_sym_delete] = ACTIONS(3018),
    [anon_sym_PLUS_PLUS] = ACTIONS(3020),
    [anon_sym_DASH_DASH] = ACTIONS(3020),
    [anon_sym_DQUOTE] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3020),
    [sym_number] = ACTIONS(3020),
    [sym_this] = ACTIONS(3018),
    [sym_super] = ACTIONS(3018),
    [sym_true] = ACTIONS(3018),
    [sym_false] = ACTIONS(3018),
    [sym_null] = ACTIONS(3018),
    [sym_undefined] = ACTIONS(3018),
    [anon_sym_AT] = ACTIONS(3020),
    [anon_sym_static] = ACTIONS(3018),
    [anon_sym_readonly] = ACTIONS(3018),
    [anon_sym_get] = ACTIONS(3018),
    [anon_sym_set] = ACTIONS(3018),
    [anon_sym_declare] = ACTIONS(3018),
    [anon_sym_namespace] = ACTIONS(3018),
    [anon_sym_public] = ACTIONS(3018),
    [anon_sym_private] = ACTIONS(3018),
    [anon_sym_protected] = ACTIONS(3018),
    [anon_sym_override] = ACTIONS(3018),
    [anon_sym_module] = ACTIONS(3018),
    [anon_sym_any] = ACTIONS(3018),
    [anon_sym_number] = ACTIONS(3018),
    [anon_sym_boolean] = ACTIONS(3018),
    [anon_sym_string] = ACTIONS(3018),
    [anon_sym_symbol] = ACTIONS(3018),
    [anon_sym_abstract] = ACTIONS(3018),
    [anon_sym_interface] = ACTIONS(3018),
    [anon_sym_enum] = ACTIONS(3018),
    [anon_sym_component] = ACTIONS(3018),
  },
  [857] = {
    [sym_identifier] = ACTIONS(3022),
    [anon_sym_export] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3024),
    [anon_sym_RBRACE] = ACTIONS(3024),
    [anon_sym_type] = ACTIONS(3022),
    [anon_sym_typeof] = ACTIONS(3022),
    [anon_sym_import] = ACTIONS(3022),
    [anon_sym_var] = ACTIONS(3022),
    [anon_sym_let] = ACTIONS(3022),
    [anon_sym_const] = ACTIONS(3022),
    [anon_sym_BANG] = ACTIONS(3024),
    [anon_sym_else] = ACTIONS(3022),
    [anon_sym_if] = ACTIONS(3022),
    [anon_sym_switch] = ACTIONS(3022),
    [anon_sym_for] = ACTIONS(3022),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_await] = ACTIONS(3022),
    [anon_sym_while] = ACTIONS(3022),
    [anon_sym_do] = ACTIONS(3022),
    [anon_sym_try] = ACTIONS(3022),
    [anon_sym_with] = ACTIONS(3022),
    [anon_sym_break] = ACTIONS(3022),
    [anon_sym_continue] = ACTIONS(3022),
    [anon_sym_debugger] = ACTIONS(3022),
    [anon_sym_return] = ACTIONS(3022),
    [anon_sym_throw] = ACTIONS(3022),
    [anon_sym_SEMI] = ACTIONS(3024),
    [anon_sym_case] = ACTIONS(3022),
    [anon_sym_default] = ACTIONS(3022),
    [anon_sym_yield] = ACTIONS(3022),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_LTtemplate_GT] = ACTIONS(3024),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_SLASH] = ACTIONS(3022),
    [anon_sym_class] = ACTIONS(3022),
    [anon_sym_async] = ACTIONS(3022),
    [anon_sym_function] = ACTIONS(3022),
    [anon_sym_new] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3022),
    [anon_sym_DASH] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3024),
    [anon_sym_void] = ACTIONS(3022),
    [anon_sym_delete] = ACTIONS(3022),
    [anon_sym_PLUS_PLUS] = ACTIONS(3024),
    [anon_sym_DASH_DASH] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3024),
    [anon_sym_SQUOTE] = ACTIONS(3024),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3024),
    [sym_number] = ACTIONS(3024),
    [sym_this] = ACTIONS(3022),
    [sym_super] = ACTIONS(3022),
    [sym_true] = ACTIONS(3022),
    [sym_false] = ACTIONS(3022),
    [sym_null] = ACTIONS(3022),
    [sym_undefined] = ACTIONS(3022),
    [anon_sym_AT] = ACTIONS(3024),
    [anon_sym_static] = ACTIONS(3022),
    [anon_sym_readonly] = ACTIONS(3022),
    [anon_sym_get] = ACTIONS(3022),
    [anon_sym_set] = ACTIONS(3022),
    [anon_sym_declare] = ACTIONS(3022),
    [anon_sym_namespace] = ACTIONS(3022),
    [anon_sym_public] = ACTIONS(3022),
    [anon_sym_private] = ACTIONS(3022),
    [anon_sym_protected] = ACTIONS(3022),
    [anon_sym_override] = ACTIONS(3022),
    [anon_sym_module] = ACTIONS(3022),
    [anon_sym_any] = ACTIONS(3022),
    [anon_sym_number] = ACTIONS(3022),
    [anon_sym_boolean] = ACTIONS(3022),
    [anon_sym_string] = ACTIONS(3022),
    [anon_sym_symbol] = ACTIONS(3022),
    [anon_sym_abstract] = ACTIONS(3022),
    [anon_sym_interface] = ACTIONS(3022),
    [anon_sym_enum] = ACTIONS(3022),
    [anon_sym_component] = ACTIONS(3022),
  },
  [858] = {
    [sym_identifier] = ACTIONS(3026),
    [anon_sym_export] = ACTIONS(3026),
    [anon_sym_LBRACE] = ACTIONS(3028),
    [anon_sym_RBRACE] = ACTIONS(3028),
    [anon_sym_type] = ACTIONS(3026),
    [anon_sym_typeof] = ACTIONS(3026),
    [anon_sym_import] = ACTIONS(3026),
    [anon_sym_var] = ACTIONS(3026),
    [anon_sym_let] = ACTIONS(3026),
    [anon_sym_const] = ACTIONS(3026),
    [anon_sym_BANG] = ACTIONS(3028),
    [anon_sym_else] = ACTIONS(3026),
    [anon_sym_if] = ACTIONS(3026),
    [anon_sym_switch] = ACTIONS(3026),
    [anon_sym_for] = ACTIONS(3026),
    [anon_sym_LPAREN] = ACTIONS(3028),
    [anon_sym_await] = ACTIONS(3026),
    [anon_sym_while] = ACTIONS(3026),
    [anon_sym_do] = ACTIONS(3026),
    [anon_sym_try] = ACTIONS(3026),
    [anon_sym_with] = ACTIONS(3026),
    [anon_sym_break] = ACTIONS(3026),
    [anon_sym_continue] = ACTIONS(3026),
    [anon_sym_debugger] = ACTIONS(3026),
    [anon_sym_return] = ACTIONS(3026),
    [anon_sym_throw] = ACTIONS(3026),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym_case] = ACTIONS(3026),
    [anon_sym_default] = ACTIONS(3026),
    [anon_sym_yield] = ACTIONS(3026),
    [anon_sym_LBRACK] = ACTIONS(3028),
    [anon_sym_LTtemplate_GT] = ACTIONS(3028),
    [anon_sym_LT] = ACTIONS(3026),
    [anon_sym_SLASH] = ACTIONS(3026),
    [anon_sym_class] = ACTIONS(3026),
    [anon_sym_async] = ACTIONS(3026),
    [anon_sym_function] = ACTIONS(3026),
    [anon_sym_new] = ACTIONS(3026),
    [anon_sym_AMP] = ACTIONS(3028),
    [anon_sym_PLUS] = ACTIONS(3026),
    [anon_sym_DASH] = ACTIONS(3026),
    [anon_sym_TILDE] = ACTIONS(3028),
    [anon_sym_void] = ACTIONS(3026),
    [anon_sym_delete] = ACTIONS(3026),
    [anon_sym_PLUS_PLUS] = ACTIONS(3028),
    [anon_sym_DASH_DASH] = ACTIONS(3028),
    [anon_sym_DQUOTE] = ACTIONS(3028),
    [anon_sym_SQUOTE] = ACTIONS(3028),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3028),
    [sym_number] = ACTIONS(3028),
    [sym_this] = ACTIONS(3026),
    [sym_super] = ACTIONS(3026),
    [sym_true] = ACTIONS(3026),
    [sym_false] = ACTIONS(3026),
    [sym_null] = ACTIONS(3026),
    [sym_undefined] = ACTIONS(3026),
    [anon_sym_AT] = ACTIONS(3028),
    [anon_sym_static] = ACTIONS(3026),
    [anon_sym_readonly] = ACTIONS(3026),
    [anon_sym_get] = ACTIONS(3026),
    [anon_sym_set] = ACTIONS(3026),
    [anon_sym_declare] = ACTIONS(3026),
    [anon_sym_namespace] = ACTIONS(3026),
    [anon_sym_public] = ACTIONS(3026),
    [anon_sym_private] = ACTIONS(3026),
    [anon_sym_protected] = ACTIONS(3026),
    [anon_sym_override] = ACTIONS(3026),
    [anon_sym_module] = ACTIONS(3026),
    [anon_sym_any] = ACTIONS(3026),
    [anon_sym_number] = ACTIONS(3026),
    [anon_sym_boolean] = ACTIONS(3026),
    [anon_sym_string] = ACTIONS(3026),
    [anon_sym_symbol] = ACTIONS(3026),
    [anon_sym_abstract] = ACTIONS(3026),
    [anon_sym_interface] = ACTIONS(3026),
    [anon_sym_enum] = ACTIONS(3026),
    [anon_sym_component] = ACTIONS(3026),
  },
  [859] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(3030),
    [anon_sym_RBRACE] = ACTIONS(3032),
    [anon_sym_typeof] = ACTIONS(3030),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(3030),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_QMARK_QMARK] = ACTIONS(2650),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(3030),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3032),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3032),
    [sym_number] = ACTIONS(3032),
    [sym_this] = ACTIONS(3030),
    [sym_true] = ACTIONS(3030),
    [sym_false] = ACTIONS(3030),
    [sym_null] = ACTIONS(3030),
    [sym_undefined] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_readonly] = ACTIONS(3030),
    [anon_sym_get] = ACTIONS(3030),
    [anon_sym_set] = ACTIONS(3030),
    [anon_sym_QMARK] = ACTIONS(3030),
    [anon_sym_any] = ACTIONS(3030),
    [anon_sym_number] = ACTIONS(3030),
    [anon_sym_boolean] = ACTIONS(3030),
    [anon_sym_string] = ACTIONS(3030),
    [anon_sym_symbol] = ACTIONS(3030),
    [anon_sym_abstract] = ACTIONS(3030),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(3030),
    [anon_sym_keyof] = ACTIONS(3030),
    [anon_sym_unknown] = ACTIONS(3030),
    [anon_sym_never] = ACTIONS(3030),
    [anon_sym_object] = ACTIONS(3030),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3032),
    [anon_sym_constructor] = ACTIONS(3030),
    [anon_sym_prop] = ACTIONS(3030),
    [anon_sym_id] = ACTIONS(3030),
    [anon_sym_event] = ACTIONS(3030),
    [anon_sym_fn] = ACTIONS(3030),
    [anon_sym_on] = ACTIONS(3030),
    [sym__ternary_qmark] = ACTIONS(2656),
  },
  [860] = {
    [sym_identifier] = ACTIONS(3034),
    [anon_sym_export] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_RBRACE] = ACTIONS(3036),
    [anon_sym_type] = ACTIONS(3034),
    [anon_sym_typeof] = ACTIONS(3034),
    [anon_sym_import] = ACTIONS(3034),
    [anon_sym_var] = ACTIONS(3034),
    [anon_sym_let] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_else] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_LPAREN] = ACTIONS(3036),
    [anon_sym_await] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_with] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_debugger] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3036),
    [anon_sym_LTtemplate_GT] = ACTIONS(3036),
    [anon_sym_LT] = ACTIONS(3034),
    [anon_sym_SLASH] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_async] = ACTIONS(3034),
    [anon_sym_function] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_AMP] = ACTIONS(3036),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_void] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3036),
    [sym_number] = ACTIONS(3036),
    [sym_this] = ACTIONS(3034),
    [sym_super] = ACTIONS(3034),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [sym_null] = ACTIONS(3034),
    [sym_undefined] = ACTIONS(3034),
    [anon_sym_AT] = ACTIONS(3036),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_readonly] = ACTIONS(3034),
    [anon_sym_get] = ACTIONS(3034),
    [anon_sym_set] = ACTIONS(3034),
    [anon_sym_declare] = ACTIONS(3034),
    [anon_sym_namespace] = ACTIONS(3034),
    [anon_sym_public] = ACTIONS(3034),
    [anon_sym_private] = ACTIONS(3034),
    [anon_sym_protected] = ACTIONS(3034),
    [anon_sym_override] = ACTIONS(3034),
    [anon_sym_module] = ACTIONS(3034),
    [anon_sym_any] = ACTIONS(3034),
    [anon_sym_number] = ACTIONS(3034),
    [anon_sym_boolean] = ACTIONS(3034),
    [anon_sym_string] = ACTIONS(3034),
    [anon_sym_symbol] = ACTIONS(3034),
    [anon_sym_abstract] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_component] = ACTIONS(3034),
  },
  [861] = {
    [sym_identifier] = ACTIONS(3038),
    [anon_sym_export] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_RBRACE] = ACTIONS(3040),
    [anon_sym_type] = ACTIONS(3038),
    [anon_sym_typeof] = ACTIONS(3038),
    [anon_sym_import] = ACTIONS(3038),
    [anon_sym_var] = ACTIONS(3038),
    [anon_sym_let] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_else] = ACTIONS(3038),
    [anon_sym_if] = ACTIONS(3038),
    [anon_sym_switch] = ACTIONS(3038),
    [anon_sym_for] = ACTIONS(3038),
    [anon_sym_LPAREN] = ACTIONS(3040),
    [anon_sym_await] = ACTIONS(3038),
    [anon_sym_while] = ACTIONS(3038),
    [anon_sym_do] = ACTIONS(3038),
    [anon_sym_try] = ACTIONS(3038),
    [anon_sym_with] = ACTIONS(3038),
    [anon_sym_break] = ACTIONS(3038),
    [anon_sym_continue] = ACTIONS(3038),
    [anon_sym_debugger] = ACTIONS(3038),
    [anon_sym_return] = ACTIONS(3038),
    [anon_sym_throw] = ACTIONS(3038),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym_case] = ACTIONS(3038),
    [anon_sym_default] = ACTIONS(3038),
    [anon_sym_yield] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3040),
    [anon_sym_LTtemplate_GT] = ACTIONS(3040),
    [anon_sym_LT] = ACTIONS(3038),
    [anon_sym_SLASH] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_async] = ACTIONS(3038),
    [anon_sym_function] = ACTIONS(3038),
    [anon_sym_new] = ACTIONS(3038),
    [anon_sym_AMP] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_void] = ACTIONS(3038),
    [anon_sym_delete] = ACTIONS(3038),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3040),
    [sym_number] = ACTIONS(3040),
    [sym_this] = ACTIONS(3038),
    [sym_super] = ACTIONS(3038),
    [sym_true] = ACTIONS(3038),
    [sym_false] = ACTIONS(3038),
    [sym_null] = ACTIONS(3038),
    [sym_undefined] = ACTIONS(3038),
    [anon_sym_AT] = ACTIONS(3040),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_readonly] = ACTIONS(3038),
    [anon_sym_get] = ACTIONS(3038),
    [anon_sym_set] = ACTIONS(3038),
    [anon_sym_declare] = ACTIONS(3038),
    [anon_sym_namespace] = ACTIONS(3038),
    [anon_sym_public] = ACTIONS(3038),
    [anon_sym_private] = ACTIONS(3038),
    [anon_sym_protected] = ACTIONS(3038),
    [anon_sym_override] = ACTIONS(3038),
    [anon_sym_module] = ACTIONS(3038),
    [anon_sym_any] = ACTIONS(3038),
    [anon_sym_number] = ACTIONS(3038),
    [anon_sym_boolean] = ACTIONS(3038),
    [anon_sym_string] = ACTIONS(3038),
    [anon_sym_symbol] = ACTIONS(3038),
    [anon_sym_abstract] = ACTIONS(3038),
    [anon_sym_interface] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_component] = ACTIONS(3038),
  },
  [862] = {
    [sym_identifier] = ACTIONS(3042),
    [anon_sym_export] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3044),
    [anon_sym_RBRACE] = ACTIONS(3044),
    [anon_sym_type] = ACTIONS(3042),
    [anon_sym_typeof] = ACTIONS(3042),
    [anon_sym_import] = ACTIONS(3042),
    [anon_sym_var] = ACTIONS(3042),
    [anon_sym_let] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_else] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_switch] = ACTIONS(3042),
    [anon_sym_for] = ACTIONS(3042),
    [anon_sym_LPAREN] = ACTIONS(3044),
    [anon_sym_await] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_try] = ACTIONS(3042),
    [anon_sym_with] = ACTIONS(3042),
    [anon_sym_break] = ACTIONS(3042),
    [anon_sym_continue] = ACTIONS(3042),
    [anon_sym_debugger] = ACTIONS(3042),
    [anon_sym_return] = ACTIONS(3042),
    [anon_sym_throw] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym_case] = ACTIONS(3042),
    [anon_sym_default] = ACTIONS(3042),
    [anon_sym_yield] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3044),
    [anon_sym_LTtemplate_GT] = ACTIONS(3044),
    [anon_sym_LT] = ACTIONS(3042),
    [anon_sym_SLASH] = ACTIONS(3042),
    [anon_sym_class] = ACTIONS(3042),
    [anon_sym_async] = ACTIONS(3042),
    [anon_sym_function] = ACTIONS(3042),
    [anon_sym_new] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3044),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_void] = ACTIONS(3042),
    [anon_sym_delete] = ACTIONS(3042),
    [anon_sym_PLUS_PLUS] = ACTIONS(3044),
    [anon_sym_DASH_DASH] = ACTIONS(3044),
    [anon_sym_DQUOTE] = ACTIONS(3044),
    [anon_sym_SQUOTE] = ACTIONS(3044),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3044),
    [sym_number] = ACTIONS(3044),
    [sym_this] = ACTIONS(3042),
    [sym_super] = ACTIONS(3042),
    [sym_true] = ACTIONS(3042),
    [sym_false] = ACTIONS(3042),
    [sym_null] = ACTIONS(3042),
    [sym_undefined] = ACTIONS(3042),
    [anon_sym_AT] = ACTIONS(3044),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_readonly] = ACTIONS(3042),
    [anon_sym_get] = ACTIONS(3042),
    [anon_sym_set] = ACTIONS(3042),
    [anon_sym_declare] = ACTIONS(3042),
    [anon_sym_namespace] = ACTIONS(3042),
    [anon_sym_public] = ACTIONS(3042),
    [anon_sym_private] = ACTIONS(3042),
    [anon_sym_protected] = ACTIONS(3042),
    [anon_sym_override] = ACTIONS(3042),
    [anon_sym_module] = ACTIONS(3042),
    [anon_sym_any] = ACTIONS(3042),
    [anon_sym_number] = ACTIONS(3042),
    [anon_sym_boolean] = ACTIONS(3042),
    [anon_sym_string] = ACTIONS(3042),
    [anon_sym_symbol] = ACTIONS(3042),
    [anon_sym_abstract] = ACTIONS(3042),
    [anon_sym_interface] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_component] = ACTIONS(3042),
  },
  [863] = {
    [sym_identifier] = ACTIONS(2774),
    [anon_sym_export] = ACTIONS(2774),
    [anon_sym_LBRACE] = ACTIONS(2776),
    [anon_sym_RBRACE] = ACTIONS(2776),
    [anon_sym_type] = ACTIONS(2774),
    [anon_sym_typeof] = ACTIONS(2774),
    [anon_sym_import] = ACTIONS(2774),
    [anon_sym_var] = ACTIONS(2774),
    [anon_sym_let] = ACTIONS(2774),
    [anon_sym_const] = ACTIONS(2774),
    [anon_sym_BANG] = ACTIONS(2776),
    [anon_sym_else] = ACTIONS(2774),
    [anon_sym_if] = ACTIONS(2774),
    [anon_sym_switch] = ACTIONS(2774),
    [anon_sym_for] = ACTIONS(2774),
    [anon_sym_LPAREN] = ACTIONS(2776),
    [anon_sym_await] = ACTIONS(2774),
    [anon_sym_while] = ACTIONS(2774),
    [anon_sym_do] = ACTIONS(2774),
    [anon_sym_try] = ACTIONS(2774),
    [anon_sym_with] = ACTIONS(2774),
    [anon_sym_break] = ACTIONS(2774),
    [anon_sym_continue] = ACTIONS(2774),
    [anon_sym_debugger] = ACTIONS(2774),
    [anon_sym_return] = ACTIONS(2774),
    [anon_sym_throw] = ACTIONS(2774),
    [anon_sym_SEMI] = ACTIONS(2776),
    [anon_sym_case] = ACTIONS(2774),
    [anon_sym_default] = ACTIONS(2774),
    [anon_sym_yield] = ACTIONS(2774),
    [anon_sym_LBRACK] = ACTIONS(2776),
    [anon_sym_LTtemplate_GT] = ACTIONS(2776),
    [anon_sym_LT] = ACTIONS(2774),
    [anon_sym_SLASH] = ACTIONS(2774),
    [anon_sym_class] = ACTIONS(2774),
    [anon_sym_async] = ACTIONS(2774),
    [anon_sym_function] = ACTIONS(2774),
    [anon_sym_new] = ACTIONS(2774),
    [anon_sym_AMP] = ACTIONS(2776),
    [anon_sym_PLUS] = ACTIONS(2774),
    [anon_sym_DASH] = ACTIONS(2774),
    [anon_sym_TILDE] = ACTIONS(2776),
    [anon_sym_void] = ACTIONS(2774),
    [anon_sym_delete] = ACTIONS(2774),
    [anon_sym_PLUS_PLUS] = ACTIONS(2776),
    [anon_sym_DASH_DASH] = ACTIONS(2776),
    [anon_sym_DQUOTE] = ACTIONS(2776),
    [anon_sym_SQUOTE] = ACTIONS(2776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2776),
    [sym_number] = ACTIONS(2776),
    [sym_this] = ACTIONS(2774),
    [sym_super] = ACTIONS(2774),
    [sym_true] = ACTIONS(2774),
    [sym_false] = ACTIONS(2774),
    [sym_null] = ACTIONS(2774),
    [sym_undefined] = ACTIONS(2774),
    [anon_sym_AT] = ACTIONS(2776),
    [anon_sym_static] = ACTIONS(2774),
    [anon_sym_readonly] = ACTIONS(2774),
    [anon_sym_get] = ACTIONS(2774),
    [anon_sym_set] = ACTIONS(2774),
    [anon_sym_declare] = ACTIONS(2774),
    [anon_sym_namespace] = ACTIONS(2774),
    [anon_sym_public] = ACTIONS(2774),
    [anon_sym_private] = ACTIONS(2774),
    [anon_sym_protected] = ACTIONS(2774),
    [anon_sym_override] = ACTIONS(2774),
    [anon_sym_module] = ACTIONS(2774),
    [anon_sym_any] = ACTIONS(2774),
    [anon_sym_number] = ACTIONS(2774),
    [anon_sym_boolean] = ACTIONS(2774),
    [anon_sym_string] = ACTIONS(2774),
    [anon_sym_symbol] = ACTIONS(2774),
    [anon_sym_abstract] = ACTIONS(2774),
    [anon_sym_interface] = ACTIONS(2774),
    [anon_sym_enum] = ACTIONS(2774),
    [anon_sym_component] = ACTIONS(2774),
  },
  [864] = {
    [sym_identifier] = ACTIONS(3046),
    [anon_sym_export] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3048),
    [anon_sym_RBRACE] = ACTIONS(3048),
    [anon_sym_type] = ACTIONS(3046),
    [anon_sym_typeof] = ACTIONS(3046),
    [anon_sym_import] = ACTIONS(3046),
    [anon_sym_var] = ACTIONS(3046),
    [anon_sym_let] = ACTIONS(3046),
    [anon_sym_const] = ACTIONS(3046),
    [anon_sym_BANG] = ACTIONS(3048),
    [anon_sym_else] = ACTIONS(3046),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_switch] = ACTIONS(3046),
    [anon_sym_for] = ACTIONS(3046),
    [anon_sym_LPAREN] = ACTIONS(3048),
    [anon_sym_await] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_try] = ACTIONS(3046),
    [anon_sym_with] = ACTIONS(3046),
    [anon_sym_break] = ACTIONS(3046),
    [anon_sym_continue] = ACTIONS(3046),
    [anon_sym_debugger] = ACTIONS(3046),
    [anon_sym_return] = ACTIONS(3046),
    [anon_sym_throw] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym_case] = ACTIONS(3046),
    [anon_sym_default] = ACTIONS(3046),
    [anon_sym_yield] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3048),
    [anon_sym_LTtemplate_GT] = ACTIONS(3048),
    [anon_sym_LT] = ACTIONS(3046),
    [anon_sym_SLASH] = ACTIONS(3046),
    [anon_sym_class] = ACTIONS(3046),
    [anon_sym_async] = ACTIONS(3046),
    [anon_sym_function] = ACTIONS(3046),
    [anon_sym_new] = ACTIONS(3046),
    [anon_sym_AMP] = ACTIONS(3048),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_DASH] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3048),
    [anon_sym_void] = ACTIONS(3046),
    [anon_sym_delete] = ACTIONS(3046),
    [anon_sym_PLUS_PLUS] = ACTIONS(3048),
    [anon_sym_DASH_DASH] = ACTIONS(3048),
    [anon_sym_DQUOTE] = ACTIONS(3048),
    [anon_sym_SQUOTE] = ACTIONS(3048),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3048),
    [sym_number] = ACTIONS(3048),
    [sym_this] = ACTIONS(3046),
    [sym_super] = ACTIONS(3046),
    [sym_true] = ACTIONS(3046),
    [sym_false] = ACTIONS(3046),
    [sym_null] = ACTIONS(3046),
    [sym_undefined] = ACTIONS(3046),
    [anon_sym_AT] = ACTIONS(3048),
    [anon_sym_static] = ACTIONS(3046),
    [anon_sym_readonly] = ACTIONS(3046),
    [anon_sym_get] = ACTIONS(3046),
    [anon_sym_set] = ACTIONS(3046),
    [anon_sym_declare] = ACTIONS(3046),
    [anon_sym_namespace] = ACTIONS(3046),
    [anon_sym_public] = ACTIONS(3046),
    [anon_sym_private] = ACTIONS(3046),
    [anon_sym_protected] = ACTIONS(3046),
    [anon_sym_override] = ACTIONS(3046),
    [anon_sym_module] = ACTIONS(3046),
    [anon_sym_any] = ACTIONS(3046),
    [anon_sym_number] = ACTIONS(3046),
    [anon_sym_boolean] = ACTIONS(3046),
    [anon_sym_string] = ACTIONS(3046),
    [anon_sym_symbol] = ACTIONS(3046),
    [anon_sym_abstract] = ACTIONS(3046),
    [anon_sym_interface] = ACTIONS(3046),
    [anon_sym_enum] = ACTIONS(3046),
    [anon_sym_component] = ACTIONS(3046),
  },
  [865] = {
    [sym_identifier] = ACTIONS(3050),
    [anon_sym_export] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_type] = ACTIONS(3050),
    [anon_sym_typeof] = ACTIONS(3050),
    [anon_sym_import] = ACTIONS(3050),
    [anon_sym_var] = ACTIONS(3050),
    [anon_sym_let] = ACTIONS(3050),
    [anon_sym_const] = ACTIONS(3050),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_else] = ACTIONS(3050),
    [anon_sym_if] = ACTIONS(3050),
    [anon_sym_switch] = ACTIONS(3050),
    [anon_sym_for] = ACTIONS(3050),
    [anon_sym_LPAREN] = ACTIONS(3052),
    [anon_sym_await] = ACTIONS(3050),
    [anon_sym_while] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3050),
    [anon_sym_try] = ACTIONS(3050),
    [anon_sym_with] = ACTIONS(3050),
    [anon_sym_break] = ACTIONS(3050),
    [anon_sym_continue] = ACTIONS(3050),
    [anon_sym_debugger] = ACTIONS(3050),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_throw] = ACTIONS(3050),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym_case] = ACTIONS(3050),
    [anon_sym_default] = ACTIONS(3050),
    [anon_sym_yield] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3052),
    [anon_sym_LTtemplate_GT] = ACTIONS(3052),
    [anon_sym_LT] = ACTIONS(3050),
    [anon_sym_SLASH] = ACTIONS(3050),
    [anon_sym_class] = ACTIONS(3050),
    [anon_sym_async] = ACTIONS(3050),
    [anon_sym_function] = ACTIONS(3050),
    [anon_sym_new] = ACTIONS(3050),
    [anon_sym_AMP] = ACTIONS(3052),
    [anon_sym_PLUS] = ACTIONS(3050),
    [anon_sym_DASH] = ACTIONS(3050),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_void] = ACTIONS(3050),
    [anon_sym_delete] = ACTIONS(3050),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3052),
    [sym_number] = ACTIONS(3052),
    [sym_this] = ACTIONS(3050),
    [sym_super] = ACTIONS(3050),
    [sym_true] = ACTIONS(3050),
    [sym_false] = ACTIONS(3050),
    [sym_null] = ACTIONS(3050),
    [sym_undefined] = ACTIONS(3050),
    [anon_sym_AT] = ACTIONS(3052),
    [anon_sym_static] = ACTIONS(3050),
    [anon_sym_readonly] = ACTIONS(3050),
    [anon_sym_get] = ACTIONS(3050),
    [anon_sym_set] = ACTIONS(3050),
    [anon_sym_declare] = ACTIONS(3050),
    [anon_sym_namespace] = ACTIONS(3050),
    [anon_sym_public] = ACTIONS(3050),
    [anon_sym_private] = ACTIONS(3050),
    [anon_sym_protected] = ACTIONS(3050),
    [anon_sym_override] = ACTIONS(3050),
    [anon_sym_module] = ACTIONS(3050),
    [anon_sym_any] = ACTIONS(3050),
    [anon_sym_number] = ACTIONS(3050),
    [anon_sym_boolean] = ACTIONS(3050),
    [anon_sym_string] = ACTIONS(3050),
    [anon_sym_symbol] = ACTIONS(3050),
    [anon_sym_abstract] = ACTIONS(3050),
    [anon_sym_interface] = ACTIONS(3050),
    [anon_sym_enum] = ACTIONS(3050),
    [anon_sym_component] = ACTIONS(3050),
  },
  [866] = {
    [sym_identifier] = ACTIONS(3054),
    [anon_sym_export] = ACTIONS(3054),
    [anon_sym_LBRACE] = ACTIONS(3056),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_type] = ACTIONS(3054),
    [anon_sym_typeof] = ACTIONS(3054),
    [anon_sym_import] = ACTIONS(3054),
    [anon_sym_var] = ACTIONS(3054),
    [anon_sym_let] = ACTIONS(3054),
    [anon_sym_const] = ACTIONS(3054),
    [anon_sym_BANG] = ACTIONS(3056),
    [anon_sym_else] = ACTIONS(3054),
    [anon_sym_if] = ACTIONS(3054),
    [anon_sym_switch] = ACTIONS(3054),
    [anon_sym_for] = ACTIONS(3054),
    [anon_sym_LPAREN] = ACTIONS(3056),
    [anon_sym_await] = ACTIONS(3054),
    [anon_sym_while] = ACTIONS(3054),
    [anon_sym_do] = ACTIONS(3054),
    [anon_sym_try] = ACTIONS(3054),
    [anon_sym_with] = ACTIONS(3054),
    [anon_sym_break] = ACTIONS(3054),
    [anon_sym_continue] = ACTIONS(3054),
    [anon_sym_debugger] = ACTIONS(3054),
    [anon_sym_return] = ACTIONS(3054),
    [anon_sym_throw] = ACTIONS(3054),
    [anon_sym_SEMI] = ACTIONS(3056),
    [anon_sym_case] = ACTIONS(3054),
    [anon_sym_default] = ACTIONS(3054),
    [anon_sym_yield] = ACTIONS(3054),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_LTtemplate_GT] = ACTIONS(3056),
    [anon_sym_LT] = ACTIONS(3054),
    [anon_sym_SLASH] = ACTIONS(3054),
    [anon_sym_class] = ACTIONS(3054),
    [anon_sym_async] = ACTIONS(3054),
    [anon_sym_function] = ACTIONS(3054),
    [anon_sym_new] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_PLUS] = ACTIONS(3054),
    [anon_sym_DASH] = ACTIONS(3054),
    [anon_sym_TILDE] = ACTIONS(3056),
    [anon_sym_void] = ACTIONS(3054),
    [anon_sym_delete] = ACTIONS(3054),
    [anon_sym_PLUS_PLUS] = ACTIONS(3056),
    [anon_sym_DASH_DASH] = ACTIONS(3056),
    [anon_sym_DQUOTE] = ACTIONS(3056),
    [anon_sym_SQUOTE] = ACTIONS(3056),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3056),
    [sym_number] = ACTIONS(3056),
    [sym_this] = ACTIONS(3054),
    [sym_super] = ACTIONS(3054),
    [sym_true] = ACTIONS(3054),
    [sym_false] = ACTIONS(3054),
    [sym_null] = ACTIONS(3054),
    [sym_undefined] = ACTIONS(3054),
    [anon_sym_AT] = ACTIONS(3056),
    [anon_sym_static] = ACTIONS(3054),
    [anon_sym_readonly] = ACTIONS(3054),
    [anon_sym_get] = ACTIONS(3054),
    [anon_sym_set] = ACTIONS(3054),
    [anon_sym_declare] = ACTIONS(3054),
    [anon_sym_namespace] = ACTIONS(3054),
    [anon_sym_public] = ACTIONS(3054),
    [anon_sym_private] = ACTIONS(3054),
    [anon_sym_protected] = ACTIONS(3054),
    [anon_sym_override] = ACTIONS(3054),
    [anon_sym_module] = ACTIONS(3054),
    [anon_sym_any] = ACTIONS(3054),
    [anon_sym_number] = ACTIONS(3054),
    [anon_sym_boolean] = ACTIONS(3054),
    [anon_sym_string] = ACTIONS(3054),
    [anon_sym_symbol] = ACTIONS(3054),
    [anon_sym_abstract] = ACTIONS(3054),
    [anon_sym_interface] = ACTIONS(3054),
    [anon_sym_enum] = ACTIONS(3054),
    [anon_sym_component] = ACTIONS(3054),
  },
  [867] = {
    [sym_identifier] = ACTIONS(3058),
    [anon_sym_export] = ACTIONS(3058),
    [anon_sym_LBRACE] = ACTIONS(3060),
    [anon_sym_RBRACE] = ACTIONS(3060),
    [anon_sym_type] = ACTIONS(3058),
    [anon_sym_typeof] = ACTIONS(3058),
    [anon_sym_import] = ACTIONS(3058),
    [anon_sym_var] = ACTIONS(3058),
    [anon_sym_let] = ACTIONS(3058),
    [anon_sym_const] = ACTIONS(3058),
    [anon_sym_BANG] = ACTIONS(3060),
    [anon_sym_else] = ACTIONS(3058),
    [anon_sym_if] = ACTIONS(3058),
    [anon_sym_switch] = ACTIONS(3058),
    [anon_sym_for] = ACTIONS(3058),
    [anon_sym_LPAREN] = ACTIONS(3060),
    [anon_sym_await] = ACTIONS(3058),
    [anon_sym_while] = ACTIONS(3058),
    [anon_sym_do] = ACTIONS(3058),
    [anon_sym_try] = ACTIONS(3058),
    [anon_sym_with] = ACTIONS(3058),
    [anon_sym_break] = ACTIONS(3058),
    [anon_sym_continue] = ACTIONS(3058),
    [anon_sym_debugger] = ACTIONS(3058),
    [anon_sym_return] = ACTIONS(3058),
    [anon_sym_throw] = ACTIONS(3058),
    [anon_sym_SEMI] = ACTIONS(3060),
    [anon_sym_case] = ACTIONS(3058),
    [anon_sym_default] = ACTIONS(3058),
    [anon_sym_yield] = ACTIONS(3058),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [anon_sym_LTtemplate_GT] = ACTIONS(3060),
    [anon_sym_LT] = ACTIONS(3058),
    [anon_sym_SLASH] = ACTIONS(3058),
    [anon_sym_class] = ACTIONS(3058),
    [anon_sym_async] = ACTIONS(3058),
    [anon_sym_function] = ACTIONS(3058),
    [anon_sym_new] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym_PLUS] = ACTIONS(3058),
    [anon_sym_DASH] = ACTIONS(3058),
    [anon_sym_TILDE] = ACTIONS(3060),
    [anon_sym_void] = ACTIONS(3058),
    [anon_sym_delete] = ACTIONS(3058),
    [anon_sym_PLUS_PLUS] = ACTIONS(3060),
    [anon_sym_DASH_DASH] = ACTIONS(3060),
    [anon_sym_DQUOTE] = ACTIONS(3060),
    [anon_sym_SQUOTE] = ACTIONS(3060),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3060),
    [sym_number] = ACTIONS(3060),
    [sym_this] = ACTIONS(3058),
    [sym_super] = ACTIONS(3058),
    [sym_true] = ACTIONS(3058),
    [sym_false] = ACTIONS(3058),
    [sym_null] = ACTIONS(3058),
    [sym_undefined] = ACTIONS(3058),
    [anon_sym_AT] = ACTIONS(3060),
    [anon_sym_static] = ACTIONS(3058),
    [anon_sym_readonly] = ACTIONS(3058),
    [anon_sym_get] = ACTIONS(3058),
    [anon_sym_set] = ACTIONS(3058),
    [anon_sym_declare] = ACTIONS(3058),
    [anon_sym_namespace] = ACTIONS(3058),
    [anon_sym_public] = ACTIONS(3058),
    [anon_sym_private] = ACTIONS(3058),
    [anon_sym_protected] = ACTIONS(3058),
    [anon_sym_override] = ACTIONS(3058),
    [anon_sym_module] = ACTIONS(3058),
    [anon_sym_any] = ACTIONS(3058),
    [anon_sym_number] = ACTIONS(3058),
    [anon_sym_boolean] = ACTIONS(3058),
    [anon_sym_string] = ACTIONS(3058),
    [anon_sym_symbol] = ACTIONS(3058),
    [anon_sym_abstract] = ACTIONS(3058),
    [anon_sym_interface] = ACTIONS(3058),
    [anon_sym_enum] = ACTIONS(3058),
    [anon_sym_component] = ACTIONS(3058),
  },
  [868] = {
    [sym_identifier] = ACTIONS(3062),
    [anon_sym_export] = ACTIONS(3062),
    [anon_sym_LBRACE] = ACTIONS(3064),
    [anon_sym_RBRACE] = ACTIONS(3064),
    [anon_sym_type] = ACTIONS(3062),
    [anon_sym_typeof] = ACTIONS(3062),
    [anon_sym_import] = ACTIONS(3062),
    [anon_sym_var] = ACTIONS(3062),
    [anon_sym_let] = ACTIONS(3062),
    [anon_sym_const] = ACTIONS(3062),
    [anon_sym_BANG] = ACTIONS(3064),
    [anon_sym_else] = ACTIONS(3062),
    [anon_sym_if] = ACTIONS(3062),
    [anon_sym_switch] = ACTIONS(3062),
    [anon_sym_for] = ACTIONS(3062),
    [anon_sym_LPAREN] = ACTIONS(3064),
    [anon_sym_await] = ACTIONS(3062),
    [anon_sym_while] = ACTIONS(3062),
    [anon_sym_do] = ACTIONS(3062),
    [anon_sym_try] = ACTIONS(3062),
    [anon_sym_with] = ACTIONS(3062),
    [anon_sym_break] = ACTIONS(3062),
    [anon_sym_continue] = ACTIONS(3062),
    [anon_sym_debugger] = ACTIONS(3062),
    [anon_sym_return] = ACTIONS(3062),
    [anon_sym_throw] = ACTIONS(3062),
    [anon_sym_SEMI] = ACTIONS(3064),
    [anon_sym_case] = ACTIONS(3062),
    [anon_sym_default] = ACTIONS(3062),
    [anon_sym_yield] = ACTIONS(3062),
    [anon_sym_LBRACK] = ACTIONS(3064),
    [anon_sym_LTtemplate_GT] = ACTIONS(3064),
    [anon_sym_LT] = ACTIONS(3062),
    [anon_sym_SLASH] = ACTIONS(3062),
    [anon_sym_class] = ACTIONS(3062),
    [anon_sym_async] = ACTIONS(3062),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_new] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym_PLUS] = ACTIONS(3062),
    [anon_sym_DASH] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3064),
    [anon_sym_void] = ACTIONS(3062),
    [anon_sym_delete] = ACTIONS(3062),
    [anon_sym_PLUS_PLUS] = ACTIONS(3064),
    [anon_sym_DASH_DASH] = ACTIONS(3064),
    [anon_sym_DQUOTE] = ACTIONS(3064),
    [anon_sym_SQUOTE] = ACTIONS(3064),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3064),
    [sym_number] = ACTIONS(3064),
    [sym_this] = ACTIONS(3062),
    [sym_super] = ACTIONS(3062),
    [sym_true] = ACTIONS(3062),
    [sym_false] = ACTIONS(3062),
    [sym_null] = ACTIONS(3062),
    [sym_undefined] = ACTIONS(3062),
    [anon_sym_AT] = ACTIONS(3064),
    [anon_sym_static] = ACTIONS(3062),
    [anon_sym_readonly] = ACTIONS(3062),
    [anon_sym_get] = ACTIONS(3062),
    [anon_sym_set] = ACTIONS(3062),
    [anon_sym_declare] = ACTIONS(3062),
    [anon_sym_namespace] = ACTIONS(3062),
    [anon_sym_public] = ACTIONS(3062),
    [anon_sym_private] = ACTIONS(3062),
    [anon_sym_protected] = ACTIONS(3062),
    [anon_sym_override] = ACTIONS(3062),
    [anon_sym_module] = ACTIONS(3062),
    [anon_sym_any] = ACTIONS(3062),
    [anon_sym_number] = ACTIONS(3062),
    [anon_sym_boolean] = ACTIONS(3062),
    [anon_sym_string] = ACTIONS(3062),
    [anon_sym_symbol] = ACTIONS(3062),
    [anon_sym_abstract] = ACTIONS(3062),
    [anon_sym_interface] = ACTIONS(3062),
    [anon_sym_enum] = ACTIONS(3062),
    [anon_sym_component] = ACTIONS(3062),
  },
  [869] = {
    [sym_identifier] = ACTIONS(3066),
    [anon_sym_export] = ACTIONS(3066),
    [anon_sym_LBRACE] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(3068),
    [anon_sym_type] = ACTIONS(3066),
    [anon_sym_typeof] = ACTIONS(3066),
    [anon_sym_import] = ACTIONS(3066),
    [anon_sym_var] = ACTIONS(3066),
    [anon_sym_let] = ACTIONS(3066),
    [anon_sym_const] = ACTIONS(3066),
    [anon_sym_BANG] = ACTIONS(3068),
    [anon_sym_else] = ACTIONS(3066),
    [anon_sym_if] = ACTIONS(3066),
    [anon_sym_switch] = ACTIONS(3066),
    [anon_sym_for] = ACTIONS(3066),
    [anon_sym_LPAREN] = ACTIONS(3068),
    [anon_sym_await] = ACTIONS(3066),
    [anon_sym_while] = ACTIONS(3066),
    [anon_sym_do] = ACTIONS(3066),
    [anon_sym_try] = ACTIONS(3066),
    [anon_sym_with] = ACTIONS(3066),
    [anon_sym_break] = ACTIONS(3066),
    [anon_sym_continue] = ACTIONS(3066),
    [anon_sym_debugger] = ACTIONS(3066),
    [anon_sym_return] = ACTIONS(3066),
    [anon_sym_throw] = ACTIONS(3066),
    [anon_sym_SEMI] = ACTIONS(3068),
    [anon_sym_case] = ACTIONS(3066),
    [anon_sym_default] = ACTIONS(3066),
    [anon_sym_yield] = ACTIONS(3066),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_LTtemplate_GT] = ACTIONS(3068),
    [anon_sym_LT] = ACTIONS(3066),
    [anon_sym_SLASH] = ACTIONS(3066),
    [anon_sym_class] = ACTIONS(3066),
    [anon_sym_async] = ACTIONS(3066),
    [anon_sym_function] = ACTIONS(3066),
    [anon_sym_new] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3066),
    [anon_sym_DASH] = ACTIONS(3066),
    [anon_sym_TILDE] = ACTIONS(3068),
    [anon_sym_void] = ACTIONS(3066),
    [anon_sym_delete] = ACTIONS(3066),
    [anon_sym_PLUS_PLUS] = ACTIONS(3068),
    [anon_sym_DASH_DASH] = ACTIONS(3068),
    [anon_sym_DQUOTE] = ACTIONS(3068),
    [anon_sym_SQUOTE] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3068),
    [sym_number] = ACTIONS(3068),
    [sym_this] = ACTIONS(3066),
    [sym_super] = ACTIONS(3066),
    [sym_true] = ACTIONS(3066),
    [sym_false] = ACTIONS(3066),
    [sym_null] = ACTIONS(3066),
    [sym_undefined] = ACTIONS(3066),
    [anon_sym_AT] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3066),
    [anon_sym_readonly] = ACTIONS(3066),
    [anon_sym_get] = ACTIONS(3066),
    [anon_sym_set] = ACTIONS(3066),
    [anon_sym_declare] = ACTIONS(3066),
    [anon_sym_namespace] = ACTIONS(3066),
    [anon_sym_public] = ACTIONS(3066),
    [anon_sym_private] = ACTIONS(3066),
    [anon_sym_protected] = ACTIONS(3066),
    [anon_sym_override] = ACTIONS(3066),
    [anon_sym_module] = ACTIONS(3066),
    [anon_sym_any] = ACTIONS(3066),
    [anon_sym_number] = ACTIONS(3066),
    [anon_sym_boolean] = ACTIONS(3066),
    [anon_sym_string] = ACTIONS(3066),
    [anon_sym_symbol] = ACTIONS(3066),
    [anon_sym_abstract] = ACTIONS(3066),
    [anon_sym_interface] = ACTIONS(3066),
    [anon_sym_enum] = ACTIONS(3066),
    [anon_sym_component] = ACTIONS(3066),
  },
  [870] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(3070),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_RBRACE] = ACTIONS(3072),
    [anon_sym_typeof] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(3070),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_QMARK_QMARK] = ACTIONS(2650),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(3072),
    [anon_sym_SQUOTE] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3072),
    [sym_number] = ACTIONS(3072),
    [sym_this] = ACTIONS(3070),
    [sym_true] = ACTIONS(3070),
    [sym_false] = ACTIONS(3070),
    [sym_null] = ACTIONS(3070),
    [sym_undefined] = ACTIONS(3070),
    [anon_sym_static] = ACTIONS(3070),
    [anon_sym_readonly] = ACTIONS(3070),
    [anon_sym_get] = ACTIONS(3070),
    [anon_sym_set] = ACTIONS(3070),
    [anon_sym_QMARK] = ACTIONS(3070),
    [anon_sym_any] = ACTIONS(3070),
    [anon_sym_number] = ACTIONS(3070),
    [anon_sym_boolean] = ACTIONS(3070),
    [anon_sym_string] = ACTIONS(3070),
    [anon_sym_symbol] = ACTIONS(3070),
    [anon_sym_abstract] = ACTIONS(3070),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(3070),
    [anon_sym_keyof] = ACTIONS(3070),
    [anon_sym_unknown] = ACTIONS(3070),
    [anon_sym_never] = ACTIONS(3070),
    [anon_sym_object] = ACTIONS(3070),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3072),
    [anon_sym_constructor] = ACTIONS(3070),
    [anon_sym_prop] = ACTIONS(3070),
    [anon_sym_id] = ACTIONS(3070),
    [anon_sym_event] = ACTIONS(3070),
    [anon_sym_fn] = ACTIONS(3070),
    [anon_sym_on] = ACTIONS(3070),
    [sym__ternary_qmark] = ACTIONS(2656),
  },
  [871] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(3074),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3076),
    [anon_sym_typeof] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(3076),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(3074),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_GT_GT] = ACTIONS(2628),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_PERCENT] = ACTIONS(2640),
    [anon_sym_STAR_STAR] = ACTIONS(2642),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_QMARK_QMARK] = ACTIONS(2650),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(3076),
    [anon_sym_SQUOTE] = ACTIONS(3076),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3076),
    [sym_number] = ACTIONS(3076),
    [sym_this] = ACTIONS(3074),
    [sym_true] = ACTIONS(3074),
    [sym_false] = ACTIONS(3074),
    [sym_null] = ACTIONS(3074),
    [sym_undefined] = ACTIONS(3074),
    [anon_sym_static] = ACTIONS(3074),
    [anon_sym_readonly] = ACTIONS(3074),
    [anon_sym_get] = ACTIONS(3074),
    [anon_sym_set] = ACTIONS(3074),
    [anon_sym_QMARK] = ACTIONS(3074),
    [anon_sym_any] = ACTIONS(3074),
    [anon_sym_number] = ACTIONS(3074),
    [anon_sym_boolean] = ACTIONS(3074),
    [anon_sym_string] = ACTIONS(3074),
    [anon_sym_symbol] = ACTIONS(3074),
    [anon_sym_abstract] = ACTIONS(3074),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(3074),
    [anon_sym_keyof] = ACTIONS(3074),
    [anon_sym_unknown] = ACTIONS(3074),
    [anon_sym_never] = ACTIONS(3074),
    [anon_sym_object] = ACTIONS(3074),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3076),
    [anon_sym_constructor] = ACTIONS(3074),
    [anon_sym_prop] = ACTIONS(3074),
    [anon_sym_id] = ACTIONS(3074),
    [anon_sym_event] = ACTIONS(3074),
    [anon_sym_fn] = ACTIONS(3074),
    [anon_sym_on] = ACTIONS(3074),
    [sym__ternary_qmark] = ACTIONS(2656),
  },
  [872] = {
    [sym_identifier] = ACTIONS(3078),
    [anon_sym_export] = ACTIONS(3078),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_RBRACE] = ACTIONS(3080),
    [anon_sym_type] = ACTIONS(3078),
    [anon_sym_typeof] = ACTIONS(3078),
    [anon_sym_import] = ACTIONS(3078),
    [anon_sym_var] = ACTIONS(3078),
    [anon_sym_let] = ACTIONS(3078),
    [anon_sym_const] = ACTIONS(3078),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_else] = ACTIONS(3078),
    [anon_sym_if] = ACTIONS(3078),
    [anon_sym_switch] = ACTIONS(3078),
    [anon_sym_for] = ACTIONS(3078),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_await] = ACTIONS(3078),
    [anon_sym_while] = ACTIONS(3078),
    [anon_sym_do] = ACTIONS(3078),
    [anon_sym_try] = ACTIONS(3078),
    [anon_sym_with] = ACTIONS(3078),
    [anon_sym_break] = ACTIONS(3078),
    [anon_sym_continue] = ACTIONS(3078),
    [anon_sym_debugger] = ACTIONS(3078),
    [anon_sym_return] = ACTIONS(3078),
    [anon_sym_throw] = ACTIONS(3078),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_case] = ACTIONS(3078),
    [anon_sym_default] = ACTIONS(3078),
    [anon_sym_yield] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(3080),
    [anon_sym_LTtemplate_GT] = ACTIONS(3080),
    [anon_sym_LT] = ACTIONS(3078),
    [anon_sym_SLASH] = ACTIONS(3078),
    [anon_sym_class] = ACTIONS(3078),
    [anon_sym_async] = ACTIONS(3078),
    [anon_sym_function] = ACTIONS(3078),
    [anon_sym_new] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3080),
    [anon_sym_PLUS] = ACTIONS(3078),
    [anon_sym_DASH] = ACTIONS(3078),
    [anon_sym_TILDE] = ACTIONS(3080),
    [anon_sym_void] = ACTIONS(3078),
    [anon_sym_delete] = ACTIONS(3078),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_DQUOTE] = ACTIONS(3080),
    [anon_sym_SQUOTE] = ACTIONS(3080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3080),
    [sym_number] = ACTIONS(3080),
    [sym_this] = ACTIONS(3078),
    [sym_super] = ACTIONS(3078),
    [sym_true] = ACTIONS(3078),
    [sym_false] = ACTIONS(3078),
    [sym_null] = ACTIONS(3078),
    [sym_undefined] = ACTIONS(3078),
    [anon_sym_AT] = ACTIONS(3080),
    [anon_sym_static] = ACTIONS(3078),
    [anon_sym_readonly] = ACTIONS(3078),
    [anon_sym_get] = ACTIONS(3078),
    [anon_sym_set] = ACTIONS(3078),
    [anon_sym_declare] = ACTIONS(3078),
    [anon_sym_namespace] = ACTIONS(3078),
    [anon_sym_public] = ACTIONS(3078),
    [anon_sym_private] = ACTIONS(3078),
    [anon_sym_protected] = ACTIONS(3078),
    [anon_sym_override] = ACTIONS(3078),
    [anon_sym_module] = ACTIONS(3078),
    [anon_sym_any] = ACTIONS(3078),
    [anon_sym_number] = ACTIONS(3078),
    [anon_sym_boolean] = ACTIONS(3078),
    [anon_sym_string] = ACTIONS(3078),
    [anon_sym_symbol] = ACTIONS(3078),
    [anon_sym_abstract] = ACTIONS(3078),
    [anon_sym_interface] = ACTIONS(3078),
    [anon_sym_enum] = ACTIONS(3078),
    [anon_sym_component] = ACTIONS(3078),
  },
  [873] = {
    [sym_identifier] = ACTIONS(3082),
    [anon_sym_export] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_RBRACE] = ACTIONS(3084),
    [anon_sym_type] = ACTIONS(3082),
    [anon_sym_typeof] = ACTIONS(3082),
    [anon_sym_import] = ACTIONS(3082),
    [anon_sym_var] = ACTIONS(3082),
    [anon_sym_let] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_else] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_LPAREN] = ACTIONS(3084),
    [anon_sym_await] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_with] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_debugger] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_yield] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3084),
    [anon_sym_LTtemplate_GT] = ACTIONS(3084),
    [anon_sym_LT] = ACTIONS(3082),
    [anon_sym_SLASH] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_async] = ACTIONS(3082),
    [anon_sym_function] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_AMP] = ACTIONS(3084),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_void] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3084),
    [sym_number] = ACTIONS(3084),
    [sym_this] = ACTIONS(3082),
    [sym_super] = ACTIONS(3082),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [sym_null] = ACTIONS(3082),
    [sym_undefined] = ACTIONS(3082),
    [anon_sym_AT] = ACTIONS(3084),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_readonly] = ACTIONS(3082),
    [anon_sym_get] = ACTIONS(3082),
    [anon_sym_set] = ACTIONS(3082),
    [anon_sym_declare] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(3082),
    [anon_sym_private] = ACTIONS(3082),
    [anon_sym_protected] = ACTIONS(3082),
    [anon_sym_override] = ACTIONS(3082),
    [anon_sym_module] = ACTIONS(3082),
    [anon_sym_any] = ACTIONS(3082),
    [anon_sym_number] = ACTIONS(3082),
    [anon_sym_boolean] = ACTIONS(3082),
    [anon_sym_string] = ACTIONS(3082),
    [anon_sym_symbol] = ACTIONS(3082),
    [anon_sym_abstract] = ACTIONS(3082),
    [anon_sym_interface] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_component] = ACTIONS(3082),
  },
  [874] = {
    [sym_identifier] = ACTIONS(3086),
    [anon_sym_export] = ACTIONS(3086),
    [anon_sym_LBRACE] = ACTIONS(3088),
    [anon_sym_RBRACE] = ACTIONS(3088),
    [anon_sym_type] = ACTIONS(3086),
    [anon_sym_typeof] = ACTIONS(3086),
    [anon_sym_import] = ACTIONS(3086),
    [anon_sym_var] = ACTIONS(3086),
    [anon_sym_let] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [anon_sym_BANG] = ACTIONS(3088),
    [anon_sym_else] = ACTIONS(3086),
    [anon_sym_if] = ACTIONS(3086),
    [anon_sym_switch] = ACTIONS(3086),
    [anon_sym_for] = ACTIONS(3086),
    [anon_sym_LPAREN] = ACTIONS(3088),
    [anon_sym_await] = ACTIONS(3086),
    [anon_sym_while] = ACTIONS(3086),
    [anon_sym_do] = ACTIONS(3086),
    [anon_sym_try] = ACTIONS(3086),
    [anon_sym_with] = ACTIONS(3086),
    [anon_sym_break] = ACTIONS(3086),
    [anon_sym_continue] = ACTIONS(3086),
    [anon_sym_debugger] = ACTIONS(3086),
    [anon_sym_return] = ACTIONS(3086),
    [anon_sym_throw] = ACTIONS(3086),
    [anon_sym_SEMI] = ACTIONS(3088),
    [anon_sym_case] = ACTIONS(3086),
    [anon_sym_default] = ACTIONS(3086),
    [anon_sym_yield] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3088),
    [anon_sym_LTtemplate_GT] = ACTIONS(3088),
    [anon_sym_LT] = ACTIONS(3086),
    [anon_sym_SLASH] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_async] = ACTIONS(3086),
    [anon_sym_function] = ACTIONS(3086),
    [anon_sym_new] = ACTIONS(3086),
    [anon_sym_AMP] = ACTIONS(3088),
    [anon_sym_PLUS] = ACTIONS(3086),
    [anon_sym_DASH] = ACTIONS(3086),
    [anon_sym_TILDE] = ACTIONS(3088),
    [anon_sym_void] = ACTIONS(3086),
    [anon_sym_delete] = ACTIONS(3086),
    [anon_sym_PLUS_PLUS] = ACTIONS(3088),
    [anon_sym_DASH_DASH] = ACTIONS(3088),
    [anon_sym_DQUOTE] = ACTIONS(3088),
    [anon_sym_SQUOTE] = ACTIONS(3088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3088),
    [sym_number] = ACTIONS(3088),
    [sym_this] = ACTIONS(3086),
    [sym_super] = ACTIONS(3086),
    [sym_true] = ACTIONS(3086),
    [sym_false] = ACTIONS(3086),
    [sym_null] = ACTIONS(3086),
    [sym_undefined] = ACTIONS(3086),
    [anon_sym_AT] = ACTIONS(3088),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_readonly] = ACTIONS(3086),
    [anon_sym_get] = ACTIONS(3086),
    [anon_sym_set] = ACTIONS(3086),
    [anon_sym_declare] = ACTIONS(3086),
    [anon_sym_namespace] = ACTIONS(3086),
    [anon_sym_public] = ACTIONS(3086),
    [anon_sym_private] = ACTIONS(3086),
    [anon_sym_protected] = ACTIONS(3086),
    [anon_sym_override] = ACTIONS(3086),
    [anon_sym_module] = ACTIONS(3086),
    [anon_sym_any] = ACTIONS(3086),
    [anon_sym_number] = ACTIONS(3086),
    [anon_sym_boolean] = ACTIONS(3086),
    [anon_sym_string] = ACTIONS(3086),
    [anon_sym_symbol] = ACTIONS(3086),
    [anon_sym_abstract] = ACTIONS(3086),
    [anon_sym_interface] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_component] = ACTIONS(3086),
  },
  [875] = {
    [sym_identifier] = ACTIONS(3090),
    [anon_sym_export] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3092),
    [anon_sym_RBRACE] = ACTIONS(3092),
    [anon_sym_type] = ACTIONS(3090),
    [anon_sym_typeof] = ACTIONS(3090),
    [anon_sym_import] = ACTIONS(3090),
    [anon_sym_var] = ACTIONS(3090),
    [anon_sym_let] = ACTIONS(3090),
    [anon_sym_const] = ACTIONS(3090),
    [anon_sym_BANG] = ACTIONS(3092),
    [anon_sym_else] = ACTIONS(3090),
    [anon_sym_if] = ACTIONS(3090),
    [anon_sym_switch] = ACTIONS(3090),
    [anon_sym_for] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_await] = ACTIONS(3090),
    [anon_sym_while] = ACTIONS(3090),
    [anon_sym_do] = ACTIONS(3090),
    [anon_sym_try] = ACTIONS(3090),
    [anon_sym_with] = ACTIONS(3090),
    [anon_sym_break] = ACTIONS(3090),
    [anon_sym_continue] = ACTIONS(3090),
    [anon_sym_debugger] = ACTIONS(3090),
    [anon_sym_return] = ACTIONS(3090),
    [anon_sym_throw] = ACTIONS(3090),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym_case] = ACTIONS(3090),
    [anon_sym_default] = ACTIONS(3090),
    [anon_sym_yield] = ACTIONS(3090),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_LTtemplate_GT] = ACTIONS(3092),
    [anon_sym_LT] = ACTIONS(3090),
    [anon_sym_SLASH] = ACTIONS(3090),
    [anon_sym_class] = ACTIONS(3090),
    [anon_sym_async] = ACTIONS(3090),
    [anon_sym_function] = ACTIONS(3090),
    [anon_sym_new] = ACTIONS(3090),
    [anon_sym_AMP] = ACTIONS(3092),
    [anon_sym_PLUS] = ACTIONS(3090),
    [anon_sym_DASH] = ACTIONS(3090),
    [anon_sym_TILDE] = ACTIONS(3092),
    [anon_sym_void] = ACTIONS(3090),
    [anon_sym_delete] = ACTIONS(3090),
    [anon_sym_PLUS_PLUS] = ACTIONS(3092),
    [anon_sym_DASH_DASH] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [anon_sym_SQUOTE] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3092),
    [sym_number] = ACTIONS(3092),
    [sym_this] = ACTIONS(3090),
    [sym_super] = ACTIONS(3090),
    [sym_true] = ACTIONS(3090),
    [sym_false] = ACTIONS(3090),
    [sym_null] = ACTIONS(3090),
    [sym_undefined] = ACTIONS(3090),
    [anon_sym_AT] = ACTIONS(3092),
    [anon_sym_static] = ACTIONS(3090),
    [anon_sym_readonly] = ACTIONS(3090),
    [anon_sym_get] = ACTIONS(3090),
    [anon_sym_set] = ACTIONS(3090),
    [anon_sym_declare] = ACTIONS(3090),
    [anon_sym_namespace] = ACTIONS(3090),
    [anon_sym_public] = ACTIONS(3090),
    [anon_sym_private] = ACTIONS(3090),
    [anon_sym_protected] = ACTIONS(3090),
    [anon_sym_override] = ACTIONS(3090),
    [anon_sym_module] = ACTIONS(3090),
    [anon_sym_any] = ACTIONS(3090),
    [anon_sym_number] = ACTIONS(3090),
    [anon_sym_boolean] = ACTIONS(3090),
    [anon_sym_string] = ACTIONS(3090),
    [anon_sym_symbol] = ACTIONS(3090),
    [anon_sym_abstract] = ACTIONS(3090),
    [anon_sym_interface] = ACTIONS(3090),
    [anon_sym_enum] = ACTIONS(3090),
    [anon_sym_component] = ACTIONS(3090),
  },
  [876] = {
    [sym_identifier] = ACTIONS(3082),
    [anon_sym_export] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_RBRACE] = ACTIONS(3084),
    [anon_sym_type] = ACTIONS(3082),
    [anon_sym_typeof] = ACTIONS(3082),
    [anon_sym_import] = ACTIONS(3082),
    [anon_sym_var] = ACTIONS(3082),
    [anon_sym_let] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_else] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_LPAREN] = ACTIONS(3084),
    [anon_sym_await] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_with] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_debugger] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_yield] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3084),
    [anon_sym_LTtemplate_GT] = ACTIONS(3084),
    [anon_sym_LT] = ACTIONS(3082),
    [anon_sym_SLASH] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_async] = ACTIONS(3082),
    [anon_sym_function] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_AMP] = ACTIONS(3084),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_void] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3084),
    [sym_number] = ACTIONS(3084),
    [sym_this] = ACTIONS(3082),
    [sym_super] = ACTIONS(3082),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [sym_null] = ACTIONS(3082),
    [sym_undefined] = ACTIONS(3082),
    [anon_sym_AT] = ACTIONS(3084),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_readonly] = ACTIONS(3082),
    [anon_sym_get] = ACTIONS(3082),
    [anon_sym_set] = ACTIONS(3082),
    [anon_sym_declare] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(3082),
    [anon_sym_private] = ACTIONS(3082),
    [anon_sym_protected] = ACTIONS(3082),
    [anon_sym_override] = ACTIONS(3082),
    [anon_sym_module] = ACTIONS(3082),
    [anon_sym_any] = ACTIONS(3082),
    [anon_sym_number] = ACTIONS(3082),
    [anon_sym_boolean] = ACTIONS(3082),
    [anon_sym_string] = ACTIONS(3082),
    [anon_sym_symbol] = ACTIONS(3082),
    [anon_sym_abstract] = ACTIONS(3082),
    [anon_sym_interface] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_component] = ACTIONS(3082),
  },
  [877] = {
    [sym_identifier] = ACTIONS(3082),
    [anon_sym_export] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_RBRACE] = ACTIONS(3084),
    [anon_sym_type] = ACTIONS(3082),
    [anon_sym_typeof] = ACTIONS(3082),
    [anon_sym_import] = ACTIONS(3082),
    [anon_sym_var] = ACTIONS(3082),
    [anon_sym_let] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_else] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_LPAREN] = ACTIONS(3084),
    [anon_sym_await] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_with] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_debugger] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_yield] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3084),
    [anon_sym_LTtemplate_GT] = ACTIONS(3084),
    [anon_sym_LT] = ACTIONS(3082),
    [anon_sym_SLASH] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_async] = ACTIONS(3082),
    [anon_sym_function] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_AMP] = ACTIONS(3084),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_void] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3084),
    [sym_number] = ACTIONS(3084),
    [sym_this] = ACTIONS(3082),
    [sym_super] = ACTIONS(3082),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [sym_null] = ACTIONS(3082),
    [sym_undefined] = ACTIONS(3082),
    [anon_sym_AT] = ACTIONS(3084),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_readonly] = ACTIONS(3082),
    [anon_sym_get] = ACTIONS(3082),
    [anon_sym_set] = ACTIONS(3082),
    [anon_sym_declare] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(3082),
    [anon_sym_private] = ACTIONS(3082),
    [anon_sym_protected] = ACTIONS(3082),
    [anon_sym_override] = ACTIONS(3082),
    [anon_sym_module] = ACTIONS(3082),
    [anon_sym_any] = ACTIONS(3082),
    [anon_sym_number] = ACTIONS(3082),
    [anon_sym_boolean] = ACTIONS(3082),
    [anon_sym_string] = ACTIONS(3082),
    [anon_sym_symbol] = ACTIONS(3082),
    [anon_sym_abstract] = ACTIONS(3082),
    [anon_sym_interface] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_component] = ACTIONS(3082),
  },
  [878] = {
    [sym_identifier] = ACTIONS(3094),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_as] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_RBRACE] = ACTIONS(3096),
    [anon_sym_typeof] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_LPAREN] = ACTIONS(3096),
    [anon_sym_in] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3096),
    [anon_sym_LBRACK] = ACTIONS(3096),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_GT] = ACTIONS(3094),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_DOT] = ACTIONS(3094),
    [anon_sym_async] = ACTIONS(3094),
    [anon_sym_QMARK_DOT] = ACTIONS(3096),
    [anon_sym_new] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3096),
    [anon_sym_PIPE_PIPE] = ACTIONS(3096),
    [anon_sym_GT_GT] = ACTIONS(3094),
    [anon_sym_GT_GT_GT] = ACTIONS(3096),
    [anon_sym_LT_LT] = ACTIONS(3096),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_CARET] = ACTIONS(3096),
    [anon_sym_PIPE] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3094),
    [anon_sym_PERCENT] = ACTIONS(3096),
    [anon_sym_STAR_STAR] = ACTIONS(3096),
    [anon_sym_LT_EQ] = ACTIONS(3096),
    [anon_sym_EQ_EQ] = ACTIONS(3094),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3096),
    [anon_sym_BANG_EQ] = ACTIONS(3094),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3096),
    [anon_sym_GT_EQ] = ACTIONS(3096),
    [anon_sym_QMARK_QMARK] = ACTIONS(3096),
    [anon_sym_instanceof] = ACTIONS(3094),
    [anon_sym_void] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3096),
    [anon_sym_DASH_DASH] = ACTIONS(3096),
    [anon_sym_DQUOTE] = ACTIONS(3096),
    [anon_sym_SQUOTE] = ACTIONS(3096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3096),
    [sym_number] = ACTIONS(3096),
    [sym_this] = ACTIONS(3094),
    [sym_true] = ACTIONS(3094),
    [sym_false] = ACTIONS(3094),
    [sym_null] = ACTIONS(3094),
    [sym_undefined] = ACTIONS(3094),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_readonly] = ACTIONS(3094),
    [anon_sym_get] = ACTIONS(3094),
    [anon_sym_set] = ACTIONS(3094),
    [anon_sym_QMARK] = ACTIONS(3094),
    [anon_sym_any] = ACTIONS(3094),
    [anon_sym_number] = ACTIONS(3094),
    [anon_sym_boolean] = ACTIONS(3094),
    [anon_sym_string] = ACTIONS(3094),
    [anon_sym_symbol] = ACTIONS(3094),
    [anon_sym_abstract] = ACTIONS(3094),
    [anon_sym_satisfies] = ACTIONS(3094),
    [anon_sym_extends] = ACTIONS(3094),
    [anon_sym_infer] = ACTIONS(3094),
    [anon_sym_keyof] = ACTIONS(3094),
    [anon_sym_unknown] = ACTIONS(3094),
    [anon_sym_never] = ACTIONS(3094),
    [anon_sym_object] = ACTIONS(3094),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3096),
    [anon_sym_constructor] = ACTIONS(3094),
    [anon_sym_prop] = ACTIONS(3094),
    [anon_sym_id] = ACTIONS(3094),
    [anon_sym_event] = ACTIONS(3094),
    [anon_sym_fn] = ACTIONS(3094),
    [anon_sym_on] = ACTIONS(3094),
    [sym__ternary_qmark] = ACTIONS(3096),
  },
  [879] = {
    [sym_identifier] = ACTIONS(3098),
    [anon_sym_STAR] = ACTIONS(3098),
    [anon_sym_as] = ACTIONS(3098),
    [anon_sym_LBRACE] = ACTIONS(3098),
    [anon_sym_RBRACE] = ACTIONS(3100),
    [anon_sym_typeof] = ACTIONS(3098),
    [anon_sym_BANG] = ACTIONS(3098),
    [anon_sym_LPAREN] = ACTIONS(3100),
    [anon_sym_in] = ACTIONS(3098),
    [anon_sym_SEMI] = ACTIONS(3100),
    [anon_sym_LBRACK] = ACTIONS(3100),
    [anon_sym_LT] = ACTIONS(3098),
    [anon_sym_GT] = ACTIONS(3098),
    [anon_sym_SLASH] = ACTIONS(3098),
    [anon_sym_DOT] = ACTIONS(3098),
    [anon_sym_async] = ACTIONS(3098),
    [anon_sym_QMARK_DOT] = ACTIONS(3100),
    [anon_sym_new] = ACTIONS(3098),
    [anon_sym_AMP_AMP] = ACTIONS(3100),
    [anon_sym_PIPE_PIPE] = ACTIONS(3100),
    [anon_sym_GT_GT] = ACTIONS(3098),
    [anon_sym_GT_GT_GT] = ACTIONS(3100),
    [anon_sym_LT_LT] = ACTIONS(3100),
    [anon_sym_AMP] = ACTIONS(3098),
    [anon_sym_CARET] = ACTIONS(3100),
    [anon_sym_PIPE] = ACTIONS(3098),
    [anon_sym_PLUS] = ACTIONS(3098),
    [anon_sym_DASH] = ACTIONS(3098),
    [anon_sym_PERCENT] = ACTIONS(3100),
    [anon_sym_STAR_STAR] = ACTIONS(3100),
    [anon_sym_LT_EQ] = ACTIONS(3100),
    [anon_sym_EQ_EQ] = ACTIONS(3098),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3100),
    [anon_sym_BANG_EQ] = ACTIONS(3098),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3100),
    [anon_sym_GT_EQ] = ACTIONS(3100),
    [anon_sym_QMARK_QMARK] = ACTIONS(3100),
    [anon_sym_instanceof] = ACTIONS(3098),
    [anon_sym_void] = ACTIONS(3098),
    [anon_sym_PLUS_PLUS] = ACTIONS(3100),
    [anon_sym_DASH_DASH] = ACTIONS(3100),
    [anon_sym_DQUOTE] = ACTIONS(3100),
    [anon_sym_SQUOTE] = ACTIONS(3100),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3100),
    [sym_number] = ACTIONS(3100),
    [sym_this] = ACTIONS(3098),
    [sym_true] = ACTIONS(3098),
    [sym_false] = ACTIONS(3098),
    [sym_null] = ACTIONS(3098),
    [sym_undefined] = ACTIONS(3098),
    [anon_sym_static] = ACTIONS(3098),
    [anon_sym_readonly] = ACTIONS(3098),
    [anon_sym_get] = ACTIONS(3098),
    [anon_sym_set] = ACTIONS(3098),
    [anon_sym_QMARK] = ACTIONS(3098),
    [anon_sym_any] = ACTIONS(3098),
    [anon_sym_number] = ACTIONS(3098),
    [anon_sym_boolean] = ACTIONS(3098),
    [anon_sym_string] = ACTIONS(3098),
    [anon_sym_symbol] = ACTIONS(3098),
    [anon_sym_abstract] = ACTIONS(3098),
    [anon_sym_satisfies] = ACTIONS(3098),
    [anon_sym_extends] = ACTIONS(3098),
    [anon_sym_infer] = ACTIONS(3098),
    [anon_sym_keyof] = ACTIONS(3098),
    [anon_sym_unknown] = ACTIONS(3098),
    [anon_sym_never] = ACTIONS(3098),
    [anon_sym_object] = ACTIONS(3098),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3100),
    [anon_sym_constructor] = ACTIONS(3098),
    [anon_sym_prop] = ACTIONS(3098),
    [anon_sym_id] = ACTIONS(3098),
    [anon_sym_event] = ACTIONS(3098),
    [anon_sym_fn] = ACTIONS(3098),
    [anon_sym_on] = ACTIONS(3098),
    [sym__ternary_qmark] = ACTIONS(3100),
  },
  [880] = {
    [sym_identifier] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3102),
    [anon_sym_as] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_RBRACE] = ACTIONS(3104),
    [anon_sym_typeof] = ACTIONS(3102),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_LPAREN] = ACTIONS(3104),
    [anon_sym_in] = ACTIONS(3102),
    [anon_sym_SEMI] = ACTIONS(3104),
    [anon_sym_LBRACK] = ACTIONS(3104),
    [anon_sym_LT] = ACTIONS(3102),
    [anon_sym_GT] = ACTIONS(3102),
    [anon_sym_SLASH] = ACTIONS(3102),
    [anon_sym_DOT] = ACTIONS(3102),
    [anon_sym_async] = ACTIONS(3102),
    [anon_sym_QMARK_DOT] = ACTIONS(3104),
    [anon_sym_new] = ACTIONS(3102),
    [anon_sym_AMP_AMP] = ACTIONS(3104),
    [anon_sym_PIPE_PIPE] = ACTIONS(3104),
    [anon_sym_GT_GT] = ACTIONS(3102),
    [anon_sym_GT_GT_GT] = ACTIONS(3104),
    [anon_sym_LT_LT] = ACTIONS(3104),
    [anon_sym_AMP] = ACTIONS(3102),
    [anon_sym_CARET] = ACTIONS(3104),
    [anon_sym_PIPE] = ACTIONS(3102),
    [anon_sym_PLUS] = ACTIONS(3102),
    [anon_sym_DASH] = ACTIONS(3102),
    [anon_sym_PERCENT] = ACTIONS(3104),
    [anon_sym_STAR_STAR] = ACTIONS(3104),
    [anon_sym_LT_EQ] = ACTIONS(3104),
    [anon_sym_EQ_EQ] = ACTIONS(3102),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3104),
    [anon_sym_BANG_EQ] = ACTIONS(3102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3104),
    [anon_sym_GT_EQ] = ACTIONS(3104),
    [anon_sym_QMARK_QMARK] = ACTIONS(3104),
    [anon_sym_instanceof] = ACTIONS(3102),
    [anon_sym_void] = ACTIONS(3102),
    [anon_sym_PLUS_PLUS] = ACTIONS(3104),
    [anon_sym_DASH_DASH] = ACTIONS(3104),
    [anon_sym_DQUOTE] = ACTIONS(3104),
    [anon_sym_SQUOTE] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3104),
    [sym_number] = ACTIONS(3104),
    [sym_this] = ACTIONS(3102),
    [sym_true] = ACTIONS(3102),
    [sym_false] = ACTIONS(3102),
    [sym_null] = ACTIONS(3102),
    [sym_undefined] = ACTIONS(3102),
    [anon_sym_static] = ACTIONS(3102),
    [anon_sym_readonly] = ACTIONS(3102),
    [anon_sym_get] = ACTIONS(3102),
    [anon_sym_set] = ACTIONS(3102),
    [anon_sym_QMARK] = ACTIONS(3102),
    [anon_sym_any] = ACTIONS(3102),
    [anon_sym_number] = ACTIONS(3102),
    [anon_sym_boolean] = ACTIONS(3102),
    [anon_sym_string] = ACTIONS(3102),
    [anon_sym_symbol] = ACTIONS(3102),
    [anon_sym_abstract] = ACTIONS(3102),
    [anon_sym_satisfies] = ACTIONS(3102),
    [anon_sym_extends] = ACTIONS(3102),
    [anon_sym_infer] = ACTIONS(3102),
    [anon_sym_keyof] = ACTIONS(3102),
    [anon_sym_unknown] = ACTIONS(3102),
    [anon_sym_never] = ACTIONS(3102),
    [anon_sym_object] = ACTIONS(3102),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3104),
    [anon_sym_constructor] = ACTIONS(3102),
    [anon_sym_prop] = ACTIONS(3102),
    [anon_sym_id] = ACTIONS(3102),
    [anon_sym_event] = ACTIONS(3102),
    [anon_sym_fn] = ACTIONS(3102),
    [anon_sym_on] = ACTIONS(3102),
    [sym__ternary_qmark] = ACTIONS(3104),
  },
  [881] = {
    [sym_identifier] = ACTIONS(3106),
    [anon_sym_STAR] = ACTIONS(3106),
    [anon_sym_as] = ACTIONS(3106),
    [anon_sym_LBRACE] = ACTIONS(3106),
    [anon_sym_RBRACE] = ACTIONS(3108),
    [anon_sym_typeof] = ACTIONS(3106),
    [anon_sym_BANG] = ACTIONS(3106),
    [anon_sym_LPAREN] = ACTIONS(3108),
    [anon_sym_in] = ACTIONS(3106),
    [anon_sym_SEMI] = ACTIONS(3108),
    [anon_sym_LBRACK] = ACTIONS(3108),
    [anon_sym_LT] = ACTIONS(3106),
    [anon_sym_GT] = ACTIONS(3106),
    [anon_sym_SLASH] = ACTIONS(3106),
    [anon_sym_DOT] = ACTIONS(3106),
    [anon_sym_async] = ACTIONS(3106),
    [anon_sym_QMARK_DOT] = ACTIONS(3108),
    [anon_sym_new] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3108),
    [anon_sym_PIPE_PIPE] = ACTIONS(3108),
    [anon_sym_GT_GT] = ACTIONS(3106),
    [anon_sym_GT_GT_GT] = ACTIONS(3108),
    [anon_sym_LT_LT] = ACTIONS(3108),
    [anon_sym_AMP] = ACTIONS(3110),
    [anon_sym_CARET] = ACTIONS(3108),
    [anon_sym_PIPE] = ACTIONS(3106),
    [anon_sym_PLUS] = ACTIONS(3106),
    [anon_sym_DASH] = ACTIONS(3106),
    [anon_sym_PERCENT] = ACTIONS(3108),
    [anon_sym_STAR_STAR] = ACTIONS(3108),
    [anon_sym_LT_EQ] = ACTIONS(3108),
    [anon_sym_EQ_EQ] = ACTIONS(3106),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3108),
    [anon_sym_BANG_EQ] = ACTIONS(3106),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3108),
    [anon_sym_GT_EQ] = ACTIONS(3108),
    [anon_sym_QMARK_QMARK] = ACTIONS(3108),
    [anon_sym_instanceof] = ACTIONS(3106),
    [anon_sym_void] = ACTIONS(3106),
    [anon_sym_PLUS_PLUS] = ACTIONS(3108),
    [anon_sym_DASH_DASH] = ACTIONS(3108),
    [anon_sym_DQUOTE] = ACTIONS(3108),
    [anon_sym_SQUOTE] = ACTIONS(3108),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3108),
    [sym_number] = ACTIONS(3108),
    [sym_this] = ACTIONS(3106),
    [sym_true] = ACTIONS(3106),
    [sym_false] = ACTIONS(3106),
    [sym_null] = ACTIONS(3106),
    [sym_undefined] = ACTIONS(3106),
    [anon_sym_static] = ACTIONS(3106),
    [anon_sym_readonly] = ACTIONS(3106),
    [anon_sym_get] = ACTIONS(3106),
    [anon_sym_set] = ACTIONS(3106),
    [anon_sym_QMARK] = ACTIONS(3106),
    [anon_sym_any] = ACTIONS(3106),
    [anon_sym_number] = ACTIONS(3106),
    [anon_sym_boolean] = ACTIONS(3106),
    [anon_sym_string] = ACTIONS(3106),
    [anon_sym_symbol] = ACTIONS(3106),
    [anon_sym_abstract] = ACTIONS(3106),
    [anon_sym_satisfies] = ACTIONS(3106),
    [anon_sym_extends] = ACTIONS(3106),
    [anon_sym_infer] = ACTIONS(3106),
    [anon_sym_keyof] = ACTIONS(3106),
    [anon_sym_unknown] = ACTIONS(3106),
    [anon_sym_never] = ACTIONS(3106),
    [anon_sym_object] = ACTIONS(3106),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3108),
    [anon_sym_constructor] = ACTIONS(3106),
    [anon_sym_prop] = ACTIONS(3106),
    [anon_sym_id] = ACTIONS(3106),
    [anon_sym_event] = ACTIONS(3106),
    [anon_sym_fn] = ACTIONS(3106),
    [anon_sym_on] = ACTIONS(3106),
    [sym__ternary_qmark] = ACTIONS(3108),
  },
  [882] = {
    [sym_identifier] = ACTIONS(3112),
    [anon_sym_STAR] = ACTIONS(3112),
    [anon_sym_as] = ACTIONS(3112),
    [anon_sym_LBRACE] = ACTIONS(3112),
    [anon_sym_RBRACE] = ACTIONS(3114),
    [anon_sym_typeof] = ACTIONS(3112),
    [anon_sym_BANG] = ACTIONS(3112),
    [anon_sym_LPAREN] = ACTIONS(3114),
    [anon_sym_in] = ACTIONS(3112),
    [anon_sym_SEMI] = ACTIONS(3114),
    [anon_sym_LBRACK] = ACTIONS(3114),
    [anon_sym_LT] = ACTIONS(3112),
    [anon_sym_GT] = ACTIONS(3112),
    [anon_sym_SLASH] = ACTIONS(3112),
    [anon_sym_DOT] = ACTIONS(3116),
    [anon_sym_async] = ACTIONS(3112),
    [anon_sym_QMARK_DOT] = ACTIONS(3114),
    [anon_sym_new] = ACTIONS(3112),
    [anon_sym_AMP_AMP] = ACTIONS(3114),
    [anon_sym_PIPE_PIPE] = ACTIONS(3114),
    [anon_sym_GT_GT] = ACTIONS(3112),
    [anon_sym_GT_GT_GT] = ACTIONS(3114),
    [anon_sym_LT_LT] = ACTIONS(3114),
    [anon_sym_AMP] = ACTIONS(3112),
    [anon_sym_CARET] = ACTIONS(3114),
    [anon_sym_PIPE] = ACTIONS(3112),
    [anon_sym_PLUS] = ACTIONS(3112),
    [anon_sym_DASH] = ACTIONS(3112),
    [anon_sym_PERCENT] = ACTIONS(3114),
    [anon_sym_STAR_STAR] = ACTIONS(3114),
    [anon_sym_LT_EQ] = ACTIONS(3114),
    [anon_sym_EQ_EQ] = ACTIONS(3112),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3114),
    [anon_sym_BANG_EQ] = ACTIONS(3112),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3114),
    [anon_sym_GT_EQ] = ACTIONS(3114),
    [anon_sym_QMARK_QMARK] = ACTIONS(3114),
    [anon_sym_instanceof] = ACTIONS(3112),
    [anon_sym_void] = ACTIONS(3112),
    [anon_sym_PLUS_PLUS] = ACTIONS(3114),
    [anon_sym_DASH_DASH] = ACTIONS(3114),
    [anon_sym_DQUOTE] = ACTIONS(3114),
    [anon_sym_SQUOTE] = ACTIONS(3114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3114),
    [sym_number] = ACTIONS(3114),
    [sym_this] = ACTIONS(3112),
    [sym_true] = ACTIONS(3112),
    [sym_false] = ACTIONS(3112),
    [sym_null] = ACTIONS(3112),
    [sym_undefined] = ACTIONS(3112),
    [anon_sym_static] = ACTIONS(3112),
    [anon_sym_readonly] = ACTIONS(3112),
    [anon_sym_get] = ACTIONS(3112),
    [anon_sym_set] = ACTIONS(3112),
    [anon_sym_QMARK] = ACTIONS(3112),
    [anon_sym_any] = ACTIONS(3112),
    [anon_sym_number] = ACTIONS(3112),
    [anon_sym_boolean] = ACTIONS(3112),
    [anon_sym_string] = ACTIONS(3112),
    [anon_sym_symbol] = ACTIONS(3112),
    [anon_sym_abstract] = ACTIONS(3112),
    [anon_sym_satisfies] = ACTIONS(3112),
    [anon_sym_extends] = ACTIONS(3112),
    [anon_sym_infer] = ACTIONS(3112),
    [anon_sym_keyof] = ACTIONS(3112),
    [anon_sym_unknown] = ACTIONS(3112),
    [anon_sym_never] = ACTIONS(3112),
    [anon_sym_object] = ACTIONS(3112),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3114),
    [anon_sym_constructor] = ACTIONS(3112),
    [anon_sym_prop] = ACTIONS(3112),
    [anon_sym_id] = ACTIONS(3112),
    [anon_sym_event] = ACTIONS(3112),
    [anon_sym_fn] = ACTIONS(3112),
    [anon_sym_on] = ACTIONS(3112),
    [sym__ternary_qmark] = ACTIONS(3114),
  },
  [883] = {
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_STAR] = ACTIONS(3119),
    [anon_sym_as] = ACTIONS(3119),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_RBRACE] = ACTIONS(3121),
    [anon_sym_typeof] = ACTIONS(3119),
    [anon_sym_BANG] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3121),
    [anon_sym_in] = ACTIONS(3119),
    [anon_sym_SEMI] = ACTIONS(3121),
    [anon_sym_LBRACK] = ACTIONS(3121),
    [anon_sym_LT] = ACTIONS(3119),
    [anon_sym_GT] = ACTIONS(3119),
    [anon_sym_SLASH] = ACTIONS(3119),
    [anon_sym_DOT] = ACTIONS(3119),
    [anon_sym_async] = ACTIONS(3119),
    [anon_sym_QMARK_DOT] = ACTIONS(3121),
    [anon_sym_new] = ACTIONS(3119),
    [anon_sym_AMP_AMP] = ACTIONS(3121),
    [anon_sym_PIPE_PIPE] = ACTIONS(3121),
    [anon_sym_GT_GT] = ACTIONS(3119),
    [anon_sym_GT_GT_GT] = ACTIONS(3121),
    [anon_sym_LT_LT] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3119),
    [anon_sym_CARET] = ACTIONS(3121),
    [anon_sym_PIPE] = ACTIONS(3119),
    [anon_sym_PLUS] = ACTIONS(3119),
    [anon_sym_DASH] = ACTIONS(3119),
    [anon_sym_PERCENT] = ACTIONS(3121),
    [anon_sym_STAR_STAR] = ACTIONS(3121),
    [anon_sym_LT_EQ] = ACTIONS(3121),
    [anon_sym_EQ_EQ] = ACTIONS(3119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3121),
    [anon_sym_BANG_EQ] = ACTIONS(3119),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3121),
    [anon_sym_GT_EQ] = ACTIONS(3121),
    [anon_sym_QMARK_QMARK] = ACTIONS(3121),
    [anon_sym_instanceof] = ACTIONS(3119),
    [anon_sym_void] = ACTIONS(3119),
    [anon_sym_PLUS_PLUS] = ACTIONS(3121),
    [anon_sym_DASH_DASH] = ACTIONS(3121),
    [anon_sym_DQUOTE] = ACTIONS(3121),
    [anon_sym_SQUOTE] = ACTIONS(3121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3121),
    [sym_number] = ACTIONS(3121),
    [sym_this] = ACTIONS(3119),
    [sym_true] = ACTIONS(3119),
    [sym_false] = ACTIONS(3119),
    [sym_null] = ACTIONS(3119),
    [sym_undefined] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(3119),
    [anon_sym_readonly] = ACTIONS(3119),
    [anon_sym_get] = ACTIONS(3119),
    [anon_sym_set] = ACTIONS(3119),
    [anon_sym_QMARK] = ACTIONS(3119),
    [anon_sym_any] = ACTIONS(3119),
    [anon_sym_number] = ACTIONS(3119),
    [anon_sym_boolean] = ACTIONS(3119),
    [anon_sym_string] = ACTIONS(3119),
    [anon_sym_symbol] = ACTIONS(3119),
    [anon_sym_abstract] = ACTIONS(3119),
    [anon_sym_satisfies] = ACTIONS(3119),
    [anon_sym_extends] = ACTIONS(3119),
    [anon_sym_infer] = ACTIONS(3119),
    [anon_sym_keyof] = ACTIONS(3119),
    [anon_sym_unknown] = ACTIONS(3119),
    [anon_sym_never] = ACTIONS(3119),
    [anon_sym_object] = ACTIONS(3119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3121),
    [anon_sym_constructor] = ACTIONS(3119),
    [anon_sym_prop] = ACTIONS(3119),
    [anon_sym_id] = ACTIONS(3119),
    [anon_sym_event] = ACTIONS(3119),
    [anon_sym_fn] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [sym__ternary_qmark] = ACTIONS(3121),
  },
  [884] = {
    [sym_identifier] = ACTIONS(3123),
    [anon_sym_STAR] = ACTIONS(3123),
    [anon_sym_as] = ACTIONS(3123),
    [anon_sym_LBRACE] = ACTIONS(3123),
    [anon_sym_RBRACE] = ACTIONS(3125),
    [anon_sym_typeof] = ACTIONS(3123),
    [anon_sym_BANG] = ACTIONS(3123),
    [anon_sym_LPAREN] = ACTIONS(3125),
    [anon_sym_in] = ACTIONS(3123),
    [anon_sym_SEMI] = ACTIONS(3125),
    [anon_sym_LBRACK] = ACTIONS(3125),
    [anon_sym_LT] = ACTIONS(3123),
    [anon_sym_GT] = ACTIONS(3123),
    [anon_sym_SLASH] = ACTIONS(3123),
    [anon_sym_DOT] = ACTIONS(3123),
    [anon_sym_async] = ACTIONS(3123),
    [anon_sym_QMARK_DOT] = ACTIONS(3125),
    [anon_sym_new] = ACTIONS(3123),
    [anon_sym_AMP_AMP] = ACTIONS(3125),
    [anon_sym_PIPE_PIPE] = ACTIONS(3125),
    [anon_sym_GT_GT] = ACTIONS(3123),
    [anon_sym_GT_GT_GT] = ACTIONS(3125),
    [anon_sym_LT_LT] = ACTIONS(3125),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_CARET] = ACTIONS(3125),
    [anon_sym_PIPE] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_PERCENT] = ACTIONS(3125),
    [anon_sym_STAR_STAR] = ACTIONS(3125),
    [anon_sym_LT_EQ] = ACTIONS(3125),
    [anon_sym_EQ_EQ] = ACTIONS(3123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3125),
    [anon_sym_BANG_EQ] = ACTIONS(3123),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3125),
    [anon_sym_GT_EQ] = ACTIONS(3125),
    [anon_sym_QMARK_QMARK] = ACTIONS(3125),
    [anon_sym_instanceof] = ACTIONS(3123),
    [anon_sym_void] = ACTIONS(3123),
    [anon_sym_PLUS_PLUS] = ACTIONS(3125),
    [anon_sym_DASH_DASH] = ACTIONS(3125),
    [anon_sym_DQUOTE] = ACTIONS(3125),
    [anon_sym_SQUOTE] = ACTIONS(3125),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3125),
    [sym_number] = ACTIONS(3125),
    [sym_this] = ACTIONS(3123),
    [sym_true] = ACTIONS(3123),
    [sym_false] = ACTIONS(3123),
    [sym_null] = ACTIONS(3123),
    [sym_undefined] = ACTIONS(3123),
    [anon_sym_static] = ACTIONS(3123),
    [anon_sym_readonly] = ACTIONS(3123),
    [anon_sym_get] = ACTIONS(3123),
    [anon_sym_set] = ACTIONS(3123),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_any] = ACTIONS(3123),
    [anon_sym_number] = ACTIONS(3123),
    [anon_sym_boolean] = ACTIONS(3123),
    [anon_sym_string] = ACTIONS(3123),
    [anon_sym_symbol] = ACTIONS(3123),
    [anon_sym_abstract] = ACTIONS(3123),
    [anon_sym_satisfies] = ACTIONS(3123),
    [anon_sym_extends] = ACTIONS(3123),
    [anon_sym_infer] = ACTIONS(3123),
    [anon_sym_keyof] = ACTIONS(3123),
    [anon_sym_unknown] = ACTIONS(3123),
    [anon_sym_never] = ACTIONS(3123),
    [anon_sym_object] = ACTIONS(3123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3125),
    [anon_sym_constructor] = ACTIONS(3123),
    [anon_sym_prop] = ACTIONS(3123),
    [anon_sym_id] = ACTIONS(3123),
    [anon_sym_event] = ACTIONS(3123),
    [anon_sym_fn] = ACTIONS(3123),
    [anon_sym_on] = ACTIONS(3123),
    [sym__ternary_qmark] = ACTIONS(3125),
  },
  [885] = {
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_STAR] = ACTIONS(3127),
    [anon_sym_as] = ACTIONS(3127),
    [anon_sym_LBRACE] = ACTIONS(3127),
    [anon_sym_RBRACE] = ACTIONS(3129),
    [anon_sym_typeof] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3127),
    [anon_sym_LPAREN] = ACTIONS(3129),
    [anon_sym_in] = ACTIONS(3127),
    [anon_sym_SEMI] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_DOT] = ACTIONS(3127),
    [anon_sym_async] = ACTIONS(3127),
    [anon_sym_QMARK_DOT] = ACTIONS(3129),
    [anon_sym_new] = ACTIONS(3127),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3127),
    [anon_sym_CARET] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PLUS] = ACTIONS(3127),
    [anon_sym_DASH] = ACTIONS(3127),
    [anon_sym_PERCENT] = ACTIONS(3129),
    [anon_sym_STAR_STAR] = ACTIONS(3129),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_EQ_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3129),
    [anon_sym_BANG_EQ] = ACTIONS(3127),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3129),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_QMARK_QMARK] = ACTIONS(3129),
    [anon_sym_instanceof] = ACTIONS(3127),
    [anon_sym_void] = ACTIONS(3127),
    [anon_sym_PLUS_PLUS] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3129),
    [anon_sym_DQUOTE] = ACTIONS(3129),
    [anon_sym_SQUOTE] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3129),
    [sym_number] = ACTIONS(3129),
    [sym_this] = ACTIONS(3127),
    [sym_true] = ACTIONS(3127),
    [sym_false] = ACTIONS(3127),
    [sym_null] = ACTIONS(3127),
    [sym_undefined] = ACTIONS(3127),
    [anon_sym_static] = ACTIONS(3127),
    [anon_sym_readonly] = ACTIONS(3127),
    [anon_sym_get] = ACTIONS(3127),
    [anon_sym_set] = ACTIONS(3127),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_any] = ACTIONS(3127),
    [anon_sym_number] = ACTIONS(3127),
    [anon_sym_boolean] = ACTIONS(3127),
    [anon_sym_string] = ACTIONS(3127),
    [anon_sym_symbol] = ACTIONS(3127),
    [anon_sym_abstract] = ACTIONS(3127),
    [anon_sym_satisfies] = ACTIONS(3127),
    [anon_sym_extends] = ACTIONS(3127),
    [anon_sym_infer] = ACTIONS(3127),
    [anon_sym_keyof] = ACTIONS(3127),
    [anon_sym_unknown] = ACTIONS(3127),
    [anon_sym_never] = ACTIONS(3127),
    [anon_sym_object] = ACTIONS(3127),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3129),
    [anon_sym_constructor] = ACTIONS(3127),
    [anon_sym_prop] = ACTIONS(3127),
    [anon_sym_id] = ACTIONS(3127),
    [anon_sym_event] = ACTIONS(3127),
    [anon_sym_fn] = ACTIONS(3127),
    [anon_sym_on] = ACTIONS(3127),
    [sym__ternary_qmark] = ACTIONS(3129),
  },
  [886] = {
    [sym_identifier] = ACTIONS(3131),
    [anon_sym_STAR] = ACTIONS(3131),
    [anon_sym_as] = ACTIONS(3131),
    [anon_sym_LBRACE] = ACTIONS(3131),
    [anon_sym_RBRACE] = ACTIONS(3133),
    [anon_sym_typeof] = ACTIONS(3131),
    [anon_sym_BANG] = ACTIONS(3131),
    [anon_sym_LPAREN] = ACTIONS(3133),
    [anon_sym_in] = ACTIONS(3131),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym_LBRACK] = ACTIONS(3133),
    [anon_sym_LT] = ACTIONS(3131),
    [anon_sym_GT] = ACTIONS(3131),
    [anon_sym_SLASH] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(3131),
    [anon_sym_async] = ACTIONS(3131),
    [anon_sym_QMARK_DOT] = ACTIONS(3133),
    [anon_sym_new] = ACTIONS(3131),
    [anon_sym_AMP_AMP] = ACTIONS(3133),
    [anon_sym_PIPE_PIPE] = ACTIONS(3133),
    [anon_sym_GT_GT] = ACTIONS(3131),
    [anon_sym_GT_GT_GT] = ACTIONS(3133),
    [anon_sym_LT_LT] = ACTIONS(3133),
    [anon_sym_AMP] = ACTIONS(3110),
    [anon_sym_CARET] = ACTIONS(3133),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_PLUS] = ACTIONS(3131),
    [anon_sym_DASH] = ACTIONS(3131),
    [anon_sym_PERCENT] = ACTIONS(3133),
    [anon_sym_STAR_STAR] = ACTIONS(3133),
    [anon_sym_LT_EQ] = ACTIONS(3133),
    [anon_sym_EQ_EQ] = ACTIONS(3131),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3133),
    [anon_sym_BANG_EQ] = ACTIONS(3131),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3133),
    [anon_sym_GT_EQ] = ACTIONS(3133),
    [anon_sym_QMARK_QMARK] = ACTIONS(3133),
    [anon_sym_instanceof] = ACTIONS(3131),
    [anon_sym_void] = ACTIONS(3131),
    [anon_sym_PLUS_PLUS] = ACTIONS(3133),
    [anon_sym_DASH_DASH] = ACTIONS(3133),
    [anon_sym_DQUOTE] = ACTIONS(3133),
    [anon_sym_SQUOTE] = ACTIONS(3133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3133),
    [sym_number] = ACTIONS(3133),
    [sym_this] = ACTIONS(3131),
    [sym_true] = ACTIONS(3131),
    [sym_false] = ACTIONS(3131),
    [sym_null] = ACTIONS(3131),
    [sym_undefined] = ACTIONS(3131),
    [anon_sym_static] = ACTIONS(3131),
    [anon_sym_readonly] = ACTIONS(3131),
    [anon_sym_get] = ACTIONS(3131),
    [anon_sym_set] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3131),
    [anon_sym_any] = ACTIONS(3131),
    [anon_sym_number] = ACTIONS(3131),
    [anon_sym_boolean] = ACTIONS(3131),
    [anon_sym_string] = ACTIONS(3131),
    [anon_sym_symbol] = ACTIONS(3131),
    [anon_sym_abstract] = ACTIONS(3131),
    [anon_sym_satisfies] = ACTIONS(3131),
    [anon_sym_extends] = ACTIONS(3131),
    [anon_sym_infer] = ACTIONS(3131),
    [anon_sym_keyof] = ACTIONS(3131),
    [anon_sym_unknown] = ACTIONS(3131),
    [anon_sym_never] = ACTIONS(3131),
    [anon_sym_object] = ACTIONS(3131),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3133),
    [anon_sym_constructor] = ACTIONS(3131),
    [anon_sym_prop] = ACTIONS(3131),
    [anon_sym_id] = ACTIONS(3131),
    [anon_sym_event] = ACTIONS(3131),
    [anon_sym_fn] = ACTIONS(3131),
    [anon_sym_on] = ACTIONS(3131),
    [sym__ternary_qmark] = ACTIONS(3133),
  },
  [887] = {
    [sym_identifier] = ACTIONS(3137),
    [anon_sym_STAR] = ACTIONS(3137),
    [anon_sym_as] = ACTIONS(3137),
    [anon_sym_LBRACE] = ACTIONS(3137),
    [anon_sym_RBRACE] = ACTIONS(3139),
    [anon_sym_typeof] = ACTIONS(3137),
    [anon_sym_BANG] = ACTIONS(3137),
    [anon_sym_LPAREN] = ACTIONS(3139),
    [anon_sym_in] = ACTIONS(3137),
    [anon_sym_SEMI] = ACTIONS(3139),
    [anon_sym_LBRACK] = ACTIONS(3139),
    [anon_sym_LT] = ACTIONS(3137),
    [anon_sym_GT] = ACTIONS(3137),
    [anon_sym_SLASH] = ACTIONS(3137),
    [anon_sym_DOT] = ACTIONS(3137),
    [anon_sym_async] = ACTIONS(3137),
    [anon_sym_QMARK_DOT] = ACTIONS(3139),
    [anon_sym_new] = ACTIONS(3137),
    [anon_sym_AMP_AMP] = ACTIONS(3139),
    [anon_sym_PIPE_PIPE] = ACTIONS(3139),
    [anon_sym_GT_GT] = ACTIONS(3137),
    [anon_sym_GT_GT_GT] = ACTIONS(3139),
    [anon_sym_LT_LT] = ACTIONS(3139),
    [anon_sym_AMP] = ACTIONS(3137),
    [anon_sym_CARET] = ACTIONS(3139),
    [anon_sym_PIPE] = ACTIONS(3137),
    [anon_sym_PLUS] = ACTIONS(3137),
    [anon_sym_DASH] = ACTIONS(3137),
    [anon_sym_PERCENT] = ACTIONS(3139),
    [anon_sym_STAR_STAR] = ACTIONS(3139),
    [anon_sym_LT_EQ] = ACTIONS(3139),
    [anon_sym_EQ_EQ] = ACTIONS(3137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3139),
    [anon_sym_BANG_EQ] = ACTIONS(3137),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3139),
    [anon_sym_GT_EQ] = ACTIONS(3139),
    [anon_sym_QMARK_QMARK] = ACTIONS(3139),
    [anon_sym_instanceof] = ACTIONS(3137),
    [anon_sym_void] = ACTIONS(3137),
    [anon_sym_PLUS_PLUS] = ACTIONS(3139),
    [anon_sym_DASH_DASH] = ACTIONS(3139),
    [anon_sym_DQUOTE] = ACTIONS(3139),
    [anon_sym_SQUOTE] = ACTIONS(3139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3139),
    [sym_number] = ACTIONS(3139),
    [sym_this] = ACTIONS(3137),
    [sym_true] = ACTIONS(3137),
    [sym_false] = ACTIONS(3137),
    [sym_null] = ACTIONS(3137),
    [sym_undefined] = ACTIONS(3137),
    [anon_sym_static] = ACTIONS(3137),
    [anon_sym_readonly] = ACTIONS(3137),
    [anon_sym_get] = ACTIONS(3137),
    [anon_sym_set] = ACTIONS(3137),
    [anon_sym_QMARK] = ACTIONS(3137),
    [anon_sym_any] = ACTIONS(3137),
    [anon_sym_number] = ACTIONS(3137),
    [anon_sym_boolean] = ACTIONS(3137),
    [anon_sym_string] = ACTIONS(3137),
    [anon_sym_symbol] = ACTIONS(3137),
    [anon_sym_abstract] = ACTIONS(3137),
    [anon_sym_satisfies] = ACTIONS(3137),
    [anon_sym_extends] = ACTIONS(3137),
    [anon_sym_infer] = ACTIONS(3137),
    [anon_sym_keyof] = ACTIONS(3137),
    [anon_sym_unknown] = ACTIONS(3137),
    [anon_sym_never] = ACTIONS(3137),
    [anon_sym_object] = ACTIONS(3137),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3139),
    [anon_sym_constructor] = ACTIONS(3137),
    [anon_sym_prop] = ACTIONS(3137),
    [anon_sym_id] = ACTIONS(3137),
    [anon_sym_event] = ACTIONS(3137),
    [anon_sym_fn] = ACTIONS(3137),
    [anon_sym_on] = ACTIONS(3137),
    [sym__ternary_qmark] = ACTIONS(3139),
  },
  [888] = {
    [sym_identifier] = ACTIONS(2904),
    [anon_sym_STAR] = ACTIONS(2904),
    [anon_sym_as] = ACTIONS(2904),
    [anon_sym_LBRACE] = ACTIONS(2904),
    [anon_sym_RBRACE] = ACTIONS(2906),
    [anon_sym_typeof] = ACTIONS(2904),
    [anon_sym_BANG] = ACTIONS(2904),
    [anon_sym_LPAREN] = ACTIONS(2906),
    [anon_sym_in] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(2906),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_LT] = ACTIONS(2904),
    [anon_sym_GT] = ACTIONS(2904),
    [anon_sym_SLASH] = ACTIONS(2904),
    [anon_sym_DOT] = ACTIONS(2904),
    [anon_sym_async] = ACTIONS(2904),
    [anon_sym_QMARK_DOT] = ACTIONS(2906),
    [anon_sym_new] = ACTIONS(2904),
    [anon_sym_AMP_AMP] = ACTIONS(2906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2906),
    [anon_sym_GT_GT] = ACTIONS(2904),
    [anon_sym_GT_GT_GT] = ACTIONS(2906),
    [anon_sym_LT_LT] = ACTIONS(2906),
    [anon_sym_AMP] = ACTIONS(2904),
    [anon_sym_CARET] = ACTIONS(2906),
    [anon_sym_PIPE] = ACTIONS(2904),
    [anon_sym_PLUS] = ACTIONS(2904),
    [anon_sym_DASH] = ACTIONS(2904),
    [anon_sym_PERCENT] = ACTIONS(2906),
    [anon_sym_STAR_STAR] = ACTIONS(2906),
    [anon_sym_LT_EQ] = ACTIONS(2906),
    [anon_sym_EQ_EQ] = ACTIONS(2904),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2906),
    [anon_sym_BANG_EQ] = ACTIONS(2904),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2906),
    [anon_sym_GT_EQ] = ACTIONS(2906),
    [anon_sym_QMARK_QMARK] = ACTIONS(2906),
    [anon_sym_instanceof] = ACTIONS(2904),
    [anon_sym_void] = ACTIONS(2904),
    [anon_sym_PLUS_PLUS] = ACTIONS(2906),
    [anon_sym_DASH_DASH] = ACTIONS(2906),
    [anon_sym_DQUOTE] = ACTIONS(2906),
    [anon_sym_SQUOTE] = ACTIONS(2906),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2906),
    [sym_number] = ACTIONS(2906),
    [sym_this] = ACTIONS(2904),
    [sym_true] = ACTIONS(2904),
    [sym_false] = ACTIONS(2904),
    [sym_null] = ACTIONS(2904),
    [sym_undefined] = ACTIONS(2904),
    [anon_sym_static] = ACTIONS(2904),
    [anon_sym_readonly] = ACTIONS(2904),
    [anon_sym_get] = ACTIONS(2904),
    [anon_sym_set] = ACTIONS(2904),
    [anon_sym_QMARK] = ACTIONS(2904),
    [anon_sym_any] = ACTIONS(2904),
    [anon_sym_number] = ACTIONS(2904),
    [anon_sym_boolean] = ACTIONS(2904),
    [anon_sym_string] = ACTIONS(2904),
    [anon_sym_symbol] = ACTIONS(2904),
    [anon_sym_abstract] = ACTIONS(2904),
    [anon_sym_satisfies] = ACTIONS(2904),
    [anon_sym_extends] = ACTIONS(2904),
    [anon_sym_infer] = ACTIONS(2904),
    [anon_sym_keyof] = ACTIONS(2904),
    [anon_sym_unknown] = ACTIONS(2904),
    [anon_sym_never] = ACTIONS(2904),
    [anon_sym_object] = ACTIONS(2904),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2906),
    [anon_sym_constructor] = ACTIONS(2904),
    [anon_sym_prop] = ACTIONS(2904),
    [anon_sym_id] = ACTIONS(2904),
    [anon_sym_event] = ACTIONS(2904),
    [anon_sym_fn] = ACTIONS(2904),
    [anon_sym_on] = ACTIONS(2904),
    [sym__ternary_qmark] = ACTIONS(2906),
  },
  [889] = {
    [sym_arguments] = STATE(988),
    [sym_identifier] = ACTIONS(3141),
    [anon_sym_STAR] = ACTIONS(3141),
    [anon_sym_as] = ACTIONS(3141),
    [anon_sym_LBRACE] = ACTIONS(3141),
    [anon_sym_RBRACE] = ACTIONS(3143),
    [anon_sym_typeof] = ACTIONS(3141),
    [anon_sym_BANG] = ACTIONS(3141),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3141),
    [anon_sym_SEMI] = ACTIONS(3143),
    [anon_sym_LBRACK] = ACTIONS(3143),
    [anon_sym_LT] = ACTIONS(3141),
    [anon_sym_GT] = ACTIONS(3141),
    [anon_sym_SLASH] = ACTIONS(3141),
    [anon_sym_DOT] = ACTIONS(3141),
    [anon_sym_async] = ACTIONS(3141),
    [anon_sym_QMARK_DOT] = ACTIONS(3143),
    [anon_sym_new] = ACTIONS(3141),
    [anon_sym_AMP_AMP] = ACTIONS(3143),
    [anon_sym_PIPE_PIPE] = ACTIONS(3143),
    [anon_sym_GT_GT] = ACTIONS(3141),
    [anon_sym_GT_GT_GT] = ACTIONS(3143),
    [anon_sym_LT_LT] = ACTIONS(3143),
    [anon_sym_AMP] = ACTIONS(3141),
    [anon_sym_CARET] = ACTIONS(3143),
    [anon_sym_PIPE] = ACTIONS(3141),
    [anon_sym_PLUS] = ACTIONS(3141),
    [anon_sym_DASH] = ACTIONS(3141),
    [anon_sym_PERCENT] = ACTIONS(3143),
    [anon_sym_STAR_STAR] = ACTIONS(3143),
    [anon_sym_LT_EQ] = ACTIONS(3143),
    [anon_sym_EQ_EQ] = ACTIONS(3141),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3143),
    [anon_sym_BANG_EQ] = ACTIONS(3141),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3143),
    [anon_sym_GT_EQ] = ACTIONS(3143),
    [anon_sym_QMARK_QMARK] = ACTIONS(3143),
    [anon_sym_instanceof] = ACTIONS(3141),
    [anon_sym_void] = ACTIONS(3141),
    [anon_sym_PLUS_PLUS] = ACTIONS(3143),
    [anon_sym_DASH_DASH] = ACTIONS(3143),
    [anon_sym_DQUOTE] = ACTIONS(3143),
    [anon_sym_SQUOTE] = ACTIONS(3143),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3143),
    [sym_number] = ACTIONS(3143),
    [sym_this] = ACTIONS(3141),
    [sym_true] = ACTIONS(3141),
    [sym_false] = ACTIONS(3141),
    [sym_null] = ACTIONS(3141),
    [sym_undefined] = ACTIONS(3141),
    [anon_sym_static] = ACTIONS(3141),
    [anon_sym_readonly] = ACTIONS(3141),
    [anon_sym_get] = ACTIONS(3141),
    [anon_sym_set] = ACTIONS(3141),
    [anon_sym_QMARK] = ACTIONS(3141),
    [anon_sym_any] = ACTIONS(3141),
    [anon_sym_number] = ACTIONS(3141),
    [anon_sym_boolean] = ACTIONS(3141),
    [anon_sym_string] = ACTIONS(3141),
    [anon_sym_symbol] = ACTIONS(3141),
    [anon_sym_abstract] = ACTIONS(3141),
    [anon_sym_satisfies] = ACTIONS(3141),
    [anon_sym_infer] = ACTIONS(3141),
    [anon_sym_keyof] = ACTIONS(3141),
    [anon_sym_unknown] = ACTIONS(3141),
    [anon_sym_never] = ACTIONS(3141),
    [anon_sym_object] = ACTIONS(3141),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3143),
    [anon_sym_constructor] = ACTIONS(3141),
    [anon_sym_prop] = ACTIONS(3141),
    [anon_sym_id] = ACTIONS(3141),
    [anon_sym_event] = ACTIONS(3141),
    [anon_sym_fn] = ACTIONS(3141),
    [anon_sym_on] = ACTIONS(3141),
    [sym__ternary_qmark] = ACTIONS(3143),
  },
  [890] = {
    [sym_identifier] = ACTIONS(3148),
    [anon_sym_STAR] = ACTIONS(3148),
    [anon_sym_as] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_RBRACE] = ACTIONS(3150),
    [anon_sym_typeof] = ACTIONS(3148),
    [anon_sym_BANG] = ACTIONS(3148),
    [anon_sym_LPAREN] = ACTIONS(3150),
    [anon_sym_in] = ACTIONS(3148),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_LT] = ACTIONS(3148),
    [anon_sym_GT] = ACTIONS(3148),
    [anon_sym_SLASH] = ACTIONS(3148),
    [anon_sym_DOT] = ACTIONS(3148),
    [anon_sym_async] = ACTIONS(3148),
    [anon_sym_QMARK_DOT] = ACTIONS(3150),
    [anon_sym_new] = ACTIONS(3148),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_PIPE_PIPE] = ACTIONS(3150),
    [anon_sym_GT_GT] = ACTIONS(3148),
    [anon_sym_GT_GT_GT] = ACTIONS(3150),
    [anon_sym_LT_LT] = ACTIONS(3150),
    [anon_sym_AMP] = ACTIONS(3148),
    [anon_sym_CARET] = ACTIONS(3150),
    [anon_sym_PIPE] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3148),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_PERCENT] = ACTIONS(3150),
    [anon_sym_STAR_STAR] = ACTIONS(3150),
    [anon_sym_LT_EQ] = ACTIONS(3150),
    [anon_sym_EQ_EQ] = ACTIONS(3148),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3150),
    [anon_sym_BANG_EQ] = ACTIONS(3148),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3150),
    [anon_sym_GT_EQ] = ACTIONS(3150),
    [anon_sym_QMARK_QMARK] = ACTIONS(3150),
    [anon_sym_instanceof] = ACTIONS(3148),
    [anon_sym_void] = ACTIONS(3148),
    [anon_sym_PLUS_PLUS] = ACTIONS(3150),
    [anon_sym_DASH_DASH] = ACTIONS(3150),
    [anon_sym_DQUOTE] = ACTIONS(3150),
    [anon_sym_SQUOTE] = ACTIONS(3150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3150),
    [sym_number] = ACTIONS(3150),
    [sym_this] = ACTIONS(3148),
    [sym_true] = ACTIONS(3148),
    [sym_false] = ACTIONS(3148),
    [sym_null] = ACTIONS(3148),
    [sym_undefined] = ACTIONS(3148),
    [anon_sym_static] = ACTIONS(3148),
    [anon_sym_readonly] = ACTIONS(3148),
    [anon_sym_get] = ACTIONS(3148),
    [anon_sym_set] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(3148),
    [anon_sym_any] = ACTIONS(3148),
    [anon_sym_number] = ACTIONS(3148),
    [anon_sym_boolean] = ACTIONS(3148),
    [anon_sym_string] = ACTIONS(3148),
    [anon_sym_symbol] = ACTIONS(3148),
    [anon_sym_abstract] = ACTIONS(3148),
    [anon_sym_satisfies] = ACTIONS(3148),
    [anon_sym_extends] = ACTIONS(3148),
    [anon_sym_infer] = ACTIONS(3148),
    [anon_sym_keyof] = ACTIONS(3148),
    [anon_sym_unknown] = ACTIONS(3148),
    [anon_sym_never] = ACTIONS(3148),
    [anon_sym_object] = ACTIONS(3148),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3150),
    [anon_sym_constructor] = ACTIONS(3148),
    [anon_sym_prop] = ACTIONS(3148),
    [anon_sym_id] = ACTIONS(3148),
    [anon_sym_event] = ACTIONS(3148),
    [anon_sym_fn] = ACTIONS(3148),
    [anon_sym_on] = ACTIONS(3148),
    [sym__ternary_qmark] = ACTIONS(3150),
  },
  [891] = {
    [sym_identifier] = ACTIONS(2852),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_as] = ACTIONS(2852),
    [anon_sym_LBRACE] = ACTIONS(2852),
    [anon_sym_RBRACE] = ACTIONS(2854),
    [anon_sym_typeof] = ACTIONS(2852),
    [anon_sym_BANG] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2854),
    [anon_sym_in] = ACTIONS(2852),
    [anon_sym_SEMI] = ACTIONS(2854),
    [anon_sym_LBRACK] = ACTIONS(2854),
    [anon_sym_LT] = ACTIONS(2852),
    [anon_sym_GT] = ACTIONS(2852),
    [anon_sym_SLASH] = ACTIONS(2852),
    [anon_sym_DOT] = ACTIONS(2852),
    [anon_sym_async] = ACTIONS(2852),
    [anon_sym_QMARK_DOT] = ACTIONS(2854),
    [anon_sym_new] = ACTIONS(2852),
    [anon_sym_AMP_AMP] = ACTIONS(2854),
    [anon_sym_PIPE_PIPE] = ACTIONS(2854),
    [anon_sym_GT_GT] = ACTIONS(2852),
    [anon_sym_GT_GT_GT] = ACTIONS(2854),
    [anon_sym_LT_LT] = ACTIONS(2854),
    [anon_sym_AMP] = ACTIONS(2852),
    [anon_sym_CARET] = ACTIONS(2854),
    [anon_sym_PIPE] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2852),
    [anon_sym_PERCENT] = ACTIONS(2854),
    [anon_sym_STAR_STAR] = ACTIONS(2854),
    [anon_sym_LT_EQ] = ACTIONS(2854),
    [anon_sym_EQ_EQ] = ACTIONS(2852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2854),
    [anon_sym_BANG_EQ] = ACTIONS(2852),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2854),
    [anon_sym_GT_EQ] = ACTIONS(2854),
    [anon_sym_QMARK_QMARK] = ACTIONS(2854),
    [anon_sym_instanceof] = ACTIONS(2852),
    [anon_sym_void] = ACTIONS(2852),
    [anon_sym_PLUS_PLUS] = ACTIONS(2854),
    [anon_sym_DASH_DASH] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2854),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2854),
    [sym_number] = ACTIONS(2854),
    [sym_this] = ACTIONS(2852),
    [sym_true] = ACTIONS(2852),
    [sym_false] = ACTIONS(2852),
    [sym_null] = ACTIONS(2852),
    [sym_undefined] = ACTIONS(2852),
    [anon_sym_static] = ACTIONS(2852),
    [anon_sym_readonly] = ACTIONS(2852),
    [anon_sym_get] = ACTIONS(2852),
    [anon_sym_set] = ACTIONS(2852),
    [anon_sym_QMARK] = ACTIONS(2852),
    [anon_sym_any] = ACTIONS(2852),
    [anon_sym_number] = ACTIONS(2852),
    [anon_sym_boolean] = ACTIONS(2852),
    [anon_sym_string] = ACTIONS(2852),
    [anon_sym_symbol] = ACTIONS(2852),
    [anon_sym_abstract] = ACTIONS(2852),
    [anon_sym_satisfies] = ACTIONS(2852),
    [anon_sym_extends] = ACTIONS(2852),
    [anon_sym_infer] = ACTIONS(2852),
    [anon_sym_keyof] = ACTIONS(2852),
    [anon_sym_unknown] = ACTIONS(2852),
    [anon_sym_never] = ACTIONS(2852),
    [anon_sym_object] = ACTIONS(2852),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2854),
    [anon_sym_constructor] = ACTIONS(2852),
    [anon_sym_prop] = ACTIONS(2852),
    [anon_sym_id] = ACTIONS(2852),
    [anon_sym_event] = ACTIONS(2852),
    [anon_sym_fn] = ACTIONS(2852),
    [anon_sym_on] = ACTIONS(2852),
    [sym__ternary_qmark] = ACTIONS(2854),
  },
  [892] = {
    [sym_identifier] = ACTIONS(3152),
    [anon_sym_STAR] = ACTIONS(3152),
    [anon_sym_as] = ACTIONS(3152),
    [anon_sym_LBRACE] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(3154),
    [anon_sym_typeof] = ACTIONS(3152),
    [anon_sym_BANG] = ACTIONS(3152),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_in] = ACTIONS(3152),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_LT] = ACTIONS(3152),
    [anon_sym_GT] = ACTIONS(3152),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_DOT] = ACTIONS(3152),
    [anon_sym_async] = ACTIONS(3152),
    [anon_sym_QMARK_DOT] = ACTIONS(3154),
    [anon_sym_new] = ACTIONS(3152),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_PIPE_PIPE] = ACTIONS(3154),
    [anon_sym_GT_GT] = ACTIONS(3152),
    [anon_sym_GT_GT_GT] = ACTIONS(3154),
    [anon_sym_LT_LT] = ACTIONS(3154),
    [anon_sym_AMP] = ACTIONS(3152),
    [anon_sym_CARET] = ACTIONS(3154),
    [anon_sym_PIPE] = ACTIONS(3152),
    [anon_sym_PLUS] = ACTIONS(3152),
    [anon_sym_DASH] = ACTIONS(3152),
    [anon_sym_PERCENT] = ACTIONS(3154),
    [anon_sym_STAR_STAR] = ACTIONS(3154),
    [anon_sym_LT_EQ] = ACTIONS(3154),
    [anon_sym_EQ_EQ] = ACTIONS(3152),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3154),
    [anon_sym_BANG_EQ] = ACTIONS(3152),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3154),
    [anon_sym_GT_EQ] = ACTIONS(3154),
    [anon_sym_QMARK_QMARK] = ACTIONS(3154),
    [anon_sym_instanceof] = ACTIONS(3152),
    [anon_sym_void] = ACTIONS(3152),
    [anon_sym_PLUS_PLUS] = ACTIONS(3154),
    [anon_sym_DASH_DASH] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_SQUOTE] = ACTIONS(3154),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3154),
    [sym_number] = ACTIONS(3154),
    [sym_this] = ACTIONS(3152),
    [sym_true] = ACTIONS(3152),
    [sym_false] = ACTIONS(3152),
    [sym_null] = ACTIONS(3152),
    [sym_undefined] = ACTIONS(3152),
    [anon_sym_static] = ACTIONS(3152),
    [anon_sym_readonly] = ACTIONS(3152),
    [anon_sym_get] = ACTIONS(3152),
    [anon_sym_set] = ACTIONS(3152),
    [anon_sym_QMARK] = ACTIONS(3152),
    [anon_sym_any] = ACTIONS(3152),
    [anon_sym_number] = ACTIONS(3152),
    [anon_sym_boolean] = ACTIONS(3152),
    [anon_sym_string] = ACTIONS(3152),
    [anon_sym_symbol] = ACTIONS(3152),
    [anon_sym_abstract] = ACTIONS(3152),
    [anon_sym_satisfies] = ACTIONS(3152),
    [anon_sym_extends] = ACTIONS(3152),
    [anon_sym_infer] = ACTIONS(3152),
    [anon_sym_keyof] = ACTIONS(3152),
    [anon_sym_unknown] = ACTIONS(3152),
    [anon_sym_never] = ACTIONS(3152),
    [anon_sym_object] = ACTIONS(3152),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3154),
    [anon_sym_constructor] = ACTIONS(3152),
    [anon_sym_prop] = ACTIONS(3152),
    [anon_sym_id] = ACTIONS(3152),
    [anon_sym_event] = ACTIONS(3152),
    [anon_sym_fn] = ACTIONS(3152),
    [anon_sym_on] = ACTIONS(3152),
    [sym__ternary_qmark] = ACTIONS(3154),
  },
  [893] = {
    [sym_identifier] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3156),
    [anon_sym_as] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3156),
    [anon_sym_RBRACE] = ACTIONS(3158),
    [anon_sym_typeof] = ACTIONS(3156),
    [anon_sym_BANG] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3158),
    [anon_sym_in] = ACTIONS(3156),
    [anon_sym_SEMI] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_GT] = ACTIONS(3156),
    [anon_sym_SLASH] = ACTIONS(3156),
    [anon_sym_DOT] = ACTIONS(3156),
    [anon_sym_async] = ACTIONS(3156),
    [anon_sym_QMARK_DOT] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3156),
    [anon_sym_AMP_AMP] = ACTIONS(3158),
    [anon_sym_PIPE_PIPE] = ACTIONS(3158),
    [anon_sym_GT_GT] = ACTIONS(3156),
    [anon_sym_GT_GT_GT] = ACTIONS(3158),
    [anon_sym_LT_LT] = ACTIONS(3158),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_CARET] = ACTIONS(3158),
    [anon_sym_PIPE] = ACTIONS(3156),
    [anon_sym_PLUS] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3156),
    [anon_sym_PERCENT] = ACTIONS(3158),
    [anon_sym_STAR_STAR] = ACTIONS(3158),
    [anon_sym_LT_EQ] = ACTIONS(3158),
    [anon_sym_EQ_EQ] = ACTIONS(3156),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3158),
    [anon_sym_BANG_EQ] = ACTIONS(3156),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3158),
    [anon_sym_GT_EQ] = ACTIONS(3158),
    [anon_sym_QMARK_QMARK] = ACTIONS(3158),
    [anon_sym_instanceof] = ACTIONS(3156),
    [anon_sym_void] = ACTIONS(3156),
    [anon_sym_PLUS_PLUS] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3158),
    [anon_sym_SQUOTE] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3158),
    [sym_number] = ACTIONS(3158),
    [sym_this] = ACTIONS(3156),
    [sym_true] = ACTIONS(3156),
    [sym_false] = ACTIONS(3156),
    [sym_null] = ACTIONS(3156),
    [sym_undefined] = ACTIONS(3156),
    [anon_sym_static] = ACTIONS(3156),
    [anon_sym_readonly] = ACTIONS(3156),
    [anon_sym_get] = ACTIONS(3156),
    [anon_sym_set] = ACTIONS(3156),
    [anon_sym_QMARK] = ACTIONS(3156),
    [anon_sym_any] = ACTIONS(3156),
    [anon_sym_number] = ACTIONS(3156),
    [anon_sym_boolean] = ACTIONS(3156),
    [anon_sym_string] = ACTIONS(3156),
    [anon_sym_symbol] = ACTIONS(3156),
    [anon_sym_abstract] = ACTIONS(3156),
    [anon_sym_satisfies] = ACTIONS(3156),
    [anon_sym_extends] = ACTIONS(3156),
    [anon_sym_infer] = ACTIONS(3156),
    [anon_sym_keyof] = ACTIONS(3156),
    [anon_sym_unknown] = ACTIONS(3156),
    [anon_sym_never] = ACTIONS(3156),
    [anon_sym_object] = ACTIONS(3156),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3158),
    [anon_sym_constructor] = ACTIONS(3156),
    [anon_sym_prop] = ACTIONS(3156),
    [anon_sym_id] = ACTIONS(3156),
    [anon_sym_event] = ACTIONS(3156),
    [anon_sym_fn] = ACTIONS(3156),
    [anon_sym_on] = ACTIONS(3156),
    [sym__ternary_qmark] = ACTIONS(3158),
  },
  [894] = {
    [sym_identifier] = ACTIONS(3137),
    [anon_sym_STAR] = ACTIONS(3137),
    [anon_sym_as] = ACTIONS(3137),
    [anon_sym_LBRACE] = ACTIONS(3137),
    [anon_sym_RBRACE] = ACTIONS(3139),
    [anon_sym_typeof] = ACTIONS(3137),
    [anon_sym_BANG] = ACTIONS(3137),
    [anon_sym_LPAREN] = ACTIONS(3139),
    [anon_sym_in] = ACTIONS(3137),
    [anon_sym_SEMI] = ACTIONS(3139),
    [anon_sym_LBRACK] = ACTIONS(3139),
    [anon_sym_LT] = ACTIONS(3137),
    [anon_sym_GT] = ACTIONS(3137),
    [anon_sym_SLASH] = ACTIONS(3137),
    [anon_sym_DOT] = ACTIONS(3137),
    [anon_sym_async] = ACTIONS(3137),
    [anon_sym_QMARK_DOT] = ACTIONS(3139),
    [anon_sym_new] = ACTIONS(3137),
    [anon_sym_AMP_AMP] = ACTIONS(3139),
    [anon_sym_PIPE_PIPE] = ACTIONS(3139),
    [anon_sym_GT_GT] = ACTIONS(3137),
    [anon_sym_GT_GT_GT] = ACTIONS(3139),
    [anon_sym_LT_LT] = ACTIONS(3139),
    [anon_sym_AMP] = ACTIONS(3110),
    [anon_sym_CARET] = ACTIONS(3139),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_PLUS] = ACTIONS(3137),
    [anon_sym_DASH] = ACTIONS(3137),
    [anon_sym_PERCENT] = ACTIONS(3139),
    [anon_sym_STAR_STAR] = ACTIONS(3139),
    [anon_sym_LT_EQ] = ACTIONS(3139),
    [anon_sym_EQ_EQ] = ACTIONS(3137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3139),
    [anon_sym_BANG_EQ] = ACTIONS(3137),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3139),
    [anon_sym_GT_EQ] = ACTIONS(3139),
    [anon_sym_QMARK_QMARK] = ACTIONS(3139),
    [anon_sym_instanceof] = ACTIONS(3137),
    [anon_sym_void] = ACTIONS(3137),
    [anon_sym_PLUS_PLUS] = ACTIONS(3139),
    [anon_sym_DASH_DASH] = ACTIONS(3139),
    [anon_sym_DQUOTE] = ACTIONS(3139),
    [anon_sym_SQUOTE] = ACTIONS(3139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3139),
    [sym_number] = ACTIONS(3139),
    [sym_this] = ACTIONS(3137),
    [sym_true] = ACTIONS(3137),
    [sym_false] = ACTIONS(3137),
    [sym_null] = ACTIONS(3137),
    [sym_undefined] = ACTIONS(3137),
    [anon_sym_static] = ACTIONS(3137),
    [anon_sym_readonly] = ACTIONS(3137),
    [anon_sym_get] = ACTIONS(3137),
    [anon_sym_set] = ACTIONS(3137),
    [anon_sym_QMARK] = ACTIONS(3137),
    [anon_sym_any] = ACTIONS(3137),
    [anon_sym_number] = ACTIONS(3137),
    [anon_sym_boolean] = ACTIONS(3137),
    [anon_sym_string] = ACTIONS(3137),
    [anon_sym_symbol] = ACTIONS(3137),
    [anon_sym_abstract] = ACTIONS(3137),
    [anon_sym_satisfies] = ACTIONS(3137),
    [anon_sym_extends] = ACTIONS(3160),
    [anon_sym_infer] = ACTIONS(3137),
    [anon_sym_keyof] = ACTIONS(3137),
    [anon_sym_unknown] = ACTIONS(3137),
    [anon_sym_never] = ACTIONS(3137),
    [anon_sym_object] = ACTIONS(3137),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3139),
    [anon_sym_constructor] = ACTIONS(3137),
    [anon_sym_prop] = ACTIONS(3137),
    [anon_sym_id] = ACTIONS(3137),
    [anon_sym_event] = ACTIONS(3137),
    [anon_sym_fn] = ACTIONS(3137),
    [anon_sym_on] = ACTIONS(3137),
    [sym__ternary_qmark] = ACTIONS(3139),
  },
  [895] = {
    [sym_identifier] = ACTIONS(3162),
    [anon_sym_STAR] = ACTIONS(3162),
    [anon_sym_as] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3162),
    [anon_sym_RBRACE] = ACTIONS(3164),
    [anon_sym_typeof] = ACTIONS(3162),
    [anon_sym_BANG] = ACTIONS(3162),
    [anon_sym_LPAREN] = ACTIONS(3164),
    [anon_sym_in] = ACTIONS(3162),
    [anon_sym_SEMI] = ACTIONS(3164),
    [anon_sym_LBRACK] = ACTIONS(3164),
    [anon_sym_LT] = ACTIONS(3162),
    [anon_sym_GT] = ACTIONS(3162),
    [anon_sym_SLASH] = ACTIONS(3162),
    [anon_sym_DOT] = ACTIONS(3162),
    [anon_sym_async] = ACTIONS(3162),
    [anon_sym_QMARK_DOT] = ACTIONS(3164),
    [anon_sym_new] = ACTIONS(3162),
    [anon_sym_AMP_AMP] = ACTIONS(3164),
    [anon_sym_PIPE_PIPE] = ACTIONS(3164),
    [anon_sym_GT_GT] = ACTIONS(3162),
    [anon_sym_GT_GT_GT] = ACTIONS(3164),
    [anon_sym_LT_LT] = ACTIONS(3164),
    [anon_sym_AMP] = ACTIONS(3162),
    [anon_sym_CARET] = ACTIONS(3164),
    [anon_sym_PIPE] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_PERCENT] = ACTIONS(3164),
    [anon_sym_STAR_STAR] = ACTIONS(3164),
    [anon_sym_LT_EQ] = ACTIONS(3164),
    [anon_sym_EQ_EQ] = ACTIONS(3162),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3164),
    [anon_sym_BANG_EQ] = ACTIONS(3162),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3164),
    [anon_sym_GT_EQ] = ACTIONS(3164),
    [anon_sym_QMARK_QMARK] = ACTIONS(3164),
    [anon_sym_instanceof] = ACTIONS(3162),
    [anon_sym_void] = ACTIONS(3162),
    [anon_sym_PLUS_PLUS] = ACTIONS(3164),
    [anon_sym_DASH_DASH] = ACTIONS(3164),
    [anon_sym_DQUOTE] = ACTIONS(3164),
    [anon_sym_SQUOTE] = ACTIONS(3164),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3164),
    [sym_number] = ACTIONS(3164),
    [sym_this] = ACTIONS(3162),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [sym_null] = ACTIONS(3162),
    [sym_undefined] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_readonly] = ACTIONS(3162),
    [anon_sym_get] = ACTIONS(3162),
    [anon_sym_set] = ACTIONS(3162),
    [anon_sym_QMARK] = ACTIONS(3162),
    [anon_sym_any] = ACTIONS(3162),
    [anon_sym_number] = ACTIONS(3162),
    [anon_sym_boolean] = ACTIONS(3162),
    [anon_sym_string] = ACTIONS(3162),
    [anon_sym_symbol] = ACTIONS(3162),
    [anon_sym_abstract] = ACTIONS(3162),
    [anon_sym_satisfies] = ACTIONS(3162),
    [anon_sym_extends] = ACTIONS(3162),
    [anon_sym_infer] = ACTIONS(3162),
    [anon_sym_keyof] = ACTIONS(3162),
    [anon_sym_unknown] = ACTIONS(3162),
    [anon_sym_never] = ACTIONS(3162),
    [anon_sym_object] = ACTIONS(3162),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3164),
    [anon_sym_constructor] = ACTIONS(3162),
    [anon_sym_prop] = ACTIONS(3162),
    [anon_sym_id] = ACTIONS(3162),
    [anon_sym_event] = ACTIONS(3162),
    [anon_sym_fn] = ACTIONS(3162),
    [anon_sym_on] = ACTIONS(3162),
    [sym__ternary_qmark] = ACTIONS(3164),
  },
  [896] = {
    [sym_identifier] = ACTIONS(3166),
    [anon_sym_STAR] = ACTIONS(3166),
    [anon_sym_as] = ACTIONS(3166),
    [anon_sym_LBRACE] = ACTIONS(3166),
    [anon_sym_RBRACE] = ACTIONS(3168),
    [anon_sym_typeof] = ACTIONS(3166),
    [anon_sym_BANG] = ACTIONS(3166),
    [anon_sym_LPAREN] = ACTIONS(3168),
    [anon_sym_in] = ACTIONS(3166),
    [anon_sym_SEMI] = ACTIONS(3168),
    [anon_sym_LBRACK] = ACTIONS(3168),
    [anon_sym_LT] = ACTIONS(3166),
    [anon_sym_GT] = ACTIONS(3166),
    [anon_sym_SLASH] = ACTIONS(3166),
    [anon_sym_DOT] = ACTIONS(3166),
    [anon_sym_async] = ACTIONS(3166),
    [anon_sym_QMARK_DOT] = ACTIONS(3168),
    [anon_sym_new] = ACTIONS(3166),
    [anon_sym_AMP_AMP] = ACTIONS(3168),
    [anon_sym_PIPE_PIPE] = ACTIONS(3168),
    [anon_sym_GT_GT] = ACTIONS(3166),
    [anon_sym_GT_GT_GT] = ACTIONS(3168),
    [anon_sym_LT_LT] = ACTIONS(3168),
    [anon_sym_AMP] = ACTIONS(3166),
    [anon_sym_CARET] = ACTIONS(3168),
    [anon_sym_PIPE] = ACTIONS(3166),
    [anon_sym_PLUS] = ACTIONS(3166),
    [anon_sym_DASH] = ACTIONS(3166),
    [anon_sym_PERCENT] = ACTIONS(3168),
    [anon_sym_STAR_STAR] = ACTIONS(3168),
    [anon_sym_LT_EQ] = ACTIONS(3168),
    [anon_sym_EQ_EQ] = ACTIONS(3166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3168),
    [anon_sym_BANG_EQ] = ACTIONS(3166),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3168),
    [anon_sym_GT_EQ] = ACTIONS(3168),
    [anon_sym_QMARK_QMARK] = ACTIONS(3168),
    [anon_sym_instanceof] = ACTIONS(3166),
    [anon_sym_void] = ACTIONS(3166),
    [anon_sym_PLUS_PLUS] = ACTIONS(3168),
    [anon_sym_DASH_DASH] = ACTIONS(3168),
    [anon_sym_DQUOTE] = ACTIONS(3168),
    [anon_sym_SQUOTE] = ACTIONS(3168),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3168),
    [sym_number] = ACTIONS(3168),
    [sym_this] = ACTIONS(3166),
    [sym_true] = ACTIONS(3166),
    [sym_false] = ACTIONS(3166),
    [sym_null] = ACTIONS(3166),
    [sym_undefined] = ACTIONS(3166),
    [anon_sym_static] = ACTIONS(3166),
    [anon_sym_readonly] = ACTIONS(3166),
    [anon_sym_get] = ACTIONS(3166),
    [anon_sym_set] = ACTIONS(3166),
    [anon_sym_QMARK] = ACTIONS(3166),
    [anon_sym_any] = ACTIONS(3166),
    [anon_sym_number] = ACTIONS(3166),
    [anon_sym_boolean] = ACTIONS(3166),
    [anon_sym_string] = ACTIONS(3166),
    [anon_sym_symbol] = ACTIONS(3166),
    [anon_sym_abstract] = ACTIONS(3166),
    [anon_sym_satisfies] = ACTIONS(3166),
    [anon_sym_extends] = ACTIONS(3166),
    [anon_sym_infer] = ACTIONS(3166),
    [anon_sym_keyof] = ACTIONS(3166),
    [anon_sym_unknown] = ACTIONS(3166),
    [anon_sym_never] = ACTIONS(3166),
    [anon_sym_object] = ACTIONS(3166),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3168),
    [anon_sym_constructor] = ACTIONS(3166),
    [anon_sym_prop] = ACTIONS(3166),
    [anon_sym_id] = ACTIONS(3166),
    [anon_sym_event] = ACTIONS(3166),
    [anon_sym_fn] = ACTIONS(3166),
    [anon_sym_on] = ACTIONS(3166),
    [sym__ternary_qmark] = ACTIONS(3168),
  },
  [897] = {
    [sym_identifier] = ACTIONS(3170),
    [anon_sym_STAR] = ACTIONS(3170),
    [anon_sym_as] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_RBRACE] = ACTIONS(3172),
    [anon_sym_typeof] = ACTIONS(3170),
    [anon_sym_BANG] = ACTIONS(3170),
    [anon_sym_LPAREN] = ACTIONS(3172),
    [anon_sym_in] = ACTIONS(3170),
    [anon_sym_SEMI] = ACTIONS(3172),
    [anon_sym_LBRACK] = ACTIONS(3172),
    [anon_sym_LT] = ACTIONS(3170),
    [anon_sym_GT] = ACTIONS(3170),
    [anon_sym_SLASH] = ACTIONS(3170),
    [anon_sym_DOT] = ACTIONS(3170),
    [anon_sym_async] = ACTIONS(3170),
    [anon_sym_QMARK_DOT] = ACTIONS(3172),
    [anon_sym_new] = ACTIONS(3170),
    [anon_sym_AMP_AMP] = ACTIONS(3172),
    [anon_sym_PIPE_PIPE] = ACTIONS(3172),
    [anon_sym_GT_GT] = ACTIONS(3170),
    [anon_sym_GT_GT_GT] = ACTIONS(3172),
    [anon_sym_LT_LT] = ACTIONS(3172),
    [anon_sym_AMP] = ACTIONS(3170),
    [anon_sym_CARET] = ACTIONS(3172),
    [anon_sym_PIPE] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3170),
    [anon_sym_DASH] = ACTIONS(3170),
    [anon_sym_PERCENT] = ACTIONS(3172),
    [anon_sym_STAR_STAR] = ACTIONS(3172),
    [anon_sym_LT_EQ] = ACTIONS(3172),
    [anon_sym_EQ_EQ] = ACTIONS(3170),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3172),
    [anon_sym_BANG_EQ] = ACTIONS(3170),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3172),
    [anon_sym_GT_EQ] = ACTIONS(3172),
    [anon_sym_QMARK_QMARK] = ACTIONS(3172),
    [anon_sym_instanceof] = ACTIONS(3170),
    [anon_sym_void] = ACTIONS(3170),
    [anon_sym_PLUS_PLUS] = ACTIONS(3172),
    [anon_sym_DASH_DASH] = ACTIONS(3172),
    [anon_sym_DQUOTE] = ACTIONS(3172),
    [anon_sym_SQUOTE] = ACTIONS(3172),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3172),
    [sym_number] = ACTIONS(3172),
    [sym_this] = ACTIONS(3170),
    [sym_true] = ACTIONS(3170),
    [sym_false] = ACTIONS(3170),
    [sym_null] = ACTIONS(3170),
    [sym_undefined] = ACTIONS(3170),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_readonly] = ACTIONS(3170),
    [anon_sym_get] = ACTIONS(3170),
    [anon_sym_set] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(3170),
    [anon_sym_any] = ACTIONS(3170),
    [anon_sym_number] = ACTIONS(3170),
    [anon_sym_boolean] = ACTIONS(3170),
    [anon_sym_string] = ACTIONS(3170),
    [anon_sym_symbol] = ACTIONS(3170),
    [anon_sym_abstract] = ACTIONS(3170),
    [anon_sym_satisfies] = ACTIONS(3170),
    [anon_sym_extends] = ACTIONS(3170),
    [anon_sym_infer] = ACTIONS(3170),
    [anon_sym_keyof] = ACTIONS(3170),
    [anon_sym_unknown] = ACTIONS(3170),
    [anon_sym_never] = ACTIONS(3170),
    [anon_sym_object] = ACTIONS(3170),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3172),
    [anon_sym_constructor] = ACTIONS(3170),
    [anon_sym_prop] = ACTIONS(3170),
    [anon_sym_id] = ACTIONS(3170),
    [anon_sym_event] = ACTIONS(3170),
    [anon_sym_fn] = ACTIONS(3170),
    [anon_sym_on] = ACTIONS(3170),
    [sym__ternary_qmark] = ACTIONS(3172),
  },
  [898] = {
    [sym_identifier] = ACTIONS(3174),
    [anon_sym_STAR] = ACTIONS(3174),
    [anon_sym_as] = ACTIONS(3174),
    [anon_sym_LBRACE] = ACTIONS(3174),
    [anon_sym_RBRACE] = ACTIONS(3176),
    [anon_sym_typeof] = ACTIONS(3174),
    [anon_sym_BANG] = ACTIONS(3174),
    [anon_sym_LPAREN] = ACTIONS(3176),
    [anon_sym_in] = ACTIONS(3174),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym_LBRACK] = ACTIONS(3176),
    [anon_sym_LT] = ACTIONS(3174),
    [anon_sym_GT] = ACTIONS(3174),
    [anon_sym_SLASH] = ACTIONS(3174),
    [anon_sym_DOT] = ACTIONS(3174),
    [anon_sym_async] = ACTIONS(3174),
    [anon_sym_QMARK_DOT] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3174),
    [anon_sym_AMP_AMP] = ACTIONS(3176),
    [anon_sym_PIPE_PIPE] = ACTIONS(3176),
    [anon_sym_GT_GT] = ACTIONS(3174),
    [anon_sym_GT_GT_GT] = ACTIONS(3176),
    [anon_sym_LT_LT] = ACTIONS(3176),
    [anon_sym_AMP] = ACTIONS(3174),
    [anon_sym_CARET] = ACTIONS(3176),
    [anon_sym_PIPE] = ACTIONS(3174),
    [anon_sym_PLUS] = ACTIONS(3174),
    [anon_sym_DASH] = ACTIONS(3174),
    [anon_sym_PERCENT] = ACTIONS(3176),
    [anon_sym_STAR_STAR] = ACTIONS(3176),
    [anon_sym_LT_EQ] = ACTIONS(3176),
    [anon_sym_EQ_EQ] = ACTIONS(3174),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3176),
    [anon_sym_BANG_EQ] = ACTIONS(3174),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3176),
    [anon_sym_GT_EQ] = ACTIONS(3176),
    [anon_sym_QMARK_QMARK] = ACTIONS(3176),
    [anon_sym_instanceof] = ACTIONS(3174),
    [anon_sym_void] = ACTIONS(3174),
    [anon_sym_PLUS_PLUS] = ACTIONS(3176),
    [anon_sym_DASH_DASH] = ACTIONS(3176),
    [anon_sym_DQUOTE] = ACTIONS(3176),
    [anon_sym_SQUOTE] = ACTIONS(3176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3176),
    [sym_number] = ACTIONS(3176),
    [sym_this] = ACTIONS(3174),
    [sym_true] = ACTIONS(3174),
    [sym_false] = ACTIONS(3174),
    [sym_null] = ACTIONS(3174),
    [sym_undefined] = ACTIONS(3174),
    [anon_sym_static] = ACTIONS(3174),
    [anon_sym_readonly] = ACTIONS(3174),
    [anon_sym_get] = ACTIONS(3174),
    [anon_sym_set] = ACTIONS(3174),
    [anon_sym_QMARK] = ACTIONS(3174),
    [anon_sym_any] = ACTIONS(3174),
    [anon_sym_number] = ACTIONS(3174),
    [anon_sym_boolean] = ACTIONS(3174),
    [anon_sym_string] = ACTIONS(3174),
    [anon_sym_symbol] = ACTIONS(3174),
    [anon_sym_abstract] = ACTIONS(3174),
    [anon_sym_satisfies] = ACTIONS(3174),
    [anon_sym_extends] = ACTIONS(3174),
    [anon_sym_infer] = ACTIONS(3174),
    [anon_sym_keyof] = ACTIONS(3174),
    [anon_sym_unknown] = ACTIONS(3174),
    [anon_sym_never] = ACTIONS(3174),
    [anon_sym_object] = ACTIONS(3174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3176),
    [anon_sym_constructor] = ACTIONS(3174),
    [anon_sym_prop] = ACTIONS(3174),
    [anon_sym_id] = ACTIONS(3174),
    [anon_sym_event] = ACTIONS(3174),
    [anon_sym_fn] = ACTIONS(3174),
    [anon_sym_on] = ACTIONS(3174),
    [sym__ternary_qmark] = ACTIONS(3176),
  },
  [899] = {
    [sym_identifier] = ACTIONS(3178),
    [anon_sym_STAR] = ACTIONS(3178),
    [anon_sym_as] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3178),
    [anon_sym_RBRACE] = ACTIONS(3180),
    [anon_sym_typeof] = ACTIONS(3178),
    [anon_sym_BANG] = ACTIONS(3178),
    [anon_sym_LPAREN] = ACTIONS(3180),
    [anon_sym_in] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3180),
    [anon_sym_LBRACK] = ACTIONS(3180),
    [anon_sym_LT] = ACTIONS(3178),
    [anon_sym_GT] = ACTIONS(3178),
    [anon_sym_SLASH] = ACTIONS(3178),
    [anon_sym_DOT] = ACTIONS(3178),
    [anon_sym_async] = ACTIONS(3178),
    [anon_sym_QMARK_DOT] = ACTIONS(3180),
    [anon_sym_new] = ACTIONS(3178),
    [anon_sym_AMP_AMP] = ACTIONS(3180),
    [anon_sym_PIPE_PIPE] = ACTIONS(3180),
    [anon_sym_GT_GT] = ACTIONS(3178),
    [anon_sym_GT_GT_GT] = ACTIONS(3180),
    [anon_sym_LT_LT] = ACTIONS(3180),
    [anon_sym_AMP] = ACTIONS(3178),
    [anon_sym_CARET] = ACTIONS(3180),
    [anon_sym_PIPE] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3178),
    [anon_sym_DASH] = ACTIONS(3178),
    [anon_sym_PERCENT] = ACTIONS(3180),
    [anon_sym_STAR_STAR] = ACTIONS(3180),
    [anon_sym_LT_EQ] = ACTIONS(3180),
    [anon_sym_EQ_EQ] = ACTIONS(3178),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3180),
    [anon_sym_BANG_EQ] = ACTIONS(3178),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3180),
    [anon_sym_GT_EQ] = ACTIONS(3180),
    [anon_sym_QMARK_QMARK] = ACTIONS(3180),
    [anon_sym_instanceof] = ACTIONS(3178),
    [anon_sym_void] = ACTIONS(3178),
    [anon_sym_PLUS_PLUS] = ACTIONS(3180),
    [anon_sym_DASH_DASH] = ACTIONS(3180),
    [anon_sym_DQUOTE] = ACTIONS(3180),
    [anon_sym_SQUOTE] = ACTIONS(3180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3180),
    [sym_number] = ACTIONS(3180),
    [sym_this] = ACTIONS(3178),
    [sym_true] = ACTIONS(3178),
    [sym_false] = ACTIONS(3178),
    [sym_null] = ACTIONS(3178),
    [sym_undefined] = ACTIONS(3178),
    [anon_sym_static] = ACTIONS(3178),
    [anon_sym_readonly] = ACTIONS(3178),
    [anon_sym_get] = ACTIONS(3178),
    [anon_sym_set] = ACTIONS(3178),
    [anon_sym_QMARK] = ACTIONS(3178),
    [anon_sym_any] = ACTIONS(3178),
    [anon_sym_number] = ACTIONS(3178),
    [anon_sym_boolean] = ACTIONS(3178),
    [anon_sym_string] = ACTIONS(3178),
    [anon_sym_symbol] = ACTIONS(3178),
    [anon_sym_abstract] = ACTIONS(3178),
    [anon_sym_satisfies] = ACTIONS(3178),
    [anon_sym_extends] = ACTIONS(3178),
    [anon_sym_infer] = ACTIONS(3178),
    [anon_sym_keyof] = ACTIONS(3178),
    [anon_sym_unknown] = ACTIONS(3178),
    [anon_sym_never] = ACTIONS(3178),
    [anon_sym_object] = ACTIONS(3178),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3180),
    [anon_sym_constructor] = ACTIONS(3178),
    [anon_sym_prop] = ACTIONS(3178),
    [anon_sym_id] = ACTIONS(3178),
    [anon_sym_event] = ACTIONS(3178),
    [anon_sym_fn] = ACTIONS(3178),
    [anon_sym_on] = ACTIONS(3178),
    [sym__ternary_qmark] = ACTIONS(3180),
  },
  [900] = {
    [sym_identifier] = ACTIONS(3174),
    [anon_sym_STAR] = ACTIONS(3174),
    [anon_sym_as] = ACTIONS(3174),
    [anon_sym_LBRACE] = ACTIONS(3174),
    [anon_sym_RBRACE] = ACTIONS(3176),
    [anon_sym_typeof] = ACTIONS(3174),
    [anon_sym_BANG] = ACTIONS(3174),
    [anon_sym_LPAREN] = ACTIONS(3176),
    [anon_sym_in] = ACTIONS(3174),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym_LBRACK] = ACTIONS(3176),
    [anon_sym_LT] = ACTIONS(3174),
    [anon_sym_GT] = ACTIONS(3174),
    [anon_sym_SLASH] = ACTIONS(3174),
    [anon_sym_DOT] = ACTIONS(3174),
    [anon_sym_async] = ACTIONS(3174),
    [anon_sym_QMARK_DOT] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3174),
    [anon_sym_AMP_AMP] = ACTIONS(3176),
    [anon_sym_PIPE_PIPE] = ACTIONS(3176),
    [anon_sym_GT_GT] = ACTIONS(3174),
    [anon_sym_GT_GT_GT] = ACTIONS(3176),
    [anon_sym_LT_LT] = ACTIONS(3176),
    [anon_sym_AMP] = ACTIONS(3174),
    [anon_sym_CARET] = ACTIONS(3176),
    [anon_sym_PIPE] = ACTIONS(3174),
    [anon_sym_PLUS] = ACTIONS(3174),
    [anon_sym_DASH] = ACTIONS(3174),
    [anon_sym_PERCENT] = ACTIONS(3176),
    [anon_sym_STAR_STAR] = ACTIONS(3176),
    [anon_sym_LT_EQ] = ACTIONS(3176),
    [anon_sym_EQ_EQ] = ACTIONS(3174),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3176),
    [anon_sym_BANG_EQ] = ACTIONS(3174),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3176),
    [anon_sym_GT_EQ] = ACTIONS(3176),
    [anon_sym_QMARK_QMARK] = ACTIONS(3176),
    [anon_sym_instanceof] = ACTIONS(3174),
    [anon_sym_void] = ACTIONS(3174),
    [anon_sym_PLUS_PLUS] = ACTIONS(3176),
    [anon_sym_DASH_DASH] = ACTIONS(3176),
    [anon_sym_DQUOTE] = ACTIONS(3176),
    [anon_sym_SQUOTE] = ACTIONS(3176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3176),
    [sym_number] = ACTIONS(3176),
    [sym_this] = ACTIONS(3174),
    [sym_true] = ACTIONS(3174),
    [sym_false] = ACTIONS(3174),
    [sym_null] = ACTIONS(3174),
    [sym_undefined] = ACTIONS(3174),
    [anon_sym_static] = ACTIONS(3174),
    [anon_sym_readonly] = ACTIONS(3174),
    [anon_sym_get] = ACTIONS(3174),
    [anon_sym_set] = ACTIONS(3174),
    [anon_sym_QMARK] = ACTIONS(3174),
    [anon_sym_any] = ACTIONS(3174),
    [anon_sym_number] = ACTIONS(3174),
    [anon_sym_boolean] = ACTIONS(3174),
    [anon_sym_string] = ACTIONS(3174),
    [anon_sym_symbol] = ACTIONS(3174),
    [anon_sym_abstract] = ACTIONS(3174),
    [anon_sym_satisfies] = ACTIONS(3174),
    [anon_sym_extends] = ACTIONS(3174),
    [anon_sym_infer] = ACTIONS(3174),
    [anon_sym_keyof] = ACTIONS(3174),
    [anon_sym_unknown] = ACTIONS(3174),
    [anon_sym_never] = ACTIONS(3174),
    [anon_sym_object] = ACTIONS(3174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3176),
    [anon_sym_constructor] = ACTIONS(3174),
    [anon_sym_prop] = ACTIONS(3174),
    [anon_sym_id] = ACTIONS(3174),
    [anon_sym_event] = ACTIONS(3174),
    [anon_sym_fn] = ACTIONS(3174),
    [anon_sym_on] = ACTIONS(3174),
    [sym__ternary_qmark] = ACTIONS(3176),
  },
  [901] = {
    [sym_identifier] = ACTIONS(3182),
    [anon_sym_STAR] = ACTIONS(3182),
    [anon_sym_as] = ACTIONS(3182),
    [anon_sym_LBRACE] = ACTIONS(3182),
    [anon_sym_RBRACE] = ACTIONS(3184),
    [anon_sym_typeof] = ACTIONS(3182),
    [anon_sym_BANG] = ACTIONS(3182),
    [anon_sym_LPAREN] = ACTIONS(3184),
    [anon_sym_in] = ACTIONS(3182),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym_LBRACK] = ACTIONS(3184),
    [anon_sym_LT] = ACTIONS(3182),
    [anon_sym_GT] = ACTIONS(3182),
    [anon_sym_SLASH] = ACTIONS(3182),
    [anon_sym_DOT] = ACTIONS(3182),
    [anon_sym_async] = ACTIONS(3182),
    [anon_sym_QMARK_DOT] = ACTIONS(3184),
    [anon_sym_new] = ACTIONS(3182),
    [anon_sym_AMP_AMP] = ACTIONS(3184),
    [anon_sym_PIPE_PIPE] = ACTIONS(3184),
    [anon_sym_GT_GT] = ACTIONS(3182),
    [anon_sym_GT_GT_GT] = ACTIONS(3184),
    [anon_sym_LT_LT] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3182),
    [anon_sym_CARET] = ACTIONS(3184),
    [anon_sym_PIPE] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3182),
    [anon_sym_DASH] = ACTIONS(3182),
    [anon_sym_PERCENT] = ACTIONS(3184),
    [anon_sym_STAR_STAR] = ACTIONS(3184),
    [anon_sym_LT_EQ] = ACTIONS(3184),
    [anon_sym_EQ_EQ] = ACTIONS(3182),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3184),
    [anon_sym_BANG_EQ] = ACTIONS(3182),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3184),
    [anon_sym_GT_EQ] = ACTIONS(3184),
    [anon_sym_QMARK_QMARK] = ACTIONS(3184),
    [anon_sym_instanceof] = ACTIONS(3182),
    [anon_sym_void] = ACTIONS(3182),
    [anon_sym_PLUS_PLUS] = ACTIONS(3184),
    [anon_sym_DASH_DASH] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3184),
    [sym_number] = ACTIONS(3184),
    [sym_this] = ACTIONS(3182),
    [sym_true] = ACTIONS(3182),
    [sym_false] = ACTIONS(3182),
    [sym_null] = ACTIONS(3182),
    [sym_undefined] = ACTIONS(3182),
    [anon_sym_static] = ACTIONS(3182),
    [anon_sym_readonly] = ACTIONS(3182),
    [anon_sym_get] = ACTIONS(3182),
    [anon_sym_set] = ACTIONS(3182),
    [anon_sym_QMARK] = ACTIONS(3182),
    [anon_sym_any] = ACTIONS(3182),
    [anon_sym_number] = ACTIONS(3182),
    [anon_sym_boolean] = ACTIONS(3182),
    [anon_sym_string] = ACTIONS(3182),
    [anon_sym_symbol] = ACTIONS(3182),
    [anon_sym_abstract] = ACTIONS(3182),
    [anon_sym_satisfies] = ACTIONS(3182),
    [anon_sym_extends] = ACTIONS(3182),
    [anon_sym_infer] = ACTIONS(3182),
    [anon_sym_keyof] = ACTIONS(3182),
    [anon_sym_unknown] = ACTIONS(3182),
    [anon_sym_never] = ACTIONS(3182),
    [anon_sym_object] = ACTIONS(3182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3184),
    [anon_sym_constructor] = ACTIONS(3182),
    [anon_sym_prop] = ACTIONS(3182),
    [anon_sym_id] = ACTIONS(3182),
    [anon_sym_event] = ACTIONS(3182),
    [anon_sym_fn] = ACTIONS(3182),
    [anon_sym_on] = ACTIONS(3182),
    [sym__ternary_qmark] = ACTIONS(3184),
  },
  [902] = {
    [sym_identifier] = ACTIONS(3174),
    [anon_sym_STAR] = ACTIONS(3174),
    [anon_sym_as] = ACTIONS(3174),
    [anon_sym_LBRACE] = ACTIONS(3174),
    [anon_sym_RBRACE] = ACTIONS(3176),
    [anon_sym_typeof] = ACTIONS(3174),
    [anon_sym_BANG] = ACTIONS(3174),
    [anon_sym_LPAREN] = ACTIONS(3176),
    [anon_sym_in] = ACTIONS(3174),
    [anon_sym_SEMI] = ACTIONS(3176),
    [anon_sym_LBRACK] = ACTIONS(3176),
    [anon_sym_LT] = ACTIONS(3174),
    [anon_sym_GT] = ACTIONS(3174),
    [anon_sym_SLASH] = ACTIONS(3174),
    [anon_sym_DOT] = ACTIONS(3174),
    [anon_sym_async] = ACTIONS(3174),
    [anon_sym_QMARK_DOT] = ACTIONS(3176),
    [anon_sym_new] = ACTIONS(3174),
    [anon_sym_AMP_AMP] = ACTIONS(3176),
    [anon_sym_PIPE_PIPE] = ACTIONS(3176),
    [anon_sym_GT_GT] = ACTIONS(3174),
    [anon_sym_GT_GT_GT] = ACTIONS(3176),
    [anon_sym_LT_LT] = ACTIONS(3176),
    [anon_sym_AMP] = ACTIONS(3174),
    [anon_sym_CARET] = ACTIONS(3176),
    [anon_sym_PIPE] = ACTIONS(3174),
    [anon_sym_PLUS] = ACTIONS(3174),
    [anon_sym_DASH] = ACTIONS(3174),
    [anon_sym_PERCENT] = ACTIONS(3176),
    [anon_sym_STAR_STAR] = ACTIONS(3176),
    [anon_sym_LT_EQ] = ACTIONS(3176),
    [anon_sym_EQ_EQ] = ACTIONS(3174),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3176),
    [anon_sym_BANG_EQ] = ACTIONS(3174),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3176),
    [anon_sym_GT_EQ] = ACTIONS(3176),
    [anon_sym_QMARK_QMARK] = ACTIONS(3176),
    [anon_sym_instanceof] = ACTIONS(3174),
    [anon_sym_void] = ACTIONS(3174),
    [anon_sym_PLUS_PLUS] = ACTIONS(3176),
    [anon_sym_DASH_DASH] = ACTIONS(3176),
    [anon_sym_DQUOTE] = ACTIONS(3176),
    [anon_sym_SQUOTE] = ACTIONS(3176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3176),
    [sym_number] = ACTIONS(3176),
    [sym_this] = ACTIONS(3174),
    [sym_true] = ACTIONS(3174),
    [sym_false] = ACTIONS(3174),
    [sym_null] = ACTIONS(3174),
    [sym_undefined] = ACTIONS(3174),
    [anon_sym_static] = ACTIONS(3174),
    [anon_sym_readonly] = ACTIONS(3174),
    [anon_sym_get] = ACTIONS(3174),
    [anon_sym_set] = ACTIONS(3174),
    [anon_sym_QMARK] = ACTIONS(3174),
    [anon_sym_any] = ACTIONS(3174),
    [anon_sym_number] = ACTIONS(3174),
    [anon_sym_boolean] = ACTIONS(3174),
    [anon_sym_string] = ACTIONS(3174),
    [anon_sym_symbol] = ACTIONS(3174),
    [anon_sym_abstract] = ACTIONS(3174),
    [anon_sym_satisfies] = ACTIONS(3174),
    [anon_sym_extends] = ACTIONS(3174),
    [anon_sym_infer] = ACTIONS(3174),
    [anon_sym_keyof] = ACTIONS(3174),
    [anon_sym_unknown] = ACTIONS(3174),
    [anon_sym_never] = ACTIONS(3174),
    [anon_sym_object] = ACTIONS(3174),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3176),
    [anon_sym_constructor] = ACTIONS(3174),
    [anon_sym_prop] = ACTIONS(3174),
    [anon_sym_id] = ACTIONS(3174),
    [anon_sym_event] = ACTIONS(3174),
    [anon_sym_fn] = ACTIONS(3174),
    [anon_sym_on] = ACTIONS(3174),
    [sym__ternary_qmark] = ACTIONS(3176),
  },
  [903] = {
    [sym_identifier] = ACTIONS(3186),
    [anon_sym_STAR] = ACTIONS(3186),
    [anon_sym_as] = ACTIONS(3186),
    [anon_sym_LBRACE] = ACTIONS(3186),
    [anon_sym_RBRACE] = ACTIONS(3188),
    [anon_sym_typeof] = ACTIONS(3186),
    [anon_sym_BANG] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(3188),
    [anon_sym_in] = ACTIONS(3186),
    [anon_sym_SEMI] = ACTIONS(3188),
    [anon_sym_LBRACK] = ACTIONS(3188),
    [anon_sym_LT] = ACTIONS(3186),
    [anon_sym_GT] = ACTIONS(3186),
    [anon_sym_SLASH] = ACTIONS(3186),
    [anon_sym_DOT] = ACTIONS(3186),
    [anon_sym_async] = ACTIONS(3186),
    [anon_sym_QMARK_DOT] = ACTIONS(3188),
    [anon_sym_new] = ACTIONS(3186),
    [anon_sym_AMP_AMP] = ACTIONS(3188),
    [anon_sym_PIPE_PIPE] = ACTIONS(3188),
    [anon_sym_GT_GT] = ACTIONS(3186),
    [anon_sym_GT_GT_GT] = ACTIONS(3188),
    [anon_sym_LT_LT] = ACTIONS(3188),
    [anon_sym_AMP] = ACTIONS(3186),
    [anon_sym_CARET] = ACTIONS(3188),
    [anon_sym_PIPE] = ACTIONS(3186),
    [anon_sym_PLUS] = ACTIONS(3186),
    [anon_sym_DASH] = ACTIONS(3186),
    [anon_sym_PERCENT] = ACTIONS(3188),
    [anon_sym_STAR_STAR] = ACTIONS(3188),
    [anon_sym_LT_EQ] = ACTIONS(3188),
    [anon_sym_EQ_EQ] = ACTIONS(3186),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3188),
    [anon_sym_BANG_EQ] = ACTIONS(3186),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3188),
    [anon_sym_GT_EQ] = ACTIONS(3188),
    [anon_sym_QMARK_QMARK] = ACTIONS(3188),
    [anon_sym_instanceof] = ACTIONS(3186),
    [anon_sym_void] = ACTIONS(3186),
    [anon_sym_PLUS_PLUS] = ACTIONS(3188),
    [anon_sym_DASH_DASH] = ACTIONS(3188),
    [anon_sym_DQUOTE] = ACTIONS(3188),
    [anon_sym_SQUOTE] = ACTIONS(3188),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3188),
    [sym_number] = ACTIONS(3188),
    [sym_this] = ACTIONS(3186),
    [sym_true] = ACTIONS(3186),
    [sym_false] = ACTIONS(3186),
    [sym_null] = ACTIONS(3186),
    [sym_undefined] = ACTIONS(3186),
    [anon_sym_static] = ACTIONS(3186),
    [anon_sym_readonly] = ACTIONS(3186),
    [anon_sym_get] = ACTIONS(3186),
    [anon_sym_set] = ACTIONS(3186),
    [anon_sym_QMARK] = ACTIONS(3186),
    [anon_sym_any] = ACTIONS(3186),
    [anon_sym_number] = ACTIONS(3186),
    [anon_sym_boolean] = ACTIONS(3186),
    [anon_sym_string] = ACTIONS(3186),
    [anon_sym_symbol] = ACTIONS(3186),
    [anon_sym_abstract] = ACTIONS(3186),
    [anon_sym_satisfies] = ACTIONS(3186),
    [anon_sym_extends] = ACTIONS(3186),
    [anon_sym_infer] = ACTIONS(3186),
    [anon_sym_keyof] = ACTIONS(3186),
    [anon_sym_unknown] = ACTIONS(3186),
    [anon_sym_never] = ACTIONS(3186),
    [anon_sym_object] = ACTIONS(3186),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3188),
    [anon_sym_constructor] = ACTIONS(3186),
    [anon_sym_prop] = ACTIONS(3186),
    [anon_sym_id] = ACTIONS(3186),
    [anon_sym_event] = ACTIONS(3186),
    [anon_sym_fn] = ACTIONS(3186),
    [anon_sym_on] = ACTIONS(3186),
    [sym__ternary_qmark] = ACTIONS(3188),
  },
  [904] = {
    [sym_identifier] = ACTIONS(3190),
    [anon_sym_STAR] = ACTIONS(3190),
    [anon_sym_as] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3190),
    [anon_sym_RBRACE] = ACTIONS(3192),
    [anon_sym_typeof] = ACTIONS(3190),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_LPAREN] = ACTIONS(3192),
    [anon_sym_in] = ACTIONS(3190),
    [anon_sym_SEMI] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_LT] = ACTIONS(3190),
    [anon_sym_GT] = ACTIONS(3190),
    [anon_sym_SLASH] = ACTIONS(3190),
    [anon_sym_DOT] = ACTIONS(3190),
    [anon_sym_async] = ACTIONS(3190),
    [anon_sym_QMARK_DOT] = ACTIONS(3192),
    [anon_sym_new] = ACTIONS(3190),
    [anon_sym_AMP_AMP] = ACTIONS(3192),
    [anon_sym_PIPE_PIPE] = ACTIONS(3192),
    [anon_sym_GT_GT] = ACTIONS(3190),
    [anon_sym_GT_GT_GT] = ACTIONS(3192),
    [anon_sym_LT_LT] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(3190),
    [anon_sym_CARET] = ACTIONS(3192),
    [anon_sym_PIPE] = ACTIONS(3190),
    [anon_sym_PLUS] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3190),
    [anon_sym_PERCENT] = ACTIONS(3192),
    [anon_sym_STAR_STAR] = ACTIONS(3192),
    [anon_sym_LT_EQ] = ACTIONS(3192),
    [anon_sym_EQ_EQ] = ACTIONS(3190),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3192),
    [anon_sym_BANG_EQ] = ACTIONS(3190),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3192),
    [anon_sym_GT_EQ] = ACTIONS(3192),
    [anon_sym_QMARK_QMARK] = ACTIONS(3192),
    [anon_sym_instanceof] = ACTIONS(3190),
    [anon_sym_void] = ACTIONS(3190),
    [anon_sym_PLUS_PLUS] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3192),
    [anon_sym_DQUOTE] = ACTIONS(3192),
    [anon_sym_SQUOTE] = ACTIONS(3192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3192),
    [sym_number] = ACTIONS(3192),
    [sym_this] = ACTIONS(3190),
    [sym_true] = ACTIONS(3190),
    [sym_false] = ACTIONS(3190),
    [sym_null] = ACTIONS(3190),
    [sym_undefined] = ACTIONS(3190),
    [anon_sym_static] = ACTIONS(3190),
    [anon_sym_readonly] = ACTIONS(3190),
    [anon_sym_get] = ACTIONS(3190),
    [anon_sym_set] = ACTIONS(3190),
    [anon_sym_QMARK] = ACTIONS(3190),
    [anon_sym_any] = ACTIONS(3190),
    [anon_sym_number] = ACTIONS(3190),
    [anon_sym_boolean] = ACTIONS(3190),
    [anon_sym_string] = ACTIONS(3190),
    [anon_sym_symbol] = ACTIONS(3190),
    [anon_sym_abstract] = ACTIONS(3190),
    [anon_sym_satisfies] = ACTIONS(3190),
    [anon_sym_extends] = ACTIONS(3190),
    [anon_sym_infer] = ACTIONS(3190),
    [anon_sym_keyof] = ACTIONS(3190),
    [anon_sym_unknown] = ACTIONS(3190),
    [anon_sym_never] = ACTIONS(3190),
    [anon_sym_object] = ACTIONS(3190),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3192),
    [anon_sym_constructor] = ACTIONS(3190),
    [anon_sym_prop] = ACTIONS(3190),
    [anon_sym_id] = ACTIONS(3190),
    [anon_sym_event] = ACTIONS(3190),
    [anon_sym_fn] = ACTIONS(3190),
    [anon_sym_on] = ACTIONS(3190),
    [sym__ternary_qmark] = ACTIONS(3192),
  },
  [905] = {
    [sym_identifier] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3194),
    [anon_sym_as] = ACTIONS(3194),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3196),
    [anon_sym_typeof] = ACTIONS(3194),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_LPAREN] = ACTIONS(3196),
    [anon_sym_in] = ACTIONS(3194),
    [anon_sym_SEMI] = ACTIONS(3196),
    [anon_sym_LBRACK] = ACTIONS(3196),
    [anon_sym_LT] = ACTIONS(3194),
    [anon_sym_GT] = ACTIONS(3194),
    [anon_sym_SLASH] = ACTIONS(3194),
    [anon_sym_DOT] = ACTIONS(3194),
    [anon_sym_async] = ACTIONS(3194),
    [anon_sym_QMARK_DOT] = ACTIONS(3196),
    [anon_sym_new] = ACTIONS(3194),
    [anon_sym_AMP_AMP] = ACTIONS(3196),
    [anon_sym_PIPE_PIPE] = ACTIONS(3196),
    [anon_sym_GT_GT] = ACTIONS(3194),
    [anon_sym_GT_GT_GT] = ACTIONS(3196),
    [anon_sym_LT_LT] = ACTIONS(3196),
    [anon_sym_AMP] = ACTIONS(3194),
    [anon_sym_CARET] = ACTIONS(3196),
    [anon_sym_PIPE] = ACTIONS(3194),
    [anon_sym_PLUS] = ACTIONS(3194),
    [anon_sym_DASH] = ACTIONS(3194),
    [anon_sym_PERCENT] = ACTIONS(3196),
    [anon_sym_STAR_STAR] = ACTIONS(3196),
    [anon_sym_LT_EQ] = ACTIONS(3196),
    [anon_sym_EQ_EQ] = ACTIONS(3194),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3196),
    [anon_sym_BANG_EQ] = ACTIONS(3194),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3196),
    [anon_sym_GT_EQ] = ACTIONS(3196),
    [anon_sym_QMARK_QMARK] = ACTIONS(3196),
    [anon_sym_instanceof] = ACTIONS(3194),
    [anon_sym_void] = ACTIONS(3194),
    [anon_sym_PLUS_PLUS] = ACTIONS(3196),
    [anon_sym_DASH_DASH] = ACTIONS(3196),
    [anon_sym_DQUOTE] = ACTIONS(3196),
    [anon_sym_SQUOTE] = ACTIONS(3196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3196),
    [sym_number] = ACTIONS(3196),
    [sym_this] = ACTIONS(3194),
    [sym_true] = ACTIONS(3194),
    [sym_false] = ACTIONS(3194),
    [sym_null] = ACTIONS(3194),
    [sym_undefined] = ACTIONS(3194),
    [anon_sym_static] = ACTIONS(3194),
    [anon_sym_readonly] = ACTIONS(3194),
    [anon_sym_get] = ACTIONS(3194),
    [anon_sym_set] = ACTIONS(3194),
    [anon_sym_QMARK] = ACTIONS(3194),
    [anon_sym_any] = ACTIONS(3194),
    [anon_sym_number] = ACTIONS(3194),
    [anon_sym_boolean] = ACTIONS(3194),
    [anon_sym_string] = ACTIONS(3194),
    [anon_sym_symbol] = ACTIONS(3194),
    [anon_sym_abstract] = ACTIONS(3194),
    [anon_sym_satisfies] = ACTIONS(3194),
    [anon_sym_extends] = ACTIONS(3194),
    [anon_sym_infer] = ACTIONS(3194),
    [anon_sym_keyof] = ACTIONS(3194),
    [anon_sym_unknown] = ACTIONS(3194),
    [anon_sym_never] = ACTIONS(3194),
    [anon_sym_object] = ACTIONS(3194),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3196),
    [anon_sym_constructor] = ACTIONS(3194),
    [anon_sym_prop] = ACTIONS(3194),
    [anon_sym_id] = ACTIONS(3194),
    [anon_sym_event] = ACTIONS(3194),
    [anon_sym_fn] = ACTIONS(3194),
    [anon_sym_on] = ACTIONS(3194),
    [sym__ternary_qmark] = ACTIONS(3196),
  },
  [906] = {
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_STAR] = ACTIONS(3198),
    [anon_sym_as] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3200),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(3200),
    [anon_sym_in] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3200),
    [anon_sym_LBRACK] = ACTIONS(3200),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_GT] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_DOT] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_QMARK_DOT] = ACTIONS(3200),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_AMP_AMP] = ACTIONS(3200),
    [anon_sym_PIPE_PIPE] = ACTIONS(3200),
    [anon_sym_GT_GT] = ACTIONS(3198),
    [anon_sym_GT_GT_GT] = ACTIONS(3200),
    [anon_sym_LT_LT] = ACTIONS(3200),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_CARET] = ACTIONS(3200),
    [anon_sym_PIPE] = ACTIONS(3198),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_PERCENT] = ACTIONS(3200),
    [anon_sym_STAR_STAR] = ACTIONS(3200),
    [anon_sym_LT_EQ] = ACTIONS(3200),
    [anon_sym_EQ_EQ] = ACTIONS(3198),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3200),
    [anon_sym_BANG_EQ] = ACTIONS(3198),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3200),
    [anon_sym_GT_EQ] = ACTIONS(3200),
    [anon_sym_QMARK_QMARK] = ACTIONS(3200),
    [anon_sym_instanceof] = ACTIONS(3198),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3200),
    [anon_sym_DASH_DASH] = ACTIONS(3200),
    [anon_sym_DQUOTE] = ACTIONS(3200),
    [anon_sym_SQUOTE] = ACTIONS(3200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3200),
    [sym_number] = ACTIONS(3200),
    [sym_this] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_QMARK] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_abstract] = ACTIONS(3198),
    [anon_sym_satisfies] = ACTIONS(3198),
    [anon_sym_extends] = ACTIONS(3198),
    [anon_sym_infer] = ACTIONS(3198),
    [anon_sym_keyof] = ACTIONS(3198),
    [anon_sym_unknown] = ACTIONS(3198),
    [anon_sym_never] = ACTIONS(3198),
    [anon_sym_object] = ACTIONS(3198),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3200),
    [anon_sym_constructor] = ACTIONS(3198),
    [anon_sym_prop] = ACTIONS(3198),
    [anon_sym_id] = ACTIONS(3198),
    [anon_sym_event] = ACTIONS(3198),
    [anon_sym_fn] = ACTIONS(3198),
    [anon_sym_on] = ACTIONS(3198),
    [sym__ternary_qmark] = ACTIONS(3200),
  },
  [907] = {
    [sym_identifier] = ACTIONS(3190),
    [anon_sym_STAR] = ACTIONS(3190),
    [anon_sym_as] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3190),
    [anon_sym_RBRACE] = ACTIONS(3192),
    [anon_sym_typeof] = ACTIONS(3190),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_LPAREN] = ACTIONS(3192),
    [anon_sym_in] = ACTIONS(3190),
    [anon_sym_SEMI] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_LT] = ACTIONS(3190),
    [anon_sym_GT] = ACTIONS(3190),
    [anon_sym_SLASH] = ACTIONS(3190),
    [anon_sym_DOT] = ACTIONS(3190),
    [anon_sym_async] = ACTIONS(3190),
    [anon_sym_QMARK_DOT] = ACTIONS(3192),
    [anon_sym_new] = ACTIONS(3190),
    [anon_sym_AMP_AMP] = ACTIONS(3192),
    [anon_sym_PIPE_PIPE] = ACTIONS(3192),
    [anon_sym_GT_GT] = ACTIONS(3190),
    [anon_sym_GT_GT_GT] = ACTIONS(3192),
    [anon_sym_LT_LT] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(3190),
    [anon_sym_CARET] = ACTIONS(3192),
    [anon_sym_PIPE] = ACTIONS(3190),
    [anon_sym_PLUS] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3190),
    [anon_sym_PERCENT] = ACTIONS(3192),
    [anon_sym_STAR_STAR] = ACTIONS(3192),
    [anon_sym_LT_EQ] = ACTIONS(3192),
    [anon_sym_EQ_EQ] = ACTIONS(3190),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3192),
    [anon_sym_BANG_EQ] = ACTIONS(3190),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3192),
    [anon_sym_GT_EQ] = ACTIONS(3192),
    [anon_sym_QMARK_QMARK] = ACTIONS(3192),
    [anon_sym_instanceof] = ACTIONS(3190),
    [anon_sym_void] = ACTIONS(3190),
    [anon_sym_PLUS_PLUS] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3192),
    [anon_sym_DQUOTE] = ACTIONS(3192),
    [anon_sym_SQUOTE] = ACTIONS(3192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3192),
    [sym_number] = ACTIONS(3192),
    [sym_this] = ACTIONS(3190),
    [sym_true] = ACTIONS(3190),
    [sym_false] = ACTIONS(3190),
    [sym_null] = ACTIONS(3190),
    [sym_undefined] = ACTIONS(3190),
    [anon_sym_static] = ACTIONS(3190),
    [anon_sym_readonly] = ACTIONS(3190),
    [anon_sym_get] = ACTIONS(3190),
    [anon_sym_set] = ACTIONS(3190),
    [anon_sym_QMARK] = ACTIONS(3190),
    [anon_sym_any] = ACTIONS(3190),
    [anon_sym_number] = ACTIONS(3190),
    [anon_sym_boolean] = ACTIONS(3190),
    [anon_sym_string] = ACTIONS(3190),
    [anon_sym_symbol] = ACTIONS(3190),
    [anon_sym_abstract] = ACTIONS(3190),
    [anon_sym_satisfies] = ACTIONS(3190),
    [anon_sym_extends] = ACTIONS(3190),
    [anon_sym_infer] = ACTIONS(3190),
    [anon_sym_keyof] = ACTIONS(3190),
    [anon_sym_unknown] = ACTIONS(3190),
    [anon_sym_never] = ACTIONS(3190),
    [anon_sym_object] = ACTIONS(3190),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3192),
    [anon_sym_constructor] = ACTIONS(3190),
    [anon_sym_prop] = ACTIONS(3190),
    [anon_sym_id] = ACTIONS(3190),
    [anon_sym_event] = ACTIONS(3190),
    [anon_sym_fn] = ACTIONS(3190),
    [anon_sym_on] = ACTIONS(3190),
    [sym__ternary_qmark] = ACTIONS(3192),
  },
  [908] = {
    [sym_identifier] = ACTIONS(1366),
    [anon_sym_STAR] = ACTIONS(1366),
    [anon_sym_as] = ACTIONS(1366),
    [anon_sym_LBRACE] = ACTIONS(1366),
    [anon_sym_RBRACE] = ACTIONS(1370),
    [anon_sym_typeof] = ACTIONS(1366),
    [anon_sym_BANG] = ACTIONS(1366),
    [anon_sym_LPAREN] = ACTIONS(1370),
    [anon_sym_in] = ACTIONS(1366),
    [anon_sym_SEMI] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_GT] = ACTIONS(1366),
    [anon_sym_SLASH] = ACTIONS(1366),
    [anon_sym_DOT] = ACTIONS(1366),
    [anon_sym_async] = ACTIONS(1366),
    [anon_sym_QMARK_DOT] = ACTIONS(1370),
    [anon_sym_new] = ACTIONS(1366),
    [anon_sym_AMP_AMP] = ACTIONS(1370),
    [anon_sym_PIPE_PIPE] = ACTIONS(1370),
    [anon_sym_GT_GT] = ACTIONS(1366),
    [anon_sym_GT_GT_GT] = ACTIONS(1370),
    [anon_sym_LT_LT] = ACTIONS(1370),
    [anon_sym_AMP] = ACTIONS(1366),
    [anon_sym_CARET] = ACTIONS(1370),
    [anon_sym_PIPE] = ACTIONS(1366),
    [anon_sym_PLUS] = ACTIONS(1366),
    [anon_sym_DASH] = ACTIONS(1366),
    [anon_sym_PERCENT] = ACTIONS(1370),
    [anon_sym_STAR_STAR] = ACTIONS(1370),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_EQ_EQ] = ACTIONS(1366),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG_EQ] = ACTIONS(1366),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_QMARK_QMARK] = ACTIONS(1370),
    [anon_sym_instanceof] = ACTIONS(1366),
    [anon_sym_void] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_DQUOTE] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1370),
    [sym_number] = ACTIONS(1370),
    [sym_this] = ACTIONS(1366),
    [sym_true] = ACTIONS(1366),
    [sym_false] = ACTIONS(1366),
    [sym_null] = ACTIONS(1366),
    [sym_undefined] = ACTIONS(1366),
    [anon_sym_static] = ACTIONS(1366),
    [anon_sym_readonly] = ACTIONS(1366),
    [anon_sym_get] = ACTIONS(1366),
    [anon_sym_set] = ACTIONS(1366),
    [anon_sym_QMARK] = ACTIONS(1366),
    [anon_sym_any] = ACTIONS(1366),
    [anon_sym_number] = ACTIONS(1366),
    [anon_sym_boolean] = ACTIONS(1366),
    [anon_sym_string] = ACTIONS(1366),
    [anon_sym_symbol] = ACTIONS(1366),
    [anon_sym_abstract] = ACTIONS(1366),
    [anon_sym_satisfies] = ACTIONS(1366),
    [anon_sym_infer] = ACTIONS(1366),
    [anon_sym_keyof] = ACTIONS(1366),
    [anon_sym_unknown] = ACTIONS(1366),
    [anon_sym_never] = ACTIONS(1366),
    [anon_sym_object] = ACTIONS(1366),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1370),
    [anon_sym_constructor] = ACTIONS(1366),
    [anon_sym_prop] = ACTIONS(1366),
    [anon_sym_id] = ACTIONS(1366),
    [anon_sym_event] = ACTIONS(1366),
    [anon_sym_fn] = ACTIONS(1366),
    [anon_sym_on] = ACTIONS(1366),
    [sym__automatic_semicolon] = ACTIONS(2778),
    [sym__ternary_qmark] = ACTIONS(1370),
  },
  [909] = {
    [sym_identifier] = ACTIONS(3152),
    [anon_sym_STAR] = ACTIONS(3152),
    [anon_sym_as] = ACTIONS(3152),
    [anon_sym_LBRACE] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(3154),
    [anon_sym_typeof] = ACTIONS(3152),
    [anon_sym_BANG] = ACTIONS(3152),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_in] = ACTIONS(3152),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_LT] = ACTIONS(3152),
    [anon_sym_GT] = ACTIONS(3152),
    [anon_sym_SLASH] = ACTIONS(3152),
    [anon_sym_DOT] = ACTIONS(3152),
    [anon_sym_async] = ACTIONS(3152),
    [anon_sym_QMARK_DOT] = ACTIONS(3154),
    [anon_sym_new] = ACTIONS(3152),
    [anon_sym_AMP_AMP] = ACTIONS(3154),
    [anon_sym_PIPE_PIPE] = ACTIONS(3154),
    [anon_sym_GT_GT] = ACTIONS(3152),
    [anon_sym_GT_GT_GT] = ACTIONS(3154),
    [anon_sym_LT_LT] = ACTIONS(3154),
    [anon_sym_AMP] = ACTIONS(3152),
    [anon_sym_CARET] = ACTIONS(3154),
    [anon_sym_PIPE] = ACTIONS(3152),
    [anon_sym_PLUS] = ACTIONS(3152),
    [anon_sym_DASH] = ACTIONS(3152),
    [anon_sym_PERCENT] = ACTIONS(3154),
    [anon_sym_STAR_STAR] = ACTIONS(3154),
    [anon_sym_LT_EQ] = ACTIONS(3154),
    [anon_sym_EQ_EQ] = ACTIONS(3152),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3154),
    [anon_sym_BANG_EQ] = ACTIONS(3152),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3154),
    [anon_sym_GT_EQ] = ACTIONS(3154),
    [anon_sym_QMARK_QMARK] = ACTIONS(3154),
    [anon_sym_instanceof] = ACTIONS(3152),
    [anon_sym_void] = ACTIONS(3152),
    [anon_sym_PLUS_PLUS] = ACTIONS(3154),
    [anon_sym_DASH_DASH] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_SQUOTE] = ACTIONS(3154),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3154),
    [sym_number] = ACTIONS(3154),
    [sym_this] = ACTIONS(3152),
    [sym_true] = ACTIONS(3152),
    [sym_false] = ACTIONS(3152),
    [sym_null] = ACTIONS(3152),
    [sym_undefined] = ACTIONS(3152),
    [anon_sym_static] = ACTIONS(3152),
    [anon_sym_readonly] = ACTIONS(3152),
    [anon_sym_get] = ACTIONS(3152),
    [anon_sym_set] = ACTIONS(3152),
    [anon_sym_QMARK] = ACTIONS(3152),
    [anon_sym_any] = ACTIONS(3152),
    [anon_sym_number] = ACTIONS(3152),
    [anon_sym_boolean] = ACTIONS(3152),
    [anon_sym_string] = ACTIONS(3152),
    [anon_sym_symbol] = ACTIONS(3152),
    [anon_sym_abstract] = ACTIONS(3152),
    [anon_sym_satisfies] = ACTIONS(3152),
    [anon_sym_extends] = ACTIONS(3152),
    [anon_sym_infer] = ACTIONS(3152),
    [anon_sym_keyof] = ACTIONS(3152),
    [anon_sym_unknown] = ACTIONS(3152),
    [anon_sym_never] = ACTIONS(3152),
    [anon_sym_object] = ACTIONS(3152),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3154),
    [anon_sym_constructor] = ACTIONS(3152),
    [anon_sym_prop] = ACTIONS(3152),
    [anon_sym_id] = ACTIONS(3152),
    [anon_sym_event] = ACTIONS(3152),
    [anon_sym_fn] = ACTIONS(3152),
    [anon_sym_on] = ACTIONS(3152),
    [sym__ternary_qmark] = ACTIONS(3154),
  },
  [910] = {
    [sym_identifier] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3194),
    [anon_sym_as] = ACTIONS(3194),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3196),
    [anon_sym_typeof] = ACTIONS(3194),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_LPAREN] = ACTIONS(3196),
    [anon_sym_in] = ACTIONS(3194),
    [anon_sym_SEMI] = ACTIONS(3196),
    [anon_sym_LBRACK] = ACTIONS(3196),
    [anon_sym_LT] = ACTIONS(3194),
    [anon_sym_GT] = ACTIONS(3194),
    [anon_sym_SLASH] = ACTIONS(3194),
    [anon_sym_DOT] = ACTIONS(3194),
    [anon_sym_async] = ACTIONS(3194),
    [anon_sym_QMARK_DOT] = ACTIONS(3196),
    [anon_sym_new] = ACTIONS(3194),
    [anon_sym_AMP_AMP] = ACTIONS(3196),
    [anon_sym_PIPE_PIPE] = ACTIONS(3196),
    [anon_sym_GT_GT] = ACTIONS(3194),
    [anon_sym_GT_GT_GT] = ACTIONS(3196),
    [anon_sym_LT_LT] = ACTIONS(3196),
    [anon_sym_AMP] = ACTIONS(3194),
    [anon_sym_CARET] = ACTIONS(3196),
    [anon_sym_PIPE] = ACTIONS(3194),
    [anon_sym_PLUS] = ACTIONS(3194),
    [anon_sym_DASH] = ACTIONS(3194),
    [anon_sym_PERCENT] = ACTIONS(3196),
    [anon_sym_STAR_STAR] = ACTIONS(3196),
    [anon_sym_LT_EQ] = ACTIONS(3196),
    [anon_sym_EQ_EQ] = ACTIONS(3194),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3196),
    [anon_sym_BANG_EQ] = ACTIONS(3194),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3196),
    [anon_sym_GT_EQ] = ACTIONS(3196),
    [anon_sym_QMARK_QMARK] = ACTIONS(3196),
    [anon_sym_instanceof] = ACTIONS(3194),
    [anon_sym_void] = ACTIONS(3194),
    [anon_sym_PLUS_PLUS] = ACTIONS(3196),
    [anon_sym_DASH_DASH] = ACTIONS(3196),
    [anon_sym_DQUOTE] = ACTIONS(3196),
    [anon_sym_SQUOTE] = ACTIONS(3196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3196),
    [sym_number] = ACTIONS(3196),
    [sym_this] = ACTIONS(3194),
    [sym_true] = ACTIONS(3194),
    [sym_false] = ACTIONS(3194),
    [sym_null] = ACTIONS(3194),
    [sym_undefined] = ACTIONS(3194),
    [anon_sym_static] = ACTIONS(3194),
    [anon_sym_readonly] = ACTIONS(3194),
    [anon_sym_get] = ACTIONS(3194),
    [anon_sym_set] = ACTIONS(3194),
    [anon_sym_QMARK] = ACTIONS(3194),
    [anon_sym_any] = ACTIONS(3194),
    [anon_sym_number] = ACTIONS(3194),
    [anon_sym_boolean] = ACTIONS(3194),
    [anon_sym_string] = ACTIONS(3194),
    [anon_sym_symbol] = ACTIONS(3194),
    [anon_sym_abstract] = ACTIONS(3194),
    [anon_sym_satisfies] = ACTIONS(3194),
    [anon_sym_extends] = ACTIONS(3194),
    [anon_sym_infer] = ACTIONS(3194),
    [anon_sym_keyof] = ACTIONS(3194),
    [anon_sym_unknown] = ACTIONS(3194),
    [anon_sym_never] = ACTIONS(3194),
    [anon_sym_object] = ACTIONS(3194),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3196),
    [anon_sym_constructor] = ACTIONS(3194),
    [anon_sym_prop] = ACTIONS(3194),
    [anon_sym_id] = ACTIONS(3194),
    [anon_sym_event] = ACTIONS(3194),
    [anon_sym_fn] = ACTIONS(3194),
    [anon_sym_on] = ACTIONS(3194),
    [sym__ternary_qmark] = ACTIONS(3196),
  },
  [911] = {
    [sym_identifier] = ACTIONS(2834),
    [anon_sym_STAR] = ACTIONS(2834),
    [anon_sym_as] = ACTIONS(2834),
    [anon_sym_LBRACE] = ACTIONS(2834),
    [anon_sym_RBRACE] = ACTIONS(2836),
    [anon_sym_typeof] = ACTIONS(2834),
    [anon_sym_BANG] = ACTIONS(2834),
    [anon_sym_LPAREN] = ACTIONS(2836),
    [anon_sym_in] = ACTIONS(2834),
    [anon_sym_SEMI] = ACTIONS(2836),
    [anon_sym_LBRACK] = ACTIONS(2836),
    [anon_sym_LT] = ACTIONS(2834),
    [anon_sym_GT] = ACTIONS(2834),
    [anon_sym_SLASH] = ACTIONS(2834),
    [anon_sym_DOT] = ACTIONS(2834),
    [anon_sym_async] = ACTIONS(2834),
    [anon_sym_QMARK_DOT] = ACTIONS(2836),
    [anon_sym_new] = ACTIONS(2834),
    [anon_sym_AMP_AMP] = ACTIONS(2836),
    [anon_sym_PIPE_PIPE] = ACTIONS(2836),
    [anon_sym_GT_GT] = ACTIONS(2834),
    [anon_sym_GT_GT_GT] = ACTIONS(2836),
    [anon_sym_LT_LT] = ACTIONS(2836),
    [anon_sym_AMP] = ACTIONS(2834),
    [anon_sym_CARET] = ACTIONS(2836),
    [anon_sym_PIPE] = ACTIONS(2834),
    [anon_sym_PLUS] = ACTIONS(2834),
    [anon_sym_DASH] = ACTIONS(2834),
    [anon_sym_PERCENT] = ACTIONS(2836),
    [anon_sym_STAR_STAR] = ACTIONS(2836),
    [anon_sym_LT_EQ] = ACTIONS(2836),
    [anon_sym_EQ_EQ] = ACTIONS(2834),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2836),
    [anon_sym_BANG_EQ] = ACTIONS(2834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2836),
    [anon_sym_GT_EQ] = ACTIONS(2836),
    [anon_sym_QMARK_QMARK] = ACTIONS(2836),
    [anon_sym_instanceof] = ACTIONS(2834),
    [anon_sym_void] = ACTIONS(2834),
    [anon_sym_PLUS_PLUS] = ACTIONS(2836),
    [anon_sym_DASH_DASH] = ACTIONS(2836),
    [anon_sym_DQUOTE] = ACTIONS(2836),
    [anon_sym_SQUOTE] = ACTIONS(2836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2836),
    [sym_number] = ACTIONS(2836),
    [sym_this] = ACTIONS(2834),
    [sym_true] = ACTIONS(2834),
    [sym_false] = ACTIONS(2834),
    [sym_null] = ACTIONS(2834),
    [sym_undefined] = ACTIONS(2834),
    [anon_sym_static] = ACTIONS(2834),
    [anon_sym_readonly] = ACTIONS(2834),
    [anon_sym_get] = ACTIONS(2834),
    [anon_sym_set] = ACTIONS(2834),
    [anon_sym_QMARK] = ACTIONS(2834),
    [anon_sym_any] = ACTIONS(2834),
    [anon_sym_number] = ACTIONS(2834),
    [anon_sym_boolean] = ACTIONS(2834),
    [anon_sym_string] = ACTIONS(2834),
    [anon_sym_symbol] = ACTIONS(2834),
    [anon_sym_abstract] = ACTIONS(2834),
    [anon_sym_satisfies] = ACTIONS(2834),
    [anon_sym_extends] = ACTIONS(2834),
    [anon_sym_infer] = ACTIONS(2834),
    [anon_sym_keyof] = ACTIONS(2834),
    [anon_sym_unknown] = ACTIONS(2834),
    [anon_sym_never] = ACTIONS(2834),
    [anon_sym_object] = ACTIONS(2834),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2836),
    [anon_sym_constructor] = ACTIONS(2834),
    [anon_sym_prop] = ACTIONS(2834),
    [anon_sym_id] = ACTIONS(2834),
    [anon_sym_event] = ACTIONS(2834),
    [anon_sym_fn] = ACTIONS(2834),
    [anon_sym_on] = ACTIONS(2834),
    [sym__ternary_qmark] = ACTIONS(2836),
  },
  [912] = {
    [sym_identifier] = ACTIONS(3190),
    [anon_sym_STAR] = ACTIONS(3190),
    [anon_sym_as] = ACTIONS(3190),
    [anon_sym_LBRACE] = ACTIONS(3190),
    [anon_sym_RBRACE] = ACTIONS(3192),
    [anon_sym_typeof] = ACTIONS(3190),
    [anon_sym_BANG] = ACTIONS(3190),
    [anon_sym_LPAREN] = ACTIONS(3192),
    [anon_sym_in] = ACTIONS(3190),
    [anon_sym_SEMI] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_LT] = ACTIONS(3190),
    [anon_sym_GT] = ACTIONS(3190),
    [anon_sym_SLASH] = ACTIONS(3190),
    [anon_sym_DOT] = ACTIONS(3190),
    [anon_sym_async] = ACTIONS(3190),
    [anon_sym_QMARK_DOT] = ACTIONS(3192),
    [anon_sym_new] = ACTIONS(3190),
    [anon_sym_AMP_AMP] = ACTIONS(3192),
    [anon_sym_PIPE_PIPE] = ACTIONS(3192),
    [anon_sym_GT_GT] = ACTIONS(3190),
    [anon_sym_GT_GT_GT] = ACTIONS(3192),
    [anon_sym_LT_LT] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(3190),
    [anon_sym_CARET] = ACTIONS(3192),
    [anon_sym_PIPE] = ACTIONS(3190),
    [anon_sym_PLUS] = ACTIONS(3190),
    [anon_sym_DASH] = ACTIONS(3190),
    [anon_sym_PERCENT] = ACTIONS(3192),
    [anon_sym_STAR_STAR] = ACTIONS(3192),
    [anon_sym_LT_EQ] = ACTIONS(3192),
    [anon_sym_EQ_EQ] = ACTIONS(3190),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3192),
    [anon_sym_BANG_EQ] = ACTIONS(3190),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3192),
    [anon_sym_GT_EQ] = ACTIONS(3192),
    [anon_sym_QMARK_QMARK] = ACTIONS(3192),
    [anon_sym_instanceof] = ACTIONS(3190),
    [anon_sym_void] = ACTIONS(3190),
    [anon_sym_PLUS_PLUS] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3192),
    [anon_sym_DQUOTE] = ACTIONS(3192),
    [anon_sym_SQUOTE] = ACTIONS(3192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3192),
    [sym_number] = ACTIONS(3192),
    [sym_this] = ACTIONS(3190),
    [sym_true] = ACTIONS(3190),
    [sym_false] = ACTIONS(3190),
    [sym_null] = ACTIONS(3190),
    [sym_undefined] = ACTIONS(3190),
    [anon_sym_static] = ACTIONS(3190),
    [anon_sym_readonly] = ACTIONS(3190),
    [anon_sym_get] = ACTIONS(3190),
    [anon_sym_set] = ACTIONS(3190),
    [anon_sym_QMARK] = ACTIONS(3190),
    [anon_sym_any] = ACTIONS(3190),
    [anon_sym_number] = ACTIONS(3190),
    [anon_sym_boolean] = ACTIONS(3190),
    [anon_sym_string] = ACTIONS(3190),
    [anon_sym_symbol] = ACTIONS(3190),
    [anon_sym_abstract] = ACTIONS(3190),
    [anon_sym_satisfies] = ACTIONS(3190),
    [anon_sym_extends] = ACTIONS(3190),
    [anon_sym_infer] = ACTIONS(3190),
    [anon_sym_keyof] = ACTIONS(3190),
    [anon_sym_unknown] = ACTIONS(3190),
    [anon_sym_never] = ACTIONS(3190),
    [anon_sym_object] = ACTIONS(3190),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3192),
    [anon_sym_constructor] = ACTIONS(3190),
    [anon_sym_prop] = ACTIONS(3190),
    [anon_sym_id] = ACTIONS(3190),
    [anon_sym_event] = ACTIONS(3190),
    [anon_sym_fn] = ACTIONS(3190),
    [anon_sym_on] = ACTIONS(3190),
    [sym__ternary_qmark] = ACTIONS(3192),
  },
  [913] = {
    [sym_identifier] = ACTIONS(3202),
    [anon_sym_STAR] = ACTIONS(3202),
    [anon_sym_as] = ACTIONS(3202),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_typeof] = ACTIONS(3202),
    [anon_sym_BANG] = ACTIONS(3202),
    [anon_sym_LPAREN] = ACTIONS(3204),
    [anon_sym_in] = ACTIONS(3202),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3202),
    [anon_sym_GT] = ACTIONS(3202),
    [anon_sym_SLASH] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(3202),
    [anon_sym_async] = ACTIONS(3202),
    [anon_sym_QMARK_DOT] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(3204),
    [anon_sym_GT_GT] = ACTIONS(3202),
    [anon_sym_GT_GT_GT] = ACTIONS(3204),
    [anon_sym_LT_LT] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_CARET] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(3204),
    [anon_sym_LT_EQ] = ACTIONS(3204),
    [anon_sym_EQ_EQ] = ACTIONS(3202),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3204),
    [anon_sym_BANG_EQ] = ACTIONS(3202),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3204),
    [anon_sym_GT_EQ] = ACTIONS(3204),
    [anon_sym_QMARK_QMARK] = ACTIONS(3204),
    [anon_sym_instanceof] = ACTIONS(3202),
    [anon_sym_void] = ACTIONS(3202),
    [anon_sym_PLUS_PLUS] = ACTIONS(3204),
    [anon_sym_DASH_DASH] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3204),
    [anon_sym_SQUOTE] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3204),
    [sym_number] = ACTIONS(3204),
    [sym_this] = ACTIONS(3202),
    [sym_true] = ACTIONS(3202),
    [sym_false] = ACTIONS(3202),
    [sym_null] = ACTIONS(3202),
    [sym_undefined] = ACTIONS(3202),
    [anon_sym_static] = ACTIONS(3202),
    [anon_sym_readonly] = ACTIONS(3202),
    [anon_sym_get] = ACTIONS(3202),
    [anon_sym_set] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_any] = ACTIONS(3202),
    [anon_sym_number] = ACTIONS(3202),
    [anon_sym_boolean] = ACTIONS(3202),
    [anon_sym_string] = ACTIONS(3202),
    [anon_sym_symbol] = ACTIONS(3202),
    [anon_sym_abstract] = ACTIONS(3202),
    [anon_sym_satisfies] = ACTIONS(3202),
    [anon_sym_extends] = ACTIONS(3202),
    [anon_sym_infer] = ACTIONS(3202),
    [anon_sym_keyof] = ACTIONS(3202),
    [anon_sym_unknown] = ACTIONS(3202),
    [anon_sym_never] = ACTIONS(3202),
    [anon_sym_object] = ACTIONS(3202),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3204),
    [anon_sym_constructor] = ACTIONS(3202),
    [anon_sym_prop] = ACTIONS(3202),
    [anon_sym_id] = ACTIONS(3202),
    [anon_sym_event] = ACTIONS(3202),
    [anon_sym_fn] = ACTIONS(3202),
    [anon_sym_on] = ACTIONS(3202),
    [sym__ternary_qmark] = ACTIONS(3204),
  },
  [914] = {
    [sym_identifier] = ACTIONS(3206),
    [anon_sym_STAR] = ACTIONS(3206),
    [anon_sym_as] = ACTIONS(3206),
    [anon_sym_LBRACE] = ACTIONS(3206),
    [anon_sym_RBRACE] = ACTIONS(3208),
    [anon_sym_typeof] = ACTIONS(3206),
    [anon_sym_BANG] = ACTIONS(3206),
    [anon_sym_LPAREN] = ACTIONS(3208),
    [anon_sym_in] = ACTIONS(3206),
    [anon_sym_SEMI] = ACTIONS(3208),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_LT] = ACTIONS(3206),
    [anon_sym_GT] = ACTIONS(3206),
    [anon_sym_SLASH] = ACTIONS(3206),
    [anon_sym_DOT] = ACTIONS(3206),
    [anon_sym_async] = ACTIONS(3206),
    [anon_sym_QMARK_DOT] = ACTIONS(3208),
    [anon_sym_new] = ACTIONS(3206),
    [anon_sym_AMP_AMP] = ACTIONS(3208),
    [anon_sym_PIPE_PIPE] = ACTIONS(3208),
    [anon_sym_GT_GT] = ACTIONS(3206),
    [anon_sym_GT_GT_GT] = ACTIONS(3208),
    [anon_sym_LT_LT] = ACTIONS(3208),
    [anon_sym_AMP] = ACTIONS(3206),
    [anon_sym_CARET] = ACTIONS(3208),
    [anon_sym_PIPE] = ACTIONS(3206),
    [anon_sym_PLUS] = ACTIONS(3206),
    [anon_sym_DASH] = ACTIONS(3206),
    [anon_sym_PERCENT] = ACTIONS(3208),
    [anon_sym_STAR_STAR] = ACTIONS(3208),
    [anon_sym_LT_EQ] = ACTIONS(3208),
    [anon_sym_EQ_EQ] = ACTIONS(3206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3208),
    [anon_sym_BANG_EQ] = ACTIONS(3206),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3208),
    [anon_sym_GT_EQ] = ACTIONS(3208),
    [anon_sym_QMARK_QMARK] = ACTIONS(3208),
    [anon_sym_instanceof] = ACTIONS(3206),
    [anon_sym_void] = ACTIONS(3206),
    [anon_sym_PLUS_PLUS] = ACTIONS(3208),
    [anon_sym_DASH_DASH] = ACTIONS(3208),
    [anon_sym_DQUOTE] = ACTIONS(3208),
    [anon_sym_SQUOTE] = ACTIONS(3208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3208),
    [sym_number] = ACTIONS(3208),
    [sym_this] = ACTIONS(3206),
    [sym_true] = ACTIONS(3206),
    [sym_false] = ACTIONS(3206),
    [sym_null] = ACTIONS(3206),
    [sym_undefined] = ACTIONS(3206),
    [anon_sym_static] = ACTIONS(3206),
    [anon_sym_readonly] = ACTIONS(3206),
    [anon_sym_get] = ACTIONS(3206),
    [anon_sym_set] = ACTIONS(3206),
    [anon_sym_QMARK] = ACTIONS(3206),
    [anon_sym_any] = ACTIONS(3206),
    [anon_sym_number] = ACTIONS(3206),
    [anon_sym_boolean] = ACTIONS(3206),
    [anon_sym_string] = ACTIONS(3206),
    [anon_sym_symbol] = ACTIONS(3206),
    [anon_sym_abstract] = ACTIONS(3206),
    [anon_sym_satisfies] = ACTIONS(3206),
    [anon_sym_extends] = ACTIONS(3206),
    [anon_sym_infer] = ACTIONS(3206),
    [anon_sym_keyof] = ACTIONS(3206),
    [anon_sym_unknown] = ACTIONS(3206),
    [anon_sym_never] = ACTIONS(3206),
    [anon_sym_object] = ACTIONS(3206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3208),
    [anon_sym_constructor] = ACTIONS(3206),
    [anon_sym_prop] = ACTIONS(3206),
    [anon_sym_id] = ACTIONS(3206),
    [anon_sym_event] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(3206),
    [anon_sym_on] = ACTIONS(3206),
    [sym__ternary_qmark] = ACTIONS(3208),
  },
  [915] = {
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_STAR] = ACTIONS(2738),
    [anon_sym_as] = ACTIONS(2738),
    [anon_sym_LBRACE] = ACTIONS(2738),
    [anon_sym_RBRACE] = ACTIONS(2740),
    [anon_sym_typeof] = ACTIONS(2738),
    [anon_sym_BANG] = ACTIONS(2738),
    [anon_sym_LPAREN] = ACTIONS(2740),
    [anon_sym_in] = ACTIONS(2738),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym_LBRACK] = ACTIONS(2740),
    [anon_sym_LT] = ACTIONS(2738),
    [anon_sym_GT] = ACTIONS(2738),
    [anon_sym_SLASH] = ACTIONS(2738),
    [anon_sym_DOT] = ACTIONS(2738),
    [anon_sym_async] = ACTIONS(2738),
    [anon_sym_QMARK_DOT] = ACTIONS(2740),
    [anon_sym_new] = ACTIONS(2738),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_PIPE_PIPE] = ACTIONS(2740),
    [anon_sym_GT_GT] = ACTIONS(2738),
    [anon_sym_GT_GT_GT] = ACTIONS(2740),
    [anon_sym_LT_LT] = ACTIONS(2740),
    [anon_sym_AMP] = ACTIONS(2738),
    [anon_sym_CARET] = ACTIONS(2740),
    [anon_sym_PIPE] = ACTIONS(2738),
    [anon_sym_PLUS] = ACTIONS(2738),
    [anon_sym_DASH] = ACTIONS(2738),
    [anon_sym_PERCENT] = ACTIONS(2740),
    [anon_sym_STAR_STAR] = ACTIONS(2740),
    [anon_sym_LT_EQ] = ACTIONS(2740),
    [anon_sym_EQ_EQ] = ACTIONS(2738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2738),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2740),
    [anon_sym_GT_EQ] = ACTIONS(2740),
    [anon_sym_QMARK_QMARK] = ACTIONS(2740),
    [anon_sym_instanceof] = ACTIONS(2738),
    [anon_sym_void] = ACTIONS(2738),
    [anon_sym_PLUS_PLUS] = ACTIONS(2740),
    [anon_sym_DASH_DASH] = ACTIONS(2740),
    [anon_sym_DQUOTE] = ACTIONS(2740),
    [anon_sym_SQUOTE] = ACTIONS(2740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2740),
    [sym_number] = ACTIONS(2740),
    [sym_this] = ACTIONS(2738),
    [sym_true] = ACTIONS(2738),
    [sym_false] = ACTIONS(2738),
    [sym_null] = ACTIONS(2738),
    [sym_undefined] = ACTIONS(2738),
    [anon_sym_static] = ACTIONS(2738),
    [anon_sym_readonly] = ACTIONS(2738),
    [anon_sym_get] = ACTIONS(2738),
    [anon_sym_set] = ACTIONS(2738),
    [anon_sym_QMARK] = ACTIONS(2738),
    [anon_sym_any] = ACTIONS(2738),
    [anon_sym_number] = ACTIONS(2738),
    [anon_sym_boolean] = ACTIONS(2738),
    [anon_sym_string] = ACTIONS(2738),
    [anon_sym_symbol] = ACTIONS(2738),
    [anon_sym_abstract] = ACTIONS(2738),
    [anon_sym_satisfies] = ACTIONS(2738),
    [anon_sym_extends] = ACTIONS(2738),
    [anon_sym_infer] = ACTIONS(2738),
    [anon_sym_keyof] = ACTIONS(2738),
    [anon_sym_unknown] = ACTIONS(2738),
    [anon_sym_never] = ACTIONS(2738),
    [anon_sym_object] = ACTIONS(2738),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2740),
    [anon_sym_constructor] = ACTIONS(2738),
    [anon_sym_prop] = ACTIONS(2738),
    [anon_sym_id] = ACTIONS(2738),
    [anon_sym_event] = ACTIONS(2738),
    [anon_sym_fn] = ACTIONS(2738),
    [anon_sym_on] = ACTIONS(2738),
    [sym__ternary_qmark] = ACTIONS(2740),
  },
  [916] = {
    [sym_identifier] = ACTIONS(3206),
    [anon_sym_STAR] = ACTIONS(3206),
    [anon_sym_as] = ACTIONS(3206),
    [anon_sym_LBRACE] = ACTIONS(3206),
    [anon_sym_RBRACE] = ACTIONS(3208),
    [anon_sym_typeof] = ACTIONS(3206),
    [anon_sym_BANG] = ACTIONS(3206),
    [anon_sym_LPAREN] = ACTIONS(3208),
    [anon_sym_in] = ACTIONS(3206),
    [anon_sym_SEMI] = ACTIONS(3208),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_LT] = ACTIONS(3206),
    [anon_sym_GT] = ACTIONS(3206),
    [anon_sym_SLASH] = ACTIONS(3206),
    [anon_sym_DOT] = ACTIONS(3206),
    [anon_sym_async] = ACTIONS(3206),
    [anon_sym_QMARK_DOT] = ACTIONS(3208),
    [anon_sym_new] = ACTIONS(3206),
    [anon_sym_AMP_AMP] = ACTIONS(3208),
    [anon_sym_PIPE_PIPE] = ACTIONS(3208),
    [anon_sym_GT_GT] = ACTIONS(3206),
    [anon_sym_GT_GT_GT] = ACTIONS(3208),
    [anon_sym_LT_LT] = ACTIONS(3208),
    [anon_sym_AMP] = ACTIONS(3206),
    [anon_sym_CARET] = ACTIONS(3208),
    [anon_sym_PIPE] = ACTIONS(3206),
    [anon_sym_PLUS] = ACTIONS(3206),
    [anon_sym_DASH] = ACTIONS(3206),
    [anon_sym_PERCENT] = ACTIONS(3208),
    [anon_sym_STAR_STAR] = ACTIONS(3208),
    [anon_sym_LT_EQ] = ACTIONS(3208),
    [anon_sym_EQ_EQ] = ACTIONS(3206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3208),
    [anon_sym_BANG_EQ] = ACTIONS(3206),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3208),
    [anon_sym_GT_EQ] = ACTIONS(3208),
    [anon_sym_QMARK_QMARK] = ACTIONS(3208),
    [anon_sym_instanceof] = ACTIONS(3206),
    [anon_sym_void] = ACTIONS(3206),
    [anon_sym_PLUS_PLUS] = ACTIONS(3208),
    [anon_sym_DASH_DASH] = ACTIONS(3208),
    [anon_sym_DQUOTE] = ACTIONS(3208),
    [anon_sym_SQUOTE] = ACTIONS(3208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3208),
    [sym_number] = ACTIONS(3208),
    [sym_this] = ACTIONS(3206),
    [sym_true] = ACTIONS(3206),
    [sym_false] = ACTIONS(3206),
    [sym_null] = ACTIONS(3206),
    [sym_undefined] = ACTIONS(3206),
    [anon_sym_static] = ACTIONS(3206),
    [anon_sym_readonly] = ACTIONS(3206),
    [anon_sym_get] = ACTIONS(3206),
    [anon_sym_set] = ACTIONS(3206),
    [anon_sym_QMARK] = ACTIONS(3206),
    [anon_sym_any] = ACTIONS(3206),
    [anon_sym_number] = ACTIONS(3206),
    [anon_sym_boolean] = ACTIONS(3206),
    [anon_sym_string] = ACTIONS(3206),
    [anon_sym_symbol] = ACTIONS(3206),
    [anon_sym_abstract] = ACTIONS(3206),
    [anon_sym_satisfies] = ACTIONS(3206),
    [anon_sym_extends] = ACTIONS(3206),
    [anon_sym_infer] = ACTIONS(3206),
    [anon_sym_keyof] = ACTIONS(3206),
    [anon_sym_unknown] = ACTIONS(3206),
    [anon_sym_never] = ACTIONS(3206),
    [anon_sym_object] = ACTIONS(3206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3208),
    [anon_sym_constructor] = ACTIONS(3206),
    [anon_sym_prop] = ACTIONS(3206),
    [anon_sym_id] = ACTIONS(3206),
    [anon_sym_event] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(3206),
    [anon_sym_on] = ACTIONS(3206),
    [sym__ternary_qmark] = ACTIONS(3208),
  },
  [917] = {
    [sym_identifier] = ACTIONS(3206),
    [anon_sym_STAR] = ACTIONS(3206),
    [anon_sym_as] = ACTIONS(3206),
    [anon_sym_LBRACE] = ACTIONS(3206),
    [anon_sym_RBRACE] = ACTIONS(3208),
    [anon_sym_typeof] = ACTIONS(3206),
    [anon_sym_BANG] = ACTIONS(3206),
    [anon_sym_LPAREN] = ACTIONS(3208),
    [anon_sym_in] = ACTIONS(3206),
    [anon_sym_SEMI] = ACTIONS(3208),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_LT] = ACTIONS(3206),
    [anon_sym_GT] = ACTIONS(3206),
    [anon_sym_SLASH] = ACTIONS(3206),
    [anon_sym_DOT] = ACTIONS(3206),
    [anon_sym_async] = ACTIONS(3206),
    [anon_sym_QMARK_DOT] = ACTIONS(3208),
    [anon_sym_new] = ACTIONS(3206),
    [anon_sym_AMP_AMP] = ACTIONS(3208),
    [anon_sym_PIPE_PIPE] = ACTIONS(3208),
    [anon_sym_GT_GT] = ACTIONS(3206),
    [anon_sym_GT_GT_GT] = ACTIONS(3208),
    [anon_sym_LT_LT] = ACTIONS(3208),
    [anon_sym_AMP] = ACTIONS(3206),
    [anon_sym_CARET] = ACTIONS(3208),
    [anon_sym_PIPE] = ACTIONS(3206),
    [anon_sym_PLUS] = ACTIONS(3206),
    [anon_sym_DASH] = ACTIONS(3206),
    [anon_sym_PERCENT] = ACTIONS(3208),
    [anon_sym_STAR_STAR] = ACTIONS(3208),
    [anon_sym_LT_EQ] = ACTIONS(3208),
    [anon_sym_EQ_EQ] = ACTIONS(3206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3208),
    [anon_sym_BANG_EQ] = ACTIONS(3206),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3208),
    [anon_sym_GT_EQ] = ACTIONS(3208),
    [anon_sym_QMARK_QMARK] = ACTIONS(3208),
    [anon_sym_instanceof] = ACTIONS(3206),
    [anon_sym_void] = ACTIONS(3206),
    [anon_sym_PLUS_PLUS] = ACTIONS(3208),
    [anon_sym_DASH_DASH] = ACTIONS(3208),
    [anon_sym_DQUOTE] = ACTIONS(3208),
    [anon_sym_SQUOTE] = ACTIONS(3208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3208),
    [sym_number] = ACTIONS(3208),
    [sym_this] = ACTIONS(3206),
    [sym_true] = ACTIONS(3206),
    [sym_false] = ACTIONS(3206),
    [sym_null] = ACTIONS(3206),
    [sym_undefined] = ACTIONS(3206),
    [anon_sym_static] = ACTIONS(3206),
    [anon_sym_readonly] = ACTIONS(3206),
    [anon_sym_get] = ACTIONS(3206),
    [anon_sym_set] = ACTIONS(3206),
    [anon_sym_QMARK] = ACTIONS(3206),
    [anon_sym_any] = ACTIONS(3206),
    [anon_sym_number] = ACTIONS(3206),
    [anon_sym_boolean] = ACTIONS(3206),
    [anon_sym_string] = ACTIONS(3206),
    [anon_sym_symbol] = ACTIONS(3206),
    [anon_sym_abstract] = ACTIONS(3206),
    [anon_sym_satisfies] = ACTIONS(3206),
    [anon_sym_extends] = ACTIONS(3206),
    [anon_sym_infer] = ACTIONS(3206),
    [anon_sym_keyof] = ACTIONS(3206),
    [anon_sym_unknown] = ACTIONS(3206),
    [anon_sym_never] = ACTIONS(3206),
    [anon_sym_object] = ACTIONS(3206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3208),
    [anon_sym_constructor] = ACTIONS(3206),
    [anon_sym_prop] = ACTIONS(3206),
    [anon_sym_id] = ACTIONS(3206),
    [anon_sym_event] = ACTIONS(3206),
    [anon_sym_fn] = ACTIONS(3206),
    [anon_sym_on] = ACTIONS(3206),
    [sym__ternary_qmark] = ACTIONS(3208),
  },
  [918] = {
    [sym_identifier] = ACTIONS(3210),
    [anon_sym_STAR] = ACTIONS(3210),
    [anon_sym_as] = ACTIONS(3210),
    [anon_sym_LBRACE] = ACTIONS(3210),
    [anon_sym_RBRACE] = ACTIONS(3212),
    [anon_sym_typeof] = ACTIONS(3210),
    [anon_sym_BANG] = ACTIONS(3210),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_in] = ACTIONS(3210),
    [anon_sym_SEMI] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [anon_sym_LT] = ACTIONS(3210),
    [anon_sym_GT] = ACTIONS(3210),
    [anon_sym_SLASH] = ACTIONS(3210),
    [anon_sym_DOT] = ACTIONS(3210),
    [anon_sym_async] = ACTIONS(3210),
    [anon_sym_QMARK_DOT] = ACTIONS(3212),
    [anon_sym_new] = ACTIONS(3210),
    [anon_sym_AMP_AMP] = ACTIONS(3212),
    [anon_sym_PIPE_PIPE] = ACTIONS(3212),
    [anon_sym_GT_GT] = ACTIONS(3210),
    [anon_sym_GT_GT_GT] = ACTIONS(3212),
    [anon_sym_LT_LT] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3210),
    [anon_sym_CARET] = ACTIONS(3212),
    [anon_sym_PIPE] = ACTIONS(3210),
    [anon_sym_PLUS] = ACTIONS(3210),
    [anon_sym_DASH] = ACTIONS(3210),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_LT_EQ] = ACTIONS(3212),
    [anon_sym_EQ_EQ] = ACTIONS(3210),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3212),
    [anon_sym_BANG_EQ] = ACTIONS(3210),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3212),
    [anon_sym_GT_EQ] = ACTIONS(3212),
    [anon_sym_QMARK_QMARK] = ACTIONS(3212),
    [anon_sym_instanceof] = ACTIONS(3210),
    [anon_sym_void] = ACTIONS(3210),
    [anon_sym_PLUS_PLUS] = ACTIONS(3212),
    [anon_sym_DASH_DASH] = ACTIONS(3212),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_SQUOTE] = ACTIONS(3212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3212),
    [sym_number] = ACTIONS(3212),
    [sym_this] = ACTIONS(3210),
    [sym_true] = ACTIONS(3210),
    [sym_false] = ACTIONS(3210),
    [sym_null] = ACTIONS(3210),
    [sym_undefined] = ACTIONS(3210),
    [anon_sym_static] = ACTIONS(3210),
    [anon_sym_readonly] = ACTIONS(3210),
    [anon_sym_get] = ACTIONS(3210),
    [anon_sym_set] = ACTIONS(3210),
    [anon_sym_QMARK] = ACTIONS(3210),
    [anon_sym_any] = ACTIONS(3210),
    [anon_sym_number] = ACTIONS(3210),
    [anon_sym_boolean] = ACTIONS(3210),
    [anon_sym_string] = ACTIONS(3210),
    [anon_sym_symbol] = ACTIONS(3210),
    [anon_sym_abstract] = ACTIONS(3210),
    [anon_sym_satisfies] = ACTIONS(3210),
    [anon_sym_extends] = ACTIONS(3210),
    [anon_sym_infer] = ACTIONS(3210),
    [anon_sym_keyof] = ACTIONS(3210),
    [anon_sym_unknown] = ACTIONS(3210),
    [anon_sym_never] = ACTIONS(3210),
    [anon_sym_object] = ACTIONS(3210),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3212),
    [anon_sym_constructor] = ACTIONS(3210),
    [anon_sym_prop] = ACTIONS(3210),
    [anon_sym_id] = ACTIONS(3210),
    [anon_sym_event] = ACTIONS(3210),
    [anon_sym_fn] = ACTIONS(3210),
    [anon_sym_on] = ACTIONS(3210),
    [sym__ternary_qmark] = ACTIONS(3212),
  },
  [919] = {
    [sym_identifier] = ACTIONS(3214),
    [anon_sym_STAR] = ACTIONS(3214),
    [anon_sym_as] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3214),
    [anon_sym_RBRACE] = ACTIONS(3216),
    [anon_sym_typeof] = ACTIONS(3214),
    [anon_sym_BANG] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3216),
    [anon_sym_in] = ACTIONS(3214),
    [anon_sym_SEMI] = ACTIONS(3216),
    [anon_sym_LBRACK] = ACTIONS(3216),
    [anon_sym_LT] = ACTIONS(3214),
    [anon_sym_GT] = ACTIONS(3214),
    [anon_sym_SLASH] = ACTIONS(3214),
    [anon_sym_DOT] = ACTIONS(3214),
    [anon_sym_async] = ACTIONS(3214),
    [anon_sym_QMARK_DOT] = ACTIONS(3216),
    [anon_sym_new] = ACTIONS(3214),
    [anon_sym_AMP_AMP] = ACTIONS(3216),
    [anon_sym_PIPE_PIPE] = ACTIONS(3216),
    [anon_sym_GT_GT] = ACTIONS(3214),
    [anon_sym_GT_GT_GT] = ACTIONS(3216),
    [anon_sym_LT_LT] = ACTIONS(3216),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_CARET] = ACTIONS(3216),
    [anon_sym_PIPE] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3214),
    [anon_sym_DASH] = ACTIONS(3214),
    [anon_sym_PERCENT] = ACTIONS(3216),
    [anon_sym_STAR_STAR] = ACTIONS(3216),
    [anon_sym_LT_EQ] = ACTIONS(3216),
    [anon_sym_EQ_EQ] = ACTIONS(3214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3216),
    [anon_sym_BANG_EQ] = ACTIONS(3214),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3216),
    [anon_sym_GT_EQ] = ACTIONS(3216),
    [anon_sym_QMARK_QMARK] = ACTIONS(3216),
    [anon_sym_instanceof] = ACTIONS(3214),
    [anon_sym_void] = ACTIONS(3214),
    [anon_sym_PLUS_PLUS] = ACTIONS(3216),
    [anon_sym_DASH_DASH] = ACTIONS(3216),
    [anon_sym_DQUOTE] = ACTIONS(3216),
    [anon_sym_SQUOTE] = ACTIONS(3216),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3216),
    [sym_number] = ACTIONS(3216),
    [sym_this] = ACTIONS(3214),
    [sym_true] = ACTIONS(3214),
    [sym_false] = ACTIONS(3214),
    [sym_null] = ACTIONS(3214),
    [sym_undefined] = ACTIONS(3214),
    [anon_sym_static] = ACTIONS(3214),
    [anon_sym_readonly] = ACTIONS(3214),
    [anon_sym_get] = ACTIONS(3214),
    [anon_sym_set] = ACTIONS(3214),
    [anon_sym_QMARK] = ACTIONS(3214),
    [anon_sym_any] = ACTIONS(3214),
    [anon_sym_number] = ACTIONS(3214),
    [anon_sym_boolean] = ACTIONS(3214),
    [anon_sym_string] = ACTIONS(3214),
    [anon_sym_symbol] = ACTIONS(3214),
    [anon_sym_abstract] = ACTIONS(3214),
    [anon_sym_satisfies] = ACTIONS(3214),
    [anon_sym_extends] = ACTIONS(3214),
    [anon_sym_infer] = ACTIONS(3214),
    [anon_sym_keyof] = ACTIONS(3214),
    [anon_sym_unknown] = ACTIONS(3214),
    [anon_sym_never] = ACTIONS(3214),
    [anon_sym_object] = ACTIONS(3214),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3216),
    [anon_sym_constructor] = ACTIONS(3214),
    [anon_sym_prop] = ACTIONS(3214),
    [anon_sym_id] = ACTIONS(3214),
    [anon_sym_event] = ACTIONS(3214),
    [anon_sym_fn] = ACTIONS(3214),
    [anon_sym_on] = ACTIONS(3214),
    [sym__ternary_qmark] = ACTIONS(3216),
  },
  [920] = {
    [sym_identifier] = ACTIONS(2812),
    [anon_sym_STAR] = ACTIONS(2812),
    [anon_sym_as] = ACTIONS(2812),
    [anon_sym_LBRACE] = ACTIONS(2812),
    [anon_sym_RBRACE] = ACTIONS(2814),
    [anon_sym_typeof] = ACTIONS(2812),
    [anon_sym_BANG] = ACTIONS(2812),
    [anon_sym_LPAREN] = ACTIONS(2814),
    [anon_sym_in] = ACTIONS(2812),
    [anon_sym_SEMI] = ACTIONS(2814),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2812),
    [anon_sym_GT] = ACTIONS(2812),
    [anon_sym_SLASH] = ACTIONS(2812),
    [anon_sym_DOT] = ACTIONS(2812),
    [anon_sym_async] = ACTIONS(2812),
    [anon_sym_QMARK_DOT] = ACTIONS(2814),
    [anon_sym_new] = ACTIONS(2812),
    [anon_sym_AMP_AMP] = ACTIONS(2814),
    [anon_sym_PIPE_PIPE] = ACTIONS(2814),
    [anon_sym_GT_GT] = ACTIONS(2812),
    [anon_sym_GT_GT_GT] = ACTIONS(2814),
    [anon_sym_LT_LT] = ACTIONS(2814),
    [anon_sym_AMP] = ACTIONS(2812),
    [anon_sym_CARET] = ACTIONS(2814),
    [anon_sym_PIPE] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2812),
    [anon_sym_PERCENT] = ACTIONS(2814),
    [anon_sym_STAR_STAR] = ACTIONS(2814),
    [anon_sym_LT_EQ] = ACTIONS(2814),
    [anon_sym_EQ_EQ] = ACTIONS(2812),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2814),
    [anon_sym_BANG_EQ] = ACTIONS(2812),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2814),
    [anon_sym_GT_EQ] = ACTIONS(2814),
    [anon_sym_QMARK_QMARK] = ACTIONS(2814),
    [anon_sym_instanceof] = ACTIONS(2812),
    [anon_sym_void] = ACTIONS(2812),
    [anon_sym_PLUS_PLUS] = ACTIONS(2814),
    [anon_sym_DASH_DASH] = ACTIONS(2814),
    [anon_sym_DQUOTE] = ACTIONS(2814),
    [anon_sym_SQUOTE] = ACTIONS(2814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2814),
    [sym_number] = ACTIONS(2814),
    [sym_this] = ACTIONS(2812),
    [sym_true] = ACTIONS(2812),
    [sym_false] = ACTIONS(2812),
    [sym_null] = ACTIONS(2812),
    [sym_undefined] = ACTIONS(2812),
    [anon_sym_static] = ACTIONS(2812),
    [anon_sym_readonly] = ACTIONS(2812),
    [anon_sym_get] = ACTIONS(2812),
    [anon_sym_set] = ACTIONS(2812),
    [anon_sym_QMARK] = ACTIONS(2812),
    [anon_sym_any] = ACTIONS(2812),
    [anon_sym_number] = ACTIONS(2812),
    [anon_sym_boolean] = ACTIONS(2812),
    [anon_sym_string] = ACTIONS(2812),
    [anon_sym_symbol] = ACTIONS(2812),
    [anon_sym_abstract] = ACTIONS(2812),
    [anon_sym_satisfies] = ACTIONS(2812),
    [anon_sym_extends] = ACTIONS(2812),
    [anon_sym_infer] = ACTIONS(2812),
    [anon_sym_keyof] = ACTIONS(2812),
    [anon_sym_unknown] = ACTIONS(2812),
    [anon_sym_never] = ACTIONS(2812),
    [anon_sym_object] = ACTIONS(2812),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2814),
    [anon_sym_constructor] = ACTIONS(2812),
    [anon_sym_prop] = ACTIONS(2812),
    [anon_sym_id] = ACTIONS(2812),
    [anon_sym_event] = ACTIONS(2812),
    [anon_sym_fn] = ACTIONS(2812),
    [anon_sym_on] = ACTIONS(2812),
    [sym__ternary_qmark] = ACTIONS(2814),
  },
  [921] = {
    [sym_identifier] = ACTIONS(3218),
    [anon_sym_STAR] = ACTIONS(3218),
    [anon_sym_as] = ACTIONS(3218),
    [anon_sym_LBRACE] = ACTIONS(3218),
    [anon_sym_RBRACE] = ACTIONS(3220),
    [anon_sym_typeof] = ACTIONS(3218),
    [anon_sym_BANG] = ACTIONS(3218),
    [anon_sym_LPAREN] = ACTIONS(3220),
    [anon_sym_in] = ACTIONS(3218),
    [anon_sym_SEMI] = ACTIONS(3220),
    [anon_sym_LBRACK] = ACTIONS(3220),
    [anon_sym_LT] = ACTIONS(3218),
    [anon_sym_GT] = ACTIONS(3218),
    [anon_sym_SLASH] = ACTIONS(3218),
    [anon_sym_DOT] = ACTIONS(3218),
    [anon_sym_async] = ACTIONS(3218),
    [anon_sym_QMARK_DOT] = ACTIONS(3220),
    [anon_sym_new] = ACTIONS(3218),
    [anon_sym_AMP_AMP] = ACTIONS(3220),
    [anon_sym_PIPE_PIPE] = ACTIONS(3220),
    [anon_sym_GT_GT] = ACTIONS(3218),
    [anon_sym_GT_GT_GT] = ACTIONS(3220),
    [anon_sym_LT_LT] = ACTIONS(3220),
    [anon_sym_AMP] = ACTIONS(3218),
    [anon_sym_CARET] = ACTIONS(3220),
    [anon_sym_PIPE] = ACTIONS(3218),
    [anon_sym_PLUS] = ACTIONS(3218),
    [anon_sym_DASH] = ACTIONS(3218),
    [anon_sym_PERCENT] = ACTIONS(3220),
    [anon_sym_STAR_STAR] = ACTIONS(3220),
    [anon_sym_LT_EQ] = ACTIONS(3220),
    [anon_sym_EQ_EQ] = ACTIONS(3218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3220),
    [anon_sym_BANG_EQ] = ACTIONS(3218),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3220),
    [anon_sym_GT_EQ] = ACTIONS(3220),
    [anon_sym_QMARK_QMARK] = ACTIONS(3220),
    [anon_sym_instanceof] = ACTIONS(3218),
    [anon_sym_void] = ACTIONS(3218),
    [anon_sym_PLUS_PLUS] = ACTIONS(3220),
    [anon_sym_DASH_DASH] = ACTIONS(3220),
    [anon_sym_DQUOTE] = ACTIONS(3220),
    [anon_sym_SQUOTE] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3220),
    [sym_number] = ACTIONS(3220),
    [sym_this] = ACTIONS(3218),
    [sym_true] = ACTIONS(3218),
    [sym_false] = ACTIONS(3218),
    [sym_null] = ACTIONS(3218),
    [sym_undefined] = ACTIONS(3218),
    [anon_sym_static] = ACTIONS(3218),
    [anon_sym_readonly] = ACTIONS(3218),
    [anon_sym_get] = ACTIONS(3218),
    [anon_sym_set] = ACTIONS(3218),
    [anon_sym_QMARK] = ACTIONS(3218),
    [anon_sym_any] = ACTIONS(3218),
    [anon_sym_number] = ACTIONS(3218),
    [anon_sym_boolean] = ACTIONS(3218),
    [anon_sym_string] = ACTIONS(3218),
    [anon_sym_symbol] = ACTIONS(3218),
    [anon_sym_abstract] = ACTIONS(3218),
    [anon_sym_satisfies] = ACTIONS(3218),
    [anon_sym_extends] = ACTIONS(3218),
    [anon_sym_infer] = ACTIONS(3218),
    [anon_sym_keyof] = ACTIONS(3218),
    [anon_sym_unknown] = ACTIONS(3218),
    [anon_sym_never] = ACTIONS(3218),
    [anon_sym_object] = ACTIONS(3218),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3220),
    [anon_sym_constructor] = ACTIONS(3218),
    [anon_sym_prop] = ACTIONS(3218),
    [anon_sym_id] = ACTIONS(3218),
    [anon_sym_event] = ACTIONS(3218),
    [anon_sym_fn] = ACTIONS(3218),
    [anon_sym_on] = ACTIONS(3218),
    [sym__ternary_qmark] = ACTIONS(3220),
  },
  [922] = {
    [sym_identifier] = ACTIONS(2796),
    [anon_sym_STAR] = ACTIONS(2796),
    [anon_sym_as] = ACTIONS(2796),
    [anon_sym_LBRACE] = ACTIONS(2796),
    [anon_sym_RBRACE] = ACTIONS(2798),
    [anon_sym_typeof] = ACTIONS(2796),
    [anon_sym_BANG] = ACTIONS(2796),
    [anon_sym_LPAREN] = ACTIONS(2798),
    [anon_sym_in] = ACTIONS(2796),
    [anon_sym_SEMI] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(2798),
    [anon_sym_LT] = ACTIONS(2796),
    [anon_sym_GT] = ACTIONS(2796),
    [anon_sym_SLASH] = ACTIONS(2796),
    [anon_sym_DOT] = ACTIONS(2796),
    [anon_sym_async] = ACTIONS(2796),
    [anon_sym_QMARK_DOT] = ACTIONS(2798),
    [anon_sym_new] = ACTIONS(2796),
    [anon_sym_AMP_AMP] = ACTIONS(2798),
    [anon_sym_PIPE_PIPE] = ACTIONS(2798),
    [anon_sym_GT_GT] = ACTIONS(2796),
    [anon_sym_GT_GT_GT] = ACTIONS(2798),
    [anon_sym_LT_LT] = ACTIONS(2798),
    [anon_sym_AMP] = ACTIONS(2796),
    [anon_sym_CARET] = ACTIONS(2798),
    [anon_sym_PIPE] = ACTIONS(2796),
    [anon_sym_PLUS] = ACTIONS(2796),
    [anon_sym_DASH] = ACTIONS(2796),
    [anon_sym_PERCENT] = ACTIONS(2798),
    [anon_sym_STAR_STAR] = ACTIONS(2798),
    [anon_sym_LT_EQ] = ACTIONS(2798),
    [anon_sym_EQ_EQ] = ACTIONS(2796),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2798),
    [anon_sym_BANG_EQ] = ACTIONS(2796),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2798),
    [anon_sym_GT_EQ] = ACTIONS(2798),
    [anon_sym_QMARK_QMARK] = ACTIONS(2798),
    [anon_sym_instanceof] = ACTIONS(2796),
    [anon_sym_void] = ACTIONS(2796),
    [anon_sym_PLUS_PLUS] = ACTIONS(2798),
    [anon_sym_DASH_DASH] = ACTIONS(2798),
    [anon_sym_DQUOTE] = ACTIONS(2798),
    [anon_sym_SQUOTE] = ACTIONS(2798),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2798),
    [sym_number] = ACTIONS(2798),
    [sym_this] = ACTIONS(2796),
    [sym_true] = ACTIONS(2796),
    [sym_false] = ACTIONS(2796),
    [sym_null] = ACTIONS(2796),
    [sym_undefined] = ACTIONS(2796),
    [anon_sym_static] = ACTIONS(2796),
    [anon_sym_readonly] = ACTIONS(2796),
    [anon_sym_get] = ACTIONS(2796),
    [anon_sym_set] = ACTIONS(2796),
    [anon_sym_QMARK] = ACTIONS(2796),
    [anon_sym_any] = ACTIONS(2796),
    [anon_sym_number] = ACTIONS(2796),
    [anon_sym_boolean] = ACTIONS(2796),
    [anon_sym_string] = ACTIONS(2796),
    [anon_sym_symbol] = ACTIONS(2796),
    [anon_sym_abstract] = ACTIONS(2796),
    [anon_sym_satisfies] = ACTIONS(2796),
    [anon_sym_extends] = ACTIONS(2796),
    [anon_sym_infer] = ACTIONS(2796),
    [anon_sym_keyof] = ACTIONS(2796),
    [anon_sym_unknown] = ACTIONS(2796),
    [anon_sym_never] = ACTIONS(2796),
    [anon_sym_object] = ACTIONS(2796),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2798),
    [anon_sym_constructor] = ACTIONS(2796),
    [anon_sym_prop] = ACTIONS(2796),
    [anon_sym_id] = ACTIONS(2796),
    [anon_sym_event] = ACTIONS(2796),
    [anon_sym_fn] = ACTIONS(2796),
    [anon_sym_on] = ACTIONS(2796),
    [sym__ternary_qmark] = ACTIONS(2798),
  },
  [923] = {
    [sym_identifier] = ACTIONS(3222),
    [anon_sym_STAR] = ACTIONS(3222),
    [anon_sym_as] = ACTIONS(3222),
    [anon_sym_LBRACE] = ACTIONS(3222),
    [anon_sym_RBRACE] = ACTIONS(3224),
    [anon_sym_typeof] = ACTIONS(3222),
    [anon_sym_BANG] = ACTIONS(3222),
    [anon_sym_LPAREN] = ACTIONS(3224),
    [anon_sym_in] = ACTIONS(3222),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym_LBRACK] = ACTIONS(3224),
    [anon_sym_LT] = ACTIONS(3222),
    [anon_sym_GT] = ACTIONS(3222),
    [anon_sym_SLASH] = ACTIONS(3222),
    [anon_sym_DOT] = ACTIONS(3222),
    [anon_sym_async] = ACTIONS(3222),
    [anon_sym_QMARK_DOT] = ACTIONS(3224),
    [anon_sym_new] = ACTIONS(3222),
    [anon_sym_AMP_AMP] = ACTIONS(3224),
    [anon_sym_PIPE_PIPE] = ACTIONS(3224),
    [anon_sym_GT_GT] = ACTIONS(3222),
    [anon_sym_GT_GT_GT] = ACTIONS(3224),
    [anon_sym_LT_LT] = ACTIONS(3224),
    [anon_sym_AMP] = ACTIONS(3110),
    [anon_sym_CARET] = ACTIONS(3224),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_PLUS] = ACTIONS(3222),
    [anon_sym_DASH] = ACTIONS(3222),
    [anon_sym_PERCENT] = ACTIONS(3224),
    [anon_sym_STAR_STAR] = ACTIONS(3224),
    [anon_sym_LT_EQ] = ACTIONS(3224),
    [anon_sym_EQ_EQ] = ACTIONS(3222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3224),
    [anon_sym_BANG_EQ] = ACTIONS(3222),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3224),
    [anon_sym_GT_EQ] = ACTIONS(3224),
    [anon_sym_QMARK_QMARK] = ACTIONS(3224),
    [anon_sym_instanceof] = ACTIONS(3222),
    [anon_sym_void] = ACTIONS(3222),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3224),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3224),
    [sym_number] = ACTIONS(3224),
    [sym_this] = ACTIONS(3222),
    [sym_true] = ACTIONS(3222),
    [sym_false] = ACTIONS(3222),
    [sym_null] = ACTIONS(3222),
    [sym_undefined] = ACTIONS(3222),
    [anon_sym_static] = ACTIONS(3222),
    [anon_sym_readonly] = ACTIONS(3222),
    [anon_sym_get] = ACTIONS(3222),
    [anon_sym_set] = ACTIONS(3222),
    [anon_sym_QMARK] = ACTIONS(3222),
    [anon_sym_any] = ACTIONS(3222),
    [anon_sym_number] = ACTIONS(3222),
    [anon_sym_boolean] = ACTIONS(3222),
    [anon_sym_string] = ACTIONS(3222),
    [anon_sym_symbol] = ACTIONS(3222),
    [anon_sym_abstract] = ACTIONS(3222),
    [anon_sym_satisfies] = ACTIONS(3222),
    [anon_sym_extends] = ACTIONS(3160),
    [anon_sym_infer] = ACTIONS(3222),
    [anon_sym_keyof] = ACTIONS(3222),
    [anon_sym_unknown] = ACTIONS(3222),
    [anon_sym_never] = ACTIONS(3222),
    [anon_sym_object] = ACTIONS(3222),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3224),
    [anon_sym_constructor] = ACTIONS(3222),
    [anon_sym_prop] = ACTIONS(3222),
    [anon_sym_id] = ACTIONS(3222),
    [anon_sym_event] = ACTIONS(3222),
    [anon_sym_fn] = ACTIONS(3222),
    [anon_sym_on] = ACTIONS(3222),
    [sym__ternary_qmark] = ACTIONS(3224),
  },
  [924] = {
    [sym_identifier] = ACTIONS(3222),
    [anon_sym_STAR] = ACTIONS(3222),
    [anon_sym_as] = ACTIONS(3222),
    [anon_sym_LBRACE] = ACTIONS(3222),
    [anon_sym_RBRACE] = ACTIONS(3224),
    [anon_sym_typeof] = ACTIONS(3222),
    [anon_sym_BANG] = ACTIONS(3222),
    [anon_sym_LPAREN] = ACTIONS(3224),
    [anon_sym_in] = ACTIONS(3222),
    [anon_sym_SEMI] = ACTIONS(3224),
    [anon_sym_LBRACK] = ACTIONS(3224),
    [anon_sym_LT] = ACTIONS(3222),
    [anon_sym_GT] = ACTIONS(3222),
    [anon_sym_SLASH] = ACTIONS(3222),
    [anon_sym_DOT] = ACTIONS(3222),
    [anon_sym_async] = ACTIONS(3222),
    [anon_sym_QMARK_DOT] = ACTIONS(3224),
    [anon_sym_new] = ACTIONS(3222),
    [anon_sym_AMP_AMP] = ACTIONS(3224),
    [anon_sym_PIPE_PIPE] = ACTIONS(3224),
    [anon_sym_GT_GT] = ACTIONS(3222),
    [anon_sym_GT_GT_GT] = ACTIONS(3224),
    [anon_sym_LT_LT] = ACTIONS(3224),
    [anon_sym_AMP] = ACTIONS(3222),
    [anon_sym_CARET] = ACTIONS(3224),
    [anon_sym_PIPE] = ACTIONS(3222),
    [anon_sym_PLUS] = ACTIONS(3222),
    [anon_sym_DASH] = ACTIONS(3222),
    [anon_sym_PERCENT] = ACTIONS(3224),
    [anon_sym_STAR_STAR] = ACTIONS(3224),
    [anon_sym_LT_EQ] = ACTIONS(3224),
    [anon_sym_EQ_EQ] = ACTIONS(3222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3224),
    [anon_sym_BANG_EQ] = ACTIONS(3222),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3224),
    [anon_sym_GT_EQ] = ACTIONS(3224),
    [anon_sym_QMARK_QMARK] = ACTIONS(3224),
    [anon_sym_instanceof] = ACTIONS(3222),
    [anon_sym_void] = ACTIONS(3222),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3224),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3224),
    [sym_number] = ACTIONS(3224),
    [sym_this] = ACTIONS(3222),
    [sym_true] = ACTIONS(3222),
    [sym_false] = ACTIONS(3222),
    [sym_null] = ACTIONS(3222),
    [sym_undefined] = ACTIONS(3222),
    [anon_sym_static] = ACTIONS(3222),
    [anon_sym_readonly] = ACTIONS(3222),
    [anon_sym_get] = ACTIONS(3222),
    [anon_sym_set] = ACTIONS(3222),
    [anon_sym_QMARK] = ACTIONS(3222),
    [anon_sym_any] = ACTIONS(3222),
    [anon_sym_number] = ACTIONS(3222),
    [anon_sym_boolean] = ACTIONS(3222),
    [anon_sym_string] = ACTIONS(3222),
    [anon_sym_symbol] = ACTIONS(3222),
    [anon_sym_abstract] = ACTIONS(3222),
    [anon_sym_satisfies] = ACTIONS(3222),
    [anon_sym_extends] = ACTIONS(3222),
    [anon_sym_infer] = ACTIONS(3222),
    [anon_sym_keyof] = ACTIONS(3222),
    [anon_sym_unknown] = ACTIONS(3222),
    [anon_sym_never] = ACTIONS(3222),
    [anon_sym_object] = ACTIONS(3222),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3224),
    [anon_sym_constructor] = ACTIONS(3222),
    [anon_sym_prop] = ACTIONS(3222),
    [anon_sym_id] = ACTIONS(3222),
    [anon_sym_event] = ACTIONS(3222),
    [anon_sym_fn] = ACTIONS(3222),
    [anon_sym_on] = ACTIONS(3222),
    [sym__ternary_qmark] = ACTIONS(3224),
  },
  [925] = {
    [sym_identifier] = ACTIONS(3226),
    [anon_sym_STAR] = ACTIONS(3226),
    [anon_sym_as] = ACTIONS(3226),
    [anon_sym_LBRACE] = ACTIONS(3226),
    [anon_sym_RBRACE] = ACTIONS(3228),
    [anon_sym_typeof] = ACTIONS(3226),
    [anon_sym_BANG] = ACTIONS(3226),
    [anon_sym_LPAREN] = ACTIONS(3228),
    [anon_sym_in] = ACTIONS(3226),
    [anon_sym_SEMI] = ACTIONS(3228),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LT] = ACTIONS(3226),
    [anon_sym_GT] = ACTIONS(3226),
    [anon_sym_SLASH] = ACTIONS(3226),
    [anon_sym_DOT] = ACTIONS(3226),
    [anon_sym_async] = ACTIONS(3226),
    [anon_sym_QMARK_DOT] = ACTIONS(3228),
    [anon_sym_new] = ACTIONS(3226),
    [anon_sym_AMP_AMP] = ACTIONS(3228),
    [anon_sym_PIPE_PIPE] = ACTIONS(3228),
    [anon_sym_GT_GT] = ACTIONS(3226),
    [anon_sym_GT_GT_GT] = ACTIONS(3228),
    [anon_sym_LT_LT] = ACTIONS(3228),
    [anon_sym_AMP] = ACTIONS(3226),
    [anon_sym_CARET] = ACTIONS(3228),
    [anon_sym_PIPE] = ACTIONS(3226),
    [anon_sym_PLUS] = ACTIONS(3226),
    [anon_sym_DASH] = ACTIONS(3226),
    [anon_sym_PERCENT] = ACTIONS(3228),
    [anon_sym_STAR_STAR] = ACTIONS(3228),
    [anon_sym_LT_EQ] = ACTIONS(3228),
    [anon_sym_EQ_EQ] = ACTIONS(3226),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3228),
    [anon_sym_BANG_EQ] = ACTIONS(3226),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3228),
    [anon_sym_GT_EQ] = ACTIONS(3228),
    [anon_sym_QMARK_QMARK] = ACTIONS(3228),
    [anon_sym_instanceof] = ACTIONS(3226),
    [anon_sym_void] = ACTIONS(3226),
    [anon_sym_PLUS_PLUS] = ACTIONS(3228),
    [anon_sym_DASH_DASH] = ACTIONS(3228),
    [anon_sym_DQUOTE] = ACTIONS(3228),
    [anon_sym_SQUOTE] = ACTIONS(3228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3228),
    [sym_number] = ACTIONS(3228),
    [sym_this] = ACTIONS(3226),
    [sym_true] = ACTIONS(3226),
    [sym_false] = ACTIONS(3226),
    [sym_null] = ACTIONS(3226),
    [sym_undefined] = ACTIONS(3226),
    [anon_sym_static] = ACTIONS(3226),
    [anon_sym_readonly] = ACTIONS(3226),
    [anon_sym_get] = ACTIONS(3226),
    [anon_sym_set] = ACTIONS(3226),
    [anon_sym_QMARK] = ACTIONS(3226),
    [anon_sym_any] = ACTIONS(3226),
    [anon_sym_number] = ACTIONS(3226),
    [anon_sym_boolean] = ACTIONS(3226),
    [anon_sym_string] = ACTIONS(3226),
    [anon_sym_symbol] = ACTIONS(3226),
    [anon_sym_abstract] = ACTIONS(3226),
    [anon_sym_satisfies] = ACTIONS(3226),
    [anon_sym_extends] = ACTIONS(3226),
    [anon_sym_infer] = ACTIONS(3226),
    [anon_sym_keyof] = ACTIONS(3226),
    [anon_sym_unknown] = ACTIONS(3226),
    [anon_sym_never] = ACTIONS(3226),
    [anon_sym_object] = ACTIONS(3226),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3228),
    [anon_sym_constructor] = ACTIONS(3226),
    [anon_sym_prop] = ACTIONS(3226),
    [anon_sym_id] = ACTIONS(3226),
    [anon_sym_event] = ACTIONS(3226),
    [anon_sym_fn] = ACTIONS(3226),
    [anon_sym_on] = ACTIONS(3226),
    [sym__ternary_qmark] = ACTIONS(3228),
  },
  [926] = {
    [sym_identifier] = ACTIONS(3232),
    [anon_sym_STAR] = ACTIONS(3232),
    [anon_sym_as] = ACTIONS(3232),
    [anon_sym_LBRACE] = ACTIONS(3232),
    [anon_sym_RBRACE] = ACTIONS(3234),
    [anon_sym_typeof] = ACTIONS(3232),
    [anon_sym_BANG] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3234),
    [anon_sym_in] = ACTIONS(3232),
    [anon_sym_SEMI] = ACTIONS(3234),
    [anon_sym_LBRACK] = ACTIONS(3234),
    [anon_sym_LT] = ACTIONS(3232),
    [anon_sym_GT] = ACTIONS(3232),
    [anon_sym_SLASH] = ACTIONS(3232),
    [anon_sym_DOT] = ACTIONS(3232),
    [anon_sym_async] = ACTIONS(3232),
    [anon_sym_QMARK_DOT] = ACTIONS(3234),
    [anon_sym_new] = ACTIONS(3232),
    [anon_sym_AMP_AMP] = ACTIONS(3234),
    [anon_sym_PIPE_PIPE] = ACTIONS(3234),
    [anon_sym_GT_GT] = ACTIONS(3232),
    [anon_sym_GT_GT_GT] = ACTIONS(3234),
    [anon_sym_LT_LT] = ACTIONS(3234),
    [anon_sym_AMP] = ACTIONS(3232),
    [anon_sym_CARET] = ACTIONS(3234),
    [anon_sym_PIPE] = ACTIONS(3232),
    [anon_sym_PLUS] = ACTIONS(3232),
    [anon_sym_DASH] = ACTIONS(3232),
    [anon_sym_PERCENT] = ACTIONS(3234),
    [anon_sym_STAR_STAR] = ACTIONS(3234),
    [anon_sym_LT_EQ] = ACTIONS(3234),
    [anon_sym_EQ_EQ] = ACTIONS(3232),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3234),
    [anon_sym_BANG_EQ] = ACTIONS(3232),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3234),
    [anon_sym_GT_EQ] = ACTIONS(3234),
    [anon_sym_QMARK_QMARK] = ACTIONS(3234),
    [anon_sym_instanceof] = ACTIONS(3232),
    [anon_sym_void] = ACTIONS(3232),
    [anon_sym_PLUS_PLUS] = ACTIONS(3234),
    [anon_sym_DASH_DASH] = ACTIONS(3234),
    [anon_sym_DQUOTE] = ACTIONS(3234),
    [anon_sym_SQUOTE] = ACTIONS(3234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3234),
    [sym_number] = ACTIONS(3234),
    [sym_this] = ACTIONS(3232),
    [sym_true] = ACTIONS(3232),
    [sym_false] = ACTIONS(3232),
    [sym_null] = ACTIONS(3232),
    [sym_undefined] = ACTIONS(3232),
    [anon_sym_static] = ACTIONS(3232),
    [anon_sym_readonly] = ACTIONS(3232),
    [anon_sym_get] = ACTIONS(3232),
    [anon_sym_set] = ACTIONS(3232),
    [anon_sym_QMARK] = ACTIONS(3232),
    [anon_sym_any] = ACTIONS(3232),
    [anon_sym_number] = ACTIONS(3232),
    [anon_sym_boolean] = ACTIONS(3232),
    [anon_sym_string] = ACTIONS(3232),
    [anon_sym_symbol] = ACTIONS(3232),
    [anon_sym_abstract] = ACTIONS(3232),
    [anon_sym_satisfies] = ACTIONS(3232),
    [anon_sym_extends] = ACTIONS(3232),
    [anon_sym_infer] = ACTIONS(3232),
    [anon_sym_keyof] = ACTIONS(3232),
    [anon_sym_unknown] = ACTIONS(3232),
    [anon_sym_never] = ACTIONS(3232),
    [anon_sym_object] = ACTIONS(3232),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3234),
    [anon_sym_constructor] = ACTIONS(3232),
    [anon_sym_prop] = ACTIONS(3232),
    [anon_sym_id] = ACTIONS(3232),
    [anon_sym_event] = ACTIONS(3232),
    [anon_sym_fn] = ACTIONS(3232),
    [anon_sym_on] = ACTIONS(3232),
    [sym__ternary_qmark] = ACTIONS(3234),
  },
  [927] = {
    [sym_identifier] = ACTIONS(3236),
    [anon_sym_STAR] = ACTIONS(3236),
    [anon_sym_as] = ACTIONS(3236),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_RBRACE] = ACTIONS(3238),
    [anon_sym_typeof] = ACTIONS(3236),
    [anon_sym_BANG] = ACTIONS(3236),
    [anon_sym_LPAREN] = ACTIONS(3238),
    [anon_sym_in] = ACTIONS(3236),
    [anon_sym_SEMI] = ACTIONS(3238),
    [anon_sym_LBRACK] = ACTIONS(3238),
    [anon_sym_LT] = ACTIONS(3236),
    [anon_sym_GT] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(3236),
    [anon_sym_async] = ACTIONS(3236),
    [anon_sym_QMARK_DOT] = ACTIONS(3238),
    [anon_sym_new] = ACTIONS(3236),
    [anon_sym_AMP_AMP] = ACTIONS(3238),
    [anon_sym_PIPE_PIPE] = ACTIONS(3238),
    [anon_sym_GT_GT] = ACTIONS(3236),
    [anon_sym_GT_GT_GT] = ACTIONS(3238),
    [anon_sym_LT_LT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3236),
    [anon_sym_CARET] = ACTIONS(3238),
    [anon_sym_PIPE] = ACTIONS(3236),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_DASH] = ACTIONS(3236),
    [anon_sym_PERCENT] = ACTIONS(3238),
    [anon_sym_STAR_STAR] = ACTIONS(3238),
    [anon_sym_LT_EQ] = ACTIONS(3238),
    [anon_sym_EQ_EQ] = ACTIONS(3236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3238),
    [anon_sym_BANG_EQ] = ACTIONS(3236),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3238),
    [anon_sym_GT_EQ] = ACTIONS(3238),
    [anon_sym_QMARK_QMARK] = ACTIONS(3238),
    [anon_sym_instanceof] = ACTIONS(3236),
    [anon_sym_void] = ACTIONS(3236),
    [anon_sym_PLUS_PLUS] = ACTIONS(3238),
    [anon_sym_DASH_DASH] = ACTIONS(3238),
    [anon_sym_DQUOTE] = ACTIONS(3238),
    [anon_sym_SQUOTE] = ACTIONS(3238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3238),
    [sym_number] = ACTIONS(3238),
    [sym_this] = ACTIONS(3236),
    [sym_true] = ACTIONS(3236),
    [sym_false] = ACTIONS(3236),
    [sym_null] = ACTIONS(3236),
    [sym_undefined] = ACTIONS(3236),
    [anon_sym_static] = ACTIONS(3236),
    [anon_sym_readonly] = ACTIONS(3236),
    [anon_sym_get] = ACTIONS(3236),
    [anon_sym_set] = ACTIONS(3236),
    [anon_sym_QMARK] = ACTIONS(3236),
    [anon_sym_any] = ACTIONS(3236),
    [anon_sym_number] = ACTIONS(3236),
    [anon_sym_boolean] = ACTIONS(3236),
    [anon_sym_string] = ACTIONS(3236),
    [anon_sym_symbol] = ACTIONS(3236),
    [anon_sym_abstract] = ACTIONS(3236),
    [anon_sym_satisfies] = ACTIONS(3236),
    [anon_sym_extends] = ACTIONS(3236),
    [anon_sym_infer] = ACTIONS(3236),
    [anon_sym_keyof] = ACTIONS(3236),
    [anon_sym_unknown] = ACTIONS(3236),
    [anon_sym_never] = ACTIONS(3236),
    [anon_sym_object] = ACTIONS(3236),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3238),
    [anon_sym_constructor] = ACTIONS(3236),
    [anon_sym_prop] = ACTIONS(3236),
    [anon_sym_id] = ACTIONS(3236),
    [anon_sym_event] = ACTIONS(3236),
    [anon_sym_fn] = ACTIONS(3236),
    [anon_sym_on] = ACTIONS(3236),
    [sym__ternary_qmark] = ACTIONS(3238),
  },
  [928] = {
    [sym_identifier] = ACTIONS(3240),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_as] = ACTIONS(3240),
    [anon_sym_LBRACE] = ACTIONS(3240),
    [anon_sym_RBRACE] = ACTIONS(3242),
    [anon_sym_typeof] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(3242),
    [anon_sym_in] = ACTIONS(3240),
    [anon_sym_SEMI] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3242),
    [anon_sym_LT] = ACTIONS(3240),
    [anon_sym_GT] = ACTIONS(3240),
    [anon_sym_SLASH] = ACTIONS(3240),
    [anon_sym_DOT] = ACTIONS(3240),
    [anon_sym_async] = ACTIONS(3240),
    [anon_sym_QMARK_DOT] = ACTIONS(3242),
    [anon_sym_new] = ACTIONS(3240),
    [anon_sym_AMP_AMP] = ACTIONS(3242),
    [anon_sym_PIPE_PIPE] = ACTIONS(3242),
    [anon_sym_GT_GT] = ACTIONS(3240),
    [anon_sym_GT_GT_GT] = ACTIONS(3242),
    [anon_sym_LT_LT] = ACTIONS(3242),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_CARET] = ACTIONS(3242),
    [anon_sym_PIPE] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3240),
    [anon_sym_PERCENT] = ACTIONS(3242),
    [anon_sym_STAR_STAR] = ACTIONS(3242),
    [anon_sym_LT_EQ] = ACTIONS(3242),
    [anon_sym_EQ_EQ] = ACTIONS(3240),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3242),
    [anon_sym_BANG_EQ] = ACTIONS(3240),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3242),
    [anon_sym_GT_EQ] = ACTIONS(3242),
    [anon_sym_QMARK_QMARK] = ACTIONS(3242),
    [anon_sym_instanceof] = ACTIONS(3240),
    [anon_sym_void] = ACTIONS(3240),
    [anon_sym_PLUS_PLUS] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3242),
    [anon_sym_DQUOTE] = ACTIONS(3242),
    [anon_sym_SQUOTE] = ACTIONS(3242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3242),
    [sym_number] = ACTIONS(3242),
    [sym_this] = ACTIONS(3240),
    [sym_true] = ACTIONS(3240),
    [sym_false] = ACTIONS(3240),
    [sym_null] = ACTIONS(3240),
    [sym_undefined] = ACTIONS(3240),
    [anon_sym_static] = ACTIONS(3240),
    [anon_sym_readonly] = ACTIONS(3240),
    [anon_sym_get] = ACTIONS(3240),
    [anon_sym_set] = ACTIONS(3240),
    [anon_sym_QMARK] = ACTIONS(3240),
    [anon_sym_any] = ACTIONS(3240),
    [anon_sym_number] = ACTIONS(3240),
    [anon_sym_boolean] = ACTIONS(3240),
    [anon_sym_string] = ACTIONS(3240),
    [anon_sym_symbol] = ACTIONS(3240),
    [anon_sym_abstract] = ACTIONS(3240),
    [anon_sym_satisfies] = ACTIONS(3240),
    [anon_sym_extends] = ACTIONS(3240),
    [anon_sym_infer] = ACTIONS(3240),
    [anon_sym_keyof] = ACTIONS(3240),
    [anon_sym_unknown] = ACTIONS(3240),
    [anon_sym_never] = ACTIONS(3240),
    [anon_sym_object] = ACTIONS(3240),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3242),
    [anon_sym_constructor] = ACTIONS(3240),
    [anon_sym_prop] = ACTIONS(3240),
    [anon_sym_id] = ACTIONS(3240),
    [anon_sym_event] = ACTIONS(3240),
    [anon_sym_fn] = ACTIONS(3240),
    [anon_sym_on] = ACTIONS(3240),
    [sym__ternary_qmark] = ACTIONS(3242),
  },
  [929] = {
    [sym_identifier] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_as] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3244),
    [anon_sym_RBRACE] = ACTIONS(3246),
    [anon_sym_typeof] = ACTIONS(3244),
    [anon_sym_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3246),
    [anon_sym_in] = ACTIONS(3244),
    [anon_sym_SEMI] = ACTIONS(3246),
    [anon_sym_LBRACK] = ACTIONS(3246),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_GT] = ACTIONS(3244),
    [anon_sym_SLASH] = ACTIONS(3244),
    [anon_sym_DOT] = ACTIONS(3244),
    [anon_sym_async] = ACTIONS(3244),
    [anon_sym_QMARK_DOT] = ACTIONS(3246),
    [anon_sym_new] = ACTIONS(3244),
    [anon_sym_AMP_AMP] = ACTIONS(3246),
    [anon_sym_PIPE_PIPE] = ACTIONS(3246),
    [anon_sym_GT_GT] = ACTIONS(3244),
    [anon_sym_GT_GT_GT] = ACTIONS(3246),
    [anon_sym_LT_LT] = ACTIONS(3246),
    [anon_sym_AMP] = ACTIONS(3244),
    [anon_sym_CARET] = ACTIONS(3246),
    [anon_sym_PIPE] = ACTIONS(3244),
    [anon_sym_PLUS] = ACTIONS(3244),
    [anon_sym_DASH] = ACTIONS(3244),
    [anon_sym_PERCENT] = ACTIONS(3246),
    [anon_sym_STAR_STAR] = ACTIONS(3246),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_EQ_EQ] = ACTIONS(3244),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3246),
    [anon_sym_BANG_EQ] = ACTIONS(3244),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3246),
    [anon_sym_QMARK_QMARK] = ACTIONS(3246),
    [anon_sym_instanceof] = ACTIONS(3244),
    [anon_sym_void] = ACTIONS(3244),
    [anon_sym_PLUS_PLUS] = ACTIONS(3246),
    [anon_sym_DASH_DASH] = ACTIONS(3246),
    [anon_sym_DQUOTE] = ACTIONS(3246),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3246),
    [sym_number] = ACTIONS(3246),
    [sym_this] = ACTIONS(3244),
    [sym_true] = ACTIONS(3244),
    [sym_false] = ACTIONS(3244),
    [sym_null] = ACTIONS(3244),
    [sym_undefined] = ACTIONS(3244),
    [anon_sym_static] = ACTIONS(3244),
    [anon_sym_readonly] = ACTIONS(3244),
    [anon_sym_get] = ACTIONS(3244),
    [anon_sym_set] = ACTIONS(3244),
    [anon_sym_QMARK] = ACTIONS(3244),
    [anon_sym_any] = ACTIONS(3244),
    [anon_sym_number] = ACTIONS(3244),
    [anon_sym_boolean] = ACTIONS(3244),
    [anon_sym_string] = ACTIONS(3244),
    [anon_sym_symbol] = ACTIONS(3244),
    [anon_sym_abstract] = ACTIONS(3244),
    [anon_sym_satisfies] = ACTIONS(3244),
    [anon_sym_extends] = ACTIONS(3244),
    [anon_sym_infer] = ACTIONS(3244),
    [anon_sym_keyof] = ACTIONS(3244),
    [anon_sym_unknown] = ACTIONS(3244),
    [anon_sym_never] = ACTIONS(3244),
    [anon_sym_object] = ACTIONS(3244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3246),
    [anon_sym_constructor] = ACTIONS(3244),
    [anon_sym_prop] = ACTIONS(3244),
    [anon_sym_id] = ACTIONS(3244),
    [anon_sym_event] = ACTIONS(3244),
    [anon_sym_fn] = ACTIONS(3244),
    [anon_sym_on] = ACTIONS(3244),
    [sym__ternary_qmark] = ACTIONS(3246),
  },
  [930] = {
    [sym_identifier] = ACTIONS(2982),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_as] = ACTIONS(2982),
    [anon_sym_LBRACE] = ACTIONS(2982),
    [anon_sym_RBRACE] = ACTIONS(2984),
    [anon_sym_typeof] = ACTIONS(2982),
    [anon_sym_BANG] = ACTIONS(2982),
    [anon_sym_LPAREN] = ACTIONS(2984),
    [anon_sym_in] = ACTIONS(2982),
    [anon_sym_SEMI] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2984),
    [anon_sym_LT] = ACTIONS(2982),
    [anon_sym_GT] = ACTIONS(2982),
    [anon_sym_SLASH] = ACTIONS(2982),
    [anon_sym_DOT] = ACTIONS(2982),
    [anon_sym_async] = ACTIONS(2982),
    [anon_sym_QMARK_DOT] = ACTIONS(2984),
    [anon_sym_new] = ACTIONS(2982),
    [anon_sym_AMP_AMP] = ACTIONS(2984),
    [anon_sym_PIPE_PIPE] = ACTIONS(2984),
    [anon_sym_GT_GT] = ACTIONS(2982),
    [anon_sym_GT_GT_GT] = ACTIONS(2984),
    [anon_sym_LT_LT] = ACTIONS(2984),
    [anon_sym_AMP] = ACTIONS(2982),
    [anon_sym_CARET] = ACTIONS(2984),
    [anon_sym_PIPE] = ACTIONS(2982),
    [anon_sym_PLUS] = ACTIONS(2982),
    [anon_sym_DASH] = ACTIONS(2982),
    [anon_sym_PERCENT] = ACTIONS(2984),
    [anon_sym_STAR_STAR] = ACTIONS(2984),
    [anon_sym_LT_EQ] = ACTIONS(2984),
    [anon_sym_EQ_EQ] = ACTIONS(2982),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2984),
    [anon_sym_BANG_EQ] = ACTIONS(2982),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2984),
    [anon_sym_GT_EQ] = ACTIONS(2984),
    [anon_sym_QMARK_QMARK] = ACTIONS(2984),
    [anon_sym_instanceof] = ACTIONS(2982),
    [anon_sym_void] = ACTIONS(2982),
    [anon_sym_PLUS_PLUS] = ACTIONS(2984),
    [anon_sym_DASH_DASH] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2984),
    [anon_sym_SQUOTE] = ACTIONS(2984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2984),
    [sym_number] = ACTIONS(2984),
    [sym_this] = ACTIONS(2982),
    [sym_true] = ACTIONS(2982),
    [sym_false] = ACTIONS(2982),
    [sym_null] = ACTIONS(2982),
    [sym_undefined] = ACTIONS(2982),
    [anon_sym_static] = ACTIONS(2982),
    [anon_sym_readonly] = ACTIONS(2982),
    [anon_sym_get] = ACTIONS(2982),
    [anon_sym_set] = ACTIONS(2982),
    [anon_sym_QMARK] = ACTIONS(2982),
    [anon_sym_any] = ACTIONS(2982),
    [anon_sym_number] = ACTIONS(2982),
    [anon_sym_boolean] = ACTIONS(2982),
    [anon_sym_string] = ACTIONS(2982),
    [anon_sym_symbol] = ACTIONS(2982),
    [anon_sym_abstract] = ACTIONS(2982),
    [anon_sym_satisfies] = ACTIONS(2982),
    [anon_sym_extends] = ACTIONS(2982),
    [anon_sym_infer] = ACTIONS(2982),
    [anon_sym_keyof] = ACTIONS(2982),
    [anon_sym_unknown] = ACTIONS(2982),
    [anon_sym_never] = ACTIONS(2982),
    [anon_sym_object] = ACTIONS(2982),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2984),
    [anon_sym_constructor] = ACTIONS(2982),
    [anon_sym_prop] = ACTIONS(2982),
    [anon_sym_id] = ACTIONS(2982),
    [anon_sym_event] = ACTIONS(2982),
    [anon_sym_fn] = ACTIONS(2982),
    [anon_sym_on] = ACTIONS(2982),
    [sym__ternary_qmark] = ACTIONS(2984),
  },
  [931] = {
    [sym_identifier] = ACTIONS(3094),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_as] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_RBRACE] = ACTIONS(3096),
    [anon_sym_typeof] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_LPAREN] = ACTIONS(3096),
    [anon_sym_in] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3096),
    [anon_sym_LBRACK] = ACTIONS(3096),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_GT] = ACTIONS(3094),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_DOT] = ACTIONS(3094),
    [anon_sym_async] = ACTIONS(3094),
    [anon_sym_QMARK_DOT] = ACTIONS(3096),
    [anon_sym_new] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3096),
    [anon_sym_PIPE_PIPE] = ACTIONS(3096),
    [anon_sym_GT_GT] = ACTIONS(3094),
    [anon_sym_GT_GT_GT] = ACTIONS(3096),
    [anon_sym_LT_LT] = ACTIONS(3096),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_CARET] = ACTIONS(3096),
    [anon_sym_PIPE] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3094),
    [anon_sym_PERCENT] = ACTIONS(3096),
    [anon_sym_STAR_STAR] = ACTIONS(3096),
    [anon_sym_LT_EQ] = ACTIONS(3096),
    [anon_sym_EQ_EQ] = ACTIONS(3094),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3096),
    [anon_sym_BANG_EQ] = ACTIONS(3094),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3096),
    [anon_sym_GT_EQ] = ACTIONS(3096),
    [anon_sym_QMARK_QMARK] = ACTIONS(3096),
    [anon_sym_instanceof] = ACTIONS(3094),
    [anon_sym_void] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3096),
    [anon_sym_DASH_DASH] = ACTIONS(3096),
    [anon_sym_DQUOTE] = ACTIONS(3096),
    [anon_sym_SQUOTE] = ACTIONS(3096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3096),
    [sym_number] = ACTIONS(3096),
    [sym_this] = ACTIONS(3094),
    [sym_true] = ACTIONS(3094),
    [sym_false] = ACTIONS(3094),
    [sym_null] = ACTIONS(3094),
    [sym_undefined] = ACTIONS(3094),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_readonly] = ACTIONS(3094),
    [anon_sym_get] = ACTIONS(3094),
    [anon_sym_set] = ACTIONS(3094),
    [anon_sym_QMARK] = ACTIONS(3094),
    [anon_sym_any] = ACTIONS(3094),
    [anon_sym_number] = ACTIONS(3094),
    [anon_sym_boolean] = ACTIONS(3094),
    [anon_sym_string] = ACTIONS(3094),
    [anon_sym_symbol] = ACTIONS(3094),
    [anon_sym_abstract] = ACTIONS(3094),
    [anon_sym_satisfies] = ACTIONS(3094),
    [anon_sym_extends] = ACTIONS(3094),
    [anon_sym_infer] = ACTIONS(3094),
    [anon_sym_keyof] = ACTIONS(3094),
    [anon_sym_unknown] = ACTIONS(3094),
    [anon_sym_never] = ACTIONS(3094),
    [anon_sym_object] = ACTIONS(3094),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3096),
    [anon_sym_constructor] = ACTIONS(3094),
    [anon_sym_prop] = ACTIONS(3094),
    [anon_sym_id] = ACTIONS(3094),
    [anon_sym_event] = ACTIONS(3094),
    [anon_sym_fn] = ACTIONS(3094),
    [anon_sym_on] = ACTIONS(3094),
    [sym__ternary_qmark] = ACTIONS(3096),
  },
  [932] = {
    [sym_identifier] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_as] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3244),
    [anon_sym_RBRACE] = ACTIONS(3246),
    [anon_sym_typeof] = ACTIONS(3244),
    [anon_sym_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3246),
    [anon_sym_in] = ACTIONS(3244),
    [anon_sym_SEMI] = ACTIONS(3246),
    [anon_sym_LBRACK] = ACTIONS(3246),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_GT] = ACTIONS(3244),
    [anon_sym_SLASH] = ACTIONS(3244),
    [anon_sym_DOT] = ACTIONS(3244),
    [anon_sym_async] = ACTIONS(3244),
    [anon_sym_QMARK_DOT] = ACTIONS(3246),
    [anon_sym_new] = ACTIONS(3244),
    [anon_sym_AMP_AMP] = ACTIONS(3246),
    [anon_sym_PIPE_PIPE] = ACTIONS(3246),
    [anon_sym_GT_GT] = ACTIONS(3244),
    [anon_sym_GT_GT_GT] = ACTIONS(3246),
    [anon_sym_LT_LT] = ACTIONS(3246),
    [anon_sym_AMP] = ACTIONS(3244),
    [anon_sym_CARET] = ACTIONS(3246),
    [anon_sym_PIPE] = ACTIONS(3244),
    [anon_sym_PLUS] = ACTIONS(3244),
    [anon_sym_DASH] = ACTIONS(3244),
    [anon_sym_PERCENT] = ACTIONS(3246),
    [anon_sym_STAR_STAR] = ACTIONS(3246),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_EQ_EQ] = ACTIONS(3244),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3246),
    [anon_sym_BANG_EQ] = ACTIONS(3244),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3246),
    [anon_sym_QMARK_QMARK] = ACTIONS(3246),
    [anon_sym_instanceof] = ACTIONS(3244),
    [anon_sym_void] = ACTIONS(3244),
    [anon_sym_PLUS_PLUS] = ACTIONS(3246),
    [anon_sym_DASH_DASH] = ACTIONS(3246),
    [anon_sym_DQUOTE] = ACTIONS(3246),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3246),
    [sym_number] = ACTIONS(3246),
    [sym_this] = ACTIONS(3244),
    [sym_true] = ACTIONS(3244),
    [sym_false] = ACTIONS(3244),
    [sym_null] = ACTIONS(3244),
    [sym_undefined] = ACTIONS(3244),
    [anon_sym_static] = ACTIONS(3244),
    [anon_sym_readonly] = ACTIONS(3244),
    [anon_sym_get] = ACTIONS(3244),
    [anon_sym_set] = ACTIONS(3244),
    [anon_sym_QMARK] = ACTIONS(3244),
    [anon_sym_any] = ACTIONS(3244),
    [anon_sym_number] = ACTIONS(3244),
    [anon_sym_boolean] = ACTIONS(3244),
    [anon_sym_string] = ACTIONS(3244),
    [anon_sym_symbol] = ACTIONS(3244),
    [anon_sym_abstract] = ACTIONS(3244),
    [anon_sym_satisfies] = ACTIONS(3244),
    [anon_sym_extends] = ACTIONS(3244),
    [anon_sym_infer] = ACTIONS(3244),
    [anon_sym_keyof] = ACTIONS(3244),
    [anon_sym_unknown] = ACTIONS(3244),
    [anon_sym_never] = ACTIONS(3244),
    [anon_sym_object] = ACTIONS(3244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3246),
    [anon_sym_constructor] = ACTIONS(3244),
    [anon_sym_prop] = ACTIONS(3244),
    [anon_sym_id] = ACTIONS(3244),
    [anon_sym_event] = ACTIONS(3244),
    [anon_sym_fn] = ACTIONS(3244),
    [anon_sym_on] = ACTIONS(3244),
    [sym__ternary_qmark] = ACTIONS(3246),
  },
  [933] = {
    [sym_identifier] = ACTIONS(3248),
    [anon_sym_STAR] = ACTIONS(3248),
    [anon_sym_as] = ACTIONS(3248),
    [anon_sym_LBRACE] = ACTIONS(3248),
    [anon_sym_RBRACE] = ACTIONS(3250),
    [anon_sym_typeof] = ACTIONS(3248),
    [anon_sym_BANG] = ACTIONS(3248),
    [anon_sym_LPAREN] = ACTIONS(3250),
    [anon_sym_in] = ACTIONS(3248),
    [anon_sym_SEMI] = ACTIONS(3250),
    [anon_sym_LBRACK] = ACTIONS(3250),
    [anon_sym_LT] = ACTIONS(3248),
    [anon_sym_GT] = ACTIONS(3248),
    [anon_sym_SLASH] = ACTIONS(3248),
    [anon_sym_DOT] = ACTIONS(3248),
    [anon_sym_async] = ACTIONS(3248),
    [anon_sym_QMARK_DOT] = ACTIONS(3250),
    [anon_sym_new] = ACTIONS(3248),
    [anon_sym_AMP_AMP] = ACTIONS(3250),
    [anon_sym_PIPE_PIPE] = ACTIONS(3250),
    [anon_sym_GT_GT] = ACTIONS(3248),
    [anon_sym_GT_GT_GT] = ACTIONS(3250),
    [anon_sym_LT_LT] = ACTIONS(3250),
    [anon_sym_AMP] = ACTIONS(3248),
    [anon_sym_CARET] = ACTIONS(3250),
    [anon_sym_PIPE] = ACTIONS(3248),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_DASH] = ACTIONS(3248),
    [anon_sym_PERCENT] = ACTIONS(3250),
    [anon_sym_STAR_STAR] = ACTIONS(3250),
    [anon_sym_LT_EQ] = ACTIONS(3250),
    [anon_sym_EQ_EQ] = ACTIONS(3248),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3250),
    [anon_sym_BANG_EQ] = ACTIONS(3248),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3250),
    [anon_sym_GT_EQ] = ACTIONS(3250),
    [anon_sym_QMARK_QMARK] = ACTIONS(3250),
    [anon_sym_instanceof] = ACTIONS(3248),
    [anon_sym_void] = ACTIONS(3248),
    [anon_sym_PLUS_PLUS] = ACTIONS(3250),
    [anon_sym_DASH_DASH] = ACTIONS(3250),
    [anon_sym_DQUOTE] = ACTIONS(3250),
    [anon_sym_SQUOTE] = ACTIONS(3250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3250),
    [sym_number] = ACTIONS(3250),
    [sym_this] = ACTIONS(3248),
    [sym_true] = ACTIONS(3248),
    [sym_false] = ACTIONS(3248),
    [sym_null] = ACTIONS(3248),
    [sym_undefined] = ACTIONS(3248),
    [anon_sym_static] = ACTIONS(3248),
    [anon_sym_readonly] = ACTIONS(3248),
    [anon_sym_get] = ACTIONS(3248),
    [anon_sym_set] = ACTIONS(3248),
    [anon_sym_QMARK] = ACTIONS(3248),
    [anon_sym_any] = ACTIONS(3248),
    [anon_sym_number] = ACTIONS(3248),
    [anon_sym_boolean] = ACTIONS(3248),
    [anon_sym_string] = ACTIONS(3248),
    [anon_sym_symbol] = ACTIONS(3248),
    [anon_sym_abstract] = ACTIONS(3248),
    [anon_sym_satisfies] = ACTIONS(3248),
    [anon_sym_extends] = ACTIONS(3248),
    [anon_sym_infer] = ACTIONS(3248),
    [anon_sym_keyof] = ACTIONS(3248),
    [anon_sym_unknown] = ACTIONS(3248),
    [anon_sym_never] = ACTIONS(3248),
    [anon_sym_object] = ACTIONS(3248),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3250),
    [anon_sym_constructor] = ACTIONS(3248),
    [anon_sym_prop] = ACTIONS(3248),
    [anon_sym_id] = ACTIONS(3248),
    [anon_sym_event] = ACTIONS(3248),
    [anon_sym_fn] = ACTIONS(3248),
    [anon_sym_on] = ACTIONS(3248),
    [sym__ternary_qmark] = ACTIONS(3250),
  },
  [934] = {
    [sym_identifier] = ACTIONS(3244),
    [anon_sym_STAR] = ACTIONS(3244),
    [anon_sym_as] = ACTIONS(3244),
    [anon_sym_LBRACE] = ACTIONS(3244),
    [anon_sym_RBRACE] = ACTIONS(3246),
    [anon_sym_typeof] = ACTIONS(3244),
    [anon_sym_BANG] = ACTIONS(3244),
    [anon_sym_LPAREN] = ACTIONS(3246),
    [anon_sym_in] = ACTIONS(3244),
    [anon_sym_SEMI] = ACTIONS(3246),
    [anon_sym_LBRACK] = ACTIONS(3246),
    [anon_sym_LT] = ACTIONS(3244),
    [anon_sym_GT] = ACTIONS(3244),
    [anon_sym_SLASH] = ACTIONS(3244),
    [anon_sym_DOT] = ACTIONS(3244),
    [anon_sym_async] = ACTIONS(3244),
    [anon_sym_QMARK_DOT] = ACTIONS(3246),
    [anon_sym_new] = ACTIONS(3244),
    [anon_sym_AMP_AMP] = ACTIONS(3246),
    [anon_sym_PIPE_PIPE] = ACTIONS(3246),
    [anon_sym_GT_GT] = ACTIONS(3244),
    [anon_sym_GT_GT_GT] = ACTIONS(3246),
    [anon_sym_LT_LT] = ACTIONS(3246),
    [anon_sym_AMP] = ACTIONS(3244),
    [anon_sym_CARET] = ACTIONS(3246),
    [anon_sym_PIPE] = ACTIONS(3244),
    [anon_sym_PLUS] = ACTIONS(3244),
    [anon_sym_DASH] = ACTIONS(3244),
    [anon_sym_PERCENT] = ACTIONS(3246),
    [anon_sym_STAR_STAR] = ACTIONS(3246),
    [anon_sym_LT_EQ] = ACTIONS(3246),
    [anon_sym_EQ_EQ] = ACTIONS(3244),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3246),
    [anon_sym_BANG_EQ] = ACTIONS(3244),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3246),
    [anon_sym_GT_EQ] = ACTIONS(3246),
    [anon_sym_QMARK_QMARK] = ACTIONS(3246),
    [anon_sym_instanceof] = ACTIONS(3244),
    [anon_sym_void] = ACTIONS(3244),
    [anon_sym_PLUS_PLUS] = ACTIONS(3246),
    [anon_sym_DASH_DASH] = ACTIONS(3246),
    [anon_sym_DQUOTE] = ACTIONS(3246),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3246),
    [sym_number] = ACTIONS(3246),
    [sym_this] = ACTIONS(3244),
    [sym_true] = ACTIONS(3244),
    [sym_false] = ACTIONS(3244),
    [sym_null] = ACTIONS(3244),
    [sym_undefined] = ACTIONS(3244),
    [anon_sym_static] = ACTIONS(3244),
    [anon_sym_readonly] = ACTIONS(3244),
    [anon_sym_get] = ACTIONS(3244),
    [anon_sym_set] = ACTIONS(3244),
    [anon_sym_QMARK] = ACTIONS(3244),
    [anon_sym_any] = ACTIONS(3244),
    [anon_sym_number] = ACTIONS(3244),
    [anon_sym_boolean] = ACTIONS(3244),
    [anon_sym_string] = ACTIONS(3244),
    [anon_sym_symbol] = ACTIONS(3244),
    [anon_sym_abstract] = ACTIONS(3244),
    [anon_sym_satisfies] = ACTIONS(3244),
    [anon_sym_extends] = ACTIONS(3244),
    [anon_sym_infer] = ACTIONS(3244),
    [anon_sym_keyof] = ACTIONS(3244),
    [anon_sym_unknown] = ACTIONS(3244),
    [anon_sym_never] = ACTIONS(3244),
    [anon_sym_object] = ACTIONS(3244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3246),
    [anon_sym_constructor] = ACTIONS(3244),
    [anon_sym_prop] = ACTIONS(3244),
    [anon_sym_id] = ACTIONS(3244),
    [anon_sym_event] = ACTIONS(3244),
    [anon_sym_fn] = ACTIONS(3244),
    [anon_sym_on] = ACTIONS(3244),
    [sym__ternary_qmark] = ACTIONS(3246),
  },
  [935] = {
    [sym_identifier] = ACTIONS(3252),
    [anon_sym_STAR] = ACTIONS(3252),
    [anon_sym_as] = ACTIONS(3252),
    [anon_sym_LBRACE] = ACTIONS(3252),
    [anon_sym_RBRACE] = ACTIONS(3254),
    [anon_sym_typeof] = ACTIONS(3252),
    [anon_sym_BANG] = ACTIONS(3252),
    [anon_sym_LPAREN] = ACTIONS(3254),
    [anon_sym_in] = ACTIONS(3252),
    [anon_sym_SEMI] = ACTIONS(3254),
    [anon_sym_LBRACK] = ACTIONS(3254),
    [anon_sym_LT] = ACTIONS(3252),
    [anon_sym_GT] = ACTIONS(3252),
    [anon_sym_SLASH] = ACTIONS(3252),
    [anon_sym_DOT] = ACTIONS(3252),
    [anon_sym_async] = ACTIONS(3252),
    [anon_sym_QMARK_DOT] = ACTIONS(3254),
    [anon_sym_new] = ACTIONS(3252),
    [anon_sym_AMP_AMP] = ACTIONS(3254),
    [anon_sym_PIPE_PIPE] = ACTIONS(3254),
    [anon_sym_GT_GT] = ACTIONS(3252),
    [anon_sym_GT_GT_GT] = ACTIONS(3254),
    [anon_sym_LT_LT] = ACTIONS(3254),
    [anon_sym_AMP] = ACTIONS(3252),
    [anon_sym_CARET] = ACTIONS(3254),
    [anon_sym_PIPE] = ACTIONS(3252),
    [anon_sym_PLUS] = ACTIONS(3252),
    [anon_sym_DASH] = ACTIONS(3252),
    [anon_sym_PERCENT] = ACTIONS(3254),
    [anon_sym_STAR_STAR] = ACTIONS(3254),
    [anon_sym_LT_EQ] = ACTIONS(3254),
    [anon_sym_EQ_EQ] = ACTIONS(3252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3254),
    [anon_sym_BANG_EQ] = ACTIONS(3252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3254),
    [anon_sym_GT_EQ] = ACTIONS(3254),
    [anon_sym_QMARK_QMARK] = ACTIONS(3254),
    [anon_sym_instanceof] = ACTIONS(3252),
    [anon_sym_void] = ACTIONS(3252),
    [anon_sym_PLUS_PLUS] = ACTIONS(3254),
    [anon_sym_DASH_DASH] = ACTIONS(3254),
    [anon_sym_DQUOTE] = ACTIONS(3254),
    [anon_sym_SQUOTE] = ACTIONS(3254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3254),
    [sym_number] = ACTIONS(3254),
    [sym_this] = ACTIONS(3252),
    [sym_true] = ACTIONS(3252),
    [sym_false] = ACTIONS(3252),
    [sym_null] = ACTIONS(3252),
    [sym_undefined] = ACTIONS(3252),
    [anon_sym_static] = ACTIONS(3252),
    [anon_sym_readonly] = ACTIONS(3252),
    [anon_sym_get] = ACTIONS(3252),
    [anon_sym_set] = ACTIONS(3252),
    [anon_sym_QMARK] = ACTIONS(3252),
    [anon_sym_any] = ACTIONS(3252),
    [anon_sym_number] = ACTIONS(3252),
    [anon_sym_boolean] = ACTIONS(3252),
    [anon_sym_string] = ACTIONS(3252),
    [anon_sym_symbol] = ACTIONS(3252),
    [anon_sym_abstract] = ACTIONS(3252),
    [anon_sym_satisfies] = ACTIONS(3252),
    [anon_sym_extends] = ACTIONS(3252),
    [anon_sym_infer] = ACTIONS(3252),
    [anon_sym_keyof] = ACTIONS(3252),
    [anon_sym_unknown] = ACTIONS(3252),
    [anon_sym_never] = ACTIONS(3252),
    [anon_sym_object] = ACTIONS(3252),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3254),
    [anon_sym_constructor] = ACTIONS(3252),
    [anon_sym_prop] = ACTIONS(3252),
    [anon_sym_id] = ACTIONS(3252),
    [anon_sym_event] = ACTIONS(3252),
    [anon_sym_fn] = ACTIONS(3252),
    [anon_sym_on] = ACTIONS(3252),
    [sym__ternary_qmark] = ACTIONS(3254),
  },
  [936] = {
    [sym_identifier] = ACTIONS(3256),
    [anon_sym_STAR] = ACTIONS(3256),
    [anon_sym_as] = ACTIONS(3256),
    [anon_sym_LBRACE] = ACTIONS(3256),
    [anon_sym_RBRACE] = ACTIONS(3258),
    [anon_sym_typeof] = ACTIONS(3256),
    [anon_sym_BANG] = ACTIONS(3256),
    [anon_sym_LPAREN] = ACTIONS(3258),
    [anon_sym_in] = ACTIONS(3256),
    [anon_sym_SEMI] = ACTIONS(3258),
    [anon_sym_LBRACK] = ACTIONS(3258),
    [anon_sym_LT] = ACTIONS(3256),
    [anon_sym_GT] = ACTIONS(3256),
    [anon_sym_SLASH] = ACTIONS(3256),
    [anon_sym_DOT] = ACTIONS(3256),
    [anon_sym_async] = ACTIONS(3256),
    [anon_sym_QMARK_DOT] = ACTIONS(3258),
    [anon_sym_new] = ACTIONS(3256),
    [anon_sym_AMP_AMP] = ACTIONS(3258),
    [anon_sym_PIPE_PIPE] = ACTIONS(3258),
    [anon_sym_GT_GT] = ACTIONS(3256),
    [anon_sym_GT_GT_GT] = ACTIONS(3258),
    [anon_sym_LT_LT] = ACTIONS(3258),
    [anon_sym_AMP] = ACTIONS(3256),
    [anon_sym_CARET] = ACTIONS(3258),
    [anon_sym_PIPE] = ACTIONS(3256),
    [anon_sym_PLUS] = ACTIONS(3256),
    [anon_sym_DASH] = ACTIONS(3256),
    [anon_sym_PERCENT] = ACTIONS(3258),
    [anon_sym_STAR_STAR] = ACTIONS(3258),
    [anon_sym_LT_EQ] = ACTIONS(3258),
    [anon_sym_EQ_EQ] = ACTIONS(3256),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3258),
    [anon_sym_BANG_EQ] = ACTIONS(3256),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3258),
    [anon_sym_GT_EQ] = ACTIONS(3258),
    [anon_sym_QMARK_QMARK] = ACTIONS(3258),
    [anon_sym_instanceof] = ACTIONS(3256),
    [anon_sym_void] = ACTIONS(3256),
    [anon_sym_PLUS_PLUS] = ACTIONS(3258),
    [anon_sym_DASH_DASH] = ACTIONS(3258),
    [anon_sym_DQUOTE] = ACTIONS(3258),
    [anon_sym_SQUOTE] = ACTIONS(3258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3258),
    [sym_number] = ACTIONS(3258),
    [sym_this] = ACTIONS(3256),
    [sym_true] = ACTIONS(3256),
    [sym_false] = ACTIONS(3256),
    [sym_null] = ACTIONS(3256),
    [sym_undefined] = ACTIONS(3256),
    [anon_sym_static] = ACTIONS(3256),
    [anon_sym_readonly] = ACTIONS(3256),
    [anon_sym_get] = ACTIONS(3256),
    [anon_sym_set] = ACTIONS(3256),
    [anon_sym_QMARK] = ACTIONS(3256),
    [anon_sym_any] = ACTIONS(3256),
    [anon_sym_number] = ACTIONS(3256),
    [anon_sym_boolean] = ACTIONS(3256),
    [anon_sym_string] = ACTIONS(3256),
    [anon_sym_symbol] = ACTIONS(3256),
    [anon_sym_abstract] = ACTIONS(3256),
    [anon_sym_satisfies] = ACTIONS(3256),
    [anon_sym_extends] = ACTIONS(3256),
    [anon_sym_infer] = ACTIONS(3256),
    [anon_sym_keyof] = ACTIONS(3256),
    [anon_sym_unknown] = ACTIONS(3256),
    [anon_sym_never] = ACTIONS(3256),
    [anon_sym_object] = ACTIONS(3256),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3258),
    [anon_sym_constructor] = ACTIONS(3256),
    [anon_sym_prop] = ACTIONS(3256),
    [anon_sym_id] = ACTIONS(3256),
    [anon_sym_event] = ACTIONS(3256),
    [anon_sym_fn] = ACTIONS(3256),
    [anon_sym_on] = ACTIONS(3256),
    [sym__ternary_qmark] = ACTIONS(3258),
  },
  [937] = {
    [sym_identifier] = ACTIONS(3260),
    [anon_sym_STAR] = ACTIONS(3260),
    [anon_sym_as] = ACTIONS(3260),
    [anon_sym_LBRACE] = ACTIONS(3260),
    [anon_sym_RBRACE] = ACTIONS(3262),
    [anon_sym_typeof] = ACTIONS(3260),
    [anon_sym_BANG] = ACTIONS(3260),
    [anon_sym_LPAREN] = ACTIONS(3262),
    [anon_sym_in] = ACTIONS(3260),
    [anon_sym_SEMI] = ACTIONS(3262),
    [anon_sym_LBRACK] = ACTIONS(3262),
    [anon_sym_LT] = ACTIONS(3260),
    [anon_sym_GT] = ACTIONS(3260),
    [anon_sym_SLASH] = ACTIONS(3260),
    [anon_sym_DOT] = ACTIONS(3260),
    [anon_sym_async] = ACTIONS(3260),
    [anon_sym_QMARK_DOT] = ACTIONS(3262),
    [anon_sym_new] = ACTIONS(3260),
    [anon_sym_AMP_AMP] = ACTIONS(3262),
    [anon_sym_PIPE_PIPE] = ACTIONS(3262),
    [anon_sym_GT_GT] = ACTIONS(3260),
    [anon_sym_GT_GT_GT] = ACTIONS(3262),
    [anon_sym_LT_LT] = ACTIONS(3262),
    [anon_sym_AMP] = ACTIONS(3110),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_PLUS] = ACTIONS(3260),
    [anon_sym_DASH] = ACTIONS(3260),
    [anon_sym_PERCENT] = ACTIONS(3262),
    [anon_sym_STAR_STAR] = ACTIONS(3262),
    [anon_sym_LT_EQ] = ACTIONS(3262),
    [anon_sym_EQ_EQ] = ACTIONS(3260),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3262),
    [anon_sym_BANG_EQ] = ACTIONS(3260),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3262),
    [anon_sym_GT_EQ] = ACTIONS(3262),
    [anon_sym_QMARK_QMARK] = ACTIONS(3262),
    [anon_sym_instanceof] = ACTIONS(3260),
    [anon_sym_void] = ACTIONS(3260),
    [anon_sym_PLUS_PLUS] = ACTIONS(3262),
    [anon_sym_DASH_DASH] = ACTIONS(3262),
    [anon_sym_DQUOTE] = ACTIONS(3262),
    [anon_sym_SQUOTE] = ACTIONS(3262),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3262),
    [sym_number] = ACTIONS(3262),
    [sym_this] = ACTIONS(3260),
    [sym_true] = ACTIONS(3260),
    [sym_false] = ACTIONS(3260),
    [sym_null] = ACTIONS(3260),
    [sym_undefined] = ACTIONS(3260),
    [anon_sym_static] = ACTIONS(3260),
    [anon_sym_readonly] = ACTIONS(3260),
    [anon_sym_get] = ACTIONS(3260),
    [anon_sym_set] = ACTIONS(3260),
    [anon_sym_QMARK] = ACTIONS(3260),
    [anon_sym_any] = ACTIONS(3260),
    [anon_sym_number] = ACTIONS(3260),
    [anon_sym_boolean] = ACTIONS(3260),
    [anon_sym_string] = ACTIONS(3260),
    [anon_sym_symbol] = ACTIONS(3260),
    [anon_sym_abstract] = ACTIONS(3260),
    [anon_sym_satisfies] = ACTIONS(3260),
    [anon_sym_extends] = ACTIONS(3160),
    [anon_sym_infer] = ACTIONS(3260),
    [anon_sym_keyof] = ACTIONS(3260),
    [anon_sym_unknown] = ACTIONS(3260),
    [anon_sym_never] = ACTIONS(3260),
    [anon_sym_object] = ACTIONS(3260),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3262),
    [anon_sym_constructor] = ACTIONS(3260),
    [anon_sym_prop] = ACTIONS(3260),
    [anon_sym_id] = ACTIONS(3260),
    [anon_sym_event] = ACTIONS(3260),
    [anon_sym_fn] = ACTIONS(3260),
    [anon_sym_on] = ACTIONS(3260),
    [sym__ternary_qmark] = ACTIONS(3262),
  },
  [938] = {
    [sym_identifier] = ACTIONS(3264),
    [anon_sym_STAR] = ACTIONS(3264),
    [anon_sym_as] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3264),
    [anon_sym_RBRACE] = ACTIONS(3266),
    [anon_sym_typeof] = ACTIONS(3264),
    [anon_sym_BANG] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3266),
    [anon_sym_in] = ACTIONS(3264),
    [anon_sym_SEMI] = ACTIONS(3266),
    [anon_sym_LBRACK] = ACTIONS(3266),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_GT] = ACTIONS(3264),
    [anon_sym_SLASH] = ACTIONS(3264),
    [anon_sym_DOT] = ACTIONS(3264),
    [anon_sym_async] = ACTIONS(3264),
    [anon_sym_QMARK_DOT] = ACTIONS(3266),
    [anon_sym_new] = ACTIONS(3264),
    [anon_sym_AMP_AMP] = ACTIONS(3266),
    [anon_sym_PIPE_PIPE] = ACTIONS(3266),
    [anon_sym_GT_GT] = ACTIONS(3264),
    [anon_sym_GT_GT_GT] = ACTIONS(3266),
    [anon_sym_LT_LT] = ACTIONS(3266),
    [anon_sym_AMP] = ACTIONS(3264),
    [anon_sym_CARET] = ACTIONS(3266),
    [anon_sym_PIPE] = ACTIONS(3264),
    [anon_sym_PLUS] = ACTIONS(3264),
    [anon_sym_DASH] = ACTIONS(3264),
    [anon_sym_PERCENT] = ACTIONS(3266),
    [anon_sym_STAR_STAR] = ACTIONS(3266),
    [anon_sym_LT_EQ] = ACTIONS(3266),
    [anon_sym_EQ_EQ] = ACTIONS(3264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3266),
    [anon_sym_BANG_EQ] = ACTIONS(3264),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3266),
    [anon_sym_GT_EQ] = ACTIONS(3266),
    [anon_sym_QMARK_QMARK] = ACTIONS(3266),
    [anon_sym_instanceof] = ACTIONS(3264),
    [anon_sym_void] = ACTIONS(3264),
    [anon_sym_PLUS_PLUS] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3266),
    [anon_sym_DQUOTE] = ACTIONS(3266),
    [anon_sym_SQUOTE] = ACTIONS(3266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3266),
    [sym_number] = ACTIONS(3266),
    [sym_this] = ACTIONS(3264),
    [sym_true] = ACTIONS(3264),
    [sym_false] = ACTIONS(3264),
    [sym_null] = ACTIONS(3264),
    [sym_undefined] = ACTIONS(3264),
    [anon_sym_static] = ACTIONS(3264),
    [anon_sym_readonly] = ACTIONS(3264),
    [anon_sym_get] = ACTIONS(3264),
    [anon_sym_set] = ACTIONS(3264),
    [anon_sym_QMARK] = ACTIONS(3264),
    [anon_sym_any] = ACTIONS(3264),
    [anon_sym_number] = ACTIONS(3264),
    [anon_sym_boolean] = ACTIONS(3264),
    [anon_sym_string] = ACTIONS(3264),
    [anon_sym_symbol] = ACTIONS(3264),
    [anon_sym_abstract] = ACTIONS(3264),
    [anon_sym_satisfies] = ACTIONS(3264),
    [anon_sym_extends] = ACTIONS(3264),
    [anon_sym_infer] = ACTIONS(3264),
    [anon_sym_keyof] = ACTIONS(3264),
    [anon_sym_unknown] = ACTIONS(3264),
    [anon_sym_never] = ACTIONS(3264),
    [anon_sym_object] = ACTIONS(3264),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3266),
    [anon_sym_constructor] = ACTIONS(3264),
    [anon_sym_prop] = ACTIONS(3264),
    [anon_sym_id] = ACTIONS(3264),
    [anon_sym_event] = ACTIONS(3264),
    [anon_sym_fn] = ACTIONS(3264),
    [anon_sym_on] = ACTIONS(3264),
    [sym__ternary_qmark] = ACTIONS(3266),
  },
  [939] = {
    [sym_identifier] = ACTIONS(3268),
    [anon_sym_STAR] = ACTIONS(3268),
    [anon_sym_as] = ACTIONS(3268),
    [anon_sym_LBRACE] = ACTIONS(3268),
    [anon_sym_RBRACE] = ACTIONS(3270),
    [anon_sym_typeof] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3268),
    [anon_sym_LPAREN] = ACTIONS(3270),
    [anon_sym_in] = ACTIONS(3268),
    [anon_sym_SEMI] = ACTIONS(3270),
    [anon_sym_LBRACK] = ACTIONS(3270),
    [anon_sym_LT] = ACTIONS(3268),
    [anon_sym_GT] = ACTIONS(3268),
    [anon_sym_SLASH] = ACTIONS(3268),
    [anon_sym_DOT] = ACTIONS(3268),
    [anon_sym_async] = ACTIONS(3268),
    [anon_sym_QMARK_DOT] = ACTIONS(3270),
    [anon_sym_new] = ACTIONS(3268),
    [anon_sym_AMP_AMP] = ACTIONS(3270),
    [anon_sym_PIPE_PIPE] = ACTIONS(3270),
    [anon_sym_GT_GT] = ACTIONS(3268),
    [anon_sym_GT_GT_GT] = ACTIONS(3270),
    [anon_sym_LT_LT] = ACTIONS(3270),
    [anon_sym_AMP] = ACTIONS(3268),
    [anon_sym_CARET] = ACTIONS(3270),
    [anon_sym_PIPE] = ACTIONS(3268),
    [anon_sym_PLUS] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3268),
    [anon_sym_PERCENT] = ACTIONS(3270),
    [anon_sym_STAR_STAR] = ACTIONS(3270),
    [anon_sym_LT_EQ] = ACTIONS(3270),
    [anon_sym_EQ_EQ] = ACTIONS(3268),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3270),
    [anon_sym_BANG_EQ] = ACTIONS(3268),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3270),
    [anon_sym_GT_EQ] = ACTIONS(3270),
    [anon_sym_QMARK_QMARK] = ACTIONS(3270),
    [anon_sym_instanceof] = ACTIONS(3268),
    [anon_sym_void] = ACTIONS(3268),
    [anon_sym_PLUS_PLUS] = ACTIONS(3270),
    [anon_sym_DASH_DASH] = ACTIONS(3270),
    [anon_sym_DQUOTE] = ACTIONS(3270),
    [anon_sym_SQUOTE] = ACTIONS(3270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3270),
    [sym_number] = ACTIONS(3270),
    [sym_this] = ACTIONS(3268),
    [sym_true] = ACTIONS(3268),
    [sym_false] = ACTIONS(3268),
    [sym_null] = ACTIONS(3268),
    [sym_undefined] = ACTIONS(3268),
    [anon_sym_static] = ACTIONS(3268),
    [anon_sym_readonly] = ACTIONS(3268),
    [anon_sym_get] = ACTIONS(3268),
    [anon_sym_set] = ACTIONS(3268),
    [anon_sym_QMARK] = ACTIONS(3268),
    [anon_sym_any] = ACTIONS(3268),
    [anon_sym_number] = ACTIONS(3268),
    [anon_sym_boolean] = ACTIONS(3268),
    [anon_sym_string] = ACTIONS(3268),
    [anon_sym_symbol] = ACTIONS(3268),
    [anon_sym_abstract] = ACTIONS(3268),
    [anon_sym_satisfies] = ACTIONS(3268),
    [anon_sym_extends] = ACTIONS(3268),
    [anon_sym_infer] = ACTIONS(3268),
    [anon_sym_keyof] = ACTIONS(3268),
    [anon_sym_unknown] = ACTIONS(3268),
    [anon_sym_never] = ACTIONS(3268),
    [anon_sym_object] = ACTIONS(3268),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3270),
    [anon_sym_constructor] = ACTIONS(3268),
    [anon_sym_prop] = ACTIONS(3268),
    [anon_sym_id] = ACTIONS(3268),
    [anon_sym_event] = ACTIONS(3268),
    [anon_sym_fn] = ACTIONS(3268),
    [anon_sym_on] = ACTIONS(3268),
    [sym__ternary_qmark] = ACTIONS(3270),
  },
  [940] = {
    [sym_identifier] = ACTIONS(3272),
    [anon_sym_STAR] = ACTIONS(3272),
    [anon_sym_as] = ACTIONS(3272),
    [anon_sym_LBRACE] = ACTIONS(3272),
    [anon_sym_RBRACE] = ACTIONS(3274),
    [anon_sym_typeof] = ACTIONS(3272),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_LPAREN] = ACTIONS(3274),
    [anon_sym_in] = ACTIONS(3272),
    [anon_sym_SEMI] = ACTIONS(3274),
    [anon_sym_LBRACK] = ACTIONS(3274),
    [anon_sym_LT] = ACTIONS(3272),
    [anon_sym_GT] = ACTIONS(3272),
    [anon_sym_SLASH] = ACTIONS(3272),
    [anon_sym_DOT] = ACTIONS(3272),
    [anon_sym_async] = ACTIONS(3272),
    [anon_sym_QMARK_DOT] = ACTIONS(3274),
    [anon_sym_new] = ACTIONS(3272),
    [anon_sym_AMP_AMP] = ACTIONS(3274),
    [anon_sym_PIPE_PIPE] = ACTIONS(3274),
    [anon_sym_GT_GT] = ACTIONS(3272),
    [anon_sym_GT_GT_GT] = ACTIONS(3274),
    [anon_sym_LT_LT] = ACTIONS(3274),
    [anon_sym_AMP] = ACTIONS(3272),
    [anon_sym_CARET] = ACTIONS(3274),
    [anon_sym_PIPE] = ACTIONS(3272),
    [anon_sym_PLUS] = ACTIONS(3272),
    [anon_sym_DASH] = ACTIONS(3272),
    [anon_sym_PERCENT] = ACTIONS(3274),
    [anon_sym_STAR_STAR] = ACTIONS(3274),
    [anon_sym_LT_EQ] = ACTIONS(3274),
    [anon_sym_EQ_EQ] = ACTIONS(3272),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3274),
    [anon_sym_BANG_EQ] = ACTIONS(3272),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3274),
    [anon_sym_GT_EQ] = ACTIONS(3274),
    [anon_sym_QMARK_QMARK] = ACTIONS(3274),
    [anon_sym_instanceof] = ACTIONS(3272),
    [anon_sym_void] = ACTIONS(3272),
    [anon_sym_PLUS_PLUS] = ACTIONS(3274),
    [anon_sym_DASH_DASH] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(3274),
    [anon_sym_SQUOTE] = ACTIONS(3274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3274),
    [sym_number] = ACTIONS(3274),
    [sym_this] = ACTIONS(3272),
    [sym_true] = ACTIONS(3272),
    [sym_false] = ACTIONS(3272),
    [sym_null] = ACTIONS(3272),
    [sym_undefined] = ACTIONS(3272),
    [anon_sym_static] = ACTIONS(3272),
    [anon_sym_readonly] = ACTIONS(3272),
    [anon_sym_get] = ACTIONS(3272),
    [anon_sym_set] = ACTIONS(3272),
    [anon_sym_QMARK] = ACTIONS(3272),
    [anon_sym_any] = ACTIONS(3272),
    [anon_sym_number] = ACTIONS(3272),
    [anon_sym_boolean] = ACTIONS(3272),
    [anon_sym_string] = ACTIONS(3272),
    [anon_sym_symbol] = ACTIONS(3272),
    [anon_sym_abstract] = ACTIONS(3272),
    [anon_sym_satisfies] = ACTIONS(3272),
    [anon_sym_extends] = ACTIONS(3272),
    [anon_sym_infer] = ACTIONS(3272),
    [anon_sym_keyof] = ACTIONS(3272),
    [anon_sym_unknown] = ACTIONS(3272),
    [anon_sym_never] = ACTIONS(3272),
    [anon_sym_object] = ACTIONS(3272),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3274),
    [anon_sym_constructor] = ACTIONS(3272),
    [anon_sym_prop] = ACTIONS(3272),
    [anon_sym_id] = ACTIONS(3272),
    [anon_sym_event] = ACTIONS(3272),
    [anon_sym_fn] = ACTIONS(3272),
    [anon_sym_on] = ACTIONS(3272),
    [sym__ternary_qmark] = ACTIONS(3274),
  },
  [941] = {
    [sym_identifier] = ACTIONS(3276),
    [anon_sym_STAR] = ACTIONS(3276),
    [anon_sym_as] = ACTIONS(3276),
    [anon_sym_LBRACE] = ACTIONS(3276),
    [anon_sym_RBRACE] = ACTIONS(3278),
    [anon_sym_typeof] = ACTIONS(3276),
    [anon_sym_BANG] = ACTIONS(3276),
    [anon_sym_LPAREN] = ACTIONS(3278),
    [anon_sym_in] = ACTIONS(3276),
    [anon_sym_SEMI] = ACTIONS(3278),
    [anon_sym_EQ] = ACTIONS(3280),
    [anon_sym_LBRACK] = ACTIONS(3278),
    [anon_sym_LT] = ACTIONS(3276),
    [anon_sym_GT] = ACTIONS(3276),
    [anon_sym_SLASH] = ACTIONS(3276),
    [anon_sym_DOT] = ACTIONS(3276),
    [anon_sym_async] = ACTIONS(3276),
    [anon_sym_QMARK_DOT] = ACTIONS(3278),
    [anon_sym_new] = ACTIONS(3276),
    [anon_sym_AMP_AMP] = ACTIONS(3278),
    [anon_sym_PIPE_PIPE] = ACTIONS(3278),
    [anon_sym_GT_GT] = ACTIONS(3276),
    [anon_sym_GT_GT_GT] = ACTIONS(3278),
    [anon_sym_LT_LT] = ACTIONS(3278),
    [anon_sym_AMP] = ACTIONS(3276),
    [anon_sym_CARET] = ACTIONS(3278),
    [anon_sym_PIPE] = ACTIONS(3276),
    [anon_sym_PLUS] = ACTIONS(3276),
    [anon_sym_DASH] = ACTIONS(3276),
    [anon_sym_PERCENT] = ACTIONS(3278),
    [anon_sym_STAR_STAR] = ACTIONS(3278),
    [anon_sym_LT_EQ] = ACTIONS(3278),
    [anon_sym_EQ_EQ] = ACTIONS(3276),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3278),
    [anon_sym_BANG_EQ] = ACTIONS(3276),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3278),
    [anon_sym_GT_EQ] = ACTIONS(3278),
    [anon_sym_QMARK_QMARK] = ACTIONS(3278),
    [anon_sym_instanceof] = ACTIONS(3276),
    [anon_sym_void] = ACTIONS(3276),
    [anon_sym_PLUS_PLUS] = ACTIONS(3278),
    [anon_sym_DASH_DASH] = ACTIONS(3278),
    [anon_sym_DQUOTE] = ACTIONS(3278),
    [anon_sym_SQUOTE] = ACTIONS(3278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3278),
    [sym_number] = ACTIONS(3278),
    [sym_this] = ACTIONS(3276),
    [sym_true] = ACTIONS(3276),
    [sym_false] = ACTIONS(3276),
    [sym_null] = ACTIONS(3276),
    [sym_undefined] = ACTIONS(3276),
    [anon_sym_static] = ACTIONS(3276),
    [anon_sym_readonly] = ACTIONS(3276),
    [anon_sym_get] = ACTIONS(3276),
    [anon_sym_set] = ACTIONS(3276),
    [anon_sym_QMARK] = ACTIONS(3276),
    [anon_sym_any] = ACTIONS(3276),
    [anon_sym_number] = ACTIONS(3276),
    [anon_sym_boolean] = ACTIONS(3276),
    [anon_sym_string] = ACTIONS(3276),
    [anon_sym_symbol] = ACTIONS(3276),
    [anon_sym_abstract] = ACTIONS(3276),
    [anon_sym_satisfies] = ACTIONS(3276),
    [anon_sym_infer] = ACTIONS(3276),
    [anon_sym_keyof] = ACTIONS(3276),
    [anon_sym_unknown] = ACTIONS(3276),
    [anon_sym_never] = ACTIONS(3276),
    [anon_sym_object] = ACTIONS(3276),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3278),
    [anon_sym_constructor] = ACTIONS(3276),
    [anon_sym_prop] = ACTIONS(3276),
    [anon_sym_id] = ACTIONS(3276),
    [anon_sym_event] = ACTIONS(3276),
    [anon_sym_fn] = ACTIONS(3276),
    [anon_sym_on] = ACTIONS(3276),
    [sym__ternary_qmark] = ACTIONS(3278),
  },
  [942] = {
    [sym_identifier] = ACTIONS(3282),
    [anon_sym_STAR] = ACTIONS(3282),
    [anon_sym_as] = ACTIONS(3282),
    [anon_sym_LBRACE] = ACTIONS(3282),
    [anon_sym_RBRACE] = ACTIONS(3284),
    [anon_sym_typeof] = ACTIONS(3282),
    [anon_sym_BANG] = ACTIONS(3282),
    [anon_sym_LPAREN] = ACTIONS(3284),
    [anon_sym_in] = ACTIONS(3282),
    [anon_sym_SEMI] = ACTIONS(3284),
    [anon_sym_LBRACK] = ACTIONS(3284),
    [anon_sym_LT] = ACTIONS(3282),
    [anon_sym_GT] = ACTIONS(3282),
    [anon_sym_SLASH] = ACTIONS(3282),
    [anon_sym_DOT] = ACTIONS(3282),
    [anon_sym_async] = ACTIONS(3282),
    [anon_sym_QMARK_DOT] = ACTIONS(3284),
    [anon_sym_new] = ACTIONS(3282),
    [anon_sym_AMP_AMP] = ACTIONS(3284),
    [anon_sym_PIPE_PIPE] = ACTIONS(3284),
    [anon_sym_GT_GT] = ACTIONS(3282),
    [anon_sym_GT_GT_GT] = ACTIONS(3284),
    [anon_sym_LT_LT] = ACTIONS(3284),
    [anon_sym_AMP] = ACTIONS(3282),
    [anon_sym_CARET] = ACTIONS(3284),
    [anon_sym_PIPE] = ACTIONS(3282),
    [anon_sym_PLUS] = ACTIONS(3282),
    [anon_sym_DASH] = ACTIONS(3282),
    [anon_sym_PERCENT] = ACTIONS(3284),
    [anon_sym_STAR_STAR] = ACTIONS(3284),
    [anon_sym_LT_EQ] = ACTIONS(3284),
    [anon_sym_EQ_EQ] = ACTIONS(3282),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3284),
    [anon_sym_BANG_EQ] = ACTIONS(3282),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3284),
    [anon_sym_GT_EQ] = ACTIONS(3284),
    [anon_sym_QMARK_QMARK] = ACTIONS(3284),
    [anon_sym_instanceof] = ACTIONS(3282),
    [anon_sym_void] = ACTIONS(3282),
    [anon_sym_PLUS_PLUS] = ACTIONS(3284),
    [anon_sym_DASH_DASH] = ACTIONS(3284),
    [anon_sym_DQUOTE] = ACTIONS(3284),
    [anon_sym_SQUOTE] = ACTIONS(3284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3284),
    [sym_number] = ACTIONS(3284),
    [sym_this] = ACTIONS(3282),
    [sym_true] = ACTIONS(3282),
    [sym_false] = ACTIONS(3282),
    [sym_null] = ACTIONS(3282),
    [sym_undefined] = ACTIONS(3282),
    [anon_sym_static] = ACTIONS(3282),
    [anon_sym_readonly] = ACTIONS(3282),
    [anon_sym_get] = ACTIONS(3282),
    [anon_sym_set] = ACTIONS(3282),
    [anon_sym_QMARK] = ACTIONS(3282),
    [anon_sym_any] = ACTIONS(3282),
    [anon_sym_number] = ACTIONS(3282),
    [anon_sym_boolean] = ACTIONS(3282),
    [anon_sym_string] = ACTIONS(3282),
    [anon_sym_symbol] = ACTIONS(3282),
    [anon_sym_abstract] = ACTIONS(3282),
    [anon_sym_satisfies] = ACTIONS(3282),
    [anon_sym_extends] = ACTIONS(3282),
    [anon_sym_infer] = ACTIONS(3282),
    [anon_sym_keyof] = ACTIONS(3282),
    [anon_sym_unknown] = ACTIONS(3282),
    [anon_sym_never] = ACTIONS(3282),
    [anon_sym_object] = ACTIONS(3282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3284),
    [anon_sym_constructor] = ACTIONS(3282),
    [anon_sym_prop] = ACTIONS(3282),
    [anon_sym_id] = ACTIONS(3282),
    [anon_sym_event] = ACTIONS(3282),
    [anon_sym_fn] = ACTIONS(3282),
    [anon_sym_on] = ACTIONS(3282),
    [sym__ternary_qmark] = ACTIONS(3284),
  },
  [943] = {
    [sym_optional_chain] = STATE(3632),
    [sym_identifier] = ACTIONS(3286),
    [anon_sym_STAR] = ACTIONS(3286),
    [anon_sym_as] = ACTIONS(3286),
    [anon_sym_LBRACE] = ACTIONS(3286),
    [anon_sym_RBRACE] = ACTIONS(3288),
    [anon_sym_typeof] = ACTIONS(3286),
    [anon_sym_BANG] = ACTIONS(3286),
    [anon_sym_LPAREN] = ACTIONS(3288),
    [anon_sym_in] = ACTIONS(3286),
    [anon_sym_SEMI] = ACTIONS(3288),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(3286),
    [anon_sym_GT] = ACTIONS(3286),
    [anon_sym_SLASH] = ACTIONS(3286),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(3286),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(3286),
    [anon_sym_AMP_AMP] = ACTIONS(3288),
    [anon_sym_PIPE_PIPE] = ACTIONS(3288),
    [anon_sym_GT_GT] = ACTIONS(3286),
    [anon_sym_GT_GT_GT] = ACTIONS(3288),
    [anon_sym_LT_LT] = ACTIONS(3288),
    [anon_sym_AMP] = ACTIONS(3286),
    [anon_sym_CARET] = ACTIONS(3288),
    [anon_sym_PIPE] = ACTIONS(3286),
    [anon_sym_PLUS] = ACTIONS(3286),
    [anon_sym_DASH] = ACTIONS(3286),
    [anon_sym_PERCENT] = ACTIONS(3288),
    [anon_sym_STAR_STAR] = ACTIONS(3288),
    [anon_sym_LT_EQ] = ACTIONS(3288),
    [anon_sym_EQ_EQ] = ACTIONS(3286),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3288),
    [anon_sym_BANG_EQ] = ACTIONS(3286),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3288),
    [anon_sym_GT_EQ] = ACTIONS(3288),
    [anon_sym_QMARK_QMARK] = ACTIONS(3288),
    [anon_sym_instanceof] = ACTIONS(3286),
    [anon_sym_void] = ACTIONS(3286),
    [anon_sym_PLUS_PLUS] = ACTIONS(3288),
    [anon_sym_DASH_DASH] = ACTIONS(3288),
    [anon_sym_DQUOTE] = ACTIONS(3288),
    [anon_sym_SQUOTE] = ACTIONS(3288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3288),
    [sym_number] = ACTIONS(3288),
    [sym_this] = ACTIONS(3286),
    [sym_true] = ACTIONS(3286),
    [sym_false] = ACTIONS(3286),
    [sym_null] = ACTIONS(3286),
    [sym_undefined] = ACTIONS(3286),
    [anon_sym_static] = ACTIONS(3286),
    [anon_sym_readonly] = ACTIONS(3286),
    [anon_sym_get] = ACTIONS(3286),
    [anon_sym_set] = ACTIONS(3286),
    [anon_sym_QMARK] = ACTIONS(3286),
    [anon_sym_any] = ACTIONS(3286),
    [anon_sym_number] = ACTIONS(3286),
    [anon_sym_boolean] = ACTIONS(3286),
    [anon_sym_string] = ACTIONS(3286),
    [anon_sym_symbol] = ACTIONS(3286),
    [anon_sym_abstract] = ACTIONS(3286),
    [anon_sym_satisfies] = ACTIONS(3286),
    [anon_sym_infer] = ACTIONS(3286),
    [anon_sym_keyof] = ACTIONS(3286),
    [anon_sym_unknown] = ACTIONS(3286),
    [anon_sym_never] = ACTIONS(3286),
    [anon_sym_object] = ACTIONS(3286),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3288),
    [anon_sym_constructor] = ACTIONS(3286),
    [anon_sym_prop] = ACTIONS(3286),
    [anon_sym_id] = ACTIONS(3286),
    [anon_sym_event] = ACTIONS(3286),
    [anon_sym_fn] = ACTIONS(3286),
    [anon_sym_on] = ACTIONS(3286),
    [sym__ternary_qmark] = ACTIONS(3288),
  },
  [944] = {
    [sym_identifier] = ACTIONS(3290),
    [anon_sym_STAR] = ACTIONS(3290),
    [anon_sym_as] = ACTIONS(3290),
    [anon_sym_LBRACE] = ACTIONS(3290),
    [anon_sym_RBRACE] = ACTIONS(3292),
    [anon_sym_typeof] = ACTIONS(3290),
    [anon_sym_BANG] = ACTIONS(3290),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_in] = ACTIONS(3290),
    [anon_sym_SEMI] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LT] = ACTIONS(3290),
    [anon_sym_GT] = ACTIONS(3290),
    [anon_sym_SLASH] = ACTIONS(3290),
    [anon_sym_DOT] = ACTIONS(3290),
    [anon_sym_async] = ACTIONS(3290),
    [anon_sym_QMARK_DOT] = ACTIONS(3292),
    [anon_sym_new] = ACTIONS(3290),
    [anon_sym_AMP_AMP] = ACTIONS(3292),
    [anon_sym_PIPE_PIPE] = ACTIONS(3292),
    [anon_sym_GT_GT] = ACTIONS(3290),
    [anon_sym_GT_GT_GT] = ACTIONS(3292),
    [anon_sym_LT_LT] = ACTIONS(3292),
    [anon_sym_AMP] = ACTIONS(3290),
    [anon_sym_CARET] = ACTIONS(3292),
    [anon_sym_PIPE] = ACTIONS(3290),
    [anon_sym_PLUS] = ACTIONS(3290),
    [anon_sym_DASH] = ACTIONS(3290),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_STAR_STAR] = ACTIONS(3292),
    [anon_sym_LT_EQ] = ACTIONS(3292),
    [anon_sym_EQ_EQ] = ACTIONS(3290),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3292),
    [anon_sym_BANG_EQ] = ACTIONS(3290),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3292),
    [anon_sym_GT_EQ] = ACTIONS(3292),
    [anon_sym_QMARK_QMARK] = ACTIONS(3292),
    [anon_sym_instanceof] = ACTIONS(3290),
    [anon_sym_void] = ACTIONS(3290),
    [anon_sym_PLUS_PLUS] = ACTIONS(3292),
    [anon_sym_DASH_DASH] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_SQUOTE] = ACTIONS(3292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3292),
    [sym_number] = ACTIONS(3292),
    [sym_this] = ACTIONS(3290),
    [sym_true] = ACTIONS(3290),
    [sym_false] = ACTIONS(3290),
    [sym_null] = ACTIONS(3290),
    [sym_undefined] = ACTIONS(3290),
    [anon_sym_static] = ACTIONS(3290),
    [anon_sym_readonly] = ACTIONS(3290),
    [anon_sym_get] = ACTIONS(3290),
    [anon_sym_set] = ACTIONS(3290),
    [anon_sym_QMARK] = ACTIONS(3290),
    [anon_sym_any] = ACTIONS(3290),
    [anon_sym_number] = ACTIONS(3290),
    [anon_sym_boolean] = ACTIONS(3290),
    [anon_sym_string] = ACTIONS(3290),
    [anon_sym_symbol] = ACTIONS(3290),
    [anon_sym_abstract] = ACTIONS(3290),
    [anon_sym_satisfies] = ACTIONS(3290),
    [anon_sym_extends] = ACTIONS(3290),
    [anon_sym_infer] = ACTIONS(3290),
    [anon_sym_keyof] = ACTIONS(3290),
    [anon_sym_unknown] = ACTIONS(3290),
    [anon_sym_never] = ACTIONS(3290),
    [anon_sym_object] = ACTIONS(3290),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3292),
    [anon_sym_constructor] = ACTIONS(3290),
    [anon_sym_prop] = ACTIONS(3290),
    [anon_sym_id] = ACTIONS(3290),
    [anon_sym_event] = ACTIONS(3290),
    [anon_sym_fn] = ACTIONS(3290),
    [anon_sym_on] = ACTIONS(3290),
    [sym__ternary_qmark] = ACTIONS(3292),
  },
  [945] = {
    [sym_identifier] = ACTIONS(1368),
    [anon_sym_STAR] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(1368),
    [anon_sym_LBRACE] = ACTIONS(1368),
    [anon_sym_RBRACE] = ACTIONS(1372),
    [anon_sym_typeof] = ACTIONS(1368),
    [anon_sym_BANG] = ACTIONS(1368),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_in] = ACTIONS(1368),
    [anon_sym_SEMI] = ACTIONS(1372),
    [anon_sym_EQ] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1372),
    [anon_sym_LT] = ACTIONS(1368),
    [anon_sym_GT] = ACTIONS(1368),
    [anon_sym_SLASH] = ACTIONS(1368),
    [anon_sym_DOT] = ACTIONS(1368),
    [anon_sym_async] = ACTIONS(1368),
    [anon_sym_QMARK_DOT] = ACTIONS(1372),
    [anon_sym_new] = ACTIONS(1368),
    [anon_sym_AMP_AMP] = ACTIONS(1372),
    [anon_sym_PIPE_PIPE] = ACTIONS(1372),
    [anon_sym_GT_GT] = ACTIONS(1368),
    [anon_sym_GT_GT_GT] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1368),
    [anon_sym_CARET] = ACTIONS(1372),
    [anon_sym_PIPE] = ACTIONS(1368),
    [anon_sym_PLUS] = ACTIONS(1368),
    [anon_sym_DASH] = ACTIONS(1368),
    [anon_sym_PERCENT] = ACTIONS(1372),
    [anon_sym_STAR_STAR] = ACTIONS(1372),
    [anon_sym_LT_EQ] = ACTIONS(1372),
    [anon_sym_EQ_EQ] = ACTIONS(1368),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1372),
    [anon_sym_BANG_EQ] = ACTIONS(1368),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1372),
    [anon_sym_GT_EQ] = ACTIONS(1372),
    [anon_sym_QMARK_QMARK] = ACTIONS(1372),
    [anon_sym_instanceof] = ACTIONS(1368),
    [anon_sym_void] = ACTIONS(1368),
    [anon_sym_PLUS_PLUS] = ACTIONS(1372),
    [anon_sym_DASH_DASH] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1372),
    [anon_sym_SQUOTE] = ACTIONS(1372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1372),
    [sym_number] = ACTIONS(1372),
    [sym_this] = ACTIONS(1368),
    [sym_true] = ACTIONS(1368),
    [sym_false] = ACTIONS(1368),
    [sym_null] = ACTIONS(1368),
    [sym_undefined] = ACTIONS(1368),
    [anon_sym_static] = ACTIONS(1368),
    [anon_sym_readonly] = ACTIONS(1368),
    [anon_sym_get] = ACTIONS(1368),
    [anon_sym_set] = ACTIONS(1368),
    [anon_sym_QMARK] = ACTIONS(1368),
    [anon_sym_any] = ACTIONS(1368),
    [anon_sym_number] = ACTIONS(1368),
    [anon_sym_boolean] = ACTIONS(1368),
    [anon_sym_string] = ACTIONS(1368),
    [anon_sym_symbol] = ACTIONS(1368),
    [anon_sym_abstract] = ACTIONS(1368),
    [anon_sym_satisfies] = ACTIONS(1368),
    [anon_sym_infer] = ACTIONS(1368),
    [anon_sym_keyof] = ACTIONS(1368),
    [anon_sym_unknown] = ACTIONS(1368),
    [anon_sym_never] = ACTIONS(1368),
    [anon_sym_object] = ACTIONS(1368),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1372),
    [anon_sym_constructor] = ACTIONS(1368),
    [anon_sym_prop] = ACTIONS(1368),
    [anon_sym_id] = ACTIONS(1368),
    [anon_sym_event] = ACTIONS(1368),
    [anon_sym_fn] = ACTIONS(1368),
    [anon_sym_on] = ACTIONS(1368),
    [sym__ternary_qmark] = ACTIONS(1372),
  },
  [946] = {
    [sym_identifier] = ACTIONS(1848),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1848),
    [anon_sym_LBRACE] = ACTIONS(1848),
    [anon_sym_RBRACE] = ACTIONS(1852),
    [anon_sym_typeof] = ACTIONS(1848),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(1854),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(1848),
    [anon_sym_async] = ACTIONS(1848),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1848),
    [anon_sym_AMP_AMP] = ACTIONS(1852),
    [anon_sym_PIPE_PIPE] = ACTIONS(1852),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1852),
    [anon_sym_LT_LT] = ACTIONS(1852),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1852),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1852),
    [anon_sym_STAR_STAR] = ACTIONS(1852),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1852),
    [anon_sym_instanceof] = ACTIONS(1848),
    [anon_sym_void] = ACTIONS(1848),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [anon_sym_DQUOTE] = ACTIONS(1852),
    [anon_sym_SQUOTE] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1852),
    [sym_number] = ACTIONS(1852),
    [sym_this] = ACTIONS(1848),
    [sym_true] = ACTIONS(1848),
    [sym_false] = ACTIONS(1848),
    [sym_null] = ACTIONS(1848),
    [sym_undefined] = ACTIONS(1848),
    [anon_sym_static] = ACTIONS(1848),
    [anon_sym_readonly] = ACTIONS(1848),
    [anon_sym_get] = ACTIONS(1848),
    [anon_sym_set] = ACTIONS(1848),
    [anon_sym_QMARK] = ACTIONS(1848),
    [anon_sym_any] = ACTIONS(1848),
    [anon_sym_number] = ACTIONS(1848),
    [anon_sym_boolean] = ACTIONS(1848),
    [anon_sym_string] = ACTIONS(1848),
    [anon_sym_symbol] = ACTIONS(1848),
    [anon_sym_abstract] = ACTIONS(1848),
    [anon_sym_satisfies] = ACTIONS(1848),
    [anon_sym_infer] = ACTIONS(1848),
    [anon_sym_keyof] = ACTIONS(1848),
    [anon_sym_unknown] = ACTIONS(1848),
    [anon_sym_never] = ACTIONS(1848),
    [anon_sym_object] = ACTIONS(1848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_constructor] = ACTIONS(1848),
    [anon_sym_prop] = ACTIONS(1848),
    [anon_sym_id] = ACTIONS(1848),
    [anon_sym_event] = ACTIONS(1848),
    [anon_sym_fn] = ACTIONS(1848),
    [anon_sym_on] = ACTIONS(1848),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [947] = {
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(3294),
    [anon_sym_as] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3294),
    [anon_sym_RBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(3294),
    [anon_sym_BANG] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3294),
    [anon_sym_DOT] = ACTIONS(3294),
    [anon_sym_async] = ACTIONS(3294),
    [anon_sym_QMARK_DOT] = ACTIONS(3296),
    [anon_sym_new] = ACTIONS(3294),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3296),
    [anon_sym_GT_GT] = ACTIONS(3294),
    [anon_sym_GT_GT_GT] = ACTIONS(3296),
    [anon_sym_LT_LT] = ACTIONS(3296),
    [anon_sym_AMP] = ACTIONS(3294),
    [anon_sym_CARET] = ACTIONS(3296),
    [anon_sym_PIPE] = ACTIONS(3294),
    [anon_sym_PLUS] = ACTIONS(3294),
    [anon_sym_DASH] = ACTIONS(3294),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_STAR_STAR] = ACTIONS(3296),
    [anon_sym_LT_EQ] = ACTIONS(3296),
    [anon_sym_EQ_EQ] = ACTIONS(3294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3296),
    [anon_sym_BANG_EQ] = ACTIONS(3294),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3296),
    [anon_sym_GT_EQ] = ACTIONS(3296),
    [anon_sym_QMARK_QMARK] = ACTIONS(3296),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(3294),
    [anon_sym_PLUS_PLUS] = ACTIONS(3296),
    [anon_sym_DASH_DASH] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_SQUOTE] = ACTIONS(3296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3296),
    [sym_number] = ACTIONS(3296),
    [sym_this] = ACTIONS(3294),
    [sym_true] = ACTIONS(3294),
    [sym_false] = ACTIONS(3294),
    [sym_null] = ACTIONS(3294),
    [sym_undefined] = ACTIONS(3294),
    [anon_sym_static] = ACTIONS(3294),
    [anon_sym_readonly] = ACTIONS(3294),
    [anon_sym_get] = ACTIONS(3294),
    [anon_sym_set] = ACTIONS(3294),
    [anon_sym_QMARK] = ACTIONS(3294),
    [anon_sym_any] = ACTIONS(3294),
    [anon_sym_number] = ACTIONS(3294),
    [anon_sym_boolean] = ACTIONS(3294),
    [anon_sym_string] = ACTIONS(3294),
    [anon_sym_symbol] = ACTIONS(3294),
    [anon_sym_abstract] = ACTIONS(3294),
    [anon_sym_satisfies] = ACTIONS(3294),
    [anon_sym_extends] = ACTIONS(3294),
    [anon_sym_infer] = ACTIONS(3294),
    [anon_sym_keyof] = ACTIONS(3294),
    [anon_sym_unknown] = ACTIONS(3294),
    [anon_sym_never] = ACTIONS(3294),
    [anon_sym_object] = ACTIONS(3294),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3296),
    [anon_sym_constructor] = ACTIONS(3294),
    [anon_sym_prop] = ACTIONS(3294),
    [anon_sym_id] = ACTIONS(3294),
    [anon_sym_event] = ACTIONS(3294),
    [anon_sym_fn] = ACTIONS(3294),
    [anon_sym_on] = ACTIONS(3294),
    [sym__ternary_qmark] = ACTIONS(3296),
  },
  [948] = {
    [sym_identifier] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3090),
    [anon_sym_as] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3090),
    [anon_sym_RBRACE] = ACTIONS(3092),
    [anon_sym_typeof] = ACTIONS(3090),
    [anon_sym_BANG] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(3092),
    [anon_sym_in] = ACTIONS(3090),
    [anon_sym_SEMI] = ACTIONS(3092),
    [anon_sym_LBRACK] = ACTIONS(3092),
    [anon_sym_LT] = ACTIONS(3090),
    [anon_sym_GT] = ACTIONS(3090),
    [anon_sym_SLASH] = ACTIONS(3090),
    [anon_sym_DOT] = ACTIONS(3090),
    [anon_sym_async] = ACTIONS(3090),
    [anon_sym_QMARK_DOT] = ACTIONS(3092),
    [anon_sym_new] = ACTIONS(3090),
    [anon_sym_AMP_AMP] = ACTIONS(3092),
    [anon_sym_PIPE_PIPE] = ACTIONS(3092),
    [anon_sym_GT_GT] = ACTIONS(3090),
    [anon_sym_GT_GT_GT] = ACTIONS(3092),
    [anon_sym_LT_LT] = ACTIONS(3092),
    [anon_sym_AMP] = ACTIONS(3090),
    [anon_sym_CARET] = ACTIONS(3092),
    [anon_sym_PIPE] = ACTIONS(3090),
    [anon_sym_PLUS] = ACTIONS(3090),
    [anon_sym_DASH] = ACTIONS(3090),
    [anon_sym_PERCENT] = ACTIONS(3092),
    [anon_sym_STAR_STAR] = ACTIONS(3092),
    [anon_sym_LT_EQ] = ACTIONS(3092),
    [anon_sym_EQ_EQ] = ACTIONS(3090),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3092),
    [anon_sym_BANG_EQ] = ACTIONS(3090),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3092),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_QMARK_QMARK] = ACTIONS(3092),
    [anon_sym_instanceof] = ACTIONS(3090),
    [anon_sym_void] = ACTIONS(3090),
    [anon_sym_PLUS_PLUS] = ACTIONS(3092),
    [anon_sym_DASH_DASH] = ACTIONS(3092),
    [anon_sym_DQUOTE] = ACTIONS(3092),
    [anon_sym_SQUOTE] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3092),
    [sym_number] = ACTIONS(3092),
    [sym_this] = ACTIONS(3090),
    [sym_true] = ACTIONS(3090),
    [sym_false] = ACTIONS(3090),
    [sym_null] = ACTIONS(3090),
    [sym_undefined] = ACTIONS(3090),
    [anon_sym_static] = ACTIONS(3090),
    [anon_sym_readonly] = ACTIONS(3090),
    [anon_sym_get] = ACTIONS(3090),
    [anon_sym_set] = ACTIONS(3090),
    [anon_sym_QMARK] = ACTIONS(3090),
    [anon_sym_any] = ACTIONS(3090),
    [anon_sym_number] = ACTIONS(3090),
    [anon_sym_boolean] = ACTIONS(3090),
    [anon_sym_string] = ACTIONS(3090),
    [anon_sym_symbol] = ACTIONS(3090),
    [anon_sym_abstract] = ACTIONS(3090),
    [anon_sym_satisfies] = ACTIONS(3090),
    [anon_sym_extends] = ACTIONS(3090),
    [anon_sym_infer] = ACTIONS(3090),
    [anon_sym_keyof] = ACTIONS(3090),
    [anon_sym_unknown] = ACTIONS(3090),
    [anon_sym_never] = ACTIONS(3090),
    [anon_sym_object] = ACTIONS(3090),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3092),
    [anon_sym_constructor] = ACTIONS(3090),
    [anon_sym_prop] = ACTIONS(3090),
    [anon_sym_id] = ACTIONS(3090),
    [anon_sym_event] = ACTIONS(3090),
    [anon_sym_fn] = ACTIONS(3090),
    [anon_sym_on] = ACTIONS(3090),
    [sym__ternary_qmark] = ACTIONS(3092),
  },
  [949] = {
    [sym_identifier] = ACTIONS(3298),
    [anon_sym_STAR] = ACTIONS(3298),
    [anon_sym_as] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3298),
    [anon_sym_RBRACE] = ACTIONS(3300),
    [anon_sym_typeof] = ACTIONS(3298),
    [anon_sym_BANG] = ACTIONS(3298),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_in] = ACTIONS(3298),
    [anon_sym_SEMI] = ACTIONS(3300),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_LT] = ACTIONS(3298),
    [anon_sym_GT] = ACTIONS(3298),
    [anon_sym_SLASH] = ACTIONS(3298),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_async] = ACTIONS(3298),
    [anon_sym_QMARK_DOT] = ACTIONS(3300),
    [anon_sym_new] = ACTIONS(3298),
    [anon_sym_AMP_AMP] = ACTIONS(3300),
    [anon_sym_PIPE_PIPE] = ACTIONS(3300),
    [anon_sym_GT_GT] = ACTIONS(3298),
    [anon_sym_GT_GT_GT] = ACTIONS(3300),
    [anon_sym_LT_LT] = ACTIONS(3300),
    [anon_sym_AMP] = ACTIONS(3298),
    [anon_sym_CARET] = ACTIONS(3300),
    [anon_sym_PIPE] = ACTIONS(3298),
    [anon_sym_PLUS] = ACTIONS(3298),
    [anon_sym_DASH] = ACTIONS(3298),
    [anon_sym_PERCENT] = ACTIONS(3300),
    [anon_sym_STAR_STAR] = ACTIONS(3300),
    [anon_sym_LT_EQ] = ACTIONS(3300),
    [anon_sym_EQ_EQ] = ACTIONS(3298),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3300),
    [anon_sym_BANG_EQ] = ACTIONS(3298),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3300),
    [anon_sym_GT_EQ] = ACTIONS(3300),
    [anon_sym_QMARK_QMARK] = ACTIONS(3300),
    [anon_sym_instanceof] = ACTIONS(3298),
    [anon_sym_void] = ACTIONS(3298),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_SQUOTE] = ACTIONS(3300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3300),
    [sym_number] = ACTIONS(3300),
    [sym_this] = ACTIONS(3298),
    [sym_true] = ACTIONS(3298),
    [sym_false] = ACTIONS(3298),
    [sym_null] = ACTIONS(3298),
    [sym_undefined] = ACTIONS(3298),
    [anon_sym_static] = ACTIONS(3298),
    [anon_sym_readonly] = ACTIONS(3298),
    [anon_sym_get] = ACTIONS(3298),
    [anon_sym_set] = ACTIONS(3298),
    [anon_sym_QMARK] = ACTIONS(3298),
    [anon_sym_any] = ACTIONS(3298),
    [anon_sym_number] = ACTIONS(3298),
    [anon_sym_boolean] = ACTIONS(3298),
    [anon_sym_string] = ACTIONS(3298),
    [anon_sym_symbol] = ACTIONS(3298),
    [anon_sym_abstract] = ACTIONS(3298),
    [anon_sym_satisfies] = ACTIONS(3298),
    [anon_sym_extends] = ACTIONS(3298),
    [anon_sym_infer] = ACTIONS(3298),
    [anon_sym_keyof] = ACTIONS(3298),
    [anon_sym_unknown] = ACTIONS(3298),
    [anon_sym_never] = ACTIONS(3298),
    [anon_sym_object] = ACTIONS(3298),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3300),
    [anon_sym_constructor] = ACTIONS(3298),
    [anon_sym_prop] = ACTIONS(3298),
    [anon_sym_id] = ACTIONS(3298),
    [anon_sym_event] = ACTIONS(3298),
    [anon_sym_fn] = ACTIONS(3298),
    [anon_sym_on] = ACTIONS(3298),
    [sym__ternary_qmark] = ACTIONS(3300),
  },
  [950] = {
    [sym_arguments] = STATE(1066),
    [sym_identifier] = ACTIONS(3302),
    [anon_sym_STAR] = ACTIONS(3302),
    [anon_sym_as] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3302),
    [anon_sym_RBRACE] = ACTIONS(3304),
    [anon_sym_typeof] = ACTIONS(3302),
    [anon_sym_BANG] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3306),
    [anon_sym_in] = ACTIONS(3302),
    [anon_sym_SEMI] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3304),
    [anon_sym_LT] = ACTIONS(3302),
    [anon_sym_GT] = ACTIONS(3302),
    [anon_sym_SLASH] = ACTIONS(3302),
    [anon_sym_DOT] = ACTIONS(3302),
    [anon_sym_async] = ACTIONS(3302),
    [anon_sym_QMARK_DOT] = ACTIONS(3304),
    [anon_sym_new] = ACTIONS(3302),
    [anon_sym_AMP_AMP] = ACTIONS(3304),
    [anon_sym_PIPE_PIPE] = ACTIONS(3304),
    [anon_sym_GT_GT] = ACTIONS(3302),
    [anon_sym_GT_GT_GT] = ACTIONS(3304),
    [anon_sym_LT_LT] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3302),
    [anon_sym_CARET] = ACTIONS(3304),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_LT_EQ] = ACTIONS(3304),
    [anon_sym_EQ_EQ] = ACTIONS(3302),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3304),
    [anon_sym_BANG_EQ] = ACTIONS(3302),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3304),
    [anon_sym_GT_EQ] = ACTIONS(3304),
    [anon_sym_QMARK_QMARK] = ACTIONS(3304),
    [anon_sym_instanceof] = ACTIONS(3302),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3304),
    [anon_sym_DASH_DASH] = ACTIONS(3304),
    [anon_sym_DQUOTE] = ACTIONS(3304),
    [anon_sym_SQUOTE] = ACTIONS(3304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3304),
    [sym_number] = ACTIONS(3304),
    [sym_this] = ACTIONS(3302),
    [sym_true] = ACTIONS(3302),
    [sym_false] = ACTIONS(3302),
    [sym_null] = ACTIONS(3302),
    [sym_undefined] = ACTIONS(3302),
    [anon_sym_static] = ACTIONS(3302),
    [anon_sym_readonly] = ACTIONS(3302),
    [anon_sym_get] = ACTIONS(3302),
    [anon_sym_set] = ACTIONS(3302),
    [anon_sym_QMARK] = ACTIONS(3302),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_abstract] = ACTIONS(3302),
    [anon_sym_satisfies] = ACTIONS(3302),
    [anon_sym_infer] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(3302),
    [anon_sym_unknown] = ACTIONS(3302),
    [anon_sym_never] = ACTIONS(3302),
    [anon_sym_object] = ACTIONS(3302),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3304),
    [anon_sym_constructor] = ACTIONS(3302),
    [anon_sym_prop] = ACTIONS(3302),
    [anon_sym_id] = ACTIONS(3302),
    [anon_sym_event] = ACTIONS(3302),
    [anon_sym_fn] = ACTIONS(3302),
    [anon_sym_on] = ACTIONS(3302),
    [sym__ternary_qmark] = ACTIONS(3304),
  },
  [951] = {
    [sym_identifier] = ACTIONS(3309),
    [anon_sym_STAR] = ACTIONS(3309),
    [anon_sym_as] = ACTIONS(3309),
    [anon_sym_LBRACE] = ACTIONS(3309),
    [anon_sym_RBRACE] = ACTIONS(3311),
    [anon_sym_typeof] = ACTIONS(3309),
    [anon_sym_BANG] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(3311),
    [anon_sym_in] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(3311),
    [anon_sym_LT] = ACTIONS(3309),
    [anon_sym_GT] = ACTIONS(3309),
    [anon_sym_SLASH] = ACTIONS(3309),
    [anon_sym_DOT] = ACTIONS(3309),
    [anon_sym_async] = ACTIONS(3309),
    [anon_sym_QMARK_DOT] = ACTIONS(3311),
    [anon_sym_new] = ACTIONS(3309),
    [anon_sym_AMP_AMP] = ACTIONS(3311),
    [anon_sym_PIPE_PIPE] = ACTIONS(3311),
    [anon_sym_GT_GT] = ACTIONS(3309),
    [anon_sym_GT_GT_GT] = ACTIONS(3311),
    [anon_sym_LT_LT] = ACTIONS(3311),
    [anon_sym_AMP] = ACTIONS(3309),
    [anon_sym_CARET] = ACTIONS(3311),
    [anon_sym_PIPE] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3309),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_PERCENT] = ACTIONS(3311),
    [anon_sym_STAR_STAR] = ACTIONS(3311),
    [anon_sym_LT_EQ] = ACTIONS(3311),
    [anon_sym_EQ_EQ] = ACTIONS(3309),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3311),
    [anon_sym_BANG_EQ] = ACTIONS(3309),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3311),
    [anon_sym_GT_EQ] = ACTIONS(3311),
    [anon_sym_QMARK_QMARK] = ACTIONS(3311),
    [anon_sym_instanceof] = ACTIONS(3309),
    [anon_sym_void] = ACTIONS(3309),
    [anon_sym_PLUS_PLUS] = ACTIONS(3311),
    [anon_sym_DASH_DASH] = ACTIONS(3311),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3311),
    [sym_number] = ACTIONS(3311),
    [sym_this] = ACTIONS(3309),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [sym_null] = ACTIONS(3309),
    [sym_undefined] = ACTIONS(3309),
    [anon_sym_static] = ACTIONS(3309),
    [anon_sym_readonly] = ACTIONS(3309),
    [anon_sym_get] = ACTIONS(3309),
    [anon_sym_set] = ACTIONS(3309),
    [anon_sym_QMARK] = ACTIONS(3309),
    [anon_sym_any] = ACTIONS(3309),
    [anon_sym_number] = ACTIONS(3309),
    [anon_sym_boolean] = ACTIONS(3309),
    [anon_sym_string] = ACTIONS(3309),
    [anon_sym_symbol] = ACTIONS(3309),
    [anon_sym_abstract] = ACTIONS(3309),
    [anon_sym_satisfies] = ACTIONS(3309),
    [anon_sym_extends] = ACTIONS(3309),
    [anon_sym_infer] = ACTIONS(3309),
    [anon_sym_keyof] = ACTIONS(3309),
    [anon_sym_unknown] = ACTIONS(3309),
    [anon_sym_never] = ACTIONS(3309),
    [anon_sym_object] = ACTIONS(3309),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3311),
    [anon_sym_constructor] = ACTIONS(3309),
    [anon_sym_prop] = ACTIONS(3309),
    [anon_sym_id] = ACTIONS(3309),
    [anon_sym_event] = ACTIONS(3309),
    [anon_sym_fn] = ACTIONS(3309),
    [anon_sym_on] = ACTIONS(3309),
    [sym__ternary_qmark] = ACTIONS(3311),
  },
  [952] = {
    [sym_identifier] = ACTIONS(3313),
    [anon_sym_STAR] = ACTIONS(3313),
    [anon_sym_as] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3313),
    [anon_sym_RBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3313),
    [anon_sym_BANG] = ACTIONS(3313),
    [anon_sym_LPAREN] = ACTIONS(3315),
    [anon_sym_in] = ACTIONS(3313),
    [anon_sym_SEMI] = ACTIONS(3315),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LT] = ACTIONS(3313),
    [anon_sym_GT] = ACTIONS(3313),
    [anon_sym_SLASH] = ACTIONS(3313),
    [anon_sym_DOT] = ACTIONS(3313),
    [anon_sym_async] = ACTIONS(3313),
    [anon_sym_QMARK_DOT] = ACTIONS(3315),
    [anon_sym_new] = ACTIONS(3313),
    [anon_sym_AMP_AMP] = ACTIONS(3315),
    [anon_sym_PIPE_PIPE] = ACTIONS(3315),
    [anon_sym_GT_GT] = ACTIONS(3313),
    [anon_sym_GT_GT_GT] = ACTIONS(3315),
    [anon_sym_LT_LT] = ACTIONS(3315),
    [anon_sym_AMP] = ACTIONS(3313),
    [anon_sym_CARET] = ACTIONS(3315),
    [anon_sym_PIPE] = ACTIONS(3313),
    [anon_sym_PLUS] = ACTIONS(3313),
    [anon_sym_DASH] = ACTIONS(3313),
    [anon_sym_PERCENT] = ACTIONS(3315),
    [anon_sym_STAR_STAR] = ACTIONS(3315),
    [anon_sym_LT_EQ] = ACTIONS(3315),
    [anon_sym_EQ_EQ] = ACTIONS(3313),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3315),
    [anon_sym_BANG_EQ] = ACTIONS(3313),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3315),
    [anon_sym_GT_EQ] = ACTIONS(3315),
    [anon_sym_QMARK_QMARK] = ACTIONS(3315),
    [anon_sym_instanceof] = ACTIONS(3313),
    [anon_sym_void] = ACTIONS(3313),
    [anon_sym_PLUS_PLUS] = ACTIONS(3315),
    [anon_sym_DASH_DASH] = ACTIONS(3315),
    [anon_sym_DQUOTE] = ACTIONS(3315),
    [anon_sym_SQUOTE] = ACTIONS(3315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3315),
    [sym_number] = ACTIONS(3315),
    [sym_this] = ACTIONS(3313),
    [sym_true] = ACTIONS(3313),
    [sym_false] = ACTIONS(3313),
    [sym_null] = ACTIONS(3313),
    [sym_undefined] = ACTIONS(3313),
    [anon_sym_static] = ACTIONS(3313),
    [anon_sym_readonly] = ACTIONS(3313),
    [anon_sym_get] = ACTIONS(3313),
    [anon_sym_set] = ACTIONS(3313),
    [anon_sym_QMARK] = ACTIONS(3313),
    [anon_sym_any] = ACTIONS(3313),
    [anon_sym_number] = ACTIONS(3313),
    [anon_sym_boolean] = ACTIONS(3313),
    [anon_sym_string] = ACTIONS(3313),
    [anon_sym_symbol] = ACTIONS(3313),
    [anon_sym_abstract] = ACTIONS(3313),
    [anon_sym_satisfies] = ACTIONS(3313),
    [anon_sym_extends] = ACTIONS(3313),
    [anon_sym_infer] = ACTIONS(3313),
    [anon_sym_keyof] = ACTIONS(3313),
    [anon_sym_unknown] = ACTIONS(3313),
    [anon_sym_never] = ACTIONS(3313),
    [anon_sym_object] = ACTIONS(3313),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3315),
    [anon_sym_constructor] = ACTIONS(3313),
    [anon_sym_prop] = ACTIONS(3313),
    [anon_sym_id] = ACTIONS(3313),
    [anon_sym_event] = ACTIONS(3313),
    [anon_sym_fn] = ACTIONS(3313),
    [anon_sym_on] = ACTIONS(3313),
    [sym__ternary_qmark] = ACTIONS(3315),
  },
  [953] = {
    [sym_identifier] = ACTIONS(3094),
    [anon_sym_STAR] = ACTIONS(3094),
    [anon_sym_as] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3094),
    [anon_sym_RBRACE] = ACTIONS(3096),
    [anon_sym_typeof] = ACTIONS(3094),
    [anon_sym_BANG] = ACTIONS(3094),
    [anon_sym_LPAREN] = ACTIONS(3096),
    [anon_sym_in] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3096),
    [anon_sym_LBRACK] = ACTIONS(3096),
    [anon_sym_LT] = ACTIONS(3094),
    [anon_sym_GT] = ACTIONS(3094),
    [anon_sym_SLASH] = ACTIONS(3094),
    [anon_sym_DOT] = ACTIONS(3094),
    [anon_sym_async] = ACTIONS(3094),
    [anon_sym_QMARK_DOT] = ACTIONS(3096),
    [anon_sym_new] = ACTIONS(3094),
    [anon_sym_AMP_AMP] = ACTIONS(3096),
    [anon_sym_PIPE_PIPE] = ACTIONS(3096),
    [anon_sym_GT_GT] = ACTIONS(3094),
    [anon_sym_GT_GT_GT] = ACTIONS(3096),
    [anon_sym_LT_LT] = ACTIONS(3096),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_CARET] = ACTIONS(3096),
    [anon_sym_PIPE] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_DASH] = ACTIONS(3094),
    [anon_sym_PERCENT] = ACTIONS(3096),
    [anon_sym_STAR_STAR] = ACTIONS(3096),
    [anon_sym_LT_EQ] = ACTIONS(3096),
    [anon_sym_EQ_EQ] = ACTIONS(3094),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3096),
    [anon_sym_BANG_EQ] = ACTIONS(3094),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3096),
    [anon_sym_GT_EQ] = ACTIONS(3096),
    [anon_sym_QMARK_QMARK] = ACTIONS(3096),
    [anon_sym_instanceof] = ACTIONS(3094),
    [anon_sym_void] = ACTIONS(3094),
    [anon_sym_PLUS_PLUS] = ACTIONS(3096),
    [anon_sym_DASH_DASH] = ACTIONS(3096),
    [anon_sym_DQUOTE] = ACTIONS(3096),
    [anon_sym_SQUOTE] = ACTIONS(3096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3096),
    [sym_number] = ACTIONS(3096),
    [sym_this] = ACTIONS(3094),
    [sym_true] = ACTIONS(3094),
    [sym_false] = ACTIONS(3094),
    [sym_null] = ACTIONS(3094),
    [sym_undefined] = ACTIONS(3094),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_readonly] = ACTIONS(3094),
    [anon_sym_get] = ACTIONS(3094),
    [anon_sym_set] = ACTIONS(3094),
    [anon_sym_QMARK] = ACTIONS(3094),
    [anon_sym_any] = ACTIONS(3094),
    [anon_sym_number] = ACTIONS(3094),
    [anon_sym_boolean] = ACTIONS(3094),
    [anon_sym_string] = ACTIONS(3094),
    [anon_sym_symbol] = ACTIONS(3094),
    [anon_sym_abstract] = ACTIONS(3094),
    [anon_sym_satisfies] = ACTIONS(3094),
    [anon_sym_extends] = ACTIONS(3094),
    [anon_sym_infer] = ACTIONS(3094),
    [anon_sym_keyof] = ACTIONS(3094),
    [anon_sym_unknown] = ACTIONS(3094),
    [anon_sym_never] = ACTIONS(3094),
    [anon_sym_object] = ACTIONS(3094),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3096),
    [anon_sym_constructor] = ACTIONS(3094),
    [anon_sym_prop] = ACTIONS(3094),
    [anon_sym_id] = ACTIONS(3094),
    [anon_sym_event] = ACTIONS(3094),
    [anon_sym_fn] = ACTIONS(3094),
    [anon_sym_on] = ACTIONS(3094),
    [sym__ternary_qmark] = ACTIONS(3096),
  },
  [954] = {
    [sym_identifier] = ACTIONS(3317),
    [anon_sym_STAR] = ACTIONS(3317),
    [anon_sym_as] = ACTIONS(3317),
    [anon_sym_LBRACE] = ACTIONS(3317),
    [anon_sym_RBRACE] = ACTIONS(3319),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_BANG] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_in] = ACTIONS(3317),
    [anon_sym_SEMI] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_LT] = ACTIONS(3317),
    [anon_sym_GT] = ACTIONS(3317),
    [anon_sym_SLASH] = ACTIONS(3317),
    [anon_sym_DOT] = ACTIONS(3317),
    [anon_sym_async] = ACTIONS(3317),
    [anon_sym_QMARK_DOT] = ACTIONS(3319),
    [anon_sym_new] = ACTIONS(3317),
    [anon_sym_AMP_AMP] = ACTIONS(3319),
    [anon_sym_PIPE_PIPE] = ACTIONS(3319),
    [anon_sym_GT_GT] = ACTIONS(3317),
    [anon_sym_GT_GT_GT] = ACTIONS(3319),
    [anon_sym_LT_LT] = ACTIONS(3319),
    [anon_sym_AMP] = ACTIONS(3317),
    [anon_sym_CARET] = ACTIONS(3319),
    [anon_sym_PIPE] = ACTIONS(3317),
    [anon_sym_PLUS] = ACTIONS(3317),
    [anon_sym_DASH] = ACTIONS(3317),
    [anon_sym_PERCENT] = ACTIONS(3319),
    [anon_sym_STAR_STAR] = ACTIONS(3319),
    [anon_sym_LT_EQ] = ACTIONS(3319),
    [anon_sym_EQ_EQ] = ACTIONS(3317),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3319),
    [anon_sym_BANG_EQ] = ACTIONS(3317),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3319),
    [anon_sym_GT_EQ] = ACTIONS(3319),
    [anon_sym_QMARK_QMARK] = ACTIONS(3319),
    [anon_sym_instanceof] = ACTIONS(3317),
    [anon_sym_void] = ACTIONS(3317),
    [anon_sym_PLUS_PLUS] = ACTIONS(3319),
    [anon_sym_DASH_DASH] = ACTIONS(3319),
    [anon_sym_DQUOTE] = ACTIONS(3319),
    [anon_sym_SQUOTE] = ACTIONS(3319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3319),
    [sym_number] = ACTIONS(3319),
    [sym_this] = ACTIONS(3317),
    [sym_true] = ACTIONS(3317),
    [sym_false] = ACTIONS(3317),
    [sym_null] = ACTIONS(3317),
    [sym_undefined] = ACTIONS(3317),
    [anon_sym_static] = ACTIONS(3317),
    [anon_sym_readonly] = ACTIONS(3317),
    [anon_sym_get] = ACTIONS(3317),
    [anon_sym_set] = ACTIONS(3317),
    [anon_sym_QMARK] = ACTIONS(3317),
    [anon_sym_any] = ACTIONS(3317),
    [anon_sym_number] = ACTIONS(3317),
    [anon_sym_boolean] = ACTIONS(3317),
    [anon_sym_string] = ACTIONS(3317),
    [anon_sym_symbol] = ACTIONS(3317),
    [anon_sym_abstract] = ACTIONS(3317),
    [anon_sym_satisfies] = ACTIONS(3317),
    [anon_sym_extends] = ACTIONS(3317),
    [anon_sym_infer] = ACTIONS(3317),
    [anon_sym_keyof] = ACTIONS(3317),
    [anon_sym_unknown] = ACTIONS(3317),
    [anon_sym_never] = ACTIONS(3317),
    [anon_sym_object] = ACTIONS(3317),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3319),
    [anon_sym_constructor] = ACTIONS(3317),
    [anon_sym_prop] = ACTIONS(3317),
    [anon_sym_id] = ACTIONS(3317),
    [anon_sym_event] = ACTIONS(3317),
    [anon_sym_fn] = ACTIONS(3317),
    [anon_sym_on] = ACTIONS(3317),
    [sym__ternary_qmark] = ACTIONS(3319),
  },
  [955] = {
    [sym_identifier] = ACTIONS(3086),
    [anon_sym_STAR] = ACTIONS(3086),
    [anon_sym_as] = ACTIONS(3086),
    [anon_sym_LBRACE] = ACTIONS(3086),
    [anon_sym_RBRACE] = ACTIONS(3088),
    [anon_sym_typeof] = ACTIONS(3086),
    [anon_sym_BANG] = ACTIONS(3086),
    [anon_sym_LPAREN] = ACTIONS(3088),
    [anon_sym_in] = ACTIONS(3086),
    [anon_sym_SEMI] = ACTIONS(3088),
    [anon_sym_LBRACK] = ACTIONS(3088),
    [anon_sym_LT] = ACTIONS(3086),
    [anon_sym_GT] = ACTIONS(3086),
    [anon_sym_SLASH] = ACTIONS(3086),
    [anon_sym_DOT] = ACTIONS(3086),
    [anon_sym_async] = ACTIONS(3086),
    [anon_sym_QMARK_DOT] = ACTIONS(3088),
    [anon_sym_new] = ACTIONS(3086),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_PIPE_PIPE] = ACTIONS(3088),
    [anon_sym_GT_GT] = ACTIONS(3086),
    [anon_sym_GT_GT_GT] = ACTIONS(3088),
    [anon_sym_LT_LT] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym_CARET] = ACTIONS(3088),
    [anon_sym_PIPE] = ACTIONS(3086),
    [anon_sym_PLUS] = ACTIONS(3086),
    [anon_sym_DASH] = ACTIONS(3086),
    [anon_sym_PERCENT] = ACTIONS(3088),
    [anon_sym_STAR_STAR] = ACTIONS(3088),
    [anon_sym_LT_EQ] = ACTIONS(3088),
    [anon_sym_EQ_EQ] = ACTIONS(3086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3088),
    [anon_sym_BANG_EQ] = ACTIONS(3086),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3088),
    [anon_sym_GT_EQ] = ACTIONS(3088),
    [anon_sym_QMARK_QMARK] = ACTIONS(3088),
    [anon_sym_instanceof] = ACTIONS(3086),
    [anon_sym_void] = ACTIONS(3086),
    [anon_sym_PLUS_PLUS] = ACTIONS(3088),
    [anon_sym_DASH_DASH] = ACTIONS(3088),
    [anon_sym_DQUOTE] = ACTIONS(3088),
    [anon_sym_SQUOTE] = ACTIONS(3088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3088),
    [sym_number] = ACTIONS(3088),
    [sym_this] = ACTIONS(3086),
    [sym_true] = ACTIONS(3086),
    [sym_false] = ACTIONS(3086),
    [sym_null] = ACTIONS(3086),
    [sym_undefined] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_readonly] = ACTIONS(3086),
    [anon_sym_get] = ACTIONS(3086),
    [anon_sym_set] = ACTIONS(3086),
    [anon_sym_QMARK] = ACTIONS(3086),
    [anon_sym_any] = ACTIONS(3086),
    [anon_sym_number] = ACTIONS(3086),
    [anon_sym_boolean] = ACTIONS(3086),
    [anon_sym_string] = ACTIONS(3086),
    [anon_sym_symbol] = ACTIONS(3086),
    [anon_sym_abstract] = ACTIONS(3086),
    [anon_sym_satisfies] = ACTIONS(3086),
    [anon_sym_extends] = ACTIONS(3086),
    [anon_sym_infer] = ACTIONS(3086),
    [anon_sym_keyof] = ACTIONS(3086),
    [anon_sym_unknown] = ACTIONS(3086),
    [anon_sym_never] = ACTIONS(3086),
    [anon_sym_object] = ACTIONS(3086),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3088),
    [anon_sym_constructor] = ACTIONS(3086),
    [anon_sym_prop] = ACTIONS(3086),
    [anon_sym_id] = ACTIONS(3086),
    [anon_sym_event] = ACTIONS(3086),
    [anon_sym_fn] = ACTIONS(3086),
    [anon_sym_on] = ACTIONS(3086),
    [sym__ternary_qmark] = ACTIONS(3088),
  },
  [956] = {
    [sym_identifier] = ACTIONS(3321),
    [anon_sym_STAR] = ACTIONS(3321),
    [anon_sym_as] = ACTIONS(3321),
    [anon_sym_LBRACE] = ACTIONS(3321),
    [anon_sym_RBRACE] = ACTIONS(3323),
    [anon_sym_typeof] = ACTIONS(3321),
    [anon_sym_BANG] = ACTIONS(3321),
    [anon_sym_LPAREN] = ACTIONS(3323),
    [anon_sym_in] = ACTIONS(3321),
    [anon_sym_SEMI] = ACTIONS(3323),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_LT] = ACTIONS(3321),
    [anon_sym_GT] = ACTIONS(3321),
    [anon_sym_SLASH] = ACTIONS(3321),
    [anon_sym_DOT] = ACTIONS(3321),
    [anon_sym_async] = ACTIONS(3321),
    [anon_sym_QMARK_DOT] = ACTIONS(3323),
    [anon_sym_new] = ACTIONS(3321),
    [anon_sym_AMP_AMP] = ACTIONS(3323),
    [anon_sym_PIPE_PIPE] = ACTIONS(3323),
    [anon_sym_GT_GT] = ACTIONS(3321),
    [anon_sym_GT_GT_GT] = ACTIONS(3323),
    [anon_sym_LT_LT] = ACTIONS(3323),
    [anon_sym_AMP] = ACTIONS(3321),
    [anon_sym_CARET] = ACTIONS(3323),
    [anon_sym_PIPE] = ACTIONS(3321),
    [anon_sym_PLUS] = ACTIONS(3321),
    [anon_sym_DASH] = ACTIONS(3321),
    [anon_sym_PERCENT] = ACTIONS(3323),
    [anon_sym_STAR_STAR] = ACTIONS(3323),
    [anon_sym_LT_EQ] = ACTIONS(3323),
    [anon_sym_EQ_EQ] = ACTIONS(3321),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3323),
    [anon_sym_BANG_EQ] = ACTIONS(3321),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3323),
    [anon_sym_GT_EQ] = ACTIONS(3323),
    [anon_sym_QMARK_QMARK] = ACTIONS(3323),
    [anon_sym_instanceof] = ACTIONS(3321),
    [anon_sym_void] = ACTIONS(3321),
    [anon_sym_PLUS_PLUS] = ACTIONS(3323),
    [anon_sym_DASH_DASH] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3323),
    [anon_sym_SQUOTE] = ACTIONS(3323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3323),
    [sym_number] = ACTIONS(3323),
    [sym_this] = ACTIONS(3321),
    [sym_true] = ACTIONS(3321),
    [sym_false] = ACTIONS(3321),
    [sym_null] = ACTIONS(3321),
    [sym_undefined] = ACTIONS(3321),
    [anon_sym_static] = ACTIONS(3321),
    [anon_sym_readonly] = ACTIONS(3321),
    [anon_sym_get] = ACTIONS(3321),
    [anon_sym_set] = ACTIONS(3321),
    [anon_sym_QMARK] = ACTIONS(3321),
    [anon_sym_any] = ACTIONS(3321),
    [anon_sym_number] = ACTIONS(3321),
    [anon_sym_boolean] = ACTIONS(3321),
    [anon_sym_string] = ACTIONS(3321),
    [anon_sym_symbol] = ACTIONS(3321),
    [anon_sym_abstract] = ACTIONS(3321),
    [anon_sym_satisfies] = ACTIONS(3321),
    [anon_sym_extends] = ACTIONS(3321),
    [anon_sym_infer] = ACTIONS(3321),
    [anon_sym_keyof] = ACTIONS(3321),
    [anon_sym_unknown] = ACTIONS(3321),
    [anon_sym_never] = ACTIONS(3321),
    [anon_sym_object] = ACTIONS(3321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3323),
    [anon_sym_constructor] = ACTIONS(3321),
    [anon_sym_prop] = ACTIONS(3321),
    [anon_sym_id] = ACTIONS(3321),
    [anon_sym_event] = ACTIONS(3321),
    [anon_sym_fn] = ACTIONS(3321),
    [anon_sym_on] = ACTIONS(3321),
    [sym__ternary_qmark] = ACTIONS(3323),
  },
  [957] = {
    [sym_identifier] = ACTIONS(3325),
    [anon_sym_STAR] = ACTIONS(3325),
    [anon_sym_as] = ACTIONS(3325),
    [anon_sym_LBRACE] = ACTIONS(3325),
    [anon_sym_RBRACE] = ACTIONS(3327),
    [anon_sym_typeof] = ACTIONS(3325),
    [anon_sym_BANG] = ACTIONS(3325),
    [anon_sym_LPAREN] = ACTIONS(3327),
    [anon_sym_in] = ACTIONS(3325),
    [anon_sym_SEMI] = ACTIONS(3327),
    [anon_sym_LBRACK] = ACTIONS(3327),
    [anon_sym_LT] = ACTIONS(3325),
    [anon_sym_GT] = ACTIONS(3325),
    [anon_sym_SLASH] = ACTIONS(3325),
    [anon_sym_DOT] = ACTIONS(3329),
    [anon_sym_async] = ACTIONS(3325),
    [anon_sym_QMARK_DOT] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3325),
    [anon_sym_AMP_AMP] = ACTIONS(3327),
    [anon_sym_PIPE_PIPE] = ACTIONS(3327),
    [anon_sym_GT_GT] = ACTIONS(3325),
    [anon_sym_GT_GT_GT] = ACTIONS(3327),
    [anon_sym_LT_LT] = ACTIONS(3327),
    [anon_sym_AMP] = ACTIONS(3325),
    [anon_sym_CARET] = ACTIONS(3327),
    [anon_sym_PIPE] = ACTIONS(3325),
    [anon_sym_PLUS] = ACTIONS(3325),
    [anon_sym_DASH] = ACTIONS(3325),
    [anon_sym_PERCENT] = ACTIONS(3327),
    [anon_sym_STAR_STAR] = ACTIONS(3327),
    [anon_sym_LT_EQ] = ACTIONS(3327),
    [anon_sym_EQ_EQ] = ACTIONS(3325),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3327),
    [anon_sym_BANG_EQ] = ACTIONS(3325),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3327),
    [anon_sym_GT_EQ] = ACTIONS(3327),
    [anon_sym_QMARK_QMARK] = ACTIONS(3327),
    [anon_sym_instanceof] = ACTIONS(3325),
    [anon_sym_void] = ACTIONS(3325),
    [anon_sym_PLUS_PLUS] = ACTIONS(3327),
    [anon_sym_DASH_DASH] = ACTIONS(3327),
    [anon_sym_DQUOTE] = ACTIONS(3327),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3327),
    [sym_number] = ACTIONS(3327),
    [sym_this] = ACTIONS(3325),
    [sym_true] = ACTIONS(3325),
    [sym_false] = ACTIONS(3325),
    [sym_null] = ACTIONS(3325),
    [sym_undefined] = ACTIONS(3325),
    [anon_sym_static] = ACTIONS(3325),
    [anon_sym_readonly] = ACTIONS(3325),
    [anon_sym_get] = ACTIONS(3325),
    [anon_sym_set] = ACTIONS(3325),
    [anon_sym_QMARK] = ACTIONS(3325),
    [anon_sym_any] = ACTIONS(3325),
    [anon_sym_number] = ACTIONS(3325),
    [anon_sym_boolean] = ACTIONS(3325),
    [anon_sym_string] = ACTIONS(3325),
    [anon_sym_symbol] = ACTIONS(3325),
    [anon_sym_abstract] = ACTIONS(3325),
    [anon_sym_satisfies] = ACTIONS(3325),
    [anon_sym_extends] = ACTIONS(3325),
    [anon_sym_infer] = ACTIONS(3325),
    [anon_sym_keyof] = ACTIONS(3325),
    [anon_sym_unknown] = ACTIONS(3325),
    [anon_sym_never] = ACTIONS(3325),
    [anon_sym_object] = ACTIONS(3325),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3327),
    [anon_sym_constructor] = ACTIONS(3325),
    [anon_sym_prop] = ACTIONS(3325),
    [anon_sym_id] = ACTIONS(3325),
    [anon_sym_event] = ACTIONS(3325),
    [anon_sym_fn] = ACTIONS(3325),
    [anon_sym_on] = ACTIONS(3325),
    [sym__ternary_qmark] = ACTIONS(3327),
  },
  [958] = {
    [sym_identifier] = ACTIONS(3290),
    [anon_sym_STAR] = ACTIONS(3290),
    [anon_sym_as] = ACTIONS(3290),
    [anon_sym_LBRACE] = ACTIONS(3290),
    [anon_sym_RBRACE] = ACTIONS(3292),
    [anon_sym_typeof] = ACTIONS(3290),
    [anon_sym_BANG] = ACTIONS(3290),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_in] = ACTIONS(3290),
    [anon_sym_SEMI] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_LT] = ACTIONS(3290),
    [anon_sym_GT] = ACTIONS(3290),
    [anon_sym_SLASH] = ACTIONS(3290),
    [anon_sym_DOT] = ACTIONS(3290),
    [anon_sym_async] = ACTIONS(3290),
    [anon_sym_QMARK_DOT] = ACTIONS(3292),
    [anon_sym_new] = ACTIONS(3290),
    [anon_sym_AMP_AMP] = ACTIONS(3292),
    [anon_sym_PIPE_PIPE] = ACTIONS(3292),
    [anon_sym_GT_GT] = ACTIONS(3290),
    [anon_sym_GT_GT_GT] = ACTIONS(3292),
    [anon_sym_LT_LT] = ACTIONS(3292),
    [anon_sym_AMP] = ACTIONS(3290),
    [anon_sym_CARET] = ACTIONS(3292),
    [anon_sym_PIPE] = ACTIONS(3290),
    [anon_sym_PLUS] = ACTIONS(3290),
    [anon_sym_DASH] = ACTIONS(3290),
    [anon_sym_PERCENT] = ACTIONS(3292),
    [anon_sym_STAR_STAR] = ACTIONS(3292),
    [anon_sym_LT_EQ] = ACTIONS(3292),
    [anon_sym_EQ_EQ] = ACTIONS(3290),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3292),
    [anon_sym_BANG_EQ] = ACTIONS(3290),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3292),
    [anon_sym_GT_EQ] = ACTIONS(3292),
    [anon_sym_QMARK_QMARK] = ACTIONS(3292),
    [anon_sym_instanceof] = ACTIONS(3290),
    [anon_sym_void] = ACTIONS(3290),
    [anon_sym_PLUS_PLUS] = ACTIONS(3292),
    [anon_sym_DASH_DASH] = ACTIONS(3292),
    [anon_sym_DQUOTE] = ACTIONS(3292),
    [anon_sym_SQUOTE] = ACTIONS(3292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3292),
    [sym_number] = ACTIONS(3292),
    [sym_this] = ACTIONS(3290),
    [sym_true] = ACTIONS(3290),
    [sym_false] = ACTIONS(3290),
    [sym_null] = ACTIONS(3290),
    [sym_undefined] = ACTIONS(3290),
    [anon_sym_static] = ACTIONS(3290),
    [anon_sym_readonly] = ACTIONS(3290),
    [anon_sym_get] = ACTIONS(3290),
    [anon_sym_set] = ACTIONS(3290),
    [anon_sym_QMARK] = ACTIONS(3290),
    [anon_sym_any] = ACTIONS(3290),
    [anon_sym_number] = ACTIONS(3290),
    [anon_sym_boolean] = ACTIONS(3290),
    [anon_sym_string] = ACTIONS(3290),
    [anon_sym_symbol] = ACTIONS(3290),
    [anon_sym_abstract] = ACTIONS(3290),
    [anon_sym_satisfies] = ACTIONS(3290),
    [anon_sym_extends] = ACTIONS(3290),
    [anon_sym_infer] = ACTIONS(3290),
    [anon_sym_keyof] = ACTIONS(3290),
    [anon_sym_unknown] = ACTIONS(3290),
    [anon_sym_never] = ACTIONS(3290),
    [anon_sym_object] = ACTIONS(3290),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3292),
    [anon_sym_constructor] = ACTIONS(3290),
    [anon_sym_prop] = ACTIONS(3290),
    [anon_sym_id] = ACTIONS(3290),
    [anon_sym_event] = ACTIONS(3290),
    [anon_sym_fn] = ACTIONS(3290),
    [anon_sym_on] = ACTIONS(3290),
    [sym__ternary_qmark] = ACTIONS(3292),
  },
  [959] = {
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(3294),
    [anon_sym_as] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3294),
    [anon_sym_RBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(3294),
    [anon_sym_BANG] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(3296),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(3296),
    [anon_sym_LBRACK] = ACTIONS(3296),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3294),
    [anon_sym_DOT] = ACTIONS(3294),
    [anon_sym_async] = ACTIONS(3294),
    [anon_sym_QMARK_DOT] = ACTIONS(3296),
    [anon_sym_new] = ACTIONS(3294),
    [anon_sym_AMP_AMP] = ACTIONS(3296),
    [anon_sym_PIPE_PIPE] = ACTIONS(3296),
    [anon_sym_GT_GT] = ACTIONS(3294),
    [anon_sym_GT_GT_GT] = ACTIONS(3296),
    [anon_sym_LT_LT] = ACTIONS(3296),
    [anon_sym_AMP] = ACTIONS(3294),
    [anon_sym_CARET] = ACTIONS(3296),
    [anon_sym_PIPE] = ACTIONS(3294),
    [anon_sym_PLUS] = ACTIONS(3294),
    [anon_sym_DASH] = ACTIONS(3294),
    [anon_sym_PERCENT] = ACTIONS(3296),
    [anon_sym_STAR_STAR] = ACTIONS(3296),
    [anon_sym_LT_EQ] = ACTIONS(3296),
    [anon_sym_EQ_EQ] = ACTIONS(3294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3296),
    [anon_sym_BANG_EQ] = ACTIONS(3294),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3296),
    [anon_sym_GT_EQ] = ACTIONS(3296),
    [anon_sym_QMARK_QMARK] = ACTIONS(3296),
    [anon_sym_instanceof] = ACTIONS(3294),
    [anon_sym_void] = ACTIONS(3294),
    [anon_sym_PLUS_PLUS] = ACTIONS(3296),
    [anon_sym_DASH_DASH] = ACTIONS(3296),
    [anon_sym_DQUOTE] = ACTIONS(3296),
    [anon_sym_SQUOTE] = ACTIONS(3296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3296),
    [sym_number] = ACTIONS(3296),
    [sym_this] = ACTIONS(3294),
    [sym_true] = ACTIONS(3294),
    [sym_false] = ACTIONS(3294),
    [sym_null] = ACTIONS(3294),
    [sym_undefined] = ACTIONS(3294),
    [anon_sym_static] = ACTIONS(3294),
    [anon_sym_readonly] = ACTIONS(3294),
    [anon_sym_get] = ACTIONS(3294),
    [anon_sym_set] = ACTIONS(3294),
    [anon_sym_QMARK] = ACTIONS(3294),
    [anon_sym_any] = ACTIONS(3294),
    [anon_sym_number] = ACTIONS(3294),
    [anon_sym_boolean] = ACTIONS(3294),
    [anon_sym_string] = ACTIONS(3294),
    [anon_sym_symbol] = ACTIONS(3294),
    [anon_sym_abstract] = ACTIONS(3294),
    [anon_sym_satisfies] = ACTIONS(3294),
    [anon_sym_extends] = ACTIONS(3294),
    [anon_sym_infer] = ACTIONS(3294),
    [anon_sym_keyof] = ACTIONS(3294),
    [anon_sym_unknown] = ACTIONS(3294),
    [anon_sym_never] = ACTIONS(3294),
    [anon_sym_object] = ACTIONS(3294),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3296),
    [anon_sym_constructor] = ACTIONS(3294),
    [anon_sym_prop] = ACTIONS(3294),
    [anon_sym_id] = ACTIONS(3294),
    [anon_sym_event] = ACTIONS(3294),
    [anon_sym_fn] = ACTIONS(3294),
    [anon_sym_on] = ACTIONS(3294),
    [sym__ternary_qmark] = ACTIONS(3296),
  },
  [960] = {
    [sym_identifier] = ACTIONS(3331),
    [anon_sym_STAR] = ACTIONS(3331),
    [anon_sym_as] = ACTIONS(3331),
    [anon_sym_LBRACE] = ACTIONS(3331),
    [anon_sym_RBRACE] = ACTIONS(3333),
    [anon_sym_typeof] = ACTIONS(3331),
    [anon_sym_BANG] = ACTIONS(3331),
    [anon_sym_LPAREN] = ACTIONS(3333),
    [anon_sym_in] = ACTIONS(3331),
    [anon_sym_SEMI] = ACTIONS(3333),
    [anon_sym_LBRACK] = ACTIONS(3333),
    [anon_sym_LT] = ACTIONS(3331),
    [anon_sym_GT] = ACTIONS(3331),
    [anon_sym_SLASH] = ACTIONS(3331),
    [anon_sym_DOT] = ACTIONS(3331),
    [anon_sym_async] = ACTIONS(3331),
    [anon_sym_QMARK_DOT] = ACTIONS(3333),
    [anon_sym_new] = ACTIONS(3331),
    [anon_sym_AMP_AMP] = ACTIONS(3333),
    [anon_sym_PIPE_PIPE] = ACTIONS(3333),
    [anon_sym_GT_GT] = ACTIONS(3331),
    [anon_sym_GT_GT_GT] = ACTIONS(3333),
    [anon_sym_LT_LT] = ACTIONS(3333),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_CARET] = ACTIONS(3333),
    [anon_sym_PIPE] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_PERCENT] = ACTIONS(3333),
    [anon_sym_STAR_STAR] = ACTIONS(3333),
    [anon_sym_LT_EQ] = ACTIONS(3333),
    [anon_sym_EQ_EQ] = ACTIONS(3331),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3333),
    [anon_sym_BANG_EQ] = ACTIONS(3331),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3333),
    [anon_sym_GT_EQ] = ACTIONS(3333),
    [anon_sym_QMARK_QMARK] = ACTIONS(3333),
    [anon_sym_instanceof] = ACTIONS(3331),
    [anon_sym_void] = ACTIONS(3331),
    [anon_sym_PLUS_PLUS] = ACTIONS(3333),
    [anon_sym_DASH_DASH] = ACTIONS(3333),
    [anon_sym_DQUOTE] = ACTIONS(3333),
    [anon_sym_SQUOTE] = ACTIONS(3333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3333),
    [sym_number] = ACTIONS(3333),
    [sym_this] = ACTIONS(3331),
    [sym_true] = ACTIONS(3331),
    [sym_false] = ACTIONS(3331),
    [sym_null] = ACTIONS(3331),
    [sym_undefined] = ACTIONS(3331),
    [anon_sym_static] = ACTIONS(3331),
    [anon_sym_readonly] = ACTIONS(3331),
    [anon_sym_get] = ACTIONS(3331),
    [anon_sym_set] = ACTIONS(3331),
    [anon_sym_QMARK] = ACTIONS(3331),
    [anon_sym_any] = ACTIONS(3331),
    [anon_sym_number] = ACTIONS(3331),
    [anon_sym_boolean] = ACTIONS(3331),
    [anon_sym_string] = ACTIONS(3331),
    [anon_sym_symbol] = ACTIONS(3331),
    [anon_sym_abstract] = ACTIONS(3331),
    [anon_sym_satisfies] = ACTIONS(3331),
    [anon_sym_extends] = ACTIONS(3331),
    [anon_sym_infer] = ACTIONS(3331),
    [anon_sym_keyof] = ACTIONS(3331),
    [anon_sym_unknown] = ACTIONS(3331),
    [anon_sym_never] = ACTIONS(3331),
    [anon_sym_object] = ACTIONS(3331),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3333),
    [anon_sym_constructor] = ACTIONS(3331),
    [anon_sym_prop] = ACTIONS(3331),
    [anon_sym_id] = ACTIONS(3331),
    [anon_sym_event] = ACTIONS(3331),
    [anon_sym_fn] = ACTIONS(3331),
    [anon_sym_on] = ACTIONS(3331),
    [sym__ternary_qmark] = ACTIONS(3333),
  },
  [961] = {
    [sym_identifier] = ACTIONS(3335),
    [anon_sym_STAR] = ACTIONS(3335),
    [anon_sym_as] = ACTIONS(3335),
    [anon_sym_LBRACE] = ACTIONS(3335),
    [anon_sym_RBRACE] = ACTIONS(3337),
    [anon_sym_typeof] = ACTIONS(3335),
    [anon_sym_BANG] = ACTIONS(3335),
    [anon_sym_LPAREN] = ACTIONS(3337),
    [anon_sym_in] = ACTIONS(3335),
    [anon_sym_SEMI] = ACTIONS(3337),
    [anon_sym_LBRACK] = ACTIONS(3337),
    [anon_sym_LT] = ACTIONS(3335),
    [anon_sym_GT] = ACTIONS(3335),
    [anon_sym_SLASH] = ACTIONS(3335),
    [anon_sym_DOT] = ACTIONS(3335),
    [anon_sym_async] = ACTIONS(3335),
    [anon_sym_QMARK_DOT] = ACTIONS(3337),
    [anon_sym_new] = ACTIONS(3335),
    [anon_sym_AMP_AMP] = ACTIONS(3337),
    [anon_sym_PIPE_PIPE] = ACTIONS(3337),
    [anon_sym_GT_GT] = ACTIONS(3335),
    [anon_sym_GT_GT_GT] = ACTIONS(3337),
    [anon_sym_LT_LT] = ACTIONS(3337),
    [anon_sym_AMP] = ACTIONS(3335),
    [anon_sym_CARET] = ACTIONS(3337),
    [anon_sym_PIPE] = ACTIONS(3335),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_PERCENT] = ACTIONS(3337),
    [anon_sym_STAR_STAR] = ACTIONS(3337),
    [anon_sym_LT_EQ] = ACTIONS(3337),
    [anon_sym_EQ_EQ] = ACTIONS(3335),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3337),
    [anon_sym_BANG_EQ] = ACTIONS(3335),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3337),
    [anon_sym_GT_EQ] = ACTIONS(3337),
    [anon_sym_QMARK_QMARK] = ACTIONS(3337),
    [anon_sym_instanceof] = ACTIONS(3335),
    [anon_sym_void] = ACTIONS(3335),
    [anon_sym_PLUS_PLUS] = ACTIONS(3337),
    [anon_sym_DASH_DASH] = ACTIONS(3337),
    [anon_sym_DQUOTE] = ACTIONS(3337),
    [anon_sym_SQUOTE] = ACTIONS(3337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3337),
    [sym_number] = ACTIONS(3337),
    [sym_this] = ACTIONS(3335),
    [sym_true] = ACTIONS(3335),
    [sym_false] = ACTIONS(3335),
    [sym_null] = ACTIONS(3335),
    [sym_undefined] = ACTIONS(3335),
    [anon_sym_static] = ACTIONS(3335),
    [anon_sym_readonly] = ACTIONS(3335),
    [anon_sym_get] = ACTIONS(3335),
    [anon_sym_set] = ACTIONS(3335),
    [anon_sym_QMARK] = ACTIONS(3335),
    [anon_sym_any] = ACTIONS(3335),
    [anon_sym_number] = ACTIONS(3335),
    [anon_sym_boolean] = ACTIONS(3335),
    [anon_sym_string] = ACTIONS(3335),
    [anon_sym_symbol] = ACTIONS(3335),
    [anon_sym_abstract] = ACTIONS(3335),
    [anon_sym_satisfies] = ACTIONS(3335),
    [anon_sym_extends] = ACTIONS(3335),
    [anon_sym_infer] = ACTIONS(3335),
    [anon_sym_keyof] = ACTIONS(3335),
    [anon_sym_unknown] = ACTIONS(3335),
    [anon_sym_never] = ACTIONS(3335),
    [anon_sym_object] = ACTIONS(3335),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3337),
    [anon_sym_constructor] = ACTIONS(3335),
    [anon_sym_prop] = ACTIONS(3335),
    [anon_sym_id] = ACTIONS(3335),
    [anon_sym_event] = ACTIONS(3335),
    [anon_sym_fn] = ACTIONS(3335),
    [anon_sym_on] = ACTIONS(3335),
    [sym__ternary_qmark] = ACTIONS(3337),
  },
  [962] = {
    [sym_identifier] = ACTIONS(3339),
    [anon_sym_STAR] = ACTIONS(3339),
    [anon_sym_as] = ACTIONS(3339),
    [anon_sym_LBRACE] = ACTIONS(3339),
    [anon_sym_RBRACE] = ACTIONS(3341),
    [anon_sym_typeof] = ACTIONS(3339),
    [anon_sym_BANG] = ACTIONS(3339),
    [anon_sym_LPAREN] = ACTIONS(3341),
    [anon_sym_in] = ACTIONS(3339),
    [anon_sym_SEMI] = ACTIONS(3341),
    [anon_sym_LBRACK] = ACTIONS(3341),
    [anon_sym_LT] = ACTIONS(3339),
    [anon_sym_GT] = ACTIONS(3339),
    [anon_sym_SLASH] = ACTIONS(3339),
    [anon_sym_DOT] = ACTIONS(3339),
    [anon_sym_async] = ACTIONS(3339),
    [anon_sym_QMARK_DOT] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(3339),
    [anon_sym_AMP_AMP] = ACTIONS(3341),
    [anon_sym_PIPE_PIPE] = ACTIONS(3341),
    [anon_sym_GT_GT] = ACTIONS(3339),
    [anon_sym_GT_GT_GT] = ACTIONS(3341),
    [anon_sym_LT_LT] = ACTIONS(3341),
    [anon_sym_AMP] = ACTIONS(3339),
    [anon_sym_CARET] = ACTIONS(3341),
    [anon_sym_PIPE] = ACTIONS(3339),
    [anon_sym_PLUS] = ACTIONS(3339),
    [anon_sym_DASH] = ACTIONS(3339),
    [anon_sym_PERCENT] = ACTIONS(3341),
    [anon_sym_STAR_STAR] = ACTIONS(3341),
    [anon_sym_LT_EQ] = ACTIONS(3341),
    [anon_sym_EQ_EQ] = ACTIONS(3339),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3341),
    [anon_sym_BANG_EQ] = ACTIONS(3339),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3341),
    [anon_sym_GT_EQ] = ACTIONS(3341),
    [anon_sym_QMARK_QMARK] = ACTIONS(3341),
    [anon_sym_instanceof] = ACTIONS(3339),
    [anon_sym_void] = ACTIONS(3339),
    [anon_sym_PLUS_PLUS] = ACTIONS(3341),
    [anon_sym_DASH_DASH] = ACTIONS(3341),
    [anon_sym_DQUOTE] = ACTIONS(3341),
    [anon_sym_SQUOTE] = ACTIONS(3341),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3341),
    [sym_number] = ACTIONS(3341),
    [sym_this] = ACTIONS(3339),
    [sym_true] = ACTIONS(3339),
    [sym_false] = ACTIONS(3339),
    [sym_null] = ACTIONS(3339),
    [sym_undefined] = ACTIONS(3339),
    [anon_sym_static] = ACTIONS(3339),
    [anon_sym_readonly] = ACTIONS(3339),
    [anon_sym_get] = ACTIONS(3339),
    [anon_sym_set] = ACTIONS(3339),
    [anon_sym_QMARK] = ACTIONS(3339),
    [anon_sym_any] = ACTIONS(3339),
    [anon_sym_number] = ACTIONS(3339),
    [anon_sym_boolean] = ACTIONS(3339),
    [anon_sym_string] = ACTIONS(3339),
    [anon_sym_symbol] = ACTIONS(3339),
    [anon_sym_abstract] = ACTIONS(3339),
    [anon_sym_satisfies] = ACTIONS(3339),
    [anon_sym_extends] = ACTIONS(3339),
    [anon_sym_infer] = ACTIONS(3339),
    [anon_sym_keyof] = ACTIONS(3339),
    [anon_sym_unknown] = ACTIONS(3339),
    [anon_sym_never] = ACTIONS(3339),
    [anon_sym_object] = ACTIONS(3339),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3341),
    [anon_sym_constructor] = ACTIONS(3339),
    [anon_sym_prop] = ACTIONS(3339),
    [anon_sym_id] = ACTIONS(3339),
    [anon_sym_event] = ACTIONS(3339),
    [anon_sym_fn] = ACTIONS(3339),
    [anon_sym_on] = ACTIONS(3339),
    [sym__ternary_qmark] = ACTIONS(3341),
  },
  [963] = {
    [sym_identifier] = ACTIONS(3343),
    [anon_sym_STAR] = ACTIONS(3343),
    [anon_sym_as] = ACTIONS(3343),
    [anon_sym_LBRACE] = ACTIONS(3343),
    [anon_sym_RBRACE] = ACTIONS(3345),
    [anon_sym_typeof] = ACTIONS(3343),
    [anon_sym_BANG] = ACTIONS(3343),
    [anon_sym_LPAREN] = ACTIONS(3345),
    [anon_sym_in] = ACTIONS(3343),
    [anon_sym_SEMI] = ACTIONS(3345),
    [anon_sym_LBRACK] = ACTIONS(3345),
    [anon_sym_LT] = ACTIONS(3343),
    [anon_sym_GT] = ACTIONS(3343),
    [anon_sym_SLASH] = ACTIONS(3343),
    [anon_sym_DOT] = ACTIONS(3343),
    [anon_sym_async] = ACTIONS(3343),
    [anon_sym_QMARK_DOT] = ACTIONS(3345),
    [anon_sym_new] = ACTIONS(3343),
    [anon_sym_AMP_AMP] = ACTIONS(3345),
    [anon_sym_PIPE_PIPE] = ACTIONS(3345),
    [anon_sym_GT_GT] = ACTIONS(3343),
    [anon_sym_GT_GT_GT] = ACTIONS(3345),
    [anon_sym_LT_LT] = ACTIONS(3345),
    [anon_sym_AMP] = ACTIONS(3343),
    [anon_sym_CARET] = ACTIONS(3345),
    [anon_sym_PIPE] = ACTIONS(3343),
    [anon_sym_PLUS] = ACTIONS(3343),
    [anon_sym_DASH] = ACTIONS(3343),
    [anon_sym_PERCENT] = ACTIONS(3345),
    [anon_sym_STAR_STAR] = ACTIONS(3345),
    [anon_sym_LT_EQ] = ACTIONS(3345),
    [anon_sym_EQ_EQ] = ACTIONS(3343),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3345),
    [anon_sym_BANG_EQ] = ACTIONS(3343),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3345),
    [anon_sym_GT_EQ] = ACTIONS(3345),
    [anon_sym_QMARK_QMARK] = ACTIONS(3345),
    [anon_sym_instanceof] = ACTIONS(3343),
    [anon_sym_void] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3345),
    [anon_sym_DASH_DASH] = ACTIONS(3345),
    [anon_sym_DQUOTE] = ACTIONS(3345),
    [anon_sym_SQUOTE] = ACTIONS(3345),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3345),
    [sym_number] = ACTIONS(3345),
    [sym_this] = ACTIONS(3343),
    [sym_true] = ACTIONS(3343),
    [sym_false] = ACTIONS(3343),
    [sym_null] = ACTIONS(3343),
    [sym_undefined] = ACTIONS(3343),
    [anon_sym_static] = ACTIONS(3343),
    [anon_sym_readonly] = ACTIONS(3343),
    [anon_sym_get] = ACTIONS(3343),
    [anon_sym_set] = ACTIONS(3343),
    [anon_sym_QMARK] = ACTIONS(3343),
    [anon_sym_any] = ACTIONS(3343),
    [anon_sym_number] = ACTIONS(3343),
    [anon_sym_boolean] = ACTIONS(3343),
    [anon_sym_string] = ACTIONS(3343),
    [anon_sym_symbol] = ACTIONS(3343),
    [anon_sym_abstract] = ACTIONS(3343),
    [anon_sym_satisfies] = ACTIONS(3343),
    [anon_sym_extends] = ACTIONS(3343),
    [anon_sym_infer] = ACTIONS(3343),
    [anon_sym_keyof] = ACTIONS(3343),
    [anon_sym_unknown] = ACTIONS(3343),
    [anon_sym_never] = ACTIONS(3343),
    [anon_sym_object] = ACTIONS(3343),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3345),
    [anon_sym_constructor] = ACTIONS(3343),
    [anon_sym_prop] = ACTIONS(3343),
    [anon_sym_id] = ACTIONS(3343),
    [anon_sym_event] = ACTIONS(3343),
    [anon_sym_fn] = ACTIONS(3343),
    [anon_sym_on] = ACTIONS(3343),
    [sym__ternary_qmark] = ACTIONS(3345),
  },
  [964] = {
    [sym_identifier] = ACTIONS(3347),
    [anon_sym_STAR] = ACTIONS(3347),
    [anon_sym_as] = ACTIONS(3347),
    [anon_sym_LBRACE] = ACTIONS(3347),
    [anon_sym_RBRACE] = ACTIONS(3349),
    [anon_sym_typeof] = ACTIONS(3347),
    [anon_sym_BANG] = ACTIONS(3347),
    [anon_sym_LPAREN] = ACTIONS(3349),
    [anon_sym_in] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(3349),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [anon_sym_LT] = ACTIONS(3347),
    [anon_sym_GT] = ACTIONS(3347),
    [anon_sym_SLASH] = ACTIONS(3347),
    [anon_sym_DOT] = ACTIONS(3347),
    [anon_sym_async] = ACTIONS(3347),
    [anon_sym_QMARK_DOT] = ACTIONS(3349),
    [anon_sym_new] = ACTIONS(3347),
    [anon_sym_AMP_AMP] = ACTIONS(3349),
    [anon_sym_PIPE_PIPE] = ACTIONS(3349),
    [anon_sym_GT_GT] = ACTIONS(3347),
    [anon_sym_GT_GT_GT] = ACTIONS(3349),
    [anon_sym_LT_LT] = ACTIONS(3349),
    [anon_sym_AMP] = ACTIONS(3226),
    [anon_sym_CARET] = ACTIONS(3349),
    [anon_sym_PIPE] = ACTIONS(3226),
    [anon_sym_PLUS] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(3347),
    [anon_sym_PERCENT] = ACTIONS(3349),
    [anon_sym_STAR_STAR] = ACTIONS(3349),
    [anon_sym_LT_EQ] = ACTIONS(3349),
    [anon_sym_EQ_EQ] = ACTIONS(3347),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3349),
    [anon_sym_BANG_EQ] = ACTIONS(3347),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3349),
    [anon_sym_GT_EQ] = ACTIONS(3349),
    [anon_sym_QMARK_QMARK] = ACTIONS(3349),
    [anon_sym_instanceof] = ACTIONS(3347),
    [anon_sym_void] = ACTIONS(3347),
    [anon_sym_PLUS_PLUS] = ACTIONS(3349),
    [anon_sym_DASH_DASH] = ACTIONS(3349),
    [anon_sym_DQUOTE] = ACTIONS(3349),
    [anon_sym_SQUOTE] = ACTIONS(3349),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3349),
    [sym_number] = ACTIONS(3349),
    [sym_this] = ACTIONS(3347),
    [sym_true] = ACTIONS(3347),
    [sym_false] = ACTIONS(3347),
    [sym_null] = ACTIONS(3347),
    [sym_undefined] = ACTIONS(3347),
    [anon_sym_static] = ACTIONS(3347),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_get] = ACTIONS(3347),
    [anon_sym_set] = ACTIONS(3347),
    [anon_sym_QMARK] = ACTIONS(3347),
    [anon_sym_any] = ACTIONS(3347),
    [anon_sym_number] = ACTIONS(3347),
    [anon_sym_boolean] = ACTIONS(3347),
    [anon_sym_string] = ACTIONS(3347),
    [anon_sym_symbol] = ACTIONS(3347),
    [anon_sym_abstract] = ACTIONS(3347),
    [anon_sym_satisfies] = ACTIONS(3347),
    [anon_sym_extends] = ACTIONS(3226),
    [anon_sym_infer] = ACTIONS(3347),
    [anon_sym_keyof] = ACTIONS(3347),
    [anon_sym_unknown] = ACTIONS(3347),
    [anon_sym_never] = ACTIONS(3347),
    [anon_sym_object] = ACTIONS(3347),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3349),
    [anon_sym_constructor] = ACTIONS(3347),
    [anon_sym_prop] = ACTIONS(3347),
    [anon_sym_id] = ACTIONS(3347),
    [anon_sym_event] = ACTIONS(3347),
    [anon_sym_fn] = ACTIONS(3347),
    [anon_sym_on] = ACTIONS(3347),
    [sym__ternary_qmark] = ACTIONS(3349),
  },
  [965] = {
    [sym_identifier] = ACTIONS(3317),
    [anon_sym_STAR] = ACTIONS(3317),
    [anon_sym_as] = ACTIONS(3317),
    [anon_sym_LBRACE] = ACTIONS(3317),
    [anon_sym_RBRACE] = ACTIONS(3319),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_BANG] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_in] = ACTIONS(3317),
    [anon_sym_SEMI] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_LT] = ACTIONS(3317),
    [anon_sym_GT] = ACTIONS(3317),
    [anon_sym_SLASH] = ACTIONS(3317),
    [anon_sym_DOT] = ACTIONS(3317),
    [anon_sym_async] = ACTIONS(3317),
    [anon_sym_QMARK_DOT] = ACTIONS(3319),
    [anon_sym_new] = ACTIONS(3317),
    [anon_sym_AMP_AMP] = ACTIONS(3319),
    [anon_sym_PIPE_PIPE] = ACTIONS(3319),
    [anon_sym_GT_GT] = ACTIONS(3317),
    [anon_sym_GT_GT_GT] = ACTIONS(3319),
    [anon_sym_LT_LT] = ACTIONS(3319),
    [anon_sym_AMP] = ACTIONS(3317),
    [anon_sym_CARET] = ACTIONS(3319),
    [anon_sym_PIPE] = ACTIONS(3317),
    [anon_sym_PLUS] = ACTIONS(3317),
    [anon_sym_DASH] = ACTIONS(3317),
    [anon_sym_PERCENT] = ACTIONS(3319),
    [anon_sym_STAR_STAR] = ACTIONS(3319),
    [anon_sym_LT_EQ] = ACTIONS(3319),
    [anon_sym_EQ_EQ] = ACTIONS(3317),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3319),
    [anon_sym_BANG_EQ] = ACTIONS(3317),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3319),
    [anon_sym_GT_EQ] = ACTIONS(3319),
    [anon_sym_QMARK_QMARK] = ACTIONS(3319),
    [anon_sym_instanceof] = ACTIONS(3317),
    [anon_sym_void] = ACTIONS(3317),
    [anon_sym_PLUS_PLUS] = ACTIONS(3319),
    [anon_sym_DASH_DASH] = ACTIONS(3319),
    [anon_sym_DQUOTE] = ACTIONS(3319),
    [anon_sym_SQUOTE] = ACTIONS(3319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3319),
    [sym_number] = ACTIONS(3319),
    [sym_this] = ACTIONS(3317),
    [sym_true] = ACTIONS(3317),
    [sym_false] = ACTIONS(3317),
    [sym_null] = ACTIONS(3317),
    [sym_undefined] = ACTIONS(3317),
    [anon_sym_static] = ACTIONS(3317),
    [anon_sym_readonly] = ACTIONS(3317),
    [anon_sym_get] = ACTIONS(3317),
    [anon_sym_set] = ACTIONS(3317),
    [anon_sym_QMARK] = ACTIONS(3317),
    [anon_sym_any] = ACTIONS(3317),
    [anon_sym_number] = ACTIONS(3317),
    [anon_sym_boolean] = ACTIONS(3317),
    [anon_sym_string] = ACTIONS(3317),
    [anon_sym_symbol] = ACTIONS(3317),
    [anon_sym_abstract] = ACTIONS(3317),
    [anon_sym_satisfies] = ACTIONS(3317),
    [anon_sym_extends] = ACTIONS(3317),
    [anon_sym_infer] = ACTIONS(3317),
    [anon_sym_keyof] = ACTIONS(3317),
    [anon_sym_unknown] = ACTIONS(3317),
    [anon_sym_never] = ACTIONS(3317),
    [anon_sym_object] = ACTIONS(3317),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3319),
    [anon_sym_constructor] = ACTIONS(3317),
    [anon_sym_prop] = ACTIONS(3317),
    [anon_sym_id] = ACTIONS(3317),
    [anon_sym_event] = ACTIONS(3317),
    [anon_sym_fn] = ACTIONS(3317),
    [anon_sym_on] = ACTIONS(3317),
    [sym__ternary_qmark] = ACTIONS(3319),
  },
  [966] = {
    [sym_identifier] = ACTIONS(3335),
    [anon_sym_STAR] = ACTIONS(3335),
    [anon_sym_as] = ACTIONS(3335),
    [anon_sym_LBRACE] = ACTIONS(3335),
    [anon_sym_RBRACE] = ACTIONS(3337),
    [anon_sym_typeof] = ACTIONS(3335),
    [anon_sym_BANG] = ACTIONS(3335),
    [anon_sym_LPAREN] = ACTIONS(3337),
    [anon_sym_in] = ACTIONS(3335),
    [anon_sym_SEMI] = ACTIONS(3337),
    [anon_sym_LBRACK] = ACTIONS(3337),
    [anon_sym_LT] = ACTIONS(3335),
    [anon_sym_GT] = ACTIONS(3335),
    [anon_sym_SLASH] = ACTIONS(3335),
    [anon_sym_DOT] = ACTIONS(3335),
    [anon_sym_async] = ACTIONS(3335),
    [anon_sym_QMARK_DOT] = ACTIONS(3337),
    [anon_sym_new] = ACTIONS(3335),
    [anon_sym_AMP_AMP] = ACTIONS(3337),
    [anon_sym_PIPE_PIPE] = ACTIONS(3337),
    [anon_sym_GT_GT] = ACTIONS(3335),
    [anon_sym_GT_GT_GT] = ACTIONS(3337),
    [anon_sym_LT_LT] = ACTIONS(3337),
    [anon_sym_AMP] = ACTIONS(3335),
    [anon_sym_CARET] = ACTIONS(3337),
    [anon_sym_PIPE] = ACTIONS(3335),
    [anon_sym_PLUS] = ACTIONS(3335),
    [anon_sym_DASH] = ACTIONS(3335),
    [anon_sym_PERCENT] = ACTIONS(3337),
    [anon_sym_STAR_STAR] = ACTIONS(3337),
    [anon_sym_LT_EQ] = ACTIONS(3337),
    [anon_sym_EQ_EQ] = ACTIONS(3335),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3337),
    [anon_sym_BANG_EQ] = ACTIONS(3335),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3337),
    [anon_sym_GT_EQ] = ACTIONS(3337),
    [anon_sym_QMARK_QMARK] = ACTIONS(3337),
    [anon_sym_instanceof] = ACTIONS(3335),
    [anon_sym_void] = ACTIONS(3335),
    [anon_sym_PLUS_PLUS] = ACTIONS(3337),
    [anon_sym_DASH_DASH] = ACTIONS(3337),
    [anon_sym_DQUOTE] = ACTIONS(3337),
    [anon_sym_SQUOTE] = ACTIONS(3337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3337),
    [sym_number] = ACTIONS(3337),
    [sym_this] = ACTIONS(3335),
    [sym_true] = ACTIONS(3335),
    [sym_false] = ACTIONS(3335),
    [sym_null] = ACTIONS(3335),
    [sym_undefined] = ACTIONS(3335),
    [anon_sym_static] = ACTIONS(3335),
    [anon_sym_readonly] = ACTIONS(3335),
    [anon_sym_get] = ACTIONS(3335),
    [anon_sym_set] = ACTIONS(3335),
    [anon_sym_QMARK] = ACTIONS(3335),
    [anon_sym_any] = ACTIONS(3335),
    [anon_sym_number] = ACTIONS(3335),
    [anon_sym_boolean] = ACTIONS(3335),
    [anon_sym_string] = ACTIONS(3335),
    [anon_sym_symbol] = ACTIONS(3335),
    [anon_sym_abstract] = ACTIONS(3335),
    [anon_sym_satisfies] = ACTIONS(3335),
    [anon_sym_extends] = ACTIONS(3335),
    [anon_sym_infer] = ACTIONS(3335),
    [anon_sym_keyof] = ACTIONS(3335),
    [anon_sym_unknown] = ACTIONS(3335),
    [anon_sym_never] = ACTIONS(3335),
    [anon_sym_object] = ACTIONS(3335),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3337),
    [anon_sym_constructor] = ACTIONS(3335),
    [anon_sym_prop] = ACTIONS(3335),
    [anon_sym_id] = ACTIONS(3335),
    [anon_sym_event] = ACTIONS(3335),
    [anon_sym_fn] = ACTIONS(3335),
    [anon_sym_on] = ACTIONS(3335),
    [sym__ternary_qmark] = ACTIONS(3337),
  },
  [967] = {
    [sym_identifier] = ACTIONS(1848),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1848),
    [anon_sym_LBRACE] = ACTIONS(1848),
    [anon_sym_RBRACE] = ACTIONS(1852),
    [anon_sym_typeof] = ACTIONS(1848),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(1848),
    [anon_sym_async] = ACTIONS(1848),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1848),
    [anon_sym_AMP_AMP] = ACTIONS(1852),
    [anon_sym_PIPE_PIPE] = ACTIONS(1852),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1852),
    [anon_sym_LT_LT] = ACTIONS(1852),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1852),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1852),
    [anon_sym_STAR_STAR] = ACTIONS(1852),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1852),
    [anon_sym_instanceof] = ACTIONS(1848),
    [anon_sym_void] = ACTIONS(1848),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [anon_sym_DQUOTE] = ACTIONS(1852),
    [anon_sym_SQUOTE] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1852),
    [sym_number] = ACTIONS(1852),
    [sym_this] = ACTIONS(1848),
    [sym_true] = ACTIONS(1848),
    [sym_false] = ACTIONS(1848),
    [sym_null] = ACTIONS(1848),
    [sym_undefined] = ACTIONS(1848),
    [anon_sym_static] = ACTIONS(1848),
    [anon_sym_readonly] = ACTIONS(1848),
    [anon_sym_get] = ACTIONS(1848),
    [anon_sym_set] = ACTIONS(1848),
    [anon_sym_QMARK] = ACTIONS(1848),
    [anon_sym_any] = ACTIONS(1848),
    [anon_sym_number] = ACTIONS(1848),
    [anon_sym_boolean] = ACTIONS(1848),
    [anon_sym_string] = ACTIONS(1848),
    [anon_sym_symbol] = ACTIONS(1848),
    [anon_sym_abstract] = ACTIONS(1848),
    [anon_sym_satisfies] = ACTIONS(1848),
    [anon_sym_infer] = ACTIONS(1848),
    [anon_sym_keyof] = ACTIONS(1848),
    [anon_sym_unknown] = ACTIONS(1848),
    [anon_sym_never] = ACTIONS(1848),
    [anon_sym_object] = ACTIONS(1848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_constructor] = ACTIONS(1848),
    [anon_sym_prop] = ACTIONS(1848),
    [anon_sym_id] = ACTIONS(1848),
    [anon_sym_event] = ACTIONS(1848),
    [anon_sym_fn] = ACTIONS(1848),
    [anon_sym_on] = ACTIONS(1848),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [968] = {
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_as] = ACTIONS(3351),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_RBRACE] = ACTIONS(3353),
    [anon_sym_typeof] = ACTIONS(3351),
    [anon_sym_BANG] = ACTIONS(3351),
    [anon_sym_LPAREN] = ACTIONS(3353),
    [anon_sym_in] = ACTIONS(3351),
    [anon_sym_SEMI] = ACTIONS(3353),
    [anon_sym_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3351),
    [anon_sym_GT] = ACTIONS(3351),
    [anon_sym_SLASH] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_async] = ACTIONS(3351),
    [anon_sym_QMARK_DOT] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3353),
    [anon_sym_PIPE_PIPE] = ACTIONS(3353),
    [anon_sym_GT_GT] = ACTIONS(3351),
    [anon_sym_GT_GT_GT] = ACTIONS(3353),
    [anon_sym_LT_LT] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_CARET] = ACTIONS(3353),
    [anon_sym_PIPE] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3353),
    [anon_sym_STAR_STAR] = ACTIONS(3353),
    [anon_sym_LT_EQ] = ACTIONS(3353),
    [anon_sym_EQ_EQ] = ACTIONS(3351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3353),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3353),
    [anon_sym_GT_EQ] = ACTIONS(3353),
    [anon_sym_QMARK_QMARK] = ACTIONS(3353),
    [anon_sym_instanceof] = ACTIONS(3351),
    [anon_sym_void] = ACTIONS(3351),
    [anon_sym_PLUS_PLUS] = ACTIONS(3353),
    [anon_sym_DASH_DASH] = ACTIONS(3353),
    [anon_sym_DQUOTE] = ACTIONS(3353),
    [anon_sym_SQUOTE] = ACTIONS(3353),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3353),
    [sym_regex_flags] = ACTIONS(3355),
    [sym_number] = ACTIONS(3353),
    [sym_this] = ACTIONS(3351),
    [sym_true] = ACTIONS(3351),
    [sym_false] = ACTIONS(3351),
    [sym_null] = ACTIONS(3351),
    [sym_undefined] = ACTIONS(3351),
    [anon_sym_static] = ACTIONS(3351),
    [anon_sym_readonly] = ACTIONS(3351),
    [anon_sym_get] = ACTIONS(3351),
    [anon_sym_set] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_any] = ACTIONS(3351),
    [anon_sym_number] = ACTIONS(3351),
    [anon_sym_boolean] = ACTIONS(3351),
    [anon_sym_string] = ACTIONS(3351),
    [anon_sym_symbol] = ACTIONS(3351),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_satisfies] = ACTIONS(3351),
    [anon_sym_infer] = ACTIONS(3351),
    [anon_sym_keyof] = ACTIONS(3351),
    [anon_sym_unknown] = ACTIONS(3351),
    [anon_sym_never] = ACTIONS(3351),
    [anon_sym_object] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_constructor] = ACTIONS(3351),
    [anon_sym_prop] = ACTIONS(3351),
    [anon_sym_id] = ACTIONS(3351),
    [anon_sym_event] = ACTIONS(3351),
    [anon_sym_fn] = ACTIONS(3351),
    [anon_sym_on] = ACTIONS(3351),
    [sym__ternary_qmark] = ACTIONS(3353),
  },
  [969] = {
    [sym_identifier] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(3357),
    [anon_sym_as] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3357),
    [anon_sym_RBRACE] = ACTIONS(3359),
    [anon_sym_typeof] = ACTIONS(3357),
    [anon_sym_BANG] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3359),
    [anon_sym_in] = ACTIONS(3357),
    [anon_sym_SEMI] = ACTIONS(3359),
    [anon_sym_LBRACK] = ACTIONS(3359),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_GT] = ACTIONS(3357),
    [anon_sym_SLASH] = ACTIONS(3357),
    [anon_sym_DOT] = ACTIONS(3357),
    [anon_sym_async] = ACTIONS(3357),
    [anon_sym_QMARK_DOT] = ACTIONS(3359),
    [anon_sym_new] = ACTIONS(3357),
    [anon_sym_AMP_AMP] = ACTIONS(3359),
    [anon_sym_PIPE_PIPE] = ACTIONS(3359),
    [anon_sym_GT_GT] = ACTIONS(3357),
    [anon_sym_GT_GT_GT] = ACTIONS(3359),
    [anon_sym_LT_LT] = ACTIONS(3359),
    [anon_sym_AMP] = ACTIONS(3110),
    [anon_sym_CARET] = ACTIONS(3359),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_PLUS] = ACTIONS(3357),
    [anon_sym_DASH] = ACTIONS(3357),
    [anon_sym_PERCENT] = ACTIONS(3359),
    [anon_sym_STAR_STAR] = ACTIONS(3359),
    [anon_sym_LT_EQ] = ACTIONS(3359),
    [anon_sym_EQ_EQ] = ACTIONS(3357),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3359),
    [anon_sym_BANG_EQ] = ACTIONS(3357),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3359),
    [anon_sym_GT_EQ] = ACTIONS(3359),
    [anon_sym_QMARK_QMARK] = ACTIONS(3359),
    [anon_sym_instanceof] = ACTIONS(3357),
    [anon_sym_void] = ACTIONS(3357),
    [anon_sym_PLUS_PLUS] = ACTIONS(3359),
    [anon_sym_DASH_DASH] = ACTIONS(3359),
    [anon_sym_DQUOTE] = ACTIONS(3359),
    [anon_sym_SQUOTE] = ACTIONS(3359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3359),
    [sym_number] = ACTIONS(3359),
    [sym_this] = ACTIONS(3357),
    [sym_true] = ACTIONS(3357),
    [sym_false] = ACTIONS(3357),
    [sym_null] = ACTIONS(3357),
    [sym_undefined] = ACTIONS(3357),
    [anon_sym_static] = ACTIONS(3357),
    [anon_sym_readonly] = ACTIONS(3357),
    [anon_sym_get] = ACTIONS(3357),
    [anon_sym_set] = ACTIONS(3357),
    [anon_sym_QMARK] = ACTIONS(3357),
    [anon_sym_any] = ACTIONS(3357),
    [anon_sym_number] = ACTIONS(3357),
    [anon_sym_boolean] = ACTIONS(3357),
    [anon_sym_string] = ACTIONS(3357),
    [anon_sym_symbol] = ACTIONS(3357),
    [anon_sym_abstract] = ACTIONS(3357),
    [anon_sym_satisfies] = ACTIONS(3357),
    [anon_sym_extends] = ACTIONS(3160),
    [anon_sym_infer] = ACTIONS(3357),
    [anon_sym_keyof] = ACTIONS(3357),
    [anon_sym_unknown] = ACTIONS(3357),
    [anon_sym_never] = ACTIONS(3357),
    [anon_sym_object] = ACTIONS(3357),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3359),
    [anon_sym_constructor] = ACTIONS(3357),
    [anon_sym_prop] = ACTIONS(3357),
    [anon_sym_id] = ACTIONS(3357),
    [anon_sym_event] = ACTIONS(3357),
    [anon_sym_fn] = ACTIONS(3357),
    [anon_sym_on] = ACTIONS(3357),
    [sym__ternary_qmark] = ACTIONS(3359),
  },
  [970] = {
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_STAR] = ACTIONS(3361),
    [anon_sym_as] = ACTIONS(3361),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_RBRACE] = ACTIONS(3363),
    [anon_sym_typeof] = ACTIONS(3361),
    [anon_sym_BANG] = ACTIONS(3361),
    [anon_sym_LPAREN] = ACTIONS(3363),
    [anon_sym_in] = ACTIONS(3361),
    [anon_sym_SEMI] = ACTIONS(3363),
    [anon_sym_LBRACK] = ACTIONS(3363),
    [anon_sym_LT] = ACTIONS(3361),
    [anon_sym_GT] = ACTIONS(3361),
    [anon_sym_SLASH] = ACTIONS(3361),
    [anon_sym_DOT] = ACTIONS(3361),
    [anon_sym_async] = ACTIONS(3361),
    [anon_sym_QMARK_DOT] = ACTIONS(3363),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_AMP_AMP] = ACTIONS(3363),
    [anon_sym_PIPE_PIPE] = ACTIONS(3363),
    [anon_sym_GT_GT] = ACTIONS(3361),
    [anon_sym_GT_GT_GT] = ACTIONS(3363),
    [anon_sym_LT_LT] = ACTIONS(3363),
    [anon_sym_AMP] = ACTIONS(3361),
    [anon_sym_CARET] = ACTIONS(3363),
    [anon_sym_PIPE] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_PERCENT] = ACTIONS(3363),
    [anon_sym_STAR_STAR] = ACTIONS(3363),
    [anon_sym_LT_EQ] = ACTIONS(3363),
    [anon_sym_EQ_EQ] = ACTIONS(3361),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3363),
    [anon_sym_BANG_EQ] = ACTIONS(3361),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3363),
    [anon_sym_GT_EQ] = ACTIONS(3363),
    [anon_sym_QMARK_QMARK] = ACTIONS(3363),
    [anon_sym_instanceof] = ACTIONS(3361),
    [anon_sym_void] = ACTIONS(3361),
    [anon_sym_PLUS_PLUS] = ACTIONS(3363),
    [anon_sym_DASH_DASH] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3363),
    [anon_sym_SQUOTE] = ACTIONS(3363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3363),
    [sym_number] = ACTIONS(3363),
    [sym_this] = ACTIONS(3361),
    [sym_true] = ACTIONS(3361),
    [sym_false] = ACTIONS(3361),
    [sym_null] = ACTIONS(3361),
    [sym_undefined] = ACTIONS(3361),
    [anon_sym_static] = ACTIONS(3361),
    [anon_sym_readonly] = ACTIONS(3361),
    [anon_sym_get] = ACTIONS(3361),
    [anon_sym_set] = ACTIONS(3361),
    [anon_sym_QMARK] = ACTIONS(3361),
    [anon_sym_any] = ACTIONS(3361),
    [anon_sym_number] = ACTIONS(3361),
    [anon_sym_boolean] = ACTIONS(3361),
    [anon_sym_string] = ACTIONS(3361),
    [anon_sym_symbol] = ACTIONS(3361),
    [anon_sym_abstract] = ACTIONS(3361),
    [anon_sym_satisfies] = ACTIONS(3361),
    [anon_sym_extends] = ACTIONS(3361),
    [anon_sym_infer] = ACTIONS(3361),
    [anon_sym_keyof] = ACTIONS(3361),
    [anon_sym_unknown] = ACTIONS(3361),
    [anon_sym_never] = ACTIONS(3361),
    [anon_sym_object] = ACTIONS(3361),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3363),
    [anon_sym_constructor] = ACTIONS(3361),
    [anon_sym_prop] = ACTIONS(3361),
    [anon_sym_id] = ACTIONS(3361),
    [anon_sym_event] = ACTIONS(3361),
    [anon_sym_fn] = ACTIONS(3361),
    [anon_sym_on] = ACTIONS(3361),
    [sym__ternary_qmark] = ACTIONS(3363),
  },
  [971] = {
    [sym_identifier] = ACTIONS(1524),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_as] = ACTIONS(1524),
    [anon_sym_LBRACE] = ACTIONS(1524),
    [anon_sym_RBRACE] = ACTIONS(1526),
    [anon_sym_typeof] = ACTIONS(1524),
    [anon_sym_BANG] = ACTIONS(1524),
    [anon_sym_LPAREN] = ACTIONS(1526),
    [anon_sym_in] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1526),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_GT] = ACTIONS(1524),
    [anon_sym_SLASH] = ACTIONS(1524),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_async] = ACTIONS(1524),
    [anon_sym_QMARK_DOT] = ACTIONS(1526),
    [anon_sym_new] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE_PIPE] = ACTIONS(1526),
    [anon_sym_GT_GT] = ACTIONS(1524),
    [anon_sym_GT_GT_GT] = ACTIONS(1526),
    [anon_sym_LT_LT] = ACTIONS(1526),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_CARET] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_PLUS] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1524),
    [anon_sym_PERCENT] = ACTIONS(1526),
    [anon_sym_STAR_STAR] = ACTIONS(1526),
    [anon_sym_LT_EQ] = ACTIONS(1526),
    [anon_sym_EQ_EQ] = ACTIONS(1524),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1526),
    [anon_sym_BANG_EQ] = ACTIONS(1524),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1526),
    [anon_sym_GT_EQ] = ACTIONS(1526),
    [anon_sym_QMARK_QMARK] = ACTIONS(1526),
    [anon_sym_instanceof] = ACTIONS(1524),
    [anon_sym_void] = ACTIONS(1524),
    [anon_sym_PLUS_PLUS] = ACTIONS(1526),
    [anon_sym_DASH_DASH] = ACTIONS(1526),
    [anon_sym_DQUOTE] = ACTIONS(1526),
    [anon_sym_SQUOTE] = ACTIONS(1526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1526),
    [sym_number] = ACTIONS(1526),
    [sym_this] = ACTIONS(1524),
    [sym_true] = ACTIONS(1524),
    [sym_false] = ACTIONS(1524),
    [sym_null] = ACTIONS(1524),
    [sym_undefined] = ACTIONS(1524),
    [anon_sym_static] = ACTIONS(1524),
    [anon_sym_readonly] = ACTIONS(1524),
    [anon_sym_get] = ACTIONS(1524),
    [anon_sym_set] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(1524),
    [anon_sym_any] = ACTIONS(1524),
    [anon_sym_number] = ACTIONS(1524),
    [anon_sym_boolean] = ACTIONS(1524),
    [anon_sym_string] = ACTIONS(1524),
    [anon_sym_symbol] = ACTIONS(1524),
    [anon_sym_abstract] = ACTIONS(1524),
    [anon_sym_satisfies] = ACTIONS(1524),
    [anon_sym_infer] = ACTIONS(1524),
    [anon_sym_keyof] = ACTIONS(1524),
    [anon_sym_unknown] = ACTIONS(1524),
    [anon_sym_never] = ACTIONS(1524),
    [anon_sym_object] = ACTIONS(1524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1526),
    [anon_sym_constructor] = ACTIONS(1524),
    [anon_sym_prop] = ACTIONS(1524),
    [anon_sym_id] = ACTIONS(1524),
    [anon_sym_event] = ACTIONS(1524),
    [anon_sym_fn] = ACTIONS(1524),
    [anon_sym_on] = ACTIONS(1524),
    [sym__automatic_semicolon] = ACTIONS(3365),
    [sym__ternary_qmark] = ACTIONS(1526),
  },
  [972] = {
    [sym_identifier] = ACTIONS(3367),
    [anon_sym_STAR] = ACTIONS(3367),
    [anon_sym_as] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3367),
    [anon_sym_RBRACE] = ACTIONS(3369),
    [anon_sym_typeof] = ACTIONS(3367),
    [anon_sym_BANG] = ACTIONS(3367),
    [anon_sym_LPAREN] = ACTIONS(3369),
    [anon_sym_in] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3369),
    [anon_sym_LBRACK] = ACTIONS(3369),
    [anon_sym_LT] = ACTIONS(3367),
    [anon_sym_GT] = ACTIONS(3367),
    [anon_sym_SLASH] = ACTIONS(3367),
    [anon_sym_DOT] = ACTIONS(3367),
    [anon_sym_async] = ACTIONS(3367),
    [anon_sym_QMARK_DOT] = ACTIONS(3369),
    [anon_sym_new] = ACTIONS(3367),
    [anon_sym_AMP_AMP] = ACTIONS(3369),
    [anon_sym_PIPE_PIPE] = ACTIONS(3369),
    [anon_sym_GT_GT] = ACTIONS(3367),
    [anon_sym_GT_GT_GT] = ACTIONS(3369),
    [anon_sym_LT_LT] = ACTIONS(3369),
    [anon_sym_AMP] = ACTIONS(3110),
    [anon_sym_CARET] = ACTIONS(3369),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_PLUS] = ACTIONS(3367),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_PERCENT] = ACTIONS(3369),
    [anon_sym_STAR_STAR] = ACTIONS(3369),
    [anon_sym_LT_EQ] = ACTIONS(3369),
    [anon_sym_EQ_EQ] = ACTIONS(3367),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3369),
    [anon_sym_BANG_EQ] = ACTIONS(3367),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3369),
    [anon_sym_GT_EQ] = ACTIONS(3369),
    [anon_sym_QMARK_QMARK] = ACTIONS(3369),
    [anon_sym_instanceof] = ACTIONS(3367),
    [anon_sym_void] = ACTIONS(3367),
    [anon_sym_PLUS_PLUS] = ACTIONS(3369),
    [anon_sym_DASH_DASH] = ACTIONS(3369),
    [anon_sym_DQUOTE] = ACTIONS(3369),
    [anon_sym_SQUOTE] = ACTIONS(3369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3369),
    [sym_number] = ACTIONS(3369),
    [sym_this] = ACTIONS(3367),
    [sym_true] = ACTIONS(3367),
    [sym_false] = ACTIONS(3367),
    [sym_null] = ACTIONS(3367),
    [sym_undefined] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3367),
    [anon_sym_readonly] = ACTIONS(3367),
    [anon_sym_get] = ACTIONS(3367),
    [anon_sym_set] = ACTIONS(3367),
    [anon_sym_QMARK] = ACTIONS(3367),
    [anon_sym_any] = ACTIONS(3367),
    [anon_sym_number] = ACTIONS(3367),
    [anon_sym_boolean] = ACTIONS(3367),
    [anon_sym_string] = ACTIONS(3367),
    [anon_sym_symbol] = ACTIONS(3367),
    [anon_sym_abstract] = ACTIONS(3367),
    [anon_sym_satisfies] = ACTIONS(3367),
    [anon_sym_extends] = ACTIONS(3160),
    [anon_sym_infer] = ACTIONS(3367),
    [anon_sym_keyof] = ACTIONS(3367),
    [anon_sym_unknown] = ACTIONS(3367),
    [anon_sym_never] = ACTIONS(3367),
    [anon_sym_object] = ACTIONS(3367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3369),
    [anon_sym_constructor] = ACTIONS(3367),
    [anon_sym_prop] = ACTIONS(3367),
    [anon_sym_id] = ACTIONS(3367),
    [anon_sym_event] = ACTIONS(3367),
    [anon_sym_fn] = ACTIONS(3367),
    [anon_sym_on] = ACTIONS(3367),
    [sym__ternary_qmark] = ACTIONS(3369),
  },
  [973] = {
    [sym_identifier] = ACTIONS(3317),
    [anon_sym_STAR] = ACTIONS(3317),
    [anon_sym_as] = ACTIONS(3317),
    [anon_sym_LBRACE] = ACTIONS(3317),
    [anon_sym_RBRACE] = ACTIONS(3319),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_BANG] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_in] = ACTIONS(3317),
    [anon_sym_SEMI] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_LT] = ACTIONS(3317),
    [anon_sym_GT] = ACTIONS(3317),
    [anon_sym_SLASH] = ACTIONS(3317),
    [anon_sym_DOT] = ACTIONS(3317),
    [anon_sym_async] = ACTIONS(3317),
    [anon_sym_QMARK_DOT] = ACTIONS(3319),
    [anon_sym_new] = ACTIONS(3317),
    [anon_sym_AMP_AMP] = ACTIONS(3319),
    [anon_sym_PIPE_PIPE] = ACTIONS(3319),
    [anon_sym_GT_GT] = ACTIONS(3317),
    [anon_sym_GT_GT_GT] = ACTIONS(3319),
    [anon_sym_LT_LT] = ACTIONS(3319),
    [anon_sym_AMP] = ACTIONS(3317),
    [anon_sym_CARET] = ACTIONS(3319),
    [anon_sym_PIPE] = ACTIONS(3317),
    [anon_sym_PLUS] = ACTIONS(3317),
    [anon_sym_DASH] = ACTIONS(3317),
    [anon_sym_PERCENT] = ACTIONS(3319),
    [anon_sym_STAR_STAR] = ACTIONS(3319),
    [anon_sym_LT_EQ] = ACTIONS(3319),
    [anon_sym_EQ_EQ] = ACTIONS(3317),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3319),
    [anon_sym_BANG_EQ] = ACTIONS(3317),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3319),
    [anon_sym_GT_EQ] = ACTIONS(3319),
    [anon_sym_QMARK_QMARK] = ACTIONS(3319),
    [anon_sym_instanceof] = ACTIONS(3317),
    [anon_sym_void] = ACTIONS(3317),
    [anon_sym_PLUS_PLUS] = ACTIONS(3319),
    [anon_sym_DASH_DASH] = ACTIONS(3319),
    [anon_sym_DQUOTE] = ACTIONS(3319),
    [anon_sym_SQUOTE] = ACTIONS(3319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3319),
    [sym_number] = ACTIONS(3319),
    [sym_this] = ACTIONS(3317),
    [sym_true] = ACTIONS(3317),
    [sym_false] = ACTIONS(3317),
    [sym_null] = ACTIONS(3317),
    [sym_undefined] = ACTIONS(3317),
    [anon_sym_static] = ACTIONS(3317),
    [anon_sym_readonly] = ACTIONS(3317),
    [anon_sym_get] = ACTIONS(3317),
    [anon_sym_set] = ACTIONS(3317),
    [anon_sym_QMARK] = ACTIONS(3317),
    [anon_sym_any] = ACTIONS(3317),
    [anon_sym_number] = ACTIONS(3317),
    [anon_sym_boolean] = ACTIONS(3317),
    [anon_sym_string] = ACTIONS(3317),
    [anon_sym_symbol] = ACTIONS(3317),
    [anon_sym_abstract] = ACTIONS(3317),
    [anon_sym_satisfies] = ACTIONS(3317),
    [anon_sym_extends] = ACTIONS(3317),
    [anon_sym_infer] = ACTIONS(3317),
    [anon_sym_keyof] = ACTIONS(3317),
    [anon_sym_unknown] = ACTIONS(3317),
    [anon_sym_never] = ACTIONS(3317),
    [anon_sym_object] = ACTIONS(3317),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3319),
    [anon_sym_constructor] = ACTIONS(3317),
    [anon_sym_prop] = ACTIONS(3317),
    [anon_sym_id] = ACTIONS(3317),
    [anon_sym_event] = ACTIONS(3317),
    [anon_sym_fn] = ACTIONS(3317),
    [anon_sym_on] = ACTIONS(3317),
    [sym__ternary_qmark] = ACTIONS(3319),
  },
  [974] = {
    [sym_arguments] = STATE(1041),
    [sym_identifier] = ACTIONS(3371),
    [anon_sym_STAR] = ACTIONS(3371),
    [anon_sym_as] = ACTIONS(3371),
    [anon_sym_LBRACE] = ACTIONS(3371),
    [anon_sym_RBRACE] = ACTIONS(3373),
    [anon_sym_typeof] = ACTIONS(3371),
    [anon_sym_BANG] = ACTIONS(3371),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(3371),
    [anon_sym_SEMI] = ACTIONS(3373),
    [anon_sym_LBRACK] = ACTIONS(3373),
    [anon_sym_LT] = ACTIONS(3371),
    [anon_sym_GT] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3371),
    [anon_sym_DOT] = ACTIONS(3371),
    [anon_sym_async] = ACTIONS(3371),
    [anon_sym_QMARK_DOT] = ACTIONS(3373),
    [anon_sym_new] = ACTIONS(3371),
    [anon_sym_AMP_AMP] = ACTIONS(3373),
    [anon_sym_PIPE_PIPE] = ACTIONS(3373),
    [anon_sym_GT_GT] = ACTIONS(3371),
    [anon_sym_GT_GT_GT] = ACTIONS(3373),
    [anon_sym_LT_LT] = ACTIONS(3373),
    [anon_sym_AMP] = ACTIONS(3371),
    [anon_sym_CARET] = ACTIONS(3373),
    [anon_sym_PIPE] = ACTIONS(3371),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_PERCENT] = ACTIONS(3373),
    [anon_sym_STAR_STAR] = ACTIONS(3373),
    [anon_sym_LT_EQ] = ACTIONS(3373),
    [anon_sym_EQ_EQ] = ACTIONS(3371),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3373),
    [anon_sym_BANG_EQ] = ACTIONS(3371),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3373),
    [anon_sym_GT_EQ] = ACTIONS(3373),
    [anon_sym_QMARK_QMARK] = ACTIONS(3373),
    [anon_sym_instanceof] = ACTIONS(3371),
    [anon_sym_void] = ACTIONS(3371),
    [anon_sym_PLUS_PLUS] = ACTIONS(3373),
    [anon_sym_DASH_DASH] = ACTIONS(3373),
    [anon_sym_DQUOTE] = ACTIONS(3373),
    [anon_sym_SQUOTE] = ACTIONS(3373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3373),
    [sym_number] = ACTIONS(3373),
    [sym_this] = ACTIONS(3371),
    [sym_true] = ACTIONS(3371),
    [sym_false] = ACTIONS(3371),
    [sym_null] = ACTIONS(3371),
    [sym_undefined] = ACTIONS(3371),
    [anon_sym_static] = ACTIONS(3371),
    [anon_sym_readonly] = ACTIONS(3371),
    [anon_sym_get] = ACTIONS(3371),
    [anon_sym_set] = ACTIONS(3371),
    [anon_sym_QMARK] = ACTIONS(3371),
    [anon_sym_any] = ACTIONS(3371),
    [anon_sym_number] = ACTIONS(3371),
    [anon_sym_boolean] = ACTIONS(3371),
    [anon_sym_string] = ACTIONS(3371),
    [anon_sym_symbol] = ACTIONS(3371),
    [anon_sym_abstract] = ACTIONS(3371),
    [anon_sym_satisfies] = ACTIONS(3371),
    [anon_sym_infer] = ACTIONS(3371),
    [anon_sym_keyof] = ACTIONS(3371),
    [anon_sym_unknown] = ACTIONS(3371),
    [anon_sym_never] = ACTIONS(3371),
    [anon_sym_object] = ACTIONS(3371),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3373),
    [anon_sym_constructor] = ACTIONS(3371),
    [anon_sym_prop] = ACTIONS(3371),
    [anon_sym_id] = ACTIONS(3371),
    [anon_sym_event] = ACTIONS(3371),
    [anon_sym_fn] = ACTIONS(3371),
    [anon_sym_on] = ACTIONS(3371),
    [sym__ternary_qmark] = ACTIONS(3373),
  },
  [975] = {
    [sym_identifier] = ACTIONS(3339),
    [anon_sym_STAR] = ACTIONS(3339),
    [anon_sym_as] = ACTIONS(3339),
    [anon_sym_LBRACE] = ACTIONS(3339),
    [anon_sym_RBRACE] = ACTIONS(3341),
    [anon_sym_typeof] = ACTIONS(3339),
    [anon_sym_BANG] = ACTIONS(3339),
    [anon_sym_LPAREN] = ACTIONS(3341),
    [anon_sym_in] = ACTIONS(3339),
    [anon_sym_SEMI] = ACTIONS(3341),
    [anon_sym_LBRACK] = ACTIONS(3341),
    [anon_sym_LT] = ACTIONS(3339),
    [anon_sym_GT] = ACTIONS(3339),
    [anon_sym_SLASH] = ACTIONS(3339),
    [anon_sym_DOT] = ACTIONS(3339),
    [anon_sym_async] = ACTIONS(3339),
    [anon_sym_QMARK_DOT] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(3339),
    [anon_sym_AMP_AMP] = ACTIONS(3341),
    [anon_sym_PIPE_PIPE] = ACTIONS(3341),
    [anon_sym_GT_GT] = ACTIONS(3339),
    [anon_sym_GT_GT_GT] = ACTIONS(3341),
    [anon_sym_LT_LT] = ACTIONS(3341),
    [anon_sym_AMP] = ACTIONS(3339),
    [anon_sym_CARET] = ACTIONS(3341),
    [anon_sym_PIPE] = ACTIONS(3339),
    [anon_sym_PLUS] = ACTIONS(3339),
    [anon_sym_DASH] = ACTIONS(3339),
    [anon_sym_PERCENT] = ACTIONS(3341),
    [anon_sym_STAR_STAR] = ACTIONS(3341),
    [anon_sym_LT_EQ] = ACTIONS(3341),
    [anon_sym_EQ_EQ] = ACTIONS(3339),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3341),
    [anon_sym_BANG_EQ] = ACTIONS(3339),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3341),
    [anon_sym_GT_EQ] = ACTIONS(3341),
    [anon_sym_QMARK_QMARK] = ACTIONS(3341),
    [anon_sym_instanceof] = ACTIONS(3339),
    [anon_sym_void] = ACTIONS(3339),
    [anon_sym_PLUS_PLUS] = ACTIONS(3341),
    [anon_sym_DASH_DASH] = ACTIONS(3341),
    [anon_sym_DQUOTE] = ACTIONS(3341),
    [anon_sym_SQUOTE] = ACTIONS(3341),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3341),
    [sym_number] = ACTIONS(3341),
    [sym_this] = ACTIONS(3339),
    [sym_true] = ACTIONS(3339),
    [sym_false] = ACTIONS(3339),
    [sym_null] = ACTIONS(3339),
    [sym_undefined] = ACTIONS(3339),
    [anon_sym_static] = ACTIONS(3339),
    [anon_sym_readonly] = ACTIONS(3339),
    [anon_sym_get] = ACTIONS(3339),
    [anon_sym_set] = ACTIONS(3339),
    [anon_sym_QMARK] = ACTIONS(3339),
    [anon_sym_any] = ACTIONS(3339),
    [anon_sym_number] = ACTIONS(3339),
    [anon_sym_boolean] = ACTIONS(3339),
    [anon_sym_string] = ACTIONS(3339),
    [anon_sym_symbol] = ACTIONS(3339),
    [anon_sym_abstract] = ACTIONS(3339),
    [anon_sym_satisfies] = ACTIONS(3339),
    [anon_sym_extends] = ACTIONS(3339),
    [anon_sym_infer] = ACTIONS(3339),
    [anon_sym_keyof] = ACTIONS(3339),
    [anon_sym_unknown] = ACTIONS(3339),
    [anon_sym_never] = ACTIONS(3339),
    [anon_sym_object] = ACTIONS(3339),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3341),
    [anon_sym_constructor] = ACTIONS(3339),
    [anon_sym_prop] = ACTIONS(3339),
    [anon_sym_id] = ACTIONS(3339),
    [anon_sym_event] = ACTIONS(3339),
    [anon_sym_fn] = ACTIONS(3339),
    [anon_sym_on] = ACTIONS(3339),
    [sym__ternary_qmark] = ACTIONS(3341),
  },
  [976] = {
    [sym_identifier] = ACTIONS(3375),
    [anon_sym_STAR] = ACTIONS(3375),
    [anon_sym_as] = ACTIONS(3375),
    [anon_sym_LBRACE] = ACTIONS(3375),
    [anon_sym_RBRACE] = ACTIONS(3377),
    [anon_sym_typeof] = ACTIONS(3375),
    [anon_sym_BANG] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(3377),
    [anon_sym_in] = ACTIONS(3375),
    [anon_sym_SEMI] = ACTIONS(3377),
    [anon_sym_LBRACK] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3375),
    [anon_sym_GT] = ACTIONS(3375),
    [anon_sym_SLASH] = ACTIONS(3375),
    [anon_sym_DOT] = ACTIONS(3375),
    [anon_sym_async] = ACTIONS(3375),
    [anon_sym_QMARK_DOT] = ACTIONS(3377),
    [anon_sym_new] = ACTIONS(3375),
    [anon_sym_AMP_AMP] = ACTIONS(3377),
    [anon_sym_PIPE_PIPE] = ACTIONS(3377),
    [anon_sym_GT_GT] = ACTIONS(3375),
    [anon_sym_GT_GT_GT] = ACTIONS(3377),
    [anon_sym_LT_LT] = ACTIONS(3377),
    [anon_sym_AMP] = ACTIONS(3110),
    [anon_sym_CARET] = ACTIONS(3377),
    [anon_sym_PIPE] = ACTIONS(3375),
    [anon_sym_PLUS] = ACTIONS(3375),
    [anon_sym_DASH] = ACTIONS(3375),
    [anon_sym_PERCENT] = ACTIONS(3377),
    [anon_sym_STAR_STAR] = ACTIONS(3377),
    [anon_sym_LT_EQ] = ACTIONS(3377),
    [anon_sym_EQ_EQ] = ACTIONS(3375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3377),
    [anon_sym_BANG_EQ] = ACTIONS(3375),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3377),
    [anon_sym_GT_EQ] = ACTIONS(3377),
    [anon_sym_QMARK_QMARK] = ACTIONS(3377),
    [anon_sym_instanceof] = ACTIONS(3375),
    [anon_sym_void] = ACTIONS(3375),
    [anon_sym_PLUS_PLUS] = ACTIONS(3377),
    [anon_sym_DASH_DASH] = ACTIONS(3377),
    [anon_sym_DQUOTE] = ACTIONS(3377),
    [anon_sym_SQUOTE] = ACTIONS(3377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3377),
    [sym_number] = ACTIONS(3377),
    [sym_this] = ACTIONS(3375),
    [sym_true] = ACTIONS(3375),
    [sym_false] = ACTIONS(3375),
    [sym_null] = ACTIONS(3375),
    [sym_undefined] = ACTIONS(3375),
    [anon_sym_static] = ACTIONS(3375),
    [anon_sym_readonly] = ACTIONS(3375),
    [anon_sym_get] = ACTIONS(3375),
    [anon_sym_set] = ACTIONS(3375),
    [anon_sym_QMARK] = ACTIONS(3375),
    [anon_sym_any] = ACTIONS(3375),
    [anon_sym_number] = ACTIONS(3375),
    [anon_sym_boolean] = ACTIONS(3375),
    [anon_sym_string] = ACTIONS(3375),
    [anon_sym_symbol] = ACTIONS(3375),
    [anon_sym_abstract] = ACTIONS(3375),
    [anon_sym_satisfies] = ACTIONS(3375),
    [anon_sym_extends] = ACTIONS(3375),
    [anon_sym_infer] = ACTIONS(3375),
    [anon_sym_keyof] = ACTIONS(3375),
    [anon_sym_unknown] = ACTIONS(3375),
    [anon_sym_never] = ACTIONS(3375),
    [anon_sym_object] = ACTIONS(3375),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3377),
    [anon_sym_constructor] = ACTIONS(3375),
    [anon_sym_prop] = ACTIONS(3375),
    [anon_sym_id] = ACTIONS(3375),
    [anon_sym_event] = ACTIONS(3375),
    [anon_sym_fn] = ACTIONS(3375),
    [anon_sym_on] = ACTIONS(3375),
    [sym__ternary_qmark] = ACTIONS(3377),
  },
  [977] = {
    [sym_identifier] = ACTIONS(3379),
    [anon_sym_STAR] = ACTIONS(3379),
    [anon_sym_as] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3379),
    [anon_sym_RBRACE] = ACTIONS(3381),
    [anon_sym_typeof] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(3379),
    [anon_sym_LPAREN] = ACTIONS(3381),
    [anon_sym_in] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym_LBRACK] = ACTIONS(3381),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_GT] = ACTIONS(3379),
    [anon_sym_SLASH] = ACTIONS(3379),
    [anon_sym_DOT] = ACTIONS(3379),
    [anon_sym_async] = ACTIONS(3379),
    [anon_sym_QMARK_DOT] = ACTIONS(3381),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_AMP_AMP] = ACTIONS(3381),
    [anon_sym_PIPE_PIPE] = ACTIONS(3381),
    [anon_sym_GT_GT] = ACTIONS(3379),
    [anon_sym_GT_GT_GT] = ACTIONS(3381),
    [anon_sym_LT_LT] = ACTIONS(3381),
    [anon_sym_AMP] = ACTIONS(3110),
    [anon_sym_CARET] = ACTIONS(3381),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_PERCENT] = ACTIONS(3381),
    [anon_sym_STAR_STAR] = ACTIONS(3381),
    [anon_sym_LT_EQ] = ACTIONS(3381),
    [anon_sym_EQ_EQ] = ACTIONS(3379),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3381),
    [anon_sym_BANG_EQ] = ACTIONS(3379),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3381),
    [anon_sym_GT_EQ] = ACTIONS(3381),
    [anon_sym_QMARK_QMARK] = ACTIONS(3381),
    [anon_sym_instanceof] = ACTIONS(3379),
    [anon_sym_void] = ACTIONS(3379),
    [anon_sym_PLUS_PLUS] = ACTIONS(3381),
    [anon_sym_DASH_DASH] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(3381),
    [anon_sym_SQUOTE] = ACTIONS(3381),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3381),
    [sym_number] = ACTIONS(3381),
    [sym_this] = ACTIONS(3379),
    [sym_true] = ACTIONS(3379),
    [sym_false] = ACTIONS(3379),
    [sym_null] = ACTIONS(3379),
    [sym_undefined] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_readonly] = ACTIONS(3379),
    [anon_sym_get] = ACTIONS(3379),
    [anon_sym_set] = ACTIONS(3379),
    [anon_sym_QMARK] = ACTIONS(3379),
    [anon_sym_any] = ACTIONS(3379),
    [anon_sym_number] = ACTIONS(3379),
    [anon_sym_boolean] = ACTIONS(3379),
    [anon_sym_string] = ACTIONS(3379),
    [anon_sym_symbol] = ACTIONS(3379),
    [anon_sym_abstract] = ACTIONS(3379),
    [anon_sym_satisfies] = ACTIONS(3379),
    [anon_sym_extends] = ACTIONS(3160),
    [anon_sym_infer] = ACTIONS(3379),
    [anon_sym_keyof] = ACTIONS(3379),
    [anon_sym_unknown] = ACTIONS(3379),
    [anon_sym_never] = ACTIONS(3379),
    [anon_sym_object] = ACTIONS(3379),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3381),
    [anon_sym_constructor] = ACTIONS(3379),
    [anon_sym_prop] = ACTIONS(3379),
    [anon_sym_id] = ACTIONS(3379),
    [anon_sym_event] = ACTIONS(3379),
    [anon_sym_fn] = ACTIONS(3379),
    [anon_sym_on] = ACTIONS(3379),
    [sym__ternary_qmark] = ACTIONS(3381),
  },
  [978] = {
    [sym_identifier] = ACTIONS(3383),
    [anon_sym_STAR] = ACTIONS(3383),
    [anon_sym_as] = ACTIONS(3383),
    [anon_sym_LBRACE] = ACTIONS(3383),
    [anon_sym_RBRACE] = ACTIONS(3385),
    [anon_sym_typeof] = ACTIONS(3383),
    [anon_sym_BANG] = ACTIONS(3383),
    [anon_sym_LPAREN] = ACTIONS(3385),
    [anon_sym_in] = ACTIONS(3383),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym_EQ] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3385),
    [anon_sym_LT] = ACTIONS(3383),
    [anon_sym_GT] = ACTIONS(3383),
    [anon_sym_SLASH] = ACTIONS(3383),
    [anon_sym_DOT] = ACTIONS(3383),
    [anon_sym_async] = ACTIONS(3383),
    [anon_sym_QMARK_DOT] = ACTIONS(3385),
    [anon_sym_new] = ACTIONS(3383),
    [anon_sym_AMP_AMP] = ACTIONS(3385),
    [anon_sym_PIPE_PIPE] = ACTIONS(3385),
    [anon_sym_GT_GT] = ACTIONS(3383),
    [anon_sym_GT_GT_GT] = ACTIONS(3385),
    [anon_sym_LT_LT] = ACTIONS(3385),
    [anon_sym_AMP] = ACTIONS(3383),
    [anon_sym_CARET] = ACTIONS(3385),
    [anon_sym_PIPE] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3383),
    [anon_sym_DASH] = ACTIONS(3383),
    [anon_sym_PERCENT] = ACTIONS(3385),
    [anon_sym_STAR_STAR] = ACTIONS(3385),
    [anon_sym_LT_EQ] = ACTIONS(3385),
    [anon_sym_EQ_EQ] = ACTIONS(3383),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3385),
    [anon_sym_BANG_EQ] = ACTIONS(3383),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3385),
    [anon_sym_GT_EQ] = ACTIONS(3385),
    [anon_sym_QMARK_QMARK] = ACTIONS(3385),
    [anon_sym_instanceof] = ACTIONS(3383),
    [anon_sym_void] = ACTIONS(3383),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3385),
    [anon_sym_SQUOTE] = ACTIONS(3385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3385),
    [sym_number] = ACTIONS(3385),
    [sym_this] = ACTIONS(3383),
    [sym_true] = ACTIONS(3383),
    [sym_false] = ACTIONS(3383),
    [sym_null] = ACTIONS(3383),
    [sym_undefined] = ACTIONS(3383),
    [anon_sym_static] = ACTIONS(3383),
    [anon_sym_readonly] = ACTIONS(3383),
    [anon_sym_get] = ACTIONS(3383),
    [anon_sym_set] = ACTIONS(3383),
    [anon_sym_QMARK] = ACTIONS(3383),
    [anon_sym_any] = ACTIONS(3383),
    [anon_sym_number] = ACTIONS(3383),
    [anon_sym_boolean] = ACTIONS(3383),
    [anon_sym_string] = ACTIONS(3383),
    [anon_sym_symbol] = ACTIONS(3383),
    [anon_sym_abstract] = ACTIONS(3383),
    [anon_sym_satisfies] = ACTIONS(3383),
    [anon_sym_infer] = ACTIONS(3383),
    [anon_sym_keyof] = ACTIONS(3383),
    [anon_sym_unknown] = ACTIONS(3383),
    [anon_sym_never] = ACTIONS(3383),
    [anon_sym_object] = ACTIONS(3383),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3385),
    [anon_sym_constructor] = ACTIONS(3383),
    [anon_sym_prop] = ACTIONS(3383),
    [anon_sym_id] = ACTIONS(3383),
    [anon_sym_event] = ACTIONS(3383),
    [anon_sym_fn] = ACTIONS(3383),
    [anon_sym_on] = ACTIONS(3383),
    [sym__ternary_qmark] = ACTIONS(3385),
  },
  [979] = {
    [sym_identifier] = ACTIONS(3389),
    [anon_sym_STAR] = ACTIONS(3389),
    [anon_sym_as] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3389),
    [anon_sym_RBRACE] = ACTIONS(3391),
    [anon_sym_typeof] = ACTIONS(3389),
    [anon_sym_BANG] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3391),
    [anon_sym_in] = ACTIONS(3389),
    [anon_sym_SEMI] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3391),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_GT] = ACTIONS(3389),
    [anon_sym_SLASH] = ACTIONS(3389),
    [anon_sym_DOT] = ACTIONS(3389),
    [anon_sym_async] = ACTIONS(3389),
    [anon_sym_QMARK_DOT] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3389),
    [anon_sym_AMP_AMP] = ACTIONS(3391),
    [anon_sym_PIPE_PIPE] = ACTIONS(3391),
    [anon_sym_GT_GT] = ACTIONS(3389),
    [anon_sym_GT_GT_GT] = ACTIONS(3391),
    [anon_sym_LT_LT] = ACTIONS(3391),
    [anon_sym_AMP] = ACTIONS(3389),
    [anon_sym_CARET] = ACTIONS(3391),
    [anon_sym_PIPE] = ACTIONS(3389),
    [anon_sym_PLUS] = ACTIONS(3389),
    [anon_sym_DASH] = ACTIONS(3389),
    [anon_sym_PERCENT] = ACTIONS(3391),
    [anon_sym_STAR_STAR] = ACTIONS(3391),
    [anon_sym_LT_EQ] = ACTIONS(3391),
    [anon_sym_EQ_EQ] = ACTIONS(3389),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3391),
    [anon_sym_BANG_EQ] = ACTIONS(3389),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3391),
    [anon_sym_GT_EQ] = ACTIONS(3391),
    [anon_sym_QMARK_QMARK] = ACTIONS(3391),
    [anon_sym_instanceof] = ACTIONS(3389),
    [anon_sym_void] = ACTIONS(3389),
    [anon_sym_PLUS_PLUS] = ACTIONS(3391),
    [anon_sym_DASH_DASH] = ACTIONS(3391),
    [anon_sym_DQUOTE] = ACTIONS(3391),
    [anon_sym_SQUOTE] = ACTIONS(3391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3391),
    [sym_number] = ACTIONS(3391),
    [sym_this] = ACTIONS(3389),
    [sym_true] = ACTIONS(3389),
    [sym_false] = ACTIONS(3389),
    [sym_null] = ACTIONS(3389),
    [sym_undefined] = ACTIONS(3389),
    [anon_sym_static] = ACTIONS(3389),
    [anon_sym_readonly] = ACTIONS(3389),
    [anon_sym_get] = ACTIONS(3389),
    [anon_sym_set] = ACTIONS(3389),
    [anon_sym_QMARK] = ACTIONS(3389),
    [anon_sym_any] = ACTIONS(3389),
    [anon_sym_number] = ACTIONS(3389),
    [anon_sym_boolean] = ACTIONS(3389),
    [anon_sym_string] = ACTIONS(3389),
    [anon_sym_symbol] = ACTIONS(3389),
    [anon_sym_abstract] = ACTIONS(3389),
    [anon_sym_satisfies] = ACTIONS(3389),
    [anon_sym_extends] = ACTIONS(3389),
    [anon_sym_infer] = ACTIONS(3389),
    [anon_sym_keyof] = ACTIONS(3389),
    [anon_sym_unknown] = ACTIONS(3389),
    [anon_sym_never] = ACTIONS(3389),
    [anon_sym_object] = ACTIONS(3389),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3391),
    [anon_sym_constructor] = ACTIONS(3389),
    [anon_sym_prop] = ACTIONS(3389),
    [anon_sym_id] = ACTIONS(3389),
    [anon_sym_event] = ACTIONS(3389),
    [anon_sym_fn] = ACTIONS(3389),
    [anon_sym_on] = ACTIONS(3389),
    [sym__ternary_qmark] = ACTIONS(3391),
  },
  [980] = {
    [sym_identifier] = ACTIONS(3393),
    [anon_sym_STAR] = ACTIONS(3393),
    [anon_sym_as] = ACTIONS(3393),
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_RBRACE] = ACTIONS(3395),
    [anon_sym_typeof] = ACTIONS(3393),
    [anon_sym_BANG] = ACTIONS(3393),
    [anon_sym_LPAREN] = ACTIONS(3395),
    [anon_sym_in] = ACTIONS(3393),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_LT] = ACTIONS(3393),
    [anon_sym_GT] = ACTIONS(3393),
    [anon_sym_SLASH] = ACTIONS(3393),
    [anon_sym_DOT] = ACTIONS(3393),
    [anon_sym_async] = ACTIONS(3393),
    [anon_sym_QMARK_DOT] = ACTIONS(3395),
    [anon_sym_new] = ACTIONS(3393),
    [anon_sym_AMP_AMP] = ACTIONS(3395),
    [anon_sym_PIPE_PIPE] = ACTIONS(3395),
    [anon_sym_GT_GT] = ACTIONS(3393),
    [anon_sym_GT_GT_GT] = ACTIONS(3395),
    [anon_sym_LT_LT] = ACTIONS(3395),
    [anon_sym_AMP] = ACTIONS(3110),
    [anon_sym_CARET] = ACTIONS(3395),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_PLUS] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3393),
    [anon_sym_PERCENT] = ACTIONS(3395),
    [anon_sym_STAR_STAR] = ACTIONS(3395),
    [anon_sym_LT_EQ] = ACTIONS(3395),
    [anon_sym_EQ_EQ] = ACTIONS(3393),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3395),
    [anon_sym_BANG_EQ] = ACTIONS(3393),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3395),
    [anon_sym_GT_EQ] = ACTIONS(3395),
    [anon_sym_QMARK_QMARK] = ACTIONS(3395),
    [anon_sym_instanceof] = ACTIONS(3393),
    [anon_sym_void] = ACTIONS(3393),
    [anon_sym_PLUS_PLUS] = ACTIONS(3395),
    [anon_sym_DASH_DASH] = ACTIONS(3395),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [anon_sym_SQUOTE] = ACTIONS(3395),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3395),
    [sym_number] = ACTIONS(3395),
    [sym_this] = ACTIONS(3393),
    [sym_true] = ACTIONS(3393),
    [sym_false] = ACTIONS(3393),
    [sym_null] = ACTIONS(3393),
    [sym_undefined] = ACTIONS(3393),
    [anon_sym_static] = ACTIONS(3393),
    [anon_sym_readonly] = ACTIONS(3393),
    [anon_sym_get] = ACTIONS(3393),
    [anon_sym_set] = ACTIONS(3393),
    [anon_sym_QMARK] = ACTIONS(3393),
    [anon_sym_any] = ACTIONS(3393),
    [anon_sym_number] = ACTIONS(3393),
    [anon_sym_boolean] = ACTIONS(3393),
    [anon_sym_string] = ACTIONS(3393),
    [anon_sym_symbol] = ACTIONS(3393),
    [anon_sym_abstract] = ACTIONS(3393),
    [anon_sym_satisfies] = ACTIONS(3393),
    [anon_sym_extends] = ACTIONS(3160),
    [anon_sym_infer] = ACTIONS(3393),
    [anon_sym_keyof] = ACTIONS(3393),
    [anon_sym_unknown] = ACTIONS(3393),
    [anon_sym_never] = ACTIONS(3393),
    [anon_sym_object] = ACTIONS(3393),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3395),
    [anon_sym_constructor] = ACTIONS(3393),
    [anon_sym_prop] = ACTIONS(3393),
    [anon_sym_id] = ACTIONS(3393),
    [anon_sym_event] = ACTIONS(3393),
    [anon_sym_fn] = ACTIONS(3393),
    [anon_sym_on] = ACTIONS(3393),
    [sym__ternary_qmark] = ACTIONS(3395),
  },
  [981] = {
    [sym_identifier] = ACTIONS(1424),
    [anon_sym_STAR] = ACTIONS(1424),
    [anon_sym_as] = ACTIONS(1424),
    [anon_sym_LBRACE] = ACTIONS(1424),
    [anon_sym_RBRACE] = ACTIONS(1428),
    [anon_sym_typeof] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(1424),
    [anon_sym_LPAREN] = ACTIONS(1428),
    [anon_sym_in] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1428),
    [anon_sym_LBRACK] = ACTIONS(1428),
    [anon_sym_LT] = ACTIONS(1424),
    [anon_sym_GT] = ACTIONS(1424),
    [anon_sym_SLASH] = ACTIONS(1424),
    [anon_sym_DOT] = ACTIONS(1424),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_QMARK_DOT] = ACTIONS(1428),
    [anon_sym_new] = ACTIONS(1424),
    [anon_sym_AMP_AMP] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1428),
    [anon_sym_GT_GT] = ACTIONS(1424),
    [anon_sym_GT_GT_GT] = ACTIONS(1428),
    [anon_sym_LT_LT] = ACTIONS(1428),
    [anon_sym_AMP] = ACTIONS(1424),
    [anon_sym_CARET] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1424),
    [anon_sym_PLUS] = ACTIONS(1424),
    [anon_sym_DASH] = ACTIONS(1424),
    [anon_sym_PERCENT] = ACTIONS(1428),
    [anon_sym_STAR_STAR] = ACTIONS(1428),
    [anon_sym_LT_EQ] = ACTIONS(1428),
    [anon_sym_EQ_EQ] = ACTIONS(1424),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1428),
    [anon_sym_BANG_EQ] = ACTIONS(1424),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1428),
    [anon_sym_GT_EQ] = ACTIONS(1428),
    [anon_sym_QMARK_QMARK] = ACTIONS(1428),
    [anon_sym_instanceof] = ACTIONS(1424),
    [anon_sym_void] = ACTIONS(1424),
    [anon_sym_PLUS_PLUS] = ACTIONS(1428),
    [anon_sym_DASH_DASH] = ACTIONS(1428),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [anon_sym_SQUOTE] = ACTIONS(1428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1428),
    [sym_number] = ACTIONS(1428),
    [sym_this] = ACTIONS(1424),
    [sym_true] = ACTIONS(1424),
    [sym_false] = ACTIONS(1424),
    [sym_null] = ACTIONS(1424),
    [sym_undefined] = ACTIONS(1424),
    [anon_sym_static] = ACTIONS(1424),
    [anon_sym_readonly] = ACTIONS(1424),
    [anon_sym_get] = ACTIONS(1424),
    [anon_sym_set] = ACTIONS(1424),
    [anon_sym_QMARK] = ACTIONS(1424),
    [anon_sym_any] = ACTIONS(1424),
    [anon_sym_number] = ACTIONS(1424),
    [anon_sym_boolean] = ACTIONS(1424),
    [anon_sym_string] = ACTIONS(1424),
    [anon_sym_symbol] = ACTIONS(1424),
    [anon_sym_abstract] = ACTIONS(1424),
    [anon_sym_satisfies] = ACTIONS(1424),
    [anon_sym_infer] = ACTIONS(1424),
    [anon_sym_keyof] = ACTIONS(1424),
    [anon_sym_unknown] = ACTIONS(1424),
    [anon_sym_never] = ACTIONS(1424),
    [anon_sym_object] = ACTIONS(1424),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1428),
    [anon_sym_constructor] = ACTIONS(1424),
    [anon_sym_prop] = ACTIONS(1424),
    [anon_sym_id] = ACTIONS(1424),
    [anon_sym_event] = ACTIONS(1424),
    [anon_sym_fn] = ACTIONS(1424),
    [anon_sym_on] = ACTIONS(1424),
    [sym__ternary_qmark] = ACTIONS(1428),
  },
  [982] = {
    [sym_identifier] = ACTIONS(3397),
    [anon_sym_STAR] = ACTIONS(3397),
    [anon_sym_as] = ACTIONS(3397),
    [anon_sym_LBRACE] = ACTIONS(3397),
    [anon_sym_RBRACE] = ACTIONS(3399),
    [anon_sym_typeof] = ACTIONS(3397),
    [anon_sym_BANG] = ACTIONS(3397),
    [anon_sym_LPAREN] = ACTIONS(3399),
    [anon_sym_in] = ACTIONS(3397),
    [anon_sym_SEMI] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_LT] = ACTIONS(3397),
    [anon_sym_GT] = ACTIONS(3397),
    [anon_sym_SLASH] = ACTIONS(3397),
    [anon_sym_DOT] = ACTIONS(3397),
    [anon_sym_async] = ACTIONS(3397),
    [anon_sym_QMARK_DOT] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3397),
    [anon_sym_AMP_AMP] = ACTIONS(3399),
    [anon_sym_PIPE_PIPE] = ACTIONS(3399),
    [anon_sym_GT_GT] = ACTIONS(3397),
    [anon_sym_GT_GT_GT] = ACTIONS(3399),
    [anon_sym_LT_LT] = ACTIONS(3399),
    [anon_sym_AMP] = ACTIONS(3397),
    [anon_sym_CARET] = ACTIONS(3399),
    [anon_sym_PIPE] = ACTIONS(3397),
    [anon_sym_PLUS] = ACTIONS(3397),
    [anon_sym_DASH] = ACTIONS(3397),
    [anon_sym_PERCENT] = ACTIONS(3399),
    [anon_sym_STAR_STAR] = ACTIONS(3399),
    [anon_sym_LT_EQ] = ACTIONS(3399),
    [anon_sym_EQ_EQ] = ACTIONS(3397),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3399),
    [anon_sym_BANG_EQ] = ACTIONS(3397),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3399),
    [anon_sym_GT_EQ] = ACTIONS(3399),
    [anon_sym_QMARK_QMARK] = ACTIONS(3399),
    [anon_sym_instanceof] = ACTIONS(3397),
    [anon_sym_void] = ACTIONS(3397),
    [anon_sym_PLUS_PLUS] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3399),
    [anon_sym_DQUOTE] = ACTIONS(3399),
    [anon_sym_SQUOTE] = ACTIONS(3399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3399),
    [sym_number] = ACTIONS(3399),
    [sym_this] = ACTIONS(3397),
    [sym_true] = ACTIONS(3397),
    [sym_false] = ACTIONS(3397),
    [sym_null] = ACTIONS(3397),
    [sym_undefined] = ACTIONS(3397),
    [anon_sym_static] = ACTIONS(3397),
    [anon_sym_readonly] = ACTIONS(3397),
    [anon_sym_get] = ACTIONS(3397),
    [anon_sym_set] = ACTIONS(3397),
    [anon_sym_QMARK] = ACTIONS(3397),
    [anon_sym_any] = ACTIONS(3397),
    [anon_sym_number] = ACTIONS(3397),
    [anon_sym_boolean] = ACTIONS(3397),
    [anon_sym_string] = ACTIONS(3397),
    [anon_sym_symbol] = ACTIONS(3397),
    [anon_sym_abstract] = ACTIONS(3397),
    [anon_sym_satisfies] = ACTIONS(3397),
    [anon_sym_infer] = ACTIONS(3397),
    [anon_sym_keyof] = ACTIONS(3397),
    [anon_sym_unknown] = ACTIONS(3397),
    [anon_sym_never] = ACTIONS(3397),
    [anon_sym_object] = ACTIONS(3397),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3399),
    [anon_sym_constructor] = ACTIONS(3397),
    [anon_sym_prop] = ACTIONS(3397),
    [anon_sym_id] = ACTIONS(3397),
    [anon_sym_event] = ACTIONS(3397),
    [anon_sym_fn] = ACTIONS(3397),
    [anon_sym_on] = ACTIONS(3397),
    [sym__ternary_qmark] = ACTIONS(3399),
  },
  [983] = {
    [sym_identifier] = ACTIONS(1658),
    [anon_sym_STAR] = ACTIONS(1658),
    [anon_sym_as] = ACTIONS(1658),
    [anon_sym_LBRACE] = ACTIONS(1658),
    [anon_sym_RBRACE] = ACTIONS(1662),
    [anon_sym_typeof] = ACTIONS(1658),
    [anon_sym_BANG] = ACTIONS(1658),
    [anon_sym_LPAREN] = ACTIONS(1662),
    [anon_sym_in] = ACTIONS(1658),
    [anon_sym_SEMI] = ACTIONS(1662),
    [anon_sym_LBRACK] = ACTIONS(1662),
    [anon_sym_LT] = ACTIONS(1658),
    [anon_sym_GT] = ACTIONS(1658),
    [anon_sym_SLASH] = ACTIONS(1658),
    [anon_sym_DOT] = ACTIONS(1658),
    [anon_sym_async] = ACTIONS(1658),
    [anon_sym_QMARK_DOT] = ACTIONS(1662),
    [anon_sym_new] = ACTIONS(1658),
    [anon_sym_AMP_AMP] = ACTIONS(1662),
    [anon_sym_PIPE_PIPE] = ACTIONS(1662),
    [anon_sym_GT_GT] = ACTIONS(1658),
    [anon_sym_GT_GT_GT] = ACTIONS(1662),
    [anon_sym_LT_LT] = ACTIONS(1662),
    [anon_sym_AMP] = ACTIONS(1658),
    [anon_sym_CARET] = ACTIONS(1662),
    [anon_sym_PIPE] = ACTIONS(1658),
    [anon_sym_PLUS] = ACTIONS(1658),
    [anon_sym_DASH] = ACTIONS(1658),
    [anon_sym_PERCENT] = ACTIONS(1662),
    [anon_sym_STAR_STAR] = ACTIONS(1662),
    [anon_sym_LT_EQ] = ACTIONS(1662),
    [anon_sym_EQ_EQ] = ACTIONS(1658),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1662),
    [anon_sym_BANG_EQ] = ACTIONS(1658),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1662),
    [anon_sym_GT_EQ] = ACTIONS(1662),
    [anon_sym_QMARK_QMARK] = ACTIONS(1662),
    [anon_sym_instanceof] = ACTIONS(1658),
    [anon_sym_void] = ACTIONS(1658),
    [anon_sym_PLUS_PLUS] = ACTIONS(1662),
    [anon_sym_DASH_DASH] = ACTIONS(1662),
    [anon_sym_DQUOTE] = ACTIONS(1662),
    [anon_sym_SQUOTE] = ACTIONS(1662),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1662),
    [sym_number] = ACTIONS(1662),
    [sym_this] = ACTIONS(1658),
    [sym_true] = ACTIONS(1658),
    [sym_false] = ACTIONS(1658),
    [sym_null] = ACTIONS(1658),
    [sym_undefined] = ACTIONS(1658),
    [anon_sym_static] = ACTIONS(1658),
    [anon_sym_readonly] = ACTIONS(1658),
    [anon_sym_get] = ACTIONS(1658),
    [anon_sym_set] = ACTIONS(1658),
    [anon_sym_QMARK] = ACTIONS(1658),
    [anon_sym_any] = ACTIONS(1658),
    [anon_sym_number] = ACTIONS(1658),
    [anon_sym_boolean] = ACTIONS(1658),
    [anon_sym_string] = ACTIONS(1658),
    [anon_sym_symbol] = ACTIONS(1658),
    [anon_sym_abstract] = ACTIONS(1658),
    [anon_sym_satisfies] = ACTIONS(1658),
    [anon_sym_infer] = ACTIONS(1658),
    [anon_sym_keyof] = ACTIONS(1658),
    [anon_sym_unknown] = ACTIONS(1658),
    [anon_sym_never] = ACTIONS(1658),
    [anon_sym_object] = ACTIONS(1658),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1662),
    [anon_sym_constructor] = ACTIONS(1658),
    [anon_sym_prop] = ACTIONS(1658),
    [anon_sym_id] = ACTIONS(1658),
    [anon_sym_event] = ACTIONS(1658),
    [anon_sym_fn] = ACTIONS(1658),
    [anon_sym_on] = ACTIONS(1658),
    [sym__ternary_qmark] = ACTIONS(1662),
  },
  [984] = {
    [sym_identifier] = ACTIONS(3401),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_as] = ACTIONS(3401),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_RBRACE] = ACTIONS(3403),
    [anon_sym_typeof] = ACTIONS(3401),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_LPAREN] = ACTIONS(3403),
    [anon_sym_in] = ACTIONS(3401),
    [anon_sym_SEMI] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3403),
    [anon_sym_LT] = ACTIONS(3401),
    [anon_sym_GT] = ACTIONS(3401),
    [anon_sym_SLASH] = ACTIONS(3401),
    [anon_sym_DOT] = ACTIONS(3401),
    [anon_sym_async] = ACTIONS(3401),
    [anon_sym_QMARK_DOT] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3401),
    [anon_sym_AMP_AMP] = ACTIONS(3403),
    [anon_sym_PIPE_PIPE] = ACTIONS(3403),
    [anon_sym_GT_GT] = ACTIONS(3401),
    [anon_sym_GT_GT_GT] = ACTIONS(3403),
    [anon_sym_LT_LT] = ACTIONS(3403),
    [anon_sym_AMP] = ACTIONS(3401),
    [anon_sym_CARET] = ACTIONS(3403),
    [anon_sym_PIPE] = ACTIONS(3401),
    [anon_sym_PLUS] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3401),
    [anon_sym_PERCENT] = ACTIONS(3403),
    [anon_sym_STAR_STAR] = ACTIONS(3403),
    [anon_sym_LT_EQ] = ACTIONS(3403),
    [anon_sym_EQ_EQ] = ACTIONS(3401),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3403),
    [anon_sym_BANG_EQ] = ACTIONS(3401),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3403),
    [anon_sym_GT_EQ] = ACTIONS(3403),
    [anon_sym_QMARK_QMARK] = ACTIONS(3403),
    [anon_sym_instanceof] = ACTIONS(3401),
    [anon_sym_void] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3403),
    [anon_sym_DASH_DASH] = ACTIONS(3403),
    [anon_sym_DQUOTE] = ACTIONS(3403),
    [anon_sym_SQUOTE] = ACTIONS(3403),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3403),
    [sym_number] = ACTIONS(3403),
    [sym_this] = ACTIONS(3401),
    [sym_true] = ACTIONS(3401),
    [sym_false] = ACTIONS(3401),
    [sym_null] = ACTIONS(3401),
    [sym_undefined] = ACTIONS(3401),
    [anon_sym_static] = ACTIONS(3401),
    [anon_sym_readonly] = ACTIONS(3401),
    [anon_sym_get] = ACTIONS(3401),
    [anon_sym_set] = ACTIONS(3401),
    [anon_sym_QMARK] = ACTIONS(3401),
    [anon_sym_any] = ACTIONS(3401),
    [anon_sym_number] = ACTIONS(3401),
    [anon_sym_boolean] = ACTIONS(3401),
    [anon_sym_string] = ACTIONS(3401),
    [anon_sym_symbol] = ACTIONS(3401),
    [anon_sym_abstract] = ACTIONS(3401),
    [anon_sym_satisfies] = ACTIONS(3401),
    [anon_sym_infer] = ACTIONS(3401),
    [anon_sym_keyof] = ACTIONS(3401),
    [anon_sym_unknown] = ACTIONS(3401),
    [anon_sym_never] = ACTIONS(3401),
    [anon_sym_object] = ACTIONS(3401),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3403),
    [anon_sym_constructor] = ACTIONS(3401),
    [anon_sym_prop] = ACTIONS(3401),
    [anon_sym_id] = ACTIONS(3401),
    [anon_sym_event] = ACTIONS(3401),
    [anon_sym_fn] = ACTIONS(3401),
    [anon_sym_on] = ACTIONS(3401),
    [sym__ternary_qmark] = ACTIONS(3403),
  },
  [985] = {
    [sym_identifier] = ACTIONS(3405),
    [anon_sym_STAR] = ACTIONS(3405),
    [anon_sym_as] = ACTIONS(3405),
    [anon_sym_LBRACE] = ACTIONS(3405),
    [anon_sym_RBRACE] = ACTIONS(3407),
    [anon_sym_typeof] = ACTIONS(3405),
    [anon_sym_BANG] = ACTIONS(3405),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_in] = ACTIONS(3405),
    [anon_sym_SEMI] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LT] = ACTIONS(3405),
    [anon_sym_GT] = ACTIONS(3405),
    [anon_sym_SLASH] = ACTIONS(3405),
    [anon_sym_DOT] = ACTIONS(3405),
    [anon_sym_async] = ACTIONS(3405),
    [anon_sym_QMARK_DOT] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(3405),
    [anon_sym_AMP_AMP] = ACTIONS(3407),
    [anon_sym_PIPE_PIPE] = ACTIONS(3407),
    [anon_sym_GT_GT] = ACTIONS(3405),
    [anon_sym_GT_GT_GT] = ACTIONS(3407),
    [anon_sym_LT_LT] = ACTIONS(3407),
    [anon_sym_AMP] = ACTIONS(3405),
    [anon_sym_CARET] = ACTIONS(3407),
    [anon_sym_PIPE] = ACTIONS(3405),
    [anon_sym_PLUS] = ACTIONS(3405),
    [anon_sym_DASH] = ACTIONS(3405),
    [anon_sym_PERCENT] = ACTIONS(3407),
    [anon_sym_STAR_STAR] = ACTIONS(3407),
    [anon_sym_LT_EQ] = ACTIONS(3407),
    [anon_sym_EQ_EQ] = ACTIONS(3405),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3407),
    [anon_sym_BANG_EQ] = ACTIONS(3405),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3407),
    [anon_sym_GT_EQ] = ACTIONS(3407),
    [anon_sym_QMARK_QMARK] = ACTIONS(3407),
    [anon_sym_instanceof] = ACTIONS(3405),
    [anon_sym_void] = ACTIONS(3405),
    [anon_sym_PLUS_PLUS] = ACTIONS(3407),
    [anon_sym_DASH_DASH] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_SQUOTE] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3407),
    [sym_number] = ACTIONS(3407),
    [sym_this] = ACTIONS(3405),
    [sym_true] = ACTIONS(3405),
    [sym_false] = ACTIONS(3405),
    [sym_null] = ACTIONS(3405),
    [sym_undefined] = ACTIONS(3405),
    [anon_sym_static] = ACTIONS(3405),
    [anon_sym_readonly] = ACTIONS(3405),
    [anon_sym_get] = ACTIONS(3405),
    [anon_sym_set] = ACTIONS(3405),
    [anon_sym_QMARK] = ACTIONS(3405),
    [anon_sym_any] = ACTIONS(3405),
    [anon_sym_number] = ACTIONS(3405),
    [anon_sym_boolean] = ACTIONS(3405),
    [anon_sym_string] = ACTIONS(3405),
    [anon_sym_symbol] = ACTIONS(3405),
    [anon_sym_abstract] = ACTIONS(3405),
    [anon_sym_satisfies] = ACTIONS(3405),
    [anon_sym_infer] = ACTIONS(3405),
    [anon_sym_keyof] = ACTIONS(3405),
    [anon_sym_unknown] = ACTIONS(3405),
    [anon_sym_never] = ACTIONS(3405),
    [anon_sym_object] = ACTIONS(3405),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3407),
    [anon_sym_constructor] = ACTIONS(3405),
    [anon_sym_prop] = ACTIONS(3405),
    [anon_sym_id] = ACTIONS(3405),
    [anon_sym_event] = ACTIONS(3405),
    [anon_sym_fn] = ACTIONS(3405),
    [anon_sym_on] = ACTIONS(3405),
    [sym__ternary_qmark] = ACTIONS(3407),
  },
  [986] = {
    [sym_identifier] = ACTIONS(3409),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_as] = ACTIONS(3409),
    [anon_sym_LBRACE] = ACTIONS(3409),
    [anon_sym_RBRACE] = ACTIONS(3411),
    [anon_sym_typeof] = ACTIONS(3409),
    [anon_sym_BANG] = ACTIONS(3409),
    [anon_sym_LPAREN] = ACTIONS(3411),
    [anon_sym_in] = ACTIONS(3409),
    [anon_sym_SEMI] = ACTIONS(3411),
    [anon_sym_LBRACK] = ACTIONS(3411),
    [anon_sym_LT] = ACTIONS(3409),
    [anon_sym_GT] = ACTIONS(3409),
    [anon_sym_SLASH] = ACTIONS(3409),
    [anon_sym_DOT] = ACTIONS(3409),
    [anon_sym_async] = ACTIONS(3409),
    [anon_sym_QMARK_DOT] = ACTIONS(3411),
    [anon_sym_new] = ACTIONS(3409),
    [anon_sym_AMP_AMP] = ACTIONS(3411),
    [anon_sym_PIPE_PIPE] = ACTIONS(3411),
    [anon_sym_GT_GT] = ACTIONS(3409),
    [anon_sym_GT_GT_GT] = ACTIONS(3411),
    [anon_sym_LT_LT] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_CARET] = ACTIONS(3411),
    [anon_sym_PIPE] = ACTIONS(3409),
    [anon_sym_PLUS] = ACTIONS(3409),
    [anon_sym_DASH] = ACTIONS(3409),
    [anon_sym_PERCENT] = ACTIONS(3411),
    [anon_sym_STAR_STAR] = ACTIONS(3411),
    [anon_sym_LT_EQ] = ACTIONS(3411),
    [anon_sym_EQ_EQ] = ACTIONS(3409),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3411),
    [anon_sym_BANG_EQ] = ACTIONS(3409),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3411),
    [anon_sym_GT_EQ] = ACTIONS(3411),
    [anon_sym_QMARK_QMARK] = ACTIONS(3411),
    [anon_sym_instanceof] = ACTIONS(3409),
    [anon_sym_void] = ACTIONS(3409),
    [anon_sym_PLUS_PLUS] = ACTIONS(3411),
    [anon_sym_DASH_DASH] = ACTIONS(3411),
    [anon_sym_DQUOTE] = ACTIONS(3411),
    [anon_sym_SQUOTE] = ACTIONS(3411),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3411),
    [sym_number] = ACTIONS(3411),
    [sym_this] = ACTIONS(3409),
    [sym_true] = ACTIONS(3409),
    [sym_false] = ACTIONS(3409),
    [sym_null] = ACTIONS(3409),
    [sym_undefined] = ACTIONS(3409),
    [anon_sym_static] = ACTIONS(3409),
    [anon_sym_readonly] = ACTIONS(3409),
    [anon_sym_get] = ACTIONS(3409),
    [anon_sym_set] = ACTIONS(3409),
    [anon_sym_QMARK] = ACTIONS(3409),
    [anon_sym_any] = ACTIONS(3409),
    [anon_sym_number] = ACTIONS(3409),
    [anon_sym_boolean] = ACTIONS(3409),
    [anon_sym_string] = ACTIONS(3409),
    [anon_sym_symbol] = ACTIONS(3409),
    [anon_sym_abstract] = ACTIONS(3409),
    [anon_sym_satisfies] = ACTIONS(3409),
    [anon_sym_infer] = ACTIONS(3409),
    [anon_sym_keyof] = ACTIONS(3409),
    [anon_sym_unknown] = ACTIONS(3409),
    [anon_sym_never] = ACTIONS(3409),
    [anon_sym_object] = ACTIONS(3409),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3411),
    [anon_sym_constructor] = ACTIONS(3409),
    [anon_sym_prop] = ACTIONS(3409),
    [anon_sym_id] = ACTIONS(3409),
    [anon_sym_event] = ACTIONS(3409),
    [anon_sym_fn] = ACTIONS(3409),
    [anon_sym_on] = ACTIONS(3409),
    [sym__ternary_qmark] = ACTIONS(3411),
  },
  [987] = {
    [sym_identifier] = ACTIONS(3413),
    [anon_sym_STAR] = ACTIONS(3413),
    [anon_sym_as] = ACTIONS(3413),
    [anon_sym_LBRACE] = ACTIONS(3413),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_typeof] = ACTIONS(3413),
    [anon_sym_BANG] = ACTIONS(3413),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_in] = ACTIONS(3413),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3413),
    [anon_sym_GT] = ACTIONS(3413),
    [anon_sym_SLASH] = ACTIONS(3413),
    [anon_sym_DOT] = ACTIONS(3413),
    [anon_sym_async] = ACTIONS(3413),
    [anon_sym_QMARK_DOT] = ACTIONS(3415),
    [anon_sym_new] = ACTIONS(3413),
    [anon_sym_AMP_AMP] = ACTIONS(3415),
    [anon_sym_PIPE_PIPE] = ACTIONS(3415),
    [anon_sym_GT_GT] = ACTIONS(3413),
    [anon_sym_GT_GT_GT] = ACTIONS(3415),
    [anon_sym_LT_LT] = ACTIONS(3415),
    [anon_sym_AMP] = ACTIONS(3413),
    [anon_sym_CARET] = ACTIONS(3415),
    [anon_sym_PIPE] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3413),
    [anon_sym_DASH] = ACTIONS(3413),
    [anon_sym_PERCENT] = ACTIONS(3415),
    [anon_sym_STAR_STAR] = ACTIONS(3415),
    [anon_sym_LT_EQ] = ACTIONS(3415),
    [anon_sym_EQ_EQ] = ACTIONS(3413),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(3413),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3415),
    [anon_sym_GT_EQ] = ACTIONS(3415),
    [anon_sym_QMARK_QMARK] = ACTIONS(3415),
    [anon_sym_instanceof] = ACTIONS(3413),
    [anon_sym_void] = ACTIONS(3413),
    [anon_sym_PLUS_PLUS] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3415),
    [anon_sym_DQUOTE] = ACTIONS(3415),
    [anon_sym_SQUOTE] = ACTIONS(3415),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3415),
    [sym_number] = ACTIONS(3415),
    [sym_this] = ACTIONS(3413),
    [sym_true] = ACTIONS(3413),
    [sym_false] = ACTIONS(3413),
    [sym_null] = ACTIONS(3413),
    [sym_undefined] = ACTIONS(3413),
    [anon_sym_static] = ACTIONS(3413),
    [anon_sym_readonly] = ACTIONS(3413),
    [anon_sym_get] = ACTIONS(3413),
    [anon_sym_set] = ACTIONS(3413),
    [anon_sym_QMARK] = ACTIONS(3413),
    [anon_sym_any] = ACTIONS(3413),
    [anon_sym_number] = ACTIONS(3413),
    [anon_sym_boolean] = ACTIONS(3413),
    [anon_sym_string] = ACTIONS(3413),
    [anon_sym_symbol] = ACTIONS(3413),
    [anon_sym_abstract] = ACTIONS(3413),
    [anon_sym_satisfies] = ACTIONS(3413),
    [anon_sym_infer] = ACTIONS(3413),
    [anon_sym_keyof] = ACTIONS(3413),
    [anon_sym_unknown] = ACTIONS(3413),
    [anon_sym_never] = ACTIONS(3413),
    [anon_sym_object] = ACTIONS(3413),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3415),
    [anon_sym_constructor] = ACTIONS(3413),
    [anon_sym_prop] = ACTIONS(3413),
    [anon_sym_id] = ACTIONS(3413),
    [anon_sym_event] = ACTIONS(3413),
    [anon_sym_fn] = ACTIONS(3413),
    [anon_sym_on] = ACTIONS(3413),
    [sym__ternary_qmark] = ACTIONS(3415),
  },
  [988] = {
    [sym_identifier] = ACTIONS(3417),
    [anon_sym_STAR] = ACTIONS(3417),
    [anon_sym_as] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(3419),
    [anon_sym_typeof] = ACTIONS(3417),
    [anon_sym_BANG] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_in] = ACTIONS(3417),
    [anon_sym_SEMI] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LT] = ACTIONS(3417),
    [anon_sym_GT] = ACTIONS(3417),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(3417),
    [anon_sym_async] = ACTIONS(3417),
    [anon_sym_QMARK_DOT] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_AMP_AMP] = ACTIONS(3419),
    [anon_sym_PIPE_PIPE] = ACTIONS(3419),
    [anon_sym_GT_GT] = ACTIONS(3417),
    [anon_sym_GT_GT_GT] = ACTIONS(3419),
    [anon_sym_LT_LT] = ACTIONS(3419),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_CARET] = ACTIONS(3419),
    [anon_sym_PIPE] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_PERCENT] = ACTIONS(3419),
    [anon_sym_STAR_STAR] = ACTIONS(3419),
    [anon_sym_LT_EQ] = ACTIONS(3419),
    [anon_sym_EQ_EQ] = ACTIONS(3417),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3419),
    [anon_sym_BANG_EQ] = ACTIONS(3417),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3419),
    [anon_sym_GT_EQ] = ACTIONS(3419),
    [anon_sym_QMARK_QMARK] = ACTIONS(3419),
    [anon_sym_instanceof] = ACTIONS(3417),
    [anon_sym_void] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3419),
    [anon_sym_DASH_DASH] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3419),
    [sym_number] = ACTIONS(3419),
    [sym_this] = ACTIONS(3417),
    [sym_true] = ACTIONS(3417),
    [sym_false] = ACTIONS(3417),
    [sym_null] = ACTIONS(3417),
    [sym_undefined] = ACTIONS(3417),
    [anon_sym_static] = ACTIONS(3417),
    [anon_sym_readonly] = ACTIONS(3417),
    [anon_sym_get] = ACTIONS(3417),
    [anon_sym_set] = ACTIONS(3417),
    [anon_sym_QMARK] = ACTIONS(3417),
    [anon_sym_any] = ACTIONS(3417),
    [anon_sym_number] = ACTIONS(3417),
    [anon_sym_boolean] = ACTIONS(3417),
    [anon_sym_string] = ACTIONS(3417),
    [anon_sym_symbol] = ACTIONS(3417),
    [anon_sym_abstract] = ACTIONS(3417),
    [anon_sym_satisfies] = ACTIONS(3417),
    [anon_sym_infer] = ACTIONS(3417),
    [anon_sym_keyof] = ACTIONS(3417),
    [anon_sym_unknown] = ACTIONS(3417),
    [anon_sym_never] = ACTIONS(3417),
    [anon_sym_object] = ACTIONS(3417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3419),
    [anon_sym_constructor] = ACTIONS(3417),
    [anon_sym_prop] = ACTIONS(3417),
    [anon_sym_id] = ACTIONS(3417),
    [anon_sym_event] = ACTIONS(3417),
    [anon_sym_fn] = ACTIONS(3417),
    [anon_sym_on] = ACTIONS(3417),
    [sym__ternary_qmark] = ACTIONS(3419),
  },
  [989] = {
    [sym_identifier] = ACTIONS(1668),
    [anon_sym_STAR] = ACTIONS(1668),
    [anon_sym_as] = ACTIONS(1668),
    [anon_sym_LBRACE] = ACTIONS(1668),
    [anon_sym_RBRACE] = ACTIONS(1672),
    [anon_sym_typeof] = ACTIONS(1668),
    [anon_sym_BANG] = ACTIONS(1668),
    [anon_sym_LPAREN] = ACTIONS(1672),
    [anon_sym_in] = ACTIONS(1668),
    [anon_sym_SEMI] = ACTIONS(1672),
    [anon_sym_LBRACK] = ACTIONS(1672),
    [anon_sym_LT] = ACTIONS(1668),
    [anon_sym_GT] = ACTIONS(1668),
    [anon_sym_SLASH] = ACTIONS(1668),
    [anon_sym_DOT] = ACTIONS(1668),
    [anon_sym_async] = ACTIONS(1668),
    [anon_sym_QMARK_DOT] = ACTIONS(1672),
    [anon_sym_new] = ACTIONS(1668),
    [anon_sym_AMP_AMP] = ACTIONS(1672),
    [anon_sym_PIPE_PIPE] = ACTIONS(1672),
    [anon_sym_GT_GT] = ACTIONS(1668),
    [anon_sym_GT_GT_GT] = ACTIONS(1672),
    [anon_sym_LT_LT] = ACTIONS(1672),
    [anon_sym_AMP] = ACTIONS(1668),
    [anon_sym_CARET] = ACTIONS(1672),
    [anon_sym_PIPE] = ACTIONS(1668),
    [anon_sym_PLUS] = ACTIONS(1668),
    [anon_sym_DASH] = ACTIONS(1668),
    [anon_sym_PERCENT] = ACTIONS(1672),
    [anon_sym_STAR_STAR] = ACTIONS(1672),
    [anon_sym_LT_EQ] = ACTIONS(1672),
    [anon_sym_EQ_EQ] = ACTIONS(1668),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1672),
    [anon_sym_BANG_EQ] = ACTIONS(1668),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1672),
    [anon_sym_GT_EQ] = ACTIONS(1672),
    [anon_sym_QMARK_QMARK] = ACTIONS(1672),
    [anon_sym_instanceof] = ACTIONS(1668),
    [anon_sym_void] = ACTIONS(1668),
    [anon_sym_PLUS_PLUS] = ACTIONS(1672),
    [anon_sym_DASH_DASH] = ACTIONS(1672),
    [anon_sym_DQUOTE] = ACTIONS(1672),
    [anon_sym_SQUOTE] = ACTIONS(1672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1672),
    [sym_number] = ACTIONS(1672),
    [sym_this] = ACTIONS(1668),
    [sym_true] = ACTIONS(1668),
    [sym_false] = ACTIONS(1668),
    [sym_null] = ACTIONS(1668),
    [sym_undefined] = ACTIONS(1668),
    [anon_sym_static] = ACTIONS(1668),
    [anon_sym_readonly] = ACTIONS(1668),
    [anon_sym_get] = ACTIONS(1668),
    [anon_sym_set] = ACTIONS(1668),
    [anon_sym_QMARK] = ACTIONS(1668),
    [anon_sym_any] = ACTIONS(1668),
    [anon_sym_number] = ACTIONS(1668),
    [anon_sym_boolean] = ACTIONS(1668),
    [anon_sym_string] = ACTIONS(1668),
    [anon_sym_symbol] = ACTIONS(1668),
    [anon_sym_abstract] = ACTIONS(1668),
    [anon_sym_satisfies] = ACTIONS(1668),
    [anon_sym_infer] = ACTIONS(1668),
    [anon_sym_keyof] = ACTIONS(1668),
    [anon_sym_unknown] = ACTIONS(1668),
    [anon_sym_never] = ACTIONS(1668),
    [anon_sym_object] = ACTIONS(1668),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1672),
    [anon_sym_constructor] = ACTIONS(1668),
    [anon_sym_prop] = ACTIONS(1668),
    [anon_sym_id] = ACTIONS(1668),
    [anon_sym_event] = ACTIONS(1668),
    [anon_sym_fn] = ACTIONS(1668),
    [anon_sym_on] = ACTIONS(1668),
    [sym__ternary_qmark] = ACTIONS(1672),
  },
  [990] = {
    [sym_identifier] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_as] = ACTIONS(3421),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_RBRACE] = ACTIONS(3423),
    [anon_sym_typeof] = ACTIONS(3421),
    [anon_sym_BANG] = ACTIONS(3421),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_in] = ACTIONS(3421),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3421),
    [anon_sym_DOT] = ACTIONS(3421),
    [anon_sym_async] = ACTIONS(3421),
    [anon_sym_QMARK_DOT] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3421),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_GT_GT_GT] = ACTIONS(3423),
    [anon_sym_LT_LT] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_PERCENT] = ACTIONS(3423),
    [anon_sym_STAR_STAR] = ACTIONS(3423),
    [anon_sym_LT_EQ] = ACTIONS(3423),
    [anon_sym_EQ_EQ] = ACTIONS(3421),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3423),
    [anon_sym_BANG_EQ] = ACTIONS(3421),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3423),
    [anon_sym_GT_EQ] = ACTIONS(3423),
    [anon_sym_QMARK_QMARK] = ACTIONS(3423),
    [anon_sym_instanceof] = ACTIONS(3421),
    [anon_sym_void] = ACTIONS(3421),
    [anon_sym_PLUS_PLUS] = ACTIONS(3423),
    [anon_sym_DASH_DASH] = ACTIONS(3423),
    [anon_sym_DQUOTE] = ACTIONS(3423),
    [anon_sym_SQUOTE] = ACTIONS(3423),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3423),
    [sym_number] = ACTIONS(3423),
    [sym_this] = ACTIONS(3421),
    [sym_true] = ACTIONS(3421),
    [sym_false] = ACTIONS(3421),
    [sym_null] = ACTIONS(3421),
    [sym_undefined] = ACTIONS(3421),
    [anon_sym_static] = ACTIONS(3421),
    [anon_sym_readonly] = ACTIONS(3421),
    [anon_sym_get] = ACTIONS(3421),
    [anon_sym_set] = ACTIONS(3421),
    [anon_sym_QMARK] = ACTIONS(3421),
    [anon_sym_any] = ACTIONS(3421),
    [anon_sym_number] = ACTIONS(3421),
    [anon_sym_boolean] = ACTIONS(3421),
    [anon_sym_string] = ACTIONS(3421),
    [anon_sym_symbol] = ACTIONS(3421),
    [anon_sym_abstract] = ACTIONS(3421),
    [anon_sym_satisfies] = ACTIONS(3421),
    [anon_sym_infer] = ACTIONS(3421),
    [anon_sym_keyof] = ACTIONS(3421),
    [anon_sym_unknown] = ACTIONS(3421),
    [anon_sym_never] = ACTIONS(3421),
    [anon_sym_object] = ACTIONS(3421),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3423),
    [anon_sym_constructor] = ACTIONS(3421),
    [anon_sym_prop] = ACTIONS(3421),
    [anon_sym_id] = ACTIONS(3421),
    [anon_sym_event] = ACTIONS(3421),
    [anon_sym_fn] = ACTIONS(3421),
    [anon_sym_on] = ACTIONS(3421),
    [sym__ternary_qmark] = ACTIONS(3423),
  },
  [991] = {
    [sym_identifier] = ACTIONS(1628),
    [anon_sym_STAR] = ACTIONS(1628),
    [anon_sym_as] = ACTIONS(1628),
    [anon_sym_LBRACE] = ACTIONS(1628),
    [anon_sym_RBRACE] = ACTIONS(1632),
    [anon_sym_typeof] = ACTIONS(1628),
    [anon_sym_BANG] = ACTIONS(1628),
    [anon_sym_LPAREN] = ACTIONS(1632),
    [anon_sym_in] = ACTIONS(1628),
    [anon_sym_SEMI] = ACTIONS(1632),
    [anon_sym_LBRACK] = ACTIONS(1632),
    [anon_sym_LT] = ACTIONS(1628),
    [anon_sym_GT] = ACTIONS(1628),
    [anon_sym_SLASH] = ACTIONS(1628),
    [anon_sym_DOT] = ACTIONS(1628),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_QMARK_DOT] = ACTIONS(1632),
    [anon_sym_new] = ACTIONS(1628),
    [anon_sym_AMP_AMP] = ACTIONS(1632),
    [anon_sym_PIPE_PIPE] = ACTIONS(1632),
    [anon_sym_GT_GT] = ACTIONS(1628),
    [anon_sym_GT_GT_GT] = ACTIONS(1632),
    [anon_sym_LT_LT] = ACTIONS(1632),
    [anon_sym_AMP] = ACTIONS(1628),
    [anon_sym_CARET] = ACTIONS(1632),
    [anon_sym_PIPE] = ACTIONS(1628),
    [anon_sym_PLUS] = ACTIONS(1628),
    [anon_sym_DASH] = ACTIONS(1628),
    [anon_sym_PERCENT] = ACTIONS(1632),
    [anon_sym_STAR_STAR] = ACTIONS(1632),
    [anon_sym_LT_EQ] = ACTIONS(1632),
    [anon_sym_EQ_EQ] = ACTIONS(1628),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1632),
    [anon_sym_BANG_EQ] = ACTIONS(1628),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1632),
    [anon_sym_GT_EQ] = ACTIONS(1632),
    [anon_sym_QMARK_QMARK] = ACTIONS(1632),
    [anon_sym_instanceof] = ACTIONS(1628),
    [anon_sym_void] = ACTIONS(1628),
    [anon_sym_PLUS_PLUS] = ACTIONS(1632),
    [anon_sym_DASH_DASH] = ACTIONS(1632),
    [anon_sym_DQUOTE] = ACTIONS(1632),
    [anon_sym_SQUOTE] = ACTIONS(1632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1632),
    [sym_number] = ACTIONS(1632),
    [sym_this] = ACTIONS(1628),
    [sym_true] = ACTIONS(1628),
    [sym_false] = ACTIONS(1628),
    [sym_null] = ACTIONS(1628),
    [sym_undefined] = ACTIONS(1628),
    [anon_sym_static] = ACTIONS(1628),
    [anon_sym_readonly] = ACTIONS(1628),
    [anon_sym_get] = ACTIONS(1628),
    [anon_sym_set] = ACTIONS(1628),
    [anon_sym_QMARK] = ACTIONS(1628),
    [anon_sym_any] = ACTIONS(1628),
    [anon_sym_number] = ACTIONS(1628),
    [anon_sym_boolean] = ACTIONS(1628),
    [anon_sym_string] = ACTIONS(1628),
    [anon_sym_symbol] = ACTIONS(1628),
    [anon_sym_abstract] = ACTIONS(1628),
    [anon_sym_satisfies] = ACTIONS(1628),
    [anon_sym_infer] = ACTIONS(1628),
    [anon_sym_keyof] = ACTIONS(1628),
    [anon_sym_unknown] = ACTIONS(1628),
    [anon_sym_never] = ACTIONS(1628),
    [anon_sym_object] = ACTIONS(1628),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1632),
    [anon_sym_constructor] = ACTIONS(1628),
    [anon_sym_prop] = ACTIONS(1628),
    [anon_sym_id] = ACTIONS(1628),
    [anon_sym_event] = ACTIONS(1628),
    [anon_sym_fn] = ACTIONS(1628),
    [anon_sym_on] = ACTIONS(1628),
    [sym__ternary_qmark] = ACTIONS(1632),
  },
  [992] = {
    [sym_identifier] = ACTIONS(1618),
    [anon_sym_STAR] = ACTIONS(1618),
    [anon_sym_as] = ACTIONS(1618),
    [anon_sym_LBRACE] = ACTIONS(1618),
    [anon_sym_RBRACE] = ACTIONS(1622),
    [anon_sym_typeof] = ACTIONS(1618),
    [anon_sym_BANG] = ACTIONS(1618),
    [anon_sym_LPAREN] = ACTIONS(1622),
    [anon_sym_in] = ACTIONS(1618),
    [anon_sym_SEMI] = ACTIONS(1622),
    [anon_sym_LBRACK] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(1618),
    [anon_sym_GT] = ACTIONS(1618),
    [anon_sym_SLASH] = ACTIONS(1618),
    [anon_sym_DOT] = ACTIONS(1618),
    [anon_sym_async] = ACTIONS(1618),
    [anon_sym_QMARK_DOT] = ACTIONS(1622),
    [anon_sym_new] = ACTIONS(1618),
    [anon_sym_AMP_AMP] = ACTIONS(1622),
    [anon_sym_PIPE_PIPE] = ACTIONS(1622),
    [anon_sym_GT_GT] = ACTIONS(1618),
    [anon_sym_GT_GT_GT] = ACTIONS(1622),
    [anon_sym_LT_LT] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1618),
    [anon_sym_CARET] = ACTIONS(1622),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_PLUS] = ACTIONS(1618),
    [anon_sym_DASH] = ACTIONS(1618),
    [anon_sym_PERCENT] = ACTIONS(1622),
    [anon_sym_STAR_STAR] = ACTIONS(1622),
    [anon_sym_LT_EQ] = ACTIONS(1622),
    [anon_sym_EQ_EQ] = ACTIONS(1618),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1622),
    [anon_sym_BANG_EQ] = ACTIONS(1618),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1622),
    [anon_sym_GT_EQ] = ACTIONS(1622),
    [anon_sym_QMARK_QMARK] = ACTIONS(1622),
    [anon_sym_instanceof] = ACTIONS(1618),
    [anon_sym_void] = ACTIONS(1618),
    [anon_sym_PLUS_PLUS] = ACTIONS(1622),
    [anon_sym_DASH_DASH] = ACTIONS(1622),
    [anon_sym_DQUOTE] = ACTIONS(1622),
    [anon_sym_SQUOTE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1622),
    [sym_number] = ACTIONS(1622),
    [sym_this] = ACTIONS(1618),
    [sym_true] = ACTIONS(1618),
    [sym_false] = ACTIONS(1618),
    [sym_null] = ACTIONS(1618),
    [sym_undefined] = ACTIONS(1618),
    [anon_sym_static] = ACTIONS(1618),
    [anon_sym_readonly] = ACTIONS(1618),
    [anon_sym_get] = ACTIONS(1618),
    [anon_sym_set] = ACTIONS(1618),
    [anon_sym_QMARK] = ACTIONS(1618),
    [anon_sym_any] = ACTIONS(1618),
    [anon_sym_number] = ACTIONS(1618),
    [anon_sym_boolean] = ACTIONS(1618),
    [anon_sym_string] = ACTIONS(1618),
    [anon_sym_symbol] = ACTIONS(1618),
    [anon_sym_abstract] = ACTIONS(1618),
    [anon_sym_satisfies] = ACTIONS(1618),
    [anon_sym_infer] = ACTIONS(1618),
    [anon_sym_keyof] = ACTIONS(1618),
    [anon_sym_unknown] = ACTIONS(1618),
    [anon_sym_never] = ACTIONS(1618),
    [anon_sym_object] = ACTIONS(1618),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1622),
    [anon_sym_constructor] = ACTIONS(1618),
    [anon_sym_prop] = ACTIONS(1618),
    [anon_sym_id] = ACTIONS(1618),
    [anon_sym_event] = ACTIONS(1618),
    [anon_sym_fn] = ACTIONS(1618),
    [anon_sym_on] = ACTIONS(1618),
    [sym__ternary_qmark] = ACTIONS(1622),
  },
  [993] = {
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_STAR] = ACTIONS(1516),
    [anon_sym_as] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(1516),
    [anon_sym_RBRACE] = ACTIONS(1520),
    [anon_sym_typeof] = ACTIONS(1516),
    [anon_sym_BANG] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_in] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(1520),
    [anon_sym_LBRACK] = ACTIONS(1520),
    [anon_sym_LT] = ACTIONS(1516),
    [anon_sym_GT] = ACTIONS(1516),
    [anon_sym_SLASH] = ACTIONS(1516),
    [anon_sym_DOT] = ACTIONS(1516),
    [anon_sym_async] = ACTIONS(1516),
    [anon_sym_QMARK_DOT] = ACTIONS(1520),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_AMP_AMP] = ACTIONS(1520),
    [anon_sym_PIPE_PIPE] = ACTIONS(1520),
    [anon_sym_GT_GT] = ACTIONS(1516),
    [anon_sym_GT_GT_GT] = ACTIONS(1520),
    [anon_sym_LT_LT] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1516),
    [anon_sym_CARET] = ACTIONS(1520),
    [anon_sym_PIPE] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1516),
    [anon_sym_DASH] = ACTIONS(1516),
    [anon_sym_PERCENT] = ACTIONS(1520),
    [anon_sym_STAR_STAR] = ACTIONS(1520),
    [anon_sym_LT_EQ] = ACTIONS(1520),
    [anon_sym_EQ_EQ] = ACTIONS(1516),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1520),
    [anon_sym_BANG_EQ] = ACTIONS(1516),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1520),
    [anon_sym_GT_EQ] = ACTIONS(1520),
    [anon_sym_QMARK_QMARK] = ACTIONS(1520),
    [anon_sym_instanceof] = ACTIONS(1516),
    [anon_sym_void] = ACTIONS(1516),
    [anon_sym_PLUS_PLUS] = ACTIONS(1520),
    [anon_sym_DASH_DASH] = ACTIONS(1520),
    [anon_sym_DQUOTE] = ACTIONS(1520),
    [anon_sym_SQUOTE] = ACTIONS(1520),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1520),
    [sym_number] = ACTIONS(1520),
    [sym_this] = ACTIONS(1516),
    [sym_true] = ACTIONS(1516),
    [sym_false] = ACTIONS(1516),
    [sym_null] = ACTIONS(1516),
    [sym_undefined] = ACTIONS(1516),
    [anon_sym_static] = ACTIONS(1516),
    [anon_sym_readonly] = ACTIONS(1516),
    [anon_sym_get] = ACTIONS(1516),
    [anon_sym_set] = ACTIONS(1516),
    [anon_sym_QMARK] = ACTIONS(1516),
    [anon_sym_any] = ACTIONS(1516),
    [anon_sym_number] = ACTIONS(1516),
    [anon_sym_boolean] = ACTIONS(1516),
    [anon_sym_string] = ACTIONS(1516),
    [anon_sym_symbol] = ACTIONS(1516),
    [anon_sym_abstract] = ACTIONS(1516),
    [anon_sym_satisfies] = ACTIONS(1516),
    [anon_sym_infer] = ACTIONS(1516),
    [anon_sym_keyof] = ACTIONS(1516),
    [anon_sym_unknown] = ACTIONS(1516),
    [anon_sym_never] = ACTIONS(1516),
    [anon_sym_object] = ACTIONS(1516),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1520),
    [anon_sym_constructor] = ACTIONS(1516),
    [anon_sym_prop] = ACTIONS(1516),
    [anon_sym_id] = ACTIONS(1516),
    [anon_sym_event] = ACTIONS(1516),
    [anon_sym_fn] = ACTIONS(1516),
    [anon_sym_on] = ACTIONS(1516),
    [sym__ternary_qmark] = ACTIONS(1520),
  },
  [994] = {
    [sym_identifier] = ACTIONS(1684),
    [anon_sym_STAR] = ACTIONS(1684),
    [anon_sym_as] = ACTIONS(1684),
    [anon_sym_LBRACE] = ACTIONS(1684),
    [anon_sym_RBRACE] = ACTIONS(1688),
    [anon_sym_typeof] = ACTIONS(1684),
    [anon_sym_BANG] = ACTIONS(1684),
    [anon_sym_LPAREN] = ACTIONS(1688),
    [anon_sym_in] = ACTIONS(1684),
    [anon_sym_SEMI] = ACTIONS(1688),
    [anon_sym_LBRACK] = ACTIONS(1688),
    [anon_sym_LT] = ACTIONS(1684),
    [anon_sym_GT] = ACTIONS(1684),
    [anon_sym_SLASH] = ACTIONS(1684),
    [anon_sym_DOT] = ACTIONS(1684),
    [anon_sym_async] = ACTIONS(1684),
    [anon_sym_QMARK_DOT] = ACTIONS(1688),
    [anon_sym_new] = ACTIONS(1684),
    [anon_sym_AMP_AMP] = ACTIONS(1688),
    [anon_sym_PIPE_PIPE] = ACTIONS(1688),
    [anon_sym_GT_GT] = ACTIONS(1684),
    [anon_sym_GT_GT_GT] = ACTIONS(1688),
    [anon_sym_LT_LT] = ACTIONS(1688),
    [anon_sym_AMP] = ACTIONS(1684),
    [anon_sym_CARET] = ACTIONS(1688),
    [anon_sym_PIPE] = ACTIONS(1684),
    [anon_sym_PLUS] = ACTIONS(1684),
    [anon_sym_DASH] = ACTIONS(1684),
    [anon_sym_PERCENT] = ACTIONS(1688),
    [anon_sym_STAR_STAR] = ACTIONS(1688),
    [anon_sym_LT_EQ] = ACTIONS(1688),
    [anon_sym_EQ_EQ] = ACTIONS(1684),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1688),
    [anon_sym_BANG_EQ] = ACTIONS(1684),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1688),
    [anon_sym_GT_EQ] = ACTIONS(1688),
    [anon_sym_QMARK_QMARK] = ACTIONS(1688),
    [anon_sym_instanceof] = ACTIONS(1684),
    [anon_sym_void] = ACTIONS(1684),
    [anon_sym_PLUS_PLUS] = ACTIONS(1688),
    [anon_sym_DASH_DASH] = ACTIONS(1688),
    [anon_sym_DQUOTE] = ACTIONS(1688),
    [anon_sym_SQUOTE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1688),
    [sym_number] = ACTIONS(1688),
    [sym_this] = ACTIONS(1684),
    [sym_true] = ACTIONS(1684),
    [sym_false] = ACTIONS(1684),
    [sym_null] = ACTIONS(1684),
    [sym_undefined] = ACTIONS(1684),
    [anon_sym_static] = ACTIONS(1684),
    [anon_sym_readonly] = ACTIONS(1684),
    [anon_sym_get] = ACTIONS(1684),
    [anon_sym_set] = ACTIONS(1684),
    [anon_sym_QMARK] = ACTIONS(1684),
    [anon_sym_any] = ACTIONS(1684),
    [anon_sym_number] = ACTIONS(1684),
    [anon_sym_boolean] = ACTIONS(1684),
    [anon_sym_string] = ACTIONS(1684),
    [anon_sym_symbol] = ACTIONS(1684),
    [anon_sym_abstract] = ACTIONS(1684),
    [anon_sym_satisfies] = ACTIONS(1684),
    [anon_sym_infer] = ACTIONS(1684),
    [anon_sym_keyof] = ACTIONS(1684),
    [anon_sym_unknown] = ACTIONS(1684),
    [anon_sym_never] = ACTIONS(1684),
    [anon_sym_object] = ACTIONS(1684),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1688),
    [anon_sym_constructor] = ACTIONS(1684),
    [anon_sym_prop] = ACTIONS(1684),
    [anon_sym_id] = ACTIONS(1684),
    [anon_sym_event] = ACTIONS(1684),
    [anon_sym_fn] = ACTIONS(1684),
    [anon_sym_on] = ACTIONS(1684),
    [sym__ternary_qmark] = ACTIONS(1688),
  },
  [995] = {
    [sym_identifier] = ACTIONS(1694),
    [anon_sym_STAR] = ACTIONS(1694),
    [anon_sym_as] = ACTIONS(1694),
    [anon_sym_LBRACE] = ACTIONS(1694),
    [anon_sym_RBRACE] = ACTIONS(1698),
    [anon_sym_typeof] = ACTIONS(1694),
    [anon_sym_BANG] = ACTIONS(1694),
    [anon_sym_LPAREN] = ACTIONS(1698),
    [anon_sym_in] = ACTIONS(1694),
    [anon_sym_SEMI] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1698),
    [anon_sym_LT] = ACTIONS(1694),
    [anon_sym_GT] = ACTIONS(1694),
    [anon_sym_SLASH] = ACTIONS(1694),
    [anon_sym_DOT] = ACTIONS(1694),
    [anon_sym_async] = ACTIONS(1694),
    [anon_sym_QMARK_DOT] = ACTIONS(1698),
    [anon_sym_new] = ACTIONS(1694),
    [anon_sym_AMP_AMP] = ACTIONS(1698),
    [anon_sym_PIPE_PIPE] = ACTIONS(1698),
    [anon_sym_GT_GT] = ACTIONS(1694),
    [anon_sym_GT_GT_GT] = ACTIONS(1698),
    [anon_sym_LT_LT] = ACTIONS(1698),
    [anon_sym_AMP] = ACTIONS(1694),
    [anon_sym_CARET] = ACTIONS(1698),
    [anon_sym_PIPE] = ACTIONS(1694),
    [anon_sym_PLUS] = ACTIONS(1694),
    [anon_sym_DASH] = ACTIONS(1694),
    [anon_sym_PERCENT] = ACTIONS(1698),
    [anon_sym_STAR_STAR] = ACTIONS(1698),
    [anon_sym_LT_EQ] = ACTIONS(1698),
    [anon_sym_EQ_EQ] = ACTIONS(1694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1698),
    [anon_sym_BANG_EQ] = ACTIONS(1694),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1698),
    [anon_sym_GT_EQ] = ACTIONS(1698),
    [anon_sym_QMARK_QMARK] = ACTIONS(1698),
    [anon_sym_instanceof] = ACTIONS(1694),
    [anon_sym_void] = ACTIONS(1694),
    [anon_sym_PLUS_PLUS] = ACTIONS(1698),
    [anon_sym_DASH_DASH] = ACTIONS(1698),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [anon_sym_SQUOTE] = ACTIONS(1698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1698),
    [sym_number] = ACTIONS(1698),
    [sym_this] = ACTIONS(1694),
    [sym_true] = ACTIONS(1694),
    [sym_false] = ACTIONS(1694),
    [sym_null] = ACTIONS(1694),
    [sym_undefined] = ACTIONS(1694),
    [anon_sym_static] = ACTIONS(1694),
    [anon_sym_readonly] = ACTIONS(1694),
    [anon_sym_get] = ACTIONS(1694),
    [anon_sym_set] = ACTIONS(1694),
    [anon_sym_QMARK] = ACTIONS(1694),
    [anon_sym_any] = ACTIONS(1694),
    [anon_sym_number] = ACTIONS(1694),
    [anon_sym_boolean] = ACTIONS(1694),
    [anon_sym_string] = ACTIONS(1694),
    [anon_sym_symbol] = ACTIONS(1694),
    [anon_sym_abstract] = ACTIONS(1694),
    [anon_sym_satisfies] = ACTIONS(1694),
    [anon_sym_infer] = ACTIONS(1694),
    [anon_sym_keyof] = ACTIONS(1694),
    [anon_sym_unknown] = ACTIONS(1694),
    [anon_sym_never] = ACTIONS(1694),
    [anon_sym_object] = ACTIONS(1694),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1698),
    [anon_sym_constructor] = ACTIONS(1694),
    [anon_sym_prop] = ACTIONS(1694),
    [anon_sym_id] = ACTIONS(1694),
    [anon_sym_event] = ACTIONS(1694),
    [anon_sym_fn] = ACTIONS(1694),
    [anon_sym_on] = ACTIONS(1694),
    [sym__ternary_qmark] = ACTIONS(1698),
  },
  [996] = {
    [sym_identifier] = ACTIONS(1718),
    [anon_sym_STAR] = ACTIONS(1718),
    [anon_sym_as] = ACTIONS(1718),
    [anon_sym_LBRACE] = ACTIONS(1718),
    [anon_sym_RBRACE] = ACTIONS(1722),
    [anon_sym_typeof] = ACTIONS(1718),
    [anon_sym_BANG] = ACTIONS(1718),
    [anon_sym_LPAREN] = ACTIONS(1722),
    [anon_sym_in] = ACTIONS(1718),
    [anon_sym_SEMI] = ACTIONS(1722),
    [anon_sym_LBRACK] = ACTIONS(1722),
    [anon_sym_LT] = ACTIONS(1718),
    [anon_sym_GT] = ACTIONS(1718),
    [anon_sym_SLASH] = ACTIONS(1718),
    [anon_sym_DOT] = ACTIONS(1718),
    [anon_sym_async] = ACTIONS(1718),
    [anon_sym_QMARK_DOT] = ACTIONS(1722),
    [anon_sym_new] = ACTIONS(1718),
    [anon_sym_AMP_AMP] = ACTIONS(1722),
    [anon_sym_PIPE_PIPE] = ACTIONS(1722),
    [anon_sym_GT_GT] = ACTIONS(1718),
    [anon_sym_GT_GT_GT] = ACTIONS(1722),
    [anon_sym_LT_LT] = ACTIONS(1722),
    [anon_sym_AMP] = ACTIONS(1718),
    [anon_sym_CARET] = ACTIONS(1722),
    [anon_sym_PIPE] = ACTIONS(1718),
    [anon_sym_PLUS] = ACTIONS(1718),
    [anon_sym_DASH] = ACTIONS(1718),
    [anon_sym_PERCENT] = ACTIONS(1722),
    [anon_sym_STAR_STAR] = ACTIONS(1722),
    [anon_sym_LT_EQ] = ACTIONS(1722),
    [anon_sym_EQ_EQ] = ACTIONS(1718),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1722),
    [anon_sym_BANG_EQ] = ACTIONS(1718),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1722),
    [anon_sym_GT_EQ] = ACTIONS(1722),
    [anon_sym_QMARK_QMARK] = ACTIONS(1722),
    [anon_sym_instanceof] = ACTIONS(1718),
    [anon_sym_void] = ACTIONS(1718),
    [anon_sym_PLUS_PLUS] = ACTIONS(1722),
    [anon_sym_DASH_DASH] = ACTIONS(1722),
    [anon_sym_DQUOTE] = ACTIONS(1722),
    [anon_sym_SQUOTE] = ACTIONS(1722),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1722),
    [sym_number] = ACTIONS(1722),
    [sym_this] = ACTIONS(1718),
    [sym_true] = ACTIONS(1718),
    [sym_false] = ACTIONS(1718),
    [sym_null] = ACTIONS(1718),
    [sym_undefined] = ACTIONS(1718),
    [anon_sym_static] = ACTIONS(1718),
    [anon_sym_readonly] = ACTIONS(1718),
    [anon_sym_get] = ACTIONS(1718),
    [anon_sym_set] = ACTIONS(1718),
    [anon_sym_QMARK] = ACTIONS(1718),
    [anon_sym_any] = ACTIONS(1718),
    [anon_sym_number] = ACTIONS(1718),
    [anon_sym_boolean] = ACTIONS(1718),
    [anon_sym_string] = ACTIONS(1718),
    [anon_sym_symbol] = ACTIONS(1718),
    [anon_sym_abstract] = ACTIONS(1718),
    [anon_sym_satisfies] = ACTIONS(1718),
    [anon_sym_infer] = ACTIONS(1718),
    [anon_sym_keyof] = ACTIONS(1718),
    [anon_sym_unknown] = ACTIONS(1718),
    [anon_sym_never] = ACTIONS(1718),
    [anon_sym_object] = ACTIONS(1718),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1722),
    [anon_sym_constructor] = ACTIONS(1718),
    [anon_sym_prop] = ACTIONS(1718),
    [anon_sym_id] = ACTIONS(1718),
    [anon_sym_event] = ACTIONS(1718),
    [anon_sym_fn] = ACTIONS(1718),
    [anon_sym_on] = ACTIONS(1718),
    [sym__ternary_qmark] = ACTIONS(1722),
  },
  [997] = {
    [sym_identifier] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1506),
    [anon_sym_as] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(1510),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1510),
    [anon_sym_in] = ACTIONS(1506),
    [anon_sym_SEMI] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1510),
    [anon_sym_LT] = ACTIONS(1506),
    [anon_sym_GT] = ACTIONS(1506),
    [anon_sym_SLASH] = ACTIONS(1506),
    [anon_sym_DOT] = ACTIONS(1506),
    [anon_sym_async] = ACTIONS(1506),
    [anon_sym_QMARK_DOT] = ACTIONS(1510),
    [anon_sym_new] = ACTIONS(1506),
    [anon_sym_AMP_AMP] = ACTIONS(1510),
    [anon_sym_PIPE_PIPE] = ACTIONS(1510),
    [anon_sym_GT_GT] = ACTIONS(1506),
    [anon_sym_GT_GT_GT] = ACTIONS(1510),
    [anon_sym_LT_LT] = ACTIONS(1510),
    [anon_sym_AMP] = ACTIONS(1506),
    [anon_sym_CARET] = ACTIONS(1510),
    [anon_sym_PIPE] = ACTIONS(1506),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_PERCENT] = ACTIONS(1510),
    [anon_sym_STAR_STAR] = ACTIONS(1510),
    [anon_sym_LT_EQ] = ACTIONS(1510),
    [anon_sym_EQ_EQ] = ACTIONS(1506),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1510),
    [anon_sym_BANG_EQ] = ACTIONS(1506),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1510),
    [anon_sym_GT_EQ] = ACTIONS(1510),
    [anon_sym_QMARK_QMARK] = ACTIONS(1510),
    [anon_sym_instanceof] = ACTIONS(1506),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1510),
    [anon_sym_DASH_DASH] = ACTIONS(1510),
    [anon_sym_DQUOTE] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1510),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1510),
    [sym_number] = ACTIONS(1510),
    [sym_this] = ACTIONS(1506),
    [sym_true] = ACTIONS(1506),
    [sym_false] = ACTIONS(1506),
    [sym_null] = ACTIONS(1506),
    [sym_undefined] = ACTIONS(1506),
    [anon_sym_static] = ACTIONS(1506),
    [anon_sym_readonly] = ACTIONS(1506),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_QMARK] = ACTIONS(1506),
    [anon_sym_any] = ACTIONS(1506),
    [anon_sym_number] = ACTIONS(1506),
    [anon_sym_boolean] = ACTIONS(1506),
    [anon_sym_string] = ACTIONS(1506),
    [anon_sym_symbol] = ACTIONS(1506),
    [anon_sym_abstract] = ACTIONS(1506),
    [anon_sym_satisfies] = ACTIONS(1506),
    [anon_sym_infer] = ACTIONS(1506),
    [anon_sym_keyof] = ACTIONS(1506),
    [anon_sym_unknown] = ACTIONS(1506),
    [anon_sym_never] = ACTIONS(1506),
    [anon_sym_object] = ACTIONS(1506),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1510),
    [anon_sym_constructor] = ACTIONS(1506),
    [anon_sym_prop] = ACTIONS(1506),
    [anon_sym_id] = ACTIONS(1506),
    [anon_sym_event] = ACTIONS(1506),
    [anon_sym_fn] = ACTIONS(1506),
    [anon_sym_on] = ACTIONS(1506),
    [sym__ternary_qmark] = ACTIONS(1510),
  },
  [998] = {
    [sym_identifier] = ACTIONS(1848),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1848),
    [anon_sym_LBRACE] = ACTIONS(1848),
    [anon_sym_RBRACE] = ACTIONS(1852),
    [anon_sym_typeof] = ACTIONS(1848),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(1848),
    [anon_sym_async] = ACTIONS(1848),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1848),
    [anon_sym_AMP_AMP] = ACTIONS(1852),
    [anon_sym_PIPE_PIPE] = ACTIONS(1852),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1852),
    [anon_sym_LT_LT] = ACTIONS(1852),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1852),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1852),
    [anon_sym_STAR_STAR] = ACTIONS(1852),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1852),
    [anon_sym_instanceof] = ACTIONS(1848),
    [anon_sym_void] = ACTIONS(1848),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [anon_sym_DQUOTE] = ACTIONS(1852),
    [anon_sym_SQUOTE] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1852),
    [sym_number] = ACTIONS(1852),
    [sym_this] = ACTIONS(1848),
    [sym_true] = ACTIONS(1848),
    [sym_false] = ACTIONS(1848),
    [sym_null] = ACTIONS(1848),
    [sym_undefined] = ACTIONS(1848),
    [anon_sym_static] = ACTIONS(1848),
    [anon_sym_readonly] = ACTIONS(1848),
    [anon_sym_get] = ACTIONS(1848),
    [anon_sym_set] = ACTIONS(1848),
    [anon_sym_QMARK] = ACTIONS(1848),
    [anon_sym_any] = ACTIONS(1848),
    [anon_sym_number] = ACTIONS(1848),
    [anon_sym_boolean] = ACTIONS(1848),
    [anon_sym_string] = ACTIONS(1848),
    [anon_sym_symbol] = ACTIONS(1848),
    [anon_sym_abstract] = ACTIONS(1848),
    [anon_sym_satisfies] = ACTIONS(1848),
    [anon_sym_infer] = ACTIONS(1848),
    [anon_sym_keyof] = ACTIONS(1848),
    [anon_sym_unknown] = ACTIONS(1848),
    [anon_sym_never] = ACTIONS(1848),
    [anon_sym_object] = ACTIONS(1848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_constructor] = ACTIONS(1848),
    [anon_sym_prop] = ACTIONS(1848),
    [anon_sym_id] = ACTIONS(1848),
    [anon_sym_event] = ACTIONS(1848),
    [anon_sym_fn] = ACTIONS(1848),
    [anon_sym_on] = ACTIONS(1848),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [999] = {
    [sym_identifier] = ACTIONS(1474),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_as] = ACTIONS(1474),
    [anon_sym_LBRACE] = ACTIONS(1474),
    [anon_sym_RBRACE] = ACTIONS(1478),
    [anon_sym_typeof] = ACTIONS(1474),
    [anon_sym_BANG] = ACTIONS(1474),
    [anon_sym_LPAREN] = ACTIONS(1478),
    [anon_sym_in] = ACTIONS(1474),
    [anon_sym_SEMI] = ACTIONS(1478),
    [anon_sym_LBRACK] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(1474),
    [anon_sym_GT] = ACTIONS(1474),
    [anon_sym_SLASH] = ACTIONS(1474),
    [anon_sym_DOT] = ACTIONS(1474),
    [anon_sym_async] = ACTIONS(1474),
    [anon_sym_QMARK_DOT] = ACTIONS(1478),
    [anon_sym_new] = ACTIONS(1474),
    [anon_sym_AMP_AMP] = ACTIONS(1478),
    [anon_sym_PIPE_PIPE] = ACTIONS(1478),
    [anon_sym_GT_GT] = ACTIONS(1474),
    [anon_sym_GT_GT_GT] = ACTIONS(1478),
    [anon_sym_LT_LT] = ACTIONS(1478),
    [anon_sym_AMP] = ACTIONS(1474),
    [anon_sym_CARET] = ACTIONS(1478),
    [anon_sym_PIPE] = ACTIONS(1474),
    [anon_sym_PLUS] = ACTIONS(1474),
    [anon_sym_DASH] = ACTIONS(1474),
    [anon_sym_PERCENT] = ACTIONS(1478),
    [anon_sym_STAR_STAR] = ACTIONS(1478),
    [anon_sym_LT_EQ] = ACTIONS(1478),
    [anon_sym_EQ_EQ] = ACTIONS(1474),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1478),
    [anon_sym_BANG_EQ] = ACTIONS(1474),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1478),
    [anon_sym_GT_EQ] = ACTIONS(1478),
    [anon_sym_QMARK_QMARK] = ACTIONS(1478),
    [anon_sym_instanceof] = ACTIONS(1474),
    [anon_sym_void] = ACTIONS(1474),
    [anon_sym_PLUS_PLUS] = ACTIONS(1478),
    [anon_sym_DASH_DASH] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1478),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1478),
    [sym_number] = ACTIONS(1478),
    [sym_this] = ACTIONS(1474),
    [sym_true] = ACTIONS(1474),
    [sym_false] = ACTIONS(1474),
    [sym_null] = ACTIONS(1474),
    [sym_undefined] = ACTIONS(1474),
    [anon_sym_static] = ACTIONS(1474),
    [anon_sym_readonly] = ACTIONS(1474),
    [anon_sym_get] = ACTIONS(1474),
    [anon_sym_set] = ACTIONS(1474),
    [anon_sym_QMARK] = ACTIONS(1474),
    [anon_sym_any] = ACTIONS(1474),
    [anon_sym_number] = ACTIONS(1474),
    [anon_sym_boolean] = ACTIONS(1474),
    [anon_sym_string] = ACTIONS(1474),
    [anon_sym_symbol] = ACTIONS(1474),
    [anon_sym_abstract] = ACTIONS(1474),
    [anon_sym_satisfies] = ACTIONS(1474),
    [anon_sym_infer] = ACTIONS(1474),
    [anon_sym_keyof] = ACTIONS(1474),
    [anon_sym_unknown] = ACTIONS(1474),
    [anon_sym_never] = ACTIONS(1474),
    [anon_sym_object] = ACTIONS(1474),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1478),
    [anon_sym_constructor] = ACTIONS(1474),
    [anon_sym_prop] = ACTIONS(1474),
    [anon_sym_id] = ACTIONS(1474),
    [anon_sym_event] = ACTIONS(1474),
    [anon_sym_fn] = ACTIONS(1474),
    [anon_sym_on] = ACTIONS(1474),
    [sym__ternary_qmark] = ACTIONS(1478),
  },
  [1000] = {
    [sym_identifier] = ACTIONS(3425),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_as] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3425),
    [anon_sym_RBRACE] = ACTIONS(3427),
    [anon_sym_typeof] = ACTIONS(3425),
    [anon_sym_BANG] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_in] = ACTIONS(3425),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_GT] = ACTIONS(3425),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_DOT] = ACTIONS(3425),
    [anon_sym_async] = ACTIONS(3425),
    [anon_sym_QMARK_DOT] = ACTIONS(3427),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_GT_GT] = ACTIONS(3425),
    [anon_sym_GT_GT_GT] = ACTIONS(3427),
    [anon_sym_LT_LT] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym_CARET] = ACTIONS(3427),
    [anon_sym_PIPE] = ACTIONS(3425),
    [anon_sym_PLUS] = ACTIONS(3425),
    [anon_sym_DASH] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(3427),
    [anon_sym_STAR_STAR] = ACTIONS(3427),
    [anon_sym_LT_EQ] = ACTIONS(3427),
    [anon_sym_EQ_EQ] = ACTIONS(3425),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3427),
    [anon_sym_BANG_EQ] = ACTIONS(3425),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3427),
    [anon_sym_GT_EQ] = ACTIONS(3427),
    [anon_sym_QMARK_QMARK] = ACTIONS(3427),
    [anon_sym_instanceof] = ACTIONS(3425),
    [anon_sym_void] = ACTIONS(3425),
    [anon_sym_PLUS_PLUS] = ACTIONS(3427),
    [anon_sym_DASH_DASH] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3427),
    [sym_number] = ACTIONS(3427),
    [sym_this] = ACTIONS(3425),
    [sym_true] = ACTIONS(3425),
    [sym_false] = ACTIONS(3425),
    [sym_null] = ACTIONS(3425),
    [sym_undefined] = ACTIONS(3425),
    [anon_sym_static] = ACTIONS(3425),
    [anon_sym_readonly] = ACTIONS(3425),
    [anon_sym_get] = ACTIONS(3425),
    [anon_sym_set] = ACTIONS(3425),
    [anon_sym_QMARK] = ACTIONS(3425),
    [anon_sym_any] = ACTIONS(3425),
    [anon_sym_number] = ACTIONS(3425),
    [anon_sym_boolean] = ACTIONS(3425),
    [anon_sym_string] = ACTIONS(3425),
    [anon_sym_symbol] = ACTIONS(3425),
    [anon_sym_abstract] = ACTIONS(3425),
    [anon_sym_satisfies] = ACTIONS(3425),
    [anon_sym_infer] = ACTIONS(3425),
    [anon_sym_keyof] = ACTIONS(3425),
    [anon_sym_unknown] = ACTIONS(3425),
    [anon_sym_never] = ACTIONS(3425),
    [anon_sym_object] = ACTIONS(3425),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3427),
    [anon_sym_constructor] = ACTIONS(3425),
    [anon_sym_prop] = ACTIONS(3425),
    [anon_sym_id] = ACTIONS(3425),
    [anon_sym_event] = ACTIONS(3425),
    [anon_sym_fn] = ACTIONS(3425),
    [anon_sym_on] = ACTIONS(3425),
    [sym__ternary_qmark] = ACTIONS(3427),
  },
  [1001] = {
    [sym_identifier] = ACTIONS(1434),
    [anon_sym_STAR] = ACTIONS(1434),
    [anon_sym_as] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1434),
    [anon_sym_RBRACE] = ACTIONS(1438),
    [anon_sym_typeof] = ACTIONS(1434),
    [anon_sym_BANG] = ACTIONS(1434),
    [anon_sym_LPAREN] = ACTIONS(1438),
    [anon_sym_in] = ACTIONS(1434),
    [anon_sym_SEMI] = ACTIONS(1438),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_LT] = ACTIONS(1434),
    [anon_sym_GT] = ACTIONS(1434),
    [anon_sym_SLASH] = ACTIONS(1434),
    [anon_sym_DOT] = ACTIONS(1434),
    [anon_sym_async] = ACTIONS(1434),
    [anon_sym_QMARK_DOT] = ACTIONS(1438),
    [anon_sym_new] = ACTIONS(1434),
    [anon_sym_AMP_AMP] = ACTIONS(1438),
    [anon_sym_PIPE_PIPE] = ACTIONS(1438),
    [anon_sym_GT_GT] = ACTIONS(1434),
    [anon_sym_GT_GT_GT] = ACTIONS(1438),
    [anon_sym_LT_LT] = ACTIONS(1438),
    [anon_sym_AMP] = ACTIONS(1434),
    [anon_sym_CARET] = ACTIONS(1438),
    [anon_sym_PIPE] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_PERCENT] = ACTIONS(1438),
    [anon_sym_STAR_STAR] = ACTIONS(1438),
    [anon_sym_LT_EQ] = ACTIONS(1438),
    [anon_sym_EQ_EQ] = ACTIONS(1434),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1438),
    [anon_sym_BANG_EQ] = ACTIONS(1434),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1438),
    [anon_sym_GT_EQ] = ACTIONS(1438),
    [anon_sym_QMARK_QMARK] = ACTIONS(1438),
    [anon_sym_instanceof] = ACTIONS(1434),
    [anon_sym_void] = ACTIONS(1434),
    [anon_sym_PLUS_PLUS] = ACTIONS(1438),
    [anon_sym_DASH_DASH] = ACTIONS(1438),
    [anon_sym_DQUOTE] = ACTIONS(1438),
    [anon_sym_SQUOTE] = ACTIONS(1438),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1438),
    [sym_number] = ACTIONS(1438),
    [sym_this] = ACTIONS(1434),
    [sym_true] = ACTIONS(1434),
    [sym_false] = ACTIONS(1434),
    [sym_null] = ACTIONS(1434),
    [sym_undefined] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(1434),
    [anon_sym_readonly] = ACTIONS(1434),
    [anon_sym_get] = ACTIONS(1434),
    [anon_sym_set] = ACTIONS(1434),
    [anon_sym_QMARK] = ACTIONS(1434),
    [anon_sym_any] = ACTIONS(1434),
    [anon_sym_number] = ACTIONS(1434),
    [anon_sym_boolean] = ACTIONS(1434),
    [anon_sym_string] = ACTIONS(1434),
    [anon_sym_symbol] = ACTIONS(1434),
    [anon_sym_abstract] = ACTIONS(1434),
    [anon_sym_satisfies] = ACTIONS(1434),
    [anon_sym_infer] = ACTIONS(1434),
    [anon_sym_keyof] = ACTIONS(1434),
    [anon_sym_unknown] = ACTIONS(1434),
    [anon_sym_never] = ACTIONS(1434),
    [anon_sym_object] = ACTIONS(1434),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1438),
    [anon_sym_constructor] = ACTIONS(1434),
    [anon_sym_prop] = ACTIONS(1434),
    [anon_sym_id] = ACTIONS(1434),
    [anon_sym_event] = ACTIONS(1434),
    [anon_sym_fn] = ACTIONS(1434),
    [anon_sym_on] = ACTIONS(1434),
    [sym__ternary_qmark] = ACTIONS(1438),
  },
  [1002] = {
    [sym_identifier] = ACTIONS(3429),
    [anon_sym_STAR] = ACTIONS(3429),
    [anon_sym_as] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3429),
    [anon_sym_RBRACE] = ACTIONS(3431),
    [anon_sym_typeof] = ACTIONS(3429),
    [anon_sym_BANG] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_in] = ACTIONS(3429),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LT] = ACTIONS(3429),
    [anon_sym_GT] = ACTIONS(3429),
    [anon_sym_SLASH] = ACTIONS(3429),
    [anon_sym_DOT] = ACTIONS(3429),
    [anon_sym_async] = ACTIONS(3429),
    [anon_sym_QMARK_DOT] = ACTIONS(3431),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_AMP_AMP] = ACTIONS(3431),
    [anon_sym_PIPE_PIPE] = ACTIONS(3431),
    [anon_sym_GT_GT] = ACTIONS(3429),
    [anon_sym_GT_GT_GT] = ACTIONS(3431),
    [anon_sym_LT_LT] = ACTIONS(3431),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym_CARET] = ACTIONS(3431),
    [anon_sym_PIPE] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PERCENT] = ACTIONS(3431),
    [anon_sym_STAR_STAR] = ACTIONS(3431),
    [anon_sym_LT_EQ] = ACTIONS(3431),
    [anon_sym_EQ_EQ] = ACTIONS(3429),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3429),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3431),
    [anon_sym_GT_EQ] = ACTIONS(3431),
    [anon_sym_QMARK_QMARK] = ACTIONS(3431),
    [anon_sym_instanceof] = ACTIONS(3429),
    [anon_sym_void] = ACTIONS(3429),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3431),
    [sym_number] = ACTIONS(3431),
    [sym_this] = ACTIONS(3429),
    [sym_true] = ACTIONS(3429),
    [sym_false] = ACTIONS(3429),
    [sym_null] = ACTIONS(3429),
    [sym_undefined] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_readonly] = ACTIONS(3429),
    [anon_sym_get] = ACTIONS(3429),
    [anon_sym_set] = ACTIONS(3429),
    [anon_sym_QMARK] = ACTIONS(3429),
    [anon_sym_any] = ACTIONS(3429),
    [anon_sym_number] = ACTIONS(3429),
    [anon_sym_boolean] = ACTIONS(3429),
    [anon_sym_string] = ACTIONS(3429),
    [anon_sym_symbol] = ACTIONS(3429),
    [anon_sym_abstract] = ACTIONS(3429),
    [anon_sym_satisfies] = ACTIONS(3429),
    [anon_sym_infer] = ACTIONS(3429),
    [anon_sym_keyof] = ACTIONS(3429),
    [anon_sym_unknown] = ACTIONS(3429),
    [anon_sym_never] = ACTIONS(3429),
    [anon_sym_object] = ACTIONS(3429),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3431),
    [anon_sym_constructor] = ACTIONS(3429),
    [anon_sym_prop] = ACTIONS(3429),
    [anon_sym_id] = ACTIONS(3429),
    [anon_sym_event] = ACTIONS(3429),
    [anon_sym_fn] = ACTIONS(3429),
    [anon_sym_on] = ACTIONS(3429),
    [sym__ternary_qmark] = ACTIONS(3431),
  },
  [1003] = {
    [sym_identifier] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1414),
    [anon_sym_as] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(1414),
    [anon_sym_RBRACE] = ACTIONS(1418),
    [anon_sym_typeof] = ACTIONS(1414),
    [anon_sym_BANG] = ACTIONS(1414),
    [anon_sym_LPAREN] = ACTIONS(1418),
    [anon_sym_in] = ACTIONS(1414),
    [anon_sym_SEMI] = ACTIONS(1418),
    [anon_sym_LBRACK] = ACTIONS(1418),
    [anon_sym_LT] = ACTIONS(1414),
    [anon_sym_GT] = ACTIONS(1414),
    [anon_sym_SLASH] = ACTIONS(1414),
    [anon_sym_DOT] = ACTIONS(1414),
    [anon_sym_async] = ACTIONS(1414),
    [anon_sym_QMARK_DOT] = ACTIONS(1418),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP_AMP] = ACTIONS(1418),
    [anon_sym_PIPE_PIPE] = ACTIONS(1418),
    [anon_sym_GT_GT] = ACTIONS(1414),
    [anon_sym_GT_GT_GT] = ACTIONS(1418),
    [anon_sym_LT_LT] = ACTIONS(1418),
    [anon_sym_AMP] = ACTIONS(1414),
    [anon_sym_CARET] = ACTIONS(1418),
    [anon_sym_PIPE] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1414),
    [anon_sym_DASH] = ACTIONS(1414),
    [anon_sym_PERCENT] = ACTIONS(1418),
    [anon_sym_STAR_STAR] = ACTIONS(1418),
    [anon_sym_LT_EQ] = ACTIONS(1418),
    [anon_sym_EQ_EQ] = ACTIONS(1414),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1418),
    [anon_sym_BANG_EQ] = ACTIONS(1414),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1418),
    [anon_sym_GT_EQ] = ACTIONS(1418),
    [anon_sym_QMARK_QMARK] = ACTIONS(1418),
    [anon_sym_instanceof] = ACTIONS(1414),
    [anon_sym_void] = ACTIONS(1414),
    [anon_sym_PLUS_PLUS] = ACTIONS(1418),
    [anon_sym_DASH_DASH] = ACTIONS(1418),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [sym_number] = ACTIONS(1418),
    [sym_this] = ACTIONS(1414),
    [sym_true] = ACTIONS(1414),
    [sym_false] = ACTIONS(1414),
    [sym_null] = ACTIONS(1414),
    [sym_undefined] = ACTIONS(1414),
    [anon_sym_static] = ACTIONS(1414),
    [anon_sym_readonly] = ACTIONS(1414),
    [anon_sym_get] = ACTIONS(1414),
    [anon_sym_set] = ACTIONS(1414),
    [anon_sym_QMARK] = ACTIONS(1414),
    [anon_sym_any] = ACTIONS(1414),
    [anon_sym_number] = ACTIONS(1414),
    [anon_sym_boolean] = ACTIONS(1414),
    [anon_sym_string] = ACTIONS(1414),
    [anon_sym_symbol] = ACTIONS(1414),
    [anon_sym_abstract] = ACTIONS(1414),
    [anon_sym_satisfies] = ACTIONS(1414),
    [anon_sym_infer] = ACTIONS(1414),
    [anon_sym_keyof] = ACTIONS(1414),
    [anon_sym_unknown] = ACTIONS(1414),
    [anon_sym_never] = ACTIONS(1414),
    [anon_sym_object] = ACTIONS(1414),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1418),
    [anon_sym_constructor] = ACTIONS(1414),
    [anon_sym_prop] = ACTIONS(1414),
    [anon_sym_id] = ACTIONS(1414),
    [anon_sym_event] = ACTIONS(1414),
    [anon_sym_fn] = ACTIONS(1414),
    [anon_sym_on] = ACTIONS(1414),
    [sym__ternary_qmark] = ACTIONS(1418),
  },
  [1004] = {
    [sym_identifier] = ACTIONS(3433),
    [anon_sym_STAR] = ACTIONS(3433),
    [anon_sym_as] = ACTIONS(3433),
    [anon_sym_LBRACE] = ACTIONS(3433),
    [anon_sym_RBRACE] = ACTIONS(3435),
    [anon_sym_typeof] = ACTIONS(3433),
    [anon_sym_BANG] = ACTIONS(3433),
    [anon_sym_LPAREN] = ACTIONS(3435),
    [anon_sym_in] = ACTIONS(3433),
    [anon_sym_SEMI] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3435),
    [anon_sym_LT] = ACTIONS(3433),
    [anon_sym_GT] = ACTIONS(3433),
    [anon_sym_SLASH] = ACTIONS(3433),
    [anon_sym_DOT] = ACTIONS(3433),
    [anon_sym_async] = ACTIONS(3433),
    [anon_sym_QMARK_DOT] = ACTIONS(3435),
    [anon_sym_new] = ACTIONS(3433),
    [anon_sym_AMP_AMP] = ACTIONS(3435),
    [anon_sym_PIPE_PIPE] = ACTIONS(3435),
    [anon_sym_GT_GT] = ACTIONS(3433),
    [anon_sym_GT_GT_GT] = ACTIONS(3435),
    [anon_sym_LT_LT] = ACTIONS(3435),
    [anon_sym_AMP] = ACTIONS(3433),
    [anon_sym_CARET] = ACTIONS(3435),
    [anon_sym_PIPE] = ACTIONS(3433),
    [anon_sym_PLUS] = ACTIONS(3433),
    [anon_sym_DASH] = ACTIONS(3433),
    [anon_sym_PERCENT] = ACTIONS(3435),
    [anon_sym_STAR_STAR] = ACTIONS(3435),
    [anon_sym_LT_EQ] = ACTIONS(3435),
    [anon_sym_EQ_EQ] = ACTIONS(3433),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3435),
    [anon_sym_BANG_EQ] = ACTIONS(3433),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3435),
    [anon_sym_GT_EQ] = ACTIONS(3435),
    [anon_sym_QMARK_QMARK] = ACTIONS(3435),
    [anon_sym_instanceof] = ACTIONS(3433),
    [anon_sym_void] = ACTIONS(3433),
    [anon_sym_PLUS_PLUS] = ACTIONS(3435),
    [anon_sym_DASH_DASH] = ACTIONS(3435),
    [anon_sym_DQUOTE] = ACTIONS(3435),
    [anon_sym_SQUOTE] = ACTIONS(3435),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3435),
    [sym_number] = ACTIONS(3435),
    [sym_this] = ACTIONS(3433),
    [sym_true] = ACTIONS(3433),
    [sym_false] = ACTIONS(3433),
    [sym_null] = ACTIONS(3433),
    [sym_undefined] = ACTIONS(3433),
    [anon_sym_static] = ACTIONS(3433),
    [anon_sym_readonly] = ACTIONS(3433),
    [anon_sym_get] = ACTIONS(3433),
    [anon_sym_set] = ACTIONS(3433),
    [anon_sym_QMARK] = ACTIONS(3433),
    [anon_sym_any] = ACTIONS(3433),
    [anon_sym_number] = ACTIONS(3433),
    [anon_sym_boolean] = ACTIONS(3433),
    [anon_sym_string] = ACTIONS(3433),
    [anon_sym_symbol] = ACTIONS(3433),
    [anon_sym_abstract] = ACTIONS(3433),
    [anon_sym_satisfies] = ACTIONS(3433),
    [anon_sym_infer] = ACTIONS(3433),
    [anon_sym_keyof] = ACTIONS(3433),
    [anon_sym_unknown] = ACTIONS(3433),
    [anon_sym_never] = ACTIONS(3433),
    [anon_sym_object] = ACTIONS(3433),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3435),
    [anon_sym_constructor] = ACTIONS(3433),
    [anon_sym_prop] = ACTIONS(3433),
    [anon_sym_id] = ACTIONS(3433),
    [anon_sym_event] = ACTIONS(3433),
    [anon_sym_fn] = ACTIONS(3433),
    [anon_sym_on] = ACTIONS(3433),
    [sym__ternary_qmark] = ACTIONS(3435),
  },
  [1005] = {
    [sym_identifier] = ACTIONS(1540),
    [anon_sym_STAR] = ACTIONS(1540),
    [anon_sym_as] = ACTIONS(1540),
    [anon_sym_LBRACE] = ACTIONS(1540),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [anon_sym_typeof] = ACTIONS(1540),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1542),
    [anon_sym_in] = ACTIONS(1540),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_LBRACK] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1540),
    [anon_sym_DOT] = ACTIONS(1540),
    [anon_sym_async] = ACTIONS(1540),
    [anon_sym_QMARK_DOT] = ACTIONS(1542),
    [anon_sym_new] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1540),
    [anon_sym_GT_GT_GT] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_AMP] = ACTIONS(1540),
    [anon_sym_CARET] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_PERCENT] = ACTIONS(1542),
    [anon_sym_STAR_STAR] = ACTIONS(1542),
    [anon_sym_LT_EQ] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1540),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1540),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1542),
    [anon_sym_GT_EQ] = ACTIONS(1542),
    [anon_sym_QMARK_QMARK] = ACTIONS(1542),
    [anon_sym_instanceof] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1542),
    [anon_sym_DASH_DASH] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [sym_number] = ACTIONS(1542),
    [sym_this] = ACTIONS(1540),
    [sym_true] = ACTIONS(1540),
    [sym_false] = ACTIONS(1540),
    [sym_null] = ACTIONS(1540),
    [sym_undefined] = ACTIONS(1540),
    [anon_sym_static] = ACTIONS(1540),
    [anon_sym_readonly] = ACTIONS(1540),
    [anon_sym_get] = ACTIONS(1540),
    [anon_sym_set] = ACTIONS(1540),
    [anon_sym_QMARK] = ACTIONS(1540),
    [anon_sym_any] = ACTIONS(1540),
    [anon_sym_number] = ACTIONS(1540),
    [anon_sym_boolean] = ACTIONS(1540),
    [anon_sym_string] = ACTIONS(1540),
    [anon_sym_symbol] = ACTIONS(1540),
    [anon_sym_abstract] = ACTIONS(1540),
    [anon_sym_satisfies] = ACTIONS(1540),
    [anon_sym_infer] = ACTIONS(1540),
    [anon_sym_keyof] = ACTIONS(1540),
    [anon_sym_unknown] = ACTIONS(1540),
    [anon_sym_never] = ACTIONS(1540),
    [anon_sym_object] = ACTIONS(1540),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1542),
    [anon_sym_constructor] = ACTIONS(1540),
    [anon_sym_prop] = ACTIONS(1540),
    [anon_sym_id] = ACTIONS(1540),
    [anon_sym_event] = ACTIONS(1540),
    [anon_sym_fn] = ACTIONS(1540),
    [anon_sym_on] = ACTIONS(1540),
    [sym__ternary_qmark] = ACTIONS(1542),
  },
  [1006] = {
    [sym_identifier] = ACTIONS(2990),
    [anon_sym_STAR] = ACTIONS(2990),
    [anon_sym_as] = ACTIONS(2990),
    [anon_sym_LBRACE] = ACTIONS(2990),
    [anon_sym_RBRACE] = ACTIONS(2992),
    [anon_sym_typeof] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2990),
    [anon_sym_LPAREN] = ACTIONS(2992),
    [anon_sym_in] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2992),
    [anon_sym_LT] = ACTIONS(2990),
    [anon_sym_GT] = ACTIONS(2990),
    [anon_sym_SLASH] = ACTIONS(2990),
    [anon_sym_DOT] = ACTIONS(2990),
    [anon_sym_async] = ACTIONS(2990),
    [anon_sym_QMARK_DOT] = ACTIONS(2992),
    [anon_sym_new] = ACTIONS(2990),
    [anon_sym_AMP_AMP] = ACTIONS(2992),
    [anon_sym_PIPE_PIPE] = ACTIONS(2992),
    [anon_sym_GT_GT] = ACTIONS(2990),
    [anon_sym_GT_GT_GT] = ACTIONS(2992),
    [anon_sym_LT_LT] = ACTIONS(2992),
    [anon_sym_AMP] = ACTIONS(2990),
    [anon_sym_CARET] = ACTIONS(2992),
    [anon_sym_PIPE] = ACTIONS(2990),
    [anon_sym_PLUS] = ACTIONS(2990),
    [anon_sym_DASH] = ACTIONS(2990),
    [anon_sym_PERCENT] = ACTIONS(2992),
    [anon_sym_STAR_STAR] = ACTIONS(2992),
    [anon_sym_LT_EQ] = ACTIONS(2992),
    [anon_sym_EQ_EQ] = ACTIONS(2990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2992),
    [anon_sym_BANG_EQ] = ACTIONS(2990),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2992),
    [anon_sym_GT_EQ] = ACTIONS(2992),
    [anon_sym_QMARK_QMARK] = ACTIONS(2992),
    [anon_sym_instanceof] = ACTIONS(2990),
    [anon_sym_void] = ACTIONS(2990),
    [anon_sym_PLUS_PLUS] = ACTIONS(2992),
    [anon_sym_DASH_DASH] = ACTIONS(2992),
    [anon_sym_DQUOTE] = ACTIONS(2992),
    [anon_sym_SQUOTE] = ACTIONS(2992),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2992),
    [sym_number] = ACTIONS(2992),
    [sym_this] = ACTIONS(2990),
    [sym_true] = ACTIONS(2990),
    [sym_false] = ACTIONS(2990),
    [sym_null] = ACTIONS(2990),
    [sym_undefined] = ACTIONS(2990),
    [anon_sym_static] = ACTIONS(2990),
    [anon_sym_readonly] = ACTIONS(2990),
    [anon_sym_get] = ACTIONS(2990),
    [anon_sym_set] = ACTIONS(2990),
    [anon_sym_QMARK] = ACTIONS(2990),
    [anon_sym_any] = ACTIONS(2990),
    [anon_sym_number] = ACTIONS(2990),
    [anon_sym_boolean] = ACTIONS(2990),
    [anon_sym_string] = ACTIONS(2990),
    [anon_sym_symbol] = ACTIONS(2990),
    [anon_sym_abstract] = ACTIONS(2990),
    [anon_sym_satisfies] = ACTIONS(2990),
    [anon_sym_infer] = ACTIONS(2990),
    [anon_sym_keyof] = ACTIONS(2990),
    [anon_sym_unknown] = ACTIONS(2990),
    [anon_sym_never] = ACTIONS(2990),
    [anon_sym_object] = ACTIONS(2990),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2992),
    [anon_sym_constructor] = ACTIONS(2990),
    [anon_sym_prop] = ACTIONS(2990),
    [anon_sym_id] = ACTIONS(2990),
    [anon_sym_event] = ACTIONS(2990),
    [anon_sym_fn] = ACTIONS(2990),
    [anon_sym_on] = ACTIONS(2990),
    [sym__ternary_qmark] = ACTIONS(2992),
  },
  [1007] = {
    [sym_identifier] = ACTIONS(1394),
    [anon_sym_STAR] = ACTIONS(1394),
    [anon_sym_as] = ACTIONS(1394),
    [anon_sym_LBRACE] = ACTIONS(1394),
    [anon_sym_RBRACE] = ACTIONS(1398),
    [anon_sym_typeof] = ACTIONS(1394),
    [anon_sym_BANG] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1398),
    [anon_sym_in] = ACTIONS(1394),
    [anon_sym_SEMI] = ACTIONS(1398),
    [anon_sym_LBRACK] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1394),
    [anon_sym_GT] = ACTIONS(1394),
    [anon_sym_SLASH] = ACTIONS(1394),
    [anon_sym_DOT] = ACTIONS(1394),
    [anon_sym_async] = ACTIONS(1394),
    [anon_sym_QMARK_DOT] = ACTIONS(1398),
    [anon_sym_new] = ACTIONS(1394),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_GT_GT] = ACTIONS(1394),
    [anon_sym_GT_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1394),
    [anon_sym_CARET] = ACTIONS(1398),
    [anon_sym_PIPE] = ACTIONS(1394),
    [anon_sym_PLUS] = ACTIONS(1394),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_PERCENT] = ACTIONS(1398),
    [anon_sym_STAR_STAR] = ACTIONS(1398),
    [anon_sym_LT_EQ] = ACTIONS(1398),
    [anon_sym_EQ_EQ] = ACTIONS(1394),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1398),
    [anon_sym_BANG_EQ] = ACTIONS(1394),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1398),
    [anon_sym_GT_EQ] = ACTIONS(1398),
    [anon_sym_QMARK_QMARK] = ACTIONS(1398),
    [anon_sym_instanceof] = ACTIONS(1394),
    [anon_sym_void] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1398),
    [anon_sym_DASH_DASH] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [sym_number] = ACTIONS(1398),
    [sym_this] = ACTIONS(1394),
    [sym_true] = ACTIONS(1394),
    [sym_false] = ACTIONS(1394),
    [sym_null] = ACTIONS(1394),
    [sym_undefined] = ACTIONS(1394),
    [anon_sym_static] = ACTIONS(1394),
    [anon_sym_readonly] = ACTIONS(1394),
    [anon_sym_get] = ACTIONS(1394),
    [anon_sym_set] = ACTIONS(1394),
    [anon_sym_QMARK] = ACTIONS(1394),
    [anon_sym_any] = ACTIONS(1394),
    [anon_sym_number] = ACTIONS(1394),
    [anon_sym_boolean] = ACTIONS(1394),
    [anon_sym_string] = ACTIONS(1394),
    [anon_sym_symbol] = ACTIONS(1394),
    [anon_sym_abstract] = ACTIONS(1394),
    [anon_sym_satisfies] = ACTIONS(1394),
    [anon_sym_infer] = ACTIONS(1394),
    [anon_sym_keyof] = ACTIONS(1394),
    [anon_sym_unknown] = ACTIONS(1394),
    [anon_sym_never] = ACTIONS(1394),
    [anon_sym_object] = ACTIONS(1394),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1398),
    [anon_sym_constructor] = ACTIONS(1394),
    [anon_sym_prop] = ACTIONS(1394),
    [anon_sym_id] = ACTIONS(1394),
    [anon_sym_event] = ACTIONS(1394),
    [anon_sym_fn] = ACTIONS(1394),
    [anon_sym_on] = ACTIONS(1394),
    [sym__ternary_qmark] = ACTIONS(1398),
  },
  [1008] = {
    [sym_identifier] = ACTIONS(3437),
    [anon_sym_STAR] = ACTIONS(3437),
    [anon_sym_as] = ACTIONS(3437),
    [anon_sym_LBRACE] = ACTIONS(3437),
    [anon_sym_RBRACE] = ACTIONS(3439),
    [anon_sym_typeof] = ACTIONS(3437),
    [anon_sym_BANG] = ACTIONS(3437),
    [anon_sym_LPAREN] = ACTIONS(3439),
    [anon_sym_in] = ACTIONS(3437),
    [anon_sym_SEMI] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_LT] = ACTIONS(3437),
    [anon_sym_GT] = ACTIONS(3437),
    [anon_sym_SLASH] = ACTIONS(3437),
    [anon_sym_DOT] = ACTIONS(3437),
    [anon_sym_async] = ACTIONS(3437),
    [anon_sym_QMARK_DOT] = ACTIONS(3439),
    [anon_sym_new] = ACTIONS(3437),
    [anon_sym_AMP_AMP] = ACTIONS(3439),
    [anon_sym_PIPE_PIPE] = ACTIONS(3439),
    [anon_sym_GT_GT] = ACTIONS(3437),
    [anon_sym_GT_GT_GT] = ACTIONS(3439),
    [anon_sym_LT_LT] = ACTIONS(3439),
    [anon_sym_AMP] = ACTIONS(3437),
    [anon_sym_CARET] = ACTIONS(3439),
    [anon_sym_PIPE] = ACTIONS(3437),
    [anon_sym_PLUS] = ACTIONS(3437),
    [anon_sym_DASH] = ACTIONS(3437),
    [anon_sym_PERCENT] = ACTIONS(3439),
    [anon_sym_STAR_STAR] = ACTIONS(3439),
    [anon_sym_LT_EQ] = ACTIONS(3439),
    [anon_sym_EQ_EQ] = ACTIONS(3437),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3439),
    [anon_sym_BANG_EQ] = ACTIONS(3437),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3439),
    [anon_sym_GT_EQ] = ACTIONS(3439),
    [anon_sym_QMARK_QMARK] = ACTIONS(3439),
    [anon_sym_instanceof] = ACTIONS(3437),
    [anon_sym_void] = ACTIONS(3437),
    [anon_sym_PLUS_PLUS] = ACTIONS(3439),
    [anon_sym_DASH_DASH] = ACTIONS(3439),
    [anon_sym_DQUOTE] = ACTIONS(3439),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3439),
    [sym_number] = ACTIONS(3439),
    [sym_this] = ACTIONS(3437),
    [sym_true] = ACTIONS(3437),
    [sym_false] = ACTIONS(3437),
    [sym_null] = ACTIONS(3437),
    [sym_undefined] = ACTIONS(3437),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_readonly] = ACTIONS(3437),
    [anon_sym_get] = ACTIONS(3437),
    [anon_sym_set] = ACTIONS(3437),
    [anon_sym_QMARK] = ACTIONS(3437),
    [anon_sym_any] = ACTIONS(3437),
    [anon_sym_number] = ACTIONS(3437),
    [anon_sym_boolean] = ACTIONS(3437),
    [anon_sym_string] = ACTIONS(3437),
    [anon_sym_symbol] = ACTIONS(3437),
    [anon_sym_abstract] = ACTIONS(3437),
    [anon_sym_satisfies] = ACTIONS(3437),
    [anon_sym_infer] = ACTIONS(3437),
    [anon_sym_keyof] = ACTIONS(3437),
    [anon_sym_unknown] = ACTIONS(3437),
    [anon_sym_never] = ACTIONS(3437),
    [anon_sym_object] = ACTIONS(3437),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3439),
    [anon_sym_constructor] = ACTIONS(3437),
    [anon_sym_prop] = ACTIONS(3437),
    [anon_sym_id] = ACTIONS(3437),
    [anon_sym_event] = ACTIONS(3437),
    [anon_sym_fn] = ACTIONS(3437),
    [anon_sym_on] = ACTIONS(3437),
    [sym__ternary_qmark] = ACTIONS(3439),
  },
  [1009] = {
    [sym_identifier] = ACTIONS(3441),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_as] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3441),
    [anon_sym_RBRACE] = ACTIONS(3443),
    [anon_sym_typeof] = ACTIONS(3441),
    [anon_sym_BANG] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_in] = ACTIONS(3441),
    [anon_sym_SEMI] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_GT] = ACTIONS(3441),
    [anon_sym_SLASH] = ACTIONS(3441),
    [anon_sym_DOT] = ACTIONS(3441),
    [anon_sym_async] = ACTIONS(3441),
    [anon_sym_QMARK_DOT] = ACTIONS(3443),
    [anon_sym_new] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3443),
    [anon_sym_PIPE_PIPE] = ACTIONS(3443),
    [anon_sym_GT_GT] = ACTIONS(3441),
    [anon_sym_GT_GT_GT] = ACTIONS(3443),
    [anon_sym_LT_LT] = ACTIONS(3443),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym_CARET] = ACTIONS(3443),
    [anon_sym_PIPE] = ACTIONS(3441),
    [anon_sym_PLUS] = ACTIONS(3441),
    [anon_sym_DASH] = ACTIONS(3441),
    [anon_sym_PERCENT] = ACTIONS(3443),
    [anon_sym_STAR_STAR] = ACTIONS(3443),
    [anon_sym_LT_EQ] = ACTIONS(3443),
    [anon_sym_EQ_EQ] = ACTIONS(3441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3443),
    [anon_sym_BANG_EQ] = ACTIONS(3441),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3443),
    [anon_sym_GT_EQ] = ACTIONS(3443),
    [anon_sym_QMARK_QMARK] = ACTIONS(3443),
    [anon_sym_instanceof] = ACTIONS(3441),
    [anon_sym_void] = ACTIONS(3441),
    [anon_sym_PLUS_PLUS] = ACTIONS(3443),
    [anon_sym_DASH_DASH] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [anon_sym_SQUOTE] = ACTIONS(3443),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3443),
    [sym_number] = ACTIONS(3443),
    [sym_this] = ACTIONS(3441),
    [sym_true] = ACTIONS(3441),
    [sym_false] = ACTIONS(3441),
    [sym_null] = ACTIONS(3441),
    [sym_undefined] = ACTIONS(3441),
    [anon_sym_static] = ACTIONS(3441),
    [anon_sym_readonly] = ACTIONS(3441),
    [anon_sym_get] = ACTIONS(3441),
    [anon_sym_set] = ACTIONS(3441),
    [anon_sym_QMARK] = ACTIONS(3441),
    [anon_sym_any] = ACTIONS(3441),
    [anon_sym_number] = ACTIONS(3441),
    [anon_sym_boolean] = ACTIONS(3441),
    [anon_sym_string] = ACTIONS(3441),
    [anon_sym_symbol] = ACTIONS(3441),
    [anon_sym_abstract] = ACTIONS(3441),
    [anon_sym_satisfies] = ACTIONS(3441),
    [anon_sym_infer] = ACTIONS(3441),
    [anon_sym_keyof] = ACTIONS(3441),
    [anon_sym_unknown] = ACTIONS(3441),
    [anon_sym_never] = ACTIONS(3441),
    [anon_sym_object] = ACTIONS(3441),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3443),
    [anon_sym_constructor] = ACTIONS(3441),
    [anon_sym_prop] = ACTIONS(3441),
    [anon_sym_id] = ACTIONS(3441),
    [anon_sym_event] = ACTIONS(3441),
    [anon_sym_fn] = ACTIONS(3441),
    [anon_sym_on] = ACTIONS(3441),
    [sym__ternary_qmark] = ACTIONS(3443),
  },
  [1010] = {
    [sym_identifier] = ACTIONS(3445),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_as] = ACTIONS(3445),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_RBRACE] = ACTIONS(3447),
    [anon_sym_typeof] = ACTIONS(3445),
    [anon_sym_BANG] = ACTIONS(3445),
    [anon_sym_LPAREN] = ACTIONS(3447),
    [anon_sym_in] = ACTIONS(3445),
    [anon_sym_SEMI] = ACTIONS(3447),
    [anon_sym_LBRACK] = ACTIONS(3447),
    [anon_sym_LT] = ACTIONS(3445),
    [anon_sym_GT] = ACTIONS(3445),
    [anon_sym_SLASH] = ACTIONS(3445),
    [anon_sym_DOT] = ACTIONS(3445),
    [anon_sym_async] = ACTIONS(3445),
    [anon_sym_QMARK_DOT] = ACTIONS(3447),
    [anon_sym_new] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3447),
    [anon_sym_PIPE_PIPE] = ACTIONS(3447),
    [anon_sym_GT_GT] = ACTIONS(3445),
    [anon_sym_GT_GT_GT] = ACTIONS(3447),
    [anon_sym_LT_LT] = ACTIONS(3447),
    [anon_sym_AMP] = ACTIONS(3445),
    [anon_sym_CARET] = ACTIONS(3447),
    [anon_sym_PIPE] = ACTIONS(3445),
    [anon_sym_PLUS] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3445),
    [anon_sym_PERCENT] = ACTIONS(3447),
    [anon_sym_STAR_STAR] = ACTIONS(3447),
    [anon_sym_LT_EQ] = ACTIONS(3447),
    [anon_sym_EQ_EQ] = ACTIONS(3445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3447),
    [anon_sym_BANG_EQ] = ACTIONS(3445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3447),
    [anon_sym_GT_EQ] = ACTIONS(3447),
    [anon_sym_QMARK_QMARK] = ACTIONS(3447),
    [anon_sym_instanceof] = ACTIONS(3445),
    [anon_sym_void] = ACTIONS(3445),
    [anon_sym_PLUS_PLUS] = ACTIONS(3447),
    [anon_sym_DASH_DASH] = ACTIONS(3447),
    [anon_sym_DQUOTE] = ACTIONS(3447),
    [anon_sym_SQUOTE] = ACTIONS(3447),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3447),
    [sym_number] = ACTIONS(3447),
    [sym_this] = ACTIONS(3445),
    [sym_true] = ACTIONS(3445),
    [sym_false] = ACTIONS(3445),
    [sym_null] = ACTIONS(3445),
    [sym_undefined] = ACTIONS(3445),
    [anon_sym_static] = ACTIONS(3445),
    [anon_sym_readonly] = ACTIONS(3445),
    [anon_sym_get] = ACTIONS(3445),
    [anon_sym_set] = ACTIONS(3445),
    [anon_sym_QMARK] = ACTIONS(3445),
    [anon_sym_any] = ACTIONS(3445),
    [anon_sym_number] = ACTIONS(3445),
    [anon_sym_boolean] = ACTIONS(3445),
    [anon_sym_string] = ACTIONS(3445),
    [anon_sym_symbol] = ACTIONS(3445),
    [anon_sym_abstract] = ACTIONS(3445),
    [anon_sym_satisfies] = ACTIONS(3445),
    [anon_sym_infer] = ACTIONS(3445),
    [anon_sym_keyof] = ACTIONS(3445),
    [anon_sym_unknown] = ACTIONS(3445),
    [anon_sym_never] = ACTIONS(3445),
    [anon_sym_object] = ACTIONS(3445),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3447),
    [anon_sym_constructor] = ACTIONS(3445),
    [anon_sym_prop] = ACTIONS(3445),
    [anon_sym_id] = ACTIONS(3445),
    [anon_sym_event] = ACTIONS(3445),
    [anon_sym_fn] = ACTIONS(3445),
    [anon_sym_on] = ACTIONS(3445),
    [sym__ternary_qmark] = ACTIONS(3447),
  },
  [1011] = {
    [sym_identifier] = ACTIONS(3449),
    [anon_sym_STAR] = ACTIONS(3449),
    [anon_sym_as] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3449),
    [anon_sym_RBRACE] = ACTIONS(3451),
    [anon_sym_typeof] = ACTIONS(3449),
    [anon_sym_BANG] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_in] = ACTIONS(3449),
    [anon_sym_SEMI] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_GT] = ACTIONS(3449),
    [anon_sym_SLASH] = ACTIONS(3449),
    [anon_sym_DOT] = ACTIONS(3449),
    [anon_sym_async] = ACTIONS(3449),
    [anon_sym_QMARK_DOT] = ACTIONS(3451),
    [anon_sym_new] = ACTIONS(3449),
    [anon_sym_AMP_AMP] = ACTIONS(3451),
    [anon_sym_PIPE_PIPE] = ACTIONS(3451),
    [anon_sym_GT_GT] = ACTIONS(3449),
    [anon_sym_GT_GT_GT] = ACTIONS(3451),
    [anon_sym_LT_LT] = ACTIONS(3451),
    [anon_sym_AMP] = ACTIONS(3449),
    [anon_sym_CARET] = ACTIONS(3451),
    [anon_sym_PIPE] = ACTIONS(3449),
    [anon_sym_PLUS] = ACTIONS(3449),
    [anon_sym_DASH] = ACTIONS(3449),
    [anon_sym_PERCENT] = ACTIONS(3451),
    [anon_sym_STAR_STAR] = ACTIONS(3451),
    [anon_sym_LT_EQ] = ACTIONS(3451),
    [anon_sym_EQ_EQ] = ACTIONS(3449),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3451),
    [anon_sym_BANG_EQ] = ACTIONS(3449),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3451),
    [anon_sym_GT_EQ] = ACTIONS(3451),
    [anon_sym_QMARK_QMARK] = ACTIONS(3451),
    [anon_sym_instanceof] = ACTIONS(3449),
    [anon_sym_void] = ACTIONS(3449),
    [anon_sym_PLUS_PLUS] = ACTIONS(3451),
    [anon_sym_DASH_DASH] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_SQUOTE] = ACTIONS(3451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3451),
    [sym_number] = ACTIONS(3451),
    [sym_this] = ACTIONS(3449),
    [sym_true] = ACTIONS(3449),
    [sym_false] = ACTIONS(3449),
    [sym_null] = ACTIONS(3449),
    [sym_undefined] = ACTIONS(3449),
    [anon_sym_static] = ACTIONS(3449),
    [anon_sym_readonly] = ACTIONS(3449),
    [anon_sym_get] = ACTIONS(3449),
    [anon_sym_set] = ACTIONS(3449),
    [anon_sym_QMARK] = ACTIONS(3449),
    [anon_sym_any] = ACTIONS(3449),
    [anon_sym_number] = ACTIONS(3449),
    [anon_sym_boolean] = ACTIONS(3449),
    [anon_sym_string] = ACTIONS(3449),
    [anon_sym_symbol] = ACTIONS(3449),
    [anon_sym_abstract] = ACTIONS(3449),
    [anon_sym_satisfies] = ACTIONS(3449),
    [anon_sym_infer] = ACTIONS(3449),
    [anon_sym_keyof] = ACTIONS(3449),
    [anon_sym_unknown] = ACTIONS(3449),
    [anon_sym_never] = ACTIONS(3449),
    [anon_sym_object] = ACTIONS(3449),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3451),
    [anon_sym_constructor] = ACTIONS(3449),
    [anon_sym_prop] = ACTIONS(3449),
    [anon_sym_id] = ACTIONS(3449),
    [anon_sym_event] = ACTIONS(3449),
    [anon_sym_fn] = ACTIONS(3449),
    [anon_sym_on] = ACTIONS(3449),
    [sym__ternary_qmark] = ACTIONS(3451),
  },
  [1012] = {
    [sym_identifier] = ACTIONS(3453),
    [anon_sym_STAR] = ACTIONS(3453),
    [anon_sym_as] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3453),
    [anon_sym_RBRACE] = ACTIONS(3455),
    [anon_sym_typeof] = ACTIONS(3453),
    [anon_sym_BANG] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3455),
    [anon_sym_in] = ACTIONS(3453),
    [anon_sym_SEMI] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3453),
    [anon_sym_GT] = ACTIONS(3453),
    [anon_sym_SLASH] = ACTIONS(3453),
    [anon_sym_DOT] = ACTIONS(3453),
    [anon_sym_async] = ACTIONS(3453),
    [anon_sym_QMARK_DOT] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3453),
    [anon_sym_AMP_AMP] = ACTIONS(3455),
    [anon_sym_PIPE_PIPE] = ACTIONS(3455),
    [anon_sym_GT_GT] = ACTIONS(3453),
    [anon_sym_GT_GT_GT] = ACTIONS(3455),
    [anon_sym_LT_LT] = ACTIONS(3455),
    [anon_sym_AMP] = ACTIONS(3453),
    [anon_sym_CARET] = ACTIONS(3455),
    [anon_sym_PIPE] = ACTIONS(3453),
    [anon_sym_PLUS] = ACTIONS(3453),
    [anon_sym_DASH] = ACTIONS(3453),
    [anon_sym_PERCENT] = ACTIONS(3455),
    [anon_sym_STAR_STAR] = ACTIONS(3455),
    [anon_sym_LT_EQ] = ACTIONS(3455),
    [anon_sym_EQ_EQ] = ACTIONS(3453),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3455),
    [anon_sym_BANG_EQ] = ACTIONS(3453),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3455),
    [anon_sym_GT_EQ] = ACTIONS(3455),
    [anon_sym_QMARK_QMARK] = ACTIONS(3455),
    [anon_sym_instanceof] = ACTIONS(3453),
    [anon_sym_void] = ACTIONS(3453),
    [anon_sym_PLUS_PLUS] = ACTIONS(3455),
    [anon_sym_DASH_DASH] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(3455),
    [anon_sym_SQUOTE] = ACTIONS(3455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3455),
    [sym_number] = ACTIONS(3455),
    [sym_this] = ACTIONS(3453),
    [sym_true] = ACTIONS(3453),
    [sym_false] = ACTIONS(3453),
    [sym_null] = ACTIONS(3453),
    [sym_undefined] = ACTIONS(3453),
    [anon_sym_static] = ACTIONS(3453),
    [anon_sym_readonly] = ACTIONS(3453),
    [anon_sym_get] = ACTIONS(3453),
    [anon_sym_set] = ACTIONS(3453),
    [anon_sym_QMARK] = ACTIONS(3453),
    [anon_sym_any] = ACTIONS(3453),
    [anon_sym_number] = ACTIONS(3453),
    [anon_sym_boolean] = ACTIONS(3453),
    [anon_sym_string] = ACTIONS(3453),
    [anon_sym_symbol] = ACTIONS(3453),
    [anon_sym_abstract] = ACTIONS(3453),
    [anon_sym_satisfies] = ACTIONS(3453),
    [anon_sym_infer] = ACTIONS(3453),
    [anon_sym_keyof] = ACTIONS(3453),
    [anon_sym_unknown] = ACTIONS(3453),
    [anon_sym_never] = ACTIONS(3453),
    [anon_sym_object] = ACTIONS(3453),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3455),
    [anon_sym_constructor] = ACTIONS(3453),
    [anon_sym_prop] = ACTIONS(3453),
    [anon_sym_id] = ACTIONS(3453),
    [anon_sym_event] = ACTIONS(3453),
    [anon_sym_fn] = ACTIONS(3453),
    [anon_sym_on] = ACTIONS(3453),
    [sym__ternary_qmark] = ACTIONS(3455),
  },
  [1013] = {
    [sym_identifier] = ACTIONS(1738),
    [anon_sym_STAR] = ACTIONS(1738),
    [anon_sym_as] = ACTIONS(1738),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_RBRACE] = ACTIONS(1742),
    [anon_sym_typeof] = ACTIONS(1738),
    [anon_sym_BANG] = ACTIONS(1738),
    [anon_sym_LPAREN] = ACTIONS(1742),
    [anon_sym_in] = ACTIONS(1738),
    [anon_sym_SEMI] = ACTIONS(1742),
    [anon_sym_LBRACK] = ACTIONS(1742),
    [anon_sym_LT] = ACTIONS(1738),
    [anon_sym_GT] = ACTIONS(1738),
    [anon_sym_SLASH] = ACTIONS(1738),
    [anon_sym_DOT] = ACTIONS(1738),
    [anon_sym_async] = ACTIONS(1738),
    [anon_sym_QMARK_DOT] = ACTIONS(1742),
    [anon_sym_new] = ACTIONS(1738),
    [anon_sym_AMP_AMP] = ACTIONS(1742),
    [anon_sym_PIPE_PIPE] = ACTIONS(1742),
    [anon_sym_GT_GT] = ACTIONS(1738),
    [anon_sym_GT_GT_GT] = ACTIONS(1742),
    [anon_sym_LT_LT] = ACTIONS(1742),
    [anon_sym_AMP] = ACTIONS(1738),
    [anon_sym_CARET] = ACTIONS(1742),
    [anon_sym_PIPE] = ACTIONS(1738),
    [anon_sym_PLUS] = ACTIONS(1738),
    [anon_sym_DASH] = ACTIONS(1738),
    [anon_sym_PERCENT] = ACTIONS(1742),
    [anon_sym_STAR_STAR] = ACTIONS(1742),
    [anon_sym_LT_EQ] = ACTIONS(1742),
    [anon_sym_EQ_EQ] = ACTIONS(1738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1742),
    [anon_sym_BANG_EQ] = ACTIONS(1738),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1742),
    [anon_sym_GT_EQ] = ACTIONS(1742),
    [anon_sym_QMARK_QMARK] = ACTIONS(1742),
    [anon_sym_instanceof] = ACTIONS(1738),
    [anon_sym_void] = ACTIONS(1738),
    [anon_sym_PLUS_PLUS] = ACTIONS(1742),
    [anon_sym_DASH_DASH] = ACTIONS(1742),
    [anon_sym_DQUOTE] = ACTIONS(1742),
    [anon_sym_SQUOTE] = ACTIONS(1742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1742),
    [sym_number] = ACTIONS(1742),
    [sym_this] = ACTIONS(1738),
    [sym_true] = ACTIONS(1738),
    [sym_false] = ACTIONS(1738),
    [sym_null] = ACTIONS(1738),
    [sym_undefined] = ACTIONS(1738),
    [anon_sym_static] = ACTIONS(1738),
    [anon_sym_readonly] = ACTIONS(1738),
    [anon_sym_get] = ACTIONS(1738),
    [anon_sym_set] = ACTIONS(1738),
    [anon_sym_QMARK] = ACTIONS(1738),
    [anon_sym_any] = ACTIONS(1738),
    [anon_sym_number] = ACTIONS(1738),
    [anon_sym_boolean] = ACTIONS(1738),
    [anon_sym_string] = ACTIONS(1738),
    [anon_sym_symbol] = ACTIONS(1738),
    [anon_sym_abstract] = ACTIONS(1738),
    [anon_sym_satisfies] = ACTIONS(1738),
    [anon_sym_infer] = ACTIONS(1738),
    [anon_sym_keyof] = ACTIONS(1738),
    [anon_sym_unknown] = ACTIONS(1738),
    [anon_sym_never] = ACTIONS(1738),
    [anon_sym_object] = ACTIONS(1738),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1742),
    [anon_sym_constructor] = ACTIONS(1738),
    [anon_sym_prop] = ACTIONS(1738),
    [anon_sym_id] = ACTIONS(1738),
    [anon_sym_event] = ACTIONS(1738),
    [anon_sym_fn] = ACTIONS(1738),
    [anon_sym_on] = ACTIONS(1738),
    [sym__ternary_qmark] = ACTIONS(1742),
  },
  [1014] = {
    [sym_identifier] = ACTIONS(3457),
    [anon_sym_STAR] = ACTIONS(3457),
    [anon_sym_as] = ACTIONS(3457),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_typeof] = ACTIONS(3457),
    [anon_sym_BANG] = ACTIONS(3457),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_in] = ACTIONS(3457),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LT] = ACTIONS(3457),
    [anon_sym_GT] = ACTIONS(3457),
    [anon_sym_SLASH] = ACTIONS(3457),
    [anon_sym_DOT] = ACTIONS(3457),
    [anon_sym_async] = ACTIONS(3457),
    [anon_sym_QMARK_DOT] = ACTIONS(3459),
    [anon_sym_new] = ACTIONS(3457),
    [anon_sym_AMP_AMP] = ACTIONS(3459),
    [anon_sym_PIPE_PIPE] = ACTIONS(3459),
    [anon_sym_GT_GT] = ACTIONS(3457),
    [anon_sym_GT_GT_GT] = ACTIONS(3459),
    [anon_sym_LT_LT] = ACTIONS(3459),
    [anon_sym_AMP] = ACTIONS(3457),
    [anon_sym_CARET] = ACTIONS(3459),
    [anon_sym_PIPE] = ACTIONS(3457),
    [anon_sym_PLUS] = ACTIONS(3457),
    [anon_sym_DASH] = ACTIONS(3457),
    [anon_sym_PERCENT] = ACTIONS(3459),
    [anon_sym_STAR_STAR] = ACTIONS(3459),
    [anon_sym_LT_EQ] = ACTIONS(3459),
    [anon_sym_EQ_EQ] = ACTIONS(3457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3459),
    [anon_sym_BANG_EQ] = ACTIONS(3457),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3459),
    [anon_sym_GT_EQ] = ACTIONS(3459),
    [anon_sym_QMARK_QMARK] = ACTIONS(3459),
    [anon_sym_instanceof] = ACTIONS(3457),
    [anon_sym_void] = ACTIONS(3457),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [anon_sym_DQUOTE] = ACTIONS(3459),
    [anon_sym_SQUOTE] = ACTIONS(3459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3459),
    [sym_number] = ACTIONS(3459),
    [sym_this] = ACTIONS(3457),
    [sym_true] = ACTIONS(3457),
    [sym_false] = ACTIONS(3457),
    [sym_null] = ACTIONS(3457),
    [sym_undefined] = ACTIONS(3457),
    [anon_sym_static] = ACTIONS(3457),
    [anon_sym_readonly] = ACTIONS(3457),
    [anon_sym_get] = ACTIONS(3457),
    [anon_sym_set] = ACTIONS(3457),
    [anon_sym_QMARK] = ACTIONS(3457),
    [anon_sym_any] = ACTIONS(3457),
    [anon_sym_number] = ACTIONS(3457),
    [anon_sym_boolean] = ACTIONS(3457),
    [anon_sym_string] = ACTIONS(3457),
    [anon_sym_symbol] = ACTIONS(3457),
    [anon_sym_abstract] = ACTIONS(3457),
    [anon_sym_satisfies] = ACTIONS(3457),
    [anon_sym_infer] = ACTIONS(3457),
    [anon_sym_keyof] = ACTIONS(3457),
    [anon_sym_unknown] = ACTIONS(3457),
    [anon_sym_never] = ACTIONS(3457),
    [anon_sym_object] = ACTIONS(3457),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3459),
    [anon_sym_constructor] = ACTIONS(3457),
    [anon_sym_prop] = ACTIONS(3457),
    [anon_sym_id] = ACTIONS(3457),
    [anon_sym_event] = ACTIONS(3457),
    [anon_sym_fn] = ACTIONS(3457),
    [anon_sym_on] = ACTIONS(3457),
    [sym__ternary_qmark] = ACTIONS(3459),
  },
  [1015] = {
    [sym_identifier] = ACTIONS(3461),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_as] = ACTIONS(3461),
    [anon_sym_LBRACE] = ACTIONS(3461),
    [anon_sym_RBRACE] = ACTIONS(3463),
    [anon_sym_typeof] = ACTIONS(3461),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_LPAREN] = ACTIONS(3463),
    [anon_sym_in] = ACTIONS(3461),
    [anon_sym_SEMI] = ACTIONS(3463),
    [anon_sym_LBRACK] = ACTIONS(3463),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_SLASH] = ACTIONS(3461),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_async] = ACTIONS(3461),
    [anon_sym_QMARK_DOT] = ACTIONS(3463),
    [anon_sym_new] = ACTIONS(3461),
    [anon_sym_AMP_AMP] = ACTIONS(3463),
    [anon_sym_PIPE_PIPE] = ACTIONS(3463),
    [anon_sym_GT_GT] = ACTIONS(3461),
    [anon_sym_GT_GT_GT] = ACTIONS(3463),
    [anon_sym_LT_LT] = ACTIONS(3463),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3463),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_PLUS] = ACTIONS(3461),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3463),
    [anon_sym_STAR_STAR] = ACTIONS(3463),
    [anon_sym_LT_EQ] = ACTIONS(3463),
    [anon_sym_EQ_EQ] = ACTIONS(3461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3463),
    [anon_sym_BANG_EQ] = ACTIONS(3461),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3463),
    [anon_sym_GT_EQ] = ACTIONS(3463),
    [anon_sym_QMARK_QMARK] = ACTIONS(3463),
    [anon_sym_instanceof] = ACTIONS(3461),
    [anon_sym_void] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3463),
    [anon_sym_DASH_DASH] = ACTIONS(3463),
    [anon_sym_DQUOTE] = ACTIONS(3463),
    [anon_sym_SQUOTE] = ACTIONS(3463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3463),
    [sym_number] = ACTIONS(3463),
    [sym_this] = ACTIONS(3461),
    [sym_true] = ACTIONS(3461),
    [sym_false] = ACTIONS(3461),
    [sym_null] = ACTIONS(3461),
    [sym_undefined] = ACTIONS(3461),
    [anon_sym_static] = ACTIONS(3461),
    [anon_sym_readonly] = ACTIONS(3461),
    [anon_sym_get] = ACTIONS(3461),
    [anon_sym_set] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_any] = ACTIONS(3461),
    [anon_sym_number] = ACTIONS(3461),
    [anon_sym_boolean] = ACTIONS(3461),
    [anon_sym_string] = ACTIONS(3461),
    [anon_sym_symbol] = ACTIONS(3461),
    [anon_sym_abstract] = ACTIONS(3461),
    [anon_sym_satisfies] = ACTIONS(3461),
    [anon_sym_infer] = ACTIONS(3461),
    [anon_sym_keyof] = ACTIONS(3461),
    [anon_sym_unknown] = ACTIONS(3461),
    [anon_sym_never] = ACTIONS(3461),
    [anon_sym_object] = ACTIONS(3461),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3463),
    [anon_sym_constructor] = ACTIONS(3461),
    [anon_sym_prop] = ACTIONS(3461),
    [anon_sym_id] = ACTIONS(3461),
    [anon_sym_event] = ACTIONS(3461),
    [anon_sym_fn] = ACTIONS(3461),
    [anon_sym_on] = ACTIONS(3461),
    [sym__ternary_qmark] = ACTIONS(3463),
  },
  [1016] = {
    [sym_identifier] = ACTIONS(3465),
    [anon_sym_STAR] = ACTIONS(3465),
    [anon_sym_as] = ACTIONS(3465),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_RBRACE] = ACTIONS(3467),
    [anon_sym_typeof] = ACTIONS(3465),
    [anon_sym_BANG] = ACTIONS(3465),
    [anon_sym_LPAREN] = ACTIONS(3467),
    [anon_sym_in] = ACTIONS(3465),
    [anon_sym_SEMI] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3467),
    [anon_sym_LT] = ACTIONS(3465),
    [anon_sym_GT] = ACTIONS(3465),
    [anon_sym_SLASH] = ACTIONS(3465),
    [anon_sym_DOT] = ACTIONS(3465),
    [anon_sym_async] = ACTIONS(3465),
    [anon_sym_QMARK_DOT] = ACTIONS(3467),
    [anon_sym_new] = ACTIONS(3465),
    [anon_sym_AMP_AMP] = ACTIONS(3467),
    [anon_sym_PIPE_PIPE] = ACTIONS(3467),
    [anon_sym_GT_GT] = ACTIONS(3465),
    [anon_sym_GT_GT_GT] = ACTIONS(3467),
    [anon_sym_LT_LT] = ACTIONS(3467),
    [anon_sym_AMP] = ACTIONS(3465),
    [anon_sym_CARET] = ACTIONS(3467),
    [anon_sym_PIPE] = ACTIONS(3465),
    [anon_sym_PLUS] = ACTIONS(3465),
    [anon_sym_DASH] = ACTIONS(3465),
    [anon_sym_PERCENT] = ACTIONS(3467),
    [anon_sym_STAR_STAR] = ACTIONS(3467),
    [anon_sym_LT_EQ] = ACTIONS(3467),
    [anon_sym_EQ_EQ] = ACTIONS(3465),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3467),
    [anon_sym_BANG_EQ] = ACTIONS(3465),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3467),
    [anon_sym_GT_EQ] = ACTIONS(3467),
    [anon_sym_QMARK_QMARK] = ACTIONS(3467),
    [anon_sym_instanceof] = ACTIONS(3465),
    [anon_sym_void] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3467),
    [anon_sym_DASH_DASH] = ACTIONS(3467),
    [anon_sym_DQUOTE] = ACTIONS(3467),
    [anon_sym_SQUOTE] = ACTIONS(3467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3467),
    [sym_number] = ACTIONS(3467),
    [sym_this] = ACTIONS(3465),
    [sym_true] = ACTIONS(3465),
    [sym_false] = ACTIONS(3465),
    [sym_null] = ACTIONS(3465),
    [sym_undefined] = ACTIONS(3465),
    [anon_sym_static] = ACTIONS(3465),
    [anon_sym_readonly] = ACTIONS(3465),
    [anon_sym_get] = ACTIONS(3465),
    [anon_sym_set] = ACTIONS(3465),
    [anon_sym_QMARK] = ACTIONS(3465),
    [anon_sym_any] = ACTIONS(3465),
    [anon_sym_number] = ACTIONS(3465),
    [anon_sym_boolean] = ACTIONS(3465),
    [anon_sym_string] = ACTIONS(3465),
    [anon_sym_symbol] = ACTIONS(3465),
    [anon_sym_abstract] = ACTIONS(3465),
    [anon_sym_satisfies] = ACTIONS(3465),
    [anon_sym_infer] = ACTIONS(3465),
    [anon_sym_keyof] = ACTIONS(3465),
    [anon_sym_unknown] = ACTIONS(3465),
    [anon_sym_never] = ACTIONS(3465),
    [anon_sym_object] = ACTIONS(3465),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3467),
    [anon_sym_constructor] = ACTIONS(3465),
    [anon_sym_prop] = ACTIONS(3465),
    [anon_sym_id] = ACTIONS(3465),
    [anon_sym_event] = ACTIONS(3465),
    [anon_sym_fn] = ACTIONS(3465),
    [anon_sym_on] = ACTIONS(3465),
    [sym__ternary_qmark] = ACTIONS(3467),
  },
  [1017] = {
    [sym_identifier] = ACTIONS(1586),
    [anon_sym_STAR] = ACTIONS(1586),
    [anon_sym_as] = ACTIONS(1586),
    [anon_sym_LBRACE] = ACTIONS(1586),
    [anon_sym_RBRACE] = ACTIONS(1590),
    [anon_sym_typeof] = ACTIONS(1586),
    [anon_sym_BANG] = ACTIONS(1586),
    [anon_sym_LPAREN] = ACTIONS(1590),
    [anon_sym_in] = ACTIONS(1586),
    [anon_sym_SEMI] = ACTIONS(1590),
    [anon_sym_LBRACK] = ACTIONS(1590),
    [anon_sym_LT] = ACTIONS(1586),
    [anon_sym_GT] = ACTIONS(1586),
    [anon_sym_SLASH] = ACTIONS(1586),
    [anon_sym_DOT] = ACTIONS(1586),
    [anon_sym_async] = ACTIONS(1586),
    [anon_sym_QMARK_DOT] = ACTIONS(1590),
    [anon_sym_new] = ACTIONS(1586),
    [anon_sym_AMP_AMP] = ACTIONS(1590),
    [anon_sym_PIPE_PIPE] = ACTIONS(1590),
    [anon_sym_GT_GT] = ACTIONS(1586),
    [anon_sym_GT_GT_GT] = ACTIONS(1590),
    [anon_sym_LT_LT] = ACTIONS(1590),
    [anon_sym_AMP] = ACTIONS(1586),
    [anon_sym_CARET] = ACTIONS(1590),
    [anon_sym_PIPE] = ACTIONS(1586),
    [anon_sym_PLUS] = ACTIONS(1586),
    [anon_sym_DASH] = ACTIONS(1586),
    [anon_sym_PERCENT] = ACTIONS(1590),
    [anon_sym_STAR_STAR] = ACTIONS(1590),
    [anon_sym_LT_EQ] = ACTIONS(1590),
    [anon_sym_EQ_EQ] = ACTIONS(1586),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1590),
    [anon_sym_BANG_EQ] = ACTIONS(1586),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1590),
    [anon_sym_GT_EQ] = ACTIONS(1590),
    [anon_sym_QMARK_QMARK] = ACTIONS(1590),
    [anon_sym_instanceof] = ACTIONS(1586),
    [anon_sym_void] = ACTIONS(1586),
    [anon_sym_PLUS_PLUS] = ACTIONS(1590),
    [anon_sym_DASH_DASH] = ACTIONS(1590),
    [anon_sym_DQUOTE] = ACTIONS(1590),
    [anon_sym_SQUOTE] = ACTIONS(1590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1590),
    [sym_number] = ACTIONS(1590),
    [sym_this] = ACTIONS(1586),
    [sym_true] = ACTIONS(1586),
    [sym_false] = ACTIONS(1586),
    [sym_null] = ACTIONS(1586),
    [sym_undefined] = ACTIONS(1586),
    [anon_sym_static] = ACTIONS(1586),
    [anon_sym_readonly] = ACTIONS(1586),
    [anon_sym_get] = ACTIONS(1586),
    [anon_sym_set] = ACTIONS(1586),
    [anon_sym_QMARK] = ACTIONS(1586),
    [anon_sym_any] = ACTIONS(1586),
    [anon_sym_number] = ACTIONS(1586),
    [anon_sym_boolean] = ACTIONS(1586),
    [anon_sym_string] = ACTIONS(1586),
    [anon_sym_symbol] = ACTIONS(1586),
    [anon_sym_abstract] = ACTIONS(1586),
    [anon_sym_satisfies] = ACTIONS(1586),
    [anon_sym_infer] = ACTIONS(1586),
    [anon_sym_keyof] = ACTIONS(1586),
    [anon_sym_unknown] = ACTIONS(1586),
    [anon_sym_never] = ACTIONS(1586),
    [anon_sym_object] = ACTIONS(1586),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1590),
    [anon_sym_constructor] = ACTIONS(1586),
    [anon_sym_prop] = ACTIONS(1586),
    [anon_sym_id] = ACTIONS(1586),
    [anon_sym_event] = ACTIONS(1586),
    [anon_sym_fn] = ACTIONS(1586),
    [anon_sym_on] = ACTIONS(1586),
    [sym__ternary_qmark] = ACTIONS(1590),
  },
  [1018] = {
    [sym_identifier] = ACTIONS(1524),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_as] = ACTIONS(1524),
    [anon_sym_LBRACE] = ACTIONS(1524),
    [anon_sym_RBRACE] = ACTIONS(1526),
    [anon_sym_typeof] = ACTIONS(1524),
    [anon_sym_BANG] = ACTIONS(1524),
    [anon_sym_LPAREN] = ACTIONS(1526),
    [anon_sym_in] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1526),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_GT] = ACTIONS(1524),
    [anon_sym_SLASH] = ACTIONS(1524),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_async] = ACTIONS(1524),
    [anon_sym_QMARK_DOT] = ACTIONS(1526),
    [anon_sym_new] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1526),
    [anon_sym_PIPE_PIPE] = ACTIONS(1526),
    [anon_sym_GT_GT] = ACTIONS(1524),
    [anon_sym_GT_GT_GT] = ACTIONS(1526),
    [anon_sym_LT_LT] = ACTIONS(1526),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_CARET] = ACTIONS(1526),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_PLUS] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1524),
    [anon_sym_PERCENT] = ACTIONS(1526),
    [anon_sym_STAR_STAR] = ACTIONS(1526),
    [anon_sym_LT_EQ] = ACTIONS(1526),
    [anon_sym_EQ_EQ] = ACTIONS(1524),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1526),
    [anon_sym_BANG_EQ] = ACTIONS(1524),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1526),
    [anon_sym_GT_EQ] = ACTIONS(1526),
    [anon_sym_QMARK_QMARK] = ACTIONS(1526),
    [anon_sym_instanceof] = ACTIONS(1524),
    [anon_sym_void] = ACTIONS(1524),
    [anon_sym_PLUS_PLUS] = ACTIONS(1526),
    [anon_sym_DASH_DASH] = ACTIONS(1526),
    [anon_sym_DQUOTE] = ACTIONS(1526),
    [anon_sym_SQUOTE] = ACTIONS(1526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1526),
    [sym_number] = ACTIONS(1526),
    [sym_this] = ACTIONS(1524),
    [sym_true] = ACTIONS(1524),
    [sym_false] = ACTIONS(1524),
    [sym_null] = ACTIONS(1524),
    [sym_undefined] = ACTIONS(1524),
    [anon_sym_static] = ACTIONS(1524),
    [anon_sym_readonly] = ACTIONS(1524),
    [anon_sym_get] = ACTIONS(1524),
    [anon_sym_set] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(1524),
    [anon_sym_any] = ACTIONS(1524),
    [anon_sym_number] = ACTIONS(1524),
    [anon_sym_boolean] = ACTIONS(1524),
    [anon_sym_string] = ACTIONS(1524),
    [anon_sym_symbol] = ACTIONS(1524),
    [anon_sym_abstract] = ACTIONS(1524),
    [anon_sym_satisfies] = ACTIONS(1524),
    [anon_sym_infer] = ACTIONS(1524),
    [anon_sym_keyof] = ACTIONS(1524),
    [anon_sym_unknown] = ACTIONS(1524),
    [anon_sym_never] = ACTIONS(1524),
    [anon_sym_object] = ACTIONS(1524),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1526),
    [anon_sym_constructor] = ACTIONS(1524),
    [anon_sym_prop] = ACTIONS(1524),
    [anon_sym_id] = ACTIONS(1524),
    [anon_sym_event] = ACTIONS(1524),
    [anon_sym_fn] = ACTIONS(1524),
    [anon_sym_on] = ACTIONS(1524),
    [sym__ternary_qmark] = ACTIONS(1526),
  },
  [1019] = {
    [sym_identifier] = ACTIONS(1404),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_as] = ACTIONS(1404),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_RBRACE] = ACTIONS(1408),
    [anon_sym_typeof] = ACTIONS(1404),
    [anon_sym_BANG] = ACTIONS(1404),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(1404),
    [anon_sym_SEMI] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1408),
    [anon_sym_LT] = ACTIONS(1404),
    [anon_sym_GT] = ACTIONS(1404),
    [anon_sym_SLASH] = ACTIONS(1404),
    [anon_sym_DOT] = ACTIONS(1404),
    [anon_sym_async] = ACTIONS(1404),
    [anon_sym_QMARK_DOT] = ACTIONS(1408),
    [anon_sym_new] = ACTIONS(1404),
    [anon_sym_AMP_AMP] = ACTIONS(1408),
    [anon_sym_PIPE_PIPE] = ACTIONS(1408),
    [anon_sym_GT_GT] = ACTIONS(1404),
    [anon_sym_GT_GT_GT] = ACTIONS(1408),
    [anon_sym_LT_LT] = ACTIONS(1408),
    [anon_sym_AMP] = ACTIONS(1404),
    [anon_sym_CARET] = ACTIONS(1408),
    [anon_sym_PIPE] = ACTIONS(1404),
    [anon_sym_PLUS] = ACTIONS(1404),
    [anon_sym_DASH] = ACTIONS(1404),
    [anon_sym_PERCENT] = ACTIONS(1408),
    [anon_sym_STAR_STAR] = ACTIONS(1408),
    [anon_sym_LT_EQ] = ACTIONS(1408),
    [anon_sym_EQ_EQ] = ACTIONS(1404),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1408),
    [anon_sym_BANG_EQ] = ACTIONS(1404),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1408),
    [anon_sym_GT_EQ] = ACTIONS(1408),
    [anon_sym_QMARK_QMARK] = ACTIONS(1408),
    [anon_sym_instanceof] = ACTIONS(1404),
    [anon_sym_void] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1408),
    [anon_sym_DASH_DASH] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1408),
    [anon_sym_SQUOTE] = ACTIONS(1408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1408),
    [sym_number] = ACTIONS(1408),
    [sym_this] = ACTIONS(1404),
    [sym_true] = ACTIONS(1404),
    [sym_false] = ACTIONS(1404),
    [sym_null] = ACTIONS(1404),
    [sym_undefined] = ACTIONS(1404),
    [anon_sym_static] = ACTIONS(1404),
    [anon_sym_readonly] = ACTIONS(1404),
    [anon_sym_get] = ACTIONS(1404),
    [anon_sym_set] = ACTIONS(1404),
    [anon_sym_QMARK] = ACTIONS(1404),
    [anon_sym_any] = ACTIONS(1404),
    [anon_sym_number] = ACTIONS(1404),
    [anon_sym_boolean] = ACTIONS(1404),
    [anon_sym_string] = ACTIONS(1404),
    [anon_sym_symbol] = ACTIONS(1404),
    [anon_sym_abstract] = ACTIONS(1404),
    [anon_sym_satisfies] = ACTIONS(1404),
    [anon_sym_infer] = ACTIONS(1404),
    [anon_sym_keyof] = ACTIONS(1404),
    [anon_sym_unknown] = ACTIONS(1404),
    [anon_sym_never] = ACTIONS(1404),
    [anon_sym_object] = ACTIONS(1404),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1408),
    [anon_sym_constructor] = ACTIONS(1404),
    [anon_sym_prop] = ACTIONS(1404),
    [anon_sym_id] = ACTIONS(1404),
    [anon_sym_event] = ACTIONS(1404),
    [anon_sym_fn] = ACTIONS(1404),
    [anon_sym_on] = ACTIONS(1404),
    [sym__ternary_qmark] = ACTIONS(1408),
  },
  [1020] = {
    [sym_identifier] = ACTIONS(1576),
    [anon_sym_STAR] = ACTIONS(1576),
    [anon_sym_as] = ACTIONS(1576),
    [anon_sym_LBRACE] = ACTIONS(1576),
    [anon_sym_RBRACE] = ACTIONS(1580),
    [anon_sym_typeof] = ACTIONS(1576),
    [anon_sym_BANG] = ACTIONS(1576),
    [anon_sym_LPAREN] = ACTIONS(1580),
    [anon_sym_in] = ACTIONS(1576),
    [anon_sym_SEMI] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1580),
    [anon_sym_LT] = ACTIONS(1576),
    [anon_sym_GT] = ACTIONS(1576),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_DOT] = ACTIONS(1576),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_QMARK_DOT] = ACTIONS(1580),
    [anon_sym_new] = ACTIONS(1576),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_GT_GT] = ACTIONS(1576),
    [anon_sym_GT_GT_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1576),
    [anon_sym_CARET] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1576),
    [anon_sym_PLUS] = ACTIONS(1576),
    [anon_sym_DASH] = ACTIONS(1576),
    [anon_sym_PERCENT] = ACTIONS(1580),
    [anon_sym_STAR_STAR] = ACTIONS(1580),
    [anon_sym_LT_EQ] = ACTIONS(1580),
    [anon_sym_EQ_EQ] = ACTIONS(1576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ] = ACTIONS(1576),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1580),
    [anon_sym_GT_EQ] = ACTIONS(1580),
    [anon_sym_QMARK_QMARK] = ACTIONS(1580),
    [anon_sym_instanceof] = ACTIONS(1576),
    [anon_sym_void] = ACTIONS(1576),
    [anon_sym_PLUS_PLUS] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1580),
    [anon_sym_DQUOTE] = ACTIONS(1580),
    [anon_sym_SQUOTE] = ACTIONS(1580),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1580),
    [sym_number] = ACTIONS(1580),
    [sym_this] = ACTIONS(1576),
    [sym_true] = ACTIONS(1576),
    [sym_false] = ACTIONS(1576),
    [sym_null] = ACTIONS(1576),
    [sym_undefined] = ACTIONS(1576),
    [anon_sym_static] = ACTIONS(1576),
    [anon_sym_readonly] = ACTIONS(1576),
    [anon_sym_get] = ACTIONS(1576),
    [anon_sym_set] = ACTIONS(1576),
    [anon_sym_QMARK] = ACTIONS(1576),
    [anon_sym_any] = ACTIONS(1576),
    [anon_sym_number] = ACTIONS(1576),
    [anon_sym_boolean] = ACTIONS(1576),
    [anon_sym_string] = ACTIONS(1576),
    [anon_sym_symbol] = ACTIONS(1576),
    [anon_sym_abstract] = ACTIONS(1576),
    [anon_sym_satisfies] = ACTIONS(1576),
    [anon_sym_infer] = ACTIONS(1576),
    [anon_sym_keyof] = ACTIONS(1576),
    [anon_sym_unknown] = ACTIONS(1576),
    [anon_sym_never] = ACTIONS(1576),
    [anon_sym_object] = ACTIONS(1576),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1580),
    [anon_sym_constructor] = ACTIONS(1576),
    [anon_sym_prop] = ACTIONS(1576),
    [anon_sym_id] = ACTIONS(1576),
    [anon_sym_event] = ACTIONS(1576),
    [anon_sym_fn] = ACTIONS(1576),
    [anon_sym_on] = ACTIONS(1576),
    [sym__ternary_qmark] = ACTIONS(1580),
  },
  [1021] = {
    [sym_identifier] = ACTIONS(3469),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_as] = ACTIONS(3469),
    [anon_sym_LBRACE] = ACTIONS(3469),
    [anon_sym_RBRACE] = ACTIONS(3471),
    [anon_sym_typeof] = ACTIONS(3469),
    [anon_sym_BANG] = ACTIONS(3469),
    [anon_sym_LPAREN] = ACTIONS(3471),
    [anon_sym_in] = ACTIONS(3469),
    [anon_sym_SEMI] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3471),
    [anon_sym_LT] = ACTIONS(3469),
    [anon_sym_GT] = ACTIONS(3469),
    [anon_sym_SLASH] = ACTIONS(3469),
    [anon_sym_DOT] = ACTIONS(3469),
    [anon_sym_async] = ACTIONS(3469),
    [anon_sym_QMARK_DOT] = ACTIONS(3471),
    [anon_sym_new] = ACTIONS(3469),
    [anon_sym_AMP_AMP] = ACTIONS(3471),
    [anon_sym_PIPE_PIPE] = ACTIONS(3471),
    [anon_sym_GT_GT] = ACTIONS(3469),
    [anon_sym_GT_GT_GT] = ACTIONS(3471),
    [anon_sym_LT_LT] = ACTIONS(3471),
    [anon_sym_AMP] = ACTIONS(3469),
    [anon_sym_CARET] = ACTIONS(3471),
    [anon_sym_PIPE] = ACTIONS(3469),
    [anon_sym_PLUS] = ACTIONS(3469),
    [anon_sym_DASH] = ACTIONS(3469),
    [anon_sym_PERCENT] = ACTIONS(3471),
    [anon_sym_STAR_STAR] = ACTIONS(3471),
    [anon_sym_LT_EQ] = ACTIONS(3471),
    [anon_sym_EQ_EQ] = ACTIONS(3469),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3471),
    [anon_sym_BANG_EQ] = ACTIONS(3469),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3471),
    [anon_sym_GT_EQ] = ACTIONS(3471),
    [anon_sym_QMARK_QMARK] = ACTIONS(3471),
    [anon_sym_instanceof] = ACTIONS(3469),
    [anon_sym_void] = ACTIONS(3469),
    [anon_sym_PLUS_PLUS] = ACTIONS(3471),
    [anon_sym_DASH_DASH] = ACTIONS(3471),
    [anon_sym_DQUOTE] = ACTIONS(3471),
    [anon_sym_SQUOTE] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3471),
    [sym_number] = ACTIONS(3471),
    [sym_this] = ACTIONS(3469),
    [sym_true] = ACTIONS(3469),
    [sym_false] = ACTIONS(3469),
    [sym_null] = ACTIONS(3469),
    [sym_undefined] = ACTIONS(3469),
    [anon_sym_static] = ACTIONS(3469),
    [anon_sym_readonly] = ACTIONS(3469),
    [anon_sym_get] = ACTIONS(3469),
    [anon_sym_set] = ACTIONS(3469),
    [anon_sym_QMARK] = ACTIONS(3469),
    [anon_sym_any] = ACTIONS(3469),
    [anon_sym_number] = ACTIONS(3469),
    [anon_sym_boolean] = ACTIONS(3469),
    [anon_sym_string] = ACTIONS(3469),
    [anon_sym_symbol] = ACTIONS(3469),
    [anon_sym_abstract] = ACTIONS(3469),
    [anon_sym_satisfies] = ACTIONS(3469),
    [anon_sym_infer] = ACTIONS(3469),
    [anon_sym_keyof] = ACTIONS(3469),
    [anon_sym_unknown] = ACTIONS(3469),
    [anon_sym_never] = ACTIONS(3469),
    [anon_sym_object] = ACTIONS(3469),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3471),
    [anon_sym_constructor] = ACTIONS(3469),
    [anon_sym_prop] = ACTIONS(3469),
    [anon_sym_id] = ACTIONS(3469),
    [anon_sym_event] = ACTIONS(3469),
    [anon_sym_fn] = ACTIONS(3469),
    [anon_sym_on] = ACTIONS(3469),
    [sym__ternary_qmark] = ACTIONS(3471),
  },
  [1022] = {
    [sym_identifier] = ACTIONS(3473),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_as] = ACTIONS(3473),
    [anon_sym_LBRACE] = ACTIONS(3473),
    [anon_sym_RBRACE] = ACTIONS(3475),
    [anon_sym_typeof] = ACTIONS(3473),
    [anon_sym_BANG] = ACTIONS(3473),
    [anon_sym_LPAREN] = ACTIONS(3475),
    [anon_sym_in] = ACTIONS(3473),
    [anon_sym_SEMI] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3475),
    [anon_sym_LT] = ACTIONS(3473),
    [anon_sym_GT] = ACTIONS(3473),
    [anon_sym_SLASH] = ACTIONS(3473),
    [anon_sym_DOT] = ACTIONS(3473),
    [anon_sym_async] = ACTIONS(3473),
    [anon_sym_QMARK_DOT] = ACTIONS(3475),
    [anon_sym_new] = ACTIONS(3473),
    [anon_sym_AMP_AMP] = ACTIONS(3475),
    [anon_sym_PIPE_PIPE] = ACTIONS(3475),
    [anon_sym_GT_GT] = ACTIONS(3473),
    [anon_sym_GT_GT_GT] = ACTIONS(3475),
    [anon_sym_LT_LT] = ACTIONS(3475),
    [anon_sym_AMP] = ACTIONS(3473),
    [anon_sym_CARET] = ACTIONS(3475),
    [anon_sym_PIPE] = ACTIONS(3473),
    [anon_sym_PLUS] = ACTIONS(3473),
    [anon_sym_DASH] = ACTIONS(3473),
    [anon_sym_PERCENT] = ACTIONS(3475),
    [anon_sym_STAR_STAR] = ACTIONS(3475),
    [anon_sym_LT_EQ] = ACTIONS(3475),
    [anon_sym_EQ_EQ] = ACTIONS(3473),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3475),
    [anon_sym_BANG_EQ] = ACTIONS(3473),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3475),
    [anon_sym_GT_EQ] = ACTIONS(3475),
    [anon_sym_QMARK_QMARK] = ACTIONS(3475),
    [anon_sym_instanceof] = ACTIONS(3473),
    [anon_sym_void] = ACTIONS(3473),
    [anon_sym_PLUS_PLUS] = ACTIONS(3475),
    [anon_sym_DASH_DASH] = ACTIONS(3475),
    [anon_sym_DQUOTE] = ACTIONS(3475),
    [anon_sym_SQUOTE] = ACTIONS(3475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3475),
    [sym_number] = ACTIONS(3475),
    [sym_this] = ACTIONS(3473),
    [sym_true] = ACTIONS(3473),
    [sym_false] = ACTIONS(3473),
    [sym_null] = ACTIONS(3473),
    [sym_undefined] = ACTIONS(3473),
    [anon_sym_static] = ACTIONS(3473),
    [anon_sym_readonly] = ACTIONS(3473),
    [anon_sym_get] = ACTIONS(3473),
    [anon_sym_set] = ACTIONS(3473),
    [anon_sym_QMARK] = ACTIONS(3473),
    [anon_sym_any] = ACTIONS(3473),
    [anon_sym_number] = ACTIONS(3473),
    [anon_sym_boolean] = ACTIONS(3473),
    [anon_sym_string] = ACTIONS(3473),
    [anon_sym_symbol] = ACTIONS(3473),
    [anon_sym_abstract] = ACTIONS(3473),
    [anon_sym_satisfies] = ACTIONS(3473),
    [anon_sym_infer] = ACTIONS(3473),
    [anon_sym_keyof] = ACTIONS(3473),
    [anon_sym_unknown] = ACTIONS(3473),
    [anon_sym_never] = ACTIONS(3473),
    [anon_sym_object] = ACTIONS(3473),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3475),
    [anon_sym_constructor] = ACTIONS(3473),
    [anon_sym_prop] = ACTIONS(3473),
    [anon_sym_id] = ACTIONS(3473),
    [anon_sym_event] = ACTIONS(3473),
    [anon_sym_fn] = ACTIONS(3473),
    [anon_sym_on] = ACTIONS(3473),
    [sym__ternary_qmark] = ACTIONS(3475),
  },
  [1023] = {
    [sym_identifier] = ACTIONS(1532),
    [anon_sym_STAR] = ACTIONS(1532),
    [anon_sym_as] = ACTIONS(1532),
    [anon_sym_LBRACE] = ACTIONS(1532),
    [anon_sym_RBRACE] = ACTIONS(1536),
    [anon_sym_typeof] = ACTIONS(1532),
    [anon_sym_BANG] = ACTIONS(1532),
    [anon_sym_LPAREN] = ACTIONS(1536),
    [anon_sym_in] = ACTIONS(1532),
    [anon_sym_SEMI] = ACTIONS(1536),
    [anon_sym_LBRACK] = ACTIONS(1536),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_SLASH] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1532),
    [anon_sym_async] = ACTIONS(1532),
    [anon_sym_QMARK_DOT] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1532),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE_PIPE] = ACTIONS(1536),
    [anon_sym_GT_GT] = ACTIONS(1532),
    [anon_sym_GT_GT_GT] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1536),
    [anon_sym_AMP] = ACTIONS(1532),
    [anon_sym_CARET] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_PLUS] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(1532),
    [anon_sym_PERCENT] = ACTIONS(1536),
    [anon_sym_STAR_STAR] = ACTIONS(1536),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_EQ_EQ] = ACTIONS(1532),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1536),
    [anon_sym_BANG_EQ] = ACTIONS(1532),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_QMARK_QMARK] = ACTIONS(1536),
    [anon_sym_instanceof] = ACTIONS(1532),
    [anon_sym_void] = ACTIONS(1532),
    [anon_sym_PLUS_PLUS] = ACTIONS(1536),
    [anon_sym_DASH_DASH] = ACTIONS(1536),
    [anon_sym_DQUOTE] = ACTIONS(1536),
    [anon_sym_SQUOTE] = ACTIONS(1536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1536),
    [sym_number] = ACTIONS(1536),
    [sym_this] = ACTIONS(1532),
    [sym_true] = ACTIONS(1532),
    [sym_false] = ACTIONS(1532),
    [sym_null] = ACTIONS(1532),
    [sym_undefined] = ACTIONS(1532),
    [anon_sym_static] = ACTIONS(1532),
    [anon_sym_readonly] = ACTIONS(1532),
    [anon_sym_get] = ACTIONS(1532),
    [anon_sym_set] = ACTIONS(1532),
    [anon_sym_QMARK] = ACTIONS(1532),
    [anon_sym_any] = ACTIONS(1532),
    [anon_sym_number] = ACTIONS(1532),
    [anon_sym_boolean] = ACTIONS(1532),
    [anon_sym_string] = ACTIONS(1532),
    [anon_sym_symbol] = ACTIONS(1532),
    [anon_sym_abstract] = ACTIONS(1532),
    [anon_sym_satisfies] = ACTIONS(1532),
    [anon_sym_infer] = ACTIONS(1532),
    [anon_sym_keyof] = ACTIONS(1532),
    [anon_sym_unknown] = ACTIONS(1532),
    [anon_sym_never] = ACTIONS(1532),
    [anon_sym_object] = ACTIONS(1532),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1536),
    [anon_sym_constructor] = ACTIONS(1532),
    [anon_sym_prop] = ACTIONS(1532),
    [anon_sym_id] = ACTIONS(1532),
    [anon_sym_event] = ACTIONS(1532),
    [anon_sym_fn] = ACTIONS(1532),
    [anon_sym_on] = ACTIONS(1532),
    [sym__ternary_qmark] = ACTIONS(1536),
  },
  [1024] = {
    [sym_identifier] = ACTIONS(1636),
    [anon_sym_STAR] = ACTIONS(1636),
    [anon_sym_as] = ACTIONS(1636),
    [anon_sym_LBRACE] = ACTIONS(1636),
    [anon_sym_RBRACE] = ACTIONS(1638),
    [anon_sym_typeof] = ACTIONS(1636),
    [anon_sym_BANG] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1638),
    [anon_sym_in] = ACTIONS(1636),
    [anon_sym_SEMI] = ACTIONS(1638),
    [anon_sym_LBRACK] = ACTIONS(1638),
    [anon_sym_LT] = ACTIONS(1636),
    [anon_sym_GT] = ACTIONS(1636),
    [anon_sym_SLASH] = ACTIONS(1636),
    [anon_sym_DOT] = ACTIONS(1636),
    [anon_sym_async] = ACTIONS(1636),
    [anon_sym_QMARK_DOT] = ACTIONS(1638),
    [anon_sym_new] = ACTIONS(1636),
    [anon_sym_AMP_AMP] = ACTIONS(1638),
    [anon_sym_PIPE_PIPE] = ACTIONS(1638),
    [anon_sym_GT_GT] = ACTIONS(1636),
    [anon_sym_GT_GT_GT] = ACTIONS(1638),
    [anon_sym_LT_LT] = ACTIONS(1638),
    [anon_sym_AMP] = ACTIONS(1636),
    [anon_sym_CARET] = ACTIONS(1638),
    [anon_sym_PIPE] = ACTIONS(1636),
    [anon_sym_PLUS] = ACTIONS(1636),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_PERCENT] = ACTIONS(1638),
    [anon_sym_STAR_STAR] = ACTIONS(1638),
    [anon_sym_LT_EQ] = ACTIONS(1638),
    [anon_sym_EQ_EQ] = ACTIONS(1636),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1638),
    [anon_sym_BANG_EQ] = ACTIONS(1636),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1638),
    [anon_sym_GT_EQ] = ACTIONS(1638),
    [anon_sym_QMARK_QMARK] = ACTIONS(1638),
    [anon_sym_instanceof] = ACTIONS(1636),
    [anon_sym_void] = ACTIONS(1636),
    [anon_sym_PLUS_PLUS] = ACTIONS(1638),
    [anon_sym_DASH_DASH] = ACTIONS(1638),
    [anon_sym_DQUOTE] = ACTIONS(1638),
    [anon_sym_SQUOTE] = ACTIONS(1638),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1638),
    [sym_number] = ACTIONS(1638),
    [sym_this] = ACTIONS(1636),
    [sym_true] = ACTIONS(1636),
    [sym_false] = ACTIONS(1636),
    [sym_null] = ACTIONS(1636),
    [sym_undefined] = ACTIONS(1636),
    [anon_sym_static] = ACTIONS(1636),
    [anon_sym_readonly] = ACTIONS(1636),
    [anon_sym_get] = ACTIONS(1636),
    [anon_sym_set] = ACTIONS(1636),
    [anon_sym_QMARK] = ACTIONS(1636),
    [anon_sym_any] = ACTIONS(1636),
    [anon_sym_number] = ACTIONS(1636),
    [anon_sym_boolean] = ACTIONS(1636),
    [anon_sym_string] = ACTIONS(1636),
    [anon_sym_symbol] = ACTIONS(1636),
    [anon_sym_abstract] = ACTIONS(1636),
    [anon_sym_satisfies] = ACTIONS(1636),
    [anon_sym_infer] = ACTIONS(1636),
    [anon_sym_keyof] = ACTIONS(1636),
    [anon_sym_unknown] = ACTIONS(1636),
    [anon_sym_never] = ACTIONS(1636),
    [anon_sym_object] = ACTIONS(1636),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1638),
    [anon_sym_constructor] = ACTIONS(1636),
    [anon_sym_prop] = ACTIONS(1636),
    [anon_sym_id] = ACTIONS(1636),
    [anon_sym_event] = ACTIONS(1636),
    [anon_sym_fn] = ACTIONS(1636),
    [anon_sym_on] = ACTIONS(1636),
    [sym__ternary_qmark] = ACTIONS(1638),
  },
  [1025] = {
    [sym_identifier] = ACTIONS(1566),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_as] = ACTIONS(1566),
    [anon_sym_LBRACE] = ACTIONS(1566),
    [anon_sym_RBRACE] = ACTIONS(1570),
    [anon_sym_typeof] = ACTIONS(1566),
    [anon_sym_BANG] = ACTIONS(1566),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_in] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1570),
    [anon_sym_LBRACK] = ACTIONS(1570),
    [anon_sym_LT] = ACTIONS(1566),
    [anon_sym_GT] = ACTIONS(1566),
    [anon_sym_SLASH] = ACTIONS(1566),
    [anon_sym_DOT] = ACTIONS(1566),
    [anon_sym_async] = ACTIONS(1566),
    [anon_sym_QMARK_DOT] = ACTIONS(1570),
    [anon_sym_new] = ACTIONS(1566),
    [anon_sym_AMP_AMP] = ACTIONS(1570),
    [anon_sym_PIPE_PIPE] = ACTIONS(1570),
    [anon_sym_GT_GT] = ACTIONS(1566),
    [anon_sym_GT_GT_GT] = ACTIONS(1570),
    [anon_sym_LT_LT] = ACTIONS(1570),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_CARET] = ACTIONS(1570),
    [anon_sym_PIPE] = ACTIONS(1566),
    [anon_sym_PLUS] = ACTIONS(1566),
    [anon_sym_DASH] = ACTIONS(1566),
    [anon_sym_PERCENT] = ACTIONS(1570),
    [anon_sym_STAR_STAR] = ACTIONS(1570),
    [anon_sym_LT_EQ] = ACTIONS(1570),
    [anon_sym_EQ_EQ] = ACTIONS(1566),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1570),
    [anon_sym_BANG_EQ] = ACTIONS(1566),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1570),
    [anon_sym_GT_EQ] = ACTIONS(1570),
    [anon_sym_QMARK_QMARK] = ACTIONS(1570),
    [anon_sym_instanceof] = ACTIONS(1566),
    [anon_sym_void] = ACTIONS(1566),
    [anon_sym_PLUS_PLUS] = ACTIONS(1570),
    [anon_sym_DASH_DASH] = ACTIONS(1570),
    [anon_sym_DQUOTE] = ACTIONS(1570),
    [anon_sym_SQUOTE] = ACTIONS(1570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1570),
    [sym_number] = ACTIONS(1570),
    [sym_this] = ACTIONS(1566),
    [sym_true] = ACTIONS(1566),
    [sym_false] = ACTIONS(1566),
    [sym_null] = ACTIONS(1566),
    [sym_undefined] = ACTIONS(1566),
    [anon_sym_static] = ACTIONS(1566),
    [anon_sym_readonly] = ACTIONS(1566),
    [anon_sym_get] = ACTIONS(1566),
    [anon_sym_set] = ACTIONS(1566),
    [anon_sym_QMARK] = ACTIONS(1566),
    [anon_sym_any] = ACTIONS(1566),
    [anon_sym_number] = ACTIONS(1566),
    [anon_sym_boolean] = ACTIONS(1566),
    [anon_sym_string] = ACTIONS(1566),
    [anon_sym_symbol] = ACTIONS(1566),
    [anon_sym_abstract] = ACTIONS(1566),
    [anon_sym_satisfies] = ACTIONS(1566),
    [anon_sym_infer] = ACTIONS(1566),
    [anon_sym_keyof] = ACTIONS(1566),
    [anon_sym_unknown] = ACTIONS(1566),
    [anon_sym_never] = ACTIONS(1566),
    [anon_sym_object] = ACTIONS(1566),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1570),
    [anon_sym_constructor] = ACTIONS(1566),
    [anon_sym_prop] = ACTIONS(1566),
    [anon_sym_id] = ACTIONS(1566),
    [anon_sym_event] = ACTIONS(1566),
    [anon_sym_fn] = ACTIONS(1566),
    [anon_sym_on] = ACTIONS(1566),
    [sym__ternary_qmark] = ACTIONS(1570),
  },
  [1026] = {
    [sym_identifier] = ACTIONS(1546),
    [anon_sym_STAR] = ACTIONS(1546),
    [anon_sym_as] = ACTIONS(1546),
    [anon_sym_LBRACE] = ACTIONS(1546),
    [anon_sym_RBRACE] = ACTIONS(1550),
    [anon_sym_typeof] = ACTIONS(1546),
    [anon_sym_BANG] = ACTIONS(1546),
    [anon_sym_LPAREN] = ACTIONS(1550),
    [anon_sym_in] = ACTIONS(1546),
    [anon_sym_SEMI] = ACTIONS(1550),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LT] = ACTIONS(1546),
    [anon_sym_GT] = ACTIONS(1546),
    [anon_sym_SLASH] = ACTIONS(1546),
    [anon_sym_DOT] = ACTIONS(1546),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_QMARK_DOT] = ACTIONS(1550),
    [anon_sym_new] = ACTIONS(1546),
    [anon_sym_AMP_AMP] = ACTIONS(1550),
    [anon_sym_PIPE_PIPE] = ACTIONS(1550),
    [anon_sym_GT_GT] = ACTIONS(1546),
    [anon_sym_GT_GT_GT] = ACTIONS(1550),
    [anon_sym_LT_LT] = ACTIONS(1550),
    [anon_sym_AMP] = ACTIONS(1546),
    [anon_sym_CARET] = ACTIONS(1550),
    [anon_sym_PIPE] = ACTIONS(1546),
    [anon_sym_PLUS] = ACTIONS(1546),
    [anon_sym_DASH] = ACTIONS(1546),
    [anon_sym_PERCENT] = ACTIONS(1550),
    [anon_sym_STAR_STAR] = ACTIONS(1550),
    [anon_sym_LT_EQ] = ACTIONS(1550),
    [anon_sym_EQ_EQ] = ACTIONS(1546),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1550),
    [anon_sym_BANG_EQ] = ACTIONS(1546),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1550),
    [anon_sym_GT_EQ] = ACTIONS(1550),
    [anon_sym_QMARK_QMARK] = ACTIONS(1550),
    [anon_sym_instanceof] = ACTIONS(1546),
    [anon_sym_void] = ACTIONS(1546),
    [anon_sym_PLUS_PLUS] = ACTIONS(1550),
    [anon_sym_DASH_DASH] = ACTIONS(1550),
    [anon_sym_DQUOTE] = ACTIONS(1550),
    [anon_sym_SQUOTE] = ACTIONS(1550),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1550),
    [sym_number] = ACTIONS(1550),
    [sym_this] = ACTIONS(1546),
    [sym_true] = ACTIONS(1546),
    [sym_false] = ACTIONS(1546),
    [sym_null] = ACTIONS(1546),
    [sym_undefined] = ACTIONS(1546),
    [anon_sym_static] = ACTIONS(1546),
    [anon_sym_readonly] = ACTIONS(1546),
    [anon_sym_get] = ACTIONS(1546),
    [anon_sym_set] = ACTIONS(1546),
    [anon_sym_QMARK] = ACTIONS(1546),
    [anon_sym_any] = ACTIONS(1546),
    [anon_sym_number] = ACTIONS(1546),
    [anon_sym_boolean] = ACTIONS(1546),
    [anon_sym_string] = ACTIONS(1546),
    [anon_sym_symbol] = ACTIONS(1546),
    [anon_sym_abstract] = ACTIONS(1546),
    [anon_sym_satisfies] = ACTIONS(1546),
    [anon_sym_infer] = ACTIONS(1546),
    [anon_sym_keyof] = ACTIONS(1546),
    [anon_sym_unknown] = ACTIONS(1546),
    [anon_sym_never] = ACTIONS(1546),
    [anon_sym_object] = ACTIONS(1546),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1550),
    [anon_sym_constructor] = ACTIONS(1546),
    [anon_sym_prop] = ACTIONS(1546),
    [anon_sym_id] = ACTIONS(1546),
    [anon_sym_event] = ACTIONS(1546),
    [anon_sym_fn] = ACTIONS(1546),
    [anon_sym_on] = ACTIONS(1546),
    [sym__ternary_qmark] = ACTIONS(1550),
  },
  [1027] = {
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_STAR] = ACTIONS(1444),
    [anon_sym_as] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(1444),
    [anon_sym_RBRACE] = ACTIONS(1448),
    [anon_sym_typeof] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1444),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [anon_sym_in] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1448),
    [anon_sym_LBRACK] = ACTIONS(1448),
    [anon_sym_LT] = ACTIONS(1444),
    [anon_sym_GT] = ACTIONS(1444),
    [anon_sym_SLASH] = ACTIONS(1444),
    [anon_sym_DOT] = ACTIONS(1444),
    [anon_sym_async] = ACTIONS(1444),
    [anon_sym_QMARK_DOT] = ACTIONS(1448),
    [anon_sym_new] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1448),
    [anon_sym_PIPE_PIPE] = ACTIONS(1448),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_GT_GT_GT] = ACTIONS(1448),
    [anon_sym_LT_LT] = ACTIONS(1448),
    [anon_sym_AMP] = ACTIONS(1444),
    [anon_sym_CARET] = ACTIONS(1448),
    [anon_sym_PIPE] = ACTIONS(1444),
    [anon_sym_PLUS] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1444),
    [anon_sym_PERCENT] = ACTIONS(1448),
    [anon_sym_STAR_STAR] = ACTIONS(1448),
    [anon_sym_LT_EQ] = ACTIONS(1448),
    [anon_sym_EQ_EQ] = ACTIONS(1444),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1448),
    [anon_sym_BANG_EQ] = ACTIONS(1444),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1448),
    [anon_sym_GT_EQ] = ACTIONS(1448),
    [anon_sym_QMARK_QMARK] = ACTIONS(1448),
    [anon_sym_instanceof] = ACTIONS(1444),
    [anon_sym_void] = ACTIONS(1444),
    [anon_sym_PLUS_PLUS] = ACTIONS(1448),
    [anon_sym_DASH_DASH] = ACTIONS(1448),
    [anon_sym_DQUOTE] = ACTIONS(1448),
    [anon_sym_SQUOTE] = ACTIONS(1448),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1448),
    [sym_number] = ACTIONS(1448),
    [sym_this] = ACTIONS(1444),
    [sym_true] = ACTIONS(1444),
    [sym_false] = ACTIONS(1444),
    [sym_null] = ACTIONS(1444),
    [sym_undefined] = ACTIONS(1444),
    [anon_sym_static] = ACTIONS(1444),
    [anon_sym_readonly] = ACTIONS(1444),
    [anon_sym_get] = ACTIONS(1444),
    [anon_sym_set] = ACTIONS(1444),
    [anon_sym_QMARK] = ACTIONS(1444),
    [anon_sym_any] = ACTIONS(1444),
    [anon_sym_number] = ACTIONS(1444),
    [anon_sym_boolean] = ACTIONS(1444),
    [anon_sym_string] = ACTIONS(1444),
    [anon_sym_symbol] = ACTIONS(1444),
    [anon_sym_abstract] = ACTIONS(1444),
    [anon_sym_satisfies] = ACTIONS(1444),
    [anon_sym_infer] = ACTIONS(1444),
    [anon_sym_keyof] = ACTIONS(1444),
    [anon_sym_unknown] = ACTIONS(1444),
    [anon_sym_never] = ACTIONS(1444),
    [anon_sym_object] = ACTIONS(1444),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1448),
    [anon_sym_constructor] = ACTIONS(1444),
    [anon_sym_prop] = ACTIONS(1444),
    [anon_sym_id] = ACTIONS(1444),
    [anon_sym_event] = ACTIONS(1444),
    [anon_sym_fn] = ACTIONS(1444),
    [anon_sym_on] = ACTIONS(1444),
    [sym__ternary_qmark] = ACTIONS(1448),
  },
  [1028] = {
    [sym_identifier] = ACTIONS(3477),
    [anon_sym_STAR] = ACTIONS(3477),
    [anon_sym_as] = ACTIONS(3477),
    [anon_sym_LBRACE] = ACTIONS(3477),
    [anon_sym_RBRACE] = ACTIONS(3479),
    [anon_sym_typeof] = ACTIONS(3477),
    [anon_sym_BANG] = ACTIONS(3477),
    [anon_sym_LPAREN] = ACTIONS(3479),
    [anon_sym_in] = ACTIONS(3477),
    [anon_sym_SEMI] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(3479),
    [anon_sym_LT] = ACTIONS(3477),
    [anon_sym_GT] = ACTIONS(3477),
    [anon_sym_SLASH] = ACTIONS(3477),
    [anon_sym_DOT] = ACTIONS(3477),
    [anon_sym_async] = ACTIONS(3477),
    [anon_sym_QMARK_DOT] = ACTIONS(3479),
    [anon_sym_new] = ACTIONS(3477),
    [anon_sym_AMP_AMP] = ACTIONS(3479),
    [anon_sym_PIPE_PIPE] = ACTIONS(3479),
    [anon_sym_GT_GT] = ACTIONS(3477),
    [anon_sym_GT_GT_GT] = ACTIONS(3479),
    [anon_sym_LT_LT] = ACTIONS(3479),
    [anon_sym_AMP] = ACTIONS(3477),
    [anon_sym_CARET] = ACTIONS(3479),
    [anon_sym_PIPE] = ACTIONS(3477),
    [anon_sym_PLUS] = ACTIONS(3477),
    [anon_sym_DASH] = ACTIONS(3477),
    [anon_sym_PERCENT] = ACTIONS(3479),
    [anon_sym_STAR_STAR] = ACTIONS(3479),
    [anon_sym_LT_EQ] = ACTIONS(3479),
    [anon_sym_EQ_EQ] = ACTIONS(3477),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3479),
    [anon_sym_BANG_EQ] = ACTIONS(3477),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3479),
    [anon_sym_GT_EQ] = ACTIONS(3479),
    [anon_sym_QMARK_QMARK] = ACTIONS(3479),
    [anon_sym_instanceof] = ACTIONS(3477),
    [anon_sym_void] = ACTIONS(3477),
    [anon_sym_PLUS_PLUS] = ACTIONS(3479),
    [anon_sym_DASH_DASH] = ACTIONS(3479),
    [anon_sym_DQUOTE] = ACTIONS(3479),
    [anon_sym_SQUOTE] = ACTIONS(3479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3479),
    [sym_number] = ACTIONS(3479),
    [sym_this] = ACTIONS(3477),
    [sym_true] = ACTIONS(3477),
    [sym_false] = ACTIONS(3477),
    [sym_null] = ACTIONS(3477),
    [sym_undefined] = ACTIONS(3477),
    [anon_sym_static] = ACTIONS(3477),
    [anon_sym_readonly] = ACTIONS(3477),
    [anon_sym_get] = ACTIONS(3477),
    [anon_sym_set] = ACTIONS(3477),
    [anon_sym_QMARK] = ACTIONS(3477),
    [anon_sym_any] = ACTIONS(3477),
    [anon_sym_number] = ACTIONS(3477),
    [anon_sym_boolean] = ACTIONS(3477),
    [anon_sym_string] = ACTIONS(3477),
    [anon_sym_symbol] = ACTIONS(3477),
    [anon_sym_abstract] = ACTIONS(3477),
    [anon_sym_satisfies] = ACTIONS(3477),
    [anon_sym_infer] = ACTIONS(3477),
    [anon_sym_keyof] = ACTIONS(3477),
    [anon_sym_unknown] = ACTIONS(3477),
    [anon_sym_never] = ACTIONS(3477),
    [anon_sym_object] = ACTIONS(3477),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3479),
    [anon_sym_constructor] = ACTIONS(3477),
    [anon_sym_prop] = ACTIONS(3477),
    [anon_sym_id] = ACTIONS(3477),
    [anon_sym_event] = ACTIONS(3477),
    [anon_sym_fn] = ACTIONS(3477),
    [anon_sym_on] = ACTIONS(3477),
    [sym__ternary_qmark] = ACTIONS(3479),
  },
  [1029] = {
    [sym_identifier] = ACTIONS(3481),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_as] = ACTIONS(3481),
    [anon_sym_LBRACE] = ACTIONS(3481),
    [anon_sym_RBRACE] = ACTIONS(3483),
    [anon_sym_typeof] = ACTIONS(3481),
    [anon_sym_BANG] = ACTIONS(3481),
    [anon_sym_LPAREN] = ACTIONS(3483),
    [anon_sym_in] = ACTIONS(3481),
    [anon_sym_SEMI] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3483),
    [anon_sym_LT] = ACTIONS(3481),
    [anon_sym_GT] = ACTIONS(3481),
    [anon_sym_SLASH] = ACTIONS(3481),
    [anon_sym_DOT] = ACTIONS(3481),
    [anon_sym_async] = ACTIONS(3481),
    [anon_sym_QMARK_DOT] = ACTIONS(3483),
    [anon_sym_new] = ACTIONS(3481),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_PIPE_PIPE] = ACTIONS(3483),
    [anon_sym_GT_GT] = ACTIONS(3481),
    [anon_sym_GT_GT_GT] = ACTIONS(3483),
    [anon_sym_LT_LT] = ACTIONS(3483),
    [anon_sym_AMP] = ACTIONS(3481),
    [anon_sym_CARET] = ACTIONS(3483),
    [anon_sym_PIPE] = ACTIONS(3481),
    [anon_sym_PLUS] = ACTIONS(3481),
    [anon_sym_DASH] = ACTIONS(3481),
    [anon_sym_PERCENT] = ACTIONS(3483),
    [anon_sym_STAR_STAR] = ACTIONS(3483),
    [anon_sym_LT_EQ] = ACTIONS(3483),
    [anon_sym_EQ_EQ] = ACTIONS(3481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3483),
    [anon_sym_BANG_EQ] = ACTIONS(3481),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3483),
    [anon_sym_GT_EQ] = ACTIONS(3483),
    [anon_sym_QMARK_QMARK] = ACTIONS(3483),
    [anon_sym_instanceof] = ACTIONS(3481),
    [anon_sym_void] = ACTIONS(3481),
    [anon_sym_PLUS_PLUS] = ACTIONS(3483),
    [anon_sym_DASH_DASH] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3483),
    [anon_sym_SQUOTE] = ACTIONS(3483),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3483),
    [sym_number] = ACTIONS(3483),
    [sym_this] = ACTIONS(3481),
    [sym_true] = ACTIONS(3481),
    [sym_false] = ACTIONS(3481),
    [sym_null] = ACTIONS(3481),
    [sym_undefined] = ACTIONS(3481),
    [anon_sym_static] = ACTIONS(3481),
    [anon_sym_readonly] = ACTIONS(3481),
    [anon_sym_get] = ACTIONS(3481),
    [anon_sym_set] = ACTIONS(3481),
    [anon_sym_QMARK] = ACTIONS(3481),
    [anon_sym_any] = ACTIONS(3481),
    [anon_sym_number] = ACTIONS(3481),
    [anon_sym_boolean] = ACTIONS(3481),
    [anon_sym_string] = ACTIONS(3481),
    [anon_sym_symbol] = ACTIONS(3481),
    [anon_sym_abstract] = ACTIONS(3481),
    [anon_sym_satisfies] = ACTIONS(3481),
    [anon_sym_infer] = ACTIONS(3481),
    [anon_sym_keyof] = ACTIONS(3481),
    [anon_sym_unknown] = ACTIONS(3481),
    [anon_sym_never] = ACTIONS(3481),
    [anon_sym_object] = ACTIONS(3481),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3483),
    [anon_sym_constructor] = ACTIONS(3481),
    [anon_sym_prop] = ACTIONS(3481),
    [anon_sym_id] = ACTIONS(3481),
    [anon_sym_event] = ACTIONS(3481),
    [anon_sym_fn] = ACTIONS(3481),
    [anon_sym_on] = ACTIONS(3481),
    [sym__ternary_qmark] = ACTIONS(3483),
  },
  [1030] = {
    [sym_identifier] = ACTIONS(3485),
    [anon_sym_STAR] = ACTIONS(3485),
    [anon_sym_as] = ACTIONS(3485),
    [anon_sym_LBRACE] = ACTIONS(3485),
    [anon_sym_RBRACE] = ACTIONS(3487),
    [anon_sym_typeof] = ACTIONS(3485),
    [anon_sym_BANG] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3487),
    [anon_sym_in] = ACTIONS(3485),
    [anon_sym_SEMI] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3487),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_GT] = ACTIONS(3485),
    [anon_sym_SLASH] = ACTIONS(3485),
    [anon_sym_DOT] = ACTIONS(3485),
    [anon_sym_async] = ACTIONS(3485),
    [anon_sym_QMARK_DOT] = ACTIONS(3487),
    [anon_sym_new] = ACTIONS(3485),
    [anon_sym_AMP_AMP] = ACTIONS(3487),
    [anon_sym_PIPE_PIPE] = ACTIONS(3487),
    [anon_sym_GT_GT] = ACTIONS(3485),
    [anon_sym_GT_GT_GT] = ACTIONS(3487),
    [anon_sym_LT_LT] = ACTIONS(3487),
    [anon_sym_AMP] = ACTIONS(3485),
    [anon_sym_CARET] = ACTIONS(3487),
    [anon_sym_PIPE] = ACTIONS(3485),
    [anon_sym_PLUS] = ACTIONS(3485),
    [anon_sym_DASH] = ACTIONS(3485),
    [anon_sym_PERCENT] = ACTIONS(3487),
    [anon_sym_STAR_STAR] = ACTIONS(3487),
    [anon_sym_LT_EQ] = ACTIONS(3487),
    [anon_sym_EQ_EQ] = ACTIONS(3485),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3487),
    [anon_sym_BANG_EQ] = ACTIONS(3485),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3487),
    [anon_sym_GT_EQ] = ACTIONS(3487),
    [anon_sym_QMARK_QMARK] = ACTIONS(3487),
    [anon_sym_instanceof] = ACTIONS(3485),
    [anon_sym_void] = ACTIONS(3485),
    [anon_sym_PLUS_PLUS] = ACTIONS(3487),
    [anon_sym_DASH_DASH] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3487),
    [anon_sym_SQUOTE] = ACTIONS(3487),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3487),
    [sym_number] = ACTIONS(3487),
    [sym_this] = ACTIONS(3485),
    [sym_true] = ACTIONS(3485),
    [sym_false] = ACTIONS(3485),
    [sym_null] = ACTIONS(3485),
    [sym_undefined] = ACTIONS(3485),
    [anon_sym_static] = ACTIONS(3485),
    [anon_sym_readonly] = ACTIONS(3485),
    [anon_sym_get] = ACTIONS(3485),
    [anon_sym_set] = ACTIONS(3485),
    [anon_sym_QMARK] = ACTIONS(3485),
    [anon_sym_any] = ACTIONS(3485),
    [anon_sym_number] = ACTIONS(3485),
    [anon_sym_boolean] = ACTIONS(3485),
    [anon_sym_string] = ACTIONS(3485),
    [anon_sym_symbol] = ACTIONS(3485),
    [anon_sym_abstract] = ACTIONS(3485),
    [anon_sym_satisfies] = ACTIONS(3485),
    [anon_sym_infer] = ACTIONS(3485),
    [anon_sym_keyof] = ACTIONS(3485),
    [anon_sym_unknown] = ACTIONS(3485),
    [anon_sym_never] = ACTIONS(3485),
    [anon_sym_object] = ACTIONS(3485),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3487),
    [anon_sym_constructor] = ACTIONS(3485),
    [anon_sym_prop] = ACTIONS(3485),
    [anon_sym_id] = ACTIONS(3485),
    [anon_sym_event] = ACTIONS(3485),
    [anon_sym_fn] = ACTIONS(3485),
    [anon_sym_on] = ACTIONS(3485),
    [sym__ternary_qmark] = ACTIONS(3487),
  },
  [1031] = {
    [sym_identifier] = ACTIONS(1464),
    [anon_sym_STAR] = ACTIONS(1464),
    [anon_sym_as] = ACTIONS(1464),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_RBRACE] = ACTIONS(1468),
    [anon_sym_typeof] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1464),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [anon_sym_in] = ACTIONS(1464),
    [anon_sym_SEMI] = ACTIONS(1468),
    [anon_sym_LBRACK] = ACTIONS(1468),
    [anon_sym_LT] = ACTIONS(1464),
    [anon_sym_GT] = ACTIONS(1464),
    [anon_sym_SLASH] = ACTIONS(1464),
    [anon_sym_DOT] = ACTIONS(1464),
    [anon_sym_async] = ACTIONS(1464),
    [anon_sym_QMARK_DOT] = ACTIONS(1468),
    [anon_sym_new] = ACTIONS(1464),
    [anon_sym_AMP_AMP] = ACTIONS(1468),
    [anon_sym_PIPE_PIPE] = ACTIONS(1468),
    [anon_sym_GT_GT] = ACTIONS(1464),
    [anon_sym_GT_GT_GT] = ACTIONS(1468),
    [anon_sym_LT_LT] = ACTIONS(1468),
    [anon_sym_AMP] = ACTIONS(1464),
    [anon_sym_CARET] = ACTIONS(1468),
    [anon_sym_PIPE] = ACTIONS(1464),
    [anon_sym_PLUS] = ACTIONS(1464),
    [anon_sym_DASH] = ACTIONS(1464),
    [anon_sym_PERCENT] = ACTIONS(1468),
    [anon_sym_STAR_STAR] = ACTIONS(1468),
    [anon_sym_LT_EQ] = ACTIONS(1468),
    [anon_sym_EQ_EQ] = ACTIONS(1464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1468),
    [anon_sym_BANG_EQ] = ACTIONS(1464),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1468),
    [anon_sym_GT_EQ] = ACTIONS(1468),
    [anon_sym_QMARK_QMARK] = ACTIONS(1468),
    [anon_sym_instanceof] = ACTIONS(1464),
    [anon_sym_void] = ACTIONS(1464),
    [anon_sym_PLUS_PLUS] = ACTIONS(1468),
    [anon_sym_DASH_DASH] = ACTIONS(1468),
    [anon_sym_DQUOTE] = ACTIONS(1468),
    [anon_sym_SQUOTE] = ACTIONS(1468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1468),
    [sym_number] = ACTIONS(1468),
    [sym_this] = ACTIONS(1464),
    [sym_true] = ACTIONS(1464),
    [sym_false] = ACTIONS(1464),
    [sym_null] = ACTIONS(1464),
    [sym_undefined] = ACTIONS(1464),
    [anon_sym_static] = ACTIONS(1464),
    [anon_sym_readonly] = ACTIONS(1464),
    [anon_sym_get] = ACTIONS(1464),
    [anon_sym_set] = ACTIONS(1464),
    [anon_sym_QMARK] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(1464),
    [anon_sym_number] = ACTIONS(1464),
    [anon_sym_boolean] = ACTIONS(1464),
    [anon_sym_string] = ACTIONS(1464),
    [anon_sym_symbol] = ACTIONS(1464),
    [anon_sym_abstract] = ACTIONS(1464),
    [anon_sym_satisfies] = ACTIONS(1464),
    [anon_sym_infer] = ACTIONS(1464),
    [anon_sym_keyof] = ACTIONS(1464),
    [anon_sym_unknown] = ACTIONS(1464),
    [anon_sym_never] = ACTIONS(1464),
    [anon_sym_object] = ACTIONS(1464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1468),
    [anon_sym_constructor] = ACTIONS(1464),
    [anon_sym_prop] = ACTIONS(1464),
    [anon_sym_id] = ACTIONS(1464),
    [anon_sym_event] = ACTIONS(1464),
    [anon_sym_fn] = ACTIONS(1464),
    [anon_sym_on] = ACTIONS(1464),
    [sym__ternary_qmark] = ACTIONS(1468),
  },
  [1032] = {
    [sym_identifier] = ACTIONS(1484),
    [anon_sym_STAR] = ACTIONS(1484),
    [anon_sym_as] = ACTIONS(1484),
    [anon_sym_LBRACE] = ACTIONS(1484),
    [anon_sym_RBRACE] = ACTIONS(1488),
    [anon_sym_typeof] = ACTIONS(1484),
    [anon_sym_BANG] = ACTIONS(1484),
    [anon_sym_LPAREN] = ACTIONS(1488),
    [anon_sym_in] = ACTIONS(1484),
    [anon_sym_SEMI] = ACTIONS(1488),
    [anon_sym_LBRACK] = ACTIONS(1488),
    [anon_sym_LT] = ACTIONS(1484),
    [anon_sym_GT] = ACTIONS(1484),
    [anon_sym_SLASH] = ACTIONS(1484),
    [anon_sym_DOT] = ACTIONS(1484),
    [anon_sym_async] = ACTIONS(1484),
    [anon_sym_QMARK_DOT] = ACTIONS(1488),
    [anon_sym_new] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1488),
    [anon_sym_PIPE_PIPE] = ACTIONS(1488),
    [anon_sym_GT_GT] = ACTIONS(1484),
    [anon_sym_GT_GT_GT] = ACTIONS(1488),
    [anon_sym_LT_LT] = ACTIONS(1488),
    [anon_sym_AMP] = ACTIONS(1484),
    [anon_sym_CARET] = ACTIONS(1488),
    [anon_sym_PIPE] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1484),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1488),
    [anon_sym_STAR_STAR] = ACTIONS(1488),
    [anon_sym_LT_EQ] = ACTIONS(1488),
    [anon_sym_EQ_EQ] = ACTIONS(1484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1488),
    [anon_sym_BANG_EQ] = ACTIONS(1484),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1488),
    [anon_sym_GT_EQ] = ACTIONS(1488),
    [anon_sym_QMARK_QMARK] = ACTIONS(1488),
    [anon_sym_instanceof] = ACTIONS(1484),
    [anon_sym_void] = ACTIONS(1484),
    [anon_sym_PLUS_PLUS] = ACTIONS(1488),
    [anon_sym_DASH_DASH] = ACTIONS(1488),
    [anon_sym_DQUOTE] = ACTIONS(1488),
    [anon_sym_SQUOTE] = ACTIONS(1488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1488),
    [sym_number] = ACTIONS(1488),
    [sym_this] = ACTIONS(1484),
    [sym_true] = ACTIONS(1484),
    [sym_false] = ACTIONS(1484),
    [sym_null] = ACTIONS(1484),
    [sym_undefined] = ACTIONS(1484),
    [anon_sym_static] = ACTIONS(1484),
    [anon_sym_readonly] = ACTIONS(1484),
    [anon_sym_get] = ACTIONS(1484),
    [anon_sym_set] = ACTIONS(1484),
    [anon_sym_QMARK] = ACTIONS(1484),
    [anon_sym_any] = ACTIONS(1484),
    [anon_sym_number] = ACTIONS(1484),
    [anon_sym_boolean] = ACTIONS(1484),
    [anon_sym_string] = ACTIONS(1484),
    [anon_sym_symbol] = ACTIONS(1484),
    [anon_sym_abstract] = ACTIONS(1484),
    [anon_sym_satisfies] = ACTIONS(1484),
    [anon_sym_infer] = ACTIONS(1484),
    [anon_sym_keyof] = ACTIONS(1484),
    [anon_sym_unknown] = ACTIONS(1484),
    [anon_sym_never] = ACTIONS(1484),
    [anon_sym_object] = ACTIONS(1484),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1488),
    [anon_sym_constructor] = ACTIONS(1484),
    [anon_sym_prop] = ACTIONS(1484),
    [anon_sym_id] = ACTIONS(1484),
    [anon_sym_event] = ACTIONS(1484),
    [anon_sym_fn] = ACTIONS(1484),
    [anon_sym_on] = ACTIONS(1484),
    [sym__ternary_qmark] = ACTIONS(1488),
  },
  [1033] = {
    [sym_identifier] = ACTIONS(3489),
    [anon_sym_STAR] = ACTIONS(3489),
    [anon_sym_as] = ACTIONS(3489),
    [anon_sym_LBRACE] = ACTIONS(3489),
    [anon_sym_RBRACE] = ACTIONS(3491),
    [anon_sym_typeof] = ACTIONS(3489),
    [anon_sym_BANG] = ACTIONS(3489),
    [anon_sym_LPAREN] = ACTIONS(3491),
    [anon_sym_in] = ACTIONS(3489),
    [anon_sym_SEMI] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3491),
    [anon_sym_LT] = ACTIONS(3489),
    [anon_sym_GT] = ACTIONS(3489),
    [anon_sym_SLASH] = ACTIONS(3489),
    [anon_sym_DOT] = ACTIONS(3489),
    [anon_sym_async] = ACTIONS(3489),
    [anon_sym_QMARK_DOT] = ACTIONS(3491),
    [anon_sym_new] = ACTIONS(3489),
    [anon_sym_AMP_AMP] = ACTIONS(3491),
    [anon_sym_PIPE_PIPE] = ACTIONS(3491),
    [anon_sym_GT_GT] = ACTIONS(3489),
    [anon_sym_GT_GT_GT] = ACTIONS(3491),
    [anon_sym_LT_LT] = ACTIONS(3491),
    [anon_sym_AMP] = ACTIONS(3489),
    [anon_sym_CARET] = ACTIONS(3491),
    [anon_sym_PIPE] = ACTIONS(3489),
    [anon_sym_PLUS] = ACTIONS(3489),
    [anon_sym_DASH] = ACTIONS(3489),
    [anon_sym_PERCENT] = ACTIONS(3491),
    [anon_sym_STAR_STAR] = ACTIONS(3491),
    [anon_sym_LT_EQ] = ACTIONS(3491),
    [anon_sym_EQ_EQ] = ACTIONS(3489),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3491),
    [anon_sym_BANG_EQ] = ACTIONS(3489),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3491),
    [anon_sym_GT_EQ] = ACTIONS(3491),
    [anon_sym_QMARK_QMARK] = ACTIONS(3491),
    [anon_sym_instanceof] = ACTIONS(3489),
    [anon_sym_void] = ACTIONS(3489),
    [anon_sym_PLUS_PLUS] = ACTIONS(3491),
    [anon_sym_DASH_DASH] = ACTIONS(3491),
    [anon_sym_DQUOTE] = ACTIONS(3491),
    [anon_sym_SQUOTE] = ACTIONS(3491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3491),
    [sym_number] = ACTIONS(3491),
    [sym_this] = ACTIONS(3489),
    [sym_true] = ACTIONS(3489),
    [sym_false] = ACTIONS(3489),
    [sym_null] = ACTIONS(3489),
    [sym_undefined] = ACTIONS(3489),
    [anon_sym_static] = ACTIONS(3489),
    [anon_sym_readonly] = ACTIONS(3489),
    [anon_sym_get] = ACTIONS(3489),
    [anon_sym_set] = ACTIONS(3489),
    [anon_sym_QMARK] = ACTIONS(3489),
    [anon_sym_any] = ACTIONS(3489),
    [anon_sym_number] = ACTIONS(3489),
    [anon_sym_boolean] = ACTIONS(3489),
    [anon_sym_string] = ACTIONS(3489),
    [anon_sym_symbol] = ACTIONS(3489),
    [anon_sym_abstract] = ACTIONS(3489),
    [anon_sym_satisfies] = ACTIONS(3489),
    [anon_sym_infer] = ACTIONS(3489),
    [anon_sym_keyof] = ACTIONS(3489),
    [anon_sym_unknown] = ACTIONS(3489),
    [anon_sym_never] = ACTIONS(3489),
    [anon_sym_object] = ACTIONS(3489),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3491),
    [anon_sym_constructor] = ACTIONS(3489),
    [anon_sym_prop] = ACTIONS(3489),
    [anon_sym_id] = ACTIONS(3489),
    [anon_sym_event] = ACTIONS(3489),
    [anon_sym_fn] = ACTIONS(3489),
    [anon_sym_on] = ACTIONS(3489),
    [sym__ternary_qmark] = ACTIONS(3491),
  },
  [1034] = {
    [sym_identifier] = ACTIONS(3493),
    [anon_sym_STAR] = ACTIONS(3493),
    [anon_sym_as] = ACTIONS(3493),
    [anon_sym_LBRACE] = ACTIONS(3493),
    [anon_sym_RBRACE] = ACTIONS(3495),
    [anon_sym_typeof] = ACTIONS(3493),
    [anon_sym_BANG] = ACTIONS(3493),
    [anon_sym_LPAREN] = ACTIONS(3495),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_SEMI] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(3495),
    [anon_sym_LT] = ACTIONS(3493),
    [anon_sym_GT] = ACTIONS(3493),
    [anon_sym_SLASH] = ACTIONS(3493),
    [anon_sym_DOT] = ACTIONS(3493),
    [anon_sym_async] = ACTIONS(3493),
    [anon_sym_QMARK_DOT] = ACTIONS(3495),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_AMP_AMP] = ACTIONS(3495),
    [anon_sym_PIPE_PIPE] = ACTIONS(3495),
    [anon_sym_GT_GT] = ACTIONS(3493),
    [anon_sym_GT_GT_GT] = ACTIONS(3495),
    [anon_sym_LT_LT] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_CARET] = ACTIONS(3495),
    [anon_sym_PIPE] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(3493),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_PERCENT] = ACTIONS(3495),
    [anon_sym_STAR_STAR] = ACTIONS(3495),
    [anon_sym_LT_EQ] = ACTIONS(3495),
    [anon_sym_EQ_EQ] = ACTIONS(3493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3495),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3495),
    [anon_sym_GT_EQ] = ACTIONS(3495),
    [anon_sym_QMARK_QMARK] = ACTIONS(3495),
    [anon_sym_instanceof] = ACTIONS(3493),
    [anon_sym_void] = ACTIONS(3493),
    [anon_sym_PLUS_PLUS] = ACTIONS(3495),
    [anon_sym_DASH_DASH] = ACTIONS(3495),
    [anon_sym_DQUOTE] = ACTIONS(3495),
    [anon_sym_SQUOTE] = ACTIONS(3495),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3495),
    [sym_number] = ACTIONS(3495),
    [sym_this] = ACTIONS(3493),
    [sym_true] = ACTIONS(3493),
    [sym_false] = ACTIONS(3493),
    [sym_null] = ACTIONS(3493),
    [sym_undefined] = ACTIONS(3493),
    [anon_sym_static] = ACTIONS(3493),
    [anon_sym_readonly] = ACTIONS(3493),
    [anon_sym_get] = ACTIONS(3493),
    [anon_sym_set] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3493),
    [anon_sym_any] = ACTIONS(3493),
    [anon_sym_number] = ACTIONS(3493),
    [anon_sym_boolean] = ACTIONS(3493),
    [anon_sym_string] = ACTIONS(3493),
    [anon_sym_symbol] = ACTIONS(3493),
    [anon_sym_abstract] = ACTIONS(3493),
    [anon_sym_satisfies] = ACTIONS(3493),
    [anon_sym_infer] = ACTIONS(3493),
    [anon_sym_keyof] = ACTIONS(3493),
    [anon_sym_unknown] = ACTIONS(3493),
    [anon_sym_never] = ACTIONS(3493),
    [anon_sym_object] = ACTIONS(3493),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3495),
    [anon_sym_constructor] = ACTIONS(3493),
    [anon_sym_prop] = ACTIONS(3493),
    [anon_sym_id] = ACTIONS(3493),
    [anon_sym_event] = ACTIONS(3493),
    [anon_sym_fn] = ACTIONS(3493),
    [anon_sym_on] = ACTIONS(3493),
    [sym__ternary_qmark] = ACTIONS(3495),
  },
  [1035] = {
    [sym_identifier] = ACTIONS(3497),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_as] = ACTIONS(3497),
    [anon_sym_LBRACE] = ACTIONS(3497),
    [anon_sym_RBRACE] = ACTIONS(3499),
    [anon_sym_typeof] = ACTIONS(3497),
    [anon_sym_BANG] = ACTIONS(3497),
    [anon_sym_LPAREN] = ACTIONS(3499),
    [anon_sym_in] = ACTIONS(3497),
    [anon_sym_SEMI] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(3499),
    [anon_sym_LT] = ACTIONS(3497),
    [anon_sym_GT] = ACTIONS(3497),
    [anon_sym_SLASH] = ACTIONS(3497),
    [anon_sym_DOT] = ACTIONS(3497),
    [anon_sym_async] = ACTIONS(3497),
    [anon_sym_QMARK_DOT] = ACTIONS(3499),
    [anon_sym_new] = ACTIONS(3497),
    [anon_sym_AMP_AMP] = ACTIONS(3499),
    [anon_sym_PIPE_PIPE] = ACTIONS(3499),
    [anon_sym_GT_GT] = ACTIONS(3497),
    [anon_sym_GT_GT_GT] = ACTIONS(3499),
    [anon_sym_LT_LT] = ACTIONS(3499),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_CARET] = ACTIONS(3499),
    [anon_sym_PIPE] = ACTIONS(3497),
    [anon_sym_PLUS] = ACTIONS(3497),
    [anon_sym_DASH] = ACTIONS(3497),
    [anon_sym_PERCENT] = ACTIONS(3499),
    [anon_sym_STAR_STAR] = ACTIONS(3499),
    [anon_sym_LT_EQ] = ACTIONS(3499),
    [anon_sym_EQ_EQ] = ACTIONS(3497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3499),
    [anon_sym_BANG_EQ] = ACTIONS(3497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3499),
    [anon_sym_GT_EQ] = ACTIONS(3499),
    [anon_sym_QMARK_QMARK] = ACTIONS(3499),
    [anon_sym_instanceof] = ACTIONS(3497),
    [anon_sym_void] = ACTIONS(3497),
    [anon_sym_PLUS_PLUS] = ACTIONS(3499),
    [anon_sym_DASH_DASH] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3499),
    [anon_sym_SQUOTE] = ACTIONS(3499),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3499),
    [sym_number] = ACTIONS(3499),
    [sym_this] = ACTIONS(3497),
    [sym_true] = ACTIONS(3497),
    [sym_false] = ACTIONS(3497),
    [sym_null] = ACTIONS(3497),
    [sym_undefined] = ACTIONS(3497),
    [anon_sym_static] = ACTIONS(3497),
    [anon_sym_readonly] = ACTIONS(3497),
    [anon_sym_get] = ACTIONS(3497),
    [anon_sym_set] = ACTIONS(3497),
    [anon_sym_QMARK] = ACTIONS(3497),
    [anon_sym_any] = ACTIONS(3497),
    [anon_sym_number] = ACTIONS(3497),
    [anon_sym_boolean] = ACTIONS(3497),
    [anon_sym_string] = ACTIONS(3497),
    [anon_sym_symbol] = ACTIONS(3497),
    [anon_sym_abstract] = ACTIONS(3497),
    [anon_sym_satisfies] = ACTIONS(3497),
    [anon_sym_infer] = ACTIONS(3497),
    [anon_sym_keyof] = ACTIONS(3497),
    [anon_sym_unknown] = ACTIONS(3497),
    [anon_sym_never] = ACTIONS(3497),
    [anon_sym_object] = ACTIONS(3497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3499),
    [anon_sym_constructor] = ACTIONS(3497),
    [anon_sym_prop] = ACTIONS(3497),
    [anon_sym_id] = ACTIONS(3497),
    [anon_sym_event] = ACTIONS(3497),
    [anon_sym_fn] = ACTIONS(3497),
    [anon_sym_on] = ACTIONS(3497),
    [sym__ternary_qmark] = ACTIONS(3499),
  },
  [1036] = {
    [sym_identifier] = ACTIONS(3501),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_as] = ACTIONS(3501),
    [anon_sym_LBRACE] = ACTIONS(3501),
    [anon_sym_RBRACE] = ACTIONS(3503),
    [anon_sym_typeof] = ACTIONS(3501),
    [anon_sym_BANG] = ACTIONS(3501),
    [anon_sym_LPAREN] = ACTIONS(3503),
    [anon_sym_in] = ACTIONS(3501),
    [anon_sym_SEMI] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3503),
    [anon_sym_LT] = ACTIONS(3501),
    [anon_sym_GT] = ACTIONS(3501),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(3501),
    [anon_sym_async] = ACTIONS(3501),
    [anon_sym_QMARK_DOT] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3501),
    [anon_sym_AMP_AMP] = ACTIONS(3503),
    [anon_sym_PIPE_PIPE] = ACTIONS(3503),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3503),
    [anon_sym_LT_LT] = ACTIONS(3503),
    [anon_sym_AMP] = ACTIONS(3501),
    [anon_sym_CARET] = ACTIONS(3503),
    [anon_sym_PIPE] = ACTIONS(3501),
    [anon_sym_PLUS] = ACTIONS(3501),
    [anon_sym_DASH] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(3503),
    [anon_sym_STAR_STAR] = ACTIONS(3503),
    [anon_sym_LT_EQ] = ACTIONS(3503),
    [anon_sym_EQ_EQ] = ACTIONS(3501),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3503),
    [anon_sym_BANG_EQ] = ACTIONS(3501),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3503),
    [anon_sym_GT_EQ] = ACTIONS(3503),
    [anon_sym_QMARK_QMARK] = ACTIONS(3503),
    [anon_sym_instanceof] = ACTIONS(3501),
    [anon_sym_void] = ACTIONS(3501),
    [anon_sym_PLUS_PLUS] = ACTIONS(3503),
    [anon_sym_DASH_DASH] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3503),
    [anon_sym_SQUOTE] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3503),
    [sym_number] = ACTIONS(3503),
    [sym_this] = ACTIONS(3501),
    [sym_true] = ACTIONS(3501),
    [sym_false] = ACTIONS(3501),
    [sym_null] = ACTIONS(3501),
    [sym_undefined] = ACTIONS(3501),
    [anon_sym_static] = ACTIONS(3501),
    [anon_sym_readonly] = ACTIONS(3501),
    [anon_sym_get] = ACTIONS(3501),
    [anon_sym_set] = ACTIONS(3501),
    [anon_sym_QMARK] = ACTIONS(3501),
    [anon_sym_any] = ACTIONS(3501),
    [anon_sym_number] = ACTIONS(3501),
    [anon_sym_boolean] = ACTIONS(3501),
    [anon_sym_string] = ACTIONS(3501),
    [anon_sym_symbol] = ACTIONS(3501),
    [anon_sym_abstract] = ACTIONS(3501),
    [anon_sym_satisfies] = ACTIONS(3501),
    [anon_sym_infer] = ACTIONS(3501),
    [anon_sym_keyof] = ACTIONS(3501),
    [anon_sym_unknown] = ACTIONS(3501),
    [anon_sym_never] = ACTIONS(3501),
    [anon_sym_object] = ACTIONS(3501),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3503),
    [anon_sym_constructor] = ACTIONS(3501),
    [anon_sym_prop] = ACTIONS(3501),
    [anon_sym_id] = ACTIONS(3501),
    [anon_sym_event] = ACTIONS(3501),
    [anon_sym_fn] = ACTIONS(3501),
    [anon_sym_on] = ACTIONS(3501),
    [sym__ternary_qmark] = ACTIONS(3503),
  },
  [1037] = {
    [sym_identifier] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(1646),
    [anon_sym_as] = ACTIONS(1646),
    [anon_sym_LBRACE] = ACTIONS(1646),
    [anon_sym_RBRACE] = ACTIONS(1650),
    [anon_sym_typeof] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1646),
    [anon_sym_LPAREN] = ACTIONS(1650),
    [anon_sym_in] = ACTIONS(1646),
    [anon_sym_SEMI] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(1650),
    [anon_sym_LT] = ACTIONS(1646),
    [anon_sym_GT] = ACTIONS(1646),
    [anon_sym_SLASH] = ACTIONS(1646),
    [anon_sym_DOT] = ACTIONS(1646),
    [anon_sym_async] = ACTIONS(1646),
    [anon_sym_QMARK_DOT] = ACTIONS(1650),
    [anon_sym_new] = ACTIONS(1646),
    [anon_sym_AMP_AMP] = ACTIONS(1650),
    [anon_sym_PIPE_PIPE] = ACTIONS(1650),
    [anon_sym_GT_GT] = ACTIONS(1646),
    [anon_sym_GT_GT_GT] = ACTIONS(1650),
    [anon_sym_LT_LT] = ACTIONS(1650),
    [anon_sym_AMP] = ACTIONS(1646),
    [anon_sym_CARET] = ACTIONS(1650),
    [anon_sym_PIPE] = ACTIONS(1646),
    [anon_sym_PLUS] = ACTIONS(1646),
    [anon_sym_DASH] = ACTIONS(1646),
    [anon_sym_PERCENT] = ACTIONS(1650),
    [anon_sym_STAR_STAR] = ACTIONS(1650),
    [anon_sym_LT_EQ] = ACTIONS(1650),
    [anon_sym_EQ_EQ] = ACTIONS(1646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1650),
    [anon_sym_BANG_EQ] = ACTIONS(1646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1650),
    [anon_sym_GT_EQ] = ACTIONS(1650),
    [anon_sym_QMARK_QMARK] = ACTIONS(1650),
    [anon_sym_instanceof] = ACTIONS(1646),
    [anon_sym_void] = ACTIONS(1646),
    [anon_sym_PLUS_PLUS] = ACTIONS(1650),
    [anon_sym_DASH_DASH] = ACTIONS(1650),
    [anon_sym_DQUOTE] = ACTIONS(1650),
    [anon_sym_SQUOTE] = ACTIONS(1650),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1650),
    [sym_number] = ACTIONS(1650),
    [sym_this] = ACTIONS(1646),
    [sym_true] = ACTIONS(1646),
    [sym_false] = ACTIONS(1646),
    [sym_null] = ACTIONS(1646),
    [sym_undefined] = ACTIONS(1646),
    [anon_sym_static] = ACTIONS(1646),
    [anon_sym_readonly] = ACTIONS(1646),
    [anon_sym_get] = ACTIONS(1646),
    [anon_sym_set] = ACTIONS(1646),
    [anon_sym_QMARK] = ACTIONS(1646),
    [anon_sym_any] = ACTIONS(1646),
    [anon_sym_number] = ACTIONS(1646),
    [anon_sym_boolean] = ACTIONS(1646),
    [anon_sym_string] = ACTIONS(1646),
    [anon_sym_symbol] = ACTIONS(1646),
    [anon_sym_abstract] = ACTIONS(1646),
    [anon_sym_satisfies] = ACTIONS(1646),
    [anon_sym_infer] = ACTIONS(1646),
    [anon_sym_keyof] = ACTIONS(1646),
    [anon_sym_unknown] = ACTIONS(1646),
    [anon_sym_never] = ACTIONS(1646),
    [anon_sym_object] = ACTIONS(1646),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1650),
    [anon_sym_constructor] = ACTIONS(1646),
    [anon_sym_prop] = ACTIONS(1646),
    [anon_sym_id] = ACTIONS(1646),
    [anon_sym_event] = ACTIONS(1646),
    [anon_sym_fn] = ACTIONS(1646),
    [anon_sym_on] = ACTIONS(1646),
    [sym__ternary_qmark] = ACTIONS(1650),
  },
  [1038] = {
    [sym_identifier] = ACTIONS(1384),
    [anon_sym_STAR] = ACTIONS(1384),
    [anon_sym_as] = ACTIONS(1384),
    [anon_sym_LBRACE] = ACTIONS(1384),
    [anon_sym_RBRACE] = ACTIONS(1388),
    [anon_sym_typeof] = ACTIONS(1384),
    [anon_sym_BANG] = ACTIONS(1384),
    [anon_sym_LPAREN] = ACTIONS(1388),
    [anon_sym_in] = ACTIONS(1384),
    [anon_sym_SEMI] = ACTIONS(1388),
    [anon_sym_LBRACK] = ACTIONS(1388),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_GT] = ACTIONS(1384),
    [anon_sym_SLASH] = ACTIONS(1384),
    [anon_sym_DOT] = ACTIONS(1384),
    [anon_sym_async] = ACTIONS(1384),
    [anon_sym_QMARK_DOT] = ACTIONS(1388),
    [anon_sym_new] = ACTIONS(1384),
    [anon_sym_AMP_AMP] = ACTIONS(1388),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_GT_GT] = ACTIONS(1384),
    [anon_sym_GT_GT_GT] = ACTIONS(1388),
    [anon_sym_LT_LT] = ACTIONS(1388),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_PIPE] = ACTIONS(1384),
    [anon_sym_PLUS] = ACTIONS(1384),
    [anon_sym_DASH] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1388),
    [anon_sym_LT_EQ] = ACTIONS(1388),
    [anon_sym_EQ_EQ] = ACTIONS(1384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1388),
    [anon_sym_BANG_EQ] = ACTIONS(1384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1388),
    [anon_sym_GT_EQ] = ACTIONS(1388),
    [anon_sym_QMARK_QMARK] = ACTIONS(1388),
    [anon_sym_instanceof] = ACTIONS(1384),
    [anon_sym_void] = ACTIONS(1384),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [anon_sym_DQUOTE] = ACTIONS(1388),
    [anon_sym_SQUOTE] = ACTIONS(1388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1388),
    [sym_number] = ACTIONS(1388),
    [sym_this] = ACTIONS(1384),
    [sym_true] = ACTIONS(1384),
    [sym_false] = ACTIONS(1384),
    [sym_null] = ACTIONS(1384),
    [sym_undefined] = ACTIONS(1384),
    [anon_sym_static] = ACTIONS(1384),
    [anon_sym_readonly] = ACTIONS(1384),
    [anon_sym_get] = ACTIONS(1384),
    [anon_sym_set] = ACTIONS(1384),
    [anon_sym_QMARK] = ACTIONS(1384),
    [anon_sym_any] = ACTIONS(1384),
    [anon_sym_number] = ACTIONS(1384),
    [anon_sym_boolean] = ACTIONS(1384),
    [anon_sym_string] = ACTIONS(1384),
    [anon_sym_symbol] = ACTIONS(1384),
    [anon_sym_abstract] = ACTIONS(1384),
    [anon_sym_satisfies] = ACTIONS(1384),
    [anon_sym_infer] = ACTIONS(1384),
    [anon_sym_keyof] = ACTIONS(1384),
    [anon_sym_unknown] = ACTIONS(1384),
    [anon_sym_never] = ACTIONS(1384),
    [anon_sym_object] = ACTIONS(1384),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1388),
    [anon_sym_constructor] = ACTIONS(1384),
    [anon_sym_prop] = ACTIONS(1384),
    [anon_sym_id] = ACTIONS(1384),
    [anon_sym_event] = ACTIONS(1384),
    [anon_sym_fn] = ACTIONS(1384),
    [anon_sym_on] = ACTIONS(1384),
    [sym__ternary_qmark] = ACTIONS(1388),
  },
  [1039] = {
    [sym_identifier] = ACTIONS(1556),
    [anon_sym_STAR] = ACTIONS(1556),
    [anon_sym_as] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(1556),
    [anon_sym_RBRACE] = ACTIONS(1560),
    [anon_sym_typeof] = ACTIONS(1556),
    [anon_sym_BANG] = ACTIONS(1556),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_in] = ACTIONS(1556),
    [anon_sym_SEMI] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1560),
    [anon_sym_LT] = ACTIONS(1556),
    [anon_sym_GT] = ACTIONS(1556),
    [anon_sym_SLASH] = ACTIONS(1556),
    [anon_sym_DOT] = ACTIONS(1556),
    [anon_sym_async] = ACTIONS(1556),
    [anon_sym_QMARK_DOT] = ACTIONS(1560),
    [anon_sym_new] = ACTIONS(1556),
    [anon_sym_AMP_AMP] = ACTIONS(1560),
    [anon_sym_PIPE_PIPE] = ACTIONS(1560),
    [anon_sym_GT_GT] = ACTIONS(1556),
    [anon_sym_GT_GT_GT] = ACTIONS(1560),
    [anon_sym_LT_LT] = ACTIONS(1560),
    [anon_sym_AMP] = ACTIONS(1556),
    [anon_sym_CARET] = ACTIONS(1560),
    [anon_sym_PIPE] = ACTIONS(1556),
    [anon_sym_PLUS] = ACTIONS(1556),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_PERCENT] = ACTIONS(1560),
    [anon_sym_STAR_STAR] = ACTIONS(1560),
    [anon_sym_LT_EQ] = ACTIONS(1560),
    [anon_sym_EQ_EQ] = ACTIONS(1556),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1560),
    [anon_sym_BANG_EQ] = ACTIONS(1556),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1560),
    [anon_sym_GT_EQ] = ACTIONS(1560),
    [anon_sym_QMARK_QMARK] = ACTIONS(1560),
    [anon_sym_instanceof] = ACTIONS(1556),
    [anon_sym_void] = ACTIONS(1556),
    [anon_sym_PLUS_PLUS] = ACTIONS(1560),
    [anon_sym_DASH_DASH] = ACTIONS(1560),
    [anon_sym_DQUOTE] = ACTIONS(1560),
    [anon_sym_SQUOTE] = ACTIONS(1560),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1560),
    [sym_number] = ACTIONS(1560),
    [sym_this] = ACTIONS(1556),
    [sym_true] = ACTIONS(1556),
    [sym_false] = ACTIONS(1556),
    [sym_null] = ACTIONS(1556),
    [sym_undefined] = ACTIONS(1556),
    [anon_sym_static] = ACTIONS(1556),
    [anon_sym_readonly] = ACTIONS(1556),
    [anon_sym_get] = ACTIONS(1556),
    [anon_sym_set] = ACTIONS(1556),
    [anon_sym_QMARK] = ACTIONS(1556),
    [anon_sym_any] = ACTIONS(1556),
    [anon_sym_number] = ACTIONS(1556),
    [anon_sym_boolean] = ACTIONS(1556),
    [anon_sym_string] = ACTIONS(1556),
    [anon_sym_symbol] = ACTIONS(1556),
    [anon_sym_abstract] = ACTIONS(1556),
    [anon_sym_satisfies] = ACTIONS(1556),
    [anon_sym_infer] = ACTIONS(1556),
    [anon_sym_keyof] = ACTIONS(1556),
    [anon_sym_unknown] = ACTIONS(1556),
    [anon_sym_never] = ACTIONS(1556),
    [anon_sym_object] = ACTIONS(1556),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1560),
    [anon_sym_constructor] = ACTIONS(1556),
    [anon_sym_prop] = ACTIONS(1556),
    [anon_sym_id] = ACTIONS(1556),
    [anon_sym_event] = ACTIONS(1556),
    [anon_sym_fn] = ACTIONS(1556),
    [anon_sym_on] = ACTIONS(1556),
    [sym__ternary_qmark] = ACTIONS(1560),
  },
  [1040] = {
    [sym_identifier] = ACTIONS(1606),
    [anon_sym_STAR] = ACTIONS(1606),
    [anon_sym_as] = ACTIONS(1606),
    [anon_sym_LBRACE] = ACTIONS(1606),
    [anon_sym_RBRACE] = ACTIONS(1610),
    [anon_sym_typeof] = ACTIONS(1606),
    [anon_sym_BANG] = ACTIONS(1606),
    [anon_sym_LPAREN] = ACTIONS(1610),
    [anon_sym_in] = ACTIONS(1606),
    [anon_sym_SEMI] = ACTIONS(1610),
    [anon_sym_LBRACK] = ACTIONS(1610),
    [anon_sym_LT] = ACTIONS(1606),
    [anon_sym_GT] = ACTIONS(1606),
    [anon_sym_SLASH] = ACTIONS(1606),
    [anon_sym_DOT] = ACTIONS(1606),
    [anon_sym_async] = ACTIONS(1606),
    [anon_sym_QMARK_DOT] = ACTIONS(1610),
    [anon_sym_new] = ACTIONS(1606),
    [anon_sym_AMP_AMP] = ACTIONS(1610),
    [anon_sym_PIPE_PIPE] = ACTIONS(1610),
    [anon_sym_GT_GT] = ACTIONS(1606),
    [anon_sym_GT_GT_GT] = ACTIONS(1610),
    [anon_sym_LT_LT] = ACTIONS(1610),
    [anon_sym_AMP] = ACTIONS(1606),
    [anon_sym_CARET] = ACTIONS(1610),
    [anon_sym_PIPE] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1606),
    [anon_sym_DASH] = ACTIONS(1606),
    [anon_sym_PERCENT] = ACTIONS(1610),
    [anon_sym_STAR_STAR] = ACTIONS(1610),
    [anon_sym_LT_EQ] = ACTIONS(1610),
    [anon_sym_EQ_EQ] = ACTIONS(1606),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1610),
    [anon_sym_BANG_EQ] = ACTIONS(1606),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1610),
    [anon_sym_GT_EQ] = ACTIONS(1610),
    [anon_sym_QMARK_QMARK] = ACTIONS(1610),
    [anon_sym_instanceof] = ACTIONS(1606),
    [anon_sym_void] = ACTIONS(1606),
    [anon_sym_PLUS_PLUS] = ACTIONS(1610),
    [anon_sym_DASH_DASH] = ACTIONS(1610),
    [anon_sym_DQUOTE] = ACTIONS(1610),
    [anon_sym_SQUOTE] = ACTIONS(1610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1610),
    [sym_number] = ACTIONS(1610),
    [sym_this] = ACTIONS(1606),
    [sym_true] = ACTIONS(1606),
    [sym_false] = ACTIONS(1606),
    [sym_null] = ACTIONS(1606),
    [sym_undefined] = ACTIONS(1606),
    [anon_sym_static] = ACTIONS(1606),
    [anon_sym_readonly] = ACTIONS(1606),
    [anon_sym_get] = ACTIONS(1606),
    [anon_sym_set] = ACTIONS(1606),
    [anon_sym_QMARK] = ACTIONS(1606),
    [anon_sym_any] = ACTIONS(1606),
    [anon_sym_number] = ACTIONS(1606),
    [anon_sym_boolean] = ACTIONS(1606),
    [anon_sym_string] = ACTIONS(1606),
    [anon_sym_symbol] = ACTIONS(1606),
    [anon_sym_abstract] = ACTIONS(1606),
    [anon_sym_satisfies] = ACTIONS(1606),
    [anon_sym_infer] = ACTIONS(1606),
    [anon_sym_keyof] = ACTIONS(1606),
    [anon_sym_unknown] = ACTIONS(1606),
    [anon_sym_never] = ACTIONS(1606),
    [anon_sym_object] = ACTIONS(1606),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1610),
    [anon_sym_constructor] = ACTIONS(1606),
    [anon_sym_prop] = ACTIONS(1606),
    [anon_sym_id] = ACTIONS(1606),
    [anon_sym_event] = ACTIONS(1606),
    [anon_sym_fn] = ACTIONS(1606),
    [anon_sym_on] = ACTIONS(1606),
    [sym__ternary_qmark] = ACTIONS(1610),
  },
  [1041] = {
    [sym_identifier] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_as] = ACTIONS(3505),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_RBRACE] = ACTIONS(3507),
    [anon_sym_typeof] = ACTIONS(3505),
    [anon_sym_BANG] = ACTIONS(3505),
    [anon_sym_LPAREN] = ACTIONS(3507),
    [anon_sym_in] = ACTIONS(3505),
    [anon_sym_SEMI] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3507),
    [anon_sym_LT] = ACTIONS(3505),
    [anon_sym_GT] = ACTIONS(3505),
    [anon_sym_SLASH] = ACTIONS(3505),
    [anon_sym_DOT] = ACTIONS(3505),
    [anon_sym_async] = ACTIONS(3505),
    [anon_sym_QMARK_DOT] = ACTIONS(3507),
    [anon_sym_new] = ACTIONS(3505),
    [anon_sym_AMP_AMP] = ACTIONS(3507),
    [anon_sym_PIPE_PIPE] = ACTIONS(3507),
    [anon_sym_GT_GT] = ACTIONS(3505),
    [anon_sym_GT_GT_GT] = ACTIONS(3507),
    [anon_sym_LT_LT] = ACTIONS(3507),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_PIPE] = ACTIONS(3505),
    [anon_sym_PLUS] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3505),
    [anon_sym_PERCENT] = ACTIONS(3507),
    [anon_sym_STAR_STAR] = ACTIONS(3507),
    [anon_sym_LT_EQ] = ACTIONS(3507),
    [anon_sym_EQ_EQ] = ACTIONS(3505),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3507),
    [anon_sym_BANG_EQ] = ACTIONS(3505),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3507),
    [anon_sym_GT_EQ] = ACTIONS(3507),
    [anon_sym_QMARK_QMARK] = ACTIONS(3507),
    [anon_sym_instanceof] = ACTIONS(3505),
    [anon_sym_void] = ACTIONS(3505),
    [anon_sym_PLUS_PLUS] = ACTIONS(3507),
    [anon_sym_DASH_DASH] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3507),
    [anon_sym_SQUOTE] = ACTIONS(3507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3507),
    [sym_number] = ACTIONS(3507),
    [sym_this] = ACTIONS(3505),
    [sym_true] = ACTIONS(3505),
    [sym_false] = ACTIONS(3505),
    [sym_null] = ACTIONS(3505),
    [sym_undefined] = ACTIONS(3505),
    [anon_sym_static] = ACTIONS(3505),
    [anon_sym_readonly] = ACTIONS(3505),
    [anon_sym_get] = ACTIONS(3505),
    [anon_sym_set] = ACTIONS(3505),
    [anon_sym_QMARK] = ACTIONS(3505),
    [anon_sym_any] = ACTIONS(3505),
    [anon_sym_number] = ACTIONS(3505),
    [anon_sym_boolean] = ACTIONS(3505),
    [anon_sym_string] = ACTIONS(3505),
    [anon_sym_symbol] = ACTIONS(3505),
    [anon_sym_abstract] = ACTIONS(3505),
    [anon_sym_satisfies] = ACTIONS(3505),
    [anon_sym_infer] = ACTIONS(3505),
    [anon_sym_keyof] = ACTIONS(3505),
    [anon_sym_unknown] = ACTIONS(3505),
    [anon_sym_never] = ACTIONS(3505),
    [anon_sym_object] = ACTIONS(3505),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3507),
    [anon_sym_constructor] = ACTIONS(3505),
    [anon_sym_prop] = ACTIONS(3505),
    [anon_sym_id] = ACTIONS(3505),
    [anon_sym_event] = ACTIONS(3505),
    [anon_sym_fn] = ACTIONS(3505),
    [anon_sym_on] = ACTIONS(3505),
    [sym__ternary_qmark] = ACTIONS(3507),
  },
  [1042] = {
    [sym_identifier] = ACTIONS(1454),
    [anon_sym_STAR] = ACTIONS(1454),
    [anon_sym_as] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1454),
    [anon_sym_RBRACE] = ACTIONS(1458),
    [anon_sym_typeof] = ACTIONS(1454),
    [anon_sym_BANG] = ACTIONS(1454),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [anon_sym_in] = ACTIONS(1454),
    [anon_sym_SEMI] = ACTIONS(1458),
    [anon_sym_LBRACK] = ACTIONS(1458),
    [anon_sym_LT] = ACTIONS(1454),
    [anon_sym_GT] = ACTIONS(1454),
    [anon_sym_SLASH] = ACTIONS(1454),
    [anon_sym_DOT] = ACTIONS(1454),
    [anon_sym_async] = ACTIONS(1454),
    [anon_sym_QMARK_DOT] = ACTIONS(1458),
    [anon_sym_new] = ACTIONS(1454),
    [anon_sym_AMP_AMP] = ACTIONS(1458),
    [anon_sym_PIPE_PIPE] = ACTIONS(1458),
    [anon_sym_GT_GT] = ACTIONS(1454),
    [anon_sym_GT_GT_GT] = ACTIONS(1458),
    [anon_sym_LT_LT] = ACTIONS(1458),
    [anon_sym_AMP] = ACTIONS(1454),
    [anon_sym_CARET] = ACTIONS(1458),
    [anon_sym_PIPE] = ACTIONS(1454),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_PERCENT] = ACTIONS(1458),
    [anon_sym_STAR_STAR] = ACTIONS(1458),
    [anon_sym_LT_EQ] = ACTIONS(1458),
    [anon_sym_EQ_EQ] = ACTIONS(1454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1458),
    [anon_sym_BANG_EQ] = ACTIONS(1454),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1458),
    [anon_sym_GT_EQ] = ACTIONS(1458),
    [anon_sym_QMARK_QMARK] = ACTIONS(1458),
    [anon_sym_instanceof] = ACTIONS(1454),
    [anon_sym_void] = ACTIONS(1454),
    [anon_sym_PLUS_PLUS] = ACTIONS(1458),
    [anon_sym_DASH_DASH] = ACTIONS(1458),
    [anon_sym_DQUOTE] = ACTIONS(1458),
    [anon_sym_SQUOTE] = ACTIONS(1458),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1458),
    [sym_number] = ACTIONS(1458),
    [sym_this] = ACTIONS(1454),
    [sym_true] = ACTIONS(1454),
    [sym_false] = ACTIONS(1454),
    [sym_null] = ACTIONS(1454),
    [sym_undefined] = ACTIONS(1454),
    [anon_sym_static] = ACTIONS(1454),
    [anon_sym_readonly] = ACTIONS(1454),
    [anon_sym_get] = ACTIONS(1454),
    [anon_sym_set] = ACTIONS(1454),
    [anon_sym_QMARK] = ACTIONS(1454),
    [anon_sym_any] = ACTIONS(1454),
    [anon_sym_number] = ACTIONS(1454),
    [anon_sym_boolean] = ACTIONS(1454),
    [anon_sym_string] = ACTIONS(1454),
    [anon_sym_symbol] = ACTIONS(1454),
    [anon_sym_abstract] = ACTIONS(1454),
    [anon_sym_satisfies] = ACTIONS(1454),
    [anon_sym_infer] = ACTIONS(1454),
    [anon_sym_keyof] = ACTIONS(1454),
    [anon_sym_unknown] = ACTIONS(1454),
    [anon_sym_never] = ACTIONS(1454),
    [anon_sym_object] = ACTIONS(1454),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1458),
    [anon_sym_constructor] = ACTIONS(1454),
    [anon_sym_prop] = ACTIONS(1454),
    [anon_sym_id] = ACTIONS(1454),
    [anon_sym_event] = ACTIONS(1454),
    [anon_sym_fn] = ACTIONS(1454),
    [anon_sym_on] = ACTIONS(1454),
    [sym__ternary_qmark] = ACTIONS(1458),
  },
  [1043] = {
    [sym_identifier] = ACTIONS(3509),
    [anon_sym_STAR] = ACTIONS(3509),
    [anon_sym_as] = ACTIONS(3509),
    [anon_sym_LBRACE] = ACTIONS(3509),
    [anon_sym_RBRACE] = ACTIONS(3511),
    [anon_sym_typeof] = ACTIONS(3509),
    [anon_sym_BANG] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3511),
    [anon_sym_in] = ACTIONS(3509),
    [anon_sym_SEMI] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3511),
    [anon_sym_LT] = ACTIONS(3509),
    [anon_sym_GT] = ACTIONS(3509),
    [anon_sym_SLASH] = ACTIONS(3509),
    [anon_sym_DOT] = ACTIONS(3509),
    [anon_sym_async] = ACTIONS(3509),
    [anon_sym_QMARK_DOT] = ACTIONS(3511),
    [anon_sym_new] = ACTIONS(3509),
    [anon_sym_AMP_AMP] = ACTIONS(3511),
    [anon_sym_PIPE_PIPE] = ACTIONS(3511),
    [anon_sym_GT_GT] = ACTIONS(3509),
    [anon_sym_GT_GT_GT] = ACTIONS(3511),
    [anon_sym_LT_LT] = ACTIONS(3511),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_CARET] = ACTIONS(3511),
    [anon_sym_PIPE] = ACTIONS(3509),
    [anon_sym_PLUS] = ACTIONS(3509),
    [anon_sym_DASH] = ACTIONS(3509),
    [anon_sym_PERCENT] = ACTIONS(3511),
    [anon_sym_STAR_STAR] = ACTIONS(3511),
    [anon_sym_LT_EQ] = ACTIONS(3511),
    [anon_sym_EQ_EQ] = ACTIONS(3509),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3511),
    [anon_sym_BANG_EQ] = ACTIONS(3509),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3511),
    [anon_sym_GT_EQ] = ACTIONS(3511),
    [anon_sym_QMARK_QMARK] = ACTIONS(3511),
    [anon_sym_instanceof] = ACTIONS(3509),
    [anon_sym_void] = ACTIONS(3509),
    [anon_sym_PLUS_PLUS] = ACTIONS(3511),
    [anon_sym_DASH_DASH] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3511),
    [anon_sym_SQUOTE] = ACTIONS(3511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3511),
    [sym_number] = ACTIONS(3511),
    [sym_this] = ACTIONS(3509),
    [sym_true] = ACTIONS(3509),
    [sym_false] = ACTIONS(3509),
    [sym_null] = ACTIONS(3509),
    [sym_undefined] = ACTIONS(3509),
    [anon_sym_static] = ACTIONS(3509),
    [anon_sym_readonly] = ACTIONS(3509),
    [anon_sym_get] = ACTIONS(3509),
    [anon_sym_set] = ACTIONS(3509),
    [anon_sym_QMARK] = ACTIONS(3509),
    [anon_sym_any] = ACTIONS(3509),
    [anon_sym_number] = ACTIONS(3509),
    [anon_sym_boolean] = ACTIONS(3509),
    [anon_sym_string] = ACTIONS(3509),
    [anon_sym_symbol] = ACTIONS(3509),
    [anon_sym_abstract] = ACTIONS(3509),
    [anon_sym_satisfies] = ACTIONS(3509),
    [anon_sym_infer] = ACTIONS(3509),
    [anon_sym_keyof] = ACTIONS(3509),
    [anon_sym_unknown] = ACTIONS(3509),
    [anon_sym_never] = ACTIONS(3509),
    [anon_sym_object] = ACTIONS(3509),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3511),
    [anon_sym_constructor] = ACTIONS(3509),
    [anon_sym_prop] = ACTIONS(3509),
    [anon_sym_id] = ACTIONS(3509),
    [anon_sym_event] = ACTIONS(3509),
    [anon_sym_fn] = ACTIONS(3509),
    [anon_sym_on] = ACTIONS(3509),
    [sym__ternary_qmark] = ACTIONS(3511),
  },
  [1044] = {
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_STAR] = ACTIONS(2970),
    [anon_sym_as] = ACTIONS(2970),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2970),
    [anon_sym_BANG] = ACTIONS(2970),
    [anon_sym_LPAREN] = ACTIONS(2972),
    [anon_sym_in] = ACTIONS(2970),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_LT] = ACTIONS(2970),
    [anon_sym_GT] = ACTIONS(2970),
    [anon_sym_SLASH] = ACTIONS(2970),
    [anon_sym_DOT] = ACTIONS(2970),
    [anon_sym_async] = ACTIONS(2970),
    [anon_sym_QMARK_DOT] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2972),
    [anon_sym_PIPE_PIPE] = ACTIONS(2972),
    [anon_sym_GT_GT] = ACTIONS(2970),
    [anon_sym_GT_GT_GT] = ACTIONS(2972),
    [anon_sym_LT_LT] = ACTIONS(2972),
    [anon_sym_AMP] = ACTIONS(2970),
    [anon_sym_CARET] = ACTIONS(2972),
    [anon_sym_PIPE] = ACTIONS(2970),
    [anon_sym_PLUS] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2970),
    [anon_sym_PERCENT] = ACTIONS(2972),
    [anon_sym_STAR_STAR] = ACTIONS(2972),
    [anon_sym_LT_EQ] = ACTIONS(2972),
    [anon_sym_EQ_EQ] = ACTIONS(2970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2972),
    [anon_sym_BANG_EQ] = ACTIONS(2970),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2972),
    [anon_sym_GT_EQ] = ACTIONS(2972),
    [anon_sym_QMARK_QMARK] = ACTIONS(2972),
    [anon_sym_instanceof] = ACTIONS(2970),
    [anon_sym_void] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2972),
    [anon_sym_DASH_DASH] = ACTIONS(2972),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2972),
    [sym_number] = ACTIONS(2972),
    [sym_this] = ACTIONS(2970),
    [sym_true] = ACTIONS(2970),
    [sym_false] = ACTIONS(2970),
    [sym_null] = ACTIONS(2970),
    [sym_undefined] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_readonly] = ACTIONS(2970),
    [anon_sym_get] = ACTIONS(2970),
    [anon_sym_set] = ACTIONS(2970),
    [anon_sym_QMARK] = ACTIONS(2970),
    [anon_sym_any] = ACTIONS(2970),
    [anon_sym_number] = ACTIONS(2970),
    [anon_sym_boolean] = ACTIONS(2970),
    [anon_sym_string] = ACTIONS(2970),
    [anon_sym_symbol] = ACTIONS(2970),
    [anon_sym_abstract] = ACTIONS(2970),
    [anon_sym_satisfies] = ACTIONS(2970),
    [anon_sym_infer] = ACTIONS(2970),
    [anon_sym_keyof] = ACTIONS(2970),
    [anon_sym_unknown] = ACTIONS(2970),
    [anon_sym_never] = ACTIONS(2970),
    [anon_sym_object] = ACTIONS(2970),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2972),
    [anon_sym_constructor] = ACTIONS(2970),
    [anon_sym_prop] = ACTIONS(2970),
    [anon_sym_id] = ACTIONS(2970),
    [anon_sym_event] = ACTIONS(2970),
    [anon_sym_fn] = ACTIONS(2970),
    [anon_sym_on] = ACTIONS(2970),
    [sym__ternary_qmark] = ACTIONS(2972),
  },
  [1045] = {
    [sym_identifier] = ACTIONS(2780),
    [anon_sym_STAR] = ACTIONS(2780),
    [anon_sym_as] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2780),
    [anon_sym_RBRACE] = ACTIONS(2782),
    [anon_sym_typeof] = ACTIONS(2780),
    [anon_sym_BANG] = ACTIONS(2780),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(2780),
    [anon_sym_SEMI] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2780),
    [anon_sym_GT] = ACTIONS(2780),
    [anon_sym_SLASH] = ACTIONS(2780),
    [anon_sym_DOT] = ACTIONS(2780),
    [anon_sym_async] = ACTIONS(2780),
    [anon_sym_QMARK_DOT] = ACTIONS(2782),
    [anon_sym_new] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(2782),
    [anon_sym_PIPE_PIPE] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2780),
    [anon_sym_GT_GT_GT] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2780),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2780),
    [anon_sym_DASH] = ACTIONS(2780),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_STAR_STAR] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2782),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2782),
    [anon_sym_GT_EQ] = ACTIONS(2782),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_instanceof] = ACTIONS(2780),
    [anon_sym_void] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2782),
    [anon_sym_DASH_DASH] = ACTIONS(2782),
    [anon_sym_DQUOTE] = ACTIONS(2782),
    [anon_sym_SQUOTE] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2782),
    [sym_number] = ACTIONS(2782),
    [sym_this] = ACTIONS(2780),
    [sym_true] = ACTIONS(2780),
    [sym_false] = ACTIONS(2780),
    [sym_null] = ACTIONS(2780),
    [sym_undefined] = ACTIONS(2780),
    [anon_sym_static] = ACTIONS(2780),
    [anon_sym_readonly] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2780),
    [anon_sym_set] = ACTIONS(2780),
    [anon_sym_QMARK] = ACTIONS(2780),
    [anon_sym_any] = ACTIONS(2780),
    [anon_sym_number] = ACTIONS(2780),
    [anon_sym_boolean] = ACTIONS(2780),
    [anon_sym_string] = ACTIONS(2780),
    [anon_sym_symbol] = ACTIONS(2780),
    [anon_sym_abstract] = ACTIONS(2780),
    [anon_sym_satisfies] = ACTIONS(2780),
    [anon_sym_infer] = ACTIONS(2780),
    [anon_sym_keyof] = ACTIONS(2780),
    [anon_sym_unknown] = ACTIONS(2780),
    [anon_sym_never] = ACTIONS(2780),
    [anon_sym_object] = ACTIONS(2780),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2782),
    [anon_sym_constructor] = ACTIONS(2780),
    [anon_sym_prop] = ACTIONS(2780),
    [anon_sym_id] = ACTIONS(2780),
    [anon_sym_event] = ACTIONS(2780),
    [anon_sym_fn] = ACTIONS(2780),
    [anon_sym_on] = ACTIONS(2780),
    [sym__ternary_qmark] = ACTIONS(2782),
  },
  [1046] = {
    [sym_identifier] = ACTIONS(1728),
    [anon_sym_STAR] = ACTIONS(1728),
    [anon_sym_as] = ACTIONS(1728),
    [anon_sym_LBRACE] = ACTIONS(1728),
    [anon_sym_RBRACE] = ACTIONS(1732),
    [anon_sym_typeof] = ACTIONS(1728),
    [anon_sym_BANG] = ACTIONS(1728),
    [anon_sym_LPAREN] = ACTIONS(1732),
    [anon_sym_in] = ACTIONS(1728),
    [anon_sym_SEMI] = ACTIONS(1732),
    [anon_sym_LBRACK] = ACTIONS(1732),
    [anon_sym_LT] = ACTIONS(1728),
    [anon_sym_GT] = ACTIONS(1728),
    [anon_sym_SLASH] = ACTIONS(1728),
    [anon_sym_DOT] = ACTIONS(1728),
    [anon_sym_async] = ACTIONS(1728),
    [anon_sym_QMARK_DOT] = ACTIONS(1732),
    [anon_sym_new] = ACTIONS(1728),
    [anon_sym_AMP_AMP] = ACTIONS(1732),
    [anon_sym_PIPE_PIPE] = ACTIONS(1732),
    [anon_sym_GT_GT] = ACTIONS(1728),
    [anon_sym_GT_GT_GT] = ACTIONS(1732),
    [anon_sym_LT_LT] = ACTIONS(1732),
    [anon_sym_AMP] = ACTIONS(1728),
    [anon_sym_CARET] = ACTIONS(1732),
    [anon_sym_PIPE] = ACTIONS(1728),
    [anon_sym_PLUS] = ACTIONS(1728),
    [anon_sym_DASH] = ACTIONS(1728),
    [anon_sym_PERCENT] = ACTIONS(1732),
    [anon_sym_STAR_STAR] = ACTIONS(1732),
    [anon_sym_LT_EQ] = ACTIONS(1732),
    [anon_sym_EQ_EQ] = ACTIONS(1728),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1732),
    [anon_sym_BANG_EQ] = ACTIONS(1728),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1732),
    [anon_sym_GT_EQ] = ACTIONS(1732),
    [anon_sym_QMARK_QMARK] = ACTIONS(1732),
    [anon_sym_instanceof] = ACTIONS(1728),
    [anon_sym_void] = ACTIONS(1728),
    [anon_sym_PLUS_PLUS] = ACTIONS(1732),
    [anon_sym_DASH_DASH] = ACTIONS(1732),
    [anon_sym_DQUOTE] = ACTIONS(1732),
    [anon_sym_SQUOTE] = ACTIONS(1732),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1732),
    [sym_number] = ACTIONS(1732),
    [sym_this] = ACTIONS(1728),
    [sym_true] = ACTIONS(1728),
    [sym_false] = ACTIONS(1728),
    [sym_null] = ACTIONS(1728),
    [sym_undefined] = ACTIONS(1728),
    [anon_sym_static] = ACTIONS(1728),
    [anon_sym_readonly] = ACTIONS(1728),
    [anon_sym_get] = ACTIONS(1728),
    [anon_sym_set] = ACTIONS(1728),
    [anon_sym_QMARK] = ACTIONS(1728),
    [anon_sym_any] = ACTIONS(1728),
    [anon_sym_number] = ACTIONS(1728),
    [anon_sym_boolean] = ACTIONS(1728),
    [anon_sym_string] = ACTIONS(1728),
    [anon_sym_symbol] = ACTIONS(1728),
    [anon_sym_abstract] = ACTIONS(1728),
    [anon_sym_satisfies] = ACTIONS(1728),
    [anon_sym_infer] = ACTIONS(1728),
    [anon_sym_keyof] = ACTIONS(1728),
    [anon_sym_unknown] = ACTIONS(1728),
    [anon_sym_never] = ACTIONS(1728),
    [anon_sym_object] = ACTIONS(1728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1732),
    [anon_sym_constructor] = ACTIONS(1728),
    [anon_sym_prop] = ACTIONS(1728),
    [anon_sym_id] = ACTIONS(1728),
    [anon_sym_event] = ACTIONS(1728),
    [anon_sym_fn] = ACTIONS(1728),
    [anon_sym_on] = ACTIONS(1728),
    [sym__ternary_qmark] = ACTIONS(1732),
  },
  [1047] = {
    [sym_identifier] = ACTIONS(3513),
    [anon_sym_STAR] = ACTIONS(3513),
    [anon_sym_as] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3513),
    [anon_sym_RBRACE] = ACTIONS(3515),
    [anon_sym_typeof] = ACTIONS(3513),
    [anon_sym_BANG] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [anon_sym_in] = ACTIONS(3513),
    [anon_sym_SEMI] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [anon_sym_LT] = ACTIONS(3513),
    [anon_sym_GT] = ACTIONS(3513),
    [anon_sym_SLASH] = ACTIONS(3513),
    [anon_sym_DOT] = ACTIONS(3513),
    [anon_sym_async] = ACTIONS(3513),
    [anon_sym_QMARK_DOT] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3513),
    [anon_sym_AMP_AMP] = ACTIONS(3515),
    [anon_sym_PIPE_PIPE] = ACTIONS(3515),
    [anon_sym_GT_GT] = ACTIONS(3513),
    [anon_sym_GT_GT_GT] = ACTIONS(3515),
    [anon_sym_LT_LT] = ACTIONS(3515),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym_CARET] = ACTIONS(3515),
    [anon_sym_PIPE] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3513),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_PERCENT] = ACTIONS(3515),
    [anon_sym_STAR_STAR] = ACTIONS(3515),
    [anon_sym_LT_EQ] = ACTIONS(3515),
    [anon_sym_EQ_EQ] = ACTIONS(3513),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3515),
    [anon_sym_BANG_EQ] = ACTIONS(3513),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3515),
    [anon_sym_GT_EQ] = ACTIONS(3515),
    [anon_sym_QMARK_QMARK] = ACTIONS(3515),
    [anon_sym_instanceof] = ACTIONS(3513),
    [anon_sym_void] = ACTIONS(3513),
    [anon_sym_PLUS_PLUS] = ACTIONS(3515),
    [anon_sym_DASH_DASH] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_SQUOTE] = ACTIONS(3515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3515),
    [sym_number] = ACTIONS(3515),
    [sym_this] = ACTIONS(3513),
    [sym_true] = ACTIONS(3513),
    [sym_false] = ACTIONS(3513),
    [sym_null] = ACTIONS(3513),
    [sym_undefined] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_readonly] = ACTIONS(3513),
    [anon_sym_get] = ACTIONS(3513),
    [anon_sym_set] = ACTIONS(3513),
    [anon_sym_QMARK] = ACTIONS(3513),
    [anon_sym_any] = ACTIONS(3513),
    [anon_sym_number] = ACTIONS(3513),
    [anon_sym_boolean] = ACTIONS(3513),
    [anon_sym_string] = ACTIONS(3513),
    [anon_sym_symbol] = ACTIONS(3513),
    [anon_sym_abstract] = ACTIONS(3513),
    [anon_sym_satisfies] = ACTIONS(3513),
    [anon_sym_infer] = ACTIONS(3513),
    [anon_sym_keyof] = ACTIONS(3513),
    [anon_sym_unknown] = ACTIONS(3513),
    [anon_sym_never] = ACTIONS(3513),
    [anon_sym_object] = ACTIONS(3513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3515),
    [anon_sym_constructor] = ACTIONS(3513),
    [anon_sym_prop] = ACTIONS(3513),
    [anon_sym_id] = ACTIONS(3513),
    [anon_sym_event] = ACTIONS(3513),
    [anon_sym_fn] = ACTIONS(3513),
    [anon_sym_on] = ACTIONS(3513),
    [sym__ternary_qmark] = ACTIONS(3515),
  },
  [1048] = {
    [sym_identifier] = ACTIONS(1640),
    [anon_sym_STAR] = ACTIONS(1640),
    [anon_sym_as] = ACTIONS(1640),
    [anon_sym_LBRACE] = ACTIONS(1640),
    [anon_sym_RBRACE] = ACTIONS(1642),
    [anon_sym_typeof] = ACTIONS(1640),
    [anon_sym_BANG] = ACTIONS(1640),
    [anon_sym_LPAREN] = ACTIONS(1642),
    [anon_sym_in] = ACTIONS(1640),
    [anon_sym_SEMI] = ACTIONS(1642),
    [anon_sym_LBRACK] = ACTIONS(1642),
    [anon_sym_LT] = ACTIONS(1640),
    [anon_sym_GT] = ACTIONS(1640),
    [anon_sym_SLASH] = ACTIONS(1640),
    [anon_sym_DOT] = ACTIONS(1640),
    [anon_sym_async] = ACTIONS(1640),
    [anon_sym_QMARK_DOT] = ACTIONS(1642),
    [anon_sym_new] = ACTIONS(1640),
    [anon_sym_AMP_AMP] = ACTIONS(1642),
    [anon_sym_PIPE_PIPE] = ACTIONS(1642),
    [anon_sym_GT_GT] = ACTIONS(1640),
    [anon_sym_GT_GT_GT] = ACTIONS(1642),
    [anon_sym_LT_LT] = ACTIONS(1642),
    [anon_sym_AMP] = ACTIONS(1640),
    [anon_sym_CARET] = ACTIONS(1642),
    [anon_sym_PIPE] = ACTIONS(1640),
    [anon_sym_PLUS] = ACTIONS(1640),
    [anon_sym_DASH] = ACTIONS(1640),
    [anon_sym_PERCENT] = ACTIONS(1642),
    [anon_sym_STAR_STAR] = ACTIONS(1642),
    [anon_sym_LT_EQ] = ACTIONS(1642),
    [anon_sym_EQ_EQ] = ACTIONS(1640),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1642),
    [anon_sym_BANG_EQ] = ACTIONS(1640),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1642),
    [anon_sym_GT_EQ] = ACTIONS(1642),
    [anon_sym_QMARK_QMARK] = ACTIONS(1642),
    [anon_sym_instanceof] = ACTIONS(1640),
    [anon_sym_void] = ACTIONS(1640),
    [anon_sym_PLUS_PLUS] = ACTIONS(1642),
    [anon_sym_DASH_DASH] = ACTIONS(1642),
    [anon_sym_DQUOTE] = ACTIONS(1642),
    [anon_sym_SQUOTE] = ACTIONS(1642),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1642),
    [sym_number] = ACTIONS(1642),
    [sym_this] = ACTIONS(1640),
    [sym_true] = ACTIONS(1640),
    [sym_false] = ACTIONS(1640),
    [sym_null] = ACTIONS(1640),
    [sym_undefined] = ACTIONS(1640),
    [anon_sym_static] = ACTIONS(1640),
    [anon_sym_readonly] = ACTIONS(1640),
    [anon_sym_get] = ACTIONS(1640),
    [anon_sym_set] = ACTIONS(1640),
    [anon_sym_QMARK] = ACTIONS(1640),
    [anon_sym_any] = ACTIONS(1640),
    [anon_sym_number] = ACTIONS(1640),
    [anon_sym_boolean] = ACTIONS(1640),
    [anon_sym_string] = ACTIONS(1640),
    [anon_sym_symbol] = ACTIONS(1640),
    [anon_sym_abstract] = ACTIONS(1640),
    [anon_sym_satisfies] = ACTIONS(1640),
    [anon_sym_infer] = ACTIONS(1640),
    [anon_sym_keyof] = ACTIONS(1640),
    [anon_sym_unknown] = ACTIONS(1640),
    [anon_sym_never] = ACTIONS(1640),
    [anon_sym_object] = ACTIONS(1640),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1642),
    [anon_sym_constructor] = ACTIONS(1640),
    [anon_sym_prop] = ACTIONS(1640),
    [anon_sym_id] = ACTIONS(1640),
    [anon_sym_event] = ACTIONS(1640),
    [anon_sym_fn] = ACTIONS(1640),
    [anon_sym_on] = ACTIONS(1640),
    [sym__ternary_qmark] = ACTIONS(1642),
  },
  [1049] = {
    [sym_identifier] = ACTIONS(1596),
    [anon_sym_STAR] = ACTIONS(1596),
    [anon_sym_as] = ACTIONS(1596),
    [anon_sym_LBRACE] = ACTIONS(1596),
    [anon_sym_RBRACE] = ACTIONS(1600),
    [anon_sym_typeof] = ACTIONS(1596),
    [anon_sym_BANG] = ACTIONS(1596),
    [anon_sym_LPAREN] = ACTIONS(1600),
    [anon_sym_in] = ACTIONS(1596),
    [anon_sym_SEMI] = ACTIONS(1600),
    [anon_sym_LBRACK] = ACTIONS(1600),
    [anon_sym_LT] = ACTIONS(1596),
    [anon_sym_GT] = ACTIONS(1596),
    [anon_sym_SLASH] = ACTIONS(1596),
    [anon_sym_DOT] = ACTIONS(1596),
    [anon_sym_async] = ACTIONS(1596),
    [anon_sym_QMARK_DOT] = ACTIONS(1600),
    [anon_sym_new] = ACTIONS(1596),
    [anon_sym_AMP_AMP] = ACTIONS(1600),
    [anon_sym_PIPE_PIPE] = ACTIONS(1600),
    [anon_sym_GT_GT] = ACTIONS(1596),
    [anon_sym_GT_GT_GT] = ACTIONS(1600),
    [anon_sym_LT_LT] = ACTIONS(1600),
    [anon_sym_AMP] = ACTIONS(1596),
    [anon_sym_CARET] = ACTIONS(1600),
    [anon_sym_PIPE] = ACTIONS(1596),
    [anon_sym_PLUS] = ACTIONS(1596),
    [anon_sym_DASH] = ACTIONS(1596),
    [anon_sym_PERCENT] = ACTIONS(1600),
    [anon_sym_STAR_STAR] = ACTIONS(1600),
    [anon_sym_LT_EQ] = ACTIONS(1600),
    [anon_sym_EQ_EQ] = ACTIONS(1596),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1600),
    [anon_sym_BANG_EQ] = ACTIONS(1596),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1600),
    [anon_sym_GT_EQ] = ACTIONS(1600),
    [anon_sym_QMARK_QMARK] = ACTIONS(1600),
    [anon_sym_instanceof] = ACTIONS(1596),
    [anon_sym_void] = ACTIONS(1596),
    [anon_sym_PLUS_PLUS] = ACTIONS(1600),
    [anon_sym_DASH_DASH] = ACTIONS(1600),
    [anon_sym_DQUOTE] = ACTIONS(1600),
    [anon_sym_SQUOTE] = ACTIONS(1600),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1600),
    [sym_number] = ACTIONS(1600),
    [sym_this] = ACTIONS(1596),
    [sym_true] = ACTIONS(1596),
    [sym_false] = ACTIONS(1596),
    [sym_null] = ACTIONS(1596),
    [sym_undefined] = ACTIONS(1596),
    [anon_sym_static] = ACTIONS(1596),
    [anon_sym_readonly] = ACTIONS(1596),
    [anon_sym_get] = ACTIONS(1596),
    [anon_sym_set] = ACTIONS(1596),
    [anon_sym_QMARK] = ACTIONS(1596),
    [anon_sym_any] = ACTIONS(1596),
    [anon_sym_number] = ACTIONS(1596),
    [anon_sym_boolean] = ACTIONS(1596),
    [anon_sym_string] = ACTIONS(1596),
    [anon_sym_symbol] = ACTIONS(1596),
    [anon_sym_abstract] = ACTIONS(1596),
    [anon_sym_satisfies] = ACTIONS(1596),
    [anon_sym_infer] = ACTIONS(1596),
    [anon_sym_keyof] = ACTIONS(1596),
    [anon_sym_unknown] = ACTIONS(1596),
    [anon_sym_never] = ACTIONS(1596),
    [anon_sym_object] = ACTIONS(1596),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1600),
    [anon_sym_constructor] = ACTIONS(1596),
    [anon_sym_prop] = ACTIONS(1596),
    [anon_sym_id] = ACTIONS(1596),
    [anon_sym_event] = ACTIONS(1596),
    [anon_sym_fn] = ACTIONS(1596),
    [anon_sym_on] = ACTIONS(1596),
    [sym__ternary_qmark] = ACTIONS(1600),
  },
  [1050] = {
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_STAR] = ACTIONS(2882),
    [anon_sym_as] = ACTIONS(2882),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_RBRACE] = ACTIONS(2884),
    [anon_sym_typeof] = ACTIONS(2882),
    [anon_sym_BANG] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_in] = ACTIONS(2882),
    [anon_sym_SEMI] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2884),
    [anon_sym_LT] = ACTIONS(2882),
    [anon_sym_GT] = ACTIONS(2882),
    [anon_sym_SLASH] = ACTIONS(2882),
    [anon_sym_DOT] = ACTIONS(2882),
    [anon_sym_async] = ACTIONS(2882),
    [anon_sym_QMARK_DOT] = ACTIONS(2884),
    [anon_sym_new] = ACTIONS(2882),
    [anon_sym_AMP_AMP] = ACTIONS(2884),
    [anon_sym_PIPE_PIPE] = ACTIONS(2884),
    [anon_sym_GT_GT] = ACTIONS(2882),
    [anon_sym_GT_GT_GT] = ACTIONS(2884),
    [anon_sym_LT_LT] = ACTIONS(2884),
    [anon_sym_AMP] = ACTIONS(2882),
    [anon_sym_CARET] = ACTIONS(2884),
    [anon_sym_PIPE] = ACTIONS(2882),
    [anon_sym_PLUS] = ACTIONS(2882),
    [anon_sym_DASH] = ACTIONS(2882),
    [anon_sym_PERCENT] = ACTIONS(2884),
    [anon_sym_STAR_STAR] = ACTIONS(2884),
    [anon_sym_LT_EQ] = ACTIONS(2884),
    [anon_sym_EQ_EQ] = ACTIONS(2882),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2884),
    [anon_sym_BANG_EQ] = ACTIONS(2882),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2884),
    [anon_sym_GT_EQ] = ACTIONS(2884),
    [anon_sym_QMARK_QMARK] = ACTIONS(2884),
    [anon_sym_instanceof] = ACTIONS(2882),
    [anon_sym_void] = ACTIONS(2882),
    [anon_sym_PLUS_PLUS] = ACTIONS(2884),
    [anon_sym_DASH_DASH] = ACTIONS(2884),
    [anon_sym_DQUOTE] = ACTIONS(2884),
    [anon_sym_SQUOTE] = ACTIONS(2884),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2884),
    [sym_number] = ACTIONS(2884),
    [sym_this] = ACTIONS(2882),
    [sym_true] = ACTIONS(2882),
    [sym_false] = ACTIONS(2882),
    [sym_null] = ACTIONS(2882),
    [sym_undefined] = ACTIONS(2882),
    [anon_sym_static] = ACTIONS(2882),
    [anon_sym_readonly] = ACTIONS(2882),
    [anon_sym_get] = ACTIONS(2882),
    [anon_sym_set] = ACTIONS(2882),
    [anon_sym_QMARK] = ACTIONS(2882),
    [anon_sym_any] = ACTIONS(2882),
    [anon_sym_number] = ACTIONS(2882),
    [anon_sym_boolean] = ACTIONS(2882),
    [anon_sym_string] = ACTIONS(2882),
    [anon_sym_symbol] = ACTIONS(2882),
    [anon_sym_abstract] = ACTIONS(2882),
    [anon_sym_satisfies] = ACTIONS(2882),
    [anon_sym_infer] = ACTIONS(2882),
    [anon_sym_keyof] = ACTIONS(2882),
    [anon_sym_unknown] = ACTIONS(2882),
    [anon_sym_never] = ACTIONS(2882),
    [anon_sym_object] = ACTIONS(2882),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2884),
    [anon_sym_constructor] = ACTIONS(2882),
    [anon_sym_prop] = ACTIONS(2882),
    [anon_sym_id] = ACTIONS(2882),
    [anon_sym_event] = ACTIONS(2882),
    [anon_sym_fn] = ACTIONS(2882),
    [anon_sym_on] = ACTIONS(2882),
    [sym__ternary_qmark] = ACTIONS(2884),
  },
  [1051] = {
    [sym_identifier] = ACTIONS(3517),
    [anon_sym_STAR] = ACTIONS(3517),
    [anon_sym_as] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3517),
    [anon_sym_RBRACE] = ACTIONS(3519),
    [anon_sym_typeof] = ACTIONS(3517),
    [anon_sym_BANG] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [anon_sym_in] = ACTIONS(3517),
    [anon_sym_SEMI] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_LT] = ACTIONS(3517),
    [anon_sym_GT] = ACTIONS(3517),
    [anon_sym_SLASH] = ACTIONS(3517),
    [anon_sym_DOT] = ACTIONS(3517),
    [anon_sym_async] = ACTIONS(3517),
    [anon_sym_QMARK_DOT] = ACTIONS(3519),
    [anon_sym_new] = ACTIONS(3517),
    [anon_sym_AMP_AMP] = ACTIONS(3519),
    [anon_sym_PIPE_PIPE] = ACTIONS(3519),
    [anon_sym_GT_GT] = ACTIONS(3517),
    [anon_sym_GT_GT_GT] = ACTIONS(3519),
    [anon_sym_LT_LT] = ACTIONS(3519),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_CARET] = ACTIONS(3519),
    [anon_sym_PIPE] = ACTIONS(3517),
    [anon_sym_PLUS] = ACTIONS(3517),
    [anon_sym_DASH] = ACTIONS(3517),
    [anon_sym_PERCENT] = ACTIONS(3519),
    [anon_sym_STAR_STAR] = ACTIONS(3519),
    [anon_sym_LT_EQ] = ACTIONS(3519),
    [anon_sym_EQ_EQ] = ACTIONS(3517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3519),
    [anon_sym_BANG_EQ] = ACTIONS(3517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3519),
    [anon_sym_GT_EQ] = ACTIONS(3519),
    [anon_sym_QMARK_QMARK] = ACTIONS(3519),
    [anon_sym_instanceof] = ACTIONS(3517),
    [anon_sym_void] = ACTIONS(3517),
    [anon_sym_PLUS_PLUS] = ACTIONS(3519),
    [anon_sym_DASH_DASH] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3519),
    [sym_number] = ACTIONS(3519),
    [sym_this] = ACTIONS(3517),
    [sym_true] = ACTIONS(3517),
    [sym_false] = ACTIONS(3517),
    [sym_null] = ACTIONS(3517),
    [sym_undefined] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3517),
    [anon_sym_readonly] = ACTIONS(3517),
    [anon_sym_get] = ACTIONS(3517),
    [anon_sym_set] = ACTIONS(3517),
    [anon_sym_QMARK] = ACTIONS(3517),
    [anon_sym_any] = ACTIONS(3517),
    [anon_sym_number] = ACTIONS(3517),
    [anon_sym_boolean] = ACTIONS(3517),
    [anon_sym_string] = ACTIONS(3517),
    [anon_sym_symbol] = ACTIONS(3517),
    [anon_sym_abstract] = ACTIONS(3517),
    [anon_sym_satisfies] = ACTIONS(3517),
    [anon_sym_infer] = ACTIONS(3517),
    [anon_sym_keyof] = ACTIONS(3517),
    [anon_sym_unknown] = ACTIONS(3517),
    [anon_sym_never] = ACTIONS(3517),
    [anon_sym_object] = ACTIONS(3517),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3519),
    [anon_sym_constructor] = ACTIONS(3517),
    [anon_sym_prop] = ACTIONS(3517),
    [anon_sym_id] = ACTIONS(3517),
    [anon_sym_event] = ACTIONS(3517),
    [anon_sym_fn] = ACTIONS(3517),
    [anon_sym_on] = ACTIONS(3517),
    [sym__ternary_qmark] = ACTIONS(3519),
  },
  [1052] = {
    [sym_identifier] = ACTIONS(3521),
    [anon_sym_STAR] = ACTIONS(3521),
    [anon_sym_as] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3521),
    [anon_sym_RBRACE] = ACTIONS(3523),
    [anon_sym_typeof] = ACTIONS(3521),
    [anon_sym_BANG] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_in] = ACTIONS(3521),
    [anon_sym_SEMI] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LT] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3521),
    [anon_sym_SLASH] = ACTIONS(3521),
    [anon_sym_DOT] = ACTIONS(3521),
    [anon_sym_async] = ACTIONS(3521),
    [anon_sym_QMARK_DOT] = ACTIONS(3523),
    [anon_sym_new] = ACTIONS(3521),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_GT_GT] = ACTIONS(3521),
    [anon_sym_GT_GT_GT] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3521),
    [anon_sym_CARET] = ACTIONS(3523),
    [anon_sym_PIPE] = ACTIONS(3521),
    [anon_sym_PLUS] = ACTIONS(3521),
    [anon_sym_DASH] = ACTIONS(3521),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_STAR_STAR] = ACTIONS(3523),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_EQ_EQ] = ACTIONS(3521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3523),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_QMARK_QMARK] = ACTIONS(3523),
    [anon_sym_instanceof] = ACTIONS(3521),
    [anon_sym_void] = ACTIONS(3521),
    [anon_sym_PLUS_PLUS] = ACTIONS(3523),
    [anon_sym_DASH_DASH] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_SQUOTE] = ACTIONS(3523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3523),
    [sym_number] = ACTIONS(3523),
    [sym_this] = ACTIONS(3521),
    [sym_true] = ACTIONS(3521),
    [sym_false] = ACTIONS(3521),
    [sym_null] = ACTIONS(3521),
    [sym_undefined] = ACTIONS(3521),
    [anon_sym_static] = ACTIONS(3521),
    [anon_sym_readonly] = ACTIONS(3521),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_QMARK] = ACTIONS(3521),
    [anon_sym_any] = ACTIONS(3521),
    [anon_sym_number] = ACTIONS(3521),
    [anon_sym_boolean] = ACTIONS(3521),
    [anon_sym_string] = ACTIONS(3521),
    [anon_sym_symbol] = ACTIONS(3521),
    [anon_sym_abstract] = ACTIONS(3521),
    [anon_sym_satisfies] = ACTIONS(3521),
    [anon_sym_infer] = ACTIONS(3521),
    [anon_sym_keyof] = ACTIONS(3521),
    [anon_sym_unknown] = ACTIONS(3521),
    [anon_sym_never] = ACTIONS(3521),
    [anon_sym_object] = ACTIONS(3521),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3523),
    [anon_sym_constructor] = ACTIONS(3521),
    [anon_sym_prop] = ACTIONS(3521),
    [anon_sym_id] = ACTIONS(3521),
    [anon_sym_event] = ACTIONS(3521),
    [anon_sym_fn] = ACTIONS(3521),
    [anon_sym_on] = ACTIONS(3521),
    [sym__ternary_qmark] = ACTIONS(3523),
  },
  [1053] = {
    [sym_identifier] = ACTIONS(3525),
    [anon_sym_STAR] = ACTIONS(3525),
    [anon_sym_as] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3525),
    [anon_sym_RBRACE] = ACTIONS(3527),
    [anon_sym_typeof] = ACTIONS(3525),
    [anon_sym_BANG] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_in] = ACTIONS(3525),
    [anon_sym_SEMI] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_GT] = ACTIONS(3525),
    [anon_sym_SLASH] = ACTIONS(3525),
    [anon_sym_DOT] = ACTIONS(3525),
    [anon_sym_async] = ACTIONS(3525),
    [anon_sym_QMARK_DOT] = ACTIONS(3527),
    [anon_sym_new] = ACTIONS(3525),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_GT_GT_GT] = ACTIONS(3527),
    [anon_sym_LT_LT] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(3525),
    [anon_sym_CARET] = ACTIONS(3527),
    [anon_sym_PIPE] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3525),
    [anon_sym_DASH] = ACTIONS(3525),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_STAR_STAR] = ACTIONS(3527),
    [anon_sym_LT_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ] = ACTIONS(3525),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3525),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3527),
    [anon_sym_GT_EQ] = ACTIONS(3527),
    [anon_sym_QMARK_QMARK] = ACTIONS(3527),
    [anon_sym_instanceof] = ACTIONS(3525),
    [anon_sym_void] = ACTIONS(3525),
    [anon_sym_PLUS_PLUS] = ACTIONS(3527),
    [anon_sym_DASH_DASH] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_SQUOTE] = ACTIONS(3527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3527),
    [sym_number] = ACTIONS(3527),
    [sym_this] = ACTIONS(3525),
    [sym_true] = ACTIONS(3525),
    [sym_false] = ACTIONS(3525),
    [sym_null] = ACTIONS(3525),
    [sym_undefined] = ACTIONS(3525),
    [anon_sym_static] = ACTIONS(3525),
    [anon_sym_readonly] = ACTIONS(3525),
    [anon_sym_get] = ACTIONS(3525),
    [anon_sym_set] = ACTIONS(3525),
    [anon_sym_QMARK] = ACTIONS(3525),
    [anon_sym_any] = ACTIONS(3525),
    [anon_sym_number] = ACTIONS(3525),
    [anon_sym_boolean] = ACTIONS(3525),
    [anon_sym_string] = ACTIONS(3525),
    [anon_sym_symbol] = ACTIONS(3525),
    [anon_sym_abstract] = ACTIONS(3525),
    [anon_sym_satisfies] = ACTIONS(3525),
    [anon_sym_infer] = ACTIONS(3525),
    [anon_sym_keyof] = ACTIONS(3525),
    [anon_sym_unknown] = ACTIONS(3525),
    [anon_sym_never] = ACTIONS(3525),
    [anon_sym_object] = ACTIONS(3525),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3527),
    [anon_sym_constructor] = ACTIONS(3525),
    [anon_sym_prop] = ACTIONS(3525),
    [anon_sym_id] = ACTIONS(3525),
    [anon_sym_event] = ACTIONS(3525),
    [anon_sym_fn] = ACTIONS(3525),
    [anon_sym_on] = ACTIONS(3525),
    [sym__ternary_qmark] = ACTIONS(3527),
  },
  [1054] = {
    [sym_identifier] = ACTIONS(2784),
    [anon_sym_STAR] = ACTIONS(2784),
    [anon_sym_as] = ACTIONS(2784),
    [anon_sym_LBRACE] = ACTIONS(2784),
    [anon_sym_RBRACE] = ACTIONS(2786),
    [anon_sym_typeof] = ACTIONS(2784),
    [anon_sym_BANG] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2786),
    [anon_sym_in] = ACTIONS(2784),
    [anon_sym_SEMI] = ACTIONS(2786),
    [anon_sym_LBRACK] = ACTIONS(2786),
    [anon_sym_LT] = ACTIONS(2784),
    [anon_sym_GT] = ACTIONS(2784),
    [anon_sym_SLASH] = ACTIONS(2784),
    [anon_sym_DOT] = ACTIONS(2784),
    [anon_sym_async] = ACTIONS(2784),
    [anon_sym_QMARK_DOT] = ACTIONS(2786),
    [anon_sym_new] = ACTIONS(2784),
    [anon_sym_AMP_AMP] = ACTIONS(2786),
    [anon_sym_PIPE_PIPE] = ACTIONS(2786),
    [anon_sym_GT_GT] = ACTIONS(2784),
    [anon_sym_GT_GT_GT] = ACTIONS(2786),
    [anon_sym_LT_LT] = ACTIONS(2786),
    [anon_sym_AMP] = ACTIONS(2784),
    [anon_sym_CARET] = ACTIONS(2786),
    [anon_sym_PIPE] = ACTIONS(2784),
    [anon_sym_PLUS] = ACTIONS(2784),
    [anon_sym_DASH] = ACTIONS(2784),
    [anon_sym_PERCENT] = ACTIONS(2786),
    [anon_sym_STAR_STAR] = ACTIONS(2786),
    [anon_sym_LT_EQ] = ACTIONS(2786),
    [anon_sym_EQ_EQ] = ACTIONS(2784),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2786),
    [anon_sym_BANG_EQ] = ACTIONS(2784),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2786),
    [anon_sym_GT_EQ] = ACTIONS(2786),
    [anon_sym_QMARK_QMARK] = ACTIONS(2786),
    [anon_sym_instanceof] = ACTIONS(2784),
    [anon_sym_void] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2786),
    [anon_sym_DQUOTE] = ACTIONS(2786),
    [anon_sym_SQUOTE] = ACTIONS(2786),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2786),
    [sym_number] = ACTIONS(2786),
    [sym_this] = ACTIONS(2784),
    [sym_true] = ACTIONS(2784),
    [sym_false] = ACTIONS(2784),
    [sym_null] = ACTIONS(2784),
    [sym_undefined] = ACTIONS(2784),
    [anon_sym_static] = ACTIONS(2784),
    [anon_sym_readonly] = ACTIONS(2784),
    [anon_sym_get] = ACTIONS(2784),
    [anon_sym_set] = ACTIONS(2784),
    [anon_sym_QMARK] = ACTIONS(2784),
    [anon_sym_any] = ACTIONS(2784),
    [anon_sym_number] = ACTIONS(2784),
    [anon_sym_boolean] = ACTIONS(2784),
    [anon_sym_string] = ACTIONS(2784),
    [anon_sym_symbol] = ACTIONS(2784),
    [anon_sym_abstract] = ACTIONS(2784),
    [anon_sym_satisfies] = ACTIONS(2784),
    [anon_sym_infer] = ACTIONS(2784),
    [anon_sym_keyof] = ACTIONS(2784),
    [anon_sym_unknown] = ACTIONS(2784),
    [anon_sym_never] = ACTIONS(2784),
    [anon_sym_object] = ACTIONS(2784),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2786),
    [anon_sym_constructor] = ACTIONS(2784),
    [anon_sym_prop] = ACTIONS(2784),
    [anon_sym_id] = ACTIONS(2784),
    [anon_sym_event] = ACTIONS(2784),
    [anon_sym_fn] = ACTIONS(2784),
    [anon_sym_on] = ACTIONS(2784),
    [sym__ternary_qmark] = ACTIONS(2786),
  },
  [1055] = {
    [sym_identifier] = ACTIONS(3529),
    [anon_sym_STAR] = ACTIONS(3529),
    [anon_sym_as] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3529),
    [anon_sym_RBRACE] = ACTIONS(3531),
    [anon_sym_typeof] = ACTIONS(3529),
    [anon_sym_BANG] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3529),
    [anon_sym_SEMI] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_GT] = ACTIONS(3529),
    [anon_sym_SLASH] = ACTIONS(3529),
    [anon_sym_DOT] = ACTIONS(3529),
    [anon_sym_async] = ACTIONS(3529),
    [anon_sym_QMARK_DOT] = ACTIONS(3531),
    [anon_sym_new] = ACTIONS(3529),
    [anon_sym_AMP_AMP] = ACTIONS(3531),
    [anon_sym_PIPE_PIPE] = ACTIONS(3531),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3529),
    [anon_sym_CARET] = ACTIONS(3531),
    [anon_sym_PIPE] = ACTIONS(3529),
    [anon_sym_PLUS] = ACTIONS(3529),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_STAR_STAR] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3531),
    [anon_sym_EQ_EQ] = ACTIONS(3529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_BANG_EQ] = ACTIONS(3529),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3531),
    [anon_sym_GT_EQ] = ACTIONS(3531),
    [anon_sym_QMARK_QMARK] = ACTIONS(3531),
    [anon_sym_instanceof] = ACTIONS(3529),
    [anon_sym_void] = ACTIONS(3529),
    [anon_sym_PLUS_PLUS] = ACTIONS(3531),
    [anon_sym_DASH_DASH] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_SQUOTE] = ACTIONS(3531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3531),
    [sym_number] = ACTIONS(3531),
    [sym_this] = ACTIONS(3529),
    [sym_true] = ACTIONS(3529),
    [sym_false] = ACTIONS(3529),
    [sym_null] = ACTIONS(3529),
    [sym_undefined] = ACTIONS(3529),
    [anon_sym_static] = ACTIONS(3529),
    [anon_sym_readonly] = ACTIONS(3529),
    [anon_sym_get] = ACTIONS(3529),
    [anon_sym_set] = ACTIONS(3529),
    [anon_sym_QMARK] = ACTIONS(3529),
    [anon_sym_any] = ACTIONS(3529),
    [anon_sym_number] = ACTIONS(3529),
    [anon_sym_boolean] = ACTIONS(3529),
    [anon_sym_string] = ACTIONS(3529),
    [anon_sym_symbol] = ACTIONS(3529),
    [anon_sym_abstract] = ACTIONS(3529),
    [anon_sym_satisfies] = ACTIONS(3529),
    [anon_sym_infer] = ACTIONS(3529),
    [anon_sym_keyof] = ACTIONS(3529),
    [anon_sym_unknown] = ACTIONS(3529),
    [anon_sym_never] = ACTIONS(3529),
    [anon_sym_object] = ACTIONS(3529),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3531),
    [anon_sym_constructor] = ACTIONS(3529),
    [anon_sym_prop] = ACTIONS(3529),
    [anon_sym_id] = ACTIONS(3529),
    [anon_sym_event] = ACTIONS(3529),
    [anon_sym_fn] = ACTIONS(3529),
    [anon_sym_on] = ACTIONS(3529),
    [sym__ternary_qmark] = ACTIONS(3531),
  },
  [1056] = {
    [sym_identifier] = ACTIONS(3533),
    [anon_sym_STAR] = ACTIONS(3533),
    [anon_sym_as] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3533),
    [anon_sym_RBRACE] = ACTIONS(3535),
    [anon_sym_typeof] = ACTIONS(3533),
    [anon_sym_BANG] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_in] = ACTIONS(3533),
    [anon_sym_SEMI] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3535),
    [anon_sym_LT] = ACTIONS(3533),
    [anon_sym_GT] = ACTIONS(3533),
    [anon_sym_SLASH] = ACTIONS(3533),
    [anon_sym_DOT] = ACTIONS(3533),
    [anon_sym_async] = ACTIONS(3533),
    [anon_sym_QMARK_DOT] = ACTIONS(3535),
    [anon_sym_new] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3535),
    [anon_sym_PIPE_PIPE] = ACTIONS(3535),
    [anon_sym_GT_GT] = ACTIONS(3533),
    [anon_sym_GT_GT_GT] = ACTIONS(3535),
    [anon_sym_LT_LT] = ACTIONS(3535),
    [anon_sym_AMP] = ACTIONS(3533),
    [anon_sym_CARET] = ACTIONS(3535),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_PERCENT] = ACTIONS(3535),
    [anon_sym_STAR_STAR] = ACTIONS(3535),
    [anon_sym_LT_EQ] = ACTIONS(3535),
    [anon_sym_EQ_EQ] = ACTIONS(3533),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3535),
    [anon_sym_BANG_EQ] = ACTIONS(3533),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3535),
    [anon_sym_GT_EQ] = ACTIONS(3535),
    [anon_sym_QMARK_QMARK] = ACTIONS(3535),
    [anon_sym_instanceof] = ACTIONS(3533),
    [anon_sym_void] = ACTIONS(3533),
    [anon_sym_PLUS_PLUS] = ACTIONS(3535),
    [anon_sym_DASH_DASH] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3535),
    [anon_sym_SQUOTE] = ACTIONS(3535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3535),
    [sym_number] = ACTIONS(3535),
    [sym_this] = ACTIONS(3533),
    [sym_true] = ACTIONS(3533),
    [sym_false] = ACTIONS(3533),
    [sym_null] = ACTIONS(3533),
    [sym_undefined] = ACTIONS(3533),
    [anon_sym_static] = ACTIONS(3533),
    [anon_sym_readonly] = ACTIONS(3533),
    [anon_sym_get] = ACTIONS(3533),
    [anon_sym_set] = ACTIONS(3533),
    [anon_sym_QMARK] = ACTIONS(3533),
    [anon_sym_any] = ACTIONS(3533),
    [anon_sym_number] = ACTIONS(3533),
    [anon_sym_boolean] = ACTIONS(3533),
    [anon_sym_string] = ACTIONS(3533),
    [anon_sym_symbol] = ACTIONS(3533),
    [anon_sym_abstract] = ACTIONS(3533),
    [anon_sym_satisfies] = ACTIONS(3533),
    [anon_sym_infer] = ACTIONS(3533),
    [anon_sym_keyof] = ACTIONS(3533),
    [anon_sym_unknown] = ACTIONS(3533),
    [anon_sym_never] = ACTIONS(3533),
    [anon_sym_object] = ACTIONS(3533),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3535),
    [anon_sym_constructor] = ACTIONS(3533),
    [anon_sym_prop] = ACTIONS(3533),
    [anon_sym_id] = ACTIONS(3533),
    [anon_sym_event] = ACTIONS(3533),
    [anon_sym_fn] = ACTIONS(3533),
    [anon_sym_on] = ACTIONS(3533),
    [sym__ternary_qmark] = ACTIONS(3535),
  },
  [1057] = {
    [sym_identifier] = ACTIONS(3537),
    [anon_sym_STAR] = ACTIONS(3537),
    [anon_sym_as] = ACTIONS(3537),
    [anon_sym_LBRACE] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3539),
    [anon_sym_typeof] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_in] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_GT] = ACTIONS(3537),
    [anon_sym_SLASH] = ACTIONS(3537),
    [anon_sym_DOT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(3537),
    [anon_sym_QMARK_DOT] = ACTIONS(3539),
    [anon_sym_new] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3539),
    [anon_sym_GT_GT] = ACTIONS(3537),
    [anon_sym_GT_GT_GT] = ACTIONS(3539),
    [anon_sym_LT_LT] = ACTIONS(3539),
    [anon_sym_AMP] = ACTIONS(3537),
    [anon_sym_CARET] = ACTIONS(3539),
    [anon_sym_PIPE] = ACTIONS(3537),
    [anon_sym_PLUS] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(3537),
    [anon_sym_PERCENT] = ACTIONS(3539),
    [anon_sym_STAR_STAR] = ACTIONS(3539),
    [anon_sym_LT_EQ] = ACTIONS(3539),
    [anon_sym_EQ_EQ] = ACTIONS(3537),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3539),
    [anon_sym_BANG_EQ] = ACTIONS(3537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3539),
    [anon_sym_GT_EQ] = ACTIONS(3539),
    [anon_sym_QMARK_QMARK] = ACTIONS(3539),
    [anon_sym_instanceof] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3537),
    [anon_sym_PLUS_PLUS] = ACTIONS(3539),
    [anon_sym_DASH_DASH] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [anon_sym_SQUOTE] = ACTIONS(3539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3539),
    [sym_number] = ACTIONS(3539),
    [sym_this] = ACTIONS(3537),
    [sym_true] = ACTIONS(3537),
    [sym_false] = ACTIONS(3537),
    [sym_null] = ACTIONS(3537),
    [sym_undefined] = ACTIONS(3537),
    [anon_sym_static] = ACTIONS(3537),
    [anon_sym_readonly] = ACTIONS(3537),
    [anon_sym_get] = ACTIONS(3537),
    [anon_sym_set] = ACTIONS(3537),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_any] = ACTIONS(3537),
    [anon_sym_number] = ACTIONS(3537),
    [anon_sym_boolean] = ACTIONS(3537),
    [anon_sym_string] = ACTIONS(3537),
    [anon_sym_symbol] = ACTIONS(3537),
    [anon_sym_abstract] = ACTIONS(3537),
    [anon_sym_satisfies] = ACTIONS(3537),
    [anon_sym_infer] = ACTIONS(3537),
    [anon_sym_keyof] = ACTIONS(3537),
    [anon_sym_unknown] = ACTIONS(3537),
    [anon_sym_never] = ACTIONS(3537),
    [anon_sym_object] = ACTIONS(3537),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3539),
    [anon_sym_constructor] = ACTIONS(3537),
    [anon_sym_prop] = ACTIONS(3537),
    [anon_sym_id] = ACTIONS(3537),
    [anon_sym_event] = ACTIONS(3537),
    [anon_sym_fn] = ACTIONS(3537),
    [anon_sym_on] = ACTIONS(3537),
    [sym__ternary_qmark] = ACTIONS(3539),
  },
  [1058] = {
    [sym_identifier] = ACTIONS(3286),
    [anon_sym_STAR] = ACTIONS(3286),
    [anon_sym_as] = ACTIONS(3286),
    [anon_sym_LBRACE] = ACTIONS(3286),
    [anon_sym_RBRACE] = ACTIONS(3288),
    [anon_sym_typeof] = ACTIONS(3286),
    [anon_sym_BANG] = ACTIONS(3286),
    [anon_sym_LPAREN] = ACTIONS(3288),
    [anon_sym_in] = ACTIONS(3286),
    [anon_sym_SEMI] = ACTIONS(3288),
    [anon_sym_LBRACK] = ACTIONS(3288),
    [anon_sym_LT] = ACTIONS(3286),
    [anon_sym_GT] = ACTIONS(3286),
    [anon_sym_SLASH] = ACTIONS(3286),
    [anon_sym_DOT] = ACTIONS(3286),
    [anon_sym_async] = ACTIONS(3286),
    [anon_sym_QMARK_DOT] = ACTIONS(3288),
    [anon_sym_new] = ACTIONS(3286),
    [anon_sym_AMP_AMP] = ACTIONS(3288),
    [anon_sym_PIPE_PIPE] = ACTIONS(3288),
    [anon_sym_GT_GT] = ACTIONS(3286),
    [anon_sym_GT_GT_GT] = ACTIONS(3288),
    [anon_sym_LT_LT] = ACTIONS(3288),
    [anon_sym_AMP] = ACTIONS(3286),
    [anon_sym_CARET] = ACTIONS(3288),
    [anon_sym_PIPE] = ACTIONS(3286),
    [anon_sym_PLUS] = ACTIONS(3286),
    [anon_sym_DASH] = ACTIONS(3286),
    [anon_sym_PERCENT] = ACTIONS(3288),
    [anon_sym_STAR_STAR] = ACTIONS(3288),
    [anon_sym_LT_EQ] = ACTIONS(3288),
    [anon_sym_EQ_EQ] = ACTIONS(3286),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3288),
    [anon_sym_BANG_EQ] = ACTIONS(3286),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3288),
    [anon_sym_GT_EQ] = ACTIONS(3288),
    [anon_sym_QMARK_QMARK] = ACTIONS(3288),
    [anon_sym_instanceof] = ACTIONS(3286),
    [anon_sym_void] = ACTIONS(3286),
    [anon_sym_PLUS_PLUS] = ACTIONS(3288),
    [anon_sym_DASH_DASH] = ACTIONS(3288),
    [anon_sym_DQUOTE] = ACTIONS(3288),
    [anon_sym_SQUOTE] = ACTIONS(3288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3288),
    [sym_number] = ACTIONS(3288),
    [sym_this] = ACTIONS(3286),
    [sym_true] = ACTIONS(3286),
    [sym_false] = ACTIONS(3286),
    [sym_null] = ACTIONS(3286),
    [sym_undefined] = ACTIONS(3286),
    [anon_sym_static] = ACTIONS(3286),
    [anon_sym_readonly] = ACTIONS(3286),
    [anon_sym_get] = ACTIONS(3286),
    [anon_sym_set] = ACTIONS(3286),
    [anon_sym_QMARK] = ACTIONS(3286),
    [anon_sym_any] = ACTIONS(3286),
    [anon_sym_number] = ACTIONS(3286),
    [anon_sym_boolean] = ACTIONS(3286),
    [anon_sym_string] = ACTIONS(3286),
    [anon_sym_symbol] = ACTIONS(3286),
    [anon_sym_abstract] = ACTIONS(3286),
    [anon_sym_satisfies] = ACTIONS(3286),
    [anon_sym_infer] = ACTIONS(3286),
    [anon_sym_keyof] = ACTIONS(3286),
    [anon_sym_unknown] = ACTIONS(3286),
    [anon_sym_never] = ACTIONS(3286),
    [anon_sym_object] = ACTIONS(3286),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3288),
    [anon_sym_constructor] = ACTIONS(3286),
    [anon_sym_prop] = ACTIONS(3286),
    [anon_sym_id] = ACTIONS(3286),
    [anon_sym_event] = ACTIONS(3286),
    [anon_sym_fn] = ACTIONS(3286),
    [anon_sym_on] = ACTIONS(3286),
    [sym__ternary_qmark] = ACTIONS(3288),
  },
  [1059] = {
    [sym_identifier] = ACTIONS(1702),
    [anon_sym_STAR] = ACTIONS(1702),
    [anon_sym_as] = ACTIONS(1702),
    [anon_sym_LBRACE] = ACTIONS(1702),
    [anon_sym_RBRACE] = ACTIONS(1704),
    [anon_sym_typeof] = ACTIONS(1702),
    [anon_sym_BANG] = ACTIONS(1702),
    [anon_sym_LPAREN] = ACTIONS(1704),
    [anon_sym_in] = ACTIONS(1702),
    [anon_sym_SEMI] = ACTIONS(1704),
    [anon_sym_LBRACK] = ACTIONS(1704),
    [anon_sym_LT] = ACTIONS(1702),
    [anon_sym_GT] = ACTIONS(1702),
    [anon_sym_SLASH] = ACTIONS(1702),
    [anon_sym_DOT] = ACTIONS(1702),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_QMARK_DOT] = ACTIONS(1704),
    [anon_sym_new] = ACTIONS(1702),
    [anon_sym_AMP_AMP] = ACTIONS(1704),
    [anon_sym_PIPE_PIPE] = ACTIONS(1704),
    [anon_sym_GT_GT] = ACTIONS(1702),
    [anon_sym_GT_GT_GT] = ACTIONS(1704),
    [anon_sym_LT_LT] = ACTIONS(1704),
    [anon_sym_AMP] = ACTIONS(1702),
    [anon_sym_CARET] = ACTIONS(1704),
    [anon_sym_PIPE] = ACTIONS(1702),
    [anon_sym_PLUS] = ACTIONS(1702),
    [anon_sym_DASH] = ACTIONS(1702),
    [anon_sym_PERCENT] = ACTIONS(1704),
    [anon_sym_STAR_STAR] = ACTIONS(1704),
    [anon_sym_LT_EQ] = ACTIONS(1704),
    [anon_sym_EQ_EQ] = ACTIONS(1702),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1704),
    [anon_sym_BANG_EQ] = ACTIONS(1702),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1704),
    [anon_sym_GT_EQ] = ACTIONS(1704),
    [anon_sym_QMARK_QMARK] = ACTIONS(1704),
    [anon_sym_instanceof] = ACTIONS(1702),
    [anon_sym_void] = ACTIONS(1702),
    [anon_sym_PLUS_PLUS] = ACTIONS(1704),
    [anon_sym_DASH_DASH] = ACTIONS(1704),
    [anon_sym_DQUOTE] = ACTIONS(1704),
    [anon_sym_SQUOTE] = ACTIONS(1704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1704),
    [sym_number] = ACTIONS(1704),
    [sym_this] = ACTIONS(1702),
    [sym_true] = ACTIONS(1702),
    [sym_false] = ACTIONS(1702),
    [sym_null] = ACTIONS(1702),
    [sym_undefined] = ACTIONS(1702),
    [anon_sym_static] = ACTIONS(1702),
    [anon_sym_readonly] = ACTIONS(1702),
    [anon_sym_get] = ACTIONS(1702),
    [anon_sym_set] = ACTIONS(1702),
    [anon_sym_QMARK] = ACTIONS(1702),
    [anon_sym_any] = ACTIONS(1702),
    [anon_sym_number] = ACTIONS(1702),
    [anon_sym_boolean] = ACTIONS(1702),
    [anon_sym_string] = ACTIONS(1702),
    [anon_sym_symbol] = ACTIONS(1702),
    [anon_sym_abstract] = ACTIONS(1702),
    [anon_sym_satisfies] = ACTIONS(1702),
    [anon_sym_infer] = ACTIONS(1702),
    [anon_sym_keyof] = ACTIONS(1702),
    [anon_sym_unknown] = ACTIONS(1702),
    [anon_sym_never] = ACTIONS(1702),
    [anon_sym_object] = ACTIONS(1702),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1704),
    [anon_sym_constructor] = ACTIONS(1702),
    [anon_sym_prop] = ACTIONS(1702),
    [anon_sym_id] = ACTIONS(1702),
    [anon_sym_event] = ACTIONS(1702),
    [anon_sym_fn] = ACTIONS(1702),
    [anon_sym_on] = ACTIONS(1702),
    [sym__ternary_qmark] = ACTIONS(1704),
  },
  [1060] = {
    [sym_identifier] = ACTIONS(3541),
    [anon_sym_STAR] = ACTIONS(3541),
    [anon_sym_as] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(3543),
    [anon_sym_typeof] = ACTIONS(3541),
    [anon_sym_BANG] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3543),
    [anon_sym_in] = ACTIONS(3541),
    [anon_sym_SEMI] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3543),
    [anon_sym_LT] = ACTIONS(3541),
    [anon_sym_GT] = ACTIONS(3541),
    [anon_sym_SLASH] = ACTIONS(3541),
    [anon_sym_DOT] = ACTIONS(3541),
    [anon_sym_async] = ACTIONS(3541),
    [anon_sym_QMARK_DOT] = ACTIONS(3543),
    [anon_sym_new] = ACTIONS(3541),
    [anon_sym_AMP_AMP] = ACTIONS(3543),
    [anon_sym_PIPE_PIPE] = ACTIONS(3543),
    [anon_sym_GT_GT] = ACTIONS(3541),
    [anon_sym_GT_GT_GT] = ACTIONS(3543),
    [anon_sym_LT_LT] = ACTIONS(3543),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_CARET] = ACTIONS(3543),
    [anon_sym_PIPE] = ACTIONS(3541),
    [anon_sym_PLUS] = ACTIONS(3541),
    [anon_sym_DASH] = ACTIONS(3541),
    [anon_sym_PERCENT] = ACTIONS(3543),
    [anon_sym_STAR_STAR] = ACTIONS(3543),
    [anon_sym_LT_EQ] = ACTIONS(3543),
    [anon_sym_EQ_EQ] = ACTIONS(3541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3543),
    [anon_sym_BANG_EQ] = ACTIONS(3541),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3543),
    [anon_sym_GT_EQ] = ACTIONS(3543),
    [anon_sym_QMARK_QMARK] = ACTIONS(3543),
    [anon_sym_instanceof] = ACTIONS(3541),
    [anon_sym_void] = ACTIONS(3541),
    [anon_sym_PLUS_PLUS] = ACTIONS(3543),
    [anon_sym_DASH_DASH] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3543),
    [anon_sym_SQUOTE] = ACTIONS(3543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3543),
    [sym_number] = ACTIONS(3543),
    [sym_this] = ACTIONS(3541),
    [sym_true] = ACTIONS(3541),
    [sym_false] = ACTIONS(3541),
    [sym_null] = ACTIONS(3541),
    [sym_undefined] = ACTIONS(3541),
    [anon_sym_static] = ACTIONS(3541),
    [anon_sym_readonly] = ACTIONS(3541),
    [anon_sym_get] = ACTIONS(3541),
    [anon_sym_set] = ACTIONS(3541),
    [anon_sym_QMARK] = ACTIONS(3541),
    [anon_sym_any] = ACTIONS(3541),
    [anon_sym_number] = ACTIONS(3541),
    [anon_sym_boolean] = ACTIONS(3541),
    [anon_sym_string] = ACTIONS(3541),
    [anon_sym_symbol] = ACTIONS(3541),
    [anon_sym_abstract] = ACTIONS(3541),
    [anon_sym_satisfies] = ACTIONS(3541),
    [anon_sym_infer] = ACTIONS(3541),
    [anon_sym_keyof] = ACTIONS(3541),
    [anon_sym_unknown] = ACTIONS(3541),
    [anon_sym_never] = ACTIONS(3541),
    [anon_sym_object] = ACTIONS(3541),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3543),
    [anon_sym_constructor] = ACTIONS(3541),
    [anon_sym_prop] = ACTIONS(3541),
    [anon_sym_id] = ACTIONS(3541),
    [anon_sym_event] = ACTIONS(3541),
    [anon_sym_fn] = ACTIONS(3541),
    [anon_sym_on] = ACTIONS(3541),
    [sym__ternary_qmark] = ACTIONS(3543),
  },
  [1061] = {
    [sym_identifier] = ACTIONS(2792),
    [anon_sym_STAR] = ACTIONS(2792),
    [anon_sym_as] = ACTIONS(2792),
    [anon_sym_LBRACE] = ACTIONS(2792),
    [anon_sym_RBRACE] = ACTIONS(2794),
    [anon_sym_typeof] = ACTIONS(2792),
    [anon_sym_BANG] = ACTIONS(2792),
    [anon_sym_LPAREN] = ACTIONS(2794),
    [anon_sym_in] = ACTIONS(2792),
    [anon_sym_SEMI] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2792),
    [anon_sym_GT] = ACTIONS(2792),
    [anon_sym_SLASH] = ACTIONS(2792),
    [anon_sym_DOT] = ACTIONS(2792),
    [anon_sym_async] = ACTIONS(2792),
    [anon_sym_QMARK_DOT] = ACTIONS(2794),
    [anon_sym_new] = ACTIONS(2792),
    [anon_sym_AMP_AMP] = ACTIONS(2794),
    [anon_sym_PIPE_PIPE] = ACTIONS(2794),
    [anon_sym_GT_GT] = ACTIONS(2792),
    [anon_sym_GT_GT_GT] = ACTIONS(2794),
    [anon_sym_LT_LT] = ACTIONS(2794),
    [anon_sym_AMP] = ACTIONS(2792),
    [anon_sym_CARET] = ACTIONS(2794),
    [anon_sym_PIPE] = ACTIONS(2792),
    [anon_sym_PLUS] = ACTIONS(2792),
    [anon_sym_DASH] = ACTIONS(2792),
    [anon_sym_PERCENT] = ACTIONS(2794),
    [anon_sym_STAR_STAR] = ACTIONS(2794),
    [anon_sym_LT_EQ] = ACTIONS(2794),
    [anon_sym_EQ_EQ] = ACTIONS(2792),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2794),
    [anon_sym_BANG_EQ] = ACTIONS(2792),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2794),
    [anon_sym_GT_EQ] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK] = ACTIONS(2794),
    [anon_sym_instanceof] = ACTIONS(2792),
    [anon_sym_void] = ACTIONS(2792),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_DQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2794),
    [sym_number] = ACTIONS(2794),
    [sym_this] = ACTIONS(2792),
    [sym_true] = ACTIONS(2792),
    [sym_false] = ACTIONS(2792),
    [sym_null] = ACTIONS(2792),
    [sym_undefined] = ACTIONS(2792),
    [anon_sym_static] = ACTIONS(2792),
    [anon_sym_readonly] = ACTIONS(2792),
    [anon_sym_get] = ACTIONS(2792),
    [anon_sym_set] = ACTIONS(2792),
    [anon_sym_QMARK] = ACTIONS(2792),
    [anon_sym_any] = ACTIONS(2792),
    [anon_sym_number] = ACTIONS(2792),
    [anon_sym_boolean] = ACTIONS(2792),
    [anon_sym_string] = ACTIONS(2792),
    [anon_sym_symbol] = ACTIONS(2792),
    [anon_sym_abstract] = ACTIONS(2792),
    [anon_sym_satisfies] = ACTIONS(2792),
    [anon_sym_infer] = ACTIONS(2792),
    [anon_sym_keyof] = ACTIONS(2792),
    [anon_sym_unknown] = ACTIONS(2792),
    [anon_sym_never] = ACTIONS(2792),
    [anon_sym_object] = ACTIONS(2792),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2794),
    [anon_sym_constructor] = ACTIONS(2792),
    [anon_sym_prop] = ACTIONS(2792),
    [anon_sym_id] = ACTIONS(2792),
    [anon_sym_event] = ACTIONS(2792),
    [anon_sym_fn] = ACTIONS(2792),
    [anon_sym_on] = ACTIONS(2792),
    [sym__ternary_qmark] = ACTIONS(2794),
  },
  [1062] = {
    [sym_identifier] = ACTIONS(3545),
    [anon_sym_STAR] = ACTIONS(3545),
    [anon_sym_as] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(3545),
    [anon_sym_RBRACE] = ACTIONS(3547),
    [anon_sym_typeof] = ACTIONS(3545),
    [anon_sym_BANG] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3547),
    [anon_sym_in] = ACTIONS(3545),
    [anon_sym_SEMI] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3547),
    [anon_sym_LT] = ACTIONS(3545),
    [anon_sym_GT] = ACTIONS(3545),
    [anon_sym_SLASH] = ACTIONS(3545),
    [anon_sym_DOT] = ACTIONS(3545),
    [anon_sym_async] = ACTIONS(3545),
    [anon_sym_QMARK_DOT] = ACTIONS(3547),
    [anon_sym_new] = ACTIONS(3545),
    [anon_sym_AMP_AMP] = ACTIONS(3547),
    [anon_sym_PIPE_PIPE] = ACTIONS(3547),
    [anon_sym_GT_GT] = ACTIONS(3545),
    [anon_sym_GT_GT_GT] = ACTIONS(3547),
    [anon_sym_LT_LT] = ACTIONS(3547),
    [anon_sym_AMP] = ACTIONS(3545),
    [anon_sym_CARET] = ACTIONS(3547),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3545),
    [anon_sym_DASH] = ACTIONS(3545),
    [anon_sym_PERCENT] = ACTIONS(3547),
    [anon_sym_STAR_STAR] = ACTIONS(3547),
    [anon_sym_LT_EQ] = ACTIONS(3547),
    [anon_sym_EQ_EQ] = ACTIONS(3545),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3547),
    [anon_sym_BANG_EQ] = ACTIONS(3545),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3547),
    [anon_sym_GT_EQ] = ACTIONS(3547),
    [anon_sym_QMARK_QMARK] = ACTIONS(3547),
    [anon_sym_instanceof] = ACTIONS(3545),
    [anon_sym_void] = ACTIONS(3545),
    [anon_sym_PLUS_PLUS] = ACTIONS(3547),
    [anon_sym_DASH_DASH] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3547),
    [anon_sym_SQUOTE] = ACTIONS(3547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3547),
    [sym_number] = ACTIONS(3547),
    [sym_this] = ACTIONS(3545),
    [sym_true] = ACTIONS(3545),
    [sym_false] = ACTIONS(3545),
    [sym_null] = ACTIONS(3545),
    [sym_undefined] = ACTIONS(3545),
    [anon_sym_static] = ACTIONS(3545),
    [anon_sym_readonly] = ACTIONS(3545),
    [anon_sym_get] = ACTIONS(3545),
    [anon_sym_set] = ACTIONS(3545),
    [anon_sym_QMARK] = ACTIONS(3545),
    [anon_sym_any] = ACTIONS(3545),
    [anon_sym_number] = ACTIONS(3545),
    [anon_sym_boolean] = ACTIONS(3545),
    [anon_sym_string] = ACTIONS(3545),
    [anon_sym_symbol] = ACTIONS(3545),
    [anon_sym_abstract] = ACTIONS(3545),
    [anon_sym_satisfies] = ACTIONS(3545),
    [anon_sym_infer] = ACTIONS(3545),
    [anon_sym_keyof] = ACTIONS(3545),
    [anon_sym_unknown] = ACTIONS(3545),
    [anon_sym_never] = ACTIONS(3545),
    [anon_sym_object] = ACTIONS(3545),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3547),
    [anon_sym_constructor] = ACTIONS(3545),
    [anon_sym_prop] = ACTIONS(3545),
    [anon_sym_id] = ACTIONS(3545),
    [anon_sym_event] = ACTIONS(3545),
    [anon_sym_fn] = ACTIONS(3545),
    [anon_sym_on] = ACTIONS(3545),
    [sym__ternary_qmark] = ACTIONS(3547),
  },
  [1063] = {
    [sym_identifier] = ACTIONS(3549),
    [anon_sym_STAR] = ACTIONS(3549),
    [anon_sym_as] = ACTIONS(3549),
    [anon_sym_LBRACE] = ACTIONS(3549),
    [anon_sym_RBRACE] = ACTIONS(3551),
    [anon_sym_typeof] = ACTIONS(3549),
    [anon_sym_BANG] = ACTIONS(3549),
    [anon_sym_LPAREN] = ACTIONS(3551),
    [anon_sym_in] = ACTIONS(3549),
    [anon_sym_SEMI] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3551),
    [anon_sym_LT] = ACTIONS(3549),
    [anon_sym_GT] = ACTIONS(3549),
    [anon_sym_SLASH] = ACTIONS(3549),
    [anon_sym_DOT] = ACTIONS(3549),
    [anon_sym_async] = ACTIONS(3549),
    [anon_sym_QMARK_DOT] = ACTIONS(3551),
    [anon_sym_new] = ACTIONS(3549),
    [anon_sym_AMP_AMP] = ACTIONS(3551),
    [anon_sym_PIPE_PIPE] = ACTIONS(3551),
    [anon_sym_GT_GT] = ACTIONS(3549),
    [anon_sym_GT_GT_GT] = ACTIONS(3551),
    [anon_sym_LT_LT] = ACTIONS(3551),
    [anon_sym_AMP] = ACTIONS(3549),
    [anon_sym_CARET] = ACTIONS(3551),
    [anon_sym_PIPE] = ACTIONS(3549),
    [anon_sym_PLUS] = ACTIONS(3549),
    [anon_sym_DASH] = ACTIONS(3549),
    [anon_sym_PERCENT] = ACTIONS(3551),
    [anon_sym_STAR_STAR] = ACTIONS(3551),
    [anon_sym_LT_EQ] = ACTIONS(3551),
    [anon_sym_EQ_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3551),
    [anon_sym_BANG_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3551),
    [anon_sym_GT_EQ] = ACTIONS(3551),
    [anon_sym_QMARK_QMARK] = ACTIONS(3551),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_void] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(3551),
    [anon_sym_DASH_DASH] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3551),
    [anon_sym_SQUOTE] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3551),
    [sym_number] = ACTIONS(3551),
    [sym_this] = ACTIONS(3549),
    [sym_true] = ACTIONS(3549),
    [sym_false] = ACTIONS(3549),
    [sym_null] = ACTIONS(3549),
    [sym_undefined] = ACTIONS(3549),
    [anon_sym_static] = ACTIONS(3549),
    [anon_sym_readonly] = ACTIONS(3549),
    [anon_sym_get] = ACTIONS(3549),
    [anon_sym_set] = ACTIONS(3549),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_any] = ACTIONS(3549),
    [anon_sym_number] = ACTIONS(3549),
    [anon_sym_boolean] = ACTIONS(3549),
    [anon_sym_string] = ACTIONS(3549),
    [anon_sym_symbol] = ACTIONS(3549),
    [anon_sym_abstract] = ACTIONS(3549),
    [anon_sym_satisfies] = ACTIONS(3549),
    [anon_sym_infer] = ACTIONS(3549),
    [anon_sym_keyof] = ACTIONS(3549),
    [anon_sym_unknown] = ACTIONS(3549),
    [anon_sym_never] = ACTIONS(3549),
    [anon_sym_object] = ACTIONS(3549),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3551),
    [anon_sym_constructor] = ACTIONS(3549),
    [anon_sym_prop] = ACTIONS(3549),
    [anon_sym_id] = ACTIONS(3549),
    [anon_sym_event] = ACTIONS(3549),
    [anon_sym_fn] = ACTIONS(3549),
    [anon_sym_on] = ACTIONS(3549),
    [sym__ternary_qmark] = ACTIONS(3551),
  },
  [1064] = {
    [sym_identifier] = ACTIONS(3553),
    [anon_sym_STAR] = ACTIONS(3553),
    [anon_sym_as] = ACTIONS(3553),
    [anon_sym_LBRACE] = ACTIONS(3553),
    [anon_sym_RBRACE] = ACTIONS(3555),
    [anon_sym_typeof] = ACTIONS(3553),
    [anon_sym_BANG] = ACTIONS(3553),
    [anon_sym_LPAREN] = ACTIONS(3555),
    [anon_sym_in] = ACTIONS(3553),
    [anon_sym_SEMI] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3555),
    [anon_sym_LT] = ACTIONS(3553),
    [anon_sym_GT] = ACTIONS(3553),
    [anon_sym_SLASH] = ACTIONS(3553),
    [anon_sym_DOT] = ACTIONS(3553),
    [anon_sym_async] = ACTIONS(3553),
    [anon_sym_QMARK_DOT] = ACTIONS(3555),
    [anon_sym_new] = ACTIONS(3553),
    [anon_sym_AMP_AMP] = ACTIONS(3555),
    [anon_sym_PIPE_PIPE] = ACTIONS(3555),
    [anon_sym_GT_GT] = ACTIONS(3553),
    [anon_sym_GT_GT_GT] = ACTIONS(3555),
    [anon_sym_LT_LT] = ACTIONS(3555),
    [anon_sym_AMP] = ACTIONS(3553),
    [anon_sym_CARET] = ACTIONS(3555),
    [anon_sym_PIPE] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(3553),
    [anon_sym_DASH] = ACTIONS(3553),
    [anon_sym_PERCENT] = ACTIONS(3555),
    [anon_sym_STAR_STAR] = ACTIONS(3555),
    [anon_sym_LT_EQ] = ACTIONS(3555),
    [anon_sym_EQ_EQ] = ACTIONS(3553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3555),
    [anon_sym_BANG_EQ] = ACTIONS(3553),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3555),
    [anon_sym_GT_EQ] = ACTIONS(3555),
    [anon_sym_QMARK_QMARK] = ACTIONS(3555),
    [anon_sym_instanceof] = ACTIONS(3553),
    [anon_sym_void] = ACTIONS(3553),
    [anon_sym_PLUS_PLUS] = ACTIONS(3555),
    [anon_sym_DASH_DASH] = ACTIONS(3555),
    [anon_sym_DQUOTE] = ACTIONS(3555),
    [anon_sym_SQUOTE] = ACTIONS(3555),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3555),
    [sym_number] = ACTIONS(3555),
    [sym_this] = ACTIONS(3553),
    [sym_true] = ACTIONS(3553),
    [sym_false] = ACTIONS(3553),
    [sym_null] = ACTIONS(3553),
    [sym_undefined] = ACTIONS(3553),
    [anon_sym_static] = ACTIONS(3553),
    [anon_sym_readonly] = ACTIONS(3553),
    [anon_sym_get] = ACTIONS(3553),
    [anon_sym_set] = ACTIONS(3553),
    [anon_sym_QMARK] = ACTIONS(3553),
    [anon_sym_any] = ACTIONS(3553),
    [anon_sym_number] = ACTIONS(3553),
    [anon_sym_boolean] = ACTIONS(3553),
    [anon_sym_string] = ACTIONS(3553),
    [anon_sym_symbol] = ACTIONS(3553),
    [anon_sym_abstract] = ACTIONS(3553),
    [anon_sym_satisfies] = ACTIONS(3553),
    [anon_sym_infer] = ACTIONS(3553),
    [anon_sym_keyof] = ACTIONS(3553),
    [anon_sym_unknown] = ACTIONS(3553),
    [anon_sym_never] = ACTIONS(3553),
    [anon_sym_object] = ACTIONS(3553),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3555),
    [anon_sym_constructor] = ACTIONS(3553),
    [anon_sym_prop] = ACTIONS(3553),
    [anon_sym_id] = ACTIONS(3553),
    [anon_sym_event] = ACTIONS(3553),
    [anon_sym_fn] = ACTIONS(3553),
    [anon_sym_on] = ACTIONS(3553),
    [sym__ternary_qmark] = ACTIONS(3555),
  },
  [1065] = {
    [sym_identifier] = ACTIONS(1678),
    [anon_sym_STAR] = ACTIONS(1678),
    [anon_sym_as] = ACTIONS(1678),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_RBRACE] = ACTIONS(1680),
    [anon_sym_typeof] = ACTIONS(1678),
    [anon_sym_BANG] = ACTIONS(1678),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [anon_sym_in] = ACTIONS(1678),
    [anon_sym_SEMI] = ACTIONS(1680),
    [anon_sym_LBRACK] = ACTIONS(1680),
    [anon_sym_LT] = ACTIONS(1678),
    [anon_sym_GT] = ACTIONS(1678),
    [anon_sym_SLASH] = ACTIONS(1678),
    [anon_sym_DOT] = ACTIONS(1678),
    [anon_sym_async] = ACTIONS(1678),
    [anon_sym_QMARK_DOT] = ACTIONS(1680),
    [anon_sym_new] = ACTIONS(1678),
    [anon_sym_AMP_AMP] = ACTIONS(1680),
    [anon_sym_PIPE_PIPE] = ACTIONS(1680),
    [anon_sym_GT_GT] = ACTIONS(1678),
    [anon_sym_GT_GT_GT] = ACTIONS(1680),
    [anon_sym_LT_LT] = ACTIONS(1680),
    [anon_sym_AMP] = ACTIONS(1678),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_PIPE] = ACTIONS(1678),
    [anon_sym_PLUS] = ACTIONS(1678),
    [anon_sym_DASH] = ACTIONS(1678),
    [anon_sym_PERCENT] = ACTIONS(1680),
    [anon_sym_STAR_STAR] = ACTIONS(1680),
    [anon_sym_LT_EQ] = ACTIONS(1680),
    [anon_sym_EQ_EQ] = ACTIONS(1678),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1680),
    [anon_sym_BANG_EQ] = ACTIONS(1678),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1680),
    [anon_sym_GT_EQ] = ACTIONS(1680),
    [anon_sym_QMARK_QMARK] = ACTIONS(1680),
    [anon_sym_instanceof] = ACTIONS(1678),
    [anon_sym_void] = ACTIONS(1678),
    [anon_sym_PLUS_PLUS] = ACTIONS(1680),
    [anon_sym_DASH_DASH] = ACTIONS(1680),
    [anon_sym_DQUOTE] = ACTIONS(1680),
    [anon_sym_SQUOTE] = ACTIONS(1680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1680),
    [sym_number] = ACTIONS(1680),
    [sym_this] = ACTIONS(1678),
    [sym_true] = ACTIONS(1678),
    [sym_false] = ACTIONS(1678),
    [sym_null] = ACTIONS(1678),
    [sym_undefined] = ACTIONS(1678),
    [anon_sym_static] = ACTIONS(1678),
    [anon_sym_readonly] = ACTIONS(1678),
    [anon_sym_get] = ACTIONS(1678),
    [anon_sym_set] = ACTIONS(1678),
    [anon_sym_QMARK] = ACTIONS(1678),
    [anon_sym_any] = ACTIONS(1678),
    [anon_sym_number] = ACTIONS(1678),
    [anon_sym_boolean] = ACTIONS(1678),
    [anon_sym_string] = ACTIONS(1678),
    [anon_sym_symbol] = ACTIONS(1678),
    [anon_sym_abstract] = ACTIONS(1678),
    [anon_sym_satisfies] = ACTIONS(1678),
    [anon_sym_infer] = ACTIONS(1678),
    [anon_sym_keyof] = ACTIONS(1678),
    [anon_sym_unknown] = ACTIONS(1678),
    [anon_sym_never] = ACTIONS(1678),
    [anon_sym_object] = ACTIONS(1678),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1680),
    [anon_sym_constructor] = ACTIONS(1678),
    [anon_sym_prop] = ACTIONS(1678),
    [anon_sym_id] = ACTIONS(1678),
    [anon_sym_event] = ACTIONS(1678),
    [anon_sym_fn] = ACTIONS(1678),
    [anon_sym_on] = ACTIONS(1678),
    [sym__ternary_qmark] = ACTIONS(1680),
  },
  [1066] = {
    [sym_identifier] = ACTIONS(3557),
    [anon_sym_STAR] = ACTIONS(3557),
    [anon_sym_as] = ACTIONS(3557),
    [anon_sym_LBRACE] = ACTIONS(3557),
    [anon_sym_RBRACE] = ACTIONS(3559),
    [anon_sym_typeof] = ACTIONS(3557),
    [anon_sym_BANG] = ACTIONS(3557),
    [anon_sym_LPAREN] = ACTIONS(3559),
    [anon_sym_in] = ACTIONS(3557),
    [anon_sym_SEMI] = ACTIONS(3559),
    [anon_sym_LBRACK] = ACTIONS(3559),
    [anon_sym_LT] = ACTIONS(3557),
    [anon_sym_GT] = ACTIONS(3557),
    [anon_sym_SLASH] = ACTIONS(3557),
    [anon_sym_DOT] = ACTIONS(3557),
    [anon_sym_async] = ACTIONS(3557),
    [anon_sym_QMARK_DOT] = ACTIONS(3559),
    [anon_sym_new] = ACTIONS(3557),
    [anon_sym_AMP_AMP] = ACTIONS(3559),
    [anon_sym_PIPE_PIPE] = ACTIONS(3559),
    [anon_sym_GT_GT] = ACTIONS(3557),
    [anon_sym_GT_GT_GT] = ACTIONS(3559),
    [anon_sym_LT_LT] = ACTIONS(3559),
    [anon_sym_AMP] = ACTIONS(3557),
    [anon_sym_CARET] = ACTIONS(3559),
    [anon_sym_PIPE] = ACTIONS(3557),
    [anon_sym_PLUS] = ACTIONS(3557),
    [anon_sym_DASH] = ACTIONS(3557),
    [anon_sym_PERCENT] = ACTIONS(3559),
    [anon_sym_STAR_STAR] = ACTIONS(3559),
    [anon_sym_LT_EQ] = ACTIONS(3559),
    [anon_sym_EQ_EQ] = ACTIONS(3557),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3559),
    [anon_sym_BANG_EQ] = ACTIONS(3557),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3559),
    [anon_sym_GT_EQ] = ACTIONS(3559),
    [anon_sym_QMARK_QMARK] = ACTIONS(3559),
    [anon_sym_instanceof] = ACTIONS(3557),
    [anon_sym_void] = ACTIONS(3557),
    [anon_sym_PLUS_PLUS] = ACTIONS(3559),
    [anon_sym_DASH_DASH] = ACTIONS(3559),
    [anon_sym_DQUOTE] = ACTIONS(3559),
    [anon_sym_SQUOTE] = ACTIONS(3559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3559),
    [sym_number] = ACTIONS(3559),
    [sym_this] = ACTIONS(3557),
    [sym_true] = ACTIONS(3557),
    [sym_false] = ACTIONS(3557),
    [sym_null] = ACTIONS(3557),
    [sym_undefined] = ACTIONS(3557),
    [anon_sym_static] = ACTIONS(3557),
    [anon_sym_readonly] = ACTIONS(3557),
    [anon_sym_get] = ACTIONS(3557),
    [anon_sym_set] = ACTIONS(3557),
    [anon_sym_QMARK] = ACTIONS(3557),
    [anon_sym_any] = ACTIONS(3557),
    [anon_sym_number] = ACTIONS(3557),
    [anon_sym_boolean] = ACTIONS(3557),
    [anon_sym_string] = ACTIONS(3557),
    [anon_sym_symbol] = ACTIONS(3557),
    [anon_sym_abstract] = ACTIONS(3557),
    [anon_sym_satisfies] = ACTIONS(3557),
    [anon_sym_infer] = ACTIONS(3557),
    [anon_sym_keyof] = ACTIONS(3557),
    [anon_sym_unknown] = ACTIONS(3557),
    [anon_sym_never] = ACTIONS(3557),
    [anon_sym_object] = ACTIONS(3557),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3559),
    [anon_sym_constructor] = ACTIONS(3557),
    [anon_sym_prop] = ACTIONS(3557),
    [anon_sym_id] = ACTIONS(3557),
    [anon_sym_event] = ACTIONS(3557),
    [anon_sym_fn] = ACTIONS(3557),
    [anon_sym_on] = ACTIONS(3557),
    [sym__ternary_qmark] = ACTIONS(3559),
  },
  [1067] = {
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_STAR] = ACTIONS(3561),
    [anon_sym_as] = ACTIONS(3561),
    [anon_sym_LBRACE] = ACTIONS(3561),
    [anon_sym_RBRACE] = ACTIONS(3563),
    [anon_sym_typeof] = ACTIONS(3561),
    [anon_sym_BANG] = ACTIONS(3561),
    [anon_sym_LPAREN] = ACTIONS(3563),
    [anon_sym_in] = ACTIONS(3561),
    [anon_sym_SEMI] = ACTIONS(3563),
    [anon_sym_LBRACK] = ACTIONS(3563),
    [anon_sym_LT] = ACTIONS(3561),
    [anon_sym_GT] = ACTIONS(3561),
    [anon_sym_SLASH] = ACTIONS(3561),
    [anon_sym_DOT] = ACTIONS(3561),
    [anon_sym_async] = ACTIONS(3561),
    [anon_sym_QMARK_DOT] = ACTIONS(3563),
    [anon_sym_new] = ACTIONS(3561),
    [anon_sym_AMP_AMP] = ACTIONS(3563),
    [anon_sym_PIPE_PIPE] = ACTIONS(3563),
    [anon_sym_GT_GT] = ACTIONS(3561),
    [anon_sym_GT_GT_GT] = ACTIONS(3563),
    [anon_sym_LT_LT] = ACTIONS(3563),
    [anon_sym_AMP] = ACTIONS(3561),
    [anon_sym_CARET] = ACTIONS(3563),
    [anon_sym_PIPE] = ACTIONS(3561),
    [anon_sym_PLUS] = ACTIONS(3561),
    [anon_sym_DASH] = ACTIONS(3561),
    [anon_sym_PERCENT] = ACTIONS(3563),
    [anon_sym_STAR_STAR] = ACTIONS(3563),
    [anon_sym_LT_EQ] = ACTIONS(3563),
    [anon_sym_EQ_EQ] = ACTIONS(3561),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3563),
    [anon_sym_BANG_EQ] = ACTIONS(3561),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3563),
    [anon_sym_GT_EQ] = ACTIONS(3563),
    [anon_sym_QMARK_QMARK] = ACTIONS(3563),
    [anon_sym_instanceof] = ACTIONS(3561),
    [anon_sym_void] = ACTIONS(3561),
    [anon_sym_PLUS_PLUS] = ACTIONS(3563),
    [anon_sym_DASH_DASH] = ACTIONS(3563),
    [anon_sym_DQUOTE] = ACTIONS(3563),
    [anon_sym_SQUOTE] = ACTIONS(3563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3563),
    [sym_number] = ACTIONS(3563),
    [sym_this] = ACTIONS(3561),
    [sym_true] = ACTIONS(3561),
    [sym_false] = ACTIONS(3561),
    [sym_null] = ACTIONS(3561),
    [sym_undefined] = ACTIONS(3561),
    [anon_sym_static] = ACTIONS(3561),
    [anon_sym_readonly] = ACTIONS(3561),
    [anon_sym_get] = ACTIONS(3561),
    [anon_sym_set] = ACTIONS(3561),
    [anon_sym_QMARK] = ACTIONS(3561),
    [anon_sym_any] = ACTIONS(3561),
    [anon_sym_number] = ACTIONS(3561),
    [anon_sym_boolean] = ACTIONS(3561),
    [anon_sym_string] = ACTIONS(3561),
    [anon_sym_symbol] = ACTIONS(3561),
    [anon_sym_abstract] = ACTIONS(3561),
    [anon_sym_satisfies] = ACTIONS(3561),
    [anon_sym_infer] = ACTIONS(3561),
    [anon_sym_keyof] = ACTIONS(3561),
    [anon_sym_unknown] = ACTIONS(3561),
    [anon_sym_never] = ACTIONS(3561),
    [anon_sym_object] = ACTIONS(3561),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3563),
    [anon_sym_constructor] = ACTIONS(3561),
    [anon_sym_prop] = ACTIONS(3561),
    [anon_sym_id] = ACTIONS(3561),
    [anon_sym_event] = ACTIONS(3561),
    [anon_sym_fn] = ACTIONS(3561),
    [anon_sym_on] = ACTIONS(3561),
    [sym__ternary_qmark] = ACTIONS(3563),
  },
  [1068] = {
    [sym_identifier] = ACTIONS(1708),
    [anon_sym_STAR] = ACTIONS(1708),
    [anon_sym_as] = ACTIONS(1708),
    [anon_sym_LBRACE] = ACTIONS(1708),
    [anon_sym_RBRACE] = ACTIONS(1712),
    [anon_sym_typeof] = ACTIONS(1708),
    [anon_sym_BANG] = ACTIONS(1708),
    [anon_sym_LPAREN] = ACTIONS(1712),
    [anon_sym_in] = ACTIONS(1708),
    [anon_sym_SEMI] = ACTIONS(1712),
    [anon_sym_LBRACK] = ACTIONS(1712),
    [anon_sym_LT] = ACTIONS(1708),
    [anon_sym_GT] = ACTIONS(1708),
    [anon_sym_SLASH] = ACTIONS(1708),
    [anon_sym_DOT] = ACTIONS(1708),
    [anon_sym_async] = ACTIONS(1708),
    [anon_sym_QMARK_DOT] = ACTIONS(1712),
    [anon_sym_new] = ACTIONS(1708),
    [anon_sym_AMP_AMP] = ACTIONS(1712),
    [anon_sym_PIPE_PIPE] = ACTIONS(1712),
    [anon_sym_GT_GT] = ACTIONS(1708),
    [anon_sym_GT_GT_GT] = ACTIONS(1712),
    [anon_sym_LT_LT] = ACTIONS(1712),
    [anon_sym_AMP] = ACTIONS(1708),
    [anon_sym_CARET] = ACTIONS(1712),
    [anon_sym_PIPE] = ACTIONS(1708),
    [anon_sym_PLUS] = ACTIONS(1708),
    [anon_sym_DASH] = ACTIONS(1708),
    [anon_sym_PERCENT] = ACTIONS(1712),
    [anon_sym_STAR_STAR] = ACTIONS(1712),
    [anon_sym_LT_EQ] = ACTIONS(1712),
    [anon_sym_EQ_EQ] = ACTIONS(1708),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1712),
    [anon_sym_BANG_EQ] = ACTIONS(1708),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1712),
    [anon_sym_GT_EQ] = ACTIONS(1712),
    [anon_sym_QMARK_QMARK] = ACTIONS(1712),
    [anon_sym_instanceof] = ACTIONS(1708),
    [anon_sym_void] = ACTIONS(1708),
    [anon_sym_PLUS_PLUS] = ACTIONS(1712),
    [anon_sym_DASH_DASH] = ACTIONS(1712),
    [anon_sym_DQUOTE] = ACTIONS(1712),
    [anon_sym_SQUOTE] = ACTIONS(1712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1712),
    [sym_number] = ACTIONS(1712),
    [sym_this] = ACTIONS(1708),
    [sym_true] = ACTIONS(1708),
    [sym_false] = ACTIONS(1708),
    [sym_null] = ACTIONS(1708),
    [sym_undefined] = ACTIONS(1708),
    [anon_sym_static] = ACTIONS(1708),
    [anon_sym_readonly] = ACTIONS(1708),
    [anon_sym_get] = ACTIONS(1708),
    [anon_sym_set] = ACTIONS(1708),
    [anon_sym_QMARK] = ACTIONS(1708),
    [anon_sym_any] = ACTIONS(1708),
    [anon_sym_number] = ACTIONS(1708),
    [anon_sym_boolean] = ACTIONS(1708),
    [anon_sym_string] = ACTIONS(1708),
    [anon_sym_symbol] = ACTIONS(1708),
    [anon_sym_abstract] = ACTIONS(1708),
    [anon_sym_satisfies] = ACTIONS(1708),
    [anon_sym_infer] = ACTIONS(1708),
    [anon_sym_keyof] = ACTIONS(1708),
    [anon_sym_unknown] = ACTIONS(1708),
    [anon_sym_never] = ACTIONS(1708),
    [anon_sym_object] = ACTIONS(1708),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1712),
    [anon_sym_constructor] = ACTIONS(1708),
    [anon_sym_prop] = ACTIONS(1708),
    [anon_sym_id] = ACTIONS(1708),
    [anon_sym_event] = ACTIONS(1708),
    [anon_sym_fn] = ACTIONS(1708),
    [anon_sym_on] = ACTIONS(1708),
    [sym__ternary_qmark] = ACTIONS(1712),
  },
  [1069] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_PIPE_PIPE] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(3573),
    [anon_sym_GT_GT_GT] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3579),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3593),
    [anon_sym_GT_EQ] = ACTIONS(3589),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(3567),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [1070] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(3030),
    [anon_sym_RBRACE] = ACTIONS(3032),
    [anon_sym_typeof] = ACTIONS(3030),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(3030),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(3030),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_PIPE_PIPE] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(3573),
    [anon_sym_GT_GT_GT] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3579),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3593),
    [anon_sym_GT_EQ] = ACTIONS(3589),
    [anon_sym_QMARK_QMARK] = ACTIONS(3595),
    [anon_sym_instanceof] = ACTIONS(3567),
    [anon_sym_void] = ACTIONS(3030),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3032),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3032),
    [sym_number] = ACTIONS(3032),
    [sym_this] = ACTIONS(3030),
    [sym_true] = ACTIONS(3030),
    [sym_false] = ACTIONS(3030),
    [sym_null] = ACTIONS(3030),
    [sym_undefined] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_readonly] = ACTIONS(3030),
    [anon_sym_QMARK] = ACTIONS(3030),
    [anon_sym_any] = ACTIONS(3030),
    [anon_sym_number] = ACTIONS(3030),
    [anon_sym_boolean] = ACTIONS(3030),
    [anon_sym_string] = ACTIONS(3030),
    [anon_sym_symbol] = ACTIONS(3030),
    [anon_sym_abstract] = ACTIONS(3030),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(3030),
    [anon_sym_keyof] = ACTIONS(3030),
    [anon_sym_unknown] = ACTIONS(3030),
    [anon_sym_never] = ACTIONS(3030),
    [anon_sym_object] = ACTIONS(3030),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3032),
    [anon_sym_prop] = ACTIONS(3030),
    [anon_sym_id] = ACTIONS(3030),
    [anon_sym_event] = ACTIONS(3030),
    [anon_sym_fn] = ACTIONS(3030),
    [anon_sym_on] = ACTIONS(3030),
    [sym__ternary_qmark] = ACTIONS(3597),
  },
  [1071] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2698),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2698),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2698),
    [anon_sym_GT_GT_GT] = ACTIONS(2700),
    [anon_sym_LT_LT] = ACTIONS(2700),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(2700),
    [anon_sym_EQ_EQ] = ACTIONS(2698),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2700),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2700),
    [anon_sym_GT_EQ] = ACTIONS(2700),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(2698),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [1072] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2970),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_RBRACE] = ACTIONS(2972),
    [anon_sym_typeof] = ACTIONS(2970),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2970),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_PIPE_PIPE] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(3573),
    [anon_sym_GT_GT_GT] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3579),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3593),
    [anon_sym_GT_EQ] = ACTIONS(3589),
    [anon_sym_QMARK_QMARK] = ACTIONS(3595),
    [anon_sym_instanceof] = ACTIONS(3567),
    [anon_sym_void] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2972),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2972),
    [sym_number] = ACTIONS(2972),
    [sym_this] = ACTIONS(2970),
    [sym_true] = ACTIONS(2970),
    [sym_false] = ACTIONS(2970),
    [sym_null] = ACTIONS(2970),
    [sym_undefined] = ACTIONS(2970),
    [anon_sym_static] = ACTIONS(2970),
    [anon_sym_readonly] = ACTIONS(2970),
    [anon_sym_QMARK] = ACTIONS(2970),
    [anon_sym_any] = ACTIONS(2970),
    [anon_sym_number] = ACTIONS(2970),
    [anon_sym_boolean] = ACTIONS(2970),
    [anon_sym_string] = ACTIONS(2970),
    [anon_sym_symbol] = ACTIONS(2970),
    [anon_sym_abstract] = ACTIONS(2970),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2970),
    [anon_sym_keyof] = ACTIONS(2970),
    [anon_sym_unknown] = ACTIONS(2970),
    [anon_sym_never] = ACTIONS(2970),
    [anon_sym_object] = ACTIONS(2970),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2972),
    [anon_sym_prop] = ACTIONS(2970),
    [anon_sym_id] = ACTIONS(2970),
    [anon_sym_event] = ACTIONS(2970),
    [anon_sym_fn] = ACTIONS(2970),
    [anon_sym_on] = ACTIONS(2970),
    [sym__ternary_qmark] = ACTIONS(3597),
  },
  [1073] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(3573),
    [anon_sym_GT_GT_GT] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3579),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3593),
    [anon_sym_GT_EQ] = ACTIONS(3589),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(3567),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [1074] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(3573),
    [anon_sym_GT_GT_GT] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3579),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3593),
    [anon_sym_GT_EQ] = ACTIONS(3589),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(3567),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [1075] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2698),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2698),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(3573),
    [anon_sym_GT_GT_GT] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(2700),
    [anon_sym_EQ_EQ] = ACTIONS(2698),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2700),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2700),
    [anon_sym_GT_EQ] = ACTIONS(2700),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(2698),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [1076] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(3002),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(3002),
    [anon_sym_RBRACE] = ACTIONS(3004),
    [anon_sym_typeof] = ACTIONS(3002),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(3004),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(3002),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(3002),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_PIPE_PIPE] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(3573),
    [anon_sym_GT_GT_GT] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3579),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3593),
    [anon_sym_GT_EQ] = ACTIONS(3589),
    [anon_sym_QMARK_QMARK] = ACTIONS(3595),
    [anon_sym_instanceof] = ACTIONS(3567),
    [anon_sym_void] = ACTIONS(3002),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(3004),
    [anon_sym_SQUOTE] = ACTIONS(3004),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3004),
    [sym_number] = ACTIONS(3004),
    [sym_this] = ACTIONS(3002),
    [sym_true] = ACTIONS(3002),
    [sym_false] = ACTIONS(3002),
    [sym_null] = ACTIONS(3002),
    [sym_undefined] = ACTIONS(3002),
    [anon_sym_static] = ACTIONS(3002),
    [anon_sym_readonly] = ACTIONS(3002),
    [anon_sym_QMARK] = ACTIONS(3002),
    [anon_sym_any] = ACTIONS(3002),
    [anon_sym_number] = ACTIONS(3002),
    [anon_sym_boolean] = ACTIONS(3002),
    [anon_sym_string] = ACTIONS(3002),
    [anon_sym_symbol] = ACTIONS(3002),
    [anon_sym_abstract] = ACTIONS(3002),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(3002),
    [anon_sym_keyof] = ACTIONS(3002),
    [anon_sym_unknown] = ACTIONS(3002),
    [anon_sym_never] = ACTIONS(3002),
    [anon_sym_object] = ACTIONS(3002),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3004),
    [anon_sym_prop] = ACTIONS(3002),
    [anon_sym_id] = ACTIONS(3002),
    [anon_sym_event] = ACTIONS(3002),
    [anon_sym_fn] = ACTIONS(3002),
    [anon_sym_on] = ACTIONS(3002),
    [sym__ternary_qmark] = ACTIONS(3597),
  },
  [1077] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2612),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2612),
    [anon_sym_RBRACE] = ACTIONS(2618),
    [anon_sym_typeof] = ACTIONS(2612),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2612),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_PIPE_PIPE] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(3573),
    [anon_sym_GT_GT_GT] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3579),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3593),
    [anon_sym_GT_EQ] = ACTIONS(3589),
    [anon_sym_QMARK_QMARK] = ACTIONS(3595),
    [anon_sym_instanceof] = ACTIONS(3567),
    [anon_sym_void] = ACTIONS(2612),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2618),
    [anon_sym_SQUOTE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2618),
    [sym_number] = ACTIONS(2618),
    [sym_this] = ACTIONS(2612),
    [sym_true] = ACTIONS(2612),
    [sym_false] = ACTIONS(2612),
    [sym_null] = ACTIONS(2612),
    [sym_undefined] = ACTIONS(2612),
    [anon_sym_static] = ACTIONS(2612),
    [anon_sym_readonly] = ACTIONS(2612),
    [anon_sym_QMARK] = ACTIONS(2612),
    [anon_sym_any] = ACTIONS(2612),
    [anon_sym_number] = ACTIONS(2612),
    [anon_sym_boolean] = ACTIONS(2612),
    [anon_sym_string] = ACTIONS(2612),
    [anon_sym_symbol] = ACTIONS(2612),
    [anon_sym_abstract] = ACTIONS(2612),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2612),
    [anon_sym_keyof] = ACTIONS(2612),
    [anon_sym_unknown] = ACTIONS(2612),
    [anon_sym_never] = ACTIONS(2612),
    [anon_sym_object] = ACTIONS(2612),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2618),
    [anon_sym_prop] = ACTIONS(2612),
    [anon_sym_id] = ACTIONS(2612),
    [anon_sym_event] = ACTIONS(2612),
    [anon_sym_fn] = ACTIONS(2612),
    [anon_sym_on] = ACTIONS(2612),
    [sym__ternary_qmark] = ACTIONS(3597),
  },
  [1078] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(2698),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2698),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2698),
    [anon_sym_SLASH] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2698),
    [anon_sym_GT_GT_GT] = ACTIONS(2700),
    [anon_sym_LT_LT] = ACTIONS(2700),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2700),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(2700),
    [anon_sym_EQ_EQ] = ACTIONS(2698),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2700),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2700),
    [anon_sym_GT_EQ] = ACTIONS(2700),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(2698),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [1079] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2882),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_RBRACE] = ACTIONS(2884),
    [anon_sym_typeof] = ACTIONS(2882),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2882),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2882),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_PIPE_PIPE] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(3573),
    [anon_sym_GT_GT_GT] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3579),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3593),
    [anon_sym_GT_EQ] = ACTIONS(3589),
    [anon_sym_QMARK_QMARK] = ACTIONS(3595),
    [anon_sym_instanceof] = ACTIONS(3567),
    [anon_sym_void] = ACTIONS(2882),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2884),
    [anon_sym_SQUOTE] = ACTIONS(2884),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2884),
    [sym_number] = ACTIONS(2884),
    [sym_this] = ACTIONS(2882),
    [sym_true] = ACTIONS(2882),
    [sym_false] = ACTIONS(2882),
    [sym_null] = ACTIONS(2882),
    [sym_undefined] = ACTIONS(2882),
    [anon_sym_static] = ACTIONS(2882),
    [anon_sym_readonly] = ACTIONS(2882),
    [anon_sym_QMARK] = ACTIONS(2882),
    [anon_sym_any] = ACTIONS(2882),
    [anon_sym_number] = ACTIONS(2882),
    [anon_sym_boolean] = ACTIONS(2882),
    [anon_sym_string] = ACTIONS(2882),
    [anon_sym_symbol] = ACTIONS(2882),
    [anon_sym_abstract] = ACTIONS(2882),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2882),
    [anon_sym_keyof] = ACTIONS(2882),
    [anon_sym_unknown] = ACTIONS(2882),
    [anon_sym_never] = ACTIONS(2882),
    [anon_sym_object] = ACTIONS(2882),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2884),
    [anon_sym_prop] = ACTIONS(2882),
    [anon_sym_id] = ACTIONS(2882),
    [anon_sym_event] = ACTIONS(2882),
    [anon_sym_fn] = ACTIONS(2882),
    [anon_sym_on] = ACTIONS(2882),
    [sym__ternary_qmark] = ACTIONS(3597),
  },
  [1080] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2820),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2820),
    [anon_sym_RBRACE] = ACTIONS(2822),
    [anon_sym_typeof] = ACTIONS(2820),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(2822),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2820),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2820),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_PIPE_PIPE] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(3573),
    [anon_sym_GT_GT_GT] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3579),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3593),
    [anon_sym_GT_EQ] = ACTIONS(3589),
    [anon_sym_QMARK_QMARK] = ACTIONS(3595),
    [anon_sym_instanceof] = ACTIONS(3567),
    [anon_sym_void] = ACTIONS(2820),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2822),
    [anon_sym_SQUOTE] = ACTIONS(2822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2822),
    [sym_number] = ACTIONS(2822),
    [sym_this] = ACTIONS(2820),
    [sym_true] = ACTIONS(2820),
    [sym_false] = ACTIONS(2820),
    [sym_null] = ACTIONS(2820),
    [sym_undefined] = ACTIONS(2820),
    [anon_sym_static] = ACTIONS(2820),
    [anon_sym_readonly] = ACTIONS(2820),
    [anon_sym_QMARK] = ACTIONS(2820),
    [anon_sym_any] = ACTIONS(2820),
    [anon_sym_number] = ACTIONS(2820),
    [anon_sym_boolean] = ACTIONS(2820),
    [anon_sym_string] = ACTIONS(2820),
    [anon_sym_symbol] = ACTIONS(2820),
    [anon_sym_abstract] = ACTIONS(2820),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2820),
    [anon_sym_keyof] = ACTIONS(2820),
    [anon_sym_unknown] = ACTIONS(2820),
    [anon_sym_never] = ACTIONS(2820),
    [anon_sym_object] = ACTIONS(2820),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2822),
    [anon_sym_prop] = ACTIONS(2820),
    [anon_sym_id] = ACTIONS(2820),
    [anon_sym_event] = ACTIONS(2820),
    [anon_sym_fn] = ACTIONS(2820),
    [anon_sym_on] = ACTIONS(2820),
    [sym__ternary_qmark] = ACTIONS(3597),
  },
  [1081] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(3573),
    [anon_sym_GT_GT_GT] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3593),
    [anon_sym_GT_EQ] = ACTIONS(3589),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(3567),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [1082] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(3070),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_RBRACE] = ACTIONS(3072),
    [anon_sym_typeof] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(3070),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_PIPE_PIPE] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(3573),
    [anon_sym_GT_GT_GT] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3579),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3593),
    [anon_sym_GT_EQ] = ACTIONS(3589),
    [anon_sym_QMARK_QMARK] = ACTIONS(3595),
    [anon_sym_instanceof] = ACTIONS(3567),
    [anon_sym_void] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(3072),
    [anon_sym_SQUOTE] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3072),
    [sym_number] = ACTIONS(3072),
    [sym_this] = ACTIONS(3070),
    [sym_true] = ACTIONS(3070),
    [sym_false] = ACTIONS(3070),
    [sym_null] = ACTIONS(3070),
    [sym_undefined] = ACTIONS(3070),
    [anon_sym_static] = ACTIONS(3070),
    [anon_sym_readonly] = ACTIONS(3070),
    [anon_sym_QMARK] = ACTIONS(3070),
    [anon_sym_any] = ACTIONS(3070),
    [anon_sym_number] = ACTIONS(3070),
    [anon_sym_boolean] = ACTIONS(3070),
    [anon_sym_string] = ACTIONS(3070),
    [anon_sym_symbol] = ACTIONS(3070),
    [anon_sym_abstract] = ACTIONS(3070),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(3070),
    [anon_sym_keyof] = ACTIONS(3070),
    [anon_sym_unknown] = ACTIONS(3070),
    [anon_sym_never] = ACTIONS(3070),
    [anon_sym_object] = ACTIONS(3070),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3072),
    [anon_sym_prop] = ACTIONS(3070),
    [anon_sym_id] = ACTIONS(3070),
    [anon_sym_event] = ACTIONS(3070),
    [anon_sym_fn] = ACTIONS(3070),
    [anon_sym_on] = ACTIONS(3070),
    [sym__ternary_qmark] = ACTIONS(3597),
  },
  [1083] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(3573),
    [anon_sym_GT_GT_GT] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3593),
    [anon_sym_GT_EQ] = ACTIONS(3589),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(3567),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [1084] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(3573),
    [anon_sym_GT_GT_GT] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3579),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3593),
    [anon_sym_GT_EQ] = ACTIONS(3589),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(3567),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [1085] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2990),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2990),
    [anon_sym_RBRACE] = ACTIONS(2992),
    [anon_sym_typeof] = ACTIONS(2990),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2990),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2990),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_PIPE_PIPE] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(3573),
    [anon_sym_GT_GT_GT] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3579),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3593),
    [anon_sym_GT_EQ] = ACTIONS(3589),
    [anon_sym_QMARK_QMARK] = ACTIONS(3595),
    [anon_sym_instanceof] = ACTIONS(3567),
    [anon_sym_void] = ACTIONS(2990),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2992),
    [anon_sym_SQUOTE] = ACTIONS(2992),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2992),
    [sym_number] = ACTIONS(2992),
    [sym_this] = ACTIONS(2990),
    [sym_true] = ACTIONS(2990),
    [sym_false] = ACTIONS(2990),
    [sym_null] = ACTIONS(2990),
    [sym_undefined] = ACTIONS(2990),
    [anon_sym_static] = ACTIONS(2990),
    [anon_sym_readonly] = ACTIONS(2990),
    [anon_sym_QMARK] = ACTIONS(2990),
    [anon_sym_any] = ACTIONS(2990),
    [anon_sym_number] = ACTIONS(2990),
    [anon_sym_boolean] = ACTIONS(2990),
    [anon_sym_string] = ACTIONS(2990),
    [anon_sym_symbol] = ACTIONS(2990),
    [anon_sym_abstract] = ACTIONS(2990),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2990),
    [anon_sym_keyof] = ACTIONS(2990),
    [anon_sym_unknown] = ACTIONS(2990),
    [anon_sym_never] = ACTIONS(2990),
    [anon_sym_object] = ACTIONS(2990),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2992),
    [anon_sym_prop] = ACTIONS(2990),
    [anon_sym_id] = ACTIONS(2990),
    [anon_sym_event] = ACTIONS(2990),
    [anon_sym_fn] = ACTIONS(2990),
    [anon_sym_on] = ACTIONS(2990),
    [sym__ternary_qmark] = ACTIONS(3597),
  },
  [1086] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2886),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2886),
    [anon_sym_RBRACE] = ACTIONS(2888),
    [anon_sym_typeof] = ACTIONS(2886),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(2888),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2886),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2886),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_PIPE_PIPE] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(3573),
    [anon_sym_GT_GT_GT] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3579),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3593),
    [anon_sym_GT_EQ] = ACTIONS(3589),
    [anon_sym_QMARK_QMARK] = ACTIONS(3595),
    [anon_sym_instanceof] = ACTIONS(3567),
    [anon_sym_void] = ACTIONS(2886),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2888),
    [anon_sym_SQUOTE] = ACTIONS(2888),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2888),
    [sym_number] = ACTIONS(2888),
    [sym_this] = ACTIONS(2886),
    [sym_true] = ACTIONS(2886),
    [sym_false] = ACTIONS(2886),
    [sym_null] = ACTIONS(2886),
    [sym_undefined] = ACTIONS(2886),
    [anon_sym_static] = ACTIONS(2886),
    [anon_sym_readonly] = ACTIONS(2886),
    [anon_sym_QMARK] = ACTIONS(2886),
    [anon_sym_any] = ACTIONS(2886),
    [anon_sym_number] = ACTIONS(2886),
    [anon_sym_boolean] = ACTIONS(2886),
    [anon_sym_string] = ACTIONS(2886),
    [anon_sym_symbol] = ACTIONS(2886),
    [anon_sym_abstract] = ACTIONS(2886),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2886),
    [anon_sym_keyof] = ACTIONS(2886),
    [anon_sym_unknown] = ACTIONS(2886),
    [anon_sym_never] = ACTIONS(2886),
    [anon_sym_object] = ACTIONS(2886),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2888),
    [anon_sym_prop] = ACTIONS(2886),
    [anon_sym_id] = ACTIONS(2886),
    [anon_sym_event] = ACTIONS(2886),
    [anon_sym_fn] = ACTIONS(2886),
    [anon_sym_on] = ACTIONS(2886),
    [sym__ternary_qmark] = ACTIONS(3597),
  },
  [1087] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2698),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2698),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2698),
    [anon_sym_GT_GT_GT] = ACTIONS(2700),
    [anon_sym_LT_LT] = ACTIONS(2700),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(2700),
    [anon_sym_EQ_EQ] = ACTIONS(2698),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2700),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2700),
    [anon_sym_GT_EQ] = ACTIONS(2700),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(2698),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [1088] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2788),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2788),
    [anon_sym_RBRACE] = ACTIONS(2790),
    [anon_sym_typeof] = ACTIONS(2788),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(2790),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2788),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2788),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_PIPE_PIPE] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(3573),
    [anon_sym_GT_GT_GT] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3579),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3593),
    [anon_sym_GT_EQ] = ACTIONS(3589),
    [anon_sym_QMARK_QMARK] = ACTIONS(3595),
    [anon_sym_instanceof] = ACTIONS(3567),
    [anon_sym_void] = ACTIONS(2788),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2790),
    [anon_sym_SQUOTE] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2790),
    [sym_number] = ACTIONS(2790),
    [sym_this] = ACTIONS(2788),
    [sym_true] = ACTIONS(2788),
    [sym_false] = ACTIONS(2788),
    [sym_null] = ACTIONS(2788),
    [sym_undefined] = ACTIONS(2788),
    [anon_sym_static] = ACTIONS(2788),
    [anon_sym_readonly] = ACTIONS(2788),
    [anon_sym_QMARK] = ACTIONS(2788),
    [anon_sym_any] = ACTIONS(2788),
    [anon_sym_number] = ACTIONS(2788),
    [anon_sym_boolean] = ACTIONS(2788),
    [anon_sym_string] = ACTIONS(2788),
    [anon_sym_symbol] = ACTIONS(2788),
    [anon_sym_abstract] = ACTIONS(2788),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2788),
    [anon_sym_keyof] = ACTIONS(2788),
    [anon_sym_unknown] = ACTIONS(2788),
    [anon_sym_never] = ACTIONS(2788),
    [anon_sym_object] = ACTIONS(2788),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2790),
    [anon_sym_prop] = ACTIONS(2788),
    [anon_sym_id] = ACTIONS(2788),
    [anon_sym_event] = ACTIONS(2788),
    [anon_sym_fn] = ACTIONS(2788),
    [anon_sym_on] = ACTIONS(2788),
    [sym__ternary_qmark] = ACTIONS(3597),
  },
  [1089] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(2698),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2698),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2698),
    [anon_sym_SLASH] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2698),
    [anon_sym_GT_GT_GT] = ACTIONS(2700),
    [anon_sym_LT_LT] = ACTIONS(2700),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_PERCENT] = ACTIONS(2700),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(2700),
    [anon_sym_EQ_EQ] = ACTIONS(2698),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2700),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2700),
    [anon_sym_GT_EQ] = ACTIONS(2700),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(2698),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [1090] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2780),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2780),
    [anon_sym_RBRACE] = ACTIONS(2782),
    [anon_sym_typeof] = ACTIONS(2780),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2780),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_PIPE_PIPE] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(3573),
    [anon_sym_GT_GT_GT] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3579),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3593),
    [anon_sym_GT_EQ] = ACTIONS(3589),
    [anon_sym_QMARK_QMARK] = ACTIONS(3595),
    [anon_sym_instanceof] = ACTIONS(3567),
    [anon_sym_void] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2782),
    [anon_sym_SQUOTE] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2782),
    [sym_number] = ACTIONS(2782),
    [sym_this] = ACTIONS(2780),
    [sym_true] = ACTIONS(2780),
    [sym_false] = ACTIONS(2780),
    [sym_null] = ACTIONS(2780),
    [sym_undefined] = ACTIONS(2780),
    [anon_sym_static] = ACTIONS(2780),
    [anon_sym_readonly] = ACTIONS(2780),
    [anon_sym_QMARK] = ACTIONS(2780),
    [anon_sym_any] = ACTIONS(2780),
    [anon_sym_number] = ACTIONS(2780),
    [anon_sym_boolean] = ACTIONS(2780),
    [anon_sym_string] = ACTIONS(2780),
    [anon_sym_symbol] = ACTIONS(2780),
    [anon_sym_abstract] = ACTIONS(2780),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2780),
    [anon_sym_keyof] = ACTIONS(2780),
    [anon_sym_unknown] = ACTIONS(2780),
    [anon_sym_never] = ACTIONS(2780),
    [anon_sym_object] = ACTIONS(2780),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2782),
    [anon_sym_prop] = ACTIONS(2780),
    [anon_sym_id] = ACTIONS(2780),
    [anon_sym_event] = ACTIONS(2780),
    [anon_sym_fn] = ACTIONS(2780),
    [anon_sym_on] = ACTIONS(2780),
    [sym__ternary_qmark] = ACTIONS(3597),
  },
  [1091] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2784),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2784),
    [anon_sym_RBRACE] = ACTIONS(2786),
    [anon_sym_typeof] = ACTIONS(2784),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(2786),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2784),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2784),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_PIPE_PIPE] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(3573),
    [anon_sym_GT_GT_GT] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3579),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3593),
    [anon_sym_GT_EQ] = ACTIONS(3589),
    [anon_sym_QMARK_QMARK] = ACTIONS(3595),
    [anon_sym_instanceof] = ACTIONS(3567),
    [anon_sym_void] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2786),
    [anon_sym_SQUOTE] = ACTIONS(2786),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2786),
    [sym_number] = ACTIONS(2786),
    [sym_this] = ACTIONS(2784),
    [sym_true] = ACTIONS(2784),
    [sym_false] = ACTIONS(2784),
    [sym_null] = ACTIONS(2784),
    [sym_undefined] = ACTIONS(2784),
    [anon_sym_static] = ACTIONS(2784),
    [anon_sym_readonly] = ACTIONS(2784),
    [anon_sym_QMARK] = ACTIONS(2784),
    [anon_sym_any] = ACTIONS(2784),
    [anon_sym_number] = ACTIONS(2784),
    [anon_sym_boolean] = ACTIONS(2784),
    [anon_sym_string] = ACTIONS(2784),
    [anon_sym_symbol] = ACTIONS(2784),
    [anon_sym_abstract] = ACTIONS(2784),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2784),
    [anon_sym_keyof] = ACTIONS(2784),
    [anon_sym_unknown] = ACTIONS(2784),
    [anon_sym_never] = ACTIONS(2784),
    [anon_sym_object] = ACTIONS(2784),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2786),
    [anon_sym_prop] = ACTIONS(2784),
    [anon_sym_id] = ACTIONS(2784),
    [anon_sym_event] = ACTIONS(2784),
    [anon_sym_fn] = ACTIONS(2784),
    [anon_sym_on] = ACTIONS(2784),
    [sym__ternary_qmark] = ACTIONS(3597),
  },
  [1092] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2792),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2792),
    [anon_sym_RBRACE] = ACTIONS(2794),
    [anon_sym_typeof] = ACTIONS(2792),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2792),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2792),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_PIPE_PIPE] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(3573),
    [anon_sym_GT_GT_GT] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3579),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3593),
    [anon_sym_GT_EQ] = ACTIONS(3589),
    [anon_sym_QMARK_QMARK] = ACTIONS(3595),
    [anon_sym_instanceof] = ACTIONS(3567),
    [anon_sym_void] = ACTIONS(2792),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2794),
    [sym_number] = ACTIONS(2794),
    [sym_this] = ACTIONS(2792),
    [sym_true] = ACTIONS(2792),
    [sym_false] = ACTIONS(2792),
    [sym_null] = ACTIONS(2792),
    [sym_undefined] = ACTIONS(2792),
    [anon_sym_static] = ACTIONS(2792),
    [anon_sym_readonly] = ACTIONS(2792),
    [anon_sym_QMARK] = ACTIONS(2792),
    [anon_sym_any] = ACTIONS(2792),
    [anon_sym_number] = ACTIONS(2792),
    [anon_sym_boolean] = ACTIONS(2792),
    [anon_sym_string] = ACTIONS(2792),
    [anon_sym_symbol] = ACTIONS(2792),
    [anon_sym_abstract] = ACTIONS(2792),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2792),
    [anon_sym_keyof] = ACTIONS(2792),
    [anon_sym_unknown] = ACTIONS(2792),
    [anon_sym_never] = ACTIONS(2792),
    [anon_sym_object] = ACTIONS(2792),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2794),
    [anon_sym_prop] = ACTIONS(2792),
    [anon_sym_id] = ACTIONS(2792),
    [anon_sym_event] = ACTIONS(2792),
    [anon_sym_fn] = ACTIONS(2792),
    [anon_sym_on] = ACTIONS(2792),
    [sym__ternary_qmark] = ACTIONS(3597),
  },
  [1093] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_AMP_AMP] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(3573),
    [anon_sym_GT_GT_GT] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(2698),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2700),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2700),
    [anon_sym_GT_EQ] = ACTIONS(3589),
    [anon_sym_QMARK_QMARK] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(3567),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_satisfies] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2698),
    [anon_sym_keyof] = ACTIONS(2698),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_prop] = ACTIONS(2698),
    [anon_sym_id] = ACTIONS(2698),
    [anon_sym_event] = ACTIONS(2698),
    [anon_sym_fn] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [sym__ternary_qmark] = ACTIONS(2700),
  },
  [1094] = {
    [sym_optional_chain] = STATE(4033),
    [sym_arguments] = STATE(1016),
    [sym_identifier] = ACTIONS(2890),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_RBRACE] = ACTIONS(2892),
    [anon_sym_typeof] = ACTIONS(2890),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(2892),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(3567),
    [anon_sym_GT] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3565),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2890),
    [anon_sym_QMARK_DOT] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2890),
    [anon_sym_AMP_AMP] = ACTIONS(3569),
    [anon_sym_PIPE_PIPE] = ACTIONS(3571),
    [anon_sym_GT_GT] = ACTIONS(3573),
    [anon_sym_GT_GT_GT] = ACTIONS(3575),
    [anon_sym_LT_LT] = ACTIONS(3575),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3579),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_PERCENT] = ACTIONS(3585),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_LT_EQ] = ACTIONS(3589),
    [anon_sym_EQ_EQ] = ACTIONS(3591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3593),
    [anon_sym_BANG_EQ] = ACTIONS(3591),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3593),
    [anon_sym_GT_EQ] = ACTIONS(3589),
    [anon_sym_QMARK_QMARK] = ACTIONS(3595),
    [anon_sym_instanceof] = ACTIONS(3567),
    [anon_sym_void] = ACTIONS(2890),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2892),
    [anon_sym_SQUOTE] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2892),
    [sym_number] = ACTIONS(2892),
    [sym_this] = ACTIONS(2890),
    [sym_true] = ACTIONS(2890),
    [sym_false] = ACTIONS(2890),
    [sym_null] = ACTIONS(2890),
    [sym_undefined] = ACTIONS(2890),
    [anon_sym_static] = ACTIONS(2890),
    [anon_sym_readonly] = ACTIONS(2890),
    [anon_sym_QMARK] = ACTIONS(2890),
    [anon_sym_any] = ACTIONS(2890),
    [anon_sym_number] = ACTIONS(2890),
    [anon_sym_boolean] = ACTIONS(2890),
    [anon_sym_string] = ACTIONS(2890),
    [anon_sym_symbol] = ACTIONS(2890),
    [anon_sym_abstract] = ACTIONS(2890),
    [anon_sym_satisfies] = ACTIONS(2654),
    [anon_sym_infer] = ACTIONS(2890),
    [anon_sym_keyof] = ACTIONS(2890),
    [anon_sym_unknown] = ACTIONS(2890),
    [anon_sym_never] = ACTIONS(2890),
    [anon_sym_object] = ACTIONS(2890),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2892),
    [anon_sym_prop] = ACTIONS(2890),
    [anon_sym_id] = ACTIONS(2890),
    [anon_sym_event] = ACTIONS(2890),
    [anon_sym_fn] = ACTIONS(2890),
    [anon_sym_on] = ACTIONS(2890),
    [sym__ternary_qmark] = ACTIONS(3597),
  },
  [1095] = {
    [sym_identifier] = ACTIONS(3599),
    [anon_sym_export] = ACTIONS(3599),
    [anon_sym_LBRACE] = ACTIONS(3601),
    [anon_sym_type] = ACTIONS(3599),
    [anon_sym_typeof] = ACTIONS(3599),
    [anon_sym_import] = ACTIONS(3599),
    [anon_sym_var] = ACTIONS(3599),
    [anon_sym_let] = ACTIONS(3599),
    [anon_sym_const] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3601),
    [anon_sym_if] = ACTIONS(3599),
    [anon_sym_switch] = ACTIONS(3599),
    [anon_sym_for] = ACTIONS(3599),
    [anon_sym_LPAREN] = ACTIONS(3601),
    [anon_sym_await] = ACTIONS(3599),
    [anon_sym_while] = ACTIONS(3599),
    [anon_sym_do] = ACTIONS(3599),
    [anon_sym_try] = ACTIONS(3599),
    [anon_sym_with] = ACTIONS(3599),
    [anon_sym_break] = ACTIONS(3599),
    [anon_sym_continue] = ACTIONS(3599),
    [anon_sym_debugger] = ACTIONS(3599),
    [anon_sym_return] = ACTIONS(3599),
    [anon_sym_throw] = ACTIONS(3599),
    [anon_sym_SEMI] = ACTIONS(3601),
    [anon_sym_yield] = ACTIONS(3599),
    [anon_sym_LBRACK] = ACTIONS(3601),
    [anon_sym_LTtemplate_GT] = ACTIONS(3601),
    [anon_sym_LT] = ACTIONS(3599),
    [anon_sym_SLASH] = ACTIONS(3599),
    [anon_sym_class] = ACTIONS(3599),
    [anon_sym_async] = ACTIONS(3599),
    [anon_sym_function] = ACTIONS(3599),
    [anon_sym_new] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3601),
    [anon_sym_PLUS] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3601),
    [anon_sym_void] = ACTIONS(3599),
    [anon_sym_delete] = ACTIONS(3599),
    [anon_sym_PLUS_PLUS] = ACTIONS(3601),
    [anon_sym_DASH_DASH] = ACTIONS(3601),
    [anon_sym_DQUOTE] = ACTIONS(3601),
    [anon_sym_SQUOTE] = ACTIONS(3601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3601),
    [sym_number] = ACTIONS(3601),
    [sym_this] = ACTIONS(3599),
    [sym_super] = ACTIONS(3599),
    [sym_true] = ACTIONS(3599),
    [sym_false] = ACTIONS(3599),
    [sym_null] = ACTIONS(3599),
    [sym_undefined] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(3601),
    [anon_sym_static] = ACTIONS(3599),
    [anon_sym_readonly] = ACTIONS(3599),
    [anon_sym_get] = ACTIONS(3599),
    [anon_sym_set] = ACTIONS(3599),
    [anon_sym_declare] = ACTIONS(3599),
    [anon_sym_namespace] = ACTIONS(3599),
    [anon_sym_public] = ACTIONS(3599),
    [anon_sym_private] = ACTIONS(3599),
    [anon_sym_protected] = ACTIONS(3599),
    [anon_sym_override] = ACTIONS(3599),
    [anon_sym_module] = ACTIONS(3599),
    [anon_sym_any] = ACTIONS(3599),
    [anon_sym_number] = ACTIONS(3599),
    [anon_sym_boolean] = ACTIONS(3599),
    [anon_sym_string] = ACTIONS(3599),
    [anon_sym_symbol] = ACTIONS(3599),
    [anon_sym_abstract] = ACTIONS(3599),
    [anon_sym_interface] = ACTIONS(3599),
    [anon_sym_enum] = ACTIONS(3599),
    [anon_sym_component] = ACTIONS(3599),
  },
  [1096] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_rest_pattern] = STATE(4228),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4098),
    [sym_optional_tuple_parameter] = STATE(4098),
    [sym_optional_type] = STATE(4098),
    [sym_rest_type] = STATE(4098),
    [sym__tuple_type_member] = STATE(4098),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_identifier] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_COMMA] = ACTIONS(3605),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(3607),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1097] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_rest_pattern] = STATE(4228),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(3922),
    [sym_optional_tuple_parameter] = STATE(3922),
    [sym_optional_type] = STATE(3922),
    [sym_rest_type] = STATE(3922),
    [sym__tuple_type_member] = STATE(3922),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_identifier] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_COMMA] = ACTIONS(3611),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(3613),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1098] = {
    [sym_identifier] = ACTIONS(3599),
    [anon_sym_export] = ACTIONS(3599),
    [anon_sym_LBRACE] = ACTIONS(3601),
    [anon_sym_type] = ACTIONS(3599),
    [anon_sym_typeof] = ACTIONS(3599),
    [anon_sym_import] = ACTIONS(3599),
    [anon_sym_var] = ACTIONS(3599),
    [anon_sym_let] = ACTIONS(3599),
    [anon_sym_const] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3601),
    [anon_sym_if] = ACTIONS(3599),
    [anon_sym_switch] = ACTIONS(3599),
    [anon_sym_for] = ACTIONS(3599),
    [anon_sym_LPAREN] = ACTIONS(3601),
    [anon_sym_await] = ACTIONS(3599),
    [anon_sym_while] = ACTIONS(3599),
    [anon_sym_do] = ACTIONS(3599),
    [anon_sym_try] = ACTIONS(3599),
    [anon_sym_with] = ACTIONS(3599),
    [anon_sym_break] = ACTIONS(3599),
    [anon_sym_continue] = ACTIONS(3599),
    [anon_sym_debugger] = ACTIONS(3599),
    [anon_sym_return] = ACTIONS(3599),
    [anon_sym_throw] = ACTIONS(3599),
    [anon_sym_SEMI] = ACTIONS(3601),
    [anon_sym_yield] = ACTIONS(3599),
    [anon_sym_LBRACK] = ACTIONS(3601),
    [anon_sym_LTtemplate_GT] = ACTIONS(3601),
    [anon_sym_LT] = ACTIONS(3599),
    [anon_sym_SLASH] = ACTIONS(3599),
    [anon_sym_class] = ACTIONS(3599),
    [anon_sym_async] = ACTIONS(3599),
    [anon_sym_function] = ACTIONS(3599),
    [anon_sym_new] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3601),
    [anon_sym_PLUS] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3601),
    [anon_sym_void] = ACTIONS(3599),
    [anon_sym_delete] = ACTIONS(3599),
    [anon_sym_PLUS_PLUS] = ACTIONS(3601),
    [anon_sym_DASH_DASH] = ACTIONS(3601),
    [anon_sym_DQUOTE] = ACTIONS(3601),
    [anon_sym_SQUOTE] = ACTIONS(3601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3601),
    [sym_number] = ACTIONS(3601),
    [sym_this] = ACTIONS(3599),
    [sym_super] = ACTIONS(3599),
    [sym_true] = ACTIONS(3599),
    [sym_false] = ACTIONS(3599),
    [sym_null] = ACTIONS(3599),
    [sym_undefined] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(3601),
    [anon_sym_static] = ACTIONS(3599),
    [anon_sym_readonly] = ACTIONS(3599),
    [anon_sym_get] = ACTIONS(3599),
    [anon_sym_set] = ACTIONS(3599),
    [anon_sym_declare] = ACTIONS(3599),
    [anon_sym_namespace] = ACTIONS(3599),
    [anon_sym_public] = ACTIONS(3599),
    [anon_sym_private] = ACTIONS(3599),
    [anon_sym_protected] = ACTIONS(3599),
    [anon_sym_override] = ACTIONS(3599),
    [anon_sym_module] = ACTIONS(3599),
    [anon_sym_any] = ACTIONS(3599),
    [anon_sym_number] = ACTIONS(3599),
    [anon_sym_boolean] = ACTIONS(3599),
    [anon_sym_string] = ACTIONS(3599),
    [anon_sym_symbol] = ACTIONS(3599),
    [anon_sym_abstract] = ACTIONS(3599),
    [anon_sym_interface] = ACTIONS(3599),
    [anon_sym_enum] = ACTIONS(3599),
    [anon_sym_component] = ACTIONS(3599),
  },
  [1099] = {
    [sym_identifier] = ACTIONS(1848),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1848),
    [anon_sym_LBRACE] = ACTIONS(1848),
    [anon_sym_RBRACE] = ACTIONS(1852),
    [anon_sym_typeof] = ACTIONS(1848),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(1932),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(1848),
    [anon_sym_async] = ACTIONS(1848),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_new] = ACTIONS(1848),
    [anon_sym_AMP_AMP] = ACTIONS(1852),
    [anon_sym_PIPE_PIPE] = ACTIONS(1852),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1852),
    [anon_sym_LT_LT] = ACTIONS(1852),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1852),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1852),
    [anon_sym_STAR_STAR] = ACTIONS(1852),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1852),
    [anon_sym_instanceof] = ACTIONS(1848),
    [anon_sym_void] = ACTIONS(1848),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [anon_sym_DQUOTE] = ACTIONS(1852),
    [anon_sym_SQUOTE] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1852),
    [sym_number] = ACTIONS(1852),
    [sym_this] = ACTIONS(1848),
    [sym_true] = ACTIONS(1848),
    [sym_false] = ACTIONS(1848),
    [sym_null] = ACTIONS(1848),
    [sym_undefined] = ACTIONS(1848),
    [anon_sym_static] = ACTIONS(1848),
    [anon_sym_readonly] = ACTIONS(1848),
    [anon_sym_QMARK] = ACTIONS(1848),
    [anon_sym_any] = ACTIONS(1848),
    [anon_sym_number] = ACTIONS(1848),
    [anon_sym_boolean] = ACTIONS(1848),
    [anon_sym_string] = ACTIONS(1848),
    [anon_sym_symbol] = ACTIONS(1848),
    [anon_sym_abstract] = ACTIONS(1848),
    [anon_sym_satisfies] = ACTIONS(1848),
    [anon_sym_infer] = ACTIONS(1848),
    [anon_sym_keyof] = ACTIONS(1848),
    [anon_sym_unknown] = ACTIONS(1848),
    [anon_sym_never] = ACTIONS(1848),
    [anon_sym_object] = ACTIONS(1848),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1852),
    [anon_sym_prop] = ACTIONS(1848),
    [anon_sym_id] = ACTIONS(1848),
    [anon_sym_event] = ACTIONS(1848),
    [anon_sym_fn] = ACTIONS(1848),
    [anon_sym_on] = ACTIONS(1848),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1100] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_rest_pattern] = STATE(4228),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4120),
    [sym_optional_tuple_parameter] = STATE(4120),
    [sym_optional_type] = STATE(4120),
    [sym_rest_type] = STATE(4120),
    [sym__tuple_type_member] = STATE(4120),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_identifier] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_COMMA] = ACTIONS(3615),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(3617),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1101] = {
    [sym_identifier] = ACTIONS(3619),
    [anon_sym_export] = ACTIONS(3619),
    [anon_sym_LBRACE] = ACTIONS(3621),
    [anon_sym_type] = ACTIONS(3619),
    [anon_sym_typeof] = ACTIONS(3619),
    [anon_sym_import] = ACTIONS(3619),
    [anon_sym_var] = ACTIONS(3619),
    [anon_sym_let] = ACTIONS(3619),
    [anon_sym_const] = ACTIONS(3619),
    [anon_sym_BANG] = ACTIONS(3621),
    [anon_sym_if] = ACTIONS(3619),
    [anon_sym_switch] = ACTIONS(3619),
    [anon_sym_for] = ACTIONS(3619),
    [anon_sym_LPAREN] = ACTIONS(3621),
    [anon_sym_await] = ACTIONS(3619),
    [anon_sym_while] = ACTIONS(3619),
    [anon_sym_do] = ACTIONS(3619),
    [anon_sym_try] = ACTIONS(3619),
    [anon_sym_with] = ACTIONS(3619),
    [anon_sym_break] = ACTIONS(3619),
    [anon_sym_continue] = ACTIONS(3619),
    [anon_sym_debugger] = ACTIONS(3619),
    [anon_sym_return] = ACTIONS(3619),
    [anon_sym_throw] = ACTIONS(3619),
    [anon_sym_SEMI] = ACTIONS(3621),
    [anon_sym_yield] = ACTIONS(3619),
    [anon_sym_LBRACK] = ACTIONS(3621),
    [anon_sym_LTtemplate_GT] = ACTIONS(3621),
    [anon_sym_LT] = ACTIONS(3619),
    [anon_sym_SLASH] = ACTIONS(3619),
    [anon_sym_class] = ACTIONS(3619),
    [anon_sym_async] = ACTIONS(3619),
    [anon_sym_function] = ACTIONS(3619),
    [anon_sym_new] = ACTIONS(3619),
    [anon_sym_AMP] = ACTIONS(3621),
    [anon_sym_PLUS] = ACTIONS(3619),
    [anon_sym_DASH] = ACTIONS(3619),
    [anon_sym_TILDE] = ACTIONS(3621),
    [anon_sym_void] = ACTIONS(3619),
    [anon_sym_delete] = ACTIONS(3619),
    [anon_sym_PLUS_PLUS] = ACTIONS(3621),
    [anon_sym_DASH_DASH] = ACTIONS(3621),
    [anon_sym_DQUOTE] = ACTIONS(3621),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3621),
    [sym_number] = ACTIONS(3621),
    [sym_this] = ACTIONS(3619),
    [sym_super] = ACTIONS(3619),
    [sym_true] = ACTIONS(3619),
    [sym_false] = ACTIONS(3619),
    [sym_null] = ACTIONS(3619),
    [sym_undefined] = ACTIONS(3619),
    [anon_sym_AT] = ACTIONS(3621),
    [anon_sym_static] = ACTIONS(3619),
    [anon_sym_readonly] = ACTIONS(3619),
    [anon_sym_get] = ACTIONS(3619),
    [anon_sym_set] = ACTIONS(3619),
    [anon_sym_declare] = ACTIONS(3619),
    [anon_sym_namespace] = ACTIONS(3619),
    [anon_sym_public] = ACTIONS(3619),
    [anon_sym_private] = ACTIONS(3619),
    [anon_sym_protected] = ACTIONS(3619),
    [anon_sym_override] = ACTIONS(3619),
    [anon_sym_module] = ACTIONS(3619),
    [anon_sym_any] = ACTIONS(3619),
    [anon_sym_number] = ACTIONS(3619),
    [anon_sym_boolean] = ACTIONS(3619),
    [anon_sym_string] = ACTIONS(3619),
    [anon_sym_symbol] = ACTIONS(3619),
    [anon_sym_abstract] = ACTIONS(3619),
    [anon_sym_interface] = ACTIONS(3619),
    [anon_sym_enum] = ACTIONS(3619),
    [anon_sym_component] = ACTIONS(3619),
  },
  [1102] = {
    [sym_identifier] = ACTIONS(2012),
    [anon_sym_export] = ACTIONS(2012),
    [anon_sym_LBRACE] = ACTIONS(2014),
    [anon_sym_type] = ACTIONS(2012),
    [anon_sym_typeof] = ACTIONS(2012),
    [anon_sym_import] = ACTIONS(2012),
    [anon_sym_var] = ACTIONS(2012),
    [anon_sym_let] = ACTIONS(2012),
    [anon_sym_const] = ACTIONS(2012),
    [anon_sym_BANG] = ACTIONS(2014),
    [anon_sym_if] = ACTIONS(2012),
    [anon_sym_switch] = ACTIONS(2012),
    [anon_sym_for] = ACTIONS(2012),
    [anon_sym_LPAREN] = ACTIONS(2014),
    [anon_sym_await] = ACTIONS(2012),
    [anon_sym_while] = ACTIONS(2012),
    [anon_sym_do] = ACTIONS(2012),
    [anon_sym_try] = ACTIONS(2012),
    [anon_sym_with] = ACTIONS(2012),
    [anon_sym_break] = ACTIONS(2012),
    [anon_sym_continue] = ACTIONS(2012),
    [anon_sym_debugger] = ACTIONS(2012),
    [anon_sym_return] = ACTIONS(2012),
    [anon_sym_throw] = ACTIONS(2012),
    [anon_sym_SEMI] = ACTIONS(2014),
    [anon_sym_yield] = ACTIONS(2012),
    [anon_sym_LBRACK] = ACTIONS(2014),
    [anon_sym_LTtemplate_GT] = ACTIONS(2014),
    [anon_sym_LT] = ACTIONS(2012),
    [anon_sym_SLASH] = ACTIONS(2012),
    [anon_sym_class] = ACTIONS(2012),
    [anon_sym_async] = ACTIONS(2012),
    [anon_sym_function] = ACTIONS(2012),
    [anon_sym_new] = ACTIONS(2012),
    [anon_sym_AMP] = ACTIONS(2014),
    [anon_sym_PLUS] = ACTIONS(2012),
    [anon_sym_DASH] = ACTIONS(2012),
    [anon_sym_TILDE] = ACTIONS(2014),
    [anon_sym_void] = ACTIONS(2012),
    [anon_sym_delete] = ACTIONS(2012),
    [anon_sym_PLUS_PLUS] = ACTIONS(2014),
    [anon_sym_DASH_DASH] = ACTIONS(2014),
    [anon_sym_DQUOTE] = ACTIONS(2014),
    [anon_sym_SQUOTE] = ACTIONS(2014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2014),
    [sym_number] = ACTIONS(2014),
    [sym_this] = ACTIONS(2012),
    [sym_super] = ACTIONS(2012),
    [sym_true] = ACTIONS(2012),
    [sym_false] = ACTIONS(2012),
    [sym_null] = ACTIONS(2012),
    [sym_undefined] = ACTIONS(2012),
    [anon_sym_AT] = ACTIONS(2014),
    [anon_sym_static] = ACTIONS(2012),
    [anon_sym_readonly] = ACTIONS(2012),
    [anon_sym_get] = ACTIONS(2012),
    [anon_sym_set] = ACTIONS(2012),
    [anon_sym_declare] = ACTIONS(2012),
    [anon_sym_namespace] = ACTIONS(2012),
    [anon_sym_public] = ACTIONS(2012),
    [anon_sym_private] = ACTIONS(2012),
    [anon_sym_protected] = ACTIONS(2012),
    [anon_sym_override] = ACTIONS(2012),
    [anon_sym_module] = ACTIONS(2012),
    [anon_sym_any] = ACTIONS(2012),
    [anon_sym_number] = ACTIONS(2012),
    [anon_sym_boolean] = ACTIONS(2012),
    [anon_sym_string] = ACTIONS(2012),
    [anon_sym_symbol] = ACTIONS(2012),
    [anon_sym_abstract] = ACTIONS(2012),
    [anon_sym_interface] = ACTIONS(2012),
    [anon_sym_enum] = ACTIONS(2012),
    [anon_sym_component] = ACTIONS(2012),
  },
  [1103] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_rest_pattern] = STATE(4228),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4019),
    [sym_optional_tuple_parameter] = STATE(4019),
    [sym_optional_type] = STATE(4019),
    [sym_rest_type] = STATE(4019),
    [sym__tuple_type_member] = STATE(4019),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_identifier] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_COMMA] = ACTIONS(3623),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(3625),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1104] = {
    [sym_identifier] = ACTIONS(3627),
    [anon_sym_export] = ACTIONS(3627),
    [anon_sym_LBRACE] = ACTIONS(3629),
    [anon_sym_type] = ACTIONS(3627),
    [anon_sym_typeof] = ACTIONS(3627),
    [anon_sym_import] = ACTIONS(3627),
    [anon_sym_var] = ACTIONS(3627),
    [anon_sym_let] = ACTIONS(3627),
    [anon_sym_const] = ACTIONS(3627),
    [anon_sym_BANG] = ACTIONS(3629),
    [anon_sym_if] = ACTIONS(3627),
    [anon_sym_switch] = ACTIONS(3627),
    [anon_sym_for] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_await] = ACTIONS(3627),
    [anon_sym_while] = ACTIONS(3627),
    [anon_sym_do] = ACTIONS(3627),
    [anon_sym_try] = ACTIONS(3627),
    [anon_sym_with] = ACTIONS(3627),
    [anon_sym_break] = ACTIONS(3627),
    [anon_sym_continue] = ACTIONS(3627),
    [anon_sym_debugger] = ACTIONS(3627),
    [anon_sym_return] = ACTIONS(3627),
    [anon_sym_throw] = ACTIONS(3627),
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym_yield] = ACTIONS(3627),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [anon_sym_LTtemplate_GT] = ACTIONS(3629),
    [anon_sym_LT] = ACTIONS(3627),
    [anon_sym_SLASH] = ACTIONS(3627),
    [anon_sym_class] = ACTIONS(3627),
    [anon_sym_async] = ACTIONS(3627),
    [anon_sym_function] = ACTIONS(3627),
    [anon_sym_new] = ACTIONS(3627),
    [anon_sym_AMP] = ACTIONS(3629),
    [anon_sym_PLUS] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(3627),
    [anon_sym_TILDE] = ACTIONS(3629),
    [anon_sym_void] = ACTIONS(3627),
    [anon_sym_delete] = ACTIONS(3627),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_DQUOTE] = ACTIONS(3629),
    [anon_sym_SQUOTE] = ACTIONS(3629),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3629),
    [sym_number] = ACTIONS(3629),
    [sym_this] = ACTIONS(3627),
    [sym_super] = ACTIONS(3627),
    [sym_true] = ACTIONS(3627),
    [sym_false] = ACTIONS(3627),
    [sym_null] = ACTIONS(3627),
    [sym_undefined] = ACTIONS(3627),
    [anon_sym_AT] = ACTIONS(3629),
    [anon_sym_static] = ACTIONS(3627),
    [anon_sym_readonly] = ACTIONS(3627),
    [anon_sym_get] = ACTIONS(3627),
    [anon_sym_set] = ACTIONS(3627),
    [anon_sym_declare] = ACTIONS(3627),
    [anon_sym_namespace] = ACTIONS(3627),
    [anon_sym_public] = ACTIONS(3627),
    [anon_sym_private] = ACTIONS(3627),
    [anon_sym_protected] = ACTIONS(3627),
    [anon_sym_override] = ACTIONS(3627),
    [anon_sym_module] = ACTIONS(3627),
    [anon_sym_any] = ACTIONS(3627),
    [anon_sym_number] = ACTIONS(3627),
    [anon_sym_boolean] = ACTIONS(3627),
    [anon_sym_string] = ACTIONS(3627),
    [anon_sym_symbol] = ACTIONS(3627),
    [anon_sym_abstract] = ACTIONS(3627),
    [anon_sym_interface] = ACTIONS(3627),
    [anon_sym_enum] = ACTIONS(3627),
    [anon_sym_component] = ACTIONS(3627),
  },
  [1105] = {
    [sym_identifier] = ACTIONS(3631),
    [anon_sym_export] = ACTIONS(3631),
    [anon_sym_LBRACE] = ACTIONS(3633),
    [anon_sym_type] = ACTIONS(3631),
    [anon_sym_typeof] = ACTIONS(3631),
    [anon_sym_import] = ACTIONS(3631),
    [anon_sym_var] = ACTIONS(3631),
    [anon_sym_let] = ACTIONS(3631),
    [anon_sym_const] = ACTIONS(3631),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_if] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3631),
    [anon_sym_for] = ACTIONS(3631),
    [anon_sym_LPAREN] = ACTIONS(3633),
    [anon_sym_await] = ACTIONS(3631),
    [anon_sym_while] = ACTIONS(3631),
    [anon_sym_do] = ACTIONS(3631),
    [anon_sym_try] = ACTIONS(3631),
    [anon_sym_with] = ACTIONS(3631),
    [anon_sym_break] = ACTIONS(3631),
    [anon_sym_continue] = ACTIONS(3631),
    [anon_sym_debugger] = ACTIONS(3631),
    [anon_sym_return] = ACTIONS(3631),
    [anon_sym_throw] = ACTIONS(3631),
    [anon_sym_SEMI] = ACTIONS(3633),
    [anon_sym_yield] = ACTIONS(3631),
    [anon_sym_LBRACK] = ACTIONS(3633),
    [anon_sym_LTtemplate_GT] = ACTIONS(3633),
    [anon_sym_LT] = ACTIONS(3631),
    [anon_sym_SLASH] = ACTIONS(3631),
    [anon_sym_class] = ACTIONS(3631),
    [anon_sym_async] = ACTIONS(3631),
    [anon_sym_function] = ACTIONS(3631),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_PLUS] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(3631),
    [anon_sym_TILDE] = ACTIONS(3633),
    [anon_sym_void] = ACTIONS(3631),
    [anon_sym_delete] = ACTIONS(3631),
    [anon_sym_PLUS_PLUS] = ACTIONS(3633),
    [anon_sym_DASH_DASH] = ACTIONS(3633),
    [anon_sym_DQUOTE] = ACTIONS(3633),
    [anon_sym_SQUOTE] = ACTIONS(3633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3633),
    [sym_number] = ACTIONS(3633),
    [sym_this] = ACTIONS(3631),
    [sym_super] = ACTIONS(3631),
    [sym_true] = ACTIONS(3631),
    [sym_false] = ACTIONS(3631),
    [sym_null] = ACTIONS(3631),
    [sym_undefined] = ACTIONS(3631),
    [anon_sym_AT] = ACTIONS(3633),
    [anon_sym_static] = ACTIONS(3631),
    [anon_sym_readonly] = ACTIONS(3631),
    [anon_sym_get] = ACTIONS(3631),
    [anon_sym_set] = ACTIONS(3631),
    [anon_sym_declare] = ACTIONS(3631),
    [anon_sym_namespace] = ACTIONS(3631),
    [anon_sym_public] = ACTIONS(3631),
    [anon_sym_private] = ACTIONS(3631),
    [anon_sym_protected] = ACTIONS(3631),
    [anon_sym_override] = ACTIONS(3631),
    [anon_sym_module] = ACTIONS(3631),
    [anon_sym_any] = ACTIONS(3631),
    [anon_sym_number] = ACTIONS(3631),
    [anon_sym_boolean] = ACTIONS(3631),
    [anon_sym_string] = ACTIONS(3631),
    [anon_sym_symbol] = ACTIONS(3631),
    [anon_sym_abstract] = ACTIONS(3631),
    [anon_sym_interface] = ACTIONS(3631),
    [anon_sym_enum] = ACTIONS(3631),
    [anon_sym_component] = ACTIONS(3631),
  },
  [1106] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_rest_pattern] = STATE(4228),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4150),
    [sym_optional_tuple_parameter] = STATE(4150),
    [sym_optional_type] = STATE(4150),
    [sym_rest_type] = STATE(4150),
    [sym__tuple_type_member] = STATE(4150),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_identifier] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_COMMA] = ACTIONS(3635),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(3637),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1107] = {
    [sym_identifier] = ACTIONS(3599),
    [anon_sym_export] = ACTIONS(3599),
    [anon_sym_LBRACE] = ACTIONS(3601),
    [anon_sym_type] = ACTIONS(3599),
    [anon_sym_typeof] = ACTIONS(3599),
    [anon_sym_import] = ACTIONS(3599),
    [anon_sym_var] = ACTIONS(3599),
    [anon_sym_let] = ACTIONS(3599),
    [anon_sym_const] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3601),
    [anon_sym_if] = ACTIONS(3599),
    [anon_sym_switch] = ACTIONS(3599),
    [anon_sym_for] = ACTIONS(3599),
    [anon_sym_LPAREN] = ACTIONS(3601),
    [anon_sym_await] = ACTIONS(3599),
    [anon_sym_while] = ACTIONS(3599),
    [anon_sym_do] = ACTIONS(3599),
    [anon_sym_try] = ACTIONS(3599),
    [anon_sym_with] = ACTIONS(3599),
    [anon_sym_break] = ACTIONS(3599),
    [anon_sym_continue] = ACTIONS(3599),
    [anon_sym_debugger] = ACTIONS(3599),
    [anon_sym_return] = ACTIONS(3599),
    [anon_sym_throw] = ACTIONS(3599),
    [anon_sym_SEMI] = ACTIONS(3601),
    [anon_sym_yield] = ACTIONS(3599),
    [anon_sym_LBRACK] = ACTIONS(3601),
    [anon_sym_LTtemplate_GT] = ACTIONS(3601),
    [anon_sym_LT] = ACTIONS(3599),
    [anon_sym_SLASH] = ACTIONS(3599),
    [anon_sym_class] = ACTIONS(3599),
    [anon_sym_async] = ACTIONS(3599),
    [anon_sym_function] = ACTIONS(3599),
    [anon_sym_new] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3601),
    [anon_sym_PLUS] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3601),
    [anon_sym_void] = ACTIONS(3599),
    [anon_sym_delete] = ACTIONS(3599),
    [anon_sym_PLUS_PLUS] = ACTIONS(3601),
    [anon_sym_DASH_DASH] = ACTIONS(3601),
    [anon_sym_DQUOTE] = ACTIONS(3601),
    [anon_sym_SQUOTE] = ACTIONS(3601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3601),
    [sym_number] = ACTIONS(3601),
    [sym_this] = ACTIONS(3599),
    [sym_super] = ACTIONS(3599),
    [sym_true] = ACTIONS(3599),
    [sym_false] = ACTIONS(3599),
    [sym_null] = ACTIONS(3599),
    [sym_undefined] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(3601),
    [anon_sym_static] = ACTIONS(3599),
    [anon_sym_readonly] = ACTIONS(3599),
    [anon_sym_get] = ACTIONS(3599),
    [anon_sym_set] = ACTIONS(3599),
    [anon_sym_declare] = ACTIONS(3599),
    [anon_sym_namespace] = ACTIONS(3599),
    [anon_sym_public] = ACTIONS(3599),
    [anon_sym_private] = ACTIONS(3599),
    [anon_sym_protected] = ACTIONS(3599),
    [anon_sym_override] = ACTIONS(3599),
    [anon_sym_module] = ACTIONS(3599),
    [anon_sym_any] = ACTIONS(3599),
    [anon_sym_number] = ACTIONS(3599),
    [anon_sym_boolean] = ACTIONS(3599),
    [anon_sym_string] = ACTIONS(3599),
    [anon_sym_symbol] = ACTIONS(3599),
    [anon_sym_abstract] = ACTIONS(3599),
    [anon_sym_interface] = ACTIONS(3599),
    [anon_sym_enum] = ACTIONS(3599),
    [anon_sym_component] = ACTIONS(3599),
  },
  [1108] = {
    [sym_identifier] = ACTIONS(3599),
    [anon_sym_export] = ACTIONS(3599),
    [anon_sym_LBRACE] = ACTIONS(3601),
    [anon_sym_type] = ACTIONS(3599),
    [anon_sym_typeof] = ACTIONS(3599),
    [anon_sym_import] = ACTIONS(3599),
    [anon_sym_var] = ACTIONS(3599),
    [anon_sym_let] = ACTIONS(3599),
    [anon_sym_const] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3601),
    [anon_sym_if] = ACTIONS(3599),
    [anon_sym_switch] = ACTIONS(3599),
    [anon_sym_for] = ACTIONS(3599),
    [anon_sym_LPAREN] = ACTIONS(3601),
    [anon_sym_await] = ACTIONS(3599),
    [anon_sym_while] = ACTIONS(3599),
    [anon_sym_do] = ACTIONS(3599),
    [anon_sym_try] = ACTIONS(3599),
    [anon_sym_with] = ACTIONS(3599),
    [anon_sym_break] = ACTIONS(3599),
    [anon_sym_continue] = ACTIONS(3599),
    [anon_sym_debugger] = ACTIONS(3599),
    [anon_sym_return] = ACTIONS(3599),
    [anon_sym_throw] = ACTIONS(3599),
    [anon_sym_SEMI] = ACTIONS(3601),
    [anon_sym_yield] = ACTIONS(3599),
    [anon_sym_LBRACK] = ACTIONS(3601),
    [anon_sym_LTtemplate_GT] = ACTIONS(3601),
    [anon_sym_LT] = ACTIONS(3599),
    [anon_sym_SLASH] = ACTIONS(3599),
    [anon_sym_class] = ACTIONS(3599),
    [anon_sym_async] = ACTIONS(3599),
    [anon_sym_function] = ACTIONS(3599),
    [anon_sym_new] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3601),
    [anon_sym_PLUS] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3601),
    [anon_sym_void] = ACTIONS(3599),
    [anon_sym_delete] = ACTIONS(3599),
    [anon_sym_PLUS_PLUS] = ACTIONS(3601),
    [anon_sym_DASH_DASH] = ACTIONS(3601),
    [anon_sym_DQUOTE] = ACTIONS(3601),
    [anon_sym_SQUOTE] = ACTIONS(3601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3601),
    [sym_number] = ACTIONS(3601),
    [sym_this] = ACTIONS(3599),
    [sym_super] = ACTIONS(3599),
    [sym_true] = ACTIONS(3599),
    [sym_false] = ACTIONS(3599),
    [sym_null] = ACTIONS(3599),
    [sym_undefined] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(3601),
    [anon_sym_static] = ACTIONS(3599),
    [anon_sym_readonly] = ACTIONS(3599),
    [anon_sym_get] = ACTIONS(3599),
    [anon_sym_set] = ACTIONS(3599),
    [anon_sym_declare] = ACTIONS(3599),
    [anon_sym_namespace] = ACTIONS(3599),
    [anon_sym_public] = ACTIONS(3599),
    [anon_sym_private] = ACTIONS(3599),
    [anon_sym_protected] = ACTIONS(3599),
    [anon_sym_override] = ACTIONS(3599),
    [anon_sym_module] = ACTIONS(3599),
    [anon_sym_any] = ACTIONS(3599),
    [anon_sym_number] = ACTIONS(3599),
    [anon_sym_boolean] = ACTIONS(3599),
    [anon_sym_string] = ACTIONS(3599),
    [anon_sym_symbol] = ACTIONS(3599),
    [anon_sym_abstract] = ACTIONS(3599),
    [anon_sym_interface] = ACTIONS(3599),
    [anon_sym_enum] = ACTIONS(3599),
    [anon_sym_component] = ACTIONS(3599),
  },
  [1109] = {
    [sym_identifier] = ACTIONS(3599),
    [anon_sym_export] = ACTIONS(3599),
    [anon_sym_LBRACE] = ACTIONS(3601),
    [anon_sym_type] = ACTIONS(3599),
    [anon_sym_typeof] = ACTIONS(3599),
    [anon_sym_import] = ACTIONS(3599),
    [anon_sym_var] = ACTIONS(3599),
    [anon_sym_let] = ACTIONS(3599),
    [anon_sym_const] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3601),
    [anon_sym_if] = ACTIONS(3599),
    [anon_sym_switch] = ACTIONS(3599),
    [anon_sym_for] = ACTIONS(3599),
    [anon_sym_LPAREN] = ACTIONS(3601),
    [anon_sym_await] = ACTIONS(3599),
    [anon_sym_while] = ACTIONS(3599),
    [anon_sym_do] = ACTIONS(3599),
    [anon_sym_try] = ACTIONS(3599),
    [anon_sym_with] = ACTIONS(3599),
    [anon_sym_break] = ACTIONS(3599),
    [anon_sym_continue] = ACTIONS(3599),
    [anon_sym_debugger] = ACTIONS(3599),
    [anon_sym_return] = ACTIONS(3599),
    [anon_sym_throw] = ACTIONS(3599),
    [anon_sym_SEMI] = ACTIONS(3601),
    [anon_sym_yield] = ACTIONS(3599),
    [anon_sym_LBRACK] = ACTIONS(3601),
    [anon_sym_LTtemplate_GT] = ACTIONS(3601),
    [anon_sym_LT] = ACTIONS(3599),
    [anon_sym_SLASH] = ACTIONS(3599),
    [anon_sym_class] = ACTIONS(3599),
    [anon_sym_async] = ACTIONS(3599),
    [anon_sym_function] = ACTIONS(3599),
    [anon_sym_new] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3601),
    [anon_sym_PLUS] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3601),
    [anon_sym_void] = ACTIONS(3599),
    [anon_sym_delete] = ACTIONS(3599),
    [anon_sym_PLUS_PLUS] = ACTIONS(3601),
    [anon_sym_DASH_DASH] = ACTIONS(3601),
    [anon_sym_DQUOTE] = ACTIONS(3601),
    [anon_sym_SQUOTE] = ACTIONS(3601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3601),
    [sym_number] = ACTIONS(3601),
    [sym_this] = ACTIONS(3599),
    [sym_super] = ACTIONS(3599),
    [sym_true] = ACTIONS(3599),
    [sym_false] = ACTIONS(3599),
    [sym_null] = ACTIONS(3599),
    [sym_undefined] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(3601),
    [anon_sym_static] = ACTIONS(3599),
    [anon_sym_readonly] = ACTIONS(3599),
    [anon_sym_get] = ACTIONS(3599),
    [anon_sym_set] = ACTIONS(3599),
    [anon_sym_declare] = ACTIONS(3599),
    [anon_sym_namespace] = ACTIONS(3599),
    [anon_sym_public] = ACTIONS(3599),
    [anon_sym_private] = ACTIONS(3599),
    [anon_sym_protected] = ACTIONS(3599),
    [anon_sym_override] = ACTIONS(3599),
    [anon_sym_module] = ACTIONS(3599),
    [anon_sym_any] = ACTIONS(3599),
    [anon_sym_number] = ACTIONS(3599),
    [anon_sym_boolean] = ACTIONS(3599),
    [anon_sym_string] = ACTIONS(3599),
    [anon_sym_symbol] = ACTIONS(3599),
    [anon_sym_abstract] = ACTIONS(3599),
    [anon_sym_interface] = ACTIONS(3599),
    [anon_sym_enum] = ACTIONS(3599),
    [anon_sym_component] = ACTIONS(3599),
  },
  [1110] = {
    [sym_identifier] = ACTIONS(3599),
    [anon_sym_export] = ACTIONS(3599),
    [anon_sym_LBRACE] = ACTIONS(3601),
    [anon_sym_type] = ACTIONS(3599),
    [anon_sym_typeof] = ACTIONS(3599),
    [anon_sym_import] = ACTIONS(3599),
    [anon_sym_var] = ACTIONS(3599),
    [anon_sym_let] = ACTIONS(3599),
    [anon_sym_const] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3601),
    [anon_sym_if] = ACTIONS(3599),
    [anon_sym_switch] = ACTIONS(3599),
    [anon_sym_for] = ACTIONS(3599),
    [anon_sym_LPAREN] = ACTIONS(3601),
    [anon_sym_await] = ACTIONS(3599),
    [anon_sym_while] = ACTIONS(3599),
    [anon_sym_do] = ACTIONS(3599),
    [anon_sym_try] = ACTIONS(3599),
    [anon_sym_with] = ACTIONS(3599),
    [anon_sym_break] = ACTIONS(3599),
    [anon_sym_continue] = ACTIONS(3599),
    [anon_sym_debugger] = ACTIONS(3599),
    [anon_sym_return] = ACTIONS(3599),
    [anon_sym_throw] = ACTIONS(3599),
    [anon_sym_SEMI] = ACTIONS(3601),
    [anon_sym_yield] = ACTIONS(3599),
    [anon_sym_LBRACK] = ACTIONS(3601),
    [anon_sym_LTtemplate_GT] = ACTIONS(3601),
    [anon_sym_LT] = ACTIONS(3599),
    [anon_sym_SLASH] = ACTIONS(3599),
    [anon_sym_class] = ACTIONS(3599),
    [anon_sym_async] = ACTIONS(3599),
    [anon_sym_function] = ACTIONS(3599),
    [anon_sym_new] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3601),
    [anon_sym_PLUS] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3601),
    [anon_sym_void] = ACTIONS(3599),
    [anon_sym_delete] = ACTIONS(3599),
    [anon_sym_PLUS_PLUS] = ACTIONS(3601),
    [anon_sym_DASH_DASH] = ACTIONS(3601),
    [anon_sym_DQUOTE] = ACTIONS(3601),
    [anon_sym_SQUOTE] = ACTIONS(3601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3601),
    [sym_number] = ACTIONS(3601),
    [sym_this] = ACTIONS(3599),
    [sym_super] = ACTIONS(3599),
    [sym_true] = ACTIONS(3599),
    [sym_false] = ACTIONS(3599),
    [sym_null] = ACTIONS(3599),
    [sym_undefined] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(3601),
    [anon_sym_static] = ACTIONS(3599),
    [anon_sym_readonly] = ACTIONS(3599),
    [anon_sym_get] = ACTIONS(3599),
    [anon_sym_set] = ACTIONS(3599),
    [anon_sym_declare] = ACTIONS(3599),
    [anon_sym_namespace] = ACTIONS(3599),
    [anon_sym_public] = ACTIONS(3599),
    [anon_sym_private] = ACTIONS(3599),
    [anon_sym_protected] = ACTIONS(3599),
    [anon_sym_override] = ACTIONS(3599),
    [anon_sym_module] = ACTIONS(3599),
    [anon_sym_any] = ACTIONS(3599),
    [anon_sym_number] = ACTIONS(3599),
    [anon_sym_boolean] = ACTIONS(3599),
    [anon_sym_string] = ACTIONS(3599),
    [anon_sym_symbol] = ACTIONS(3599),
    [anon_sym_abstract] = ACTIONS(3599),
    [anon_sym_interface] = ACTIONS(3599),
    [anon_sym_enum] = ACTIONS(3599),
    [anon_sym_component] = ACTIONS(3599),
  },
  [1111] = {
    [sym_identifier] = ACTIONS(2008),
    [anon_sym_export] = ACTIONS(2008),
    [anon_sym_LBRACE] = ACTIONS(2010),
    [anon_sym_type] = ACTIONS(2008),
    [anon_sym_typeof] = ACTIONS(2008),
    [anon_sym_import] = ACTIONS(2008),
    [anon_sym_var] = ACTIONS(2008),
    [anon_sym_let] = ACTIONS(2008),
    [anon_sym_const] = ACTIONS(2008),
    [anon_sym_BANG] = ACTIONS(2010),
    [anon_sym_if] = ACTIONS(2008),
    [anon_sym_switch] = ACTIONS(2008),
    [anon_sym_for] = ACTIONS(2008),
    [anon_sym_LPAREN] = ACTIONS(2010),
    [anon_sym_await] = ACTIONS(2008),
    [anon_sym_while] = ACTIONS(2008),
    [anon_sym_do] = ACTIONS(2008),
    [anon_sym_try] = ACTIONS(2008),
    [anon_sym_with] = ACTIONS(2008),
    [anon_sym_break] = ACTIONS(2008),
    [anon_sym_continue] = ACTIONS(2008),
    [anon_sym_debugger] = ACTIONS(2008),
    [anon_sym_return] = ACTIONS(2008),
    [anon_sym_throw] = ACTIONS(2008),
    [anon_sym_SEMI] = ACTIONS(2010),
    [anon_sym_yield] = ACTIONS(2008),
    [anon_sym_LBRACK] = ACTIONS(2010),
    [anon_sym_LTtemplate_GT] = ACTIONS(2010),
    [anon_sym_LT] = ACTIONS(2008),
    [anon_sym_SLASH] = ACTIONS(2008),
    [anon_sym_class] = ACTIONS(2008),
    [anon_sym_async] = ACTIONS(2008),
    [anon_sym_function] = ACTIONS(2008),
    [anon_sym_new] = ACTIONS(2008),
    [anon_sym_AMP] = ACTIONS(2010),
    [anon_sym_PLUS] = ACTIONS(2008),
    [anon_sym_DASH] = ACTIONS(2008),
    [anon_sym_TILDE] = ACTIONS(2010),
    [anon_sym_void] = ACTIONS(2008),
    [anon_sym_delete] = ACTIONS(2008),
    [anon_sym_PLUS_PLUS] = ACTIONS(2010),
    [anon_sym_DASH_DASH] = ACTIONS(2010),
    [anon_sym_DQUOTE] = ACTIONS(2010),
    [anon_sym_SQUOTE] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2010),
    [sym_number] = ACTIONS(2010),
    [sym_this] = ACTIONS(2008),
    [sym_super] = ACTIONS(2008),
    [sym_true] = ACTIONS(2008),
    [sym_false] = ACTIONS(2008),
    [sym_null] = ACTIONS(2008),
    [sym_undefined] = ACTIONS(2008),
    [anon_sym_AT] = ACTIONS(2010),
    [anon_sym_static] = ACTIONS(2008),
    [anon_sym_readonly] = ACTIONS(2008),
    [anon_sym_get] = ACTIONS(2008),
    [anon_sym_set] = ACTIONS(2008),
    [anon_sym_declare] = ACTIONS(2008),
    [anon_sym_namespace] = ACTIONS(2008),
    [anon_sym_public] = ACTIONS(2008),
    [anon_sym_private] = ACTIONS(2008),
    [anon_sym_protected] = ACTIONS(2008),
    [anon_sym_override] = ACTIONS(2008),
    [anon_sym_module] = ACTIONS(2008),
    [anon_sym_any] = ACTIONS(2008),
    [anon_sym_number] = ACTIONS(2008),
    [anon_sym_boolean] = ACTIONS(2008),
    [anon_sym_string] = ACTIONS(2008),
    [anon_sym_symbol] = ACTIONS(2008),
    [anon_sym_abstract] = ACTIONS(2008),
    [anon_sym_interface] = ACTIONS(2008),
    [anon_sym_enum] = ACTIONS(2008),
    [anon_sym_component] = ACTIONS(2008),
  },
  [1112] = {
    [sym_identifier] = ACTIONS(3599),
    [anon_sym_export] = ACTIONS(3599),
    [anon_sym_LBRACE] = ACTIONS(3601),
    [anon_sym_type] = ACTIONS(3599),
    [anon_sym_typeof] = ACTIONS(3599),
    [anon_sym_import] = ACTIONS(3599),
    [anon_sym_var] = ACTIONS(3599),
    [anon_sym_let] = ACTIONS(3599),
    [anon_sym_const] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3601),
    [anon_sym_if] = ACTIONS(3599),
    [anon_sym_switch] = ACTIONS(3599),
    [anon_sym_for] = ACTIONS(3599),
    [anon_sym_LPAREN] = ACTIONS(3601),
    [anon_sym_await] = ACTIONS(3599),
    [anon_sym_while] = ACTIONS(3599),
    [anon_sym_do] = ACTIONS(3599),
    [anon_sym_try] = ACTIONS(3599),
    [anon_sym_with] = ACTIONS(3599),
    [anon_sym_break] = ACTIONS(3599),
    [anon_sym_continue] = ACTIONS(3599),
    [anon_sym_debugger] = ACTIONS(3599),
    [anon_sym_return] = ACTIONS(3599),
    [anon_sym_throw] = ACTIONS(3599),
    [anon_sym_SEMI] = ACTIONS(3601),
    [anon_sym_yield] = ACTIONS(3599),
    [anon_sym_LBRACK] = ACTIONS(3601),
    [anon_sym_LTtemplate_GT] = ACTIONS(3601),
    [anon_sym_LT] = ACTIONS(3599),
    [anon_sym_SLASH] = ACTIONS(3599),
    [anon_sym_class] = ACTIONS(3599),
    [anon_sym_async] = ACTIONS(3599),
    [anon_sym_function] = ACTIONS(3599),
    [anon_sym_new] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3601),
    [anon_sym_PLUS] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3601),
    [anon_sym_void] = ACTIONS(3599),
    [anon_sym_delete] = ACTIONS(3599),
    [anon_sym_PLUS_PLUS] = ACTIONS(3601),
    [anon_sym_DASH_DASH] = ACTIONS(3601),
    [anon_sym_DQUOTE] = ACTIONS(3601),
    [anon_sym_SQUOTE] = ACTIONS(3601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3601),
    [sym_number] = ACTIONS(3601),
    [sym_this] = ACTIONS(3599),
    [sym_super] = ACTIONS(3599),
    [sym_true] = ACTIONS(3599),
    [sym_false] = ACTIONS(3599),
    [sym_null] = ACTIONS(3599),
    [sym_undefined] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(3601),
    [anon_sym_static] = ACTIONS(3599),
    [anon_sym_readonly] = ACTIONS(3599),
    [anon_sym_get] = ACTIONS(3599),
    [anon_sym_set] = ACTIONS(3599),
    [anon_sym_declare] = ACTIONS(3599),
    [anon_sym_namespace] = ACTIONS(3599),
    [anon_sym_public] = ACTIONS(3599),
    [anon_sym_private] = ACTIONS(3599),
    [anon_sym_protected] = ACTIONS(3599),
    [anon_sym_override] = ACTIONS(3599),
    [anon_sym_module] = ACTIONS(3599),
    [anon_sym_any] = ACTIONS(3599),
    [anon_sym_number] = ACTIONS(3599),
    [anon_sym_boolean] = ACTIONS(3599),
    [anon_sym_string] = ACTIONS(3599),
    [anon_sym_symbol] = ACTIONS(3599),
    [anon_sym_abstract] = ACTIONS(3599),
    [anon_sym_interface] = ACTIONS(3599),
    [anon_sym_enum] = ACTIONS(3599),
    [anon_sym_component] = ACTIONS(3599),
  },
  [1113] = {
    [sym_identifier] = ACTIONS(3599),
    [anon_sym_export] = ACTIONS(3599),
    [anon_sym_LBRACE] = ACTIONS(3601),
    [anon_sym_type] = ACTIONS(3599),
    [anon_sym_typeof] = ACTIONS(3599),
    [anon_sym_import] = ACTIONS(3599),
    [anon_sym_var] = ACTIONS(3599),
    [anon_sym_let] = ACTIONS(3599),
    [anon_sym_const] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3601),
    [anon_sym_if] = ACTIONS(3599),
    [anon_sym_switch] = ACTIONS(3599),
    [anon_sym_for] = ACTIONS(3599),
    [anon_sym_LPAREN] = ACTIONS(3601),
    [anon_sym_await] = ACTIONS(3599),
    [anon_sym_while] = ACTIONS(3599),
    [anon_sym_do] = ACTIONS(3599),
    [anon_sym_try] = ACTIONS(3599),
    [anon_sym_with] = ACTIONS(3599),
    [anon_sym_break] = ACTIONS(3599),
    [anon_sym_continue] = ACTIONS(3599),
    [anon_sym_debugger] = ACTIONS(3599),
    [anon_sym_return] = ACTIONS(3599),
    [anon_sym_throw] = ACTIONS(3599),
    [anon_sym_SEMI] = ACTIONS(3601),
    [anon_sym_yield] = ACTIONS(3599),
    [anon_sym_LBRACK] = ACTIONS(3601),
    [anon_sym_LTtemplate_GT] = ACTIONS(3601),
    [anon_sym_LT] = ACTIONS(3599),
    [anon_sym_SLASH] = ACTIONS(3599),
    [anon_sym_class] = ACTIONS(3599),
    [anon_sym_async] = ACTIONS(3599),
    [anon_sym_function] = ACTIONS(3599),
    [anon_sym_new] = ACTIONS(3599),
    [anon_sym_AMP] = ACTIONS(3601),
    [anon_sym_PLUS] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3601),
    [anon_sym_void] = ACTIONS(3599),
    [anon_sym_delete] = ACTIONS(3599),
    [anon_sym_PLUS_PLUS] = ACTIONS(3601),
    [anon_sym_DASH_DASH] = ACTIONS(3601),
    [anon_sym_DQUOTE] = ACTIONS(3601),
    [anon_sym_SQUOTE] = ACTIONS(3601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3601),
    [sym_number] = ACTIONS(3601),
    [sym_this] = ACTIONS(3599),
    [sym_super] = ACTIONS(3599),
    [sym_true] = ACTIONS(3599),
    [sym_false] = ACTIONS(3599),
    [sym_null] = ACTIONS(3599),
    [sym_undefined] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(3601),
    [anon_sym_static] = ACTIONS(3599),
    [anon_sym_readonly] = ACTIONS(3599),
    [anon_sym_get] = ACTIONS(3599),
    [anon_sym_set] = ACTIONS(3599),
    [anon_sym_declare] = ACTIONS(3599),
    [anon_sym_namespace] = ACTIONS(3599),
    [anon_sym_public] = ACTIONS(3599),
    [anon_sym_private] = ACTIONS(3599),
    [anon_sym_protected] = ACTIONS(3599),
    [anon_sym_override] = ACTIONS(3599),
    [anon_sym_module] = ACTIONS(3599),
    [anon_sym_any] = ACTIONS(3599),
    [anon_sym_number] = ACTIONS(3599),
    [anon_sym_boolean] = ACTIONS(3599),
    [anon_sym_string] = ACTIONS(3599),
    [anon_sym_symbol] = ACTIONS(3599),
    [anon_sym_abstract] = ACTIONS(3599),
    [anon_sym_interface] = ACTIONS(3599),
    [anon_sym_enum] = ACTIONS(3599),
    [anon_sym_component] = ACTIONS(3599),
  },
  [1114] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_rest_pattern] = STATE(4228),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4031),
    [sym_optional_tuple_parameter] = STATE(4031),
    [sym_optional_type] = STATE(4031),
    [sym_rest_type] = STATE(4031),
    [sym__tuple_type_member] = STATE(4031),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_identifier] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_COMMA] = ACTIONS(3639),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(3641),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1115] = {
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_as] = ACTIONS(3351),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_RBRACE] = ACTIONS(3353),
    [anon_sym_typeof] = ACTIONS(3351),
    [anon_sym_BANG] = ACTIONS(3351),
    [anon_sym_LPAREN] = ACTIONS(3353),
    [anon_sym_in] = ACTIONS(3351),
    [anon_sym_SEMI] = ACTIONS(3353),
    [anon_sym_LBRACK] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3351),
    [anon_sym_GT] = ACTIONS(3351),
    [anon_sym_SLASH] = ACTIONS(3351),
    [anon_sym_DOT] = ACTIONS(3351),
    [anon_sym_async] = ACTIONS(3351),
    [anon_sym_QMARK_DOT] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_AMP_AMP] = ACTIONS(3353),
    [anon_sym_PIPE_PIPE] = ACTIONS(3353),
    [anon_sym_GT_GT] = ACTIONS(3351),
    [anon_sym_GT_GT_GT] = ACTIONS(3353),
    [anon_sym_LT_LT] = ACTIONS(3353),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_CARET] = ACTIONS(3353),
    [anon_sym_PIPE] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_PERCENT] = ACTIONS(3353),
    [anon_sym_STAR_STAR] = ACTIONS(3353),
    [anon_sym_LT_EQ] = ACTIONS(3353),
    [anon_sym_EQ_EQ] = ACTIONS(3351),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3353),
    [anon_sym_BANG_EQ] = ACTIONS(3351),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3353),
    [anon_sym_GT_EQ] = ACTIONS(3353),
    [anon_sym_QMARK_QMARK] = ACTIONS(3353),
    [anon_sym_instanceof] = ACTIONS(3351),
    [anon_sym_void] = ACTIONS(3351),
    [anon_sym_PLUS_PLUS] = ACTIONS(3353),
    [anon_sym_DASH_DASH] = ACTIONS(3353),
    [anon_sym_DQUOTE] = ACTIONS(3353),
    [anon_sym_SQUOTE] = ACTIONS(3353),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3353),
    [sym_regex_flags] = ACTIONS(3355),
    [sym_number] = ACTIONS(3353),
    [sym_this] = ACTIONS(3351),
    [sym_true] = ACTIONS(3351),
    [sym_false] = ACTIONS(3351),
    [sym_null] = ACTIONS(3351),
    [sym_undefined] = ACTIONS(3351),
    [anon_sym_static] = ACTIONS(3351),
    [anon_sym_readonly] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3351),
    [anon_sym_any] = ACTIONS(3351),
    [anon_sym_number] = ACTIONS(3351),
    [anon_sym_boolean] = ACTIONS(3351),
    [anon_sym_string] = ACTIONS(3351),
    [anon_sym_symbol] = ACTIONS(3351),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_satisfies] = ACTIONS(3351),
    [anon_sym_infer] = ACTIONS(3351),
    [anon_sym_keyof] = ACTIONS(3351),
    [anon_sym_unknown] = ACTIONS(3351),
    [anon_sym_never] = ACTIONS(3351),
    [anon_sym_object] = ACTIONS(3351),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3353),
    [anon_sym_prop] = ACTIONS(3351),
    [anon_sym_id] = ACTIONS(3351),
    [anon_sym_event] = ACTIONS(3351),
    [anon_sym_fn] = ACTIONS(3351),
    [anon_sym_on] = ACTIONS(3351),
    [sym__ternary_qmark] = ACTIONS(3353),
  },
  [1116] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_rest_pattern] = STATE(4228),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4474),
    [sym_optional_tuple_parameter] = STATE(4474),
    [sym_optional_type] = STATE(4474),
    [sym_rest_type] = STATE(4474),
    [sym__tuple_type_member] = STATE(4474),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_identifier] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(3643),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1117] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_rest_pattern] = STATE(4228),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4474),
    [sym_optional_tuple_parameter] = STATE(4474),
    [sym_optional_type] = STATE(4474),
    [sym_rest_type] = STATE(4474),
    [sym__tuple_type_member] = STATE(4474),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_identifier] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(3645),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1118] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_rest_pattern] = STATE(4228),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4474),
    [sym_optional_tuple_parameter] = STATE(4474),
    [sym_optional_type] = STATE(4474),
    [sym_rest_type] = STATE(4474),
    [sym__tuple_type_member] = STATE(4474),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_identifier] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(3647),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1119] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_rest_pattern] = STATE(4228),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4474),
    [sym_optional_tuple_parameter] = STATE(4474),
    [sym_optional_type] = STATE(4474),
    [sym_rest_type] = STATE(4474),
    [sym__tuple_type_member] = STATE(4474),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_identifier] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(3649),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1120] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_rest_pattern] = STATE(4228),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4474),
    [sym_optional_tuple_parameter] = STATE(4474),
    [sym_optional_type] = STATE(4474),
    [sym_rest_type] = STATE(4474),
    [sym__tuple_type_member] = STATE(4474),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_identifier] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(3651),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1121] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_rest_pattern] = STATE(4228),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4474),
    [sym_optional_tuple_parameter] = STATE(4474),
    [sym_optional_type] = STATE(4474),
    [sym_rest_type] = STATE(4474),
    [sym__tuple_type_member] = STATE(4474),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_identifier] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(3653),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1122] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_rest_pattern] = STATE(4228),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4474),
    [sym_optional_tuple_parameter] = STATE(4474),
    [sym_optional_type] = STATE(4474),
    [sym_rest_type] = STATE(4474),
    [sym__tuple_type_member] = STATE(4474),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_identifier] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(3655),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1123] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_rest_pattern] = STATE(4228),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4474),
    [sym_optional_tuple_parameter] = STATE(4474),
    [sym_optional_type] = STATE(4474),
    [sym_rest_type] = STATE(4474),
    [sym__tuple_type_member] = STATE(4474),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_identifier] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(3657),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1124] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_rest_pattern] = STATE(4228),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4474),
    [sym_optional_tuple_parameter] = STATE(4474),
    [sym_optional_type] = STATE(4474),
    [sym_rest_type] = STATE(4474),
    [sym__tuple_type_member] = STATE(4474),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_identifier] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(3659),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1125] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_rest_pattern] = STATE(4228),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4474),
    [sym_optional_tuple_parameter] = STATE(4474),
    [sym_optional_type] = STATE(4474),
    [sym_rest_type] = STATE(4474),
    [sym__tuple_type_member] = STATE(4474),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_identifier] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(3661),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1126] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_rest_pattern] = STATE(4228),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4474),
    [sym_optional_tuple_parameter] = STATE(4474),
    [sym_optional_type] = STATE(4474),
    [sym_rest_type] = STATE(4474),
    [sym__tuple_type_member] = STATE(4474),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_identifier] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(3663),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1127] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_rest_pattern] = STATE(4228),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4474),
    [sym_optional_tuple_parameter] = STATE(4474),
    [sym_optional_type] = STATE(4474),
    [sym_rest_type] = STATE(4474),
    [sym__tuple_type_member] = STATE(4474),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_identifier] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(3665),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1128] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_rest_pattern] = STATE(4228),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3407),
    [sym_tuple_parameter] = STATE(4474),
    [sym_optional_tuple_parameter] = STATE(4474),
    [sym_optional_type] = STATE(4474),
    [sym_rest_type] = STATE(4474),
    [sym__tuple_type_member] = STATE(4474),
    [sym_constructor_type] = STATE(3407),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3407),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3407),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3407),
    [sym_identifier] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1129] = {
    [sym_component_identifier] = STATE(3493),
    [sym_new_component_body] = STATE(1960),
    [sym_tagged_type_string] = STATE(2108),
    [sym_tripple_tagged_type_string] = STATE(2109),
    [aux_sym_object_repeat1] = STATE(4053),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_COMMA] = ACTIONS(1852),
    [anon_sym_RBRACE] = ACTIONS(1879),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(3669),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(3672),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3677),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3682),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3684),
    [sym__automatic_semicolon] = ACTIONS(1852),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1130] = {
    [sym_component_identifier] = STATE(3493),
    [sym_new_component_body] = STATE(1960),
    [sym_tagged_type_string] = STATE(2108),
    [sym_tripple_tagged_type_string] = STATE(2109),
    [aux_sym_object_repeat1] = STATE(3936),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_COMMA] = ACTIONS(1852),
    [anon_sym_RBRACE] = ACTIONS(1926),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(3669),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(3672),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3677),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3682),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3684),
    [sym__automatic_semicolon] = ACTIONS(1852),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1131] = {
    [sym_component_identifier] = STATE(3493),
    [sym_new_component_body] = STATE(1960),
    [sym_tagged_type_string] = STATE(2108),
    [sym_tripple_tagged_type_string] = STATE(2109),
    [aux_sym_object_repeat1] = STATE(3990),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_COMMA] = ACTIONS(1852),
    [anon_sym_RBRACE] = ACTIONS(1930),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(3669),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(3672),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3677),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3682),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3684),
    [sym__automatic_semicolon] = ACTIONS(1852),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1132] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_type_narrow] = STATE(4237),
    [sym_identifier] = ACTIONS(3686),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_async] = ACTIONS(3688),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
    [anon_sym_prop] = ACTIONS(3690),
    [anon_sym_fn] = ACTIONS(3692),
  },
  [1133] = {
    [sym_component_identifier] = STATE(3493),
    [sym_new_component_body] = STATE(1960),
    [sym_tagged_type_string] = STATE(2108),
    [sym_tripple_tagged_type_string] = STATE(2109),
    [aux_sym_object_repeat1] = STATE(3936),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_COMMA] = ACTIONS(1852),
    [anon_sym_RBRACE] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(3669),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(3672),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(3674),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3677),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3682),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3684),
    [sym__automatic_semicolon] = ACTIONS(1852),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1134] = {
    [sym_arguments] = STATE(2877),
    [sym_component_identifier] = STATE(3375),
    [sym_new_component_body] = STATE(1721),
    [sym_tagged_type_string] = STATE(1832),
    [sym_tripple_tagged_type_string] = STATE(1831),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(2830),
    [anon_sym_RBRACE] = ACTIONS(2830),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(3696),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(2830),
    [anon_sym_EQ] = ACTIONS(1854),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3698),
    [anon_sym_EQ_GT] = ACTIONS(3700),
    [anon_sym_QMARK_DOT] = ACTIONS(3702),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(2828),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(2828),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3704),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_extends] = ACTIONS(2830),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2830),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1868),
    [sym__automatic_semicolon] = ACTIONS(2830),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1135] = {
    [sym_type_arguments] = STATE(3013),
    [sym_component_identifier] = STATE(3375),
    [sym_new_component_body] = STATE(1721),
    [sym_tagged_type_string] = STATE(1832),
    [sym_tripple_tagged_type_string] = STATE(1831),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(3706),
    [anon_sym_RBRACE] = ACTIONS(3706),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_EQ] = ACTIONS(3710),
    [anon_sym_LBRACK] = ACTIONS(3713),
    [anon_sym_LT] = ACTIONS(3716),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3719),
    [anon_sym_EQ_GT] = ACTIONS(3700),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3704),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_extends] = ACTIONS(2590),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2590),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1868),
    [sym__automatic_semicolon] = ACTIONS(2590),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1136] = {
    [sym_type_annotation] = STATE(4339),
    [sym_type_arguments] = STATE(2752),
    [sym_component_identifier] = STATE(3375),
    [sym_new_component_body] = STATE(1721),
    [sym_tagged_type_string] = STATE(1832),
    [sym_tripple_tagged_type_string] = STATE(1831),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(3706),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_COLON] = ACTIONS(3725),
    [anon_sym_EQ] = ACTIONS(3710),
    [anon_sym_LBRACK] = ACTIONS(3713),
    [anon_sym_RBRACK] = ACTIONS(3706),
    [anon_sym_LT] = ACTIONS(3727),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3730),
    [anon_sym_EQ_GT] = ACTIONS(3700),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3704),
    [anon_sym_QMARK] = ACTIONS(3733),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_extends] = ACTIONS(2590),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1868),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1137] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_type_narrow] = STATE(4418),
    [sym_property_expression_initializer] = STATE(1538),
    [sym_identifier] = ACTIONS(3686),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_EQ] = ACTIONS(3736),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1138] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_type_narrow] = STATE(4510),
    [sym_identifier] = ACTIONS(3686),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_COLON] = ACTIONS(3738),
    [anon_sym_EQ] = ACTIONS(3740),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1139] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(3311),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(3311),
    [sym_predefined_type] = STATE(3311),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3311),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_type_narrow] = STATE(4377),
    [sym_identifier] = ACTIONS(3686),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_COLON] = ACTIONS(3742),
    [anon_sym_EQ] = ACTIONS(3744),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1140] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3315),
    [sym_constructor_type] = STATE(3315),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3315),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_predicate] = STATE(4433),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(3046),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3315),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3315),
    [sym_identifier] = ACTIONS(3746),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(3754),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_asserts] = ACTIONS(3762),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1141] = {
    [sym_nested_identifier] = STATE(633),
    [sym_string] = STATE(702),
    [sym__module] = STATE(723),
    [aux_sym_object_repeat1] = STATE(4053),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1879),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(3768),
    [anon_sym_SQUOTE] = ACTIONS(3770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [1142] = {
    [sym_nested_identifier] = STATE(633),
    [sym_string] = STATE(702),
    [sym__module] = STATE(723),
    [aux_sym_object_repeat1] = STATE(3936),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1926),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(3768),
    [anon_sym_SQUOTE] = ACTIONS(3770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [1143] = {
    [sym_nested_identifier] = STATE(633),
    [sym_string] = STATE(702),
    [sym__module] = STATE(723),
    [aux_sym_object_repeat1] = STATE(3990),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1930),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(3768),
    [anon_sym_SQUOTE] = ACTIONS(3770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [1144] = {
    [sym_nested_identifier] = STATE(633),
    [sym_string] = STATE(702),
    [sym__module] = STATE(718),
    [aux_sym_object_repeat1] = STATE(3990),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1930),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(3768),
    [anon_sym_SQUOTE] = ACTIONS(3770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [1145] = {
    [sym_identifier] = ACTIONS(3218),
    [anon_sym_export] = ACTIONS(3218),
    [anon_sym_LBRACE] = ACTIONS(3220),
    [anon_sym_COMMA] = ACTIONS(3220),
    [anon_sym_RBRACE] = ACTIONS(3220),
    [anon_sym_type] = ACTIONS(3218),
    [anon_sym_typeof] = ACTIONS(3218),
    [anon_sym_import] = ACTIONS(3218),
    [anon_sym_BANG] = ACTIONS(3220),
    [anon_sym_LPAREN] = ACTIONS(3220),
    [anon_sym_RPAREN] = ACTIONS(3220),
    [anon_sym_await] = ACTIONS(3218),
    [anon_sym_COLON] = ACTIONS(3220),
    [anon_sym_yield] = ACTIONS(3218),
    [anon_sym_EQ] = ACTIONS(3218),
    [anon_sym_LBRACK] = ACTIONS(3220),
    [anon_sym_RBRACK] = ACTIONS(3220),
    [anon_sym_LTtemplate_GT] = ACTIONS(3220),
    [anon_sym_LT] = ACTIONS(3218),
    [anon_sym_GT] = ACTIONS(3220),
    [anon_sym_SLASH] = ACTIONS(3218),
    [anon_sym_class] = ACTIONS(3218),
    [anon_sym_async] = ACTIONS(3218),
    [anon_sym_function] = ACTIONS(3218),
    [anon_sym_EQ_GT] = ACTIONS(3220),
    [anon_sym_new] = ACTIONS(3218),
    [anon_sym_AMP] = ACTIONS(3220),
    [anon_sym_PIPE] = ACTIONS(3220),
    [anon_sym_PLUS] = ACTIONS(3218),
    [anon_sym_DASH] = ACTIONS(3218),
    [anon_sym_TILDE] = ACTIONS(3220),
    [anon_sym_void] = ACTIONS(3218),
    [anon_sym_delete] = ACTIONS(3218),
    [anon_sym_PLUS_PLUS] = ACTIONS(3220),
    [anon_sym_DASH_DASH] = ACTIONS(3220),
    [anon_sym_DQUOTE] = ACTIONS(3220),
    [anon_sym_SQUOTE] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3220),
    [sym_number] = ACTIONS(3220),
    [sym_this] = ACTIONS(3218),
    [sym_super] = ACTIONS(3218),
    [sym_true] = ACTIONS(3218),
    [sym_false] = ACTIONS(3218),
    [sym_null] = ACTIONS(3218),
    [sym_undefined] = ACTIONS(3218),
    [anon_sym_AT] = ACTIONS(3220),
    [anon_sym_static] = ACTIONS(3218),
    [anon_sym_readonly] = ACTIONS(3218),
    [anon_sym_get] = ACTIONS(3218),
    [anon_sym_set] = ACTIONS(3218),
    [anon_sym_QMARK] = ACTIONS(3220),
    [anon_sym_declare] = ACTIONS(3218),
    [anon_sym_namespace] = ACTIONS(3218),
    [anon_sym_public] = ACTIONS(3218),
    [anon_sym_private] = ACTIONS(3218),
    [anon_sym_protected] = ACTIONS(3218),
    [anon_sym_override] = ACTIONS(3218),
    [anon_sym_module] = ACTIONS(3218),
    [anon_sym_any] = ACTIONS(3218),
    [anon_sym_number] = ACTIONS(3218),
    [anon_sym_boolean] = ACTIONS(3218),
    [anon_sym_string] = ACTIONS(3218),
    [anon_sym_symbol] = ACTIONS(3218),
    [anon_sym_extends] = ACTIONS(3218),
    [anon_sym_implements] = ACTIONS(3218),
    [anon_sym_component] = ACTIONS(3218),
  },
  [1146] = {
    [sym_nested_identifier] = STATE(633),
    [sym_string] = STATE(702),
    [sym__module] = STATE(723),
    [aux_sym_object_repeat1] = STATE(3936),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(3768),
    [anon_sym_SQUOTE] = ACTIONS(3770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [1147] = {
    [sym_identifier] = ACTIONS(3298),
    [anon_sym_export] = ACTIONS(3298),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_COMMA] = ACTIONS(3300),
    [anon_sym_RBRACE] = ACTIONS(3300),
    [anon_sym_type] = ACTIONS(3298),
    [anon_sym_typeof] = ACTIONS(3298),
    [anon_sym_import] = ACTIONS(3298),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3300),
    [anon_sym_RPAREN] = ACTIONS(3300),
    [anon_sym_await] = ACTIONS(3298),
    [anon_sym_COLON] = ACTIONS(3300),
    [anon_sym_yield] = ACTIONS(3298),
    [anon_sym_EQ] = ACTIONS(3298),
    [anon_sym_LBRACK] = ACTIONS(3300),
    [anon_sym_RBRACK] = ACTIONS(3300),
    [anon_sym_LTtemplate_GT] = ACTIONS(3300),
    [anon_sym_LT] = ACTIONS(3298),
    [anon_sym_GT] = ACTIONS(3300),
    [anon_sym_SLASH] = ACTIONS(3298),
    [anon_sym_class] = ACTIONS(3298),
    [anon_sym_async] = ACTIONS(3298),
    [anon_sym_function] = ACTIONS(3298),
    [anon_sym_EQ_GT] = ACTIONS(3300),
    [anon_sym_new] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_PIPE] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3298),
    [anon_sym_DASH] = ACTIONS(3298),
    [anon_sym_TILDE] = ACTIONS(3300),
    [anon_sym_void] = ACTIONS(3298),
    [anon_sym_delete] = ACTIONS(3298),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_DQUOTE] = ACTIONS(3300),
    [anon_sym_SQUOTE] = ACTIONS(3300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3300),
    [sym_number] = ACTIONS(3300),
    [sym_this] = ACTIONS(3298),
    [sym_super] = ACTIONS(3298),
    [sym_true] = ACTIONS(3298),
    [sym_false] = ACTIONS(3298),
    [sym_null] = ACTIONS(3298),
    [sym_undefined] = ACTIONS(3298),
    [anon_sym_AT] = ACTIONS(3300),
    [anon_sym_static] = ACTIONS(3298),
    [anon_sym_readonly] = ACTIONS(3298),
    [anon_sym_get] = ACTIONS(3298),
    [anon_sym_set] = ACTIONS(3298),
    [anon_sym_QMARK] = ACTIONS(3300),
    [anon_sym_declare] = ACTIONS(3298),
    [anon_sym_namespace] = ACTIONS(3298),
    [anon_sym_public] = ACTIONS(3298),
    [anon_sym_private] = ACTIONS(3298),
    [anon_sym_protected] = ACTIONS(3298),
    [anon_sym_override] = ACTIONS(3298),
    [anon_sym_module] = ACTIONS(3298),
    [anon_sym_any] = ACTIONS(3298),
    [anon_sym_number] = ACTIONS(3298),
    [anon_sym_boolean] = ACTIONS(3298),
    [anon_sym_string] = ACTIONS(3298),
    [anon_sym_symbol] = ACTIONS(3298),
    [anon_sym_extends] = ACTIONS(3298),
    [anon_sym_implements] = ACTIONS(3298),
    [anon_sym_component] = ACTIONS(3298),
  },
  [1148] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3123),
    [sym_constructor_type] = STATE(3123),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3123),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_predicate] = STATE(3500),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3031),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3123),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3123),
    [sym_identifier] = ACTIONS(3772),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(3778),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_asserts] = ACTIONS(3780),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1149] = {
    [sym_identifier] = ACTIONS(3198),
    [anon_sym_export] = ACTIONS(3198),
    [anon_sym_LBRACE] = ACTIONS(3200),
    [anon_sym_COMMA] = ACTIONS(3200),
    [anon_sym_RBRACE] = ACTIONS(3200),
    [anon_sym_type] = ACTIONS(3198),
    [anon_sym_typeof] = ACTIONS(3198),
    [anon_sym_import] = ACTIONS(3198),
    [anon_sym_BANG] = ACTIONS(3200),
    [anon_sym_LPAREN] = ACTIONS(3200),
    [anon_sym_RPAREN] = ACTIONS(3200),
    [anon_sym_await] = ACTIONS(3198),
    [anon_sym_COLON] = ACTIONS(3200),
    [anon_sym_yield] = ACTIONS(3198),
    [anon_sym_EQ] = ACTIONS(3198),
    [anon_sym_LBRACK] = ACTIONS(3200),
    [anon_sym_RBRACK] = ACTIONS(3200),
    [anon_sym_LTtemplate_GT] = ACTIONS(3200),
    [anon_sym_LT] = ACTIONS(3198),
    [anon_sym_GT] = ACTIONS(3200),
    [anon_sym_SLASH] = ACTIONS(3198),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_async] = ACTIONS(3198),
    [anon_sym_function] = ACTIONS(3198),
    [anon_sym_EQ_GT] = ACTIONS(3200),
    [anon_sym_new] = ACTIONS(3198),
    [anon_sym_AMP] = ACTIONS(3200),
    [anon_sym_PIPE] = ACTIONS(3200),
    [anon_sym_PLUS] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3198),
    [anon_sym_TILDE] = ACTIONS(3200),
    [anon_sym_void] = ACTIONS(3198),
    [anon_sym_delete] = ACTIONS(3198),
    [anon_sym_PLUS_PLUS] = ACTIONS(3200),
    [anon_sym_DASH_DASH] = ACTIONS(3200),
    [anon_sym_DQUOTE] = ACTIONS(3200),
    [anon_sym_SQUOTE] = ACTIONS(3200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3200),
    [sym_number] = ACTIONS(3200),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(3198),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(3200),
    [anon_sym_static] = ACTIONS(3198),
    [anon_sym_readonly] = ACTIONS(3198),
    [anon_sym_get] = ACTIONS(3198),
    [anon_sym_set] = ACTIONS(3198),
    [anon_sym_QMARK] = ACTIONS(3200),
    [anon_sym_declare] = ACTIONS(3198),
    [anon_sym_namespace] = ACTIONS(3198),
    [anon_sym_public] = ACTIONS(3198),
    [anon_sym_private] = ACTIONS(3198),
    [anon_sym_protected] = ACTIONS(3198),
    [anon_sym_override] = ACTIONS(3198),
    [anon_sym_module] = ACTIONS(3198),
    [anon_sym_any] = ACTIONS(3198),
    [anon_sym_number] = ACTIONS(3198),
    [anon_sym_boolean] = ACTIONS(3198),
    [anon_sym_string] = ACTIONS(3198),
    [anon_sym_symbol] = ACTIONS(3198),
    [anon_sym_extends] = ACTIONS(3198),
    [anon_sym_implements] = ACTIONS(3198),
    [anon_sym_component] = ACTIONS(3198),
  },
  [1150] = {
    [sym_nested_identifier] = STATE(633),
    [sym_string] = STATE(702),
    [sym__module] = STATE(718),
    [aux_sym_object_repeat1] = STATE(3936),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(3768),
    [anon_sym_SQUOTE] = ACTIONS(3770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [1151] = {
    [sym_component_identifier] = STATE(3375),
    [sym_new_component_body] = STATE(1721),
    [sym_tagged_type_string] = STATE(1832),
    [sym_tripple_tagged_type_string] = STATE(1831),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(3782),
    [anon_sym_RBRACE] = ACTIONS(3782),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_RPAREN] = ACTIONS(3782),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_COLON] = ACTIONS(3782),
    [anon_sym_EQ] = ACTIONS(3710),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_RBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3677),
    [anon_sym_EQ_GT] = ACTIONS(3700),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3704),
    [anon_sym_QMARK] = ACTIONS(3787),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1868),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1152] = {
    [sym_nested_identifier] = STATE(4619),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4579),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3182),
    [sym_constructor_type] = STATE(3182),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3182),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_predicate] = STATE(3500),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3024),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4402),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3182),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3182),
    [sym_identifier] = ACTIONS(3789),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3791),
    [anon_sym_AMP] = ACTIONS(3793),
    [anon_sym_PIPE] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(3797),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(3799),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(3803),
    [anon_sym_asserts] = ACTIONS(3805),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(3807),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1153] = {
    [sym_type_arguments] = STATE(2752),
    [sym_component_identifier] = STATE(3375),
    [sym_new_component_body] = STATE(1721),
    [sym_tagged_type_string] = STATE(1832),
    [sym_tripple_tagged_type_string] = STATE(1831),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(3782),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_RPAREN] = ACTIONS(3809),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_COLON] = ACTIONS(3782),
    [anon_sym_EQ] = ACTIONS(3710),
    [anon_sym_LBRACK] = ACTIONS(3713),
    [anon_sym_LT] = ACTIONS(3727),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3730),
    [anon_sym_EQ_GT] = ACTIONS(3700),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3704),
    [anon_sym_QMARK] = ACTIONS(3787),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_extends] = ACTIONS(2590),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1868),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1154] = {
    [sym_type_arguments] = STATE(2752),
    [sym_component_identifier] = STATE(3375),
    [sym_new_component_body] = STATE(1721),
    [sym_tagged_type_string] = STATE(1832),
    [sym_tripple_tagged_type_string] = STATE(1831),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_RPAREN] = ACTIONS(3706),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_COLON] = ACTIONS(3784),
    [anon_sym_EQ] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3713),
    [anon_sym_LT] = ACTIONS(3727),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3730),
    [anon_sym_EQ_GT] = ACTIONS(3815),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3704),
    [anon_sym_QMARK] = ACTIONS(3787),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_extends] = ACTIONS(2590),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1868),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1155] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3264),
    [sym_constructor_type] = STATE(3264),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3264),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_predicate] = STATE(4433),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2946),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3264),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3264),
    [sym_identifier] = ACTIONS(3817),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(3819),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_asserts] = ACTIONS(3821),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1156] = {
    [sym_nested_identifier] = STATE(4639),
    [sym_string] = STATE(3150),
    [sym_formal_parameters] = STATE(4801),
    [sym_nested_type_identifier] = STATE(2986),
    [sym__type] = STATE(3207),
    [sym_constructor_type] = STATE(3207),
    [sym__primary_type] = STATE(3156),
    [sym_template_literal_type] = STATE(3157),
    [sym_infer_type] = STATE(3207),
    [sym_conditional_type] = STATE(3157),
    [sym_generic_type] = STATE(3157),
    [sym_type_predicate] = STATE(3706),
    [sym_type_query] = STATE(3157),
    [sym_index_type_query] = STATE(3157),
    [sym_lookup_type] = STATE(3157),
    [sym_literal_type] = STATE(3157),
    [sym__number] = STATE(3158),
    [sym_existential_type] = STATE(3157),
    [sym_flow_maybe_type] = STATE(3157),
    [sym_parenthesized_type] = STATE(3157),
    [sym_predefined_type] = STATE(3057),
    [sym_object_type] = STATE(3157),
    [sym_type_parameters] = STATE(4371),
    [sym_array_type] = STATE(3157),
    [sym_tuple_type] = STATE(3157),
    [sym_readonly_type] = STATE(3207),
    [sym_union_type] = STATE(3157),
    [sym_intersection_type] = STATE(3157),
    [sym_function_type] = STATE(3207),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_LBRACE] = ACTIONS(3827),
    [anon_sym_typeof] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(3833),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3839),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_void] = ACTIONS(3843),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3849),
    [sym_number] = ACTIONS(3851),
    [sym_this] = ACTIONS(3853),
    [sym_true] = ACTIONS(3855),
    [sym_false] = ACTIONS(3855),
    [sym_null] = ACTIONS(3855),
    [sym_undefined] = ACTIONS(3855),
    [anon_sym_readonly] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_any] = ACTIONS(3843),
    [anon_sym_number] = ACTIONS(3843),
    [anon_sym_boolean] = ACTIONS(3843),
    [anon_sym_string] = ACTIONS(3843),
    [anon_sym_symbol] = ACTIONS(3843),
    [anon_sym_abstract] = ACTIONS(3861),
    [anon_sym_asserts] = ACTIONS(3863),
    [anon_sym_infer] = ACTIONS(3865),
    [anon_sym_keyof] = ACTIONS(3867),
    [anon_sym_unknown] = ACTIONS(3843),
    [anon_sym_never] = ACTIONS(3843),
    [anon_sym_object] = ACTIONS(3843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3869),
  },
  [1157] = {
    [sym_nested_identifier] = STATE(633),
    [sym_string] = STATE(702),
    [sym__module] = STATE(718),
    [aux_sym_object_repeat1] = STATE(3936),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1926),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(3768),
    [anon_sym_SQUOTE] = ACTIONS(3770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [1158] = {
    [sym_component_identifier] = STATE(3375),
    [sym_new_component_body] = STATE(1721),
    [sym_tagged_type_string] = STATE(1832),
    [sym_tripple_tagged_type_string] = STATE(1831),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(3871),
    [anon_sym_RBRACE] = ACTIONS(3871),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_RPAREN] = ACTIONS(3871),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_COLON] = ACTIONS(3871),
    [anon_sym_EQ] = ACTIONS(1854),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_RBRACK] = ACTIONS(3871),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3677),
    [anon_sym_EQ_GT] = ACTIONS(3700),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3704),
    [anon_sym_QMARK] = ACTIONS(3873),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1868),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1159] = {
    [sym_nested_identifier] = STATE(633),
    [sym_string] = STATE(702),
    [sym__module] = STATE(718),
    [aux_sym_object_repeat1] = STATE(4053),
    [aux_sym_object_pattern_repeat1] = STATE(3933),
    [sym_identifier] = ACTIONS(3766),
    [anon_sym_STAR] = ACTIONS(25),
    [anon_sym_as] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(1879),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_in] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_COLON] = ACTIONS(1894),
    [anon_sym_EQ] = ACTIONS(1897),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(25),
    [anon_sym_SLASH] = ACTIONS(25),
    [anon_sym_DOT] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(1908),
    [anon_sym_QMARK_DOT] = ACTIONS(65),
    [anon_sym_PLUS_EQ] = ACTIONS(69),
    [anon_sym_DASH_EQ] = ACTIONS(69),
    [anon_sym_STAR_EQ] = ACTIONS(69),
    [anon_sym_SLASH_EQ] = ACTIONS(69),
    [anon_sym_PERCENT_EQ] = ACTIONS(69),
    [anon_sym_CARET_EQ] = ACTIONS(69),
    [anon_sym_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(69),
    [anon_sym_LT_LT_EQ] = ACTIONS(69),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(69),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(69),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(69),
    [anon_sym_AMP_AMP] = ACTIONS(25),
    [anon_sym_PIPE_PIPE] = ACTIONS(25),
    [anon_sym_GT_GT] = ACTIONS(25),
    [anon_sym_GT_GT_GT] = ACTIONS(25),
    [anon_sym_LT_LT] = ACTIONS(25),
    [anon_sym_AMP] = ACTIONS(25),
    [anon_sym_CARET] = ACTIONS(25),
    [anon_sym_PIPE] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PERCENT] = ACTIONS(25),
    [anon_sym_STAR_STAR] = ACTIONS(25),
    [anon_sym_LT_EQ] = ACTIONS(65),
    [anon_sym_EQ_EQ] = ACTIONS(25),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(65),
    [anon_sym_BANG_EQ] = ACTIONS(25),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(65),
    [anon_sym_GT_EQ] = ACTIONS(65),
    [anon_sym_QMARK_QMARK] = ACTIONS(25),
    [anon_sym_instanceof] = ACTIONS(25),
    [anon_sym_PLUS_PLUS] = ACTIONS(65),
    [anon_sym_DASH_DASH] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(3768),
    [anon_sym_SQUOTE] = ACTIONS(3770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_QMARK] = ACTIONS(1910),
    [anon_sym_satisfies] = ACTIONS(25),
    [sym__automatic_semicolon] = ACTIONS(65),
    [sym__ternary_qmark] = ACTIONS(65),
  },
  [1160] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3047),
    [sym_constructor_type] = STATE(3047),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3047),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_predicate] = STATE(3008),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3031),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3047),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3047),
    [sym_identifier] = ACTIONS(3772),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(3778),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1161] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3683),
    [sym_constructor_type] = STATE(3683),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3683),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3683),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3683),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(3875),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1162] = {
    [sym_arguments] = STATE(2741),
    [sym_component_identifier] = STATE(3375),
    [sym_new_component_body] = STATE(1721),
    [sym_tagged_type_string] = STATE(1832),
    [sym_tripple_tagged_type_string] = STATE(1831),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(2830),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(3877),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_EQ] = ACTIONS(1854),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_RBRACK] = ACTIONS(2830),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3879),
    [anon_sym_EQ_GT] = ACTIONS(3700),
    [anon_sym_QMARK_DOT] = ACTIONS(3881),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(2828),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(2828),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3704),
    [anon_sym_QMARK] = ACTIONS(2828),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_extends] = ACTIONS(2830),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1868),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1163] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(2992),
    [sym_constructor_type] = STATE(2992),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(2992),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_predicate] = STATE(2790),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2946),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(2992),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(2992),
    [sym_identifier] = ACTIONS(3817),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(3819),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1164] = {
    [sym_nested_identifier] = STATE(4603),
    [sym_string] = STATE(938),
    [sym_formal_parameters] = STATE(4595),
    [sym_nested_type_identifier] = STATE(786),
    [sym__type] = STATE(894),
    [sym_constructor_type] = STATE(894),
    [sym__primary_type] = STATE(925),
    [sym_template_literal_type] = STATE(911),
    [sym_infer_type] = STATE(894),
    [sym_conditional_type] = STATE(911),
    [sym_generic_type] = STATE(911),
    [sym_type_predicate] = STATE(887),
    [sym_type_query] = STATE(911),
    [sym_index_type_query] = STATE(911),
    [sym_lookup_type] = STATE(911),
    [sym_literal_type] = STATE(911),
    [sym__number] = STATE(899),
    [sym_existential_type] = STATE(911),
    [sym_flow_maybe_type] = STATE(911),
    [sym_parenthesized_type] = STATE(911),
    [sym_predefined_type] = STATE(815),
    [sym_object_type] = STATE(911),
    [sym_type_parameters] = STATE(4495),
    [sym_array_type] = STATE(911),
    [sym_tuple_type] = STATE(911),
    [sym_readonly_type] = STATE(894),
    [sym_union_type] = STATE(911),
    [sym_intersection_type] = STATE(911),
    [sym_function_type] = STATE(894),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3891),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3897),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3901),
    [anon_sym_DASH] = ACTIONS(3901),
    [anon_sym_void] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3905),
    [sym_number] = ACTIONS(3907),
    [sym_this] = ACTIONS(3909),
    [sym_true] = ACTIONS(3911),
    [sym_false] = ACTIONS(3911),
    [sym_null] = ACTIONS(3911),
    [sym_undefined] = ACTIONS(3911),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3903),
    [anon_sym_number] = ACTIONS(3903),
    [anon_sym_boolean] = ACTIONS(3903),
    [anon_sym_string] = ACTIONS(3903),
    [anon_sym_symbol] = ACTIONS(3903),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3919),
    [anon_sym_keyof] = ACTIONS(3921),
    [anon_sym_unknown] = ACTIONS(3903),
    [anon_sym_never] = ACTIONS(3903),
    [anon_sym_object] = ACTIONS(3903),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
  },
  [1165] = {
    [sym_type_arguments] = STATE(2752),
    [sym_component_identifier] = STATE(3375),
    [sym_new_component_body] = STATE(1721),
    [sym_tagged_type_string] = STATE(1832),
    [sym_tripple_tagged_type_string] = STATE(1831),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_COLON] = ACTIONS(3871),
    [anon_sym_EQ] = ACTIONS(1854),
    [anon_sym_LBRACK] = ACTIONS(3713),
    [anon_sym_RBRACK] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3727),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3730),
    [anon_sym_EQ_GT] = ACTIONS(3700),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3704),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_extends] = ACTIONS(2590),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1868),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1166] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4859),
    [sym_nested_type_identifier] = STATE(3193),
    [sym__type] = STATE(3506),
    [sym_constructor_type] = STATE(3506),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3506),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_predicate] = STATE(2800),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(3322),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4172),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3506),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3506),
    [sym_identifier] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_PIPE] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(3937),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3939),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3943),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3945),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1167] = {
    [sym_type_arguments] = STATE(2752),
    [sym_component_identifier] = STATE(3375),
    [sym_new_component_body] = STATE(1721),
    [sym_tagged_type_string] = STATE(1832),
    [sym_tripple_tagged_type_string] = STATE(1831),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_COLON] = ACTIONS(3871),
    [anon_sym_EQ] = ACTIONS(1854),
    [anon_sym_LBRACK] = ACTIONS(3713),
    [anon_sym_RBRACK] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(3727),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3730),
    [anon_sym_EQ_GT] = ACTIONS(3700),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3704),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_extends] = ACTIONS(2590),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1868),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1168] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3683),
    [sym_constructor_type] = STATE(3683),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3683),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3683),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3683),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(3947),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1169] = {
    [sym_nested_identifier] = STATE(4559),
    [sym_string] = STATE(1693),
    [sym_formal_parameters] = STATE(4819),
    [sym_nested_type_identifier] = STATE(1628),
    [sym__type] = STATE(1671),
    [sym_constructor_type] = STATE(1671),
    [sym__primary_type] = STATE(1647),
    [sym_template_literal_type] = STATE(1697),
    [sym_infer_type] = STATE(1671),
    [sym_conditional_type] = STATE(1697),
    [sym_generic_type] = STATE(1697),
    [sym_type_predicate] = STATE(1670),
    [sym_type_query] = STATE(1697),
    [sym_index_type_query] = STATE(1697),
    [sym_lookup_type] = STATE(1697),
    [sym_literal_type] = STATE(1697),
    [sym__number] = STATE(1699),
    [sym_existential_type] = STATE(1697),
    [sym_flow_maybe_type] = STATE(1697),
    [sym_parenthesized_type] = STATE(1697),
    [sym_predefined_type] = STATE(1630),
    [sym_object_type] = STATE(1697),
    [sym_type_parameters] = STATE(4263),
    [sym_array_type] = STATE(1697),
    [sym_tuple_type] = STATE(1697),
    [sym_readonly_type] = STATE(1671),
    [sym_union_type] = STATE(1697),
    [sym_intersection_type] = STATE(1697),
    [sym_function_type] = STATE(1671),
    [sym_identifier] = ACTIONS(3949),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_typeof] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_void] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3971),
    [sym_number] = ACTIONS(3973),
    [sym_this] = ACTIONS(3975),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [sym_null] = ACTIONS(3977),
    [sym_undefined] = ACTIONS(3977),
    [anon_sym_readonly] = ACTIONS(3979),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_any] = ACTIONS(3969),
    [anon_sym_number] = ACTIONS(3969),
    [anon_sym_boolean] = ACTIONS(3969),
    [anon_sym_string] = ACTIONS(3969),
    [anon_sym_symbol] = ACTIONS(3969),
    [anon_sym_abstract] = ACTIONS(3983),
    [anon_sym_infer] = ACTIONS(3985),
    [anon_sym_keyof] = ACTIONS(3987),
    [anon_sym_unknown] = ACTIONS(3969),
    [anon_sym_never] = ACTIONS(3969),
    [anon_sym_object] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3989),
  },
  [1170] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3683),
    [sym_constructor_type] = STATE(3683),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3683),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3683),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3683),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(3991),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1171] = {
    [sym_nested_identifier] = STATE(4603),
    [sym_string] = STATE(938),
    [sym_formal_parameters] = STATE(4595),
    [sym_nested_type_identifier] = STATE(786),
    [sym__type] = STATE(923),
    [sym_constructor_type] = STATE(923),
    [sym__primary_type] = STATE(925),
    [sym_template_literal_type] = STATE(911),
    [sym_infer_type] = STATE(923),
    [sym_conditional_type] = STATE(911),
    [sym_generic_type] = STATE(911),
    [sym_type_predicate] = STATE(924),
    [sym_type_query] = STATE(911),
    [sym_index_type_query] = STATE(911),
    [sym_lookup_type] = STATE(911),
    [sym_literal_type] = STATE(911),
    [sym__number] = STATE(899),
    [sym_existential_type] = STATE(911),
    [sym_flow_maybe_type] = STATE(911),
    [sym_parenthesized_type] = STATE(911),
    [sym_predefined_type] = STATE(815),
    [sym_object_type] = STATE(911),
    [sym_type_parameters] = STATE(4495),
    [sym_array_type] = STATE(911),
    [sym_tuple_type] = STATE(911),
    [sym_readonly_type] = STATE(923),
    [sym_union_type] = STATE(911),
    [sym_intersection_type] = STATE(911),
    [sym_function_type] = STATE(923),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3891),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3897),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3901),
    [anon_sym_DASH] = ACTIONS(3901),
    [anon_sym_void] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3905),
    [sym_number] = ACTIONS(3907),
    [sym_this] = ACTIONS(3909),
    [sym_true] = ACTIONS(3911),
    [sym_false] = ACTIONS(3911),
    [sym_null] = ACTIONS(3911),
    [sym_undefined] = ACTIONS(3911),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3903),
    [anon_sym_number] = ACTIONS(3903),
    [anon_sym_boolean] = ACTIONS(3903),
    [anon_sym_string] = ACTIONS(3903),
    [anon_sym_symbol] = ACTIONS(3903),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3919),
    [anon_sym_keyof] = ACTIONS(3921),
    [anon_sym_unknown] = ACTIONS(3903),
    [anon_sym_never] = ACTIONS(3903),
    [anon_sym_object] = ACTIONS(3903),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
  },
  [1172] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3875),
    [sym_constructor_type] = STATE(3875),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3875),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3875),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3875),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1173] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4859),
    [sym_nested_type_identifier] = STATE(3193),
    [sym__type] = STATE(3516),
    [sym_constructor_type] = STATE(3516),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3516),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_predicate] = STATE(2790),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(3322),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4172),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3516),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3516),
    [sym_identifier] = ACTIONS(3929),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_PIPE] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(3937),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3939),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3943),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3945),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1174] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3090),
    [sym_constructor_type] = STATE(3090),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3090),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_predicate] = STATE(2993),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3031),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3090),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3090),
    [sym_identifier] = ACTIONS(3772),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(3778),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1175] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3843),
    [sym_constructor_type] = STATE(3843),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3843),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3843),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3843),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(3995),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1176] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3883),
    [sym_constructor_type] = STATE(3883),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3883),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3883),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3883),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(3997),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1177] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3785),
    [sym_constructor_type] = STATE(3785),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3785),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3785),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3785),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(3999),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1178] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3683),
    [sym_constructor_type] = STATE(3683),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3683),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3683),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3683),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(4001),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1179] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3683),
    [sym_constructor_type] = STATE(3683),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3683),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3683),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3683),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(4003),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1180] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3440),
    [sym_constructor_type] = STATE(3440),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3440),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_type_parameter] = STATE(4018),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3440),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3440),
    [sym_identifier] = ACTIONS(4005),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1181] = {
    [sym_nested_identifier] = STATE(4619),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4579),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3077),
    [sym_constructor_type] = STATE(3077),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3077),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_predicate] = STATE(2993),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3024),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4402),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3077),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3077),
    [sym_identifier] = ACTIONS(3789),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3791),
    [anon_sym_AMP] = ACTIONS(3793),
    [anon_sym_PIPE] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(3797),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(3799),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(3803),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(3807),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1182] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3797),
    [sym_constructor_type] = STATE(3797),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3797),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3797),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3797),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(4007),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1183] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3683),
    [sym_constructor_type] = STATE(3683),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3683),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3683),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3683),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(4009),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1184] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3683),
    [sym_constructor_type] = STATE(3683),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3683),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3683),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3683),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(4011),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1185] = {
    [sym_nested_identifier] = STATE(4619),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4579),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3081),
    [sym_constructor_type] = STATE(3081),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3081),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_predicate] = STATE(3008),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3024),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4402),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3081),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3081),
    [sym_identifier] = ACTIONS(3789),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3791),
    [anon_sym_AMP] = ACTIONS(3793),
    [anon_sym_PIPE] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(3797),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(3799),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(3803),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(3807),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1186] = {
    [sym_arguments] = STATE(2741),
    [sym_component_identifier] = STATE(3375),
    [sym_new_component_body] = STATE(1721),
    [sym_tagged_type_string] = STATE(1832),
    [sym_tripple_tagged_type_string] = STATE(1831),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(1852),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(3877),
    [anon_sym_RPAREN] = ACTIONS(2830),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_COLON] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(4013),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3879),
    [anon_sym_EQ_GT] = ACTIONS(3815),
    [anon_sym_QMARK_DOT] = ACTIONS(3881),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(2828),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(2828),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3704),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_extends] = ACTIONS(2830),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1868),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1187] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3683),
    [sym_constructor_type] = STATE(3683),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3683),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3683),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3683),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(4015),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1188] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3683),
    [sym_constructor_type] = STATE(3683),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3683),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3683),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3683),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(4017),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1189] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3683),
    [sym_constructor_type] = STATE(3683),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3683),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3683),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3683),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(4019),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1190] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3038),
    [sym_constructor_type] = STATE(3038),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3038),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_predicate] = STATE(2800),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2946),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3038),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3038),
    [sym_identifier] = ACTIONS(3817),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(3819),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1191] = {
    [sym_nested_identifier] = STATE(4559),
    [sym_string] = STATE(1693),
    [sym_formal_parameters] = STATE(4819),
    [sym_nested_type_identifier] = STATE(1628),
    [sym__type] = STATE(1710),
    [sym_constructor_type] = STATE(1710),
    [sym__primary_type] = STATE(1647),
    [sym_template_literal_type] = STATE(1697),
    [sym_infer_type] = STATE(1710),
    [sym_conditional_type] = STATE(1697),
    [sym_generic_type] = STATE(1697),
    [sym_type_predicate] = STATE(1709),
    [sym_type_query] = STATE(1697),
    [sym_index_type_query] = STATE(1697),
    [sym_lookup_type] = STATE(1697),
    [sym_literal_type] = STATE(1697),
    [sym__number] = STATE(1699),
    [sym_existential_type] = STATE(1697),
    [sym_flow_maybe_type] = STATE(1697),
    [sym_parenthesized_type] = STATE(1697),
    [sym_predefined_type] = STATE(1630),
    [sym_object_type] = STATE(1697),
    [sym_type_parameters] = STATE(4263),
    [sym_array_type] = STATE(1697),
    [sym_tuple_type] = STATE(1697),
    [sym_readonly_type] = STATE(1710),
    [sym_union_type] = STATE(1697),
    [sym_intersection_type] = STATE(1697),
    [sym_function_type] = STATE(1710),
    [sym_identifier] = ACTIONS(3949),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_typeof] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_void] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3971),
    [sym_number] = ACTIONS(3973),
    [sym_this] = ACTIONS(3975),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [sym_null] = ACTIONS(3977),
    [sym_undefined] = ACTIONS(3977),
    [anon_sym_readonly] = ACTIONS(3979),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_any] = ACTIONS(3969),
    [anon_sym_number] = ACTIONS(3969),
    [anon_sym_boolean] = ACTIONS(3969),
    [anon_sym_string] = ACTIONS(3969),
    [anon_sym_symbol] = ACTIONS(3969),
    [anon_sym_abstract] = ACTIONS(3983),
    [anon_sym_infer] = ACTIONS(3985),
    [anon_sym_keyof] = ACTIONS(3987),
    [anon_sym_unknown] = ACTIONS(3969),
    [anon_sym_never] = ACTIONS(3969),
    [anon_sym_object] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3989),
  },
  [1192] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3683),
    [sym_constructor_type] = STATE(3683),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3683),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3683),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3683),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1193] = {
    [sym_nested_identifier] = STATE(4633),
    [sym_string] = STATE(1972),
    [sym_formal_parameters] = STATE(4675),
    [sym_nested_type_identifier] = STATE(1862),
    [sym__type] = STATE(2045),
    [sym_constructor_type] = STATE(2045),
    [sym__primary_type] = STATE(1965),
    [sym_template_literal_type] = STATE(1964),
    [sym_infer_type] = STATE(2045),
    [sym_conditional_type] = STATE(1964),
    [sym_generic_type] = STATE(1964),
    [sym_type_predicate] = STATE(2046),
    [sym_type_query] = STATE(1964),
    [sym_index_type_query] = STATE(1964),
    [sym_lookup_type] = STATE(1964),
    [sym_literal_type] = STATE(1964),
    [sym__number] = STATE(1961),
    [sym_existential_type] = STATE(1964),
    [sym_flow_maybe_type] = STATE(1964),
    [sym_parenthesized_type] = STATE(1964),
    [sym_predefined_type] = STATE(1878),
    [sym_object_type] = STATE(1964),
    [sym_type_parameters] = STATE(4387),
    [sym_array_type] = STATE(1964),
    [sym_tuple_type] = STATE(1964),
    [sym_readonly_type] = STATE(2045),
    [sym_union_type] = STATE(1964),
    [sym_intersection_type] = STATE(1964),
    [sym_function_type] = STATE(2045),
    [sym_identifier] = ACTIONS(4023),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_LBRACE] = ACTIONS(4027),
    [anon_sym_typeof] = ACTIONS(4029),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(4037),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4041),
    [anon_sym_void] = ACTIONS(4043),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [sym_number] = ACTIONS(4047),
    [sym_this] = ACTIONS(4049),
    [sym_true] = ACTIONS(4051),
    [sym_false] = ACTIONS(4051),
    [sym_null] = ACTIONS(4051),
    [sym_undefined] = ACTIONS(4051),
    [anon_sym_readonly] = ACTIONS(4053),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_any] = ACTIONS(4043),
    [anon_sym_number] = ACTIONS(4043),
    [anon_sym_boolean] = ACTIONS(4043),
    [anon_sym_string] = ACTIONS(4043),
    [anon_sym_symbol] = ACTIONS(4043),
    [anon_sym_abstract] = ACTIONS(4057),
    [anon_sym_infer] = ACTIONS(4059),
    [anon_sym_keyof] = ACTIONS(4061),
    [anon_sym_unknown] = ACTIONS(4043),
    [anon_sym_never] = ACTIONS(4043),
    [anon_sym_object] = ACTIONS(4043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4063),
  },
  [1194] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3683),
    [sym_constructor_type] = STATE(3683),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3683),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3683),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3683),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(4065),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1195] = {
    [sym_arguments] = STATE(2741),
    [sym_component_identifier] = STATE(3375),
    [sym_new_component_body] = STATE(1721),
    [sym_tagged_type_string] = STATE(1832),
    [sym_tripple_tagged_type_string] = STATE(1831),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(1852),
    [anon_sym_RBRACE] = ACTIONS(2830),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(3877),
    [anon_sym_RPAREN] = ACTIONS(2830),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_EQ] = ACTIONS(1854),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3879),
    [anon_sym_EQ_GT] = ACTIONS(3700),
    [anon_sym_QMARK_DOT] = ACTIONS(3881),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(2828),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(2828),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3704),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_extends] = ACTIONS(2830),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1868),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1196] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3069),
    [sym_constructor_type] = STATE(3069),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3069),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_predicate] = STATE(2790),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(3046),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3069),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3069),
    [sym_identifier] = ACTIONS(3746),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(3754),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1197] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3683),
    [sym_constructor_type] = STATE(3683),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3683),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3683),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3683),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(4067),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1198] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3683),
    [sym_constructor_type] = STATE(3683),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3683),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3683),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3683),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1199] = {
    [sym_nested_identifier] = STATE(4639),
    [sym_string] = STATE(3150),
    [sym_formal_parameters] = STATE(4801),
    [sym_nested_type_identifier] = STATE(2986),
    [sym__type] = STATE(3183),
    [sym_constructor_type] = STATE(3183),
    [sym__primary_type] = STATE(3156),
    [sym_template_literal_type] = STATE(3157),
    [sym_infer_type] = STATE(3183),
    [sym_conditional_type] = STATE(3157),
    [sym_generic_type] = STATE(3157),
    [sym_type_predicate] = STATE(3096),
    [sym_type_query] = STATE(3157),
    [sym_index_type_query] = STATE(3157),
    [sym_lookup_type] = STATE(3157),
    [sym_literal_type] = STATE(3157),
    [sym__number] = STATE(3158),
    [sym_existential_type] = STATE(3157),
    [sym_flow_maybe_type] = STATE(3157),
    [sym_parenthesized_type] = STATE(3157),
    [sym_predefined_type] = STATE(3057),
    [sym_object_type] = STATE(3157),
    [sym_type_parameters] = STATE(4371),
    [sym_array_type] = STATE(3157),
    [sym_tuple_type] = STATE(3157),
    [sym_readonly_type] = STATE(3183),
    [sym_union_type] = STATE(3157),
    [sym_intersection_type] = STATE(3157),
    [sym_function_type] = STATE(3183),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_LBRACE] = ACTIONS(3827),
    [anon_sym_typeof] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(3833),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3839),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_void] = ACTIONS(3843),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3849),
    [sym_number] = ACTIONS(3851),
    [sym_this] = ACTIONS(3853),
    [sym_true] = ACTIONS(3855),
    [sym_false] = ACTIONS(3855),
    [sym_null] = ACTIONS(3855),
    [sym_undefined] = ACTIONS(3855),
    [anon_sym_readonly] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_any] = ACTIONS(3843),
    [anon_sym_number] = ACTIONS(3843),
    [anon_sym_boolean] = ACTIONS(3843),
    [anon_sym_string] = ACTIONS(3843),
    [anon_sym_symbol] = ACTIONS(3843),
    [anon_sym_abstract] = ACTIONS(3861),
    [anon_sym_infer] = ACTIONS(3865),
    [anon_sym_keyof] = ACTIONS(3867),
    [anon_sym_unknown] = ACTIONS(3843),
    [anon_sym_never] = ACTIONS(3843),
    [anon_sym_object] = ACTIONS(3843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3869),
  },
  [1200] = {
    [sym_nested_identifier] = STATE(4639),
    [sym_string] = STATE(3150),
    [sym_formal_parameters] = STATE(4801),
    [sym_nested_type_identifier] = STATE(2986),
    [sym__type] = STATE(3129),
    [sym_constructor_type] = STATE(3129),
    [sym__primary_type] = STATE(3156),
    [sym_template_literal_type] = STATE(3157),
    [sym_infer_type] = STATE(3129),
    [sym_conditional_type] = STATE(3157),
    [sym_generic_type] = STATE(3157),
    [sym_type_predicate] = STATE(3125),
    [sym_type_query] = STATE(3157),
    [sym_index_type_query] = STATE(3157),
    [sym_lookup_type] = STATE(3157),
    [sym_literal_type] = STATE(3157),
    [sym__number] = STATE(3158),
    [sym_existential_type] = STATE(3157),
    [sym_flow_maybe_type] = STATE(3157),
    [sym_parenthesized_type] = STATE(3157),
    [sym_predefined_type] = STATE(3057),
    [sym_object_type] = STATE(3157),
    [sym_type_parameters] = STATE(4371),
    [sym_array_type] = STATE(3157),
    [sym_tuple_type] = STATE(3157),
    [sym_readonly_type] = STATE(3129),
    [sym_union_type] = STATE(3157),
    [sym_intersection_type] = STATE(3157),
    [sym_function_type] = STATE(3129),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_LBRACE] = ACTIONS(3827),
    [anon_sym_typeof] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(3833),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3839),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_void] = ACTIONS(3843),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3849),
    [sym_number] = ACTIONS(3851),
    [sym_this] = ACTIONS(3853),
    [sym_true] = ACTIONS(3855),
    [sym_false] = ACTIONS(3855),
    [sym_null] = ACTIONS(3855),
    [sym_undefined] = ACTIONS(3855),
    [anon_sym_readonly] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_any] = ACTIONS(3843),
    [anon_sym_number] = ACTIONS(3843),
    [anon_sym_boolean] = ACTIONS(3843),
    [anon_sym_string] = ACTIONS(3843),
    [anon_sym_symbol] = ACTIONS(3843),
    [anon_sym_abstract] = ACTIONS(3861),
    [anon_sym_infer] = ACTIONS(3865),
    [anon_sym_keyof] = ACTIONS(3867),
    [anon_sym_unknown] = ACTIONS(3843),
    [anon_sym_never] = ACTIONS(3843),
    [anon_sym_object] = ACTIONS(3843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3869),
  },
  [1201] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3731),
    [sym_constructor_type] = STATE(3731),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3731),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3731),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3731),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_RBRACK] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1202] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3074),
    [sym_constructor_type] = STATE(3074),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3074),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_predicate] = STATE(2800),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(3046),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3074),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3074),
    [sym_identifier] = ACTIONS(3746),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(3754),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1203] = {
    [sym_nested_identifier] = STATE(4633),
    [sym_string] = STATE(1972),
    [sym_formal_parameters] = STATE(4675),
    [sym_nested_type_identifier] = STATE(1862),
    [sym__type] = STATE(1921),
    [sym_constructor_type] = STATE(1921),
    [sym__primary_type] = STATE(1965),
    [sym_template_literal_type] = STATE(1964),
    [sym_infer_type] = STATE(1921),
    [sym_conditional_type] = STATE(1964),
    [sym_generic_type] = STATE(1964),
    [sym_type_predicate] = STATE(1923),
    [sym_type_query] = STATE(1964),
    [sym_index_type_query] = STATE(1964),
    [sym_lookup_type] = STATE(1964),
    [sym_literal_type] = STATE(1964),
    [sym__number] = STATE(1961),
    [sym_existential_type] = STATE(1964),
    [sym_flow_maybe_type] = STATE(1964),
    [sym_parenthesized_type] = STATE(1964),
    [sym_predefined_type] = STATE(1878),
    [sym_object_type] = STATE(1964),
    [sym_type_parameters] = STATE(4387),
    [sym_array_type] = STATE(1964),
    [sym_tuple_type] = STATE(1964),
    [sym_readonly_type] = STATE(1921),
    [sym_union_type] = STATE(1964),
    [sym_intersection_type] = STATE(1964),
    [sym_function_type] = STATE(1921),
    [sym_identifier] = ACTIONS(4023),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_LBRACE] = ACTIONS(4027),
    [anon_sym_typeof] = ACTIONS(4029),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(4037),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4041),
    [anon_sym_void] = ACTIONS(4043),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [sym_number] = ACTIONS(4047),
    [sym_this] = ACTIONS(4049),
    [sym_true] = ACTIONS(4051),
    [sym_false] = ACTIONS(4051),
    [sym_null] = ACTIONS(4051),
    [sym_undefined] = ACTIONS(4051),
    [anon_sym_readonly] = ACTIONS(4053),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_any] = ACTIONS(4043),
    [anon_sym_number] = ACTIONS(4043),
    [anon_sym_boolean] = ACTIONS(4043),
    [anon_sym_string] = ACTIONS(4043),
    [anon_sym_symbol] = ACTIONS(4043),
    [anon_sym_abstract] = ACTIONS(4057),
    [anon_sym_infer] = ACTIONS(4059),
    [anon_sym_keyof] = ACTIONS(4061),
    [anon_sym_unknown] = ACTIONS(4043),
    [anon_sym_never] = ACTIONS(4043),
    [anon_sym_object] = ACTIONS(4043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4063),
  },
  [1204] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4859),
    [sym_nested_type_identifier] = STATE(3193),
    [sym__type] = STATE(2798),
    [sym_constructor_type] = STATE(2798),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(2798),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4172),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(2798),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(2798),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_PIPE] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3939),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3943),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3945),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1205] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3943),
    [sym_constructor_type] = STATE(3943),
    [sym__primary_type] = STATE(2801),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3943),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3943),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3943),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1206] = {
    [sym_nested_identifier] = STATE(4559),
    [sym_string] = STATE(1693),
    [sym_formal_parameters] = STATE(4819),
    [sym_nested_type_identifier] = STATE(1628),
    [sym__type] = STATE(1708),
    [sym_constructor_type] = STATE(1708),
    [sym__primary_type] = STATE(1647),
    [sym_template_literal_type] = STATE(1697),
    [sym_infer_type] = STATE(1708),
    [sym_conditional_type] = STATE(1697),
    [sym_generic_type] = STATE(1697),
    [sym_type_query] = STATE(1697),
    [sym_index_type_query] = STATE(1697),
    [sym_lookup_type] = STATE(1697),
    [sym_literal_type] = STATE(1697),
    [sym__number] = STATE(1699),
    [sym_existential_type] = STATE(1697),
    [sym_flow_maybe_type] = STATE(1697),
    [sym_parenthesized_type] = STATE(1697),
    [sym_predefined_type] = STATE(1697),
    [sym_object_type] = STATE(1697),
    [sym_type_parameters] = STATE(4263),
    [sym_array_type] = STATE(1697),
    [sym_tuple_type] = STATE(1697),
    [sym_readonly_type] = STATE(1708),
    [sym_union_type] = STATE(1697),
    [sym_intersection_type] = STATE(1697),
    [sym_function_type] = STATE(1708),
    [sym_identifier] = ACTIONS(4077),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_typeof] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_void] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3971),
    [sym_number] = ACTIONS(3973),
    [sym_this] = ACTIONS(4079),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [sym_null] = ACTIONS(3977),
    [sym_undefined] = ACTIONS(3977),
    [anon_sym_readonly] = ACTIONS(3979),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_any] = ACTIONS(3969),
    [anon_sym_number] = ACTIONS(3969),
    [anon_sym_boolean] = ACTIONS(3969),
    [anon_sym_string] = ACTIONS(3969),
    [anon_sym_symbol] = ACTIONS(3969),
    [anon_sym_abstract] = ACTIONS(3983),
    [anon_sym_infer] = ACTIONS(3985),
    [anon_sym_keyof] = ACTIONS(3987),
    [anon_sym_unknown] = ACTIONS(3969),
    [anon_sym_never] = ACTIONS(3969),
    [anon_sym_object] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3989),
  },
  [1207] = {
    [sym_nested_identifier] = STATE(4633),
    [sym_string] = STATE(1972),
    [sym_formal_parameters] = STATE(4675),
    [sym_nested_type_identifier] = STATE(1862),
    [sym__type] = STATE(1887),
    [sym_constructor_type] = STATE(1887),
    [sym__primary_type] = STATE(1965),
    [sym_template_literal_type] = STATE(1964),
    [sym_infer_type] = STATE(1887),
    [sym_conditional_type] = STATE(1964),
    [sym_generic_type] = STATE(1964),
    [sym_type_query] = STATE(1964),
    [sym_index_type_query] = STATE(1964),
    [sym_lookup_type] = STATE(1964),
    [sym_literal_type] = STATE(1964),
    [sym__number] = STATE(1961),
    [sym_existential_type] = STATE(1964),
    [sym_flow_maybe_type] = STATE(1964),
    [sym_parenthesized_type] = STATE(1964),
    [sym_predefined_type] = STATE(1964),
    [sym_object_type] = STATE(1964),
    [sym_type_parameters] = STATE(4387),
    [sym_array_type] = STATE(1964),
    [sym_tuple_type] = STATE(1964),
    [sym_readonly_type] = STATE(1887),
    [sym_union_type] = STATE(1964),
    [sym_intersection_type] = STATE(1964),
    [sym_function_type] = STATE(1887),
    [sym_identifier] = ACTIONS(4081),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_LBRACE] = ACTIONS(4027),
    [anon_sym_typeof] = ACTIONS(4029),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(4037),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4041),
    [anon_sym_void] = ACTIONS(4043),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [sym_number] = ACTIONS(4047),
    [sym_this] = ACTIONS(4083),
    [sym_true] = ACTIONS(4051),
    [sym_false] = ACTIONS(4051),
    [sym_null] = ACTIONS(4051),
    [sym_undefined] = ACTIONS(4051),
    [anon_sym_readonly] = ACTIONS(4053),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_any] = ACTIONS(4043),
    [anon_sym_number] = ACTIONS(4043),
    [anon_sym_boolean] = ACTIONS(4043),
    [anon_sym_string] = ACTIONS(4043),
    [anon_sym_symbol] = ACTIONS(4043),
    [anon_sym_abstract] = ACTIONS(4057),
    [anon_sym_infer] = ACTIONS(4059),
    [anon_sym_keyof] = ACTIONS(4061),
    [anon_sym_unknown] = ACTIONS(4043),
    [anon_sym_never] = ACTIONS(4043),
    [anon_sym_object] = ACTIONS(4043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4063),
  },
  [1208] = {
    [sym_nested_identifier] = STATE(4633),
    [sym_string] = STATE(1972),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(1862),
    [sym__type] = STATE(4015),
    [sym_constructor_type] = STATE(4015),
    [sym__primary_type] = STATE(2025),
    [sym_template_literal_type] = STATE(1964),
    [sym_infer_type] = STATE(4015),
    [sym_conditional_type] = STATE(1964),
    [sym_generic_type] = STATE(1964),
    [sym_type_query] = STATE(1964),
    [sym_index_type_query] = STATE(1964),
    [sym_lookup_type] = STATE(1964),
    [sym_literal_type] = STATE(1964),
    [sym__number] = STATE(1961),
    [sym_existential_type] = STATE(1964),
    [sym_flow_maybe_type] = STATE(1964),
    [sym_parenthesized_type] = STATE(1964),
    [sym_predefined_type] = STATE(1964),
    [sym_object_type] = STATE(1964),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(1964),
    [sym_tuple_type] = STATE(1964),
    [sym_readonly_type] = STATE(4015),
    [sym_union_type] = STATE(1964),
    [sym_intersection_type] = STATE(1964),
    [sym_function_type] = STATE(4015),
    [sym_identifier] = ACTIONS(4081),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_LBRACE] = ACTIONS(4027),
    [anon_sym_typeof] = ACTIONS(4029),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(4037),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4041),
    [anon_sym_void] = ACTIONS(4043),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [sym_number] = ACTIONS(4047),
    [sym_this] = ACTIONS(4083),
    [sym_true] = ACTIONS(4051),
    [sym_false] = ACTIONS(4051),
    [sym_null] = ACTIONS(4051),
    [sym_undefined] = ACTIONS(4051),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_any] = ACTIONS(4043),
    [anon_sym_number] = ACTIONS(4043),
    [anon_sym_boolean] = ACTIONS(4043),
    [anon_sym_string] = ACTIONS(4043),
    [anon_sym_symbol] = ACTIONS(4043),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(4061),
    [anon_sym_unknown] = ACTIONS(4043),
    [anon_sym_never] = ACTIONS(4043),
    [anon_sym_object] = ACTIONS(4043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4063),
  },
  [1209] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3732),
    [sym_constructor_type] = STATE(3732),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3732),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3732),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3732),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1210] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3401),
    [sym_constructor_type] = STATE(3401),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3401),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3401),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3401),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1211] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3752),
    [sym_constructor_type] = STATE(3752),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3752),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3752),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3752),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1212] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(3527),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3866),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1213] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3766),
    [sym_constructor_type] = STATE(3766),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3766),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3766),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3766),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1214] = {
    [sym_nested_identifier] = STATE(4633),
    [sym_string] = STATE(1972),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(1862),
    [sym__type] = STATE(4015),
    [sym_constructor_type] = STATE(4015),
    [sym__primary_type] = STATE(1932),
    [sym_template_literal_type] = STATE(1964),
    [sym_infer_type] = STATE(4015),
    [sym_conditional_type] = STATE(1964),
    [sym_generic_type] = STATE(1964),
    [sym_type_query] = STATE(1964),
    [sym_index_type_query] = STATE(1964),
    [sym_lookup_type] = STATE(1964),
    [sym_literal_type] = STATE(1964),
    [sym__number] = STATE(1961),
    [sym_existential_type] = STATE(1964),
    [sym_flow_maybe_type] = STATE(1964),
    [sym_parenthesized_type] = STATE(1964),
    [sym_predefined_type] = STATE(1964),
    [sym_object_type] = STATE(1964),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(1964),
    [sym_tuple_type] = STATE(1964),
    [sym_readonly_type] = STATE(4015),
    [sym_union_type] = STATE(1964),
    [sym_intersection_type] = STATE(1964),
    [sym_function_type] = STATE(4015),
    [sym_identifier] = ACTIONS(4081),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_LBRACE] = ACTIONS(4027),
    [anon_sym_typeof] = ACTIONS(4029),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(4037),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4041),
    [anon_sym_void] = ACTIONS(4043),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [sym_number] = ACTIONS(4047),
    [sym_this] = ACTIONS(4083),
    [sym_true] = ACTIONS(4051),
    [sym_false] = ACTIONS(4051),
    [sym_null] = ACTIONS(4051),
    [sym_undefined] = ACTIONS(4051),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_any] = ACTIONS(4043),
    [anon_sym_number] = ACTIONS(4043),
    [anon_sym_boolean] = ACTIONS(4043),
    [anon_sym_string] = ACTIONS(4043),
    [anon_sym_symbol] = ACTIONS(4043),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(4061),
    [anon_sym_unknown] = ACTIONS(4043),
    [anon_sym_never] = ACTIONS(4043),
    [anon_sym_object] = ACTIONS(4043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4063),
  },
  [1215] = {
    [sym_nested_identifier] = STATE(4633),
    [sym_string] = STATE(1972),
    [sym_formal_parameters] = STATE(4675),
    [sym_nested_type_identifier] = STATE(1862),
    [sym__type] = STATE(1901),
    [sym_constructor_type] = STATE(1901),
    [sym__primary_type] = STATE(1965),
    [sym_template_literal_type] = STATE(1964),
    [sym_infer_type] = STATE(1901),
    [sym_conditional_type] = STATE(1964),
    [sym_generic_type] = STATE(1964),
    [sym_type_query] = STATE(1964),
    [sym_index_type_query] = STATE(1964),
    [sym_lookup_type] = STATE(1964),
    [sym_literal_type] = STATE(1964),
    [sym__number] = STATE(1961),
    [sym_existential_type] = STATE(1964),
    [sym_flow_maybe_type] = STATE(1964),
    [sym_parenthesized_type] = STATE(1964),
    [sym_predefined_type] = STATE(1964),
    [sym_object_type] = STATE(1964),
    [sym_type_parameters] = STATE(4387),
    [sym_array_type] = STATE(1964),
    [sym_tuple_type] = STATE(1964),
    [sym_readonly_type] = STATE(1901),
    [sym_union_type] = STATE(1964),
    [sym_intersection_type] = STATE(1964),
    [sym_function_type] = STATE(1901),
    [sym_identifier] = ACTIONS(4081),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_LBRACE] = ACTIONS(4027),
    [anon_sym_typeof] = ACTIONS(4029),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(4037),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4041),
    [anon_sym_void] = ACTIONS(4043),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [sym_number] = ACTIONS(4047),
    [sym_this] = ACTIONS(4083),
    [sym_true] = ACTIONS(4051),
    [sym_false] = ACTIONS(4051),
    [sym_null] = ACTIONS(4051),
    [sym_undefined] = ACTIONS(4051),
    [anon_sym_readonly] = ACTIONS(4053),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_any] = ACTIONS(4043),
    [anon_sym_number] = ACTIONS(4043),
    [anon_sym_boolean] = ACTIONS(4043),
    [anon_sym_string] = ACTIONS(4043),
    [anon_sym_symbol] = ACTIONS(4043),
    [anon_sym_abstract] = ACTIONS(4057),
    [anon_sym_infer] = ACTIONS(4059),
    [anon_sym_keyof] = ACTIONS(4061),
    [anon_sym_unknown] = ACTIONS(4043),
    [anon_sym_never] = ACTIONS(4043),
    [anon_sym_object] = ACTIONS(4043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4063),
  },
  [1216] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(2799),
    [sym_constructor_type] = STATE(2799),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(2799),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(2799),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(2799),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1217] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3768),
    [sym_constructor_type] = STATE(3768),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3768),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3768),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3768),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1218] = {
    [sym_component_identifier] = STATE(3375),
    [sym_new_component_body] = STATE(1721),
    [sym_tagged_type_string] = STATE(1832),
    [sym_tripple_tagged_type_string] = STATE(1831),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_RPAREN] = ACTIONS(3784),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_COLON] = ACTIONS(3784),
    [anon_sym_EQ] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3677),
    [anon_sym_EQ_GT] = ACTIONS(3815),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3704),
    [anon_sym_QMARK] = ACTIONS(3787),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1868),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1219] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3087),
    [sym_constructor_type] = STATE(3087),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3087),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3087),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3087),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1220] = {
    [sym_nested_identifier] = STATE(4559),
    [sym_string] = STATE(1693),
    [sym_formal_parameters] = STATE(4819),
    [sym_nested_type_identifier] = STATE(1628),
    [sym__type] = STATE(1706),
    [sym_constructor_type] = STATE(1706),
    [sym__primary_type] = STATE(1647),
    [sym_template_literal_type] = STATE(1697),
    [sym_infer_type] = STATE(1706),
    [sym_conditional_type] = STATE(1697),
    [sym_generic_type] = STATE(1697),
    [sym_type_query] = STATE(1697),
    [sym_index_type_query] = STATE(1697),
    [sym_lookup_type] = STATE(1697),
    [sym_literal_type] = STATE(1697),
    [sym__number] = STATE(1699),
    [sym_existential_type] = STATE(1697),
    [sym_flow_maybe_type] = STATE(1697),
    [sym_parenthesized_type] = STATE(1697),
    [sym_predefined_type] = STATE(1697),
    [sym_object_type] = STATE(1697),
    [sym_type_parameters] = STATE(4263),
    [sym_array_type] = STATE(1697),
    [sym_tuple_type] = STATE(1697),
    [sym_readonly_type] = STATE(1706),
    [sym_union_type] = STATE(1697),
    [sym_intersection_type] = STATE(1697),
    [sym_function_type] = STATE(1706),
    [sym_identifier] = ACTIONS(4077),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_typeof] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_void] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3971),
    [sym_number] = ACTIONS(3973),
    [sym_this] = ACTIONS(4079),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [sym_null] = ACTIONS(3977),
    [sym_undefined] = ACTIONS(3977),
    [anon_sym_readonly] = ACTIONS(3979),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_any] = ACTIONS(3969),
    [anon_sym_number] = ACTIONS(3969),
    [anon_sym_boolean] = ACTIONS(3969),
    [anon_sym_string] = ACTIONS(3969),
    [anon_sym_symbol] = ACTIONS(3969),
    [anon_sym_abstract] = ACTIONS(3983),
    [anon_sym_infer] = ACTIONS(3985),
    [anon_sym_keyof] = ACTIONS(3987),
    [anon_sym_unknown] = ACTIONS(3969),
    [anon_sym_never] = ACTIONS(3969),
    [anon_sym_object] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3989),
  },
  [1221] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3617),
    [sym_constructor_type] = STATE(3617),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3617),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3617),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3617),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1222] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3579),
    [sym_constructor_type] = STATE(3579),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3579),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3579),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3579),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1223] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3874),
    [sym_constructor_type] = STATE(3874),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3874),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3874),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3874),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1224] = {
    [sym_nested_identifier] = STATE(4619),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3952),
    [sym_constructor_type] = STATE(3952),
    [sym__primary_type] = STATE(2980),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3952),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3952),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3952),
    [sym_identifier] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(3793),
    [anon_sym_PIPE] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3807),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1225] = {
    [sym_nested_identifier] = STATE(4619),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3952),
    [sym_constructor_type] = STATE(3952),
    [sym__primary_type] = STATE(2978),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3952),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3952),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3952),
    [sym_identifier] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(3793),
    [anon_sym_PIPE] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3807),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1226] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3351),
    [sym_constructor_type] = STATE(3351),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3351),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3351),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3351),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1227] = {
    [sym_nested_identifier] = STATE(4619),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4579),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3084),
    [sym_constructor_type] = STATE(3084),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3084),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4402),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3084),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3084),
    [sym_identifier] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3791),
    [anon_sym_AMP] = ACTIONS(3793),
    [anon_sym_PIPE] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(3799),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(3803),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(3807),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1228] = {
    [sym_nested_identifier] = STATE(4619),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4579),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3068),
    [sym_constructor_type] = STATE(3068),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3068),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4402),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3068),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3068),
    [sym_identifier] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3791),
    [anon_sym_AMP] = ACTIONS(3793),
    [anon_sym_PIPE] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(3799),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(3803),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(3807),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1229] = {
    [sym_nested_identifier] = STATE(4603),
    [sym_string] = STATE(938),
    [sym_formal_parameters] = STATE(4595),
    [sym_nested_type_identifier] = STATE(786),
    [sym__type] = STATE(886),
    [sym_constructor_type] = STATE(886),
    [sym__primary_type] = STATE(925),
    [sym_template_literal_type] = STATE(911),
    [sym_infer_type] = STATE(886),
    [sym_conditional_type] = STATE(911),
    [sym_generic_type] = STATE(911),
    [sym_type_query] = STATE(911),
    [sym_index_type_query] = STATE(911),
    [sym_lookup_type] = STATE(911),
    [sym_literal_type] = STATE(911),
    [sym__number] = STATE(899),
    [sym_existential_type] = STATE(911),
    [sym_flow_maybe_type] = STATE(911),
    [sym_parenthesized_type] = STATE(911),
    [sym_predefined_type] = STATE(911),
    [sym_object_type] = STATE(911),
    [sym_type_parameters] = STATE(4495),
    [sym_array_type] = STATE(911),
    [sym_tuple_type] = STATE(911),
    [sym_readonly_type] = STATE(886),
    [sym_union_type] = STATE(911),
    [sym_intersection_type] = STATE(911),
    [sym_function_type] = STATE(886),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3891),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3897),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3901),
    [anon_sym_DASH] = ACTIONS(3901),
    [anon_sym_void] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3905),
    [sym_number] = ACTIONS(3907),
    [sym_this] = ACTIONS(4089),
    [sym_true] = ACTIONS(3911),
    [sym_false] = ACTIONS(3911),
    [sym_null] = ACTIONS(3911),
    [sym_undefined] = ACTIONS(3911),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3903),
    [anon_sym_number] = ACTIONS(3903),
    [anon_sym_boolean] = ACTIONS(3903),
    [anon_sym_string] = ACTIONS(3903),
    [anon_sym_symbol] = ACTIONS(3903),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3919),
    [anon_sym_keyof] = ACTIONS(3921),
    [anon_sym_unknown] = ACTIONS(3903),
    [anon_sym_never] = ACTIONS(3903),
    [anon_sym_object] = ACTIONS(3903),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
  },
  [1230] = {
    [sym_nested_identifier] = STATE(4619),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4579),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(2991),
    [sym_constructor_type] = STATE(2991),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(2991),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4402),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(2991),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(2991),
    [sym_identifier] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3791),
    [anon_sym_AMP] = ACTIONS(3793),
    [anon_sym_PIPE] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(3799),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(3803),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(3807),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1231] = {
    [sym_nested_identifier] = STATE(4619),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4579),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3059),
    [sym_constructor_type] = STATE(3059),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3059),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4402),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3059),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3059),
    [sym_identifier] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3791),
    [anon_sym_AMP] = ACTIONS(3793),
    [anon_sym_PIPE] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(3799),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(3803),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(3807),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1232] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3773),
    [sym_constructor_type] = STATE(3773),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3773),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3773),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3773),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1233] = {
    [sym_nested_identifier] = STATE(4619),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4579),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3017),
    [sym_constructor_type] = STATE(3017),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3017),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4402),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3017),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3017),
    [sym_identifier] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3791),
    [anon_sym_AMP] = ACTIONS(3793),
    [anon_sym_PIPE] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(3799),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(3803),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(3807),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1234] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3478),
    [sym_constructor_type] = STATE(3478),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3478),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3478),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3478),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1235] = {
    [sym_nested_identifier] = STATE(4619),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4579),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3035),
    [sym_constructor_type] = STATE(3035),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3035),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4402),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3035),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3035),
    [sym_identifier] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3791),
    [anon_sym_AMP] = ACTIONS(3793),
    [anon_sym_PIPE] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(3799),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(3803),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(3807),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1236] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3774),
    [sym_constructor_type] = STATE(3774),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3774),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3774),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3774),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1237] = {
    [sym_nested_identifier] = STATE(4633),
    [sym_string] = STATE(1972),
    [sym_formal_parameters] = STATE(4675),
    [sym_nested_type_identifier] = STATE(1862),
    [sym__type] = STATE(1937),
    [sym_constructor_type] = STATE(1937),
    [sym__primary_type] = STATE(1965),
    [sym_template_literal_type] = STATE(1964),
    [sym_infer_type] = STATE(1937),
    [sym_conditional_type] = STATE(1964),
    [sym_generic_type] = STATE(1964),
    [sym_type_query] = STATE(1964),
    [sym_index_type_query] = STATE(1964),
    [sym_lookup_type] = STATE(1964),
    [sym_literal_type] = STATE(1964),
    [sym__number] = STATE(1961),
    [sym_existential_type] = STATE(1964),
    [sym_flow_maybe_type] = STATE(1964),
    [sym_parenthesized_type] = STATE(1964),
    [sym_predefined_type] = STATE(1964),
    [sym_object_type] = STATE(1964),
    [sym_type_parameters] = STATE(4387),
    [sym_array_type] = STATE(1964),
    [sym_tuple_type] = STATE(1964),
    [sym_readonly_type] = STATE(1937),
    [sym_union_type] = STATE(1964),
    [sym_intersection_type] = STATE(1964),
    [sym_function_type] = STATE(1937),
    [sym_identifier] = ACTIONS(4081),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_LBRACE] = ACTIONS(4027),
    [anon_sym_typeof] = ACTIONS(4029),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(4037),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4041),
    [anon_sym_void] = ACTIONS(4043),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [sym_number] = ACTIONS(4047),
    [sym_this] = ACTIONS(4083),
    [sym_true] = ACTIONS(4051),
    [sym_false] = ACTIONS(4051),
    [sym_null] = ACTIONS(4051),
    [sym_undefined] = ACTIONS(4051),
    [anon_sym_readonly] = ACTIONS(4053),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_any] = ACTIONS(4043),
    [anon_sym_number] = ACTIONS(4043),
    [anon_sym_boolean] = ACTIONS(4043),
    [anon_sym_string] = ACTIONS(4043),
    [anon_sym_symbol] = ACTIONS(4043),
    [anon_sym_abstract] = ACTIONS(4057),
    [anon_sym_infer] = ACTIONS(4059),
    [anon_sym_keyof] = ACTIONS(4061),
    [anon_sym_unknown] = ACTIONS(4043),
    [anon_sym_never] = ACTIONS(4043),
    [anon_sym_object] = ACTIONS(4043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4063),
  },
  [1238] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3836),
    [sym_constructor_type] = STATE(3836),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3836),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3836),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3836),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1239] = {
    [sym_nested_identifier] = STATE(4619),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4579),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(2995),
    [sym_constructor_type] = STATE(2995),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(2995),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4402),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(2995),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(2995),
    [sym_identifier] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3791),
    [anon_sym_AMP] = ACTIONS(3793),
    [anon_sym_PIPE] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(3799),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(3803),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(3807),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1240] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3837),
    [sym_constructor_type] = STATE(3837),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3837),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3837),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3837),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1241] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3085),
    [sym_constructor_type] = STATE(3085),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3085),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3085),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3085),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1242] = {
    [sym_nested_identifier] = STATE(4619),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4579),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3052),
    [sym_constructor_type] = STATE(3052),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3052),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4402),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3052),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3052),
    [sym_identifier] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3791),
    [anon_sym_AMP] = ACTIONS(3793),
    [anon_sym_PIPE] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(3799),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(3803),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(3807),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1243] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3196),
    [sym_constructor_type] = STATE(3196),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3196),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3196),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3196),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1244] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3198),
    [sym_constructor_type] = STATE(3198),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3198),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3198),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3198),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1245] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3017),
    [sym_constructor_type] = STATE(3017),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3017),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3017),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3017),
    [sym_identifier] = ACTIONS(4091),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1246] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(2994),
    [sym_constructor_type] = STATE(2994),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(2994),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(2994),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(2994),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1247] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3037),
    [sym_constructor_type] = STATE(3037),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3037),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3037),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3037),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1248] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4859),
    [sym_nested_type_identifier] = STATE(3193),
    [sym__type] = STATE(3451),
    [sym_constructor_type] = STATE(3451),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3451),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4172),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3451),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3451),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_PIPE] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3939),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3943),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3945),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1249] = {
    [sym_nested_identifier] = STATE(4559),
    [sym_string] = STATE(1693),
    [sym_formal_parameters] = STATE(4819),
    [sym_nested_type_identifier] = STATE(1628),
    [sym__type] = STATE(1666),
    [sym_constructor_type] = STATE(1666),
    [sym__primary_type] = STATE(1647),
    [sym_template_literal_type] = STATE(1697),
    [sym_infer_type] = STATE(1666),
    [sym_conditional_type] = STATE(1697),
    [sym_generic_type] = STATE(1697),
    [sym_type_query] = STATE(1697),
    [sym_index_type_query] = STATE(1697),
    [sym_lookup_type] = STATE(1697),
    [sym_literal_type] = STATE(1697),
    [sym__number] = STATE(1699),
    [sym_existential_type] = STATE(1697),
    [sym_flow_maybe_type] = STATE(1697),
    [sym_parenthesized_type] = STATE(1697),
    [sym_predefined_type] = STATE(1697),
    [sym_object_type] = STATE(1697),
    [sym_type_parameters] = STATE(4263),
    [sym_array_type] = STATE(1697),
    [sym_tuple_type] = STATE(1697),
    [sym_readonly_type] = STATE(1666),
    [sym_union_type] = STATE(1697),
    [sym_intersection_type] = STATE(1697),
    [sym_function_type] = STATE(1666),
    [sym_identifier] = ACTIONS(4077),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_typeof] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_void] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3971),
    [sym_number] = ACTIONS(3973),
    [sym_this] = ACTIONS(4079),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [sym_null] = ACTIONS(3977),
    [sym_undefined] = ACTIONS(3977),
    [anon_sym_readonly] = ACTIONS(3979),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_any] = ACTIONS(3969),
    [anon_sym_number] = ACTIONS(3969),
    [anon_sym_boolean] = ACTIONS(3969),
    [anon_sym_string] = ACTIONS(3969),
    [anon_sym_symbol] = ACTIONS(3969),
    [anon_sym_abstract] = ACTIONS(3983),
    [anon_sym_infer] = ACTIONS(3985),
    [anon_sym_keyof] = ACTIONS(3987),
    [anon_sym_unknown] = ACTIONS(3969),
    [anon_sym_never] = ACTIONS(3969),
    [anon_sym_object] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3989),
  },
  [1250] = {
    [sym_nested_identifier] = STATE(4619),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4579),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3039),
    [sym_constructor_type] = STATE(3039),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3039),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4402),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3039),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3039),
    [sym_identifier] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3791),
    [anon_sym_AMP] = ACTIONS(3793),
    [anon_sym_PIPE] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(3799),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(3803),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(3807),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1251] = {
    [sym_nested_identifier] = STATE(4559),
    [sym_string] = STATE(1693),
    [sym_formal_parameters] = STATE(4819),
    [sym_nested_type_identifier] = STATE(1628),
    [sym__type] = STATE(1667),
    [sym_constructor_type] = STATE(1667),
    [sym__primary_type] = STATE(1647),
    [sym_template_literal_type] = STATE(1697),
    [sym_infer_type] = STATE(1667),
    [sym_conditional_type] = STATE(1697),
    [sym_generic_type] = STATE(1697),
    [sym_type_query] = STATE(1697),
    [sym_index_type_query] = STATE(1697),
    [sym_lookup_type] = STATE(1697),
    [sym_literal_type] = STATE(1697),
    [sym__number] = STATE(1699),
    [sym_existential_type] = STATE(1697),
    [sym_flow_maybe_type] = STATE(1697),
    [sym_parenthesized_type] = STATE(1697),
    [sym_predefined_type] = STATE(1697),
    [sym_object_type] = STATE(1697),
    [sym_type_parameters] = STATE(4263),
    [sym_array_type] = STATE(1697),
    [sym_tuple_type] = STATE(1697),
    [sym_readonly_type] = STATE(1667),
    [sym_union_type] = STATE(1697),
    [sym_intersection_type] = STATE(1697),
    [sym_function_type] = STATE(1667),
    [sym_identifier] = ACTIONS(4077),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_typeof] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_void] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3971),
    [sym_number] = ACTIONS(3973),
    [sym_this] = ACTIONS(4079),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [sym_null] = ACTIONS(3977),
    [sym_undefined] = ACTIONS(3977),
    [anon_sym_readonly] = ACTIONS(3979),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_any] = ACTIONS(3969),
    [anon_sym_number] = ACTIONS(3969),
    [anon_sym_boolean] = ACTIONS(3969),
    [anon_sym_string] = ACTIONS(3969),
    [anon_sym_symbol] = ACTIONS(3969),
    [anon_sym_abstract] = ACTIONS(3983),
    [anon_sym_infer] = ACTIONS(3985),
    [anon_sym_keyof] = ACTIONS(3987),
    [anon_sym_unknown] = ACTIONS(3969),
    [anon_sym_never] = ACTIONS(3969),
    [anon_sym_object] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3989),
  },
  [1252] = {
    [sym_nested_identifier] = STATE(4619),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4579),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3080),
    [sym_constructor_type] = STATE(3080),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3080),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4402),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3080),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3080),
    [sym_identifier] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3791),
    [anon_sym_AMP] = ACTIONS(3793),
    [anon_sym_PIPE] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(3799),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(3803),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(3807),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1253] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(2761),
    [sym_constructor_type] = STATE(2761),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(2761),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(2761),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(2761),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1254] = {
    [sym_nested_identifier] = STATE(4603),
    [sym_string] = STATE(938),
    [sym_formal_parameters] = STATE(4595),
    [sym_nested_type_identifier] = STATE(786),
    [sym__type] = STATE(977),
    [sym_constructor_type] = STATE(977),
    [sym__primary_type] = STATE(925),
    [sym_template_literal_type] = STATE(911),
    [sym_infer_type] = STATE(977),
    [sym_conditional_type] = STATE(911),
    [sym_generic_type] = STATE(911),
    [sym_type_query] = STATE(911),
    [sym_index_type_query] = STATE(911),
    [sym_lookup_type] = STATE(911),
    [sym_literal_type] = STATE(911),
    [sym__number] = STATE(899),
    [sym_existential_type] = STATE(911),
    [sym_flow_maybe_type] = STATE(911),
    [sym_parenthesized_type] = STATE(911),
    [sym_predefined_type] = STATE(911),
    [sym_object_type] = STATE(911),
    [sym_type_parameters] = STATE(4495),
    [sym_array_type] = STATE(911),
    [sym_tuple_type] = STATE(911),
    [sym_readonly_type] = STATE(977),
    [sym_union_type] = STATE(911),
    [sym_intersection_type] = STATE(911),
    [sym_function_type] = STATE(977),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3891),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3897),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3901),
    [anon_sym_DASH] = ACTIONS(3901),
    [anon_sym_void] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3905),
    [sym_number] = ACTIONS(3907),
    [sym_this] = ACTIONS(4089),
    [sym_true] = ACTIONS(3911),
    [sym_false] = ACTIONS(3911),
    [sym_null] = ACTIONS(3911),
    [sym_undefined] = ACTIONS(3911),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3903),
    [anon_sym_number] = ACTIONS(3903),
    [anon_sym_boolean] = ACTIONS(3903),
    [anon_sym_string] = ACTIONS(3903),
    [anon_sym_symbol] = ACTIONS(3903),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3919),
    [anon_sym_keyof] = ACTIONS(3921),
    [anon_sym_unknown] = ACTIONS(3903),
    [anon_sym_never] = ACTIONS(3903),
    [anon_sym_object] = ACTIONS(3903),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
  },
  [1255] = {
    [sym_nested_identifier] = STATE(4603),
    [sym_string] = STATE(938),
    [sym_formal_parameters] = STATE(4595),
    [sym_nested_type_identifier] = STATE(786),
    [sym__type] = STATE(972),
    [sym_constructor_type] = STATE(972),
    [sym__primary_type] = STATE(925),
    [sym_template_literal_type] = STATE(911),
    [sym_infer_type] = STATE(972),
    [sym_conditional_type] = STATE(911),
    [sym_generic_type] = STATE(911),
    [sym_type_query] = STATE(911),
    [sym_index_type_query] = STATE(911),
    [sym_lookup_type] = STATE(911),
    [sym_literal_type] = STATE(911),
    [sym__number] = STATE(899),
    [sym_existential_type] = STATE(911),
    [sym_flow_maybe_type] = STATE(911),
    [sym_parenthesized_type] = STATE(911),
    [sym_predefined_type] = STATE(911),
    [sym_object_type] = STATE(911),
    [sym_type_parameters] = STATE(4495),
    [sym_array_type] = STATE(911),
    [sym_tuple_type] = STATE(911),
    [sym_readonly_type] = STATE(972),
    [sym_union_type] = STATE(911),
    [sym_intersection_type] = STATE(911),
    [sym_function_type] = STATE(972),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3891),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3897),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3901),
    [anon_sym_DASH] = ACTIONS(3901),
    [anon_sym_void] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3905),
    [sym_number] = ACTIONS(3907),
    [sym_this] = ACTIONS(4089),
    [sym_true] = ACTIONS(3911),
    [sym_false] = ACTIONS(3911),
    [sym_null] = ACTIONS(3911),
    [sym_undefined] = ACTIONS(3911),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3903),
    [anon_sym_number] = ACTIONS(3903),
    [anon_sym_boolean] = ACTIONS(3903),
    [anon_sym_string] = ACTIONS(3903),
    [anon_sym_symbol] = ACTIONS(3903),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3919),
    [anon_sym_keyof] = ACTIONS(3921),
    [anon_sym_unknown] = ACTIONS(3903),
    [anon_sym_never] = ACTIONS(3903),
    [anon_sym_object] = ACTIONS(3903),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
  },
  [1256] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4859),
    [sym_nested_type_identifier] = STATE(3193),
    [sym__type] = STATE(3462),
    [sym_constructor_type] = STATE(3462),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3462),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4172),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3462),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3462),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_PIPE] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3939),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3943),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3945),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1257] = {
    [sym_nested_identifier] = STATE(4619),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4579),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(2994),
    [sym_constructor_type] = STATE(2994),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(2994),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4402),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(2994),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(2994),
    [sym_identifier] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3791),
    [anon_sym_AMP] = ACTIONS(3793),
    [anon_sym_PIPE] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(3799),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(3803),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(3807),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1258] = {
    [sym_nested_identifier] = STATE(4603),
    [sym_string] = STATE(938),
    [sym_formal_parameters] = STATE(4595),
    [sym_nested_type_identifier] = STATE(786),
    [sym__type] = STATE(936),
    [sym_constructor_type] = STATE(936),
    [sym__primary_type] = STATE(925),
    [sym_template_literal_type] = STATE(911),
    [sym_infer_type] = STATE(936),
    [sym_conditional_type] = STATE(911),
    [sym_generic_type] = STATE(911),
    [sym_type_query] = STATE(911),
    [sym_index_type_query] = STATE(911),
    [sym_lookup_type] = STATE(911),
    [sym_literal_type] = STATE(911),
    [sym__number] = STATE(899),
    [sym_existential_type] = STATE(911),
    [sym_flow_maybe_type] = STATE(911),
    [sym_parenthesized_type] = STATE(911),
    [sym_predefined_type] = STATE(911),
    [sym_object_type] = STATE(911),
    [sym_type_parameters] = STATE(4495),
    [sym_array_type] = STATE(911),
    [sym_tuple_type] = STATE(911),
    [sym_readonly_type] = STATE(936),
    [sym_union_type] = STATE(911),
    [sym_intersection_type] = STATE(911),
    [sym_function_type] = STATE(936),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3891),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3897),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3901),
    [anon_sym_DASH] = ACTIONS(3901),
    [anon_sym_void] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3905),
    [sym_number] = ACTIONS(3907),
    [sym_this] = ACTIONS(4089),
    [sym_true] = ACTIONS(3911),
    [sym_false] = ACTIONS(3911),
    [sym_null] = ACTIONS(3911),
    [sym_undefined] = ACTIONS(3911),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3903),
    [anon_sym_number] = ACTIONS(3903),
    [anon_sym_boolean] = ACTIONS(3903),
    [anon_sym_string] = ACTIONS(3903),
    [anon_sym_symbol] = ACTIONS(3903),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3919),
    [anon_sym_keyof] = ACTIONS(3921),
    [anon_sym_unknown] = ACTIONS(3903),
    [anon_sym_never] = ACTIONS(3903),
    [anon_sym_object] = ACTIONS(3903),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
  },
  [1259] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4859),
    [sym_nested_type_identifier] = STATE(3193),
    [sym__type] = STATE(3468),
    [sym_constructor_type] = STATE(3468),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3468),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4172),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3468),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3468),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_PIPE] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3939),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3943),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3945),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1260] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3315),
    [sym_constructor_type] = STATE(3315),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3315),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3315),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3315),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1261] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3264),
    [sym_constructor_type] = STATE(3264),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3264),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3264),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3264),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1262] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3780),
    [sym_constructor_type] = STATE(3780),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3780),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3780),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3780),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1263] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4859),
    [sym_nested_type_identifier] = STATE(3193),
    [sym__type] = STATE(2763),
    [sym_constructor_type] = STATE(2763),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(2763),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4172),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(2763),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(2763),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_PIPE] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3939),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3943),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3945),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1264] = {
    [sym_nested_identifier] = STATE(4603),
    [sym_string] = STATE(938),
    [sym_formal_parameters] = STATE(4595),
    [sym_nested_type_identifier] = STATE(786),
    [sym__type] = STATE(935),
    [sym_constructor_type] = STATE(935),
    [sym__primary_type] = STATE(925),
    [sym_template_literal_type] = STATE(911),
    [sym_infer_type] = STATE(935),
    [sym_conditional_type] = STATE(911),
    [sym_generic_type] = STATE(911),
    [sym_type_query] = STATE(911),
    [sym_index_type_query] = STATE(911),
    [sym_lookup_type] = STATE(911),
    [sym_literal_type] = STATE(911),
    [sym__number] = STATE(899),
    [sym_existential_type] = STATE(911),
    [sym_flow_maybe_type] = STATE(911),
    [sym_parenthesized_type] = STATE(911),
    [sym_predefined_type] = STATE(911),
    [sym_object_type] = STATE(911),
    [sym_type_parameters] = STATE(4495),
    [sym_array_type] = STATE(911),
    [sym_tuple_type] = STATE(911),
    [sym_readonly_type] = STATE(935),
    [sym_union_type] = STATE(911),
    [sym_intersection_type] = STATE(911),
    [sym_function_type] = STATE(935),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3891),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3897),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3901),
    [anon_sym_DASH] = ACTIONS(3901),
    [anon_sym_void] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3905),
    [sym_number] = ACTIONS(3907),
    [sym_this] = ACTIONS(4089),
    [sym_true] = ACTIONS(3911),
    [sym_false] = ACTIONS(3911),
    [sym_null] = ACTIONS(3911),
    [sym_undefined] = ACTIONS(3911),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3903),
    [anon_sym_number] = ACTIONS(3903),
    [anon_sym_boolean] = ACTIONS(3903),
    [anon_sym_string] = ACTIONS(3903),
    [anon_sym_symbol] = ACTIONS(3903),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3919),
    [anon_sym_keyof] = ACTIONS(3921),
    [anon_sym_unknown] = ACTIONS(3903),
    [anon_sym_never] = ACTIONS(3903),
    [anon_sym_object] = ACTIONS(3903),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
  },
  [1265] = {
    [sym_nested_identifier] = STATE(4633),
    [sym_string] = STATE(1972),
    [sym_formal_parameters] = STATE(4675),
    [sym_nested_type_identifier] = STATE(1862),
    [sym__type] = STATE(1899),
    [sym_constructor_type] = STATE(1899),
    [sym__primary_type] = STATE(1965),
    [sym_template_literal_type] = STATE(1964),
    [sym_infer_type] = STATE(1899),
    [sym_conditional_type] = STATE(1964),
    [sym_generic_type] = STATE(1964),
    [sym_type_query] = STATE(1964),
    [sym_index_type_query] = STATE(1964),
    [sym_lookup_type] = STATE(1964),
    [sym_literal_type] = STATE(1964),
    [sym__number] = STATE(1961),
    [sym_existential_type] = STATE(1964),
    [sym_flow_maybe_type] = STATE(1964),
    [sym_parenthesized_type] = STATE(1964),
    [sym_predefined_type] = STATE(1964),
    [sym_object_type] = STATE(1964),
    [sym_type_parameters] = STATE(4387),
    [sym_array_type] = STATE(1964),
    [sym_tuple_type] = STATE(1964),
    [sym_readonly_type] = STATE(1899),
    [sym_union_type] = STATE(1964),
    [sym_intersection_type] = STATE(1964),
    [sym_function_type] = STATE(1899),
    [sym_identifier] = ACTIONS(4081),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_LBRACE] = ACTIONS(4027),
    [anon_sym_typeof] = ACTIONS(4029),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(4037),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4041),
    [anon_sym_void] = ACTIONS(4043),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [sym_number] = ACTIONS(4047),
    [sym_this] = ACTIONS(4083),
    [sym_true] = ACTIONS(4051),
    [sym_false] = ACTIONS(4051),
    [sym_null] = ACTIONS(4051),
    [sym_undefined] = ACTIONS(4051),
    [anon_sym_readonly] = ACTIONS(4053),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_any] = ACTIONS(4043),
    [anon_sym_number] = ACTIONS(4043),
    [anon_sym_boolean] = ACTIONS(4043),
    [anon_sym_string] = ACTIONS(4043),
    [anon_sym_symbol] = ACTIONS(4043),
    [anon_sym_abstract] = ACTIONS(4057),
    [anon_sym_infer] = ACTIONS(4059),
    [anon_sym_keyof] = ACTIONS(4061),
    [anon_sym_unknown] = ACTIONS(4043),
    [anon_sym_never] = ACTIONS(4043),
    [anon_sym_object] = ACTIONS(4043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4063),
  },
  [1266] = {
    [sym_nested_identifier] = STATE(4603),
    [sym_string] = STATE(938),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(786),
    [sym__type] = STATE(3904),
    [sym_constructor_type] = STATE(3904),
    [sym__primary_type] = STATE(952),
    [sym_template_literal_type] = STATE(911),
    [sym_infer_type] = STATE(3904),
    [sym_conditional_type] = STATE(911),
    [sym_generic_type] = STATE(911),
    [sym_type_query] = STATE(911),
    [sym_index_type_query] = STATE(911),
    [sym_lookup_type] = STATE(911),
    [sym_literal_type] = STATE(911),
    [sym__number] = STATE(899),
    [sym_existential_type] = STATE(911),
    [sym_flow_maybe_type] = STATE(911),
    [sym_parenthesized_type] = STATE(911),
    [sym_predefined_type] = STATE(911),
    [sym_object_type] = STATE(911),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(911),
    [sym_tuple_type] = STATE(911),
    [sym_readonly_type] = STATE(3904),
    [sym_union_type] = STATE(911),
    [sym_intersection_type] = STATE(911),
    [sym_function_type] = STATE(3904),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3891),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(3897),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3901),
    [anon_sym_DASH] = ACTIONS(3901),
    [anon_sym_void] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3905),
    [sym_number] = ACTIONS(3907),
    [sym_this] = ACTIONS(4089),
    [sym_true] = ACTIONS(3911),
    [sym_false] = ACTIONS(3911),
    [sym_null] = ACTIONS(3911),
    [sym_undefined] = ACTIONS(3911),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3903),
    [anon_sym_number] = ACTIONS(3903),
    [anon_sym_boolean] = ACTIONS(3903),
    [anon_sym_string] = ACTIONS(3903),
    [anon_sym_symbol] = ACTIONS(3903),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3921),
    [anon_sym_unknown] = ACTIONS(3903),
    [anon_sym_never] = ACTIONS(3903),
    [anon_sym_object] = ACTIONS(3903),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
  },
  [1267] = {
    [sym_nested_identifier] = STATE(4603),
    [sym_string] = STATE(938),
    [sym_formal_parameters] = STATE(4595),
    [sym_nested_type_identifier] = STATE(786),
    [sym__type] = STATE(926),
    [sym_constructor_type] = STATE(926),
    [sym__primary_type] = STATE(925),
    [sym_template_literal_type] = STATE(911),
    [sym_infer_type] = STATE(926),
    [sym_conditional_type] = STATE(911),
    [sym_generic_type] = STATE(911),
    [sym_type_query] = STATE(911),
    [sym_index_type_query] = STATE(911),
    [sym_lookup_type] = STATE(911),
    [sym_literal_type] = STATE(911),
    [sym__number] = STATE(899),
    [sym_existential_type] = STATE(911),
    [sym_flow_maybe_type] = STATE(911),
    [sym_parenthesized_type] = STATE(911),
    [sym_predefined_type] = STATE(911),
    [sym_object_type] = STATE(911),
    [sym_type_parameters] = STATE(4495),
    [sym_array_type] = STATE(911),
    [sym_tuple_type] = STATE(911),
    [sym_readonly_type] = STATE(926),
    [sym_union_type] = STATE(911),
    [sym_intersection_type] = STATE(911),
    [sym_function_type] = STATE(926),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3891),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3897),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3901),
    [anon_sym_DASH] = ACTIONS(3901),
    [anon_sym_void] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3905),
    [sym_number] = ACTIONS(3907),
    [sym_this] = ACTIONS(4089),
    [sym_true] = ACTIONS(3911),
    [sym_false] = ACTIONS(3911),
    [sym_null] = ACTIONS(3911),
    [sym_undefined] = ACTIONS(3911),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3903),
    [anon_sym_number] = ACTIONS(3903),
    [anon_sym_boolean] = ACTIONS(3903),
    [anon_sym_string] = ACTIONS(3903),
    [anon_sym_symbol] = ACTIONS(3903),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3919),
    [anon_sym_keyof] = ACTIONS(3921),
    [anon_sym_unknown] = ACTIONS(3903),
    [anon_sym_never] = ACTIONS(3903),
    [anon_sym_object] = ACTIONS(3903),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
  },
  [1268] = {
    [sym_component_identifier] = STATE(3375),
    [sym_new_component_body] = STATE(1721),
    [sym_tagged_type_string] = STATE(1832),
    [sym_tripple_tagged_type_string] = STATE(1831),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(1852),
    [anon_sym_RBRACE] = ACTIONS(1852),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(1854),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3677),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3704),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1868),
    [sym__automatic_semicolon] = ACTIONS(1852),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1269] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4859),
    [sym_nested_type_identifier] = STATE(3193),
    [sym__type] = STATE(2778),
    [sym_constructor_type] = STATE(2778),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(2778),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4172),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(2778),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(2778),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_PIPE] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3939),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3943),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3945),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1270] = {
    [sym_nested_identifier] = STATE(4633),
    [sym_string] = STATE(1972),
    [sym_formal_parameters] = STATE(4675),
    [sym_nested_type_identifier] = STATE(1862),
    [sym__type] = STATE(1900),
    [sym_constructor_type] = STATE(1900),
    [sym__primary_type] = STATE(1965),
    [sym_template_literal_type] = STATE(1964),
    [sym_infer_type] = STATE(1900),
    [sym_conditional_type] = STATE(1964),
    [sym_generic_type] = STATE(1964),
    [sym_type_query] = STATE(1964),
    [sym_index_type_query] = STATE(1964),
    [sym_lookup_type] = STATE(1964),
    [sym_literal_type] = STATE(1964),
    [sym__number] = STATE(1961),
    [sym_existential_type] = STATE(1964),
    [sym_flow_maybe_type] = STATE(1964),
    [sym_parenthesized_type] = STATE(1964),
    [sym_predefined_type] = STATE(1964),
    [sym_object_type] = STATE(1964),
    [sym_type_parameters] = STATE(4387),
    [sym_array_type] = STATE(1964),
    [sym_tuple_type] = STATE(1964),
    [sym_readonly_type] = STATE(1900),
    [sym_union_type] = STATE(1964),
    [sym_intersection_type] = STATE(1964),
    [sym_function_type] = STATE(1900),
    [sym_identifier] = ACTIONS(4081),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_LBRACE] = ACTIONS(4027),
    [anon_sym_typeof] = ACTIONS(4029),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(4037),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4041),
    [anon_sym_void] = ACTIONS(4043),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [sym_number] = ACTIONS(4047),
    [sym_this] = ACTIONS(4083),
    [sym_true] = ACTIONS(4051),
    [sym_false] = ACTIONS(4051),
    [sym_null] = ACTIONS(4051),
    [sym_undefined] = ACTIONS(4051),
    [anon_sym_readonly] = ACTIONS(4053),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_any] = ACTIONS(4043),
    [anon_sym_number] = ACTIONS(4043),
    [anon_sym_boolean] = ACTIONS(4043),
    [anon_sym_string] = ACTIONS(4043),
    [anon_sym_symbol] = ACTIONS(4043),
    [anon_sym_abstract] = ACTIONS(4057),
    [anon_sym_infer] = ACTIONS(4059),
    [anon_sym_keyof] = ACTIONS(4061),
    [anon_sym_unknown] = ACTIONS(4043),
    [anon_sym_never] = ACTIONS(4043),
    [anon_sym_object] = ACTIONS(4043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4063),
  },
  [1271] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3123),
    [sym_constructor_type] = STATE(3123),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3123),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3123),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3123),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1272] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4859),
    [sym_nested_type_identifier] = STATE(3193),
    [sym__type] = STATE(2761),
    [sym_constructor_type] = STATE(2761),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(2761),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4172),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(2761),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(2761),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_PIPE] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3939),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3943),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3945),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1273] = {
    [sym_nested_identifier] = STATE(4603),
    [sym_string] = STATE(938),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(786),
    [sym__type] = STATE(3904),
    [sym_constructor_type] = STATE(3904),
    [sym__primary_type] = STATE(964),
    [sym_template_literal_type] = STATE(911),
    [sym_infer_type] = STATE(3904),
    [sym_conditional_type] = STATE(911),
    [sym_generic_type] = STATE(911),
    [sym_type_query] = STATE(911),
    [sym_index_type_query] = STATE(911),
    [sym_lookup_type] = STATE(911),
    [sym_literal_type] = STATE(911),
    [sym__number] = STATE(899),
    [sym_existential_type] = STATE(911),
    [sym_flow_maybe_type] = STATE(911),
    [sym_parenthesized_type] = STATE(911),
    [sym_predefined_type] = STATE(911),
    [sym_object_type] = STATE(911),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(911),
    [sym_tuple_type] = STATE(911),
    [sym_readonly_type] = STATE(3904),
    [sym_union_type] = STATE(911),
    [sym_intersection_type] = STATE(911),
    [sym_function_type] = STATE(3904),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3891),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(3897),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3901),
    [anon_sym_DASH] = ACTIONS(3901),
    [anon_sym_void] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3905),
    [sym_number] = ACTIONS(3907),
    [sym_this] = ACTIONS(4089),
    [sym_true] = ACTIONS(3911),
    [sym_false] = ACTIONS(3911),
    [sym_null] = ACTIONS(3911),
    [sym_undefined] = ACTIONS(3911),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3903),
    [anon_sym_number] = ACTIONS(3903),
    [anon_sym_boolean] = ACTIONS(3903),
    [anon_sym_string] = ACTIONS(3903),
    [anon_sym_symbol] = ACTIONS(3903),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3921),
    [anon_sym_unknown] = ACTIONS(3903),
    [anon_sym_never] = ACTIONS(3903),
    [anon_sym_object] = ACTIONS(3903),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
  },
  [1274] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(2799),
    [sym_constructor_type] = STATE(2799),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(2799),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(2799),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(2799),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1275] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(4122),
    [sym_constructor_type] = STATE(4122),
    [sym__primary_type] = STATE(2980),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(4122),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(4122),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(4122),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1276] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3656),
    [sym_constructor_type] = STATE(3656),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3656),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3656),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3656),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1277] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(4122),
    [sym_constructor_type] = STATE(4122),
    [sym__primary_type] = STATE(2978),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(4122),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(4122),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(4122),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1278] = {
    [sym_nested_identifier] = STATE(4603),
    [sym_string] = STATE(938),
    [sym_formal_parameters] = STATE(4595),
    [sym_nested_type_identifier] = STATE(786),
    [sym__type] = STATE(969),
    [sym_constructor_type] = STATE(969),
    [sym__primary_type] = STATE(925),
    [sym_template_literal_type] = STATE(911),
    [sym_infer_type] = STATE(969),
    [sym_conditional_type] = STATE(911),
    [sym_generic_type] = STATE(911),
    [sym_type_query] = STATE(911),
    [sym_index_type_query] = STATE(911),
    [sym_lookup_type] = STATE(911),
    [sym_literal_type] = STATE(911),
    [sym__number] = STATE(899),
    [sym_existential_type] = STATE(911),
    [sym_flow_maybe_type] = STATE(911),
    [sym_parenthesized_type] = STATE(911),
    [sym_predefined_type] = STATE(911),
    [sym_object_type] = STATE(911),
    [sym_type_parameters] = STATE(4495),
    [sym_array_type] = STATE(911),
    [sym_tuple_type] = STATE(911),
    [sym_readonly_type] = STATE(969),
    [sym_union_type] = STATE(911),
    [sym_intersection_type] = STATE(911),
    [sym_function_type] = STATE(969),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3891),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3897),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3901),
    [anon_sym_DASH] = ACTIONS(3901),
    [anon_sym_void] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3905),
    [sym_number] = ACTIONS(3907),
    [sym_this] = ACTIONS(4089),
    [sym_true] = ACTIONS(3911),
    [sym_false] = ACTIONS(3911),
    [sym_null] = ACTIONS(3911),
    [sym_undefined] = ACTIONS(3911),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3903),
    [anon_sym_number] = ACTIONS(3903),
    [anon_sym_boolean] = ACTIONS(3903),
    [anon_sym_string] = ACTIONS(3903),
    [anon_sym_symbol] = ACTIONS(3903),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3919),
    [anon_sym_keyof] = ACTIONS(3921),
    [anon_sym_unknown] = ACTIONS(3903),
    [anon_sym_never] = ACTIONS(3903),
    [anon_sym_object] = ACTIONS(3903),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
  },
  [1279] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3834),
    [sym_constructor_type] = STATE(3834),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3834),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3834),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3834),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1280] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3051),
    [sym_constructor_type] = STATE(3051),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3051),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3051),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3051),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1281] = {
    [sym_nested_identifier] = STATE(4603),
    [sym_string] = STATE(938),
    [sym_formal_parameters] = STATE(4595),
    [sym_nested_type_identifier] = STATE(786),
    [sym__type] = STATE(890),
    [sym_constructor_type] = STATE(890),
    [sym__primary_type] = STATE(925),
    [sym_template_literal_type] = STATE(911),
    [sym_infer_type] = STATE(890),
    [sym_conditional_type] = STATE(911),
    [sym_generic_type] = STATE(911),
    [sym_type_query] = STATE(911),
    [sym_index_type_query] = STATE(911),
    [sym_lookup_type] = STATE(911),
    [sym_literal_type] = STATE(911),
    [sym__number] = STATE(899),
    [sym_existential_type] = STATE(911),
    [sym_flow_maybe_type] = STATE(911),
    [sym_parenthesized_type] = STATE(911),
    [sym_predefined_type] = STATE(911),
    [sym_object_type] = STATE(911),
    [sym_type_parameters] = STATE(4495),
    [sym_array_type] = STATE(911),
    [sym_tuple_type] = STATE(911),
    [sym_readonly_type] = STATE(890),
    [sym_union_type] = STATE(911),
    [sym_intersection_type] = STATE(911),
    [sym_function_type] = STATE(890),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3891),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3897),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3901),
    [anon_sym_DASH] = ACTIONS(3901),
    [anon_sym_void] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3905),
    [sym_number] = ACTIONS(3907),
    [sym_this] = ACTIONS(4089),
    [sym_true] = ACTIONS(3911),
    [sym_false] = ACTIONS(3911),
    [sym_null] = ACTIONS(3911),
    [sym_undefined] = ACTIONS(3911),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3903),
    [anon_sym_number] = ACTIONS(3903),
    [anon_sym_boolean] = ACTIONS(3903),
    [anon_sym_string] = ACTIONS(3903),
    [anon_sym_symbol] = ACTIONS(3903),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3919),
    [anon_sym_keyof] = ACTIONS(3921),
    [anon_sym_unknown] = ACTIONS(3903),
    [anon_sym_never] = ACTIONS(3903),
    [anon_sym_object] = ACTIONS(3903),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
  },
  [1282] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3066),
    [sym_constructor_type] = STATE(3066),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3066),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3066),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3066),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1283] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3017),
    [sym_constructor_type] = STATE(3017),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3017),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3017),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3017),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1284] = {
    [sym_nested_identifier] = STATE(4559),
    [sym_string] = STATE(1693),
    [sym_formal_parameters] = STATE(4819),
    [sym_nested_type_identifier] = STATE(1628),
    [sym__type] = STATE(1674),
    [sym_constructor_type] = STATE(1674),
    [sym__primary_type] = STATE(1647),
    [sym_template_literal_type] = STATE(1697),
    [sym_infer_type] = STATE(1674),
    [sym_conditional_type] = STATE(1697),
    [sym_generic_type] = STATE(1697),
    [sym_type_query] = STATE(1697),
    [sym_index_type_query] = STATE(1697),
    [sym_lookup_type] = STATE(1697),
    [sym_literal_type] = STATE(1697),
    [sym__number] = STATE(1699),
    [sym_existential_type] = STATE(1697),
    [sym_flow_maybe_type] = STATE(1697),
    [sym_parenthesized_type] = STATE(1697),
    [sym_predefined_type] = STATE(1697),
    [sym_object_type] = STATE(1697),
    [sym_type_parameters] = STATE(4263),
    [sym_array_type] = STATE(1697),
    [sym_tuple_type] = STATE(1697),
    [sym_readonly_type] = STATE(1674),
    [sym_union_type] = STATE(1697),
    [sym_intersection_type] = STATE(1697),
    [sym_function_type] = STATE(1674),
    [sym_identifier] = ACTIONS(4077),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_typeof] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_void] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3971),
    [sym_number] = ACTIONS(3973),
    [sym_this] = ACTIONS(4079),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [sym_null] = ACTIONS(3977),
    [sym_undefined] = ACTIONS(3977),
    [anon_sym_readonly] = ACTIONS(3979),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_any] = ACTIONS(3969),
    [anon_sym_number] = ACTIONS(3969),
    [anon_sym_boolean] = ACTIONS(3969),
    [anon_sym_string] = ACTIONS(3969),
    [anon_sym_symbol] = ACTIONS(3969),
    [anon_sym_abstract] = ACTIONS(3983),
    [anon_sym_infer] = ACTIONS(3985),
    [anon_sym_keyof] = ACTIONS(3987),
    [anon_sym_unknown] = ACTIONS(3969),
    [anon_sym_never] = ACTIONS(3969),
    [anon_sym_object] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3989),
  },
  [1285] = {
    [sym_component_identifier] = STATE(3493),
    [sym_new_component_body] = STATE(1960),
    [sym_tagged_type_string] = STATE(2108),
    [sym_tripple_tagged_type_string] = STATE(2109),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_COMMA] = ACTIONS(1852),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_COLON] = ACTIONS(1940),
    [anon_sym_EQ] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3677),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3682),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3684),
    [sym__automatic_semicolon] = ACTIONS(1852),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1286] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3045),
    [sym_constructor_type] = STATE(3045),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3045),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3045),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3045),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1287] = {
    [sym_nested_identifier] = STATE(4619),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4579),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3053),
    [sym_constructor_type] = STATE(3053),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3053),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4402),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3053),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3053),
    [sym_identifier] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3791),
    [anon_sym_AMP] = ACTIONS(3793),
    [anon_sym_PIPE] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(3799),
    [anon_sym_QMARK] = ACTIONS(3801),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(3803),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(3807),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1288] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4859),
    [sym_nested_type_identifier] = STATE(3193),
    [sym__type] = STATE(3507),
    [sym_constructor_type] = STATE(3507),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3507),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4172),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3507),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3507),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_PIPE] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3939),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3943),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3945),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1289] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3850),
    [sym_constructor_type] = STATE(3850),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3850),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3850),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3850),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1290] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4859),
    [sym_nested_type_identifier] = STATE(3193),
    [sym__type] = STATE(2799),
    [sym_constructor_type] = STATE(2799),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(2799),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4172),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(2799),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(2799),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_PIPE] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3939),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3943),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3945),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1291] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3377),
    [sym_constructor_type] = STATE(3377),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3377),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3377),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3377),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1292] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(3193),
    [sym__type] = STATE(4110),
    [sym_constructor_type] = STATE(4110),
    [sym__primary_type] = STATE(2779),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4110),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4110),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4110),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_PIPE] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3945),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1293] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3644),
    [sym_constructor_type] = STATE(3644),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3644),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3644),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3644),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1294] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(3193),
    [sym__type] = STATE(4110),
    [sym_constructor_type] = STATE(4110),
    [sym__primary_type] = STATE(2801),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4110),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4110),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4110),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_PIPE] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3945),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1295] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4859),
    [sym_nested_type_identifier] = STATE(3193),
    [sym__type] = STATE(3357),
    [sym_constructor_type] = STATE(3357),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3357),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4172),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3357),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3357),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_PIPE] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3939),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3943),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3945),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1296] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(2798),
    [sym_constructor_type] = STATE(2798),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(2798),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(2798),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(2798),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1297] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3486),
    [sym_constructor_type] = STATE(3486),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3486),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3486),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3486),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1298] = {
    [sym_nested_identifier] = STATE(4633),
    [sym_string] = STATE(1972),
    [sym_formal_parameters] = STATE(4675),
    [sym_nested_type_identifier] = STATE(1862),
    [sym__type] = STATE(2029),
    [sym_constructor_type] = STATE(2029),
    [sym__primary_type] = STATE(1965),
    [sym_template_literal_type] = STATE(1964),
    [sym_infer_type] = STATE(2029),
    [sym_conditional_type] = STATE(1964),
    [sym_generic_type] = STATE(1964),
    [sym_type_query] = STATE(1964),
    [sym_index_type_query] = STATE(1964),
    [sym_lookup_type] = STATE(1964),
    [sym_literal_type] = STATE(1964),
    [sym__number] = STATE(1961),
    [sym_existential_type] = STATE(1964),
    [sym_flow_maybe_type] = STATE(1964),
    [sym_parenthesized_type] = STATE(1964),
    [sym_predefined_type] = STATE(1964),
    [sym_object_type] = STATE(1964),
    [sym_type_parameters] = STATE(4387),
    [sym_array_type] = STATE(1964),
    [sym_tuple_type] = STATE(1964),
    [sym_readonly_type] = STATE(2029),
    [sym_union_type] = STATE(1964),
    [sym_intersection_type] = STATE(1964),
    [sym_function_type] = STATE(2029),
    [sym_identifier] = ACTIONS(4081),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_LBRACE] = ACTIONS(4027),
    [anon_sym_typeof] = ACTIONS(4029),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(4037),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4041),
    [anon_sym_void] = ACTIONS(4043),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [sym_number] = ACTIONS(4047),
    [sym_this] = ACTIONS(4083),
    [sym_true] = ACTIONS(4051),
    [sym_false] = ACTIONS(4051),
    [sym_null] = ACTIONS(4051),
    [sym_undefined] = ACTIONS(4051),
    [anon_sym_readonly] = ACTIONS(4053),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_any] = ACTIONS(4043),
    [anon_sym_number] = ACTIONS(4043),
    [anon_sym_boolean] = ACTIONS(4043),
    [anon_sym_string] = ACTIONS(4043),
    [anon_sym_symbol] = ACTIONS(4043),
    [anon_sym_abstract] = ACTIONS(4057),
    [anon_sym_infer] = ACTIONS(4059),
    [anon_sym_keyof] = ACTIONS(4061),
    [anon_sym_unknown] = ACTIONS(4043),
    [anon_sym_never] = ACTIONS(4043),
    [anon_sym_object] = ACTIONS(4043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4063),
  },
  [1299] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(2761),
    [sym_constructor_type] = STATE(2761),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(2761),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(2761),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(2761),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1300] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3072),
    [sym_constructor_type] = STATE(3072),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3072),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3072),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3072),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1301] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3943),
    [sym_constructor_type] = STATE(3943),
    [sym__primary_type] = STATE(2779),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3943),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3943),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3943),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1302] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3070),
    [sym_constructor_type] = STATE(3070),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3070),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3070),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3070),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1303] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3055),
    [sym_constructor_type] = STATE(3055),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3055),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3055),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3055),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1304] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(2773),
    [sym_constructor_type] = STATE(2773),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(2773),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(2773),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(2773),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1305] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3739),
    [sym_constructor_type] = STATE(3739),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3739),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3739),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3739),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1306] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3848),
    [sym_constructor_type] = STATE(3848),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3848),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3848),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3848),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1307] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3477),
    [sym_constructor_type] = STATE(3477),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3477),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3477),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3477),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1308] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3011),
    [sym_constructor_type] = STATE(3011),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3011),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3011),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3011),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1309] = {
    [sym_nested_identifier] = STATE(4639),
    [sym_string] = STATE(3150),
    [sym_formal_parameters] = STATE(4801),
    [sym_nested_type_identifier] = STATE(2986),
    [sym__type] = STATE(3141),
    [sym_constructor_type] = STATE(3141),
    [sym__primary_type] = STATE(3156),
    [sym_template_literal_type] = STATE(3157),
    [sym_infer_type] = STATE(3141),
    [sym_conditional_type] = STATE(3157),
    [sym_generic_type] = STATE(3157),
    [sym_type_query] = STATE(3157),
    [sym_index_type_query] = STATE(3157),
    [sym_lookup_type] = STATE(3157),
    [sym_literal_type] = STATE(3157),
    [sym__number] = STATE(3158),
    [sym_existential_type] = STATE(3157),
    [sym_flow_maybe_type] = STATE(3157),
    [sym_parenthesized_type] = STATE(3157),
    [sym_predefined_type] = STATE(3157),
    [sym_object_type] = STATE(3157),
    [sym_type_parameters] = STATE(4371),
    [sym_array_type] = STATE(3157),
    [sym_tuple_type] = STATE(3157),
    [sym_readonly_type] = STATE(3141),
    [sym_union_type] = STATE(3157),
    [sym_intersection_type] = STATE(3157),
    [sym_function_type] = STATE(3141),
    [sym_identifier] = ACTIONS(4095),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_LBRACE] = ACTIONS(3827),
    [anon_sym_typeof] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(3833),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3839),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_void] = ACTIONS(3843),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3849),
    [sym_number] = ACTIONS(3851),
    [sym_this] = ACTIONS(4097),
    [sym_true] = ACTIONS(3855),
    [sym_false] = ACTIONS(3855),
    [sym_null] = ACTIONS(3855),
    [sym_undefined] = ACTIONS(3855),
    [anon_sym_readonly] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_any] = ACTIONS(3843),
    [anon_sym_number] = ACTIONS(3843),
    [anon_sym_boolean] = ACTIONS(3843),
    [anon_sym_string] = ACTIONS(3843),
    [anon_sym_symbol] = ACTIONS(3843),
    [anon_sym_abstract] = ACTIONS(3861),
    [anon_sym_infer] = ACTIONS(3865),
    [anon_sym_keyof] = ACTIONS(3867),
    [anon_sym_unknown] = ACTIONS(3843),
    [anon_sym_never] = ACTIONS(3843),
    [anon_sym_object] = ACTIONS(3843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3869),
  },
  [1310] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3009),
    [sym_constructor_type] = STATE(3009),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3009),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3009),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3009),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1311] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3777),
    [sym_constructor_type] = STATE(3777),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3777),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3777),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3777),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1312] = {
    [sym_nested_identifier] = STATE(4559),
    [sym_string] = STATE(1693),
    [sym_formal_parameters] = STATE(4819),
    [sym_nested_type_identifier] = STATE(1628),
    [sym__type] = STATE(1719),
    [sym_constructor_type] = STATE(1719),
    [sym__primary_type] = STATE(1647),
    [sym_template_literal_type] = STATE(1697),
    [sym_infer_type] = STATE(1719),
    [sym_conditional_type] = STATE(1697),
    [sym_generic_type] = STATE(1697),
    [sym_type_query] = STATE(1697),
    [sym_index_type_query] = STATE(1697),
    [sym_lookup_type] = STATE(1697),
    [sym_literal_type] = STATE(1697),
    [sym__number] = STATE(1699),
    [sym_existential_type] = STATE(1697),
    [sym_flow_maybe_type] = STATE(1697),
    [sym_parenthesized_type] = STATE(1697),
    [sym_predefined_type] = STATE(1697),
    [sym_object_type] = STATE(1697),
    [sym_type_parameters] = STATE(4263),
    [sym_array_type] = STATE(1697),
    [sym_tuple_type] = STATE(1697),
    [sym_readonly_type] = STATE(1719),
    [sym_union_type] = STATE(1697),
    [sym_intersection_type] = STATE(1697),
    [sym_function_type] = STATE(1719),
    [sym_identifier] = ACTIONS(4077),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_typeof] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_void] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3971),
    [sym_number] = ACTIONS(3973),
    [sym_this] = ACTIONS(4079),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [sym_null] = ACTIONS(3977),
    [sym_undefined] = ACTIONS(3977),
    [anon_sym_readonly] = ACTIONS(3979),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_any] = ACTIONS(3969),
    [anon_sym_number] = ACTIONS(3969),
    [anon_sym_boolean] = ACTIONS(3969),
    [anon_sym_string] = ACTIONS(3969),
    [anon_sym_symbol] = ACTIONS(3969),
    [anon_sym_abstract] = ACTIONS(3983),
    [anon_sym_infer] = ACTIONS(3985),
    [anon_sym_keyof] = ACTIONS(3987),
    [anon_sym_unknown] = ACTIONS(3969),
    [anon_sym_never] = ACTIONS(3969),
    [anon_sym_object] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3989),
  },
  [1313] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(2778),
    [sym_constructor_type] = STATE(2778),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(2778),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(2778),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(2778),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1314] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3440),
    [sym_constructor_type] = STATE(3440),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3440),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3440),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3440),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1315] = {
    [sym_component_identifier] = STATE(3493),
    [sym_new_component_body] = STATE(1960),
    [sym_tagged_type_string] = STATE(2108),
    [sym_tripple_tagged_type_string] = STATE(2109),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_COMMA] = ACTIONS(1852),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_COLON] = ACTIONS(1936),
    [anon_sym_EQ] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3677),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3682),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3684),
    [sym__automatic_semicolon] = ACTIONS(1852),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1316] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3380),
    [sym_constructor_type] = STATE(3380),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3380),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3380),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3380),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1317] = {
    [sym_nested_identifier] = STATE(4639),
    [sym_string] = STATE(3150),
    [sym_formal_parameters] = STATE(4801),
    [sym_nested_type_identifier] = STATE(2986),
    [sym__type] = STATE(3142),
    [sym_constructor_type] = STATE(3142),
    [sym__primary_type] = STATE(3156),
    [sym_template_literal_type] = STATE(3157),
    [sym_infer_type] = STATE(3142),
    [sym_conditional_type] = STATE(3157),
    [sym_generic_type] = STATE(3157),
    [sym_type_query] = STATE(3157),
    [sym_index_type_query] = STATE(3157),
    [sym_lookup_type] = STATE(3157),
    [sym_literal_type] = STATE(3157),
    [sym__number] = STATE(3158),
    [sym_existential_type] = STATE(3157),
    [sym_flow_maybe_type] = STATE(3157),
    [sym_parenthesized_type] = STATE(3157),
    [sym_predefined_type] = STATE(3157),
    [sym_object_type] = STATE(3157),
    [sym_type_parameters] = STATE(4371),
    [sym_array_type] = STATE(3157),
    [sym_tuple_type] = STATE(3157),
    [sym_readonly_type] = STATE(3142),
    [sym_union_type] = STATE(3157),
    [sym_intersection_type] = STATE(3157),
    [sym_function_type] = STATE(3142),
    [sym_identifier] = ACTIONS(4095),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_LBRACE] = ACTIONS(3827),
    [anon_sym_typeof] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(3833),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3839),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_void] = ACTIONS(3843),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3849),
    [sym_number] = ACTIONS(3851),
    [sym_this] = ACTIONS(4097),
    [sym_true] = ACTIONS(3855),
    [sym_false] = ACTIONS(3855),
    [sym_null] = ACTIONS(3855),
    [sym_undefined] = ACTIONS(3855),
    [anon_sym_readonly] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_any] = ACTIONS(3843),
    [anon_sym_number] = ACTIONS(3843),
    [anon_sym_boolean] = ACTIONS(3843),
    [anon_sym_string] = ACTIONS(3843),
    [anon_sym_symbol] = ACTIONS(3843),
    [anon_sym_abstract] = ACTIONS(3861),
    [anon_sym_infer] = ACTIONS(3865),
    [anon_sym_keyof] = ACTIONS(3867),
    [anon_sym_unknown] = ACTIONS(3843),
    [anon_sym_never] = ACTIONS(3843),
    [anon_sym_object] = ACTIONS(3843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3869),
  },
  [1318] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4859),
    [sym_nested_type_identifier] = STATE(3193),
    [sym__type] = STATE(3359),
    [sym_constructor_type] = STATE(3359),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3359),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4172),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3359),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3359),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_PIPE] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3939),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3943),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3945),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1319] = {
    [sym_nested_identifier] = STATE(4633),
    [sym_string] = STATE(1972),
    [sym_formal_parameters] = STATE(4675),
    [sym_nested_type_identifier] = STATE(1862),
    [sym__type] = STATE(1933),
    [sym_constructor_type] = STATE(1933),
    [sym__primary_type] = STATE(1965),
    [sym_template_literal_type] = STATE(1964),
    [sym_infer_type] = STATE(1933),
    [sym_conditional_type] = STATE(1964),
    [sym_generic_type] = STATE(1964),
    [sym_type_query] = STATE(1964),
    [sym_index_type_query] = STATE(1964),
    [sym_lookup_type] = STATE(1964),
    [sym_literal_type] = STATE(1964),
    [sym__number] = STATE(1961),
    [sym_existential_type] = STATE(1964),
    [sym_flow_maybe_type] = STATE(1964),
    [sym_parenthesized_type] = STATE(1964),
    [sym_predefined_type] = STATE(1964),
    [sym_object_type] = STATE(1964),
    [sym_type_parameters] = STATE(4387),
    [sym_array_type] = STATE(1964),
    [sym_tuple_type] = STATE(1964),
    [sym_readonly_type] = STATE(1933),
    [sym_union_type] = STATE(1964),
    [sym_intersection_type] = STATE(1964),
    [sym_function_type] = STATE(1933),
    [sym_identifier] = ACTIONS(4081),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_LBRACE] = ACTIONS(4027),
    [anon_sym_typeof] = ACTIONS(4029),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(4037),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4041),
    [anon_sym_void] = ACTIONS(4043),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [sym_number] = ACTIONS(4047),
    [sym_this] = ACTIONS(4083),
    [sym_true] = ACTIONS(4051),
    [sym_false] = ACTIONS(4051),
    [sym_null] = ACTIONS(4051),
    [sym_undefined] = ACTIONS(4051),
    [anon_sym_readonly] = ACTIONS(4053),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_any] = ACTIONS(4043),
    [anon_sym_number] = ACTIONS(4043),
    [anon_sym_boolean] = ACTIONS(4043),
    [anon_sym_string] = ACTIONS(4043),
    [anon_sym_symbol] = ACTIONS(4043),
    [anon_sym_abstract] = ACTIONS(4057),
    [anon_sym_infer] = ACTIONS(4059),
    [anon_sym_keyof] = ACTIONS(4061),
    [anon_sym_unknown] = ACTIONS(4043),
    [anon_sym_never] = ACTIONS(4043),
    [anon_sym_object] = ACTIONS(4043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4063),
  },
  [1320] = {
    [sym_component_identifier] = STATE(3375),
    [sym_new_component_body] = STATE(1721),
    [sym_tagged_type_string] = STATE(1832),
    [sym_tripple_tagged_type_string] = STATE(1831),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(1852),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_of] = ACTIONS(1852),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(1854),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3677),
    [anon_sym_EQ_GT] = ACTIONS(4099),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3704),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1868),
    [sym__automatic_semicolon] = ACTIONS(1852),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1321] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(2763),
    [sym_constructor_type] = STATE(2763),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(2763),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(2763),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(2763),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1322] = {
    [sym_arguments] = STATE(2741),
    [sym_component_identifier] = STATE(3375),
    [sym_new_component_body] = STATE(1721),
    [sym_tagged_type_string] = STATE(1832),
    [sym_tripple_tagged_type_string] = STATE(1831),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(2830),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(3877),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_EQ] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(2828),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3879),
    [anon_sym_EQ_GT] = ACTIONS(4103),
    [anon_sym_QMARK_DOT] = ACTIONS(3881),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(2828),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(2828),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3704),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_extends] = ACTIONS(2830),
    [anon_sym_implements] = ACTIONS(1852),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1868),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1323] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3039),
    [sym_constructor_type] = STATE(3039),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3039),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3039),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3039),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1324] = {
    [sym_nested_identifier] = STATE(4633),
    [sym_string] = STATE(1972),
    [sym_formal_parameters] = STATE(4675),
    [sym_nested_type_identifier] = STATE(1862),
    [sym__type] = STATE(1984),
    [sym_constructor_type] = STATE(1984),
    [sym__primary_type] = STATE(1965),
    [sym_template_literal_type] = STATE(1964),
    [sym_infer_type] = STATE(1984),
    [sym_conditional_type] = STATE(1964),
    [sym_generic_type] = STATE(1964),
    [sym_type_query] = STATE(1964),
    [sym_index_type_query] = STATE(1964),
    [sym_lookup_type] = STATE(1964),
    [sym_literal_type] = STATE(1964),
    [sym__number] = STATE(1961),
    [sym_existential_type] = STATE(1964),
    [sym_flow_maybe_type] = STATE(1964),
    [sym_parenthesized_type] = STATE(1964),
    [sym_predefined_type] = STATE(1964),
    [sym_object_type] = STATE(1964),
    [sym_type_parameters] = STATE(4387),
    [sym_array_type] = STATE(1964),
    [sym_tuple_type] = STATE(1964),
    [sym_readonly_type] = STATE(1984),
    [sym_union_type] = STATE(1964),
    [sym_intersection_type] = STATE(1964),
    [sym_function_type] = STATE(1984),
    [sym_identifier] = ACTIONS(4081),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_LBRACE] = ACTIONS(4027),
    [anon_sym_typeof] = ACTIONS(4029),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(4037),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4041),
    [anon_sym_void] = ACTIONS(4043),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [sym_number] = ACTIONS(4047),
    [sym_this] = ACTIONS(4083),
    [sym_true] = ACTIONS(4051),
    [sym_false] = ACTIONS(4051),
    [sym_null] = ACTIONS(4051),
    [sym_undefined] = ACTIONS(4051),
    [anon_sym_readonly] = ACTIONS(4053),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_any] = ACTIONS(4043),
    [anon_sym_number] = ACTIONS(4043),
    [anon_sym_boolean] = ACTIONS(4043),
    [anon_sym_string] = ACTIONS(4043),
    [anon_sym_symbol] = ACTIONS(4043),
    [anon_sym_abstract] = ACTIONS(4057),
    [anon_sym_infer] = ACTIONS(4059),
    [anon_sym_keyof] = ACTIONS(4061),
    [anon_sym_unknown] = ACTIONS(4043),
    [anon_sym_never] = ACTIONS(4043),
    [anon_sym_object] = ACTIONS(4043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4063),
  },
  [1325] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(2773),
    [sym_constructor_type] = STATE(2773),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(2773),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(2773),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(2773),
    [sym_identifier] = ACTIONS(4105),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1326] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3879),
    [sym_constructor_type] = STATE(3879),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3879),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3879),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3879),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1327] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3858),
    [sym_constructor_type] = STATE(3858),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3858),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3858),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3858),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1328] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3400),
    [sym_constructor_type] = STATE(3400),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3400),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3400),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3400),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1329] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4859),
    [sym_nested_type_identifier] = STATE(3193),
    [sym__type] = STATE(2773),
    [sym_constructor_type] = STATE(2773),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(2773),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4172),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(2773),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(2773),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_PIPE] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3939),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3943),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3945),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1330] = {
    [sym_nested_identifier] = STATE(4559),
    [sym_string] = STATE(1693),
    [sym_formal_parameters] = STATE(4819),
    [sym_nested_type_identifier] = STATE(1628),
    [sym__type] = STATE(1701),
    [sym_constructor_type] = STATE(1701),
    [sym__primary_type] = STATE(1647),
    [sym_template_literal_type] = STATE(1697),
    [sym_infer_type] = STATE(1701),
    [sym_conditional_type] = STATE(1697),
    [sym_generic_type] = STATE(1697),
    [sym_type_query] = STATE(1697),
    [sym_index_type_query] = STATE(1697),
    [sym_lookup_type] = STATE(1697),
    [sym_literal_type] = STATE(1697),
    [sym__number] = STATE(1699),
    [sym_existential_type] = STATE(1697),
    [sym_flow_maybe_type] = STATE(1697),
    [sym_parenthesized_type] = STATE(1697),
    [sym_predefined_type] = STATE(1697),
    [sym_object_type] = STATE(1697),
    [sym_type_parameters] = STATE(4263),
    [sym_array_type] = STATE(1697),
    [sym_tuple_type] = STATE(1697),
    [sym_readonly_type] = STATE(1701),
    [sym_union_type] = STATE(1697),
    [sym_intersection_type] = STATE(1697),
    [sym_function_type] = STATE(1701),
    [sym_identifier] = ACTIONS(4077),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_typeof] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_void] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3971),
    [sym_number] = ACTIONS(3973),
    [sym_this] = ACTIONS(4079),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [sym_null] = ACTIONS(3977),
    [sym_undefined] = ACTIONS(3977),
    [anon_sym_readonly] = ACTIONS(3979),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_any] = ACTIONS(3969),
    [anon_sym_number] = ACTIONS(3969),
    [anon_sym_boolean] = ACTIONS(3969),
    [anon_sym_string] = ACTIONS(3969),
    [anon_sym_symbol] = ACTIONS(3969),
    [anon_sym_abstract] = ACTIONS(3983),
    [anon_sym_infer] = ACTIONS(3985),
    [anon_sym_keyof] = ACTIONS(3987),
    [anon_sym_unknown] = ACTIONS(3969),
    [anon_sym_never] = ACTIONS(3969),
    [anon_sym_object] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3989),
  },
  [1331] = {
    [sym_nested_identifier] = STATE(4603),
    [sym_string] = STATE(938),
    [sym_formal_parameters] = STATE(4595),
    [sym_nested_type_identifier] = STATE(786),
    [sym__type] = STATE(963),
    [sym_constructor_type] = STATE(963),
    [sym__primary_type] = STATE(925),
    [sym_template_literal_type] = STATE(911),
    [sym_infer_type] = STATE(963),
    [sym_conditional_type] = STATE(911),
    [sym_generic_type] = STATE(911),
    [sym_type_query] = STATE(911),
    [sym_index_type_query] = STATE(911),
    [sym_lookup_type] = STATE(911),
    [sym_literal_type] = STATE(911),
    [sym__number] = STATE(899),
    [sym_existential_type] = STATE(911),
    [sym_flow_maybe_type] = STATE(911),
    [sym_parenthesized_type] = STATE(911),
    [sym_predefined_type] = STATE(911),
    [sym_object_type] = STATE(911),
    [sym_type_parameters] = STATE(4495),
    [sym_array_type] = STATE(911),
    [sym_tuple_type] = STATE(911),
    [sym_readonly_type] = STATE(963),
    [sym_union_type] = STATE(911),
    [sym_intersection_type] = STATE(911),
    [sym_function_type] = STATE(963),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3891),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3897),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3901),
    [anon_sym_DASH] = ACTIONS(3901),
    [anon_sym_void] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3905),
    [sym_number] = ACTIONS(3907),
    [sym_this] = ACTIONS(4089),
    [sym_true] = ACTIONS(3911),
    [sym_false] = ACTIONS(3911),
    [sym_null] = ACTIONS(3911),
    [sym_undefined] = ACTIONS(3911),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3903),
    [anon_sym_number] = ACTIONS(3903),
    [anon_sym_boolean] = ACTIONS(3903),
    [anon_sym_string] = ACTIONS(3903),
    [anon_sym_symbol] = ACTIONS(3903),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3919),
    [anon_sym_keyof] = ACTIONS(3921),
    [anon_sym_unknown] = ACTIONS(3903),
    [anon_sym_never] = ACTIONS(3903),
    [anon_sym_object] = ACTIONS(3903),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
  },
  [1332] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3824),
    [sym_constructor_type] = STATE(3824),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3824),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3824),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3824),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1333] = {
    [sym_nested_identifier] = STATE(4603),
    [sym_string] = STATE(938),
    [sym_formal_parameters] = STATE(4595),
    [sym_nested_type_identifier] = STATE(786),
    [sym__type] = STATE(976),
    [sym_constructor_type] = STATE(976),
    [sym__primary_type] = STATE(925),
    [sym_template_literal_type] = STATE(911),
    [sym_infer_type] = STATE(976),
    [sym_conditional_type] = STATE(911),
    [sym_generic_type] = STATE(911),
    [sym_type_query] = STATE(911),
    [sym_index_type_query] = STATE(911),
    [sym_lookup_type] = STATE(911),
    [sym_literal_type] = STATE(911),
    [sym__number] = STATE(899),
    [sym_existential_type] = STATE(911),
    [sym_flow_maybe_type] = STATE(911),
    [sym_parenthesized_type] = STATE(911),
    [sym_predefined_type] = STATE(911),
    [sym_object_type] = STATE(911),
    [sym_type_parameters] = STATE(4495),
    [sym_array_type] = STATE(911),
    [sym_tuple_type] = STATE(911),
    [sym_readonly_type] = STATE(976),
    [sym_union_type] = STATE(911),
    [sym_intersection_type] = STATE(911),
    [sym_function_type] = STATE(976),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3891),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3897),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3901),
    [anon_sym_DASH] = ACTIONS(3901),
    [anon_sym_void] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3905),
    [sym_number] = ACTIONS(3907),
    [sym_this] = ACTIONS(4089),
    [sym_true] = ACTIONS(3911),
    [sym_false] = ACTIONS(3911),
    [sym_null] = ACTIONS(3911),
    [sym_undefined] = ACTIONS(3911),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3903),
    [anon_sym_number] = ACTIONS(3903),
    [anon_sym_boolean] = ACTIONS(3903),
    [anon_sym_string] = ACTIONS(3903),
    [anon_sym_symbol] = ACTIONS(3903),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3919),
    [anon_sym_keyof] = ACTIONS(3921),
    [anon_sym_unknown] = ACTIONS(3903),
    [anon_sym_never] = ACTIONS(3903),
    [anon_sym_object] = ACTIONS(3903),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
  },
  [1334] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(2763),
    [sym_constructor_type] = STATE(2763),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(2763),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(2763),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(2763),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1335] = {
    [sym_nested_identifier] = STATE(4633),
    [sym_string] = STATE(1972),
    [sym_formal_parameters] = STATE(4675),
    [sym_nested_type_identifier] = STATE(1862),
    [sym__type] = STATE(2047),
    [sym_constructor_type] = STATE(2047),
    [sym__primary_type] = STATE(1965),
    [sym_template_literal_type] = STATE(1964),
    [sym_infer_type] = STATE(2047),
    [sym_conditional_type] = STATE(1964),
    [sym_generic_type] = STATE(1964),
    [sym_type_query] = STATE(1964),
    [sym_index_type_query] = STATE(1964),
    [sym_lookup_type] = STATE(1964),
    [sym_literal_type] = STATE(1964),
    [sym__number] = STATE(1961),
    [sym_existential_type] = STATE(1964),
    [sym_flow_maybe_type] = STATE(1964),
    [sym_parenthesized_type] = STATE(1964),
    [sym_predefined_type] = STATE(1964),
    [sym_object_type] = STATE(1964),
    [sym_type_parameters] = STATE(4387),
    [sym_array_type] = STATE(1964),
    [sym_tuple_type] = STATE(1964),
    [sym_readonly_type] = STATE(2047),
    [sym_union_type] = STATE(1964),
    [sym_intersection_type] = STATE(1964),
    [sym_function_type] = STATE(2047),
    [sym_identifier] = ACTIONS(4081),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_LBRACE] = ACTIONS(4027),
    [anon_sym_typeof] = ACTIONS(4029),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(4037),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4041),
    [anon_sym_void] = ACTIONS(4043),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [sym_number] = ACTIONS(4047),
    [sym_this] = ACTIONS(4083),
    [sym_true] = ACTIONS(4051),
    [sym_false] = ACTIONS(4051),
    [sym_null] = ACTIONS(4051),
    [sym_undefined] = ACTIONS(4051),
    [anon_sym_readonly] = ACTIONS(4053),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_any] = ACTIONS(4043),
    [anon_sym_number] = ACTIONS(4043),
    [anon_sym_boolean] = ACTIONS(4043),
    [anon_sym_string] = ACTIONS(4043),
    [anon_sym_symbol] = ACTIONS(4043),
    [anon_sym_abstract] = ACTIONS(4057),
    [anon_sym_infer] = ACTIONS(4059),
    [anon_sym_keyof] = ACTIONS(4061),
    [anon_sym_unknown] = ACTIONS(4043),
    [anon_sym_never] = ACTIONS(4043),
    [anon_sym_object] = ACTIONS(4043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4063),
  },
  [1336] = {
    [sym_nested_identifier] = STATE(4603),
    [sym_string] = STATE(938),
    [sym_formal_parameters] = STATE(4595),
    [sym_nested_type_identifier] = STATE(786),
    [sym__type] = STATE(933),
    [sym_constructor_type] = STATE(933),
    [sym__primary_type] = STATE(925),
    [sym_template_literal_type] = STATE(911),
    [sym_infer_type] = STATE(933),
    [sym_conditional_type] = STATE(911),
    [sym_generic_type] = STATE(911),
    [sym_type_query] = STATE(911),
    [sym_index_type_query] = STATE(911),
    [sym_lookup_type] = STATE(911),
    [sym_literal_type] = STATE(911),
    [sym__number] = STATE(899),
    [sym_existential_type] = STATE(911),
    [sym_flow_maybe_type] = STATE(911),
    [sym_parenthesized_type] = STATE(911),
    [sym_predefined_type] = STATE(911),
    [sym_object_type] = STATE(911),
    [sym_type_parameters] = STATE(4495),
    [sym_array_type] = STATE(911),
    [sym_tuple_type] = STATE(911),
    [sym_readonly_type] = STATE(933),
    [sym_union_type] = STATE(911),
    [sym_intersection_type] = STATE(911),
    [sym_function_type] = STATE(933),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3891),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3897),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3901),
    [anon_sym_DASH] = ACTIONS(3901),
    [anon_sym_void] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3905),
    [sym_number] = ACTIONS(3907),
    [sym_this] = ACTIONS(4089),
    [sym_true] = ACTIONS(3911),
    [sym_false] = ACTIONS(3911),
    [sym_null] = ACTIONS(3911),
    [sym_undefined] = ACTIONS(3911),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3903),
    [anon_sym_number] = ACTIONS(3903),
    [anon_sym_boolean] = ACTIONS(3903),
    [anon_sym_string] = ACTIONS(3903),
    [anon_sym_symbol] = ACTIONS(3903),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3919),
    [anon_sym_keyof] = ACTIONS(3921),
    [anon_sym_unknown] = ACTIONS(3903),
    [anon_sym_never] = ACTIONS(3903),
    [anon_sym_object] = ACTIONS(3903),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
  },
  [1337] = {
    [sym_nested_identifier] = STATE(4559),
    [sym_string] = STATE(1693),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(1628),
    [sym__type] = STATE(4129),
    [sym_constructor_type] = STATE(4129),
    [sym__primary_type] = STATE(1737),
    [sym_template_literal_type] = STATE(1697),
    [sym_infer_type] = STATE(4129),
    [sym_conditional_type] = STATE(1697),
    [sym_generic_type] = STATE(1697),
    [sym_type_query] = STATE(1697),
    [sym_index_type_query] = STATE(1697),
    [sym_lookup_type] = STATE(1697),
    [sym_literal_type] = STATE(1697),
    [sym__number] = STATE(1699),
    [sym_existential_type] = STATE(1697),
    [sym_flow_maybe_type] = STATE(1697),
    [sym_parenthesized_type] = STATE(1697),
    [sym_predefined_type] = STATE(1697),
    [sym_object_type] = STATE(1697),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(1697),
    [sym_tuple_type] = STATE(1697),
    [sym_readonly_type] = STATE(4129),
    [sym_union_type] = STATE(1697),
    [sym_intersection_type] = STATE(1697),
    [sym_function_type] = STATE(4129),
    [sym_identifier] = ACTIONS(4077),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_typeof] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_void] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3971),
    [sym_number] = ACTIONS(3973),
    [sym_this] = ACTIONS(4079),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [sym_null] = ACTIONS(3977),
    [sym_undefined] = ACTIONS(3977),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_any] = ACTIONS(3969),
    [anon_sym_number] = ACTIONS(3969),
    [anon_sym_boolean] = ACTIONS(3969),
    [anon_sym_string] = ACTIONS(3969),
    [anon_sym_symbol] = ACTIONS(3969),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3987),
    [anon_sym_unknown] = ACTIONS(3969),
    [anon_sym_never] = ACTIONS(3969),
    [anon_sym_object] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3989),
  },
  [1338] = {
    [sym_nested_identifier] = STATE(4639),
    [sym_string] = STATE(3150),
    [sym_formal_parameters] = STATE(4801),
    [sym_nested_type_identifier] = STATE(2986),
    [sym__type] = STATE(3148),
    [sym_constructor_type] = STATE(3148),
    [sym__primary_type] = STATE(3156),
    [sym_template_literal_type] = STATE(3157),
    [sym_infer_type] = STATE(3148),
    [sym_conditional_type] = STATE(3157),
    [sym_generic_type] = STATE(3157),
    [sym_type_query] = STATE(3157),
    [sym_index_type_query] = STATE(3157),
    [sym_lookup_type] = STATE(3157),
    [sym_literal_type] = STATE(3157),
    [sym__number] = STATE(3158),
    [sym_existential_type] = STATE(3157),
    [sym_flow_maybe_type] = STATE(3157),
    [sym_parenthesized_type] = STATE(3157),
    [sym_predefined_type] = STATE(3157),
    [sym_object_type] = STATE(3157),
    [sym_type_parameters] = STATE(4371),
    [sym_array_type] = STATE(3157),
    [sym_tuple_type] = STATE(3157),
    [sym_readonly_type] = STATE(3148),
    [sym_union_type] = STATE(3157),
    [sym_intersection_type] = STATE(3157),
    [sym_function_type] = STATE(3148),
    [sym_identifier] = ACTIONS(4095),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_LBRACE] = ACTIONS(3827),
    [anon_sym_typeof] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(3833),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3839),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_void] = ACTIONS(3843),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3849),
    [sym_number] = ACTIONS(3851),
    [sym_this] = ACTIONS(4097),
    [sym_true] = ACTIONS(3855),
    [sym_false] = ACTIONS(3855),
    [sym_null] = ACTIONS(3855),
    [sym_undefined] = ACTIONS(3855),
    [anon_sym_readonly] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_any] = ACTIONS(3843),
    [anon_sym_number] = ACTIONS(3843),
    [anon_sym_boolean] = ACTIONS(3843),
    [anon_sym_string] = ACTIONS(3843),
    [anon_sym_symbol] = ACTIONS(3843),
    [anon_sym_abstract] = ACTIONS(3861),
    [anon_sym_infer] = ACTIONS(3865),
    [anon_sym_keyof] = ACTIONS(3867),
    [anon_sym_unknown] = ACTIONS(3843),
    [anon_sym_never] = ACTIONS(3843),
    [anon_sym_object] = ACTIONS(3843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3869),
  },
  [1339] = {
    [sym_nested_identifier] = STATE(4639),
    [sym_string] = STATE(3150),
    [sym_formal_parameters] = STATE(4801),
    [sym_nested_type_identifier] = STATE(2986),
    [sym__type] = STATE(3160),
    [sym_constructor_type] = STATE(3160),
    [sym__primary_type] = STATE(3156),
    [sym_template_literal_type] = STATE(3157),
    [sym_infer_type] = STATE(3160),
    [sym_conditional_type] = STATE(3157),
    [sym_generic_type] = STATE(3157),
    [sym_type_query] = STATE(3157),
    [sym_index_type_query] = STATE(3157),
    [sym_lookup_type] = STATE(3157),
    [sym_literal_type] = STATE(3157),
    [sym__number] = STATE(3158),
    [sym_existential_type] = STATE(3157),
    [sym_flow_maybe_type] = STATE(3157),
    [sym_parenthesized_type] = STATE(3157),
    [sym_predefined_type] = STATE(3157),
    [sym_object_type] = STATE(3157),
    [sym_type_parameters] = STATE(4371),
    [sym_array_type] = STATE(3157),
    [sym_tuple_type] = STATE(3157),
    [sym_readonly_type] = STATE(3160),
    [sym_union_type] = STATE(3157),
    [sym_intersection_type] = STATE(3157),
    [sym_function_type] = STATE(3160),
    [sym_identifier] = ACTIONS(4095),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_LBRACE] = ACTIONS(3827),
    [anon_sym_typeof] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(3833),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3839),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_void] = ACTIONS(3843),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3849),
    [sym_number] = ACTIONS(3851),
    [sym_this] = ACTIONS(4097),
    [sym_true] = ACTIONS(3855),
    [sym_false] = ACTIONS(3855),
    [sym_null] = ACTIONS(3855),
    [sym_undefined] = ACTIONS(3855),
    [anon_sym_readonly] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_any] = ACTIONS(3843),
    [anon_sym_number] = ACTIONS(3843),
    [anon_sym_boolean] = ACTIONS(3843),
    [anon_sym_string] = ACTIONS(3843),
    [anon_sym_symbol] = ACTIONS(3843),
    [anon_sym_abstract] = ACTIONS(3861),
    [anon_sym_infer] = ACTIONS(3865),
    [anon_sym_keyof] = ACTIONS(3867),
    [anon_sym_unknown] = ACTIONS(3843),
    [anon_sym_never] = ACTIONS(3843),
    [anon_sym_object] = ACTIONS(3843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3869),
  },
  [1340] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(2995),
    [sym_constructor_type] = STATE(2995),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(2995),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(2995),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(2995),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1341] = {
    [sym_nested_identifier] = STATE(4559),
    [sym_string] = STATE(1693),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(1628),
    [sym__type] = STATE(4129),
    [sym_constructor_type] = STATE(4129),
    [sym__primary_type] = STATE(1735),
    [sym_template_literal_type] = STATE(1697),
    [sym_infer_type] = STATE(4129),
    [sym_conditional_type] = STATE(1697),
    [sym_generic_type] = STATE(1697),
    [sym_type_query] = STATE(1697),
    [sym_index_type_query] = STATE(1697),
    [sym_lookup_type] = STATE(1697),
    [sym_literal_type] = STATE(1697),
    [sym__number] = STATE(1699),
    [sym_existential_type] = STATE(1697),
    [sym_flow_maybe_type] = STATE(1697),
    [sym_parenthesized_type] = STATE(1697),
    [sym_predefined_type] = STATE(1697),
    [sym_object_type] = STATE(1697),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(1697),
    [sym_tuple_type] = STATE(1697),
    [sym_readonly_type] = STATE(4129),
    [sym_union_type] = STATE(1697),
    [sym_intersection_type] = STATE(1697),
    [sym_function_type] = STATE(4129),
    [sym_identifier] = ACTIONS(4077),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_typeof] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_void] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3971),
    [sym_number] = ACTIONS(3973),
    [sym_this] = ACTIONS(4079),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [sym_null] = ACTIONS(3977),
    [sym_undefined] = ACTIONS(3977),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_any] = ACTIONS(3969),
    [anon_sym_number] = ACTIONS(3969),
    [anon_sym_boolean] = ACTIONS(3969),
    [anon_sym_string] = ACTIONS(3969),
    [anon_sym_symbol] = ACTIONS(3969),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3987),
    [anon_sym_unknown] = ACTIONS(3969),
    [anon_sym_never] = ACTIONS(3969),
    [anon_sym_object] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3989),
  },
  [1342] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(2798),
    [sym_constructor_type] = STATE(2798),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(2798),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(2798),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(2798),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1343] = {
    [sym_nested_identifier] = STATE(4559),
    [sym_string] = STATE(1693),
    [sym_formal_parameters] = STATE(4819),
    [sym_nested_type_identifier] = STATE(1628),
    [sym__type] = STATE(1734),
    [sym_constructor_type] = STATE(1734),
    [sym__primary_type] = STATE(1647),
    [sym_template_literal_type] = STATE(1697),
    [sym_infer_type] = STATE(1734),
    [sym_conditional_type] = STATE(1697),
    [sym_generic_type] = STATE(1697),
    [sym_type_query] = STATE(1697),
    [sym_index_type_query] = STATE(1697),
    [sym_lookup_type] = STATE(1697),
    [sym_literal_type] = STATE(1697),
    [sym__number] = STATE(1699),
    [sym_existential_type] = STATE(1697),
    [sym_flow_maybe_type] = STATE(1697),
    [sym_parenthesized_type] = STATE(1697),
    [sym_predefined_type] = STATE(1697),
    [sym_object_type] = STATE(1697),
    [sym_type_parameters] = STATE(4263),
    [sym_array_type] = STATE(1697),
    [sym_tuple_type] = STATE(1697),
    [sym_readonly_type] = STATE(1734),
    [sym_union_type] = STATE(1697),
    [sym_intersection_type] = STATE(1697),
    [sym_function_type] = STATE(1734),
    [sym_identifier] = ACTIONS(4077),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_typeof] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_void] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3971),
    [sym_number] = ACTIONS(3973),
    [sym_this] = ACTIONS(4079),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [sym_null] = ACTIONS(3977),
    [sym_undefined] = ACTIONS(3977),
    [anon_sym_readonly] = ACTIONS(3979),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_any] = ACTIONS(3969),
    [anon_sym_number] = ACTIONS(3969),
    [anon_sym_boolean] = ACTIONS(3969),
    [anon_sym_string] = ACTIONS(3969),
    [anon_sym_symbol] = ACTIONS(3969),
    [anon_sym_abstract] = ACTIONS(3983),
    [anon_sym_infer] = ACTIONS(3985),
    [anon_sym_keyof] = ACTIONS(3987),
    [anon_sym_unknown] = ACTIONS(3969),
    [anon_sym_never] = ACTIONS(3969),
    [anon_sym_object] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3989),
  },
  [1344] = {
    [sym_component_identifier] = STATE(3493),
    [sym_new_component_body] = STATE(1960),
    [sym_tagged_type_string] = STATE(2108),
    [sym_tripple_tagged_type_string] = STATE(2109),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_COMMA] = ACTIONS(1852),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(4107),
    [anon_sym_of] = ACTIONS(4110),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3677),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3682),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3684),
    [sym__automatic_semicolon] = ACTIONS(1852),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1345] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(2773),
    [sym_constructor_type] = STATE(2773),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(2773),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(2773),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(2773),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1346] = {
    [sym_nested_identifier] = STATE(4633),
    [sym_string] = STATE(1972),
    [sym_formal_parameters] = STATE(4675),
    [sym_nested_type_identifier] = STATE(1862),
    [sym__type] = STATE(2053),
    [sym_constructor_type] = STATE(2053),
    [sym__primary_type] = STATE(1965),
    [sym_template_literal_type] = STATE(1964),
    [sym_infer_type] = STATE(2053),
    [sym_conditional_type] = STATE(1964),
    [sym_generic_type] = STATE(1964),
    [sym_type_query] = STATE(1964),
    [sym_index_type_query] = STATE(1964),
    [sym_lookup_type] = STATE(1964),
    [sym_literal_type] = STATE(1964),
    [sym__number] = STATE(1961),
    [sym_existential_type] = STATE(1964),
    [sym_flow_maybe_type] = STATE(1964),
    [sym_parenthesized_type] = STATE(1964),
    [sym_predefined_type] = STATE(1964),
    [sym_object_type] = STATE(1964),
    [sym_type_parameters] = STATE(4387),
    [sym_array_type] = STATE(1964),
    [sym_tuple_type] = STATE(1964),
    [sym_readonly_type] = STATE(2053),
    [sym_union_type] = STATE(1964),
    [sym_intersection_type] = STATE(1964),
    [sym_function_type] = STATE(2053),
    [sym_identifier] = ACTIONS(4081),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_LBRACE] = ACTIONS(4027),
    [anon_sym_typeof] = ACTIONS(4029),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(4037),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4041),
    [anon_sym_void] = ACTIONS(4043),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [sym_number] = ACTIONS(4047),
    [sym_this] = ACTIONS(4083),
    [sym_true] = ACTIONS(4051),
    [sym_false] = ACTIONS(4051),
    [sym_null] = ACTIONS(4051),
    [sym_undefined] = ACTIONS(4051),
    [anon_sym_readonly] = ACTIONS(4053),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_any] = ACTIONS(4043),
    [anon_sym_number] = ACTIONS(4043),
    [anon_sym_boolean] = ACTIONS(4043),
    [anon_sym_string] = ACTIONS(4043),
    [anon_sym_symbol] = ACTIONS(4043),
    [anon_sym_abstract] = ACTIONS(4057),
    [anon_sym_infer] = ACTIONS(4059),
    [anon_sym_keyof] = ACTIONS(4061),
    [anon_sym_unknown] = ACTIONS(4043),
    [anon_sym_never] = ACTIONS(4043),
    [anon_sym_object] = ACTIONS(4043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4063),
  },
  [1347] = {
    [sym_nested_identifier] = STATE(4559),
    [sym_string] = STATE(1693),
    [sym_formal_parameters] = STATE(4819),
    [sym_nested_type_identifier] = STATE(1628),
    [sym__type] = STATE(1730),
    [sym_constructor_type] = STATE(1730),
    [sym__primary_type] = STATE(1647),
    [sym_template_literal_type] = STATE(1697),
    [sym_infer_type] = STATE(1730),
    [sym_conditional_type] = STATE(1697),
    [sym_generic_type] = STATE(1697),
    [sym_type_query] = STATE(1697),
    [sym_index_type_query] = STATE(1697),
    [sym_lookup_type] = STATE(1697),
    [sym_literal_type] = STATE(1697),
    [sym__number] = STATE(1699),
    [sym_existential_type] = STATE(1697),
    [sym_flow_maybe_type] = STATE(1697),
    [sym_parenthesized_type] = STATE(1697),
    [sym_predefined_type] = STATE(1697),
    [sym_object_type] = STATE(1697),
    [sym_type_parameters] = STATE(4263),
    [sym_array_type] = STATE(1697),
    [sym_tuple_type] = STATE(1697),
    [sym_readonly_type] = STATE(1730),
    [sym_union_type] = STATE(1697),
    [sym_intersection_type] = STATE(1697),
    [sym_function_type] = STATE(1730),
    [sym_identifier] = ACTIONS(4077),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_typeof] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_void] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3971),
    [sym_number] = ACTIONS(3973),
    [sym_this] = ACTIONS(4079),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [sym_null] = ACTIONS(3977),
    [sym_undefined] = ACTIONS(3977),
    [anon_sym_readonly] = ACTIONS(3979),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_any] = ACTIONS(3969),
    [anon_sym_number] = ACTIONS(3969),
    [anon_sym_boolean] = ACTIONS(3969),
    [anon_sym_string] = ACTIONS(3969),
    [anon_sym_symbol] = ACTIONS(3969),
    [anon_sym_abstract] = ACTIONS(3983),
    [anon_sym_infer] = ACTIONS(3985),
    [anon_sym_keyof] = ACTIONS(3987),
    [anon_sym_unknown] = ACTIONS(3969),
    [anon_sym_never] = ACTIONS(3969),
    [anon_sym_object] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3989),
  },
  [1348] = {
    [sym_nested_identifier] = STATE(4559),
    [sym_string] = STATE(1693),
    [sym_formal_parameters] = STATE(4819),
    [sym_nested_type_identifier] = STATE(1628),
    [sym__type] = STATE(1729),
    [sym_constructor_type] = STATE(1729),
    [sym__primary_type] = STATE(1647),
    [sym_template_literal_type] = STATE(1697),
    [sym_infer_type] = STATE(1729),
    [sym_conditional_type] = STATE(1697),
    [sym_generic_type] = STATE(1697),
    [sym_type_query] = STATE(1697),
    [sym_index_type_query] = STATE(1697),
    [sym_lookup_type] = STATE(1697),
    [sym_literal_type] = STATE(1697),
    [sym__number] = STATE(1699),
    [sym_existential_type] = STATE(1697),
    [sym_flow_maybe_type] = STATE(1697),
    [sym_parenthesized_type] = STATE(1697),
    [sym_predefined_type] = STATE(1697),
    [sym_object_type] = STATE(1697),
    [sym_type_parameters] = STATE(4263),
    [sym_array_type] = STATE(1697),
    [sym_tuple_type] = STATE(1697),
    [sym_readonly_type] = STATE(1729),
    [sym_union_type] = STATE(1697),
    [sym_intersection_type] = STATE(1697),
    [sym_function_type] = STATE(1729),
    [sym_identifier] = ACTIONS(4077),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_typeof] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_void] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3971),
    [sym_number] = ACTIONS(3973),
    [sym_this] = ACTIONS(4079),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [sym_null] = ACTIONS(3977),
    [sym_undefined] = ACTIONS(3977),
    [anon_sym_readonly] = ACTIONS(3979),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_any] = ACTIONS(3969),
    [anon_sym_number] = ACTIONS(3969),
    [anon_sym_boolean] = ACTIONS(3969),
    [anon_sym_string] = ACTIONS(3969),
    [anon_sym_symbol] = ACTIONS(3969),
    [anon_sym_abstract] = ACTIONS(3983),
    [anon_sym_infer] = ACTIONS(3985),
    [anon_sym_keyof] = ACTIONS(3987),
    [anon_sym_unknown] = ACTIONS(3969),
    [anon_sym_never] = ACTIONS(3969),
    [anon_sym_object] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3989),
  },
  [1349] = {
    [sym_nested_identifier] = STATE(4639),
    [sym_string] = STATE(3150),
    [sym_formal_parameters] = STATE(4801),
    [sym_nested_type_identifier] = STATE(2986),
    [sym__type] = STATE(3117),
    [sym_constructor_type] = STATE(3117),
    [sym__primary_type] = STATE(3156),
    [sym_template_literal_type] = STATE(3157),
    [sym_infer_type] = STATE(3117),
    [sym_conditional_type] = STATE(3157),
    [sym_generic_type] = STATE(3157),
    [sym_type_query] = STATE(3157),
    [sym_index_type_query] = STATE(3157),
    [sym_lookup_type] = STATE(3157),
    [sym_literal_type] = STATE(3157),
    [sym__number] = STATE(3158),
    [sym_existential_type] = STATE(3157),
    [sym_flow_maybe_type] = STATE(3157),
    [sym_parenthesized_type] = STATE(3157),
    [sym_predefined_type] = STATE(3157),
    [sym_object_type] = STATE(3157),
    [sym_type_parameters] = STATE(4371),
    [sym_array_type] = STATE(3157),
    [sym_tuple_type] = STATE(3157),
    [sym_readonly_type] = STATE(3117),
    [sym_union_type] = STATE(3157),
    [sym_intersection_type] = STATE(3157),
    [sym_function_type] = STATE(3117),
    [sym_identifier] = ACTIONS(4095),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_LBRACE] = ACTIONS(3827),
    [anon_sym_typeof] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(3833),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3839),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_void] = ACTIONS(3843),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3849),
    [sym_number] = ACTIONS(3851),
    [sym_this] = ACTIONS(4097),
    [sym_true] = ACTIONS(3855),
    [sym_false] = ACTIONS(3855),
    [sym_null] = ACTIONS(3855),
    [sym_undefined] = ACTIONS(3855),
    [anon_sym_readonly] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_any] = ACTIONS(3843),
    [anon_sym_number] = ACTIONS(3843),
    [anon_sym_boolean] = ACTIONS(3843),
    [anon_sym_string] = ACTIONS(3843),
    [anon_sym_symbol] = ACTIONS(3843),
    [anon_sym_abstract] = ACTIONS(3861),
    [anon_sym_infer] = ACTIONS(3865),
    [anon_sym_keyof] = ACTIONS(3867),
    [anon_sym_unknown] = ACTIONS(3843),
    [anon_sym_never] = ACTIONS(3843),
    [anon_sym_object] = ACTIONS(3843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3869),
  },
  [1350] = {
    [sym_nested_identifier] = STATE(4633),
    [sym_string] = STATE(1972),
    [sym_formal_parameters] = STATE(4675),
    [sym_nested_type_identifier] = STATE(1862),
    [sym__type] = STATE(2055),
    [sym_constructor_type] = STATE(2055),
    [sym__primary_type] = STATE(1965),
    [sym_template_literal_type] = STATE(1964),
    [sym_infer_type] = STATE(2055),
    [sym_conditional_type] = STATE(1964),
    [sym_generic_type] = STATE(1964),
    [sym_type_query] = STATE(1964),
    [sym_index_type_query] = STATE(1964),
    [sym_lookup_type] = STATE(1964),
    [sym_literal_type] = STATE(1964),
    [sym__number] = STATE(1961),
    [sym_existential_type] = STATE(1964),
    [sym_flow_maybe_type] = STATE(1964),
    [sym_parenthesized_type] = STATE(1964),
    [sym_predefined_type] = STATE(1964),
    [sym_object_type] = STATE(1964),
    [sym_type_parameters] = STATE(4387),
    [sym_array_type] = STATE(1964),
    [sym_tuple_type] = STATE(1964),
    [sym_readonly_type] = STATE(2055),
    [sym_union_type] = STATE(1964),
    [sym_intersection_type] = STATE(1964),
    [sym_function_type] = STATE(2055),
    [sym_identifier] = ACTIONS(4081),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_LBRACE] = ACTIONS(4027),
    [anon_sym_typeof] = ACTIONS(4029),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(4037),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4041),
    [anon_sym_void] = ACTIONS(4043),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [sym_number] = ACTIONS(4047),
    [sym_this] = ACTIONS(4083),
    [sym_true] = ACTIONS(4051),
    [sym_false] = ACTIONS(4051),
    [sym_null] = ACTIONS(4051),
    [sym_undefined] = ACTIONS(4051),
    [anon_sym_readonly] = ACTIONS(4053),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_any] = ACTIONS(4043),
    [anon_sym_number] = ACTIONS(4043),
    [anon_sym_boolean] = ACTIONS(4043),
    [anon_sym_string] = ACTIONS(4043),
    [anon_sym_symbol] = ACTIONS(4043),
    [anon_sym_abstract] = ACTIONS(4057),
    [anon_sym_infer] = ACTIONS(4059),
    [anon_sym_keyof] = ACTIONS(4061),
    [anon_sym_unknown] = ACTIONS(4043),
    [anon_sym_never] = ACTIONS(4043),
    [anon_sym_object] = ACTIONS(4043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4063),
  },
  [1351] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(2778),
    [sym_constructor_type] = STATE(2778),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(2778),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(2778),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(2778),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1352] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3040),
    [sym_constructor_type] = STATE(3040),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3040),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3040),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3040),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1353] = {
    [sym_component_identifier] = STATE(3375),
    [sym_new_component_body] = STATE(1721),
    [sym_tagged_type_string] = STATE(1832),
    [sym_tripple_tagged_type_string] = STATE(1831),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(1852),
    [anon_sym_RBRACE] = ACTIONS(1852),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_RPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_EQ] = ACTIONS(1854),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_RBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3677),
    [anon_sym_EQ_GT] = ACTIONS(3700),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3704),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1868),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1354] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(2991),
    [sym_constructor_type] = STATE(2991),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(2991),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(2991),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(2991),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1355] = {
    [sym_nested_identifier] = STATE(4603),
    [sym_string] = STATE(938),
    [sym_formal_parameters] = STATE(4595),
    [sym_nested_type_identifier] = STATE(786),
    [sym__type] = STATE(881),
    [sym_constructor_type] = STATE(881),
    [sym__primary_type] = STATE(925),
    [sym_template_literal_type] = STATE(911),
    [sym_infer_type] = STATE(881),
    [sym_conditional_type] = STATE(911),
    [sym_generic_type] = STATE(911),
    [sym_type_query] = STATE(911),
    [sym_index_type_query] = STATE(911),
    [sym_lookup_type] = STATE(911),
    [sym_literal_type] = STATE(911),
    [sym__number] = STATE(899),
    [sym_existential_type] = STATE(911),
    [sym_flow_maybe_type] = STATE(911),
    [sym_parenthesized_type] = STATE(911),
    [sym_predefined_type] = STATE(911),
    [sym_object_type] = STATE(911),
    [sym_type_parameters] = STATE(4495),
    [sym_array_type] = STATE(911),
    [sym_tuple_type] = STATE(911),
    [sym_readonly_type] = STATE(881),
    [sym_union_type] = STATE(911),
    [sym_intersection_type] = STATE(911),
    [sym_function_type] = STATE(881),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3891),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3897),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3901),
    [anon_sym_DASH] = ACTIONS(3901),
    [anon_sym_void] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3905),
    [sym_number] = ACTIONS(3907),
    [sym_this] = ACTIONS(4089),
    [sym_true] = ACTIONS(3911),
    [sym_false] = ACTIONS(3911),
    [sym_null] = ACTIONS(3911),
    [sym_undefined] = ACTIONS(3911),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3903),
    [anon_sym_number] = ACTIONS(3903),
    [anon_sym_boolean] = ACTIONS(3903),
    [anon_sym_string] = ACTIONS(3903),
    [anon_sym_symbol] = ACTIONS(3903),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3919),
    [anon_sym_keyof] = ACTIONS(3921),
    [anon_sym_unknown] = ACTIONS(3903),
    [anon_sym_never] = ACTIONS(3903),
    [anon_sym_object] = ACTIONS(3903),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
  },
  [1356] = {
    [sym_nested_identifier] = STATE(4639),
    [sym_string] = STATE(3150),
    [sym_formal_parameters] = STATE(4801),
    [sym_nested_type_identifier] = STATE(2986),
    [sym__type] = STATE(3114),
    [sym_constructor_type] = STATE(3114),
    [sym__primary_type] = STATE(3156),
    [sym_template_literal_type] = STATE(3157),
    [sym_infer_type] = STATE(3114),
    [sym_conditional_type] = STATE(3157),
    [sym_generic_type] = STATE(3157),
    [sym_type_query] = STATE(3157),
    [sym_index_type_query] = STATE(3157),
    [sym_lookup_type] = STATE(3157),
    [sym_literal_type] = STATE(3157),
    [sym__number] = STATE(3158),
    [sym_existential_type] = STATE(3157),
    [sym_flow_maybe_type] = STATE(3157),
    [sym_parenthesized_type] = STATE(3157),
    [sym_predefined_type] = STATE(3157),
    [sym_object_type] = STATE(3157),
    [sym_type_parameters] = STATE(4371),
    [sym_array_type] = STATE(3157),
    [sym_tuple_type] = STATE(3157),
    [sym_readonly_type] = STATE(3114),
    [sym_union_type] = STATE(3157),
    [sym_intersection_type] = STATE(3157),
    [sym_function_type] = STATE(3114),
    [sym_identifier] = ACTIONS(4095),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_LBRACE] = ACTIONS(3827),
    [anon_sym_typeof] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(3833),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3839),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_void] = ACTIONS(3843),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3849),
    [sym_number] = ACTIONS(3851),
    [sym_this] = ACTIONS(4097),
    [sym_true] = ACTIONS(3855),
    [sym_false] = ACTIONS(3855),
    [sym_null] = ACTIONS(3855),
    [sym_undefined] = ACTIONS(3855),
    [anon_sym_readonly] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_any] = ACTIONS(3843),
    [anon_sym_number] = ACTIONS(3843),
    [anon_sym_boolean] = ACTIONS(3843),
    [anon_sym_string] = ACTIONS(3843),
    [anon_sym_symbol] = ACTIONS(3843),
    [anon_sym_abstract] = ACTIONS(3861),
    [anon_sym_infer] = ACTIONS(3865),
    [anon_sym_keyof] = ACTIONS(3867),
    [anon_sym_unknown] = ACTIONS(3843),
    [anon_sym_never] = ACTIONS(3843),
    [anon_sym_object] = ACTIONS(3843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3869),
  },
  [1357] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3006),
    [sym_constructor_type] = STATE(3006),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3006),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3006),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3006),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1358] = {
    [sym_nested_identifier] = STATE(4603),
    [sym_string] = STATE(938),
    [sym_formal_parameters] = STATE(4595),
    [sym_nested_type_identifier] = STATE(786),
    [sym__type] = STATE(980),
    [sym_constructor_type] = STATE(980),
    [sym__primary_type] = STATE(925),
    [sym_template_literal_type] = STATE(911),
    [sym_infer_type] = STATE(980),
    [sym_conditional_type] = STATE(911),
    [sym_generic_type] = STATE(911),
    [sym_type_query] = STATE(911),
    [sym_index_type_query] = STATE(911),
    [sym_lookup_type] = STATE(911),
    [sym_literal_type] = STATE(911),
    [sym__number] = STATE(899),
    [sym_existential_type] = STATE(911),
    [sym_flow_maybe_type] = STATE(911),
    [sym_parenthesized_type] = STATE(911),
    [sym_predefined_type] = STATE(911),
    [sym_object_type] = STATE(911),
    [sym_type_parameters] = STATE(4495),
    [sym_array_type] = STATE(911),
    [sym_tuple_type] = STATE(911),
    [sym_readonly_type] = STATE(980),
    [sym_union_type] = STATE(911),
    [sym_intersection_type] = STATE(911),
    [sym_function_type] = STATE(980),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3891),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3897),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3901),
    [anon_sym_DASH] = ACTIONS(3901),
    [anon_sym_void] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3905),
    [sym_number] = ACTIONS(3907),
    [sym_this] = ACTIONS(4089),
    [sym_true] = ACTIONS(3911),
    [sym_false] = ACTIONS(3911),
    [sym_null] = ACTIONS(3911),
    [sym_undefined] = ACTIONS(3911),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3903),
    [anon_sym_number] = ACTIONS(3903),
    [anon_sym_boolean] = ACTIONS(3903),
    [anon_sym_string] = ACTIONS(3903),
    [anon_sym_symbol] = ACTIONS(3903),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3919),
    [anon_sym_keyof] = ACTIONS(3921),
    [anon_sym_unknown] = ACTIONS(3903),
    [anon_sym_never] = ACTIONS(3903),
    [anon_sym_object] = ACTIONS(3903),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
  },
  [1359] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3058),
    [sym_constructor_type] = STATE(3058),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3058),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3058),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3058),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1360] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3091),
    [sym_constructor_type] = STATE(3091),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3091),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3091),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3091),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1361] = {
    [sym_nested_identifier] = STATE(4603),
    [sym_string] = STATE(938),
    [sym_formal_parameters] = STATE(4595),
    [sym_nested_type_identifier] = STATE(786),
    [sym__type] = STATE(937),
    [sym_constructor_type] = STATE(937),
    [sym__primary_type] = STATE(925),
    [sym_template_literal_type] = STATE(911),
    [sym_infer_type] = STATE(937),
    [sym_conditional_type] = STATE(911),
    [sym_generic_type] = STATE(911),
    [sym_type_query] = STATE(911),
    [sym_index_type_query] = STATE(911),
    [sym_lookup_type] = STATE(911),
    [sym_literal_type] = STATE(911),
    [sym__number] = STATE(899),
    [sym_existential_type] = STATE(911),
    [sym_flow_maybe_type] = STATE(911),
    [sym_parenthesized_type] = STATE(911),
    [sym_predefined_type] = STATE(911),
    [sym_object_type] = STATE(911),
    [sym_type_parameters] = STATE(4495),
    [sym_array_type] = STATE(911),
    [sym_tuple_type] = STATE(911),
    [sym_readonly_type] = STATE(937),
    [sym_union_type] = STATE(911),
    [sym_intersection_type] = STATE(911),
    [sym_function_type] = STATE(937),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_LPAREN] = ACTIONS(3891),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3895),
    [anon_sym_AMP] = ACTIONS(3897),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3901),
    [anon_sym_DASH] = ACTIONS(3901),
    [anon_sym_void] = ACTIONS(3903),
    [anon_sym_DQUOTE] = ACTIONS(794),
    [anon_sym_SQUOTE] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3905),
    [sym_number] = ACTIONS(3907),
    [sym_this] = ACTIONS(4089),
    [sym_true] = ACTIONS(3911),
    [sym_false] = ACTIONS(3911),
    [sym_null] = ACTIONS(3911),
    [sym_undefined] = ACTIONS(3911),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3903),
    [anon_sym_number] = ACTIONS(3903),
    [anon_sym_boolean] = ACTIONS(3903),
    [anon_sym_string] = ACTIONS(3903),
    [anon_sym_symbol] = ACTIONS(3903),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3919),
    [anon_sym_keyof] = ACTIONS(3921),
    [anon_sym_unknown] = ACTIONS(3903),
    [anon_sym_never] = ACTIONS(3903),
    [anon_sym_object] = ACTIONS(3903),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3923),
  },
  [1362] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3846),
    [sym_constructor_type] = STATE(3846),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3846),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3846),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3846),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1363] = {
    [sym_component_identifier] = STATE(3493),
    [sym_new_component_body] = STATE(1960),
    [sym_tagged_type_string] = STATE(2108),
    [sym_tripple_tagged_type_string] = STATE(2109),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_COMMA] = ACTIONS(1852),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_of] = ACTIONS(1852),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3677),
    [anon_sym_EQ_GT] = ACTIONS(4099),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3682),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3684),
    [sym__automatic_semicolon] = ACTIONS(1852),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1364] = {
    [sym_nested_identifier] = STATE(4708),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4650),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3075),
    [sym_constructor_type] = STATE(3075),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3075),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4360),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3075),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3075),
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3748),
    [anon_sym_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3752),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3756),
    [anon_sym_QMARK] = ACTIONS(3758),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3764),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1365] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3035),
    [sym_constructor_type] = STATE(3035),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3035),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3035),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3035),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1366] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2801),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1367] = {
    [sym_nested_identifier] = STATE(4559),
    [sym_string] = STATE(1693),
    [sym_formal_parameters] = STATE(4819),
    [sym_nested_type_identifier] = STATE(1628),
    [sym__type] = STATE(1698),
    [sym_constructor_type] = STATE(1698),
    [sym__primary_type] = STATE(1647),
    [sym_template_literal_type] = STATE(1697),
    [sym_infer_type] = STATE(1698),
    [sym_conditional_type] = STATE(1697),
    [sym_generic_type] = STATE(1697),
    [sym_type_query] = STATE(1697),
    [sym_index_type_query] = STATE(1697),
    [sym_lookup_type] = STATE(1697),
    [sym_literal_type] = STATE(1697),
    [sym__number] = STATE(1699),
    [sym_existential_type] = STATE(1697),
    [sym_flow_maybe_type] = STATE(1697),
    [sym_parenthesized_type] = STATE(1697),
    [sym_predefined_type] = STATE(1697),
    [sym_object_type] = STATE(1697),
    [sym_type_parameters] = STATE(4263),
    [sym_array_type] = STATE(1697),
    [sym_tuple_type] = STATE(1697),
    [sym_readonly_type] = STATE(1698),
    [sym_union_type] = STATE(1697),
    [sym_intersection_type] = STATE(1697),
    [sym_function_type] = STATE(1698),
    [sym_identifier] = ACTIONS(4077),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_typeof] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_void] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3971),
    [sym_number] = ACTIONS(3973),
    [sym_this] = ACTIONS(4079),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [sym_null] = ACTIONS(3977),
    [sym_undefined] = ACTIONS(3977),
    [anon_sym_readonly] = ACTIONS(3979),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_any] = ACTIONS(3969),
    [anon_sym_number] = ACTIONS(3969),
    [anon_sym_boolean] = ACTIONS(3969),
    [anon_sym_string] = ACTIONS(3969),
    [anon_sym_symbol] = ACTIONS(3969),
    [anon_sym_abstract] = ACTIONS(3983),
    [anon_sym_infer] = ACTIONS(3985),
    [anon_sym_keyof] = ACTIONS(3987),
    [anon_sym_unknown] = ACTIONS(3969),
    [anon_sym_never] = ACTIONS(3969),
    [anon_sym_object] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3989),
  },
  [1368] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3683),
    [sym_constructor_type] = STATE(3683),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3683),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3683),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3683),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1369] = {
    [sym_type_arguments] = STATE(2752),
    [sym_component_identifier] = STATE(3375),
    [sym_new_component_body] = STATE(1721),
    [sym_tagged_type_string] = STATE(1832),
    [sym_tripple_tagged_type_string] = STATE(1831),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(1852),
    [anon_sym_RBRACE] = ACTIONS(3713),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_EQ] = ACTIONS(1854),
    [anon_sym_LBRACK] = ACTIONS(3713),
    [anon_sym_LT] = ACTIONS(3727),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3730),
    [anon_sym_EQ_GT] = ACTIONS(3700),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3704),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_extends] = ACTIONS(2590),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1868),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1370] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3531),
    [sym_constructor_type] = STATE(3531),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3531),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3531),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3531),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1371] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3819),
    [sym_constructor_type] = STATE(3819),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3819),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3819),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3819),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1372] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4096),
    [sym__primary_type] = STATE(2779),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(4096),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(4096),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(4096),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1373] = {
    [sym_nested_identifier] = STATE(4639),
    [sym_string] = STATE(3150),
    [sym_formal_parameters] = STATE(4801),
    [sym_nested_type_identifier] = STATE(2986),
    [sym__type] = STATE(3186),
    [sym_constructor_type] = STATE(3186),
    [sym__primary_type] = STATE(3156),
    [sym_template_literal_type] = STATE(3157),
    [sym_infer_type] = STATE(3186),
    [sym_conditional_type] = STATE(3157),
    [sym_generic_type] = STATE(3157),
    [sym_type_query] = STATE(3157),
    [sym_index_type_query] = STATE(3157),
    [sym_lookup_type] = STATE(3157),
    [sym_literal_type] = STATE(3157),
    [sym__number] = STATE(3158),
    [sym_existential_type] = STATE(3157),
    [sym_flow_maybe_type] = STATE(3157),
    [sym_parenthesized_type] = STATE(3157),
    [sym_predefined_type] = STATE(3157),
    [sym_object_type] = STATE(3157),
    [sym_type_parameters] = STATE(4371),
    [sym_array_type] = STATE(3157),
    [sym_tuple_type] = STATE(3157),
    [sym_readonly_type] = STATE(3186),
    [sym_union_type] = STATE(3157),
    [sym_intersection_type] = STATE(3157),
    [sym_function_type] = STATE(3186),
    [sym_identifier] = ACTIONS(4095),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_LBRACE] = ACTIONS(3827),
    [anon_sym_typeof] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(3833),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3839),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_void] = ACTIONS(3843),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3849),
    [sym_number] = ACTIONS(3851),
    [sym_this] = ACTIONS(4097),
    [sym_true] = ACTIONS(3855),
    [sym_false] = ACTIONS(3855),
    [sym_null] = ACTIONS(3855),
    [sym_undefined] = ACTIONS(3855),
    [anon_sym_readonly] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_any] = ACTIONS(3843),
    [anon_sym_number] = ACTIONS(3843),
    [anon_sym_boolean] = ACTIONS(3843),
    [anon_sym_string] = ACTIONS(3843),
    [anon_sym_symbol] = ACTIONS(3843),
    [anon_sym_abstract] = ACTIONS(3861),
    [anon_sym_infer] = ACTIONS(3865),
    [anon_sym_keyof] = ACTIONS(3867),
    [anon_sym_unknown] = ACTIONS(3843),
    [anon_sym_never] = ACTIONS(3843),
    [anon_sym_object] = ACTIONS(3843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3869),
  },
  [1374] = {
    [sym_nested_identifier] = STATE(4559),
    [sym_string] = STATE(1693),
    [sym_formal_parameters] = STATE(4819),
    [sym_nested_type_identifier] = STATE(1628),
    [sym__type] = STATE(1707),
    [sym_constructor_type] = STATE(1707),
    [sym__primary_type] = STATE(1647),
    [sym_template_literal_type] = STATE(1697),
    [sym_infer_type] = STATE(1707),
    [sym_conditional_type] = STATE(1697),
    [sym_generic_type] = STATE(1697),
    [sym_type_query] = STATE(1697),
    [sym_index_type_query] = STATE(1697),
    [sym_lookup_type] = STATE(1697),
    [sym_literal_type] = STATE(1697),
    [sym__number] = STATE(1699),
    [sym_existential_type] = STATE(1697),
    [sym_flow_maybe_type] = STATE(1697),
    [sym_parenthesized_type] = STATE(1697),
    [sym_predefined_type] = STATE(1697),
    [sym_object_type] = STATE(1697),
    [sym_type_parameters] = STATE(4263),
    [sym_array_type] = STATE(1697),
    [sym_tuple_type] = STATE(1697),
    [sym_readonly_type] = STATE(1707),
    [sym_union_type] = STATE(1697),
    [sym_intersection_type] = STATE(1697),
    [sym_function_type] = STATE(1707),
    [sym_identifier] = ACTIONS(4077),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_typeof] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_void] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3971),
    [sym_number] = ACTIONS(3973),
    [sym_this] = ACTIONS(4079),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [sym_null] = ACTIONS(3977),
    [sym_undefined] = ACTIONS(3977),
    [anon_sym_readonly] = ACTIONS(3979),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_any] = ACTIONS(3969),
    [anon_sym_number] = ACTIONS(3969),
    [anon_sym_boolean] = ACTIONS(3969),
    [anon_sym_string] = ACTIONS(3969),
    [anon_sym_symbol] = ACTIONS(3969),
    [anon_sym_abstract] = ACTIONS(3983),
    [anon_sym_infer] = ACTIONS(3985),
    [anon_sym_keyof] = ACTIONS(3987),
    [anon_sym_unknown] = ACTIONS(3969),
    [anon_sym_never] = ACTIONS(3969),
    [anon_sym_object] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3989),
  },
  [1375] = {
    [sym_component_identifier] = STATE(3493),
    [sym_new_component_body] = STATE(1960),
    [sym_tagged_type_string] = STATE(2108),
    [sym_tripple_tagged_type_string] = STATE(2109),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_COMMA] = ACTIONS(1852),
    [anon_sym_RBRACE] = ACTIONS(1852),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_SEMI] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(1852),
    [anon_sym_LT] = ACTIONS(1848),
    [anon_sym_GT] = ACTIONS(1848),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3677),
    [anon_sym_EQ_GT] = ACTIONS(3680),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(1848),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(1848),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3682),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3684),
    [sym__automatic_semicolon] = ACTIONS(1852),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1376] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3810),
    [sym_constructor_type] = STATE(3810),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3810),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3810),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3810),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1377] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3808),
    [sym_constructor_type] = STATE(3808),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3808),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3808),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3808),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1378] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3730),
    [sym_constructor_type] = STATE(3730),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3730),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3730),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3730),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1379] = {
    [sym_nested_identifier] = STATE(4633),
    [sym_string] = STATE(1972),
    [sym_formal_parameters] = STATE(4675),
    [sym_nested_type_identifier] = STATE(1862),
    [sym__type] = STATE(2009),
    [sym_constructor_type] = STATE(2009),
    [sym__primary_type] = STATE(1965),
    [sym_template_literal_type] = STATE(1964),
    [sym_infer_type] = STATE(2009),
    [sym_conditional_type] = STATE(1964),
    [sym_generic_type] = STATE(1964),
    [sym_type_query] = STATE(1964),
    [sym_index_type_query] = STATE(1964),
    [sym_lookup_type] = STATE(1964),
    [sym_literal_type] = STATE(1964),
    [sym__number] = STATE(1961),
    [sym_existential_type] = STATE(1964),
    [sym_flow_maybe_type] = STATE(1964),
    [sym_parenthesized_type] = STATE(1964),
    [sym_predefined_type] = STATE(1964),
    [sym_object_type] = STATE(1964),
    [sym_type_parameters] = STATE(4387),
    [sym_array_type] = STATE(1964),
    [sym_tuple_type] = STATE(1964),
    [sym_readonly_type] = STATE(2009),
    [sym_union_type] = STATE(1964),
    [sym_intersection_type] = STATE(1964),
    [sym_function_type] = STATE(2009),
    [sym_identifier] = ACTIONS(4081),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_LBRACE] = ACTIONS(4027),
    [anon_sym_typeof] = ACTIONS(4029),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(4037),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4041),
    [anon_sym_void] = ACTIONS(4043),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [sym_number] = ACTIONS(4047),
    [sym_this] = ACTIONS(4083),
    [sym_true] = ACTIONS(4051),
    [sym_false] = ACTIONS(4051),
    [sym_null] = ACTIONS(4051),
    [sym_undefined] = ACTIONS(4051),
    [anon_sym_readonly] = ACTIONS(4053),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_any] = ACTIONS(4043),
    [anon_sym_number] = ACTIONS(4043),
    [anon_sym_boolean] = ACTIONS(4043),
    [anon_sym_string] = ACTIONS(4043),
    [anon_sym_symbol] = ACTIONS(4043),
    [anon_sym_abstract] = ACTIONS(4057),
    [anon_sym_infer] = ACTIONS(4059),
    [anon_sym_keyof] = ACTIONS(4061),
    [anon_sym_unknown] = ACTIONS(4043),
    [anon_sym_never] = ACTIONS(4043),
    [anon_sym_object] = ACTIONS(4043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4063),
  },
  [1380] = {
    [sym_nested_identifier] = STATE(4639),
    [sym_string] = STATE(3150),
    [sym_formal_parameters] = STATE(4801),
    [sym_nested_type_identifier] = STATE(2986),
    [sym__type] = STATE(3120),
    [sym_constructor_type] = STATE(3120),
    [sym__primary_type] = STATE(3156),
    [sym_template_literal_type] = STATE(3157),
    [sym_infer_type] = STATE(3120),
    [sym_conditional_type] = STATE(3157),
    [sym_generic_type] = STATE(3157),
    [sym_type_query] = STATE(3157),
    [sym_index_type_query] = STATE(3157),
    [sym_lookup_type] = STATE(3157),
    [sym_literal_type] = STATE(3157),
    [sym__number] = STATE(3158),
    [sym_existential_type] = STATE(3157),
    [sym_flow_maybe_type] = STATE(3157),
    [sym_parenthesized_type] = STATE(3157),
    [sym_predefined_type] = STATE(3157),
    [sym_object_type] = STATE(3157),
    [sym_type_parameters] = STATE(4371),
    [sym_array_type] = STATE(3157),
    [sym_tuple_type] = STATE(3157),
    [sym_readonly_type] = STATE(3120),
    [sym_union_type] = STATE(3157),
    [sym_intersection_type] = STATE(3157),
    [sym_function_type] = STATE(3120),
    [sym_identifier] = ACTIONS(4095),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_LBRACE] = ACTIONS(3827),
    [anon_sym_typeof] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(3833),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3839),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_void] = ACTIONS(3843),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3849),
    [sym_number] = ACTIONS(3851),
    [sym_this] = ACTIONS(4097),
    [sym_true] = ACTIONS(3855),
    [sym_false] = ACTIONS(3855),
    [sym_null] = ACTIONS(3855),
    [sym_undefined] = ACTIONS(3855),
    [anon_sym_readonly] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_any] = ACTIONS(3843),
    [anon_sym_number] = ACTIONS(3843),
    [anon_sym_boolean] = ACTIONS(3843),
    [anon_sym_string] = ACTIONS(3843),
    [anon_sym_symbol] = ACTIONS(3843),
    [anon_sym_abstract] = ACTIONS(3861),
    [anon_sym_infer] = ACTIONS(3865),
    [anon_sym_keyof] = ACTIONS(3867),
    [anon_sym_unknown] = ACTIONS(3843),
    [anon_sym_never] = ACTIONS(3843),
    [anon_sym_object] = ACTIONS(3843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3869),
  },
  [1381] = {
    [sym_nested_identifier] = STATE(4639),
    [sym_string] = STATE(3150),
    [sym_formal_parameters] = STATE(4801),
    [sym_nested_type_identifier] = STATE(2986),
    [sym__type] = STATE(3121),
    [sym_constructor_type] = STATE(3121),
    [sym__primary_type] = STATE(3156),
    [sym_template_literal_type] = STATE(3157),
    [sym_infer_type] = STATE(3121),
    [sym_conditional_type] = STATE(3157),
    [sym_generic_type] = STATE(3157),
    [sym_type_query] = STATE(3157),
    [sym_index_type_query] = STATE(3157),
    [sym_lookup_type] = STATE(3157),
    [sym_literal_type] = STATE(3157),
    [sym__number] = STATE(3158),
    [sym_existential_type] = STATE(3157),
    [sym_flow_maybe_type] = STATE(3157),
    [sym_parenthesized_type] = STATE(3157),
    [sym_predefined_type] = STATE(3157),
    [sym_object_type] = STATE(3157),
    [sym_type_parameters] = STATE(4371),
    [sym_array_type] = STATE(3157),
    [sym_tuple_type] = STATE(3157),
    [sym_readonly_type] = STATE(3121),
    [sym_union_type] = STATE(3157),
    [sym_intersection_type] = STATE(3157),
    [sym_function_type] = STATE(3121),
    [sym_identifier] = ACTIONS(4095),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_LBRACE] = ACTIONS(3827),
    [anon_sym_typeof] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(3833),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3839),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_void] = ACTIONS(3843),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3849),
    [sym_number] = ACTIONS(3851),
    [sym_this] = ACTIONS(4097),
    [sym_true] = ACTIONS(3855),
    [sym_false] = ACTIONS(3855),
    [sym_null] = ACTIONS(3855),
    [sym_undefined] = ACTIONS(3855),
    [anon_sym_readonly] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_any] = ACTIONS(3843),
    [anon_sym_number] = ACTIONS(3843),
    [anon_sym_boolean] = ACTIONS(3843),
    [anon_sym_string] = ACTIONS(3843),
    [anon_sym_symbol] = ACTIONS(3843),
    [anon_sym_abstract] = ACTIONS(3861),
    [anon_sym_infer] = ACTIONS(3865),
    [anon_sym_keyof] = ACTIONS(3867),
    [anon_sym_unknown] = ACTIONS(3843),
    [anon_sym_never] = ACTIONS(3843),
    [anon_sym_object] = ACTIONS(3843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3869),
  },
  [1382] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3871),
    [sym_constructor_type] = STATE(3871),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3871),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3871),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3871),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1383] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4859),
    [sym_nested_type_identifier] = STATE(3193),
    [sym__type] = STATE(3700),
    [sym_constructor_type] = STATE(3700),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3700),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4172),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3700),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3700),
    [sym_identifier] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3931),
    [anon_sym_AMP] = ACTIONS(3933),
    [anon_sym_PIPE] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(3939),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(3943),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3945),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1384] = {
    [sym_nested_identifier] = STATE(4770),
    [sym_string] = STATE(2767),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2754),
    [sym__type] = STATE(3870),
    [sym_constructor_type] = STATE(3870),
    [sym__primary_type] = STATE(2772),
    [sym_template_literal_type] = STATE(2771),
    [sym_infer_type] = STATE(3870),
    [sym_conditional_type] = STATE(2771),
    [sym_generic_type] = STATE(2771),
    [sym_type_query] = STATE(2771),
    [sym_index_type_query] = STATE(2771),
    [sym_lookup_type] = STATE(2771),
    [sym_literal_type] = STATE(2771),
    [sym__number] = STATE(2770),
    [sym_existential_type] = STATE(2771),
    [sym_flow_maybe_type] = STATE(2771),
    [sym_parenthesized_type] = STATE(2771),
    [sym_predefined_type] = STATE(2771),
    [sym_object_type] = STATE(2771),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(2771),
    [sym_tuple_type] = STATE(2771),
    [sym_readonly_type] = STATE(3870),
    [sym_union_type] = STATE(2771),
    [sym_intersection_type] = STATE(2771),
    [sym_function_type] = STATE(3870),
    [sym_identifier] = ACTIONS(1136),
    [anon_sym_STAR] = ACTIONS(646),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_typeof] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_void] = ACTIONS(116),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [sym_number] = ACTIONS(1160),
    [sym_this] = ACTIONS(1162),
    [sym_true] = ACTIONS(1164),
    [sym_false] = ACTIONS(1164),
    [sym_null] = ACTIONS(1164),
    [sym_undefined] = ACTIONS(1164),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_any] = ACTIONS(116),
    [anon_sym_number] = ACTIONS(116),
    [anon_sym_boolean] = ACTIONS(116),
    [anon_sym_string] = ACTIONS(116),
    [anon_sym_symbol] = ACTIONS(116),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(114),
    [anon_sym_unknown] = ACTIONS(116),
    [anon_sym_never] = ACTIONS(116),
    [anon_sym_object] = ACTIONS(116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(118),
  },
  [1385] = {
    [sym_type_arguments] = STATE(2752),
    [sym_component_identifier] = STATE(3375),
    [sym_new_component_body] = STATE(1721),
    [sym_tagged_type_string] = STATE(1832),
    [sym_tripple_tagged_type_string] = STATE(1831),
    [anon_sym_STAR] = ACTIONS(1848),
    [anon_sym_as] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(3713),
    [anon_sym_BANG] = ACTIONS(1848),
    [anon_sym_LPAREN] = ACTIONS(1852),
    [anon_sym_in] = ACTIONS(1848),
    [anon_sym_EQ] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3713),
    [anon_sym_LT] = ACTIONS(3727),
    [anon_sym_GT] = ACTIONS(3722),
    [anon_sym_SLASH] = ACTIONS(1848),
    [anon_sym_DOT] = ACTIONS(3730),
    [anon_sym_EQ_GT] = ACTIONS(4103),
    [anon_sym_QMARK_DOT] = ACTIONS(1852),
    [anon_sym_PLUS_EQ] = ACTIONS(1861),
    [anon_sym_DASH_EQ] = ACTIONS(1861),
    [anon_sym_STAR_EQ] = ACTIONS(1861),
    [anon_sym_SLASH_EQ] = ACTIONS(1861),
    [anon_sym_PERCENT_EQ] = ACTIONS(1861),
    [anon_sym_CARET_EQ] = ACTIONS(1861),
    [anon_sym_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_LT_EQ] = ACTIONS(1861),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1861),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1848),
    [anon_sym_PIPE_PIPE] = ACTIONS(1848),
    [anon_sym_GT_GT] = ACTIONS(1848),
    [anon_sym_GT_GT_GT] = ACTIONS(1848),
    [anon_sym_LT_LT] = ACTIONS(1848),
    [anon_sym_AMP] = ACTIONS(3722),
    [anon_sym_CARET] = ACTIONS(1848),
    [anon_sym_PIPE] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(1848),
    [anon_sym_DASH] = ACTIONS(1848),
    [anon_sym_PERCENT] = ACTIONS(1848),
    [anon_sym_STAR_STAR] = ACTIONS(1848),
    [anon_sym_LT_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ] = ACTIONS(1848),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ] = ACTIONS(1848),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1852),
    [anon_sym_GT_EQ] = ACTIONS(1852),
    [anon_sym_QMARK_QMARK] = ACTIONS(1848),
    [anon_sym_instanceof] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1852),
    [anon_sym_DASH_DASH] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3704),
    [anon_sym_satisfies] = ACTIONS(1852),
    [anon_sym_extends] = ACTIONS(2590),
    [anon_sym_implements] = ACTIONS(1852),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1868),
    [sym__ternary_qmark] = ACTIONS(1852),
  },
  [1386] = {
    [sym_nested_identifier] = STATE(4633),
    [sym_string] = STATE(1972),
    [sym_formal_parameters] = STATE(4675),
    [sym_nested_type_identifier] = STATE(1862),
    [sym__type] = STATE(2010),
    [sym_constructor_type] = STATE(2010),
    [sym__primary_type] = STATE(1965),
    [sym_template_literal_type] = STATE(1964),
    [sym_infer_type] = STATE(2010),
    [sym_conditional_type] = STATE(1964),
    [sym_generic_type] = STATE(1964),
    [sym_type_query] = STATE(1964),
    [sym_index_type_query] = STATE(1964),
    [sym_lookup_type] = STATE(1964),
    [sym_literal_type] = STATE(1964),
    [sym__number] = STATE(1961),
    [sym_existential_type] = STATE(1964),
    [sym_flow_maybe_type] = STATE(1964),
    [sym_parenthesized_type] = STATE(1964),
    [sym_predefined_type] = STATE(1964),
    [sym_object_type] = STATE(1964),
    [sym_type_parameters] = STATE(4387),
    [sym_array_type] = STATE(1964),
    [sym_tuple_type] = STATE(1964),
    [sym_readonly_type] = STATE(2010),
    [sym_union_type] = STATE(1964),
    [sym_intersection_type] = STATE(1964),
    [sym_function_type] = STATE(2010),
    [sym_identifier] = ACTIONS(4081),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_LBRACE] = ACTIONS(4027),
    [anon_sym_typeof] = ACTIONS(4029),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(4037),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4041),
    [anon_sym_void] = ACTIONS(4043),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [sym_number] = ACTIONS(4047),
    [sym_this] = ACTIONS(4083),
    [sym_true] = ACTIONS(4051),
    [sym_false] = ACTIONS(4051),
    [sym_null] = ACTIONS(4051),
    [sym_undefined] = ACTIONS(4051),
    [anon_sym_readonly] = ACTIONS(4053),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_any] = ACTIONS(4043),
    [anon_sym_number] = ACTIONS(4043),
    [anon_sym_boolean] = ACTIONS(4043),
    [anon_sym_string] = ACTIONS(4043),
    [anon_sym_symbol] = ACTIONS(4043),
    [anon_sym_abstract] = ACTIONS(4057),
    [anon_sym_infer] = ACTIONS(4059),
    [anon_sym_keyof] = ACTIONS(4061),
    [anon_sym_unknown] = ACTIONS(4043),
    [anon_sym_never] = ACTIONS(4043),
    [anon_sym_object] = ACTIONS(4043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4063),
  },
  [1387] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3056),
    [sym_constructor_type] = STATE(3056),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3056),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3056),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3056),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1388] = {
    [sym_nested_identifier] = STATE(4639),
    [sym_string] = STATE(3150),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2986),
    [sym__type] = STATE(4106),
    [sym_constructor_type] = STATE(4106),
    [sym__primary_type] = STATE(3179),
    [sym_template_literal_type] = STATE(3157),
    [sym_infer_type] = STATE(4106),
    [sym_conditional_type] = STATE(3157),
    [sym_generic_type] = STATE(3157),
    [sym_type_query] = STATE(3157),
    [sym_index_type_query] = STATE(3157),
    [sym_lookup_type] = STATE(3157),
    [sym_literal_type] = STATE(3157),
    [sym__number] = STATE(3158),
    [sym_existential_type] = STATE(3157),
    [sym_flow_maybe_type] = STATE(3157),
    [sym_parenthesized_type] = STATE(3157),
    [sym_predefined_type] = STATE(3157),
    [sym_object_type] = STATE(3157),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3157),
    [sym_tuple_type] = STATE(3157),
    [sym_readonly_type] = STATE(4106),
    [sym_union_type] = STATE(3157),
    [sym_intersection_type] = STATE(3157),
    [sym_function_type] = STATE(4106),
    [sym_identifier] = ACTIONS(4095),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_LBRACE] = ACTIONS(3827),
    [anon_sym_typeof] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(3833),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3839),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_void] = ACTIONS(3843),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3849),
    [sym_number] = ACTIONS(3851),
    [sym_this] = ACTIONS(4097),
    [sym_true] = ACTIONS(3855),
    [sym_false] = ACTIONS(3855),
    [sym_null] = ACTIONS(3855),
    [sym_undefined] = ACTIONS(3855),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_any] = ACTIONS(3843),
    [anon_sym_number] = ACTIONS(3843),
    [anon_sym_boolean] = ACTIONS(3843),
    [anon_sym_string] = ACTIONS(3843),
    [anon_sym_symbol] = ACTIONS(3843),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3867),
    [anon_sym_unknown] = ACTIONS(3843),
    [anon_sym_never] = ACTIONS(3843),
    [anon_sym_object] = ACTIONS(3843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3869),
  },
  [1389] = {
    [sym_nested_identifier] = STATE(4633),
    [sym_string] = STATE(1972),
    [sym_formal_parameters] = STATE(4675),
    [sym_nested_type_identifier] = STATE(1862),
    [sym__type] = STATE(1934),
    [sym_constructor_type] = STATE(1934),
    [sym__primary_type] = STATE(1965),
    [sym_template_literal_type] = STATE(1964),
    [sym_infer_type] = STATE(1934),
    [sym_conditional_type] = STATE(1964),
    [sym_generic_type] = STATE(1964),
    [sym_type_query] = STATE(1964),
    [sym_index_type_query] = STATE(1964),
    [sym_lookup_type] = STATE(1964),
    [sym_literal_type] = STATE(1964),
    [sym__number] = STATE(1961),
    [sym_existential_type] = STATE(1964),
    [sym_flow_maybe_type] = STATE(1964),
    [sym_parenthesized_type] = STATE(1964),
    [sym_predefined_type] = STATE(1964),
    [sym_object_type] = STATE(1964),
    [sym_type_parameters] = STATE(4387),
    [sym_array_type] = STATE(1964),
    [sym_tuple_type] = STATE(1964),
    [sym_readonly_type] = STATE(1934),
    [sym_union_type] = STATE(1964),
    [sym_intersection_type] = STATE(1964),
    [sym_function_type] = STATE(1934),
    [sym_identifier] = ACTIONS(4081),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_LBRACE] = ACTIONS(4027),
    [anon_sym_typeof] = ACTIONS(4029),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(4037),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4041),
    [anon_sym_void] = ACTIONS(4043),
    [anon_sym_DQUOTE] = ACTIONS(203),
    [anon_sym_SQUOTE] = ACTIONS(205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [sym_number] = ACTIONS(4047),
    [sym_this] = ACTIONS(4083),
    [sym_true] = ACTIONS(4051),
    [sym_false] = ACTIONS(4051),
    [sym_null] = ACTIONS(4051),
    [sym_undefined] = ACTIONS(4051),
    [anon_sym_readonly] = ACTIONS(4053),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_any] = ACTIONS(4043),
    [anon_sym_number] = ACTIONS(4043),
    [anon_sym_boolean] = ACTIONS(4043),
    [anon_sym_string] = ACTIONS(4043),
    [anon_sym_symbol] = ACTIONS(4043),
    [anon_sym_abstract] = ACTIONS(4057),
    [anon_sym_infer] = ACTIONS(4059),
    [anon_sym_keyof] = ACTIONS(4061),
    [anon_sym_unknown] = ACTIONS(4043),
    [anon_sym_never] = ACTIONS(4043),
    [anon_sym_object] = ACTIONS(4043),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4063),
  },
  [1390] = {
    [sym_nested_identifier] = STATE(4540),
    [sym_string] = STATE(3032),
    [sym_formal_parameters] = STATE(4864),
    [sym_nested_type_identifier] = STATE(2897),
    [sym__type] = STATE(3054),
    [sym_constructor_type] = STATE(3054),
    [sym__primary_type] = STATE(3027),
    [sym_template_literal_type] = STATE(3026),
    [sym_infer_type] = STATE(3054),
    [sym_conditional_type] = STATE(3026),
    [sym_generic_type] = STATE(3026),
    [sym_type_query] = STATE(3026),
    [sym_index_type_query] = STATE(3026),
    [sym_lookup_type] = STATE(3026),
    [sym_literal_type] = STATE(3026),
    [sym__number] = STATE(2976),
    [sym_existential_type] = STATE(3026),
    [sym_flow_maybe_type] = STATE(3026),
    [sym_parenthesized_type] = STATE(3026),
    [sym_predefined_type] = STATE(3026),
    [sym_object_type] = STATE(3026),
    [sym_type_parameters] = STATE(4454),
    [sym_array_type] = STATE(3026),
    [sym_tuple_type] = STATE(3026),
    [sym_readonly_type] = STATE(3054),
    [sym_union_type] = STATE(3026),
    [sym_intersection_type] = STATE(3026),
    [sym_function_type] = STATE(3054),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(834),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1211),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(876),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_SQUOTE] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1227),
    [sym_this] = ACTIONS(1229),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_readonly] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(866),
    [anon_sym_any] = ACTIONS(876),
    [anon_sym_number] = ACTIONS(876),
    [anon_sym_boolean] = ACTIONS(876),
    [anon_sym_string] = ACTIONS(876),
    [anon_sym_symbol] = ACTIONS(876),
    [anon_sym_abstract] = ACTIONS(870),
    [anon_sym_infer] = ACTIONS(872),
    [anon_sym_keyof] = ACTIONS(874),
    [anon_sym_unknown] = ACTIONS(876),
    [anon_sym_never] = ACTIONS(876),
    [anon_sym_object] = ACTIONS(876),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
  },
  [1391] = {
    [sym_nested_identifier] = STATE(4639),
    [sym_string] = STATE(3150),
    [sym_formal_parameters] = STATE(4825),
    [sym_nested_type_identifier] = STATE(2986),
    [sym__type] = STATE(4106),
    [sym_constructor_type] = STATE(4106),
    [sym__primary_type] = STATE(3177),
    [sym_template_literal_type] = STATE(3157),
    [sym_infer_type] = STATE(4106),
    [sym_conditional_type] = STATE(3157),
    [sym_generic_type] = STATE(3157),
    [sym_type_query] = STATE(3157),
    [sym_index_type_query] = STATE(3157),
    [sym_lookup_type] = STATE(3157),
    [sym_literal_type] = STATE(3157),
    [sym__number] = STATE(3158),
    [sym_existential_type] = STATE(3157),
    [sym_flow_maybe_type] = STATE(3157),
    [sym_parenthesized_type] = STATE(3157),
    [sym_predefined_type] = STATE(3157),
    [sym_object_type] = STATE(3157),
    [sym_type_parameters] = STATE(4186),
    [sym_array_type] = STATE(3157),
    [sym_tuple_type] = STATE(3157),
    [sym_readonly_type] = STATE(4106),
    [sym_union_type] = STATE(3157),
    [sym_intersection_type] = STATE(3157),
    [sym_function_type] = STATE(4106),
    [sym_identifier] = ACTIONS(4095),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_LBRACE] = ACTIONS(3827),
    [anon_sym_typeof] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(3833),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(1148),
    [anon_sym_AMP] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3839),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_void] = ACTIONS(3843),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3849),
    [sym_number] = ACTIONS(3851),
    [sym_this] = ACTIONS(4097),
    [sym_true] = ACTIONS(3855),
    [sym_false] = ACTIONS(3855),
    [sym_null] = ACTIONS(3855),
    [sym_undefined] = ACTIONS(3855),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_any] = ACTIONS(3843),
    [anon_sym_number] = ACTIONS(3843),
    [anon_sym_boolean] = ACTIONS(3843),
    [anon_sym_string] = ACTIONS(3843),
    [anon_sym_symbol] = ACTIONS(3843),
    [anon_sym_abstract] = ACTIONS(110),
    [anon_sym_infer] = ACTIONS(112),
    [anon_sym_keyof] = ACTIONS(3867),
    [anon_sym_unknown] = ACTIONS(3843),
    [anon_sym_never] = ACTIONS(3843),
    [anon_sym_object] = ACTIONS(3843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3869),
  },
  [1392] = {
    [sym_nested_identifier] = STATE(4639),
    [sym_string] = STATE(3150),
    [sym_formal_parameters] = STATE(4801),
    [sym_nested_type_identifier] = STATE(2986),
    [sym__type] = STATE(3176),
    [sym_constructor_type] = STATE(3176),
    [sym__primary_type] = STATE(3156),
    [sym_template_literal_type] = STATE(3157),
    [sym_infer_type] = STATE(3176),
    [sym_conditional_type] = STATE(3157),
    [sym_generic_type] = STATE(3157),
    [sym_type_query] = STATE(3157),
    [sym_index_type_query] = STATE(3157),
    [sym_lookup_type] = STATE(3157),
    [sym_literal_type] = STATE(3157),
    [sym__number] = STATE(3158),
    [sym_existential_type] = STATE(3157),
    [sym_flow_maybe_type] = STATE(3157),
    [sym_parenthesized_type] = STATE(3157),
    [sym_predefined_type] = STATE(3157),
    [sym_object_type] = STATE(3157),
    [sym_type_parameters] = STATE(4371),
    [sym_array_type] = STATE(3157),
    [sym_tuple_type] = STATE(3157),
    [sym_readonly_type] = STATE(3176),
    [sym_union_type] = STATE(3157),
    [sym_intersection_type] = STATE(3157),
    [sym_function_type] = STATE(3176),
    [sym_identifier] = ACTIONS(4095),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_LBRACE] = ACTIONS(3827),
    [anon_sym_typeof] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(3833),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3839),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_void] = ACTIONS(3843),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3849),
    [sym_number] = ACTIONS(3851),
    [sym_this] = ACTIONS(4097),
    [sym_true] = ACTIONS(3855),
    [sym_false] = ACTIONS(3855),
    [sym_null] = ACTIONS(3855),
    [sym_undefined] = ACTIONS(3855),
    [anon_sym_readonly] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_any] = ACTIONS(3843),
    [anon_sym_number] = ACTIONS(3843),
    [anon_sym_boolean] = ACTIONS(3843),
    [anon_sym_string] = ACTIONS(3843),
    [anon_sym_symbol] = ACTIONS(3843),
    [anon_sym_abstract] = ACTIONS(3861),
    [anon_sym_infer] = ACTIONS(3865),
    [anon_sym_keyof] = ACTIONS(3867),
    [anon_sym_unknown] = ACTIONS(3843),
    [anon_sym_never] = ACTIONS(3843),
    [anon_sym_object] = ACTIONS(3843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3869),
  },
  [1393] = {
    [sym_nested_identifier] = STATE(4639),
    [sym_string] = STATE(3150),
    [sym_formal_parameters] = STATE(4801),
    [sym_nested_type_identifier] = STATE(2986),
    [sym__type] = STATE(3171),
    [sym_constructor_type] = STATE(3171),
    [sym__primary_type] = STATE(3156),
    [sym_template_literal_type] = STATE(3157),
    [sym_infer_type] = STATE(3171),
    [sym_conditional_type] = STATE(3157),
    [sym_generic_type] = STATE(3157),
    [sym_type_query] = STATE(3157),
    [sym_index_type_query] = STATE(3157),
    [sym_lookup_type] = STATE(3157),
    [sym_literal_type] = STATE(3157),
    [sym__number] = STATE(3158),
    [sym_existential_type] = STATE(3157),
    [sym_flow_maybe_type] = STATE(3157),
    [sym_parenthesized_type] = STATE(3157),
    [sym_predefined_type] = STATE(3157),
    [sym_object_type] = STATE(3157),
    [sym_type_parameters] = STATE(4371),
    [sym_array_type] = STATE(3157),
    [sym_tuple_type] = STATE(3157),
    [sym_readonly_type] = STATE(3171),
    [sym_union_type] = STATE(3157),
    [sym_intersection_type] = STATE(3157),
    [sym_function_type] = STATE(3171),
    [sym_identifier] = ACTIONS(4095),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_LBRACE] = ACTIONS(3827),
    [anon_sym_typeof] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(3833),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3839),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_void] = ACTIONS(3843),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3849),
    [sym_number] = ACTIONS(3851),
    [sym_this] = ACTIONS(4097),
    [sym_true] = ACTIONS(3855),
    [sym_false] = ACTIONS(3855),
    [sym_null] = ACTIONS(3855),
    [sym_undefined] = ACTIONS(3855),
    [anon_sym_readonly] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_any] = ACTIONS(3843),
    [anon_sym_number] = ACTIONS(3843),
    [anon_sym_boolean] = ACTIONS(3843),
    [anon_sym_string] = ACTIONS(3843),
    [anon_sym_symbol] = ACTIONS(3843),
    [anon_sym_abstract] = ACTIONS(3861),
    [anon_sym_infer] = ACTIONS(3865),
    [anon_sym_keyof] = ACTIONS(3867),
    [anon_sym_unknown] = ACTIONS(3843),
    [anon_sym_never] = ACTIONS(3843),
    [anon_sym_object] = ACTIONS(3843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3869),
  },
  [1394] = {
    [sym_nested_identifier] = STATE(4639),
    [sym_string] = STATE(3150),
    [sym_formal_parameters] = STATE(4801),
    [sym_nested_type_identifier] = STATE(2986),
    [sym__type] = STATE(3172),
    [sym_constructor_type] = STATE(3172),
    [sym__primary_type] = STATE(3156),
    [sym_template_literal_type] = STATE(3157),
    [sym_infer_type] = STATE(3172),
    [sym_conditional_type] = STATE(3157),
    [sym_generic_type] = STATE(3157),
    [sym_type_query] = STATE(3157),
    [sym_index_type_query] = STATE(3157),
    [sym_lookup_type] = STATE(3157),
    [sym_literal_type] = STATE(3157),
    [sym__number] = STATE(3158),
    [sym_existential_type] = STATE(3157),
    [sym_flow_maybe_type] = STATE(3157),
    [sym_parenthesized_type] = STATE(3157),
    [sym_predefined_type] = STATE(3157),
    [sym_object_type] = STATE(3157),
    [sym_type_parameters] = STATE(4371),
    [sym_array_type] = STATE(3157),
    [sym_tuple_type] = STATE(3157),
    [sym_readonly_type] = STATE(3172),
    [sym_union_type] = STATE(3157),
    [sym_intersection_type] = STATE(3157),
    [sym_function_type] = STATE(3172),
    [sym_identifier] = ACTIONS(4095),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_LBRACE] = ACTIONS(3827),
    [anon_sym_typeof] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(3833),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3837),
    [anon_sym_PIPE] = ACTIONS(3839),
    [anon_sym_PLUS] = ACTIONS(3841),
    [anon_sym_DASH] = ACTIONS(3841),
    [anon_sym_void] = ACTIONS(3843),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_SQUOTE] = ACTIONS(3847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3849),
    [sym_number] = ACTIONS(3851),
    [sym_this] = ACTIONS(4097),
    [sym_true] = ACTIONS(3855),
    [sym_false] = ACTIONS(3855),
    [sym_null] = ACTIONS(3855),
    [sym_undefined] = ACTIONS(3855),
    [anon_sym_readonly] = ACTIONS(3857),
    [anon_sym_QMARK] = ACTIONS(3859),
    [anon_sym_any] = ACTIONS(3843),
    [anon_sym_number] = ACTIONS(3843),
    [anon_sym_boolean] = ACTIONS(3843),
    [anon_sym_string] = ACTIONS(3843),
    [anon_sym_symbol] = ACTIONS(3843),
    [anon_sym_abstract] = ACTIONS(3861),
    [anon_sym_infer] = ACTIONS(3865),
    [anon_sym_keyof] = ACTIONS(3867),
    [anon_sym_unknown] = ACTIONS(3843),
    [anon_sym_never] = ACTIONS(3843),
    [anon_sym_object] = ACTIONS(3843),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3869),
  },
  [1395] = {
    [sym_nested_identifier] = STATE(4559),
    [sym_string] = STATE(1693),
    [sym_formal_parameters] = STATE(4819),
    [sym_nested_type_identifier] = STATE(1628),
    [sym__type] = STATE(1648),
    [sym_constructor_type] = STATE(1648),
    [sym__primary_type] = STATE(1647),
    [sym_template_literal_type] = STATE(1697),
    [sym_infer_type] = STATE(1648),
    [sym_conditional_type] = STATE(1697),
    [sym_generic_type] = STATE(1697),
    [sym_type_query] = STATE(1697),
    [sym_index_type_query] = STATE(1697),
    [sym_lookup_type] = STATE(1697),
    [sym_literal_type] = STATE(1697),
    [sym__number] = STATE(1699),
    [sym_existential_type] = STATE(1697),
    [sym_flow_maybe_type] = STATE(1697),
    [sym_parenthesized_type] = STATE(1697),
    [sym_predefined_type] = STATE(1697),
    [sym_object_type] = STATE(1697),
    [sym_type_parameters] = STATE(4263),
    [sym_array_type] = STATE(1697),
    [sym_tuple_type] = STATE(1697),
    [sym_readonly_type] = STATE(1648),
    [sym_union_type] = STATE(1697),
    [sym_intersection_type] = STATE(1697),
    [sym_function_type] = STATE(1648),
    [sym_identifier] = ACTIONS(4077),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_typeof] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_void] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3971),
    [sym_number] = ACTIONS(3973),
    [sym_this] = ACTIONS(4079),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [sym_null] = ACTIONS(3977),
    [sym_undefined] = ACTIONS(3977),
    [anon_sym_readonly] = ACTIONS(3979),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_any] = ACTIONS(3969),
    [anon_sym_number] = ACTIONS(3969),
    [anon_sym_boolean] = ACTIONS(3969),
    [anon_sym_string] = ACTIONS(3969),
    [anon_sym_symbol] = ACTIONS(3969),
    [anon_sym_abstract] = ACTIONS(3983),
    [anon_sym_infer] = ACTIONS(3985),
    [anon_sym_keyof] = ACTIONS(3987),
    [anon_sym_unknown] = ACTIONS(3969),
    [anon_sym_never] = ACTIONS(3969),
    [anon_sym_object] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3989),
  },
  [1396] = {
    [sym_nested_identifier] = STATE(4559),
    [sym_string] = STATE(1693),
    [sym_formal_parameters] = STATE(4819),
    [sym_nested_type_identifier] = STATE(1628),
    [sym__type] = STATE(1650),
    [sym_constructor_type] = STATE(1650),
    [sym__primary_type] = STATE(1647),
    [sym_template_literal_type] = STATE(1697),
    [sym_infer_type] = STATE(1650),
    [sym_conditional_type] = STATE(1697),
    [sym_generic_type] = STATE(1697),
    [sym_type_query] = STATE(1697),
    [sym_index_type_query] = STATE(1697),
    [sym_lookup_type] = STATE(1697),
    [sym_literal_type] = STATE(1697),
    [sym__number] = STATE(1699),
    [sym_existential_type] = STATE(1697),
    [sym_flow_maybe_type] = STATE(1697),
    [sym_parenthesized_type] = STATE(1697),
    [sym_predefined_type] = STATE(1697),
    [sym_object_type] = STATE(1697),
    [sym_type_parameters] = STATE(4263),
    [sym_array_type] = STATE(1697),
    [sym_tuple_type] = STATE(1697),
    [sym_readonly_type] = STATE(1650),
    [sym_union_type] = STATE(1697),
    [sym_intersection_type] = STATE(1697),
    [sym_function_type] = STATE(1650),
    [sym_identifier] = ACTIONS(4077),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_LBRACE] = ACTIONS(3953),
    [anon_sym_typeof] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3959),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_PIPE] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_void] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(88),
    [anon_sym_SQUOTE] = ACTIONS(90),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3971),
    [sym_number] = ACTIONS(3973),
    [sym_this] = ACTIONS(4079),
    [sym_true] = ACTIONS(3977),
    [sym_false] = ACTIONS(3977),
    [sym_null] = ACTIONS(3977),
    [sym_undefined] = ACTIONS(3977),
    [anon_sym_readonly] = ACTIONS(3979),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_any] = ACTIONS(3969),
    [anon_sym_number] = ACTIONS(3969),
    [anon_sym_boolean] = ACTIONS(3969),
    [anon_sym_string] = ACTIONS(3969),
    [anon_sym_symbol] = ACTIONS(3969),
    [anon_sym_abstract] = ACTIONS(3983),
    [anon_sym_infer] = ACTIONS(3985),
    [anon_sym_keyof] = ACTIONS(3987),
    [anon_sym_unknown] = ACTIONS(3969),
    [anon_sym_never] = ACTIONS(3969),
    [anon_sym_object] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3989),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(1868), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3677), 1,
      anon_sym_DOT,
    ACTIONS(3694), 1,
      anon_sym_LBRACE,
    ACTIONS(3700), 1,
      anon_sym_EQ_GT,
    ACTIONS(3704), 1,
      anon_sym_BQUOTE,
    ACTIONS(3710), 1,
      anon_sym_EQ,
    STATE(1721), 1,
      sym_new_component_body,
    STATE(1831), 1,
      sym_tripple_tagged_type_string,
    STATE(1832), 1,
      sym_tagged_type_string,
    STATE(3375), 1,
      sym_component_identifier,
    ACTIONS(3784), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(1852), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1848), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [97] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(1868), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3677), 1,
      anon_sym_DOT,
    ACTIONS(3694), 1,
      anon_sym_LBRACE,
    ACTIONS(3700), 1,
      anon_sym_EQ_GT,
    ACTIONS(3704), 1,
      anon_sym_BQUOTE,
    ACTIONS(3710), 1,
      anon_sym_EQ,
    ACTIONS(3782), 1,
      anon_sym_COMMA,
    ACTIONS(3784), 1,
      anon_sym_RBRACK,
    ACTIONS(4114), 1,
      anon_sym_in,
    ACTIONS(4116), 1,
      anon_sym_COLON,
    STATE(1721), 1,
      sym_new_component_body,
    STATE(1831), 1,
      sym_tripple_tagged_type_string,
    STATE(1832), 1,
      sym_tagged_type_string,
    STATE(3375), 1,
      sym_component_identifier,
    ACTIONS(1852), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1848), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [200] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_EQ,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(1868), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3677), 1,
      anon_sym_DOT,
    ACTIONS(3694), 1,
      anon_sym_LBRACE,
    ACTIONS(3704), 1,
      anon_sym_BQUOTE,
    ACTIONS(3815), 1,
      anon_sym_EQ_GT,
    STATE(1721), 1,
      sym_new_component_body,
    STATE(1831), 1,
      sym_tripple_tagged_type_string,
    STATE(1832), 1,
      sym_tagged_type_string,
    STATE(3375), 1,
      sym_component_identifier,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1852), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1848), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [295] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(1868), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3677), 1,
      anon_sym_DOT,
    ACTIONS(3694), 1,
      anon_sym_LBRACE,
    ACTIONS(3704), 1,
      anon_sym_BQUOTE,
    ACTIONS(3815), 1,
      anon_sym_EQ_GT,
    ACTIONS(4013), 1,
      anon_sym_EQ,
    STATE(1721), 1,
      sym_new_component_body,
    STATE(1831), 1,
      sym_tripple_tagged_type_string,
    STATE(1832), 1,
      sym_tagged_type_string,
    STATE(3375), 1,
      sym_component_identifier,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1852), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1848), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [390] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_EQ,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(1868), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3677), 1,
      anon_sym_DOT,
    ACTIONS(3694), 1,
      anon_sym_LBRACE,
    ACTIONS(3700), 1,
      anon_sym_EQ_GT,
    ACTIONS(3704), 1,
      anon_sym_BQUOTE,
    STATE(1721), 1,
      sym_new_component_body,
    STATE(1831), 1,
      sym_tripple_tagged_type_string,
    STATE(1832), 1,
      sym_tagged_type_string,
    STATE(3375), 1,
      sym_component_identifier,
    ACTIONS(4118), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(1852), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1848), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [487] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_EQ,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(1868), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3677), 1,
      anon_sym_DOT,
    ACTIONS(3694), 1,
      anon_sym_LBRACE,
    ACTIONS(3700), 1,
      anon_sym_EQ_GT,
    ACTIONS(3704), 1,
      anon_sym_BQUOTE,
    ACTIONS(4114), 1,
      anon_sym_in,
    ACTIONS(4116), 1,
      anon_sym_COLON,
    STATE(1721), 1,
      sym_new_component_body,
    STATE(1831), 1,
      sym_tripple_tagged_type_string,
    STATE(1832), 1,
      sym_tagged_type_string,
    STATE(3375), 1,
      sym_component_identifier,
    ACTIONS(1852), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1848), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [585] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(199), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4123), 1,
      anon_sym_export,
    ACTIONS(4125), 1,
      anon_sym_STAR,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4129), 1,
      anon_sym_COMMA,
    ACTIONS(4131), 1,
      anon_sym_RBRACE,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(4137), 1,
      anon_sym_LBRACK,
    ACTIONS(4139), 1,
      anon_sym_async,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4147), 1,
      anon_sym_static,
    ACTIONS(4149), 1,
      anon_sym_readonly,
    ACTIONS(4155), 1,
      anon_sym_override,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4159), 1,
      anon_sym_PIPE_RBRACE,
    STATE(2637), 1,
      sym_accessibility_modifier,
    STATE(2654), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4001), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4005), 1,
      aux_sym_object_repeat1,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2902), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4006), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4014), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3394), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4121), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [723] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1936), 1,
      anon_sym_COLON,
    ACTIONS(1938), 1,
      anon_sym_EQ,
    ACTIONS(3766), 1,
      sym_identifier,
    ACTIONS(3768), 1,
      anon_sym_DQUOTE,
    ACTIONS(3770), 1,
      anon_sym_SQUOTE,
    STATE(633), 1,
      sym_nested_identifier,
    STATE(702), 1,
      sym_string,
    STATE(723), 1,
      sym__module,
    ACTIONS(65), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [813] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(199), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4123), 1,
      anon_sym_export,
    ACTIONS(4125), 1,
      anon_sym_STAR,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4129), 1,
      anon_sym_COMMA,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(4137), 1,
      anon_sym_LBRACK,
    ACTIONS(4139), 1,
      anon_sym_async,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4147), 1,
      anon_sym_static,
    ACTIONS(4149), 1,
      anon_sym_readonly,
    ACTIONS(4155), 1,
      anon_sym_override,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4159), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4161), 1,
      anon_sym_RBRACE,
    STATE(2637), 1,
      sym_accessibility_modifier,
    STATE(2654), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4001), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4005), 1,
      aux_sym_object_repeat1,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2902), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4006), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4014), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3394), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4121), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [951] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1938), 1,
      anon_sym_EQ,
    ACTIONS(1940), 1,
      anon_sym_COLON,
    ACTIONS(4163), 1,
      sym_identifier,
    STATE(718), 1,
      sym__module,
    STATE(3611), 1,
      sym_nested_identifier,
    STATE(3852), 1,
      sym_string,
    ACTIONS(65), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [1041] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1938), 1,
      anon_sym_EQ,
    ACTIONS(1940), 1,
      anon_sym_COLON,
    ACTIONS(4163), 1,
      sym_identifier,
    STATE(723), 1,
      sym__module,
    STATE(3611), 1,
      sym_nested_identifier,
    STATE(3852), 1,
      sym_string,
    ACTIONS(65), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [1131] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(199), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4125), 1,
      anon_sym_STAR,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4129), 1,
      anon_sym_COMMA,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(4137), 1,
      anon_sym_LBRACK,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4159), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4167), 1,
      anon_sym_export,
    ACTIONS(4169), 1,
      anon_sym_RBRACE,
    ACTIONS(4171), 1,
      anon_sym_async,
    ACTIONS(4173), 1,
      anon_sym_static,
    ACTIONS(4175), 1,
      anon_sym_readonly,
    ACTIONS(4181), 1,
      anon_sym_override,
    STATE(2637), 1,
      sym_accessibility_modifier,
    STATE(2654), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4001), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4005), 1,
      aux_sym_object_repeat1,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4177), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4179), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2902), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4006), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4014), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3394), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4165), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [1269] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(1868), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3677), 1,
      anon_sym_DOT,
    ACTIONS(3694), 1,
      anon_sym_LBRACE,
    ACTIONS(3700), 1,
      anon_sym_EQ_GT,
    ACTIONS(3704), 1,
      anon_sym_BQUOTE,
    ACTIONS(3710), 1,
      anon_sym_EQ,
    STATE(1721), 1,
      sym_new_component_body,
    STATE(1831), 1,
      sym_tripple_tagged_type_string,
    STATE(1832), 1,
      sym_tagged_type_string,
    STATE(3375), 1,
      sym_component_identifier,
    ACTIONS(3782), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1852), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1848), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [1365] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(199), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4123), 1,
      anon_sym_export,
    ACTIONS(4125), 1,
      anon_sym_STAR,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4137), 1,
      anon_sym_LBRACK,
    ACTIONS(4139), 1,
      anon_sym_async,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4147), 1,
      anon_sym_static,
    ACTIONS(4149), 1,
      anon_sym_readonly,
    ACTIONS(4155), 1,
      anon_sym_override,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4183), 1,
      anon_sym_COMMA,
    ACTIONS(4185), 1,
      anon_sym_RBRACE,
    ACTIONS(4187), 1,
      anon_sym_SEMI,
    ACTIONS(4189), 1,
      anon_sym_PIPE_RBRACE,
    STATE(2637), 1,
      sym_accessibility_modifier,
    STATE(2654), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4001), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4005), 1,
      aux_sym_object_repeat1,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2902), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4006), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4014), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3347), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4121), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [1503] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(199), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4125), 1,
      anon_sym_STAR,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4129), 1,
      anon_sym_COMMA,
    ACTIONS(4131), 1,
      anon_sym_RBRACE,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(4137), 1,
      anon_sym_LBRACK,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4159), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4193), 1,
      anon_sym_export,
    ACTIONS(4195), 1,
      anon_sym_async,
    ACTIONS(4197), 1,
      anon_sym_static,
    ACTIONS(4199), 1,
      anon_sym_readonly,
    ACTIONS(4205), 1,
      anon_sym_override,
    STATE(2637), 1,
      sym_accessibility_modifier,
    STATE(2654), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4001), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4005), 1,
      aux_sym_object_repeat1,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4201), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4203), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2902), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4006), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4014), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3394), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4191), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [1641] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_EQ,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(1868), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3677), 1,
      anon_sym_DOT,
    ACTIONS(3694), 1,
      anon_sym_LBRACE,
    ACTIONS(3700), 1,
      anon_sym_EQ_GT,
    ACTIONS(3704), 1,
      anon_sym_BQUOTE,
    ACTIONS(4114), 1,
      anon_sym_in,
    ACTIONS(4207), 1,
      anon_sym_COLON,
    STATE(1721), 1,
      sym_new_component_body,
    STATE(1831), 1,
      sym_tripple_tagged_type_string,
    STATE(1832), 1,
      sym_tagged_type_string,
    STATE(3375), 1,
      sym_component_identifier,
    ACTIONS(1852), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1848), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [1739] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_EQ,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(1868), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3677), 1,
      anon_sym_DOT,
    ACTIONS(3694), 1,
      anon_sym_LBRACE,
    ACTIONS(3704), 1,
      anon_sym_BQUOTE,
    ACTIONS(4103), 1,
      anon_sym_EQ_GT,
    STATE(1721), 1,
      sym_new_component_body,
    STATE(1831), 1,
      sym_tripple_tagged_type_string,
    STATE(1832), 1,
      sym_tagged_type_string,
    STATE(3375), 1,
      sym_component_identifier,
    ACTIONS(1852), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1848), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [1833] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(199), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4125), 1,
      anon_sym_STAR,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4129), 1,
      anon_sym_COMMA,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(4137), 1,
      anon_sym_LBRACK,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4159), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4167), 1,
      anon_sym_export,
    ACTIONS(4171), 1,
      anon_sym_async,
    ACTIONS(4173), 1,
      anon_sym_static,
    ACTIONS(4175), 1,
      anon_sym_readonly,
    ACTIONS(4181), 1,
      anon_sym_override,
    ACTIONS(4209), 1,
      anon_sym_RBRACE,
    STATE(2637), 1,
      sym_accessibility_modifier,
    STATE(2654), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4001), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4005), 1,
      aux_sym_object_repeat1,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4177), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4179), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2902), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4006), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4014), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3394), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4165), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [1971] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(199), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4125), 1,
      anon_sym_STAR,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4129), 1,
      anon_sym_COMMA,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(4137), 1,
      anon_sym_LBRACK,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4159), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4213), 1,
      anon_sym_export,
    ACTIONS(4215), 1,
      anon_sym_RBRACE,
    ACTIONS(4217), 1,
      anon_sym_async,
    ACTIONS(4219), 1,
      anon_sym_static,
    ACTIONS(4221), 1,
      anon_sym_readonly,
    ACTIONS(4227), 1,
      anon_sym_override,
    STATE(2637), 1,
      sym_accessibility_modifier,
    STATE(2654), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4001), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4005), 1,
      aux_sym_object_repeat1,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4223), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4225), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2902), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4006), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4014), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3394), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4211), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2109] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1936), 1,
      anon_sym_COLON,
    ACTIONS(1938), 1,
      anon_sym_EQ,
    ACTIONS(3766), 1,
      sym_identifier,
    ACTIONS(3768), 1,
      anon_sym_DQUOTE,
    ACTIONS(3770), 1,
      anon_sym_SQUOTE,
    STATE(633), 1,
      sym_nested_identifier,
    STATE(702), 1,
      sym_string,
    STATE(718), 1,
      sym__module,
    ACTIONS(65), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [2199] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(199), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4125), 1,
      anon_sym_STAR,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4129), 1,
      anon_sym_COMMA,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4135), 1,
      anon_sym_SEMI,
    ACTIONS(4137), 1,
      anon_sym_LBRACK,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4159), 1,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4167), 1,
      anon_sym_export,
    ACTIONS(4171), 1,
      anon_sym_async,
    ACTIONS(4173), 1,
      anon_sym_static,
    ACTIONS(4175), 1,
      anon_sym_readonly,
    ACTIONS(4181), 1,
      anon_sym_override,
    ACTIONS(4229), 1,
      anon_sym_RBRACE,
    STATE(2637), 1,
      sym_accessibility_modifier,
    STATE(2654), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4001), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4005), 1,
      aux_sym_object_repeat1,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4177), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4179), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2902), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4006), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4014), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3394), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4165), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [2337] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(1868), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3677), 1,
      anon_sym_DOT,
    ACTIONS(3694), 1,
      anon_sym_LBRACE,
    ACTIONS(3704), 1,
      anon_sym_BQUOTE,
    ACTIONS(4101), 1,
      anon_sym_EQ,
    ACTIONS(4103), 1,
      anon_sym_EQ_GT,
    STATE(1721), 1,
      sym_new_component_body,
    STATE(1831), 1,
      sym_tripple_tagged_type_string,
    STATE(1832), 1,
      sym_tagged_type_string,
    STATE(3375), 1,
      sym_component_identifier,
    ACTIONS(1852), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1848), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2431] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(1868), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3677), 1,
      anon_sym_DOT,
    ACTIONS(3694), 1,
      anon_sym_LBRACE,
    ACTIONS(3704), 1,
      anon_sym_BQUOTE,
    ACTIONS(4231), 1,
      anon_sym_EQ,
    ACTIONS(4233), 1,
      anon_sym_EQ_GT,
    STATE(1721), 1,
      sym_new_component_body,
    STATE(1831), 1,
      sym_tripple_tagged_type_string,
    STATE(1832), 1,
      sym_tagged_type_string,
    STATE(3375), 1,
      sym_component_identifier,
    ACTIONS(1852), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1848), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2524] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    ACTIONS(1894), 1,
      anon_sym_COLON,
    ACTIONS(1897), 1,
      anon_sym_EQ,
    ACTIONS(1899), 1,
      anon_sym_LT,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1910), 1,
      anon_sym_QMARK,
    ACTIONS(1930), 1,
      anon_sym_RBRACE,
    ACTIONS(4235), 1,
      sym_identifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3990), 1,
      aux_sym_object_repeat1,
    ACTIONS(65), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [2615] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_EQ,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(1868), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3677), 1,
      anon_sym_DOT,
    ACTIONS(3694), 1,
      anon_sym_LBRACE,
    ACTIONS(3704), 1,
      anon_sym_BQUOTE,
    ACTIONS(4233), 1,
      anon_sym_EQ_GT,
    STATE(1721), 1,
      sym_new_component_body,
    STATE(1831), 1,
      sym_tripple_tagged_type_string,
    STATE(1832), 1,
      sym_tagged_type_string,
    STATE(3375), 1,
      sym_component_identifier,
    ACTIONS(1852), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1848), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2708] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_RBRACE,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    ACTIONS(1894), 1,
      anon_sym_COLON,
    ACTIONS(1897), 1,
      anon_sym_EQ,
    ACTIONS(1899), 1,
      anon_sym_LT,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1910), 1,
      anon_sym_QMARK,
    ACTIONS(4237), 1,
      sym_identifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4053), 1,
      aux_sym_object_repeat1,
    ACTIONS(65), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [2799] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_RBRACE,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    ACTIONS(1894), 1,
      anon_sym_COLON,
    ACTIONS(1897), 1,
      anon_sym_EQ,
    ACTIONS(1899), 1,
      anon_sym_LT,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1910), 1,
      anon_sym_QMARK,
    ACTIONS(4235), 1,
      sym_identifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4053), 1,
      aux_sym_object_repeat1,
    ACTIONS(65), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [2890] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    ACTIONS(1894), 1,
      anon_sym_COLON,
    ACTIONS(1897), 1,
      anon_sym_EQ,
    ACTIONS(1899), 1,
      anon_sym_LT,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1910), 1,
      anon_sym_QMARK,
    ACTIONS(1928), 1,
      anon_sym_RBRACE,
    ACTIONS(4237), 1,
      sym_identifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(65), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [2981] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    ACTIONS(1894), 1,
      anon_sym_COLON,
    ACTIONS(1897), 1,
      anon_sym_EQ,
    ACTIONS(1899), 1,
      anon_sym_LT,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1910), 1,
      anon_sym_QMARK,
    ACTIONS(1926), 1,
      anon_sym_RBRACE,
    ACTIONS(4237), 1,
      sym_identifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(65), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [3072] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    ACTIONS(1894), 1,
      anon_sym_COLON,
    ACTIONS(1897), 1,
      anon_sym_EQ,
    ACTIONS(1899), 1,
      anon_sym_LT,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1910), 1,
      anon_sym_QMARK,
    ACTIONS(1928), 1,
      anon_sym_RBRACE,
    ACTIONS(4235), 1,
      sym_identifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(65), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [3163] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_EQ,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(1868), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3677), 1,
      anon_sym_DOT,
    ACTIONS(3694), 1,
      anon_sym_LBRACE,
    ACTIONS(3700), 1,
      anon_sym_EQ_GT,
    ACTIONS(3704), 1,
      anon_sym_BQUOTE,
    ACTIONS(4107), 1,
      anon_sym_in,
    ACTIONS(4110), 1,
      anon_sym_of,
    STATE(1721), 1,
      sym_new_component_body,
    STATE(1831), 1,
      sym_tripple_tagged_type_string,
    STATE(1832), 1,
      sym_tagged_type_string,
    STATE(3375), 1,
      sym_component_identifier,
    ACTIONS(1852), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1848), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3260] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    ACTIONS(1894), 1,
      anon_sym_COLON,
    ACTIONS(1897), 1,
      anon_sym_EQ,
    ACTIONS(1899), 1,
      anon_sym_LT,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1910), 1,
      anon_sym_QMARK,
    ACTIONS(1930), 1,
      anon_sym_RBRACE,
    ACTIONS(4237), 1,
      sym_identifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3990), 1,
      aux_sym_object_repeat1,
    ACTIONS(65), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [3351] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    ACTIONS(1894), 1,
      anon_sym_COLON,
    ACTIONS(1897), 1,
      anon_sym_EQ,
    ACTIONS(1899), 1,
      anon_sym_LT,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1910), 1,
      anon_sym_QMARK,
    ACTIONS(1926), 1,
      anon_sym_RBRACE,
    ACTIONS(4235), 1,
      sym_identifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(65), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [3442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1992), 23,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(1994), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [3510] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    ACTIONS(1894), 1,
      anon_sym_COLON,
    ACTIONS(1897), 1,
      anon_sym_EQ,
    ACTIONS(1899), 1,
      anon_sym_LT,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1910), 1,
      anon_sym_QMARK,
    ACTIONS(1926), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(65), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(25), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1984), 23,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(1986), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [3666] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    ACTIONS(1894), 1,
      anon_sym_COLON,
    ACTIONS(1897), 1,
      anon_sym_EQ,
    ACTIONS(1899), 1,
      anon_sym_LT,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1910), 1,
      anon_sym_QMARK,
    ACTIONS(1930), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3990), 1,
      aux_sym_object_repeat1,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(65), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(25), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3754] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    ACTIONS(1894), 1,
      anon_sym_COLON,
    ACTIONS(1897), 1,
      anon_sym_EQ,
    ACTIONS(1899), 1,
      anon_sym_LT,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1910), 1,
      anon_sym_QMARK,
    ACTIONS(1928), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(65), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(25), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1996), 23,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(1998), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [3910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1980), 23,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(1982), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [3978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2004), 23,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2006), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [4046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1988), 23,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(1990), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [4114] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_RBRACE,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    ACTIONS(1894), 1,
      anon_sym_COLON,
    ACTIONS(1897), 1,
      anon_sym_EQ,
    ACTIONS(1899), 1,
      anon_sym_LT,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1910), 1,
      anon_sym_QMARK,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4053), 1,
      aux_sym_object_repeat1,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(65), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(25), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2000), 23,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2002), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [4270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2008), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2010), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [4337] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_EQ,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1848), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [4408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2012), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2014), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [4475] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(199), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4125), 1,
      anon_sym_STAR,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4137), 1,
      anon_sym_LBRACK,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4241), 1,
      anon_sym_export,
    ACTIONS(4246), 1,
      anon_sym_async,
    ACTIONS(4248), 1,
      anon_sym_static,
    ACTIONS(4250), 1,
      anon_sym_readonly,
    ACTIONS(4256), 1,
      anon_sym_override,
    STATE(2637), 1,
      sym_accessibility_modifier,
    STATE(2654), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4243), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4252), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4254), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2902), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4384), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4444), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3513), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4239), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [4599] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(124), 1,
      anon_sym_EQ,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(4258), 1,
      anon_sym_LBRACK,
    ACTIONS(4261), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1248), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(65), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4677] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(199), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4125), 1,
      anon_sym_STAR,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4137), 1,
      anon_sym_LBRACK,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4241), 1,
      anon_sym_export,
    ACTIONS(4246), 1,
      anon_sym_async,
    ACTIONS(4248), 1,
      anon_sym_static,
    ACTIONS(4250), 1,
      anon_sym_readonly,
    ACTIONS(4256), 1,
      anon_sym_override,
    STATE(2637), 1,
      sym_accessibility_modifier,
    STATE(2654), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4243), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4252), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4254), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2902), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4384), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4444), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3376), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4239), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [4801] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_RBRACK,
    ACTIONS(124), 1,
      anon_sym_EQ,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(628), 1,
      anon_sym_QMARK,
    ACTIONS(122), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(65), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4879] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(1185), 1,
      anon_sym_EQ,
    ACTIONS(2319), 1,
      anon_sym_QMARK,
    ACTIONS(1183), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(65), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4955] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4268), 1,
      anon_sym_class,
    ACTIONS(4271), 1,
      anon_sym_AMP,
    ACTIONS(4274), 1,
      anon_sym_AT,
    ACTIONS(4277), 1,
      anon_sym_component,
    STATE(1456), 1,
      aux_sym_class_repeat1,
    STATE(1469), 1,
      sym_decorator,
    STATE(3844), 1,
      sym_component_short_heritage,
    ACTIONS(4266), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
    ACTIONS(4264), 38,
      anon_sym_export,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [5035] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1936), 1,
      anon_sym_COLON,
    ACTIONS(1938), 1,
      anon_sym_EQ,
    ACTIONS(4235), 1,
      sym_identifier,
    ACTIONS(65), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [5110] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_EQ,
    ACTIONS(3873), 1,
      anon_sym_QMARK,
    ACTIONS(3871), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1852), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1848), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5183] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3710), 1,
      anon_sym_EQ,
    ACTIONS(3784), 1,
      anon_sym_RBRACK,
    ACTIONS(3787), 1,
      anon_sym_QMARK,
    ACTIONS(3782), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1852), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1848), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5258] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1936), 1,
      anon_sym_COLON,
    ACTIONS(1938), 1,
      anon_sym_EQ,
    ACTIONS(4237), 1,
      sym_identifier,
    ACTIONS(65), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [5333] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4284), 1,
      anon_sym_LPAREN,
    ACTIONS(4286), 1,
      anon_sym_DOT,
    STATE(1481), 1,
      sym_arguments,
    ACTIONS(4282), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4280), 40,
      anon_sym_export,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_component,
  [5404] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(124), 1,
      anon_sym_EQ,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(628), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_LBRACK,
    ACTIONS(122), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1248), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(4261), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(65), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5485] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4274), 1,
      anon_sym_AT,
    STATE(1456), 1,
      aux_sym_class_repeat1,
    STATE(1469), 1,
      sym_decorator,
    ACTIONS(4266), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
    ACTIONS(4264), 40,
      anon_sym_export,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_component,
  [5556] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_EQ,
    ACTIONS(63), 1,
      anon_sym_EQ_GT,
    ACTIONS(628), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1248), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(4261), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(65), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5637] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1938), 1,
      anon_sym_EQ,
    ACTIONS(1940), 1,
      anon_sym_COLON,
    ACTIONS(4237), 1,
      sym_identifier,
    ACTIONS(65), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [5712] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1938), 1,
      anon_sym_EQ,
    ACTIONS(1940), 1,
      anon_sym_COLON,
    ACTIONS(4235), 1,
      sym_identifier,
    ACTIONS(65), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [5787] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_EQ,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1852), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1848), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4290), 15,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4288), 41,
      anon_sym_export,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_component,
  [5919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1992), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1994), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [5983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1984), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1986), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [6047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1988), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1990), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [6111] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(124), 1,
      anon_sym_EQ,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(4258), 1,
      anon_sym_LBRACK,
    ACTIONS(4261), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1248), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(65), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1996), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1998), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [6253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1980), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1982), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [6317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4282), 15,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4280), 41,
      anon_sym_export,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_component,
  [6381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4294), 15,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4292), 41,
      anon_sym_export,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_component,
  [6445] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1237), 1,
      anon_sym_EQ,
    ACTIONS(1239), 1,
      anon_sym_EQ_GT,
    ACTIONS(1248), 1,
      anon_sym_extends,
    ACTIONS(4258), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4261), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(65), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6521] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_EQ,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(65), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(25), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2012), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2014), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [6655] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(1183), 1,
      anon_sym_COLON,
    ACTIONS(1185), 1,
      anon_sym_EQ,
    ACTIONS(4258), 1,
      anon_sym_LBRACK,
    ACTIONS(4261), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1248), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(65), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6733] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1938), 1,
      anon_sym_EQ,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(65), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(25), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6803] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_EQ,
    ACTIONS(63), 1,
      anon_sym_EQ_GT,
    ACTIONS(628), 1,
      anon_sym_QMARK,
    ACTIONS(29), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(65), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6877] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(1183), 1,
      anon_sym_COLON,
    ACTIONS(1185), 1,
      anon_sym_EQ,
    ACTIONS(1180), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(65), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2000), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2002), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [7015] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1938), 1,
      anon_sym_EQ,
    ACTIONS(2374), 1,
      anon_sym_in,
    ACTIONS(4296), 1,
      anon_sym_of,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(65), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(25), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2008), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2010), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [7153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2004), 22,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2006), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [7217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4300), 15,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(4298), 41,
      anon_sym_export,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_component,
  [7281] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2393), 1,
      anon_sym_EQ,
    ACTIONS(2395), 1,
      anon_sym_EQ_GT,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(65), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(25), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7351] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(1185), 1,
      anon_sym_EQ,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(65), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(25), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7421] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1936), 1,
      anon_sym_COLON,
    ACTIONS(1938), 1,
      anon_sym_EQ,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(65), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(25), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7493] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_EQ,
    ACTIONS(2395), 1,
      anon_sym_EQ_GT,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(65), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(25), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7563] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(1183), 1,
      anon_sym_COLON,
    ACTIONS(1185), 1,
      anon_sym_EQ,
    ACTIONS(1248), 1,
      anon_sym_extends,
    ACTIONS(4258), 1,
      anon_sym_LBRACK,
    ACTIONS(4261), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4302), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(65), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7643] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1908), 1,
      anon_sym_EQ_GT,
    ACTIONS(1938), 1,
      anon_sym_EQ,
    ACTIONS(1940), 1,
      anon_sym_COLON,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(65), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(25), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7715] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_EQ,
    ACTIONS(1239), 1,
      anon_sym_EQ_GT,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(65), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(25), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 15,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3127), 40,
      anon_sym_export,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_component,
  [7847] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_EQ,
    ACTIONS(3871), 1,
      anon_sym_COLON,
    ACTIONS(4118), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(1852), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1848), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7918] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(124), 1,
      anon_sym_EQ,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(29), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(65), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7989] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1237), 1,
      anon_sym_EQ,
    ACTIONS(1239), 1,
      anon_sym_EQ_GT,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(65), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(25), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3274), 15,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3272), 40,
      anon_sym_export,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_component,
  [8121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 15,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3210), 40,
      anon_sym_export,
      anon_sym_type,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_component,
  [8184] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4093), 1,
      anon_sym_EQ,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1852), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1848), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8251] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3787), 1,
      anon_sym_QMARK,
    ACTIONS(3812), 1,
      anon_sym_EQ,
    ACTIONS(3784), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1852), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1848), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8322] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_EQ_GT,
    ACTIONS(1185), 1,
      anon_sym_EQ,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(65), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(25), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8391] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_RBRACK,
    ACTIONS(122), 1,
      anon_sym_COMMA,
    ACTIONS(124), 1,
      anon_sym_EQ,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(2484), 1,
      anon_sym_COLON,
    ACTIONS(65), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8466] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4093), 1,
      anon_sym_EQ,
    ACTIONS(4107), 1,
      anon_sym_in,
    ACTIONS(4110), 1,
      anon_sym_of,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1852), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1848), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8537] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym_EQ,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1852), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1848), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8604] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(1185), 1,
      anon_sym_EQ,
    ACTIONS(1248), 1,
      anon_sym_extends,
    ACTIONS(4258), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4261), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(65), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8679] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 1,
      anon_sym_EQ_GT,
    ACTIONS(2425), 1,
      anon_sym_EQ,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(65), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(25), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8748] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3710), 1,
      anon_sym_EQ,
    ACTIONS(3784), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(1852), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1848), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8816] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(1185), 1,
      anon_sym_EQ,
    ACTIONS(2542), 1,
      anon_sym_COLON,
    ACTIONS(65), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4306), 1,
      sym__automatic_semicolon,
    ACTIONS(1526), 17,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1524), 36,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_else,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [8950] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2898), 1,
      sym__automatic_semicolon,
    ACTIONS(1370), 17,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1366), 36,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_else,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [9014] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4013), 1,
      anon_sym_EQ,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1852), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1848), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9080] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4101), 1,
      anon_sym_EQ,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1852), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(1848), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9146] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(124), 1,
      anon_sym_EQ,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(122), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(65), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9216] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(1185), 1,
      anon_sym_EQ,
    ACTIONS(2484), 1,
      anon_sym_COLON,
    ACTIONS(65), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9286] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(1185), 1,
      anon_sym_EQ,
    ACTIONS(2374), 1,
      anon_sym_in,
    ACTIONS(4296), 1,
      anon_sym_of,
    ACTIONS(65), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 18,
      ts_builtin_sym_end,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3429), 35,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_component,
      anon_sym_instance,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [9418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3559), 18,
      ts_builtin_sym_end,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3557), 35,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_component,
      anon_sym_instance,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [9479] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3710), 1,
      anon_sym_EQ,
    ACTIONS(3782), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1852), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1848), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9546] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2662), 1,
      anon_sym_EQ,
    ACTIONS(2664), 1,
      anon_sym_EQ_GT,
    ACTIONS(65), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3419), 18,
      ts_builtin_sym_end,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3417), 35,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_component,
      anon_sym_instance,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [9674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3547), 18,
      ts_builtin_sym_end,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3545), 35,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_component,
      anon_sym_instance,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [9735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 17,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1640), 36,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_else,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [9796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1526), 17,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1524), 36,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_else,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [9857] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1185), 1,
      anon_sym_EQ,
    ACTIONS(2664), 1,
      anon_sym_EQ_GT,
    ACTIONS(65), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(69), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(25), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9924] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4231), 1,
      anon_sym_EQ,
    ACTIONS(1852), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1848), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9988] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_EQ,
    ACTIONS(4107), 1,
      anon_sym_in,
    ACTIONS(4110), 1,
      anon_sym_of,
    ACTIONS(1852), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
    ACTIONS(1861), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1848), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10056] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4312), 1,
      anon_sym_COLON,
    ACTIONS(4314), 1,
      anon_sym_EQ,
    ACTIONS(4310), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4308), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [10118] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3736), 1,
      anon_sym_EQ,
    STATE(1554), 1,
      sym_property_expression_initializer,
    ACTIONS(4318), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4316), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [10180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4322), 18,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4320), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [10238] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4328), 1,
      anon_sym_COLON,
    ACTIONS(4326), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4324), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [10297] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4334), 1,
      anon_sym_COLON,
    ACTIONS(4332), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4330), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [10356] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4135), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4159), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3394), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [10463] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4358), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4360), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3480), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [10570] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4362), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4364), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3425), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [10677] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4366), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4368), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3348), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [10784] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4370), 1,
      anon_sym_LPAREN,
    STATE(1513), 1,
      sym_arguments,
    ACTIONS(3304), 15,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3302), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [10845] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4187), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4189), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3347), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [10952] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 1,
      anon_sym_LPAREN,
    STATE(1516), 1,
      sym_arguments,
    ACTIONS(3143), 15,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3141), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11013] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4376), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4378), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3503), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [11120] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4380), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4382), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3354), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [11227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4386), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4384), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4390), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4388), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4394), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4392), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3411), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3409), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4398), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4396), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2618), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2612), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3455), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3453), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4402), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4400), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3127), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4406), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4404), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4410), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4408), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4414), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4412), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3437), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [11955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4418), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4416), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4422), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4420), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4426), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4424), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4430), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4428), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4434), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4432), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4438), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4436), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4442), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4440), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12347] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4448), 1,
      anon_sym_SEMI,
    ACTIONS(4446), 15,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4444), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4452), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4450), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4456), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4454), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3433), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4460), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4458), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4464), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4462), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4468), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4466), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4472), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4470), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3531), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3529), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3407), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3405), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3274), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3272), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [12965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3403), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3401), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [13021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3415), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3413), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [13077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4474), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [13133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4480), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4478), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [13189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(3210), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [13245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4484), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4482), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [13301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4488), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4486), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [13357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4492), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4490), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [13413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4496), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4494), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [13469] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4498), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3601), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [13572] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4500), 1,
      anon_sym_COLON,
    ACTIONS(4502), 1,
      anon_sym_EQ,
    ACTIONS(4310), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4308), 29,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [13631] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4504), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3601), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [13734] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4506), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3601), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [13837] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4508), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3601), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [13940] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4510), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3601), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14043] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4512), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3601), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14146] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4514), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3601), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14249] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4516), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3601), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14352] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4518), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3601), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14455] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4520), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3601), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14558] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4522), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3601), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14661] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4524), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3601), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14764] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4526), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3601), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14867] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4528), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3601), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [14970] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4530), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3601), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15073] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4532), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3601), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15176] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4534), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3601), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15279] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4536), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3601), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4540), 15,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4538), 32,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_constructor,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [15437] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4542), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3601), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15540] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4544), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3601), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15643] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4546), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3601), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15746] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4548), 1,
      anon_sym_LT,
    ACTIONS(4550), 1,
      anon_sym_DOT,
    ACTIONS(4552), 1,
      anon_sym_is,
    STATE(1733), 1,
      sym_type_arguments,
    ACTIONS(2588), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2590), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [15808] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_STAR,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(199), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4556), 1,
      anon_sym_RBRACE,
    ACTIONS(4558), 1,
      anon_sym_LBRACK,
    ACTIONS(4560), 1,
      anon_sym_async,
    ACTIONS(4562), 1,
      anon_sym_static,
    ACTIONS(4564), 1,
      anon_sym_readonly,
    ACTIONS(4570), 1,
      anon_sym_override,
    STATE(2635), 1,
      sym_accessibility_modifier,
    STATE(2656), 1,
      sym_override_modifier,
    STATE(4001), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4065), 1,
      aux_sym_object_repeat1,
    ACTIONS(211), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4566), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4568), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3249), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4014), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4067), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4554), 11,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [15906] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_STAR,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(199), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4558), 1,
      anon_sym_LBRACK,
    ACTIONS(4574), 1,
      anon_sym_RBRACE,
    ACTIONS(4576), 1,
      anon_sym_async,
    ACTIONS(4578), 1,
      anon_sym_static,
    ACTIONS(4580), 1,
      anon_sym_readonly,
    ACTIONS(4586), 1,
      anon_sym_override,
    STATE(2635), 1,
      sym_accessibility_modifier,
    STATE(2656), 1,
      sym_override_modifier,
    STATE(4001), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4005), 1,
      aux_sym_object_repeat1,
    ACTIONS(211), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4582), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4584), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3249), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4006), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4014), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4572), 11,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16004] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_STAR,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(199), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4558), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_RBRACE,
    ACTIONS(4592), 1,
      anon_sym_async,
    ACTIONS(4594), 1,
      anon_sym_static,
    ACTIONS(4596), 1,
      anon_sym_readonly,
    ACTIONS(4602), 1,
      anon_sym_override,
    STATE(2635), 1,
      sym_accessibility_modifier,
    STATE(2656), 1,
      sym_override_modifier,
    STATE(4001), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4005), 1,
      aux_sym_object_repeat1,
    ACTIONS(211), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4598), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4600), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3249), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4006), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4014), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4588), 11,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16102] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_STAR,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(199), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4558), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_RBRACE,
    ACTIONS(4606), 1,
      anon_sym_async,
    ACTIONS(4608), 1,
      anon_sym_static,
    ACTIONS(4610), 1,
      anon_sym_readonly,
    ACTIONS(4616), 1,
      anon_sym_override,
    STATE(2635), 1,
      sym_accessibility_modifier,
    STATE(2656), 1,
      sym_override_modifier,
    STATE(4001), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4005), 1,
      aux_sym_object_repeat1,
    ACTIONS(211), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4612), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4614), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3249), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4006), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4014), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4604), 11,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16200] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_STAR,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(199), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4558), 1,
      anon_sym_LBRACK,
    ACTIONS(4620), 1,
      anon_sym_RBRACE,
    ACTIONS(4622), 1,
      anon_sym_async,
    ACTIONS(4624), 1,
      anon_sym_static,
    ACTIONS(4626), 1,
      anon_sym_readonly,
    ACTIONS(4632), 1,
      anon_sym_override,
    STATE(2635), 1,
      sym_accessibility_modifier,
    STATE(2656), 1,
      sym_override_modifier,
    STATE(4001), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4005), 1,
      aux_sym_object_repeat1,
    ACTIONS(211), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4628), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4630), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3249), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4006), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4014), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4618), 11,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16298] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_STAR,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(199), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4558), 1,
      anon_sym_LBRACK,
    ACTIONS(4636), 1,
      anon_sym_RBRACE,
    ACTIONS(4638), 1,
      anon_sym_async,
    ACTIONS(4640), 1,
      anon_sym_static,
    ACTIONS(4642), 1,
      anon_sym_readonly,
    ACTIONS(4648), 1,
      anon_sym_override,
    STATE(2635), 1,
      sym_accessibility_modifier,
    STATE(2656), 1,
      sym_override_modifier,
    STATE(4001), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4005), 1,
      aux_sym_object_repeat1,
    ACTIONS(211), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4644), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4646), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3249), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4006), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4014), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4634), 11,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16396] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4548), 1,
      anon_sym_LT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    STATE(1653), 1,
      sym_type_arguments,
    STATE(1772), 1,
      sym_arguments,
    STATE(3575), 1,
      sym_optional_chain,
    ACTIONS(2552), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2554), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [16466] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_STAR,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(199), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4558), 1,
      anon_sym_LBRACK,
    ACTIONS(4658), 1,
      anon_sym_RBRACE,
    ACTIONS(4660), 1,
      anon_sym_async,
    ACTIONS(4662), 1,
      anon_sym_static,
    ACTIONS(4664), 1,
      anon_sym_readonly,
    ACTIONS(4670), 1,
      anon_sym_override,
    STATE(2635), 1,
      sym_accessibility_modifier,
    STATE(2656), 1,
      sym_override_modifier,
    STATE(4001), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4133), 1,
      aux_sym_object_repeat1,
    ACTIONS(211), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4666), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4668), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3249), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4014), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4134), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4656), 11,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16564] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_STAR,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(199), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4558), 1,
      anon_sym_LBRACK,
    ACTIONS(4674), 1,
      anon_sym_RBRACE,
    ACTIONS(4676), 1,
      anon_sym_async,
    ACTIONS(4678), 1,
      anon_sym_static,
    ACTIONS(4680), 1,
      anon_sym_readonly,
    ACTIONS(4686), 1,
      anon_sym_override,
    STATE(2635), 1,
      sym_accessibility_modifier,
    STATE(2656), 1,
      sym_override_modifier,
    STATE(4001), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4133), 1,
      aux_sym_object_repeat1,
    ACTIONS(211), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4682), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4684), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3249), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4014), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4134), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4672), 11,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16662] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_STAR,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(199), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4558), 1,
      anon_sym_LBRACK,
    ACTIONS(4690), 1,
      anon_sym_RBRACE,
    ACTIONS(4692), 1,
      anon_sym_async,
    ACTIONS(4694), 1,
      anon_sym_static,
    ACTIONS(4696), 1,
      anon_sym_readonly,
    ACTIONS(4702), 1,
      anon_sym_override,
    STATE(2635), 1,
      sym_accessibility_modifier,
    STATE(2656), 1,
      sym_override_modifier,
    STATE(4001), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4005), 1,
      aux_sym_object_repeat1,
    ACTIONS(211), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4698), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4700), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3249), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4006), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4014), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4688), 11,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [16760] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4704), 1,
      anon_sym_COLON,
    ACTIONS(4326), 16,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4324), 29,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [16816] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2848), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2850), 22,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [16889] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 1,
      anon_sym_EQ,
    ACTIONS(4714), 1,
      sym__automatic_semicolon,
    ACTIONS(1366), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1370), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [16946] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2804), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2806), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [17013] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3426), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17112] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(2762), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2764), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [17177] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(2710), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2712), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [17236] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3376), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17335] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4548), 1,
      anon_sym_LT,
    ACTIONS(4550), 1,
      anon_sym_DOT,
    STATE(1733), 1,
      sym_type_arguments,
    ACTIONS(2588), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2590), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [17394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3090), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(3092), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [17447] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3601), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17546] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4716), 1,
      anon_sym_DOT,
    STATE(1715), 1,
      sym_arguments,
    ACTIONS(2860), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2862), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [17605] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4718), 1,
      anon_sym_DOT,
    STATE(1716), 1,
      sym_arguments,
    ACTIONS(2842), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2844), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [17664] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4720), 1,
      anon_sym_DOT,
    STATE(1717), 1,
      sym_arguments,
    ACTIONS(2828), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2830), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [17723] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3473), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2904), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(2906), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [17875] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3484), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17974] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4548), 1,
      anon_sym_LT,
    STATE(1696), 1,
      sym_type_arguments,
    ACTIONS(2834), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2836), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1250), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1248), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_is,
  [18084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4722), 1,
      anon_sym_is,
    ACTIONS(2834), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2836), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18139] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3513), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [18238] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3381), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [18337] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(4141), 1,
      anon_sym_new,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4157), 1,
      anon_sym_abstract,
    ACTIONS(4338), 1,
      anon_sym_export,
    ACTIONS(4340), 1,
      anon_sym_STAR,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4344), 1,
      anon_sym_async,
    ACTIONS(4348), 1,
      anon_sym_static,
    ACTIONS(4350), 1,
      anon_sym_readonly,
    ACTIONS(4356), 1,
      anon_sym_override,
    STATE(2636), 1,
      sym_accessibility_modifier,
    STATE(2657), 1,
      sym_override_modifier,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3659), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(4346), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4352), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3398), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [18436] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4728), 1,
      anon_sym_SEMI,
    ACTIONS(4726), 15,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4724), 29,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [18491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4552), 1,
      anon_sym_is,
    ACTIONS(2982), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2984), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3290), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3292), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3152), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3154), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18650] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4730), 1,
      anon_sym_DOT,
    ACTIONS(3112), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3114), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3190), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3192), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3190), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3192), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3190), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3192), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3208), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3208), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [18964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3208), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3214), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3216), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2812), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2814), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19120] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4733), 1,
      anon_sym_LBRACK,
    ACTIONS(3226), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3228), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3232), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3234), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19226] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4735), 1,
      sym__automatic_semicolon,
    ACTIONS(1524), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1526), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [19280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3256), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3258), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19332] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    STATE(3575), 1,
      sym_optional_chain,
    ACTIONS(3286), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3288), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [19392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3236), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3238), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19444] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    STATE(1813), 1,
      sym_arguments,
    ACTIONS(3371), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3373), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [19500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3094), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3096), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19552] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_EQ,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [19606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3094), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3096), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3094), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3096), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3319), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3319), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3319), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3246), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3246), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [19970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3246), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3240), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3242), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2796), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2798), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20126] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4739), 1,
      anon_sym_PIPE,
    ACTIONS(4741), 1,
      anon_sym_extends,
    ACTIONS(3393), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3395), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [20184] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4739), 1,
      anon_sym_PIPE,
    ACTIONS(4741), 1,
      anon_sym_extends,
    ACTIONS(3260), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3262), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [20242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3174), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3176), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3198), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3200), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3139), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20398] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4739), 1,
      anon_sym_PIPE,
    ACTIONS(4741), 1,
      anon_sym_extends,
    ACTIONS(3137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3139), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [20456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3102), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3104), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20508] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4714), 1,
      sym__automatic_semicolon,
    ACTIONS(1366), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1370), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [20562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3252), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3254), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3284), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3294), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3296), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3290), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3292), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3294), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3296), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3335), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3337), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3339), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3341), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3335), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3337), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [20978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3339), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3341), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3196), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3090), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(3092), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [21134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3152), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3154), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3196), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3174), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3176), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3119), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3121), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3156), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3158), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2740), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3123), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21498] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 1,
      anon_sym_EQ,
    ACTIONS(1368), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [21552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3264), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3266), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2982), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2984), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3174), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3176), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3309), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3311), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2834), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2836), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21812] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4739), 1,
      anon_sym_PIPE,
    ACTIONS(4741), 1,
      anon_sym_extends,
    ACTIONS(3379), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3381), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [21870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3178), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3180), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [21922] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3280), 1,
      anon_sym_EQ,
    ACTIONS(4743), 1,
      anon_sym_COLON,
    ACTIONS(3276), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3278), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [21978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3148), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3150), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3272), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3274), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3210), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3212), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3298), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3300), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3268), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3270), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22238] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(3375), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3377), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22292] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4739), 1,
      anon_sym_PIPE,
    ACTIONS(4741), 1,
      anon_sym_extends,
    ACTIONS(3367), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3369), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [22350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3248), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3250), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3222), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3224), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22454] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4739), 1,
      anon_sym_PIPE,
    ACTIONS(4741), 1,
      anon_sym_extends,
    ACTIONS(3222), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3224), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [22512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3202), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3204), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3186), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3188), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3182), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3184), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3086), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3088), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3170), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3172), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3166), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3168), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3162), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3164), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4747), 15,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_QMARK,
      anon_sym_LBRACE_PIPE,
    ACTIONS(4745), 29,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_async,
      anon_sym_new,
      anon_sym_void,
      sym_identifier,
      sym_this,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
      anon_sym_infer,
      anon_sym_keyof,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
      anon_sym_prop,
      anon_sym_id,
      anon_sym_event,
      anon_sym_fn,
      anon_sym_on,
  [22928] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4739), 1,
      anon_sym_PIPE,
    ACTIONS(3131), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3133), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [22984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2852), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2854), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23036] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4749), 1,
      anon_sym_LPAREN,
    STATE(1828), 1,
      sym_arguments,
    ACTIONS(3141), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3143), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [23092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2904), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(2906), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [23144] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4752), 1,
      anon_sym_DOT,
    ACTIONS(3325), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3327), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3127), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3129), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3218), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3220), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23302] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4754), 1,
      anon_sym_LPAREN,
    STATE(1796), 1,
      sym_arguments,
    ACTIONS(3302), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3304), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [23358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3333), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23410] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 1,
      anon_sym_EQ,
    ACTIONS(3383), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3385), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [23464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3343), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3345), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23516] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(3106), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3108), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3391), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3098), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3100), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3361), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3363), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23726] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_AMP,
    ACTIONS(4739), 1,
      anon_sym_PIPE,
    ACTIONS(4741), 1,
      anon_sym_extends,
    ACTIONS(3357), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3359), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [23784] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3228), 1,
      anon_sym_extends,
    ACTIONS(4733), 1,
      anon_sym_LBRACK,
    ACTIONS(3226), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3347), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [23842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3321), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3323), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23894] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4733), 1,
      anon_sym_LBRACK,
    ACTIONS(3313), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3315), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [23948] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_STAR,
    ACTIONS(199), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4558), 1,
      anon_sym_LBRACK,
    ACTIONS(4759), 1,
      anon_sym_async,
    ACTIONS(4761), 1,
      anon_sym_static,
    ACTIONS(4763), 1,
      anon_sym_readonly,
    ACTIONS(4769), 1,
      anon_sym_override,
    STATE(2635), 1,
      sym_accessibility_modifier,
    STATE(2656), 1,
      sym_override_modifier,
    ACTIONS(211), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4243), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4765), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4767), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3249), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4384), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4444), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4757), 11,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [24038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1532), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1536), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24089] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4771), 1,
      anon_sym_LT,
    ACTIONS(4773), 1,
      anon_sym_DOT,
    ACTIONS(4775), 1,
      anon_sym_is,
    STATE(1893), 1,
      sym_type_arguments,
    ACTIONS(2588), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2590), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [24148] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4777), 1,
      anon_sym_STAR,
    ACTIONS(4779), 1,
      anon_sym_RBRACE,
    ACTIONS(4781), 1,
      anon_sym_async,
    ACTIONS(4785), 1,
      anon_sym_AT,
    ACTIONS(4787), 1,
      anon_sym_static,
    ACTIONS(4789), 1,
      anon_sym_readonly,
    ACTIONS(4793), 1,
      anon_sym_declare,
    ACTIONS(4795), 1,
      anon_sym_abstract,
    STATE(2593), 1,
      sym_method_definition,
    STATE(2619), 1,
      sym_accessibility_modifier,
    STATE(2652), 1,
      sym_override_modifier,
    STATE(3899), 1,
      sym_method_signature,
    ACTIONS(4783), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4791), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1745), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2860), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3907), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [24243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3523), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3286), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3288), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24396] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4777), 1,
      anon_sym_STAR,
    ACTIONS(4781), 1,
      anon_sym_async,
    ACTIONS(4785), 1,
      anon_sym_AT,
    ACTIONS(4787), 1,
      anon_sym_static,
    ACTIONS(4789), 1,
      anon_sym_readonly,
    ACTIONS(4793), 1,
      anon_sym_declare,
    ACTIONS(4795), 1,
      anon_sym_abstract,
    ACTIONS(4797), 1,
      anon_sym_RBRACE,
    STATE(2593), 1,
      sym_method_definition,
    STATE(2619), 1,
      sym_accessibility_modifier,
    STATE(2652), 1,
      sym_override_modifier,
    STATE(3899), 1,
      sym_method_signature,
    ACTIONS(4783), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4791), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1803), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2860), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3907), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [24491] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4771), 1,
      anon_sym_LT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    STATE(2017), 1,
      sym_type_arguments,
    STATE(2248), 1,
      sym_arguments,
    STATE(3681), 1,
      sym_optional_chain,
    ACTIONS(2552), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2554), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [24558] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4777), 1,
      anon_sym_STAR,
    ACTIONS(4781), 1,
      anon_sym_async,
    ACTIONS(4785), 1,
      anon_sym_AT,
    ACTIONS(4787), 1,
      anon_sym_static,
    ACTIONS(4789), 1,
      anon_sym_readonly,
    ACTIONS(4793), 1,
      anon_sym_declare,
    ACTIONS(4795), 1,
      anon_sym_abstract,
    ACTIONS(4805), 1,
      anon_sym_RBRACE,
    STATE(2593), 1,
      sym_method_definition,
    STATE(2619), 1,
      sym_accessibility_modifier,
    STATE(2652), 1,
      sym_override_modifier,
    STATE(3899), 1,
      sym_method_signature,
    ACTIONS(4783), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4791), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1803), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2860), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3907), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [24653] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4777), 1,
      anon_sym_STAR,
    ACTIONS(4781), 1,
      anon_sym_async,
    ACTIONS(4785), 1,
      anon_sym_AT,
    ACTIONS(4787), 1,
      anon_sym_static,
    ACTIONS(4789), 1,
      anon_sym_readonly,
    ACTIONS(4793), 1,
      anon_sym_declare,
    ACTIONS(4795), 1,
      anon_sym_abstract,
    ACTIONS(4807), 1,
      anon_sym_RBRACE,
    STATE(2593), 1,
      sym_method_definition,
    STATE(2619), 1,
      sym_accessibility_modifier,
    STATE(2652), 1,
      sym_override_modifier,
    STATE(3899), 1,
      sym_method_signature,
    ACTIONS(4783), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4791), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1764), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2860), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3907), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [24748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3561), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3563), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1658), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1662), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3445), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3447), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3465), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3467), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [24952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3495), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3497), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3499), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1596), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1600), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25105] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3877), 1,
      anon_sym_LPAREN,
    STATE(2741), 1,
      sym_arguments,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3543), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2970), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2972), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1642), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25313] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4777), 1,
      anon_sym_STAR,
    ACTIONS(4781), 1,
      anon_sym_async,
    ACTIONS(4785), 1,
      anon_sym_AT,
    ACTIONS(4787), 1,
      anon_sym_static,
    ACTIONS(4789), 1,
      anon_sym_readonly,
    ACTIONS(4793), 1,
      anon_sym_declare,
    ACTIONS(4795), 1,
      anon_sym_abstract,
    ACTIONS(4809), 1,
      anon_sym_RBRACE,
    STATE(2593), 1,
      sym_method_definition,
    STATE(2619), 1,
      sym_accessibility_modifier,
    STATE(2652), 1,
      sym_override_modifier,
    STATE(3899), 1,
      sym_method_signature,
    ACTIONS(4783), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4791), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1769), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2860), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3907), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [25408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3491), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3481), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3483), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1636), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1638), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25561] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4777), 1,
      anon_sym_STAR,
    ACTIONS(4781), 1,
      anon_sym_async,
    ACTIONS(4785), 1,
      anon_sym_AT,
    ACTIONS(4787), 1,
      anon_sym_static,
    ACTIONS(4789), 1,
      anon_sym_readonly,
    ACTIONS(4793), 1,
      anon_sym_declare,
    ACTIONS(4795), 1,
      anon_sym_abstract,
    ACTIONS(4811), 1,
      anon_sym_RBRACE,
    STATE(2593), 1,
      sym_method_definition,
    STATE(2619), 1,
      sym_accessibility_modifier,
    STATE(2652), 1,
      sym_override_modifier,
    STATE(3899), 1,
      sym_method_signature,
    ACTIONS(4783), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4791), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1803), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2860), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3907), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [25656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3473), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3475), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1524), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1526), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3469), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3471), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [25809] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4777), 1,
      anon_sym_STAR,
    ACTIONS(4781), 1,
      anon_sym_async,
    ACTIONS(4785), 1,
      anon_sym_AT,
    ACTIONS(4787), 1,
      anon_sym_static,
    ACTIONS(4789), 1,
      anon_sym_readonly,
    ACTIONS(4793), 1,
      anon_sym_declare,
    ACTIONS(4795), 1,
      anon_sym_abstract,
    ACTIONS(4813), 1,
      anon_sym_RBRACE,
    STATE(2593), 1,
      sym_method_definition,
    STATE(2619), 1,
      sym_accessibility_modifier,
    STATE(2652), 1,
      sym_override_modifier,
    STATE(3899), 1,
      sym_method_signature,
    ACTIONS(4783), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4791), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1803), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2860), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3907), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [25904] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4777), 1,
      anon_sym_STAR,
    ACTIONS(4781), 1,
      anon_sym_async,
    ACTIONS(4785), 1,
      anon_sym_AT,
    ACTIONS(4787), 1,
      anon_sym_static,
    ACTIONS(4789), 1,
      anon_sym_readonly,
    ACTIONS(4793), 1,
      anon_sym_declare,
    ACTIONS(4795), 1,
      anon_sym_abstract,
    ACTIONS(4815), 1,
      anon_sym_RBRACE,
    STATE(2593), 1,
      sym_method_definition,
    STATE(2619), 1,
      sym_accessibility_modifier,
    STATE(2652), 1,
      sym_override_modifier,
    STATE(3899), 1,
      sym_method_signature,
    ACTIONS(4783), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4791), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1803), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2860), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3907), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [25999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3461), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3463), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3457), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3459), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3449), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3451), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3441), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3443), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2990), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2992), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1722), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1694), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1698), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1684), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1688), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3533), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3535), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3519), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2882), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2884), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1646), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1650), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3501), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3503), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1448), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1394), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1398), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3433), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3435), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3529), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3531), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [26866] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4817), 1,
      sym_identifier,
    ACTIONS(4819), 1,
      anon_sym_STAR,
    ACTIONS(4821), 1,
      anon_sym_LBRACE,
    ACTIONS(4823), 1,
      anon_sym_from,
    ACTIONS(4825), 1,
      anon_sym_DOT,
    STATE(3004), 1,
      sym_import_path_segment,
    STATE(3079), 1,
      sym_import_path,
    ACTIONS(3521), 15,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(3523), 21,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [26931] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4827), 1,
      sym_identifier,
    ACTIONS(4829), 1,
      anon_sym_STAR,
    ACTIONS(4831), 1,
      anon_sym_LBRACE,
    ACTIONS(4833), 1,
      anon_sym_from,
    ACTIONS(4835), 1,
      anon_sym_DOT,
    STATE(592), 1,
      sym_import_path_segment,
    STATE(641), 1,
      sym_import_path,
    ACTIONS(3521), 15,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(3523), 21,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [26996] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4777), 1,
      anon_sym_STAR,
    ACTIONS(4781), 1,
      anon_sym_async,
    ACTIONS(4785), 1,
      anon_sym_AT,
    ACTIONS(4787), 1,
      anon_sym_static,
    ACTIONS(4789), 1,
      anon_sym_readonly,
    ACTIONS(4793), 1,
      anon_sym_declare,
    ACTIONS(4795), 1,
      anon_sym_abstract,
    ACTIONS(4837), 1,
      anon_sym_RBRACE,
    STATE(2593), 1,
      sym_method_definition,
    STATE(2619), 1,
      sym_accessibility_modifier,
    STATE(2652), 1,
      sym_override_modifier,
    STATE(3899), 1,
      sym_method_signature,
    ACTIONS(4783), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4791), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1768), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2860), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3907), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27091] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4777), 1,
      anon_sym_STAR,
    ACTIONS(4781), 1,
      anon_sym_async,
    ACTIONS(4785), 1,
      anon_sym_AT,
    ACTIONS(4787), 1,
      anon_sym_static,
    ACTIONS(4789), 1,
      anon_sym_readonly,
    ACTIONS(4793), 1,
      anon_sym_declare,
    ACTIONS(4795), 1,
      anon_sym_abstract,
    ACTIONS(4839), 1,
      anon_sym_RBRACE,
    STATE(2593), 1,
      sym_method_definition,
    STATE(2619), 1,
      sym_accessibility_modifier,
    STATE(2652), 1,
      sym_override_modifier,
    STATE(3899), 1,
      sym_method_signature,
    ACTIONS(4783), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4791), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1791), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2860), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3907), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27186] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4777), 1,
      anon_sym_STAR,
    ACTIONS(4781), 1,
      anon_sym_async,
    ACTIONS(4785), 1,
      anon_sym_AT,
    ACTIONS(4787), 1,
      anon_sym_static,
    ACTIONS(4789), 1,
      anon_sym_readonly,
    ACTIONS(4793), 1,
      anon_sym_declare,
    ACTIONS(4795), 1,
      anon_sym_abstract,
    ACTIONS(4841), 1,
      anon_sym_RBRACE,
    STATE(2593), 1,
      sym_method_definition,
    STATE(2619), 1,
      sym_accessibility_modifier,
    STATE(2652), 1,
      sym_override_modifier,
    STATE(3899), 1,
      sym_method_signature,
    ACTIONS(4783), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4791), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1803), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2860), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3907), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3513), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3515), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27332] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3525), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3527), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3539), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3553), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3557), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3559), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3545), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3547), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3403), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3405), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3407), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3409), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3411), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3413), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3415), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1678), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1680), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27842] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_STAR,
    ACTIONS(4849), 1,
      anon_sym_RBRACE,
    ACTIONS(4851), 1,
      anon_sym_LBRACK,
    ACTIONS(4854), 1,
      anon_sym_async,
    ACTIONS(4857), 1,
      anon_sym_DASH,
    ACTIONS(4860), 1,
      anon_sym_DQUOTE,
    ACTIONS(4863), 1,
      anon_sym_SQUOTE,
    ACTIONS(4869), 1,
      anon_sym_AT,
    ACTIONS(4872), 1,
      anon_sym_static,
    ACTIONS(4875), 1,
      anon_sym_readonly,
    ACTIONS(4881), 1,
      anon_sym_declare,
    ACTIONS(4887), 1,
      anon_sym_override,
    ACTIONS(4890), 1,
      anon_sym_abstract,
    STATE(2593), 1,
      sym_method_definition,
    STATE(2619), 1,
      sym_accessibility_modifier,
    STATE(2652), 1,
      sym_override_modifier,
    STATE(3899), 1,
      sym_method_signature,
    ACTIONS(4866), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4878), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4884), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1803), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2860), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3907), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4843), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [27937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1708), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1712), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [27988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1728), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1732), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3549), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3551), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2792), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2794), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3399), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2784), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2786), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2780), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2782), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3509), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3511), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1454), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1458), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3505), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3507), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1606), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1610), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1560), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1384), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1388), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1464), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1468), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3485), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3487), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3477), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3479), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1546), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1566), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1570), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1576), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1580), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1586), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1590), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [28957] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4143), 1,
      anon_sym_DASH,
    ACTIONS(4342), 1,
      anon_sym_LBRACK,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4777), 1,
      anon_sym_STAR,
    ACTIONS(4781), 1,
      anon_sym_async,
    ACTIONS(4785), 1,
      anon_sym_AT,
    ACTIONS(4787), 1,
      anon_sym_static,
    ACTIONS(4789), 1,
      anon_sym_readonly,
    ACTIONS(4793), 1,
      anon_sym_declare,
    ACTIONS(4795), 1,
      anon_sym_abstract,
    ACTIONS(4893), 1,
      anon_sym_RBRACE,
    STATE(2593), 1,
      sym_method_definition,
    STATE(2619), 1,
      sym_accessibility_modifier,
    STATE(2652), 1,
      sym_override_modifier,
    STATE(3899), 1,
      sym_method_signature,
    ACTIONS(4783), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4791), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(1747), 3,
      sym_decorator,
      sym_class_static_block,
      aux_sym_class_body_repeat1,
    STATE(2860), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3907), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4336), 10,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1484), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1488), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [29103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1404), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1408), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [29154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1738), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1742), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [29205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3417), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3419), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [29256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3429), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3431), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [29307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1540), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1542), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [29358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3439), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [29409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3453), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3455), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [29460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1672), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [29511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1702), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1704), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [29562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3423), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [29613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1628), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1632), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [29664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1622), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [29715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1516), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1520), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [29766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1506), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1510), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [29817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1478), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [29868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3425), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3427), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [29919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1434), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1438), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [29970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1424), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1428), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [30021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1414), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1418), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [30072] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4895), 1,
      anon_sym_STAR,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4900), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(4909), 1,
      anon_sym_async,
    ACTIONS(4913), 1,
      anon_sym_readonly,
    STATE(2650), 1,
      sym_override_modifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4911), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4915), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2883), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4336), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30154] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 1,
      anon_sym_EQ,
    ACTIONS(4921), 1,
      anon_sym_LBRACK,
    ACTIONS(4917), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4924), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3333), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3383), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3385), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [30214] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4895), 1,
      anon_sym_STAR,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(4909), 1,
      anon_sym_async,
    ACTIONS(4913), 1,
      anon_sym_readonly,
    ACTIONS(4927), 1,
      anon_sym_RBRACE,
    STATE(2650), 1,
      sym_override_modifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4911), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4915), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2883), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4336), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30296] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4771), 1,
      anon_sym_LT,
    ACTIONS(4773), 1,
      anon_sym_DOT,
    STATE(1893), 1,
      sym_type_arguments,
    ACTIONS(2588), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2590), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [30352] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4932), 1,
      anon_sym_RBRACK,
    ACTIONS(1374), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4930), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1368), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [30408] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2804), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2806), 21,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [30472] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2848), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2850), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [30542] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4945), 1,
      anon_sym_RBRACK,
    ACTIONS(3387), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4943), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3383), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3385), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [30598] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(2762), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2764), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [30660] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_EQ,
    ACTIONS(3873), 1,
      anon_sym_QMARK,
    ACTIONS(3871), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [30716] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(2710), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2712), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [30772] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4948), 1,
      anon_sym_DOT,
    STATE(1998), 1,
      sym_arguments,
    ACTIONS(2860), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2862), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [30828] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4895), 1,
      anon_sym_STAR,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(4909), 1,
      anon_sym_async,
    ACTIONS(4913), 1,
      anon_sym_readonly,
    ACTIONS(4950), 1,
      anon_sym_RBRACE,
    STATE(2650), 1,
      sym_override_modifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4911), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4915), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2883), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4336), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30910] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4953), 1,
      anon_sym_DOT,
    STATE(1995), 1,
      sym_arguments,
    ACTIONS(2842), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2844), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [30966] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4955), 1,
      anon_sym_DOT,
    STATE(1997), 1,
      sym_arguments,
    ACTIONS(2828), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2830), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [31022] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4895), 1,
      anon_sym_STAR,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(4909), 1,
      anon_sym_async,
    ACTIONS(4913), 1,
      anon_sym_readonly,
    ACTIONS(4957), 1,
      anon_sym_RBRACE,
    STATE(2650), 1,
      sym_override_modifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4911), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4915), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2883), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4336), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31104] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(4964), 1,
      anon_sym_COMMA,
    ACTIONS(4968), 1,
      anon_sym_LT,
    ACTIONS(4970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4974), 1,
      anon_sym_GT_GT,
    ACTIONS(4978), 1,
      anon_sym_AMP,
    ACTIONS(4980), 1,
      anon_sym_CARET,
    ACTIONS(4982), 1,
      anon_sym_PIPE,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4998), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3877), 1,
      aux_sym_extends_clause_repeat1,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4962), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(4966), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4976), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4992), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4990), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [31214] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4771), 1,
      anon_sym_LT,
    STATE(1904), 1,
      sym_type_arguments,
    ACTIONS(2834), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2836), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [31268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1250), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1248), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_is,
  [31318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1702), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1704), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [31368] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3280), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5000), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3276), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3278), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [31422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1636), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1638), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [31472] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5000), 1,
      anon_sym_RBRACK,
    ACTIONS(3280), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4743), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3276), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3278), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [31528] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4945), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3383), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3385), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [31582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5003), 1,
      sym__automatic_semicolon,
    ACTIONS(1366), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1370), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [31634] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3710), 1,
      anon_sym_EQ,
    ACTIONS(3784), 1,
      anon_sym_RBRACK,
    ACTIONS(3787), 1,
      anon_sym_QMARK,
    ACTIONS(3782), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [31692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1540), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1542), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [31742] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4932), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1368), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [31796] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5005), 1,
      sym__automatic_semicolon,
    ACTIONS(1524), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1526), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [31848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1642), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [31898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1678), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1680), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [31948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1524), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1526), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [31998] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3710), 1,
      anon_sym_EQ,
    ACTIONS(5007), 1,
      anon_sym_LBRACK,
    ACTIONS(5010), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3266), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1848), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [32056] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5013), 1,
      anon_sym_is,
    ACTIONS(2834), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2836), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [32108] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4775), 1,
      anon_sym_is,
    ACTIONS(2982), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2984), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [32160] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 1,
      anon_sym_EQ,
    ACTIONS(5019), 1,
      anon_sym_LBRACK,
    ACTIONS(5015), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5022), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3088), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1368), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [32220] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_BANG,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_GT_GT,
    ACTIONS(5033), 1,
      anon_sym_AMP,
    ACTIONS(5035), 1,
      anon_sym_CARET,
    ACTIONS(5037), 1,
      anon_sym_PIPE,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5031), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5039), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5047), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5049), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5027), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5045), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [32309] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5029), 1,
      anon_sym_GT_GT,
    ACTIONS(5033), 1,
      anon_sym_AMP,
    ACTIONS(5035), 1,
      anon_sym_CARET,
    ACTIONS(5037), 1,
      anon_sym_PIPE,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5051), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5053), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5055), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5057), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5031), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5039), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5047), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5049), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5027), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5045), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2794), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [32410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3246), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [32459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3319), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [32508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3319), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [32557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3319), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [32606] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5059), 1,
      anon_sym_AMP,
    ACTIONS(5061), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_extends,
    ACTIONS(3357), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3359), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [32661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3094), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3096), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [32710] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2892), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [32811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3094), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3096), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [32860] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5010), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5007), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3266), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1848), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [32915] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5099), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [33016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3361), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3363), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3094), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3096), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33114] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5103), 1,
      anon_sym_COMMA,
    ACTIONS(5106), 1,
      anon_sym_RBRACE,
    ACTIONS(5110), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5112), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5138), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(3072), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [33219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3236), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3238), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3098), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3100), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3391), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3256), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3258), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3232), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3234), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33464] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5059), 1,
      anon_sym_AMP,
    ACTIONS(3106), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3108), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33515] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3725), 1,
      anon_sym_COLON,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    ACTIONS(5144), 1,
      anon_sym_RPAREN,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    STATE(4783), 1,
      sym_type_annotation,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [33622] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    STATE(3681), 1,
      sym_optional_chain,
    ACTIONS(3286), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3288), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [33679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3309), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3311), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2812), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2814), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33777] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3088), 1,
      anon_sym_extends,
    ACTIONS(5019), 1,
      anon_sym_LBRACK,
    ACTIONS(5178), 1,
      anon_sym_RPAREN,
    ACTIONS(1374), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4930), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(5022), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1368), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [33838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3214), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3216), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3208), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3208), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [33985] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4895), 1,
      anon_sym_STAR,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4927), 1,
      anon_sym_RBRACE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(5183), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5185), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3435), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [34058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3102), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3104), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [34107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3190), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3192), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [34156] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5190), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5187), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(2984), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1848), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [34211] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5106), 1,
      anon_sym_RBRACE,
    ACTIONS(5110), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5112), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5138), 1,
      sym__ternary_qmark,
    ACTIONS(5193), 1,
      anon_sym_COMMA,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(3032), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [34316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3190), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3192), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [34365] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4895), 1,
      anon_sym_STAR,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4909), 1,
      anon_sym_async,
    ACTIONS(4927), 1,
      anon_sym_RBRACE,
    ACTIONS(5196), 1,
      anon_sym_LBRACK,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4911), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4915), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2883), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4336), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [34440] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3725), 1,
      anon_sym_COLON,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    ACTIONS(5198), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    STATE(4609), 1,
      sym_type_annotation,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [34547] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3333), 1,
      anon_sym_extends,
    ACTIONS(4921), 1,
      anon_sym_LBRACK,
    ACTIONS(5200), 1,
      anon_sym_RPAREN,
    ACTIONS(3387), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4924), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4943), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3383), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3385), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [34608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3333), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [34657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3190), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3192), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [34706] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5059), 1,
      anon_sym_AMP,
    ACTIONS(5061), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_extends,
    ACTIONS(3137), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3139), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [34761] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2984), 1,
      anon_sym_extends,
    ACTIONS(5187), 1,
      anon_sym_LBRACK,
    ACTIONS(5205), 1,
      anon_sym_RPAREN,
    ACTIONS(5190), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5203), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(5208), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(1848), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [34822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3139), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [34871] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5110), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5112), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5138), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2892), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [34972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3321), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3323), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3174), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3176), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35070] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2698), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [35135] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2698), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [35210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3174), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3176), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3174), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3176), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35308] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3032), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [35409] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5210), 1,
      anon_sym_LBRACK,
    ACTIONS(3313), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3315), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3148), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3150), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35509] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5059), 1,
      anon_sym_AMP,
    ACTIONS(5061), 1,
      anon_sym_PIPE,
    ACTIONS(3131), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3133), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35562] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5029), 1,
      anon_sym_GT_GT,
    ACTIONS(5033), 1,
      anon_sym_AMP,
    ACTIONS(5035), 1,
      anon_sym_CARET,
    ACTIONS(5037), 1,
      anon_sym_PIPE,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5051), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5053), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5055), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5057), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5031), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5039), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5047), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5049), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5027), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5045), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3032), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [35663] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2972), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [35764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3343), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3345), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [35813] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5029), 1,
      anon_sym_GT_GT,
    ACTIONS(5033), 1,
      anon_sym_AMP,
    ACTIONS(5035), 1,
      anon_sym_CARET,
    ACTIONS(5037), 1,
      anon_sym_PIPE,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5051), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5053), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5055), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5057), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5031), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5039), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5047), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5049), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5027), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5045), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2972), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [35914] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5029), 1,
      anon_sym_GT_GT,
    ACTIONS(5033), 1,
      anon_sym_AMP,
    ACTIONS(5035), 1,
      anon_sym_CARET,
    ACTIONS(5037), 1,
      anon_sym_PIPE,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5051), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5053), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5055), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5057), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5031), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5039), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5047), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5049), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5027), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5045), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2790), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [36015] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 1,
      anon_sym_EQ,
    ACTIONS(3086), 1,
      anon_sym_QMARK,
    ACTIONS(3088), 1,
      anon_sym_extends,
    ACTIONS(4930), 1,
      anon_sym_COLON,
    ACTIONS(5019), 1,
      anon_sym_LBRACK,
    ACTIONS(5015), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5022), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1368), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [36078] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_QMARK,
    ACTIONS(3333), 1,
      anon_sym_extends,
    ACTIONS(3387), 1,
      anon_sym_EQ,
    ACTIONS(4921), 1,
      anon_sym_LBRACK,
    ACTIONS(4943), 1,
      anon_sym_COLON,
    ACTIONS(4917), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4924), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3383), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3385), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [36141] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5029), 1,
      anon_sym_GT_GT,
    ACTIONS(5033), 1,
      anon_sym_AMP,
    ACTIONS(5035), 1,
      anon_sym_CARET,
    ACTIONS(5037), 1,
      anon_sym_PIPE,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5051), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5053), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5055), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5057), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5031), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5039), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5047), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5049), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5027), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5045), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3072), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [36242] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5215), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5212), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3100), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3561), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3563), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [36297] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5110), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5112), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5138), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2822), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [36398] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5218), 1,
      anon_sym_DOT,
    ACTIONS(3325), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3327), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [36449] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5029), 1,
      anon_sym_GT_GT,
    ACTIONS(5033), 1,
      anon_sym_AMP,
    ACTIONS(5035), 1,
      anon_sym_CARET,
    ACTIONS(5037), 1,
      anon_sym_PIPE,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5051), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5053), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5055), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5057), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5031), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5039), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5047), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5049), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5027), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5045), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2992), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [36550] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4895), 1,
      anon_sym_STAR,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4950), 1,
      anon_sym_RBRACE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(5183), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5185), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3435), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [36623] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2790), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [36724] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4895), 1,
      anon_sym_STAR,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4909), 1,
      anon_sym_async,
    ACTIONS(4950), 1,
      anon_sym_RBRACE,
    ACTIONS(5196), 1,
      anon_sym_LBRACK,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4911), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4915), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2883), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4336), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [36799] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 1,
      anon_sym_EQ,
    ACTIONS(1368), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [36850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5220), 1,
      sym_regex_flags,
    ACTIONS(3351), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(3353), 24,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [36901] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5222), 1,
      anon_sym_STAR,
    ACTIONS(5224), 1,
      anon_sym_LBRACE,
    ACTIONS(5226), 1,
      anon_sym_async,
    ACTIONS(5230), 1,
      anon_sym_readonly,
    STATE(2642), 1,
      sym_statement_block,
    STATE(2659), 1,
      sym_override_modifier,
    ACTIONS(5228), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5232), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2864), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4336), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [36976] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4895), 1,
      anon_sym_STAR,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4909), 1,
      anon_sym_async,
    ACTIONS(4957), 1,
      anon_sym_RBRACE,
    ACTIONS(5196), 1,
      anon_sym_LBRACK,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4911), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4915), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2883), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4336), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [37051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3210), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3212), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [37100] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2698), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [37165] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_GT_GT,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5031), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5039), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2698), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [37240] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4895), 1,
      anon_sym_STAR,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4957), 1,
      anon_sym_RBRACE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(5183), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5185), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3435), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [37313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3086), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3088), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [37362] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_EQ,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [37413] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5234), 1,
      anon_sym_LPAREN,
    STATE(2125), 1,
      sym_arguments,
    ACTIONS(3141), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3143), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [37466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3178), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3180), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [37515] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4730), 1,
      anon_sym_DOT,
    ACTIONS(3112), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3114), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [37566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3284), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [37615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2834), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2836), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [37664] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5210), 1,
      anon_sym_LBRACK,
    ACTIONS(3226), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3228), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [37715] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_BANG,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_GT_GT,
    ACTIONS(5033), 1,
      anon_sym_AMP,
    ACTIONS(5035), 1,
      anon_sym_CARET,
    ACTIONS(5037), 1,
      anon_sym_PIPE,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5051), 1,
      anon_sym_AMP_AMP,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5031), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5039), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5047), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5049), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5027), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5045), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [37806] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5039), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2698), 9,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [37877] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_GT_GT,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5031), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5039), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5047), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5049), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2698), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5027), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5045), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [37960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2982), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2984), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [38009] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3072), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [38110] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2992), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [38211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3264), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3266), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [38260] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2822), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [38361] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 1,
      anon_sym_EQ,
    ACTIONS(2898), 1,
      sym__automatic_semicolon,
    ACTIONS(1370), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1368), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [38416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3208), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [38465] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_GT_GT,
    ACTIONS(5033), 1,
      anon_sym_AMP,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(2698), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5031), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5039), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5047), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5049), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5027), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5045), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [38550] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_BANG,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [38639] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_BANG,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [38730] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5029), 1,
      anon_sym_GT_GT,
    ACTIONS(5033), 1,
      anon_sym_AMP,
    ACTIONS(5035), 1,
      anon_sym_CARET,
    ACTIONS(5037), 1,
      anon_sym_PIPE,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5051), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5053), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5055), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5057), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5031), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5039), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5047), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5049), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5027), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5045), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2892), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [38831] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2698), 9,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [38902] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2698), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [38985] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(2698), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [39070] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(4968), 1,
      anon_sym_LT,
    ACTIONS(4970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4974), 1,
      anon_sym_GT_GT,
    ACTIONS(4978), 1,
      anon_sym_AMP,
    ACTIONS(4980), 1,
      anon_sym_CARET,
    ACTIONS(4982), 1,
      anon_sym_PIPE,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4998), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    STATE(4013), 1,
      sym_type_arguments,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4966), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4976), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4992), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4990), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5237), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [39175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3252), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3254), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [39224] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(2698), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [39311] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2698), 11,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [39380] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2698), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 17,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [39451] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2698), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [39530] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_BANG,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [39623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3280), 1,
      anon_sym_EQ,
    ACTIONS(3276), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3278), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [39674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3298), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3300), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [39723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3127), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3129), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [39772] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2884), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [39873] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2888), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [39974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3166), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3168), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [40023] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3725), 1,
      anon_sym_COLON,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    ACTIONS(5239), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    STATE(4601), 1,
      sym_type_annotation,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [40130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3162), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3164), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [40179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3170), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3172), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [40228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3272), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3274), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [40277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3198), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3200), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [40326] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3710), 1,
      anon_sym_EQ,
    ACTIONS(3787), 1,
      anon_sym_QMARK,
    ACTIONS(5007), 1,
      anon_sym_LBRACK,
    ACTIONS(3266), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3782), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(5010), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1848), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [40387] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2984), 1,
      anon_sym_extends,
    ACTIONS(5187), 1,
      anon_sym_LBRACK,
    ACTIONS(5243), 1,
      anon_sym_RPAREN,
    ACTIONS(5190), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5241), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(5246), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(1848), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [40448] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_GT_GT,
    ACTIONS(5033), 1,
      anon_sym_AMP,
    ACTIONS(5035), 1,
      anon_sym_CARET,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(2698), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5031), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5039), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5047), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5049), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5027), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5045), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [40535] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5110), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5112), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5138), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3032), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [40636] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5110), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5112), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5138), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2782), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [40737] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4895), 1,
      anon_sym_STAR,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4900), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4909), 1,
      anon_sym_async,
    ACTIONS(5196), 1,
      anon_sym_LBRACK,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4911), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4915), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2883), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4336), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [40812] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5110), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5112), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5138), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2786), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [40913] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5110), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5112), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5138), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2972), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [41014] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5059), 1,
      anon_sym_AMP,
    ACTIONS(5061), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_extends,
    ACTIONS(3379), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3381), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [41069] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5059), 1,
      anon_sym_AMP,
    ACTIONS(5061), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_extends,
    ACTIONS(3367), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3369), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [41124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3218), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3220), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [41173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2852), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2854), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [41222] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2698), 11,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [41291] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5110), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5112), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5138), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2794), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [41392] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5110), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5112), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5138), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2790), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [41493] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4895), 1,
      anon_sym_STAR,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4900), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(5183), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5185), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3435), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [41566] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    STATE(2291), 1,
      sym_arguments,
    ACTIONS(3371), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3373), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [41619] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5110), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5112), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5138), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3072), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [41720] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5110), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5112), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5138), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2992), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [41821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3182), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3184), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [41870] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3725), 1,
      anon_sym_COLON,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    ACTIONS(5248), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    STATE(4716), 1,
      sym_type_annotation,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3186), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3188), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [42026] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3725), 1,
      anon_sym_COLON,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    ACTIONS(5250), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    STATE(4602), 1,
      sym_type_annotation,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3202), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3204), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [42182] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3228), 1,
      anon_sym_extends,
    ACTIONS(5210), 1,
      anon_sym_LBRACK,
    ACTIONS(3226), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3347), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3349), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [42237] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2698), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [42302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3246), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [42351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3246), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [42400] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5059), 1,
      anon_sym_AMP,
    ACTIONS(5061), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_extends,
    ACTIONS(3393), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3395), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [42455] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2698), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [42530] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2698), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [42601] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_BANG,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [42690] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_BANG,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(5110), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [42781] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2698), 9,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [42852] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2698), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [42935] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2984), 1,
      anon_sym_extends,
    ACTIONS(5187), 1,
      anon_sym_LBRACK,
    ACTIONS(5255), 1,
      anon_sym_RPAREN,
    ACTIONS(5190), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5246), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5252), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1848), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [42996] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3787), 1,
      anon_sym_QMARK,
    ACTIONS(3812), 1,
      anon_sym_EQ,
    ACTIONS(5007), 1,
      anon_sym_LBRACK,
    ACTIONS(3266), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3784), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(5010), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1848), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [43057] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(2698), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [43142] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(2698), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [43229] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2698), 11,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [43298] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5259), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [43401] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2698), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [43472] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2698), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [43551] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_BANG,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(5110), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5112), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [43644] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5059), 1,
      anon_sym_AMP,
    ACTIONS(5061), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_extends,
    ACTIONS(3222), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3224), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [43699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3222), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3224), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [43748] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5059), 1,
      anon_sym_AMP,
    ACTIONS(5061), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_extends,
    ACTIONS(3260), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3262), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [43803] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5110), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5112), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5138), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2884), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [43904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3123), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3125), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [43953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2740), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [44002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3290), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3292), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [44051] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5110), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5112), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5138), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2888), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [44152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3248), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3250), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [44201] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_GT_GT,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5031), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5039), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5027), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5045), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2698), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [44280] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5059), 1,
      anon_sym_AMP,
    ACTIONS(3375), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3377), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [44331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3152), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3154), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [44380] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_BANG,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_GT_GT,
    ACTIONS(5033), 1,
      anon_sym_AMP,
    ACTIONS(5035), 1,
      anon_sym_CARET,
    ACTIONS(5037), 1,
      anon_sym_PIPE,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5051), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5053), 1,
      anon_sym_PIPE_PIPE,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5031), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5039), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5047), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5049), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5027), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5045), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [44473] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2794), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [44574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3196), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [44623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3268), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3270), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [44672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3294), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3296), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [44721] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5110), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5112), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5138), 1,
      sym__ternary_qmark,
    ACTIONS(5261), 1,
      anon_sym_COMMA,
    ACTIONS(5264), 1,
      anon_sym_RBRACE,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(3072), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44826] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5266), 1,
      anon_sym_LPAREN,
    STATE(2155), 1,
      sym_arguments,
    ACTIONS(3302), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3304), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [44879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3290), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3292), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [44928] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5029), 1,
      anon_sym_GT_GT,
    ACTIONS(5033), 1,
      anon_sym_AMP,
    ACTIONS(5035), 1,
      anon_sym_CARET,
    ACTIONS(5037), 1,
      anon_sym_PIPE,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5051), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5053), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5055), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5057), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5031), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5039), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5047), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5049), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5027), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5045), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2888), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [45029] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5029), 1,
      anon_sym_GT_GT,
    ACTIONS(5033), 1,
      anon_sym_AMP,
    ACTIONS(5035), 1,
      anon_sym_CARET,
    ACTIONS(5037), 1,
      anon_sym_PIPE,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5051), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5053), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5055), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5057), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5031), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5039), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5047), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5049), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5027), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5045), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2884), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [45130] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2782), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [45231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3152), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3154), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [45280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3240), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3242), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [45329] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2786), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [45430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3294), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3296), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [45479] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3088), 1,
      anon_sym_extends,
    ACTIONS(5015), 1,
      anon_sym_RPAREN,
    ACTIONS(5019), 1,
      anon_sym_LBRACK,
    ACTIONS(1374), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4932), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(5022), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1368), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [45540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3335), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3337), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [45589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3119), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3121), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [45638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2796), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2798), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [45687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3339), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3341), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [45736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 1,
      anon_sym_EQ,
    ACTIONS(3383), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3385), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [45787] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5029), 1,
      anon_sym_GT_GT,
    ACTIONS(5033), 1,
      anon_sym_AMP,
    ACTIONS(5035), 1,
      anon_sym_CARET,
    ACTIONS(5037), 1,
      anon_sym_PIPE,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5051), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5053), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5055), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5057), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5031), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5039), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5047), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5049), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5027), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5045), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2822), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [45888] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3333), 1,
      anon_sym_extends,
    ACTIONS(4917), 1,
      anon_sym_RPAREN,
    ACTIONS(4921), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4924), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4945), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3383), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3385), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [45949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3335), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3337), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [45998] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5029), 1,
      anon_sym_GT_GT,
    ACTIONS(5033), 1,
      anon_sym_AMP,
    ACTIONS(5035), 1,
      anon_sym_CARET,
    ACTIONS(5037), 1,
      anon_sym_PIPE,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5051), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5053), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5055), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5057), 1,
      sym__ternary_qmark,
    ACTIONS(5271), 1,
      anon_sym_in,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5031), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5039), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5047), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5049), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5045), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5269), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [46101] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3391), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1848), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [46154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3339), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3341), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [46203] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5029), 1,
      anon_sym_GT_GT,
    ACTIONS(5033), 1,
      anon_sym_AMP,
    ACTIONS(5035), 1,
      anon_sym_CARET,
    ACTIONS(5037), 1,
      anon_sym_PIPE,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5051), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5053), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5055), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5057), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5031), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5039), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5047), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5049), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5027), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5045), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2782), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [46304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3196), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [46353] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5029), 1,
      anon_sym_GT_GT,
    ACTIONS(5033), 1,
      anon_sym_AMP,
    ACTIONS(5035), 1,
      anon_sym_CARET,
    ACTIONS(5037), 1,
      anon_sym_PIPE,
    ACTIONS(5041), 1,
      anon_sym_PERCENT,
    ACTIONS(5043), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5051), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5053), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5055), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5057), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5031), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5039), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5047), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5049), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5027), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5045), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2786), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [46454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3156), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3158), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_extends,
  [46503] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 1,
      anon_sym_EQ,
    ACTIONS(5003), 1,
      sym__automatic_semicolon,
    ACTIONS(1366), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1370), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [46556] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5276), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5274), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [46608] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2698), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 16,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [46678] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3264), 1,
      anon_sym_QMARK,
    ACTIONS(3710), 1,
      anon_sym_EQ,
    ACTIONS(5007), 1,
      anon_sym_LBRACK,
    ACTIONS(5010), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3266), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(1848), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [46736] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_BANG,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4974), 1,
      anon_sym_GT_GT,
    ACTIONS(4978), 1,
      anon_sym_AMP,
    ACTIONS(4980), 1,
      anon_sym_CARET,
    ACTIONS(4982), 1,
      anon_sym_PIPE,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4976), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4992), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4966), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4990), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [46828] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5280), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5278), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [46880] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5282), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    STATE(4085), 1,
      aux_sym_array_repeat1,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46984] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5284), 1,
      anon_sym_LPAREN,
    ACTIONS(5287), 1,
      anon_sym_COLON,
    ACTIONS(5289), 1,
      anon_sym_LT,
    ACTIONS(5292), 1,
      anon_sym_QMARK,
    ACTIONS(3481), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3483), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [47040] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5294), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3947), 1,
      aux_sym_array_repeat1,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47144] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2790), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3286), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3288), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [47292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3529), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3531), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [47340] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4974), 1,
      anon_sym_GT_GT,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4976), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4966), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4990), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2698), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [47418] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4093), 1,
      anon_sym_EQ,
    ACTIONS(4107), 1,
      anon_sym_in,
    ACTIONS(4110), 1,
      anon_sym_of,
    ACTIONS(1848), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [47472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4093), 1,
      anon_sym_EQ,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [47522] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2884), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47622] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5241), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [47674] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5296), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3978), 1,
      aux_sym_array_repeat1,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47778] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_BANG,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [47870] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2698), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [47948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3453), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3455), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [47996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3439), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [48044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [48092] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5298), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [48192] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 1,
      anon_sym_EQ,
    ACTIONS(4930), 1,
      anon_sym_COLON,
    ACTIONS(5019), 1,
      anon_sym_LBRACK,
    ACTIONS(5022), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3088), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(1368), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [48250] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5300), 1,
      anon_sym_RBRACK,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    STATE(4038), 1,
      aux_sym_array_repeat1,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48354] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2892), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48454] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 1,
      anon_sym_EQ,
    ACTIONS(4921), 1,
      anon_sym_LBRACK,
    ACTIONS(4943), 1,
      anon_sym_COLON,
    ACTIONS(4924), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3333), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3383), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3385), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [48512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1414), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1418), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [48560] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5302), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    STATE(4028), 1,
      aux_sym_array_repeat1,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48664] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2794), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48764] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5304), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    STATE(4136), 1,
      aux_sym_array_repeat1,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3429), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3431), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [48916] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2972), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49016] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3032), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49116] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5308), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5306), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [49168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3413), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3415), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [49216] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3417), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3419), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [49264] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(4970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4974), 1,
      anon_sym_GT_GT,
    ACTIONS(4978), 1,
      anon_sym_AMP,
    ACTIONS(4980), 1,
      anon_sym_CARET,
    ACTIONS(4982), 1,
      anon_sym_PIPE,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4998), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4976), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4992), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3032), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4966), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4990), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3409), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3411), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [49412] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(4970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4974), 1,
      anon_sym_GT_GT,
    ACTIONS(4978), 1,
      anon_sym_AMP,
    ACTIONS(4980), 1,
      anon_sym_CARET,
    ACTIONS(4982), 1,
      anon_sym_PIPE,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4998), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4976), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4992), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2972), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4966), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4990), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3405), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3407), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [49560] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(4970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4974), 1,
      anon_sym_GT_GT,
    ACTIONS(4978), 1,
      anon_sym_AMP,
    ACTIONS(4980), 1,
      anon_sym_CARET,
    ACTIONS(4982), 1,
      anon_sym_PIPE,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4998), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4976), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4992), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2790), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4966), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4990), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [49660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1394), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1398), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [49708] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4927), 1,
      anon_sym_RBRACE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(5183), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3435), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [49776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1448), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [49824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3501), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3503), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [49872] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_extends,
    ACTIONS(5215), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5212), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(3561), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3563), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [49926] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5310), 1,
      anon_sym_RBRACK,
    STATE(1752), 1,
      sym_arguments,
    STATE(3918), 1,
      aux_sym_array_repeat1,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3401), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3403), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1646), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1650), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50126] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_EQ,
    ACTIONS(3266), 1,
      anon_sym_extends,
    ACTIONS(3871), 1,
      anon_sym_COLON,
    ACTIONS(5007), 1,
      anon_sym_LBRACK,
    ACTIONS(5010), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5312), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1848), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50186] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2698), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [50260] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3787), 1,
      anon_sym_QMARK,
    ACTIONS(3812), 1,
      anon_sym_EQ,
    ACTIONS(3784), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50314] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5246), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5252), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50366] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3391), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1848), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50418] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3098), 1,
      anon_sym_QMARK,
    ACTIONS(3100), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5215), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5212), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3561), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3563), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50474] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2786), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50574] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5316), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [50674] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 1,
      sym__automatic_semicolon,
    ACTIONS(1486), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1484), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1488), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50726] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1410), 1,
      sym__automatic_semicolon,
    ACTIONS(1406), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1404), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1408), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50778] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1744), 1,
      sym__automatic_semicolon,
    ACTIONS(1740), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1738), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1742), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50830] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5208), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5203), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3545), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3547), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2882), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2884), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [50978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3519), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3533), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3535), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3557), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3559), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3543), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51170] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1420), 1,
      sym__automatic_semicolon,
    ACTIONS(1416), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1414), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1418), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51222] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5276), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5274), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51274] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1430), 1,
      sym__automatic_semicolon,
    ACTIONS(1426), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1424), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1428), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5276), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5274), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51378] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1440), 1,
      sym__automatic_semicolon,
    ACTIONS(1436), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1434), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1438), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51430] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1480), 1,
      sym__automatic_semicolon,
    ACTIONS(1476), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1474), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1478), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51482] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(4970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4974), 1,
      anon_sym_GT_GT,
    ACTIONS(4978), 1,
      anon_sym_AMP,
    ACTIONS(4980), 1,
      anon_sym_CARET,
    ACTIONS(4982), 1,
      anon_sym_PIPE,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4998), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4976), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4992), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3072), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4966), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4990), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51582] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2698), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 16,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [51652] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1512), 1,
      sym__automatic_semicolon,
    ACTIONS(1508), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1506), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1510), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51704] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1522), 1,
      sym__automatic_semicolon,
    ACTIONS(1518), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1516), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1520), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51756] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym_EQ,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3513), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3515), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51854] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(4970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4974), 1,
      anon_sym_GT_GT,
    ACTIONS(4978), 1,
      anon_sym_AMP,
    ACTIONS(4980), 1,
      anon_sym_CARET,
    ACTIONS(4982), 1,
      anon_sym_PIPE,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4998), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4976), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4992), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2992), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4966), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4990), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51954] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      sym__automatic_semicolon,
    ACTIONS(1620), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1618), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1622), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3525), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3527), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52054] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2698), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [52118] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4974), 1,
      anon_sym_GT_GT,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4976), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2698), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [52192] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_BANG,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4974), 1,
      anon_sym_GT_GT,
    ACTIONS(4978), 1,
      anon_sym_AMP,
    ACTIONS(4980), 1,
      anon_sym_CARET,
    ACTIONS(4982), 1,
      anon_sym_PIPE,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4976), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4992), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4966), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4990), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [52280] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_BANG,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4974), 1,
      anon_sym_GT_GT,
    ACTIONS(4978), 1,
      anon_sym_AMP,
    ACTIONS(4980), 1,
      anon_sym_CARET,
    ACTIONS(4982), 1,
      anon_sym_PIPE,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4976), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4992), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4966), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4990), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [52370] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1634), 1,
      sym__automatic_semicolon,
    ACTIONS(1630), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1628), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1632), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52422] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1674), 1,
      sym__automatic_semicolon,
    ACTIONS(1670), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1668), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1672), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3539), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52522] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5320), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5318), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3553), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52622] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5110), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5112), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5138), 1,
      sym__ternary_qmark,
    ACTIONS(5322), 1,
      anon_sym_COMMA,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5324), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1484), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1488), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52772] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      anon_sym_extends,
    ACTIONS(5010), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5007), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(1848), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3561), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3563), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52874] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_EQ,
    ACTIONS(3871), 1,
      anon_sym_COLON,
    ACTIONS(5007), 1,
      anon_sym_LBRACK,
    ACTIONS(5010), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3266), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(1848), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [52932] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5110), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5112), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5138), 1,
      sym__ternary_qmark,
    ACTIONS(5322), 1,
      anon_sym_COMMA,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5326), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1658), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1662), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53082] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5328), 1,
      anon_sym_RBRACK,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    STATE(4038), 1,
      aux_sym_array_repeat1,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53186] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2698), 9,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [53256] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1592), 1,
      sym__automatic_semicolon,
    ACTIONS(1588), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1586), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1590), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53308] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4974), 1,
      anon_sym_GT_GT,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4976), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4992), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2698), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4966), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4990), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [53390] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1582), 1,
      sym__automatic_semicolon,
    ACTIONS(1578), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1576), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1580), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53442] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1572), 1,
      sym__automatic_semicolon,
    ACTIONS(1568), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1566), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1570), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3433), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3435), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53542] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 1,
      sym__automatic_semicolon,
    ACTIONS(1548), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1546), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53594] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2888), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53694] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1470), 1,
      sym__automatic_semicolon,
    ACTIONS(1466), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1464), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1468), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1684), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1688), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [53794] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4974), 1,
      anon_sym_GT_GT,
    ACTIONS(4978), 1,
      anon_sym_AMP,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(2698), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4976), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4992), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4966), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4990), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [53878] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4974), 1,
      anon_sym_GT_GT,
    ACTIONS(4978), 1,
      anon_sym_AMP,
    ACTIONS(4980), 1,
      anon_sym_CARET,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(2698), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4976), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4992), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4966), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4990), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [53964] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2698), 11,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [54032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1464), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1468), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54080] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1390), 1,
      sym__automatic_semicolon,
    ACTIONS(1386), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1384), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1388), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54132] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2782), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54232] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      sym__automatic_semicolon,
    ACTIONS(1608), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1606), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1610), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54284] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(4970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4974), 1,
      anon_sym_GT_GT,
    ACTIONS(4978), 1,
      anon_sym_AMP,
    ACTIONS(4980), 1,
      anon_sym_CARET,
    ACTIONS(4982), 1,
      anon_sym_PIPE,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4998), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4976), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4992), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2884), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4966), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4990), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54384] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(4970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4974), 1,
      anon_sym_GT_GT,
    ACTIONS(4978), 1,
      anon_sym_AMP,
    ACTIONS(4980), 1,
      anon_sym_CARET,
    ACTIONS(4982), 1,
      anon_sym_PIPE,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4998), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4976), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4992), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2888), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4966), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4990), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1694), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1698), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1722), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54580] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1460), 1,
      sym__automatic_semicolon,
    ACTIONS(1456), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1454), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1458), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54632] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5110), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5112), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5138), 1,
      sym__ternary_qmark,
    ACTIONS(5322), 1,
      anon_sym_COMMA,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5330), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54734] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3280), 1,
      anon_sym_EQ,
    ACTIONS(4743), 1,
      anon_sym_of,
    ACTIONS(5332), 1,
      anon_sym_in,
    ACTIONS(3276), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3278), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54788] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(4970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4974), 1,
      anon_sym_GT_GT,
    ACTIONS(4978), 1,
      anon_sym_AMP,
    ACTIONS(4980), 1,
      anon_sym_CARET,
    ACTIONS(4982), 1,
      anon_sym_PIPE,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4998), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4976), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4992), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2794), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4966), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4990), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54888] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5335), 1,
      anon_sym_LPAREN,
    ACTIONS(5338), 1,
      anon_sym_COLON,
    ACTIONS(5340), 1,
      anon_sym_LT,
    ACTIONS(5343), 1,
      anon_sym_QMARK,
    ACTIONS(1848), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [54944] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5345), 1,
      anon_sym_RBRACK,
    STATE(1752), 1,
      sym_arguments,
    STATE(3974), 1,
      aux_sym_array_repeat1,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55048] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(4970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4974), 1,
      anon_sym_GT_GT,
    ACTIONS(4978), 1,
      anon_sym_AMP,
    ACTIONS(4980), 1,
      anon_sym_CARET,
    ACTIONS(4982), 1,
      anon_sym_PIPE,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4998), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4976), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4992), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2786), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4966), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4990), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55148] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(4970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4974), 1,
      anon_sym_GT_GT,
    ACTIONS(4978), 1,
      anon_sym_AMP,
    ACTIONS(4980), 1,
      anon_sym_CARET,
    ACTIONS(4982), 1,
      anon_sym_PIPE,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4998), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4976), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4992), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2782), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4966), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4990), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55248] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(4970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4974), 1,
      anon_sym_GT_GT,
    ACTIONS(4978), 1,
      anon_sym_AMP,
    ACTIONS(4980), 1,
      anon_sym_CARET,
    ACTIONS(4982), 1,
      anon_sym_PIPE,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4998), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4976), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4992), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2822), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4966), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4990), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1708), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1712), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55396] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3333), 1,
      anon_sym_extends,
    ACTIONS(3387), 1,
      anon_sym_EQ,
    ACTIONS(4921), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4924), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3383), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3385), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [55452] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 1,
      anon_sym_EQ,
    ACTIONS(3088), 1,
      anon_sym_extends,
    ACTIONS(5019), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5022), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1368), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [55508] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1734), 1,
      sym__automatic_semicolon,
    ACTIONS(1730), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1728), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1732), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1728), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1732), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2990), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2992), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3549), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3551), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55704] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1714), 1,
      sym__automatic_semicolon,
    ACTIONS(1710), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1708), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1712), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3445), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3447), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3441), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3443), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55852] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5347), 1,
      sym_regex_flags,
    ACTIONS(3351), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(3353), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [55902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3465), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3467), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3495), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [55998] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5351), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5349), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3497), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3499), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56098] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5351), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5349), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1424), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1428), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56198] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5351), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5349), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1434), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1438), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56298] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5269), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
  [56398] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5355), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5353), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56450] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1400), 1,
      sym__automatic_semicolon,
    ACTIONS(1396), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1394), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1398), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56502] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1450), 1,
      sym__automatic_semicolon,
    ACTIONS(1446), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1444), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1448), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3425), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3427), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56602] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5357), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    STATE(4049), 1,
      aux_sym_array_repeat1,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56706] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1652), 1,
      sym__automatic_semicolon,
    ACTIONS(1648), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1646), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1650), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56758] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1690), 1,
      sym__automatic_semicolon,
    ACTIONS(1686), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1684), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1688), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56810] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1700), 1,
      sym__automatic_semicolon,
    ACTIONS(1696), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1694), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1698), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56862] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1724), 1,
      sym__automatic_semicolon,
    ACTIONS(1720), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1718), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1722), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3449), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3451), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [56962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3457), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3459), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [57010] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      anon_sym_extends,
    ACTIONS(4101), 1,
      anon_sym_EQ,
    ACTIONS(5007), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5010), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1848), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [57066] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1538), 1,
      sym__automatic_semicolon,
    ACTIONS(1534), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1532), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1536), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [57118] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_BANG,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [57206] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5110), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5112), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5138), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5269), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [57306] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4895), 1,
      anon_sym_STAR,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(4909), 1,
      anon_sym_async,
    ACTIONS(4913), 1,
      anon_sym_readonly,
    STATE(2650), 1,
      sym_override_modifier,
    ACTIONS(4911), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4915), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5359), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2883), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4336), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [57380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1596), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1600), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [57428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3461), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3463), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [57476] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4957), 1,
      anon_sym_RBRACE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(5183), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3435), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [57544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3469), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3471), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [57592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3473), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3475), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [57640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1506), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1510), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [57688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1532), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1536), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [57736] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5363), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    STATE(4075), 1,
      aux_sym_array_repeat1,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57840] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5365), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    STATE(4107), 1,
      aux_sym_array_repeat1,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1516), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1520), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [57992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3481), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3483), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [58040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2792), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2794), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [58088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1622), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [58136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1404), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1408), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [58184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3399), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [58232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3491), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [58280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1478), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [58328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1628), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1632), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [58376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3423), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [58424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1738), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1742), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [58472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2784), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2786), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [58520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1672), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [58568] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_BANG,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [58658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2970), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2972), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [58706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2780), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2782), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [58754] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2698), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [58818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3509), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3511), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [58866] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4900), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(5183), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3435), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [58934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3523), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [58982] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5369), 1,
      anon_sym_static,
    ACTIONS(5371), 1,
      anon_sym_readonly,
    ACTIONS(5373), 1,
      anon_sym_abstract,
    STATE(2640), 1,
      sym_accessibility_modifier,
    STATE(2680), 1,
      sym_override_modifier,
    ACTIONS(5367), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4354), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3108), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4336), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [59054] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2698), 9,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [59124] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4950), 1,
      anon_sym_RBRACE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(5183), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3435), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [59192] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1602), 1,
      sym__automatic_semicolon,
    ACTIONS(1598), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1596), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1600), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [59244] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3264), 1,
      anon_sym_QMARK,
    ACTIONS(3266), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5010), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5007), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1848), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [59300] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4937), 1,
      anon_sym_as,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(4941), 1,
      anon_sym_satisfies,
    ACTIONS(5110), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5112), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5114), 1,
      anon_sym_GT_GT,
    ACTIONS(5118), 1,
      anon_sym_AMP,
    ACTIONS(5120), 1,
      anon_sym_CARET,
    ACTIONS(5122), 1,
      anon_sym_PIPE,
    ACTIONS(5126), 1,
      anon_sym_PERCENT,
    ACTIONS(5128), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5138), 1,
      sym__ternary_qmark,
    ACTIONS(5322), 1,
      anon_sym_COMMA,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4935), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5101), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5116), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5124), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5132), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5134), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5259), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5108), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5130), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1454), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1458), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [59450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3505), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3507), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [59498] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      sym__automatic_semicolon,
    ACTIONS(1660), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1658), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1662), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [59550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1606), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1610), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [59598] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2698), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [59680] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 1,
      anon_sym_EQ,
    ACTIONS(4930), 1,
      anon_sym_of,
    ACTIONS(5375), 1,
      anon_sym_in,
    ACTIONS(1368), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [59734] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 1,
      anon_sym_EQ,
    ACTIONS(4943), 1,
      anon_sym_of,
    ACTIONS(5378), 1,
      anon_sym_in,
    ACTIONS(3383), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3385), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [59788] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(2698), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [59874] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2992), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59974] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(2698), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [60058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3485), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3487), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [60106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1560), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [60154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1384), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1388), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [60202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3477), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3479), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [60250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1576), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1580), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [60298] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2822), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60398] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5381), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    STATE(4103), 1,
      aux_sym_array_repeat1,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60502] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2698), 11,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [60570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1546), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [60618] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3072), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60718] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(4970), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4972), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4974), 1,
      anon_sym_GT_GT,
    ACTIONS(4978), 1,
      anon_sym_AMP,
    ACTIONS(4980), 1,
      anon_sym_CARET,
    ACTIONS(4982), 1,
      anon_sym_PIPE,
    ACTIONS(4986), 1,
      anon_sym_PERCENT,
    ACTIONS(4988), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4996), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4998), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4960), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4976), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4984), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4992), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4994), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2892), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4966), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(4990), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1566), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1570), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [60866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5347), 1,
      sym_regex_flags,
    ACTIONS(3351), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(3353), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [60916] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1562), 1,
      sym__automatic_semicolon,
    ACTIONS(1558), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1556), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1560), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [60968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1586), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1590), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [61016] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    ACTIONS(5383), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61117] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    ACTIONS(5385), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61218] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4101), 1,
      anon_sym_EQ,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [61267] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    ACTIONS(5387), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61368] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3100), 1,
      anon_sym_extends,
    ACTIONS(5212), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5215), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3561), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3563), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [61421] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    ACTIONS(5389), 1,
      anon_sym_RBRACK,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61522] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(2172), 1,
      anon_sym_readonly,
    ACTIONS(2176), 1,
      anon_sym_override,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    ACTIONS(5393), 1,
      anon_sym_RBRACE,
    STATE(2649), 1,
      sym_override_modifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4053), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [61601] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    ACTIONS(5395), 1,
      anon_sym_RBRACK,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61702] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5397), 1,
      anon_sym_STAR,
    ACTIONS(5399), 1,
      anon_sym_async,
    ACTIONS(5403), 1,
      anon_sym_readonly,
    STATE(2658), 1,
      sym_override_modifier,
    ACTIONS(5401), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5405), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2879), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4336), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [61771] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(2172), 1,
      anon_sym_readonly,
    ACTIONS(2176), 1,
      anon_sym_override,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    ACTIONS(5407), 1,
      anon_sym_RBRACE,
    STATE(2649), 1,
      sym_override_modifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [61850] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    ACTIONS(5259), 1,
      anon_sym_COLON,
    ACTIONS(5409), 1,
      anon_sym_COMMA,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61951] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    ACTIONS(5411), 1,
      anon_sym_RBRACK,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62052] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_EQ,
    ACTIONS(4118), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [62103] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2984), 1,
      anon_sym_extends,
    ACTIONS(5187), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5190), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1848), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [62156] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(2172), 1,
      anon_sym_readonly,
    ACTIONS(2176), 1,
      anon_sym_override,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    ACTIONS(5413), 1,
      anon_sym_RBRACE,
    STATE(2649), 1,
      sym_override_modifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [62235] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3280), 1,
      anon_sym_EQ,
    ACTIONS(4743), 1,
      anon_sym_COLON,
    ACTIONS(5000), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3276), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3278), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [62288] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5415), 1,
      anon_sym_STAR,
    ACTIONS(5417), 1,
      anon_sym_async,
    ACTIONS(5423), 1,
      anon_sym_abstract,
    ACTIONS(5419), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5421), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2842), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4336), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [62353] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5415), 1,
      anon_sym_STAR,
    ACTIONS(5417), 1,
      anon_sym_async,
    ACTIONS(5425), 1,
      anon_sym_readonly,
    STATE(2648), 1,
      sym_override_modifier,
    ACTIONS(5419), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5421), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2842), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4336), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [62422] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    ACTIONS(5427), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62523] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2982), 1,
      anon_sym_QMARK,
    ACTIONS(2984), 1,
      anon_sym_extends,
    ACTIONS(5190), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5187), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1848), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [62578] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3710), 1,
      anon_sym_EQ,
    ACTIONS(3784), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [62629] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5429), 1,
      anon_sym_STAR,
    ACTIONS(5431), 1,
      anon_sym_async,
    ACTIONS(5435), 1,
      anon_sym_readonly,
    STATE(2647), 1,
      sym_override_modifier,
    ACTIONS(5433), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5437), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2905), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4336), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [62698] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      anon_sym_extends,
    ACTIONS(5007), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5010), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1848), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [62751] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    ACTIONS(5409), 1,
      anon_sym_COMMA,
    ACTIONS(5439), 1,
      anon_sym_COLON,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62852] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3280), 1,
      anon_sym_EQ,
    ACTIONS(3276), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3278), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [62901] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5441), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63000] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    ACTIONS(5443), 1,
      anon_sym_RBRACK,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63101] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    ACTIONS(5445), 1,
      anon_sym_RBRACE,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63202] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5264), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63301] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4558), 1,
      anon_sym_LBRACK,
    ACTIONS(5449), 1,
      anon_sym_COMMA,
    ACTIONS(5451), 1,
      anon_sym_RBRACE,
    STATE(4062), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(5453), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4068), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4624), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(5447), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [63370] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4013), 1,
      anon_sym_EQ,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [63419] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(1926), 1,
      anon_sym_RBRACE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(2172), 1,
      anon_sym_readonly,
    ACTIONS(2176), 1,
      anon_sym_override,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    STATE(2649), 1,
      sym_override_modifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [63498] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(2172), 1,
      anon_sym_readonly,
    ACTIONS(2176), 1,
      anon_sym_override,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    ACTIONS(5455), 1,
      anon_sym_RBRACE,
    STATE(2649), 1,
      sym_override_modifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [63577] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5106), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63676] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4558), 1,
      anon_sym_LBRACK,
    ACTIONS(5449), 1,
      anon_sym_COMMA,
    ACTIONS(5459), 1,
      anon_sym_RBRACE,
    STATE(4001), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(5453), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4014), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4624), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(5457), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [63745] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    ACTIONS(5461), 1,
      anon_sym_RBRACK,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63846] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(1930), 1,
      anon_sym_RBRACE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(2172), 1,
      anon_sym_readonly,
    ACTIONS(2176), 1,
      anon_sym_override,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    STATE(2649), 1,
      sym_override_modifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3990), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [63925] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    ACTIONS(5463), 1,
      anon_sym_RBRACE,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64026] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5220), 1,
      sym_regex_flags,
    ACTIONS(3351), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(3353), 21,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [64075] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    ACTIONS(5465), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64176] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    ACTIONS(5467), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64277] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
    ACTIONS(3391), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(1848), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [64328] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    ACTIONS(5469), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64429] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    ACTIONS(5471), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64530] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 1,
      anon_sym_EQ,
    ACTIONS(3088), 1,
      anon_sym_extends,
    ACTIONS(5019), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(5022), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1368), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [64585] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_EQ,
    ACTIONS(3266), 1,
      anon_sym_extends,
    ACTIONS(5007), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(5010), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1848), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [64640] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3333), 1,
      anon_sym_extends,
    ACTIONS(3387), 1,
      anon_sym_EQ,
    ACTIONS(4921), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4924), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3383), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3385), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [64695] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(1879), 1,
      anon_sym_RBRACE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(2172), 1,
      anon_sym_readonly,
    ACTIONS(2176), 1,
      anon_sym_override,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    STATE(2649), 1,
      sym_override_modifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4053), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [64774] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    ACTIONS(5473), 1,
      anon_sym_RBRACK,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64875] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5475), 1,
      anon_sym_STAR,
    ACTIONS(5477), 1,
      anon_sym_async,
    ACTIONS(5481), 1,
      anon_sym_readonly,
    STATE(2653), 1,
      sym_override_modifier,
    ACTIONS(5479), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5483), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2885), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4336), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [64944] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(2172), 1,
      anon_sym_readonly,
    ACTIONS(2176), 1,
      anon_sym_override,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    ACTIONS(5485), 1,
      anon_sym_RBRACE,
    STATE(2649), 1,
      sym_override_modifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [65023] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4895), 1,
      anon_sym_STAR,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4909), 1,
      anon_sym_async,
    ACTIONS(5196), 1,
      anon_sym_LBRACK,
    ACTIONS(4911), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4915), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5359), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2883), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4336), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [65090] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4895), 1,
      anon_sym_STAR,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5183), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5185), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5359), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3435), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [65155] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(5196), 1,
      anon_sym_LBRACK,
    ACTIONS(5222), 1,
      anon_sym_STAR,
    ACTIONS(5226), 1,
      anon_sym_async,
    ACTIONS(5487), 1,
      anon_sym_abstract,
    ACTIONS(5228), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5232), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2864), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4336), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [65220] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5142), 1,
      anon_sym_COMMA,
    ACTIONS(5489), 1,
      anon_sym_RPAREN,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65321] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3391), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(1848), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [65372] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(1928), 1,
      anon_sym_RBRACE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(2172), 1,
      anon_sym_readonly,
    ACTIONS(2176), 1,
      anon_sym_override,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    STATE(2649), 1,
      sym_override_modifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [65451] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(1930), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3990), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [65521] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1428), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5491), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5494), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [65569] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2892), 1,
      anon_sym_of,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5501), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_GT_GT,
    ACTIONS(5509), 1,
      anon_sym_AMP,
    ACTIONS(5511), 1,
      anon_sym_CARET,
    ACTIONS(5513), 1,
      anon_sym_PIPE,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5527), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5529), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5507), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5523), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5525), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5499), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5521), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65667] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(1879), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4053), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [65737] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5505), 1,
      anon_sym_GT_GT,
    ACTIONS(5509), 1,
      anon_sym_AMP,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(2698), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5507), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5523), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5525), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5499), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5521), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [65819] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5505), 1,
      anon_sym_GT_GT,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5507), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5523), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5525), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(2698), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5499), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5521), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [65899] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2786), 1,
      anon_sym_of,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5501), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_GT_GT,
    ACTIONS(5509), 1,
      anon_sym_AMP,
    ACTIONS(5511), 1,
      anon_sym_CARET,
    ACTIONS(5513), 1,
      anon_sym_PIPE,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5527), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5529), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5507), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5523), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5525), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5499), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5521), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65997] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2782), 1,
      anon_sym_of,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5501), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_GT_GT,
    ACTIONS(5509), 1,
      anon_sym_AMP,
    ACTIONS(5511), 1,
      anon_sym_CARET,
    ACTIONS(5513), 1,
      anon_sym_PIPE,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5527), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5529), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5507), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5523), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5525), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5499), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5521), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66095] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5531), 1,
      anon_sym_STAR,
    ACTIONS(5533), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5535), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3346), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [66155] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5531), 1,
      anon_sym_STAR,
    ACTIONS(5537), 1,
      anon_sym_async,
    ACTIONS(5539), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5541), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4336), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [66217] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5505), 1,
      anon_sym_GT_GT,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5507), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2698), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [66289] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(1879), 1,
      anon_sym_RBRACE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4053), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [66361] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5543), 1,
      anon_sym_RBRACK,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66459] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    ACTIONS(5485), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [66531] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2698), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [66593] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5222), 1,
      anon_sym_STAR,
    ACTIONS(5545), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5547), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [66653] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3696), 1,
      anon_sym_LPAREN,
    STATE(2877), 1,
      sym_arguments,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [66703] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5549), 1,
      anon_sym_STAR,
    ACTIONS(5551), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5553), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3399), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [66763] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2822), 1,
      anon_sym_of,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5501), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_GT_GT,
    ACTIONS(5509), 1,
      anon_sym_AMP,
    ACTIONS(5511), 1,
      anon_sym_CARET,
    ACTIONS(5513), 1,
      anon_sym_PIPE,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5527), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5529), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5507), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5523), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5525), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5499), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5521), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66861] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    ACTIONS(5555), 1,
      anon_sym_COLON,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66959] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2992), 1,
      anon_sym_of,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5501), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_GT_GT,
    ACTIONS(5509), 1,
      anon_sym_AMP,
    ACTIONS(5511), 1,
      anon_sym_CARET,
    ACTIONS(5513), 1,
      anon_sym_PIPE,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5527), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5529), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5507), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5523), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5525), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5499), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5521), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67057] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5557), 1,
      anon_sym_STAR,
    ACTIONS(5559), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5561), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3427), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [67117] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3072), 1,
      anon_sym_of,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5501), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_GT_GT,
    ACTIONS(5509), 1,
      anon_sym_AMP,
    ACTIONS(5511), 1,
      anon_sym_CARET,
    ACTIONS(5513), 1,
      anon_sym_PIPE,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5527), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5529), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5507), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5523), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5525), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5499), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5521), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67215] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    ACTIONS(5563), 1,
      anon_sym_COLON,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67313] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5565), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5568), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [67361] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    ACTIONS(5393), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4053), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [67433] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2790), 1,
      anon_sym_of,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5501), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_GT_GT,
    ACTIONS(5509), 1,
      anon_sym_AMP,
    ACTIONS(5511), 1,
      anon_sym_CARET,
    ACTIONS(5513), 1,
      anon_sym_PIPE,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5527), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5529), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5507), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5523), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5525), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5499), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5521), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67531] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2972), 1,
      anon_sym_of,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5501), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_GT_GT,
    ACTIONS(5509), 1,
      anon_sym_AMP,
    ACTIONS(5511), 1,
      anon_sym_CARET,
    ACTIONS(5513), 1,
      anon_sym_PIPE,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5527), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5529), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5507), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5523), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5525), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5499), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5521), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67629] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5397), 1,
      anon_sym_STAR,
    ACTIONS(5571), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5573), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3457), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [67689] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2984), 1,
      anon_sym_extends,
    ACTIONS(5187), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(5190), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1848), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [67741] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3032), 1,
      anon_sym_of,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5501), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_GT_GT,
    ACTIONS(5509), 1,
      anon_sym_AMP,
    ACTIONS(5511), 1,
      anon_sym_CARET,
    ACTIONS(5513), 1,
      anon_sym_PIPE,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5527), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5529), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5507), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5523), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5525), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5499), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5521), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67839] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(5196), 1,
      anon_sym_LBRACK,
    ACTIONS(5429), 1,
      anon_sym_STAR,
    ACTIONS(5431), 1,
      anon_sym_async,
    ACTIONS(5433), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5437), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2905), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4336), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [67901] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5397), 1,
      anon_sym_STAR,
    ACTIONS(5399), 1,
      anon_sym_async,
    ACTIONS(5401), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5405), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2879), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4336), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [67963] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5505), 1,
      anon_sym_GT_GT,
    ACTIONS(5509), 1,
      anon_sym_AMP,
    ACTIONS(5511), 1,
      anon_sym_CARET,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(2698), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5507), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5523), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5525), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5499), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5521), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [68047] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5212), 1,
      anon_sym_LBRACK,
    ACTIONS(5215), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3100), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3561), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3563), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [68099] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(1928), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68169] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5415), 1,
      anon_sym_STAR,
    ACTIONS(5575), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5577), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3334), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68229] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(4558), 1,
      anon_sym_LBRACK,
    ACTIONS(5453), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5581), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4444), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4624), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4739), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(5579), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68293] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    ACTIONS(5583), 1,
      anon_sym_COLON,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68391] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2698), 11,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [68457] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(1928), 1,
      anon_sym_RBRACE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68529] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5183), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5359), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3435), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68589] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5475), 1,
      anon_sym_STAR,
    ACTIONS(5585), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5587), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3368), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68649] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3280), 1,
      anon_sym_EQ,
    ACTIONS(4743), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3276), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3278), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [68699] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5475), 1,
      anon_sym_STAR,
    ACTIONS(5477), 1,
      anon_sym_async,
    ACTIONS(5479), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5483), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2885), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4336), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [68761] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 1,
      anon_sym_EQ,
    ACTIONS(4943), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3383), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3385), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [68811] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5589), 1,
      anon_sym_RBRACK,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68909] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5007), 1,
      anon_sym_LBRACK,
    ACTIONS(5010), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3266), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(1848), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [68961] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5591), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5594), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [69009] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5557), 1,
      anon_sym_STAR,
    ACTIONS(5597), 1,
      anon_sym_async,
    ACTIONS(5599), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5601), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2840), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4336), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69071] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1448), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5603), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5606), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [69119] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5609), 1,
      anon_sym_STAR,
    ACTIONS(5611), 1,
      anon_sym_async,
    ACTIONS(5613), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5615), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2906), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4336), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69181] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2698), 9,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [69249] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1398), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5617), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5620), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [69297] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    ACTIONS(5623), 1,
      anon_sym_COLON,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69395] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5609), 1,
      anon_sym_STAR,
    ACTIONS(5625), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5627), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3409), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69455] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5629), 1,
      anon_sym_STAR,
    ACTIONS(5631), 1,
      anon_sym_async,
    ACTIONS(5633), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5635), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2822), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4336), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69517] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_BANG,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5505), 1,
      anon_sym_GT_GT,
    ACTIONS(5509), 1,
      anon_sym_AMP,
    ACTIONS(5511), 1,
      anon_sym_CARET,
    ACTIONS(5513), 1,
      anon_sym_PIPE,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5507), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5523), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5525), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5499), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5521), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [69603] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(1930), 1,
      anon_sym_RBRACE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3990), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69675] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    ACTIONS(5485), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69745] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5637), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5640), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [69793] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4927), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1846), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1844), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69851] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4950), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1842), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1840), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69909] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    ACTIONS(5393), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4053), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [69979] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4927), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1842), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1840), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70037] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    ACTIONS(5455), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70109] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_BANG,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5501), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5505), 1,
      anon_sym_GT_GT,
    ACTIONS(5509), 1,
      anon_sym_AMP,
    ACTIONS(5511), 1,
      anon_sym_CARET,
    ACTIONS(5513), 1,
      anon_sym_PIPE,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5507), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5523), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5525), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5499), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5521), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [70197] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    ACTIONS(5643), 1,
      anon_sym_COLON,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70295] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    ACTIONS(5455), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70365] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(1926), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70435] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4900), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1842), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1840), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70493] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(1926), 1,
      anon_sym_RBRACE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70565] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    ACTIONS(5413), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70637] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5645), 1,
      anon_sym_STAR,
    ACTIONS(5647), 1,
      anon_sym_async,
    ACTIONS(5649), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5651), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2909), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4336), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70699] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    ACTIONS(5653), 1,
      anon_sym_COLON,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70797] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4900), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1846), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1844), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70855] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 1,
      anon_sym_EQ,
    ACTIONS(4930), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1368), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [70905] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4950), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1846), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1844), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70963] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    ACTIONS(5655), 1,
      anon_sym_COLON,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71061] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    ACTIONS(5407), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1488), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5657), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5660), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [71181] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5645), 1,
      anon_sym_STAR,
    ACTIONS(5663), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5665), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3447), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71241] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1590), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5667), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5670), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [71289] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1408), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5673), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5676), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [71337] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    ACTIONS(5407), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71407] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5679), 1,
      anon_sym_STAR,
    ACTIONS(5681), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5683), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3356), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71467] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5415), 1,
      anon_sym_STAR,
    ACTIONS(5417), 1,
      anon_sym_async,
    ACTIONS(5419), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5421), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2842), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4336), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71529] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2888), 1,
      anon_sym_of,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5501), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_GT_GT,
    ACTIONS(5509), 1,
      anon_sym_AMP,
    ACTIONS(5511), 1,
      anon_sym_CARET,
    ACTIONS(5513), 1,
      anon_sym_PIPE,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5527), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5529), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5507), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5523), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5525), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5499), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5521), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71627] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5685), 1,
      anon_sym_STAR,
    ACTIONS(5687), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5689), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3441), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71687] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5429), 1,
      anon_sym_STAR,
    ACTIONS(5691), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5693), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3514), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5695), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5698), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [71795] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1842), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1840), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [71843] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5685), 1,
      anon_sym_STAR,
    ACTIONS(5701), 1,
      anon_sym_async,
    ACTIONS(5703), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5705), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2895), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4336), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [71905] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5187), 1,
      anon_sym_LBRACK,
    ACTIONS(5190), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2984), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(1848), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [71957] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1510), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5707), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5710), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [72005] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5713), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5716), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [72053] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5269), 1,
      anon_sym_of,
    ACTIONS(5501), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_GT_GT,
    ACTIONS(5509), 1,
      anon_sym_AMP,
    ACTIONS(5511), 1,
      anon_sym_CARET,
    ACTIONS(5513), 1,
      anon_sym_PIPE,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5527), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5529), 1,
      sym__ternary_qmark,
    ACTIONS(5719), 1,
      anon_sym_in,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5499), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5507), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5523), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5525), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5521), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72153] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(2698), 12,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 14,
      sym__ternary_qmark,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [72221] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5722), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5725), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [72269] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3710), 1,
      anon_sym_EQ,
    ACTIONS(3782), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [72319] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1550), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5728), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5731), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [72367] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5629), 1,
      anon_sym_STAR,
    ACTIONS(5734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5736), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3444), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72427] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3479), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5738), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5741), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [72475] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1478), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5744), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5747), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [72523] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4957), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1846), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1844), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72581] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4957), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1842), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1840), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72639] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5148), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5150), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5152), 1,
      anon_sym_GT_GT,
    ACTIONS(5156), 1,
      anon_sym_AMP,
    ACTIONS(5158), 1,
      anon_sym_CARET,
    ACTIONS(5160), 1,
      anon_sym_PIPE,
    ACTIONS(5164), 1,
      anon_sym_PERCENT,
    ACTIONS(5166), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5174), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5176), 1,
      sym__ternary_qmark,
    ACTIONS(5750), 1,
      anon_sym_COLON,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5140), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5154), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5162), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5172), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5146), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5168), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72737] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    ACTIONS(5413), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72807] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5752), 1,
      anon_sym_STAR,
    ACTIONS(5754), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5756), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3418), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [72867] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2794), 1,
      anon_sym_of,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5501), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_GT_GT,
    ACTIONS(5509), 1,
      anon_sym_AMP,
    ACTIONS(5511), 1,
      anon_sym_CARET,
    ACTIONS(5513), 1,
      anon_sym_PIPE,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5527), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5529), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5507), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5523), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5525), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5499), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5521), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72965] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3427), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5758), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5761), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [73013] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2884), 1,
      anon_sym_of,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5501), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_GT_GT,
    ACTIONS(5509), 1,
      anon_sym_AMP,
    ACTIONS(5511), 1,
      anon_sym_CARET,
    ACTIONS(5513), 1,
      anon_sym_PIPE,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5527), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5529), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5507), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5523), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5525), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5499), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5521), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73111] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2698), 1,
      anon_sym_BANG,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5501), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5505), 1,
      anon_sym_GT_GT,
    ACTIONS(5509), 1,
      anon_sym_AMP,
    ACTIONS(5511), 1,
      anon_sym_CARET,
    ACTIONS(5513), 1,
      anon_sym_PIPE,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5507), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5523), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5525), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5499), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5521), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2700), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [73201] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5764), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5767), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [73249] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(5505), 1,
      anon_sym_GT_GT,
    ACTIONS(5517), 1,
      anon_sym_PERCENT,
    ACTIONS(5519), 1,
      anon_sym_STAR_STAR,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5497), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5507), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5515), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5499), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5521), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(2698), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2700), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [73325] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5407), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [73390] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5663), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3447), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [73445] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5770), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3442), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [73500] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5772), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3492), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [73555] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5774), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3170), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4336), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [73610] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5691), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3514), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [73665] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5571), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3457), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [73720] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_AMP,
    ACTIONS(13), 1,
      anon_sym_AT,
    ACTIONS(15), 1,
      anon_sym_component,
    ACTIONS(1881), 1,
      anon_sym_type,
    ACTIONS(1883), 1,
      anon_sym_import,
    ACTIONS(1885), 1,
      anon_sym_var,
    ACTIONS(1887), 1,
      anon_sym_let,
    ACTIONS(1889), 1,
      anon_sym_const,
    ACTIONS(1902), 1,
      anon_sym_class,
    ACTIONS(1904), 1,
      anon_sym_async,
    ACTIONS(1906), 1,
      anon_sym_function,
    ACTIONS(1912), 1,
      anon_sym_declare,
    ACTIONS(1914), 1,
      anon_sym_namespace,
    ACTIONS(1916), 1,
      anon_sym_module,
    ACTIONS(1918), 1,
      anon_sym_abstract,
    ACTIONS(1920), 1,
      anon_sym_global,
    ACTIONS(1922), 1,
      anon_sym_interface,
    ACTIONS(1924), 1,
      anon_sym_enum,
    STATE(752), 1,
      sym_internal_module,
    STATE(864), 1,
      sym_declaration,
    STATE(1469), 1,
      sym_decorator,
    STATE(3200), 1,
      aux_sym_class_repeat1,
    STATE(3735), 1,
      sym_component_short_heritage,
    STATE(759), 14,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
      sym_component_declaration,
  [73809] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(4801), 1,
      anon_sym_LBRACK,
    ACTIONS(4803), 1,
      anon_sym_DOT,
    ACTIONS(4939), 1,
      anon_sym_BANG,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    STATE(2230), 1,
      sym_arguments,
    STATE(4108), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73904] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_AMP,
    ACTIONS(13), 1,
      anon_sym_AT,
    ACTIONS(15), 1,
      anon_sym_component,
    ACTIONS(1881), 1,
      anon_sym_type,
    ACTIONS(1883), 1,
      anon_sym_import,
    ACTIONS(1885), 1,
      anon_sym_var,
    ACTIONS(1887), 1,
      anon_sym_let,
    ACTIONS(1889), 1,
      anon_sym_const,
    ACTIONS(1902), 1,
      anon_sym_class,
    ACTIONS(1918), 1,
      anon_sym_abstract,
    ACTIONS(1924), 1,
      anon_sym_enum,
    ACTIONS(1942), 1,
      anon_sym_async,
    ACTIONS(1944), 1,
      anon_sym_function,
    ACTIONS(1946), 1,
      anon_sym_declare,
    ACTIONS(1948), 1,
      anon_sym_namespace,
    ACTIONS(1950), 1,
      anon_sym_module,
    ACTIONS(1952), 1,
      anon_sym_global,
    ACTIONS(1954), 1,
      anon_sym_interface,
    STATE(752), 1,
      sym_internal_module,
    STATE(864), 1,
      sym_declaration,
    STATE(1469), 1,
      sym_decorator,
    STATE(3200), 1,
      aux_sym_class_repeat1,
    STATE(3735), 1,
      sym_component_short_heritage,
    STATE(759), 14,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
      sym_component_declaration,
  [73993] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1846), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1844), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74040] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5559), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3427), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74095] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5575), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3334), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74150] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5754), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3418), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74205] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5625), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3409), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74260] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5776), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3099), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4336), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74315] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3280), 1,
      anon_sym_EQ,
    ACTIONS(4743), 1,
      anon_sym_of,
    ACTIONS(5332), 1,
      anon_sym_in,
    ACTIONS(3276), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3278), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [74366] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5413), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74431] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(1926), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4231), 1,
      anon_sym_EQ,
    ACTIONS(1848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [74543] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5455), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74608] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2556), 1,
      anon_sym_LPAREN,
    ACTIONS(2558), 1,
      anon_sym_LBRACK,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2620), 1,
      anon_sym_BANG,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    ACTIONS(5778), 1,
      anon_sym_DOT,
    STATE(1016), 1,
      sym_arguments,
    STATE(4033), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74703] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3444), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5220), 1,
      sym_regex_flags,
    ACTIONS(3351), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(3353), 19,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [74805] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(1930), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3990), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74870] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5681), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3356), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74925] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5533), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3346), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [74980] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3387), 1,
      anon_sym_EQ,
    ACTIONS(4943), 1,
      anon_sym_of,
    ACTIONS(5378), 1,
      anon_sym_in,
    ACTIONS(3383), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3385), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [75031] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5585), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3368), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75086] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(1928), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75151] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_EQ,
    ACTIONS(4107), 1,
      anon_sym_in,
    ACTIONS(4110), 1,
      anon_sym_of,
    ACTIONS(1848), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [75202] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5393), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4053), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75267] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(2172), 1,
      anon_sym_readonly,
    ACTIONS(2176), 1,
      anon_sym_override,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    STATE(2649), 1,
      sym_override_modifier,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5780), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75338] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3441), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75393] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 1,
      anon_sym_EQ,
    ACTIONS(4930), 1,
      anon_sym_of,
    ACTIONS(5375), 1,
      anon_sym_in,
    ACTIONS(1368), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [75444] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_STAR,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(1276), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5787), 1,
      anon_sym_async,
    ACTIONS(5791), 1,
      anon_sym_static,
    ACTIONS(5793), 1,
      anon_sym_readonly,
    ACTIONS(5799), 1,
      anon_sym_override,
    STATE(2635), 1,
      sym_accessibility_modifier,
    STATE(2656), 1,
      sym_override_modifier,
    ACTIONS(5785), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5789), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5795), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5797), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3332), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4384), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(5783), 11,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75521] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5485), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75586] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5551), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3399), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75641] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5545), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75696] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(1879), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4053), 1,
      aux_sym_object_repeat1,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75761] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(4652), 1,
      anon_sym_LBRACK,
    ACTIONS(4654), 1,
      anon_sym_DOT,
    ACTIONS(4706), 1,
      anon_sym_as,
    ACTIONS(4708), 1,
      anon_sym_BANG,
    ACTIONS(4712), 1,
      anon_sym_satisfies,
    ACTIONS(5069), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5071), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5073), 1,
      anon_sym_GT_GT,
    ACTIONS(5077), 1,
      anon_sym_AMP,
    ACTIONS(5079), 1,
      anon_sym_CARET,
    ACTIONS(5081), 1,
      anon_sym_PIPE,
    ACTIONS(5085), 1,
      anon_sym_PERCENT,
    ACTIONS(5087), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5095), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5097), 1,
      sym__ternary_qmark,
    STATE(1752), 1,
      sym_arguments,
    STATE(3980), 1,
      sym_optional_chain,
    ACTIONS(4710), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5065), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5075), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5083), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5091), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5093), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5067), 3,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5089), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75856] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(2172), 1,
      anon_sym_readonly,
    ACTIONS(2176), 1,
      anon_sym_override,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    STATE(2649), 1,
      sym_override_modifier,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5801), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75924] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5803), 1,
      anon_sym_abstract,
    ACTIONS(5776), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3099), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4336), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [75980] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5359), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1842), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1840), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76030] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5423), 1,
      anon_sym_abstract,
    ACTIONS(5774), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3170), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4336), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76086] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5805), 1,
      anon_sym_readonly,
    STATE(2660), 1,
      sym_override_modifier,
    ACTIONS(5774), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3170), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4336), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76146] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5780), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76208] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5359), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1846), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1844), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76258] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5807), 1,
      anon_sym_readonly,
    STATE(2665), 1,
      sym_override_modifier,
    ACTIONS(5776), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3099), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4336), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76318] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5780), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76382] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5413), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1846), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1844), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76437] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5801), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76496] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1930), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3990), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1842), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1840), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76551] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1879), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4053), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1842), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1840), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76606] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5413), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1842), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1840), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76661] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5809), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3095), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4336), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76714] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5393), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4053), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1842), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1840), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76769] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1926), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1846), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1844), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76824] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1930), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3990), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1846), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1844), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76879] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5780), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76936] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5811), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3106), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4336), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76989] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1926), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1842), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1840), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77044] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5455), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1846), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1844), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77099] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5407), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1846), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1844), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77154] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5407), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1842), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1840), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77209] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5393), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4053), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1846), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1844), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77264] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5801), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77325] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1928), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1846), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1844), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77380] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1928), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1842), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1840), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77435] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5485), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1846), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1844), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77490] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5455), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1842), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1840), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77545] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5485), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1842), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1840), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77600] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1879), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4053), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1846), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1844), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77655] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5801), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1640), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_else,
      anon_sym_while,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [77751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1526), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1524), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_else,
      anon_sym_while,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [77793] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(2176), 1,
      anon_sym_override,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5813), 1,
      anon_sym_STAR,
    ACTIONS(5815), 1,
      anon_sym_async,
    ACTIONS(5819), 1,
      anon_sym_readonly,
    STATE(2655), 1,
      sym_override_modifier,
    ACTIONS(5817), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5821), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3382), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 15,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77856] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5823), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_DOT,
    STATE(2628), 1,
      sym_arguments,
    ACTIONS(4282), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(4280), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [77903] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5780), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1842), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1840), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77950] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5780), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1846), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1844), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5829), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5827), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [78037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5833), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5831), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [78077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5837), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5835), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [78117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4290), 10,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(4288), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_DOT,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [78157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5841), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5839), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [78197] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1842), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1840), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5837), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5835), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [78281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5841), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5839), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [78321] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1846), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1844), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5833), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5831), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [78405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5829), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5827), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [78445] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5843), 1,
      anon_sym_STAR,
    ACTIONS(5845), 1,
      anon_sym_async,
    ACTIONS(5847), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5849), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3479), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78501] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5843), 1,
      anon_sym_STAR,
    ACTIONS(5847), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5849), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3479), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78555] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5813), 1,
      anon_sym_STAR,
    ACTIONS(5817), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5821), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3382), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78609] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5813), 1,
      anon_sym_STAR,
    ACTIONS(5815), 1,
      anon_sym_async,
    ACTIONS(5817), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5821), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3382), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5853), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5851), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [78705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5855), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [78745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5861), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5859), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [78785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5865), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5863), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [78825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5869), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5867), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [78865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5873), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5871), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [78905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5855), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [78945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5865), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5863), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [78985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5861), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5859), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [79025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5877), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5875), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [79065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5881), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5879), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [79105] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5887), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5885), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5883), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [79147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5891), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5889), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [79187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5895), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5893), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [79227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5897), 1,
      sym__automatic_semicolon,
    ACTIONS(1370), 10,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1366), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [79269] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5899), 1,
      anon_sym_EQ_GT,
    ACTIONS(5817), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3382), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5891), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5889), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [79361] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5901), 1,
      anon_sym_STAR,
    ACTIONS(5903), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5905), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3350), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79415] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5901), 1,
      anon_sym_STAR,
    ACTIONS(5907), 1,
      anon_sym_async,
    ACTIONS(5903), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5905), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3350), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 17,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79471] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 1,
      sym__automatic_semicolon,
    ACTIONS(1526), 10,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1524), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [79513] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5911), 1,
      anon_sym_STAR,
    ACTIONS(5913), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5915), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3470), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79567] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5903), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3350), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79616] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5917), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3423), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79665] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5551), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3399), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79714] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5913), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3470), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79763] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5919), 1,
      sym__automatic_semicolon,
    ACTIONS(1526), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1524), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [79804] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5575), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3334), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79853] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5734), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3444), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79902] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5585), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3368), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [79951] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5571), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3457), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80000] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5921), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3392), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80049] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5847), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3479), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80098] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5559), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3427), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80147] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5817), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3382), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80196] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5754), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3418), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80245] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5923), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3408), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80294] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3441), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80343] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5222), 1,
      anon_sym_STAR,
    ACTIONS(5226), 1,
      anon_sym_async,
    ACTIONS(5925), 1,
      anon_sym_static,
    ACTIONS(5927), 1,
      anon_sym_readonly,
    ACTIONS(5929), 1,
      anon_sym_abstract,
    STATE(2659), 1,
      sym_override_modifier,
    ACTIONS(5228), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5232), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2864), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4336), 14,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80406] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5681), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3356), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80455] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5931), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3481), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80504] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5533), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3346), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80553] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5625), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3409), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80602] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5663), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3447), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80651] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5933), 1,
      sym__automatic_semicolon,
    ACTIONS(1370), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1366), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [80692] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5935), 1,
      anon_sym_RBRACE,
    STATE(4230), 1,
      sym_enum_assignment,
    ACTIONS(5937), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3779), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80742] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5939), 1,
      anon_sym_RBRACE,
    STATE(4230), 1,
      sym_enum_assignment,
    ACTIONS(5937), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3779), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4300), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(4298), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [80830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3274), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3272), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [80868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1640), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [80906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3127), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [80944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4849), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5941), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [80982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3210), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [81020] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5943), 1,
      anon_sym_RBRACE,
    STATE(4230), 1,
      sym_enum_assignment,
    ACTIONS(5937), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3779), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81070] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(2172), 1,
      anon_sym_readonly,
    ACTIONS(2176), 1,
      anon_sym_override,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    ACTIONS(5945), 1,
      anon_sym_static,
    STATE(2649), 1,
      sym_override_modifier,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 14,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81130] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5429), 1,
      anon_sym_STAR,
    ACTIONS(5431), 1,
      anon_sym_async,
    ACTIONS(5435), 1,
      anon_sym_readonly,
    ACTIONS(5947), 1,
      anon_sym_static,
    STATE(2647), 1,
      sym_override_modifier,
    ACTIONS(5433), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5437), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2905), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4336), 14,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81190] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4895), 1,
      anon_sym_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(4909), 1,
      anon_sym_async,
    ACTIONS(4913), 1,
      anon_sym_readonly,
    ACTIONS(5949), 1,
      anon_sym_static,
    STATE(2650), 1,
      sym_override_modifier,
    ACTIONS(4911), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4915), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2883), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4336), 14,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81250] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5951), 1,
      anon_sym_RBRACE,
    STATE(4035), 1,
      sym_enum_assignment,
    ACTIONS(5953), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3534), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81300] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5955), 1,
      anon_sym_RBRACE,
    STATE(4230), 1,
      sym_enum_assignment,
    ACTIONS(5937), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3779), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81350] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4356), 1,
      anon_sym_override,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5957), 1,
      anon_sym_static,
    ACTIONS(5959), 1,
      anon_sym_readonly,
    ACTIONS(5961), 1,
      anon_sym_abstract,
    STATE(2660), 1,
      sym_override_modifier,
    ACTIONS(5774), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3170), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4336), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4282), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(4280), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [81444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5965), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5963), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [81482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1526), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1524), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [81520] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1846), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1844), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81559] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5805), 1,
      anon_sym_readonly,
    ACTIONS(5967), 1,
      anon_sym_STAR,
    ACTIONS(5969), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5971), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2838), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4336), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81610] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    STATE(4230), 1,
      sym_enum_assignment,
    ACTIONS(5937), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3779), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81657] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5397), 1,
      anon_sym_STAR,
    ACTIONS(5399), 1,
      anon_sym_async,
    ACTIONS(5403), 1,
      anon_sym_readonly,
    ACTIONS(5401), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5405), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2879), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4336), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81710] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5629), 1,
      anon_sym_STAR,
    ACTIONS(5631), 1,
      anon_sym_async,
    ACTIONS(5973), 1,
      anon_sym_readonly,
    ACTIONS(5633), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5635), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2822), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4336), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81763] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5813), 1,
      anon_sym_STAR,
    ACTIONS(5815), 1,
      anon_sym_async,
    ACTIONS(5819), 1,
      anon_sym_readonly,
    ACTIONS(5817), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5821), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3382), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81816] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5475), 1,
      anon_sym_STAR,
    ACTIONS(5477), 1,
      anon_sym_async,
    ACTIONS(5481), 1,
      anon_sym_readonly,
    ACTIONS(5479), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5483), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2885), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4336), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81869] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5975), 1,
      anon_sym_STAR,
    ACTIONS(5979), 1,
      anon_sym_readonly,
    ACTIONS(5977), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5981), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2863), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4336), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81920] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5222), 1,
      anon_sym_STAR,
    ACTIONS(5226), 1,
      anon_sym_async,
    ACTIONS(5230), 1,
      anon_sym_readonly,
    ACTIONS(5228), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5232), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2864), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4336), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [81973] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5609), 1,
      anon_sym_STAR,
    ACTIONS(5611), 1,
      anon_sym_async,
    ACTIONS(5983), 1,
      anon_sym_readonly,
    ACTIONS(5613), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5615), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2906), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4336), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82026] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4895), 1,
      anon_sym_STAR,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(4909), 1,
      anon_sym_async,
    ACTIONS(4913), 1,
      anon_sym_readonly,
    ACTIONS(4911), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4915), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2883), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4336), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82079] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5843), 1,
      anon_sym_STAR,
    ACTIONS(5845), 1,
      anon_sym_async,
    ACTIONS(5985), 1,
      anon_sym_readonly,
    ACTIONS(5847), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5849), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3479), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82132] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(2170), 1,
      anon_sym_async,
    ACTIONS(2172), 1,
      anon_sym_readonly,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5391), 1,
      anon_sym_STAR,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82185] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5429), 1,
      anon_sym_STAR,
    ACTIONS(5431), 1,
      anon_sym_async,
    ACTIONS(5435), 1,
      anon_sym_readonly,
    ACTIONS(5433), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5437), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2905), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4336), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82238] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5531), 1,
      anon_sym_STAR,
    ACTIONS(5537), 1,
      anon_sym_async,
    ACTIONS(5987), 1,
      anon_sym_readonly,
    ACTIONS(5539), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5541), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2884), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4336), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82291] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5415), 1,
      anon_sym_STAR,
    ACTIONS(5417), 1,
      anon_sym_async,
    ACTIONS(5425), 1,
      anon_sym_readonly,
    ACTIONS(5419), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5421), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2842), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4336), 16,
      anon_sym_export,
      anon_sym_type,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82344] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5807), 1,
      anon_sym_readonly,
    ACTIONS(5776), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3099), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4336), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82390] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5663), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3447), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82434] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5734), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3444), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82478] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5551), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3399), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82522] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5989), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4752), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82566] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5991), 1,
      anon_sym_readonly,
    ACTIONS(5809), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3095), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4336), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82612] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5585), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3368), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82656] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5809), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3095), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4336), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82700] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5770), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3442), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82744] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5545), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82788] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5847), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3479), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82832] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5571), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3457), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82876] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5817), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3382), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82920] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5776), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3099), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4336), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82964] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(1976), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83008] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5687), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3441), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83052] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5183), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3435), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83096] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5559), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3427), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83140] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5774), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3170), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4336), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83184] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5921), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3392), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83228] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1221), 1,
      anon_sym_DQUOTE,
    ACTIONS(1223), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_LBRACK,
    ACTIONS(5805), 1,
      anon_sym_readonly,
    ACTIONS(5774), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3170), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(4336), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83274] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5772), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3492), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83318] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5993), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4867), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83362] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5681), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3356), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83406] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5903), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3350), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83450] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5754), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3418), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83494] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5931), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3481), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83538] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5923), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3408), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83582] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5575), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3334), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83626] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5533), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3346), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83670] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5917), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3423), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83714] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5691), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3514), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83758] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5913), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3470), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83802] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(5181), 1,
      anon_sym_LBRACK,
    ACTIONS(5625), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3409), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2168), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3127), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3129), 22,
      ts_builtin_sym_end,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_import,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_abstract,
      anon_sym_extends,
      anon_sym_component,
      anon_sym_instance,
  [83878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3272), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3274), 22,
      ts_builtin_sym_end,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_import,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_abstract,
      anon_sym_extends,
      anon_sym_component,
      anon_sym_instance,
  [83910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3090), 1,
      anon_sym_EQ,
    ACTIONS(3092), 23,
      ts_builtin_sym_end,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_import,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_component,
      anon_sym_instance,
  [83942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2904), 1,
      anon_sym_EQ,
    ACTIONS(2906), 23,
      ts_builtin_sym_end,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_import,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_component,
      anon_sym_instance,
  [83974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3210), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3212), 22,
      ts_builtin_sym_end,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_import,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_abstract,
      anon_sym_extends,
      anon_sym_component,
      anon_sym_instance,
  [84006] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5995), 1,
      sym_identifier,
    STATE(4545), 1,
      sym_mapped_type_clause,
    ACTIONS(5997), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_namespace,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 2,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    ACTIONS(2586), 5,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3114), 13,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [84067] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3877), 1,
      anon_sym_LPAREN,
    ACTIONS(5999), 1,
      anon_sym_DOT,
    ACTIONS(6001), 1,
      anon_sym_QMARK_DOT,
    STATE(2747), 1,
      sym_arguments,
    ACTIONS(2842), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2844), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84102] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3877), 1,
      anon_sym_LPAREN,
    ACTIONS(6003), 1,
      anon_sym_DOT,
    ACTIONS(6005), 1,
      anon_sym_QMARK_DOT,
    STATE(2744), 1,
      sym_arguments,
    ACTIONS(2860), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2862), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84137] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3877), 1,
      anon_sym_LPAREN,
    ACTIONS(3881), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6007), 1,
      anon_sym_DOT,
    STATE(2741), 1,
      sym_arguments,
    ACTIONS(2828), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(2830), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3196), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3174), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3176), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3190), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3192), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3094), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3096), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3094), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3096), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3094), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3096), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3119), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3121), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3294), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3296), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3174), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3176), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3339), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3341), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3190), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3192), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3208), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3208), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3335), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3337), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3246), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3208), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3190), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3192), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3240), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3242), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3214), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3216), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3339), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3341), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3152), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3154), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84718] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(2588), 1,
      anon_sym_extends,
    ACTIONS(6009), 1,
      sym_identifier,
    ACTIONS(6011), 1,
      anon_sym_LBRACE,
    ACTIONS(6013), 1,
      anon_sym_COLON,
    ACTIONS(6015), 1,
      anon_sym_EQ,
    ACTIONS(6017), 1,
      anon_sym_LT,
    ACTIONS(6019), 1,
      anon_sym_DOT,
    ACTIONS(6021), 1,
      anon_sym_BQUOTE,
    ACTIONS(6023), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(1534), 1,
      sym_new_component_body,
    STATE(1543), 1,
      sym_tagged_type_string,
    STATE(1549), 1,
      sym_tripple_tagged_type_string,
    STATE(2752), 1,
      sym_type_arguments,
    STATE(3419), 1,
      sym_component_identifier,
    ACTIONS(2590), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [84772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3319), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3290), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3292), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3294), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3296), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3290), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3292), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3174), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3176), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3196), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3156), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3158), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3319), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [84980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3319), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3335), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3337), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3246), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3152), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3154), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3246), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85110] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(2588), 1,
      anon_sym_extends,
    ACTIONS(6009), 1,
      sym_identifier,
    ACTIONS(6011), 1,
      anon_sym_LBRACE,
    ACTIONS(6017), 1,
      anon_sym_LT,
    ACTIONS(6019), 1,
      anon_sym_DOT,
    ACTIONS(6021), 1,
      anon_sym_BQUOTE,
    ACTIONS(6023), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6025), 1,
      anon_sym_COLON,
    ACTIONS(6027), 1,
      anon_sym_EQ,
    STATE(1534), 1,
      sym_new_component_body,
    STATE(1543), 1,
      sym_tagged_type_string,
    STATE(1549), 1,
      sym_tripple_tagged_type_string,
    STATE(2752), 1,
      sym_type_arguments,
    STATE(3419), 1,
      sym_component_identifier,
    ACTIONS(2590), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [85164] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6029), 1,
      anon_sym_DOT,
    ACTIONS(6031), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3325), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3327), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3162), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3164), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2812), 1,
      anon_sym_EQ,
    ACTIONS(2814), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [85243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 1,
      anon_sym_EQ,
    ACTIONS(2740), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [85268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3170), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3172), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1250), 5,
      anon_sym_as,
      anon_sym_EQ,
      sym_identifier,
      anon_sym_extends,
      anon_sym_is,
    ACTIONS(1248), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [85318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2852), 1,
      anon_sym_EQ,
    ACTIONS(2854), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [85343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3166), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3168), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3086), 1,
      anon_sym_EQ,
    ACTIONS(3088), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [85393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2796), 1,
      anon_sym_EQ,
    ACTIONS(2798), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [85418] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 1,
      anon_sym_BQUOTE,
    ACTIONS(3156), 1,
      anon_sym_QMARK,
    ACTIONS(6033), 1,
      anon_sym_DOT,
    ACTIONS(2586), 3,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3158), 11,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [85449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3309), 4,
      anon_sym_as,
      anon_sym_EQ,
      sym_identifier,
      anon_sym_extends,
    ACTIONS(3311), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [85473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3361), 4,
      anon_sym_as,
      anon_sym_EQ,
      sym_identifier,
      anon_sym_extends,
    ACTIONS(3363), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [85497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3182), 4,
      anon_sym_as,
      anon_sym_EQ,
      sym_identifier,
      anon_sym_extends,
    ACTIONS(3184), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [85521] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2834), 1,
      anon_sym_EQ,
    ACTIONS(6017), 1,
      anon_sym_LT,
    STATE(2751), 1,
      sym_type_arguments,
    ACTIONS(2836), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [85549] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 1,
      anon_sym_BQUOTE,
    ACTIONS(3112), 1,
      anon_sym_PIPE,
    ACTIONS(2586), 4,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3114), 10,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [85577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3268), 4,
      anon_sym_as,
      anon_sym_EQ,
      sym_identifier,
      anon_sym_extends,
    ACTIONS(3270), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [85601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2904), 1,
      anon_sym_PIPE,
    ACTIONS(2906), 15,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [85625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3090), 1,
      anon_sym_PIPE,
    ACTIONS(3092), 15,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [85649] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 1,
      anon_sym_BQUOTE,
    ACTIONS(3156), 1,
      anon_sym_PIPE,
    ACTIONS(6033), 1,
      anon_sym_DOT,
    ACTIONS(2586), 3,
      anon_sym_LBRACE,
      anon_sym_POUND,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3158), 10,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [85679] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6017), 1,
      anon_sym_LT,
    ACTIONS(6038), 1,
      anon_sym_DOT,
    STATE(2752), 1,
      sym_type_arguments,
    STATE(3762), 1,
      aux_sym_component_short_heritage_repeat1,
    ACTIONS(6036), 2,
      anon_sym_LBRACE,
      anon_sym_POUND,
    ACTIONS(2590), 10,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [85711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3252), 1,
      anon_sym_EQ,
    ACTIONS(3254), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [85734] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_import,
    ACTIONS(11), 1,
      anon_sym_AMP,
    ACTIONS(13), 1,
      anon_sym_AT,
    ACTIONS(15), 1,
      anon_sym_component,
    ACTIONS(17), 1,
      anon_sym_instance,
    ACTIONS(6040), 1,
      ts_builtin_sym_end,
    STATE(1469), 1,
      sym_decorator,
    STATE(3337), 1,
      aux_sym_class_repeat1,
    STATE(3735), 1,
      sym_component_short_heritage,
    STATE(4130), 1,
      sym_component_instance,
    STATE(2797), 5,
      sym_import_statement,
      sym_js_import_statement,
      sym_component_declaration,
      sym_component_instance_statement,
      aux_sym_program_repeat1,
  [85775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3232), 1,
      anon_sym_EQ,
    ACTIONS(3234), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [85798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6042), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [85819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2982), 1,
      anon_sym_EQ,
    ACTIONS(2984), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [85842] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2860), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_LPAREN,
    ACTIONS(6044), 1,
      anon_sym_DOT,
    ACTIONS(6046), 1,
      anon_sym_QMARK_DOT,
    STATE(2880), 1,
      sym_arguments,
    ACTIONS(2862), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [85873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3264), 1,
      anon_sym_EQ,
    ACTIONS(3266), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [85896] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2842), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_LPAREN,
    ACTIONS(6048), 1,
      anon_sym_DOT,
    ACTIONS(6050), 1,
      anon_sym_QMARK_DOT,
    STATE(2878), 1,
      sym_arguments,
    ACTIONS(2844), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [85927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3123), 1,
      anon_sym_EQ,
    ACTIONS(3125), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [85950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3178), 1,
      anon_sym_EQ,
    ACTIONS(3180), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [85973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2834), 1,
      anon_sym_EQ,
    ACTIONS(2836), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [85996] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3226), 1,
      anon_sym_EQ,
    ACTIONS(6052), 1,
      anon_sym_LBRACK,
    ACTIONS(3228), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [86021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3343), 1,
      anon_sym_EQ,
    ACTIONS(3345), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [86044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3236), 1,
      anon_sym_EQ,
    ACTIONS(3238), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [86067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6054), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [86088] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2828), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 1,
      anon_sym_LPAREN,
    ACTIONS(3702), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6056), 1,
      anon_sym_DOT,
    STATE(2877), 1,
      sym_arguments,
    ACTIONS(2830), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6058), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [86140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3256), 1,
      anon_sym_EQ,
    ACTIONS(3258), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [86163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3313), 1,
      anon_sym_EQ,
    ACTIONS(6052), 1,
      anon_sym_LBRACK,
    ACTIONS(3315), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [86188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [86209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6062), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [86230] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 1,
      anon_sym_PIPE,
    ACTIONS(6064), 1,
      anon_sym_LT,
    ACTIONS(6066), 1,
      anon_sym_DOT,
    STATE(3013), 1,
      sym_type_arguments,
    STATE(3762), 1,
      aux_sym_component_short_heritage_repeat1,
    ACTIONS(6036), 2,
      anon_sym_LBRACE,
      anon_sym_POUND,
    ACTIONS(2590), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3186), 1,
      anon_sym_EQ,
    ACTIONS(3188), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [86286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_EQ,
    ACTIONS(3284), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [86309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6068), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [86330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3202), 1,
      anon_sym_EQ,
    ACTIONS(3204), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [86353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [86374] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6072), 1,
      ts_builtin_sym_end,
    ACTIONS(6074), 1,
      anon_sym_import,
    ACTIONS(6077), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_AT,
    ACTIONS(6083), 1,
      anon_sym_component,
    ACTIONS(6086), 1,
      anon_sym_instance,
    STATE(1469), 1,
      sym_decorator,
    STATE(3337), 1,
      aux_sym_class_repeat1,
    STATE(3735), 1,
      sym_component_short_heritage,
    STATE(4130), 1,
      sym_component_instance,
    STATE(2788), 5,
      sym_import_statement,
      sym_js_import_statement,
      sym_component_declaration,
      sym_component_instance_statement,
      aux_sym_program_repeat1,
  [86415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6089), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [86436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3137), 1,
      anon_sym_EQ,
    ACTIONS(3139), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [86459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3102), 1,
      anon_sym_EQ,
    ACTIONS(3104), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [86482] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6017), 1,
      anon_sym_LT,
    ACTIONS(6019), 1,
      anon_sym_DOT,
    ACTIONS(6091), 1,
      anon_sym_is,
    STATE(2752), 1,
      sym_type_arguments,
    ACTIONS(2590), 11,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [86511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_EQ,
    ACTIONS(3333), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [86534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 1,
      anon_sym_EQ,
    ACTIONS(3391), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [86557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3098), 1,
      anon_sym_EQ,
    ACTIONS(3100), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [86580] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_COMMA,
    ACTIONS(6093), 1,
      sym_identifier,
    ACTIONS(6095), 1,
      anon_sym_from,
    STATE(2875), 1,
      aux_sym_import_path_segment_repeat1,
    STATE(4118), 1,
      aux_sym_js_import_statement_repeat1,
    ACTIONS(6097), 2,
      anon_sym_DASH,
      sym_number,
    ACTIONS(2183), 3,
      ts_builtin_sym_end,
      anon_sym_AMP,
      anon_sym_AT,
    ACTIONS(2181), 5,
      anon_sym_as,
      anon_sym_import,
      anon_sym_DOT,
      anon_sym_component,
      anon_sym_instance,
  [86615] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_import,
    ACTIONS(11), 1,
      anon_sym_AMP,
    ACTIONS(13), 1,
      anon_sym_AT,
    ACTIONS(15), 1,
      anon_sym_component,
    ACTIONS(17), 1,
      anon_sym_instance,
    ACTIONS(6099), 1,
      ts_builtin_sym_end,
    STATE(1469), 1,
      sym_decorator,
    STATE(3337), 1,
      aux_sym_class_repeat1,
    STATE(3735), 1,
      sym_component_short_heritage,
    STATE(4130), 1,
      sym_component_instance,
    STATE(2788), 5,
      sym_import_statement,
      sym_js_import_statement,
      sym_component_declaration,
      sym_component_instance_statement,
      aux_sym_program_repeat1,
  [86656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3148), 1,
      anon_sym_EQ,
    ACTIONS(3150), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [86679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3248), 1,
      anon_sym_EQ,
    ACTIONS(3250), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [86702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3222), 1,
      anon_sym_EQ,
    ACTIONS(3224), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [86725] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3347), 1,
      anon_sym_EQ,
    ACTIONS(6052), 1,
      anon_sym_LBRACK,
    ACTIONS(3228), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(3349), 10,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [86752] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_import,
    ACTIONS(11), 1,
      anon_sym_AMP,
    ACTIONS(13), 1,
      anon_sym_AT,
    ACTIONS(15), 1,
      anon_sym_component,
    ACTIONS(17), 1,
      anon_sym_instance,
    ACTIONS(6040), 1,
      ts_builtin_sym_end,
    STATE(1469), 1,
      sym_decorator,
    STATE(3337), 1,
      aux_sym_class_repeat1,
    STATE(3735), 1,
      sym_component_short_heritage,
    STATE(4130), 1,
      sym_component_instance,
    STATE(2788), 5,
      sym_import_statement,
      sym_js_import_statement,
      sym_component_declaration,
      sym_component_instance_statement,
      aux_sym_program_repeat1,
  [86793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3321), 1,
      anon_sym_EQ,
    ACTIONS(3323), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [86816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3174), 1,
      anon_sym_PIPE,
    ACTIONS(3176), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6103), 1,
      anon_sym_DOT,
    ACTIONS(6101), 2,
      anon_sym_LBRACE,
      anon_sym_POUND,
    ACTIONS(3114), 11,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [86862] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6017), 1,
      anon_sym_LT,
    ACTIONS(6019), 1,
      anon_sym_DOT,
    STATE(2752), 1,
      sym_type_arguments,
    ACTIONS(2590), 11,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [86888] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6106), 1,
      sym_identifier,
    STATE(2807), 1,
      aux_sym_import_path_segment_repeat1,
    ACTIONS(6109), 2,
      anon_sym_DASH,
      sym_number,
    ACTIONS(2358), 3,
      ts_builtin_sym_end,
      anon_sym_AMP,
      anon_sym_AT,
    ACTIONS(2356), 7,
      anon_sym_as,
      anon_sym_import,
      anon_sym_else,
      anon_sym_while,
      anon_sym_DOT,
      anon_sym_component,
      anon_sym_instance,
  [86916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3214), 1,
      anon_sym_PIPE,
    ACTIONS(3216), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [86982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3206), 1,
      anon_sym_PIPE,
    ACTIONS(3208), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3190), 1,
      anon_sym_PIPE,
    ACTIONS(3192), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3190), 1,
      anon_sym_PIPE,
    ACTIONS(3192), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3190), 1,
      anon_sym_PIPE,
    ACTIONS(3192), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3174), 1,
      anon_sym_PIPE,
    ACTIONS(3176), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3174), 1,
      anon_sym_PIPE,
    ACTIONS(3176), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87114] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6114), 1,
      sym_number,
    STATE(4655), 1,
      sym_string,
    STATE(4665), 1,
      sym_predefined_type,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [87144] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6116), 1,
      sym_number,
    STATE(4614), 1,
      sym_string,
    STATE(4617), 1,
      sym_predefined_type,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [87174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_PIPE,
    ACTIONS(3246), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87196] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6118), 1,
      sym_number,
    STATE(4610), 1,
      sym_string,
    STATE(4611), 1,
      sym_predefined_type,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [87226] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6120), 1,
      sym_number,
    STATE(4605), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [87254] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6124), 1,
      anon_sym_BANG,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    ACTIONS(6132), 1,
      anon_sym_QMARK,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3402), 1,
      sym__call_signature,
    STATE(3557), 1,
      sym_type_annotation,
    STATE(4042), 1,
      sym__initializer,
    STATE(4162), 1,
      sym_type_parameters,
    ACTIONS(6122), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3094), 1,
      anon_sym_PIPE,
    ACTIONS(3096), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3094), 1,
      anon_sym_PIPE,
    ACTIONS(3096), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3094), 1,
      anon_sym_PIPE,
    ACTIONS(3096), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 1,
      anon_sym_PIPE,
    ACTIONS(3319), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 1,
      anon_sym_PIPE,
    ACTIONS(3319), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 1,
      anon_sym_PIPE,
    ACTIONS(3319), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3152), 1,
      anon_sym_PIPE,
    ACTIONS(3154), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_PIPE,
    ACTIONS(3246), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_PIPE,
    ACTIONS(3246), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3240), 1,
      anon_sym_PIPE,
    ACTIONS(3242), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87516] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6134), 1,
      sym_number,
    STATE(4834), 1,
      sym_predefined_type,
    STATE(4835), 1,
      sym_string,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [87546] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6136), 1,
      sym_number,
    STATE(4840), 1,
      sym_predefined_type,
    STATE(4849), 1,
      sym_string,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [87576] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 1,
      anon_sym_PIPE,
    ACTIONS(6064), 1,
      anon_sym_LT,
    ACTIONS(6138), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_is,
    STATE(3013), 1,
      sym_type_arguments,
    ACTIONS(2590), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87606] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6142), 1,
      sym_number,
    STATE(4856), 1,
      sym_predefined_type,
    STATE(4858), 1,
      sym_string,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [87636] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6144), 1,
      sym_number,
    STATE(4861), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [87664] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    ACTIONS(6148), 1,
      anon_sym_BANG,
    ACTIONS(6150), 1,
      anon_sym_QMARK,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3705), 1,
      sym_type_annotation,
    STATE(4008), 1,
      sym__call_signature,
    STATE(4011), 1,
      sym__initializer,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(6146), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87706] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6152), 1,
      sym_number,
    STATE(4775), 1,
      sym_string,
    STATE(4779), 1,
      sym_predefined_type,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [87736] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    ACTIONS(6156), 1,
      anon_sym_BANG,
    ACTIONS(6158), 1,
      anon_sym_QMARK,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3391), 1,
      sym__call_signature,
    STATE(3679), 1,
      sym_type_annotation,
    STATE(4080), 1,
      sym__initializer,
    STATE(4162), 1,
      sym_type_parameters,
    ACTIONS(6154), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87778] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6160), 1,
      sym_number,
    STATE(4513), 1,
      sym_string,
    STATE(4773), 1,
      sym_predefined_type,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [87808] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    ACTIONS(6148), 1,
      anon_sym_BANG,
    ACTIONS(6162), 1,
      anon_sym_QMARK,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3424), 1,
      sym__call_signature,
    STATE(3705), 1,
      sym_type_annotation,
    STATE(3994), 1,
      sym__initializer,
    STATE(4162), 1,
      sym_type_parameters,
    ACTIONS(6146), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [87850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3294), 1,
      anon_sym_PIPE,
    ACTIONS(3296), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3290), 1,
      anon_sym_PIPE,
    ACTIONS(3292), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3294), 1,
      anon_sym_PIPE,
    ACTIONS(3296), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3335), 1,
      anon_sym_PIPE,
    ACTIONS(3337), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3339), 1,
      anon_sym_PIPE,
    ACTIONS(3341), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [87982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3335), 1,
      anon_sym_PIPE,
    ACTIONS(3337), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [88004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3339), 1,
      anon_sym_PIPE,
    ACTIONS(3341), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [88026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_PIPE,
    ACTIONS(3196), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [88048] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6164), 1,
      sym_number,
    STATE(4764), 1,
      sym_string,
    STATE(4767), 1,
      sym_predefined_type,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [88078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3194), 1,
      anon_sym_PIPE,
    ACTIONS(3196), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [88100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3152), 1,
      anon_sym_PIPE,
    ACTIONS(3154), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [88122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3119), 1,
      anon_sym_PIPE,
    ACTIONS(3121), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [88144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3156), 1,
      anon_sym_PIPE,
    ACTIONS(3158), 13,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [88166] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 1,
      anon_sym_PIPE,
    ACTIONS(6064), 1,
      anon_sym_LT,
    ACTIONS(6166), 1,
      anon_sym_DOT,
    ACTIONS(6168), 1,
      anon_sym_is,
    STATE(3013), 1,
      sym_type_arguments,
    ACTIONS(2590), 9,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [88196] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6170), 1,
      sym_number,
    STATE(4758), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [88224] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6093), 1,
      sym_identifier,
    STATE(2875), 1,
      aux_sym_import_path_segment_repeat1,
    ACTIONS(6097), 2,
      anon_sym_DASH,
      sym_number,
    ACTIONS(2183), 3,
      ts_builtin_sym_end,
      anon_sym_AMP,
      anon_sym_AT,
    ACTIONS(2181), 7,
      anon_sym_as,
      anon_sym_import,
      anon_sym_else,
      anon_sym_while,
      anon_sym_DOT,
      anon_sym_component,
      anon_sym_instance,
  [88252] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    ACTIONS(6174), 1,
      anon_sym_BANG,
    ACTIONS(6176), 1,
      anon_sym_QMARK,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3505), 1,
      sym__call_signature,
    STATE(3692), 1,
      sym_type_annotation,
    STATE(3935), 1,
      sym__initializer,
    STATE(4162), 1,
      sym_type_parameters,
    ACTIONS(6172), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88294] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6178), 1,
      sym_number,
    STATE(4667), 1,
      sym_string,
    STATE(4668), 1,
      sym_predefined_type,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [88324] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6180), 1,
      sym_number,
    STATE(4661), 1,
      sym_string,
    STATE(4662), 1,
      sym_predefined_type,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [88354] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    ACTIONS(6184), 1,
      anon_sym_BANG,
    ACTIONS(6186), 1,
      anon_sym_QMARK,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3564), 1,
      sym_type_annotation,
    STATE(3965), 1,
      sym__call_signature,
    STATE(3966), 1,
      sym__initializer,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(6182), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88396] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    ACTIONS(6184), 1,
      anon_sym_BANG,
    ACTIONS(6188), 1,
      anon_sym_QMARK,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3446), 1,
      sym__call_signature,
    STATE(3564), 1,
      sym_type_annotation,
    STATE(3963), 1,
      sym__initializer,
    STATE(4162), 1,
      sym_type_parameters,
    ACTIONS(6182), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [88438] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6190), 1,
      sym_number,
    STATE(4652), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [88466] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6192), 1,
      sym_number,
    STATE(4644), 1,
      sym_predefined_type,
    STATE(4646), 1,
      sym_string,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [88496] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6194), 1,
      sym_number,
    STATE(4635), 1,
      sym_predefined_type,
    STATE(4636), 1,
      sym_string,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [88526] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6196), 1,
      sym_number,
    STATE(4627), 1,
      sym_predefined_type,
    STATE(4629), 1,
      sym_string,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [88556] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6198), 1,
      sym_number,
    STATE(4654), 1,
      sym_string,
    STATE(4656), 1,
      sym_predefined_type,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [88586] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6200), 1,
      sym_number,
    STATE(4647), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [88614] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6017), 1,
      anon_sym_LT,
    ACTIONS(6202), 1,
      anon_sym_DOT,
    ACTIONS(6204), 1,
      anon_sym_is,
    STATE(2752), 1,
      sym_type_arguments,
    ACTIONS(2590), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [88642] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6206), 1,
      sym_number,
    STATE(4546), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [88670] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6208), 1,
      sym_number,
    STATE(4547), 1,
      sym_string,
    STATE(4549), 1,
      sym_predefined_type,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [88700] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6210), 1,
      sym_number,
    STATE(4554), 1,
      sym_string,
    STATE(4555), 1,
      sym_predefined_type,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [88730] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6212), 1,
      sym_identifier,
    STATE(2807), 1,
      aux_sym_import_path_segment_repeat1,
    ACTIONS(6214), 2,
      anon_sym_DASH,
      sym_number,
    ACTIONS(2384), 3,
      ts_builtin_sym_end,
      anon_sym_AMP,
      anon_sym_AT,
    ACTIONS(2382), 7,
      anon_sym_as,
      anon_sym_import,
      anon_sym_else,
      anon_sym_while,
      anon_sym_DOT,
      anon_sym_component,
      anon_sym_instance,
  [88758] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6216), 1,
      sym_number,
    STATE(4551), 1,
      sym_string,
    STATE(4552), 1,
      sym_predefined_type,
    ACTIONS(6112), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [88788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3162), 1,
      anon_sym_PIPE,
    ACTIONS(3164), 12,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [88809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3166), 1,
      anon_sym_PIPE,
    ACTIONS(3168), 12,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [88830] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6220), 1,
      anon_sym_QMARK,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3598), 1,
      sym__call_signature,
    STATE(3720), 1,
      sym_type_annotation,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(6218), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [88865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3170), 1,
      anon_sym_PIPE,
    ACTIONS(3172), 12,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [88886] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4490), 1,
      sym_type_predicate,
    STATE(4538), 1,
      sym_predefined_type,
    ACTIONS(6222), 2,
      sym_identifier,
      sym_this,
    ACTIONS(116), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [88911] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4900), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(6224), 1,
      sym_identifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [88942] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6228), 1,
      anon_sym_QMARK,
    STATE(3073), 1,
      sym_formal_parameters,
    STATE(3318), 1,
      sym__call_signature,
    STATE(3595), 1,
      sym_type_annotation,
    STATE(4208), 1,
      sym_type_parameters,
    ACTIONS(6226), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [88977] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6232), 1,
      anon_sym_QMARK,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3607), 1,
      sym__call_signature,
    STATE(3614), 1,
      sym_type_annotation,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(6230), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89012] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6234), 1,
      anon_sym_QMARK,
    STATE(3073), 1,
      sym_formal_parameters,
    STATE(3272), 1,
      sym__call_signature,
    STATE(3720), 1,
      sym_type_annotation,
    STATE(4208), 1,
      sym_type_parameters,
    ACTIONS(6218), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89047] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3112), 1,
      anon_sym_PIPE,
    ACTIONS(6103), 1,
      anon_sym_DOT,
    ACTIONS(6101), 2,
      anon_sym_LBRACE,
      anon_sym_POUND,
    ACTIONS(3114), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [89072] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 1,
      anon_sym_PIPE,
    ACTIONS(6064), 1,
      anon_sym_LT,
    ACTIONS(6166), 1,
      anon_sym_DOT,
    STATE(3013), 1,
      sym_type_arguments,
    ACTIONS(2590), 9,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [89099] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 1,
      anon_sym_PIPE,
    ACTIONS(6064), 1,
      anon_sym_LT,
    ACTIONS(6138), 1,
      anon_sym_DOT,
    STATE(3013), 1,
      sym_type_arguments,
    ACTIONS(2590), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [89126] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6017), 1,
      anon_sym_LT,
    ACTIONS(6202), 1,
      anon_sym_DOT,
    STATE(2752), 1,
      sym_type_arguments,
    ACTIONS(2590), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3210), 1,
      anon_sym_PIPE,
    ACTIONS(3212), 12,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [89172] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3325), 1,
      anon_sym_PIPE,
    ACTIONS(6236), 1,
      anon_sym_DOT,
    ACTIONS(6238), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3327), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [89197] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4950), 1,
      anon_sym_RBRACE,
    ACTIONS(6224), 1,
      sym_identifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [89228] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3517), 1,
      sym_type_predicate,
    STATE(4865), 1,
      sym_predefined_type,
    ACTIONS(6240), 2,
      sym_identifier,
      sym_this,
    ACTIONS(116), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [89253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3127), 1,
      anon_sym_PIPE,
    ACTIONS(3129), 12,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [89274] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6244), 1,
      anon_sym_QMARK,
    STATE(3073), 1,
      sym_formal_parameters,
    STATE(3266), 1,
      sym__call_signature,
    STATE(3704), 1,
      sym_type_annotation,
    STATE(4208), 1,
      sym_type_parameters,
    ACTIONS(6242), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89309] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6246), 1,
      anon_sym_LPAREN,
    ACTIONS(6248), 1,
      anon_sym_DOT,
    ACTIONS(6250), 1,
      anon_sym_QMARK_DOT,
    STATE(3028), 1,
      sym_arguments,
    ACTIONS(2862), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89336] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2834), 1,
      anon_sym_PIPE,
    ACTIONS(6064), 1,
      anon_sym_LT,
    STATE(2981), 1,
      sym_type_arguments,
    ACTIONS(2836), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [89361] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6252), 1,
      anon_sym_LT,
    ACTIONS(6254), 1,
      anon_sym_DOT,
    ACTIONS(6256), 1,
      anon_sym_is,
    STATE(3175), 1,
      sym_type_arguments,
    ACTIONS(2590), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89388] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6246), 1,
      anon_sym_LPAREN,
    ACTIONS(6258), 1,
      anon_sym_DOT,
    ACTIONS(6260), 1,
      anon_sym_QMARK_DOT,
    STATE(3025), 1,
      sym_arguments,
    ACTIONS(2844), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89415] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6246), 1,
      anon_sym_LPAREN,
    ACTIONS(6262), 1,
      anon_sym_DOT,
    ACTIONS(6264), 1,
      anon_sym_QMARK_DOT,
    STATE(2977), 1,
      sym_arguments,
    ACTIONS(2830), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    ACTIONS(3274), 12,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [89463] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6268), 1,
      anon_sym_COLON,
    ACTIONS(6270), 1,
      anon_sym_QMARK,
    STATE(3073), 1,
      sym_formal_parameters,
    STATE(3277), 1,
      sym__call_signature,
    STATE(3554), 1,
      sym_type_annotation,
    STATE(4208), 1,
      sym_type_parameters,
    ACTIONS(6266), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89498] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4927), 1,
      anon_sym_RBRACE,
    ACTIONS(6224), 1,
      sym_identifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [89529] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4490), 1,
      sym_type_predicate,
    STATE(4612), 1,
      sym_predefined_type,
    ACTIONS(6272), 2,
      sym_identifier,
      sym_this,
    ACTIONS(116), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [89554] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6274), 1,
      anon_sym_QMARK,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3594), 1,
      sym__call_signature,
    STATE(3595), 1,
      sym_type_annotation,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(6226), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89589] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6276), 1,
      anon_sym_QMARK,
    STATE(3073), 1,
      sym_formal_parameters,
    STATE(3241), 1,
      sym__call_signature,
    STATE(3614), 1,
      sym_type_annotation,
    STATE(4208), 1,
      sym_type_parameters,
    ACTIONS(6230), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89624] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6017), 1,
      anon_sym_LT,
    ACTIONS(6019), 1,
      anon_sym_DOT,
    ACTIONS(6281), 1,
      anon_sym_COLON,
    ACTIONS(6283), 1,
      anon_sym_EQ,
    ACTIONS(6285), 1,
      anon_sym_extends,
    STATE(2752), 1,
      sym_type_arguments,
    STATE(3862), 1,
      sym_constraint,
    STATE(4344), 1,
      sym_default_type,
    ACTIONS(6278), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(2590), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [89661] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4957), 1,
      anon_sym_RBRACE,
    ACTIONS(6224), 1,
      sym_identifier,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [89692] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6288), 1,
      anon_sym_QMARK,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3699), 1,
      sym__call_signature,
    STATE(3704), 1,
      sym_type_annotation,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(6242), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89727] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3517), 1,
      sym_type_predicate,
    STATE(4725), 1,
      sym_predefined_type,
    ACTIONS(6290), 2,
      sym_identifier,
      sym_this,
    ACTIONS(116), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [89752] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3718), 1,
      sym_type_predicate,
    STATE(4845), 1,
      sym_predefined_type,
    ACTIONS(6292), 2,
      sym_identifier,
      sym_this,
    ACTIONS(116), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [89777] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6294), 1,
      anon_sym_QMARK,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3554), 1,
      sym_type_annotation,
    STATE(3555), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(6266), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3208), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [89830] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4957), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [89858] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    STATE(3073), 1,
      sym_formal_parameters,
    STATE(3242), 1,
      sym__call_signature,
    STATE(3597), 1,
      sym_type_annotation,
    STATE(4208), 1,
      sym_type_parameters,
    ACTIONS(6296), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89890] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3405), 1,
      sym__call_signature,
    STATE(3523), 1,
      sym_type_annotation,
    STATE(4039), 1,
      sym__initializer,
    STATE(4162), 1,
      sym_type_parameters,
    ACTIONS(6298), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [89926] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3523), 1,
      sym_type_annotation,
    STATE(4046), 1,
      sym__call_signature,
    STATE(4047), 1,
      sym__initializer,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(6298), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [89962] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3664), 1,
      sym__call_signature,
    STATE(3667), 1,
      sym_type_annotation,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(6300), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [89994] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4900), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [90022] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3725), 1,
      anon_sym_COLON,
    ACTIONS(6017), 1,
      anon_sym_LT,
    ACTIONS(6019), 1,
      anon_sym_DOT,
    ACTIONS(6302), 1,
      anon_sym_QMARK,
    STATE(2752), 1,
      sym_type_arguments,
    STATE(4339), 1,
      sym_type_annotation,
    ACTIONS(2590), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90052] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    STATE(3073), 1,
      sym_formal_parameters,
    STATE(3265), 1,
      sym__call_signature,
    STATE(3667), 1,
      sym_type_annotation,
    STATE(4208), 1,
      sym_type_parameters,
    ACTIONS(6300), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90084] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6252), 1,
      anon_sym_LT,
    ACTIONS(6254), 1,
      anon_sym_DOT,
    STATE(3175), 1,
      sym_type_arguments,
    ACTIONS(2590), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90108] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3552), 1,
      sym_type_annotation,
    STATE(3569), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(6305), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3158), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3121), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3154), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90194] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_COMMA,
    ACTIONS(2189), 1,
      anon_sym_EQ,
    ACTIONS(6093), 1,
      sym_identifier,
    ACTIONS(6095), 1,
      anon_sym_from,
    STATE(2875), 1,
      aux_sym_import_path_segment_repeat1,
    STATE(4118), 1,
      aux_sym_js_import_statement_repeat1,
    ACTIONS(6097), 2,
      anon_sym_DASH,
      sym_number,
    ACTIONS(2181), 4,
      anon_sym_as,
      anon_sym_else,
      anon_sym_while,
      anon_sym_DOT,
  [90226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3196), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3154), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3196), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3341), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90298] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4950), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [90326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3337), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3341), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90362] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3604), 1,
      sym__call_signature,
    STATE(3605), 1,
      sym_type_annotation,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(6307), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [90394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3337), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3296), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3292), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3296), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1250), 1,
      anon_sym_PIPE,
    ACTIONS(1248), 11,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_is,
      anon_sym_PIPE_RBRACE,
  [90486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3292), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90504] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3707), 1,
      sym_type_annotation,
    STATE(4000), 1,
      sym__call_signature,
    STATE(4003), 1,
      sym__initializer,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(6309), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90540] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3393), 1,
      sym__call_signature,
    STATE(3673), 1,
      sym_type_annotation,
    STATE(4077), 1,
      sym__initializer,
    STATE(4162), 1,
      sym_type_parameters,
    ACTIONS(6311), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6091), 1,
      anon_sym_is,
    ACTIONS(2984), 11,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [90596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3242), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6313), 1,
      anon_sym_is,
    ACTIONS(2836), 11,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [90634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3246), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3246), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3246), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 1,
      anon_sym_DOT,
    ACTIONS(3114), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3096), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90816] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4897), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(4927), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [90844] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3422), 1,
      sym__call_signature,
    STATE(3707), 1,
      sym_type_annotation,
    STATE(3996), 1,
      sym__initializer,
    STATE(4162), 1,
      sym_type_parameters,
    ACTIONS(6309), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [90880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3216), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90898] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3208), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3208), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [90970] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    STATE(3073), 1,
      sym_formal_parameters,
    STATE(3276), 1,
      sym__call_signature,
    STATE(3552), 1,
      sym_type_annotation,
    STATE(4208), 1,
      sym_type_parameters,
    ACTIONS(6305), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3192), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [91020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3176), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [91038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3176), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [91056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3176), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [91074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 1,
      anon_sym_DOT,
    ACTIONS(3112), 1,
      anon_sym_PIPE,
    ACTIONS(3114), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [91096] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    STATE(3073), 1,
      sym_formal_parameters,
    STATE(3275), 1,
      sym__call_signature,
    STATE(3723), 1,
      sym_type_annotation,
    STATE(4208), 1,
      sym_type_parameters,
    ACTIONS(6315), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91128] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3445), 1,
      sym__call_signature,
    STATE(3556), 1,
      sym_type_annotation,
    STATE(3969), 1,
      sym__initializer,
    STATE(4162), 1,
      sym_type_parameters,
    ACTIONS(6317), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91164] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3596), 1,
      sym__call_signature,
    STATE(3597), 1,
      sym_type_annotation,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(6296), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91196] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3721), 1,
      sym__call_signature,
    STATE(3723), 1,
      sym_type_annotation,
    STATE(4202), 1,
      sym_type_parameters,
    ACTIONS(6315), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91228] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3385), 1,
      sym__call_signature,
    STATE(3606), 1,
      sym_type_annotation,
    STATE(4119), 1,
      sym__initializer,
    STATE(4162), 1,
      sym_type_parameters,
    ACTIONS(6319), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [91264] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    STATE(3073), 1,
      sym_formal_parameters,
    STATE(3317), 1,
      sym__call_signature,
    STATE(3605), 1,
      sym_type_annotation,
    STATE(4208), 1,
      sym_type_parameters,
    ACTIONS(6307), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [91296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3178), 1,
      anon_sym_PIPE,
    ACTIONS(3180), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [91315] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3164), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [91332] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(6321), 1,
      anon_sym_LBRACK,
    ACTIONS(3228), 2,
      anon_sym_AMP,
      anon_sym_extends,
    ACTIONS(3349), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_PIPE_RBRACE,
  [91355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3321), 1,
      anon_sym_PIPE,
    ACTIONS(3323), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [91374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3313), 1,
      anon_sym_PIPE,
    ACTIONS(6321), 1,
      anon_sym_LBRACK,
    ACTIONS(3315), 9,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [91395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3309), 1,
      anon_sym_PIPE,
    ACTIONS(3311), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [91414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6323), 1,
      anon_sym_DOT,
    STATE(2999), 1,
      aux_sym_import_path_repeat1,
    ACTIONS(2331), 9,
      ts_builtin_sym_end,
      anon_sym_as,
      anon_sym_import,
      anon_sym_else,
      anon_sym_while,
      anon_sym_AMP,
      anon_sym_AT,
      anon_sym_component,
      anon_sym_instance,
  [91435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2852), 1,
      anon_sym_PIPE,
    ACTIONS(2854), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [91454] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(6224), 1,
      sym_identifier,
    ACTIONS(5359), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [91477] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6323), 1,
      anon_sym_DOT,
    STATE(3042), 1,
      aux_sym_import_path_repeat1,
    ACTIONS(2365), 9,
      ts_builtin_sym_end,
      anon_sym_as,
      anon_sym_import,
      anon_sym_else,
      anon_sym_while,
      anon_sym_AMP,
      anon_sym_AT,
      anon_sym_component,
      anon_sym_instance,
  [91498] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6252), 1,
      anon_sym_LT,
    STATE(3181), 1,
      sym_type_arguments,
    ACTIONS(2836), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [91519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2812), 1,
      anon_sym_PIPE,
    ACTIONS(2814), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [91538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3182), 1,
      anon_sym_PIPE,
    ACTIONS(3184), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [91557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3186), 1,
      anon_sym_PIPE,
    ACTIONS(3188), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [91576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3202), 1,
      anon_sym_PIPE,
    ACTIONS(3204), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [91595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3148), 1,
      anon_sym_PIPE,
    ACTIONS(3150), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [91614] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(3139), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [91637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3222), 1,
      anon_sym_PIPE,
    ACTIONS(3224), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [91656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3248), 1,
      anon_sym_PIPE,
    ACTIONS(3250), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [91675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3256), 1,
      anon_sym_PIPE,
    ACTIONS(3258), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [91694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3236), 1,
      anon_sym_PIPE,
    ACTIONS(3238), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [91713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3268), 1,
      anon_sym_PIPE,
    ACTIONS(3270), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [91732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3298), 1,
      anon_sym_PIPE,
    ACTIONS(3300), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [91751] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6331), 1,
      anon_sym_DOT,
    STATE(2999), 1,
      aux_sym_import_path_repeat1,
    ACTIONS(2369), 9,
      ts_builtin_sym_end,
      anon_sym_as,
      anon_sym_import,
      anon_sym_else,
      anon_sym_while,
      anon_sym_AMP,
      anon_sym_AT,
      anon_sym_component,
      anon_sym_instance,
  [91772] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6334), 1,
      sym_identifier,
    STATE(2985), 1,
      sym_import_path_segment,
    ACTIONS(2438), 3,
      ts_builtin_sym_end,
      anon_sym_AMP,
      anon_sym_AT,
    ACTIONS(2436), 6,
      anon_sym_as,
      anon_sym_import,
      anon_sym_else,
      anon_sym_while,
      anon_sym_component,
      anon_sym_instance,
  [91795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2796), 1,
      anon_sym_PIPE,
    ACTIONS(2798), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [91814] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6011), 1,
      anon_sym_LBRACE,
    ACTIONS(6019), 1,
      anon_sym_DOT,
    ACTIONS(6021), 1,
      anon_sym_BQUOTE,
    ACTIONS(6023), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6025), 1,
      anon_sym_COLON,
    ACTIONS(6027), 1,
      anon_sym_EQ,
    STATE(1534), 1,
      sym_new_component_body,
    STATE(1543), 1,
      sym_tagged_type_string,
    STATE(1549), 1,
      sym_tripple_tagged_type_string,
    STATE(3419), 1,
      sym_component_identifier,
  [91851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4903), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [91868] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6323), 1,
      anon_sym_DOT,
    STATE(2982), 1,
      aux_sym_import_path_repeat1,
    ACTIONS(2337), 9,
      ts_builtin_sym_end,
      anon_sym_as,
      anon_sym_import,
      anon_sym_else,
      anon_sym_while,
      anon_sym_AMP,
      anon_sym_AT,
      anon_sym_component,
      anon_sym_instance,
  [91889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3198), 1,
      anon_sym_PIPE,
    ACTIONS(3200), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [91908] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(3359), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [91931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 1,
      anon_sym_DOT,
    ACTIONS(3114), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [91950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3137), 1,
      anon_sym_PIPE,
    ACTIONS(3139), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [91969] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(3381), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [91992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 1,
      anon_sym_PIPE,
    ACTIONS(2740), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92011] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(3369), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [92034] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6336), 1,
      anon_sym_DOT,
    ACTIONS(6338), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3327), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [92055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3361), 1,
      anon_sym_PIPE,
    ACTIONS(3363), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3098), 1,
      anon_sym_PIPE,
    ACTIONS(3100), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3218), 1,
      anon_sym_PIPE,
    ACTIONS(3220), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [92129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3343), 1,
      anon_sym_PIPE,
    ACTIONS(3345), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3331), 1,
      anon_sym_PIPE,
    ACTIONS(3333), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92167] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6011), 1,
      anon_sym_LBRACE,
    ACTIONS(6013), 1,
      anon_sym_COLON,
    ACTIONS(6015), 1,
      anon_sym_EQ,
    ACTIONS(6019), 1,
      anon_sym_DOT,
    ACTIONS(6021), 1,
      anon_sym_BQUOTE,
    ACTIONS(6023), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(1534), 1,
      sym_new_component_body,
    STATE(1543), 1,
      sym_tagged_type_string,
    STATE(1549), 1,
      sym_tripple_tagged_type_string,
    STATE(3419), 1,
      sym_component_identifier,
  [92204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3086), 1,
      anon_sym_PIPE,
    ACTIONS(3088), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3212), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [92240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5287), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [92257] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2982), 1,
      anon_sym_PIPE,
    ACTIONS(6168), 1,
      anon_sym_is,
    ACTIONS(2984), 9,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2834), 1,
      anon_sym_PIPE,
    ACTIONS(6340), 1,
      anon_sym_is,
    ACTIONS(2836), 9,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3168), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [92316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2834), 1,
      anon_sym_PIPE,
    ACTIONS(2836), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3226), 1,
      anon_sym_PIPE,
    ACTIONS(6321), 1,
      anon_sym_LBRACK,
    ACTIONS(3228), 9,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3172), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [92373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2982), 1,
      anon_sym_PIPE,
    ACTIONS(2984), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92392] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2982), 1,
      anon_sym_PIPE,
    ACTIONS(6140), 1,
      anon_sym_is,
    ACTIONS(2984), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92413] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2834), 1,
      anon_sym_PIPE,
    ACTIONS(6342), 1,
      anon_sym_is,
    ACTIONS(2836), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3264), 1,
      anon_sym_PIPE,
    ACTIONS(3266), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3102), 1,
      anon_sym_PIPE,
    ACTIONS(3104), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3282), 1,
      anon_sym_PIPE,
    ACTIONS(3284), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3232), 1,
      anon_sym_PIPE,
    ACTIONS(3234), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3274), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [92527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(3377), 10,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [92546] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(3224), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [92569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3252), 1,
      anon_sym_PIPE,
    ACTIONS(3254), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(3108), 10,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [92607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 1,
      anon_sym_PIPE,
    ACTIONS(3391), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6323), 1,
      anon_sym_DOT,
    STATE(2999), 1,
      aux_sym_import_path_repeat1,
    ACTIONS(2347), 9,
      ts_builtin_sym_end,
      anon_sym_as,
      anon_sym_import,
      anon_sym_else,
      anon_sym_while,
      anon_sym_AMP,
      anon_sym_AT,
      anon_sym_component,
      anon_sym_instance,
  [92647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3123), 1,
      anon_sym_PIPE,
    ACTIONS(3125), 10,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [92666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6204), 1,
      anon_sym_is,
    ACTIONS(2984), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [92685] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
  [92706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 1,
      anon_sym_is,
    ACTIONS(2836), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [92725] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6346), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_extends,
    ACTIONS(3139), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [92747] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6352), 1,
      sym_identifier,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    ACTIONS(6356), 1,
      anon_sym_extends,
    ACTIONS(6358), 1,
      anon_sym_implements,
    STATE(2134), 1,
      sym_class_body,
    STATE(3251), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4255), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [92781] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6356), 1,
      anon_sym_extends,
    ACTIONS(6358), 1,
      anon_sym_implements,
    ACTIONS(6360), 1,
      sym_identifier,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    STATE(2420), 1,
      sym_class_body,
    STATE(3280), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4469), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [92815] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6366), 1,
      anon_sym_COLON,
    STATE(3502), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(6364), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [92835] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6346), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_extends,
    ACTIONS(3359), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [92857] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6368), 1,
      anon_sym_AMP,
    ACTIONS(6370), 1,
      anon_sym_PIPE,
    ACTIONS(6372), 1,
      anon_sym_extends,
    ACTIONS(3381), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [92879] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6368), 1,
      anon_sym_AMP,
    ACTIONS(6370), 1,
      anon_sym_PIPE,
    ACTIONS(6372), 1,
      anon_sym_extends,
    ACTIONS(3369), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [92901] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6346), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_extends,
    ACTIONS(3381), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [92923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_AMP,
    ACTIONS(3108), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_extends,
  [92941] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6346), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_extends,
    ACTIONS(3369), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [92963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6376), 1,
      anon_sym_is,
    ACTIONS(2836), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [92981] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_AMP,
    ACTIONS(6378), 1,
      anon_sym_PIPE,
    ACTIONS(6380), 1,
      anon_sym_extends,
    ACTIONS(3381), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
  [93003] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3106), 1,
      anon_sym_PIPE,
    ACTIONS(6368), 1,
      anon_sym_AMP,
    ACTIONS(3108), 8,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [93023] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    ACTIONS(6356), 1,
      anon_sym_extends,
    ACTIONS(6358), 1,
      anon_sym_implements,
    ACTIONS(6382), 1,
      sym_identifier,
    STATE(2134), 1,
      sym_class_body,
    STATE(3251), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4255), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [93057] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5359), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4903), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [93077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6256), 1,
      anon_sym_is,
    ACTIONS(2984), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [93095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 10,
      ts_builtin_sym_end,
      anon_sym_as,
      anon_sym_import,
      anon_sym_else,
      anon_sym_while,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_AT,
      anon_sym_component,
      anon_sym_instance,
  [93111] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    ACTIONS(6356), 1,
      anon_sym_extends,
    ACTIONS(6358), 1,
      anon_sym_implements,
    ACTIONS(6384), 1,
      sym_identifier,
    STATE(2134), 1,
      sym_class_body,
    STATE(3251), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4255), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [93145] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    ACTIONS(6388), 1,
      anon_sym_BANG,
    STATE(3663), 1,
      sym_type_annotation,
    STATE(3979), 1,
      sym__initializer,
    ACTIONS(6390), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(6386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93173] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3106), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_AMP,
    ACTIONS(3108), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [93193] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6388), 1,
      anon_sym_BANG,
    ACTIONS(6392), 1,
      anon_sym_EQ,
    STATE(3585), 1,
      sym__initializer,
    STATE(3663), 1,
      sym_type_annotation,
    ACTIONS(6390), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(6386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93221] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6368), 1,
      anon_sym_AMP,
    ACTIONS(6370), 1,
      anon_sym_PIPE,
    ACTIONS(6372), 1,
      anon_sym_extends,
    ACTIONS(3359), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [93243] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_AMP,
    ACTIONS(6378), 1,
      anon_sym_PIPE,
    ACTIONS(6380), 1,
      anon_sym_extends,
    ACTIONS(3139), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
  [93265] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_AMP,
    ACTIONS(6378), 1,
      anon_sym_PIPE,
    ACTIONS(6380), 1,
      anon_sym_extends,
    ACTIONS(3359), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
  [93287] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6356), 1,
      anon_sym_extends,
    ACTIONS(6358), 1,
      anon_sym_implements,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6394), 1,
      sym_identifier,
    STATE(1782), 1,
      sym_class_body,
    STATE(3285), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4443), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [93321] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_AMP,
    ACTIONS(6378), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_extends,
  [93341] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6366), 1,
      anon_sym_COLON,
    STATE(3495), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(6396), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [93361] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_AMP,
    ACTIONS(6378), 1,
      anon_sym_PIPE,
    ACTIONS(6380), 1,
      anon_sym_extends,
    ACTIONS(3224), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
  [93383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_AMP,
    ACTIONS(3377), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_extends,
  [93401] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    ACTIONS(6356), 1,
      anon_sym_extends,
    ACTIONS(6358), 1,
      anon_sym_implements,
    ACTIONS(6398), 1,
      sym_identifier,
    STATE(2156), 1,
      sym_class_body,
    STATE(3312), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4164), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [93435] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6368), 1,
      anon_sym_AMP,
    ACTIONS(6370), 1,
      anon_sym_PIPE,
    ACTIONS(6372), 1,
      anon_sym_extends,
    ACTIONS(3224), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [93457] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 1,
      anon_sym_extends,
    ACTIONS(6009), 1,
      sym_identifier,
    ACTIONS(6017), 1,
      anon_sym_LT,
    ACTIONS(6019), 1,
      anon_sym_DOT,
    STATE(2752), 1,
      sym_type_arguments,
    ACTIONS(6400), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(2590), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [93485] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6402), 1,
      anon_sym_as,
    STATE(657), 1,
      sym_import_as,
    ACTIONS(2431), 8,
      ts_builtin_sym_end,
      anon_sym_import,
      anon_sym_else,
      anon_sym_while,
      anon_sym_AMP,
      anon_sym_AT,
      anon_sym_component,
      anon_sym_instance,
  [93505] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_PIPE,
    ACTIONS(6368), 1,
      anon_sym_AMP,
    ACTIONS(3377), 8,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [93525] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6368), 1,
      anon_sym_AMP,
    ACTIONS(6370), 1,
      anon_sym_PIPE,
    ACTIONS(6372), 1,
      anon_sym_extends,
    ACTIONS(3139), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [93547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6224), 1,
      sym_identifier,
    ACTIONS(4903), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [93565] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6356), 1,
      anon_sym_extends,
    ACTIONS(6358), 1,
      anon_sym_implements,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6404), 1,
      sym_identifier,
    STATE(1757), 1,
      sym_class_body,
    STATE(3216), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4268), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [93599] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6368), 1,
      anon_sym_AMP,
    ACTIONS(6370), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 8,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [93619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_AMP,
    ACTIONS(3377), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [93639] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6356), 1,
      anon_sym_extends,
    ACTIONS(6358), 1,
      anon_sym_implements,
    ACTIONS(6406), 1,
      sym_identifier,
    ACTIONS(6408), 1,
      anon_sym_LBRACE,
    STATE(1060), 1,
      sym_class_body,
    STATE(3286), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4300), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [93673] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6346), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [93693] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    ACTIONS(6356), 1,
      anon_sym_extends,
    ACTIONS(6358), 1,
      anon_sym_implements,
    ACTIONS(6410), 1,
      sym_identifier,
    STATE(2156), 1,
      sym_class_body,
    STATE(3312), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4164), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [93727] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6019), 1,
      anon_sym_DOT,
    ACTIONS(6412), 1,
      anon_sym_LT,
    ACTIONS(6414), 1,
      anon_sym_is,
    STATE(2752), 1,
      sym_type_arguments,
    ACTIONS(2590), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [93751] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6346), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_extends,
    ACTIONS(3224), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [93773] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_AMP,
    ACTIONS(6378), 1,
      anon_sym_PIPE,
    ACTIONS(6380), 1,
      anon_sym_extends,
    ACTIONS(3369), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_GT,
  [93795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1248), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_is,
  [93811] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    ACTIONS(6356), 1,
      anon_sym_extends,
    ACTIONS(6358), 1,
      anon_sym_implements,
    ACTIONS(6416), 1,
      sym_identifier,
    STATE(2156), 1,
      sym_class_body,
    STATE(3312), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4164), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [93845] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6356), 1,
      anon_sym_extends,
    ACTIONS(6358), 1,
      anon_sym_implements,
    ACTIONS(6408), 1,
      anon_sym_LBRACE,
    ACTIONS(6418), 1,
      sym_identifier,
    STATE(1036), 1,
      sym_class_body,
    STATE(3246), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4434), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [93879] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(3679), 1,
      sym_type_annotation,
    STATE(4079), 1,
      sym__initializer,
    ACTIONS(6156), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(6154), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3139), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [93919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3298), 1,
      anon_sym_LBRACE,
    ACTIONS(3300), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [93936] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5485), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [93961] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(3557), 1,
      sym_type_annotation,
    STATE(4043), 1,
      sym__initializer,
    ACTIONS(6124), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(6122), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [93986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3198), 1,
      anon_sym_LBRACE,
    ACTIONS(3200), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [94003] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(3667), 1,
      anon_sym_LBRACE,
    ACTIONS(3682), 1,
      anon_sym_BQUOTE,
    ACTIONS(3684), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6420), 1,
      anon_sym_DOT,
    STATE(1960), 1,
      sym_new_component_body,
    STATE(2108), 1,
      sym_tagged_type_string,
    STATE(2109), 1,
      sym_tripple_tagged_type_string,
    STATE(3493), 1,
      sym_component_identifier,
  [94034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2740), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94049] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5413), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [94074] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6422), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(676), 1,
      sym_class_body,
    STATE(3294), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4277), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [94105] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5407), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [94130] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(3550), 1,
      sym_type_annotation,
    STATE(4102), 1,
      sym__initializer,
    ACTIONS(6430), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(6428), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94170] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(3564), 1,
      sym_type_annotation,
    STATE(3964), 1,
      sym__initializer,
    ACTIONS(6184), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(6182), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6432), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [94210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6434), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [94225] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5455), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [94250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6436), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [94265] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    ACTIONS(6438), 1,
      anon_sym_LBRACE,
    STATE(176), 1,
      sym_class_body,
    STATE(3223), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4313), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [94296] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(6442), 1,
      anon_sym_PIPE,
    ACTIONS(6444), 1,
      anon_sym_extends,
    ACTIONS(3369), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [94317] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6446), 1,
      anon_sym_COLON,
    STATE(3710), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(6364), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94336] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(2261), 1,
      sym_class_body,
    STATE(3256), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4218), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [94367] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(6442), 1,
      anon_sym_PIPE,
    ACTIONS(6444), 1,
      anon_sym_extends,
    ACTIONS(3381), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [94388] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6446), 1,
      anon_sym_COLON,
    STATE(3712), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(6396), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [94407] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    ACTIONS(6448), 1,
      anon_sym_LBRACE,
    STATE(713), 1,
      sym_class_body,
    STATE(3219), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4318), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [94438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(3377), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [94455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3250), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94470] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6422), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(686), 1,
      sym_class_body,
    STATE(3210), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4321), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [94501] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6346), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_extends,
    ACTIONS(6450), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_PIPE_RBRACE,
  [94522] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    ACTIONS(6438), 1,
      anon_sym_LBRACE,
    STATE(183), 1,
      sym_class_body,
    STATE(3296), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4372), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [94553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3224), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3220), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3200), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94598] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(1868), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3694), 1,
      anon_sym_LBRACE,
    ACTIONS(3704), 1,
      anon_sym_BQUOTE,
    ACTIONS(6420), 1,
      anon_sym_DOT,
    STATE(1721), 1,
      sym_new_component_body,
    STATE(1831), 1,
      sym_tripple_tagged_type_string,
    STATE(1832), 1,
      sym_tagged_type_string,
    STATE(3375), 1,
      sym_component_identifier,
  [94629] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(6442), 1,
      anon_sym_PIPE,
    ACTIONS(6444), 1,
      anon_sym_extends,
    ACTIONS(3224), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [94650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3218), 1,
      anon_sym_LBRACE,
    ACTIONS(3220), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [94667] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6408), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(1023), 1,
      sym_class_body,
    STATE(3259), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4401), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [94698] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    ACTIONS(6448), 1,
      anon_sym_LBRACE,
    STATE(777), 1,
      sym_class_body,
    STATE(3302), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4266), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [94729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3300), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94744] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1930), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3990), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [94769] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6019), 1,
      anon_sym_DOT,
    ACTIONS(6412), 1,
      anon_sym_LT,
    STATE(2752), 1,
      sym_type_arguments,
    ACTIONS(2590), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3204), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94805] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(1868), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3694), 1,
      anon_sym_LBRACE,
    ACTIONS(3704), 1,
      anon_sym_BQUOTE,
    ACTIONS(6019), 1,
      anon_sym_DOT,
    STATE(1721), 1,
      sym_new_component_body,
    STATE(1831), 1,
      sym_tripple_tagged_type_string,
    STATE(1832), 1,
      sym_tagged_type_string,
    STATE(3375), 1,
      sym_component_identifier,
  [94836] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(1868), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3694), 1,
      anon_sym_LBRACE,
    ACTIONS(3704), 1,
      anon_sym_BQUOTE,
    ACTIONS(6138), 1,
      anon_sym_DOT,
    STATE(1721), 1,
      sym_new_component_body,
    STATE(1831), 1,
      sym_tripple_tagged_type_string,
    STATE(1832), 1,
      sym_tagged_type_string,
    STATE(3375), 1,
      sym_component_identifier,
  [94867] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(2396), 1,
      sym_class_body,
    STATE(3314), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4463), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [94898] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5393), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4053), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [94923] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(6442), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
  [94942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3150), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [94957] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(1817), 1,
      sym_class_body,
    STATE(3326), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4488), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [94988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2814), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95003] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1879), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4053), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [95028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3125), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6452), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [95058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3234), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95073] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6454), 1,
      anon_sym_COLON,
    STATE(3495), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(6396), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2984), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3188), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95137] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1926), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [95162] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(2202), 1,
      sym_class_body,
    STATE(3229), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4342), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [95193] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(2197), 1,
      sym_class_body,
    STATE(3267), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4213), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [95224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6456), 1,
      anon_sym_LBRACK,
    ACTIONS(3228), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2836), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3180), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2906), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95286] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3258), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3238), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95316] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6408), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(1031), 1,
      sym_class_body,
    STATE(3224), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4412), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [95347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6458), 9,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [95362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3088), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95377] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6454), 1,
      anon_sym_COLON,
    STATE(3502), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(6364), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95396] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(1739), 1,
      sym_class_body,
    STATE(3257), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4416), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [95427] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(137), 1,
      anon_sym_COMMA,
    ACTIONS(1928), 1,
      anon_sym_RBRACE,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3936), 1,
      aux_sym_object_repeat1,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [95452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2798), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3333), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95482] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(3705), 1,
      sym_type_annotation,
    STATE(3998), 1,
      sym__initializer,
    ACTIONS(6148), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(6146), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3345), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(3108), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [95539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3391), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3100), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3363), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95584] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(6442), 1,
      anon_sym_PIPE,
    ACTIONS(6444), 1,
      anon_sym_extends,
    ACTIONS(3359), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [95605] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6456), 1,
      anon_sym_LBRACK,
    ACTIONS(3228), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(3349), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3323), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6456), 1,
      anon_sym_LBRACK,
    ACTIONS(3315), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95656] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(1877), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6420), 1,
      anon_sym_DOT,
    ACTIONS(6460), 1,
      anon_sym_LBRACE,
    ACTIONS(6462), 1,
      anon_sym_BQUOTE,
    STATE(889), 1,
      sym_new_component_body,
    STATE(1008), 1,
      sym_tripple_tagged_type_string,
    STATE(1012), 1,
      sym_tagged_type_string,
    STATE(3339), 1,
      sym_component_identifier,
  [95687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3311), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95702] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6368), 1,
      anon_sym_AMP,
    ACTIONS(6370), 1,
      anon_sym_PIPE,
    ACTIONS(6372), 1,
      anon_sym_extends,
    ACTIONS(6450), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95723] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(6442), 1,
      anon_sym_PIPE,
    ACTIONS(6444), 1,
      anon_sym_extends,
    ACTIONS(3139), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [95744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3092), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3104), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3254), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95789] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(2251), 1,
      sym_class_body,
    STATE(3250), 1,
      sym_type_parameters,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4274), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [95820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2854), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95835] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6392), 1,
      anon_sym_EQ,
    STATE(3588), 1,
      sym__initializer,
    STATE(3663), 1,
      sym_type_annotation,
    ACTIONS(6390), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(6386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95860] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(3663), 1,
      sym_type_annotation,
    STATE(3981), 1,
      sym__initializer,
    ACTIONS(6390), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(6386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [95885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3284), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3184), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95915] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6412), 1,
      anon_sym_LT,
    STATE(2751), 1,
      sym_type_arguments,
    ACTIONS(2836), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [95933] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6464), 1,
      sym_escape_sequence,
    ACTIONS(6466), 1,
      anon_sym_BQUOTE,
    ACTIONS(6468), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6470), 1,
      sym__template_chars,
    STATE(3452), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3719), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [95957] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3877), 1,
      anon_sym_LPAREN,
    STATE(1513), 1,
      sym_arguments,
    ACTIONS(3304), 6,
      ts_builtin_sym_end,
      anon_sym_import,
      anon_sym_AMP,
      anon_sym_AT,
      anon_sym_component,
      anon_sym_instance,
  [95975] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6346), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_extends,
    ACTIONS(6472), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [95995] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6464), 1,
      sym_escape_sequence,
    ACTIONS(6468), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6470), 1,
      sym__template_chars,
    ACTIONS(6474), 1,
      anon_sym_BQUOTE,
    STATE(3452), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3638), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [96019] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6346), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_PIPE,
    ACTIONS(6350), 1,
      anon_sym_extends,
    ACTIONS(6476), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96039] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6464), 1,
      sym_escape_sequence,
    ACTIONS(6468), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6470), 1,
      sym__template_chars,
    ACTIONS(6478), 1,
      anon_sym_BQUOTE,
    STATE(3452), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3638), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [96063] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_AMP,
    ACTIONS(13), 1,
      anon_sym_AT,
    ACTIONS(6480), 1,
      anon_sym_class,
    ACTIONS(6482), 1,
      anon_sym_abstract,
    ACTIONS(6484), 1,
      anon_sym_component,
    STATE(1469), 1,
      sym_decorator,
    STATE(3325), 1,
      aux_sym_class_repeat1,
    STATE(3750), 1,
      sym_component_short_heritage,
  [96091] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_AMP,
    ACTIONS(13), 1,
      anon_sym_AT,
    ACTIONS(6482), 1,
      anon_sym_abstract,
    ACTIONS(6486), 1,
      anon_sym_class,
    ACTIONS(6488), 1,
      anon_sym_component,
    STATE(1469), 1,
      sym_decorator,
    STATE(3325), 1,
      aux_sym_class_repeat1,
    STATE(3847), 1,
      sym_component_short_heritage,
  [96119] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6490), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_LBRACE,
    ACTIONS(6494), 1,
      anon_sym_LBRACK,
    ACTIONS(6496), 1,
      anon_sym_enum,
    STATE(3726), 1,
      sym_variable_declarator,
    STATE(3304), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [96143] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    ACTIONS(6388), 1,
      anon_sym_BANG,
    STATE(3663), 1,
      sym_type_annotation,
    STATE(3979), 1,
      sym__initializer,
    ACTIONS(6386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96167] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3877), 1,
      anon_sym_LPAREN,
    STATE(1516), 1,
      sym_arguments,
    ACTIONS(3143), 6,
      ts_builtin_sym_end,
      anon_sym_import,
      anon_sym_AMP,
      anon_sym_AT,
      anon_sym_component,
      anon_sym_instance,
  [96185] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_AMP,
    ACTIONS(13), 1,
      anon_sym_AT,
    ACTIONS(6482), 1,
      anon_sym_abstract,
    ACTIONS(6498), 1,
      anon_sym_class,
    ACTIONS(6500), 1,
      anon_sym_component,
    STATE(1469), 1,
      sym_decorator,
    STATE(3325), 1,
      aux_sym_class_repeat1,
    STATE(3854), 1,
      sym_component_short_heritage,
  [96213] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6464), 1,
      sym_escape_sequence,
    ACTIONS(6468), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6470), 1,
      sym__template_chars,
    ACTIONS(6502), 1,
      anon_sym_BQUOTE,
    STATE(3452), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3638), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [96237] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(6442), 1,
      anon_sym_PIPE,
    ACTIONS(6444), 1,
      anon_sym_extends,
    ACTIONS(6450), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96257] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3877), 1,
      anon_sym_LPAREN,
    ACTIONS(6504), 1,
      anon_sym_DOT,
    STATE(1481), 1,
      sym_arguments,
    ACTIONS(4282), 5,
      anon_sym_class,
      anon_sym_AMP,
      anon_sym_AT,
      anon_sym_abstract,
      anon_sym_component,
  [96277] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6464), 1,
      sym_escape_sequence,
    ACTIONS(6468), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6470), 1,
      sym__template_chars,
    ACTIONS(6506), 1,
      anon_sym_BQUOTE,
    STATE(3452), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3638), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [96301] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6422), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(673), 1,
      sym_class_body,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4265), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [96326] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    STATE(3713), 1,
      sym_type_annotation,
    ACTIONS(6508), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4743), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
  [96356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6436), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
  [96369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6510), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [96382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5287), 7,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
  [96395] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(1767), 1,
      sym_class_body,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4420), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [96420] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6512), 1,
      sym_identifier,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    ACTIONS(6516), 1,
      anon_sym_LT,
    STATE(2422), 1,
      sym_component_body,
    STATE(3897), 1,
      sym_component_heritage,
    STATE(4471), 1,
      sym_component_identifier,
  [96445] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6516), 1,
      anon_sym_LT,
    ACTIONS(6518), 1,
      sym_identifier,
    ACTIONS(6520), 1,
      anon_sym_LBRACE,
    STATE(603), 1,
      sym_component_body,
    STATE(3747), 1,
      sym_component_heritage,
    STATE(4165), 1,
      sym_component_identifier,
  [96470] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    ACTIONS(6448), 1,
      anon_sym_LBRACE,
    STATE(804), 1,
      sym_class_body,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4276), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [96495] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6412), 1,
      anon_sym_LT,
    ACTIONS(6522), 1,
      anon_sym_LBRACE,
    ACTIONS(6524), 1,
      anon_sym_COMMA,
    ACTIONS(6526), 1,
      anon_sym_DOT,
    ACTIONS(6528), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3790), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(4137), 1,
      sym_type_arguments,
  [96520] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6516), 1,
      anon_sym_LT,
    ACTIONS(6530), 1,
      sym_identifier,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2292), 1,
      sym_component_body,
    STATE(3851), 1,
      sym_component_heritage,
    STATE(4298), 1,
      sym_component_identifier,
  [96545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6432), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
  [96558] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    ACTIONS(6438), 1,
      anon_sym_LBRACE,
    STATE(177), 1,
      sym_class_body,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4267), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [96583] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(999), 1,
      sym_class_body,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4291), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [96608] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6534), 1,
      sym_identifier,
    ACTIONS(6536), 1,
      anon_sym_STAR,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4167), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [96633] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    STATE(3587), 1,
      sym_type_annotation,
    ACTIONS(6540), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96650] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    ACTIONS(6516), 1,
      anon_sym_LT,
    ACTIONS(6542), 1,
      sym_identifier,
    STATE(1783), 1,
      sym_component_body,
    STATE(3896), 1,
      sym_component_heritage,
    STATE(4446), 1,
      sym_component_identifier,
  [96675] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6544), 1,
      sym_identifier,
    ACTIONS(6546), 1,
      anon_sym_STAR,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4219), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [96700] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(2271), 1,
      sym_class_body,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4378), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [96725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6452), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
  [96738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6458), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
  [96751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4943), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
  [96764] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6548), 1,
      sym_identifier,
    ACTIONS(6550), 1,
      anon_sym_DOT,
    STATE(718), 1,
      sym__module,
    STATE(3611), 1,
      sym_nested_identifier,
    STATE(3852), 1,
      sym_string,
  [96789] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(118), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1138), 1,
      anon_sym_LBRACE,
    ACTIONS(6552), 1,
      anon_sym_LT,
    ACTIONS(6554), 1,
      anon_sym_extends,
    STATE(832), 1,
      sym_object_type,
    STATE(3610), 1,
      sym_type_parameters,
    STATE(3977), 1,
      sym_extends_type_clause,
  [96814] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6516), 1,
      anon_sym_LT,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    ACTIONS(6556), 1,
      sym_identifier,
    STATE(2241), 1,
      sym_component_body,
    STATE(3820), 1,
      sym_component_heritage,
    STATE(4253), 1,
      sym_component_identifier,
  [96839] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6558), 1,
      sym_identifier,
    ACTIONS(6560), 1,
      anon_sym_STAR,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4424), 1,
      sym__call_signature,
  [96864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6562), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [96877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6168), 1,
      anon_sym_is,
    ACTIONS(6564), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96892] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(3673), 1,
      sym_type_annotation,
    STATE(4076), 1,
      sym__initializer,
    ACTIONS(6311), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [96913] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6566), 1,
      sym_identifier,
    ACTIONS(6568), 1,
      anon_sym_STAR,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4405), 1,
      sym__call_signature,
  [96938] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4292), 1,
      sym_statement_block,
    ACTIONS(6572), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96955] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4293), 1,
      sym_statement_block,
    ACTIONS(6574), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [96972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6576), 1,
      anon_sym_EQ,
    ACTIONS(3871), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [96987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6578), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [97000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6580), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [97013] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(1028), 1,
      sym_class_body,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4404), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [97038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4307), 1,
      sym_statement_block,
    ACTIONS(6572), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4903), 7,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_QMARK,
  [97068] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6582), 1,
      anon_sym_COLON,
    ACTIONS(6584), 1,
      anon_sym_QMARK,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4390), 1,
      sym__call_signature,
  [97093] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(2222), 1,
      sym_class_body,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4247), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [97118] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(2303), 1,
      sym_class_body,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4345), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [97143] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(3707), 1,
      sym_type_annotation,
    STATE(3995), 1,
      sym__initializer,
    ACTIONS(6309), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 1,
      anon_sym_BQUOTE,
    ACTIONS(2586), 6,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
  [97179] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4199), 1,
      sym_statement_block,
    ACTIONS(6586), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4323), 1,
      sym_statement_block,
    ACTIONS(6588), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97213] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(2223), 1,
      sym_class_body,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4303), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [97238] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(1805), 1,
      sym_class_body,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4502), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [97263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4351), 1,
      sym_statement_block,
    ACTIONS(6590), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97280] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(1046), 1,
      sym_class_body,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4478), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [97305] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4204), 1,
      sym_statement_block,
    ACTIONS(6592), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4262), 1,
      sym_statement_block,
    ACTIONS(6594), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97339] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5780), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [97356] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4258), 1,
      sym_statement_block,
    ACTIONS(6596), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97373] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(6450), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
  [97392] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4245), 1,
      sym_statement_block,
    ACTIONS(6594), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97409] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4241), 1,
      sym_statement_block,
    ACTIONS(6596), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97426] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(2162), 1,
      sym_class_body,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4200), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [97451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
  [97464] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4206), 1,
      sym_statement_block,
    ACTIONS(6598), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97481] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6283), 1,
      anon_sym_EQ,
    STATE(3862), 1,
      sym_constraint,
    STATE(4344), 1,
      sym_default_type,
    ACTIONS(6281), 2,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(6600), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [97502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6434), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
  [97515] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4334), 1,
      sym_statement_block,
    ACTIONS(6590), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97532] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(3535), 1,
      sym_type_annotation,
    STATE(4105), 1,
      sym__initializer,
    ACTIONS(6602), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [97553] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    STATE(3725), 1,
      sym_type_annotation,
    ACTIONS(6604), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97570] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4333), 1,
      sym_statement_block,
    ACTIONS(6588), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4214), 1,
      sym_statement_block,
    ACTIONS(6606), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4506), 1,
      sym_statement_block,
    ACTIONS(6608), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [97621] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6516), 1,
      anon_sym_LT,
    ACTIONS(6610), 1,
      sym_identifier,
    ACTIONS(6612), 1,
      anon_sym_LBRACE,
    STATE(1027), 1,
      sym_component_body,
    STATE(3861), 1,
      sym_component_heritage,
    STATE(4453), 1,
      sym_component_identifier,
  [97646] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6616), 1,
      anon_sym_COLON,
    ACTIONS(6618), 1,
      anon_sym_EQ,
    ACTIONS(6620), 1,
      anon_sym_QMARK,
    STATE(3859), 1,
      sym_type_annotation,
    STATE(4329), 1,
      sym__initializer,
    ACTIONS(6614), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [97669] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(2474), 1,
      sym_class_body,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4462), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [97694] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6516), 1,
      anon_sym_LT,
    ACTIONS(6622), 1,
      sym_identifier,
    ACTIONS(6624), 1,
      anon_sym_LBRACE,
    STATE(174), 1,
      sym_component_body,
    STATE(3827), 1,
      sym_component_heritage,
    STATE(4359), 1,
      sym_component_identifier,
  [97719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3782), 7,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [97732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6626), 1,
      anon_sym_EQ,
    ACTIONS(3782), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [97747] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6492), 1,
      anon_sym_LBRACE,
    ACTIONS(6494), 1,
      anon_sym_LBRACK,
    ACTIONS(6629), 1,
      sym_identifier,
    STATE(4027), 1,
      sym_variable_declarator,
    STATE(3304), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [97768] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(1819), 1,
      sym_class_body,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4487), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [97793] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(1021), 1,
      sym_class_body,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4403), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [97818] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6552), 1,
      anon_sym_LT,
    ACTIONS(6554), 1,
      anon_sym_extends,
    ACTIONS(6631), 1,
      anon_sym_LBRACE,
    ACTIONS(6633), 1,
      anon_sym_LBRACE_PIPE,
    STATE(832), 1,
      sym_object_type,
    STATE(3696), 1,
      sym_type_parameters,
    STATE(3988), 1,
      sym_extends_type_clause,
  [97843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4290), 7,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_AMP,
      anon_sym_AT,
      anon_sym_abstract,
      anon_sym_component,
  [97856] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_AMP,
    ACTIONS(13), 1,
      anon_sym_AT,
    ACTIONS(6635), 1,
      anon_sym_class,
    ACTIONS(6637), 1,
      anon_sym_component,
    STATE(1469), 1,
      sym_decorator,
    STATE(3325), 1,
      aux_sym_class_repeat1,
    STATE(3844), 1,
      sym_component_short_heritage,
  [97881] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3768), 1,
      anon_sym_DQUOTE,
    ACTIONS(3770), 1,
      anon_sym_SQUOTE,
    ACTIONS(6550), 1,
      anon_sym_DOT,
    ACTIONS(6639), 1,
      sym_identifier,
    STATE(633), 1,
      sym_nested_identifier,
    STATE(702), 1,
      sym_string,
    STATE(718), 1,
      sym__module,
  [97906] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6492), 1,
      anon_sym_LBRACE,
    ACTIONS(6494), 1,
      anon_sym_LBRACK,
    ACTIONS(6629), 1,
      sym_identifier,
    STATE(3863), 1,
      sym_variable_declarator,
    STATE(3304), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [97927] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6492), 1,
      anon_sym_LBRACE,
    ACTIONS(6494), 1,
      anon_sym_LBRACK,
    ACTIONS(6641), 1,
      sym_identifier,
    STATE(3863), 1,
      sym_variable_declarator,
    STATE(3189), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [97948] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6492), 1,
      anon_sym_LBRACE,
    ACTIONS(6494), 1,
      anon_sym_LBRACK,
    ACTIONS(6643), 1,
      sym_identifier,
    STATE(3726), 1,
      sym_variable_declarator,
    STATE(3190), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [97969] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6422), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(680), 1,
      sym_class_body,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4234), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [97994] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6492), 1,
      anon_sym_LBRACE,
    ACTIONS(6494), 1,
      anon_sym_LBRACK,
    ACTIONS(6629), 1,
      sym_identifier,
    STATE(3726), 1,
      sym_variable_declarator,
    STATE(3304), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [98015] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    ACTIONS(6438), 1,
      anon_sym_LBRACE,
    STATE(222), 1,
      sym_class_body,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4279), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [98040] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    ACTIONS(6516), 1,
      anon_sym_LT,
    ACTIONS(6645), 1,
      sym_identifier,
    STATE(1750), 1,
      sym_component_body,
    STATE(3832), 1,
      sym_component_heritage,
    STATE(4270), 1,
      sym_component_identifier,
  [98065] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6647), 1,
      sym_identifier,
    ACTIONS(6649), 1,
      anon_sym_STAR,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4219), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [98090] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6651), 1,
      sym_identifier,
    ACTIONS(6653), 1,
      anon_sym_STAR,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4269), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [98115] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_AMP,
    ACTIONS(13), 1,
      anon_sym_AT,
    ACTIONS(6655), 1,
      anon_sym_class,
    ACTIONS(6657), 1,
      anon_sym_component,
    STATE(1469), 1,
      sym_decorator,
    STATE(3325), 1,
      aux_sym_class_repeat1,
    STATE(3807), 1,
      sym_component_short_heritage,
  [98140] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6659), 1,
      sym_identifier,
    ACTIONS(6661), 1,
      anon_sym_STAR,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4304), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [98165] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    ACTIONS(6448), 1,
      anon_sym_LBRACE,
    STATE(740), 1,
      sym_class_body,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4225), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [98190] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4222), 1,
      sym_statement_block,
    ACTIONS(6663), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98207] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(3663), 1,
      sym_type_annotation,
    STATE(3981), 1,
      sym__initializer,
    ACTIONS(6386), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98228] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6665), 1,
      sym_identifier,
    ACTIONS(6667), 1,
      anon_sym_STAR,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4167), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [98253] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4821), 1,
      anon_sym_LBRACE,
    ACTIONS(4823), 1,
      anon_sym_from,
    ACTIONS(4825), 1,
      anon_sym_DOT,
    ACTIONS(6669), 1,
      sym_identifier,
    ACTIONS(6671), 1,
      anon_sym_STAR,
    STATE(3004), 1,
      sym_import_path_segment,
    STATE(3079), 1,
      sym_import_path,
  [98278] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6673), 1,
      sym_identifier,
    ACTIONS(6675), 1,
      anon_sym_STAR,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4167), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [98303] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6516), 1,
      anon_sym_LT,
    ACTIONS(6624), 1,
      anon_sym_LBRACE,
    ACTIONS(6677), 1,
      sym_identifier,
    STATE(207), 1,
      sym_component_body,
    STATE(3855), 1,
      sym_component_heritage,
    STATE(4423), 1,
      sym_component_identifier,
  [98328] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4224), 1,
      sym_statement_block,
    ACTIONS(6606), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98345] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6516), 1,
      anon_sym_LT,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    ACTIONS(6679), 1,
      sym_identifier,
    STATE(2133), 1,
      sym_component_body,
    STATE(3822), 1,
      sym_component_heritage,
    STATE(4257), 1,
      sym_component_identifier,
  [98370] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2834), 1,
      anon_sym_extends,
    ACTIONS(6681), 1,
      sym_identifier,
    ACTIONS(6683), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(2836), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [98389] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(2258), 1,
      sym_class_body,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4320), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [98414] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_AMP,
    ACTIONS(13), 1,
      anon_sym_AT,
    ACTIONS(6685), 1,
      anon_sym_class,
    ACTIONS(6687), 1,
      anon_sym_component,
    STATE(1469), 1,
      sym_decorator,
    STATE(3325), 1,
      aux_sym_class_repeat1,
    STATE(3770), 1,
      sym_component_short_heritage,
  [98439] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(2475), 1,
      sym_class_body,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4389), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [98464] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_AMP,
    ACTIONS(6378), 1,
      anon_sym_PIPE,
    ACTIONS(6380), 1,
      anon_sym_extends,
    ACTIONS(6450), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [98483] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6516), 1,
      anon_sym_LT,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    ACTIONS(6689), 1,
      sym_identifier,
    STATE(2187), 1,
      sym_component_body,
    STATE(3759), 1,
      sym_component_heritage,
    STATE(4170), 1,
      sym_component_identifier,
  [98508] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4407), 1,
      sym_statement_block,
    ACTIONS(6691), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98525] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4353), 1,
      sym_statement_block,
    ACTIONS(6693), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98542] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(3523), 1,
      sym_type_annotation,
    STATE(4037), 1,
      sym__initializer,
    ACTIONS(6298), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98563] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(3606), 1,
      sym_type_annotation,
    STATE(4093), 1,
      sym__initializer,
    ACTIONS(6319), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6414), 1,
      anon_sym_is,
    ACTIONS(2984), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [98599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6695), 1,
      anon_sym_is,
    ACTIONS(2836), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [98614] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(3556), 1,
      sym_type_annotation,
    STATE(3967), 1,
      sym__initializer,
    ACTIONS(6317), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [98635] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4409), 1,
      sym_statement_block,
    ACTIONS(6693), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98652] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6697), 1,
      anon_sym_AT,
    STATE(1469), 1,
      sym_decorator,
    STATE(3325), 1,
      aux_sym_class_repeat1,
    ACTIONS(4266), 4,
      anon_sym_class,
      anon_sym_AMP,
      anon_sym_abstract,
      anon_sym_component,
  [98671] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    ACTIONS(6424), 1,
      anon_sym_extends,
    ACTIONS(6426), 1,
      anon_sym_implements,
    STATE(1840), 1,
      sym_class_body,
    STATE(3954), 1,
      sym_extends_clause,
    STATE(4396), 1,
      sym_class_heritage,
    STATE(4724), 1,
      sym_implements_clause,
  [98696] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6700), 1,
      sym_identifier,
    ACTIONS(6702), 1,
      anon_sym_STAR,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4219), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [98721] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4309), 1,
      sym_statement_block,
    ACTIONS(6574), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98738] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6516), 1,
      anon_sym_LT,
    ACTIONS(6520), 1,
      anon_sym_LBRACE,
    ACTIONS(6704), 1,
      sym_identifier,
    STATE(621), 1,
      sym_component_body,
    STATE(3784), 1,
      sym_component_heritage,
    STATE(4196), 1,
      sym_component_identifier,
  [98763] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6516), 1,
      anon_sym_LT,
    ACTIONS(6612), 1,
      anon_sym_LBRACE,
    ACTIONS(6706), 1,
      sym_identifier,
    STATE(983), 1,
      sym_component_body,
    STATE(3801), 1,
      sym_component_heritage,
    STATE(4312), 1,
      sym_component_identifier,
  [98788] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    STATE(3622), 1,
      sym_type_annotation,
    ACTIONS(6708), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [98805] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6584), 1,
      anon_sym_QMARK,
    ACTIONS(6710), 1,
      anon_sym_COLON,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4390), 1,
      sym__call_signature,
  [98830] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6715), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6718), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6712), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3333), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [98848] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    ACTIONS(6720), 1,
      anon_sym_QMARK,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3428), 1,
      sym__call_signature,
    STATE(4162), 1,
      sym_type_parameters,
  [98870] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6722), 1,
      sym_identifier,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4220), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [98892] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6724), 1,
      sym_identifier,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4470), 1,
      sym__call_signature,
  [98914] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_AMP,
    ACTIONS(13), 1,
      anon_sym_AT,
    ACTIONS(6484), 1,
      anon_sym_component,
    STATE(1469), 1,
      sym_decorator,
    STATE(3325), 1,
      aux_sym_class_repeat1,
    STATE(3750), 1,
      sym_component_short_heritage,
  [98936] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6726), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6728), 1,
      anon_sym_QMARK_COLON,
    STATE(3619), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [98954] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1877), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6460), 1,
      anon_sym_LBRACE,
    ACTIONS(6462), 1,
      anon_sym_BQUOTE,
    STATE(950), 1,
      sym_new_component_body,
    STATE(984), 1,
      sym_tripple_tagged_type_string,
    STATE(985), 1,
      sym_tagged_type_string,
  [98976] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6732), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6734), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6730), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3421), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [98994] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6738), 1,
      anon_sym_BQUOTE,
    ACTIONS(6740), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6736), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3420), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [99012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6256), 1,
      anon_sym_is,
    ACTIONS(6564), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6510), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [99038] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6740), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6744), 1,
      anon_sym_BQUOTE,
    ACTIONS(6742), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3412), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [99056] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6516), 1,
      anon_sym_LT,
    ACTIONS(6520), 1,
      anon_sym_LBRACE,
    STATE(612), 1,
      sym_component_body,
    STATE(3782), 1,
      sym_component_heritage,
    STATE(4191), 1,
      sym_component_identifier,
  [99078] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6746), 1,
      anon_sym_QMARK,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3590), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
  [99100] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3404), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6750), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6748), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99116] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3430), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6754), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6752), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6756), 6,
      ts_builtin_sym_end,
      anon_sym_import,
      anon_sym_AMP,
      anon_sym_AT,
      anon_sym_component,
      anon_sym_instance,
  [99144] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6758), 1,
      anon_sym_QMARK,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4306), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [99166] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(6760), 1,
      anon_sym_COMMA,
    ACTIONS(6762), 1,
      anon_sym_GT,
    STATE(4032), 1,
      aux_sym_implements_clause_repeat1,
  [99188] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6516), 1,
      anon_sym_LT,
    ACTIONS(6624), 1,
      anon_sym_LBRACE,
    STATE(187), 1,
      sym_component_body,
    STATE(3802), 1,
      sym_component_heritage,
    STATE(4311), 1,
      sym_component_identifier,
  [99210] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6740), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6766), 1,
      anon_sym_BQUOTE,
    ACTIONS(6764), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3364), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [99228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3429), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6770), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6768), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6562), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [99256] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6772), 1,
      anon_sym_QMARK,
    STATE(3073), 1,
      sym_formal_parameters,
    STATE(3303), 1,
      sym__call_signature,
    STATE(4208), 1,
      sym_type_parameters,
  [99278] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6774), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(3359), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [99296] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6780), 1,
      sym_identifier,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4317), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [99318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6774), 1,
      anon_sym_AMP,
    ACTIONS(3108), 5,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [99332] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6726), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6728), 1,
      anon_sym_QMARK_COLON,
    STATE(3561), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [99350] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_LBRACE,
    STATE(2568), 1,
      sym_statement_block,
    ACTIONS(6594), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99366] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6784), 1,
      sym_identifier,
    ACTIONS(6786), 1,
      anon_sym_import,
    STATE(2896), 1,
      sym__type_query_subscript_expression,
    STATE(2899), 1,
      sym__type_query_member_expression,
    STATE(3012), 1,
      sym__type_query_call_expression,
    STATE(4185), 1,
      sym_import,
  [99388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6580), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [99400] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6740), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6790), 1,
      anon_sym_BQUOTE,
    ACTIONS(6788), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3471), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [99418] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6516), 1,
      anon_sym_LT,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2209), 1,
      sym_component_body,
    STATE(3811), 1,
      sym_component_heritage,
    STATE(4229), 1,
      sym_component_identifier,
  [99440] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_import,
    ACTIONS(6792), 1,
      sym_identifier,
    STATE(1622), 1,
      sym__type_query_subscript_expression,
    STATE(1623), 1,
      sym__type_query_member_expression,
    STATE(1723), 1,
      sym__type_query_call_expression,
    STATE(4216), 1,
      sym_import,
  [99462] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_import,
    ACTIONS(6794), 1,
      sym_identifier,
    STATE(2701), 1,
      sym__type_query_member_expression,
    STATE(2702), 1,
      sym__type_query_subscript_expression,
    STATE(2740), 1,
      sym__type_query_call_expression,
    STATE(4233), 1,
      sym_import,
  [99484] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6796), 1,
      anon_sym_QMARK,
    STATE(3073), 1,
      sym_formal_parameters,
    STATE(3258), 1,
      sym__call_signature,
    STATE(4208), 1,
      sym_type_parameters,
  [99506] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6726), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6728), 1,
      anon_sym_QMARK_COLON,
    STATE(3563), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [99524] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_import,
    ACTIONS(6798), 1,
      sym_identifier,
    STATE(2766), 1,
      sym__type_query_subscript_expression,
    STATE(2768), 1,
      sym__type_query_member_expression,
    STATE(2891), 1,
      sym__type_query_call_expression,
    STATE(4160), 1,
      sym_import,
  [99546] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_LBRACE,
    STATE(2595), 1,
      sym_statement_block,
    ACTIONS(6586), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99562] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6516), 1,
      anon_sym_LT,
    ACTIONS(6520), 1,
      anon_sym_LBRACE,
    STATE(593), 1,
      sym_component_body,
    STATE(3815), 1,
      sym_component_heritage,
    STATE(4250), 1,
      sym_component_identifier,
  [99584] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6740), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6802), 1,
      anon_sym_BQUOTE,
    ACTIONS(6800), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3454), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [99602] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6732), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6806), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6804), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3455), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [99620] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1868), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3694), 1,
      anon_sym_LBRACE,
    ACTIONS(3704), 1,
      anon_sym_BQUOTE,
    STATE(1726), 1,
      sym_new_component_body,
    STATE(1798), 1,
      sym_tripple_tagged_type_string,
    STATE(1799), 1,
      sym_tagged_type_string,
  [99642] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3436), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4518), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6808), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99658] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_AMP,
    ACTIONS(6378), 1,
      anon_sym_PIPE,
    ACTIONS(6380), 1,
      anon_sym_extends,
    ACTIONS(6810), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_GT,
  [99676] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3443), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4536), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6812), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5801), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4903), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [99706] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(6814), 1,
      anon_sym_COMMA,
    ACTIONS(6816), 1,
      anon_sym_GT,
    STATE(4148), 1,
      aux_sym_implements_clause_repeat1,
  [99728] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3439), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4544), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6818), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99744] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6820), 1,
      anon_sym_QMARK,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4408), 1,
      sym__call_signature,
  [99766] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_LBRACE,
    STATE(2592), 1,
      sym_statement_block,
    ACTIONS(6592), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_LBRACE,
    STATE(2591), 1,
      sym_statement_block,
    ACTIONS(6598), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99798] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_LBRACE,
    STATE(2588), 1,
      sym_statement_block,
    ACTIONS(6606), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_LBRACE,
    STATE(2587), 1,
      sym_statement_block,
    ACTIONS(6663), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99830] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_LBRACE,
    STATE(2583), 1,
      sym_statement_block,
    ACTIONS(6606), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99846] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6822), 1,
      sym_identifier,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4317), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [99868] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6740), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6824), 1,
      anon_sym_BQUOTE,
    ACTIONS(6464), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3452), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [99886] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6826), 1,
      anon_sym_RBRACE,
    ACTIONS(6828), 1,
      anon_sym_case,
    ACTIONS(6830), 1,
      anon_sym_default,
    STATE(3463), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [99904] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_LBRACE,
    STATE(2577), 1,
      sym_statement_block,
    ACTIONS(6596), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99920] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6832), 1,
      anon_sym_QMARK,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4221), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [99942] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_LBRACE,
    STATE(2576), 1,
      sym_statement_block,
    ACTIONS(6594), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99958] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3509), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6836), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6834), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99974] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_LBRACE,
    STATE(2567), 1,
      sym_statement_block,
    ACTIONS(6596), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [99990] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3443), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4534), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6838), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6140), 1,
      anon_sym_is,
    ACTIONS(6564), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [100020] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3378), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4534), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6838), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100036] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6840), 1,
      anon_sym_QMARK,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3567), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
  [100058] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(6842), 1,
      anon_sym_COMMA,
    ACTIONS(6844), 1,
      anon_sym_GT,
    STATE(4066), 1,
      aux_sym_implements_clause_repeat1,
  [100080] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(6846), 1,
      anon_sym_COMMA,
    ACTIONS(6848), 1,
      anon_sym_GT,
    STATE(3972), 1,
      aux_sym_implements_clause_repeat1,
  [100102] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_LBRACE,
    STATE(2569), 1,
      sym_statement_block,
    ACTIONS(6572), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100118] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6850), 1,
      sym_identifier,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4220), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [100140] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3443), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4518), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6808), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100156] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_LBRACE,
    STATE(2571), 1,
      sym_statement_block,
    ACTIONS(6574), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100172] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3768), 1,
      anon_sym_DQUOTE,
    ACTIONS(3770), 1,
      anon_sym_SQUOTE,
    ACTIONS(6639), 1,
      sym_identifier,
    STATE(633), 1,
      sym_nested_identifier,
    STATE(702), 1,
      sym_string,
    STATE(723), 1,
      sym__module,
  [100194] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(6854), 1,
      anon_sym_QMARK,
    ACTIONS(6852), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [100214] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    ACTIONS(6856), 1,
      anon_sym_QMARK,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3383), 1,
      sym__call_signature,
    STATE(4162), 1,
      sym_type_parameters,
  [100236] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6858), 1,
      anon_sym_QMARK,
    STATE(3073), 1,
      sym_formal_parameters,
    STATE(3247), 1,
      sym__call_signature,
    STATE(4208), 1,
      sym_type_parameters,
  [100258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_LBRACE,
    STATE(2573), 1,
      sym_statement_block,
    ACTIONS(6572), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_LBRACE,
    STATE(2574), 1,
      sym_statement_block,
    ACTIONS(6574), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100290] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6740), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6860), 1,
      anon_sym_BQUOTE,
    ACTIONS(6788), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3471), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [100308] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6516), 1,
      anon_sym_LT,
    ACTIONS(6612), 1,
      anon_sym_LBRACE,
    STATE(996), 1,
      sym_component_body,
    STATE(3849), 1,
      sym_component_heritage,
    STATE(4419), 1,
      sym_component_identifier,
  [100330] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6516), 1,
      anon_sym_LT,
    ACTIONS(6624), 1,
      anon_sym_LBRACE,
    STATE(219), 1,
      sym_component_body,
    STATE(3828), 1,
      sym_component_heritage,
    STATE(4363), 1,
      sym_component_identifier,
  [100352] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6740), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6864), 1,
      anon_sym_BQUOTE,
    ACTIONS(6862), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3499), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [100370] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    ACTIONS(6516), 1,
      anon_sym_LT,
    STATE(2472), 1,
      sym_component_body,
    STATE(3867), 1,
      sym_component_heritage,
    STATE(4460), 1,
      sym_component_identifier,
  [100392] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6732), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6868), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6866), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3498), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [100410] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    ACTIONS(6870), 1,
      anon_sym_QMARK,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3386), 1,
      sym__call_signature,
    STATE(4162), 1,
      sym_type_parameters,
  [100432] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6011), 1,
      anon_sym_LBRACE,
    ACTIONS(6021), 1,
      anon_sym_BQUOTE,
    ACTIONS(6023), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(1532), 1,
      sym_new_component_body,
    STATE(1566), 1,
      sym_tagged_type_string,
    STATE(1568), 1,
      sym_tripple_tagged_type_string,
  [100454] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6740), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6872), 1,
      anon_sym_BQUOTE,
    ACTIONS(6788), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3471), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [100472] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6732), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6876), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6874), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3333), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [100490] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_LBRACE,
    STATE(2584), 1,
      sym_statement_block,
    ACTIONS(6588), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100506] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6878), 1,
      anon_sym_QMARK,
    STATE(3073), 1,
      sym_formal_parameters,
    STATE(3260), 1,
      sym__call_signature,
    STATE(4208), 1,
      sym_type_parameters,
  [100528] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_LBRACE,
    STATE(2585), 1,
      sym_statement_block,
    ACTIONS(6590), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100544] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3396), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6882), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6880), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100560] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3485), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4542), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6884), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100576] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    ACTIONS(6886), 1,
      anon_sym_QMARK,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3395), 1,
      sym__call_signature,
    STATE(4162), 1,
      sym_type_parameters,
  [100598] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_LBRACE,
    STATE(2589), 1,
      sym_statement_block,
    ACTIONS(6590), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100614] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3443), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4542), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6884), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3443), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4544), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6818), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100646] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_LBRACE,
    STATE(2590), 1,
      sym_statement_block,
    ACTIONS(6588), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100662] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6516), 1,
      anon_sym_LT,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2195), 1,
      sym_component_body,
    STATE(3796), 1,
      sym_component_heritage,
    STATE(4210), 1,
      sym_component_identifier,
  [100684] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6412), 1,
      anon_sym_LT,
    ACTIONS(6526), 1,
      anon_sym_DOT,
    ACTIONS(6888), 1,
      anon_sym_LBRACE,
    STATE(4137), 1,
      sym_type_arguments,
    ACTIONS(6890), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [100704] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6516), 1,
      anon_sym_LT,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2308), 1,
      sym_component_body,
    STATE(3865), 1,
      sym_component_heritage,
    STATE(4346), 1,
      sym_component_identifier,
  [100726] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6892), 1,
      anon_sym_QMARK,
    STATE(3073), 1,
      sym_formal_parameters,
    STATE(3324), 1,
      sym__call_signature,
    STATE(4208), 1,
      sym_type_parameters,
  [100748] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3443), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4526), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6894), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100764] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(6896), 1,
      sym_identifier,
    ACTIONS(6898), 1,
      anon_sym_LBRACK,
    STATE(4282), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [100782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3443), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4520), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6900), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100798] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3443), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4522), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6902), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100814] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(6904), 1,
      anon_sym_COMMA,
    ACTIONS(6906), 1,
      anon_sym_GT,
    STATE(3908), 1,
      aux_sym_implements_clause_repeat1,
  [100836] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6908), 1,
      anon_sym_QMARK,
    STATE(3073), 1,
      sym_formal_parameters,
    STATE(3263), 1,
      sym__call_signature,
    STATE(4208), 1,
      sym_type_parameters,
  [100858] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6910), 1,
      anon_sym_QMARK,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(4045), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
  [100880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3443), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6915), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6912), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100896] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    ACTIONS(6917), 1,
      anon_sym_QMARK,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3410), 1,
      sym__call_signature,
    STATE(4162), 1,
      sym_type_parameters,
  [100918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_LBRACE,
    STATE(2586), 1,
      sym_statement_block,
    ACTIONS(6691), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100934] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_LBRACE,
    STATE(2594), 1,
      sym_statement_block,
    ACTIONS(6693), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [100950] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6919), 1,
      anon_sym_QMARK,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3650), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
  [100972] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6578), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [100984] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_import,
    ACTIONS(6921), 1,
      sym_identifier,
    STATE(1856), 1,
      sym__type_query_subscript_expression,
    STATE(1858), 1,
      sym__type_query_member_expression,
    STATE(1945), 1,
      sym__type_query_call_expression,
    STATE(4331), 1,
      sym_import,
  [101006] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6923), 1,
      sym_identifier,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4425), 1,
      sym__call_signature,
  [101028] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6774), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(3133), 4,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
  [101044] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6740), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6925), 1,
      anon_sym_BQUOTE,
    ACTIONS(6788), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3471), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [101062] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    ACTIONS(6516), 1,
      anon_sym_LT,
    STATE(1775), 1,
      sym_component_body,
    STATE(3901), 1,
      sym_component_heritage,
    STATE(4430), 1,
      sym_component_identifier,
  [101084] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6740), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6927), 1,
      anon_sym_BQUOTE,
    ACTIONS(6788), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3471), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [101102] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6732), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6929), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6874), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3333), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [101120] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(6898), 1,
      anon_sym_LBRACK,
    ACTIONS(6931), 1,
      sym_identifier,
    STATE(3956), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [101138] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6933), 1,
      anon_sym_QMARK,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3711), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
  [101160] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6726), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6728), 1,
      anon_sym_QMARK_COLON,
    STATE(3703), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [101178] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6516), 1,
      anon_sym_LT,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2247), 1,
      sym_component_body,
    STATE(3826), 1,
      sym_component_heritage,
    STATE(4264), 1,
      sym_component_identifier,
  [101200] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6935), 1,
      sym_identifier,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4317), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [101222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3443), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4528), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6937), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101238] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6774), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(3369), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [101256] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6828), 1,
      anon_sym_case,
    ACTIONS(6830), 1,
      anon_sym_default,
    ACTIONS(6939), 1,
      anon_sym_RBRACE,
    STATE(3466), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [101274] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    ACTIONS(6516), 1,
      anon_sym_LT,
    STATE(1820), 1,
      sym_component_body,
    STATE(3727), 1,
      sym_component_heritage,
    STATE(4485), 1,
      sym_component_identifier,
  [101296] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    ACTIONS(6548), 1,
      sym_identifier,
    STATE(723), 1,
      sym__module,
    STATE(3611), 1,
      sym_nested_identifier,
    STATE(3852), 1,
      sym_string,
  [101318] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 1,
      anon_sym_RBRACE,
    ACTIONS(6943), 1,
      anon_sym_case,
    ACTIONS(6946), 1,
      anon_sym_default,
    STATE(3466), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [101336] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(6898), 1,
      anon_sym_LBRACK,
    ACTIONS(6949), 1,
      sym_identifier,
    STATE(3795), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [101354] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6774), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(3381), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [101372] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3443), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4514), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6951), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101388] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6953), 1,
      anon_sym_QMARK,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4254), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [101410] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6718), 1,
      anon_sym_BQUOTE,
    ACTIONS(6958), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6955), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3471), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [101428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3443), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4510), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6961), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101444] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3438), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4510), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6961), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101460] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6732), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6963), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6874), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3333), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [101478] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6740), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6965), 1,
      anon_sym_BQUOTE,
    ACTIONS(6788), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3471), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [101496] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6967), 1,
      sym_identifier,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4498), 1,
      sym__call_signature,
  [101518] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(6969), 1,
      anon_sym_COMMA,
    ACTIONS(6971), 1,
      anon_sym_GT,
    STATE(4099), 1,
      aux_sym_implements_clause_repeat1,
  [101540] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_AMP,
    ACTIONS(6378), 1,
      anon_sym_PIPE,
    ACTIONS(6380), 1,
      anon_sym_extends,
    ACTIONS(6973), 1,
      anon_sym_LBRACE,
    ACTIONS(6975), 1,
      anon_sym_COMMA,
    STATE(3938), 1,
      aux_sym_implements_clause_repeat1,
  [101562] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6977), 1,
      anon_sym_QMARK,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4350), 1,
      sym__call_signature,
  [101584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3472), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6981), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6979), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101600] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6983), 1,
      anon_sym_QMARK,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3666), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
  [101622] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3443), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4524), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6985), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101638] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6516), 1,
      anon_sym_LT,
    ACTIONS(6612), 1,
      anon_sym_LBRACE,
    STATE(1026), 1,
      sym_component_body,
    STATE(3895), 1,
      sym_component_heritage,
    STATE(4400), 1,
      sym_component_identifier,
  [101660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3469), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4524), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6985), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101676] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3443), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4498), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6987), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101692] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(6989), 1,
      anon_sym_COMMA,
    ACTIONS(6991), 1,
      anon_sym_GT,
    STATE(3971), 1,
      aux_sym_implements_clause_repeat1,
  [101714] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6726), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6728), 1,
      anon_sym_QMARK_COLON,
    STATE(3689), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [101732] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6993), 1,
      anon_sym_QMARK,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4511), 1,
      sym__call_signature,
  [101754] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6726), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6728), 1,
      anon_sym_QMARK_COLON,
    STATE(3715), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [101772] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    ACTIONS(6995), 1,
      anon_sym_QMARK,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3491), 1,
      sym__call_signature,
    STATE(4162), 1,
      sym_type_parameters,
  [101794] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_LBRACE,
    STATE(2598), 1,
      sym_statement_block,
    ACTIONS(6693), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [101810] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(6997), 1,
      anon_sym_QMARK,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3999), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
  [101832] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3667), 1,
      anon_sym_LBRACE,
    ACTIONS(3682), 1,
      anon_sym_BQUOTE,
    ACTIONS(3684), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(2063), 1,
      sym_new_component_body,
    STATE(2129), 1,
      sym_tagged_type_string,
    STATE(2137), 1,
      sym_tripple_tagged_type_string,
  [101854] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(6999), 1,
      sym_identifier,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4406), 1,
      sym__call_signature,
  [101876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7001), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101888] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6732), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7005), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(7003), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3474), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [101906] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6740), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7009), 1,
      anon_sym_BQUOTE,
    ACTIONS(7007), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3475), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [101924] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6732), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7011), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6874), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3333), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [101942] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6740), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7013), 1,
      anon_sym_BQUOTE,
    ACTIONS(6788), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3471), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [101960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7015), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [101972] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6412), 1,
      anon_sym_LT,
    ACTIONS(6524), 1,
      anon_sym_COMMA,
    ACTIONS(7017), 1,
      anon_sym_LBRACE,
    ACTIONS(7019), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3788), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(4144), 1,
      sym_type_arguments,
  [101994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7021), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102006] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3482), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(7025), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7023), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102022] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6616), 1,
      anon_sym_COLON,
    ACTIONS(6618), 1,
      anon_sym_EQ,
    STATE(3898), 1,
      sym_type_annotation,
    STATE(4467), 1,
      sym__initializer,
    ACTIONS(7027), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [102042] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6782), 1,
      anon_sym_LBRACE,
    STATE(2582), 1,
      sym_statement_block,
    ACTIONS(6608), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102058] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6774), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(3224), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [102076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6774), 1,
      anon_sym_AMP,
    ACTIONS(3377), 5,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [102090] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4127), 1,
      anon_sym_LBRACE,
    ACTIONS(6898), 1,
      anon_sym_LBRACK,
    ACTIONS(7029), 1,
      sym_identifier,
    STATE(4055), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [102108] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3443), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4546), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102124] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7033), 1,
      anon_sym_catch,
    ACTIONS(7035), 1,
      anon_sym_finally,
    STATE(853), 1,
      sym_finally_clause,
    STATE(3839), 1,
      sym_catch_clause,
    ACTIONS(2323), 2,
      anon_sym_else,
      anon_sym_while,
  [102144] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_import,
    ACTIONS(7037), 1,
      sym_identifier,
    STATE(788), 1,
      sym__type_query_member_expression,
    STATE(794), 1,
      sym__type_query_subscript_expression,
    STATE(957), 1,
      sym__type_query_call_expression,
    STATE(4479), 1,
      sym_import,
  [102166] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6726), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6728), 1,
      anon_sym_QMARK_COLON,
    STATE(3568), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [102184] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3461), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(4546), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(7031), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102200] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    ACTIONS(7039), 1,
      anon_sym_QMARK,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3583), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
  [102222] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6726), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6728), 1,
      anon_sym_QMARK_COLON,
    STATE(3613), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [102240] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6774), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(3139), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [102258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6564), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102270] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    ACTIONS(7041), 1,
      sym_identifier,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4220), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [102292] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(6726), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6728), 1,
      anon_sym_QMARK_COLON,
    STATE(3616), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [102310] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3639), 1,
      sym__call_signature,
    STATE(4162), 1,
      sym_type_parameters,
  [102329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6594), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102340] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    ACTIONS(6616), 1,
      anon_sym_COLON,
    STATE(1550), 1,
      sym_statement_block,
    STATE(4153), 1,
      sym_typed_function_return_type,
    STATE(4514), 1,
      sym_type_annotation,
  [102359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(4074), 1,
      sym__initializer,
    ACTIONS(7043), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6606), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102385] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4352), 1,
      sym__call_signature,
  [102404] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7045), 1,
      anon_sym_BQUOTE,
    ACTIONS(7047), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7050), 1,
      sym__template_chars,
    STATE(3526), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [102421] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6052), 1,
      anon_sym_LBRACK,
    ACTIONS(7053), 1,
      anon_sym_RBRACE,
    ACTIONS(3228), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [102436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7055), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_extends,
      anon_sym_implements,
  [102447] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_LBRACE,
    ACTIONS(7057), 1,
      anon_sym_COLON,
    STATE(4287), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [102462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_EQ,
    ACTIONS(3782), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [102475] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6346), 1,
      anon_sym_AMP,
    ACTIONS(6350), 1,
      anon_sym_extends,
    ACTIONS(7064), 1,
      anon_sym_PIPE,
    ACTIONS(7062), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [102492] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4261), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [102511] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7066), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [102528] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6618), 1,
      anon_sym_EQ,
    ACTIONS(7068), 1,
      anon_sym_COMMA,
    ACTIONS(7070), 1,
      anon_sym_RBRACE,
    STATE(4064), 1,
      aux_sym_enum_body_repeat1,
    STATE(4271), 1,
      sym__initializer,
  [102547] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(4115), 1,
      sym__initializer,
    ACTIONS(7072), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5318), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [102573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4943), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_EQ,
  [102584] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7074), 1,
      sym_identifier,
    ACTIONS(7076), 1,
      anon_sym_RPAREN,
    STATE(4413), 1,
      sym_formal_type_parameter,
    STATE(4365), 2,
      sym_required_type_parameter,
      sym_optional_type_parameter,
  [102601] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    STATE(3073), 1,
      sym_formal_parameters,
    STATE(3309), 1,
      sym__call_signature,
    STATE(4208), 1,
      sym_type_parameters,
  [102620] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7078), 1,
      anon_sym_COLON,
    ACTIONS(7080), 1,
      anon_sym_EQ_GT,
    STATE(4440), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [102635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_EQ,
  [102646] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4903), 1,
      anon_sym_COLON,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5449), 1,
      anon_sym_COMMA,
    ACTIONS(7083), 1,
      anon_sym_RBRACE,
    STATE(3933), 1,
      aux_sym_object_pattern_repeat1,
  [102665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5203), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [102676] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7085), 1,
      anon_sym_LBRACE,
    ACTIONS(7087), 1,
      anon_sym_SEMI,
    ACTIONS(7089), 1,
      sym__automatic_semicolon,
    ACTIONS(7091), 1,
      sym__function_signature_automatic_semicolon,
    STATE(674), 1,
      sym_statement_block,
  [102695] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7078), 1,
      anon_sym_COLON,
    ACTIONS(7093), 1,
      anon_sym_EQ_GT,
    STATE(4287), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [102710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3725), 1,
      anon_sym_COLON,
    STATE(4339), 1,
      sym_type_annotation,
    ACTIONS(3782), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
  [102725] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4278), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [102744] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4497), 1,
      sym__call_signature,
  [102763] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3648), 1,
      sym__call_signature,
    STATE(4162), 1,
      sym_type_parameters,
  [102782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(4111), 1,
      sym__initializer,
    ACTIONS(7096), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102797] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7098), 1,
      anon_sym_LBRACE,
    ACTIONS(7100), 1,
      anon_sym_SEMI,
    ACTIONS(7102), 1,
      sym__automatic_semicolon,
    ACTIONS(7104), 1,
      sym__function_signature_automatic_semicolon,
    STATE(201), 1,
      sym_statement_block,
  [102816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7106), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102827] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(4081), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
  [102846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7108), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6608), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102868] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(4007), 1,
      sym__initializer,
    ACTIONS(7110), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102883] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(4078), 1,
      sym__initializer,
    ACTIONS(7112), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6364), 1,
      anon_sym_LBRACE,
    ACTIONS(7057), 1,
      anon_sym_COLON,
    STATE(4440), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [102913] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 1,
      anon_sym_BQUOTE,
    ACTIONS(7116), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7118), 1,
      sym__template_chars,
    STATE(3577), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [102930] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3608), 1,
      sym__call_signature,
    STATE(4162), 1,
      sym_type_parameters,
  [102949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7120), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102960] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7078), 1,
      anon_sym_COLON,
    ACTIONS(7122), 1,
      anon_sym_EQ_GT,
    STATE(4440), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [102975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7125), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [102986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(3997), 1,
      sym__initializer,
    ACTIONS(7127), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103001] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4496), 1,
      sym__call_signature,
  [103020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6663), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7129), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6606), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103064] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6364), 1,
      anon_sym_EQ_GT,
    ACTIONS(7078), 1,
      anon_sym_COLON,
    STATE(4440), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [103079] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3688), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
  [103098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6574), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103109] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3624), 1,
      sym__call_signature,
    STATE(4162), 1,
      sym_type_parameters,
  [103128] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4507), 1,
      sym__call_signature,
  [103147] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    ACTIONS(7131), 1,
      sym_identifier,
    ACTIONS(7133), 1,
      anon_sym_LBRACK,
    ACTIONS(7135), 1,
      sym_private_property_identifier,
    STATE(1778), 1,
      sym_arguments,
  [103166] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3431), 1,
      sym__call_signature,
    STATE(4162), 1,
      sym_type_parameters,
  [103185] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7137), 1,
      anon_sym_BQUOTE,
    ACTIONS(7139), 1,
      sym__template_chars,
    STATE(3526), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [103202] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4242), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [103221] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6346), 1,
      anon_sym_AMP,
    ACTIONS(6350), 1,
      anon_sym_extends,
    ACTIONS(7064), 1,
      anon_sym_PIPE,
    ACTIONS(7141), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103238] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4903), 1,
      anon_sym_COLON,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(5449), 1,
      anon_sym_COMMA,
    ACTIONS(7143), 1,
      anon_sym_RBRACE,
    STATE(3989), 1,
      aux_sym_object_pattern_repeat1,
  [103257] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7074), 1,
      sym_identifier,
    ACTIONS(7145), 1,
      anon_sym_RPAREN,
    STATE(4413), 1,
      sym_formal_type_parameter,
    STATE(4365), 2,
      sym_required_type_parameter,
      sym_optional_type_parameter,
  [103274] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3698), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
  [103293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6693), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103304] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3521), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
  [103323] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7149), 1,
      anon_sym_in,
    ACTIONS(7151), 1,
      anon_sym_of,
    ACTIONS(7147), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6586), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7153), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103360] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7155), 1,
      anon_sym_in,
    ACTIONS(7157), 1,
      anon_sym_of,
    ACTIONS(7147), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103375] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4235), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [103394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103405] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4427), 1,
      sym__call_signature,
  [103424] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7074), 1,
      sym_identifier,
    ACTIONS(7159), 1,
      anon_sym_RPAREN,
    STATE(4413), 1,
      sym_formal_type_parameter,
    STATE(4365), 2,
      sym_required_type_parameter,
      sym_optional_type_parameter,
  [103441] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3626), 1,
      sym__call_signature,
    STATE(4162), 1,
      sym_type_parameters,
  [103460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6693), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7161), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6574), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7163), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103504] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6590), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103515] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7078), 1,
      anon_sym_COLON,
    ACTIONS(7165), 1,
      anon_sym_EQ_GT,
    STATE(4440), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [103530] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3411), 1,
      sym__call_signature,
    STATE(4162), 1,
      sym_type_parameters,
  [103549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6915), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103560] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7168), 1,
      anon_sym_BQUOTE,
    ACTIONS(7170), 1,
      sym__template_chars,
    STATE(3637), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [103577] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7078), 1,
      anon_sym_COLON,
    ACTIONS(7172), 1,
      anon_sym_EQ_GT,
    STATE(4287), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [103592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6691), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7175), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103614] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(4104), 1,
      sym__initializer,
    ACTIONS(7177), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6572), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103640] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7087), 1,
      anon_sym_SEMI,
    ACTIONS(7089), 1,
      sym__automatic_semicolon,
    ACTIONS(7091), 1,
      sym__function_signature_automatic_semicolon,
    ACTIONS(7179), 1,
      anon_sym_LBRACE,
    STATE(2210), 1,
      sym_statement_block,
  [103659] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4205), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [103678] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(118), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1138), 1,
      anon_sym_LBRACE,
    ACTIONS(6554), 1,
      anon_sym_extends,
    STATE(719), 1,
      sym_object_type,
    STATE(4029), 1,
      sym_extends_type_clause,
  [103697] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6420), 1,
      anon_sym_DOT,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(822), 1,
      sym_statement_block,
    ACTIONS(2405), 2,
      anon_sym_else,
      anon_sym_while,
  [103714] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4203), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [103733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7181), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7183), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103755] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6412), 1,
      anon_sym_LT,
    ACTIONS(7185), 1,
      anon_sym_LBRACE,
    STATE(4144), 1,
      sym_type_arguments,
    ACTIONS(7187), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [103772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7189), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103783] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6346), 1,
      anon_sym_AMP,
    ACTIONS(6350), 1,
      anon_sym_extends,
    ACTIONS(7064), 1,
      anon_sym_PIPE,
    ACTIONS(7191), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [103800] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7193), 1,
      anon_sym_BQUOTE,
    ACTIONS(7195), 1,
      sym__template_chars,
    STATE(3687), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [103817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7197), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103828] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3361), 1,
      sym__call_signature,
    STATE(4162), 1,
      sym_type_parameters,
  [103847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7078), 1,
      anon_sym_COLON,
    ACTIONS(7199), 1,
      anon_sym_EQ_GT,
    STATE(4440), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [103862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7202), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [103873] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4411), 1,
      sym__call_signature,
  [103892] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_SEMI,
    ACTIONS(7102), 1,
      sym__automatic_semicolon,
    ACTIONS(7104), 1,
      sym__function_signature_automatic_semicolon,
    ACTIONS(7179), 1,
      anon_sym_LBRACE,
    STATE(2176), 1,
      sym_statement_block,
  [103911] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3524), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
  [103930] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7087), 1,
      anon_sym_SEMI,
    ACTIONS(7089), 1,
      sym__automatic_semicolon,
    ACTIONS(7091), 1,
      sym__function_signature_automatic_semicolon,
    ACTIONS(7204), 1,
      anon_sym_LBRACE,
    STATE(674), 1,
      sym_statement_block,
  [103949] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7074), 1,
      sym_identifier,
    ACTIONS(7206), 1,
      anon_sym_RPAREN,
    STATE(3941), 1,
      sym_formal_type_parameter,
    STATE(4365), 2,
      sym_required_type_parameter,
      sym_optional_type_parameter,
  [103966] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5353), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [103977] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    ACTIONS(6616), 1,
      anon_sym_COLON,
    STATE(1548), 1,
      sym_statement_block,
    STATE(4357), 1,
      sym_typed_function_return_type,
    STATE(4514), 1,
      sym_type_annotation,
  [103996] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    STATE(3073), 1,
      sym_formal_parameters,
    STATE(3328), 1,
      sym__call_signature,
    STATE(4208), 1,
      sym_type_parameters,
  [104015] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4201), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [104034] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2556), 1,
      anon_sym_LPAREN,
    ACTIONS(7208), 1,
      sym_identifier,
    ACTIONS(7210), 1,
      anon_sym_LBRACK,
    ACTIONS(7212), 1,
      sym_private_property_identifier,
    STATE(1056), 1,
      sym_arguments,
  [104053] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4226), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [104072] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3387), 1,
      sym__call_signature,
    STATE(4162), 1,
      sym_type_parameters,
  [104091] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4190), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [104110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [104121] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7139), 1,
      sym__template_chars,
    ACTIONS(7214), 1,
      anon_sym_BQUOTE,
    STATE(3526), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [104138] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7139), 1,
      sym__template_chars,
    ACTIONS(7216), 1,
      anon_sym_BQUOTE,
    STATE(3526), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [104155] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 1,
      anon_sym_SEMI,
    ACTIONS(7102), 1,
      sym__automatic_semicolon,
    ACTIONS(7104), 1,
      sym__function_signature_automatic_semicolon,
    ACTIONS(7204), 1,
      anon_sym_LBRACE,
    STATE(682), 1,
      sym_statement_block,
  [104174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [104185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5349), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [104196] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4280), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [104215] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3384), 1,
      sym__call_signature,
    STATE(4162), 1,
      sym_type_parameters,
  [104234] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7218), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [104251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7220), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_extends,
      anon_sym_implements,
  [104262] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    ACTIONS(6616), 1,
      anon_sym_COLON,
    STATE(1555), 1,
      sym_statement_block,
    STATE(4457), 1,
      sym_typed_function_return_type,
    STATE(4514), 1,
      sym_type_annotation,
  [104281] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3371), 1,
      sym__call_signature,
    STATE(4162), 1,
      sym_type_parameters,
  [104300] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7085), 1,
      anon_sym_LBRACE,
    ACTIONS(7100), 1,
      anon_sym_SEMI,
    ACTIONS(7102), 1,
      sym__automatic_semicolon,
    ACTIONS(7104), 1,
      sym__function_signature_automatic_semicolon,
    STATE(682), 1,
      sym_statement_block,
  [104319] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3680), 1,
      sym__call_signature,
    STATE(4162), 1,
      sym_type_parameters,
  [104338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6596), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104349] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 1,
      anon_sym_DOT,
    ACTIONS(3112), 1,
      anon_sym_LBRACE,
    ACTIONS(3114), 3,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_LBRACE_PIPE,
  [104364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5241), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [104375] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7078), 1,
      anon_sym_COLON,
    ACTIONS(7222), 1,
      anon_sym_EQ_GT,
    STATE(4287), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [104390] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4294), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [104409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5306), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [104420] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_AMP,
    ACTIONS(6378), 1,
      anon_sym_PIPE,
    ACTIONS(6380), 1,
      anon_sym_extends,
    ACTIONS(7225), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [104437] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4223), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [104456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7227), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_extends,
      anon_sym_implements,
  [104467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7229), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104478] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4375), 1,
      sym__call_signature,
  [104497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5274), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [104508] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    STATE(3073), 1,
      sym_formal_parameters,
    STATE(3269), 1,
      sym__call_signature,
    STATE(4208), 1,
      sym_type_parameters,
  [104527] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(4025), 1,
      sym__initializer,
    ACTIONS(7231), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6594), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104553] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_EQ_GT,
    ACTIONS(7078), 1,
      anon_sym_COLON,
    STATE(4287), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [104568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6592), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7233), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5274), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [104601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5274), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [104612] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    ACTIONS(6616), 1,
      anon_sym_COLON,
    STATE(1561), 1,
      sym_statement_block,
    STATE(4417), 1,
      sym_typed_function_return_type,
    STATE(4514), 1,
      sym_type_annotation,
  [104631] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7074), 1,
      sym_identifier,
    ACTIONS(7235), 1,
      anon_sym_RPAREN,
    STATE(4413), 1,
      sym_formal_type_parameter,
    STATE(4365), 2,
      sym_required_type_parameter,
      sym_optional_type_parameter,
  [104648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5278), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_QMARK,
  [104659] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(4092), 1,
      sym__initializer,
    ACTIONS(7237), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104674] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4410), 1,
      sym__call_signature,
  [104693] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3551), 1,
      sym__call_signature,
    STATE(4162), 1,
      sym_type_parameters,
  [104712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4743), 5,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_EQ,
  [104723] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7074), 1,
      sym_identifier,
    ACTIONS(7239), 1,
      anon_sym_RPAREN,
    STATE(4004), 1,
      sym_formal_type_parameter,
    STATE(4365), 2,
      sym_required_type_parameter,
      sym_optional_type_parameter,
  [104740] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4322), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [104759] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(4094), 1,
      sym__initializer,
    ACTIONS(7241), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104774] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7087), 1,
      anon_sym_SEMI,
    ACTIONS(7089), 1,
      sym__automatic_semicolon,
    ACTIONS(7091), 1,
      sym__function_signature_automatic_semicolon,
    ACTIONS(7098), 1,
      anon_sym_LBRACE,
    STATE(175), 1,
      sym_statement_block,
  [104793] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    ACTIONS(7243), 1,
      sym_identifier,
    ACTIONS(7245), 1,
      anon_sym_LBRACK,
    ACTIONS(7247), 1,
      sym_private_property_identifier,
    STATE(2154), 1,
      sym_arguments,
  [104812] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    STATE(3118), 1,
      sym_formal_parameters,
    STATE(3544), 1,
      sym__call_signature,
    STATE(4162), 1,
      sym_type_parameters,
  [104831] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7225), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [104848] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3586), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
  [104867] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7249), 1,
      anon_sym_BQUOTE,
    ACTIONS(7251), 1,
      sym__template_chars,
    STATE(3638), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [104884] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7253), 1,
      anon_sym_BQUOTE,
    ACTIONS(7255), 1,
      sym__template_chars,
    STATE(3719), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [104901] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7139), 1,
      sym__template_chars,
    ACTIONS(7257), 1,
      anon_sym_BQUOTE,
    STATE(3526), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [104918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6598), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7259), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [104940] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4325), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [104959] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7078), 1,
      anon_sym_COLON,
    ACTIONS(7261), 1,
      anon_sym_EQ_GT,
    STATE(4287), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [104974] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(3970), 1,
      sym__initializer,
    ACTIONS(7264), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [104989] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4308), 1,
      sym__call_signature,
    STATE(4343), 1,
      sym_type_parameters,
  [105008] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    STATE(3073), 1,
      sym_formal_parameters,
    STATE(3255), 1,
      sym__call_signature,
    STATE(4208), 1,
      sym_type_parameters,
  [105027] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4361), 1,
      sym__call_signature,
  [105046] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6554), 1,
      anon_sym_extends,
    ACTIONS(6631), 1,
      anon_sym_LBRACE,
    ACTIONS(6633), 1,
      anon_sym_LBRACE_PIPE,
    STATE(719), 1,
      sym_object_type,
    STATE(4034), 1,
      sym_extends_type_clause,
  [105065] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4397), 1,
      sym__call_signature,
  [105084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6588), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6596), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105106] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6774), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
    ACTIONS(7266), 1,
      anon_sym_as,
    ACTIONS(7268), 1,
      anon_sym_RBRACK,
  [105125] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7270), 1,
      anon_sym_BQUOTE,
    ACTIONS(7272), 1,
      sym__template_chars,
    STATE(3722), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [105142] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    STATE(3073), 1,
      sym_formal_parameters,
    STATE(3261), 1,
      sym__call_signature,
    STATE(4208), 1,
      sym_type_parameters,
  [105161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7274), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(4040), 1,
      sym__initializer,
    ACTIONS(7278), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105198] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7015), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6130), 1,
      anon_sym_EQ,
    STATE(4041), 1,
      sym__initializer,
    ACTIONS(7280), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105224] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(3572), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
  [105243] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6011), 1,
      anon_sym_LBRACE,
    ACTIONS(6420), 1,
      anon_sym_DOT,
    STATE(3204), 1,
      sym_new_component_body,
    STATE(4194), 1,
      sym_component_identifier,
  [105262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7021), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6590), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7001), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7282), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105306] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4456), 1,
      sym__call_signature,
  [105325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7284), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105336] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    STATE(3073), 1,
      sym_formal_parameters,
    STATE(3254), 1,
      sym__call_signature,
    STATE(4208), 1,
      sym_type_parameters,
  [105355] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    STATE(3149), 1,
      sym_formal_parameters,
    STATE(4044), 1,
      sym__call_signature,
    STATE(4202), 1,
      sym_type_parameters,
  [105374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6564), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [105385] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7139), 1,
      sym__template_chars,
    ACTIONS(7286), 1,
      anon_sym_BQUOTE,
    STATE(3526), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [105402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7288), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105413] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6588), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105424] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7139), 1,
      sym__template_chars,
    ACTIONS(7290), 1,
      anon_sym_BQUOTE,
    STATE(3526), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [105441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7292), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105452] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3529), 1,
      sym_formal_parameters,
    STATE(4343), 1,
      sym_type_parameters,
    STATE(4465), 1,
      sym__call_signature,
  [105471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7294), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [105482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7296), 1,
      anon_sym_COMMA,
    STATE(3831), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(7298), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [105496] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(1842), 1,
      sym_component_body,
    STATE(4395), 1,
      sym_component_identifier,
  [105512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7300), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_DOLLAR_LBRACE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
  [105522] = 5,
    ACTIONS(7302), 1,
      sym__glimmer_template_content,
    ACTIONS(7304), 1,
      anon_sym_LT_SLASHtemplate_GT,
    ACTIONS(7306), 1,
      sym_comment,
    STATE(2153), 1,
      sym_glimmer_closing_tag,
    STATE(3903), 1,
      aux_sym_glimmer_template_repeat1,
  [105538] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7308), 1,
      anon_sym_QMARK,
  [105554] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7310), 1,
      anon_sym_RBRACK,
  [105570] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7312), 1,
      anon_sym_QMARK,
  [105586] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7314), 1,
      anon_sym_RPAREN,
  [105602] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4158), 1,
      sym_type_parameters,
    STATE(4871), 1,
      sym_formal_parameters,
  [105618] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6520), 1,
      anon_sym_LBRACE,
    STATE(605), 1,
      sym_component_body,
    STATE(4166), 1,
      sym_component_identifier,
  [105634] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7316), 1,
      anon_sym_DQUOTE,
    STATE(3744), 1,
      aux_sym_string_repeat1,
    ACTIONS(7318), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [105648] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2255), 1,
      sym_component_body,
    STATE(4178), 1,
      sym_component_identifier,
  [105664] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4161), 1,
      sym_type_parameters,
    STATE(4862), 1,
      sym_formal_parameters,
  [105680] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_AMP,
    ACTIONS(6378), 1,
      anon_sym_PIPE,
    ACTIONS(6380), 1,
      anon_sym_extends,
    ACTIONS(7320), 1,
      anon_sym_COLON,
  [105696] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7322), 1,
      anon_sym_DQUOTE,
    STATE(3745), 1,
      aux_sym_string_repeat1,
    ACTIONS(7324), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [105710] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7322), 1,
      anon_sym_SQUOTE,
    STATE(3757), 1,
      aux_sym_string_repeat2,
    ACTIONS(7326), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [105724] = 5,
    ACTIONS(7302), 1,
      sym__glimmer_template_content,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7328), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(1051), 1,
      sym_glimmer_closing_tag,
    STATE(3903), 1,
      aux_sym_glimmer_template_repeat1,
  [105740] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7316), 1,
      anon_sym_SQUOTE,
    STATE(3753), 1,
      aux_sym_string_repeat2,
    ACTIONS(7330), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [105754] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7332), 1,
      anon_sym_DQUOTE,
    STATE(3817), 1,
      aux_sym_string_repeat1,
    ACTIONS(7334), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [105768] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7336), 1,
      anon_sym_DQUOTE,
    STATE(3817), 1,
      aux_sym_string_repeat1,
    ACTIONS(7334), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [105782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7338), 1,
      anon_sym_DOT,
    STATE(3762), 1,
      aux_sym_component_short_heritage_repeat1,
    ACTIONS(6036), 2,
      anon_sym_LBRACE,
      anon_sym_POUND,
  [105796] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6520), 1,
      anon_sym_LBRACE,
    STATE(604), 1,
      sym_component_body,
    STATE(4193), 1,
      sym_component_identifier,
  [105812] = 5,
    ACTIONS(7304), 1,
      anon_sym_LT_SLASHtemplate_GT,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7340), 1,
      sym__glimmer_template_content,
    STATE(2233), 1,
      sym_glimmer_closing_tag,
    STATE(3729), 1,
      aux_sym_glimmer_template_repeat1,
  [105828] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7342), 1,
      anon_sym_SQUOTE,
    STATE(3818), 1,
      aux_sym_string_repeat2,
    ACTIONS(7344), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [105842] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6520), 1,
      anon_sym_LBRACE,
    STATE(597), 1,
      sym_component_body,
    STATE(4198), 1,
      sym_component_identifier,
  [105858] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7342), 1,
      anon_sym_DQUOTE,
    STATE(3817), 1,
      aux_sym_string_repeat1,
    ACTIONS(7334), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [105872] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_AMP,
    ACTIONS(6378), 1,
      anon_sym_PIPE,
    ACTIONS(6380), 1,
      anon_sym_extends,
    ACTIONS(7346), 1,
      anon_sym_COLON,
  [105888] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7332), 1,
      anon_sym_SQUOTE,
    STATE(3818), 1,
      aux_sym_string_repeat2,
    ACTIONS(7344), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [105902] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7348), 1,
      anon_sym_DQUOTE,
    STATE(3787), 1,
      aux_sym_string_repeat1,
    ACTIONS(7350), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [105916] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7348), 1,
      anon_sym_SQUOTE,
    STATE(3789), 1,
      aux_sym_string_repeat2,
    ACTIONS(7352), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [105930] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4168), 1,
      sym_type_parameters,
    STATE(4687), 1,
      sym_formal_parameters,
  [105946] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7336), 1,
      anon_sym_SQUOTE,
    STATE(3818), 1,
      aux_sym_string_repeat2,
    ACTIONS(7344), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [105960] = 5,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7328), 1,
      anon_sym_LT_SLASHtemplate_GT,
    ACTIONS(7354), 1,
      sym__glimmer_template_content,
    STATE(1035), 1,
      sym_glimmer_closing_tag,
    STATE(3742), 1,
      aux_sym_glimmer_template_repeat1,
  [105976] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2208), 1,
      sym_component_body,
    STATE(4231), 1,
      sym_component_identifier,
  [105992] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7356), 1,
      anon_sym_RPAREN,
  [106008] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6612), 1,
      anon_sym_LBRACE,
    STATE(1049), 1,
      sym_component_body,
    STATE(4330), 1,
      sym_component_identifier,
  [106024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7338), 1,
      anon_sym_DOT,
    STATE(3793), 1,
      aux_sym_component_short_heritage_repeat1,
    ACTIONS(7358), 2,
      anon_sym_LBRACE,
      anon_sym_POUND,
  [106038] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4171), 1,
      sym_type_parameters,
    STATE(4670), 1,
      sym_formal_parameters,
  [106054] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7360), 1,
      anon_sym_SQUOTE,
    STATE(3818), 1,
      aux_sym_string_repeat2,
    ACTIONS(7344), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [106068] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7360), 1,
      anon_sym_DQUOTE,
    STATE(3817), 1,
      aux_sym_string_repeat1,
    ACTIONS(7334), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [106082] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7362), 1,
      anon_sym_QMARK,
  [106098] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4232), 1,
      sym_type_parameters,
    STATE(4765), 1,
      sym_formal_parameters,
  [106114] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7364), 1,
      anon_sym_QMARK,
  [106130] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7366), 1,
      anon_sym_SQUOTE,
    STATE(3749), 1,
      aux_sym_string_repeat2,
    ACTIONS(7368), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [106144] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2131), 1,
      sym_component_body,
    STATE(4260), 1,
      sym_component_identifier,
  [106160] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7366), 1,
      anon_sym_DQUOTE,
    STATE(3751), 1,
      aux_sym_string_repeat1,
    ACTIONS(7370), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [106174] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7372), 1,
      anon_sym_RPAREN,
  [106190] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7374), 1,
      anon_sym_QMARK,
  [106206] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7376), 1,
      anon_sym_QMARK,
  [106222] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7378), 1,
      anon_sym_SQUOTE,
    STATE(3764), 1,
      aux_sym_string_repeat2,
    ACTIONS(7380), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [106236] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7378), 1,
      anon_sym_DQUOTE,
    STATE(3765), 1,
      aux_sym_string_repeat1,
    ACTIONS(7382), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [106250] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_AMP,
    ACTIONS(6378), 1,
      anon_sym_PIPE,
    ACTIONS(6380), 1,
      anon_sym_extends,
    ACTIONS(7384), 1,
      anon_sym_COLON,
  [106266] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7338), 1,
      anon_sym_DOT,
    STATE(3814), 1,
      aux_sym_component_short_heritage_repeat1,
    ACTIONS(7386), 2,
      anon_sym_LBRACE,
      anon_sym_POUND,
  [106280] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6618), 1,
      anon_sym_EQ,
    STATE(4271), 1,
      sym__initializer,
    ACTIONS(7388), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [106294] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7390), 1,
      anon_sym_QMARK,
  [106310] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7392), 1,
      anon_sym_LBRACE,
    ACTIONS(7394), 1,
      anon_sym_COMMA,
    ACTIONS(7397), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3781), 1,
      aux_sym_extends_type_clause_repeat1,
  [106326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6520), 1,
      anon_sym_LBRACE,
    STATE(609), 1,
      sym_component_body,
    STATE(4248), 1,
      sym_component_identifier,
  [106342] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4286), 1,
      sym_type_parameters,
    STATE(4757), 1,
      sym_formal_parameters,
  [106358] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6520), 1,
      anon_sym_LBRACE,
    STATE(594), 1,
      sym_component_body,
    STATE(4251), 1,
      sym_component_identifier,
  [106374] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7399), 1,
      anon_sym_RBRACK,
  [106390] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 1,
      anon_sym_COMMA,
    ACTIONS(7401), 1,
      anon_sym_LBRACE,
    ACTIONS(7403), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3781), 1,
      aux_sym_extends_type_clause_repeat1,
  [106406] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7405), 1,
      anon_sym_DQUOTE,
    STATE(3817), 1,
      aux_sym_string_repeat1,
    ACTIONS(7334), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [106420] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 1,
      anon_sym_COMMA,
    ACTIONS(7401), 1,
      anon_sym_LBRACE,
    ACTIONS(7403), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3781), 1,
      aux_sym_extends_type_clause_repeat1,
  [106436] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7405), 1,
      anon_sym_SQUOTE,
    STATE(3818), 1,
      aux_sym_string_repeat2,
    ACTIONS(7344), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [106450] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 1,
      anon_sym_COMMA,
    ACTIONS(7407), 1,
      anon_sym_LBRACE,
    ACTIONS(7409), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3781), 1,
      aux_sym_extends_type_clause_repeat1,
  [106466] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7411), 1,
      anon_sym_COMMA,
    STATE(3791), 1,
      aux_sym_js_import_statement_repeat1,
    ACTIONS(7414), 2,
      anon_sym_RBRACE,
      anon_sym_from,
  [106480] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 1,
      sym_identifier,
    STATE(3615), 1,
      sym_nested_type_identifier,
    STATE(4086), 1,
      sym_generic_type,
    STATE(4640), 1,
      sym_nested_identifier,
  [106496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7418), 1,
      anon_sym_DOT,
    STATE(3793), 1,
      aux_sym_component_short_heritage_repeat1,
    ACTIONS(6101), 2,
      anon_sym_LBRACE,
      anon_sym_POUND,
  [106510] = 5,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7421), 1,
      sym__glimmer_template_content,
    ACTIONS(7423), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(1754), 1,
      sym_glimmer_closing_tag,
    STATE(3838), 1,
      aux_sym_glimmer_template_repeat1,
  [106526] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7425), 1,
      anon_sym_EQ,
    STATE(4239), 1,
      sym__initializer,
    ACTIONS(6390), 2,
      anon_sym_in,
      anon_sym_of,
  [106540] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2161), 1,
      sym_component_body,
    STATE(4195), 1,
      sym_component_identifier,
  [106556] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7427), 1,
      anon_sym_RBRACK,
  [106572] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4328), 1,
      sym_type_parameters,
    STATE(4671), 1,
      sym_formal_parameters,
  [106588] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1193), 1,
      anon_sym_COMMA,
    ACTIONS(7429), 1,
      anon_sym_EQ,
    ACTIONS(7431), 1,
      anon_sym_RBRACK,
    STATE(3973), 1,
      aux_sym_array_pattern_repeat1,
  [106604] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(1755), 1,
      sym_component_body,
    STATE(4288), 1,
      sym_component_identifier,
  [106620] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6612), 1,
      anon_sym_LBRACE,
    STATE(995), 1,
      sym_component_body,
    STATE(4422), 1,
      sym_component_identifier,
  [106636] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6624), 1,
      anon_sym_LBRACE,
    STATE(173), 1,
      sym_component_body,
    STATE(4215), 1,
      sym_component_identifier,
  [106652] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6524), 1,
      anon_sym_COMMA,
    ACTIONS(7017), 1,
      anon_sym_LBRACE,
    ACTIONS(7019), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3786), 1,
      aux_sym_extends_type_clause_repeat1,
  [106668] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    STATE(3226), 1,
      sym_formal_parameters,
    STATE(4296), 1,
      sym_type_parameters,
  [106684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7433), 1,
      anon_sym_COMMA,
    STATE(3805), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(7436), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [106698] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7438), 1,
      anon_sym_RPAREN,
  [106714] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6612), 1,
      anon_sym_LBRACE,
    STATE(1007), 1,
      sym_component_body,
    STATE(4455), 1,
      sym_component_identifier,
  [106730] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7440), 1,
      anon_sym_RBRACK,
  [106746] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7442), 1,
      anon_sym_RPAREN,
  [106762] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7444), 1,
      anon_sym_RBRACK,
  [106778] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2293), 1,
      sym_component_body,
    STATE(4327), 1,
      sym_component_identifier,
  [106794] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_SQUOTE,
    STATE(3818), 1,
      aux_sym_string_repeat2,
    ACTIONS(7344), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [106808] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4382), 1,
      sym_type_parameters,
    STATE(4651), 1,
      sym_formal_parameters,
  [106824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7338), 1,
      anon_sym_DOT,
    STATE(3793), 1,
      aux_sym_component_short_heritage_repeat1,
    ACTIONS(7448), 2,
      anon_sym_LBRACE,
      anon_sym_POUND,
  [106838] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6520), 1,
      anon_sym_LBRACE,
    STATE(622), 1,
      sym_component_body,
    STATE(4373), 1,
      sym_component_identifier,
  [106854] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_DQUOTE,
    STATE(3817), 1,
      aux_sym_string_repeat1,
    ACTIONS(7334), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [106868] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7450), 1,
      anon_sym_DQUOTE,
    STATE(3817), 1,
      aux_sym_string_repeat1,
    ACTIONS(7452), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [106882] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7455), 1,
      anon_sym_SQUOTE,
    STATE(3818), 1,
      aux_sym_string_repeat2,
    ACTIONS(7457), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [106896] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7460), 1,
      anon_sym_RBRACK,
  [106912] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2193), 1,
      sym_component_body,
    STATE(4209), 1,
      sym_component_identifier,
  [106928] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7462), 1,
      anon_sym_SQUOTE,
    STATE(3812), 1,
      aux_sym_string_repeat2,
    ACTIONS(7464), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [106942] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2311), 1,
      sym_component_body,
    STATE(4348), 1,
      sym_component_identifier,
  [106958] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7462), 1,
      anon_sym_DQUOTE,
    STATE(3816), 1,
      aux_sym_string_repeat1,
    ACTIONS(7466), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [106972] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_AMP,
    ACTIONS(6378), 1,
      anon_sym_PIPE,
    ACTIONS(6380), 1,
      anon_sym_extends,
    ACTIONS(7468), 1,
      anon_sym_COLON,
  [106988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7074), 1,
      sym_identifier,
    STATE(4413), 1,
      sym_formal_type_parameter,
    STATE(4365), 2,
      sym_required_type_parameter,
      sym_optional_type_parameter,
  [107002] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2205), 1,
      sym_component_body,
    STATE(4217), 1,
      sym_component_identifier,
  [107018] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6624), 1,
      anon_sym_LBRACE,
    STATE(194), 1,
      sym_component_body,
    STATE(4310), 1,
      sym_component_identifier,
  [107034] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6624), 1,
      anon_sym_LBRACE,
    STATE(198), 1,
      sym_component_body,
    STATE(4314), 1,
      sym_component_identifier,
  [107050] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1193), 1,
      anon_sym_COMMA,
    ACTIONS(7429), 1,
      anon_sym_EQ,
    ACTIONS(7470), 1,
      anon_sym_RBRACK,
    STATE(3914), 1,
      aux_sym_array_pattern_repeat1,
  [107066] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7472), 1,
      sym_identifier,
    STATE(3501), 1,
      sym_nested_type_identifier,
    STATE(3803), 1,
      sym_generic_type,
    STATE(4640), 1,
      sym_nested_identifier,
  [107082] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7296), 1,
      anon_sym_COMMA,
    STATE(3805), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(7474), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [107096] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(1776), 1,
      sym_component_body,
    STATE(4431), 1,
      sym_component_identifier,
  [107112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7476), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      sym_identifier,
      sym_private_property_identifier,
  [107122] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_AMP,
    ACTIONS(6378), 1,
      anon_sym_PIPE,
    ACTIONS(6380), 1,
      anon_sym_extends,
    ACTIONS(7478), 1,
      anon_sym_COLON,
  [107138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7296), 1,
      anon_sym_COMMA,
    STATE(3805), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(7480), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [107152] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7482), 1,
      anon_sym_RBRACK,
  [107168] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7484), 1,
      anon_sym_RBRACK,
  [107184] = 5,
    ACTIONS(7302), 1,
      sym__glimmer_template_content,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7423), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(1779), 1,
      sym_glimmer_closing_tag,
    STATE(3903), 1,
      aux_sym_glimmer_template_repeat1,
  [107200] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7035), 1,
      anon_sym_finally,
    STATE(751), 1,
      sym_finally_clause,
    ACTIONS(2462), 2,
      anon_sym_else,
      anon_sym_while,
  [107214] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 1,
      anon_sym_COMMA,
    STATE(3840), 1,
      aux_sym_array_repeat1,
    ACTIONS(5316), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [107228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7491), 1,
      anon_sym_COMMA,
    STATE(3841), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(7489), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [107242] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4964), 1,
      anon_sym_COMMA,
    STATE(3841), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(7494), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [107256] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7496), 1,
      anon_sym_RBRACK,
  [107272] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(1784), 1,
      sym_component_body,
    STATE(4447), 1,
      sym_component_identifier,
  [107288] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    STATE(3274), 1,
      sym_formal_parameters,
    STATE(4448), 1,
      sym_type_parameters,
  [107304] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_AMP,
    ACTIONS(6378), 1,
      anon_sym_PIPE,
    ACTIONS(6380), 1,
      anon_sym_extends,
    ACTIONS(7498), 1,
      anon_sym_COLON,
  [107320] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2240), 1,
      sym_component_body,
    STATE(4252), 1,
      sym_component_identifier,
  [107336] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_AMP,
    ACTIONS(6378), 1,
      anon_sym_PIPE,
    ACTIONS(6380), 1,
      anon_sym_extends,
    ACTIONS(7500), 1,
      anon_sym_COLON,
  [107352] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6612), 1,
      anon_sym_LBRACE,
    STATE(1040), 1,
      sym_component_body,
    STATE(4432), 1,
      sym_component_identifier,
  [107368] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7502), 1,
      anon_sym_QMARK,
  [107384] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2246), 1,
      sym_component_body,
    STATE(4256), 1,
      sym_component_identifier,
  [107400] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(822), 1,
      sym_statement_block,
    ACTIONS(2405), 2,
      anon_sym_else,
      anon_sym_while,
  [107414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6618), 1,
      anon_sym_EQ,
    STATE(4356), 1,
      sym__initializer,
    ACTIONS(7504), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [107428] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6624), 1,
      anon_sym_LBRACE,
    STATE(169), 1,
      sym_component_body,
    STATE(4358), 1,
      sym_component_identifier,
  [107444] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6624), 1,
      anon_sym_LBRACE,
    STATE(215), 1,
      sym_component_body,
    STATE(4362), 1,
      sym_component_identifier,
  [107460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7506), 1,
      anon_sym_EQ_GT,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [107472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5899), 1,
      anon_sym_EQ_GT,
    ACTIONS(4903), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [107484] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_AMP,
    ACTIONS(6378), 1,
      anon_sym_PIPE,
    ACTIONS(6380), 1,
      anon_sym_extends,
    ACTIONS(7508), 1,
      anon_sym_COLON,
  [107500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6618), 1,
      anon_sym_EQ,
    STATE(4468), 1,
      sym__initializer,
    ACTIONS(7510), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [107514] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_component_body,
    STATE(4472), 1,
      sym_component_identifier,
  [107530] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6612), 1,
      anon_sym_LBRACE,
    STATE(1025), 1,
      sym_component_body,
    STATE(4399), 1,
      sym_component_identifier,
  [107546] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6283), 1,
      anon_sym_EQ,
    STATE(4475), 1,
      sym_default_type,
    ACTIONS(7512), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [107560] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7296), 1,
      anon_sym_COMMA,
    STATE(3835), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(7514), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [107574] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4466), 1,
      sym_type_parameters,
    STATE(4776), 1,
      sym_formal_parameters,
  [107590] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2237), 1,
      sym_component_body,
    STATE(4381), 1,
      sym_component_identifier,
  [107606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7053), 1,
      anon_sym_RBRACE,
    ACTIONS(3228), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [107618] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(2485), 1,
      sym_component_body,
    STATE(4388), 1,
      sym_component_identifier,
  [107634] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4493), 1,
      sym_type_parameters,
    STATE(4786), 1,
      sym_formal_parameters,
  [107650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7516), 1,
      sym_escape_sequence,
    ACTIONS(7518), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [107662] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7521), 1,
      anon_sym_RBRACK,
  [107678] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7523), 1,
      anon_sym_RBRACK,
  [107694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7300), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [107704] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4368), 1,
      sym_type_parameters,
    STATE(4866), 1,
      sym_formal_parameters,
  [107720] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7525), 1,
      anon_sym_QMARK,
  [107736] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7527), 1,
      anon_sym_RBRACK,
  [107752] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4369), 1,
      sym_type_parameters,
    STATE(4811), 1,
      sym_formal_parameters,
  [107768] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4964), 1,
      anon_sym_COMMA,
    STATE(3841), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(7529), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [107782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4964), 1,
      anon_sym_COMMA,
    STATE(3842), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(7531), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [107796] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_AMP,
    ACTIONS(6378), 1,
      anon_sym_PIPE,
    ACTIONS(6380), 1,
      anon_sym_extends,
    ACTIONS(7533), 1,
      anon_sym_COLON,
  [107812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5259), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [107822] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4379), 1,
      sym_type_parameters,
    STATE(4715), 1,
      sym_formal_parameters,
  [107838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4903), 1,
      anon_sym_COLON,
    ACTIONS(4905), 1,
      anon_sym_EQ,
    ACTIONS(7535), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [107852] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7537), 1,
      anon_sym_RBRACK,
  [107868] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4383), 1,
      sym_type_parameters,
    STATE(4679), 1,
      sym_formal_parameters,
  [107884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6618), 1,
      anon_sym_EQ,
    STATE(4415), 1,
      sym__initializer,
    ACTIONS(7539), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [107898] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6624), 1,
      anon_sym_LBRACE,
    STATE(197), 1,
      sym_component_body,
    STATE(4421), 1,
      sym_component_identifier,
  [107914] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4482), 1,
      sym_type_parameters,
    STATE(4532), 1,
      sym_formal_parameters,
  [107930] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4393), 1,
      sym_type_parameters,
    STATE(4574), 1,
      sym_formal_parameters,
  [107946] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
    ACTIONS(7541), 1,
      anon_sym_RPAREN,
  [107962] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7543), 1,
      anon_sym_DQUOTE,
    STATE(3902), 1,
      aux_sym_string_repeat1,
    ACTIONS(7545), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [107976] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7543), 1,
      anon_sym_SQUOTE,
    STATE(3900), 1,
      aux_sym_string_repeat2,
    ACTIONS(7547), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [107990] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2287), 1,
      sym_component_body,
    STATE(4169), 1,
      sym_component_identifier,
  [108006] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4449), 1,
      sym_type_parameters,
    STATE(4599), 1,
      sym_formal_parameters,
  [108022] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4398), 1,
      sym_type_parameters,
    STATE(4578), 1,
      sym_formal_parameters,
  [108038] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6612), 1,
      anon_sym_LBRACE,
    STATE(1001), 1,
      sym_component_body,
    STATE(4290), 1,
      sym_component_identifier,
  [108054] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(1821), 1,
      sym_component_body,
    STATE(4484), 1,
      sym_component_identifier,
  [108070] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(2470), 1,
      sym_component_body,
    STATE(4459), 1,
      sym_component_identifier,
  [108086] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6618), 1,
      anon_sym_EQ,
    STATE(4464), 1,
      sym__initializer,
    ACTIONS(7549), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [108100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5887), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108110] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7551), 1,
      anon_sym_SQUOTE,
    STATE(3818), 1,
      aux_sym_string_repeat2,
    ACTIONS(7344), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [108124] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_POUND,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(1814), 1,
      sym_component_body,
    STATE(4494), 1,
      sym_component_identifier,
  [108140] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7551), 1,
      anon_sym_DQUOTE,
    STATE(3817), 1,
      aux_sym_string_repeat1,
    ACTIONS(7334), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [108154] = 4,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(7553), 1,
      sym__glimmer_template_content,
    ACTIONS(7556), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(3903), 1,
      aux_sym_glimmer_template_repeat1,
  [108167] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7558), 1,
      anon_sym_AMP,
    ACTIONS(7560), 1,
      anon_sym_PIPE,
    ACTIONS(7562), 1,
      anon_sym_extends,
  [108180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6510), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [108189] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7564), 1,
      anon_sym_COMMA,
    ACTIONS(7567), 1,
      anon_sym_RPAREN,
    STATE(3906), 1,
      aux_sym_formal_parameters_repeat1,
  [108202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5887), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4001), 1,
      anon_sym_GT,
    ACTIONS(7569), 1,
      anon_sym_COMMA,
    STATE(3934), 1,
      aux_sym_implements_clause_repeat1,
  [108224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7571), 1,
      anon_sym_COMMA,
    ACTIONS(7574), 1,
      anon_sym_RBRACK,
    STATE(3909), 1,
      aux_sym_array_pattern_repeat1,
  [108237] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7576), 1,
      sym_identifier,
    ACTIONS(7578), 1,
      anon_sym_GT,
    STATE(4476), 1,
      sym_type_parameter,
  [108250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5294), 1,
      anon_sym_RPAREN,
    STATE(3947), 1,
      aux_sym_array_repeat1,
  [108263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5294), 1,
      anon_sym_RPAREN,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [108276] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7580), 1,
      anon_sym_COMMA,
    ACTIONS(7583), 1,
      anon_sym_GT,
    STATE(3913), 1,
      aux_sym_type_parameters_repeat1,
  [108289] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1193), 1,
      anon_sym_COMMA,
    ACTIONS(7585), 1,
      anon_sym_RBRACK,
    STATE(3909), 1,
      aux_sym_array_pattern_repeat1,
  [108302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5897), 1,
      sym__automatic_semicolon,
    ACTIONS(1370), 2,
      anon_sym_else,
      anon_sym_while,
  [108313] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7076), 1,
      anon_sym_RPAREN,
    ACTIONS(7587), 1,
      anon_sym_COMMA,
    STATE(3960), 1,
      aux_sym_formal_type_parameters_repeat1,
  [108326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7589), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [108335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(7591), 1,
      anon_sym_RBRACK,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [108348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7593), 1,
      anon_sym_LPAREN,
    ACTIONS(7595), 1,
      anon_sym_await,
    STATE(52), 1,
      sym__for_header,
  [108361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7429), 1,
      anon_sym_EQ,
    ACTIONS(7574), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [108372] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7597), 1,
      anon_sym_COMMA,
    ACTIONS(7600), 1,
      anon_sym_RBRACE,
    STATE(3921), 1,
      aux_sym_object_pattern_repeat1,
  [108385] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7602), 1,
      anon_sym_COMMA,
    ACTIONS(7604), 1,
      anon_sym_RBRACK,
    STATE(3961), 1,
      aux_sym_tuple_type_repeat1,
  [108398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7606), 1,
      sym_identifier,
    ACTIONS(7608), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [108409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7610), 1,
      sym_identifier,
    ACTIONS(7612), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [108420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7614), 1,
      anon_sym_COMMA,
    ACTIONS(7617), 1,
      anon_sym_RBRACE,
    STATE(3925), 1,
      aux_sym_object_repeat1,
  [108433] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7619), 1,
      anon_sym_COMMA,
    ACTIONS(7622), 1,
      anon_sym_RBRACK,
    STATE(3926), 1,
      aux_sym_tuple_type_repeat1,
  [108446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7624), 1,
      anon_sym_LPAREN,
    ACTIONS(7626), 1,
      anon_sym_await,
    STATE(47), 1,
      sym__for_header,
  [108459] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7628), 1,
      anon_sym_COMMA,
    ACTIONS(7630), 1,
      anon_sym_RBRACE,
    STATE(3925), 1,
      aux_sym_object_repeat1,
  [108472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7576), 1,
      sym_identifier,
    ACTIONS(7632), 1,
      anon_sym_GT,
    STATE(4476), 1,
      sym_type_parameter,
  [108485] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7235), 1,
      anon_sym_RPAREN,
    ACTIONS(7634), 1,
      anon_sym_COMMA,
    STATE(3960), 1,
      aux_sym_formal_type_parameters_repeat1,
  [108498] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5449), 1,
      anon_sym_COMMA,
    ACTIONS(7636), 1,
      anon_sym_RBRACE,
    STATE(3921), 1,
      aux_sym_object_pattern_repeat1,
  [108511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7429), 1,
      anon_sym_EQ,
    ACTIONS(7638), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [108522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5449), 1,
      anon_sym_COMMA,
    ACTIONS(7640), 1,
      anon_sym_RBRACE,
    STATE(3921), 1,
      aux_sym_object_pattern_repeat1,
  [108535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7225), 1,
      anon_sym_GT,
    ACTIONS(7642), 1,
      anon_sym_COMMA,
    STATE(3934), 1,
      aux_sym_implements_clause_repeat1,
  [108548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7645), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108557] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7628), 1,
      anon_sym_COMMA,
    ACTIONS(7647), 1,
      anon_sym_RBRACE,
    STATE(3925), 1,
      aux_sym_object_repeat1,
  [108570] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    STATE(634), 1,
      sym_string,
  [108583] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6975), 1,
      anon_sym_COMMA,
    ACTIONS(7649), 1,
      anon_sym_LBRACE,
    STATE(3968), 1,
      aux_sym_implements_clause_repeat1,
  [108596] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_COMMA,
    ACTIONS(7651), 1,
      anon_sym_RBRACE,
    STATE(3945), 1,
      aux_sym_js_import_statement_repeat1,
  [108609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7653), 1,
      anon_sym_LBRACE,
    ACTIONS(7227), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [108620] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7655), 1,
      anon_sym_COMMA,
    ACTIONS(7657), 1,
      anon_sym_RPAREN,
    STATE(3930), 1,
      aux_sym_formal_type_parameters_repeat1,
  [108633] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6616), 1,
      anon_sym_COLON,
    ACTIONS(7659), 1,
      anon_sym_QMARK,
    STATE(3885), 1,
      sym_type_annotation,
  [108646] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6374), 1,
      anon_sym_AMP,
    ACTIONS(6378), 1,
      anon_sym_PIPE,
    ACTIONS(6380), 1,
      anon_sym_extends,
  [108659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6578), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [108668] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_COMMA,
    ACTIONS(7661), 1,
      anon_sym_RBRACE,
    STATE(3791), 1,
      aux_sym_js_import_statement_repeat1,
  [108681] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LT,
    ACTIONS(7663), 1,
      anon_sym_EQ,
    STATE(4618), 1,
      sym_type_parameters,
  [108694] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(7665), 1,
      anon_sym_RPAREN,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [108707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7667), 1,
      anon_sym_COMMA,
    ACTIONS(7669), 1,
      anon_sym_GT,
    STATE(3913), 1,
      aux_sym_type_parameters_repeat1,
  [108720] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7576), 1,
      sym_identifier,
    ACTIONS(7669), 1,
      anon_sym_GT,
    STATE(4476), 1,
      sym_type_parameter,
  [108733] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3657), 1,
      anon_sym_RBRACK,
    ACTIONS(7671), 1,
      anon_sym_COMMA,
    STATE(3926), 1,
      aux_sym_tuple_type_repeat1,
  [108746] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1102), 1,
      anon_sym_RPAREN,
    ACTIONS(7673), 1,
      anon_sym_COMMA,
    STATE(3906), 1,
      aux_sym_formal_parameters_repeat1,
  [108759] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6368), 1,
      anon_sym_AMP,
    ACTIONS(6372), 1,
      anon_sym_extends,
    ACTIONS(7675), 1,
      anon_sym_PIPE,
  [108772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6562), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [108781] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6426), 1,
      anon_sym_implements,
    ACTIONS(7677), 1,
      anon_sym_LBRACE,
    STATE(4592), 1,
      sym_implements_clause,
  [108794] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7679), 1,
      sym_identifier,
    ACTIONS(7681), 1,
      anon_sym_LBRACK,
    ACTIONS(7683), 1,
      sym_private_property_identifier,
  [108807] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3725), 1,
      anon_sym_COLON,
    ACTIONS(7685), 1,
      anon_sym_RPAREN,
    STATE(4591), 1,
      sym_type_annotation,
  [108820] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7687), 1,
      sym_identifier,
    ACTIONS(7689), 1,
      anon_sym_LBRACK,
    ACTIONS(7691), 1,
      sym_private_property_identifier,
  [108833] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7693), 1,
      sym_identifier,
    ACTIONS(7695), 1,
      anon_sym_LBRACK,
    ACTIONS(7697), 1,
      sym_private_property_identifier,
  [108846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7699), 1,
      sym_identifier,
    ACTIONS(7701), 1,
      anon_sym_LBRACK,
    ACTIONS(7703), 1,
      sym_private_property_identifier,
  [108859] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7705), 1,
      anon_sym_COMMA,
    ACTIONS(7708), 1,
      anon_sym_RPAREN,
    STATE(3960), 1,
      aux_sym_formal_type_parameters_repeat1,
  [108872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym_RBRACK,
    ACTIONS(7710), 1,
      anon_sym_COMMA,
    STATE(3926), 1,
      aux_sym_tuple_type_repeat1,
  [108885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 1,
      sym__automatic_semicolon,
    ACTIONS(1526), 2,
      anon_sym_else,
      anon_sym_while,
  [108896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7712), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7712), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7714), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7712), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7716), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108941] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7225), 1,
      anon_sym_LBRACE,
    ACTIONS(7718), 1,
      anon_sym_COMMA,
    STATE(3968), 1,
      aux_sym_implements_clause_repeat1,
  [108954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7716), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7721), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108972] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3875), 1,
      anon_sym_GT,
    ACTIONS(7723), 1,
      anon_sym_COMMA,
    STATE(3934), 1,
      aux_sym_implements_clause_repeat1,
  [108985] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4009), 1,
      anon_sym_GT,
    ACTIONS(7725), 1,
      anon_sym_COMMA,
    STATE(3934), 1,
      aux_sym_implements_clause_repeat1,
  [108998] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1193), 1,
      anon_sym_COMMA,
    ACTIONS(7727), 1,
      anon_sym_RBRACK,
    STATE(3909), 1,
      aux_sym_array_pattern_repeat1,
  [109011] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(7729), 1,
      anon_sym_RBRACK,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [109024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2574), 1,
      anon_sym_while,
    ACTIONS(7731), 1,
      anon_sym_else,
    STATE(869), 1,
      sym_else_clause,
  [109037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    ACTIONS(7733), 1,
      anon_sym_LPAREN,
    STATE(698), 1,
      sym_statement_block,
  [109050] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(118), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1138), 1,
      anon_sym_LBRACE,
    STATE(716), 1,
      sym_object_type,
  [109063] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(7735), 1,
      anon_sym_RPAREN,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [109076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7147), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109085] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7131), 1,
      sym_identifier,
    ACTIONS(7133), 1,
      anon_sym_LBRACK,
    ACTIONS(7135), 1,
      sym_private_property_identifier,
  [109098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7147), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109107] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1193), 1,
      anon_sym_COMMA,
    ACTIONS(7470), 1,
      anon_sym_RBRACK,
    STATE(3909), 1,
      aux_sym_array_pattern_repeat1,
  [109120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7737), 1,
      anon_sym_EQ,
    ACTIONS(4110), 2,
      anon_sym_in,
      anon_sym_of,
  [109131] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2403), 1,
      anon_sym_LBRACE,
    ACTIONS(7739), 1,
      anon_sym_LPAREN,
    STATE(698), 1,
      sym_statement_block,
  [109144] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5310), 1,
      anon_sym_RBRACK,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [109157] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7628), 1,
      anon_sym_COMMA,
    ACTIONS(7741), 1,
      anon_sym_RBRACE,
    STATE(3925), 1,
      aux_sym_object_repeat1,
  [109170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5449), 1,
      anon_sym_COMMA,
    ACTIONS(7743), 1,
      anon_sym_RBRACE,
    STATE(3921), 1,
      aux_sym_object_pattern_repeat1,
  [109183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6631), 1,
      anon_sym_LBRACE,
    ACTIONS(6633), 1,
      anon_sym_LBRACE_PIPE,
    STATE(716), 1,
      sym_object_type,
  [109196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5449), 1,
      anon_sym_COMMA,
    ACTIONS(7745), 1,
      anon_sym_RBRACE,
    STATE(3921), 1,
      aux_sym_object_pattern_repeat1,
  [109209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7628), 1,
      anon_sym_COMMA,
    ACTIONS(7747), 1,
      anon_sym_RBRACE,
    STATE(3925), 1,
      aux_sym_object_repeat1,
  [109222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5310), 1,
      anon_sym_RBRACK,
    STATE(3918), 1,
      aux_sym_array_repeat1,
  [109235] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1193), 1,
      anon_sym_COMMA,
    ACTIONS(7470), 1,
      anon_sym_RBRACK,
    STATE(3914), 1,
      aux_sym_array_pattern_repeat1,
  [109248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5316), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [109257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7751), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7751), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7753), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7755), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109320] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5449), 1,
      anon_sym_COMMA,
    ACTIONS(7759), 1,
      anon_sym_RBRACE,
    STATE(3921), 1,
      aux_sym_object_pattern_repeat1,
  [109333] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3768), 1,
      anon_sym_DQUOTE,
    ACTIONS(3770), 1,
      anon_sym_SQUOTE,
    STATE(634), 1,
      sym_string,
  [109346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7751), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109355] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7761), 1,
      anon_sym_COMMA,
    ACTIONS(7763), 1,
      anon_sym_RPAREN,
    STATE(3916), 1,
      aux_sym_formal_type_parameters_repeat1,
  [109368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7628), 1,
      anon_sym_COMMA,
    ACTIONS(7765), 1,
      anon_sym_RBRACE,
    STATE(3925), 1,
      aux_sym_object_repeat1,
  [109381] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7628), 1,
      anon_sym_COMMA,
    ACTIONS(7765), 1,
      anon_sym_RBRACE,
    STATE(3928), 1,
      aux_sym_object_repeat1,
  [109394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7767), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7755), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109412] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7769), 1,
      anon_sym_COMMA,
    ACTIONS(7771), 1,
      anon_sym_GT,
    STATE(3913), 1,
      aux_sym_type_parameters_repeat1,
  [109425] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7576), 1,
      sym_identifier,
    ACTIONS(7771), 1,
      anon_sym_GT,
    STATE(4476), 1,
      sym_type_parameter,
  [109438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109447] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      anon_sym_RBRACK,
    ACTIONS(7773), 1,
      anon_sym_COMMA,
    STATE(3926), 1,
      aux_sym_tuple_type_repeat1,
  [109460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7775), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [109469] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5449), 1,
      anon_sym_COMMA,
    ACTIONS(7759), 1,
      anon_sym_RBRACE,
    STATE(3931), 1,
      aux_sym_object_pattern_repeat1,
  [109482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5063), 1,
      anon_sym_extends,
    ACTIONS(7777), 1,
      anon_sym_AMP,
    ACTIONS(7779), 1,
      anon_sym_PIPE,
  [109495] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1100), 1,
      anon_sym_RPAREN,
    ACTIONS(7781), 1,
      anon_sym_COMMA,
    STATE(3906), 1,
      aux_sym_formal_parameters_repeat1,
  [109508] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    STATE(636), 1,
      sym_string,
  [109521] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7783), 1,
      anon_sym_COMMA,
    ACTIONS(7785), 1,
      anon_sym_GT,
    STATE(3948), 1,
      aux_sym_type_parameters_repeat1,
  [109534] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7787), 1,
      anon_sym_COMMA,
    ACTIONS(7789), 1,
      anon_sym_RBRACK,
    STATE(3950), 1,
      aux_sym_tuple_type_repeat1,
  [109547] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7791), 1,
      anon_sym_COMMA,
    ACTIONS(7793), 1,
      anon_sym_RPAREN,
    STATE(3951), 1,
      aux_sym_formal_parameters_repeat1,
  [109560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7797), 1,
      anon_sym_DOT,
    ACTIONS(7795), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [109571] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5357), 1,
      anon_sym_RPAREN,
    STATE(4049), 1,
      aux_sym_array_repeat1,
  [109584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5357), 1,
      anon_sym_RPAREN,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [109597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7799), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7801), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6580), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [109624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7436), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109633] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(7803), 1,
      anon_sym_RPAREN,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [109646] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(118), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1138), 1,
      anon_sym_LBRACE,
    STATE(797), 1,
      sym_object_type,
  [109659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7414), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_from,
  [109668] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7805), 1,
      anon_sym_COMMA,
    ACTIONS(7807), 1,
      anon_sym_RBRACK,
    STATE(4058), 1,
      aux_sym_tuple_type_repeat1,
  [109681] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4003), 1,
      anon_sym_GT,
    ACTIONS(7809), 1,
      anon_sym_COMMA,
    STATE(3934), 1,
      aux_sym_implements_clause_repeat1,
  [109694] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 1,
      sym_identifier,
    ACTIONS(7210), 1,
      anon_sym_LBRACK,
    ACTIONS(7212), 1,
      sym_private_property_identifier,
  [109707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6631), 1,
      anon_sym_LBRACE,
    ACTIONS(6633), 1,
      anon_sym_LBRACE_PIPE,
    STATE(797), 1,
      sym_object_type,
  [109720] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7811), 1,
      anon_sym_COMMA,
    ACTIONS(7813), 1,
      anon_sym_RBRACE,
    STATE(4070), 1,
      aux_sym_enum_body_repeat1,
  [109733] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5296), 1,
      anon_sym_RPAREN,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [109746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7815), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109755] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(7817), 1,
      anon_sym_RBRACK,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [109768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7815), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7819), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7821), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7823), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7823), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7825), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7827), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7825), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7815), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109849] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1193), 1,
      anon_sym_COMMA,
    ACTIONS(7431), 1,
      anon_sym_RBRACK,
    STATE(3909), 1,
      aux_sym_array_pattern_repeat1,
  [109862] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(7829), 1,
      anon_sym_RPAREN,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [109875] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5345), 1,
      anon_sym_RBRACK,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [109888] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7628), 1,
      anon_sym_COMMA,
    ACTIONS(7831), 1,
      anon_sym_RBRACE,
    STATE(3925), 1,
      aux_sym_object_repeat1,
  [109901] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5345), 1,
      anon_sym_RBRACK,
    STATE(3974), 1,
      aux_sym_array_repeat1,
  [109914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7628), 1,
      anon_sym_COMMA,
    ACTIONS(7833), 1,
      anon_sym_RBRACE,
    STATE(3925), 1,
      aux_sym_object_repeat1,
  [109927] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5296), 1,
      anon_sym_RPAREN,
    STATE(3978), 1,
      aux_sym_array_repeat1,
  [109940] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3725), 1,
      anon_sym_COLON,
    ACTIONS(7835), 1,
      anon_sym_RPAREN,
    STATE(4763), 1,
      sym_type_annotation,
  [109953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6101), 3,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_POUND,
  [109962] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1193), 1,
      anon_sym_COMMA,
    ACTIONS(7431), 1,
      anon_sym_RBRACK,
    STATE(3973), 1,
      aux_sym_array_pattern_repeat1,
  [109975] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3655), 1,
      anon_sym_RBRACK,
    ACTIONS(7837), 1,
      anon_sym_COMMA,
    STATE(3926), 1,
      aux_sym_tuple_type_repeat1,
  [109988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3649), 1,
      anon_sym_RBRACK,
    ACTIONS(7839), 1,
      anon_sym_COMMA,
    STATE(3926), 1,
      aux_sym_tuple_type_repeat1,
  [110001] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1090), 1,
      anon_sym_RPAREN,
    ACTIONS(7841), 1,
      anon_sym_COMMA,
    STATE(3906), 1,
      aux_sym_formal_parameters_repeat1,
  [110014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_COMMA,
    ACTIONS(7843), 1,
      anon_sym_RBRACE,
    STATE(3791), 1,
      aux_sym_js_import_statement_repeat1,
  [110027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5449), 1,
      anon_sym_COMMA,
    ACTIONS(7845), 1,
      anon_sym_RBRACE,
    STATE(3921), 1,
      aux_sym_object_pattern_repeat1,
  [110040] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    STATE(662), 1,
      sym_string,
  [110053] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7847), 1,
      anon_sym_COMMA,
    ACTIONS(7849), 1,
      anon_sym_RBRACE,
    STATE(4091), 1,
      aux_sym_enum_body_repeat1,
  [110066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7628), 1,
      anon_sym_COMMA,
    ACTIONS(7851), 1,
      anon_sym_RBRACE,
    STATE(3925), 1,
      aux_sym_object_repeat1,
  [110079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4015), 1,
      anon_sym_GT,
    ACTIONS(7853), 1,
      anon_sym_COMMA,
    STATE(3934), 1,
      aux_sym_implements_clause_repeat1,
  [110092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7628), 1,
      anon_sym_COMMA,
    ACTIONS(7851), 1,
      anon_sym_RBRACE,
    STATE(3986), 1,
      aux_sym_object_repeat1,
  [110105] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5449), 1,
      anon_sym_COMMA,
    ACTIONS(7845), 1,
      anon_sym_RBRACE,
    STATE(3987), 1,
      aux_sym_object_pattern_repeat1,
  [110118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3768), 1,
      anon_sym_DQUOTE,
    ACTIONS(3770), 1,
      anon_sym_SQUOTE,
    STATE(636), 1,
      sym_string,
  [110131] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7855), 1,
      anon_sym_COMMA,
    ACTIONS(7857), 1,
      anon_sym_RBRACE,
    STATE(4091), 1,
      aux_sym_enum_body_repeat1,
  [110144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7861), 1,
      anon_sym_BQUOTE,
    ACTIONS(7859), 2,
      anon_sym_LBRACE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
  [110155] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_COMMA,
    ACTIONS(7863), 1,
      anon_sym_from,
    STATE(3791), 1,
      aux_sym_js_import_statement_repeat1,
  [110168] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3768), 1,
      anon_sym_DQUOTE,
    ACTIONS(3770), 1,
      anon_sym_SQUOTE,
    STATE(668), 1,
      sym_string,
  [110181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7865), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110190] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(7867), 1,
      anon_sym_RPAREN,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [110203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7869), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110212] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7869), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7871), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7873), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7873), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7875), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110257] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5363), 1,
      anon_sym_RPAREN,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [110270] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5363), 1,
      anon_sym_RPAREN,
    STATE(4075), 1,
      aux_sym_array_repeat1,
  [110283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7877), 1,
      anon_sym_COMMA,
    ACTIONS(7879), 1,
      anon_sym_GT,
    STATE(4009), 1,
      aux_sym_type_parameters_repeat1,
  [110296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(7881), 1,
      anon_sym_RPAREN,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [110309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7185), 1,
      anon_sym_LBRACE,
    ACTIONS(7187), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [110320] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7883), 1,
      sym_identifier,
    ACTIONS(7885), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      sym_private_property_identifier,
  [110333] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7889), 1,
      sym_identifier,
    ACTIONS(7891), 1,
      anon_sym_LBRACK,
    ACTIONS(7893), 1,
      sym_private_property_identifier,
  [110346] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5282), 1,
      anon_sym_RPAREN,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [110359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5282), 1,
      anon_sym_RPAREN,
    STATE(4085), 1,
      aux_sym_array_repeat1,
  [110372] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7895), 1,
      anon_sym_COMMA,
    ACTIONS(7898), 1,
      anon_sym_RBRACE,
    STATE(4091), 1,
      aux_sym_enum_body_repeat1,
  [110385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7900), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7902), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7904), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110412] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7906), 1,
      sym_identifier,
    ACTIONS(7908), 1,
      anon_sym_LBRACK,
    ACTIONS(7910), 1,
      sym_private_property_identifier,
  [110425] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_AMP,
    ACTIONS(6327), 1,
      anon_sym_PIPE,
    ACTIONS(6329), 1,
      anon_sym_extends,
  [110438] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7912), 1,
      sym_identifier,
    ACTIONS(7914), 1,
      anon_sym_LBRACK,
    ACTIONS(7916), 1,
      sym_private_property_identifier,
  [110451] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7918), 1,
      anon_sym_COMMA,
    ACTIONS(7920), 1,
      anon_sym_RBRACK,
    STATE(4012), 1,
      aux_sym_tuple_type_repeat1,
  [110464] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4067), 1,
      anon_sym_GT,
    ACTIONS(7922), 1,
      anon_sym_COMMA,
    STATE(3934), 1,
      aux_sym_implements_clause_repeat1,
  [110477] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7924), 1,
      sym_identifier,
    STATE(2564), 1,
      sym_decorator_member_expression,
    STATE(2641), 1,
      sym_decorator_call_expression,
  [110490] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7926), 1,
      anon_sym_COMMA,
    ACTIONS(7928), 1,
      anon_sym_RPAREN,
    STATE(4016), 1,
      aux_sym_formal_parameters_repeat1,
  [110503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7930), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110512] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(7932), 1,
      anon_sym_RPAREN,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [110525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7934), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7936), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(6442), 1,
      anon_sym_PIPE,
    ACTIONS(6444), 1,
      anon_sym_extends,
  [110556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(7938), 1,
      anon_sym_RPAREN,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [110569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7243), 1,
      sym_identifier,
    ACTIONS(7245), 1,
      anon_sym_LBRACK,
    ACTIONS(7247), 1,
      sym_private_property_identifier,
  [110582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5302), 1,
      anon_sym_RPAREN,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [110595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6774), 1,
      anon_sym_AMP,
    ACTIONS(6776), 1,
      anon_sym_PIPE,
    ACTIONS(6778), 1,
      anon_sym_extends,
  [110608] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7940), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110617] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5304), 1,
      anon_sym_RPAREN,
    STATE(4136), 1,
      aux_sym_array_repeat1,
  [110630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5304), 1,
      anon_sym_RPAREN,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [110643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5302), 1,
      anon_sym_RPAREN,
    STATE(4028), 1,
      aux_sym_array_repeat1,
  [110656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7942), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5381), 1,
      anon_sym_RPAREN,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [110678] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5381), 1,
      anon_sym_RPAREN,
    STATE(4103), 1,
      aux_sym_array_repeat1,
  [110691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_COMMA,
    ACTIONS(7944), 1,
      anon_sym_from,
    STATE(3791), 1,
      aux_sym_js_import_statement_repeat1,
  [110704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7902), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110713] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7946), 1,
      anon_sym_COMMA,
    ACTIONS(7948), 1,
      anon_sym_RBRACK,
    STATE(4145), 1,
      aux_sym_tuple_type_repeat1,
  [110726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7950), 1,
      anon_sym_LBRACE,
    ACTIONS(7055), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [110737] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6346), 1,
      anon_sym_AMP,
    ACTIONS(6350), 1,
      anon_sym_extends,
    ACTIONS(7064), 1,
      anon_sym_PIPE,
  [110750] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    STATE(650), 1,
      sym_string,
  [110763] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_COMMA,
    ACTIONS(7952), 1,
      anon_sym_RBRACE,
    STATE(4061), 1,
      aux_sym_js_import_statement_repeat1,
  [110776] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5300), 1,
      anon_sym_RBRACK,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [110789] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5300), 1,
      anon_sym_RBRACK,
    STATE(4038), 1,
      aux_sym_array_repeat1,
  [110802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3768), 1,
      anon_sym_DQUOTE,
    ACTIONS(3770), 1,
      anon_sym_SQUOTE,
    STATE(662), 1,
      sym_string,
  [110815] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 1,
      anon_sym_DQUOTE,
    ACTIONS(1156), 1,
      anon_sym_SQUOTE,
    STATE(668), 1,
      sym_string,
  [110828] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4741), 1,
      anon_sym_extends,
    ACTIONS(7954), 1,
      anon_sym_AMP,
    ACTIONS(7956), 1,
      anon_sym_PIPE,
  [110841] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7958), 1,
      sym_identifier,
    STATE(3349), 1,
      sym_new_component_expression,
    STATE(3709), 1,
      sym_nested_identifier,
  [110854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7960), 1,
      anon_sym_LBRACE,
    ACTIONS(7220), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [110865] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5365), 1,
      anon_sym_RPAREN,
    STATE(4107), 1,
      aux_sym_array_repeat1,
  [110878] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7628), 1,
      anon_sym_COMMA,
    ACTIONS(7962), 1,
      anon_sym_RBRACE,
    STATE(3925), 1,
      aux_sym_object_repeat1,
  [110891] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7628), 1,
      anon_sym_COMMA,
    ACTIONS(7962), 1,
      anon_sym_RBRACE,
    STATE(4051), 1,
      aux_sym_object_repeat1,
  [110904] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3768), 1,
      anon_sym_DQUOTE,
    ACTIONS(3770), 1,
      anon_sym_SQUOTE,
    STATE(650), 1,
      sym_string,
  [110917] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(7964), 1,
      anon_sym_RPAREN,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [110930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3361), 1,
      anon_sym_LBRACE,
    ACTIONS(3363), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [110941] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1272), 1,
      anon_sym_COMMA,
    ACTIONS(5365), 1,
      anon_sym_RPAREN,
    STATE(3840), 1,
      aux_sym_array_repeat1,
  [110954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7966), 1,
      sym_identifier,
    STATE(1454), 1,
      sym_decorator_member_expression,
    STATE(1468), 1,
      sym_decorator_call_expression,
  [110967] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7968), 1,
      sym_identifier,
    ACTIONS(7970), 1,
      anon_sym_LBRACK,
    ACTIONS(7972), 1,
      sym_private_property_identifier,
  [110980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7974), 1,
      sym_identifier,
    ACTIONS(7976), 1,
      anon_sym_LBRACK,
    ACTIONS(7978), 1,
      sym_private_property_identifier,
  [110993] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7980), 1,
      sym_identifier,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(7984), 1,
      sym_private_property_identifier,
  [111006] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7986), 1,
      sym_identifier,
    ACTIONS(7988), 1,
      anon_sym_LBRACK,
    ACTIONS(7990), 1,
      sym_private_property_identifier,
  [111019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3309), 1,
      anon_sym_LBRACE,
    ACTIONS(3311), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [111030] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3647), 1,
      anon_sym_RBRACK,
    ACTIONS(7992), 1,
      anon_sym_COMMA,
    STATE(3926), 1,
      aux_sym_tuple_type_repeat1,
  [111043] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7994), 1,
      anon_sym_COMMA,
    ACTIONS(7996), 1,
      anon_sym_RPAREN,
    STATE(4060), 1,
      aux_sym_formal_parameters_repeat1,
  [111056] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7998), 1,
      sym_identifier,
    STATE(1468), 1,
      sym_decorator_call_expression,
    STATE(3208), 1,
      sym_decorator_member_expression,
  [111069] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4011), 1,
      anon_sym_GT,
    ACTIONS(8000), 1,
      anon_sym_COMMA,
    STATE(3934), 1,
      aux_sym_implements_clause_repeat1,
  [111082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_DOT,
  [111091] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8002), 1,
      anon_sym_COMMA,
    ACTIONS(8004), 1,
      anon_sym_RBRACK,
    STATE(4059), 1,
      aux_sym_tuple_type_repeat1,
  [111104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6576), 1,
      anon_sym_EQ,
    ACTIONS(4110), 2,
      anon_sym_in,
      anon_sym_of,
  [111115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8006), 1,
      sym_identifier,
    ACTIONS(8008), 1,
      sym_private_property_identifier,
  [111125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(1551), 1,
      sym_statement_block,
  [111135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8010), 1,
      sym_identifier,
    ACTIONS(8012), 1,
      sym_private_property_identifier,
  [111145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7968), 1,
      sym_identifier,
    ACTIONS(7972), 1,
      sym_private_property_identifier,
  [111155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8014), 1,
      sym_identifier,
    ACTIONS(8016), 1,
      sym_private_property_identifier,
  [111165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8018), 1,
      sym_identifier,
    ACTIONS(8020), 1,
      sym_private_property_identifier,
  [111175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4875), 1,
      sym_formal_parameters,
  [111185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2014), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [111193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3696), 1,
      anon_sym_LPAREN,
    STATE(2877), 1,
      sym_arguments,
  [111203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4870), 1,
      sym_formal_parameters,
  [111213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6126), 1,
      anon_sym_LPAREN,
    STATE(3115), 1,
      sym_formal_parameters,
  [111223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8022), 1,
      sym_identifier,
    ACTIONS(8024), 1,
      anon_sym_RBRACE,
  [111233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    STATE(2259), 1,
      sym_class_body,
  [111243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 1,
      anon_sym_LBRACE,
    STATE(608), 1,
      sym_component_body,
  [111253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 1,
      anon_sym_LBRACE,
    STATE(610), 1,
      sym_component_body,
  [111263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7179), 1,
      anon_sym_LBRACE,
    STATE(2256), 1,
      sym_statement_block,
  [111273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4699), 1,
      sym_formal_parameters,
  [111283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2244), 1,
      sym_component_body,
  [111293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2198), 1,
      sym_component_body,
  [111303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4686), 1,
      sym_formal_parameters,
  [111313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4678), 1,
      sym_formal_parameters,
  [111323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7916), 1,
      sym_private_property_identifier,
    ACTIONS(8026), 1,
      sym_identifier,
  [111333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5259), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [111341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8028), 1,
      sym_identifier,
    ACTIONS(8030), 1,
      sym_private_property_identifier,
  [111351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8032), 1,
      sym_identifier,
    STATE(1611), 1,
      sym_property_declaration_name,
  [111361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8034), 1,
      sym_identifier,
    STATE(3063), 1,
      sym_import_path_segment,
  [111371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2138), 1,
      sym_component_body,
  [111381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7576), 1,
      sym_identifier,
    STATE(4018), 1,
      sym_type_parameter,
  [111391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7912), 1,
      sym_identifier,
    ACTIONS(7916), 1,
      sym_private_property_identifier,
  [111401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8036), 1,
      anon_sym_LPAREN,
    STATE(4243), 1,
      sym_formal_type_parameters,
  [111411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8032), 1,
      sym_identifier,
    STATE(1526), 1,
      sym_property_declaration_name,
  [111421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8038), 1,
      sym_identifier,
    ACTIONS(8040), 1,
      sym_private_property_identifier,
  [111431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8042), 1,
      sym_identifier,
    ACTIONS(8044), 1,
      sym_private_property_identifier,
  [111441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6246), 1,
      anon_sym_LPAREN,
    STATE(2977), 1,
      sym_arguments,
  [111451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4751), 1,
      sym_formal_parameters,
  [111461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8032), 1,
      sym_identifier,
    STATE(1523), 1,
      sym_property_declaration_name,
  [111471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8046), 1,
      sym_identifier,
    ACTIONS(8048), 1,
      sym_private_property_identifier,
  [111481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(701), 1,
      sym_statement_block,
  [111491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 1,
      anon_sym_LBRACE,
    STATE(694), 1,
      sym_statement_block,
  [111501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 1,
      anon_sym_LBRACE,
    STATE(602), 1,
      sym_component_body,
  [111511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(689), 1,
      sym_statement_block,
  [111521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 1,
      anon_sym_LBRACE,
    STATE(600), 1,
      sym_component_body,
  [111531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6011), 1,
      anon_sym_LBRACE,
    STATE(3195), 1,
      sym_new_component_body,
  [111541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2147), 1,
      sym_component_body,
  [111551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 1,
      anon_sym_LBRACE,
    STATE(595), 1,
      sym_component_body,
  [111561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8050), 1,
      sym_identifier,
    STATE(652), 1,
      sym_import_path_segment,
  [111571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 1,
      anon_sym_LBRACE,
    STATE(596), 1,
      sym_component_body,
  [111581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5895), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    STATE(2148), 1,
      sym_class_body,
  [111599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 1,
      anon_sym_LBRACE,
    STATE(678), 1,
      sym_statement_block,
  [111609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    STATE(3165), 1,
      sym_formal_parameters,
  [111619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7179), 1,
      anon_sym_LBRACE,
    STATE(2149), 1,
      sym_statement_block,
  [111629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5881), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4199), 1,
      sym_statement_block,
  [111647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5877), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2403), 1,
      anon_sym_LBRACE,
    STATE(701), 1,
      sym_statement_block,
  [111665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    STATE(3050), 1,
      sym_formal_parameters,
  [111675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2157), 1,
      sym_component_body,
  [111685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2159), 1,
      sym_component_body,
  [111695] = 2,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(8052), 2,
      sym__glimmer_template_content,
      anon_sym_LT_SLASHtemplate_GT,
  [111703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3570), 1,
      sym_formal_parameters,
  [111713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    STATE(2165), 1,
      sym_class_body,
  [111723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6624), 1,
      anon_sym_LBRACE,
    STATE(178), 1,
      sym_component_body,
  [111741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4650), 1,
      anon_sym_LPAREN,
    STATE(1717), 1,
      sym_arguments,
  [111751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2166), 1,
      sym_component_body,
  [111761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    STATE(2219), 1,
      sym_class_body,
  [111771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7179), 1,
      anon_sym_LBRACE,
    STATE(2269), 1,
      sym_statement_block,
  [111781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7179), 1,
      anon_sym_LBRACE,
    STATE(2281), 1,
      sym_statement_block,
  [111791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4204), 1,
      sym_statement_block,
  [111801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5873), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4206), 1,
      sym_statement_block,
  [111819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6448), 1,
      anon_sym_LBRACE,
    STATE(842), 1,
      sym_class_body,
  [111837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7179), 1,
      anon_sym_LBRACE,
    STATE(2290), 1,
      sym_statement_block,
  [111847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3540), 1,
      sym_formal_parameters,
  [111857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3725), 1,
      anon_sym_COLON,
    STATE(4339), 1,
      sym_type_annotation,
  [111867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2301), 1,
      sym_component_body,
  [111877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8054), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2302), 1,
      sym_component_body,
  [111895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4660), 1,
      sym_formal_parameters,
  [111905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3877), 1,
      anon_sym_LPAREN,
    STATE(2741), 1,
      sym_arguments,
  [111915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6422), 1,
      anon_sym_LBRACE,
    STATE(695), 1,
      sym_class_body,
  [111925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7085), 1,
      anon_sym_LBRACE,
    STATE(694), 1,
      sym_statement_block,
  [111935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8032), 1,
      sym_identifier,
    STATE(1527), 1,
      sym_property_declaration_name,
  [111945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8032), 1,
      sym_identifier,
    STATE(1524), 1,
      sym_property_declaration_name,
  [111955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2403), 1,
      anon_sym_LBRACE,
    STATE(689), 1,
      sym_statement_block,
  [111965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7149), 1,
      anon_sym_in,
    ACTIONS(7151), 1,
      anon_sym_of,
  [111975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8036), 1,
      anon_sym_LPAREN,
    STATE(4349), 1,
      sym_formal_type_parameters,
  [111985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5829), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7179), 1,
      anon_sym_LBRACE,
    STATE(2170), 1,
      sym_statement_block,
  [112003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(1544), 1,
      sym_statement_block,
  [112013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8056), 1,
      anon_sym_LPAREN,
    STATE(1552), 1,
      sym_formal_type_parameters,
  [112023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5833), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [112031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8036), 1,
      anon_sym_LPAREN,
    STATE(3522), 1,
      sym_formal_type_parameters,
  [112041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    STATE(2177), 1,
      sym_class_body,
  [112051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 1,
      anon_sym_LBRACE,
    STATE(613), 1,
      sym_component_body,
  [112061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8058), 1,
      anon_sym_async,
    ACTIONS(8060), 1,
      anon_sym_fn,
  [112071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 1,
      anon_sym_LBRACE,
    STATE(623), 1,
      sym_component_body,
  [112081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 1,
      anon_sym_LBRACE,
    STATE(625), 1,
      sym_component_body,
  [112091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2190), 1,
      sym_component_body,
  [112101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2192), 1,
      sym_component_body,
  [112111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4222), 1,
      sym_statement_block,
  [112121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    STATE(2300), 1,
      sym_class_body,
  [112131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2203), 1,
      sym_component_body,
  [112141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2304), 1,
      sym_component_body,
  [112151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5829), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [112159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7576), 1,
      sym_identifier,
    STATE(4084), 1,
      sym_type_parameter,
  [112169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2314), 1,
      sym_component_body,
  [112179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4224), 1,
      sym_statement_block,
  [112189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5833), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [112197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4750), 1,
      sym_formal_parameters,
  [112207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2313), 1,
      sym_component_body,
  [112217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6422), 1,
      anon_sym_LBRACE,
    STATE(691), 1,
      sym_class_body,
  [112227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6448), 1,
      anon_sym_LBRACE,
    STATE(737), 1,
      sym_class_body,
  [112237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6438), 1,
      anon_sym_LBRACE,
    STATE(170), 1,
      sym_class_body,
  [112247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    STATE(1765), 1,
      sym_class_body,
  [112257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8062), 1,
      anon_sym_LBRACE,
    STATE(1770), 1,
      sym_statement_block,
  [112267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(1777), 1,
      sym_component_body,
  [112277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8064), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [112285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8066), 1,
      sym_identifier,
    ACTIONS(8068), 1,
      sym_private_property_identifier,
  [112295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8070), 1,
      sym_identifier,
    ACTIONS(8072), 1,
      anon_sym_STAR,
  [112305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    STATE(2226), 1,
      sym_class_body,
  [112315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(727), 1,
      sym_statement_block,
  [112325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6448), 1,
      anon_sym_LBRACE,
    STATE(787), 1,
      sym_class_body,
  [112335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6422), 1,
      anon_sym_LBRACE,
    STATE(679), 1,
      sym_class_body,
  [112345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7085), 1,
      anon_sym_LBRACE,
    STATE(678), 1,
      sym_statement_block,
  [112355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6438), 1,
      anon_sym_LBRACE,
    STATE(209), 1,
      sym_class_body,
  [112365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7098), 1,
      anon_sym_LBRACE,
    STATE(223), 1,
      sym_statement_block,
  [112375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8074), 1,
      sym_identifier,
    ACTIONS(8076), 1,
      sym_private_property_identifier,
  [112385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6390), 2,
      anon_sym_in,
      anon_sym_of,
  [112393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8078), 1,
      sym_identifier,
    ACTIONS(8080), 1,
      sym_private_property_identifier,
  [112403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3599), 1,
      sym_formal_parameters,
  [112413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8082), 1,
      sym_identifier,
    ACTIONS(8084), 1,
      anon_sym_STAR,
  [112423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4669), 1,
      sym_formal_parameters,
  [112433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7001), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [112441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(1781), 1,
      sym_component_body,
  [112451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8086), 1,
      sym_identifier,
    ACTIONS(8088), 1,
      sym_private_property_identifier,
  [112461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6612), 1,
      anon_sym_LBRACE,
    STATE(1032), 1,
      sym_component_body,
  [112471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 1,
      anon_sym_LBRACE,
    STATE(1019), 1,
      sym_class_body,
  [112481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5837), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [112489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5841), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [112497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8090), 1,
      anon_sym_LBRACE,
    STATE(1013), 1,
      sym_statement_block,
  [112507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8092), 1,
      sym_identifier,
    ACTIONS(8094), 1,
      sym_private_property_identifier,
  [112517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    STATE(3211), 1,
      sym_formal_parameters,
  [112527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7699), 1,
      sym_identifier,
    ACTIONS(7703), 1,
      sym_private_property_identifier,
  [112537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2245), 1,
      sym_component_body,
  [112547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8096), 1,
      sym_identifier,
    ACTIONS(8098), 1,
      sym_private_property_identifier,
  [112557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 1,
      anon_sym_LBRACE,
    STATE(1022), 1,
      sym_class_body,
  [112567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(813), 1,
      sym_statement_block,
  [112577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8100), 1,
      sym_identifier,
    ACTIONS(8102), 1,
      sym_private_property_identifier,
  [112587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    STATE(2276), 1,
      sym_class_body,
  [112597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8090), 1,
      anon_sym_LBRACE,
    STATE(1015), 1,
      sym_statement_block,
  [112607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8104), 1,
      sym_identifier,
    ACTIONS(8106), 1,
      sym_private_property_identifier,
  [112617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4258), 1,
      sym_statement_block,
  [112627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5837), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [112635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4262), 1,
      sym_statement_block,
  [112645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5841), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [112653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6624), 1,
      anon_sym_LBRACE,
    STATE(171), 1,
      sym_component_body,
  [112663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6624), 1,
      anon_sym_LBRACE,
    STATE(172), 1,
      sym_component_body,
  [112673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6612), 1,
      anon_sym_LBRACE,
    STATE(994), 1,
      sym_component_body,
  [112683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6438), 1,
      anon_sym_LBRACE,
    STATE(180), 1,
      sym_class_body,
  [112693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6624), 1,
      anon_sym_LBRACE,
    STATE(181), 1,
      sym_component_body,
  [112703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4626), 1,
      sym_formal_parameters,
  [112713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8108), 1,
      sym_identifier,
    ACTIONS(8110), 1,
      sym_private_property_identifier,
  [112723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7179), 1,
      anon_sym_LBRACE,
    STATE(2273), 1,
      sym_statement_block,
  [112733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6448), 1,
      anon_sym_LBRACE,
    STATE(806), 1,
      sym_class_body,
  [112743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3621), 1,
      sym_formal_parameters,
  [112753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    STATE(2225), 1,
      sym_class_body,
  [112763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6422), 1,
      anon_sym_LBRACE,
    STATE(692), 1,
      sym_class_body,
  [112773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7098), 1,
      anon_sym_LBRACE,
    STATE(200), 1,
      sym_statement_block,
  [112783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5861), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [112791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8112), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [112799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7179), 1,
      anon_sym_LBRACE,
    STATE(2267), 1,
      sym_statement_block,
  [112809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3562), 1,
      sym_formal_parameters,
  [112819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2264), 1,
      sym_component_body,
  [112829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4543), 1,
      sym_formal_parameters,
  [112839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8114), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [112847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6612), 1,
      anon_sym_LBRACE,
    STATE(1037), 1,
      sym_component_body,
  [112857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4799), 1,
      anon_sym_LPAREN,
    STATE(1997), 1,
      sym_arguments,
  [112867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8116), 1,
      sym_identifier,
    ACTIONS(8118), 1,
      sym_private_property_identifier,
  [112877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5861), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [112885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5865), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [112893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8120), 1,
      sym_identifier,
    ACTIONS(8122), 1,
      sym_private_property_identifier,
  [112903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8124), 1,
      anon_sym_LPAREN,
    STATE(43), 1,
      sym__for_header,
  [112913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8126), 1,
      sym_identifier,
    ACTIONS(8128), 1,
      sym_private_property_identifier,
  [112923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3725), 1,
      anon_sym_COLON,
    STATE(4473), 1,
      sym_type_annotation,
  [112933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8130), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [112941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2010), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [112949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8132), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [112957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    STATE(2260), 1,
      sym_class_body,
  [112967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(3558), 1,
      sym_formal_parameters,
  [112977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8134), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [112985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    STATE(2242), 1,
      sym_class_body,
  [112995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2235), 1,
      sym_component_body,
  [113005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8036), 1,
      anon_sym_LPAREN,
    STATE(3646), 1,
      sym_formal_type_parameters,
  [113015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2116), 1,
      sym_component_body,
  [113025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(1553), 1,
      sym_statement_block,
  [113035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4307), 1,
      sym_statement_block,
  [113045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5865), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [113053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4309), 1,
      sym_statement_block,
  [113063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5891), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [113071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8032), 1,
      sym_identifier,
    STATE(1578), 1,
      sym_property_declaration_name,
  [113081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4394), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [113089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8136), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [113097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(1563), 1,
      sym_statement_block,
  [113107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6624), 1,
      anon_sym_LBRACE,
    STATE(196), 1,
      sym_component_body,
  [113117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6624), 1,
      anon_sym_LBRACE,
    STATE(195), 1,
      sym_component_body,
  [113127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4703), 1,
      sym_formal_parameters,
  [113137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7179), 1,
      anon_sym_LBRACE,
    STATE(2272), 1,
      sym_statement_block,
  [113147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6624), 1,
      anon_sym_LBRACE,
    STATE(168), 1,
      sym_component_body,
  [113157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6624), 1,
      anon_sym_LBRACE,
    STATE(193), 1,
      sym_component_body,
  [113167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4442), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [113175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8138), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [113183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8140), 1,
      sym_identifier,
    ACTIONS(8142), 1,
      anon_sym_RBRACE,
  [113193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4707), 1,
      sym_formal_parameters,
  [113203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4863), 1,
      sym_formal_parameters,
  [113213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4772), 1,
      sym_formal_parameters,
  [113223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8144), 1,
      sym_identifier,
    ACTIONS(8146), 1,
      anon_sym_STAR,
  [113233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4815), 1,
      sym_formal_parameters,
  [113243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6438), 1,
      anon_sym_LBRACE,
    STATE(218), 1,
      sym_class_body,
  [113253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 1,
      anon_sym_LBRACE,
    STATE(627), 1,
      sym_component_body,
  [113263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2403), 1,
      anon_sym_LBRACE,
    STATE(727), 1,
      sym_statement_block,
  [113273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7179), 1,
      anon_sym_LBRACE,
    STATE(2274), 1,
      sym_statement_block,
  [113283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8148), 1,
      anon_sym_LPAREN,
    STATE(4324), 1,
      sym_parenthesized_expression,
  [113293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8150), 1,
      anon_sym_COLON,
    ACTIONS(8152), 1,
      anon_sym_EQ,
  [113303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6354), 1,
      anon_sym_LBRACE,
    STATE(2268), 1,
      sym_class_body,
  [113313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4754), 1,
      sym_formal_parameters,
  [113323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8154), 1,
      anon_sym_LBRACE,
    STATE(866), 1,
      sym_enum_body,
  [113333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_LBRACE,
    STATE(2182), 1,
      sym_component_body,
  [113343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4519), 1,
      sym_formal_parameters,
  [113353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4709), 1,
      sym_formal_parameters,
  [113363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7617), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [113371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    STATE(4024), 1,
      sym_type_annotation,
  [113381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8156), 1,
      sym_identifier,
    STATE(4021), 1,
      sym_nested_identifier,
  [113391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4689), 1,
      sym_formal_parameters,
  [113401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(2452), 1,
      sym_component_body,
  [113411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    STATE(2455), 1,
      sym_class_body,
  [113421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4506), 1,
      sym_statement_block,
  [113431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6204), 1,
      anon_sym_is,
    ACTIONS(6564), 1,
      anon_sym_LBRACE,
  [113441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7574), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [113449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4564), 1,
      sym_formal_parameters,
  [113459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LPAREN,
    STATE(48), 1,
      sym_parenthesized_expression,
  [113469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(1825), 1,
      sym_component_body,
  [113479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    STATE(1826), 1,
      sym_class_body,
  [113489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8062), 1,
      anon_sym_LBRACE,
    STATE(1827), 1,
      sym_statement_block,
  [113499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4576), 1,
      sym_formal_parameters,
  [113509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6612), 1,
      anon_sym_LBRACE,
    STATE(1003), 1,
      sym_component_body,
  [113519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6612), 1,
      anon_sym_LBRACE,
    STATE(981), 1,
      sym_component_body,
  [113529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 1,
      anon_sym_LBRACE,
    STATE(1068), 1,
      sym_class_body,
  [113539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4577), 1,
      sym_formal_parameters,
  [113549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 1,
      anon_sym_LBRACE,
    STATE(1063), 1,
      sym_class_body,
  [113559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 1,
      anon_sym_LBRACE,
    STATE(1000), 1,
      sym_class_body,
  [113569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8090), 1,
      anon_sym_LBRACE,
    STATE(982), 1,
      sym_statement_block,
  [113579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8090), 1,
      anon_sym_LBRACE,
    STATE(1043), 1,
      sym_statement_block,
  [113589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5869), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [113597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4351), 1,
      sym_statement_block,
  [113607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5891), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [113615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4323), 1,
      sym_statement_block,
  [113625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8090), 1,
      anon_sym_LBRACE,
    STATE(1042), 1,
      sym_statement_block,
  [113635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 1,
      anon_sym_LBRACE,
    STATE(997), 1,
      sym_class_body,
  [113645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7708), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [113653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4476), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [113661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8160), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [113669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    STATE(1804), 1,
      sym_class_body,
  [113679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(1546), 1,
      sym_statement_block,
  [113689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3736), 1,
      anon_sym_EQ,
    STATE(1547), 1,
      sym_property_expression_initializer,
  [113699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6612), 1,
      anon_sym_LBRACE,
    STATE(1039), 1,
      sym_component_body,
  [113709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    STATE(1806), 1,
      sym_class_body,
  [113719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6624), 1,
      anon_sym_LBRACE,
    STATE(204), 1,
      sym_component_body,
  [113729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6612), 1,
      anon_sym_LBRACE,
    STATE(1038), 1,
      sym_component_body,
  [113739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6624), 1,
      anon_sym_LBRACE,
    STATE(214), 1,
      sym_component_body,
  [113749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8062), 1,
      anon_sym_LBRACE,
    STATE(1808), 1,
      sym_statement_block,
  [113759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8062), 1,
      anon_sym_LBRACE,
    STATE(1811), 1,
      sym_statement_block,
  [113769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8154), 1,
      anon_sym_LBRACE,
    STATE(839), 1,
      sym_enum_body,
  [113779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8062), 1,
      anon_sym_LBRACE,
    STATE(1812), 1,
      sym_statement_block,
  [113789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2403), 1,
      anon_sym_LBRACE,
    STATE(813), 1,
      sym_statement_block,
  [113799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8162), 1,
      sym_identifier,
    ACTIONS(8164), 1,
      anon_sym_STAR,
  [113809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(1815), 1,
      sym_component_body,
  [113819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(1816), 1,
      sym_component_body,
  [113829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6612), 1,
      anon_sym_LBRACE,
    STATE(993), 1,
      sym_component_body,
  [113839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7015), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [113847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 1,
      anon_sym_LBRACE,
    STATE(1030), 1,
      sym_class_body,
  [113857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8166), 1,
      sym_identifier,
    ACTIONS(8168), 1,
      sym_private_property_identifier,
  [113867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5326), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [113875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5324), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [113883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [113891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8172), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [113899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7021), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [113907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8124), 1,
      anon_sym_LPAREN,
    STATE(49), 1,
      sym__for_header,
  [113917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8174), 1,
      anon_sym_LBRACE,
    STATE(729), 1,
      sym_switch_body,
  [113927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    STATE(1818), 1,
      sym_class_body,
  [113937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7600), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [113945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8176), 1,
      sym_identifier,
    ACTIONS(8178), 1,
      sym_private_property_identifier,
  [113955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(1822), 1,
      sym_component_body,
  [113965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(1823), 1,
      sym_component_body,
  [113975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4133), 1,
      anon_sym_LPAREN,
    STATE(3331), 1,
      sym_formal_parameters,
  [113985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4594), 1,
      sym_formal_parameters,
  [113995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7703), 1,
      sym_private_property_identifier,
    ACTIONS(8180), 1,
      sym_identifier,
  [114005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8182), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      sym_private_property_identifier,
  [114015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8186), 1,
      sym_identifier,
    ACTIONS(8188), 1,
      sym_private_property_identifier,
  [114025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6612), 1,
      anon_sym_LBRACE,
    STATE(1020), 1,
      sym_component_body,
  [114035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4903), 1,
      sym_formal_parameters,
  [114045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6612), 1,
      anon_sym_LBRACE,
    STATE(1017), 1,
      sym_component_body,
  [114055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8090), 1,
      anon_sym_LBRACE,
    STATE(992), 1,
      sym_statement_block,
  [114065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(1559), 1,
      sym_statement_block,
  [114075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7576), 1,
      sym_identifier,
    STATE(4476), 1,
      sym_type_parameter,
  [114085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(2462), 1,
      sym_component_body,
  [114095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(2373), 1,
      sym_component_body,
  [114105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7567), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [114113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    STATE(2482), 1,
      sym_class_body,
  [114123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    STATE(2466), 1,
      sym_class_body,
  [114133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8190), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [114141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8090), 1,
      anon_sym_LBRACE,
    STATE(991), 1,
      sym_statement_block,
  [114151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4794), 1,
      sym_formal_parameters,
  [114161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8192), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [114169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8194), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [114177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    STATE(2432), 1,
      sym_class_body,
  [114187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8090), 1,
      anon_sym_LBRACE,
    STATE(990), 1,
      sym_statement_block,
  [114197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(2467), 1,
      sym_component_body,
  [114207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(2454), 1,
      sym_component_body,
  [114217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8196), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [114225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7622), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [114233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8198), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [114241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7583), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [114249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7638), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [114257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 1,
      anon_sym_LBRACE,
    STATE(989), 1,
      sym_class_body,
  [114267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2556), 1,
      anon_sym_LPAREN,
    STATE(895), 1,
      sym_arguments,
  [114277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8200), 1,
      anon_sym_in,
    ACTIONS(8202), 1,
      anon_sym_COLON,
  [114287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LPAREN,
    STATE(45), 1,
      sym_parenthesized_expression,
  [114297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4597), 1,
      sym_formal_parameters,
  [114307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LPAREN,
    STATE(51), 1,
      sym_parenthesized_expression,
  [114317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(1844), 1,
      sym_component_body,
  [114327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(1843), 1,
      sym_component_body,
  [114337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LPAREN,
    STATE(4442), 1,
      sym_parenthesized_expression,
  [114347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    STATE(1841), 1,
      sym_class_body,
  [114357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    STATE(1839), 1,
      sym_class_body,
  [114367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LPAREN,
    STATE(54), 1,
      sym_parenthesized_expression,
  [114377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6564), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [114385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6091), 1,
      anon_sym_is,
    ACTIONS(6564), 1,
      anon_sym_EQ_GT,
  [114395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2403), 1,
      anon_sym_LBRACE,
    STATE(590), 1,
      sym_statement_block,
  [114405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4693), 1,
      sym_formal_parameters,
  [114415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6514), 1,
      anon_sym_LBRACE,
    STATE(1838), 1,
      sym_component_body,
  [114425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym_LPAREN,
    STATE(4518), 1,
      sym_formal_parameters,
  [114435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8062), 1,
      anon_sym_LBRACE,
    STATE(1837), 1,
      sym_statement_block,
  [114445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8062), 1,
      anon_sym_LBRACE,
    STATE(1836), 1,
      sym_statement_block,
  [114455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8062), 1,
      anon_sym_LBRACE,
    STATE(1835), 1,
      sym_statement_block,
  [114465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LPAREN,
    STATE(36), 1,
      sym_parenthesized_expression,
  [114475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(3510), 1,
      sym_statement_block,
  [114485] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8204), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [114493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6362), 1,
      anon_sym_LBRACE,
    STATE(1833), 1,
      sym_class_body,
  [114503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5330), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [114511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      anon_sym_LPAREN,
    STATE(46), 1,
      sym_parenthesized_expression,
  [114521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8036), 1,
      anon_sym_LPAREN,
    STATE(3629), 1,
      sym_formal_type_parameters,
  [114531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5853), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [114539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4407), 1,
      sym_statement_block,
  [114549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6616), 1,
      anon_sym_COLON,
    STATE(3853), 1,
      sym_type_annotation,
  [114559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4480), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [114567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8206), 1,
      anon_sym_COLON,
    ACTIONS(8208), 1,
      anon_sym_EQ,
  [114577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      anon_sym_LBRACE,
    STATE(4409), 1,
      sym_statement_block,
  [114587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8210), 1,
      sym_number,
  [114594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8212), 1,
      anon_sym_RBRACK,
  [114601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8214), 1,
      anon_sym_LBRACE,
  [114608] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5463), 1,
      anon_sym_RBRACE,
  [114615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8216), 1,
      sym_identifier,
  [114622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8218), 1,
      anon_sym_RBRACK,
  [114629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8220), 1,
      anon_sym_EQ_GT,
  [114636] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8222), 1,
      anon_sym_EQ_GT,
  [114643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8224), 1,
      anon_sym_RBRACK,
  [114650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8226), 1,
      anon_sym_RBRACK,
  [114657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8228), 1,
      anon_sym_RBRACK,
  [114664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8230), 1,
      anon_sym_RBRACK,
  [114671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8232), 1,
      anon_sym_EQ,
  [114678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8234), 1,
      sym_identifier,
  [114685] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8236), 1,
      sym_identifier,
  [114692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8238), 1,
      anon_sym_class,
  [114699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8240), 1,
      anon_sym_RBRACK,
  [114706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8242), 1,
      sym_identifier,
  [114713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8244), 1,
      anon_sym_RBRACK,
  [114720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8246), 1,
      anon_sym_RBRACK,
  [114727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8248), 1,
      anon_sym_EQ_GT,
  [114734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8250), 1,
      anon_sym_RBRACK,
  [114741] = 2,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(8252), 1,
      sym_regex_pattern,
  [114748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5239), 1,
      anon_sym_RPAREN,
  [114755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5411), 1,
      anon_sym_RBRACK,
  [114762] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7604), 1,
      anon_sym_RBRACK,
  [114769] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6313), 1,
      anon_sym_is,
  [114776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8254), 1,
      anon_sym_RBRACK,
  [114783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6138), 1,
      anon_sym_DOT,
  [114790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8256), 1,
      anon_sym_SLASH2,
  [114797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8258), 1,
      anon_sym_RBRACK,
  [114804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8260), 1,
      anon_sym_EQ_GT,
  [114811] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8262), 1,
      anon_sym_COLON,
  [114818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8264), 1,
      anon_sym_RBRACK,
  [114825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8266), 1,
      anon_sym_RBRACK,
  [114832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8268), 1,
      anon_sym_RBRACK,
  [114839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8270), 1,
      anon_sym_EQ,
  [114846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8272), 1,
      anon_sym_RBRACK,
  [114853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8274), 1,
      anon_sym_RBRACK,
  [114860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8276), 1,
      anon_sym_RBRACK,
  [114867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_RBRACK,
  [114874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8280), 1,
      anon_sym_RBRACK,
  [114881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8282), 1,
      anon_sym_RBRACK,
  [114888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8284), 1,
      anon_sym_RBRACK,
  [114895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8286), 1,
      anon_sym_EQ_GT,
  [114902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8288), 1,
      anon_sym_EQ_GT,
  [114909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8290), 1,
      anon_sym_EQ_GT,
  [114916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4550), 1,
      anon_sym_DOT,
  [114923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8292), 1,
      anon_sym_EQ_GT,
  [114930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8294), 1,
      sym_identifier,
  [114937] = 2,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(8296), 1,
      sym_regex_pattern,
  [114944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8298), 1,
      anon_sym_RBRACK,
  [114951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8300), 1,
      anon_sym_EQ_GT,
  [114958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8302), 1,
      anon_sym_RBRACK,
  [114965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8304), 1,
      anon_sym_RBRACK,
  [114972] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8306), 1,
      anon_sym_RBRACK,
  [114979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8308), 1,
      anon_sym_RBRACK,
  [114986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8310), 1,
      anon_sym_RBRACK,
  [114993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8312), 1,
      anon_sym_RBRACK,
  [115000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8314), 1,
      anon_sym_RBRACK,
  [115007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8316), 1,
      anon_sym_RBRACK,
  [115014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8318), 1,
      anon_sym_RBRACK,
  [115021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
  [115028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8322), 1,
      anon_sym_RBRACK,
  [115035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8324), 1,
      anon_sym_EQ_GT,
  [115042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8326), 1,
      anon_sym_EQ_GT,
  [115049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8328), 1,
      anon_sym_EQ_GT,
  [115056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 1,
      anon_sym_EQ_GT,
  [115063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8332), 1,
      sym_identifier,
  [115070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8334), 1,
      anon_sym_while,
  [115077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8336), 1,
      sym_identifier,
  [115084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5443), 1,
      anon_sym_RBRACK,
  [115091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8338), 1,
      sym_identifier,
  [115098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8340), 1,
      sym_identifier,
  [115105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5389), 1,
      anon_sym_RBRACK,
  [115112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5445), 1,
      anon_sym_RBRACE,
  [115119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8342), 1,
      anon_sym_function,
  [115126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      sym_identifier,
  [115133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5473), 1,
      anon_sym_RBRACK,
  [115140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8346), 1,
      anon_sym_RPAREN,
  [115147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8348), 1,
      anon_sym_LBRACE,
  [115154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8350), 1,
      anon_sym_RBRACK,
  [115161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8352), 1,
      anon_sym_EQ_GT,
  [115168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8354), 1,
      anon_sym_EQ_GT,
  [115175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8356), 1,
      sym_identifier,
  [115182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8358), 1,
      anon_sym_EQ_GT,
  [115189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8360), 1,
      sym_number,
  [115196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8362), 1,
      anon_sym_EQ_GT,
  [115203] = 2,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(8364), 1,
      sym_regex_pattern,
  [115210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8366), 1,
      anon_sym_RPAREN,
  [115217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8368), 1,
      anon_sym_RPAREN,
  [115224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8370), 1,
      anon_sym_DOT,
  [115231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8372), 1,
      anon_sym_RBRACK,
  [115238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8374), 1,
      anon_sym_RBRACK,
  [115245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8376), 1,
      anon_sym_RBRACK,
  [115252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8378), 1,
      anon_sym_RBRACK,
  [115259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8380), 1,
      anon_sym_class,
  [115266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8382), 1,
      anon_sym_RPAREN,
  [115273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8384), 1,
      anon_sym_RBRACK,
  [115280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_RBRACK,
  [115287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6344), 1,
      anon_sym_is,
  [115294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8388), 1,
      anon_sym_RBRACK,
  [115301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8390), 1,
      anon_sym_RBRACK,
  [115308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8392), 1,
      anon_sym_RBRACK,
  [115315] = 2,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(8394), 1,
      sym_regex_pattern,
  [115322] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8396), 1,
      anon_sym_RBRACK,
  [115329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8398), 1,
      anon_sym_EQ,
  [115336] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6166), 1,
      anon_sym_DOT,
  [115343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8400), 1,
      anon_sym_RBRACK,
  [115350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8402), 1,
      anon_sym_RBRACK,
  [115357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8404), 1,
      anon_sym_RBRACK,
  [115364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8406), 1,
      anon_sym_RBRACK,
  [115371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8408), 1,
      anon_sym_COLON,
  [115378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8410), 1,
      anon_sym_RBRACK,
  [115385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8412), 1,
      anon_sym_EQ_GT,
  [115392] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8414), 1,
      anon_sym_RBRACK,
  [115399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8416), 1,
      anon_sym_RBRACK,
  [115406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8418), 1,
      anon_sym_RBRACK,
  [115413] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8420), 1,
      sym_identifier,
  [115420] = 2,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(8422), 1,
      sym_regex_pattern,
  [115427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8424), 1,
      anon_sym_RBRACK,
  [115434] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4773), 1,
      anon_sym_DOT,
  [115441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2189), 1,
      anon_sym_EQ,
  [115448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8426), 1,
      anon_sym_RBRACK,
  [115455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8428), 1,
      anon_sym_RBRACK,
  [115462] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8430), 1,
      sym_identifier,
  [115469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8432), 1,
      sym_identifier,
  [115476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6254), 1,
      anon_sym_DOT,
  [115483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6526), 1,
      anon_sym_DOT,
  [115490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8434), 1,
      sym_identifier,
  [115497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7651), 1,
      sym_identifier,
  [115504] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8436), 1,
      anon_sym_RBRACK,
  [115511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8438), 1,
      anon_sym_RBRACK,
  [115518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_RPAREN,
  [115525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8440), 1,
      anon_sym_RBRACK,
  [115532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8442), 1,
      anon_sym_RBRACK,
  [115539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8444), 1,
      anon_sym_new,
  [115546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8446), 1,
      anon_sym_RBRACK,
  [115553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8448), 1,
      anon_sym_EQ_GT,
  [115560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8450), 1,
      anon_sym_EQ_GT,
  [115567] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8452), 1,
      anon_sym_RBRACK,
  [115574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8454), 1,
      sym_identifier,
  [115581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8456), 1,
      anon_sym_RBRACK,
  [115588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8458), 1,
      anon_sym_RBRACK,
  [115595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8460), 1,
      anon_sym_RBRACK,
  [115602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8462), 1,
      anon_sym_RPAREN,
  [115609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8464), 1,
      sym_identifier,
  [115616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8466), 1,
      anon_sym_RBRACK,
  [115623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8468), 1,
      anon_sym_EQ_GT,
  [115630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8470), 1,
      anon_sym_RBRACK,
  [115637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8472), 1,
      anon_sym_RBRACK,
  [115644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8474), 1,
      anon_sym_RBRACK,
  [115651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8476), 1,
      anon_sym_EQ_GT,
  [115658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8478), 1,
      anon_sym_RBRACK,
  [115665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8480), 1,
      anon_sym_EQ,
  [115672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8482), 1,
      anon_sym_RBRACK,
  [115679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8484), 1,
      anon_sym_RBRACK,
  [115686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8486), 1,
      anon_sym_EQ_GT,
  [115693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8488), 1,
      anon_sym_EQ_GT,
  [115700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8490), 1,
      anon_sym_EQ_GT,
  [115707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8492), 1,
      sym_identifier,
  [115714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8494), 1,
      sym_identifier,
  [115721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      anon_sym_RBRACK,
  [115728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8496), 1,
      anon_sym_EQ_GT,
  [115735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8004), 1,
      anon_sym_RBRACK,
  [115742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7807), 1,
      anon_sym_RBRACK,
  [115749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8498), 1,
      anon_sym_EQ_GT,
  [115756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8500), 1,
      anon_sym_EQ_GT,
  [115763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8502), 1,
      anon_sym_COLON,
  [115770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8504), 1,
      sym_identifier,
  [115777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8506), 1,
      anon_sym_EQ_GT,
  [115784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8508), 1,
      anon_sym_EQ_GT,
  [115791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8510), 1,
      anon_sym_EQ_GT,
  [115798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8512), 1,
      anon_sym_COLON,
  [115805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8514), 1,
      anon_sym_EQ_GT,
  [115812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8516), 1,
      anon_sym_EQ_GT,
  [115819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8518), 1,
      sym_identifier,
  [115826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8520), 1,
      anon_sym_EQ_GT,
  [115833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8522), 1,
      anon_sym_target,
  [115840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8524), 1,
      anon_sym_EQ_GT,
  [115847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8526), 1,
      anon_sym_EQ_GT,
  [115854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8528), 1,
      anon_sym_EQ_GT,
  [115861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8530), 1,
      anon_sym_EQ_GT,
  [115868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5248), 1,
      anon_sym_RPAREN,
  [115875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8532), 1,
      anon_sym_SLASH2,
  [115882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8534), 1,
      anon_sym_RBRACK,
  [115889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8536), 1,
      anon_sym_LBRACK,
  [115896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8538), 1,
      anon_sym_EQ_GT,
  [115903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8540), 1,
      anon_sym_SLASH2,
  [115910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8542), 1,
      anon_sym_RBRACK,
  [115917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8544), 1,
      anon_sym_from,
  [115924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8546), 1,
      anon_sym_EQ_GT,
  [115931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5439), 1,
      anon_sym_COLON,
  [115938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5427), 1,
      anon_sym_RPAREN,
  [115945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5465), 1,
      anon_sym_RPAREN,
  [115952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8548), 1,
      anon_sym_EQ_GT,
  [115959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_DOT,
  [115966] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8550), 1,
      anon_sym_EQ_GT,
  [115973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8552), 1,
      anon_sym_RBRACK,
  [115980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8554), 1,
      anon_sym_RBRACK,
  [115987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8556), 1,
      anon_sym_RBRACK,
  [115994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5250), 1,
      anon_sym_RPAREN,
  [116001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8558), 1,
      sym_identifier,
  [116008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8560), 1,
      anon_sym_EQ_GT,
  [116015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8562), 1,
      anon_sym_RPAREN,
  [116022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8564), 1,
      sym_identifier,
  [116029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8566), 1,
      anon_sym_RBRACK,
  [116036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8568), 1,
      anon_sym_target,
  [116043] = 2,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(8570), 1,
      sym_regex_pattern,
  [116050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8572), 1,
      anon_sym_EQ_GT,
  [116057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8574), 1,
      anon_sym_EQ_GT,
  [116064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8576), 1,
      anon_sym_EQ_GT,
  [116071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7677), 1,
      anon_sym_LBRACE,
  [116078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6340), 1,
      anon_sym_is,
  [116085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8578), 1,
      sym_identifier,
  [116092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_RBRACK,
  [116099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8582), 1,
      anon_sym_SLASH2,
  [116106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8584), 1,
      anon_sym_RBRACK,
  [116113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8586), 1,
      anon_sym_RBRACK,
  [116120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_RBRACK,
  [116127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_RBRACK,
  [116134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8592), 1,
      anon_sym_RBRACK,
  [116141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5198), 1,
      anon_sym_RPAREN,
  [116148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8594), 1,
      anon_sym_RBRACK,
  [116155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8596), 1,
      anon_sym_RBRACK,
  [116162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8598), 1,
      anon_sym_from,
  [116169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8600), 1,
      anon_sym_RBRACK,
  [116176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8602), 1,
      anon_sym_EQ,
  [116183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8604), 1,
      anon_sym_RBRACK,
  [116190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7863), 1,
      anon_sym_from,
  [116197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8606), 1,
      anon_sym_RBRACK,
  [116204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8608), 1,
      anon_sym_from,
  [116211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8610), 1,
      anon_sym_RBRACK,
  [116218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8612), 1,
      anon_sym_RBRACK,
  [116225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8614), 1,
      anon_sym_RBRACK,
  [116232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5461), 1,
      anon_sym_RBRACK,
  [116239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8616), 1,
      anon_sym_RBRACK,
  [116246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8618), 1,
      anon_sym_RBRACK,
  [116253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8620), 1,
      anon_sym_EQ_GT,
  [116260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8622), 1,
      anon_sym_EQ_GT,
  [116267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8624), 1,
      anon_sym_COLON,
  [116274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8626), 1,
      sym_identifier,
  [116281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8628), 1,
      anon_sym_EQ_GT,
  [116288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8630), 1,
      sym_identifier,
  [116295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8632), 1,
      sym_identifier,
  [116302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8634), 1,
      anon_sym_EQ_GT,
  [116309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8636), 1,
      anon_sym_RBRACK,
  [116316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8638), 1,
      anon_sym_LPAREN,
  [116323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5387), 1,
      anon_sym_RPAREN,
  [116330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8640), 1,
      anon_sym_RBRACK,
  [116337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8642), 1,
      anon_sym_fn,
  [116344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8644), 1,
      anon_sym_RPAREN,
  [116351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8646), 1,
      anon_sym_RBRACK,
  [116358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8648), 1,
      anon_sym_EQ_GT,
  [116365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8650), 1,
      sym_identifier,
  [116372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8652), 1,
      anon_sym_RBRACK,
  [116379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8654), 1,
      anon_sym_RBRACK,
  [116386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8656), 1,
      sym_identifier,
  [116393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6019), 1,
      anon_sym_DOT,
  [116400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7789), 1,
      anon_sym_RBRACK,
  [116407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8658), 1,
      anon_sym_EQ_GT,
  [116414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8660), 1,
      anon_sym_RBRACK,
  [116421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8662), 1,
      anon_sym_RBRACK,
  [116428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8664), 1,
      anon_sym_RBRACK,
  [116435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8666), 1,
      anon_sym_EQ_GT,
  [116442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8668), 1,
      anon_sym_new,
  [116449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8670), 1,
      anon_sym_readonly,
  [116456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8672), 1,
      anon_sym_RBRACK,
  [116463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7920), 1,
      anon_sym_RBRACK,
  [116470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8674), 1,
      sym_number,
  [116477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8676), 1,
      anon_sym_RPAREN,
  [116484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8678), 1,
      anon_sym_RPAREN,
  [116491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6576), 1,
      anon_sym_EQ,
  [116498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8680), 1,
      anon_sym_EQ_GT,
  [116505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8682), 1,
      anon_sym_EQ_GT,
  [116512] = 2,
    ACTIONS(7306), 1,
      sym_comment,
    ACTIONS(8684), 1,
      sym_regex_pattern,
  [116519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8686), 1,
      anon_sym_RPAREN,
  [116526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8688), 1,
      anon_sym_RPAREN,
  [116533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8690), 1,
      sym_identifier,
  [116540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 1,
      anon_sym_RPAREN,
  [116547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8692), 1,
      anon_sym_SLASH2,
  [116554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8694), 1,
      sym_identifier,
  [116561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8696), 1,
      anon_sym_EQ_GT,
  [116568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8698), 1,
      anon_sym_EQ_GT,
  [116575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8700), 1,
      anon_sym_RPAREN,
  [116582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8702), 1,
      anon_sym_EQ,
  [116589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8704), 1,
      anon_sym_EQ_GT,
  [116596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8706), 1,
      anon_sym_EQ_GT,
  [116603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8708), 1,
      anon_sym_EQ_GT,
  [116610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8710), 1,
      anon_sym_EQ_GT,
  [116617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8712), 1,
      anon_sym_RBRACK,
  [116624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8714), 1,
      anon_sym_new,
  [116631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8716), 1,
      anon_sym_from,
  [116638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8718), 1,
      sym_identifier,
  [116645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8720), 1,
      anon_sym_EQ,
  [116652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8722), 1,
      anon_sym_EQ_GT,
  [116659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7948), 1,
      anon_sym_RBRACK,
  [116666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8724), 1,
      sym_identifier,
  [116673] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_LPAREN,
  [116680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8726), 1,
      anon_sym_EQ_GT,
  [116687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8728), 1,
      anon_sym_EQ_GT,
  [116694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8730), 1,
      sym_identifier,
  [116701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8732), 1,
      anon_sym_EQ,
  [116708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8734), 1,
      anon_sym_EQ_GT,
  [116715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8736), 1,
      anon_sym_EQ_GT,
  [116722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8738), 1,
      anon_sym_EQ_GT,
  [116729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8740), 1,
      anon_sym_EQ_GT,
  [116736] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8742), 1,
      anon_sym_EQ_GT,
  [116743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8744), 1,
      sym_identifier,
  [116750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8746), 1,
      anon_sym_new,
  [116757] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8748), 1,
      sym_number,
  [116764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8750), 1,
      sym_identifier,
  [116771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8752), 1,
      anon_sym_SLASH2,
  [116778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8754), 1,
      anon_sym_EQ_GT,
  [116785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8756), 1,
      sym_identifier,
  [116792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8758), 1,
      anon_sym_EQ_GT,
  [116799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8760), 1,
      sym_identifier,
  [116806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8762), 1,
      anon_sym_EQ,
  [116813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8764), 1,
      anon_sym_COLON,
  [116820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8766), 1,
      anon_sym_EQ_GT,
  [116827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8768), 1,
      anon_sym_EQ_GT,
  [116834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8770), 1,
      anon_sym_EQ_GT,
  [116841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8772), 1,
      anon_sym_RBRACK,
  [116848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8774), 1,
      anon_sym_RBRACK,
  [116855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8776), 1,
      anon_sym_new,
  [116862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8778), 1,
      anon_sym_RBRACK,
  [116869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8780), 1,
      sym_identifier,
  [116876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8782), 1,
      anon_sym_new,
  [116883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8784), 1,
      anon_sym_RBRACK,
  [116890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8786), 1,
      anon_sym_new,
  [116897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8788), 1,
      sym_identifier,
  [116904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8790), 1,
      sym_identifier,
  [116911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8792), 1,
      sym_number,
  [116918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6376), 1,
      anon_sym_is,
  [116925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8794), 1,
      anon_sym_new,
  [116932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8796), 1,
      sym_identifier,
  [116939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8060), 1,
      anon_sym_fn,
  [116946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8798), 1,
      anon_sym_RBRACK,
  [116953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8800), 1,
      anon_sym_RBRACK,
  [116960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8802), 1,
      anon_sym_as,
  [116967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8804), 1,
      sym_number,
  [116974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8806), 1,
      sym_identifier,
  [116981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8808), 1,
      sym_identifier,
  [116988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8810), 1,
      sym_identifier,
  [116995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8812), 1,
      anon_sym_RBRACK,
  [117002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8814), 1,
      sym_identifier,
  [117009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8816), 1,
      anon_sym_RBRACK,
  [117016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8818), 1,
      anon_sym_EQ_GT,
  [117023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8820), 1,
      anon_sym_RBRACK,
  [117030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8822), 1,
      anon_sym_RBRACK,
  [117037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8824), 1,
      anon_sym_EQ_GT,
  [117044] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8826), 1,
      anon_sym_EQ_GT,
  [117051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8828), 1,
      anon_sym_EQ_GT,
  [117058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6342), 1,
      anon_sym_is,
  [117065] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8830), 1,
      anon_sym_EQ_GT,
  [117072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8832), 1,
      anon_sym_COLON,
  [117079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8834), 1,
      sym_identifier,
  [117086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8836), 1,
      anon_sym_target,
  [117093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8838), 1,
      anon_sym_EQ_GT,
  [117100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8840), 1,
      anon_sym_EQ_GT,
  [117107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8842), 1,
      anon_sym_RBRACK,
  [117114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8844), 1,
      anon_sym_RBRACK,
  [117121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8846), 1,
      anon_sym_EQ_GT,
  [117128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8848), 1,
      anon_sym_EQ_GT,
  [117135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7944), 1,
      anon_sym_from,
  [117142] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8850), 1,
      anon_sym_function,
  [117149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7506), 1,
      anon_sym_EQ_GT,
  [117156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7952), 1,
      sym_identifier,
  [117163] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5899), 1,
      anon_sym_EQ_GT,
  [117170] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8852), 1,
      anon_sym_RBRACK,
  [117177] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8854), 1,
      sym_identifier,
  [117184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8856), 1,
      anon_sym_RBRACK,
  [117191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8858), 1,
      anon_sym_RBRACK,
  [117198] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8860), 1,
      sym_identifier,
  [117205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8862), 1,
      sym_identifier,
  [117212] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8864), 1,
      anon_sym_SLASH2,
  [117219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8866), 1,
      anon_sym_EQ_GT,
  [117226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8868), 1,
      anon_sym_RBRACK,
  [117233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8870), 1,
      anon_sym_as,
  [117240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7737), 1,
      anon_sym_EQ,
  [117247] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5144), 1,
      anon_sym_RPAREN,
  [117254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8872), 1,
      anon_sym_new,
  [117261] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8874), 1,
      anon_sym_RBRACK,
  [117268] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8876), 1,
      anon_sym_RBRACK,
  [117275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8878), 1,
      anon_sym_RBRACK,
  [117282] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8880), 1,
      anon_sym_RBRACK,
  [117289] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8882), 1,
      sym_identifier,
  [117296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8884), 1,
      ts_builtin_sym_end,
  [117303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8886), 1,
      anon_sym_new,
  [117310] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8888), 1,
      sym_identifier,
  [117317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8890), 1,
      sym_identifier,
  [117324] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8892), 1,
      anon_sym_EQ_GT,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(1397)] = 0,
  [SMALL_STATE(1398)] = 97,
  [SMALL_STATE(1399)] = 200,
  [SMALL_STATE(1400)] = 295,
  [SMALL_STATE(1401)] = 390,
  [SMALL_STATE(1402)] = 487,
  [SMALL_STATE(1403)] = 585,
  [SMALL_STATE(1404)] = 723,
  [SMALL_STATE(1405)] = 813,
  [SMALL_STATE(1406)] = 951,
  [SMALL_STATE(1407)] = 1041,
  [SMALL_STATE(1408)] = 1131,
  [SMALL_STATE(1409)] = 1269,
  [SMALL_STATE(1410)] = 1365,
  [SMALL_STATE(1411)] = 1503,
  [SMALL_STATE(1412)] = 1641,
  [SMALL_STATE(1413)] = 1739,
  [SMALL_STATE(1414)] = 1833,
  [SMALL_STATE(1415)] = 1971,
  [SMALL_STATE(1416)] = 2109,
  [SMALL_STATE(1417)] = 2199,
  [SMALL_STATE(1418)] = 2337,
  [SMALL_STATE(1419)] = 2431,
  [SMALL_STATE(1420)] = 2524,
  [SMALL_STATE(1421)] = 2615,
  [SMALL_STATE(1422)] = 2708,
  [SMALL_STATE(1423)] = 2799,
  [SMALL_STATE(1424)] = 2890,
  [SMALL_STATE(1425)] = 2981,
  [SMALL_STATE(1426)] = 3072,
  [SMALL_STATE(1427)] = 3163,
  [SMALL_STATE(1428)] = 3260,
  [SMALL_STATE(1429)] = 3351,
  [SMALL_STATE(1430)] = 3442,
  [SMALL_STATE(1431)] = 3510,
  [SMALL_STATE(1432)] = 3598,
  [SMALL_STATE(1433)] = 3666,
  [SMALL_STATE(1434)] = 3754,
  [SMALL_STATE(1435)] = 3842,
  [SMALL_STATE(1436)] = 3910,
  [SMALL_STATE(1437)] = 3978,
  [SMALL_STATE(1438)] = 4046,
  [SMALL_STATE(1439)] = 4114,
  [SMALL_STATE(1440)] = 4202,
  [SMALL_STATE(1441)] = 4270,
  [SMALL_STATE(1442)] = 4337,
  [SMALL_STATE(1443)] = 4408,
  [SMALL_STATE(1444)] = 4475,
  [SMALL_STATE(1445)] = 4599,
  [SMALL_STATE(1446)] = 4677,
  [SMALL_STATE(1447)] = 4801,
  [SMALL_STATE(1448)] = 4879,
  [SMALL_STATE(1449)] = 4955,
  [SMALL_STATE(1450)] = 5035,
  [SMALL_STATE(1451)] = 5110,
  [SMALL_STATE(1452)] = 5183,
  [SMALL_STATE(1453)] = 5258,
  [SMALL_STATE(1454)] = 5333,
  [SMALL_STATE(1455)] = 5404,
  [SMALL_STATE(1456)] = 5485,
  [SMALL_STATE(1457)] = 5556,
  [SMALL_STATE(1458)] = 5637,
  [SMALL_STATE(1459)] = 5712,
  [SMALL_STATE(1460)] = 5787,
  [SMALL_STATE(1461)] = 5855,
  [SMALL_STATE(1462)] = 5919,
  [SMALL_STATE(1463)] = 5983,
  [SMALL_STATE(1464)] = 6047,
  [SMALL_STATE(1465)] = 6111,
  [SMALL_STATE(1466)] = 6189,
  [SMALL_STATE(1467)] = 6253,
  [SMALL_STATE(1468)] = 6317,
  [SMALL_STATE(1469)] = 6381,
  [SMALL_STATE(1470)] = 6445,
  [SMALL_STATE(1471)] = 6521,
  [SMALL_STATE(1472)] = 6591,
  [SMALL_STATE(1473)] = 6655,
  [SMALL_STATE(1474)] = 6733,
  [SMALL_STATE(1475)] = 6803,
  [SMALL_STATE(1476)] = 6877,
  [SMALL_STATE(1477)] = 6951,
  [SMALL_STATE(1478)] = 7015,
  [SMALL_STATE(1479)] = 7089,
  [SMALL_STATE(1480)] = 7153,
  [SMALL_STATE(1481)] = 7217,
  [SMALL_STATE(1482)] = 7281,
  [SMALL_STATE(1483)] = 7351,
  [SMALL_STATE(1484)] = 7421,
  [SMALL_STATE(1485)] = 7493,
  [SMALL_STATE(1486)] = 7563,
  [SMALL_STATE(1487)] = 7643,
  [SMALL_STATE(1488)] = 7715,
  [SMALL_STATE(1489)] = 7784,
  [SMALL_STATE(1490)] = 7847,
  [SMALL_STATE(1491)] = 7918,
  [SMALL_STATE(1492)] = 7989,
  [SMALL_STATE(1493)] = 8058,
  [SMALL_STATE(1494)] = 8121,
  [SMALL_STATE(1495)] = 8184,
  [SMALL_STATE(1496)] = 8251,
  [SMALL_STATE(1497)] = 8322,
  [SMALL_STATE(1498)] = 8391,
  [SMALL_STATE(1499)] = 8466,
  [SMALL_STATE(1500)] = 8537,
  [SMALL_STATE(1501)] = 8604,
  [SMALL_STATE(1502)] = 8679,
  [SMALL_STATE(1503)] = 8748,
  [SMALL_STATE(1504)] = 8816,
  [SMALL_STATE(1505)] = 8886,
  [SMALL_STATE(1506)] = 8950,
  [SMALL_STATE(1507)] = 9014,
  [SMALL_STATE(1508)] = 9080,
  [SMALL_STATE(1509)] = 9146,
  [SMALL_STATE(1510)] = 9216,
  [SMALL_STATE(1511)] = 9286,
  [SMALL_STATE(1512)] = 9357,
  [SMALL_STATE(1513)] = 9418,
  [SMALL_STATE(1514)] = 9479,
  [SMALL_STATE(1515)] = 9546,
  [SMALL_STATE(1516)] = 9613,
  [SMALL_STATE(1517)] = 9674,
  [SMALL_STATE(1518)] = 9735,
  [SMALL_STATE(1519)] = 9796,
  [SMALL_STATE(1520)] = 9857,
  [SMALL_STATE(1521)] = 9924,
  [SMALL_STATE(1522)] = 9988,
  [SMALL_STATE(1523)] = 10056,
  [SMALL_STATE(1524)] = 10118,
  [SMALL_STATE(1525)] = 10180,
  [SMALL_STATE(1526)] = 10238,
  [SMALL_STATE(1527)] = 10297,
  [SMALL_STATE(1528)] = 10356,
  [SMALL_STATE(1529)] = 10463,
  [SMALL_STATE(1530)] = 10570,
  [SMALL_STATE(1531)] = 10677,
  [SMALL_STATE(1532)] = 10784,
  [SMALL_STATE(1533)] = 10845,
  [SMALL_STATE(1534)] = 10952,
  [SMALL_STATE(1535)] = 11013,
  [SMALL_STATE(1536)] = 11120,
  [SMALL_STATE(1537)] = 11227,
  [SMALL_STATE(1538)] = 11283,
  [SMALL_STATE(1539)] = 11339,
  [SMALL_STATE(1540)] = 11395,
  [SMALL_STATE(1541)] = 11451,
  [SMALL_STATE(1542)] = 11507,
  [SMALL_STATE(1543)] = 11563,
  [SMALL_STATE(1544)] = 11619,
  [SMALL_STATE(1545)] = 11675,
  [SMALL_STATE(1546)] = 11731,
  [SMALL_STATE(1547)] = 11787,
  [SMALL_STATE(1548)] = 11843,
  [SMALL_STATE(1549)] = 11899,
  [SMALL_STATE(1550)] = 11955,
  [SMALL_STATE(1551)] = 12011,
  [SMALL_STATE(1552)] = 12067,
  [SMALL_STATE(1553)] = 12123,
  [SMALL_STATE(1554)] = 12179,
  [SMALL_STATE(1555)] = 12235,
  [SMALL_STATE(1556)] = 12291,
  [SMALL_STATE(1557)] = 12347,
  [SMALL_STATE(1558)] = 12405,
  [SMALL_STATE(1559)] = 12461,
  [SMALL_STATE(1560)] = 12517,
  [SMALL_STATE(1561)] = 12573,
  [SMALL_STATE(1562)] = 12629,
  [SMALL_STATE(1563)] = 12685,
  [SMALL_STATE(1564)] = 12741,
  [SMALL_STATE(1565)] = 12797,
  [SMALL_STATE(1566)] = 12853,
  [SMALL_STATE(1567)] = 12909,
  [SMALL_STATE(1568)] = 12965,
  [SMALL_STATE(1569)] = 13021,
  [SMALL_STATE(1570)] = 13077,
  [SMALL_STATE(1571)] = 13133,
  [SMALL_STATE(1572)] = 13189,
  [SMALL_STATE(1573)] = 13245,
  [SMALL_STATE(1574)] = 13301,
  [SMALL_STATE(1575)] = 13357,
  [SMALL_STATE(1576)] = 13413,
  [SMALL_STATE(1577)] = 13469,
  [SMALL_STATE(1578)] = 13572,
  [SMALL_STATE(1579)] = 13631,
  [SMALL_STATE(1580)] = 13734,
  [SMALL_STATE(1581)] = 13837,
  [SMALL_STATE(1582)] = 13940,
  [SMALL_STATE(1583)] = 14043,
  [SMALL_STATE(1584)] = 14146,
  [SMALL_STATE(1585)] = 14249,
  [SMALL_STATE(1586)] = 14352,
  [SMALL_STATE(1587)] = 14455,
  [SMALL_STATE(1588)] = 14558,
  [SMALL_STATE(1589)] = 14661,
  [SMALL_STATE(1590)] = 14764,
  [SMALL_STATE(1591)] = 14867,
  [SMALL_STATE(1592)] = 14970,
  [SMALL_STATE(1593)] = 15073,
  [SMALL_STATE(1594)] = 15176,
  [SMALL_STATE(1595)] = 15279,
  [SMALL_STATE(1596)] = 15382,
  [SMALL_STATE(1597)] = 15437,
  [SMALL_STATE(1598)] = 15540,
  [SMALL_STATE(1599)] = 15643,
  [SMALL_STATE(1600)] = 15746,
  [SMALL_STATE(1601)] = 15808,
  [SMALL_STATE(1602)] = 15906,
  [SMALL_STATE(1603)] = 16004,
  [SMALL_STATE(1604)] = 16102,
  [SMALL_STATE(1605)] = 16200,
  [SMALL_STATE(1606)] = 16298,
  [SMALL_STATE(1607)] = 16396,
  [SMALL_STATE(1608)] = 16466,
  [SMALL_STATE(1609)] = 16564,
  [SMALL_STATE(1610)] = 16662,
  [SMALL_STATE(1611)] = 16760,
  [SMALL_STATE(1612)] = 16816,
  [SMALL_STATE(1613)] = 16889,
  [SMALL_STATE(1614)] = 16946,
  [SMALL_STATE(1615)] = 17013,
  [SMALL_STATE(1616)] = 17112,
  [SMALL_STATE(1617)] = 17177,
  [SMALL_STATE(1618)] = 17236,
  [SMALL_STATE(1619)] = 17335,
  [SMALL_STATE(1620)] = 17394,
  [SMALL_STATE(1621)] = 17447,
  [SMALL_STATE(1622)] = 17546,
  [SMALL_STATE(1623)] = 17605,
  [SMALL_STATE(1624)] = 17664,
  [SMALL_STATE(1625)] = 17723,
  [SMALL_STATE(1626)] = 17822,
  [SMALL_STATE(1627)] = 17875,
  [SMALL_STATE(1628)] = 17974,
  [SMALL_STATE(1629)] = 18031,
  [SMALL_STATE(1630)] = 18084,
  [SMALL_STATE(1631)] = 18139,
  [SMALL_STATE(1632)] = 18238,
  [SMALL_STATE(1633)] = 18337,
  [SMALL_STATE(1634)] = 18436,
  [SMALL_STATE(1635)] = 18491,
  [SMALL_STATE(1636)] = 18546,
  [SMALL_STATE(1637)] = 18598,
  [SMALL_STATE(1638)] = 18650,
  [SMALL_STATE(1639)] = 18704,
  [SMALL_STATE(1640)] = 18756,
  [SMALL_STATE(1641)] = 18808,
  [SMALL_STATE(1642)] = 18860,
  [SMALL_STATE(1643)] = 18912,
  [SMALL_STATE(1644)] = 18964,
  [SMALL_STATE(1645)] = 19016,
  [SMALL_STATE(1646)] = 19068,
  [SMALL_STATE(1647)] = 19120,
  [SMALL_STATE(1648)] = 19174,
  [SMALL_STATE(1649)] = 19226,
  [SMALL_STATE(1650)] = 19280,
  [SMALL_STATE(1651)] = 19332,
  [SMALL_STATE(1652)] = 19392,
  [SMALL_STATE(1653)] = 19444,
  [SMALL_STATE(1654)] = 19500,
  [SMALL_STATE(1655)] = 19552,
  [SMALL_STATE(1656)] = 19606,
  [SMALL_STATE(1657)] = 19658,
  [SMALL_STATE(1658)] = 19710,
  [SMALL_STATE(1659)] = 19762,
  [SMALL_STATE(1660)] = 19814,
  [SMALL_STATE(1661)] = 19866,
  [SMALL_STATE(1662)] = 19918,
  [SMALL_STATE(1663)] = 19970,
  [SMALL_STATE(1664)] = 20022,
  [SMALL_STATE(1665)] = 20074,
  [SMALL_STATE(1666)] = 20126,
  [SMALL_STATE(1667)] = 20184,
  [SMALL_STATE(1668)] = 20242,
  [SMALL_STATE(1669)] = 20294,
  [SMALL_STATE(1670)] = 20346,
  [SMALL_STATE(1671)] = 20398,
  [SMALL_STATE(1672)] = 20456,
  [SMALL_STATE(1673)] = 20508,
  [SMALL_STATE(1674)] = 20562,
  [SMALL_STATE(1675)] = 20614,
  [SMALL_STATE(1676)] = 20666,
  [SMALL_STATE(1677)] = 20718,
  [SMALL_STATE(1678)] = 20770,
  [SMALL_STATE(1679)] = 20822,
  [SMALL_STATE(1680)] = 20874,
  [SMALL_STATE(1681)] = 20926,
  [SMALL_STATE(1682)] = 20978,
  [SMALL_STATE(1683)] = 21030,
  [SMALL_STATE(1684)] = 21082,
  [SMALL_STATE(1685)] = 21134,
  [SMALL_STATE(1686)] = 21186,
  [SMALL_STATE(1687)] = 21238,
  [SMALL_STATE(1688)] = 21290,
  [SMALL_STATE(1689)] = 21342,
  [SMALL_STATE(1690)] = 21394,
  [SMALL_STATE(1691)] = 21446,
  [SMALL_STATE(1692)] = 21498,
  [SMALL_STATE(1693)] = 21552,
  [SMALL_STATE(1694)] = 21604,
  [SMALL_STATE(1695)] = 21656,
  [SMALL_STATE(1696)] = 21708,
  [SMALL_STATE(1697)] = 21760,
  [SMALL_STATE(1698)] = 21812,
  [SMALL_STATE(1699)] = 21870,
  [SMALL_STATE(1700)] = 21922,
  [SMALL_STATE(1701)] = 21978,
  [SMALL_STATE(1702)] = 22030,
  [SMALL_STATE(1703)] = 22082,
  [SMALL_STATE(1704)] = 22134,
  [SMALL_STATE(1705)] = 22186,
  [SMALL_STATE(1706)] = 22238,
  [SMALL_STATE(1707)] = 22292,
  [SMALL_STATE(1708)] = 22350,
  [SMALL_STATE(1709)] = 22402,
  [SMALL_STATE(1710)] = 22454,
  [SMALL_STATE(1711)] = 22512,
  [SMALL_STATE(1712)] = 22564,
  [SMALL_STATE(1713)] = 22616,
  [SMALL_STATE(1714)] = 22668,
  [SMALL_STATE(1715)] = 22720,
  [SMALL_STATE(1716)] = 22772,
  [SMALL_STATE(1717)] = 22824,
  [SMALL_STATE(1718)] = 22876,
  [SMALL_STATE(1719)] = 22928,
  [SMALL_STATE(1720)] = 22984,
  [SMALL_STATE(1721)] = 23036,
  [SMALL_STATE(1722)] = 23092,
  [SMALL_STATE(1723)] = 23144,
  [SMALL_STATE(1724)] = 23198,
  [SMALL_STATE(1725)] = 23250,
  [SMALL_STATE(1726)] = 23302,
  [SMALL_STATE(1727)] = 23358,
  [SMALL_STATE(1728)] = 23410,
  [SMALL_STATE(1729)] = 23464,
  [SMALL_STATE(1730)] = 23516,
  [SMALL_STATE(1731)] = 23570,
  [SMALL_STATE(1732)] = 23622,
  [SMALL_STATE(1733)] = 23674,
  [SMALL_STATE(1734)] = 23726,
  [SMALL_STATE(1735)] = 23784,
  [SMALL_STATE(1736)] = 23842,
  [SMALL_STATE(1737)] = 23894,
  [SMALL_STATE(1738)] = 23948,
  [SMALL_STATE(1739)] = 24038,
  [SMALL_STATE(1740)] = 24089,
  [SMALL_STATE(1741)] = 24148,
  [SMALL_STATE(1742)] = 24243,
  [SMALL_STATE(1743)] = 24294,
  [SMALL_STATE(1744)] = 24345,
  [SMALL_STATE(1745)] = 24396,
  [SMALL_STATE(1746)] = 24491,
  [SMALL_STATE(1747)] = 24558,
  [SMALL_STATE(1748)] = 24653,
  [SMALL_STATE(1749)] = 24748,
  [SMALL_STATE(1750)] = 24799,
  [SMALL_STATE(1751)] = 24850,
  [SMALL_STATE(1752)] = 24901,
  [SMALL_STATE(1753)] = 24952,
  [SMALL_STATE(1754)] = 25003,
  [SMALL_STATE(1755)] = 25054,
  [SMALL_STATE(1756)] = 25105,
  [SMALL_STATE(1757)] = 25160,
  [SMALL_STATE(1758)] = 25211,
  [SMALL_STATE(1759)] = 25262,
  [SMALL_STATE(1760)] = 25313,
  [SMALL_STATE(1761)] = 25408,
  [SMALL_STATE(1762)] = 25459,
  [SMALL_STATE(1763)] = 25510,
  [SMALL_STATE(1764)] = 25561,
  [SMALL_STATE(1765)] = 25656,
  [SMALL_STATE(1766)] = 25707,
  [SMALL_STATE(1767)] = 25758,
  [SMALL_STATE(1768)] = 25809,
  [SMALL_STATE(1769)] = 25904,
  [SMALL_STATE(1770)] = 25999,
  [SMALL_STATE(1771)] = 26050,
  [SMALL_STATE(1772)] = 26101,
  [SMALL_STATE(1773)] = 26152,
  [SMALL_STATE(1774)] = 26203,
  [SMALL_STATE(1775)] = 26254,
  [SMALL_STATE(1776)] = 26305,
  [SMALL_STATE(1777)] = 26356,
  [SMALL_STATE(1778)] = 26407,
  [SMALL_STATE(1779)] = 26458,
  [SMALL_STATE(1780)] = 26509,
  [SMALL_STATE(1781)] = 26560,
  [SMALL_STATE(1782)] = 26611,
  [SMALL_STATE(1783)] = 26662,
  [SMALL_STATE(1784)] = 26713,
  [SMALL_STATE(1785)] = 26764,
  [SMALL_STATE(1786)] = 26815,
  [SMALL_STATE(1787)] = 26866,
  [SMALL_STATE(1788)] = 26931,
  [SMALL_STATE(1789)] = 26996,
  [SMALL_STATE(1790)] = 27091,
  [SMALL_STATE(1791)] = 27186,
  [SMALL_STATE(1792)] = 27281,
  [SMALL_STATE(1793)] = 27332,
  [SMALL_STATE(1794)] = 27383,
  [SMALL_STATE(1795)] = 27434,
  [SMALL_STATE(1796)] = 27485,
  [SMALL_STATE(1797)] = 27536,
  [SMALL_STATE(1798)] = 27587,
  [SMALL_STATE(1799)] = 27638,
  [SMALL_STATE(1800)] = 27689,
  [SMALL_STATE(1801)] = 27740,
  [SMALL_STATE(1802)] = 27791,
  [SMALL_STATE(1803)] = 27842,
  [SMALL_STATE(1804)] = 27937,
  [SMALL_STATE(1805)] = 27988,
  [SMALL_STATE(1806)] = 28039,
  [SMALL_STATE(1807)] = 28090,
  [SMALL_STATE(1808)] = 28141,
  [SMALL_STATE(1809)] = 28192,
  [SMALL_STATE(1810)] = 28243,
  [SMALL_STATE(1811)] = 28294,
  [SMALL_STATE(1812)] = 28345,
  [SMALL_STATE(1813)] = 28396,
  [SMALL_STATE(1814)] = 28447,
  [SMALL_STATE(1815)] = 28498,
  [SMALL_STATE(1816)] = 28549,
  [SMALL_STATE(1817)] = 28600,
  [SMALL_STATE(1818)] = 28651,
  [SMALL_STATE(1819)] = 28702,
  [SMALL_STATE(1820)] = 28753,
  [SMALL_STATE(1821)] = 28804,
  [SMALL_STATE(1822)] = 28855,
  [SMALL_STATE(1823)] = 28906,
  [SMALL_STATE(1824)] = 28957,
  [SMALL_STATE(1825)] = 29052,
  [SMALL_STATE(1826)] = 29103,
  [SMALL_STATE(1827)] = 29154,
  [SMALL_STATE(1828)] = 29205,
  [SMALL_STATE(1829)] = 29256,
  [SMALL_STATE(1830)] = 29307,
  [SMALL_STATE(1831)] = 29358,
  [SMALL_STATE(1832)] = 29409,
  [SMALL_STATE(1833)] = 29460,
  [SMALL_STATE(1834)] = 29511,
  [SMALL_STATE(1835)] = 29562,
  [SMALL_STATE(1836)] = 29613,
  [SMALL_STATE(1837)] = 29664,
  [SMALL_STATE(1838)] = 29715,
  [SMALL_STATE(1839)] = 29766,
  [SMALL_STATE(1840)] = 29817,
  [SMALL_STATE(1841)] = 29868,
  [SMALL_STATE(1842)] = 29919,
  [SMALL_STATE(1843)] = 29970,
  [SMALL_STATE(1844)] = 30021,
  [SMALL_STATE(1845)] = 30072,
  [SMALL_STATE(1846)] = 30154,
  [SMALL_STATE(1847)] = 30214,
  [SMALL_STATE(1848)] = 30296,
  [SMALL_STATE(1849)] = 30352,
  [SMALL_STATE(1850)] = 30408,
  [SMALL_STATE(1851)] = 30472,
  [SMALL_STATE(1852)] = 30542,
  [SMALL_STATE(1853)] = 30598,
  [SMALL_STATE(1854)] = 30660,
  [SMALL_STATE(1855)] = 30716,
  [SMALL_STATE(1856)] = 30772,
  [SMALL_STATE(1857)] = 30828,
  [SMALL_STATE(1858)] = 30910,
  [SMALL_STATE(1859)] = 30966,
  [SMALL_STATE(1860)] = 31022,
  [SMALL_STATE(1861)] = 31104,
  [SMALL_STATE(1862)] = 31214,
  [SMALL_STATE(1863)] = 31268,
  [SMALL_STATE(1864)] = 31318,
  [SMALL_STATE(1865)] = 31368,
  [SMALL_STATE(1866)] = 31422,
  [SMALL_STATE(1867)] = 31472,
  [SMALL_STATE(1868)] = 31528,
  [SMALL_STATE(1869)] = 31582,
  [SMALL_STATE(1870)] = 31634,
  [SMALL_STATE(1871)] = 31692,
  [SMALL_STATE(1872)] = 31742,
  [SMALL_STATE(1873)] = 31796,
  [SMALL_STATE(1874)] = 31848,
  [SMALL_STATE(1875)] = 31898,
  [SMALL_STATE(1876)] = 31948,
  [SMALL_STATE(1877)] = 31998,
  [SMALL_STATE(1878)] = 32056,
  [SMALL_STATE(1879)] = 32108,
  [SMALL_STATE(1880)] = 32160,
  [SMALL_STATE(1881)] = 32220,
  [SMALL_STATE(1882)] = 32309,
  [SMALL_STATE(1883)] = 32410,
  [SMALL_STATE(1884)] = 32459,
  [SMALL_STATE(1885)] = 32508,
  [SMALL_STATE(1886)] = 32557,
  [SMALL_STATE(1887)] = 32606,
  [SMALL_STATE(1888)] = 32661,
  [SMALL_STATE(1889)] = 32710,
  [SMALL_STATE(1890)] = 32811,
  [SMALL_STATE(1891)] = 32860,
  [SMALL_STATE(1892)] = 32915,
  [SMALL_STATE(1893)] = 33016,
  [SMALL_STATE(1894)] = 33065,
  [SMALL_STATE(1895)] = 33114,
  [SMALL_STATE(1896)] = 33219,
  [SMALL_STATE(1897)] = 33268,
  [SMALL_STATE(1898)] = 33317,
  [SMALL_STATE(1899)] = 33366,
  [SMALL_STATE(1900)] = 33415,
  [SMALL_STATE(1901)] = 33464,
  [SMALL_STATE(1902)] = 33515,
  [SMALL_STATE(1903)] = 33622,
  [SMALL_STATE(1904)] = 33679,
  [SMALL_STATE(1905)] = 33728,
  [SMALL_STATE(1906)] = 33777,
  [SMALL_STATE(1907)] = 33838,
  [SMALL_STATE(1908)] = 33887,
  [SMALL_STATE(1909)] = 33936,
  [SMALL_STATE(1910)] = 33985,
  [SMALL_STATE(1911)] = 34058,
  [SMALL_STATE(1912)] = 34107,
  [SMALL_STATE(1913)] = 34156,
  [SMALL_STATE(1914)] = 34211,
  [SMALL_STATE(1915)] = 34316,
  [SMALL_STATE(1916)] = 34365,
  [SMALL_STATE(1917)] = 34440,
  [SMALL_STATE(1918)] = 34547,
  [SMALL_STATE(1919)] = 34608,
  [SMALL_STATE(1920)] = 34657,
  [SMALL_STATE(1921)] = 34706,
  [SMALL_STATE(1922)] = 34761,
  [SMALL_STATE(1923)] = 34822,
  [SMALL_STATE(1924)] = 34871,
  [SMALL_STATE(1925)] = 34972,
  [SMALL_STATE(1926)] = 35021,
  [SMALL_STATE(1927)] = 35070,
  [SMALL_STATE(1928)] = 35135,
  [SMALL_STATE(1929)] = 35210,
  [SMALL_STATE(1930)] = 35259,
  [SMALL_STATE(1931)] = 35308,
  [SMALL_STATE(1932)] = 35409,
  [SMALL_STATE(1933)] = 35460,
  [SMALL_STATE(1934)] = 35509,
  [SMALL_STATE(1935)] = 35562,
  [SMALL_STATE(1936)] = 35663,
  [SMALL_STATE(1937)] = 35764,
  [SMALL_STATE(1938)] = 35813,
  [SMALL_STATE(1939)] = 35914,
  [SMALL_STATE(1940)] = 36015,
  [SMALL_STATE(1941)] = 36078,
  [SMALL_STATE(1942)] = 36141,
  [SMALL_STATE(1943)] = 36242,
  [SMALL_STATE(1944)] = 36297,
  [SMALL_STATE(1945)] = 36398,
  [SMALL_STATE(1946)] = 36449,
  [SMALL_STATE(1947)] = 36550,
  [SMALL_STATE(1948)] = 36623,
  [SMALL_STATE(1949)] = 36724,
  [SMALL_STATE(1950)] = 36799,
  [SMALL_STATE(1951)] = 36850,
  [SMALL_STATE(1952)] = 36901,
  [SMALL_STATE(1953)] = 36976,
  [SMALL_STATE(1954)] = 37051,
  [SMALL_STATE(1955)] = 37100,
  [SMALL_STATE(1956)] = 37165,
  [SMALL_STATE(1957)] = 37240,
  [SMALL_STATE(1958)] = 37313,
  [SMALL_STATE(1959)] = 37362,
  [SMALL_STATE(1960)] = 37413,
  [SMALL_STATE(1961)] = 37466,
  [SMALL_STATE(1962)] = 37515,
  [SMALL_STATE(1963)] = 37566,
  [SMALL_STATE(1964)] = 37615,
  [SMALL_STATE(1965)] = 37664,
  [SMALL_STATE(1966)] = 37715,
  [SMALL_STATE(1967)] = 37806,
  [SMALL_STATE(1968)] = 37877,
  [SMALL_STATE(1969)] = 37960,
  [SMALL_STATE(1970)] = 38009,
  [SMALL_STATE(1971)] = 38110,
  [SMALL_STATE(1972)] = 38211,
  [SMALL_STATE(1973)] = 38260,
  [SMALL_STATE(1974)] = 38361,
  [SMALL_STATE(1975)] = 38416,
  [SMALL_STATE(1976)] = 38465,
  [SMALL_STATE(1977)] = 38550,
  [SMALL_STATE(1978)] = 38639,
  [SMALL_STATE(1979)] = 38730,
  [SMALL_STATE(1980)] = 38831,
  [SMALL_STATE(1981)] = 38902,
  [SMALL_STATE(1982)] = 38985,
  [SMALL_STATE(1983)] = 39070,
  [SMALL_STATE(1984)] = 39175,
  [SMALL_STATE(1985)] = 39224,
  [SMALL_STATE(1986)] = 39311,
  [SMALL_STATE(1987)] = 39380,
  [SMALL_STATE(1988)] = 39451,
  [SMALL_STATE(1989)] = 39530,
  [SMALL_STATE(1990)] = 39623,
  [SMALL_STATE(1991)] = 39674,
  [SMALL_STATE(1992)] = 39723,
  [SMALL_STATE(1993)] = 39772,
  [SMALL_STATE(1994)] = 39873,
  [SMALL_STATE(1995)] = 39974,
  [SMALL_STATE(1996)] = 40023,
  [SMALL_STATE(1997)] = 40130,
  [SMALL_STATE(1998)] = 40179,
  [SMALL_STATE(1999)] = 40228,
  [SMALL_STATE(2000)] = 40277,
  [SMALL_STATE(2001)] = 40326,
  [SMALL_STATE(2002)] = 40387,
  [SMALL_STATE(2003)] = 40448,
  [SMALL_STATE(2004)] = 40535,
  [SMALL_STATE(2005)] = 40636,
  [SMALL_STATE(2006)] = 40737,
  [SMALL_STATE(2007)] = 40812,
  [SMALL_STATE(2008)] = 40913,
  [SMALL_STATE(2009)] = 41014,
  [SMALL_STATE(2010)] = 41069,
  [SMALL_STATE(2011)] = 41124,
  [SMALL_STATE(2012)] = 41173,
  [SMALL_STATE(2013)] = 41222,
  [SMALL_STATE(2014)] = 41291,
  [SMALL_STATE(2015)] = 41392,
  [SMALL_STATE(2016)] = 41493,
  [SMALL_STATE(2017)] = 41566,
  [SMALL_STATE(2018)] = 41619,
  [SMALL_STATE(2019)] = 41720,
  [SMALL_STATE(2020)] = 41821,
  [SMALL_STATE(2021)] = 41870,
  [SMALL_STATE(2022)] = 41977,
  [SMALL_STATE(2023)] = 42026,
  [SMALL_STATE(2024)] = 42133,
  [SMALL_STATE(2025)] = 42182,
  [SMALL_STATE(2026)] = 42237,
  [SMALL_STATE(2027)] = 42302,
  [SMALL_STATE(2028)] = 42351,
  [SMALL_STATE(2029)] = 42400,
  [SMALL_STATE(2030)] = 42455,
  [SMALL_STATE(2031)] = 42530,
  [SMALL_STATE(2032)] = 42601,
  [SMALL_STATE(2033)] = 42690,
  [SMALL_STATE(2034)] = 42781,
  [SMALL_STATE(2035)] = 42852,
  [SMALL_STATE(2036)] = 42935,
  [SMALL_STATE(2037)] = 42996,
  [SMALL_STATE(2038)] = 43057,
  [SMALL_STATE(2039)] = 43142,
  [SMALL_STATE(2040)] = 43229,
  [SMALL_STATE(2041)] = 43298,
  [SMALL_STATE(2042)] = 43401,
  [SMALL_STATE(2043)] = 43472,
  [SMALL_STATE(2044)] = 43551,
  [SMALL_STATE(2045)] = 43644,
  [SMALL_STATE(2046)] = 43699,
  [SMALL_STATE(2047)] = 43748,
  [SMALL_STATE(2048)] = 43803,
  [SMALL_STATE(2049)] = 43904,
  [SMALL_STATE(2050)] = 43953,
  [SMALL_STATE(2051)] = 44002,
  [SMALL_STATE(2052)] = 44051,
  [SMALL_STATE(2053)] = 44152,
  [SMALL_STATE(2054)] = 44201,
  [SMALL_STATE(2055)] = 44280,
  [SMALL_STATE(2056)] = 44331,
  [SMALL_STATE(2057)] = 44380,
  [SMALL_STATE(2058)] = 44473,
  [SMALL_STATE(2059)] = 44574,
  [SMALL_STATE(2060)] = 44623,
  [SMALL_STATE(2061)] = 44672,
  [SMALL_STATE(2062)] = 44721,
  [SMALL_STATE(2063)] = 44826,
  [SMALL_STATE(2064)] = 44879,
  [SMALL_STATE(2065)] = 44928,
  [SMALL_STATE(2066)] = 45029,
  [SMALL_STATE(2067)] = 45130,
  [SMALL_STATE(2068)] = 45231,
  [SMALL_STATE(2069)] = 45280,
  [SMALL_STATE(2070)] = 45329,
  [SMALL_STATE(2071)] = 45430,
  [SMALL_STATE(2072)] = 45479,
  [SMALL_STATE(2073)] = 45540,
  [SMALL_STATE(2074)] = 45589,
  [SMALL_STATE(2075)] = 45638,
  [SMALL_STATE(2076)] = 45687,
  [SMALL_STATE(2077)] = 45736,
  [SMALL_STATE(2078)] = 45787,
  [SMALL_STATE(2079)] = 45888,
  [SMALL_STATE(2080)] = 45949,
  [SMALL_STATE(2081)] = 45998,
  [SMALL_STATE(2082)] = 46101,
  [SMALL_STATE(2083)] = 46154,
  [SMALL_STATE(2084)] = 46203,
  [SMALL_STATE(2085)] = 46304,
  [SMALL_STATE(2086)] = 46353,
  [SMALL_STATE(2087)] = 46454,
  [SMALL_STATE(2088)] = 46503,
  [SMALL_STATE(2089)] = 46556,
  [SMALL_STATE(2090)] = 46608,
  [SMALL_STATE(2091)] = 46678,
  [SMALL_STATE(2092)] = 46736,
  [SMALL_STATE(2093)] = 46828,
  [SMALL_STATE(2094)] = 46880,
  [SMALL_STATE(2095)] = 46984,
  [SMALL_STATE(2096)] = 47040,
  [SMALL_STATE(2097)] = 47144,
  [SMALL_STATE(2098)] = 47244,
  [SMALL_STATE(2099)] = 47292,
  [SMALL_STATE(2100)] = 47340,
  [SMALL_STATE(2101)] = 47418,
  [SMALL_STATE(2102)] = 47472,
  [SMALL_STATE(2103)] = 47522,
  [SMALL_STATE(2104)] = 47622,
  [SMALL_STATE(2105)] = 47674,
  [SMALL_STATE(2106)] = 47778,
  [SMALL_STATE(2107)] = 47870,
  [SMALL_STATE(2108)] = 47948,
  [SMALL_STATE(2109)] = 47996,
  [SMALL_STATE(2110)] = 48044,
  [SMALL_STATE(2111)] = 48092,
  [SMALL_STATE(2112)] = 48192,
  [SMALL_STATE(2113)] = 48250,
  [SMALL_STATE(2114)] = 48354,
  [SMALL_STATE(2115)] = 48454,
  [SMALL_STATE(2116)] = 48512,
  [SMALL_STATE(2117)] = 48560,
  [SMALL_STATE(2118)] = 48664,
  [SMALL_STATE(2119)] = 48764,
  [SMALL_STATE(2120)] = 48868,
  [SMALL_STATE(2121)] = 48916,
  [SMALL_STATE(2122)] = 49016,
  [SMALL_STATE(2123)] = 49116,
  [SMALL_STATE(2124)] = 49168,
  [SMALL_STATE(2125)] = 49216,
  [SMALL_STATE(2126)] = 49264,
  [SMALL_STATE(2127)] = 49364,
  [SMALL_STATE(2128)] = 49412,
  [SMALL_STATE(2129)] = 49512,
  [SMALL_STATE(2130)] = 49560,
  [SMALL_STATE(2131)] = 49660,
  [SMALL_STATE(2132)] = 49708,
  [SMALL_STATE(2133)] = 49776,
  [SMALL_STATE(2134)] = 49824,
  [SMALL_STATE(2135)] = 49872,
  [SMALL_STATE(2136)] = 49926,
  [SMALL_STATE(2137)] = 50030,
  [SMALL_STATE(2138)] = 50078,
  [SMALL_STATE(2139)] = 50126,
  [SMALL_STATE(2140)] = 50186,
  [SMALL_STATE(2141)] = 50260,
  [SMALL_STATE(2142)] = 50314,
  [SMALL_STATE(2143)] = 50366,
  [SMALL_STATE(2144)] = 50418,
  [SMALL_STATE(2145)] = 50474,
  [SMALL_STATE(2146)] = 50574,
  [SMALL_STATE(2147)] = 50674,
  [SMALL_STATE(2148)] = 50726,
  [SMALL_STATE(2149)] = 50778,
  [SMALL_STATE(2150)] = 50830,
  [SMALL_STATE(2151)] = 50882,
  [SMALL_STATE(2152)] = 50930,
  [SMALL_STATE(2153)] = 50978,
  [SMALL_STATE(2154)] = 51026,
  [SMALL_STATE(2155)] = 51074,
  [SMALL_STATE(2156)] = 51122,
  [SMALL_STATE(2157)] = 51170,
  [SMALL_STATE(2158)] = 51222,
  [SMALL_STATE(2159)] = 51274,
  [SMALL_STATE(2160)] = 51326,
  [SMALL_STATE(2161)] = 51378,
  [SMALL_STATE(2162)] = 51430,
  [SMALL_STATE(2163)] = 51482,
  [SMALL_STATE(2164)] = 51582,
  [SMALL_STATE(2165)] = 51652,
  [SMALL_STATE(2166)] = 51704,
  [SMALL_STATE(2167)] = 51756,
  [SMALL_STATE(2168)] = 51806,
  [SMALL_STATE(2169)] = 51854,
  [SMALL_STATE(2170)] = 51954,
  [SMALL_STATE(2171)] = 52006,
  [SMALL_STATE(2172)] = 52054,
  [SMALL_STATE(2173)] = 52118,
  [SMALL_STATE(2174)] = 52192,
  [SMALL_STATE(2175)] = 52280,
  [SMALL_STATE(2176)] = 52370,
  [SMALL_STATE(2177)] = 52422,
  [SMALL_STATE(2178)] = 52474,
  [SMALL_STATE(2179)] = 52522,
  [SMALL_STATE(2180)] = 52574,
  [SMALL_STATE(2181)] = 52622,
  [SMALL_STATE(2182)] = 52724,
  [SMALL_STATE(2183)] = 52772,
  [SMALL_STATE(2184)] = 52826,
  [SMALL_STATE(2185)] = 52874,
  [SMALL_STATE(2186)] = 52932,
  [SMALL_STATE(2187)] = 53034,
  [SMALL_STATE(2188)] = 53082,
  [SMALL_STATE(2189)] = 53186,
  [SMALL_STATE(2190)] = 53256,
  [SMALL_STATE(2191)] = 53308,
  [SMALL_STATE(2192)] = 53390,
  [SMALL_STATE(2193)] = 53442,
  [SMALL_STATE(2194)] = 53494,
  [SMALL_STATE(2195)] = 53542,
  [SMALL_STATE(2196)] = 53594,
  [SMALL_STATE(2197)] = 53694,
  [SMALL_STATE(2198)] = 53746,
  [SMALL_STATE(2199)] = 53794,
  [SMALL_STATE(2200)] = 53878,
  [SMALL_STATE(2201)] = 53964,
  [SMALL_STATE(2202)] = 54032,
  [SMALL_STATE(2203)] = 54080,
  [SMALL_STATE(2204)] = 54132,
  [SMALL_STATE(2205)] = 54232,
  [SMALL_STATE(2206)] = 54284,
  [SMALL_STATE(2207)] = 54384,
  [SMALL_STATE(2208)] = 54484,
  [SMALL_STATE(2209)] = 54532,
  [SMALL_STATE(2210)] = 54580,
  [SMALL_STATE(2211)] = 54632,
  [SMALL_STATE(2212)] = 54734,
  [SMALL_STATE(2213)] = 54788,
  [SMALL_STATE(2214)] = 54888,
  [SMALL_STATE(2215)] = 54944,
  [SMALL_STATE(2216)] = 55048,
  [SMALL_STATE(2217)] = 55148,
  [SMALL_STATE(2218)] = 55248,
  [SMALL_STATE(2219)] = 55348,
  [SMALL_STATE(2220)] = 55396,
  [SMALL_STATE(2221)] = 55452,
  [SMALL_STATE(2222)] = 55508,
  [SMALL_STATE(2223)] = 55560,
  [SMALL_STATE(2224)] = 55608,
  [SMALL_STATE(2225)] = 55656,
  [SMALL_STATE(2226)] = 55704,
  [SMALL_STATE(2227)] = 55756,
  [SMALL_STATE(2228)] = 55804,
  [SMALL_STATE(2229)] = 55852,
  [SMALL_STATE(2230)] = 55902,
  [SMALL_STATE(2231)] = 55950,
  [SMALL_STATE(2232)] = 55998,
  [SMALL_STATE(2233)] = 56050,
  [SMALL_STATE(2234)] = 56098,
  [SMALL_STATE(2235)] = 56150,
  [SMALL_STATE(2236)] = 56198,
  [SMALL_STATE(2237)] = 56250,
  [SMALL_STATE(2238)] = 56298,
  [SMALL_STATE(2239)] = 56398,
  [SMALL_STATE(2240)] = 56450,
  [SMALL_STATE(2241)] = 56502,
  [SMALL_STATE(2242)] = 56554,
  [SMALL_STATE(2243)] = 56602,
  [SMALL_STATE(2244)] = 56706,
  [SMALL_STATE(2245)] = 56758,
  [SMALL_STATE(2246)] = 56810,
  [SMALL_STATE(2247)] = 56862,
  [SMALL_STATE(2248)] = 56914,
  [SMALL_STATE(2249)] = 56962,
  [SMALL_STATE(2250)] = 57010,
  [SMALL_STATE(2251)] = 57066,
  [SMALL_STATE(2252)] = 57118,
  [SMALL_STATE(2253)] = 57206,
  [SMALL_STATE(2254)] = 57306,
  [SMALL_STATE(2255)] = 57380,
  [SMALL_STATE(2256)] = 57428,
  [SMALL_STATE(2257)] = 57476,
  [SMALL_STATE(2258)] = 57544,
  [SMALL_STATE(2259)] = 57592,
  [SMALL_STATE(2260)] = 57640,
  [SMALL_STATE(2261)] = 57688,
  [SMALL_STATE(2262)] = 57736,
  [SMALL_STATE(2263)] = 57840,
  [SMALL_STATE(2264)] = 57944,
  [SMALL_STATE(2265)] = 57992,
  [SMALL_STATE(2266)] = 58040,
  [SMALL_STATE(2267)] = 58088,
  [SMALL_STATE(2268)] = 58136,
  [SMALL_STATE(2269)] = 58184,
  [SMALL_STATE(2270)] = 58232,
  [SMALL_STATE(2271)] = 58280,
  [SMALL_STATE(2272)] = 58328,
  [SMALL_STATE(2273)] = 58376,
  [SMALL_STATE(2274)] = 58424,
  [SMALL_STATE(2275)] = 58472,
  [SMALL_STATE(2276)] = 58520,
  [SMALL_STATE(2277)] = 58568,
  [SMALL_STATE(2278)] = 58658,
  [SMALL_STATE(2279)] = 58706,
  [SMALL_STATE(2280)] = 58754,
  [SMALL_STATE(2281)] = 58818,
  [SMALL_STATE(2282)] = 58866,
  [SMALL_STATE(2283)] = 58934,
  [SMALL_STATE(2284)] = 58982,
  [SMALL_STATE(2285)] = 59054,
  [SMALL_STATE(2286)] = 59124,
  [SMALL_STATE(2287)] = 59192,
  [SMALL_STATE(2288)] = 59244,
  [SMALL_STATE(2289)] = 59300,
  [SMALL_STATE(2290)] = 59402,
  [SMALL_STATE(2291)] = 59450,
  [SMALL_STATE(2292)] = 59498,
  [SMALL_STATE(2293)] = 59550,
  [SMALL_STATE(2294)] = 59598,
  [SMALL_STATE(2295)] = 59680,
  [SMALL_STATE(2296)] = 59734,
  [SMALL_STATE(2297)] = 59788,
  [SMALL_STATE(2298)] = 59874,
  [SMALL_STATE(2299)] = 59974,
  [SMALL_STATE(2300)] = 60058,
  [SMALL_STATE(2301)] = 60106,
  [SMALL_STATE(2302)] = 60154,
  [SMALL_STATE(2303)] = 60202,
  [SMALL_STATE(2304)] = 60250,
  [SMALL_STATE(2305)] = 60298,
  [SMALL_STATE(2306)] = 60398,
  [SMALL_STATE(2307)] = 60502,
  [SMALL_STATE(2308)] = 60570,
  [SMALL_STATE(2309)] = 60618,
  [SMALL_STATE(2310)] = 60718,
  [SMALL_STATE(2311)] = 60818,
  [SMALL_STATE(2312)] = 60866,
  [SMALL_STATE(2313)] = 60916,
  [SMALL_STATE(2314)] = 60968,
  [SMALL_STATE(2315)] = 61016,
  [SMALL_STATE(2316)] = 61117,
  [SMALL_STATE(2317)] = 61218,
  [SMALL_STATE(2318)] = 61267,
  [SMALL_STATE(2319)] = 61368,
  [SMALL_STATE(2320)] = 61421,
  [SMALL_STATE(2321)] = 61522,
  [SMALL_STATE(2322)] = 61601,
  [SMALL_STATE(2323)] = 61702,
  [SMALL_STATE(2324)] = 61771,
  [SMALL_STATE(2325)] = 61850,
  [SMALL_STATE(2326)] = 61951,
  [SMALL_STATE(2327)] = 62052,
  [SMALL_STATE(2328)] = 62103,
  [SMALL_STATE(2329)] = 62156,
  [SMALL_STATE(2330)] = 62235,
  [SMALL_STATE(2331)] = 62288,
  [SMALL_STATE(2332)] = 62353,
  [SMALL_STATE(2333)] = 62422,
  [SMALL_STATE(2334)] = 62523,
  [SMALL_STATE(2335)] = 62578,
  [SMALL_STATE(2336)] = 62629,
  [SMALL_STATE(2337)] = 62698,
  [SMALL_STATE(2338)] = 62751,
  [SMALL_STATE(2339)] = 62852,
  [SMALL_STATE(2340)] = 62901,
  [SMALL_STATE(2341)] = 63000,
  [SMALL_STATE(2342)] = 63101,
  [SMALL_STATE(2343)] = 63202,
  [SMALL_STATE(2344)] = 63301,
  [SMALL_STATE(2345)] = 63370,
  [SMALL_STATE(2346)] = 63419,
  [SMALL_STATE(2347)] = 63498,
  [SMALL_STATE(2348)] = 63577,
  [SMALL_STATE(2349)] = 63676,
  [SMALL_STATE(2350)] = 63745,
  [SMALL_STATE(2351)] = 63846,
  [SMALL_STATE(2352)] = 63925,
  [SMALL_STATE(2353)] = 64026,
  [SMALL_STATE(2354)] = 64075,
  [SMALL_STATE(2355)] = 64176,
  [SMALL_STATE(2356)] = 64277,
  [SMALL_STATE(2357)] = 64328,
  [SMALL_STATE(2358)] = 64429,
  [SMALL_STATE(2359)] = 64530,
  [SMALL_STATE(2360)] = 64585,
  [SMALL_STATE(2361)] = 64640,
  [SMALL_STATE(2362)] = 64695,
  [SMALL_STATE(2363)] = 64774,
  [SMALL_STATE(2364)] = 64875,
  [SMALL_STATE(2365)] = 64944,
  [SMALL_STATE(2366)] = 65023,
  [SMALL_STATE(2367)] = 65090,
  [SMALL_STATE(2368)] = 65155,
  [SMALL_STATE(2369)] = 65220,
  [SMALL_STATE(2370)] = 65321,
  [SMALL_STATE(2371)] = 65372,
  [SMALL_STATE(2372)] = 65451,
  [SMALL_STATE(2373)] = 65521,
  [SMALL_STATE(2374)] = 65569,
  [SMALL_STATE(2375)] = 65667,
  [SMALL_STATE(2376)] = 65737,
  [SMALL_STATE(2377)] = 65819,
  [SMALL_STATE(2378)] = 65899,
  [SMALL_STATE(2379)] = 65997,
  [SMALL_STATE(2380)] = 66095,
  [SMALL_STATE(2381)] = 66155,
  [SMALL_STATE(2382)] = 66217,
  [SMALL_STATE(2383)] = 66289,
  [SMALL_STATE(2384)] = 66361,
  [SMALL_STATE(2385)] = 66459,
  [SMALL_STATE(2386)] = 66531,
  [SMALL_STATE(2387)] = 66593,
  [SMALL_STATE(2388)] = 66653,
  [SMALL_STATE(2389)] = 66703,
  [SMALL_STATE(2390)] = 66763,
  [SMALL_STATE(2391)] = 66861,
  [SMALL_STATE(2392)] = 66959,
  [SMALL_STATE(2393)] = 67057,
  [SMALL_STATE(2394)] = 67117,
  [SMALL_STATE(2395)] = 67215,
  [SMALL_STATE(2396)] = 67313,
  [SMALL_STATE(2397)] = 67361,
  [SMALL_STATE(2398)] = 67433,
  [SMALL_STATE(2399)] = 67531,
  [SMALL_STATE(2400)] = 67629,
  [SMALL_STATE(2401)] = 67689,
  [SMALL_STATE(2402)] = 67741,
  [SMALL_STATE(2403)] = 67839,
  [SMALL_STATE(2404)] = 67901,
  [SMALL_STATE(2405)] = 67963,
  [SMALL_STATE(2406)] = 68047,
  [SMALL_STATE(2407)] = 68099,
  [SMALL_STATE(2408)] = 68169,
  [SMALL_STATE(2409)] = 68229,
  [SMALL_STATE(2410)] = 68293,
  [SMALL_STATE(2411)] = 68391,
  [SMALL_STATE(2412)] = 68457,
  [SMALL_STATE(2413)] = 68529,
  [SMALL_STATE(2414)] = 68589,
  [SMALL_STATE(2415)] = 68649,
  [SMALL_STATE(2416)] = 68699,
  [SMALL_STATE(2417)] = 68761,
  [SMALL_STATE(2418)] = 68811,
  [SMALL_STATE(2419)] = 68909,
  [SMALL_STATE(2420)] = 68961,
  [SMALL_STATE(2421)] = 69009,
  [SMALL_STATE(2422)] = 69071,
  [SMALL_STATE(2423)] = 69119,
  [SMALL_STATE(2424)] = 69181,
  [SMALL_STATE(2425)] = 69249,
  [SMALL_STATE(2426)] = 69297,
  [SMALL_STATE(2427)] = 69395,
  [SMALL_STATE(2428)] = 69455,
  [SMALL_STATE(2429)] = 69517,
  [SMALL_STATE(2430)] = 69603,
  [SMALL_STATE(2431)] = 69675,
  [SMALL_STATE(2432)] = 69745,
  [SMALL_STATE(2433)] = 69793,
  [SMALL_STATE(2434)] = 69851,
  [SMALL_STATE(2435)] = 69909,
  [SMALL_STATE(2436)] = 69979,
  [SMALL_STATE(2437)] = 70037,
  [SMALL_STATE(2438)] = 70109,
  [SMALL_STATE(2439)] = 70197,
  [SMALL_STATE(2440)] = 70295,
  [SMALL_STATE(2441)] = 70365,
  [SMALL_STATE(2442)] = 70435,
  [SMALL_STATE(2443)] = 70493,
  [SMALL_STATE(2444)] = 70565,
  [SMALL_STATE(2445)] = 70637,
  [SMALL_STATE(2446)] = 70699,
  [SMALL_STATE(2447)] = 70797,
  [SMALL_STATE(2448)] = 70855,
  [SMALL_STATE(2449)] = 70905,
  [SMALL_STATE(2450)] = 70963,
  [SMALL_STATE(2451)] = 71061,
  [SMALL_STATE(2452)] = 71133,
  [SMALL_STATE(2453)] = 71181,
  [SMALL_STATE(2454)] = 71241,
  [SMALL_STATE(2455)] = 71289,
  [SMALL_STATE(2456)] = 71337,
  [SMALL_STATE(2457)] = 71407,
  [SMALL_STATE(2458)] = 71467,
  [SMALL_STATE(2459)] = 71529,
  [SMALL_STATE(2460)] = 71627,
  [SMALL_STATE(2461)] = 71687,
  [SMALL_STATE(2462)] = 71747,
  [SMALL_STATE(2463)] = 71795,
  [SMALL_STATE(2464)] = 71843,
  [SMALL_STATE(2465)] = 71905,
  [SMALL_STATE(2466)] = 71957,
  [SMALL_STATE(2467)] = 72005,
  [SMALL_STATE(2468)] = 72053,
  [SMALL_STATE(2469)] = 72153,
  [SMALL_STATE(2470)] = 72221,
  [SMALL_STATE(2471)] = 72269,
  [SMALL_STATE(2472)] = 72319,
  [SMALL_STATE(2473)] = 72367,
  [SMALL_STATE(2474)] = 72427,
  [SMALL_STATE(2475)] = 72475,
  [SMALL_STATE(2476)] = 72523,
  [SMALL_STATE(2477)] = 72581,
  [SMALL_STATE(2478)] = 72639,
  [SMALL_STATE(2479)] = 72737,
  [SMALL_STATE(2480)] = 72807,
  [SMALL_STATE(2481)] = 72867,
  [SMALL_STATE(2482)] = 72965,
  [SMALL_STATE(2483)] = 73013,
  [SMALL_STATE(2484)] = 73111,
  [SMALL_STATE(2485)] = 73201,
  [SMALL_STATE(2486)] = 73249,
  [SMALL_STATE(2487)] = 73325,
  [SMALL_STATE(2488)] = 73390,
  [SMALL_STATE(2489)] = 73445,
  [SMALL_STATE(2490)] = 73500,
  [SMALL_STATE(2491)] = 73555,
  [SMALL_STATE(2492)] = 73610,
  [SMALL_STATE(2493)] = 73665,
  [SMALL_STATE(2494)] = 73720,
  [SMALL_STATE(2495)] = 73809,
  [SMALL_STATE(2496)] = 73904,
  [SMALL_STATE(2497)] = 73993,
  [SMALL_STATE(2498)] = 74040,
  [SMALL_STATE(2499)] = 74095,
  [SMALL_STATE(2500)] = 74150,
  [SMALL_STATE(2501)] = 74205,
  [SMALL_STATE(2502)] = 74260,
  [SMALL_STATE(2503)] = 74315,
  [SMALL_STATE(2504)] = 74366,
  [SMALL_STATE(2505)] = 74431,
  [SMALL_STATE(2506)] = 74496,
  [SMALL_STATE(2507)] = 74543,
  [SMALL_STATE(2508)] = 74608,
  [SMALL_STATE(2509)] = 74703,
  [SMALL_STATE(2510)] = 74758,
  [SMALL_STATE(2511)] = 74805,
  [SMALL_STATE(2512)] = 74870,
  [SMALL_STATE(2513)] = 74925,
  [SMALL_STATE(2514)] = 74980,
  [SMALL_STATE(2515)] = 75031,
  [SMALL_STATE(2516)] = 75086,
  [SMALL_STATE(2517)] = 75151,
  [SMALL_STATE(2518)] = 75202,
  [SMALL_STATE(2519)] = 75267,
  [SMALL_STATE(2520)] = 75338,
  [SMALL_STATE(2521)] = 75393,
  [SMALL_STATE(2522)] = 75444,
  [SMALL_STATE(2523)] = 75521,
  [SMALL_STATE(2524)] = 75586,
  [SMALL_STATE(2525)] = 75641,
  [SMALL_STATE(2526)] = 75696,
  [SMALL_STATE(2527)] = 75761,
  [SMALL_STATE(2528)] = 75856,
  [SMALL_STATE(2529)] = 75924,
  [SMALL_STATE(2530)] = 75980,
  [SMALL_STATE(2531)] = 76030,
  [SMALL_STATE(2532)] = 76086,
  [SMALL_STATE(2533)] = 76146,
  [SMALL_STATE(2534)] = 76208,
  [SMALL_STATE(2535)] = 76258,
  [SMALL_STATE(2536)] = 76318,
  [SMALL_STATE(2537)] = 76382,
  [SMALL_STATE(2538)] = 76437,
  [SMALL_STATE(2539)] = 76496,
  [SMALL_STATE(2540)] = 76551,
  [SMALL_STATE(2541)] = 76606,
  [SMALL_STATE(2542)] = 76661,
  [SMALL_STATE(2543)] = 76714,
  [SMALL_STATE(2544)] = 76769,
  [SMALL_STATE(2545)] = 76824,
  [SMALL_STATE(2546)] = 76879,
  [SMALL_STATE(2547)] = 76936,
  [SMALL_STATE(2548)] = 76989,
  [SMALL_STATE(2549)] = 77044,
  [SMALL_STATE(2550)] = 77099,
  [SMALL_STATE(2551)] = 77154,
  [SMALL_STATE(2552)] = 77209,
  [SMALL_STATE(2553)] = 77264,
  [SMALL_STATE(2554)] = 77325,
  [SMALL_STATE(2555)] = 77380,
  [SMALL_STATE(2556)] = 77435,
  [SMALL_STATE(2557)] = 77490,
  [SMALL_STATE(2558)] = 77545,
  [SMALL_STATE(2559)] = 77600,
  [SMALL_STATE(2560)] = 77655,
  [SMALL_STATE(2561)] = 77709,
  [SMALL_STATE(2562)] = 77751,
  [SMALL_STATE(2563)] = 77793,
  [SMALL_STATE(2564)] = 77856,
  [SMALL_STATE(2565)] = 77903,
  [SMALL_STATE(2566)] = 77950,
  [SMALL_STATE(2567)] = 77997,
  [SMALL_STATE(2568)] = 78037,
  [SMALL_STATE(2569)] = 78077,
  [SMALL_STATE(2570)] = 78117,
  [SMALL_STATE(2571)] = 78157,
  [SMALL_STATE(2572)] = 78197,
  [SMALL_STATE(2573)] = 78241,
  [SMALL_STATE(2574)] = 78281,
  [SMALL_STATE(2575)] = 78321,
  [SMALL_STATE(2576)] = 78365,
  [SMALL_STATE(2577)] = 78405,
  [SMALL_STATE(2578)] = 78445,
  [SMALL_STATE(2579)] = 78501,
  [SMALL_STATE(2580)] = 78555,
  [SMALL_STATE(2581)] = 78609,
  [SMALL_STATE(2582)] = 78665,
  [SMALL_STATE(2583)] = 78705,
  [SMALL_STATE(2584)] = 78745,
  [SMALL_STATE(2585)] = 78785,
  [SMALL_STATE(2586)] = 78825,
  [SMALL_STATE(2587)] = 78865,
  [SMALL_STATE(2588)] = 78905,
  [SMALL_STATE(2589)] = 78945,
  [SMALL_STATE(2590)] = 78985,
  [SMALL_STATE(2591)] = 79025,
  [SMALL_STATE(2592)] = 79065,
  [SMALL_STATE(2593)] = 79105,
  [SMALL_STATE(2594)] = 79147,
  [SMALL_STATE(2595)] = 79187,
  [SMALL_STATE(2596)] = 79227,
  [SMALL_STATE(2597)] = 79269,
  [SMALL_STATE(2598)] = 79321,
  [SMALL_STATE(2599)] = 79361,
  [SMALL_STATE(2600)] = 79415,
  [SMALL_STATE(2601)] = 79471,
  [SMALL_STATE(2602)] = 79513,
  [SMALL_STATE(2603)] = 79567,
  [SMALL_STATE(2604)] = 79616,
  [SMALL_STATE(2605)] = 79665,
  [SMALL_STATE(2606)] = 79714,
  [SMALL_STATE(2607)] = 79763,
  [SMALL_STATE(2608)] = 79804,
  [SMALL_STATE(2609)] = 79853,
  [SMALL_STATE(2610)] = 79902,
  [SMALL_STATE(2611)] = 79951,
  [SMALL_STATE(2612)] = 80000,
  [SMALL_STATE(2613)] = 80049,
  [SMALL_STATE(2614)] = 80098,
  [SMALL_STATE(2615)] = 80147,
  [SMALL_STATE(2616)] = 80196,
  [SMALL_STATE(2617)] = 80245,
  [SMALL_STATE(2618)] = 80294,
  [SMALL_STATE(2619)] = 80343,
  [SMALL_STATE(2620)] = 80406,
  [SMALL_STATE(2621)] = 80455,
  [SMALL_STATE(2622)] = 80504,
  [SMALL_STATE(2623)] = 80553,
  [SMALL_STATE(2624)] = 80602,
  [SMALL_STATE(2625)] = 80651,
  [SMALL_STATE(2626)] = 80692,
  [SMALL_STATE(2627)] = 80742,
  [SMALL_STATE(2628)] = 80792,
  [SMALL_STATE(2629)] = 80830,
  [SMALL_STATE(2630)] = 80868,
  [SMALL_STATE(2631)] = 80906,
  [SMALL_STATE(2632)] = 80944,
  [SMALL_STATE(2633)] = 80982,
  [SMALL_STATE(2634)] = 81020,
  [SMALL_STATE(2635)] = 81070,
  [SMALL_STATE(2636)] = 81130,
  [SMALL_STATE(2637)] = 81190,
  [SMALL_STATE(2638)] = 81250,
  [SMALL_STATE(2639)] = 81300,
  [SMALL_STATE(2640)] = 81350,
  [SMALL_STATE(2641)] = 81406,
  [SMALL_STATE(2642)] = 81444,
  [SMALL_STATE(2643)] = 81482,
  [SMALL_STATE(2644)] = 81520,
  [SMALL_STATE(2645)] = 81559,
  [SMALL_STATE(2646)] = 81610,
  [SMALL_STATE(2647)] = 81657,
  [SMALL_STATE(2648)] = 81710,
  [SMALL_STATE(2649)] = 81763,
  [SMALL_STATE(2650)] = 81816,
  [SMALL_STATE(2651)] = 81869,
  [SMALL_STATE(2652)] = 81920,
  [SMALL_STATE(2653)] = 81973,
  [SMALL_STATE(2654)] = 82026,
  [SMALL_STATE(2655)] = 82079,
  [SMALL_STATE(2656)] = 82132,
  [SMALL_STATE(2657)] = 82185,
  [SMALL_STATE(2658)] = 82238,
  [SMALL_STATE(2659)] = 82291,
  [SMALL_STATE(2660)] = 82344,
  [SMALL_STATE(2661)] = 82390,
  [SMALL_STATE(2662)] = 82434,
  [SMALL_STATE(2663)] = 82478,
  [SMALL_STATE(2664)] = 82522,
  [SMALL_STATE(2665)] = 82566,
  [SMALL_STATE(2666)] = 82612,
  [SMALL_STATE(2667)] = 82656,
  [SMALL_STATE(2668)] = 82700,
  [SMALL_STATE(2669)] = 82744,
  [SMALL_STATE(2670)] = 82788,
  [SMALL_STATE(2671)] = 82832,
  [SMALL_STATE(2672)] = 82876,
  [SMALL_STATE(2673)] = 82920,
  [SMALL_STATE(2674)] = 82964,
  [SMALL_STATE(2675)] = 83008,
  [SMALL_STATE(2676)] = 83052,
  [SMALL_STATE(2677)] = 83096,
  [SMALL_STATE(2678)] = 83140,
  [SMALL_STATE(2679)] = 83184,
  [SMALL_STATE(2680)] = 83228,
  [SMALL_STATE(2681)] = 83274,
  [SMALL_STATE(2682)] = 83318,
  [SMALL_STATE(2683)] = 83362,
  [SMALL_STATE(2684)] = 83406,
  [SMALL_STATE(2685)] = 83450,
  [SMALL_STATE(2686)] = 83494,
  [SMALL_STATE(2687)] = 83538,
  [SMALL_STATE(2688)] = 83582,
  [SMALL_STATE(2689)] = 83626,
  [SMALL_STATE(2690)] = 83670,
  [SMALL_STATE(2691)] = 83714,
  [SMALL_STATE(2692)] = 83758,
  [SMALL_STATE(2693)] = 83802,
  [SMALL_STATE(2694)] = 83846,
  [SMALL_STATE(2695)] = 83878,
  [SMALL_STATE(2696)] = 83910,
  [SMALL_STATE(2697)] = 83942,
  [SMALL_STATE(2698)] = 83974,
  [SMALL_STATE(2699)] = 84006,
  [SMALL_STATE(2700)] = 84037,
  [SMALL_STATE(2701)] = 84067,
  [SMALL_STATE(2702)] = 84102,
  [SMALL_STATE(2703)] = 84137,
  [SMALL_STATE(2704)] = 84172,
  [SMALL_STATE(2705)] = 84198,
  [SMALL_STATE(2706)] = 84224,
  [SMALL_STATE(2707)] = 84250,
  [SMALL_STATE(2708)] = 84276,
  [SMALL_STATE(2709)] = 84302,
  [SMALL_STATE(2710)] = 84328,
  [SMALL_STATE(2711)] = 84354,
  [SMALL_STATE(2712)] = 84380,
  [SMALL_STATE(2713)] = 84406,
  [SMALL_STATE(2714)] = 84432,
  [SMALL_STATE(2715)] = 84458,
  [SMALL_STATE(2716)] = 84484,
  [SMALL_STATE(2717)] = 84510,
  [SMALL_STATE(2718)] = 84536,
  [SMALL_STATE(2719)] = 84562,
  [SMALL_STATE(2720)] = 84588,
  [SMALL_STATE(2721)] = 84614,
  [SMALL_STATE(2722)] = 84640,
  [SMALL_STATE(2723)] = 84666,
  [SMALL_STATE(2724)] = 84692,
  [SMALL_STATE(2725)] = 84718,
  [SMALL_STATE(2726)] = 84772,
  [SMALL_STATE(2727)] = 84798,
  [SMALL_STATE(2728)] = 84824,
  [SMALL_STATE(2729)] = 84850,
  [SMALL_STATE(2730)] = 84876,
  [SMALL_STATE(2731)] = 84902,
  [SMALL_STATE(2732)] = 84928,
  [SMALL_STATE(2733)] = 84954,
  [SMALL_STATE(2734)] = 84980,
  [SMALL_STATE(2735)] = 85006,
  [SMALL_STATE(2736)] = 85032,
  [SMALL_STATE(2737)] = 85058,
  [SMALL_STATE(2738)] = 85084,
  [SMALL_STATE(2739)] = 85110,
  [SMALL_STATE(2740)] = 85164,
  [SMALL_STATE(2741)] = 85193,
  [SMALL_STATE(2742)] = 85218,
  [SMALL_STATE(2743)] = 85243,
  [SMALL_STATE(2744)] = 85268,
  [SMALL_STATE(2745)] = 85293,
  [SMALL_STATE(2746)] = 85318,
  [SMALL_STATE(2747)] = 85343,
  [SMALL_STATE(2748)] = 85368,
  [SMALL_STATE(2749)] = 85393,
  [SMALL_STATE(2750)] = 85418,
  [SMALL_STATE(2751)] = 85449,
  [SMALL_STATE(2752)] = 85473,
  [SMALL_STATE(2753)] = 85497,
  [SMALL_STATE(2754)] = 85521,
  [SMALL_STATE(2755)] = 85549,
  [SMALL_STATE(2756)] = 85577,
  [SMALL_STATE(2757)] = 85601,
  [SMALL_STATE(2758)] = 85625,
  [SMALL_STATE(2759)] = 85649,
  [SMALL_STATE(2760)] = 85679,
  [SMALL_STATE(2761)] = 85711,
  [SMALL_STATE(2762)] = 85734,
  [SMALL_STATE(2763)] = 85775,
  [SMALL_STATE(2764)] = 85798,
  [SMALL_STATE(2765)] = 85819,
  [SMALL_STATE(2766)] = 85842,
  [SMALL_STATE(2767)] = 85873,
  [SMALL_STATE(2768)] = 85896,
  [SMALL_STATE(2769)] = 85927,
  [SMALL_STATE(2770)] = 85950,
  [SMALL_STATE(2771)] = 85973,
  [SMALL_STATE(2772)] = 85996,
  [SMALL_STATE(2773)] = 86021,
  [SMALL_STATE(2774)] = 86044,
  [SMALL_STATE(2775)] = 86067,
  [SMALL_STATE(2776)] = 86088,
  [SMALL_STATE(2777)] = 86119,
  [SMALL_STATE(2778)] = 86140,
  [SMALL_STATE(2779)] = 86163,
  [SMALL_STATE(2780)] = 86188,
  [SMALL_STATE(2781)] = 86209,
  [SMALL_STATE(2782)] = 86230,
  [SMALL_STATE(2783)] = 86263,
  [SMALL_STATE(2784)] = 86286,
  [SMALL_STATE(2785)] = 86309,
  [SMALL_STATE(2786)] = 86330,
  [SMALL_STATE(2787)] = 86353,
  [SMALL_STATE(2788)] = 86374,
  [SMALL_STATE(2789)] = 86415,
  [SMALL_STATE(2790)] = 86436,
  [SMALL_STATE(2791)] = 86459,
  [SMALL_STATE(2792)] = 86482,
  [SMALL_STATE(2793)] = 86511,
  [SMALL_STATE(2794)] = 86534,
  [SMALL_STATE(2795)] = 86557,
  [SMALL_STATE(2796)] = 86580,
  [SMALL_STATE(2797)] = 86615,
  [SMALL_STATE(2798)] = 86656,
  [SMALL_STATE(2799)] = 86679,
  [SMALL_STATE(2800)] = 86702,
  [SMALL_STATE(2801)] = 86725,
  [SMALL_STATE(2802)] = 86752,
  [SMALL_STATE(2803)] = 86793,
  [SMALL_STATE(2804)] = 86816,
  [SMALL_STATE(2805)] = 86838,
  [SMALL_STATE(2806)] = 86862,
  [SMALL_STATE(2807)] = 86888,
  [SMALL_STATE(2808)] = 86916,
  [SMALL_STATE(2809)] = 86938,
  [SMALL_STATE(2810)] = 86960,
  [SMALL_STATE(2811)] = 86982,
  [SMALL_STATE(2812)] = 87004,
  [SMALL_STATE(2813)] = 87026,
  [SMALL_STATE(2814)] = 87048,
  [SMALL_STATE(2815)] = 87070,
  [SMALL_STATE(2816)] = 87092,
  [SMALL_STATE(2817)] = 87114,
  [SMALL_STATE(2818)] = 87144,
  [SMALL_STATE(2819)] = 87174,
  [SMALL_STATE(2820)] = 87196,
  [SMALL_STATE(2821)] = 87226,
  [SMALL_STATE(2822)] = 87254,
  [SMALL_STATE(2823)] = 87296,
  [SMALL_STATE(2824)] = 87318,
  [SMALL_STATE(2825)] = 87340,
  [SMALL_STATE(2826)] = 87362,
  [SMALL_STATE(2827)] = 87384,
  [SMALL_STATE(2828)] = 87406,
  [SMALL_STATE(2829)] = 87428,
  [SMALL_STATE(2830)] = 87450,
  [SMALL_STATE(2831)] = 87472,
  [SMALL_STATE(2832)] = 87494,
  [SMALL_STATE(2833)] = 87516,
  [SMALL_STATE(2834)] = 87546,
  [SMALL_STATE(2835)] = 87576,
  [SMALL_STATE(2836)] = 87606,
  [SMALL_STATE(2837)] = 87636,
  [SMALL_STATE(2838)] = 87664,
  [SMALL_STATE(2839)] = 87706,
  [SMALL_STATE(2840)] = 87736,
  [SMALL_STATE(2841)] = 87778,
  [SMALL_STATE(2842)] = 87808,
  [SMALL_STATE(2843)] = 87850,
  [SMALL_STATE(2844)] = 87872,
  [SMALL_STATE(2845)] = 87894,
  [SMALL_STATE(2846)] = 87916,
  [SMALL_STATE(2847)] = 87938,
  [SMALL_STATE(2848)] = 87960,
  [SMALL_STATE(2849)] = 87982,
  [SMALL_STATE(2850)] = 88004,
  [SMALL_STATE(2851)] = 88026,
  [SMALL_STATE(2852)] = 88048,
  [SMALL_STATE(2853)] = 88078,
  [SMALL_STATE(2854)] = 88100,
  [SMALL_STATE(2855)] = 88122,
  [SMALL_STATE(2856)] = 88144,
  [SMALL_STATE(2857)] = 88166,
  [SMALL_STATE(2858)] = 88196,
  [SMALL_STATE(2859)] = 88224,
  [SMALL_STATE(2860)] = 88252,
  [SMALL_STATE(2861)] = 88294,
  [SMALL_STATE(2862)] = 88324,
  [SMALL_STATE(2863)] = 88354,
  [SMALL_STATE(2864)] = 88396,
  [SMALL_STATE(2865)] = 88438,
  [SMALL_STATE(2866)] = 88466,
  [SMALL_STATE(2867)] = 88496,
  [SMALL_STATE(2868)] = 88526,
  [SMALL_STATE(2869)] = 88556,
  [SMALL_STATE(2870)] = 88586,
  [SMALL_STATE(2871)] = 88614,
  [SMALL_STATE(2872)] = 88642,
  [SMALL_STATE(2873)] = 88670,
  [SMALL_STATE(2874)] = 88700,
  [SMALL_STATE(2875)] = 88730,
  [SMALL_STATE(2876)] = 88758,
  [SMALL_STATE(2877)] = 88788,
  [SMALL_STATE(2878)] = 88809,
  [SMALL_STATE(2879)] = 88830,
  [SMALL_STATE(2880)] = 88865,
  [SMALL_STATE(2881)] = 88886,
  [SMALL_STATE(2882)] = 88911,
  [SMALL_STATE(2883)] = 88942,
  [SMALL_STATE(2884)] = 88977,
  [SMALL_STATE(2885)] = 89012,
  [SMALL_STATE(2886)] = 89047,
  [SMALL_STATE(2887)] = 89072,
  [SMALL_STATE(2888)] = 89099,
  [SMALL_STATE(2889)] = 89126,
  [SMALL_STATE(2890)] = 89151,
  [SMALL_STATE(2891)] = 89172,
  [SMALL_STATE(2892)] = 89197,
  [SMALL_STATE(2893)] = 89228,
  [SMALL_STATE(2894)] = 89253,
  [SMALL_STATE(2895)] = 89274,
  [SMALL_STATE(2896)] = 89309,
  [SMALL_STATE(2897)] = 89336,
  [SMALL_STATE(2898)] = 89361,
  [SMALL_STATE(2899)] = 89388,
  [SMALL_STATE(2900)] = 89415,
  [SMALL_STATE(2901)] = 89442,
  [SMALL_STATE(2902)] = 89463,
  [SMALL_STATE(2903)] = 89498,
  [SMALL_STATE(2904)] = 89529,
  [SMALL_STATE(2905)] = 89554,
  [SMALL_STATE(2906)] = 89589,
  [SMALL_STATE(2907)] = 89624,
  [SMALL_STATE(2908)] = 89661,
  [SMALL_STATE(2909)] = 89692,
  [SMALL_STATE(2910)] = 89727,
  [SMALL_STATE(2911)] = 89752,
  [SMALL_STATE(2912)] = 89777,
  [SMALL_STATE(2913)] = 89812,
  [SMALL_STATE(2914)] = 89830,
  [SMALL_STATE(2915)] = 89858,
  [SMALL_STATE(2916)] = 89890,
  [SMALL_STATE(2917)] = 89926,
  [SMALL_STATE(2918)] = 89962,
  [SMALL_STATE(2919)] = 89994,
  [SMALL_STATE(2920)] = 90022,
  [SMALL_STATE(2921)] = 90052,
  [SMALL_STATE(2922)] = 90084,
  [SMALL_STATE(2923)] = 90108,
  [SMALL_STATE(2924)] = 90140,
  [SMALL_STATE(2925)] = 90158,
  [SMALL_STATE(2926)] = 90176,
  [SMALL_STATE(2927)] = 90194,
  [SMALL_STATE(2928)] = 90226,
  [SMALL_STATE(2929)] = 90244,
  [SMALL_STATE(2930)] = 90262,
  [SMALL_STATE(2931)] = 90280,
  [SMALL_STATE(2932)] = 90298,
  [SMALL_STATE(2933)] = 90326,
  [SMALL_STATE(2934)] = 90344,
  [SMALL_STATE(2935)] = 90362,
  [SMALL_STATE(2936)] = 90394,
  [SMALL_STATE(2937)] = 90412,
  [SMALL_STATE(2938)] = 90430,
  [SMALL_STATE(2939)] = 90448,
  [SMALL_STATE(2940)] = 90466,
  [SMALL_STATE(2941)] = 90486,
  [SMALL_STATE(2942)] = 90504,
  [SMALL_STATE(2943)] = 90540,
  [SMALL_STATE(2944)] = 90576,
  [SMALL_STATE(2945)] = 90596,
  [SMALL_STATE(2946)] = 90614,
  [SMALL_STATE(2947)] = 90634,
  [SMALL_STATE(2948)] = 90652,
  [SMALL_STATE(2949)] = 90670,
  [SMALL_STATE(2950)] = 90688,
  [SMALL_STATE(2951)] = 90706,
  [SMALL_STATE(2952)] = 90724,
  [SMALL_STATE(2953)] = 90742,
  [SMALL_STATE(2954)] = 90760,
  [SMALL_STATE(2955)] = 90780,
  [SMALL_STATE(2956)] = 90798,
  [SMALL_STATE(2957)] = 90816,
  [SMALL_STATE(2958)] = 90844,
  [SMALL_STATE(2959)] = 90880,
  [SMALL_STATE(2960)] = 90898,
  [SMALL_STATE(2961)] = 90916,
  [SMALL_STATE(2962)] = 90934,
  [SMALL_STATE(2963)] = 90952,
  [SMALL_STATE(2964)] = 90970,
  [SMALL_STATE(2965)] = 91002,
  [SMALL_STATE(2966)] = 91020,
  [SMALL_STATE(2967)] = 91038,
  [SMALL_STATE(2968)] = 91056,
  [SMALL_STATE(2969)] = 91074,
  [SMALL_STATE(2970)] = 91096,
  [SMALL_STATE(2971)] = 91128,
  [SMALL_STATE(2972)] = 91164,
  [SMALL_STATE(2973)] = 91196,
  [SMALL_STATE(2974)] = 91228,
  [SMALL_STATE(2975)] = 91264,
  [SMALL_STATE(2976)] = 91296,
  [SMALL_STATE(2977)] = 91315,
  [SMALL_STATE(2978)] = 91332,
  [SMALL_STATE(2979)] = 91355,
  [SMALL_STATE(2980)] = 91374,
  [SMALL_STATE(2981)] = 91395,
  [SMALL_STATE(2982)] = 91414,
  [SMALL_STATE(2983)] = 91435,
  [SMALL_STATE(2984)] = 91454,
  [SMALL_STATE(2985)] = 91477,
  [SMALL_STATE(2986)] = 91498,
  [SMALL_STATE(2987)] = 91519,
  [SMALL_STATE(2988)] = 91538,
  [SMALL_STATE(2989)] = 91557,
  [SMALL_STATE(2990)] = 91576,
  [SMALL_STATE(2991)] = 91595,
  [SMALL_STATE(2992)] = 91614,
  [SMALL_STATE(2993)] = 91637,
  [SMALL_STATE(2994)] = 91656,
  [SMALL_STATE(2995)] = 91675,
  [SMALL_STATE(2996)] = 91694,
  [SMALL_STATE(2997)] = 91713,
  [SMALL_STATE(2998)] = 91732,
  [SMALL_STATE(2999)] = 91751,
  [SMALL_STATE(3000)] = 91772,
  [SMALL_STATE(3001)] = 91795,
  [SMALL_STATE(3002)] = 91814,
  [SMALL_STATE(3003)] = 91851,
  [SMALL_STATE(3004)] = 91868,
  [SMALL_STATE(3005)] = 91889,
  [SMALL_STATE(3006)] = 91908,
  [SMALL_STATE(3007)] = 91931,
  [SMALL_STATE(3008)] = 91950,
  [SMALL_STATE(3009)] = 91969,
  [SMALL_STATE(3010)] = 91992,
  [SMALL_STATE(3011)] = 92011,
  [SMALL_STATE(3012)] = 92034,
  [SMALL_STATE(3013)] = 92055,
  [SMALL_STATE(3014)] = 92074,
  [SMALL_STATE(3015)] = 92093,
  [SMALL_STATE(3016)] = 92112,
  [SMALL_STATE(3017)] = 92129,
  [SMALL_STATE(3018)] = 92148,
  [SMALL_STATE(3019)] = 92167,
  [SMALL_STATE(3020)] = 92204,
  [SMALL_STATE(3021)] = 92223,
  [SMALL_STATE(3022)] = 92240,
  [SMALL_STATE(3023)] = 92257,
  [SMALL_STATE(3024)] = 92278,
  [SMALL_STATE(3025)] = 92299,
  [SMALL_STATE(3026)] = 92316,
  [SMALL_STATE(3027)] = 92335,
  [SMALL_STATE(3028)] = 92356,
  [SMALL_STATE(3029)] = 92373,
  [SMALL_STATE(3030)] = 92392,
  [SMALL_STATE(3031)] = 92413,
  [SMALL_STATE(3032)] = 92434,
  [SMALL_STATE(3033)] = 92453,
  [SMALL_STATE(3034)] = 92472,
  [SMALL_STATE(3035)] = 92491,
  [SMALL_STATE(3036)] = 92510,
  [SMALL_STATE(3037)] = 92527,
  [SMALL_STATE(3038)] = 92546,
  [SMALL_STATE(3039)] = 92569,
  [SMALL_STATE(3040)] = 92588,
  [SMALL_STATE(3041)] = 92607,
  [SMALL_STATE(3042)] = 92626,
  [SMALL_STATE(3043)] = 92647,
  [SMALL_STATE(3044)] = 92666,
  [SMALL_STATE(3045)] = 92685,
  [SMALL_STATE(3046)] = 92706,
  [SMALL_STATE(3047)] = 92725,
  [SMALL_STATE(3048)] = 92747,
  [SMALL_STATE(3049)] = 92781,
  [SMALL_STATE(3050)] = 92815,
  [SMALL_STATE(3051)] = 92835,
  [SMALL_STATE(3052)] = 92857,
  [SMALL_STATE(3053)] = 92879,
  [SMALL_STATE(3054)] = 92901,
  [SMALL_STATE(3055)] = 92923,
  [SMALL_STATE(3056)] = 92941,
  [SMALL_STATE(3057)] = 92963,
  [SMALL_STATE(3058)] = 92981,
  [SMALL_STATE(3059)] = 93003,
  [SMALL_STATE(3060)] = 93023,
  [SMALL_STATE(3061)] = 93057,
  [SMALL_STATE(3062)] = 93077,
  [SMALL_STATE(3063)] = 93095,
  [SMALL_STATE(3064)] = 93111,
  [SMALL_STATE(3065)] = 93145,
  [SMALL_STATE(3066)] = 93173,
  [SMALL_STATE(3067)] = 93193,
  [SMALL_STATE(3068)] = 93221,
  [SMALL_STATE(3069)] = 93243,
  [SMALL_STATE(3070)] = 93265,
  [SMALL_STATE(3071)] = 93287,
  [SMALL_STATE(3072)] = 93321,
  [SMALL_STATE(3073)] = 93341,
  [SMALL_STATE(3074)] = 93361,
  [SMALL_STATE(3075)] = 93383,
  [SMALL_STATE(3076)] = 93401,
  [SMALL_STATE(3077)] = 93435,
  [SMALL_STATE(3078)] = 93457,
  [SMALL_STATE(3079)] = 93485,
  [SMALL_STATE(3080)] = 93505,
  [SMALL_STATE(3081)] = 93525,
  [SMALL_STATE(3082)] = 93547,
  [SMALL_STATE(3083)] = 93565,
  [SMALL_STATE(3084)] = 93599,
  [SMALL_STATE(3085)] = 93619,
  [SMALL_STATE(3086)] = 93639,
  [SMALL_STATE(3087)] = 93673,
  [SMALL_STATE(3088)] = 93693,
  [SMALL_STATE(3089)] = 93727,
  [SMALL_STATE(3090)] = 93751,
  [SMALL_STATE(3091)] = 93773,
  [SMALL_STATE(3092)] = 93795,
  [SMALL_STATE(3093)] = 93811,
  [SMALL_STATE(3094)] = 93845,
  [SMALL_STATE(3095)] = 93879,
  [SMALL_STATE(3096)] = 93904,
  [SMALL_STATE(3097)] = 93919,
  [SMALL_STATE(3098)] = 93936,
  [SMALL_STATE(3099)] = 93961,
  [SMALL_STATE(3100)] = 93986,
  [SMALL_STATE(3101)] = 94003,
  [SMALL_STATE(3102)] = 94034,
  [SMALL_STATE(3103)] = 94049,
  [SMALL_STATE(3104)] = 94074,
  [SMALL_STATE(3105)] = 94105,
  [SMALL_STATE(3106)] = 94130,
  [SMALL_STATE(3107)] = 94155,
  [SMALL_STATE(3108)] = 94170,
  [SMALL_STATE(3109)] = 94195,
  [SMALL_STATE(3110)] = 94210,
  [SMALL_STATE(3111)] = 94225,
  [SMALL_STATE(3112)] = 94250,
  [SMALL_STATE(3113)] = 94265,
  [SMALL_STATE(3114)] = 94296,
  [SMALL_STATE(3115)] = 94317,
  [SMALL_STATE(3116)] = 94336,
  [SMALL_STATE(3117)] = 94367,
  [SMALL_STATE(3118)] = 94388,
  [SMALL_STATE(3119)] = 94407,
  [SMALL_STATE(3120)] = 94438,
  [SMALL_STATE(3121)] = 94455,
  [SMALL_STATE(3122)] = 94470,
  [SMALL_STATE(3123)] = 94501,
  [SMALL_STATE(3124)] = 94522,
  [SMALL_STATE(3125)] = 94553,
  [SMALL_STATE(3126)] = 94568,
  [SMALL_STATE(3127)] = 94583,
  [SMALL_STATE(3128)] = 94598,
  [SMALL_STATE(3129)] = 94629,
  [SMALL_STATE(3130)] = 94650,
  [SMALL_STATE(3131)] = 94667,
  [SMALL_STATE(3132)] = 94698,
  [SMALL_STATE(3133)] = 94729,
  [SMALL_STATE(3134)] = 94744,
  [SMALL_STATE(3135)] = 94769,
  [SMALL_STATE(3136)] = 94790,
  [SMALL_STATE(3137)] = 94805,
  [SMALL_STATE(3138)] = 94836,
  [SMALL_STATE(3139)] = 94867,
  [SMALL_STATE(3140)] = 94898,
  [SMALL_STATE(3141)] = 94923,
  [SMALL_STATE(3142)] = 94942,
  [SMALL_STATE(3143)] = 94957,
  [SMALL_STATE(3144)] = 94988,
  [SMALL_STATE(3145)] = 95003,
  [SMALL_STATE(3146)] = 95028,
  [SMALL_STATE(3147)] = 95043,
  [SMALL_STATE(3148)] = 95058,
  [SMALL_STATE(3149)] = 95073,
  [SMALL_STATE(3150)] = 95092,
  [SMALL_STATE(3151)] = 95107,
  [SMALL_STATE(3152)] = 95122,
  [SMALL_STATE(3153)] = 95137,
  [SMALL_STATE(3154)] = 95162,
  [SMALL_STATE(3155)] = 95193,
  [SMALL_STATE(3156)] = 95224,
  [SMALL_STATE(3157)] = 95241,
  [SMALL_STATE(3158)] = 95256,
  [SMALL_STATE(3159)] = 95271,
  [SMALL_STATE(3160)] = 95286,
  [SMALL_STATE(3161)] = 95301,
  [SMALL_STATE(3162)] = 95316,
  [SMALL_STATE(3163)] = 95347,
  [SMALL_STATE(3164)] = 95362,
  [SMALL_STATE(3165)] = 95377,
  [SMALL_STATE(3166)] = 95396,
  [SMALL_STATE(3167)] = 95427,
  [SMALL_STATE(3168)] = 95452,
  [SMALL_STATE(3169)] = 95467,
  [SMALL_STATE(3170)] = 95482,
  [SMALL_STATE(3171)] = 95507,
  [SMALL_STATE(3172)] = 95522,
  [SMALL_STATE(3173)] = 95539,
  [SMALL_STATE(3174)] = 95554,
  [SMALL_STATE(3175)] = 95569,
  [SMALL_STATE(3176)] = 95584,
  [SMALL_STATE(3177)] = 95605,
  [SMALL_STATE(3178)] = 95624,
  [SMALL_STATE(3179)] = 95639,
  [SMALL_STATE(3180)] = 95656,
  [SMALL_STATE(3181)] = 95687,
  [SMALL_STATE(3182)] = 95702,
  [SMALL_STATE(3183)] = 95723,
  [SMALL_STATE(3184)] = 95744,
  [SMALL_STATE(3185)] = 95759,
  [SMALL_STATE(3186)] = 95774,
  [SMALL_STATE(3187)] = 95789,
  [SMALL_STATE(3188)] = 95820,
  [SMALL_STATE(3189)] = 95835,
  [SMALL_STATE(3190)] = 95860,
  [SMALL_STATE(3191)] = 95885,
  [SMALL_STATE(3192)] = 95900,
  [SMALL_STATE(3193)] = 95915,
  [SMALL_STATE(3194)] = 95933,
  [SMALL_STATE(3195)] = 95957,
  [SMALL_STATE(3196)] = 95975,
  [SMALL_STATE(3197)] = 95995,
  [SMALL_STATE(3198)] = 96019,
  [SMALL_STATE(3199)] = 96039,
  [SMALL_STATE(3200)] = 96063,
  [SMALL_STATE(3201)] = 96091,
  [SMALL_STATE(3202)] = 96119,
  [SMALL_STATE(3203)] = 96143,
  [SMALL_STATE(3204)] = 96167,
  [SMALL_STATE(3205)] = 96185,
  [SMALL_STATE(3206)] = 96213,
  [SMALL_STATE(3207)] = 96237,
  [SMALL_STATE(3208)] = 96257,
  [SMALL_STATE(3209)] = 96277,
  [SMALL_STATE(3210)] = 96301,
  [SMALL_STATE(3211)] = 96326,
  [SMALL_STATE(3212)] = 96343,
  [SMALL_STATE(3213)] = 96356,
  [SMALL_STATE(3214)] = 96369,
  [SMALL_STATE(3215)] = 96382,
  [SMALL_STATE(3216)] = 96395,
  [SMALL_STATE(3217)] = 96420,
  [SMALL_STATE(3218)] = 96445,
  [SMALL_STATE(3219)] = 96470,
  [SMALL_STATE(3220)] = 96495,
  [SMALL_STATE(3221)] = 96520,
  [SMALL_STATE(3222)] = 96545,
  [SMALL_STATE(3223)] = 96558,
  [SMALL_STATE(3224)] = 96583,
  [SMALL_STATE(3225)] = 96608,
  [SMALL_STATE(3226)] = 96633,
  [SMALL_STATE(3227)] = 96650,
  [SMALL_STATE(3228)] = 96675,
  [SMALL_STATE(3229)] = 96700,
  [SMALL_STATE(3230)] = 96725,
  [SMALL_STATE(3231)] = 96738,
  [SMALL_STATE(3232)] = 96751,
  [SMALL_STATE(3233)] = 96764,
  [SMALL_STATE(3234)] = 96789,
  [SMALL_STATE(3235)] = 96814,
  [SMALL_STATE(3236)] = 96839,
  [SMALL_STATE(3237)] = 96864,
  [SMALL_STATE(3238)] = 96877,
  [SMALL_STATE(3239)] = 96892,
  [SMALL_STATE(3240)] = 96913,
  [SMALL_STATE(3241)] = 96938,
  [SMALL_STATE(3242)] = 96955,
  [SMALL_STATE(3243)] = 96972,
  [SMALL_STATE(3244)] = 96987,
  [SMALL_STATE(3245)] = 97000,
  [SMALL_STATE(3246)] = 97013,
  [SMALL_STATE(3247)] = 97038,
  [SMALL_STATE(3248)] = 97055,
  [SMALL_STATE(3249)] = 97068,
  [SMALL_STATE(3250)] = 97093,
  [SMALL_STATE(3251)] = 97118,
  [SMALL_STATE(3252)] = 97143,
  [SMALL_STATE(3253)] = 97164,
  [SMALL_STATE(3254)] = 97179,
  [SMALL_STATE(3255)] = 97196,
  [SMALL_STATE(3256)] = 97213,
  [SMALL_STATE(3257)] = 97238,
  [SMALL_STATE(3258)] = 97263,
  [SMALL_STATE(3259)] = 97280,
  [SMALL_STATE(3260)] = 97305,
  [SMALL_STATE(3261)] = 97322,
  [SMALL_STATE(3262)] = 97339,
  [SMALL_STATE(3263)] = 97356,
  [SMALL_STATE(3264)] = 97373,
  [SMALL_STATE(3265)] = 97392,
  [SMALL_STATE(3266)] = 97409,
  [SMALL_STATE(3267)] = 97426,
  [SMALL_STATE(3268)] = 97451,
  [SMALL_STATE(3269)] = 97464,
  [SMALL_STATE(3270)] = 97481,
  [SMALL_STATE(3271)] = 97502,
  [SMALL_STATE(3272)] = 97515,
  [SMALL_STATE(3273)] = 97532,
  [SMALL_STATE(3274)] = 97553,
  [SMALL_STATE(3275)] = 97570,
  [SMALL_STATE(3276)] = 97587,
  [SMALL_STATE(3277)] = 97604,
  [SMALL_STATE(3278)] = 97621,
  [SMALL_STATE(3279)] = 97646,
  [SMALL_STATE(3280)] = 97669,
  [SMALL_STATE(3281)] = 97694,
  [SMALL_STATE(3282)] = 97719,
  [SMALL_STATE(3283)] = 97732,
  [SMALL_STATE(3284)] = 97747,
  [SMALL_STATE(3285)] = 97768,
  [SMALL_STATE(3286)] = 97793,
  [SMALL_STATE(3287)] = 97818,
  [SMALL_STATE(3288)] = 97843,
  [SMALL_STATE(3289)] = 97856,
  [SMALL_STATE(3290)] = 97881,
  [SMALL_STATE(3291)] = 97906,
  [SMALL_STATE(3292)] = 97927,
  [SMALL_STATE(3293)] = 97948,
  [SMALL_STATE(3294)] = 97969,
  [SMALL_STATE(3295)] = 97994,
  [SMALL_STATE(3296)] = 98015,
  [SMALL_STATE(3297)] = 98040,
  [SMALL_STATE(3298)] = 98065,
  [SMALL_STATE(3299)] = 98090,
  [SMALL_STATE(3300)] = 98115,
  [SMALL_STATE(3301)] = 98140,
  [SMALL_STATE(3302)] = 98165,
  [SMALL_STATE(3303)] = 98190,
  [SMALL_STATE(3304)] = 98207,
  [SMALL_STATE(3305)] = 98228,
  [SMALL_STATE(3306)] = 98253,
  [SMALL_STATE(3307)] = 98278,
  [SMALL_STATE(3308)] = 98303,
  [SMALL_STATE(3309)] = 98328,
  [SMALL_STATE(3310)] = 98345,
  [SMALL_STATE(3311)] = 98370,
  [SMALL_STATE(3312)] = 98389,
  [SMALL_STATE(3313)] = 98414,
  [SMALL_STATE(3314)] = 98439,
  [SMALL_STATE(3315)] = 98464,
  [SMALL_STATE(3316)] = 98483,
  [SMALL_STATE(3317)] = 98508,
  [SMALL_STATE(3318)] = 98525,
  [SMALL_STATE(3319)] = 98542,
  [SMALL_STATE(3320)] = 98563,
  [SMALL_STATE(3321)] = 98584,
  [SMALL_STATE(3322)] = 98599,
  [SMALL_STATE(3323)] = 98614,
  [SMALL_STATE(3324)] = 98635,
  [SMALL_STATE(3325)] = 98652,
  [SMALL_STATE(3326)] = 98671,
  [SMALL_STATE(3327)] = 98696,
  [SMALL_STATE(3328)] = 98721,
  [SMALL_STATE(3329)] = 98738,
  [SMALL_STATE(3330)] = 98763,
  [SMALL_STATE(3331)] = 98788,
  [SMALL_STATE(3332)] = 98805,
  [SMALL_STATE(3333)] = 98830,
  [SMALL_STATE(3334)] = 98848,
  [SMALL_STATE(3335)] = 98870,
  [SMALL_STATE(3336)] = 98892,
  [SMALL_STATE(3337)] = 98914,
  [SMALL_STATE(3338)] = 98936,
  [SMALL_STATE(3339)] = 98954,
  [SMALL_STATE(3340)] = 98976,
  [SMALL_STATE(3341)] = 98994,
  [SMALL_STATE(3342)] = 99012,
  [SMALL_STATE(3343)] = 99026,
  [SMALL_STATE(3344)] = 99038,
  [SMALL_STATE(3345)] = 99056,
  [SMALL_STATE(3346)] = 99078,
  [SMALL_STATE(3347)] = 99100,
  [SMALL_STATE(3348)] = 99116,
  [SMALL_STATE(3349)] = 99132,
  [SMALL_STATE(3350)] = 99144,
  [SMALL_STATE(3351)] = 99166,
  [SMALL_STATE(3352)] = 99188,
  [SMALL_STATE(3353)] = 99210,
  [SMALL_STATE(3354)] = 99228,
  [SMALL_STATE(3355)] = 99244,
  [SMALL_STATE(3356)] = 99256,
  [SMALL_STATE(3357)] = 99278,
  [SMALL_STATE(3358)] = 99296,
  [SMALL_STATE(3359)] = 99318,
  [SMALL_STATE(3360)] = 99332,
  [SMALL_STATE(3361)] = 99350,
  [SMALL_STATE(3362)] = 99366,
  [SMALL_STATE(3363)] = 99388,
  [SMALL_STATE(3364)] = 99400,
  [SMALL_STATE(3365)] = 99418,
  [SMALL_STATE(3366)] = 99440,
  [SMALL_STATE(3367)] = 99462,
  [SMALL_STATE(3368)] = 99484,
  [SMALL_STATE(3369)] = 99506,
  [SMALL_STATE(3370)] = 99524,
  [SMALL_STATE(3371)] = 99546,
  [SMALL_STATE(3372)] = 99562,
  [SMALL_STATE(3373)] = 99584,
  [SMALL_STATE(3374)] = 99602,
  [SMALL_STATE(3375)] = 99620,
  [SMALL_STATE(3376)] = 99642,
  [SMALL_STATE(3377)] = 99658,
  [SMALL_STATE(3378)] = 99676,
  [SMALL_STATE(3379)] = 99692,
  [SMALL_STATE(3380)] = 99706,
  [SMALL_STATE(3381)] = 99728,
  [SMALL_STATE(3382)] = 99744,
  [SMALL_STATE(3383)] = 99766,
  [SMALL_STATE(3384)] = 99782,
  [SMALL_STATE(3385)] = 99798,
  [SMALL_STATE(3386)] = 99814,
  [SMALL_STATE(3387)] = 99830,
  [SMALL_STATE(3388)] = 99846,
  [SMALL_STATE(3389)] = 99868,
  [SMALL_STATE(3390)] = 99886,
  [SMALL_STATE(3391)] = 99904,
  [SMALL_STATE(3392)] = 99920,
  [SMALL_STATE(3393)] = 99942,
  [SMALL_STATE(3394)] = 99958,
  [SMALL_STATE(3395)] = 99974,
  [SMALL_STATE(3396)] = 99990,
  [SMALL_STATE(3397)] = 100006,
  [SMALL_STATE(3398)] = 100020,
  [SMALL_STATE(3399)] = 100036,
  [SMALL_STATE(3400)] = 100058,
  [SMALL_STATE(3401)] = 100080,
  [SMALL_STATE(3402)] = 100102,
  [SMALL_STATE(3403)] = 100118,
  [SMALL_STATE(3404)] = 100140,
  [SMALL_STATE(3405)] = 100156,
  [SMALL_STATE(3406)] = 100172,
  [SMALL_STATE(3407)] = 100194,
  [SMALL_STATE(3408)] = 100214,
  [SMALL_STATE(3409)] = 100236,
  [SMALL_STATE(3410)] = 100258,
  [SMALL_STATE(3411)] = 100274,
  [SMALL_STATE(3412)] = 100290,
  [SMALL_STATE(3413)] = 100308,
  [SMALL_STATE(3414)] = 100330,
  [SMALL_STATE(3415)] = 100352,
  [SMALL_STATE(3416)] = 100370,
  [SMALL_STATE(3417)] = 100392,
  [SMALL_STATE(3418)] = 100410,
  [SMALL_STATE(3419)] = 100432,
  [SMALL_STATE(3420)] = 100454,
  [SMALL_STATE(3421)] = 100472,
  [SMALL_STATE(3422)] = 100490,
  [SMALL_STATE(3423)] = 100506,
  [SMALL_STATE(3424)] = 100528,
  [SMALL_STATE(3425)] = 100544,
  [SMALL_STATE(3426)] = 100560,
  [SMALL_STATE(3427)] = 100576,
  [SMALL_STATE(3428)] = 100598,
  [SMALL_STATE(3429)] = 100614,
  [SMALL_STATE(3430)] = 100630,
  [SMALL_STATE(3431)] = 100646,
  [SMALL_STATE(3432)] = 100662,
  [SMALL_STATE(3433)] = 100684,
  [SMALL_STATE(3434)] = 100704,
  [SMALL_STATE(3435)] = 100726,
  [SMALL_STATE(3436)] = 100748,
  [SMALL_STATE(3437)] = 100764,
  [SMALL_STATE(3438)] = 100782,
  [SMALL_STATE(3439)] = 100798,
  [SMALL_STATE(3440)] = 100814,
  [SMALL_STATE(3441)] = 100836,
  [SMALL_STATE(3442)] = 100858,
  [SMALL_STATE(3443)] = 100880,
  [SMALL_STATE(3444)] = 100896,
  [SMALL_STATE(3445)] = 100918,
  [SMALL_STATE(3446)] = 100934,
  [SMALL_STATE(3447)] = 100950,
  [SMALL_STATE(3448)] = 100972,
  [SMALL_STATE(3449)] = 100984,
  [SMALL_STATE(3450)] = 101006,
  [SMALL_STATE(3451)] = 101028,
  [SMALL_STATE(3452)] = 101044,
  [SMALL_STATE(3453)] = 101062,
  [SMALL_STATE(3454)] = 101084,
  [SMALL_STATE(3455)] = 101102,
  [SMALL_STATE(3456)] = 101120,
  [SMALL_STATE(3457)] = 101138,
  [SMALL_STATE(3458)] = 101160,
  [SMALL_STATE(3459)] = 101178,
  [SMALL_STATE(3460)] = 101200,
  [SMALL_STATE(3461)] = 101222,
  [SMALL_STATE(3462)] = 101238,
  [SMALL_STATE(3463)] = 101256,
  [SMALL_STATE(3464)] = 101274,
  [SMALL_STATE(3465)] = 101296,
  [SMALL_STATE(3466)] = 101318,
  [SMALL_STATE(3467)] = 101336,
  [SMALL_STATE(3468)] = 101354,
  [SMALL_STATE(3469)] = 101372,
  [SMALL_STATE(3470)] = 101388,
  [SMALL_STATE(3471)] = 101410,
  [SMALL_STATE(3472)] = 101428,
  [SMALL_STATE(3473)] = 101444,
  [SMALL_STATE(3474)] = 101460,
  [SMALL_STATE(3475)] = 101478,
  [SMALL_STATE(3476)] = 101496,
  [SMALL_STATE(3477)] = 101518,
  [SMALL_STATE(3478)] = 101540,
  [SMALL_STATE(3479)] = 101562,
  [SMALL_STATE(3480)] = 101584,
  [SMALL_STATE(3481)] = 101600,
  [SMALL_STATE(3482)] = 101622,
  [SMALL_STATE(3483)] = 101638,
  [SMALL_STATE(3484)] = 101660,
  [SMALL_STATE(3485)] = 101676,
  [SMALL_STATE(3486)] = 101692,
  [SMALL_STATE(3487)] = 101714,
  [SMALL_STATE(3488)] = 101732,
  [SMALL_STATE(3489)] = 101754,
  [SMALL_STATE(3490)] = 101772,
  [SMALL_STATE(3491)] = 101794,
  [SMALL_STATE(3492)] = 101810,
  [SMALL_STATE(3493)] = 101832,
  [SMALL_STATE(3494)] = 101854,
  [SMALL_STATE(3495)] = 101876,
  [SMALL_STATE(3496)] = 101888,
  [SMALL_STATE(3497)] = 101906,
  [SMALL_STATE(3498)] = 101924,
  [SMALL_STATE(3499)] = 101942,
  [SMALL_STATE(3500)] = 101960,
  [SMALL_STATE(3501)] = 101972,
  [SMALL_STATE(3502)] = 101994,
  [SMALL_STATE(3503)] = 102006,
  [SMALL_STATE(3504)] = 102022,
  [SMALL_STATE(3505)] = 102042,
  [SMALL_STATE(3506)] = 102058,
  [SMALL_STATE(3507)] = 102076,
  [SMALL_STATE(3508)] = 102090,
  [SMALL_STATE(3509)] = 102108,
  [SMALL_STATE(3510)] = 102124,
  [SMALL_STATE(3511)] = 102144,
  [SMALL_STATE(3512)] = 102166,
  [SMALL_STATE(3513)] = 102184,
  [SMALL_STATE(3514)] = 102200,
  [SMALL_STATE(3515)] = 102222,
  [SMALL_STATE(3516)] = 102240,
  [SMALL_STATE(3517)] = 102258,
  [SMALL_STATE(3518)] = 102270,
  [SMALL_STATE(3519)] = 102292,
  [SMALL_STATE(3520)] = 102310,
  [SMALL_STATE(3521)] = 102329,
  [SMALL_STATE(3522)] = 102340,
  [SMALL_STATE(3523)] = 102359,
  [SMALL_STATE(3524)] = 102374,
  [SMALL_STATE(3525)] = 102385,
  [SMALL_STATE(3526)] = 102404,
  [SMALL_STATE(3527)] = 102421,
  [SMALL_STATE(3528)] = 102436,
  [SMALL_STATE(3529)] = 102447,
  [SMALL_STATE(3530)] = 102462,
  [SMALL_STATE(3531)] = 102475,
  [SMALL_STATE(3532)] = 102492,
  [SMALL_STATE(3533)] = 102511,
  [SMALL_STATE(3534)] = 102528,
  [SMALL_STATE(3535)] = 102547,
  [SMALL_STATE(3536)] = 102562,
  [SMALL_STATE(3537)] = 102573,
  [SMALL_STATE(3538)] = 102584,
  [SMALL_STATE(3539)] = 102601,
  [SMALL_STATE(3540)] = 102620,
  [SMALL_STATE(3541)] = 102635,
  [SMALL_STATE(3542)] = 102646,
  [SMALL_STATE(3543)] = 102665,
  [SMALL_STATE(3544)] = 102676,
  [SMALL_STATE(3545)] = 102695,
  [SMALL_STATE(3546)] = 102710,
  [SMALL_STATE(3547)] = 102725,
  [SMALL_STATE(3548)] = 102744,
  [SMALL_STATE(3549)] = 102763,
  [SMALL_STATE(3550)] = 102782,
  [SMALL_STATE(3551)] = 102797,
  [SMALL_STATE(3552)] = 102816,
  [SMALL_STATE(3553)] = 102827,
  [SMALL_STATE(3554)] = 102846,
  [SMALL_STATE(3555)] = 102857,
  [SMALL_STATE(3556)] = 102868,
  [SMALL_STATE(3557)] = 102883,
  [SMALL_STATE(3558)] = 102898,
  [SMALL_STATE(3559)] = 102913,
  [SMALL_STATE(3560)] = 102930,
  [SMALL_STATE(3561)] = 102949,
  [SMALL_STATE(3562)] = 102960,
  [SMALL_STATE(3563)] = 102975,
  [SMALL_STATE(3564)] = 102986,
  [SMALL_STATE(3565)] = 103001,
  [SMALL_STATE(3566)] = 103020,
  [SMALL_STATE(3567)] = 103031,
  [SMALL_STATE(3568)] = 103042,
  [SMALL_STATE(3569)] = 103053,
  [SMALL_STATE(3570)] = 103064,
  [SMALL_STATE(3571)] = 103079,
  [SMALL_STATE(3572)] = 103098,
  [SMALL_STATE(3573)] = 103109,
  [SMALL_STATE(3574)] = 103128,
  [SMALL_STATE(3575)] = 103147,
  [SMALL_STATE(3576)] = 103166,
  [SMALL_STATE(3577)] = 103185,
  [SMALL_STATE(3578)] = 103202,
  [SMALL_STATE(3579)] = 103221,
  [SMALL_STATE(3580)] = 103238,
  [SMALL_STATE(3581)] = 103257,
  [SMALL_STATE(3582)] = 103274,
  [SMALL_STATE(3583)] = 103293,
  [SMALL_STATE(3584)] = 103304,
  [SMALL_STATE(3585)] = 103323,
  [SMALL_STATE(3586)] = 103338,
  [SMALL_STATE(3587)] = 103349,
  [SMALL_STATE(3588)] = 103360,
  [SMALL_STATE(3589)] = 103375,
  [SMALL_STATE(3590)] = 103394,
  [SMALL_STATE(3591)] = 103405,
  [SMALL_STATE(3592)] = 103424,
  [SMALL_STATE(3593)] = 103441,
  [SMALL_STATE(3594)] = 103460,
  [SMALL_STATE(3595)] = 103471,
  [SMALL_STATE(3596)] = 103482,
  [SMALL_STATE(3597)] = 103493,
  [SMALL_STATE(3598)] = 103504,
  [SMALL_STATE(3599)] = 103515,
  [SMALL_STATE(3600)] = 103530,
  [SMALL_STATE(3601)] = 103549,
  [SMALL_STATE(3602)] = 103560,
  [SMALL_STATE(3603)] = 103577,
  [SMALL_STATE(3604)] = 103592,
  [SMALL_STATE(3605)] = 103603,
  [SMALL_STATE(3606)] = 103614,
  [SMALL_STATE(3607)] = 103629,
  [SMALL_STATE(3608)] = 103640,
  [SMALL_STATE(3609)] = 103659,
  [SMALL_STATE(3610)] = 103678,
  [SMALL_STATE(3611)] = 103697,
  [SMALL_STATE(3612)] = 103714,
  [SMALL_STATE(3613)] = 103733,
  [SMALL_STATE(3614)] = 103744,
  [SMALL_STATE(3615)] = 103755,
  [SMALL_STATE(3616)] = 103772,
  [SMALL_STATE(3617)] = 103783,
  [SMALL_STATE(3618)] = 103800,
  [SMALL_STATE(3619)] = 103817,
  [SMALL_STATE(3620)] = 103828,
  [SMALL_STATE(3621)] = 103847,
  [SMALL_STATE(3622)] = 103862,
  [SMALL_STATE(3623)] = 103873,
  [SMALL_STATE(3624)] = 103892,
  [SMALL_STATE(3625)] = 103911,
  [SMALL_STATE(3626)] = 103930,
  [SMALL_STATE(3627)] = 103949,
  [SMALL_STATE(3628)] = 103966,
  [SMALL_STATE(3629)] = 103977,
  [SMALL_STATE(3630)] = 103996,
  [SMALL_STATE(3631)] = 104015,
  [SMALL_STATE(3632)] = 104034,
  [SMALL_STATE(3633)] = 104053,
  [SMALL_STATE(3634)] = 104072,
  [SMALL_STATE(3635)] = 104091,
  [SMALL_STATE(3636)] = 104110,
  [SMALL_STATE(3637)] = 104121,
  [SMALL_STATE(3638)] = 104138,
  [SMALL_STATE(3639)] = 104155,
  [SMALL_STATE(3640)] = 104174,
  [SMALL_STATE(3641)] = 104185,
  [SMALL_STATE(3642)] = 104196,
  [SMALL_STATE(3643)] = 104215,
  [SMALL_STATE(3644)] = 104234,
  [SMALL_STATE(3645)] = 104251,
  [SMALL_STATE(3646)] = 104262,
  [SMALL_STATE(3647)] = 104281,
  [SMALL_STATE(3648)] = 104300,
  [SMALL_STATE(3649)] = 104319,
  [SMALL_STATE(3650)] = 104338,
  [SMALL_STATE(3651)] = 104349,
  [SMALL_STATE(3652)] = 104364,
  [SMALL_STATE(3653)] = 104375,
  [SMALL_STATE(3654)] = 104390,
  [SMALL_STATE(3655)] = 104409,
  [SMALL_STATE(3656)] = 104420,
  [SMALL_STATE(3657)] = 104437,
  [SMALL_STATE(3658)] = 104456,
  [SMALL_STATE(3659)] = 104467,
  [SMALL_STATE(3660)] = 104478,
  [SMALL_STATE(3661)] = 104497,
  [SMALL_STATE(3662)] = 104508,
  [SMALL_STATE(3663)] = 104527,
  [SMALL_STATE(3664)] = 104542,
  [SMALL_STATE(3665)] = 104553,
  [SMALL_STATE(3666)] = 104568,
  [SMALL_STATE(3667)] = 104579,
  [SMALL_STATE(3668)] = 104590,
  [SMALL_STATE(3669)] = 104601,
  [SMALL_STATE(3670)] = 104612,
  [SMALL_STATE(3671)] = 104631,
  [SMALL_STATE(3672)] = 104648,
  [SMALL_STATE(3673)] = 104659,
  [SMALL_STATE(3674)] = 104674,
  [SMALL_STATE(3675)] = 104693,
  [SMALL_STATE(3676)] = 104712,
  [SMALL_STATE(3677)] = 104723,
  [SMALL_STATE(3678)] = 104740,
  [SMALL_STATE(3679)] = 104759,
  [SMALL_STATE(3680)] = 104774,
  [SMALL_STATE(3681)] = 104793,
  [SMALL_STATE(3682)] = 104812,
  [SMALL_STATE(3683)] = 104831,
  [SMALL_STATE(3684)] = 104848,
  [SMALL_STATE(3685)] = 104867,
  [SMALL_STATE(3686)] = 104884,
  [SMALL_STATE(3687)] = 104901,
  [SMALL_STATE(3688)] = 104918,
  [SMALL_STATE(3689)] = 104929,
  [SMALL_STATE(3690)] = 104940,
  [SMALL_STATE(3691)] = 104959,
  [SMALL_STATE(3692)] = 104974,
  [SMALL_STATE(3693)] = 104989,
  [SMALL_STATE(3694)] = 105008,
  [SMALL_STATE(3695)] = 105027,
  [SMALL_STATE(3696)] = 105046,
  [SMALL_STATE(3697)] = 105065,
  [SMALL_STATE(3698)] = 105084,
  [SMALL_STATE(3699)] = 105095,
  [SMALL_STATE(3700)] = 105106,
  [SMALL_STATE(3701)] = 105125,
  [SMALL_STATE(3702)] = 105142,
  [SMALL_STATE(3703)] = 105161,
  [SMALL_STATE(3704)] = 105172,
  [SMALL_STATE(3705)] = 105183,
  [SMALL_STATE(3706)] = 105198,
  [SMALL_STATE(3707)] = 105209,
  [SMALL_STATE(3708)] = 105224,
  [SMALL_STATE(3709)] = 105243,
  [SMALL_STATE(3710)] = 105262,
  [SMALL_STATE(3711)] = 105273,
  [SMALL_STATE(3712)] = 105284,
  [SMALL_STATE(3713)] = 105295,
  [SMALL_STATE(3714)] = 105306,
  [SMALL_STATE(3715)] = 105325,
  [SMALL_STATE(3716)] = 105336,
  [SMALL_STATE(3717)] = 105355,
  [SMALL_STATE(3718)] = 105374,
  [SMALL_STATE(3719)] = 105385,
  [SMALL_STATE(3720)] = 105402,
  [SMALL_STATE(3721)] = 105413,
  [SMALL_STATE(3722)] = 105424,
  [SMALL_STATE(3723)] = 105441,
  [SMALL_STATE(3724)] = 105452,
  [SMALL_STATE(3725)] = 105471,
  [SMALL_STATE(3726)] = 105482,
  [SMALL_STATE(3727)] = 105496,
  [SMALL_STATE(3728)] = 105512,
  [SMALL_STATE(3729)] = 105522,
  [SMALL_STATE(3730)] = 105538,
  [SMALL_STATE(3731)] = 105554,
  [SMALL_STATE(3732)] = 105570,
  [SMALL_STATE(3733)] = 105586,
  [SMALL_STATE(3734)] = 105602,
  [SMALL_STATE(3735)] = 105618,
  [SMALL_STATE(3736)] = 105634,
  [SMALL_STATE(3737)] = 105648,
  [SMALL_STATE(3738)] = 105664,
  [SMALL_STATE(3739)] = 105680,
  [SMALL_STATE(3740)] = 105696,
  [SMALL_STATE(3741)] = 105710,
  [SMALL_STATE(3742)] = 105724,
  [SMALL_STATE(3743)] = 105740,
  [SMALL_STATE(3744)] = 105754,
  [SMALL_STATE(3745)] = 105768,
  [SMALL_STATE(3746)] = 105782,
  [SMALL_STATE(3747)] = 105796,
  [SMALL_STATE(3748)] = 105812,
  [SMALL_STATE(3749)] = 105828,
  [SMALL_STATE(3750)] = 105842,
  [SMALL_STATE(3751)] = 105858,
  [SMALL_STATE(3752)] = 105872,
  [SMALL_STATE(3753)] = 105888,
  [SMALL_STATE(3754)] = 105902,
  [SMALL_STATE(3755)] = 105916,
  [SMALL_STATE(3756)] = 105930,
  [SMALL_STATE(3757)] = 105946,
  [SMALL_STATE(3758)] = 105960,
  [SMALL_STATE(3759)] = 105976,
  [SMALL_STATE(3760)] = 105992,
  [SMALL_STATE(3761)] = 106008,
  [SMALL_STATE(3762)] = 106024,
  [SMALL_STATE(3763)] = 106038,
  [SMALL_STATE(3764)] = 106054,
  [SMALL_STATE(3765)] = 106068,
  [SMALL_STATE(3766)] = 106082,
  [SMALL_STATE(3767)] = 106098,
  [SMALL_STATE(3768)] = 106114,
  [SMALL_STATE(3769)] = 106130,
  [SMALL_STATE(3770)] = 106144,
  [SMALL_STATE(3771)] = 106160,
  [SMALL_STATE(3772)] = 106174,
  [SMALL_STATE(3773)] = 106190,
  [SMALL_STATE(3774)] = 106206,
  [SMALL_STATE(3775)] = 106222,
  [SMALL_STATE(3776)] = 106236,
  [SMALL_STATE(3777)] = 106250,
  [SMALL_STATE(3778)] = 106266,
  [SMALL_STATE(3779)] = 106280,
  [SMALL_STATE(3780)] = 106294,
  [SMALL_STATE(3781)] = 106310,
  [SMALL_STATE(3782)] = 106326,
  [SMALL_STATE(3783)] = 106342,
  [SMALL_STATE(3784)] = 106358,
  [SMALL_STATE(3785)] = 106374,
  [SMALL_STATE(3786)] = 106390,
  [SMALL_STATE(3787)] = 106406,
  [SMALL_STATE(3788)] = 106420,
  [SMALL_STATE(3789)] = 106436,
  [SMALL_STATE(3790)] = 106450,
  [SMALL_STATE(3791)] = 106466,
  [SMALL_STATE(3792)] = 106480,
  [SMALL_STATE(3793)] = 106496,
  [SMALL_STATE(3794)] = 106510,
  [SMALL_STATE(3795)] = 106526,
  [SMALL_STATE(3796)] = 106540,
  [SMALL_STATE(3797)] = 106556,
  [SMALL_STATE(3798)] = 106572,
  [SMALL_STATE(3799)] = 106588,
  [SMALL_STATE(3800)] = 106604,
  [SMALL_STATE(3801)] = 106620,
  [SMALL_STATE(3802)] = 106636,
  [SMALL_STATE(3803)] = 106652,
  [SMALL_STATE(3804)] = 106668,
  [SMALL_STATE(3805)] = 106684,
  [SMALL_STATE(3806)] = 106698,
  [SMALL_STATE(3807)] = 106714,
  [SMALL_STATE(3808)] = 106730,
  [SMALL_STATE(3809)] = 106746,
  [SMALL_STATE(3810)] = 106762,
  [SMALL_STATE(3811)] = 106778,
  [SMALL_STATE(3812)] = 106794,
  [SMALL_STATE(3813)] = 106808,
  [SMALL_STATE(3814)] = 106824,
  [SMALL_STATE(3815)] = 106838,
  [SMALL_STATE(3816)] = 106854,
  [SMALL_STATE(3817)] = 106868,
  [SMALL_STATE(3818)] = 106882,
  [SMALL_STATE(3819)] = 106896,
  [SMALL_STATE(3820)] = 106912,
  [SMALL_STATE(3821)] = 106928,
  [SMALL_STATE(3822)] = 106942,
  [SMALL_STATE(3823)] = 106958,
  [SMALL_STATE(3824)] = 106972,
  [SMALL_STATE(3825)] = 106988,
  [SMALL_STATE(3826)] = 107002,
  [SMALL_STATE(3827)] = 107018,
  [SMALL_STATE(3828)] = 107034,
  [SMALL_STATE(3829)] = 107050,
  [SMALL_STATE(3830)] = 107066,
  [SMALL_STATE(3831)] = 107082,
  [SMALL_STATE(3832)] = 107096,
  [SMALL_STATE(3833)] = 107112,
  [SMALL_STATE(3834)] = 107122,
  [SMALL_STATE(3835)] = 107138,
  [SMALL_STATE(3836)] = 107152,
  [SMALL_STATE(3837)] = 107168,
  [SMALL_STATE(3838)] = 107184,
  [SMALL_STATE(3839)] = 107200,
  [SMALL_STATE(3840)] = 107214,
  [SMALL_STATE(3841)] = 107228,
  [SMALL_STATE(3842)] = 107242,
  [SMALL_STATE(3843)] = 107256,
  [SMALL_STATE(3844)] = 107272,
  [SMALL_STATE(3845)] = 107288,
  [SMALL_STATE(3846)] = 107304,
  [SMALL_STATE(3847)] = 107320,
  [SMALL_STATE(3848)] = 107336,
  [SMALL_STATE(3849)] = 107352,
  [SMALL_STATE(3850)] = 107368,
  [SMALL_STATE(3851)] = 107384,
  [SMALL_STATE(3852)] = 107400,
  [SMALL_STATE(3853)] = 107414,
  [SMALL_STATE(3854)] = 107428,
  [SMALL_STATE(3855)] = 107444,
  [SMALL_STATE(3856)] = 107460,
  [SMALL_STATE(3857)] = 107472,
  [SMALL_STATE(3858)] = 107484,
  [SMALL_STATE(3859)] = 107500,
  [SMALL_STATE(3860)] = 107514,
  [SMALL_STATE(3861)] = 107530,
  [SMALL_STATE(3862)] = 107546,
  [SMALL_STATE(3863)] = 107560,
  [SMALL_STATE(3864)] = 107574,
  [SMALL_STATE(3865)] = 107590,
  [SMALL_STATE(3866)] = 107606,
  [SMALL_STATE(3867)] = 107618,
  [SMALL_STATE(3868)] = 107634,
  [SMALL_STATE(3869)] = 107650,
  [SMALL_STATE(3870)] = 107662,
  [SMALL_STATE(3871)] = 107678,
  [SMALL_STATE(3872)] = 107694,
  [SMALL_STATE(3873)] = 107704,
  [SMALL_STATE(3874)] = 107720,
  [SMALL_STATE(3875)] = 107736,
  [SMALL_STATE(3876)] = 107752,
  [SMALL_STATE(3877)] = 107768,
  [SMALL_STATE(3878)] = 107782,
  [SMALL_STATE(3879)] = 107796,
  [SMALL_STATE(3880)] = 107812,
  [SMALL_STATE(3881)] = 107822,
  [SMALL_STATE(3882)] = 107838,
  [SMALL_STATE(3883)] = 107852,
  [SMALL_STATE(3884)] = 107868,
  [SMALL_STATE(3885)] = 107884,
  [SMALL_STATE(3886)] = 107898,
  [SMALL_STATE(3887)] = 107914,
  [SMALL_STATE(3888)] = 107930,
  [SMALL_STATE(3889)] = 107946,
  [SMALL_STATE(3890)] = 107962,
  [SMALL_STATE(3891)] = 107976,
  [SMALL_STATE(3892)] = 107990,
  [SMALL_STATE(3893)] = 108006,
  [SMALL_STATE(3894)] = 108022,
  [SMALL_STATE(3895)] = 108038,
  [SMALL_STATE(3896)] = 108054,
  [SMALL_STATE(3897)] = 108070,
  [SMALL_STATE(3898)] = 108086,
  [SMALL_STATE(3899)] = 108100,
  [SMALL_STATE(3900)] = 108110,
  [SMALL_STATE(3901)] = 108124,
  [SMALL_STATE(3902)] = 108140,
  [SMALL_STATE(3903)] = 108154,
  [SMALL_STATE(3904)] = 108167,
  [SMALL_STATE(3905)] = 108180,
  [SMALL_STATE(3906)] = 108189,
  [SMALL_STATE(3907)] = 108202,
  [SMALL_STATE(3908)] = 108211,
  [SMALL_STATE(3909)] = 108224,
  [SMALL_STATE(3910)] = 108237,
  [SMALL_STATE(3911)] = 108250,
  [SMALL_STATE(3912)] = 108263,
  [SMALL_STATE(3913)] = 108276,
  [SMALL_STATE(3914)] = 108289,
  [SMALL_STATE(3915)] = 108302,
  [SMALL_STATE(3916)] = 108313,
  [SMALL_STATE(3917)] = 108326,
  [SMALL_STATE(3918)] = 108335,
  [SMALL_STATE(3919)] = 108348,
  [SMALL_STATE(3920)] = 108361,
  [SMALL_STATE(3921)] = 108372,
  [SMALL_STATE(3922)] = 108385,
  [SMALL_STATE(3923)] = 108398,
  [SMALL_STATE(3924)] = 108409,
  [SMALL_STATE(3925)] = 108420,
  [SMALL_STATE(3926)] = 108433,
  [SMALL_STATE(3927)] = 108446,
  [SMALL_STATE(3928)] = 108459,
  [SMALL_STATE(3929)] = 108472,
  [SMALL_STATE(3930)] = 108485,
  [SMALL_STATE(3931)] = 108498,
  [SMALL_STATE(3932)] = 108511,
  [SMALL_STATE(3933)] = 108522,
  [SMALL_STATE(3934)] = 108535,
  [SMALL_STATE(3935)] = 108548,
  [SMALL_STATE(3936)] = 108557,
  [SMALL_STATE(3937)] = 108570,
  [SMALL_STATE(3938)] = 108583,
  [SMALL_STATE(3939)] = 108596,
  [SMALL_STATE(3940)] = 108609,
  [SMALL_STATE(3941)] = 108620,
  [SMALL_STATE(3942)] = 108633,
  [SMALL_STATE(3943)] = 108646,
  [SMALL_STATE(3944)] = 108659,
  [SMALL_STATE(3945)] = 108668,
  [SMALL_STATE(3946)] = 108681,
  [SMALL_STATE(3947)] = 108694,
  [SMALL_STATE(3948)] = 108707,
  [SMALL_STATE(3949)] = 108720,
  [SMALL_STATE(3950)] = 108733,
  [SMALL_STATE(3951)] = 108746,
  [SMALL_STATE(3952)] = 108759,
  [SMALL_STATE(3953)] = 108772,
  [SMALL_STATE(3954)] = 108781,
  [SMALL_STATE(3955)] = 108794,
  [SMALL_STATE(3956)] = 108807,
  [SMALL_STATE(3957)] = 108820,
  [SMALL_STATE(3958)] = 108833,
  [SMALL_STATE(3959)] = 108846,
  [SMALL_STATE(3960)] = 108859,
  [SMALL_STATE(3961)] = 108872,
  [SMALL_STATE(3962)] = 108885,
  [SMALL_STATE(3963)] = 108896,
  [SMALL_STATE(3964)] = 108905,
  [SMALL_STATE(3965)] = 108914,
  [SMALL_STATE(3966)] = 108923,
  [SMALL_STATE(3967)] = 108932,
  [SMALL_STATE(3968)] = 108941,
  [SMALL_STATE(3969)] = 108954,
  [SMALL_STATE(3970)] = 108963,
  [SMALL_STATE(3971)] = 108972,
  [SMALL_STATE(3972)] = 108985,
  [SMALL_STATE(3973)] = 108998,
  [SMALL_STATE(3974)] = 109011,
  [SMALL_STATE(3975)] = 109024,
  [SMALL_STATE(3976)] = 109037,
  [SMALL_STATE(3977)] = 109050,
  [SMALL_STATE(3978)] = 109063,
  [SMALL_STATE(3979)] = 109076,
  [SMALL_STATE(3980)] = 109085,
  [SMALL_STATE(3981)] = 109098,
  [SMALL_STATE(3982)] = 109107,
  [SMALL_STATE(3983)] = 109120,
  [SMALL_STATE(3984)] = 109131,
  [SMALL_STATE(3985)] = 109144,
  [SMALL_STATE(3986)] = 109157,
  [SMALL_STATE(3987)] = 109170,
  [SMALL_STATE(3988)] = 109183,
  [SMALL_STATE(3989)] = 109196,
  [SMALL_STATE(3990)] = 109209,
  [SMALL_STATE(3991)] = 109222,
  [SMALL_STATE(3992)] = 109235,
  [SMALL_STATE(3993)] = 109248,
  [SMALL_STATE(3994)] = 109257,
  [SMALL_STATE(3995)] = 109266,
  [SMALL_STATE(3996)] = 109275,
  [SMALL_STATE(3997)] = 109284,
  [SMALL_STATE(3998)] = 109293,
  [SMALL_STATE(3999)] = 109302,
  [SMALL_STATE(4000)] = 109311,
  [SMALL_STATE(4001)] = 109320,
  [SMALL_STATE(4002)] = 109333,
  [SMALL_STATE(4003)] = 109346,
  [SMALL_STATE(4004)] = 109355,
  [SMALL_STATE(4005)] = 109368,
  [SMALL_STATE(4006)] = 109381,
  [SMALL_STATE(4007)] = 109394,
  [SMALL_STATE(4008)] = 109403,
  [SMALL_STATE(4009)] = 109412,
  [SMALL_STATE(4010)] = 109425,
  [SMALL_STATE(4011)] = 109438,
  [SMALL_STATE(4012)] = 109447,
  [SMALL_STATE(4013)] = 109460,
  [SMALL_STATE(4014)] = 109469,
  [SMALL_STATE(4015)] = 109482,
  [SMALL_STATE(4016)] = 109495,
  [SMALL_STATE(4017)] = 109508,
  [SMALL_STATE(4018)] = 109521,
  [SMALL_STATE(4019)] = 109534,
  [SMALL_STATE(4020)] = 109547,
  [SMALL_STATE(4021)] = 109560,
  [SMALL_STATE(4022)] = 109571,
  [SMALL_STATE(4023)] = 109584,
  [SMALL_STATE(4024)] = 109597,
  [SMALL_STATE(4025)] = 109606,
  [SMALL_STATE(4026)] = 109615,
  [SMALL_STATE(4027)] = 109624,
  [SMALL_STATE(4028)] = 109633,
  [SMALL_STATE(4029)] = 109646,
  [SMALL_STATE(4030)] = 109659,
  [SMALL_STATE(4031)] = 109668,
  [SMALL_STATE(4032)] = 109681,
  [SMALL_STATE(4033)] = 109694,
  [SMALL_STATE(4034)] = 109707,
  [SMALL_STATE(4035)] = 109720,
  [SMALL_STATE(4036)] = 109733,
  [SMALL_STATE(4037)] = 109746,
  [SMALL_STATE(4038)] = 109755,
  [SMALL_STATE(4039)] = 109768,
  [SMALL_STATE(4040)] = 109777,
  [SMALL_STATE(4041)] = 109786,
  [SMALL_STATE(4042)] = 109795,
  [SMALL_STATE(4043)] = 109804,
  [SMALL_STATE(4044)] = 109813,
  [SMALL_STATE(4045)] = 109822,
  [SMALL_STATE(4046)] = 109831,
  [SMALL_STATE(4047)] = 109840,
  [SMALL_STATE(4048)] = 109849,
  [SMALL_STATE(4049)] = 109862,
  [SMALL_STATE(4050)] = 109875,
  [SMALL_STATE(4051)] = 109888,
  [SMALL_STATE(4052)] = 109901,
  [SMALL_STATE(4053)] = 109914,
  [SMALL_STATE(4054)] = 109927,
  [SMALL_STATE(4055)] = 109940,
  [SMALL_STATE(4056)] = 109953,
  [SMALL_STATE(4057)] = 109962,
  [SMALL_STATE(4058)] = 109975,
  [SMALL_STATE(4059)] = 109988,
  [SMALL_STATE(4060)] = 110001,
  [SMALL_STATE(4061)] = 110014,
  [SMALL_STATE(4062)] = 110027,
  [SMALL_STATE(4063)] = 110040,
  [SMALL_STATE(4064)] = 110053,
  [SMALL_STATE(4065)] = 110066,
  [SMALL_STATE(4066)] = 110079,
  [SMALL_STATE(4067)] = 110092,
  [SMALL_STATE(4068)] = 110105,
  [SMALL_STATE(4069)] = 110118,
  [SMALL_STATE(4070)] = 110131,
  [SMALL_STATE(4071)] = 110144,
  [SMALL_STATE(4072)] = 110155,
  [SMALL_STATE(4073)] = 110168,
  [SMALL_STATE(4074)] = 110181,
  [SMALL_STATE(4075)] = 110190,
  [SMALL_STATE(4076)] = 110203,
  [SMALL_STATE(4077)] = 110212,
  [SMALL_STATE(4078)] = 110221,
  [SMALL_STATE(4079)] = 110230,
  [SMALL_STATE(4080)] = 110239,
  [SMALL_STATE(4081)] = 110248,
  [SMALL_STATE(4082)] = 110257,
  [SMALL_STATE(4083)] = 110270,
  [SMALL_STATE(4084)] = 110283,
  [SMALL_STATE(4085)] = 110296,
  [SMALL_STATE(4086)] = 110309,
  [SMALL_STATE(4087)] = 110320,
  [SMALL_STATE(4088)] = 110333,
  [SMALL_STATE(4089)] = 110346,
  [SMALL_STATE(4090)] = 110359,
  [SMALL_STATE(4091)] = 110372,
  [SMALL_STATE(4092)] = 110385,
  [SMALL_STATE(4093)] = 110394,
  [SMALL_STATE(4094)] = 110403,
  [SMALL_STATE(4095)] = 110412,
  [SMALL_STATE(4096)] = 110425,
  [SMALL_STATE(4097)] = 110438,
  [SMALL_STATE(4098)] = 110451,
  [SMALL_STATE(4099)] = 110464,
  [SMALL_STATE(4100)] = 110477,
  [SMALL_STATE(4101)] = 110490,
  [SMALL_STATE(4102)] = 110503,
  [SMALL_STATE(4103)] = 110512,
  [SMALL_STATE(4104)] = 110525,
  [SMALL_STATE(4105)] = 110534,
  [SMALL_STATE(4106)] = 110543,
  [SMALL_STATE(4107)] = 110556,
  [SMALL_STATE(4108)] = 110569,
  [SMALL_STATE(4109)] = 110582,
  [SMALL_STATE(4110)] = 110595,
  [SMALL_STATE(4111)] = 110608,
  [SMALL_STATE(4112)] = 110617,
  [SMALL_STATE(4113)] = 110630,
  [SMALL_STATE(4114)] = 110643,
  [SMALL_STATE(4115)] = 110656,
  [SMALL_STATE(4116)] = 110665,
  [SMALL_STATE(4117)] = 110678,
  [SMALL_STATE(4118)] = 110691,
  [SMALL_STATE(4119)] = 110704,
  [SMALL_STATE(4120)] = 110713,
  [SMALL_STATE(4121)] = 110726,
  [SMALL_STATE(4122)] = 110737,
  [SMALL_STATE(4123)] = 110750,
  [SMALL_STATE(4124)] = 110763,
  [SMALL_STATE(4125)] = 110776,
  [SMALL_STATE(4126)] = 110789,
  [SMALL_STATE(4127)] = 110802,
  [SMALL_STATE(4128)] = 110815,
  [SMALL_STATE(4129)] = 110828,
  [SMALL_STATE(4130)] = 110841,
  [SMALL_STATE(4131)] = 110854,
  [SMALL_STATE(4132)] = 110865,
  [SMALL_STATE(4133)] = 110878,
  [SMALL_STATE(4134)] = 110891,
  [SMALL_STATE(4135)] = 110904,
  [SMALL_STATE(4136)] = 110917,
  [SMALL_STATE(4137)] = 110930,
  [SMALL_STATE(4138)] = 110941,
  [SMALL_STATE(4139)] = 110954,
  [SMALL_STATE(4140)] = 110967,
  [SMALL_STATE(4141)] = 110980,
  [SMALL_STATE(4142)] = 110993,
  [SMALL_STATE(4143)] = 111006,
  [SMALL_STATE(4144)] = 111019,
  [SMALL_STATE(4145)] = 111030,
  [SMALL_STATE(4146)] = 111043,
  [SMALL_STATE(4147)] = 111056,
  [SMALL_STATE(4148)] = 111069,
  [SMALL_STATE(4149)] = 111082,
  [SMALL_STATE(4150)] = 111091,
  [SMALL_STATE(4151)] = 111104,
  [SMALL_STATE(4152)] = 111115,
  [SMALL_STATE(4153)] = 111125,
  [SMALL_STATE(4154)] = 111135,
  [SMALL_STATE(4155)] = 111145,
  [SMALL_STATE(4156)] = 111155,
  [SMALL_STATE(4157)] = 111165,
  [SMALL_STATE(4158)] = 111175,
  [SMALL_STATE(4159)] = 111185,
  [SMALL_STATE(4160)] = 111193,
  [SMALL_STATE(4161)] = 111203,
  [SMALL_STATE(4162)] = 111213,
  [SMALL_STATE(4163)] = 111223,
  [SMALL_STATE(4164)] = 111233,
  [SMALL_STATE(4165)] = 111243,
  [SMALL_STATE(4166)] = 111253,
  [SMALL_STATE(4167)] = 111263,
  [SMALL_STATE(4168)] = 111273,
  [SMALL_STATE(4169)] = 111283,
  [SMALL_STATE(4170)] = 111293,
  [SMALL_STATE(4171)] = 111303,
  [SMALL_STATE(4172)] = 111313,
  [SMALL_STATE(4173)] = 111323,
  [SMALL_STATE(4174)] = 111333,
  [SMALL_STATE(4175)] = 111341,
  [SMALL_STATE(4176)] = 111351,
  [SMALL_STATE(4177)] = 111361,
  [SMALL_STATE(4178)] = 111371,
  [SMALL_STATE(4179)] = 111381,
  [SMALL_STATE(4180)] = 111391,
  [SMALL_STATE(4181)] = 111401,
  [SMALL_STATE(4182)] = 111411,
  [SMALL_STATE(4183)] = 111421,
  [SMALL_STATE(4184)] = 111431,
  [SMALL_STATE(4185)] = 111441,
  [SMALL_STATE(4186)] = 111451,
  [SMALL_STATE(4187)] = 111461,
  [SMALL_STATE(4188)] = 111471,
  [SMALL_STATE(4189)] = 111481,
  [SMALL_STATE(4190)] = 111491,
  [SMALL_STATE(4191)] = 111501,
  [SMALL_STATE(4192)] = 111511,
  [SMALL_STATE(4193)] = 111521,
  [SMALL_STATE(4194)] = 111531,
  [SMALL_STATE(4195)] = 111541,
  [SMALL_STATE(4196)] = 111551,
  [SMALL_STATE(4197)] = 111561,
  [SMALL_STATE(4198)] = 111571,
  [SMALL_STATE(4199)] = 111581,
  [SMALL_STATE(4200)] = 111589,
  [SMALL_STATE(4201)] = 111599,
  [SMALL_STATE(4202)] = 111609,
  [SMALL_STATE(4203)] = 111619,
  [SMALL_STATE(4204)] = 111629,
  [SMALL_STATE(4205)] = 111637,
  [SMALL_STATE(4206)] = 111647,
  [SMALL_STATE(4207)] = 111655,
  [SMALL_STATE(4208)] = 111665,
  [SMALL_STATE(4209)] = 111675,
  [SMALL_STATE(4210)] = 111685,
  [SMALL_STATE(4211)] = 111695,
  [SMALL_STATE(4212)] = 111703,
  [SMALL_STATE(4213)] = 111713,
  [SMALL_STATE(4214)] = 111723,
  [SMALL_STATE(4215)] = 111731,
  [SMALL_STATE(4216)] = 111741,
  [SMALL_STATE(4217)] = 111751,
  [SMALL_STATE(4218)] = 111761,
  [SMALL_STATE(4219)] = 111771,
  [SMALL_STATE(4220)] = 111781,
  [SMALL_STATE(4221)] = 111791,
  [SMALL_STATE(4222)] = 111801,
  [SMALL_STATE(4223)] = 111809,
  [SMALL_STATE(4224)] = 111819,
  [SMALL_STATE(4225)] = 111827,
  [SMALL_STATE(4226)] = 111837,
  [SMALL_STATE(4227)] = 111847,
  [SMALL_STATE(4228)] = 111857,
  [SMALL_STATE(4229)] = 111867,
  [SMALL_STATE(4230)] = 111877,
  [SMALL_STATE(4231)] = 111885,
  [SMALL_STATE(4232)] = 111895,
  [SMALL_STATE(4233)] = 111905,
  [SMALL_STATE(4234)] = 111915,
  [SMALL_STATE(4235)] = 111925,
  [SMALL_STATE(4236)] = 111935,
  [SMALL_STATE(4237)] = 111945,
  [SMALL_STATE(4238)] = 111955,
  [SMALL_STATE(4239)] = 111965,
  [SMALL_STATE(4240)] = 111975,
  [SMALL_STATE(4241)] = 111985,
  [SMALL_STATE(4242)] = 111993,
  [SMALL_STATE(4243)] = 112003,
  [SMALL_STATE(4244)] = 112013,
  [SMALL_STATE(4245)] = 112023,
  [SMALL_STATE(4246)] = 112031,
  [SMALL_STATE(4247)] = 112041,
  [SMALL_STATE(4248)] = 112051,
  [SMALL_STATE(4249)] = 112061,
  [SMALL_STATE(4250)] = 112071,
  [SMALL_STATE(4251)] = 112081,
  [SMALL_STATE(4252)] = 112091,
  [SMALL_STATE(4253)] = 112101,
  [SMALL_STATE(4254)] = 112111,
  [SMALL_STATE(4255)] = 112121,
  [SMALL_STATE(4256)] = 112131,
  [SMALL_STATE(4257)] = 112141,
  [SMALL_STATE(4258)] = 112151,
  [SMALL_STATE(4259)] = 112159,
  [SMALL_STATE(4260)] = 112169,
  [SMALL_STATE(4261)] = 112179,
  [SMALL_STATE(4262)] = 112189,
  [SMALL_STATE(4263)] = 112197,
  [SMALL_STATE(4264)] = 112207,
  [SMALL_STATE(4265)] = 112217,
  [SMALL_STATE(4266)] = 112227,
  [SMALL_STATE(4267)] = 112237,
  [SMALL_STATE(4268)] = 112247,
  [SMALL_STATE(4269)] = 112257,
  [SMALL_STATE(4270)] = 112267,
  [SMALL_STATE(4271)] = 112277,
  [SMALL_STATE(4272)] = 112285,
  [SMALL_STATE(4273)] = 112295,
  [SMALL_STATE(4274)] = 112305,
  [SMALL_STATE(4275)] = 112315,
  [SMALL_STATE(4276)] = 112325,
  [SMALL_STATE(4277)] = 112335,
  [SMALL_STATE(4278)] = 112345,
  [SMALL_STATE(4279)] = 112355,
  [SMALL_STATE(4280)] = 112365,
  [SMALL_STATE(4281)] = 112375,
  [SMALL_STATE(4282)] = 112385,
  [SMALL_STATE(4283)] = 112393,
  [SMALL_STATE(4284)] = 112403,
  [SMALL_STATE(4285)] = 112413,
  [SMALL_STATE(4286)] = 112423,
  [SMALL_STATE(4287)] = 112433,
  [SMALL_STATE(4288)] = 112441,
  [SMALL_STATE(4289)] = 112451,
  [SMALL_STATE(4290)] = 112461,
  [SMALL_STATE(4291)] = 112471,
  [SMALL_STATE(4292)] = 112481,
  [SMALL_STATE(4293)] = 112489,
  [SMALL_STATE(4294)] = 112497,
  [SMALL_STATE(4295)] = 112507,
  [SMALL_STATE(4296)] = 112517,
  [SMALL_STATE(4297)] = 112527,
  [SMALL_STATE(4298)] = 112537,
  [SMALL_STATE(4299)] = 112547,
  [SMALL_STATE(4300)] = 112557,
  [SMALL_STATE(4301)] = 112567,
  [SMALL_STATE(4302)] = 112577,
  [SMALL_STATE(4303)] = 112587,
  [SMALL_STATE(4304)] = 112597,
  [SMALL_STATE(4305)] = 112607,
  [SMALL_STATE(4306)] = 112617,
  [SMALL_STATE(4307)] = 112627,
  [SMALL_STATE(4308)] = 112635,
  [SMALL_STATE(4309)] = 112645,
  [SMALL_STATE(4310)] = 112653,
  [SMALL_STATE(4311)] = 112663,
  [SMALL_STATE(4312)] = 112673,
  [SMALL_STATE(4313)] = 112683,
  [SMALL_STATE(4314)] = 112693,
  [SMALL_STATE(4315)] = 112703,
  [SMALL_STATE(4316)] = 112713,
  [SMALL_STATE(4317)] = 112723,
  [SMALL_STATE(4318)] = 112733,
  [SMALL_STATE(4319)] = 112743,
  [SMALL_STATE(4320)] = 112753,
  [SMALL_STATE(4321)] = 112763,
  [SMALL_STATE(4322)] = 112773,
  [SMALL_STATE(4323)] = 112783,
  [SMALL_STATE(4324)] = 112791,
  [SMALL_STATE(4325)] = 112799,
  [SMALL_STATE(4326)] = 112809,
  [SMALL_STATE(4327)] = 112819,
  [SMALL_STATE(4328)] = 112829,
  [SMALL_STATE(4329)] = 112839,
  [SMALL_STATE(4330)] = 112847,
  [SMALL_STATE(4331)] = 112857,
  [SMALL_STATE(4332)] = 112867,
  [SMALL_STATE(4333)] = 112877,
  [SMALL_STATE(4334)] = 112885,
  [SMALL_STATE(4335)] = 112893,
  [SMALL_STATE(4336)] = 112903,
  [SMALL_STATE(4337)] = 112913,
  [SMALL_STATE(4338)] = 112923,
  [SMALL_STATE(4339)] = 112933,
  [SMALL_STATE(4340)] = 112941,
  [SMALL_STATE(4341)] = 112949,
  [SMALL_STATE(4342)] = 112957,
  [SMALL_STATE(4343)] = 112967,
  [SMALL_STATE(4344)] = 112977,
  [SMALL_STATE(4345)] = 112985,
  [SMALL_STATE(4346)] = 112995,
  [SMALL_STATE(4347)] = 113005,
  [SMALL_STATE(4348)] = 113015,
  [SMALL_STATE(4349)] = 113025,
  [SMALL_STATE(4350)] = 113035,
  [SMALL_STATE(4351)] = 113045,
  [SMALL_STATE(4352)] = 113053,
  [SMALL_STATE(4353)] = 113063,
  [SMALL_STATE(4354)] = 113071,
  [SMALL_STATE(4355)] = 113081,
  [SMALL_STATE(4356)] = 113089,
  [SMALL_STATE(4357)] = 113097,
  [SMALL_STATE(4358)] = 113107,
  [SMALL_STATE(4359)] = 113117,
  [SMALL_STATE(4360)] = 113127,
  [SMALL_STATE(4361)] = 113137,
  [SMALL_STATE(4362)] = 113147,
  [SMALL_STATE(4363)] = 113157,
  [SMALL_STATE(4364)] = 113167,
  [SMALL_STATE(4365)] = 113175,
  [SMALL_STATE(4366)] = 113183,
  [SMALL_STATE(4367)] = 113193,
  [SMALL_STATE(4368)] = 113203,
  [SMALL_STATE(4369)] = 113213,
  [SMALL_STATE(4370)] = 113223,
  [SMALL_STATE(4371)] = 113233,
  [SMALL_STATE(4372)] = 113243,
  [SMALL_STATE(4373)] = 113253,
  [SMALL_STATE(4374)] = 113263,
  [SMALL_STATE(4375)] = 113273,
  [SMALL_STATE(4376)] = 113283,
  [SMALL_STATE(4377)] = 113293,
  [SMALL_STATE(4378)] = 113303,
  [SMALL_STATE(4379)] = 113313,
  [SMALL_STATE(4380)] = 113323,
  [SMALL_STATE(4381)] = 113333,
  [SMALL_STATE(4382)] = 113343,
  [SMALL_STATE(4383)] = 113353,
  [SMALL_STATE(4384)] = 113363,
  [SMALL_STATE(4385)] = 113371,
  [SMALL_STATE(4386)] = 113381,
  [SMALL_STATE(4387)] = 113391,
  [SMALL_STATE(4388)] = 113401,
  [SMALL_STATE(4389)] = 113411,
  [SMALL_STATE(4390)] = 113421,
  [SMALL_STATE(4391)] = 113431,
  [SMALL_STATE(4392)] = 113441,
  [SMALL_STATE(4393)] = 113449,
  [SMALL_STATE(4394)] = 113459,
  [SMALL_STATE(4395)] = 113469,
  [SMALL_STATE(4396)] = 113479,
  [SMALL_STATE(4397)] = 113489,
  [SMALL_STATE(4398)] = 113499,
  [SMALL_STATE(4399)] = 113509,
  [SMALL_STATE(4400)] = 113519,
  [SMALL_STATE(4401)] = 113529,
  [SMALL_STATE(4402)] = 113539,
  [SMALL_STATE(4403)] = 113549,
  [SMALL_STATE(4404)] = 113559,
  [SMALL_STATE(4405)] = 113569,
  [SMALL_STATE(4406)] = 113579,
  [SMALL_STATE(4407)] = 113589,
  [SMALL_STATE(4408)] = 113597,
  [SMALL_STATE(4409)] = 113607,
  [SMALL_STATE(4410)] = 113615,
  [SMALL_STATE(4411)] = 113625,
  [SMALL_STATE(4412)] = 113635,
  [SMALL_STATE(4413)] = 113645,
  [SMALL_STATE(4414)] = 113653,
  [SMALL_STATE(4415)] = 113661,
  [SMALL_STATE(4416)] = 113669,
  [SMALL_STATE(4417)] = 113679,
  [SMALL_STATE(4418)] = 113689,
  [SMALL_STATE(4419)] = 113699,
  [SMALL_STATE(4420)] = 113709,
  [SMALL_STATE(4421)] = 113719,
  [SMALL_STATE(4422)] = 113729,
  [SMALL_STATE(4423)] = 113739,
  [SMALL_STATE(4424)] = 113749,
  [SMALL_STATE(4425)] = 113759,
  [SMALL_STATE(4426)] = 113769,
  [SMALL_STATE(4427)] = 113779,
  [SMALL_STATE(4428)] = 113789,
  [SMALL_STATE(4429)] = 113799,
  [SMALL_STATE(4430)] = 113809,
  [SMALL_STATE(4431)] = 113819,
  [SMALL_STATE(4432)] = 113829,
  [SMALL_STATE(4433)] = 113839,
  [SMALL_STATE(4434)] = 113847,
  [SMALL_STATE(4435)] = 113857,
  [SMALL_STATE(4436)] = 113867,
  [SMALL_STATE(4437)] = 113875,
  [SMALL_STATE(4438)] = 113883,
  [SMALL_STATE(4439)] = 113891,
  [SMALL_STATE(4440)] = 113899,
  [SMALL_STATE(4441)] = 113907,
  [SMALL_STATE(4442)] = 113917,
  [SMALL_STATE(4443)] = 113927,
  [SMALL_STATE(4444)] = 113937,
  [SMALL_STATE(4445)] = 113945,
  [SMALL_STATE(4446)] = 113955,
  [SMALL_STATE(4447)] = 113965,
  [SMALL_STATE(4448)] = 113975,
  [SMALL_STATE(4449)] = 113985,
  [SMALL_STATE(4450)] = 113995,
  [SMALL_STATE(4451)] = 114005,
  [SMALL_STATE(4452)] = 114015,
  [SMALL_STATE(4453)] = 114025,
  [SMALL_STATE(4454)] = 114035,
  [SMALL_STATE(4455)] = 114045,
  [SMALL_STATE(4456)] = 114055,
  [SMALL_STATE(4457)] = 114065,
  [SMALL_STATE(4458)] = 114075,
  [SMALL_STATE(4459)] = 114085,
  [SMALL_STATE(4460)] = 114095,
  [SMALL_STATE(4461)] = 114105,
  [SMALL_STATE(4462)] = 114113,
  [SMALL_STATE(4463)] = 114123,
  [SMALL_STATE(4464)] = 114133,
  [SMALL_STATE(4465)] = 114141,
  [SMALL_STATE(4466)] = 114151,
  [SMALL_STATE(4467)] = 114161,
  [SMALL_STATE(4468)] = 114169,
  [SMALL_STATE(4469)] = 114177,
  [SMALL_STATE(4470)] = 114187,
  [SMALL_STATE(4471)] = 114197,
  [SMALL_STATE(4472)] = 114207,
  [SMALL_STATE(4473)] = 114217,
  [SMALL_STATE(4474)] = 114225,
  [SMALL_STATE(4475)] = 114233,
  [SMALL_STATE(4476)] = 114241,
  [SMALL_STATE(4477)] = 114249,
  [SMALL_STATE(4478)] = 114257,
  [SMALL_STATE(4479)] = 114267,
  [SMALL_STATE(4480)] = 114277,
  [SMALL_STATE(4481)] = 114287,
  [SMALL_STATE(4482)] = 114297,
  [SMALL_STATE(4483)] = 114307,
  [SMALL_STATE(4484)] = 114317,
  [SMALL_STATE(4485)] = 114327,
  [SMALL_STATE(4486)] = 114337,
  [SMALL_STATE(4487)] = 114347,
  [SMALL_STATE(4488)] = 114357,
  [SMALL_STATE(4489)] = 114367,
  [SMALL_STATE(4490)] = 114377,
  [SMALL_STATE(4491)] = 114385,
  [SMALL_STATE(4492)] = 114395,
  [SMALL_STATE(4493)] = 114405,
  [SMALL_STATE(4494)] = 114415,
  [SMALL_STATE(4495)] = 114425,
  [SMALL_STATE(4496)] = 114435,
  [SMALL_STATE(4497)] = 114445,
  [SMALL_STATE(4498)] = 114455,
  [SMALL_STATE(4499)] = 114465,
  [SMALL_STATE(4500)] = 114475,
  [SMALL_STATE(4501)] = 114485,
  [SMALL_STATE(4502)] = 114493,
  [SMALL_STATE(4503)] = 114503,
  [SMALL_STATE(4504)] = 114511,
  [SMALL_STATE(4505)] = 114521,
  [SMALL_STATE(4506)] = 114531,
  [SMALL_STATE(4507)] = 114539,
  [SMALL_STATE(4508)] = 114549,
  [SMALL_STATE(4509)] = 114559,
  [SMALL_STATE(4510)] = 114567,
  [SMALL_STATE(4511)] = 114577,
  [SMALL_STATE(4512)] = 114587,
  [SMALL_STATE(4513)] = 114594,
  [SMALL_STATE(4514)] = 114601,
  [SMALL_STATE(4515)] = 114608,
  [SMALL_STATE(4516)] = 114615,
  [SMALL_STATE(4517)] = 114622,
  [SMALL_STATE(4518)] = 114629,
  [SMALL_STATE(4519)] = 114636,
  [SMALL_STATE(4520)] = 114643,
  [SMALL_STATE(4521)] = 114650,
  [SMALL_STATE(4522)] = 114657,
  [SMALL_STATE(4523)] = 114664,
  [SMALL_STATE(4524)] = 114671,
  [SMALL_STATE(4525)] = 114678,
  [SMALL_STATE(4526)] = 114685,
  [SMALL_STATE(4527)] = 114692,
  [SMALL_STATE(4528)] = 114699,
  [SMALL_STATE(4529)] = 114706,
  [SMALL_STATE(4530)] = 114713,
  [SMALL_STATE(4531)] = 114720,
  [SMALL_STATE(4532)] = 114727,
  [SMALL_STATE(4533)] = 114734,
  [SMALL_STATE(4534)] = 114741,
  [SMALL_STATE(4535)] = 114748,
  [SMALL_STATE(4536)] = 114755,
  [SMALL_STATE(4537)] = 114762,
  [SMALL_STATE(4538)] = 114769,
  [SMALL_STATE(4539)] = 114776,
  [SMALL_STATE(4540)] = 114783,
  [SMALL_STATE(4541)] = 114790,
  [SMALL_STATE(4542)] = 114797,
  [SMALL_STATE(4543)] = 114804,
  [SMALL_STATE(4544)] = 114811,
  [SMALL_STATE(4545)] = 114818,
  [SMALL_STATE(4546)] = 114825,
  [SMALL_STATE(4547)] = 114832,
  [SMALL_STATE(4548)] = 114839,
  [SMALL_STATE(4549)] = 114846,
  [SMALL_STATE(4550)] = 114853,
  [SMALL_STATE(4551)] = 114860,
  [SMALL_STATE(4552)] = 114867,
  [SMALL_STATE(4553)] = 114874,
  [SMALL_STATE(4554)] = 114881,
  [SMALL_STATE(4555)] = 114888,
  [SMALL_STATE(4556)] = 114895,
  [SMALL_STATE(4557)] = 114902,
  [SMALL_STATE(4558)] = 114909,
  [SMALL_STATE(4559)] = 114916,
  [SMALL_STATE(4560)] = 114923,
  [SMALL_STATE(4561)] = 114930,
  [SMALL_STATE(4562)] = 114937,
  [SMALL_STATE(4563)] = 114944,
  [SMALL_STATE(4564)] = 114951,
  [SMALL_STATE(4565)] = 114958,
  [SMALL_STATE(4566)] = 114965,
  [SMALL_STATE(4567)] = 114972,
  [SMALL_STATE(4568)] = 114979,
  [SMALL_STATE(4569)] = 114986,
  [SMALL_STATE(4570)] = 114993,
  [SMALL_STATE(4571)] = 115000,
  [SMALL_STATE(4572)] = 115007,
  [SMALL_STATE(4573)] = 115014,
  [SMALL_STATE(4574)] = 115021,
  [SMALL_STATE(4575)] = 115028,
  [SMALL_STATE(4576)] = 115035,
  [SMALL_STATE(4577)] = 115042,
  [SMALL_STATE(4578)] = 115049,
  [SMALL_STATE(4579)] = 115056,
  [SMALL_STATE(4580)] = 115063,
  [SMALL_STATE(4581)] = 115070,
  [SMALL_STATE(4582)] = 115077,
  [SMALL_STATE(4583)] = 115084,
  [SMALL_STATE(4584)] = 115091,
  [SMALL_STATE(4585)] = 115098,
  [SMALL_STATE(4586)] = 115105,
  [SMALL_STATE(4587)] = 115112,
  [SMALL_STATE(4588)] = 115119,
  [SMALL_STATE(4589)] = 115126,
  [SMALL_STATE(4590)] = 115133,
  [SMALL_STATE(4591)] = 115140,
  [SMALL_STATE(4592)] = 115147,
  [SMALL_STATE(4593)] = 115154,
  [SMALL_STATE(4594)] = 115161,
  [SMALL_STATE(4595)] = 115168,
  [SMALL_STATE(4596)] = 115175,
  [SMALL_STATE(4597)] = 115182,
  [SMALL_STATE(4598)] = 115189,
  [SMALL_STATE(4599)] = 115196,
  [SMALL_STATE(4600)] = 115203,
  [SMALL_STATE(4601)] = 115210,
  [SMALL_STATE(4602)] = 115217,
  [SMALL_STATE(4603)] = 115224,
  [SMALL_STATE(4604)] = 115231,
  [SMALL_STATE(4605)] = 115238,
  [SMALL_STATE(4606)] = 115245,
  [SMALL_STATE(4607)] = 115252,
  [SMALL_STATE(4608)] = 115259,
  [SMALL_STATE(4609)] = 115266,
  [SMALL_STATE(4610)] = 115273,
  [SMALL_STATE(4611)] = 115280,
  [SMALL_STATE(4612)] = 115287,
  [SMALL_STATE(4613)] = 115294,
  [SMALL_STATE(4614)] = 115301,
  [SMALL_STATE(4615)] = 115308,
  [SMALL_STATE(4616)] = 115315,
  [SMALL_STATE(4617)] = 115322,
  [SMALL_STATE(4618)] = 115329,
  [SMALL_STATE(4619)] = 115336,
  [SMALL_STATE(4620)] = 115343,
  [SMALL_STATE(4621)] = 115350,
  [SMALL_STATE(4622)] = 115357,
  [SMALL_STATE(4623)] = 115364,
  [SMALL_STATE(4624)] = 115371,
  [SMALL_STATE(4625)] = 115378,
  [SMALL_STATE(4626)] = 115385,
  [SMALL_STATE(4627)] = 115392,
  [SMALL_STATE(4628)] = 115399,
  [SMALL_STATE(4629)] = 115406,
  [SMALL_STATE(4630)] = 115413,
  [SMALL_STATE(4631)] = 115420,
  [SMALL_STATE(4632)] = 115427,
  [SMALL_STATE(4633)] = 115434,
  [SMALL_STATE(4634)] = 115441,
  [SMALL_STATE(4635)] = 115448,
  [SMALL_STATE(4636)] = 115455,
  [SMALL_STATE(4637)] = 115462,
  [SMALL_STATE(4638)] = 115469,
  [SMALL_STATE(4639)] = 115476,
  [SMALL_STATE(4640)] = 115483,
  [SMALL_STATE(4641)] = 115490,
  [SMALL_STATE(4642)] = 115497,
  [SMALL_STATE(4643)] = 115504,
  [SMALL_STATE(4644)] = 115511,
  [SMALL_STATE(4645)] = 115518,
  [SMALL_STATE(4646)] = 115525,
  [SMALL_STATE(4647)] = 115532,
  [SMALL_STATE(4648)] = 115539,
  [SMALL_STATE(4649)] = 115546,
  [SMALL_STATE(4650)] = 115553,
  [SMALL_STATE(4651)] = 115560,
  [SMALL_STATE(4652)] = 115567,
  [SMALL_STATE(4653)] = 115574,
  [SMALL_STATE(4654)] = 115581,
  [SMALL_STATE(4655)] = 115588,
  [SMALL_STATE(4656)] = 115595,
  [SMALL_STATE(4657)] = 115602,
  [SMALL_STATE(4658)] = 115609,
  [SMALL_STATE(4659)] = 115616,
  [SMALL_STATE(4660)] = 115623,
  [SMALL_STATE(4661)] = 115630,
  [SMALL_STATE(4662)] = 115637,
  [SMALL_STATE(4663)] = 115644,
  [SMALL_STATE(4664)] = 115651,
  [SMALL_STATE(4665)] = 115658,
  [SMALL_STATE(4666)] = 115665,
  [SMALL_STATE(4667)] = 115672,
  [SMALL_STATE(4668)] = 115679,
  [SMALL_STATE(4669)] = 115686,
  [SMALL_STATE(4670)] = 115693,
  [SMALL_STATE(4671)] = 115700,
  [SMALL_STATE(4672)] = 115707,
  [SMALL_STATE(4673)] = 115714,
  [SMALL_STATE(4674)] = 115721,
  [SMALL_STATE(4675)] = 115728,
  [SMALL_STATE(4676)] = 115735,
  [SMALL_STATE(4677)] = 115742,
  [SMALL_STATE(4678)] = 115749,
  [SMALL_STATE(4679)] = 115756,
  [SMALL_STATE(4680)] = 115763,
  [SMALL_STATE(4681)] = 115770,
  [SMALL_STATE(4682)] = 115777,
  [SMALL_STATE(4683)] = 115784,
  [SMALL_STATE(4684)] = 115791,
  [SMALL_STATE(4685)] = 115798,
  [SMALL_STATE(4686)] = 115805,
  [SMALL_STATE(4687)] = 115812,
  [SMALL_STATE(4688)] = 115819,
  [SMALL_STATE(4689)] = 115826,
  [SMALL_STATE(4690)] = 115833,
  [SMALL_STATE(4691)] = 115840,
  [SMALL_STATE(4692)] = 115847,
  [SMALL_STATE(4693)] = 115854,
  [SMALL_STATE(4694)] = 115861,
  [SMALL_STATE(4695)] = 115868,
  [SMALL_STATE(4696)] = 115875,
  [SMALL_STATE(4697)] = 115882,
  [SMALL_STATE(4698)] = 115889,
  [SMALL_STATE(4699)] = 115896,
  [SMALL_STATE(4700)] = 115903,
  [SMALL_STATE(4701)] = 115910,
  [SMALL_STATE(4702)] = 115917,
  [SMALL_STATE(4703)] = 115924,
  [SMALL_STATE(4704)] = 115931,
  [SMALL_STATE(4705)] = 115938,
  [SMALL_STATE(4706)] = 115945,
  [SMALL_STATE(4707)] = 115952,
  [SMALL_STATE(4708)] = 115959,
  [SMALL_STATE(4709)] = 115966,
  [SMALL_STATE(4710)] = 115973,
  [SMALL_STATE(4711)] = 115980,
  [SMALL_STATE(4712)] = 115987,
  [SMALL_STATE(4713)] = 115994,
  [SMALL_STATE(4714)] = 116001,
  [SMALL_STATE(4715)] = 116008,
  [SMALL_STATE(4716)] = 116015,
  [SMALL_STATE(4717)] = 116022,
  [SMALL_STATE(4718)] = 116029,
  [SMALL_STATE(4719)] = 116036,
  [SMALL_STATE(4720)] = 116043,
  [SMALL_STATE(4721)] = 116050,
  [SMALL_STATE(4722)] = 116057,
  [SMALL_STATE(4723)] = 116064,
  [SMALL_STATE(4724)] = 116071,
  [SMALL_STATE(4725)] = 116078,
  [SMALL_STATE(4726)] = 116085,
  [SMALL_STATE(4727)] = 116092,
  [SMALL_STATE(4728)] = 116099,
  [SMALL_STATE(4729)] = 116106,
  [SMALL_STATE(4730)] = 116113,
  [SMALL_STATE(4731)] = 116120,
  [SMALL_STATE(4732)] = 116127,
  [SMALL_STATE(4733)] = 116134,
  [SMALL_STATE(4734)] = 116141,
  [SMALL_STATE(4735)] = 116148,
  [SMALL_STATE(4736)] = 116155,
  [SMALL_STATE(4737)] = 116162,
  [SMALL_STATE(4738)] = 116169,
  [SMALL_STATE(4739)] = 116176,
  [SMALL_STATE(4740)] = 116183,
  [SMALL_STATE(4741)] = 116190,
  [SMALL_STATE(4742)] = 116197,
  [SMALL_STATE(4743)] = 116204,
  [SMALL_STATE(4744)] = 116211,
  [SMALL_STATE(4745)] = 116218,
  [SMALL_STATE(4746)] = 116225,
  [SMALL_STATE(4747)] = 116232,
  [SMALL_STATE(4748)] = 116239,
  [SMALL_STATE(4749)] = 116246,
  [SMALL_STATE(4750)] = 116253,
  [SMALL_STATE(4751)] = 116260,
  [SMALL_STATE(4752)] = 116267,
  [SMALL_STATE(4753)] = 116274,
  [SMALL_STATE(4754)] = 116281,
  [SMALL_STATE(4755)] = 116288,
  [SMALL_STATE(4756)] = 116295,
  [SMALL_STATE(4757)] = 116302,
  [SMALL_STATE(4758)] = 116309,
  [SMALL_STATE(4759)] = 116316,
  [SMALL_STATE(4760)] = 116323,
  [SMALL_STATE(4761)] = 116330,
  [SMALL_STATE(4762)] = 116337,
  [SMALL_STATE(4763)] = 116344,
  [SMALL_STATE(4764)] = 116351,
  [SMALL_STATE(4765)] = 116358,
  [SMALL_STATE(4766)] = 116365,
  [SMALL_STATE(4767)] = 116372,
  [SMALL_STATE(4768)] = 116379,
  [SMALL_STATE(4769)] = 116386,
  [SMALL_STATE(4770)] = 116393,
  [SMALL_STATE(4771)] = 116400,
  [SMALL_STATE(4772)] = 116407,
  [SMALL_STATE(4773)] = 116414,
  [SMALL_STATE(4774)] = 116421,
  [SMALL_STATE(4775)] = 116428,
  [SMALL_STATE(4776)] = 116435,
  [SMALL_STATE(4777)] = 116442,
  [SMALL_STATE(4778)] = 116449,
  [SMALL_STATE(4779)] = 116456,
  [SMALL_STATE(4780)] = 116463,
  [SMALL_STATE(4781)] = 116470,
  [SMALL_STATE(4782)] = 116477,
  [SMALL_STATE(4783)] = 116484,
  [SMALL_STATE(4784)] = 116491,
  [SMALL_STATE(4785)] = 116498,
  [SMALL_STATE(4786)] = 116505,
  [SMALL_STATE(4787)] = 116512,
  [SMALL_STATE(4788)] = 116519,
  [SMALL_STATE(4789)] = 116526,
  [SMALL_STATE(4790)] = 116533,
  [SMALL_STATE(4791)] = 116540,
  [SMALL_STATE(4792)] = 116547,
  [SMALL_STATE(4793)] = 116554,
  [SMALL_STATE(4794)] = 116561,
  [SMALL_STATE(4795)] = 116568,
  [SMALL_STATE(4796)] = 116575,
  [SMALL_STATE(4797)] = 116582,
  [SMALL_STATE(4798)] = 116589,
  [SMALL_STATE(4799)] = 116596,
  [SMALL_STATE(4800)] = 116603,
  [SMALL_STATE(4801)] = 116610,
  [SMALL_STATE(4802)] = 116617,
  [SMALL_STATE(4803)] = 116624,
  [SMALL_STATE(4804)] = 116631,
  [SMALL_STATE(4805)] = 116638,
  [SMALL_STATE(4806)] = 116645,
  [SMALL_STATE(4807)] = 116652,
  [SMALL_STATE(4808)] = 116659,
  [SMALL_STATE(4809)] = 116666,
  [SMALL_STATE(4810)] = 116673,
  [SMALL_STATE(4811)] = 116680,
  [SMALL_STATE(4812)] = 116687,
  [SMALL_STATE(4813)] = 116694,
  [SMALL_STATE(4814)] = 116701,
  [SMALL_STATE(4815)] = 116708,
  [SMALL_STATE(4816)] = 116715,
  [SMALL_STATE(4817)] = 116722,
  [SMALL_STATE(4818)] = 116729,
  [SMALL_STATE(4819)] = 116736,
  [SMALL_STATE(4820)] = 116743,
  [SMALL_STATE(4821)] = 116750,
  [SMALL_STATE(4822)] = 116757,
  [SMALL_STATE(4823)] = 116764,
  [SMALL_STATE(4824)] = 116771,
  [SMALL_STATE(4825)] = 116778,
  [SMALL_STATE(4826)] = 116785,
  [SMALL_STATE(4827)] = 116792,
  [SMALL_STATE(4828)] = 116799,
  [SMALL_STATE(4829)] = 116806,
  [SMALL_STATE(4830)] = 116813,
  [SMALL_STATE(4831)] = 116820,
  [SMALL_STATE(4832)] = 116827,
  [SMALL_STATE(4833)] = 116834,
  [SMALL_STATE(4834)] = 116841,
  [SMALL_STATE(4835)] = 116848,
  [SMALL_STATE(4836)] = 116855,
  [SMALL_STATE(4837)] = 116862,
  [SMALL_STATE(4838)] = 116869,
  [SMALL_STATE(4839)] = 116876,
  [SMALL_STATE(4840)] = 116883,
  [SMALL_STATE(4841)] = 116890,
  [SMALL_STATE(4842)] = 116897,
  [SMALL_STATE(4843)] = 116904,
  [SMALL_STATE(4844)] = 116911,
  [SMALL_STATE(4845)] = 116918,
  [SMALL_STATE(4846)] = 116925,
  [SMALL_STATE(4847)] = 116932,
  [SMALL_STATE(4848)] = 116939,
  [SMALL_STATE(4849)] = 116946,
  [SMALL_STATE(4850)] = 116953,
  [SMALL_STATE(4851)] = 116960,
  [SMALL_STATE(4852)] = 116967,
  [SMALL_STATE(4853)] = 116974,
  [SMALL_STATE(4854)] = 116981,
  [SMALL_STATE(4855)] = 116988,
  [SMALL_STATE(4856)] = 116995,
  [SMALL_STATE(4857)] = 117002,
  [SMALL_STATE(4858)] = 117009,
  [SMALL_STATE(4859)] = 117016,
  [SMALL_STATE(4860)] = 117023,
  [SMALL_STATE(4861)] = 117030,
  [SMALL_STATE(4862)] = 117037,
  [SMALL_STATE(4863)] = 117044,
  [SMALL_STATE(4864)] = 117051,
  [SMALL_STATE(4865)] = 117058,
  [SMALL_STATE(4866)] = 117065,
  [SMALL_STATE(4867)] = 117072,
  [SMALL_STATE(4868)] = 117079,
  [SMALL_STATE(4869)] = 117086,
  [SMALL_STATE(4870)] = 117093,
  [SMALL_STATE(4871)] = 117100,
  [SMALL_STATE(4872)] = 117107,
  [SMALL_STATE(4873)] = 117114,
  [SMALL_STATE(4874)] = 117121,
  [SMALL_STATE(4875)] = 117128,
  [SMALL_STATE(4876)] = 117135,
  [SMALL_STATE(4877)] = 117142,
  [SMALL_STATE(4878)] = 117149,
  [SMALL_STATE(4879)] = 117156,
  [SMALL_STATE(4880)] = 117163,
  [SMALL_STATE(4881)] = 117170,
  [SMALL_STATE(4882)] = 117177,
  [SMALL_STATE(4883)] = 117184,
  [SMALL_STATE(4884)] = 117191,
  [SMALL_STATE(4885)] = 117198,
  [SMALL_STATE(4886)] = 117205,
  [SMALL_STATE(4887)] = 117212,
  [SMALL_STATE(4888)] = 117219,
  [SMALL_STATE(4889)] = 117226,
  [SMALL_STATE(4890)] = 117233,
  [SMALL_STATE(4891)] = 117240,
  [SMALL_STATE(4892)] = 117247,
  [SMALL_STATE(4893)] = 117254,
  [SMALL_STATE(4894)] = 117261,
  [SMALL_STATE(4895)] = 117268,
  [SMALL_STATE(4896)] = 117275,
  [SMALL_STATE(4897)] = 117282,
  [SMALL_STATE(4898)] = 117289,
  [SMALL_STATE(4899)] = 117296,
  [SMALL_STATE(4900)] = 117303,
  [SMALL_STATE(4901)] = 117310,
  [SMALL_STATE(4902)] = 117317,
  [SMALL_STATE(4903)] = 117324,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2762),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4793),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4147),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4901),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2769),
  [25] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 20),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1415),
  [29] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 20), REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 20),
  [32] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [34] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [36] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 20), SHIFT(489),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [45] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 20), SHIFT(434),
  [48] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [50] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4211),
  [52] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [54] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 20), SHIFT(4787),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3083),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3299),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [65] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 20),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [69] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1, .production_id = 20),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [85] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 20), SHIFT(484),
  [88] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3736),
  [90] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3743),
  [92] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3197),
  [94] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [96] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1922),
  [98] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1743),
  [100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2288),
  [102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2001),
  [104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1455),
  [110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4839),
  [112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4838),
  [114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1372),
  [116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2745),
  [118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3297),
  [122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 20),
  [124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 20), SHIFT(342),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1422),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1788),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3291),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3295),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3202),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4483),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4486),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3919),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4489),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4492),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4499),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3923),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3924),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4501),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4534),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3093),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3305),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3823),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3821),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3353),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3249),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2110),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2102),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1159),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1439),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4527),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4526),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4525),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3308),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1425),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(577),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1157),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1133),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1424),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1150),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(1315),
  [334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(1450),
  [337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(9),
  [340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2),
  [342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(1453),
  [345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(492),
  [348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(1788),
  [351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3291),
  [354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3295),
  [357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3202),
  [360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(492),
  [363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4483),
  [366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4486),
  [369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3919),
  [372] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(92),
  [375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(486),
  [378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4489),
  [381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(39),
  [384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4492),
  [387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4499),
  [390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3923),
  [393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3924),
  [396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4501),
  [399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(154),
  [402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(286),
  [405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(681),
  [408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2),
  [410] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(87),
  [413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(108),
  [416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4211),
  [419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(1180),
  [422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4534),
  [425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3093),
  [428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(618),
  [431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3305),
  [434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(241),
  [437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4793),
  [440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(479),
  [443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3823),
  [446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3821),
  [449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3353),
  [452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(2110),
  [455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(2110),
  [458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(2102),
  [461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4147),
  [464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(1484),
  [467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(525),
  [470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(1404),
  [473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(1416),
  [476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4527),
  [479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4526),
  [482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4525),
  [485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3308),
  [488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1450),
  [492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, .production_id = 287),
  [494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1453),
  [496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, .production_id = 287),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1416),
  [512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 2),
  [514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 2),
  [516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 3, .production_id = 85),
  [518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 3, .production_id = 85),
  [520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, .production_id = 84),
  [522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, .production_id = 84),
  [524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3962),
  [538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3915),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1458),
  [572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1787),
  [574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4394),
  [576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3927),
  [578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4504),
  [580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4500),
  [582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4481),
  [584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3088),
  [586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3225),
  [590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1407),
  [596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4630),
  [600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3221),
  [602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [606] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 20), SHIFT(93),
  [609] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 20), SHIFT(112),
  [612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 20), SHIFT(1180),
  [615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 20), SHIFT(4793),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2093),
  [626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 20),
  [630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2150),
  [632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2089),
  [634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2158),
  [636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2236),
  [640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2239),
  [642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2769),
  [648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1403),
  [650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4787),
  [660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2334),
  [674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2091),
  [676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1465),
  [682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1154),
  [698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1475),
  [700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1405),
  [702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4026),
  [708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3206),
  [728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2183),
  [734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2037),
  [736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4139),
  [738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2002),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(514),
  [752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1),
  [762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1601),
  [764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1),
  [766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1052),
  [770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4720),
  [780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3086),
  [782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3301),
  [786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4793),
  [790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3890),
  [796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3891),
  [798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(998),
  [804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3330),
  [808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4600),
  [822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1099),
  [832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1891),
  [862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1877),
  [864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1445),
  [870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4803),
  [872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4854),
  [874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1275),
  [876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2940),
  [878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1417),
  [886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(626),
  [890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2401),
  [892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2360),
  [894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1501),
  [898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1414),
  [904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4562),
  [916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2328),
  [934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2337),
  [936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2250),
  [938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2465),
  [958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2419),
  [960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2185),
  [962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1476),
  [970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1411),
  [972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2139),
  [976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2283),
  [990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4616),
  [996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3076),
  [998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(628),
  [1000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3307),
  [1002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [1004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [1006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [1008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2167),
  [1010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3316),
  [1012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1353),
  [1014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [1018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [1020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [1022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1655),
  [1024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1375),
  [1026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1474),
  [1028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [1030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(599),
  [1032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [1034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1502),
  [1036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [1038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [1040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [1042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [1044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2345),
  [1046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1418),
  [1048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [1050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [1052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2317),
  [1054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1419),
  [1056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [1058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [1060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [1062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [1064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [1066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4631),
  [1068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [1070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [1072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [1074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [1076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2506),
  [1078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1218),
  [1080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [1082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2142),
  [1086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2141),
  [1088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [1090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3343),
  [1092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [1094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [1096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3944),
  [1100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3214),
  [1102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3905),
  [1104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [1106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3448),
  [1108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [1110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [1112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1344),
  [1114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1478),
  [1116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [1118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3292),
  [1120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3293),
  [1122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [1124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [1126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2101),
  [1128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [1132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [1134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2335),
  [1136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2806),
  [1138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1528),
  [1140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3367),
  [1142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [1144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [1146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4179),
  [1148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3767),
  [1150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [1152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4844),
  [1154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [1156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3755),
  [1158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3685),
  [1160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2767),
  [1162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2765),
  [1164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2767),
  [1166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [1168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [1172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [1174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [1176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [1178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [1180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 20), REDUCE(sym_rest_pattern, 2, .production_id = 58),
  [1183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2, .production_id = 58),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1398),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3537),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [1199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2888),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3043),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1533),
  [1207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3370),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [1213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3864),
  [1215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [1217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1282),
  [1219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4852),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3771),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3769),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3686),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [1229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3029),
  [1231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3032),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [1237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [1241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1),
  [1244] = {.entry = {.count = 3, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1), SHIFT(2989),
  [1248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predefined_type, 1),
  [1250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predefined_type, 1),
  [1252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [1254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [1256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [1258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [1262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2471),
  [1264] = {.entry = {.count = 3, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1), SHIFT(2783),
  [1268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [1270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 1),
  [1272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [1274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [1276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [1278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [1280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [1282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [1284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [1286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2890),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [1290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1),
  [1292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [1296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3049),
  [1298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2179),
  [1300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [1302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3217),
  [1304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2234),
  [1306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [1308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [1310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 20), SHIFT(4692),
  [1313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4694),
  [1315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 20), SHIFT(97),
  [1318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 20), SHIFT(4179),
  [1321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 20), SHIFT(4694),
  [1324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3240),
  [1326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [1328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2160),
  [1330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [1332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [1334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [1338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [1340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1427),
  [1342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [1344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [1346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3467),
  [1348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3437),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [1352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [1354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2517),
  [1356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1162),
  [1358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [1360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2232),
  [1362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [1364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [1366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 2),
  [1368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 2),
  [1370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 2),
  [1372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2),
  [1374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 2),
  [1376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [1378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [1382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 4, .production_id = 41),
  [1384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 4, .production_id = 41),
  [1386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 4, .production_id = 41),
  [1388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 4, .production_id = 41),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [1392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 3, .production_id = 18),
  [1394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 3, .production_id = 18),
  [1396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 3, .production_id = 18),
  [1398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 3, .production_id = 18),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [1402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 222),
  [1404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 6, .production_id = 222),
  [1406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 222),
  [1408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, .production_id = 222),
  [1410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [1412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 5, .production_id = 77),
  [1414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 5, .production_id = 77),
  [1416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 5, .production_id = 77),
  [1418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 5, .production_id = 77),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [1422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 5, .production_id = 76),
  [1424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 5, .production_id = 76),
  [1426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 5, .production_id = 76),
  [1428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 5, .production_id = 76),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [1432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 5, .production_id = 75),
  [1434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 5, .production_id = 75),
  [1436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 5, .production_id = 75),
  [1438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 5, .production_id = 75),
  [1440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [1442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 3, .production_id = 17),
  [1444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 3, .production_id = 17),
  [1446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 3, .production_id = 17),
  [1448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 3, .production_id = 17),
  [1450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [1452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 141),
  [1454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 141),
  [1456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 141),
  [1458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 141),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [1462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 144),
  [1464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 144),
  [1466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 144),
  [1468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 144),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [1472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 184),
  [1474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 184),
  [1476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 184),
  [1478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 184),
  [1480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [1482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 6, .production_id = 124),
  [1484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 6, .production_id = 124),
  [1486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 6, .production_id = 124),
  [1488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 6, .production_id = 124),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [1492] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 20), SHIFT(4558),
  [1495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4557),
  [1497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [1499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 20), SHIFT(4557),
  [1502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [1504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 183),
  [1506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 183),
  [1508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 183),
  [1510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 183),
  [1512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [1514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 5, .production_id = 73),
  [1516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 5, .production_id = 73),
  [1518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 5, .production_id = 73),
  [1520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 5, .production_id = 73),
  [1522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [1524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 3),
  [1526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 3),
  [1528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [1530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 83),
  [1532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 83),
  [1534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 83),
  [1536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 83),
  [1538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [1540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_body, 3, .production_id = 37),
  [1542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_body, 3, .production_id = 37),
  [1544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 4, .production_id = 43),
  [1546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 4, .production_id = 43),
  [1548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 4, .production_id = 43),
  [1550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 4, .production_id = 43),
  [1552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [1554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 4, .production_id = 40),
  [1556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 4, .production_id = 40),
  [1558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 4, .production_id = 40),
  [1560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 4, .production_id = 40),
  [1562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [1564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 4, .production_id = 44),
  [1566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 4, .production_id = 44),
  [1568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 4, .production_id = 44),
  [1570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 4, .production_id = 44),
  [1572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [1574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 4, .production_id = 45),
  [1576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 4, .production_id = 45),
  [1578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 4, .production_id = 45),
  [1580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 4, .production_id = 45),
  [1582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [1584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 4, .production_id = 46),
  [1586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 4, .production_id = 46),
  [1588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 4, .production_id = 46),
  [1590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 4, .production_id = 46),
  [1592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [1594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 2, .production_id = 4),
  [1596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 2, .production_id = 4),
  [1598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 2, .production_id = 4),
  [1600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 2, .production_id = 4),
  [1602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [1604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 4, .production_id = 39),
  [1606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 4, .production_id = 39),
  [1608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 4, .production_id = 39),
  [1610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 4, .production_id = 39),
  [1612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [1616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 180),
  [1618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 180),
  [1620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 180),
  [1622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 180),
  [1624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [1626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 180),
  [1628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5, .production_id = 180),
  [1630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 180),
  [1632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5, .production_id = 180),
  [1634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [1636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2),
  [1638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2),
  [1640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 4),
  [1642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 4),
  [1644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 3, .production_id = 15),
  [1646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 3, .production_id = 15),
  [1648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 3, .production_id = 15),
  [1650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 3, .production_id = 15),
  [1652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [1654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [1656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 2, .production_id = 3),
  [1658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 2, .production_id = 3),
  [1660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 2, .production_id = 3),
  [1662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 2, .production_id = 3),
  [1664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [1666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 176),
  [1668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 176),
  [1670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 176),
  [1672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 176),
  [1674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [1676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [1678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3),
  [1680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3),
  [1682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 3, .production_id = 14),
  [1684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 3, .production_id = 14),
  [1686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 3, .production_id = 14),
  [1688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 3, .production_id = 14),
  [1690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [1692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 3, .production_id = 13),
  [1694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 3, .production_id = 13),
  [1696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 3, .production_id = 13),
  [1698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 3, .production_id = 13),
  [1700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [1702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_body, 2),
  [1704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_body, 2),
  [1706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 132),
  [1708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 132),
  [1710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 132),
  [1712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 132),
  [1714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [1716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 3, .production_id = 12),
  [1718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component, 3, .production_id = 12),
  [1720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 3, .production_id = 12),
  [1722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component, 3, .production_id = 12),
  [1724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [1726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 133),
  [1728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 133),
  [1730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 133),
  [1732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 133),
  [1734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [1736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 221),
  [1738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 6, .production_id = 221),
  [1740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 221),
  [1742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 6, .production_id = 221),
  [1744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [1746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [1748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [1750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4719),
  [1752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1399),
  [1754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [1756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [1758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [1760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1471),
  [1762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4869),
  [1764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [1766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [1768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1959),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [1772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [1774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(629),
  [1776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [1780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [1782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [1784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [1786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [1788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [1790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4690),
  [1792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [1794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [1796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(946),
  [1798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [1800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [1802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1504),
  [1804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [1806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [1808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [1810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [1812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [1814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [1816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [1818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1413),
  [1820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [1826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [1828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [1830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2327),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [1834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [1836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1854),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [1840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessibility_modifier, 1),
  [1842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessibility_modifier, 1),
  [1844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_modifier, 1),
  [1846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override_modifier, 1),
  [1848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1),
  [1850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [1852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1),
  [1854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [1856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(4809),
  [1859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [1861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1),
  [1863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(3373),
  [1866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4885),
  [1868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [1870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [1872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [1874] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(3341),
  [1877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [1879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [1881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4582),
  [1883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4584),
  [1885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [1887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [1889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [1891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 20), REDUCE(sym__property_name, 1, .production_id = 23),
  [1894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 23), SHIFT(42),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [1899] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 20), REDUCE(sym__property_name, 1, .production_id = 23),
  [1902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4585),
  [1904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4588),
  [1906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4429),
  [1908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [1910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_name, 1, .production_id = 23),
  [1912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [1914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [1916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [1918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4527),
  [1920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4428),
  [1922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4526),
  [1924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4525),
  [1926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [1928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [1930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [1932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [1934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [1936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [1938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [1940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [1942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4877),
  [1944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4285),
  [1946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [1948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3465),
  [1950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3233),
  [1952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4301),
  [1954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4630),
  [1956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3856),
  [1958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3857),
  [1960] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 20), SHIFT(2672),
  [1963] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 20), REDUCE(sym__property_name, 1, .production_id = 23), SHIFT(97),
  [1967] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 20), SHIFT(392),
  [1970] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 20), REDUCE(sym__property_name, 1, .production_id = 23), SHIFT(4179),
  [1974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3298),
  [1976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3488),
  [1978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2597),
  [1980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 22),
  [1982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 22),
  [1984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 94),
  [1986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 94),
  [1988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_null_expression, 2),
  [1990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_null_expression, 2),
  [1992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 95),
  [1994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 95),
  [1996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 93),
  [1998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 93),
  [2000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 143),
  [2002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 143),
  [2004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5, .production_id = 182),
  [2006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5, .production_id = 182),
  [2008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 4, .production_id = 129),
  [2010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 4, .production_id = 129),
  [2012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [2014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [2016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2725),
  [2018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [2020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4179),
  [2022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4848),
  [2024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [2026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4844),
  [2028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [2030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4843),
  [2032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4842),
  [2034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4181),
  [2036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4182),
  [2038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4830),
  [2040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4828),
  [2042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4826),
  [2044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2664),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [2050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [2056] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(2725),
  [2059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(2769),
  [2062] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(1528),
  [2065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38),
  [2067] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(3367),
  [2070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(72),
  [2073] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(1103),
  [2076] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(4179),
  [2079] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(4848),
  [2082] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(3767),
  [2085] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(1345),
  [2088] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(1352),
  [2091] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(4844),
  [2094] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(2745),
  [2097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(3754),
  [2100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(3755),
  [2103] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(3685),
  [2106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(2767),
  [2109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(2765),
  [2112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(2767),
  [2115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(1132),
  [2118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(1357),
  [2121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(4843),
  [2124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(4842),
  [2127] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(1366),
  [2130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(4839),
  [2133] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(4838),
  [2136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(1372),
  [2139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(1528),
  [2142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(4181),
  [2145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(4182),
  [2148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(4830),
  [2151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(4828),
  [2154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(4826),
  [2157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(2664),
  [2160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [2162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [2168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3248),
  [2170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2580),
  [2172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2581),
  [2174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2615),
  [2176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2644),
  [2178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_import_path_segment, 1), SHIFT(619),
  [2181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_path_segment, 1),
  [2183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_path_segment, 1),
  [2185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4868),
  [2187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4135),
  [2189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4386),
  [2191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_import_path_segment, 1), SHIFT(619),
  [2194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2739),
  [2196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [2198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4249),
  [2200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4176),
  [2202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2682),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [2206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(2739),
  [2209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(2769),
  [2212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(1528),
  [2215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38),
  [2217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(3367),
  [2220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(72),
  [2223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(1103),
  [2226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(4179),
  [2229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(4848),
  [2232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(3767),
  [2235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(1345),
  [2238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(1352),
  [2241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(4844),
  [2244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(2745),
  [2247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(3754),
  [2250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(3755),
  [2253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(3685),
  [2256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(2767),
  [2259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(2765),
  [2262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(2767),
  [2265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(4249),
  [2268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(1357),
  [2271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(1366),
  [2274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(4839),
  [2277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(4838),
  [2280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(1372),
  [2283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(1528),
  [2286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(4176),
  [2289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(4830),
  [2292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(4828),
  [2295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(4826),
  [2298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 38), SHIFT_REPEAT(2682),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [2303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [2305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [2313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4722),
  [2315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4723),
  [2317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3236),
  [2319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2, .production_id = 58),
  [2321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, .production_id = 3),
  [2323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, .production_id = 3),
  [2325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3984),
  [2327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4374),
  [2329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_path, 2),
  [2331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_path, 2),
  [2333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4197),
  [2335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_path, 1),
  [2337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_path, 1),
  [2339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4878),
  [2341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4880),
  [2343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3327),
  [2345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_path, 3, .production_id = 2),
  [2347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_path, 3, .production_id = 2),
  [2349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4683),
  [2351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4682),
  [2353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_path_segment_repeat1, 2), SHIFT_REPEAT(607),
  [2356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_path_segment_repeat1, 2),
  [2358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_path_segment_repeat1, 2),
  [2360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_path_segment_repeat1, 2), SHIFT_REPEAT(607),
  [2363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_path, 2, .production_id = 2),
  [2365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_path, 2, .production_id = 2),
  [2367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_path_repeat1, 2),
  [2369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_path_repeat1, 2),
  [2371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_path_repeat1, 2), SHIFT_REPEAT(4197),
  [2374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 20), SHIFT(239),
  [2377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [2379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_import_path_segment, 2), SHIFT(607),
  [2382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_path_segment, 2),
  [2384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_path_segment, 2),
  [2386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_import_path_segment, 2), SHIFT(607),
  [2389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4799),
  [2391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4798),
  [2393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [2395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [2397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [2399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3228),
  [2401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 1, .production_id = 16),
  [2403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [2405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 1, .production_id = 16),
  [2407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4672),
  [2409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_js_import_statement, 7, .production_id = 125),
  [2411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_js_import_statement, 7, .production_id = 125),
  [2413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 5, .production_id = 46),
  [2415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 5, .production_id = 46),
  [2417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_js_import_statement, 6, .production_id = 78),
  [2419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_js_import_statement, 6, .production_id = 78),
  [2421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 3, .production_id = 4),
  [2423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 3, .production_id = 4),
  [2425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [2427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 2),
  [2429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4857),
  [2431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 2),
  [2433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_import_path, 1, .production_id = 2), SHIFT(614),
  [2436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_path, 1, .production_id = 2),
  [2438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_path, 1, .production_id = 2),
  [2440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 5, .production_id = 43),
  [2442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 5, .production_id = 43),
  [2444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 5, .production_id = 44),
  [2446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 5, .production_id = 44),
  [2448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 3, .production_id = 3),
  [2450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 3, .production_id = 3),
  [2452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 4, .production_id = 12),
  [2454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 4, .production_id = 12),
  [2456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 4, .production_id = 13),
  [2458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 4, .production_id = 13),
  [2460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 205),
  [2462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 205),
  [2464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 7, .production_id = 124),
  [2466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 7, .production_id = 124),
  [2468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_js_import_statement, 4, .production_id = 19),
  [2470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_js_import_statement, 4, .production_id = 19),
  [2472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 4, .production_id = 14),
  [2474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 4, .production_id = 14),
  [2476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 6, .production_id = 77),
  [2478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 6, .production_id = 77),
  [2480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 4, .production_id = 15),
  [2482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 4, .production_id = 15),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [2486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3),
  [2488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3),
  [2490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 5, .production_id = 41),
  [2492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 5, .production_id = 41),
  [2494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 4, .production_id = 17),
  [2496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 4, .production_id = 17),
  [2498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 4, .production_id = 18),
  [2500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 4, .production_id = 18),
  [2502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_js_import_statement, 5, .production_id = 47),
  [2504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_js_import_statement, 5, .production_id = 47),
  [2506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 5, .production_id = 40),
  [2508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 5, .production_id = 40),
  [2510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 5, .production_id = 45),
  [2512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 5, .production_id = 45),
  [2514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4817),
  [2516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4816),
  [2518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_as, 2),
  [2520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_as, 2),
  [2522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 5, .production_id = 39),
  [2524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 5, .production_id = 39),
  [2526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_js_import_statement, 3, .production_id = 6),
  [2528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_js_import_statement, 3, .production_id = 6),
  [2530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 6, .production_id = 76),
  [2532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 6, .production_id = 76),
  [2534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 6, .production_id = 75),
  [2536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 6, .production_id = 75),
  [2538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_declaration, 6, .production_id = 73),
  [2540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_declaration, 6, .production_id = 73),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [2544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [2546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [2548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [2550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [2552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 48),
  [2554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 48),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [2560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [2562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4316),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [2566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 290),
  [2568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 290),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [2572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 201),
  [2574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 201),
  [2576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [2580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, .production_id = 3),
  [2582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, .production_id = 3),
  [2584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3),
  [2586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3),
  [2588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 8),
  [2590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 8),
  [2592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4688),
  [2594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [2596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 6, .production_id = 300),
  [2598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 6, .production_id = 300),
  [2600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2),
  [2602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2),
  [2604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 4, .production_id = 233),
  [2606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 4, .production_id = 233),
  [2608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 3, .production_id = 203),
  [2610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 3, .production_id = 203),
  [2612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_listener_declaration, 6, .production_id = 216),
  [2614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [2616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [2618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_listener_declaration, 6, .production_id = 216),
  [2620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [2622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [2624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [2628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [2632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [2634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [2636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [2638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [2646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [2648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [2652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [2654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1361),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [2658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4832),
  [2660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4831),
  [2662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [2664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [2666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 235),
  [2668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 235),
  [2670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_alias, 5),
  [2672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_alias, 5),
  [2674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 132),
  [2676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 132),
  [2678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 2, .production_id = 165),
  [2680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 2, .production_id = 165),
  [2682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 133),
  [2684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 133),
  [2686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2),
  [2688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2),
  [2690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 274),
  [2692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 274),
  [2694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_internal_module, 2, .production_id = 165),
  [2696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_internal_module, 2, .production_id = 165),
  [2698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 92),
  [2700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 92),
  [2702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 34),
  [2704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 34),
  [2706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, .production_id = 3),
  [2708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, .production_id = 3),
  [2710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_assertion, 2),
  [2712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_assertion, 2),
  [2714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 202),
  [2716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 202),
  [2718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4),
  [2720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4),
  [2722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 3, .production_id = 200),
  [2724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 3, .production_id = 200),
  [2726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 276),
  [2728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 276),
  [2730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 183),
  [2732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 183),
  [2734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3),
  [2736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3),
  [2738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 4),
  [2740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 4),
  [2742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 184),
  [2744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 184),
  [2746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 277),
  [2748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 277),
  [2750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 278),
  [2752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 278),
  [2754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 199),
  [2756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 199),
  [2758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2),
  [2760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2),
  [2762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 31),
  [2764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 31),
  [2766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 234),
  [2768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 234),
  [2770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1),
  [2772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1),
  [2774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 4, .production_id = 100),
  [2776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 4, .production_id = 100),
  [2778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [2780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 140),
  [2782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 140),
  [2784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 139),
  [2786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 139),
  [2788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 3),
  [2790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3),
  [2792] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 137),
  [2794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 137),
  [2796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 5),
  [2798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 5),
  [2800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 268),
  [2802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 268),
  [2804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 31),
  [2806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 31),
  [2808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 256),
  [2810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 256),
  [2812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 6),
  [2814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 6),
  [2816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 250),
  [2818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 250),
  [2820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternary_expression, 5, .production_id = 181),
  [2822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 181),
  [2824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 144),
  [2826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 144),
  [2828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2),
  [2830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2),
  [2832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4452),
  [2834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1),
  [2836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1),
  [2838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 272),
  [2840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 272),
  [2842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 25),
  [2844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 25),
  [2846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4451),
  [2848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2),
  [2850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2),
  [2852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 3),
  [2854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 3),
  [2856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3),
  [2858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3),
  [2860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 26),
  [2862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 26),
  [2864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4445),
  [2866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [2868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [2870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3, .production_id = 34),
  [2872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, .production_id = 34),
  [2874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 176),
  [2876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 176),
  [2878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debugger_statement, 2),
  [2880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debugger_statement, 2),
  [2882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 98),
  [2884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 98),
  [2886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 92),
  [2888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 92),
  [2890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 2),
  [2892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2),
  [2894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 253),
  [2896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 253),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [2900] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 252),
  [2902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 252),
  [2904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [2906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [2908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 251),
  [2910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 251),
  [2912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 133),
  [2914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 133),
  [2916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 3),
  [2918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 3),
  [2920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [2922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 289),
  [2924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 289),
  [2926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 2, .production_id = 209),
  [2928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 2, .production_id = 209),
  [2930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 180),
  [2932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 180),
  [2934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 221),
  [2936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 221),
  [2938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 180),
  [2940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 180),
  [2942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 83),
  [2944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 83),
  [2946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 7, .production_id = 291),
  [2948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 7, .production_id = 291),
  [2950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, .production_id = 274),
  [2952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, .production_id = 274),
  [2954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 176),
  [2956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 176),
  [2958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, .production_id = 276),
  [2960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, .production_id = 276),
  [2962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 141),
  [2964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 141),
  [2966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 12),
  [2968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 12),
  [2970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 80),
  [2972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 80),
  [2974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 222),
  [2976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 222),
  [2978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 292),
  [2980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 292),
  [2982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 9),
  [2984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 9),
  [2986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 204),
  [2988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 204),
  [2990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 91),
  [2992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 91),
  [2994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 83),
  [2996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 83),
  [2998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 271),
  [3000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 271),
  [3002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_assignment_expression, 1),
  [3004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_assignment_expression, 1),
  [3006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 206),
  [3008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 206),
  [3010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 3, .production_id = 207),
  [3012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 3, .production_id = 207),
  [3014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [3016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [3018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 132),
  [3020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 132),
  [3022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3, .production_id = 208),
  [3024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3, .production_id = 208),
  [3026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4),
  [3028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4),
  [3030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 79),
  [3032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 79),
  [3034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [3036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [3038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3),
  [3040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3),
  [3042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 4, .production_id = 200),
  [3044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 4, .production_id = 200),
  [3046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 2),
  [3048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 2),
  [3050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3, .production_id = 208),
  [3052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3, .production_id = 208),
  [3054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 231),
  [3056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 231),
  [3058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [3060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [3062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [3064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [3066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 232),
  [3068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 232),
  [3070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 90),
  [3072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 90),
  [3074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_expression_initializer, 2, .production_id = 84),
  [3076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_expression_initializer, 2, .production_id = 84),
  [3078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2),
  [3080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2),
  [3082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 5, .production_id = 150),
  [3084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 5, .production_id = 150),
  [3086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 2),
  [3088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 2),
  [3090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [3092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [3094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 159),
  [3096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 159),
  [3098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_literal_type, 2),
  [3100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_literal_type, 2),
  [3102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lookup_type, 4),
  [3104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lookup_type, 4),
  [3106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 2),
  [3108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 2),
  [3110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [3112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 67),
  [3114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 67),
  [3116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 67),
  [3119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 93),
  [3121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 93),
  [3123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_existential_type, 1),
  [3125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_existential_type, 1),
  [3127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [3129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [3131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_type, 7, .production_id = 239),
  [3133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_type, 7, .production_id = 239),
  [3135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [3137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, .production_id = 121),
  [3139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, .production_id = 121),
  [3141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_component_expression, 2, .production_id = 16),
  [3143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_component_expression, 2, .production_id = 16),
  [3145] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_new_component_expression, 2, .production_id = 16), SHIFT(132),
  [3148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 6, .production_id = 212),
  [3150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 6, .production_id = 212),
  [3152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 107),
  [3154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 107),
  [3156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 22),
  [3158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 22),
  [3160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [3162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 7),
  [3164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 7),
  [3166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 56),
  [3168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 56),
  [3170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 57),
  [3172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 57),
  [3174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 196),
  [3176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 196),
  [3178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1, .production_id = 10),
  [3180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1, .production_id = 10),
  [3182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3),
  [3184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3),
  [3186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3),
  [3188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3),
  [3190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 195),
  [3192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 195),
  [3194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 108),
  [3196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 108),
  [3198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [3200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [3202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_literal_type, 3),
  [3204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_literal_type, 3),
  [3206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 194),
  [3208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 194),
  [3210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [3212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [3214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 193),
  [3216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 193),
  [3218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5),
  [3220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5),
  [3222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, .production_id = 72),
  [3224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, .production_id = 72),
  [3226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [3228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [3230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [3232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5, .production_id = 167),
  [3234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5, .production_id = 167),
  [3236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 5),
  [3238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5),
  [3240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 143),
  [3242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 143),
  [3244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 157),
  [3246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 157),
  [3248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 3),
  [3250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 3),
  [3252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 4, .production_id = 119),
  [3254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 4, .production_id = 119),
  [3256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5, .production_id = 164),
  [3258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5, .production_id = 164),
  [3260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_satisfies_expression, 3),
  [3262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_satisfies_expression, 3),
  [3264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1),
  [3266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1),
  [3268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3),
  [3270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3),
  [3272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [3274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [3276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 81),
  [3278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 81),
  [3280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 3, .production_id = 82),
  [3282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4),
  [3284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4),
  [3286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [3288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [3290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 112),
  [3292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 112),
  [3294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 111),
  [3296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 111),
  [3298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [3300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [3302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_component_expression, 3, .production_id = 16),
  [3304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_component_expression, 3, .production_id = 16),
  [3306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_new_component_expression, 3, .production_id = 16), SHIFT(132),
  [3309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 35),
  [3311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 35),
  [3313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2),
  [3315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2),
  [3317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 158),
  [3319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 158),
  [3321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infer_type, 2, .production_id = 33),
  [3323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infer_type, 2, .production_id = 33),
  [3325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 27),
  [3327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 27),
  [3329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4435),
  [3331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 2),
  [3333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 2),
  [3335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 110),
  [3337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 110),
  [3339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 109),
  [3341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 109),
  [3343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 2),
  [3345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 2),
  [3347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_flow_maybe_type, 2),
  [3349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flow_maybe_type, 2),
  [3351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, .production_id = 59),
  [3353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, .production_id = 59),
  [3355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [3357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_readonly_type, 2),
  [3359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_readonly_type, 2),
  [3361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 32),
  [3363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 32),
  [3365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [3367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_predicate, 3, .production_id = 172),
  [3369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3, .production_id = 172),
  [3371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 89),
  [3373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 89),
  [3375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 3),
  [3377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3),
  [3379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_predicate, 3, .production_id = 106),
  [3381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3, .production_id = 106),
  [3383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [3385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [3387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 2),
  [3389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__number, 2, .production_id = 31),
  [3391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__number, 2, .production_id = 31),
  [3393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_expression, 3),
  [3395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_expression, 3),
  [3397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 138),
  [3399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 138),
  [3401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_tripple_tagged_component_expression, 3, .production_id = 16),
  [3403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_tripple_tagged_component_expression, 3, .production_id = 16),
  [3405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_tagged_component_expression, 3, .production_id = 16),
  [3407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_tagged_component_expression, 3, .production_id = 16),
  [3409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tripple_tagged_type_string, 2),
  [3411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tripple_tagged_type_string, 2),
  [3413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tagged_type_string, 2),
  [3415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tagged_type_string, 2),
  [3417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_component_expression, 3, .production_id = 42),
  [3419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_component_expression, 3, .production_id = 42),
  [3421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 179),
  [3423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 179),
  [3425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 185),
  [3427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 185),
  [3429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_component_body, 2),
  [3431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_component_body, 2),
  [3433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tripple_tagged_type_string, 3),
  [3435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tripple_tagged_type_string, 3),
  [3437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_tripple_tagged_component_expression, 2, .production_id = 16),
  [3439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_tripple_tagged_component_expression, 2, .production_id = 16),
  [3441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 3),
  [3443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 3),
  [3445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 49),
  [3447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 49),
  [3449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 88),
  [3451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 88),
  [3453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_tagged_component_expression, 2, .production_id = 16),
  [3455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_tagged_component_expression, 2, .production_id = 16),
  [3457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_property, 3),
  [3459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_property, 3),
  [3461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 3, .production_id = 87),
  [3463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, .production_id = 87),
  [3465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 7),
  [3467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 7),
  [3469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 86),
  [3471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 86),
  [3473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 85),
  [3475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 85),
  [3477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 146),
  [3479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 146),
  [3481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3),
  [3483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3),
  [3485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 145),
  [3487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 145),
  [3489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3),
  [3491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3),
  [3493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_closing_tag, 1),
  [3495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_closing_tag, 1),
  [3497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_template, 2, .production_id = 50),
  [3499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_template, 2, .production_id = 50),
  [3501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 17),
  [3503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 17),
  [3505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 142),
  [3507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 142),
  [3509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 4, .production_id = 138),
  [3511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 4, .production_id = 138),
  [3513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, .production_id = 81),
  [3515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, .production_id = 81),
  [3517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_template, 3, .production_id = 97),
  [3519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_template, 3, .production_id = 97),
  [3521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 1),
  [3523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 1),
  [3525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4),
  [3527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4),
  [3529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tagged_type_string, 3),
  [3531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tagged_type_string, 3),
  [3533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 96),
  [3535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 96),
  [3537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4),
  [3539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4),
  [3541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 3),
  [3543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 3),
  [3545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_component_body, 3, .production_id = 37),
  [3547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_component_body, 3, .production_id = 37),
  [3549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 136),
  [3551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 136),
  [3553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 4, .production_id = 130),
  [3555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 4, .production_id = 130),
  [3557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_component_expression, 4, .production_id = 74),
  [3559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_component_expression, 4, .production_id = 74),
  [3561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 2),
  [3563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 2),
  [3565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [3567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [3569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [3571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [3573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [3575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [3577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [3579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [3581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [3583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(506),
  [3585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [3587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [3589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [3591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [3593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [3595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [3597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [3599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 7, .production_id = 299),
  [3601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 7, .production_id = 299),
  [3603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2920),
  [3605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4780),
  [3607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [3609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [3611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4537),
  [3613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [3615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4808),
  [3617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3169),
  [3619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 269),
  [3621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 269),
  [3623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4771),
  [3625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2793),
  [3627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 288),
  [3629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 288),
  [3631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 270),
  [3633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 270),
  [3635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4676),
  [3637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3018),
  [3639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4677),
  [3641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [3643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [3645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [3647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3191),
  [3649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [3651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [3653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [3655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [3657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2784),
  [3659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [3661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [3663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [3665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2774),
  [3667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [3669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1, .production_id = 23),
  [3672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [3674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1, .production_id = 23),
  [3677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(4809),
  [3680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [3682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3497),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [3686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3078),
  [3688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4762),
  [3690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4236),
  [3692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4766),
  [3694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [3696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4173),
  [3700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [3702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [3704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3373),
  [3706] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1), REDUCE(sym__primary_type, 1, .production_id = 8),
  [3710] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(405),
  [3713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 8),
  [3716] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(1226),
  [3719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(4529),
  [3722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 8),
  [3725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [3727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(1314),
  [3730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(4726),
  [3733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 8), SHIFT(4338),
  [3736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [3738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [3740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [3742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [3744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [3746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2871),
  [3748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3763),
  [3750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [3752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [3754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3044),
  [3756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [3758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [3760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4893),
  [3762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2904),
  [3764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1301),
  [3766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [3768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3776),
  [3770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3775),
  [3772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2835),
  [3774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [3776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4852),
  [3778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3030),
  [3780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2893),
  [3782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [3784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [3787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [3789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2857),
  [3791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3894),
  [3793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [3795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [3797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3023),
  [3799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [3801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [3803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4836),
  [3805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2910),
  [3807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [3809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), REDUCE(sym__primary_type, 1, .production_id = 8),
  [3812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(318),
  [3815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [3817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2792),
  [3819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2944),
  [3821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2881),
  [3823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2898),
  [3825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [3827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1529),
  [3829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3362),
  [3831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [3833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [3835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3876),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [3839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [3841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4781),
  [3843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3092),
  [3845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3740),
  [3847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3701),
  [3851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [3853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3062),
  [3855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3150),
  [3857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [3859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [3861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4846),
  [3863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2911),
  [3865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4790),
  [3867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [3869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [3871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2),
  [3873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2),
  [3875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [3877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [3879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4450),
  [3881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3959),
  [3883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [3885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [3887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1535),
  [3889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3511),
  [3891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [3893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [3895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3887),
  [3897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [3899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [3901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4598),
  [3903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [3905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3559),
  [3907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [3909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [3911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [3913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [3915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [3917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4821),
  [3919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4596),
  [3921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [3923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [3925] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 8), REDUCE(sym_rest_pattern, 2),
  [3929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3089),
  [3931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3738),
  [3933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [3935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [3937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3321),
  [3939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [3943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4900),
  [3945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [3947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [3949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1600),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [3953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1536),
  [3955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3366),
  [3957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [3959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [3961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3783),
  [3963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [3965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [3967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4822),
  [3969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1629),
  [3971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3618),
  [3973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [3975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1635),
  [3977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1693),
  [3979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [3981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [3983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4648),
  [3985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4820),
  [3987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1337),
  [3989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [3991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2756),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [3997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [3999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [4001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [4005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2907),
  [4007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2997),
  [4009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [4011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [4013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [4015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3100),
  [4017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3126),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [4021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [4023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1740),
  [4025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [4027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [4029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3449),
  [4031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [4033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [4035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3884),
  [4037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [4039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [4041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4512),
  [4043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1863),
  [4045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3602),
  [4047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [4049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1879),
  [4051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1972),
  [4053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [4055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [4057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4841),
  [4059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4673),
  [4061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [4063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [4065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [4067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [4069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [4071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3107),
  [4073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3135),
  [4075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2889),
  [4077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [4079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1694),
  [4081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [4083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1969),
  [4085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2887),
  [4087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [4089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [4091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2782),
  [4093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [4095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2922),
  [4097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3151),
  [4099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [4101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [4103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [4105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2760),
  [4107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(227),
  [4110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [4112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [4114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [4116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [4118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_rest_pattern, 2),
  [4121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2919),
  [4123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2882),
  [4125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [4127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [4129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [4131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [4135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [4139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2016),
  [4141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3804),
  [4143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4778),
  [4145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [4147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1845),
  [4149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2006),
  [4151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2282),
  [4153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2442),
  [4155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2447),
  [4157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4777),
  [4159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [4161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [4163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3611),
  [4165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2914),
  [4167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2908),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [4171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1957),
  [4173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [4175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1953),
  [4177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2257),
  [4179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2477),
  [4181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2476),
  [4183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [4185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [4187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [4189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [4191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2932),
  [4193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2892),
  [4195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1947),
  [4197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [4199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1949),
  [4201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2286),
  [4203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2434),
  [4205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2449),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [4209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [4211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2957),
  [4213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2903),
  [4215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [4217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [4219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1847),
  [4221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1916),
  [4223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2132),
  [4225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2436),
  [4227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2433),
  [4229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [4231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(439),
  [4233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [4235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [4237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3946),
  [4239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3061),
  [4241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2984),
  [4243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1), REDUCE(aux_sym_object_pattern_repeat1, 1),
  [4246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2367),
  [4248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2254),
  [4250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2366),
  [4252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2413),
  [4254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2530),
  [4256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2534),
  [4258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 20), REDUCE(sym_predefined_type, 1),
  [4261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 20), REDUCE(sym_predefined_type, 1),
  [4264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_repeat1, 2, .production_id = 5),
  [4266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_repeat1, 2, .production_id = 5),
  [4268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_repeat1, 2, .production_id = 5), SHIFT(3071),
  [4271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_repeat1, 2, .production_id = 5), SHIFT(4793),
  [4274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_repeat1, 2, .production_id = 5), SHIFT_REPEAT(4139),
  [4277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_repeat1, 2, .production_id = 5), SHIFT(3227),
  [4280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2),
  [4282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2),
  [4284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [4286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4823),
  [4288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 22),
  [4290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 22),
  [4292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_repeat1, 1, .production_id = 1),
  [4294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_repeat1, 1, .production_id = 1),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [4298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 7),
  [4300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 7),
  [4302] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 20), REDUCE(sym_predefined_type, 1), REDUCE(sym_rest_pattern, 2, .production_id = 58),
  [4306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [4308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 2, .production_id = 36),
  [4310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 2, .production_id = 36),
  [4312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [4314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [4316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_property_declaration, 3, .production_id = 69),
  [4318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_property_declaration, 3, .production_id = 69),
  [4320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration_name, 1),
  [4322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration_name, 1),
  [4324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 2, .production_id = 34),
  [4326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 2, .production_id = 34),
  [4328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [4330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_property_declaration, 3, .production_id = 68),
  [4332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_property_declaration, 3, .production_id = 68),
  [4334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [4336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3003),
  [4338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3082),
  [4340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [4342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [4344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2461),
  [4346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [4348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2336),
  [4350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2403),
  [4352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2492),
  [4354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2463),
  [4356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2497),
  [4358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3164),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [4370] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_new_component_expression, 3, .production_id = 16), SHIFT(135),
  [4373] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_new_component_expression, 2, .production_id = 16), SHIFT(135),
  [4376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [4378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [4380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [4382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [4384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, .production_id = 214),
  [4386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, .production_id = 214),
  [4388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_property_declaration, 5, .production_id = 68),
  [4390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_property_declaration, 5, .production_id = 68),
  [4392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_formal_type_parameters, 5),
  [4394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_type_parameters, 5),
  [4396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, .production_id = 215),
  [4398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, .production_id = 215),
  [4400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_definition, 3, .production_id = 70),
  [4402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_definition, 3, .production_id = 70),
  [4404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_accessor_declaration, 6, .production_id = 211),
  [4406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_accessor_declaration, 6, .production_id = 211),
  [4408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_property_declaration, 6, .production_id = 188),
  [4410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_property_declaration, 6, .production_id = 188),
  [4412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_method_declaration, 6, .production_id = 210),
  [4414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_method_declaration, 6, .production_id = 210),
  [4416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_method_declaration, 4, .production_id = 120),
  [4418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_method_declaration, 4, .production_id = 120),
  [4420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_method_declaration, 5, .production_id = 171),
  [4422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_method_declaration, 5, .production_id = 171),
  [4424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 3, .production_id = 71),
  [4426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 3, .production_id = 71),
  [4428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_accessor_declaration, 4, .production_id = 120),
  [4430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_accessor_declaration, 4, .production_id = 120),
  [4432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_property_declaration, 4, .production_id = 69),
  [4434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_property_declaration, 4, .production_id = 69),
  [4436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_method_declaration, 5, .production_id = 163),
  [4438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_method_declaration, 5, .production_id = 163),
  [4440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_formal_type_parameters, 2),
  [4442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_type_parameters, 2),
  [4444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 1, .production_id = 11),
  [4446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 1, .production_id = 11),
  [4448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [4450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier_property_assignment, 3, .production_id = 16),
  [4452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_property_assignment, 3, .production_id = 16),
  [4454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_method_declaration, 6, .production_id = 198),
  [4456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_method_declaration, 6, .production_id = 198),
  [4458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_accessor_declaration, 5, .production_id = 166),
  [4460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_accessor_declaration, 5, .production_id = 166),
  [4462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_assignment, 3, .production_id = 66),
  [4464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_assignment, 3, .production_id = 66),
  [4466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_method_declaration, 7, .production_id = 238),
  [4468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_method_declaration, 7, .production_id = 238),
  [4470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_assignment, 3, .production_id = 65),
  [4472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_assignment, 3, .production_id = 65),
  [4474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_formal_type_parameters, 4),
  [4476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_type_parameters, 4),
  [4478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_formal_type_parameters, 3),
  [4480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_type_parameters, 3),
  [4482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 4, .production_id = 123),
  [4484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4, .production_id = 123),
  [4486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 5, .production_id = 169),
  [4488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, .production_id = 169),
  [4490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 5, .production_id = 170),
  [4492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, .production_id = 170),
  [4494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 4, .production_id = 122),
  [4496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4, .production_id = 122),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [4500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [4502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [4506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [4508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [4510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [4514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [4518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [4520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3168),
  [4522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [4524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [4526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [4528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [4530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [4532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [4534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [4536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [4538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 11),
  [4540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_component_body_repeat1, 2, .production_id = 11),
  [4542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [4544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [4546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2743),
  [4548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1210),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4902),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [4554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3134),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [4560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2372),
  [4562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2351),
  [4564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2430),
  [4566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2511),
  [4568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2539),
  [4570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2545),
  [4572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3103),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [4576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2479),
  [4578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2329),
  [4580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2444),
  [4582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2504),
  [4584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2541),
  [4586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2537),
  [4588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3167),
  [4590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [4592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2407),
  [4594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2371),
  [4596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2412),
  [4598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2516),
  [4600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2555),
  [4602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2554),
  [4604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3153),
  [4606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2441),
  [4608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2346),
  [4610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2443),
  [4612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2505),
  [4614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2548),
  [4616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2544),
  [4618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3105),
  [4620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [4622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2456),
  [4624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2324),
  [4626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2451),
  [4628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2487),
  [4630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2551),
  [4632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2550),
  [4634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3111),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [4638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2440),
  [4640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2347),
  [4642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2437),
  [4644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2507),
  [4646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2557),
  [4648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2549),
  [4650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [4652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4272),
  [4656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3145),
  [4658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [4660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2375),
  [4662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2362),
  [4664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2383),
  [4666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2526),
  [4668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2540),
  [4670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2559),
  [4672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3140),
  [4674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [4676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2435),
  [4678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2321),
  [4680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2397),
  [4682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2518),
  [4684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2543),
  [4686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2552),
  [4688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3098),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [4692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2431),
  [4694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2365),
  [4696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2385),
  [4698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2523),
  [4700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2558),
  [4702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2556),
  [4704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [4706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [4708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1438),
  [4710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [4712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [4714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [4716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4152),
  [4718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4335),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4332),
  [4722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [4724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 1, .production_id = 11),
  [4726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 1, .production_id = 11),
  [4728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [4730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 67),
  [4733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [4735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [4737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [4739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [4743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3, .production_id = 82),
  [4745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 11),
  [4747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_new_component_body_repeat1, 2, .production_id = 11),
  [4749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_new_component_expression, 2, .production_id = 16), SHIFT(131),
  [4752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4337),
  [4754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_new_component_expression, 3, .production_id = 16), SHIFT(131),
  [4757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3262),
  [4759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2533),
  [4761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2519),
  [4763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2536),
  [4765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2546),
  [4767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2565),
  [4769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2566),
  [4771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1316),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4805),
  [4775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2669),
  [4779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [4781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2387),
  [4783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2860),
  [4785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4100),
  [4787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1952),
  [4789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2368),
  [4791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2525),
  [4793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2284),
  [4795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2651),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [4799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4175),
  [4805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [4807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [4811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [4813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [4817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2927),
  [4819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4890),
  [4821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4163),
  [4823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4128),
  [4825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3000),
  [4827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [4829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4851),
  [4831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4366),
  [4833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4073),
  [4835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [4843] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3003),
  [4846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2669),
  [4849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4851] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(292),
  [4854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2387),
  [4857] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(4778),
  [4860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3771),
  [4863] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3769),
  [4866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2860),
  [4869] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(4100),
  [4872] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1952),
  [4875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2368),
  [4878] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2525),
  [4881] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2284),
  [4884] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2463),
  [4887] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2497),
  [4890] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2651),
  [4893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [4897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 23), SHIFT(1738),
  [4900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 23), SHIFT(1865),
  [4903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 23),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [4909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2414),
  [4911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2883),
  [4913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2416),
  [4915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2515),
  [4917] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2), REDUCE(sym_tuple_type, 2),
  [4921] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_tuple_type, 2),
  [4924] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym_tuple_type, 2),
  [4927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 23), SHIFT(1867),
  [4930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 2),
  [4932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [4937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [4939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [4943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 2),
  [4945] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2),
  [4948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4283),
  [4950] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 23), SHIFT(2330),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4289),
  [4955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4295),
  [4957] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 23), SHIFT(1700),
  [4960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [4962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2, .production_id = 84),
  [4964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [4966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [4968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [4970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [4972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [4974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [4976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [4978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [4980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [4982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [4984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [4986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [4988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [4990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [4992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [4994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [4996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [4998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [5000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 81), REDUCE(sym_object_pattern, 3, .production_id = 82),
  [5003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [5005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [5007] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1),
  [5010] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1),
  [5013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [5015] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2), REDUCE(sym_object_type, 2),
  [5019] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_type, 2),
  [5022] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2), REDUCE(sym_object_type, 2),
  [5025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [5027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [5029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [5031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [5033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [5035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [5037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [5039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [5043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [5045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [5047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [5051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [5053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [5055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [5057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [5059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [5061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [5065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [5067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [5069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [5071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [5073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [5075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [5077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [5079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [5081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [5083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [5085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [5091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [5095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [5097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [5099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 2),
  [5101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [5103] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 126), REDUCE(sym_assignment_expression, 3, .production_id = 90),
  [5106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 126),
  [5108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [5110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [5112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [5114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [5116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [5118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [5120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [5122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [5124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [5126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [5128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [5130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [5132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [5134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [5136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [5138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [5140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [5142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [5144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [5146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [5148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [5150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [5152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [5154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [5156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [5158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [5160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [5162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(501),
  [5164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [5166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [5168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [5170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [5172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [5174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [5176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [5178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_pattern, 2), REDUCE(sym_object_type, 2),
  [5181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [5183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3435),
  [5185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2610),
  [5187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 9),
  [5190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 9),
  [5193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 126), REDUCE(sym_assignment_expression, 3, .production_id = 79),
  [5196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [5198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [5200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_pattern, 2), REDUCE(sym_tuple_type, 2),
  [5203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 59),
  [5205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 9), REDUCE(sym__parameter_name, 2, .production_id = 59),
  [5208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 2, .production_id = 59),
  [5210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [5212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_template_string, 2), REDUCE(sym_template_literal_type, 2),
  [5215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_template_string, 2), REDUCE(sym_template_literal_type, 2),
  [5218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4281),
  [5220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1795),
  [5222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2688),
  [5224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [5226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2408),
  [5228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2864),
  [5230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2458),
  [5232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2499),
  [5234] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_new_component_expression, 2, .production_id = 16), SHIFT(137),
  [5237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 84),
  [5239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [5241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 28),
  [5243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 28), REDUCE(sym__primary_type, 1, .production_id = 9),
  [5246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 28),
  [5248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4159),
  [5250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [5252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 28),
  [5255] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 28), REDUCE(sym__primary_type, 1, .production_id = 9),
  [5259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 3, .production_id = 90),
  [5261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 90), REDUCE(sym_assignment_expression, 3, .production_id = 90),
  [5264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 90),
  [5266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_new_component_expression, 3, .production_id = 16), SHIFT(137),
  [5269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 2, .production_id = 84),
  [5271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__initializer, 2, .production_id = 84), SHIFT(330),
  [5274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, .production_id = 162),
  [5276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 4, .production_id = 162),
  [5278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, .production_id = 160),
  [5280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 4, .production_id = 160),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [5284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [5287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_computed_property_name, 3),
  [5289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [5292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_computed_property_name, 3),
  [5294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [5296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [5298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 90),
  [5300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [5302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [5304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [5306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 5, .production_id = 197),
  [5308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 5, .production_id = 197),
  [5310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [5312] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1), REDUCE(sym_rest_pattern, 2),
  [5316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2),
  [5318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 62),
  [5320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 2, .production_id = 62),
  [5322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [5324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [5326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [5328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [5330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [5332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 81), REDUCE(sym_object_pattern, 3, .production_id = 82),
  [5335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1),
  [5338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1),
  [5340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1),
  [5343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_name, 1),
  [5345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [5347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2180),
  [5349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 117),
  [5351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 3, .production_id = 117),
  [5353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 113),
  [5355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 3, .production_id = 113),
  [5357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [5359] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 23), REDUCE(aux_sym_object_repeat1, 2, .production_id = 81), REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 82),
  [5363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [5367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [5369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2532),
  [5371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2531),
  [5373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2680),
  [5375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2),
  [5378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [5387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [5389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [5391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2672),
  [5393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [5395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [5397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [5399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2380),
  [5401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2879),
  [5403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2381),
  [5405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2513),
  [5407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [5409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [5411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [5413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [5415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2662),
  [5417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2473),
  [5419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2842),
  [5421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2509),
  [5423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2673),
  [5425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2428),
  [5427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [5429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [5431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2400),
  [5433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2905),
  [5435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2404),
  [5437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2493),
  [5439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [5441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 127),
  [5443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [5445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3872),
  [5447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3580),
  [5449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [5451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [5453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4624),
  [5455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [5457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3542),
  [5459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3541),
  [5461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [5463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3728),
  [5465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [5467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [5469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [5471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [5473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [5475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2693),
  [5477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2427),
  [5479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [5481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2423),
  [5483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2501),
  [5485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [5487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2678),
  [5489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [5491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_component, 4, .production_id = 40), REDUCE(sym_component, 5, .production_id = 76),
  [5494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_component, 4, .production_id = 40), REDUCE(sym_component, 5, .production_id = 76),
  [5497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [5499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [5501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [5503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [5505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [5507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [5509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [5511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [5513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [5515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [5517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [5519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [5521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [5523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [5525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [5527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [5529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [5531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [5533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [5535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2624),
  [5537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2453),
  [5539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2884),
  [5541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2488),
  [5543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [5545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3490),
  [5547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2608),
  [5549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [5551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [5553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2621),
  [5555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [5557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [5559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3427),
  [5561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2616),
  [5563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [5565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 83), REDUCE(sym_class, 4, .production_id = 144),
  [5568] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 83), REDUCE(sym_class, 4, .production_id = 144),
  [5571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3457),
  [5573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2622),
  [5575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3334),
  [5577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2609),
  [5579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3882),
  [5581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 1),
  [5583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [5585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3368),
  [5587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2623),
  [5589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [5591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 3), REDUCE(sym_class, 3, .production_id = 17),
  [5594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 3), REDUCE(sym_class, 3, .production_id = 17),
  [5597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2480),
  [5599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2840),
  [5601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2500),
  [5603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_component, 2, .production_id = 3), REDUCE(sym_component, 3, .production_id = 17),
  [5606] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_component, 2, .production_id = 3), REDUCE(sym_component, 3, .production_id = 17),
  [5609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [5611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2460),
  [5613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2906),
  [5615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2520),
  [5617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_component, 2, .production_id = 4), REDUCE(sym_component, 3, .production_id = 18),
  [5620] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_component, 2, .production_id = 4), REDUCE(sym_component, 3, .production_id = 18),
  [5623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [5625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [5627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2618),
  [5629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [5631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2393),
  [5633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2822),
  [5635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2498),
  [5637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 85), REDUCE(sym_class, 4, .production_id = 145),
  [5640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 85), REDUCE(sym_class, 4, .production_id = 145),
  [5643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [5645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [5647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2389),
  [5649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [5651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2524),
  [5653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [5655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [5657] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_component, 5, .production_id = 73), REDUCE(sym_component, 6, .production_id = 124),
  [5660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_component, 5, .production_id = 73), REDUCE(sym_component, 6, .production_id = 124),
  [5663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3447),
  [5665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2605),
  [5667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_component, 3, .production_id = 15), REDUCE(sym_component, 4, .production_id = 46),
  [5670] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_component, 3, .production_id = 15), REDUCE(sym_component, 4, .production_id = 46),
  [5673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 176), REDUCE(sym_class, 6, .production_id = 222),
  [5676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 176), REDUCE(sym_class, 6, .production_id = 222),
  [5679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [5681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [5683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2604),
  [5685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [5687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [5689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2620),
  [5691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3514),
  [5693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2611),
  [5695] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_component, 4, .production_id = 41), REDUCE(sym_component, 5, .production_id = 77),
  [5698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_component, 4, .production_id = 41), REDUCE(sym_component, 5, .production_id = 77),
  [5701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2457),
  [5703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [5705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2512),
  [5707] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 132), REDUCE(sym_class, 5, .production_id = 183),
  [5710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 132), REDUCE(sym_class, 5, .production_id = 183),
  [5713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_component, 3, .production_id = 14), REDUCE(sym_component, 4, .production_id = 45),
  [5716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_component, 3, .production_id = 14), REDUCE(sym_component, 4, .production_id = 45),
  [5719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__initializer, 2, .production_id = 84), SHIFT(504),
  [5722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_component, 3, .production_id = 13), REDUCE(sym_component, 4, .production_id = 44),
  [5725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_component, 3, .production_id = 13), REDUCE(sym_component, 4, .production_id = 44),
  [5728] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_component, 3, .production_id = 12), REDUCE(sym_component, 4, .production_id = 43),
  [5731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_component, 3, .production_id = 12), REDUCE(sym_component, 4, .production_id = 43),
  [5734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [5736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2614),
  [5738] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 86), REDUCE(sym_class, 4, .production_id = 146),
  [5741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 86), REDUCE(sym_class, 4, .production_id = 146),
  [5744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 133), REDUCE(sym_class, 5, .production_id = 184),
  [5747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 133), REDUCE(sym_class, 5, .production_id = 184),
  [5750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [5752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [5754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3418),
  [5756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2617),
  [5758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 136), REDUCE(sym_class, 5, .production_id = 185),
  [5761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 136), REDUCE(sym_class, 5, .production_id = 185),
  [5764] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_component, 4, .production_id = 39), REDUCE(sym_component, 5, .production_id = 75),
  [5767] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_component, 4, .production_id = 39), REDUCE(sym_component, 5, .production_id = 75),
  [5770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3442),
  [5772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [5774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3099),
  [5778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4316),
  [5780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 81), REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 82),
  [5783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3379),
  [5785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1),
  [5787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2538),
  [5789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [5791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2528),
  [5793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2553),
  [5795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2560),
  [5797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2572),
  [5799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2575),
  [5801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 81),
  [5803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2667),
  [5805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2502),
  [5807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2542),
  [5809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [5811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3106),
  [5813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2670),
  [5815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2579),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [5819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2578),
  [5821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2613),
  [5823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [5825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4847),
  [5827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 258),
  [5829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 258),
  [5831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 257),
  [5833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 257),
  [5835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 221),
  [5837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 221),
  [5839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 240),
  [5841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 240),
  [5843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2684),
  [5845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2599),
  [5847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [5849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2603),
  [5851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 3, .production_id = 128),
  [5853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 3, .production_id = 128),
  [5855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 279),
  [5857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 279),
  [5859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 217),
  [5861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 217),
  [5863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 180),
  [5865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 180),
  [5867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 173),
  [5869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 173),
  [5871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 280),
  [5873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 280),
  [5875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, .production_id = 293),
  [5877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, .production_id = 293),
  [5879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, .production_id = 294),
  [5881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, .production_id = 294),
  [5883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [5885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [5887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [5889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 141),
  [5891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 141),
  [5893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 10, .production_id = 301),
  [5895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 10, .production_id = 301),
  [5897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [5899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [5901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2692),
  [5903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [5905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2606),
  [5907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2602),
  [5909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [5911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2679),
  [5913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3470),
  [5915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2612),
  [5917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3423),
  [5919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [5921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [5923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [5925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2332),
  [5927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2331),
  [5929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2645),
  [5931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [5933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2643),
  [5935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [5937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [5939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [5941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [5943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [5945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2563),
  [5947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2323),
  [5949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2364),
  [5951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [5953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3534),
  [5955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [5957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2535),
  [5959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2529),
  [5961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2660),
  [5963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_static_block, 2, .production_id = 3),
  [5965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_static_block, 2, .production_id = 3),
  [5967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [5969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2838),
  [5971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2489),
  [5973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2421),
  [5975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2681),
  [5977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2863),
  [5979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2491),
  [5981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2490),
  [5983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2464),
  [5985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2600),
  [5987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2445),
  [5989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4752),
  [5991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2547),
  [5993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4867),
  [5995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4480),
  [5997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4544),
  [5999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4299),
  [6001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3958),
  [6003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4302),
  [6005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [6007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4297),
  [6009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_narrow, 1, .production_id = 8),
  [6011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [6013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [6015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [6017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [6019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4726),
  [6021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3415),
  [6023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [6025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [6027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [6029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4305),
  [6031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3955),
  [6033] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym__type_query_member_expression, 3, .production_id = 22),
  [6036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_short_heritage, 2),
  [6038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4561),
  [6040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [6042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [6044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4184),
  [6046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4088),
  [6048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4183),
  [6050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4095),
  [6052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [6054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [6056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4180),
  [6058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [6060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [6062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [6064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [6066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4516),
  [6068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [6070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [6072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [6074] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3306),
  [6077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4793),
  [6080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4147),
  [6083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3218),
  [6086] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4901),
  [6089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [6091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [6093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2875),
  [6095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4123),
  [6097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2875),
  [6099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2),
  [6101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_component_short_heritage_repeat1, 2),
  [6103] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_short_heritage_repeat1, 2), REDUCE(sym_nested_identifier, 3),
  [6106] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_path_segment_repeat1, 2), SHIFT_REPEAT(2807),
  [6109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_path_segment_repeat1, 2), SHIFT_REPEAT(2807),
  [6112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2745),
  [6114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4697),
  [6116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4613),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4606),
  [6120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4605),
  [6122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 154),
  [6124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3239),
  [6126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [6128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [6130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [6132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2943),
  [6134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4837),
  [6136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4850),
  [6138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4529),
  [6140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [6142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4860),
  [6144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4861),
  [6146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 68),
  [6148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [6150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2917),
  [6152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4774),
  [6154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 192),
  [6156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [6158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [6160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4768),
  [6162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [6164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4761),
  [6166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4813),
  [6168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [6170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4758),
  [6172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 1, .production_id = 16),
  [6174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [6176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2971),
  [6178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4663),
  [6180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4659),
  [6182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 34),
  [6184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [6186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [6188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2958),
  [6190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4652),
  [6192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4520),
  [6194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4643),
  [6196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4632),
  [6198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4649),
  [6200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4647),
  [6202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4753),
  [6204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [6206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4546),
  [6208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4593),
  [6210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4553),
  [6212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2807),
  [6214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2807),
  [6216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4550),
  [6218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 68),
  [6220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2972),
  [6222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4491),
  [6224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3566),
  [6226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 34),
  [6228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [6230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 154),
  [6232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [6234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2915),
  [6236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4188),
  [6238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4087),
  [6240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3397),
  [6242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 192),
  [6244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2964),
  [6246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [6248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [6250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4142),
  [6252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [6254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4769),
  [6256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [6258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4157),
  [6260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4141),
  [6262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4155),
  [6264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4140),
  [6266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 1, .production_id = 16),
  [6268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [6270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [6272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4391),
  [6274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [6276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2921),
  [6278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 8), REDUCE(sym_type_parameter, 1, .production_id = 30),
  [6281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [6283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [6285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 8), SHIFT(1291),
  [6288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [6290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3238),
  [6292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3342),
  [6294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2935),
  [6296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 68),
  [6298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 68),
  [6300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 154),
  [6302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 8), SHIFT(4338),
  [6305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 192),
  [6307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 16),
  [6309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 34),
  [6311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 154),
  [6313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [6315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 34),
  [6317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 16),
  [6319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 192),
  [6321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [6323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4177),
  [6325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [6327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [6329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [6331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_path_repeat1, 2), SHIFT_REPEAT(4177),
  [6334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2859),
  [6336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4154),
  [6338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4143),
  [6340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [6342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [6344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [6346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [6348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [6350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [6352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3113),
  [6354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [6356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [6358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [6360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3139),
  [6362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [6364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 52),
  [6366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [6368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [6370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [6374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [6376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [6378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [6380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [6382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3155),
  [6384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3154),
  [6386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 16),
  [6388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4385),
  [6390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [6392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [6394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3143),
  [6396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 21),
  [6398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3116),
  [6400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_narrow, 1, .production_id = 8),
  [6402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4857),
  [6404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3166),
  [6406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3131),
  [6408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [6410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3187),
  [6412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [6414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [6416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3124),
  [6418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3162),
  [6420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4809),
  [6422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [6424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [6426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [6428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 263),
  [6430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [6432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 4),
  [6434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4),
  [6436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4, .production_id = 82),
  [6438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [6440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [6442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [6444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [6446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [6448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [6450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2),
  [6452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 3),
  [6454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [6456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [6458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3),
  [6460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [6462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3341),
  [6464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [6466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [6468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [6470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3869),
  [6472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opting_type_annotation, 2),
  [6474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [6476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_omitting_type_annotation, 2),
  [6478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [6480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4641),
  [6482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4608),
  [6484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [6486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3060),
  [6488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [6490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3203),
  [6492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [6494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [6496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4580),
  [6498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3048),
  [6500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3281),
  [6502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [6504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4853),
  [6506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [6508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, .production_id = 102),
  [6510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [6512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [6514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [6516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4886),
  [6518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [6520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [6522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 2, .production_id = 236),
  [6524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3792),
  [6526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4756),
  [6528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 2, .production_id = 236),
  [6530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3459),
  [6532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [6534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3560),
  [6536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3518),
  [6538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [6540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 2, .production_id = 53),
  [6542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3464),
  [6544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3573),
  [6546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [6548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3611),
  [6550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4638),
  [6552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4259),
  [6554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3830),
  [6556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3432),
  [6558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3548),
  [6560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [6562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [6564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asserts, 3),
  [6566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3724),
  [6568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [6570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [6572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 187),
  [6574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 186),
  [6576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [6578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5),
  [6580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [6582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [6584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3574),
  [6586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 9, .production_id = 286),
  [6588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 147),
  [6590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 150),
  [6592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, .production_id = 267),
  [6594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 227),
  [6596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 228),
  [6598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, .production_id = 266),
  [6600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, .production_id = 30),
  [6602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 263),
  [6604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, .production_id = 104),
  [6606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 245),
  [6608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 2, .production_id = 54),
  [6610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3483),
  [6612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [6614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 1, .production_id = 29),
  [6616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [6618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [6620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3504),
  [6622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3352),
  [6624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [6626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(405),
  [6629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3203),
  [6631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1530),
  [6633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [6635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [6637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [6639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [6641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [6643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [6645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [6647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3675),
  [6649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [6651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3591),
  [6653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3450),
  [6655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [6657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [6659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3623),
  [6661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [6663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 246),
  [6665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [6667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3403),
  [6669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2796),
  [6671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4890),
  [6673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3633),
  [6675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [6677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [6679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [6681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_narrow, 1),
  [6683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_narrow, 1),
  [6685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3064),
  [6687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3310),
  [6689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [6691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 105),
  [6693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 100),
  [6695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [6697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_repeat1, 2, .production_id = 5), SHIFT_REPEAT(4147),
  [6700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3695),
  [6702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [6704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [6706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3413),
  [6708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, .production_id = 156),
  [6710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [6712] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(3333),
  [6715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(288),
  [6718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2),
  [6720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3600),
  [6722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3690),
  [6724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [6726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [6728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [6730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3421),
  [6732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [6734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [6736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [6738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [6740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [6742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3412),
  [6744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [6746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3584),
  [6748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [6750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2983),
  [6752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [6754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [6756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_instance_statement, 2),
  [6758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3532),
  [6760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [6762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2998),
  [6764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [6766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [6768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [6770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [6772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3662),
  [6774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [6776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [6778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [6780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3660),
  [6782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [6784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2900),
  [6786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4810),
  [6788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3471),
  [6790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [6792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1624),
  [6794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2703),
  [6796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3630),
  [6798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2776),
  [6800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [6802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [6804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3455),
  [6806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [6808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [6810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 2),
  [6812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [6814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [6816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [6818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [6820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3525),
  [6822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3642),
  [6824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [6826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [6828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [6830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4680),
  [6832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3609),
  [6834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [6836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [6838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [6840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3571),
  [6842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [6844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [6846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [6848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [6850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3678),
  [6852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_member, 1),
  [6854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4341),
  [6856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3647),
  [6858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3702),
  [6860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [6862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [6864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [6866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [6868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [6870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3643),
  [6872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [6874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3333),
  [6876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [6878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3716),
  [6880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [6882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [6884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [6886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3634),
  [6888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 236),
  [6890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 236),
  [6892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [6894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [6896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4282),
  [6898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [6900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [6902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [6904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [6906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [6908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3539),
  [6910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3553),
  [6912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(1621),
  [6915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2),
  [6917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3620),
  [6919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3625),
  [6921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [6923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3565),
  [6925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [6927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [6929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [6931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3956),
  [6933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3708),
  [6935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3612),
  [6937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [6939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [6941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [6943] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(250),
  [6946] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(4680),
  [6949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3795),
  [6951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [6953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [6955] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(3471),
  [6958] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(289),
  [6961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [6963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [6965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [6967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3697),
  [6969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [6971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [6973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 2),
  [6975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [6977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [6979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [6981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [6983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3684),
  [6985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [6987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [6989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [6991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [6993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [6995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3576),
  [6997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3717),
  [6999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [7001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 51),
  [7003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [7005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [7007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3475),
  [7009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [7011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [7013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [7015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate_annotation, 2),
  [7017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 2, .production_id = 237),
  [7019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 2, .production_id = 237),
  [7021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 3, .production_id = 99),
  [7023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [7025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [7027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 2, .production_id = 29),
  [7029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4055),
  [7031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [7033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3976),
  [7035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4275),
  [7037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [7039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3582),
  [7041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3578),
  [7043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 188),
  [7045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2),
  [7047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2), SHIFT_REPEAT(1212),
  [7050] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2), SHIFT_REPEAT(3526),
  [7053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [7055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [7057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [7059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(318),
  [7062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [7064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [7066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_type, 2),
  [7068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [7070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [7072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 297),
  [7074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3942),
  [7076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [7078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [7080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 52), SHIFT(1163),
  [7083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3676),
  [7085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [7087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [7089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [7091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [7093] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 21), SHIFT(1299),
  [7096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 285),
  [7098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [7100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [7102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [7104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [7106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 7, .production_id = 249),
  [7108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 55),
  [7110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 106),
  [7112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 189),
  [7114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [7116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [7118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3577),
  [7120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, .production_id = 248),
  [7122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 52), SHIFT(1340),
  [7125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, .production_id = 247),
  [7127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 103),
  [7129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 223),
  [7131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [7133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [7135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [7137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [7139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3526),
  [7141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [7143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3212),
  [7145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4355),
  [7147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 131),
  [7149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [7151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [7153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, .production_id = 101),
  [7155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [7157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [7159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [7161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 103),
  [7163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 188),
  [7165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 52), SHIFT(1160),
  [7168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [7170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3637),
  [7172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 21), SHIFT(1323),
  [7175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 106),
  [7177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 249),
  [7179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [7181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 225),
  [7183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 189),
  [7185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 237),
  [7187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 237),
  [7189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 226),
  [7191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [7193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [7195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3687),
  [7197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 5, .production_id = 190),
  [7199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 52), SHIFT(1351),
  [7202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 5, .production_id = 191),
  [7204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [7206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4364),
  [7208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [7210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [7212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [7214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [7216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2786),
  [7218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_type, 2),
  [7220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [7222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 21), SHIFT(1190),
  [7225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [7227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5),
  [7229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_signature, 1, .production_id = 24),
  [7231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 55),
  [7233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 229),
  [7235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4414),
  [7237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 229),
  [7239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [7241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 230),
  [7243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [7245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [7247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [7249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2795),
  [7251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3638),
  [7253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3014),
  [7255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3719),
  [7257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [7259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 265),
  [7261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 21), SHIFT(1174),
  [7264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 55),
  [7266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [7268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 3, .production_id = 148),
  [7270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [7272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3722),
  [7274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 4, .production_id = 149),
  [7276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 230),
  [7278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 152),
  [7280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 153),
  [7282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, .production_id = 151),
  [7284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 264),
  [7286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2990),
  [7288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 152),
  [7290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [7292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 153),
  [7294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, .production_id = 155),
  [7296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3284),
  [7298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [7300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 3),
  [7302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3903),
  [7304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2231),
  [7306] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [7308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [7310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3185),
  [7312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [7314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [7316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1626),
  [7318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3744),
  [7320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [7322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3159),
  [7324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3745),
  [7326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3757),
  [7328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [7330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3753),
  [7332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [7334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3817),
  [7336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3184),
  [7338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4855),
  [7340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3729),
  [7342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2758),
  [7344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3818),
  [7346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [7348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2697),
  [7350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3787),
  [7352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3789),
  [7354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3742),
  [7356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3192),
  [7358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_short_heritage, 3),
  [7360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [7362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [7364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [7366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2757),
  [7368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3749),
  [7370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3751),
  [7372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [7374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [7376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [7378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [7380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3764),
  [7382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3765),
  [7384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [7386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_heritage, 2),
  [7388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 34),
  [7390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [7392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 273),
  [7394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 273), SHIFT_REPEAT(3792),
  [7397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 273),
  [7399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [7401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 3, .production_id = 255),
  [7403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 3, .production_id = 255),
  [7405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2696),
  [7407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 3, .production_id = 254),
  [7409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 3, .production_id = 254),
  [7411] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_js_import_statement_repeat1, 2), SHIFT_REPEAT(4868),
  [7414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_js_import_statement_repeat1, 2),
  [7416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3433),
  [7418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_component_short_heritage_repeat1, 2), SHIFT_REPEAT(4855),
  [7421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3838),
  [7423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1753),
  [7425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [7427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3033),
  [7429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [7431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3230),
  [7433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(3284),
  [7436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [7438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [7440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3487),
  [7442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2753),
  [7444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [7446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [7448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_heritage, 3),
  [7450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [7452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(3817),
  [7455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2),
  [7457] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(3818),
  [7460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 5, .production_id = 224),
  [7462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1722),
  [7464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3812),
  [7466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3816),
  [7468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [7470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [7472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3220),
  [7474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [7476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_chain, 1),
  [7478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [7480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [7482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [7484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [7486] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(138),
  [7489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 178),
  [7491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 178), SHIFT_REPEAT(511),
  [7494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 4, .production_id = 177),
  [7496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [7498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [7500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [7502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [7504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter, 3, .production_id = 106),
  [7506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [7508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [7510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 61),
  [7512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 64),
  [7514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [7516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 1),
  [7518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 1), REDUCE(aux_sym_template_literal_type_repeat1, 1),
  [7521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3515),
  [7523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3512),
  [7525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [7527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2791),
  [7529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, .production_id = 135),
  [7531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, .production_id = 134),
  [7533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [7535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 82),
  [7537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [7539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_type_parameter, 2, .production_id = 55),
  [7541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [7543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [7545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [7547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3900),
  [7549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 115),
  [7551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(948),
  [7553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_glimmer_template_repeat1, 2), SHIFT_REPEAT(3903),
  [7556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_glimmer_template_repeat1, 2),
  [7558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [7560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [7562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [7564] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(114),
  [7567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [7569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [7571] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2), SHIFT_REPEAT(130),
  [7574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2),
  [7576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3270),
  [7578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3658),
  [7580] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(4458),
  [7583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [7585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [7587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3592),
  [7589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_type, 3),
  [7591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [7593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [7595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4441),
  [7597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2), SHIFT_REPEAT(2409),
  [7600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2),
  [7602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [7604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [7606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4439),
  [7608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [7610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4438),
  [7612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [7614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(2522),
  [7617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2),
  [7619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2), SHIFT_REPEAT(1128),
  [7622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2),
  [7624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [7626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4336),
  [7628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [7630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [7632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [7634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3581),
  [7636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [7638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair_pattern, 3, .production_id = 127),
  [7640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3112),
  [7642] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(1368),
  [7645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 131),
  [7647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [7649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 3),
  [7651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4737),
  [7653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5),
  [7655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3671),
  [7657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4509),
  [7659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4508),
  [7661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4702),
  [7663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [7665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [7667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [7669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3645),
  [7671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [7673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [7675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [7677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 1),
  [7679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [7681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2874),
  [7683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [7685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4192),
  [7687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2713),
  [7689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [7691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2735),
  [7693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [7695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2873),
  [7697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [7699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [7701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2872),
  [7703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [7705] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_type_parameters_repeat1, 2), SHIFT_REPEAT(3825),
  [7708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_type_parameters_repeat1, 2),
  [7710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [7712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 174),
  [7714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 3, .production_id = 100),
  [7716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 175),
  [7718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(1276),
  [7721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 168),
  [7723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [7725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [7727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [7729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [7731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [7733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3456),
  [7735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2695),
  [7737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [7739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3508),
  [7741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [7743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [7745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [7747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [7749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 218),
  [7751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 219),
  [7753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 220),
  [7755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 150),
  [7757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 147),
  [7759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [7761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3538),
  [7763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [7765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [7767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 213),
  [7769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3929),
  [7771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4131),
  [7773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [7775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 3, .production_id = 134),
  [7777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [7779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [7781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [7783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3949),
  [7785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [7787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [7789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2783),
  [7791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [7793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3953),
  [7795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [7797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4898),
  [7799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 106),
  [7801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 168),
  [7803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [7805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [7807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [7809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [7811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [7813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [7815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 241),
  [7817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [7819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 242),
  [7821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 243),
  [7823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 244),
  [7825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 186),
  [7827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 187),
  [7829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [7831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [7833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [7835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4238),
  [7837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [7839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [7841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [7843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4743),
  [7845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [7847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [7849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [7851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [7853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [7855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [7857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [7859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_identifier, 2),
  [7861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_component_identifier, 2),
  [7863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4127),
  [7865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 259),
  [7867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3036),
  [7869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 260),
  [7871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 261),
  [7873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 262),
  [7875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 6, .production_id = 227),
  [7877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4010),
  [7879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4121),
  [7881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2901),
  [7883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [7885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [7887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2843),
  [7889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [7891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2867),
  [7893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2847),
  [7895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 275), SHIFT_REPEAT(2646),
  [7898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 275),
  [7900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 281),
  [7902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 282),
  [7904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 283),
  [7906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2829),
  [7908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [7910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2851),
  [7912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [7914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2865),
  [7916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [7918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [7920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [7922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [7924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [7926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [7928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3237),
  [7930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 284),
  [7932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [7934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 295),
  [7936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 296),
  [7938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [7940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 298),
  [7942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, .production_id = 302),
  [7944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4063),
  [7946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [7948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3152),
  [7950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [7952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4804),
  [7954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [7956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [7958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3709),
  [7960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [7962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [7964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [7966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [7968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [7970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2837),
  [7972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [7974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [7976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2836),
  [7978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2930),
  [7980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2934),
  [7982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2834),
  [7984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2936),
  [7986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2939),
  [7988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [7990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [7992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [7994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [7996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3355),
  [7998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3208),
  [8000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [8002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [8004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2989),
  [8006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [8008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [8010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [8012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2938),
  [8014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [8016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2933),
  [8018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [8020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [8022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4124),
  [8024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4876),
  [8026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [8028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [8030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [8032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [8034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [8036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3627),
  [8038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [8040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [8042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2850),
  [8044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2849),
  [8046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [8048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [8050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [8052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_opening_tag, 1),
  [8054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [8056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [8058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4762),
  [8060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4766),
  [8062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [8064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_assignment, 2, .production_id = 131),
  [8066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [8068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [8070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3520),
  [8072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4717),
  [8074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [8076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [8078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [8080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [8082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3593),
  [8084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4714),
  [8086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [8088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [8090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [8092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [8094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [8096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [8098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2731),
  [8100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [8102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [8104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [8106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [8108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [8110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [8112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [8114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 60),
  [8116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [8118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [8120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [8122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [8124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [8126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [8128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [8130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameter, 2, .production_id = 55),
  [8132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type, 2),
  [8134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 63),
  [8136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter, 4, .production_id = 213),
  [8138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_type_parameter, 1),
  [8140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3939),
  [8142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4741),
  [8144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3549),
  [8146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4681),
  [8148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [8150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [8152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [8154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [8156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4021),
  [8158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [8160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_type_parameter, 3, .production_id = 168),
  [8162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [8164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4637),
  [8166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [8168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [8170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [8172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [8174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [8176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [8178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [8180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2750),
  [8182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [8184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [8186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [8188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [8190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 4, .production_id = 161),
  [8192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 114),
  [8194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 3, .production_id = 116),
  [8196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_tuple_parameter, 3, .production_id = 106),
  [8198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, .production_id = 118),
  [8200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [8202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [8204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [8206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [8208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [8210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [8212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [8214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_function_return_type, 1),
  [8216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [8218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [8220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [8222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [8224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2809),
  [8226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [8228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [8230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [8232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [8234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4426),
  [8236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3287),
  [8238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4589),
  [8240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [8242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2755),
  [8244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [8246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [8248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [8250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [8252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4541),
  [8254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [8256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2229),
  [8258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [8260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [8262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [8264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3519),
  [8266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [8268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [8270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [8272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2715),
  [8274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [8276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [8278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [8280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [8282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [8284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [8286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [8288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [8290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [8292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [8294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2805),
  [8296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4887),
  [8298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [8300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [8302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [8304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [8306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [8308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [8310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [8312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2736),
  [8314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [8316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [8318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [8320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [8322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [8324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [8326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [8328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [8330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [8332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4380),
  [8334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4376),
  [8336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [8338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4634),
  [8340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [8342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4370),
  [8344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [8346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4189),
  [8348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 2),
  [8350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [8352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [8354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [8356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [8358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [8360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [8362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [8364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4700),
  [8366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [8368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [8370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4688),
  [8372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [8374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [8376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [8378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [8380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4653),
  [8382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [8384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [8386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [8388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [8390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [8392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [8394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4824),
  [8396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [8398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [8400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [8402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [8404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [8406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [8408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [8410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [8412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [8414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2816),
  [8416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [8418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [8420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [8422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4792),
  [8424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2815),
  [8426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [8428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [8430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [8432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4685),
  [8434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3104),
  [8436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [8438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2811),
  [8440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2810),
  [8442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [8444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3798),
  [8446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [8448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [8450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [8452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2808),
  [8454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3132),
  [8456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [8458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [8460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [8462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3670),
  [8464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4505),
  [8466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [8468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [8470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [8472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [8474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [8476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [8478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [8480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [8482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [8484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [8486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [8488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [8490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [8492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [8494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [8496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [8498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [8500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [8502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [8504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3589),
  [8506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [8508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [8510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [8512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [8514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [8516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [8518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [8520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [8522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [8524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [8526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [8528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [8530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [8532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [8534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [8536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2699),
  [8538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [8540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [8542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [8544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4002),
  [8546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [8548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [8550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [8552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [8554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2824),
  [8556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2825),
  [8558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3631),
  [8560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [8562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4340),
  [8564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3635),
  [8566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [8568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [8570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4696),
  [8572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [8574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [8576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [8578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [8580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [8582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1951),
  [8584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [8586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [8588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [8590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [8592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [8594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2832),
  [8596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [8598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4069),
  [8600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [8602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [8604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [8606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [8608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3937),
  [8610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [8612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [8614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [8616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [8618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [8620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [8622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [8624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4367),
  [8626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2954),
  [8628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [8630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [8632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3651),
  [8634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [8636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [8638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4657),
  [8640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [8642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4658),
  [8644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4207),
  [8646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [8648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [8650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4347),
  [8652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [8654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [8656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [8658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [8660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [8662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [8664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [8666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [8668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3845),
  [8670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4698),
  [8672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [8674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [8676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [8678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [8680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [8682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [8684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4728),
  [8686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [8688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [8690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [8692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2510),
  [8694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3746),
  [8696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [8698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [8700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [8702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [8704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [8706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [8708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [8710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [8712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [8714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3868),
  [8716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4017),
  [8718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [8720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [8722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [8724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [8726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [8728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [8730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2969),
  [8732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [8734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [8736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [8738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [8740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [8742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [8744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [8746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3893),
  [8748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [8750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [8752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [8754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [8756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4246),
  [8758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [8760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4244),
  [8762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [8764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4755),
  [8766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [8768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [8770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [8772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [8774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [8776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [8778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [8780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2803),
  [8782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3813),
  [8784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [8786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [8788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4240),
  [8790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4759),
  [8792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2794),
  [8794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3873),
  [8796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [8798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [8800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [8802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4642),
  [8804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [8806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [8808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [8810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4056),
  [8812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2961),
  [8814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [8816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [8818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [8820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2913),
  [8822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [8824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [8826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [8828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [8830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [8832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4315),
  [8834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4030),
  [8836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [8838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [8840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [8842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [8844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2955),
  [8846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [8848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [8850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4273),
  [8852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2953),
  [8854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_component_instance, 2),
  [8856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2952),
  [8858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [8860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4071),
  [8862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [8864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2353),
  [8866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [8868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2950),
  [8870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4879),
  [8872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3756),
  [8874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [8876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2948),
  [8878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2947),
  [8880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2945),
  [8882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4149),
  [8884] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [8886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3734),
  [8888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4882),
  [8890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [8892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_elements_external_scanner_create(void);
void tree_sitter_elements_external_scanner_destroy(void *);
bool tree_sitter_elements_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_elements_external_scanner_serialize(void *, char *);
void tree_sitter_elements_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_elements(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_elements_external_scanner_create,
      tree_sitter_elements_external_scanner_destroy,
      tree_sitter_elements_external_scanner_scan,
      tree_sitter_elements_external_scanner_serialize,
      tree_sitter_elements_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
